function calcCharacter(calcBaseOnly){

  var calcStartTime = new Date().getTime();

  updateGlobalLists(); // Links to global lists


// ресетим все важное
  gm(".bonus").removeClass("temporal").text(0); // обнуляем все бонусы
  gm(".cost-modifier").text(1); // обнуляем все модификаторы
  gm("reaction-text").html("");
  gm(".stat-result").removeClass("gc-warning");

  // Проходим все "включенные" модификаторы и собираем с них разные бонусы
  charCalcModifiersBonuses();

  // Считаем стоимость основных и вторичных статов
  charCalcStats();

  // Строим таблицы нагрузки, хитпоинтов, усталости
  charCalcLiftHpFp();


  // При малой калькуляции (когда общий пересчет отключен) - прекратить не считаем все что требует опроса всех объектов
  if (calcBaseOnly) return;


  // Вес
  calcEquipmentWeightAndValue(gm("total-wealth-modifier").text()*1.0);

  // Только после рассчета веса!!!
  charCalcMove();


  // Большой циклы - считаем все объекты в списках - даватаги, скилы и т.п.
  charCalcAllLists();


  // считаме damage
  charCalcBaseDamage();

  // Активные защиты - dodge, pary, block
  charCalcActiveDefence();



  // Считаем Итого
  charCalcTotal();


  // Оружие
  charCalcWeapons();

  // DR - строим таблицу
  charCalcDR();


  // Вешаем событие броска кубика на дэмежэи и скилы (вынести в отдельную функцию???)

  gm("damage,damage-result").addClass("gc-tool-click");
  gm(".gc-tool-click").unbind("click").bind("click", function () {makeToolRoll(this)});





  // Время расчета
  var calcTime = new Date().getTime() - calcStartTime;
  console.log('Calc time: ' + calcTime);

  globalCalced = true;

  $("body").lightStatus("low-speed-warning", (calcTime > globalCalcTimeLimit));


  undoSave();
  spellChartsMark();
}

// ----------------------------  Calc Char functions ---------------

function charCalcModifiersBonuses() {
  var wealthModifier = 1;
  globalModifiersOn.each(function () {
    var bonus = 0;
    $(this).find(">attribute_bonus").each(function () {
      var ammountObj = $(this).find("amount");
      if (ammountObj.attr("per_level") == "yes") {
        bonus = 1 * ammountObj.html() * ($(this).parent().find(">levels").float() || $(this).parent().parent().find(">levels").float() || 0);
      } else {
        bonus = 1 * ammountObj.html();
      }
      var attr = $(this).find("attribute").text();
      if ($(this).find("attribute").attr("limitation") == "lifting only") attr += "_lift";
      if ($(this).find("attribute").attr("limitation") == "striking only") attr += "_strike";
      if (attr == "taste smell") attr = "taste_smell";
      if (attr == "fright check") attr = "fright_check";

      if (attr == "air move") attr = "air_move";
      if (attr == "ground move") attr = "ground_move";
      if (attr == "space move") attr = "space_move";
      if (attr == "water move") attr = "water_move";
      if (attr == "move multiplyaer") attr = "move_multiplyaer";

      if (attr == "reaction") {
        var name = $(this).parents("advantage,skill,technique,spell,equipment,equipment_container").find(">name,>description").html();
        var limitation = $(this).find(">limitation").text();
        if (limitation == "") {
          gm("reaction-text").append("<reaction>" + (bonus > 0 ? "+" : "") + bonus + " от " + name + "</reaction>");
        }
        else {
          gm("reaction-text").append("<limitation>" + limitation + ": " + (bonus > 0 ? "+" : "") + bonus + " от " + name + "</limitation>");
          return; // что не считать в общий аджастмент
        }
      }

      var bonusField = gm(attr + "_bonus");

      if (ammountObj.attr("temporal") == "yes") {
        gm(attr + "_result").addClass("gc-warning");
        bonusField.addClass("temporal");
      }

      bonusField.html(bonusField.float() + bonus);
    });

    $(this).find(">cost_reduction").each(function () {
      var attr = $(this).find("attribute").html();
      var curr = gm(attr + "_cost_modifier").float();
      curr = curr - 0.01 * $(this).find("percentage").int();
      gm(attr + "_cost_modifier").html(curr);
    });

    $(this).find(">wealth_modifier").each(function () {
      var val = $(this).html();
      if ($(this).attr("per_level") == "yes") {
        var level = $(this).parent().find(">levels").float() || $(this).parent().parent().find(">levels").float() || 0;
        val = Math.pow(val, level);
      }
      gm("total-wealth-modifier").text()
      wealthModifier *= val;
    });
  });
  gm("total-wealth-modifier").text(wealthModifier);


  if (gm("reaction-text").html() != "") gm("reaction-text reaction").last().after("<total>" + (gm("reaction_bonus").int() > 0 ? "+" : "") + gm("reaction_bonus").int() + "</total>");
  gm("reaction-text limitation").appendTo(gm("reaction-text"));
}

function charCalcStats() {
  gm("SM_result").html(gm("SM").int() + gm("SM_bonus").int()); // Надо считаь до цены ST и HP ибо влияет
  { // size modifier on cost
    var sm = gm("SM_result").int();
    if (sm < 0) sm = 0;
    if (sm > 8) sm = 8;
    gm("ST_cost_modifier").html(gm("ST_cost_modifier").float() - 0.1 * sm)
    gm("HP_cost_modifier").html(gm("HP_cost_modifier").float() - 0.1 * sm)
  }

  // Режем модификатор до минимуму в 20%
  gm(".cost-modifier").each(function () {
    if ($(this).float() < 0.2) $(this).html("0.2");
  });


  $.each(["ST", "DX", "IQ", "HT"], function (i, stat) {
    gm(stat + "_result").next('gc-cost').html(getAttrCost(stat, gm(stat).int()));
    gm(stat + "_result").setHtmlIfChanged(gm(stat).int() + gm(stat + "_bonus").int());

  });

  gm(".HP_cost").html(Math.round(gm("HP").html() * 2 * gm("HP_cost_modifier").float()));
  gm("HP_result").setHtmlIfChanged(1 * getAttr('ST') + gm("HP").int() + gm("HP_bonus").int());
  var toHeight = (Math.abs(gm("HP").html()) / getAttr('ST') > 0.3);
  gm("HP_result").lightStatus("gc-warning", toHeight);

  gm(".FP_cost").html(gm("FP").html() * 3);
  gm("FP_result").setHtmlIfChanged(1 * getAttr('HT') + gm("FP").int() + gm("FP_bonus").int());
  var toHeight = (Math.abs(gm("FP").html()) / getAttr('HT') > 0.3);
  gm("FP_result").lightStatus("gc-warning", toHeight);


  gm(".WILL_cost").html(gm("WILL").html() * 5);
  gm("WILL_result").setHtmlIfChanged(1 * (isCharOption("will-free") ? 10 : getAttr('IQ')) + gm("WILL").int() + gm("WILL_bonus").int());
  var toHeight = (gm("WILL_result").html() > 20 || gm("WILL_result").html() < 4);
  gm("WILL_result").lightStatus("gc-warning", toHeight);

  var fearTexts = "";
  if (gm("fright_check_bonus").int() != 0) fearTexts = "Страх " + (gm("WILL_result").int() + gm("fright_check_bonus").int());
  gm("WILL_add").html(fearTexts);


  gm(".PERCEPTION_cost").html(gm("PERCEPTION").html() * 5);
  gm("PERCEPTION_result").setHtmlIfChanged(1 * (isCharOption("will-free") ? 10 : getAttr('IQ')) + gm("PERCEPTION").int() + gm("PERCEPTION_bonus").int());
  var toHeight = (gm("PERCEPTION_result").html() > 20 || gm("PERCEPTION_result").html() < 4);
  gm("PERCEPTION_result").lightStatus("gc-warning", toHeight);

  var perceptonTexts = "";
  var perceptonBase = gm("PERCEPTION_result").int();
  if (gm("hearing_bonus").int() != 0) perceptonTexts += "Слух " + (perceptonBase + gm("hearing_bonus").int()) + "<br>";
  if (gm("taste_smell_bonus").int() != 0) perceptonTexts += "Нюх " + (perceptonBase + gm("taste_smell_bonus").int()) + "<br>";
  if (gm("touch_bonus").int() != 0) perceptonTexts += "Осяз " + (perceptonBase + gm("touch_bonus").int()) + "<br>";
  if (gm("vision_bonus").int() != 0) perceptonTexts += "Зрен " + (perceptonBase + gm("vision_bonus").int()) + "<br>";
  gm("PERCEPTION_add").html(perceptonTexts);

  gm(".SPEED_cost").html(gm("SPEED").html() * 20);
  gm("SPEED_result").setHtmlIfChanged((1 * getAttr('HT') + 1 * getAttr('DX')) / 4 + 1 * gm("SPEED").html() + 1 * gm("SPEED_bonus").html());
  var toHeight = (Math.abs(gm("SPEED").html()) > 2);
  gm("SPEED_result").lightStatus("gc-warning", toHeight);


  gm(".MOVE_cost").html(gm("MOVE").html() * 5);
  gm("MOVE_result").setHtmlIfChanged(Math.floor(Math.floor(gm("SPEED_result").float()) + 1 * gm("MOVE").int() + gm("MOVE_bonus").int()));
  var toHeight = (Math.abs(gm("MOVE").html()) > 3);
  gm("MOVE_result").lightStatus("gc-warning", toHeight);
}

function charCalcLiftHpFp() {

  var basicLift = getBasicLift(1 * getAttr('ST') + gm("ST_lift_bonus").int());
  gm("lift").html(
    "<item modifier='0'><name>Нет (0)</name><lbs>" + round(basicLift, 1) + "</lbs><kg>" + round(basicLift * 0.5, 1) + "</kg></item>" +
    "<item modifier='-1'><name>Легкая(-1)</name><lbs>" + round(basicLift * 2, 1) + "</lbs><kg>" + round(basicLift, 1) + "</kg></item>" +
    "<item modifier='-2'><name>Средняя(-2)</name><lbs>" + round(basicLift * 3, 1) + "</lbs><kg>" + round(basicLift * 1.5, 1) + "</kg></item>" +
    "<item modifier='-3'><name>Тяжелая(-3)</name><lbs>" + round(basicLift * 6, 1) + "</lbs><kg>" + round(basicLift * 3, 1) + "</kg></item>" +
    "<item modifier='-4'><name>Сверх(-4)</name><lbs>" + round(basicLift * 10, 1) + "</lbs><kg>" + round(basicLift * 5, 1) + "</kg></item>"
  );

  // HP


  gm("hp-mark").html(
    "<num class='hp-low'>" + Math.ceil(2 * getAttr('HP_result') / 3 + 0.001) + "</num><label>Измотан 1/2 move, 1/2 dodge</label>" +
    "<num>" + getAttr('HP_result') + "</num><label>Без сознания (HT - death lev) каждый ход</label>" +
    "<num>" + (2 * getAttr('HP_result')) + "</num><label>1й бросок от смерти</label> " +
    "<num>" + (3 * getAttr('HP_result')) + "</num><label>2й бросок от смерти</label> " +
    "<num>" + (4 * getAttr('HP_result')) + "</num><label>3й бросок от смерти</label> " +
    "<num>" + (5 * getAttr('HP_result')) + "</num><label>4й бросок от смерти</label> " +
    "<num>" + (6 * getAttr('HP_result')) + "</num><label>Смерть"
  );

  // HP lost
  {
    var lostStr = gm("hp_lost").text()
    var lostNum = tryCalculateString(lostStr);
    gm("hp_lost").attr("total", (lostNum == "" || lostNum == lostStr) ? "" : "=" + lostNum);
    gm("hp-mark num").each(function () {
      $(this).lightStatus("gc-warning", ($(this).int() <= lostNum));
    });
  }

  // FP

  gm("fp-mark").html(
    "<num class='fp-low'>" + Math.ceil(2 * getAttr('FP_result') / 3 + 0.001) + "</num><label>Устал: 1/2 move, 1/2 dodge, 1/2 ST</label>" +
    "<num>" + getAttr('FP_result') + "</num><label>Потеря HP<br/>(бросок воли на любое действие)</label>" +
    "<num>" + (2 * getAttr('FP_result')) + "</num><label>Потеря сознания</label> "
  );

  // FP lost
  {
    var lostStr = gm("fp_lost").text()
    var lostNum = tryCalculateString(lostStr);
    gm("fp_lost").attr("total", (lostNum == "" || lostNum == lostStr) ? "" : "=" + lostNum);
    gm("fp-mark num").each(function () {
      $(this).lightStatus("gc-warning", ($(this).int() <= lostNum));
    });

    // Елси FP ниже варнинга - подсветить "новую" силу
    gm("st_add").html(gm(".fp-low.gc-warning").length ? (Math.ceil(getAttr("ST") / 2)) : "");
  }
}

function charCalcAllLists(){
  globalAdvantagesList.each(function () {
    calcAdvantage($(this));
  });
  globalSkillsList.each(function () {
    calcSkill($(this));
  });
  globalSpellsList.each(function () {
    calcSpell($(this));
  });
  globalTechniqueList.each(function () {
    // Объязательно после скилов и спелов!!!
    calcSkill($(this));
  });

  globalEquipmentList.each(function () {
    calcEquipment($(this));
  });

  globalAllList.each(function () {
    $(this).lightStatus("prereq-fail", !checkPrerequisits($(this)));
  });

  // Считаем контейнеры
  // todo не косистентно - преенести это в containers.js

  globalAllList.find(">points").each(function () {
    $(this).attr("gc-points", $(this).int() || 0);
  });

  gm(".container-cost-modified").each(function () {
    var multiplier = ($(this).find(">modifier>cost").int() / 100 + 1);
    $(this).find("skill>points, technique>points, spell>points").each(function () {
      $(this).attr("gc-points", Math.round($(this).attr("gc-points") * multiplier));
    });
  });

  gm("advantage_container,skill_container,spell_container").each(function () {
    var containerCost = 0;
    $(this).find("gc-cost, skill>points, technique>points, spell>points").each(function () {
      containerCost += ($(this).attr("gc-points") !== undefined) ? ($(this).attr("gc-points") * 1) : ($(this).int() || 0);
    });
    if ($(this).attr('type') == 'alternative abilities' && containerCost < 0) containerCost = 0;
    $(this).find("gc-container-cost").html(containerCost);
  });

}

function charCalcMove() {
  var moveText = "";
  var moveBase = gm("move_result").int();
  var movieModified = moveModifiedByAll();
  if (moveBase != movieModified) moveText += "<span class='gc-warning'>Сейчас " + movieModified + "</span><br>";

  if (gm("air_move_bonus").float() != 0) moveText += "Полет " + Math.round(moveBase * Math.pow(2, gm("air_move_bonus").float())) + "<br>";
  if (gm("ground_move_bonus").float() != 0) moveText += "Назем. " + Math.round(moveBase * Math.pow(2, gm("ground_move_bonus").float())) + "<br>";
  if (gm("space_move_bonus").float() != 0) moveText += "Космос " + Math.round(moveBase * Math.pow(2, gm("space_move_bonus").float())) + "<br>";
  if (gm("water_move_bonus").float() != 0) moveText += "Вода " + Math.round(moveBase * Math.pow(2, gm("water_move_bonus").float())) + "<br>";

  gm("move_add").html(moveText);
}


function charCalcBaseDamage(){

  var strikingST = 1 * getAttr('ST') + gm("ST_strike_bonus").int();

  gm("damages damage-thr").html(getThr(strikingST));
  gm("damages damage-sw").html(getSw(strikingST));
  gm("damages damage-punch").html(modifyDamage(getThr(strikingST), -1));
  gm("damages damage-kick").html(getThr(strikingST));

  var weaponBonus = {};
  globalSkillsAndTechniqueListNotStopped.find("weapon_bonus").each(function () {
    // Тупо предполагаем что там всегда DX
    var lev = parseInt($(this).parent().find(">gc-stat").text().substr(2)) || 0;
    if ($(this).parent().find(">gc-stat").text().substr(0, 2) != 'DX') lev = undefined;

    if (lev >= $(this).find("level").int()) {
      weaponBonus[$(this).find("name").text()] = $(this).find("amount").int() + (weaponBonus[$(this).find("name").text()] || 0);
    }
  });

  var dicesPunch = getBaseDice(gm("damages damage-punch").html());
  var dicesKick = getBaseDice(gm("damages damage-kick").html());
  $.each(weaponBonus, function (k, v) {
    gm("damages damage-punch").append("<weapon-bonus class='gc-tool-click'>" + k + " <ammount>+" + v * dicesPunch + "</ammount></weapon-bonus>");
    gm("damages damage-kick").append("<weapon-bonus class='gc-tool-click'>" + k + " <ammount>+" + v * dicesKick + "</ammount></weapon-bonus>");
  });

}

function charCalcActiveDefence() {
  var encumbranceBonus = gm("encumbrance_bonus").int();
  var lowFp = (gm(".fp-low.gc-warning").length);
  var lowHp = (gm(".hp-low.gc-warning").length);
  var dodge = Math.floor(getAttr('SPEED_result')) + 3 + gm("dodge_bonus").int() + encumbranceBonus;
  if (lowFp) dodge *= 0.5;
  if (lowHp) dodge *= 0.5;
  dodge = (dodge < 1) ? 1 : Math.ceil(dodge);
  dodge = "<val class='gc-tool-click'>" + dodge + "</val>";

  if (encumbranceBonus != 0) dodge += "<dodge-tmp-modifier>нагрузка " + encumbranceBonus + "</dodge-tmp-modifier>";
  if (lowHp) dodge += "<dodge-tmp-modifier>1/2 за раны</note>";
  if (lowFp) dodge += "<dodge-tmp-modifier>1/2 - устал</note>";


  gm("damages dodge").html(dodge).lightStatus("gc-warning", gm("dodge_bonus").hasClass("temporal"));

  gm("damages parry,damages block").remove();


  var temporal = gm("parry_bonus").hasClass("temporal") ? "gc-warning" : "";
  globalSkillsAndTechniqueListNotStopped.find("parry").each(function () {
    var obj = $(this).parent();
    if ($(obj).find(">points").int() > 0) {
      var add = ($(this).attr("after-attack") == "no") ? "<no-parry-after-attack class='nosave'></no-parry-after-attack>" : "";
      gm("damages dodge").before("<parry class='nosave " + temporal + "'><note>Parry " + $(obj).find("name-loc").html() + "</note><val class='gc-tool-click'>" + (Math.floor($(obj).find("gc-level").int() / 2) + 3 + $(this).int() + gm("parry_bonus").int()) + "</val>" + add + "</parry>");
    }
  });

  var temporal = gm("block_bonus").hasClass("temporal") ? "gc-warning" : "";
  globalSkillsAndTechniqueListNotStopped.find("block").each(function () {
    var obj = $(this).parent();
    if ($(obj).find(">points").int() > 0) {
      gm("damages dodge").before("<block class='nosave " + temporal + "'><note>Block " + $(obj).find("name-loc").html() + "</note><val class='gc-tool-click'>" + (Math.floor($(obj).find("gc-level").int() / 2) + 3 + $(this).int() + gm("block_bonus").int()) + "</val></block>");
    }
  });
}



function charCalcTotal(){
  var totalCost = 0;
  var totalStats = 0, totalAdv = 0, totalDisadv = 0, totalQuirks = 0, totalSkills = 0, totalSpells = 0,
    totalRace = 0;
  gm("gc-cost, skill>points, technique>points, spell>points").each(function () {

    if ($(this).parents("advantage_container[type]").length) {
      return // Это специальный контейнер - ненадо считать
    }

    var currentPoints = ($(this).attr("gc-points") !== undefined) ? ($(this).attr("gc-points") * 1) : ($(this).int() || 0);

    totalCost += currentPoints;

    //var tag=$(this)[0].tagName.toLowerCase();
    if ($(this).hasClass('attr_cost') || $(this).hasClass('second_attr_cost')) totalStats += currentPoints;
    if ($(this).parents("skill_list").length) totalSkills += currentPoints;
    if ($(this).parents("spell_list").length) totalSpells += currentPoints;
    if ($(this).parents("advantage_list").length) {
      if ($(this).parent().find("category:contains('Quirk')").length) totalQuirks += currentPoints;
      else if (currentPoints < 0) totalDisadv += currentPoints;
      else totalAdv += currentPoints;
    }
  });

  gm("advantage_container[type]").each(function () {
    if ($(this).parents("advantage_container[type]").length) {
      return // ненадо считать вложеные контейнеры!
    }
    var cost = $(this).find(">gc-container-cost").int();
    totalCost += cost;
    if ($(this).attr("type") == 'race') {
      totalRace += cost;
    } else {
      if (cost < 0) totalDisadv += cost;
      else totalAdv += cost;
    }

  });

  var totalPoints = gm("total_points").int() + gm("earn_points").int()

  var totalLeft = totalPoints - totalCost;
  if (isNaN(totalLeft)) totalLeft = "---";
  gm("left_points").text(totalLeft);
  gm("spend_points").text(totalCost);
  gm("spend_points_stats").text(totalStats);
  gm("spend_points_adv").text(totalAdv);
  gm("spend_points_disadv").text(totalDisadv);
  gm("spend_points_quirks").text(totalQuirks);
  gm("spend_points_skills").text(totalSkills);
  gm("spend_points_spells").text(totalSpells);
  gm("spend_points_race").text(totalRace);
  gm("left_points").lightStatus("gc-ok", (totalPoints == totalCost));
  gm("left_points").lightStatus("gc-warning", (totalPoints < totalCost));

  var disadvantagesThreshold = gm("disadvantages_threshold").int() || -40;
  gm("spend_points_disadv").lightStatus("gc-warning", (gm("spend_points_disadv").int() < disadvantagesThreshold ));

  var quirksThreshold = gm("quirks_threshold").int() || -5;
  gm("spend_points_quirks").lightStatus("gc-warning", (gm("spend_points_quirks").int() < quirksThreshold ));
}

function charCalcWeapons() {
  // Проверка достаточности силы - что-то надо как-то по другому - сильно глобально проходит!
  var st = getAttr('ST');
  gm("strength").each(function () {
    $(this).removeClass('gc-warning').removeClass('gc-info');
    if ($(this).text().indexOf("M") > 0) return;
    if ($(this).text().indexOf("B") > 0) {
      // если есть турель
      if (Math.ceil($(this).int() * 2 / 3) > st) $(this).addClass('gc-warning');
      else if ($(this).int() > st) $(this).addClass('gc-info');

    }
    else if ($(this).int() > st) {
      $(this).addClass('gc-warning');
    }
  })

  $(globalChar).find(".gc-modified-value").remove();
  $(globalChar).find(".gc-source-value").removeClass("gc-source-value");


  // Скилы для оружия
  gm("ranged_weapon,melee_weapon,dr_bonus,transport").each(function () {
    var bestDefault = getBestDefault($(this), true);

    var modifier = $(this).find("handling").int() | 0;
    if (modifier != 0) {
      bestDefault.bestDefaultText += " мод" + ((modifier > 0) ? "+" : "") + modifier;
      bestDefault.bestDefaultLevel += modifier;
    }

    if (bestDefault.bestDefaultLevel < 0) bestDefault.bestDefaultLevel = "";

    $(this).find("gc-level").html(bestDefault.bestDefaultLevel);
    $(this).find("gc-default").html(bestDefault.bestDefaultText).prop("title", "Умения:\n" + bestDefault.defaultsListText);

    $(this).find("damage-result, range-result").remove();

    // демедж за левел адвантаги
    var levels = $(this).parent().find(">levels").int();
    $(this).find("*[level_mod='yes']").each(function () {

      $(this).addClass("gc-source-value");
      var tag = $(this).prop("tagName").toLowerCase();

      var newVal = modifyField($(this).text(), levels, (tag == "damage") ? "damage dice multiply" : "multiply");
      $(this).after("<" + tag + " class='nosave gc-modified-value'>" + newVal + "</" + tag + ">")
    });
  })

  // Модификаторы оружия
  $(globalChar).find("equipment_modifier>*").each(function () {
    if ($(this).parent().parent().attr("state") == 'not carried' || $(this).parent().parent().attr("state") == 'carried' || $(this).parent().parent().attr("enabled") == 'no') {
      $(this).removeClass("gc-warning");
      return;
    }
    var mod = $(this);
    var tag = $(this)[0].tagName;
    var source = $(this).parent().parent().parent("equipment_container,advantage").find(">ranged_weapon,>melee_weapon,>transport");
    if (mod.attr("type") == "create") source.append("<" + tag + " class='nosave gc-modified-value'>" + mod.text() + "</" + tag + ">");
    var target = source.find(">" + tag);

    if (tag == "SKILL_LEVEL") {
      target = $(this).parent().parent().parent("equipment_container").find(">*>gc-level");
      mod.lightStatus("gc-warning", target.length == 0);
      target.each(function () {
        $(this).html(modifyFieldByTag($(this).text(), mod));
      });
    } else if (tag == "VALUE") {
      mod.lightStatus("gc-warning", $(this).parent().parent().parent("equipment_container").length == 0);
    }
    else {
      mod.lightStatus("gc-warning", target.length == 0);
      target.each(function () {
        if (!$(this).hasClass("gc-source-value")) {
          $(this).addClass("gc-source-value");
          var result = modifyFieldByTag($(this).text(), mod)
          var newObj = $(this).after("<" + tag + " class='nosave gc-modified-value'>" + result + "</" + tag + ">");
        }
      });
    }
  });

  // Добавляем Sw и Thr а так-же Range x
  gm("ranged_weapon,melee_weapon,dr_bonus,transport").each(function () {

    var selfStrength = ($(this).find("self_strength:not(.gc-source-value)").int());
    $(this).find("damage").not(".gc-source-value").each(function () {

      var d_parsed = $(this).text().match(/(thr|sw)( ){0,10}((\+|\-)[0-9]{1,2}){0,1}(( ){0,10}(:)((\+|\-)[0-9]{1,2})){0,1}(.*)/);

      if (d_parsed !== null) {
        var mod = d_parsed[1];
        var damageMod = parseInt(d_parsed[3]) || 0;
        var perDice = parseInt(d_parsed[8] || 0);
        var endOfDamage = d_parsed[10];

        var baseDmg = "";
        if (selfStrength > 0) baseDmg = (mod == "sw") ? getSw(selfStrength) : getThr(selfStrength);
        else baseDmg = gm("damages damage-" + mod).text();

        baseDmg = modifyDamage(baseDmg, perDice, true);
        baseDmg = modifyDamage(baseDmg, damageMod);


        $(this).after("<damage-result class='nosave' level_mod='" + $(this).attr('level_mod') + "'>" + baseDmg + " " + endOfDamage + "</damage-result>");
      }


    });

    var weaponSt = (selfStrength > 0) ? selfStrength : getAttr('st');
    $(this).find("range").not(".gc-source-value").each(function () {
      if ($(this).text()[0] == 'x') {
        var spl = $(this).text().split('/');
        $(this).after("<range-result class='nosave'>" + round((spl[0] || "").substr(1) * weaponSt) + "/" + round((spl[1] || "").substr(1) * weaponSt) + "</range-result>");
      }

    });
  });
}

function charCalcDR(){
  function drSumm(a, b) {
    // Архаизм с записью брони через дробь можно бурать в последствии
    var x = (a + "").split("/");
    var y = (b + "").split("/");
    if (x[1] == undefined) x[1] = x[0];
    if (y[1] == undefined) y[1] = y[0];
    x[0] = parseInt(x[0]) + parseInt(y[0]);
    x[1] = parseInt(x[1]) + parseInt(y[1]);

    if (x[0] == x[1]) return (x[0]);
    return (x[0] + "/" + x[1]);
  }

  function drSummObj(res, src) {

    function getObjByTypeOrCreate(inObj, typeName) {
      var obj = $(inObj).find(">dr[type='" + typeName + "']");
      if (obj.length == 0) {
        obj = $("<dr type='" + typeName + "'>" + inObj.find(">dr:first").html() + "</dr>");
        $(inObj).find(">dr:first").after(obj);
      }
      return obj;
    }

    if ($(src)[0].tagName == "LOCATION") {
      // если суммируем с существующим объетом!
      src.find(">dr[type]").each(function () {
        var obj = getObjByTypeOrCreate(res, $(this).attr("type"));
        obj.html(drSumm(obj.html(), $(this).html()))
      });
      $(res).find(">dr:first").html(drSumm($(res).find(">dr:first").text(), $(src).find(">dr:first").text()));

    } else {
      // если сумируем с объектом с листа
      var srcVal = (src.find("amount,>dr:first").not(".gc-source-value").text() || 0);
      var addGlobal = true;

      src.find(">damage-type").each(function () {
        addGlobal = false;
        var k = 1;
        if ($(src).attr("except-damage-type") == "yes") {
          addGlobal = true;
          k = -1;
        }
        var obj = getObjByTypeOrCreate(res, $(this).text());
        obj.html(drSumm(obj.html(), k * srcVal))
      });

      if (addGlobal) $(res).find(">dr").each(function () {
        $(this).html(drSumm($(this).html(), srcVal))
      });
    }
  }


  var locationsList = gm("locations-list");

  locationsList.find("location dr").remove();
  locationsList.find(".custom-location").remove();
  locationsList.find("location").prepend("<dr>0</dr>");
  locationsList.find("location[name='skull'] dr").html("2");

  var fullBody = $("<location><dr>0</dr></location>"); // Объект временного хранения
  var fullBodyExceptEyes = $("<location><dr>0</dr></location>"); // Объект временного хранения
  globalModifiersOn.find(">dr_bonus").each(function () {
    var location = $(this).find("location").text();
    var srcObj = $(this);
    if (location == 'full body') {
      drSummObj(fullBody, srcObj);
    }
    else if (location == 'full body except eyes') {
      drSummObj(fullBodyExceptEyes, srcObj);
    }
    else if (location == 'head') {
      drSummObj(locationsList.find("location[name='face']"), srcObj);
      drSummObj(locationsList.find("location[name='skull']"), srcObj);
    }
    else {
      var obj = locationsList.find("location[name='" + location + "']");
      if (obj.length == 0) {
        var appendTo = locationsList;
        if (location == 'chest' || location == 'abdomen') appendTo = locationsList.find("location[name='torso']");
        if (location == 'shoulders' || location == 'upper arms' || location == 'elbows' || location == 'forearms') appendTo = locationsList.find("location[name='arms']");
        if (location == 'thighs' || location == 'knees' || location == 'shins') appendTo = locationsList.find("location[name='legs']");
        obj = $("<location name='" + location + "' class='custom-location'><dr>0</dr></location>");
        appendTo.append(obj);
      }
      drSummObj(obj, srcObj);
    }
  });
  locationsList.find("location>location").each(function () {
    // суммируем сабброню
    drSummObj(this, $(this).parent())
  });

  locationsList.find("location").each(function () {
    drSummObj($(this), fullBody);
    if ($(this).attr("name") != "eyes") drSummObj($(this), fullBodyExceptEyes);
  });
}



/// -------------------- Render Char Functions

function charAddMisingTags(){
  function addTagIfNotExists(name, path, mode, element, value) {
    value = value || "";
    if (gm(path + name).length == 0) {
      var tag = "\n<" + name + ">" + value + "</" + name + ">\n";
      if (mode == "append") gm(element).append(tag);
      if (mode == "prepend") gm(element).prepend(tag);
      if (mode == "after") gm(element).after(tag);
      if (mode == "before") gm(element).before(tag);
    }
  }

  addTagIfNotExists("name", ">character>profile>", "prepend", ">character>profile");
  addTagIfNotExists("tech_level", ">character>profile>", "after", ">character>profile>name", "8");

  addTagIfNotExists("advantage_list", ">character>", "append", ">character");
  addTagIfNotExists("skill_list", ">character>", "append", ">character");
  addTagIfNotExists("spell_list", ">character>", "append", ">character");
  addTagIfNotExists("equipment_list", ">character>", "append", ">character");
  addTagIfNotExists("notes", ">character>", "append", ">character");
  addTagIfNotExists("history", ">character>", "append", ">character");
  addTagIfNotExists("condition_list", ">character>", "before", ">character>advantage_list");

  //addTagIfNotExists("profile", ">character>", "before", ">advantage_list");

  addTagIfNotExists("portrait", ">character>profile>", "append", ">character>profile");
  addTagIfNotExists("notes", ">character>profile>", "before", ">character>profile>portrait", "0");
  addTagIfNotExists("sm", ">character>profile>", "before", ">character>profile>notes");

  addTagIfNotExists("total_points", ">character>", "after", ">character>profile","100");
  addTagIfNotExists("earn_points", ">character>", "after", ">character>total_points","0");
  addTagIfNotExists("disadvantages_threshold", ">character>", "after", ">character>profile","-40");
  addTagIfNotExists("quirks_threshold", ">character>", "after", ">character>profile","-5");


  //todo статы и вторичные статы

  addTagIfNotExists("hp_lost", ">character>", "after", "move");
  addTagIfNotExists("fp_lost", ">character>", "after", "move");
  //undone


  // Template
  addTagIfNotExists("advantage_list", ">template-fix>", "prepend", ">template-fix");
  addTagIfNotExists("skill_list", ">template-fix>", "after", ">template-fix>advantage_list");
  addTagIfNotExists("spell_list", ">template-fix>", "after", ">template-fix>skill_list");
  addTagIfNotExists("equipment_list", ">template-fix>", "after", ">template-fix>spell_list");
  addTagIfNotExists("notes", ">template-fix>", "after", ">template-fix>spell_list");
  addTagIfNotExists("history", ">template-fix>", "append", ">template-fix");

  addTagIfNotExists("profile", ">template-fix>", "prepend", ">template-fix");
  addTagIfNotExists("name", ">template-fix>profile>", "append", ">template-fix>profile","Название");
  addTagIfNotExists("notes", ">template-fix>profile>", "after", ">template-fix>profile>name","");
  addTagIfNotExists("portrait", ">template-fix>profile>", "append", ">template-fix>profile");

  //      addTagIfNotExists("declaration", ">template-fix>", "prepend", ">template-fix");
  //      addTagIfNotExists("name", ">template-fix>declaration>", "append", ">template-fix>declaration");
  addTagIfNotExists("spend_points", ">template-fix>", "prepend", ">template-fix");

}

function charRenderProfile(){
  gm("profile>*").addClass("editable editable-locked");

  if (gm("profile portrait").length == 0) gm("profile").append("<portrait></portrait>");
  gm("profile").prepend("<portrait-img class='nosave'></portrait-img>");
  portraitShow();

  gm("profile tech_level").addClass('spinner spinner-not-negative editable');

  gm("profile sm").after("<SM_result class='nosave spinner editable result-reverse'/>");

  gm("profile").before("<minimizer class='nosave profile_minimizer'></minimizer>");
}

function charRenderTotal(){
  gm("total_points").addClass('spinner spinner-five editable nozoom');
  gm("earn_points").addClass('spinner editable unlockable nozoom');
  gm("spend_points").addClass('nozoom');

  gm("total_points,spend_points").after(
    "<left_points class='nosave nozoom'></left_points>" +
    "<spend_points_details class='nosave nozoom'>" +
    " <spend_points_stats class='nosave spend_points_details'></spend_points_stats>" +
    " <spend_points_adv class='nosave spend_points_details'></spend_points_adv>" +
    " <spend_points_disadv class='nosave spend_points_details'></spend_points_disadv>" +
    " <spend_points_quirks class='nosave spend_points_details'></spend_points_quirks>" +
    " <spend_points_skills class='nosave spend_points_details'></spend_points_skills>" +
    " <spend_points_spells class='nosave spend_points_details'></spend_points_spells>" +
    " <spend_points_race class='nosave spend_points_details'></spend_points_race>" +
    "</spend_points_details>"
  );
  gm("disadvantages_threshold").addClass('spinner spinner-not-positive spinner-five editable nozoom');
  gm("quirks_threshold").addClass('spinner spinner-not-positive editable nozoom');
}

function charRenderToolbars(){
  var toolbar = $("<list_toolbar class='nosave'><font-increment></font-increment> <font-decrement></font-decrement> <description-inline-btn></description-inline-btn> <fold-unfold></fold-unfold> <sort></sort> <container-add></container-add> <item-add></item-add>  <page-cut-btn></page-cut-btn></list_toolbar>");

  gm("advantage_list,skill_list,spell_list,equipment_list").before(toolbar);
  gm("character>notes").before("<list_toolbar class='nosave'><page-cut-btn></page-cut-btn></list_toolbar>");
  gm("character>condition_list").before("<list_toolbar class='nosave'><item-add></item-add></list_toolbar>");

  gm("list_toolbar").each(function () {$(this).addClass($(this).next().prop("tagName").toLowerCase()+"_toolbar");})
}

function charRenderHistory(){
  gm("history").addClass("nozoom").before("<list_toolbar class='nosave history_toolbar nozoom'><close-btn></close-btn><add-note></add-note> </list_toolbar>");
  gm("history").children().filter("note").addClass("editable");
}

function charRenderAllLists(){
  gm("advantage_container,skill_container,spell_container,equipment_container").each(function () {renderContainer($(this));});

  gm("advantage_list advantage").each(function () {renderAdvantage($(this));});

  gm("condition_list advantage").each(function () {renderAdvantage($(this));});

  gm("skill_list skill,skill_list technique").each(function () {renderSkill($(this));});

  gm("spell_list spell").each(function () {renderSpell($(this));});

  gm("equipment_list equipment").each(function () {renderEquipment($(this));});

  gm("obj").each(function () {renderCustomItem($(this));});
}


function charRenderClassicElements() {


  gm("character>profile").after("<HP_result class='nosave'/><WILL_result class='nosave'/><PERCEPTION_result class='nosave'/><FP_result class='nosave'/><move_result class='nosave'/><speed_result class='nosave'/>" +
    "<will_add class='nosave'/><perception_add class='nosave'/><move_add class='nosave'/><st_add class='nosave'/>")

  gm("character>profile").after("<ST_bonus class='nosave bonus'/><DX_bonus class='nosave bonus'/><IQ_bonus class='nosave bonus'/><HT_bonus class='nosave bonus'/><HP_bonus class='nosave bonus'/><WILL_bonus class='nosave bonus'/><PERCEPTION_bonus class='nosave bonus'/><FP_bonus class='nosave bonus'/><move_bonus class='nosave bonus'/><speed_bonus class='nosave bonus'/><dodge_bonus class='nosave bonus'/><parry_bonus class='nosave bonus'/><block_bonus class='nosave bonus'/><SM_bonus class='nosave bonus'/><ST_strike_bonus class='nosave bonus'/><ST_lift_bonus class='nosave bonus'/><encumbrance_bonus class='nosave bonus'/>" +
    "<hearing_bonus class='nosave bonus'/><taste_smell_bonus class='nosave bonus'/><touch_bonus class='nosave bonus'/><vision_bonus class='nosave bonus'/><fright_check_bonus class='nosave bonus'/><air_move_bonus class='nosave bonus'/><ground_move_bonus class='nosave bonus'/><space_move_bonus class='nosave bonus'/><water_move_bonus class='nosave bonus'/><move_multiplyaer_bonus class='nosave bonus'/><reaction_bonus class='nosave bonus'/>");

  gm("character>profile").after("<ST_cost_modifier class='nosave cost-modifier'/><DX_cost_modifier class='nosave cost-modifier'/><IQ_cost_modifier class='nosave cost-modifier'/><HT_cost_modifier class='nosave cost-modifier'/><HP_cost_modifier class='nosave cost-modifier'/>");
  gm("character>profile").after("<total-wealth-modifier class='nosave cost-modifier'/>");

  gm("character").find("speed,speed_result").addClass("spinner-quarter float");

  gm("character").find("hp_lost,fp_lost").addClass("editable unlockable");

  gm("character>profile").after("<ST_result class='nosave'/><DX_result class='nosave'/><IQ_result class='nosave'/><HT_result class='nosave'/>");


  gm("character").find("ST_result,DX_result,IQ_result,HT_result,hp_result,will_result,perception_result,fp_result,move_result,speed_result").addClass("spinner spinner-not-negative editable result-reverse stat-result");

  gm("character").find("ST_result,DX_result,IQ_result,HT_result,will_result,perception_result").addClass("spinner-tool-btn");

  gm("character").find("ST_result,DX_result,IQ_result,HT_result").after("<gc-cost class='nosave attr_cost'></gc-cost>")
  gm("character").find("hp,fp,will,perception,speed,move").each(function () {
    $(this).after("<gc-cost class='nosave second_attr_cost " + $(this)[0].tagName + "_cost'></gc-cost>");
  });

  gm("character>condition_list").before(
    "<hp-mark class='nosave'></hp-mark>" +
    "<lift class='nosave'></lift>" +
    "<fp-mark class='nosave'></fp-mark>" +
    "<damages class='nosave'>" +
    "<damage-thr class='nosave gc-tool-click'></damage-thr>" +
    "<damage-sw class='nosave gc-tool-click'></damage-sw>" +
    "<damage-punch class='nosave gc-tool-click'></damage-punch>" +
    "<damage-kick class='nosave gc-tool-click'></damage-kick>" +
    "<separator class='nosave'></separator>" +
    "<dodge class='nosave'></dodge>" +
    "</damages>" +
    "<locations-list class='nosave'>" +
    "<location name='skull'><dr></dr><to-hit>-7</to-hit><roll>3 4</roll></location>" +
    "<location name='face'><dr></dr><to-hit>-5</to-hit><roll>5</roll></location>" +
    "<location name='eyes'><dr></dr><to-hit>-9</to-hit></location>" +
    "<location name='neck'><dr></dr><to-hit>-5</to-hit><roll>17 18</roll></location>" +
    "<location name='torso'><dr></dr><to-hit>0</to-hit><roll>9 10</roll></location>" +
    "<location name='groin'><dr></dr><to-hit>-3</to-hit><roll>11</roll></location>" +
    "<location name='arms'><dr></dr><to-hit>-2</to-hit><roll>п.8<br/>л.12</roll></location>" +
    "<location name='hands'><dr></dr><to-hit>-4</to-hit><roll>15</roll></location>" +
    "<location name='legs'><dr></dr><to-hit>-2</to-hit><roll>п.6 7<br/>л.13 14</roll></location>" +
    "<location name='feet'><dr></dr><to-hit>-4</to-hit><roll>16</roll></location>" +
    "</locations-list>" +
    "<reaction-text class='nosave'></reaction-text>");

  // Notes on the bottom
  gm(">template-fix>notes,>character>notes").addClass("editable unlockable");
}