var dragObj=$();
var dragAccept="";
var dragCounter=0;
var dragLastDrop=$();
var dragCopy;
var dragOverTimestamp=0;

function clearDrag(from)
{
  from.unbind('dragstart drop dragover dragleave dragenter dragend');
  from.removeAttr("draggable");
}

function setDrag() {

  if (viewerMode) return;

  // Из библиотеки
  var libXml=$("lib-xml");
  makeDraggable(libXml.find("advantage"),globalChar.find("advantage_list advantage,advantage_list advantage_container,advantage_list"),true);
  makeDraggable(libXml.find("skill,technique"),globalChar.find("skill,skill_container,technique,skill_list"),true);
  makeDraggable(libXml.find("spell"),globalChar.find("spell,spell_container,spell_list"),true);
  makeDraggable(libXml.find("equipment"),globalChar.find("equipment,equipment_container,equipment_list"),true);

  // на листе персонажа
  makeDraggable(globalChar.find("advantage_list advantage,advantage_list advantage_container"), globalChar.find("advantage_list advantage,advantage_list advantage_container,advantage_list"),false);
  makeDraggable(globalChar.find("skill,technique,skill_container"), globalChar.find("skill,technique,skill_container,skill_list"),false);
  makeDraggable(globalChar.find("spell,spell_container"), globalChar.find("spell,spell_container,spell_list"),false);
  makeDraggable(globalChar.find("equipment,equipment_container"), globalChar.find("equipment,equipment_container,equipment_list"),false);

  // Кастомные объекты
  globalChar.find(".can-move").each(function() {
    makeDraggable($(this).find("obj"), globalChar.find("obj"), false);
  });

  if (lockedMode) clearDrag(globalChar.find("advantage,advantage_container,advantage_list,skill,skill_container,technique,skill_list,spell,spell_container,spell_list"));
}

function makeDraggable(from, accept, doCopy) {

  if (isTouchDevice()) return; // На мобилах драг дропа нет - пользуйте кнопочки

  function removeDropMarker() {
    dragLastDrop.removeClass("ui-drop-before").removeClass("ui-drop-after").removeClass("ui-drop-inside");
  }

  from.attr("draggable","true");

  // Drag Start
  from.unbind('dragstart').bind('dragstart', function () {

    dragCounter=0;
    dragCopy=doCopy;
    if (event.ctrlKey) dragCopy=true;
    if (dragCopy) event.dataTransfer.effectAllowed='copy';

    var el=$("<div class='ui-drag-counter'></div>")
    $(event.target).before(el);
    event.dataTransfer.setDragImage($(el)[0], -10, -10);

    if ($(event.target).hasClass("ui-selected")) {
      if (dragCopy) dragObj = $(".ui-selected").clone();
      else dragObj = $(".ui-selected");
    }
    else {
      if (dragCopy) dragObj = $(event.target).clone();
      else dragObj = $(event.target);
    }
    dragObj.addClass("ui-dragging");


    var strAdd=(dragCopy)?'+ ':'';
    if ($(dragObj).length==1) $(".ui-drag-counter").html(strAdd+$(dragObj).find(">name,>description").text());
    else {$(".ui-drag-counter").html(strAdd+$(dragObj).length);}


    $(dragObj).removeClass("ui-selected");
    dragAccept="yes";
    var dropList=placeToDrop(dragObj);
    dropList.addClass("gc-dropplace");


    event.stopPropagation(); // Защита от двойного драга внутри кнотейнера

    return true;
  });

  from.unbind('dragend').bind('dragend', function () {
    $(".ui-drag-counter").remove();
    $(".ui-dragging").removeClass("ui-dragging");
    $(".ui-selected").removeClass("ui-selected");
    $(".gc-dropplace").removeClass("gc-dropplace");
    removeDropMarker();
    dragAccept="";
  });

  // Drag Enter
  accept.unbind('dragenter').bind('dragenter',function (){
    if (dragAccept=="") return true;
    dragCounter++;
  });

  // Drag Leave
  accept.unbind('dragleave').bind('dragleave',function (){
    if (dragAccept=="") return true;
    dragCounter--;
    if (dragCounter === 0) removeDropMarker();
  });

  // Drag Over
  accept.unbind('dragover').bind('dragover',function (){

    event.preventDefault();

    if (dragAccept=="") return true;

    if (Date.now()<(dragOverTimestamp+50)) return false; // задержка убирающая лаг
    dragOverTimestamp=Date.now();

    var place=$(event.currentTarget);
    var isList;


    if (isDropable(dragObj,place)) {
      removeDropMarker();

      var tag = place[0].tagName.toLowerCase();
      if ($(dragObj).attr("modifier")=="yes") {
        if (tag=="advantage") place.addClass("ui-drop-inside");
      }
      else if (tag=="advantage_list"||tag=="skill_list"||tag=="spell_list"||tag=="equipment_list") {place.addClass("ui-drop-inside");}
      else if (tag=="equipment"&&event.layerY >5&&event.layerY < place.height()-5&&isEquipmentModifier(dragObj)&&isEquipmentAutoContainer(place)) {place.addClass("ui-drop-inside");}
      else if (event.layerY < place.height()/2) {place.addClass("ui-drop-before");}
      else {place.addClass("ui-drop-after");}
      dragLastDrop=place;

    }
    else {
      return true;
    }


  });

  // Drop
  accept.unbind('drop').bind('drop', function () {

    if (dragObj.length==0) return false;

    if ($(".ui-drop-inside").prop("tagName")=="EQUIPMENT") {
      var newObj=convertEquipmentToContainer($(".ui-drop-inside"));
      $(newObj).append(dragObj);
    }

    if ((dragObj).attr("modifier")) {
      // Модификаор накладывается на адвантагу
      addModifierToAdvantage($(dragObj), $(".ui-drop-inside"));
    }
    else {
      $(".ui-drop-before").before(dragObj);
      $(".ui-drop-after").after(dragObj);
      $(".ui-drop-inside").prepend(dragObj);

      clearObj($(dragObj));

      $(dragObj).each(function (){
        renderObj($(this));
      });


      if (dragCopy&&$(dragObj).length==1) editObj($(dragObj), true);
      checkEmptyContainers();
      setDrag();
      bindEvents();
      saveButtonEnable();
      if (dragCopy) {
        calcAll();
        logIt($(dragObj),"add");
        setModifyAttr($(dragObj),"changed");
      } else {
        calcAllSchedule();
        setModifyAttr($(dragObj),"moved");
      }


      flashObj($(dragObj));
    }

    removeDropMarker();
    dragCounter=1;

    event.preventDefault();
    event.stopPropagation();
    event.stopImmediatePropagation();
    return true;
  });

}

function isDropable(source,dest){
  if ($(dest).parents().is($(source))) return false; // Зпрещаем кидать группу в саму себя
  var tag = $(source)[0].tagName.toLowerCase();
  var tag2 = $(dest)[0].tagName.toLowerCase();
  if ((tag == "advantage" || tag =="advantage_container") && (tag2=="advantage"||tag2=="advantage_container"||tag2=="advantage_list")) return true;
  if ((tag == "skill" || tag =="technique" || tag =="skill_container") && (tag2=="skill"||tag2=="skill_container"||tag2=="technique"||tag2=="skill_list")) return true;
  if ((tag == "spell" || tag =="spell_container") && (tag2=="spell"||tag2=="spell_container"||tag2=="spell_list")) return true;
  if ((tag == "equipment" || tag =="equipment_container") && (tag2=="equipment"||tag2=="equipment_container"||tag2=="equipment_list")) return true;
  if ((tag=="text-block"||tag=="group")&&(tag2=="text-block"||tag2=="group")) return true;
  if (tag=="obj"&&(tag2=="obj"||tag2=="obj-list")&&$(source).parent().is($(dest).parent())) return true;
  return false;
}

function placeToDrop(obj){
  var tag = $(obj)[0].tagName.toLowerCase();
  if (tag == "advantage" || tag =="advantage_container") return globalChar.find("advantage_list");
  if (tag == "skill" ||tag == "technique" || tag =="skill_container") return globalChar.find("skill_list");
  if (tag == "spell" || tag =="spell_container")  return globalChar.find("spell_list");
  if (tag == "equipment" || tag =="equipment_container")  return globalChar.find("equipment_list");
  if (tag=="obj"){
    var objList=$(obj).parents("obj-list");
    echo (obj,objList)
    if (objList.length&&objList.attr("type").length) {return globalChar.find("obj-list[type='"+objList.attr("type")+"']");}
    return $(obj).parents("obj-list.can-modify");
  }
  return $();
}