function loadLib(fileName,btnObj) {
  $('infopopup').addClass('empty');

  $('lib-menu more').removeClass('visible');

  $('lib-menu button, char-menu button').removeClass('selected');
  $(btnObj).addClass('selected');

  var path=(typeof standalonePath != "undefined")?standalonePath:"./";

  $("lib-xml").html("<loading/>");

  if (standaloneMode) {

    if (fileName=='upload'){
      var fileReader = new FileReader();
      fileReader.onload = function(fileLoadedEvent){
        libLoaded(fileLoadedEvent.target.result)
      };
      fileReader.readAsText($("lib lib-menu input")[0].files[0], "UTF-8");
    }else {
      var clearName=fileName.substr(4,fileName.indexOf("?")-4);
      libLoaded(standaloneLibs[clearName]);
    }
  }
  else {
    $.ajax({
      type: "GET",
      url: path + fileName,
      dataType: "html",
      cache: true,
      contentType: "application/xhtml+xml;charset=utf-8",
      success: libLoaded
    });
  }
}

function libLoaded(result){
    // необходимо, поскольку template зарезервированый тег
    result = result.replace("<template", "<template-fix");
    result = result.replace("</template", "</template-fix");

    var libXml=$("lib-xml");
    libXml.html($(result));

    if (typeof publicLibClearMarkers === "function") publicLibClearMarkers(libXml);

    if (typeof standalonePath != "undefined") {
      libXml.find("img").each(function(){
        if ($(this).attr("data-src").search("http")!=0){
          $(this).attr("data-src",standalonePath+$(this).attr("data-src"));
        }
      });

    }

    //var libElements=libXml.find("advantage,skill,technique,spell,equipment,obj");
    var libElementsAndContainers=libXml.find("advantage,skill,technique,spell,equipment,obj,advantage_container,skill_container,spell_container,equipment_container");
    if (typeof setDrag === "function") setDrag();
    $("lib-filter points input").val("");
    loadLibCategories();
    doSearch();

    libXml.find("profile").attr("minimized","yes");
    var base = (libXml.find("portrait").html()||"").replace(/(\r\n|\n|\r)/gm, "");
    if (base!=""){
      var portrait="background-image:url(data:image/png;base64,"+base+")";
      libXml.find("profile").prepend("<portrait-img style='"+portrait+"'></portrait-img>");
    }



  libXml.find(">text").prepend("<drop-to-char class='nosave nocopy' title='Добавить на лист персонажа (Double Click)'></drop-to-char>").bind("dblclick", function () {
      addObjToChar($(this));
      return(false);
    });

    libElementsAndContainers.prepend("<drop-to-char class='nosave nocopy' title='Добавить на лист персонажа (Double Click)'></drop-to-char><view-details class='nosave nocopy' title='Описание (F1)'></view-details>");

    libXml.find("advantage_container,skill_container,spell_container,equipment_container").prepend("<expander class='nosave nocopy'/>");

    libElementsAndContainers.unbind("click").bind("click", function (e) {
      selectElement(this);
      return false;
    }).unbind("dblclick").bind("dblclick", function () {
      addObjToChar($(this));
      return(false);
    });

    libXml.find("expander").bind('click',function () {containerToggleExpand($(this).parent());});


    libXml.find("view-details").unbind("click").bind("click", function (e) {
      selectElement($(this).parent(),true);
      viewDescription($(this).parent(),true);
      return false;
    });
    libXml.find("drop-to-char").unbind("click").bind("click", function (e) {
      $(this).parent().dblclick();
    });

    libXml.find("rule").each(function() {
      $(this).html(raplaceAllReferenceLink($(this).html()));
    });

    libXml.find("advantage,skill,technique,spell,equipment").find(">type").each(function () {
      if ($(this).html().search(/mental/i) >= 0) $(this).parent().append("<type-mental class='nosave nocopy type' title='Ментальное'></type-mental>");
      if ($(this).html().search(/physical/i) >= 0) $(this).parent().append("<type-physical class='nosave nocopy type' title='Физическое'></type-physical>");
      if ($(this).html().search(/social/i) >= 0) $(this).parent().append("<type-social class='nosave nocopy type'  title='Социальное'></type-social>");
      if ($(this).html().search(/exotic/i) >= 0) $(this).parent().append("<type-exotic class='nosave nocopy type' title='Экзотик'></type-exotic>");
      if ($(this).html().search(/supernatural/i) >= 0) $(this).parent().append("<type-supernatural class='nosave nocopy type'  title='Супер'></type-supernatural>");
    });


    $("lib-filter").find("input,select,desc-search").removeClass("hide");

    if (libXml.find("advantage>type").length) $("lib-filter types,lib-filter points").removeClass("hide");
    else $("lib-filter types,lib-filter points").addClass("hide");

    if (libXml.find("equipment>tech_level").length) $("lib-filter tech_level").removeClass("hide");
    else $("lib-filter tech_level").addClass("hide");

    if (libXml.find("equipment>legality_class").length) $("lib-filter legality_class").removeClass("hide");
    else $("lib-filter legality_class").addClass("hide");


    if (libXml.find("equipment>value").length) $("lib-filter price").removeClass("hide");
    else $("lib-filter price").addClass("hide");

    if (libXml.find("equipment>weight").length) $("lib-filter weight").removeClass("hide");
    else $("lib-filter weight").addClass("hide");

    var el=$("<button class='round secondary add-random'><i class='fa fa-random fa-flip-horizontal' title='Добавить случайный объект из библиотеки'></i></button>").on('click',function(){
      // add random object

      var list = $("lib-xml").find("advantage,skill,tecnique,spell,equipment").not('.hide');
      if (list.length==0)return;

      var obj=$(list[Math.floor(Math.random()*list.length)]).clone();
      $(obj).removeClass("ui-selected");

      logIt($(obj),"add rand");

      $(obj).prependTo(placeToDrop($(obj)));
      if (templateMode) placeInFirstContainer(obj);

      setModifyAttr($(obj),"changed");

      renderObj($(obj));

      flashObj(obj);

      setDrag();
      bindEvents();
      saveButtonEnable();
      calcAll();

    });
    $("lib-xml").prepend(el);
}

function loadLibCategories() {
  var categories = {};
  $("lib-xml categories category").each(function () {

    if (categories[$(this).text()]) categories[$(this).text()]++;
    else categories[$(this).text()] = 1;
  });

  $("lib-filter select").html("<option value='' selected>--- Все категории ---</option>");

  $.each(categories, function (index, value) {
    $("lib-filter select").append("<option value='" + index + "'>" + index + " (" + value + ")" + "</option>");
  });

  $("lib-filter select").sortSelectBox();
}


// Search in lib

$("lib-filter input").on('keyup',doSearchSchedule).on('search', doSearch);
$("lib-filter input[type='number']").on('mouseup mousewheel',doSearchSchedule);
$("lib-filter input[type='range']").on('mouseup',doSearchSchedule);


$("lib-filter desc-search input").on('click',doSearch);

$("lib-filter select").change(doSearch);
$("lib-filter types>*").on('click', function () {
  var newClass='no-search';
  if ($(this).hasClass('no-search')) newClass='must-search';
  if ($(this).hasClass('must-search')) newClass='';
  $(this).attr("class",newClass);
  doSearchSchedule();
});

$("lib-filter tech_level input,lib-filter legality_class input").on('input',function (){updateRange($(this).parent())});
function updateRange(obj) {
  v1=parseInt($(obj).find("input:first-child").val());
  v2=parseInt($(obj).find("input:last-child").val());
  var t=v1;
  if (v1>v2) t=v2+" - "+v1;
  if (v1<v2) t=v1+" - "+v2;
  var maxVal=$(obj).find("input:first-child").prop("max");
  $(obj).attr("range",t).lightStatus("has-value",(t!='0 - '+maxVal));

  doSearchSchedule();
};

updateRange($("lib-filter tech_level"));
updateRange($("lib-filter legality_class"));



var searchTimeut;
function doSearchSchedule() {
  clearTimeout(searchTimeut);
  searchTimeut = setTimeout(doSearch, 200);
}
function doSearch() {
  $("lib-xml .ui-selected").removeClass("ui-selected");
  $("infopopup").addClass("empty");

  var libFilter=$("lib-filter");
  libFilter.find("input[type=search],input[type=number]").each(function () {
    $(this).lightStatus("has-value", !($(this).val() == ""));
  });
  libFilter.find("select").lightStatus("has-value", !($("lib-filter select").val() == ""));



  var category = libFilter.find("select").val();
  var types = [];
  libFilter.find("types .no-search").each(function () {
    types.push($(this).prop("tagName").substr(5).toLowerCase());
  })
  var typesMust = [];
  libFilter.find("types .must-search").each(function () {
    typesMust.push($(this).prop("tagName").substr(5).toLowerCase());
  })

  var tl1=parseInt(libFilter.find("tech_level input:first-child").val());
  var tl2=parseInt(libFilter.find("tech_level input:last-child").val());
  if (tl1>tl2) {var t=tl1; tl1=tl2; tl2=t;}
  var doTlSearch=!(tl1==0&&tl2==12);

  var lc1=parseInt(libFilter.find("legality_class input:first-child").val());
  var lc2=parseInt(libFilter.find("legality_class input:last-child").val());
  if (lc1>lc2) {var t=lc1; lc1=tl2; lc2=t;}
  var doLcSearch=!(lc1==0&&lc2==4);

  var price_from=parseInt(libFilter.find("price input:first-child").val());
  var price_to=parseInt(libFilter.find("price input:last-child").val());
  var doPriceSearch=!(isNaN(price_from)&&isNaN(price_to));

  var weight_from=parseFloat(libFilter.find("weight input:first-child").val());
  var weight_to=parseFloat(libFilter.find("weight input:last-child").val());
  var doWeightSearch=!(isNaN(weight_from)&&isNaN(weight_to));

  var points_from=parseInt(libFilter.find("points input:first-child").val());
  var points_to=parseInt(libFilter.find("points input:last-child").val());
  var doPointsSearch=!(isNaN(points_from)&&isNaN(points_to));


  var doTextSearch=libFilter.find(">input").val().length>0;
  var textSearch=libFilter.find(">input").val().toLowerCase().split(" ");
  var textSearchKeyboardSwitch=keyboardSwitch(libFilter.find(">input").val().toLowerCase()).split(" "); //тот же массив но с переключеной клавой

  var descSearch=(libFilter.find("desc-search input:checked").length)?",>description-loc":"";


  $("lib-xml").find("advantage,skill,technique,spell,equipment,rule,advantage_container,skill_container,spell_container,equipment_container").each(function () {

    var hide=false;
    if (doTextSearch) {
      var searchIn=$(this).find(">name,>name-loc,>description,>subrule"+descSearch).text().toLowerCase();
      $.each(textSearch,function( i, v ) {
        if (searchIn.indexOf(textSearch[i]) == -1 && searchIn.indexOf(textSearchKeyboardSwitch[i]) == -1) {hide=true;}
      });
    }
    $(this).lightStatus("hide",hide);

    var hideByCategory = false;
    if (category != "") {
      hideByCategory = true;
      $(this).find(">categories>category").each(function () {
        if ($(this).text() == category) hideByCategory = false;
      });
    }
    if (hideByCategory) $(this).addClass("hide");

    if ($(this).find(">type").length){
      var type = $(this).find(">type").text().toLowerCase();
      var hideByType = false;
      $.each(types, function (i, v) {
        if (type.indexOf(v) >= 0) hideByType = true;
      });
      $.each(typesMust, function (i, v) {
        if (type.indexOf(v) == -1) hideByType = true;
      });
      if (hideByType) $(this).addClass("hide");
    }

    if (doTlSearch) {
      var tech_level = $(this).find(">tech_level").int();
      if (!isNaN(tech_level)) {
        if (tl1 > tech_level || tl2 < tech_level) $(this).addClass("hide");
      }
    }

    if (doLcSearch){
      var legality_class=$(this).find(">legality_class").int();
      if (!isNaN(legality_class)) {
        if (lc1 > legality_class || lc2 < legality_class) $(this).addClass("hide");
      }
    }

    if (doPriceSearch){
      var price=$(this).find(">value").int();
      if (!isNaN(price)) {
        if (!isNaN(price_from)&&price_from>price) $(this).addClass("hide");
        if (!isNaN(price_to)&&price_to<price) $(this).addClass("hide");
      }
    }
    if (doWeightSearch){
      var weight=$(this).find(">weight").float()||0;
      if (!isNaN(weight_from)&&weight_from>weight||0) $(this).addClass("hide");
      if (!isNaN(weight_to)&&weight_to<weight) $(this).addClass("hide");
    }
    if (doPointsSearch){
      var points=$(this).find(">base_points").int()||0;
      if (!isNaN(points_from)&&points_from>points) $(this).addClass("hide");
      if (!isNaN(points_to)&&points_to<points) $(this).addClass("hide");
    }


  });
  // Показываем контейнеры в которых есть найденые элементы
  $("lib-xml").find("advantage_container,skill_container,spell_container,equipment_container").each(function () {
    var inside=$(this).find("advantage,skill,technique,spell,equipment");
    if (inside.not(".hide").length) $(this).removeClass("hide");
    else if (inside.length) $(this).addClass("hide"); // чтобы не спрятать пустые контейнеры - они важны )
  })
}

$(function (){
  window.loadLib=loadLib;
  // Защищаем телефон от нагрузки
  if ($(document).width()>800)  $(".loadLibAtStartup").click();
});


$("lib-menu more").find("h2,h3").prepend("<icon></icon>").click(function() {
  $(this).next('block').toggleClass("hide");
  $(this).find('icon').toggleClass("icon-down");
});
$("lib-menu more block").addClass("hide");

$("lib-menu .more-btn").click(function(){
  $('lib-menu more').toggleClass('visible');
  $('my-libs').load('templates_list.php');
});

$("infopopup .close").click(function(){
  $('infopopup').toggleClass('hide');
});

if ($(window).width()<1000) $('infopopup').addClass('hide');
 var standaloneLibs=[]
 standaloneLibs['Advantages&Dsiadvantages-rus.adq']=`<!--?xml version="1.0" encoding="UTF-8" ?-->
<name>Mentor: Advantages &amp; Dsiadvantages</name>
<notes>Basic Set 4ed - Преимущества, Недостатки и Причуды<br><br><a href="editor.phtml?v=10000000000000000000000000000000" target="_blank">Редактирование библиотеки</a> разрешно, но с предмодерацией</notes><editor-message>Редакторы!<br>
Эта библиотека только для преимуществ и недостатков и книги Basic Set. <br>
В качестве модификаторов местами приведены powers и прочие, но не стоит добавлять сюда отсебятину или данные из других книг без предварительного согласования.<br>
Так-же не стоит пресортировывать библиотеку.<br>
Спасибо за ваше участие!<br></editor-message>
<advantage_list unique_id="hv8id3uc:-e6u7xnrpfa9n" version="1">
	<advantage version="2">
	<name>360° Vision</name>
	<name-loc>Круговой обзор</name-loc>
	<base_points>25</base_points>
	<modifier version="1" enabled="no">
		<name>Легко попасть (Easy to hit) </name>
		<notes> Противники могут целиться в ваши глаза с -6</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B34</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Panoptic 1</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P39</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Panoptic 2</name>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>P39</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B34</reference>
	<description-loc>Вы имеете полное 360-градусное поле зрения. Вы не получаете штрафов к защите от атак сзади или с флангов, и атакуете в них со штрафом -2 из-за неудобства (однако некоторые приёмы умения Каратэ не получают данный штраф). Кроме того, вы получаете +5 на обнаружение Слежки, и вас нельзя застать врасплох, только если атакующий не скрыт от зрения совсем.
Дополнительные глаза – только специальный эффект преимущества: персонаж с этим преимуществом может не иметь ни одного глаза, или иметь сотню глаз – все это стоит одну и ту же цену.

===Особые улучшения (P39)===
Преломление (Panoptic 1): Вы можете видеть все вокруг себя, совершенно не поворачивая головы и без дополнительных глаз. Это улучшение, поскольку ваш дар становится скрытым – вы можете внешне смотреть в одном направлении, а в действительности же – совсем в другом.
Однако, глаза вам по-прежнему нужны. Если глаза вам закрыли или вас ослепили, вы видеть не можете. +20%.

Не требуется видеть (Panoptic 2): Как и выше, но вы вообще не нуждаетесь в глазах! Вы можете видеть все, даже если глаза завязаны или вы ослеплены. Вам по-прежнему нужен свет, чтобы видеть (если у вас нет Зрения в темноте). Ранения глаз ранят вас как обычно, но не лишают вас зрения. +60%.

===Особые ограничения===
Легко попасть (Easy to Hit): Ваши глаза располагаются на глазных стебельках, либо необычайно большие, или иначе уязвимы для атаки. Противники могут целиться в них с -6, если находятся в зоне их зрения. -20%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Absent-Mindedness</name>
	<name-loc>Рассеянность
</name-loc>
	<base_points>-15</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B122</reference>
	<description-loc>
		Вы испытываете проблемы со вниманием ко всему, на чем вы не сосредоточены в конкретный момент. Вы получаете -5 ко всем проверкам IQ и умений, зависящих от IQ, кроме тех, что относятся к текущему заданию. Если никакого привлекательного задания или предмета не видно, то вы спустя пять минут сосредоточитесь на более интересных вещах и не будете обращать внимание на текущее окружение, пока что-либо не привлечет ваше внимание и не вернет вас на землю. Будучи погруженным в собственные мысли, вы должны сделать проверку Восприятия(Per)-5, чтобы заметить что угодно, что не наносит лично вам физического ущерба.
Вы можете попытаться приковать свое внимание к скучному предмету за счет силы воли. Чтобы сделать это, понадобится делать проверку Воли(Will)-5 каждые пять минут. К "скучным вещам" относятся светские разговоры, монотонный ручной труд, охрана чего-либо, езда по пустому шоссе...
Рассеянные люди склонны забывать тривиальные вещи (например, оплачивать счета) и предметы (например, ключи от машины или чековую книжку). Каждый раз, когда становится важным, выполнили ли вы подобное задание и захватили ли подобную вещь, мастеру следует потребовать от вас проверки IQ-2. В случае неудачи, этот момент ускользнул от вашего внимания.
=====Пример: Рассеянный детектив попал в перестрелку. Он уже участвовал в перестрелке в этот день, и потратил там четыре патрона, так что мастер требует сделать проверку IQ-2. Детектив проваливает эту проверку, и слишком поздно обнаруживает, что забыл перезарядить оружие, так что в его револьвере осталось только два патрона!=====
Это классический недостаток эксцентричных гениев.
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Absolute Direction</name>
		<name-loc>Чувство направления</name-loc>
		<description-loc>У вас есть превосходное чувство направления. Существует два уровня преимущества:
Чувство направления (Absolute Direction): Вы всегда знаете направление на север и можете найти и повторить путь, по которому шли когда-то в течение последнего месяца - независимо от того, насколько он неразличим и запутан. Эта способность не работает в космосе, астральном плане и т.д., но работает под землей, под водой и на других планетах. Также дает +3 к умению Навигации и Чувству тела (навигационные способности мигрирующих созданий – слишком простые и грубые, чтобы их можно было отнести к Чувству направления – считайте их 0-очковой чертой). 5 очков.
Чувство пространства (3D Spatial Sense): Вы прекрасно чувствуете себя в трех измерениях. Персонаж никогда не теряет путь – даже в комплексе лабиринтов со скользящими проходами и движущимися полами. Это преимущество включает преимущество Чувство Направления со всеми его плюсами и кроме этого, добавляет +1 к навыку Пилотирования, +2 к Аэробатике, Свободному падению, Навигации (гиперпространство и космос). 10 очков.

===Особые ограничения.===
Требуется сигнал (Requires Signal): ваше чувство зависит от наличия сигнала от спутниковой системы (наподобие GPS) или чего-либо подобного. Если такой системы нет, ваше чувство не работает, кроме того, сигнал может быть заглушен. -20%.</description-loc>
		<type>Mental/Physical</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Требуется сигнал (Requires Signal)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B34</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Чувство пространства (3D Spatial Sense)</name>
			<cost type="points">5</cost>
			<affects>total</affects>
			<reference>B34</reference>
			<skill_bonus>
				<name compare="starts with">piloting</name>
				<specialization compare="is anything"></specialization>
				<amount>1</amount>
			</skill_bonus>
			<skill_bonus>
				<name compare="is">aerobatics</name>
				<specialization compare="is anything"></specialization>
				<amount>2</amount>
			</skill_bonus>
			<skill_bonus>
				<name compare="is">free fall</name>
				<specialization compare="is anything"></specialization>
				<amount>2</amount>
			</skill_bonus>
			<skill_bonus>
				<name compare="is">navigation</name>
				<specialization compare="is">hyperspace</specialization>
				<amount>2</amount>
			</skill_bonus>
			<skill_bonus>
				<name compare="is">navigation</name>
				<specialization compare="is">space</specialization>
				<amount>2</amount>
			</skill_bonus>
		</modifier>
		<reference>B34</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">body sense</name>
			<specialization compare="is anything"></specialization>
			<amount>3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">navigation</name>
			<specialization compare="is">air</specialization>
			<amount>3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">navigation</name>
			<specialization compare="is">land</specialization>
			<amount>3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">navigation</name>
			<specialization compare="is">sea</specialization>
			<amount>3</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Absolute Timing</name>
		<name-loc>Чувство времени</name-loc>
		<description-loc>Вы очень точно следите за временем. Существует два уровня преимущества, каждый из которых в какой-то мере киношный (cinematic).
Чувство времени (Absolute Timing): Если только вас не лишили сознания, загипнотизировали или повлияли на вас другим способом, вы всегда знаете текущее время с точностью лучших доступных вам часов (но не лучше, чем с точностью до нескольких секунд). С такой же точностью вы можете засекать его. Сон и смена часовых поясов не влияет на эту способность (более того, вы можете проснуться точно в установленное время, если захотите). Перемещение во времение запутает вас до того момента, пока вы не выясните, сколько сейчас времени. 2 очка.
Хронолокация (Chronolocation):  Вы абсолютно всегда знаете время, и даже перемещение во времени не может вас сбить, более того, вы точно узнаете, на сколько времени вы переместились («Ты переместился ровно на 92,876.3 дня). Однако, изменения во времени захода Солнца и календаря могут вас запутать. 5 очков.</description-loc>
		<type>Mental</type>
		<base_points>2</base_points>
		<modifier version="1" enabled="no">
			<name>Хронолокация (Chronolocation)</name>
			<cost type="points">3</cost>
			<affects>total</affects>
		</modifier>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Acceleration Weakness</name>
		<name-loc>Чувствительность к ускорению</name-loc>
		<description-loc>
Вы восприимчивы к отрицательным последствиям сильного ускорения и получаете -3 к проверкам на HT, чтобы их избежать.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Accessory (@Tool@)</name>
		<name-loc>Аксессуар  (@Встроен@)</name-loc>
		<description-loc>В ваше тело встроено полезное устройство, предоставляющее вам небольшую небоевую выгоду, не включенную в какое-то определенное преимущество. 
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>1</base_points>
		<reference>B100</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Acrophobia (Heights)</name>
	<name-loc>Боязнь высоты (Акрофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы не можете добровольно подняться выше 15 футов над землей, если только не находитесь внутри здания вдали от окон. Если есть возможность упасть, проверка на самоконтроль получает пенальти -5.-10 очков. *


==Фобии ==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Acute Hearing</name>
		<name-loc>Обостренный слух</name-loc>
		<description-loc>Вы получате бонус на проверку Слуха, когда вы должны делать бросок, чтобы узнать, услышали вы что-нибудь, или когда мастер делает проверку вашего IQ, чтобы определить, услышали ли вы какой-нибудь звук.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>hearing</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Acute Sense (@Special Sense@)</name>
		<name-loc>Обостренные чувства  (@Чувство@)</name-loc>
		<description-loc>Одно (или несколько) ваше чувство острее, чем у обычных людей. Каждое чувство – отдельное преимущество, каждый уровень которого дает +1 на бросок проверки этого чувства. Обостренный слух. Вы получате бонус на проверку Слуха, когда вы должны делать бросок, чтобы узнать, услышали вы что-нибудь, или когда мастер делает проверку вашего IQ, чтобы определить, услышали ли вы какой-нибудь звук. 
Обостренный вкус/обоняние:  Вы получате бонус на проверку Вкуса или Обоняния. К примеру, мастер может производить проверку, чтобы определить, почувствовали ли вы запах яда в своем напитке.
Обостренное зрение: Вы получаете бонус на любой бросок Зрения - то есть, когда бросаете проверку, чтобы чего-нибудь разглядеть, или когда мастер проверяет ваш IQ с целью узнать, заметили ли вы чего-нибудь. 
Обостренное осязание. Вы получаете бонус на все проверки узнать что-либо с помощью осязания (например, обнаружить скрытые предметы при обыске).
С позволения Мастера можно «усилить» и другие, нестандартные чувства – вроде Сканирования или Восприятия вибрации. 
Обычно приобретение этого преимущества во время игры невозможно – вместо этого необходимо повышать Восприятие(Per). Однако, если вы теряете одно из чувств, Мастер может позволить вам потратить несколько очков на обострение других чувств в качестве компенсации. Так, если вы теряете зрение, то можете приобрести Обостренный слух.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Acute Taste &amp; Smell</name>
		<name-loc>Обостренный вкус/обоняние</name-loc>
		<description-loc>Вы получате бонус на проверку Вкуса или Обоняния. К примеру, мастер может производить проверку, чтобы определить, почувствовали ли вы запах яда в своем напитке.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>taste smell</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Acute Touch</name>
		<name-loc>Обостренное осязание</name-loc>
		<description-loc>Вы получаете бонус на все проверки узнать что-либо с помощью осязания (например, обнаружить скрытые предметы при обыске).</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>touch</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Acute Vision</name>
		<name-loc>Обостренное зрение</name-loc>
		<description-loc>Вы получаете бонус на любой бросок Зрения - то есть, когда бросаете проверку, чтобы чего-нибудь разглядеть, или когда мастер проверяет ваш IQ с целью узнать, заметили ли вы чего-нибудь.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B35</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>vision</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
	<name>Addiction (@Substance@)</name>
	<name-loc>Пристрастие (@Вещество@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Дешёвый</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Дорогой</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очень дорогой</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Галюцинагенный </name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Выводящий из строя</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Обычное привыкание</name>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Cильное привыкание (-5 при бросоке отказа)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Абсолютное привыкание (-10 при бросоке отказа)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Нелегальный</name>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Легальный</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B122</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type></type>
	<reference>B122</reference>
	<description-loc>Вы пристрастились к наркотику, который необходимо принимать ежедневно, иначе отказ от него повлечет отрицательные эффекты. Цена данного недостатка зависит от цены, эффектов и легальности наркотика:


Цена (дневная доза)
Дешевый (до 0.1% среднего начального богатства): -5 очков.
Дорогой (до 0.5% среднего начального богатства): -10 очков.
Очень дорогой (более 0.5% среднего начального богатства): -20 очков.


Эффекты
Выводящий из строя или галлюциногенный: -10 очков.
Вызывает сильное привыкание (-5 при проверке на отказ): -5 очков.
Вызывает абсолютное привыкание (-10 при проверке на отказ): -10 очков.


Легальность
Нелегальный: +0 очков.
Легальный: +5 очков.


=====Пример: Табак стоит дешево, вызывает сильное привыкание и легален; заядлый курильщик получает Пристрастие на -5 очков. Героин очень дорог, выводит из строя, вызывает полное привыкание и нелегален; героиновый наркоман получает Пристрастие на -40 очков.=====


Нехимические пристрастия: Вы можете иметь Пристрастие к какой-либо деятельности, а не к наркотику - например, к телепатическим контактам или пребыванию в виртуальной реальности. Если это стоит денег, то оцените Пристрастие по ежедневным расходам на него. Если это бесплатно (например, как телепатический контакт), то считайте его "Дешевым", если можете делать это практически везде (телепатический контакт с кем угодно), и "Дорогим", если требуются специальные условия (телепатический контакт с определенным человеком). Подобные Пристрастия почти всегда вызывают психологическую зависимость (см. ниже раздел Отказ).


Эффекты наркотиков
Стимуляторы вызывают прилив сил... пока не проходит их действие. После этого вы становитесь подавленным и раздражительным. Выводящие из строя наркотики лишают вас сознания (или просто вызывают блаженную апатию, лишая способности действовать) примерно на два часа. Галлюциногены делают невозможными работу или участие в бою, хотя вы можете оставаться активным и разговорчивым. Некоторые наркотики (например, табак), не вызывают ни одного из указанных эффектов, а некоторые имеют свои уникальные эффекты. Возможны и побочные эффекты. Детальные правила см. в разделе Наркотики, вызывающие привыкание (B440)


Отказ
Иногда, добровольно или нет, вы вынуждены воздерживаться от своего Пристрастия. Пристрастие к наркотику, который вызывает психологическую зависимость - это ментальный недостаток; отказ от такого наркотика требует серии проверок Воли(Will) и может вызвать ментальные проблемы. Пристрастие к наркотику, который вызывает физиологическую зависимость - это физический недостаток; отказ от наркотика зависит от вашего HT и может причинять физический вред. Подробнее см. раздел Отказ от наркотика (B440). Если вы успешно откажетесь от Пристрастия, то обязаны немедленно выкупить данный недостаток.


Незначительные пристрастия
Если Пристрастие стоит лишь -5 очков, мастер может определить, что стоимость наркотика, негативное отношение окружающих и долгосрочные пагубные эффекты и составляют данный недостаток, и можно не применять обычные правила по отказу от наркотика. Это подходит для таких наркотиков, как табак или кофеин. Если вам приходится обходиться без них, то нужно как обычно делать проверки Воли(Will) или HT, но единственным эффектом при провале будут общее чувство тревоги, раздражительность или беспокойство. Это выражается во временном пенальти -1 к проверкам на DX, IQ, самоконтроль или к проверкам реакции (по выбору мастера) - но не в схождении с ума или физическом ущербе. Последовательные неудачи при проверке продляют данные эффекты; они не увеличивают пенальти. Если вы сумеете выполнить 14 удачных проверок подряд, то обязаны выкупить данное Пристрастие.
Согласно данным правилам, можно создать Пристрастие ценой 0 очков. Подобные Пристрастия - это всегда незначительные Пристрастия, и вы можете взять их в качестве причуд за -1 очко (см. Причуды, B162).</description-loc>
</advantage>
	<advantage version="2">
		<name>Affliction</name>
		<name-loc>Воздействие</name-loc>
		<description-loc>Вы имеете атаку, причиняющую неприятный, но не наносящий прямого вреда эффект (слепота, паралич, слабость и пр.). Природа атаки может быть любой – фантастический лучевой бластер, химическое распыление, сверхъестественная атака взглядом, и т.д. Детали определяются в момент приобретения способности.
По умолчанию атака имеет характеристики 1/2D=10, Max=100, Acc +3, RoF 1, Rcl=1. Однако, вы можете приобретать модификаторы атаки (с. B101-B116), чтобы изменить эти параметры. 
При попадании жертва кидает сопротивление против НТ+1. К этому броску применяется штраф, равный уровню Воздействия (так, Воздействие 1-го уровня вынуждает жертву сделать бросок НТ). Жертва также получает бонус, равный ее DR, если преимущество не модифицировано следующими особенностями: Воздействие через кровь, Воздействие при контакте, Абсолют, Нужен носитель, Проклятие, Воздействие при вдыхании, Воздействие на чувства. Чтобы уменьшить эффект брони, используется модификатор Делитель брони. За пределами 1/2D жертва получает дополнительные +3 на сопротивление. 
При успешном броске сопротивления, ваша атака не сработала, и никакого эффекта жервта не получает. При провале броска сопротивления жертва получает эффект. По умолчанию это физическое оглушение (с. B420) на 1 секунду. Она может кидать НТ+1 каждую секунду для восстановления, но и на этот бросок она получает штраф, равный уровню Воздействия (DR не помогает в данном случае).
Если ваше Воздействие не оказывает вышеуказанного оглушающего эффекта, а несет другой – приобретаются особые расширения (см. ниже). Можно приобретать множество различных эффектов, и они вступают в действие одновременно, если не указано иначе. 
Одинаковые эффекты успешного Воздействия не кумулятивны, используется самый худший. 
Для создания определенного Воздействия используются нижеследующие модификаторы. Также можно использовать большинство из Модификаторов Атаки (c.B102). например, ослепляющая вспышка основана на зрении (Воздействие на чувства, c.B109), большинство ядов и химических веществ будут иметь «Нужен носитель» (c.B105), переноситься через кровь (Воздействие через кровь, c.B102) или при контакте с кожей (Воздействие при контакте, с. B103). сверхъестественные атаки, наподобие «дурного глаза» являются проклятиями (Проклятие, c.B106), а атаки касанием – атаками ближнего боя (Ближний бой, c.B112).
Если Воздействие одновременно налагает 2 и больше эффектов – можно определить, который из них является вторичным (возникает только при провале НТ на 5+, и стоит всего 20% от своей цены). 
Для воздействия, производящего выгодный эффект, бросок делается с премией, равной уровню, и длится (успешность броска) минут. Субъект может вообще отказаться от броска сопротивления в этом случае – тогда длительность воздействия – успешность броска Воли(Will) владельца.

Сущность Воздействия описывается как для Природной атаки.

===Особые улучшения.===

Сердечный приступ (Heart Attack): жертва получает серьезное повреждение сердца, и умрет через несколько минут, если ей не окажут помощь (см. Смертельные состояния, с. B429). +300%

Кома (Coma) (+250%): жертва падает без сознания, и погибнет через несколько дней без оказания помощи (см. Смертельные состояния, с. B429). +250%

Кумулятивность (Cumulative): повторные атаки, даже одного и того же типа, кумулятивны! Приобертается в сочетании с Преимуществом, Недостатком, Штрафом к атрибуту или Аннулированием преимущества (если указанные модификаторы влияют на поуровневую способность). +400%

Недееспособность (Incapacitation): Жертва выходит из строя на количество минут, равное провалу броска, а затем становится оглушенной (см. Состояния недееспособности, с. B428). Если этот модификатор приобретается одновременно с другими эффектами, то они наступают после того, как состояние недееспособности пройдет; они заменяют вышеуказанное Оглушение, и длятся столько же времени, сколько продлилось состояние недееспособности. Агония (agony), +50%; Галлюцинация (Hallucinating), +50%; Ошеломление (Daze), +50%; Паралич (Paralysis), +150%; Рвота (retching), +50%; Судороги (Seizure), +100%; Удушение (Choking), +100%; Экстаз (Extasy), +100%;  Сон (Sleep), +150%; Потеря сознания (Unconsciouness), +200%.

Недостаток (Disadvantage): жертва временно получает один физический или ментальный недостаток (но не из добровольных!). Это стоит +1% за каждое очко цены недостатка; так, Паранойя -10 будет стоить +10%. Если недостаток должен приобретаться по уровням, он указывается при создании Воздействия. Эффект длится по одной минуте за каждое очко, на которое жертва провалила бросок сопротивления.

Раздражение (Irritant): Жертва испытывает вредный эффект, но не становится оглушенной. Эффект длится столько минут, на сколько был провален бросок сопротивления. (см. Отвлекающие состояния, с. B428). Возможные эффекты – Зуд (Itching), +10%; Кашель (Coughing), +20%; Опьянение (Tipsy/Drunk), +10%/20%; Тошнота (Nauseated), +30%; Серьезная боль (Severe Pain) (+40%), Сильная боль (Terrible Pain) (+60%), Средняя боль (Moderate Pain), +20%; Эйфория (Euphoria), +30%.

Преимущество (Advantage): жертва немедленно испытывает эффект определенного физического или ментального преимущества. Преимущества с мгновенным эффектом воздействуют на цель одномоментно, немедленно при провале броска НТ на сопротивление; так, Телепортация немедленно отправит субъекта в другое место. Для преимуществ, эффект которых может быть включен и выключен (например, Нематериальность), эффект длится по минуте за каждое очко, на которое был провален бросок сопротивления. Если преимущество идет по уровням, уровень определяется в момент приобретения Воздействия. Стоимость: +10% за очко цены преимущества.

Штраф к атрибутам (Attribute Penalty): Жертва теряет несколько уровней определенного атрибута. +5% за -1 к НТ или ST, и +10% за штраф -1 к DX, IQ; так, атака, снижающая DX на 3 очка, и IQ на 2 – будет стоить +50%. Все основанные на пониженных атрибутах характеристики (Воля(Will), Восприятие(Per), Грузоподъемность(BL), повреждения) и навыки также уменьшаются, кроме Скорости, FP и НР. Штраф длится по минуте за каждое очко провала броска сопротивления.

Аннулирование преимущества (Negate Advantage): Жертва теряет одно указанное преимущество на одну минуту за каждое очко провала броска сопротивления. Если у жертвы нет этого преимущества, атака не подействовала. +10% за очко цены преимущества. Если преимущество выражается в уровнях, вы должны указать этот уровень.
Оглушение (Stun): кроме прочих эффектов, жертва оглушена (действие идентично немодифицированному Воздействию). Сочетается только с Преимуществом, Недостатком, Аннулированием Преимущества или Штрафом к атрибутам. +10%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<reference>B35</reference>
		<ranged_weapon><damage>spec. HT+1-level+DR</damage><range>10/100</range><accuracy>3</accuracy><rate_of_fire>1</rate_of_fire><recoil>1</recoil></ranged_weapon>
		<modifier version="1" enabled="no">
			<name>Физическое оглушение</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B35</reference>
			
		</modifier>			
		<modifier version="1" enabled="no">
			<name>Сердечный приступ (Heart Attack)</name>
			<cost type="percentage">300</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>умрет через несколько минут, если ей не окажут помощь B429</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Кома (Coma)</name>
			<cost type="percentage">250</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>погибнет через несколько дней без оказания помощи B429</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Кумулятивность (Cumulative)</name>
			<cost type="percentage">400</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>повторные атаки, суммируются</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Агония (agony)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Галлюцинация (Hallucinating)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ошеломление (Daze)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Паралич (Paralysis)</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Рвота (retching)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Судороги (Seizure)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Удушение (Choking)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Экстаз (Extasy)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Сон (Sleep)</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Потеря сознания (Unconsciouness)</name>
			<cost type="percentage">200</cost>
			<affects>total</affects>
			<reference>B35</reference>
			<notes>Жертва недеспособна на количество минут, равное провалу броска, после оглушена</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>@Эффект@</name>
			<cost type="percentage">@Цена@</cost>
			<affects>total</affects>
			<reference>B35</reference>
		</modifier>			
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Agoraphobia (Open Spaces)</name>
	<name-loc>Боязнь открытых пространств (Агорафобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы плохо себя чувствуете на открытом пространстве и по-настоящему пугаетесь, если в пределах 50 футов от вас нет стен.-10 очков *


==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Aichmophobia/TL5- (Sharp Things)</name>
	<name-loc>Боязнь острых предметов (Айхмофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь всего острого - мечей, копий, ножей и даже шприцов. При попытке использовать острое оружие, или при угрозе им требуется проверка на самоконтроль с -2. -15 очков при TL5 или ниже, -10 при TL6 или выше. *


==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Aichmophobia/TL6+ (Sharp Things)</name>
	<name-loc>Боязнь острых предметов (Айхмофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь всего острого - мечей, копий, ножей и даже шприцов. При попытке использовать острое оружие, или при угрозе им требуется проверка на самоконтроль с -2. -15 очков при TL5 или ниже, -10 при TL6 или выше. *


==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Ailurophobia (Cats)</name>
	<name-loc>Боязнь кошек (Айлурофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>-5 очков.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Alcohol Intolerance</name>
		<name-loc>Непереносимость алкоголя</name-loc>
		<description-loc>
Спиртное бьет вам прямо в голову. Вы пьянеете гораздо быстрее обычного человека. Вы получаете -2 к любым проверкам HT, связанным с выпивкой.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Alcohol Tolerance</name>
		<name-loc>Устойчивость к алкоголю</name-loc>
		<description-loc>Ваше тело быстрее перерабатывает алкоголь. Вы получаете +2 на броски НТ, связанные с выпивкой. Вы можете пить намного дольше, чем другие, не испытывая особых неудобств.
</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B100</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Alcoholism</name>
		<name-loc>Алкоголизм
</name-loc>
		<description-loc>Вы испытываете пристрастие к алкоголю. Алкоголизм использует правила по Пристрастиям (см. выше). Алкоголь дешев, выводит из строя и обычно легален, так что в нормальных условиях это было бы Пристрастием за -10 очков. Но алкоголь еще и очень коварен; таким образом, он стоит -15 очков - или -20, если он нелегален.
Большую часть времени вы можете пить исключительно вечерами, и (с игровой точки зрения) действовать нормально. Однако каждый раз, когда вы находитесь в присутствии алкоголя, требуется проверка Воли(Will), чтобы не выпить. Проваленная проверка означает, что вы уходите в "запой" продолжительностью 2d часов, вызывающий похмелье; см. Алкогольные напитки и опьянение (B439). Алкоголикам в ходе запоя свойственна резкая смена настроения - от абсолютного дружелюбия до крайней враждебности - и они могут нападать на друзей, слишком вольно разговаривать и совершать другие ошибки.
К другим неприятным свойствам Алкоголизма относится то, что от него трудно избавиться. Если вам удалось победить пристрастие к алкоголю, то вы можете больше не пить ежедневно... но все равно необходимо делать проверку Воли(Will)+4, если вы оказались рядом с алкоголем. Проваленная проверка не восстанавливает зависимости, но вызывает запой. (Три запоя в неделю возвращают зависимость.) Таким образом, не существует обычного способа "выкупить" этот недостаток.
Продолжительный Алкоголизм будет снижать ваши способности. Ежегодно необходимо совершать проверку против HT+2, если вы не избавились от зависимости. Провал означает, что вы теряете один уровень в каком-либо из четырех базовых атрибутов - в каком именно, определяется случайным бросоком.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<modifier version="1" enabled="no">
			<name>Нелегальный</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B122</reference>
		</modifier>
		<reference>B122</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Ally (@Who@)</name>
	<name-loc>Союзники  (@Кто@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очки</name>
		<notes>25% ваших стартовых</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очки</name>
		<notes>50% ваших стартовых</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очки</name>
		<notes>75% ваших стартовых</notes>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очки</name>
		<notes>100% ваших стартовых</notes>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очки</name>
		<notes>150% ваших стартовых</notes>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется постоянно</name>
		<notes>Бросок не требуется</notes>
		<cost type="multiplier">4</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется почти всегда</name>
		<notes>15-</notes>
		<cost type="multiplier">3</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется часто</name>
		<notes>12-</notes>
		<cost type="multiplier">2</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется периодически</name>
		<notes>9-</notes>
		<cost type="multiplier">1</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется редко</name>
		<notes>6-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 6-10</name>
		<cost type="multiplier">6</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 11-20</name>
		<cost type="multiplier">8</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 21-50</name>
		<cost type="multiplier">10</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 51-100</name>
		<cost type="multiplier">12</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 101-1000</name>
		<cost type="multiplier">18</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 1001-10000</name>
		<cost type="multiplier">24</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 10001-100000</name>
		<cost type="multiplier">30</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа размером 100001-1000000</name>
		<cost type="multiplier">36</cost>
		<reference>B37</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Слуга (Minion)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Слуга (Minion)</name>
		<notes>IQ 0 или рабский менталитет</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Спец. способности</name>
		<notes>@Способности@</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Призываемый (Summonable)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Симпатическая связь (Sympathy)</name>
		<notes>Смерть одного из вас уменьшает HP второго до 0</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Симпатическая связь (Sympathy)</name>
		<notes>Смерть одного из вас уменьшает HP второго до 0 и раны действют на союзинка но не на вас</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Симпатическая связь (Sympathy)</name>
		<notes>Смерть одного из вас убивает второго</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Симпатическая связь (Sympathy)</name>
		<notes>Смерть одного из вас убивает второго до 0 и раны действют на союзинка но не на вас</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невольный (Unwilling)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B38</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Одноразовая услуга - Благосклонность (Favor)</name>
		<cost type="multiplier">0.2</cost>
		<reference>B55</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B36</reference>
	<description-loc>У многих вымышленных героев есть партнеры - соратники, коллеги или верные друзья - сопровождающие их в путешествиях. Эти партнеры - Союзники. 
С одной стороны, другие путешествующие с вами герои, управляемые игроками - тоже союзники. Но на них зачастую нельзя положиться. Иногда они - случайные знакомые, впервые встреченные в придорожном трактире пару часов назад. У них могут быть свои скрытые цели, своя этика и мотивы, которые могут и не совпадать с вашими.
Неигровой союзник, наоборот, полностью надежен. Возможно, вы долго дрались с ним бок обок, вместе учились или выросли в одной деревне. Вы безоговорочно доверяете друг другу. Вы вместе путешествуете, сражаетесь спина к спине, делитесь пайками и подменяете друг друга на ночном дежурстве.
Союзник - неигровой персонаж, и его нужно отыгрывать соответственно. Хотя обычно они соглашаются с мнением игрока, они не марионетки. Время от времени они будут расходится во мнении со своими друзьями. Союзник может попытаться отговорить своего друга от задуманного им, может отказаться помогать. Союзник даже может принести герою проблемы, завязав драку, попав в тюрьму, оскорбив вельможу... Конечно, Союзник может также попытаться вытащить своего друга, совершившего те же ошибки.
Герой не получает очков персонажа за любую игру, в которой он предал, атаковал или без надобности навлек опасность на Союзника. Если предательство особо очевидное, затянувшееся или серьезное, доверие между героем и Союзником будет разорвано; Союзник будет потерян, также как и потраченные на него очки персонажей. Подвергание союзника опасности – не наказуемо, пока вы сами тоже сражаетесь с нею, и достаточно убедительны.
Стоимость союзника определяется его ценностью в очках персонажа и частотой появления. Цена преимущества оплачивается тольк PC, и только за союзников-NPC. Два PC могут быть союзниками, не оплачивая друг друга; Союзники-NPC не оплачивают союзников-PC. Союзник – это умелый NPC, дружественный одному PC.
Группа союзников.
Сила Союзника
По таблице определите, сколько очков вы потратите на союзника. Столбик «Цена союзника» - количество очков персонажа, потраченное на создание NPC, относительно стартовой цены PC. «Цена в очках» - базовая стоимость этого союзника. Если стоимость попадает между двумя значениями – используется высшее из них. 
!Цена союзника	|Цена в очках
|25% |1
|50% |2
|75% |3
|100% |5
|150% |10
	Более сильные союзники (150% и больше) считаются за покровителей (с. B72), и не могут быть Союзниками. Исключение: вышеуказанная прогрессия не ограничена для NPC с IQ 0, каждое увеличение силы союзника на +50% от стартовой стоимости персонажа, увеличивает базовую цену на +5 очков.
Союзники, созданные не более, чем на 100% от стартовой цены персонажа, могут быть одновременно и Иждивенцами (с. B131). Суммы очков за эти две черты складываются, и объединяются в одну черту, которая в зависимости от знака очковой стоимости считается преимуществом или недостатком.
Группа союзников.
Вы можете купить столько союзников, сколько сможете оплатить. Обычно каждый союзник – отдельное преимущество, но группу сходных союзников вы можете считать одним – для экономии места на листе персонажа. 
Группа уникальных персонажей-союзников, обладающих каждый своими способностями, могут быть записаны одной строкой, но их сумма складывается, и вы не получаете никакого уменьшения цены.
Несколько (6+) почти идентичных и взаимозаменяемых союзников (группа непрофессиональных бандитов или рой роботов-дронов) считаются Группой союзников – и могут покупаться дешевле.
!Размер группы |Множитель стоимости
|6-10 |х6
|11-20 |х8
|21-50 |х10
|51-100 |х12
	Каждое дальнейшее увеличение количества в 10 раз добавляет х6 к модификатору (так, 100,000 союзников обойдутся вам в х30).  Мастер может потребовать от вас Необычного Происхождения, если вы хотите иметь орды союзников, или запретить приобретать группу свыше определенного размера – хотя вы можете купить армию или другую серьезную группу в качестве покровителя.
Множитель частоты появления (с. B36) применяется к финальной стоимости Группы союзников, но до применения особых модификаторов.
Частота Появления
Модифицирует результат соответственно таблице на с. B36. 
Если выброшенный результат определяет появление Союзника, то союзник на протяжении этого приключения будет с вами.
Создание Союзника
Выбирая умения, преимущества и недостатки для Союзника, помните, что у большинства их было то же прошлое, что и у героев. У солдат наиболее распространенными союзниками будут солдаты, у воров - всякие подозрительные личности, у священников - другие жрецы или святые рыцари и т.д. У игрока должно быть очень веское обоснование, если он хочет, чтобы прошлое его союзника сильно отличалось от прошлого его персонажа.
Ни союзник NPC, ни персонаж игрока не получают очки, выбрав Чувство Ответственности (Sense of Duty) или Клятва (Oath) в отношении своего соратника. Стоимость Союзника уже учитывает эти недостатки.
Отыгрывание союзника
Как и в случае с Иждивенцами (с. B131), Мастер увеличивает силу союзника соответственно росту персонажа, что сохраняет очковую стоимость союзника на постоянном уровне. Мастер, а не игрок решает, куда пойдут эти очки (хотя вы можете просить о каком-то развитии, желаемом для вас). 
Если Союзник погибает без помощи со стороны героя, тот не будет наказан. Позвольте герою приобрести себе другого союзника. Эти отношения должны развиваться постепенно - никто не может приобрести себе Союзника за ночь – хотя все зависит от обстоятельств: вы можете приобрести надежного друга, спасши ему жизнь. Такой вариант особенно распространен в культурах, где честь и долг имеют важное значение.
Вы не получаете штрафов за добровольное, дружелюбное расставание с Союзником. Вы можете потратить очки, высвободившиеся при его потере, на другого союзника. На усмотрение Мастера, вы можете также приобрести на них снаряжение или взять их в виде денег (обмен очков на деньги, с. B26). что отражает прощальный подарок.
Фамилиары.
Маги, телепаты и другие подобные люди часто имеют сверхъестественную связь с особым родом Союзника, известном как Фамилиар. Обычно это животные или духи.
Обсудите способности фамилиара с Мастером, начиная с базового шаблона нужного создания. Если его шаблонный IQ 5 или меньше, поднимите его до 6 как минимум. Возможно выкупить Немоту, если разрешит Мастер. Многие фамилиары имеют сверхъестественные способности – Дополнительные Жизни у кошек, Ментальная связь и Отправка мыслей для фамилиаров, способных передавать свои мысли, и т.д. После определения способностей, вычислите его очковую стоимость, и определите его базовую цену для вас. Затем, как обычно, укажите частоту появления. Она может отражать частоту появления (при провале фамилиар спит, отчитывается перед повелителем и т.д.), либо частоту срабатывания его сил (при провале он является ничем больше, кроме как обычным представителем своего вида) – на ваш выбор.
Этот тип союзников часто имеет одно или больше особых модификаторов. Слуга, Призываемый и Симпатия – наиболее частые из них. Недобровольным обычно бывает демонический слуга или другое злое существо. Особые способности приобретаются в данном случае только если фамилиар предоставляет вам особые способности (такие, как Полет, в случае с птицами). Вы не получаете доступа к этим способностям, если бросок на появление фамилиара провален, или он без сознания, мертв или оглушен, а также если он или вы находитесь в области, где ваша духовная связь не работает. Эти способности приобретаются с особым ограничением: «Даровано фамилиаром» (Granted by Familiar) (-40%):

===Особые улучшения.===

Эти модификаторы применяются после вычисления цены группы и модификации за частоту появления.

Слуга (minion): ваш Союзник служит вам независимо от угрозы и вашего с ним обращения. Это может быть из-за программы, страха или недостатка самооценки. Примеры включают роботов, зомби и магических слуг. Вы можете обращаться с ним как угодно без штрафа со стороны мастера, это может привести к неудобствам (ментальным или физическим повреждениям), но союзник никогда не покинет вас. Дополнительные опции можно найти в преимуществе Кукла (с.78). +0%, если Слуга имеет IQ 0 или Рабский менталитет (с.154), иначе - +50%.

Особые способности (Special Abilities): ваш союзник имеет силы, выходящие за рамки его ценности. Возможно, он имеет особый политический вес или доступ к более развитому снаряжению. Эти способности не оплачиваются отдельно, поскольку они повышают стоимость союзника. Этот модификатор не должен покупаться просто потому, что ваш союзники имеет необычные силы. Если они уж совсем необычны, то такой союзник будет требовать Необычного происхождения. +50%.

Призываемый (Summonable): Вместо броска на встречу союзника вы можете призвать его. Для этого вы выполняете маневр Концентрация, и бросаете бросок против частоты появления. При успешном броске ваш союзник появляется поблизости, при провале – вы не сможете призывать его снова целые сутки. Отпускание союзника – свободное действие, но вы можете отпустить его, только если он физически присутствует рядом. +100%.
===Особые ограничения.===

Симпатия (Simpathy): если вы получаете рану, оглушение, теряете сознание или попадаете под контроль, ваш союзник получает подобный эффект. Обратное – также верно, так что присматривайте за своим союзником. -25%, если смерть одного из союзников уменьшает здоровье другого до 0. -50%, если смерть одного автоматически убивает другого. Если ваши раны влияют на вашего союзника, но раны вашего союзника не влияют на вас, уменьшите эти штрафы до -5% и -10% соответственно.
Нежелающий (Unwilling): Вы приобрели своего союзника насильно (шантажом или магическим воздействем). Вы можете не обращаться с ним так же хорошо, как с обычным союзником, однако, он вас ненавидит, и способен соответственно действовать. Если вы ставите его под угрозу или приказываете сделать что-то, что он не желает делать, он может предать или сделать что-то, что уменьшит полезность его действий. Предавший союзник уходит, и вы теряете все очки, потраченные на него. -50%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Altered Time Rate</name>
		<name-loc>Ускоренное течение времени</name-loc>
		<description-loc>Ваше восприятие времени быстрее, чем у нормальных людей. При наличии первого уровня этого преимущества, за то время, как в реальности проходит только одна секунда, вы проживаете две! Каждый последующий уровень увеличивает это значение еще на один – так, вы действуете в три раза быстрее на уровне 2, в четыре – на уровне 3, и так далее.
Каждый уровень позволит вам дополнительный любой боевой маневр в ваш ход, не требующий реакции окружающих – включая более быстрое колдовство, бег и лишние атаки. Тем не менее, ваш ход не наступает быстрее – преимущество не увеличивает вашу реакцию.
Вне боя, это преимущество позволит вам роскошь планирования, даже в критической ситуации, поскольку все вокруг движется медленнее. Вы всегда можете бросить восприятие, или ментальный навык, чтобы составить план или вспомнить что-то, без штрафов за дополнительное действие.
Чтобы сделать что-то, что зависит от реакции других, вам придется замедлится до их скорости. Это равно верно и для Финтов и бросков влияния. Например, если вы пытаетесь провести финт, вы больше ничего не сможете сделать в этот ход – вы не получаете дополнительных действий за скорость движений. С другой стороны, вы можете просто провести маневр Атаки, а затем, когда противник потратит на него свою защиту – Тотальную атаку (all-out attack)!

===Новые особые улучшения (P42)===
Супер-скорость (Super-Speed): Вне боя вы еще быстрее! Когда вы выполняете обычную, не боевую, монотонную задачу – создание объектов (включая разработку новых), чтение, ремонт и т.д. – разделите требуемое время на значение, находящееся в таблице Скоростей и Расстояний (с.В550) в графе Линейные размеры, на строчке, определяющей ваш уровень преимущества. Например, УХВ 6 даст делитель времени 20 – это значит, что задача, обычно занявшая бы целый час, у вас отнимет лишь три минуты. Вы можете уменьшить время еще больше, получив штраф к умению (с. В346). Невозможно ускорить обучение, применение спецспособностей (создание волшебных предметов, концентрация на Контроле разума и т.д.). Броски новых концепций при изобретении, общение с другими людьми также не подвержено влиянию этого модификатора. Мастер может ограничить доступность этого улучшения – только для супер-героев. +20%

===Новые особые ограничения (P42)===
Небоевая скорость (Non-combat Speed): Ваша супер-скорость действует только в обычной жизни. Вы не получаете дополнительных маневров во время боя. Вы можете приобрести несколько уровней УХВ с 1 этим ограничением, и несколько – с улучшением Супер-скорость. -60%.
<br></description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>100</points_per_level>
		<modifier version="1" enabled="no">
			<name>Super-Speed</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P42</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Non-Combat Speed</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P42</reference>
		</modifier>
		<reference>B38</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Alternate Identity</name>
		<name-loc>Альтернативное имя</name-loc>
		<description-loc>Вы обладаете дополнительным именем, которое полностью заверено документами. Ваши отпечатки пальцев (или другой распространенный метод идентификации) зарегистрированы под двумя различными именами, у вас есть по двое удостоверений, паспортов, свидетельств о рождении и т.д. Это может быть чрезвычайно полезно для любого, кто вовлечен в незаконную деятельность, или для того, кто пытается скрыть свою супер-личность. Это преимущество можно приобрести сколько угодно раз, и каждый раз оно будет давать новый набор документов.
Вы можете даже обладать банковскими счетами и кредитными картами, записанными на другое имя, но деньги на них должны собирать вы сами – дополнительные средства не включены в преимущество!
Если органы правопорядка попытаются идентифицировать ваши отпечатки, не имея данных о вашем имени, то у них равные шансы найти каждое из ваших имен. Тогда поиски прекратятся... если только у них нет причин подозревать, что это фальшивые документы. Если поиски продолжаются, то, конечно же, всплывет второе имя, и вы будете раскрыты. Как только определят, кто вы на самом деле, альтернативное имя (или имена) будет потеряно.
Альтернативные имена запрещены обычным людям. Если вас поймают, то могут подвергнуть серьезному штрафу или посадить в тюрьму. Альтернативное имя также может быть «секретным», но не обязательно!

Существует два вида Альтернативного имени:

Легальное (Legal): Некоторые игровые персонажи могут получить Альтернативное имя по закону. Работающий под прикрытием агент ФБР, например, может обладать полным набором бумаг, легендой и т.д. на чужое имя. Или правительство может обеспечить супергерою секретность! Персонаж должен иметь как минимум 10 очков в  преимуществах Представитель силовых структур, Секретный доступ, Полицейское звание, Юридическая неприкосновенность или им подобных, чтобы легально получить подобное альтернативное имя. Если супергерою разрешено правительством скрывать свое настоящее имя (чтобы не подвергать опасности семью и т.д.), и иметь записанную на свое «супер» имя собственность и т.д., то это сочетание Легального альтернативного имени с Секретным именем – см. с.153 (настоящее имя держится в секрете). 5 очков.
Нелегальное (Illegal). Преступники или иностранные агенты могут иметь нелегальное Альтернативное имя. Его преимущество в том, что вы будете полностью неизвестны при первом появлении, и правительство не сможет его у вас отобрать. С другой стороны, если оно будет раскрыто, вы получите неприятности с законом: это может быть крупный штраф, тюремное заключение или даже казнь (наказание зависит от времени и мира). 15 очков.</description-loc>
		<type>Social</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Нелегальное</name>
			<cost type="points">10</cost>
			<affects>total</affects>
		</modifier>
		<reference>B39</reference>
		<notes>@Имя@</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Ambidexterity</name>
		<name-loc>Обоюдорукость</name-loc>
		<description-loc>Вы можете пользоваться обеими руками одинаково умело. Вы не получаете -4 DX пенальти за использование "не той" руки (см. Выбор Руки, B14), и можете драться (или действовать) любой рукой, или (в случае маневра Тотальной атаки (All-Out Attack) - обоими руками сразу. Если в результате какого-то происшествия вы лишаетесь или повреждаете одну из рук, считайте, что это была левая. Обратите внимание, что это не дает вам дополнительного действия в бою – приобретайте Дополнительные атаки (с.53).</description-loc>
		<type>Physical</type>
		<base_points>5</base_points>
		<reference>B39</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Amnesia (Partial)</name>
	<name-loc>Амнезия (Частичная)</name-loc>
	<base_points>-10</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B123</reference>
	<description-loc>
		Вы потеряли память. Вы не можете вспомнить ничего о своей прошлой жизни, включая собственное имя. Этот недостаток бывает двух уровней:


Частичная амнезия: Вы, игрок, можете видеть лист персонажа, но мастер имеет право зарезервировать до -30 очков ваших недостатков в качестве "секретных" недостатков, которые выберет, но вы не будете знать, где всему этому научились. Вероятно, у вас будут враги - а может и друзья - о которых вы не помните. Если вы обратитесь в полицию, то там смогут выполнить стандартную процедуру установления личности... но вы можете оказаться разыскиваемым преступником. Даже если это и не так, то, узнав собственное имя, вы не восстановите память! -10 очков.
Полная амнезия: Единственные особенности, которые вы можете определить при создании персонажа - это те, которые можно рассмотреть в зеркале. Мастер определяет все остальное - и держит весь ваш лист персонажа у себя, пока к вам не вернется память! Вы даже не подозреваете о своих способностях. Поскольку мастер знает о ваших причудах и ментальных особенностях, а вы не знаете, иногда он будет изменять ваши решения о том, что вы делаете. Кроме того, он будет делать за вас все проверки умений, поскольку вы не догадываетесь что умеете, пока не попробуете! Проверки на умения, зависящие от IQ, выполняются с -2, если только мастер не считает, что память не повлияет на исполнение определенного задания. -25 очков.


Вы можете выкупить Амнезию, только если по некой причине могли восстановить воспоминания; например, встретили старого друга, вновь пережили некое значимое событие или вас, как часто водится, ударили по голове. В большинстве случаев, восстановление памяти будет связано с причиной, вызвавшей ее потерю. Особенно гадкие мастера могут связать потерю памяти с неким промыванием мозгов. В данном случае, одним из тайных недостатков вероятно окажется Враг, обладающий достаточными ресурсами, чтобы использовать именно промывание мозгов.
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Amnesia (Total)</name>
	<name-loc>Амнезия (Полная)</name-loc>
	<base_points>-25</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B123</reference>
	<description-loc>
		Вы потеряли память. Вы не можете вспомнить ничего о своей прошлой жизни, включая собственное имя. Этот недостаток бывает двух уровней:


Частичная амнезия: Вы, игрок, можете видеть лист персонажа, но мастер имеет право зарезервировать до -30 очков ваших недостатков в качестве "секретных" недостатков, которые выберет, но вы не будете знать, где всему этому научились. Вероятно, у вас будут враги - а может и друзья - о которых вы не помните. Если вы обратитесь в полицию, то там смогут выполнить стандартную процедуру установления личности... но вы можете оказаться разыскиваемым преступником. Даже если это и не так, то, узнав собственное имя, вы не восстановите память! -10 очков.
Полная амнезия: Единственные особенности, которые вы можете определить при создании персонажа - это те, которые можно рассмотреть в зеркале. Мастер определяет все остальное - и держит весь ваш лист персонажа у себя, пока к вам не вернется память! Вы даже не подозреваете о своих способностях. Поскольку мастер знает о ваших причудах и ментальных особенностях, а вы не знаете, иногда он будет изменять ваши решения о том, что вы делаете. Кроме того, он будет делать за вас все проверки умений, поскольку вы не догадываетесь что умеете, пока не попробуете! Проверки на умения, зависящие от IQ, выполняются с -2, если только мастер не считает, что память не повлияет на исполнение определенного задания. -25 очков.


Вы можете выкупить Амнезию, только если по некой причине могли восстановить воспоминания; например, встретили старого друга, вновь пережили некое значимое событие или вас, как часто водится, ударили по голове. В большинстве случаев, восстановление памяти будет связано с причиной, вызвавшей ее потерю. Особенно гадкие мастера могут связать потерю памяти с неким промыванием мозгов. В данном случае, одним из тайных недостатков вероятно окажется Враг, обладающий достаточными ресурсами, чтобы использовать именно промывание мозгов.
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Amphibious</name>
		<name-loc>Амфибия</name-loc>
		<description-loc>Вы чувствуете себя как дома и на земле и на воде. Амфибии не нуждаются в умении «плавание» – они автоматически плывут со своей нормальной скоростью передвижения; вы также не получаете штрафа к навыкам за работу под водой. Не дает вам способности дышать под водой (см. Не нуждается в дыхании (c.B45). 
Если вы можете передвигаться только под водой, приобретайте недостаток Водный (c.B145).</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<reference>B40</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Animal Empathy</name>
	<name-loc>Понимание животных</name-loc>
	<base_points>5</base_points>
	<modifier version="1" enabled="no">
		<name>На расстоянии (Remote)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P48</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация</name>
		<notes>Все водные</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация</name>
		<notes>Все наземние</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация</name>
		<notes>@Класс: млекопитающие, птицы, итп@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация</name>
		<notes>@Семейство: кошачьи, попугаи, итп@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация</name>
		<notes>@Вид: домашние кошки, попугаи ара, итп@</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B40</reference>
	<description-loc>Вы понимаете животных и любите их, а они любят вас. При встрече с животным мастер может бросить ваш IQ, чтобы вы поняли эмоции животного (дружелюбно, напугано, враждебно, голодно и т.д.), и находится ли под сверхъестественным контролем. Также вы можете использовать навыки влияния, как если бы животное было разумным собеседником. 
Способность часто идет в комплекте с талантом Друг животных (с. B89), и – часто – Чувство долга (животные) или Клятва (вегетарианец).</description-loc>
</advantage>
	<advantage version="2">
	<name>Appearance</name>
	<name-loc>Внешность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ужасающая (Horrific)</name>
		<cost type="points">-24</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-6</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Чудовищная (Monstrous)</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-5</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Отвратительная (Hideous)</name>
		<cost type="points">-16</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-4</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уродливая (Ugly)</name>
		<cost type="points">-8</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-2</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Непривлекательная (Unattractive)</name>
		<cost type="points">-4</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Средняя (Average)</name>
		<cost type="points">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Привлекательная (Attractive)</name>
		<cost type="points">4</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Красивая (Handsome)</name>
		<cost type="points">12</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Прекрасная (Beautiful)</name>
		<cost type="points">12</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>2</amount>
			<limitation>Другой пол</limitation>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очень красивая (Very Handsome)</name>
		<cost type="points">16</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>4</amount>
			<limitation>Другой пол</limitation>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Сверх прекрасная (Very Beautiful)</name>
		<cost type="points">16</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>4</amount>
			<limitation>Другой пол</limitation>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Исключительная (Transcendent)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>6</amount>
			<limitation>Другой пол</limitation>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>универсальная (не зависима от расы)</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Типовой шаблон (Off-the-Shelf Looks)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Бесполая красота (Androgynous)</name>
		<cost type="points">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Впечатляющая / Брутальная (Impressive)</name>
		<cost type="points">0</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B21</reference>
	<description-loc>Чаще всего внешность - это просто "особый эффект", так что вы можете выбрать любую внешность, какую хотите. Как минимум укажите цвет кожи, волос и глаз (или иных важных для вашей расы деталей: чешуи, перьев, шерсти и т.д.) Однако некоторые особенности считаются преимуществами или недостатками.

==Уровни внешности==
Внешность измеряется по уровням. У большинства людей "Средняя" внешность, стоящая 0 очков. Приятная наружность дает бонус к реакции; это преимущество за определенное количество очков. Подобные модификаторы к реакции вы получаете только от тех, кто вас видит! От того, кто вас не видел, может потребоваться новая проверка реакции при первой личной встрече (на усмотрение мастера).
Модификаторы к реакции за внешность влияют только на представителей вашей собственной или близкой расы, либо непохожей расы, находящей ваш народ привлекательным (по каким угодно причинам). В любом случае, последнее слово за мастером; люди "очень близки" к эльфам, но маленьких зеленых человечков вряд ли будет беспокоить ваша внешность, разве что только в юмористических кампаниях.

Ужасная [Horrific]: Вы неописуемо ужасны или жутко омерзительны, и не можете взаимодействовать с простыми смертными. Этот уровень дает вам -6 к проверкам реакции. Мастер может сказать, что это является сверхъестественной особенностью, а потому недоступно для обычных персонажей. -24 очка.
Чудовищная [Monstrous]: Вы отвратительны и явно ненормальны. Большинство людей реагирует на вас как на чудовище, а не как на разумное существо. Этот уровень дает -5 к проверкам реакции. Опять же, эта особенность может быть недоступна обычным персонажам. -20 очков.
Отвратительная [Hideous]: В вашей наружности присутствует нечто настолько отвратительное, насколько вы можете вообразить... серьезное кожное заболевание, бельмо на глазу... а вероятнее сразу несколько подобных черт. Этот уровень дает -4 к проверкам реакции. -16 очков.
Уродливая [Ugly]: То же что и выше, но не столь серьезное - это могут быть просто некрасивые космы волос и кривые зубы. Это дает -2 к проверкам реакции. -8 очков.
Непривлекательная [Unattractive]: Вы выглядите несколько неприятно, но у вас нет ничего такого, на что стали бы показывать пальцем. Этот уровень дает -1 к проверкам реакции. -4 очка.
Средняя [Average]: Ваша внешность не дает вам модификаторов к проверкам реакции ни в одну сторону; вы легко можете смешаться с толпой. Впечатление видящего вас человека зависит от вашего поведения. Если вы улыбаетесь и действуете дружелюбно, то он запомнит вас как симпатичного человека; если вы хмуритесь и что-то бубните, то вас запомнят как непривлекательного. 0 очков.
Привлекательная [Attractive]: Вы не участвуете в конкурсах красоты, но определенно неплохо выглядите. Этот уровень дает +1 к проверкам реакции. 4 очка.
Красивая (или Прекрасная) [Handsome (or Beautiful)]: Вы могли бы принимать участие в конкурсах красоты. Этот уровень дает вам +4 к проверкам реакции от тех, кого привлекают представители вашего пола, +2 от всех остальных. 12 очков.
Очень красивая (или Очень прекрасная) [Very Handsome (or Very Beautiful)]: Вы могли бы побеждать в конкурсах красоты - причем постоянно. Этот уровень дает +6 к проверкам реакции от тех, кого привлекают представители вашего пола, и +2 от прочих. Представителей вашего пола, у которых есть повод не любить вас (более -4 к реакции, без учета бонусов), злит ваша красота, и вместо этого они реагируют на вас с -2. Кроме того, очень вероятно, что проблемы для вас будут представлять те, продюсеры, пьяные, работорговцы и прочие надоедливые люди. 16 очков.
Исключительная [Transcendent]: Вы "идеальный представитель расы". Это дает вам +8 (!) к проверкам реакции от тех, кого привлекают представители вашего пола, +2 от остальных, а также все те проблемы, что описаны в пункте об Очень красивой внешности. Мастер может оставить эту черту доступно лишь ангелам, божествам и им подобным созданиям. Подобные сущности часто наделены Харизмой (B41) или Ужасом (B93). 20 очков.

===Особые условия===
Бесполая красота [Androgynous]: Если уровень вашей внешности не ниже Красивой (Прекрасной), то вы можете определить, что выглядите одинаково для представителей любого пола. Вы получаете один модификатор к реакции вместо зависящего от пола: +3 за Красивую, +4 за Очень красивую и +5 за Исключительную внешность.
Впечатляющая внешность [Impressive]: Если уровень вашей внешности не ниже Привлекательной, то вы можете определить, что у вас выдающаяся наружность, но без явной выраженной сексуальности. Это характерно для суровых людей или представителей королевской семьи. Если уровень вашей внешности не ниже Красивой (Прекрасной), то используйте единый бонус к реакции, указанный для Бесполой красоты.

===Особые улучшения===
Универсальная красота [Universal]: Ваш модификатор к реакции работает на всех, кто вас видит, независимо от расы. Если ваш уровень внешность не ниже Красивой (Прекрасной), то используйте единый бонус к реакции, указанный для Бесполой красоты. Это улучшение наиболее распространено среди Отвратительных и еще более уродливых чудовищ, а также среди Красивых и более привлекательных богов, фей и подобных существ. Мастер может запретить это улучшение простым смертным. +25%

===Особые ограничения===
Типовая красота [Off-the-Shelf Looks]: Вы можете взять этот модификатор для любого уровня внешности выше Привлекательного. Благодаря развитым технологиям или магии вы выглядите вариацией на тему стандартного шаблона или известного лица. Вы так же красивы, как и положено, но получаете половину обычного бонуса к реакции от людей из своей собственной культуры, потому что они уже видели подобное прежде. ("Глядите-ка! Еще один Мистер Вселенная 2003!") -50%</description-loc>
</advantage>
	<advantage version="2">
	<name>Arachnophobia (Spiders)</name>
	<name-loc>Боязнь пауков (Арахнофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>-5 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Arm DX</name>
		<name-loc>Увеличенная Ловкость рук</name-loc>
		<description-loc>Одна или две ваших рук имеют большую ловкость, чем общая ловкость тела. DX руки используется только для действий этой рукой, она не влияет на базовую скорость. Если задача использует две или больше рук с разной ловкостью – используется низшее значение. Боевые навыки используют ловкость тела, и не получают премий от ловкости рук.
Увеличение ловкости для одной руки стоит 12 очков за уровень; для двух – 16. Если вы хотите увеличить ловкость трех и более рук – увеличивайте ловкость общую. Если вы приобретаете это преимущество к ловкости с ограничением Нет тонких манипуляторов, то это ограничение модифицирует стоимость и данного преимущества тоже.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>16</points_per_level>
		<modifier version="1" enabled="no">
			<name>Только одна рука</name>
			<cost type="points">-4</cost>
			<affects>levels only</affects>
			<reference>B40</reference>
			<notes>@какая рука?@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Нет хороших манипуляторов (No fine manipulators)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B145</reference>
		</modifier>
		<reference>B40</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Arm ST</name>
		<name-loc>Увеличенная Сила рук</name-loc>
		<description-loc>Некоторые из ваших рук сильнее, чем ваше тело. Эта сила применяется только для метания, поднятия и атаки этими руками. Она не воздействует на НР и общую грузоподъемность. Если задача требует нескольких рук с разной силой – используется средняя.
Увеличение силы для одной руки стоит 3 очка за уровень; для двух – 5, для трех - 8. Если вы хотите увеличить силу четырех и более рук – увеличивайте общую. Если вы приобретаете это преимущество к силе с ограничением Нет тонких манипуляторов или Размер, то они модифицируют стоимость и данного преимущества тоже.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Нет хороших манипуляторов (No fine manipulators)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B145</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только одна рука</name>
			<cost type="points">-2</cost>
			<affects>levels only</affects>
			<reference>B40</reference>
			<notes>@какая рука?@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Три руки</name>
			<cost type="points">3</cost>
			<affects>levels only</affects>
			<reference>B40</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Размер</name>
			<cost type="percentage">-10</cost>
			<levels>1</levels>
			<affects>total</affects>
		</modifier>
		<reference>B40</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Attentive</name>
	<name-loc>Внимательный</name-loc>
	<base_points>-1</base_points>
	<categories>
		<category>Quirk</category>
	</categories>
	<type>Mental</type>
	<reference>B163</reference>
	<description-loc>
Вы сосредоточиваетесь на одном задании до самого его выполнения. Вы получаете бонус +1 при выполнении долгих задач, но пенальти -3, чтобы заметить в это время любое важное происшествие!</description-loc>
</advantage>
	<advantage version="2">
	<name>Autophobia (Being Alone)</name>
	<name-loc>Боязнь одиночества (Аутофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Вы не можете остаться один и сделаете все возможное, чтобы этого избежать. -15 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Autotrance</name>
		<name-loc>Быстрый транс</name-loc>
		<description-loc>Вы можете входить в транс, когда пожелаете. Это требует минуты концентрации и успешного броска Воли(Will), с кумулятивным штрафом -1 за каждую попытку в час. Транс дает +2 на броски для контакта с духами и пр. Чтобы выйти из транса, сделайте бросок Воли(Will). При провале вы можете пытаться каждые пять минут.
</description-loc>
		<type>Mental</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bad Back (Mild)</name>
		<name-loc>Боли в спине
 (Слабо)</name-loc>
		<description-loc>По какой-либо причине у вас проблемы с позвоночником. При требующей усилий физической деятельности у вас может "прихватить спину", что вызовет сильную боль или причинит дополнительные повреждения. Когда вы делаете проверку ST или выпадает 17 или 18 при проверке на атаку или защиту в ближнем бою либо при проверке на "атлетические" умения вроде Акробатики, требуется также выполнить проверку HT.


Модификаторы: Все модификаторы к проверке, которая вызвала проверку HT. При длительных заданиях это позволяет вам подготовиться и снизить риск для спины; успешная проверка IQ-2 или Физиологии+4 даст вам +2 к проверке HT.


В случае неудачи вы срываете спину. Последствия зависят от тяжести вашего случая:


Легкая форма: Вы получаете -3 к DX до тех пор, пока не отдохнете или пока кто-либо не окажет вам помощь; Первая помощь-2 поможет вашей спине. Вы также получаете -3 к IQ, но лишь на следующую секунду (в бою это будет ваш следующий ход). При критической неудаче вы получаете -5 к DX и должны выполнить проверку Воли(Will), чтобы предпринять любое физическое действие. -15 очков. 
Тяжелая форма: Проверка HT производится с -2. В случае неудачи DX и IQ получают пенальти -4, пока вы не получите помощь или не отдохнете; вы испытываете постоянную мучительную боль. При критической неудаче вы получаете 1d-3 повреждений, -6 к DX и -4 к IQ. -25 очков.


Высокий болевой порог (B59) уменьшает пенальти к DX и IQ наполовину (дробная часть отбрасывается), но не избавляет от него полностью.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B123</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bad Back (Severe)</name>
		<name-loc>Боли в спине
 (Сильно)</name-loc>
		<description-loc>По какой-либо причине у вас проблемы с позвоночником. При требующей усилий физической деятельности у вас может "прихватить спину", что вызовет сильную боль или причинит дополнительные повреждения. Когда вы делаете проверку ST или выпадает 17 или 18 при проверке на атаку или защиту в ближнем бою либо при проверке на "атлетические" умения вроде Акробатики, требуется также выполнить проверку HT.


Модификаторы: Все модификаторы к проверке, которая вызвала проверку HT. При длительных заданиях это позволяет вам подготовиться и снизить риск для спины; успешная проверка IQ-2 или Физиологии+4 даст вам +2 к проверке HT.


В случае неудачи вы срываете спину. Последствия зависят от тяжести вашего случая:


Легкая форма: Вы получаете -3 к DX до тех пор, пока не отдохнете или пока кто-либо не окажет вам помощь; Первая помощь-2 поможет вашей спине. Вы также получаете -3 к IQ, но лишь на следующую секунду (в бою это будет ваш следующий ход). При критической неудаче вы получаете -5 к DX и должны выполнить проверку Воли(Will), чтобы предпринять любое физическое действие. -15 очков. 
Тяжелая форма: Проверка HT производится с -2. В случае неудачи DX и IQ получают пенальти -4, пока вы не получите помощь или не отдохнете; вы испытываете постоянную мучительную боль. При критической неудаче вы получаете 1d-3 повреждений, -6 к DX и -4 к IQ. -25 очков.


Высокий болевой порог (B59) уменьшает пенальти к DX и IQ наполовину (дробная часть отбрасывается), но не избавляет от него полностью.</description-loc>
		<type>Physical</type>
		<base_points>-25</base_points>
		<reference>B123</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bad Grip</name>
		<name-loc>Слабая хватка
</name-loc>
		<description-loc>Вы получаете пенальти при выполнении заданий, требующих твердой хватки. Каждый уровень (максимально три уровня) дает -2 к подобным заданиям. Это общее пенальти - не за каждую руку отдельно. К таким заданиям относится использование холодного оружия, лазание, попытки поймать предмет и другие вещи, которые по мнению мастера требуют твердой хватки (например, проверка Акробатики, чтобы ухватиться за трапецию).
Данный недостаток взаимно исключается с недостатком Нет хороших манипуляторов (B145).</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-5</points_per_level>
		<reference>B123</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">no fine manipulators</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Bad Sight (Farsighted)</name>
		<name-loc>Слабое зрение (Дальнозоркость)</name-loc>
		<description-loc>У вас проблемы со зрением. Это относится ко всем способам визуального восприятия: обычному зрения, Инфразрению, Ультразрению и т.д. Вы можете быть близоруким или дальнозорким - по собственному выбору.


Близорукость: Вы не можете читать то, что напечатано мелким шрифтом, с компьютерного дисплея и т.д. на расстоянии более фута, не можете читать дорожные указатели и т.д., если они более чем в 10 ярдах. Вы получаете -6 к проверкам Зрения, чтобы заметить предметы, удаленные более чем на ярд. При атаках в ближнем бою вы получаете -2 к умению. При атаках оружием дальнего боя удвойте реальное расстояние до цели перед вычислением модификатора за расстояние. -25 очков
Дальнозоркость: Вы можете читать лишь с большими трудностями (требуется в три раза больше времени). Вы получаете -6 к проверкам Зрения, чтобы заметить предметы на расстоянии менее ярда, а также получаете -3 к DX при выполнении любой ручной работы близко к глазам, включая бой вплотную. -25 очков.


===Особые ограничения===
Смягчитель: При TL5+ вы можете приобрести очки, которые полностью снимут эффект Слабого зрения пока вы их носите. При TL7+ доступны контактные линзы. В обоих случаях помните, что может случиться несчастный случай... и что враги могут лишить вас этих предметов. Если вы начинаете игру на техническом уровне, где зрение может быть исправлено, вы обязаны взять данное ограничение. -60%</description-loc>
		<type>Physical</type>
		<base_points>-25</base_points>
		<modifier version="1" enabled="no">
			<name>Смягчитель</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<notes>Очки</notes>
		</modifier>
		<reference>B123</reference>
		<notes>-6 к броскам зрения чтобы заметить что-то на растоянии 1 метр и меньше; -3 DX при выполнении любой ручной работы близко к глазам, включая бой вплотную</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bad Sight (Nearsighted)</name>
		<name-loc>Слабое зрение (Близорукость)</name-loc>
		<description-loc>У вас проблемы со зрением. Это относится ко всем способам визуального восприятия: обычному зрения, Инфразрению, Ультразрению и т.д. Вы можете быть близоруким или дальнозорким - по собственному выбору.


Близорукость: Вы не можете читать то, что напечатано мелким шрифтом, с компьютерного дисплея и т.д. на расстоянии более фута, не можете читать дорожные указатели и т.д., если они более чем в 10 ярдах. Вы получаете -6 к проверкам Зрения, чтобы заметить предметы, удаленные более чем на ярд. При атаках в ближнем бою вы получаете -2 к умению. При атаках оружием дальнего боя удвойте реальное расстояние до цели перед вычислением модификатора за расстояние. -25 очков
Дальнозоркость: Вы можете читать лишь с большими трудностями (требуется в три раза больше времени). Вы получаете -6 к проверкам Зрения, чтобы заметить предметы на расстоянии менее ярда, а также получаете -3 к DX при выполнении любой ручной работы близко к глазам, включая бой вплотную. -25 очков.


===Особые ограничения===
Смягчитель: При TL5+ вы можете приобрести очки, которые полностью снимут эффект Слабого зрения пока вы их носите. При TL7+ доступны контактные линзы. В обоих случаях помните, что может случиться несчастный случай... и что враги могут лишить вас этих предметов. Если вы начинаете игру на техническом уровне, где зрение может быть исправлено, вы обязаны взять данное ограничение. -60%</description-loc>
		<type>Physical</type>
		<base_points>-25</base_points>
		<modifier version="1" enabled="no">
			<name>Смягчитель</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<notes>Очки</notes>
		</modifier>
		<reference>B123</reference>
		<notes> -6 к броскам зрения чтобы заметить что-то на растоянии более 1 метра; -2 ко всем атакам ближнего боя; при атаках оружием дальнего боя удвойте реальное расстояние до цели перед вычислением модификатора за расстояние</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Bad Smell</name>
	<name-loc>Неприятный запах
</name-loc>
	<notes>-2 реакции</notes>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B128</reference>
	<description-loc>Вы источаете отталкивающий запах, от которого невозможно избавиться, например, зловоние смерти и разложения. Это дает -2 к реакции от большинства людей и животных (хотя вы можете необыкновенно привлекать паразитов или стервятников, питающихся падалью!). Вы можете скрыть этот запах с помощью парфюмерии, но ее понадобится такое количество, что она вызовет то же пенальти к реакции.</description-loc>
</advantage>
	<advantage version="2">
		<name>Bad Temper</name>
		<name-loc>Вспыльчивость
</name-loc>
		<description-loc>Вы не полностью контролируете свои эмоции. Делайте проверку на самоконтроль в любой стрессовой ситуации. Если она провалена, то вы выходите из себя и можете оскорбить, напасть или иным образом начать действовать против источника стресса.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B124</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Berserk</name>
		<name-loc>Неистовство
</name-loc>
		<description-loc>Вы склонны от ярости терять контроль над собой, когда вам или вашим близким причиняют вред, и вы бешено атакуете кого и что угодно, что считаете источником этого вреда. Если вы обладаете еще и Вспыльчивостью (выше), то любой стресс может вызвать Неистовство.
Делайте проверку на самоконтроль каждый раз, когда получаете повреждения свыше 1/4 от своих HP в течение секунды, и каждый раз, когда видите, как подобный вред причиняют вашим близким. При провале вы впадаете в неистовство. Это же происходит автоматически, если вы проваливаете проверку на самоконтроль за Вспыльчивость! Вы можете сознательно впасть в неистовство, использовав маневр Концентрация и успешно выполнив проверку Воли(Will). Как только вы впали в неистовство, применяются следующие правила:


* Если вы вооружены холодным оружием, то обязаны совершать Тотальную Атаку (all-out attack) каждый ход, когда противник находится в зоне досягаемости. Если противник вне зоны досягаемости, то вы обязаны использовать маневр Передвижение, чтобы подобраться как можно ближе к нему - а если вы способны совершить Движение и Атаку или закончить Атаку толчком, то так и сделаете.
* Если противник более чем в 20 ярдах от вас, то вы можете атаковать с помощью оружия дальнего боя, если таковое имеется, но вы не можете Прицеливаться. При использовании огнестрельного оружия вы непрерывно палите с максимальной скоростью, пока не закончится боезапас. Вы не можете перезаряжать оружие, если только оно - и ваше умение Быстрое выхватывание - не позволяют зарядить "рефлекторно" (это может занимать не более секунды). Как только ваше оружие опустело, вы должны или выхватить другое, или броситься врукопашную.
* Вы невосприимчивы к оглушению и шоку, а ваши раны не дают пенальти к Передвижению. Вы делаете все проверки против потери сознания или смерти с +4 к HT. Если вы не провалили ни одной проверки, то остаетесь на ногах и бешено атакуете, пока не достигните -5xHP. И после этого упадете замертво!
* Когда вы разделались с противником, то можете (при желании) сделать еще одну проверку на самоконтроль с целью выйти из неистовства. Если проверка неудачна (или она не проводилась), то вы остаетесь неистовым и атакуете следующего противника. Любой друг, который пытается вас остановить, считается противником! Вы можете делать проверку каждый раз, когда побеждаете противника, а также получаете дополнительную проверку, когда противников не осталось. Если неистовство продолжается, то вы начинаете атаковать своих друзей...


Как только вы возвращаетесь в нормальное состояние, все ваши раны немедленно начинают действовать. Проведите необходимые проверки против нормального HT, чтобы определить, остались ли вы в сознании и сохранили ли жизнь.


===Особые улучшения===
Бешенство в бою. Вы впадаете в неистовство в любой боевой ситуации, независимо от того, были ли ранены. Чтобы избежать этого, необходимо сделать проверку на самоконтроль при первом попадании в сражение (даже если речь идет о потасовке в баре или о матче по боксу). +50%</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<modifier version="1" enabled="no">
			<name>Бешенство в бою (Battle Rage)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
		</modifier>
		<reference>B124</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bestial</name>
		<name-loc>Животное поведение
</name-loc>
		<description-loc>Вы мыслите и действуете как дикое животное. У вас нет представлений о "цивилизованных" нормах морали или приличиях, вы не понимаете что такое собственность. Если кто-то пугает вас или угрожает вам, то вы деретесь с ним или убегаете. Вы не можете изучать умения, которые, по мнению мастера, основаны на "цивилизованных" понятиях об искусстве или на социальном взаимодействии, и у вас нет этих умений по умолчанию.
Вы не обязательно не контролируете себя; вы просто действуете как положено животному. Обычно вы игнорируете тех, кто не трогает вас (если они не из разряда еды!), и можете даже выражать привязанность к тем, кто обращается с вами с особой добротой. Вы не можете понять, что такое собственность в человеческом смысле, но (в зависимости от расы) способны понять, что такое чужая территория, и не вредить тому, что находится на ней. Но вот считаете ли вы людей существами, у которых есть право на территорию - это вопрос открытый! Вы также способны понимать силу и уважать человека, который доказал, что он сильнее вас.
Вы не можете брать недостаток Дурная привычка для отражения своего животного поведения; оно уже включено в стоимость Животного поведения. Но если ваше поведение особенно неприятно людям - по серьезности равняется Дурной привычке за -15 очков - то мастер может считать, что для вас Животное поведение стоит -15 очков, а не обычные -10. Однако вы вольны выбирать Дурные привычки, не связанные с животным поведением (включая "людоедство").
Животное поведение не обязательно привязано к низкому IQ, но вот отыграть персонажа, который одновременно ведет себя как животное и обладает выдающимся интеллектом - это серьезное испытание, требующее изрядной смекалки и усилий. Мастер, однако, может ограничить IQ для персонажей с Животным поведением значением не более 10 (или даже не более 6!), а может и вовсе оставить этот недостаток только для NPC.
Обратите внимание, что мета-особенность Дикое Животное (B263) включает данный недостаток.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>-10</base_points>
		<reference>B124</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Binding</name>
	<name-loc>Сковывание</name-loc>
	<points_per_level>2</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Опутывание (Engulfing)</name>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушается только @Огнем/Режущим/Дробящим@</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушается только двумя из @Огнем/Режущим/Дробящим@</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушается только огнем или режущим или дробящим</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Липкое (Sticky)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неразрушимое (Unbreakable)</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Однослойное (One-Shot)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B40</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Super-Binding</name>
		<cost type="percentage">400</cost>
		<affects>total</affects>
		<reference>Sup25</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B40</reference>
	<description-loc>Ваша атака привязывавает цель к месту. Природа этого выбирается при покупке – паутина, лозы, кусок льда, зыбучий песок и пр. 
Связывающая атака – дальняя атака с Max 100, Acc 3, RoF 1, Rcl 1. Вы можете приобретать Модификаторы атаки, чтобы изменить эти параметры (с. B101-B116).
В случае попадания, ваша жертва прикована к месту. Она не может двигаться, поворачиваться и менять положение, и получает -4 DX. ST эффекта равна уровню Сковывания, но вы можете накладывать дополнительные «слои» - каждый новый слой добавляет +1 ST.
Для освобождения, жертве надо выиграть в состязании ST своей против ST Сковывания. Каждая попытка занимает 1 секунду, и в случае провала стоит 1 FP. Также она может попытаться уничтожить путы (попадание природным оружием автоматическое, прочим – с -4). Атаки союзников не получают штрафа, но могут поранить самого привязанного (с. B392). Путы имеют DR, равный 1/3 уровня преимущества (округляется вниз). Каждое очко вреда, полученное путами, уменьшает их эффективную ST на 1, жертва считается освобожденной, когда ST становится 0.

Для имитации паутины, лоз и т.п., приобретайте дополнительные модификаторы – Воздействие на область (с. B102), Продолжительное действие (с. B107), Стена (с. B109), и, возможно, некоторые из нижеследующих модификаторов.

===Особые улучшения.===

Поглощение (Engulfing): Ваша атака поглощает жертву полностью – она не может двигаться и говорить – только использовать ментальные способности, атаковать узы врожденной атакой или пытаться вырваться (даже Побегом). Попытка вырваться доступна только каждые 10 сек, и при результате 17-18 жертва запутывается настолько, что не может вырваться самостоятельно. +60%.

Повреждение только определенной атакой (Only Damaged By X): Только определенный тип вреда может повредить путы: огненный, разъедающий, режущий или тупой. +30% за один из них, +20% за два из них, +10% за три.

Липкая (Sticky): Ваши путы считаются заразными (с. B107), но действуют только на тех, кто касается первой жертвы.

Неразрушимое (Unbreakable): Ваши путы не могут быть уничтожены – из них можно только вырваться. +40%.

Зависят от окружения (Environmental): Ваши манипуляции путами зависят от окружающей среды, и не работают в отсутствии. Цена колеблется от -20% (жертва должна касаться земли) до -40% (должна находиться в плотной растительности).

===Особые ограничения.===
Только один слой (One-Shot): Вы не можете накладывать дополнительные слои для усиления пут. -10%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Blessed</name>
	<name-loc>Благословение</name-loc>
	<base_points>10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Единоверцы</limitation>
		<amount>1</amount>
	</attribute_bonus>
	<modifier version="1" enabled="no">
		<name>Сильно (Very)</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B40</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Единоверцы</limitation>
			<amount>1</amount>
		</attribute_bonus>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B40</reference>
	<description-loc>Вы живете в гармонии с некой высшей силой – божеством, повелителем демонов, великим духом, абсолютным разумом и т.п. Всякий благословленный персонаж обязан действовать согласно с правилами и ценностями своего божества, иначе это преимущество потеряется.

Благословленный (Blessed): После часа медитации или молитвы вы можете получить некоторое озарение от вашего покровителя. Детали ритуала зависят от покровителя – например, Бог Огня может требовать, чтобы вы целый час глядели в огонь, после чего вы услышите голос в реве пламени. Мастер тайно кидает IQ, чтобы определить наличие и пользу озарения. Ритуал очень утомляет (стоит 10 FP). Последователи вашего покровителя также реагируют на вас с +1. 10 очков.

Озаренный (Very Blessed): Как и выше, но бросок IQ на интерпретацию видений делается с +5; а бонус реакции от последователей одной с вами веры составит +2. 20 очков.
Героические деяния (Heroic Feats): Благословение дает вам природную способность совершить определенное героическое деяние. Один раз за игровую сессию вы можете добавить 1d к ST, DX или HT (атрибут определяется в момент приобретения черты) на время до 3d секунд. По прошествии этого времени вы возвращаетесь к своим обычным показателям и страдаете от всех пенальти, полученных за время героического деяния. (Например, если вы получили повреждения, более чем в пять раз превосходящие ваш обычный показатель HT в то время, как HT был повышен, то без какого-либо лечения немедленно умрете по прошествии этого эффекта.) 10 очков.
Мастер может определять другие виды благословения.</description-loc>
</advantage>
	<advantage version="2">
		<name>Blessed (Heroic Feats)</name>
		<name-loc>Благословение  (Героические деяния)</name-loc>
		<description-loc>Вы живете в гармонии с некой высшей силой – божеством, повелителем демонов, великим духом, абсолютным разумом и т.п. Всякий благословленный персонаж обязан действовать согласно с правилами и ценностями своего божества, иначе это преимущество потеряется.

Благословленный (Blessed): После часа медитации или молитвы вы можете получить некоторое озарение от вашего покровителя. Детали ритуала зависят от покровителя – например, Бог Огня может требовать, чтобы вы целый час глядели в огонь, после чего вы услышите голос в реве пламени. Мастер тайно кидает IQ, чтобы определить наличие и пользу озарения. Ритуал очень утомляет (стоит 10 FP). Последователи вашего покровителя также реагируют на вас с +1. 10 очков.

Озаренный (Very Blessed): Как и выше, но бросок IQ на интерпретацию видений делается с +5; а бонус реакции от последователей одной с вами веры составит +2. 20 очков.
Героические деяния (Heroic Feats): Благословение дает вам природную способность совершить определенное героическое деяние. Один раз за игровую сессию вы можете добавить 1d к ST, DX или HT (атрибут определяется в момент приобретения черты) на время до 3d секунд. По прошествии этого времени вы возвращаетесь к своим обычным показателям и страдаете от всех пенальти, полученных за время героического деяния. (Например, если вы получили повреждения, более чем в пять раз превосходящие ваш обычный показатель HT в то время, как HT был повышен, то без какого-либо лечения немедленно умрете по прошествии этого эффекта.) 10 очков.
Мастер может определять другие виды благословения.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>10</base_points>
		<reference>B41</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Blindness</name>
		<name-loc>Слепота
</name-loc>
		<description-loc>Вы совсем не можете видеть. В незнакомой местности вам приходится перемещаться медленно и осторожно либо пользоваться помощью спутника или животного-поводыря. Многие действия для вас невозможны; мастеру следует использовать здравый смысл.
Вы получаете -6 ко всем боевым умениям. Вы можете использовать холодное оружие, но не можете целиться в определенную часть тела. Используя оружие дальнего боя, вы можете стрелять наугад или подпускать противников настолько близко, чтобы было можно их слышать. Все это относится к случаям, когда вы привычны к слепоте. Если вы внезапно потеряли зрение, то сражаетесь с -10, так, как если бы были в абсолютной темноте. В любом случае, вы не получаете дополнительных пенальти за действия в темноте.
Если вы слепы, то не можете приобретать сверхчеловеческие зрительные способности. Если вы воспринимаете невидимую область спектра, то у вас просто версия Инфравидения (B60) или Ультравидения (B94) за 0 очков - а не Слепота вместе с 10-очковой версией одного из указанных преимуществ. Обратите внимание, что Природный сканнер (B81) и Чувство вибраций (B96) - это не зрение; вы можете взять любое из этих преимуществ вместе со Слепотой за обычную цену.</description-loc>
		<type>Physical</type>
		<base_points>-50</base_points>
		<reference>B124</reference>
		<notes>-6 ко всем боевым умениям; нельзя задавать локацию при атаке</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bloodlust</name>
		<name-loc>Кровожадность
</name-loc>
		<description-loc>Вы желаете видеть своих врагов мертвыми. В бою вы обязаны использовать смертельные удары и делать контрольный выстрел, чтобы убедиться, что враг погиб. Необходима проверка на самоконтроль, если вам нужно позволить противнику сдаться, пройти мимо вражеского караула, захватить пленного и т.д. При неудачной проверке вы вместо этого попытаетесь убить врага - даже если это означает нарушить закон, выдать свое расположение, потратить патроны или нарушить приказ. В не боевой ситуации вы тоже никогда не забываете, что враг - это враг.
Это может показаться подлинно злодейской чертой, но многие литературные герои страдали от нее. Герой не изверг и не садист; его злоба ограничивается "законными врагами", будь то преступники, вражеские солдаты или члены враждебного клана. Обычно у него есть веская причина относить к ним именно так. А в обычной кабацкой драке он будет использовать кулаки, как и все остальные. С другой стороны, Кровожадный гладиатор или дуэлянт был бы весьма непопулярен, а полицейский вскоре бы попал под разбирательство, а солдат рисковал бы угодить под трибунал.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Bowlegged</name>
		<name-loc>Кривоногий</name-loc>
		<description-loc>
Ваша кривоногость обычно не влияет на Передвижение, но дает -1 к умению Прыжки. Эта причуда может привести к штрафу в -1 на реакцию от человека, считающего ваш недостаток забавным.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Brachiator</name>
		<name-loc>Цепкость</name-loc>
		<description-loc>Вы можете лазать по лианам, веревкам и сквозь кроны деревьев с огромной ловкостью. Вы получаете +2 на броски Лазания, и во время лазания можете передвигаться со скоростью, равной половине от вашей наземной.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B41</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">climbing</name>
			<specialization compare="is anything"></specialization>
			<amount>2</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Breath-Holding</name>
		<name-loc>Задержка Дыхания</name-loc>
		<description-loc>Вы способны задерживать дыхание. Каждый уровень удваивает продолжительность времени, на которое вы можете задерживать дыхание (с. B351). Обычные люди не могут брать это преимущество, вместо этого используется соответствующий навык Задержка дыхания (с. B182). Нелюди и супер-герои могут комбинировать их!</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B41</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Broad-Minded</name>
		<name-loc>Терпимый</name-loc>
		<description-loc>
Мягкая форма Ксенофилии (B163). Вы хорошо уживаетесь с другими расами и видами, и странная внешность вас вряд ли обеспокоит.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B163</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Brontophobia (Loud Noises)</name>
	<name-loc>Боязнь громких звуков (Бронтофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы избегаете любой ситуации, при которой возможен громкий шум. Внезапный громкий звук требует проверки на самоконтроль. Гроза ужасает вас до глубины души! -10 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Bully</name>
		<name-loc>Задира
</name-loc>
		<description-loc>Вы любите третировать людей, когда вам это сходит с рук. В зависимости от вашей личности и положения, это может принимать формы физического насилия, словесных оскорблений или издевательств. Сделайте проверку на самоконтроль, чтобы явно не задирать кого-то, когда этого делать не нужно - но, чтобы отыграть своего персонажа как положено, вам придется задирать всех кого можете. Поскольку никто не любит задир, реагировать на вас будут с -2.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Callous</name>
		<name-loc>Бесчувственный
</name-loc>
		<description-loc>Вы безжалостны, если не сказать жестоки. Вы способны понимать чужие эмоции, но делаете это лишь для того, чтобы управлять ими - вам нет дела до чужих чувств или боли. Это дает вам -3 ко всем проверкам на Обучение, к проверкам Психологии с целью помочь кому-то (но не с целью определить чужие слабости или провести научное исследование), а также ко всем проверкам на взаимодействие с теми, кто в прошлом пострадал от вашей бесчувственности (это решает мастер). Кроме того, жертвы вашего отношения и те, кто обладает Эмпатией, реагируют на вас с -1. Но безжалостность имеет и свои положительные черты: вы получаете +1 к проверкам на Допрашивание и Запугивание, когда используете угрозы или пытки.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">psychology</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">teaching</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Cannot Float</name>
		<name-loc>Неспособен плавать</name-loc>
		<description-loc>
Вы плаваете, как топор. Это больше подходит машинам, но может быть присуще и некоторым фантастическим расам или быть результатом проклятия.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Cannot Learn</name>
		<name-loc>Неспособен учиться
</name-loc>
		<description-loc>Вы не можете тратить заработанные очки персонажа на увеличение DX, IQ, умений, приобретение ментальных преимуществ, не можете изучать новые техники (см. Техники, B229) или получать знакомство с чем-либо (см. Знакомство, B169) для уже имеющихся умений. Вы застываете с изначальными способностями!
Вы все же можете повышать свои ST и HT, получать физические преимущества (с разрешения мастера). Помимо этого, Неспособность учиться не мешает вам временно приобретать умения, используя преимущество Изменяемые способности (B71). Существа с компьютерным сознанием часто обладают обеими этими особенностями.
Данная особенность наиболее подходит для големов, лишенных сознания живых мертвецов, роботов и прочих автоматов.</description-loc>
		<type>Mental</type>
		<base_points>-30</base_points>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Cannot Speak</name>
		<name-loc>Неспособен говорить 
</name-loc>
		<description-loc>У вас ограничена способность говорить. Данная особенность бывает двух уровней:
Неспособность говорить: Вы можете издавать звуки (лаять, рычать, выводить трели и т.д., в зависимости от персонажа), но ваш речевой аппарат не приспособлен, чтобы издавать тонкие звуки, необходимые для разговора. У вас все же могут быть преимущества Подражание голосам или Голос, а также недостаток Неприятный голос (но не Заикание). У большинства животных есть эта особенность. -15 очков.
Немота: Вы вовсе не способны издавать звуки. Всякое общение с окружающими должно быть невербальным: письменным, на языке жестов, морзянкой, с помощью телепатии и т.д. Время, проводимое за таким общением, считается полностью посвященным изучению соответствующих умений (см. Главу 9). Проводить проверку не требуется (и не разрешается!), если вы пытаетесь объясниться с игровым персонажем, который не знает языка жестов - отыграйте это как считаете нужным! Вы не можете обладать никакими особенностями, которые связаны с голосом. -25 очков.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">stuttering</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Cannot Speak (Mute)</name>
		<name-loc>Неспособен говорить 
 (Немой)</name-loc>
		<description-loc>У вас ограничена способность говорить. Данная особенность бывает двух уровней:
Неспособность говорить: Вы можете издавать звуки (лаять, рычать, выводить трели и т.д., в зависимости от персонажа), но ваш речевой аппарат не приспособлен, чтобы издавать тонкие звуки, необходимые для разговора. У вас все же могут быть преимущества Подражание голосам или Голос, а также недостаток Неприятный голос (но не Заикание). У большинства животных есть эта особенность. -15 очков.
Немота: Вы вовсе не способны издавать звуки. Всякое общение с окружающими должно быть невербальным: письменным, на языке жестов, морзянкой, с помощью телепатии и т.д. Время, проводимое за таким общением, считается полностью посвященным изучению соответствующих умений (см. Главу 9). Проводить проверку не требуется (и не разрешается!), если вы пытаетесь объясниться с игровым персонажем, который не знает языка жестов - отыграйте это как считаете нужным! Вы не можете обладать никакими особенностями, которые связаны с голосом. -25 очков.</description-loc>
		<type>Physical</type>
		<base_points>-25</base_points>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Careful</name>
		<name-loc>Осторожный</name-loc>
		<description-loc>
Трусость (B129) на уровне причуды. Вы постоянно настороже и всегда в поисках угрозы. Вы тратите дополнительное время и деньги на подготовку перед рискованным предприятием.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B163</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Catfall</name>
		<name-loc>Мягкое падение</name-loc>
		<description-loc>Персонаж вычитает 5 ярдов из высоты падения автоматически (это считается за автоматический успех навыка «акробатика», дополнительный бросок не требуется). Дополнительный успешный бросок DX вдвое уменьшит любое повреждение от падения. Однако, во время падения вы должны иметь полную свободу действий.

===Новые особые улучшения===
Падение пера (Feather Fall): Вы получаете выгоду от преимущества всегда – независимо от своей свободы и состояния сознания. +20%.

===Новые особые ограничения===
Парашют (Parachute): Вы используете природную версию парашюта. Преимущество действует только при падении дольше двух секунд, но слишком медленно, чтобы помочь вам на низкой высоте (c высоты 6×G ярдов и меньше). Вам необходимо свободное пространство, радиусом равное вашему росту; оно будет бесполезно при падении в узких колодцах. Не работает в атмосферах очень разреженных (very thin) и еще более слабых.
-30%.
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Feather Fall</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P43</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Parachute</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P43</reference>
		</modifier>
		<reference>B41</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Chameleon</name>
		<name-loc>Хамелеон</name-loc>
		<description-loc>Вы можете сливаться с окружающей средой. В любой ситуации, где видимость существа значима, вы получаете +2 за уровень к умению Скрытность когда стоите совершенно неподвижно и +1 за уровень при движении. Одежда уменьшает бонус до +1 за уровень при неподвижности до 0 в движении, если мастер считает, что маскировка не подходит к местности. 

Это преимущество не помогает в темноте или прочих ситуациях, когда большее значение играет не зрение. Вы можете указать, что ваша версия Хамелеона помогает против другого одного вида визуального или сканирующего восприятия, указанного при создании (вместо обычного зрения).

===Особые улучшения.===

Расширенное (Extended): способность захватывает и другие чувства. Цена +20% за каждое дополнительное чувство.

===Особые ограничения.===
Всегда включено (Always On): вы не можете выключить особенность. Другие реагируют с -1, т.к. это раздражает. -10%.

===Новые особые улучшения===
Контролируемое (Controllable): Вы можете по желанию изменять свою окраску. Это может сделать вас более заметным, если вы того хотите – например, чтобы подать сигнал. В этом случае пытающиеся вас заметить получают премию +2 за каждый уровень преимущества. Взаимоисключающий с Действует всегда. +20%.

В движении (Dynamic): Ваша окраска приспосабливается к изменяющимся условиям. Вы получаете полную премию к Скрытности (+2 за уровень) даже в движении. +40%.
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Расширенное (Extended)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B41</reference>
			<notes>@Чувство@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Действует постоянно (Always On)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B41</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Controllable</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P43</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Dynamic</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>P43</reference>
		</modifier>
		<reference>B41</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Channeling</name>
	<name-loc>Проводник духов</name-loc>
	<base_points>10</base_points>
	<modifier version="1" enabled="no">
		<name>Aware</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P43</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Specialized</name>
		<notes>@Тип@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P44</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B41</reference>
	<description-loc>Вы можете становиться проводником между вашим миром и миром духов, позволяя духам говорить через вас. Для этого необходимо войти в транс минутой концентрации и броском Воли(Will). Во время транса вы ничего не знаете о вашем окружении.
После этого любой дух вблизи может войти в ваше тело и использовать его для разговора. Духа контролирует мастер. Дух ответит на вопросы других, но не обязательно честно.
Это малая форма одержания – дух может использовать ваше тело только для общения. Однако, если у него есть способность Одержания, он может попытаться захватить полный контроль. Вы считаетесь предупрежденным, и сопротивляетесь с +5.

===Новые особые улучшения===
Сохранение сознания (Aware): Во время сеанса вы сохраняете контроль над своим телом, и можете свободно передвигаться и действовать, когда дух говорит через вас. +50%.

===Новые особые ограничения===
Спиритический сеанс часто требует определенного ритуала – в таком случае добавляется модификатор Требует подготовки (с. В114). Другое ограничение, часто встречающееся во многих мирах: 
Специализированное (Specialized): вы можете проводить только один определенный вид духов. Возможные виды включают: ангелов, демонов, элементалей, фейри, призраков, и т.д. – все, что позволит Мастер. -50%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Charisma</name>
	<name-loc>Харизма</name-loc>
	<notes>+1/ур. к броскам реакции</notes>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount per_level="yes">1</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">fortune-telling</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">leadership</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">panhandling</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">public speaking</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B41</reference>
	<description-loc>Это природная способность производить впечатление и вести за собой других. Любой может получить подобие харизмы за счет привлекательности, хороших манер и интеллигентности - но настоящая харизма работает независимо от всех этих вещей и она или есть, или ее нет. Влияет на броски реакции, совершаемые всеми разумными существами, на броски влияния на них (с. B359), а также дает +1 на все броски Предсказания судьбы, Лидерства, Попрошайничества и Публичного выступления. Мастер может решить, что преимущество не действует на своершенно чужеродные расы.</description-loc>
</advantage>
	<advantage version="2">
		<name>Charitable</name>
		<name-loc>Филантропия
</name-loc>
		<description-loc>Вы остро ощущаете чужие эмоции и считаете обязательным для себя помогать окружающим - даже своим явным врагам. Сделайте проверку на самоконтроль в любой ситуации, где вы можете оказать помощь или где вас специально просят о помощи, но в которой вы не должны этого делать. Если проверка не удалась, то вы обязаны предложить помощь, даже если это означает нарушение приказа или вероятность попасть в ловушку.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B125</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Chauvinistic</name>
		<name-loc>Шовинист</name-loc>
		<description-loc>
Очень слабое подобие Нетерпимости (B140). Вы всегда держите в уме различия, касающиеся пола, цвета кожи, и т.п., даже если внешне никак этого не показываете. В результате обидчивые люди могут иногда реагировать на вас с -1.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B163</reference>
		<notes>@Чего?@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Chronic Depression</name>
		<name-loc>Хроническая депрессия
</name-loc>
		<description-loc>Вы утратили волю к жизни. Вы бы совершили самоубийство, но это для вас слишком сложно. Необходимо выполнить проверку на самоконтроль, чтобы сделать что угодно помимо минимально необходимого для выживания (например, чтобы решиться пойти в кино, на собеседование по трудоустройству, прийти на свидание), а также каждый раз, когда нужно выбрать из двух или более действий. Если проверка не удалась, вы выбираете путь наименьшего сопротивления. Обычно это означает, что вы остаетесь на месте и ничего не делаете.
Если ваш показатель самоконтроля слишком низок, то вы будете практически не способны делать что-либо для себя, если кто-то физически не вытащит вас из берлоги. Если кто-то появляется с требованием пойти и сделать что-то вместе, выполните проверку на самоконтроль. Если проверка не удалась, то вы смирились с его планом, но без энтузиазма.
Однажды вы можете заменить этот недостаток другим недостатком за ту же цену, который связан с большим самоуважением. Мастеру следует позволять это преображение, только если вы убедительно его отыграли. На время перехода мастер может потребовать отыгрывать оба недостатка (новый на постоянной основе, а Хроническую Депрессию тогда, когда мастер решит ввести ее в игру).
Вы можете также получить этот недостаток по ходу игры. Если ваше поведение разошлось с добровольно принятым ментальным недостатком (см. B121) или если вы лишились Иждивенца, то мастер может заменить данный недостаток Хронической депрессией.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B126</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Chronic Pain</name>
	<name-loc>Хронические боли
</name-loc>
	<notes>-2 к DX, IQ, и броскам самоконтроля</notes>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Умереная</name>
		<notes>-2 к DX, IQ, и броскам самоконтроля</notes>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Серьёзная</name>
		<notes>-4 к DX, IQ, и броскам самоконтроля</notes>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Мучительная</name>
		<notes>-6 к DX, IQ, и броскам самоконтроля</notes>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B126</reference>
	</modifier>	
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1 час</name>
		<cost type="multiplier">0.5</cost>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>2 часа</name>
		<cost type="multiplier">1</cost>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>4 часа</name>
		<cost type="multiplier">1.5</cost>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>8 часов</name>
		<cost type="multiplier">2</cost>
		<reference>B126</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Бросок пояления: 6</name>
		<cost type="multiplier">0.5</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Бросок пояления: 9</name>
		<cost type="multiplier">1</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Бросок пояления: 12</name>
		<cost type="multiplier">2</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Бросок пояления: 15</name>
		<cost type="multiplier">3</cost>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B126</reference>
	<description-loc>Вы страдаете от ранения, нарушения или болезни, которая регулярно - или даже постоянно - причиняет вам серьезную боль. Примеры этого - артрит, рак кости, мигрени и застрявшие в теле осколки ("старая боевая рана").
Один раз в день следует выполнить проверку против частоты появления Хронической боли. Если результат ниже указанного значения, то с вами случается приступ болевых ощущений. Время приступа определяет мастер, но обычно такое случается когда вы бодрствуете - вы можете проснуться с болью или в течение дня ее может вызвать стресс (усталость, напряжение и т.д.).
Во время болей ваши DX и IQ снижаются на число, определяемое серьезностью боли (см. ниже). Снизьте на это же число показатель самоконтроля при сопротивлении недостаткам вроде Вспыльчивости или Неистовства - испытывая боль, сложнее сдерживать себя. Если мастер решает, что боли начались тогда, когда вы пытаетесь спать, то вместо обычных эффектов недостатка вы получаете штрафы за недосыпание.
Приступ Хронических болей продолжается в течение установленного "интервала", после которого вы можете выполнить проверку HT, чтобы прийти в себя. Если проверка успешна, то вы справились с болью... на сегодня. Если неудачна, то приступ продолжается еще один интервал, после которого можно провести еще одну проверку HT. И так далее.
Определите цену Хронических болей, выбрав их серьезность, а затем изменив полученную цену в зависимости от продолжительности приступа и частоты его появления. Все дробные значения отбрасываются.


Серьезность
Умеренная: -2 к DX, IQ и проверкам на самоконтроль: -5 очков.
Серьезная: -4 к DX, IQ и проверкам на самоконтроль: -10 очков.
Мучительная: -6 к DX, IQ и проверкам на самоконтроль: -15 очков.


Интервал
1 час: x0.5.
2 часа: x1.
4 часа: x1.5.
8 часов: x2.


Частота появления
Приступ случается при результате 6 или меньше: x0.5.
Приступ случается при результате 9 или меньше: x1.
Приступ случается при результате 12 или меньше: x2.
Приступ случается при результате 15 или меньше: x3.</description-loc>
</advantage>
	<advantage version="2">
		<name>Chummy</name>
		<name-loc>Общительный</name-loc>
		<description-loc>Вы хорошо работаете в команде и ищете чужого общества. Данная черта бывает двух уровней:


Общительный: Чаще всего вы реагируете на окружающих с +2. В одиночестве вы несчастливы и расстроены, отчего получаете -1 к умениям, зависящим от IQ. -5 очков.
Стайный: Обычно вы реагируете на окружающих с +4. Вы несчастны, если остаетесь в одиночестве, и получаете -2 к зависящим от IQ умениям, либо -1, если работаете в группе из четырех или менее человек. -10 очков.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B126</reference>
		<notes>Реагирует на людей с +2; -1 к броскам и умениям на основе IQ когда один</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Chummy (Gregarious)</name>
		<name-loc>Общительный (Стайный)</name-loc>
		<description-loc>Вы хорошо работаете в команде и ищете чужого общества. Данная черта бывает двух уровней:


Общительный: Чаще всего вы реагируете на окружающих с +2. В одиночестве вы несчастливы и расстроены, отчего получаете -1 к умениям, зависящим от IQ. -5 очков.
Стайный: Обычно вы реагируете на окружающих с +4. Вы несчастны, если остаетесь в одиночестве, и получаете -2 к зависящим от IQ умениям, либо -1, если работаете в группе из четырех или менее человек. -10 очков.


Если ваш показатель самоконтроля слишком низок, то вы будете практически не способны делать что-либо для себя, если кто-то физически не вытащит вас из берлоги.
	</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B126</reference>
        <notes>Реагирует на людей с +4; -2 к броскам и умениям на основе IQ когда один, -1 когда в группе 4х и менее человек</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Claim to Hospitality</name>
	<name-loc>Традиция гостеприимства</name-loc>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Ваша соц. группа</limitation>
		<amount>3</amount>
	</attribute_bonus>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Один друг@ (с местом для укрытия)</name>
		<cost type="points">1</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Группа@ - @услуга@</name>
		<cost type="points">1</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Группа@ - есть @ресурсы@</name>
		<cost type="points">2</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Большая группа@ - @много услуг@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Широкая группа@ - @много услуг@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B41</reference>
	<description-loc>Вы принадлежите к социальной группе, которая рада помочь другому члену. Когда вы далеко от дома, вы можете обращаться к другим членам группы за пропитанием, убежищем и небольшой материальной помощью. 
Цена зависит от богатства и величины группы. Друг с домом в другом городе стоит 1 очко; небольшая семья – 2 очка; общество торговцев на важном торговом маршруте – 5 очков; широкий круг богатых людей (любой торговец в мире) – 10 очков.  
В подходящей ситуации их можно найти после 1d-1 часов поисков при успешном броске на 14. В неподходящей - только на 6.
Члены группы относятся друг к другу дружелюбно (+3 реакции), могут дать совет, информацию или небольшую ссуду, если их попросят. Уровень помощи сравним с рекомендациями, данными в описании Контакта (с. B44). Если вы ожидаете чего-то большего, приобретайте Союзников (с. B36) или Покровителей (с. B72). 72).
Преимущество это действует в обе стороны. Вы также должны помогать нуждающимся членам своей группы. В случае отказа вы можете получить плохую репутацию и потерять это преимущество.</description-loc>
</advantage>
	<advantage version="2">
	<name>Clairsentience</name>
	<name-loc>Дальновидение</name-loc>
	<base_points>50</base_points>
	<modifier version="1" enabled="no">
		<name>Только слух</name>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только обоняние</name>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только зрение</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Экстрасенсорика</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Видимое проявление</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Aware</name>
		<notes>Сохранение контроля</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P44</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Действует только на невидимый мир</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P43</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Может использовать способности на материальный мир</notes>
		<cost type="percentage">140</cost>
		<affects>total</affects>
		<reference>P44</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Second Nature</name>
		<notes>Вторая натура</notes>
		<cost type="percentage">70</cost>
		<affects>total</affects>
		<reference>P44</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B42</reference>
	<description-loc>Название преимущества выбрано лишь для удобства – на самом деле, все чувства перемещаются одновременно, если вы не выберете определенных ограничений. 
Вы можете «перемещать» ваши дальние чувства (для людей это слух, зрение и обоняние) вне вашего тела – на расстояние до 10 ярдов. Вы можете изменить это расстояние покупкой соответствующих модификаторов (Увеличенная или Уменьшенная дистанция). Вы можете временно удвоить расстояние за 2 FP за минуту использования.
Для использования Дальновидения, вы выбираете желаемую точку зрения (она может находиться и внутри объекта), и ее направление, концентрируетесь в течение минуты, и делаете бросок IQ. Если вы не видите этой точки, вы указывате дистанцию и направление, а бросок делается с -5.
В случае успеха, вы можете использовать ваши удаленные чувства, как будто вы находитесь в этой точке (это значит, что вы не можете ощущать окружение вашего физического тела). Ваше зрение не подвергается штрафам за темноту. Вы не можете смотреть сквозь непрозрачные предметы, но если ваша точка зрения находится внутри (например) закрытого сундука, вы можете видеть, что в нем находится, несмотря на то, что там нет света. При использовании способностей, зависящих от расстояния (например, заклинаний), расстояние расчитывается от вашего физического тела. Вы можете поддерживать дальновидение сколько угодно времени.
При провале на 1, ваши чувства перемещены в другое место. При любом более серьезном провале способность просто не срабатывает. Критически провал лишает вас этой способности на 1d часов.

Для возвращения перемещенных чувств, перемещения и поворота их в другую сторону вам потребуется опять же сконцентрироваться в течение 1 секунды и сделать успешный бросок IQ. Точка зрения, расположенная внутри движущегося объекта, может двигаться вместе с ним без усилий с вашей стороны. Вы можете иметь только одну точку зрения одновременно – нельзя зрение поставить в одно место, слух в другое, и так далее.

===Новые особые улучшения===
Сохранение контроля (Aware): вы сохраняете контроль над своим телом, но можете концентрироваться только на чем-то одном. В начале каждого хода (в бою), вы должны сделать заявку: на чем вы сосредоточены в этот ход – на своем теле или удаленных чувствах. Концентрация для перемещения или поворота ваших удаленных чувств автоматически сосредотачивает вас на них, если вы не имеете Второй натуры (см. ниже). Все действия и задачи, зависящие от чувств, на которых вы в данный момент не сосредоточились, получают -4. +50%.

Проекция (Projection): вы смещаете не чувства, а сознание. Ваше тело лежит без сознания в этот момент, если вы не имеете Сохранения контроля. Ваша проекция уязвима только для заклинаний, Заклятий и ментальных способностей. Подробности – в выделенном блоке Проекция. Модификатор стоит 0%, если вы во время использования способности можете воздействовать только на нематериальный мир, и +140%, если вы можете влиять на мир материальный – заклинаниями и ментальными способностями. Если другие могут видеть вашу
проекцию, возьмите еще и модификатор Видимое (c.112).

Вторая натура (Second Nature): Вы настолько тренированы в использовании удаленных чувств, что можете активировать их свободным действием и пользоваться как обычным взглядом или слухом. Концентрация в течение минуты и бросок ИН-5 нужны только если новая точка зрения находится вне зоны видимости, и налагает обычные неприятные эффекты при провале. 
Это улучшение дешевле Быстрой подготовки, но применяется только к Дальновидению. +70%.

Слух (Clairaudience): Вы можете переместить только слух. -30%.

Зрение (ClairVoyance): Только зрение может перемещаться. -10%.
Обоняние (Clairosmia): Вы можете переместить только чувство обоняния. -60%.

ЭСВ (ESP): Ваша способность – часть псионической силы ЭСВ (с. B255). -10%.
Видимая (Visible): Ваши перемещенные чувства имеют видимое представление – например, висящее в воздухе лицо. -10%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Claustrophobia (Enclosed Spaces)</name>
	<name-loc>Боязнь замкнутых пространств (Клаустрофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Распространенная, но очень неудобная боязнь. Вам не по себе, если не видите неба - или, по крайней мере, очень высокого потолка. В маленькой комнате или в транспорте вы чувствуете, что на вас давят стены... вам не хватает воздуха! Это очень опасная боязнь для того, кто собирается спуститься под землю. -75 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Claws, Blunt (Feet)</name>
		<name-loc>Когти  (Тупые, ноги)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>3</base_points>
		<melee_weapon>
			<damage>thr:+1 cr</damage>
			<usage>Kick</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<reference>B42</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Blunt (Hands)</name>
		<name-loc>Когти  (Тупые, руки)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>3</base_points>
		<melee_weapon>
			<damage>thr-1:+1 cr</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B42</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Hooves</name>
		<name-loc>Когти  (Копыта)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>3</base_points>
		<melee_weapon>
			<damage>thr:+1 cr</damage>
			<usage>Trample</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<reference>B42</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<dr_bonus>
			<location>feet</location>
			<amount>1</amount>
		</dr_bonus>
	</advantage>
	<advantage version="2">
		<name>Claws, Long Talons (Feet)</name>
		<name-loc>Когти  (Очень) (Длинные, ноги)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>11</base_points>
		<melee_weapon>
			<damage>thr:+1 cut</damage>
			<usage>Slash</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr:+1 imp</damage>
			<usage>Stab</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<reference>B43</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Long Talons (Hands)</name>
		<name-loc>Когти  (Очень) (Длинные, руки)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>11</base_points>
		<melee_weapon>
			<damage>thr-1:+1 cut</damage>
			<usage>Slash</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1:+1 imp</damage>
			<usage>Stab</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B43</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Sharp (Feet)</name>
		<name-loc>Когти  (Острые, ноги)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>5</base_points>
		<melee_weapon>
			<damage>thr cut</damage>
			<usage>Kick</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<reference>B42</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Sharp (Hands)</name>
		<name-loc>Когти  (Острые, руки)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>5</base_points>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<usage>Slash</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B42</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Talons (Feet)</name>
		<name-loc>Когти  (Длинные, ноги)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>8</base_points>
		<melee_weapon>
			<damage>thr cut</damage>
			<usage>Trample</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<usage>Kick</usage>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<reference>B43</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Claws, Talons (Hands)</name>
		<name-loc>Когти  (Длинные, руки)</name-loc>
		<description-loc>У вас есть когти. Преимущество учитывает все конечности, скидки за когтистость только одной конечности нет. Существует несколько вариантов:

Тупые когти (Blunt claws): Подобные собачьим. Удары руками и ногами наносят +1 вреда на кубик – так, 2d-3 станут 2d-1 вреда. 3 очка.

Копыта (Hooves):  Твердые копыта, подобные лошадиным. Наносят +1 вреда за кубик при ударах ногами, и дают ступням DR 1. 3 очка.

Острые когти (Sharp Claws): Короткие, как у кошки. Удары ногами и руками с ними наносят не тупой, а режущий вред. 5 очков.

Длинные когти (Talons): До 12 дюймов длиной. Удар рукой или ногой наносит не тупой, а режущий или проникающий вред (выбирай перед любой атакой). 8 очков.
Очень длинные когти (Long Talons): Гигантские лезвия. Считаются как Длинные когти, но наносимые повреждения увеличиваются на +1 за кубик. 11 очков.</description-loc>
		<type>Physical</type>
		<base_points>8</base_points>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<usage>Slash</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<usage>Stab</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B43</reference>
		<notes>Для рук и для ног покупается отдельно</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Clerical Investment</name>
	<name-loc>Духовный сан</name-loc>
	<base_points>5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>1</amount>
		<limitation>Единоверцы</limitation>
	</attribute_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B43</reference>
	<description-loc>Вы были посвящены в духовный сан и стали священником какой-то религии. У клирика есть ряд возможностей и привилегий, недоступных мирянам, включающих +1 бонус на реакцию от всех персонажей, исповедающих или уважающих вашу религию. К вам будут обращаться по титулу - Отец, Сестра, Преподобный, Шаман - и вы можете выполнять такие церемонии, как конфирмация, женитьба и экзорцизм.
Помните, что не все священники добры и миролюбивы. Ака'Ар, высший жрец порочного Культа Сета, такой же законный священник для своих прихожан, как святой отец для своей церкви. Он также может совершать обряды бракосочетаний и даже может изгнать бесов не хуже христианского священника - он ведь наверняка гораздо больше знает о демонах.
Природа этого преимущества – чисто социальна. Она не дает никаких чудодейственных сил. Если вы хотите призывать помощь свыше, приобретайте Благословение (с.40), Дарованную силу (c.B77) или Истинную веру (с. B94).
Духовный сан включает Религиозный ранг 0 (с. B30). если вы хотите большего влияния в иерархии церкви – приобретайте дополнительные уровни.</description-loc>
</advantage>
	<advantage version="2">
	<name>Clinging</name>
	<name-loc>Прилипание</name-loc>
	<base_points>20</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Избирательность</name>
		<notes>@Распространенный материал@</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B43</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Избирательность</name>
		<notes>@Нераспространенный материал@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B43</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Избирательность</name>
		<notes>@Абсурдный материал@</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B43</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Attraction</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<reference>P45</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Requires Low Gravity</name>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>P45</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B43</reference>
	<description-loc>Вы можете ходить или карабкаться по стенам и потолку с половиной скорости. Персонаж может остановиться в любой момент без страха упасть. Бросков на Лазание вообще не требуется!

Если персонаж падает и пытается зацепиться за стену до удара о землю, мастер сначала должен определить, может ли он вообще достать до стены. Если стена в пределах досягаемости, необходим бросок DX для прикосновения к стене. Когда стена схвачена, нужно успешно выбросить ST с модификацией –1 за каждые 5 ярдов, которые уже пролетел. Если бросок ST провален, то вы падаете, но из высоты падения 5 ярдов вычитается за счет замедления скорости падения. Разница в гравитации влияет на эти броски. Так, в 0.5G вы получаете -1 к ST только за каждые 10 ярдов падения.

===Особые улучшения.===

Избирательное (Specific): Персонаж может цепляться только за один конкретный материал. –30% за обычные материалы как дерево, камень, кирпич, металл и –50% за редкие материалы – лед, резину и пр. -80% за абсурдные материалы (шоколад, например).

===Новое особое улучшение===

Притяжение (Attraction): Вы можете удерживаться на поверхности, используя любую часть вашего тела – вам больше не надо принимать положение для лазания. Вы можете ходить «стоя» по вертикальным поверхностям, освободив руки, или висеть на голове, используя конечности для других целей. +25%.

===Новое особое ограничение===
Необходима низкая гравитация (Requires Low Gravity): Ваша способность не действует в условиях нормальной гравитации. Скидка по -5% за каждые 0,1 G ниже стандартной, до максимума -50% при 0 G.(-5% за уровень).
</description-loc>
</advantage>
	<advantage version="2">
		<name>Clueless</name>
		<name-loc>Несообразительный
</name-loc>
		<description-loc>Вы абсолютно не понимаете шуток, объектом которых являетесь сами, и не чувствуете, когда вас соблазняют (+4 к сопротивлению Сексапильности). Смысл образных выражений от вас ускользает. Выше вашего разумения и тонкое обхождение, что дает вам -4 к умению Хорошие манеры. Ваши незначительные привычки (например, когда вы оставляете включенным поворотник всю дорогу от Чикаго до Альбукерке) раздражают других, и вы можете взять одну-две из них в качестве причуд. Большинство людей реагирует на вас с -2.
В отличие от обладателей недостатка Нет чувства юмора (B146), вы можете шутить - хотя и не смешно - и можете оценить грубые шутки или юмористические произведения. Но вы редко способны уловить шутку в разговоре, особенно если шутят над вами (чтобы понять, что объектом шутки стали вы, необходима проверка IQ-4). В отличие от обладателей Доверчивости (B137), вы вполне понимаете, когда кто-то пытается вас использовать, если это происходит не в общении. Вы подвержены Заговариванию зубов не более других, если только вас не пытаются убедить в том, будто привлекательный представитель противоположного пола в вас заинтересован...
Данный недостаток больше всего подходит для гениев не от мира сего, пришельцев с Марса и др.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B126</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="starts with">savoir-faire</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Code of Honor</name>
		<name-loc>Кодекс чести</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B163</reference>
		<notes>@Содержание@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Chivalry)</name>
		<name-loc>Кодекс чести
 (Рыцарский)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Gentleman's)</name>
		<name-loc>Кодекс чести
 (Джентльменский)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Pirate's)</name>
		<name-loc>Кодекс чести
 (Пиратский)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Professional)</name>
		<name-loc>Кодекс чести
 (Профессиональный)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Soldier's)</name>
		<name-loc>Кодекс чести
 (Солдатский)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Code of Honor (Theatrical)</name>
		<name-loc>Кодекс чести
 (Показной)</name-loc>
		<description-loc>Вы гордитесь набором принципов, которым следуете постоянно. На практике это может выражаться по-разному, но обычно требует некого "честного" поведения. Вы будете готовы практически на все - даже на смертельный риск - чтобы избежать "бесчестия" (в чем бы оно для вас ни заключалось).
Чтобы получать очки за Кодекс чести, вы должны не просто говорить о своих принципах. Вы обязаны быть истинным последователем этого Кодекса! Это недостаток, поскольку он часто требует опасного - если не безрассудного - поведения. Более того, вас часто могут загнать в невыгодную ситуацию, если враги знают о ваших принципах.
Кодекс чести - это не то же самое, что и Долг (B133) или Чувство долга (B153). Самурай или британский гренадер идет в бой с превосходящими силами врага из-за долга, а не из собственных соображений о чести (хотя бегство с поля боя может лишить их и чести). Риск, которому вы подвергаетесь по соображениям чести - это исключительно ваше дело.
Цена определенного Кодекса чести в очках зависит от того, какие проблемы он способен вам принести и от того, насколько произвольны и нерациональны его требования. Неформальный Кодекс, относящийся только к равным, стоит -5 очков. Формальный Кодекс, относящийся только к равным, стоит -10 очков. Формальный Кодекс, действующий все время или требующий совершить самоубийство в случае нарушения, стоит -15 очков. Последнее слово за мастером! Вот несколько примеров:


Кодекс чести (пиратский): Всегда мстить за обиды, независимо от грозящей опасности; считать врагов своего друга своими врагами; сражаться против члена своей же команды или своего товарища лишь в открытом и честном поединке. Все остальное делать можно. Этот кодекс подойдет также бандитам, байкерам и т.д. -5 очков.
Кодекс чести (профессиональный): Придерживаться своей профессиональной этики; всегда выполнять работу настолько хорошо, насколько возможно; поддерживать свою гильдию, союз или профессиональное объединение. Этот кодекс лучше всего подходит юристам и врачам (клятва Гиппократа), но честные купцы, торговцы и др. также могут придерживаться подобного Кодекса. -5 очков.
Кодекс чести (джентльменский): Никогда не нарушать слова. Никогда не спускать оскорбления, нанесенного себе, даме или своему флагу; обиду можно смыть только извинением или дуэлью (не обязательно смертельной!). Никогда не пользоваться каким-либо преимуществом перед соперником; оружие и условия сторон должны быть равными (исключение представляет война). Данный кодекс действует только среди джентльменов. Грубость со стороны кого-либо со Статусом 0 и ниже наказывается поркой, а не дуэлью! -10 очков.
Кодекс чести (солдатский): Офицер должен быть строг, но справедлив, быть на переднем краю и оберегать своих людей; солдат должен беречь своих товарищей и следить за своим снаряжением. Каждый солдат должен быть готов сражаться и с честью погибнуть за свое подразделение, свои войска и свою страну; выполнять приказы; следовать "законам военного времени"; относиться к честному противнику с уважением (бесчестный враг заслуживает пули); с гордостью носить свою форму. -10 очков.
Кодекс чести (рыцарский): То же, что и джентльменский Кодекс чести с тем исключением, что флаги пока не изобретены. Отвечать на любое оскорбление, нанесенное своему вассалу или вере. Защищать любую даму и любого, кто слабее. Принимать вызов на поединок от любого человека вашего статуса и выше. Даже в открытой войне силы и оружие должны быть одинаковы, если противник тоже знатен и благороден. -15 очков.

Вы можете взять Кодекс чести в качестве причуды. Например, вы можете настаивать на «джентльменском» поведении с женщинами, или наоборот, презрительно отвергать «мужской шовинизм».</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Coitophobia (Sex)</name>
	<name-loc>Боязнь секса (Коитофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы пугает мысль о сексуальных отношениях или о потере девственности. -10 очков*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Cold-Blooded</name>
		<name-loc>Холоднокровный
</name-loc>
		<description-loc>Температура вашего тела изменяется вместе с температурой окружающей среды. На вас меньше сказывается серьезное повышение или понижение температуры тела (+2 к проверкам HT при сопротивлении температурный эффектам), вам требуется лишь 1/3 еды, потребляемой теплокровными существами с такой же массой, но вы склонны "замерзать" в холодную погоду.
После 30 минут нахождения в холодной среде (или после часа, если у вас есть какая-либо Устойчивость к температуре) вы получаете -1 к Базовой скорости и DX за 10 градусов Фаренгейта [~5.5 градусов Цельсия - прим. пер.] ниже вашей "пороговой температуры" (см. ниже). При температуре ниже 32 градусов [0 градусов Цельсия], вы должны сделать проверку HT или получить повреждения в 1 HP. Теплая одежда дает +2 к этой проверке.
Вы восстанавливаете потерянную Базовую скорость и DX со скоростью одно очко в час, когда возвращаетесь в теплую среду. Удвойте эту скорость, если среда исключительно теплая.
Цена недостатка зависит от значения вашей "пороговой температуры":


Вы "замерзаете" при температуре ниже 50 градусов [~10 по Цельсию]: -5 очков.
Вы "замерзаете" при температуре ниже 65 градусов [~20 по Цельсию]: -10 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-5</base_points>
		<reference>B127</reference>
		<notes>Ниже 50-градусов</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Cold-Blooded</name>
		<name-loc>Холоднокровный
</name-loc>
		<description-loc>Температура вашего тела изменяется вместе с температурой окружающей среды. На вас меньше сказывается серьезное повышение или понижение температуры тела (+2 к проверкам HT при сопротивлении температурный эффектам), вам требуется лишь 1/3 еды, потребляемой теплокровными существами с такой же массой, но вы склонны "замерзать" в холодную погоду.
После 30 минут нахождения в холодной среде (или после часа, если у вас есть какая-либо Устойчивость к температуре) вы получаете -1 к Базовой скорости и DX за 10 градусов Фаренгейта [~5.5 градусов Цельсия - прим. пер.] ниже вашей "пороговой температуры" (см. ниже). При температуре ниже 32 градусов [0 градусов Цельсия], вы должны сделать проверку HT или получить повреждения в 1 HP. Теплая одежда дает +2 к этой проверке.
Вы восстанавливаете потерянную Базовую скорость и DX со скоростью одно очко в час, когда возвращаетесь в теплую среду. Удвойте эту скорость, если среда исключительно теплая.
Цена недостатка зависит от значения вашей "пороговой температуры":


Вы "замерзаете" при температуре ниже 50 градусов [~10 по Цельсию]: -5 очков.
Вы "замерзаете" при температуре ниже 65 градусов [~20 по Цельсию]: -10 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B127</reference>
		<notes>Ниже 65-градусов</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Colorblindness</name>
		<name-loc>Дальтонизм
</name-loc>
		<description-loc>Вы совершенно не способны различать цвета (это полный дальтонизм). В любой ситуации, где необходимо распознавать цвета (например, при покупке самоцветов, попытках распознать цветные знаки или нажать красную кнопку для запуска двигателя), мастеру следует создать вам соответствующие трудности. Определенные умения становятся для вас сложнее. В частности, вы получаете -1 к большинству проверок на Рисование, Химию, Вождение, Торговое дело, Пилотирование и умение Следопыт.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="contains">artist</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">chemistry</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">driving</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">merchant</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">piloting</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">tracking</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Combat Paralysis</name>
		<name-loc>Ступор в бою
</name-loc>
		<description-loc>Вы склонны внезапно "застывать" в бою, и получаете -2 ко всем Проверкам на испуг. Это совершенно не то же самое, что Трусость (B129) - вы может быть и храбры, но тело предает вас.
В любой ситуации, где вам грозят повреждения, сделайте проверку HT. Не делайте проверку до того момента, пока вам не придется сражаться, бежать, нажимать на курок или делать что-то еще. Любой результат выше 13 означает провал, даже если ваш показатель HT 14+. В случае успеха, вы способны действовать обычным образом. При неудаче вы ментально оглушены (см. Эффекты оглушения, B420). Делайте проверку HT каждую последующую секунду с накапливающимся бонусом +1 за ход, чтобы выйти из ступора. Пощечина от товарища даст еще +1 к вашей проверке.
Как только вы пришли в себя, вы больше не застынете, имея дело с текущей опасностью. После этого вы можете вновь впасть в ступор в следующей опасной ситуации.
Данный недостаток - противоположность Боевым рефлексам (B43). У вас не может быть обеих этих черт.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B127</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Combat Reflexes</name>
		<name-loc>Боевые рефлексы</name-loc>
		<description-loc>У вас экстраординарная реакция и вы быстро приходите в себя при неожиданном нападении. Вы получаете бонус +1 на любую Активную Защиту во время сражения. Также вы получаете бонус +1 на любое умение Быстрое выхватывание и +2 на броски страха (с. B360). Вы никогда не "замираете" при неожиданной ситуации, и получаете бонус +6 на все броски IQ чтобы прийти в себя после внезапной атаки или ментального «оглушения».
Кроме того, сторона, на которой вы деретесь, получает +1 на броски инициативы, чтобы избежать внезапной атаки, или +2, если вы лидер (см. инициатива и внезапные атаки, с. B393).
Это преимущество включено в Улучшенное восприятие времени (Enhanced Time Sense, c.B52), и не может быть взято одновременно с ним.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<reference>B43</reference>
		<notes>Никогда не "замираете" в неожиданной ситуации, +6 на все броски IQ прийти в себя после внезапной атаки или ментального «оглушения»; +1 инициативе (+2 если лидер)</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="starts with">fast-draw</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>fright check</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">Enhanced Time Sense</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Common Sense</name>
		<name-loc>Здравый смысл</name-loc>
		<description-loc>Каждый раз, когда вы делаете что-либо, что ГЛУПО по мнению мастера, он бросает проверку вашего IQ. Если бросок был для вас успешным, то он должен предупредить вас: "Ты хорошо об этом подумал?". Это преимущество позволяет импульсивному игроку отыгрывать разумного персонажа.

===Новое особое улучшение===
Сознательное (Conscious): Вы можете сами спрашивать мастера, какие действия он считает более умными. Мастер тайно бросает ваш ИН: чем лучше был бросок, тем лучше будет предложенный вариант. +50%
</description-loc>
		<type>Mental</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Concious</name>e&gt;
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P45</reference>
		</modifier>
		<reference>B43</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Compartmentalized Mind</name>
	<name-loc>Разделенное сознание</name-loc>
	<points_per_level>50</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Средства управления (Controls)</name>
		<cost type="points">-25</cost>
		<affects>base only</affects>
		<reference>B43</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализированные средства управления (Dedicated Controls)</name>
		<cost type="points">-40</cost>
		<affects>base only</affects>
		<reference>B43</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Massively Parallel</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>Sup26</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B43</reference>
	<description-loc>Ваша ментальная координация, по сути, дает вам еще один мозг. Каждый разум функционирует независимо и с полной силой. Ваши разумы идентичны, но магия, псионика и подобные вещи влияют на них отдельно (например, один разум может быть загипнотизирован, а другие будут действовать нормально).
Преимущество не дает вам способности выполнять больше одной задачи физически. Каждый уровень позволяет вам применить одновременно еще один ментальный маневр (обычно – один физический или ментальный). Например, РС 1 позволит вам выполнить один ментальный и физический маневр (концентрация на заклинании и атака), или два ментальных (концентрация на двух заклинаниях), но не больше одного физического – для этого необходимо брать Дополнительную атаку (с. B53).
Сознания могут пытаться взять тело под личный контроль (состязание по Воле(Will), текущее контролирующее сознание кидает с +1) и даже сражаться между собой – используя друг на друга ментальные способности (каждое из них использует полное значение вашего IQ, Воли(Will) и все ментальные способности).

Две специальных версии для техники, созданной на очки:

Управление (Control): каждый уровень дает вам один «пульт управления». Контроль позволяет оператору выполнять свои ментальные и физические действия, используя ваши способности (например, Природную атаку или Радар) – по правилам транспортного боя (с.467). В случае с техникой, имеющей IQ 0, оператор направляет все действия ее. Физические ограничения все равно применяются – например, невозможно использовать больше атак, чем на машине установлено готового оружия. Конфликт между операторами разрешается состязанием по навыку управления. 25 очков/уровень.
Выделенное управление (Dedicated Control):  Каждый «пульт» управляет только одной указанной задачей (бортовой стрелок, к примеру). Управляющий персонал не может управлять ничем другим. 10 очков/уровень</description-loc>
</advantage>
	<advantage version="2">
		<name>Compulsive Carousing</name>
		<name-loc>Вечеринки
</name-loc>
		<description-loc>Вы не можете отказаться от участия в вечеринке! Раз в день вы обязаны попасть туда, где много людей, и побездельничать там - попраздновать, выпить, попеть песни и пошутить - хотя бы в течение часа. Если вас не пригласили, вы явитесь без приглашения; если никакой вечеринки не намечается, вы постараетесь сами ее устроить. Деньги значения не имеют! Если они у вас есть, вы их потратите. Вы без особых размышлений готовы употребить почти любые стимуляторы, никогда не отказываетесь выпить в компании и мало разборчивы в выборе того, с кем из представителей противоположного пола проводить время. Вы получаете +1 к реакции от настроенных похожим образом экстравертов, но -1 и хуже от здравомыслящих граждан - даже -4 в мирах с пуританской моралью. -5 очков* (-10* очков в мирах с пуританской моралью).</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B128</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Compulsive Gambling</name>
		<name-loc>Азартные игры
</name-loc>
		<description-loc>Вы не упускаете возможности сыграть. Пари, ставки, рулетка и даже лотерея для вас необычайно притягательны. Если никто не принимает ставки и не играет в рулетку, то вы начнете делать это сами. Вы поучаствуете в любой предложенной азартной игре, не важно, знакомы вам правила или нет. Вам не обязательно владеть умением Азартные игры, но если его нет, то вам понадобится изрядный источник богатства! Если вам что-то мешает играть - например, вы путешествуете в компании, где не любят игры - то вы вскоре заработаете пенальти к реакции (-1 за каждые -5 очков цены недостатка, полученных после использования множителя), поскольку постоянно говорите об играх и пытаетесь соблазнить окружающих поиграть или заключить пари. -5 очков*.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B128</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Compulsive Generosity</name>
		<name-loc>Щедрость
</name-loc>
		<description-loc>Вы слишком щедры. Если нищий просит денег, то вы ему подадите - причем там, где другой обошелся бы медяком, дадите серебро. Вы всегда прислушиваетесь и к более серьезным просьбам помочь деньгами, даже если они трудновыполнимы, и вам следует сделать проверку на самоконтроль каждый раз, когда вы слышите убедительную историю о превратностях судьбы (если в этот момент вы без денег, то будете долго извиняться). Вы не полный простак - просто вы чувствуете вину за то, что вам лучше, чем другим. В обществе, где много нищих, увеличьте свои расходы на жизнь:

Показатель самоконтроля          6     9    12    15
Возрастание расходов на жизнь   20%   15%   10%   5%
	

Это может дать вам +1 к реакции от набожных людей; если вы сами бедны, то бонус к реакции может быть даже больше. Данная черта несовместима со Скупостью. -5 очков.*</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr adj="minor cost of living increase">12</cr>
		<reference>B128</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">miserliness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Compulsive Lying</name>
		<name-loc>Ложь
</name-loc>
		<description-loc>Вы постоянно лжете без какой-либо причины кроме удовольствия от процесса вранья. Вы наслаждаетесь выдумками о своих подвигах, происхождении и богатстве - обо всем том, что может произвести впечатление на слушателей. Даже если ваша ложь становится явной, вы упорно цепляетесь за свои выдумки, называя обвинителя лжецом и мерзавцем. Чтобы рассказать чистую, не приукрашенную правду, необходимо выполнить проверку на самоконтроль. Если она неудачна, то вы лжете - не имеет значения, насколько тяжелыми будут последствия. Когда вы делаете проверку, чтобы сказать правду своим товарищам по партии, то бросайте кубики незаметно для других игроков. Таким образом, они никогда не смогут быть уверены, что получают точную информацию. -15 очков.*</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B128</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Compulsive Spending</name>
	<name-loc>Расточительство
</name-loc>
	<base_points>-5</base_points>
	<cr adj="major cost of living increase">12</cr>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">miserliness</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B129</reference>
	<description-loc>Ваши деньги просачиваются сквозь пальцы! Вам нравится слыть транжиром, вы слишком любите роскошь или обожаете сам факт покупки - а может и все одновременно. Делайте проверку на самоконтроль каждый раз, когда вам предлагается купить что-то, что связано с любой вашей причудой или интересом, а денег в кармане минимум в два раза больше, чем стоит покупка. В случае неудачи, вы покупаете данный товар. Это увеличивает ваши расходы на жизнь и дает пенальти к умению Торговое дело, когда вы торгуетесь или сбиваете цену:

!Показатель самоконтроля|Возрастание расходов на жизнь|Пенальти к умению Торговое дело
|6| 80%| -4
|9| 40%|	-3
|12|	20%| -2
|15|	10%| -1
	
Расточительство не определяется богатством! Бедный фермер может быть расточителем. Данная особенность несовместима со Скупостью (это ее противоположность!), но вы можете сочетать ее с Жадностью. -5 очков.*</description-loc>
</advantage>
	<advantage version="2">
		<name>Compulsive Vowing</name>
		<name-loc>Клятвы
</name-loc>
		<description-loc>Вы никогда не решаете просто что-то сделать; вам необходимо поклясться это исполнить. Хотя подобные клятвы обычно по своей природе незначительны, вы подходите к ним со всей серьезностью и преданностью. Вы можете добавлять такие клятвы к формальным клятвам. -5 очков.*</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Confused</name>
		<name-loc>Заторможенный
</name-loc>
		<description-loc>Чаще всего мир кажется вам странным и непонятным местом. Вы не обязательно глупы, но вы медленно осознаете факты и понимаете ситуации.
В частности, вы плохо реагируете, когда вокруг происходит слишком много всего. Когда вы один, в тишине и покое, то действуете нормально. Но в незнакомом месте или в суматохе вам следует выполнить проверку на самоконтроль. В случае неудачи вы застываете вместо того, чтобы действовать решительно или так как нужно. Обычно это мешает вам выполнять проверки на Тактику и участвовать в иного рода долгосрочном планировании. Мастер может добавлять модификаторы к проверке на самоконтроль в зависимости от сил, действующих в данной области. Чтобы не быть сбитым с толку, когда двое ваших друзей тихо болтают в знакомой вам комнате, понадобится обычная проверка, в ночном клубе, мерцающем огнями и наполненном музыкой, вы получите -5, а посреди крупного восстания или битвы получите -10!
Если этот недостаток срабатывает в бою, вы должны каждый ход выбирать маневр Бездействие. Вы не оглушены, и если конкретно вас атакуют, то можете нормально защищаться. Вы даже можете атаковать именно этого противника в ответ. Но вы никогда не действуете - вы просто отвечаете.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Congenial</name>
		<name-loc>Компанейский</name-loc>
		<description-loc>
Мягкая версия Общительного (B126). Вы любите компанию и хорошо работаете в команде. Вы всегда предпочитаете действовать в группе, а не в одиночку.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Constriction Attack</name>
		<name-loc>Атака сдавлением</name-loc>
		<description-loc>Вы способны сжимать врага – как гигантский медведь или змея. SM противника не может превышать вашего. Сначала требуется успешно схватить его, и на следующий ход вы делаете состязание по вашей ST против ST или НТ (что выше) врага. При вашей победе враг получает вред, равный значению победы. При провале вы не наносите вреда.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Engulfing</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>P45</reference>
		</modifier>
		<reference>B43</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Contact (@Who@)</name>
	<name-loc>Контакты, группа контактов  (@Кто@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уровень умения</name>
		<notes>12</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уровень умения</name>
		<notes>15</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уровень умения</name>
		<notes>18</notes>
		<cost type="points">3</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уровень умения</name>
		<notes>21</notes>
		<cost type="points">4</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Может получать информацию используя сверхестественные способности</name>
		<cost type="points">1</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Группа</name>
		<cost type="multiplier">5</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется почти всега</name>
		<notes>15-</notes>
		<cost type="multiplier">3</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется часто</name>
		<notes>12-</notes>
		<cost type="multiplier">2</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется переодически</name>
		<notes>9-</notes>
		<cost type="multiplier">1</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется редко</name>
		<notes>6-</notes>
		<cost type="multiplier">0.5</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Полностью надежный</name>
		<cost type="multiplier">3</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Обычно надежный</name>
		<cost type="multiplier">2</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Не всегда надежный</name>
		<cost type="multiplier">1</cost>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Ненадежный</name>
		<cost type="multiplier">0.5</cost>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Одноразовая услуга - Благосклонность (Favor)</name>
		<cost type="multiplier">0.2</cost>
		<reference>B55</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B44</reference>
	<description-loc>Контакт – это неигровой персонаж вроде Союзника или Покровителя. Однако Контакт лишь предоставляет информацию или может оказать быструю, недорогую, неопасную помощь. 
Цена Контакта зависит от типа информации и его эффективного умения, и изменяется в зависимости от частоты, с которой он может предоставлять информацию, и надежности сведений. 
Эффективный навык контакта.
Сначала определяется тип контакта. Им может быть кто угодно – от нищего из трущоб до главы государства, в зависимости от происхождения персонажа. Контакт имеет доступ к информации, он уже знаком с персонажем и находится с ним по большей части в хороших отношениях. (Конечно, предложить оплату в виде денег или помощи никогда не плохо. Контакт всегда отыгрывается и контролируется мастером, и любая запрошенная им оплата устанавливается мастером.)
Затем устанавливается полезный рабочий навык контакта. Этот навык должен совпадать с происхождением Контакта (Знание улиц для мелкого преступника, Судебная экспертиза для эксперта-криминалиста и т.д.) Контакта. Поскольку Мастер кидает шансы найти информацию против этого навыка, вы должны выбрать навык, который может предоставить нужную информацию – если вам нужна баллистическая экспертиза, свяжитесь с криминалистами, а не с банкирами! В любом случае, Контакт может предоставить только ту информацию, которая касается его компетенции. Эксперт из лаборатории судебной экспертизы наверняка не обладает информацией о валютных переводах, а вице-президент местного банка наверное не сможет провести баллистическую экспертизу.
Следующий шаг – определение эффективного навыка. Он отражает связи Контакта, его положение, прочие навыки и т.д. Обратите внимание, что эффективное умение это не обязательно действительное умение NPC; действительное умение определяется мастером, если неигровой персонаж принимает участие в обычной игре. Например, хозяин местного сталелитейного завода в действительности обладает умениями, связанными с бизнесом, на уровне 16-18, но его эффективное умение равняется 21, что увеличивает его цену еще на 4 очка, потому что он сам располагает неплохими связями!
Уровень навыка определяет базовую стоимость Контакта.
!Эффективный навык контакта|Цена
|	12|	1
|	15|	2
|	18|	3
|	21|	4
	Эта стоимость увеличивается на 1, если контакт добывает информацию с помощью сверхъестественных способностей (ЭСВ (ESP), прорицания и т.д.). Этот вариант обычен для магов и духов.
Частота помощи
Частота означает вероятность того, что Контакт будет найден, когда это нужно. Стоимость модифицируется соответственно таблице Частоты появления (с. B36): 
Если во время приключения игровой персонаж хочет поговорить с Контактом, мастер бросает против указанного числа для этого Контакта. Неудачный бросок означает, что Контакт занят и с ним невозможно связаться в этот день. Если Контакт доступен, то мастер делает проверку против эффективного умения Контакта при попытке персонажа выяснить у него ответ на каждый серьезный вопрос. 
Если игровой персонаж терпит критическую неудачу при попытке связаться с Контактом, то этот Контакт будет недоступен в течение всего приключения.
Ни с одним Контактом нельзя связаться более чем один раз в день, даже если несколько игровых персонажей располагают одним и тем же Контактом. Если персонажу нужно выяснить несколько вопросов, он должен помнить их все при первой встрече с Контактом. Контакт ответит на первый вопрос, используя полный уровень в умении, а на каждый последующий – с кумулятивным пенальти –2. Не злоупотребляйте своими Контактами!
Контакт не может предоставить никакой информации вне своей компетенции. Используйте здравый смысл. Также мастер не должен позволять Контакту предоставить информацию, которая помешает приключению в целом или его части!
Во время создания персонажа, игрок должен определить обычный способ связи с Контактом! Независимо от выбранной частоты, с Контактом нельзя связаться, если игровой персонаж явно не может с ним поговорить. 
Надежность информации
Контакты не обязательно знают что-нибудь полезное и не обязательно будут честны. Используйте следующие модификаторы (они объединяются с модификаторами частоты). 
* Полностью надежный: Даже при критической неудаче самым худшим ответом будет «Я не знаю». При обычной неудаче он может получить информацию за 1d дней. Утроенная цена.
* Достаточно надежный: При критической неудаче Контакт солжет; при любой другой неудаче он «сейчас не в курсе, так что приходи через 1d дней». Тогда сделайте бросок; неудача означает, что он ничего не нашел. Удвоенная цена.
* Несколько надежный: При неудаче Контакт ничего не знает и не сможет узнать; при критической неудаче он солжет; при выпадении на кубиках 18 он даст знать противнику или властям (что подходит) о том, кто спрашивал. Указанная цена.
* Ненадежный: Уменьшите эффективное умение на 2. При любой неудаче он солжет; при критической неудаче он оповестит противника. Цена меньше в два раза (округлять вверх; минимальная цена всегда 1).
Предложение денег
Взятка, будь то наличные или помощь, стимулирует Контакт и повышает уровень надежности. Когда надежность достигает уровня «достаточно надежный», в дальнейшем повышается эффективное умение; взятка не может сделать кого угодно полностью надежным!
Взятка деньгами должна составлять примерно доход за один день, чтобы дать +1 бонус, доход за неделю для +2, доход за месяц для +3 и доход за год для +4. Помощь должна быть эквивалентной по стоимости. Помощь должна быть чем-то, что персонаж действительно делает в игре. Мастер должен поддерживать соответствующий отыгрыш – дипломат может быть оскорблен денежной взяткой, но будет рад, если его представят правильным людям. Преступник может попросить денег, но согласится принять помощь, которая создаст игровым персонажам проблемы. Следователь из полиции или богатый бизнесмен может просто сказать партии в будущем не забывать про «должок»... который может привести их к новому приключению когда-нибудь в дальнейшем.
Контакты в игре
Контакт не обязательно должен быть создан при начальной разработке игрового персонажа. Контакт может быть добавлен позднее. Если необходимо, мастер может превратить уже существующего неигрового персонажа в Контакт для одного или более игроков, возможно вместо очков персонажа за приключение, в котором появился и был встречен Контакт. Например, наградой за приключение, в котором партия помогла раскрыть ограбление банка, может стать осведомленный и надежный контакт в полиции, доступный всей партии. Он стоит 18 очков – больше чем любой из персонажей заработал за приключение, но это справедливая награда для всей группы.
Тип информации
Полный список всех возможных контактов и их навыков может занять всю книгу. Вот лишь некоторые:
Уличные контакты: Это мелкие преступники, беспризорники, уличные головорезы, члены банды, скупщики краденого и другие NPC, обладающие знанием улиц, которые предоставляют информацию о незаконной деятельности, слухи о местных преступниках, о запланированных преступлениях и так далее. Базовая эффективный навык составляет 12 для Контактов «без связей» (не входящих в местную криминальную структуру) и 15 для Контактов «со связями». Навык 18 будет иметь главарь банды или другой подобный могущественный преступник. Если Контакт занимает важное место в преступной организации (дон, глава клана или «посвященный» член Семьи), то его эффективный навык будет равен 21.
Деловые контакты: Администраторы, бизнесмены, секретари – даже мальчик на посылках – могут предоставить информацию о бизнесе и финансовых сделках. Базовая цена зависит от компетенции контакта: мальчик на побегушках или машинистка (эффективное умение 12), секретарь директора – эффективное умение 15, бухгалтер – навык 18, а директор компании или председатель правления - эффективное умение 21.
Полицейские контакты: Они включают любого, кто связан с охраной правопорядка и расследованием преступлений: патрульный полицейский, корпоративный охранник, правительственный агент, судебный эксперт, коронер и т.д. Цена зависит от доступа к информации или услугам. Обычные навыки – Криминология, Право, Анализ разведданных, Судебная экспертиза, и т.д. Офицер патруля или обычный частный охранник имеет эффективное умение 12; детектив, федеральный агент или клерк из регистратуры – 15: руководитель (лейтенант, капитан, специальный агент на задании, глава службы безопасности и т.д.) - 18, а высокопоставленный офицер (шериф, начальник полиции, глава районной полиции, шеф безопасности и т.д.) – эффективное умение 21.

Военные контакты: Начиная от простого пехотинца – до генерала! Такой контакт может предоставить информацию о передвижении частей, подробности о секретном оружии или засекреченных тактических приемах, или стратегии высшего уровня. Это может принимать форму Хороших манер (армия), Стратегии, Тактики и, возможно, технических навыков наподобие Инженерии. Солдат ранга 0 будет иметь навык 12, Ранга 1 – 15, офицер с рангом 3-5 обладает эффективным навыком 18, а старшие офицеры с рангом 6 и больше – навыком 21.
Группа контактов (Contact Group): У вас есть сеть контактов в организации или слое общества. Вы должны указать определенную организацию одного определенного города (корпорацию, преступный синдикат, военную часть, полицейское управление, торговцы, высший свет и т.д.). Более широкая сеть контактов (выходящая за пределы города) недоступна.
Работа с группой контактов почти не отличается от работы с одним. Отличие только в том, что эффективный навык группы отражает целую категорию навыков (бизнес-навыки, военные навыки и пр.) – в соответствии с организацией. Создается группа контактов точно так же, как и один контакт, и категория навыков определяется при создании.
Бросок на успешность запроса отражает абстрактную помощь. Например, Группа Контактов в полиции может помочь с досье на преступников, баллистической экспертизой, юридической справкой, полицейскими картотеками, криминальной обстановкой и связями. Она не использует соответствующих навыков по-настоящему, но полученная от нее информация может подходить под любой из них.
Для определения стоимости Группы контактов, она создается как обычный отдельный контакт, и стоимость умножается на 5.</description-loc>
</advantage>
	<advantage version="2">
	<name>Cowardice</name>
	<name-loc>Трусость
</name-loc>
	<base_points>-10</base_points>
	<cr adj="fright check penalty">12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B129</reference>
	<description-loc>Вас очень беспокоит собственное физическое здоровье. Каждый раз, когда от вас требуется подвергать себя физической опасности, необходима проверка на самоконтроль. Проверка делается с -5, если вам грозит смерть. В случае неудачи вы отказываетесь подвергаться опасности, если только при этом вам не будет угрожать еще большая опасность!
Трусость дает пенальти к Проверкам на испуг, если имеет место физическая опасность:


!Показатель самоконтроля|Пенальти к Проверкам на испуг
|	6|	-4
|	9|	-3
|	12|	-2
|	15|	-1
	

В некоторых местах и эпохах, при общении с солдатами, полицией и т.д. на вас реагируют с тем же пенальти, если станет известно, что вы трус.</description-loc>
</advantage>
	<advantage version="2">
		<name>Cultural Adaptability</name>
		<name-loc>Культурная приспособляемость</name-loc>
		<description-loc>Вы знакомы с широким спектром культур. Имея дело с чужими культурами, вы не получаете штрафа -3 за незнание культуры. Это определенно киношная (cinematic) способность! Существует два варианта.

Адаптация (cultural Adaptability): Вы знакомы со всеми культурами вашей расы. 10 очков.
Ксено-адаптация (Xeno-adaptability): вы знакомы со всеми культурами игрового мира, независимо от расы. 20 очков.</description-loc>
		<type>Mental</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Ксено-адаптация (Xeno)</name>
			<cost type="points">10</cost>
			<affects>total</affects>
		</modifier>
		<reference>B46</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Cultural Familiarity (@Culture@)</name>
		<name-loc>Знание культуры  (@Культура@)</name-loc>
		<description-loc>Вы знакомы с культурами помимо собственной и не получаете пенальти -3 за неосведомленность. Это стоит 1 очко за культуру вашей (или очень похожей) расы или 2 очка за культуру другой расы.
Чтобы избежать нехватки очков, мастеру следует использовать широкое определение того, что есть культура: восточно-азиатская, мусульманская, западная и т.д. Отдельному народу нужно очень выделяться, чтобы Знание его культуры было отдельным преимуществом. В фентези мирах по желанию мастера  у каждой расы может быть одна культура; в футуристических сеттингах целая планета или даже галактическая империя может обладать единой цельной культурой.
Дополнительно см. преимущество Культурная приспособляемость (B46).</description-loc>
		<type>Mental</type>
		<base_points>1</base_points>
		<modifier version="1" enabled="no">
			<name>Чуждая</name>
			<cost type="points">1</cost>
			<affects>total</affects>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Похожая</name>
			<cost type="points">-1</cost>
			<affects>total</affects>
		</modifier>
		<reference>B23</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Curious</name>
		<name-loc>Любопытство
</name-loc>
		<description-loc>Вы от природы очень любознательны. Это не то любопытство, которое свойственно всем PC ("Что в той пещере? Откуда берутся летающие тарелки?"), а то, которое касается реальных вещей ("Что будет, если нажать эту кнопку?").
При встрече с интересным предметом или ситуацией выполните проверку на самоконтроль. В случае неудачи вы посмотрите поближе - нажмете кнопку, дернете рычаг, откроете дверь, развернете подарок и т.д. - даже если знаете, что это может быть опасно. Хорошие игроки не станут прибегать к этой проверке слишком часто...
В целом же, вы сделаете все что в ваших силах, чтобы исследовать любую ситуацию, которая вам не знакома на все 100%. При встрече с настоящей тайной вы просто не можете отвернуться от нее. Вы пытаетесь разумно обосновать свое любопытство, если остальные пытаются вас отговорить. Здравый смысл здесь не помогает - вы знаете, что это рискованно, но все равно вам любопытно!</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Cursed</name>
		<name-loc>Проклятый
</name-loc>
		<description-loc>То же, что и Невезение, но хуже. Когда что-то плохое происходит с партией, то в первую очередь и самым худшим образом это обрушивается на вас. Если что-то идет хорошо, то это проходит мимо вас. Каждый раз, когда мастеру захочется вас пнуть, он может это сделать, и вам придется с этим смириться, потому что вы Прокляты. Вы не можете выкупить данный недостаток, просто выплатив очки - придется установить, кто вас проклял, разобраться с этим проклятием и лишь потом потратить очки.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>-75</base_points>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Cybernetics</name>
	<name-loc>Кибернетика</name-loc>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B46</reference>
	<description-loc>Считайте большинство кибернетических имплантов эквивалентом преимуществ: Инфразрение для бионического глаза, Сопротивление повреждениям для кожной брони и т.д. Некоторые импланты могут подпадать под ограничение Временный недостаток (с.115); подходящими вариантами являются Электрический (с.134) и Требует обслуживания (с.143). Они применяются к импланту, а не к вашим общим способностям.

</description-loc>
</advantage>
	<advantage version="2">
	<name>Cynophobia (Dogs)</name>
	<name-loc>Боязнь собак (Кинофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Эта боязнь включает всех собачьих лис, волков, койотов, диких собак и т.п. -5 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Damage Resistance</name>
	<name-loc>Сопротивление вреду</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<dr_bonus>
		<location>full body</location>
		<amount level_mod="yes">1</amount>
	</dr_bonus>
	<modifier version="1" enabled="no">
		<name>Силовое поле (Force Field)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Укрепленный (Hardened)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Поглощение (Absorption)</name>
		<notes>Улучшает @черта@</notes>
		<cost type="percentage">80</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Поглощение (Absorption)</name>
		<notes>Только лечение</notes>
		<cost type="percentage">80</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Поглощение (Absorption)</name>
		<notes>Улучшить любую черту</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Отражение (Reflection)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Bane</name>
		<notes>@Rare@</notes>
		<cost type="points">-1</cost>
		<affects>total</affects>
		<reference>H14</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Bane</name>
		<notes>@Occasional@</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>H14</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Bane</name>
		<notes>@Common@</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>H14</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Bane</name>
		<notes>@Very Common@</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>H14</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Направленое (Directional)</name>
		<notes>Спереди</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Направленое (Directional)</name>
		<notes>@Направление: сзади, справа, слева, сверху или снизу@</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Гибкая (Flexible)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Полуразрушающаяся (SemiAblative)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невозможность одевать броню (Can’t Wear Armor)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Прочная кожа (Tough Skin)</name>
		<notes>Эффекты требующие контакта с кожей или царапины игнорируют этот DR</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Разрушающаяся (Ablative)</name>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B47</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченная (Limited)</name>
		<notes>@Повсеместный частый тип атаки@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченная (Limited)</name>
		<notes>@Распространенный тип атаки@</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченная (Limited)</name>
		<notes>@Частый тип атаки@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченная (Limited)</name>
		<notes>@Редкий тип атаки@</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B46</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B47</reference>
	<description-loc>Ваше тело защищено от атак, имея свой собственный DR. Это значение вычитается из любого физического или энергетического вреда после вычета DR искусственной брони (если вы не возьмете особое ограничение, то вы можете одевать броню поверх своей природной), но до применения модификаторов вреда за тип повреждения. DR не защищает ваши глаза (или стекла, если вы машина), и не помогает от чисто ментальных атак.

Обычные люди вообще не могут приобретать DR. Создания с природной броней обычно могут покупать до 5 уровней (тонкая шкура дает DR 1, свиная – 2, носорог – 3, слон или аллигатор  - 4, гигантская черепаха – 5). Роботы, супер-герои, сверхъестественные существа могут брать любое количество уровней DR. 

===Особые улучшения.===

Поглощение (Absorption): Вы можете поглощать вред и использовать его для увеличения ваших способностей. Каждое остановленное очко дает вам 1 временное очко персонажа. Вы можете накопить столько очков, сколько у вас всего уровней поглощающего DR, после чего поглощающая броня будет работать как обычная. Поглощенные очки теряются по 1 в секунду (сначала неиспользованные); усиленные способности теряются сразу, как испарятся поглощенные очки. Исключение: вы можете исцелять себя (2 очко за НР, 3 за FP), и это не потеряется (потеряются только НР и FP, поднятые выше максимума). +80%, если поглощенные очки могут использоваться только для одной черты или только лечения; +100%, если вы можете улучшаять любые черты.

Силовое поле (Force Field): Ваша защита – силовое поле вблизи тела. Она защищает все ваше тело, включая глаза и всю вашу ношу. DR силового поля применяется до учета носимой брони. Эффекты, основанные на касании воздействуют на вас только если нанесли достаточно вреда, чтобы пробить броню. +20%.

Уплотненная (Hardened): Каждый уровень уплотнения уменьшает делитель брони атаки на один уровень (Игнорирование DR, 100, 10, 5, 3, 2, 1 (нет делителя). +20% за уровень.

Отражение (Reflection): ваша броня отбрасывает остановленный ею вред назад. Первая отраженная атака не позволяет атакующему активной защиты. Влияет только на прямые удары! Не отражает взрывы, осколки, ядовитый газ и прочее – помогает только как обычный DR. Взаимоисключающий модификатор с Поглощением. +100%.

===Особые ограничения.===

Разрушающаяся (Ablative): Ваша защита останавливает удары только один раз, и затем разрушается. Каждое очко DR останавливает 1 очко вреда, и уничтожается. Потерянные очки DR восстанавливаются как и хиты (Регенерация (с. B80) помогает). Так можно представить сверхвыносливого супер-героя, которому не хватает массы тела, чтобы приобрести достаточное количество дополнительных НР. -80%.

Невозможность одевать броню (Can’t Wear Armor): Ваше тело имеет такую форму, что вы не можете одевать одежду или броню. -40%.

Определенное направление (Directional): DR защищает только от вреда с одного направления: -20% за фронт, -40% за все остальные направления (тыл, верх, них, слева, справа). Гуманоидам позволено выбирать только фронт и тыл. 

Гибкая (Flexible): Ваша броня не жесткая, и это делает вас уязвимым к тупым травмам (с. B379). -20%.

Ограниченная (Limited): Ваша броня защищает только от одной формы атак (см. выделенный блок на с. B46).

Частичная (Partial): Броня защищает только определенную часть тела. Цена -10% за каждый -1 штрафа к попаданию по этой части тела. «Торс» равен -10%, и защищает жизненные органы. Защита только одной руки удваивает ограничение цены (рука имеет -2 на попадание, одна рука -40%): В случае с варьирующимся штрафом на попадание, для расчета модификатора используется менее серьезный.

Полуразрушающаяся (Semi-ablative): Когда атака попадает по такой броне, каждые 10 очков базового вреда разрушают одно очко DR, независимо от того, пробила атака броню или нет. Потерянные очки DR восстанавливаются так же, как и хиты (регенерация помогает). -20%.
Прочная кожа (Tough Skin): Обычно DR означает жесткую броню (хитин, доспех). Это ограничение – просто толстая кожа. Любой эффект, требующий царапины (яды) или касания (электрический разряд или Смертельные удары) воздействует на вас, даже если вашей природной брони достигло значение 0 вреда. Ваша природная защита не помогает от такого вреда, будучи живой тканью вашего организма! Этот эффект включает эффект ограничения Гибкая (см.выше), и вы не можете взять их одновременно. Несовместимо с силовым полем. -40%.
Послойная защита.
Вы можете иметь несколько слоев брони, каждый со своей комбинацией модификаторов. Во время создания вы должны указать порядок расположения слоев брони, и не сможете изменить их в дальнейшем!</description-loc>
</advantage>
	<advantage version="2">
		<name>Danger Sense</name>
		<name-loc>Предчувствие опасности</name-loc>
		<description-loc>Вы не можете всегда на это рассчитывать, но иногда вы ощущаете, что что-то не так.
Если у вас есть это преимущество, то мастер секретно бросает проверку вашего Восприятия(Per) во всех ситуациях, связанных с засадой, надвигающейся бедой или чем-то в этом духе. Успешный бросок означает, что вы почувствовали, что происходит что-то не то. Бросок 3 или 4 позволяет вам узнать немного деталей о природе опасности.
Это преимущество включено в Предвидение (с. B77). Если вы имеете последнее, вы не можете взять Предчувствие опасности.

===Особые ограничения.===
ЭСВ (ESP): Ваша способность – часть вашей псионической силы ЭСВ. -10%.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<reference>B47</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Daredevil</name>
		<name-loc>Рисковый</name-loc>
		<description-loc>Удача улыбается вам, когда вы рискуете: в любой момент, когда вы сами себя подвергаете ненужному риску (на усмотрение мастера) вы получаете +1 на все броски и можете перебросить любой критический провал.
Например, банда убийц стреляет по вам из автоматов. Если вы пригибаетесь за стенкой и стреляете из-за укрытия, вы не получаете премий. Если вы выскакиваете и с воплями несетесь на них, вы получаете все выгоды.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<reference>B47</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Dark Vision</name>
	<name-loc>Зрение в темноте</name-loc>
	<base_points>25</base_points>
	<modifier version="1" enabled="no">
		<name>Может видеть цвета в темноте</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Hypersensory</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>P46</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B47</reference>
	<description-loc>Вы можете видеть в абсолютной темноте каким-то способом без света, радара или гидролокации. Вы не получаете штрафов за темноту, независимо от ее происхождения. Вы не можете различать цвета, когда нет света.

===Особые улучшения.===
Различение цветов (Color Vision): Вы также различаете и цвета. +20%.

===Новое особое улучшение===
Гиперсенсорное (Hypersensory): вы воспринимаете окружающий мир в комплексе, получая информацию от всех ваших чувств одновременно – зрения, слуха,осязания (разницы температур,вибрации и даже восприятия электрических полей) – и замечаете все от практически невидимых огней, до течения химических реакций, статических разрядов и космических лучей. Вы видите все это не по отдельности, но в комплексе, что позволяет вам видеть в абсолютной темноте как при обычном освещении и даже замечать невидимых врагов! Каждое потерянное чувство дает вам -2 на броски Зрения (однако, этот штраф не может стать значительнее текущего штрафа за темноту).
Вы полностью слепы только в том случае, если теряете все чувства. Однако, ваши чувства ограничены обычным полем зрения для человека, если у вас нет преимуществ, модифицирующих его.
+40%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Deafness</name>
		<name-loc>Глухота
</name-loc>
		<description-loc>Вы совсем не способны слышать. Вам придется получать информацию в письменной форме (если вы грамотны) или с помощью языка символов. Однако все время, потраченное вами на подобное общение, считается полностью потраченным на обучение используемым умениям (Язык жестов, Чтение по губам и т.д.); см. Главу 9.</description-loc>
		<type>Physical</type>
		<base_points>-20</base_points>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Debt</name>
		<name-loc>Долги</name-loc>
		<description-loc>Вы обязаны выплачивать деньги. Этот недостаток может отражать кредит, налоговую задолженность, пособие на детей или алименты... или "плату за молчание" шантажистам... или плату за "защиту" гангстерам. Ежемесячно вы должны выплачивать по 1% начального богатства (сумма зависит от уровня богатства) за уровень данной особенности, вплоть до максимума в 20%. Долги могут присутствовать у любого, чье богатство выше уровня Нищий; многие мультимиллионеры вынуждены выплачивать значительные суммы денег!
Месячный размер выплаты вычитается из вашего месячного заработка на работе. Если ваша работа не может покрыть Долги, то приходится платить из имеющихся сбережений, устраиваться на вторую работу или воровать.
Если вы не можете заплатить - или не хотите платить - то вас ждут неприятности. В случае с банковским кредитом это значит, что будут изымать ваше имущество. При неуплате алиментов, пособия на детей, штрафа или налогов это приведет к суду. Если вы задолжали бандитам, то можете быть втянуты в противозаконную деятельности... или оказаться под дулом ружья. Мастеру следует проявить изобретательность!
Предполагается, что вы не можете легко отделаться от этих обязательств. Чтобы избавиться от Долгов, нужны не просто деньги - вы должны выплатить очки и придумать вместе с мастером логичное объяснение произошедшему в игре.</description-loc>
		<type>Social</type>
		<levels>1</levels>
		<points_per_level>-1</points_per_level>
		<reference>B26</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
    <advantage version="2">
        <name>Decreased Basic Move</name>
        <name-loc>Пониженное перемещение</name-loc>
        <description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
        <type>Physical</type>
        <levels>1</levels>
        <points_per_level>-5</points_per_level>
        <reference>B17</reference>
        <categories>
            <category>Disadvantage</category>
            <category>Attribute</category>
        </categories>
        <attribute_bonus>
            <attribute>move</attribute>
            <amount per_level="yes">-1</amount>
        </attribute_bonus>
    </advantage>
    <advantage version="2">
        <name>Decreased Basic Speed</name>
        <name-loc>Пониженная скорость</name-loc>
        <description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
        <type>Physical</type>
        <levels>1</levels>
        <points_per_level>-5</points_per_level>
        <reference>B17</reference>
        <categories>
            <category>Disadvantage</category>
            <category>Attribute</category>
        </categories>
        <attribute_bonus>
            <attribute>speed</attribute>
            <amount per_level="yes">-0.25</amount>
        </attribute_bonus>
    </advantage>
	<advantage version="2">
		<name>Decreased Dexterity</name>
		<name-loc>Пониженная ловкость</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-20</points_per_level>
		<reference>B15</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>dx</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Decreased Health</name>
		<name-loc>Пониженое здоровье</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-10</points_per_level>
		<reference>B14</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>ht</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Decreased Intelligence</name>
		<name-loc>Пониженный интеллект</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>-20</points_per_level>
		<reference>B15</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>iq</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Decreased Perception</name>
		<name-loc>Пониженное восприятие</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental/Physical</type>
		<levels>1</levels>
		<points_per_level>-5</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>perception</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Decreased Strength</name>
		<name-loc>Пониженая сила</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-10</points_per_level>
		<reference>B14</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>st</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
    <advantage version="2">
        <name>Decreased Size</name>
        <name-loc>Пониженный Размер</name-loc>
        <description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
        <type>Physical</type>
        <levels>1</levels>
        <points_per_level>0</points_per_level>
        <reference>B19</reference>
        <categories>
            <category>Attribute</category>
        </categories>
        <attribute_bonus>
            <attribute>sm</attribute>
            <amount per_level="yes">-1</amount>
        </attribute_bonus>
    </advantage>
	<advantage version="2">
		<name>Decreased Time Rate</name>
		<name-loc>Замедленный ход времени
</name-loc>
		<description-loc>Данный недостаток является противоположностью Убыстренному ходу времени (B38). Вы ощущаете течение времени с половиной обычной скорости: прошедшие в реальности две секунды вы воспринимаете как одну. Ваш ход наступает в бою раз в две секунды! (Если ваша группа любит серьезную детализацию, то ход персонажа с Замедленным ходом времени можно разбивать на два "полухода": Движение разделяется на два хода, Атака объявляется в один ход, а проверка на попадание делается в следующий и т.д.)</description-loc>
		<type>Mental, Exotic</type>
		<base_points>-100</base_points>
		<reference>B129</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Decreased Will</name>
		<name-loc>Пониженная воля</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>-5</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>will</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Deep Sleeper</name>
		<name-loc>Глубокий сон</name-loc>
		<description-loc>Вы можете спать в любых условиях, и не просыпаться при воздействии большинства раздражителей. Вы никогда не чувствуете последствий плохого сна. Вы можете делать бросок IQ, чтобы заметить воздействие и проснуться, как и все остальные; а если у вас есть Боевые рефлексы, этот бросок автоматически засчитывается как успешный. 
</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Delusion (@Belief@)</name>
	<name-loc>Заблуждение (@Заблуждение@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Незначительное (Minor)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Значительное (Major)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Серьёзное (Severe)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B130</reference>
	<description-loc>Вы верите во что-то, что попросту не соответствует действительности. Из-за этого окружающие могут считать вас сумасшедшим. И могут оказаться правы! Если у вас имеется Заблуждение, то вы обязаны отыгрывать веру в него постоянно. Стоимость Заблуждения зависит от его сути.


Незначительное: Данное заблуждение влияет на ваше поведение, и всем окружающим это вскоре становится заметно, однако это не мешает вам действовать более или менее нормально. Те, кто видит ваше Заблуждение, реагирует на вас с -1. Примеры: "Белки - посланцы Бога." "Иллюминаты постоянно за мной наблюдают - но только чтобы меня защищать." "Я урожденный герцог Фнордский, похищенный в младенчестве цыганами и обреченный жить среди простолюдинов." -5 очков.
Значительное: Данное Заблуждение сильно влияет на ваше поведение, но не мешает вам жить относительно нормальной жизнью. Окружающие реагируют на вас с -2. Примеры: "Правительство записывает все телефонные разговоры." "У меня есть Абсолютная память и Чувство направления". -10 очков.
Серьезное: Данное Заблуждение настолько сильно влияет на ваше поведение, что способно помешать вам жить обычной жизнью. Окружающие реагируют на вас с -3, но они скорее будут пугаться или жалеть вас, а не нападать. Столь серьезное заблуждение может не дать вам нормально участвовать в кампании; поэтому его обязательно следует обсудить с мастером заранее. Примеры: "Я Наполеон." "Я бессмертен." "Мороженое помогает механизмам работать лучше, а компьютерам особенно. Просто нужно правильно его положить". -15 очков.


В зависимости от вашего поведение, одно и то же заблуждение может быть причудой (-1 очко) или стоить -5, -10 или -15 очков. Например, "Все фиолетовые вещи разумны". Если вы похлопываете фиолетовые предметы и здороваетесь с ними, то это причуда. Если не обсуждаете важные дела в присутствии таких предметов, то это Незначительное Заблуждение. Если пикетируете Капитолий, требуя предоставить права фиолетовым, то это Значительное Заблуждение. Если при виде фиолетовых вещей бросаетесь в атаку, то это Серьезное Заблуждение!
Независимо от того, насколько вы ненормальны, от Заблуждений нельзя получить больше -40 очков.
При желании расшевелить игроков мастер может сделать так, чтобы Заблуждение оказалось правдой. Это подходит не ко всем Заблуждениям. Например, из описанных выше для этого вряд ли подойдут Заблуждения про белок, мороженое или Наполеона. Но Иллюминаты могут и правда существовать, а цыгане могли похитить наследника Фнордского престола... Главное чтобы было интересно!
Если Заблуждение оказывается правдой, то вам не нужно выкупать его, пока в этом не убедятся остальные игроки. (И помните: мастер не говорит, что вы не сумасшедший. Ведь вы можете знать правду и при этом быть ненормальным...)


При желании расшевелить игроков мастер может сделать так, чтобы Заблуждение оказалось правдой. (И помните: мастер не говорит, что вы не сумасшедший. Ведь вы можете знать правду и при этом быть ненормальным...)
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Delusions</name>
		<name-loc>Заблуждения</name-loc>
		<description-loc>
Вы можете взять полностью безобидное Заблуждение (B130) в качестве причуды. Это не повлияет на ваше обычное поведение и вряд ли будет замечено случайными людьми, но вы должны верить в это! Примеры: «Земля плоская». «Пентагон контролирует бой-
скаутов и магазины здоровой пищи». «Носки вызывают болезни ног».</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Заблуждение@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Demophobia (Crowds)</name>
	<name-loc>Боязнь толпы (Демофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Вы боитесь любой группы людей в количестве более дюжины, если только не знаете всех их. Проверка на самоконтроля производится с пенальти -1, если их более 25 человек, -2, если 100 или больше, -3, если 1,000, -4, если 10,000 и так далее. -15 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Dependant (@Who@)</name>
	<name-loc>Иждивенцы (@Кто@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очков</name>
		<notes>100% от ваших стартовых</notes>
		<cost type="points">-1</cost>
		<affects>total</affects>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очков</name>
		<notes>75% от ваших стартовых</notes>
		<cost type="points">-2</cost>
		<affects>total</affects>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очков</name>
		<notes>50% от ваших стартовых</notes>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очков</name>
		<notes>25% от ваших стартовых</notes>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очков</name>
		<notes>0 или меньше</notes>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется почти всегда</name>
		<notes>15-</notes>
		<cost type="multiplier">3</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется часто</name>
		<notes>12-</notes>
		<cost type="multiplier">2</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется периодически</name>
		<notes>9-</notes>
		<cost type="multiplier">1</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется редко</name>
		<notes>6-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Группа</name>
		<cost type="multiplier">2</cost>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Наниматель или знакомый</name>
		<cost type="multiplier">0.5</cost>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Друг</name>
		<cost type="multiplier">1</cost>
		<reference>B131</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Возлюбленный</name>
		<cost type="multiplier">2</cost>
		<reference>B131</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B131</reference>
	<description-loc>"Иждивенец" - это NPC, за которого вы несете ответственность; например, ваш ребенок, младший брат или супруг. Вы обязаны заботиться об Иждивенцах. Более того, враги могут использовать их для удара по вам. (Если у вас есть и Враг, и Иждивенец, а кубики указывают, что оба они появились, то мастер может выстроить целое приключение на подобную тему!)
Если Иждивенец в ходе приключения будет похищен или окажется в опасности, то вы обязаны отправиться на его спасение как можно быстрее. Если вы не поспешите ему на помощь немедленно, мастер может лишить вас премии в виде очков персонажа за плохой "отыгрыш персонажа". Более того, вы не получаете очков персонажа за игровую сессию, в которой ваш Иждивенец был убит или серьезно ранен.
Цену этого недостатка определяют три фактора относительно Иждивенца: его способности, его важность (для вас!), а также частота его появления.


Способности
Определите число очков, на которое создается Иждивенец. Чем больше очков используется для его создания, тем более способным он будет, и тем меньше очков Иждивенец будет стоить в качестве недостатка. "Общее число очков" - это процент от очков игрового персонажа, лишь в последней строчке дано абсолютное значение; "Цена" - это число очков персонажа, которое приносит подобный недостаток.


!Общее число очков|	Цена
|	Не более 100%|	-1 очко
|	Не более 75%|	-2 очка
|	Не более 50%|	-5 очков
|	Не более 20%|	-10 очков
|	0 или меньше очков|	-15 очков
	

Один и тот же человек может быть одновременно и Иждивенцем, и Союзником (B36)! Сложите цену Союзник и Иждивенца, и получившееся число запишите как единую особенность: как преимущество, если сумма положительна, как недостаток, если отрицательна. При обоих подсчетах необходимо использовать одинаковое число его общих очков, но частота появления может быть разной. Делайте проверки на его появление в качестве Иждивенца и в качестве Союзника отдельно. Если он появляется как Иждивенец, то его появление приносит вам неприятности (например, его захватили в плен). Если он появляется в качестве Союзника, то он окажется полезен и сам о себе позаботится. Если он появляется и в том, и в другом качестве, то поможет вам, одновременно принося неприятности; например, он помогает вам своими навыками, но при этом теряется, его вычисляют враги или он иным образом вызывает проблемы, равные предложенной помощи.


Важность
Чем важнее для вас Иждивенец, тем большей обузой он для вас является, и тем больше он приносит очков.
Наниматель или знакомый: Вы чувствуете ответственность за этого человека, но способны разумно оценить риск, которому он подвергается. x1/2
Друг: Вы обязаны защищать этого человека всегда. Вы можете подвергать его риску только если дело касается чего-то очень важного (например, безопасности множества других людей). x1
Возлюбленный: Иждивенец - это ваш родственник или любовник. Вы не цените ничего превыше его безопасности! x2


Частота появления
Выберите частоту появления, как описано в разделе Частота появления (B36). Она должна соответствовать "легенде" данного Иждивенца. Если, к примеру, Иждивенец - маленький ребенок, то было бы странно, что он появляется "относительно редко"!


Множественные Иждивенцы
Вы не можете получать очки более чем за двух Иждивенцев. Однако если у вас есть группа Иждивенцев, то вы можете считать всю группу за двух Иждивенцев. Рассчитайте стоимость обычного члена группы по приведенным правилам, а затем получите двойную приведенную цену.


=====Пример: Борец с преступностью, который днем работает учителем в школе, может получить "группу иждивенцев": это все школьники. Он молоды (-10 очков), появляются "достаточно часто" (x2) и считаются "друзьями" (x1), то есть каждый стоит -20 очков. Однако ограничение в двух Иждивенцев позволит герои получить за них лишь -40 очков. (И если один из них пострадает, то останутся и другие.)=====


Иждивенцы в игре
По ходу игры вы будете получать очки, и мастер будет повышать способности Иждивенца, чтобы его общее число очков оставалось неизменным относительно вашего. Таким образом, цена этого недостатка не изменится. Дети растут, взрослые зарабатывают деньги, все приобретают новые умения. Иждивенцы, которые много путешествуют, сами могут становиться приключенцами. Вы можете предлагать логичные изменения для Иждивенцев, но последнее слово за мастером.
Если ваш Иждивенец убит или серьезно ранен, после чего мастер решает, что он вышел из кампании, вы обязаны вернуть дополнительные очки, полученные за него. У вас есть три выхода: выкупить его за заработанные очки персонажа, взять новый недостаток (например, Хроническую Депрессию, B126) или взять нового Иждивенца. Новые Иждивенцы обычно не подходят, но неплохим решением может стать психологическая травма из-за потери. (С тех пор, как осьминог проглотил Эми, вы боитесь моря...)


Примеры Иждивенцев
* Для всех: старшие родственники, учителя, друзья, дети, младшие браться и сестры, любовники и любовницы, мужья и жены.
* Для борцов с преступностью: младшие друзья, репортеры или опекуны.
* Для колдунов: ученики.
* Для капитанов (морских и космических судов): офицеры или юнги.
* Для солдат: сироты или новобранцы.
* Для преступников или сумасшедших ученых: неумелые сообщники.</description-loc>
</advantage>
	<advantage version="2">
	<name>Dependency (@Substance@)</name>
	<name-loc>Зависимость (@Вещество@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Исключительно редкое</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Редкое</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Распространенное</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Повсеместное</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Незаконное</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Постоянно</name>
		<notes>без него теряете 1 HP в минуту</notes>
		<cost type="multiplier">5</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежечасно</name>
		<notes>-1 HP каждые 10 минут, если пропустили ежечасную дозу</notes>
		<cost type="multiplier">4</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежедневно</name>
		<notes>-1 HP каждый час, если пропустили ежедневную дозу</notes>
		<cost type="multiplier">3</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Еженедельно</name>
		<notes>-1 HP каждые 6 часов, если пропустили еженедельную дозу</notes>
		<cost type="multiplier">2</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежемесячно</name>
		<notes>-1 HP каждый день, если пропустили ежемесячную дозу</notes>
		<cost type="multiplier">1</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Раз в сезон</name>
		<notes>-1 HP каждый день, если пропустили сезонную дозу</notes>
		<cost type="multiplier">0.33333</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежегодно</name>
		<notes>-1 HP каждые две недели, если пропустили ежегодную дозу</notes>
		<cost type="multiplier">0.1</cost>
		<reference>B130</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Старение (Aging)</name>
		<notes>Стареете на 2 года вместе с каждой потерей HP</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B130</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B130</reference>
	<description-loc>Вы обязаны регулярно принимать некое вещество (например, лекарство или волшебный эликсир), прикасаться или носить при себе предмет (например, святой ковчег или волшебный амулет) либо проводить время в некой среде (например, в гробу или в родной стране, на родной планете или измерении), чтобы жить. Если вы не смогли этого сделать, то начинаете терять HP и в конце концов умираете. Цена в очках зависит от редкости необходимого вам средства:
Исключительное (невозможно купить; необходимо находить или изготавливать): -30 очков.
Редкое (очень дорогое или трудно находимое): -20 очков.
Распространенное (дорогое, не очень просто найти): -10 очков.
Очень распространенное (доступно почти везде): -5 очков


Добавьте -5 к цене, если данное средство незаконно в вашем игровом мире.
Используйте множитель в зависимости от частоты, с которой вам необходимо употреблять средство:


Постоянно: Вы обязаны носить с собой предмет или использовать вещество все время - например, вам нужна необычная атмосфера. Вы теряете 1 HP в минуту без этого средства. x5
Ежечасно: Теряете 1 HP за каждые 10 минут после пропущенной часовой дозы. x4
Ежедневно: Теряете 1 HP за каждый час после пропущенной дневной дозы. x3
Еженедельно: Теряете 1 HP за каждые шесть часов после пропущенной недельной дозы. x2
Ежемесячно: Теряете 1 HP за каждый день после пропущенной месячной дозы. x1
Раз в сезон: Теряете 1 HP за каждые три дня после пропущенной сезонной дозы (под "сезоном" в данном случае понимается три месяца). x1/3 (все дробные числа отбрасываются).
Ежегодно: Теряете 1 HP за каждые две недели после пропущенной годовой дозы. x1/10 (все дробные числа отбрасываются).


Если вам необходимо прикасаться к некому объекту или проводить время в определенной среде, то, чтобы не получать повреждений, на это нужно потратить время, равное интервалу, с которым вы теряете HP. Например, чтобы не терять по 1 HP в час при ежедневной Зависимости от отдыха в гробу, вам необходимо пролежать в гробу минимум один час в день. Чтобы не терять 1 HP каждые две недели из-за Зависимости от родной планеты, вы обязаны посетить планету и пробыть там минимум две недели в году.
С разрешения мастера обычные люди могут брать данный недостаток для отражения своих особых потребностей или неких хронических заболеваний.
Не все, что необходимо для поддержания жизни, считается Зависимостью. Используйте недостаток Требует обслуживания (B143), если вам, чтобы не терять здоровье (ранения сюда не относятся), необходим квалифицированный уход - а не вещество, предмет или среда. Чтобы отразить особые требования к пище, при невыполнении которых вы будете медленно умирать от голода, а не стремительно терять HP при лишении еды, используйте недостаток Ограниченный рацион (B151).


===Особые улучшения===
Старение: Вы неестественно стареете при отсутствии средства, от которого зависите. За каждый потерянный HP вы также стареете на 2 года (даже если вы Нестареющий). +30%</description-loc>
</advantage>
	<advantage version="2">
	<name>Destiny (@Advantage@)</name>
	<name-loc>Судьба (@Хорошая судьба@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Незначительная</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Значительная</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Огромная</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B132</reference>
	<description-loc>Судьба – это непреодолимая сила, которая может подтолкнуть жизнь героя в ту или иную сторону, принося то удачу, то несчастье, слепо ведя его к предопределенному жребию. Чью-либо судьбу можно обнаружить с помощью магического предсказания, толкования знамений или другим магическим способом, но истинное значение предзнаменования часто бывает непонятно до тех пор, пока пророчество не исполнится. Персонаж, обладающий Судьбой, вероятно станет героем песен и легенд для последующих поколений.
Судьба может быть как преимуществом, так и недостатком с ценой от 15 до –15 очков (отрицательную судьбу можно присмотреть на с. B131). 
Когда игрок хочет получить Судьбу, он говорит мастеру ее желаемую стоимость в очках. Мастер тайно определяет характер Судьбы героя в зависимости от ее цены и нужд кампании. Конечно, в дальнейшем, с развитием кампании мастер может передумать!
Когда игрок выбирает Судьбу, он дает мастеру полное право вмешиваться в жизнь своего героя. Чем более искусно действует мастер, тем лучше, но он обязан заставить судьбу работать. Цена Судьбы показывает силу, с которой происходит воздействие на жизнь героя, но точные детали определяет мастер и течение кампании. Герой не должен узнать природу своей Судьбы, разве только благодаря смутным предзнаменованиям или сверхъестественным силам.

Судьба, взятая как преимущество, будет вести героя в конечном итоге к хорошему – хотя это и не всегда может явствовать, и время от времени она может доставлять неудобства. Роковая, трагическая смерть может быть концом, достойным героя.

Огромное преимущество: Персонажу в жизни суждено достичь величия – в конце концов каждый будет знать его имя и прославлять его! Рано или поздно удача исполнит его судьбу. Обратите внимание, что это не равнозначно «успеху» персонажа. Если он решит броситься на нож убийцы во время ближайшей игровой сессии, мастер может решить, что его судьба исполнилась... он умер героем! 15 очков.

Серьезное преимущество: То же, что и выше, но меньший успех. Или же персонаж может быть обречен погибнуть в определенном месте или определенным образом: в море, от руки императора, под землей или где-либо еще. Хотя он может получить тяжелое ранение и другим образом, он не умрет: все повреждения идут обычным образом, но он не умирает. Если он избегает обстоятельств, которые исполнят его Судьбу, сознательно или нет, судьба может преподнести ему некоторые сюрпризы. Море может затопить дом, когда он спит, генерал, против которого он сражается, может оказаться будущим императором, или Везувий может похоронить его под слоем пепла. Возможно, мастеру придется прибегнуть к таким ухищрениям, если персонаж узнает, что у него подобная Судьба. 10 очков.
Небольшое преимущество: Персонажу суждено сыграть маленькую роль в большой истории, но эта роль послужит ему на пользу. В игре это гарантирует ему одну серьезную победу. 5 очков.
Чтобы придумать интересную Судьбу – и исполнить ее – от мастера требуется большая изобретательность. Прежде чем вы выберете Судьбу, удостоверьтесь, что она не будет портить ход кампании. 
Если чья-то Судьба свершилась, и он все еще жив, то она теряется – хотя ее последствия могут посещать героя еще много лет. Персонаж не получает никаких дополнительных очков после того, как исполняется Судьба, бывшая преимуществом, но может обменять их на положительную репутацию. Даже если Судьба была неизвестна персонажу, она больше не является преимуществом.


Судьба как недостаток действует тем же образом, что и одноименное преимущество (см. B48), но она всегда ведет к плохому - не обязательно сразу и не лишая вас шанса добиться славы, стойко перенося ее удары. Предрешенная трагическая гибель может стать достойным концом для героя! Подобная Судьба бывает трех уровней:


Незначительный недостаток: Вам предопределено сыграть маленькую роль в большой истории, и для вас все не закончится так просто. С вами обязательно случится хотя бы одно трагическое событие или серьезная потеря - хотя эти вещи вряд ли приведут к вашей смерти, если только она не случится в самых отчаянных и героических обстоятельствах. -5 очков
Значительный недостаток: Вам суждено сыграть ключевую роль в печальных событиях. Например, вы не сможете во время доставить письмо, которое способно было спасти положение... или же вы казните единственного сведущего генерала в пограничной провинции, из-за чего ее захватят варвары. Вы при этом останетесь в живых. -10 очков
Огромный недостаток: Смерть преследует вас по пятам. И чему-то уже предназначено добраться до вас. Оно знает где вы и все время приближается. Вы будете убиты или сломлены, а ваше падение тяжелейшим образом отразиться на других. Такого рода Судьба подойдет не для каждой кампании! Мастеру не обязательно разрешать ее - и если он разрешил, то следует быть готовым радикально повернуть или закончить кампанию, когда Судьба окажется исполнена. -15 очков


Вы обязаны выкупить недостаток Судьба, как только она исполнена. Это происходит автоматически, если ее исход лишает вас Союзников, Статуса, Богатства и т.п. особенностей на равное число очков. Если вам не хватает очков, чтобы выкупить Судьбу, то вы получаете Невезение (B160) независимо от того, сколько очков стоила Судьба. Можете ли вы выкупить Невезение, решает мастер! Или же мастер может назначить вам новую Судьбу, Божественное проклятие (ниже) или иной сверхъестественный недостаток.</description-loc>
</advantage>
	<advantage version="2">
	<name>Destiny (@Disadvantage@)</name>
	<name-loc>Судьба (@Плохая судьба@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Незначительная</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Значительная</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Огромная</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B132</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B132</reference>
	<description-loc>Судьба – это непреодолимая сила, которая может подтолкнуть жизнь героя в ту или иную сторону, принося то удачу, то несчастье, слепо ведя его к предопределенному жребию. Чью-либо судьбу можно обнаружить с помощью магического предсказания, толкования знамений или другим магическим способом, но истинное значение предзнаменования часто бывает непонятно до тех пор, пока пророчество не исполнится. Персонаж, обладающий Судьбой, вероятно станет героем песен и легенд для последующих поколений.
Судьба может быть как преимуществом, так и недостатком с ценой от 15 до –15 очков (отрицательную судьбу можно присмотреть на с. B131). 
Когда игрок хочет получить Судьбу, он говорит мастеру ее желаемую стоимость в очках. Мастер тайно определяет характер Судьбы героя в зависимости от ее цены и нужд кампании. Конечно, в дальнейшем, с развитием кампании мастер может передумать!
Когда игрок выбирает Судьбу, он дает мастеру полное право вмешиваться в жизнь своего героя. Чем более искусно действует мастер, тем лучше, но он обязан заставить судьбу работать. Цена Судьбы показывает силу, с которой происходит воздействие на жизнь героя, но точные детали определяет мастер и течение кампании. Герой не должен узнать природу своей Судьбы, разве только благодаря смутным предзнаменованиям или сверхъестественным силам.

Судьба, взятая как преимущество, будет вести героя в конечном итоге к хорошему – хотя это и не всегда может явствовать, и время от времени она может доставлять неудобства. Роковая, трагическая смерть может быть концом, достойным героя.

Огромное преимущество: Персонажу в жизни суждено достичь величия – в конце концов каждый будет знать его имя и прославлять его! Рано или поздно удача исполнит его судьбу. Обратите внимание, что это не равнозначно «успеху» персонажа. Если он решит броситься на нож убийцы во время ближайшей игровой сессии, мастер может решить, что его судьба исполнилась... он умер героем! 15 очков.

Серьезное преимущество: То же, что и выше, но меньший успех. Или же персонаж может быть обречен погибнуть в определенном месте или определенным образом: в море, от руки императора, под землей или где-либо еще. Хотя он может получить тяжелое ранение и другим образом, он не умрет: все повреждения идут обычным образом, но он не умирает. Если он избегает обстоятельств, которые исполнят его Судьбу, сознательно или нет, судьба может преподнести ему некоторые сюрпризы. Море может затопить дом, когда он спит, генерал, против которого он сражается, может оказаться будущим императором, или Везувий может похоронить его под слоем пепла. Возможно, мастеру придется прибегнуть к таким ухищрениям, если персонаж узнает, что у него подобная Судьба. 10 очков.
Небольшое преимущество: Персонажу суждено сыграть маленькую роль в большой истории, но эта роль послужит ему на пользу. В игре это гарантирует ему одну серьезную победу. 5 очков.
Чтобы придумать интересную Судьбу – и исполнить ее – от мастера требуется большая изобретательность. Прежде чем вы выберете Судьбу, удостоверьтесь, что она не будет портить ход кампании. 
Если чья-то Судьба свершилась, и он все еще жив, то она теряется – хотя ее последствия могут посещать героя еще много лет. Персонаж не получает никаких дополнительных очков после того, как исполняется Судьба, бывшая преимуществом, но может обменять их на положительную репутацию. Даже если Судьба была неизвестна персонажу, она больше не является преимуществом.


Судьба как недостаток действует тем же образом, что и одноименное преимущество (см. B48), но она всегда ведет к плохому - не обязательно сразу и не лишая вас шанса добиться славы, стойко перенося ее удары. Предрешенная трагическая гибель может стать достойным концом для героя! Подобная Судьба бывает трех уровней:


Незначительный недостаток: Вам предопределено сыграть маленькую роль в большой истории, и для вас все не закончится так просто. С вами обязательно случится хотя бы одно трагическое событие или серьезная потеря - хотя эти вещи вряд ли приведут к вашей смерти, если только она не случится в самых отчаянных и героических обстоятельствах. -5 очков
Значительный недостаток: Вам суждено сыграть ключевую роль в печальных событиях. Например, вы не сможете во время доставить письмо, которое способно было спасти положение... или же вы казните единственного сведущего генерала в пограничной провинции, из-за чего ее захватят варвары. Вы при этом останетесь в живых. -10 очков
Огромный недостаток: Смерть преследует вас по пятам. И чему-то уже предназначено добраться до вас. Оно знает где вы и все время приближается. Вы будете убиты или сломлены, а ваше падение тяжелейшим образом отразиться на других. Такого рода Судьба подойдет не для каждой кампании! Мастеру не обязательно разрешать ее - и если он разрешил, то следует быть готовым радикально повернуть или закончить кампанию, когда Судьба окажется исполнена. -15 очков


Вы обязаны выкупить недостаток Судьба, как только она исполнена. Это происходит автоматически, если ее исход лишает вас Союзников, Статуса, Богатства и т.п. особенностей на равное число очков. Если вам не хватает очков, чтобы выкупить Судьбу, то вы получаете Невезение (B160) независимо от того, сколько очков стоила Судьба. Можете ли вы выкупить Невезение, решает мастер! Или же мастер может назначить вам новую Судьбу, Божественное проклятие (ниже) или иной сверхъестественный недостаток.</description-loc>
</advantage>
	<advantage version="2">
	<name>Detect</name>
	<name-loc>Обнаружение</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Редкое (ведьмы, огненная магия,зомби, золото, радар, радио)@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Частое (волшебники, магия, нежить, драгоценный металл, электрические поля, магнитные поля, радар и радио)@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Распространенное (люди, сверхествественные явления, сверхествественные существа, металл, электрические и магнитные поля)@</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Повсеместное (все живое, все сверхествественные явления и существа, все полезные ископаемые, любая энергия)@</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Точный (Precise)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Обнаружение сигнала (Signal Detection)</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Нечеткий (Vague)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B48</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Analyzing</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P47</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Exotic</type>
	<reference>B48</reference>
	<description-loc>Вы можете обнаруживать определенные материалы или состояния, даже недоступные человеческим чувствам. Это требует одной секунды концентрации, после чего Мастер скрытно делает бросок чувств (с. B358). Применяются модификаторы размера и Скорости/расстояния (c.B550). Вы можете приобрести особое обостренное чувство (с. B35), чтобы улучшить бросок, и увеличить эффективную дальность соответствующим модификатором.
В случае успеха мастер сообщает вам направление на ближайший значительный источник материала, и примерное количество. В случае провала – вы ничего не почувствовали.

Обнаружение также позволяет анализировать найденное. Это требует броска IQ – чем лучше бросок, тем больше вы получите информации. Например, если вы имеете Обнаружение (металлы), в случае успешного броска IQ вы сможете отличить железо от золота, и узнаете некоторые детали – например, форма хранения золота (слитки или руда), а в случае критического успеха – и пробу.

Редкие (Rare):. волшебницы, магия огня, радар, зомби, золото. 5 очков.

Частые (Occasional):  (маги, магия, драгоценные металлы, электрополя, нежить). 10 очков.

Распространенные (Common): (люди, сверхъестественные существа, металлы, электрические и магнитные поля). 20 очков.
Повсеместные (Very Common): (любая жизнь, все минералы, любая энергия). 30 очков.

Обратите внимание, что обнаружение определенных феноменов может быть засчитано за другие преимущества (например, Обнаружение магнитных полей – за Чувство направления).

===Особые улучшения.===

Точность (Precise): В случае успешного броска обнаружения вы точно определяете дистанцию. (+100%):

Обнаружение сигнала (Signal Detection): вы можете обнаруживать активные передачи определенного вида (радио, радар, лазер) – см. Сканирование (с. B81) и Телекоммуникация (с. B91). Вы не получаете штрафов за расстояние, но должны находиться на расстоянии не более двухкратной дальности сигнала, и (если сигнал направленный) на его пути. +0%.

===Новое особое улучшение===

Анализ (Analyzing): ваше чувство имеет необычайно высокое разрешение восприятия, почти как у сверхнаучного сканера. Обычный анализ автоматически считается успешным, если вы прокинули бросок Восприятия, более точный анализ требует броска ИН. Успех обнаружит такие детали, как форму, чистоту цели, точный вид, и так далее. Несовместимо со Нечеткостью. +100%.

===Особые ограничения.===
Смутное чувство (Vague): Вы можете обнаружить только присутствие вещества, но только при критическом успехе узнаете его количество и расстояние до него. -50%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Digital Mind</name>
		<name-loc>Цифровой разум</name-loc>
		<description-loc>Вы – разумная программа, возможно – искусственный интеллект или «слепок» живого разума. По умолчанию, вы населяете тело с компьютером Сложностью не меньше половины вашего IQ (см. Компьютеры, с. B472).
Вы полностью иммунны к любым телепатическим силам, и заклинаниям, воздействующим на живой разум. Однако, на вас могут воздействовать программы и компьютерные вирусы, вас можно отключить, а хакеры и программисты могут получить доступ к вашим данным и даже изменить ваше сознание!
Черта Машина рекомендуется, но не является необходимой (в конце концов, вы можете быть просто мозговым имплантом в органическом теле). Также обычными являются Автомат (c.B263) и Перепрограммируемый (с. B150).
Возможности компьютера: Если вы считаете быстрее обычного человека, покупайте Улучшенное восприятие времени. Если вы можете добавлять преимущества или навыки запуском программ – это Изменяемые способности.
Копии: Если вы можете запускать несколько копий разума на одной системе – Разделенный разум. Создание лояльных копий на другой системе – Разделение с ограничением Цифровое. Наличие резервных копий – дополнительная жизнь, и так далее.
Загрузка: Если вы можете активно загружать себя на другие рабочие станции – это Переселение (с. B75) с ограничением Цифровое. Если вы делаете это с легкостью, приобретайте Кукол (с. B78)</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B49</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Disciplines of Faith (Asceticism)</name>
		<name-loc>Требования веры
 (Аскетизм)</name-loc>
		<description-loc>Вы живете согласно строгому набору правил, чтобы продвинуться дальше в понимании своей веры. Это может быть как личным решением, так и требованием вашей религии. Хотя подобные правила во многих верах необязательны - напротив, некоторые религии могут запрещать их как чрезмерные! Обычно Требования веры - необходимая предпосылка для получения способностей использовать божественные силы: Дарованную силу, Истинную веру и др.
Вот некоторые примеры Требований веры:


Аскетизм: Вы удалились от общества с тем, чтобы вести жизнь, полную самоотречения и самоконтроля. Часто это означает некую изоляцию в суровых и аскетических условиях. Сюда даже могут относиться отдельные случаи сурового самоистязания с целью очиститься от земных страстей. Вы должны стараться изжить всякую необходимость в мирской собственности, и ни при каких обстоятельствах не можете владеть Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -15 очков
Монашество: Вы ведете жизнь вдали от мирских забот. Вы полностью посвятили себя религиозным искания, что обычно включает отрицание собственного эго и свой личности. Вы обязаны проводить не меньше 75% времени в изоляции от мира, и не можете обладать Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -10 очков
Мистицизм: Вы посвящаете себя глубокой медитации и созерцанию, которое походит на транс, с целью достичь большего единства с божеством. Вы проводите большую часть времени, исполняя эти ритуалы, а также песнопения и прочие необходимые обряды. Люди, не относящиеся к вашим единоверцам, считают вас слегка сумасшедшим, и реагируют на вас с -2. -10 очков.
Обрядность: Вы строго следуете четким ритуалам, касающимся всех сторон жизни - от прогулок и еды до купания и занятий сексом. У каждого ритуала есть свое четкое место, время, произносимые слова, особенности и церемония. Вы глубоко верите, что, безукоризненно исполняя данные ритуалы, вы приближаете все аспекты своей жизни к божественному. -5 очков.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<reference>B132</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Disciplines of Faith (Monasticism)</name>
		<name-loc>Требования веры
 (Монашество)</name-loc>
		<description-loc>Вы живете согласно строгому набору правил, чтобы продвинуться дальше в понимании своей веры. Это может быть как личным решением, так и требованием вашей религии. Хотя подобные правила во многих верах необязательны - напротив, некоторые религии могут запрещать их как чрезмерные! Обычно Требования веры - необходимая предпосылка для получения способностей использовать божественные силы: Дарованную силу, Истинную веру и др.
Вот некоторые примеры Требований веры:


Аскетизм: Вы удалились от общества с тем, чтобы вести жизнь, полную самоотречения и самоконтроля. Часто это означает некую изоляцию в суровых и аскетических условиях. Сюда даже могут относиться отдельные случаи сурового самоистязания с целью очиститься от земных страстей. Вы должны стараться изжить всякую необходимость в мирской собственности, и ни при каких обстоятельствах не можете владеть Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -15 очков
Монашество: Вы ведете жизнь вдали от мирских забот. Вы полностью посвятили себя религиозным искания, что обычно включает отрицание собственного эго и свой личности. Вы обязаны проводить не меньше 75% времени в изоляции от мира, и не можете обладать Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -10 очков
Мистицизм: Вы посвящаете себя глубокой медитации и созерцанию, которое походит на транс, с целью достичь большего единства с божеством. Вы проводите большую часть времени, исполняя эти ритуалы, а также песнопения и прочие необходимые обряды. Люди, не относящиеся к вашим единоверцам, считают вас слегка сумасшедшим, и реагируют на вас с -2. -10 очков.
Обрядность: Вы строго следуете четким ритуалам, касающимся всех сторон жизни - от прогулок и еды до купания и занятий сексом. У каждого ритуала есть свое четкое место, время, произносимые слова, особенности и церемония. Вы глубоко верите, что, безукоризненно исполняя данные ритуалы, вы приближаете все аспекты своей жизни к божественному. -5 очков.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B132</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Disciplines of Faith (Mysticism)</name>
		<name-loc>Требования веры
 (Мистицизм)</name-loc>
		<description-loc>Вы живете согласно строгому набору правил, чтобы продвинуться дальше в понимании своей веры. Это может быть как личным решением, так и требованием вашей религии. Хотя подобные правила во многих верах необязательны - напротив, некоторые религии могут запрещать их как чрезмерные! Обычно Требования веры - необходимая предпосылка для получения способностей использовать божественные силы: Дарованную силу, Истинную веру и др.
Вот некоторые примеры Требований веры:


Аскетизм: Вы удалились от общества с тем, чтобы вести жизнь, полную самоотречения и самоконтроля. Часто это означает некую изоляцию в суровых и аскетических условиях. Сюда даже могут относиться отдельные случаи сурового самоистязания с целью очиститься от земных страстей. Вы должны стараться изжить всякую необходимость в мирской собственности, и ни при каких обстоятельствах не можете владеть Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -15 очков
Монашество: Вы ведете жизнь вдали от мирских забот. Вы полностью посвятили себя религиозным искания, что обычно включает отрицание собственного эго и свой личности. Вы обязаны проводить не меньше 75% времени в изоляции от мира, и не можете обладать Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -10 очков
Мистицизм: Вы посвящаете себя глубокой медитации и созерцанию, которое походит на транс, с целью достичь большего единства с божеством. Вы проводите большую часть времени, исполняя эти ритуалы, а также песнопения и прочие необходимые обряды. Люди, не относящиеся к вашим единоверцам, считают вас слегка сумасшедшим, и реагируют на вас с -2. -10 очков.
Обрядность: Вы строго следуете четким ритуалам, касающимся всех сторон жизни - от прогулок и еды до купания и занятий сексом. У каждого ритуала есть свое четкое место, время, произносимые слова, особенности и церемония. Вы глубоко верите, что, безукоризненно исполняя данные ритуалы, вы приближаете все аспекты своей жизни к божественному. -5 очков.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B132</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Disciplines of Faith (Ritualism)</name>
		<name-loc>Требования веры
 (Обрядность)</name-loc>
		<description-loc>Вы живете согласно строгому набору правил, чтобы продвинуться дальше в понимании своей веры. Это может быть как личным решением, так и требованием вашей религии. Хотя подобные правила во многих верах необязательны - напротив, некоторые религии могут запрещать их как чрезмерные! Обычно Требования веры - необходимая предпосылка для получения способностей использовать божественные силы: Дарованную силу, Истинную веру и др.
Вот некоторые примеры Требований веры:


Аскетизм: Вы удалились от общества с тем, чтобы вести жизнь, полную самоотречения и самоконтроля. Часто это означает некую изоляцию в суровых и аскетических условиях. Сюда даже могут относиться отдельные случаи сурового самоистязания с целью очиститься от земных страстей. Вы должны стараться изжить всякую необходимость в мирской собственности, и ни при каких обстоятельствах не можете владеть Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -15 очков
Монашество: Вы ведете жизнь вдали от мирских забот. Вы полностью посвятили себя религиозным искания, что обычно включает отрицание собственного эго и свой личности. Вы обязаны проводить не меньше 75% времени в изоляции от мира, и не можете обладать Богатством выше среднего или Статусом, превышающим тот, который дает ваше Духовное звание (если оно есть). -10 очков
Мистицизм: Вы посвящаете себя глубокой медитации и созерцанию, которое походит на транс, с целью достичь большего единства с божеством. Вы проводите большую часть времени, исполняя эти ритуалы, а также песнопения и прочие необходимые обряды. Люди, не относящиеся к вашим единоверцам, считают вас слегка сумасшедшим, и реагируют на вас с -2. -10 очков.
Обрядность: Вы строго следуете четким ритуалам, касающимся всех сторон жизни - от прогулок и еды до купания и занятий сексом. У каждого ритуала есть свое четкое место, время, произносимые слова, особенности и церемония. Вы глубоко верите, что, безукоризненно исполняя данные ритуалы, вы приближаете все аспекты своей жизни к божественному. -5 очков.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B132</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Discriminatory Hearing</name>
		<name-loc>Необычайный слух</name-loc>
		<description-loc>Это сверхчеловеческая способность различать звуки. Вы всегда можете различить людей по голосу, способны распознать механизмы по звуку. Вы можете запомнить звук, слушая его в течение минуты, а затем сделав успешный бросок IQ. При провале вы не можете повторить эту попытку в течение дня.
Вы получаете +4 (дополнительно ко всем остальным премиям за слух) на любую задачу, использующую слух, и +4 на выслеживание шумной цели.
Для симуляции пассивного сонара, используемого подводными лодками, используется Доступность: только под водой, -30%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Только под водой</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Профилирование (Profiling)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P47</reference>
		</modifier>
		<reference>B49</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Discriminatory Smell</name>
		<name-loc>Необычайное Обоняние</name-loc>
		<description-loc>Раса может отличать и расползнавать людей, вещи и места по запаху. Члены расы обладают чувством обоняния далеко за пределами человеческого, и может отчетливо определять запахи для практически всего и всех, что им встречается. Индивидуум может запомнить запах с помощью обнюхивания не меньше одной минуты и успешного броска IQ. Если бросок провален, индивидуум может не пытаться запомнить этот запах как минимум один полный день. Индивидуумы получают +4 к любой задаче, где важно обоняние (разумеется, со всеми бонусами за Обостренное Обоняние) и +4 к умению Следопыт.

Если вы начинаете себя плохо чувствовать, если вдохнете определенную субстанцию, можно приобретси ограничение Временный недостаток (с. B115). Наиболее обычный эффект – Отвращение (с. B151), но Мастер может позволить и другие.

===Особые улучшения.===
Восприятие эмоций (Emotion Sense): Вы можете обнаруживать эмоциональное состояние субъекта по запаху. Это работает как преимущество Эмпатия (с. B51), но только в радиусе 2 ярдов от субъекта. +50%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Ощущение эмоций (Emotion Sense)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Профилирование (Profiling)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P47</reference>
		</modifier>
		<reference>B49</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">tracking</name>
			<specialization compare="is anything"></specialization>
			<amount>4</amount>
		</skill_bonus>	
	</advantage>
	<advantage version="2">
		<name>Discriminatory Taste</name>
		<name-loc>Необычайный вкус</name-loc>
		<description-loc>Эта способность работает почти также, как Необычайное обоняние, но улучшает только чувство вкуса, и потому не помогает в выслеживании. Для изучения вы должны попробовать немного вещества (или аромата тела). Это дает вам бросок IQ для распознавания вкуса, определения съедобности субстанции, и пр. Вы также можете выполнить детальный «анализ» броском против подходящего навыка (Химия, Повар, Фармакология, Яды…). Кроме любых бонусов за Обостренные обоняние и вкус вы получаете +4 на любые задачи, использующие вкус.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Profiling</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P47</reference>
		</modifier>
		<reference>B49</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Dislikes @Item@</name>
		<name-loc>Неприязнь  (@Предмет@)</name-loc>
		<description-loc>
Вы можете взять любую из Фобий (с. B148) на уровне обычной «неприязни». Когда вам не нравится что-то, вы избегаете этого насколько возможно, но на самом деле оно не вредит вам, как при Фобии. Неприязнь - это не обязательно слабая форма Фобий. В мире полно вещей, к которым можно испытывать неприязнь: морковь, кошки, галстуки, насилие, телефоны, реклама по телефону, налоги...</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Distinctive Features</name>
		<name-loc>Особые приметы</name-loc>
		<description-loc>
У вас есть физическая особенность - например, «красивые синие волосы» - которая выделяет вас из толпы. Это дает -1 к Изменению внешности или Слежке и +1 к попыткам опознать или выследить вас. Некоторые Особые приметы могут проистекать из полноценных недостатков. Например, альбинос (человек, у которого тело лишено природного пигмента, из-за чего у него розовые глаза, абсолютно белые волосы и кожа) обладает еще и Ослабление (Солнечный свет). Сравните Сверхъестественные черты (B157) и Неестественные черты (B22).</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Distractible</name>
		<name-loc>Рассеянный</name-loc>
		<description-loc>
Непродолжительное внимание (B153) на уровне причуды. Вас легко отвлечь, и вам сложно выполнять долгие задачи - вы получаете -1 к проверке на их выполнение.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Disturbing Voice</name>
	<name-loc>Неприятный голос
</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">diplomacy</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fast-talk</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">performance</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">public speaking</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sex appeal</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">singing</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">voice</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B132</reference>
	<description-loc>Ваш голос от природы звучит неприятно или явно искусственно. Детали могут различаться. Вы можете быть роботом или использовать технологию для смягчения недостатка Немота. Ваш голос может быть дребезжащим, пустым или писклявым, или же ваша речь - монотонной и страдающей от отсутствия интонации. Игровые эффекты те же самые, что и у недостатка Заикание (B157), хотя вы не обязательно заикаетесь.
Данная особенность является противоположностью преимуществу Голос (B97); у вас не может быть и того, и другого одновременно.</description-loc>
</advantage>
	<advantage version="2">
	<name>Divine Curse (@Curse@)</name>
	<name-loc>Божественное проклятие (@Проклятие@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Незначительное</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Значительное</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Суровое</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B132</reference>
	<description-loc>Вы страдаете от проклятия, наложенного богом или подобной сверхъестественной силой. Проклятие может быть наложено лишь на вас, на вашу семью или даже на весь народ или расу.
Божественное проклятие может принимать любую форму по желанию мастера. Это может быть постоянный запрет (например, "Ты не сможешь спать по ночам", -10 очков), несчастье (например, "Любой рожденный от тебя умрет юным", -5 очков), или даже некий неприятный недостаток вроде Неистовства, Слепоты или Эпилепсии (все за обычную цену). Что отличает проклятие от других недостатков - это возможность от него избавиться. Проклятие дано по какой-то причине, и вы можете попытаться открыть ее и искупить свою вину по ходу игры, таким образом избавившись от проклятия.
Мастеру следует оценивать стоимость Божественного проклятия индивидуально каждый раз, используя для сравнения существующие недостатки: чем более всеобъемлющим или неудобным является проклятие, тем выше его стоимость. Проклятия, которые выражаются обычными недостатками, не должны давать больше очков, чем данные недостатки. Запреты оценивайте так, как если бы они были Клятвами. Условия прощения часто будут почти так же тяжелы, как и само проклятие, или потребуется много усилий, чтобы их узнать и выполнить. Уменьшите стоимость вполовину, если для прощения этого не потребуется.</description-loc>
</advantage>
	<advantage version="2">
	<name>Divine Curse (All children die young)</name>
	<name-loc>Божественное проклятие (Все дети умирают молодыми)
</name-loc>
	<base_points>-5</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B132</reference>
	<description-loc>Вы страдаете от проклятия, наложенного богом или подобной сверхъестественной силой. Проклятие может быть наложено лишь на вас, на вашу семью или даже на весь народ или расу.
Божественное проклятие может принимать любую форму по желанию мастера. Это может быть постоянный запрет (например, "Ты не сможешь спать по ночам", -10 очков), несчастье (например, "Любой рожденный от тебя умрет юным", -5 очков), или даже некий неприятный недостаток вроде Неистовства, Слепоты или Эпилепсии (все за обычную цену). Что отличает проклятие от других недостатков - это возможность от него избавиться. Проклятие дано по какой-то причине, и вы можете попытаться открыть ее и искупить свою вину по ходу игры, таким образом избавившись от проклятия.
Мастеру следует оценивать стоимость Божественного проклятия индивидуально каждый раз, используя для сравнения существующие недостатки: чем более всеобъемлющим или неудобным является проклятие, тем выше его стоимость. Проклятия, которые выражаются обычными недостатками, не должны давать больше очков, чем данные недостатки. Запреты оценивайте так, как если бы они были Клятвами. Условия прощения часто будут почти так же тяжелы, как и само проклятие, или потребуется много усилий, чтобы их узнать и выполнить. Уменьшите стоимость вполовину, если для прощения этого не потребуется.</description-loc>
</advantage>
	<advantage version="2">
	<name>Divine Curse (Never sleep at night)</name>
	<name-loc>Божественное проклятие (Никогда не спит ночью)
</name-loc>
	<base_points>-10</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B132</reference>
	<description-loc>Вы страдаете от проклятия, наложенного богом или подобной сверхъестественной силой. Проклятие может быть наложено лишь на вас, на вашу семью или даже на весь народ или расу.
Божественное проклятие может принимать любую форму по желанию мастера. Это может быть постоянный запрет (например, "Ты не сможешь спать по ночам", -10 очков), несчастье (например, "Любой рожденный от тебя умрет юным", -5 очков), или даже некий неприятный недостаток вроде Неистовства, Слепоты или Эпилепсии (все за обычную цену). Что отличает проклятие от других недостатков - это возможность от него избавиться. Проклятие дано по какой-то причине, и вы можете попытаться открыть ее и искупить свою вину по ходу игры, таким образом избавившись от проклятия.
Мастеру следует оценивать стоимость Божественного проклятия индивидуально каждый раз, используя для сравнения существующие недостатки: чем более всеобъемлющим или неудобным является проклятие, тем выше его стоимость. Проклятия, которые выражаются обычными недостатками, не должны давать больше очков, чем данные недостатки. Запреты оценивайте так, как если бы они были Клятвами. Условия прощения часто будут почти так же тяжелы, как и само проклятие, или потребуется много усилий, чтобы их узнать и выполнить. Уменьшите стоимость вполовину, если для прощения этого не потребуется.</description-loc>
</advantage>
	<advantage version="2">
	<name>Doesn't Breathe</name>
	<name-loc>Не Нуждается в Дыхании</name-loc>
	<base_points>20</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Жабры (Gills)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Жабры (Gills)</name>
		<notes>Задыхается на воздухе</notes>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Поглощение кислорода (Oxygen Absorption)</name>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сжигание кислорода (Oxygen Combustion):</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Запас воздуха (Oxygen Storage)</name>
		<notes>Может задерживать дыхание на время в 25 раз дольше обычного</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Запас воздуха (Oxygen Storage)</name>
		<notes>Может задерживать дыхание на время в 50 раз дольше обычного</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Запас воздуха (Oxygen Storage)</name>
		<notes>Может задерживать дыхание на время в 100 раз дольше обычного</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Запас воздуха (Oxygen Storage)</name>
		<notes>Может задерживать дыхание на время в 200 раз дольше обычного</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Запас воздуха (Oxygen Storage)</name>
		<notes>Может задерживать дыхание на время в 300 раз дольше обычного</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B49</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B49</reference>
	<description-loc>Вы не дышите и не требуете кислорода. Удушение не может вам повредить или лишить вас голоса, и вы неуязвимы для дыхательных токсинов. Вы по-прежнему уязвимы для контактных ядов, давления и вакуума; для сопротивления им приобретайте Герметичность (с. B82), Устойчивость к давлению (с. B77) и Устойчивость к вакууму (с. B96).
===Особые ограничения.===

Жабры (Gills): Вы можете выделять кислород из воды, что позволяет вам находится под водой неограниченное время. Если вода не содержит растворенного кислорода, вы начинаете задыхаться. Вы иммунны к удавлению и кессонной болезни. Если вы можете жить только под водой, а на воздухе начинаете задыхаться (как обычный человек под водой), Жабры стоят 0 очков, иначе -50%.

Поглощение кислорода (Oxygen Absorption): Подобно Жабрам, но вы способны поглощать кислород всей поверхностью тела, пока он присутствует в окружающей среде. Тело не поглощает ядовитых газов, но вы начнете задыхаться, если кислорода вокруг нет. Вы можете использовать дыхательное снаряжение в космосе (ваши легкие также работают). Вы не можете иметь преимущество Герметичность. -25%.

Окисление (oxygen combustion): Подобно Поглощению кислорода, но вы не можете дышать под водой и в любых других условиях, где не может гореть обычное пламя. -50%.
Запас кислорода (Oxygen Storage): Вы должны дышать, но можете задерживать дыхание на продолжительный период времени, возможно что вы храните кислород в особой емкости или из-за избыточного насыщения крови кислородом. Это отличается от обычной задержки дыхания, поскольку вы невосприимчивы к кессонной болезни. Если вы способны задерживать дыхание на время в 25 раз больше обычного, это -50%-е ограничение; х50 - -40%, х100 -30%; х200 -20%; х300 -10%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Doesn't Eat or Drink</name>
		<name-loc>Не Нуждается в пище и воде</name-loc>
		<description-loc>Вам не требуется пища - вы питаетесь другим способом (солнечная энергия, мана, и пр.). Заметьте, что достаточно редко встречающийся источник энергии пойдет как недостаток Зависимость (с. B130).</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<reference>B50</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Doesn't Sleep</name>
		<name-loc>Не Нуждается во Сне</name-loc>
		<description-loc>Вы совершенно не нуждаетесь во сне. Вы можете игнорировать любые штрафы за пропущенный сон и отдых.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>20</base_points>
		<reference>B50</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Dominance</name>
		<name-loc>Порабощение</name-loc>
		<description-loc>Вы можете заражать других сверхъестественным путем (вампиризм, ликантропия и пр) и приобретать абсолютный контроль над ними. Эта черта доступна только сверхъестественным существам, которые распространяют свое проклятие через заражение, и влияет только на членов подобных рас. Мастер решает, какие проклятия и на кого могут быть распространены.
При покупке Порабощения, укажите одну природную атаку (когти, врожденная атака, укус вампира и пр) – которая переносит инфекцию. Любой раненый этой формой атаки, должен кинуть 3d против количества полученных повреждений (максимум – 1 бросок в день). Если результат броска меньше, чем количество вреда – персонаж заражен, и превратится в подобное создание через 2d дней (или на усмотрение мастера). Мастер может добавлять дополнительные условия для заражения (например, жертва должна перенести три атаки, или получить вашу кровь, или даже сначала умереть). 
По завершении заражения, жертва получает шаблон расы (Вампир, Оборотень и пр.), плюс Рабский менталитет (с. B154), и становится вашим подчиненным. Если она кого-либо заражает, ее жертвы получают те же атрибуты, и также служат вам.
Само по себе Порабощение стоит 20 очков, но чтобы контролировать каждую новую жертву, вы должны покупать каждый раз нового Союзника с расширением Слуга (из-за Рабского менталитета), и Спец. Способностями (поскольку он может создавать новых слуг). Вы можете выбрать любую частоту встреч, и увеличить ее позже путем дополнительной оплаты. Если у вас недостаточно очков для покупки нового слуги даже с частотой «при броске 6-», жертва все равно инфицируется, но не становится вашим рабом.
Порабощение длится, пока вы не умрете (если вы нежить – истинной смертью), или ваш раб не вырастет до такой степени, что вы не сможете больше оплачивать его стоимость, или Мастер не решит, что проклятие снято. В этом случае жертва теряет рабский менталитет и становится свободной. Вы можете использовать потраченные на эту жертву очки, чтобы купить нового раба.
Вариант данной черты с отрицательной стоимостью –Заразная атака (c.B140).</description-loc>
		<type>Mental, Exotic</type>
		<base_points>20</base_points>
		<reference>B50</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Draining (@Substance@)</name>
	<name-loc>Истощение (@Вещество@)</name-loc>
	<base_points>-5</base_points>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Распространенное (Common)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Редкое (Occasional) </name>
		<cost type="points">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Исключительное (Rare)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Незаконное</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B132</reference>
	<description-loc>Раз в день в определенное время - на восходе, в полдень, на закате, в полночь и т.д. - вы получаете 2 HP повреждений. Вы ничего не можете сделать, чтобы это предотвратить, и не сможете вылечить рану естественным образом (даже если у вас есть Регенерация!), технологическим или сверхъестественным способом. Единственный способ восстановить потерянные HP - это принять дневную дозу определенного вещества. Цена зависит от редкости данного вещества:


Исключительное (например, специальный эликсир): -15 очков.
Редкое (например, кровь девственницы): -10 очков.
Распространенное (например, человеческая кровь): -5 очков.


Увеличьте цену на -5 очков, если данное средство незаконно в вашем игровом мире.
Это не то же самое, что Зависимость (B130). У вас может быть и то, и другое одновременно!</description-loc>
</advantage>
	<advantage version="2">
	<name>Dread (@Item@)</name>
	<name-loc>Боязнь (@Предмет@)</name-loc>
	<base_points>-9</base_points>
	<points_per_level>-1</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Повсеместная (Very Common)</name>
		<cost type="multiplier">3</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Распространенная(Common)</name>
		<cost type="multiplier">2</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Редкая (Occational)</name>
		<cost type="multiplier">1</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Исключительная (Rare)</name>
		<cost type="multiplier">0.5</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невозможно загнать в угол (Cannot Be Trapped)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B133</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Insensitive</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>H25</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B132</reference>
	<description-loc>Вы чувствуете сверхъестественное отторжение, заставляющее вас держаться на неком минимальном расстоянии от определенного предмета или вещества. Если внешняя сила сводит вас и предмет вашей боязни ближе этого расстояния, вы обязаны убежать прочь так быстро, как только сможете, по самому короткому из доступных путей. Вы не можете делать ничего больше, пока не пересечете границу своей Боязни. Если вы не можете сбежать на минимальное расстояние, которого требует ваша Боязнь, то предмет Боязни сделает вас беспомощным!
Вы постоянно чувствуете присутствие предмета, которого боитесь, как только пересекаете запретную черту. Вы не знаете точно, где он находится, но понимаете, в каком он направлении, и вынуждены бежать в противоположную сторону.
Базовая цена Боязни составляет -10 очков, и при ней вы не можете подходить к предмету своей боязни ближе чем на один ярд. Больший радиус даст дополнительно по -1 очку за ярд, вплоть до максимума -20 очков за 11 ярдов. Чтобы определить финальную стоимость недостатка, необходимо умножить полученное число на модификатор, отражающий редкость данного предмета, как описано для недостатка Слабость (B161).


Специальные ограничения
Невозможно загнать в угол: Вы не способны войти в запретную зону по собственной воле, но если вас загнала туда внешняя сила, то вы больше не чувствуете Боязни. Вы можете действовать нормальным образом в запретной зоне до тех пор, пока не покинете ее, после чего действие запрета возобновляется. -50%</description-loc>
</advantage>
	<advantage version="2">
		<name>Dreamer</name>
		<name-loc>Мечтатель</name-loc>
		<description-loc>
Вы получаете -1 к любой долгой работе, поскольку предпочитаете размышлять о наилучших способах ее выполнения, а не работать.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Dull</name>
		<name-loc>Консервативный</name-loc>
		<description-loc>
Вы не совсем Консервативны (B138), но предпочитаете использовать старые испытанные методы.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Duplication</name>
		<name-loc>Разделение</name-loc>
		<description-loc>Вы можете разделяться на два или более тел («дублей»), каждый из которых обладает всеми вашими способностями и силами (но не снаряжением, если вы не приобрели соответствующее улучшение). Разделение и слияние занимает 1 секунду маневра Концентрация. Слившийся получает средний показатель FP и НР, и весь накопленный опыт.
Дубли не имеют никакой особой способности к общению между собой. Для этого приобретается Телекоммуникация (с. B91). Если ваши дубли могут общаться только между собой, вы можете взять к Телекоммуникации ограничение Расовое. Возможна комбинация Отправки мыслей с Ментальной связью (с.70), что дает вам возможность постоянного ментального контакта с дублями – броски становятся не нужны.

При гибели одного из дублей все остальные получают 2d вреда и оглушены (ментально, если способность ментальная, или физически, если физическая). Бросок IQ или НТ на восстановление делается с -6. Также вы теряете все очки, затраченные на этого дубля. Мастер может позволить купить нового дубля за непотраченные очки. Дополнительная жизнь может вернуть к жизни одного дубля – вы ее теряете, но тратите меньше, чем если бы выкупили дубля заново.

===Особые улучшения.===

Дубликация снаряжения (Duplicated Gear): ваши дубли появляются с полной копией вашего текущего снаряжения. При слиянии снаряжение дубля исчезает, даже если находится в другом месте. Энергозапас, боекомплект, НР снаряжения считается точно также, как и FP и НР. +100%.

Нет симпатии (No Sympathetic Injury): Если один из дублей убит, другие не оглушаются и не получают вреда. +20%.

===Новое особое улучшение===

Творения (Construct): ваши дубли – просто материальные проекции под вашим ментальным контролем. Когда вы развеиваете их, вы остаетесь при своих текущих (не средних) ЕЖ и ЕУ. Вы также получаете улучшение Нет симпатических повреждений (покупать его отдельно не надо). Наконец, смерть ваших дублей – непостоянна, простой концентрацией и за 10 ЕУ вы можете создать замену.
Однако, личность содержит только ваше тело, и если вас убьют – все дубли погибнут сразу. Улучшение несовместимо с Цифровым копированием и Общими ресурсами. +60%
===Особые ограничения.===

Цифровое копирование (Digital): ваши дубли – копии разума, а не физического тела. Они могут жить в компьютерах или населять куклы. Это ограничение доступно только если вы имеете Цифровой разум (с.48) и Переселение (цифровое) (с.75). -60%.
Разделяемые силы (Shared Resources): при разделении вы распределяете текущие FP и НР среди дублей, не обязательно поровну. При слиянии вы получаете оставшиеся у дублей очки, а не средние. Например, если вы имеете 15 НР и одного дубля, то можете разделить их на 8 и 7, 2 и 13, и в любой другой комбинации. Не обязательно также разделять FP и НР пропорционально – при наличии 15 FP и 15 НР можно дать одной копии 3 FP и 9 НР, а другой – 12 FP и 6 НР. -40%.

===Новое особое ограничение===
Последовательное (Sequential): Вы и ваши дубли связаны между собой в определенном порядке.
Пронумеруйте их, начиная с первого. Когда один из дублей погибает, погибают все дубли, созданные после него. Это позволяет создать персонажа, который может призывать копии себя из возможного будущего – все последующие копии зависят от жизни предыдущих. Модификатор «Творения» (выше) в этом случае позволит вам призывать копии из другого возможного будущего. -40%.
</description-loc>
		<type>Mental/Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>35</points_per_level>
		<modifier version="1" enabled="no">
			<name>Копирование вещей (Duplicated Gear)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Нет симпатических повреждений (No Sympathetic Injury)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Цифровой (Digital)</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Общие ресурсы (Shared Resources)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Construct</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>P48</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Sequential</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P48</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Multiplication</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>Sup26</reference>
		</modifier>
		<reference>B50</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Duty (@Duty@)</name>
	<name-loc>Служба (@Служба@)
</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Весьма редко: бросок 6</name>
		<cost type="points">-2</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Относительно часто: бросок 9</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Весьма часто: бросок 12</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Почти всегда: бросок 15</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Особо опасная (Extremely Hazardous)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невольная (Involuntary)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неопасная (Nonhazardous)</name>
		<cost type="points">5</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B133</reference>
	<description-loc>
		Если ваша профессия и социальное положение накладывают на вас определенные личные обязательства по отношению к другим и периодически требуют выполнять рискованные приказы, то у вас есть "Долг". Долг обычно сопровождается Званием (B29), Покровителем (B72) или одной из особенностей, относящихся к Привилегиям (B30).
Особо тяжелая работа может считаться Долгом, но большинство обычных работ сюда не относится. Обязательства, наложенные на себя сугубо добровольно, это также не Долг (но они все равно могут быть недостатком; см. Чувство Долга, B153). И, наконец, вы не можете требовать очков за Долг по отношению к Иждивенцам (B131); получаемые за Иждивенцев очки уже отражают ваши обязательства в его отношении.
Мастер может ограничить разрешенные в кампании виды Долга или даже полностью запретить это недостаток, если посчитает, что он сильно нарушит ход приключения.
Если у вас есть Долг, то в начале каждого приключения мастер кидает кубики, чтобы определить, будет ли он задействован в игре. Если вас "позвал долг", то это может отодвинуть ваши личные планы... или может стать причиной для приключения! Или же начальство может дать вам секретное задание, а коллеги - беспокоить вас и тогда, когда вы официально находитесь "на отдыхе". Если вы пытаетесь избежать исполнения Долга, то мастер имеет право оштрафовать вас за плохой отыгрыш.
!Долга зависит от частоты, с которой он появляется в игре|Базовая цена
|Почти всегда (результат броска 15 и меньше): |-15 очков. На этом уровне мастер может решить, что вы постоянно на службе.
|Весьма часто (результат броска 12 и меньше): |-10 очков.
|Относительно часто (результат броска 9 и меньше): |-5 очков.
|Весьма редко (результат броска 6 и меньше): |-2 очка.


Данная цена отражает социально приемлемую службу, при которой вы иногда подвергаетесь опасности. Если ваш Долг не подходит под это описание, то необходимо модифицировать цену:


Особо опасный: Вы постоянно рискуете жизнью или здоровьем при исполнении Долга. Если вы откажетесь рисковать, то вас ждет серьезное наказание: позорное увольнение, заключение, а может быть и смерть. Последнее слово о том, является ли определенный Долг в его кампании "особо опасным", остается за мастером. -5 очков.
Недобровольный: Вас заставляют исполнять долг угрозами вам или вашим близким, либо он накладывается с помощью особого контроля над сознанием, проклятия и т.д. Это не влияет на степень риска в момент исполнения Долга - опасность заключается в том, что будет, если вы не исполните его! Долг может быть недобровольным и одновременно Особо опасным либо Неопасным. -5 очков.
Неопасный: Долг никогда не требует от вас рисковать жизнью. Данный вариант взаимно исключается с Особо опасным Долгом. +5 очков. (Если это поднимает цену вашего долга до 0 очков и более, то данные обязательства слишком тривиальны, чтобы считаться Долгом.)


Примеры
Пример 1: Мэр обязан мафиозному боссу, который поддержал его на выборах. Его благодетель изредка просит об услугах (-2 очка), но поскольку в случае отказа мэра ждет шантаж или насилие, его Долг считается Недобровольным. Долг (Босс мафии, 6 или меньше; Недобровольный) стоит -7 очков.
Пример 2: Боец "коммандос" всегда на службе (-15 очков). За всю свою карьеру он может столкнуться лишь с несколькими боевыми заданиями, но они будут смертельно опасны. Даже его ежедневная работа требует прыгать с самолетов, ходить по лесам, кишащим змеями, и стрелять боевыми патронами. Коммандос обладают недостатком Долг (Армия, 15 или меньше; Особо опасный), за -20 очков.
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Dwarfism</name>
		<name-loc>Карлик</name-loc>
		<description-loc>-1 SM
Ваш рост необычно мал для данной расы. Независимо от ST, ваш рост меньше самого низкого значения в Таблице телосложения - то есть меньше 4'4'' для людей. Это дает вам Модификатор размера -1. Выберите вес из первой строки Таблицы телосложения и снизьте его на 15%.
Вы получаете -1 к Базовому передвижению (у вас короткие ноги). В бою ваша досягаемость (reach) снижается на 1 ярд. Частично это объясняется длиной ваших рук, частично тем, что вы вынуждены использовать оружие меньших размеров (независимо от Силы, ваши руки не могут служить достаточным рычагом для полноценного оружия). 
Вы получаете -2 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. В отсталых мирах мастер может потребовать от вас недостатка Социальная дискриминация, если вы страдаете карликовостью.
Карликом может быть представитель любой расы. Уменьшите рост, умножив средний рост для данной расы на коэффициент 0.75, а расовый SM снизьте на -1. Во всем остальном правила те же.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B19</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>move</attribute>
			<amount>-1</amount>
		</attribute_bonus>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<attribute_bonus>
			<attribute>sm</attribute>
			<amount>-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Dyslexia</name>
		<name-loc>Дислексия
</name-loc>
		<description-loc>Вы не способны читать в принципе. Даже простые карты и дорожные указатели вам непонятны. На начало игры уровень письменного восприятия родного языка у вас "Отсутствует". Это входит в Дислексию; дополнительных очков за это вы не получаете. Более того, вы никогда не сможете повысить свой уровень письменного восприятия выше "Отсутствующего" ни в одном из языков. Подробнее о восприятии языков см. раздел Языки (B23).
Вы способны учиться "книжным" умениям с нормальной скоростью, если имеется учитель, который компенсирует вашу неспособность использовать тексты. Попытки изучить подобные умения без учителя происходят с 1/4 скорости - если это умение вообще можно изучить без книг. В любом случае, последнее слово за мастером. В традиционных фентези мирах магия изучается по книгам, и Дислексия не даст вам стать колдуном.
Обратите внимание, что это тяжелая форма заболевания. Легкая дислексия не имеет значения для игры, и может быть разве что причудой.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B134</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Easy to Kill</name>
		<name-loc>Легко убить
</name-loc>
		<description-loc>У вас имеются проблемы со здоровьем или структурная слабость, которая увеличивает для вас риск полного выхода из строя при получении достаточных повреждений. Каждый уровень недостатка Легко убить дает -1 к проверкам HT, которые выполняются для выживания при -HP и ниже, а также на проверки HT, где неудача означает мгновенную смерть (например, при сердечном приступе). Это не влияет на большинство обычных проверок HT - только при необходимости избежать верной смерти. Вы не можете уменьшить необходимый результат при проверке HT ниже 3. Например, если ваш показатель HT 10, то максимальный уровень недостатка Легко убить составляет 7.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-2</points_per_level>
		<reference>B134</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Easy to Read</name>
		<name-loc>Легко понять
</name-loc>
		<description-loc>Тело выдает ваши истинные намерения. Это не то же самое, что Правдивость (B159). Вы не испытываете моральных трудностей с тем чтобы соврать и даже можете обладать высоким уровнем в Заговаривании зубов, но ваше лицо или жесты вас выдают.
Недостаток Легко понять дает окружающим +4 ко всем проверкам на Эмпатию, Язык тела и Психологию, чтобы раскрыть ваши намерения или понять, правду ли вы говорите. Точно так же они получают +4 к своим проверкам IQ, Определения лжи и Азартных игр в Быстром состязании против ваших умений Артистизм, Заговаривание зубов или Азартные игры, когда вы пытаетесь лгать или блефовать. (Если у вас есть вдобавок Правдивость, то Заговаривание зубов получает вдобавок еще -5.) Это гибельный недостаток для потенциального шпиона, мошенника или игрока!
Это ментальный недостаток, несмотря на его физическое проявление; достаточно потренировавшись, вы сможете его "выкупить".</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B134</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Eidetic Memory</name>
		<name-loc>Идеальная память</name-loc>
		<description-loc>У вас исключительная память. Любой может попытаться бросить IQ, чтобы вспомнить общие детали недавних событий – чем лучше бросок, тем правильнее воспоминание, но это все равно не будет более чем наброском. С этим талантом вы автоматически прокидываете бросок IQ, и часто вспоминаете точные детали. Существует два уровня преимущества:

Хорошая память (Eidetic Memory): Вы автоматически вспоминаете то, на чем сосредотачиваетесь, и можете вспомнить детали, если прокинете бросок IQ. Возможно изучение этого преимущества во время игры (особенно неплохо для бардов). 5 очков.
Фотографическая память (Photographic Memory): Вы также автоматически вспоминаете любые детали. В любое время, когда игрок забывает некоторые вещи, которые его персонаж слышал или видел, Мастер или игроки должны напомнить ему их – честно. 10 очков.
Обратите внимание, что преимущество отражает хорошую память, но не сообразительность, и не влияет на уровни навыков. Однако, оно дает премию +5/+10 соответственно к броскам IQ для обучения.</description-loc>
		<type>Mental</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Фотографическая (Photographic)</name>
			<cost type="points">5</cost>
			<affects>total</affects>
			<reference>B51</reference>
		</modifier>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Elastic Skin</name>
		<name-loc>Эластичная кожа</name-loc>
		<description-loc>Вы можете изменять черты лица и кожы (но не одежду и макияж), копируя кого-нибудь принадлежащего к вашей (или очень похожей) расе. Это занимает 10 секунд, а копирование кого-то определенного требует еще и броска Изменения внешности. Возвращение к вашему нормальному виду займет всего три секунды. +4 на броски Изменения внешности.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>20</base_points>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>4</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Electrical</name>
		<name-loc>Электроника
</name-loc>
		<description-loc>Ваше тело содержит неэкранированную электронику или его жизненная энергия зависит от электричества. Это делает вас уязвимым к атакам, влияющим лишь на электронные системы, куда относятся некоторые заклинания, преимущества и высокотехнологичные виды оружия, которые вытягивают энергию или выжигают электронику, а также электромагнитный импульс от ядерного взрыва.
Данный недостаток обычно дополняется мета-особенностью Машина (B263), но это не обязательно. Возможны Атаки воздействием и Природные атаки, влияющие только на обладателей данной особенности. Примените ко всем подобным атакам -20% ограничение Доступность "Только против Электроники".</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B134</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Empathy</name>
	<name-loc>Эмпатия</name-loc>
	<base_points>15</base_points>
	<skill_bonus>
		<name compare="is">detect lies</name>
		<specialization compare="is anything"></specialization>
		<amount>3</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fortune-telling</name>
		<specialization compare="is anything"></specialization>
		<amount>3</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">psychology</name>
		<specialization compare="is anything"></specialization>
		<amount>3</amount>
	</skill_bonus>
	<modifier version="1" enabled="no">
		<name>Remote</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P48</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B51</reference>
	<description-loc>О каждом человеке у вас быстро складывается определенное мнение. Когда вы в первый раз или после долгой разлуки встречаете кого-то, вы можете попросить мастера сделать бросок проверки вашего IQ. Он расскажет вам, что вы "чувствуете" об этом человеке. (Проваленный бросок означает, что мастер может вам солгать). Этот талант, когда он срабатывает, великолепен для определения самозванцев, лгунов, и т.д. и понимания истинной лояльности NPC. Вы можете использовать его чтобы определить, врет вам человек или нет: Не узнать правду, а именно определить, честен ли он с вами.
Понимание (Sensitive): Ваша способность не очень надежна – вы делаете бросок IQ-3, и получаете +1 на броски Обнаружения лжи, Предсказания судьбы; а также к психологии. 5 очков.
Эмпатия (Empathy): Вы делаете бросок IQ, и получаете +3 к Психологии, Обнаружению лжи или Предсказанию судьбы. 15 очков.
Способность работает только на разумных (IQ 6+) естественных существ. Эквивалентные таланты для животных, растений и сверхъестественных существ можно найти в виде Понимания животных (с. B40), Растений (с. B75) и духов (с. B88).

===Новые особые улучшения===
Удаленный (Remote): Эмпатия больше не ограничивается прямыми личными встречами. Вы можете "чувствовать" любого человека, которого вы видите или слышите - даже с помощью электронных средств массовой информации (или сверхъестественными средствами для Понимания духов). +50%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Empathy (Sensitive)</name>
	<name-loc>Эмпатия</name-loc>
	<base_points>5</base_points>
	<skill_bonus>
		<name compare="is">detect lies</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fortune-telling</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">psychology</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<modifier version="1" enabled="no">
		<name>Remote</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P48</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B51</reference>
	<description-loc>О каждом человеке у вас быстро складывается определенное мнение. Когда вы в первый раз или после долгой разлуки встречаете кого-то, вы можете попросить мастера сделать бросок проверки вашего IQ. Он расскажет вам, что вы "чувствуете" об этом человеке. (Проваленный бросок означает, что мастер может вам солгать). Этот талант, когда он срабатывает, великолепен для определения самозванцев, лгунов, и т.д. и понимания истинной лояльности NPC. Вы можете использовать его чтобы определить, врет вам человек или нет: Не узнать правду, а именно определить, честен ли он с вами.
Понимание (Sensitive): Ваша способность не очень надежна – вы делаете бросок IQ-3, и получаете +1 на броски Обнаружения лжи, Предсказания судьбы; а также к психологии. 5 очков.
Эмпатия (Empathy): Вы делаете бросок IQ, и получаете +3 к Психологии, Обнаружению лжи или Предсказанию судьбы. 15 очков.
Способность работает только на разумных (IQ 6+) естественных существ. Эквивалентные таланты для животных, растений и сверхъестественных существ можно найти в виде Понимания животных (с. B40), Растений (с. B75) и духов (с. B88).

===Новые особые улучшения===
Удаленный (Remote): Эмпатия больше не ограничивается прямыми личными встречами. Вы можете "чувствовать" любого человека, которого вы видите или слышите - даже с помощью электронных средств массовой информации (или сверхъестественными средствами для Понимания духов). +50%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Enemy (@Who@)</name>
	<name-loc>Враги (@Кто@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Один слабый</name>
		<notes>50% ваших стартовых очков</notes>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Один равный по силе</name>
		<notes>100% ваших стартовых очков</notes>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Один сильный</name>
		<notes>&gt;150% ваших стартовых очков</notes>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа слабая</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа средняя</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа большая/сильная</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Крайне опасная группа</name>
		<cost type="points">-40</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется почти всегда</name>
		<notes>15-</notes>
		<cost type="multiplier">3</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется часто</name>
		<notes>12-</notes>
		<cost type="multiplier">2</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется периодически</name>
		<notes>9-</notes>
		<cost type="multiplier">1</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется редко</name>
		<notes>6-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Наблюдатель (Watcher)</name>
		<cost type="multiplier">0.25</cost>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Соперник (Rival)</name>
		<cost type="multiplier">0.5</cost>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="3">
		<name>Охотник (Hunter)</name>
		<cost type="multiplier">1</cost>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неизвестный:</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B135</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Злой Близнец</name>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B135</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-3</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Злой Близнец</name>
		<notes>более опытный / дополнительные способоности</notes>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B135</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-3</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Evil Twin</name>
		<notes>более опытный и дополнительные способоности</notes>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B135</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-3</amount>
		</attribute_bonus>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B135</reference>
	<description-loc>"Враг" - это NPC, группа NPC или организация, которая активно действует лично против вас в ходе приключений. Одни Враги желают вас убить... другие преследуют более далеко идущие цели.
Определите сущность своего Врага при создании персонажа и объясните мастеру, почему Враг настроен против вас. Мастер волен добавлять подробности, которые сочтет нужными.
Цену этого недостатка определяют три фактора, касающиеся Врага: его сила, его намерения и частота его появления.


Сила
Чем могущественнее ваш Враг, тем больше очков вы получаете за данный недостаток. Эту цену устанавливает мастер. Помните, что, если Врагом является организация, число очков зависит от числа членов организации, выступающих против вас - а не от общего размера группы!


Один человек, менее сильный, чем персонаж (создан примерно на 50% от начальных очков персонажа). -5 очков.
Один человек, равный по силе персонажу (создан примерно на 100% от начальных очков персонажа) или небольшая группа менее сильных людей (от 3 до 5 человек). Примеры: сумасшедший ученый или четверка братьев соперника, убитого вами на дуэли. -10 очков.
Один человек, превосходящий персонажа по силе (создан как минимум на 150% от начальных очков персонажа) или средних размеров группа, состоящая из менее сильных людей (от 6 до 20 человек). Примеры: один сверхчеловек или полиция города (которая включает сотни человек, но не все они охотятся за вами одновременно). -20 очков.
Большая группа менее сильных людей (от 21 до 1,000 человек) или группа средних размеров, включающая несколько опасных людей или несколько сверхлюдей. Примеры: ФБР или Мафия. -30 очков.
Целое правительство или гильдия могущественных волшебников, организация сверхъестественных существ или иная крайне опасная группа. -40 очков.


Особые случаи
В двух случаях вам следует изменить приведенную выше цену до ее изменения в зависимости от намерений и частоты появления Врага:
Злой Близнец: Ваш Враг выглядит и говорит как вы, а возможно даже использует ваше имя, но действует абсолютно против вас. Зачастую людям будет казаться, что вы страдаете Раздвоением личности (B156), и они будут реагировать соответственно (-3 к реакции). Вы можете и не встретиться со своим Злым близнецом, но вы определенно услышите о нем - зачатую, когда вас обвинят в чем-то, чего вы не делали. Обычно Злой близнец обладает теми же умениями и способностями, что и вы, но его ментальные недостатки противоположны или отличны от ваших. Это делает его равным противником: Врагом на -10 очков. Если он сильнее вас, он стоит еще больше очков, потому что у него есть возможность выставить вас сумасшедшим, а у вас меньше вероятность предсказать его действия и помешать им.


Злой близнец более умел, чем вы или обладает способностями, которых нет у вас (по решению мастера): -5 очков.
Злой близнец более умел, чем вы и обладает способностями, которых у вас нет (по решению мастера): -10 очков.


Неизвестный: Вы знаете, что у вас есть Враг, но вы не знаете кто он. Сообщите мастеру уровень силы своего Врага. Он создаст Врага втайне и ничего вам про него не скажет! Эффект неожиданности увеличивает эффективный уровень сил вашего Врага, и повышает стоимость данного недостатка. -5 очков.


Намерения
Чем более неприятны намерения вашего Врага, тем выше его стоимость:


Наблюдатель: Враг преследует вас и следит за вами. Это раздражает, вам сложнее хранить тайны, но это редко доставляет что-то более легкого неудобства. Примеры: настойчивый журналист, преследующий политика, детектив, следящий за подозреваемым. x1/4
Соперник: Враг желает превзойти вас или усложнить вам жизнь, либо жестоко и грубо шутит над вами (это типично для большинства Злых близнецов), но не переходит грань, после которой вам был бы причинен вред. Примеры: политический противник другого политического деятеля, детектив, надоедающий подозреваемому. x1/2
Охотник: Враг намеревается арестовать, разорить, ранить или причинить вам иной ущерб - либо просто хочет вас убить. Примеры: убийца, охотящийся за политиком, детективы, желающие арестовать подозреваемого. x1


Частота появления
Выберите частоту появления, как описано в разделе Частота появления (B36). Делайте проверку в начале каждого приключения, или в начале каждой сессии длительного приключения.


Ограничения на Врагов
Вы не можете брать более двух Врагов и не можете получить более -60 очков за Врагов. (Если за вами охотится все правительство США, тот факт, что ваш профессор из колледжа сошел с ума и тоже за вами охотится, уже не имеет особого значения.)


Враги в игре
Если кубики показали, что Враг должен появиться, мастеру следует решить, как и где Враг окажется вовлеченным в приключение. Если Враг очень силен или одновременно появляется несколько разных Врагов, это может повлиять на все приключение.
Если вы выбрали особо могущественного Врага, то очень вероятно, что вас скоро посадят в тюрьму или убьют. Так и должно быть. Вы можете получить бонус  в размере 60 очков за Врага (ФБР, 12 или меньше; Охотник), но все ваши приключения превратятся в приключения разыскиваемого преступника. Даже при наличии дополнительных 60 очков ваша карьера может оказаться недолгой.
Если вы начинаете со слабым Врагом или ведете умную игру, то можете уничтожить врага или навсегда изменить его отношение к вам. Но, как говорится, "бесплатный сыр бывает только в мышеловке". Если вы избавились от Врага, то у вас есть три варианта:


1. Выплатить необходимое количество очков персонажа, чтобы вернуть бонус, полученный за данного Врага.
2. Взять недостаток вместо потерянного. Например, в последнем бою вас могли ударить ногой по голове, отчего вы частично оглохли. Или на вас напал гигантский паук, отчего у вас появилась арахнофобия. Этот новый недостаток должен стоить столько же очков, сколько стоил ваш бывший Враг (или меньше, если вы хотите выкупить недостаток частично). Если вы не можете придумать хороший недостаток на замену, то мастер будет крайне счастлив предложить свой вариант!
3. Взять нового Врага равного по стоимости. Вы может быть и уничтожили злобного Доктора Скорпиона - но его брат продолжает свое черное дело.</description-loc>
</advantage>
	<advantage version="2">
		<name>Enhanced Block</name>
		<name-loc>Блок</name-loc>
		<description-loc>Вы получаете +1 к блокированию щитом или плащом. 5 очков.</description-loc>
		<type>Mental</type>
		<base_points>5</base_points>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Enhanced Dodge</name>
		<name-loc>Уклонение</name-loc>
		<description-loc>Вы получаете +1 к уклонению. 15 очков.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Enhanced Move (Air: @New Move@)</name>
		<name-loc>Увеличенная скорость  (Воздух)</name-loc>
		<description-loc>Вы можете быстро двигаться. Каждый уровень расширенного движения удваивает вашу максимальную скорость в одной среде (воздух, поверхность, космос, вода). Возможно купить половину уровня – это будет стоить 10 очков, и будет иметь множитель 1.5.
Пример 1. Супер покупает Увеличенную скорость 4 (земля) за 80 очков. Он умножает скорость на 2х2х2х2 = 16. если его базовая скорость 8 – он сможет бежать со скоростью 128 (262 мили в час)!
Пример 2. Летающая раса имеет Увеличенную скорость 2.5 (воздух), оплатив 50 очков. все члены этой расы увеличивают максимальную скорость полета в 2х2х1.5 = 6 раз.
Полученная скорость – максимальная и отмечается одельно (в примере с супер-героем выше, он запишет так: Увеличенная скорость 4 (скорость по земле – 128), вы всегда можете выбирать скорость своего движения.
Расширенное движение не воздействует на базовую скорость и уклонение, оно работает только при движении по относительно прямому маршруту (см. Спринт, с. B354). Однако, она вносит свой вклад в защиту: атакующие вас издалека должны будут принять вашу скорость в расчет при взятии штрафов за скорость цели (с. B550).

Большинство видов Увеличенной скорости имеют пререквизиты: Для движения под водой требуется иметь преимущества Амфибия (с. B40) или Водный (с. B145), в воздухе – Полет (с. B56), в космосе – Полет в космосе.
===Особые улучшения.===

Бонус к управлению (Handling Bonus): Вы получаете +1 бонус к DX или навыкам вождения для сохранения контроля при скорости выше вашей базовой. +5% за каждые +1 к навыку, до максимума в +5. 

===Особые ограничения.===

Штраф к управлению (Handling Penalty): вы получаете штраф к DX или управлению на высокой скорости. -5% за уровень.

Полное внимание (All-Out): Столь быстрое движение требует вашего полного внимания. Использование Увеличенного движения подобно Тотальной атаке… но без атаки. Вы не получаете права на активную защиту, не можете ни атаковать, ни концентрироваться, ни делать вообще что-либо еще во время движения с увеличенной скоростью. Определите, что вы делаете в этот момент: хлопаете крыльями изо всех сил, направляете всю свою энергию на извержение реактивной струи и т.д. Это стоит меньше обычного модификатора Тотальное действие (с.110), поскольку не ограничивает ваше Движение его половиной при движении вперед. -20%.

Изменение скорости (Newtonian): Это ограничение для Увеличенной скорости (космос). Ваша «максимальная скорость» - «Delta-V», общее изменение скорости, которое вы можете произвести до исчерпания запаса энергии. Когда вы в общем измените скорость (ускоритесь и замедлитесь) до этого значения – вам будет необходима заправка, прежде чем вы сможете изменить скорость снова. -50%.
Привязанный к дороге (Road-Bound): только для наземной скорости: ваше расширенное движение эффективно только при движении по относительно ровной плоской поверхности. Часто сочетается с недостатком Колесный (с. B145). -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Пол уровня (Half level)</name>
			<cost type="points">10</cost>
			<affects>total</affects>
			<reference>B52</reference>
			<attribute_bonus>
				<attribute>air move</attribute>
				<amount>0.59</amount>
			</attribute_bonus>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Улучшенное управление (Handling Bonus)</name>
			<cost type="percentage">5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ухудшенное управление (Handling Penalty)</name>
			<cost type="percentage">-5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ньютоновский (Newtonian)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Магистральный (Road-Bound)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>All-Out</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup26</reference>
			<notes>Мгновенное ускорение</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup27</reference>
			<notes>Полная маневренность</notes>
		</modifier>
		<attribute_bonus>
			<attribute>air move</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
		<reference>B52</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Move (Ground: @New Move@)</name>
		<name-loc>Увеличенная скорость  (Земля)</name-loc>
		<description-loc>Вы можете быстро двигаться. Каждый уровень расширенного движения удваивает вашу максимальную скорость в одной среде (воздух, поверхность, космос, вода). Возможно купить половину уровня – это будет стоить 10 очков, и будет иметь множитель 1.5.
Пример 1. Супер покупает Увеличенную скорость 4 (земля) за 80 очков. Он умножает скорость на 2х2х2х2 = 16. если его базовая скорость 8 – он сможет бежать со скоростью 128 (262 мили в час)!
Пример 2. Летающая раса имеет Увеличенную скорость 2.5 (воздух), оплатив 50 очков. все члены этой расы увеличивают максимальную скорость полета в 2х2х1.5 = 6 раз.
Полученная скорость – максимальная и отмечается одельно (в примере с супер-героем выше, он запишет так: Увеличенная скорость 4 (скорость по земле – 128), вы всегда можете выбирать скорость своего движения.
Расширенное движение не воздействует на базовую скорость и уклонение, оно работает только при движении по относительно прямому маршруту (см. Спринт, с. B354). Однако, она вносит свой вклад в защиту: атакующие вас издалека должны будут принять вашу скорость в расчет при взятии штрафов за скорость цели (с. B550).

Большинство видов Увеличенной скорости имеют пререквизиты: Для движения под водой требуется иметь преимущества Амфибия (с. B40) или Водный (с. B145), в воздухе – Полет (с. B56), в космосе – Полет в космосе.
===Особые улучшения.===

Бонус к управлению (Handling Bonus): Вы получаете +1 бонус к DX или навыкам вождения для сохранения контроля при скорости выше вашей базовой. +5% за каждые +1 к навыку, до максимума в +5. 

===Особые ограничения.===

Штраф к управлению (Handling Penalty): вы получаете штраф к DX или управлению на высокой скорости. -5% за уровень.

Полное внимание (All-Out): Столь быстрое движение требует вашего полного внимания. Использование Увеличенного движения подобно Тотальной атаке… но без атаки. Вы не получаете права на активную защиту, не можете ни атаковать, ни концентрироваться, ни делать вообще что-либо еще во время движения с увеличенной скоростью. Определите, что вы делаете в этот момент: хлопаете крыльями изо всех сил, направляете всю свою энергию на извержение реактивной струи и т.д. Это стоит меньше обычного модификатора Тотальное действие (с.110), поскольку не ограничивает ваше Движение его половиной при движении вперед. -20%.

Изменение скорости (Newtonian): Это ограничение для Увеличенной скорости (космос). Ваша «максимальная скорость» - «Delta-V», общее изменение скорости, которое вы можете произвести до исчерпания запаса энергии. Когда вы в общем измените скорость (ускоритесь и замедлитесь) до этого значения – вам будет необходима заправка, прежде чем вы сможете изменить скорость снова. -50%.
Привязанный к дороге (Road-Bound): только для наземной скорости: ваше расширенное движение эффективно только при движении по относительно ровной плоской поверхности. Часто сочетается с недостатком Колесный (с. B145). -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Пол уровня (Half level)</name>
			<cost type="points">10</cost>
			<affects>total</affects>
			<reference>B52</reference>
			<attribute_bonus>
				<attribute>ground move</attribute>
				<amount>0.59</amount>
			</attribute_bonus>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Улучшенное управление (Handling Bonus)</name>
			<cost type="percentage">5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ухудшенное управление (Handling Penalty)</name>
			<cost type="percentage">-5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ньютоновский (Newtonian)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Магистральный (Road-Bound)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>All-Out</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup26</reference>
			<notes>Мгновенное ускорение</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup27</reference>
			<notes>Полная маневренность</notes>
		</modifier>
		<attribute_bonus>
			<attribute>ground move</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>		
		<reference>B52</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Move (Space: @New Move@)</name>
		<name-loc>Увеличенная скорость  (Космос)</name-loc>
		<description-loc>Вы можете быстро двигаться. Каждый уровень расширенного движения удваивает вашу максимальную скорость в одной среде (воздух, поверхность, космос, вода). Возможно купить половину уровня – это будет стоить 10 очков, и будет иметь множитель 1.5.
Пример 1. Супер покупает Увеличенную скорость 4 (земля) за 80 очков. Он умножает скорость на 2х2х2х2 = 16. если его базовая скорость 8 – он сможет бежать со скоростью 128 (262 мили в час)!
Пример 2. Летающая раса имеет Увеличенную скорость 2.5 (воздух), оплатив 50 очков. все члены этой расы увеличивают максимальную скорость полета в 2х2х1.5 = 6 раз.
Полученная скорость – максимальная и отмечается одельно (в примере с супер-героем выше, он запишет так: Увеличенная скорость 4 (скорость по земле – 128), вы всегда можете выбирать скорость своего движения.
Расширенное движение не воздействует на базовую скорость и уклонение, оно работает только при движении по относительно прямому маршруту (см. Спринт, с. B354). Однако, она вносит свой вклад в защиту: атакующие вас издалека должны будут принять вашу скорость в расчет при взятии штрафов за скорость цели (с. B550).

Большинство видов Увеличенной скорости имеют пререквизиты: Для движения под водой требуется иметь преимущества Амфибия (с. B40) или Водный (с. B145), в воздухе – Полет (с. B56), в космосе – Полет в космосе.

===Особые улучшения.===

Бонус к управлению (Handling Bonus): Вы получаете +1 бонус к DX или навыкам вождения для сохранения контроля при скорости выше вашей базовой. +5% за каждые +1 к навыку, до максимума в +5. 

===Особые ограничения.===

Штраф к управлению (Handling Penalty): вы получаете штраф к DX или управлению на высокой скорости. -5% за уровень.

Полное внимание (All-Out): Столь быстрое движение требует вашего полного внимания. Использование Увеличенного движения подобно Тотальной атаке… но без атаки. Вы не получаете права на активную защиту, не можете ни атаковать, ни концентрироваться, ни делать вообще что-либо еще во время движения с увеличенной скоростью. Определите, что вы делаете в этот момент: хлопаете крыльями изо всех сил, направляете всю свою энергию на извержение реактивной струи и т.д. Это стоит меньше обычного модификатора Тотальное действие (с.110), поскольку не ограничивает ваше Движение его половиной при движении вперед. -20%.

Изменение скорости (Newtonian): Это ограничение для Увеличенной скорости (космос). Ваша «максимальная скорость» - «Delta-V», общее изменение скорости, которое вы можете произвести до исчерпания запаса энергии. Когда вы в общем измените скорость (ускоритесь и замедлитесь) до этого значения – вам будет необходима заправка, прежде чем вы сможете изменить скорость снова. -50%.
Привязанный к дороге (Road-Bound): только для наземной скорости: ваше расширенное движение эффективно только при движении по относительно ровной плоской поверхности. Часто сочетается с недостатком Колесный (с. B145). -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Пол уровня (Half level)</name>
			<cost type="points">10</cost>
			<affects>total</affects>
			<reference>B52</reference>
			<attribute_bonus>
				<attribute>space move</attribute>
				<amount>0.59</amount>
			</attribute_bonus>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Улучшенное управление (Handling Bonus)</name>
			<cost type="percentage">5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ухудшенное управление (Handling Penalty)</name>
			<cost type="percentage">-5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ньютоновский (Newtonian)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Магистральный (Road-Bound)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>All-Out</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup26</reference>
			<notes>Мгновенное ускорение</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup27</reference>
			<notes>Полная маневренность</notes>
		</modifier>
		<attribute_bonus>
			<attribute>space move</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>			
		<reference>B52</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Move (Water: @New Move@)</name>
		<name-loc>Увеличенная скорость  (Вода)</name-loc>
		<description-loc>Вы можете быстро двигаться. Каждый уровень расширенного движения удваивает вашу максимальную скорость в одной среде (воздух, поверхность, космос, вода). Возможно купить половину уровня – это будет стоить 10 очков, и будет иметь множитель 1.5.
Пример 1. Супер покупает Увеличенную скорость 4 (земля) за 80 очков. Он умножает скорость на 2х2х2х2 = 16. если его базовая скорость 8 – он сможет бежать со скоростью 128 (262 мили в час)!
Пример 2. Летающая раса имеет Увеличенную скорость 2.5 (воздух), оплатив 50 очков. все члены этой расы увеличивают максимальную скорость полета в 2х2х1.5 = 6 раз.
Полученная скорость – максимальная и отмечается одельно (в примере с супер-героем выше, он запишет так: Увеличенная скорость 4 (скорость по земле – 128), вы всегда можете выбирать скорость своего движения.
Расширенное движение не воздействует на базовую скорость и уклонение, оно работает только при движении по относительно прямому маршруту (см. Спринт, с. B354). Однако, она вносит свой вклад в защиту: атакующие вас издалека должны будут принять вашу скорость в расчет при взятии штрафов за скорость цели (с. B550).

Большинство видов Увеличенной скорости имеют пререквизиты: Для движения под водой требуется иметь преимущества Амфибия (с. B40) или Водный (с. B145), в воздухе – Полет (с. B56), в космосе – Полет в космосе.

===Особые улучшения.===

Бонус к управлению (Handling Bonus): Вы получаете +1 бонус к DX или навыкам вождения для сохранения контроля при скорости выше вашей базовой. +5% за каждые +1 к навыку, до максимума в +5. 

===Особые ограничения.===

Штраф к управлению (Handling Penalty): вы получаете штраф к DX или управлению на высокой скорости. -5% за уровень.

Полное внимание (All-Out): Столь быстрое движение требует вашего полного внимания. Использование Увеличенного движения подобно Тотальной атаке… но без атаки. Вы не получаете права на активную защиту, не можете ни атаковать, ни концентрироваться, ни делать вообще что-либо еще во время движения с увеличенной скоростью. Определите, что вы делаете в этот момент: хлопаете крыльями изо всех сил, направляете всю свою энергию на извержение реактивной струи и т.д. Это стоит меньше обычного модификатора Тотальное действие (с.110), поскольку не ограничивает ваше Движение его половиной при движении вперед. -20%.
 
Изменение скорости (Newtonian): Это ограничение для Увеличенной скорости (космос). Ваша «максимальная скорость» - «Delta-V», общее изменение скорости, которое вы можете произвести до исчерпания запаса энергии. Когда вы в общем измените скорость (ускоритесь и замедлитесь) до этого значения – вам будет необходима заправка, прежде чем вы сможете изменить скорость снова. -50%.
Привязанный к дороге (Road-Bound): только для наземной скорости: ваше расширенное движение эффективно только при движении по относительно ровной плоской поверхности. Часто сочетается с недостатком Колесный (с. B145). -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Пол уровня (Half level)</name>
			<cost type="points">10</cost>
			<affects>total</affects>
			<reference>B52</reference>
			<attribute_bonus>
				<attribute>water move</attribute>
				<amount>0.59</amount>
			</attribute_bonus>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Улучшенное управление (Handling Bonus)</name>
			<cost type="percentage">5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ухудшенное управление (Handling Penalty)</name>
			<cost type="percentage">-5</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ньютоновский (Newtonian)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Магистральный (Road-Bound)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B52</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>All-Out</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup26</reference>
			<notes>Мгновенное ускорение</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cosmic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>Sup27</reference>
			<notes>Полная маневренность</notes>
		</modifier>
		<attribute_bonus>
			<attribute>water move</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>			
		<reference>B52</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Parry (All parries)</name>
		<name-loc>Парирование  (Все)</name-loc>
		<description-loc>+1 к парированию голыми руками (5 очков), одним из видов оружия ближнего боя (5 очков) или любым парированиям (10 очков).
Этот талант определенно киношный (cinematic). Мастер может потребовать приобретения Ученика мастера или Мастера оружия. Также можно позволить воинам покупать эту черту на заработанные очки. Возможно даже разрешить несколько уровней, но выше +3 делают игру несбалансированной, даже в играх супергероев.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Enhanced Parry (@Melee weapon skill@)</name>
		<name-loc>Парирование  (@Холодное оружие@)</name-loc>
		<description-loc>+1 к парированию голыми руками (5 очков), одним из видов оружия ближнего боя (5 очков) или любым парированиям (10 очков).
Этот талант определенно киношный (cinematic). Мастер может потребовать приобретения Ученика мастера или Мастера оружия. Также можно позволить воинам покупать эту черту на заработанные очки. Возможно даже разрешить несколько уровней, но выше +3 делают игру несбалансированной, даже в играх супергероев.</description-loc>
		<notes>Программа не учитывает этот бонус, добавляйте сами!</notes>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Parry (Bare hands)</name>
		<name-loc>Парирование  (Без оружия)</name-loc>
		<description-loc>+1 к парированию голыми руками (5 очков), одним из видов оружия ближнего боя (5 очков) или любым парированиям (10 очков).
Этот талант определенно киношный (cinematic). Мастер может потребовать приобретения Ученика мастера или Мастера оружия. Также можно позволить воинам покупать эту черту на заработанные очки. Возможно даже разрешить несколько уровней, но выше +3 делают игру несбалансированной, даже в играх супергероев.</description-loc>
		<notes>Программа не учитывает этот бонус, добавляйте сами!</notes>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B51</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Enhanced Time Sense</name>
		<name-loc>Улучшенное восприятие времени</name-loc>
		<description-loc>Вы получаете и обрабатываете информацию намного быстрее, чем обычный человек. Это увеличивает скорость вашей мысли – и особенно реакции – но не физическую скорость.
Во-первых, это преимущество включает все выгоды от Боевых рефлексов (с. B43). В бою вы всегда реагируете раньше тех, кто не имеет этого преимущества, независимо от базовой скорости. Между имеющими УВВ идет распределение по их базовой скорости – но все они будут действовать раньше не имеющих этого преимущества.
Вы также можете воспринимать слишком быстрое для обычного восприятия движение. Например, вас невозможно обмануть голограммой – вы видите смену кадров. Вы можете обнаружить высокоскоростную секретную передачу, если наблюдаете за передачей (хотя не обязательно ее расшифруете). На усмотрение мастера, вы можете броском восприятия увидеть даже пули в полете. УВВ особенно ценно, если вы обладаете силами, действующими со скоростью мысли.
Ваши быстрые мысли позволяют вам быстро решить проблемы и принять решение – так что вы никогда не получите штрафов за нехватку времени на ментальную задачу (но УВВ не позволяет ускорить физической работы). Мастер не может от вас требовать принятия немедленного решения (но не злоупотребляйте привилегией часа раздумий на каждый раунд боя!).
Исключением может являться вещи, которые даже для вас происходят слишком быстро. Если уж Мастер от вас требует немедленного решения, другие не получат права на него вообще.
УВВ не замедляет мир относительно вас. Вы можете получать удовольствие от фильма, игнорируя кадры, как человек может не обращать внимания на буквы в словах. Также оно не позволяет нарушать законы физики – некоторые вещи (лучи лазера) движутся слишком быстро, чтобы их заметить.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>45</base_points>
		<reference>B52</reference>
		<notes>Действуете раньше тех у кого нет этого преимущества. Никогда не "замираете" в неожиданной ситуации, +6 на все броски IQ прийти в себя после внезапной атаки или ментального «оглушения»; +1 инициативе (+2 если лидер)</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="contains">fast-draw</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>fright check</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">Combat Reflexes</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Enhanced Tracking</name>
	<name-loc>Улучшенное слежение</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Multiple Lock-Ons</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P49</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B53</reference>
	<description-loc>Вы способны следить за несколькими целями – возможно, у вас есть встроенный сенсор или глаза, способные к независимому движению. Каждый уровень преимущества позволяет вам следить за одной дополнительной целью или движениями, и использовать на все отслеживаемые цели маневры Прицеливание или Оценка. Вы можете следить только за теми целями, которые в состоянии обнаружить, и не можете целиться в больше мишеней, чем у вас есть готового оружия.

===Новое особое улучшение===
Мульти-слежение (Multiple Lock-Ons): вы можете отслеживать несколько целей даже если имеете одно оружие, и получаете выгоды Прицеливания или Оценки при атаке по любой из них. На такое способны некоторые киношные воины и высокотехнологичные сенсорные системы. +20%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Entomophobia (Insects)</name>
	<name-loc>Боязнь насекомых (Энтомофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь всех "жуков". Большие или ядовитые насекомые дают пенальти -3 к проверкам на самоконтроль, огромные или в больших количествах -6. Избегайте муравейников с гигантскими муравьями. -10 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Epilipsy</name>
		<name-loc>Эпилепсия
</name-loc>
		<description-loc>Вы страдаете тяжелой формой эпилепсии. С вами случаются припадки, во время которых ваши конечности неконтролируемо подергиваются, и вы не способны говорить или ясно мыслить.
Каждый раз в стрессовой ситуации (особенно если что-то угрожает вашей жизни или жизни друга) выполняйте проверку HT. Если у вас есть какая-либо Фобия, то появление объекта вашей боязни считается стрессовой ситуацией; делайте проверку против HT каждые 10 минут. В случае неудачи с вами случается припадок, продолжающийся 1d минут и отнимающий 1d FP. В течение этого времени вы не можете делать ничего.
Вы можете постараться вызвать припадок с помощью самовнушения. Это требует одной минуты концентрации и успешной проверки на Волю(Will) или Самогипноз. Припадок в месте, пронизанном сверхъестественной энергией, может вызывать видения. Насколько они будут полезны, решает мастер.
Низко развитые существа, которые не понимают, что такое "приступ", могут быть напуганы им или даже могут поверить, что ваш припадок - это общение с богами. Сделайте проверку реакции с +1. "Очень хорошая" реакция и выше означает благоговейный трепет! "Слабая" реакция и ниже заставляет наблюдателей бежать - но не нападать (если ничто иное их к этому не провоцирует).</description-loc>
		<type>Physical</type>
		<base_points>-30</base_points>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Expression</name>
		<name-loc>Выражения</name-loc>
		<description-loc>
Постоянно восклицать «Ёлки-палки!» или «Боже ты мой»... или подбрасывать в воздух серебряную монетку... или никогда не садиться спиной к двери.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>"@Что говорит?@"</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Extended Lifespan</name>
		<name-loc>Увеличенная продолжительность жизни</name-loc>
		<description-loc>Средняя продолжительность жизни определена как 18-летнее детство, 32-летний взросление и так далее. Один уровень Увеличенной продолжительности жизни удвоит эти сроки, два уровня учетверят, и так далее. Если вам необходимо взять более 7 уровней черты (срок совершеннолетия – 2,304 года, а начало старения – в 6,400 лет) – лучше будет взять Нестареющий (с. B95).</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B53</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Extra Arm</name>
	<name-loc>Дополнительные руки</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Очень гибкий (Extra-Flexible)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Длинный (Long)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Ноги-манипуляторы (Foot Manipulators)</name>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Нет физической атаки (No Physical Attack)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Короткая (Short)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Слабая (Weak)</name>
		<notes>Половина ST тела</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Слабая (Weak)</name>
		<notes>четверть ST тела</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Встроенное оружие (Weapon Mount)</name>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B53</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B53</reference>
	<description-loc>Рукой считается конечность, способная к манипулированию объектами, независимо от того, откуда она растет. Нормальная рука может бить, нанося Кол-1 тупого вреда, основанного на ST. Человеческая норма – две руки, и это стоит 0 очков. Каждая дополнительная рука требует оплаты.
Координация.
Вы можете свободно использовать дополнительные руки для выполнения небоевых задач. Так, тремя руками вы можете одновременно печатать и использовать мышь. Для задач, требующих постоянного внимания вам нужно Улучшенное Слежение (с. B53). 
В бою вы можете проводить простые боевые маневры (захват), используя все руки сразу. Если у вас есть три и больше рук, вы можете в одной руке держать щит, а в других двух – двуручный меч, также как обычный боец может одновременно использовать щит и одноручный меч.
Однако, независимо от количества рук, вы не получаете ни одной дополнительной атаки – для этого приобретается преимущество Дополнительная атака.
Ближний бой с дополнительными руками.

Дополнительные руки дают вам серьезное преимущество в борьбе. Вы не можете бить одновременно всеми руками, но вы можете ими всеми хватать! Каждая дополнительная рука свыше обычного набора в две штуки, дает вам +2 к любой попытке захвата, или освобождения от него. Обладание большим количеством рук, чем есть у вашего оппонента, дает вам также +3 на попытки прижать его, или сопротивляться его попытке сделать то же самое с вами.

===Особые улучшения.===

Сверхгибкие (Extra Flexible): Ваши руки более гибки, чем обычные руки – как щупальца или хобот слона. Это позволяет им достигать любой точки в пределах длины – рука больше не зависит от положения тела, разворота его или расположения руки слева или справа тела. +50%.

Длинные (Long): Ваши руки относительно длиннее. Это дает им увеличенную досягаемость (reach) – по +1 SM за уровень (см. SM и досягаемость, с. B402), включая досягаемость (reach) оружия, используемого этой рукой. Также каждый уровень увеличивает амплитудные повреждения на +1 за кубик. +100% за уровень.

===Особые ограничения.===

Нога-манипулятор (Foot Manipulator): ваша рука – просто необычайно ловкая нога. Вы не можете ходить, когда используете предметы (хотя вы можете летать, сидеть или плыть). Это просто вариант ограничения Временный недостаток (см. недостаток Безногий, с. B141). также такие руки обычно – но не всегда – коротки (см. ниже). -30%.

Неатакующая (No Physical Attack): Конечность может использовать предметы, но не оружие ближнего боя, и не дает бонуса в ближнем бою. Вы можете использовать дальнобойное оружие. -50%.

Короткая (Short): Досягаемость рук – «С» (reach C); не дает размахнуться большинством оружия. Досягаемость (reach) любого оружия ближнего боя в этой руке меньше на 1 ярд. Если все ваши руки коротки, вы получаете -2 на попытки захвата. -50%.

Слабая (Weak): сила этой руки меньше, чем сила тела. За половину силы -25%, за четверть -50%.
Оружейное крепление (Weapon Mount): это не рука, а просто крепление для оружия (не зависит от того, какое именно – механическое, биологическое или другое). Ни для чего другого использоваться не может. Несовместимо с Короткой, Неатакующей, Ногой-манипулятором, Слабой. -80%.
Модификация двуруких существ. 
Очковая цена стоит 1/10 соответствующего процентного модификатора. Так, человек с одной короткой рукой (-50%) имеет недостаток в -5 очков. Человек, у которого обе руки коротки, получает недостаток на -10 очков.
Однорукие существа могут применить эти модификаторы только к одной своей руке, но имеют недостаток Однорукий (с.147). Например, слон имеет хобот, который Сверхгибкий (+50%), Длинный (+100%), и Слабый (-50%): Итоговая стоимость этих модификаторов - +100%, что дает преимущество на 10 очков. Однако, -20 очков от недостатка Однорукий, приводят к итоговому изменению цены -10 очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Extra Attack</name>
		<name-loc>Дополнительная атака</name-loc>
		<description-loc>Вы можете атаковать больше одного раза в ход. По умолчанию, пероснаж в GURPS может атаковать только раз в ход. Каждый уровень этого преимущества дает возможность одной дополнительной атаки. Вы не можете атаковать больше раз, чем у вас есть конечностей, атакующих сил и природного оружия.
Обычный человек может купить только одну дополнительную атаку – и атаковать двумя руками сразу, что обычно отражает превосходную координацию. Суперы и нелюди часто не имеют такого ограничения. Супер-полицейский может взять две дополнительных атаки, и одновременно стрелять лучами из глаз, из пистолета, и бить дубинкой. Дракон может взять целых четыре – и атаковать пять раз за ход, четырьмя лапами, зубами, рогами, крыльями и огненным дыханием!        
По сути, Дополнительная атака – это особый маневр в ваш ход. Она не снимет штраф за неудобную руку (см. Обоюдорукость, с. B39), и не позволит использовать одновременно два маневра прицеливания (см. Улучшенное отслеживание, с.53). Вы можете использовать некоторые из ваших атак в виде Финта, но не можете использовать одновременно два действия другого вида (это требует Ускоренного течения времени, с. B38).
Дополнительные атаки и Тотальная атака (all-out attack).
При использовании тотальной атаки, один вид атаки применяется ко всем атакам, производимым в ход. Персонаж не может выбрать одновременно для одной атаки Тотальная атака (точная) (all-out attack), а для другой – Тотальная атака (сильная) (all-out attack). Если он выбирает Тотальная атака (двойная) (all-out attack), он получает еще одну атаку за ход.
Дополнительные атаки и Быстрый удар.
Персонаж с Дополнительными атаками также может использовать Быстрый удар (с. B370), для одной из них в свой ход, с обычными штрафами. Остальные считаются обычными атаками, и такого штрафа не получают. Использовать Быстрый удар для нескольких атак за один раунд нельзя.

===Новое особое улучшение===
Мульти-удар (Multi-Strike): Вы можете атаковать более одного раза одним оружием или частью тела.
Это значит, что вы можете сделать больше дополнительных атак, чем у вас есть атакующих способностей, конечностей или оружия. Вы можете использовать наилучшую свою атаку несколько раз. +20%.

===Новое особое ограничение===
Одно умение (Single Skill): Ваша дополнительная атака возможна только при использовании одного определенного умения. Например, Дополнительная атака 2 (одно умение, карате) позволит вам атаковать три раза – но минимум две из этих атак должны использовать умение Карате. Для повторных атак с использованием одного и того же оружейного умения, вы должны иметь по одному оружию для каждой атаки, если у вас нет Мульти-удара. -20%.
</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>25</points_per_level>
		<modifier version="1" enabled="no">
			<name>Multi-Strike</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P49</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Single Skill</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P49</reference>
			<notes>@Умение@</notes>
		</modifier>
		<reference>B53</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Extra Fatigue Points</name>
		<name-loc>Дополнительные очки усталости</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>3</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>fp</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Extra Fatigue Points</name>
		<name-loc>Дополнительные очки усталости</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>3</points_per_level>
		<modifier version="1">
			<name>Magic Only</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>FAQ 3.2.17</reference>
			<notes>Subject to involuntary FP drain</notes>
		</modifier>
		<reference>B16</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Extra Head</name>
	<name-loc>Дополнительная голова</name-loc>
	<points_per_level>15</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Периферическая (Extraneous)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B54</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B54</reference>
	<description-loc>Вы имеете больше одной головы, каждая из них имеет полностью функционирующие органы чувств. Каждая голова дает вам Дополнительный рот (с. B55) и один уровень Улучшенного Слежения (с. B53) бесплатно. Также каждая голова содержит дополнительный мозг, имеющий полную копию личности, памяти и навыков. Однако, они только копии, и не дают дополнительных ментальных действий – берите Разделенная сознание (с. B43). 

Вы не можете получить более 2*(НР/число голов) очков вреда от любой одной атаки по вашей шее или голове. Любой удар по голове, вызвавший потерю сознания вырубает только одну голову; другие продолжают работать. Критический удар, убивший бы обычного человека, просто уничтожает одну голову, нанося максимальное количество вреда (указано выше), и разбивая, отрубая или иначе уничтожая голову.

===Особые ограничения.===
Внешняя (Extraneous): ваша голова не содержит копии памяти, но дает вам дополнительный рот и способность к отслеживанию. Один удар по внешней голове может нанести не более НР/(1,5*число голов) очков вреда, но удар по реальной голове наносит вред по обычным правилам (может вырубить или убить). -20%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Extra Hit Points</name>
		<name-loc>Дополнительные очки жизни</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<modifier version="1" enabled="no">
			<name>Размер (Size)</name>
			<cost type="percentage">-10</cost>
			<levels>1</levels>
			<affects>total</affects>
		</modifier>
		<reference>B16</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>hp</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
	<name>Extra Legs</name>
	<name-loc>Дополнительные ноги</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@3 или 4 ноги@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B54</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@5 или 6 ноги@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B55</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@7 и более ног@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B55</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Длинные (Long)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B55</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Не могут бить (Cannot Kick)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B55</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B54</reference>
	<description-loc>Если вы можете использовать конечность для ходьбы, но не для манипуляции – это нога. Нормальная нога может пинать, нанося колющие/тупые повреждения на обычной дистанции (для человека – 1 ярд). Норма для человека – 2 ноги, они даются бесплатно. Дополнительные ноги стоят очков.

3-4 ноги: если вы потеряете ногу, вы можете передвигаться с половиной скорости. Потеря еще одной ноги заставит вас упасть. 5 очков.

5-6 ног: каждая потерянная нога уменьшает вашу скорость на 20%, потеря 4 ног – падение. 10 очков.

7+ ног: каждая потерянная нога уменьшает скорость на 10%. Если у вас останется только три ноги, вы сможете передвигаться только с 40% нормальной скорости, а если потеряете еще одну – упадете. 15 очков

===Особые улучшения.===

Длинные ноги (Long): Ваши ноги пропорционально длиннее. Это увеличивает ваш эффективный SM в целях преодоления препятствий и расчета досягаемости (reach). +100% за +1 SM.

===Особые ограничения.===
Невозможность атаки (Cannot Kick): вы не можете атаковать этой ногой. -50%.
Модификация существ с двумя ногами. 
Очковая цена стоит 1/10 процентного модификатора. Так, человек, неспособный пинать (-50%) имеет недостаток в -5 очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Extra Life</name>
		<name-loc>Дополнительная жизнь</name-loc>
		<description-loc>Вы можете воскреснуть из мертвых! Не имеет значения, от чего вы погибнете, на самом деле вы не умираете. Отработайте детали с мастером. Каждый раз, когда вы возвращаетесь к жизни, вы тратите одну Дополнительную жизнь – сотрите ее с листа персонажа и уменьшите итоговую стоимость его на 25 очков. Мастер может позволить игрокам потратить заработанные очки на покупку дополнительной жизни в процессе игры.
===Особые ограничения.===

Копия (Copy): При гибели вы возвращаетесь в «резервную копию». Создание копии занимает от нескольких минут до многих часов, возможно с использованием особого оснащения. Разработка деталей остается за мастером. Вы делаете копию листа персонажа когда создаете резервную копию. Возвращаясь к сохраненному состоянию, вы теряете все изменения, заработанные после создания копии. Обратите внимание, что копия существует и до вашей смерти. Вы должны сказать мастеру, где вы ее храните. После смерти вы вернетесь к жизни в этом месте. Если ваши враги прознают, где вы храните вашу копию, они могут разделаться с ней заранее. -20%.
Требуется тело (Requires Body): Вы возвращаетесь к жизни без тела – например, в виде духа или цифровой копии на компьютере. Весь ваш опыт и способности сохраняются (если вы не взяли еще и Копию), но вы не можете взаимодействовать с окружающим миром, пока не приобретете новое тело. Это может быть клон, неупокоенный труп или даже робот. От -20% до -40% - в зависимости от легальности, редкости и ценности тела.</description-loc>
		<type>Mental, Exotic</type>
		<levels>1</levels>
		<points_per_level>25</points_per_level>
		<modifier version="1" enabled="no">
			<name>Copy</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B55</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Требует тела (Requires Body)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B55</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Требует тела (Requires Body)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B55</reference>
			<notes>@незаконно, редкое или дорогое@</notes>
		</modifier>
		<reference>B55</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Extra Mouth</name>
		<name-loc>Дополнительный рот</name-loc>
		<description-loc>У вас есть дополнительный полностью функциональный рот, который может быть расположен где угодно на вашем теле. Все ваши рты способны дышать, есть и говорить. Дополнительный рот позволит вам лишний раз укусить врага, если у вас есть Дополнительная атака (с. B53). Если у вас есть Разделенное (Compartmentalized Mind, с. B43), вы можете поддерживать несколько разговоров, или колдовать несколько заклинаний, требующих только речевого компонента. Другие выгоды – вам сложно заткнуть рот или задушить, и вы можете петь хором сами с собой!</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B55</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Extra Sleep</name>
		<name-loc>Долго спит
</name-loc>
		<description-loc>Вам необходимо спать дольше, чем большинству людей. Нормальному человеку необходимо спать по 8 часов каждую ночь. Каждый уровень (максимум - четыре) означает, что вам на сон требуется дополнительно час. Таким образом, вы должны рано ложиться или вставать на несколько часов позже каждый день. Это дает вам меньше времени на учебу или какую-либо работу в течение дня.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-2</points_per_level>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Fanaticism (@Group or ideal@)</name>
		<name-loc>Фанатизм (@Группа или идея@)</name-loc>
		<description-loc>Вы столь сильно верите в некую страну, организацию, философию или религию, что ставите ее превыше всего остального. Вы даже можете испытывать желание погибнуть за нее! Если объект вашего Фанатизма требует следования определенному кодексу поведения или верности лидеру, вы выполняете это сознательно и беспрекословно. Вы обязаны отыгрывать свою неколебимую преданность.
Фанатизм не делает вас глупым или злым. Свирепый жрец Сета, размахивающий окровавленным кинжалом, - фанатик. Но такой же фанатик - пилот камикадзе, отдающий свою жизнь ради уничтожения вражеского авианосца. И такой же фанатик - патриот, говорящий: "Дайте мне свободу или смерть!" Фанатизм - это склад ума; разница в том, к чему относится ваш фанатизм.


Крайний фанатизм: Это высшая форма Фанатизма. Вы получаете +3 ко всем проверкам Воли(Will), чтобы избежать Промывания мозгов, Допрашивания и сверхъестественного воздействия на сознание в случаях, когда неудача приведет к предательству своей веры или организации. С другой стороны, вы без колебаний умрете за свое дело и с легкостью пойдете на самоубийственное задание. Это стоит те же -15 очков. Ваша готовность умереть уравновешивается бонусом к Воле(Will) (который будет помогать вам достаточно часто, если правильно отыгрывать роль).</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<modifier version="1" enabled="no">
			<name>Крайний фанатизм (Extreme)</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B136</reference>
		</modifier>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Fashion Sense</name>
	<name-loc>Чувство стиля</name-loc>
	<base_points>5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Вы выбирали одежду</limitation>
		<amount>1</amount>
	</attribute_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B21</reference>
	<description-loc>В отношении моды вы всегда на шаг впереди толпы. Вы способны создать нечто модное даже из самых дешевых и непотребных материалов. Это дает +1 к проверкам реакции в социальном взаимодействии, когда у вас есть возможность принарядиться заранее. Кроме того, вы можете дать бонус +1 к реакции кому-то другому, если помогаете ему подобрать одежду.</description-loc>
</advantage>
	<advantage version="2">
		<name>Fat</name>
		<name-loc>Толстый</name-loc>
		<description-loc>Вы весите примерно 150% от нормы для данной ST. Вы получаете -2 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. Однако дополнительный запас жира дает вам +3 к проверкам Плавания и +2 к ST при попытке противостоять толканию. Ваш HT не может превышать 15.</description-loc>
		<type>Physical</type>
		<base_points>-3</base_points>
		<reference>B19</reference>
		<notes>+2 ST против отбрасывания</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">swimming</name>
			<specialization compare="is anything"></specialization>
			<amount>3</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="ht" compare="at most">15</attribute_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Fearfulness</name>
		<name-loc>Боязливость
</name-loc>
		<description-loc>Вы нервный и опасливый человек. Вычитайте свой уровень Боязливости из Воли(Will) каждый раз, когда выполняете Проверку на испуг, и каждый раз, когда необходимо сопротивляться Допрашиванию (B202) или сверхъестественным силам, вызывающим страх. Кроме того, добавьте свой уровень Боязливости ко всем проверкам на Запугивание, направленным против вас.
Вы не можете снизить уровень своей Воли(Will) ниже 3. Например, если ваша Воля(Will) 11, то ваш максимальный уровень недостатка Боязливость составляет 8.
Данная особенность является противоположностью Бесстрашию (B55); вы не можете взять и то, и другое одновременно.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>-2</points_per_level>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>fright check</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">fearlessness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Fearlessness</name>
		<name-loc>Бесстрашие</name-loc>
		<description-loc>Вас сложнее запугать! Уровень этого преимущества добавляется к броскам Воли(Will) при проверках на испуг и в случае Запугивания (см. B202), а также для противодействия сверхъестественных сил, внушающих страх. Уровень Бесстрашия вычитается из эффективного уровня Запугивания, применяемого против вас.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B55</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute>fright check</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Fewer Fatigue Points</name>
		<name-loc>Пониженные очки усталости</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-3</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>fp</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Fewer Hit Points</name>
		<name-loc>Пониженные очки жизни</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-2</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Attribute</category>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>hp</attribute>
			<amount per_level="yes">-1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Filter Lungs</name>
		<name-loc>Фильтрация воздуха</name-loc>
		<description-loc>Ваша дыхательная система способна отфильтровывать лишние компоненты – пыль, дым и даже слезоточивый газ, (но не кислоту и нервно-паралитический газ). Вы не получаете неприятных эффектов от таких неудобств. Это особенно полезно в чужих мирах или задымленных городах. Обратите внимание, что если у вас есть преимущество Не нуждается в дыхании (с. B49), вам не нужны фильтрующие легкие.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B55</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Fit</name>
	<name-loc>Спортивный</name-loc>
	<notes>+1 на броски HT чтобы оставаться в сознании, избежать смерти, сопротивляться болезням и ядам; восстанавливает FP вдвое быстрее (это не касается FP,  потраченное на магию или псионику)</notes>
	<base_points>5</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B55</reference>
	<description-loc>Вы гораздо более выносливы, чем обычные люди. Существует два уровня преимущества:

Крепкий (Fit): Вы получаете +1 на все броски НТ (на сохранение сознания, избегание смерти, сопротивление ядам и болезням, и т.д.). Это преимущество не увеличивает действительный уровень НТ, и не влияет на умения, основанные на НТ. Также вы восстанавливаете усталость в два раза быстрее. 5 очков.
Очень крепкий (Very Fit): Как описано выше, но бонус к НТ составляет +2. Дополнительно, вы устаете в два раза медленнее. 15 очков.

В любом случае, это преимущество действует только на потерю FP вследствие физической нагрузки, перегрева и так далее. Оно никак не восстанавливает FP, потраченное магию или псионику. </description-loc>
</advantage>
	<advantage version="2">
	<name>Fit, Very</name>
	<name-loc>Спортивный(Очень)</name-loc>
	<notes>+2 на броски HT чтобы оставаться в сознании, избежать смерти, сопротивляться болезням и ядам; восстанавливает FP вдвое быстрее; теряет FP вдвое медленнее (в обоих случаях это не касается FP, потраченное на магию или псионику)</notes>
	<base_points>15</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B55</reference>
	<description-loc>Вы гораздо более выносливы, чем обычные люди. Существует два уровня преимущества:

Крепкий (Fit): Вы получаете +1 на все броски НТ (на сохранение сознания, избегание смерти, сопротивление ядам и болезням, и т.д.). Это преимущество не увеличивает действительный уровень НТ, и не влияет на умения, основанные на НТ. Также вы восстанавливаете усталость в два раза быстрее. 5 очков.
Очень крепкий (Very Fit): Как описано выше, но бонус к НТ составляет +2. Дополнительно, вы устаете в два раза медленнее. 15 очков.

В любом случае, это преимущество действует только на потерю FP вследствие физической нагрузки, перегрева и так далее. Оно никак не восстанавливает FP, потраченное магию или псионику. </description-loc>
</advantage>
	<advantage version="2">
		<name>Flashbacks (Crippling, 3D minutes)</name>
		<name-loc>Галлюцинации (Калечащие)</name-loc>
		<description-loc>В стрессовых ситуациях вам свойственно испытывать галлюцинации. Это яркие образы, вновь разыгрывающиеся воспоминания с полным погружением или похожие явления. При выборе данного недостатка вам необходимо определить тип галлюцинаций, которые с вами случаются. Содержание каждого из эпизодов остается на усмотрение мастера.
В любой ситуации, которую мастер считает стрессовой, он делает бросок 3d. При результате 6 или меньше у вас начинаются галлюцинации. Мастер бросает кубики каждый раз, когда вы проваливаете Проверку на испуг или ее результат равен необходимому, а также когда вы проваливаете проверку на самоконтроль для иного недостатка, вызываемого стрессом. В этом случае галлюцинации возникают в дополнение ко всем прочим эффектам!
Цена недостатка зависит от серьезности галлюцинаций:


Умеренные: Продолжительность составляет 2d секунд. В продолжение галлюцинаций вы получаете -2 ко всем проверкам умений, однако сами галлюцинации незначительны - вы осознаете, что это происходит не наяву. -5 очков.
Тяжелые: Продолжительность 1d минут. Галлюцинации дают -5 ко всем проверкам умений и кажутся реальными. -10 очков.
Калечащие: Продолжительность 3d минут. Галлюцинации столь серьезны, что не дают использовать умения. Галлюцинации кажутся полностью, на 100% реальными, и могут оказаться смертельно опасными, поскольку вы теряете связь с реальным миром. -20 очков.</description-loc>
		<type>Physical</type>
		<base_points>-20</base_points>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Flashbacks (Mild, -2, 2D seconds)</name>
		<name-loc>Галлюцинации
 (Слабо)</name-loc>
		<description-loc>В стрессовых ситуациях вам свойственно испытывать галлюцинации. Это яркие образы, вновь разыгрывающиеся воспоминания с полным погружением или похожие явления. При выборе данного недостатка вам необходимо определить тип галлюцинаций, которые с вами случаются. Содержание каждого из эпизодов остается на усмотрение мастера.
В любой ситуации, которую мастер считает стрессовой, он делает бросок 3d. При результате 6 или меньше у вас начинаются галлюцинации. Мастер бросает кубики каждый раз, когда вы проваливаете Проверку на испуг или ее результат равен необходимому, а также когда вы проваливаете проверку на самоконтроль для иного недостатка, вызываемого стрессом. В этом случае галлюцинации возникают в дополнение ко всем прочим эффектам!
Цена недостатка зависит от серьезности галлюцинаций:


Умеренные: Продолжительность составляет 2d секунд. В продолжение галлюцинаций вы получаете -2 ко всем проверкам умений, однако сами галлюцинации незначительны - вы осознаете, что это происходит не наяву. -5 очков.
Тяжелые: Продолжительность 1d минут. Галлюцинации дают -5 ко всем проверкам умений и кажутся реальными. -10 очков.
Калечащие: Продолжительность 3d минут. Галлюцинации столь серьезны, что не дают использовать умения. Галлюцинации кажутся полностью, на 100% реальными, и могут оказаться смертельно опасными, поскольку вы теряете связь с реальным миром. -20 очков.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Flashbacks (Severe, -5, 1D minutes)</name>
		<name-loc>Галлюцинации
 (Сильно)</name-loc>
		<description-loc>В стрессовых ситуациях вам свойственно испытывать галлюцинации. Это яркие образы, вновь разыгрывающиеся воспоминания с полным погружением или похожие явления. При выборе данного недостатка вам необходимо определить тип галлюцинаций, которые с вами случаются. Содержание каждого из эпизодов остается на усмотрение мастера.
В любой ситуации, которую мастер считает стрессовой, он делает бросок 3d. При результате 6 или меньше у вас начинаются галлюцинации. Мастер бросает кубики каждый раз, когда вы проваливаете Проверку на испуг или ее результат равен необходимому, а также когда вы проваливаете проверку на самоконтроль для иного недостатка, вызываемого стрессом. В этом случае галлюцинации возникают в дополнение ко всем прочим эффектам!
Цена недостатка зависит от серьезности галлюцинаций:


Умеренные: Продолжительность составляет 2d секунд. В продолжение галлюцинаций вы получаете -2 ко всем проверкам умений, однако сами галлюцинации незначительны - вы осознаете, что это происходит не наяву. -5 очков.
Тяжелые: Продолжительность 1d минут. Галлюцинации дают -5 ко всем проверкам умений и кажутся реальными. -10 очков.
Калечащие: Продолжительность 3d минут. Галлюцинации столь серьезны, что не дают использовать умения. Галлюцинации кажутся полностью, на 100% реальными, и могут оказаться смертельно опасными, поскольку вы теряете связь с реальным миром. -20 очков.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Flexibility</name>
		<name-loc>Гибкость</name-loc>
		<description-loc>Ваше тело необычно гибко. Преимущество имеет два уровня: Гибкость и Феноменальная гибкость.

Гибкость (Flexibility): +3 на броски Лазания, освобождения от пут и захватов в ближнем бою, а также Эротическое искусство. Кроме того, вы можете игнорировать до -3 штрафа за работу в тесноте (относится ко многим броскам навыков Подрывник или Механика). 5 очков.
Феноменальная гибкость (Double-jointed): вы не можете сгибать конечности ненормально, но любая часть вашего тела движется очень свободно. Премия на Лазание, Побег и освобождение от захвата противника, Эротическое искусство получает +5; и игнорирование до -5 штрафа за работу в тесноте. 15 очков.</description-loc>
		<type>Physical</type>
		<base_points>5</base_points>
		<reference>B56</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">climbing</name>
			<specialization compare="is anything"></specialization>
			<amount>3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">escape</name>
			<specialization compare="is anything"></specialization>
			<amount>3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">erotic art</name>
			<specialization compare="is anything"></specialization>
			<amount>3</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Flexibility (Double-Jointed)</name>
		<name-loc>Гибкость  (Феноменальная)</name-loc>
		<description-loc>Ваше тело необычно гибко. Преимущество имеет два уровня: Гибкость и Феноменальная гибкость.

Гибкость (Flexibility): +3 на броски Лазания, освобождения от пут и захватов в ближнем бою, а также Эротическое искусство. Кроме того, вы можете игнорировать до -3 штрафа за работу в тесноте (относится ко многим броскам навыков Подрывник или Механика). 5 очков.
Феноменальная гибкость (Double-jointed): вы не можете сгибать конечности ненормально, но любая часть вашего тела движется очень свободно. Премия на Лазание, Побег и освобождение от захвата противника, Эротическое искусство получает +5; и игнорирование до -5 штрафа за работу в тесноте. 15 очков.</description-loc>
		<type>Physical</type>
		<base_points>15</base_points>
		<reference>B56</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">climbing</name>
			<specialization compare="is anything"></specialization>
			<amount>5</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">escape</name>
			<specialization compare="is anything"></specialization>
			<amount>5</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">erotic art</name>
			<specialization compare="is anything"></specialization>
			<amount>5</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Flight</name>
		<name-loc>Полет</name-loc>
		<description-loc>Вы можете летать. По умолчанию это полноценный полет без крыльев или несущих поверхностей – вроде магического полета или природной реактивной тяги. Однако, доступны различные формы скольжения и крылатого полета. Полет работает на любой высоте, где есть достаточная атмосфера – однако в верхних слоях вам может потребоваться способность выживать в разреженном воздухе и при низкой температуре. Вы не можете летать в вакууме или там, где присутствует слишком слабая атмосфера. 
Скорость полета – Базовая скорость х2 (все дроби отбрасываются). Вы можете модифицировать скорость за ±2 очка за ± 1 ярд/сек (см. Увеличение скорости передвижения в других средах, с. B18). Для достижения очень высокой скорости, приобретайте Расширенное передвижение. Если вы не имеете ограничений Планирование, Легче воздуха, Только космический полет, Крылья – вы также можете летать с половиной скорости под водой. Также вы можете зависать на одном месте.

Полет не дает способности совершать сложные актробатические трюки – покупайте навык Полет (увеличивает выносливость в полете) или Аэробатику.

===Особые улучшения.===

Космический (Space Flight): Вы можете летать в вакууме и космосе. Ваша скорость – базовая х2. Если вы хотите увеличить максимальную скорость – покупайте Расширенное передвижение (космос). Это позволит вам ускоряться или замедляться на значение вашего Базового движения каждый ход. Реалистичный полет в космосе предполагает почти бесконечное ускорение, что разрешает вам купить до 27 уровней расширенного движения. Несовместимо почти со всеми остальными модификатороами кроме Только космический полет. +50%.

===Новые особые ограничения===
Планетарный полет (Planetary): Ваша способность работает, отталкиваясь от гравитационного или магнитного поля планеты, и бесполезна, если планеты нет. Несовместимо с любыми видами Космического полета. -5%.

Необходима поверхность (Requires Surface): Вы летаете, отталкиваясь от поверхности. Вы можете лететь максимум 5 секунд, после чего вам необходим новый толчок от любой более-менее твердой поверхности (стены, стебля бамбука) - или даже от воды в киношных играх. Это не требует маневра. В противном случае вы
упадете. -20%.

Космический, изменение скорости (Newtonian Space Flight):  почти как Космический полет (ниже), но в действительности ваша космическая скорость – максимальная, если у вас есть Увеличенное движение (космос) – «delta-v», общее значение изменения скорости, которого вы можете достичь, прежде чем исчерпаете свой запас энергии. Например, вы можете ускориться до этого значения и оставить его (как ракета); или до его половины на время межзвездного перелета, а затем – замедлиться в конце путешествия до обычной скорости (как обычный звездолет). Когда суммарное ускорение и замедление становится равным значению delta-V, вам потребуется дозаправка, прежде чем вы сможете изменить скорость снова. -25%.

Невозможность парить (Cannot Hover): Вы должны постоянно поддерживать скорость не менее 1/4 от максимальной скорости полета, чтобы не упасть. Это ограничение несовместимо с Планированием. -15%

Контролируемое планирование (Controlled Gliding): Вы можете подниматься вверх, используя восходящие потоки (термалы) – обычно со скоростью 1 ярд в секунду. Вы можете находить термалы (если они вообще есть) успешным броском IQ или Метеорологии (одна попытка в минуту). -45%.

Планирование (Gliding): Вы не можете набирать высоту. Прыгнув с разбега, вы можете полететь со скоростью, равной вашему наземному движению. Каждый ход вы можете изменять скорость на 10 ярдов/сек * локальная гравитация в G (гравитация на земле – 1G). Для ускорения вы должны снижаться на 1 ярд за каждые добавочные 1 ярдов/сек, максимальная скорость – Базовое движение *4. Для замедления вы просто можете лететь на одном уровне. Если вы не опускаетесь на 1 ярд, вы автоматически замедляетесь на 1 ярд/сек в этот ход. Каждый уровень Расширенного движения в воздухе удваивает максимальную скорость или уменьшает замедление при полете на одной высоте. Для вычисления радиуса разворота – ваша базовая скорость в воздухе – 10 * местная гравитация в G. -50%.

Легче воздуха (Lighter than Air): вы летаете из-за того, что вы легче воздуха. Ветер перемещает вас со скоростью 1 м/с за каждые 5 миль/час своей скорости, в соответствующем направлении. Если ветер попутный, эта скорость прибавляется к вашей скорости перемещения, иначе – уменьшает ее, поскольку вы пытаетесь лететь против ветра. -10%.

Низкий потолок (Low Ceiling): вы не можете летать очень высоко. Это не ограничивает скорости, но мастер может потребовать бросков аэро-акробатики, чтобы уклоняться от препятствий вблизи земли. Потолок 30 футов -10%, 10 футов -20%, 5 футов -25%.

Маленькие крылья (Small Wings): вы имеете крылья, которые используете не для создания тяги, а для маневров и управления. Если ваши крылья сломаны во время полета, требуется бросок Аэробатики, чтобы приземлиться безопасно. Размах крыльев – примерно половина вашего роста. -10%.

Только космический полет (Space Flight Only): вы можете брать это ограничение только с расширениями Космический полет и Newtonian Space Flight. Вы можете летать только в космосе, ваша скорость в атмосфере – 0. Вы должны быть ускорены, чтобы достигнуть космоса с любой планеты, имеющей атмосферу, и не можете войти в атмосферу снова. -75%.
Крылья (Winged): Для полета вы используете большие крылья, размахом минимум в два раза больше вашего роста. Для взлета, приземления или маневрирования вы должны иметь открытую область с радиусом равным вашему размаху крыльев во всех направлениях. Если ваши крылья связаны, или одно крыло сломано (если у вас несколько крыльев – 1/3 из них), вы не можете летать. В качестве цели для удара и калечащих ранений считайте крылья как руки. Если ваши крылья могут манипулировать предметами или бить, вы должны также оплатить их как Естественное оружие или дополнительные руки. -25%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>40</base_points>
		<modifier version="1" enabled="no">
			<name>Ньютоновское (Newtonian Space Flight)</name>
			<cost type="percentage">25</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Космический полет (Space Flight)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Не может зависать (Cannot Hover)</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Контролируемое планирование (Controlled Gliding)</name>
			<cost type="percentage">-45</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Планирование (Gliding)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Легче воздуха (Lighter Than Air)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Низкий потолок (Low Ceiling)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B56</reference>
			<notes>10 метров</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Низкий потолок (Low Ceiling)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B56</reference>
			<notes>3 метра</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Низкий потолок (Low Ceiling)</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B56</reference>
			<notes>1.5 метра</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Маленькие крылья (Small Wings)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только космический полет (Space Flight Only)</name>
			<cost type="percentage">-75</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Крылатый (Winged)</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B56</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Planetary</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>P50</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Requires Surface</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P50</reference>
		</modifier>
		<reference>B56</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Fragile (Brittle)</name>
	<name-loc>Хрупкий (Ломкий)</name-loc>
	<base_points>-15</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B136</reference>
	<description-loc>Вы уязвимы для таких эффектов ранения, которые на обычных людей не действуют. Атаки не вредят вам больше обычного (это уже Уязвимость, B161), но достаточное число прошедших повреждений может повлечь результаты куда хуже, чем оглушение, потеря сознания или кровотечение. Возможные варианты:
Ломкий: Вы легко ломаетесь (как ледяное или кристаллическое создание) или разваливаетесь (как разлагающийся оживший мертвец). Каждый раз, когда ранение калечит одну из ваших конечностей или выступающих частей, она отрывается. В случае успешной проверки HT, она отваливается одним куском; в случае неудачи разбивается или тает, так что ее уже нельзя восстановить. Более того, провалив проверку HT, чтобы не умереть, вы оказываетесь полностью уничтожены - разбиваетесь на куски, таете, полностью сгниваете и т.д., и мгновенно оказываетесь в -10xHP. -15 очков.
Воспламеняемый: Ваше тело горит легче, чем плоть. Возможно, оно сухое, смолистое или деревянное. Выполните проверку HT, чтобы не загореться, каждый раз когда получаете сильное ранение от огня или взрыва. Вы автоматически загораетесь, если подобная атака наносит 10+ HP повреждений. Загоревшись, вы получаете 1d-1 ранений в секунду до тех пор, пока не собьете огонь водой, катанием по земле (это займет 3 секунды) и т.д. -5 очков.
Взрывоопасный: Ваше тело содержит взрывчатые вещества, сжатый газ или иные взрывоопасные материалы. При любой критической неудаче в ходе проверки HT из-за сильного ранения вы взрываетесь! Также вы взрываетесь, если проваливаете более чем на 3 проверку HT, чтобы избежать смерти. Считайте это дробящим взрывом силой 6dx(HP/10). Взрыв мгновенно отправляет вас в -10xHP, независимо от причиненных повреждений. -15 очков.
Огнеопасный: Ваше тело содержит нечто крайне огнеопасное: бензин, водород и т.д. Чтобы не загореться, делайте проверку HT после любого сильного ранения от любого типа атак, эффект будет тем же, что и для Воспламеняемого. Проверка делается с -3 при атаке огнем или взрывом. -3, если атака направлена по жизненно важным органам, -6, если выполняются оба условия. Как только вы загорелись, критическая неудача при проверке HT, чтобы избежать смерти, приводит к взрыву, как описано для варианта Взрывоопасный. Одновременно с этим вы можете быть Воспламеняемым. Если так, то любая атака огнем или взрывом, наносящая сильное ранение или 10+ HP, автоматически приводит к возгоранию. -10 очков.
Неестественный: Вы призванное, подчиненное или созданное волшебником либо фантастической наукой существо (например, демон, голем или умертвие). Вы автоматически проваливаете проверку HT против смерти, когда оказываетесь в -HP или ниже, поскольку столь серьезные повреждения разрывают вашу связь с силой, которая движет вами. -50 очков.


Иногда логичным бывает совместить несколько указанных типов (особенно часто подходят друг другу Взрывоопасный и Огнеопасный). Мастер должен лично одобрить любое сочетание Хрупкости и Устойчивости к ранениям (B60), т.к. данные особенности во многом противоположны.</description-loc>
</advantage>
	<advantage version="2">
		<name>Fragile (Combustible)</name>
		<name-loc>Хрупкий (Воспламеняемый)</name-loc>
		<description-loc>Вы уязвимы для таких эффектов ранения, которые на обычных людей не действуют. Атаки не вредят вам больше обычного (это уже Уязвимость, B161), но достаточное число прошедших повреждений может повлечь результаты куда хуже, чем оглушение, потеря сознания или кровотечение. Возможные варианты:
Ломкий: Вы легко ломаетесь (как ледяное или кристаллическое создание) или разваливаетесь (как разлагающийся оживший мертвец). Каждый раз, когда ранение калечит одну из ваших конечностей или выступающих частей, она отрывается. В случае успешной проверки HT, она отваливается одним куском; в случае неудачи разбивается или тает, так что ее уже нельзя восстановить. Более того, провалив проверку HT, чтобы не умереть, вы оказываетесь полностью уничтожены - разбиваетесь на куски, таете, полностью сгниваете и т.д., и мгновенно оказываетесь в -10xHP. -15 очков.
Воспламеняемый: Ваше тело горит легче, чем плоть. Возможно, оно сухое, смолистое или деревянное. Выполните проверку HT, чтобы не загореться, каждый раз когда получаете сильное ранение от огня или взрыва. Вы автоматически загораетесь, если подобная атака наносит 10+ HP повреждений. Загоревшись, вы получаете 1d-1 ранений в секунду до тех пор, пока не собьете огонь водой, катанием по земле (это займет 3 секунды) и т.д. -5 очков.
Взрывоопасный: Ваше тело содержит взрывчатые вещества, сжатый газ или иные взрывоопасные материалы. При любой критической неудаче в ходе проверки HT из-за сильного ранения вы взрываетесь! Также вы взрываетесь, если проваливаете более чем на 3 проверку HT, чтобы избежать смерти. Считайте это дробящим взрывом силой 6dx(HP/10). Взрыв мгновенно отправляет вас в -10xHP, независимо от причиненных повреждений. -15 очков.
Огнеопасный: Ваше тело содержит нечто крайне огнеопасное: бензин, водород и т.д. Чтобы не загореться, делайте проверку HT после любого сильного ранения от любого типа атак, эффект будет тем же, что и для Воспламеняемого. Проверка делается с -3 при атаке огнем или взрывом. -3, если атака направлена по жизненно важным органам, -6, если выполняются оба условия. Как только вы загорелись, критическая неудача при проверке HT, чтобы избежать смерти, приводит к взрыву, как описано для варианта Взрывоопасный. Одновременно с этим вы можете быть Воспламеняемым. Если так, то любая атака огнем или взрывом, наносящая сильное ранение или 10+ HP, автоматически приводит к возгоранию. -10 очков.
Неестественный: Вы призванное, подчиненное или созданное волшебником либо фантастической наукой существо (например, демон, голем или умертвие). Вы автоматически проваливаете проверку HT против смерти, когда оказываетесь в -HP или ниже, поскольку столь серьезные повреждения разрывают вашу связь с силой, которая движет вами. -50 очков.


Иногда логичным бывает совместить несколько указанных типов (особенно часто подходят друг другу Взрывоопасный и Огнеопасный). Мастер должен лично одобрить любое сочетание Хрупкости и Устойчивости к ранениям (B60), т.к. данные особенности во многом противоположны.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-5</base_points>
		<reference>B136</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Fragile (Explosive)</name>
		<name-loc>Хрупкий (Взрывоопасный)</name-loc>
		<description-loc>Вы уязвимы для таких эффектов ранения, которые на обычных людей не действуют. Атаки не вредят вам больше обычного (это уже Уязвимость, B161), но достаточное число прошедших повреждений может повлечь результаты куда хуже, чем оглушение, потеря сознания или кровотечение. Возможные варианты:
Ломкий: Вы легко ломаетесь (как ледяное или кристаллическое создание) или разваливаетесь (как разлагающийся оживший мертвец). Каждый раз, когда ранение калечит одну из ваших конечностей или выступающих частей, она отрывается. В случае успешной проверки HT, она отваливается одним куском; в случае неудачи разбивается или тает, так что ее уже нельзя восстановить. Более того, провалив проверку HT, чтобы не умереть, вы оказываетесь полностью уничтожены - разбиваетесь на куски, таете, полностью сгниваете и т.д., и мгновенно оказываетесь в -10xHP. -15 очков.
Воспламеняемый: Ваше тело горит легче, чем плоть. Возможно, оно сухое, смолистое или деревянное. Выполните проверку HT, чтобы не загореться, каждый раз когда получаете сильное ранение от огня или взрыва. Вы автоматически загораетесь, если подобная атака наносит 10+ HP повреждений. Загоревшись, вы получаете 1d-1 ранений в секунду до тех пор, пока не собьете огонь водой, катанием по земле (это займет 3 секунды) и т.д. -5 очков.
Взрывоопасный: Ваше тело содержит взрывчатые вещества, сжатый газ или иные взрывоопасные материалы. При любой критической неудаче в ходе проверки HT из-за сильного ранения вы взрываетесь! Также вы взрываетесь, если проваливаете более чем на 3 проверку HT, чтобы избежать смерти. Считайте это дробящим взрывом силой 6dx(HP/10). Взрыв мгновенно отправляет вас в -10xHP, независимо от причиненных повреждений. -15 очков.
Огнеопасный: Ваше тело содержит нечто крайне огнеопасное: бензин, водород и т.д. Чтобы не загореться, делайте проверку HT после любого сильного ранения от любого типа атак, эффект будет тем же, что и для Воспламеняемого. Проверка делается с -3 при атаке огнем или взрывом. -3, если атака направлена по жизненно важным органам, -6, если выполняются оба условия. Как только вы загорелись, критическая неудача при проверке HT, чтобы избежать смерти, приводит к взрыву, как описано для варианта Взрывоопасный. Одновременно с этим вы можете быть Воспламеняемым. Если так, то любая атака огнем или взрывом, наносящая сильное ранение или 10+ HP, автоматически приводит к возгоранию. -10 очков.
Неестественный: Вы призванное, подчиненное или созданное волшебником либо фантастической наукой существо (например, демон, голем или умертвие). Вы автоматически проваливаете проверку HT против смерти, когда оказываетесь в -HP или ниже, поскольку столь серьезные повреждения разрывают вашу связь с силой, которая движет вами. -50 очков.


Иногда логичным бывает совместить несколько указанных типов (особенно часто подходят друг другу Взрывоопасный и Огнеопасный). Мастер должен лично одобрить любое сочетание Хрупкости и Устойчивости к ранениям (B60), т.к. данные особенности во многом противоположны.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-15</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Fragile (Flammable)</name>
		<name-loc>Хрупкий
 (Огнеопасный)</name-loc>
		<description-loc>Вы уязвимы для таких эффектов ранения, которые на обычных людей не действуют. Атаки не вредят вам больше обычного (это уже Уязвимость, B161), но достаточное число прошедших повреждений может повлечь результаты куда хуже, чем оглушение, потеря сознания или кровотечение. Возможные варианты:
Ломкий: Вы легко ломаетесь (как ледяное или кристаллическое создание) или разваливаетесь (как разлагающийся оживший мертвец). Каждый раз, когда ранение калечит одну из ваших конечностей или выступающих частей, она отрывается. В случае успешной проверки HT, она отваливается одним куском; в случае неудачи разбивается или тает, так что ее уже нельзя восстановить. Более того, провалив проверку HT, чтобы не умереть, вы оказываетесь полностью уничтожены - разбиваетесь на куски, таете, полностью сгниваете и т.д., и мгновенно оказываетесь в -10xHP. -15 очков.
Воспламеняемый: Ваше тело горит легче, чем плоть. Возможно, оно сухое, смолистое или деревянное. Выполните проверку HT, чтобы не загореться, каждый раз когда получаете сильное ранение от огня или взрыва. Вы автоматически загораетесь, если подобная атака наносит 10+ HP повреждений. Загоревшись, вы получаете 1d-1 ранений в секунду до тех пор, пока не собьете огонь водой, катанием по земле (это займет 3 секунды) и т.д. -5 очков.
Взрывоопасный: Ваше тело содержит взрывчатые вещества, сжатый газ или иные взрывоопасные материалы. При любой критической неудаче в ходе проверки HT из-за сильного ранения вы взрываетесь! Также вы взрываетесь, если проваливаете более чем на 3 проверку HT, чтобы избежать смерти. Считайте это дробящим взрывом силой 6dx(HP/10). Взрыв мгновенно отправляет вас в -10xHP, независимо от причиненных повреждений. -15 очков.
Огнеопасный: Ваше тело содержит нечто крайне огнеопасное: бензин, водород и т.д. Чтобы не загореться, делайте проверку HT после любого сильного ранения от любого типа атак, эффект будет тем же, что и для Воспламеняемого. Проверка делается с -3 при атаке огнем или взрывом. -3, если атака направлена по жизненно важным органам, -6, если выполняются оба условия. Как только вы загорелись, критическая неудача при проверке HT, чтобы избежать смерти, приводит к взрыву, как описано для варианта Взрывоопасный. Одновременно с этим вы можете быть Воспламеняемым. Если так, то любая атака огнем или взрывом, наносящая сильное ранение или 10+ HP, автоматически приводит к возгоранию. -10 очков.
Неестественный: Вы призванное, подчиненное или созданное волшебником либо фантастической наукой существо (например, демон, голем или умертвие). Вы автоматически проваливаете проверку HT против смерти, когда оказываетесь в -HP или ниже, поскольку столь серьезные повреждения разрывают вашу связь с силой, которая движет вами. -50 очков.


Иногда логичным бывает совместить несколько указанных типов (особенно часто подходят друг другу Взрывоопасный и Огнеопасный). Мастер должен лично одобрить любое сочетание Хрупкости и Устойчивости к ранениям (B60), т.к. данные особенности во многом противоположны.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Fragile (Unnatural)</name>
		<name-loc>Хрупкий
 (Неестественный)</name-loc>
		<description-loc>Вы уязвимы для таких эффектов ранения, которые на обычных людей не действуют. Атаки не вредят вам больше обычного (это уже Уязвимость, B161), но достаточное число прошедших повреждений может повлечь результаты куда хуже, чем оглушение, потеря сознания или кровотечение. Возможные варианты:
Ломкий: Вы легко ломаетесь (как ледяное или кристаллическое создание) или разваливаетесь (как разлагающийся оживший мертвец). Каждый раз, когда ранение калечит одну из ваших конечностей или выступающих частей, она отрывается. В случае успешной проверки HT, она отваливается одним куском; в случае неудачи разбивается или тает, так что ее уже нельзя восстановить. Более того, провалив проверку HT, чтобы не умереть, вы оказываетесь полностью уничтожены - разбиваетесь на куски, таете, полностью сгниваете и т.д., и мгновенно оказываетесь в -10xHP. -15 очков.
Воспламеняемый: Ваше тело горит легче, чем плоть. Возможно, оно сухое, смолистое или деревянное. Выполните проверку HT, чтобы не загореться, каждый раз когда получаете сильное ранение от огня или взрыва. Вы автоматически загораетесь, если подобная атака наносит 10+ HP повреждений. Загоревшись, вы получаете 1d-1 ранений в секунду до тех пор, пока не собьете огонь водой, катанием по земле (это займет 3 секунды) и т.д. -5 очков.
Взрывоопасный: Ваше тело содержит взрывчатые вещества, сжатый газ или иные взрывоопасные материалы. При любой критической неудаче в ходе проверки HT из-за сильного ранения вы взрываетесь! Также вы взрываетесь, если проваливаете более чем на 3 проверку HT, чтобы избежать смерти. Считайте это дробящим взрывом силой 6dx(HP/10). Взрыв мгновенно отправляет вас в -10xHP, независимо от причиненных повреждений. -15 очков.
Огнеопасный: Ваше тело содержит нечто крайне огнеопасное: бензин, водород и т.д. Чтобы не загореться, делайте проверку HT после любого сильного ранения от любого типа атак, эффект будет тем же, что и для Воспламеняемого. Проверка делается с -3 при атаке огнем или взрывом. -3, если атака направлена по жизненно важным органам, -6, если выполняются оба условия. Как только вы загорелись, критическая неудача при проверке HT, чтобы избежать смерти, приводит к взрыву, как описано для варианта Взрывоопасный. Одновременно с этим вы можете быть Воспламеняемым. Если так, то любая атака огнем или взрывом, наносящая сильное ранение или 10+ HP, автоматически приводит к возгоранию. -10 очков.
Неестественный: Вы призванное, подчиненное или созданное волшебником либо фантастической наукой существо (например, демон, голем или умертвие). Вы автоматически проваливаете проверку HT против смерти, когда оказываетесь в -HP или ниже, поскольку столь серьезные повреждения разрывают вашу связь с силой, которая движет вами. -50 очков.


Иногда логичным бывает совместить несколько указанных типов (особенно часто подходят друг другу Взрывоопасный и Огнеопасный). Мастер должен лично одобрить любое сочетание Хрупкости и Устойчивости к ранениям (B60), т.к. данные особенности во многом противоположны.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-50</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Frightens Animals</name>
	<name-loc>Пугает животных
</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-4</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B137</reference>
	<description-loc>Животные проявляют по отношению к вам страх и агрессию. Лошади не дают ездить на себе, собаки сторонятся вас или яростно нападают, и одного вашего запаха достаточно, чтобы большинство животных впало в панику. Вы получаете -4 ко всем проверкам реакции со стороны животных. Все, кто видит такую реакцию животных на вас, - и кто обладает Пониманием животных - реагируют на вас с -1. Обратите внимание, что стража или полиция, использующая сторожевых животных, ищеек и т.д. решает, как с вами поступить, опираясь на реакцию животного, а не на свою собственную!
Если данный недостаток получен из-за ликантропии, вампиризма или подобной особенности, то наблюдатель получает +1 ко всем проверкам на раскрытие вашей тайны!</description-loc>
</advantage>
	<advantage version="2">
		<name>Fur</name>
		<name-loc>Мех</name-loc>
		<description-loc>Ваше тело покрыто мехом. Он защищает вас от солнечных ожогов, и может служить Необычным Происхождением для приобретения Устойчивости к повреждениям 1-3 (с. B46), Шипов (с. B88) или Устойчивости к температурам 1-3 (с. B93), в зависимости от толщины. Все эти преимущества должны приобретаться отдельно.
&lt; B101, Perks, 10&gt;</description-loc>
		<type>Physical, Exotic</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>G-Experience (All)</name>
		<name-loc>Опыт гравитации  (Все)</name-loc>
		<description-loc>Вы знакомы с работой в одном или более гравитационных полях, кроме вашего родного, и ваши рефлексы быстрее приспосабливаются к ним. Вы получаете только половинный штраф к DX за необычную гравитацию (с. B350), а если низкая гравитация делает задачу легче, вместо штрафа вы получаете премию +1, и плюс бонус за низкую гравитацию. Например, если нормальный человек получает +2 шанс на ловлю мяча в низкой гравитации, вы получаете +3.
Черта стоит по 1 очку за каждое знакомое вам гравитационное поле. Например, уроженец Земли, работающий на Луне, может имееть Опыт гравитации (0,16G). Для получения выгоды от опыта работы в любых полях – покупайте 10-очковую версию.</description-loc>
		<type>Mental</type>
		<base_points>10</base_points>
		<reference>B57</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>G-Experience</name>
		<name-loc>Опыт гравитации</name-loc>
		<description-loc>Вы знакомы с работой в одном или более гравитационных полях, кроме вашего родного, и ваши рефлексы быстрее приспосабливаются к ним. Вы получаете только половинный штраф к DX за необычную гравитацию (с. B350), а если низкая гравитация делает задачу легче, вместо штрафа вы получаете премию +1, и плюс бонус за низкую гравитацию. Например, если нормальный человек получает +2 шанс на ловлю мяча в низкой гравитации, вы получаете +3.
Черта стоит по 1 очку за каждое знакомое вам гравитационное поле. Например, уроженец Земли, работающий на Луне, может имееть Опыт гравитации (0,16G). Для получения выгоды от опыта работы в любых полях – покупайте 10-очковую версию.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<reference>B57</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>G-Intolerance (0.1G increment)</name>
		<name-loc>Чувствительность к гравитации
 (0.1G)</name-loc>
		<description-loc>Вы хорошо действуете лишь при ограниченном разбросе гравитации. У обычного человека пенальти за неродную гравитацию увеличиваются с повышения гравитации на 0.2 G; см. Иная Гравитация (B350). Если для вас это повышение на 0.1 G, то оно стоит -10 очков. Повышение на 0.05 G стоит -20 очков.
Данный недостаток разрешается лишь в кампаниях, где имеют место регулярные космические путешествия.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>G-Intolerance (0.05G increment)</name>
		<name-loc>Чувствительность к гравитации
 (0.05G)</name-loc>
		<description-loc>Вы хорошо действуете лишь при ограниченном разбросе гравитации. У обычного человека пенальти за неродную гравитацию увеличиваются с повышения гравитации на 0.2 G; см. Иная Гравитация (B350). Если для вас это повышение на 0.1 G, то оно стоит -10 очков. Повышение на 0.05 G стоит -20 очков.
Данный недостаток разрешается лишь в кампаниях, где имеют место регулярные космические путешествия.</description-loc>
		<type>Physical</type>
		<base_points>-20</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Gadgeteer</name>
		<name-loc>Изобретатель</name-loc>
		<description-loc>Вы – прирожденный изобретатель. Вы можете модифицировать существующее снаряжение и – имея достаточно времени и средств – разрабатывать полностью новые приспособления, как указано в главе Изобретательство (Gadgeteering, с. B475). Это позволяет вам быстро разрабатывать предметы, и быстрее переходить в более высокий ТУ.

Изобретатель: Работа займет дни и месяцы, и требует значительных денежных вкладов и хорошего оборудования. 25 очков.
Быстрый изобретатель: Вы можете изобрести невероятные устройства за несколько часов из того, что завалялось в кладовке, затратив всего несколько процентов от реалистичной суммы. Этот уровень не подходит для реалистичной кампании. 50 очков.</description-loc>
		<type>Mental</type>
		<base_points>25</base_points>
		<modifier version="1" enabled="no">
			<name>Гениальный (Quick)</name>
			<cost type="points">25</cost>
			<affects>total</affects>
			<reference>B57</reference>
		</modifier>
		<reference>B57</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Gigantism</name>
		<name-loc>Гигант</name-loc>
		<description-loc>+1 SM
Ваш рост необычайно велик для данной расы. Независимо от ST, ваш рост большее самого высокого значения в Таблице сложения - то есть больше 7' для людей. Это дает вам Модификатор размера +1 и +1 к Базовому передвижению (у вас длинные ноги), а также позволяет вам покупать ST и HP со скидкой. Выберите вес из последней строки Таблицы телосложения и увеличьте его на 10%.
Вы получаете -2 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. С другой стороны, рост часто дает бонус к умению Запугивание (см. B202). В отсталых мирах мастер может потребовать от вас недостатка Социальная дискриминация, если вы страдаете гигантизмом.
Гигантом может быть представитель любой расы. Увеличьте рост, умножив средний рост для данной расы на коэффициент 1.25, а расовый SM увеличьте на +1. Во всем остальном правила те же.</description-loc>
		<type>Physical</type>
		<reference>B20</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>move</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is not">animals</specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<attribute_bonus>
			<attribute>sm</attribute>
			<amount>1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
	<name>Gizmo</name>
	<name-loc>Штуковины</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B57</reference>
	<description-loc>Кажется, у вас всегда есть что-то необходимое. Один раз за сессию за каждый уровень преимущества, вы можете добыть небольшой предмет снаряжения, который мог у вас быть. Этот предмет неопределен, пока вы его не откроете, он не может быть поврежден, найден при обыске или потерян.
Предмет должен быть достаточно маленьким, чтобы влезть в карман, и отвечать хотя бы одному из требований:
1. Предмет, которым вы владеете, но не заявлили специально, что вы его взяли. Например, если у вас есть пистолет, и попали в засаду по пути в церковь – вы можете достать пистолет – даже если полиция пять минут назад вас обыскала и ничего не нашла!
2. Предмет, которым вы можете владеть в соответствии с концепцией персонажа, но не определен особо. Например, у полицейского может оказаться лишний ключ от наручников.
3. Недорогое устройство, широко доступное на вашем ТУ. Например, если вам надо поджечь фитиль динамита, вы можете достать коробку спичек – даже если вы только что вылезли из реки.
Каждый Случай вы можете использовать раз за сессию (максимум 3 уровня). Это преимущество нереалистично; В реалистичной кампании Мастер может запретить его или ограничить.
Случай и Изобретатели.
Имеющие Изобретательство получают больше выгод. Кроме обычных доступных предметов, Изобретатель может указать, что один уровень этого преимущества – одно из его изобретений (которое все равно должно быть небольшого размера). Вместо доставания существующего предмета из кармана, изобретатель может быстро построить необходимое устройство – хотя все равно необходимы материалы и навык. Мастер тайно кидает навык, с -2 и хуже – при провале устройство не работает (но Случай все равно использован). При критическом провале возникает сбой.</description-loc>
</advantage>
	<advantage version="2">
		<name>Gluttony</name>
		<name-loc>Прожорливость
</name-loc>
		<description-loc>Вы слишком любите хорошую еду и напитки. При возможности вы всегда будете нагружать себя дополнительной провизией. Вы не должны сознательно пропускать прием пищи. Сделайте проверку на самоконтроль, если вам попадается аппетитная еда или хорошее вино, которые во почему-либо не должны пробовать. В случае неудачи вы попробуете - независимо от последствий.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Greed</name>
		<name-loc>Жадность
</name-loc>
		<description-loc>Вы страстно желаете богатства. Каждый раз, когда вам предлагаются богатства - в качестве оплаты за честную работу, доходов от приключения, добычи от преступления или просто в качестве приманки, сделайте проверку на самоконтроль. Если она неудачна, то вы сделаете все что необходимо для получения богатств. Мастер может ввести модификаторы к проверке, если предлагаемые деньги малы относительно вашего богатства. Небольшие суммы не так уж сильно вас искушают, если вы богаты, но если вы бедны, то получаете -5 и больше к проверке на самоконтроль, если предлагается богатая награда. Если вы Законопослушны (B138), то получаете +5 к проверке на самоконтроль, если предлагаются подозрительные дела, и +10, если явные преступления. Но почти неизбежно вы в итоге сделаете что-то противозаконное.


Gregarious
Стайный
См. Общительный, B126</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Growth</name>
		<name-loc>Рост</name-loc>
		<description-loc>Вы можете расти – серьезно, расти! Поскольку увеличивается ваш размер, также и ваша сила (иначе вы упадете, задавленный собственным весом). Ваше снаряжение не изменяется. 
Каждый уровень преимущества позволяет увеличить SM на +1. Итоговый рост и все дистации изменяются соответственно (Модификатор размера и досягаемость, с. B402). Изменение роста (рост или уменьшение) занимает 1 секунду за 1 SM.
Если помещение не может поместить выросшего персонажа, рост останавливается; но если максимальный колющий (thrusting) вред текущей ST достаточен, чтобы пробить потолок – вы его пробъете за (DR потолка) секунд.
Вы должны приобрести необходимую силу – 5 * итоговый рост в ярдах. Если ваша сила увеличивается только на время роста, вы можете купить ее с ограничением Рост (-10%*SM, до максимума -80%): Цена ограничения рассчитывается по максимальному росту.

=====Пример: 6-футовый персонаж МР(SM)0 покупает Рост х4. он может вырастать до МР(SM) +4, получая максимальный рост 10 ярдов. Чтобы выдержать новый вес, он должен купить ST 50! Если он имеет ST 15 и получает +35 ST только во время увеличения, он покупает эти 35 ST с 40% скидкой. На SM +1 он имеет рост 3 ярда, это 30% от его итогового роста, так что он имеет лишь 30% от 35 ST, то есть +10 ST, итак имеет ST 25.=====

===Особые ограничения.===
Только максимальный рост (Maximum Size Only): Вы можете расти только до максимального роста – но это занимает всего секунду. Неудобства от этого ограничения (невозможность расти в тесных помещениях) отменяются выгодами быстрого роста (весьма полезно в бою). +0%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<modifier version="1" enabled="no">
			<name>Только максимальный размер (Maximum Size Only)</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B58</reference>
		</modifier>
		<reference>B58</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Guilt Complex</name>
		<name-loc>Комплекс вины
</name-loc>
		<description-loc>Вы чувствуете личную ответственность за тех, кто играет заметную роль в вашей жизни. К ним относятся ваши товарищи по приключениям, наниматели, подчиненные, Союзники, Иждивенцы и те, к кому у вас есть Долг или Чувство долга. Если с ними случится что-либо плохое, вы будете испытывать чувство тревоги и вины - даже если вы ничего не могли сделать, чтобы предотвратить несчастье.
Если несчастье случилось не по вашей вине, то вы страдаете от последствий Хронической депрессии (B126) в течение (15 - Воля(Will)) дней, минимум один день. Используйте Волю(Will) в качестве эффективного показателя самоконтроля. Если несчастье случилось по вашей вине, то последствия Хронической депрессии продлятся (20 - Воля(Will)) дней, минимум два дня, и ваш эффективный показатель самоконтроля будет равен Воле(Will)-3.
Окружающие могут постараться помочь вам преодолеть чувство вины с помощью проверок на Заговаривание зубов или Психологию. Мастер имеет право ввести модификаторы к данным проверкам в зависимости от того, насколько убедительно они звучат. Отыграйте это!</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Gullibility</name>
		<name-loc>Доверчивость
</name-loc>
		<description-loc>Если кто и рождается каждую минуту, так это вы. Вы верите всему что слышите. Вы способны проглотить даже самую глупую историю, если ее рассказать убедительно. Сделайте проверку на самоконтроль с модификатором за правдоподобность истории, когда сталкиваетесь с ложью - или с невероятной правдой, что в данном случае безразлично. В случае неудачи вы верите в то, что вам рассказали!
Уверенно произнесенная ложь или ложь, касающаяся чего-то, с чем вы незнакомы ("Мой отец - начальник местной полиции, он этого так не оставит!), дает -6 к проверке на самоконтроль. Ложь, касающаяся чего-то, с чем вы знакомы ("Торг, разве ты не знаешь, что в твоей деревне разводят уток?") дает -3. Вы поверите и в совсем уж нелепые сказки ("Конечно же эскимосы - потомки испанских конкистадоров; это все знают!), если провалите проверку на самоконтроль без модификаторов.
Кроме того, вы получаете пенальти -3 ко всем проверкам на Торговое дело, а также в любой ситуации, где вашим легковерием могут воспользоваться. Вы не способны овладеть умением Определение лжи.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B137</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">merchant</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<skill_prereq has="no">
				<name compare="is">detect lies</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Gunslinger</name>
	<name-loc>Меткий стрелок</name-loc>
	<base_points>25</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B58</reference>
	<description-loc>Вы можете невероятно метко стрелять даже без прицеливания. Эта способность работает с любым видом оружия, использующим Лучевое оружие, Тяжелое оружие, Распылители, Огнестрельное оружие, но не дает премии при использовании оружия дальнего боя, использующего мускульную силу (но мастер может ввести версию для низкотехнологичных видов оружия).
При стрельбе одиночными выстрелами (RoF 1-3, не больше) с одной руки вы получаете премию за прицеливание без выполнения прицеливания. При использовании двуручного оружия или при стрельбе очередями премия – половинная (округляется вверх). Если вы тратите время на прицеливание, вы всегда получаете полную премию Асс. Упор, прицелы и дополнительные секунды прицеливания дают обычные плюсы.
Это преимущество встречается в киношных (cinematic)  кампаниях. Мастер может запретить его в реалистичных играх.</description-loc>
</advantage>
	<advantage version="2">
		<name>Habit</name>
		<name-loc>Привычки</name-loc>
		<description-loc>
Постоянно восклицать «Ёлки-палки!» или «Боже ты мой»... или подбрасывать в воздух серебряную монетку... или никогда не садиться спиной к двери.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Привчка@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Ham-Fisted</name>
		<name-loc>Криворучка</name-loc>
		<description-loc>У вас очень слабо развита тонкая моторика. Вы получаете пенальти ко всем проверкам, зависящим от DX, при использовании умений, которые перечислены в описании Высокой ловкости рук (B59), а также умения Быстрое выхватывание. За -5 очков это пенальти составит -3; за -10 очков оно составит -6. Это не влияет на задания, зависящие от IQ, или на более масштабное использование DX и не действует на боевые проверки за исключением Быстрого выхватывания.
Вы неаккуратно едите, не можете правильно завязать галстук и т.д. По решению мастера вы получаете -1 за уровень данной особенности ко всем проверкам на Влияние или реакцию, когда необходимо проявить опрятность и аккуратность.
Данный недостаток взаимно исключается с преимуществом Высокая ловкость рук.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B138</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="contains">artist</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">jeweler</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">knot-tying</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leatherworking</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">lockpicking</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pickpocket</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sewing</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sleight of hand</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">surgery</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">machinist</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">mechanic</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">fast-draw</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">high manual dexterity</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Ham-Fisted (Severe)</name>
	<name-loc>Криворучка (Тяжелый случай)</name-loc>
	<base_points>-10</base_points>
	<skill_bonus>
		<name compare="contains">artist</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">jeweler</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">knot-tying</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">leatherworking</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">lockpicking</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">pickpocket</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sewing</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sleight of hand</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">surgery</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">fast-draw</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">machinist</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">mechanic</name>
		<specialization compare="is anything"></specialization>
		<amount>-6</amount>
	</skill_bonus>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">high manual dexterity</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B138</reference>
	<description-loc>У вас очень слабо развита тонкая моторика. Вы получаете пенальти ко всем проверкам, зависящим от DX, при использовании умений, которые перечислены в описании Высокой ловкости рук (B59), а также умения Быстрое выхватывание. За -5 очков это пенальти составит -3; за -10 очков оно составит -6. Это не влияет на задания, зависящие от IQ, или на более масштабное использование DX и не действует на боевые проверки за исключением Быстрого выхватывания.
Вы неаккуратно едите, не можете правильно завязать галстук и т.д. По решению мастера вы получаете -1 за уровень данной особенности ко всем проверкам на Влияние или реакцию, когда необходимо проявить опрятность и аккуратность.
Данный недостаток взаимно исключается с преимуществом Высокая ловкость рук.</description-loc>
</advantage>
	<advantage version="2">
		<name>Hard of Hearing</name>
		<name-loc>Тугоухость
</name-loc>
		<description-loc>Вы не глухой, но испытываете проблемы со слухом. Вы получаете -4 к любой проверке на Слух и к любым умениям, для которых важно что-то разбирать со слуха (если вы выступаете в роли говорящего, то этот недостаток на вас не влияет).</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B138</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<attribute_bonus>
			<attribute>hearing</attribute>
			<amount>-4</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Hard to Kill</name>
		<name-loc>Трудно убить</name-loc>
		<description-loc>Вас необычайно трудно убить. Каждый уровень этого преимущества добавляет +1 ко всем проверкам HT на выживание. Если вы провалили обычную проверку HT, но выполнили ее с бонусом за преимущество Трудно убить, вы выглядите мертвым (успешная проверка Диагностики выявит признаки жизни), но придете в себя через некоторое время (см. Восстановление сознания, с. B423).
=====Пример: У Бруно HT 12 и 4 уровня преимущества Трудно убить. Снаряд из гранатомета наносит ему 30 очков повреждений, что снижает его HT до –18. Это требует от него двух проверок HT, чтобы остаться в живых (первая при –12, а вторая при –17). В первый раз он выбрасывает 11 – никаких проблем, остается в живых. При втором броске выпадает 14. Это выше его обычного HT (12), но меньше модифицированного HT (12+4 уровня преимущества Трудно убить). Проверка удачна, и враги бросают его, считая мертвым. Почти через день он придет в сознание, все еще раненный, но живой!=====
Это «киношное» (cinematic) преимущество, и мастер волен запретить его в реалистичной кампании. С другой стороны, в действительно реалистичной кампании продолжительность жизни приключенца может оказаться удручающе короткой... Для реалистичных игр рекомендуемый максимальный уровень - 2.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B58</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Hard to Subdue</name>
		<name-loc>Сложно лишить сознания</name-loc>
		<description-loc>Вас сложнее лишить сознания. Каждый уровень дает +1 на броски НТ, чтобы избежать потери сознания от ран, оружия или химикатов – и даже от сверхъестественных способностей, которые вызывают потерю сознания. В реалистичных кампании Мастер может ограничить максимальный уровень до 1-2.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B59</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Healing</name>
		<name-loc>Исцеление</name-loc>
		<description-loc>Вы способны исцелять других (но не себя). Вы должны касаться субъекта. Для активации вы должны концентрироваться в течение 1 секунды и сделать бросок IQ. Если субъект без сознания, бросок делается с -2.
Исцеление ран: при успехе вы можете исцелить 2 НР за каждые потраченные вами 1 FP. Провал стоит 1d FP, но вы можете попробовать снова. Критический провал кроме того, наносит субъекту 1d вреда. Исцеление даже 1 НР останавливает кровотечение. Броском со штрафом -6 вы можете восстановить сломанную, но присутствующую конечность, если вы исцеляете все ранения, которые привели к калечеству. Например, чтобы исцелить сломанную кисть (получила 4 вреда), сделайте бросок IQ-6 и потратьте 2 FP. Каждый целитель получает только одну попытку на каждую сломанную конечность. Исцеление не может отрастить конечность заново, или вернуть к жизни мертвого.
Исцеление болезней. Требует броска IQ, модифицированного на усмотрение мастера – от +1 за банальную простуду до -15 за СПИД. Цена в FP равна удвоенному штрафу, но минимум – 1 FP. Например, вы можете исцелить болезнь, требующую броска IQ-3, потратив 6 FP.
За каждую успешную попытку одного типа (исцеление ран или болезней), применяемую на одного субъекта, вы получаете кумулятивный штраф -3. Этот штраф накапливается, пока не пройдет один полный день со времени последней попытки.

Считается, что данная способность работает только по отношению к расе целителя и всем «подобным» расам. В кампании по фентези все теплокровные гуманоидные расы (эльфы, дварфы, орки, хоббиты и т.д.) будут «подобными».

===Новые особые улучшения===
Обычно Исцеление подразумевает касание. «Целительные лучи» можно имитировать улучшением
Дистанционность (+40%). Распространены и другие улучшения:
Исцеление себя (Affects Self): Вы можете исцелять и себя тоже, если находитесь в сознании. Если вы пытаетесь исцелиться в следующий ход после получения вреда, на бросок Исцеления налагается штраф за болевой шок. +50%.
Исцеление воздействий (Cure Affliction): Вы можете нейтрализовать активные Воздействия – включая подобные им эффекты Побочного действия и Симптомов. Это требует броска ИН со штрафом, равным -1 за каждые полные +50% улучшений Воздействия. Затраты энергии равны удвоенному
значению этого штрафа, но минимум 1 ЕУ. Например, Слепота – улучшение Воздействия на +50%, так что ее исцеление будет стоить 2 ЕУ, и бросок Исцеления получит штраф -1. +60%.

Исцеление верой (Faith Healing): Ваша сила работает путем направления духовной энергии. Это позволяет вам исцелять любого, кого посчитают достойным этого ваши покровители. Однако вы (и возможно, субъект), должны придерживаться определенного морального кодекса, соответствюущего покровителям, иначе способность перестанет работать. Вы не можете комбинировать это расширение с модификаторами Только своя раса или Ксенолечение. +20%.

Ксенолечение (Xeno Healing): Вы можете исцелять существ, значительно отличающихся от вас. Например, если целитель – человек: «Все млекопитающие» (+20%), «Все живые существа Земли» (+40%), «Все белковые формы жизни» (+60%), «Все живые существа» (+80%), «Все существа, обладающие признаками жизни» (включая умертвия, големов и т.д.) (+100%):

===Новые особые ограничения===
Только исцеление Воздействий (Affliction Only): вы можете исцелять только воздействия, как описано выше. Вы не можете лечить раны и болезни. -40%.

Только болезни (Disease Only): Вы можете только исцелять болезни. -40%.

Только ранения (Injuries Only): Вы можете исцелять только раны. -20%.

Только своя раса (Own Race Only): Это ограничение доступно только в мирах с множеством разумных рас. -20%.
Псионическое лечение (Psychic Healing): Ваша способность – часть Псионической силы. -10%.

===Ограниченные затраты===

Ограниченные затраты (Capped): вы можете тратить только ограниченное количество ЕУ на каждое использование. Это ограничивает серьезность болезней, которые вы можете исцелять и заставит вас потратить несколько попыток на серьезные раны (занимая больше времени и, разумеется, с обычным штрафом -3 за
повторное лечение), и может вообще запретить исцеление травм.
Стоимость ограничения - -25% за потолок в 2 ЕУ, -20% за 4 ЕУ, -15% за 6 ЕУ, -10% за 8 ЕУ, и -5% за 10 ЕУ.
Дальнейшее увеличение потолка свыше 10 ЕУ нецелесообразно.

Эмпатическое (Empathic): Когда вы исцеляете других, вы не оплачиваете цену в ЕУ, но страдаете от эффектов, которые вы исцеляете. Эффекты действуют на вас, даже если вы неуязвимы к ним. На вас они исцеляются своим обычным путем, если не будут вылечены искусственно (например, вы можете перенести ваши раны на кого-либо другого с помощью Вытягивания). Ограничение несовместимо с Ограниченными Затратами. -50%.
</description-loc>
		<type>Mental, Exotic</type>
		<base_points>30</base_points>
		<modifier version="1" enabled="no">
			<name>Исцеление верой (Faith Healing)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B59</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ксенолечение (Xenohealing)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B59</reference>
			<notes>Все млекокитающие</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ксенолечение (Xenohealing)</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B59</reference>
			<notes>Все земные формы жизни</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ксенолечение (Xenohealing)</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B59</reference>
			<notes>Все углеродные формы жизни</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ксенолечение (Xenohealing)</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>B59</reference>
			<notes>Любые формы жизни</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ксенолечение (Xenohealing)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B59</reference>
			<notes>Все движущиеся (включая нежить, големов и т.п.)</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только болезни (Disease Only)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B59</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только раны (Injuries Only)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B59</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только своя раса (Own Race Only)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B59</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Пси-лечение (Psychic Healing)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B59</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Affects Self</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cure Affliction</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>P51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Affliction Only</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P51</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Capped</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P51</reference>
			<notes>2 FP</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Capped</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P51</reference>
			<notes>4 FP</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Capped</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>P51</reference>
			<notes>6 FP</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Capped</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P51</reference>
			<notes>8 FP</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Capped</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>P51</reference>
			<notes>10 FP</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Empathic</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P51</reference>
		</modifier>
		<reference>B59</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Heliophobia (Sun)</name>
	<name-loc>Боязнь солнца (Гелиофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>-15 очков *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Hemophilia</name>
		<name-loc>Гемофилия
</name-loc>
		<description-loc>Вы страдаете несвертываемостью крови. Даже небольшая рана не затянется, если ее не перевязать как следует - и вы можете истечь кровью. Неперевязанная рана кровоточит, нанося в минуту изначальное число повреждений от ранения. Например, не перевязанная рана на 3 HP будет каждую минуту отнимать еще 3 HP из-за кровотечения, если его не остановить.
Первой помощи достаточно, чтобы остановить кровь из большинства ран, но проникающие ранения в торс приводят к медленному внутреннему кровотечению. Они причиняют повреждения каждую минуту, как описано выше, пока вам не окажут Первую помощь. Более того, она продолжает наносить вред, равный изначальным повреждениям, раз в день, пока ее не обработают. Только проверка на Хирургию или сверхъестественное лечение способно остановить внутреннее кровотечение и вернуть потерянные из-за него HP. Если подобное лечение недоступно, то вы вскоре умрете.
Если вы страдаете от данного недостатка, то ваш показатель HT не может превышать 10.</description-loc>
		<type>Physical</type>
		<base_points>-30</base_points>
		<reference>B138</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="ht" compare="at most">10</attribute_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Hemophobia (Blood)</name>
	<name-loc>Боязнь крови (Гемофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Вас бросает в дрожь от одного вида крови! Вам приходится делать проверку на самоконтроль во время большинства боев... -10 очков.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Hermaphromorph</name>
		<name-loc>Гермафроморф</name-loc>
		<description-loc>Вы можете полноценно изменять свой пол (мужской, женский или средний) за 10 секунд. Соответствующие модификаторы (Требует перезарядки, Занимает больше времени, Требуется подготовка) – доступны.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B59</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Herpetophobia (Reptiles)</name>
	<name-loc>Боязнь рептилий (Герпетофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>У вас вызывает отвращение одна мысль о рептилиях, земноводных и тому подобных чешуйчатых гадах. Очень большая или ядовитая рептилия дает пенальти -2 к самоконтролю, а множество (например, яма со змеями) -4. -10 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Hidebound</name>
		<name-loc>Косный
</name-loc>
		<description-loc>Вам трудно породить оригинальную мысль. Вы получаете пенальти -2 ко всем заданиям, которые требуют творческого или изобретательного подхода, а к ним относится большинство проверок умения Рисование, проверки Инженерии для создания новых изобретений и все проверки умений, необходимые для использования преимущества Изобретатель.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B138</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>High Manual Dexterity</name>
		<name-loc>Улучшенная ловкость рук</name-loc>
		<description-loc>Вы обладаете заметно более развитой тонкой моторикой рук. Каждый уровень (до максимума в +4) дает +1 к DX для тех задач, где важна тонкая моторика. Это включает все броски, основанные на DX для таких навыков, как Изобразительное искусство, Ювелир, Вязание узлов, Кожевник, Взлом, Карманное воровство, Шитье, Ловкость рук и Хирургия, а также в случае работы с мелкими деталями при использовании навыков Слесарь или Механик (например, с часовыми механизмами). Премия не распространяется на задачи, основанные на IQ, или работу с более крупными предметами; а также на боевые броски любого рода.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B59</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="contains">artist</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">jeweler</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">knot-tying</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leatherworking</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">lockpicking</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pickpocket</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sewing</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sleight of hand</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">surgery</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">machinist</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">mechanic</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
	<name>High Pain Threshold</name>
	<name-loc>Высокий болевой порог</name-loc>
	<notes>Не получает штрафов за шок от ран; +3 на HT броски чтобы избежать потри сознания или оглушения; +3 сопротивления пыткам</notes>
	<base_points>10</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B59</reference>
	<description-loc>Вы подвержены ранениям как и все, но не так остро ощущаете боль. Вы никогда не получаете штраф за шок когда ранены. А также, получаете +3 к броску HT чтобы избежать нокаута или оглушения — и даже если вас физически пытают , вы сопротивляетесь с +3. Мастер может позволить вам проверять Волю (Will) с +3 для игнорирования боли в других ситуациях

Высокий болевой порог включен в Сверхъестественную выносливость (с. B89). если у вас есть последнее, вы не можете взять Высокий болевой порог.</description-loc>
</advantage>
	<advantage version="2">
		<name>High TL</name>
		<name-loc>Высокий TL</name-loc>
		<description-loc>Ваш личный TL выше технического уровня мира, где проходит кампания. Вы можете начать игру с умениями, связанными с вещами своего TL. Это наиболее полезно, если у вас также имеется доступ к снаряжению более высокого TL (см. Технический уровень и снаряжение, B27), хотя, например, знания врача или ученого из технически развитого мира окажутся очень полезны в слаборазвитом мире, даже если у него не будет специального оборудования!</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B23</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Higher Purpose</name>
	<name-loc>Высшая цель</name-loc>
	<base_points>5</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B59</reference>
	<description-loc>Вы стараетесь всеми силами выполнять одну цель. Цель определяется точно также, как и Кодекс Чести (с. B127) (защищать всех женщин, уничтожать всех демонов и пр.). Вы получаете +1 на все броски, прямо относящиеся к вашей цели. Отклонение от цели карается потерей бонуса и штрафами за плохой отыгрыш. 
Высшая цель должна быть специфичной. Цели наподобие «побеждать зло» или «противостоять чиновникам» слишком широки. Кроме того, Высшая цель должна доставлять риск и неудобства. Мастер не должен позволять прагматичные цели наподобие «верно служить господину».</description-loc>
</advantage>
	<advantage version="2">
		<name>Honest Face</name>
		<name-loc>Честное лицо</name-loc>
		<description-loc>Вы просто выглядите честным, надежным или безобидным человеком. Это ничуть не влияет на вашу репутацию среди тех, кто знает вас или ваше истинное лицо. Люди, с вами не знакомые, будут выбирать вас, если хотят доверить что-то – или избегать этого, если ищут потенциального преступника или неприятных людей. Таможенники не выберут вас и ваши вещи для случайного досмотра, если не имеют причин для подозрения. Вы получает +1 к изученному навыку Артистизма, если пытаетесь «изобразить невинность»
</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Honesty</name>
	<name-loc>Законопослушный
</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>1</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Вопросы справедливости</limitation>
		<amount>2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B138</reference>
	<description-loc>Вы обязаны следовать закону и делать все что в ваших силах, чтобы и другие ему следовали. В тех местах, где закона нет или он плохо соблюдается, вы не считаете все дозволенным - вы действуете так, как если бы законы ваших родных мест действовали и здесь. Кроме того, вы считаете, что другие поступают по закону, если только не знаете, что это не так (сделайте проверку IQ, чтобы понять, что кто-либо действует не по закону, если вы не видели доказательств этого).
Это недостаток, поскольку он ограничивает ваши возможности! Сделайте проверку на самоконтроль, когда сталкиваетесь с "необходимостью" нарушить неразумный закон; в случае неудачи вы обязаны ему подчиниться независимо от последствий. Если вы смогли сдержать свой порыв и нарушили закон, то после этого проведите еще одну проверку на самоконтроль. В случае неудачи вы должны пойти и сдаться властям!
Вы можете сражаться (или даже начинать бой, если это не нарушает закона). Вы даже способны убить в ходе законной дуэли или при самозащите - но вы никогда не совершите преступного убийства. Вы можете украсть, если очень нуждаетесь, но это будет последним из ваших средств, и позже вы должны попытаться 
возместить пострадавшему украденное. Если вы осуждены за преступление, которого не совершали, но с вами обращаются как положено и вам гарантирован суд, то вы не попытаетесь бежать.
Вы всегда держите слово. (На войне вы способны действовать против врага "бесчестно", но радости по этому поводу не испытываете!) Однако вы способны лгать, если это не означает нарушения закона. Правдивость (B159) - это отдельный недостаток.
Конечно, Законопослушность по-своему вознаграждается. Если вы жили в определенном месте достаточно долго, чтобы о вашей законопослушности стало известно, то мастер может дать вам +1 к не боевым проверкам реакции - или +3, если затрагивается вопрос правдивости или чести. По сути, это бесплатная Репутация (см. Репутация, B26).</description-loc>
</advantage>
	<advantage version="2">
	<name>Hoplophobia (Weapons)</name>
	<name-loc>Боязнь оружия (Гоплофобия)</name-loc>
	<base_points>-20</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы нервничаете в присутствии любого оружия. Попытка использовать оружие или угроза им, требует проверки на самоконтроль с -2. -20 очков *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Horizontal</name>
		<name-loc>Горизонтальный
</name-loc>
		<description-loc>Ваше тело имеет горизонтальное положение, как у кошки. Вы можете недолго простоять на задних лапах, но для вас это очень неудобно. Вы можете использовать одну руку (если у вас вообще есть руки), стоя на других конечностях, или две руки, стоя на задних лапах; в обоих случаях ваше Передвижение в этот момент равно 0. Вы можете нести предмет в одной руке, двигаясь с половиной Передвижения, но не можете его использовать. Если вы человеческих размеров, то занимаете два гекса на боевой карте.
Горизонтальное строение не позволяет вам вложить всю массу в удар ногой. Как результат, ваши повреждения при ударе ногой получают -1 за кубик. Не учитывайте данное пенальти, если у вас есть Когти (B42) - данная особенность предполагает приспособленность к удару в полную силу. Но данное пенальти применяется к тем, у кого есть Копыта.
Не берите данный недостаток, если вы Воздушное или Водное существо (см. Безногий, B145). Если вы полностью приспособлены к трехмерной среде обитания, то положение тела не имеет значения.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Horrible Hangovers</name>
		<name-loc>Жуткое похмелье</name-loc>
		<description-loc>
Вы получаете дополнительных -3 очка к любым пенальти, которые мастер назначает за вчерашнее злоупотребление алкоголем, а ваше похмелье длится на три часа дольше.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Humble</name>
		<name-loc>Скромный</name-loc>
		<description-loc>
Слабая форма Альтруиста (B153). Вы чаще принимаете во внимание интересы других людей или группы, чем свои собственные.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Hunchback</name>
		<name-loc>Горбун
</name-loc>
		<description-loc>Деформация позвоночника заставляет вас находиться в скривленном и сгорбленном положении, обычно это выражается в наличии заметного горба на одном или обоих плечах. Это снижает рост на 6'' при неизменном весе или сложении. Обычные одежда и броня вам плохо подходят, что дает -1 к DX; во избежание этого вам придется платить на 10% больше за специально изготовленные вещи.
Большинство людей ваш вид раздражает, и они реагируют на вас с -1. Данное пенальти добавляется к обычным модификаторам за внешность (см. Внешность, B21), и ваша внешность не может быть выше Средней. Кроме того, ваша внешность примечательна, что дает вам -3 к проверкам на Изменение внешности или Слежку, а другим +3 к попыткам узнать вас или следить за вами.
Для правдоподобия горбуну следует также взять недостаток Боли в спине (B123), но это не обязательно.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Hyperspectral Vision</name>
		<name-loc>Гиперспектральное зрение</name-loc>
		<description-loc>Вы можете видеть во всех частях спектра – инфракрасном, видимом и ультрафиолетовом. Такое совмещенное зрение часто окрывает вещи, невидимые для обладателей только одного или двух видов.
Гиперспектральное зрение дает почти совершенное ночное зрение: вы не получаете штрафа за плохую освещенность до тех пор, пока вокруг есть вообще хоть немного света. В абсолютной темноте вы действуете с помощью Инфразрения. Эта черта дает вам также +3 на все броски зрения, и попытки увидеть что-либо с помощью Поиска, Наблюдения и Следопытства, а также Экспертизы.

Преимущество уже включает эффекты Инфразрения и Ультразрения, так что вы не можете купить их отдельно. Мастер может разрешить суперам брать особые расширения, которые недоступны в обычном мире.

===Особые улучшения.===

Расширенный нижний порог (Extended Low-band): вы воспринимаете излучение частотой ниже инфракрасного – микроволны и радиоволны. Это не дает способности понимать радиосигналы. +30%.
Расширенный верхний порог (Extended High-band): вы можете воспринимать излучение свыше ультрафиолетового, и видите такое излучение, как рентгеновское и гамма-излучение. +30%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>25</base_points>
		<modifier version="1" enabled="no">
			<name>Расширенный нижний диапазон (Extended Low-Band)</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>B60</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Расширенный верхний диапазон (Extended High-Band)</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>B60</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Extended</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>P52</reference>
			<notes>@Special@</notes>
		</modifier>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">infravision</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="no">
				<name compare="is">ultravision</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Illuminated</name>
		<name-loc>Просвещенный</name-loc>
		<description-loc>Вы – «иллюминати», просвещенный о истинной природе мира. Вы интуитивно знаете, что происходит.
Вы можете безошибочно различить других Иллюминати при взгляде на них. Далее, когда Мастер требует броска против таких навыков, как Свежие новости, Тайное знание или Анализ разведданных в случае, когда странные события возникли в результате конспиративных действий, вы можете бросать высшее значение из IQ и требуемого навыка. Наконец, вы можете обнаруживать и общаться со сверхъестественными существами, связанными с конспиративными структурами Иллюминати в вашем игровом мире (на усмотрение Мастера). Это не дает вам никаких особых способностей их контролировать, но они узнают вас и реагируют с определенным уважением: +3 на броски реакции.
Единственный недостаток – то, что другие Иллюминати и существа их мира также распознают вашу просвещенную натуру, и вы ничего не можете сделать, кроме как не попадаться им на глаза.
Это преимущество лучше подходит для мистической или фантастической кампании. Для обычной игры, пусть и проходящей в условиях конспирации – не очень. Кто может обладать этой чертой – на усмотрение Мастера.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>15</base_points>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Imaginative</name>
		<name-loc>Богатое воображение</name-loc>
		<description-loc>
Из вас фонтаном бьют идеи, которыми вы непременно желаете поделиться с остальными! Это, конечно, могут быть хорошие идеи или не очень хорошие...</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Improved G-tolerance</name>
	<name-loc>Терпимость к перегрузкам</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>0.3G</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B60</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>0.5G</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B60</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1G</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B60</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>5G</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B60</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>10G</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>B60</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B60</reference>
	<description-loc>Вы можете нормально действовать при другой гравитации. Для нормального человека штрафы за неродную гравитацию начинаются при изменении гравитации на 0.2G (см. Различная гравитация, с.350). Более широкие пределы стоят следующим образом: 5 очков - 0.3G, 10 очков - 0.5G, 15 очков - 1G, 20 очков - 5G, 25 очков - 10G.
Обычным людям не следует позволять тратить на эту черту свыше 10 очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Impulsiveness</name>
		<name-loc>Импульсивность
</name-loc>
		<description-loc>Вы ненавидите разговоры и обсуждения. Вы предпочитаете действовать! Когда вы один, то сначала действуете, а потом думаете. В составе группы, когда ваши друзья собираются остановиться и что-то обсудить, вам следует внести свои пять центов как можно быстрее - если вообще это делать - а затем сделать что-нибудь. Отыграйте это! Выполните проверку на самоконтроль каждый раз, когда разумнее было бы подождать и подумать. В случае неудачи вы обязаны действовать.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Incompetence (@Skill@)</name>
		<name-loc>Некомпетентность  (@Умение@)</name-loc>
		<description-loc>
Вы ни на что не годны в одном конкретном умении. Вы не можете ему научиться и получаете пенальти -4 к его значению по умолчанию. Это не может касаться только одной специализации из умения - если вы, например, некомпетентны с огнестрельным оружием, то со всеми его видами. Мастер может не позволить Некомпетентность, если умение не подходит для данного персонажа или вряд ли будет играть роль в кампании.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
		<skill_bonus>
			<name compare="is">@Skill@</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Basic Move</name>
		<name-loc>Повышенное перемещение</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B17</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>move</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Basic Speed</name>
		<name-loc>Повышенная скорость</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B17</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>speed</attribute>
			<amount per_level="yes">0.25</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
	<name>Increased Consumption</name>
	<name-loc>Повышенная потребность в пище</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>x2</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B139</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>x4</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B139</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>x8</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B139</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B139</reference>
	<description-loc>Один "прием пищи" позволяет вам действовать гораздо меньшее время, чем обычному человеку. Это подходит для небольших существ, которым необходимо есть часто, а также машинам, которые быстро расходуют топливо или запас энергии.


|Повышенная потребность в пище 1: |Вы обязаны принимать пищу шесть раз в день. Если вы обладаете мета-особенностью Машина (B263), то ваш заряд составляет 4 часа.
|Повышенная потребность в пище 2: |Вы обязаны принимать пищу 12 раз в день. Если вы обладаете мета-особенностью Машина, то ваш заряд составляет 2 часа.
|Повышенная потребность в пище 3: |Вы обязаны принимать пищу 24 раза в день. Если вы обладаете мета-особенностью Машина, то ваш заряд составляет 1 час.


...и так далее, удваивайте потребность в пище и сокращайте вдвое заряд на каждом последующем уровне. Первый уровень данной особенности доступен обычным людям, страдающим Полнотой и лишним весом (см. Сложение, B19) или недостатком Прожорливость (B137).</description-loc>
</advantage>
	<advantage version="2">
		<name>Increased Dexterity</name>
		<name-loc>Повышенная ловкость</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Нет хороших манипуляторов (No Fine Manipulators)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
		</modifier>
		<reference>B15</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>dx</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Health</name>
		<name-loc>Повышенное здоровье</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<reference>B14</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>ht</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Intelligence</name>
		<name-loc>Повышенный интеллект</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<reference>B15</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>iq</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Life Support (Extreme Cold, below 0)</name>
		<name-loc>Повышенные требования к среде
 (Холод, ниже -20С)</name-loc>
		<description-loc>Ваши требования к жизнеобеспечению во враждебной среде выше, чем у обычных людей. Вот ряд примеров:


Особо высокая/низкая температура: Вам требуется температура свыше 200 градусов [~100 градусов по Цельсию] или ниже 0 градусов [~20 градусов по Цельсию]. -10 очков.
Массивное снаряжение: Вам требуется более тонны дополнительного груза, чтобы жить на борту космического корабля или подводной лодки или в любом месте, где ограничены ресурсы и пространство. Если вы можете использовать скафандр, то он всегда весит не менее тонны. -10 очков.
Герметичность: Для жизнеобеспечения вам необходимо отдельное герметичное пространство. -10 очков.
Радиоактивность: Вы радиоактивны или вам требуется радиоактивная среда. -10 очков.


Мастер может позволить прочие виды Повышенных требований к среде. Это не должно стоить больше -10 очков за раз, разве что эти требования чрезвычайно необычны. Если у вас имеются различные требования, то сложите их цены, но обратите внимание, что общая стоимость недостатка не может превышать -40 очков.
Данный недостаток отражает неудобства с материальным обеспечением, возникающие при использовании систем жизнеобеспечения, в то время как Зависимость (B130), Требует обслуживания (B143) и Ограниченный рацион (B151) отражают последствия для здоровья, наступающие при несоблюдении определенных требований. Одинаковые требования могут входить в обе категории, если последствия есть как для здоровья, так и для материального обеспечения. Но помните, что Зависимость, которая удовлетворяется маленьким ингалятором или лекарством, не позволяет вам получить Повышенные требования к среде за герметичный отсек, заполненный этим средством! Последнее слово остается за мастером.
С разрешения мастера обычные люди могут брать этот недостаток для отражения особых требований при определенных хронических заболеваниях.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Increased Life Support (Extreme Heat, above 200)</name>
		<name-loc>Повышенные требования к среде
 (Жара, выше 100С)</name-loc>
		<description-loc>Ваши требования к жизнеобеспечению во враждебной среде выше, чем у обычных людей. Вот ряд примеров:


Особо высокая/низкая температура: Вам требуется температура свыше 200 градусов [~100 градусов по Цельсию] или ниже 0 градусов [~20 градусов по Цельсию]. -10 очков.
Массивное снаряжение: Вам требуется более тонны дополнительного груза, чтобы жить на борту космического корабля или подводной лодки или в любом месте, где ограничены ресурсы и пространство. Если вы можете использовать скафандр, то он всегда весит не менее тонны. -10 очков.
Герметичность: Для жизнеобеспечения вам необходимо отдельное герметичное пространство. -10 очков.
Радиоактивность: Вы радиоактивны или вам требуется радиоактивная среда. -10 очков.


Мастер может позволить прочие виды Повышенных требований к среде. Это не должно стоить больше -10 очков за раз, разве что эти требования чрезвычайно необычны. Если у вас имеются различные требования, то сложите их цены, но обратите внимание, что общая стоимость недостатка не может превышать -40 очков.
Данный недостаток отражает неудобства с материальным обеспечением, возникающие при использовании систем жизнеобеспечения, в то время как Зависимость (B130), Требует обслуживания (B143) и Ограниченный рацион (B151) отражают последствия для здоровья, наступающие при несоблюдении определенных требований. Одинаковые требования могут входить в обе категории, если последствия есть как для здоровья, так и для материального обеспечения. Но помните, что Зависимость, которая удовлетворяется маленьким ингалятором или лекарством, не позволяет вам получить Повышенные требования к среде за герметичный отсек, заполненный этим средством! Последнее слово остается за мастером.
С разрешения мастера обычные люди могут брать этот недостаток для отражения особых требований при определенных хронических заболеваниях.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Increased Life Support (Massive)</name>
		<name-loc>Повышенные требования к среде
 (Массивное снаряжение)</name-loc>
		<description-loc>Ваши требования к жизнеобеспечению во враждебной среде выше, чем у обычных людей. Вот ряд примеров:


Особо высокая/низкая температура: Вам требуется температура свыше 200 градусов [~100 градусов по Цельсию] или ниже 0 градусов [~20 градусов по Цельсию]. -10 очков.
Массивное снаряжение: Вам требуется более тонны дополнительного груза, чтобы жить на борту космического корабля или подводной лодки или в любом месте, где ограничены ресурсы и пространство. Если вы можете использовать скафандр, то он всегда весит не менее тонны. -10 очков.
Герметичность: Для жизнеобеспечения вам необходимо отдельное герметичное пространство. -10 очков.
Радиоактивность: Вы радиоактивны или вам требуется радиоактивная среда. -10 очков.


Мастер может позволить прочие виды Повышенных требований к среде. Это не должно стоить больше -10 очков за раз, разве что эти требования чрезвычайно необычны. Если у вас имеются различные требования, то сложите их цены, но обратите внимание, что общая стоимость недостатка не может превышать -40 очков.
Данный недостаток отражает неудобства с материальным обеспечением, возникающие при использовании систем жизнеобеспечения, в то время как Зависимость (B130), Требует обслуживания (B143) и Ограниченный рацион (B151) отражают последствия для здоровья, наступающие при несоблюдении определенных требований. Одинаковые требования могут входить в обе категории, если последствия есть как для здоровья, так и для материального обеспечения. Но помните, что Зависимость, которая удовлетворяется маленьким ингалятором или лекарством, не позволяет вам получить Повышенные требования к среде за герметичный отсек, заполненный этим средством! Последнее слово остается за мастером.
С разрешения мастера обычные люди могут брать этот недостаток для отражения особых требований при определенных хронических заболеваниях.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Increased Life Support (Pressurized)</name>
		<name-loc>Повышенные требования к среде
 (Герметичность)</name-loc>
		<description-loc>Ваши требования к жизнеобеспечению во враждебной среде выше, чем у обычных людей. Вот ряд примеров:


Особо высокая/низкая температура: Вам требуется температура свыше 200 градусов [~100 градусов по Цельсию] или ниже 0 градусов [~20 градусов по Цельсию]. -10 очков.
Массивное снаряжение: Вам требуется более тонны дополнительного груза, чтобы жить на борту космического корабля или подводной лодки или в любом месте, где ограничены ресурсы и пространство. Если вы можете использовать скафандр, то он всегда весит не менее тонны. -10 очков.
Герметичность: Для жизнеобеспечения вам необходимо отдельное герметичное пространство. -10 очков.
Радиоактивность: Вы радиоактивны или вам требуется радиоактивная среда. -10 очков.


Мастер может позволить прочие виды Повышенных требований к среде. Это не должно стоить больше -10 очков за раз, разве что эти требования чрезвычайно необычны. Если у вас имеются различные требования, то сложите их цены, но обратите внимание, что общая стоимость недостатка не может превышать -40 очков.
Данный недостаток отражает неудобства с материальным обеспечением, возникающие при использовании систем жизнеобеспечения, в то время как Зависимость (B130), Требует обслуживания (B143) и Ограниченный рацион (B151) отражают последствия для здоровья, наступающие при несоблюдении определенных требований. Одинаковые требования могут входить в обе категории, если последствия есть как для здоровья, так и для материального обеспечения. Но помните, что Зависимость, которая удовлетворяется маленьким ингалятором или лекарством, не позволяет вам получить Повышенные требования к среде за герметичный отсек, заполненный этим средством! Последнее слово остается за мастером.
С разрешения мастера обычные люди могут брать этот недостаток для отражения особых требований при определенных хронических заболеваниях.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Increased Life Support (Radioactive)</name>
		<name-loc>Повышенные требования к среде
 (Радиоактивность)</name-loc>
		<description-loc>Ваши требования к жизнеобеспечению во враждебной среде выше, чем у обычных людей. Вот ряд примеров:


Особо высокая/низкая температура: Вам требуется температура свыше 200 градусов [~100 градусов по Цельсию] или ниже 0 градусов [~20 градусов по Цельсию]. -10 очков.
Массивное снаряжение: Вам требуется более тонны дополнительного груза, чтобы жить на борту космического корабля или подводной лодки или в любом месте, где ограничены ресурсы и пространство. Если вы можете использовать скафандр, то он всегда весит не менее тонны. -10 очков.
Герметичность: Для жизнеобеспечения вам необходимо отдельное герметичное пространство. -10 очков.
Радиоактивность: Вы радиоактивны или вам требуется радиоактивная среда. -10 очков.


Мастер может позволить прочие виды Повышенных требований к среде. Это не должно стоить больше -10 очков за раз, разве что эти требования чрезвычайно необычны. Если у вас имеются различные требования, то сложите их цены, но обратите внимание, что общая стоимость недостатка не может превышать -40 очков.
Данный недостаток отражает неудобства с материальным обеспечением, возникающие при использовании систем жизнеобеспечения, в то время как Зависимость (B130), Требует обслуживания (B143) и Ограниченный рацион (B151) отражают последствия для здоровья, наступающие при несоблюдении определенных требований. Одинаковые требования могут входить в обе категории, если последствия есть как для здоровья, так и для материального обеспечения. Но помните, что Зависимость, которая удовлетворяется маленьким ингалятором или лекарством, не позволяет вам получить Повышенные требования к среде за герметичный отсек, заполненный этим средством! Последнее слово остается за мастером.
С разрешения мастера обычные люди могут брать этот недостаток для отражения особых требований при определенных хронических заболеваниях.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B139</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Increased Perception</name>
		<name-loc>Повышенное восприятие</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental/Physical</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>perception</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Increased Strength</name>
		<name-loc>Повышенная сила</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<modifier version="1" enabled="no">
			<name>Нет хороших манипуляторов (No Fine Manipulators)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B15</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Размер (Size)</name>
			<cost type="percentage">-10</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B15</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Super-Effort</name>
			<cost type="percentage">300</cost>
			<affects>total</affects>
			<reference>Sup24</reference>
		</modifier>
		<reference>B14</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>st</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
    <advantage version="2">
        <name>Increased Size</name>
        <name-loc>Увеличеный Размер</name-loc>
        <description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
        <type>Physical</type>
        <levels>1</levels>
        <points_per_level>0</points_per_level>
        <reference>B19</reference>
        <categories>
            <category>Attribute</category>
        </categories>
        <attribute_bonus>
            <attribute>sm</attribute>
            <amount per_level="yes">1</amount>
        </attribute_bonus>
    </advantage>
	<advantage version="2">
		<name>Increased Will</name>
		<name-loc>Повышенная воля</name-loc>
		<description-loc>Используется для создания рас и шаблонов.
В другом случае просто изменяйте характеристику на листе персонажа.</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B16</reference>
		<categories>
			<category>Advantage</category>
			<category>Attribute</category>
		</categories>
		<attribute_bonus>
			<attribute>will</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Incurious</name>
		<name-loc>Нелюбопытный
</name-loc>
		<description-loc>Вы с большим трудом замечаете вещи, несвязанные с вашими текущими интересами. Сделайте проверку на самоконтроль, когда сталкиваетесь с чем-то необычным. Если проверка неудачна, то вы не обращаете на это внимания! На все новое вы реагируете с -1.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Indecisive</name>
		<name-loc>Нерешительность
</name-loc>
		<description-loc>Вы испытываете трудности с принятием решений. Пока существует единственный путь, вы чувствуете себя хорошо, но как только возникает выбор, вы приходите в замешательство. Сделайте проверку на самоконтроль, когда сталкиваетесь с выбором, используя отрицательный модификатор за каждую явную для вас альтернативу: -2, если выбор из двух вариантов, -3, если из трех и т.д. Если проверка неудачна, то вы ничего не делаете. Повторяйте проверку ежеминутно (или ежесекундно в бою или подобной крайне напряженной ситуации), пока не решитесь, после чего вы можете нормально действовать до тех пор, пока снова не встретитесь с выбором.
Если вы одновременно Нерешительны и Заторможены (B129), то должны делать описанную выше проверку, чтобы выбрать, как действовать. Когда вы наконец решились, следует выполнить еще одну проверку на самоконтроль - в этот раз за Заторможенность - чтобы узнать, смогли ли вы сразу исполнить свое решение.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Independent Income</name>
		<name-loc>Независимый доход</name-loc>
		<description-loc>У вас имеется источник дохода, не требующий работы: пакет акций, доверительная или сдаваемая собственность, гонорар, пособие и т.д. Ваш месячный доход составляет 1% от начального богатства (сумма зависит от уровня богатства) за уровень этого преимущества вплоть до максимума 20%. Если ваш доход зависит от вложений, то вам нужно определить их размер; эта особенность предполагает, что вы не можете или не желаете изымать капитал из оборота.
Данная черта не привязана к уровню богатства. Жутко богатая наследница может обладать Независимым доходом... но им же могут обладать пенсионер со Средним богатством или Бедный получатель благотворительных пособий.
Независимый доход чаще всего означает, что вы не занимаетесь настоящей работой - вы некто вроде рантье, пенсионера или получателя пособий.
Однако вы можете обладать Независимым доходом и работать; просто считайте доход из обоих источников. Если вы богатый, то это позволяет вам работать неполный день (например, по 10 часов в неделю, а не 40, за 1/4 обычных денег) и в то же время неплохо жить.</description-loc>
		<type>Social</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<reference>B26</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Indomitable</name>
		<name-loc>Убежденный</name-loc>
		<description-loc>На вас невозможно повлиять обычными словами или действиями. Чтобы использовать на вас навыки влияния (с. B359), необходимо иметь соответствующий вид Эмпатии (обычной, к животным, растениям или духам, в зависимости от того, кем вы являетесь). Все остальные – независимо от убедительности – автоматически проваливаются. Часто идет в комплекте с Невозмутимостью (с. B95).</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Infectious Attack</name>
		<name-loc>Заражение
</name-loc>
		<description-loc>Вы обладаете заразным сверхъестественным свойством. Эта особенность работает так же, как и преимущество Порабощение (B50) с той разницей, что вы не можете решать, кого заразить, и не можете превращать зараженных в Союзников. Это недостаток, поскольку враги, пережившие (или не пережившие!) столкновение с вами, становятся сильнее, получая "в дар" ваши сверхъестественные способности, и свободно могут использовать новые возможности с целью отомстить вам за то, что вы сделали.
Чтобы персонаж с данной особенностью не мог просто так превратить своих друзей в могущественных чудовищ, мастеру следует установить, что зараженные игровые персонажи платят очки за шаблон сверхъестественной расы, полученный таким образом. Если они не могут позволить себе подобный шаблон, мастер волен уравновесить его стоимость сверхъестественными побочными эффектами, такими, как недостатки Проклятый, Боязнь, Отвращение или Слабость.</description-loc>
		<type>Physical, Supernatural</type>
		<base_points>-5</base_points>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Infravision</name>
		<name-loc>Инфракрасное зрение</name-loc>
		<description-loc>Вы можете видеть в инфракрасной части спектра, что позволяет вам видеть различия температур. Вы даже можете видеть в абсолютной темноте, если температура выше 70оF (~20оC). Независимо от температуры, вы не получаете штрафов за темноту, сражаясь ночью, если ваш враг – это кто-то или что-то, что выделяет тепло (живые существа или большинство механизмов)! Вы получаете бонус +2 при попытке увидеть любое живое существо днем, если осматриваете некий район. Это преимущество также позволяет вам отслеживать тепловой след, идя за кем-либо. Добавьте +3 ко всем проверкам на следопытство, если следам не больше часа. 
Инфравидение не позволяет различать цвета, а только общий размер и форму объектов, излучающих тепло, так что вы можете затрудняться в различении двух людей похожих по фигуре. Для различения двух объектов, похожих по форме и размеру, необходим бросок с -4. Мастер может потребовать от вас также броска Зрения-4 для обнаружения отраженного тепла. Внезапное выделение тепла, такое как взрыв, действует на любого, кто обладает Инфракрасным зрением, подобно заклинанию Вспышка.
Если вы можете видеть только в инфракрасном спектре, то преимущество стоит 0 очков.
Обратите внимание: Инфракрасное зрение можно брать вместе с недостатком Слепота. Слепое существо, обладающее Инфракрасным зрением, всегда действует как ночью. Оно может идти по следу, но только если ему не больше часа.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормального зрения (No normal vision)</name>
			<cost type="points">-10</cost>
			<affects>total</affects>
			<reference>B60</reference>
		</modifier>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (Diffuse)</name>
		<name-loc>Устойчивость к повреждениям  (Диффузный)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>100</base_points>
		<modifier version="1" enabled="no">
			<name>Infiltration</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>P53</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Swarm</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>P53</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Swarm</name>
			<cost type="percentage">160</cost>
			<affects>total</affects>
			<reference>P53</reference>
			<notes>Can Affect Substantial</notes>
		</modifier>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (Homogenous)</name>
		<name-loc>Устойчивость к повреждениям  (Гомогенный)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>40</base_points>
		<reference>B60</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Blood)</name>
		<name-loc>Устойчивость к повреждениям  (Нет крови)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Brain)</name>
		<name-loc>Устойчивость к повреждениям  (Нет мозга)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Eyes)</name>
		<name-loc>Устойчивость к повреждениям  (Нет глаз)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Head)</name>
		<name-loc>Устойчивость к повреждениям  (Нет головы)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>7</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Neck)</name>
		<name-loc>Устойчивость к повреждениям  (Нет шеи)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (No Vitals)</name>
		<name-loc>Устойчивость к повреждениям  (Нет ж.в.о.)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Injury Tolerance (Unliving)</name>
		<name-loc>Устойчивость к повреждениям  (Неживой)</name-loc>
		<description-loc>У вас меньше физиологических слабостей, чем у обычных живых существ. Цена преимущества зависит от ценности аннулируемых уязвимости. Заметьте, что некоторые формы преимущества включают другие, и Диффузный, Гомогенный и Неживой – несовместимы.

Диффузный (Diffuse): Ваше тело стостоит из жидкости, энергии или мелких подвижных частиц. Это защищает вас от калечащих ранений, и уменьшает вред, получаемый вами от большинства физических атак. Большинство врагов не смогут вас толкнуть или схватить. Этот вариант включает все выгоды от вариантов Нет крови, Нет мозга, Нет жизненных органов. (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). 100 очков.

Гомогенный (Homogenous):  Ваше тело не имеет уязвимых внутренних органов, костей, мышц и прочих механизмов. В результате этого вы менее уязвимы для проникающих и режущих атак (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Гомогенность включает все выгоды от вариантов Нет Мозга и Нет жизненных органов. Этот вариант подходит для таких существ, как големы, деревья, слизи. 40 очков.

Нет крови (No blood): Вы не имеете жизненно важной жидкости в вашем теле, подобной крови. У вас не бывает кровотечения, вы неуязвимы для токсинов, передающихся через кровь, и иммунны к эффектам атак, отрезающих кровь от частей вашего тела. 5 очков.

Нет мозга (No Brain): Ваш мозг – если он вообще есть – отделен от вашего тела, рассеян по нему, или не является истинным вместилищем сознания. Ваши оппоненты не наносят дополнительного вреда при ударах по мозгу. У вас может быть голова, но удары по черепу и глазам не отличаются от ударов по лицу (ну разве что глаз можно повредить). 5 очков.

Нет глаз (No Eyes): У вас нет глаз или других уязвимых органов зрения, но вы каким-то образом можете видеть без них, если не возьмете Слепоту. Поскольку глаз нет, по ним нельзя бить. Кроме того, вы неуязвимы для ослепляющих атак. 5 очков.

Нет головы (No Head):  У вас совершенно нет головы. Это включает выгоды от варианта Нет мозга. Также у вас нет локаций «лицо» и «череп», и вы не нуждаетесь в защите головы. Вы по-прежнему можете говорить, слышать, видеть, обонять и пр., если не возьмете соответствующих недостатков. Укажите, как вы получаете эти возможности (с помощью технологий, сверхъестественных способностей, органов на торсе и пр.). Обычно – но не обязательно – неимеющим головы также не иметь шеи и глаз. 7 очков. 

Нет шеи (No neck):. У вас нет шеи, как следствие – нет локации «шея», вас нельзя задушить, обезглавить или повесить. 5 очков.

Нет жизненно важных органов (No Vitals): У вас нет жизненно важных органов (таких, как сердце или двигатель), по которым могут бить враги, чтобы нанести дополнительный вред. Считайте удары по «жизненным органам» и «паху» как удары по корпусу. 5 очков.
Неживой (Unliving): Ваше тело не состоит из живой плоти. Вы получаете меньше вреда от режущих и проникающих атак, но не так упруги, как Гомогенные; (см. Повреждения Гомогенным, Диффузным и Неживым целям, с. B380). Эта черта больше подходит для материальной нежити и механизмов. 20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>20</base_points>
		<reference>B61</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Innate Attack (Burn)</name>
	<name-loc>Природная атака  (Обжигающее)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d burn</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Corrosion)</name>
	<name-loc>Природная атака  (Разъедающее)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d cor</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Crush)</name>
	<name-loc>Природная атака  (Cr)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d cr</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Cut)</name>
	<name-loc>Природная атака  (Cut)</name-loc>
	<points_per_level>7</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d cut</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-6.3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-4.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-2.1</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">2.1</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">4.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">6.3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Fatigue)</name>
	<name-loc>Природная атака  (Изнуряющее)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d fat</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Huge Pierce)</name>
	<name-loc>Природная атака  (Pi++)</name-loc>
	<points_per_level>8</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d pi++</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-7.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-4.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">4.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">7.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Impaling)</name>
	<name-loc>Природная атака  (Imp)</name-loc>
	<points_per_level>8</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d imp</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-7.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-4.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">4.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">7.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B61</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Large Pierce)</name>
	<name-loc>Природная атака  (Pi+)</name-loc>
	<points_per_level>6</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d pi+</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-5.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-3.6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-1.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">1.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">3.6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">5.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Piercing)</name>
	<name-loc>Природная атака  (Pi)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d pi</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">1.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">4.5</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Small Pierce)</name>
	<name-loc>Природная атака  (Pi-)</name-loc>
	<points_per_level>3</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d pi-</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-2.7</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-1.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-0.9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">0.9</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">1.8</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">2.7</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innate Attack (Toxic)</name>
	<name-loc>Природная атака  (Токсическое)</name-loc>
	<points_per_level>4</points_per_level>
	<levels>1</levels>
	<ranged_weapon>
		<damage level_mod="yes">1d tox</damage>
		<accuracy>3</accuracy>
		<range>10/100</range>
		<rate_of_fire>1</rate_of_fire>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>@Attack Type@</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<modifier version="1" enabled="no">
		<name>-3 к кубам повреждений</name>
		<cost type="points">-3.6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-2 к кубам повреждений</name>
		<cost type="points">-2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>-1 к кубам повреждений</name>
		<cost type="points">-1.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">-1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+1 к кубам повреждений</name>
		<cost type="points">1.2</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+2 к кубам повреждений</name>
		<cost type="points">2.4</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>+3 к кубам повреждений</name>
		<cost type="points">3.6</cost>
		<affects>total</affects>
		<reference>B103</reference>
		<equipment_modifier>
			<damage type="damage value">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier enabled="no">
		<name>1 единица вреда</name>
		<cost type="multiplier">0.25</cost>
		<affects>levels only</affects>
		<equipment_modifier>
			<damage type="override">1</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы имеете природную или встроенную атаку, которая наносит физический вред. Для атак, вреда не наносящих, используется Сковывание (с. B40) или Воздействие (с. B35). Примером может служить дыхание дракона, встроенная лазерная батарея робота, способность божества метать молнии, и т.д. 
По умолчанию атака имеет характеристики 1/2D=10, Мах=100, Асс=3, RoF=1, Rcl=1, но вы можете использовать соостветствующие модификаторы (с. B101-B116) для изменения этих параметров.

Природная атака наносит 1d вреда за уровень. Цена зависит от типа наносимого повреждения.

Обжигающее (Burning): (Электричество, луч, огонь). Может воспламенять. 5 очков/уровень.

Разъедающее (Corrosive): (кислота, дезинтеграция): за каждые 5 единиц наносимого базового вреда DR цели уменьшается на 1, в дополнение к обычному вреду. Живые существа восстанавливают природную броню с той же скоростью, как и НР. 10 очков/уровень.

Тупое (Crushing): (тупое оружие, взрыв). Часто отбрасывает (с. B378) и наносит тупую травму (с. B379). 5 очков/уровень.

Режущее (Cutting): Ваша атака наносит порезы. (острые лезвия и т.п.) Прошедшее через броню повреждение умножается на 1,5. Может отбрасывать и наносит тупую травму. 7 очков/уровень.

Изнуряющее (Fatigue): Ваша атака – несмертельна, но ослабляет жертву (электричество, истощение, и пр.). Уменьшает FP, а не хиты, не воздействует на механизмы. 10 очков/уровень.
Проникающее (Impaling): Атака наносит глубокие раны – урон плоти удваивается. Проникающие атаки могут быть нацелены в глаза и жизненно важные органы, могут наносить тупую травму и пробивать высокотехнологичную гибкую броню. 8 очков/уровень.

Пробивающее. Представлено быстрым тупым снарядом (пуля) или острым, но небольшим (дротик, шип). Может наносить тупую травму, и целиться в жизненно важные органы и глаза. Существует четыре варианта пробивающей атаки:

Малое пробивающее (Small Piercing, Pi-): слабые снаряды (дротики духовых трубок), снаряды, оставляющие небольшую рану (бронебойные пули). Повреждение плоти, прошедшее через броню, уменьшается вдвое. 3 очка/уровень.

Пробивающее (Piercing, Pi): большинство винтовочных и пистолетных пуль. 5 очков/уровень.

Крупное пробивающее (Large Piercing, Pi+): Крупнокалиберные пули и пули со смещенным центром тяжести. Прошедшее через броню повреждение увеличивается на 50%.  6 очков/уровень.

Огромное пробивающее (Huge Piercing, Pi++): Еще более крупные отверстия. Вред плоти удвоен. 8 очков/уровень.
Токсическое (Toxic): Ваша атака повреждает клетки – болезнь, радиация, яды и тп. Обычно не воздействует на механизмы. 4 очка/уровень.
Части кубиков. 
Каждые ±1 к вреду считаются как ±0.3 кубика. Цена округляется вверх. Например, Природная атака, наносящая 1d+2 вреда будет стоить как 1.6 кубика. Если допустить, что она является тупой (5 очков за кубик), то стоить она будет 1.6*5 = 8 очков.
Атаки, наносящие только 1 единицу вреда стоят 0.25 кубика. Они все равно могут быть смертоносными – особенно если сочетаются с модификаторами Нужен носитель (с. B105) или Цикличность (с. B103).
Особые модификаторы.
Великое множество модификаторов для Природной атаки вы можете найти в Модификаторах атаки (с. B102). Используя их, можно создать почти любую форму атаки – лазеры, пулеметы, струи напалма, ветер и пр. – и воспроизвести любую возможность оружия, описанного в книгах GURPS. Изнуряющие и токсические атаки, симулирующие эффект ядов и инфекций, требуют соответствующих модификаторов. Ядовитые когти (с. B42), зубы (с. B91), дротики и т.п. используют Требуется носитель (с. B105). Газы и брызги – Воздействие при вдыхании (с. B108) или Воздействие при контакте (с. B103), совместно с Воздействием на область (с. B102), Конусом (с. B103) или Струей (с. B106). Атаки, зависящие от касания, используют Воздействие при контакте (с. B102), или Воздействие через кровь (с. B102), плюс Аура (с. B102) или Ближний бой (с. B112).
Независимо от наличия других модификаторов, Природная атака считается дальней, если не имеет ограничения Ближняя атака; тогда считается оружием ближнего боя.
Альтернативные атаки (выделенный блок).
если несколько видов атак происходят из одного источника, вы можете определить их как одну атаку, но с различными «боеприпасами». Это позволит вам полностью оплатить только самую дорогую атаку, а остальные вы получите за 20% цены. Однако, вы не сможете эти атаки использовать одновременно, а также, если случится неприятность (сбой, осечка) с одним видом атаки, она также повлияет и на другие.
Описание.
После применения всех нужных модификаторов, необходимо атаку назвать и описать. Описание может быть универсальным и общим (Дыхание дракона) или подробным (9-мм автоматический пистолет, встроенный в левую руку). На усмотрение Мастера, он может разрешить и небоевое применение атаки – например, мощная струя воды может сбивать пламя. Мастер может требовать любых модификаций атаки или описания, если считает, что они не подходят к стилю кампании.</description-loc>
</advantage>
	<advantage version="2">
	<name>Innumerate</name>
	<name-loc>Не воспринимает цифры
</name-loc>
	<base_points>-5</base_points>
	<modifier enabled="no">
		<name>Мир с TL5+</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-1</amount>
		</attribute_bonus>
	</modifier>
	<prereq_list all="yes">
		<skill_prereq has="no">
			<name compare="contains">physics</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="contains">mathematics</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">market analysis</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">finance</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="contains">engineer</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">cryptography</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">astronomy</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">accounting</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">economics</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
		<skill_prereq has="no">
			<name compare="is">computer programming</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B140</reference>
	<description-loc>Вы почти или совсем не понимаете математики. Вы не можете изучить - и использовать по умолчанию - Программирование, Экономику и любые другие умения, которым помогают Математические способности (см. Талант, B89). По сути, вы Некомпетентны (B164) в этих областях. Это влечет за собой множество неудобных последствий: вам нужно производить арифметические действия и считать на пальцах, вы не знаете, правильны ли результаты, подсчитанные компьютером или калькулятором (что по существу делает их бесполезными), и вас легко обсчитать нечестному торговцу (-4 к проверкам на понимание, что вас обманули).
В культурах, незнакомых с цифрами, к которым относится множество культур TL4 и ниже, данный недостаток распространен широко, и мастер не должен включать его в ограничение по недостаткам (если таковое имеется).  В обществах, где ценятся технические или торговые способности, Не воспринимающие цифр люди вероятно подвергнутся вдобавок Социальной дискриминации. Это стоит еще -5 очков и дает -1 при проверках реакции.</description-loc>
</advantage>
	<advantage version="2">
		<name>Insomniac (Mild)</name>
		<name-loc>Бессонница (Слабо)</name-loc>
		<description-loc>У вас бывают периоды, когда вам крайне сложно заснуть. В такие моменты вам необходимо сделать проверку HT-1 один раз за ночь. В случае успеха вы легко засыпаете, и данный период бессонницы заканчивается. При неудаче в эту ночь вы теряете два часа сна (и страдаете от всех обычных последствий; см. Недосыпание, B426) и бессонница продолжается и в следующую ночь. При критической неудаче вы вообще не спите в эту ночь. Цена недостатка в очках зависит от серьезности Бессонницы:


Умеренная. Мастер тайно бросает 3d, чтобы определить число дней между приступами бессонницы. -10 очков.
Серьезная. Мастер бросает 2d-1, чтобы определить число дней между приступами бессонницы. -15 очков.


Независимо от серьезности бессонницы, если вы подвергаетесь длительному стрессу, мастер может потребовать проверки HT. Неудача означает, что бессонница возвращается немедленно.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B140</reference>
		<notes>Мастер скрытно бросает 3d, чтобы узнать количество дней между приступами</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Insomniac (Severe)</name>
		<name-loc>Бессонница (Сильно)</name-loc>
		<description-loc>У вас бывают периоды, когда вам крайне сложно заснуть. В такие моменты вам необходимо сделать проверку HT-1 один раз за ночь. В случае успеха вы легко засыпаете, и данный период бессонницы заканчивается. При неудаче в эту ночь вы теряете два часа сна (и страдаете от всех обычных последствий; см. Недосыпание, B426) и бессонница продолжается и в следующую ночь. При критической неудаче вы вообще не спите в эту ночь. Цена недостатка в очках зависит от серьезности Бессонницы:


Умеренная. Мастер тайно бросает 3d, чтобы определить число дней между приступами бессонницы. -10 очков.
Серьезная. Мастер бросает 2d-1, чтобы определить число дней между приступами бессонницы. -15 очков.


Независимо от серьезности бессонницы, если вы подвергаетесь длительному стрессу, мастер может потребовать проверки HT. Неудача означает, что бессонница возвращается немедленно.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B140</reference>
		<notes>Мастер скрытно бросает 2d-1, чтобы узнать количество дней между приступами</notes>		
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Insubstantiality</name>
	<name-loc>Нематериальность</name-loc>
	<base_points>80</base_points>
	<modifier version="1" enabled="no">
		<name>Воздействие на материальное(Affect Substantial)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До нулевой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Частичное изменение (Partial Change)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Частичное изменение (Partial Change)</name>
		<notes>может материализовывать предметы не выпуская их из рук</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Действует постоянно (Always On)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Обычно действует (Usually On)</name>
		<notes>Материализация стоит 1 FP в секунду</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>No Vertical Move</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>P56</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Noisy</name>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>P56</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P56</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Reversion</name>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>H16</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Touch</name>
		<notes>Always On</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>H16</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Touch</name>
		<notes>Switchable</notes>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<reference>H16</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Difficult Materialization</name>
		<notes>Mutually exclusive with Usually On.</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>H16</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Ectoplasmic Materialization</name>
		<cost type="percentage">-35</cost>
		<affects>total</affects>
		<reference>H16</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Exotic</type>
	<reference>B62</reference>
	<description-loc>Вы можете становиться нематериальным, и проходить сквозь предметы, как будто их нет. Гравитация не действует на вас – вы можете двигаться в любом направлении с полной скоростью и бесшумно. Вы можете воспринимать осязаемый мир, говорить с обычными людьми – но вы не можете воздействовать на материальный мир никаким образом.
Физические и энергетические атаки не могут вам навредить, но вы остаетесь уязвимым к псионике и нематериальным магическим атакам. Ваши физические и энергетические атаки также не вредят материальному миру. Вы можете воздействовать на него с помощью магии и псионики, но получаете -3 на все эти броски.
Несмотря на то, что вы можете проходить сквозь твердые предметы, вы все равно должны дышать. При движении сквозь материальные предметы считайте как движение под водой. Вы не можете материализоваться внутри предмета.
Выбор исходной формы (физическая или материальная) – просто эффект, и не стоит очков. Вы должны выбрать это преимущество, если можете менять состояние.

Эта черта может быть представлена любыми способностями из фольклора и фантастики. Вы должны отработать происхождение и особые черты с Мастером – возможно, ваша вибрация происходит несинхронизировано с реальностью, вы сдвигаетесь в другое измерение, или становитесь духом. Это определит вашу внешность (вы можете быть прозрачным, туманным или полностью нормальным – но вы не можете быть невидимым, если не возьмете соответствующее преимуещство). Ваши физические и энергетические атаки воздействуют на существ, имеющих ту же форму нематериальности, и наоборот. Мастер может определить, что определенные материалы, энергобарьеры и магия непроницаемы для вашей формы нематериальности.

===Особые улучшения.===

Воздействие на материальный мир (Affect Substantial): Если вы имеете способнсоти, которые могут воздействовать на обычный мир, когда вы сами нематериальны – магию, псионику или силы с расширением «Воздействие на материальный мир» (с. B102) - преимущество стоит больше. +100%.

Переноска объектов (Can Carry Objects): Обычно, вы не можете нести ничего. Это расширение позволяет вам носить предметы, включая броню и одежду. Они становятся материальными, когда будут брошены вами. Вы не можете материализовывать эти объекты внутри других объектов или существ. Нагрузка 0: +10%, Нагрузка 1: +20%; Нагрузка 2: +50%; Нагрузка 3: +100%.

Частичное изменение (Partial Change): Вы можете делать нематериальной часть вашего тела, оставляя остальное тело обычным, и наоборот. Так, вы можете протянуть руку сквозь стену и похлопать кого-нибудь по плечу. +20%, или +100%, если вы можете сделать любой предмет в руках материальным, не роняя его. 

===Особые ограничения.===

Всегда включено (Always On): Вы всегда нематериальны, и не можете материализовываться. Если у вас есть это ограничение, вы не получаете -3 на использование магии и псионики. -50%.
Обычно включено (Usually On): Также, как и Всегда включено, но вы можете материализовываться на короткое время, прилагая значительные усилия. Материализация стоит 1FP в секунду. -40%.

===Новые особые ограничения===
Нет полета (No Vertical Move): Вы не можете игнорировать гравитацию. Позволено движение только по горизонтальным поверхностям и по склонам, не требующим броска Лазания. Вы по-прежнему ничего не весите, не оставляете следов и можете ходить по поверхностям, обычно не выдерживающим вес тела – например, по воде. -10%.
Шум (Noisy): Вы издаете звуки, как обычный человек – шаги, дыхание и т.д. – и вас не сложнее услышать, чем обычного человека. -5%.
Проекция (Projection): вы не становитесь совсем нематериальным. Вместо этого, ваше физическое тело падает без сознания, а «дух» выходит из него. Как и в случае использования немодифицированной Нематериальности, ваша проекция видима, и присутствует в данном месте, что позволяет влиять на вас любыми способами, которыми можно повлиять на нематериальные объекты… а ваше тело остается в материальном мире, уязвимое для материальных атак; см. Проекция (с.44). Вы все равно не можете воздействовать на мир, если у вас нет Воздействия на материальное. -50%. 
</description-loc>
</advantage>
	<advantage version="2">
	<name>Intolerance (@Class, Ethnicity, Nationality, Religion, Sex, or Species@)</name>
	<name-loc>Нетерпимость (@Класс, Раса, Национальность, Религия, Пол или Вид@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Встречаются: Редко</name>
		<cost type="points">-1</cost>
		<affects>total</affects>
		<reference>B140</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Встречаются: Иногда</name>
		<cost type="points">-2</cost>
		<affects>total</affects>
		<reference>B140</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Встречаются: Часто</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B140</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ко всем непохожим на вас</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B140</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B140</reference>
	<description-loc>Вы не любите или не доверяете кому-либо из людей (или всем людям), которые отличаются от вас. Вы можете делить окружающих по классовому, этническому, национальному, религиозному, половому или видовому признаку. Те, к кому вы Нетерпимы, относятся к вам с пенальти от -1 до -5 (по решению мастера). Цена в очках зависит от масштабов вашей Нетерпимости.
Если вы полностью нетерпимы, то реагируете с -3 на всех, кто не принадлежит к вашему классу, этносу, национальности, религии или виду (выберите нужное). При "Хорошей" реакции вы терпите и относитесь к представителю этой группы предельно вежливо (но вы жестки и холодны по отношению к нему). При "Нейтральной" реакции вы все равно его терпите, но явно выказываете словами и действиями, что не желаете находиться рядом с ним, и считаете его присутствие недостойным или оскорбительным. При худшей реакции вы нападаете или отказываетесь иметь дело с жертвой своей Нетерпимости. Такого рода полная Нетерпимость стоит -10 очков.
Нетерпимость, направленная против одного конкретного класса, этноса, национальности, религии, пола или вида стоит от -5 очков, если его представители встречаются часто, до -1 очка (неприятная причуда), если они встречаются редко.</description-loc>
</advantage>
	<advantage version="2">
		<name>Intuition</name>
		<name-loc>Интуиция</name-loc>
		<description-loc>Обычно ваши догадки бывают верны. Когда Вы сталкиваетесь с несколькими вариантами, и нет логического способа выбрать правильный, Вы можете использовать свою интуицию следующим образом: мастер добавляет ваш IQ к числу "правильных" вариантов, вычитает число возможных "неправильных" вариантов, и делает проверку против полученного значения. Успешный бросок означает, что он подсказывает Вам хороший вариант; при броске 3 или 4, он сообщает Вам наилучший вариант. Неудачный бросок означает, что вы не получаете никакой информации. Критическая неудача означает, что мастер сообщает неудачный вариант. Мастер может модифицировать эту систему применительно к другой ситуации, в которой интуиция может помочь. Допускается только один бросок на один вопрос. 
Также обратите внимание: мастер не должен позволять использовать это преимущество для быстрых решений, иначе озаренный интуицией детектив пройдет в комнату, наденет наручники на виновных, и завершит расследование. Наиболее правильно будет, если интуиция укажет детективу направление поиска улик. Мастер, считающий, что не сможет контролировать эту способность, не должен позволять ее использовать.

===Новое особое улучшение===
Вдохновение (Inspired): Ваш дар очень точен, и при любом успехе броска вы узнаете наилучший вариант из возможных. Худший возможный результат – провал, и даже критический провал – просто отсутствие информации. Мастер никогда не предлагает плохого варианта. +100%.
</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Inspired</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P56</reference>
		</modifier>
		<reference>B63</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Invertebrate</name>
		<name-loc>Беспозвоночный
</name-loc>
		<description-loc>У вас нет позвоночника, внешнего скелета или иной природной поддержки для тела. В этом случае ваш Базовый подъем используется для толкания, а вес, который вы способны поднять, нести или тянуть, равен лишь 1/4 вашего BL. Однако данная особенность приносит небольшую пользу: вы способны пролезть в куда меньший проем, чем, казалось бы, позволяет ваш размер!
Обратите внимание, что данная особенность несколько отличается от биологического термина "беспозвоночное".</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Invisibility</name>
	<name-loc>Невидимость</name-loc>
	<base_points>40</base_points>
	<modifier version="1" enabled="no">
		<name>Воздействие на механизмы (Affect Machines)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До нулевой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска объектов (Can Carry Objects)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Расширение (Extended)</name>
		<notes>@тип зрения@</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Переключаемость (Switchable)</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Обычно действует (Usually On)</name>
		<notes>Turning visible costs 1 FP per second</notes>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только машины (Machines Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только материальное (Substantial Only)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Видимое отражение (Visible Reflection)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Видимая тень (Visible Shadow)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B63</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Fringe</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>P56</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Exotic</type>
	<reference>B63</reference>
	<description-loc>Вы невидимы. В отличие от большинства преимуществ, это всегда считается включенным, если вы не возьмете расширение. Вы по-прежнему издаете звуки, оставляете следы и имеете запах, и – по умолчанию – все, что вы несете – видимо. Если вы не несете ничего, вы получаете +9 на броски Скрытности в любой ситуации, где имеет значение зрительное восприятие.
Использующие паранормальное удаленное зрение (хрустальные шары, Дальновидение и т.д.)не могут видеть вас, если вы невидимы для их обычного зрения. Устройства с подобными возможностями могут вас обнаружить, если имеют способности на обнаружение врагов, жизни и т.д. невизуальным путем.

Невидимость работает только против одного вида обнаружения. Типы включают что-нибудь вроде Электромагнитного зрения (включает обычное зрение, инфразрение, ультразрение и радары), сонары, магнитные поля и все остальное, что пожелает мастер. Если вы невидимы для электромагнитного зрения – то вы не отбрасываете теней и не отражаетесь в зеркалах.

===Особые улучшения.===

Воздействие на механизмы (Affect Machines): Вы невидимы даже для машин. Вас нельзя сфотографировать, и вы не показываетесь на камерах и детекторах. Устройства вроде напольных плит, работающих от давления, могут вас обнаружить. Оружие, использующее электронные системы наведения, не дают бонусов против вас. +50%.

Переноска предметов (Can Carry Objects): все, что вы несете, становится невидимым. Предметы снова станут видимыми, когда вы их бросите. Нет нагрузки +10%, Легкая нагрузка: +20%, Средняя нагрузка: +50%, тяжелая нагрузка: +100%.

Расширенная (Extended): невидимость работает более чем для одного типа зрения. +20% за каждый дополнительный вид обнаружения.

Выключаемое (Switchable): Вы обычно видимы, но можете становиться невидимым по желанию. +10%. (+10%):

Обычно включенное (Usually On): Вы обычно невидимы, но можете становиться видимым, прилагая значительные усилия. Включение видимости стоит 1 FP в секунду. +5%.

===Особые ограничения.===

Только для машин (Machines Only): Вы невидимы только для машин. Живые существа могут видеть вас как обычно. -50%.

Только материальный мир (Substantial Only): Ваша невидимость скрывает вас только в материальном мире. Нематериальные существа могут видеть вас нормально. -10%.

Видимое отражение (Visible Reflection): Вы отражаетесь в зеркалах, даже когда невидимы. -10%.
Видимая тень (Visible Shadow): Вы отбрасываете тень, даже когда невидимы. -10%.

===Новое особое ограничение===
Контур (Fringe): Ваша способность действует нормально, если вы стоите спокойно, но оставляет слабые контуры при движении. Во время движения вас можно обнаружить броском Зрения-6, а в бою по вам целятся лишь с -6. -10%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Jealousy</name>
		<name-loc>Зависть</name-loc>
		<description-loc>Вы плохо относитесь к тем, кто умнее, привлекательнее или состоятельнее вас! Вы выступаете против любого плана, предложенного своим "соперником", и ненавидите, если кто-то другой оказывается в центре внимания. (Зависть неплохо сочетается с Манией величия). Если NPC завистлив, то мастеру следует использовать пенальти от -2 до -4 к реакции на тех, кому он завидует.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Jumper (@World/Time/Spirit@)</name>
	<name-loc>Прыгун (@Между мирами/временем@)</name-loc>
	<base_points>100</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До нулевой нагрузкиe</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До легкой нагрузки&lt;</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Новые миры (New Worlds)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Общий прыжок (Omni-Jump)</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Отслеживание (Tracking)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Тоннель (Tunnel)</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Прыжок с телепортацией (Warp Jump)</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Без сопровождения (Cannot Escort)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невозможность следования(Cannot Follow)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Дрейф (Drift)</name>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Ограниченный прыжок (Limited Jump)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Максимальная дальность (Maximum Range)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B64</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Голый (Naked)</name>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Оглушение (Stunning)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Interplanar</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P57</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Interplanar Only</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P57</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Reliable</name>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>P57</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Limited Access</name>
		<notes>@Миры@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P57</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Не может воздействовать</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Может воздействовать</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Физическая</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Special Movement</name>
		<notes>@маневр@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Special Portal</name>
		<notes>@портал@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B64</reference>
	<description-loc>Вы можете перемещаться через время или в параллельные миры по желанию. Определите, являетесь ли вы Прыгуном по времени или Прыгуном по мирам. Если вы желаете быть и тем и другим, покупайте преимущество два раза.
Для инициализации прыжка, вы должны четко представить ваше место назначения, концентрироваться в течение 10 секунд и сделать бросок IQ. Вы можете ускорить прыжок, но получаете -1 штраф за каждую упущенную секунду концентрации (-10 без подготовки). Независимо от IQ, бросок 14 или больше – всегда провал. При успешном броске вы успешно перемещаетесь, при провале – остаетесь на месте, и получаете штраф -5 при повторных попытках в течение 10 минут. При критическом провале вы прибываете в неправильное место.
Вы появляетесь в новом мире как можно ближе к тому месту, которое вы покинули. При прыжках через время – вы появляетесь на том же месте, но в другом времени. При прыжках через миры, это значит то же место в том же времени, но в параллельном мире. Если в радиусе 100 ярдов нет безопасного места (например, если вы прыгаете с самолета, а в точке назначения самолета нет), прыжок не происходит, и вы точно знаете почему. Это не защищает вас от других типов опасности (радиации, обстрела, диких животных). Если у вас есть Чувство опасности, мастер может бросить IQ, чтобы попытаться предупредить вас.
Использование способности всегда стоит 1 FP, независимо от успешности. Особенно удаленные времена или миры будут стоить больше, возможно до 10 FP – на усмотрение мастера. Если вы механизм, то способность вам не стоит FP, но если у вас есть пассажиры, каждый из них оплачивает прыжок. 
В качестве примера, как это преимущество может работать на примере одного определенного мира, см. Прыгуны по мирам, с. B544).
Перенос вещей. 
Вы можете перемещать нагрузку до Базовой, плюс любой багаж (Payload). Увеличение этого веса может быть достигнуто покупкой Дополнительной нагрузки (ниже).
Если несколько прыгунов одного типа находятся в физическом контакте, при прыжке одного другие могут «поймать поток», если пожелают (даже если первый не желал этого), и переместиться в то же место. Бросок делает только инициатор прыжка.
Если вы прыгун по мирам, «поймать поток» - единственный для вас способ переместиться в новый для вас мир. Побывав в нем один раз, вы можете запомнить его «волны» концентрацией и покупкой изучения этого мира как навык IQ/Е. это занимает по 1 часу за каждое затрачиваемое очко персонажа. Этот навык затем может использоваться вместо броска IQ при последующих перемещениях в этот мир. Вы не обязаны запоминать мир, но если вы этого не сделаете, попытка вернуться будет бросаться с IQ-3.
Прыгуны по времени не имеют подобных запретов.

Вы можете улучшить способность практикой, затрачивая очки на добавление улучшений и снятие ограничений. Мастер, нежелающий, чтобы игроки постоянно шатались из мира в мир, может назначить невыкупаемое ограничение (например, Ограниченное использование).

===Особые улучшения.===

Дополнительная нагрузка (Extra Carrying Capacity): Вы можете нести больше, чем ваша базовая нагрузка. Если ваша сила достаточна, вы можете перенести одну персону с собой. Легкая нагрузка стоит +10%, Средняя +20%, Тяжелая +30%, Сверхтяжелая +50%.

Новые миры (New Worlds) (+50%): Это улучшение доступно только для Прыгунов по мирам. Вы можете нацеливаться на миры, в которых никогда не были. В этом случае бросок IQ будет всегда идти с -3 или хуже (на усмотрение мастера). Разумеется, всегда есть возможность того, что цель не существует – в этом случае попытка автоматически проваливается, но мастер не говорит почему. Затраты FP удвоены при прыжке в новый мир. +50%.

Общий прыжок (Omni-Jump): доступно только если вы имеете способность прыгать и по мирам, и через время. Вы должны применять это улучшение к обоим преимуществам. Это позволит вам прыгать через миры и времена одним броском IQ. +10%.

Слежка (Tracking): Вы можете прыгнуть в домашний мир или время любого рукотворного предмета, который вы можете коснуться. Прыгуны по времени прибывают во время сразу после создания артефакта, прыгуны по мирам – в текущую дату. Любая подобная попытка идет с дополнительным штрафом -2, и каждый прыгун имеет только одну попытку на каждый артефакт. +20%.

Туннель (Tunnel) (+40%): Вы создаете портал примерно вашего размера. В этот портал может последовать кто угодно, даже если он не может прыгать. Портал остается на 3d секунд, что может быть хорошо или плохо (враги тоже могут пройти за вами)! +40%.

Телепортационный прыжок (Warp Jump): Доступно только если вы имеете преимущество Телепортация. Вы должны купить это улучшение для обоих преимуществ. При прыжке вы можете одновременно использовать Телепортацию, и попасть в желаемое место. Необходимы два броска – по одному на каждую способность, и возможно, что один из них (или оба!) провалятся. +10%.

===Особые ограничения.===

Невозможность эскорта (Cannot Escort): Доступно только для прыгунов по мирам. Другие прыгуны не могут «поймать поток», даже если вы желаете взять их с собой. -10%.

Невозможность следования (Cannot Follow): Только для прыгунов по мирам. Вы не можете «поймать поток» другого прыгуна. -20%.

Смещение (Drift): Вы не можете точно прицелиться. Вы не переместитесь в небо или под землю, но можете оказаться в любом месте в радиусе 10 миль от желаемого места. Чем лучше вы сделали бросок, тем ближе вы окажестеь, но мастер всегда определяет сам. -15%.

Ограниченный прыжок (Limited Jump): Ваш прыжок ограничен определенным количеством времени или изменений в мирах за один прыжок. Для дальнейшего перемещения вы должны прыгать снова. Мастер определяет сам стоимость этого ограничения. -10%.

Максимальная дистанция (Maximum Range): Вы можете прыгать только на определенное время или изменений, независимо от количества прыжков. Мастер устанавливает ценность сам.

Обнаженный (Naked): Вы не можете нести ничего, и всегда прибываете обнаженным. -30%.
Оглушение (Stun): После прыжка вы всегда оказываетесь ментально оглушены. -10%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Killjoy</name>
		<name-loc>Не испытывает удовольствий
</name-loc>
		<description-loc>Часть вашего мозга, отвечающая за удовольствия, уничтожена или отсутствует. Вы не способны оценить вкус хорошей еды, радость секса, жестокую красоту битвы и т.д. Вы даже не способны вспомнить, что это были за удовольствия! Вы способны "повторять нужные движения", но получаете -3 ко всем проверкам умений Пирушки, Знаток, Эротическое искусство и Азартные игры. Окружающие реагируют на вас с пенальти от -1 до -3 в любой ситуации, где недостаток радости с вашей стороны становится очевидным (это решает мастер). Отрицательная реакция означает насмешки в культурном обществе, разрыв с любовником и т.д. - но не насилие.
Некоторые высокотехнологичные общества могут применять хирургию, чтобы приводить в такое состояние с целью наказания! Если так, то вы не будете стремиться к мести... потому что она не доставит вам удовольствия.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B140</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">carousing</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">connoisseur</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">erotic art</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">gambling</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Kleptomania</name>
		<name-loc>Клептомания
</name-loc>
		<description-loc>Вы вынуждены красть - не обязательно ценности, но всякие вещи, кража которых сойдет вам с рук. Сделайте проверку на самоконтроль, если предоставляется возможность украсть, с пенальти до -3, если эта вещь вам особенно интересна (не обязательно ценна, если только вы не бедны или не Жадны). В случае неудачи вы обязаны попытаться ее украсть. Вы можете хранить украденные вещи или продавать их, но не можете их возвращать или выбрасывать.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B141</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Klutz</name>
		<name-loc>Неуклюжий</name-loc>
		<description-loc>Вы обладаете удивительным свойством притягивать серьезные физические промахи. У вас не обязательно низкая DX (ваш показатель DX может достигать 13, что не помешает взять данную особенность), но вы более неуклюжи, чем позволяет предположить ваша ловкость. Данный недостаток бывает двух уровней:


Недотепа: Сделайте проверку DX, чтобы прожить день, ни разу не упав, не уронив книги и не опрокинув полки с чем-нибудь хрупким. Это редко представляет опасность для жизни, но неудобно и часто ведет к затратам. Мастеру следует подойти творчески к выдумыванию небольших досадных происшествий. Вам нужно особенно избегать лабораторий, взрывчатых веществ, лавок, где торгуют фарфором и т.д. -5 очков.
Полный недотепа: То же, что и выше, но в дополнение, любой провал при проверке DX или умения, зависящего от DX, считается для вас критическим провалом! -15 очков.


Данная особенность может показаться глупой, а может и нет. Большинство реальных роботов TL7-8 обладают данным недостатком!</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<modifier version="1" enabled="no">
			<name>Крайне неуклюжий (Total)</name>
			<cost type="points">-10</cost>
			<affects>total</affects>
			<reference>B141</reference>
		</modifier>
		<reference>B141</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="dx" compare="at most">13</attribute_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Lame (Crippled Legs)</name>
		<name-loc>Хромой (Сломанные ноги)</name-loc>
		<description-loc>Данный недостаток предполагает, что вы принадлежите к расе, обладающей ногами. Если у всей расы ноги отсутствуют, см. недостаток Безногий (B145).
У вас в определенной степени снижена мобильность:


Сломанные ноги: У вас есть все ноги, но часть из них повреждена. Для человека это означает, что одна нога нездорова. Вы получаете -3 к любому умению, для которого требуется использовать ноги - это включает все умения для Оружия ближнего боя и рукопашного боя (но не для оружия дальнего боя). Вы обязаны снизить свое Передвижение до половины от Базовой скорости (округлять вниз), но получаете за это все положенные очки (см. Базовое передвижение, B17). -10 очков.
Отсутствие ног: У вас отсутствует часть ног, но не ноги целиком. Для человека это означает, что у вас нет одной ноги. Вы получаете -6 к любому умению, для которого требуется использовать ноги. При использовании костылей или протеза вы можете стоять и медленно ходить. Вы обязаны снизить Базовое передвижение до 2, но получаете за это все положенные очки. Вы можете бить ногами, но к обычному пенальти -2 к ударам ногой добавляется еще -6 за данный недостаток, так что проверка будет производиться против DX-8! Без костылей или протеза вы не можете стоять, ходить или наносить удары ногой. -20 очков.
Безногий: У вас нет ни одной ноги, независимо от того, сколько их должно быть. Вы получаете -6 к любому умению, для которого требуется использовать ноги, и совсем не способны стоять, наносить удары ногами или ходить. Вы обязаны снизить Базовое передвижение до 0, но получаете за это все положенные очки. -30 очков.
Паралич ног: У вас есть все ноги, но они парализованы. Последствия и цена этого те же, что и для варианта Безногий. Но в отличие от Безного персонажа, вас могут ударить по ногам, и это причинит повреждения. Это уравновешивается тем фактом, что нет ничего невероятного, если вы однажды вновь сможете ходить (для Безного персонажа это невозможно). -30 очков.


Техническая помощь
Кресло-каталка или тележка, передвигаемые руками, дают Передвижение по земле, равное 1/4 вашей ST (округляется вниз), но они не способны проходить в узкие двери, преодолевать лестницы и крутые подъемы, въезжать в большинство видов транспорта и т.д.
Если вы используете протезы, которые отменяют действие данного недостатка, будучи надеты, то примените ограничение Смягчитель (B112) к недостатку Хромой и сниженному Базовому передвижению. Если хирургия или высокотехнологичная замена полностью избавляет вас от данного недостатка, вы обязаны вернуть очки, полученные за недостаток Хромой и сниженное Базовое передвижение.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B141</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Lame (Missing Legs)</name>
	<name-loc>Хромой
 (Отсутствие части ног)</name-loc>
	<base_points>-20</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B141</reference>
	<description-loc>Данный недостаток предполагает, что вы принадлежите к расе, обладающей ногами. Если у всей расы ноги отсутствуют, см. недостаток Безногий (B145).
У вас в определенной степени снижена мобильность:


Сломанные ноги: У вас есть все ноги, но часть из них повреждена. Для человека это означает, что одна нога нездорова. Вы получаете -3 к любому умению, для которого требуется использовать ноги - это включает все умения для Оружия ближнего боя и рукопашного боя (но не для оружия дальнего боя). Вы обязаны снизить свое Передвижение до половины от Базовой скорости (округлять вниз), но получаете за это все положенные очки (см. Базовое передвижение, B17). -10 очков.
Отсутствие ног: У вас отсутствует часть ног, но не ноги целиком. Для человека это означает, что у вас нет одной ноги. Вы получаете -6 к любому умению, для которого требуется использовать ноги. При использовании костылей или протеза вы можете стоять и медленно ходить. Вы обязаны снизить Базовое передвижение до 2, но получаете за это все положенные очки. Вы можете бить ногами, но к обычному пенальти -2 к ударам ногой добавляется еще -6 за данный недостаток, так что проверка будет производиться против DX-8! Без костылей или протеза вы не можете стоять, ходить или наносить удары ногой. -20 очков.
Безногий: У вас нет ни одной ноги, независимо от того, сколько их должно быть. Вы получаете -6 к любому умению, для которого требуется использовать ноги, и совсем не способны стоять, наносить удары ногами или ходить. Вы обязаны снизить Базовое передвижение до 0, но получаете за это все положенные очки. -30 очков.
Паралич ног: У вас есть все ноги, но они парализованы. Последствия и цена этого те же, что и для варианта Безногий. Но в отличие от Безного персонажа, вас могут ударить по ногам, и это причинит повреждения. Это уравновешивается тем фактом, что нет ничего невероятного, если вы однажды вновь сможете ходить (для Безного персонажа это невозможно). -30 очков.


Техническая помощь
Кресло-каталка или тележка, передвигаемые руками, дают Передвижение по земле, равное 1/4 вашей ST (округляется вниз), но они не способны проходить в узкие двери, преодолевать лестницы и крутые подъемы, въезжать в большинство видов транспорта и т.д.
Если вы используете протезы, которые отменяют действие данного недостатка, будучи надеты, то примените ограничение Смягчитель (B112) к недостатку Хромой и сниженному Базовому передвижению. Если хирургия или высокотехнологичная замена полностью избавляет вас от данного недостатка, вы обязаны вернуть очки, полученные за недостаток Хромой и сниженное Базовое передвижение.</description-loc>
</advantage>
	<advantage version="2">
	<name>Lame (Legless)</name>
	<name-loc>Хромой
 (Безногий)</name-loc>
	<base_points>-30</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B141</reference>
	<description-loc>Данный недостаток предполагает, что вы принадлежите к расе, обладающей ногами. Если у всей расы ноги отсутствуют, см. недостаток Безногий (B145).
У вас в определенной степени снижена мобильность:


Сломанные ноги: У вас есть все ноги, но часть из них повреждена. Для человека это означает, что одна нога нездорова. Вы получаете -3 к любому умению, для которого требуется использовать ноги - это включает все умения для Оружия ближнего боя и рукопашного боя (но не для оружия дальнего боя). Вы обязаны снизить свое Передвижение до половины от Базовой скорости (округлять вниз), но получаете за это все положенные очки (см. Базовое передвижение, B17). -10 очков.
Отсутствие ног: У вас отсутствует часть ног, но не ноги целиком. Для человека это означает, что у вас нет одной ноги. Вы получаете -6 к любому умению, для которого требуется использовать ноги. При использовании костылей или протеза вы можете стоять и медленно ходить. Вы обязаны снизить Базовое передвижение до 2, но получаете за это все положенные очки. Вы можете бить ногами, но к обычному пенальти -2 к ударам ногой добавляется еще -6 за данный недостаток, так что проверка будет производиться против DX-8! Без костылей или протеза вы не можете стоять, ходить или наносить удары ногой. -20 очков.
Безногий: У вас нет ни одной ноги, независимо от того, сколько их должно быть. Вы получаете -6 к любому умению, для которого требуется использовать ноги, и совсем не способны стоять, наносить удары ногами или ходить. Вы обязаны снизить Базовое передвижение до 0, но получаете за это все положенные очки. -30 очков.
Паралич ног: У вас есть все ноги, но они парализованы. Последствия и цена этого те же, что и для варианта Безногий. Но в отличие от Безного персонажа, вас могут ударить по ногам, и это причинит повреждения. Это уравновешивается тем фактом, что нет ничего невероятного, если вы однажды вновь сможете ходить (для Безного персонажа это невозможно). -30 очков.


Техническая помощь
Кресло-каталка или тележка, передвигаемые руками, дают Передвижение по земле, равное 1/4 вашей ST (округляется вниз), но они не способны проходить в узкие двери, преодолевать лестницы и крутые подъемы, въезжать в большинство видов транспорта и т.д.
Если вы используете протезы, которые отменяют действие данного недостатка, будучи надеты, то примените ограничение Смягчитель (B112) к недостатку Хромой и сниженному Базовому передвижению. Если хирургия или высокотехнологичная замена полностью избавляет вас от данного недостатка, вы обязаны вернуть очки, полученные за недостаток Хромой и сниженное Базовое передвижение.</description-loc>
</advantage>
	<advantage version="2">
		<name>Lame (Paraplegic)</name>
		<name-loc>Хромой (Паралич ног)</name-loc>
		<description-loc>Данный недостаток предполагает, что вы принадлежите к расе, обладающей ногами. Если у всей расы ноги отсутствуют, см. недостаток Безногий (B145).
У вас в определенной степени снижена мобильность:


Сломанные ноги: У вас есть все ноги, но часть из них повреждена. Для человека это означает, что одна нога нездорова. Вы получаете -3 к любому умению, для которого требуется использовать ноги - это включает все умения для Оружия ближнего боя и рукопашного боя (но не для оружия дальнего боя). Вы обязаны снизить свое Передвижение до половины от Базовой скорости (округлять вниз), но получаете за это все положенные очки (см. Базовое передвижение, B17). -10 очков.
Отсутствие ног: У вас отсутствует часть ног, но не ноги целиком. Для человека это означает, что у вас нет одной ноги. Вы получаете -6 к любому умению, для которого требуется использовать ноги. При использовании костылей или протеза вы можете стоять и медленно ходить. Вы обязаны снизить Базовое передвижение до 2, но получаете за это все положенные очки. Вы можете бить ногами, но к обычному пенальти -2 к ударам ногой добавляется еще -6 за данный недостаток, так что проверка будет производиться против DX-8! Без костылей или протеза вы не можете стоять, ходить или наносить удары ногой. -20 очков.
Безногий: У вас нет ни одной ноги, независимо от того, сколько их должно быть. Вы получаете -6 к любому умению, для которого требуется использовать ноги, и совсем не способны стоять, наносить удары ногами или ходить. Вы обязаны снизить Базовое передвижение до 0, но получаете за это все положенные очки. -30 очков.
Паралич ног: У вас есть все ноги, но они парализованы. Последствия и цена этого те же, что и для варианта Безногий. Но в отличие от Безного персонажа, вас могут ударить по ногам, и это причинит повреждения. Это уравновешивается тем фактом, что нет ничего невероятного, если вы однажды вновь сможете ходить (для Безного персонажа это невозможно). -30 очков.


Техническая помощь
Кресло-каталка или тележка, передвигаемые руками, дают Передвижение по земле, равное 1/4 вашей ST (округляется вниз), но они не способны проходить в узкие двери, преодолевать лестницы и крутые подъемы, въезжать в большинство видов транспорта и т.д.
Если вы используете протезы, которые отменяют действие данного недостатка, будучи надеты, то примените ограничение Смягчитель (B112) к недостатку Хромой и сниженному Базовому передвижению. Если хирургия или высокотехнологичная замена полностью избавляет вас от данного недостатка, вы обязаны вернуть очки, полученные за недостаток Хромой и сниженное Базовое передвижение.</description-loc>
		<type>Physical</type>
		<base_points>-30</base_points>
		<reference>B141</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Language Talent</name>
		<name-loc>Талант к языкам</name-loc>
		<description-loc>Вы быстро учитесь языкам. Если вы изучаете язык на любом уровне выше Незнания, вы автоматически получаете дополнительный уровень знания этого языка бесплатно. Так, вы можете приобрести язык на уровне Акцент всего за 2 очка, или стать носителем языка за 4 очка вместо 6.</description-loc>
		<type>Mental</type>
		<base_points>10</base_points>
		<reference>B65</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Language: @Language@</name>
	<name-loc>Язык @язык@</name-loc>
	<modifier version="1" enabled="no">
		<name>Родной Язык (Native)</name>
		<cost type="points">-6</cost>
		<affects>total</affects>
		<reference>B23</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Отсутствует (None)</notes>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Ломаный (Broken)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Отсутствует (None)</notes>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Ломаный (Broken)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Language</category>
	</categories>
	<type>Mental</type>
	<reference>B24</reference>
	<description-loc>
		GURPS предполагает, что большинство персонажей способно читать и писать на «родном» языке. Эта способность не стоит очков, но вы должны отметить родной язык в листе персонажа; например, «Русский (Родной) [0]». Оставшаяся часть данного раздела важна лишь в том случае, если вы умеете изъясняться более чем на одном языке (это преимущество) или испытываете трудности со своим родным языком (это недостаток). 

Уровни понимания 
Сколько очков будет стоить изучение дополнительного языка, зависит от вашего «уровня понимания»: того, насколько хорошо вы владеете данным языком в целом. Существует четыре уровня понимания языков:
* Отсутствует (None): вы абсолютно не владеете данным языком. Если вы не тратите очков на неродной язык, то именно этот уровень и подразумевается - не нужно записывать все языки, которых вы не знаете! 0 очков/язык. 
* Ломаный (Broken): вы можете распознать важные слова и понимать простые предложения, если их произносят медленно. Вы получаете -3 при использовании умений, которые зависят от языка, таких как Заговаривание зубов, Публичное выступление, Исследования, Скорочтение, Обучение и Письмо. Этот штраф удваивается до -6 при использовании творческих умений, основанных на красоте языка (Поэзия, Пение и т.д.). В стрессовых ситуациях - например, в бою или когда требуются броски реакции - вы должны сделать бросок IQ, чтобы понять этот язык или быть понятым, когда выражаетесь на нем. При провале понять друг друга не удается, но вы можете попытаться еще раз. Критический провал означает, что информация понята неправильно! При быстром разговоре, плохой связи и т.д. эти броски делаются со штрафом от -2 до -8! Носители языка, которые и так не любят иностранцев (см. Нетерпимость, B140) реагируют на вас с дополнительным штрафом -1. 2 очка/язык.
* Акцент (Accented): вы можете свободно общаться даже в стрессовых ситуациях. Однако ваша речь и письмо весьма характерны, и по ним легко понять, что этот язык для вас не родной. Вы получаете -1 при использовании умений, зависящих от языка, удвойте штраф до -2 для творческих умений. Вы не получаете штрафа к реакции от носителей языка, но вы не сумеете сойти за местного (а это может оказаться огромной проблемой для потенциальных шпионов!). 4 очка/язык. 
* Родной (Native): вы полностью владеете языком и стилем общения. Вы можете думать на этом языке. Вы не получаете штраф при использовании умений, зависящих от языка. Вы бесплатно начинаете с одним из языков на этом уровне. Если вы покупаете понимание иностранного языка на уровне Родного, то можете сойти за носителя языка. 6 очков/язык

Выдающееся знание и незнание
Великие ораторы, писатели и прочие Мастера слова должны начинать с Родным пониманием языка, а затем бать умения вроде Публичного выступления и Письма на очень высоких уровнях.
Плохо образованным людям, которые с трудом изъясняются даже на родном языке, разницу между уровнем понимания языка и Родным уровнем следует взять в качестве недостатка. Например, некто владеющий родным языком на уровне Ломаного, получает недостаток на -4 очка.

Разговорный и письменный язык
Указанные выше цены предполагают, что вы одинаково хорошо разговариваете и пишете/читаете на языке. Если ваши знания письменного и разговорного язык отличаются, выберите уровни понимания отдельно для письменного и разговорного языка, заплатив половину стоимости за каждый. Например, если вы научились писать по-французски по учебнику, то можете взять «Французский: Разговорный (Отсутствует)/Письменный (Родной) [3]».

Грамотность 
Ваш уровень понимания письменного языка определяет степень грамотности в данном языке:
* Грамотность - это способность понимать язык на уровне с «Акцентом» и выше, но для письменной речи. Вы можете читать и писать с полной скоростью. 
* Полу-грамотность - это понимание письменной речи на «ломаном» уровне и ниже. Полуграмотному человеку понадобилось бы три минуты, чтобы прочитать это предложение, а затем бросок IQ, чтобы понять его значение! Многие слова всегда оказываются непонятны полуграмотному человеку, включая и ряд слов из данного параграфа. 
* Неграмотность - это «отсутствующее» понимание письменной речи. В этом случае вы и правда не можете читать! Вывески, свитки, книги и названия на карте (хотя и не сами карты) вам абсолютно непонятны. Игрок может передать тайную записку Мастеру (и наоборот), но персонаж ничего прочитать не может.

При TL4 и ниже вполне возможно прожить всю жизнь и ни разу не испытать потребности в чтении. В подобных мирах неграмотность или полу-грамотность являются нормой. Большинство людей владеют разговорным языком на уровне Родного, а письменную речь понимают на Ломаном уровне или вовсе не понимают. 
Неграмотность в родном языке - Разговорный (Родной)/Письменный (Отсутствует) - это недостаток стоимостью -3 очка. Полу-грамотность - Разговорный (Родной)/Письменный (Ломаный) - стоит -2 очка. Мастер не должен учитывать эти очки при расчете ограничения по недостаткам, если неграмотность является нормой для вашего игрового мира.
		<div>
			<br>
		</div>
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Language: @Language@</name>
	<name-loc>Язык @язык@</name-loc>
	<notes>Когда есть языковой талант (Language Talent)</notes>
	<modifier version="1" enabled="no">
		<name>Родной язык (Native)</name>
		<cost type="points">-4</cost>
		<affects>total</affects>
		<reference>B23</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Разговорный (Spoken)</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Письменный (Written)</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="yes">
			<name compare="is">Language Talent</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
		<category>Language</category>
	</categories>
	<type>Mental</type>
	<reference>B24</reference>
	<description-loc>
		GURPS предполагает, что большинство персонажей способно читать и писать на «родном» языке. Эта способность не стоит очков, но вы должны отметить родной язык в листе персонажа; например, «Русский (Родной) [0]». Оставшаяся часть данного раздела важна лишь в том случае, если вы умеете изъясняться более чем на одном языке (это преимущество) или испытываете трудности со своим родным языком (это недостаток). 

Уровни понимания 
Сколько очков будет стоить изучение дополнительного языка, зависит от вашего «уровня понимания»: того, насколько хорошо вы владеете данным языком в целом. Существует четыре уровня понимания языков:
* Отсутствует (None): вы абсолютно не владеете данным языком. Если вы не тратите очков на неродной язык, то именно этот уровень и подразумевается - не нужно записывать все языки, которых вы не знаете! 0 очков/язык. 
* Ломаный (Broken): вы можете распознать важные слова и понимать простые предложения, если их произносят медленно. Вы получаете -3 при использовании умений, которые зависят от языка, таких как Заговаривание зубов, Публичное выступление, Исследования, Скорочтение, Обучение и Письмо. Этот штраф удваивается до -6 при использовании творческих умений, основанных на красоте языка (Поэзия, Пение и т.д.). В стрессовых ситуациях - например, в бою или когда требуются броски реакции - вы должны сделать бросок IQ, чтобы понять этот язык или быть понятым, когда выражаетесь на нем. При провале понять друг друга не удается, но вы можете попытаться еще раз. Критический провал означает, что информация понята неправильно! При быстром разговоре, плохой связи и т.д. эти броски делаются со штрафом от -2 до -8! Носители языка, которые и так не любят иностранцев (см. Нетерпимость, B140) реагируют на вас с дополнительным штрафом -1. 2 очка/язык.
* Акцент (Accented): вы можете свободно общаться даже в стрессовых ситуациях. Однако ваша речь и письмо весьма характерны, и по ним легко понять, что этот язык для вас не родной. Вы получаете -1 при использовании умений, зависящих от языка, удвойте штраф до -2 для творческих умений. Вы не получаете штрафа к реакции от носителей языка, но вы не сумеете сойти за местного (а это может оказаться огромной проблемой для потенциальных шпионов!). 4 очка/язык. 
* Родной (Native): вы полностью владеете языком и стилем общения. Вы можете думать на этом языке. Вы не получаете штраф при использовании умений, зависящих от языка. Вы бесплатно начинаете с одним из языков на этом уровне. Если вы покупаете понимание иностранного языка на уровне Родного, то можете сойти за носителя языка. 6 очков/язык

Выдающееся знание и незнание
Великие ораторы, писатели и прочие Мастера слова должны начинать с Родным пониманием языка, а затем бать умения вроде Публичного выступления и Письма на очень высоких уровнях.
Плохо образованным людям, которые с трудом изъясняются даже на родном языке, разницу между уровнем понимания языка и Родным уровнем следует взять в качестве недостатка. Например, некто владеющий родным языком на уровне Ломаного, получает недостаток на -4 очка.

Разговорный и письменный язык
Указанные выше цены предполагают, что вы одинаково хорошо разговариваете и пишете/читаете на языке. Если ваши знания письменного и разговорного язык отличаются, выберите уровни понимания отдельно для письменного и разговорного языка, заплатив половину стоимости за каждый. Например, если вы научились писать по-французски по учебнику, то можете взять «Французский: Разговорный (Отсутствует)/Письменный (Родной) [3]».

Грамотность 
Ваш уровень понимания письменного языка определяет степень грамотности в данном языке:
* Грамотность - это способность понимать язык на уровне с «Акцентом» и выше, но для письменной речи. Вы можете читать и писать с полной скоростью. 
* Полу-грамотность - это понимание письменной речи на «ломаном» уровне и ниже. Полуграмотному человеку понадобилось бы три минуты, чтобы прочитать это предложение, а затем бросок IQ, чтобы понять его значение! Многие слова всегда оказываются непонятны полуграмотному человеку, включая и ряд слов из данного параграфа. 
* Неграмотность - это «отсутствующее» понимание письменной речи. В этом случае вы и правда не можете читать! Вывески, свитки, книги и названия на карте (хотя и не сами карты) вам абсолютно непонятны. Игрок может передать тайную записку Мастеру (и наоборот), но персонаж ничего прочитать не может.

При TL4 и ниже вполне возможно прожить всю жизнь и ни разу не испытать потребности в чтении. В подобных мирах неграмотность или полу-грамотность являются нормой. Большинство людей владеют разговорным языком на уровне Родного, а письменную речь понимают на Ломаном уровне или вовсе не понимают. 
Неграмотность в родном языке - Разговорный (Родной)/Письменный (Отсутствует) - это недостаток стоимостью -3 очка. Полу-грамотность - Разговорный (Родной)/Письменный (Ломаный) - стоит -2 очка. Мастер не должен учитывать эти очки при расчете ограничения по недостаткам, если неграмотность является нормой для вашего игрового мира.
		<div>
			<br>
		</div>
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Laziness</name>
		<name-loc>Лень</name-loc>
		<description-loc>Вы очень не любите работать. Вероятность получить прибавку или повышение на любой работе в два раза меньше. Если вы работаете не по найму, делите ежемесячную плату вдвое (см. Работы, B516). Вы должны избегать работы, особенно тяжелой, любой ценой. Отыграйте это!</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B142</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Lecherousness</name>
		<name-loc>Развратность</name-loc>
		<description-loc>У вас необычайно сильная страсть закручивать романы. При каждом более-менее продолжительном контакте с привлекательным лицом подходящего пола сделайте проверку на самоконтроль (с -5, если у этого существа Красивая/Прекрасная внешность; с -10 если Очень Красивая/Очень Прекрасная). При провале вы должны "наводить мосты", пуская в ход всю свою хитрость и умение. После этого вам придется испытать последствия своих действий, успешных или не очень, как то: физическое возмездие, тюрьма, венерическое заболевание, или (возможно) новый любящий друг.
Если объект вашей страсти не Очень Красив/Очень Прекрасен, вам не нужно делать проверку более раза в день, чтобы избежать активных действий. Если кто-то упорно вам отказывает (например, ставит синяк под глазом или подает в суд за домогательство), мастер может дать бонус к следующей проверке на самоконтроль, cвязанной с этим человеком...
Обратите внимание, что вы, скорее всего, измените критерии привлекательности, если по-настоящему привлекательные лица данного пола будут недоступны!</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B142</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Legal Enforcement Powers</name>
	<name-loc>Представитель силовых структур</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Полицейская должность@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Агент федерального уровня@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Гос безопасность - КГБ/Штази/Гестапо и т.п.@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B65</reference>
	<description-loc>Вы - офицер правопорядка, со всеми соответствующими правами, обязанностями и привилегиями. В некоторых временах и местах, это дает право на убийство; в других это всего лишь подразумевает право носить значок и выписывать штрафы за парковку. Стоимость этого преимущества определяется правами и привилегиями, получаемыми персонажем.
* Полисмен с местной юрисдикцией, правом арестовывать подозреваемых, производить обыски при наличии ордера и, может быть, скрыто носить оружие, стоит 5 очков. Примером может быть современный полисмен.
* Кто-либо с национальной или международной юрисдикцией, или не обязанный уважать гражданские права других людей, или способный участвовать в секретных операциях, или обладающий правом на убийство, должен платить 10 очков. Примером могут быть современные агенты ФБР или средневековые Королевские Стражники.
* Офицер с тремя или большим числом этих способностей должен заплатить 15 очков. Примером могут служить высокопоставленные агенты КГБ, ЦРУ или MI-5.
Преимущество "Представитель Силовых Структур" обычно выдается в комплекте со "Службой" и "Репутацией", что может быть преимуществом, недостатком или и тем, и другим. Любой из вариантов уже включает Полицейский Ранг 0.</description-loc>
</advantage>
	<advantage version="2">
	<name>Legal Immunity</name>
	<name-loc>Юридическая Неприкосновенность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Наблюдатель ООН@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Бард / пресса@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Дипломат@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Дипломатическая неприкосновенность@</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B65</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B65</reference>
	<description-loc>Вы дипломат, представитель духовенства, привилегированный дворянин, или по иной причине находитесь вне юрисдикции судебных структур вашего общества. Вы не можете быть арестованы или обвинены в преступлении обычными властями. Только «себе подобные» - ваша собственная церковь, ваше собственное правительство, ваш собственная социальная группа может заключить вас в тюрьму или подвергнуть суду.
Стоимость этого преимущества зависит от его силы. 
* Если персонаж не подчиняется местным властям, но существуют определенные мастером жесткие правила, которые ограничивают его поведение (наблюдатель ООН). 5 очков.
* Если кроме того, по всей стране законы менее строги к персонажу (средневековый бард, см. ниже), то стоимость этого преимущества 10 очков. 
* Если персонаж может делать почти все, что ему угодно, пока он не вредит собственной стране, церкви или организации, то это преимущество стоит 15 очков. примером может служить международный дипломат (см. ниже) или герцог.
За 5 дополнительных очков вы также можете получить право "дипломатической неприкосновенности". Вы можете посылать или получать корреспонденцию или предметы, которые не могут задерживать или досматривать местные власти.

Особенно интересны для приключенцев следующие два особых варианта.

Иммунитет барда: Вы можете петь что угодно без страха серьезных последствий. Вы даже можете спеть шокирующую песню королю – вас за это могут выгнать, но не посадить или убить. Любой нарушивший иммунитет рискует нанести вред своему имени и репутации. Другие барды будут составлять и распространять жесткую сатиру о нем, давая плохую репутацию. Они могут даже раскрыть секрет, если есть такой. Преимущество применяется только и исключительно на содержание выступлений, и доступно только истинным бардам в фэнтези или средневековье (не менее одного очка в каждом из навыков: Выступление, Поэзия и Пение) 10 очков.
Дипломатический иммунитет: Вы – международный дипломат. Вы можете игнорировать законы любой страны, кроме вашей собственной. Вы не можете стать подследственным за любое преступление, независимо от его серьезности. Местная полиция может вас арестовать, но не обвинять. Единственная доступная возможность для иностранного правительства – объявить вас персоной нон-грата. Это запрещает вам повторный въезд в страну, автоматически заканчивает текущее назначение – и, возможно, вашу карьеру. Иностранные силовые структуры могут требовать вашей выдачи, но ваше правительство обычно не соглашается с этим. Эта черта всегда идет в комплекте со Службой правительству, и часто – рангом в администрации. 20 очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Less Sleep</name>
		<name-loc>Уменьшенная потребность во сне</name-loc>
		<description-loc>Вы меньше нуждаетесь во сне, чем другие люди. Каждый уровень этого преимущества уменьшает необходимое количество сна на один час. Максимальное количество уровней для этого преимущества – 4.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B65</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Lifebane</name>
	<name-loc>Аура смерти 
</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B142</reference>
	<description-loc>Вас окружает сверхъестественная аура смерти. Там, где вы прошли, погибает и больше не растет трава, более крупные растения немедленно увядают рядом с вами, а насекомые и другие маленькие существа умирают, приблизившись к вам на ярд. Аура не влияет на животных весом больше нескольких унций и на очень большие растения вроде деревьев (но листья поблизости от вас могут засохнуть, а дерево, мимо которого вы будете ежедневно ходить несколько лет в конце концов пострадает), на обычные формы жизни под управлением сверхъестественных сих (например, вызванный магией рой насекомых), или на сверхъестественные объекты любого рода.
Аура смерти дает -2 к реакции от любого, кто замечает ее действие. Если аура является следствием демонических способностей, вампиризма и т.п., наблюдатель получает +2 ко всем проверкам, позволяющим разгадать эту тайну! Данная черта также мешает использовать невидимость (и связанные с ней способности) на открытом воздухе: +2 к броскам на обнаружение в большинстве открытых мест. У нее, однако, есть и положительные стороны. Например, вам никогда не придется покупать средство от насекомых!</description-loc>
</advantage>
	<advantage version="2">
	<name>Lifting ST</name>
	<name-loc>Подъемная сила</name-loc>
	<points_per_level>3</points_per_level>
	<levels>1</levels>
	<attribute_bonus>
		<attribute limitation="lifting only">st</attribute>
		<amount per_level="yes">1</amount>
	</attribute_bonus>
	<modifier version="1" enabled="no">
		<name>Нет хороших манипуляторов (No fine manipulators)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B15</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Размер (Size)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B15</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Супер-усилие (Super-Effort)</name>
		<cost type="percentage">400</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B65</reference>
	<description-loc>Вы обладаете грузоподъемностью намного большей относительно вашей массы. Эта черта обычна для супер-героев и машин. Уровень Подъемной силы добавляется к обычной ST, когда вы рассчитываете свою грузоподъемность (с. B15) в целях переноски, подъема, толкания или тяги других предметов. Также, Подъемная сила добавляется к ST, когда необходимо медленное, постоянное давление (захват, попытки удушения и т.д.). Подъемная сила не влияет на ST (и Базовую грузоподъемность) в целях определения НР, дистанции броска или повреждений, наносимых оружием ближнего и дальнего боя.
Если вы приобретаете ST с модификатором Размер, этот же модификатор применяется и к Подъемной силе. Модификатор Нет точных манипуляторов не дает скидки.

===Новое особое улучшение===
Это необязательное улучшение для полубогов и суперов. С ним сила подъема становится еще более эффективна, чем обычно после восьмого уровня… и дальше становится только лучше. Таким образом, она имеет ценность только для героев со значительными вложениями в Подъемную СЛ. Если Мастер устанавливает ограничение по использованию этого модификатора, он должен быть на уровне Подъемной СЛ +8 или выше.
Супер-усилие (Super-effort): Вы можете поднимать невероятные тяжести! Ваша Подъемная сила работает как обычно, пока вы не используете сверх-усилия. В этом случае игнорируйте обычные правила по сверх-усилиям. Вместо этого найдите ваш уровень Подъемной силы в столбце Размер таблицы Размеров, скоростей и расстояний (с. В550), найдите на этой строчке значение из столбца Линейное измерение, и используйте это значение в качестве премии к вашей СЛ для подъема. Например, Подъемная сила +20 даст вам +5000 СЛ. Вы тратите 1 ЕУ при каждой попытке сверх-усилия. Когда вы подняли предмет, дальнейшие затраты усталости рассчитываются по правилам Способности и утомление (с. Р159). Ходьба с грузом или перетаскивание его считается «интенсивным использованием» (1 ЕУ/мин.); простое удерживание – «длительное использование» (1 ЕУ/час). Эти затраты не могут быть снижены приобретением Уменьшенной усталости, если вы не приобретете еще и модификатор Абсолют (+50%). Сверх-усилие не влияет на захваты и удушение. +400%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Light Sleeper</name>
		<name-loc>Чуткий сон
</name-loc>
		<description-loc>Вы не можете так легко заснуть и крепко спать, как это делает большинство людей. Всякий раз, когда спать предстоит в неудобном месте, или слышен шум, чуть громче самого минимального, вы должны сделать проверку HT, чтобы заснуть. В случае провала попытку можно повторить спустя час, но вы испытаете все последствия от пропущенного часа сна (см. Пропущенный сон, B426).
Если вокруг вас что-то происходит, вы обычно просыпаетесь (но оглушенным, если только у вас нет Боевых рефлексов). Чтобы продолжить спать, вам нужно неудачно выполнить Проверку чувств. Если вы все-таки проснулись и хотите опять заснуть, придется делать проверку на HT, как описано выше. Иногда это может быть полезным, но чаще это будет приводить к тому, что вы просыпаетесь, когда шумные попутчики будут сменять друг друга на часах или возвращаться после ночных похождений.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B142</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Lightning Calculator</name>
		<name-loc>Молниеносные расчеты</name-loc>
		<description-loc>У вас есть способность делать мгновенные математические расчеты в уме. Талант делится на два уровня:

Молниеносные расчеты (Lightning Calculator): Если у вас есть этот талант, вы Вы ( игрок) можете использовать калькулятор в любое время, чтобы посчитать то, что Вы хотите - даже если ваш персонаж в это время спасается бегством! Также, в случае простых математических проблем мастер может просто сообщить, что персонаж знает ответ. 2 очка.
Математическая интуиция (Mathematical Intuition): Ваша способность не ограничена арифметическими действиями. Вы можете высчитывать звездные пути без компьютера, в уме рассчитывать чертежи любой сложности, и мгновенно решать дифференциальные уравнения. Вам не нужен калькулятор – вы намного быстрее его, и даже многих компьютеров. 5 очков.
Истинные математические гении имеют одну из этих черт, и 1+ уровней математических способностей (см. Таланты).</description-loc>
		<type>Mental</type>
		<base_points>2</base_points>
		<modifier version="1" enabled="no">
			<name>Интуитивная математика(Intuitive Mathematician)</name>
			<cost type="points">3</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<reference>B66</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Like @Item@</name>
		<name-loc>Предпочитаю @Предмет@</name-loc>
		<description-loc>
Если вам что-то нравится, вы будете стремиться к этому всеми силами. Приспособления, котята, сверкающие ножи, керамические совы, произведения искусства... все, что угодно. Это не фанатизм, а просто предпочтение.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Loner</name>
	<name-loc>Одиночка 
</name-loc>
	<base_points>-5</base_points>
	<cr adj="reaction penalty">12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B142</reference>
	<description-loc>Вам нужно много "личного пространства". Делайте проверку на самоконтроль всякий раз, когда кто-то маячит слишком близко, заглядывает вам через плечо и т.п. В случае провала вы должны наброситься на этого человека, как при Вспыльчивости (B124). Одиночки-NPC всегда реагируют на других людей с пенальти.


!Cамоконтроль|Пенальти к реакции
|6|-4
|9|-3
|12|-2
|15|-1
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Longevity</name>
		<name-loc>Долгожительство</name-loc>
		<description-loc>Продолжительность Вашей жизни очень велика. При бросках на старение (с. B444) Вы потерпите неудачу только выбросив 17 или 18 – или только на 18, если модифицированное значение НТ равно или превышает 17!</description-loc>
		<type>Physical</type>
		<base_points>2</base_points>
		<reference>B66</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Low Empathy</name>
		<name-loc>Нечувствительный 
</name-loc>
		<description-loc>Вы совсем не понимаете эмоций. Это не мешает испытывать и выказывать свои эмоции (если у вас нет чего-то вроде недостатка Нет чувства юмора) - проблема в том, что вы их в действительности не понимаете. В результате у вас возникают определенные социальные проблемы.
Вы не можете взять преимущество Эмпатия и получаете пенальти -3 ко всем умениям, частично или полностью связанным с пониманием чьего-то эмоционального состояния, включая Артистизм, Пирушки, Криминологию, Определение лжи, Дипломатию, Увлечение, Заговаривание зубов, Допрашивание, Лидерство, Торговое дело, Политику, Психологию, Хорошие манеры, Сексапильность, Социологию, и Знание улиц. Это не значит, что у вас не должно быть этих умений - вы просто испытываете трудности при их использовании.
Нечувствительность характерна для андроидов, демонов, големов, нежити и части инопланетных существ. Она также может быть присуща некоторым людям. Эту черту нельзя объединять с похожими недостатками Бесчувственный (B125) и Непонимающий (B146), которые все-таки предполагают некоторое, хоть и искаженное, понимание эмоций.</description-loc>
		<type>Mental</type>
		<base_points>-20</base_points>
		<reference>B142</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">acting</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">carousing</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">criminology</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">detect lies</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">diplomacy</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">enthrallment</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">fast-talk</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">interrogation</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leadership</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">merchant</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">politics</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">psychology</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="contains">savoir-faire</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sex appeal</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sociology</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">streetwise</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">oblivious</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="no">
				<name compare="is">callous</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="no">
				<name compare="is">empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Low Pain Threshold</name>
		<name-loc>Низкий болевой порог 
</name-loc>
		<description-loc>Вы очень чувствительны к любой боли. Удвойте шок от любой раны - если вы, например, вам наносят 2 хита повреждений, то вы получаете -4 к DX на следующий ход. Вы получаете пенальти -4 к броскам на сопротивление сбиванию с ног, оглушению и физическим пыткам. Всякий раз, получив рану более чем на хит, вы должны сделать проверку Воли(Will), чтобы не закричать. Это может подпортить вашу репутацию и принести пенальти -1 к реакции от "крутых парней".</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B142</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">high pain threshold</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Low Self-Image</name>
		<name-loc>Низкая самооценка 
</name-loc>
		<description-loc>Вам не хватает уверенности в себе и своих способностях настолько, что это влияет на вашу работу. Вы получаете пенальти -3 ко всем проверкам умений в ситуациях, когда вы считаете, что шансы не в вашу пользу или другие ожидают от вас провала (на усмотрение мастера). Например, будучи механиком, вы не получите пенальти, ремонтируя машину в гараже... но попытка сделать то же на дороге, под дождем, только с переносным набором инструментов и врагом, сидящем на хвосте, принесет -3 в добавок к обычным модификаторам, положенным в такой ситуации!</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B143</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Low TL</name>
	<name-loc>Низкий TL 
</name-loc>
	<points_per_level>-5</points_per_level>
	<levels>1</levels>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B22</reference>
	<description-loc>
Ваш личный TL ниже технологического уровня мира, где проходит кампания. Вы начинаете игру без знаний (или лишь с умениями по умолчанию), связанных с вещами более высокого TL. Вы сможете научиться технологическим умениям, зависящим от DX (связанным с транспортом, оружием и т.д.) по ходу игры, если найдете учителя, но фундаментальная разница мышления не позволит вам изучить зависящие от IQ технологические умения. Чтобы преодолеть это ограничение, вам придется выкупить данную черту, повысив личный TL. 
Обычно это требует длительного периода переобучения (см. Главу 9).
</description-loc>
</advantage>
	<advantage version="2">
		<name>Luck</name>
		<name-loc>Удача</name-loc>
		<description-loc>Вы просто счастливчик. Преимущество имеет несколько уровней, различающихся по силе и приведены в порядке убывания реалистичности.

Удача (Luck): Каждый час реального времени, вы можете перебросить один неудачный бросок дважды и выбрать лучший из результатов! Если вы используете удачу, вы должны это сделать немедленно после броска – если еще кто-нибудь сделает бросок, будет уже поздно. Если бросает мастер (к примеру, чтобы узнать, прибыл ли нужный NPC или заметили ли вы что-нибудь), вы можете сказать ему, что используете свою удачу и тогда он должен будет сделать три броска и выбрать лучший результат. Это преимущество можно использовать после первого броска, чтобы получить еще две попытки. 15 очков.

Удача, Экстраординарная (Extraordinary Luck): Точно также, но работает раз в 30 минут. 30 очков.
Удача, чудесная (Ridiculous Luck): Точно также, но работает раз в 10 минут! 60 очков.
Ваша удача влияет только на броски, когда ваш персонаж пытается что-то сделать, ИЛИ на внешние события, которые влияют на вас или на всю команду, ИЛИ когда вас атакуют ( в этом случае вы можете заставить атакующего три раза бросить кубик и выбрать худший результат).
Удачу нельзя делить. Когда Сильный Сэм громит дверь, Счастливчик Лу не может стоять сзади и передавать тому удачу. Он должен выбивать дверь сам.

После использования Удачи вы должны ждать час (при Экстраординарной удаче - 30 минут, или 10 – при Чудесной) перед тем, как снова использовать ее. Нельзя один раз использовать ее в 11:58, а другой в 12:01. И нельзя играть несколько часов подряд, не пользуясь Удачей, а потом спустить всю ее за раз. 

Сверх-удача (Super-Luck): Вы не просто удачливы – вы можете влиять на будущее. Раз в час игры, вы можете заказать нужный вам результат на кубиках, которые бросаете вы (или мастер бросает за вас) вместо броска. Абсолютно невозможные действия не пройдут (эффективный уровень должен быть по крайней мере 3), но вы можете выбрать результат любой, какой только может выпасть. 
Вы можете иметь любой уровень простой удачи и супер-удачу, но не можете взять супер-удачу несколько раз.


===Особые ограничения.===

Активная (Active): Ваша удача – сознательная сверхъестественная сила. Вы должны объявить ее использование до броска. Перебросить уже выпавший плохой результат не получится. -40%.

Аспект (Aspected): Ваша удача действует только на один класс связанных между собой действий – вроде атлетики, общения или рабочих навыков. «боевая» удача – тоже неплохо, но она действует только на броски навыков, активных защит, и бросков для ближнего боя – не для избежания смерти. -20%.
Защитная (Defensive): Вы можете использовать удачу только для перебрасываня плохих бросков защиты и сопротивления, бросков НТ для сопротивления эффектам ран, или заставить врага перебросить критическое попадание по вам. -20%.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Активная (Active)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Специфичная (Aspected)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
			<notes>@Класс задач@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Защитная (Defensive)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Wishing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P59</reference>
		</modifier>
		<reference>B66</reference>
		<notes>Не чаще раза в час реального времени</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="starts with">Luck</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Luck, Extraordinary</name>
		<name-loc>Удача, Экстраординарная</name-loc>
		<description-loc>Вы просто счастливчик. Преимущество имеет несколько уровней, различающихся по силе и приведены в порядке убывания реалистичности.

Удача (Luck): Каждый час реального времени, вы можете перебросить один неудачный бросок дважды и выбрать лучший из результатов! Если вы используете удачу, вы должны это сделать немедленно после броска – если еще кто-нибудь сделает бросок, будет уже поздно. Если бросает мастер (к примеру, чтобы узнать, прибыл ли нужный NPC или заметили ли вы что-нибудь), вы можете сказать ему, что используете свою удачу и тогда он должен будет сделать три броска и выбрать лучший результат. Это преимущество можно использовать после первого броска, чтобы получить еще две попытки. 15 очков.

Удача, Экстраординарная (Extraordinary Luck): Точно также, но работает раз в 30 минут. 30 очков.
Удача, чудесная (Ridiculous Luck): Точно также, но работает раз в 10 минут! 60 очков.
Ваша удача влияет только на броски, когда ваш персонаж пытается что-то сделать, ИЛИ на внешние события, которые влияют на вас или на всю команду, ИЛИ когда вас атакуют ( в этом случае вы можете заставить атакующего три раза бросить кубик и выбрать худший результат).
Удачу нельзя делить. Когда Сильный Сэм громит дверь, Счастливчик Лу не может стоять сзади и передавать тому удачу. Он должен выбивать дверь сам.

После использования Удачи вы должны ждать час (при Экстраординарной удаче - 30 минут, или 10 – при Чудесной) перед тем, как снова использовать ее. Нельзя один раз использовать ее в 11:58, а другой в 12:01. И нельзя играть несколько часов подряд, не пользуясь Удачей, а потом спустить всю ее за раз. 

Сверх-удача (Super-Luck): Вы не просто удачливы – вы можете влиять на будущее. Раз в час игры, вы можете заказать нужный вам результат на кубиках, которые бросаете вы (или мастер бросает за вас) вместо броска. Абсолютно невозможные действия не пройдут (эффективный уровень должен быть по крайней мере 3), но вы можете выбрать результат любой, какой только может выпасть. 
Вы можете иметь любой уровень простой удачи и супер-удачу, но не можете взять супер-удачу несколько раз.


===Особые ограничения.===

Активная (Active): Ваша удача – сознательная сверхъестественная сила. Вы должны объявить ее использование до броска. Перебросить уже выпавший плохой результат не получится. -40%.

Аспект (Aspected): Ваша удача действует только на один класс связанных между собой действий – вроде атлетики, общения или рабочих навыков. «боевая» удача – тоже неплохо, но она действует только на броски навыков, активных защит, и бросков для ближнего боя – не для избежания смерти. -20%.
Защитная (Defensive): Вы можете использовать удачу только для перебрасываня плохих бросков защиты и сопротивления, бросков НТ для сопротивления эффектам ран, или заставить врага перебросить критическое попадание по вам. -20%.</description-loc>
		<type>Mental</type>
		<base_points>30</base_points>
		<modifier version="1" enabled="no">
			<name>Активная (Active)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Специфичная (Aspected)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
			<notes>@Класс задач@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Защитная (Defensive)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Wishing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P59</reference>
		</modifier>
		<reference>B66</reference>
		<notes>Не чаще раза в 30 мин. реального времени</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="starts with">Luck</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Luck, Ridiculous</name>
		<name-loc>Удача, Невообразимая</name-loc>
		<description-loc>Вы просто счастливчик. Преимущество имеет несколько уровней, различающихся по силе и приведены в порядке убывания реалистичности.

Удача (Luck): Каждый час реального времени, вы можете перебросить один неудачный бросок дважды и выбрать лучший из результатов! Если вы используете удачу, вы должны это сделать немедленно после броска – если еще кто-нибудь сделает бросок, будет уже поздно. Если бросает мастер (к примеру, чтобы узнать, прибыл ли нужный NPC или заметили ли вы что-нибудь), вы можете сказать ему, что используете свою удачу и тогда он должен будет сделать три броска и выбрать лучший результат. Это преимущество можно использовать после первого броска, чтобы получить еще две попытки. 15 очков.

Удача, Экстраординарная (Extraordinary Luck): Точно также, но работает раз в 30 минут. 30 очков.
Удача, чудесная (Ridiculous Luck): Точно также, но работает раз в 10 минут! 60 очков.
Ваша удача влияет только на броски, когда ваш персонаж пытается что-то сделать, ИЛИ на внешние события, которые влияют на вас или на всю команду, ИЛИ когда вас атакуют ( в этом случае вы можете заставить атакующего три раза бросить кубик и выбрать худший результат).
Удачу нельзя делить. Когда Сильный Сэм громит дверь, Счастливчик Лу не может стоять сзади и передавать тому удачу. Он должен выбивать дверь сам.

После использования Удачи вы должны ждать час (при Экстраординарной удаче - 30 минут, или 10 – при Чудесной) перед тем, как снова использовать ее. Нельзя один раз использовать ее в 11:58, а другой в 12:01. И нельзя играть несколько часов подряд, не пользуясь Удачей, а потом спустить всю ее за раз. 

Сверх-удача (Super-Luck): Вы не просто удачливы – вы можете влиять на будущее. Раз в час игры, вы можете заказать нужный вам результат на кубиках, которые бросаете вы (или мастер бросает за вас) вместо броска. Абсолютно невозможные действия не пройдут (эффективный уровень должен быть по крайней мере 3), но вы можете выбрать результат любой, какой только может выпасть. 
Вы можете иметь любой уровень простой удачи и супер-удачу, но не можете взять супер-удачу несколько раз.


===Особые ограничения.===

Активная (Active): Ваша удача – сознательная сверхъестественная сила. Вы должны объявить ее использование до броска. Перебросить уже выпавший плохой результат не получится. -40%.

Аспект (Aspected): Ваша удача действует только на один класс связанных между собой действий – вроде атлетики, общения или рабочих навыков. «боевая» удача – тоже неплохо, но она действует только на броски навыков, активных защит, и бросков для ближнего боя – не для избежания смерти. -20%.
Защитная (Defensive): Вы можете использовать удачу только для перебрасываня плохих бросков защиты и сопротивления, бросков НТ для сопротивления эффектам ран, или заставить врага перебросить критическое попадание по вам. -20%.</description-loc>
		<type>Mental</type>
		<base_points>60</base_points>
		<modifier version="1" enabled="no">
			<name>Активная (Active)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Специфичная (Aspected)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
			<notes>@Класс задач@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Защитная (Defensive)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B66</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Wishing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P59</reference>
		</modifier>
		<reference>B66</reference>
		<notes>Не чаще раза в 10 мин. реального времени</notes>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="starts with">Luck</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Luck, Super</name>
	<name-loc>Удача, Супер</name-loc>
	<notes>Не чаще раза в час реального времени говорите необходимый вам результат броска</notes>
	<base_points>100</base_points>
	<modifier version="1" enabled="no">
		<name>Активная (Active)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B66</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Специфичная (Aspected)</name>
		<notes>@Класс задач@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B66</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Защитная (Defensive)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B66</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Wishing</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P59</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Alter Reality</name>
		<cost type="percentage">75</cost>
		<affects>total</affects>
		<reference>P80</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Wishing</name>
		<notes>Только помощь другим</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P80</reference>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="starts with">Luck</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B89</reference>
	<description-loc>Вы просто счастливчик. Преимущество имеет несколько уровней, различающихся по силе и приведены в порядке убывания реалистичности.

Удача (Luck): Каждый час реального времени, вы можете перебросить один неудачный бросок дважды и выбрать лучший из результатов! Если вы используете удачу, вы должны это сделать немедленно после броска – если еще кто-нибудь сделает бросок, будет уже поздно. Если бросает мастер (к примеру, чтобы узнать, прибыл ли нужный NPC или заметили ли вы что-нибудь), вы можете сказать ему, что используете свою удачу и тогда он должен будет сделать три броска и выбрать лучший результат. Это преимущество можно использовать после первого броска, чтобы получить еще две попытки. 15 очков.

Удача, Экстраординарная (Extraordinary Luck): Точно также, но работает раз в 30 минут. 30 очков.
Удача, чудесная (Ridiculous Luck): Точно также, но работает раз в 10 минут! 60 очков.
Ваша удача влияет только на броски, когда ваш персонаж пытается что-то сделать, ИЛИ на внешние события, которые влияют на вас или на всю команду, ИЛИ когда вас атакуют ( в этом случае вы можете заставить атакующего три раза бросить кубик и выбрать худший результат).
Удачу нельзя делить. Когда Сильный Сэм громит дверь, Счастливчик Лу не может стоять сзади и передавать тому удачу. Он должен выбивать дверь сам.

После использования Удачи вы должны ждать час (при Экстраординарной удаче - 30 минут, или 10 – при Чудесной) перед тем, как снова использовать ее. Нельзя один раз использовать ее в 11:58, а другой в 12:01. И нельзя играть несколько часов подряд, не пользуясь Удачей, а потом спустить всю ее за раз. 

Сверх-удача (Super-Luck): Вы не просто удачливы – вы можете влиять на будущее. Раз в час игры, вы можете заказать нужный вам результат на кубиках, которые бросаете вы (или мастер бросает за вас) вместо броска. Абсолютно невозможные действия не пройдут (эффективный уровень должен быть по крайней мере 3), но вы можете выбрать результат любой, какой только может выпасть. 
Вы можете иметь любой уровень простой удачи и супер-удачу, но не можете взять супер-удачу несколько раз.


===Особые ограничения.===

Активная (Active): Ваша удача – сознательная сверхъестественная сила. Вы должны объявить ее использование до броска. Перебросить уже выпавший плохой результат не получится. -40%.

Аспект (Aspected): Ваша удача действует только на один класс связанных между собой действий – вроде атлетики, общения или рабочих навыков. «боевая» удача – тоже неплохо, но она действует только на броски навыков, активных защит, и бросков для ближнего боя – не для избежания смерти. -20%.
Защитная (Defensive): Вы можете использовать удачу только для перебрасываня плохих бросков защиты и сопротивления, бросков НТ для сопротивления эффектам ран, или заставить врага перебросить критическое попадание по вам. -20%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Lunacy</name>
		<name-loc>Лунатизм</name-loc>
		<description-loc>Луна серьезно влияет на ваш характер и причиняет определенные неудобства. Во время полнолуния вы чрезвычайно эмоциональны и непостоянны (-2 ко всем проверкам Воли(Will) и самоконтроля), а в новолуние очень пассивны (временно получаете недостаток Лень, B142). Когда луна прибывает, вы сосредоточены и радостны; когда убывает - апатичны и немного раздражительны. Отыграйте это!</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B143</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Magery</name>
	<name-loc>Магические способности</name-loc>
	<base_points>5</base_points>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">thaumatology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<spell_bonus all_colleges="yes">
		<amount per_level="yes">1</amount>
	</spell_bonus>
	<modifier version="1" enabled="no">
		<name>Танец (Dance)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение во тьме (Dark-Aspected)</name>
		<cost type="percentage">-50</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение днем (Day-Aspected)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Музыкант (Musical)</name>
		<cost type="percentage">-50</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение ночью (Night-Aspected)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Одиночка (Solitary)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Песня (Song)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B66</reference>
	<description-loc>Вы имеете способности к магии. Преимущество приобретается по уровням. Вы должны приобрести Магические способности 0 перед покупкой высших уровней.
Магические способности 0: это базовая склонность к магии, требование (prerequisite) для изучения заклинаний в большинстве миров. Мастер будет бросать проверку против вашего Восприятия(Per) (с. B358), когда вы в первый раз видите магический предмет, и еще раз, когда вы дотрагиваетесь до него. Если бросок будет успешным, вы интуитивной поймете, что он обладает магией. Результат 3 или 4 еще и сообщит, полезна ли эта магия или опасна, и насколько она сильна. Персонажи без магических способностей не обладают возможностью определить магическая это вещь, или нет. 5 очков.
Магические способности 1+: У вас есть преимущество при изучении и использовании любого магического заклинания. Когда вы учите какое-либо заклинание, вы учите его так, словно ваш IQ на самом деле равен IQ + уровень магических способностей. 
=====Пример: Ваше IQ 14, а магические способности 3. Вы учите заклинания, словно ваш IQ 17. Кроме того, на изучение заклинаний вы тратите меньше времени – время, но не очки персонажа уменьшается на (уровень Магичности *10%) (при Магичности 3 вы потратите на 30% меньше времени).=====
Уровень магичности также добавляется к вышеописанному броску на определение наличия магии на предмете, и к IQ при изучении навыка Тауматология (с. B225). 10 очков/уровень.
Мощные заклинания часто имеют определенный уровень Магичности в виде пререквизитов (см. Список заклинаний, с. B242-B253). Высокий уровень магических способностей также позволяет вам выдавать более мощные эффекты многих заклинаний (см. Магичность и эффект, с. B237).
Максимальный уровень магичности, доступный для игроков, устанавливается Мастером. Уровня 3 достаточно для большинства игр в жанре классической фентези.
Магия в немагических культурах.
Использвоание магии в немагических культурах может быть сложнее. Вы по-прежнему способны чувствовать магию, но пока у вас нет опыта в колдовстве и знания магии, Мастер не скажет вам: «Эта статуэтка магическая», вместо этого вы получите ответ «Эта статуэтка кажется вам очень зловещим. В нем есть что-то особенное».
Конечно, если вы из немагической культуры, никаких заклинаний у вас не будет, но вы все равно с легкостью сможете выучить их, если будет возможность. И, когда вы окажетесь в магическом мире, те, кто способен прочесть вашу ауру, определят вас, как потенциально мощного, но не тренированного мага.

Магические способности 0 стоят 5 очков для всех магов; но вы можете приобретать особые ограничения для магических способностей уровня 1 и выше.
===Особые ограничения.===

Магия танца (Dance): Вы должны иметь полную свободу движений, чтобы колдовать. Нужда в движениях не уменьшается при увеличении уровня навыка заклинания (см. Магические ритуалы, с. B237). Однако, вам вовсе не нужно говорить, чтобы колдовать. -40%.

Магия тьмы (Dark-aspected): Вы можете колдовать только в темноте. Независимо от времени дня или ночи, любой свет ярче свечи или звезд лишит вас способностей, однако ваша аура все равно будет выдавать в вас мага. -50%.

Магия дня (Day-Aspected): Вы можете колдовать только когда солнце в небе. Во время солнечных затмений вы теряете силы. После заката вы теряете способности, но ваша аура все равно определяет в вас мага. Вы не зависите от освещенности вокруг – только от положения солнца на небе. Вы автоматически узнаете (если не спите), когда остается одна минута до восхода или одна минута до заката. -40%.

Магия музыки (Musical): Вы должны играть на музыкальном инструменте, чтобы колдовать. Вы не можете колдовать заклинания без звука. -50%.

Магия ночи (Night-aspected): Вы можете колдовать только когда солнце заходит. После рассвета вы теряете способности, но ваша аура все равно определяет в вас мага. Вы не зависите от освещенности вокруг – только от положения солнца на небе. Вы автоматически узнаете (если не спите), когда остается одна минута до восхода или одна минута до заката. -40%.

Только одна школа (One College Only): Вы получаете выгоды от уровня магических способностей только при изучении заклинаний одной определенной сферы и заклинания Восстановление энергии. Другие заклинания вы изучаете как будто у вас нет магических способностей вообще, и можете сотворять их только в областях Высокой маны. Вы не можете определять наличие магии на предметах, если они не содержат ни одного заклинания вашей школы. -40%.

Маг-одиночка (Solitary): За каждое разумное существо в радиусе 5 ярдов от вас вы получаете -3 при сотворении любых заклинаний (-6 за каждого, кто вас касается). Однако, вы получаете шанс обнаружить разумных существ, пересекающих этот «барьер» - бросок IQ. -40%.
Магия песни (Song): Вы должны петь, чтобы сотворять заклинания. Вы не можете сотворять заклинания молча на любом уровне умений. -40%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Magery</name>
	<name-loc>Магические способности (одна школа)</name-loc>
	<notes>One College (@Collage@)</notes>
	<base_points>5</base_points>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">thaumatology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<spell_bonus>
		<college_name compare="contains">@Collage@</college_name>
		<amount per_level="yes">1</amount>
	</spell_bonus>
	<modifier version="1" enabled="no">
		<name>Танец (Dance)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение во тьме (Dark-Aspected)</name>
		<cost type="percentage">-50</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение днем (Day-Aspected)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Музыкант (Musical)</name>
		<cost type="percentage">-50</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сотворение ночью (Night-Aspected)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Одиночка (Solitary)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Песня (Song)</name>
		<cost type="percentage">-40</cost>
		<affects>levels only</affects>
	</modifier>
	<modifier enabled="yes">
		<name>Одна школа (One College)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B66</reference>
	<description-loc>Вы имеете способности к магии. Преимущество приобретается по уровням. Вы должны приобрести Магические способности 0 перед покупкой высших уровней.
Магические способности 0: это базовая склонность к магии, требование для изучения заклинаний в большинстве миров. Мастер будет бросать проверку против вашего Восприятия(Per) (с. B358), когда вы в первый раз видите магический предмет, и еще раз, когда вы дотрагиваетесь до него. Если бросок будет успешным, вы интуитивной поймете, что он обладает магией. Результат 3 или 4 еще и сообщит, полезна ли эта магия или опасна, и насколько она сильна. Персонажи без магических способностей не обладают возможностью определить магическая это вещь, или нет. 5 очков.
Магические способности 1+: У вас есть преимущество при изучении и использовании любого магического заклинания. Когда вы учите какое-либо заклинание, вы учите его так, словно ваш IQ на самом деле равен IQ + уровень магических способностей. 
=====Пример: Ваше IQ 14, а магические способности 3. Вы учите заклинания, словно ваш IQ 17. Кроме того, на изучение заклинаний вы тратите меньше времени – время, но не очки персонажа уменьшается на (уровень Магичности *10%) (при Магичности 3 вы потратите на 30% меньше времени).=====
Уровень магичности также добавляется к вышеописанному броску на определение наличия магии на предмете, и к IQ при изучении навыка Тауматология (с. B225). 10 очков/уровень.
Мощные заклинания часто имеют определенный уровень Магичности в виде пререквизитов (см. Список заклинаний, с. B242-B253). Высокий уровень магических способностей также позволяет вам выдавать более мощные эффекты многих заклинаний (см. Магичность и эффект, с. B237).
Максимальный уровень магичности, доступный для игроков, устанавливается Мастером. Уровня 3 достаточно для большинства игр в жанре классической фентези.
Магия в немагических культурах.
Использвоание магии в немагических культурах может быть сложнее. Вы по-прежнему способны чувствовать магию, но пока у вас нет опыта в колдовстве и знания магии, Мастер не скажет вам: «Эта статуэтка магическая», вместо этого вы получите ответ «Эта статуэтка кажется вам очень зловещим. В нем есть что-то особенное».
Конечно, если вы из немагической культуры, никаких заклинаний у вас не будет, но вы все равно с легкостью сможете выучить их, если будет возможность. И, когда вы окажетесь в магическом мире, те, кто способен прочесть вашу ауру, определят вас, как потенциально мощного, но не тренированного мага.

Магические способности 0 стоят 5 очков для всех магов; но вы можете приобретать особые ограничения для магических способностей уровня 1 и выше.
===Особые ограничения.===

Магия танца (Dance): Вы должны иметь полную свободу движений, чтобы колдовать. Нужда в движениях не уменьшается при увеличении уровня навыка заклинания (см. Магические ритуалы, с. B237). Однако, вам вовсе не нужно говорить, чтобы колдовать. -40%.

Магия тьмы (Dark-aspected): Вы можете колдовать только в темноте. Независимо от времени дня или ночи, любой свет ярче свечи или звезд лишит вас способностей, однако ваша аура все равно будет выдавать в вас мага. -50%.

Магия дня (Day-Aspected): Вы можете колдовать только когда солнце в небе. Во время солнечных затмений вы теряете силы. После заката вы теряете способности, но ваша аура все равно определяет в вас мага. Вы не зависите от освещенности вокруг – только от положения солнца на небе. Вы автоматически узнаете (если не спите), когда остается одна минута до восхода или одна минута до заката. -40%.

Магия музыки (Musical): Вы должны играть на музыкальном инструменте, чтобы колдовать. Вы не можете колдовать заклинания без звука. -50%.

Магия ночи (Night-aspected): Вы можете колдовать только когда солнце заходит. После рассвета вы теряете способности, но ваша аура все равно определяет в вас мага. Вы не зависите от освещенности вокруг – только от положения солнца на небе. Вы автоматически узнаете (если не спите), когда остается одна минута до восхода или одна минута до заката. -40%.

Только одна школа (One College Only): Вы получаете выгоды от уровня магических способностей только при изучении заклинаний одной определенной сферы и заклинания Восстановление энергии. Другие заклинания вы изучаете как будто у вас нет магических способностей вообще, и можете сотворять их только в областях Высокой маны. Вы не можете определять наличие магии на предметах, если они не содержат ни одного заклинания вашей школы. -40%.

Маг-одиночка (Solitary): За каждое разумное существо в радиусе 5 ярдов от вас вы получаете -3 при сотворении любых заклинаний (-6 за каждого, кто вас касается). Однако, вы получаете шанс обнаружить разумных существ, пересекающих этот «барьер» - бросок IQ. -40%.
Магия песни (Song): Вы должны петь, чтобы сотворять заклинания. Вы не можете сотворять заклинания молча на любом уровне умений. -40%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Magic Resistance</name>
	<name-loc>Сопротивление магии</name-loc>
	<points_per_level>2</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Улучшенная (Improved)</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B67</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Super</type>
	<reference>B67</reference>
	<description-loc>На вас меньше действует магия всех видов. Уровень Сопротивления штрафует эффективный навык любого, кто сотворяет на вас заклинание, и добавляется к вашему броску сопротивления любому из заклинаний. Например, если у вас есть СМ 3, любой маг, пытающийся вас заколдовать, получит дополнительный штраф -3, а вы – дополнительный бонус +3 на сопротивление ему. Кроме того, вы бросаете НТ+СМ для сопротивления любым магическим эликсирам.
Увы, но вы также не можете "отключить его", чтобы на вас подействовали дружественные заклинания.
СМ влияет только на заклинания, сотворяемые прямо на вас. Она не защищает от большинства боевых метательных заклинаний (маг сотворяет их у себя в руке и кидает в вас), атак магическим оружием, или информационных заклинаний, не направленных специально на вас. Также она совершенно не помогает против немагических воздействий – божественных, псионических и т.д.

Обратите внимание, что это преимущество не может быть использовано вместе с Магическими Способностями (Magical Aptitude). Вы не можете одновременно быть способным к магии и устойчивым к ней же. В самом деле, если у вас есть устойчивость, вы вообще не можете произносить заклинания (хотя и способны использовать магическое оружие). Сопротивляемость магии и ее точный уровень может быть определен магом, посмотревшим вашу ауру и любым, произнесшим на вас заклинание. 
===Особые улучшения.===
Улучшенная (Improved): Ваша СМ не мешает вам колдовать! Вы можете обладать одновременно Магическими способностями и Сопротивлением к магии. +150%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Magic Susceptibility</name>
	<name-loc>Подверженность магии 
</name-loc>
	<points_per_level>-3</points_per_level>
	<levels>1</levels>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">magic resistance</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B143</reference>
	<description-loc>Магия с большей вероятностью действует на вас. Добавляйте Подверженность магии к умению заклинателя и вычитайте из своего броска на сопротивление волшебству. Например, если ваша Подверженность магии равна 4, волшебники получают +4 при применении заклинаний против вас, а вы получаете -4 к сопротивлению.
Подверженность магии делает уязвимее только к заклинаниям, направленным непосредственно на вас. Она не влияет на  метательные заклинания, атаки магическим оружием, информационные заклинания, не направленные прямо на вас. Она также не влияет на сверхъестественные силы, не относящиеся к магии, например, божественные чудеса, псионику, или природные способности духов. Подверженность магии обычным образом воздействует на площадные (Area) заклинания; не удваивайте ее эффект, как это делается в случае при Устойчивости к магии (B67).
Подверженность магии и ее уровень может узнать любой маг, который видел вашу ауру или применил на вас заклинание. Запрещено брать более пяти уровней Подверженности магии.
Вы можете объединить этот недостаток с Магическими способностями, но не с Сопротивляемостью магии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Maintenance</name>
	<name-loc>Требует обслуживания</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 1</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 2</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 3-5</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 6-10</name>
		<cost type="points">-40</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 11-20</name>
		<cost type="points">-50</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 21-50</name>
		<cost type="points">-60</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 51-100</name>
		<cost type="points">-70</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 101-200</name>
		<cost type="points">-80</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 201-400</name>
		<cost type="points">-90</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 401-800</name>
		<cost type="points">-100</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 801-1600</name>
		<cost type="points">-110</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 1601-3200</name>
		<cost type="points">-120</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 3201-6400</name>
		<cost type="points">-130</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 6401-12800</name>
		<cost type="points">-140</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Количество людей: 12801-25600</name>
		<cost type="points">-150</cost>
		<affects>total</affects>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежемесячно</name>
		<cost type="multiplier">0.2</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Два раза в неделю</name>
		<cost type="multiplier">0.33333</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Еженедельно</name>
		<cost type="multiplier">0.5</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Через день</name>
		<cost type="multiplier">0.75</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Ежедневно</name>
		<cost type="multiplier">1</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Дважды в день</name>
		<cost type="multiplier">2</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: 3-5 раз в день</name>
		<cost type="multiplier">3</cost>
		<reference>B143</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Частота: Непрерывно</name>
		<cost type="multiplier">5</cost>
		<reference>B143</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B143</reference>
	<description-loc>Чтобы не потерять HT, вы нуждаетесь в регулярном квалифицированном уходе. Примером может служить робот, нуждающийся в техническом обслуживании, хронический больной, которому нужен медицинский уход, или божество, требующее благочестивой молитвы.
Выберите нужный вид обслуживания и умение, которое за нее отвечает. Это может быть ремонт электроники (используется Починка электроники) или механики (Механик), врачебная помощь (Врачебное дело), непосредственный ремонт (используются умения Плотник, Электрик, и т.д.). Вы можете указать вместо умений преимущества или недостатки; например, бог может нуждаться в верующих с недостатком Требования веры. Вы можете разделить обслуживание между несколькими умениями - например, робот может нуждаться и в Починке электроники и в Механике.
Тем, кто вас обслуживает, необходимы некоторые ресурсы: механику нужны инструменты, верующие должны молиться в храме, и т.п. Ресурсы при этом не расходуются (иначе берите Зависимость (B130)).
Каждый сеанс обслуживания занимает один час. Базовая стоимость зависит от необходимого количества людей:

!Количество людей|	Стоимость
|	1|	-10
|	2|	-20
|	3-5|	-30
|	6-10|	-40
|	11-20|	-50
|	21-50|	-60
|	51-100|	-70
	

Добавьте -10 очков за полное удвоение нужного количества людей - например, бог, которому нужны 10,000 верующих, получит недостаток на -130 очков. Количество людей можно уменьшить, увеличив необходимое число человеко-часов (на усмотрение мастера).
Частота обслуживания меняет базовую стоимость.


!Частота обслуживания|	Множитель
|	Ежемесячно|	1/5
|	Два раза в неделю|	1/3
|	Еженедельно|	1/2
|	Через день|	3/4
|	Ежедневно|	1
|	Дважды в день|	2
|	3-5 раз в день|	3
|	Непрерывно|	5
	

Пропустив сеанс обслуживания, вы теряете единицу HT и должны сделать проверку HT. Неудача приводит к дополнительным неудобствам (на усмотрение мастера). Критическая неудача означает возможность смертельного исхода - например, с человеком случается сердечный приступ, у машины отказывают тормоза и т.п.
Для восстановления способностей и потерянных HT нужны соответствующее вмешательство и проверки умений (ремонт для машины, операция для живого существа и т.п.). Если вам нужно необычное обслуживание, это может потребовать весьма странных действий!</description-loc>
</advantage>
	<advantage version="2">
	<name>Mana Damper</name>
	<name-loc>Глушитель маны</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Область действия (Area Effect)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B67</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Выключаемое (Switchable)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B67</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Discriminatory</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>P59</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B67</reference>
	<description-loc>Вы нейтрализуете магическую энергию поблизости, затрудняя или делая невозможным сотворять заклинания. Вы не можете сами сотворять заклинания, и не можете иметь никаких способностей к магии.

Каждый уровень Глушения маны (максимум 3), уменьшает локальный уровень маны на 1 уровень – для вас и всей вашей ноши (включая живых существ). Например, маг может кинуть в вас огненный шар без помех, но не сможет прочитать ваши мысли или превратить вас в камень. См. Мана, с. B253.
===Особые улучшения.===

Воздействие на область (Area Effect): Ваша способность воздействует на всех в области. Первый уровень Воздействия на область – радиус 1 м; каждый последующий уровень удваивает этот радиус. +50% за уровень.
Выключаемое (Switchable): Вы можете включать и отключать способность, например, чтобы позволить дружественному магу колдовать в области воздействия или сотворять заклинания на вас. +100%.

Избирательное (Discriminatory): Вы и ваши союзники получают лучший эффект, который ваша способность может произвести – самый высокий уровень маны для сотворения заклинаний, самый низкий – для сопротивления им, а враги в области – самый худший. Модификатор включает Выключаемость и заменяет улучшение Избирательная область. +150%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Mana Enhancer</name>
	<name-loc>Излучатель маны</name-loc>
	<points_per_level>50</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Область действия (Area Effect)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B68</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Выключаемое (Switchable)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B68</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Discriminatory</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>P59</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B68</reference>
	<description-loc>Вы излучаете магическую энергию, ману. Каждый уровень Излучения (максимум – 2) увеличивает локальный уровень маны на 1 уровень, но только для вас и людей и вещей, которые вы несете. Если несколько персонажей могут увеличивать уровень маны, применяется только самый сильный.
Преимущество не дает вам права колдовать заклинания само по себе; для этого приобретаются Магические способности (с. B66). однако, если вы можете поднять уровень манны хотя бы для себя до Высокой или лучше, вы сможете колдовать не имея способностей – просто зная заклинания. (см. Мана, с. B235).
Способность имеет несколько неприятных эффектов: вы не можете иметь Сопротивление магии, и все маги получают бросок IQ+Магичность, чтобы обнаружить наличие у вас этой черты. В некоторых игровых мирах эта комбинация может вынудить вас скрываться от бесцеремонных магов.

Мастер должен держать эту способность под жестким контролем, поскольку она очень мощна и легко вносит дисбаланс в магические сеттинги.

===Особые улучшения.===

Воздействие на область (Area Effect): Ваша способность влияет на все в области, центрированной на вас. Первый уровень воздействия дает радиус 1 ярд, каждый следующий уровень удваивает этот радиус. (+50%/ур.)
Включаемая (Switchable): Вы можете включать или выключать способность по желанию. Это может лишить вражеских магов выгоды, или просто скрыться от них. +100%.

Избирательное (Discriminatory): Вы и ваши союзники получают лучший эффект, который ваша способность может произвести – самый высокий уровень маны для сотворения заклинаний, самый низкий – для сопротивления им, а враги в области – самый худший.
Модификатор включает Выключаемость и заменяет улучшение Избирательная область. +150%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Manaphobia (Magic, Common)</name>
	<name-loc>Боязнь магии (Манафобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы никогда не сможете научиться использовать магию и плохо относитесь к любому, кто умеет это. Каждый раз в присутствии магии делайте проверку на самоконтроль. Проверка делается с -3, если вы являетесь целью дружественной магии и -6, если являетесь целью враждебной. (Магия не обязательно должна быть настоящей, главное, чтобы вы в это верили!) -15 очков, если магия широко распространена, -10, если она известна, но является редкостью, -5, если "настоящая" магия неизвестна.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Manaphobia (Magic, Uncommon)</name>
	<name-loc>Боязнь магии (Манафобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы никогда не сможете научиться использовать магию и плохо относитесь к любому, кто умеет это. Каждый раз в присутствии магии делайте проверку на самоконтроль. Проверка делается с -3, если вы являетесь целью дружественной магии и -6, если являетесь целью враждебной. (Магия не обязательно должна быть настоящей, главное, чтобы вы в это верили!) -15 очков, если магия широко распространена, -10, если она известна, но является редкостью, -5, если "настоящая" магия неизвестна.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Manaphobia (Magic, Unknown)</name>
	<name-loc>Боязнь магии (Манафобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы никогда не сможете научиться использовать магию и плохо относитесь к любому, кто умеет это. Каждый раз в присутствии магии делайте проверку на самоконтроль. Проверка делается с -3, если вы являетесь целью дружественной магии и -6, если являетесь целью враждебной. (Магия не обязательно должна быть настоящей, главное, чтобы вы в это верили!) -15 очков, если магия широко распространена, -10, если она известна, но является редкостью, -5, если "настоящая" магия неизвестна.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Manic-Depressive</name>
		<name-loc>Маниакально-депрессивный психоз
</name-loc>
		<description-loc>Ваше настроение постоянно меняется. Вас бросает из детского энтузиазма в глубокую меланхолию и обратно. В начале каждой сессии делайте бросок 1d. При результате 1-3 вы находитесь в маниакальном состоянии, при результате 4-6 - в депрессивном. После этого бросайте 3d каждые пять часов игрового времени. 10 или меньше указывают на колебания настроения - в течение следующего часа оно изменится на противоположное. Вы останетесь в новом состоянии по крайней мере пять часов, после чего нужно снова бросить 3d.
В маниакальном состоянии вы получаете недостатки Самоуверенность (B148) и Трудоголик (B162). Вы дружелюбны, общительны и находитесь в возбужденном состоянии, что бы вы ни делали. В противоположном состоянии вы подвержены Хронической депрессии (B126). Вам не хочется ничего делать, кроме как валяться на кровати в полутемной комнате и хандрить. В это время ваш эффективный показатель самоконтроля равен Воле(Will).


Критическая ситуация тоже вызывает колебания настроения. При результате 10 или меньше на 3d, ваше настроение меняется на противоположное. Это может быть полезным (опасность вас встряхивает и вынуждает к действию) или наоборот (проблема повергает вас в депрессию и делает бесполезным).</description-loc>
		<type>Mental</type>
		<base_points>-20</base_points>
		<reference>B143</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Medium</name>
		<name-loc>Медиум</name-loc>
		<description-loc>Вы можете воспринимать духов и общаться с ними – в основном, с духами умерших. Вы их не видите, но знаете, что они поблизости. Вы можете разговаривать с любым духом поблизости, который понимает ваш язык. Также вы можете вызывать духов к себе – нет никаких гарантий, что они ответят на ваш призыв, но услышат они его точно. Заметьте, что эта черта не дает вам премии к реакции от духов, и любых способностей их контролировать.

===Новые особые улучшения===
Проявление (Manifestation): Ваше присутствие облегчает духам проявление, если они желают этого. Пока духи находятся в пределах ярда от вас, обладатели мета-черты Дух (с.В263) не платят по 1 ЕУ за секунду материализации, как этого требует ограничение Обычно включено. +100%. 
Универсальное (Universal): Вы можете общаться с любым духом, которого можете почувствовать, вне зависимости от знания языка. +50%.

Визуальное (Visual): Вы можете видеть духов, с которыми общаетесь, даже если они обычно невидимы. +50%.

===Новое особое ограничение===
В большинстве сеттингов использование этого преимущества требует особого ритуала или сеанса. Если это так и в вашем мире, добавляется модификатор Необходим подготовка (с.В114). Другим распространенным ограничением является:

Специализированное (Specialized):
Ваша способность работает только с одним видом духов. Возможные варианты – ангелы, демоны,
призраки, элементали, фейри, и
т.д. -50%.
</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Manifestation</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P60</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Universal</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P60</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Visual</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P60</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P60</reference>
			<notes>@Класс духов@</notes>
		</modifier>
		<reference>B68</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Megalomania</name>
		<name-loc>Мания величия 
</name-loc>
		<description-loc>Вы считаете себя сверхчеловеком, избранным, которому суждено достичь великой цели или стать выдающимся завоевателем. Вы должны поставить перед собой грандиозную цель (чаще всего завоевание или некую фантастическую задачу) и любой ценой добиваться ее выполнения.
Вы можете привлечь последователей, наделенных Фанатизмом, но кроме них никто не будет слушать рассказы о вашем величии и грандиозных планах. Молодые или наивные люди, а также фанатики в поисках нового объекта веры реагируют на вас с +2, остальные - с -2.
Этот недостаток больше подходит для NPC, чем для игровых персонажей.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Metabolism Control</name>
	<name-loc>Контроль метаболизма</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Спячка (Hybernation)</name>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B68</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Maestry</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>P60</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B68</reference>
	<description-loc>Вы можете контролировать обычно непроизвольные биологические функции вроде кровотока, сердцебиения, пищеварение и дыхание. Каждый уровень преимущества дает вам +1 на любые броски НТ, которые могут получить выгоды от него (на усмотрение Мастера), включая броски кровотечения (см. Кровотечение, с. B420) и восстановления от ядов и болезней.
Вы также можете впадать в смертоподобный транс; врач, незнакомый с особенным вашим метаболизмом, должен победить в быстром состязании (Диагностика против НТ + уровень контроля), чтобы узнать, что персонаж на самом деле не мертв. Каждый уровень Контроля метаболизма во время транса уменьшает потребность в кислороде на 10% и удваивает время, которое вы можете безопасно прожить без еды или воды. В этом состоянии персонаж совершенно не сознает, что творится вокруг, но автоматически просыпается, если получает ранение. Вы также можете установить ментальный «будильник», который разбудит вас по прошествии какого-то времени. 

Способность несовместима с мета-чертой Машина (с. B263).

===Особые ограничения.===
Спячка (Hybernation): вы можете только впадать в транс, и не получаете бонуса к НТ. Также вы автоматически впадаете в спячку при возникновении определенных условий (чрезвычайный холод, жара, жажда и прочее – обговорите с мастером) (для избежания этого – бросок Воли(Will)). Впадение в спячку по желанию – чек Воли(Will)-4 каждый час. Вы не можете устанавливать будильник точно – продолжительность умножается на (2d+3)/10. -60%.

===Новое особое улучшение===
Мастер (Mastery): Вы можете мгновенно и очень точно изменять свой метаболизм, помогая организму справится с неожиданными нагрузками. Пока вы находитесь в сознании, уровень Контроля метаболизма добавляется к любому броску ЗД! +40%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Microscopic Vision</name>
		<name-loc>Микроскопическое зрение</name-loc>
		<description-loc>Вы можете видеть объекты, невидимые без увеличительного стекла или микроскопа. Каждый уровень добавляет увеличение на порядок: за 5 очков – 10-кратное увеличение, 10 очков – 100-кратное, и так далее. Увеличение работает только на вещи менее 1 дюйма.
Первого уровня достаточно для обычного судебного исследования. Уровень 3 (1000-кратное увеличение) примерно равен лучшим оптическим микроскопам. Уровень 5 (100,000х) – электронный микроскоп, способный разглядеть вирусы. Уровень 6 (1,000,000х) – атомные микроскопы, различающие атомарную структуру объектов.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B68</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Mimicry</name>
		<name-loc>Подражание звукам</name-loc>
		<description-loc>Вы можете повторить любой простой звук (сирену, выстрел), прослушав его в течение секунды и сделав успешный бросок IQ. Голоса воспроизводить сложнее – их слушать надо не менее 10 секунд.
Способность не дает возможности оглушать других громкими звуками, или колдовать заклинания, произнося их словесную формулу – эти способности приобретаются отдельно.

===Новое особое улучшение ===
Память на звуки (Voice Library): Вы никогда не забываете звуков, которые сумели успешно сымитировать. Контроль каталога – забота игрока. Для воспоминания звука, достаточно выполнить маневр концентрации и сделать бросок ИН. +50%
</description-loc>
		<type>Mental, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Voice Library</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P61</reference>
		</modifier>
		<reference>B68</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Mind Control</name>
		<name-loc>Контроль разума</name-loc>
		<description-loc>Вы можете ментально контролировать тех, кого вы видите или касаетесь. Использование – концентрация 1 секунду и быстрое состязание вашего IQ против Воли(Will) субъекта.
Модификаторы: модификаторы дальности; -1 за каждого уже подконтрольного; +2 за минутную концентрацию; +4 за концентрацию в течение часа.
При вашей победе жертва подчиняется всем вашим командам, пока вы ее не освободите (по эффекту идентично недостатку Перепрограммируемый). Ваш контроль длится, пока не прервется Концентрация. После прекращения концентрации контроль продолжится еще по 1 минуте за каждое очко выигрыша в состязании (может быть увеличено Увеличенной продолжительностью, с. B105). В случае выхода вас из строя или попытки заставить жертву сделать что-то против ее принципов (нанести вред любимому или совершить самоубийство) – дополнительное состязание, в случае успеха жертвы она освобождается от контроля. Бросок этот делается в «момент истины» - вы можете заставить жертву встать на краю пропасти, и она не будет делать бросок, пока вы не прикажете прыгнуть. 
При провале контроля вы не можете пытаться взять эту же цель под контроль в течение суток, и она чувствует ментальное принуждение от вас. При критическом провале вы теряете контроль над всеми вашими подконтрольными существами.

Контроль разума часто комплектуется всевозможными модификаторами: Доступность (только на противоположный пол), Воздействие на чувства (гипнотичные голоса, взгляд и т.д.), и др. Он может даже обладать модификаторами атаки – Проклятием (с. B106), например. Также вы можете приобредать модификаторы Кибернетический и Только кибернетический из Чтения разума.
===Новое особое улучшение===
 
Независимый (Independent): Ваш контроль разума не требует постоянного внимания – вы можете заниматься своими делами. Вы должны концентрироваться для установления контроля, но не получаете премии +2 или +4 за длительную концентрацию. Если жертва проваливает сопротивление, контроль сохраняется по 1 минуте за каждое очко проигрыша. Вы не можете продлять его. 
Контроль может прерваться только если вы пытаетесь принудить субъекта действовать против его принципов. Выведение вас из строя не лишит жертву контроля. Поскольку контакты разделены, вы не получаете штрафа -1 за каждого подконтрольного, и критический провал контроля одной жертвы не освобождает всех
остальных. +70%.

Внушение (Conditioning): вы можете изменять психику субъекта и внушать. Вы можете добавить или убрать любой обычный ментальный недостаток. Фальшивая память – Заблуждение, стирание памяти – Амнезия. Жертва должна быть под контролем, в сознании, и желать сотрудничества. Требуется еще один бросок Состязания, с -1 за каждые -5 очков цены недостатка. Вы можете заменять бросок IQ на навык Промывания мозгов (с. B182). Эффект длится по 1 дню за каждое очко успешности. При вашем критическом успехе эффект постоянен. Если эффект стал постоянным, ваш «пациент», освободившись от вашего прямого контроля, не дает штрафов при взятии под контроль других жертв. Помните, однако, что другие обладатели данной способности могут использовать ее для восстановления прежнего состояния жертвы. +50%.

Без памяти (No Memory): Жертва не помнит, что с ней было во время контроля. +10%.
===Особые ограничения.===

Только контроль эмоций (Emotion Control): Вы не можете контролировать действий субъекта – только его чувства. Что возможно сделать с таким ограничением – смотрите в описании умения Внушение эмоций (c.B192). Взаимоисключаемо с Только обработка и Внушение. -50%.
Внушение (Suggestion): Вы не можете управлять действиями субъекта, но можете только внушить общее направление действий – как в умении Внушение (c.B191). Взаимоисключаемо с Только обработка и Только контроль эмоций. -40%. 
Только внушение (Conditioning Only): вы не можете использовать обычный контроль разума – только внушение (см.выше). Нежелающие сотрудничать должны быть нейтрализованы. -50%.
Кукла (Puppet): ваша жертва полностью безинициативна – получает Рабский менталитет. -40%.
Телепатическая (Telepathic). Ваша способность – часть псионической силы Телепатии. -10%.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>50</base_points>
		<modifier version="1" enabled="no">
			<name>Внушение (Conditioning)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Без памяти (No Memory)</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только внушение (Conditioning Only)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Кукла (Puppet)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Телепатическая (Telepathic)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Independent</name>
			<cost type="percentage">70</cost>
			<affects>total</affects>
			<reference>P61</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Emotion Control</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P61</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>One Emotion Only</name>
			<cost type="percentage">-80</cost>
			<affects>total</affects>
			<reference>H17</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Suggestion</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P61</reference>
		</modifier>
		<reference>B68</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Mind Probe</name>
	<name-loc>Зондирование разума</name-loc>
	<base_points>20</base_points>
	<modifier version="1" enabled="no">
		<name>Кибернетическое (Cybernetic)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Восприятие чувств (Sensory)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Универсальное (Universal)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только кибернетическое (Cybernetic Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Расовое (Racial)</name>
		<notes>@Расса@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только восприятие чувств (Sensory Only)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Телекоммуникация (Telecommunication)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Телепатическая (Telepathic)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Invasive</name>
		<cost type="percentage">75</cost>
		<affects>total</affects>
		<reference>P62</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Memory Bank</name>
		<notes>Количество слепков = IQ</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P62</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Memory Bank</name>
		<notes>Количество слепков неограничено</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>P62</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B69</reference>
	<description-loc>Вы можете проводить глубокое зондирование разума. Вы можете вынудить субъекта дать несложный ответ на один любой вопрос. Для зондирования требуется коснуться или успешно выполнить Чтение Разума. Вы также должны знать язык субъекта.
Использование требует секундной концентрации и быстрого состязания IQ (или навыка допроса, что выше) против Воли(Will) субъекта. Ответом будет то, что жертва считает правдой – если она не знает, вы узнаете об этом. Повторение этого вопроса в течение часа наложит штраф -2 за каждую попытку. При критическом провале вы не можете зондировать эту персону в течение суток. Каждый вопрос требует отдельного зондирования.

К этому преимуществу могут применяться почти любые модификаторы Чтения разума (см. ниже):

===Особые улучшения.===

Кибернетическое (Cybernetic): Вы можете читать мысли существ с Цифровым разумом, включая все компьютеры. Штраф к броску IQ, равный Сложности. Неразумные компьютеры не сопротивляются. +50%.

Восприятие чувств (Sensory): вы также можете подключаться к чувствам субъекта – и переживать все то, что он испытывает. +20%.

Универсальное (Universal): вы автоматически понимаете мысли даже неразумных субъектов и не зная языков. +50%.

===Особые ограничения.===

Только кибернетическое (Cybernetic Only): Вы можете читать только мысли существ с Цифровым разумом. -50%.

Расовое (Racial): Ваша способность работает только на существах вашей или очень близкой расы (люди и эльфы). -20%.

Только восприятие чувств (Sensory Only): Вы не можете читать мысли вообще, воспринимаете только чувства. -20%.
Телекоммуникация (Telecommunication): ваша способность работает только на тех, кто подключен к вам Телекоммуникацией. -20%.

===Новые особые улучшения===
Инвазивное (Invasive): только для Зондирования разума. Ваша способность работает как ментальное вторжение, а не обычный допрос. Если вы побеждаете в первом состязании, ментальная защита
субъекта пробита и вы получаете полный доступ к его памяти. Ограничение на один вопрос в секунду сохраняется, но получение ответа – простой, не состязательный бросок ИН, Допроса, Психологии – или Ясный сон, если субъект спит. +75%.
Снимок памяти (Memory Bank): только для зондирования разума. Вы можете сохранить точный «снимок» разума субъекта. Это требует обычного быстрого состязания зондирования, но занимает час. Позднее броском ИН вы можете узнать любую информацию, известную субъекту на момент зондирования – как если бы вы зондировали его, или о его личности (снимает все штрафы за незнание его поведения для бросков Актерского мастерства). Вы можете стереть «снимок» в любой момент. +100% за хранилище, ограниченное значением ИН, +150% за неограниченную емкость.
Множественный контакт (Multiple Contacts): только для Чтения разума. Вы можете поддерживать несколько контактов одновременно. Каждый новый контакт устанавливается с кумулятивным штрафом -1 за каждый после первого. Вы можете свободно переключаться между установленными контактами, но Чтение мыслей
требует концентрации. +50%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Mind Reading</name>
		<name-loc>Чтение разума</name-loc>
		<description-loc>Вы можете просматривать поверхностные мысли других. Вы должны видеть или касаться субъекта. Требуется секундная концентрация и быстрое состязание IQ против воли субъекта. Применяются модификаторы дальности до цели.
При успехе вы можете слышать все, что субъект говорит или проговаривает и активные мысли – как голос в голове. Восприятие идет со скоростью речи. Если вы не понимаете языка, или субъект неразумен, вы получаете чувства, изображения и общие эмоции.
Вы можете поддерживать чтение разума сколько угодно без необходимости в дальнейшей концентрации. Переключение на другую цель требует разрыва связи с текущей. Чтение нескольких субъектов невозможно без Разделенного сознания (с. B43).
При провале вы получаете -2 на каждую попытку прочитать мысли этого субъекта в течение часа, при критическом провале вы не можете читать его мысли в течение 24 часов.
Чтение разума обычно имеет псионическую природу, но также может быть и магической, божественной и даже технологической, и какой угодно еще.

Ограничение «Основанное на чувствах» обычно. Если вы берете Основанное на слухе, вы можете читать мысли только тех, кого вы можете услышать, но можете работать как детектор лжи или универсальный переводчик.

===Особые улучшения.===

Кибернетическое (Cybernetic): Вы можете читать мысли существ с Цифровым разумом, включая все компьютеры. Штраф к броску IQ, равный Сложности. Неразумные компьютеры не сопротивляются – вы просто делаете бросок против IQ-Сложность. +50%.

Восприятие чувств (Sensory): вы также можете подключаться к чувствам субъекта – и переживать все то, что он испытывает. Если жертву пытают, она теряет сознание или убита – Мастер может потребовать от вас броска Воли(Will), чтобы избежать оглушения – или даже броска Страха! +20%.

Универсальное (Universal): вы автоматически понимаете мысли даже неразумных субъектов и не зная языков. +50%.

===Особые ограничения.===

Только кибернетическое (Cybernetic Only): Вы можете читать только мысли существ с Цифровым разумом. -50%.

Расовое (Racial): Ваша способность работает только на существах вашей или очень близкой расы (люди и эльфы). -20%.

Только восприятие чувств (Sensory Only): Вы не можете читать мысли вообще, воспринимаете только чувства. -20%.
Телекоммуникация (Telecommunication): ваша способность работает только на тех, кто подключен к вам Телекоммуникацией. -20%.
Телепатическая (telepathic): Ваша способность – часть псионической силы Телепатии. -10%.

===Новые особые улучшения===
Инвазивное (Invasive): только для Зондирования разума. Ваша способность работает как ментальное вторжение, а не обычный допрос. Если вы побеждаете в первом состязании, ментальная защита
субъекта пробита и вы получаете полный доступ к его памяти. Ограничение на один вопрос в секунду сохраняется, но получение ответа – простой, не состязательный бросок ИН, Допроса, Психологии – или Ясный сон, если субъект спит. +75%.
Снимок памяти (Memory Bank): только для зондирования разума. Вы можете сохранить точный «снимок» разума субъекта. Это требует обычного быстрого состязания зондирования, но занимает час. Позднее броском ИН вы можете узнать любую информацию, известную субъекту на момент
зондирования – как если бы вы зондировали его, или о его личности (снимает все штрафы за незнание его поведения для бросков Актерского мастерства). Вы можете стереть «снимок» в любой момент. +100% за хранилище, ограниченное значением ИН, +150% за неограниченную емкость.
Множественный контакт (Multiple Contacts): только для Чтения разума. Вы можете поддерживать несколько контактов одновременно. Каждый новый контакт устанавливается с кумулятивным штрафом -1 за каждый после первого. Вы можете свободно переключаться между установленными контактами, но Чтение мыслей
требует концентрации. +50%.
</description-loc>
		<type>Mental, Exotic</type>
		<base_points>30</base_points>
		<modifier version="1" enabled="no">
			<name>Кибернетическое (Cybernetic)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Восприятие чувств (Sensory)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Универсальное (Universal)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только кибернетическое (Cybernetic Only)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Расовое (Racial)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B70</reference>
			<notes>@Расса@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только восприятие чувств (Sensory Only)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Телекоммуникация (Telecommunication)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Телепатическая (Telepathic)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Multiple Contacts</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P62</reference>
		</modifier>
		<reference>B69</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Mind Shield</name>
		<name-loc>Ментальный щит</name-loc>
		<description-loc>У вас есть ментальный щит, который предупреждает и защищает вас от ментальных атак. Уровень Ментального щита прибавляется к броску IQ или Воли(Will), когда вы сопротивляетесь воздействию способностей с ограничением Телепатическое, или заклинаний из школ Общения и понимания (с. B245) или Контроля разума (с. B250).
Также щит мешает попыткам найти ваш разум с помощью магии или псионики. Такие способности должны выиграть быстрое состязание против вашей Воли(Will) + уровень Ментального щита.

Вы можете по желанию убирать свой щит или уменьшать его интенсивность – например, чтобы позволить другу прочитать ваши мысли. Снятие и постановка щита – свободное действие, но должно производиться в начале вашего хода. Ментальный щит также остается с прежней интенсивностью и во время сна, и когда вы находитесь в бессознательном состоянии.
===Особые ограничения.===

Кибернетический (Cybernetic): Ваш Щит защищает от компьютерных атак – например, «цифровой» формы Переселения или «кибернетического» вида Чтения или Зондирования мыслей. Ограничение доступно только имеющим Цифровой разум (с. B48). -50%.
Телепатическая (telepathic): Ваша способность – часть псионической силы Телепатии. (-10%):

===Новое особое ограничение===
Ограниченное (Limited): ваш Ментальный щит действует только против определенных ментальных атак. Целый источник силы (божественный, магический, псионический, духовный и т.д.) стоит -50%; определенный фокус, сила или школа магии (Телепатия или заклинания Контроля разума, к примеру) стоят -75%.
</description-loc>
		<type>Mental, Exotic</type>
		<levels>1</levels>
		<points_per_level>4</points_per_level>
		<modifier version="1" enabled="no">
			<name>Кибернетический (Cybernetic)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Телепатическая (Telepathic)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B70</reference>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P62</reference>
			<notes>@Источник@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-75</cost>
			<affects>total</affects>
			<reference>P62</reference>
			<notes>@Сила/Школа/Фокус@</notes>
		</modifier>
		<reference>B70</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Mindlink</name>
	<name-loc>Ментальная связь</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Одна персона</name>
		<notes>@Кто@</notes>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>2-9 людей</name>
		<notes>@Кто@</notes>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>10-99 людей</name>
		<notes>@Кто@</notes>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>100-999 людей</name>
		<notes>@Кто@</notes>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1000-9999 людей</name>
		<notes>@Кто@</notes>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>10000-99999 людей</name>
		<notes>@Кто@</notes>
		<cost type="points">50</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Широковещание (Broadcast)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Кибернетическое (Cybernetic)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Восприятие чувств (Sensory)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Универсальное (Universal)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B69</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только кибернетическое (Cybernetic Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Расовое (Racial)</name>
		<notes>@Расса@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только восприятие чувств (Sensory Only)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Телекоммуникация (Telecommunication)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Телепатическая (Telepathic)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Видео (Video)</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неопределенное (Vague)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B70</reference>
	<description-loc>У вас есть постоянная телепатрическая настройка на кого-то – часто это близнец, любимый, член семьи и пр. Все ваши попытки соединения с ним с помощью Отправки мыслей, Чтения разума или Телекоммуникации автоматически успешны, если он не сопротивляется. Связь не работает на межзвездных расстояниях (свыше 0,1 световых лет), на разных планах и параллелльных мирах.
Связь разумов стоит 5 очков за одну персону, 10 за 2-9 человек, 20 за 10-99 человек, 30 очков за 100-999 человек, и так далее – по +10 очков за десятикратное увеличение количества людей.
Как правило, мастер может разрешить игрокам покупку Связи только для Союзников, Контактов, Иждивенцев, Дублей, и других игроков (с их разрешения).
Модификаторы позволяются те же, что и для Чтения разума и Отправки мыслей.</description-loc>
</advantage>
	<advantage version="2">
		<name>Minor Addiction</name>
		<name-loc>Мелкое пристрастие</name-loc>
		<description-loc>
Вы можете взять Пристрастие (B122) на уровне причуды, если вещество вызывает психологическое привыкание и стоит 0 очков согласно классификации, изложенной в Пристрастии.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Вещество@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Minor Addiction</name>
		<name-loc>Мелкое пристрастие</name-loc>
		<description-loc>
Вы можете взять Пристрастие (B122) на уровне причуды, если вещество вызывает психологическое привыкание и стоит 0 очков согласно классификации, изложенной в Пристрастии.</description-loc>
		<type>Physical</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<notes>@Вещество@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Minor Handicap</name>
		<name-loc>Мелкие физические недостатки</name-loc>
		<description-loc>
Вы можете взять большинство обычных физических недостатков на уровне причуды; например, можно взять мягкую форму Хромоты, чтобы описать «больное колено». Эти недостатки всплывают редко, но когда это происходит, доставляют изрядное неудобство. В этом случае мастер может дать вам штраф в -1 к подходящему атрибуту, умению, или проверке на реакцию в ситуациях, где это имеет значение.</description-loc>
		<type>Physical</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<notes>@Часть тела@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Miserliness</name>
		<name-loc>Скупость 
</name-loc>
		<description-loc>Вы озабочены тем, как бы сохранить свои богатства. Вы всегда стремитесь заключить наиболее выгодную сделку. Каждый раз, когда нужно потратить деньги, сделайте проверку на самоконтроль (с -5 и больше, если речь идет о крупной сумме - на усмотрение мастера). При провале вы отказываетесь тратить деньги, но если это все-таки необходимо, вы должны нещадно торговаться и непрерывно жаловаться на расходы. Заметьте, что вы можете одновременно взять и Жадность (B137), и Скупость!</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Missing Digit (Finger)</name>
		<name-loc>Нет пальца 
</name-loc>
		<description-loc>У вас нет одного пальца на руке.


Нет пальца: Дает -1 к DX только для этой руки. -2 очка.
Нет большого пальца: Дает -5 к DX только для этой руки. -5 очков.</description-loc>
		<type>Physical</type>
		<base_points>-2</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Missing Digit (Thumb)</name>
		<name-loc>Нет пальца (Большого)</name-loc>
		<description-loc>У вас нет одного пальца на руке.


Нет пальца: Дает -1 к DX только для этой руки. -2 очка.
Нет большого пальца: Дает -5 к DX только для этой руки. -5 очков.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Mistaken Identity</name>
		<name-loc>Ошибочная внешность</name-loc>
		<description-loc>Вас часто принимают за кого-то другого. Друзья вашего "двойника" будут подходить и сообщать вам то, чего вы вовсе не хотите знать, а его знакомые будут действовать с вами как с ним, вызывая удивление и раздражение. Его враги будут охотиться и за вами тоже! В конце концов вы можете разрешить эту ситуацию, но не без некоторых усилий.
Если все представители вашей расы выглядят одинаково, то ваша раса обладает необычной особенностью (см. Особенности и табу, B261), но вы не получаете Ошибочной внешности.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B21</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Modular Abilities (Chip Slots)</name>
		<name-loc>Изменяемые способности  (Ячейки чипов )</name-loc>
		<description-loc>Вы имеете резерв очков персонажа, который можете использовать на разные нужды по желанию.
Вы можете временно перераспределять их, добавляя навыки или ментальные преимущества, или улучшать их, если они у вас уже есть. Когда вы перераспределяете очки, то теряете все способности, на которые эти очки ранее были пущены.

Преимущество идет Ячейками – каждый слот может вместить только один навык или преимущество. Каждая ячейка имеет базовую стоимость и плюс цену за очко персонажа в этом резерве. Обе цены зависят от формы Изменяемых способностей.

Компьютерный разум (Computer Brain): Ваши способности – программы. Мастер определяет, существует ли программа для нужной вам способности. Если вы имеете преимущество Телекоммуникация (с. B91), вы можете скачивать другие программы – обычно требует секунды за очко персонажа. Иногда за программы приходится платить – обычно по $100 за очко персонажа. Цена за слот – 6 + 4 за очко навыка.

Ячейки чипов (Chip Slots): аналогично программам, но поставляются они на микросхемах, которые вы должны подключать в разъем – обычно в черепе. Установка и удаление чипа занимает три секунды. Обычно чипы имеют незначительный вес, но стоят от $100 до $1000 за очко. Цена за слот – 5 + 3 за очко способности.

Супер-запоминание (Super-Memorization): вы получаете новые способности быстрым обучением с подходящего носителя (книги, фильм, магнитная лента и т.д.) – обычно по секунде за очко персонажа. Вы можете «забыть» запомненную способность мгновенно. Цена за слот – 5 + 3 за каждое очко способности.
Абсолютные силы (Cosmic Power):. Вы просто желаете новых способностей – и они появляются. Вы имеете только один слот, но можете перечислять очки как угодно – 10 очков за очко способности.
=====Пример: Алекс покупает две Ячейки чипов по базовой цене 5/слот. Это стоит 10 очков. Он хочет, чтобы один из слотов мог содержать способность на 2 очка (платит 6 очков), а другой – на 5 (платит 15 очков). Итоговая стоимость – 31 очко персонажа. Алекс записывает на листе персонажа «Ячейки чипов 2 (2, 5)». Алекс может добывать используемые чипы как угодно, но не платит очков персонажа за них.=====

Для увеличения времени перераспределения очков используйте Требует подготовки, а для отражения забывания способности после использования – Ограниченное использование.

===Особые улучшения.===

Физическое (Physical): вы можете приобретать физические преимущества (+50%) или и ментальные и физические (+100%):

Только заклинания (Spells Only): Вы можете запоминать только магические заклинания, обычно из книги. (-20%)
Виртуальное (Virtual): Полученные способности могут работать только в одной ограниченной реальности – в виртуале, астрале и т.д. -50%.</description-loc>
		<type>Mental, Exotic</type>
		<levels>1</levels>
		<base_points>5</base_points>
		<points_per_level>3</points_per_level>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Modular Abilities (Computer Brain)</name>
		<name-loc>Изменяемые способности  (Компьютерный разум)</name-loc>
		<description-loc>Вы имеете резерв очков персонажа, который можете использовать на разные нужды по желанию.
Вы можете временно перераспределять их, добавляя навыки или ментальные преимущества, или улучшать их, если они у вас уже есть. Когда вы перераспределяете очки, то теряете все способности, на которые эти очки ранее были пущены.

Преимущество идет Ячейками – каждый слот может вместить только один навык или преимущество. Каждая ячейка имеет базовую стоимость и плюс цену за очко персонажа в этом резерве. Обе цены зависят от формы Изменяемых способностей.

Компьютерный разум (Computer Brain): Ваши способности – программы. Мастер определяет, существует ли программа для нужной вам способности. Если вы имеете преимущество Телекоммуникация (с. B91), вы можете скачивать другие программы – обычно требует секунды за очко персонажа. Иногда за программы приходится платить – обычно по $100 за очко персонажа. Цена за слот – 6 + 4 за очко навыка.

Ячейки чипов (Chip Slots): аналогично программам, но поставляются они на микросхемах, которые вы должны подключать в разъем – обычно в черепе. Установка и удаление чипа занимает три секунды. Обычно чипы имеют незначительный вес, но стоят от $100 до $1000 за очко. Цена за слот – 5 + 3 за очко способности.

Супер-запоминание (Super-Memorization): вы получаете новые способности быстрым обучением с подходящего носителя (книги, фильм, магнитная лента и т.д.) – обычно по секунде за очко персонажа. Вы можете «забыть» запомненную способность мгновенно. Цена за слот – 5 + 3 за каждое очко способности.
Абсолютные силы (Cosmic Power):. Вы просто желаете новых способностей – и они появляются. Вы имеете только один слот, но можете перечислять очки как угодно – 10 очков за очко способности.
=====Пример: Алекс покупает две Ячейки чипов по базовой цене 5/слот. Это стоит 10 очков. Он хочет, чтобы один из слотов мог содержать способность на 2 очка (платит 6 очков), а другой – на 5 (платит 15 очков). Итоговая стоимость – 31 очко персонажа. Алекс записывает на листе персонажа «Ячейки чипов 2 (2, 5)». Алекс может добывать используемые чипы как угодно, но не платит очков персонажа за них.=====

Для увеличения времени перераспределения очков используйте Требует подготовки, а для отражения забывания способности после использования – Ограниченное использование.
Особые улучшения.

Физическое (Physical): вы можете приобретать физические преимущества (+50%) или и ментальные и физические (+100%):

Только заклинания (Spells Only): Вы можете запоминать только магические заклинания, обычно из книги. (-20%)
Виртуальное (Virtual): Полученные способности могут работать только в одной ограниченной реальности – в виртуале, астрале и т.д. -50%.</description-loc>
		<type>Mental, Exotic</type>
		<levels>1</levels>
		<base_points>6</base_points>
		<points_per_level>4</points_per_level>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Modular Abilities (Cosmic Power)</name>
		<name-loc>Изменяемые способности  (Абсолютные силы)</name-loc>
		<description-loc>Вы имеете резерв очков персонажа, который можете использовать на разные нужды по желанию.
Вы можете временно перераспределять их, добавляя навыки или ментальные преимущества, или улучшать их, если они у вас уже есть. Когда вы перераспределяете очки, то теряете все способности, на которые эти очки ранее были пущены.

Преимущество идет Ячейками – каждый слот может вместить только один навык или преимущество. Каждая ячейка имеет базовую стоимость и плюс цену за очко персонажа в этом резерве. Обе цены зависят от формы Изменяемых способностей.

Компьютерный разум (Computer Brain): Ваши способности – программы. Мастер определяет, существует ли программа для нужной вам способности. Если вы имеете преимущество Телекоммуникация (с. B91), вы можете скачивать другие программы – обычно требует секунды за очко персонажа. Иногда за программы приходится платить – обычно по $100 за очко персонажа. Цена за слот – 6 + 4 за очко навыка.

Ячейки чипов (Chip Slots): аналогично программам, но поставляются они на микросхемах, которые вы должны подключать в разъем – обычно в черепе. Установка и удаление чипа занимает три секунды. Обычно чипы имеют незначительный вес, но стоят от $100 до $1000 за очко. Цена за слот – 5 + 3 за очко способности.

Супер-запоминание (Super-Memorization): вы получаете новые способности быстрым обучением с подходящего носителя (книги, фильм, магнитная лента и т.д.) – обычно по секунде за очко персонажа. Вы можете «забыть» запомненную способность мгновенно. Цена за слот – 5 + 3 за каждое очко способности.
Абсолютные силы (Cosmic Power):. Вы просто желаете новых способностей – и они появляются. Вы имеете только один слот, но можете перечислять очки как угодно – 10 очков за очко способности.
=====Пример: Алекс покупает две Ячейки чипов по базовой цене 5/слот. Это стоит 10 очков. Он хочет, чтобы один из слотов мог содержать способность на 2 очка (платит 6 очков), а другой – на 5 (платит 15 очков). Итоговая стоимость – 31 очко персонажа. Алекс записывает на листе персонажа «Ячейки чипов 2 (2, 5)». Алекс может добывать используемые чипы как угодно, но не платит очков персонажа за них.=====

Для увеличения времени перераспределения очков используйте Требует подготовки, а для отражения забывания способности после использования – Ограниченное использование.

===Особые улучшения.===

Физическое (Physical): вы можете приобретать физические преимущества (+50%) или и ментальные и физические (+100%):

Только заклинания (Spells Only): Вы можете запоминать только магические заклинания, обычно из книги. (-20%)
Виртуальное (Virtual): Полученные способности могут работать только в одной ограниченной реальности – в виртуале, астрале и т.д. -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<modifier version="1" enabled="no">
			<name>Только физическое (Physical Only)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Физическое (Physical)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только заклинания (Spells Only)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Виртуальное (Virtual)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B71</reference>
			<notes>@Реальность@</notes>
		</modifier>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Modular Abilities (Super-Memorization)</name>
		<name-loc>Изменяемые способности  (Супер-запоминание)</name-loc>
		<description-loc>Вы имеете резерв очков персонажа, который можете использовать на разные нужды по желанию.
Вы можете временно перераспределять их, добавляя навыки или ментальные преимущества, или улучшать их, если они у вас уже есть. Когда вы перераспределяете очки, то теряете все способности, на которые эти очки ранее были пущены.

Преимущество идет Ячейками – каждый слот может вместить только один навык или преимущество. Каждая ячейка имеет базовую стоимость и плюс цену за очко персонажа в этом резерве. Обе цены зависят от формы Изменяемых способностей.

Компьютерный разум (Computer Brain): Ваши способности – программы. Мастер определяет, существует ли программа для нужной вам способности. Если вы имеете преимущество Телекоммуникация (с. B91), вы можете скачивать другие программы – обычно требует секунды за очко персонажа. Иногда за программы приходится платить – обычно по $100 за очко персонажа. Цена за слот – 6 + 4 за очко навыка.

Ячейки чипов (Chip Slots): аналогично программам, но поставляются они на микросхемах, которые вы должны подключать в разъем – обычно в черепе. Установка и удаление чипа занимает три секунды. Обычно чипы имеют незначительный вес, но стоят от $100 до $1000 за очко. Цена за слот – 5 + 3 за очко способности.

Супер-запоминание (Super-Memorization): вы получаете новые способности быстрым обучением с подходящего носителя (книги, фильм, магнитная лента и т.д.) – обычно по секунде за очко персонажа. Вы можете «забыть» запомненную способность мгновенно. Цена за слот – 5 + 3 за каждое очко способности.
Абсолютные силы (Cosmic Power):. Вы просто желаете новых способностей – и они появляются. Вы имеете только один слот, но можете перечислять очки как угодно – 10 очков за очко способности.
=====Пример: Алекс покупает две Ячейки чипов по базовой цене 5/слот. Это стоит 10 очков. Он хочет, чтобы один из слотов мог содержать способность на 2 очка (платит 6 очков), а другой – на 5 (платит 15 очков). Итоговая стоимость – 31 очко персонажа. Алекс записывает на листе персонажа «Ячейки чипов 2 (2, 5)». Алекс может добывать используемые чипы как угодно, но не платит очков персонажа за них.=====

Для увеличения времени перераспределения очков используйте Требует подготовки, а для отражения забывания способности после использования – Ограниченное использование.

===Особые улучшения.===

Физическое (Physical): вы можете приобретать физические преимущества (+50%) или и ментальные и физические (+100%):

Только заклинания (Spells Only): Вы можете запоминать только магические заклинания, обычно из книги. (-20%)
Виртуальное (Virtual): Полученные способности могут работать только в одной ограниченной реальности – в виртуале, астрале и т.д. -50%.</description-loc>
		<type>Mental, Exotic</type>
		<levels>1</levels>
		<base_points>5</base_points>
		<points_per_level>3</points_per_level>
		<modifier version="1" enabled="no">
			<name>Только заклинания (Spells Only)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B71</reference>
		</modifier>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Motion Sickness</name>
		<name-loc>Морская болезнь 
</name-loc>
		<description-loc>Вы плохо себя чувствуете, находясь на движущемся транспорте - в автомобиле, в поезде, на воздушном шаре, на морском судне или на космическом корабле. Вы также не способны научиться управлять ими. Попав на борт такой машины, сделайте проверку HT. При провале вас тошнит, и вы получаете -5 ко всем проверкам DX, IQ и умений до конца путешествия. При удаче вы просто плохо себя чувствуете и получаете -2 к DX, IQ и умениям. При долгом путешествии делайте проверку ежедневно.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="no">
				<name compare="is">submariner</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">submarine</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">spacer</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">shiphandling</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">seamanship</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="contains">crewman</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">boating</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">airshipman</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="contains">driving</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="contains">piloting</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Mundane Background</name>
		<name-loc>Мирское происхождение 
</name-loc>
		<description-loc>У вас полностью отсутствует опыт общения со сверхъестественным и потусторонним. В начале игры вы можете владеть только "обыденными" умениями и снаряжением, но не заклинаниями, "киношными" (cinematic) умениями, Тайным знанием или Оккультизмом. У вас могут быть сверхъестественные преимущества, но вы не можете их применять или научиться умениям, позволяющим это. Вы даже не подозреваете об этих способностях, разве что время от времени мечтаете о них. Вы должны выкупить этот недостаток, если хотите использовать сверхъестественные способности или научиться любому связанному с ними умению.
Мирское происхождение допустимо только в сеттингах со сверхъестественными или потусторонними элементами, а не в обычном мире.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Mysophobia (Dirt)</name>
	<name-loc>Боязнь грязи (Мизофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Вы до смерти боитесь инфекции или просто грязи и мусора. Делайте проверку на самоконтроль всякий раз, когда нужно сделать какую-то грязную работу. Пенальти составит -5, если вам приходится есть непривычную пищу. Вы должны быть настолько "привередливым", насколько это возможно. -10 очков.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Necrophobia (Death)</name>
	<name-loc>Боязнь смерти и мертвых (Некрофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Вы боитесь проявлений смерти. Сделайте проверку самоконтроля в присутствии любого мертвого тела (части человеческих тел учитываются, а трупы животных - нет). Пенальти составит -4, если вы знали этого человека, и -6, если тело любым образом противоестественно оживлено. Призрак (или то, что им кажется) также даст пенальти -6. -10 очков.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Nervous Stomach</name>
		<name-loc>Нежный желудок</name-loc>
		<description-loc>
Вы получаете -3 к проверкам HT с целью избежать недомогания (обычно в форме пенальти к атрибуту или в виде рвоты) после обильной или острой пищи, сильной выпивки, и т.д.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Neurological Disorder (Crippling)</name>
		<name-loc>Нервное расстройство (Калечащие)</name-loc>
		<description-loc>Вы страдаете от одной из форм нервного расстройства, которое приводит к дрожи, непроизвольным движениям, нервному тику и т.п. Стоимость зависит от тяжести расстройства.


Легкое: Ваше состояние очевидно любому, кто видит вас хотя бы несколько секунд. Вы получаете -2, занимаясь работой, где необходимы точные движения (см. Высокая ловкость рук, B59), а ее выполнение занимает вдвое больше времени. Вы получаете -2 к социальным умениям, таким как Артистизм, Лидерство, Выступление, Публичное выступление и Сексапильность, в любой ситуации, где ваш недостаток может быть замечен (на усмотрение мастера). -15 очков
Тяжелое: Вам трудно жить в обществе. Вы получаете -4 к задачам, где нужны точные движения, а их выполнение занимает в четыре раза больше времени. Ваши DX и Базовое передвижение не могут превышать средних значений для расы (DX 10 и Передвижение 5 для людей). Вы получаете -4 к социальным умениям, если ваш недостаток замечен. -35 очков.
Критическое: Вы практически не способны жить в обществе. Вы получаете -6 к действиям, требующим точных движений; они занимают в шесть раз больше времени. Ваши DX и Базовое передвижение не могут превышать 80% от среднего значения (DX 8 и Передвижение 4 для людей) и могут быть значительно ниже. В большинстве случаев вы получаете -6 к социальным умениям. -55 очков.


Возможны и другие признаки расстройства, например явная моторная недостаточность (уменьшите DX или Передвижение), непроизвольные звуки (считайте их недостатком Шумный, B146), и нервный лицевой тик (уменьшите уровень внешности, см. Внешность, B21). Сильный тик и неприятные непроизвольные звуки могут трактоваться как Дурные привычки (B22).</description-loc>
		<type>Physical</type>
		<base_points>-55</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">artist</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">jeweler</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">knot-tying</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leatherworking</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">lockpicking</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pickpocket</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sewing</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sleight of hand</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">surgery</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">acting</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leadership</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">performance</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pubic speaking</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sex appeal</name>
			<specialization compare="is anything"></specialization>
			<amount>-6</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Neurological Disorder (Mild)</name>
		<name-loc>Нервное расстройство 
 (Слабо)</name-loc>
		<description-loc>Вы страдаете от одной из форм нервного расстройства, которое приводит к дрожи, непроизвольным движениям, нервному тику и т.п. Стоимость зависит от тяжести расстройства.


Легкое: Ваше состояние очевидно любому, кто видит вас хотя бы несколько секунд. Вы получаете -2, занимаясь работой, где необходимы точные движения (см. Высокая ловкость рук, B59), а ее выполнение занимает вдвое больше времени. Вы получаете -2 к социальным умениям, таким как Артистизм, Лидерство, Выступление, Публичное выступление и Сексапильность, в любой ситуации, где ваш недостаток может быть замечен (на усмотрение мастера). -15 очков
Тяжелое: Вам трудно жить в обществе. Вы получаете -4 к задачам, где нужны точные движения, а их выполнение занимает в четыре раза больше времени. Ваши DX и Базовое передвижение не могут превышать средних значений для расы (DX 10 и Передвижение 5 для людей). Вы получаете -4 к социальным умениям, если ваш недостаток замечен. -35 очков.
Критическое: Вы практически не способны жить в обществе. Вы получаете -6 к действиям, требующим точных движений; они занимают в шесть раз больше времени. Ваши DX и Базовое передвижение не могут превышать 80% от среднего значения (DX 8 и Передвижение 4 для людей) и могут быть значительно ниже. В большинстве случаев вы получаете -6 к социальным умениям. -55 очков.


Возможны и другие признаки расстройства, например явная моторная недостаточность (уменьшите DX или Передвижение), непроизвольные звуки (считайте их недостатком Шумный, B146), и нервный лицевой тик (уменьшите уровень внешности, см. Внешность, B21). Сильный тик и неприятные непроизвольные звуки могут трактоваться как Дурные привычки (B22).</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">artist</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">jeweler</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">knot-tying</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leatherworking</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">lockpicking</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pickpocket</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sewing</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sleight of hand</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">surgery</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">acting</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leadership</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">performance</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pubic speaking</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sex appeal</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Neurological Disorder (Severe)</name>
		<name-loc>Нервное расстройство 
 (Сильно)</name-loc>
		<description-loc>Вы страдаете от одной из форм нервного расстройства, которое приводит к дрожи, непроизвольным движениям, нервному тику и т.п. Стоимость зависит от тяжести расстройства.


Легкое: Ваше состояние очевидно любому, кто видит вас хотя бы несколько секунд. Вы получаете -2, занимаясь работой, где необходимы точные движения (см. Высокая ловкость рук, B59), а ее выполнение занимает вдвое больше времени. Вы получаете -2 к социальным умениям, таким как Артистизм, Лидерство, Выступление, Публичное выступление и Сексапильность, в любой ситуации, где ваш недостаток может быть замечен (на усмотрение мастера). -15 очков
Тяжелое: Вам трудно жить в обществе. Вы получаете -4 к задачам, где нужны точные движения, а их выполнение занимает в четыре раза больше времени. Ваши DX и Базовое передвижение не могут превышать средних значений для расы (DX 10 и Передвижение 5 для людей). Вы получаете -4 к социальным умениям, если ваш недостаток замечен. -35 очков.
Критическое: Вы практически не способны жить в обществе. Вы получаете -6 к действиям, требующим точных движений; они занимают в шесть раз больше времени. Ваши DX и Базовое передвижение не могут превышать 80% от среднего значения (DX 8 и Передвижение 4 для людей) и могут быть значительно ниже. В большинстве случаев вы получаете -6 к социальным умениям. -55 очков.


Возможны и другие признаки расстройства, например явная моторная недостаточность (уменьшите DX или Передвижение), непроизвольные звуки (считайте их недостатком Шумный, B146), и нервный лицевой тик (уменьшите уровень внешности, см. Внешность, B21). Сильный тик и неприятные непроизвольные звуки могут трактоваться как Дурные привычки (B22).</description-loc>
		<type>Physical</type>
		<base_points>-35</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">artist</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">jeweler</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">knot-tying</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leatherworking</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">lockpicking</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pickpocket</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sewing</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sleight of hand</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">surgery</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">acting</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">leadership</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">performance</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">pubic speaking</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sex appeal</name>
			<specialization compare="is anything"></specialization>
			<amount>-4</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Neutered</name>
		<name-loc>Евнух</name-loc>
		<description-loc>
У вас нет половых органов, типичных для вашей расы, пола, и возраста; или, возможно, вы по-настоящему бесполое существо, которое только похоже на кого-то конкретной расы и пола. В некоторых культурах это может привести к снижению уровня внешности, Социальной дискриминации или Неестественным чертам. Однако есть и небольшая выгода: вас никто не соблазнит, и вы никогда не станете родителем. Это отличается от обычного бесплодия (являющегося особенностью за 0 очков).</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Neutralize (Psi)</name>
		<name-loc>Нейтрализация псионики  (Psi)</name-loc>
		<description-loc>Вы можете нейтрализовывать псионические силы псиоников. Это – активная способность, с длительным эффектом на субъекта. Она не требует наличия псионики – она может быть представлена магической или высокотехнологичной способностью отнимать пси-силы.

Для использования Нейтрализации вы должны успешно коснуться субъекта, и выиграть в быстром состязании по Воле(Will). При успехе вы полностью нейтрализуете все псионические силы жертвы на число минут, равное успешности вашего броска. Способность не воздействует на псионические Таланты субъекта. Вы не можете нейтрализовывать субъекта снова, пока его пси-силы не восстановятся. Критический провал использования способности – лишает вас ее на 1d часов.

===Особые улучшения.===

Кража сил (Power Theft): Когда вы успешно нейтрализуете псионика, вы приобретаете все его сиы – включая их ограничения и расширения на время действия способности. Вы не можете использовать Нейтрализацию снова, пока этот эффект не пройдет. +200%.

===Особые ограничения.===
Только одна сила (One Power): Вы можете нейтрализовывать только один вид силы – например, Экстрасенсорику или Телепатию. -50%.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>50</base_points>
		<modifier version="1" enabled="no">
			<name>Кража сил (Power Theft)</name>
			<cost type="percentage">200</cost>
			<affects>total</affects>
			<reference>B71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Одна сила (One Power)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B71</reference>
			<notes>@Сила@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Power Theft</name>
			<cost type="percentage">300</cost>
			<affects>total</affects>
			<reference>P97</reference>
			<notes>Point Total</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Precise</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P97</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Derange</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P97</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>One Ability</name>
			<cost type="percentage">-80</cost>
			<affects>total</affects>
			<reference>P97</reference>
			<notes>@Способоность@ в @Силе@</notes>
		</modifier>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Nictitating Membrane</name>
		<name-loc>Глазная мембрана</name-loc>
		<description-loc>Ваши глаза прикрыты прозрачными веками. Это позволяет нормально видеть под водой и защищает глаза от песка, дыма и так далее. В любом случае, глаза имеют DR 1 за уровень преимущества. Также вы получаете +1 за уровень к любым броскам НТ, связанных с повреждением глаз. Прозрачные веки могут быть открыты и закрыты как и обычные.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<dr_bonus>
			<location>eyes</location>
			<amount level_mod="yes">1</amount>
		</dr_bonus>
		<points_per_level>1</points_per_level>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Night Blindness</name>
		<name-loc>Куриная слепота 
</name-loc>
		<description-loc>Вы плохо видите в темноте. Если пенальти за плохое освещение к зрению или в бою составляет от -1 до -4 для большинства людей, ваше пенальти вдвое хуже обычного или -3. Если обычное пенальти -5 или больше, вы вообще ничего не видите (см. Слепота, B124). Если у вас Обостренное зрение (B35), оно применяется только при отсутствии пенальти за темноту.
С этим недостатком нельзя брать Ночное видение (B71) и Видение в темноте (B47).</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">dark vision</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="no">
				<name compare="is">night vision</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Night Vision</name>
		<name-loc>Адаптация к темноте</name-loc>
		<description-loc>Ваши глаза быстро адаптируются к темноте. Каждый уровень этого преимущества (максимум 9) позволяет вам игнорировать -1 очко штрафа в бою за плохую освещенность, пока вокруг есть хотя бы немного света. 
В полной темноте (штраф -10) это преимущество не помогает совсем.
=====Пример: Адаптация к темноте 4 полностью аннулирует 4 очка штрафа за темноту, снижая его для вас с -7 до -3.=====
</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<reference>B71</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Nightmares</name>
		<name-loc>Ночные кошмары 
</name-loc>
		<description-loc>Каждую ночь вас терзают ужасные кошмары. Иногда они настолько ужасны, что влияют на ваше утреннее состояние. Когда вы просыпаетесь, сделайте проверку самоконтроля. При провале вы страдаете от кошмаров и теряете единицу усталости, которую можно восстановить только во время сна. При 17-18 вы остаетесь под впечатлением от сна и получаете -1 ко всем умениям и проверкам Восприятия(Per) в течение дня.
Кошмары могут быть настолько яркими, что их трудно отличить от действительности. Мастер может ввести их в игру, начав описывать как реальность, постепенно делая её все ужаснее, пока жертва не начнет подозревать, что видит сон. Такие сны могут оказать огромное влияние на спящего, который может временно получить Навязчивую идею, Фобию, и даже потерять хиты или уровни атрибутов.
Если в кошмаре принимают участие другие персонажи, на них никак не влияет все, что там происходит (но мастер может дать в награду игрокам одно очко персонажа за долгий сон - или два, если они хорошо его сыграли). Говорить или нет заранее, что дело происходит во сне, зависит от мастера. В любом случае может получится необычная и увлекательная игра.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Depth Perception</name>
		<name-loc>Нет восприятия глубины 
</name-loc>
		<description-loc>У вас два глаза, но нет объемного зрения; вы не можете визуально оценивать расстояние. Это может быть следствием расстройства зрения или особенностью нервной системы вашей расы. Игровые последствия похожи на недостаток Одноглазый (B147); нельзя брать оба эти недостатка одновременно.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B144</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">one eye</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>No Fine Manipulators</name>
		<name-loc>Нет хороших манипуляторов</name-loc>
		<description-loc>У вашего тела нет рук или вообще конечностей. Стоимость зависит от степени ограничений:
Нет хороших манипуляторов: У вас нет нечего более гибкого, чем лапы или копыта. Ими нельзя ремонтировать, взламывать замки, вязать узлы, пользоваться оружием и т.п.; нельзя даже крепко схватить что-то. Вы можете взять эту черту, только не имея ничего похожего по подвижности на человеческую руку. Если у вас есть клюв, язык, цепкий хвост, и т.п., которые могут заменить руку, брать этот недостаток нельзя! -30 очков.
Нет манипуляторов: У вас вообще нет конечностей. Вы можете использовать предметы, только толкая их телом или головой. Вы можете двигаться перекатываясь, извиваясь, подпрыгивая и т.п. со скоростью Базовым передвижением, если вы не снизите его до нуля.-50 очков.
Обратите внимание, что эта черта предназначена для нечеловеческих рас и супергероев. Любой уровень данного недостатка позволяет вам покупать ST и DX с-40 % ограничением Нет хороших манипуляторов.</description-loc>
		<type>Physical</type>
		<base_points>-30</base_points>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<cost_reduction>
			<attribute>st</attribute>
			<percentage>40</percentage>
		</cost_reduction>
		<cost_reduction>
			<attribute>dx</attribute>
			<percentage>40</percentage>
		</cost_reduction>
	</advantage>
	<advantage version="2">
		<name>No Hangover</name>
		<name-loc>Нет похмелья</name-loc>
		<description-loc>Независимо от того, насколько много вы выпили, вы никогда не страдаете от похмелья. Этот перк не смягчает эффекты интоксикации – лишь снимает неприятные последствия. 
&lt; B101, Perks, 14&gt;</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Aerial)</name>
		<name-loc>Безногий 
 (Воздушный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">flight</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>No Legs (Aquatic)</name>
		<name-loc>Безногий (Водный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<modifier version="1" enabled="no">
			<name>Не может нырять (Can't dive)</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B145</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Не может носить броню (Can't armor) @Fins/Masts/Sails/Paddles@</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B145</reference>
		</modifier>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Bounces)</name>
		<name-loc>Безногий (Прыгающий)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Rolls)</name>
		<name-loc>Безногий (Катящийся)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Semi-Aquatic)</name>
		<name-loc>Безногий (Водный) (Полуводный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Sessile)</name>
		<name-loc>Безногий (Неподвижный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-50</base_points>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Slithers)</name>
		<name-loc>Безногий (Скользящий)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Tracked)</name>
		<name-loc>Безногий (Гусеничный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B145</reference>
		<notes>Гусениц: @Чиисло гусениц@</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Legs (Wheeled)</name>
		<name-loc>Безногий (Колесный)</name-loc>
		<description-loc>Этот недостаток предполагает отсутствие ног у вашей расы, а не конкретно у вас; в противном случае см. Хромой (B141).

Вы принадлежите к безногой расе. Детали могут отличаться, но в любом случае вы не можете никого пнуть ногами или носить на них броню; вам по ногам в бою тоже не попадут. Указанная стоимость предполагает, что выгода от отсутствия ног как цели компенсируется невозможностью ими ударить.

Воздушный: Вы можете скользить над землей, парить или летать в воздухе, но не передвигаться по земле. Вы должны купить преимущество Полет (B56). Ваше Базовое передвижение в воздухе, как описано для Полета, вдвое больше обычной Базовой скорости. Передвижение по земле равно нулю. 0 очков.
Водный: Вы приспособлены к движению под водой (как рыба) или по воде (как корабль), но не по земле. Вычислите Базовое передвижение и используйте его как водное. Передвижение по земле равно нулю. Вы не получаете пенальти за работу на воде или под водой. 0 очков. Если ваша подвижность зависит от плавников, мачт, весел, или парусов - значит, вы не можете носить броню или нырять: -5 очков. Если и то, и другое: -10 очков.
Прыгающий, Катящийся или Скользящий: Вы передвигаетесь по земле, не используя ног, - как змея или робот в форме колеса. Используйте обычное Базовое передвижение. 0 очков.
Полуводный: Вы ползаете на плавниках, как тюлень. Используйте Базовое передвижение в воде и 1/5 от него как Передвижение по земле - т.е. переставьте обычное соотношение. В воде вы получаете обычные пенальти к умениям. 0 очков.
Неподвижный: Ваша нижняя часть прикреплена к земле, как у дерева или здания. В любой окружающей среде вы не можете самостоятельно передвигаться или использовать движущиеся платформы (хотя с большим трудом вас все-таки можно сдвинуть). Ваше Базовое передвижение равно нулю, и вы не получаете за это очков. У вас все-таки могут быть конечности; тогда вы будете владеть оружием без пенальти к DX (как при недостатке Хромой), поскольку вы очень устойчивы. -50 очков.
Гусеничный или Колесный: У вас вместо ног гусеницы или колеса. Определите, сколько их, от 1 до 4 или даже больше. При использовании зон попаданий считайте каждую гусеницу или колесо ногой. Вы не способны ни перепрыгнуть, ни преодолеть препятствие, для которого нужна слаженная работа рук и ног (например, лестница или веревка). Вы всегда оставляете видимый след (что дает вашим преследователям +1 к умению Следопыт для Колесного, +2 для Гусеничного). Гусеницы также сильно шумят (+2 ко всем проверкам на слух против вас), но позволяют легче преодолевать неровную местность. Гусеничный и Колесный не уменьшают Передвижение; вы даже можете купить до трех уровней Увеличенного передвижения (Земля). Этот недостаток обычно сопровождается мета-чертой Машина (B263). -20 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B145</reference>
		<notes>Колес: @Число колес@ </notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Manipulators</name>
		<name-loc>Нет манипуляторов</name-loc>
		<description-loc>У вашего тела нет рук или вообще конечностей. Стоимость зависит от степени ограничений:
Нет хороших манипуляторов: У вас нет нечего более гибкого, чем лапы или копыта. Ими нельзя ремонтировать, взламывать замки, вязать узлы, пользоваться оружием и т.п.; нельзя даже крепко схватить что-то. Вы можете взять эту черту, только не имея ничего похожего по подвижности на человеческую руку. Если у вас есть клюв, язык, цепкий хвост, и т.п., которые могут заменить руку, брать этот недостаток нельзя! -30 очков.
Нет манипуляторов: У вас вообще нет конечностей. Вы можете использовать предметы, только толкая их телом или головой. Вы можете двигаться перекатываясь, извиваясь, подпрыгивая и т.п. со скоростью Базовым передвижением, если вы не снизите его до нуля.-50 очков.
Обратите внимание, что эта черта предназначена для нечеловеческих рас и супергероев. Любой уровень данного недостатка позволяет вам покупать ST и DX с-40 % ограничением Нет хороших манипуляторов.</description-loc>
		<type>Physical</type>
		<base_points>-50</base_points>
		<reference>B145</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<cost_reduction>
			<attribute>st</attribute>
			<percentage>40</percentage>
		</cost_reduction>
		<cost_reduction>
			<attribute>dx</attribute>
			<percentage>40</percentage>
		</cost_reduction>
	</advantage>
	<advantage version="2">
		<name>No Sense of Humor</name>
		<name-loc>Нет чувства юмора</name-loc>
		<description-loc>Вы не понимаете шуток и считаете, что все вокруг говорят абсолютно серьезно. Вы тоже никогда не шутите и всегда серьезны. Когда этот недостаток становится очевиден, окружающие реагируют на вас с -2.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B146</reference>
		<notes>-2 реакции</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>No Sense of Smell/Taste</name>
		<name-loc>Нет обоняния / вкуса</name-loc>
		<description-loc>Эта болезнь (известная как аносмия) не позволяет вам ничего почувствовать с помощью обоняния или на вкус. В результате вы не способны обнаружить некоторые опасности, которые быстро определят другие люди. Однако есть и достоинства - не нужно беспокоиться при виде скунса и можно всегда есть то, что дают.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Nocturnal</name>
		<name-loc>Ночной житель</name-loc>
		<description-loc>Вы активны только после захода солнца. Это больше, чем простое предпочтение ночи дню! Как только начинается рассвет, вы становитесь вялым, а после восхода солнца впадаете в состояние паралича и кому вплоть до его захода.
Обратите внимание, что это не соответствует биологическому пониманию существа, "активного в ночное время".
Специальные модификаторы
Постоянный паралич: Под лучами солнца вы превращаетесь в камень или иным образом навсегда выходите из строя. Только одна, строго определенная сила или вещь (чаще всего мощное магическое заклинание) могут вернуть вас к жизни. Детали на усмотрение мастера + 100 %.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<modifier version="1" enabled="no">
			<name>Постоянный паралич (Permanent Paralysis)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B146</reference>
		</modifier>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Noisy</name>
		<name-loc>Шумный 
</name-loc>
		<description-loc>Вы производите много шума! Возможно, вы призрак со звенящими цепями, киборг со скрипящим вентилятором, машина с громко работающим двигателем ... или просто неспособны вести себя тихо.
Вы шумите постоянно, даже стоя неподвижно, если не находитесь в коматозном состоянии (для живых существ) или не выключены (для машин). Каждый уровень в зависимости от ситуации дает +2 к проверке Чувств против вас или -2 к вашей Скрытности. В некоторых обстоятельствах (например, в опере), каждый уровень данного недостатка также может дать -1 к реакции. Вы не можете взять более пяти уровней этого недостатка без разрешения мастера.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-2</points_per_level>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">stealth</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">-2</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Non-Icongraphic</name>
		<name-loc>Не воспринимает символы 
</name-loc>
		<description-loc>Вы не способны понять абстрактные образы и символы. Графический компьютерный интерфейс, карты, геральдические изображения, волшебные руны - все это не имеет для вас никакого смысла. Как и Дислексия (B134), это структурный дефект вашего мозга; вы не можете выкупить его обычным путем.
Вы не можете изучать Картографию, Геральдику, Рисование символов или другое умение, предназначенное в основном для создания или преобразования узоров и символов. Вы также не можете использовать графические компьютерные интерфейсы - только текстовые или виртуальную реальность. Наконец, вы не понимаете волшебных символов и можете изучать магию только устно.
Обратите внимание, что вы легко понимаете текст и можете нормально изучить письменность языка (см. Язык, B23).</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="no">
				<name compare="is">symbol drawing</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">heraldry</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="no">
				<name compare="is">cartography</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Nosy</name>
		<name-loc>Проныра</name-loc>
		<description-loc>
Слабая форма Любопытства (B129). Вы суете свой нос во все дыры и в чужие дела (что, вероятно, будет приводить время от времени к небольшим пенальти к реакции).</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Numb</name>
		<name-loc>Нет осязания 
</name-loc>
		<description-loc>У вас нет чувства осязания. Вам присуще ограниченное ощущение давления - достаточное, чтобы чувствовать свой вес и нормально ходить - но вы не можете прикосновением определить структуру поверхности. Для вас невозможны действия, зависящие только от осязания (например, печать "вслепую" или развязывание рук за спиной).
При выполнении задачи, требующей координации рук и глаз, вы получаете один уровень черты Неуклюжий (B138) или, если можете четко видеть свои действия, выполняете ее вдвое дольше. Если у вас уже есть эта черта, добавьте ее последствия.
Вы страдаете от боли, температуры и шока так же, как и любой другой, если не обладаете Высоким болевым порогом (B59), но не можете без взгляда определить, где рана - вы чувствуете боль равномерно по всему телу. В результате вы не способны оказать себе Первую помощь, пока не увидите рану.</description-loc>
		<type>Physical</type>
		<base_points>-20</base_points>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Oblivious</name>
		<name-loc>Непонимающий 
</name-loc>
		<description-loc>Вы различаете эмоции, но не понимаете их причин. Это мешает при социальном взаимодействии. Вы классический зануда! Вы получаете -1 при использовании или сопротивлении умениям Влияния (см. Проверки на влияние, B359): Дипломатия, Заговаривание зубов, Запугивание, Хорошие манеры, Сексапильность, Знание улиц.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">diplomacy</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">fast-talk</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">intimidation</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="starts with">savoir-faire</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">sex appeal</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">streetwise</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Obscure (@Sense@)</name>
		<name-loc>Глушение (@Чувство@)</name-loc>
		<description-loc>Вы производите эффект, который глушит одно чувство, затрудняя обнаружение вас и всего вашего окружения. Необходимо указать чувство, на которое вы влияете. Это может быть одно из человеческих чувств или сенсорное преимущество, наподобие Инфразрения, Радара или один определенный вид Обнаружения. Примеры: Глушение (зрение) – туман, Глушение (радар) – электронное подавление.

Глушение действует на область радиусом 2 ярда, с центром на вас. Этот радиус может быть увеличен Воздействием на область. Заглушенное чувство получает -1 на уровень Глушения для замечания чего-либо в радиусе воздействия. 10 уровней полностью заглушат чувство, но четко будут видны границы области: +1 за уровень.
===Особые улучшения.===

Защитная (Defensive): Вы не страдаете от собственного Глушения. +50%.

Расширенное (Extended): ваша способность влияет не на одно чувство, а на несколько; хотя они должны быть родственными (Инфразрение + Зрение, Сонар + Слух). +20% за каждое дополнительное чувство.

Удаленная атака (Ranged): Вы можете создавать эффект на расстоянии. Это считается дальней атакой с 1/2D –; Max 100, Acc +3, RoF 1, Rcl 1. Продолжительность эффекта 10 секунд. Возможно изменение любых этих параметров соответствующими модификаторами. В отличие от обычного модификатора Дальняя атака, вы можете использовать вашу способность снова и до истечения эффекта, так что это дороже. +50%

Необнаружимая область (Stealthy): Действие вашей способности невозможно обнаружить снаружи (типа зоны волшебной тишины). Враг не получает премий на обнаружение границ зоны. +100%.

===Особые ограничения.===
Всегда включено (Always On): Вы не можете выключить эту способность. -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<modifier version="1" enabled="no">
			<name>Защитная (Defensive)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B72</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Расширенное (Extended)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B72</reference>
			<notes>@+ чувство@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Удаленная атака (Ranged)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B72</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Необнаружимая область (Stealthy)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B72</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Всегда включено (Always On)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B72</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P65</reference>
			<notes>@Источник@@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P65</reference>
			<notes>@Сила@</notes>
		</modifier>
		<reference>B72</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Obsession</name>
	<name-loc>Навязчивая идея</name-loc>
	<notes>@Цель@</notes>
	<cr>12</cr>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Кратковременная задача</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B146</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Отдаленная цель</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B146</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B146</reference>
	<description-loc>Вся ваша жизнь сводится к преследованию одной цели. В отличие от Разорительной привычки (B128), это не постоянная привычка, а всепоглощающая одержимость, влияющая на все ваши действия. И в отличие от Фанатизма (B136), она не обязательно включает в себя систему философских взглядов.
Все свои действия вы должны подчинить достижению одной цели. Делайте проверку самоконтроля каждый раз, когда было бы разумным отступиться. При неудаче вы, невзирая на последствия, продолжаете преследовать свою цель.
Стоимость зависит от времени, необходимого для ее осуществления. Кратковременная задача (например, убить кого-то) стоит -5 очков, в то время как отдаленная цель (например, стать президентом) стоит -10 очков. В обоих случаях измените базовую стоимость, чтобы учесть показатель самоконтроля. Если ваша Навязчивая идея не нравится окружающим, возьмите Дурную привычку (B22) или Заблуждение (B130).
Если вы когда-нибудь достигнете цели, вам придется выкупить Навязчивую идею или заменить ее на новую.

Вы можете взять почти нормальную и не очень странную Навязчивую идею (B146) в качестве причуды, чтобы отразить незначительную цель в жизни. Например, вы надеетесь самостоятельно скопить достаточно денег, чтобы купить ферму (лодку, космический корабль, замок).</description-loc>
</advantage>
	<advantage version="2">
		<name>Obsession</name>
		<name-loc>Навязчивая идея</name-loc>
		<description-loc>Вся ваша жизнь сводится к преследованию одной цели. В отличие от Разорительной привычки (B128), это не постоянная привычка, а всепоглощающая одержимость, влияющая на все ваши действия. И в отличие от Фанатизма (B136), она не обязательно включает в себя систему философских взглядов.
Все свои действия вы должны подчинить достижению одной цели. Делайте проверку самоконтроля каждый раз, когда было бы разумным отступиться. При неудаче вы, невзирая на последствия, продолжаете преследовать свою цель.
Стоимость зависит от времени, необходимого для ее осуществления. Кратковременная задача (например, убить кого-то) стоит -5 очков, в то время как отдаленная цель (например, стать президентом) стоит -10 очков. В обоих случаях измените базовую стоимость, чтобы учесть показатель самоконтроля. Если ваша Навязчивая идея не нравится окружающим, возьмите Дурную привычку (B22) или Заблуждение (B130).
Если вы когда-нибудь достигнете цели, вам придется выкупить Навязчивую идею или заменить ее на новую.

Вы можете взять почти нормальную и не очень странную Навязчивую идею (B146) в качестве причуды, чтобы отразить незначительную цель в жизни. Например, вы надеетесь самостоятельно скопить достаточно денег, чтобы купить ферму (лодку, космический корабль, замок).</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Просто задача@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Odious Personal Habit</name>
	<name-loc>Дурные привычки</name-loc>
	<notes>@Привычка@</notes>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Реакция -1</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B22</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Реакция -2</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B22</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-2</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Реакция -3</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B22</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-3</amount>
		</attribute_bonus>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B22</reference>
	<description-loc>Вы часто или вообще всегда ведете себя неприятно для окружающих. Дурная привычка оценивается в -5 очков за каждые -1 к проверке реакции от людей, замечающих ее. Во время создания персонажа определите, что это за привычка, и согласуйте ее цену с мастером.

Примеры: Неприятный запах, постоянное почесывание или невнятное бормотание дают -1 к реакции и стоят по -5 очков. Постоянные скабрезные шутки или плевки на пол дают -2 к реакции и стоят по -10 очков. Привычки за -15 очков (-3 к реакции) оставлены на усмотрение тех, кто испорчен настолько, чтобы их взять!

Минусы к реакции применяются только к представителям вашей расы. Какова будет реакция других рас, определяет мастер. Привычка постоянно дурачиться многих людей раздражает, марсиане могут этого не заметить - а троллю так и вовсе понравится! Конечно же, целая раса может действовать неприятным остальным образом. Эти "Дурные расовые привычки" оцениваются так же, как и обычные Дурные привычки.</description-loc>
</advantage>
	<advantage version="2">
		<name>On the Edge</name>
		<name-loc>На грани</name-loc>
		<description-loc>Вы очень неразумно рискуете перед лицом смертельной опасности. Сделайте проверку самоконтроля, столкнувшись с опасной для жизни ситуацией: когда управляете пылающей машиной, пристально пялитесь на уличную банду, когда из оружия только зубная щетка, и т.д. При неудаче вы

не способны отступить - но можете сделать повторный бросок после каждой проверки или броска реакции, связанной с данной ситуацией. В потенциально боевой обстановке можно делать проверку каждую секунду, а в опасном космическом путешествии - только раз в день.
В бою делайте проверку самоконтроля в начале своего хода. При неудаче вы должны предпринять Тотальную атаку (all-out attack) или другое безумное, практически самоубийственное действие.
Большинство людей, бывших свидетелем вашего поведения, будут считать вас сумасшедшим (-2 к реакции). Те, кто ставит храбрость выше самосохранения, будут реагировать с +2 (на усмотрение мастера).</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B146</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>One Arm</name>
		<name-loc>Однорукий</name-loc>
		<description-loc>У вас только одна рука. Вы не можете использовать двуручное оружие, держать по оружию в каждой руке (или оружие и щит), или выполнять действия, требующие участия двух рук. Вы получаете -4 к задачам, которые выполнимы одной рукой, но обычно подразумевают две (например, большинство бросков на Лазание и Реслинг), но не получаете никаких пенальти, если рука нужна только одна. В любом случае окончательное решение за мастером. Если возникают сомнения, попробуйте по возможности повторить это в действительности!
Если у вас было две руки, считайте, что потеряна левая, если вы правша, или наоборот.
Если вы представитель нечеловеческой расы, у которой изначально только одна рука, это не обязательно именно "рука" - это может быть любая конечность, способная на точные движения. Например, попугай, использующий клюв и язык, получит черту Однорукий (вместо недостатка Нет хороших манипуляторов).
Если у вас есть протез, который во время ношения отменяет недостаток Однорукий, возьмите модификатор Смягчитель (B112). Если вы когда-нибудь полностью устраните этот недостаток (путем операции или использования высокотехнологичного протеза), вы должны его выкупить.</description-loc>
		<type>Physical</type>
		<base_points>-20</base_points>
		<reference>B147</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>One Eye</name>
		<name-loc>Одноглазый</name-loc>
		<description-loc>У вас только один глаз. Вы потеряли второй (тогда вы можете носить вместо отсутствующего глаза стеклянный или прикрывать его повязкой), или он один изначально, как у циклопа. Вы получаете -1 к DX в бою и при выполнении любой задачи, требующей координации рук и глаз, и -3 к дистанционным атакам (если предварительно не Прицелитесь) и броскам на управление транспортными средствами быстрее лошади или багги.
В некоторых культурах потеря глаза делает человека непривлекательным. Если это в общем верно для вашего игрового мира, потеря глаза также уменьшит на один уровень вашу внешность (см. Внешность, B21). Если вы начинаете игру с этим недостатком, считайте, что это уже учтено во внешности - не применяйте дополнительного модификатора к реакции.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B147</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>One Hand</name>
		<name-loc>Одна кисть</name-loc>
		<description-loc>У вас только одна кисть. В большинстве случаев используйте правила для черты Однорукий (выше). Разница в том, что этой рукой можно парировать без оружия и, возможно, держать что-то (например, щит).
Протезы хорошего качества используют правила, изложенные в описании недостатка Однорукий, хотя не всякий протез достаточно хорош, чтобы считаться Смягчителем. Низкотехнологичный протез даст -2 (захват) или -4 (крюк или коготь) к действиям этой рукой. Крюк или коготь в бою трактуется как большой нож, который невозможно выбить, (используется умение Нож) и дает +1 к Запугиванию, если водить им перед лицом противника. В некоторых культурах такие заменители приведут к уменьшению уровня внешности, как описано для недостатка Однорукий (выше).</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B147</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Oracle</name>
		<name-loc>Пророк</name-loc>
		<description-loc>Вы внимательны к знамениям, и способны увидеть скрытый знак в таких вещах, как рост растений, поведение животных и даже изменения погоды. Раз в день вы получаете шанс понять знаки. Обычно это требует не менее часа, но мастер может изменить это время как угодно. Мастер кидает два броска тайно от вас – для обнаружения и верной интепретации.
Обнаружение: бросок чувств. При успехе вы замечаете некое знамение. В случае критического успеха вы получаете +5 на бросок понимания. При провале вы ничего не обнаружили, при критическом провале мастер дает ложную информацию: будто вы нашли знак, но в действительности же это просто производное ваших собственных желаний или страхов.
Толкование: для толкования нужен бросок IQ. При успешном броске толкование будет весьма общим и неконкретным: «враг приближается», или «Древняя сила пробудилась». На критическом успехе вы получаете более четкую информацию: «Опасайся навлечь гнев короля», «ищи мага, живущего в башне». При провале найденный знак слишком расплывчат, чтобы быть полезным. При критическом провале вы ошибаетесь в толковании – возможно, делаете опасную ошибку.
Эта способность отличается от Предвидения (с. B77), которое не требует толкования.

===Новое особое улучшение===
Одаренный (Inspired): Вы необычайно талантливы. Любой успешный бросок толкования дает вам четкую информацию, критический успех – однозначное видение правды. +100%.
</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Inspired</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P65</reference>
		</modifier>
		<reference>B72</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Overconfidence</name>
	<name-loc>Самоуверенность 
</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Молодые / наивные</limitation>
		<amount>4</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B148</reference>
	<description-loc>Вы считаете себя сильнее, умнее или способнее, чем это есть на самом деле. Вы можете быть самодовольны и хвастливы, или просто непоколебимо уверены в себе, но этот недостаток нужно отыграть.
Вы должны делать проверку самоконтроля всякий раз, когда, по мнению мастера, вы проявляете чрезмерную осторожность. При неудаче вы должны действовать так, как будто полностью контролируете ситуацию! Осторожность - не ваш путь.
Вы получаете +2 к реакции от молодых или наивных (которые верят, что вы хороши настолько, насколько хотите казаться) и -2 от опытных NPC.
Самонадеянность похожа на легкую форму Мании величия (B144). Самоуверенный Робин Гуд вызывал незнакомцев на поединок на шестах, а Гитлер с его манией величия вторгся в Россию! Герои чаще бывают самоуверенными, чем страдающими манией величия.</description-loc>
</advantage>
	<advantage version="2">
		<name>Overweight</name>
		<name-loc>Полный</name-loc>
		<description-loc>Вы весите примерно 130% от нормы для данной ST. Вы получаете -1 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. Однако дополнительный запас жира дает вам +1 к проверкам Плавания и +1 к ST при попытке противостоять толканию.</description-loc>
		<type>Physical</type>
		<base_points>-1</base_points>
		<reference>B19</reference>
		<notes>+1 ST против отбрасывания</notes>
		<categories>
			<category>Quirk</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">swimming</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Pacifism: Cannot Harm Innocents</name>
		<name-loc>Пацифизм 
 (Не трогает невиновных)</name-loc>
		<description-loc>Вы не приемлете насилия. Это может приобретать разные формы. Выберите одну из описанных ниже:


Тяжело убивать: Вы психологически не готовы убивать людей. Каждый раз, нанося потенциально смертельный удар (например, ножом или огнестрельным оружием) человеку, чье лицо вам хорошо видно, вы получаете -4 к попаданию и не можете Прицелиться. Если вы не видите лицо противника (из-за надетой маски, темноты, расстояния или атаки сзади), пенальти равно -2 (кроме боя вплотную). Вы не получаете пенальти при нападении на транспортное средство (даже с пассажирами), на противника, которого не считаете человеком (включая существ с Ужасной или Чудовищной внешностью), или на цель, которую не видите напрямую (например, набор координат на карте или точка на радаре). Убийство хорошо видимого человека оказывает на вас влияние, как при варианте Не может убивать (см. ниже). Вы не против убийств, совершенных союзниками; вы можете даже обеспечивать их боеприпасами, оружием и моральной поддержкой! Вы просто не можете убивать сами. -5 очков.
Не трогает невиновных: Вы можете сражаться - и даже начинать бой - но биться с риском для жизни противника начнете только после попытки причинить вам серьезный вред. Захват в плен к нему не относиться, если вам не грозит смертная казнь или у вас нет Кодекса чести, требующего самоубийства в плену. Вы никогда не сделаете того, что может причинить вред посторонним - особенно "обычным людям". Эта черта особенно подходит борцам с преступностью, супергероям, и т.д. -10 очков.
Не может убивать: Вы можете сражаться и даже начинать бой - но никогда не сделаете ничего, что может привести к смерти противника. Вы даже не можете бросить его умирать от ран! Вы также не должны позволять убивать своим союзникам. Убив кого-то (или чувствуя ответственность за чью-то смерть), вы немедленно получаете нервный срыв, и 3d дней страдаете от замкнутости и в плохого настроения (отыграйте это!). В этот период вы способны на любое насилие по любому поводу только после проверки Воли(Will). -15 очков.
Только самозащита: Вы вступаете в бой только ради самообороны или защиты союзников, используя силу только при необходимости (никаких упреждающих ударов!). Вы должны стараться отговорить других начинать драку. -15 очков.
Отказ от насилия: Вы никогда не подымете руку на разумное существо и сделаете все возможное, чтобы отговорить от насилия других. Вы можете защищаться от нападений животных, комаров, и т.д. - 30 очков.


В реалистичной кампании мастер может потребовать от всех персонажей взять недостаток Убийство через силу или даже Не может убивать, что даст им дополнительные очки, но вызовет сложности при встречах с врагами.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B148</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Pacifism: Cannot Kill</name>
		<name-loc>Пацифизм 
 (Не может убивать)</name-loc>
		<description-loc>Вы не приемлете насилия. Это может приобретать разные формы. Выберите одну из описанных ниже:


Тяжело убивать: Вы психологически не готовы убивать людей. Каждый раз, нанося потенциально смертельный удар (например, ножом или огнестрельным оружием) человеку, чье лицо вам хорошо видно, вы получаете -4 к попаданию и не можете Прицелиться. Если вы не видите лицо противника (из-за надетой маски, темноты, расстояния или атаки сзади), пенальти равно -2 (кроме боя вплотную). Вы не получаете пенальти при нападении на транспортное средство (даже с пассажирами), на противника, которого не считаете человеком (включая существ с Ужасной или Чудовищной внешностью), или на цель, которую не видите напрямую (например, набор координат на карте или точка на радаре). Убийство хорошо видимого человека оказывает на вас влияние, как при варианте Не может убивать (см. ниже). Вы не против убийств, совершенных союзниками; вы можете даже обеспечивать их боеприпасами, оружием и моральной поддержкой! Вы просто не можете убивать сами. -5 очков.
Не трогает невиновных: Вы можете сражаться - и даже начинать бой - но биться с риском для жизни противника начнете только после попытки причинить вам серьезный вред. Захват в плен к нему не относиться, если вам не грозит смертная казнь или у вас нет Кодекса чести, требующего самоубийства в плену. Вы никогда не сделаете того, что может причинить вред посторонним - особенно "обычным людям". Эта черта особенно подходит борцам с преступностью, супергероям, и т.д. -10 очков.
Не может убивать: Вы можете сражаться и даже начинать бой - но никогда не сделаете ничего, что может привести к смерти противника. Вы даже не можете бросить его умирать от ран! Вы также не должны позволять убивать своим союзникам. Убив кого-то (или чувствуя ответственность за чью-то смерть), вы немедленно получаете нервный срыв, и 3d дней страдаете от замкнутости и в плохого настроения (отыграйте это!). В этот период вы способны на любое насилие по любому поводу только после проверки Воли(Will). -15 очков.
Только самозащита: Вы вступаете в бой только ради самообороны или защиты союзников, используя силу только при необходимости (никаких упреждающих ударов!). Вы должны стараться отговорить других начинать драку. -15 очков.
Отказ от насилия: Вы никогда не подымете руку на разумное существо и сделаете все возможное, чтобы отговорить от насилия других. Вы можете защищаться от нападений животных, комаров, и т.д. - 30 очков.


В реалистичной кампании мастер может потребовать от всех персонажей взять недостаток Убийство через силу или даже Не может убивать, что даст им дополнительные очки, но вызовет сложности при встречах с врагами.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<reference>B148</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Pacifism: Reluctant Killer</name>
		<name-loc>Пацифизм 
 (Тяжело убивать)</name-loc>
		<description-loc>Вы не приемлете насилия. Это может приобретать разные формы. Выберите одну из описанных ниже:


Тяжело убивать: Вы психологически не готовы убивать людей. Каждый раз, нанося потенциально смертельный удар (например, ножом или огнестрельным оружием) человеку, чье лицо вам хорошо видно, вы получаете -4 к попаданию и не можете Прицелиться. Если вы не видите лицо противника (из-за надетой маски, темноты, расстояния или атаки сзади), пенальти равно -2 (кроме боя вплотную). Вы не получаете пенальти при нападении на транспортное средство (даже с пассажирами), на противника, которого не считаете человеком (включая существ с Ужасной или Чудовищной внешностью), или на цель, которую не видите напрямую (например, набор координат на карте или точка на радаре). Убийство хорошо видимого человека оказывает на вас влияние, как при варианте Не может убивать (см. ниже). Вы не против убийств, совершенных союзниками; вы можете даже обеспечивать их боеприпасами, оружием и моральной поддержкой! Вы просто не можете убивать сами. -5 очков.
Не трогает невиновных: Вы можете сражаться - и даже начинать бой - но биться с риском для жизни противника начнете только после попытки причинить вам серьезный вред. Захват в плен к нему не относиться, если вам не грозит смертная казнь или у вас нет Кодекса чести, требующего самоубийства в плену. Вы никогда не сделаете того, что может причинить вред посторонним - особенно "обычным людям". Эта черта особенно подходит борцам с преступностью, супергероям, и т.д. -10 очков.
Не может убивать: Вы можете сражаться и даже начинать бой - но никогда не сделаете ничего, что может привести к смерти противника. Вы даже не можете бросить его умирать от ран! Вы также не должны позволять убивать своим союзникам. Убив кого-то (или чувствуя ответственность за чью-то смерть), вы немедленно получаете нервный срыв, и 3d дней страдаете от замкнутости и в плохого настроения (отыграйте это!). В этот период вы способны на любое насилие по любому поводу только после проверки Воли(Will). -15 очков.
Только самозащита: Вы вступаете в бой только ради самообороны или защиты союзников, используя силу только при необходимости (никаких упреждающих ударов!). Вы должны стараться отговорить других начинать драку. -15 очков.
Отказ от насилия: Вы никогда не подымете руку на разумное существо и сделаете все возможное, чтобы отговорить от насилия других. Вы можете защищаться от нападений животных, комаров, и т.д. - 30 очков.


В реалистичной кампании мастер может потребовать от всех персонажей взять недостаток Убийство через силу или даже Не может убивать, что даст им дополнительные очки, но вызовет сложности при встречах с врагами.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B148</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Pacifism: Self-Defense Only</name>
	<name-loc>Пацифизм 
 (Только самооборона)</name-loc>
	<base_points>-15</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B148</reference>
	<description-loc>Вы не приемлете насилия. Это может приобретать разные формы. Выберите одну из описанных ниже:


Тяжело убивать: Вы психологически не готовы убивать людей. Каждый раз, нанося потенциально смертельный удар (например, ножом или огнестрельным оружием) человеку, чье лицо вам хорошо видно, вы получаете -4 к попаданию и не можете Прицелиться. Если вы не видите лицо противника (из-за надетой маски, темноты, расстояния или атаки сзади), пенальти равно -2 (кроме боя вплотную). Вы не получаете пенальти при нападении на транспортное средство (даже с пассажирами), на противника, которого не считаете человеком (включая существ с Ужасной или Чудовищной внешностью), или на цель, которую не видите напрямую (например, набор координат на карте или точка на радаре). Убийство хорошо видимого человека оказывает на вас влияние, как при варианте Не может убивать (см. ниже). Вы не против убийств, совершенных союзниками; вы можете даже обеспечивать их боеприпасами, оружием и моральной поддержкой! Вы просто не можете убивать сами. -5 очков.
Не трогает невиновных: Вы можете сражаться - и даже начинать бой - но биться с риском для жизни противника начнете только после попытки причинить вам серьезный вред. Захват в плен к нему не относиться, если вам не грозит смертная казнь или у вас нет Кодекса чести, требующего самоубийства в плену. Вы никогда не сделаете того, что может причинить вред посторонним - особенно "обычным людям". Эта черта особенно подходит борцам с преступностью, супергероям, и т.д. -10 очков.
Не может убивать: Вы можете сражаться и даже начинать бой - но никогда не сделаете ничего, что может привести к смерти противника. Вы даже не можете бросить его умирать от ран! Вы также не должны позволять убивать своим союзникам. Убив кого-то (или чувствуя ответственность за чью-то смерть), вы немедленно получаете нервный срыв, и 3d дней страдаете от замкнутости и в плохого настроения (отыграйте это!). В этот период вы способны на любое насилие по любому поводу только после проверки Воли(Will). -15 очков.
Только самооборона: Вы вступаете в бой только ради самообороны или защиты союзников, используя силу только при необходимости (никаких упреждающих ударов!). Вы должны стараться отговорить других начинать драку. -15 очков.
Отказ от насилия: Вы никогда не подымете руку на разумное существо и сделаете все возможное, чтобы отговорить от насилия других. Вы можете защищаться от нападений животных, комаров, и т.д. - 30 очков.


В реалистичной кампании мастер может потребовать от всех персонажей взять недостаток Убийство через силу или даже Не может убивать, что даст им дополнительные очки, но вызовет сложности при встречах с врагами.</description-loc>
</advantage>
	<advantage version="2">
		<name>Pacifism: Total Nonviolence</name>
		<name-loc>Пацифизм 
 (Полный отказ от насилия)</name-loc>
		<description-loc>Вы не приемлете насилия. Это может приобретать разные формы. Выберите одну из описанных ниже:


Тяжело убивать: Вы психологически не готовы убивать людей. Каждый раз, нанося потенциально смертельный удар (например, ножом или огнестрельным оружием) человеку, чье лицо вам хорошо видно, вы получаете -4 к попаданию и не можете Прицелиться. Если вы не видите лицо противника (из-за надетой маски, темноты, расстояния или атаки сзади), пенальти равно -2 (кроме боя вплотную). Вы не получаете пенальти при нападении на транспортное средство (даже с пассажирами), на противника, которого не считаете человеком (включая существ с Ужасной или Чудовищной внешностью), или на цель, которую не видите напрямую (например, набор координат на карте или точка на радаре). Убийство хорошо видимого человека оказывает на вас влияние, как при варианте Не может убивать (см. ниже). Вы не против убийств, совершенных союзниками; вы можете даже обеспечивать их боеприпасами, оружием и моральной поддержкой! Вы просто не можете убивать сами. -5 очков.
Не трогает невиновных: Вы можете сражаться - и даже начинать бой - но биться с риском для жизни противника начнете только после попытки причинить вам серьезный вред. Захват в плен к нему не относиться, если вам не грозит смертная казнь или у вас нет Кодекса чести, требующего самоубийства в плену. Вы никогда не сделаете того, что может причинить вред посторонним - особенно "обычным людям". Эта черта особенно подходит борцам с преступностью, супергероям, и т.д. -10 очков.
Не может убивать: Вы можете сражаться и даже начинать бой - но никогда не сделаете ничего, что может привести к смерти противника. Вы даже не можете бросить его умирать от ран! Вы также не должны позволять убивать своим союзникам. Убив кого-то (или чувствуя ответственность за чью-то смерть), вы немедленно получаете нервный срыв, и 3d дней страдаете от замкнутости и в плохого настроения (отыграйте это!). В этот период вы способны на любое насилие по любому поводу только после проверки Воли(Will). -15 очков.
Только самозащита: Вы вступаете в бой только ради самообороны или защиты союзников, используя силу только при необходимости (никаких упреждающих ударов!). Вы должны стараться отговорить других начинать драку. -15 очков.
Отказ от насилия: Вы никогда не подымете руку на разумное существо и сделаете все возможное, чтобы отговорить от насилия других. Вы можете защищаться от нападений животных, комаров, и т.д. - 30 очков.


В реалистичной кампании мастер может потребовать от всех персонажей взять недостаток Убийство через силу или даже Не может убивать, что даст им дополнительные очки, но вызовет сложности при встречах с врагами.</description-loc>
		<type>Mental</type>
		<base_points>-30</base_points>
		<reference>B148</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Parabolic Hearing</name>
		<name-loc>Избирательный слух</name-loc>
		<description-loc>Персонаж может «концентрироваться» на отдельных звуках или прослушивать определенную область, а также отделять фоновые звуки от желаемых.
Каждый уровень Избирательного слуха удваивает дальность на которой данный звук может быть услышан как «громкость разговора» (то есть без броска на слух). Например шепот или шорох листвы может быть обычно услышан без броска на 1/4 ярда, нормальный разговор или спеллкастинг на 1 ярде, тихий голос или осторожное вытаскивание оружия – на 1/2 ярда, громкий диалог на 4 ярдах и бой бронированных врагов – на 16 ярдах. (см. Слух, с. B358).</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>4</points_per_level>
		<reference>B72</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Paranoia</name>
	<name-loc>Паранойя 
</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B148</reference>
	<description-loc>Вы утратили связь с действительностью и думаете, что все вокруг плетут против вас интриги. Вы не доверяете никому, кроме старых друзей... да и за теми присматриваете... так, на всякий случай. Естественно, что большинство людей реагирует на вас с -2. NPC-параноик реагирует с -4 на всех незнакомых людей, а любое "обычное" пенальти к реакции (например, для недружелюбной расы или национальности) удваивается. Паранойя хорошо сочетается с Заблуждениями (B130), у которых своя стоимость!</description-loc>
</advantage>
	<advantage version="2">
	<name>Patron</name>
	<name-loc>Покровители</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Личность со 150% стартовых очков игрока@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Органицация с капиталом 1.000 раз больше стартового состояния игрока@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Личность со 200% стартовых очков игрока@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Органицация с капиталом 10.000 раз больше стартового состояния игрока@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Сверх могуществанная личность@</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Органицация с капиталом 100.000 раз больше стартового состояния игрока@</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Органицация с капиталом 1.000.000 раз больше стартового состояния игрока@</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто: Правительство страны или транснациональная организация@</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Кто Божество@</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется постоянно</name>
		<notes>Бросок не требуется</notes>
		<cost type="multiplier">4</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется почти всегда</name>
		<notes>15-</notes>
		<cost type="multiplier">3</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется часто</name>
		<notes>12-</notes>
		<cost type="multiplier">2</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется периодически</name>
		<notes>9-</notes>
		<cost type="multiplier">1</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Появляется редко</name>
		<notes>6-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B36</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Снаряжение</name>
		<notes>@Предметы Стоимость не выше среднего стартового капитала@</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Снаряжение</name>
		<notes>@Предметы Стоимость выше среднего стартового капитала@</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Высокая доступность</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Особые способности</name>
		<notes>@Особый социальный или политический вес@</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Особые способности</name>
		<notes>@магические силы в немагическом мире, снаряжение высокого TL, предоставляет особые силы или имеет необычайное рас пространение в пространстве или во времени@</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Минимальное вмешательство</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Тайный</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B73</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Невольный</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Одноразовая услуга - Благосклонность (Favor)</name>
		<cost type="multiplier">0.2</cost>
		<reference>B55</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B72</reference>
	<description-loc>Покровители - это неигровые персонажи, изначально созданные игроком, но отыгрываемые мастером. Покровитель может оказать большую помощь, как друг, советник, защитник или наниматель. (Вы можете работать без покровителя - см. Работы, B192.) Покровитель - больше, чем простой босс.
Сила покровителя
Стоимость покровителя определяется (а) его/ее силой и (б) частотой, с которой он появляется, чтобы помочь вам. Сила покровителя определяется мастером, ниже приведены некоторые примеры, которые могут использоваться в качестве руководства; однако помните, что существуют покровители, способные попасть в любую из этих категорий сразу. Слово Мастера имеет решающее значение.
* Покровитель в виде одной сильной личности (созданной по меньшей мере на 150% ваших стартовых очков) или группы с имуществом, по крайней мере в 1000 раз превышающими начальное стартовое состояние для этого мира: 10 очков. 
* Если покровитель чрезвычайно силен (создан на 200% стартовых очков) или это достаточно могущественная организация (имущество превышает стартовое хотя бы в 10,000 раз): 15 очков. Пример: полицейский участок Лос-Анджелеса, миллионер, аватар не особенно влиятельного божества.
* Если покровитель – невероятно сильный персонаж (любое количество очков) или очень сильная организация (капитал в 100,000 раз превышает стартовое состояние): 20 очков. Пример: супер-герой, большой город или аватар сильного божества.
* Невероятно сильная организация (капитал – в 1,000,000 раз превышающий стартовое состояние): 25 очков. Пример: небольшая страна или крупная корпорация. 
* Если покровителем является сам бог, государственное руководство или огромная межнациональная организация (стартовое состояние практически неизмеримо): 30 очков.
Обратите внимание, что хотя иметь божество в качестве покровителя стоит столько же очков, сколько и обычный несверхъестественный покровитель, божественные силы требуют наличия модификатора Особые способности (см.ниже), что увеличивает ценность данного варианта.
Частота появления покровителя
Ценность покровителя в большей степени определяется частотой, с которой он появляется в кампании. Используйте те же изменения, описанные в графе Частота появления (с. B36).
Мастер бросает кубики в начале каждого приключения. Если у нескольких игроков один покровитель, они получают только один бросок! Если результаты укладываются в требуемые, мастер может разработать приключение так, что оно будет включать задание от покровителя или просто помощь с его стороны. Также он может предоставить героев самим себе, если считает, что покровитель нарушит ход кампании. 
Тем не менее, если мастер решил, что покровитель может появиться, а вы попытаетесь связаться с ним в ходе приключения (для получения помощи, совета или чего-нибудь другого) то такие попытки, скорее всего, увенчаются успехом и будет предложена помощь. (Будьте благоразумны. Если вас заперли в подземелье без рации и других возможностей передать сообщение, вряд ли вы сможете связаться хоть с кем-нибудь). Вы не будете знать, готов ли покровитель помогать вам, пока не попробуете связаться с ним и, как правило, обратиться к нему за помощью вы сможете лишь один раз за приключение.
И игроки, и мастер должны помнить, что могущественный покровитель может быть полезным, даже не вмешиваясь. Чикагский парнишка, заявивший "Я от Большого Эдди", или борец с преступностью, блеснувший карточкой полного доступа способен повлиять на решение в сложном споре.
Покровители группы.
Часто оказывается, что у нескольких персонажей один и тот же покровитель (они все агенты одного правительства, служители одного культа, и т.д.) Тем не менее, цена Покровителя не делится; каждый персонаж оплачивает полную стоимость. Для игроков это также является преимуществом; если покровитель является к одному из них, чтобы выдать задание или предложить помощь, обычно мастер сочтет разумным, что другие также смогут воспользоваться его услугами независимо от результатов своих бросков в начале приключения. 
Недостатки Покровителей
Если Покровитель - наемник, феодал и т.д., вы можете нести Службу (с. B133) по отношению к нему. Это считается недостатком. Божество или подобный покровитель зачастую требует следования особому кодексу поведения  (см. Добровольные ментальные недостатки, с. B121).
Покровитель также может обладать серьезными врагами, которые становятся также и вашими. Это может дать недостаток Враг (с. B135). 
Наличие таких факторов может сильно уменьшить ценность Покровителя и заменить пользу серьезной ответственностью!
Наниматели и покровители
Не каждый наниматель - покровитель. Если ваш наниматель по крайней мере иногда способен вытащить вас из неприятностей, то он покровитель. В противном случае, это просто работа. К примеру, маленькое полицейское отделение стоит 10 очков, поскольку обычно заботиться о своих людях. Но армия США, хотя она сильна и могущественна, вряд ли является покровителем для простого пехотинца. Вы можете сказать "Полковник заботится о своих людях" (и приобрести покровителя) - или заявить "Если я попаду в беду, мне придется выпутываться самому" - и не платить очков за обладание покровителем.
Примеры покровителей
Некоторые возможные взаимоотношения между покровителем и персонажем в продолжительной кампании:
* Могущественный маг как покровитель воинов (или молодых колдунов), которых он отправляет искать магические предметы или убивать врагов.
* Криминальный авторитет как покровитель мелких воров и убийц.
* Маленькое божество как покровитель Праведных Грешников.
* Местное отделение полиции как покровитель местного детектива. Они могут обижаться на него, но он помогает им делать дело и наоборот.
* Местный правитель (в любом мире) как покровитель приключенцев.
* Большая компания как покровитель шпиона или человека, решающего неприятности.
* Супер-борец с преступностью или политик, как покровитель репортера.
* Разведывательная организация как покровитель наемного оперативника, или постоянный покровитель собственных агентов. (Разница по сравнению с обычной работой заключается в том, что с этой нельзя уйти...)

За мастером последнее слово при определении стоимости Покровителя. Также он может просто отказать взять данного покровителя, если считает, что он не вписывается в текущую кампанию или просто слишком абсурден.
===Особые улучшения.===
Снаряжение (Equipment): Если покровитель предоставляет какое-то снаряжение и оборудование, это увеличивает его ценность лишь в том случае, если персонаж может использовать его для собственных целей в то время, как остальным персонажам в той же кампании приходится его покупать. Персонаж доплачивает только за оборудование, которое он получает в постоянное пользование. Солдат в военной кампании не платит за свое снаряжение; когда он вне службы, он не может захватить его с собой.

Цена покровителя увеличивается на +50%, если снаряжение стоит не больше, чем средний стартовый капитал в кампании, или на 100%, если снаряжение может стоить больше.

Высокая доступность (Highly Accessible): вы можете попытаться связаться с покровителем в любое время – даже если вы заперты в подземелье или заблудились в пустыне. Это больше подходит для покровителей в виде духов или богов. +50%.

Особые способности (Special Abilities): ваш покровитель обладает силами, не отражаемыми в богатстве или очках. +50%, если покровитель имеет особый социальный или политический вес (мэр Нью-Йорка или Папа), +100%, если покровитель имеет магические силы в немагическом мире, обладает снаряжением более высокого технологического уровня, предоставляет вам особые силы или имеет необычайное распространение в пространстве или во времени.

===Особые ограничения.===

Минимальное вмешательство (Minimal Intervention) (-50%): Ваш покровитель менее полезен, чем это следует из его уровня сил. При успешном броске связи мастер кидает бросок реакции для покровителя, чтобы определить, получите ли вы помощь. При реакции Нейтральной или лучше, вы получите помощь, в которой, по мнению покровителя, вы нуждаетесь – хотя это может быть и не совсем то, что вы хотели. Это классический модификатор для богов, у которых полно других служителей, которым тоже надо помогать. -50%.

Тайный (Secret): Ваш покровитель действует за сценой. Вы не знаете, кто он, и не можете просить помощь напрямую. Вы можете попытаться попросить о помощи, послав ему сообщение (на усмотрение мастера), но Покровитель не обязательно предпримет какие-то действия. Единственное подтверждение существования такого покровителя – мелкие происшествия и счастливые обстоятельства. Это может принимать форму информации, снаряжения или даже прямой помощи, но только когда это позволяет покровителю остаться неизвестным. Покровители такого типа часто предлагают помощь, ожидая чего-то взамен, преследуя свои интересы. Точные детали знает только мастер, а вы не знаете ничего, кроме того, что у вас есть покровитель. -50%.
Невольный (Unwilling): Вы получили покровителя через принуждение (например, шантаж). Он предоставляет вам помощь только потому, что не имеет другого выбора, и определенно не заинтересован в ваших действиях. Вы в конце концов можете запросить слишком многого, и потерять покровителя навсегда (сотрите эту строчку с листа персонажа и уменьшите соответственно его стоимость). Поскольку покровитель по определению сильнее вас, иметь вынужденного покровителя – рискованное занятие. Если покровитель сможет найти лазейку или разрушить ваш «захват», вы можете вместо покровителя получить врага. -50%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Payload (@Load@)</name>
		<name-loc>Багаж (@Вес@)</name-loc>
		<description-loc>Вы можете перевозить груз или пассажиров внутри себя! Это может быть природная способность или любая иная (имплант-карман или сумка кенгуру). Это подходит не только для машин – зомби может переносить в себе колонию пауков или змей.
Каждый уровень преимущества позволяет перевозить до BL/10 фунтов внутри. Имеющие Гомогенность (с. B60) или мета-черту Машина (с. B263) должны сначала спросить разрешение у мастера, чтобы взять более 5 уровней. Нагрузка распределяется между пассажирами и багажом.
Груз. 20 фунтов груза примерно занимает 1 ф3 объема. Обычная машина имеет около 10-20 ф3, трейлер может иметь до 2,400 ф3 и больше.
Пассажиры. Одно существо размером с человека занимает 10 ф3 объема и 200 фунтов веса. Общее правило для существ других размеров - +30% к среднему весу расы. Настоящая, полноценная кабина требует в 10 раз больше места, чем это требуется минимально. Ваши защитные преимущества защищают и пассажиров. Если пассажиры могут вас контролировать, покупайте отдельно Контроль (Разделенное сознание, с. B43).
В отношении расчета нагрузки и помех из-за нее (также как и для использования способностей, предполагающих ограничение нагрузки) ваш Багаж считается вашим телом, а не нагрузкой или инвентарем – если вы носите багаж внутри себя. 

Машины, способные тянуть или перетаскивать груз с одного места на другое вне себя – приобретают Подъемную силу (с. B65), а не Багаж! Обычные грузовики и машины могут иметь Багаж, а буксиры, тягачи и погрузчики – вряд ли.

===Особые ограничения.===
Незащищенный (Exposed): Ваш багаж не закрыт вашим телом, и не защищен вашими преимуществами. Вы можете ограничивать защиту любой доли багажа. Основное использование – создание мотоциклов и подобных транспортных средств. -50%.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<modifier version="1" enabled="no">
			<name>Незащищенный (Exposed)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B74</reference>
		</modifier>
		<reference>B74</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Penetrating Vision</name>
	<name-loc>Проникающее зрение</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Блокируемое (Blockable)</name>
		<notes>@Обычные материалы (пластик, камень, дерево и т.п.)@</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Блокируемое (Blockable)</name>
		<notes>@Менее обычные материалы(кирпич, асфальт и т.п.)@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Блокируемое (Blockable)</name>
		<notes>@Один материал (свинец и т.п.)@</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специфическое (Specific)</name>
		<notes>@Обычные материалы (кирпич, металл, дерево и т.п.)@</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специфическое (Specific)</name>
		<notes>@Необычные материалы (лед, суглинок и т.п.)@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специфическое (Specific)</name>
		<notes>@Абсурдные материалы (шоколад, шелк и т.п.)@</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B74</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B74</reference>
	<description-loc>Проникающее зрение (иногда называемое рентгеновским) позволяет вам видеть через твердые предметы. Каждый уровень преимущества позволит видеть сквозь 6 дюймов материи. Автоматически применяются все другие преимущества зрения (инфразрение, ультра-зрение и пр.).

===Особые ограничения.===

Блокируемое (Blockable): некоторая субстанция полностью блокирует ваше зрение. Обычные (пластик, камень, дерево) -30%, менее обычные (кирпич, асфальт) -20%, один материал (свинец) -10%.
Специфическое (Specific): Вы можете видеть только через один материал. Обычные материалы стоят -40%, необычные -60%, редкие (шоколад, шелк) -80%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Penetrating Voice</name>
		<name-loc>Пронзительный голос</name-loc>
		<description-loc>Вас действительно слышно! В ситуациях, когда надо перекричать другие звуки, остальные получают +3 на броски слуха, чтобы услышать вас. Также вы можете получить +1 на броски допроса, если внезапно изменяете голос (на усмотрение Мастера).
</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Perfect Balance</name>
	<name-loc>Совершенное равновесие</name-loc>
	<base_points>15</base_points>
	<skill_bonus>
		<name compare="starts with">piloting</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">acrobatics</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">climbing</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B74</reference>
	<description-loc>У вас нет проблемы с сохранением баланса, независимо от того, насколько узка поверхность, по которой вы идете при нормальных условиях. Вы можете ходить по канатам, доскам, ветвям дерева или любой другой зафиксированной поверхности, не делая проверки на DX. Если поверхность мокрая, скользкая или неустойчивая, вы получаете бонус +6 на все проверки для сохранения устойчивости. В бою Вы получаете +4 к DX при любых попытках сохранить устойчивость или не быть сбитым с ног. Это преимущество добавляет +1 к умениям Пилотирование, Лазание и Акробатика.</description-loc>
</advantage>
	<advantage version="2">
		<name>Peripheral Vision</name>
		<name-loc>Периферическое зрение</name-loc>
		<description-loc>У Вас необычно большое поле зрения. Не поворачивая головы, вы можете видеть сектор в 180о перед собой; и имеете еще по 30о периферического зрения слева и справа. Это дает вам сектор обзора в 240о в целях наблюдения и дальних атак (см. иллюстрацию – белым закрашено поле зрения обычного персонажа, а серым – дополнительные сектора обзора обладателя периферического зрения). 
Если вы играете с игровой картой, то можете атаковать в правые и левые хексы также, как и вперед. (Обратите внимание, что в случае использования одноручного оружия атака влево неуклюжа и в любом случае считается "ударом наугад (wild swing)" – см с. B388.
Если вас атакуют из правого или левого хекса, вы защищаетесь безо всяких пенальти. Проверка вашей активной защиты делается лишь с -2 при атаке сзади. Вы все равно не можете напасть на врага, стоящего сзади вас (без удара наугад). Кроме того, у вас более широкое "поле обзора" для дальних атак. 

Когда что-то опасное или интересное происходит "за вашей спиной", Мастер делает за вас проверку Зрения. Успешный бросок означает, что вы это заметили, или, по крайней мере, заметили настолько, чтобы быть готовым к внезапной атаке. Также вы получаете +3 на броски обнаружения Слежки или засады сзади.

===Особые ограничения.===
Легко ударить (Easy to Hit): Ваши глаза расположены на глазных стебельках, необычайно большие или иначе уязвимы для атаки. Другие могут прицеливаться по вашим глазам всего со штрафом -6. -20%.</description-loc>
		<type>Physical</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Легко ударить (Easy to Hit)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B75</reference>
			<notes>Другие могут прицеливаться по вашим глазам со штрафом всего -6</notes>
		</modifier>
		<reference>B74</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Permeation</name>
	<name-loc>Проницание</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Повсеместные (земля, металл, камень и т.п.)@</name>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Распространенные (бетон, пластик, сталь и т.п.)@</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Частые  (стекло, лед, песок, алюминий, медь и т.п.)@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Редкие (кость, плоть, бумага и т.п.)@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Can Carry Objects</name>
		<notes>До нулевой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До средней нагрузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До тежелой нагрузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Tunnel</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B75</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Extended</name>
		<notes>@Класс@</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P66</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Meld</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>P66</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B75</reference>
	<description-loc>Вы можете двигаться сквозь определенный плотный материал как будто его не существует. Вы не оставляете прохода за собой, наблюдатели просто видят как вы входите в поверхность и исчезают. Вам необходимо Проникающее зрение (с. B74), чтобы видеть, куда вы идете. Вам по-прежнему необходимо дышать (если у вас нет соответствующей способности), что ограничивает ваши путешествия внутри твердых предметов (см. Задержка дыхания, с. B351). Проницание отличается от Нематериальности. Вы подвержены воздействию гравитации и ограничены обычной скоростью и способом передвижения; если у вас нет преимуществ, изменяющих ваш способ передвижения – вы передвигаетесь только пешком с обычной скоростью. Вы уязвимы для любой атаки, которая может достать вас, когда вы находитесь внутри. Вы также уязвимы к атакам материалом, сквозь который вы можете проходить, если вы не купите DR от него. 

Цена преимущества зависит от редкости этого материала в качестве барьера. Например, бумага является Обычной субстанцией, но стены из бумаги редки, так что она считается Редкой.

Повсеместные (Very Common): Земля (включая глину, грязь и песок), металл, камень (включая кирпич, бетон, штукатурку), дерево и другие распространенные стройматериалы. 40 очков.

Распространенные (Common): бетон, пластик, сталь, и другие определенные виды обычных стройматериалов. 20 очков.

Частые (Occasional): стекло, лед (включая снег), песок, и другие материалы, сквозь которые обычный человек может проделать себе путь, используя силу; а также необычные стройматериалы (алюминий, медь). 10 очков.

Редкие (Rare): Кость, плоть, бумага и другие материалы, редко встречаемые в больших количествах или в виде барьеров. 5 очков.
===Особые улучшения.===

Переноска предметов (Can Carry Objects): Обычно вы не можете ничего переносить, когда проходите сквозь материю. Это расширение позволяет вам переносить предметы, включая одежду и броню. Если вы бросите свою ношу, она возникнет в том месте, откуда вы вошли. Вы не можете оставить вещи внутри материи. Нет нагрузки +10%, Легкая нагрузка +20%; Средняя +50%, тяжелая +100%.
Туннель (Tunnel): Вы можете по желанию оставлять за собой проход, примерно вашего размера. Материя расступается перед вами; способность не работает на живых существах. Чтобы создать способность, которая проделывает дырки в предметах и людях – покупайте Природную атаку. +40%.

===Новые особые улучшения===
Расширенная (Extended): Вы можете проходить сквозь несколько родственных материалов. Наиболее дорогой покупается за полную цену, а каждая дополнительная субстанция считается улучшением на +20%. Например, Проницание (камень) может получить Расширенное (земля и металл) за +40%.
Слияние (Meld 1): входя в предмет, вы становитесь с ним одним целым, как дриада сливается с деревом. Работает только с определенным объектом – деревом (не  Создание способностей 67 лесом), горой (не планетой) и т.д. Во время слияния вы можете использовать свои чувства и выходить из любой точки поверхности предмета – внутренней или внешней), и можете дышать, если хотя бы одна часть предмета касается воздуха. Смена точки зрения или выход из предмета происходит по маневру Подготовки. Нанесение вреда предмету наносит пропорциональные повреждения и вам. Например, 10 ЕЖ вреда дереву, имеющему 100 ЕЖ, нанесет 1 ЕЖ вреда человеку, чье базовое значение ЕЖ – 10. Когда вы являетесь частью чего-то более крупного, вы также лучше сопротивляетесь Воздействиям – бонус к броску сопротивления равен разнице МР. Если у вас есть атака, которая ранит цели, которые касаются вас или просто стоят поблизости (типа Излучения), то при слиянии с более крупным предметом она также уменьшает свою эффективность – вред уменьшается пропорционально разнице ЕЖ (см. выше), а разница между МР предмета и вашим МР добавляется к броскам сопротивления цели. Вы не можете контролировать предмет, в котором сидите – покупайте Переселение. +150%.
Слияние 2 (Meld 2): точно также, как и Слияние 1, но работает даже на распределенные предметы. С Прониканием (Земля) вы можете слиться с землей под ногами и пересечь планету в мгновенье ока. Имея Проникание (Дерево), вы можете слиться с лесом и видеть все, что происходит в нем. +300%

===Новое особое ограничение===
Ограничение толщины (Finite Thickness): вы можете проходить только сквозь предметы ограниченной толщины. Если вы пытаетесь пройти сквозь любой предмет толще этого предела, вы проходите на соответствующую глубину и наталкиваетесь на непреодолимую преграду. Ценность зависит от толщины: -50% за тонкую преграду (типа шторки), -30% за дюйм, -15% за фут, -5% за расстояние, которое вы можете пересечь за секунду
</description-loc>
</advantage>
	<advantage version="2">
		<name>Personality Change</name>
		<name-loc>Изменчивое поведение</name-loc>
		<description-loc>
Это Раздвоение личности (B156) на уровне причуды. Вы страдаете от всех негативных эффектов ментального недостатка, но только в обстоятельствах, которые обычно находятся под вашим контролем - например, Задира, когда слишком много выпьете, или Пиромания после сотворения заклинания Создать огонь.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Условие изменения@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Phantom Voices</name>
	<name-loc>Призрачные голоса</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Раздражающие (Annoying)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B148</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Тревожащие (Disturbing)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B148</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Дьявольские (Diabolical)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B148</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B148</reference>
	<description-loc>Вам досаждает шепот голосов, которые слышите только вы. Они могут быть невнятными или постоянно повторять одно и то же, но в любом случае вы постепенно сходите с ума.
Бросьте 3d в любой ситуации, которую мастер считает стрессовой. При 6 или меньше вы слышите голоса. Мастер должен делать бросок каждый раз, когда вы проваливаете проверку на испуг (или выбрасываете ровно столько, сколько нужно), или на самоконтроль для другого, связанного со стрессом, недостатка. Голоса дополняют любой другой результат!
Стоимость зависит от их природы:


Раздражающие: Вы слышите голоса, но точно уверены в их иллюзорности и напрямую они не мешают. Однако большинство людей, заметив, что вы реагируете на отсутствующие звуки, будет реагировать с - 2. -5 очков.
Тревожащие: Голоса похожи на описанные выше, но способны заглушить окружающие звуки и даже испугать (может потребоваться проверка на испуг). -10 очков.
Дьявольские: Голоса приказывают вам убить (себя или других) или совершить иные, не менее ужасные вещи. Находясь в стрессовом состоянии или под воздействием наркотиков, вам, возможно, придется сделать проверку Воли(Will), чтобы не выполнять "приказ" (на усмотрение мастера). -15 очков.


Призрачные голоса обычно являются признаком психических расстройств, но также могут быть следствием некой сверхъестественной одержимости. В этом случае психотерапия не в силах даже определить причину заболевания, не говоря уже о лечении. Оно возможно только после проведения экзорцизма; тогда вам придется выкупить недостаток.</description-loc>
</advantage>
	<advantage version="2">
	<name>Pitiable</name>
	<name-loc>Вызывающий жалость</name-loc>
	<base_points>5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>3</amount>
	</attribute_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Social</type>
	<reference>B22</reference>
	<description-loc>Что-то в вашем виде заставляет людей жалеть и проявлять заботу о вас. Вы получаете +3 ко всем проверкам реакции от тех, кто считает вас беспомощным, слабым или нуждающимся (но это никогда не действует на людей с недостатком Черствый). Если эта особенность соседствует с внешностью выше среднего, то Вызывающий жалость означает, что вы выглядите "мило", а не "сексуально"; если она соседствует с внешностью ниже среднего, то значит вы выглядите "скромно и умоляюще", как например бассет-хаунд.</description-loc>
</advantage>
	<advantage version="2">
	<name>Plant Empathy</name>
	<name-loc>Понимание растений</name-loc>
	<base_points>5</base_points>
	<modifier version="1" enabled="no">
		<name>Remote</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P48</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Specialized</name>
		<notes>Все земеные растения</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Specialized</name>
		<notes>Все водные растения</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Specialized</name>
		<notes>@Крупное множество: Травы, деревья и т.п.@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Specialized</name>
		<notes>@Мелкое множетсво: Вечнозеленые, Лечебные и т.п.@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B75</reference>
	<description-loc>У вас есть необычайное понимание с растениями. При каждой встрече мастер тайно кидает IQ, и в случае успеха вы получаете общую информацию о состоянии его здоровья и происхождении.
При встрече с разумными растениями преимущество работает как Эмпатия (с. B51), и позволяет применять любые навыки влияния (с. B359) на них.
Часто сочетается с несколькими уровнями таланта Садовник (с. B89), и Чувством долга (растения или природа) или Клятвой (использовать растительные материалы только добытые без нанесения серьезного вреда растению).</description-loc>
</advantage>
	<advantage version="2">
		<name>Possession</name>
		<name-loc>Переселение</name-loc>
		<description-loc>Вы можете перемещать ваше сознание в другое тело. Теоретически, таким образом вы можете жить вечно, перемещаясь из умирающего тела в здоровое. Однако, вы не можете жить вне тела. Если погибает ваше текущее тело, вы погибаете тоже. Это заставляет вас хранить ваш «носитель» живым, по крайней мере, пока вы не найдете ему замену.
Для захвата нового тела, вы должны концентрироваться в течение 1 секунды и физически его коснуться. Попытки переселиться в вашу Куклу (с. B78) автоматически успешны. Во всех других случаях вы должны выиграть в состязании вашего IQ против Воли(Will) жертвы. Ваша жертва получает +5 на бросок сопротивления, если сейчас с вами сражается, или иначе предупреждена о попытке вселения.
Если вы проигрываете, вы будете ментально оглушены на 1d секунд, и никогда не сможете захватить эту жертву снова – она получает «иммунитет» к вам.
В случае победы вы захватываете тело жертвы, полностью подавляя ее личность. Личность предыдущей жертвы (если она была разумной) восстанавливает контроль через 1d секунд ментального оглушения, и ничего не помнит из того, что было во время вашего контроля над ней.
Вы получаете все физические атрибуты (ST, HT, DX) и особенности нового тела, и сохраняете ваши исходные IQ, Восприятие(Per), Волю(Will) и все ментальные черты. Социальные черты могут оказывать влияние, в зависимости от законов и ценностей общества.
Особо следует сказать о навыках. Навыки, основанные на IQ, PER, Will остаются неизменными. Все остальные навыки сохраняют относительный уровень от своего атрибута. Например, если вы изначально имели навык Акробатика на уровне DX+3, то вы будете иметь навык Акробатика-12 в теле с DX 9, и Акробатика-14 в теле с DX 11. 
Если вы занимаете тело разумного существа, вы получаете достаточный доступ к его памяти, чтобы изучить его имя и общие привычки, но недостаточно для изучения IQ-навыков. Для вспоминания определенного факта из памяти жертвы, вы должны прокинуть IQ со штрафом -1 за каждый прошедший с момента возникновения факта час. На вспоминание каждого факта позволена только одна попытка!
Если вы занимаете тело долгое время или постоянно переключаетесь между несколькими телами, мастер может модифицировать очковую стоимость вашего персонажа, чтобы отразить особенности наиболее обычного тела (см. Главу 9).

С применением различных модификаторов, Переселение может отражать разнообразные способности. Обратите внимание, что ограничения Цифровое, Магическое, Паразитическое, Спиритуальное и Телепатическое – взаимоисключающие.
===Особые улучшения.===

Усвоение (Assimilation): Когда вы захватываете новое тело, вы можете «забыть» любой из ваших исходных навыков и потратить освободившиеся – и любое количество свободных – очки на изучение любого навыка (основанного на ST, DX или НТ), известного жертве. Максимальный уровень приобретенного таким образом навыка – исходный уровень жертвы -1. Забытые навыки теряются навсегда, а новоприобретенные будут переноситься с вами в новые тела, как ваши собственные. +10%.

Постоянство (Chronic): когда вы покидаете текущее тело, вы можете оставить лазейку, которая позволит вам вернуться в него без броска состязания. Такое тело должно быть оплачено как Кукла (Puppet). Использование этого расширения требует, чтобы у вас было достаточно свободных очков персонажа, чтобы купить Куклу в момент покидания тела. +20%.

Смена разума (Mind Swap): разум нового тела и ваш разум просто меняются местами – вы перемещаетесь в новое тело, а бывший его владелец занимает ваше старое. +10%.

Телеконтроль (Telecontrol): вы можете контролировать ваше новое тело как Куклу, в то время как ваше тело пребывает в трансе. Вы можете вернуться в исходное тело в любое время, и должны сделать это, если ваш текущий носитель теряет сознание или погибает (сон не требует возврата в свое тело). В результате, вы не погибнете, если погибает ваша жертва. +50%.

===Особые ограничения.===

Цифровое (Digital): Доступно только обладателям Цифрового разума (с. B48). Вы можете захватывать контроль над компьютерами, но не над живыми организмами. Система-цель должна быть подключена к текущему «телу» через сеть, и вы должны иметь к ней полный доступ – желательный или нет (см. Компьютерный взлом, с. B184). Целевой компьютер должен иметь сложность, достаточную, чтобы запустить вашу программу (в общем, Сложность (Complexity), должна быть равна не менее половины вашего IQ). Вы также можете оставлять в компьютере вашу копию, которая будет действовать, как оригинал. Однако, если у вас нет цифровой версии Разделения (с. B50), любая система вне вашего контроля, но с вашей личностью, становится независимым NPC, считающим себя вами. Это может быть как хорошо, так и плохо – дубликат может стать любым видом Ассоциированого NPC (с. B31). -40%.

Магическое (Magical): Ваша способность – врожденный магический талант. Если субъект защищен заклинанием от враждебной магии, вам придется сначала выиграть состязание вашего IQ против уровня заклинания, чтобы попытаться захватить цель. Если жертва имеет Сопротивление к магии, уровень преимущества вычитается из вашего IQ и добавляется к Воле(Will) жертвы в быстром состязании. -10%.

Требуется связь разума (Mindlink Required): вы можете захватывать только тех, с кем у вас стоит Связь разумов. Если связь будет заглушена, выйдет из зоны действия и т.д., одержание будет разрушено. Если Связь разумов имеет ограничение Телекоммуникация, это ограничение может быть представлено имплантом или подобной технологией. -40%.

Нет доступа к памяти (No Memory Access): вы не получаете никакого доступа к памяти жертвы. -10%.

Паразит (Parasitic): вы физически проникаете в жертву. Вы должны иметь способность Проницание (плоть) (с. B75), если у вашего носителя нет достаточного уровня Багажа (с. B74) – и жертва должна иметь SM по крайней мере на 1 уровень больше. Вы можете попытаться захватить контроль только после вхождения в нее. Жертва сопротивляется по высшему из НТ и Воли(Will). В случае провала вы не можете больше пытаться захватывать этого субъекта снова, и должны искать другое тело. Когда вы находитесь в чужом теле, но не захватили его, владелец или его друзья могут попытаться обнаружить и удалить вас. Атаки, игнорирующие или пробивающие защиту носителя, могут ранить вас, но НР его работают для вас как дополнительные очки DR. Если вы – микроорганизм, вы должны приобрести черту Сопротивление повреждениям (Диффузный) (с. B60), которая будет защищать вас. Носитель кормит вас, но, возможно, будет вынужден есть больше. Вы можете покинуть тело когда захотите, тем же путем, каким вошли. Вы можете также временно освободить тело от своего духа, оставаясь внутри него, но когда захотите снова взять контроль над ним, вы должны снова бросать состязание для захвата. -60%.

Только куклы (Puppet Only): вы можете захватывать только свои куклы, и никого больше. -30%.

Духовное (Spiritual): доступно только обладателям черты Дух (с. B263). Ваше духовное тело сливается и занимает тело носителя. Оно остается нематериальным, но недоступно для вас и теряет разум. Оно может быть повреждено также, как описано в ограничении Паразит, но только атаками, воздействующими на нематериальных существ. Экзорцист может изгнать вас, выиграв в состязании его навыка изгнания против вашей Воли(Will), и вы не сможете попытаться вернуться в то же тело в течение 24 часов после изгнания. Вы можете покинуть тело в любое время. Когда вы оставляете тело-носитель, его прежняя личность восстанавливается через 1d секунд ментального оглушения. -20%.
Телепатическая (telepathic): Ваша способность – часть псионической силы Телепатии. -10%.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>100</base_points>
		<modifier version="1" enabled="no">
			<name>Усвоение (Assimilation)</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Постоянство (Chronic)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Смена разума (Mind Swap)</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Телеконтроль (Telecontrol)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Цифровое (Digital)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Магическое (Magical)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Требуется связь разума (Mindlink Required)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Нет доступа к памяти (No Memory Access)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Паразит (Parasitic)</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только куклы (Puppet Only)</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Духовное (Spiritual)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B76</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Full Memory Access</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>P67</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Telecontrol 2</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P67</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P67</reference>
			<notes>@Basis: Carbon Based@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P67</reference>
			<notes>@Planet of Origin: Terran@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P67</reference>
			<notes>@Kingdom: Animalia@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P67</reference>
			<notes>@Class: Mammalia@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P67</reference>
			<notes>@Species: Canis Lupus@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specialized</name>
			<cost type="percentage">-35</cost>
			<affects>total</affects>
			<reference>House</reference>
			<notes>@Family: Canidae@</notes>
		</modifier>
		<reference>B75</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Post-Combat Shakes</name>
		<name-loc>Шок после боя</name-loc>
		<description-loc>Бой вызывает у вас дрожь и тошноту, но только после его завершения. Сделайте проверку на самоконтроль по окончании любого сражения. Окончание боя определяет мастер; он же может добавить пенальти за особенно опасную или жуткую битву. При провале бросьте 3d, прибавьте степень своей неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 12, а получилось 14, бросьте 3d+2 и смотрите результат в таблице. Он влияет на вас немедленно!</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B150</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Power Investiture</name>
		<name-loc>Дарованная сила</name-loc>
		<description-loc>Покровитель – божество, великий дух, демон, космическая сила и др. – наградила вас способностью сотворять жреческие заклинания. При вычислении уровня изучаемых заклинаний вы получаете премию, равную уровню Дарованной силы. Например, IQ 12 и Дарованная сила 2 (Тор) позволит вам изучать заклинания, предоставляемые Тором (и только им), как если бы ваш IQ был равен 14.
Вы можете изучать заклинания только из списка, утвержденного вашим божеством. Мастер определяет список и роль божества во время изучения заклинания. Поскольку вы направляете силу свыше, а не изучаете науку, жреческие заклинания не имеют требований.
В общем, чем выше уровень Дарованной силы, тем выше ваша святость. Максимальный уровень зависит от божества. Слабые божества с ограниченными способностями или силами могут дать только один уровень, особенно могущественные более щедры.
Обратите внимание, что Дарованная сила – мера вашей связи с божеством, а Ранг и Духовный сан – социального статуса. Они не обязаны быть связаны между собой – божество может даровать силы кому захочет.
В некоторых случаях вы можете получать или увеличивать уровень Дарованной силы во время игры – детали этого зависят от мастера. Вы почти обязаны иметь одну или более добровольных ментальных недостатков (с. B121). В случае нарушения ваших клятв, вы можете потерять некоторые – или все – ваши силы, и возможно, даже навсегда. По сути, Дарованная сила уже включает в себя Договор (с. B113) – и не может получать дополнительных выгод от этого ограничения.
Возможно также, вы должны будете отвечать некоторым физическим требованиям. Некоторые божества наделяют только мужчин, женщин, девственниц или евнухов. Потеряв этот «пререквизит» (например, девственность), вы ограничите или потеряете вашу силу.
Вы можете иметь и Магические способности и Дарованную силу (если божество не запрещает этого), но Магические способности не влияет на жреческие заклинания, и наоборот. Жреческая и магическая версия одного заклинания – совершенно разные заклинания, и жреческие заклинания не годятся как требования для магических.
Дарованная сила – один из возможных путей овладения «святыми силами». Другие варианты предоставляются Благословением (с. B40) или Истинной верой (с. B94).</description-loc>
		<type>Mental, Supernatural</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<reference>B77</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Precognition</name>
		<name-loc>Предвидение</name-loc>
		<description-loc>Вы получаете видения о будущих событиях. Вы не можете их контролировать – вы просто знаете, что может случиться интересного или важного, и некоторое понятие о времени события. Вы можете получать информацию в виде видений, голосов или просто «внезапного знания». Внезапное предвидение ужасающих событий может потребовать от вас броска Страха (с.360).
Предвидение дает информацию только касающуюся вас, имеющую для вас значение, и доступную для вашего понимания и получения вами. Например, если вы находитесь в Нью-Йорке, вы не получите видения о случайном убийстве в Лос-Анджелесе. Однако, если жертва – ваш друг, или убитый – достаточно важная персона, чтобы ее показали в национальных новостях, вы можете получить озарение.
Помните, что будущее все равно остается неопределенным однозначно. Даже если Мастер рассказал вам о будущем, он может передумать… Хотя может произойти что-то связанное с предвидением. В большинстве сеттингов, предсказанное событие может случиться, если вы не предпримете никаких действий для его предотвращения. 
Когда Мастер считает, что может случиться озарение, он тайно делает бросок вашего IQ – обычно при встрече с персонажем или предметом. Например, встретив кого-то, в чьей жизни ожидается важное событие, вы можете получить предвидение, связанное с этим событием, особенно – если оно каким-то образом касется вас. Также, изучение изображения некоторого места может вызвать видение, связанное с ним. 
Намеренная попытка использования предвидения требует 10 минут концентрации, затрачивания 2 FP, и броска IQ с -8. Вы можете таким образом пытаться узнать будущее свое собственное или кого-то другого (но вы должны касаться его). 
Обычно срок предсказания ограничен ближайшим будущим – где-то около недели. На усмотрение Мастера, критический успех или особенно важное событие может позволить заглянуть и в более отдаленное будущее.
Обратите внимание, что Предвидение уже включает Чувство опасности.

===Особые ограничения.===
Не видит свою смерть (Can’t See Own Death): Ваша способность предсказывать не может показывать события и людей, которые, по мнению Мастера, несут высокую вероятность вашей смерти. Ваша способность не включает в себя Чувство опасности. -60%.

ЭСВ (ESP) (-10%): ваша способность – часть псионической силы ЭСВ. -10%.
Только один тип событий (One Event): Ваша способность работает только в отношении определенного вида событий: непосредственно затрагивающих вас (если вы сканируете будущее другого человека, вы увидите только значительные события, и то, если они вас касаются); опасности, события, связанные со смертью, события, связанные с любовью и пр. Ограничение исключает взятие Не видит свою смерть. -40%.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>25</base_points>
		<modifier version="1" enabled="no">
			<name>Не видит свою смерть (Can’t See Own Death)</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B77</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Один тип событий (One Event)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B77</reference>
			<notes>@Тип событий@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Directed</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P68</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Active Only</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Passive Only</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<reference>B77</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Pressure Support</name>
		<name-loc>Устойчивость к давлению</name-loc>
		<description-loc>Каждый персонаж имеет «родное давление». Для людей – это давление земной атмосферы (1 АТМ). Если вы можете длительно жить под более широким диапазоном давления, вы имеете преимущество.

Уровень 1: Вы можете выдержать любое давление вплоть до 10-кратного природного. Это позволит человеку выжить в большинстве континентальных шельфов. 5 очков.

Уровень 2: Вы можете выдержать даже 100-кратное давление. Это позволит человеку выжить даже в самых глубоких океанах Земли. 10 очков.
Уровень 3: Вы полностью иммунны к эффектам высокого давления. 15 очков.
Это преимущество сохраняет в организме постоянное внутреннее давление в относительно постоянном равновесии с давлением окружающей среды. Это значит, что носитель устойчив к любому повреждению, которое исходит от экстремальных барометрических перепадов или которое влияет на целое тело, но не дает никакой защиты от локального увеличения давления – такого как взрыв, удар оружия или тиски, сжимающие голову.
Это преимущество часто сочетается с Герметичностью (с. B82), но это необязательно.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<reference>B77</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Protected Sense (@Sense@)</name>
		<name-loc>Защищенное чувство</name-loc>
		<description-loc>Одно из ваших дальних чувств защищено от перегрузки. Оно мгновенно адаптируется под измененное состояние, позволяя вам нормально работать максимум через две секунды неудобств. Вы не получаете постоянных повреждений чувствам за чрезмерную нагрузку, и получаете +5 на броски сопротивления временным повреждениям и атакам на чувства. 
Защита чувств стоит по 5 очков за каждое из них. Защищенное зрение защищает глаза от лазеров, позволяет адаптироваться к быстрому изменению освещения. Защищенный слух защищает от громких звуков. Защищенное обоняние защищает от сильных запахов и вкусов, но не от токсинов. Другие виды чувств (Обнаружение, Сканирование и т.д.) также позволены.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B78</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Proud</name>
		<name-loc>Гордость</name-loc>
		<description-loc>
Эгоист (B153) на уровне причуды. Вы очень заботитесь о собственном успехе, богатстве, или социальном положении. NPC с этой причудой реагируют с -1 на приказы, оскорбления, или пренебрежительное отношение.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Psionophobia (Psionics, Common)</name>
	<name-loc>Боязнь псионических способностей (Псионофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь тех, кто использует псионические способности, а их демонстрация в вашем присутствии потребует проверки самоконтроля. По своей воле вы никому не позволите применить на себе пси-способности. Эти способности не обязательно должны быть реальными, главное, чтобы вы в них верили! -15 очков, если пси-способности широко распространены, -10, если они являются редкостью, -5 если они практически неизвестны. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Psionophobia (Psionics, Uncommon)</name>
	<name-loc>Боязнь псионических способностей (Псионофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь тех, кто использует псионические способности, а их демонстрация в вашем присутствии потребует проверки самоконтроля. По своей воле вы никому не позволите применить на себе пси-способности. Эти способности не обязательно должны быть реальными, главное, чтобы вы в них верили! -15 очков, если пси-способности широко распространены, -10, если они являются редкостью, -5 если они практически неизвестны. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Psionophobia (Psionics, Unknown)</name>
	<name-loc>Боязнь псионических способностей (Псионофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь тех, кто использует псионические способности, а их демонстрация в вашем присутствии потребует проверки самоконтроля. По своей воле вы никому не позволите применить на себе пси-способности. Эти способности не обязательно должны быть реальными, главное, чтобы вы в них верили! -15 очков, если пси-способности широко распространены, -10, если они являются редкостью, -5 если они практически неизвестны. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Psychometry</name>
		<name-loc>Психометрия</name-loc>
		<description-loc>Вы можете чувствовать историю места или предмета – использование, личность владельца и пр. Это обычно сверхъестественный дар некоторого вида (например, псионика), но также возможно и техногенное «сканирование прошлого».
Для использования вы должны концентрироваться в течение 1 секунды, касаясь предмета или места, и сделать успешный бросок IQ. Бросок не получает штрафа, если событие случилось в текущий день, -1, если случилось в пределах 10 дней назад; -2, если 100 дней назад; -3 – до 3 лет назад; -4 за 30 лет, -5 за 300 лет, и так далее – по -1 штрафа за каждые х10 срока давности.
На усмотрение мастера, вы можете заметить особенно мощное излучение даже не концентрируясь, успешно бросив IQ-4.
В случае успеха вы получаете общее представление о событиях и эмоциях, связанных с предметом или областью, если они действительно связаны с эмоционально насыщенными событиями (неприметная история может вообще не оставить следов). Это не всегда хорошо – негативные эмоции могут потребовать от вас броска Страха (с. B360). В случае критического успеха вы получаете некое видение. Независимо от успешности броска, вы не можете обнаружить магию, духов и пр. однако, магический предмет, населенный духами дом или ритуальный алтарь обычно имеют довольно насыщенную историю.
В случае провала, вы не получаете никаких впечатлений, и не можете пытаться провести психометрию снова на этот предмет или область в течение 24 часов.

===Особые ограничения.===
ЭСВ (ESP): Ваша способность – часть псионической силы ЭСВ (с. B255). -10%.


===Новые особые улучшения ===
Направленная (Directed): Вы можете концентрироваться на определенных событиях прошлого. Предмет поиска заявляется до броска. Успех означает, что вы получаете достаточно подробную информацию об этом событии, а не общий поток эмоций. При провале вы ничего не узнаете. Критический провал означает, что вы не сможете больше никогда узнать ничего об этой странице истории.
+50%.
Погружение (Immersive): Успешный бросок способности вызывает четкое видение, как при критическом успехе обычной, немодифицированной способности. Если вы изучаете предмет, вы получаете видение с его точки зрения, при сканировании места – видите все так, как будто присутствовали там сами. Это улучшение может разрушить интригу приключения – используйте его с осторожностью! +100%.
Чувствительное (Sensitive): Вы получаете знания даже о простой жизни предмета. Например, изучая кинжал – вы узнаете, кто его сделал, как часто его затачивали и где он хранился, когда не использовался для убийства. +30%.

===Новые особые ограничения===
Только активное (Active Only): Вы не получаете спонтанных видений, независимо от силы «излучения». Вы можете узнать что-то лишь намеренно применив способность. -20%.
Гиперсенсорное (Hypersensory): Вы восстанавливаете прошлое по небольшим частицам, получаемым через ваши обычные чувства. Вы не получаете сверхъестественное знание, но эти подсказки дают вам только общие мысли о происшедшем. Вы получаете по -3 за каждое заблокированное чувство (обоняние, зрение, осязание). Этот модификатор включает Обычная жизнь, и взаимоисключает взятие Погружения и Чувствительности. -50%.
Обычная жизнь (Mundane): Вы не можете получить информации о эмоциональных зарядах из прошлого. Ваша способность может обнаружить только общие детали о простой жизни предмета – как описано в модификаторе Чувствительное (не приобретайте оба модификатора). -30%.
Только пассивное использование (Passive Only): Вы не можете использовать способность по желанию – только пассивно. Обнаруживаются сильные заряды на броске ИН-4. Исключается взятие Направленное, Чувствительное и любых из трех вышеуказанных ограничений. -60%
<br></description-loc>
		<type>Mental, Supernatural</type>
		<base_points>20</base_points>
		<modifier version="1" enabled="no">
			<name>Directed</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Immersive</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Sensitive</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Active Only</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Hypersensory</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Mundane</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Passive Only</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P69</reference>
		</modifier>
		<reference>B78</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Puppet (@Ally Group@)</name>
		<name-loc>Кукла (@Группа@)</name-loc>
		<description-loc>Требования: Переселение, плюс Иждивенец или Союзник.
Кукла – Союзник (с. B36) или Иждивенец (с. B131), который не может сопротивляться вашим попыткам Переселения – они автоматически успешны. Это может происходить из чего угодно – проклятия, знания истинного имени, ключа к разуму и пр.
Кукла всегда имеет IQ 0, или поклялась служить вам (Служба, с. B133), или является Перепрограммируемой (с. B150). В случае Службы, она должна быть Недобровольной, и ее частота должна быть равна частоте появления куклы как Союзника или Иждивенца.
Каждая кукла стоит 5 очков. Целая группа связанных союзников в качестве куклы стоит 10 очков. Это цена исключительно за куклу, союзник или иждивенец оплачивается отдельно. Обычно (но не обязательно) такие союзники имеют модификаторы Слуга или Недобровольный.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>10</base_points>
		<reference>B78</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">possession</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="contains">ally</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="contains">dependant</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Puppet (@Ally or Dependant@)</name>
		<name-loc>Кукла (@Союзник или Иждивенец@)</name-loc>
		<description-loc>Требования: Переселение, плюс Иждивенец или Союзник.
Кукла – Союзник (с. B36) или Иждивенец (с. B131), который не может сопротивляться вашим попыткам Переселения – они автоматически успешны. Это может происходить из чего угодно – проклятия, знания истинного имени, ключа к разуму и пр.
Кукла всегда имеет IQ 0, или поклялась служить вам (Служба, с. B133), или является Перепрограммируемой (с. B150). В случае Службы, она должна быть Недобровольной, и ее частота должна быть равна частоте появления куклы как Союзника или Иждивенца.
Каждая кукла стоит 5 очков. Целая группа связанных союзников в качестве куклы стоит 10 очков. Это цена исключительно за куклу, союзник или иждивенец оплачивается отдельно. Обычно (но не обязательно) такие союзники имеют модификаторы Слуга или Недобровольный.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>5</base_points>
		<reference>B78</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="contains">dependant</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="contains">ally</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
			</prereq_list>
			<advantage_prereq has="yes">
				<name compare="is">possession</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Pyromania</name>
		<name-loc>Пиромания 
</name-loc>
		<description-loc>Вы обожаете огонь и любите его зажигать! Чтобы хорошо отыграть эту черту, вы не должны упускать случая что-нибудь поджечь или поддержать встреченный огонь. Каждый раз, когда есть возможность зажечь огонь, делайте проверку на самоконтроль.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B150</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Pyrophobia (Fire)</name>
	<name-loc>Боязнь огня (Пирофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вас обеспокоит даже тлеющая сигарета, если ее владелец находится ближе, чем в пяти ярдах от вас. -5 очков.*

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Quadriplegic</name>
		<name-loc>Парализованный 
</name-loc>
		<description-loc>У вас парализованы все руки и ноги или вообще нет конечностей. Вы не можете использовать или перемещать предметы без посторонней помощи. Вы страдаете от эффектов недостатков Паралич ног (см. Хромой, B141) и Нет манипуляторов (см. Нет хороших манипуляторов, B145). Если мастер вводит ограничение по недостаткам, то Парализованный под него подпадает -  но при этом вы имеет право снизить ST и DX на 4 или менее уровней, и полученные за это очки не будут входить в ограничение по недостаткам (если вы будете снижать и дальше, то эти очки будут входить в лимит).
Подробности о протезировании конечностей и хирургическом лечении см. в описаниях недостатков Хромой (B141) и Однорукий (B147) для ног и рук соответственно.</description-loc>
		<type>Physical</type>
		<base_points>-80</base_points>
		<reference>B150</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Racial Memory</name>
	<name-loc>Расовая память</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Пассивная (Passive)</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B78</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Активная (Active)</name>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B78</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Immersive</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P70</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B78</reference>
	<description-loc>Вы имеете доступ к памяти ваших прямых генетических предков (или предыдущих поколений программ в случае Цифрового разума). Существует две формы:

Пассивная (Passive): Талант неопределенный и полностью пассивный. Мастер тайно бросает IQ в ситуациях, которые могли встретиться вашим предкам. В случае успеха персонаж получает неопределенное чувство дежавю в отношении к этой ситуации. Интерпретация этого налагается на персонажа. В случае критического успеха вы получаете смутное видение. При провале не случается ничего, а при критическом провале информация будет ложной. 15 очков.
Активная (Active): Вы можете использовать способность по желанию. Мастер сначала определяет, наличие предков, знающих ответ. Потом мастер бросает IQ персонажа, чтобы посмотреть доступность информации. Если предки не имеют ответа, вы узнаете это, если бросок успешен. В случае критического провала, персонаж верит, что предки ответа не знают, даже если они знают ответ. Использование этого преимущества требует одного хода полной концентрации (мастер может потребовать бОльших приготовлений для вызова очень древних воспоминаний). 40 очков.

===Новое особое улучшение===
Погружение (Immersive): Успешное применение способности дает видение, подобное таковому при критическом успехе. При пассивном варианте способности это снимает необходимость интерпретации, при активном – вы можете просматривать жизни предков по желанию! +50%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Radiation Tolerance</name>
	<name-loc>Устойчивость к радиации</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 2</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 5</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 10</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 20</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 50</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 100</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 200</name>
		<cost type="points">35</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 500</name>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>PF: 1000</name>
		<cost type="points">45</cost>
		<affects>total</affects>
		<reference>B79</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Extended</name>
		<notes>@Тип@</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>P70</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B79</reference>
	<description-loc>Ваши клетки и ткани устойчивы к радиации. Стоимость преимущества зависит от уменьшения эффективной дозы радиации, полученной вами – после модификации дозы Уровнем защиты (Protection Factor, PF) искусственной защиты, брони.
!Делитель|	Цена
|	2|	5 очков
|	5|	10 очков
|	10|	15 очков
|	20|	20 очков
|	50|	25 очков
|	100|	30 очков
|	200|	35 очков
|	500|	40 очков
|	1,000|	45 очков	</description-loc>
</advantage>
	<advantage version="2">
	<name>Rank</name>
	<name-loc>Звание</name-loc>
	<notes>@Организация@: @Титул@</notes>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Заменяет статус (Replaces Status)</name>
		<cost type="points">5</cost>
		<affects>levels only</affects>
		<reference>B29</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Отставные звания (Courtesy)</name>
		<cost type="points">-4</cost>
		<affects>levels only</affects>
		<reference>B29</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B29</reference>
	<description-loc>Отдельные части общества - например, гражданские чиновники, военные или представители могущественных церквей - часто обладают внутренней системой званий, отличной от Статуса. Если подобная организация обладает существенным влиянием в обществе или доступом к полезным ресурсам, то ее члены должны заплатить очки за звание в данной организации.
Звания измеряются по уровням. Каждый, кто обладает более высоким Званием, имеет власть над теми, чье Звание ниже - независимо от личных способностей. В большинстве случаев, существует от шести до восьми уровней Званий. Мастеру следует определить, какое максимальное Звание доступно персонажам в начале, обычно это Звание от 3 до 5.
В отличие от Статуса, для поддержания Звания не требуется денежных вложений. С другой стороны, почти все виды Звания требуют Службы (см. B133). Звание обычно имеет строгие требования - чаще всего это одна из Привилегий (B30) или минимальный уровень в умении. Эти вещи имеют собственную стоимость, не включенную в стоимость Звания.
В обществе обычно имеется несколько систем Званий; точный их выбор зависит от игрового мира. В большинстве случаев вы можете иметь более чем один вид Звания, хотя мастер волен объявить, что один вид Звания препятствует получению других.
Звание может соседствовать со Статусом. Если так, то высокое Звание дает дополнительный Статус без дополнительной оплаты: +1 к Статусу за Звание 2-4, +2 к Статусу за Звание 5-7 и +3 к Статусу за Звание 8 и выше. Это отражает общественное уважение к высокопоставленным членам важных общественных учреждений. Если вы обладаете различного рода Званиями, то можете получить бонус к Статусу за каждое из них.
В качестве альтернативы, один из видов Звания может замещать Статус; например, Духовное звание в теократическом обществе. В подобных обществах Статуса не существует. Каждый уровень Духовного звания дает вам свои обычные преимущества плюс эффекты Статуса, равного по уровню.
Звание стоит 5 очков за уровень, если оно сосуществует со Статусом, или 10 очков за уровень, если оно вытесняет Статус. Распространенные разновидности Званий включают в себя:
Административное звание: Должность в государственном аппарате. Когда вы имеете дело с другими управленцами, то разница в Званиях работает по тому же принципу, что и разница в Статусе (B28). При TL5 и выше крупный чиновничий аппарат может иметь несколько видов званий: для каждого министерства они свои, возможны дополнительные категории для сената, судебных органов и т.д. (Представители министерства обороны и правоохранительных органов используют вместо этого Воинские или Полицейские звания.) Отметьте это в листе персонажа; например, Административное звание (Судебное).
Торговое звание: Положение в государственной или межгосударственной торговой организации. Это может быть что угодно от торговой организации ацтеков (у которых Торговое звание было приближено к Статусу) до "торгового флота" в современном или футуристическом обществе (где Торговое звание во время войны обычно соответствует Воинскому званию).
Воинское звание: Положение в военной организации. У каждой организации отдельная структура. В целом, те, кто не командует непосредственно, обладают Званием 0-2, а представители младшего офицерского или старшего сержантского состава получают Звание 3-4. Звания 5 и выше оставлены для высшего командного состава и офицеров, несущих ответственность за крайне ценные или редкие ресурсы. Офицеры, специалисты и прочие представители личного состава с ограниченными обязанностями, небольшой действительной ответственностью или возможностью командовать, согласно GURPS имеют более низкое Звание, хотя формально могут носить звания, соответствующие более высокому уровню; отразите это с помощью одного или большего количества уровней преимущества Отставное звание (см. Отставное звание, B29).
Полицейское звание: Положение в правоохранительных структурах. У каждого учреждения собственные Звания. Вы обязаны приобрести преимущество Представитель силовых структур (B65), прежде чем взять Полицейское звание; в этом разница между патрульным офицером (Полицейское звание 0 за 0 очков) и обычным гражданином (Полицейское звание отсутствует, также 0 очков). Обратите внимание, что в полицейском государстве нет разницы между Полицейским и Воинским званием.
Духовное звание: Положение в духовной иерархии. У каждой религии собственные Звания. Вы должны приобрести преимущество Церковный сан (B43), прежде чем взять Духовное звание; в этом разница между послушником (Духовное звание 0 за 0 очков) и мирянином (Духовное звание отсутствует, также 0 очков). Другие часто встречаемые требования включают минимальный уровень в умении Теология, принадлежность к определенному полу или расе. Разница в Званиях работает по тому же принципу, что и разница в Статусе (см. B28), когда вы имеете дело с единоверцем или с тем, кто уважает вашу веру.</description-loc>
</advantage>
	<advantage version="2">
	<name>Rapid Healing</name>
	<name-loc>Быстрое заживление</name-loc>
	<base_points>5</base_points>
	<prereq_list all="yes">
		<attribute_prereq has="yes" which="ht" compare="at least">10</attribute_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B79</reference>
	<description-loc>Все виды ран заживают на вас, как на собаке. Преимущество доступно в двух вариантах: 

Быстрое заживление: (требуется HT 10+) Когда вы бросаете кубики при восстановлении потерянных HP, или чтобы увидеть, заживает ли сломанная часть тела, делайте бросок HT+5. 5 очков.
Очень быстрое заживление: (требуется HT 12+) как описано выше, однако при успехе восстанавливается 2 HP, а при провале - 1 HP.  15 очков.

Данное преимущества не помогает от оглушения и т.п. (См. Восстановление сознания, c.B80).</description-loc>
</advantage>
	<advantage version="2">
	<name>Rapid Healing, Very</name>
	<name-loc>Быстрое заживление</name-loc>
	<base_points>15</base_points>
	<prereq_list all="yes">
		<attribute_prereq has="yes" which="ht" compare="at least">12</attribute_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B79</reference>
	<description-loc>Все виды ран заживают на вас, как на собаке. Преимущество доступно в двух вариантах: 

Быстрое заживление: (требуется HT 10+) Когда вы бросаете кубики при восстановлении потерянных HP, или чтобы увидеть, заживает ли сломанная часть тела, делайте бросок HT+5. 5 очков.
Очень быстрое заживление: (требуется HT 12+) как описано выше, однако при успехе восстанавливается 2 HP, а при провале - 1 HP.  15 очков.

Данное преимущества не помогает от оглушения и т.п. (См. Восстановление сознания, c.B80).</description-loc>
</advantage>
	<advantage version="2">
		<name>Rapier Wit</name>
		<name-loc>Острый язык</name-loc>
		<description-loc>Вы можете отпускать колкости, ошеломляя врагов в бою. Это не требует даже маневра – разговор – это свободное действие. Киньте состязание Публичного выступления против Воли(Will) врага. 
Модификаторы: -2, если враг не понимает юмора; любые модификаторы, которые Мастер сочтет нужным назначить за вашу речь; -1 за каждого оппонента после первого (и вы должны знать, что вся группа, на которую вы воздействуете, в каком-то отношении родственна друг другу – бойцы одного подразделения или жители одной семьи). Невозмутимые (с. B95) неуязвимы.
В случае успеха ваш оппонент ментально оглушен. Критический успех – враг получает 1 НР вреда, случайно повредив себе (что-нибудь уронил на ногу, поперхнулся и пр.). В случае вашего проигрыша – никакого эффекта, а при критическом провале – вы разозлили врага (возможно, активировав его Кровожадность или Неиствоство).</description-loc>
		<type>Mental</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Words of Power</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P70</reference>
		</modifier>
		<reference>B79</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Reawakened</name>
		<name-loc>Пробужденный</name-loc>
		<description-loc>Вы можете не изучать, а вспоминать навыки, изученные вами в прошлых жизнях. Вы должны покупать эти навыки обычным путем – это просто особая версия Необычного Происхождения (с. B96), объясняющая, как вы могли этому научиться без учителя.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>10</base_points>
		<reference>B80</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Recovery</name>
		<name-loc>Восстановление сознания</name-loc>
		<description-loc>Вы очень быстро приходите в сознание. Время восстановления сознания при его потере по любой причине, делится на 60: часы становятся минутами, минуты – секундами. Месячная кома превратится в 12-часовой сон.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<reference>B80</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Reduced Consumption</name>
		<name-loc>Уменьшенная потребность в пище</name-loc>
		<description-loc>Вы можете выжить гораздо дольше без питания – хотя оно все равно необходимо (вообще отсутствие потребности в пище – Не требуется пищи и воды, с. B50). Существует четыре уровня:
* Вы нуждаетесь только в 2/3 обычного количества воды и пищи, или топлива (два раза в день).
* Вы нуждаетесь только в 1/3 обычного количества питания или топлива (один раз в день).
* Вы можете есть только раз в неделю (или всего 5% от обычного количества).
* Вы можете есть всего раз в месяц (или 1% от обычного количества).

===Особые ограничения.===

Луженый желудок (Cast-iron Stomach): Вы нуждаетесь в обычном количестве питания, но вам не важно качество. Вы можете есть даже гнилые овощи и плесневелое мясо, и пить протухшее молоко. Вместо уменьшения объема питания вы соответственно уменьшаете денежные суммы, затрачиваемые на еду. -50%.

Только еда (Food Only): Вам необходимо обычное количество воды, но вы меньше едите. -50%.
Только вода (Water Only): Вы должны есть как обычно, но можете пить меньше. -50%.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<modifier version="1" enabled="no">
			<name>Луженый желудок (Cast-iron Stomach)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только еда (Food Only)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только вода (Water Only)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B80</reference>
		</modifier>
		<reference>B80</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Regeneration</name>
	<name-loc>Регенерация</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Медленная (Slow)</name>
		<notes>1 HP в 12 часов</notes>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Обычная (Regular)</name>
		<notes>1 HP в час</notes>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Быстрая (Fast)</name>
		<notes>1 HP в минуту</notes>
		<cost type="points">50</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очень быстрая (Very Fast)</name>
		<notes>1 HP в секунду</notes>
		<cost type="points">100</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Мгновенная (Extreme)</name>
		<notes>10 HP в секунду</notes>
		<cost type="points">150</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Исцеление радиации (Heals Radiation)</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только исцеление радиации (Radiation Only)</name>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Fatigue Recovery</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Fatigue Only</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P70</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Limited: @Advantage@ Only</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P70</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Bane</name>
		<notes>@Common or Very Common@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Bane</name>
		<notes>@Occasional@</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Bane</name>
		<notes>@Rare@</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B80</reference>
	<description-loc>Ваши раны заживают за часы, минуты или секунды. Чтобы регенерировать потерянные конечности, вам также необходимо Отращивание (Regrowth) – но регенерация сильно ускоряет этот процесс. В стоимость преимущества включено Быстрое лечение (с. B79).
Вы не можете иметь регенерацию, если у вас замедлено (Slow Healing, с. B155) или отсутствует (Unhealing, с. B160) лечение. Регенерация совместима с Истощением (Draining, с. B132), но не восстанавливает здоровья, потерянного из-за этого недостатка.

Цена преимущества зависит от скорости регенерации:

Медленная (Slow): Вы восстанавливаете 1 НР каждые 12 часов, в дополнение к обычному лечению. 10 очков.

Обычная (Regular): Вы восстанавливаете 1 НР в час. 25 очков.

Быстрая (Fast): Вы восстанавливаете 1 НР в минуту. 50 очков.

Очень быстрая (Very Fast): Вы восстанавливаете 1 НР в секунду. 100 очков.

Мгновенная (Extreme): Вы восстанавливаете по 10 НР в секунду. 150 очков.

===Особые улучшения.===

Исцеление радиации (Heals Radiation): Вы также способны избавиться от радиационного излучения – со скоростью в 10 раз большей, чем скорость вашей регенерации. Также вы регенерируете постоянный вред от радиации. +40%.

===Особые ограничения.===

Только исцеление радиации (Radiation Only): Вы способны исцелять только радиационное поражение. -60%.

===Новое особое улучшение===
Восстановление Усталости (Fatigue Recovery): Доступно только при регенерации Быстрой и лучше. Вы восстанавливаете потерянные очки ЕУ с той же скоростью, как и ЕЖ. +100%.

===Новые особые ограничения===
Только усталость (Fatigue Only): Ваша способность восстанавливает только ЕУ, как в улучшении Восстановление усталости. Она не включает Быстрое лечение и не восстанавливает ЕЖ. -0%.

Ограниченное (Limited): Ваша способность ускоряет восстановление определенного преимущества, но не здоровья. Например, «Только СП» ускоряет восстановление очков СП, потерянных в результате разъедания или поломки, «Только отращивание» позволяет быстрее отращивать конечности. Подсчитайте необходимое для отращивания время в днях и разделите его на 3 (медленная регенерация), считайте часы за дни (обычная), минуты (быстрая), секунды (очень быстрая), секунды/10 (мгновенная).
«Только бессмертие» исцеляет хиты, но только после смерти – и останавливает восстановление при достижении положительных хитов (бессмертие 2) или полных хитов (бессмертие 3). -40%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Regrowth</name>
		<name-loc>Отращивание</name-loc>
		<description-loc>Вы можете заново выращивать потерянные конечности и органы. Потерянный палец, коготь, кончик щупальца, ухо отрастет за 1d недель; кисть или ступня – за 1d+1 месяцев; рука, нога или глаз – 2d+2 месяцев. Если у вас есть еще и регенерация – вы отращиваете все потерянные части тела, когда возвращаетесь в полные хиты.
===Особые улучшения.===
Ограниченное отращивание (Minor): вы можете отращивать только небольшие части тела – уши, пальцы, и пр. – но не кисти, руки и глаза. -50%.

===Новые особые улучшения===
Удвоенное (Doubling): Когда вы теряете часть тела, вы можете отрастить сразу две – как мифическая гидра! Вы должны иметь необходимое количество очков, чтобы оплатить соответствующее преимущество (Дополнительная рука, Дополнительная голова и т.д.), иначе отрастёт только одна часть.
Отращивание идет с обычной скоростью. +25%, если работает только с одной частью тела (только с руками, ногами, головой и пр.), +50%, если работает для любых п о т е р я н н ы х частей тела.

Присоединение (Reattachment): Вы можете прирастить отсечённую, но целую часть тела, удерживая
ее на месте в течение минуты. Регенерация уменьшает это время: до 30 секунд Медленная, до 3 секунд Обычная, до 1 секунды, если
Быстрая или лучше (но Очень быстрая или Сверхбыстрая вообще может избавить вас от необходимости в этом улучшении). +50%.

===Новые особые ограничения===
Отрава (Bane): Вы не можете отрастить части тела, потерянные из-за вреда от определенного вещества или субстанции (серебра или огня, например), или подвергнутые ее воздействию (одно из двух, на выбор). Цена зависит от редкости: Редкие -10%, частые -30%, Распространенные и повсеместные -50%.

Только присоединение (Reattachment Only): Вы можете только присоединять потерянные конечности, как описано в соответствующем улучшении. Ваша способность не помогает, если конечность покалечена, испарилась или была съедена. -50%.
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>40</base_points>
		<modifier version="1" enabled="no">
			<name>Ограниченное отращивание (Minor)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Doubling</name>
			<cost type="percentage">25</cost>
			<affects>total</affects>
			<reference>P71</reference>
			<notes>Только @Часть тела@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Doubling</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Reattachment</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P71</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Bane</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P71</reference>
			<notes>@Rare@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Bane</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P71</reference>
			<notes>@Occational@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Bane</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P71</reference>
			<notes>@Common or Very Common@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Reattachment Only</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P71</reference>
		</modifier>
		<reference>B80</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Reprogrammable</name>
		<name-loc>Перепрограммируемый</name-loc>
		<description-loc>Вас можно запрограммировать на подчинение хозяину. При Рабском менталитете (B154) вы должны подобострастно повиноваться и действовать строго в пределах указаний хозяина. При отсутствии этого недостатка вы можете творчески их интерпретировать, оставаясь в пределах буквы или смысла приказов (по вашему выбору). Если вы не обладаете сознанием (IQ 0), вы не заинтересованы в их выполнении, но следуете программе!
Вы можете взять недостатки Долг и Перепрограммируемый. В таком случае вы стараетесь выполнять все свои обязательства, но при возникновении противоречий программирование всегда первично.
Эта черта в основном присуща големам, лишенной разума нежити, роботам и тому подобным автоматам. Она редко подходит для персонажей, и мастер вправе вообще запретить ее.</description-loc>
		<type>Mental, Exotic</type>
		<base_points>-10</base_points>
		<reference>B150</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2" round_down="yes">
	<name>Reputation</name>
	<name-loc>Репутация отрицательная</name-loc>
	<points_per_level>-5</points_per_level>
	<levels>1</levels>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount per_level="yes">-1</amount>
	</attribute_bonus>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>Почти все в вашем мире</notes>
		<cost type="multiplier">1</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>Почти все в вашем мире кроме @большая группа людей@</notes>
		<cost type="multiplier">0.67</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>@большая группа людей@</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>@Маленькая группа людей@</notes>
		<cost type="multiplier">0.33</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают всегда</name>
		<cost type="multiplier">1</cost>
		<reference>B28</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают иногда</name>
		<notes>10-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B28</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают редко</name>
		<notes>7-</notes>
		<cost type="multiplier">0.33</cost>
		<reference>B28</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B26</reference>
	<description-loc>Вы можете быть известны настолько, что ваша репутация становится преимуществом или недостатком. Это влияет на броски реакции, производимое неигровыми персонажами (см. с.494). Репутация имеет четыре составляющие: подробности, Модификатор реакции, Группа влияния и Частота узнавания.

Подробности о вашей репутации полностью определяете вы сами; вы можете быть известны своей храбростью, жестокостью, тем что поедаете зеленых змей или чем угодно. Однако вы обязаны обозначить подробности. Репутация - это по определению что-то, заслужи вающее внимания; не существует некой «общей» репутации.

Модификатор реакции
Выберите модификатор к реакции от людей, которые вас узнают. Это определит базовую стоимость вашей репутации. За каждую премию +1 к реакции (вплоть до +4) цена составляет 5 очков. За каждый штраф -1 (вплоть до -4), цена составляет -5 очков

Группа влияния
Размер группы людей, которая о вас слышала, влияет на базовую стоимость:
Почти все в вашем мире (но не жители других вселенных - по крайней мере пока они не встретятся с вами!):x1
Почти все в вашем мире за исклю чением одной группы (все кроме французов, все кроме эльфов, все кроме пришельцев из других миров):x2/3 (округлять вниз).
Большая группа людей (все люди определенной веры, все наемники, все торговцы и т.д.): x1/2 (округлять вниз).
Небольшая группа людей (все священники Уазу, все грамотные люди в Англии XII века, все маги в современной Алабаме): x1/3 (округлять вниз).
Если, по мнению Мастера, группа этих людей мала настолько, что вы не встретите не одного из них по ходу обычного приключения, то ваша репутация не стоит очков. Это зависит от мира; например, наемни ки встречаются редко в одних мирах и часто в других.

Частота узнавания
Вашего имени или лица достаточно, чтобы потребовался «бросок репутации», позволяющий установить, узнали вас встреченные люди или нет. Бросок делается один раз за человека или небольшую группу встречных. Для большой группы Мастер может, если сочтет нужным,потребовать нескольких бросков.
То, как часто вас узнают, влияет на стоимость вашей репутации:
Всегда: x1.
Иногда (результат 10 или меньше): x1/2 (округлять вниз).
Редко (результат 7 или меньше): x1/3 (округлять вниз).
Конечно, ваша репутация работает лишь в определенном месте. Если вы уезжаете достаточно далеко, Мастер может потребовать от вас «выкупить» недостаток в виде дурной репутации. (Никакой премии за потерю хорошей репутации не дается.

Различная репутация 
У вас может быть больше одного вида репутации, и один её вид может перекрывать другой. Мастер должен пробросить все её виды, прежде чем определить, как отреагирует на вас NPC. Общий модификатор к реакции не может быть в заданной ситуации больше +4 или меньше -4.

Многоаспектная репутация
Один тип репутации может давать разные модификаторы к реакции от разных групп, при условии что эти группы не пересекаются. Установите модификатор для каждой группы, измените цену в зависимости от их размера и в сумме посчитайте конечную цену. Измените это общее число в зависимости от частоты узнавания. Такая репутация будет преимуществом, если общее число очков положительно, и недостатком - если отрицательно. Конечная стоимость может быть равна 0, но вы все же должны записать репутацию в лист персонажа</description-loc>
</advantage>
	<advantage version="2" round_down="yes">
	<name>Reputation</name>
	<name-loc>Репутация положительная</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount per_level="yes">1</amount>
	</attribute_bonus>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>Почти все в вашем мире</notes>
		<cost type="multiplier">1</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>Почти все в вашем мире кроме @большая группа людей@</notes>
		<cost type="multiplier">0.67</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>@большая группа людей@</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Группа влияния</name>
		<notes>@Маленькая группа людей@</notes>
		<cost type="multiplier">0.33</cost>
		<reference>B27</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают всегда</name>
		<cost type="multiplier">1</cost>
		<reference>B28</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают иногда</name>
		<notes>10-</notes>
		<cost type="multiplier">0.5</cost>
		<reference>B28</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Узнают редко</name>
		<notes>7-</notes>
		<cost type="multiplier">0.33</cost>
		<reference>B28</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B26</reference>
	<description-loc>Вы можете быть известны настолько, что ваша репутация становится преимуществом или недостатком. Это влияет на броски реакции, производимое неигровыми персонажами (см. с.494). Репутация имеет четыре составляющие: подробности, Модификатор реакции, Группа влияния и Частота узнавания.

Подробности о вашей репутации полностью определяете вы сами; вы можете быть известны своей храбростью, жестокостью, тем что поедаете зеленых змей или чем угодно. Однако вы обязаны обозначить подробности. Репутация - это по определению что-то, заслужи вающее внимания; не существует некой «общей» репутации.

Модификатор реакции
Выберите модификатор к реакции от людей, которые вас узнают. Это определит базовую стоимость вашей репутации. За каждую премию +1 к реакции (вплоть до +4) цена составляет 5 очков. За каждый штраф -1 (вплоть до -4), цена составляет -5 очков

Группа влияния
Размер группы людей, которая о вас слышала, влияет на базовую стоимость:
Почти все в вашем мире (но не жители других вселенных - по крайней мере пока они не встретятся с вами!):x1
Почти все в вашем мире за исклю чением одной группы (все кроме французов, все кроме эльфов, все кроме пришельцев из других миров):x2/3 (округлять вниз).
Большая группа людей (все люди определенной веры, все наемники, все торговцы и т.д.): x1/2 (округлять вниз).
Небольшая группа людей (все священники Уазу, все грамотные люди в Англии XII века, все маги в современной Алабаме): x1/3 (округлять вниз).
Если, по мнению Мастера, группа этих людей мала настолько, что вы не встретите не одного из них по ходу обычного приключения, то ваша репутация не стоит очков. Это зависит от мира; например, наемни ки встречаются редко в одних мирах и часто в других.

Частота узнавания
Вашего имени или лица достаточно, чтобы потребовался «бросок репутации», позволяющий установить, узнали вас встреченные люди или нет. Бросок делается один раз за человека или небольшую группу встречных. Для большой группы Мастер может, если сочтет нужным,потребовать нескольких бросков.
То, как часто вас узнают, влияет на стоимость вашей репутации:
Всегда: x1.
Иногда (результат 10 или меньше): x1/2 (округлять вниз).
Редко (результат 7 или меньше): x1/3 (округлять вниз).
Конечно, ваша репутация работает лишь в определенном месте. Если вы уезжаете достаточно далеко, Мастер может потребовать от вас «выкупить» недостаток в виде дурной репутации. (Никакой премии за потерю хорошей репутации не дается.

Различная репутация 
У вас может быть больше одного вида репутации, и один её вид может перекрывать другой. Мастер должен пробросить все её виды, прежде чем определить, как отреагирует на вас NPC. Общий модификатор к реакции не может быть в заданной ситуации больше +4 или меньше -4.

Многоаспектная репутация
Один тип репутации может давать разные модификаторы к реакции от разных групп, при условии что эти группы не пересекаются. Установите модификатор для каждой группы, измените цену в зависимости от их размера и в сумме посчитайте конечную цену. Измените это общее число в зависимости от частоты узнавания. Такая репутация будет преимуществом, если общее число очков положительно, и недостатком - если отрицательно. Конечная стоимость может быть равна 0, но вы все же должны записать репутацию в лист персонажа</description-loc>
</advantage>
	<advantage version="2">
	<name>Resistant</name>
	<name-loc>Устойчивость</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Повсеместные : метаболические опасности@</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B80</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Распространенные : Яды / болезни.@</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Частые: Инфекции или Внутренние яды, и т.п.@</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Редкие : Ускорение, Морская болезнь, декомпрессия, наномеханизмы и т.п.@</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>Иммунитет (Immunity)</name>
		<cost type="multiplier">1</cost>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>+8 ко всем броскам сопростивления HT</name>
		<cost type="multiplier">0.5</cost>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>+3 ко всем броскам сопростивления HT</name>
		<cost type="multiplier">0.33</cost>
		<reference>B81</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B81</reference>
	<description-loc>Вы устойчивы или даже иммунны к вредным субстанциям, которые не являются прямыми физическими атаками. Это дает вам премию к броскам НТ для сопротивления определенной категории воздействий – обычно это болезни, яды, синдромы (космическая болезнь, кессонная болезнь и прочие). Также применяется к атакам, использующим подобные эффекты – обычно Воздействия с модификацией Воздействие через Кровь, Воздействие при контакте, Воздействие при вдыхании, Нужен носитель, и врожденным атакам с такими же модификаторами, наносящими токсическое или изнуряющее повреждение.
Сопротивление не защищает от эффектов, от которых защищает (или дает иммунитет) Сопротивление вреду или Защищенное чувство (включает большинство Природных атак и Воздействий без вышеуказанных модификаторов).

Базовая цена зависит от редкости.

Повсеместные (Very Common): широкая категория (метаболические опасности – все угрозы, которые воздействуют только на живых существ, включая яды, болезни, всевозможные синдромы вроде укачивания, кессонной болезни и т.д.). 30 очков.

Распространенные (Common): группа связанных опасностей, встречающиеся как в природе, так и в виде атак, или подходящая часть Очень обычных. Яды (все токсины, но не кислоты) или Болезни. 15 очков.

Частые (Occasional): группа близких опасностей, чаще встречающихся в природе, чем в атаках. Инфекции (все вирусные, грибковые, бактериальные) или Внутренние яды. 10 очков.
Редкие (Rare): один предмет или синдром, или подгруппа Частых. Ускорение, Морская болезнь, декомпрессия, наномеханизмы. 5 очков.
Эта цена модифицируется уровнем сопротивления:
* Полный иммунитет, бросков сопротивления не требуется. *1,0.
* Премия +8 к броскам НТ: *0,5.
* Премия +3 к броскам НТ: *0,3.
Все дроби отбрасываются.
Обычный человек может реалистично иметь сопротивление любого уровня обычному Редкому воздействию – такому, как Морская болезнь. Он также может иметь сопротивление к Инфекции (+3) 3, (+8) 5, или Ядам (+3) 5. Все более серьезное – удел нелюдей. Големы, нежить, роботы, и все остальные объекты, не являющиеся живыми по-настоящему, должны вместо этого брать иммунитет к метаболическим угрозам 30, он уже включен в мета-черту Механизм (с. B263).
Ментальное сопротивление. Действует точно также, но только против чисто ментальных видов воздействия - опасностей, которые требуют броска IQ или Воли(Will) вместо НТ. В данном случае позволяется категория «Псионика», которая является Повсеместной.</description-loc>
</advantage>
	<advantage version="2">
		<name>Responsive</name>
		<name-loc>Отзывчивый</name-loc>
		<description-loc>
Мягкая форма Филантропии (B125). Вы способны понять чувства и стремления других - и в обычных условиях склонны помогать окружающим.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Restricted Diet (@Food@)</name>
	<name-loc>Ограниченный рацион (@Еда@)</name-loc>
	<base_points>0</base_points>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очень распространенное</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B151</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Распространенное</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B151</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Редкое</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B151</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Исключительное</name>
		<cost type="points">-40</cost>
		<affects>total</affects>
		<reference>B151</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Замена (Substitution)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B151</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B151</reference>
	<description-loc>Вам требуются специальная пища или топливо, которые трудно достать. В отличие от Зависимости (B130), вы не получаете повреждений, когда их нет... просто не можете поесть или заправиться, что в конце концов выведет вас из строя. Стоимость зависит от редкости потребляемого вещества:


Исключительное: кровь дракона, необычная питательная смесь, оружейный уран. -40 очков.
Редкое: кровь девственниц, ракетное топливо, младенцы, радиоактивные материалы. -30 очков.
Распространенное: Человеческая плоть, бензин, жидкий водород. -20 очков.
Очень распространенное: Свежее мясо, любое углеводородное топливо (бензин, дизельное и т.д.), электрические батареи, свежая кровь. -10 очков.


Ограниченный рацион подходит для обычных людей с хроническими желудочно-кишечными нарушениями.
Специальные ограничения
Замена: Вы можете попытаться заменить нужную пищу или топливо на похожие. Например, киборг, которому нужна необычная питательная смесь, может попробовать обычную человеческую пищу, а машина, которой требуется бензин - дизельное топливо. Это поддержит ваши силы, но потребует проверки HT после каждого приема пищи или дозаправки. Неудача означает уменьшение HT на единицу,  пока вам не будет обеспечен нужный медицинский или механический уход. Критическая неудача означает недееспособность (на усмотрение мастера): тяжелая иммунная реакция, отказ двигателя и т.п. Если кто-то без этого ограничения попытается заменить нужное вещество, это ему в любом случае не поможет и потребует проверки HT, как описано выше; причем успех трактуется как неудача, а неудача - как критическая неудача.-50 %.</description-loc>
</advantage>
	<advantage version="2">
		<name>Restricted Vision (No Peripheral Vision)</name>
		<name-loc>Ограниченная область зрения (Нет периферического зрения)</name-loc>
		<description-loc>У вас необычно узкая область зрения. Обычный человек, не поворачивая голову, видит в пределах 120° сектора перед собой и 30 ° периферического зрения по обе его стороны, что в сумме дает 180° "сектор видимости" для наблюдения и дистанционных атак. На боевой карте это означает, что у него три "передних" гекса, два "боковых" ("левый" и "правый"), и один "задний". Ваша область зрения более ограничена. Она может быть двух типов:


Нет периферического зрения: Ваш сектор видимости составляет 120 ° спереди. На карте "левые" и "правые" гексы становятся "задними" - то есть у вас три "задних" гекса, и вы не можете защищаться против атак оттуда! -15 очков.
Узкая область зрения: Ваш сектор видимости составляет 60° спереди. На карте остается только один "передний" гекс - прямо перед вами. Гексы по боком от него становятся "боковыми": Вы получаете -2 к защите при нападении оттуда, а сами можете атаковать их только Ударом наугад (Wild Swing). Все остальные гексы - "задние", как описано выше. -30 очков.</description-loc>
		<type>Physical</type>
		<base_points>-15</base_points>
		<reference>B151</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Restricted Vision (Tunnel Vision)</name>
		<name-loc>Ограниченная область зрения 
 (Узкая область зрения)</name-loc>
		<description-loc>У вас необычно узкая область зрения. Обычный человек, не поворачивая голову, видит в пределах 120° сектора перед собой и 30 ° периферического зрения по обе его стороны, что в сумме дает 180° "сектор видимости" для наблюдения и дистанционных атак. На боевой карте это означает, что у него три "передних" гекса, два "боковых" ("левый" и "правый"), и один "задний". Ваша область зрения более ограничена. Она может быть двух типов:


Нет периферического зрения: Ваш сектор видимости составляет 120 ° спереди. На карте "левые" и "правые" гексы становятся "задними" - то есть у вас три "задних" гекса, и вы не можете защищаться против атак оттуда! -15 очков.
Узкая область зрения: Ваш сектор видимости составляет 60° спереди. На карте остается только один "передний" гекс - прямо перед вами. Гексы по боком от него становятся "боковыми": Вы получаете -2 к защите при нападении оттуда, а сами можете атаковать их только Ударом наугад (Wild Swing). Все остальные гексы - "задние", как описано выше. -30 очков.</description-loc>
		<type>Physical</type>
		<base_points>-30</base_points>
		<reference>B151</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Revulsion (@Common substance@)</name>
		<name-loc>Отвращение 
 (Обычное вещество)</name-loc>
		<description-loc>У вас сверхъестественная болезненная реакция на обычно безвредное вещество. Прикоснувшись к нему или вдохнув его, вы должны немедленно сделать проверку HT. При неудаче вы получаете -5 ко всем умениям и атрибутам в течение следующих 10 минут. Если вещество попадает внутрь, вы получаете -5 к атрибутам и -10 к умениям и Проверке чувств в течение 10 минут. Стоимость зависит от редкости вещества:


Редкое (кожа, мыло): -5 очков.
Обычное (дым, дерево): -10 очков.
Распространенное (трава, металл): -15 очков.


Эта реакция по своей природе является физической. Если нужно отразить психическое отвращение, см. Боязнь (B132).</description-loc>
		<type>Physical, Supernatural</type>
		<base_points>-10</base_points>
		<reference>B151</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Revulsion (@Occasional substance@)</name>
		<name-loc>Отвращение 
 (Редкое вещество)</name-loc>
		<description-loc>У вас сверхъестественная болезненная реакция на обычно безвредное вещество. Прикоснувшись к нему или вдохнув его, вы должны немедленно сделать проверку HT. При неудаче вы получаете -5 ко всем умениям и атрибутам в течение следующих 10 минут. Если вещество попадает внутрь, вы получаете -5 к атрибутам и -10 к умениям и Проверке чувств в течение 10 минут. Стоимость зависит от редкости вещества:


Редкое (кожа, мыло): -5 очков.
Обычное (дым, дерево): -10 очков.
Распространенное (трава, металл): -15 очков.


Эта реакция по своей природе является физической. Если нужно отразить психическое отвращение, см. Боязнь (B132).</description-loc>
		<type>Physical, Supernatural</type>
		<base_points>-5</base_points>
		<reference>B151</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Revulsion (@Very Common substance@)</name>
		<name-loc>Отвращение 
 (Распространенное вещество)</name-loc>
		<description-loc>У вас сверхъестественная болезненная реакция на обычно безвредное вещество. Прикоснувшись к нему или вдохнув его, вы должны немедленно сделать проверку HT. При неудаче вы получаете -5 ко всем умениям и атрибутам в течение следующих 10 минут. Если вещество попадает внутрь, вы получаете -5 к атрибутам и -10 к умениям и Проверке чувств в течение 10 минут. Стоимость зависит от редкости вещества:


Редкое (кожа, мыло): -5 очков.
Обычное (дым, дерево): -10 очков.
Распространенное (трава, металл): -15 очков.


Эта реакция по своей природе является физической. Если нужно отразить психическое отвращение, см. Боязнь (B132).</description-loc>
		<type>Physical, Supernatural</type>
		<base_points>-15</base_points>
		<reference>B151</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Sadism</name>
		<name-loc>Садизм 
</name-loc>
		<description-loc>Вы наслаждаетесь жестокостью... моральной, физической, какой угодно. Выполняйте проверку на самоконтроль каждый раз, когда существует возможность удовлетворить свои желания, но это чревато последствиями (например, потому что пленника нужно отпустить невредимым). При провале вы не способны сдержаться. Все, кто знает об этом недостатке, реагируют на вас с -3, кроме представителей культур, не особенно ценящих жизнь.
Это особенно "злая" особенность, более подходящая для злодеев-NPC, нежели для персонажей. Мастер может запретить Садизм, если не хочет допустить его отыгрыша в кампании.
Можно, хоть это и отвратительно, взять одновременно недостатки Задира (B125) и Садизм.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B152</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Sanitized Metabolism</name>
		<name-loc>Стерильный метаболизм</name-loc>
		<description-loc>Вы полностью чисты. Ваше тело производит очень мало отходов, да и те стерильны. Вы не страдаете от плохого запаха изо рта, потения и некрасивой кожи. Пытающиеся вас отследить по запаху получают -1, и вы получаете +1 к реакции в близком общении (подводные лодки, лифты, и т.п.).
</description-loc>
		<type>Physical</type>
		<base_points>1</base_points>
		<reference>B101</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Scanning Sense</name>
	<name-loc>Сканирование</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Радар (Radar)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точный радар (Imaging Radar)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ладар (Ladar)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Пара-радар (Para-Radar)</name>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Сонар (Sonar)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Active IR</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>P72</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>T-Ray Vision</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>P72</reference>
	</modifier>	
	<modifier version="1" enabled="no">
		<name>Расширенная дуга (Extended Arc)</name>
		<notes>240°</notes>
		<cost type="percentage">75</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Расширенная дуга (Extended Arc)</name>
		<notes>360°</notes>
		<cost type="percentage">125</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Низкая возможность перехвата (Low-Probability Intercept, LPI)</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Мульти-режим (Multi-Mode)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Проницание (Penetrating)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Наведение (Targeting)</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только наведение (Targeting Only)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Bio-Scan</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P72</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>No Intercept</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P72</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Scanner</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P72</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Field Sense</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>Sup27</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B81</reference>
	<description-loc>Вы можете излучать энергию, отражающуюся от предметов и, анализируя сигнал, составлять картину окружения. Это позволяет оценивать размер и форму, но не цвет и мелкие детали (наподобие букв). Подобное чувство не нуждается в свете, и имеет мало общего с чувством зрения. Поэтому вы можете игнорировать штрафы за темноту в бою. Восприятие ограничено 120-градусной дугой впереди. 
Ваш источник излучает сигнал, поэтому каждый, кто может воспринимать ее, может обнаружить вас на расстоянии до двукратного расстояния вашего восприятия. Вы можете отключить эту способность по желанию, чтобы замаскироваться от такого вида обнаружения.

Существует множество вариантов Сканирования. Каждый вариант – отдельное преимущество, со своими правилами (приоритетные – если они противоречат вышесказанным, используются собственные правила) и стоимостью. Каждый способ сканирования имеет свою дальность, которая может модифицироваться Увеличенной (с. B106) или Уменьшенной (с. B115) дистанцией.

Радар (Radar): Ваше сканирование использует радиоволны. Базовая дистанция – 2000 ярдов. Вы можете обнаруживать только плотные крупные (SM 0+) объекты. По броску восприятия вы получаете общее представление о размере и скорости объекта, но не более. Вы не можете прицеливаться, используя только это чувство. Радар лучше работает против летающих целей: бросок на обнаружение целей, которые не представляют собой силуэт на фоне неба, делается с -4. Радар совершенно бесполезен под водой. 20 очков.

Точный радар (Imaging Radar): Ваше чувство использует миллиметровый радар. Базовая дистанция – 200 ярдов. Вы можете обнаруживать мелкие предметы и определять их форму, но чтобы распознавать точный рельеф (например, лицо), требуется бросок Восприятия(Per). Такой радар может видеть сквозь ткань и растения. Вы получаете +3 на обнаружение предметов, скрытых под одеждой или за легкой растительностью. Обычные радар-детекторы обнаруживают Точный радар с -4. Этот вид сканирования также не работает под водой. 20 очков.

Ладар (Ladar): Способ сканирования, использующий лазерный луч. Похож на Точный радар, но луч узконаправленный и обеспечивает гораздо большее разрешение. Пользователь получает -4, чтобы заметить интересующие его вещи, но +4 на их идентификацию. Обнаружить ладар можно только с помощью специализированных ладар-детекторов, но и они получают -4. Ладар не может пробить плотный дым или твердые предметы. Во время дождя или снега дальность составляет 10-50% от базовой, под водой – всего 1%. 20 очков.

Пара-радар (Para-Radar): Ваше Сканирование использует энергию, неизвестную в 21-м веке. Считайте его как Точный радар, но работающий в любых средах. Обычные детекторы не могут обнаружить его использование - возможно, ультра-технологические детекторы? 40 очков.

Сонар (Sonar): Использование ультразвуовых волн. Базовая дистанция – 2000 ярдов под водой. Вы можете обнаружить небольшие предметы и узнать их форму, но для восприятия точного рельефа (узнавание лица) требуется бросок Восприятия(Per). Сонар не работает, если вы оглохли, и может быть обманут или заглушен громким звуком (взрывом, например). Обнаружить сонар могут лица с Ультра-слухом. Сонар менее эффективен на воздухе – дистанция составляет всего (20 м, умноженные на атмосферное давление), и не работает в вакууме. 20 очков.

===Особые улучшения.===

Расширенная дуга (Extended Arc): Вы можете сканировать большую область. Дуга в 240о (как Периферическое зрение, с. B74) - +75%, 360о (Круговое зрение, с. B34)- +125%.

Низкая возможность перехвата (Low-Probability Intercept, LPI): Доступно только для радаров и сонаров. Эта отключаемая способность делает сигнал менее заметным. Дистанция обнаружения уменьшается вдвое, но и обнаружить можно только на 1,5*новая дистанция. +10%.

Мульти-режим (Multi-Mode): Доступно только для радара. Вы можете переключаться между обычным и Точным радаром – это дешевле, чем вы будете покупать эти два преимущества отдельно, поскольку они очень похожи друг на друга. +50%.

Проницание (Penetrating): Доступно только для пара-радара. Вы можете видеть сквозь любые предметы в пределах досягаемости. Работает как Проникающее зрение 2. +50%.

Наведение (Targeting): Вы можете «захватывать» цели, и определять точную дистанцию и скорость – как хороший дальномер. Это даст вам +3 на попадание, если вы будете использовать маневр прицеливания. +20%.

===Особые ограничения.===
Только наведение (Targeting Only): Вы можете использовать вашу способность восприятия только для захвата целей, уже обнаруженных другими способами. Способность обнаруживать вещи недоступна. -40%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Scotophobia (Darkness)</name>
	<name-loc>Боязнь темноты (Скотофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B149</reference>
	<description-loc>Распространенная, но очень неудобная боязнь. Вам следует по возможности избегать подземелий - если что-то случиться с вашим фонарем или факелом, вы можете сойти с ума раньше, чем удастся его зажечь. -15 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Sealed</name>
		<name-loc>Герметичность</name-loc>
		<description-loc>Вы заключены в слой, через который не могут проникать никакие газы и жидкости. Это защищает вас о жидкости и токсичных и разъедающих субстанций, которые должны коснуться вас, чтобы подействовать. Вы должны дышать, если не имеете соответствующего преимущества (Не нуждается в дыхании, с. B49), однако ваш дыхательный аппарат защищен. Вы также не защищены от перепадов давления и вакуума (приобретайте соответствующие преимущества).</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<reference>B82</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Secret (@Secret@)</name>
	<name-loc>Секрет (@Секрет@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Серьезное затруднение (Serious Embarrassment)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Полное неприятие (Utter Rejection)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Заключение или изгнание (Imprisonment)</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Возможная смерть (Possible Death)</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B152</reference>
	<description-loc>Секрет - это часть вашей жизни или прошлого, которую вы вынуждены скрывать. Открытие тайны повлекло бы за собой длительные и неприятные последствия. Стоимость зависит от их серьезности:


Серьезное затруднение: Если эта информация распространится, вы можете забыть о повышении по службе, избрании на пост или женитьбе. Или, как вариант, это просто привлечет к вам нежелательное общественное внимание. -5 очков.
Полное неприятие: Раскрытие тайны изменит всю вашу жизнь. Возможно, вы потеряете работу и будете отвергнуты друзьями и любимыми. А может быть, вас начнут преследовать поклонники, почитатели, давно забытые родственники или журналисты. -10 очков.
Заключение или изгнание: Если власти раскроют вашу тайну, вам придется скрываться, чтобы не получить длительный тюремный срок (на усмотрение мастера). -20 очков.
Возможная смерть: Ваш Секрет настолько ужасен, что после его раскрытия вас могут казнить власти, линчевать толпа или убить (мафия, ЦРУ, и т.д.). Вы станете загнанным зверем.-30 очков.


Частота появления
В общем случае Секрет появляется в конкретной игровой сессии, если мастер до ее начала выбросит не больше 6 на 3d. Однако, как и для других подобных недостатков, мастер не должен привязывать себя к броску на появление. Если мастер считает, что пришло время для Секрета, пусть так и произойдет!
Появление Секрета, однако, не означает его немедленного раскрытия. Мастер должен дать вам шанс воспрепятствовать этому. Для этого может понадобиться заняться шантажом или вымогательством, выкрасть разоблачающие документы или даже заставить замолчать человека, знающего вашу тайну. Тем не менее,  любое решение будет временным - Секрет будет появляться снова и снова, пока не окажется раскрыт или выкуплен.


Результаты раскрытия
Обнародование Секрета немедленно влечет за собой неприятности, варьирующиеся от серьезного затруднения до возможной смерти, в зависимости от его важности (см. выше). В итоге вы навсегда приобретаете новые недостатки (или теряете старые преимущества), что в сумме составляет двойную стоимость вашего Секрета! Эти недостатки заменяют Секрет в листе персонажа и соответственно уменьшают его стоимость.
Мастер выбирает новые недостатки и потерянные преимущества в соответствии с Секретом. Раскрытие тайны чаще всего способствует появлению отрицательной Репутации (B26), Врагов (B135) и Социальной дискриминации (B155), или лишают преимуществ из раздела Богатство и влиятельность (B25-B30). Некоторые тайны могут повлечь появление ментальных или физических недостатков.

=====Пример: у городского стражника Секрет на -20 очков: ночью он занимается воровством. Поимка и суд раскрывают его Секрет, который немедленно заменяется новыми недостатками и потерянными преимуществами на -40 очков! По решению мастера стражник лишается преимущества Представитель силовых структур (-5 очков), получает Социальную дискриминацию (Судимость) (-5 очков), его приговаривают к отсечению правой руки (Однорукий, -15 очков) и выплате компенсаций, которые уменьшают его Богатство со Среднего до Бедного (-15 очков).=====
</description-loc>
</advantage>
	<advantage version="2">
	<name>Secret Identity (@Secret ID@)</name>
	<name-loc>Секретное имя (@Имя@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Серьезное затруднение (Serious Embarrassment)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Полное неприятие (Utter Rejection)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Заключение или изгнание (Imprisonment)</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Возможная смерть (Possible Death)</name>
		<cost type="points">-30</cost>
		<affects>total</affects>
		<reference>B152</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B152</reference>
	<description-loc>Секретное имя - это специальный вид Секрета (выше): другая личность, используемая для дел, которые не должны быть связаны с вашим "публичным" образом. Только ваши близкие и друзья знают о ней, и вы пойдете на все, что так было и в дальнейшем. Это недостаток, потому что он ограничивает ваше поведение. Поддерживать Секретное имя тяжело и зачастую незаконно.
Чтобы увидеть, появится ли Секретное имя в ходе игровой сессии, мастер делает бросок так же, как для любого Секрета. При удаче обычно появляется кто-то, пытающийся раскрыть вашу подлинную личность. Персонаж со Статусом 3 или выше получает дополнительные -10 очков за Секретное имя из-за повышенного внимания СМИ и общественности, но угроза его личности появляется в игре при броске на 7 или меньше вместо обычных 6 или меньше.
В остальном Секретное имя похоже на любой другой Секрет; его стоимость зависит от серьезности последствий его раскрытия.</description-loc>
</advantage>
	<advantage version="2">
	<name>Security Clearance</name>
	<name-loc>Секретный доступ</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Только необходимое</name>
		<notes>@Что@</notes>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Небольшая группа сведений</name>
		<notes>@Что@</notes>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Свободный доступ</name>
		<notes>@Что@</notes>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Небольшая важность (Minor Importance)</name>
		<cost type="multiplier">0.5</cost>
		<reference>B83</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B82</reference>
	<description-loc>Правительственная организация или корпорация доверила вам доступ в важной информации, которая иначе недоступна никому вашего ранга или статуса. Например, генералу доверяют военные тайны соответственно его званию, и он не должен покупать Секретный доступ, но гражданским лицам придется заплатить за привелегию доступа к такой информации.

Цена преимущества зависит от уровня доступа.

Только необходимое: Вам доступны только тайны, напрямую необходимые для ваших действий (пилот стратегического бомбардировщика знает секреты его самолета, вооружения и целей). 5 очков.

Небольшая группа: Вы имеете свободный доступ к некой небольшой группе сведений, или «необходимые сведения» довольно широки (офицер контр-разведки, имеющий ограниченный доступ ко многим секретам, поскольку защищать их – его работа). 10 очков.
Свободный доступ: Свободный доступ ко многим секретам (секретный агент класса 007, который может узнать почти любую информацию, требуемую от него по сюжету). 75 очков.
Стоимость преимущества уменьшается вдвое, если организация, предоставляющая доступ, имеет относительно небольшую важность (небольшая корпорация или муниципалитет).
Вы не можете получить доступ к секретной информации без тщательной проверки вашего прошлого. Мастер может запретить покупку данного преимущества персонажам, которые имеют подозрительное прошлое (включая такие черты, как Долги или Секрет), или с нестабильной личностью (паранойей, садизмом и пр.).</description-loc>
</advantage>
	<advantage version="2">
		<name>See Invisible</name>
		<name-loc>Видеть невидимое</name-loc>
		<description-loc>Вы можете видеть объекты, которые обычно невидимы. Обнаружение каждого типа невидимости требует отдельного варианта преимущества.

===Новое особое улучшение===
Истинное зрение (True Sight): ваше зрение обнаруживает любые виды обмана, связанные с типом невидимости, который вы обнаруживаете – включая маскировку, изменение внешности и иллюзии. Например, Истинное зрение позволяет преимуществу Видеть невидимое (магическое) определять магические иллюзии и заклинания «Размытие» также легко, как и обычную магическую невидимость. +50%.
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>True Sight</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P73</reference>
		</modifier>
		<reference>B83</reference>
		<notes>@Тип@</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Self-Destruct</name>
		<name-loc>Саморазрушение 
</name-loc>
		<description-loc>После достижения порога старения (50 лет для обычного человека) ваши органы и иммунная система начинают сбоить. Вы быстро стареете, делая проверки на старение каждый день с -3 к HT.
Вы не можете получить очки и за Саморазрушение, и за Смертельную болезнь (B158). Если ваша старость наступит в ближайшее время, возьмите Смертельную болезнь вместо Саморазрушения.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B153</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="starts with">terminally ill</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Selfish</name>
	<name-loc>Эгоист
</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B153</reference>
	<description-loc>Как человек с большим самомнением, сознающий собственную значимость, вы проводите много времени, стремясь занять доминирующее положение в обществе. Каждый раз, когда видите по отношению к себе явное общественное пренебрежение или неуважение, выполните проверку на самоконтроль. При провале вы набрасываетесь на виновников как при Вспыльчивости (B124), что, вероятно, закончится для вас плохим отношением (-3 к реакции) и поставит в неудобное положение.
NPC-эгоисты реагируют на пренебрежительное отношение с пенальти:


!Самоконтроль	|Пенальти к реакции
|	6|-5
|	9|-4
|	12|-3
|	15|-2
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Selfless</name>
		<name-loc>Альтруист 
</name-loc>
		<description-loc>Как альтруист и бескорыстный человек, вы мало заботитесь о собственной известности и богатстве. Вы должны сделать проверку на самоконтроль, если возникает необходимость поставить свои желания (даже жизненно важные) выше чьих-то еще. У расы альтруистов будет "муравьиное сознание".</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B153</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Semi-Upright</name>
		<name-loc>Непрямоходящий 
</name-loc>
		<description-loc>У вас осанка, характерная для непрямоходящих, вроде шимпанзе. Вы можете встать более-менее удобно, что позволяет верхними конечностями бить врагов, держать ребенка или даже использовать предметы. Вы также можете передвигаться не так неуклюже и почти вертикально (-40 % к Передвижению), но при беге со скоростью полного Передвижения должны использовать все конечности. При DX 12 или больше, вы можете при ходьбе нести один или два маленьких предмета.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-5</base_points>
		<reference>B153</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Sense of Duty</name>
	<name-loc>Чувство долга</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Один человек@</name>
		<cost type="points">-2</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Друзья или компаньоны@</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Малая группа @</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Большая группа@</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Вся раса@</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Все живые существа</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B153</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B153</reference>
	<description-loc>Вы чувствуете серьезные обязательства по отношению к определенным людям. Если есть возможность помочь, вы никогда не предадите и не бросите их в беде, не позволите страдать или голодать. Эта черта отличается от Долга (B133), который возлагается на вас извне. Чувство долга всегда исходит изнутри.
Если о вашем Чувстве долга известно, мастер, определяя степень доверия к вам в опасной ситуации, будет делать бросок с +2. Однако, если вы идете против Чувства долга и действуете вопреки интересам тех, о ком должны заботиться, мастер накажет вас за плохой отыгрыш.
Мастер назначает стоимость недостатка в зависимости от размеров группы, к которой вы испытываете обязательства:


Один человек (Президент, боец вашей эскадрильи и т.п.): -2 очка
Малая группа (например, ваши близкие друзья, компаньоны по приключению или отряд):-5 очков.
Большая группа (например, народ или адепты некой религии, или каждый, кого вы знаете лично):-10 очков.
Вся раса (весь человеческий род, все эльфы, и т.д.): -15 очков.
Все живые существа: -20 очков.


Вы не можете получать очки за Чувство долга по отношению к Союзникам, Иждивенцам, или Покровителям. Стоимость этих черт уже включает в себя такие обязательства.
Вы можете брать Чувство долга по отношению к партнерам по приключению. При этом вы должны делиться своим снаряжением, оказывать помощь другим членам группы и следовать решениям большинства. Мастер может сделать это обязательным в кампаниях, где партия должна быть единой. Это даст каждому персонажу по 5 "свободных" очков... но как только вы захотите ударить в спину партнеру, сделать что-то не советуясь и т.д., мастер волен отменить ваши действия из-за этих "бонусных" очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Sensitive Touch</name>
		<name-loc>Чувствительное Прикосновение</name-loc>
		<description-loc>Ваши пальцы или подобные органы чрезвычайно чувствительны. Например, вы можете почувствовать остаток тепла на лестнице, слабую вибрацию пола при приближении кого-то, сходство или различие двух одинаковых предметов. Вы получаете +4 (дополнительно к бонусам за Обостренное осязание) на любые задачи, использующие осязание, например, поиск отличий между двумя отрезами ткани, или бросок поиска, чтобы обнаружить крохотный спрятанный предмет.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Stethoscopic</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P73</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Ultra-Fine</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>P73</reference>
		</modifier>
		<reference>B83</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Serendipity</name>
		<name-loc>Везение</name-loc>
		<description-loc>Вы способны быть в нужном месте в нужное время. Каждый уровень этой черты доставляет вам один неожиданный, но полезный случай за сессию – детали на усмотрение Мастера. Например, он может решить, что один из стражей, с которым вам необходимо поговорить – ваш кузен; или случится так, что прямо перед входом банка оказывается заведенная спортивная машина, когда вы выбегаете из банка с мешками денег.
Время от времени Мастер может потратить все ваши доступные случаи за один раз, дав вам один большой шанс (например, механик в местном гараже имеет все необходимые части для ремонта вашего антигравитационного пояса).
Вы можете просить у Мастера обстоятельства Везения, но его мнение имеет решающее значение. Если он отвергнет все ваши случаи Везения в данной игровой сессии, он может сделать вас более везучим в следующий раз.

===Новое особое улучшение===
Произвольная (Wishing): Вы можете активно желать возникновения удачных совпадений. Желаемое событие должно быть возможным и реальным для этой ситуации. Например, находясь в камере, вы можете пожелать, чтобы стражник уронил ключ, но не можете сделать так, чтобы вас перенесло домой. Мастер может запретить любое желание, которое сочтет нарушающим баланс игры. Обычные ограничения по использованию. +100%, если вы можете желать чего-нибудь и себе, и другим, +0%, если вы можете помогать только другим.
</description-loc>
		<type>Mental</type>
		<levels>1</levels>
		<points_per_level>15</points_per_level>
		<modifier version="1" enabled="no">
			<name>Wishing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P73</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Wishing</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>P73</reference>
			<notes>Только на других</notes>
		</modifier>
		<reference>B83</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Sexless</name>
	<name-loc>Бесполый</name-loc>
	<base_points>-1</base_points>
	<categories>
		<category>Quirk</category>
	</categories>
	<type>Physical</type>
	<reference>B165</reference>
	<description-loc>
		У вас нет половых органов, типичных для вашей расы, пола, и возраста; или, возможно, вы по-настоящему бесполое существо, которое только похоже на кого-то конкретной расы и пола. В некоторых культурах это может привести к снижению уровня внешности, Социальной дискриминации или Неестественным чертам. Однако есть и небольшая выгода: вас никто не соблазнит, и вы никогда не станете родителем. Это отличается от обычного бесплодия (являющегося особенностью за 0 очков).
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Shadow Form</name>
	<name-loc>Теневая форма</name-loc>
	<base_points>50</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До нулевой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B83</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B83</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B83</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Переноска предметов (Can Carry Objects)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B83</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>3-D Movement</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P74</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Light Insensitive</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P74</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Finite Thickness</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P74</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B83</reference>
	<description-loc>Вы можете становиться двумерной тенью. Это позволяет вам скользить по стенам и потолкам – и даже через тончайшие щели – с обычной скоростью. Вы также можете игнорировать гравитацию, скользя по стенам и потолкам с половиной скоростью.
Физические атаки наносят тени половинут вреда, энергетические – обычный вред, а основанные на свете – на 50% больше. Магия, псионика и другие ментальные способности воздействуют на вас обычно.

Существует также несколько серьезных недостатков: Вы не можете пересечь трехмерное пространство – вы должны скользить по поверхности. Далее, вы не можете предпринимать чисто физических действий, и не можете носить никаких обычных предметов и воздействовать на них. Тем не менее, вы можете использовать магию, псионику и ментальные действия как обычно. Если вы не можете выключить Теневую форму, она стоит -20 очков, так как здорово ограничивает взаимодействие с миром.

===Особые улучшения.===
Переноска предметов (Can Carry Objects): Вы можете носить предметы – они делаются теневыми, когда вы их подбираете, и становятся обычными, когда бросаете. Вы по-прежнему не можете влиять на не-теневые предметы. Нет нагрузки +10%, Легкая нагрузка +20%, Средняя нагрузка +50%, Тяжелая нагрузка +100%.

===Новые особые улучшения===
Трехмерное движение (3-D Movement): Вы можете отрываться от поверхности, становясь перпендикулярно ей – 
 двумерная проекция – чтобы повернуться или обойти что-то. Вы можете ходить с обычной скоростью. Все остальные недостатки Теневой формы сохраняются. +20%.
Нечувствительность к свету (Light Insensitive): ваше тело не становится настоящей тенью. Вы можете выглядеть как проекция фотографии обычного человека. Единственный игромеханический эффект – то, что вы не получаете +50% дополнительного вреда от света. +20%.

===Новое особое ограничение===
Конечная толщина (Finite Thickness): Вы не становитесь полностью двумерным. Вместо этого тело становится толщиной с лист бумаги, поэтому вы не можете проникнуть через микроскопические трещины. Поскольку ваше тело остается материальным, вы получаете обычный вред от физических атак – и поскольку вы очень тонки, то режущие атаки имеют множитель вреда ×2, а не ×1.5. Однако, поскольку вы также не являетесь тенью, вы не получаете дополнительного вреда от света (Нечувствительность к свету приобретать не надо). Вы не можете атаковать физически, и можете воздействовать на предметы только на вашей поверхности,
если имеете улучшения Переноска предметов. -50%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Shadow Form (Can't Turn Off)</name>
		<name-loc>Теневая форма  (Не выключается)</name-loc>
		<description-loc>Вы можете становиться двумерной тенью. Это позволяет вам скользить по стенам и потолкам – и даже через тончайшие щели – с обычной скоростью. Вы также можете игнорировать гравитацию, скользя по стенам и потолкам с половиной скоростью.
Физические атаки наносят тени половинут вреда, энергетические – обычный вред, а основанные на свете – на 50% больше. Магия, псионика и другие ментальные способности воздействуют на вас обычно.

Существует также несколько серьезных недостатков: Вы не можете пересечь трехмерное пространство – вы должны скользить по поверхности. Далее, вы не можете предпринимать чисто физических действий, и не можете носить никаких обычных предметов и воздействовать на них. Тем не менее, вы можете использовать магию, псионику и ментальные действия как обычно. Если вы не можете выключить Теневую форму, она стоит -20 очков, так как здорово ограничивает взаимодействие с миром.
===Особые улучшения.===
Переноска предметов (Can Carry Objects): Вы можете носить предметы – они делаются теневыми, когда вы их подбираете, и становятся обычными, когда бросаете. Вы по-прежнему не можете влиять на не-теневые предметы. Нет нагрузки +10%, Легкая нагрузка +20%, Средняя нагрузка +50%, Тяжелая нагрузка +100%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B153</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>

<advantage version="2">
	<name>Shapeshifting</name>
	<name-loc>Превращение</name-loc>
	<base_points>@Цена@</base_points>
	<modifier version="1" enabled="no">
		<name>Только внешность</name>
		<notes></notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B84</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Безграничность</name>
		<notes>Только для Полиморфа</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сохранение массы</name>
		<notes>Только для Полиморфа</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Сохранение фигуры</name>
		<notes>Только для Полиморфа</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Не может запоминать формы</name>
		<notes>Только для Полиморфа</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неточная</name>
		<notes>Только для Полиморфа. Не совместимо с Только внешность.</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Требует пробы</name>
		<notes>Только для Полиморфа. Нужно коснуться цели.</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Требует пробы</name>
		<notes>Только для Полиморфа. Требуется капля крови, клок волос и т.д.</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Требует пробы</name>
		<notes>Только для Полиморфа. Надо съесть всю цель полностью.</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>H18</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Проецируемая форма</name>
		<notes>Только для Альтернативной формы</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>H19</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Носящий кожу</name>
		<notes>Только для Альтернативной формы</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>H19</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B83</reference>
	<description-loc>Вы можете физически превращаться в одну или несколько форм кроме вашей природной. Для превращения вы должны концентрироваться в течение 10 секунд (для более быстрого превращения добавьте Уменьшенное время активации, с. B108). Усталость, раны, воздействия и увечья передаются между формами – хотя потерянные HP и FP пропорционально изменяются. Например, вы получаете 10 очков повреждения и сломали ногу в форме, имеющей 20 хитов. Когда вы из нее превратитесь в форму, имеющую только 10 хитов, вы будете иметь 5 хитов, и сломанную ногу.
Если вы вырублены или убиты, вы немедленно возвращаетесь в вашу природную форму (которая также будет без сознания или мертва). Кроме того, вы должны указать один подходящий, относительно частый, внешний фактор, который вынудит вас вернуться в природную форму независимо от вашего желания. Это должно сочетаться с происхождением вашей способности – Рассеивание магии, если ваша способность магическая, экзорцизм для одержимых духами, сильное магнитное поле для технологического превращения и т.д.

Превращение представлено двумя разными чертами: Альтернативная форма и Полиморф.
Альтернативная форма (Alternate Form) 
Подобно оборотням, вы можете принимать другую определенную форму. Это может быть что угодно, что можно построить в очках: гуманоид, животное, робот и т.д. Создайте свою вторую форму как расовый шаблон. Однако, вы можете переключаться туда и обратно. This template need not be a "stock" template. Например, если вы хотите сохранить человеческий разум в теле животного, вы можете взять шаблон животного, но изменить его интеллект (хотя это увеличит стоимость шаблона, и соответственно, цену Альтернативной формы). Какие шаблоны доступны для взятия – решает Мастер. Во время превращения, все расовые характеристики (модификаторы атрибутов, расовые преимущества и недостатки) Альтернативной формы заменяют ваши природные. Личные черты (приобретенные лично вами уровни атрибутов, навыки выше общерасовых уровней, преимущества и недостатки) – остаются, хотя уровни навыков изменятся в соответствии с изменением атрибутов.
Если шаблон Альтернативной формы имеет черты, несовместимые с вашими личными чертами, черты новой формы имеют высший приоритет. Например, если вы становитесь дельфином с недостатком Нет манипуляторов, вы временно потеряете личные преимущества, воздействующие на ваши руки (типа Высокой ловкости рук), и некоторые навыки (взлом), поскольку они будут бесполезны – хотя вы их по-прежнему помните.
Если у вас только одна альтернативная форма ценой не выше, чем ваш природный шаблон, она стоит 15 очков. Более мощные формы стоят 15 очков +90% разницы в очках между альтернативной и природной формой.
Если у вас есть множество форм, вы полностью оплачиваете наиболее дорогую форму. Менее дорогие формы стоят по 15 очков каждая. Минимальная цена – не ниже 15 очков.
Например, есть четыре шаблона: -100-очковая «Бесполезная тварь», 0-очковый человек, 80-очковый «Лютый зверь» и 100-очковый тролль. Человек, способный превращаться в Бесполезную тварь, платит 15 очков, поскольку шаблон стоит дешевле его расового. Бесполезная тварь, способная превращаться в человека, оплачивает 15 + (0,9*100) = 105 очков, поскольку этот шаблон стоит дороже. Человек, который может превращаться в тролля, также платит 15+(0,9*100)=105 очков. Человек, который может превращаться во все три другие существа, платит полную цену за наиболее дорогую форму – тролля: 105 очков. Лютый зверь и Бесполезная тварь будут стоить по 15 очков за каждую. Итого, человеку придется заплатить 135 очков.
Оборотни. Для создания классического оборотня, начните с покупки любых черт, применяемых к обеим формам – Заразная атака, Уязвимость (серебро) и пр. – как личные черты. Затем, покупается шаблон животного, как Альтернативная форма. Поскольку большинство шаблонов животных стоят 0 и меньше очков, это обычно обойдется в 15 очков, хотя более сильные существа (медведи и тигры, например) будут стоить дороже. Если звериная форма очень опасна, добавьте к шаблону такие черты, как Неистовство, Животное поведение, Кровожадность и тд. Наконец, к Альтернативной форме применяются ограничения – вроде Только в экстренных случаях (с. B112), Только непроизвольное использование (с. B115) и Неконтролируемости (с. B116). Если вы можете превращаться только при полной луне, добавляйте -40% Триггер (с. B115). 
Расы-оборотни: при создании целой расы, имеющей способность превращаться, детали Альтернативной формы обрабатываются в последнюю очередь. Подсчитайте очки всех черт расы, кроме Альтернативной формы, вычтите этот итог из цены шаблона Альтернативной формы и вычислите цену Альтернативной формы, исходя из этой разницы. Наконец, полученная стоимость альтернативной формы добавляется к цене расового шаблона, и получается итоговая стоимость.

=====Пример: Лесные дварфы могут превращаться в разумных медведей. До учета цены Альтернативной формы, расовые черты Лесных дварфов стоят 25 очков. Шаблон медведя стоит 125 очков. Разница равна 125-25 = 100 очков. Так, цена Альтернативной формы будет стоить 15+(0,9*100)=105 очков. Итоговая стоимость шаблона Лесного дварфа стоит 25+105=135 очков.=====

===Особые ограничения.===

Косметическое превращение (Cosmetic): вы превращаетесь только внешне, способности и расовый шаблон остается без изменений. -50%.
Полиморф (Morph) 
Эта способность подобна Альтернативной форме, но не ограничена одним разовым шаблоном. Вы можете принимать любую форму с некоторыми ограничениями.
Во-первых, новый шаблон должен существовать в вашем мире. Мастер должен создать шаблон сам, или взять из книг GURPS, но вы (игрок) не можете сами создать полностью новый шаблон для этого (только модифицировать существующие).
Во-вторых, вы можете превращать только в живых, или в основном живых существ (типа вампиров). Превращаться в механизмы вы можете только взяв особое улучшение.
Наконец, очковая стоимость каждого из доступных шаблонов не должна превышать определенного лимита.
Если вы можете превращаться только в существ, чей расовый шаблон стоит не больше вашего, Полиморф стоит 100 очков. Вы можете превращаться в любые формы, но не сильнее вашей природной. Для человека, сюда относятся кошки, насекомые, совы, волки и пр. Если вы хотите принимать более сильные формы, добавьте разницу между стоимостью вашей природной формой и максимальной стоимостью доступного шаблона. Например, человек, желающий уметь принимать любую форму ценой до 75 очков, заплатит за способность превращения 175 очков. Это ограничение может быть увеличено путем оплаты заработанными очками персонажа.
Вы всегда можете принять форму любого существа, которое вы можете видеть или коснуться, пока цена его расового шаблона не превышает вашего максимума. Когда вы приняли форму один раз, вы можете попробовать запомнить ее, концентрируясь в течение минуты.  После этого вы сможете превратиться в эту форму в любое время. Вы можете запомнить количество форм, равное вашему значению IQ. Когда все «ячейки памяти» заполнены, вам придется забывать предыдущие, чтобы запомнить новую.
Как и в Альтернативной форме, расовый шаблон принимаемой формы заменяет ваш расовый шаблон. Вы не можете добавлять черты в шаблон, но свободно можете убирать расовые ментальные недостатки (например, Животное поведение), и использовать свой IQ вместо пониженного расового. Такие изменения поднимают цену животных шаблонов, которые так дешевы из-за ограниченных умственных способностей. Если вы подняли цену выше ограничения Полиморфа, вам придется потратить на него больше очков.
Полиморф включает способность к косметическим превращениям. Это вам позволит имитировать любого члена любой расы, доступной вам для превращения. Вы можете имитировать любого, кого видите, но чтобы запомнить изменения, вам надо потратить слот. Имея достаточно очков в Полиморфе, вы можете использовать эту функцию для улучшения внешности. Например, 115 очков в Полиморфе позволят вам принимать любую внешность от Ужасающей до Красивой. Косметическое превращение все равно занимает 10 секунд.
Превращающиеся расы. Члены расы со способностью превращения должны вычитать очковую стоимость Превращения из расовой цены, когда определяются доступные для превращения формы.

=====Пример: Синие капли имеют способность Полиморфа ценой 125 очков – базовая способность плюс 25 очков дополнительной емкости. Это позволяет вам принимать формы ценой на 25 очков больше, чем их родная. Итоговая стоимость Синей капли со всеми другими способностями равна 175 очкам. Однако, в целях превращения, они считаются имеющими расовую стоимость 175-125=50 очкам. С 25 очками дополнительной емкости, расовая способность превращения обойдется Синим каплям в 75 очков.=====
===Особые улучшения (для любого из вариантов).===

Неограниченность (Unlimited): Вы можете принять любую форму, какую Мастер может построить на очки. Это позволит вам превращаться в роботов, механизмы и пр., как и в живых существ. Большинство обычных неживых объектов – типа тостеров и кирпичей – стоят 0 или меньше очков. С разрешения мастера, вы можете превратиться в типичный объект этого типа без описания расового шаблона. +50%.

===Особые ограничения (для любого из вариантов).===

Косметическое (Cosmetic): Вы можете изменять только внешность – ваши способности и расовый шаблон не изменяется. -50%.

Сохранение массы (Mass Conversation): Все ваши формы имеют один вес. Если вес вашей родной формы не попадает в нормальные рамки веса расы, вы не можете стать членом этой расы. Мастер должен беспощадно следовать этому правилу – никаких 70-килограммовых мышей и слонов! -20%.
Сохранение фигуры (Retains Shape): Вы можете принимать форму только тех существ, которые имеют общую форму, количество рук, положение тела и пр. – как ваше природная форма. Это ограничит доступные формы: человек сможет превращаться только в гуманоидов (эльфов и гигантов), волк – горизонтальных четвероногих, птица – только в других птиц. -20%.</description-loc>
</advantage>

	<advantage version="2">
		<name>Short Attention Span</name>
		<name-loc>Непродолжительное внимание 
</name-loc>
		<description-loc>Вам трудно концентрироваться на одной задаче дольше нескольких минут. Делайте проверку на самоконтроль каждый раз, когда вам нужно долго заниматься чем-то одним, или всякий раз, когда вас отвлекают. При неудаче вы автоматически проваливаете ту задачу, которую выполняли. Мастер может дать маленький бонус к самоконтролю там, где сосредоточенность невероятно важна - например, когда ваша жизнь под угрозой.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B153</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Short Lifespan</name>
	<name-loc>Короткий срок жизни 
</name-loc>
	<points_per_level>-10</points_per_level>
	<levels>1</levels>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B154</reference>
	<description-loc>Продолжительность вашей жизни намного короче обычной для человека. Каждый уровень недостатка уменьшает продолжительность жизни вдвое (округлять вниз). Это влияет и на возраст совершеннолетия, и на порог старения, после которого начинаются проверки на старение, и на их частоту; см. таблицу справа. Нельзя взять более четырех уровней данного недостатка. Эта черта часто берется вместе с Саморазрушением (B153).


!Уровень|	Совершеннолетие|[colspan=3]	Порог старения (частота проверок на старение)
|0 (Человек)|	18 лет|	50 лет (1 год)|	70 лет (6 месяцев)|	90 лет (3 месяца)
|	1|	9 лет|	25 лет (6 месяцев)|	35 лет (3 месяца)|	45 лет (45 дней)
|	2|	4 года|	12 лет (3 месяца)|	17 лет (45 дней)|	22 года(22 дня)
|	3|	2 года|	6 лет  (45 дней)|	8 лет  (22 дня)|	11 лет (11 дней)
|	4|	1 год|	3 года (22 дня)|	4 года (11 дней)|	5 лет  (5 дней)
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Shrinking</name>
	<name-loc>Уменьшение</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Влияние на других (Affect Others)</name>
		<notes>Одна доп. персона</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Влияние на других (Affect Others)</name>
		<notes>Две доп. персоны</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Влияние на других (Affect Others)</name>
		<notes>Три доп. персоны</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Влияние на других (Affect Others)</name>
		<notes>Четыре доп. персоны</notes>
		<cost type="percentage">200</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Влияние на ношу (Can Carry Objects)</name>
		<notes>До нулевой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Влияние на ношу (Can Carry Objects)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Влияние на ношу (Can Carry Objects)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Влияние на ношу (Can Carry Objects)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Полный вред (Full Damage)</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Полный DR (Full DR)</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Полные НР (Full HP)</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Полная скорость (Full Move)</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B85</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B85</reference>
	<description-loc>Вы можете уменьшаться по желанию. Каждый уровень позволяет уменьшить ваш SM на -1, со скоростью -1 в секунду. Возвращение к нормальному размеру идет с той же скоростью. По умолчанию, вы не можете нести ничего, даже одежды в уменьшенном состоянии.
При уменьшении новый рост находится по таблице SM. Каждые -6 к SM уменьшают рост в 10 раз. Пропорционально уменьшаются Скорость, Досягаемость (reach), Вред, НР и DR. Каждые -2 SM также уменьшают вес в 10 рас, на нечетных уровнях – дополнительно в 3 раза.

Пример. Персонаж ростом 5’10’’ (SM 0), имеет Уменьшение 12. это позволяет ему уменьшиться до SM -12, уменьшая рост на 100 (примерно до 0,7 дюймов). Однако, при этом размере, он остается всего с 1% движения, досягаемости, хитов и DR, и должен делить наносимый вред на 100. Его вес в это время уменьшается аж в 1,000,000 раз!

===Особые улучшения.===

Влияние на других (Affect Others): Вы можете уменьшать вместе с собой и других! +50% за персону.

Влияние на ношу (Can Carry Objects): Вы можете уменьшаться вместе с предметами, которые на вас надеты или которые вы несете. Уменьшенные предметы возвращаются к нормальному размеру, если их бросить. Нет нагрузки +10%, Легкая нагрузка +20%, Средняя нагрузка +50%, Тяжелая нагрузка +100%.

Полный вред (Full Damage): Вы наносите полный вред даже в уменьшенном виде. +100%.

Полный DR (Full DR): Вы сохраняете полный DR, когда уменьшаетесь. +30%.

Полные НР (Full HP): Вы сохраняете полное значение НР, когда уменьшаетесь. +30%.
Полная скорость (Full Move): Вы сохраняете свою обычную скорость в уменьшенном виде. +30%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Shtick</name>
		<name-loc>Трюк</name-loc>
		<description-loc>Вы обладаете незначительным признаком, выделяющим вас из общей массы людей. Он не дает вам никакой выгоды в бою, премий к броскам реакции, и вы не можете использовать его для заработка, но может иногда дать небольшое преимущество во время игры (на усмотрение Мастера). Они по сути не являются физическими или ментальными, могут быть весьма яркими и невероятными, или совершенно заурядными в киношной игре. Примеры: ваша одежда всегда остается чистой, даже после плавания или боя; вы можете бегать, лазать или сражаться в сапогах на шпильке, не получая штрафов за плохую стойку, и т.д. Когда ваш Трюк принесет пользу – исключительно на усмотрение Мастера.
</description-loc>
		<type>Mental/Physical</type>
		<base_points>1</base_points>
		<reference>B101, HT250, MA51</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Shyness</name>
	<name-loc>Застенчивость</name-loc>
	<skill_bonus>
		<name compare="is">acting</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">carousing</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">diplomacy</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fast-talk</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">intimidation</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">leadership</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">merchant</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">panhandling</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">performance</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">politics</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">public speaking</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">savoir-faire</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sex appeal</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">streetwise</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">teaching</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Легкая (Mild)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Тяжелая (Severe)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Критическая (Crippling)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B154</reference>
	<description-loc>Вы неуютно себя чувствуете в компании незнакомых людей. Отыграйте это! Этот недостаток представлен тремя уровнями; вы можете выкупать их по очереди.


Легкая: Вам нелегко с незнакомыми людьми, особенно с напористыми или привлекательными. Вы получаете -1 к умениям, основанным на общении, к которым относятся Артистизм, Пирушки, Дипломатия, Заговаривание зубов, Запугивание, Лидерство, Торговое дело, Попрошайничество, Выступление, Политика, Публичное выступление, Хорошие манеры, Сексапильность, Знание улиц, и Обучение.-5 очков.
Тяжелая: Вы очень неловко себя чувствуете в окружении незнакомых людей, и стараетесь быть незаметным даже среди друзей. Пенальти -2 к умениям, перечисленным выше. -10 очков.
Критическая: Вы стараетесь избегать незнакомых людей. Вы вообще не можете изучать умения, перечисленные выше, и получаете -4 к проверкам по умолчанию против данных умений. -20 очков.</description-loc>
</advantage>
	<advantage version="2">
	<name>Sign Language: @Language@</name>
	<name-loc>Язык Жестов @Язык@</name-loc>
	<modifier version="1" enabled="no">
		<name>Родной</name>
		<cost type="points">-3</cost>
		<affects>total</affects>
		<reference>B23</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жесты</name>
		<notes>Ломаный (Broken)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жесты</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жесты</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">3</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">Language Talent</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
		<category>Language</category>
	</categories>
	<type></type>
	<reference>B25</reference>
	<description-loc>Полноценный язык жестов - например, Американский Язык Жестов - это сложный художественный язык, способный передать практически любое понятие. Рассчитывайте его стоимость как и для любого другого языка, но с одним важным отличием: у этого языка есть лишь одна форма (знаковая), а не две (разговорная и письменная). Как результат, язык жестов стоит лишь половину обычной цены: 1 очко за Ломаный, 2 очка за Акцент и 3 очка за Родной уровень понимания. Персонажи с недостатками Глухой (B129) или Немой (B125) начинают игру с одним языком жестов и способностью писать на одном обычном языке - обе формы на уровне Родного языка - вместо способности разговаривать и писать на одном языке. Те, кто не владеет грамотой или языком жестов, могут вернуть очки за языковые способности по обычным правилам.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Sign Language: @Language@</name>
	<name-loc>Язык Жестов @Язык@</name-loc>
	<notes>с преимуществом "языковой талант"</notes>
	<modifier version="1" enabled="no">
		<name>Родной</name>
		<cost type="points">-2</cost>
		<affects>total</affects>
		<reference>B23</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жесты</name>
		<notes>Акцент (Accented)</notes>
		<cost type="points">1</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жесты</name>
		<notes>Как родной (Native)</notes>
		<cost type="points">2</cost>
		<affects>total</affects>
		<reference>B24</reference>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="yes">
			<name compare="is">Language Talent</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
		<category>Language</category>
	</categories>
	<type></type>
	<reference>B25</reference>
	<description-loc>Полноценный язык жестов - например, Американский Язык Жестов - это сложный художественный язык, способный передать практически любое понятие. Рассчитывайте его стоимость как и для любого другого языка, но с одним важным отличием: у этого языка есть лишь одна форма (знаковая), а не две (разговорная и письменная). Как результат, язык жестов стоит лишь половину обычной цены: 1 очко за Ломаный, 2 очка за Акцент и 3 очка за Родной уровень понимания. Персонажи с недостатками Глухой (B129) или Немой (B125) начинают игру с одним языком жестов и способностью писать на одном обычном языке - обе формы на уровне Родного языка - вместо способности разговаривать и писать на одном языке. Те, кто не владеет грамотой или языком жестов, могут вернуть очки за языковые способности по обычным правилам.</description-loc>
</advantage>
	<advantage version="2">
		<name>Signature Gear</name>
		<name-loc>Личное имущество</name-loc>
		<description-loc>У вас есть личное ценное имущество, независимое от вашего уровня богатства. Оно – часть вашей личной истории, вашей репутации или навыков. Вы должны указать, откуда оно появилось: вы выиграли свой космолет в карты, унаследовали магический меч от учителя и пр. 
Для снаряжения, покупаемого за деньги – каждое очко в преимуществе даст вам 50% от стартового среднего капитала на покупку (и только). Все, что создается как персонаж – используется правила Союзников. Как считать роботов, верных скакунов или продвинутый транспорт – зависит от мастера (как снаряжение, за деньги или как персонажей-союзников – за очки).
Если вы теряете ваше Личное снаряжение против своей воли, мастер должен дать вам возможность вернуть его. Если вы теряете его навсегда не по своей вине, мастер возвращает вам очки, или замещает чем-то равноценным.</description-loc>
		<type>Social</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<reference>B85</reference>
		<notes>Стоимость вещи = половине вашего стартового капитала за каждый уровень преимущества</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Silence</name>
		<name-loc>Бесшумность</name-loc>
		<description-loc>Вы можете передвигаться и дышать абсолютно бесшумно. Вы получаете дополнительно +2 за уровень к умению Скрытности, если не двигаетесь, или +1, если двигаетесь (даже в броне). Эти бонусы применимы только в темноте, против подслушивающих устройств, ослепленных, и других случаях, когда бесшумность важна.

===Новое особое улучшение===
Динамическая (Dynamic): ваша способность также нейтрализует звуки при движении, или маскирует их под окружающие. Вы получаете полный бонус бесшумности (+2 к Скрытности) даже в движении. +40%.

</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Dynamic</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>P76</reference>
		</modifier>
		<reference>B85</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">stealth</name>
			<specialization compare="is anything"></specialization>
			<amount>2</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Single-Minded</name>
		<name-loc>Целеустремленный</name-loc>
		<description-loc>Вы очень хорошо концентрируетесь. Вы получаете +3 на любые броски длительных ментальных задач, если мастер сочтет подобную концентрацию выгодной. Во время работы вы не замечаете ничего, что творится вокруг (для избежания этого – бросок Воли(Will)), и получаете -5 на все броски, чтобы заметить прерывание.
Мастер может решить, что некоторые сложные задачи (изобретение, магия, социальная активность) требуют разделения внимания – тогда ваша способность к концентрации не оказывает воздействия.</description-loc>
		<type>Mental</type>
		<base_points>5</base_points>
		<reference>B85</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Skinny</name>
		<name-loc>Худой</name-loc>
		<description-loc>Вы весите примерно 2/3 от нормы для данной ST. Это дает вам пенальти -2 к ST при попытках противостоять толканию. Вы также получаете -2 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. Ваш HT не может превышать 14.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B18</reference>
		<notes>-2 ST против отбрасывания</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-2</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="ht" compare="at most">14</attribute_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Slave Mentality</name>
		<name-loc>Рабский менталитет 
</name-loc>
		<description-loc>Без "хозяина", отдающего приказы, вы теряете инициативу, становитесь растерянным и ни на что не способным. Вы должны сделать проверку IQ-8, чтобы предпринять действие, не связанное с прямым приказом или обыденными делами. Вы также автоматически проваливаете любую проверку на защиту своих интересов или сопротивление социальному влиянию, кроме обстоятельств, в которых мастер считает успех возможным (в этом случае пенальти равно -6).
Это не обязательно подразумевает низкие IQ или Волю(Will). Вы можете быть достаточно умным, чтобы выполнить команду "Запрограммируй компьютер на обнаружение кварков", но если вы голодны и вдруг находите 10 долларов, вам придется сделать проверку IQ-8, чтобы подобрать деньги и купить хлеба без соответствующих указаний. Точно так же вы можете быть достаточно решительным, чтобы проходить все проверки на испуг при виде ужасных чудовищ, но станете делать проверку Воли(Will) с -6, чтобы воспротивиться грубому манипулированию очевидного мошенника.
Эта черта редко подходит для игровых персонажей и мастер вправе полностью запретить ее.</description-loc>
		<type>Mental</type>
		<base_points>-40</base_points>
		<reference>B154</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Sleepwalker</name>
		<name-loc>Ходит во сне 
</name-loc>
		<description-loc>Вы ходите во сне ("лунатик"). В большинстве случаев это просто раздражает или немного мешает (пока вы не упадете с лестницы), но при нахождении на вражеской территории может стать опасным!
Если лунатизм может иметь значение для приключения, мастер делает проверку на самоконтроль перед каждым вашим сном. При неудаче вы станете ходить во время сна. Вы проснетесь в течении 1d минут после хождения или если кто-то вас разбудит. Мастер может сделать проверку DX, чтобы увидеть, не упадете ли вы во время спуска по лестнице или при ходьбе по неровной поверхности - в таком случае вы немедленно проснетесь и будете ошеломлены.
Как предполагается, человек во время снохождения находится в полусонном состоянии, что делает его восприимчивым к телепатическому воздействию. Если вы сами наделены сверхъестественными способностями, то можете использовать их во время снохождения (например, если у вас есть Телепорт (Warp), вы можете телепортироваться  вместо ходьбы).


В большинстве случаев хождение во сне просто раздражает или немного мешает, но при нахождении на вражеской территории может стать опасным!</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B154</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Sleepy</name>
	<name-loc>Сонливый 
</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1/2 времени</name>
		<cost type="points">-8</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>2/3 времени</name>
		<cost type="points">-16</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>3/4 времени</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>7/8 времени</name>
		<cost type="points">-26</cost>
		<affects>total</affects>
		<reference>B154</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B154</reference>
	<description-loc>Это черта предназначена для расы, представителям которой необходимо спать дольше, чем людям (треть всего времени). Стоимость зависит от времени, которое вы должны тратить на сон:


!Время на сон|	Стоимость
|	1/2 всего времени|	-8
|	2/3 всего времени|	-16
|	3/4 всего времени|	-20
|	7/8 всего времени|	-26
	

Точный период бодрствования расы является "особым эффектом". Например, раса, спящая 3/4 всего времени, может вести активный образ жизни три дня подряд, а затем спать девять дней.
Эта черта также может описывать спячку. Например, если раса активна шесть месяцев, и затем впадает в спячку на два месяца, то это в среднем равняется сну в течение 1/2 всего времени.</description-loc>
</advantage>
	<advantage version="2">
		<name>Slippery</name>
		<name-loc>Скользкий</name-loc>
		<description-loc>Вас сложно удержать. Может быть, вы просто покрыты слизью, или молекулярное покрытие у вас очень гладкое, или вы окружены силовым полем, нейтрализующим трение. Каждый уровень этой черты (5 уровней максимум) дает вам +1 на все броски высвобождения и попытки протиснуться через узкие щели.</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>2</points_per_level>
		<reference>B85</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">escape</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">1</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Slow Eater</name>
		<name-loc>Медленно ест 
</name-loc>
		<description-loc>Вы тратите много времени на еду. Каждый прием пищи длится примерно два часа, в отличие от обычного для большинства людей получаса. Это уменьшает время, доступное для учебы, продолжительной работы и путешествий пешком на четыре с половиной часа в день.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-10</base_points>
		<reference>B155</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Slow Healing</name>
		<name-loc>Медленное исцеление 
</name-loc>
		<description-loc>Ваше тело заживает очень медленно. Каждый уровень (максимум их может быть три) удваивает промежуток между проверкой HT для восстановления хитов: одна проверка каждые два дня при Медленном исцелении 1, каждые четыре дня при Медленном исцелении 2, каждые восемь дней при Медленном исцелении 3. Если ваши раны заживают еще медленнее, берите недостаток Неисцеляемый (B160). Каждый уровень также удваивает время между проверками на Врачебное дело при лечении у врача (см. Медицинский уход, B424). Обычные люди могут взять не более одного уровня Медленного исцеления.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>-5</points_per_level>
		<reference>B155</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Slow Riser</name>
		<name-loc>Медленно просыпается 
</name-loc>
		<description-loc>Вы точно не "жаворонок". Проснувшись от любого сна продолжительнее часа, вы на час получаете -2 к проверкам на самоконтроль, и -1 к IQ и умениям на его основе. Кроме того, каждый раз, когда мастер назначает пенальти к атрибутам за пропущенный сон, вы получаете дополнительно -1.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B155</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Snatcher</name>
	<name-loc>Добытчик</name-loc>
	<base_points>80</base_points>
	<modifier version="1" enabled="no">
		<name>Постоянное (Permanent)</name>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченный вес (Less Weight)</name>
		<notes>1.5 кг</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченный вес (Less Weight)</name>
		<notes>1 кг</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченный вес (Less Weight)</name>
		<notes>0.5 кг</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченный вес (Less Weight)</name>
		<notes>100 грамм</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ограниченный вес (Less Weight)</name>
		<notes>30 грамм</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только металлы</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только деньги</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только оружие</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только информацию</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только не металлические</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Специализация (Specialized)</name>
		<notes>Только @цвета@</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Оглушение (Stunning)</name>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Непредсказумость (Unpredictable)</name>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B86</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Creation</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P76</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Large Items</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>P76</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>More Weight</name>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Recall</name>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B86</reference>
	<description-loc>Вы можете найти почти любой небольшой предмет в других мирах и перенести его к себе. Предмет приносится к вам не из вашего мира, а из некоего параллельного, так что вы не можете отобрать что-то у указанной персоны. Обратите внимание, что эта способность не дает вам возможности самому посещать иные миры – только таскать оттуда предметы.
Чтобы добыть что-то, вы должны концентрироваться в течение 10 секунд, и ясно представить себе желаемый предмет. Предмет должен подходить по размеру на одну руку, и не может весить более 5 фунтов. Вы должны иметь руку свободными (если руки связаны – бросок делается с -3), и другие могут видеть ваше хватательное движение.
Затем делается бросок IQ. Если вы пытаетесь добыть информацию (в любом виде), мастер делает этот бросок скрытно. Независимо от IQ, бросок 14+ - всегда провал.
В случае успеха, желаемый предмет появляется в вашей руке – или рядом, если пожелаете. В случае провала не появляется ничего, в случае критического провала вы получаете не тот предмет. Этот предмет не обязательно будет опасным, если вы не пытаетесь добыть что-то опасное.
Независимо от успеха, каждая попытка стоит 2 FP.
Доступные предметы.
Теоретически, вы можете добыть что угодно. На практике же некоторые предметы сложно найти. У вас есть неплохие шансы найти предмет, который существует или даже вообще когда-либо существовал в вашем мире – или любой подобный. Если предмет очень необычен, мастер может назначить штраф.
* Предмет значительно отличается от всего, что когда-либо существовало в вашем мире: -1 или больше (на усмотрение мастера). Вы можете представить себе «идеальный бриллиант светло-зеленого цвета, размером с куриное яйцо, ограненный в форму печатной машинки», но вам придется бросать с -20!.
* Предмет уникален или почти уникален в каждом из миров (бриллиант Хоуп): -3 или хуже, на усмотрение мастера.
* Вы не можете ясно представить себе, чего хотите. -4 или больше. Даже в случае успеха, полученный предмет может оказаться не тем, чем надо.
Вы не можете получить предмет, использующий законы природы, которые сильно отличаются от таковых вашего мира. Например, если ваш мир немагический (или не имеет известной вам магии), вы не можете получить магический предмет, поскольку не можете представить его нормально – вы получите красивый, но бесполезный предмет. Также, живя в неразвитом мире, вы не получите лазерного пистолета – в лучшем случае, это будет игрушка. Изобретательный мастер может привязать это правило к критическому успеху – и посмотреть, как плохой Добытчик пытается научиться использовать амулет или пистолет и остаться при этом в живых. 
Информация доступна только в виде обычных рапортов и книг. Вы можете найти книгу по истории, но не сможете добыть «Книгу о том, что случится в следующем приключении». Помните, что бросок на добывание информации делает мастер. В случае провала на 5+, информация приходит из мира с другой историей, физикой и пр., и неверна для мира вашего – может быть, не очень заметно.
Повторные попытки.
Повторные попытки добыть предмет можно делать немедленно после неудачной, но каждая попытка будет идти с кумулятивным штрафом -1, и стоить 4 FP вместо 2. Чтобы избавиться от этих штрафов, перерыв между попытками должен быть не менее часа. 
Мастер должен пресекать попытки обойти это. Например, пистолет 45-го калибра не очень отличается от пистолета 357 калибра. Кроме того, критические успехи в повторных попытках не засчитываются за критические.
Продолжительность.

Добытый предмет остается с вами до тех пор, пока вы не пожелаете вернуть его, или не используете способность снова. Чтобы сохранить предметы навсегда, используйте улучшение: Постоянное.

===Особые улучшения.===

Постоянное (Permanent): добытые предметы не исчезают, когда вы снова используете способность. Мастер может запретить это расширение, поскольку оно позволяет накопить несусветные богатства, таская небольшие ценные предметы. +300%.

===Особые ограничения.===
Ограниченный вес (Less Weight): лимит веса ниже, чем стандартные 5 фунтов:
!Лимит|	Модификатор
|	3 фунта|	-5%
|	2 фунта|	-10%
|	1 фунт|	-15%
|	4 унция|	-25%
|	1 унция|	-30%
	
Специализация (Specialized): вы можете добывать только определенные типы предметов, или наоборот, не можете добывать некий тип предметов. Например: Только металлические, -5%; только деньги (-10%), только оружие (-10%), только информация (-20%), только не металлические (-20%), только синие вещи (-25%): Ценность ограничения устанавливается подобно ограничению Доступность (Accessibility).

Оглушение (Stunning): Вы ментально оглушены после успешного добывания. -10%.
Непредсказумость (Unpredictable): При провале броска IQ, вы получаете что-то, но это будет не то, что вы хотели. Чем хуже бросок, тем сильнее различаются предметы. Если вы хотели заряженный пистолет – провал на 1 принесет вам незаряженный пистолет; на 2 – водяной пистолет; на 3 – книгу «Как научиться стрелять» и так далее. Критический провал – всегда опасен, независимо от желаемого предмета. -25%.

Призыв (Recall): Вы можете призывать к себе только уже существующие предметы, которые должны быть вашим личным имуществом. Вы можете призвать свой пистолет – или даже бронекостюм (с улучшением Больший вес) – но ничего, что принадлежит другим. Процесс призыва по-прежнему занимает 10 секунд, стоит 2 ЕУ и требует броска ИН, но никаких штрафов не применяется. Вызванные предметы остаются
неопределенно долго, как если бы вы их взяли обычным путем. Как обычно, вы можете отправить их обратно в любой момент. Это ограничение несовместимо с Созданием, Постоянным добыванием и Непредсказуемостью. -25%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Chameleon</name>
	<name-loc>Социальная подстройка</name-loc>
	<base_points>5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Требующие уважения</limitation>
		<amount>1</amount>
	</attribute_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B86</reference>
	<description-loc>Вы знаете, что – и когда – нужно сказать в «высшем» обществе. Вы не получаете штрафов за различие в ранге или статусе. Если нет такого штрафа, вы получаете +1 реакции от тех, кто ожидает уважения (священники, короли и пр.). Определенно, это киношное (cinematic) преимущество.</description-loc>
</advantage>
	<advantage version="2">
		<name>Social Disease</name>
		<name-loc>Заразная болезнь 
</name-loc>
		<description-loc>Вы поражены инфекционными, устойчивыми к антибиотикам бактериями, ретро-вирусом или похожей болезнью. Она передается только при близком незащищенном физическом контакте. Все, кто знает об этом, реагируют на вас с -1 и автоматически сопротивляются попыткам соблазнения. Болезнь не смертельна (по крайней мере, не убивает сразу), но может привести к появлению физических осложнений (на усмотрение игрока или мастера).</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B155</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Social Regard</name>
	<name-loc>Уважение</name-loc>
	<notes>@Тип: Страх / Уважение / Почтение@: @Причина@</notes>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount per_level="yes">1</amount>
	</attribute_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B87</reference>
	<description-loc>Вы – член класса, расы, пола или иной группы, которая почитается в вашем обществе. Принадлежность должна быть заметна для окружающих, чтобы эффекты был заметен. Это преимущество – противоположность Дискриминации, членство в определенной группе не может привести одновременно к Дискриминации и Уважению.
Уважение стоит 5 очков за +1 к броску реакции, до максимума +4. Это не репутация, хоть они и похожи. Вас уважают за то, что вы принадлежите к определенной группе, а не за то, чем известны именно вы.
Причина, из-за которой вас уважают, зависит от типа Уважения:
Страх: другие реагируют на вас, как будто вы успешно их запугали (Запугивание). Вы встретите молчаливое внимание, или даже уважение, но никогда не найдете дружеского участия. Пример: божество среди людей, воительница-амазонка.
Уважение: вам пытаются угодить, показать свое почтение – намного большее, чем если бы вы просто имели более высокий статус. Не зависит от вашего действительного статуса. Пример: член жречества или правящей расы.
Почтение: о вас заботятся, уступают место, пропускают вперед и прислушиваются к вашим словам как к крупицам мудрости. Также люди будут стараться не подвергать вас опасности и даже дискомфорту – даже если это весьма затруднительно. Пример: старейший член большинства обществ.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Criminal Record)</name>
	<name-loc>Социальная дискриминация (Судимость)</name-loc>
	<notes>-1 реакции, -2 от полиции и судий</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Полиция / Судьи</limitation>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Disowned, Non-heir)</name>
	<name-loc>Социальная дискриминация (Изгнание)</name-loc>
	<notes>-1 реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Disowned, Outcast)</name>
	<name-loc>Социальная дискриминация (Изгнание, глава)</name-loc>
	<notes>-2 Реакции</notes>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Excommunicated)</name>
	<name-loc>Социальная дискриминация (Отлучение)</name-loc>
	<notes>-3 Реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-3</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Excommunicated)</name>
	<name-loc>Социальная дискриминация (Отлучение)</name-loc>
	<notes>-3 Реакции; Плохая аура</notes>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-3</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Ignorant; @Skill@)</name>
	<name-loc>Социальная дискриминация (@Умение@) (Несведущий)</name-loc>
	<notes>-1 реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">@Skill@</name>
		<specialization compare="is anything"></specialization>
		<amount>-1</amount>
	</skill_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Minor)</name>
	<name-loc>Социальная дискриминация (Молодой)</name-loc>
	<notes>-2 Реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Minority Group)</name>
	<name-loc>Социальная дискриминация (Меньшинство)</name-loc>
	<notes>-2 Реакции остальных; +2 реакции группы</notes>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Меньшинство</limitation>
		<amount>4</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Monster)</name>
	<name-loc>Социальная дискриминация (Чудовище)</name-loc>
	<notes>-3 Реакции</notes>
	<base_points>-15</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-3</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">intimidation</name>
		<specialization compare="is anything"></specialization>
		<amount>1</amount>
	</skill_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Second-Class Citizen)</name>
	<name-loc>Социальная дискриминация (Человек второго сорта)</name-loc>
	<notes>-1 реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Subjugated)</name>
	<name-loc>Социальная дискриминация 
 (Рабство)</name-loc>
	<notes>-1 реакции</notes>
	<base_points>-20</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B155</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
	<name>Social Stigma (Uneducated)</name>
	<name-loc>Социальная дискриминация (Невежественный)</name-loc>
	<notes>-1 реакции</notes>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B156</reference>
	<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
</advantage>
	<advantage version="2">
		<name>Social Stigma (Valuable Property)</name>
		<name-loc>Социальная дискриминация (Собственность)</name-loc>
		<description-loc>Вы принадлежите к расе, классу, полу, или иной группе, которые считаются занимающими низкое положение в обществе. Чтобы стоить очков, ваша принадлежность должна быть явно заметна по внешнему виду (клейму, татуировке, или магической метке), одежде, поведению или речи; или после проверки легко определяться кем угодно (действует только в обществах со свободным и легким доступом к информации); или быть результатом общественного осуждения (например, влиятельным лидером или СМИ), гарантирующим, что каждый встречный будет знать о вашей принадлежности к презираемой группе.
Социальная дискриминация дает вам пенальти к реакции (от -1 до -5 очков) и/или ограничивает вашу социальную мобильность. Например:


Судимость: Вы были осуждены за серьезное преступление. Вам может быть запрещено: легальное приобретение некоторых вещей (например, оружия), определенные виды работ, получение допуска к секретным материалам и даже выезд из страны. Большинство добропорядочных граждан после изучения вашей биографии будут реагировать на вас с -1; полицейские, судьи, члены "комитетов бдительности" и другие сторонники закона с -2. Также по желанию можно взять подходящего Врага. -5 очков.
Изгнание из семьи: Ваша семья публично отказалась от вас. Этот недостаток можно брать только в обществе, где семейные связи играют важную роль, и никогда - тому, кто добровольно расходится с семьей. Эта Социальная дискриминация может быть двух уровней:


• Обычным порядком вы бы стали наследником, но вместо вас им стал другой. Это неприятно, но остаетесь членом семьи. Это дает -1 к реакции. -5 очков.
• Глава семьи (или всего клана) публично полностью отрекся от вас. Это дает -2 к реакции. -10 очков.


Отлучение: Вы отлучены от церкви; адепты данной веры реагируют на вас с -3. Отлучение является недостатком, только если это влиятельная и широко распространенная религия (обычно поддерживаемая государством), которая играет важную роль в повседневной жизни. -5 очков.
Если ваша религия владеет сверхъестественными силами, и вы окружены аурой, которая расскажет о вашем отлучении верующим, ангелам и любому интересующемуся (как бы вы не маскировались) - недостаток стоит вдвое больше. -10 очков.
Несведущий: Вы не владеете умением, обязательным в этом обществе для всех взрослых людей (в него не вложено очков). Другие презрительно смотрят на вас как на дурака или бездельника. Каждое умение, которого от вас ждут, но которого у вас нет (максимум четыре) дает -1 к реакции. Это стоит очков только в очень структурированном, или, наоборот, примитивном обществе, где выживание людей зависит от навыков друг друга. -5 очков/уровень.
Молодой: Вы не считаетесь взрослым по стандартам общества. Каждый раз, имея дело с взрослыми, вы получаете -2 к реакции - вы можете нравиться, но вас не очень-то уважают. Вам также могут быть запрещены посещение ночных клубов, вождение машин, служба в армии, членство в гильдиях и т.д., в зависимости от культуры и сеттинга. Вы должны выкупить этот недостаток по достижении возраста совершеннолетия (обычно 18 лет), принятого для данной эпохи и данной местности. -5 очков.
Национальное меньшинство: Вы принадлежите к меньшинству, которое главенствующая культура считает «варварами» или «низшими» существами. Вы получаете -2 к реакции от всех, кто к нему не принадлежит. В той местности, роде занятий или ситуации, где представители вашего меньшинства попадаются особенно редко, вы получаете +2 к реакции от соплеменников. -10 очков.
Чудовище: Вы крупный хищник, волшебное чудовище или нечто иное, что вызывает ненависть или страх, несмотря на истинную внешность или поведение. Вы получаете -3 к реакции и, скорее всего, станете объектом охоты сразу после обнаружения. Однако вы получаете +3 к Запугиванию там, где вы контролируете ситуацию (на усмотрение мастера). Примеры: медведь или вампир. -15 очков.
Человек второго сорта: Вы принадлежите к группе, у которой меньше прав и свобод, чем у "полноценных" граждан. Это дает -1 к реакции от всех, кроме представителей этой группы. Примеры: женщина в Америке XIX века, последователи некоторых религий. -5 очков.
Рабство: Вы представитель народа или расы, находящейся в рабстве. В обществе своих хозяев вы бесправны и страдаете от негативных последствий, описанных в пунктах Человек второго сорта и Собственность. Если вы вырветесь на свободу, весь народ или раса хозяев станут вашими Врагами. -20 очков.
Невежественный: Вы принадлежите к классу, расе, или субкультуре, которые не обладают присущей культурным людям мудростью, избегают начального обучения и имеют смутное представление о всем, что не связано напрямую с выживанием или размножением. Вы получаете -1 к реакции от представителей более развитых народов каждый раз, когда ваш недостаток очевиден, и не можете начинать игру с какими-либо "абстрактными" умениями (на усмотрение мастера; сюда входят большинство умений IQ/Сложный). Вы можете выкупить эту черту после долгого проживания в "цивилизованной" местности (по решению мастера).-5 очков.
Собственность: Общество считает вас чьей-то собственностью, а не "юридическим лицом". Это чаще приводит к ограничению свободы или отказу видеть в вас мыслящего человека, чем к пенальти к реакции. Примеры: женщина в Америке XVIII века или Японии XVI века.-10 очков.


Социальная дискриминация должна ограничивать того, кто ее берет. Например, средневековая японская дама должна заплатить за полученные 10 очков частым ограничением свободы передвижения и необходимостью подчиняться старшим родственникам мужского пола, если они есть. Черному рабу в Америке 19 века практически не позволено учиться или иметь какую-то собственность; его свобода полностью ограничена, пока он не сбежит. (Если он это сделает, то поменяет Социальную дискриминацию на сильного Врага!)
Можно взять несколько видов Социальной дискриминации, если они незначительно пересекаются (на усмотрение мастера). Например, подросток, бросивший школу и присоединившийся к уличной банде, может без проблем взять черты Молодой, Невежественный и Судимость.</description-loc>
		<type>Social</type>
		<base_points>-10</base_points>
		<reference>B156</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Space Sickness</name>
		<name-loc>Космическая болезнь 
</name-loc>
		<description-loc>Вы себя плохо чувствуете в свободном падении. Вы не можете изучить умение Свободное падение и обязаны всегда использовать его по умолчанию. Кроме того, вы получаете -4 к проверке HT при попытке избежать "синдрома космической адаптации" (см. B434) - и при неудаче первого броска единственный для вас путь выздороветь - вернуться к нормальной гравитации.
Эта черта позволена только в кампаниях с частыми космическими путешествиями.</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B156</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="no">
				<name compare="is">free fall</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
		<name>Speak Underwater</name>
		<name-loc>Разговор под водой</name-loc>
		<description-loc>Вы можете нормально говорить под водой, и понимать все, что говорят вам под водой другие.
===Особые улучшения.===
Пересечение поверхности (Interface Crossing): Вы можете беседовать даже с теми, кто находится над поверхностью воды. +50%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Пересечение поверхности (Interface Crossing)</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B87</reference>
		</modifier>
		<reference>B87</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Speak With Animals</name>
	<name-loc>Разговор с животными</name-loc>
	<base_points>25</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>Все водные</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>Все млекопитающие</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>@Один класc: рыбы, птицы, и т.п.@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>@Одно семейство: aилины, папугаи и т.п.@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>@Один вид: домашние кошки, попугаи Ара и т.п.@</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B87</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Sapience</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Universal</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B87</reference>
	<description-loc>Вы можете общаться с животными. Качество получаемой информации зависит от IQ животного и решения мастера. Насекомые и подобные существа могут выделить только простые эмоции (страх, голод), а шимпанзе или кошка способны даже на довольно разумную беседу. Если животное вообще будет говорить, то позволен один вопрос и ответ в минуту. Также мастер может потребовать броска реакции (с +2, если вы предложите еду).

Также мастер может решить, что общение с неестественными животными недоступно. 

===Особые улучшения.===
Разумность (Sapience): Общение с животными происходит так, как будто они имели ИН, равный вашему. Они ограничены своими чувствами, но могут объяснять их, как вы хотите. Например, если муравей заметил 10 серий шагов и запах людей, когда солнце заходило, он может сказать что-нибудь в виде «десять человек прошли здесь перед закатом». +40%.

Универсальное (Universal): Вы можете общаться с любым неразумным созданием, включая сверхъестественные, инопланетные и совершенно невероятные. 
Исключает взятие Специализированного общения. +20%.

===Новое особое ограничение===
Специализация (Specialized): вы можете общаться только с определенным типом животных. Широкая категория (все наземные животные: птицы, насекомые, рептилии; все морские животные: рыбы, амфибии, моллюски) -40%; один класс (млекопитающие или птицы) -50%; одно семейство (кошачьи или попугаи) -60%, Один вид (домашние кошки, попугаи Ара) -80%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Speak With Plants</name>
	<name-loc>Разговор с растениями</name-loc>
	<base_points>15</base_points>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>Все земные растения</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>Все водные растения</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>@Крупный подвид: Травы, деревья и т.п.@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Специализация (Specialized)</name>
		<notes>@Малый подвид: Вечнозеленые, Медицинские и т.п.@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Sapience</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B87</reference>
	<description-loc>Вы можете общаться с растениями на уроне эмоций. Все земные растения имеют IQ 0, но большое дерево может быть мудрее, чем средний плющ. Растение может помнить, кто недавно поливал его или проходил мимо, или что-либо еще, напрямую касающееся его, но не способно связать подслушанный телефонный разговор. Любое обычное растение всегда будет сотрудничать по мере своих способностей. Капуста-мутант с Марса может потребовать броска реакции.

===Новое особое улучшение===
Разумность (Sapience): Общение с растениями происходит так, как будто они имели ИН, равный вашему, как указано в описании одноименного улучшения в Разговоре с животными (выше). +40%.

===Новое особое ограничение===
Специализированные (Specialized): Вы можете общаться только с определенным видом растений. «все наземные растения» (включая все деревья, кусты и травы) или «все водные растения» - по -40%, обширный класс («травы» или «деревья») -50%, меньший класс («лекарственные растения», «вечнозеленые») -60%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Special Rapport (@Person@)</name>
	<name-loc>Духовная связь</name-loc>
	<base_points>5</base_points>
	<modifier version="1" enabled="no">
		<name>One Way</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P77</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Transferable</name>
		<notes>Own Race</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P78</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Transferable</name>
		<notes>Living Being</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>P78</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Transferable</name>
		<notes>Digital Minds</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>P78</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Transferable</name>
		<notes>Any Sapient mind</notes>
		<cost type="percentage">250</cost>
		<affects>total</affects>
		<reference>P78</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Must be Willing or Helpless</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P78</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B88</reference>
	<description-loc>У вас есть уникальные связи с другим человеком. Это работает как усиленная версия Эмпатии, но работающая только с одним человеком, независимо от дистанции. Вы всегда знаете, когда ваш партнер попадает в беду, терпит боль, лжет, или нуждается в помощи. Броска IQ не нужно. 
Ваш партнер также должен купить это преимущество и, соответственно, получает такие же эффекты относительно вас. Ваш партнер не обязан быть любимым, и даже близким другом. Мастер может запретить приобретение такого преимущества для могущественного NPC, который может считаться покровителем (или потребовать, по крайней мере, Необычного происхождения).</description-loc>
</advantage>
	<advantage version="2">
		<name>Spines, Long</name>
		<name-loc>Шипы</name-loc>
		<description-loc>Это острые шипы, размещенные на стратегических частях тела, как у ехидны. Шипы – оборонительное оружие, для того, чтобы напугать атакующих. Шипы не могут быть использованы специально, но есть шанс броска (DX-4) (если со спины атакуют – то DX-2) попадания ими по врагу во время ближнего боя. Враги, пытающиеся схватить существо с шипами, повреждаются автоматически. Враги, проводящие атаку толканием, автоматически получают максимальный вред! 

Шипы (Short Spines): Длинной 1-2 дюйма. Наносят проникающий вред 1d-2, с дальностью С. 1 очко.
Длинные шипы (Long Spines):  1-2 фута длинной. Вред проникающий 1d. дальность С. 3 очка.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>3</base_points>
		<melee_weapon>
			<damage>1d imp</damage>
			<usage>Stab</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<reference>B88</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Spines, Short</name>
		<name-loc>Шипы</name-loc>
		<description-loc>Это острые шипы, размещенные на стратегических частях тела, как у ехидны. Шипы – оборонительное оружие, для того, чтобы напугать атакующих. Шипы не могут быть использованы специально, но есть шанс броска (DX-4) (если со спины атакуют – то DX-2) попадания ими по врагу во время ближнего боя. Враги, пытающиеся схватить существо с шипами, повреждаются автоматически. Враги, проводящие атаку толканием, автоматически получают максимальный вред! 

Шипы (Short Spines): Длинной 1-2 дюйма. Наносят проникающий вред 1d-2, с дальностью С. 1 очко.
Длинные шипы (Long Spines):  1-2 фута длинной. Вред проникающий 1d. дальность С. 3 очка.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>1</base_points>
		<melee_weapon>
			<damage>1d-2 imp</damage>
			<usage>Stab</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<reference>B88</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Spirit Empathy</name>
		<name-loc>Понимание духов</name-loc>
		<description-loc>Вы имеете особую чувствительность к духам, и получаете выгоды Эмпатии (с. B51), когда имеете с ними дело. Вы можете почувствовать общие эмоции и нарстроени любого встреченного духа, сделав успешный бросок IQ. Ваши навыки влияния также нормально действуют на духов, которые выделяют вас из простых смертных. Преимущество не защищает вас от вредоносного воздействия духов, но позволяет обнаружить и противостоять мотивам.
===Особые ограничения.===
Специализированное (Specialized): Вы настроены только на один класс духов. Возможные классы включают ангелов, демонов, элементалей, призраков и все, что угодно, что разрешит мастер. -50%.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Специализация (Specialized)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B87</reference>
			<notes>@Тип: ангелы, демоны, элементалы, феи, призраки и т.п.@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Remote</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P48</reference>
		</modifier>
		<reference>B88</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Split Personality</name>
	<name-loc>Раздвоение личности 
</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-1</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Видевшие смену личности</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B156</reference>
	<description-loc>У вас две или более различных личностей с собственными критериями поведения. Они могут по-разному воспринимать общие воспоминания и даже иметь разные имена.
Для каждой личности выберите "набор" ментальных недостатков и до пяти причуд. Мастер может также разрешить изменение IQ, Восприятия(Per), Воли(Will) и ментальных преимуществ, если это имеет смысл. Каждый набор ментальных особенностей должен стоить одинаковое число очков. При подсчете стоимости персонажа "цена набора" учитывается один раз, а не по разу для каждой личности. Для всех личностей физические особенности и умения одинаковы (хотя некоторые личности могут не использовать отдельные умения), равно как и все ментальные особенности, которые не входят в чей-либо набор.


=====Пример: У Боба Смита три личности. "Полковник Смит" - решительный и строгий командир с Заблуждением ("я офицер вооруженных сил") [-10], Кодексом чести (Солдаты) [-10], и причудой "Соблюдает все формальности" [-1]. "Бобби" - фанат вечеринок с -2 к Воле(Will) [-10], недостатком Разорительная привычка (Вечеринки) (6) [-10] и причудой "Спать весь день и бодрствовать ночью" [-1]. "Смитти" - вечный нарушитель спокойствия с чертами Самоуверенность (12) [-5], Насмешник [-15], и причудой "Красть ради развлечения" [-1]. Для всех личностей остальные черты Боба являются общими. Каждый пакет стоит -21 очко. Игрок учитывает -21 очко только один раз. Вместе со стоимостью Раздвоения личности (12) -15 очков, полная стоимость черты составляет -36 очков.=====


В любой стрессовой ситуации (но не чаще, чем раз в час игрового времени) вам необходимо выполнять проверку на самоконтроль. При неудаче появляется другая личность и вы ведете себя соответственно ее ментальным недостаткам и причудам. Если имеется несколько возможностей, мастер должен или выбрать личность наиболее подходящую к ситуации, или доверить выбор кубику.
Все ваши личности несколько ограниченны и неестественны, что дает -1 к реакции. Все, кто видел смену личности, будет считать вас (возможно не без основания) опасным психом и реагировать с -3.</description-loc>
</advantage>
	<advantage version="2">
		<name>Squeamish</name>
		<name-loc>Брезгливость</name-loc>
		<description-loc>Вы не любите "всякую мерзость": маленьких насекомых и ползучих тварей, кровь и мертвецов, слизь, и т.п. При виде таких вещей вы реагируете как при Фобии; см. Фобии, B148. Обратите внимание, что это не обычная боязнь насекомых, рептилий, грязи и мертвецов! Вас пугают не огромные насекомые или рептилии, обычная "чистая" грязь или призраки - а противные и отталкивающие вещи, отбросы и жидкая овсянка.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<cr>12</cr>
		<reference>B156</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Staid</name>
		<name-loc>Нелюбознательный</name-loc>
		<description-loc>
Вы можете взять Нелюбопытного (B140) на уровне причуды. Вы, вероятно, не будете интересоваться вещами, которые не касаются непосредственно вас.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Static (Psi)</name>
		<name-loc>Пси-стазис  (Psi)</name-loc>
		<description-loc>Вы псионически нейтральны. Пси-способности не могут воздействовать напрямую ни на вас, ни на вашу ношу. Например, телекинезом можно бросить в вас скалу, но нельзя левитировать вас или вырвать меч из вашей руки.
===Особые улучшения.===

Воздействие на область (Area Effect): вы излучаете пси-нейтрализационное поле. Первый уровень распространяет эффект стазиса на ваш хекс, каждый следующий уровень – удваивает радиус. +50% за уровень.

Выключаемый (Switchable): Вы можете включать и выключать пси-стазис по желанию, чтобы позволить воздействовать на вас дружественным псионикам. +100%.
===Особые ограничения.===

Сопротивление (Resistible): Ваша способность – несовершенна. Псионик может пробиться через ваш стазис, успешно выиграв в состязании по Воле(Will). Если атакующая способноть уже требует быстрого состязания, атакующий делает только один бросок, но цель сопротивляется с +5. -50%.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>30</base_points>
		<modifier version="1" enabled="no">
			<name>Воздействие на область (Area Effect)</name>
			<cost type="percentage">50</cost>
			<levels>1</levels>
			<affects>total</affects>
			<reference>B78</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Выключаемый (Switchable)</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B78</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Сопротивление (Resistible)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B78</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Discriminatory</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>P98</reference>
		</modifier>
		<reference>B78</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Status (@Description@)</name>
	<name-loc>Статус (@Описание@)</name-loc>
	<points_per_level>-5</points_per_level>
	<levels>1</levels>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B28</reference>
	<description-loc>Статус показывает ваше место в обществе. Любой способен определить ваш социальный статус, посмотрев на вас, вашу одежду и вещи. Если ваш статус очень велик , ваше лицо может быть легко узнаваемым - и, может быть, перешептывание официантов разнесет эту информацию по всему ресторану.
Статус измеряется в "социальных уровнях", изменяющихся от -2 (нищий), и до 8 (бог император). Цена - 5 очков за уровень статуса, так, Статус 5 стоит 25 очков, а -3 - это недостаток, дающий вам 15 очков.
Высокий статус: Высокий статус подразумевает, что вы член правящего класса в вашем обществе (но только в нем). Это дает вам определенные привилегии (различны для каждого мира/государства). 
Низкий статус: Вы слуга, преступник или раб. 
Статус и его влияние на Реакцию:
Когда совершается бросок реакции, относительный уровень задействованных персонажей может повлиять на реакцию. Высокий Статус, обычно, дает преимущество. Так, если ваш Статус равен 3, а того, с кем вы общаетесь - 1, то бросок будет совершаться с +4. Отрицательный статус обычно дает минус. Если ваш статус отрицателен, то те, чей статус больше, вряд ли будут хорошо к вам относиться. Из реакции вычитается разница в статусах двух задействованных персонажей. </description-loc>
</advantage>
	<advantage version="2">
	<name>Status</name>
	<name-loc>Статус 
</name-loc>
	<notes>@Описание@</notes>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B28</reference>
	<description-loc>Статус показывает ваше место в обществе. Любой способен определить ваш социальный статус, посмотрев на вас, вашу одежду и вещи. Если ваш статус очень велик , ваше лицо может быть легко узнаваемым - и, может быть, перешептывание официантов разнесет эту информацию по всему ресторану.
Статус измеряется в "социальных уровнях", изменяющихся от -2 (нищий), и до 8 (бог император). Цена - 5 очков за уровень статуса, так, Статус 5 стоит 25 очков, а -3 - это недостаток, дающий вам 15 очков.
Высокий статус: Высокий статус подразумевает, что вы член правящего класса в вашем обществе (но только в нем). Это дает вам определенные привилегии (различны для каждого мира/государства). 
Низкий статус: Вы слуга, преступник или раб. 
Статус и его влияние на Реакцию:
Когда совершается бросок реакции, относительный уровень задействованных персонажей может повлиять на реакцию. Высокий Статус, обычно, дает преимущество. Так, если ваш Статус равен 3, а того, с кем вы общаетесь - 1, то бросок будет совершаться с +4. Отрицательный статус обычно дает минус. Если ваш статус отрицателен, то те, чей статус больше, вряд ли будут хорошо к вам относиться. Из реакции вычитается разница в статусах двух задействованных персонажей. </description-loc>
</advantage>
	<advantage version="2">
	<name>Stress Atavism</name>
	<name-loc>Животный стресс</name-loc>
	<cr>12</cr>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Спокойное (Mild)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B156</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Среднее (Moderate)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B156</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Серьезное (Severe)</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B156</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental, Exotic</type>
	<reference>B156</reference>
	<description-loc>Этот недостаток позволен только представителям рас, искусственно выведенных из животных.


Вы временно "возвращаетесь" в животное состояние, когда испуганы, голодны, устали или ранены. В этих ситуациях выполните проверку на самоконтроль. При провале вы ведете себя как животное, подчиняясь своим желаниям и инстинктам.
Когда стресс отступит, делайте проверку на самоконтроль каждую минуту. Если вас поддерживают друзья, вы получаете бонус +2; если у кого-то из них есть Понимание животных или Эмпатия, - еще +2. При успехе вы возвращаетесь в норму. Если вы потеряли сознание от усталости или ранений до того, как успешно выполнили проверку, то очнетесь уже в нормальном состоянии.
Стоимость зависит от тяжести состояния:


Спокойное: У вас проблемы с речью - нужно сделать проверку IQ, чтобы произнести фразу. Вы не способны управляться со сложными механизмами, но можете яростно наносить удары оружием (-4 к попаданию). -10 очков. *
Среднее: Вы страдаете от описанного выше и с трудом понимаете сказанное другими: чтобы понять фразу, сделайте проверку IQ. Если вас атакуют или провоцируют, сделайте проверку на самоконтроль, чтобы избежать "инстинктивной" реакции. -15 очков. *


Серьезное: Вы не можете говорить или понимать других, использовать инструменты (кроме разве что подобия дубины), и всегда действуете инстинктивно. Вы ничем не отличаетесь от своих примитивных предков! -20 очков. *


Животный стресс может дополнительно привести к проблемному поведению. Выберете подходящий ментальный недостаток, уменьшите его цену вдвое (отбросьте дробную часть), и добавьте к описанной выше стоимости перед учетом модификатора за самоконтроль.</description-loc>
</advantage>
	<advantage version="2">
		<name>Stretching</name>
		<name-loc>Растягивание</name-loc>
		<description-loc>Вы можете растягивать тело в любом направлении. Каждый уровень позволяет увеличивать эффективный SM любой части тела на +1, не увеличивая общий. Вы можете удлинить ваши руки для увеличения досягаемости (reach) (но не рубящего вреда, т.к. преимущество не дает лишней массы и мышц), ноги, чтобы перешагнуть барьер и т.д. Скорость растягивания - ±1 SM в секунду.
Растягивание хорошо подходит роботам с телескопическими манипуляторами. Супер-герои с «резиновым телом» должны будут добавить что-нибудь вроде Эластичной кожи (с. B51), Гибкости (с. B56), Полиморфа (с. B84), Супер-прыжков (с. B89).

===Новое особое улучшение===
Силовое (Force Extension): Вы проецируете видимое полуматериальное силовое поле, которое действует как продолжение ваших конечностей. Это считается как использование немодифицированного Растягивания, за исключением того, что атаки по этому силовому полю не ранят вас. Вы должны по-прежнему двигать своими конечностями для ударов, действий, передвижения и т.д., и должны иметь свободные руки, чтобы брать что-либо. Вы ограничены своей природной СЛ и ЛВ, и не можете предпринимать никаких действий, недоступных для ваших родных конечностей (например, достать что-то сквозь стену). Это улучшение не делает способность Телекинезом (с.82), но подходит для любой силы, его включающей. +50%.

===Новое особое ограничение===
Ограниченное (Limited): Вы можете растягивать только определенные части тела. «Только руки», «только ноги» стоят по -20%, «одна конечность» -40%, «только шея» -50%. Возможны и другие виды ограничения, но «только руки и ноги» - недопустимо.
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>6</points_per_level>
		<modifier version="1" enabled="no">
			<name>Force Extension</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P78</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P78</reference>
			<notes>Arms Only</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P78</reference>
			<notes>Legs Only</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P78</reference>
			<notes>@Одна конечность@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Limited</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P78</reference>
			<notes>Neck Only</notes>
		</modifier>
		<reference>B88</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Striker, Crushing (@Body Part@)</name>
	<name-loc>Естественное оружие, дробящее (@Часть тела@)</name-loc>
	<base_points>5</base_points>
	<melee_weapon>
		<damage>thr:+1 cr</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B88</reference>
	<description-loc>У вас есть орган, который может наносить прицельные удары, но не манипулировать объектами или служить ногой. Это преимущество может представлять рога, клыки, тяжелый хвост, жало или иное оружие.
Ваше естественное оружие может атаковать на расстоянии С (только бой вплотную), нанося Колющий вред +1 за кубик (например, 2d-1 станет 2d+1). За 5 очков наносимый вред Тупой или пробивающий, Крупный пробивающий за 6 очков, Режущий – за 7, и проникающий за 8.

Попадание – бросок по DX или навыку Драки. Вы также можете пытаться парировать им: используете высшее значение из (DX/2)+3, или навык парирования Драки.

===Особые улучшения.===

Длинный (Long): Ваше естественное оружие длиннее, чем положено. Это увеличивает досягаемость (reach) на +1 SM за уровень. +100% за уровень, если вы можете атаковать на любом расстоянии вплоть до максимума, или +75% за уровень, если вы можете бить только на максимальную дистанцию.

===Особые ограничения.===

Невозможность парировать (Cannot Parry): Вы не можете парировать этим ударником. -40%.

Неуклюжий (Clumsy): Вы не можете точно нацелить оружие. Это обычно для хвостов и подобных частей тела, зона поражения которых обычно находится вне вашего поля зрения. -20% за -1 к броску на попадание.

Ограниченная зона поражения (Limited Arc): Ваше естественное оружие может атаковать только в одном направлении (прямо впереди, прямо сзади и пр.). Направление указывается при покупке. -40%
Слабый (Weak): Ваш ударник слишком тупой или легкий, или вы просто не можете использовать его в полную силу. Он наност только базовый колющий вред, без добавления +1 за кубик. -50%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Striker, Cutting (@Body Part@)</name>
	<name-loc>Естественное оружие, режущее (@Часть тела@)</name-loc>
	<base_points>7</base_points>
	<melee_weapon>
		<damage>thr:+1 cut</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B88</reference>
	<description-loc>У вас есть орган, который может наносить прицельные удары, но не манипулировать объектами или служить ногой. Это преимущество может представлять рога, клыки, тяжелый хвост, жало или иное оружие.
Ваше естественное оружие может атаковать на расстоянии С (только бой вплотную), нанося Колющий вред +1 за кубик (например, 2d-1 станет 2d+1). За 5 очков наносимый вред Тупой или пробивающий, Крупный пробивающий за 6 очков, Режущий – за 7, и проникающий за 8.

Попадание – бросок по DX или навыку Драки. Вы также можете пытаться парировать им: используете высшее значение из (DX/2)+3, или навык парирования Драки.

===Особые улучшения.===

Длинный (Long): Ваше естественное оружие длиннее, чем положено. Это увеличивает досягаемость (reach) на +1 SM за уровень. +100% за уровень, если вы можете атаковать на любом расстоянии вплоть до максимума, или +75% за уровень, если вы можете бить только на максимальную дистанцию.

===Особые ограничения.===

Невозможность парировать (Cannot Parry): Вы не можете парировать этим ударником. -40%.

Неуклюжий (Clumsy): Вы не можете точно нацелить оружие. Это обычно для хвостов и подобных частей тела, зона поражения которых обычно находится вне вашего поля зрения. -20% за -1 к броску на попадание.

Ограниченная зона поражения (Limited Arc): Ваше естественное оружие может атаковать только в одном направлении (прямо впереди, прямо сзади и пр.). Направление указывается при покупке. -40%
Слабый (Weak): Ваш ударник слишком тупой или легкий, или вы просто не можете использовать его в полную силу. Он наност только базовый колющий вред, без добавления +1 за кубик. -50%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Striker, Impaling (@Body Part@)</name>
	<name-loc>Естественное оружие, проникающее (@Часть тела@)</name-loc>
	<base_points>8</base_points>
	<melee_weapon>
		<damage>thr:+1 imp</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B88</reference>
	<description-loc>У вас есть орган, который может наносить прицельные удары, но не манипулировать объектами или служить ногой. Это преимущество может представлять рога, клыки, тяжелый хвост, жало или иное оружие.
Ваше естественное оружие может атаковать на расстоянии С (только бой вплотную), нанося Колющий вред +1 за кубик (например, 2d-1 станет 2d+1). За 5 очков наносимый вред Тупой или пробивающий, Крупный пробивающий за 6 очков, Режущий – за 7, и проникающий за 8.

Попадание – бросок по DX или навыку Драки. Вы также можете пытаться парировать им: используете высшее значение из (DX/2)+3, или навык парирования Драки.

===Особые улучшения.===

Длинный (Long): Ваше естественное оружие длиннее, чем положено. Это увеличивает досягаемость (reach) на +1 SM за уровень. +100% за уровень, если вы можете атаковать на любом расстоянии вплоть до максимума, или +75% за уровень, если вы можете бить только на максимальную дистанцию.

===Особые ограничения.===

Невозможность парировать (Cannot Parry): Вы не можете парировать этим ударником. -40%.

Неуклюжий (Clumsy): Вы не можете точно нацелить оружие. Это обычно для хвостов и подобных частей тела, зона поражения которых обычно находится вне вашего поля зрения. -20% за -1 к броску на попадание.

Ограниченная зона поражения (Limited Arc): Ваше естественное оружие может атаковать только в одном направлении (прямо впереди, прямо сзади и пр.). Направление указывается при покупке. -40%
Слабый (Weak): Ваш ударник слишком тупой или легкий, или вы просто не можете использовать его в полную силу. Он наност только базовый колющий вред, без добавления +1 за кубик. -50%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Striker, Large Piercing (@Body Part@)</name>
	<name-loc>Естественное оружие, большое пробивающее (@Часть тела@)</name-loc>
	<base_points>6</base_points>
	<melee_weapon>
		<damage>thr:+1 pi+</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B88</reference>
	<description-loc>У вас есть орган, который может наносить прицельные удары, но не манипулировать объектами или служить ногой. Это преимущество может представлять рога, клыки, тяжелый хвост, жало или иное оружие.
Ваше естественное оружие может атаковать на расстоянии С (только бой вплотную), нанося Колющий вред +1 за кубик (например, 2d-1 станет 2d+1). За 5 очков наносимый вред Тупой или пробивающий, Крупный пробивающий за 6 очков, Режущий – за 7, и проникающий за 8.

Попадание – бросок по DX или навыку Драки. Вы также можете пытаться парировать им: используете высшее значение из (DX/2)+3, или навык парирования Драки.
===Особые улучшения.===

Длинный (Long): Ваше естественное оружие длиннее, чем положено. Это увеличивает досягаемость (reach) на +1 SM за уровень. +100% за уровень, если вы можете атаковать на любом расстоянии вплоть до максимума, или +75% за уровень, если вы можете бить только на максимальную дистанцию.
===Особые ограничения.===

Невозможность парировать (Cannot Parry): Вы не можете парировать этим ударником. -40%.

Неуклюжий (Clumsy): Вы не можете точно нацелить оружие. Это обычно для хвостов и подобных частей тела, зона поражения которых обычно находится вне вашего поля зрения. -20% за -1 к броску на попадание.

Ограниченная зона поражения (Limited Arc): Ваше естественное оружие может атаковать только в одном направлении (прямо впереди, прямо сзади и пр.). Направление указывается при покупке. -40%
Слабый (Weak): Ваш ударник слишком тупой или легкий, или вы просто не можете использовать его в полную силу. Он наност только базовый колющий вред, без добавления +1 за кубик. -50%.</description-loc>
</advantage>
	<advantage version="2">
	<name>Striker, Piercing (@Body Part@)</name>
	<name-loc>Естественное оружие, пробивающее (@Часть тела@)</name-loc>
	<base_points>5</base_points>
	<melee_weapon>
		<damage>thr:+1 pi</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B88</reference>
	<description-loc>У вас есть орган, который может наносить прицельные удары, но не манипулировать объектами или служить ногой. Это преимущество может представлять рога, клыки, тяжелый хвост, жало или иное оружие.
Ваше естественное оружие может атаковать на расстоянии С (только бой вплотную), нанося Колющий вред +1 за кубик (например, 2d-1 станет 2d+1). За 5 очков наносимый вред Тупой или пробивающий, Крупный пробивающий за 6 очков, Режущий – за 7, и проникающий за 8.

Попадание – бросок по DX или навыку Драки. Вы также можете пытаться парировать им: используете высшее значение из (DX/2)+3, или навык парирования Драки.

===Особые улучшения.===

Длинный (Long): Ваше естественное оружие длиннее, чем положено. Это увеличивает досягаемость (reach) на +1 SM за уровень. +100% за уровень, если вы можете атаковать на любом расстоянии вплоть до максимума, или +75% за уровень, если вы можете бить только на максимальную дистанцию.

===Особые ограничения.===

Невозможность парировать (Cannot Parry): Вы не можете парировать этим ударником. -40%.

Неуклюжий (Clumsy): Вы не можете точно нацелить оружие. Это обычно для хвостов и подобных частей тела, зона поражения которых обычно находится вне вашего поля зрения. -20% за -1 к броску на попадание.

Ограниченная зона поражения (Limited Arc): Ваше естественное оружие может атаковать только в одном направлении (прямо впереди, прямо сзади и пр.). Направление указывается при покупке. -40%
Слабый (Weak): Ваш ударник слишком тупой или легкий, или вы просто не можете использовать его в полную силу. Он наност только базовый колющий вред, без добавления +1 за кубик. -50%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Striking ST</name>
		<name-loc>Ударная сила</name-loc>
		<description-loc>Ваши удары более мощны, чем это видно из вашей силы. Уровень Ударной силы добавляется к базовой ST в целях расчета рубящего и колющего повреждения (см. Таблица Повреждений, с. B16). Ударная сила не влияет на НР и Грузоподъемность. Если вы приобретаете ST с модификаторами Нет точных манипуляторов или Размер, эти же модификаторы применяются и к Ударной силе.

===Новое особое ограничение===
Только одна атака (One Attack Only): ваша Ударная СЛ влияет только на одну определенную природную атаку: укус, одно Естественное оружие и т.д. Это ограничение рекомендуется для относительно слабых существ, способных на необычно сильную атаку; например, гигантская крыса, способная разгрызать броню и кости. -60%.
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Нет хороших манипуляторов (No fine manipulators)</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Размер (Size)</name>
			<cost type="percentage">-10</cost>
			<levels>1</levels>
			<affects>total</affects>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Super Effort</name>
			<cost type="percentage">400</cost>
			<affects>total</affects>
			<reference>Sup24</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>One Attack Only</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P79</reference>
			<notes>@Атака@</notes>
		</modifier>
		<reference>B88</reference>
		<categories>
			<category>Advantage</category>
		</categories>
		<attribute_bonus>
			<attribute limitation="striking only">st</attribute>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</advantage>
	<advantage version="2">
		<name>Stubbornness</name>
		<name-loc>Упрямство 
</name-loc>
		<description-loc>Вы всегда поступаете по-своему. С вами очень трудно работать в команде - отыграйте это! Чтобы заставить вас согласиться с абсолютно разумным планом, друзьям, вероятно, придется использовать Заговаривание зубов. Другие реагируют на вас с -1.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B157</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Stuttering</name>
	<name-loc>Заикание 
</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>-2</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">diplomacy</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fast-talk</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">performance</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">public speaking</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sex appeal</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">singing</name>
		<specialization compare="is anything"></specialization>
		<amount>-2</amount>
	</skill_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Вы страдаете от заикания или другого дефекта речи. Это дает -2 к реакции при беседе и -2 к Дипломатии, Заговариванию зубов, Выступлению, Публичному выступлению, Сексапильности и Пению. Некоторые профессии (переводчик, диктор, и т.д.) для вас навсегда закрыты.</description-loc>
</advantage>
	<advantage version="2">
		<name>Subsonic Hearing</name>
		<name-loc>Инфразвуковой слух</name-loc>
		<description-loc>Вы можете слышать звуки очень низких частот (ниже 40 Гц), такие, как гул далекого шторма, вибрации землетрясения, приближение стада зверей или бронетехники и т.д. Это дает вам +1 на выслеживание движущихся по земле существ. Если вы можете слышать только низкочастотные звуки, то цена 0 очков, иначе – 5.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормального слуха (No normal hearing)</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B89</reference>
		</modifier>
		<reference>B89</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Subsonic Speech</name>
		<name-loc>Инфразвуковая речь</name-loc>
		<description-loc>Вы можете общаться, используя звуки очень низких частот. Черта также включает Инфразвуковой слух. Общение занимает в два раза больше времени, но слышимость в два раза дальше. Говорящий в любом случае получает штраф не меньше -2 на Заговаривание зубов и любой другой навык, где важна интонация и скорость речи.
Если вы можете общаться только через Инфразвуковую речь – 0 очков, если вы можете переключаться и на нормальную речь – 10 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормальной речи (No normal speech)</name>
			<cost type="points">-10</cost>
			<affects>total</affects>
			<reference>B89</reference>
		</modifier>
		<reference>B89</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Super Climbing</name>
		<name-loc>Супер-лазание</name-loc>
		<description-loc>Вы можете карабкаться очень быстро. Каждый уровень этого преимущества дает вам +1 Движения во время лазания или использования преимущества Прилипание (с. B43).

===Новые особые улучшения===
Приобретите Специфичное (с.112), если ваша премия к Движению применяется только при лазанию по определенным типам поверхностей. Распространенные материалы – металл, камень или дерево – будут стоить -40%; ферромагнитные металлы - -50%; необычные материалы – глина, лед или резина – дадут ограничение -60%.

Требует низкой гравитации (Requires Low Gravity): Ваша способность не действует в условиях гравитации выше определенной максимальной силы. -5% за каждые 0.1G ниже 1G (-5% за 0.9G, -10% за 0.8G и так далее – до -50% за 0G)
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>3</points_per_level>
		<modifier version="1" enabled="no">
			<name>Specific</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P79</reference>
			<notes>@Common Surface@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specific</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>P79</reference>
			<notes>Ferrous Metals</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Specific</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P79</reference>
			<notes>@Uncommon Surface@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Requires Low Gravity</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>P79</reference>
			<notes>@Threshold@</notes>
		</modifier>
		<reference>B89</reference>
		<notes>Climbing Move: @Новый тип движения лазания@</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Super Jump</name>
		<name-loc>Супер-прыжки</name-loc>
		<description-loc>Вы можете совершать сверхчеловеческие прыжки. Каждый уровень удваивает расстояние и высоту прыжка. Ваша скорость во время прыжка составляет 1/5 максимальной дистанции или вашу базовую – что выше. Например, если вы можете прыгнуть на 100 м, ваша скорость будет равна 20, по меньшей мере.
Вы можете прыгать на врага, чтобы сбить его – со скоростью прыжка! Вам не надо делать дополнительного броска на точность приземления.
Если вы падаете с расстояния, меньшей или равной максимальной высоте прыжка, вы не получаете повреждений, и можете еще увеличить эту высоту на 5 ярдов, сделав успешную проверку Акробатики.

===Новые особые улучшения===
Отскакивание (Bouncing): Вы можете отскакивать от поверхностей, как резиновый мяч. Когда вы падаете или сталкиваетесь – кидайте лучшее из значений ЛВ, Акробатики или Прыжков, с -5 за каждое полное значение Движения в прыжке, на которое ваша текущая скорость превышает базовое Движение прыжка. При успехе вы не получаете вреда, и отскакиваете со скоростью, равной 90% от той, что была до столкновения.
Если она не превышала скорости движения, при желании вы можете остановиться. При провале вы получаете обычный вред и останавливаетесь («Шлёп!»). +50%.
Маневрирование (Maneuverable): Вы можете изменять направление движения во время прыжка. Скорость во время прыжка и расстояние считается как обычно, но скорость считается за Движение в воздухе, как если бы вы имели преимущество Полет. Например, при способности прыгнуть на 100 ярдов со скоростью 20, вы можете «лететь» со скоростью 20 в течение 5 секунд до приземления. Исключает приобретение любых нижеописанных ограничений, кроме Планетарного. +50%.

===Новые особые ограничения===

Только полная сила (Full Power Only): Возможны прыжки только на максимальную дистанцию.
Единственный способ прыгнуть ближе – не использовать это преимущество. -10%.

Только горизонтальный прыжок (Horizontal Only): Вы можете увеличивать только горизонтальное расстояние. Высота прыжка не увеличивается, и эффект от падения не изменяется. -25%.

Легче воздуха (Lighter Than Air):
Вы прыгаете, становясь легче воздуха. За каждую секунду полета место вашей посадки смещается в сторону, куда дует ветер на 1 ярд за каждые 5 миль в час его скорости. Например, если вы находитесь в воздухе 3 секунды, и ветер дует с запада со скоростью 20 mph, вы приземлитесь на 12 ярдов восточнее. -10%.
Планетарный (Planetary): Ваши прыжки основаны на отталкивании от гравитационного или магнитного поля планеты. Если планеты нет – преимущество не работает. -5%.

Снаряд (Projectile): Вы можете прыгнуть только прямо в вашу цель. Вы – неуправляемый снаряд в неконтролируемом полете. Вы не можете делать ничего – даже защищаться – во время полета. При приземлении кидайте Прыжки или ЛВ, при провале вы сталкиваетесь с целью или землей – а если хотели этого, то промахиваетесь и попадаете во что-то рядом. В любом случае вы получаете обычный
вред от падения. -20%.

Только вертикальные прыжки
(Vertical Only): Вы можете увеличивать только высоту прыжка и уменьшать вред от падения, но не прыгать дальше. Исключает взятие Горизонтальных прыжков. -25%.
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>10</points_per_level>
		<modifier version="1" enabled="no">
			<name>Bouncing</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Maneuverable</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Full Power Only</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Horizontal Only</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Lighter Than Air</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Planetary</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Projectile</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Vertical Only</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P80</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Bouncing Only</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>Sup28</reference>
		</modifier>
		<reference>B89</reference>
		<notes>@Название движения-прыжка@</notes>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Supernatural Durability</name>
		<name-loc>Сверхъестественная выносливость</name-loc>
		<description-loc>Вы можете проигнорировать большинство ваших ран, как вампир или маньяк из фильма ужасов. Ранения лишают вас хитов, как обычно, и вы получаете обычный эффект от отбрасывания, но вы полностью иммунны к шоку, физическому оглушению, и потере сознания от ударов. Вам не нужен Высокий болевой порог – эта способность включает все его эффекты и является гораздо более мощным преимуществом.
Пока у вас 0 или больше хитов, вы также иммунны к калечащим ранениям, и ваша скорость не страдает. При достижении отрицательных хитов, скорость падает наполовину, вы можете получить калечащее ранение, но вы не погибнете, пока не получите ран от атаки, к которой вы особенно уязвимы (см. ниже). Единственное исключение – получить за одну атаку рану, которая нанесет вам 10*НР вреда или больше. Такой вред убьет вас.
Чтобы умереть, вы сначала должны быть ранены до –НР или ниже. После этого, один указанный предмет может вас убить. Вы должны указать его, когда покупаете это преимущество. Доступны все категории из Ограничений защиты (B46), предмет должен быть редкости Случайный (Occasional) или больше. Полученные от этого предмета раны действуют на вас как обычно, и вы должны делать все необходимые броски для выживания. Если вы уже получили ран на -5*НР или больше, любая рана этим предметом убьет вас. Любой предмет, к которому у вас есть Уязвимость (с. B161), также может вас убить.</description-loc>
		<type>Physical, Supernatural</type>
		<base_points>150</base_points>
		<reference>B89</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Supernatural Features (No Body Heat)</name>
	<name-loc>Сверхъестественные черты 
 (Холодное тело)</name-loc>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили холод</limitation>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (No Body Heat; Temporary)</name>
	<name-loc>Сверхъестественные черты 
 (Холодное тело; временно)</name-loc>
	<base_points>-1</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили холод</limitation>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Quirk</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (No Pulse)</name>
	<name-loc>Сверхъестественные черты (Нет пульса)</name-loc>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили пульс</limitation>
		<amount>-1</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>H26</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (No Reflection)</name>
	<name-loc>Сверхъестественные черты (Нет отражения)</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили отражение</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (No Shadow)</name>
	<name-loc>Сверхъестественные черты 
 (Нет тени)</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили тень</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (Pallor)</name>
	<name-loc>Сверхъестественные черты 
 (Безжизненный)</name-loc>
	<base_points>-10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили бледность</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
	<name>Supernatural Features (Pallor; Temporary)</name>
	<name-loc>Сверхъестественные черты 
 (Безжизненный; временно)</name-loc>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Заметили бледность</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B157</reference>
	<description-loc>Свойственные вам необычные черты выдают в вас демона, вампира или другое сверхъестественное существо. При беглом взгляде вы можете сойти за обычного смертного, но внимательный осмотр раскроет отличия, после чего знающий человек сможет понять, кто вы на самом деле.
Сверхъестественные черты отличаются от Неестественных (B22) тем, что бросаются в глаза не всегда, а только в определенных обстоятельствах. Их обнаружение, тем не менее, дает пенальти реакции. Людям, знающим, куда смотреть, они также дают бонус к любой проверке умения (Тайного знания, Оккультизма и т.д.) при попытке раскрыть вашу истинную природу.
Сверхъестественные черты могут сопутствовать уровню внешности от Отвратительного до Исключительного (см. Внешность, B21). Вы, однако, не получите очков при Чудовищной или Ужасной внешности - в этом случае вам нечего скрывать!


Холодное тело: При прикосновении ваше тело оказывается неестественно холодным: -1 к реакции от того, кто вас касался, пожимал руку, целовал и т.п.; +1 ко всем проверкам на раскрытие вашей тайны. -5 очков (-1 очко, если вы можете временно повысить температуру тела - как, например, напившийся крови вампир).
Нет отражения: Вы не отражаетесь нигде: ни в зеркалах, ни в неподвижной воде, ни в других отражающих поверхностях; даже технологические устройства вроде камер не показывают вас. Представители некоторых культур могут решить, что у вас нет души! Заметившие этот недостаток реагируют с -2; +2 на всем проверкам на раскрытие тайны. -10 очков.
Нет тени: Вне зависимости от яркости и направления света вы не отбрасываете тени. -2 к реакции от заметивших эту особенность; +2 ко всем проверкам на раскрытие вашей тайны. -10 очков.
Безжизненный: Вы похожи на труп со своей бескровной кожей, впалыми глазами и т.п. Любой, кто видел вас без грима при хорошем освещении, реагирует с -2; +2 ко всем проверкам на раскрытие тайны.-10 очков (-5 очков, если вы можете временно обрести признаки жизни - как, например, напившийся крови вампир).</description-loc>
</advantage>
	<advantage version="2">
		<name>Supersensitive</name>
		<name-loc>Сверхчувствительный 
</name-loc>
		<description-loc>Вы постоянно чувствуете на телепатическом уровне присутствие других. Вы непрерывно ощущаете едва различимый раздражающий шум телепатического происхождения. Он не дает ничего полезного - мысли и эмоции, которые вы ощущаете, остаются за пределами понимания.
Если в радиусе 20 ярдов есть любые разумные существа (IQ 6+), вы получаете -1 к DX и IQ. Пенальти возрастает до -2, если их 10 или больше, -3, если 100 или больше, -4, если 1,000 или больше и т.д. Если из-за этого DX или IQ становятся меньше половины от первоначального значения, вы впадаете в ступор и не способны ничего сделать, пока "шум" не спадет. Разумные машины или закрытые для телепатии люди (псионическими, технологическими или какими угодно средствами) вас не беспокоят.
У Сверхчувствительности есть один полезный побочный эффект: шум, который вы ощущаете, говорит о присутствии людей в пределах 20 ярдов, а его уровень показывает приблизительное их количество. Шум, однако, слишком рассеян, чтобы определить их положение.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>-15</base_points>
		<reference>B158</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Susceptible (@Substance@)</name>
	<name-loc>Восприимчивый (@Вещество@)</name-loc>
	<points_per_level>-1</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Редкое (Occasional)</name>
		<cost type="multiplier">1</cost>
		<reference>B158</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Распространенное (Common)</name>
		<cost type="multiplier">2</cost>
		<reference>B158</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Очень распространенное (Very Common)</name>
		<cost type="multiplier">4</cost>
		<reference>B158</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B158</reference>
	<description-loc>
		Вы чрезвычайно чувствительны к определенному классу вредоносных предметов или веществ - например, болезням или ядам. Вы получаете пенальти к HT при попытке сопротивления им. Вы, однако, не получаете дополнительных повреждений; для этого см. Уязвимость (B161).
Если вы подвергаетесь воздействию вещества, к которому Восприимчивы, причем в столь малых дозах, что это не затронуло бы обычных людей - вам нужно сделать проверку HT+1 с вашим обычным пенальти за этот недостаток. При неудаче вы страдаете от половины обычного эффекта полной дозы (усталость, ранение, потеря атрибутов, потеря дееспособности и т.д.). Например, Восприимчивому к отравлению придется сделать проверку, выпив воды с еле уловимой примесью промышленных отходов, а Восприимчивому к Болезни придется сделать проверку после ввода "живой" вакцины (содержащей ослабленные микробы). При любом сомнении насчет условий или эффектов, окончательное решение остается за мастером.
Стоимость зависит от распространенности вещества в окружающей среде:


Очень распространенное (например, болезни, яды): -4 очка/-1 к проверке HT.
Распространенное (например, бактерии, газы): -2 очка/-1 к проверке HT.
Редкое (например, кишечные заболевания, яды внутреннего действия): -1 очко/-1 к проверке HT.


Вы не можете без разрешения мастера взять более пяти уровней Восприимчивости к конкретному веществу или более двух этих недостатков одновременно. Вы не можете взять уровней Восприимчивости больше, чем это нужно для уменьшения вашего эффективного HT до 3. Например, если у вас HT 7, вы не можете взять более четырех уровней. Если вы обладаете любым видом Устойчивости (B80) к конкретному веществу, вы не можете взять Восприимчивость к нему же.
С помощью данной особенности можно отразить множество обычных проблем со здоровьем. Используйте Восприимчивость к болезням для слабой иммунной системы, Восприимчивость к ядам внутреннего действия при отсутствии рвоты на вредные вещества ("слабый рвотный рефлекс"), и т.п.
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (@Large@)</name>
	<name-loc>Талант  (@Большой@)</name-loc>
	<points_per_level>15</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">@skill01@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill02@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill03@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill04@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill05@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill06@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill07@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill08@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill09@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill10@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill11@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill12@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill13@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill14@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill15@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill16@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill17@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>@Бонус реакции@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>@Бонус реакции@</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>@Другие преимущества@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">0</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B89</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (@Medium@)</name>
	<name-loc>Талант  (@Средний@)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">@skill01@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill02@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill03@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill04@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill05@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill06@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill07@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill08@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill09@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill10@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill11@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill12@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>@Бонус реакции@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>@Бонус реакции@</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>@Другие преимущества@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">0</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B89</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (@Small@)</name>
	<name-loc>Талант  (@Небольшой@)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">@skill1@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill2@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill3@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill4@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill5@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">@skill6@</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>@Бонус реакции@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>@Бонус реакции@</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>@Другие преимущества@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">0</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B89</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Animal Friend)</name>
	<name-loc>Талант  (Друг животных)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="contains">animal handling</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">falconry</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">packing</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">riding</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">teamster</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="contains">veterinary</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Обычные животные</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Обычные животные</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">1</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:6</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
<advantage version="2">
	<name>Talent (Master)</name>
	<name-loc>Талант (Мастер)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Оружейник</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Плотник</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Электрик</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Ремонт электроники</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Инженер</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Каменотес</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Механик</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Кузнец</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Слесарь</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1" enabled="yes">
		<name>Бонус реакции (Все, для кого вы работаете)</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>На кого работали</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>@Другие преимущества@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">0</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B89</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Gifted Artist)</name>
	<name-loc>Талант  (Одаренный артист)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Artist</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Jeweler</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Leatherworking</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Photography</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Sewing</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Покупатели и критики</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Покупатели и критики</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:10</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Green Thumb)</name>
	<name-loc>Талант  (Садовник)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Biology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Farming</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Gardening</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Herb Lore</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Naturalist</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Садоводы и чувсвующие растения</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Садоводы и чувсвующие растения</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус к борскам выживания растений под вашей опекой</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:11</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Healer)</name>
	<name-loc>Талант  (Целитель)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Diagnosis</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Esoteric Medicine</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">First Aid</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Pharmacy</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Physician</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Physiology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Psychology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Surgery</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Veterinary</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Пациенты</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Пациенты</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус к броскам HT пациентов при вашем полном уходе</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">-1</cost>
		<affects>levels only</affects>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">Talent (Healer)</name>
			<level compare="at least">1</level>
			<notes compare="contains">Modern</notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:11</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Healer)</name>
	<name-loc>Талант  (Целитель)</name-loc>
	<notes>Современность</notes>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Diagnosis</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Esoteric Medicine</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">First Aid</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Pharmacy</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Physician</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Physiology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Psychology</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Surgery</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Veterinary</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Electronics Operation</name>
		<specialization compare="is">Medical</specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Expert Skill</name>
		<specialization compare="is">Epidemiology</specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Пациенты</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Пациенты</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус к броскам HT пациентов при вашем полном уходе</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">1</cost>
		<affects>levels only</affects>
	</modifier>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">Talent (Healer)</name>
			<level compare="at least">1</level>
			<notes compare="does not contain">Modern</notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:11</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Mathematical Ability)</name>
	<name-loc>Талант  (Математические способности)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Accounting</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Astronomy</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Cryptography</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Engineer</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Finance</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Market Analysis</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Mathematics</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Physics</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Ученные и инженеры</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Ученные и инженеры</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус на поиск мошенничеств в цифрах</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">-2</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:12</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Musical Ability)</name>
	<name-loc>Талант  (Музыкальные способности)</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Group Performance</name>
		<specialization compare="is">Conducting</specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Musical Composition</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Musical Influence</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Musical Instrument</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Singing</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Зрители и критики</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Зрители и критики</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус на бросок восприятия от людей прослушавшим исполнение</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:13</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Outdoorsman)</name>
	<name-loc>Талант  (Путешественник)</name-loc>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Camouflage</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Fishing</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Mimicry</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Naturalist</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Navigation</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Survival</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Tracking</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Исследователи и любители природы</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Исследователи и любители природы</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус к броску HT чтобы избежать вреда от провала бонусных умений</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">-3</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:14</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Talent (Smooth Operator)</name>
	<name-loc>Талант  (Красноречивый)</name-loc>
	<points_per_level>15</points_per_level>
	<levels>1</levels>
	<skill_bonus>
		<name compare="is">Acting</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Carousing</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Detect Lies</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Diplomacy</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Fast-Talk</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Intimidation</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Leadership</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Panhandling</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Politics</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Public Speaking</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Savoir-Faire</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Sex Appeal</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">Streetwise</name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is"></name>
		<specialization compare="is anything"></specialization>
		<amount per_level="yes">1</amount>
	</skill_bonus>
	<modifier version="1">
		<name>Бонус реакции (Reaction Bonus)</name>
		<notes>Мошениеи, политики, продавцы и т.п. но только если ен пытался манипулировать им.</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<limitation>Мошениеи, политики, продавцы</limitation>
			<amount per_level="yes">1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другие преимущества (Alternate Benefit)</name>
		<notes>Бонус к сопротевлению вклченным умениям</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Другая цена (Alternative Cost)</name>
		<cost type="points">-2</cost>
		<affects>levels only</affects>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Talent</category>
	</categories>
	<type>Mental</type>
	<reference>B90,PU3:15</reference>
	<description-loc>Вы имеете природные склонности к нескольким близким навыкам. Таланты измеряются в уровнях и дают следующие выгоды:
* Премия +1 за каждый уровень ко всем включенным навыкам, даже при использовании по умолчанию. Это поднимает уровень атрибута исключительно для этих навыков, так что это дешевый путь быть опытным в небольшом количестве навыков.
* Премия +1 за уровень на все броски реакции всех, кто мог заметить ваш талант, если он может быть впечатлен вашими способностями (на усмотрение Мастера). Для получения этого бонуса вы должны продемонстрировать ваш талант – чаще всего использованием навыков.
* Уменьшение времени на изучение навыков в игре, независимо от путей учебы. Время уменьшается на 10% за каждый уровень таланта. Это не уменьшает цены в очках персонажа, которые вы оплачиваете за каждый уровень навыка.
Вы не можете иметь более четырех уровней таланта, но перекрывающиеся таланты могут дать бонус к общим навыкам и больше.
Цена за Талант зависит от количества подконтрольных навыков:
* Небольшая группа (до 6 навыков): 5/уровень;
* Средняя группа (7-12 навыков): 10/уровень;
* Большая группа (13+ навыков): 15/уровень.
Навыки с множеством специализаций считаются одним навыком. Когда вы получаете талант, список навыков фиксируется. (исключение: мастер может решить, что талант может воздействовать на навыки, появляющиеся в вышедших позже дополнениях или разработанные им самим).
Примеры талантов:
Друг животных (Animal Friend): Обращение с животными, Соколиная охота, Кучер, Ветеринар, Верховая езда, Навьючивание. Бонус к реакции: все животные. 5/уровень
Мастер (Artificier): Оружейник, Плотник, Электрик, Ремонт электроники, Инженер, Каменотес, Механик, Кузнец, Машинист. Бонус к реакции: все, для кого вы работаете. 10/уровень
Бухгалтер (Business Acumen): Бухгалтерский учет, Экономика, Финансы, Азартные игры, Анализ рынка, Администратор, Торговля, Пропаганда. Бонус к реакции: все, с кем вы имеете дело. 10/уровень
Одаренный артист (Gifted Artist): Изобразительное искусство, Ювелир, Шитье, Фотография, Кожевник. Бонус к реакции: все, кто покупает или оценивает вашу работу. 5/уровень
Садовник (Green Thumb): Биология, Фермер, Садоводство, Знание трав, Натуралист. Бонус к реакции: садовники, разумные растения. 5/уровень
Целитель (Healer): Диагностика, Эзотерическая медицина, Первая помощь, Фармакология, Врачебное дело, Физиология, Психология, Хирургия, Ветеринар. Бонус к реакции: все пациенты. 10/уровень
Математические способности (Mathematical Ability): Бухгалтерский учет, Астрономия, Криптография, Инженер, Финансирование, Анализ рынка, Математика, Физика. Бонус к реакции: Инженеры, ученые. 10/уровень
Музыкальные способности (Musical Ability): Дирижер, Композитор, Музыкальное влияние, Музыкальные инструменты, Пение. Бонус к реакции: любой слушающий или оценивающий вашу работу. 5/уровень
Путешественник (Outdoorsman): Маскировка, Рыбалка, Подражание звукам, Натуралист, Ориентирование, Выживание, Следопыт. Бонус к реакции: любители природы, исследователи и им подобные. 10/уровень
Красноречивый (Smooth Operator): Выступление, Вечеринки, Обнаружение лжи, Дипломатия, Забалтывание, Допрос, Лидерство, Попрошайничество, Политика, Публичные выступления, Хорошие манеры, Сексапильность, Знание улиц. Бонус к реакции: политики, торговцы, артисты – но если вы не пытаетесь манипулировать ими! 15/уровень
Новые таланты.
С разрешения Мастера, вы можете создать свой собственный талант, определив подходящий список навыков. Талант должен быть достоверным врожденным даром.</description-loc>
</advantage>
	<advantage version="2">
	<name>Technophobia/TL4- (Machinery)</name>
	<name-loc>Боязнь машин (Технофобия)</name-loc>
	<base_points>-5</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы никогда не сможете научиться ремонтировать любые машины или использовать что-либо сложнее арбалета или велосипеда. Любое высокотехнологичное окружение требует проверки на самоконтроль; взаимодействие с роботами или компьютерами дает пенальти в -3, а враждебные действия со стороны интеллектуальных машин в -6. -5 очков при TL4 или ниже, -15 очков при TL5 или выше. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Technophobia/TL5+ (Machinery)</name>
	<name-loc>Боязнь машин (Технофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы никогда не сможете научиться ремонтировать любые машины или использовать что-либо сложнее арбалета или велосипеда. Любое высокотехнологичное окружение требует проверки на самоконтроль; взаимодействие с роботами или компьютерами дает пенальти в -3, а враждебные действия со стороны интеллектуальных машин в -6. -5 очков при TL4 или ниже, -15 очков при TL5 или выше. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Teeth, Blunt</name>
		<name-loc>Зубы, тупые</name-loc>
		<description-loc>Обычные, тупые зубы наносят повреждения кол-1 (тупые). Это типично для большинства травоядных. Вы же обладаете более острыми зубами:

Острые зубы (Sharp teeth): Как у большинства хищников. Наносят Кол-1 режущего вреда. 1 очко.

Острый клюв (Sharp Beak): Как у хищной птицы. Наносит Кол-1 Большого пробивающего (pi+) вреда. 1 очко.
Клыки (Fangs): Как у саблезубого тигра. Наносят Кол-1 проникающего вреда. 2 очка.</description-loc>
		<type>Physical, Exotic</type>
		<melee_weapon>
			<damage>thr-1 cr</damage>
			<usage>Bite</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B91</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Teeth, Fangs</name>
		<name-loc>Зубы, клыки</name-loc>
		<description-loc>Обычные, тупые зубы наносят повреждения кол-1 (тупые). Это типично для большинства травоядных. Вы же обладаете более острыми зубами:

Острые зубы (Sharp teeth): Как у большинства хищников. Наносят Кол-1 режущего вреда. 1 очко.

Острый клюв (Sharp Beak): Как у хищной птицы. Наносит Кол-1 Большого пробивающего (pi+) вреда. 1 очко.
Клыки (Fangs): Как у саблезубого тигра. Наносят Кол-1 проникающего вреда. 2 очка.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>2</base_points>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<usage>Bite</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B91</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Teeth, Sharp</name>
		<name-loc>Зубы, острые</name-loc>
		<description-loc>Обычные, тупые зубы наносят повреждения кол-1 (тупые). Это типично для большинства травоядных. Вы же обладаете более острыми зубами:

Острые зубы (Sharp teeth): Как у большинства хищников. Наносят Кол-1 режущего вреда. 1 очко.

Острый клюв (Sharp Beak): Как у хищной птицы. Наносит Кол-1 Большого пробивающего (pi+) вреда. 1 очко.
Клыки (Fangs): Как у саблезубого тигра. Наносят Кол-1 проникающего вреда. 2 очка.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>1</base_points>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<usage>Bite</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B91</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Teeth, Sharp Beak</name>
		<name-loc>Зубы, клюв</name-loc>
		<description-loc>Обычные, тупые зубы наносят повреждения кол-1 (тупые). Это типично для большинства травоядных. Вы же обладаете более острыми зубами:

Острые зубы (Sharp teeth): Как у большинства хищников. Наносят Кол-1 режущего вреда. 1 очко.

Острый клюв (Sharp Beak): Как у хищной птицы. Наносит Кол-1 Большого пробивающего (pi+) вреда. 1 очко.
Клыки (Fangs): Как у саблезубого тигра. Наносят Кол-1 проникающего вреда. 2 очка.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>1</base_points>
		<melee_weapon>
			<damage>thr-1 pi+</damage>
			<usage>Peck</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>B91</reference>
		<categories>
			<category>Perk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Telecommunication</name>
	<name-loc>Телекоммуникация</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инфракрасное (Infrared)</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Лазерное (Laser)</name>
		<cost type="points">15</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Радио (Radio)</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Телесвязь (Telesend)</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Neutrino</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>P81</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Sonar</name>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>P81</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Широковещание (Broadcast)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Короткие волны (Short Wave)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Универсальная (Universal)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Видео (Video)</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Расовое (Racial)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только прием (Receive Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только передача (Send Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неопределенное (Vague)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B91</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Directional Sound</name>
		<cost type="points">5</cost>
		<affects>total</affects>
		<reference>P81</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Gravity Ripple</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>P81</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Burst</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>P81</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>FTL</name>
		<cost type="percentage">120</cost>
		<affects>total</affects>
		<reference>P82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Secure</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P82</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Sensie</name>
		<cost type="percentage">80</cost>
		<affects>total</affects>
		<reference>P82</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Exotic</type>
	<reference>B91</reference>
	<description-loc>Вы можете общаться на дальних расстояниях, не перекрикиваясь. Вы можете отправлять слова со скоростью обычного разговора, и изображения – со скоростью, с которой вы можете их рисовать. Установка контакта требует одной секунды концентрации и броска IQ. После этого дальнейшей концентрации не требуется. Вы можете поддерживать множество контактов, но каждое уже установленное соединение налагает кумулятивный штраф -1 на бросок IQ для нового контакта.
Телекоммуникация работает при любом шуме, хотя помехи и глушение может прервать сигнал. Имеющие подходящее снаряжение могут попытаться засечь, перехватить или заглушить ваш сигнал: Работа с электроникой (связь) для электромагнитного сигнала, Работа с электроникой (психотроника) для пси-сигнала и так далее.

Каждый вариант телекоммуникации – отдельное преимущество со своими выгодами и неудобствами. Некоторые форму имеют ограниченное расстояние, которое вы можете изменять соответствующими модификаторами.

Инфракрасное (Infrared): Вы общаетесь, используя модулируемый инфракрасный луч. Базовое расстояние – 500 ярдов в пределах прямой видимости. Короткое расстояние и необходимость прямой связи делает глушение и замечание почти невозможным при обычных условиях. Вы можете общаться только с теми, кто имеет это же преимущество или инфра-коммуникатор. 10 очков.

Лазерное (Laser): Вы общаетесь, используя модулируемый лазерный луч. Базовое расстояние – 50 миль в пределах прямой видимости. Узкий луч и необходимость прямой видимости сильно затрудняет перехват сигнала. Общение возможно только с имеющими такое же преимущество или лазерный коммуникатор. 15 очков.

Радио (Radio): Вы используете радио-волны. Базовое расстояние – 10 миль. Ваш сигнал – широковещательный (omnidirectional), но поскольку вы можете менять частоту, подслушивающие должны бросать навык использования электроники (связь) для прослушки. Побочная выгода – вы можете сами принимать и слушать любые обычные радиосигналы, настраиваясь на них броском IQ (занимает одну секунду). Заметьте, что помехи от молний и неэкранированной электроники могут помешать передаче. Радио совершенно не работает под водой. 10 очков.

Телесвязь (Telesend): Вы можете передавать мысли напрямую с помощью магии, псионики или другим способом (требуется указать). Цель может принимать мысли, даже если не имеет такой способности. Дальность теоретически неограничена, но для установления контакта вы получаете штраф на бросок IQ по таблице модификации дальних дистанций (с. B241). Если вы не можете видеть или иначе чувствовать цель, вы получаете дополнительный штраф: -1 за близких друзей, семью и любимых; -3 за обычных друзей; -5 за тех, кого видели лишь короткое время. 30 очков.

===Особые улучшения.===

Направленный звук (Directional Sound): Вы общаетесь, используя сфокусированный звуковой луч.
Базовая дистанция – 100 ярдов в пределах прямой видимости. Перехват и глушение требуют особого оборудования, но даже тогда близкая дистанция и необходимость прямой видимости налагает штраф -5. Электронный шум и завесы (дым, газ, туман) не мешают. Вы можете общаться только с имеющими такое же преимущество или аналогичное оборудование. 5 очков.

Грави-волны (Gravity-Ripple Comm): В общении вы используете гравитационное излучение. Базовая дистанция – 1000 миль. Ваш сигнал – широковещание, подслушивание требует использования умения Использования электроники (связь). Глушение вообще невозможно, хотя сильные источники гравитационного излучения
(нейтронные звезды, пульсары, черные дыры и пр.) могут помешать. Волны проникают под воду и сквозь любые предметы без любых штрафов. Доступно общение только с имеющими такое же преимущество или аналогичное оборудование. 20 очков.

Нейтринный коммуникатор
(Neutrino Comm): Вы используете модулированный луч нейтрино (или подобных частиц). 
Базовая дальность – 1000 миль по прямой.
Луч невозможно перехватить и заглушить, он работает в любых средах и сквозь любые препятствия, не блокируется даже линией горизонта. Вы можете общаться только с имеющими такое же преимущество или аналогичное оборудование. 25 очков.

Сонарный коммуникатор (Sonar Comm): использование модулированного сонара. Базовая дистанция – три мили под водой (на воздухе – 50 ярдов × воздушное давление, выраженное в АТМ).
Сигнал широковещателен - услышать вас можно, имея такое же преимущество или аналогичное оборудование. Заглушить сигнал можно только особым, мощным оборудованием, хотя взрывы могут навести временные помехи. Не работает в вакууме. 10 очков.

Широковещание (Broadcast): Доступно только для Телесвязи. Это позволяет вам отправлять мысли всем в определенном радиусе. Такая отправка требует броска IQ-4, дополнительно модифицированного модификаторами дальних дистанций для требуемого радиуса. +50%.

Короткие волны (Short Wave): Доступно только для Радиосвязи. Ваш сигнал отражается от ионосферы планеты (если у планеты есть такая). Это позволяет вам принимать и передавать сигнал из любых точек планеты. Солнечные вспышки, погода и подобные неприятности могут помешать связи. +50%.

Универсальная (Universal): Ваши сообщения автоматически переводятся на язык субъекта. Мастер может ограничить это расширение индивидами высоких технологических уровней, или запретить его для Телесвязи. +50%.

Видео (Video): Вы не ограничены простыми картинками, а можете передавать видео-сигнал в реальном времени, все что вы видите. +40%.

===Новые особые улучшения===
Ускоренная передача (Burst): Недоступно для Сонарного и Направленного звука. Ваша передача проходит очень быстро, намного быстрее, чем вы можете говорить.
+30% за 10-кратное увеличение скорости, +60% за 100-кратное, +90% за
1,000-кратное и так далее. Каждая ступень увеличения также дает -1 на попытки перехвата сообщений.

Быстрее света (FTL): сигнал идет быстрее скорости света, позволяя вам общаться с меньшей задержкой. Типы телекоммуникации, к которым применим этот модификатор, устанавливает Мастер, и он же объясняет механизм передачи. Это может быть луч БЧС-энергии для Радио или Грави-волн, поток БЧС-частиц для нейтринного коммуникатора, и т.д. «Гиперпространственный туннель», по которому проходит обычный сигнал, может подходить для любого вида. Рекомендуемая скорость сигнала – 0,1 парсеков в день до максимальной дальности 1/5000 обычной дальности в милях, выраженной в парсеках. Прием сигнала доступен только для имеющих такое же преимущество или равнозначную технологию.
+120%.

Шифрование (Secure): Сигнал проходит обработку, которая затрудняет его расшифровку. Шпионы должны победить в быстром состязании по ИН (если используется Телекоммуникация) или Использование Электроники (при технологическом перехвате) против вашего ИН, чтобы понять содержания. В противном случае они получают бессмысленный мусор. +20%.
Чувства (Sensie): вы можете транслировать сенсорные впечатления в реальном времени.
Доступно для всех форм телекоммуникации, но реципиент, использующий любые методы кроме Телесвязи, должен использовать особый приемник для полного представления. +80%.

===Особые ограничения.===

Расовое (Racial): Ваша способность работает только для существ вашей расы или очень похожей (как Чтение разума). -20%.

Только прием (Receive Only): Вы можете только принимать сигнал, но не передавать его. Недоступно для Телесвязи. -50%.

Только передача (Send Only): Вы можете только передавать сигнал, но не принимать другие сигналы. Это ограничение не применимо к Телесвязи.  -50%.
Неопределенное (Vague): Вы не можете отправлять речь или изображения. Вы ограничены простым кодом (например, морзянкой) или общим содержанием и эмоциями в случае Телесвязи. -50%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Telekinesis</name>
		<name-loc>Телекинез</name-loc>
		<description-loc>Вы можете манипулировать объектами, не касаясь их, а контролируя невидимой силой, которая находится под вашим сознательным контролем. Обязательно укажите способ – возможно, это магнетизм, псионика, фантастический луч или сверхъестественный эффект полтергейста.
Вы можете манипулировать далекими предметами как если бы вы держали их двумя руками с ST, равной уровню вашего Телекинеза (ТК). Вы можете перемещать любые объекты, которые можете поднять вашим ТК, со скоростью, равной уровню ТК, модифицированной уровнем нагрузки (с. B17). Независимо от уровня, максимальная дальность – 10 ярдов, для ее модификации берите Увеличенную (с. B106) или Уменьшенную (с. B115) Дистанцию.
Телекинез требует постоянной концентрации. В бою это означает, что вы обязаны каждый ход заявлять маневр «Концентрация». Телекинезом вы можете выполнить один стандартный маневр в ход, как если бы это была пара рук без тела: Подготовка (поднять предмет), Перемещение (перенести предмет), Атака (бросить или ударить).
=====Пример: в ваш ход в бою, вы заявляете маневр Концентрация, и объявляете, что ваш ТК предпринимает маневр Атаки, чтобы отобрать оружие у врага. На следующий ход вы можете опять концентрироваться, и указать, что ваш ТК Прицеливается или держит под прицелом врага отобранным пистолетом (Ожидание), стреляет из оружия (Атака), или пытается принести оружие в ваши руки (Перемещение).=====
Для обычных передвижений и подъема не требуется бросков. Для более сложных навыков, мастер может потребовать броска навыка или DX. В ситуациях, когда требуется бросок ST, вы бросаете против уровня ТК.
Все вышесказанное подразумевает, что вы используете ТК для выполнения задач на расстоянии. Однако, ТК может помочь вам и в таких навыках как Азартные игры (особенно для жульничества), Взломе и Хирургии. В общем, все, что получает выгоду от высокой ловкости рук, получит +4, если вы успешно прокинете бросок IQ для правильного использования ТК (при провале мастер назначает необходимый штраф).
Захваты и удары: Вы можете использовать ТК для прямой атаки врага. Для попадания кидайте DX или навык рукопашного боя. Ваш враг защищается, как если бы он был атакован невидимым врагом (с. B394). Если вы захватываете врага, он не может схватить вашу ТК-силу, но может попытаться освободиться как обычно. Если он тоже обладает ТК, он может использовать маневр Концентрации и попытаться освободиться телекинезом, бросая его уровень вместо ST для особождения. На следующий ход после того, как вы схватили врага, вы можете использовать маневр Перемещения, чтобы оторвать его от земли, если у вас достаточно силы, чтобы поднять его. Противник в этом положении не может делать ничего, что требует контакта с поверхностью (убежать), но все остальные действия доступны ему.
Левитация: Если вы имеете достаточно ТК-силы, чтобы поднять вес вашего тела, вы можете левитировать. Применяйте маневр Концентрация, и заставляйте ваш ТК перемещать тело. Для истинного полета покупайте преимущество Полет (с. B56), с ограничением Психокинетический.
Метание. Посылая мгновенный ТК-импульс, вы можете кидать предметы быстрее и дальше, чем вы могли бы перемещать их. Используйте маневр Концентрации, а затем – Атаки (с использование телекинеза). Сила и дальность броска рассчитывается также, как если бы предмет бросил человек с ST, равной вашему уровню ТК. Для попадания в цель требуется бросок Метания или Метательного оружия, в зависимости от типа брошенного предмета. Для расчета 1/2D и Мах дистанций, расстояние измеряется от предмета до цели; для расчета штрафов за расстояние – сумма дистанций от вас до предмета, и от предмета до цели. 

После метания предмета вы должны использовать маневр Подготовка вашим телекинезом, чтобы взять что-нибудь снова.
===Особые ограничения.===

Магнетизм (Magnetic): Ваш ТК – просто супермагнетизм, и воздействует только на магнитные металлы (железо, сталь, никель, кобальт). -50%.
Видимый (Visible): Ваш ТК – не невидимая сила, а принимает какую-то видимую форму – руки, сияющего луча, или чего-то подобного. Это облегчает защиту от ваших атак телекинезом. -20%.
Психокинетический (Psychokinetic): Ваша способность – часть псионической силы Психокинеза. Это делает ее ментальной, а не физической. -10%.

===Новые особые ограничения===
Специфичность (с.112) обычна для ТК, принадлежащего к элементальным силам. Вот еще несколько
важных ограничений:
Анимация (Animation): Ваш ТК работает, просто изгибая неодушевленные предметы. Минимальный необходимый уровень равен ЕЖ предмета, или их половине, если объект однородный (см. таблицу Единиц жизни предметов, с.В558). 
Анимированный предмет может хватать, поднимать, бить и кидать предметы с СЛ, равной уровню ТК, необходимой для его анимации, и вашим значением ЛВ.
Скорость его передвижения – если он не прикреплён к месту – равна вашему уровню ТК, минус необходимый для анимации уровень ТК. Вы даже можете использовать умения, управляя предметом – но помните, что большинство предметов не имеют Точных манипуляторов.
При прекращении контроля предметы возвращаются в исходное положение. Вы можете управлять множеством предметов, взяв улучшение Независимость (с.108), но в этом случае уровень ТК делится между ними. Вы не можете влиять на предметы, находящиеся внутри других. -30%, если предметы не могут летать, -20%, если имеющие крылья (вертолеты, игрушечные драконы и т.д.) – могут.

Притяжение/Отталкивание
(Attraction/Repulsion): Ваш ТК может двигать вещи только прямо от вас или к вам. Для несопротивляющихся используется маневр Подготовка, для сопротивляющихся – Атака. Вы не можете с помощью ТК бить, манипулировать предметами или удерживать врага на месте. Притяжение двигает предметы до достижения контакта с вами или пока вы не прекратите использование телекинеза. Отталкивание будет передвигать объекты до границ воздействия вашего ТК.
В любом случае, предметы могут перемещаться в противоположном направлении только передвигающий победит в быстром состязании своей СЛ или уровня ТК против вашего уровня ТК. Несовместимо с Анимацией. -60% за один из этих видов движения, -30% за оба (переключение – маневр Подготовки). 

Только подъем (Lift Only): Уровни ТК с этим ограничением не добавляются к скорости движения с помощью ТК. -20%.

Только движение (Move Only): Уровни ТК с этим ограничением не увеличивают СЛ ТК. -20%.
</description-loc>
		<type>Mental/Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Магнетизм (Magnetic)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B92</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Видимый (Visible)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B92</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Психокинетический (Psychokinetic)</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B92</reference>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Super-Effort</name>
			<cost type="percentage">400</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Animation</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Animation</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P83</reference>
			<notes>Не летающие</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Attraction</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Repulsion</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Attraction/Repulsion</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Lift Only</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Move Only</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P83</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Animate Life-forms</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>Sup28</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Animate Life-forms</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>Sup28</reference>
			<notes>Частичная</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Super-Damage</name>
			<cost type="percentage">900</cost>
			<affects>total</affects>
			<reference>Sup29</reference>
		</modifier>
		<reference>B92</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Telescopic Vision</name>
	<name-loc>Телескопическое зрение</name-loc>
	<points_per_level>5</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Нет прицеливания (No Targeting)</name>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B92</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B92</reference>
	<description-loc>Вы можете увеличивать дальность зрения как при использовании бинокля. Каждый уровень позволяет игнорировать -1 штрафа за расстояние на любой бросок зрения, или до -2, если вы прицеливаетесь в одну цель. Также эта способность может использоваться как оптический прицел – давая вам бонус +1 Асс за уровень, когда вы целитесь в течение нескольких секунд, равных бонусу (см. Аксессуары для оружия, прицелы – с. B411).

Выгоды этой черты не складываются с таковыми от технологических устройств – типа биноклей или прицелов. Если у вас есть и то и другое, вы должны использовать что-то одно из них.
===Особые ограничения.===
Нет прицеливания (No Targeting): Ваше поле зрения широко, и не уменьшается для дальних атак. В бою вы не получаете бонуса за прицеливание. -60%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Temperature Control</name>
		<name-loc>Контроль температуры</name-loc>
		<description-loc>Вы можете изменять окружающую температуру. Нагревание или охлаждение ограничено 20 градусами за уровень, и изменяется на 2о за секунду концентрации. Вы можете воздействовать на область 2 ярда радиусом, на расстоянии до 10 ярдов от себя. Используйте модификаторы Увеличенная или Уменьшенная динстанция, Воздействие на область.

Эта способность никогда не наносит вреда сама по себе. Для этого покупайте врожденную атаку (обычно обжигающую или изнуряюшую). 
===Особые ограничения.===

Охлаждение (Cold): Вы можете только уменьшать температуру. -50%.
Нагревание (Heat): Вы можете только увеличивать температуру. -50%.
Психокинетическая (Psychokinesis): Ваша способность – часть псионической силы Психокинеза (с. B256), часто называемая криокинезом (для охлаждающей версии) или пирокинезом (для нагревающей). (-10%):</description-loc>
		<type>Mental/Physical, Exotic</type>
		<levels>1</levels>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Охлаждение (Cold)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B92</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Нагревание (Heat)</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B92</reference>
		</modifier>
		<reference>B92</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Temperature Tolerance</name>
		<name-loc>Устойчивость к температурам</name-loc>
		<description-loc>Каждый персонаж имеет «комфортную зону» температур, при которых он не страдает (не теряет FP и НР) от холода и жары. Для обычных людей это 55о между 35о и 90о. Для нелюдей эта зона может центрироваться где угодно, но не превышать промежутка в 55о. Более широкая зона – уже преимущество. Каждый уровень УТ добавляет НТ градусов к комфортной зоне – увеличивая ее в любом направлении, каком вы пожелаете. 
Это преимущество не предполагает специальной защиты от атак огнем или холодом, если только вред не является результатом поднятия или падения температуры окружающей среды. Также, это не поможет, если изменяется сама температура тела существа.
В реалистичной кампании мастер должен ограничить это преимущество 1-2 уровнями для людей. Нелюди могут иметь и более высокие уровни – из-за меха, или толстого слоя жира.</description-loc>
		<type>Physical</type>
		<levels>1</levels>
		<points_per_level>1</points_per_level>
		<reference>B93</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Temporal Inertia</name>
		<name-loc>Темпоральная инертность</name-loc>
		<description-loc>Вы прочно закреплены в вероятностях. Если изменяется история, вы помните обе версии. Если вы вовлечены во временной парадокс – вы не исчезаете, даже если изменяется мир вокруг вас! Для вас всегда есть место в новом мире, и вы сохраняете весь опыт – даже то, чего никогда с вами не было. В экстремальных случаях у вас есть два полных комплекта памяти, и вы должны делать бросок IQ, чтобы различить их в стрессовой ситуации.
Также существует и неприятность: вы существуете во всех параллельных мирах и временах – и тот «вы» похожи на вас, насколько это позволяет время.
Эта черта доступна только в кампаниях, где временные парадоксы и изменения в истории – включая переписывание прошлого или даже удаление целых параллельных линий времени – возможны. Противоположность этому преимуществу – Уникальность (с. B160).</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>15</base_points>
		<reference>B93</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Tenure</name>
		<name-loc>Пожизненная должность</name-loc>
		<description-loc>Вас нельзя уволить обычным путем. Вы можете потерять работу только в результате невероятной некомпетентности, серьезного преступления или аморального поведения. Во всех остальных случаях ваше место и жалование гарантировано на всю вашу жизнь. Обычно для современных профессоров университетов, но также применяется и для судей, священников, сенаторов и т.п. во многих обществах.</description-loc>
		<type>Social</type>
		<base_points>5</base_points>
		<reference>B93</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Teratophobia (Monsters)</name>
	<name-loc>Боязнь чудовищ (Тератофобия) (Чудовище)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>У вас вызывает страх любое "неестественное" создание. Вы получаете от -1 до -4 к проверке самоконтроля, если чудовище кажется очень большим или опасным, или если их много. Обратите внимание, что определение "чудовища" зависит от опыта. Для американского индейца слон будет чудовищем, а для африканского пигмея - нет! -15 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
	<name>Terminally Ill</name>
	<name-loc>Смертельная болезнь</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>2 года</name>
		<cost type="points">-50</cost>
		<affects>total</affects>
		<reference>B158</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1года</name>
		<cost type="points">-75</cost>
		<affects>total</affects>
		<reference>B158</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1 месяц</name>
		<cost type="points">-100</cost>
		<affects>total</affects>
		<reference>B158</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B158</reference>
	<description-loc>Вы скоро умрете. Это может быть следствием опасной болезни, сильного проклятия, неустранимого взрывного устройства, вживленного в основание черепа, или чего-то еще, безусловно смертельного. Стоимость зависит от оставшегося вам времени:


!Оставшееся время|	Стоимость
|	До одного месяца|	-100
|	До одного года|	-75
|	До двух лет|	-50
	

Срок более двух лет не стоит ничего. За это время любого может сбить грузовик!
Если вы достаете "чудесное снадобье", переходите в новое тело или иным способом продлеваете свою жизнь в кампании дольше, чем указано в недостатке, вы обязаны его выкупить. Если вы не можете этого сделать, мастер может восполнить разницу новыми недостатками, связанными с вашей болезнью или ее лечением (например, Хронические боли, Зависимость, Требует обслуживания или Восприимчивость).
Если мастер проводит быстрое приключение или короткую кампанию, он должен отменить этот недостаток ввиду его бессмысленности.</description-loc>
</advantage>
	<advantage version="2">
		<name>Terrain Adaptation (@Terrain Type@)</name>
		<name-loc>Адаптация к поверхности  (@Тип@)</name-loc>
		<description-loc>Вы не получаете штрафов к DX или Скорости за один указанный тип неустойчивой поверхности (снег, лед, песок и пр.). Цена зависит от способностей:

Замена. Вы можете нормально двигаться по неустойчивой поверхности одного типа, но вместо этого получаете такой же штраф при движении по твердой поверхности. 0 очков.
Полная. Вы можете нормально двигаться и работать на неустойчивой поверхности одного типа и на твердой земле. 5 очков.
Способность покупается отдельно для каждого вида неустойчивой поверхности.

===Новое особое улучшение===
Активная (Active): Вы быстро адаптируетесь к любой поверхности. Вместо покупки отдельного преимущества для каждого типа поверхности, купите 5-очковую версию с этим улучшением. Эта способность может отражать сверхчеловеческий баланс, превращение или «умные колеса». +300%.
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Нестабилен на твердой поверхности (Unstable on solid ground)</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B93</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Active</name>
			<cost type="percentage">300</cost>
			<affects>total</affects>
			<reference>P84</reference>
		</modifier>
		<reference>B93</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Terror</name>
	<name-loc>Страх</name-loc>
	<base_points>30</base_points>
	<points_per_level>10</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no">
		<name>Всегда включено (Always On)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B93</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Active</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P84</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Presence</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<reference>P84</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B93</reference>
	<description-loc>Вы можете пугать других. Эффект может быть представлен чем угодно – леденящим воем, умопомрачительной формой тела и даже божественным трепетом или невероятной красотой. При активации этой способности, любой вас видящий или слышащий (выберите что-то одно) кидает бросок страха (с. B360). 
Модификаторы: все обычные, применимые к броску Страха (с. B360). Вы можете приобрести дополнительные уровни преимущества, что дает жертвам по -1 очку штрафа за каждый уровень преимущества свыше первого. Ваши жертвы получают +1 к повторным броскам страха от вас в течение 24 часов. 

Если жертва прокидывает бросок страха, она иммунна к страху, навеваемому вами, в течение часа.
===Особые ограничения.===
Всегда включено (Always On): Вы не можете выключить способность и вернуться к нормальному общению. Часто комплектуется крайними уровнями Внешности – Отвратительной или хуже, но также применима и для Идеальных. -20%.

===Новые особые улучшения===
Богоподобные существа часто имеют Абсолют (с.В103) на уровне
«Неостановимая атака». Жертвы не получают выгоды за наличие преимуществ как Бесстрашие или Невозмутимость (если только те черты также не являются Абсолютными), и страдают от эффекта Ужаса, Трепета или Замешательства, если провалят бросок. 

Активное (Active): Ваша способность не воздействует на всех сразу – это прямая ментальная атака на одну цель в радиусе 10 ярдов. Цель должна видеть или слышать вас. Необходим маневр концентрации и состязание по Воле. Жертва получает -1 за каждые -1 штрафа к броску Страха, который вы наводите. В случае провала жертва как обычно делает бросок страха, но используется не провальность броска жертвы, а значение вашейпобеды в состязании. +0%.

Присутствие (Presence): Вашего присутствия достаточно, чтобы заставить всех в радиусе 10 ярдов сделать бросок страха. Ваши жертвы не обязаны видеть или слышать вас – вы даже можете находиться в гробу, и все равно всех пугать. Каждый уровень Области действия удваивает радиус воздействия, но Мастер может запретить воздействие на слишком уж большие зоны. +25%.
</description-loc>
</advantage>
	<advantage version="2">
	<name>Thalassophobia (Oceans)</name>
	<name-loc>Боязнь океанов (Талассофобия)</name-loc>
	<base_points>-10</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вы боитесь больших водных пространств. Вы практически не способны пересечь океан по воде или по воздуху, а встреча с водными чудовищами надолго выбьет вас из колеи. -10 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Timesickness</name>
		<name-loc>Временная болезнь</name-loc>
		<description-loc>Вы плохо себя чувствуете во время телепортации, путешествия во времени или между измерениями. Вы не способны владеть псионическими талантами, заклинаниями или технологическими умениями, имеющими отношение к этому виду путешествий, и не можете изучить умение Чувство тела. Вам необходимо делать проверку HT при каждой телепортации, путешествии во времени или между измерениями. При неудаче вы оглушены на 1d часов (время удваивается при критической неудаче!). При удаче вы оглушены только на 1dx10 минут.
Временная болезнь позволена только в кампаниях с частой телепотрацией, путешествиями во времени или между измерениями. Мастер может разрешить измененный вариант этой черты в кампаниях со сверхсветовыми гипер- ("Гиперболезнь") или прыжковыми двигателями ("Прыжковая болезнь").</description-loc>
		<type>Physical</type>
		<base_points>-10</base_points>
		<reference>B158</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trademark</name>
		<name-loc>Личный знак</name-loc>
		<description-loc>У вас есть особый знак - нечто, что вы оставляете в качестве "подписи", покидая место действия. Классический пример из литературы - вырезанный знак "Z" Зорро.

Причуда: Нужно очень мало времени; его легко не заметить, а выследить вас по нему попросту невозможно. -1 очко.
Простой: Нанесение Личного знака не занимает много времени и не позволяет вас выследить, но оставить его вы обязаны. Вы не можете уйти, не сделав этого, даже если враги уже ломятся в дверь. Типичный пример - оставить что-нибудь вроде игральной карты, маленького плюшевого зверька и т.д., если это не занимает много времени и по нему нельзя вас выследить. -5 очков.
Сложный: То же что и выше, но Личный знак несколько увеличивает вероятность вашей поимки - вырезанные инициалы, записки, улики, которые можно проследить и т.д. Чтобы оставить Личный знак, нужно потратить минимум 30 секунд. Любой, кто обыщет место действия, получит +2 к проверке Криминологии и Судебной экспертизы с целью выследить вас или установить вашу личность. -10 очков.
Детальный: Ваш Личный знак настолько сложен - обливание захваченных бандитов определенным одеколоном, окраска всего места преступления в розовый цвет, написание длинного стихотворения, обращенного к полиции, - что фактически гарантирует поимку. Мастер может дать следователям подсказки без успешной проверки Криминологии или Судебной экспертизы! -15 очков.


У вас может быть только один Личный знак. Сложные действия (например, связывание жертв фиолетовым телефонным кабелем, рисование лягушки на стене и уничтожение всех компьютеров в здании) просто дают более высокий уровень Личного знака, а не несколько отдельных знаков.
Обратите также внимание, что Личный знак отличается от собственно поимки преступников, совершения преступления, и т.д. Это особый способ совершить эти действия. Уничтожение файлов на компьютере не является Личным знаком, а замена в каждом из них символа "7" на "5" - является таковым.</description-loc>
		<type>Mental</type>
		<levels>0</levels>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<notes>@Описание@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trademark (@Complex@)</name>
		<name-loc>Личный знак (@Сложный@)</name-loc>
		<description-loc>У вас есть особый знак - нечто, что вы оставляете в качестве "подписи", покидая место действия. Классический пример из литературы - вырезанный знак "Z" Зорро.

Причуда: Нужно очень мало времени; его легко не заметить, а выследить вас по нему попросту невозможно. -1 очко.
Простой: Нанесение Личного знака не занимает много времени и не позволяет вас выследить, но оставить его вы обязаны. Вы не можете уйти, не сделав этого, даже если враги уже ломятся в дверь. Типичный пример - оставить что-нибудь вроде игральной карты, маленького плюшевого зверька и т.д., если это не занимает много времени и по нему нельзя вас выследить. -5 очков.
Сложный: То же что и выше, но Личный знак несколько увеличивает вероятность вашей поимки - вырезанные инициалы, записки, улики, которые можно проследить и т.д. Чтобы оставить Личный знак, нужно потратить минимум 30 секунд. Любой, кто обыщет место действия, получит +2 к проверке Криминологии и Судебной экспертизы с целью выследить вас или установить вашу личность. -10 очков.
Детальный: Ваш Личный знак настолько сложен - обливание захваченных бандитов определенным одеколоном, окраска всего места преступления в розовый цвет, написание длинного стихотворения, обращенного к полиции, - что фактически гарантирует поимку. Мастер может дать следователям подсказки без успешной проверки Криминологии или Судебной экспертизы! -15 очков.


У вас может быть только один Личный знак. Сложные действия (например, связывание жертв фиолетовым телефонным кабелем, рисование лягушки на стене и уничтожение всех компьютеров в здании) просто дают более высокий уровень Личного знака, а не несколько отдельных знаков.
Обратите также внимание, что Личный знак отличается от собственно поимки преступников, совершения преступления, и т.д. Это особый способ совершить эти действия. Уничтожение файлов на компьютере не является Личным знаком, а замена в каждом из них символа "7" на "5" - является таковым.</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trademark (@Elaborate@)</name>
		<name-loc>Личный знак 
 (@Детальный@)</name-loc>
		<description-loc>У вас есть особый знак - нечто, что вы оставляете в качестве "подписи", покидая место действия. Классический пример из литературы - вырезанный знак "Z" Зорро.

Причуда: Нужно очень мало времени; его легко не заметить, а выследить вас по нему попросту невозможно. -1 очко.
Простой: Нанесение Личного знака не занимает много времени и не позволяет вас выследить, но оставить его вы обязаны. Вы не можете уйти, не сделав этого, даже если враги уже ломятся в дверь. Типичный пример - оставить что-нибудь вроде игральной карты, маленького плюшевого зверька и т.д., если это не занимает много времени и по нему нельзя вас выследить. -5 очков.
Сложный: То же что и выше, но Личный знак несколько увеличивает вероятность вашей поимки - вырезанные инициалы, записки, улики, которые можно проследить и т.д. Чтобы оставить Личный знак, нужно потратить минимум 30 секунд. Любой, кто обыщет место действия, получит +2 к проверке Криминологии и Судебной экспертизы с целью выследить вас или установить вашу личность. -10 очков.
Детальный: Ваш Личный знак настолько сложен - обливание захваченных бандитов определенным одеколоном, окраска всего места преступления в розовый цвет, написание длинного стихотворения, обращенного к полиции, - что фактически гарантирует поимку. Мастер может дать следователям подсказки без успешной проверки Криминологии или Судебной экспертизы! -15 очков.


У вас может быть только один Личный знак. Сложные действия (например, связывание жертв фиолетовым телефонным кабелем, рисование лягушки на стене и уничтожение всех компьютеров в здании) просто дают более высокий уровень Личного знака, а не несколько отдельных знаков.
Обратите также внимание, что Личный знак отличается от собственно поимки преступников, совершения преступления, и т.д. Это особый способ совершить эти действия. Уничтожение файлов на компьютере не является Личным знаком, а замена в каждом из них символа "7" на "5" - является таковым.</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trademark (@Simple@)</name>
		<name-loc>Личный знак 
 (@Простой@)</name-loc>
		<description-loc>У вас есть особый знак - нечто, что вы оставляете в качестве "подписи", покидая место действия. Классический пример из литературы - вырезанный знак "Z" Зорро.

Причуда: Нужно очень мало времени; его легко не заметить, а выследить вас по нему попросту невозможно. -1 очко.
Простой: Нанесение Личного знака не занимает много времени и не позволяет вас выследить, но оставить его вы обязаны. Вы не можете уйти, не сделав этого, даже если враги уже ломятся в дверь. Типичный пример - оставить что-нибудь вроде игральной карты, маленького плюшевого зверька и т.д., если это не занимает много времени и по нему нельзя вас выследить. -5 очков.
Сложный: То же что и выше, но Личный знак несколько увеличивает вероятность вашей поимки - вырезанные инициалы, записки, улики, которые можно проследить и т.д. Чтобы оставить Личный знак, нужно потратить минимум 30 секунд. Любой, кто обыщет место действия, получит +2 к проверке Криминологии и Судебной экспертизы с целью выследить вас или установить вашу личность. -10 очков.
Детальный: Ваш Личный знак настолько сложен - обливание захваченных бандитов определенным одеколоном, окраска всего места преступления в розовый цвет, написание длинного стихотворения, обращенного к полиции, - что фактически гарантирует поимку. Мастер может дать следователям подсказки без успешной проверки Криминологии или Судебной экспертизы! -15 очков.


У вас может быть только один Личный знак. Сложные действия (например, связывание жертв фиолетовым телефонным кабелем, рисование лягушки на стене и уничтожение всех компьютеров в здании) просто дают более высокий уровень Личного знака, а не несколько отдельных знаков.
Обратите также внимание, что Личный знак отличается от собственно поимки преступников, совершения преступления, и т.д. Это особый способ совершить эти действия. Уничтожение файлов на компьютере не является Личным знаком, а замена в каждом из них символа "7" на "5" - является таковым.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trained by a Master</name>
		<name-loc>Ученик мастера</name-loc>
		<description-loc>Вас тренировал настоящий мастер боевых искусств (или вы сами являетесь им). Ваш исключительный талант дает вам возможность получать только половинный штраф от Быстрой атаки (с. B370) или за дополнительное парирование в раунд (с. B376). Вы получаете выгоды для всех боевых навыков рукопашного боя и оружия ближнего боя.
Кроме того, вы можете использовать вашу внутреннию энергию (часто называемую «Ки») для выполнения невероятных трюков. Вы можете изучать любые навыки, требующие этого преимущества (Летящий удар, Искусство невидимости, Сильный удар и пр. – см. Главу 4). 
Мастер при желании может назначить требования для этого преимущества. Обычные примеры – боевой навык, философия, теология. Эта способность определенно «больше, чем жизнь». В реалистичной кампании мастер может запретить это преимущество.</description-loc>
		<type>Mental</type>
		<base_points>30</base_points>
		<reference>B93</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Trickster</name>
		<name-loc>Насмешник</name-loc>
		<description-loc>Вы получаете удовольствие, измываясь над опасными противниками. Это не обычные розыгрыши. Вас не радуют простые шутки над наивными или безобидными людьми - в них нет риска! Это может быть совершенно бесполезно (скорее всего, так и будет), но вам просто необходимо испытывать собственное остроумие и ловкость.
Делайте проверку на самоконтроль каждый день. При неудаче вы должны попробовать разыграть кого-то опасного: опытного воина, смертоносное чудовище, целую группу достаточно разумных противников, и т.п. При удаче вы получаете штраф -1 в день, который накапливается вплоть до ближайшего провала!</description-loc>
		<type>Mental</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>True Faith</name>
		<name-loc>Истинная вера</name-loc>
		<description-loc>Вы обладаете глубокой религиозной верой, которая защищает вас от злых сверхъестественных существ, подобных демонам и вампирам. Для использования этой защиты, вы должны активно подтверждать веру ношением физического символа вашей религии (распятие, Тора, Коран), молиться или предпринимать другие действия в соответствии с вашей верой. Если вы хотите использовать способность в бою – например, чтобы отогнать зомби – вы должны использовать маневр концентрации каждый ход, и не можете делать ничего больше.
Пока вы «молитесь», ни одно враждебное сверхъестественное существо (что к ним относится – на усмотрение Мастера) – не может приблизиться к вам ближе, чем на 1 ярд. Если его туда втолкнуть, враг должен покинуть область как можно скорее, как будто на него воздействует Боязнь (с. B132). Если сущность не может покинуть область, не подойдя ближе – она должна сделать бросок Воли(Will), и в случае успеха может попытаться проскользнуть мимо вас. При провале монстр становится абсолютно неспособным предпринимать никакие действия.
Для сохранения Истинной веры, вы должны придерживаться соответствующего поведения, и иметь один или более самоограничивающих недостатков (с. B121). Это является встроенным ограничением Договор, так что вы не можете докупить это ограничение снова. Однако, вы не обязаны быть добрым и милосердным. Жестокий фанатик или религиозный террорист может иметь такую же силу, как и святой отшельник.

===Новое особое улучшение===
Изгнание (Turning): Вы можете намеренно изгонять существ, на которых действует ваша Истинная вера. Это требует маневра концентрации и быстрого состязания по Воле против Воли цели, которая может вас видеть. Для множества одинаковых монстров с одинаковой волей достаточно одного состязания. Радиус действия Истинной веры увеличивается на значение, равное успеху вашего броска, для всех существ, в состязании с которыми у вас вышла хотя бы ничья (минимум 1 ярд). Если существа оказываются в пределах этого радиуса, они должны бежать, как в случае с обычной Истинной верой.
Эффект действует, пока вы концентрируетесь и еще 1к секунд после этого. +65%.
</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Chosen</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>P84</reference>
			<notes>@Божество@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Turning</name>
			<cost type="percentage">65</cost>
			<affects>total</affects>
			<reference>P84</reference>
		</modifier>
		<reference>B94</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Truthfulness</name>
		<name-loc>Правдивость 
</name-loc>
		<description-loc>Вам крайне неприятно говорить ложь - или это у вас попросту плохо получается. Делайте проверку на самоконтроль каждый раз, когда нужно промолчать, чтобы не сказать неудобную правду (солгать, замолчав о чем-то). Пенальти -5, если вы должны сказать неправду! При неудаче вы говорите правду или так запинаетесь, что ложь становится очевидной. У вас постоянный штраф -5 к умению Заговаривания зубов и -5 к Артистизму, когда нужно кого-то обмануть.</description-loc>
		<type>Mental</type>
		<base_points>-5</base_points>
		<cr>12</cr>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">fast talk</name>
			<specialization compare="is anything"></specialization>
			<amount>-5</amount>
		</skill_bonus>
	</advantage>
	<advantage version="2">
		<name>Tunneling (@Tunnel Move@)</name>
		<name-loc>Прокладка туннелей</name-loc>
		<description-loc>Вы можете прокапываться сквозь землю как червь, выбрасывая землю и камень позади себя. Эта способность позволяет вам прокопать проход своего размера сквозь землю или даже камень (движение сквозь камень – только с половиной скорости).
Мастер может позволить шанс обвала туннеля за копающим – персонаж каждую минуту откидывает высшее значение из IQ, Инженер (рудники) или Разведки полезных ископаемых-3 для создания стабильного туннеля. Это может быть модифицировано свойствами земли. Каждое уменьшение скорости копания вдвое добавляет к броску +1.

===Новое особое улучшение===
Свободные руки (Hands-Free): Вы копаете не руками, а другой частью тела, дезинтеграцией или еще чем-то. Ваши руки свободны и вы можете пользоваться ими. +20%.
</description-loc>
		<type>Physical, Exotic</type>
		<levels>1</levels>
		<base_points>30</base_points>
		<points_per_level>5</points_per_level>
		<modifier version="1" enabled="no">
			<name>Hands Free</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P86</reference>
		</modifier>
		<reference>B94</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Ultrahearing</name>
		<name-loc>Ультразвуковой слух</name-loc>
		<description-loc>Вы можете слышать звуки свыше обычных частот, слышимых человеческим ухом (20 КГц). Это позволяет вам обнаруживать сонар, детекторы движения, собачьи свистки. Вы можете обнаруживать активный сонар на расстоянии вдвое больше его эффективного радиуса.
Если вы можете слышать только высокочастотные звуки, преимущество не стоит очков, иначе – 5 очков.
Это преимущество встроено в Ультразвуковую речь (см. выше), если вы имеете возможность издавать ульразвук, вам не надо иметь данное преимущество.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормального слуха (No normal hearing)</name>
			<cost type="points">-5</cost>
			<affects>total</affects>
			<reference>B94</reference>
		</modifier>
		<reference>B94</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Ultrasonic Speech</name>
		<name-loc>Ультразвуковая речь</name-loc>
		<description-loc>Вы можете общаться в ультразвуковом диапазоне. Также включает Ультразвуковой слух. Обратите внимание, что многие создания находят ультразвук неприятным или даже болезненным. Стоимость зависит от способности:
Вы можете общаться только в ультразвуковом диапазоне, способнсоть стоит 0 очков, 
Вы можете переключаться между обычной речью и ультразвуковой - 10.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормальной речи (No normal speech)</name>
			<cost type="points">-10</cost>
			<affects>total</affects>
			<reference>B94</reference>
		</modifier>
		<reference>B94</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Ultravision</name>
		<name-loc>Ультразрение</name-loc>
		<description-loc>Вы можете видеть ультрафиолетовое излучение. Солнечные УФЛ присутствуют на улице днем, даже в облачную погодну, но они останавливаются стеклом и любым плотным веществом. Флюоресцентные лампы также излучают УФЛ. Под УФЛ вы можете различать больше цветов, чем обычно – это позволяет вам различать границы, замечать пыль и краску – и даже определять минералы и растения. Вы получает +2 на все броски зрения, а также Судебную Экспертизу, Наблюдение и Обыск, если вокруг есть УФЛ.
Ночью небольшое количество УФЛ исходит от звезд. Это не позволит вам видеть в темноте, но вы можете игнорировать -2 штрафа за темноту (кумулятивно с Ночным зрением). Также УФЛ проникают в воду гораздо глубже – так что вы можете уменьшить штрафы за зрение под водой в два раза (однако, в полной темноте вы также слепы, как и все остальные).
Вы можете видеть только в УФ-спектре, и слепы в помещениях, под землей и везде, где нет УФ, даже если там есть обычные источники света – 0 очков.
Если вы можете видеть и при обычном свете тоже – 10 очков.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Нет нормального зрения (No normal vision)</name>
			<cost type="points">-10</cost>
			<affects>total</affects>
			<reference>B94</reference>
		</modifier>
		<reference>B94</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Unaging</name>
		<name-loc>Нестареющий</name-loc>
		<description-loc>Вы никогда не старитесь – даже от магии. Возраст фиксируется на любом моменте, когда вы пожелаете, и никогда не изменяется. 

===Особые улучшения.===

Контролируемое (Age Control): Вы можете изменять свой возраст в любом направлении с 10-кратной скоростью. +20%.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Контролируемое (Age Control)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B95</reference>
		</modifier>
		<reference>B95</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Uncongenial</name>
		<name-loc>Необщительный</name-loc>
		<description-loc>
Слабая форма Одиночки (B142). Вам нравится быть одному. Вы предпочитаете индивидуальные действия, работе в команде.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B164</reference>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Uncontrollable Appetite (@Craving@)</name>
		<name-loc>Неконтролируемый аппетит (@Потребность@)</name-loc>
		<description-loc>Вы питаетесь чем-то, что нужно получать от других разумных существ силой или хитростью, и с трудом контролируете свой голод. Вы должны определить, что вам нужно. Это может быть кровь, "жизненная сила", секс, или что-либо еще, что разрешит мастер.
Всякий раз, когда вы можете удовлетворить свою жажду, сделайте проверку на самоконтроль. Пенальти составит -2, если кто-то намеренно вас искушает или ваша "еда" находится рядом в больших количествах. Если ее поглощение восстановит потерянные хиты, вы получаете пенальти к проверке: -1 за каждый потерянный хит. При неудаче вы должны насытиться. Сделайте вторую проверку на самоконтроль, чтобы прекратить процесс питания после насыщения. При неудаче вы впадаете в безумие и продолжаете "питаться", рискуя убить жертву.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>-15</base_points>
		<cr>12</cr>
		<reference>B159</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Unfazeable</name>
		<name-loc>Невозмутимый</name-loc>
		<description-loc>Ничто не может вас удивить – по крайней мере, если это не явная угроза. Мир полон странных вещей, и до тех пор, пока они вас не трогают, вы не обращаете на них внимания. 
Вам не нужно делать бросков страха, и различные модификаторы на реакцию почти не влияют на вас. Вы одинаково вежливы со всеми незнакомцами, независимо от того, насколько они необычны, пока они ведут себя хорошо. Вы реагируете с обычными пенальти к реакции на любого, кто ведет себя грубо или буянит, но останетесь вежливым, даже если придется прибегнуть к насилию. Запугивание (B202) на вас не действует.
Персонаж с этим преимуществом не бесчувственный – он просто никогда не выказывает сильных эмоций. 
Это преимущество нужно полностью отыграть, иначе мастер может объявить, что оно потеряно. В кампании, где Проверки на испуг делаются ежечасно, мастер может потребовать за это преимущество 20 и более очков, или запретить его. Это преимущество несовместимо с любыми фобиями.</description-loc>
		<type>Mental</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Familiar Horrors</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>H20</reference>
		</modifier>
		<reference>B95</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Unfit</name>
	<name-loc>Неспортивный 
</name-loc>
	<base_points>-5</base_points>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B160</reference>
	<description-loc>
		Ваша сердечно-сосудистая система в худшем состоянии, чем это отражает ваш показатель HT. Этот недостаток может быть двух уровней:


Неспортивный: Вы получаете -1 ко всем проверкам HT, чтобы остаться в сознании, избежать смерти, сопротивляться болезни или яду, и т.п. Это не уменьшает HT как атрибут или умения на его основе! Также вы вдвое быстрее теряете очки усталости. -5 очков.
Очень неспортивный: Как и выше, но штраф к HT равен -2. Кроме того, вы восстанавливаете очки усталости вдвое медленнее. Вы не можете взять ни одного уровня Устойчивости (B80). -15 очков.


В обоих случаях этот недостаток касается только очков усталости, потерянных из-за утомления, высокой температуры, и т.п. Он не влияет на очки усталости, "потраченные" на пси-способности или магические заклинания.
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
	<name>Unfit (Very)</name>
	<name-loc>Неспортивный 
 (Сильно)</name-loc>
	<base_points>-15</base_points>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="contains">resistant</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B160</reference>
	<description-loc>
		Ваша сердечно-сосудистая система в худшем состоянии, чем это отражает ваш показатель HT. Этот недостаток может быть двух уровней:


Неспортивный: Вы получаете -1 ко всем проверкам HT, чтобы остаться в сознании, избежать смерти, сопротивляться болезни или яду, и т.п. Это не уменьшает HT как атрибут или умения на его основе! Также вы вдвое быстрее теряете очки усталости. -5 очков.
Очень неспортивный: Как и выше, но штраф к HT равен -2. Кроме того, вы восстанавливаете очки усталости вдвое медленнее. Вы не можете взять ни одного уровня Устойчивости (B80). -15 очков.


В обоих случаях этот недостаток касается только очков усталости, потерянных из-за утомления, высокой температуры, и т.п. Он не влияет на очки усталости, "потраченные" на пси-способности или магические заклинания.
		<br>
	</description-loc>
</advantage>
	<advantage version="2">
		<name>Unhealing (Partial)</name>
		<name-loc>Неисцеляемый (Частичная)</name-loc>
		<description-loc>Вы не можете излечиться естественным путем. Вам не позволена ежедневная проверка HT для восстановления потерянных хитов, и вы не сможете самостоятельно восстановиться после калечащих повреждений. Применив Первую помощь, можно остановить кровотечение, но ни эта помощь, ни Врачебное дело не смогут восстановить потерянные хиты. Технологии, ускоряющие естественное излечение (включая травы, препараты, и т.д.), бесполезны. Этот недостаток может быть двух уровней:


Частичная: В редких условиях вы способны на исцеление естественным путем (например, погружение в кровь или купание в лаве). Вы также можете вылечить себя, украв хиты у других с использованием Укуса вампира (B96), магии или псионики. -20 очков.
Полная: Вы не способны исцелиться естественным путем и не можете красть хиты у других. -30 очков.


В зависимости от вашей сущности, вы можете быть способны восстанавливать потерянные хиты и использовать поврежденные конечности неестественным путем - с помощью хирургии, ремонта (если вы машина), или других редкостных средств (заклинаний лечения, алхимии, псионики и т.п.).</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-20</base_points>
		<reference>B160</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Unhealing (Total)</name>
		<name-loc>Неисцеляемый 
 (Полная)</name-loc>
		<description-loc>Вы не можете излечиться естественным путем. Вам не позволена ежедневная проверка HT для восстановления потерянных хитов, и вы не сможете самостоятельно восстановиться после калечащих повреждений. Применив Первую помощь, можно остановить кровотечение, но ни эта помощь, ни Врачебное дело не смогут восстановить потерянные хиты. Технологии, ускоряющие естественное излечение (включая травы, препараты, и т.д.), бесполезны. Этот недостаток может быть двух уровней:


Частичная: В редких условиях вы способны на исцеление естественным путем (например, погружение в кровь или купание в лаве). Вы также можете вылечить себя, украв хиты у других с использованием Укуса вампира (B96), магии или псионики. -20 очков.
Полная: Вы не способны исцелиться естественным путем и не можете красть хиты у других. -30 очков.


В зависимости от вашей сущности, вы можете быть способны восстанавливать потерянные хиты и использовать поврежденные конечности неестественным путем - с помощью хирургии, ремонта (если вы машина), или других редкостных средств (заклинаний лечения, алхимии, псионики и т.п.).</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-30</base_points>
		<reference>B160</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Unique</name>
		<name-loc>Уникальный 
</name-loc>
		<description-loc>Вы существуете только в одной временной линии. Если возникнет временной парадокс, вы не будете помнить о нем. Если это слишком сложно, вы скорее всего исчезнете. В большинстве сеттингов, вы не будете осознавать грозящую вам опасность, пока она не произойдет... а потом вас никто не будет помнить! Потому эта черта обычно не подходит для персонажей.
В кампании о параллельных мирах быть Уникальным означает, что вас не существует в других мирах, как бы они ни были похожи на ваш. Это лишает вас шанса на дружескую поддержку от самого себя при их посещении. Есть, однако, и положительная сторона: в любом параллельном мире вы практически Безымянный (B100), причем бесплатно.
Эта черта является недостатком только в кампаниях, где возможны парадоксы или изменения в истории, стирающие прошлое или целые временные линии. Темпоральная инертность (B93) является полной противоположностью этой черты.</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>-5</base_points>
		<reference>B160</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Universal Digestion</name>
	<name-loc>Универсальное пищеварение</name-loc>
	<base_points>5</base_points>
	<modifier version="1" enabled="no">
		<name>Matter Eater</name>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>P86</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B95</reference>
	<description-loc>Персонаж обладает особенно универсальным процессом пищеварения, способным извлекать питательные вещества из любого нетоксичного растительного или животного материала, вне зависимости от фантастичности или необычности его биохимии. Это позволяет добывать пищу из вещей, которые обычно безвредны, но совершенно непитательны. Это не дает преимущества перед обычными ядами – ядовитые растения или животные все равно несьедобны (против этого приобретайте Устойчивость, с. B80). Один из полезных побочных эффектов – то, что вы можете избавиться от любых нетоксичных органических улик, просто съев их!

===Новое особое улучшение===
Поедание материи (Matter Eater): Вы можете есть все, что угодно – даже ядовитое, радиоактивное или кислотное. Ваше тело немедленно разлагает его до безвредных составляющих – вы даже можете съесть гранату, чтобы избежать ее взрыва. Тем не менее, защищена только ваша пищеварительная система.
Без защитных преимуществ вы можете получить вред от ядов или радиации, когда они находятся у вас во рту. Вы не можете есть антиматерию. +300%
</description-loc>
</advantage>
	<advantage version="2">
	<name>Unkillable</name>
	<name-loc>Бессмертие</name-loc>
	<points_per_level>50</points_per_level>
	<levels>1</levels>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ахиллесова пята (Achilles’ Heel)</name>
		<notes>@Редкое место@</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ахиллесова пята (Achilles’ Heel)</name>
		<notes>@Частое место@</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Ахиллесова пята (Achilles’ Heel)</name>
		<notes>@Банальное место@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Помеха (Hindrance)</name>
		<notes>@Редкая помеха@</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Помеха (Hindrance)</name>
		<notes>@Частая помеха@</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Помеха (Hindrance)</name>
		<notes>@Обычные помеха@</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Реинкарнация (Reincarnation)</name>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Триггер (Trigger)</name>
		<notes>@Редкий триггер@</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Триггер (Trigger)</name>
		<notes>@Частый триггер@</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Триггер (Trigger)</name>
		<notes>@Банальный триггер@</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B95</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B95</reference>
	<description-loc>Вас невозможно убить! Вы получаете все остальные эффекты от ран. Вы чувствуете боль, раны вас замедляют, вы можете потерять сознание. Вас можно покалечить или даже лишить конечности. Вы можете терять очки атрибутов, черты и навыки, страдать от яда и болезней и т.п. Однако, вы не умрете, пока ваше тело не уничтожено физически – и, возможно, даже тогда!

Существует три уровня преимущества.

Бессмертие 1. Раны действуют на вас нормально, но вы можете вообще не делать бросков НТ для выживания. Вы автоматически погибнете, когда ваше тело будет уничтожено (-10*НР). Но пока вы живы, ваше здоровье восстанавливается с обычной скоростью – обычно по 1 НР за день, модифицируется Регенерацией (с. B80), если она у вас есть. Сломанные конечности заживут как обычно, отрубленные – не вырастут без Отращивания (с. B80). 50 очков.

Бессмертие 2. Аналогично Бессмертию 1, но вы не погибаете, когда ваше тело почти уничтожено. При достижении -10*НР хитов, от вас остается неуязвимый скелет, вы теряете сознание и  больше не получаете никакого вреда от любых атак. После этого вы начинаете лечиться обычным путем – даже если вас разрубили на части – и придете в себя, когда НР вернутся в положительное значение. Конечно, ваши враги могут сохранить ваши останки в какой-нибудь тюрьме, или даже поместить их в источник вечного вреда (огонь – неплохой выбор), чтобы не дать вам лечиться. 100 очков.
Бессмертие 3. Аналогично Бессмертию 2, но при достижении -10*НР вы становитесь неуязвимым призраком, энергией или иной нематериальной субстанцией, которую нельзя повредить. Вы теряете сознание и лечитесь как обычно. При достижении полных хитов, ваше целехонькое тело появляется в выбранном мастером месте. 
С разрешения мастера, вы можете продать уровень 2 или 3, когда вы попали в -10*НР, и купить шаблон нежити или призрака, что позволит вам стать призраком или иной нежитью, когда вы восстановите все свои хиты.

По умолчанию, вы старитесь нормальным образом, и даже можете умереть от старости. Для достижения истинного бессмертия, возьмите еще и Нестареющий; а также – обычно – приобретаются Не требуется дышать (с. B49), Устойчивость к повреждениям (с. B60) и Устойчивость (с. B80). 150 очков.
===Особые ограничения.===

Ахиллесова пята (Achilles’ Heel):. Вред от определенной субстанции (обычно, от тех, к которым у вас есть Уязвимость, с. B161), может убить вас как обычно – вы делаете все положенные обычным людям броски на потерю сознания после достижения отрицательных НР, и смерть (после -5*НР). Ограничение зависит от редкости субстанции (Ограниченная защита, с. B46): Редкие -10%, частые -30%, обычные и повсеместные -50%.

Помеха (Hindrance): Определенная субстанция не дает вам лечиться (даже Регенерацией), пока остается в вашм теле. Цена зависит от редкости: -5% редкие, -15% частые, -25% обычные.

Реинкарнация (Reincarnation): Доступна только имеющим уровни 2-3. После достижения -10*НР, и восстановления полного здоровья вы возвращаетесь в совершенно новое тело с новыми способностями, но сохраняете свое Бессмертие. Новое тело создается мастером. -20%.
Триггер (Trigger): Доступно только имеющим уровни 2-3. Вам необходима определенная субстанция (кровь человека) или ритуал, чтобы начать лечиться после «временной смерти». До этого вы находитесь в «дремлющем» состоянии. Ограничение зависит от редкости триггера: редкий -25%, частый -15%, обычный и повсеместный -5%.</description-loc>
</advantage>
	<advantage version="2">
		<name>Unluckiness</name>
		<name-loc>Невезение</name-loc>
		<description-loc>Судьба играет с вами злые шутки. Все идет из рук вон плохо, причем в самое неподходящее время. Один раз за сессию мастер может намеренно вмешаться в игру и сделать вам что-то неприятное. Вы провалите жизненно важную проверку или враг (несмотря ни на что) покажется в самое неподходящее время. Если по сюжету кому-то уготован неприятный сюрприз, им станете вы. Мастер не может напрямую убить вас "невезением", но все менее неприятное подойдет. (Более смертоносный вариант этого недостатка - Проклятый, B129.)
Если хотите, можете указать, как на вас периодически будет влиять Невезение - например, постоянными поломками оружия, вашими регулярными опозданиями на 5 минут или стремлением всяческих предметов упасть вам на голову. Мастер должен стараться показать ваше Невезение именно таким образом, однако это - черта характера, а не жесткое игровое правило. Невезение всегда может проявиться по-другому, если мастер хочет подержать вас в напряжении!</description-loc>
		<type>Mental</type>
		<base_points>-10</base_points>
		<reference>B160</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Unnatural Features (@Description@)</name>
		<name-loc>Неестественные черты</name-loc>
		<points_per_level>-1</points_per_level>
		<levels>1</levels>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">-1</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount per_level="yes">-1</amount>
		</skill_bonus>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<type>Physical</type>
		<reference>B22</reference>
		<description-loc>В целом вы «обычный», но у вас есть одна или несколько странных внешних черт. Чтобы приносить вам очки, это должно быть нечто неестественное для вашей расы. Заостренные уши и горящие как угольки глаза будут необычны для человека, но не для демона из ада! Вы обязаны объяснить происхождение своих Неестественных черт: ею может быть порча, высокотехнологичная хирургия, редкое заболевание и т.д. 
Необычные черты не обязательно неприятны (но если так, то вы можете взять очки за внешность ниже средней), но они позволяют легко опознать вас и мешают вас смешаться с толпой. Каждый уровень, вплоть до максимального пятого, дает -1 к умения Изменение внешности и Слежка, а также +1 к чужим попыткам опознать или преследовать вас (включая их броски Наблюдения и Слежки), если только почти вся толпа не состоит из людей с такими же чертами.</description-loc>
	</advantage>
	<advantage version="2">
	<name>Unusual Background</name>
	<name-loc>Необычное происхождение</name-loc>
	<notes>@Описание@</notes>
	<base_points>@Стоимость в очках@</base_points>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B96</reference>
	<description-loc>Это "всеохватное" преимущество используется в случае необходимости увеличить стоимость определенных черт, не распространенных широко в вашем игровом мире. «Особыми способностями», требующими НП, может быть что угодно – киношные черты и навыки, волшебные заклинания, экзотические преимущества (для людей) – это зависит от сеттинга. Игроки могут предлагать свои варианты Необычного происхождения, но окончательную их стоимость и допустимость определяет Мастер.
Пример 1. Необычное происхождение «вырос среди волшебников», взятое чтобы объяснить доступ к волшебным заклинаниям может оказаться 0-очковой особенностью в магическом мире, где магия общедоступна; 10-очковым Необычным происхождением в мире, где магия существует, но держится в секрете; и 50-очковой чертой – или вообще оказаться запрещенной – в игре-триллере, если Мастер решит, что обладание магией разрушит весь сюжет.
Пример 2. «Дочь бога магии» - для объяснения наличия Бессмертия – будет Необычным происхождением в любом мире, и может иметь цену вплоть до равной вышеуказанному преимуществу – 50 очков и больше – если Мастер вообще ее позволит.
Не каждая концепция персонажа требует и допускает Необычное происхождение. Мастер должен требовать его только если игрок получает особенные выгоды, недоступные обычным персонажам. Например, быть выращенным волками – необычно для человека, но если это не дает персонажу никаких особых способностей (наподобие Разговора с животными) – то просто является частью предыстории, и не стоит очков.</description-loc>
</advantage>
	<advantage version="2">
		<name>Unusual Biochemistry</name>
		<name-loc>Необычная биохимия 
</name-loc>
		<description-loc>Вы можете питаться обычной пищей, но ваша биохимия настолько отличается от человеческой, что препараты, предназначенные для людей, на вас не действуют или дают непредсказуемый эффект. Разработанные специально для вас препараты действуют нормально, но стоят в 10 раз дороже обычных.
Когда вы принимаете препарат, предназначенный для людей, сделайте бросок 1d:


1-3 - обычный результат.
4-5 - обычный результат и дополнительный неблагоприятный эффект на выбор мастера: потеря 1d очков усталости (недомогание и тошнота), обычные для этого препарата побочные эффекты в более сильной форме и т.п.
6 - никакого результата.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B160</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Vacuum Support</name>
		<name-loc>Устойчивость к вакууму</name-loc>
		<description-loc>Вы иммунны к вредоносным эффектам вакуума и декомпрессии (с. B437). Преимущество не дает способности дышать без доступа воздуха (приобретайте Не требуется дышать, с. B49).
Обладатели Устойчивости к вакууму также обычно имеют преимущество Герметичность (с. B82), Устойчивость к радиации (с. B79) и Температурам (с. B93), но ни одна из этих черт не является обязательной.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>5</base_points>
		<reference>B96</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Vampiric Bite</name>
		<name-loc>Укус вампира</name-loc>
		<description-loc>Вы можете кусать людей и вытягивать из них жизненную силу, исцеляя себя. Вы можете питаться только если ваша жертва беспомощна, схвачена или желает этого. Если жертва носит броню, ваш укус должен ее пробить. Когда ваш укус достиг цели, вы можете начать вытягивать – по 1 НР в секунду. За каждые 3 вытянутых НР, вы можете восстановить себе 1 НР или FP (на ваш выбор), но не выше нормального значения.
Базовый Укус вампира, описанный выше, стоит 30 очков. Вы можете приобрести Увеличенное вытягивание НР за 5 очков за каждое дополнительное очко НР, вытягиваемое в секунду; так, чтобы высасывать 10 НР в секунду, вам нужно заплатить 75 очков.
Вы также можете кусать в бою без питания – считайте это преимущество за Острые зубы или Острый клюв (с. B91), и вам не надо покупать те преимущества отдельно.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>30</base_points>
		<points_per_level>5</points_per_level>
		<reference>B96</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Versatile</name>
		<name-loc>Хорошее воображение</name-loc>
		<description-loc>У вас необычайно хорошее воображение. Вы получаете +1 на любую задачу, требующую креативности, импровизации, изобретения, включая большинство бросков Артистизма, Инженерии (только для разработки) и бросков использования преимущества Изобретатель.</description-loc>
		<type>Mental</type>
		<base_points>5</base_points>
		<reference>B96</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Very Fat</name>
		<name-loc>Очень толстый</name-loc>
		<description-loc>Вы весите примерно вдвое больше нормы для данной ST. Вы получаете -3 к Изменению внешности и к Слежке, если пытаетесь преследовать кого-то в толпе. Однако дополнительный запас жира дает вам +5 к проверкам Плавания и +3 к ST при попытке противостоять толканию. Ваш HT не может превышать 13.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B19</reference>
		<notes>+3 ST против отбрасывания</notes>
		<categories>
			<category>Disadvantage</category>
		</categories>
		<skill_bonus>
			<name compare="is">disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">shadowing</name>
			<specialization compare="is anything"></specialization>
			<amount>-3</amount>
		</skill_bonus>
		<skill_bonus>
			<name compare="is">swimming</name>
			<specialization compare="is anything"></specialization>
			<amount>5</amount>
		</skill_bonus>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="ht" compare="at most">13</attribute_prereq>
		</prereq_list>
	</advantage>
	<advantage version="2">
	<name>Vibration Sense</name>
	<name-loc>Восприятие вибрации</name-loc>
	<base_points>10</base_points>
	<modifier version="1" enabled="no">
		<name>Универсальное (Universal)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B96</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Sense of Perception</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P86</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Targeting</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P86</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B96</reference>
	<description-loc>Вы можете определять местонахождение и размер преметов, воспринимая вибрацию кожей или усиками. Вы должны указать, работает эта способность под водой или на воздухе.
Восприятие вибрации не заменяет зрение. Вы можете почувствовать врага в темноте, но не сможете рассмотреть деталей (вооружение, например). В спокойной темной комнате вы получаете только смутный образ размеров области, но вы чувствуете течение воздуха или воды и способны почувствовать преграду.
Для восприятия вибраций кидается бросок чувств. Используются все штрафы по таблице размеров, скоростей и расстояний (с. B550). Наличие ветра или течений создает «шум», который мешает восприятию (скорость ветра или течения ищется в той же таблице, и к броску применяется соответствующий штраф). 
Успешный бросок определяет размер, местонахождение, скорость и направление движений, но не форму и цвет. Когда вы что-то заметили, вы можете попытаться атаковать его. Все модификаторы броска восприятия применяются, но никогда не дадут премий к атаке.

Если вы находитесь вне привычной среды, или одеты в герметичный костюм, эта способность не работает вообще.

===Особые улучшения.===
Универсальное (Universal): Ваша способность работает и в воздухе и в воде. +50%.

Новые особые улучшения
Восприятие окружения (Sense of Perception): ваша способность не зависит от вибрации воздуха или воды. Вы обнаруживаете ее «шестым чувством» (например, психокинетическим отражением).
Преимущество работает в любых средах, даже в скафандре и вакууме и не подвержено помехам. В этот модификатор включен модификатор Универсальное, приобретать его отдельно не надо. +100%.

Целеуказание (Targeting): применяя маневр прицеливания, вы можете «захватывать» уже обнаруженную цель, определив ее скорость и расстояние, и следить за ней с необычайной точностью – как высокоточный дальномер. Это дает вам +3 на попадание прицельной атакой с расстояния. +20%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Visualization</name>
		<name-loc>Визуализация</name-loc>
		<description-loc>Вы можете увеличить шансы выполнения задачи, представляя себя успешно ее выполнившим. Чем точнее и ярче ваше представление, тем выше будет премия. Визуализация должна быть детальной, яркой, и представлять одно определенное действие. Это делает ее бесполезной в бою и во всех случаях, когда ситуация меняется быстрее, чем вы ее можете представить.
Для использования этой способности вы должны концентрироваться в течение минуты. Игрок должен описать визуализируемую сцену, и результат, на который он надеется. Затем делается бросок IQ.
Вы получаете премию +1 за каждое очко успешности броска – если обстоятельства в точности такие же, как во время представления. В случае незначительных отличий – половина (минимум +1). Если что-то явно отличается, премия делится на 3 (минимум – 0). Мастер может назначить свой бонус или штраф за предъявленное вами описание.

===Новые особые улучшения===
Благословение (Blessing): Вы можете увеличивать шансы других разумных существ, просто «думая о них хорошо» в течение минуты. Вы должны видеть или касаться их в это время. Субъект
получает премию за визуализацию, когда делает бросок на это действие. Одновременно может быть благословленной только одна цель, но вы можете отменять свои благословения. +0%, если вы можете влиять только на других, +100%, если и на себя тоже.

Проклинание (Cursing): Вы можете проецировать негативные мысли, уменьшая шансы успеха других разумных существ. Вы должны концентрироваться в течение минуты, и должны видеть или касаться жертвы в это время. Жертва не знает, что вы ее проклинаете, если не имеет особенных способностей к этому. Когда она выполняет «проклятую» задачу, она получает штраф, равный обычному бонусу за визуализацию. Одновременно вы можете проклясть только одну цель, но можете отменить проклятие и наложить другое. Вы совершенно не можете влиять на себя, и не можете объединить Проклинание с Благословением – для этого надо покупать преимущество два раза. +100%.
</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>10</base_points>
		<modifier version="1" enabled="no">
			<name>Blessing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P87</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Blessing</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>P87</reference>
			<notes>Только не на себя</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Cursing</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>P87</reference>
		</modifier>
		<reference>B96</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Voice</name>
	<name-loc>Голос</name-loc>
	<base_points>10</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>2</amount>
	</attribute_bonus>
	<skill_bonus>
		<name compare="is">diplomacy</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">fast-talk</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="starts with">mimicry</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">performance</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">politics</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">public speaking</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">sex appeal</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<skill_bonus>
		<name compare="is">singing</name>
		<specialization compare="is anything"></specialization>
		<amount>2</amount>
	</skill_bonus>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Physical</type>
	<reference>B97</reference>
	<description-loc>У вас от природы чистый, красивый и привлекательный голос. Вы получаете постоянный бонус +2 на все следующие умения: Дипломатия, Заговаривание зубов, Политика, Хорошие Манеры, Публичное выступление, Сексапильность, Выступление, Подражание голосам и Пение. Вы также получаете +2 на реакцию всех, кто может слышать ваш голос.</description-loc>
</advantage>
	<advantage version="2">
		<name>Vow</name>
		<name-loc>Клятва</name-loc>
		<description-loc>Вы поклялись что-то исполнить или наоборот, чего-то не делать. Какой бы ни была клятва, вы относитесь к ней серьезно, иначе это не было бы недостатком. Эта черта особенно подходит рыцарям, священнослужителям и фанатикам.
Стоимость Клятвы зависит от причиняемых ею неудобств. Последнее слово за мастером. Вот несколько примеров:

Мелкая Клятва: например, никогда не пить алкоголя, вежливо относиться к дамам или отдавать 10% дохода на нужды церкви - является причудой. -1 очко
Небольшая клятва: Обет молчания днем; вегетарианство; целомудрие (да, в рамках игры это небольшая клятва). -5 очков.
Серьезная клятва: Не использовать режущего оружия; полный обет молчания; спать только на открытом воздухе; не иметь имущества больше, чем способна увезти лошадь.-10 очков.
Великая клятва: Никогда не отказывать в помощи; всегда сражаться неудобной рукой; преследовать врагов до самой смерти; бросать вызов на поединок каждому встречному рыцарю. -15 очков.


Обратите внимание, что если Клятва совпадает с каким-то недостатком, вы получите очки только за что-то одно (на ваш выбор). Нельзя получить очков одновременно за Клятву (Нищета), и за Богатство (Нищий), за Клятву (Не убивать), и Пацифизм (Не может убивать), и т.д.
Зачастую Клятва заканчивает свое действие спустя некоторое время - в таком случае вы обязаны выкупить ее. Клятвы сроком менее чем на год несерьезны! Если вы хотите закончить Клятву раньше ее срока, мастер вправе назначить наказание; например, в средневековом мире, вам, возможно, придется предпринять паломничество для покаяния.</description-loc>
		<type>Mental</type>
		<base_points>-1</base_points>
		<reference>B165</reference>
		<notes>@Клятва@</notes>
		<categories>
			<category>Quirk</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Vow (@Subject@)</name>
	<name-loc>Клятва (@Клятва@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Небольшая   (Minor)</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Серьезная клятва (Major)</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Великая клятва (Great)</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B161</reference>
	<description-loc>Вы поклялись что-то исполнить или наоборот, чего-то не делать. Какой бы ни была клятва, вы относитесь к ней серьезно, иначе это не было бы недостатком. Эта черта особенно подходит рыцарям, священнослужителям и фанатикам.
Стоимость Клятвы зависит от причиняемых ею неудобств. Последнее слово за мастером. Вот несколько примеров:

Мелкая Клятва: например, никогда не пить алкоголя, вежливо относиться к дамам или отдавать 10% дохода на нужды церкви - является причудой. -1 очко
Небольшая клятва: Обет молчания днем; вегетарианство; целомудрие (да, в рамках игры это небольшая клятва). -5 очков.
Серьезная клятва: Не использовать режущего оружия; полный обет молчания; спать только на открытом воздухе; не иметь имущества больше, чем способна увезти лошадь.-10 очков.
Великая клятва: Никогда не отказывать в помощи; всегда сражаться неудобной рукой; преследовать врагов до самой смерти; бросать вызов на поединок каждому встречному рыцарю. -15 очков.


Обратите внимание, что если Клятва совпадает с каким-то недостатком, вы получите очки только за что-то одно (на ваш выбор). Нельзя получить очков одновременно за Клятву (Нищета), и за Богатство (Нищий), за Клятву (Не убивать), и Пацифизм (Не может убивать), и т.д.
Зачастую Клятва заканчивает свое действие спустя некоторое время - в таком случае вы обязаны выкупить ее. Клятвы сроком менее чем на год несерьезны! Если вы хотите закончить Клятву раньше ее срока, мастер вправе назначить наказание; например, в средневековом мире, вам, возможно, придется предпринять паломничество для покаяния.</description-loc>
</advantage>
	<advantage version="2">
	<name>Vulnerability</name>
	<name-loc>Уязвимость</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Редкая атака@</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Частая атака@</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Распространенная атака@</name>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>@Очень распространенная атака@</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Раны x2</name>
		<cost type="multiplier">2</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Раны x3</name>
		<cost type="multiplier">3</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Раны x4</name>
		<cost type="multiplier">4</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только усталость (Fatigue Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B161</reference>
	<description-loc>Вы получаете дополнительные повреждения от атак определенного свойства. Каждый раз, когда данная атака попадает по вам, мастер применяет специальный множитель для повреждений, которые прошли сквозь броню. Обычные множители (для режущих, проникающих ударов и т.п.) применяются после него.


=====Пример: Оборотня с Уязвимостью (Серебро x4) полоснули серебряным ножом, нанеся единицу режущих повреждений. Мастер умножает ее на 4 за Уязвимость, что дает 4 единицы, а затем умножает на 1.5 за режущие повреждения. В результате нанесена рана в 6 хитов.=====


Стоимость зависит от множителя повреждений и редкости атаки:


![rowspan=2] Редкость атаки    |[colspan=3] Множитель повреждений
!	х2|	х3|	х4
|	Исключительная  |	-10|	-15|	-20
|	Редкая                    |	-20|	-30|	-40
|	Распространенная           |	-30|	-45|	-60
|	Очень распространенная|	-40|	-60|	-80
	

Для оценки редкости атаки используйте описание в разделе Ограниченная защита (B46). Последнее слово о редкости конкретного вида атак остается за мастером. Вы не можете взять более двух Уязвимостей без разрешения мастера.
Вы не можете иметь Уязвимость к тому, против чего у вас есть особая защита: Устойчивость, Устойчивость к повреждениям именно против такого рода атак, и т.д. Вы можете взять одновременно Уязвимость и Сверхъестественную живучесть (B89), но это уменьшит пользу от последней.


===Особые ограничения===
Только усталость: Вы уязвимы к атакам, которые вместо хитов отнимают очки усталости, или к некоторой форме обычных потерь усталости (например, x2 очков усталости при жаре). -50 %.</description-loc>
</advantage>
	<advantage version="2">
		<name>Walk On Air</name>
		<name-loc>Ходьба по воздуху</name-loc>
		<description-loc>Воздух, дым и другие газы под вашими ногами становятся плотными как земля, позволяя вам ходить как по невидимой лестнице с вашей обычной скоростью. Эта способность не работает в вакууме – там нет никакого газа. Если вы поскальзываетесь или теряете равновесие – вы упадете. Вы можете попытаться восстановить равновесие – каждую секунду бросая DX, при успехе падение останавливается. Иначе, вы упадете на землю и получите обычное повреждение (с. B431).

===Новые особые ограничения===

Приобретите Специфичность (с.112), если вы можете ходить только по определенному типу газов. Пыль, дым и водные испарения (облака, пар и т.д.) разрешены, “Обычный воздух” - нет. Для большинства субстанций это ограничение будет стоить около -40%, но особенно редкие газы – вроде чистого водорода – могут дать и -60%, на усмотрение Мастера.

Легче воздуха (Lighter Than Air): Ваша способность работает, делая вас легче воздуха. Ветер сдувает вас на ярд в секунду за каждые 5миль/час своей скорости. -10%.

Максимальная высота (Maximum Height): Вы не можете подняться высоко над землей. Ограничение в 30 футов стоит -10%, 10 футов -20%, а пять футов – -25%.

Планетарное (Planetary): Вы отталкиваетесь от гравитационного поля планеты или ходите по ее магнитно силовым линиям. Ваша способность совершенно бесполезна, если вы находитесь в космосе. -5%.

Только подъем (Vertical Only): Вы можете только подниматься вверх, как по невидимой лестнице. Перемещаться горизонтально вы не можете совсем. -25%.
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>20</base_points>
		<modifier version="1" enabled="no">
			<name>Specific</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>P87</reference>
			<notes>@Вещество@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Lighter than Air</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P87</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Maximum Height</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P87</reference>
			<notes>10 м</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Maximum Height</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P87</reference>
			<notes>3 м</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Maximum Height</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P87</reference>
			<notes>1.5 м</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Vertical Only</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>P87</reference>
		</modifier>
		<reference>B97</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Walk On Liquid</name>
		<name-loc>Ходьба по жидкостям</name-loc>
		<description-loc>Персонаж может ходить по поверхности любой жидкости как если бы она была землей. Это преимущество не защищает от вреда, наносимого этой поверхностью при контакте (например лава или бурлящая кислота). Движение нормальное. Мастер может решить, что это преимущество не работает, если существо несет нагрузку больше легкой.

===Новое особое улучшение===
Погружение (Submerged): Вы можете ходить даже когда находитесь под водой. Используются правила по Ходьбе по воздуху, но при падении считается, что вы будете плыть, а не идти. +20%
</description-loc>
		<type>Physical, Exotic</type>
		<base_points>15</base_points>
		<modifier version="1" enabled="no">
			<name>Specific</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>P88</reference>
			<notes>Вода</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Submerged</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>P88</reference>
		</modifier>
		<reference>B97</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Warp</name>
	<name-loc>Телепортация</name-loc>
	<base_points>100</base_points>
	<modifier version="1" enabled="no">
		<name>Вслепую (Blind)</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Надежность (Reliable)</name>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Обнаженный (Naked)</name>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До легкой нагрузки</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До среденй нагузки</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До тяжелой нагрузки</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Дополнительная нагрузка (Extra Carrying Capacity)</name>
		<notes>До сверх тяжелой нагрузки</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Телепортационный прыжок (Warp Jump)</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Гиперпрыжок (HyperJump)</name>
		<notes>Скорость света</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Гиперпрыжок (HyperJump)</name>
		<notes>Один световой год в день</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B98</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>10 метров</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>20 метров</notes>
		<cost type="percentage">-45</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>100 метров</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>500 метров</notes>
		<cost type="percentage">-35</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>2 мили</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>10 миль</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>100 миль</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>1000 миль</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>10000 миль</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="13">
		<name>Ограниченное расстояние (Range Limit)</name>
		<notes>100000 миль</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Blink</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>No Strain</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Tracking</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Tunnel</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Tunnel</name>
		<notes>After teleport</notes>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Anchored</name>
		<notes>Changable</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Anchored</name>
		<notes>Item</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Anchored</name>
		<notes>Fixed Site</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Blind Only</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Drift</name>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Can't Affect</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Projection</name>
		<notes>Can use abilities</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P58</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Special Portal</name>
		<notes>@Portal@</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>P89</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Mental Carrying Capacity</name>
		<notes>MBL: @MBL@ lb</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>Sup29</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Rapid Fire</name>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>Sup29</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Telekinetic Carrying Capacity</name>
		<notes>TBL: @TBL@ lb</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>Sup29</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Exoteleport</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>Sup30</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental, Super</type>
	<reference>B97</reference>
	<description-loc>Вы имеете способность к телепортации, путешествуя в различные места, без физического перехода. Вы должны видеть вашу точку назначения – своими глазами, телевидением, используя чувства других – или ясно представлять ее себе (возможно только если вы до этого там были).
Вы можете брать с собой вес до Базовой нагрузки, плюс любой Багаж (Payload). Чтобы брать больше, или переносить других людей, приобретайте соответствующее улучшение (см.ниже)
Активация способности требует броска IQ, модифицируемой Расстоянием и Временем подготовки.
Расстояние: используются штрафы по нижеследующей таблице. Если дистанция попадает между двумя значениями, используется высшее.
!Расстояние|	Штраф
|	10 ярдов|	0
|	20 ярдов|	-1
|	100 ярдов|	-2
|	500 ярдов|	-3
|	2 миль  |	-4
|	10 миль|	-5
|	100 миль|	-6
|	1,000 миль|	-7
За каждое дальнейшее 10-кратное увеличение расстояния применяется дополнительно по -1. 

Время на подготовку. Время, которое вы потратите на подготовку телепортации.
!Время подготовки|	Модификатор
|	Нет|	-10
|	1 секунда|	-5
|	2 секунды|	-4
|	4 секунды|	-3
|	8 секунд|	-2
|	15 секунд|	-1
|	30 секунд|	0
|	1 минута|	+1
|	2 минуты|	+2
|	4 минуты|	+3
|	8 минут |	+4
|	15 минут|	+5
|	30 минут|	+6
|	1 час|	+7
|	2 часа|	+8
|	4 часа|	+9
|	8 часов|	+10
Эта таблица ограничена: +10 – максимально возможный бонус!

Удаление: если вы видите место назначения не своими глазами, бросок модифицируется на -2 за каждую ступень удаления от целевого изображения. Например, наблюдение через ТВ или чьи-то глаза – штраф -2, но если вы видите чужими глазами телевизионную передачу, то получате -4. Также -2 за телепортацию в место, которое вы посещали, но не видите в данный момент.
Оплата усталостью. Премия +1 за каждое потраченное очко FP. Вы должны заявить трату до броска, и теряете FP в любом случае. Вы не обязаны тратить FP, но это хорошая идея, если вы путешествуете далеко или без долгой подготовки.
При успешном броске вы появляетесь в точке назначения. При провале вы никуда не перемещаетесь, и ваша сила ослабляется: в следующие 10 минут попытки перемещения будут идти с дополнительным штрафом -5. При критическом провале вы появляетесь в другом месте (в любом, куда мастер пожелает вас забросить). Это необязательно будет опасно, но принесет вам серьезные неудобства. Кроме того, ваша сила временно выходит из строя, и не будет работать в ближайшие 1d часов.
Вы можете использовать телепортацию для избежания атак в бою. Один раз в ход вы можете телепортироваться в любое место, которое вы можете видеть в радиусе 10 ярдов, мгновенно. Это считается за уклонение. Разумеется, за мгновенное использование бросок IQ получает штраф -10, так что трата FP может увеличить ваши шансы.

Вы можете улучшить контроль над телепортацией, практикуясь в ней, и затрачивая очки на покупку улучшений или выкуп ограничений. Вы не можете взять Уменьшенная стоимость или Уменьшенное время активации – вместо этого, покупайте Надежность (см. ниже).

===Особые улучшения.===

Вслепую (Blind): вы можете телепортироваться, имея только координаты (расстояние и направление), не видя и не бывая в пункте назначения. Это дает дополнительно -5 на бросок IQ. Вы должны заплатить 2 FP за каждые +1 премии, если используете такой способ перемещения. +50%.

Дополнительная нагрузка (Extra Carrying Capacity): вы можете перемещать больше веса, чем ваша базовая нагрузка, и даже, если у вас достаточно сил, можете перенести одну персону с собой. Легкая нагрузка стоит +10%, Средняя +20%, Тяжелая +30%, сверх-тяжелая +50%.

Надежность (Reliable): ваша сила стабильна и предсказуема. Каждый уровень этого улучшения дает +1 к броску IQ, позволяя телепортироваться с меньшей подготовкой или на дальние расстояния, не затрачивая много FP. 5% за каждые +1, до максимума +10.

Телепортационный прыжок (Warp Jump): Доступно только если вы имеете преимущество Прыгун. вы должны купить это улучшение для обоих этих преимуществ. Если вы способны к перемещению по мирам и времени, и желаете использовать Телепортацию с обеими способностями – покупайте улучшение дважды. При перемещении вы можете одновременно использовать Телепортацию, чтобы появиться в любом месте в целевом мире. Необходимы два броска – по одному на способность – и возможно, что один из них (или даже оба) провалятся. +10%.

===Особые ограничения.===

Гиперпрыжок (HyperJump): Вы не телепортируетесь мгновенно, а физически перемещаетесь через гиперпростраснтво. На дальних расстояниях вам может потребоваться оборудование для поддержки жизни. Кроме того, вы не можете активировать гипер-прыжок в атмосфере, и не можете перемещаться на расстояния меньше одной световой секунды (186,000 миль, -10 IQ). Это эффективно ограничивает вас космическими путешествиями. Выгода этого способа телепортации, если вы имеете навык Навигация (гиперпространство), вы можете замещать им бросок IQ. -50%, если ваша эффективная скорость ограничена скоростью света (каждые 186 тысяч миль занимают одну секунду), -25%, если вы можете перемещаться на один световой год (-17 IQ) в день.
Обнаженный (Naked): При телепортации вы вообще ничего не можете перемещать. Вы всегда прибываете обнаженным. -30%.

Псионическая телепортация (Psionic Teleportation): Ваша сила – часть пси-силы Телепортации (с. B257). -10%.
Ограничение дистанции (Range Limit): Вы не можете перемещаться больше определенной дистанции за прыжок. Выберите дистанцию и найдите ее штраф. Ограничение стоит -5% * (10+штраф); например, 10 ярдов (-0) стоит 50%, а 100 миль (-6) стоит -20%. Ограничение свыше 100,000 миль – не является значимым.

===Новые особые улучшения===
Мерцание (Blink): Во время стресса ваша способность работает, защищая вас. Раз в ход, вы можете уклониться от любой атаки броском ИН без штрафа -10 за отсутствие подготовки и телепортироваться на первое попавшееся свободное безопасное место. Направление выбирается случайно. Если в радиусе 10 ярдов нет такого места, способность не срабатывает и вы остаетесь на месте. Мерцание активируется страхом и выбросом адреналина, так что в основном работает в бою – хотя мастер может разрешить его активацию и в других опасных ситуациях. Несовместимо с Гиперпрыжком. +25%.

Нет перезарядки (No Strain): Ваша способность неуязвима к выгоранию и временной паузе. Провалы использования несут обычные последствия, но вы можете использовать новую попытку немедленно, и совершенно без штрафов. +25%.

Следование (Tracking): Вы можете следовать за другими телепортами. Используются обычные
модификаторы броска плюс по -1 за ярд расстояния между вами и местом отправки. Давность телепортации также влияет на бросок. Используются модификаторы за время подготовки с обратным знаком: если он отправился только что, вы получаете +10, а если телепортация была совершена восемь часов назад – штраф -10. За каждое дальнейшее удвоение времени – еще по -1. Если из одной точки отправлялись несколько раз, вы можете последовать только по последнему адресу. Успех означает, что вы появляетесь в точке выхода… даже если отслеживаемый телепорт пострадал от эффекта критической ошибки или Дрейфа. Провал на 1 означает, что вы последовали за телепортом, но получаете эффект Дрейфа. Более серьезные провалы имеют обычный эффект. +20%.

Портал (Tunnel): использование способности оставляет за вами врата примерно вашего размера, открытые около 3к секунд. Через эти врата может пройти кто угодно. +40%, если врата появляются после вашей телепортации, +100%, если до нее, и вы должны сами войти в портал, но можете вообще через него проходить.
Этот модификатор может быть разрешен Мастером также для
Проникания и Прыгуна.

===Новые особые ограничения===

Привязка (Anchored): вы можете телепортироваться только к определенному месту или предмету (маяку), и никуда больше. Несовместимо больше ни с какими модификаторами, кроме Дополнительной нагрузки, Обнаженности, Отсутствия перезарядки и Надежности. -50%, если вы можете телепортироваться к одному месту, но можете менять его, физически присутствуя на новом месте в течение минуты. -60%, если вы можете телепортироваться к определенному предмету, который вы можете перенести в другое место, но враги могут его украсть и поместить в опасное место, -80% за телепортацию только в одно определенное место.
Только вслепую (Blind Only): Для телепортации вы должны указывать координаты как при использовании модификатора Вслепую, даже если вы можете видеть место назначения. Так что телепортация идет всегда с -5, и каждые +1 стоят 2 ЕУ. Взять модификатор Вслепую нельзя. -50%,

Дрейф (Drift): Вы не можете перенестись напрямую к цели. Вместо этого вы появляетесь в пределах окружности радиусом 1% общей дистанции телепортации. Чем лучше ваш бросок, тем ближе вы оказываетесь к цели, но точное местоположение определяет Мастер. Например, при телепортации на 10 миль вы появляетесь в любом месте в радиусе 0,1 мили от цели. При критическом провале вы можете появиться высоко в воздухе или под землей. -15%.

Проекция (Projection): В путешествие отправляется только ваш разум, но не тело. Ваше тело остается без сознания в месте отправления, и уязвимо для всех опасностей. См. ограничение Проекция для Прыгуна (с.58). Несовместимо с Дополнительной нагрузкой, Обнаженным, и Порталом.
Необходимы врата (Special Portal): Для перехода в другой мир или время вам необходимы особенные условия – «врата». Стоимость ограничения зависит от редкости портала. «Любая отражающая поверхность» стоит -20%.
Рукотворные «звездные врата» в каждой значимой звездной системе -40%; а круг древних камней, действующий лишь несколько дней в году -80%.
</description-loc>
</advantage>
	<advantage version="2">
		<name>Weak Bite</name>
		<name-loc>Слабый укус</name-loc>
		<description-loc>Строение челюсти не позволяет вам вложить в укус всю силу. Вычислите повреждения от укуса как обычно, а затем вычтите пенальти -2 на каждый кубик повреждений. Этот недостаток часто встречается у больших травоядных (например, лошади), иногда у малых травоядных или всеядных и очень редко у плотоядных.</description-loc>
		<type>Physical, Exotic</type>
		<base_points>-2</base_points>
		<reference>B161</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Weakness</name>
	<name-loc>Слабость</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1d повреждений в минуту</name>
		<cost type="points">-20</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1d повреждений в 5 минут</name>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>1d повреждений в 30 минут</name>
		<cost type="points">-5</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>@Редкое вещество@</name>
		<cost type="multiplier">0.5</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>@Частое вещество@</name>
		<cost type="multiplier">1</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>@Распространеннео вещество@</name>
		<cost type="multiplier">2</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="2">
		<name>@Очень распространенное вещество@</name>
		<cost type="multiplier">3</cost>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Только усталось (Fatigue Only)</name>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Переменная (Variable)</name>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B161</reference>
	</modifier>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical, Exotic</type>
	<reference>B161</reference>
	<description-loc>Вы получаете повреждения в присутствии некоторых веществ или условий (это не должно быть пищей или чем-то, чего столь же легко избежать). Эти повреждения напрямую уменьшают ваши хиты, независимо от DR или преимуществ, связанных с защитой. Чем быстрее наносятся повреждения, тем дороже оценивается Слабость:


!Скорость повреждений|	Стоимость
|	1d в минуту|	-20
|	1d в 5 минут|	-10
|	1d в 30 минут|	-5
	

Умножьте базовую стоимость, чтобы учесть редкость наносящего повреждения вещества или условия:


Исключительный (например, редкий вид радиации или полезных ископаемых): x1/2.
Редкий (например, СВЧ-излучение, сильный природный холод, воздушная пыльца): x1.
Распространенный (например, дым, близость магии, лошади, громкий шум): x2.
Очень распространенный (например, солнечный свет, живые растения): x3.


=====Пример: анаэробный организм получает 1d повреждений в минуту от кислорода. Базовая стоимость Слабости при этом -20 очков. Так как кислород является "Очень распространенным", конечная стоимость равна -60 очков.=====


Вы не можете взять более двух Слабостей без разрешения мастера.


===Особые ограничения===
Только усталость: Ваша Слабость вместо хитов отнимают очки усталости. -50 %.
Переменная: Ваша Слабость чувствительна к мощности источника повреждений. Вы можете задать относительно часто встречающийся типы защиты, вдвое уменьшающей скорость получения повреждений (например, плотная одежда или солнцезащитный крем - для солнечного света). С другой стороны, мощные проявления (по решению мастера) удваивают скорость получения повреждений! -40 %.</description-loc>
</advantage>
	<advantage version="2">
	<name>Wealth</name>
	<name-loc>Богатство</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Нищий (Dead Broke)</name>
		<notes>Начальное богатство $0</notes>
		<cost type="points">-25</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>0</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Бедный (Poor)</name>
		<notes>Начальное богатство 1/5 стандартного</notes>
		<cost type="points">-15</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>0.2</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Небогатый (Struggling)</name>
		<notes>Начальное богатство 1/2 стандартного</notes>
		<cost type="points">-10</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>0.5</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Средний (Average)</name>
		<cost type="points">0</cost>
		<affects>total</affects>
		<reference>B25</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Обеспеченный (Comfortable)</name>
		<notes>Начальное богатство 2x стандартного</notes>
		<cost type="points">10</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>2</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Богатый (Wealthy)</name>
		<notes>Начальное богатство 5x стандартного</notes>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>5</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Очень богатый (Very Wealthy)</name>
		<notes>Начальное богатство 20x стандартного</notes>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>20</wealth_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Жутко богатый (Filthy Rich)</name>
		<notes>Начальное богатство 100x стандартного</notes>
		<cost type="points">50</cost>
		<affects>total</affects>
		<reference>B25</reference>
		<wealth_modifier>100</wealth_modifier>
	</modifier>
	<categories>
		<category>Advantage</category>
		<category>Disadvantage</category>
	</categories>
	<type>Social</type>
	<reference>B25</reference>
	<description-loc>
			Богатство - понятие относительное. Средний американец сегодня живет в большей роскоши, чем средневековый король, хотя у него и меньше золота в подвалах. Все зависит от игрового мира - см. Технический уровень и начальное богатство (B27). В большинстве миров разброс по начальному богатству и доходу относительно велик, а умения определяют вашу работу и доход; подробности см. в разделе Экономика (B514).
Личное богатство изменяется по "уровням богатства". "Средний" уровень не стоит очков и позволяет вам вести обычный по меркам игрового мира образ жизни. Оставшаяся часть данных правил применяется, если вы особенно бедны или богаты, имеете источник дохода, который не требует работы, или у вас есть долги.
Богатство выше среднего уровня - это преимущество; это значит, что вы начинаете игру с богатством, вдвое и более превышающим обычное для данного игрового мира. Богатство ниже среднего - недостаток; это значит, что вы начинаете игру лишь с частью обычного в данном игровом мире богатства. Точное значение каждого уровня богатство в каждой конкретной игре будет определяться книгой с описанием игрового мира.

			Богатство и статус
			В некоторых игровых мирах Статус (см. B28) прочно связан с Богатством. В подобном сеттинге, если ваш уровень богатства "Богатый" или выше, то вы получаете +1 к Статусу бесплатно. Этот бонус возрастает до +2 при 1 уровне преимущества Миллионер и до +3 при 2 его уровне. Никто не может получить более +3 к статусу за Богатство.</description-loc>
</advantage>
	<advantage version="2">
	<name>Wealth, Multimillionaire</name>
	<name-loc>Богатство 
</name-loc>
	<base_points>50</base_points>
	<points_per_level>25</points_per_level>
	<levels>1</levels>
	<wealth_modifier per_level="yes">10</wealth_modifier>
	<wealth_modifier>100</wealth_modifier>
	<prereq_list all="yes">
		<advantage_prereq has="no">
			<name compare="is">filthy rich</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Social</type>
	<reference>B25</reference>
	<description-loc>
М у л ь т и м и л л и о н е р
(Multimillionaire): слова «жутко богатый» не описывают и части вашего состояния! За каждые 25 очков, которые вы вкладываете в дополнение к 50 очкам преимущества «Жутко богатый», ваше состояние повышается еще в 10 раз: 
преимущество Мультимиллионер 1 уровня стоит 75 очков и дает вам состояние в 1.000 раз больше обычного,
Мультимиллионер 2 уровня стоит 100 очков и дает богатство в 10.000
раз больше обычного, и так далее.
50 очков +25 очков/уровень преимущества Мультимиллионер.</description-loc>
</advantage>
	<advantage version="2">
	<name>Weapon Master (@Specialty@)</name>
	<name-loc>Мастер оружия  (@Специализация@)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Одно оружие (One weapon)</name>
		<cost type="points">20</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Два оружия (Two weapons)</name>
		<cost type="points">25</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Небольшой класс (Small class)</name>
		<cost type="points">30</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Средний класс (Medium class)</name>
		<cost type="points">35</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Широкий класс (Large class)</name>
		<cost type="points">40</cost>
		<affects>total</affects>
		<reference>B99</reference>
	</modifier>
	<categories>
		<category>Advantage</category>
	</categories>
	<type>Mental</type>
	<reference>B99</reference>
	<description-loc>Вы хорошо натренированы в бою с оружием ближнего боя, метательным или дальнобойным оружием, зависящим от силы (но не огнестрельным!).
* Все оружие, зависящее от мышечной силы – 45 очков. 
* Широкий класс (все клинки, все одноручное оружие) – 40 очков
* Средний класс (все мечи, все оружие ниндзя) – 35 очков
* Небольшой класс (фехтовальное оружие, рыцарское оружие) – 30 очков
* Два оружия, обычно используемых вместе (меч и щит, рапира и дага) – 25 очков
* Одно оружие – 20 очков.
В любом случае, если выбранное оружие можно метать, то вы получаете все выгоды от преимущества и в случае метания тоже. 
При использовании оружия выбора, наносимый вред увеличивается на +1 за кубик, если вы знаете навык на уровне DX+1, и +2 за кубик, если DX+2 и выше; также вы получаете только половинный штраф за Быстрый удар (см. B369) и дополнительное парирование в ход (с. B376). При использовании навыков по умолчанию вы не получаете такой премии.
Вы имеете опыт обращения с любым оружием в выбранном классе. Это улучшает значения оружейных навыков по умолчанию: DX/Легкие виды оружия по умолчанию получают значение DX-1, DX/Средние – DX-2, а DX/Сложные – DX-3. Обратите внимание, что эти навыки не становятся легче, и не могут быть выкуплены с улучшенного значения по умолчанию для сохранения очков.
Наконец, вы можете изучать киношные (cinematic) навыки (Глава 4), имеющие это преимущество в качестве требования – например, Мощный удар или Бой вслепую.. 
Эта черта лучше подходит для киношных (cinematic) кампаний, Мастер может запретить ее в реалистичных играх.</description-loc>
</advantage>
	<advantage version="2">
		<name>Weapon Master (All weapons)</name>
		<name-loc>Мастер оружия  (Все виды оружия на мышечной силы)</name-loc>
		<description-loc>Вы хорошо натренированы в бою с оружием ближнего боя, метательным или дальнобойным оружием, зависящим от силы (но не огнестрельным!).
* Все оружие, зависящее от мышечной силы – 45 очков. 
* Широкий класс (все клинки, все одноручное оружие) – 40 очков
* Средний класс (все мечи, все оружие ниндзя) – 35 очков
* Небольшой класс (фехтовальное оружие, рыцарское оружие) – 30 очков
* Два оружия, обычно используемых вместе (меч и щит, рапира и дага) – 25 очков
* Одно оружие – 20 очков.
В любом случае, если выбранное оружие можно метать, то вы получаете все выгоды от преимущества и в случае метания тоже. 
При использовании оружия выбора, наносимый вред увеличивается на +1 за кубик, если вы знаете навык на уровне DX+1, и +2 за кубик, если DX+2 и выше; также вы получаете только половинный штраф за Быстрый удар (см. B369) и дополнительное парирование в ход (с. B376). При использовании навыков по умолчанию вы не получаете такой премии.
Вы имеете опыт обращения с любым оружием в выбранном классе. Это улучшает значения оружейных навыков по умолчанию: DX/Легкие виды оружия по умолчанию получают значение DX-1, DX/Средние – DX-2, а DX/Сложные – DX-3. Обратите внимание, что эти навыки не становятся легче, и не могут быть выкуплены с улучшенного значения по умолчанию для сохранения очков.
Наконец, вы можете изучать киношные (cinematic) навыки (Глава 4), имеющие это преимущество в качестве требования – например, Мощный удар или Бой вслепую.. 
Эта черта лучше подходит для киношных (cinematic) кампаний, Мастер может запретить ее в реалистичных играх.</description-loc>
		<type>Mental</type>
		<base_points>45</base_points>
		<reference>B99</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Weirdness Magnet</name>
		<name-loc>Притягивающий необычное</name-loc>
		<description-loc>С вами постоянно происходят странные и удивительные вещи. Вы единственный, с кем демон остановится поболтать. Магические предметы с необычными свойствами сами плывут вам в руки. Единственная в XXI веке говорящая собака на Земле пристает к вам со своими проблемами. Пространственные ворота, запечатанные столетиями, открываются, чтобы выплеснуть на вас поток освобожденной энергии... или чтобы существа с другой стороны могли пригласить вас на чай.
С вами не происходит ничего смертельного (по крайней мере, не сразу), а иногда происходящее бывает даже полезным. Но в большинстве случаев это очень, очень неудобно. Люди, понимающие, кто такой Притягивающий необычное (и сознающие, что это вы), реагируют на вас с -2. Исключения составляют парапсихологи, фанатики-культисты, полоумные сторонники теории заговора и искатели острых ощущений, которые следуют за вами по пятам!</description-loc>
		<type>Mental, Supernatural</type>
		<base_points>-15</base_points>
		<modifier version="1" enabled="no">
			<name>Origins Magnet</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>Sup32</reference>
		</modifier>
		<reference>B161</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
		<name>Wild Talent</name>
		<name-loc>Скрытый талант</name-loc>
		<description-loc>Вы не знаете как, но вы просто делаете и все. Раз в сессию за каждый уровень преимущества вы можете сделать бросок любого навыка, используя значение базового атрибута: IQ для навыков, основанных на IQ, и так далее. Вы не получаете в этом случае никакого штрафа за бросок по умолчанию, но получаете модификаторы ситуационные и за снаряжение. ТУ также не имеет значения – монах ТУ 3 может сделать бросок IQ, чтобы использовать программирование на ТУ 12!
Талант не применим к любым навыкам, не имеющим уровня по умолчанию или требующим специфических преимуществ. Например, вы не можете использовать магию, если у вас нет магических способностей.

Талант не влияет на навыки, которые у вас уже есть.
===Особые улучшения.===

Заучивание (Retention): Вы можете изучать навыки, которые используете! Вы должны потратить доступные очки персонажа, когда применяете бросок навыка. В случае успешного броска вы можете приобрести навык на 1-очковом уровне. Далее в течение месяца все броски этого навыка делаются с -2, и вы не можете увеличить его в это время. При критическом успехе первого броска вы можете выучить навык сразу, и не получаете последующего штрафа -2. При провале вы не можете выучить навык, при критическом провале вы вообще теряете одно непотраченное очко персонажа! Независимо от успеха, если вы не отвечаете требованиям навыка, вы получаете -4, пока их не приобретете, и не можете улучшать свой навык. Это расширение не позволяет вам изучать навыки ТУ более высокого, чем ваш. +25%.

===Особые ограничения.===

Только экстренные случаи (Emergencies Only): Ваш талант работает только в случаях угрозы жизни (например, бою насмерть). Вы запрашиваете результат («Прочь от меня!»), а не указываете навык («Использовать дзюдо» или «Сотворить заклинание Приказ»). Затем Мастер выбирает навык (или заклинание, если у вас есть способности к магии), который может привести к этому результату, и кидает соответствующий атрибут. Если мастер считает, что вы и так уже знаете и умеете достаточно, он подскажет вам, какой навык использовать – но это все равно засчитается за использование способности! -30%.
Фокус (Focused): Вы можете использовать только один тип навыков: ментальные (основанные на IQ, PER, WILL), физические (ST, DX, HT), магические и энергетические (заклинания и киношные боевые искусства). -20%.

===Новое особое улучшение(P90)===
Скрытые способности (Wild Ability): только для обладателей сил. Кроме доступа к неизвестным вам умениям, вы можете использовать и не присущие вам способности. Любая такая способность обязана входить в одну из ваших сил, и не может иметь никаких модификаторов, кроме тех, которыми должна обладать, чтобы принадлежать к данной силе (например, модификатора силы). Вы получаете только одно «использование» способности – что означает в точности то же, что и в описании Ограниченного использования (с.В112). Если способность идет кубиками или уровнями, вы создаете эффект, равный одному уровню способности или 30 очкам стоимости, что лучше.+50%.

===Новое особое ограничение (P90)===
Внешний (External): умения, которые вы получаете, предоставляются вам кем-то, находящимся далеко от вас. Укажите, какой способ связи он использует – радио, телепатию или что-то еще (идеи для этого см. Телекоммуникация, с.В91). Враги смогут заглушить сигнал, подговорить вашего помощника и т.д. -20%.
</description-loc>
		<type>Mental, Supernatural</type>
		<levels>1</levels>
		<points_per_level>20</points_per_level>
		<modifier version="1" enabled="no">
			<name>Заучивание (Retention)</name>
			<cost type="percentage">25</cost>
			<affects>total</affects>
			<reference>B99</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Только экстренные случаи (Emergencies Only)</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B100</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Фокус (Focused)</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B99</reference>
			<notes>@Тип: ментальные, физические, магические или энергетические @</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Wild Ability</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>P90</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>External</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>P90</reference>
		</modifier>
		<reference>B99</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Workaholic</name>
	<name-loc>Трудоголик</name-loc>
	<base_points>-5</base_points>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<amount>1</amount>
	</attribute_bonus>
	<attribute_bonus>
		<attribute>reaction</attribute>
		<limitation>Близкие</limitation>
		<amount>-2</amount>
	</attribute_bonus>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Physical</type>
	<reference>B162</reference>
	<description-loc>Вы склонны взваливать на себя больше, чем способны потянуть, вам трудно расслабится и забыть о работе. Вы всегда работаете минимум в полтора раза дольше обычного рабочего дня. Это часто заканчивается пропущенным сном (см. Пропущенный сон, B426). Большинство людей сначала относятся к вам с уважением (+1 к реакции), но потом вы обычно получаете штраф к реакции -1 или -2, особенно от друзей и близких, которые практически вас не видят.</description-loc>
</advantage>
	<advantage version="2">
		<name>Wounded</name>
		<name-loc>Рана</name-loc>
		<description-loc>На вашем теле есть открытая незаживающая рана (из-за неудачной операции, обратного удара при попытке магического лечения и т.п.). Вы не теряете хитов, но рана облегчает попадание в организм инфекций и токсинов, а также может осложнить лечение последующих ранений.
Противник, знающий о вашей ране, может попытаться намеренно попасть по ней с -7. Эта атака имеет множитель повреждений 1.5 (т.е. вы получите на 50% больше повреждений). Вещества инъекционного действия, попав на рану, действуют так, как будто были нанесены на оружие, оцарапавшее вашу кожу. Каждый день вы должны тщательно перебинтовывать рану (требуется проверка Первой помощи или Врачебного дела) или получите -3 ко всем проверкам HT при сопротивлении заражению в пораженной эпидемией местности.
По выбору мастера, вы можете получить рану во время игры в результате пыток, скальпирования и т.д. У некоторых ран есть дополнительные последствия - например, скальпирование будет стоить вам потери уровня внешности.</description-loc>
		<type>Physical</type>
		<base_points>-5</base_points>
		<reference>B162</reference>
		<categories>
			<category>Disadvantage</category>
		</categories>
	</advantage>
	<advantage version="2">
	<name>Xenophilia</name>
	<name-loc>Ксенофилия</name-loc>
	<base_points>-10</base_points>
	<cr adj="fright check bonus">12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B162</reference>
	<description-loc>Вас подсознательно очаровывают и привлекают незнакомцы или чужаки, независимо от того, насколько опасно или пугающе они выглядят. При каждой встрече с кем-то (или чем-то) подобным делайте проверку на самоконтроль. При неудаче вы считаете, что этот субъект заинтересован в общении с вами. Подобный человек часто покупает выпивку иностранным солдатам, налаживает отношения с симпатичными вампирами, и пожимает щупальца Существам, О Которых Не Следует Знать, в то время как его напарники готовятся к бою или убегают со всех ног...
В качестве частичной компенсации вы получаете премию к проверке на испуг при встрече со странными созданиями

!Самоконтроль  |	Бонус к реакции
|	6|+4
|	9|+3
|	12|+2
|	15|+1

NPC с этим недостатком будут реагировать на странных персонажей с таким же бонусом.</description-loc>
</advantage>
	<advantage version="2">
	<name>Xenophobia (Strange and Unknown Things)</name>
	<name-loc>Боязнь странных и неизвестных вещей (Ксенофобия)</name-loc>
	<base_points>-15</base_points>
	<cr>12</cr>
	<categories>
		<category>Disadvantage</category>
	</categories>
	<type>Mental</type>
	<reference>B150</reference>
	<description-loc>Вас пугают любые необычные обстоятельства, а особенно - странные люди. Делайте проверку на самоконтроль в присутствии людей другой расы или национальности; пенальти составит -3, если рядом не люди. При провале вы можете даже напасть на незнакомцев из страха. -15 очков. *

==Фобии==

Вы боитесь определенных предметов, существ, или обстоятельств. Многие страхи в основе своей разумны, но Фобия - это неразумный, преувеличенный, патологический страх. Стоимость зависит от распространенности объекта страха - боязнь темноты причиняет гораздо больше неудобств, чем боязнь водопроводчика-левши.
Столкнувшись с объектом своей фобии, сделайте проверку на самоконтроль. При провале бросьте 3d, добавьте степень неудачи и посмотрите результат в Таблице проверок на испуг (B360). Например, если нужно было выбросить 9, а получилось 13, бросьте 3d+4 и сверьтесь с таблицей. Результат влияет на вас немедленно!
При успехе вы временно преодолеваете фобию, но это не значит, что страх полностью исчезает - пока его причина остается, вы получаете пенальти к DX, IQ и умениям. Величина пенальти зависит от показателя самоконтроля.

!Самоконтроль |Пенальти к реакции      
|6  |-4
|9  |-3
|12  |-2
|15  |-1

Вы должны делать проверку каждые 10 минут, чтобы определить, не поддались ли вы страху. Даже угроза появления объекта боязни требует проверки на самоконтроль, хотя и с +4. Если враги запугивают вас объектом боязни, нужно сделать немодифицированную проверку (как описано выше). При провале вы можете сломаться (в зависимости от проверки на испуг), но не обязательно заговорите. Некоторые люди даже под пытками могут запаниковать и сломаться, но отказаться говорить.
Ситуация, связанная с фобией, по определению является стрессовой. Если у вас есть ментальные недостатки, зависящие от психического состояния, они, вероятно, проявят себя, если вы поддадитесь Фобии.</description-loc>
</advantage>
	<advantage version="2">
		<name>Zeroed</name>
		<name-loc>Безымянный</name-loc>
		<description-loc>Независимо от причины - несчастный случай при рождении, сбой в компьютере, стертая запись, или что-то еще - власти (и их компьютерные системы) не знают о вас ничего. Вас официально не существует. В магических мирах даже магия не может прояснить деталей о вашем прошлом или настоящей личности. На начало игры не существует никаких записей о вас -  ни на бумаге, ни в виде компьютерных файлов. Таким образом, вас по большей части не притесняет и ни к чему не принуждает правительство (или корпорации).
Чтобы поддерживать этот статус, вы должны иметь дело только с наличными или товарами. Любые кредиты или банковские счета должны быть либо "безымянными" (счет не записан на определенное имя, доступ к нему имеет любой, кто владеет паролем), либо зарегистрированными на Временное имя (с. B31).
Если вами интересуются власти, они сначала решат, что в компьютере произошел сбой, когда не смогут найти информацию о вас. Их беспокойство будет нарастать в течение следующих нескольких дней, так как не будет обнаружено никакой информации о вашей жизни. После этого они попытаются поймать вас. Если они не смогут вас найти, то, вероятно, пожмут плечами и отступятся.
Но если они вас поймают, то будут долго и серьезно допрашивать, возможно с применением сыворотки правды и/или пыток. В конце концов, не-гражданин не имеет гражданских прав! Если вы заранее не предприняли мер предосторожности, никто не может доказать, что вы задержаны, так как вас официально не существует!</description-loc>
		<type>Social</type>
		<base_points>10</base_points>
		<reference>B100</reference>
		<categories>
			<category>Advantage</category>
		</categories>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Accessibility</name>
	<name-loc>Доступность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@очень частая цель / ситуация@</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@частая цель / ситуация@</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@нередкая цель / ситуация@</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@редкая цель / ситуация@</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@очень редкая цель / ситуация@</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Доступность</name>
		<notes>@крайне редкая цель / ситуация@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B110</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B110</reference>
	<description-loc>Доступность – универсальное ограничение, которое может описать любое запрещение, не указанное нигде больше. Ограничения делятся на две широких категории: ограничивающие доступные для способности цели, и ограничивающие ситуации, в которых доступно использование.
Если способность может воздействовать только на определенные цели, ограничение определяет, насколько широка группа целей. «только на женщин», «Только на мужчин» или подобные категории, которые покрывают примерно половину населения – стоят -20%. «Только на механизмы» или «Только на электрические вещи» будет стоить -20% в технологическом сеттинге. «Только на морские создания» будет стоить -30%, если большая часть кампании не проходит под водой – в этом случае ограничение не даст скидки больше -10%. «Только на инопланетян» будет стоить от -30% до -40% в зависимости от мира. «Только на псиоников» - в большинстве миров будет стоить -50%. «Только не на рыжих» идентично «На всех, кроме рыжих», и будет стоить -10%.
Подобный метод применяется и к ограничению по ситуации. «Только днем» и «Только ночью» будет стоить -20%. «Только при прямом солнечном свете» -30%. «Только под водой» будет стоить -30% на Земле, но больше в пустынной планете, и меньше в подводном мире. «Только в полнолуние» или «Только в новолуние» стоит -40%. «Бесполезно во время стресса» даст скидку аж -60%, поскольку это делает способность бесполезной во время большинства ситуаций, встречающихся во время приключений. 
Ситуационная доступность может быть связана с любыми действиями персонажа. Чем более сложно, необычно или противно действие, тем выше скидка. Некоторые примеры:
Только во время невидимости, нематериальности: -10%.
Только во время игры на барабане: -20%.
Только во время полета, Только во время плавания, Только в трансе: -30%.
Только одной стороной разделенной личности: -40%.
Если способность не отключается полностью, а работает в половину силы, скидка уменьшается вдвое.
Мастер не должен разрешать бессмысленные ограничения. Например, покупка полезной способности с ограничением «Только на друзей» не даст скидки. Хотя ограничение этой же способности «Только на врагов» может быть интересным. Также, мастер может отвергнуть любое ограничение, которое уже включено в описании способности. Например, «Только во время полета» - неподходящее ограничение для Улучшенного движения (полет).</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Accurate</name>
	<name-loc>Точность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +1</name>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">1</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +2</name>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">2</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +3</name>
		<cost type="percentage">15</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">3</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +4</name>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">4</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +5</name>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">5</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +6</name>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">6</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +7</name>
		<cost type="percentage">35</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">7</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +8</name>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">8</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +9</name>
		<cost type="percentage">45</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">9</accuracy>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Точность +10</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<accuracy type="add">10</accuracy>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B102</reference>
	<description-loc>Ваши атаки необычайно точны. Вы получаете +1 к Acc за каждые +5% цены.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Affects Insubstantial</name>
		<name-loc>Воздействие на нематериальных</name-loc>
		<reference>B102</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Воздействие на нематериальных</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B102</reference>
		</modifier>
		<description-loc>Ваша способность может воздействовать на нематериальные цели, и на материальные.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Affects Substantial</name>
		<name-loc>Воздействие на материальный мир</name-loc>
		<reference>B102</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Воздействие на материальный мир</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B102</reference>
		</modifier>
		<description-loc>Ваша способность может воздействовать на материальный мир даже когда вы нематериальны. Также она воздействует на нематериальный мир. Это улучшение не применяется к магии и псионике – они уже могут влиять на материальный мир с -3.
Мастеру: Это улучшение очень мощное. Оно позволяет нематериальным созданиям влиять на материальный мир без страха ответного удара. Не стесняйтесь запрещать его, ограничить использование только НИП или убедитесь что достаточное количество врагов имеет улучшение Воздействие на нематериальное!</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Alternative Attack</name>
		<name-loc>Альтернативная атака</name-loc>
		<reference>B61</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Альтернативная атака</name>
			<cost type="percentage">-80</cost>
			<affects>total</affects>
			<reference>B61</reference>
		</modifier>			
		<description-loc>Если у вас есть несколько Природных атак, вы можете определить их как атаку одного вида, но использующую различные установки, боеприпасы и т.д. Определить стоимость этих «альтернативных атак» можно как обычно, но заплатить нужно полную цену самой дорогой из них. Докупать дополнительные можно с 1/5 цены (округлять вверх).
Это может сохранить множество очков, но есть и обратная сторона. Во-первых, для атаки предоставляется одна возможность, вы не можете использовать их совместно, даже если можете производить несколько атак. Это также не дает вам объединять их, используя модификатор Связь (B106). Также, любые критические провалы или осечки, приводящие в неработоспособность одну из атак, отменяют все из них. Наконец, если самая дорогая ваша атака нейтрализована каким-либо образом, то ни одна из более дешевых атак не будет работать.
Вы также можете применить данное правило к множественным атакам Воздействием (B35) или Удержанием (B40) или любым сочетаниям Природных атак, которые вы не можете использовать одновременно. С разрешения Мастера вы можете применить данное правило к многоцелевым Естественным орудиям (B88).</description-loc>
	</advantage>
	
	<advantage version="2" modifier="yes">
		<name>Always On</name>
		<name-loc>Всегда включено</name-loc>
		<reference>B110</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no">
			<name>Всегда включено</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B110</reference>
			<notes>Социальный или косметический эффект</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Всегда включено</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B110</reference>
			<notes>Физическое неудобство</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Всегда включено</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B110</reference>
			<notes>Опасный эффект</notes>
		</modifier>			
		<description-loc>Вы не можете отключить способность. Применимо только к способностям, которые обычно можно включать или выключать. Если эффект социальный или косметический, цена уменьшается на 10%, за физические неудобства -20%, за эффект, опасный для вас -40%. 
Всегда включено является «специальным ограничением» для большинства черт, к которым его можно применить. Мастер может назначить новую цену по мере необходимости для других способностей.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Area Effect</name>
	<name-loc>Воздействие на область</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 2 м.</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 4 м.</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 8 м.</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 16 м.</name>
		<cost type="percentage">200</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 32 м.</name>
		<cost type="percentage">250</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 64 м.</name>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 128 м.</name>
		<cost type="percentage">350</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Воздействие на область 256 м.</name>
		<cost type="percentage">400</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B102</reference>
	<description-loc>Ваша способность воздействует не на одну цель, а на целую область. Все находящиеся в области получают эффект. При провале используются правила разброса (с. B414) для вычисления эпицентра. Активные защиты не помогают от областной атаки, но жертвы могут попытаться укрыться или убежать. Подробнее смотрите раздел Площадь и Распределенные атаки  (с. B413).
!Радиус	|Модификатор
|2 метра	 |+50%
|4 метра	 |+100%
|8 метра	 |+150%
|16 метра	|+200%
На следующих уровнях сохранится удвоение радиуса. Если применяется к преимуществу, имеющему уже воздействие на площадь, каждый уровень удваивает базовый радиус.
Это улучшение – требование для Перемещения (с. B107), Продолжительного действия (с. B107), Избирательной области (с. B108), Бомбардировки (с. B111), и Излучения (с. B112).</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Armor Divisor</name>
	<name-loc>Делитель брони</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(0.1), цели с DR 0 считаются как DR 1</notes>
		<cost type="percentage">-70</cost>
		<affects>total</affects>
		<reference>B110</reference>
		<equipment_modifier>
			<damage type="damage dr">0.1</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(0.2), цели с DR 0 считаются как DR 1</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B110</reference>
		<equipment_modifier>
			<damage type="damage dr">0.2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(0.5), цели с DR 0 считаются как DR 1</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B110</reference>
		<equipment_modifier>
			<damage type="damage dr">0.5</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(2)</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<damage type="damage dr">2</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(3)</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<damage type="damage dr">3</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(5)</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<damage type="damage dr">5</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Делитель брони (Armor Divisor)</name>
		<notes>(10)</notes>
		<cost type="percentage">200</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<damage type="damage dr">10</damage>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
		<category>Limitation</category>
	</categories>
	<reference>B110</reference>
	<description-loc>Как улучшение:
		Ваша атака лучше пробивает броню, чем это показывают базовые повреждения. 
!Делитель брони	|Модификатор
|2	|+50%
|3	|+100%
|5	|+150%
|10	|+200%
Это улучшение могут иметь только Воздействия и Природные атаки. Делитель брони – «Модификатор пробивания», вы не можете комбинировать ее с другими модификаторами пробивания – такими, как Воздействие через кровь (с. B105), Воздействие при контакте (с. B103) и т. п.

Как ограничение:
Ваша атака слабее пробивает броню. Это ограничение могут иметь только Природные атаки и Воздействия. Вы не можете комбинировать этот модификатор брони с любыми другими модификаторами брони.
!Делитель 	|Множитель DR	|Модификатор
|0,5	|2	|-30%
|0,2	|5	|-50%
|0,1	|10	|-70%
Кроме того, на любом уровне этого ограничения, цели с DR 0 получают DR 1 против ваших атак.
Это ограничение могут иметь только Природные атаки и Воздействие. Ограничение является модификатором пробивания, и не может быть объединено с другими подобными модификаторами, как требуется носитель (с. B105) и действие при касании (с. B103).
</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Aura</name>
		<name-loc>Аура</name-loc>
		<reference>B102</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Аура</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>B102</reference>
		</modifier>
		<description-loc>Ваша атака имеет форму ауры, которая воздействует на все, чего касаетесь вы или что касается вас. Если оружие вас ударяет, вы воздействуете на оружие. Вы можете включать и выключать эффект ауры в свой ход (если не возьмете «Всегда Включено», с. B110). Вы должны взять кроме Ауры еще улучшение Ближний бой (с. B112) на уровне -30% (дальность ББ), и не можете взять дополнительно «невозможность парирования» - аура по определению парировать не может..
Классический пример Ауры – покров огня, окружающий огненных элементалей. Обратитесь к описанию Тело из Огня (с. B262), где описано ее действие. </description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Based on (@Attribute@)</name>
		<name-loc>Основан на (@атрибут@)</name-loc>
		<reference>B102</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Основан на (@атрибут@)</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B102</reference>
		</modifier>
		<description-loc>Это улучшение доступно только для способностей, позволяющих бросок сопротивления против любого из атрибутов (ST, DX, IQ, HT, Will, Per). Он позволяет кидать не тот атрибут, который кидался обычно, а другой – указанный при покупке способности. Преимуществом это считается, поскольку позволяет настраивать способность, делая ее более эффективной против целей с известными слабостями.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Blood Agent</name>
		<name-loc>Воздействие через кровь</name-loc>
		<reference>B110</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category><category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no">
			<name>Воздействие через кровь</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B110</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Воздействие через кровь</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B103</reference>
			<notes>При площадном воздействии это улушение, позволяет игнорировать DR</notes>
		</modifier>
		<description-loc>Ваша атака должна попасть в слизистую оболочку (глаза, нос, открытый рот) или открытую рану, чтобы вообще подействовать. DR всегда останавливает ее.
Ограничение подходит для Воздействий и Природных атак, наносящих токсическое или изнуряющее повреждение. Особенно подходит для ядовитых брызг. Объединенное с Аурой, представляет атаку, которая действует через физическое касание.
Исключение: Если атака имеет также Воздействие на область (с. B102) или Конус (с. B103), ограничение работает, как указано выше, а также срабатывает, когда попадет в дыхательные пути (как Воздействие при вдыхании). Это позволит игнорировать DR. Защищены только существа Герметичные (с. B82), не нуждающиеся в воздухе (с. B49), имеющие Фильтрацию воздуха (с. B55) и Глазные мембраны (с. B71) или Защищенное зрение (с. B78). Эта способность превращает ограничение в мощное улучшение (с ценой +100%), но только если объединено с Конусом или Воздействием на область.
Вы не можете объединять Воздействие через кровь с другими модификаторами пробивания, как Требуется носитель (с. B105).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Bombardment</name>
	<name-loc>Бомбардировка</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Бомбардировка</name>
		<notes>Уровень умения 14</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B111</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Бомбардировка</name>
		<notes>Уровень умения 12</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B111</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Бомбардировка</name>
		<notes>Уровень умения 10</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B111</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Бомбардировка</name>
		<notes>Уровень умения 8</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B111</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B111</reference>
	<description-loc>
Различная
Это ограничение может быть взято только в сочетании с Воздействием на область (с. B102) или Конусом (с. B103). Атака не попадает автоматически во всех в области. Вместо этого, каждая цель подвергается атаке с определенным эффективным навыком, зависящим от уровня ограничения.
!Эффективный навык	|Модификатор
|14	|-5%
|12	|-10%
|10	|-15%
|8	|-20%
Эффективный навык модифицируется только размером цели. Место попадания определяется случайно. Укрытия защищают нормально.
Ограничение подходит для атак, подобных ледяным бурям, которые воздействуют на многие, но не на все цели в области.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Cone</name>
	<name-loc>Конус</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 1м</name>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 2м</name>
		<cost type="percentage">70</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 3м</name>
		<cost type="percentage">80</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 4м</name>
		<cost type="percentage">90</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 5м</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 6м</name>
		<cost type="percentage">110</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 7м</name>
		<cost type="percentage">120</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 8м</name>
		<cost type="percentage">130</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 9м</name>
		<cost type="percentage">140</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Конус ширина 10м</name>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B102</reference>
	<description-loc>Ваша атака распыляется, воздействуя на всех в области, похожей на конус. Конус подчиняется особым правилам (Атаки по области и распылители, стр. В413). Определите максимальную ширину конуса в метрах, при максимальной дальности дальности атаки. Конус стоит +50% и плюс +10% за метр максимальной ширины.
Нельзя объединять Конус с Воздействием на область, Аурой, Струей, Ближней атакой, Быстрой атакой, Излучением. Доступно только для Природных атак или Воздействий.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Contact Agent</name>
		<name-loc>Воздействие при контакте</name-loc>
		<reference>B111</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category><category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no">
			<name>Воздействие при контакте</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B111</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Воздействие при контакте</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B103</reference>
			<notes>При площадном воздействии это улушение, позволяет игнорировать DR</notes>			
		</modifier>		
		<description-loc>Ваша атака должна достичь голой кожи или проницаемой одежды, чтобы подействовать. DR полностью блокирует ее. Подходит для Воздействий и Атак, наносящих изнуряющий или токсический вред. Если взято вместе с Аурой (с. B102), представляет заразную атаку, распространяемую при касании. 
Исключение: в сочетании с Воздействием на область (с. B102) или Конусом (с. B103), позволяет полностью игнорировать DR, превращаясь в мощное преимущество на +150%. Иммунны будут только герметично закрытые цели (с. B82).
Вы не можете объединять Воздействие при контакте с другими модификаторами пробивания, как Требуется носитель (с. B105).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Cosmic</name>
	<name-loc>Абсолют</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Абсолют - не атака / защита</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Абсолют - Защита или противодействие</name>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Абсолют - Атака с особым эффектом</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Абсолют - Неудержимая атака</name>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<modifier enabled="no" radiogroup="1">
		<name>Абсолют - Не требуется броска</name>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>P101</reference>
	</modifier>
	<modifier enabled="no" radiogroup="1">
		<name>Абсолют - Не позволяется защита</name>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>P101</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B103</reference>
	<description-loc>Ваша способность работает на более высоком уровне, чем существует в вашем мире. Это позволяет ей работать в любых условиях, и даже, возможно, игнорировать противодействие. Ценность улучшения зависит от типа преимущества:
Способность, не являющаяся атакой или защитой: Ваша способность не подвергается обычным запрещениям. Например, ваше Исцеление может исцелять неизлечимые никакими способами болезни, Нематериальность позволит проникать сквозь любые барьеры, мешающие другим эфирным существам. +50%.
Защита или противодействие: Ваша защитная черта позволяет противодействовать атакам, модифицированным Абсолютом, используя обычные правила. +50%.
Атака с особым эффектом: Ваша атака имеет особый эффект, которому может противодействовать только другая «Абсолютная» сила – например, зажечь огонь, который невозможно погасить никакими методами или токсичная Природная атака, вызывающая Циклические (ниже) повреждения, неизлечимые существующей медициной. Это не лишает цель защиты!  Бросок HT (или другого атрибута, который используется для сопротивления) по-прежнему позволяется для атак, которым можно сопротивляться. +100%.
Не требуется броска (no die roll required): Только для способностей, требующих броска кубиков для действия. Ваша способность работает всегда, если вы имеете хотя бы какие-то шансы на успех. Подсчитайте все нужные модификаторы. Если получившееся эффективное умение равно хотя бы трем или выше – автоматический успех, и кубики бросать не надо. Единственный шанс провала – когда эффективное умение опускается ниже 3. Вы можете брать это улучшение к любым атакам, но нельзя добавлять его к способностям, эффект которых зависит от значения успеха. Это исключает взятие такой версии Абсолюта к сопротивляемым способностям – Контролю разума или проклятьям. +100%.
Неудержимая атака: Ваша атака полностью игнорирует защиту цели. Цель может пытаться защищаться активной защитой, если это возможно. Вы не можете объединять это улучшение с любыми другими модификаторами пробивания. +300%.
Не позволяется защита (no active defense allowed): Только для атак, от которых обычно можно защищаться – уклонением, блокированием или парированием. Независимо от умения и скорости, жертва вашей атаки не получает шанса на активную защиту. Не влияет на пассивную защиту (СП) и броски сопротивления. +300%.

</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Costs Fatigue</name>
		<name-loc>Стоит усталости</name-loc>
		<reference>B111</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>1fp активация, 0 под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>2fp активация, 1fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>3fp активация, 1fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>4fp активация, 2fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>5fp активация, 2fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>6fp активация, 3fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-35</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>7fp активация, 3fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>8fp активация, 4fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-45</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>9fp активация, 4fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>10fp активация, 5fp под. в мин.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>1fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>2fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>3fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>4fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>5fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>6fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-70</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>7fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-80</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>8fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-90</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>9fp в сек.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стоит усталости</name>
			<cost type="percentage">-100</cost>
			<affects>total</affects>
			<reference>B111</reference>
			<notes>10fp в сек.</notes>
		</modifier>			
		<description-loc>Использование способности утомляет вас. Стоимость ограничения -5% за каждое очко fp.
Для способностей, имеющих мгновенное воздействие (Природная атака), вы должны оплатить полную цену каждый раз, когда используете способность.
Для способностей, предполагающих продолжительный эффект (полет) это цена за активацию и одну минуту использования. Каждая последующая минута поддержания стоит половину. Если способность предоставляет эффект, длящийся только одну секунду, вы должны оплачивать цену каждую секунду, и это удваивает ценность ограничения до -10% за очко Еус.</description-loc>
	</advantage>
<advantage version="2" modifier="yes" changed="true">
	<name>Costs Hit Points</name>
	<name-loc>Стоит здоровья</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>1hp активация, 0 под. в мин.</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>2hp активация, 1hp под. в мин.</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>3hp активация, 1hp под. в мин.</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B111</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>4hp активация, 2hp под. в мин.</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>5hp активация, 2hp под. в мин.</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>6hp активация, 3hp под. в мин.</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>7hp активация, 3hp под. в мин.</notes>
		<cost type="percentage">-70</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>8hp активация, 4hp под. в мин.</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>9hp активация, 4hp под. в мин.</notes>
		<cost type="percentage">-90</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>10hp активация, 5hp под. в мин.</notes>
		<cost type="percentage">-100</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>1hp в сек.</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>2hp в сек.</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>3hp в сек.</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>4hp в сек.</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>5hp в сек.</notes>
		<cost type="percentage">-100</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>6hp в сек.</notes>
		<cost type="percentage">-120</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>7hp в сек.</notes>
		<cost type="percentage">-140</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>8hp в сек.</notes>
		<cost type="percentage">-160</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>9hp в сек.</notes>
		<cost type="percentage">-180</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Стоит здоровья</name>
		<notes>10hp в сек.</notes>
		<cost type="percentage">-200</cost>
		<affects>total</affects>
		<reference>P110</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>P110</reference>
	<description-loc>Ограничение работает в точности как Вызывает усталость (с.B111), но истощает очки не усталости, а здоровья, так что стоит в два раза дороже. Если цена указана за секунду использования, то -20% за уровень. Также может быть использована для изменения встроенной в преимущество цены в ЕУ (если использование преимущества стоило усталости), с модификацией -5% за конвертируемое очко (или -10%, если стоимость вычитается каждую секунду).</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Cyclic</name>
	<name-loc>Цикличность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 sec</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>10 сек</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 мин</notes>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 час</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 днь</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 сек; Сопротивляема</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>10 сек; Сопротивляема</notes>
		<cost type="percentage">25</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 мин; Сопротивляема</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 час; Сопротивляема</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Цикличность</name>
		<notes>1 день; Сопротивляема</notes>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<levels>1</levels>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Заразна (Contagious)</name>
		<notes>Средне</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Заразна (Contagious)</name>
		<notes>Сильно</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B103</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B103</reference>
	<description-loc>Доступно только для атак, использующих огненный, разъедающий, изнуряющий или токсический вред. Это представляет атаку, которая продолжается в жертве: кислота, болезнь, напалм, яд и прочее. (Атаки, длительно воздействующие на окружающий мир, используют Продолжительное действие, с. B107).
Цикличная атака повреждает цель как обычно, но когда жертва уже поражена, через определенный промежуток времени она получает этот вред снова! Все модификаторы пробивания (Воздействие при контакте или Нужен носитель) также применяются; так, цикличная атака, с модификатором Нужен носитель продолжает игнорировать DR цели. Жертва не может восстанавливать hp или fp, потерянные от циклической атаки, пока эта атака не прекратит воздействие!
Вы должны указать подходящие, довольно легко до условия, которые замедлят или прекратят дальнейшее повреждение от атаки. Например, чтобы остановить вред от кислоты, ее надо смыть (огонь – потушить, усталость или яд – исцелить), что займет 1+ секунд и бросок IQ или DX. Базовая стоимость цикличности зависит от интервала между воздействием.
!Интервал	|Модификатор
|1 секунда	|+100%
|10 секунд	|+50%
|1 минута	|+40%
|1 час	|+20%
|1 день	|+10%
Огненные или разъедающие атаки не должны иметь интервала более 10 секунд. На усмотрение Мастера, жертва, получающая вред каждую секунду, должна сделать бросок страха. 
Базовая стоимость умножается на количество циклов после первого. Мастер должен рассмотреть ограничение большого количества циклов атак, наносящих менее 1d вреда.
Часто Цикличные атаки также сочетаются с Сопротивляемостью (с. B115), в этом случае бросок сопротивления позволен каждый цикл. Если так, то стоимость Цикличности уменьшается вдвое.
Некоторые циклические атаки заразны – жертва может заражать других (см. Болезни, с. B442). Заразность – увеличивает финальную стоимость улучшения, после применения всех остальных факторов: +20% за среднюю заразность, +50% за сильную.
Факторы кумулятивные. Например, заражение, которому можно сопротивляться, с 31 циклами, длящимися по 1 дню, будет стоить +10% * 20 *1/2 = +150%. При сильной заразности – +200%</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Double Blunt Trauma (dbt)</name>
		<name-loc>Повр.: Двойная тупая травма</name-loc>
		<reference>B104</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Двойная тупая травма</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Cut, Imp, Pi наносят дополнительно 1hp за 5hp повреждений остановленных мягкой броней. Burn и Cor наносят 1hp на 10 очков.</notes>			
		</modifier>
		<description-loc>Доступна для Природных атак, наносящих огненный, кислотный, режущий, проникающий или пробивающий вред. Огненные и разъедающие атаки наносят дополнительно 1 hp тупой травмы за 10 очков базового вреда, остановленного гибкой броней. Режущий, проникающий и пробивающий вред наносят такую же тупую травму, как и тупые атаки: 1 hp за 5 единиц вреда, остановленных мягкой броней.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Double Knockback (dbk)</name>
		<name-loc>Повр.: Двойное отбрасывание</name-loc>
		<reference>B104</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Двойное отбрасывание</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>cr и cur отбрасывают вдвое дальше</notes>
		</modifier>
		<description-loc>Это позволяет тупой или режущей атаке отбрасывать вдвое дальше, чем обычно (см. Отбрасывание, с. B378).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Explosion (exp)</name>
		<name-loc>Повр.: Взрыв</name-loc>
		<reference>B104</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Взрыв</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Повреждения / 3*расстояние</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Взрыв</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Повреждения / 2*расстояние</notes>
		</modifier>
				<modifier version="1" enabled="no" radiogroup="1">
			<name>Взрыв</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Повреждения / расстояние</notes>
		</modifier>
		<description-loc>Атака производит взрыв в точке столкновения (при промахе – см. Правила разброса, с. B414). Цель получает вред нормально, все вокруг – модифицированный вред, равный базовому вреду, разделенному на (3*дальность в метрах). Если атака имеет модификатор Бронебойная атака (с. B102), он не применяется к вреду, получаемому окружающими.
Вы можете взять до двух дополнительных уровней Взрыва, если хотите, чтобы вред не уменьшался на расстоянии. Второй уровень делит базовый вред на удвоенную дистанцию до эпицентра (+100%), третий – на обычную дистанцию и стоит +150%.
Взрыв обычно применяется для тупых и обжигающих атак, но Мастер может разрешить и другие комбинации.
Больше информации по взрывам вы можете найти в параграфе Взрывы (с. B414).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Damage: Fragmentation (frag) </name>
	<name-loc>Повр.: Осколки</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 5м, бросок 15</notes>
		<cost type="percentage">15</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [1d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 10м, бросок 15</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [2d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 15м, бросок 15</notes>
		<cost type="percentage">45</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [3d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 20м, бросок 15</notes>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [4d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 25м, бросок 15</notes>
		<cost type="percentage">75</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [5d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 30м, бросок 15</notes>
		<cost type="percentage">90</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [6d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 35м, бросок 15</notes>
		<cost type="percentage">105</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [7d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 40м, бросок 15</notes>
		<cost type="percentage">120</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [8d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 45м, бросок 15</notes>
		<cost type="percentage">135</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [9d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 50м, бросок 15</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [10d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 55м, бросок 15</notes>
		<cost type="percentage">165</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [11d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Осколки</name>
		<notes>Растояние 60м, бросок 15</notes>
		<cost type="percentage">180</cost>
		<affects>total</affects>
		<reference>B104</reference>
		<equipment_modifier>
			<damage type="concat"> [12d]</damage>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Горячие осколки</name>
		<notes>Наносят burn, 6 циклов по 10 сек., делитель брони (0.2)</notes>
		<cost type="percentage">0</cost>
		<affects>total</affects>
		<reference>B104</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B104</reference>
	<description-loc>Атака разбрасывает опасные осколки при столкновении. Определите количество кубиков вреда от осколков. Все в радиусе 5 метров за кубик вреда атакованы с навыком 15, модифицированным штрафами за дистанцию от точки взрыва. См. Вред от осколков (с. B414).
Осколки наносят режущий вред. Если ваша атака наносит огненный вред или модифицирована улучшением Зажигательный (см. ниже), осколки получают тот же эффект бесплатно. Если вы используете это улучшение для атаки с модификатором «Нужен носитель» (с. B105), пробивание означат, что осколки автоматически попали в цель, но ничего более. Улучшение часто идет в комплекте с Взрывом (см. выше), но это не обязательно.
Осколки стоят +15% за кубик вреда от осколков. Для гранат обычен вред [2d] или [3d]. Максимальный вред от осколков – [12d], или базовый вред от атаки – что меньше.
Горячие осколки: осколки наносят не режущий, а обжигающий вред с модификатором Цикличность (шесть 10-секундных циклов), и имеет Делитель брони (0.2). Цена та же.
	</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Hazard (haz) </name>
		<name-loc>Повр.: Вредные факторы</name-loc>
		<reference>B104</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Обезвоживание</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Утопление</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Обморожение</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Недосыпание</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Голодание</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Вредные факторы</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B104</reference>
			<notes>Удушение</notes>
		</modifier>		
		<description-loc>Природной атаке, наносящей изнуряющий вред, можно дать одно из следующих улучшений: Обезвоживание, +20%; Утопление, +0%; Обморожение, +20%; Недосыпание, +50%; Голодание, +40%; Удушение, +0%. 
Потеря FP от атаки во всех отношениях (включая восстановление) считается потерей FP от соответствующей опасности. 
Черты, защищающие цель от такой опасности, также защищают ее от вашей атаки. Например, некто с преимуществом "Не нуждается в пище и воде", будет неуязвим к атаке, модифицированной Голоданием.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Incendiary (inc)</name>
		<name-loc>Повр.: Зажигательная</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Зажигательная</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B105</reference>
		</modifier>
		<description-loc>Природная атака, не наносящая огненного вреда, может быть Зажигательной – это дает ей возможность поджечь легковоспламеняемые материалы.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: No Blunt Trauma (nbt)</name>
		<name-loc>Повр.: Нет тупой травмы</name-loc>
		<reference>B111</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Нет тупой травмы</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B111</reference>
		</modifier>
		<description-loc>Атака, наносящая кинетический вред, обычно наносит тупую травму (с. B379). С этим ограничением – нет.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: No Knockback (nkb)</name>
		<name-loc>Повр.: Нет отбрасывания</name-loc>
		<reference>B111</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Нет отбрасывания</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B111</reference>
		</modifier>
		<description-loc>Лишает атаку, наносящую тупой или режущий вред, отбрасывающего эффекта. (с. B378)</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: No Wounding (nw) </name>
		<name-loc>Повр.: Не наносит ран</name-loc>
		<reference>B111</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Не наносит ран</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B111</reference>
		</modifier>
		<description-loc>Атака наносит базовый вред, может отбросить и нанести тупую травму, но не причиняет потери fp или hp. Подобная атака отражает мощный порыв ветра или струю воды. Использование вместе с проникающей, режущей или пробивающей атакой, которая переносит связанный вред (другую атаку, имеющую ограничение Нужен носитель, с. B105), отразит ядовитые дротики и жала, которые проникают сквозь броню, но не наносят внушительных ран.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Radiation (rad) </name>
		<name-loc>Повр.: Радиация</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Радиация</name>
			<cost type="percentage">25</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Токсичная - заменяет повреждения на rad</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Радиация</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Обжигающая - повреждения и burn и rad</notes>
		</modifier>		
		<description-loc>Атака облучает субъекта. Вред кидается как обычно, но независимо от пробивания брони жертва получает 1 рад за каждое выкинутое очко базового вреда. (Эффекты радиации – с. B435). Для токсических атак эта доза идет вместо обычного вреда, а улучшение стоит +25% - это типичная радиоактивность. Обжигающие атаки наносят вред радиацией и обычный вред, цена улучшения +100% - это лучи частиц. Прочие типы вреда не могут иметь это улучшение.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Damage: Surge (sur) </name>
		<name-loc>Повр.: Импульс</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Импульс</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B105</reference>
		</modifier>
		<description-loc>Атака производит электрический импульс, который может вывести из строя электронику или любую вещь с недостатком Электрический (с. B134).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Delay</name>
		<name-loc>Задержка</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Задержка</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Фиксированая @время секунд@ секунд</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Задержка</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Настраиваемая от 1 до 10 секунд</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Задержка</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Настраиваемая любая</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Задержка</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Детонатор @тип детонатора@</notes>
		</modifier>			
		<description-loc>Задерживает наступление эффектов атаки на некоторое время после попадания. Это позволяет создавать эффект бомб замедленного взрыва и им подобных. Обязательно указать способ, которым можно нейтрализовать эффект до его наступления. Детали обрабатываются с мастером.
Фиксированная задержка (пр., 2 секунды) – 0%.
Варьируемая задержка: от 0 до 10 секунд - +10%; любое другое время - +20%. Вы должны указать время задержки до броска атаки.
Детонатор: Вместо времени задержки, эффект активируется простым действием: радиосигналом, касанием, давлением, металлическим предметом, попавшим в радиус 1 метра и пр. Укажите детонатор, когда покупаете свою атаку. +50%.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Dissipation</name>
		<name-loc>Рассеивание</name-loc>
		<reference>B112</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Рассеивание</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B112</reference>
		</modifier>
		<description-loc>Берется только в комбинации с Воздействием на область (с. B102) или Конусом (с. B103). Чем дальше жертва от центра области или конуса, тем менее эффективна атака. Подробнее смотрите областные и рассеянные атаки (стр. 413).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Drifting</name>
		<name-loc>Дрейф</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Дрейф</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B105</reference>
		</modifier>
		<description-loc>Это улучшение доступно для любых атак с Задержкой (выше) или Продолжительным действием (с. B107). Первый бросок атаки размещает эффект, который потом может перемещаться под действием силы ветра, течения, солнечного ветра и прочего. Так делаются ядовитые газы, шаровые молнии, плавучие мины и пр.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Emanation</name>
		<name-loc>Излучение</name-loc>
		<reference>B112</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Излучение</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B112</reference>
		</modifier>
		<description-loc>Берется только в комбинации с Воздействием на область (с. B102). Эффект не имеет дальности или точности, но излучается из вашего тела. Несовместимо с ограничением Ближний бой и любыми модификаторами дальних атак.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Emergencies Only</name>
		<name-loc>Только в критических ситуациях</name-loc>
		<reference>B112</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no">
			<name>Только в критических ситуациях</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B112</reference>
		</modifier>
		<modifier version="1" enabled="no">
			<name>В критических ситуациях слабеет</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B112</reference>
		</modifier>		
		<description-loc>Ваша способность включается только страхом или возбуждением, вы не можете использовать ее в обычных обстоятельствах. Мастер может решить, что несколько провалов подряд при использования вашей силы могут разозлить вас достаточно для того, чтобы она начала работать, но это остается на его усмотрение.
Полная сила только в экстренных случаях: Если ваша способность работает в обычных обстоятельствах с половинной силой, это стоит меньше. Мастер определяет «половину» эффекта. -20%.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Equipment: Breakable</name>
	<name-loc>Предм. Разрушаемость</name-loc>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушаемость</name>
		<notes>DR 2</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушаемость</name>
		<notes>DR 5</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушаемость</name>
		<notes>DR 15</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Разрушаемость</name>
		<notes>DR 25</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Разрушаемость</name>
		<notes>Механизм</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Разрушаемость</name>
		<notes>Ремонт сложен / невозможен</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Разрушаемость</name>
		<notes>размер SM -8</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Разрушаемость</name>
		<notes>размер SM -6</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Разрушаемость</name>
		<notes>размер SM -4</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Разрушаемость</name>
		<notes>размер SM -2</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="12">
		<name>Разрушаемость</name>
		<notes>размер SM 0+</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B117</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
		<category>Gadget limitation</category>
	</categories>
	<reference>B117</reference>
	<description-loc>Ограничение приспособлений!
		
		Ваши враги могут разрушить предмет, и вы потеряете все выгоды от него, пока он не будет отремонтирован. Цена ограничения складывается из прочности и размера.
		Прочность: чем легче сломать предмет, тем серьезнее ограничение. Зависит от веса и DR предмета:
!DR	|Модификатор
|2 или меньше	|-20%
|3-5	|-15%
|6-15	|-10%
|16-25	|-5%
|26 и больше	|0%
Если предмет является механизмом, он может сломаться (в отличии от простого артефакта, как кольцо или шляпа), добавьте еще -5%. Смотрите Повреждения объектам (с. B483) для определения hp и результата повреждений.
Возможность ремонта: Выберите навык, необходимый для ремонта. Если ремонт невозможен, или требует значительных усилий, занимает много времени или расходов, это стоит дополнительно -15%.
Размер: влияет на броски Зрения, чтобы заметить и распознать его вне боя, и бросок атаки, чтобы попасть по нему
!SM	|Модификатор
|-9 и меньше	|0%
|-7 или -8	|-5%
|-5 или -6	|-10%
|-3 или -4	|-15%
|-l или-2	|-20%
|0 и больше	|-25%
</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Equipment: Can Be Stolen</name>
		<name-loc>Предм. Может быть украден</name-loc>
		<reference>B117</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
			<category>Gadget limitation</category>			
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Легко украсть броском против DX</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Состязание по DX или ST</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Карманным воровством или ловкостью рук</notes>
		</modifier>	
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>С применением силы</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Легко украсть броском против DX, вор не сможет использовать</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Состязание по DX или ST, вор не сможет использовать</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>Карманным воровством или ловкостью рук, вор не сможет использовать</notes>
		</modifier>	
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Может быть украден</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>B117</reference>
			<notes>С применением силы, вор не сможет использовать</notes>
		</modifier>		
		<description-loc>Ограничение приспособлений!
		
Ваши враги могут отобрать предмет у вас, лишая вас выгод от него. Применимо только если предмет явно дает некоторые возможности и привлекателен для воров. Ценность ограничения зависит от легкости воровства:
Легко украсть броском против DX (шляпа, например). -40%.
Необходимо выиграть Быстрое состязание по DX (браслет) или ST (палочка): -30%.
Только карманным воровством или ловкостью рук (монетка в кармане): -20%.
С применением силы (доспех): -10%.
Ценность ограничения уменьшается вдвое, если вор не сможет воспользоваться предметом в той же мере, что и вы.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Equipment: Unique</name>
		<name-loc>Предм. Уникальный</name-loc>
		<reference>B117</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
			<category>Gadget limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Уникальное</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B117</reference>
		</modifier>
		<description-loc>Ограничение приспособлений!
		
		Это ограничение берется только в сочетании с Разрушаемым или Может быть украдено. Обычно вы можете заменить украденный или разрушенный предмет, пусть это и займет значительное количество времени и средств. Если предмет уникален, вы не сможете его заменить никогда!
Очки, потраченные на предмет, будут потрачены навсегда.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Extended Duration</name>
	<name-loc>Увеличенная продолжительность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>в 3 раза дольше</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>в 10 раз дольше</notes>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>в 30 раз дольше</notes>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>в 100 раз дольше</notes>
		<cost type="percentage">80</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>в 300 раз дольше</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная продолжительность</name>
		<notes>Постоянный эффект</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B105</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B105</reference>
	<description-loc>
Это улучшение увеличивает нормальную продолжительность действия вашей способности. Действие увеличивается в несколько раз или даже становится постоянным.
!Увеличение	|Модификатор
|3x 	|+20%
|10x 	|+40%
|30x	|+60%
|100x	|+80%
|300x 	|+100%
|l,000x	|+ 120%
|Постоянно*	|+ 150%
* Вы должны указать подходящей набор условий при которых эффект теряется (или возвращается, как при Воздействии или Контроле разума). Мастер решает, что такое «подходящий». Если такого события нет, улучшение стоит +300%. Чтобы предотвратить бесплатную раздачу преимуществ, мастер должен запретить этот уровень для Воздействий с модификатором Преимущество.
Атака, к которой добавляется Увеличенная продолжительность должна иметь хотя бы один из модификаторов: Аура, Продолжительное действие, Стена; также можно добавлять этот модификатор, если в описании атаки это специально указано. Также доступно для любого преимущества с улучшением Дистанционный (с .107). 
Если модифицированная черта имеет несколько видов воздействия с различной продолжительностью, требуется указать, какой именно эффект вы продлеваете. Например, в случае с облаком усыпляющего газа, вы можете использовать это улучшение для продления срока сна, им вызванного, или времени существования самого облака. Чтобы продлить длительность и того, и другого – необходимо приобретать улучшение дважды.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Extra Recoil</name>
	<name-loc>Усиленная отдача</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Усиленная отдача</name>
		<notes>2</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B112</reference>
		<equipment_modifier>
			<recoil type="add">1</recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Усиленная отдача</name>
		<notes>3</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B112</reference>
		<equipment_modifier>
			<recoil type="add">2</recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Усиленная отдача</name>
		<notes>4</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B112</reference>
		<equipment_modifier>
			<recoil type="add">3</recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Усиленная отдача</name>
		<notes>5</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B112</reference>
		<equipment_modifier>
			<recoil type="add">5</recoil>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B112</reference>
	<description-loc>По умолчанию, дальняя атака имеет Rcl 1, что почти не имеет значения (с. B271). Вы можете дать атаке с высокой скорострельностью (с. B108) более высокую отдачу: 
!Rcl	|Модификатор
|2	|-10%
|3	|-20%
|4	|-30%
|5 и больше	|-40%</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Follow-Up</name>
		<name-loc>Нужен носитель</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Нужен носитель</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Природное оружие</notes>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Нужен носитель</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Пассивное</notes>			
		</modifier>		
		<description-loc>Эффект вашей атаки достигает цели через «носитель». Это может быть яд на дротике, разрывной заряд на бронебойной пуле и пр. Носителем выбирается другая атака. Это может быть как оружие тела (когти или зубы) или Природная атака (обычно наносящая режущее, проникающее или пробивающее повреждение).
В описании переносимой атаки указывается только тип и количество вреда, все остальные детали зависят от носителя. Атака достигает своей цели, только если попадает носитель, и пробивает броню. DR не влияет на переносимую атаку, если броня уже пробита. 
Если носитель атаки – природное оружие (когти или зубы), то Переносимая атака – улучшение на +0%. Если носитель пассивен (вроде шипов), то это ограничение на -50%.
Если носитель – Природная атака, цена зависит от модификаторов носителя. Цена равна сумме всех модификаторов, примененных к переносящей атаке (Всегда включено, Аура, Конус, Дрейф, Излучение, Только в экстренных случаях, Дополнительная отдача, Управляемая, Самонаведение, Увеличенная дистанция, Струя, Ограниченное использование, Проклятие, Ближний бой, Требует подготовки, Быстрый огонь, Уменьшенная дистанция, Требует дополнительного времени, Требует перезарядки, Только непроизвольное использование, Неконтролируемая, Ненадежная и т.п.). Если не применяется ни один из модификаторов, цена равна +0%. Обратите внимание, что Переносимая атака не может сама иметь этих модификаторов – только атака-носитель. 
Нужен носитель – модификатор пробивания, и не может быть объединен с любыми другими модификаторами этой категории.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Guided or Homing</name>
		<name-loc>Управление или самонаведение</name-loc>
		<reference>B105</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Управление</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B105</reference>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Самонаведение</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Обычное зрение</notes>
		</modifier>	
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Самонаведение</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Инфразрение</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Самонаведение</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Ночное зрение</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Самонаведение</name>
			<cost type="percentage">70</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Сканирование</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Самонаведение</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B105</reference>
			<notes>Восприятие вибрации</notes>
		</modifier>		
		<description-loc>Вы можете управлять атакой – или, возможно, она сама наводится на цель. Этот модификатор используется для создания самонаводящихся ракет, или сверхъестественных атак вроде магических снарядов, самостоятельно выбирающих врагов.
Управляемая: вы контролируете полет снаряда, используя собственный навык и беря маневр Концентрация. Это позволяет вам игнорировать любые штрафы за расстояние. Если расстояние так велико, что снаряд не может достичь цели за один ход, вы должны концентрироваться несколько ходов. Если вы теряете цель из вида до того, как снаряд попадает в цель, вы автоматически промахиваетесь. +50%.
Самонаведение: ваш снаряд сам наводит себя на цель. Определите, как именно он находит цель (обычным зрением, Инфразрением (с. B60), Ночным зрением (с. B71) , Сканированием (с. B81), Обнаружением (с. B48), Восприятием Вибрации (с. B96) и т.д.). Атака использует этот тип восприятия в целях определения попадания (например, радар игнорирует темноту, но может быть заглушен помехами). Для захвата цели, вы должны прицелиться в нее (маневр Прицеливание) и сделать немодифицированный бросок навыка. Бросок на попадание – не ваш навык, а 10+Асс, игнорируются все штрафы за расстояние. Базовая цена - +50%, плюс цена соответствующего преимущества, используемого для наведения, выраженная в процентах. Например, Инфразрение стоит 10 очков, так что вы заплатите за ракету, наводящуюся по инфракрасному излучению, +60% (+50% базового, плюс +10% за инфразрение). Обычное зрение покупается за базовую цену.
Если атака имеет значение 1/2D, считайте это значение как скорость снаряда, выраженная в метрах в секунду. Снаряд попадает в цель в тот же ход, если она находится в этом радиусе, иначе – продолжает лететь в следующем. Повреждения из-за дальности не уменьшаются, но бросок на попадание откладывается до того момента, как снаряд попадет в цель.
Больше информации можно найти в параграфе «Управляемое и самонаводящееся оружие» (с. B412).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Inaccurate</name>
		<name-loc>Неточность</name-loc>
		<reference>B102</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неточность</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>B102</reference>
			<notes>-1</notes>
			<equipment_modifier>
				<accuracy type="add">-1</accuracy>
			</equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неточность</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B102</reference>
			<notes>-2</notes>
			<equipment_modifier>
				<accuracy type="add">-2</accuracy>
			</equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неточность</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B102</reference>
			<notes>-3</notes>
			<equipment_modifier>
				<accuracy type="add">-3</accuracy>
			</equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неточность</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B102</reference>
			<notes>-4</notes>
			<equipment_modifier>
				<accuracy type="add">-4</accuracy>
			</equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неточность</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B102</reference>
			<notes>-5</notes>
			<equipment_modifier>
				<accuracy type="add">-5</accuracy>
			</equipment_modifier>			
		</modifier>			
		<description-loc>Ваша атака получает меньше выгоды от прицеливания. Большинство атак имеет Точ 3, каждый уровень ограничения уменьшает Точ на -1. Вы не можете уменьшать Точ ниже 0.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Increased Range</name>
	<name-loc>Увеличенная дистанция</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x2</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">2</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x5</notes>
		<cost type="percentage">20</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">5</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x10</notes>
		<cost type="percentage">30</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">10</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x20</notes>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">20</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x50</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">50</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Увеличенная дистанция</name>
		<notes>x100</notes>
		<cost type="percentage">60</cost>
		<affects>total</affects>
		<reference>B106</reference>
		<equipment_modifier>
			<range type="multiply">100</range>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B106</reference>
	<description-loc>Используется для любого преимущества, имеющего дальность действия (Природная атака или Сканирование). Каждый уровень увеличивает дальность следующим образом: 
!Увеличение дистанции	|Модификатор
|2x	|+10%
|5x	|+20%
|10x	|+30%
|20x	|+40%
|50x	|+50%
|100x	|+60%
В дальнейшем используется та же прогрессия – «2-5-10».
Если используется для удаленной атаки, каждый уровень увеличивает и 1/2D, и Мах. Можно увеличивать только один из этих параметров за полцены, но нельзя увеличить 1/2D больше, чем значение Мах – максимум до равного значения, это значит, что атака не имеет 1/2D. Для атак, уже не имеющих 1/2D, вы можете увеличивать Мах за 5% за уровень. </description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Jet</name>
		<name-loc>Струя</name-loc>
		<reference>B106</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">0</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">5/10
			</range></equipment_modifier>			
			<notes>10м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">10/20
			</range></equipment_modifier>
			<notes>20м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">15/30
			</range></equipment_modifier>
			<notes>40м.</notes>
		</modifier>	
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">20/40
			</range></equipment_modifier>
			<notes>40м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">25/50
			</range></equipment_modifier>
			<notes>50м.</notes>
		</modifier>	
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">30/60
			</range></equipment_modifier>
			<notes>60м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">35/70
			</range></equipment_modifier>
			<notes>70м.</notes>
		</modifier>			
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">70</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">40/80
			</range></equipment_modifier>
			<notes>80м.</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">90</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">45/90
			</range></equipment_modifier>
			<notes>90м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Струя</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<range type="override">50/100
			</range></equipment_modifier>
			<notes>100м.</notes>
		</modifier>			
		<description-loc>Ваша атака имеет форму струи, подобно огнемету. Она скорее считается за оружие ближнего боя с особо большой досягаемостью, а не за дальнее оружие. Штрафы за дистанцию и скорость цели не применяются. 
Атака струей не имеет Acc; 1/2D = 5, Мах = 10. Улучшение Увеличенная дистанция увеличивает досягаемость на 100% за уровень.  
Струя несовместима с модификаторами Воздействие на область, Аура, Конус, Нужен носитель, Ближний бой, Быстрый огонь.
</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Limited Use</name>
	<name-loc>Ограниченное использование</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ограниченное использование</name>
		<notes>1 раз в день</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ограниченное использование</name>
		<notes>2 раз в день</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ограниченное использование</name>
		<notes>4 раз в день</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ограниченное использование</name>
		<notes>10 раз в день</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B102</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B102</reference>
	<description-loc>Вы можете использовать вашу способность только ограниченное количество раз в течение 24 часов. Для большей части преимуществ каждое «использование» - 1 минута действия. Для атак, каждое использование дает вам количество выстрелов, равное значение скорострельности, с минимумом 1 выстрел. Например, три использования атаки со скорострельностью 2 даст вам 6 выстрелов. Ценность зависит от количества использований.
!Количество использований в день	|Модификатор
|1	|-40%
|2	|-30%
|3-4	|-20%
|5-10	|-10%
Более 10 использований в день не является значительным ограничением.
Атаки, имеющие это ограничение, имеют две особых опции:
Быстрая перезарядка: вы можете восстановить потраченные использования простой загрузкой боеприпасов (3-5 секунд). Мастер определяет их вес и цену. Это уменьшает скидку в два раза.
Медленная перезарядка : Как и выше, но если у вас есть 2+ выстрела (не использований), вы должны перезаряжать каждый патрон отдельно (затрачивая 3+ секунд на каждый из них). Если у вас только один выстрел, перезарядка должна занимать не менее 6 секунд. Это делает ограничение на 5% менее ценным, чем обычно. Например, 3-4 использования в день будут стоить -15%, а не -20%, как обычно.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Link</name>
		<name-loc>Связь</name-loc>
		<reference>B106</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Связь</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<notes>Работают всегда вместе</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Связь</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<notes>Работают как вместе так и отдельно</notes>
		</modifier>		
		<description-loc>Вы можете использовать два или более преимуществ одновременно, как будто это одна способность. За +10% ваши способности объединены навсегда, и не работают отдельно. За +20% вы можете использовать их как одновременно, так и отдельно. Вы должны купить это улучшение для каждой связываемой способности.
Если вы связываете две атаки с идентичными характеристиками (Осечка, 1/2D, Max, Acc, RoF, Shots, Rcl.), вы можете считать их одной атакой, и использовать только один бросок на попадание, но отдельные броски на вред. Это не то же самое, что и Нужен носитель (с. B105)!</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Low or No Signature</name>
		<name-loc>Слабый или отсутствие признака</name-loc>
		<reference>B106</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Слабый признака</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B106</reference>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Отсутствие признака</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B106</reference>
		</modifier>		
		<description-loc>Обычно атака имеет внешний признак (вспышку света, звук и пр.). Если не указано особо, подразумевается, что это что-нибудь вроде выстрела или разряда – громкий звук и яркая вспышка. Это улучшение делает атаку менее заметной.
Слабый признак: атака не более заметна, чем громкий хлопок пробки от шампанского (например, заглушенный выстрел). +10%.
Нет признака: атака почти незаметна, например, как дротик из духовой трубки. Фактически, она почти не обнаруживается обычными методами (но может оставлять магические или пси-следы). +20%.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Malediction</name>
		<name-loc>Заклятие</name-loc>
		<reference>B106</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Заклятие</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<notes>Модифкатор дистанции -1 за метр.</notes>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<rate_of_fire type="override"></rate_of_fire>
				<recoil type="override"></recoil>
				<range type="override">
			</range></equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Заклятие</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<notes>Модифкаторы по таблице размеров, скоростей и расстояний (B550)</notes>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<rate_of_fire type="override"></rate_of_fire>
				<recoil type="override"></recoil>
				<range type="override">
			</range></equipment_modifier>			
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Заклятие</name>
			<cost type="percentage">200</cost>
			<affects>total</affects>
			<reference>B106</reference>
			<notes>Модифкаторы по таблице дальних дистанций (B241)</notes>
			<equipment_modifier>
				<accuracy type="override"></accuracy>
				<rate_of_fire type="override"></rate_of_fire>
				<recoil type="override"></recoil>
				<range type="override">
			</range></equipment_modifier>			
		</modifier>		
		<description-loc>Ваша атака – не стандартная дальнобойная атака, скорее, это заклинание Стандартного класса. У нее нет Malf, 1/2D, RoF, Shots, Rcl, и она не может приобретать любые улучшения и ограничения, которые воздействуют на эти параметры. Более важно то, что DR цели не влияет на вред от атаки, броски сопротивления и прочее. Использование проклятия требует маневра Концентрации, а не атаки. Вы можете атаковать любую цель, какую можете видеть или явно представлять. Успешность атаки определяется броском Воли(Will), с применением штрафа за дальность (см. ниже). Враг может попробовать сопротивляться – быстрое состязание по Воле, вы должны выиграть для того, чтобы цель попала под воздействие.
Если вы применяете улучшение на Воздействие, быстрое состязание замещает обычный бросок сопротивления, но враг бросает состязание по соответствующему атрибуту.
Ценность Проклятия зависит от штрафа за дальность. Если вы получаете штраф -1 за каждый метр дальности, как Стандартные заклинания, цена +100%. Штрафы по таблице размеров, скоростей и расстояний (с. B550) - +150%. Штрафы по таблице Дальних дистанций (с. B241) - +200%.
Проклятие – считается модификатором пробивания; вы не можете комбинировать его с другими модификаторами пробивания, а также с модификаторами для дальних атак.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Melee Attack</name>
	<name-loc>Ближний бой (Melee Attack)</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция С</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">C</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция 1</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">1</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция 2</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">2</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция C,1</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">C,1</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция 1,2</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">1,2</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция 2,3</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">2,3</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Дистанция 1-4</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<reach type="create">1-4</reach>
			<accuracy type="override"></accuracy>
			<range type="override"></range>
			<rate_of_fire type="override"></rate_of_fire>
			<recoil type="override"></recoil>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ближний бой</name>
		<notes>Не может паррировать</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B102</reference>
		<equipment_modifier>
			<parry type="create">No
			</parry>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B102</reference>
	<description-loc>Ваша атака функционирует как оружие ближнего боя. Она не имеет дальности, но позволяет парировать, использовать финты, быстрый удар и прочие маневры ближнего боя. Вместо всех параметров дальнего боя она получает атрибут Досягаемость:
!Досягаемость	|Модификатор
|С	|-30%
|1 или 2	|-25%
|С и 1, или 1 и 2, или 2 и 3	|-20%
|1-4 (как кнут) 	|-15%
Если вы не можете парировать этой атакой – это увеличивает ограничение еще на -5%.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Mitigator</name>
	<name-loc>Смягчение</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Смягчение</name>
		<notes>@лего уязвимый объект@</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Смягчение</name>
		<notes>@лекарство@ ежедневно</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Смягчение</name>
		<notes>@лекарство@ еженедельно</notes>
		<cost type="percentage">-65</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Смягчение</name>
		<notes>@лекарство@ ежемесячно</notes>
		<cost type="percentage">-65</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Смягчение</name>
		<notes>особый или дорогой</notes>
		<cost type="percentage">5</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Смягчение</name>
		<notes>только из особого источника</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B112</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Enhancement</category>
		<category>Limitation</category>
	</categories>
	<reference>B112</reference>
	<description-loc>Это ограничение применяется только для недостатков. Определенный предмет или субстанция временно нейтрализует ваш недостаток. Чем более эффективен Смягчитель, тем меньше очков вы получите за недостаток.
Смягчитель уязвим, легко может быть украден, сломан или потерян (очки): -60%.
Это лекарство или иная вещь, которая должна приниматься ежедневно: -60%
Смягчитель принимается каждую неделю: -65%
Смягчитель принимается каждый месяц: -70%.
Это подразумевает, что эти вещи доступны в виде лекарств. Если вам нужен особый или дорогой вид смягчения – скидка +5% (было -70%, станет 65%). Если вы можете получить его только из особого источника (экспериментальные лекарства), то +10%.
Пример 1: плохое зрение стоит -25 очков. Очки нейтрализуют плохое зрение, когда одеты, но они легко ломаются – это ограничение на -60%. Это уменьшает цену недостатка до -10 очков.
Пример 2. Джек болен DRИДом, и без лечения погибнет за месяц. Это – Смертельная болезнь ценой -100 очков. К счастью, Джек участвует в испытании экспериментального лекарства, которое поддерживает его в стадии ремиссии. Его требуется принимать раз в неделю (-65%), но невозможно найти больше нигде (+10%), в итоге Смягчитель -55%. Это уменьшает цену Смертельной болезни до -45 очков. Пока Джек участвует в программе, таймер его смерти остановлен.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Mobile</name>
		<name-loc>Перемещение</name-loc>
		<reference>B107</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 1м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 2м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">120</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 3м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">160</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 4м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">200</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 5м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">240</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 6м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">280</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 7м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">320</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 8м.</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">360</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 9м.</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Перемещение</name>
			<cost type="percentage">400</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Move = 10м.</notes>
		</modifier>
		<description-loc>Доступно только для атак с улучшениями Воздействие на область (с. B102) и Продолжительное воздействие (с. B107). Улучшение позволяет перемещать область воздействия по вашему желанию. Скорость перемещения равна уровню улучшения (1 за +40%, 2 за +80% и так далее), и не может превышать максимальную дальность атаки.
Для перемещения области вы должны концентрироваться. Чтобы сделать перемещение автономным, добавьте улучшение Самонаведение (это заставит атаку наводиться на ближайшую подходящую цель) и, возможно, Избирательная область (будет искать только врагов). Требуется купить улучшение дважды, если вы хотите применять ее и к начальному броску и к автономной области.
Взаимоисключающее улучшение с Дрейфом (с. B105).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Nuisance Effect</name>
	<name-loc>Неприятный эффект</name-loc>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Неприятный эффект</name>
		<notes>-1 к реакции</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B113</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-1</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Неприятный эффект</name>
		<notes>-2 к реакции</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B113</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-2</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Неприятный эффект</name>
		<notes>-3 к реакции</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B113</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-3</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no" checkgroup="11">
		<name>Неприятный эффект</name>
		<notes>-4 к реакции</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B113</reference>
		<attribute_bonus>
			<attribute>reaction</attribute>
			<amount>-4</amount>
		</attribute_bonus>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неприятный эффект</name>
		<notes>Делает вас заметными</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Неприятный эффект</name>
		<notes>Физические неудобства</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B113</reference>
	<description-loc>Ваша способность имеет побочный эффект, который причиняет вам серьезные неудобства. Мастер должен определить ценность ограничения в каждом случае, и обязан запретить эффекты, которые приносят пользу или не ограничивают ценность способности достаточно сильно. Несколько примеров:
Штраф к реакции окружающих. Возможно, вы странно выглядите или должны выполнять неприятный ритуал. -5% за каждые -1 штрафа (максимум -4).
Способность делает вас заметными, ограничивая возможность укрытия и привлекая врага. (-5%).
Ваша способность причиняет вам физические неудобства. Возможно, вы привлекаете насекомых, ваша броня ржавеет или вы становитесь голодным. (-5%).
Вы не можете взять ценную силу как Неприятный эффект. Например, «Убивает всех в радиусе мили» - точно не подходит. Вы не можете также взять эффект, который никак не мешает. Если преимущество Террор привлекает песок – это забавно, но не является ограничением.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
	<name>Onset</name>
	<name-loc>Инкубация</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инкубация</name>
		<notes>Задержка 1 минута</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инкубация</name>
		<notes>Задержка 1 час</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инкубация</name>
		<notes>Задержка 1 день</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инкубация</name>
		<notes>Задержка 1 неделя</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Инкубация</name>
		<notes>Жертва должна находиться под воздействием все время</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B113</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B113</reference>
	<description-loc>Это ограничение берется только в сочетании с одним из следующих модификаторов: Воздействие через кровь, Воздействие при контакте, Воздействие при вдыхании, Проклятие, Нужен носитель. Оно задерживает воздействие или вред на некоторое время после попадания. Цену ограничения определяет время задержки.
!Задержка	|Модификатор
|1 минута	|-10%
|1 час	|-20%
|1 день	|-30%
|1 неделя или больше	|-40%
Задержка, которая попадает между двумя порогами, использует цену низшего: 30 минут стоят -10%. Если вы можете контролировать время задержки, вы должны взять Задержку.
Вариант этого ограничения – время экспозиции, которая доступна только для атак с Аурой или Продолжительным воздействием. Это представляет радиоактивность, слаботоксичные газы и пр. Работает это практически также, но жертва должна находиться под воздействием в течение всего периода, чтобы получить эффект (или повторить его, если вы продолжаете воздействие). Это увеличивает цену на дополнительные -20%, например, 1 минута будет стоить -30%.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Overhead</name>
		<name-loc>Навесная траектория</name-loc>
		<reference>B107</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Навесная траектория</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>B107</reference>
		</modifier>
		<description-loc>Ваша атака может изменять угол удара и попадать с другой стороны – обычно сверху. Это позволяет ей обходить любое укрытие, которое не обеспечивает защиту с этой стороны, а также аннулирует штрафы за положение врага (лежа, пригнувшись, и пр.). Подобное улучшение есть у Огненного дождя, баллистической ракеты и гранат.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Pact</name>
		<name-loc>Договор</name-loc>
		<reference>B113</reference>
		<categories>
			<category>Modifier</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Договор</name>
			<cost type="percentage">@цена недостатка (отрицательная)@</cost>
			<affects>total</affects>
			<reference>B113</reference>
		</modifier>
		<description-loc>Высшая сила даровала вам способность, в обмен на ваше обещание следовать некоторым правилам (считаются за добровольные ментальные недостатки, с. B121). Эти недостатки дают обычные очки. Если вы отступаете от правил, способность отказывает, пока вы не раскаетесь. Ценность ограничения равна цене недостатка, выраженной в процентах: так, клятва на -10 очков даст ограничение ценой -10%.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Persistent</name>
		<name-loc>Устойчивый эффект</name-loc>
		<reference>B107</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Устойчивый эффект</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<notes>Эффект оставаться на 10сек.</notes>
		</modifier>
		<description-loc>Добавляется только для атак с воздействием на область (с. B102). Заставляет область эффекта оставаться в течение 10 секунд, продолжая повреждать цели (или атаковать и возможно повреждать, если это Бомбардировка, с. B111) всех, кто находится в области. Для увеличения продолжительности эффекта используйте Увеличенная продолжительность.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Preparation Required</name>
	<name-loc>Требуется подготовка</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>1 мин</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>10 мин</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>1 час</notes>
		<cost type="percentage">-50</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>8 часов</notes>
		<cost type="percentage">-60</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>1 мин, без подготовки слабее</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>10 мин, без подготовки слабее</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>1 час, без подготовки слабее</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Требуется подготовка</name>
		<notes>8 часов, без подготовки слабее</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B114</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B114</reference>
	<description-loc>Применение способности требует особой подготовки перед использованием. Возможно, требуется медитировать, или выполнить некий ритуал для концентрации. Обычно это ограничение лучше подходит для сверхъестественных способностей – Медиум (с. B41) или Спирит. 
Вы не можете использовать способность без подготовки. В течение требуемого времени вы должны выполнять маневр концентрации. Вы не обязаны указывать, как будете использовать способность, но если у вас есть несколько способностей с этим ограничением, вы должны указать – какую способность вы готовите.
Подготовленная способность может использоваться обычно – немедленно или позднее. Однако вы можете иметь подготовленным только одно преимущество с этим ограничением. Немедленно после использования способность становится неготовой, независимо от успешности использования. Если способность имеет продолжительный эффект, вы можете поддерживать ее после активации. 
!Время на подготовку	|Модификатор
|1 минута	|-20%
|10 минут	|-30%
|1 час	|-50%
|8 часов	|-60%
Ослаблено без подготовки: ваша способность может использоваться без предварительной подготовки, но все ее параметры уменьшаются вдвое. Скидка на такое ограничение – половинная.
</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Ranged</name>
		<name-loc>Дальний бой</name-loc>
		<reference>B107</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Дальний бой</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B107</reference>
			<ranged_weapon><range>10/100</range><accuracy>3</accuracy><rate_of_fire>1</rate_of_fire><recoil>1</recoil></ranged_weapon>
			<notes>Продолжительность 10 сек.</notes>
		</modifier>
		<description-loc>Улучшение добавляет дальность преимуществу, которое обычно влияет только на ваше близкое окружение или требует касания для воздействия на других. По умолчанию она получает 1/2D=10, Мах = 100, Точ = 3, RoF = 1, Rcl = 1. Продолжительность по умолчанию – 10 секунд, если в описании способности не указана другая продолжительность (Нейтрализация или Переселение) либо воздействие не мгновенно (Исцеление). Вы не можете использовать способность, пока не пройдет эффект от предыдущего применения. 
Обычно это улучшение доступно для Исцеления, Глушения и Излучения маны, Нейтрализации, Переселения и Пси-стазиса. Мастер может разрешить использование улучшения для других черт, но не должен позволять приобретать его для оружия тела (Естественного оружия или Укуса вампира) или способностей, уже имеющей дальнее действие. </description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Rapid Fire</name>
	<name-loc>Беглый огонь</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>2</notes>
		<cost type="percentage">40</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">2</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>3</notes>
		<cost type="percentage">50</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">3</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>7</notes>
		<cost type="percentage">70</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">7</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>15</notes>
		<cost type="percentage">100</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">15</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>30</notes>
		<cost type="percentage">150</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">30</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>70</notes>
		<cost type="percentage">200</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">70</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>150</notes>
		<cost type="percentage">250</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">150</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Беглый огонь</name>
		<notes>300</notes>
		<cost type="percentage">300</cost>
		<affects>total</affects>
		<reference>B108</reference>
		<equipment_modifier>
			<rate_of_fire type="override">300</rate_of_fire>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no">
		<name>Беглый огонь</name>
		<notes>Можно выберать меньшую скорострельность чем максимуму</notes>
		<cost type="percentage">10</cost>
		<affects>total</affects>
		<reference>B108</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Attack modifier</category>
		<category>Enhancement</category>
	</categories>
	<reference>B108</reference>
	<description-loc>Базовая скорострельность Природной атаки – 1. С помощью этого улучшения вы можете увеличить скорострельность:
!RoF	|Модификатор
|2	|+40%
|3	|+50%
|4-7	|+70%
|8-15	|+100%
|16-30	|+150%
|31-70	|+200%
|71-150	|+250%
|151-300	|+300%
Для атак с этим улучшением доступны две опции:
Несколько снарядов: Каждый выстрел разделяется на несколько. Это отражается множителем в RoF: например RoF 3х4 значит, что каждый из выпущенных трех снарядов разделяется еще на четыре «осколка». Цена модификатора – RoF*множитель (RoF 3x4 – стоит столько же, сколько и RoF 12).
Избирательный огонь: Вы можете выбрать более медленный огонь, если имеете RoF 5+, позволяя стрелять с RoF 1-3. это стоит дополнительных +10%</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Reduced Fatigue Cost</name>
		<name-loc>Уменьшенная усталость</name-loc>
		<reference>B108</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-1fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-2fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-3fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-4fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-5fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">120</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-6fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">140</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-7fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">160</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-8fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">180</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-9fp</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Уменьшенная усталость</name>
			<cost type="percentage">200</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>-10fp</notes>
		</modifier>
		<description-loc>Это улучшение применимо только для способностей, использование которых требует затрат fp. Каждый уровень улучшения уменьшает затраты на 1 (уменьшаются затраты как на активацию, так и на поддержку). Не доступно для способностей, имеющих модификатор «Обычно включено».</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Reduced Range</name>
	<name-loc>Уменьшенная дистанция</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уменьшенная дистанция</name>
		<notes>в 2 раза</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B115</reference>
		<equipment_modifier>
			<range type="multiply">0.5</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уменьшенная дистанция</name>
		<notes>в 5 раза</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B115</reference>
		<equipment_modifier>
			<range type="multiply">0.2</range>
		</equipment_modifier>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Уменьшенная дистанция</name>
		<notes>в 10 раза</notes>
		<cost type="percentage">-30</cost>
		<affects>total</affects>
		<reference>B115</reference>
		<equipment_modifier>
			<range type="multiply">0.1</range>
		</equipment_modifier>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B115</reference>
	<description-loc>Применимо только к способностям, имеющим дальность действия. Расстояние действия уменьшается в несколько раз. Существует три уровня ограничения:
!Уменьшение дистанции	|Модификатор
|2	|-10%
|5	|-20%
|10	|-30%
Если применяется к атакам, имеющим половинную дистанцию, каждый уровень уменьшает и 1/2D и Мах. Уменьшение только 1/2D стоит половину (т.е. «Уменьшение 1/2D» стоит -5%/уровень), независимое уменьшение значения Мах невозможно.</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Reduced Time</name>
		<name-loc>Быстрая активация</name-loc>
		<reference>B108</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Быстрая активация</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>время / 2</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Быстрая активация</name>
			<cost type="percentage">40</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>время / 4</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Быстрая активация</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>время / 8</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Быстрая активация</name>
			<cost type="percentage">80</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>время / 16</notes>
		</modifier>		
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Быстрая активация</name>
			<cost type="percentage">100</cost>
			<affects>total</affects>
			<reference>B108</reference>
			<notes>время / 32</notes>
		</modifier>		
		<description-loc>Доступно только для способностей, активация которых занимает некоторое время. Каждый уровень улучшения уменьшает требуемое время вдвое. Когда время активации станет менее 1 секунды – активация мгновенна, идет как свободное действие.
Не применяется к атакующим силам, чертам, уже имеющим персональные модификаторы, влияющие на время активации, и Магическим способностям.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Resistible</name>
		<name-loc>Сопротивление</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-5</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT-5</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT-4</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT-3</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT-2</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-25</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT-1</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-35</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+1</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+2</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-45</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+3</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-50</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+4</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-55</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+5</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Сопротивление</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>HT+6</notes>
		</modifier>
		<description-loc>Применимо только к Природным атакам, наносящим изнуряющее или токсическое повреждение. Требуется также взять Воздействие через кровь, Воздействие при контакте, Воздействие при вдыхании, Воздействие на чувства или Нужен носитель. Ограничение отражает яд, болезнь или подобный эффект, которому здоровая жертва может сопротивляться.
Для избегания эффекта требуется успешный бросок HT. Бросок против HT-5 стоит -5%, каждые +1, получаемые жертвой к броску, стоят дополнительно -5% (HT-4 – стоит -10%, HT+4 стоит -50%).
Если атака также имеет цикличность (с. B103), жертва кидает сопротивление перед каждым циклом, включая первый. Успешный бросок – прекращение получения вреда, провал – жертва получает вред и атака продолжается.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Respiratory Agent</name>
		<name-loc>Воздействие при вдыхании</name-loc>
		<reference>B108</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Воздействие при вдыхании</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B108</reference>
		</modifier>
		<description-loc>Чтобы воздействовать на цель, атака должна попасть в дыхательные пути, но тогда она полностью игнорирует DR. Защищает только Не нуждается в дыхании и Фильтрацией воздуха – хотя если жертва успела заметить атаку, она может попытаться задержать дыхание (с. B351). Используйте Уменьшенный внешний эффект (с. B106), чтобы сделать атаку менее заметной.
Вы можете добавить это улучшение только к Воздействию или Природной атаке, которая наносит токсическое или изнуряющее повреждение, и должны также взять Воздействие на область (с. B102), Конус (с. B103) или Струя (с. B106). Продолжительный эффект (с. B107)– рекомендуется, но не является необходимым. 
Воздействие при вдыхании – модификатор пробивания, и не может приобретаться в сочетании с другими подобными модификаторами, как например Требуется носитель (с. B105).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Selective Area</name>
		<name-loc>Избирательная область</name-loc>
		<reference>B108</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Избирательная область</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B108</reference>
		</modifier>
		<description-loc>Совместимо с Воздействием на область (с. B102) и Конусом (с. B103). Позволяет выбирать цели, на которых будет влиять.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Selectivity</name>
		<name-loc>Избирательность</name-loc>
		<reference>B108</reference>
		<categories>
			<category>Modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Избирательность</name>
			<cost type="percentage">10</cost>
			<affects>total</affects>
			<reference>B108</reference>
		</modifier>
		<description-loc>Это позволяет вам включать и выключать другие улучшения черты. Например, если у вас есть атака с Воздействием на область, вы можете выключить ее и атаковать только одно существо. Вы должны указать, какие улучшения вы выключаете до того, как активируете способность. По умолчанию предполагается, что вы всегда используете все ваши улучшения.
По сути, переключая способности, Избирательность позволяет вам иметь множество версий одной способности, не покупая ее несколько раз. Это особенно полезно, если вы создаете суперов из комиксов.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Sense-Based</name>
		<name-loc>Воздействие на чувства</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category><category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no">
			<name>Воздействие на чувства</name>
			<cost type="percentage">150</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>@чувство@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Воздействие на чувства</name>
			<cost type="percentage">50</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>@второе и последюущие чувства@</notes>
		</modifier>
		<modifier version="1" enabled="no">
			<name>Воздействие на чувства ограничивающее</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>@одно чувство@</notes>
		</modifier>	
		<modifier version="1" enabled="no">
			<name>Воздействие на чувства ограничивающее</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>@два чувство@</notes>
		</modifier>		
		<modifier version="1" enabled="no">
			<name>Воздействие на чувства ограничивающее</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>@три чувства@</notes>
		</modifier>				
		<description-loc>Ваша атака направляется через чувства жертвы, игнорируя DR. Вы должны указать, через которое чувство воздействует атака. Это может быть любое чувство – зрение, слух, обоняние и даже Обнаружение. Улучшение стоит +150%, +50% за каждое чувство после первого (например, атака, воздействующая через зрение и слух +200%).
Атака может воздействовать только на тех, кто использует эти чувства. Например, атаки, основанные на зрении, не действуют на слепых или закрывших глаза, атаки через обоняние – не работают под водой и на тех, кто позаботился о противогазе. Преимущества и снаряжение, защищающие чувства, полностью защищают от атаки, или (если атака позволяет бросок на сопротивление – типа Проклятия, Воздействия, Сопротивляемые атаки) дает премию к броску защиты.
Наиболее распространены такие атаки, которые нейтрализуют чувство, через которое они воздействуют. Например, Воздействие (Слепота, Воздействие через зрение) – слепящая вспышка. Однако, атаки, основанные на чувствах, могут быть и намного более смертоносными - как вой баньши или взгляд василиска.
Вы не можете объединять Воздействие через чувства с другими модификаторами пробивания
Исключение: Вы можете приобретать это улучшение вместе с модификатором пробивания Заклятие (с. B106). В комбинации с Заклятием или атакой, которая и так уже игнорирует DR, Воздействие через чувства превращается в ограничение. Она стоит -20%, если работает через одно чувство, -15%, если через два, и -10%, если через три. Если атака воздействует более чем через три чувства, то это не является значимым ограничением.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Side Effect</name>
		<name-loc>Побочный эффект</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Побочный эффект</name>
			<cost type="percentage">@цена 50+стоимость улучшения@</cost>
			<affects>total</affects>
			<reference>B109</reference>
		</modifier>
		<description-loc>Вы можете добавлять это улучшение только к Природным атакам, и не можете объединять его с любыми модификаторами пробивания, кроме Делителя брони. Если любое количество вреда пробило DR, жертва делает бросок HT, с -1 за каждые 2 очка прошедшего вреда, или получит побочный эффект.
Побочный эффект выбирается из отрицательных эффектов Воздействия (с. B35) – Оглушение, Штраф к атрибуту, Недостаток, Недееспособность. Стоимость Побочного эффекта равна +50%, плюс цена соответствующего улучшения Воздействия. Например, оглушение будет стоить +50%, а Недостаток (слепота) +100%.
Вы можете выбрать несколько побочных эффектов. Если жертва получает только один бросок сопротивления от всех сразу, считайте это одним побочным эффектом – все их цены складываются. Если жертва делает бросок для каждого эффекта отдельно, каждый из них покупается отдельным Побочным эффектом.
Оглушение проходит нормальным путем, другие эффекты длятся (20-HT) минут, минимум 1 минуту. Если Недееспособность объединена с другими эффектами, они длятся еще (20-HT) минут после прекращения действия Недееспособности.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Symptoms</name>
		<name-loc>Симптомы</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Симптомы</name>
			<cost type="percentage">@цена@</cost>
			<affects>total</affects>
			<reference>B109</reference>
		</modifier>
		<description-loc>Симптомы – это эффекты, которые возникают, когда общий вред (потеря fp или hp) от улучшенной Природной атаки превосходят определенную долю базового значения hp или fp жертвы. Жертва не получает права сопротивления симптомам. Мастер должен ограничить Симптомы атакам, которые наносят 1d или меньше вреда.
Симптомы выбираются из следующих эффектов, описанных как улучшение Воздействия (с. B35): Преимущество, Штраф к атрибутам, Недостаток, Раздражитель, Нейтрализация преимущества. Если порог возникновения симптомов равен потере 2/3 базового hp, цена равна описанной в описании Воздействия. Если порог равен 1/2 базового hp, цена удвоена, а если 1/3 – утроена.
Пример. Слепота в Воздействии стоит +50%, но как симптом, возникающий при потере половины хитов от Природной атаки, становится +100% улучшением.
В отличие от поражения Воздействием, симптомы проходят только когда повреждения, принесшие их, полностью вылечены. В примере выше, слепота пройдет только когда hp жертвы станут выше половины от максимального значения.
Природная атака может иметь несколько симптомов, отражая различные эффекты, возникающие при потере различного количества единиц урона.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Takes Extra Time</name>
		<name-loc>Требует дополнительного времени</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Требует дополнительного времени</name>
			<levels>1</levels>			
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>каждый уровень удваивает требуемое время</notes>
		</modifier>
		<description-loc>Применяется только к способностям, которые требуют времени на активацию и работают достаточно быстро, чтобы быть полезными в экстренных случаях (например, в бою). Мастер может запретить это ограничение для преимуществ, активация которых занимает 1-2 секунды.
Для способностей, требующих маневра Подготовка или Концентрация, каждый уровень ограничения удваивает требуемое время. 
Для атак первый уровень приводит к необходимости односекундного маневра Подготовки до атаки, последующие – удваивают это время.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Takes Recharge</name>
		<name-loc>Требует перезарядки</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Требует перезарядки</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>5 сек или время действия x2</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Требует перезарядки</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>15 сек или время действия x5</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Требует перезарядки</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>1 час или время действия x10</notes>
		</modifier>			
		<description-loc>Ваша способность требует перезарядки после каждого использования, и в это время недоступна. Ценность зависит от времени перезарядки: 5 секунд (или удвоенное время действия) -10%; 15 секунд (или время действия, увеличенное в пять раз): -20%; один час (или время действия способности, умноженное в 10 раз): -30%.
Дальнейшее увеличение времени перезарядки бессмысленно – см. Ограниченное использование (с. 112).</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Temporary Disadvantage</name>
		<name-loc>Временный недостаток</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Временный недостаток</name>
			<cost type="percentage">@отрицательное значание@</cost>
			<affects>total</affects>
			<reference>B115</reference>
		</modifier>
		<description-loc>Вы можете применять это ограничение к любому преимуществу, которое вы можете выключать и включать по желанию, и переключение занимает не менее 1 секунды.
Когда вы включаете преимущество, вы получаете один или несколько недостатков, пока преимущество работает. Ограничение стоит -1% за каждое очко временных недостатков, до максимума -80%.
Например: вы можете использовать ноги как руки, но не можете в это время ходить. Это будет работать как Дополнительные руки +2 (20 очков) с Временным недостатком Безногий (-30%), итоговая стоимость – 14 очков.
Снижение стоимости от Временного недостатка не может превышать 80% стоимости этого недостатка.
=====Пример: у вас есть Ускоренного течение времени х1 (100 очков) с временным недостатком: гемофилия (-30%) – кровь вы теряете тоже быстрее. Поскольку Гемофилия стоит -30 очков, максимальная скидка будет -24 очка, так что это уменьшит стоимость Ускоренного течения времени на 24 очка (до 76), а не на 30.=====
Вы можете взять только такой временный недостаток, который логически подходит под неудобства, причиняемые действием преимущества. В случае ментальных недостатков (Неистовство, Развратность), при провале броска самоконтроля вы получаете этот недостаток, и страдаете от него, пока не восстановите свое спокойствие – и это может случиться гораздо позже прекращения действия преимущества. 
Вы также можете использовать это ограничение для нейтрализации существующего преимущества. В таком случае ограничение стоит -1% за каждое очко снимаемого преимущества, и скидка не будет превышать 80% от цены деактивируемого преимущества. Только одно из включенных преимуществ может взять это ограничение – вы не можете взять два преимущества с этим ограничением, каждое из которых выключает другое во время использования.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Trigger</name>
		<name-loc>Триггер</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Повсеместная субстанция@</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Распространеная субстанция@</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Ограниченная субстанция@</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Редкая субстанция@</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-15</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Повсеместная субстанция@, нелегальна</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Распространеная субстанция@, нелегальна</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-45</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Ограниченная субстанция@, нелегальна</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Триггер</name>
			<cost type="percentage">-60</cost>
			<affects>total</affects>
			<reference>B115</reference>
			<notes>@Редкая субстанция@, нелегальна</notes>
		</modifier>		
		
		<description-loc>Ваше преимущество требует наличия особой субстанции или состояния для функционирования. Одна «доза» требуется на каждую минуту использования. Скидка зависит от редкости:
Повсеместный (доступен почти везде): -10%.
Распространенный  (дорогой или трудно найти): -20%.
Ограниченный (очень дорогой и трудно найти): -30%.
Редкий (невозможно купить, надо создать или найти): -40%.
Если Триггер нелегальный, вызывает привыкание или представляет иную опасность, скидка увеличивается в 1,5 раза.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Unconscious Only</name>
		<name-loc>Только подсознательно</name-loc>
		<reference>B115</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Только подсознательно</name>
			<cost type="percentage">-20</cost>
			<affects>total</affects>
			<reference>B115</reference>
		</modifier>
		<description-loc>Берется только в связке с Неконтролируемостью (см ниже). Вы вообще не можете активировать способность по желанию – это на усмотрение Мастера. Вы можете выкупить это ограничение позже, обретя контроль над силой.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Uncontrollable</name>
		<name-loc>Неконтролируемое</name-loc>
		<reference>B116</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неконтролируемое</name>
			<cost type="percentage">-10</cost>
			<affects>total</affects>
			<reference>B116</reference>
			<notes>Не наосит вреда</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Неконтролируемое</name>
			<cost type="percentage">-30</cost>
			<affects>total</affects>
			<reference>B116</reference>
			<notes>Опасная</notes>
		</modifier>		
		<description-loc>Ваша способность проявляется в нежелательные или неподходящие моменты. Когда мастер считает, что вы испытываете стресс (включая любые ситуации, требующие броска Страха или Самоконтроля) – вы должны кинуть Волю(Will), чтобы сохранить контроль над способностью, даже если вы не хотите ее использовать. Требуется только один бросок за каждую ситуацию, но результат 14+ - всегда провал, независимо от значения Воли(Will).
При провале мастер берет вашу способность под свой контроль, и заставляет ее действовать во враждебной или несерьезной манере. Действие способности часто отражает ваши «подавляемые желания», отраженные в причудах и ментальных недостатках.
Способность, которая не наносит вреда (Прыгун или Полет) – активируется неожиданно. Это необязательно будет опасно, но причиняет неудобства. После каждого неконтролируемого действия, вы получаете новый бросок Воли(Will), чтобы вернуть контроль. В этом случае Неконтролируемость стоит -10%.
Вредоносная способность в первую очередь обращается против ваших врагов, и никогда не обратится на вас – но никто другой не находится в безопасности. После каждого неконтролируемого действия (или перед ним, если вы атакуете Иждивенца или дорогого вам человека), вы получаете новый бросок воли, чтобы вернуть контроль. Для вредоносных способностей Неконтролируемость стоит -30%. 
Вы можете выкупить ограничение свободно, и обрести полный контроль над своей способностью.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Underwater</name>
		<name-loc>Действует под водой</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Действует под водой</name>
			<cost type="percentage">20</cost>
			<affects>total</affects>
			<reference>B109</reference>
		</modifier>
		<description-loc>Атаки обычно используются на земле или в вакууме, но неэффективны под водой. Это улучшение позволит использовать их под водой, с дальностью в 10 раз меньшей.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
	<name>Unreliable</name>
	<name-loc>Ненадежность</name-loc>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность</name>
		<notes>Бросок против 5</notes>
		<cost type="percentage">-80</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность</name>
		<notes>Бросок против 8</notes>
		<cost type="percentage">-40</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность</name>
		<notes>Бросок против 11</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность</name>
		<notes>Бросок против 14</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность оружия</name>
		<notes>Malf 12</notes>
		<cost type="percentage">-25</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность оружия</name>
		<notes>Malf 13</notes>
		<cost type="percentage">-20</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность оружия</name>
		<notes>Malf 14</notes>
		<cost type="percentage">-15</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность оружия</name>
		<notes>Malf 15</notes>
		<cost type="percentage">-10</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<modifier version="1" enabled="no" radiogroup="1">
		<name>Ненадежность оружия</name>
		<notes>Malf 16</notes>
		<cost type="percentage">-5</cost>
		<affects>total</affects>
		<reference>B116</reference>
	</modifier>
	<categories>
		<category>Modifier</category>
		<category>Limitation</category>
	</categories>
	<reference>B116</reference>
	<description-loc>Иногда ваша способность работает, а иногда нет – и вы не можете предсказать этого. Это не то же самое, что бросок на активацию способности. Вы можете иметь навык 20, и все равно сталкиваться с проблемами.
Каждый раз, когда вы используете способность, вы должны выбросить число активации или меньше на 3d. В случае успеха, в этот раз способность срабатывает – и вы можете сделать бросок активации. Если ваша способность оказывается недоступной, вы можете попытаться снова в следующую секунду, без штрафов. Каждая успешная попытка стоит 1 fp. Если у вас 3 и меньше fp, вы должны отдохнуть и восстановить все потерянные fp, прежде чем сможете попытаться снова.
!Число активации	|Модификатор
|5	|-80%
|8	|-40%
|11	|-20%
|14	|-10%
В случае применения Ненадежности к встроенному огнестрельному оружию или механизмам, используется правило Сбоев (Malf.). Вместо броска числа активации, вы получаете шанс сбоя.
!Сбой	|Модификатор
|12	|-25%
|13	|-20%
|14	|-15%
|15	|-10%
|16	|-5%</description-loc>
</advantage>
	<advantage version="2" modifier="yes">
		<name>Untrainable</name>
		<name-loc>Нетренируемость</name-loc>
		<reference>B116</reference>
		<categories>
			<category>Modifier</category>
			<category>Limitation</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Нетренируемость</name>
			<cost type="percentage">-40</cost>
			<affects>total</affects>
			<reference>B116</reference>
			<notes>Макс. умение 10</notes>			
		</modifier>
		<description-loc>Это ограничение может применяться только к способностям, для использования требующим броска навыка. 
Вы не можете обучиться нормальному контролю способности. Все навыки, ассоциированные с этой способностью, действуют, как если бы базовый для них атрибут равнялся 8 (или его текущему значению - что меньше), а максимальный уровень навыка для этой способности – 10.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Variable</name>
		<name-loc>Переменная сила</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="yes">
			<name>Переменная сила</name>
			<cost type="percentage">5</cost>
			<affects>total</affects>
			<reference>B109</reference>
		</modifier>
		<description-loc>Вы можете уменьшать силу атаки. Например, если имеете атаку, обычно наносящую 3d вреда, вы можете уменьшить вред до 1d или 2d. Уменьшение вреда заявляется до броска на атаку.</description-loc>
	</advantage>
	<advantage version="2" modifier="yes">
		<name>Wall</name>
		<name-loc>Стена</name-loc>
		<reference>B109</reference>
		<categories>
			<category>Modifier</category>
			<category>Attack modifier</category>
			<category>Enhancement</category>
		</categories>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стена</name>
			<cost type="percentage">30</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>Фиксированой формы</notes>
		</modifier>
		<modifier version="1" enabled="no" radiogroup="1">
			<name>Стена</name>
			<cost type="percentage">60</cost>
			<affects>total</affects>
			<reference>B109</reference>
			<notes>Призвольной формы</notes>
		</modifier>
		<description-loc>Это улучшение добавляется только к атакам, имеющим Воздействие на область (с. B102) и Продолжительным эффектом (с. B107). 
За +30% вы можете формировать в области стену из субстанции или эффекта вашей способности. Тогда она будет воздействовать на всех и всё, что проходит через эту стену. За каждый метр радиуса области воздействия вы получаете стену 3*1 метров.
За +60% стена работает так же, но вы можете формировать ее как угодно.
Вы должны определить, является ли ваша стена проницаемой или сплошной.
Проницаемая: стена состоит из жидкости, газа, энергии или аморфной материи (кусты с шипами). Она препятствует зрению, наносит вред всем, кто пытается сквозь нее пройти; но субъект может пройти сквозь нее, если не потеряет сознания или не будет убит ее эффектом. Все, что эффективно против субстанции стены, может разрушить ее: например, вода или огнетушитель могут погасить стену огня.
Сплошная: стена – материальная преграда. Этот тип доступен только для Природных атак, наносящих кинетический вред. Каждый метр стены имеет DR 3 и 1/2 hp за кубик наносимого вреда (округляется вверх). Например, атака, наносящая 6d вреда, может сформировать стену с DR 18 и 3 hp. Стена не наносит вреда сама по себе, но тип вреда применяется к ранениям, нанесенным жертвам.</description-loc>
	</advantage>
	
</advantage_list>`;
 standaloneLibs['Quirks-rus.adq']=`<?xml version="1.0" encoding="UTF-8" ?>
<name>Mentor: Quirks</name>
<notes>Причуды, большая коллекция из GURPS GURU, перевод Dh</notes>
<advantage_list version="1">
    <advantage version="2">
        <name>[quirk]</name>
        <name-loc>@свой текст@</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"All-Out Attack - Two Attacks"</name>
        <name-loc>"All-Out Attack! Две атаки! Ура!"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Always Put One In The Brain!"</name>
        <name-loc>"Всегда делайте контрольный выстрел"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Business Is Business"</name>
        <name-loc>"Бизнес есть бизнес"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"But Wealth IS Power"</name>
        <name-loc>"Но деньги это И ЕСТЬ власть"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Do You Want To Talk About It?"</name>
        <name-loc>"Вы хотите поговорить об этом?"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Don't Ever...EVER Call Me Stupid"</name>
        <name-loc>"Никогда... НИКОГДА не называй меня идиотом!"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Don't Hold With This Newfangled..."</name>
        <name-loc>"Ох, не гонитесь за новизной..."</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Holy Moses!"</name>
        <name-loc>"Матерь божья!"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"It's All In The Reflexes"</name>
        <name-loc>"Все на инстинктах"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"No Such Thing As Luck"</name>
        <name-loc>"Удачи не существует"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Retro" Fashion Sense</name>
        <name-loc>Одевается стиле "Ретро"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Sex Is For Humans"</name>
        <name-loc>"Секс - для людей"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Something Sweetly Sinister..."</name>
        <name-loc>"Прекрассный и омерзительный"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"The World Is My Ashtray"</name>
        <name-loc>"Я весь мир на х.. вертел"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"Water? Fish Fuck In Water."</name>
        <name-loc>"Не пейте воду, в ней рыбы ебутся!" "... а жить вообще вредно"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"When Does The Hurting Stop?"</name>
        <name-loc>"Жизнь - боль, когда это прекратится?"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>"You Betcha/Okey-Dokey!"</name>
        <name-loc>"Ну, типа, лады чувак / Оки-доки"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Abusive To His Underlings</name>
        <name-loc>Прессует подчиненных</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Accumulates Occult Junk</name>
        <name-loc>Собирает оккультное барахло</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Adjusts Others' Hair</name>
        <name-loc>Поправляет волосы собеседника</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Admires Physical Strength</name>
        <name-loc>Восхищается физической силой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Affects A Phony Accent</name>
        <name-loc>Поддельный акцент</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Afficionado of …</name>
        <name-loc>Прикалывается по …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Afraid Of Growing Old</name>
        <name-loc>Боится постареть</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Afraid That He's Bad Luck</name>
        <name-loc>Боится, что он неудачник</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Agressive Self-Promoter</name>
        <name-loc>Агрессивно рекламирует себя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Ailurophile</name>
        <name-loc>Кошатник</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Always "Dressed To Kill"</name>
        <name-loc>Всегда одет умопомрачительно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Always Sees The Brighter Side</name>
        <name-loc>Во всем ищет хорошее</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Always Telling Jokes</name>
        <name-loc>Всегда шутит</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Anarchist</name>
        <name-loc>Анархист</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Annoyed By Questions</name>
        <name-loc>Достает вопросами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Arm-Chair Fortean</name>
        <name-loc>Диванный уфолог</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Artsy</name>
        <name-loc>Претендует на "тонкий вкус"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Ashamed Of His Art</name>
        <name-loc>Стыдится своего таланта</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Assumes That Everyone Is Dishonest</name>
        <name-loc>Предполагает, что все мошенники</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Attracted To "Bad" Women</name>
        <name-loc>Тянет к "плохим" девушкам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Attracted To Men In Uniform</name>
        <name-loc>Тянет к мужчинам в форме</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Aversion to ...</name>
        <name-loc>Отвращение к …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Aversion To Bridges</name>
        <name-loc>Боится мостов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Avoids Crowds And Noise</name>
        <name-loc>Избегает толпы и шума</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Avoids Leadership Positions</name>
        <name-loc>Избегает руководящих должностей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Awash In Testosterone</name>
        <name-loc>Переполнен тестотероном</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Believes In A "Lost" Power</name>
        <name-loc>Верит в утраченные способности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Believes In The Conspiracy</name>
        <name-loc>Верит в теорию заговора</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Believes Myths About Monsters</name>
        <name-loc>Верит в мифы про чудовищ</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Bland And Apathetic</name>
        <name-loc>Вялый и апатичный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Boasts Of Sexual Conquests</name>
        <name-loc>Хвастается сексуальными победами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Bothered By Poor Grammar</name>
        <name-loc>Бесят грамматические ошибки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Bouncy And Bubbly</name>
        <name-loc>Вечно радостный и прыгающий</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Brags About His Fighting</name>
        <name-loc>Хвастается своими сражениями</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Bright-Eyed And Clean-Shaven</name>
        <name-loc>Сияющие глаза, выбритое лицо</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Calm And Emotionless</name>
        <name-loc>Спокойный и безэмоциональный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Can't Make Up His Mind</name>
        <name-loc>Тяжело принять решение</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Can't Mind His Own Business</name>
        <name-loc>Лезет в чужие дела</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Can't Sit Still</name>
        <name-loc>Не может усидеть на месте</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Can't Stand "Cute"</name>
        <name-loc>Терпеть не может "красавчиков"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Careful about …</name>
        <name-loc>Беспокоится о …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Careless about …</name>
        <name-loc>Наплевать на …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Carries Potatoes To Munch</name>
        <name-loc>Носит с собой ништяки пожевать</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Casual And Sloppy</name>
        <name-loc>Небрежный и неряшливый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cautious And Deliberate</name>
        <name-loc>Осторожный и взвешенный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Certain He Can Repair Anything</name>
        <name-loc>Уверен, что способен починить все что угодно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Chain-Smoker</name>
        <name-loc>Курит сигарету за сигаретой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Charming And Suave</name>
        <name-loc>Обаятельный и обходительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Chatterbox</name>
        <name-loc>Болтает постоянно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Chews Tobacco</name>
        <name-loc>Жует табак</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Childlike And Naive</name>
        <name-loc>Непосредственный и наивный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Chuckles To Himself</name>
        <name-loc>Смеется сам с собой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cites Quotes In Dead Tongues</name>
        <name-loc>Изрекает цитаты на мертвых языках</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cleans His Blade On Foes Hair</name>
        <name-loc>Вытирает оружие о волосы врагов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cleans His Weapon At Every Opportunity</name>
        <name-loc>Чистит оружие при первой возможности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Collects …</name>
        <name-loc>Собирает …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Collects Books</name>
        <name-loc>Собирает книги</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Composes Limericks About Himself</name>
        <name-loc>Составляет стишки о себе</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Composes Odd Drinking Ballads</name>
        <name-loc>Составляет странные песни для пьянок</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Concerned About His Reputation</name>
        <name-loc>Беспокоится о своей репутации</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Concocts Elaborate Schemes</name>
        <name-loc>Придумывает сложные комбинации</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Condescends To "Young People"</name>
        <name-loc>Снисходительно "Так и быть, молодой человек"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Considers Himself A Leader</name>
        <name-loc>Считает себя лидером</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Considers Pacifism Foolish</name>
        <name-loc>Считает пацифизм глупостью</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Considers Pet-Owning Immoral</name>
        <name-loc>Считает что держать домашних животных аморально</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Constantly Snacking</name>
        <name-loc>Постоянно что-то жрет</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Counts His Money Every Night</name>
        <name-loc>Пересчитывает сбережения каждый вечер</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cracks His Knuckles</name>
        <name-loc>Хрустит костяшками пальцев</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Creature Of The Moment</name>
        <name-loc>Повинуется сиюминутному импульсу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Crusty Old Fart Before His Time</name>
        <name-loc>Раньше времени стал ворчливым старикашкой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Curious about …</name>
        <name-loc>Любопытствует о …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Curses In His Native Tongue</name>
        <name-loc>Матерится на родном языке</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Cynical About Romance</name>
        <name-loc>Циничен к романтическим соплям</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Darts Eyes Malevolently</name>
        <name-loc>Злобно пялится</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Deadpan</name>
        <name-loc>Покерфейс</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Decisive And Determined</name>
        <name-loc>Решительный и непреклонный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Decked Out In Fur</name>
        <name-loc>Укутан в меха</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Delights In Loutishness</name>
        <name-loc>Обожает хамство</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Delights In Puzzles</name>
        <name-loc>Обожает головоломки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Delights In Spell Variations</name>
        <name-loc>Обожает модифицировать заклинания</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Denies Women His Essence</name>
        <name-loc>курица - не птица, женщина - не человек</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Despises His Job</name>
        <name-loc>Презирает свою работу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dialogue Peppered With Slang</name>
        <name-loc>Разговаривает слэнгом / жаргоном</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Disguises His Degree Of Wealth</name>
        <name-loc>Маскирует свой уровень дохода</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dislikes …</name>
        <name-loc>Не любит …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dislikes "Low Class" Thievery</name>
        <name-loc>Не любит ворье</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dislikes Being Underground</name>
        <name-loc>Не любит бывать под землей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dislikes Clothing</name>
        <name-loc>Не любит платья</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dislikes Magic And High-Tech</name>
        <name-loc>Не любит волшебство и высокие технологии</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Distracted by …</name>
        <name-loc>Смущается …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Does The "Guess Who?" Joke</name>
        <name-loc>Любит шутки начинающиеся с "Угадайте кто?"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Easily Give Trust</name>
        <name-loc>Не легко добиться доверия</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Give Direct Answers</name>
        <name-loc>Не дает прямые ответы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Know When To Shut Up</name>
        <name-loc>Не знает, когда стоит заткнуться</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like Doctors or Medicine</name>
        <name-loc>Не любит врачей и медицину</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like His Name</name>
        <name-loc>Не любит свое имя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like Spying On People</name>
        <name-loc>Не любит шпионить за людьми</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Be Touched</name>
        <name-loc>Не любит когда к нему прикасаются</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Get Attached</name>
        <name-loc>Не любит привязываться</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Get Up</name>
        <name-loc>Не любит отрывать зад от постели</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Leave His Lab</name>
        <name-loc>Не любит покидать свою лабораторию</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Lend Things</name>
        <name-loc>Не любит одалживать вещи</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Like To Remove His Armor</name>
        <name-loc>Не любит быть без брони</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Need His Eyepatch</name>
        <name-loc>Не носит повязку на глаз</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Respect Social Status</name>
        <name-loc>Клал на социальный статус</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Smile Much</name>
        <name-loc>Мало улыбается</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Take His Hat Off</name>
        <name-loc>Не снимает шляпу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doesn't Use Ranged Weapons</name>
        <name-loc>Не использовать оружие дальнего боя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Doodles On Any Blank Surface</name>
        <name-loc>Рисует на любой свободной поверхности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dragon Fixation</name>
        <name-loc>Зациклен на драконах</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dressed In Rags And Tatters</name>
        <name-loc>Одевается в лохмотья</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dresses Formally</name>
        <name-loc>Одевается строго</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Dresses Revealingly</name>
        <name-loc>Одевается показушною</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Driven By Guilt</name>
        <name-loc>Движим чувством вины</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Drools A Little</name>
        <name-loc>Привирает маленько</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Eager For Responsibility</name>
        <name-loc>Стремится к ответственности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Easily Amused</name>
        <name-loc>Смешливый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Easily Distracted By Food</name>
        <name-loc>Легко отвлечь едой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Easily Excited By The Job</name>
        <name-loc>Легко вовлекается в работу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Easily Intimidated</name>
        <name-loc>Легко запугать</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Eats …</name>
        <name-loc>Ест …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Eats Bugs</name>
        <name-loc>Жрет насекомых</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Eats Like A Pig</name>
        <name-loc>Жрет как свинья</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Effeminate</name>
        <name-loc>Женственный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Embarrassed By His Temper</name>
        <name-loc>Смущается своего характера</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Embarrassed by …</name>
        <name-loc>Смущается …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys …</name>
        <name-loc>Любит …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Fighting Outnumbered</name>
        <name-loc>Любит драться с превосходящим противником</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Folk Music</name>
        <name-loc>Любит народную музыку</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Good Tea</name>
        <name-loc>Любит хороший чай</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Humiliating Foes</name>
        <name-loc>Любит оскорблять врагов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Living Out Of A Pack</name>
        <name-loc>Любит неосёдлую жизнь</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Racist Humor</name>
        <name-loc>Любит расистские шутки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Enjoys Seeing New Places</name>
        <name-loc>Любит посещать новые места</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Epicure</name>
        <name-loc>Гедонист</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Eternal Skeptic</name>
        <name-loc>Вечный скептик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Excessively Enthusiastic</name>
        <name-loc>Много энтузиазма</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Exhilarated By Challenge</name>
        <name-loc>Тащится от поединков</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Faint Accent</name>
        <name-loc>Небольшой акцент</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Falls In Love Very Quickly</name>
        <name-loc>Влюбчив</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fanatically Punctual</name>
        <name-loc>Фанатично пунктуален</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fancies Himself A Philosopher</name>
        <name-loc>Воображает себя философом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fancies Himself A Romantic</name>
        <name-loc>Воображает себя романтический</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fashion Slave</name>
        <name-loc>Раб моды</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Feels At Home In Seedy Bars</name>
        <name-loc>Завсегдатай второсортных баров</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Feels His Face While Talking</name>
        <name-loc>Трогает лицо во время разговора</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Feminist</name>
        <name-loc>Феминистка</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fights Like A Dancing Maniac</name>
        <name-loc>Сражается по-позерски</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Finds Fulfillment In Work</name>
        <name-loc>Находит удовлетворение в работе</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Flaky</name>
        <name-loc>Ненадежный распиздяй</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Flips A Coin While Thinking</name>
        <name-loc>Подбрасывает монетку когда думает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fond Of "Scavenger" Tactics</name>
        <name-loc>Любит грязные трюки в бою</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fond Of Bawdy Humor</name>
        <name-loc>Любит похабные шуточки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Forward With Women</name>
        <name-loc>Напорист с женщинами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fountain Of Local Gossip</name>
        <name-loc>Фонтан сплетен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Friendly And Extroverted</name>
        <name-loc>Дружественный и общительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Frustrated By Emotion</name>
        <name-loc>Боится выражать эмоции</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fun-Loving And Bloodthirsty</name>
        <name-loc>Кровожадный весельчак</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Fussy about …</name>
        <name-loc>Придирчив к …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Generous To A Fault</name>
        <name-loc>Слишком щедрый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Generous With His Power</name>
        <name-loc>Делится своими способностями</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Genuinely Pious</name>
        <name-loc>Искренне набожен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gestures When Speaking</name>
        <name-loc>Жестикулирует во время разговора</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gets Cold In Warm Weather</name>
        <name-loc>Простывает в теплую погоду</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gets Off On Killing Things</name>
        <name-loc>Западает на утварь для убийства</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gets Students To Do His Work</name>
        <name-loc>Использует учеников чтобы выполнять свои обязанности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gives Names To His Weapons</name>
        <name-loc>Дает имена в своему оружию</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gives People Wierd Nicknames</name>
        <name-loc>Дает людям странные прозвища</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Goal: …</name>
        <name-loc>Цель: …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Goes To Church To Think</name>
        <name-loc>Ходит в церковь чтобы поразмышлять</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Graceful And Patient</name>
        <name-loc>Изящный и терпеливый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Grandiose Vocabulary</name>
        <name-loc>Напыщенные речи</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gripes About His Life</name>
        <name-loc>Моя жизнь одна большая проблема</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Gruff &amp; Growly</name>
        <name-loc>Угрюмый и ворчливый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Grumbling Misanthrope</name>
        <name-loc>Недовольный мизантроп</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Grumpy</name>
        <name-loc>Раздражительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Grumpy In Low Mana Areas</name>
        <name-loc>Раздражительный в областях с низким уровнем маны</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Habitual Wanderer</name>
        <name-loc>Прирожденный скиталец</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Habitually Drums Fingers</name>
        <name-loc>Привычка барабанить пальцами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hangs Back In A Fight</name>
        <name-loc>Отступает в бою</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hankers For Some Lovin'</name>
        <name-loc>Страстно ищет свою любовь</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has A LARGE Laugh</name>
        <name-loc>Очень громко ржет</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has Given Up On Himself</name>
        <name-loc>Потерял веру в себя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has No Qualms About His Work</name>
        <name-loc>Не стесняется своей работы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has No Respect For Colleagues</name>
        <name-loc>Не уважает коллег</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has To "Test" Everybody</name>
        <name-loc>Должен "испытать" каждого</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Has Tons Of Excess Energy</name>
        <name-loc>Мегатонны избыточной энергии</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates …</name>
        <name-loc>Ненавидит …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates Cold Weather</name>
        <name-loc>Ненавидит холодную погоду</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates Dogs</name>
        <name-loc>Ненавидит собак</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates To Act Without A Plan</name>
        <name-loc>Ненавидит действовать без плана</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates To Stay In One Place</name>
        <name-loc>Ненавидит оставаться на одном месте</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hates Whiners</name>
        <name-loc>Ненавидит нытиков</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Healthy Sense Of Wonder</name>
        <name-loc>Обостренное чувство прекрасного</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hesitant To Open Doors</name>
        <name-loc>С трудом допускает в свою жизнь посторонних</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Highly Confrontational</name>
        <name-loc>Конфликтный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Highly Suspicious Nature</name>
        <name-loc>Очень подозрительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>His Sword Is His "Security Blanket"</name>
        <name-loc>Мой меч - мой "плюшевый мишка"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hot-Headed</name>
        <name-loc>Вспыльчивый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Humble And Unassuming</name>
        <name-loc>Скромный и непритязательный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hums When He's Relaxed</name>
        <name-loc>Напевает себе под нос, когда на расслабоне</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Hypochondriac</name>
        <name-loc>Ипохондрик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Icy And Distant</name>
        <name-loc>Холодный и отстраненный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Idealistic</name>
        <name-loc>Идеалист</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Impeccable Good Manners</name>
        <name-loc>Непогрешимые хорошие манеры</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Incurable Showoff</name>
        <name-loc>Невозможный позер</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Intense</name>
        <name-loc>Впечатлительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Interested in …</name>
        <name-loc>Интересующийся …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Interrupts People</name>
        <name-loc>Перебивает людей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Into Leather</name>
        <name-loc>Только кожа</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Ironic Sense Of Humor</name>
        <name-loc>Ироничный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Irritable</name>
        <name-loc>Раздражительный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Irritated by …</name>
        <name-loc>Раздражает …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Irritated By Worriers</name>
        <name-loc>Раздражают воины</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Jolly And Carefree</name>
        <name-loc>Веселый и беззаботный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Keeps A Lucky Charm</name>
        <name-loc>Носит талисман</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Keeps His Head Shaved</name>
        <name-loc>Брегет голову на-лысо</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Keeps Interesting Stones</name>
        <name-loc>Собирает красивые камни</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Keeps Near The Exit</name>
        <name-loc>Старается быть возле выхода</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Knows He's Unlucky</name>
        <name-loc>Знает что невезуч</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Laughs at …</name>
        <name-loc>Насмехается над …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Laughs In Combat</name>
        <name-loc>Шутит в бою</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Leaves His Pipe Unlit</name>
        <name-loc>Оставляет трубку не потушенной</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Let's Hair Grow Long</name>
        <name-loc>Растит длинные волосы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Lies Playfully And Amusingly</name>
        <name-loc>Врет весело и складно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likeably Goofy</name>
        <name-loc>Милый дурачок</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes A Good Snowball Fight</name>
        <name-loc>Любит играть в снежки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes A Quick Buck</name>
        <name-loc>Любит легкие деньги</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Bright Primary Colors</name>
        <name-loc>Любит яркие цвета в одежде</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Dogs</name>
        <name-loc>Любит собак</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Getting Away With Things</name>
        <name-loc>Любит выходить сухим из воды</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes High-Dollar Whores</name>
        <name-loc>Любит дорогих шлюх</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes His "Wacky Announcer Voice"</name>
        <name-loc>Любит говорить дурацким голосом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes His Beard</name>
        <name-loc>Любит свою бороду</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Jewelry</name>
        <name-loc>Любит украшения</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Little Birdies</name>
        <name-loc>Любит маленьких птичек</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes To Attack From Behind</name>
        <name-loc>Любит атаковать со спины</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes To Be In Control</name>
        <name-loc>Любит когда все под контролем</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes To Empty The Clip</name>
        <name-loc>Любить всытреливать по много патронов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes To Give "Fatherly" Advice</name>
        <name-loc>Любит давать "отцовские" советы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes To Hear Himself Talk</name>
        <name-loc>Любит поговорить и быть главным в дискуссии</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Likes Women With Tatoos</name>
        <name-loc>Любит женщин с татуировками</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Little Concept Of Tact</name>
        <name-loc>Чересчур тактичен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Lives In His Own Universe</name>
        <name-loc>Живет в "своем собственном мире"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loses Temper Around Mosquitos</name>
        <name-loc>Бесят комары!</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves …</name>
        <name-loc>Любит …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves A Good Brawl</name>
        <name-loc>Любит хорошенько поскандалить</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves A Good Song Or Story</name>
        <name-loc>Любит хорошую песню или историю</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Being In Love</name>
        <name-loc>Любит влюбляются</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Disguises</name>
        <name-loc>Любит переодевания</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Eye-Shots</name>
        <name-loc>Любит стрелять глазами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves His Ugly Hat</name>
        <name-loc>Обожает свою уродливую шляпу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves His Whip</name>
        <name-loc>Любит свой кнут</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Knives Above Life Itself</name>
        <name-loc>Любит ножи больше жизни!</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Roses</name>
        <name-loc>Любит розы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves Thunderstorms</name>
        <name-loc>Любит грозы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves To Con People</name>
        <name-loc>Любит спорить</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves To Disassemble Things</name>
        <name-loc>Любит разборка вещи</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loves To Share New Learning</name>
        <name-loc>Любит делиться новыми знаниями</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loyal And Trustworthy</name>
        <name-loc>Верный и надежный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Loyal Only To Himself</name>
        <name-loc>Предан только себе</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Lusts After Fine Weaponry</name>
        <name-loc>Гоняется за высококачественным оружием</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Maddeningly Quiet</name>
        <name-loc>Раздражающе молчалив</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Makes Bets In Mid-Fight</name>
        <name-loc>Делает ставки в процессе боя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Makes Extemporaneous Poetry</name>
        <name-loc>Выдает импровизированные стихи</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Maternal By Nature</name>
        <name-loc>Материнский инстинкт</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Merciless Punster</name>
        <name-loc>Жестокий остряк</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Meticulous Planner</name>
        <name-loc>Тщательно планирует</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Mildly Paranoid</name>
        <name-loc>Немного параноик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Mispronounces People's Names</name>
        <name-loc>Коверкает имена людей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Morbid Sense Of Humor</name>
        <name-loc>Нездоровое чувство юмора</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Mumbles A Bit</name>
        <name-loc>Бубнит мелодию</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Muses Aloud To Himself</name>
        <name-loc>Размышляет сам с собой вслух</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Neat And Orderly</name>
        <name-loc>Аккуратный и опрятный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs A Constant Goal</name>
        <name-loc>Постоянно нужна Цель</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs His Privacy</name>
        <name-loc>Нуждается в уединении</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs Lots Of Peace &amp; Quiet</name>
        <name-loc>Часто хочет тишины и спокойствия</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs Somebody To Push Around</name>
        <name-loc>Должен все время кем-то помыкать</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs To Be In A Relationship</name>
        <name-loc>Доложен быть "в отношениях"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Needs To Lighten Up</name>
        <name-loc>Принимает все сишком близко к сердцу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Nettled By Weak Vocabularies</name>
        <name-loc>Бесится от бедного лексикона</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Night Owl</name>
        <name-loc>Сова (поздно ложится)</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>No Patience With Stupidity</name>
        <name-loc>Не терпит тупость</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>No Stomach For Killing</name>
        <name-loc>Неприязнь к убийству</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Nominal Vegetarian</name>
        <name-loc>Символическое вегетарианство</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Nonexistent Social Life</name>
        <name-loc>Не участвует в социальной жизни</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Oblivious To Others While Eating</name>
        <name-loc>Когда есть ни ни на кого не обращает внимания</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Obnoxiously Polite</name>
        <name-loc>Вежливый до неприязни</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Obsessively Tidy</name>
        <name-loc>Одержимо аккуратный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Old-Fashioned Romantic</name>
        <name-loc>Старомодный романтик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Only Eats Meat</name>
        <name-loc>Ест только мясо</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Opens Bottles With His Teeth</name>
        <name-loc>Открывает бутылки зубами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Overestimates His Luck</name>
        <name-loc>Переоценивает свою удачливость</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Overflowing With Innuendo</name>
        <name-loc>Перебарщивает с намеками</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Overplays His Rituals For Fun</name>
        <name-loc>Перебарщивает с ритуалами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Overprotects His Friends</name>
        <name-loc>Слишком оберегает друзей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Overprotects His Siblings</name>
        <name-loc>Слишком оберегает родных</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Painfully Insecure</name>
        <name-loc>Уж больно ненадежный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Party Animal</name>
        <name-loc>Тусовщик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Passion For Antique Technology</name>
        <name-loc>Страсть к антиквариату</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Passionate About Gemstones</name>
        <name-loc>Страсть к драгоценным камням</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Pedantic</name>
        <name-loc>Педант</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Perpetual Goofy Grin</name>
        <name-loc>Вечно кривляется</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Perpetually Angry</name>
        <name-loc>Постоянно зол</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Perpetually Unemployed</name>
        <name-loc>Постоянно бездельничает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Pessimist And Cynic</name>
        <name-loc>Пессимист и циник</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Pet Phrase: …</name>
        <name-loc>Слово паразит: …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Petty Delusion: …</name>
        <name-loc>Небольшое заблуждение: …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Plagiarizes Research</name>
        <name-loc>Любитель плагиата</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Playfully Gallant</name>
        <name-loc>Шутливо галантный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Plays In The Rain</name>
        <name-loc>Выбегает под дождь</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Prays Over Slain Foes</name>
        <name-loc>Молиться за убитых врагов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Prefers Suprise Attacks</name>
        <name-loc>Предпочитает атаковать из засады</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Prefers To Be Outdoors</name>
        <name-loc>Предпочитает быть на открытом воздухе</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Prefers To Work Alone</name>
        <name-loc>Предпочитает работать в одиночку</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Private And Reclusive</name>
        <name-loc>Замкнутый и скрытный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Prone To Tantrums</name>
        <name-loc>Склонный к истерикам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Proud of …</name>
        <name-loc>Гордится …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Proud Of His Ability To Read</name>
        <name-loc>Гордясь своим умением читать</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Puffs Pipe While Talking</name>
        <name-loc>Пыхтит трубкой во время разговора</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Purrs</name>
        <name-loc>Мурлыкает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Pushy</name>
        <name-loc>Пробивной, нахальный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Puts On Airs</name>
        <name-loc>Пускает пыль в глаза</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Quiet And Introverted</name>
        <name-loc>Тихий интроверт</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Quotes Religious Works</name>
        <name-loc>Цитирует святые книги</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Rapier Wit</name>
        <name-loc>Отпускает колкие остроты</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Rationalizes What He Does</name>
        <name-loc>Рационализирует все свои действия</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Reads Out Loud</name>
        <name-loc>Читает вслух</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Ready Smile And Warm Wit</name>
        <name-loc>Открытая улыбка и добрые шутки</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Reckless And Impulsive</name>
        <name-loc>Берассудный и импульсивный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Refuses To Wash His Hat</name>
        <name-loc>Не моет свою шляпу</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Remembers …</name>
        <name-loc>Помнит о …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Resents …</name>
        <name-loc>Обижается на …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Resents Authority</name>
        <name-loc>Возмущен властями</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Respects …</name>
        <name-loc>Уважает …</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Rolls Steel Balls (Queegs)</name>
        <name-loc>Перекатывает стальные шарики (Квигсы)</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Ruthlessly Ambitious</name>
        <name-loc>Жутко амбициозный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Satirical Wit</name>
        <name-loc>Сатирик</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Savors Moments Of Peace</name>
        <name-loc>Наслаждается моментом спокойствия</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Scared Of Black Magic</name>
        <name-loc>Боится черной магии</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Screams In Combat</name>
        <name-loc>Орет в бою</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Seeks Out Exotic New Foods</name>
        <name-loc>Ищет новую экзотическую еду</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Seems Paranoid But Isn't</name>
        <name-loc>Кажется параноиком, но таковым не является</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sees Friends As Underlings</name>
        <name-loc>Видит в друзьях своих подчиненных</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Seldom Speaks</name>
        <name-loc>Редко говорит</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Self-Conscious About Handicap</name>
        <name-loc>Стесняется физических недостатков</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Self-Conscious About His Age</name>
        <name-loc>Стесняется своего возраста</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Self-Depreciating</name>
        <name-loc>Низкая самооценка</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Self-Destructive</name>
        <name-loc>Саморазрушителен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Self-Righteous</name>
        <name-loc>Самодовольный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sensitive About His Looks</name>
        <name-loc>Восприимчив к комментариям о своем внешнем виде</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sensitive About His Size</name>
        <name-loc>Восприимчив к комментариям о своем размере</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Serene And "Together"</name>
        <name-loc>Спокойный и собранный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sexist Pig</name>
        <name-loc>Сэксистская свинья</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Shameless Flirt</name>
        <name-loc>Нагло подкатывает к дамам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Shoots Things To Relax</name>
        <name-loc>Расстреливает вещи чтобы расслабиться</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Shy Around Women</name>
        <name-loc>Застенчив рядом с женщиной</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Silent In Combat</name>
        <name-loc>Тих в бою</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sings Dirty Sea-Shanties</name>
        <name-loc>Поёт песни моряков</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sings While Working</name>
        <name-loc>Напевает, когда что-то делает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Skirt-Chaser</name>
        <name-loc>Охотник за юбками</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Smiles Sweetly At Her Victims</name>
        <name-loc>Мило улыбается жертвам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Smiles Too Damn Much</name>
        <name-loc>Слишком много улыбается</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Smokes</name>
        <name-loc>Курит</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Soap-Boxes At Any Opportunity</name>
        <name-loc>Любит поговорить "с трибуны"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Soft Spot For Animals &amp; Kids</name>
        <name-loc>Добр к детям и животным</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Sourpuss</name>
        <name-loc>Брюзга</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks In A Sepulchural Voice</name>
        <name-loc>Говорит замогильным голосом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks In A Whisper</name>
        <name-loc>Говорит шепотом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks In Dramatic Tones</name>
        <name-loc>Говорит драматически</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks In Parables</name>
        <name-loc>Говорит притчами</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks In Professional Jargon</name>
        <name-loc>Говорит на профессиональном жаргоне</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks Often Of His Wife</name>
        <name-loc>Часто говорит про свою жену</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Speaks Very Slowly</name>
        <name-loc>Говорит очень медленно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Spells Out Dirty Words</name>
        <name-loc>Матерится</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Spins Fantastic Yarns</name>
        <name-loc>Рассказывает небылицы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Spins Revolvers After A Fight</name>
        <name-loc>Крутит револьвер на пальце после боя</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Spiritual But Anti-Religious</name>
        <name-loc>Духовен но антирелигиозен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Spits Before Combat</name>
        <name-loc>Плюет перед боем</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Squeaky-Clean Language</name>
        <name-loc>Академически правильный язык</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Stares At Attractive Women</name>
        <name-loc>Пялится на красивых женщин</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Stargazer</name>
        <name-loc>Мечтатель</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Stays Active To Feel Young</name>
        <name-loc>Быть активным, чтобы чувствовать себя молодым</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Stingy With His Power</name>
        <name-loc>Скупой на свои способности</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Strong Silent Type</name>
        <name-loc>Молчаливый герой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Strong Streak Of Larceny</name>
        <name-loc>Сильная cклонность к воровству</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Strong Views On Mages Ethics</name>
        <name-loc>Твердые убеждения о этике Мага</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Studies ...</name>
        <name-loc>Учится ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Swears By His Chicken Soup</name>
        <name-loc>Клянется своим куриным супом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Swears Profusely</name>
        <name-loc>Часто клянется</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Takes No Lip</name>
        <name-loc>"Ой, все!"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Takes People At Face Value</name>
        <name-loc>Принимает все на веру</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Takes People At Their Word</name>
        <name-loc>Верит людям на слово</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Takes Walks In The Morning</name>
        <name-loc>Прогуливается по утрам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks about ...</name>
        <name-loc>Говорит о ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks In His Sleep</name>
        <name-loc>Говорит во сне</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks Rapidly</name>
        <name-loc>Тараторит</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks To Animals</name>
        <name-loc>Разговаривает с животными</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks To Himself</name>
        <name-loc>Разговаривает сам с собой</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Talks To His Weapons</name>
        <name-loc>Разговаривает со своим оружия</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Stuff and Nonsense</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Teetotaller</name>
        <name-loc>Трезвенник</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tells Is Like It Is</name>
        <name-loc>Говорит все как есть</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tends To Lead The Charge</name>
        <name-loc>Стремиться вести в атаку</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Kicking Ass and Taking Names</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tends To Lecture</name>
        <name-loc>Склонен читать лекции</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tenure-Track Mind</name>
        <name-loc>Думает на годы вперед</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Theatrical</name>
        <name-loc>Театрально показной</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thick Accent</name>
        <name-loc>Сильный акцент</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Think's He's God's Gift To Women</name>
        <name-loc>Считает, что он просто подарок с небес для любой женщины</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks All Music Is Terrible</name>
        <name-loc>Считает, что любая музыка ужасна</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Dislikes and Irritants</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks Any Good Idea Was His</name>
        <name-loc>Если идея была хорошая, это была его идея</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks He Can Sing</name>
        <name-loc>Считает что умеет петь</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks His Familiar Talks</name>
        <name-loc>Думает что его фамильяр разговаривает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks His Power Is A Mistake</name>
        <name-loc>Считает свои способности недостатком</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Thinks Sex Cures Everything</name>
        <name-loc>"Секс излечит всё!"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tired When Others Are Rested</name>
        <name-loc>Бесит когда кто-то бездельничает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Treats Wenches With Respect</name>
        <name-loc>С уважением относится с гулящим девкам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tries To Pass As A Gentleman</name>
        <name-loc>Пытается вести себя, как джентльмен</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Tries To Work Within The Law</name>
        <name-loc>Старается оставаться в рамках закона</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Trivial Vow: ...</name>
        <name-loc>Небольшая клятва: ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Trusts Authority Figures</name>
        <name-loc>Верит авторитетам</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Twirls His Mustache</name>
        <name-loc>Подкручивает усы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Twitchy And Nervous</name>
        <name-loc>Дёрганый и нервный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Unaware Of His Own Potential</name>
        <name-loc>Не раскрывает свой потенциал</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uncomfortable In The City</name>
        <name-loc>Чувствует себя плохо в городах</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uncomfortable In The Open</name>
        <name-loc>Чувствует себя плохо вне города</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Aversions and Fears</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Unkempt And Ill-Kept</name>
        <name-loc>Неряшливый и помятый</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uptight Prude</name>
        <name-loc>Синий чулок</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uses Friends As Guinea-Pigs</name>
        <name-loc>Использует друзей как подопытных кроликов</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uses His Cane Instead Of His Hand</name>
        <name-loc>Пользуется тростью вместо рук</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Uses Words He Doesn't Understand</name>
        <name-loc>Использует слова которых не понимает</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Vain</name>
        <name-loc>Тщеславный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Very Sentimental</name>
        <name-loc>Очень сентиментальный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Vocally Opinionated</name>
        <name-loc>Любит публино выражать свое мнение</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Vocally Pagan</name>
        <name-loc>Крикливый язычник</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Beliefs and Petty Delusions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants His Own Bar</name>
        <name-loc>Хочет собственный бар</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants His Own Ship</name>
        <name-loc>Хочет собственный корабль</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants The Respect Of His Peers</name>
        <name-loc>Жаждет уважения своих коллег</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants to ...</name>
        <name-loc>Хочет ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Be Famous</name>
        <name-loc>Хочет быть знаменитым</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Learn More About Fighting</name>
        <name-loc>Хочет знать больше о боевых искусствах</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Learn To Read</name>
        <name-loc>Хочет научиться читать</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Live Forever</name>
        <name-loc>Хочет жить вечно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Live In School Forever</name>
        <name-loc>Хочет оставаться "вечно молодым"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Settle Down "Someday"</name>
        <name-loc>Хочет когда-нибудь где-нибудь "осесть на всегда"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wants To Take Over The World</name>
        <name-loc>Хочет завоевать мир</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Warm &amp; Compassionate</name>
        <name-loc>Сопереживающий и сочувствующий</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Warm-Hearted</name>
        <name-loc>Мягкосердечный</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears ...</name>
        <name-loc>Носит ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Long Scarves</name>
        <name-loc>Носит длинные шарфы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Mis-Matched Clashing Clothing</name>
        <name-loc>Носит несовместимую одежду</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Non-Regulation Uniform</name>
        <name-loc>Носит что-от похожее на форму</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Nothing But Black</name>
        <name-loc>Носит только черное</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Only Tailored Clothes</name>
        <name-loc>Носит только сшитые на заказ костюмы</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Too Much Makeup</name>
        <name-loc>Накладывает слишком много косметики</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wears Uniform Off-Duty</name>
        <name-loc>Носит форму в не рабочее время</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Whistles While Walking</name>
        <name-loc>Насвистывает время прогулок</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Whittles When Bored</name>
        <name-loc>Выстругивает фигурки, когда скучно</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Will Bet On Anything</name>
        <name-loc>Держит пари на все подряд</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Pleasures and Passions</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Will Eat Nearly Anything</name>
        <name-loc>Жрет почти все</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wishes ...</name>
        <name-loc>Желает ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Withdrawn And Introvered</name>
        <name-loc>Замкнутый интроверт</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Personality and Demeanor</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't "Waste The Forest's Gifts"</name>
        <name-loc>Заботится о лесе</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Admit His Hearing Loss</name>
        <name-loc>Не признает что у него плохой слух</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Curse Around Women</name>
        <name-loc>Не ругается когда женщины рядом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Dance</name>
        <name-loc>Не танцует</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Eat Anything Red</name>
        <name-loc>Не есть ничего красного</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Food and Conversation</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Ride Another Creature</name>
        <name-loc>Не станет ездить на животных</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Steal From The Poor</name>
        <name-loc>Не ворует у бедных</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Talk About His Past</name>
        <name-loc>Не говорит о своем прошлом</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Methods and Philosopies</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Won't Wear Red</name>
        <name-loc>Не носит красное</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Looks &amp; Style</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Wonders about ...</name>
        <name-loc>Восхищается ...</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>To be Comleted</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Would Like To Have Children</name>
        <name-loc>Хочет завести детей</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Needs and Desires</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Writes Home Every Week</name>
        <name-loc>Пишет на дому каждую неделю</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Habbits nad Patterens</category>
        </categories>
    </advantage>
    <advantage version="2">
        <name>Zones Out Occasionally</name>
        <name-loc>Иногда "зависает"</name-loc>
        <description-loc></description-loc>
                <base_points>-1</base_points>

        <reference></reference>
        <categories>
            <category>Quirk</category>
            <category>Utterly Miscellaneous Quirks</category>
        </categories>
    </advantage>
</advantage_list>`;
 standaloneLibs['Equip-BS-rus.eqp']=`<!--?xml version="1.0" encoding="utf-8" ?-->
<name>Mentor: Equipment</name>
<notes>Basic Set 4ed - Снаряжение<br><br><a href="editor.phtml?v=40000000000000000000000000000000" target="_blank">Редактирование библиотеки</a> разрешно, но с предмодерацией</notes><editor-message>Редакторы!<br>
Эта библиотека только предметов из книги Basic Set. <br>
Существуют так-же другие библиотеки (к примеру High Tech и Low Tech), не стоит добавлять сюда отсебятину или данные из других книг без предварительного согласования.<br>
Так-же не стоит пресортировывать библиотеку.<br>
Спасибо за ваше участие!<br></editor-message>

<equipment_list unique_id="hv8irnjw:-jks2hyo6kqxr" version="1" size="0"><equipment version="3" color="7" state="equipped">
	<description>Медная монета</description>
	<value>1</value>
	<weight>0.006</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<categories>
		<category>Деньги</category>
		<category>Монеты средневековые</category>
	</categories>
	<reference>B264</reference>
	<description-loc>
		Copper Farthing
		<img data-src="lib/img/154261482961.png">
		Обычно стоит $1
	</description-loc>
</equipment><equipment version="3" color="7">
	<description>Серебряная монета</description>
	<value>4</value>
	<weight>0.004</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<categories>
		<category>Деньги</category>
		<category>Монеты средневековые</category>
	</categories>
	<reference>B264</reference>
	<description-loc>
		Silver Coin
		<img data-src="lib/img/151722047898.png">
		Обычно стоит $4
	</description-loc>
</equipment><equipment version="3" color="7">
	<description>Золотая монета</description>
	<value>80</value>
	<weight>0.004</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<categories>
		<category>Деньги</category>	    
		<category>Монеты средневековые</category>
	</categories>
	<reference>B264</reference>
	<description-loc>
		Gold Coin
		<img data-src="lib/img/151722044806.png">
		Обычно стоит $80
	</description-loc>
</equipment><equipment color="7">
	<description>Бумажные @Название валюты@</description>
	<value>1</value>
	<weight>0.00002</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<categories>
		<category>Деньги</category>
	</categories>
	<reference>B27</reference>
	<description-loc>Бумажные наличные деньги их эквивалент в долларах
Однако вы можете вы задать их стоимость по курсу в долларах
Вес примерно указан при купюрах номиналам $100</description-loc>
</equipment><equipment color="7">
	<description>Безналичные деньги @Название банка/счёта@</description>
	<value>1</value>
	<weight>0</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<categories>
		<category>Деньги</category>
	</categories>
	<reference>B27</reference>
	<description-loc>Безналичные деньги хранящиеся в каком-то банки или иной системе</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Антибиотик</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<reference>B289</reference>
		<notes>Лечит или предотвращает инфекционные заболевания (в течении 1d дней)</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
	<description-loc>Antibiotic
<img data-src="lib/img/151677676889.png"></description-loc><weight>0</weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Набор  антитоксинов</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>0.5</weight>
		<reference>B289</reference>
		<notes>Противоядие от конкретного яда. 10 доз</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
	<description-loc>Antitoxin Kit
<img data-src="lib/img/151677688884.png"></description-loc></equipment><equipment>
	<description>Набор писца</description>
	<value>50</value>
	<weight>2</weight>
	<quantity>1</quantity>
	<notes>Перья, чернильницы, перочинный нож, бумага.</notes>
	<tech_level>3</tech_level>
	<categories>
		<category>Связь и информация</category>
	</categories>
	<reference>B288</reference>
	<description-loc>
	    Scribe’s Kit
	    <img data-src="lib/img/154261482962.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Стрела</description>
	<value>2</value>
	<weight>0.1</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Arrow
		<img data-src="lib/img/151677710095.png">
		Тонкий стержень с заостренным наконечником на одном конце и узкими лопастями на другом.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Стрела, Бодкин</description>
	<value>2</value>
	<weight>0.1</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes">
		<damage type="damage type">pi</damage>
		<damage type="damage dr">2</damage>
	</equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>3</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B277</reference>
	<description-loc>
		Arrow, Bodkin
		<img data-src="lib/img/151677714791.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Штурмовые ботинки</description>
	<value>150</value>
	<weight>3</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>feet</location>
		<amount>6</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Обувь</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Assault Boots
		<img data-src="lib/img/151679881371.png">
		Пример из игры Warface
При атаке в нижнюю часть ступни DR 12
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Штурмовые ботинки</description>
	<value>150</value>
	<weight>3</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>feet</location>
		<amount>9</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Обувь</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Assault Boots
		<img data-src="lib/img/151679881371.png">
		Пример из игры Warface
При атаке в нижнюю часть ступни DR 18
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Штурмовые ботинки</description>
	<value>150</value>
	<weight>3</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>feet</location>
		<amount>12</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Обувь</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Assault Boots
		<img data-src="lib/img/151679881371.png">
		Пример из игры Warface
Двойное SP: используйте большее значение SP только при атаке в нижнюю часть ступни
При атаке в нижнюю часть ступни DR 24
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автомат укороченный 5.56мм</description>
	<value>900</value>
	<weight>7.3/1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>400/3000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>5.56mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Assault Carbine, 5.56mm
		<img data-src="lib/img/151694062134.png">
		Для примера приведен Steyr AUG A1 укороченная версия

У гражданского полуавтоматического варианта ROF 3, -25% к стоимости, и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автомат 5.56мм</description>
	<value>800</value>
	<weight>9/1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>500/3500</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Assault Rifle, 5.56mm
		<img data-src="http://weapons.gurps.ru/img/132.png">
		Для примера приведен Colt M16A2

У гражданского полуавтоматического варианта ROF 3, -25% к стоимости, и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автомат 7.62ммS</description>
	<value>300</value>
	<weight>10.5/1.8</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>400/3000</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>7.62mmS</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Assault Rifle, 7.62mmS
		<img data-src="http://weapons.gurps.ru/img/301.png">
		Для примера приведен Автомат Калашникова 1947 года

У гражданского полуавтоматического варианта ROF 3, -25% к стоимости, и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>ПТУР, 115mm</description>
	<value>20000</value>
	<weight>37/26</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6dx10(10) cr ex</damage>
		<strength>11B†</strength>
		<accuracy>3</accuracy>
		<range>200/2000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-10</bulk>
		<recoil>1</recoil>
		<ammo>115mm</ammo>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Guided Missile</specialization>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		ATGM, 115mm
		<img data-src="lib/img/151677803562.png">
		Противотанковая Управляемая Ракета
Минимальная дальность: 30 ярдов.
Опасный реактивный выхлоп: 1d обжигающих повреждений любому, находящемуся сзади стрелка в пределах 30 метров.
Управляемая атака (B412). Стрелок использует умение Артиллерия (Управляемая ракета) для атаки. Значение 1/2D - это скорость в м/с. Вес указан для пустой пусковой установки/одной ракеты
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Копьеметалка, дротик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>sw-1 imp</damage>
			<strength>5</strength>
			<accuracy>1</accuracy>
			<range>x3/x4</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon (Spear)</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Atlatl w/Dart
<img data-src="http://weapons.gurps.ru/img/1559.png">Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Копьеметалка, копье</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>2</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>sw+1 imp</damage>
			<strength>6</strength>
			<accuracy>3</accuracy>
			<range>x2/x3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon (Spear)</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Atlatl w/Javelin
<img data-src="http://weapons.gurps.ru/img/476.png">
Требует двух рук для подготовки, но только одной для атаки.</description-loc></equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет .40</description>
	<value>640</value>
	<weight>2.1/0.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>150/1900</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>15+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.40</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, .40
		<img data-src="http://weapons.gurps.ru/img/583.png">
		Для примера приведен пистолет Glock
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет .44M</description>
	<value>750</value>
	<weight>4.5/0.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d pi+</damage>
		<strength>12</strength>
		<accuracy>2</accuracy>
		<range>230/2500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>9+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>4</recoil>
		<ammo>.44M</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, .44M
		<img data-src="http://weapons.gurps.ru/img/19.png">
		Для примера приведен пистолет IMI Desert Eagle
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет .45</description>
	<value>300</value>
	<weight>3/0.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>175/1700</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.45</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, .45
		<img data-src="http://weapons.gurps.ru/img/4.png">
		Для примера приведен пистолет Colt Government
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет 9мм</description>
	<value>350</value>
	<weight>2.4/0.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>150/1850</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, 9mm
		<img data-src="http://weapons.gurps.ru/img/7.png">
		Для примера приведен пистолет FN-Browning HP
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет 9мм</description>
	<value>600</value>
	<weight>2.6/0.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>150/1850</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>15+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, 9mm
		<img data-src="http://weapons.gurps.ru/img/13.png">
		Для примера приведен пистолет Beretta Mod 92
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Автоматическйи Пистолет 9мм</description>
	<value>800</value>
	<weight>2/0.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>150/1900</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>18+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Auto Pistol, 9mm
		<img data-src="http://weapons.gurps.ru/img/23.png">
		Для примера приведен существующий пистолет Walther P99, при TL9 он может выглядеть как угодно
Включает «умную» оружейную электронику B278
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулемет 7.62мм</description>
	<value>6500</value>
	<weight>22/1.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>1000/4200</range>
		<rate_of_fire>9!</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>7.62mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		Auto Rifle, 7.62mm
		<img data-src="http://weapons.gurps.ru/img/117.png">
		Для примера приведен автомат Browning M1918 BAR
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Дробовик автоматический, 12G</description>
	<value>950</value>
	<weight>8.4/0.85</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>50/125</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>6+1(3i)</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>12G</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Auto Shotgun, 12G
		<img data-src="http://weapons.gurps.ru/img/85.png">
		Для примера приведен автоматический дробовик Franchi SPAS-12
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Топор</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>4</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Axe
<img data-src="http://weapons.gurps.ru/img/365.png"></description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Рюкзак, Каркасный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">100 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Backpack, Frame
<img data-src="lib/img/151678844890.png">
Вмещает 100lbs</description-loc></equipment_container>
	<equipment_container version="3" open="yes">
		<description>Рюкзак, Небольшой</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>3</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">40 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Backpack, Small
<img data-src="lib/img/151678849142.png">
Вмещает 40lbs

</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Весы  и  гирьки</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>Для взвешивания товаров</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Balance and Weights
<img data-src="lib/img/151678858295.png"></description-loc></equipment>
	<equipment version="3">
	<description>Пулезащитные перчатки</description>
	<value>150</value>
	<weight></weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>hands</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>6</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Перчатки</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Gloves
		<img data-src="lib/img/151679898312.png">
		<img data-src="lib/img/151679899018.png">
		Пример из игры Warface

Двойной DR: используйте первое, большее значение RD против пробивающих и режущих атак, а второе - против всех других типов повреждений.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитные перчатки</description>
	<value>150</value>
	<weight></weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>hands</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>9</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Перчатки</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Gloves
		<img data-src="lib/img/151679898312.png">
		<img data-src="lib/img/151679899018.png">
		Пример из игры Warface

Двойной DR: используйте первое, большее значение RD против пробивающих и режущих атак, а второе - против всех других типов повреждений.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитные перчатки</description>
	<value>150</value>
	<weight></weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>hands</location>
		<amount>4</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>12</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Перчатки</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Gloves
		<img data-src="lib/img/151679898312.png">
		<img data-src="lib/img/151679899018.png">
		Пример из игры Warface

Двойной DR: используйте первое, большее значение RD против пробивающих и режущих атак, а второе - против всех других типов повреждений.
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пулезащитный шлем</description>
		<tech_level>8</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>12</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet
<img data-src="lib/img/151678865867.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пулезащитный шлем</description>
		<tech_level>9</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>18</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet
<img data-src="lib/img/151679905754.png">Пример из игры Warface
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пулезащитный шлем</description>
		<tech_level>10</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>24</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet
<img data-src="lib/img/151679905754.png">Пример из игры Warface
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пулезащитный шлем</description>
		<tech_level>11</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>36</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet
<img data-src="lib/img/151679905754.png">Пример из игры Warface
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Визор для шлема</description>
		<tech_level>8</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>10</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>10</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet Visor
<img data-src="lib/img/151679921100.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Визор для шлема</description>
		<tech_level>9</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>15</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>15</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet Visor
<img data-src="lib/img/151679930723.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Визор для шлема</description>
		<tech_level>10</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>20</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>20</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet Visor
<img data-src="lib/img/151679930723.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Визор для шлема</description>
		<tech_level>11</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>30</amount>
		</dr_bonus>
	<description-loc>Ballistic Helmet Visor
<img data-src="lib/img/151679930723.png"></description-loc></equipment>
	<equipment version="3">
	<description>Пулезащитный бронекостюм</description>
	<value>1000</value>
	<weight>6</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>8</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>4</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>8</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>4</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>8</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Suit
		<img data-src="lib/img/151706043213.png">
		Рисунок freakyfir


Двойное СП: используйте первое, большее значение СП против пробивающих и режущих атак, а второе - против всех других типов повреждений.

Скрытно носится вместо или под одеждой.

СП увеличивается вместе с ТУ. После ТУ, при котором изделие появилось, используйте таблицу
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронекостюм</description>
	<value>1000</value>
	<weight>6</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>12</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>6</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>12</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>6</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>12</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Suit
		<img data-src="lib/img/151706043213.png">
		Рисунок freakyfir

Двойное СП: используйте первое, большее значение СП против пробивающих и режущих атак, а второе - против всех других типов повреждений.

Скрытно носится вместо или под одеждой.

СП увеличивается вместе с ТУ. После ТУ, при котором изделие появилось, используйте таблицу
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронекостюм</description>
	<value>1000</value>
	<weight>6</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>8</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>16</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>8</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>16</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>8</amount>
		<damage-type>cr</damage-type>
		<damage-type>imp</damage-type>
		<damage-type>burn</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>16</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Suit
		<img data-src="lib/img/151706043213.png">
		Рисунок freakyfir

Двойное СП: используйте первое, большее значение СП против пробивающих и режущих атак, а второе - против всех других типов повреждений.

Скрытно носится вместо или под одеждой.

СП увеличивается вместе с ТУ. После ТУ, при котором изделие появилось, используйте таблицу


Двойное СП: используйте первое, большее значение СП против пробивающих и режущих атак, а второе - против всех других типов повреждений.

Скрытно носится вместо или под одеждой.

СП увеличивается вместе с ТУ. После ТУ, при котором изделие появилось, используйте таблицу
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронежилет</description>
	<value>400</value>
	<weight>2</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Vest
		<img data-src="lib/img/151679995347.png">
		Двойное СП: используйте первое, большее значение СП против пробивающих и режущих атак, а второе - против всех других типов повреждений.

Скрытно носится вместо или под одеждой.

СП увеличивается вместе с ТУ. После ТУ, при котором изделие появилось, используйте таблицу
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронежилет</description>
	<value>400</value>
	<weight>2</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>9</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Vest
		<img data-src="lib/img/151680001422.png">
		Пример из игры Warface
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронежилет</description>
	<value>400</value>
	<weight>2</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>12</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Vest
		<img data-src="lib/img/151679999710.png">
		Пример из игры Warface
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пулезащитный бронежилет</description>
	<value>400</value>
	<weight>2</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>18</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Ballistic Vest
		<img data-src="lib/img/151680000320.png">
		Пример из игры Warface
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Перевязочные  материалы</description>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Бинты на пол сотни ран. Содержит: чистые тряпки / лейкопластырь и бинты / спрей "пластикскин" - зависит от TL. необходимо для умения Первая помощь (First Aid)</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
	<description-loc>Bandages
<img data-src="lib/img/151680017706.png"><img data-src="lib/img/151680014373.png">
<img data-src="lib/img/151680025817.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Закрытый цилиндрический шлем</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>240</value>
		<weight>10</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>6</amount>
		</dr_bonus>
	<description-loc>Barrel Helm
<img data-src="lib/img/151680039832.png">
Шлем во время ношения дает владельцу недостаток Нет периферического зрения (B151).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Полуторный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Bastard Sword
<img data-src="http://weapons.gurps.ru/img/1587.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Полуторный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>С умением Двуручный меч (Two-Handed Sword)</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Bastard Sword
<img data-src="http://weapons.gurps.ru/img/1587.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Короткая палка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc><img data-src="http://weapons.gurps.ru/img/429.png">
<img data-src="http://weapons.gurps.ru/img/1591.png">

Baton</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Батарейки</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<reference>B288</reference>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Batteries
<img data-src="lib/img/151680053798.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
	<description>Автомат 7.62мм</description>
	<value>900</value>
	<weight>11</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11†</strength>
		<accuracy>5</accuracy>
		<range>1000/4200</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Battle Rifle, 7.62mm
		<img data-src="http://weapons.gurps.ru/img/125.png">
		Для примера приведен автомат FN FAL


У гражданского полуавтоматического варианта ROF 3, -25% к стоимости, и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой скафандр комплект</description>
		<tech_level>9</tech_level>
		<legality_class>1</legality_class>
		<value>80000</value>
		<weight>150</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>70</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>50</amount>
		</dr_bonus>
		<attribute_bonus>
			<attribute limitation="striking only">st</attribute>
			<amount>10</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute limitation="lifting only">st</attribute>
			<amount>10</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">battlesuit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Battle Suit
<img data-src="lib/img/151680078382.png">
Требует умения Боевой скафандр. Дает Подъемную силу +10, Ударную силу +10, и Суперпрыжок 1. Добавьте +5 к Подъемной силе, +5 к Ударной силе, и +1 к Суперпрыжку за TL вышеTL9. При ношении шлема также предоставляет преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Устойчивость к вакууму. Не прибавляйте вес скафандра к нагрузке!

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой скафандр комплект</description>
		<tech_level>10</tech_level>
		<legality_class>1</legality_class>
		<value>80000</value>
		<weight>150</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>105</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>75</amount>
		</dr_bonus>
		<attribute_bonus>
			<attribute limitation="striking only">st</attribute>
			<amount>15</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute limitation="lifting only">st</attribute>
			<amount>15</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">battlesuit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Battle Suit
<img data-src="lib/img/151680078382.png">
Требует умения Боевой скафандр. Дает Подъемную силу +10, Ударную силу +10, и Суперпрыжок 1. Добавьте +5 к Подъемной силе, +5 к Ударной силе, и +1 к Суперпрыжку за TL вышеTL9. При ношении шлема также предоставляет преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Устойчивость к вакууму. Не прибавляйте вес скафандра к нагрузке!

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой скафандр комплект</description>
		<tech_level>11</tech_level>
		<legality_class>1</legality_class>
		<value>80000</value>
		<weight>150</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>140</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>100</amount>
		</dr_bonus>
		<attribute_bonus>
			<attribute limitation="striking only">st</attribute>
			<amount>20</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute limitation="lifting only">st</attribute>
			<amount>20</amount>
		</attribute_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">battlesuit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Battle Suit
<img data-src="lib/img/151680078382.png">
Требует умения Боевой скафандр. Дает Подъемную силу +10, Ударную силу +10, и Суперпрыжок 1. Добавьте +5 к Подъемной силе, +5 к Ударной силе, и +1 к Суперпрыжку за TL вышеTL9. При ношении шлема также предоставляет преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Устойчивость к вакууму. Не прибавляйте вес скафандра к нагрузке!

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой Костюм, Шлем</description>
		<tech_level>9</tech_level>
		<legality_class>1</legality_class>
		<value>10000</value>
		<weight>15</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>70</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>50</amount>
		</dr_bonus>
	<description-loc>Battle Suit Helmet
<img data-src="lib/img/151687124129.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой Костюм, Шлем</description>
		<tech_level>10</tech_level>
		<legality_class>1</legality_class>
		<value>10000</value>
		<weight>15</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>105</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>75</amount>
		</dr_bonus>
	<description-loc>Battle Suit Helmet
<img data-src="lib/img/151687124129.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой Костюм, Шлем</description>
		<tech_level>11</tech_level>
		<legality_class>1</legality_class>
		<value>10000</value>
		<weight>15</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>140</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>100</amount>
		</dr_bonus>
	<description-loc>Battle Suit Helmet
<img data-src="lib/img/151687124129.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Базука</description>
		<tech_level>7</tech_level>
		<legality_class>1</legality_class>
		<value>1000</value>
		<weight>16.7/3.4
<br></weight>
		<reference>B281</reference>
		<ranged_weapon>
			<damage>6dx2(10) cr ex</damage>
			<strength>10†</strength>
			<accuracy>3</accuracy>
			<range>100/650</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Machine Gun</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Submachine Gun</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Grenade Launcher</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gyroc</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Anti-Armor Weapon</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Bazooka, 60mm
<img data-src="http://weapons.gurps.ru/img/249.png">
Опасный реактивный выхлоп: 1d обжигающих повреждений любому, находящемуся сзади стрелка в пределах 15 ярдов
Повреждения не снижаются при достижении 1/2D-расстояния, но теряется делитель брони (10).


</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бинокль</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Дает (TL-4) уровней Телескопического зрения (Telescopic Vision)</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Binoculars
<img data-src="lib/img/151687142654.png">
<img data-src="lib/img/151687133436.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Удила и уздечка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>+2 к контролю лошади, +3 при управлении обоими руками</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>Bit and Bridle
<img data-src="lib/img/151592252089.png"><img data-src="lib/img/151592254706.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Дубинка работрговца</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Blackjack
<img data-src="http://weapons.gurps.ru/img/1602.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Одеяло</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>4</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Blanket
<img data-src="lib/img/151706260712.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бластерный пистолет</description>
		<tech_level>11</tech_level>
		<legality_class>3</legality_class>
		<value>2200</value>
		<weight>1.6/0.5</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>3d(5) burn</damage>
			<strength>4</strength>
			<accuracy>5</accuracy>
			<range>300/900</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>200(3)</shots>
			<bulk>-2</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Blaster Pistol
<img data-src="lib/img/151687571516.png">
Пример из фильма Blade Runner

Кроме урона огнём, наносятся повреждения Разрядом (B105).
В супернаучных компаниях у «мега-бластера» вдвое большая цена, но есть переключатель «оглушающего» режима: повреждения становится HT-3 (3) возд. Величина провала броска HT показывает продолжительность потери сознания в минутах.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бластерная винтовка</description>
		<tech_level>11</tech_level>
		<legality_class>2</legality_class>
		<value>18000</value>
		<weight>10/1</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>6d(5) burn</damage>
			<strength>7†</strength>
			<accuracy>10+2</accuracy>
			<range>700/2100</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>50(3)</shots>
			<bulk>-4</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Blaster Rifle
<img data-src="lib/img/151687602784.png">
Пример из фильма Star Wars

Кроме урона огнём, наносятся повреждения Разрядом (B105).
В супернаучных компаниях у «мега-бластера» вдвое большая цена, но есть переключатель «оглушающего» режима: повреждения становится HT-3 (6) возд. Величина провала броска HT показывает продолжительность потери сознания в минутах.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Духовая трубка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>1</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>1d-3 pi-</damage>
			<strength>2</strength>
			<accuracy>1</accuracy>
			<range>x4</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Blowpipe</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Blowpipe
<img data-src="http://weapons.gurps.ru/img/458.png">
Если повреждения проходят сквозь броню, происходит последующая атака наркотиком или ядом. Эффект зависит от яда; см. Яд (B437).

Требует двух рук для подготовки, но только одной для атаки.

 Дротик для духовой трубки - 0,1$
</description-loc></equipment>
	<equipment version="3">
	<description>Мушкетон  - Пуля</description>
	<value>0.1</value>
	<weight>0.05</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Боеприпасы</category>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Blowpipe Darts
		<img data-src="lib/img/151672076790.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Мушкетон, 8G</description>
	<value>150</value>
	<weight>12/0.13</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d pi-</damage>
		<strength>11†</strength>
		<accuracy>1</accuracy>
		<range>15/100</range>
		<rate_of_fire>1x9</rate_of_fire>
		<shots>1(15)</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>8G</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Blunderbuss, 8G
		<img data-src="http://weapons.gurps.ru/img/1606.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Болас</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>thr-1 cr (see B411)</damage>
			<strength>7</strength>
			<accuracy>0</accuracy>
			<range>x3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>Skill</type>
				<name>Bolas</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Bolas
<img data-src="http://weapons.gurps.ru/img/459.png">
Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411)
</description-loc></equipment>
	<equipment version="3">
	<description>Винтовка 7.62мм</description>
	<value>350</value>
	<weight>8.9/0.3</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1000/4200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>7.62mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Bolt-Action Rifle, 7.62mm
		<img data-src="http://weapons.gurps.ru/img/109.png">
		Для примера приведена Винтовка Мосина
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Ботинки</description>
		<tech_level>2</tech_level>
		<legality_class>-</legality_class>
		<value>80</value>
		<weight>3</weight>
		<reference>B284</reference>
		<categories>
			<category>Обувь</category>
		</categories>
		<dr_bonus>
			<location>feet</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Boots
<img data-src="lib/img/151591951382.png">
</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Бутылка, Керамика</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>1</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Bottle, Ceramic
<img data-src="lib/img/151706273845.png"></description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кастет</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Brass Knuckles
<img data-src="http://weapons.gurps.ru/img/1618.png">
Brawling (B182) увеличивает все повреждения

Claws (B42) и Karate (B203) увеличивают повреждения при ударе кулаком и пинке (когти не влияют на кастеты и ботинки)

Boxing (B182) улучшает удар кулаком
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палаш</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Broadsword
<img data-src="http://weapons.gurps.ru/img/1563.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовые наручи</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>180</value>
		<weight>9</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Bronze Armbands
<img data-src="lib/img/151695697804.png">
Часть бронзового доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовый нагрудник</description>
		<tech_level>1</tech_level>
		<legality_class>3</legality_class>
		<value>400</value>
		<weight>20</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Bronze Breastplate
<img data-src="lib/img/151695697804.png">
Часть бронзового доспеха

Частичное прикрытие: защищают только спереди
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовая кираса</description>
		<tech_level>1</tech_level>
		<legality_class>3</legality_class>
		<value>1300</value>
		<weight>40</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>5</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Bronze Corselet
<img data-src="lib/img/151695697804.png">
Часть бронзового доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовые поножи</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>270</value>
		<weight>17</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Bronze Greaves
<img data-src="lib/img/151695697804.png">
Часть бронзового доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовый шлем</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>160</value>
		<weight>7.5</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>face</location>
			<amount>3</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Bronze Helmet
<img data-src="lib/img/151704950202.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронзовый округлый шлем открытый</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>5</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Bronze Pot-Helm
<img data-src="lib/img/151704961212.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Длинная куртка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>210</value>
		<weight>16</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Buff Coat
<img data-src="lib/img/151695697804.png">
Часть бронзового доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Подавитель  «жучков»</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>1200</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>В радиусе 10 метров. 8 часов.</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Bug Stomper
<img data-src="lib/img/151686900094.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>«Жучок», аудио</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<reference>B289</reference>
		<notes>-7 на броско обнаружения, дистанция 1/4-мили, передает в течении 1 недели.</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Bug, Audio
<img data-src="lib/img/151686908300.png">
<img data-src="lib/img/151686910574.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Трос, сталь, 40мм, 10 метров</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>17</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 3,700 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Cable, Steel, 1.5", 10 yards
<img data-src="lib/img/151706282728.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Трос, сталь, 40мм, 20 метров</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>34</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 3,700 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Cable, Steel, 1.5", 20 yards
<img data-src="lib/img/151706282728.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Видеокамера</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>1</weight>
		<reference>B289</reference>
		<notes>Зум 10x, дает "ночное зрение 5 ур.". 7 часов</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Camcorder
<img data-src="lib/img/151721440817.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Фотоаппарат,  35мм</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>Базовое оборудование для умения "фотография". Пленка на 32 кадра ($10).</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Camera, 35mm
<img data-src="lib/img/151721448359.png">
Более качественные фотоаппараты стоят намного больше!
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пленка для фотокамеры</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<reference>B289</reference>
		<notes>32 кадра</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc><img data-src="lib/img/151721450374.png">
Camera-Film
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Походная печка, малая</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Расходует 1 литр керосина за 4 часа</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Camp Stove, Small
<img data-src="lib/img/151706302326.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Свеча, Сальная</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>На 12 часов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Candle, Tallow
<img data-src="lib/img/151592862451.png"></description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Армейская  фляга</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Canteen
<img data-src="lib/img/151706314982.png">
Вмещает 1 л жидкости (2ф. воды). </description-loc></equipment_container>
	<equipment version="3">
	<description>Гильзовая винтовка .455</description>
	<value>200</value>
	<weight>6/0.1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>600/2000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.455</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Cartridge Rifle, .45
		<img data-src="http://weapons.gurps.ru/img/102.png">
		Для примера приведен Remington Rolling Block
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Электрошокер для скота</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>1d-3 burn</damage>
			<strength>3</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Cattle Prod
<img data-src="http://weapons.gurps.ru/img/435.png">
Если бросок провален - жертва оглушена (sunned) пока оружие не выключено, плюс еще 20-HT секунд, и только после этого позволен бросок HT-3 чтобы придти в себя.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кавалерийская сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Cavalry Saber
<img data-src="http://weapons.gurps.ru/img/397.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сотовый телефон</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>0.25</weight>
		<reference>B288</reference>
		<notes>Работает только в пределах сети; $20/мес., 10 часов.</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Cell Phone
<img data-src="lib/img/151720812068.png"><br>
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бензопила</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>13</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+1d cut</damage>
			<strength>10‡</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Chainsaw
<img data-src="lib/img/151687427730.png">
Шумная! Работает два часа на половине галлона (~2л) бензина.</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Зажигалка</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.01</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Cigarette Lighter
<img data-src="lib/img/151706324325.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Альпинистское  снаряжение</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>4</weight>
		<reference>B288</reference>
		<notes>Ледоруб, "кошки", карабины</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Climbing Gear
<img data-src="lib/img/151706331688.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Матерчатый доспех</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>30</value>
		<weight>6</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Cloth Armor
<img data-src="lib/img/151695703666.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Матерчатая шапка</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>5</value>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Cloth Cap
<img data-src="lib/img/151705005360.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Матерчатые перчатки</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>15</value>
		<reference>B284</reference>
		<categories>
			<category>Перчатки</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Cloth Gloves
<img data-src="lib/img/151721395115.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Матерчатые рукава</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Cloth Sleeves
<img data-src="lib/img/151695703666.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр</description>
		<tech_level>9</tech_level>
		<legality_class>2</legality_class>
		<value>10000</value>
		<weight>30</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>30</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">nbc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Combat Hardsuit
<img data-src="lib/img/151680078382.png">
Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при TL9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).



</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр</description>
		<tech_level>10</tech_level>
		<legality_class>2</legality_class>
		<value>10000</value>
		<weight>30</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>45</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">nbc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Combat Hardsuit
<img data-src="lib/img/151680078382.png">

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при ТУ9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до ТУ9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр</description>
		<tech_level>11</tech_level>
		<legality_class>2</legality_class>
		<value>10000</value>
		<weight>30</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>60</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">nbc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Combat Hardsuit
<img data-src="lib/img/151680078382.png">

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при ТУ9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до ТУ9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр,  Шлем</description>
		<tech_level>9</tech_level>
		<legality_class>2</legality_class>
		<value>2000</value>
		<weight>4</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>18</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>12</amount>
		</dr_bonus>
	<description-loc>Combat Hardsuit Helmet
<img data-src="lib/img/151680078382.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр, Шлем</description>
		<tech_level>10</tech_level>
		<legality_class>2</legality_class>
		<value>2000</value>
		<weight>4</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>18</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>27</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>18</amount>
		</dr_bonus>
	<description-loc>Combat Hardsuit Helmet
<img data-src="lib/img/151680078382.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый военный скафандр, Шлем</description>
		<tech_level>11</tech_level>
		<legality_class>2</legality_class>
		<value>2000</value>
		<weight>4</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>24</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>36</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>24</amount>
		</dr_bonus>
	<description-loc>Combat Hardsuit Helmet
<img data-src="lib/img/151680078382.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Компас</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.144</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<skill_bonus>
			<name compare="starts with">navigation</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
	<description-loc>Compass
<img data-src="lib/img/151600672848.png">
+1 к умению Навигации.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Составной лук</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>4/0.1</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<accuracy>3</accuracy>
			<range>x20/x25</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Composite Bow
<img data-src="http://weapons.gurps.ru/img/463.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Компьютер,  ноутбук</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>1500</value>
		<weight>3</weight>
		<reference>B288</reference>
		<notes>Модем подключается к телефону. 2 часа.</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Computer, Laptop
<img data-src="lib/img/151720825850.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Компьютер,  носимый</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Очки - дисплеи и беспроводной модем. 8 часов.</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Computer, Wearable
<img data-src="lib/img/151720833534.png">
<img data-src="lib/img/151720830263.png">
</description-loc></equipment>
	
	<equipment version="3">
		<quantity>1</quantity>
		<description>Веревка, 5мм, 10 метров</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 90 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Cord, 3/16", 10 yards
<img data-src="lib/img/151706339471.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Шнур, 5мм, 20 метров</description>		
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 90 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Cord, 3/16", 20 yards
<img data-src="lib/img/151706339471.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Травматический  комплект/TL0-5</description>
		<tech_level>0-5</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>B289</reference>
		<notes>Полный набор для обработки серьезных ран. Включает стерильные бинты, нити и лекарства соответствующего TL. Считается как "импровизированный" (-5) к умению "Хирургия"</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
		<skill_bonus>
			<name compare="is">First Aid</name>
			<specialization compare="is anything"></specialization>
			<amount>2</amount>
		</skill_bonus>
	<description-loc>Crash Kit/TL0-5
<img data-src="lib/img/151686783852.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Травматический  комплект/TL6+</description>
		<tech_level>6+</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>B289</reference>
        <notes>Полный набор для обработки серьезных ран. Включает стерильные бинты, иглы, нити, лекарства соответствующего TL, капельницы и плазму . Считается как "импровизированный" (-5) к умению "Хирургия"</notes>		
		<categories>
			<category>Мед оборудование</category>
		</categories>
		<skill_bonus>
			<name compare="is">First Aid</name>
			<specialization compare="is anything"></specialization>
			<amount>2</amount>
		</skill_bonus>
	<description-loc>Crash Kit/TL6+
<img data-src="lib/img/151686727385.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST7)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 imp</damage>
			<strength>7†</strength>
			<accuracy>4</accuracy>
			<range>140/175</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST7)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST8)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>155</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 imp</damage>
			<strength>8†</strength>
			<accuracy>4</accuracy>
			<range>160/200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST8)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST9)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>160</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 imp</damage>
			<strength>9†</strength>
			<accuracy>4</accuracy>
			<range>180/225</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST9)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST10)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>165</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 imp</damage>
			<strength>10†</strength>
			<accuracy>4</accuracy>
			<range>200/250</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST10)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST11)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>170</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 imp</damage>
			<strength>11†</strength>
			<accuracy>4</accuracy>
			<range>220/275</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST11)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST12)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>175</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 imp</damage>
			<strength>12†</strength>
			<accuracy>4</accuracy>
			<range>240/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST12)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST13)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>185</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d imp</damage>
			<strength>13†</strength>
			<accuracy>4</accuracy>
			<range>260/325</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST13)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST14)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>195</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d imp</damage>
			<strength>14†</strength>
			<accuracy>4</accuracy>
			<range>280/350</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST14)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST15)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>205</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>15†</strength>
			<accuracy>4</accuracy>
			<range>300/375</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST15)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST16)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>215</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>16†</strength>
			<accuracy>4</accuracy>
			<range>320/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST16)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST17)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>230</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+2 imp</damage>
			<strength>17†</strength>
			<accuracy>4</accuracy>
			<range>340/425</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST17)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST18)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>245</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+2 imp</damage>
			<strength>18†</strength>
			<accuracy>4</accuracy>
			<range>360/450</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST18)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST19)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>260</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+3 imp</damage>
			<strength>19†</strength>
			<accuracy>4</accuracy>
			<range>380/475</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST19)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc></equipment>
	<equipment version="3" state="undefined">
		
		<description>Арбалет (ST20)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>275</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+3 imp</damage>
			<strength>20†</strength>
			<accuracy>4</accuracy>
			<range>400/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST20)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc><notes></notes><quantity>1</quantity></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет (ST20)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>275</value>
		<weight>6/0,06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+3 imp</damage>
			<strength>20†</strength>
			<accuracy>4</accuracy>
			<range>400/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Crossbow (ST20)
<img data-src="http://weapons.gurps.ru/img/1649.png"></description-loc><notes></notes></equipment>
	<equipment version="3">
	<description>Арбалетный Болт</description>
	<value>2</value>
	<weight>0.06</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Боеприпасы</category>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Crossbow Bolt
		<img data-src="lib/img/151676767496.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Фомка, 90см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>В бою считается малой дубинкой, но с -1 к умению</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
		<skill_bonus>
			<name compare="is">Axe/Mace</name>
			<specialization compare="is anything"></specialization>
			<amount>-1</amount>
		</skill_bonus>
	<description-loc>Crowbar, 3'
<img data-src="lib/img/151721491286.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Абордажная сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>2</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Cutlass
<img data-src="http://weapons.gurps.ru/img/433.png">
В ближнем бою гарда считается за кастет Dmg:thr cr, Reach:С, Skill: DX / Boxing / Brawing / Karate
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Газовый  резак</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>30</weight>
		<reference>B289</reference>
		<notes>1d+3(2) горения в секунду. Баллона хватает на 30 секунд резки. Балон: $50, 15 lbs.</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Cutting Torch
<img data-src="lib/img/151721499228.png">

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Газовый  резак, балон</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>15</weight>
		<reference>B289</reference>
		<notes>Расходник для резака</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Cutting Torch Gas Bottle
<img data-src="lib/img/151721501252.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кинжал</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.25</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>+0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Dagger
<img data-src="http://weapons.gurps.ru/img/411.png">
 Можно метать
</description-loc></equipment>
	<equipment version="3">
	<description>Дротиковое ружье 11мм</description>
	<value>1200</value>
	<weight>6.6/0.02</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d(0.2) pi-</damage>
		<strength>9†</strength>
		<accuracy>5+1</accuracy>
		<range>45/145</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>11mm Dart</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Dart Rifle, 11mm
		<img data-src="http://weapons.gurps.ru/img/68.png">
		Для примера приведен Иньектор Dan-Inject JM Standard

Если повреждения проходят через DR, с дротиком в качестве последующей атаки попадает наркотик или яд. Если дротик с транквилизатором, бросьте на HT-3; величина провала показывает длительность бессознательного состояния в минутах.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Дерринжер .41</description>
	<value>100</value>
	<weight>0.5/0.1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d pi+</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>80/650</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.41</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Derringer, .41
		<img data-src="http://weapons.gurps.ru/img/58.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Набор  грима</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>B289</reference>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
		<skill_bonus>
			<name compare="is">Disguise</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
	<description-loc>Disguise Kit
<img data-src="lib/img/151686929495.png"></description-loc></equipment>
	<equipment version="3">
	<description>Двуствольное ружьё , 10G</description>
	<value>450</value>
	<weight>10/0.1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+2 pi</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>50/125</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>10G</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Double Shotgun, 10G
		<img data-src="http://weapons.gurps.ru/img/77.png">
		Для примера приведен Remington Hammer Lifte
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Длинная кольчуга (хауберк) двойного плетения</description>
	<value>520</value>
	<weight>44</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>torso</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>groin</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>3</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B283</reference>
	<description-loc>
		Douple Mail Hauberk
		<img data-src="http://weapons.gurps.ru/img/2061.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Барабан</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Слышен на несколько миль</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc><img data-src="lib/img/151720842338.png">
Drum
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Защитные  наушники</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>1</weight>
		<reference>B289</reference>
		<notes>Дает "Защищенный слух (Protected Hearing)".</notes>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Ear Muffs
<img data-src="lib/img/151721632928.png">
Защищает от громких звуков (например выстрелов). 
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Электролазерный карабин</description>
		<tech_level>9</tech_level>
		<legality_class>3</legality_class>
		<value>3900</value>
		<weight>3.7/1</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>1d-3 burn</damage>
			<strength>4†</strength>
			<accuracy>8+1</accuracy>
			<range>160/470</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>360(3)</shots>
			<bulk>-4</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Electrolaser Carbine
<img data-src="lib/img/151689388543.png">
Пример взят из Mecha Journal

Для работы оружия нужна атмосфера. Никакого эффекта в разреженной атмосфере или вакууме!

Кроме урона огнем, наносятся повреждения Разрядом (B105). Вне зависимости от того, нанесен урон или нет, цели нужно сделать бросок HT-4, плюс половина DR в области удара (с учетом делителя брони). В случае провала цель оглушена электрошоком. Чтобы прийти в себя, нужно каждый ход делать бросок TH-4 (но без премии DR).

Дым, туман, дождь, темнота и т.п. дает цели дополнительный DR, равный штрафу к видимости. Например, если дождь дает штраф -1 на каждые 100 ярдов, лазер, стреляющий на 2.000 ярдов под дождем, должен пройти через дополнительный DR 20.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Электролазерный пистолет</description>
		<tech_level>9</tech_level>
		<legality_class>4</legality_class>
		<value>1800</value>
		<weight>2.2/0.5</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>1d-3 burn</damage>
			<strength>4</strength>
			<accuracy>4</accuracy>
			<range>40/80</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>180(3)</shots>
			<bulk>-2</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Electrolaser Pistol
<img data-src="lib/img/151689399566.png">
Пример взят из Mecha Journal

Для работы оружия нужна атмосфера. Никакого эффекта в разреженной атмосфере или вакууме!

Кроме урона огнем, наносятся повреждения Разрядом (B105). Вне зависимости от того, нанесен урон или нет, цели нужно сделать бросок HT-4, плюс половина DR в области удара (с учетом делителя брони). В случае провала цель оглушена электрошоком. Чтобы прийти в себя, нужно каждый ход делать бросок TH-4 (но без премии DR).

Дым, туман, дождь, темнота и т.п. дает цели дополнительный DR, равный штрафу к видимости. Например, если дождь дает штраф -1 на каждые 100 ярдов, лазер, стреляющий на 2.000 ярдов под дождем, должен пройти через дополнительный DR 20.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Электронные  «отмычки»</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>1500</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>+2 к вскрытию электронных замков</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Electronic "Lockpicks"
<img data-src="lib/img/151686939092.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лицевая маска (забрало)</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>2</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>face</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Face Mask
<img data-src="lib/img/151705016449.png">
<img data-src="lib/img/151705019687.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Аптечка  первой  помощи</description>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Полный набор для лечния ран с бинтами, мазями и т.п.</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
		<skill_bonus>
			<name compare="is">First Aid</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
	<description-loc>First Aid Kit
<img data-src="lib/img/151686804527.png">
<img data-src="lib/img/151686806593.png">
<img data-src="lib/img/151686808773.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Крючки и леска</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.01</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Fishhooks &amp; Line
<img data-src="lib/img/151706347106.png">
Базовое снаряжение для умения Рыбная ловля; требуется удилище</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Цеп двуручный</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>13†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Flail
<img data-src="http://weapons.gurps.ru/img/452.png">
Он же кистень, он же моргинштерн, он же утренняя звезда.

Попытки парировать цепы идут с -4, а фехтовальное оружие (маркировка F) вообще не может его парировать! Попытки блокировать цепы идут с -2.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бронежилет</description>
		<tech_level>6</tech_level>
		<legality_class>3</legality_class>
		<value>500</value>
		<weight>20</weight>
		<reference>B284</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>7</amount>
		</dr_bonus>
	<description-loc>Flak Jacket
<img data-src="http://weapons.gurps.ru/img/314.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Огнемет</description>
		<tech_level>6</tech_level>
		<legality_class>1</legality_class>
		<value>1800</value>
		<weight>70</weight>
		<reference>B281</reference>
		<ranged_weapon>
			<damage>3d burn</damage>
			<strength>10†</strength>
			<accuracy>-</accuracy>
			<range>50</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>10</shots>
			<bulk>-8</bulk>
			<recoil>-</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Sprayer</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Squirt Gun</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Water Cannon</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Flamethrower
<img data-src="http://weapons.gurps.ru/img/264.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Фонарик, Тяжелый</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>10 м луч, 5 часов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Flashlight, Heavy
<img data-src="lib/img/151706362804.png">
 5 часов
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Фонарик, Мини</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>B288</reference>
		<notes>5 м луч, 1 час</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Flashlight, Mini
<img data-src="lib/img/151706364923.png">
 1 час
</description-loc></equipment>
	<equipment version="3">
	<description>Кремневый мушкет .75</description>
	<value>200</value>
	<weight>13/0.05</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d pi++</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>100/1500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(15)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.75</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Flintlock Musket, .75
		<img data-src="http://weapons.gurps.ru/img/92.png">
		Для примера приведен мушкет Brown Bess
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Кремневый пистолет .51</description>
	<value>200</value>
	<weight>3/0.01</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d-1 pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>75/450</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>.51</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Flintlock Pistol, .51
		<img data-src="http://weapons.gurps.ru/img/1834.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Силовой щит</description>
		<tech_level>11^</tech_level>
		<legality_class>3</legality_class>
		<value>1500</value>
		<weight>0.5</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>-</damage>
			<strength>-</strength>
			<reach>-</reach>
			<parry>No</parry>
			<block>+0</block>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
	<description-loc>Force Shield
<img data-src="lib/img/151722126091.png">
PD:3
DR:100
HP:-

Носится на запястье, оставляя руку свободной. DR укрепленный (принимается за один уровень преимущества Укрепленный, B47).

Также доступен как баклер. Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом.
Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Силовой меч</description>
		<tech_level>11^</tech_level>
		<legality_class>2</legality_class>
		<value>10000</value>
		<weight>2</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>8d(5) burn</damage>
			<strength>3</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Force Sword
<img data-src="http://weapons.gurps.ru/img/401.png">
Энергетическое оружие. Один ready маневр чтобы активировать/деактивировать. Лезвие не может сломаться, и наносит повреждения любому оружию или частям тела которыми парировано блокировано или которое отпарировано им.

Батарея стоит $100, весит 0.5 lb., и работает 300 секунд.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Противоосколочный шлем</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Frag Helmet
<img data-src="http://weapons.gurps.ru/img/347.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Противоосколочный шлем + Щиток</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>1.5</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>face</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>eyes</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Frag Helmet Visor
<img data-src="lib/img/151705032807.png"></description-loc></equipment>
	<equipment version="3">
	<description>Противоосколочный бронежилет</description>
	<value>350</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>3</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Frag Vest
		<img data-src="http://weapons.gurps.ru/img/319.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Противоосколочный бронежилет - Дополнительные броне пластины</description>
	<value>300</value>
	<weight>15</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>20</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Frag Vest Plate Inserts
		<img data-src="http://weapons.gurps.ru/img/320.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Меховая набедренная повязка</description>
		<tech_level>0</tech_level>
		<legality_class>-</legality_class>
		<value>10</value>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Fur Loincloth
<img data-src="lib/img/151695995501.png">
 Скрытно носится вместо одежды или под одеждой
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Меховой жилет</description>
		<tech_level>0</tech_level>
		<legality_class>-</legality_class>
		<value>25</value>
		<weight>2</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Fur Tunic <img data-src="lib/img/151695736338.png">

 Скрытно носится вместо одежды или под одеждой
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Удавка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.01</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>see B405</damage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Garrote</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Garrote
<img data-src="http://weapons.gurps.ru/img/402.png">
Она же гаррота - кусок веревки для удушения, см B405
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Противогаз</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>4</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>face</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>eyes</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Gas Mask
<img data-src="lib/img/151705036976.png">
Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Бензин, 1 Галлон (~3.8л)</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>6</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Gasoline, 1 Gallon
<img data-src="lib/img/151706372222.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Латные рукавицы</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>2</weight>
		<reference>B284</reference>
		<categories>
			<category>Перчатки</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Gauntlets
<img data-src="lib/img/151721409273.png">
</description-loc></equipment>
	<equipment version="3">
	<description>Личное Оружие Самообороны Гаусса 4мм</description>
	<value>3600</value>
	<weight>4.6/1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d(3) pi-</damage>
		<strength>9†</strength>
		<accuracy>6+1</accuracy>
		<range>700/2900</range>
		<rate_of_fire>16</rate_of_fire>
		<shots>80(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>4mm Gauss</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Gauss PDW, 4mm
		<img data-src="lib/img/151689452665.png">
		Пример взят из Mecha Journal

Включает «умную» оружейную электронику (см. текст в рамке B278)
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Винтовка Гаусса 4мм</description>
	<value>7100</value>
	<weight>8.5/1.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6d+2(3) pi-</damage>
		<strength>10†</strength>
		<accuracy>7+2</accuracy>
		<range>1200/4800</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>60(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>4mm Gauss</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Gauss Rifle, 4mm
		<img data-src="lib/img/151689445244.png">
		Пример взят из Mecha Journal

Включает «умную» оружейную электронику (см. текст в рамке B278)
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Глефа</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Glaive
<img data-src="http://weapons.gurps.ru/img/416.png"></description-loc></equipment>
	
	<equipment version="3">
		<quantity>1</quantity>
		<description>GPS-приемник</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>3</weight>
		<reference>B288</reference>
		<notes>По спутникам (требуется сигнал), 24 часа</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>GPS Receiver
<img data-src="lib/img/151706381463.png">
Обновляется со спутника; дает Чувство направления (Нужен сигнал). 24 часа.</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кошка</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 300 фунтов; забрасывается на STx2 метров</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Grapnel
<img data-src="lib/img/151663274561.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Двуручный топор</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>12‡</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Great Axe
<img data-src="http://weapons.gurps.ru/img/447.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый закрытый шлем</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>340</value>
		<weight>10</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>7</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>7</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>7</amount>
		</dr_bonus>
	<description-loc>Great Helm
Greathelm
<img data-src="lib/img/151705054800.png">
Шлем во время ношения дает владельцу недостаток Нет периферического зрения (B151).

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Двуручный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>800</value>
		<weight>7</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>12†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Greatsword
<img data-src="http://weapons.gurps.ru/img/455.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Набор командных вещей</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>20</weight>
		<reference>B288</reference>
		<notes>Базовый набор для приготовления умений "приготовление пищи" и "Выживание". Котелок, веревка, топорик и т.п. на 3-8 чел.</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Group Basics
<img data-src="lib/img/151706423440.png"></description-loc></equipment>
	<equipment version="3">
	<description>Гиро-пистолет 15мм</description>
	<value>200</value>
	<weight>1/0.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6d pi++</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>1900</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>4(3i)</shots>
		<bulk>-2</bulk>
		<recoil>1</recoil>
		<ammo>15mm Gyroc</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Gyroc Pistol, 15mm
		<img data-src="http://weapons.gurps.ru/img/289.png">
		В качестве пример приведен реально существующий гиро пистолет MBA Gyrojet Mk I
Однако в TL9 он должен выглядеть по другому

Включает «умную» оружейную электронику (см. текст в рамке B278)

Ракетам нужно время для разгона. Разделите повреждения на 3 в 1-2 ярдах и на 2 в 3-10 ярдах.
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Алебарда</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>12</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+5 cut</damage>
			<strength>13‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+4 imp (may stick)</damage>
			<strength>13‡</strength>
			<usage>Swung Hook</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Halberd
<img data-src="http://weapons.gurps.ru/img/420.png">
Может застрять, см B405.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Наручники</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>0.5</weight>
		<reference>B289</reference>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
		<skill_bonus>
			<name compare="is">Escape</name>
			<specialization compare="is anything"></specialization>
			<amount>-5</amount>
		</skill_bonus>
	<description-loc>Handcuffs
<img data-src="lib/img/151686953630.png">
<img data-src="lib/img/151686961097.png">
<img data-src="lib/img/151686961703.png">

</description-loc></equipment>
	<equipment version="3">
	<description>Ручная бомбарда .90</description>
	<value>300</value>
	<weight>15/0.1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d pi++</damage>
		<strength>10†</strength>
		<accuracy>0</accuracy>
		<range>100/600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(60)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.90</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>3</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Handgonne, .90
		<img data-src="lib/img/151689520800.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Гарпун</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>11</strength>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon (Harpoon)</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon (Spear)</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Harpoon
<img data-src="http://weapons.gurps.ru/img/479.png">
Привязан веревкой. Чтобы выдернуть, нужен манёвр подготовки и успешный бросок ST (в случае провала можно повторить попытку на следующий ход). При выдергивании из раны наносит половину повреждений от причиненных при попадании.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Топорик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1.5/x2.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Hatchet
<img data-src="http://weapons.gurps.ru/img/366.png">
Можно метать</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый бластер</description>
		<tech_level>11</tech_level>
		<legality_class>1</legality_class>
		<value>23000</value>
		<weight>20/4p</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>8d(5) burn</damage>
			<strength>10†</strength>
			<accuracy>10+4</accuracy>
			<range>900/2700</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>90(5)</shots>
			<bulk>-6</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Heavy Blaster
<img data-src="lib/img/151689533618.png">
Пример взят из Mecha Journal

Кроме урона огнём, наносятся повреждения Разрядом (B105).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелый Плащ</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>-</damage>
			<strength>-</strength>
			<reach>-</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>Block</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>Special</damage>
			<strength>8</strength>
			<usage>Thrown</usage>
			<accuracy>+1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Одежда</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Heavy Cloak
<img data-src="http://weapons.gurps.ru/img/1640.png">
Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411). и Плащи (B404)</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелые латные рукавицы</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>2.5</weight>
		<reference>B284</reference>
		<categories>
			<category>Перчатки</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Heavy Gauntlets
<img data-src="lib/img/151721409273.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Толстые кожаные чулки</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>4</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Heavy Leather Leggings
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Толстые кожаные рукава</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Heavy Leather Sleeves
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелые пластинчатые рукава</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>1500</value>
		<weight>20</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>7</amount>
		</dr_bonus>
	<description-loc>Heavy Plate Arms
<img data-src="http://weapons.gurps.ru/img/2065.png">
Часть тяжелого пластинчатого доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелые пластинчатые поножи</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>1600</value>
		<weight>25</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>7</amount>
		</dr_bonus>
	<description-loc>Heavy Plate Legs
<img data-src="http://weapons.gurps.ru/img/2065.png">
Часть тяжелого пластинчатого доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелая стальная кираса</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>2300</value>
		<weight>45</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>7</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>7</amount>
		</dr_bonus>
	<description-loc>Heavy Steel Corselet
<img data-src="http://weapons.gurps.ru/img/2071.png"></description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Колчан поясной</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>1</weight>
		<reference>B289</reference>
		<notes>На 20 стрел или болтов</notes>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Hip Quiver
<img data-src="lib/img/151721639070.png">
</description-loc></equipment_container>
	<equipment version="3">
	<description>Пулемет .50</description>
	<value>14000</value>
	<weight>116/32</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>13d+1 pi+</damage>
		<strength>20M†</strength>
		<accuracy>6</accuracy>
		<range>1800/7400</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>.50</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Catapult</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Beams</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Cannon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Rockets</specialization>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		HMG, .50
		<img data-src="http://weapons.gurps.ru/img/195.png">
		Для примера приведен Browning M2HB

Съемная тренога весит дополнительно 44 фунта.
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет скрытого ношения .380</description>
		<tech_level>7</tech_level>
		<legality_class>3</legality_class>
		<value>300</value>
		<weight>1.3/0.2</weight>
		<reference>B278</reference>
		<ranged_weapon>
			<damage>2d pi</damage>
			<strength>8</strength>
			<accuracy>1</accuracy>
			<range>125/1500</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>5+1(3)</shots>
			<bulk>-1</bulk>
			<recoil>3</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Machine Gun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Submachine Gun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Grenade Launcher</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gyroc</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Anti-Armor Weapon</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Holdout Pistol, .380
<img data-src="http://weapons.gurps.ru/img/14.png">
Для примера приведен Walther PPK

</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Кобура  поясная</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>0.5</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Holster, Belt
<img data-src="lib/img/151721643084.png">
Под большинство пистолетов
</description-loc></equipment_container>
	<equipment_container version="3" open="yes">
		<description>Кобура наплечная</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1</weight>
		<reference>B289</reference>
		<notes>Позволяет использовать Утаивание (Holdout), но дает -1 к Быстрому Вытаскиванию (Fast-Draw).</notes>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Holster, Shoulder
<img data-src="lib/img/151721646747.png">
</description-loc></equipment_container>
	<equipment version="3">
	<description>«Маячок» наведения</description>
	<value>40</value>
	<weight></weight>
	<quantity>1</quantity>
	<notes>Обнаруживается сканером на расстояние в 1 милю. 12 часов</notes>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Правоохранительное</category>
		<category>Воровское</category>
		<category>Шпионское</category>
	</categories>
	<reference>B289</reference>
	<description-loc>
		Homing Beacon
		<img data-src="lib/img/151686986530.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Подковы</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>4</weight>
		<reference>B289</reference>
		<notes>Лошади получают +2 HT к любым броскам на усталость при долгих поездках</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>Horseshoes, Set
<img data-src="lib/img/151663409188.png"></description-loc></equipment>
	<equipment version="3">
	<description>Интегрированный гранатомет, 25mm</description>
	<value>0</value>
	<weight>0/1.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>7d cr ex[3d]</damage>
		<strength>10</strength>
		<accuracy>4+2</accuracy>
		<range>2200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>3(3)</shots>
		<bulk>-</bulk>
		<recoil>3</recoil>
		<ammo>25mm G</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
		<usage>Fragmentation</usage>
	</ranged_weapon>
	<ranged_weapon>
		<damage>4d cr ex</damage>
		<strength>10</strength>
		<accuracy>4+2</accuracy>
		<range>2200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>3(3)</shots>
		<bulk>-</bulk>
		<recoil>3</recoil>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
		<usage>Concussion</usage>
	</ranged_weapon>
	<ranged_weapon>
		<damage>HT-5 aff (10 yd)</damage>
		<strength>10</strength>
		<accuracy>4+2</accuracy>
		<range>2200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>3(3)</shots>
		<bulk>-</bulk>
		<recoil>3</recoil>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
		<usage>Stun</usage>
	</ranged_weapon>
	<legality_class>-</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		ICW Integral, 25mm
Integral, 25mm
		<img data-src="http://weapons.gurps.ru/img/236.png">
		Для примера приведено существующее оружие ATK-H&amp;K M29

Встроен в боевое оружие пехоты (ICW) c TL9 (B279). Используйте его Размеры (Bulk) от ICW. 

Есть «умная» оружейная электроника (см. B278).
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Боевое оружие пехоты 6.8мм</description>
	<value>7000</value>
	<weight>12/1.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10†</strength>
		<accuracy>4+2</accuracy>
		<range>700/4000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>25+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>6.8mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		ICW, 6.8mm
		<img data-src="lib/img/151689779470.png">
		Встроенная «умная» оружейная электроника (см. B278).
Встроенный 25мм гранатомет (см. B281)
	</description-loc>
</equipment>
	
	<equipment version="3">
		<quantity>1</quantity>
		<description>Железный клин (Костыль)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Iron Spike/Piton
<img data-src="lib/img/151706431436.png">
Для лазания, заклинивания двери, и т.д.</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Копье (Дротик)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>2</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>+3</accuracy>
			<range>x1.5/x2.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Javelin
<img data-src="http://weapons.gurps.ru/img/440.png">
Можно атаковать одной или двумя руками.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Катана</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Katana
<img data-src="http://weapons.gurps.ru/img/395.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Катана</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Для умения Двуручный меч (Two-Handed Sword)</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Katana
<img data-src="http://weapons.gurps.ru/img/395.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Керосин, 1 Галлон (~3.8л)</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>6</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Kerosene, 1 Gallon
<img data-src="lib/img/151706438222.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спицы для вязания, Пара</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc><img data-src="lib/img/151721504468.png">
Knitting Needles, Pair
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кусари</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>5</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Kusari
<img data-src="http://weapons.gurps.ru/img/413.png">
Попытки парировать цепы идут с -4, а фехтовальное оружие (маркировка F) вообще не может его парировать! Попытки блокировать цепы идут с -2.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пика  (Лэнца)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12</strength>
			<usage>Thrust</usage>
			<reach>4</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Lance</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Lance
<img data-src="http://weapons.gurps.ru/img/414.png">
При атаке верхом повреждения увеличиваются; см. Оружие кавалерии (B397).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Фонарь масляный</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Пол литра масла в 24 часа</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Lantern
<img data-src="lib/img/151706442847.png"></description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Вытяжной  шнур,  кожаный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<reference>B289</reference>
		<notes>Позволяет вернуть упавшее оружие по броску DX. Каждая попытка требует манёвра Подготовка. Может быть перерезан: -6 к попаданию, DR 2, HP 2</notes>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Lanyard, Leather
<img data-src="lib/img/151721652947.png">
</description-loc></equipment_container>
	<equipment_container version="3" open="yes">
		<description>Вытяжной шнур, стальная цепочка</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<reference>B289</reference>
		<notes>Позволяет вернуть упавшее оружие по броску DX. Каждая попытка требует манёвра Подготовка. Может быть перерезан: -6 к попаданию, DR 6, HP 4</notes>		
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Lanyard, Woven Steel
<img data-src="lib/img/151721652947.png">
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Большой нож</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw-2 cut</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>+0</accuracy>
			<range>x0.8/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Large Knife
<img data-src="http://weapons.gurps.ru/img/403.png">
 Можно метать
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Большая сеть</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>20</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>see B411</damage>
			<strength>11</strength>
			<accuracy>1</accuracy>
			<range>spec</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>-5</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Large Net
<img data-src="http://weapons.gurps.ru/img/1784.png">
Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411).

У сети нет расстояния половинных повреждений (1/2D). 
Максимальная дальность равна (ST + умение/5).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Большой щит</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>90</value>
		<weight>25</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
	<description-loc>Large Shield
<img data-src="http://weapons.gurps.ru/img/2086.png">

PD:3
DR:9
HP:60

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Большой щит(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>110</value>
		<weight>30</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr +1 cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
	<description-loc>Large Shield with Spike
<img data-src="http://weapons.gurps.ru/img/2086.png">

PD:3
DR:9
HP:60

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лассо</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>3</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>see B411</damage>
			<strength>7†</strength>
			<accuracy>0</accuracy>
			<range>spec</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(spec)</shots>
			<bulk>-2</bulk>
			<default>
				<type>Skill</type>
				<name>Lasso</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>  Lariat
<img data-src="http://weapons.gurps.ru/img/470.png">

Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лазерный  микрофон</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Подслушивает через стекло. До 300 метров</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Laser Microphone
<img data-src="lib/img/151686993095.png">
<img data-src="lib/img/151686994896.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лазерный пистолет</description>
		<tech_level>10</tech_level>
		<legality_class>3</legality_class>
		<value>2800</value>
		<weight>3.3/0.5</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>3d(2) burn</damage>
			<strength>6</strength>
			<accuracy>6</accuracy>
			<range>250/750</range>
			<rate_of_fire>10</rate_of_fire>
			<shots>400(3)</shots>
			<bulk>-2</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Laser Pistol
<img data-src="lib/img/151689808533.png">
Пример взят из Mecha Journal

Дым, туман, дождь, темнота и т.п. дает цели дополнительный DR, равный штрафу к видимости. Например, если дождь дает штраф -1 на каждые 100 ярдов, лазер, стреляющий на 2.000 ярдов под дождем, должен пройти через дополнительный DR 20.</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лазерная винтовка</description>
		<tech_level>10</tech_level>
		<legality_class>2</legality_class>
		<value>10000</value>
		<weight>10/2</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>5d(2) burn</damage>
			<strength>7†</strength>
			<accuracy>12+2</accuracy>
			<range>700/2100</range>
			<rate_of_fire>10</rate_of_fire>
			<shots>150(3)</shots>
			<bulk>-4</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Laser Rifle
<img data-src="lib/img/151689814631.png">
Пример взят из Mecha Journal

Дым, туман, дождь, темнота и т.п. дает цели дополнительный DR, равный штрафу к видимости. Например, если дождь дает штраф -1 на каждые 100 ярдов, лазер, стреляющий на 2.000 ярдов под дождем, должен пройти через дополнительный DR 20.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лазерный  прицел</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<reference>B289</reference>
		<notes>см B412. 6 часов.</notes>
		<equipment_modifier>
			<skill_level type="add">+1</skill_level>
		</equipment_modifier>
		<categories>
			<category>Оружейные аксессуары</category>
			<category>Модификатор оружия</category>
		</categories>
	<description-loc>Laser Sight
<img data-src="lib/img/151721659851.png">
B412
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лазерная снайперская винтовка</description>
		<tech_level>9</tech_level>
		<legality_class>1</legality_class>
		<value>20000</value>
		<weight>20/4p</weight>
		<reference>B280</reference>
		<ranged_weapon>
			<damage>5d(2) burn</damage>
			<strength>10†</strength>
			<accuracy>12+2</accuracy>
			<range>1100/3300</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>75(3)</shots>
			<bulk>-8</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Pistol</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Beam Weapons</name>
				<specialization>Projector</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Laser Sniper Rifle
<img data-src="lib/img/151689815579.png">
Пример взят из Mecha Journal

Дым, туман, дождь, темнота и т.п. дает цели дополнительный DR, равный штрафу к видимости. Например, если дождь дает штраф -1 на каждые 100 ярдов, лазер, стреляющий на 2.000 ярдов под дождем, должен пройти через дополнительный DR 20.
</description-loc></equipment>
	<equipment version="3">
	<description>РПГ, 84mm</description>
	<value>750</value>
	<weight>14.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6dx6(10) cr ex</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>330/2300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(-)</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>84mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		LAW, 84mm
		<img data-src="http://weapons.gurps.ru/img/258.png">
		Для примера приведен FFV AT4

Опасный реактивный выхлоп: 1d обжигающих повреждений любому, находящемуся сзади стрелка в пределах 30 метров.

Повреждения не снижаются при достижении 1/2D-расстояния, но теряется делитель брони (10).
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Свинцовый шарик (Продд)</description>
	<value>0.1</value>
	<weight>0.06</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Боеприпасы</category>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Lead Pellet (Prodd)
		<img data-src="lib/img/151672076790.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Свинцовый шарик (Праща)</description>
	<value>0.1</value>
	<weight>0.05</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes">
		<damage type="damage value">+1</damage>
		<range type="multiply">2</range>
	</equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Боеприпасы</category>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Lead Pellet (Sling)
		<img data-src="lib/img/151672076790.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаный жилет</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Leather Armor
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаная шапка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>32</value>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Leather Cap
<img data-src="lib/img/151705067167.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаные перчатки</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>30</value>
		<reference>B284</reference>
		<categories>
			<category>Перчатки</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Leather Gloves
<img data-src="lib/img/151721425511.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаный шлем</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>2</amount>
		</dr_bonus>
	<description-loc>Leather Helm
<img data-src="lib/img/151705064915.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаная куртка</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>50</value>
		<weight>4</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Leather Jacket
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаные поножи</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Leather Leggings
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кожаные штаны</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>40</value>
		<weight>3</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Leather Pants
<img data-src="lib/img/151696008340.png">
Часть кожаного доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легионерский шлем</description>
		<tech_level>2</tech_level>
		<legality_class>3</legality_class>
		<value>150</value>
		<weight>6</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>4</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Legionary Helmet
<img data-src="lib/img/151705078327.png">
</description-loc></equipment>
	<equipment version="3">
	<description>Рычажный карабин .30</description>
	<value>300</value>
	<weight>7/0.3</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>450/3000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6+1(3i)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>.30</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Lever-Action Carbine, .30
		<img data-src="http://weapons.gurps.ru/img/105.png">
		Для примера приведен Winchester M1873
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спасательный Жилет</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>B288</reference>
		<notes>До 350 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Life Jacket
<img data-src="lib/img/151706446344.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкий баклер</description>
		<tech_level>-</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>2</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Light Buckler
<img data-src="http://weapons.gurps.ru/img/2083.png">

PD:1
DR:5
HP:20

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкий баклер(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>45</value>
		<weight>7</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Light Buckler with Spike
<img data-src="http://weapons.gurps.ru/img/2083.png">

PD:1
DR:5
HP:20

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкий плащ</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>-</damage>
			<strength>-</strength>
			<reach>-</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>Block</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>Special</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>+1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Одежда</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>  Light Cloak
<img data-src="http://weapons.gurps.ru/img/1640.png">
Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411). и Плащи (B404)</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкая дубина</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Light Club
<img data-src="http://weapons.gurps.ru/img/385.png">
<img data-src="http://weapons.gurps.ru/img/386.png"><img data-src="http://weapons.gurps.ru/img/385.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкие чешуйчатые доспехи</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>15</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Light Scale Armor
<img data-src="http://weapons.gurps.ru/img/2053.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкий щит</description>
		<tech_level>-</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>2</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Light Shield
<img data-src="http://weapons.gurps.ru/img/2083.png">

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Легкий щит(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>45</value>
		<weight>7</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Light Shield with Spike
<img data-src="http://weapons.gurps.ru/img/2083.png">

PD:1
DR:5
HP:20

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
	<description>Ручной пулемет 7.62мм</description>
	<value>6600</value>
	<weight>30/6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>13B†</strength>
		<accuracy>5</accuracy>
		<range>1000/4200</range>
		<rate_of_fire>15!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>7.62mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		LMG, 7.62mm
LMG, 7.62mm
		<img data-src="http://weapons.gurps.ru/img/607.png">
		Для примера приведен Browning M1919
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Отмычки</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<reference>B289</reference>
		<notes>Базовое оборудование для умения Взлом (Lockpicking)</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Lockpicks
<img data-src="lib/img/151668958682.png">
<img data-src="lib/img/151686997683.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Длинное копье</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>5</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>2,3*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Long Spear
<img data-src="http://weapons.gurps.ru/img/441.png">
Можно атаковать одной или двумя руками.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Длинный лук</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>3/0.1</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>11†</strength>
			<accuracy>3</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Longbow
<img data-src="http://weapons.gurps.ru/img/460.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Ламинарный доспех</description>
		<tech_level>2</tech_level>
		<legality_class>3</legality_class>
		<value>680</value>
		<weight>26</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Lorcia Segmentata
<img data-src="http://weapons.gurps.ru/img/2064.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палица</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Mace
<img data-src="http://weapons.gurps.ru/img/370.png">
Можно метать
</description-loc></equipment>
	<equipment version="3">
	<description>Автоматический Пистолет-Пулемет 9мм</description>
	<value>900</value>
	<weight>5.5/1.1</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>12</strength>
		<accuracy>2</accuracy>
		<range>160/1900</range>
		<rate_of_fire>20</rate_of_fire>
		<shots>25+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Machine Pistol, 9mm
		<img data-src="http://weapons.gurps.ru/img/166.png">
		Для примера приведен IMI Uzi

Гражданская полуавтоматическая версия отличается - ROF 3, цена -25% и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Кольчужный облегающий капюшон</description>
	<value>55</value>
	<weight>4</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>skull</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>neck</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Шлемы</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Mail Coif
		<img data-src="lib/img/151705085825.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Длинная кольчуга (хауберк)</description>
	<value>230</value>
	<weight>25</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>torso</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>groin</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B283</reference>
	<description-loc>
		Mail Hauberk
		<img data-src="http://weapons.gurps.ru/img/2059.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Кольчужные поножи</description>
	<value>110</value>
	<weight>15</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>legs</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>legs</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Броня, конечности</category>
	</categories>
	<reference>B283</reference>
	<description-loc>
		Mail Leggings
		<img data-src="http://weapons.gurps.ru/img/2059.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Кольчужный жилет</description>
	<value>150</value>
	<weight>16</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>torso</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B283</reference>
	<description-loc>
		Mail Shirt
		<img data-src="http://weapons.gurps.ru/img/2059.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Кольчужные рукава</description>
	<value>70</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>arms</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus except-damage-type="yes">
		<location>arms</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Броня, конечности</category>
	</categories>
	<reference>B283</reference>
	<description-loc>
		Mail Sleeves
		<img data-src="http://weapons.gurps.ru/img/2059.png">
		Раздельное DR: используйте меньшее значение против дробящих (cr) атак
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спичка</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>0.3</value>
		<weight>0.001</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Match, Single, Waterproof
<img data-src="lib/img/151719958364.png">
Одна, влагозащищенная.</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спички</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>1.5</value>
		<weight>0.051</weight>
		<reference>B288</reference>
		<notes>Водонепроницаемый коробок на 50 штук</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Matches, Waterproof
<img data-src="lib/img/151706456373.png"></description-loc></equipment>
	<equipment version="3">
	<description>Мушкет Фитильный, .80</description>
	<value>150</value>
	<weight>20/0.05</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d pi++</damage>
		<strength>10R†</strength>
		<accuracy>2</accuracy>
		<range>100/600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(60)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.80</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Matchlock Musket, .80
		<img data-src="http://weapons.gurps.ru/img/1841.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кувалда</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>12</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>13‡</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Maul
<img data-src="http://weapons.gurps.ru/img/446.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Средний баклер</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>15</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Medium Buckler
<img data-src="http://weapons.gurps.ru/img/2085.png">

PD:2
DR:7
HP:40

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Средний баклер(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>20</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Medium Buckler with Spike
<img data-src="http://weapons.gurps.ru/img/2085.png">

PD:2
DR:7
HP:40

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Средний щит</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>15</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Medium Shield
<img data-src="http://weapons.gurps.ru/img/2085.png">

PD:2
DR:7
HP:40

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Средний щит(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>20</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
	<description-loc>Medium Shield with Spike
<img data-src="http://weapons.gurps.ru/img/2085.png">

PD:2
DR:7
HP:40

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сеть для ближнего боя</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>5</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>see B411</damage>
			<strength>8</strength>
			<accuracy>1</accuracy>
			<range>spec</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>-5</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>  Melee Net
<img data-src="http://weapons.gurps.ru/img/471.png">
Можно запутать или обездвижить цель; см. Специальное дистанционное оружие (B411).

У сети нет расстояния половинных повреждений (1/2D). 
Максимальная дальность равна (ST/2 + умение/5).
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Металлодетектор  ручной</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>3</weight>
		<reference>B289</reference>
		<notes>+3 к поиску металлических предметов. 8 часов.</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Metal Detector Wand
<img data-src="lib/img/151721459125.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Мини-фотоаппарат,  цифровой</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<reference>B289</reference>
		<notes>Хранит фото на оптических дисках.</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Mini-Camera, Digital
<img data-src="lib/img/151721461906.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Мини-магнитофон</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Размером с ладонь, 3 часа записи</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Mini-Recorder
<img data-src="lib/img/151720856088.png">
Карманный с пленкой на 3 часа (дополнительные пленки - 5$ каждая). 
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Мини-магнитофон,  цифровой</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>0</value>
		<reference>B288</reference>
		<notes>Размером с ладонь, 3 часа записи</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Mini-Recorder, Digital
<br><img data-src="lib/img/151720862153.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Мини-магнитофон, касета</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>B288</reference>
		<notes>3 часа записи</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Mini-Recorder-Tape
<img data-src="lib/img/151720870892.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Мономолекулярный кнут</description>
		<tech_level>9^</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>0.5</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+1d-2(10) cut</damage>
			<strength>5</strength>
			<reach>1-7*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Monowire Whip
<img data-src="http://weapons.gurps.ru/img/415.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кистень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>6</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Morningstar
<img data-src="http://weapons.gurps.ru/img/399.png">
Он же цеп, он же моргинштерн, он же утренняя звезда.

Попытки парировать цепы идут с -4, а фехтовальное оружие (маркировка F) вообще не может его парировать! Попытки блокировать цепы идут с -2.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Нагината</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Naginata
<img data-src="http://weapons.gurps.ru/img/1843.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Нагината</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<notes>При использовании тупым концом</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Naginata
<img data-src="http://weapons.gurps.ru/img/1843.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Нагината</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>С умением Двуручный меч (Two-Handed Sword)</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Naginata
<img data-src="http://weapons.gurps.ru/img/1843.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>«Нано-жучок»</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<reference>B289</reference>
		<notes>размером с булавочную головку (-10 к обнаружению)</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Nanobug
<img data-src="lib/img/151687005098.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Костюм ОМП-защиты комплект</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>3.5</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>neck</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>1</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>1</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">nbc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>NBC Suit
<img data-src="lib/img/151721749533.png">
Nuclear, Biological, Chemica - защита от Ядерной, Биологический, Химической угроз

Требует умения Костюм химзащиты - но при ТУ9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до ТУ9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.

DR скафандра применим только против разъедающего или обжигающих повреждений.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Очки  ночного  зрения</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Дает Ночное зрение 9 ур. (Night Vision). 8 часов.</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Night Vision Goggles
<img data-src="lib/img/151721466059.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Нунчаки</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Nunchaku
<img data-src="http://weapons.gurps.ru/img/400.png">
Попытки парировать цепы идут с -4, а фехтовальное оружие (маркировка F) вообще не может его парировать! Попытки блокировать цепы идут с -2.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Масло, Фонарь, 0.5 л</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>1</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Oil, Lantern, 1 Pint
<img data-src="lib/img/151715202965.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Парашют</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>30</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Parachute
<img data-src="lib/img/151715211277.png">
Используется с умением Парашют. Парашютист пролетит как минимум 80 метров, прежде чем парашют откроется, а затем его скорость будет равна 5 м/с</description-loc></equipment>
	<equipment version="3">
	<description>Личное Оружие Самообороны 4.6мм</description>
	<value>800</value>
	<weight>3.9/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d+1 pi-</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>200/2000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>4.6mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		PDW, 4.6mm
		<img data-src="lib/img/151693672574.png">
		Для примера приведен H&amp;K MP-7 PDW
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Набор личных вещей</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>Минимум, необходимый в походе: без него -2 к любому броску Выживания. Включает в себя посуду, трутницу или кремень и огниво, полотенце, и т.д. в зависимости от TL</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Personal Basics
<img data-src="lib/img/151715218004.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кирка</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 imp</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Может застрять</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Pick
<img data-src="http://weapons.gurps.ru/img/374.png">
Может застрять; см. Кирки, B405.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кирка</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>8</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Pickaxe
<img data-src="lib/img/151721506466.png">Ускоряет скорость копания
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST7)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d-1 imp</damage>
			<strength>7</strength>
			<accuracy>1</accuracy>
			<range>105/140</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST7)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST8)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>155</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d-1 imp</damage>
			<strength>8</strength>
			<accuracy>1</accuracy>
			<range>120/160</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST8)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST9)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>160</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d imp</damage>
			<strength>9</strength>
			<accuracy>1</accuracy>
			<range>135/180</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST9)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST10)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>165</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d imp</damage>
			<strength>10</strength>
			<accuracy>1</accuracy>
			<range>150/200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST10)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST11)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>170</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 imp</damage>
			<strength>11</strength>
			<accuracy>1</accuracy>
			<range>165/220</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST11)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST12)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>175</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 imp</damage>
			<strength>12</strength>
			<accuracy>1</accuracy>
			<range>180/240</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST12)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST13)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>185</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 imp</damage>
			<strength>13</strength>
			<accuracy>1</accuracy>
			<range>195/260</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST13)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST14)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>195</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 imp</damage>
			<strength>14</strength>
			<accuracy>1</accuracy>
			<range>210/280</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST14)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST15)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>205</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 imp</damage>
			<strength>15</strength>
			<accuracy>1</accuracy>
			<range>225/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST15)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST16)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>215</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 imp</damage>
			<strength>16</strength>
			<accuracy>1</accuracy>
			<range>240/320</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST16)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST17)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>230</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d imp</damage>
			<strength>17</strength>
			<accuracy>1</accuracy>
			<range>255/340</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST17)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST18)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>245</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d imp</damage>
			<strength>18</strength>
			<accuracy>1</accuracy>
			<range>270/360</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST18)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST19)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>260</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>19</strength>
			<accuracy>1</accuracy>
			<range>285/380</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST19)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный (ST20)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>275</value>
		<weight>4/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>20</strength>
			<accuracy>1</accuracy>
			<range>300/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Pistol Crossbow (ST20)
<img data-src="http://weapons.gurps.ru/img/1856.png">
Требует двух рук для подготовки, но только одной для атаки.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пластинчатые рукава</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>1000</value>
		<weight>15</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>6</amount>
		</dr_bonus>
	<description-loc>Plate Arms
<img data-src="http://weapons.gurps.ru/img/2065.png">
Часть пластинчатого доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пластинчатые пожножи</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>1100</value>
		<weight>20</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>6</amount>
		</dr_bonus>
	<description-loc>Plate Legs
<img data-src="http://weapons.gurps.ru/img/2065.png">
Часть тяжелого пластинчатого доспеха
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Плуг, железный</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>220</value>
		<weight>120</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Plow, Iron
<img data-src="lib/img/151721510644.png">
Вспыхивает твердые грунты

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Плуг, деревянный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>55</value>
		<weight>60</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Plow, Wooden
<img data-src="lib/img/151721513154.png">
Тянется скотом

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Шест, 1.8м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>3</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Pole, 6'
Для разбивки палаток, ловли рыбы или касания предметов
<img data-src="lib/img/151715596536.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Шест, 3м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>8</value>
		<weight>5</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Pole, 10'
<img data-src="lib/img/151715596536.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Секира</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>10</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw+4 cut</damage>
			<strength>12‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>12‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Poleaxe
<img data-src="http://weapons.gurps.ru/img/423.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Оружейник</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Armoury
<img data-src="lib/img/151721548008.png">
Базовое снаряжение для умения Оружейник
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Плотник</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Carpentry
<img data-src="lib/img/151721520290.png">
 Базовое снаряжение для умения Плотиник

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Электрик</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Electrician
<img data-src="lib/img/151721531299.png">
 Базовое снаряжение для умения Электрик

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Починка  электроники</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>1200</value>
		<weight>10</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Electronics Repair
<img data-src="lib/img/151721556772.png">
Базовое снаряжение для умения Починка  электроники
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Взрывотехник</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Explosives
<img data-src="lib/img/151721562810.png">
Базовое снаряжение для умения Взрывотехник
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Машинист</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Machinist
<img data-src="lib/img/151721582485.png">
Базовое снаряжение для умения Машинист
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносной  набор  инструментов, Механик</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>20</weight>
		<reference>B289</reference>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Portable Tool Kit, Mechanic
<img data-src="lib/img/151721564642.png">
Базовое снаряжение для умения Механик
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Округлый открытый шлем</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>5</weight>
		<reference>B284</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Pot-Helm
<img data-src="lib/img/151705096989.png">
</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Мешочек (сума), маленький</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">3 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Pouch, Small
<img data-src="lib/img/151715612799.png">
Вмещает 3ф
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод)  (ST7)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 pi</damage>
			<strength>7†</strength>
			<accuracy>2</accuracy>
			<range>140/175</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST7)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод)  (ST8)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>155</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+1 pi</damage>
			<strength>8†</strength>
			<accuracy>2</accuracy>
			<range>160/200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST8)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST9)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>160</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 pi</damage>
			<strength>9†</strength>
			<accuracy>2</accuracy>
			<range>180/225</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST9)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST10)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>165</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+2 pi</damage>
			<strength>10†</strength>
			<accuracy>2</accuracy>
			<range>200/250</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST10)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST11)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>170</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 pi</damage>
			<strength>11†</strength>
			<accuracy>2</accuracy>
			<range>220/275</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST11)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST12)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>175</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>1d+3 pi</damage>
			<strength>12†</strength>
			<accuracy>2</accuracy>
			<range>240/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST12)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST13)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>185</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d pi</damage>
			<strength>13†</strength>
			<accuracy>2</accuracy>
			<range>260/325</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST13)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST14)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>195</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d pi</damage>
			<strength>14†</strength>
			<accuracy>2</accuracy>
			<range>280/350</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST14)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST15)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>205</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 pi</damage>
			<strength>15†</strength>
			<accuracy>2</accuracy>
			<range>300/375</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST15)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST16)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>215</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+1 pi</damage>
			<strength>16†</strength>
			<accuracy>2</accuracy>
			<range>320/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST16)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST17)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>230</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+2 pi</damage>
			<strength>17†</strength>
			<accuracy>2</accuracy>
			<range>340/425</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST17)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод) (ST18)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>245</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+2 pi</damage>
			<strength>18†</strength>
			<accuracy>2</accuracy>
			<range>360/450</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST18)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод)  (ST19)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>260</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+3 pi</damage>
			<strength>19†</strength>
			<accuracy>2</accuracy>
			<range>380/475</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST19)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет шариковый (Прод)  (ST20)</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>275</value>
		<weight>6/0.06</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>2d+3 pi</damage>
			<strength>20†</strength>
			<accuracy>2</accuracy>
			<range>400/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Prodd (ST20)
<img data-src="http://weapons.gurps.ru/img/469.png"></description-loc></equipment>
	<equipment version="3">
	<description>Помповое ружьё, 12G</description>
	<value>240</value>
	<weight>8/0.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>50/125</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>12G</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Pump Shotgun, 12G
		<img data-src="http://weapons.gurps.ru/img/80.png">
		Для примера приведен Winchester Model 1897
	</description-loc>
</equipment>
	<equipment_container version="3" open="yes">
		<description>Кошелек, маленький</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.2</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Purse, Small
<img data-src="lib/img/151715604517.png">
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой посох</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>4</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>7†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>7†</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Quarterstaff
<img data-src="http://weapons.gurps.ru/img/444.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевой посох</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>4</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>С умением Двуручный меч (Two-Handed Sword)</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Quarterstaff
<img data-src="http://weapons.gurps.ru/img/444.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Радио, ранцевое</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>6000</value>
		<weight>15</weight>
		<reference>B288</reference>
		<notes>Часта VHF. 20 миль. 12 часов</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Radio, Backpack
<img data-src="lib/img/151720874223.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Радио,  портативное</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>Классическая "воки-токи". 2 мили. 12 часов</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Radio, Hand
<img data-src="lib/img/151720876547.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Радио,  наушники</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Микрофон на шее. 1 миля. 12 часов</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Radio, Headset
<img data-src="lib/img/151720883854.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Радио,  наушники, шифрованые</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>5000</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Микрофон на шее. 1 миля. Версия с шифрованием. 12 часов</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Radio, Headset, secure
<img data-src="lib/img/151720883854.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Рапира</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>2.75</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Rapier
<img data-src="http://weapons.gurps.ru/img/425.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Обычный лук</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>2/0.1</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>thr+1 imp</damage>
			<strength>10†</strength>
			<accuracy>2</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Regular Bow
<img data-src="http://weapons.gurps.ru/img/461.png"></description-loc></equipment>
	<equipment version="3">
	<description>Снайперская винтовка .338</description>
	<value>5600</value>
	<weight>17.5/0.8</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>9d+1 pi</damage>
		<strength>11B†</strength>
		<accuracy>6+3</accuracy>
		<range>1500/5500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>4+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.338</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Reich 2 .338 Tungsten Sniper
Sniper Rifle, .338
		<img data-src="http://weapons.gurps.ru/img/143.png">
		Для примера приведена винтовка Accuracy International AWM
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Укрепленные ботинки</description>
	<value>75</value>
	<weight>3</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>feet</location>
		<amount>2</amount>
	</dr_bonus>
	<legality_class>-</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Обувь</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Reinforced Boots
		<img data-src="lib/img/151720935099.png">
		При атаке в нижнюю часть ступни DR 5
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Револьвер .36</description>
	<value>150</value>
	<weight>2.5/0.24</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>120/1300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.36</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Revolver, .36
		<img data-src="http://weapons.gurps.ru/img/29.png">
		Для примера приведен револьвер Colt M1851 Navy
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Револьвер .38</description>
	<value>400</value>
	<weight>2/0.2</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>120/1500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.38</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Revolver, .38
		<img data-src="http://weapons.gurps.ru/img/41.png">
		Для примера приведен револьвер Smith &amp; Wesson Model 10
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Револьвер .44M</description>
	<value>900</value>
	<weight>3.25/0.3</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>200/2500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-3</bulk>
		<recoil>4</recoil>
		<ammo>.44M</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Revolver, .44M
		<img data-src="http://weapons.gurps.ru/img/48.png">
		Для примера приведен револьвер  Smith &amp; Wesson Model 26
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Револьвер .357M</description>
	<value>500</value>
	<weight>3/0.21</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>185/2000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.357M</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Revolver, .357M
		<img data-src="http://weapons.gurps.ru/img/47.png">
		Для примера приведен револьвер Colt Python
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Мушкет пулевой .577</description>
	<value>150</value>
	<weight>8.5/0.05</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d pi+</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>700/2100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(15)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.577</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Rifle-Musket, .577
		<img data-src="http://weapons.gurps.ru/img/99.png">
		Для примера приведена винтовка  Enfield P/1853
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Веревка, 20мм, 10 метров</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>5</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 1,100 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Rope, 3/4", 10 yards
<img data-src="lib/img/151719979690.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Веревка, 20мм, 20 метров</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>10</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 1,100 фунтов</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Rope, 3/4", 20 yards
<img data-src="lib/img/151719979690.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Веревка, 10мм, 10 метров</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1.5</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 300 фунтов</notes>		
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Rope, 3/8", 10 yards
<img data-src="lib/img/151719979690.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Веревка, 10мм, 20 метров</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>3</weight>
		<reference>B288</reference>
		<notes>Выдерживает до 300 фунтов</notes>				
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Rope, 3/8", 20 yards
<img data-src="lib/img/151719979690.png">
</description-loc></equipment>
	<equipment version="3">
	<description>Реактивный гранатомет, 85mm</description>
	<value>800</value>
	<weight>21/5.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6dx3(10) cr ex</damage>
		<strength>10†</strength>
		<accuracy>3+1</accuracy>
		<range>300/1000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(5)</shots>
		<bulk>-6</bulk>
		<recoil>1</recoil>
		<ammo>85mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		RPG, 85mm
		<img data-src="http://weapons.gurps.ru/img/254.png">
		Для примера приведен РПГ-7

Опасный реактивный выхлоп: 1d обжигающих повреждений любому, находящемуся сзади стрелка в пределах 30 метров.

Повреждения не снижаются при достижении 1/2D-расстояния, но теряется делитель брони (10).
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>2</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Saber
<img data-src="http://weapons.gurps.ru/img/426.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Седло и упряжь</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>15</weight>
		<reference>B289</reference>
		<notes> Базовое снаряжение для умения Верховой езды (Riding)</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>Saddle and Tack
<img data-src="lib/img/151670212095.png">
<img data-src="lib/img/151686847228.png">
<img data-src="lib/img/151686858508.png">

</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Седельные  сумки</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>B289</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">40 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Saddlebags
<img data-src="lib/img/151670268702.png"></description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Зенитная ракета, 70mm  (ЗРК)</description>
		<tech_level>8</tech_level>
		<legality_class>1</legality_class>
		<value>38000</value>
		<weight>18/22</weight>
		<reference>B281</reference>
		<ranged_weapon>
			<damage>6dx3 cr ex [6d]</damage>
			<strength>10†</strength>
			<accuracy>7</accuracy>
			<range>1000/8800</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-8</bulk>
			<recoil>1</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Guided Missile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>SAM, 70mm
<img data-src="lib/img/151695147378.png">
Для примера приведен ЗРК «Игла»

Минимальная дальность: 200 ярдов.
Опасный реактивный выхлоп: 1d обжигающих повреждений любому, находящемуся сзади стрелка в пределах 30 метров.

 Самонаводящаяся (Гиперспектральное зрение) атака (см. B413) с умением ракеты 10. Стрелок бросает на Артиллерию (Управляемая ракета), чтобы прицелиться. В случае удачи ракета получает его премию точности. Значение «1/2D» - скорость (ярды/с). Вес указан для пустой пусковой установки/одной ракеты.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сандалии</description>
		<tech_level>0</tech_level>
		<legality_class>-</legality_class>
		<value>25</value>
		<weight>0.5</weight>
		<reference>B284</reference>
		<categories>
			<category>Обувь</category>
		</categories>
	<description-loc>Sandals
<img data-src="lib/img/151720947762.png">
Частичное прикрытие: сандалии дают DR 1 нижней стороне стопы.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сапа</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Sap
<img data-src="http://weapons.gurps.ru/img/383.png">
Оглушающая дубинка или сапа 
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спутниковый телефон</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>3000</value>
		<weight>3</weight>
		<reference>B288</reference>
		<notes>Глобальный доступ через спутники. 1 час</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Satellite Phone
<img data-src="lib/img/151720889310.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пила</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>3</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Saw
<img data-src="lib/img/151721590305.png">
Инструмент дровосеков, а не плотников

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Отрядный пулемет, 5.56mm</description>
		<tech_level>7</tech_level>
		<legality_class>1</legality_class>
		<value>4800</value>
		<weight>24/7</weight>
		<reference>B281</reference>
		<ranged_weapon>
			<damage>5d+1 pi</damage>
			<strength>12B†</strength>
			<accuracy>5</accuracy>
			<range>800/3500</range>
			<rate_of_fire>12!</rate_of_fire>
			<shots>200(5)</shots>
			<bulk>-6</bulk>
			<recoil>2</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Machine Gun</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Submachine Gun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Grenade Launcher</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gyroc</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Anti-Armor Weapon</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>SAW, 5.56mm
<img data-src="http://weapons.gurps.ru/img/215.png">
Для примера приведен пулемёт H&amp;K HK23

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Чешуйчатый доспех</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>420</value>
		<weight>35</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>4</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Scale Armor
<img data-src="http://weapons.gurps.ru/img/2054.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Чешуйчетые поножи</description>
		<tech_level>2</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>21</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>legs</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Scale Leggings
<img data-src="http://weapons.gurps.ru/img/2054.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Чешуйчатые рукава</description>
		<tech_level>2</tech_level>
		<legality_class>3</legality_class>
		<value>210</value>
		<weight>14</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>arms</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Scale Sleeves
<img data-src="http://weapons.gurps.ru/img/2054.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Оптический  прицел, 4x</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>1.5</weight>
		<reference>B289</reference>
		<notes>+2 к Acc только для прицельных выстрелов.</notes>
		<equipment_modifier>
			<accuracy type="concat">+2</accuracy>
		</equipment_modifier>
		<categories>
			<category>Оружейные аксессуары</category>
			<category>Модификатор оружия</category>		
		</categories>
	<description-loc>Scope, 4x
<img data-src="lib/img/151721661614.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Оптический  прицел,  4x,  инфракрасный</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>8000</value>
		<weight>4</weight>
		<reference>B289</reference>
		<notes>+2 к Acc только для прицельных выстрелов. Дает Инфразрение. 2 часа</notes>		
		<equipment_modifier>
			<accuracy type="concat">+2</accuracy>
		</equipment_modifier>
		<categories>
			<category>Оружейные аксессуары</category>
			<category>Модификатор оружия</category>					
		</categories>
	<description-loc>Scope, 4x, Thermal Imaging
<img data-src="lib/img/151721664166.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скорпион</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>5000</value>
		<weight>110/0.9</weight>
		<reference>B281</reference>
		<ranged_weapon>
			<damage>5d imp</damage>
			<strength>45M†</strength>
			<accuracy>3</accuracy>
			<range>415/520</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>-10</bulk>
			<recoil>-</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Beams</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Machine Gun</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Rockets</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Scorpion
<img data-src="lib/img/151591643601.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Акваланг</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>1500</value>
		<weight>32</weight>
		<reference>B288</reference>
		<notes>с баллонам на 2-часа</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Scuba Gear
<img data-src="lib/img/151719994751.png">
 Базовое снаряжение для умения Акваланг: баллоны с воздухом на 2 часа, с регулятором, маска и т.п.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Коса</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>5</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw imp</damage>
			<strength>11‡</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Во 2м режиме может застрять</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Scythe
<img data-src="http://weapons.gurps.ru/img/448.png">
Может застрять; см. Кирки, B405.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Самозарядная винтовка, 7.62mm</description>
		<tech_level>6</tech_level>
		<legality_class>3</legality_class>
		<value>600</value>
		<weight>10/0.5</weight>
		<reference>B279</reference>
		<ranged_weapon>
			<damage>7d pi</damage>
			<strength>10†</strength>
			<accuracy>5</accuracy>
			<range>1000/4200</range>
			<rate_of_fire>3</rate_of_fire>
			<shots>8(3)</shots>
			<bulk>-5</bulk>
			<recoil>3</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Machine Gun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Submachine Gun</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Grenade Launcher</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gyroc</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Light Anti-Armor Weapon</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gun!</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Self-Loading Rifle, 7.62mm
<img data-src="http://weapons.gurps.ru/img/118.png">
Для примера приведена винтовка Springfield M1

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Обувь</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>B284</reference>
		<categories>
			<category>Обувь</category>
		</categories>
		<dr_bonus>
			<location>feet</location>
			<amount>1</amount>
		</dr_bonus>
	<description-loc>Shoes
<img data-src="lib/img/151670489177.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Короткий лук</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2/0.1</weight>
		<reference>B275</reference>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>7†</strength>
			<accuracy>1</accuracy>
			<range>x10/x15</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Short Bow
<img data-src="http://weapons.gurps.ru/img/462.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Короткий посох</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Short Staff
<img data-src="http://weapons.gurps.ru/img/1913.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Короткий меч</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>2</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Shortsword
<img data-src="http://weapons.gurps.ru/img/431.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Узконаправленный  микрофон</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes> Дает (ТУ-5) уровней Избирательного слуха.</notes>
		<categories>
			<category>Правоохранительное</category>
			<category>Воровское</category>
			<category>Шпионское</category>
		</categories>
	<description-loc>Shotgun Mike
<img data-src="lib/img/151687018042.png"></description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Колчан заплечный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.5</weight>
		<reference>B289</reference>
		<notes>На 12 стрел или болтов</notes>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Shoulder Quiver
<img data-src="lib/img/151721668537.png">
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Лопата</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>12</value>
		<weight>6</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Shovel
<img data-src="lib/img/151721598830.png">
Ускоряет копание

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Сюрикен</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.1</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>thr-1 cut</damage>
			<strength>5</strength>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>0</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Shuriken</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Shuriken
<img data-src="http://weapons.gurps.ru/img/478.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Глушитель</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>1</weight>
		<reference>B289</reference>
		<notes>Уменьшает повреждения на -1 за кубик, см B412</notes>
		<equipment_modifier>
			<damage type="damage value" per_dice="yes">-1</damage>
		</equipment_modifier>
		<categories>
			<category>Оружейные аксессуары</category>
			<category>Модификатор оружия</category>		
		</categories>		
	<description-loc>Silencer, Pistol or SMG
<img data-src="lib/img/151721672421.png">
</description-loc></equipment>
	
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спальный Мешок</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>7</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Sleeping Bag
<img data-src="lib/img/151720000484.png">
<img data-src="lib/img/151720002215.png">
Для обычных условий
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Спальный Мешок, Утепленный</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>15</weight>
		<reference>B288</reference>
		<notes>+3 HT к сопротивлению холоду</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Sleeping Bag, Insulated
<img data-src="lib/img/151720004190.png">
+3 к HT для сопротивления обморожению

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Меховое одеяло</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>8</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Sleeping Fur
<img data-src="lib/img/151720025824.png">
Греет, если не промокло
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Праща</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>sw pi</damage>
			<strength>6</strength>
			<accuracy>0</accuracy>
			<range>x6/x10</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Sling
<img data-src="http://weapons.gurps.ru/img/473.png">
<img data-src="http://weapons.gurps.ru/img/474.png">

Требует двух рук для подготовки, но только одной для атаки.

Может стрелять камнями (ТУ0) или свинцовыми шариками (ТУ2). В последнем случае получает +1к повреждению и удвоенную дальность.

Свинцовый шарик для пращи - 0.1$. Камни для пращи бесплатны



</description-loc></equipment>
	<equipment version="3">
	<description>Шарик для пращи</description>
	<value>0</value>
	<weight>0.05</weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Боеприпасы</category>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B276</reference>
	<description-loc>
		Sling Stone
		<img data-src="lib/img/151676856673.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малый баклер</description>
		<tech_level>-</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>8</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Small Buckler
<img data-src="http://weapons.gurps.ru/img/2089.png">

PD:1
DR:6
HP:30

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.


Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малый баклер(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>13</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Small Buckler with Spike
<img data-src="http://weapons.gurps.ru/img/2089.png">

PD:1
DR:6
HP:30

Вы можете подготовить баклер за один ход и сбросить за свободное действие, совсем как оружие - но баклер всегда занимает одну руку и не позволяет осуществлять удар щитом. Используйте умение Щит (Баклер) вместо обычного Щита. Никакого влияния на параметры.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малый нож</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>0.5</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>sw-3 cut</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>+0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>  Small Knife
<img data-src="http://weapons.gurps.ru/img/406.png">
 Можно метать
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малая палица</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cr</damage>
			<strength>10</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Small Mace
<img data-src="http://weapons.gurps.ru/img/372.png">
Можно метать
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малый щит</description>
		<tech_level>-</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>8</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Small Shield
<img data-src="http://weapons.gurps.ru/img/2089.png">

PD:1
DR:6
HP:30

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Малый щит(Шип)</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>13</weight>
		<reference>B287</reference>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>0</strength>
			<usage>Shield Bash</usage>
			<reach>1</reach>
			<parry>No</parry>
			<block>+0</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Buckler</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Force Shield</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<specialization>Shield</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Щиты</category>
		</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
	<description-loc>Small Shield with Spike
<img data-src="http://weapons.gurps.ru/img/2089.png">

PD:1
DR:6
HP:30

Может использоваться для удара щитом (см. Таблицу контактного оружия) или толчка щита (см. Толчок, B371). При ТУ2 + вы можете приделать к малому, среднему, или большому щиту шип, чтобы увеличить повреждения: добавьте 20 $ и 5 фунтов.

Начиная с TL3+ доступны железные щиты, которые встречаются редко: x5 цена, x2 вес, +3 DR, и x2 HP. 
При TL7+ пластиковые полицейские щиты (сделанные из лексана и т.п.) получают x1/2 к весу и такие же остальные параметры. Материал щита никогда не
влияет на PD.

</description-loc></equipment>
	<equipment version="3">
	<description>Шпага</description>
	<value>400</value>
	<weight>1.5</weight>
	<quantity>1</quantity>
	<melee_weapon>
		<damage>thr+1 imp</damage>
		<strength>5</strength>
		<reach>1</reach>
		<parry>0F</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Main-Gauche</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Sword!</name>
			<modifier>0</modifier>
		</default>
		<usage>Thrust</usage>
	</melee_weapon>
	<legality_class>4</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Холодное</category>
	</categories>
	<reference>B273</reference>
	<description-loc>
		Smallsword
		<img data-src="http://weapons.gurps.ru/img/1942.png">
		Шпага (англ. small sword) - холодное колюще-рубящее или колющее оружие, разновидность меча, состоящее из длинного (около 1 метра и более), прямого одно-двухлезвийного или гранёного клинка и рукояти (эфеса) с дужкой и гардой различной формы.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пистолет-Пулемет .45</description>
	<value>2200</value>
	<weight>15.7/4.9</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>190/1750</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>50+1(5)</shots>
		<bulk>-4</bulk>
		<recoil>3</recoil>
		<ammo>.45</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		SMG, .45
		<img data-src="http://weapons.gurps.ru/img/576.png">
		Для примера приведен Auto-Ordnance M1921 (Tommy Gun)

Гражданская полуавтоматическая версия отличается - SS 3, цена -25% и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пистолет-Пулемет 9мм</description>
	<value>700</value>
	<weight>10.5/1.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>160/1900</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		SMG, 9mm
		<img data-src="http://weapons.gurps.ru/img/157.png">
		Для примера приведен Bergmann MP18

Гражданская полуавтоматическая версия отличается - SS 3, цена -25% и +1 к LC.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Пистолет-Пулемет 9мм</description>
	<value>1200</value>
	<weight>7.5/1.2</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>160/1900</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		SMG, 9mm
		<img data-src="http://weapons.gurps.ru/img/168.png">
		Для примера приведен H&amp;K MP5A3

Гражданская полуавтоматическая версия отличается - SS 3, цена -25% и +1 к LC.
	</description-loc>
</equipment>
	
	<equipment version="3">
	<description>Короткоствольный револьвер .38</description>
	<value>250</value>
	<weight>1.5/0.2</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+2 pi</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>120/1250</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-1</bulk>
		<recoil>3</recoil>
		<ammo>.38</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Snub Revolver, .38
		<img data-src="http://weapons.gurps.ru/img/46.png">
		Для примера приведен револьвер S&amp;W Model 36
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Соллереты</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>150</value>
		<weight>7</weight>
		<reference>B284</reference>
		<categories>
			<category>Обувь</category>
		</categories>
		<dr_bonus>
			<location>feet</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Sollerets
<img data-src="lib/img/151720955650.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня комплект</description>
		<tech_level>9</tech_level>
		<legality_class>2</legality_class>
		<value>20000</value>
		<weight>45</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>50</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>30</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Space Armor
<img data-src="lib/img/151680078382.png">
Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).



</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня комплект</description>
		<tech_level>10</tech_level>
		<legality_class>2</legality_class>
		<value>20000</value>
		<weight>45</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>75</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>45</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Space Armor
<img data-src="lib/img/151680078382.png">
Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).


</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня комплект</description>
		<tech_level>11</tech_level>
		<legality_class>2</legality_class>
		<value>20000</value>
		<weight>45</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>100</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>60</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Space Armor
<img data-src="lib/img/151680078382.png">
Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме

Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).



</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня, Шлем</description>
		<tech_level>9</tech_level>
		<legality_class>2</legality_class>
		<value>3000</value>
		<weight>7</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>30</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>40</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>30</amount>
		</dr_bonus>
	<description-loc>Space Armor Helmet
<img data-src="lib/img/151687124129.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня, Шлем</description>
		<tech_level>10</tech_level>
		<legality_class>2</legality_class>
		<value>3000</value>
		<weight>7</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>45</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>45</amount>
		</dr_bonus>
	<description-loc>Space Armor Helmet
<img data-src="lib/img/151687124129.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космическая броня, Шлем</description>
		<tech_level>11</tech_level>
		<legality_class>2</legality_class>
		<value>3000</value>
		<weight>7</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>60</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>80</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>60</amount>
		</dr_bonus>
	<description-loc>Space Armor Helmet
<img data-src="lib/img/151680078382.png">
Двойное DR: используйте большее значение DR только при атаке в торс (бронежилет), череп (головной убор), или нижняя часть ступни (обувь).

Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космический шлем</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>25000</value>
		<weight>10</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>3</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>3</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Space Helmet
<img data-src="lib/img/151721782377.png">Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до ТУ9 также дает Нет периферического зрения.

Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Космический скафандр комплект</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>2000000</value>
		<weight>225</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>2</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>2</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Space Suit
<img data-src="lib/img/151721779858.png">
Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

DR скафандра применим только против разъедающего или обжигающих повреждений.

Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Копье</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>4</weight>
		<reference>B273</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>9</strength>
			<usage>Thrown</usage>
			<accuracy>+2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Spear
<img data-src="http://weapons.gurps.ru/img/437.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Прялка</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>40</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Spinning Wheel
<img data-src="lib/img/151721605964.png">
Прядет пряжу в шесть раз быстрее
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Шпоры</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<reference>B289</reference>
		<notes>+1 к контролю животного</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>Spurs
<img data-src="lib/img/151670729771.png"></description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Шпионский фотоаппарат</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<reference>B289</reference>
		<notes>На 36 фото, использует микропленку</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Spy Camera
<img data-src="lib/img/151721471447.png">
</description-loc><weight></weight></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Праща-ложка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B276</reference>
		<ranged_weapon>
			<damage>sw+1 pi</damage>
			<strength>7†</strength>
			<accuracy>1</accuracy>
			<range>x10/x15</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Staff Sling
<img data-src="http://weapons.gurps.ru/img/475.png">Может стрелять камнями (ТУ0) или свинцовыми шариками (ТУ2). В последнем случае получает +1к повреждению и удвоенную дальность.

Свинцовый шарик для пращи - 0.1$. Камни для пращи бесплатны
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Стальной нагрудник</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>500</value>
		<weight>18</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Steel Breastplate
<img data-src="http://weapons.gurps.ru/img/2071.png">
Частичное прикрытие: защищают только спереди
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Стальная кираса</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>1300</value>
		<weight>35</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>6</amount>
		</dr_bonus>
	<description-loc>Steel Corselet
<img data-src="http://weapons.gurps.ru/img/2071.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Стальная кираса</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>900</value>
		<weight>30</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>5</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>5</amount>
		</dr_bonus>
	<description-loc>Steel Laminate Plate
<img data-src="http://weapons.gurps.ru/img/2071.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Стальная каска</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>3</weight>
		<reference>B285</reference>
		<categories>
			<category>Шлемы</category>
		</categories>
		<dr_bonus>
			<location>skull</location>
			<amount>4</amount>
		</dr_bonus>
	<description-loc>Steel Pot
<img data-src="http://weapons.gurps.ru/img/348.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Стремена</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<weight>20</weight>
		<reference>B289</reference>
		<notes>Делают управление лошадью легче (премия +1). Требуются для использования умения Пика (Lance)</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>Stirrups
<img data-src="lib/img/151670748953.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Юбка из клепаной кожи</description>
		<tech_level>1</tech_level>
		<legality_class>-</legality_class>
		<value>60</value>
		<weight>4</weight>
		<reference>B283</reference>
		<categories>
			<category>Броня, конечности</category>
		</categories>
		<dr_bonus>
			<location>groin</location>
			<amount>3</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>3</amount>
		</dr_bonus>
	<description-loc>Studded Leather Skirt
<img data-src="http://weapons.gurps.ru/img/2068.png">
Раздельное DR: используйте меньшее значение против дробящих (cr) атак
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Электрошокер</description>
		<tech_level>8</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>1</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>HT-3(0.5) aff</damage>
			<strength>2</strength>
			<reach>C,1</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Stun Gun
<img data-src="http://weapons.gurps.ru/img/384.png">
Если бросок HT провален, цель оглушена на время касания оружия плюс 20-HT секунд, а затем может сделать бросок HT-3, чтобы прийти в себя.

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Переносная лаборатория</description>
		<legality_class>4</legality_class>
		<value>3000</value>
		<weight>10</weight>
		<reference>B289</reference>
		<notes>@Химия, Суд Мед экспертиза и т.п.@</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Suitcase Lab
<img data-src="lib/img/151721612588.png">
Базовое оборудование для каждого конкретного научного умения

</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Чемодан, Жесткий</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>8</weight>
		<reference>B288</reference>
		<notes>DR4, с замком</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">100 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Suitcase, Hard
<img data-src="lib/img/151720028519.png">Вмещает 100lbs. DR 4, с замком
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Хирургические  инструменты</description>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>15</weight>
		<reference>B289</reference>
		<notes>Включают скальпели, зажимы и т.п. Базовое снаряжение для умения Хирургия (Surgery)</notes>
		<categories>
			<category>Мед оборудование</category>
		</categories>
	<description-loc>Surgical Instruments
<img data-src="lib/img/151686826800.png">
<img data-src="lib/img/151686827925.png">
</description-loc></equipment>
	<equipment version="3">
	<description>Тактический Костюм</description>
	<value>3000</value>
	<weight>15</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>10</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<prereq_list all="yes">
		<skill_prereq has="yes">
			<name compare="is">nbc suit</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
	</prereq_list>
	<legality_class>2</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Suit
		<img data-src="lib/img/151696106252.png">
		Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при TL9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический Костюм</description>
	<value>3000</value>
	<weight>15</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>15</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<prereq_list all="yes">
		<skill_prereq has="yes">
			<name compare="is">nbc suit</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
	</prereq_list>
	<legality_class>2</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Suit
		<img data-src="lib/img/151696106252.png">
		Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при TL9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический Костюм</description>
	<value>3000</value>
	<weight>15</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>neck</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>legs</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>20</amount>
	</dr_bonus>
	<dr_bonus>
		<location>feet</location>
		<amount>20</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<prereq_list all="yes">
		<skill_prereq has="yes">
			<name compare="is">nbc suit</name>
			<specialization compare="is anything"></specialization>
		</skill_prereq>
	</prereq_list>
	<legality_class>2</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Suit
		<img data-src="lib/img/151696106252.png">
		Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Костюм химзащиты - но при TL9 + костюм не ограничивает DX. При ношении маски или шлема действует (Обеспечивает Фильтрацию воздуха, Защищенное обоняние и Защищенное зрение - но до TL9 также дает Нет периферического зрения), а их сочетание обеспечивает преимущество Герметичный.
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический бронежилет</description>
	<value>900</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Vest
		<img data-src="http://weapons.gurps.ru/img/325.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический бронежилет</description>
	<value>900</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>7</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>11</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>7</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>11</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>2</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Vest
		<img data-src="http://weapons.gurps.ru/img/325.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический бронежилет</description>
	<value>900</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>14</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>14</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>2</legality_class>
	<tech_level>10</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Vest
		<img data-src="http://weapons.gurps.ru/img/325.png">
	</description-loc>
</equipment>
	<equipment version="3">
	<description>Тактический бронежилет</description>
	<value>900</value>
	<weight>9</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>15</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>21</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>2</legality_class>
	<tech_level>11</tech_level>
	<categories>
		<category>Броня, тело</category>
	</categories>
	<reference>B284</reference>
	<description-loc>
		Tactical Vest
		<img data-src="http://weapons.gurps.ru/img/325.png">
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Тактический бронежилет - Антитравматические пластины</description>
		<tech_level>8</tech_level>
		<legality_class>2</legality_class>
		<value>600</value>
		<weight>9</weight>
		<reference>B284</reference>
		<categories>
			<category>Броня, тело</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>23</amount>
		</dr_bonus>
	<description-loc>Tactical Vest Trauma Plates
<img data-src="http://weapons.gurps.ru/img/325.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Телескоп</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>6</weight>
		<reference>B289</reference>
		<notes>Дает телескопическое зрение (Telescopic Vision) уровня (TL-3)</notes>
		<categories>
			<category>Оптика и датчики</category>
		</categories>
	<description-loc>Telescope
<img data-src="lib/img/151721475613.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палатка, 1-человек</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>B288</reference>
		<notes>С веревками; шесты не нужны</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Tent, 1-Man
<img data-src="lib/img/151720050116.png">
С веревками; шесты не нужны
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палатка, 2-человек</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>12</weight>
		<reference>B288</reference>
		<notes>С веревками; нужен один шест 1.8м</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Tent, 2-Man
<img data-src="lib/img/151720157639.png">
С веревками; нужен один шест 1.8м

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палатка, 4-человек</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>30</weight>
		<reference>B288</reference>
		<notes>С веревками; нужено два шеста 1.8м</notes>		
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>С веревками; нужно 2 шеста
<img data-src="lib/img/151720040895.png">
Tent, 4-Man
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Палатка, 20 человек</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>100</weight>
		<reference>B288</reference>
		<notes>С веревками; нужно 12 шестов 1.8м и 4 шеста 3м</notes>		
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Tent, 20-Man
<img data-src="lib/img/151720181644.png">
С веревками; нужно 16 шестов для установки
</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Термос</description>
		<tech_level>5</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>B288</reference>
		<notes>Вмещает 0.5 литра горячей (24 часа) или холодной (72 часа) жидкости.</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Thermos Bottle
<img data-src="lib/img/151720190465.png">
Вмещает 0.5л горячей (24 часа) или холодной (72 часа) жидкости
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Метательный топор</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>4</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Throwing Axe
<img data-src="http://weapons.gurps.ru/img/368.png">
Можно метать
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Колющий полуторный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>750</value>
		<weight>5</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Thrusting Bastard Sword
<img data-src="http://weapons.gurps.ru/img/393.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Колющий полуторный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>750</value>
		<weight>5</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>С умением Двуручный меч (Two-Handed Sword)</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Thrusting Bastard Sword
<img data-src="http://weapons.gurps.ru/img/393.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Колющий палаш</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>3</weight>
		<reference>B271</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Thrusting Broadsword
<img data-src="http://weapons.gurps.ru/img/389.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Колющий двуручный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>7</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>12†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Thrusting Greatsword
<img data-src="http://weapons.gurps.ru/img/455.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Факел</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>1</weight>
		<reference>B288</reference>
		<notes>Горит 1 час</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Torch
<img data-src="lib/img/151720198433.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Транзисторный  приемник</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Только прием, ловит радиостанции. 8 часов</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Transistor Radio
<img data-src="lib/img/151720892913.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Дорожные пайки</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.5</weight>
		<reference>B288</reference>
		<notes>Один прием пищи</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Traveler's Rations
<img data-src="lib/img/151720206952.png">
Одна порция сушеного мяса, сыра, и т.д. 
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Телевизор, мини</description>
		<tech_level>7</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>3</weight>
		<reference>B288</reference>
		<notes>5" плоский экран. 4 часа</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>TV Set, Mini
<img data-src="lib/img/151720903398.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Пишущая машинка, механическая</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>B289</reference>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Typewriter, Manual
<img data-src="lib/img/151720910412.png">
</description-loc></equipment>
	<equipment version="3">
	<description>Подствольный гранатомет, 40мм</description>
	<value>500</value>
	<weight>3.5/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d(10) cr ex[2d]</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>150/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-</bulk>
		<recoil>2</recoil>
		<ammo>40mm</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B281</reference>
	<description-loc>
		Under-Barrel, 40mm
		<img data-src="http://weapons.gurps.ru/img/231.png">
		Для примера приведен Гранатомет Подствольный ГП-25

Имеет минимальную дальность: 10 ярдов для

Можно прикрепить под стволом любой ТУ7+ винтовки или карабина. Используйте Размеры (Bulk) винтовки.

Повреждения не снижаются при достижении 1/2D-расстояния, но теряется делитель брони (10).
	</description-loc>
</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме</description>
		<tech_level>9</tech_level>
		<legality_class>4</legality_class>
		<value>10000</value>
		<weight>25</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>6</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Vacc Suit
<img data-src="lib/img/151721785898.png">
Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме</description>
		<tech_level>10</tech_level>
		<legality_class>4</legality_class>
		<value>10000</value>
		<weight>25</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>9</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
<description-loc>Vacc Suit
<img data-src="lib/img/151721785898.png">
Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме
</description-loc>
	</equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме</description>
		<tech_level>11</tech_level>
		<legality_class>4</legality_class>
		<value>10000</value>
		<weight>25</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>neck</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>torso</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>groin</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>arms</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>hands</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>legs</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>feet</location>
			<amount>12</amount>
		</dr_bonus>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">vacc suit</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	<description-loc>Vacc Suit
<img data-src="lib/img/151721785898.png">
Биомедицинские датчики позволяют удаленный контроль основных показателей состояния организма, что дает +1 к умению Диагностика при обследовании носителя брони. Кроме того, костюм снабжен климатической установкой.

Требует умения Космический скафандр. При ношении со шлемом обеспечивает преимущества Не дышит (в течение 12 часов), Защищенное обоняние, Герметичный и Жизнедеятельность в вакууме
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме, Шлем</description>
		<tech_level>9</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>5</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>6</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>6</amount>
		</dr_bonus>
	<description-loc>Vacc Suit Helmet
<img data-src="lib/img/151721787057.png">
Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме, Шлем</description>
		<tech_level>10</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>5</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>9</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>9</amount>
		</dr_bonus>
	<description-loc>Vacc Suit Helmet
<img data-src="lib/img/151721787057.png">
Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Скафандр для работы в вакууме, Шлем</description>
		<tech_level>11</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>5</weight>
		<reference>B285</reference>
		<categories>
			<category>Скафандры</category>
		</categories>
		<dr_bonus>
			<location>eyes</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>skull</location>
			<amount>12</amount>
		</dr_bonus>
		<dr_bonus>
			<location>face</location>
			<amount>12</amount>
		</dr_bonus>
	<description-loc>Vacc Suit Helmet
<img data-src="lib/img/151721787057.png">
Обеспечивает преимущества Защищенный слух, Защищенное зрение, Радио. При TL9 + добавьте Чувство направления (Требуется сигнал), Инфразрение , Адаптация к темноте 9, и (TL 8) уровней Телескопического зрения. Шлемы при TL9 + также включают головной дисплей, совместимый с «умной» оружейной электроникой (B278). Боевые скафандры также дают Гиперспектральное зрение и Лазерную связь

</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Боевое  седло</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>35</weight>
		<reference>B289</reference>
		<notes>+1 к броску, остался ли наездник в седле; 50% шанс остаться в седле даже без сознания. Со стременами.</notes>
		<categories>
			<category>Верховая езда</category>
		</categories>
	<description-loc>War Saddle
<img data-src="lib/img/151670251585.png"></description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Клевец</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>7</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw+3 imp</damage>
			<strength>12‡</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Может застрять</notes>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Warhammer
<img data-src="http://weapons.gurps.ru/img/450.png">
Может застрять; см. Кирки, B405.
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Таблетки для очистки воды</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>0.1</weight>
		<reference>B288</reference>
		<notes>B50 штук; На 1 литр каждая</notes>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Water Purification Tablets
<img data-src="lib/img/151720210390.png">
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Восковая  дощечка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>B289</reference>
		<notes>Для письма, стираемая</notes>
		<categories>
			<category>Связь и информация</category>
		</categories>
	<description-loc>Wax Tablet
<img data-src="lib/img/151672001204.png">
</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Разгрузка</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
	<description-loc>Web Gear
<img data-src="lib/img/151721676279.png">
пояс и ремни с карманами и кольцами для снаряжения
</description-loc></equipment_container>
	<equipment version="3">
	<description>Пистолет с колесцовым замком, .60</description>
	<value>200</value>
	<weight>3.25/0.01</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+1 pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>75/400</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>.60</ammo>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Оружие, Стрелковое</category>
	</categories>
	<reference>B278</reference>
	<description-loc>
		Wheel-Lock Pistol, .60
		<img data-src="http://weapons.gurps.ru/img/53.png">
		Для примера приведен Tower Sea Service
	</description-loc>
</equipment>
	<equipment_container version="3" open="yes">
		<description>Тачка</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>18</weight>
		<reference>B289</reference>
		<notes>Эффективный вес делится на 5</notes>
		<categories>
			<category>Инструменты</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">350 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Wheelbarrow
<img data-src="lib/img/151721618269.png">
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Точильный  камень</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>B289</reference>
		
		<categories>
			<category>Инструменты</category>
		</categories>
	<description-loc>Whetstone
<img data-src="lib/img/151721622008.png">
Для заточки инструмента и оржуия
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 1 ярд</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>6</strength>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 1 yard long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 2 ярда</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>4</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>7</strength>
			<reach>1-2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 2 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 3 ярда</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>8</strength>
			<reach>1-3*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 3 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 4 ярда</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>8</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>9</strength>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 4 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 5 ярдов</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>10</strength>
			<reach>1-5*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 5 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 6 ярдов</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>12</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>11</strength>
			<reach>1-6*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 6 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Кнут, 7 ярдов</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>140</value>
		<weight>14</weight>
		<reference>B274</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>12</strength>
			<reach>1-7*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Оружие, Холодное</category>
		</categories>
	<description-loc>Whip, 7 yards long
<img data-src="http://weapons.gurps.ru/img/457.png">
Много дополнительных правил - обязательно прочитайте B406
</description-loc></equipment>
	<equipment_container version="3" open="yes">
		<description>Бурдюк</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">8 lb</contained_weight_prereq>
		</prereq_list>
	<description-loc>Wineskin
<img data-src="lib/img/151720219624.png">
Вмещает 1 галлон (~4л) жидкости
</description-loc></equipment_container>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Деревянный кол</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<weight>0.5</weight>
		<reference>B272</reference>
		<melee_weapon>
			<damage>thr(0.5) imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sword!</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr(0.5) imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>+0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Оружие, Холодное</category>
			<category>Оружие, Стрелковое</category>
		</categories>
	<description-loc>Wooden Stake
<img data-src="http://weapons.gurps.ru/img/409.png">
 Можно метать
</description-loc></equipment>
	<equipment version="3">
		<quantity>1</quantity>
		<description>Наручные часы</description>
		<tech_level>6</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.075</weight>
		<reference>B288</reference>
		<categories>
			<category>Походы и выживание</category>
		</categories>
	<description-loc>Wristwatch
<img data-src="lib/img/151720222809.png">
</description-loc></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Собачья упряжка</description>
		<tech_level>0</tech_level>
		<value>400</value>
		<reference>B464</reference>
		<notes>Тягловые животные - собаки</notes>
		<transport>
			<strength_health>27†</strength_health>
			<handling>0</handling>
			<stability>2</stability>
			<health>12c</health>
			<acceleration_top_speed>6/6</acceleration_top_speed>
			<loaded_weight>0.29</loaded_weight>
			<load>0.14</load>
			<size_modifier>+1</size_modifier>
			<occupants>1</occupants>
			<dr>2</dr>
			<range>F</range>
			<locations>14DER</locations>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<specialization>Dogsled</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Animal Handling</name>
				<specialization>Dogs</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Dogsled
<img data-src="lib/img/151602849956.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Колесница</description>
		<tech_level>1</tech_level>
		<value>330</value>
		<reference>B464</reference>
		<notes>Тягловые животные - лошади</notes>
		<transport>
			<strength_health>22†</strength_health>
			<handling>0</handling>
			<stability>2</stability>
			<health>11c</health>
			<acceleration_top_speed>4/9*</acceleration_top_speed>
			<loaded_weight>0.29</loaded_weight>
			<load>0.2</load>
			<size_modifier>+1</size_modifier>
			<occupants>1+1</occupants>
			<dr>1</dr>
			<range>F</range>
			<locations>2DE2W</locations>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<specialization>Equines</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Animal Handling</name>
				<specialization>Equine</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Riding</name>
				<specialization>Equines</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Chariot
<img data-src="lib/img/151664239296.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Фургон</description>
		<tech_level>3</tech_level>
		<value>680</value>
		<reference>B464</reference>
		<notes>Тягловые животные - лошади</notes>
		<transport>
			<strength_health>35†</strength_health>
			<handling>-3</handling>
			<stability>4</stability>
			<health>12c</health>
			<acceleration_top_speed>4/8*</acceleration_top_speed>
			<loaded_weight>0.84</loaded_weight>
			<load>0.5</load>
			<size_modifier>+2</size_modifier>
			<occupants>1</occupants>
			<dr>2</dr>
			<range>F</range>
			<locations>2DE4W</locations>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<specialization>Equines</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Animal Handling</name>
				<specialization>Equine</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Riding</name>
				<specialization>Equines</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Wagon
<img data-src="lib/img/151670985235.png">
</description-loc>
	<weight></weight></equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Карета</description>
		<tech_level>3</tech_level>
		<value>11000</value>
		<reference>B464</reference>
		<notes>Тягловые животные - лошади</notes>
		<transport>
			<strength_health>53†</strength_health>
			<handling>-2</handling>
			<stability>3</stability>
			<health>12c</health>
			<acceleration_top_speed>4/9*</acceleration_top_speed>
			<loaded_weight>2.4</loaded_weight>
			<load>1.2</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+9</occupants>
			<dr>2</dr>
			<range>F</range>
			<locations>4DO4W</locations>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<specialization>Equines</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Animal Handling</name>
				<specialization>Equine</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Riding</name>
				<specialization>Equines</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Teamster</name>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Coach
<img data-src="lib/img/151593063540.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Паровоз</description>
		<tech_level>5</tech_level>
		<value>45000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>152</strength_health>
			<handling>-2</handling>
			<stability>5</stability>
			<health>11</health>
			<acceleration_top_speed>1/35‡</acceleration_top_speed>
			<loaded_weight>28</loaded_weight>
			<load>0.2</load>
			<size_modifier>+5</size_modifier>
			<occupants>1+1</occupants>
			<dr>8</dr>
			<range>700</range>
			<locations>8W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Locomotive</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Locomotive
<img data-src="lib/img/151724757726.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Родстер</description>
		<tech_level>6</tech_level>
		<value>3600</value>
		<reference>B464</reference>
		<transport>
			<strength_health>42</strength_health>
			<handling>-1</handling>
			<stability>3</stability>
			<health>9f</health>
			<acceleration_top_speed>2/22*</acceleration_top_speed>
			<loaded_weight>0.85</loaded_weight>
			<load>0.25</load>
			<size_modifier>+2</size_modifier>
			<occupants>1+1</occupants>
			<dr>4</dr>
			<range>200</range>
			<locations>O4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Roadster
<img data-src="lib/img/151724779887.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Седан</description>
		<tech_level>6</tech_level>
		<value>8000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>46</strength_health>
			<handling>0</handling>
			<stability>4</stability>
			<health>10f</health>
			<acceleration_top_speed>3/30*</acceleration_top_speed>
			<loaded_weight>1.3</loaded_weight>
			<load>0.5</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+3</occupants>
			<dr>5</dr>
			<range>360</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Sedan
<img data-src="lib/img/151724806572.png">
</description-loc>
	<weight></weight></equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Джип</description>
		<tech_level>6</tech_level>
		<value>10000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>52</strength_health>
			<handling>0</handling>
			<stability>3</stability>
			<health>11f</health>
			<acceleration_top_speed>2/32</acceleration_top_speed>
			<loaded_weight>1.6</loaded_weight>
			<load>0.4</load>
			<size_modifier>+2</size_modifier>
			<occupants>1+3</occupants>
			<dr>4</dr>
			<range>375</range>
			<locations>O4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Jeep
<img data-src="lib/img/151724811552.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Пикап</description>
		<tech_level>7</tech_level>
		<value>20000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>55</strength_health>
			<handling>0</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>3/50</acceleration_top_speed>
			<loaded_weight>2.2</loaded_weight>
			<load>0.85</load>
			<size_modifier>+3</size_modifier>
			<occupants>2</occupants>
			<dr>5</dr>
			<range>450</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Pickup Truck
<img data-src="lib/img/151724823701.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Седан</description>
		<tech_level>7</tech_level>
		<value>15000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>53</strength_health>
			<handling>0</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>2/55*</acceleration_top_speed>
			<loaded_weight>1.8</loaded_weight>
			<load>0.6</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+4</occupants>
			<dr>5</dr>
			<range>500</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Sedan
<img data-src="lib/img/151724836824.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Автофургон</description>
		<tech_level>7</tech_level>
		<value>25000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>68</strength_health>
			<handling>-1</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>2/45*</acceleration_top_speed>
			<loaded_weight>3.5</loaded_weight>
			<load>1</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+7</occupants>
			<dr>4</dr>
			<range>650</range>
			<locations>g4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Van
<img data-src="lib/img/151724847038.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Спорткар</description>
		<tech_level>7</tech_level>
		<value>85000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>57</strength_health>
			<handling>+1</handling>
			<stability>4</stability>
			<health>10f</health>
			<acceleration_top_speed>5/75*</acceleration_top_speed>
			<loaded_weight>1.8</loaded_weight>
			<load>0.4</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+3</occupants>
			<dr>4</dr>
			<range>500</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc><img data-src="lib/img/151728228906.png">
Sports Car</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Лимузин</description>
		<tech_level>8</tech_level>
		<value>30000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>57</strength_health>
			<handling>0</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>3/57*</acceleration_top_speed>
			<loaded_weight>2.1</loaded_weight>
			<load>0.6</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+4</occupants>
			<dr>5</dr>
			<range>500</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Luxury Car
<img data-src="lib/img/151728240802.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Внедорожник</description>
		<tech_level>8</tech_level>
		<value>45000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>68</strength_health>
			<handling>-1</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>3/50</acceleration_top_speed>
			<loaded_weight>4</loaded_weight>
			<load>1.5</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+4</occupants>
			<dr>5</dr>
			<range>400</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Automobile</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>SUV
<img data-src="lib/img/151728269845.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>2.5-тонник</description>
		<tech_level>6</tech_level>
		<value>17000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>88</strength_health>
			<handling>-1</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>1/24*</acceleration_top_speed>
			<loaded_weight>8.5</loaded_weight>
			<load>3</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+2</occupants>
			<dr>5</dr>
			<range>375</range>
			<locations>G6W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Heavy Wheeled</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>2 1/2-Ton Truck
<img data-src="lib/img/151728309903.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Автобус</description>
		<tech_level>7</tech_level>
		<value>120000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>100</strength_health>
			<handling>-2</handling>
			<stability>4</stability>
			<health>11f</health>
			<acceleration_top_speed>1/30*</acceleration_top_speed>
			<loaded_weight>14.7</loaded_weight>
			<load>6.7</load>
			<size_modifier>+6</size_modifier>
			<occupants>1+66</occupants>
			<dr>4</dr>
			<range>400</range>
			<locations>G4W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Heavy Wheeled</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Bus
<img data-src="lib/img/151728317730.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Тягач без прицепа</description>
		<tech_level>8</tech_level>
		<value>60000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>104</strength_health>
			<handling>-1</handling>
			<stability>5</stability>
			<health>12f</health>
			<acceleration_top_speed>2/55*</acceleration_top_speed>
			<loaded_weight>10.3</loaded_weight>
			<load>0.3</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+2</occupants>
			<dr>5</dr>
			<range>1200</range>
			<locations>G6W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Heavy Wheeled</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Semi-Truck
<img data-src="lib/img/151728321728.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Тягач с прицепом</description>
		<tech_level>8</tech_level>
		<value>60000</value>
		<reference>B464</reference>
		<notes> У прицепа HP 100†, Load: 24, SM +5, DR 3.</notes>		
		<transport>
			<strength_health>104</strength_health>
			<handling>-3</handling>
			<stability>4</stability>
			<health>12f</health>
			<acceleration_top_speed>1/30*</acceleration_top_speed>
			<loaded_weight>10.3</loaded_weight>
			<load>0.3</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+2</occupants>
			<dr>5</dr>
			<range>1200</range>
			<locations>G6W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Heavy Wheeled</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Semi-Truck
<img data-src="lib/img/151728330216.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Тяж. мотоцикл</description>
		<tech_level>6</tech_level>
		<value>1500</value>
		<reference>B464</reference>
		<transport>
			<strength_health>33</strength_health>
			<handling>+1</handling>
			<stability>2</stability>
			<health>10f</health>
			<acceleration_top_speed>5/32*</acceleration_top_speed>
			<loaded_weight>0.4</loaded_weight>
			<load>0.1</load>
			<size_modifier>0</size_modifier>
			<occupants>1</occupants>
			<dr>4</dr>
			<range>200</range>
			<locations>E2W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Motorcycle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Hvy. Bike
<img data-src="lib/img/151728347356.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Мотороллер</description>
		<tech_level>7</tech_level>
		<value>1000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>29</strength_health>
			<handling>+1</handling>
			<stability>2</stability>
			<health>10f</health>
			<acceleration_top_speed>3/27*</acceleration_top_speed>
			<loaded_weight>0.3</loaded_weight>
			<load>0.1</load>
			<size_modifier>0</size_modifier>
			<occupants>1</occupants>
			<dr>3</dr>
			<range>190</range>
			<locations>E2W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Motorcycle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Scooter
<img data-src="lib/img/151728350351.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Тяж. мотоцикл</description>
		<tech_level>7</tech_level>
		<value>8000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>33</strength_health>
			<handling>+1</handling>
			<stability>2</stability>
			<health>11f</health>
			<acceleration_top_speed>8/55*</acceleration_top_speed>
			<loaded_weight>0.5</loaded_weight>
			<load>0.2</load>
			<size_modifier>0</size_modifier>
			<occupants>1+1</occupants>
			<dr>4</dr>
			<range>200</range>
			<locations>E2W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Motorcycle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Hvy. Bike
<img data-src="lib/img/151728362460.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Спортбайк</description>
		<tech_level>8</tech_level>
		<value>11000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>30</strength_health>
			<handling>+2</handling>
			<stability>2</stability>
			<health>10f</health>
			<acceleration_top_speed>9/78*</acceleration_top_speed>
			<loaded_weight>0.42</loaded_weight>
			<load>0.2</load>
			<size_modifier>0</size_modifier>
			<occupants>1+1</occupants>
			<dr>3</dr>
			<range>150</range>
			<locations>E2W</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Motorcycle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>Sports Bike
<img data-src="lib/img/151728367520.png">
</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>БМП</description>
		<tech_level>7</tech_level>
		<value>120000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>111</strength_health>
			<handling>-3</handling>
			<stability>5</stability>
			<health>11f</health>
			<acceleration_top_speed>1/20</acceleration_top_speed>
			<loaded_weight>12.5</loaded_weight>
			<load>1.6</load>
			<size_modifier>+4</size_modifier>
			<occupants>2+11S</occupants>
			<dr>50/35</dr>
			<range>300</range>
			<locations>2CX</locations>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<specialization>Tracked</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Driving</name>
				<modifier>-5</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
	<description-loc>APC
<img data-src="lib/img/151728411073.png"><br>
БМП означает «Бронированная машина пехоты». Большее DR применяется только при фронтальной атаке. На крыше устанавливается пулемёт калибра 7,62мм либо .50 (12,7мм)
	</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Каноэ</description>
		<tech_level>0</tech_level>
		<value>200</value>
		<reference>B464</reference>
		<transport>
			<strength_health>23†</strength_health>
			<handling>+1</handling>
			<stability>1</stability>
			<health>12c</health>
			<acceleration_top_speed>2/2</acceleration_top_speed>
			<loaded_weight>0.3</loaded_weight>
			<load>0.2</load>
			<size_modifier>+1</size_modifier>
			<occupants>2</occupants>
			<dr>2</dr>
			<range>F</range>
			<locations>O</locations>
			<draft>3</draft>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Unpowered</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Motorboat</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Canoe
<img data-src="lib/img/151602882248.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Надувная лодка</description>
		<tech_level>7</tech_level>
		<value>2000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>20</strength_health>
			<handling>+2</handling>
			<stability>2</stability>
			<health>11</health>
			<acceleration_top_speed>2/12</acceleration_top_speed>
			<loaded_weight>0.6</loaded_weight>
			<load>0.5</load>
			<size_modifier>+1</size_modifier>
			<occupants>1+4</occupants>
			<dr>2</dr>
			<range>100</range>
			<locations>O</locations>
			<draft>2</draft>			
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Motorboat</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Unpowered</specialization>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Inflatable
<img data-src="lib/img/151728443214.png">
</description-loc>
	<weight></weight></equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Катер</description>
		<tech_level>7</tech_level>
		<value>18000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>50</strength_health>
			<handling>+1</handling>
			<stability>3</stability>
			<health>11f</health>
			<acceleration_top_speed>3/20</acceleration_top_speed>
			<loaded_weight>2</loaded_weight>
			<load>1</load>
			<size_modifier>+2</size_modifier>
			<occupants>1+9</occupants>
			<dr>3</dr>
			<range>200</range>
			<locations>O</locations>
			<draft>3</draft>			
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Motorboat</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Unpowered</specialization>
				<modifier>-3</modifier>
			</default>		
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Speedboat
<img data-src="lib/img/151728455695.png">
</description-loc>
	<weight></weight></equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Пентеконтор</description>
		<tech_level>2</tech_level>
		<value>14000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>85†</strength_health>
			<handling>-4</handling>
			<stability>3</stability>
			<health>11c</health>
			<acceleration_top_speed>1/5</acceleration_top_speed>
			<loaded_weight>12.5</loaded_weight>
			<load>7.5</load>
			<size_modifier>+8</size_modifier>
			<occupants>55</occupants>
			<dr>3</dr>
			<range>F</range>
			<locations>MO</locations>
			<draft>6</draft>			
			<default>
				<type>Skill</type>
				<name>Shiphandling</name>
				<specialization>Ship</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Seamanship</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-5</modifier>
			</default>	
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Penteconter
<img data-src="lib/img/151728463874.png">
Пентеконтер – греческая военная галера с парусом и одним рядом вёсел, была любима налётчиками и пиратами.
Вёсел и гребцов – 50. При использовании паруса Range становится «-» , а Move – 1/4 при попутном ветре.
Имеет бронзовый таран, добавляющий +1 урона за кубик, при столкновении.
		</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Когг</description>
		<tech_level>3</tech_level>
		<value>23000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>147†</strength_health>
			<handling>-3</handling>
			<stability>4</stability>
			<health>12c</health>
			<acceleration_top_speed>0.1/4</acceleration_top_speed>
			<loaded_weight>85</loaded_weight>
			<load>60</load>
			<size_modifier>+7</size_modifier>
			<occupants>18</occupants>
			<dr>5</dr>
			<range>-</range>
			<locations>M</locations>
			<draft>13</draft>			
			<default>
				<type>Skill</type>
				<name>Shiphandling</name>
				<specialization>Ship</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Seamanship</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-5</modifier>
			</default>	
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Cog
<img data-src="lib/img/151728471882.png">
Одномачтовый средневековый парусный корабль.
Парусный. Вес указан вместе с балластом.
		</description-loc>
	<weight></weight></equipment>		
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Пароход</description>
		<tech_level>6</tech_level>
		<value>15000000</value>
		<reference>B464</reference>
		<transport>
			<strength_health>750</strength_health>
			<handling>-3</handling>
			<stability>6</stability>
			<health>11f</health>
			<acceleration_top_speed>0.01/6</acceleration_top_speed>
			<loaded_weight>14000</loaded_weight>
			<load>9000</load>
			<size_modifier>+10</size_modifier>
			<occupants>41+29A</occupants>
			<dr>30</dr>
			<range>7200</range>
			<locations>g2S</locations>
			<draft>25</draft>			
			<default>
				<type>Skill</type>
				<name>Shiphandling</name>
				<specialization>Ship</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Seamanship</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Large Powerboat</specialization>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boating</name>
				<specialization>Sailboat</specialization>
				<modifier>-5</modifier>
			</default>	
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Tramp Steamer
<img data-src="lib/img/151728489274.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Биплан «Барншторм»</description>
		<tech_level>6</tech_level>
		<value>55000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>43</strength_health>
			<handling>+2</handling>
			<stability>3</stability>
			<health>10f</health>
			<acceleration_top_speed>2/37</acceleration_top_speed>
			<loaded_weight>0.9</loaded_weight>
			<load>0.2</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+1</occupants>
			<dr>3</dr>
			<range>85</range>
			<locations>O2WWi</locations>
			<stall>23</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Light Airplane</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>“Barnstormer” Biplane
<img data-src="lib/img/151728502612.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Лёгкий моноплан</description>
		<tech_level>7</tech_level>
		<value>150000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>45</strength_health>
			<handling>+2</handling>
			<stability>3</stability>
			<health>10f</health>
			<acceleration_top_speed>3/70</acceleration_top_speed>
			<loaded_weight>1.15</loaded_weight>
			<load>0.3</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+1</occupants>
			<dr>3</dr>
			<range>500</range>
			<locations>G2WWi</locations>
			<stall>25</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Light Airplane</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Light Monoplane
<img data-src="lib/img/151728510986.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Дирижабль</description>
		<tech_level>6</tech_level>
		<value>3000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>120</strength_health>
			<handling>-4</handling>
			<stability>3</stability>
			<health>10</health>
			<acceleration_top_speed>1/38</acceleration_top_speed>
			<loaded_weight>18</loaded_weight>
			<load>4</load>
			<size_modifier>+10</size_modifier>
			<occupants>10A</occupants>
			<dr>1</dr>
			<range>2300</range>
			<locations>S</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Lighter-Than-Air</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Blimp
<img data-src="lib/img/151728513750.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Двухмоторный транспорт</description>
		<tech_level>6</tech_level>
		<value>340000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>100</strength_health>
			<handling>-2</handling>
			<stability>3</stability>
			<health>12f</health>
			<acceleration_top_speed>2/114</acceleration_top_speed>
			<loaded_weight>12.8</loaded_weight>
			<load>3</load>
			<size_modifier>+7</size_modifier>
			<occupants>2+21</occupants>
			<dr>4</dr>
			<range>1500</range>
			<locations>g3WWi</locations>
			<stall>35</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Heavy Airplane</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Twin-Prop Transport
<br><img data-src="lib/img/151728535801.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Реактивный лайнер</description>
		<tech_level>7</tech_level>
		<value>10000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>84</strength_health>
			<handling>0</handling>
			<stability>3</stability>
			<health>11f</health>
			<acceleration_top_speed>4/275</acceleration_top_speed>
			<loaded_weight>9.2</loaded_weight>
			<load>1.6</load>
			<size_modifier>+6</size_modifier>
			<occupants>2+6P</occupants>
			<dr>5</dr>
			<range>1300</range>
			<locations>G3WWi</locations>
			<stall>55</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Heavy Airplane</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Business Jet
<img data-src="lib/img/151728539578.png">
</description-loc>
	<weight></weight></equipment>		
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Лёгкий вертолёт</description>
		<tech_level>7</tech_level>
		<value>400000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>47</strength_health>
			<handling>+2</handling>
			<stability>2</stability>
			<health>10f</health>
			<acceleration_top_speed>2/90</acceleration_top_speed>
			<loaded_weight>1.5</loaded_weight>
			<load>0.5</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+3</occupants>
			<dr>3</dr>
			<range>225</range>
			<locations>GH3Wr</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Helicopter</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Light Helicopter
<img data-src="lib/img/151728556239.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Вертолёт</description>
		<tech_level>7</tech_level>
		<value>2000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>70</strength_health>
			<handling>0</handling>
			<stability>2</stability>
			<health>10f</health>
			<acceleration_top_speed>2/65</acceleration_top_speed>
			<loaded_weight>4.7</loaded_weight>
			<load>1.4</load>
			<size_modifier>+5</size_modifier>
			<occupants>2+12</occupants>
			<dr>3</dr>
			<range>300</range>
			<locations>gH2R</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Helicopter</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Utility Helicopter
<img data-src="lib/img/151728563800.png">
</description-loc>
	<weight></weight></equipment>	

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Вертолёт</description>
		<tech_level>8</tech_level>
		<value>8000000</value>
		<reference>B465</reference>
		<notes>Винт DR 20, остальной вертолёт – DR 5.</notes>		
		<transport>
			<strength_health>87</strength_health>
			<handling>+1</handling>
			<stability>2</stability>
			<health>11f</health>
			<acceleration_top_speed>3/110</acceleration_top_speed>
			<loaded_weight>10</loaded_weight>
			<load>3.5</load>
			<size_modifier>+5</size_modifier>
			<occupants>3+14</occupants>
			<dr>5/20</dr>
			<range>370</range>
			<locations>gH3W</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Helicopter</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Utility Helicopter
<img data-src="lib/img/151728586114.png">
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Летающая машина</description>
		<tech_level>9</tech_level>
		<value>500000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>45</strength_health>
			<handling>+2</handling>
			<stability>3</stability>
			<health>11f</health>
			<acceleration_top_speed>4/190</acceleration_top_speed>
			<loaded_weight>1.2</loaded_weight>
			<load>0.4</load>
			<size_modifier>+3</size_modifier>
			<occupants>1+3P</occupants>
			<dr>4</dr>
			<range>900</range>
			<locations>G4W</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Vertol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Contragravity</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Helicopter</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Air Car
<img data-src="lib/img/151728595222.png">
<img data-src="lib/img/151728596413.png">
<img data-src="lib/img/151728621487.png">


</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Байк-антиграв</description>
		<tech_level>^</tech_level>
		<value>25000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>30</strength_health>
			<handling>+4</handling>
			<stability>2</stability>
			<health>11</health>
			<acceleration_top_speed>20/80</acceleration_top_speed>
			<loaded_weight>0.4</loaded_weight>
			<load>0.2</load>
			<size_modifier>0</size_modifier>
			<occupants>1+1</occupants>
			<dr>3</dr>
			<range>1000</range>
			<locations>E</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Contragravity</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Vertol</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Grav Bike
<img data-src="lib/img/151728604614.png">
<img data-src="lib/img/151728608853.png">
<img data-src="lib/img/151728625624.png">


</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Джи-антиграв</description>
		<tech_level>^</tech_level>
		<value>400000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>50</strength_health>
			<handling>+3</handling>
			<stability>3</stability>
			<health>12</health>
			<acceleration_top_speed>10/100</acceleration_top_speed>
			<loaded_weight>2</loaded_weight>
			<load>1</load>
			<size_modifier>+4</size_modifier>
			<occupants>1+5</occupants>
			<dr>4</dr>
			<range>2000</range>
			<locations>O</locations>
			<stall>0</stall>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Contragravity</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Vertol</specialization>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-5</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Grav Jeep
<img data-src="lib/img/151728638060.png">
<img data-src="lib/img/151728653751.png">

</description-loc>
	<weight></weight></equipment>

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Орбитальный клипер</description>
		<tech_level>9</tech_level>
		<value>350000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>170</strength_health>
			<handling>-2</handling>
			<stability>3</stability>
			<health>10fx</health>
			<acceleration_top_speed>30/9000 (3G)</acceleration_top_speed>
			<loaded_weight>515</loaded_weight>
			<load>10</load>
			<size_modifier>+9</size_modifier>
			<occupants>2+4SV</occupants>
			<dr>4</dr>
			<locations>-</locations>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Aerospace</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>High-Performance Airplane</specialization>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<modifier>-4</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Orbital Clipper
<img data-src="lib/img/151728660225.png">
Орбитальный клипер является заменой космического челнока, он может подниматься на орбиту, снижаться в атмосферу и подниматься обратно. Использует обычный Ньютоновский космический полёт. На TL10+ цена падает до $70M.</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Шатл</description>
		<tech_level>^</tech_level>
		<value>35000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>136</strength_health>
			<handling>+2</handling>
			<stability>4</stability>
			<health>12</health>
			<acceleration_top_speed>20/c (2G)</acceleration_top_speed>
			<loaded_weight>100</loaded_weight>
			<load>25</load>
			<size_modifier>+6</size_modifier>
			<occupants>1+10SV</occupants>
			<dr>100</dr>
			<locations>3Rr</locations>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>High-Performance Spaecraft</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Aerospace</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Low-Performance Spacecraft</specialization>
				<modifier>-2</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Shuttlecraft
<img data-src="lib/img/151728665095.png">
Использует нереактивные либо гравитационные двигатели для ускорения до скорости света (c) – либо её части, выбранной Мастером в качестве предела. Межзвёздные перемещения и силовые поля по усмотрению Мастера.</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Межзвездный транспорт</description>
		<tech_level>^</tech_level>
		<value>100000000</value>
		<reference>B465</reference>
		<transport>
			<strength_health>500</strength_health>
			<handling>0</handling>
			<stability>5</stability>
			<health>11</health>
			<acceleration_top_speed>15/c (1.5G)</acceleration_top_speed>
			<loaded_weight>1000</loaded_weight>
			<load>400</load>
			<size_modifier>+9</size_modifier>
			<occupants>2+18ASV</occupants>
			<dr>100</dr>
			<locations>3Rr2t</locations>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>High-Performance Spaecraft</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Aerospace</specialization>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Piloting</name>
				<specialization>Low-Performance Spacecraft</specialization>
				<modifier>-2</modifier>
			</default>
		</transport>
		<categories>
			<category>Транспорт</category>
		</categories>
		<description-loc>Star Freighter
<img data-src="lib/img/151728669483.png">
Использует нереактивные либо гравитационные двигатели для ускорения до скорости света (c) – либо её части, выбранной Мастером в качестве предела. Межзвёздные перемещения и силовые поля по усмотрению Мастера.

Имеет гиперспектральные сенсоры (даёт преимущества Гиперспектральное зрение, Круговой обзор и Телескопическое зрение 10) и радар (даёт преимущества Радар на 500.000 ярдов и Захват цели). Есть также две независимые башни, куда за дополнительную плату ($0,5M за штуку) можно установит лазерные пушки: Dmg 6d×5(2) burn, Acc 10, Range 100.000/300.000, Rof 4, Rcl 1.
</description-loc>
	<weight></weight></equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Верблюд</description>
		<tech_level>0</tech_level>
		<value>1500</value>
		<weight>1400</weight>		
		<reference>B459</reference>
		<notes>ST 22; DX 9; IQ 3; HT 12; Will 11; Per 12; Speed 5.25; Dodge 8; Move 7(Наземная скорость 14); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Cammel
<img data-src="lib/img/151729339217.png">
Эти уроженцы пустынь могут продержаться до четырех дней без воды. Их упрямый нрав дает штраф -4 к навыку Обращения с животными.

Особенности: Вспыльчивость (12);  Домашнее животное; Увеличенное передвижение (Наземная скорость 14); Копыта; Периферийное зрение; Четырехногое животное; Пониженное потребление 3 (Только вода); Упрямство; Слабый укус.
Умения: Выживание (Пустыня)-12.
</description-loc>
	</equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Осел</description>
		<tech_level>0</tech_level>
		<value>1000</value>
		<weight>500</weight>		
		<reference>B459</reference>
		<notes>ST 15; DX 10; IQ 3; HT 11; Will 11; Per 12; Speed 5.25; Dodge 8; Move 5(Наземная скорость 8); SM +1 (2 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Donkey
<img data-src="lib/img/151729341357.png">
Крепкий и выносливый, но слишком мал, чтобы взрослый мог на нем ездить.

Особенности: Домашнее животное; Увеличенное передвижение 1/2 (Наземная скорость 8); Копыта; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Небольшой мул</description>
		<tech_level>0</tech_level>
		<value>1000</value>
		<weight>800</weight>		
		<reference>B460</reference>
		<notes>ST 18; DX 10; IQ 3; HT 12; Will 12; Per 12; Speed 5.5; Dodge 8; Move 5(Наземная скорость 8); SM +1 (2 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Small Mule
<img data-src="lib/img/151729355126.png">

Особенности: Бесплодие; Домашнее животное; Увеличенное передвижение 1/2 (Наземная скорость 8); Копыта; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Крупный мул</description>
		<tech_level>0</tech_level>
		<value>2000</value>
		<weight>1400</weight>		
		<reference>B460</reference>
		<notes>ST 22; DX 10; IQ 3; HT 12; Will 12; Per 12; Speed 5.5; Dodge 8; Move 6(Наземная скорость 9); SM +1 (2 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Large Mule
<img data-src="lib/img/151729381463.png">
Особенности: Бесплодие; Домашнее животное; Увеличенное передвижение 1/2 (Наземная скорость 9); Копыта; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>	

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Вол</description>
		<tech_level>0</tech_level>
		<value>1500</value>
		<weight>2500</weight>		
		<reference>B460</reference>
		<notes>ST 27; DX 8; IQ 3; HT 12; Will 12; Per 10; Speed 5; Dodge 8; Move 4(Наземная скорость 8); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Oxen
<img data-src="lib/img/151729347991.png">
Волов используют для перевозки тяжелых грузов и  работы в поле. Они выносливее и легче содержатся, чем лошади.

Особенности: Домашнее животное; СП 2 (Только череп); Увеличенное передвижение 1 (Наземная скорость 8); Проникающая атака (Рога); Евнух; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Пони</description>
		<tech_level>0</tech_level>
		<value>1500</value>
		<weight>800</weight>		
		<reference>B459</reference>
		<notes>ST 18; DX 10; IQ 3; HT 11; Will 11; Per 12; Speed 5.25; Dodge 8; Move 7(Наземная скорость 14); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Pony
<img data-src="lib/img/151729382968.png">
Особенности: Домашнее животное; Увеличенное передвижение 1 (Наземная скорость 14); Копыта; Периферийное зрение; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>	

	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Скаковая лошадь</description>
		<tech_level>0</tech_level>
		<value>1200</value>
		<weight>1200</weight>		
		<reference>B460</reference>
		<notes>ST 21; DX 9; IQ 3; HT 11; Will 10; Per 12; Speed 5; Dodge 8; Move 6(Наземная скорость 12); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Saddle Horse
<img data-src="lib/img/151729336727.png">
Обычная лошадь для езды.

Особенности: Домашнее животное; Увеличенное передвижение 1 (Наземная скорость 12); Копыта; Периферийное зрение; Четырехногое животное; Слабый укус.
Умения: Скакун-11
</description-loc>
	</equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Ломовая лошадь</description>
		<tech_level>0</tech_level>
		<value>2000</value>
		<weight>2000</weight>		
		<reference>B459</reference>
		<notes>ST 25; DX 9; IQ 3; HT 12; Will 10; Per 11; Speed 5.25; Dodge 8; Move 6(Наземная скорость 16); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Draft Horse
<img data-src="lib/img/151729343504.png">
Особенности: Домашнее животное; Увеличенное передвижение 1 (Наземная скорость 12); Копыта; Периферийное зрение; Четырехногое животное; Слабый укус.
</description-loc>
	</equipment>
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Кавалерийская лошадь</description>
		<tech_level>0</tech_level>
		<value>4000</value>
		<weight>1400</weight>		
		<reference>B459</reference>
		<notes>ST 22; DX 9; IQ 3; HT 11; Will 11; Per 12; Speed 5; Dodge 9; Move 8(Наземная скорость 16); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Cavalry Horse
<img data-src="lib/img/151729316140.png">
Легкая боевая лошадь.

Особенности: Боевые рефлексы; Домашнее животное; Увеличенное передвижение (Наземная скорость 16); Копыта; Периферийное зрение; Четырехногое животное; Слабый укус.
Умения: Драка-10; Скакун-12.
</description-loc>
	</equipment>
	

	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Тяжелая боевая лошадь</description>
		<tech_level>0</tech_level>
		<value>5000</value>
		<weight>1900</weight>		
		<reference>B460</reference>
		<notes>ST 24; DX 9; IQ 3; HT 12; Will 11; Per 12; Speed 5.25; Dodge 9; Move 7(Наземная скорость 14); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Heavy Warhorse
<img data-src="lib/img/151729333786.png">
Особенности: Боевые рефлексы; Домашнее животное; Копыта; Периферийное зрение; Четырехногое животное; Слабый укус; Вспыльчивость (12) и Увеличенное передвижение 1 (Наземная скорость 14).
Умения: Драка-12; Скакун-13.

</description-loc>
	</equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Скаковая лошадь</description>
		<tech_level>0</tech_level>
		<value>4000</value>
		<weight>1100</weight>		
		<reference>B460</reference>
		<notes>ST 20; DX 9; IQ 3; HT 11; Will 11; Per 11; Speed 5; Dodge 8; Move 9(Наземная скорость 18); SM +1 (3 hex);</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Racehorse
<img data-src="lib/img/151729308191.png">
Некоторые еще быстрее!

Особенности: Домашнее животное; Увеличенное передвижение 1 (Наземная скорость 18); Копыта; Периферийное зрение; Четырехногое животное; Слабый укус.
Умения: Скакун-12; Бег-12.
</description-loc>
	</equipment>	
	
	<equipment version="3" state="not carried">
		<quantity>1</quantity>
		<description>Слон</description>
		<tech_level>0</tech_level>
		<value>10000</value>
		<weight>12000</weight>		
		<reference>B460</reference>
		<notes>ST 45; DX 12; IQ 5; HT 12; Will 10; Per 10; Speed 4; Dodge 7; Move 4(Наземная скорость 8); SM +3 (10 hex);  DR 4;</notes>		
		<categories>
			<category>Ездовые и тяговые животные</category>
		</categories>
		<description-loc>Elephant
<img data-src="lib/img/151729306256.png">
Умные, преданные и приспособлены к тяжёлой работе.

Особенности: Дробящая атака (Бивни); Домашнее (или Дикое) животное; DR 4; Увеличенное передвижение 1 (Наземная скорость 8); Периферийное зрение; Четырехногое животное (но замените Нет хороших манипуляторов недостатком Однорукий); Хобот (Очень гибкий; Длинный 1+ SM; Слабый, 1/4 ST); Слабый укус.
</description-loc>
	</equipment>
	
	<equipment version="3">
	<description>Боеприпасы</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes"></equipment_modifier>
	<tech_level>6</tech_level>
	<categories>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Ammunition
		<img data-src="lib/img/154261414836.png">
		Обычные боеприпасы для огнестрельного оружия.
Для каждого огнестрельного оружия после косой черты в столбце «Вес» показан вес в фунтах одного полного боекомплекта к нему. 
Считайте, что цена боеприпасов равна 20 $ за фунт их веса.
	</description-loc>
</equipment><equipment version="3">
	<description>Боеприпасы с полой оболочкой (Hollow-Point)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier ammunition="yes">
		<damage type="damage dr">0.5</damage>
		<damage type="damage type">++</damage>
	</equipment_modifier>
	<tech_level>6</tech_level>
	<categories>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		Hollow-Point
		<img data-src="lib/img/154261414836.png">
		Пули, которые расплющиваются при попадании в цель, нанося серьёзные ранения. У них улучшены повреждения: pi- становится pi, piстановится pi+, а pi+ становится pi++. (полые боеприпасы недоступны
для оружия, у которого уже pi++ повреждения). Однако такие пули хуже пбивают препятствия и броню; добавьте делитель брони (0.5). HP-боеприпасы доступны с TL6+ по обычной цене и LC. Такие пули широко используется охотниками и полицией
	</description-loc>
</equipment>	
	
	<equipment version="3">
	<description>Боеприпасы  с твердым сердечником (APHC)</description>
	<weight></weight>
	<quantity>1</quantity>
	<notes>Доступны с TL7+ по двойной цене и LC2</notes>
	<equipment_modifier ammunition="yes">
		<damage type="damage dr">2</damage>
		<damage type="damage type">--</damage>
	</equipment_modifier>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		APHC
		<img data-src="lib/img/154261414836.png">
		Цельные пули с твердым бронебойным сердечником. Добавьте делитель брони (2), но если калибр оружия меньше 20мм (.80), повреждения ухудшаются: с pi++ до pi+, с pi+ до pi, и с pi до pi-. (Никакого эффекта для pi-). APHC-боеприпасы доступны с TL7+ по двойной цене и LC2
	</description-loc>
</equipment>		
	
	<equipment version="3">
	<description>Боеприпасы бронебойные с отбрасываемым поддоном (APDS)</description>
	<weight></weight>
	<quantity>1</quantity>
	<notes>Применяемые танками при TL6-7 и пулеметами при TL8, доступны для стрелкового оружия при TL9 по пятикратной цене и LC1</notes>
	<equipment_modifier ammunition="yes">
		<damage type="damage dr">2</damage>
		<damage type="damage type">--</damage>
		<damage type="damage value" per_dice="yes">1</damage>
		<range type="multiply">1.5</range>
	</equipment_modifier>
	<legality_class>1</legality_class>
	<tech_level>9</tech_level>
	<categories>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B279</reference>
	<description-loc>
		APDS
		<img data-src="lib/img/154261414836.png">
		маленький вольфрамовый дротик, заключенный в пластмассовую оболочку, которая отбрасывается после вылета пули из ствола, увеличивая тем самым ее скорость. APDS похожи на обычную бронебойную пулю, но получают 50% к дальности и +1 на кубик повреждений. Применяемые танками при TL6-7 и пулеметами при LT8, эти пули становятся доступны для стрелкового оружия при TL9 по пятикратной цене и LC1
	</description-loc>
</equipment>


	<equipment version="3">
		<description>Дешовое качество (все контактное оружие)</description>
		<reference>B274</reference>
		<notes>+2 к шансу поломки при парировании тяжелого оружия (B376)</notes>
		<equipment_modifier>
			<accuracy type="add">-1</accuracy>
			<value type="multiply">0.4</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>
		</categories>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Дешевое: у дешевого оружия +2 к шансу поломки, и, если его можно метать, штраф -1 к Точности. Оно стоит 40% табличной цены при TL6 или раньше и 20% цены при TL7+. Массовое производство мечей для простых солдат часто дает оружие дешевого качества
</description-loc><quantity>1</quantity><weight></weight></equipment>
	<equipment version="3">
	<description>Отличное качество (мечи и фехтовальное оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<value type="multiply">4</value>
		<damage type="damage value">1</damage>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
	<description>Отличное качество (дробящее или проникающие оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<value type="multiply">3</value>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
	<description>Отличное качество (режущее оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<value type="multiply">10</value>
		<damage type="damage value">1</damage>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
	<description>Отличное качество (луки арбалеты духовые трубки)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<range type="multiply">1.2		
			
		</range>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
		<description>Превосходное качество (мечи и фехтовальное оружие)</description>
		<reference>B275</reference>
		<note>+2 к шансу поломки при парировании тяжелого оружия (B376)</note>
		<equipment_modifier>
			<damage type="damage value">2</damage>
			<value type="multiply">20</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Превосходное: только фехтовальное оружие и мечи могут обладать превосходным качеством. Эти клинки получают -2 к шансу поломки и +2 к режущим и проникающим повреждениям. 
При TL6 или ранее такое оружие стоит в 20 раз больше своей табличной цены; при TL7+ лишь в 4 раза больше
</description-loc><quantity>1</quantity><weight></weight></equipment>


	<equipment version="3">
		<description>Дешовое качество TL7+ (все контактное оружие)</description>
		<reference>B274</reference>
		<note>+2 к шансу поломки при парировании тяжелого оружия (B376)</note>
		<equipment_modifier>
			<accuracy type="add">-1</accuracy>
			<value type="multiply">0.2</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Дешевое: у дешевого оружия +2 к шансу поломки, и, если его можно метать, штраф -1 к Точности. Оно стоит 40% табличной цены при TL6 или раньше и 20% цены при TL7+. Массовое производство мечей для простых солдат часто дает оружие дешевого качества
</description-loc><quantity>1</quantity><weight></weight></equipment>
	<equipment version="3">
		<description>Хороше качество TL7+ (все контактное оружие)</description>
		<reference>B274</reference>
		<note>При TL7+ хороше (т.е. стандартное) оружие дешевле чем обычно</note>
		<equipment_modifier>
			<value type="multiply">0.4</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Хорошее: у такого оружия нет никаких модификаторов к поломке. Это обычное качество при TL6. При TL7+ оружие хорошего качества стоит 40% табличной цены.
</description-loc><quantity>1</quantity><weight></weight></equipment>
	<equipment version="3">
	<description>Отличное качество TL7+ (мечи и фехтовальное оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<damage type="damage value">1</damage>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
	<description>Отличное качество TL7+ (дробящее или проникающие оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
	<description>Отличное качество TL7+ (режущее оружие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<equipment_modifier>
		<damage type="damage value">1</damage>
	</equipment_modifier>
	<categories>
		<category>Модификатор оружия</category>
		<category>Качество оружия</category>
	</categories>
	<reference>B274</reference>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Отличное: у любого отличного оружия -1 к шансу поломки. Отличный клинок (режущее или проникающее оружие) также получает +1 к режущим и проникающим повреждениям.
При TL6 или ранее, мечи и фехтовальное оружие отличного качества стоят в 4 раза больше своей табличной цены. (Катаны чаще всего такого качества!) Другие типы оружия стоят в 3 раза больше, если наносят только дробящие или проникающие повреждения (например, палица или копье), и в 10 раз больше, если причиняют режущие повреждения (например, топор или алебарда).
При TL7+ все оружие относится к «отличному» без всяких дополнительных расходов
</description-loc>
	<note>+1 к шансу поломки при парировании тяжелого оружия (B376)</note>
</equipment>
	<equipment version="3">
		<description>Превосходное качество TL7+ (мечи и фехтовальное оружие)</description>
		<reference>B275</reference>
		<note>+2 к шансу поломки при парировании тяжелого оружия (B376)</note>
		<equipment_modifier>
			<damage type="damage value">2</damage>
			<value type="multiply">4</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Контактное и холодное дистанционное оружие может быть разного качества, как описано ниже. Качество влияет на шанс сломаться при парировании очень тяжелого оружия; см. Парирование тяжелого оружия (с.376). Цены в таблицах оружия подразумевают оружие хорошего качества при TL6 или раньше и отличного - при TL7+.

Превосходное: только фехтовальное оружие и мечи могут обладать превосходным качеством. Эти клинки получают -2 к шансу поломки и +2 к режущим и проникающим повреждениям. 
При TL6 или ранее такое оружие стоит в 20 раз больше своей табличной цены; при TL7+ лишь в 4 раза больше
</description-loc><quantity>1</quantity><weight></weight></equipment>	
	
	<equipment version="3">
		<description>Отличное качество (огнестрельное оружие)</description>
		<reference>B280</reference>
		<note>+1 к отказоустойчивости (B279)</note>
		<equipment_modifier>
			<accuracy type="add">1</accuracy>
			<value type="multiply">2</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Огнестрельное оружие отличного качества стоит вдвое дороже и получает +1 к Точности и +1 к отказу. Превосходное огнестрельное оружие стоит впятеро больше и получает +2 к точности и +1 к отказу. Если в результате отказ равен 19 или больше, оружие может поломаться, только если плохой уход снизит показатель отказа.</description-loc><quantity>1</quantity><weight></weight></equipment>

	<equipment version="3">
		<description>Превосходное качество (огнестрельное оружие)</description>
		<reference>B280</reference>
		<note>+1 к отказоустойчивости (B279), Если в результате отказ равен 19 или больше, оружие может поломаться, только если плохой уход снизит показатель отказа.</note>
		<equipment_modifier>
			<accuracy type="add">2</accuracy>
			<value type="multiply">5</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Качество оружия</category>			
		</categories>
	<description-loc>Огнестрельное оружие отличного качества стоит вдвое дороже и получает +1 к Точности и +1 к отказу. Превосходное огнестрельное оружие стоит впятеро больше и получает +2 к точности и +1 к отказу. Если в результате отказ равен 19 или больше, оружие может поломаться, только если плохой уход снизит показатель отказа.</description-loc><quantity>1</quantity><weight></weight></equipment>

	<equipment version="3">
		<description>Каменное оружие (лезвие или наконечник)</description>
		<tech_level>0</tech_level>		
		<reference>B275</reference>
		<note>Cчитайте дешевым при парировании им режущего оружия, сделанного из металла или лучшего материала.</note>
		<equipment_modifier>
			<damage type="damage dr">0.5</damage>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>
		</categories>
	<description-loc><img data-src="lib/img/154261437141.png">
Материал клинка
Наконечник или лезвие любого оружия ближнего или неогнестрельного оружия дальнего боя и наносящего режущие или проникающие повреждения (за исключением деревянных колов и механизированного оружия вроде циркулярных пил) считается каменным при TL0, бронзовым при TL1, железным при TL2, и стальным при TL3+. Нож, например, был бы каменным при TL0, но стальным при TL3, в то время как двуручный меч всегда будет стальным, поскольку появляется только при TL3. Материал клинка изменяет эффективное качество при парировании очень тяжелого оружия.
Оружие, сделанное из устаревшего материала, по цене обычно соответствует дешевому качеству.

Камень (TL0): У каменного лезвия делитель брони равен (0.5) для режущего или проникающего повреждений и нет бонуса к урону, даже в случае отличного или превосходного качества. Независимо от фактического качества, считайте каменный клинок дешевым при парировании им режущего оружия, сделанного из металла или лучшего материала.

<div><br></div></description-loc><quantity>1</quantity><weight></weight></equipment>	
	<equipment version="3">
		<description>Обсидиановое оружие (лезвие или наконечник)</description>
		<tech_level>1</tech_level>
		<reference>B275</reference>
		<note>-2 к шансу поломки при парировании тяжелого оружия. Теряет премию к урону после парирования любого оружия (но не при атаке) или удара по DR 2+</note>
		<equipment_modifier>
			<damage type="damage value">1</damage>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>
		</categories>
	<description-loc><img data-src="lib/img/154261440943.png">
Материал клинка
Наконечник или лезвие любого оружия ближнего или неогнестрельного оружия дальнего боя и наносящего режущие или проникающие повреждения (за исключением деревянных колов и механизированного оружия вроде циркулярных пил) считается каменным при TL0, бронзовым при TL1, железным при TL2, и стальным при TL3+. Нож, например, был бы каменным при TL0, но стальным при TL3, в то время как двуручный меч всегда будет стальным, поскольку появляется только при TL3. Материал клинка изменяет эффективное качество при парировании очень тяжелого оружия.
Оружие, сделанное из устаревшего материала, по цене обычно соответствует дешевому качеству.

Обсидиан (TL1): Клинок, сделанный из вулканического стекла, очень острый, но легко ломается или тупится. Считайте его каменным оружием хорошего качества, но с +1 к режущим или проникающим повреждениям (как если бы он был отличного качества) и с +2 к поломке (как будто он дешевый). Он теряет бонус к урону после парирования любого оружия (но не при рукопашной атаке) или удара по DR 2+.

<div><br></div></description-loc><quantity>1</quantity><weight></weight></equipment>		
	<equipment version="3">
		<description>Бронзовое оружие (лезвие или наконечник)</description>
		<tech_level>1</tech_level>
		<reference>B275</reference>
		<note>Считайте дешевым при парировании режущего оружия, сделанного из железа или стали</note>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>
		</categories>
	<description-loc><img data-src="lib/img/154261451683.png">
Материал клинка
Наконечник или лезвие любого оружия ближнего или неогнестрельного оружия дальнего боя и наносящего режущие или проникающие повреждения (за исключением деревянных колов и механизированного оружия вроде циркулярных пил) считается каменным при TL0, бронзовым при TL1, железным при TL2, и стальным при TL3+. Нож, например, был бы каменным при TL0, но стальным при TL3, в то время как двуручный меч всегда будет стальным, поскольку появляется только при TL3. Материал клинка изменяет эффективное качество при парировании очень тяжелого оружия.
Оружие, сделанное из устаревшего материала, по цене обычно соответствует дешевому качеству.

Бронза (TL1): бронзовый клинок не получает бонусов к урону, даже будучи отличного или превосходного качества. Независимо от фактического качества, считайте его дешевым при парировании режущего оружия, сделанного из лучшего материала (например, железа или стали).

<div><br></div></description-loc><quantity>1</quantity><weight></weight></equipment>
	<equipment version="3">
		<description>Железное оружие (лезвие или наконечник)</description>
		<tech_level>2</tech_level>
		<reference>B275</reference>
		<note>Считайте дешевым при парировании режущего оружия, сделанного из стали</note>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>
		</categories>
	<description-loc><img data-src="lib/img/154261459888.png">
Материал клинка
Наконечник или лезвие любого оружия ближнего или неогнестрельного оружия дальнего боя и наносящего режущие или проникающие повреждения (за исключением деревянных колов и механизированного оружия вроде циркулярных пил) считается каменным при TL0, бронзовым при TL1, железным при TL2, и стальным при TL3+. Нож, например, был бы каменным при TL0, но стальным при TL3, в то время как двуручный меч всегда будет стальным, поскольку появляется только при TL3. Материал клинка изменяет эффективное качество при парировании очень тяжелого оружия.
Оружие, сделанное из устаревшего материала, по цене обычно соответствует дешевому качеству.

Железо (ТУ2): железный клинок не получает бонусов к урону даже в случае отличного или превосходного качества. Независимо от фактического качества, считайте его дешевым при парировании режущего оружия, сделанного из лучшего материала (например, стали).
<div><br></div></description-loc><quantity>1</quantity><weight></weight></equipment>	
	<equipment version="3">
		<description>Пластиковое оружие (лезвие или наконечник)</description>
		<tech_level>7</tech_level>
		<reference>B275</reference>
		<note>Углеродистые соединения и другие современные, неметаллические материалы</note>
		<equipment_modifier>
			<weight type="multiply">0.5</weight>
			<value type="multiply">2</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>			
		</categories>
		<description-loc><img data-src="lib/img/154261467502.png">
Материал клинка
Наконечник или лезвие любого оружия ближнего или неогнестрельного оружия дальнего боя и наносящего режущие или проникающие повреждения (за исключением деревянных колов и механизированного оружия вроде циркулярных пил) считается каменным при TL0, бронзовым при TL1, железным при TL2, и стальным при TL3+. Нож, например, был бы каменным при TL0, но стальным при TL3, в то время как двуручный меч всегда будет стальным, поскольку появляется только при TL3. Материал клинка изменяет эффективное качество при парировании очень тяжелого оружия.
Оружие, сделанное из устаревшего материала, по цене обычно соответствует дешевому качеству.

Пластик (TL7): "Пластик" включает углеродистые соединения и другие современные, неметаллические материалы. Сократите наполовину вес и удвойте цену. Такие клинки не могут обладать качеством выше хорошего (чаще всего они дешевые). Считайте их стальными при оценке поломки - но из-за меньшего веса они чаще будут встречаться с более тяжелым оружием. Оружие, которое наносит только дробящий урон (дубины, дубинки и т.п.), доступно с обычным качеством. Главная польза пластикового оружия - способность обманывать детекторы металла!
<div><br></div></description-loc>
	<quantity>1</quantity></equipment>
	<equipment version="3">
		<description>Серебряное оружие (целиком)</description>
    	<tech_level>1</tech_level>
		<reference>B275</reference>
		<note>Считайте "дешевым" при парировании </note>
		<equipment_modifier>
			<value type="multiply">20</value>
		</equipment_modifier>
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>
		</categories>
	<description-loc><img data-src="lib/img/154261471981.png">
Тому, кто сражается с демонами, оборотнями и т.п. может потребоваться серебряное оружие. Обычно для этого нужен специальный заказ у ремесленника. Цельное серебряное оружие ближнего боя или наконечники для стрел стоят в 20 раз больше табличной цены и при оценке вероятности поломки считаются дешевыми. Оружие с покрытием или кромкой из серебра стоит только в три раза больше, и при поломке наследует свойства основного материала. Серебряные пули (TL4 +) должны быть цельными, и стоят в 50 раз больше табличной цены!
Серебряное оружие наносит дополнительный урон только созданиям с Уязвимостью (стр. 161) к серебру. Для оружия с покрытием или кромкой из серебра, уменьшите множитель урона: x2 становится x1.5, x3 - x2 и x4 - x3.

<div><br></div></description-loc><quantity>1</quantity><weight></weight></equipment>	
	<equipment version="3">
		<description>Серебряное оружие (покрытие)</description>
		<tech_level>1</tech_level>
		<reference>B275</reference>
		<equipment_modifier>
			<value type="multiply">3</value>
		</equipment_modifier>		
		<categories>
			<category>Модификатор оружия</category>
			<category>Материал оружия</category>			
		</categories>
	<description-loc><img data-src="lib/img/154261471981.png">
Тому, кто сражается с демонами, оборотнями и т.п. может потребоваться серебряное оружие. Обычно для этого нужен специальный заказ у ремесленника. Цельное серебряное оружие ближнего боя или наконечники для стрел стоят в 20 раз больше табличной цены и при оценке вероятности поломки считаются дешевыми. Оружие с покрытием или кромкой из серебра стоит только в три раза больше, и при поломке наследует свойства основного материала. Серебряные пули (TL4 +) должны быть цельными, и стоят в 50 раз больше табличной цены!
Серебряное оружие наносит дополнительный урон только созданиям с Уязвимостью (стр. 161) к серебру. Для оружия с покрытием или кромкой из серебра, уменьшите множитель урона: x2 становится x1.5, x3 - x2 и x4 - x3.</description-loc><quantity>1</quantity><weight></weight></equipment>
	<equipment version="3">
	<description>Серебряные пули (покрытие)</description>
	<weight></weight>
	<quantity>1</quantity>
	<notes>Стоят в 50 раз дороже обычных пуль</notes>
	<equipment_modifier ammunition="yes">
		<value type="multiply">50</value>
	</equipment_modifier>
	<tech_level>4</tech_level>
	<categories>
		<category>Модификатор оружия</category>
		<category>Боеприпасы</category>
	</categories>
	<reference>B275</reference>
	<description-loc>
		<img data-src="lib/img/154261482959.png">
		Тому, кто сражается с демонами, оборотнями и т.п. может потребоваться серебряное оружие. Обычно для этого нужен специальный заказ у ремесленника. Цельное серебряное оружие ближнего боя или наконечники для стрел стоят в 20 раз больше табличной цены и при оценке вероятности поломки считаются дешевыми. Оружие с покрытием или кромкой из серебра стоит только в три раза больше, и при поломке наследует свойства основного материала. Серебряные пули (TL4 +) должны быть цельными, и стоят в 50 раз больше табличной цены!
Серебряное оружие наносит дополнительный урон только созданиям с Уязвимостью (стр. 161) к серебру. Для оружия с покрытием или кромкой из серебра, уменьшите множитель урона: x2 становится x1.5, x3 - x2 и x4 - x3.
	</description-loc>
</equipment>	
	
</equipment_list>`;
 standaloneLibs['HighTech-rus.eqp']=`<!--?xml version="1.0" encoding="UTF-8" ?-->
<name>Mentor: High Tech</name>
<notes>High Tech - оружие и броня из базы <a href="http://weapons.gurps.ru/" target="_blank">Gurps Weapons</a><br><br><a href="editor.phtml?v=50000000000000000000000000000000" target="_blank">Редактироване библиотеки</a> разрешно, но с предмодерацией</notes>
<equipment_list version="1">
<equipment version="3">
	<quantity>1</quantity>
	<description>Mauser C96</description>
	<description-loc>Германия 1897

<img data-src="http://weapons.gurps.ru/img/1.png">

<img data-src="http://weapons.gurps.ru/img/580.png">

Это первый полуавтоматический пистолет одинарного действия ставший коммерчески успешным. Оно был сверх распространен в первой половине 20 века. Особенно в Германии, Восточной Европе, России, Китае (которая закупила около полу миллиона) и Южной Америке. Копии и дарвинизмы производились в Испании и Китае. Можно встретить в вестерне Джо Кид (с прикладом) и в качестве базы для бластера Хан Соло из Звездных Воин.

C96 имеет встроенный магазин на 10 патронов, заряжаемый с помощью специального клипа. Он не может нести дополнительный патрон в стволе. Боек бъет по первому патрону в магазине.

Многие маузеры имели отсоединяемый деревянный приклад (1.3 lbs, +1 Acc, -1 Bulk) с полостью для хранения пистолета, фактически он служил поясной кобурой. Достать из нее пистолет - три Ready маневра. Присоединить приклад - еще три маневра.

В 1908-1915, был доступен под патрон 9x25mm Mauser (Dmg 3d-1 pi). а с 1915-1918, многие выпускались под 9x19mm Parabellum для военных целей (Dmg 2d+2 pi). Китайская копия (1929-1932) под .45 ACP : Dmg 2d pi+, Wt. 3/0.5, ST 10, Rcl 3.

С 1930, маузер предлагает съемные магазины на 10 патронов (0.4 lb., $26) и на 20 патронов (0.7 lb., $27). Со съемным магазином можно было заводить дополнительный патрон в ствол.

Испанские производители выпускали вариацию с автоматическим режимом огня с 1927, а маузер выпустил первую в 1930. Самый распространенный вариант C96 Schnellfeuerpistole M32 (1932-1938) мел съемный магазин и приклад:  Acc 3, Wt. 4.2/0.7, RoF 14, Shots 20+1(3), ST 7†, Bulk -4, Cost $550/$27, LC2. Используйте умение Guns (SMG) Без приклада он был плохо контролируем: Acc 2, Wt. 3, ST 8†. А при стрельбе с одной руки без приклада: ST 10, Rcl 3. Около 70,000 было экспортировано в Китай, а остальные пошли в войска СС.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>480</value>
	<weight>2.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi-</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>180/2,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>10(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>7.63x25mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Mauser C96 (C96 Schnellfeuerpistole (SMG))</description>
	<description-loc>Германия 1897

<img data-src="http://weapons.gurps.ru/img/1.png">

<img data-src="http://weapons.gurps.ru/img/580.png">

Это первый полуавтоматический пистолет одинарного действия ставший коммерчески успешным. Оно был сверх распространен в первой половине 20 века. Особенно в Германии, Восточной Европе, России, Китае (которая закупила около полу миллиона) и Южной Америке. Копии и дарвинизмы производились в Испании и Китае. Можно встретить в вестерне Джо Кид (с прикладом) и в качестве базы для бластера Хан Соло из Звездных Воин.

C96 имеет встроенный магазин на 10 патронов, заряжаемый с помощью специального клипа. Он не может нести дополнительный патрон в стволе. Боек бъет по первому патрону в магазине.

Многие маузеры имели отсоединяемый деревянный приклад (1.3 lbs, +1 Acc, -1 Bulk) с полостью для хранения пистолета, фактически он служил поясной кобурой. Достать из нее пистолет - три Ready маневра. Присоединить приклад - еще три маневра.

В 1908-1915, был доступен под патрон 9x25mm Mauser (Dmg 3d-1 pi). а с 1915-1918, многие выпускались под 9x19mm Parabellum для военных целей (Dmg 2d+2 pi). Китайская копия (1929-1932) под .45 ACP : Dmg 2d pi+, Wt. 3/0.5, ST 10, Rcl 3.

С 1930, маузер предлагает съемные магазины на 10 патронов (0.4 lb., $26) и на 20 патронов (0.7 lb., $27). Со съемным магазином можно было заводить дополнительный патрон в ствол.

Испанские производители выпускали вариацию с автоматическим режимом огня с 1927, а маузер выпустил первую в 1930. Самый распространенный вариант C96 Schnellfeuerpistole M32 (1932-1938) мел съемный магазин и приклад:  Acc 3, Wt. 4.2/0.7, RoF 14, Shots 20+1(3), ST 7†, Bulk -4, Cost $550/$27, LC2. Используйте умение Guns (SMG) Без приклада он был плохо контролируем: Acc 2, Wt. 3, ST 8†. А при стрельбе с одной руки без приклада: ST 10, Rcl 3. Около 70,000 было экспортировано в Китай, а остальные пошли в войска СС.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>2</legality_class>
	<value>550/27</value>
	<weight>4.2/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi-</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>180/2,000</range>
		<rate_of_fire>14</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>7.63x25mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN-Browning Mle 1906</description>
	<description-loc>Бельгия 1906

<img data-src="http://weapons.gurps.ru/img/2.png">

Нет кольца для шнура (HT154)

Этот крошечный плоский пистолет одинарного действия под мелкий калибр столь мал что его можно скрыть в кармане жилета или брюк. Не точен, не убоен, не надежен, и ломающийся через несколько лет, он теме не менее стал полярным оружием самообороны. Выпускался для офицеров высокого ранга в некоторых войсках, включая США, поскольку был достаточно мал чтобы не создавать складок на форме. Часто становился вторым (иногда третьим, или четвертым) оружием для тех кто любит быть вооружен.

Было выпущено более миллиона и еще 409,000 под маркой Colt Vest Pocket (1908-1946). Простой пистолет с небольшой нагрузкой на курке. Перед Второй Мировой многие Испанские оружейники экспортировали его дешевые копии.

FN-Browning Baby (1931-1983) был похож но даже немного меньше (Wt. 0.65).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>160/25</value>
	<weight>0.8/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi-</damage>
		<strength>7</strength>
		<accuracy>0</accuracy>
		<range>90/950</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.25 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Luger P08</description>
	<description-loc>Германия 1908

<img data-src="http://weapons.gurps.ru/img/3.png">

<img data-src="http://weapons.gurps.ru/img/581.png">

Не надежный - клинит на 16+



Первый Парабеллум был разработан Джорджем Люгером в 1900. Он был одиночного действия и очень прост - навел и выстрелил. К сожалению его механизм спускового курка имел склонность заедать.

В 1900 в Швейцарии приняли на вооружение Парабелум калибра 7.65x21mm Parabellum (Dmg 2d pi-). Бразилия Болгария, Финляндия и Польша так-же использовал этот калибр. А США он продавался под маркой “American Eagle,” калибром .30 Luger.

В 1902 был выпущен патрон 9x19mm Parabellum который в конченом счете стал самым распространенным пистолетным калибром 20 века. Немецкая полиция и армия приняли его на вооружение под маркой Pistole 08 и оставался на службе с 1908 по 1945. Продавался на экспорт в Нидерланды, Персию, Турцию и Вьетнам. Более трех миллионов было выпущено.

Модель LP08 (1913-1918) или Artillerie имела удлиненный ствол: Dmg 3d-1 pi, Wt. 2.9/0.5, Bulk -3. Поставлялся со съемным прикладом (0.8 lbs, +1 Acc, -1 Bulk). С 1917 появился огромный улиточно-барабанный магазин на 32 патрона ($304, 2.4 lbs.); был громоздок (-1 Bulk) и заметно уменьшал надежность (Malf 15). В такой комплектации поставлялся расчетам пулеметчиков и штурмовым отрядам.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>500/26</value>
	<weight>2.4/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Luger P08 (LP08)</description>
	<value>500/26</value>
	<weight>2.9/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1908
		<img data-src="http://weapons.gurps.ru/img/3.png">
		<img data-src="http://weapons.gurps.ru/img/581.png">
		Не надежный - клинит на 16+



Первый Парабеллум был разработан Джорджем Люгером в 1900. Он был одиночного действия и очень прост - навел и выстрелил. К сожалению его механизм спускового курка имел склонность заедать.

В 1900 в Швейцарии приняли на вооружение Парабелум калибра 7.65x21mm Parabellum (Dmg 2d pi-). Бразилия Болгария, Финляндия и Польша так-же использовал этот калибр. А США он продавался под маркой “American Eagle,” калибром .30 Luger.

В 1902 был выпущен патрон 9x19mm Parabellum который в конченом счете стал самым распространенным пистолетным калибром 20 века. Немецкая полиция и армия приняли его на вооружение под маркой Pistole 08 и оставался на службе с 1908 по 1945. Продавался на экспорт в Нидерланды, Персию, Турцию и Вьетнам. Более трех миллионов было выпущено.

Модель LP08 (1913-1918) или Artillerie имела удлиненный ствол: Dmg 3d-1 pi, Wt. 2.9/0.5, Bulk -3. Поставлялся со съемным прикладом (0.8 lbs, +1 Acc, -1 Bulk). С 1917 появился огромный улиточно-барабанный магазин на 32 патрона ($304, 2.4 lbs.); был громоздок (-1 Bulk) и заметно уменьшал надежность (Malf 15). В такой комплектации поставлялся расчетам пулеметчиков и штурмовым отрядам.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>850/27</value>
	<weight>2.8/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (Commander)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>870</value>
	<weight>2.6/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (Officer’s Model)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>850</value>
	<weight> 2.4/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots> 6+1</shots>
		<bulk>-1</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (.38 Super Auto)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>950</value>
	<weight>2.8/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>9+1</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.38 Super Auto</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (Colt Delta Elite)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>950</value>
	<weight>2.8/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1</shots>
		<bulk>-2</bulk>
		<recoil>4</recoil>
		<ammo>10x25mm Auto</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (AMT Hardballer Longslide)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>550</value>
	<weight>3.3/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>10</strength>
		<accuracy>3</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (Detonics Combat Master)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>1,200</value>
	<weight>2.2/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6+1</shots>
		<bulk>-1</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Government (Para-Ordnance P14-45)</description>
	<description-loc>США 1912-

<img data-src="http://weapons.gurps.ru/img/4.png">

<img data-src="http://weapons.gurps.ru/img/569.png">

<img data-src="http://weapons.gurps.ru/img/571.png">

<img data-src="http://weapons.gurps.ru/img/572.png">

<img data-src="http://weapons.gurps.ru/img/573.png">

<img data-src="http://weapons.gurps.ru/img/574.png">

Разработанный Джоном Браунингом этот большой полуавтоматический пистолет одинарного действия был на вооружении Американской армии под маркой M1911 (1912-1925). После был улучшен до M1911A1 (1926-1970) а в последствии M1991A1 (1991-) однако военные больше не закупали их. Было выпущено около 3 миллионов. Многие страны так-же закупали их. После Второй Мировой Войны США поставила своим союзникам тысячи таких.

Это возможно самый переделываемый и модифицируемый пистолет в истории. Большая часть изменений направлена на улучшение точности, надежности и скорости перезарядки - не имеет заметного игрового эффекта. Для прочего смотри HT79. С 1970х доступны: магазин на 8 патронов той-же длины что и оригинальный, так-же доступен 25 патронный выпирающий магазин (-1 Bulk, $31, 1.8 lbs.) и приклад (1.1 lbs +1 Acc, -1 Bulk)

Множество производителей по всему миру включая Аргентину, Бразилию, Китай, Мексику, Норвегию, Филиппины и Испанию выпускали по лицензии или без нее. Варьировался калибр и размер. Меньшие версии: 

Commander (1949-) Wt. 2.6/0.5, Cost $870. 

Officer’s Model (1984-1999) Acc 1, Wt. 2.4/0.4, Shots 6+1, Bulk -1, Cost $850.

.38 Super Auto (1929-) калибра .38 Super Auto: Dmg 3d-1 pi, Wt. 2.8/0.4, Shots 9+1, Cost $950. Был популярен по обе стороны правопорядка в Америке 1930х в первую очередь из за того что мог пробить бронежилет того времени. ФБР приняла его на вооружение в 1938.

Colt Delta Elite (1987-1996) калибр 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.8/0.4, Shots 8+1, ST 11, Rcl 4, Cost $950.

AMT Hardballer Longslide (1977-) удлиненный ствол и затворная показан в фильме Терминатор: Dmg 2d+1 pi+, Acc 3, Wt. 3.3/0.5, Bulk -3, Cost $550.

Detonics Combat Master (1977-1992) - улучшенное (надежность) оружие, один из самых компактных: Acc 1, Wt. 2.2/0.4, Shots 6+1, Bulk -1, Cost $1,200.

Para-Ordnance P14-45 (1990-2003) канадская версия с широкой рамой, что позволяет ставить двухрядный магазин: Wt. 3.3/0.8, Shots 13+1, Cost $950/$28.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>950/28</value>
	<weight>3.3/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>150/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>13+1</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Nambu 14 Shiki</description>
	<description-loc>Япония 1925

<img data-src="http://weapons.gurps.ru/img/5.png">

Немного напоминает Люгер, но имеет абсолютно другой механизм. Этот пистолет одиночного действия был на вооружении армии Японии во времена Второй Мировой Войны и продавался на экспорт. Было выпущено 279,000.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>350/26</value>
	<weight>2.4/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,700</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>8x21mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Япония</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Walther PPK</description>
	<description-loc>Германия 1931

<img data-src="http://weapons.gurps.ru/img/6.png">

Нет кольца для шнура (HT154)



В 1929 Карл Вальтер представил радикальный дизан: полуавтоматический пистолет двойного действия который можно носить намного более безопасно чем пистолеты того времени. Названый PolizeiPistole (PP), он был компактен и изящен, разработан как пистолет для кобуры полицейсих: Wt. 1.8/0.25, Shots 8+1. Между 1930ми и 1970ми был самым распространенным полицейским оружием в Европе, поставлялся на экспорт.

Во времена Второй Мировой Войны ПП бы частым доп оружием немецких офицеров. Многие были розданы нацистской верхушке - членам партии и управленцам (Гитлер носил такой). После войны использовался Британскими десантниками и королевской охраной. Выпускался по лицензии во Франции, Венгрии, Турции и США а так-же копировался во всему миру. Доступен и в других калибрах, включая:  .22 LR (Dmg 1d+1 pi-, Wt. 1.8/0.25, Shots 10+1) и .380 ACP (Dmg 2d-1 pi, Wt. 1.8/0.25, Shots 7+1).

Еще более компактный Polizei-Pistole, Kriminal (PPK) более знаменит, хотя и менее распространен. Разрабатывался для скрытного ношения следователями. Был традиционным оружием Джеймса Бонда. Можно установить глушитель (0.4 lbs, -2 Hearing, -1 Bulk). ППК менее распространен в калибре  .22 LR (Dmg 1d+1 pi-, Wt. 1.5/0.2, Shots 9+1) и .380 ACP (Dmg 2d-1 pi, Wt. 1.7/0.25, Shots 6+1). Выпускался с гравировкой и инкрустацией, с золотым напылением с ручкой из слоновой кости, и жемчугами и т.п. </description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>480/26</value>
	<weight>1.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi-</damage>
		<strength>7</strength>
		<accuracy>1</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.32 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN-Browning HP</description>
	<description-loc>Бельгия 1935

<img data-src="http://weapons.gurps.ru/img/7.png">

Этот пистолет одиночного действия создан по чертежам Джона Браунинга после его смерти (1926) и был представлен в 1935. Это был первый из пистолетов большой емкости 9x19 мм. Более 70 армий мира приняли его на вооружение. Он стал оружием поддержки во всех уголках британской империи. Лицензированное и не лицензированное производство шло в Аргентине, Китае, Индии, Индонезии, Израиле, Нигерии и т.п. Был излюбленным оружием полицейских и разведчиков. ЦРУ использовал их во Вьетнаме, ФБРи Группы по спасению заложников в 1980х пока оно не потеряло актуальность из за механизма одиночного действия.

До 1940х некоторые шли с отсоединяемым прикладом (+1 Acc, -1 Bulk). Дополнительный магазин на 20 патронов ($28, 0.8 lb.) доступен с 1970х, и был очень популярен у Британских десантников.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>780/35</value>
	<weight>2.4/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>13+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Тульский Токарев (ТТ-33)</description>
	<description-loc>Россия / СССР 1936

<img data-src="http://weapons.gurps.ru/img/8.png">

<img data-src="http://weapons.gurps.ru/img/586.png">

в 1930 Советская Армия приняла на вооружение пистолет одиночного действия на замену Нагану. Он использовал патрон 7.62x25mm. В 1933 модифицированная версия стала стандартным оружием армии коммунистов и революционных движений. во время и после Второй Мировой Войны.

ТТ33 не имел предохранителя, если носить с патроном в стволе и уронить или ударить он может выстрелить - кидай 3d, выстрел происходит при броске 17, 18.

Отряды "Смерш" использовал модель с глушителем (1 Lbs, -2 к слуху, -1 Bulk, Хватает на 40 выстрелов): Dmg 2d pi-, Range 140/1,600. 

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>350/26</value>
	<weight>2.1/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>180/2,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>7.62x25mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Тульский Токарев (ТТ-33) (Silencer)</description>
	<description-loc>Россия / СССР 1936

<img data-src="http://weapons.gurps.ru/img/8.png">

<img data-src="http://weapons.gurps.ru/img/586.png">

в 1930 Советская Армия приняла на вооружение пистолет одиночного действия на замену Нагану. Он использовал патрон 7.62x25mm. В 1933 модифицированная версия стала стандартным оружием армии коммунистов и революционных движений. во время и после Второй Мировой Войны.

ТТ33 не имел предохранителя, если носить с патроном в стволе и уронить или ударить он может выстрелить - кидай 3d, выстрел происходит при броске 17, 18.

Отряды "Смерш" использовал модель с глушителем (1 Lbs, -2 к слуху, -1 Bulk, Хватает на 40 выстрелов): Dmg 2d pi-, Range 140/1,600. 

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>350/26</value>
	<weight>3.1/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>140/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>7.62x25mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Walther P38</description>
	<description-loc>Германия 1938

<img data-src="http://weapons.gurps.ru/img/9.png">

<img data-src="http://weapons.gurps.ru/img/577.png">

Он заменил Люгер в на вооружении Немецких военных. Это был первый мощный полуавтоматический пистолет двойного действия. После Второй Мировой Франция, Израиль и Западная Германия использовали их. Было выпущено более миллиона.

P38K (1943-1945) с укороченным стволом: Dmg 2d+1 pi, Wt. 2.3, Bulk -1. Некоторые использовались в Гестапо, и в Восточной Германии после войны. Производство было возобновлено в 1974-1981 для немецких противотерроистических сил.  Было выпущено всего 2,600. 

P1 (1957-1997) с алюминиевой рамой: Wt. 2.1/0.4.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>530/26</value>
	<weight>2.4/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Walther P38 (P38K)</description>
	<description-loc>Германия 1938

<img data-src="http://weapons.gurps.ru/img/9.png">

<img data-src="http://weapons.gurps.ru/img/577.png">

Он заменил Люгер в на вооружении Немецких военных. Это был первый мощный полуавтоматический пистолет двойного действия. После Второй Мировой Франция, Израиль и Западная Германия использовали их. Было выпущено более миллиона.

P38K (1943-1945) с укороченным стволом: Dmg 2d+1 pi, Wt. 2.3, Bulk -1. Некоторые использовались в Гестапо, и в Восточной Германии после войны. Производство было возобновлено в 1974-1981 для немецких противотерроистических сил.  Было выпущено всего 2,600. 

P1 (1957-1997) с алюминиевой рамой: Wt. 2.1/0.4.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>530/26</value>
	<weight>2.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ruger Standard MK1</description>
	<description-loc>США 1949

<img data-src="http://weapons.gurps.ru/img/10.png">

Нет кольца для шнура (HT154)

Дешёвый пистолет одинарного действия задумывался как простенькая "мелкашка". Последние модели однако стали высококачественным стрелковым пистолетом просто меньшей мощности чем конкуренты. Были выпущены миллионы.

Армия США закупала такие с настраиваемыми курками и удлиненным стволом для стрелковых занятий: Acc 3, Wt. 2.8. 

Еще была версия Standard MK2 (1982-2004): Wt.2.7/0.4, Shots 10+1, Cost $315.

Калибр .22 легко шумоподавляется из за малой мощности. Спецслужбы, убийцы мафии и прочие профессионалы использовали такие пистолеты долгое время. Он как будто задуман для самодельного глушителя. День работы по умению Armoury (Small Arms) и получается автоматическая остановка рамы  (RoF 1) и глушитель, что в сумме дает -4 к Hearing. Wt. 2.9, Bulk -3. Такая работа стоит около $500.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>300/25</value>
	<weight>2.5/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi-</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>70/1,400</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>9+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.22 LR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пистолет Макарова (ПМ)</description>
	<description-loc>Россия / СССР 1951

<img data-src="http://weapons.gurps.ru/img/11.png">

<img data-src="http://weapons.gurps.ru/img/567.png">

<img data-src="http://weapons.gurps.ru/img/568.png">

Пистолет двойного действия на базе Вальтер ПП. Компактен и достаточно эффективен, стал стандартным вооружением полиции и армии России во второй половине 20го века. Русские выпустили около пяти миллионов. Пм широко экспортировался и выпускался по лицензии в Болгарии, Китае, Восточной Германии. Он до сих пор часто встречается в руках революционеров.

ПБ (1967-1994) "Пистолет Бесшумный" иcпользовался спец подразделениями: Dmg 2d-1 pi, Range 80/800, Wt. 2.4, RoF 1, Bulk -3, Cost $600, LC2. Съемный глушитель и автоматическая постановка на блокировку (HT161) дают -3 к Hearing но оружие необходимо взводить каждый раз после выстрела.

ПММ (1994-) "модифицированный" с магазином в два ряда: Wt.1.9/0.4, Shots 12+1, $250. В отличи от ПМ, может стрелять патроном +P (Dmg 2d+2 pi).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>250/26</value>
	<weight>1.8/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x18mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пистолет Макарова (ПМ) (Пистолет Бесшумный (ПБ))</description>
	<description-loc>Россия / СССР 1951

<img data-src="http://weapons.gurps.ru/img/11.png">

<img data-src="http://weapons.gurps.ru/img/567.png">

<img data-src="http://weapons.gurps.ru/img/568.png">

Пистолет двойного действия на базе Вальтер ПП. Компактен и достаточно эффективен, стал стандартным вооружением полиции и армии России во второй половине 20го века. Русские выпустили около пяти миллионов. Пм широко экспортировался и выпускался по лицензии в Болгарии, Китае, Восточной Германии. Он до сих пор часто встречается в руках революционеров.

ПБ (1967-1994) "Пистолет Бесшумный" иcпользовался спец подразделениями: Dmg 2d-1 pi, Range 80/800, Wt. 2.4, RoF 1, Bulk -3, Cost $600, LC2. Съемный глушитель и автоматическая постановка на блокировку (HT161) дают -3 к Hearing но оружие необходимо взводить каждый раз после выстрела.

ПММ (1994-) "модифицированный" с магазином в два ряда: Wt.1.9/0.4, Shots 12+1, $250. В отличи от ПМ, может стрелять патроном +P (Dmg 2d+2 pi).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>600</value>
	<weight>2.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>80/800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>9x18mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пистолет Макарова (ПМ) (Пистолет Макарова Модернизированный (ПММ))</description>
	<description-loc>Россия / СССР 1951

<img data-src="http://weapons.gurps.ru/img/11.png">

<img data-src="http://weapons.gurps.ru/img/567.png">

<img data-src="http://weapons.gurps.ru/img/568.png">

Пистолет двойного действия на базе Вальтер ПП. Компактен и достаточно эффективен, стал стандартным вооружением полиции и армии России во второй половине 20го века. Русские выпустили около пяти миллионов. Пм широко экспортировался и выпускался по лицензии в Болгарии, Китае, Восточной Германии. Он до сих пор часто встречается в руках революционеров.

ПБ (1967-1994) "Пистолет Бесшумный" иcпользовался спец подразделениями: Dmg 2d-1 pi, Range 80/800, Wt. 2.4, RoF 1, Bulk -3, Cost $600, LC2. Съемный глушитель и автоматическая постановка на блокировку (HT161) дают -3 к Hearing но оружие необходимо взводить каждый раз после выстрела.

ПММ (1994-) "модифицированный" с магазином в два ряда: Wt.1.9/0.4, Shots 12+1, $250. В отличи от ПМ, может стрелять патроном +P (Dmg 2d+2 pi).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>250/26</value>
	<weight>1.9/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>12+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x18mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K VP70</description>
	<description-loc>Германия 1973

<img data-src="http://weapons.gurps.ru/img/12.png">

<img data-src="http://weapons.gurps.ru/img/579.png">

Нет кольца для шнура (HT154)



Пистолет большой емкости, полуавтоматический двойного действия. Это был первый пистолет на синтетической раме (черта TL8) Было выпущено менее 27,000 единиц, но за запоминающийся внешний вид появлялся в кино, допустим в фильме Чужие.

Более 3,200 из них имели съемный приклад (1 lbs) который служил в качестве кобуры. На прекладе так-же был переключатель стрельбы в автоматический режим (по три пули): Acc 3, Wt. 3.5/0.7, RoF 9#, ST 7†, Bulk -3, LC2.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>550/27</value>
	<weight>2.5/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>18+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K VP70 (version with stock)</description>
	<description-loc>Германия 1973

<img data-src="http://weapons.gurps.ru/img/12.png">

<img data-src="http://weapons.gurps.ru/img/579.png">

Нет кольца для шнура (HT154)



Пистолет большой емкости, полуавтоматический двойного действия. Это был первый пистолет на синтетической раме (черта TL8) Было выпущено менее 27,000 единиц, но за запоминающийся внешний вид появлялся в кино, допустим в фильме Чужие.

Более 3,200 из них имели съемный приклад (1 lbs) который служил в качестве кобуры. На прекладе так-же был переключатель стрельбы в автоматический режим (по три пули): Acc 3, Wt. 3.5/0.7, RoF 9#, ST 7†, Bulk -3, LC2.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>550/27</value>
	<weight>3.5/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8</strength>
		<accuracy>3</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>9#</rate_of_fire>
		<shots>7†</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Beretta Mod 92</description>
	<description-loc>Италия 1975

<img data-src="http://weapons.gurps.ru/img/13.png">

<img data-src="http://weapons.gurps.ru/img/578.png">

Хорошо сделанный полуавтоматический пистолет двойного действия с магазином на 15 патронов. Итальянская полиция и армия приняла их на вооружение в 1976 и они быстро распространились по миру. Считая модификации он производился в Бразилии, Франции, Южной Африке, Турции и США - более миллиона было сделано.

В 1986 Армия США приняла на вооружение следующую версию Mod 92F (1984-) он же M9. Так-же использовался полицейскими. В фильме Храброе Сердце такой у детектива Джона Маклейна.  У некоторых военных моделей на стволе есть крепление для глушителя (0.4 lbs, -3 к Hearing, -1 Bulk) которого хватает на 30 выстрелов.

Mod 93R (1979-) автоматический пистолет, позволяющий стрелять очередями по три патрона. Имеет увеличенный магазин, дульный компенсатор и складную переднюю ручку:  Wt. 3.4/0.9, RoF 9, Shots 20+1, ST 8†, Cost $1,100/$28, LC2. Можно прикрутить складной приклад (+1 Acc, -1 Bulk). Часто появляется в фильмах.

Есть еще много вариаций, в большинстве своем не значительных. К примеру Пограничники США приняли на вооружение модель двойного действия Mod 96D Brigadier (1991-), под .40 S&amp;W: Dmg 2d+2 pi+, Acc 1, Wt. 2.7/0.7, Shots 13+1, Cost $700/$27.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>700/27</value>
	<weight>2.8/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>15+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Италия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Beretta Mod 92 (Mod 93R)</description>
	<description-loc>Италия 1975

<img data-src="http://weapons.gurps.ru/img/13.png">

<img data-src="http://weapons.gurps.ru/img/578.png">

Хорошо сделанный полуавтоматический пистолет двойного действия с магазином на 15 патронов. Итальянская полиция и армия приняла их на вооружение в 1976 и они быстро распространились по миру. Считая модификации он производился в Бразилии, Франции, Южной Африке, Турции и США - более миллиона было сделано.

В 1986 Армия США приняла на вооружение следующую версию Mod 92F (1984-) он же M9. Так-же использовался полицейскими. В фильме Храброе Сердце такой у детектива Джона Маклейна.  У некоторых военных моделей на стволе есть крепление для глушителя (0.4 lbs, -3 к Hearing, -1 Bulk) которого хватает на 30 выстрелов.

Mod 93R (1979-) автоматический пистолет, позволяющий стрелять очередями по три патрона. Имеет увеличенный магазин, дульный компенсатор и складную переднюю ручку:  Wt. 3.4/0.9, RoF 9, Shots 20+1, ST 8†, Cost $1,100/$28, LC2. Можно прикрутить складной приклад (+1 Acc, -1 Bulk). Часто появляется в фильмах.

Есть еще много вариаций, в большинстве своем не значительных. К примеру Пограничники США приняли на вооружение модель двойного действия Mod 96D Brigadier (1991-), под .40 S&amp;W: Dmg 2d+2 pi+, Acc 1, Wt. 2.7/0.7, Shots 13+1, Cost $700/$27.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,100/28</value>
	<weight>3.4/0.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8†</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>21+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Италия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AMT Back Up</description>
	<description-loc>США 1976

<img data-src="http://weapons.gurps.ru/img/14.png">

Нет кольца для шнура (HT154)



Этот пистолет двойного действия может полностью скрыться в руке, и тем не менее имеет вполне внушительный калибр. Стал популярен как второе оружие у полиции и кримминалитета. Back Up II (1992-) заменил его имел только двойное действие. </description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>350/32</value>
	<weight>1.4/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.380 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Glock 17</description>
	<description-loc>Австрия 1983

<img data-src="http://weapons.gurps.ru/img/15.png">

<img data-src="http://weapons.gurps.ru/img/585.png">

<img data-src="http://weapons.gurps.ru/img/583.png">

<img data-src="http://weapons.gurps.ru/img/584.png">

Очень надежный, не клинит при критах если нормально обсужен



Glock 17 разрабатывался для Австрийских военных и полицейских (под маркой P80). Производитель использовал все современные наработки чтобы выпустить оружие «безопасного действия» с магазинов высокой емкости контролируемой отдачей и малым весом. Его рама и большинство частей сделаны из пластика, но ствол и казенник из стали что отлично видно на рентгене и улавливается детекторами металл (не смотря на слухи в прессе). С 1999 шел с полозьями для навесного под стволом. Часто используется магазин на 19 патронов, того же размера что и оригинальный  ($32.50, 0.7 lb.).



Glock 18 (1986-) ранняя модель с возможностью ведения автоматической стрельбы Wt. 2.6/1.1, RoF 21, Shots 31+1, ST 9, Bulk -3, Cost $1,000/$34, LC2. Может использовать магазин от Glock 17 (Bulk -2), b наоборот.

 

Выпускался в множестве калибров.

Glock 20 (1990-), 10x25mm Auto: Dmg 3d-1 pi+, Wt. 2.4/0.7, Shots 15+1, ST 10, Rcl 4.

Glock 21 (1991-), .45 ACP: Dmg 2d pi+, Wt. 2.4/0.8, Shots 13+1, ST 10, Rcl 3.

Glock 22 (1991-), .40 S&amp;W: Dmg 2d+2 pi+, Wt. 2.1/0.7, Shots 15+1.

Glock 31 (1997-), .357 SIG: Dmg 3d-1 pi, Wt. 2.1/0.7, Shots 15+1, ST 9, Rcl 3.

Glock 37 (2003-), .45 GAP: Dmg 2d pi+, Wt. 2.2/0.6, Shots 10+1, ST 9, Rcl 3.

 

Немного более компактные модели:

Glock 19 (1988-), 9x19mm: Dmg 2d+1 pi, Wt. 1.8/0.5, Shots 15+1.

Glock 23 (1991-), .40 S&amp;W: Dmg 2d+1 pi+, Wt. 1.9/0.6, Shots 13+1.

Glock 25 (1995-), .380 ACP: Dmg 2d-1 pi, Wt. 1.7/0.4, Shots 15+1.

 

Сверх компактные модели c Acc 1 и Bulk -1:

Glock 26 (1995-), 9x19mm: Dmg 2d+1 pi, Wt. 1.6/0.4, Shots 10+1.

Glock 27 (1995-), .40 S&amp;W: Dmg 2d+1 pi+, Wt. 1.7/0.4, Shots 9+1.

Glock 36 (1999-), .45 ACP: Dmg 2d-1 pi+, Wt. 1.7/0.4, Shots 6+1, ST 9, Rcl 3.

 

Большинство малых моделей могут применять магазины от больших версий но это ухудшает их Bulk. Для Glock 26 доступен крошечный глушитель (0.2 lbs, -2 Hearing, -1 Bulk) на 20 выстрелов.

Распространился по всему миру с 1990х. Стал одним из популярныйших пистолетов у силовиков Америки, за свою безопасность, низкую цену и вес. Glock 22 и 23 c 1998 на вооружении у ФБР и Управления по Борьбе с Наркотиками. Было выпущено более 2.5 миллионов единиц.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>600/32</value>
	<weight>1.9/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>17+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>SIG-Sauer P226</description>
	<description-loc>Германия 1983

<img data-src="http://weapons.gurps.ru/img/16.png">

<img data-src="http://weapons.gurps.ru/img/587.png">

Очень надежный, не клинит при критах если нормально обслужен



Это высококачественный пистолет двойного действия, популярен у силовых структур всего мира. Также широко используется армейскими спец подразделениями, такими как Морские Котики США и Британский десант. Хотя он сильно дороже своих конкурентов, но даст отличною надежность и высокую точность. Копировался в Китае и Иране, но был не надежным (Malf 17). Магазин на 20 патронов ($28, 0.8 lb.) доступен с 1987.

В 1995 доступен в калибре 357 SIG: Dmg 3d-1 pi, Shots 13+1, ST 10, Rcl 3. Техасские Рейнджеры используют эту версию. С 1998, так-же предлагается в калибре .40 S&amp;W: Dmg 2d+2 pi+, Shots 13+1.

P228 (1988-1997) с укороченным стволом и рукояткой Dmg 2d+1 pi, Wt. 2.1/0.5, Shots 13+1. В 1992 Армия США приняла его на вооружения под маркой M11 для военной полиции, пилотов и т.п. Многие федеральный агентства типа АТФ, ФБР, и Маршалы используют такие.

P229 (1992-), под .40 S&amp;W: Dmg 2d+1 pi+, Wt. 2.4/0.6, Shots 12+1. А в калибре .357 SIG, P229 с 1999: Dmg 3d-2 pi, Wt. 2.4/0.5, Shots 12+1, ST 10, Rcl 3.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>840/27</value>
	<weight>2.4/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>15+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>SIG-Sauer P226 (P228)</description>
	<description-loc>Германия 1983

<img data-src="http://weapons.gurps.ru/img/16.png">

<img data-src="http://weapons.gurps.ru/img/587.png">

Очень надежный, не клинит при критах если нормально обслужен



Это высококачественный пистолет двойного действия, популярен у силовых структур всего мира. Также широко используется армейскими спец подразделениями, такими как Морские Котики США и Британский десант. Хотя он сильно дороже своих конкурентов, но даст отличною надежность и высокую точность. Копировался в Китае и Иране, но был не надежным (Malf 17). Магазин на 20 патронов ($28, 0.8 lb.) доступен с 1987.

В 1995 доступен в калибре 357 SIG: Dmg 3d-1 pi, Shots 13+1, ST 10, Rcl 3. Техасские Рейнджеры используют эту версию. С 1998, так-же предлагается в калибре .40 S&amp;W: Dmg 2d+2 pi+, Shots 13+1.

P228 (1988-1997) с укороченным стволом и рукояткой Dmg 2d+1 pi, Wt. 2.1/0.5, Shots 13+1. В 1992 Армия США приняла его на вооружения под маркой M11 для военной полиции, пилотов и т.п. Многие федеральный агентства типа АТФ, ФБР, и Маршалы используют такие.

P229 (1992-), под .40 S&amp;W: Dmg 2d+1 pi+, Wt. 2.4/0.6, Shots 12+1. А в калибре .357 SIG, P229 с 1999: Dmg 3d-2 pi, Wt. 2.4/0.5, Shots 12+1, ST 10, Rcl 3.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>840/27</value>
	<weight>2.1/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>13+1</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>SIG-Sauer P226 (P229 .40 S&amp;W)</description>
	<description-loc>Германия 1983

<img data-src="http://weapons.gurps.ru/img/16.png">

<img data-src="http://weapons.gurps.ru/img/587.png">

Очень надежный, не клинит при критах если нормально обслужен



Это высококачественный пистолет двойного действия, популярен у силовых структур всего мира. Также широко используется армейскими спец подразделениями, такими как Морские Котики США и Британский десант. Хотя он сильно дороже своих конкурентов, но даст отличною надежность и высокую точность. Копировался в Китае и Иране, но был не надежным (Malf 17). Магазин на 20 патронов ($28, 0.8 lb.) доступен с 1987.

В 1995 доступен в калибре 357 SIG: Dmg 3d-1 pi, Shots 13+1, ST 10, Rcl 3. Техасские Рейнджеры используют эту версию. С 1998, так-же предлагается в калибре .40 S&amp;W: Dmg 2d+2 pi+, Shots 13+1.

P228 (1988-1997) с укороченным стволом и рукояткой Dmg 2d+1 pi, Wt. 2.1/0.5, Shots 13+1. В 1992 Армия США приняла его на вооружения под маркой M11 для военной полиции, пилотов и т.п. Многие федеральный агентства типа АТФ, ФБР, и Маршалы используют такие.

P229 (1992-), под .40 S&amp;W: Dmg 2d+1 pi+, Wt. 2.4/0.6, Shots 12+1. А в калибре .357 SIG, P229 с 1999: Dmg 3d-2 pi, Wt. 2.4/0.5, Shots 12+1, ST 10, Rcl 3.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>840/27</value>
	<weight>2.4/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>12+1</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>SIG-Sauer P226 (P229 .357 SIG)</description>
	<description-loc>Германия 1983

<img data-src="http://weapons.gurps.ru/img/16.png">

<img data-src="http://weapons.gurps.ru/img/587.png">

Очень надежный, не клинит при критах если нормально обслужен



Это высококачественный пистолет двойного действия, популярен у силовых структур всего мира. Также широко используется армейскими спец подразделениями, такими как Морские Котики США и Британский десант. Хотя он сильно дороже своих конкурентов, но даст отличною надежность и высокую точность. Копировался в Китае и Иране, но был не надежным (Malf 17). Магазин на 20 патронов ($28, 0.8 lb.) доступен с 1987.

В 1995 доступен в калибре 357 SIG: Dmg 3d-1 pi, Shots 13+1, ST 10, Rcl 3. Техасские Рейнджеры используют эту версию. С 1998, так-же предлагается в калибре .40 S&amp;W: Dmg 2d+2 pi+, Shots 13+1.

P228 (1988-1997) с укороченным стволом и рукояткой Dmg 2d+1 pi, Wt. 2.1/0.5, Shots 13+1. В 1992 Армия США приняла его на вооружения под маркой M11 для военной полиции, пилотов и т.п. Многие федеральный агентства типа АТФ, ФБР, и Маршалы используют такие.

P229 (1992-), под .40 S&amp;W: Dmg 2d+1 pi+, Wt. 2.4/0.6, Shots 12+1. А в калибре .357 SIG, P229 с 1999: Dmg 3d-2 pi, Wt. 2.4/0.5, Shots 12+1, ST 10, Rcl 3.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>840/27</value>
	<weight>2.4/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-2 pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>12+1</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Intratec TEC-9</description>
	<description-loc>США 1985

<img data-src="http://weapons.gurps.ru/img/17.png">

Не надежный - клинит на 16+

Sling swivels (HT154)

Это дешовый, грубый "штурмовой пистолет" имеет псевдо-военную внешность - большой магазин перед курком. Популярен у бандитов. С 1994 выпускается под кучей разных имен с незначительными изменениями (те же характеристики). Доступны укороченный магазин на 20 патронов ($28, 0.8 lb.) и огромный 50-патронный(-1 Bulk, $32, 2 lbs.) магазин.

Эта конструкция одинарного действия часто переделывается под полностью автоматический огонь: Malf. 15, RoF 20!. Предлагался с режимом переключения огня под маркой MP-9 (1985-1989): Malf. 16, Wt. 5.3/1.4, RoF 15, LC2. однако не был коммерчески успешен.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>350/30</value>
	<weight>4.5/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>36(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Intratec TEC-9 (MP-9)</description>
	<description-loc>США 1985

<img data-src="http://weapons.gurps.ru/img/17.png">

Не надежный - клинит на 16+

Sling swivels (HT154)

Это дешовый, грубый "штурмовой пистолет" имеет псевдо-военную внешность - большой магазин перед курком. Популярен у бандитов. С 1994 выпускается под кучей разных имен с незначительными изменениями (те же характеристики). Доступны укороченный магазин на 20 патронов ($28, 0.8 lb.) и огромный 50-патронный(-1 Bulk, $32, 2 lbs.) магазин.

Эта конструкция одинарного действия часто переделывается под полностью автоматический огонь: Malf. 15, RoF 20!. Предлагался с режимом переключения огня под маркой MP-9 (1985-1989): Malf. 16, Wt. 5.3/1.4, RoF 15, LC2. однако не был коммерчески успешен.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>350/30</value>
	<weight>5.3/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>36(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Lorcin L-25</description>
	<description-loc>США 1989

<img data-src="http://weapons.gurps.ru/img/18.png">

<img data-src="http://weapons.gurps.ru/img/617.png">

Нет кольца для шнура (HT154)

Не надежный - клинит на 16+

Этот крошечный пистолет считается одним из самых распространенных в преступном мире Америки 1990х. Ничем больше не знаменит кроме низкой цены и высокой доступности. Одинарного действия, низкая наденость и малая мощность. Продается в разных окрасках (включая черный и золотой, хром и жемчуг, комуюляж, розовый и т.п.) - было выпущено стони тысяч единиц. Его покупали те кто не мог позволить себе более серозный пистолет.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>80/25</value>
	<weight>0.9/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi-</damage>
		<strength>5</strength>
		<accuracy>0</accuracy>
		<range>90/950</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.25 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Desert Eagle</description>
	<description-loc>Израиль 1991

<img data-src="http://weapons.gurps.ru/img/19.png">

Нет кольца для шнура (HT154)

Работает на принципе отвода ствольных газов. Пистолет одинарного действия под крупный калибр появился а конце 80х. С 1991 часто появляется в специальном калибре .50 Action Express. Он ожидаемо мощен но очень большой и его сложно скрыть.

Любители стендовой стрельбы и охотники часто используют Desert Eagle, но полицейские и военные избегают его. Киношники обожают его за его размер. Пистолет требователен к патронам а некоторые недостаточно крепко держат его и не ожидают его чудовищной отдачи (может вывихнуть кисть) оба фактора увеличивают шансы на проблемы - уменьшайте Malf до 16 если стрелок не знаком этим оружием.

Оригинальная версия имела калибр .357 Magnum (1983-): Dmg 3d pi, Wt. 4.2/0.6, Shots 9+1, ST 10, Rcl 2. а следующая версия .44 Magnum (1986-): Dmg 3d+2 pi+, Wt. 4.6/0.7, Shots 8+1, ST 12, Rcl 4.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>1,250/45</value>
	<weight>4.6/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi+</damage>
		<strength>12</strength>
		<accuracy>2</accuracy>
		<range>220/2,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>4</recoil>
		<ammo>.50 AE</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Desert Eagle</description>
	<description-loc>Израиль 1991

<img data-src="http://weapons.gurps.ru/img/19.png">

Нет кольца для шнура (HT154)

Работает на принципе отвода ствольных газов. Пистолет одинарного действия под крупный калибр появился а конце 80х. С 1991 часто появляется в специальном калибре .50 Action Express. Он ожидаемо мощен но очень большой и его сложно скрыть.

Любители стендовой стрельбы и охотники часто используют Desert Eagle, но полицейские и военные избегают его. Киношники обожают его за его размер. Пистолет требователен к патронам а некоторые недостаточно крепко держат его и не ожидают его чудовищной отдачи (может вывихнуть кисть) оба фактора увеличивают шансы на проблемы - уменьшайте Malf до 16 если стрелок не знаком этим оружием.

Оригинальная версия имела калибр .357 Magnum (1983-): Dmg 3d pi, Wt. 4.2/0.6, Shots 9+1, ST 10, Rcl 2. а следующая версия .44 Magnum (1986-): Dmg 3d+2 pi+, Wt. 4.6/0.7, Shots 8+1, ST 12, Rcl 4.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>1,250/45</value>
	<weight>4.6/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+2 pi+</damage>
		<strength>12</strength>
		<accuracy>2</accuracy>
		<range>220/2,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1</shots>
		<bulk>-4</bulk>
		<recoil>4</recoil>
		<ammo>.44 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Desert Eagle</description>
	<description-loc>Израиль 1991

<img data-src="http://weapons.gurps.ru/img/19.png">

Нет кольца для шнура (HT154)

Работает на принципе отвода ствольных газов. Пистолет одинарного действия под крупный калибр появился а конце 80х. С 1991 часто появляется в специальном калибре .50 Action Express. Он ожидаемо мощен но очень большой и его сложно скрыть.

Любители стендовой стрельбы и охотники часто используют Desert Eagle, но полицейские и военные избегают его. Киношники обожают его за его размер. Пистолет требователен к патронам а некоторые недостаточно крепко держат его и не ожидают его чудовищной отдачи (может вывихнуть кисть) оба фактора увеличивают шансы на проблемы - уменьшайте Malf до 16 если стрелок не знаком этим оружием.

Оригинальная версия имела калибр .357 Magnum (1983-): Dmg 3d pi, Wt. 4.2/0.6, Shots 9+1, ST 10, Rcl 2. а следующая версия .44 Magnum (1986-): Dmg 3d+2 pi+, Wt. 4.6/0.7, Shots 8+1, ST 12, Rcl 4.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>1,250/45</value>
	<weight>4.2/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>220/2,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>9+1</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>.357 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K USP</description>
	<description-loc>Германия 1993

<img data-src="http://weapons.gurps.ru/img/20.png">

Полозья для навесного (HT161)

Очень надежный, не клинит при критах если нормально обслужен



"Универсальный самозарядный пистолет" первый пистолет H&amp;K разработанный для Американских стрелков. Это популярное оружие получило от Браунинга полимерную раму с подствольными полозьями для навесного. Уважаем за свою надежность и точность.

Силовые структуры предпочитают калибр  .40 S&amp;W, но остальные военные покупатели выбирают либо 9x19mm Parabellum либо .45 ACP. Первая - модель P8, на вооружении немецкой армии с 1997: Dmg 2d+2 pi, Wt. 2.1/0.5, Shots 15+1. Вторая популярна в гражданских: Dmg 2d pi+, Wt. 2.5/0.8, Shots 12+1, ST 10, Rcl 3, Cost $840.

USP Compact (1997-) несколько меньшего размера, доступен в тех-же калибрах. Версия 9x19mm (под названием P10 в германии) популярна у полицейских: Dmg 2d+1 pi, Wt. 2/0.5, Shots 13+1, Cost $800.  Иммиграционная служба США предпочитает 40 S&amp;W: Dmg 2d+1 pi+, Wt. 2/0.5, Shots 12+1, Cost $800. Так-же бывает в калибре .45 ACP: Dmg 2d pi+, Wt. 2.1/0.6, Shots 8+1, ST 10, Rcl 3, Cost $900.

USP Tactical (1998-) версия с возможностью установить глушитель  (1-lb., -2 to Hearing, -1 Bulk). Спецслужбы Германии используют его в калибре .45 ACP под маркировкой P12: Dmg 2d pi+, Wt. 2.5/0.8, Shots 12+1, ST 10, Rcl 3, Cost $1,100.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>770/32</value>
	<weight>2.3/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi+</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>13+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Самозарядный Пистолет Сердюкова (СПС) Гюрза</description>
	<description-loc>Россия / СССР 1994

<img data-src="http://weapons.gurps.ru/img/21.png">

Высокой емкости, с безопасным курком для работы против противника в броне (стреляет APHC). Один из первых российских пистолетов в синтетической рамой, используется Российскими спецслужбами и спецназом.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>450/27</value>
	<weight>2.9/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-2(2) pi-</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>18+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x21mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN Five-seveN</description>
	<description-loc>Бельгия 1996

<img data-src="http://weapons.gurps.ru/img/22.png">

Полозья для навесного (HT161)

Пистолет двойного действия разрабатывался как спутник P90 PDW, стреляет тем-же APHC патроном. Несколько спец подразделений приняло их на вооружение. Имеет подсвтольные полозья и может быть оснащено глушителем (0.4-lb., -3 Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>750/38</value>
	<weight>1.7/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2(2) pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>170/1,700</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>5.7x28mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Walther P99</description>
	<description-loc>Германия 1996

<img data-src="http://weapons.gurps.ru/img/23.png">

<img data-src="http://weapons.gurps.ru/img/592.png">

Полозья для навесного (HT161)

Это современный пистолет на синтетической раме безбойковый, способен стрелять а режиме двойного действия и одинарного. Ручка со сменной нижней частью позволяет настроить его под разный размер руки. Полицейский Англии, Германии, Испании, Таиланда и и еще нескольких стран используют их. Выпускается по лицензии в Польше. Со специальным резьбовым стволом можно установить глушитель.  (0.9-lb., -2 Hearing, -1 Bulk). С 1998, доступен в калибре .40 S&amp;W: Dmg 2d+1 pi+, Shots 12+1.

P99 Compact (2004-) меньше: Wt. 1.5/0.4, Shots 10+1, Bulk -1.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>610/39</value>
	<weight>2/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>140/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>16+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Walther P99</description>
	<description-loc>Германия 1996

<img data-src="http://weapons.gurps.ru/img/23.png">

<img data-src="http://weapons.gurps.ru/img/592.png">

Полозья для навесного (HT161)

Это современный пистолет на синтетической раме безбойковый, способен стрелять а режиме двойного действия и одинарного. Ручка со сменной нижней частью позволяет настроить его под разный размер руки. Полицейский Англии, Германии, Испании, Таиланда и и еще нескольких стран используют их. Выпускается по лицензии в Польше. Со специальным резьбовым стволом можно установить глушитель.  (0.9-lb., -2 Hearing, -1 Bulk). С 1998, доступен в калибре .40 S&amp;W: Dmg 2d+1 pi+, Shots 12+1.

P99 Compact (2004-) меньше: Wt. 1.5/0.4, Shots 10+1, Bulk -1.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>610/39</value>
	<weight>2/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>140/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>12+1</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Walther P99 (P99 Compact)</description>
	<value>610/39</value>
	<weight>1.5/0.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+1 pi</damage>
		<strength>10+1</strength>
		<accuracy>2</accuracy>
		<range>140/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>16+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1996
		<img data-src="http://weapons.gurps.ru/img/23.png">
		<img data-src="http://weapons.gurps.ru/img/592.png">
		Полозья для навесного (HT161)

Это современный пистолет на синтетической раме безбойковый, способен стрелять а режиме двойного действия и одинарного. Ручка со сменной нижней частью позволяет настроить его под разный размер руки. Полицейский Англии, Германии, Испании, Таиланда и и еще нескольких стран используют их. Выпускается по лицензии в Польше. Со специальным резьбовым стволом можно установить глушитель.  (0.9-lb., -2 Hearing, -1 Bulk). С 1998, доступен в калибре .40 S&amp;W: Dmg 2d+1 pi+, Shots 12+1.

P99 Compact (2004-) меньше: Wt. 1.5/0.4, Shots 10+1, Bulk -1.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Kahr K40</description>
	<description-loc>США 1997

<img data-src="http://weapons.gurps.ru/img/24.png">

Нет кольца для шнура (HT154)

Исключительно двойного действия, сделан из нержавеющей стали, автоматический. Столько удобный для скрытного ношения как Walther PPK но стреляет серьезным калибром. Популярен как  второй пистолет, и для полицейских под прикрытием.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>720/37</value>
	<weight>1.9/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>140/1,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6+1(3)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Collier</description>
	<description-loc>Великобритания 1818

<img data-src="http://weapons.gurps.ru/img/25.png">

Очень ненадежный - клинит на 14+

Нет кольца для шнура (HT154)



Револьвер одинарного действия с зарядкой через ствол. Кремневый замок, самовзводная скоба. В ударнике достаточно порошка для 10 выстрелов и он автоматически ударяет по скобе при взводе курка - все это уменьшает время на перезарядку. Плотная прокладка между цилиндром и стволом увеличивает мощность, уменьшает загрязнения, и выстрелы “в обратку” и прочие поломки. Было выпущено всего несколько штук. </description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>500</value>
	<weight>2.3/0.13</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>70/800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(10i)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.50 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Allen Pepperbox</description>
	<description-loc>США 1837

<img data-src="http://weapons.gurps.ru/img/26.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Это прародитель револьверов, место одного ствола у него было шесть под каждую пулю. Был популярен с 1830х по 1950е когда настоящие револьверы вытеснили его. Разработан Итаном Аленом, двойного действия, гладкоствольный, прозванный "перечница" за отверстия. Десятки тысяч были выпущены. Оно было популярно у гражданских в Британии и США широко использовалось во время Золотой Лихорадки в калифорнии, некоторые использовались даже в Гражданской Войне США.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>150</value>
	<weight>1.8/0.04</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi-</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>30/330</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(30i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.31 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Number 5</description>
	<description-loc>США 1838

<img data-src="http://weapons.gurps.ru/img/27.png">

<img data-src="http://weapons.gurps.ru/img/540.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Так-же известен как “Texas Paterson” - крупнейший револьвер одиночного действия выпущенный  Colt в Патерсоне, Нью Джерси. Его называли "оружием сделавшим людей равными". Это был первый револьвер массового производства - около 1,000 было выпущено. 

Для перезарядки барабан необходимо было снимать. Суммарное время на съем и установку барабана - 15 сек. Далее заряжается каждая пороховая пуля отдельно, но подготовленный сменный барабан ($130, 0.8 lb.) сильно ускорит процесс.

Number 1 Pocket Model (1837-1838) намного меньше, калибр .28: Dmg 1d-2 pi-, Acc 1, Range 40/450, Wt. 2/0.03, Bulk -1, ST 5, Cost $300. Было выпущено 500 единиц.

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>2.8/0.07</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(30i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.36 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Number 5 (Number 1 Pocket Model)</description>
	<description-loc>США 1838

<img data-src="http://weapons.gurps.ru/img/27.png">

<img data-src="http://weapons.gurps.ru/img/540.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Так-же известен как “Texas Paterson” - крупнейший револьвер одиночного действия выпущенный  Colt в Патерсоне, Нью Джерси. Его называли "оружием сделавшим людей равными". Это был первый револьвер массового производства - около 1,000 было выпущено. 

Для перезарядки барабан необходимо было снимать. Суммарное время на съем и установку барабана - 15 сек. Далее заряжается каждая пороховая пуля отдельно, но подготовленный сменный барабан ($130, 0.8 lb.) сильно ускорит процесс.

Number 1 Pocket Model (1837-1838) намного меньше, калибр .28: Dmg 1d-2 pi-, Acc 1, Range 40/450, Wt. 2/0.03, Bulk -1, ST 5, Cost $300. Было выпущено 500 единиц.

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>2/0.03</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-2 pi-</damage>
		<strength>5</strength>
		<accuracy>1</accuracy>
		<range>40/450</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(30i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.28</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M1848 Dragoon</description>
	<description-loc>США 1848

<img data-src="http://weapons.gurps.ru/img/28.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Это первый револьвер Кольта который стал действительно успешен. Крупный пистолет, из за его размера (35 см длиной, 18 см ствол) и веса (4lbs) его часто носили в сабельном чехле вместо кобуры. Он так-же было одним из самых мощных черно пороховых пистолетов, заряжался патроном такой длины что позавидуют некоторые винтовки. Кольт выпустил более 20,000 штук, и копии делались в Европе и Южной Конфедерации. К некоторым можно было присоединить деревянный приклад (1lbs, +1 Acc, -1 Bulk).

Перед Драгуном был еще больший револьвер  Colt M1847 Walker (1847-1848) (Dmg 2d+2 pi+, Range 110/1,200, Wt. 4.7/0.15, Bulk -4, Cost $550.) Однако мог взорваться при использовании - Mals означает что пистолет разорвало а стрелок получил 1d cr ex повреждений. Была выпущена тысяча единиц для армии США и еще сто для продажи гражданским. выпускался по лицензии в Австрии.

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>4.2/0.14</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(10i)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>.44 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M1851 Navy</description>
	<description-loc>США 1851

<img data-src="http://weapons.gurps.ru/img/29.png">

<img data-src="http://weapons.gurps.ru/img/541.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Это популярный револьвер одинарного действия получил свое название (Navy) из за сцены выгравированной не барабане - изображена сцена морского боя между Техасом и Мексикой. Это крупный пистолет - ствол 18см стал знаменит за хорошую развесовку и точность. Вместе с низкой отдачей, он стал любимцем у стрелков на точность, но был недостаточно мощен. Было выпущено 250,000 в США и Англии а так-же копировался в Южной Конфедерации. "Дикий Билл" Хичхок носил два таких заткнутыми за пояс.

Для перезарядки барабан необходимо было снимать. Суммарное время на съем и установку барабана - 15 сек. Далее заряжается каждая пороховая пуля отдельно, но подготовленный сменный барабан ($90, 0.8 lb.) сильно ускорит процесс.

К некоторым можно было присоединить деревянный приклад (1lbs, +1 Acc, -1 Bulk). Были даже полые приклады которые можно было использовать как контейнер. С 1875 часто конвертировался под калибр .38 Long Colt cartridges (Dmg 2d pi, Shots 6(3i)).

M1860 Army (1860-1873) под калибр .44 был на вооружении армии Объединения в Гражданской Войне США: Dmg 1d+2 pi+, Range 100/1,100, Wt. 2.9/0.2, ST 10, Bulk -3, Rcl 3, Cost $400. (запасной барабан $130, 0.9 lb.) Было выпущено более 200,000. С 1873 часто конвертировался под .44 Colt : Dmg 2d-1 pi+, Shots 6(3i).

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>275</value>
	<weight>2.9/0.14</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(10i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.36 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M1851 Navy (M1860 Army)</description>
	<description-loc>США 1851

<img data-src="http://weapons.gurps.ru/img/29.png">

<img data-src="http://weapons.gurps.ru/img/541.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Это популярный револьвер одинарного действия получил свое название (Navy) из за сцены выгравированной не барабане - изображена сцена морского боя между Техасом и Мексикой. Это крупный пистолет - ствол 18см стал знаменит за хорошую развесовку и точность. Вместе с низкой отдачей, он стал любимцем у стрелков на точность, но был недостаточно мощен. Было выпущено 250,000 в США и Англии а так-же копировался в Южной Конфедерации. "Дикий Билл" Хичхок носил два таких заткнутыми за пояс.

Для перезарядки барабан необходимо было снимать. Суммарное время на съем и установку барабана - 15 сек. Далее заряжается каждая пороховая пуля отдельно, но подготовленный сменный барабан ($90, 0.8 lb.) сильно ускорит процесс.

К некоторым можно было присоединить деревянный приклад (1lbs, +1 Acc, -1 Bulk). Были даже полые приклады которые можно было использовать как контейнер. С 1875 часто конвертировался под калибр .38 Long Colt cartridges (Dmg 2d pi, Shots 6(3i)).

M1860 Army (1860-1873) под калибр .44 был на вооружении армии Объединения в Гражданской Войне США: Dmg 1d+2 pi+, Range 100/1,100, Wt. 2.9/0.2, ST 10, Bulk -3, Rcl 3, Cost $400. (запасной барабан $130, 0.9 lb.) Было выпущено более 200,000. С 1873 часто конвертировался под .44 Colt : Dmg 2d-1 pi+, Shots 6(3i).

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>2.9/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(10i)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>.44</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Beaumont-Adams Mk I</description>
	<description-loc>Великобритания 1853

<img data-src="http://weapons.gurps.ru/img/30.png">

Не надежный - клинит на 16+



Один из первых револьверов двойного действия, Адамас заменил Colt M1851 в Британской армии с 1855. Выпускался по лицензии копировался в Австрии, Бельгии, Пруссии, и Соединенных Штатах. В США военный калибр был .36-caliber (Dmg 1d+2 pi). В отличии от большинства револьверов TL5 этот был достаточно ненадежен.

Выпускался под разные патроны.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>2.5/0.11</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(10i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.442 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Lefaucheux Mle 1854</description>
	<description-loc>Франция 1854

<img data-src="http://weapons.gurps.ru/img/31.png">

Заряжаемый сбоку, револьвер одинарного действия, под один из первых патронов с металлической гильзой. Французские морские пехотинцы получили его в 1858. Сотни тысяч были выпущены для коммерческой продажи - включая копии в Бельгии, Франции, Германии, Испании и много где еще. Армия Объединения закупила 12,000 таких в 1861-1862.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>270</value>
	<weight>2.3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(5i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>12x16mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Number 1</description>
	<description-loc>США 1857

<img data-src="http://weapons.gurps.ru/img/32.png">

Револьвер одинарного действия, первый американский револьвер с металлическим патроном, мелкий патрон был эффективен только на близкой дистанции. Был популярен в качестве табельного оружия поддержки у военных во времена Американской Гражданской Войны. Было выпущено 260,00 штук.

Для перезарядки необходимо полностью снять барабан. Время на снятие и установку барабана 15 сек. Вытащить гильзу и вставить новый патрон - еще по 5 сек за патрон.

В 1870х многие производители выпустили сотни тысяч подобных револьверов. Некоторые были двойного действия, но низкого качества Malf. 16, RoF 3, and Cost $75.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>280</value>
	<weight>1/0.04</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-1 pi-</damage>
		<strength>7</strength>
		<accuracy>2</accuracy>
		<range>50/550</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>7(5i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.22 Short</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Number 1 (double-action)</description>
	<description-loc>США 1857

<img data-src="http://weapons.gurps.ru/img/32.png">

Револьвер одинарного действия, первый американский револьвер с металлическим патроном, мелкий патрон был эффективен только на близкой дистанции. Был популярен в качестве табельного оружия поддержки у военных во времена Американской Гражданской Войны. Было выпущено 260,00 штук.

Для перезарядки необходимо полностью снять барабан. Время на снятие и установку барабана 15 сек. Вытащить гильзу и вставить новый патрон - еще по 5 сек за патрон.

В 1870х многие производители выпустили сотни тысяч подобных револьверов. Некоторые были двойного действия, но низкого качества Malf. 16, RoF 3, and Cost $75.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>75</value>
	<weight>1/0.04</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-1 pi-</damage>
		<strength>7</strength>
		<accuracy>2</accuracy>
		<range>50/550</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7(5i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.22 Short</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Girard LeMat</description>
	<description-loc>Франция 1861

<img data-src="http://weapons.gurps.ru/img/33.png">

Не надежный - клинит на 16+



Разработан Александром ЛеМат-ом из Нового Орлеана, этот необычный револьвер одинарного действия заряжаемый через ствол имел девать патронов в барабане а посередине 18G гладкоствол. Около 2,200 было выпущено для Конфедерации (и еще 1,000 в Британии)  и использовался в Американской Гражданской Войне.

Боек может быть переведен (Ready маневр) чтобы стрелять из наружнего створа или из внутреннего. Короткий ствол - Dmg 1d(0.5) pi-, Acc 1, Range 30/600, RoF 1x11, Shots 1(15i), Rcl 1.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>3.7/0.16</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>60/700</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>9(10i)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.42 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Girard LeMat (Short barrel)</description>
	<value>250</value>
	<weight>3.7/0.16</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d(0.5) pi-</damage>
		<accuracy>1</accuracy>
		<range>30/600</range>
		<rate_of_fire>1x11</rate_of_fire>
		<shots>1(15i)</shots>
		<recoil>1</recoil>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<tech_level>5</tech_level>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Франция</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Франция 1861
		<img data-src="http://weapons.gurps.ru/img/33.png">
		Не надежный - клинит на 16+



Разработан Александром ЛеМат-ом из Нового Орлеана, этот необычный револьвер одинарного действия заряжаемый через ствол имел девать патронов в барабане а посередине 18G гладкоствол. Около 2,200 было выпущено для Конфедерации (и еще 1,000 в Британии)  и использовался в Американской Гражданской Войне.

Боек может быть переведен (Ready маневр) чтобы стрелять из наружнего створа или из внутреннего. Короткий ствол - Dmg 1d(0.5) pi-, Acc 1, Range 30/600, RoF 1x11, Shots 1(15i), Rcl 1.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington New Model Army</description>
	<description-loc>США 1863

<img data-src="http://weapons.gurps.ru/img/34.png">

Не надежный - клинит на 16+

Был принят на вооружение во время Американской Гражданской Войны. Револьвер одинарного действия с 20см стволом. Позже стал популярен у гражданских. Было выпущено 140,000.

Для перезарядки барабан необходимо было снимать. Суммарное время на съем и установку барабана - 10 сек. Далее заряжается каждая пороховая пуля отдельно, но подготовленный сменный барабан ($70, 1 lb.) сильно ускорит процесс.

С 1871 большинство было конвертировано под калибр .44 Colt: Dmg 2d-1 pi+, Shots 6(3i).</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>200</value>
	<weight>2.9/0.14</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(10i)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.44 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Webley RIC Number 1</description>
	<description-loc>Великобритания 1868

<img data-src="http://weapons.gurps.ru/img/35.png">

Нет кольца для шнура (HT154)



Компактный револьвер двойного действия, ствол 9см для облегчения скрытного ношения. Быстро стал популярен как средство самообороны. Копии выпускались в Европе и США.

Кроме твердых пуль способен стрелять  SAPLE (Dmg 1d+2 pi+ с последующим 1d-3 [1d-2] cr ex)

British Bulldog Number 2 (1878-1914) имел еще более короткий ствол Wt. 1.4/0.3, Shots 5(5i) был доступен в калибрах  .44 Russian (Dmg 1d+2 pi+) и .450 Adams (Dmg 1d+1 pi+); позже еще и .455 Webley (Dmg 1d+2 pi+). Было выпущено около 100,000 единиц.

Полиция Лондона использовала похожий револьвер the M.P. Model (1883-1884) под патрон .450 Adams : Dmg 1d+1 pi+, Wt. 1.5/0.3. который иногда называли Шерлок Холмс.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>2.2/0.26</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(5i)</shots>
		<bulk>-1</bulk>
		<recoil>3</recoil>
		<ammo>.442 RIC</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Number 3</description>
	<description-loc>США 1871

<img data-src="http://weapons.gurps.ru/img/36.png">

В 1869 Smith &amp; Wesson представили свой первый крупно калиберный револьвер - одиночного действия  .44 American (Dmg 2d-1 pi+). Это была ранняя преламываемываемая сверху конструкция, с автоматическим эксрактором. Российская Империя приняла его на вооружение в 1871, с несколько измененным патроном, но размеры были столь похожи, что патроны обычно подходили один к другому. Лучший по точности пистолет тех дней он установил много мировых рекордов.

Было выпущено 206,000 единиц, половина из них была закуплена Россией. Так-же использовались армией Аргентины, Колониальной Полицией Австралии, Японской морской пехотой и Испанской Армией. Турция приняла на вооружение в калибре .44 Henry (Dmg 2d pi+). Лицензированные и не лицензированные копии производились в большинстве стран. Россия выпустила сотни тысяч, некоторые использовались даже во Вторую Мировую Войну.

Number 3 Schofield (1875-1877) младшая версия под .45 S&amp;W для офицеров кавелерии (Dmg 2d-1 pi+, Wt. 2.5/0.3) было выпущено менее 9,000. Большая часть использовалась Армией США особенно в 9 и 10 кавалерии. Так-же выпускались с укороченным стволом. Некоторые стрелки приобретали их потому, что им можно было перезаряжать быстрее. </description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>550</value>
	<weight>2.5/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.44 Russian</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M1873 SAA</description>
	<description-loc>США 1873

<img data-src="http://weapons.gurps.ru/img/37.png">

Нет кольца для шнура (HT154)



Знаменитый револьвер одинарного действия, имел много названий такие как SAA (Single-Action Army), “Peacemaker”, “Frontier Six-Shooter”, “Thumb-Buster”,  “Hog-Leg.”  В 1873 армия США приняла его на вооружение заменяя весь зоопарк патронов и пистолетов. Он был чрезвычайно мощен для своих дней но имел сильную отдачу. С 1875  стал использоваться более короткий .45 S&amp;W альтернативный патрон: Dmg 2d-1 pi+, ST 10, Rcl 3.

Вообще он исполняя более чем в трех десятках разных калибров, но самым основным был .45 Long Colt он винтовки Винчестер, что позволяло мнется патронами патронами.  С 1878 доступен не менее популярный 44-40 Winchester: Dmg 2d+2 pi+

Colt M1873 Cavalry версия со стволом 18 см, но выпускался и в других размерах. Таких как 10см: Dmg 2d+1 pi+, Wt.2.6  и 8см Dmg 2d pi+, Acc 1, Wt. 2.5. Последняя без эксрактора. 

В армии был снят с вооружения в 1892 а в полиции служил до 1940х. До сих пор выпускается для гражданских стрелков и энтузиастов. Было выпущено  575,000. Было много копий, некоторые вполне удачны а стоят пол цены.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>500</value>
	<weight>3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-2 pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>6(5i)</shots>
		<bulk>-2</bulk>
		<recoil>4</recoil>
		<ammo>.45 LongColt</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Safety Hammerless</description>
	<description-loc>США 1887

<img data-src="http://weapons.gurps.ru/img/38.png">

Нет кольца для шнура (HT154)



Отличный Американский пистолет для скрытного ношения конца 19, начала 20го века. Небольшой револьвер двойного действия, открываемый переломом сверху, с эксрактором, имеет гладкие очертания. Часто называли "соковыжималкой" из за отсутствия бойка его часто брали неправильно - как лимон над чашкой чая. Его можно безопасно носить в кармане (и даже стрелять из кармана с - 2) что сделало его любимчиком преступного мира и полицейских. более 260,000 было выпущено не считая множества копий.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>1.3/0.17</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>7</strength>
		<accuracy>0</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.38 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Наган</description>
	<description-loc>Россия / СССР 1895

<img data-src="http://weapons.gurps.ru/img/39.png">

<img data-src="http://weapons.gurps.ru/img/535.png">

Револьвер разработанный Наганом (Бельгия) был принят на вооружение Российской армией в 1895. Оружие производилось вплоть до Второй Мировой Войны. Танковый экипаж Советской армии был вооружен ими вместо Токарева. Было выпущено более 2 миллионов в Бельгии, Польше и России и поставлялись во все остальные страны восточной Европы и Азии. 

Наган заряжается сбоку имеет экстрактор и бывает одинарного и двойного действия. Пули обычно закрыты барабаном. Когда пистолет стреляет - цилиндр смещается вперед и прижимается к стволу что препятствует выбросу газов. Что делает его одним из немногих револьверов к которым применим глушитель.

НКВД использовали “Наган Бесшумный” (1931-1942) Dam 1d+1 pi-, Range 110/1,200, Wt. 2.7/0.2, RoF 1, Bulk -3, Cost $750. Он было одинарного действия и имел комбинированный мембранно-тряпочный глушитель (-2 к слуху и еще -1 за конструкцию нагана). У него небыло экстрактора.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>2/0.25</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>140/1,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>7(5i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Наган (Бесшумный)</description>
	<description-loc>Россия / СССР 1895

<img data-src="http://weapons.gurps.ru/img/39.png">

<img data-src="http://weapons.gurps.ru/img/535.png">

Револьвер разработанный Наганом (Бельгия) был принят на вооружение Российской армией в 1895. Оружие производилось вплоть до Второй Мировой Войны. Танковый экипаж Советской армии был вооружен ими вместо Токарева. Было выпущено более 2 миллионов в Бельгии, Польше и России и поставлялись во все остальные страны восточной Европы и Азии. 

Наган заряжается сбоку имеет экстрактор и бывает одинарного и двойного действия. Пули обычно закрыты барабаном. Когда пистолет стреляет - цилиндр смещается вперед и прижимается к стволу что препятствует выбросу газов. Что делает его одним из немногих револьверов к которым применим глушитель.

НКВД использовали “Наган Бесшумный” (1931-1942) Dam 1d+1 pi-, Range 110/1,200, Wt. 2.7/0.2, RoF 1, Bulk -3, Cost $750. Он было одинарного действия и имел комбинированный мембранно-тряпочный глушитель (-2 к слуху и еще -1 за конструкцию нагана). У него небыло экстрактора.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>750</value>
	<weight>2.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>7(5i)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Webley-Fosbery Mk I</description>
	<description-loc>Великобритания 1901

<img data-src="http://weapons.gurps.ru/img/40.png">

Не надежный - клинит на 16+



Это крупный револьвер двойного действия, открываемый на перелом, похожий не остальные модели Webley, но вся верхняя часть включая ствол и барабан откатывается назад при отдаче при этом превзводя курок и вращая цилиндр. Это уменьшат отдачу, но к сожалению и надежность. Он не стал коммерчески успешным, всего было выпущено 4,750 единиц. Несколько были куплены Британскими офицерами во время Первой Мировой. Это оружие хорошо подходит к приключениям в стиле stampunk!

Около 800 единиц было выпущено в калибре .38 ACP (1902-1904): Dmg 2d+1 pi, Wt. 2.4/0.2, Shots 8(3i) Восьмизарядный магазин перезаряжался всего 5 секунд.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi+</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.455 Webley</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 10 Military &amp; Police</description>
	<description-loc>США 1902

<img data-src="http://weapons.gurps.ru/img/41.png">

Нет кольца для шнура (HT154)



Сменил несколько названий и мелких версий, этот револьвер двойного действия с откидным барабаном, был самым распространенным полицейским оружием в Америке 20го века. На пике его популярности четыре из пяти полицейских носили такой. В дополнение армия США так-же использовала его. Он выпускается по сей день

На данный момент более шести миллионов выпущено и распространено по всему миру. Длина ствола варьируется от 5 см до 20 см, бывают настраиваемые прицелы, разные рукоятки и даже окраска от полицейского синего до золотого. С 1958 самая распространенная версия - 10см ствол, фирксированные прицелы - именно его называют Model 10

Model 64 M&amp;P (1964-) такой-же пистолет но из нержавеющей стали Wt. 2.3/0.2, Cost $580

Victory (1942-1944) максимально простая модель "без выкрутасов" на время войны - использовался Армией США. Поставлялся в Британию и Альянсу в калибре .38 S&amp;W: Dmg 2d-1 pi.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>500</value>
	<weight>2/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>9</strength>
		<accuracy>2</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.38 Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W .44 Hand Ejector</description>
	<description-loc>США 1908

<img data-src="http://weapons.gurps.ru/img/42.png">

Револьвер двойного действия, первый американский револьвер позволяющий быстрое выбрасывание гильз и перезарядку через откидной барабан. Выпускался в разных размерах, но большие модели обычно были .44 Special. Однако производился и .44-40 Winchester (Dmg 2d+1 pi+) и .45 Long Colt (Dmg 3d-2 pi+). Более 56,000 единиц было продано в розницу и почти 80,000 поставлено в Британской и Канадской армиям в период Первой Мировой Войны калибром .455 Webley (Dmg 1d+2 pi+).

M1917 (1917-1941) Был на вооружении армии США, калибр .45 ACP (Dmg 2d pi+). Двух и трех патронные клипы в виде полумесяца позволяли заряжать оружие ускорено - такая перезарядка требует 7 секунд на все. Без них перезарядка по 4 секунды на патрон.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>2.5/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>140/1,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.44 Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Webley Mk VI</description>
	<description-loc>Великобритания 1915

<img data-src="http://weapons.gurps.ru/img/43.png">

Был последним в линейке крупнокалиберных открываемых переломом револьверов двойного действия Webley. Был стандартным оружием союзников времен первой мировой войны и дослужил до второй мировой. Полицейские использовали их в 30х годах. более 300,000 было выпущено.

Британская армия использовала модель под калибр .455 Webley (бездымные). Но так-же мог стрелять 442 RIC и.450 Adams. Во время Первой Мировой, некоторые модифицировались под калибр .45 ACP -  двух и трех патронные клипы в виде полумесяца позволяли заряжать оружие ускорено - такая перезарядка требует 7 секунд на все. Без них перезарядка по 4 секунды на патрон. 

Первым в линейке был Webley Mk I (1887-1897), под дымный порох калибром .442 RIC. 

Enfield Number 2 Mk I (1936-1945) был основан на Webley но меньшего калибра - 38 S&amp;W: Dmg 2d-2 pi, Wt. 1.8/0.2. С 1938 у него отсутствуют внешние бойки и он ведет стрельбу двойным действием (Acc 1). Был на вооружении Британии до 1957.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>2.7/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi+</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.455 Webley</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 27</description>
	<description-loc>США 1935

<img data-src="http://weapons.gurps.ru/img/44.png">

Нет кольца для шнура (HT154)



"Самый мощный пистолет в мире" так писали когда-то - крупный револьвер двойного действия с 15 см стволом под калибр .357 Magnum. До  1990х Американские полицейские часто использовали подобные револьверы.

.357 Magnum это удлиненный и усиленный зарядом патрон .38 Special. Патроном .38 Special этот пистолет тоже способен стрелять (Dmg 2d pi, ST 9, Rcl 2), он намного дешевле и пистолет проще контролировать.

Model 19 Combat Magnum (1955-1999) облегченная модель отдельная модель для полицейских с меньшей рамой и укороченным стволом 10см Wt. 2.5. Так же выпускалась со стволом 5см (Dmg 2d+2 pi, Wt. 2.1, Rcl 5, Cost $450)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>3/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>190/2,100</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.357 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 34 Kit Gun</description>
	<description-loc>США 1936

<img data-src="http://weapons.gurps.ru/img/45.png">

Нет кольца для шнура (HT154)



Многие Американские любители отдыха не природе носят с собой такой. Он достаточно мал чтобы поместиться в набор для рыбалки, в рюкзаке или в кармане плаща. Обычно используется для убийства змей, охоты на черепах и хищников.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>1.5/0.05</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi-</damage>
		<strength>8</strength>
		<accuracy>2</accuracy>
		<range>70/1,400</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.22 LR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 36 Chief’s Special</description>
	<description-loc>США 1950

<img data-src="http://weapons.gurps.ru/img/46.png">

Нет кольца для шнура (HT154)



Револьвер двойного действия, построенный на самой маленькой раме S&amp;W с "коротким носом" - ствол 2.5 см - был разработан для тех кто часто носит оружие скрытно - детективов и полицейских следователей. Иногда использовался как оружие поддержки, часто в кобуре на лодыжке. Многие полицейские приняли его на вооружение.

Model 37 Chief’s Special Airweight (1952-) на легкосплавной раме: Wt. 1/0.17, Cost $570.

Model 60 Chief’s Special Stainless (1965-1996) первый пистолет из нержавеющей стали: Cost $590.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>475</value>
	<weight>1.4/0.17</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.38 Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Python</description>
	<description-loc>США 1955

<img data-src="http://weapons.gurps.ru/img/47.png">

Нет кольца для шнура (HT154)



В свое время это был возможно самый престижный пистолет Америки. Он был известен за идеальную точность, имел настраиваемые прицелы. Так же производил хороший психологический эффект своим тяжелым стволом с перфорацией на 15 см. Был на вооружении в полиции, но основным покупателем были частные лица любящие стрельбу.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>850</value>
	<weight>2.9/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>190/2,100</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.357 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 29</description>
	<description-loc>США 1955

<img data-src="http://weapons.gurps.ru/img/48.png">

<img data-src="http://weapons.gurps.ru/img/538.png">

<img data-src="http://weapons.gurps.ru/img/539.png">

Нет кольца для шнура (HT154)



Модель с крупной рамой, под калибр .44 magnum позволяет так-же стреляь короткими более управляемыми .44 Special (Dmg 2d pi+, ST 10, Rcl 3).



Стандартная версия со стволом 15см, но быват и укороченная 10см (Dmg 3d+1 pi+, Wt. 3) и огромный 20см ствол (Dmg 4d pi+, Wt. 3.5, ST 13). Smith &amp; Wesson долго являлся монополистом на .44 Magnum двойного действия;

C 1965 по 1975, он часто продавался за удвоенную или утроенную цену, из за высокого спроса.

Заменила Model 629 (1978-) Wt. 3.1, Cost $770.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>3.3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+2 pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>210/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-3</bulk>
		<recoil>4</recoil>
		<ammo>.44 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 29 (4 inch)</description>
	<description-loc>США 1955

<img data-src="http://weapons.gurps.ru/img/48.png">

<img data-src="http://weapons.gurps.ru/img/538.png">

<img data-src="http://weapons.gurps.ru/img/539.png">

Нет кольца для шнура (HT154)



Модель с крупной рамой, под калибр .44 magnum позволяет так-же стреляь короткими более управляемыми .44 Special (Dmg 2d pi+, ST 10, Rcl 3).



Стандартная версия со стволом 15см, но быват и укороченная 10см (Dmg 3d+1 pi+, Wt. 3) и огромный 20см ствол (Dmg 4d pi+, Wt. 3.5, ST 13). Smith &amp; Wesson долго являлся монополистом на .44 Magnum двойного действия;

C 1965 по 1975, он часто продавался за удвоенную или утроенную цену, из за высокого спроса.

Заменила Model 629 (1978-) Wt. 3.1, Cost $770.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+1 pi+</damage>
		<strength>11</strength>
		<accuracy>2</accuracy>
		<range>210/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-3</bulk>
		<recoil>4</recoil>
		<ammo>.44 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>S&amp;W Model 29 (8.4 inch)</description>
	<description-loc>США 1955

<img data-src="http://weapons.gurps.ru/img/48.png">

<img data-src="http://weapons.gurps.ru/img/538.png">

<img data-src="http://weapons.gurps.ru/img/539.png">

Нет кольца для шнура (HT154)



Модель с крупной рамой, под калибр .44 magnum позволяет так-же стреляь короткими более управляемыми .44 Special (Dmg 2d pi+, ST 10, Rcl 3).



Стандартная версия со стволом 15см, но быват и укороченная 10см (Dmg 3d+1 pi+, Wt. 3) и огромный 20см ствол (Dmg 4d pi+, Wt. 3.5, ST 13). Smith &amp; Wesson долго являлся монополистом на .44 Magnum двойного действия;

C 1965 по 1975, он часто продавался за удвоенную или утроенную цену, из за высокого спроса.

Заменила Model 629 (1978-) Wt. 3.1, Cost $770.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>3.5/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>Dmg 4d pi+</damage>
		<strength>13</strength>
		<accuracy>2</accuracy>
		<range>210/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-3</bulk>
		<recoil>4</recoil>
		<ammo>.44 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Charter Arms Undercover</description>
	<description-loc>США 1964

<img data-src="http://weapons.gurps.ru/img/49.png">

<img data-src="http://weapons.gurps.ru/img/537.png">

Нет кольца для шнура (HT154)



5см ствол и гладкие очертания. Это легко скрываемое оружие отличного качества



Bulldog (1973-1996) был немного крупнее и громоздкий, стрелял  .44 Special, но и имел большую отдачу: Dmg 2d pi+, Range 130/1,300, Wt. 1.7/0.2, Bulk -2, Rcl 3, Cost $300. Было выпущено более полумиллиона единиц.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>1.2/0.17</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.38 Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Charter Arms Undercover (Bulldog)</description>
	<description-loc>США 1964

<img data-src="http://weapons.gurps.ru/img/49.png">

<img data-src="http://weapons.gurps.ru/img/537.png">

Нет кольца для шнура (HT154)



5см ствол и гладкие очертания. Это легко скрываемое оружие отличного качества



Bulldog (1973-1996) был немного крупнее и громоздкий, стрелял  .44 Special, но и имел большую отдачу: Dmg 2d pi+, Range 130/1,300, Wt. 1.7/0.2, Bulk -2, Rcl 3, Cost $300. Было выпущено более полумиллиона единиц.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>1.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>130/1,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.44 Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Taurus Mod 608</description>
	<description-loc>США 1999

<img data-src="http://weapons.gurps.ru/img/50.png">

Нет кольца для шнура (HT154)



Крупная рама, нержавеющая сталь для гражданской стрельбы. Встроенный компенсатор, шесть патронов, спортивный пистолет.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>570</value>
	<weight>3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>10</strength>
		<accuracy>2</accuracy>
		<range>190/2,100</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.357 Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ruger Super Redhawk</description>
	<description-loc>США 1999

<img data-src="http://weapons.gurps.ru/img/51.png">

<img data-src="http://weapons.gurps.ru/img/536.png">

Нет кольца для шнура (HT154)

Крупная рама, нержавеющая сталь. Револьвер разработан для стрельбы по силуэтам и охоты. 20см ствол и возможность установить оптический прицел.

Super Redhawk Alaskan (2005-) ствол 6см для скрытого ношения, считается что столь мощен что  способен уложить медведя гризли Dmg 4d pi+, Acc 1, Wt. 3/0.4, Bulk -2, Rcl 6, Cost $820.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>750</value>
	<weight>3.6/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d-1 pi+</damage>
		<strength>12</strength>
		<accuracy>2</accuracy>
		<range>210/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-3</bulk>
		<recoil>5</recoil>
		<ammo>.454 Casull</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ruger Super Redhawk (Super Redhawk Alaskan)</description>
	<description-loc>США 1999

<img data-src="http://weapons.gurps.ru/img/51.png">

<img data-src="http://weapons.gurps.ru/img/536.png">

Нет кольца для шнура (HT154)

Крупная рама, нержавеющая сталь. Револьвер разработан для стрельбы по силуэтам и охоты. 20см ствол и возможность установить оптический прицел.

Super Redhawk Alaskan (2005-) ствол 6см для скрытого ношения, считается что столь мощен что  способен уложить медведя гризли Dmg 4d pi+, Acc 1, Wt. 3/0.4, Bulk -2, Rcl 6, Cost $820.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>820</value>
	<weight>3/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi+</damage>
		<strength>12</strength>
		<accuracy>1</accuracy>
		<range>210/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>6</recoil>
		<ammo>.454 Casull</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Револьверы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Wogdon Dueller</description>
	<description-loc>Великобритания 1760

<img data-src="http://weapons.gurps.ru/img/52.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Производство знаменитого Лондонского оружейника Роберта Вогдона был популярен у Британских и Американских джентельменов. Этот гладкоствольный пистолет был разработан для точной и надежной стрельбы. (Ставки на точность стрельбы было любимой забавой в Британии и Америке).

Продавался вместе с шомполом, пулевой пресс формой, пороховницей, комплектом для чистки и т.п. в дорогом деревянном футляре. Все дуэльные и большинство стрелковых пистолетов продавались парой в футляре. Одиночные экземпляры тоже попадались, но скорее всего ворованные. Указный Rof это самое быстрое время перезарядки, дуэлянты как правило тратили в двое больше что дает +1 Acc</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>2.75/0.023</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi+</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>70/800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>.45 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистоли</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Tower Sea Service P/1796</description>
	<description-loc>Великобритания 1796

<img data-src="http://weapons.gurps.ru/img/53.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Пистолет с кремневым замком принят на вооружение Королевским Военно Морским Флотом. Да и прочие моряки и пираты часто использовали подобные пистоли в течении 18 века. Имеет крючок для того чтобы вешать его на пояс. В реальности он использовался раз за бой, после чего его перехватывали взяв за ствол (маневр Ready) и использовали чтобы бить ручкой (swing+1 cr, Axe/Mace skill)</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>3/0.05</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>70/800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.56 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистоли</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MAS Pistolet AN IX</description>
	<description-loc>Франция 1801

<img data-src="http://weapons.gurps.ru/img/54.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Гладкоствольный пистоль с кремневым замком, использовался кавалерией и драгунами в Войнах Наполеона. Кавалеристы обычно делали скобы или кобуру параллельно седлу лошади. Оружие было достаточно тяжелым чтобы им можно было бить противника после выстрела (swing+1 cr, Axe/Mace Skill). Было выпущено около 66,000.

Mle 1777 (1779-1787) и AN XIII (1806-1817) те-же характеристики, только калибр .69-caliber North &amp; Cheney</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>2.9/0.076</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi++</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>50/550</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>17.1mm-Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистоли</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Rigby Traveling Pistol</description>
	<description-loc>Великобритания 1820

<img data-src="http://weapons.gurps.ru/img/55.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



В конце 18, начале 19 веков постоянно охранялась опасность разбоя - допустим печально известные окрестности Лондона. По этой причине джентельмены часто носили пистоль "путешественника", достаточно малый чтобы его было легко спрятать. Этот гладкоствольный пистоль был сделан семьей Ригби в Дублине, Ирландия.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>1.4/0.075</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi++</damage>
		<strength>10</strength>
		<accuracy>0</accuracy>
		<range>50/550</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.75 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистоли</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Elgin Cutlass Pistol</description>
	<value>300</value>
	<weight>3/0.05</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>70/800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.54 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<melee_weapon>
		<damage>sw-2 cut</damage>
		<strength>6</strength>
		<reach>C,1</reach>
		<parry>-1</parry>
	</melee_weapon>
	<melee_weapon>
		<damage>thr imp</damage>
		<strength>6</strength>
		<reach>С</reach>
		<parry>-1</parry>
	</melee_weapon>	
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Комбинированное</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 1838
		<img data-src="http://weapons.gurps.ru/img/56.png">
		Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Этот гладкоствольный пистолет разработан Джордем Элгином по заказу Морской пехоты США. Имел 30см лезвие под стволом. Морская пехота приобрела всего 150 таких и несколько были проданы гражданским. Расценивайте как большой нож но действия идут с -1 к умению Knife.
	</description-loc>
</equipment>


<equipment version="3">
	<quantity>1</quantity>
	<description>Deringer</description>
	<description-loc>США 1850

<img data-src="http://weapons.gurps.ru/img/57.png">

Не надежный - клинит на 16+

Нет кольца для шнура (HT154)



Сделан Генри Деренжером из Филадельфии это был маленький гладкий пистолет, превосходного исполнения. Дренежер продавал свои пистолеты ручной работы в футляре парами а иногда и по две штуки. Куда прозе выхватить следующий чем перезаряжать отстреленный. Дернежер в кармане брюк, и охотничьи нож в кармане фрака завершают картину правильного подбора одежды Американского игрока, адвоката или конгрессмена 1850х. Абрама Линкольна убили из такого пистолета в 1865. Было выпущено более 10,000.

Деренжер в английском языке стало синонимом любого однозарядного оружия скрытого ношения. Такчто помните что все Дернежеры - дернежеры но не наоборот.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>130</value>
	<weight>0.4/0.022</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi+</damage>
		<strength>6</strength>
		<accuracy>1</accuracy>
		<range>50/550</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(20)</shots>
		<bulk>-1</bulk>
		<recoil>3</recoil>
		<ammo>.44 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистоли</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 95</description>
	<description-loc>США 1866

<img data-src="http://weapons.gurps.ru/img/58.png">

Нет кольца для шнура (HT154)

В кнце 19, начале 20го веков этот крошечный открываемый на перлом пистолет был обычным компаньоном картежников (и многих мошейников) Ремингтон выпустил 150,000 единиц, а некоторые до сих пор(!) производят копии под более современный калибр.  .41 был слабым патроном, но лучше чем ничего. Его гладкий профиль идеально подходил для скрытного ношения в рукаве или голенище.

American Derringer Model 1 (1980-) фактически идентичная копия выпускавшаяся в 55 калибрах, от .22 LR (Dmg 1d pi-, Wt. 0.6, ST 6, Rcl 2, Cost $390) и .38 Special (Dmg 2d-1 pi, Wt. 1, ST 8, Rcl 3, Cost $390), до .410-gauge 3” (Dmg 1d-3(0.5) pi-, Wt. 1, RoF 2x65, ST 7, Rcl 1, Cost $450) и .44 Magnum (Dmg 3d pi+, Wt. 1.1, ST 9, Rcl 5, Cost $530). Большинство современных крупных калибров дают страшную отдачу в таком легком и сглаженом пистолетике. </description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>140</value>
	<weight>0.55/0.05</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi+</damage>
		<strength>6</strength>
		<accuracy>0</accuracy>
		<range>60/650</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-1</bulk>
		<recoil>2</recoil>
		<ammo>.41 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Lancaster Howdah</description>
	<description-loc>Великобритания 1885

<img data-src="http://weapons.gurps.ru/img/59.png">

<img data-src="http://weapons.gurps.ru/img/64.png">

Разработаны для защиты вблизи охотников на тигров, ездящих на слонах (в седле "хавдах"). Безбойковый пистолет имеет 4 ствола собранных в один блок. Его уникальный курок двойного действия позволяет быстро стрелять но уменьшает точность. ограничение в 4 выстрела может быть маловато, однако система с вращающимися стволами доказало что такое оружие имеет право на существование. Более надежный чем револьвер это оружие было популярно у Британских офицеров в конце 19го века. Свинцовый шарик пули был имел глиняный заостренный конец что вызывало его расширение (расценивайте как hollow-point, HT166)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>200</value>
	<weight>2.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d(0.5) pi++</damage>
		<strength>10</strength>
		<accuracy>1</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>4(3i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>.476 Enfield</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Thompson/Center Contender</description>
	<description-loc>США 1967

<img data-src="http://weapons.gurps.ru/img/60.png">

<img data-src="http://weapons.gurps.ru/img/595.png">

Нет кольца для шнура (HT154)



Это точный однозарядный пистолет с зарядом переломом ствола. Спортивный стрелковый или охотничий. Стреляет винтовочным патроном из 25 см ствола. Так-же выпускается в калибрах  .22 LR (Dmg 1d+2 pi-, ST 10, Rcl 2), .30-30 Winchester (Dmg 4d+1 pi, ST 11, Rcl 3), .44 Magnum (Dmg 5d-1 pi+, ST 11, Rcl 4) и куче других калибров. Ствол другой длины и калибра можно заменить за 30 секунд. Стволы стоят по $250. Часто снабжают переменной оптикой x2.5-x7 (0.6-lb. +2 Acc).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>560</value>
	<weight>3.5/0.026</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi</damage>
		<strength>11</strength>
		<accuracy>3</accuracy>
		<range>420/2,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-3</bulk>
		<recoil>3</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K P11 (подводный)</description>
	<description-loc>Германия 1976

<img data-src="http://weapons.gurps.ru/img/61.png">

Требуется батарейки, вторая цена за обойму батареек



Пистолет двойного действия для подводного использования. Разработан для немецких военных морских ныряльщиков. Несколько европейских спецподразделений так-же приняли их на вооружение. Секретно до 1990х сейчас фактически знаменито, благодаряд фильму Лара Крофт, Расхитительница Гробниц 2

"Бесшумный" патрон стреляет подводными "дротиками" (HT169). Максимальная рабочая глубина 10м, дели дистанцию в воде на 25, а не на 1000 как для других патронов. Низкий уровень шума при стрельбе является альтернативой глушителю даже на поверхности. Электрозажигание требует батареек (2xXS/5,000 выстрелов) - находятся в ручке. Самоподсвечивающийся подцепил (HT155).

Патроны идут в кассетах по пять уже установленные в стволы. Так что необходимо менять со стволами. Отстрелянные стволы возвращают на завод для перезарядки.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/75</value>
	<weight>2.6/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 imp</damage>
		<strength>9</strength>
		<accuracy>1</accuracy>
		<range>400/1,700</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(5)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>7.62x36mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолеты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Нож Разведчика Стреляющий НРС-2</description>
	<value>100</value>
	<weight>1.4/0.053</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>2d+1 pi-</damage>
		<strength>8</strength>
		<accuracy>0</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(10i)</shots>
		<bulk>-2</bulk>
		<recoil>3</recoil>
		<ammo>7.62x42mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<melee_weapon>
		<damage>sw-2 cut</damage>
		<strength>6</strength>
		<reach>C,1</reach>
		<parry>-1</parry>
	</melee_weapon>
	<melee_weapon>
		<damage>thr imp</damage>
		<strength>6</strength>
		<reach>С</reach>
		<parry>-1</parry>
	</melee_weapon>	
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Комбинированное</category>
		<category> Страна:Россия / СССР</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Россия / СССР 1970
		<img data-src="http://weapons.gurps.ru/img/62.png">
		<img data-src="http://weapons.gurps.ru/img/65.png">
		Боевой нож со стволом для стрельбы в ручке и выходным отверстием на конце. Стреляет "бесшумными" патронами, удобен для снятия часовых. Для выстрела необходимо развернуть нож и нажать на спусковую планку в ручке (обычно заблокирована предохранителем) В прилагаемых ножнах (0.6-lb.) есть отвертка и деталь позволяющая использовать нож как кусачки по колючей проволоке.
	</description-loc>
</equipment>


<equipment version="3">
	<quantity>1</quantity>
	<description>Нож Разведчика Стреляющий НРС-2 (Throwin Weapon (Knige) (DX-4))</description>
	<description-loc>Россия / СССР 1970

<img data-src="http://weapons.gurps.ru/img/62.png">

<img data-src="http://weapons.gurps.ru/img/65.png">

Боевой нож со стволом для стрельбы в ручке и выходным отверстием на конце. Стреляет "бесшумными" патронами, удобен для снятия часовых. Для выстрела необходимо развернуть нож и нажать на спусковую планку в ручке (обычно заблокирована предохранителем) В прилагаемых ножнах (0.6-lb.) есть отвертка и деталь позволяющая использовать нож как кусачки по колючей проволоке.</description-loc>
	<tech_level>8</tech_level>
	<value>100</value>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>thr imp</damage>
		<strength>6</strength>
		<accuracy>0</accuracy>
		<range>x0.8/x1.5</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>T(1)</shots>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Комбинированное</category>
		<category> Страна:Россия / СССР</category>
	</categories>
<weight></weight></equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Tasertron TE-76</description>
	<description-loc>США 1976

<img data-src="http://weapons.gurps.ru/img/66.png">

Встроенный тактический фонарь

При проваленном броске HT-3 жертва оглушена (stunned) пока нажат курок и еще (20-HT) секунд, после этого кидает каждый раз HT-3 чтобы придти в себя.



Первый электрошокер дистанционного действия. Использовался полицейскими NY и LA с 1978, но в большинстве штатов не продавался гражданским. Использует стандартный патрон чтобы выстрелить дротики (поэтому его классифицировали как огнестрельное оружие). Каждый патро стоит $16 и требует батарей S/100 секунд.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>2/0.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-3 pi- HT-3(0.5) aff  </damage>
		<strength>8</strength>
		<accuracy>0</accuracy>
		<range>5</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(5)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>TASER M26</description>
	<description-loc>США 1999

<img data-src="http://weapons.gurps.ru/img/67.png">

Встроенный лазерный прицел

При проваленном броске HT-5 жертва оглушена (stunned) пока нажат курок и еще (20-HT) секунд, после этого кидает каждый раз HT-5 чтобы придти в себя.



Основное отличие от прошлой версии - использует сжатый воздух вместо огнестреольно патрона. На вооружении у тысяч полицейских участков. Черный пластиковый пистолет с батарейками (8xXS/40 сек) в ручке, два воздушных картриджа ($20, 0.15 lb. каждый) в стволе и встроенный лазерный прицел который включается автоматически при снятии с предохранителя. Ток автоматически бъет в течение пяти секунд, если не отключен стрелком. Без воздуха все еще может применяться в ближнем бою.

В нем встроенная система контроля позволяющая узнать дату и время каждого выстрела. Это можно считать подключив компьютер а порту пистолета. Вторая мера безопасности - при каждом выстреле рассеиваются сотни микро отпечатков с номером ID патрона.

The M18 (1999-), гражданская версия - Range 5.

MX Animal TASER (2002-)  для оглушения крупных животных в несколько сотен фунтов весом. Те-же характеристики что и у M26, но требует броска HT-10! Запрещено применять против людей (LC3).

X26 (2003-) Уменьшенная версия, использующая те-же картриджи для воздуха, но другие батареи 

(S/1,500 сек): Wt. 0.75, Cost $800. Лазерный прицел можно выключить. У него так-же есть два встроенных фонаря на 10 метров. Военная полиция армии США вешает такие подствольно под Colt M4</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>400</value>
	<weight>1.1/0.25</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-3 pi- 0 HT-5(0.5) aff  </damage>
		<strength>7</strength>
		<accuracy>0</accuracy>
		<range>7</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Иньектор Dan-Inject JM Standard</description>
	<description-loc>Дания 1996

<img data-src="http://weapons.gurps.ru/img/68.png">

<img data-src="http://weapons.gurps.ru/img/69.png">

Баллон сжатого воздуха - хватает на 40 выстрелов.

Будпап, гладкоствол стреляет с помощью сжатого воздуха дротиком для усыпления животных. Используется в зоопарках и зоологами в дикой природе. Имеет x4 прицел, баллон с CO2 (72g, $20, 0.25 lbs) под стволом на 40 выстрелов.

11мм дротик с перьями несет шприц на 0.05 of  с 2мм иглой способной проткнуть кожу крупного животного - льва или слона. Способен ввести от 1 до 6 доз жидкой анестезии, необходимо кидать Viteranary (или Physician если используется против людей) чтобы правильно рассчитать дозу. Обычно анестезия требует броска HT-3, за каждый пункт провала жертва получает 1d FP - так что лекарству может понадобиться от нескольких секунд до нескольких минут чтобы полностью усыпить жертву. Жертва восстанавливает 1 FP каждые 10 минут как обычно.

Можно так-же выстрелить жучком слежения (HT210)</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>1,950</value>
	<weight>6.6/0.02</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi- drug</damage>
		<strength>8†</strength>
		<accuracy>3+2</accuracy>
		<range>45/150</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3i)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>11mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
		<category> Страна:Дания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN 303</description>
	<description-loc>Бельгия 2001

<img data-src="http://weapons.gurps.ru/img/70.png">

<img data-src="http://weapons.gurps.ru/img/482.png">

Баллона с воздухом хватает на 110 выстрелов

Вешается под ружье или карабин оружие становится тяжелее и получает -2 Bulk



Это гладкоствольный пневматический карабин предназначенный для полицейских и военный сил для работы с толпой. Полиция Европы и США приняли их на вооружение. Обычно подсоединяется “подствольно” к винтовке, но может быть использован и отдельно - подсоединив приклад который идет в комплекте (Wt. 5.1, Bulk -4).

Давление подается из 72г. магазина с CO2 ($20, 0.25 lb.) прикрепляемого паралельно стволу - этого хватает на 110 выстрелов. В съемном барабанном магазине 15 пуль, которые бывают резиновое (указаны в таблице), паинтбольные смываемые шарики или перманентная краска (Dmg 1d-3(0.2) cr, оставляет пятно 5см диаметром), и заряд перцовки (действует как паинбольный шарик, но жертва получает дозу перцовки HT180).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,100/21</value>
	<weight>4.5/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-3(0.5) cr</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>25/110</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>15(3)</shots>
		<bulk>-</bulk>
		<recoil>2</recoil>
		<ammo>.68 FN</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Воздушное</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Steyr-Girandoni M.1780</description>
	<description-loc>Австрия 1780

<img data-src="http://weapons.gurps.ru/img/71.png">

Баллона с воздухом хватает на 30 вытсрелов



Разработанное Барталамео Гирандони это единственное воздушное ружье, которое состояло на ворожении в армии. Было выпущено около 1,500 штук. Использовалось Австрийскими снайперами и все полицейские были снабжены ими в 1790. Использовалось в Турции (однако не против войск Наполеона, о чем часто врут) однако в 1806 оружие было списано. Конструкция базировалась на охотничьих ружьях 19 века.

Похоже на кремневое ружье, но приклад отсоединяем и содержит резервуар для воздуха: железная фляга покрытая кожей, наполняемая ручной помпой (2000 качков, что занимает почти 30 минут!) она содержит сжатый воздух на 30 выстрелов. Первые 10 выстрелов идут на дистанции и с повреждениями указанными в таблице, следующие 10 Dmg 1d+2 pi+, Range 50/400; и последние 10, Dmg 1d+1 pi+, Range 40/340. Пули подаются из трубки-магазина идущей справа от ствола. Взвод “бойка” подает пулю и подготавливает оружие к стрельбе. Оружие достаточно хрупко и не подходит для полевого использования (Malf 16).

Каждый солдат получал 3-lb. резервуар (запасной стоил $500 это была самая сложная деталь) и четыре магазина по 0.6-lb. и 20 пуль в каждом. Замена всего комплекта занимает 15 секунд.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>9.6/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi+</damage>
		<strength>10†</strength>
		<accuracy>1</accuracy>
		<range>60/480</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>21+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>11.75mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Воздушное</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Daisy Number 111 Red Ryder</description>
	<description-loc>США 1940

<img data-src="http://weapons.gurps.ru/img/72.png">

Детская игрушка



Возможно самая известная “воздушка” в мире, это гладкоствольная детская игрушка в стиле рычажных винтовок дикого запада, названа в честь ковбоя из комиксов. Было выпущено более 6.5 миллионов.

Загружается тысячей маленьких стальных шариков в трубу под стволом. Взводится рычаг - нагнетается воздух и пульки попадают в ствол. При нажатии курка пружина отпускает воздушный затвор… Не стреляйте в глаза!!!</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>50</value>
	<weight>3/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-4 pi-</damage>
		<strength>5†</strength>
		<accuracy>0</accuracy>
		<range>25/140</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1,000(2i)</shots>
		<bulk>-4</bulk>
		<recoil>1</recoil>
		<ammo>.175 BB</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Воздушное</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>NSG SplatMaster</description>
	<description-loc>США 1985

<img data-src="http://weapons.gurps.ru/img/73.png">

Баллона хватает на  30 выстрелов  

Это один из паинтбольных пистолетов - для популярной игры с цветными шариками. Стреляет с помощью сжатого газа CO2  ($1, 0.1 lb.) которого хватает на 30 выстрелов. Шарики загружаются в трубку над стволом. Необходимо взводить курок после каждого выстрела. Шарик оставляет пятно краски около 5см.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>140</value>
	<weight>2.1/0.07</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d-3(0.2) cr</damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>2/30</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10+1(5)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>.68 Paintball</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Воздушное</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Tower Blunderbuss</description>
	<description-loc>Великобритания 1700

<img data-src="http://weapons.gurps.ru/img/74.png">

Не надежный - клинит на 16+

Первое значние rcl для дроби, второе для пули (slug)



Заряжаемый через ствол мушкет, гладкоствольный с раструбом на конце. Моряки и гражданские 19го века любили его как оружие обороны. Официально выпускался для в почтовой охраны Англии, однако основным его применением было - отражение абордажа не море. Во всем военном морском флоте Европы использовалось подобное оружие.

Огромное вороночное горлышко не помогает в попадании, зато выглядит пугающе. Так-же оно упрощает перезарядку - особенно в море или на движущемся экипаже (+2 к броску Guns при перезарядке HT86). Многие были снабжены штыком располагавшимся над стволом (Reach 1)</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>200</value>
	<weight>7/0.12</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi</damage>
		<strength>11†</strength>
		<accuracy>2</accuracy>
		<range>30/600</range>
		<rate_of_fire>1x13</rate_of_fire>
		<shots>1(35)</shots>
		<bulk>-4</bulk>
		<recoil>1/6</recoil>
		<ammo>11G Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Manton Double</description>
	<description-loc>Великобритания 1797

<img data-src="http://weapons.gurps.ru/img/75.png">

Не надежный - клинит на 16+

Первое значение rcl для дроби, второе для пули (slug)



Это было дорогое оружие от одного из мастеров оружейного дела того времени: Джон Мэнтон, персональный Оружейник королевской семьи Англии. Его изобретениями были: поднятое прицельное ребро, водонепроницаемые замки и нержавеющие отдушины из платины. Для кремневого ружья с зарядкой через ствол оно было очень легким. Однако расплатой за легкий вес была внушительная отдача. (Однако нет штрафов за стрельбу из обоих стволов одновременно)

Владельцу необходимо взять перк Weapon Bond (HT250) за оружие сдельное по его индивидуальной мерке. </description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>6.7/0.17</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x8</rate_of_fire>
		<shots>2(40i)</shots>
		<bulk>-5</bulk>
		<recoil>1/5</recoil>
		<ammo>16G Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Model 1855</description>
	<description-loc>США 1856

<img data-src="http://weapons.gurps.ru/img/76.png">

Не надежный - клинит на 16+

Первое значение rcl для дроби, второе для пули (slug)



Это оружие заряжаемые через ствол имеет конструкцию револьвера Кольта -  одинарного действия, позволяет произвести пять выстрелов вместо обычных двух для двуствольного ружья. Однако перезарядка медлительна. Были дефицитны ( всего несколько тысяч было выпущено).</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>10.9/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi</damage>
		<strength>11†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x7</rate_of_fire>
		<shots>5(10i)</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>20G Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Hammer Lifter</description>
	<description-loc>США 1873

<img data-src="http://weapons.gurps.ru/img/77.png">

Первое знание rcl для дроби, второе для пули (slug)



Это двуствольное ружье с переломной зарядкой имело открытые бойки и отсутствие экстрактора. Было выпущено 5,600 штук.

Можно стрелять из обоих стволов без штрафа. Стволы не безопасны для использования бездымного пороха (TL6). При использовании таких патронов и броске 18 ружьё взрывается нанося 1d cr ex стрелку.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>7.4/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x8</rate_of_fire>
		<shots>2(4i)</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.5”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>LeFever Automatic Hammerless</description>
	<description-loc>США 1885

<img data-src="http://weapons.gurps.ru/img/78.png">

Первое значние rcl для дроби, второе для пули (slug)



Стандартное тяжелое, двуствольное, заряжаемое переломом оружие. В конце 19, начале 20 го веков часто использовалось охотниками,  почтальонами, охраной тюрем, и убийцами мафии. это было одно из первых безбойковых оружии - и первое оружие с автоматическим экстрактором. Было выпущено около 18,000

Можно стрелять из обоих стволов без штрафов. Стволы не безопасны для использования бездымного пороха (TL6). При использовании таких патронов и броске 18 ружьё взрывается нанося 1d cr ex стрелку.

Часто подвергались ручной доводке под стрелка (стоит взять  Weapon Bond HT250). Такие ружья часто декорированы или инкрустированы.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>750</value>
	<weight>10.3/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>12†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x13</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-6</bulk>
		<recoil>1/7</recoil>
		<ammo>10G 2.875”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester Model 1887</description>
	<description-loc>США 1887

<img data-src="http://weapons.gurps.ru/img/79.png">

<img data-src="http://weapons.gurps.ru/img/90.png">

Первое значние rcl для дроби, второе для пули (slug)



Это оружие было любимым среди профессиональных охотников. Его трубный магазин на 4 патрона и еще один в стволе, давали куда больше возможностей чем статарное двуствольное ружье, чем заслужили большую популяность в Америке. Были версии с коротки и длинным стволами (75см и 50см), короткий был Wt. 7.5, Bulk -5. Было выпущено 56,000. Так-же бе была версия под калибр 12G 2.75” (Dmg 1d+1 pi, RoF 2x9).

Стволы не безопасны для использования бездымного пороха (TL6). При использовании таких патронов и броске 18 ружьё взрывается нанося 1d cr ex стрелку.

Model 1901 (1901-1920) была точно таким-же ружьем но под бездымный патрон. Было выпущено 13,500 экземпляров. Засветилось фильме Теримнатор 2.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>8/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x13</rate_of_fire>
		<shots>4+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>1/7</recoil>
		<ammo>10G 2.875”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester Model 1897</description>
	<description-loc>США 1898

<img data-src="http://weapons.gurps.ru/img/80.png">

Первое значние rcl для дроби, второе для пули (slug)



Винчестер “помопвик” - одно из самых знаменитых ружий одинарного действия в истории. У него не было разъединителя - соответственно можно было зажать курок и передёргивая подачу, что увеличивало rof до 3x9 было выпущено более миллиона, а Китай выпускает копии до сих пор.

Базовая модель имела 75см ствол, однако стандартный противбунтовый размер был 50см  (Wt. 7.4, Bulk -5). Позже была доступна разборная модель - в разобранном состоянии входила в сумку менее 60см длиной  (Holdout -3, Cost $600). Так-же выпускалось в калибре 16G 2.75” (Wt. 8/0.45, RoF 2x8). Армия США использовала варинт такого ружья в обоих мировых войнах в качестве оконого оружия- ствол 50см (Wt. 8.8, Bulk -5) и штык от M1903 (1.1-lb. Reach 1).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>550</value>
	<weight>8.6/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>5+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN-Browning Auto-5</description>
	<description-loc>Бельгия 1903

<img data-src="http://weapons.gurps.ru/img/81.png">

Первое значение rcl для дроби, второе для пули (slug)



Первый самозарядный дробовик, разработан Джоном Браунингом, сначала производился компанией Fabrique Nationale. Он имел меньшую отдачу, поскольку часть энергии забирал на себя самозарядный механизм. FN выпустила более 3 миллионов. Из за этого и огромного количества копий, оружие встречается по всему миру. 

Хотя первоначально разработано для охотников, было использовано в обоих Мировых Войнах. Полицейские использовали версию с укороченным стволом 50см: Wt. 8.4, Bulk -5.  Британские парашутно-десантные части использовали их для боя в джунглях Бирмы и Малайзии в 50х-60х годах. </description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>850</value>
	<weight>8.9/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>4+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ithaca Auto &amp; Burglar</description>
	<description-loc>США 1922

<img data-src="http://weapons.gurps.ru/img/82.png">

Первое значние rcl для дроби, второе для пули (slug)

Нет крепления для ремня



Заводской “обрез” - двуствольный, безбойковый с коротким стволом и без приклада, с пистолетной ручкой. Можно носить в кобуре или под курткой. Использовался полицейскими и продавался гражданским для защиты жилища и транспорта. Было выпущено 7,000.

Из за короткого ствола - вспышка выстрела боле заметна: +1 к броску слуха и  зрения в темное время. Можно стрелять из обоих стволов одновременно без штрафов. Используется одноручно: ST11. В таблице указана картечь, но более мелкая дробь использовалась чаще: Dmg 1d(0.5) pi-, Range 30/600, RoF 2x20.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>5/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d pi</damage>
		<strength>9†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x7</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-3</bulk>
		<recoil>1/5</recoil>
		<ammo>20G 2.5”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ithaca Auto &amp; Burglar (мелкая дробь)</description>
	<description-loc>США 1922

<img data-src="http://weapons.gurps.ru/img/82.png">

Первое значние rcl для дроби, второе для пули (slug)

Нет крепления для ремня



Заводской “обрез” - двуствольный, безбойковый с коротким стволом и без приклада, с пистолетной ручкой. Можно носить в кобуре или под курткой. Использовался полицейскими и продавался гражданским для защиты жилища и транспорта. Было выпущено 7,000.

Из за короткого ствола - вспышка выстрела боле заметна: +1 к броску слуха и  зрения в темное время. Можно стрелять из обоих стволов одновременно без штрафов. Используется одноручно: ST11. В таблице указана картечь, но более мелкая дробь использовалась чаще: Dmg 1d(0.5) pi-, Range 30/600, RoF 2x20.</description-loc>
	<tech_level>6</tech_level>
	<value>400</value>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d(0.5) pi-</damage>
		<strength>9†</strength>
		<accuracy>2</accuracy>
		<range>30/600</range>
		<rate_of_fire>RoF 2x20</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-3</bulk>
		<recoil>1/5</recoil>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
<weight></weight></equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ithaca Model 37 Featherlight</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/83.png">

<img data-src="http://weapons.gurps.ru/img/526.png">

<img data-src="http://weapons.gurps.ru/img/527.png">

Первое значение rcl для дроби, второе для пули (slug)



Это легкое “помповое” ружье уникально тем что отбрасывает пустые гильзы вниз а не в сторону. Распространенное охотничье ружье, так-же послужило американским полицейским, особенно в LA и NY. У моделей до 1957 не было разъединителя - соответственно можно было зажать курок и передёргивая подачу, что увеличивало rof до 3x9. Так-же выпускалось в калибре 20G 2.75” (Wt. 6.1/0.35, RoF 2x7).

Model 37 M&amp;P (1967-) укороченным стволом и увеличенным магазином была популярна у морской пехоты во Ветнаме: Wt. 7.3/0.8, Shots 7+1, Bulk -5.

Model 37 Stakeout (1981-1987) c с пистолетной ручкой, обрезанным стволом и без переклада разработана для “ближнего боя” Acc 2, Wt. 5.4/0.4, ST 12†, Bulk -3, Rcl 1/6. Появлялось в фильме “Чужие”. Так-же выпускалась в калибре 20G 2.75”: Acc 2, Wt. 3.8/0.35, RoF 2¥7, Shots 4+1, ST 11†, Bulk -3, Rcl 1/6.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>7/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>4+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ithaca Model 37 Featherlight (Model 37 M&amp;P)</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/83.png">

<img data-src="http://weapons.gurps.ru/img/526.png">

<img data-src="http://weapons.gurps.ru/img/527.png">

Первое значение rcl для дроби, второе для пули (slug)



Это легкое “помповое” ружье уникально тем что отбрасывает пустые гильзы вниз а не в сторону. Распространенное охотничье ружье, так-же послужило американским полицейским, особенно в LA и NY. У моделей до 1957 не было разъединителя - соответственно можно было зажать курок и передёргивая подачу, что увеличивало rof до 3x9. Так-же выпускалось в калибре 20G 2.75” (Wt. 6.1/0.35, RoF 2x7).

Model 37 M&amp;P (1967-) укороченным стволом и увеличенным магазином была популярна у морской пехоты во Ветнаме: Wt. 7.3/0.8, Shots 7+1, Bulk -5.

Model 37 Stakeout (1981-1987) c с пистолетной ручкой, обрезанным стволом и без переклада разработана для “ближнего боя” Acc 2, Wt. 5.4/0.4, ST 12†, Bulk -3, Rcl 1/6. Появлялось в фильме “Чужие”. Так-же выпускалась в калибре 20G 2.75”: Acc 2, Wt. 3.8/0.35, RoF 2¥7, Shots 4+1, ST 11†, Bulk -3, Rcl 1/6.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>7.3/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>7+1</shots>
		<bulk>-5</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ithaca Model 37 Featherlight (Model 37 Stakeout)</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/83.png">

<img data-src="http://weapons.gurps.ru/img/526.png">

<img data-src="http://weapons.gurps.ru/img/527.png">

Первое значение rcl для дроби, второе для пули (slug)



Это легкое “помповое” ружье уникально тем что отбрасывает пустые гильзы вниз а не в сторону. Распространенное охотничье ружье, так-же послужило американским полицейским, особенно в LA и NY. У моделей до 1957 не было разъединителя - соответственно можно было зажать курок и передёргивая подачу, что увеличивало rof до 3x9. Так-же выпускалось в калибре 20G 2.75” (Wt. 6.1/0.35, RoF 2x7).

Model 37 M&amp;P (1967-) укороченным стволом и увеличенным магазином была популярна у морской пехоты во Ветнаме: Wt. 7.3/0.8, Shots 7+1, Bulk -5.

Model 37 Stakeout (1981-1987) c с пистолетной ручкой, обрезанным стволом и без переклада разработана для “ближнего боя” Acc 2, Wt. 5.4/0.4, ST 12†, Bulk -3, Rcl 1/6. Появлялось в фильме “Чужие”. Так-же выпускалась в калибре 20G 2.75”: Acc 2, Wt. 3.8/0.35, RoF 2¥7, Shots 4+1, ST 11†, Bulk -3, Rcl 1/6.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>5.4/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>12†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>4+1(2i)</shots>
		<bulk>-3</bulk>
		<recoil>1/6</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 870</description>
	<description-loc>США 1950

<img data-src="http://weapons.gurps.ru/img/84.png">

<img data-src="http://weapons.gurps.ru/img/529.png">

<img data-src="http://weapons.gurps.ru/img/530.png">

Первое значние rcl для дроби, второе для пули (slug)



В 1950 Remington представил улучшенное помповое руже, которая быстро стала самым продаваемым дробовиком всех времен. Он исключительно аккуратный, надежный, имеет удобный хват и радует ценой. Это выбор полицейских и охранных структур по всему миру, как и стендовых стрелков и  охотников на уток… Такой ствол весь 20й век был самым частым гостем оружейной кофры в машине Американского копа или пикапе охотника. Более восьми миллионов деиниц было сделано, не считая китайских копий.

С 1985 идет калибра 3” (Dmg 1d+2 pi, RoF 2x12, Shots 4+1) вместе с привычным 2.75”. Так-же выпускался под 20G 2.75” (Wt. 7/0.45, RoF 2x7). То что продавалось в охотничьих и спортивных магазинах шло затычкой в магазине, позволяющей держать только 2 патрона (+1 в стволе) из за Американских законах об охоте. Однако эта затычка легко удаляется, это требует пять минут и бросок по  Armoury (Small Arms) или IQ-based Guns (Shotgun).

Model 870P (1969-) для полицейских нужд, с более коротким стволом и увеличенным до 7 патронов магазином: Wt. 8.3/0.8, Shots 7+1, Bulk -5, Cost $400. С 1972 можно быть укомплектован складным прикладом (Bulk -5*). Так-же предлагалось в комплектации cruiser - ствол 35см, нет приклада и пистолетная ручка:  Acc 2, Wt. 6.7/0.4, Shots 4+1, ST 12†, Bulk -3, Rcl 1/6.

KAC Masterkey (1992-) образный вариант - крепится на полозья подствольно под винтовку: Acc 2, Wt. 6/0.3, Shots 3+1, Cost $1,900, LC2. добовлет -2 к Bulk оружия.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>330</value>
	<weight>7.6/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>5+1(2i)</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 870</description>
	<description-loc>США 1950

<img data-src="http://weapons.gurps.ru/img/84.png">

<img data-src="http://weapons.gurps.ru/img/529.png">

<img data-src="http://weapons.gurps.ru/img/530.png">

Первое значние rcl для дроби, второе для пули (slug)



В 1950 Remington представил улучшенное помповое руже, которая быстро стала самым продаваемым дробовиком всех времен. Он исключительно аккуратный, надежный, имеет удобный хват и радует ценой. Это выбор полицейских и охранных структур по всему миру, как и стендовых стрелков и  охотников на уток… Такой ствол весь 20й век был самым частым гостем оружейной кофры в машине Американского копа или пикапе охотника. Более восьми миллионов деиниц было сделано, не считая китайских копий.

С 1985 идет калибра 3” (Dmg 1d+2 pi, RoF 2x12, Shots 4+1) вместе с привычным 2.75”. Так-же выпускался под 20G 2.75” (Wt. 7/0.45, RoF 2x7). То что продавалось в охотничьих и спортивных магазинах шло затычкой в магазине, позволяющей держать только 2 патрона (+1 в стволе) из за Американских законах об охоте. Однако эта затычка легко удаляется, это требует пять минут и бросок по  Armoury (Small Arms) или IQ-based Guns (Shotgun).

Model 870P (1969-) для полицейских нужд, с более коротким стволом и увеличенным до 7 патронов магазином: Wt. 8.3/0.8, Shots 7+1, Bulk -5, Cost $400. С 1972 можно быть укомплектован складным прикладом (Bulk -5*). Так-же предлагалось в комплектации cruiser - ствол 35см, нет приклада и пистолетная ручка:  Acc 2, Wt. 6.7/0.4, Shots 4+1, ST 12†, Bulk -3, Rcl 1/6.

KAC Masterkey (1992-) образный вариант - крепится на полозья подствольно под винтовку: Acc 2, Wt. 6/0.3, Shots 3+1, Cost $1,900, LC2. добовлет -2 к Bulk оружия.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>330</value>
	<weight>7.6/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x12</rate_of_fire>
		<shots>4+1</shots>
		<bulk>-6</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 3”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 870 (Model 870P)</description>
	<description-loc>США 1950

<img data-src="http://weapons.gurps.ru/img/84.png">

<img data-src="http://weapons.gurps.ru/img/529.png">

<img data-src="http://weapons.gurps.ru/img/530.png">

Первое значние rcl для дроби, второе для пули (slug)



В 1950 Remington представил улучшенное помповое руже, которая быстро стала самым продаваемым дробовиком всех времен. Он исключительно аккуратный, надежный, имеет удобный хват и радует ценой. Это выбор полицейских и охранных структур по всему миру, как и стендовых стрелков и  охотников на уток… Такой ствол весь 20й век был самым частым гостем оружейной кофры в машине Американского копа или пикапе охотника. Более восьми миллионов деиниц было сделано, не считая китайских копий.

С 1985 идет калибра 3” (Dmg 1d+2 pi, RoF 2x12, Shots 4+1) вместе с привычным 2.75”. Так-же выпускался под 20G 2.75” (Wt. 7/0.45, RoF 2x7). То что продавалось в охотничьих и спортивных магазинах шло затычкой в магазине, позволяющей держать только 2 патрона (+1 в стволе) из за Американских законах об охоте. Однако эта затычка легко удаляется, это требует пять минут и бросок по  Armoury (Small Arms) или IQ-based Guns (Shotgun).

Model 870P (1969-) для полицейских нужд, с более коротким стволом и увеличенным до 7 патронов магазином: Wt. 8.3/0.8, Shots 7+1, Bulk -5, Cost $400. С 1972 можно быть укомплектован складным прикладом (Bulk -5*). Так-же предлагалось в комплектации cruiser - ствол 35см, нет приклада и пистолетная ручка:  Acc 2, Wt. 6.7/0.4, Shots 4+1, ST 12†, Bulk -3, Rcl 1/6.

KAC Masterkey (1992-) образный вариант - крепится на полозья подствольно под винтовку: Acc 2, Wt. 6/0.3, Shots 3+1, Cost $1,900, LC2. добовлет -2 к Bulk оружия.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>8.3/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>5+1(2i)</shots>
		<bulk>-5</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 870 (Model 870P cruiser)</description>
	<description-loc>США 1950

<img data-src="http://weapons.gurps.ru/img/84.png">

<img data-src="http://weapons.gurps.ru/img/529.png">

<img data-src="http://weapons.gurps.ru/img/530.png">

Первое значние rcl для дроби, второе для пули (slug)



В 1950 Remington представил улучшенное помповое руже, которая быстро стала самым продаваемым дробовиком всех времен. Он исключительно аккуратный, надежный, имеет удобный хват и радует ценой. Это выбор полицейских и охранных структур по всему миру, как и стендовых стрелков и  охотников на уток… Такой ствол весь 20й век был самым частым гостем оружейной кофры в машине Американского копа или пикапе охотника. Более восьми миллионов деиниц было сделано, не считая китайских копий.

С 1985 идет калибра 3” (Dmg 1d+2 pi, RoF 2x12, Shots 4+1) вместе с привычным 2.75”. Так-же выпускался под 20G 2.75” (Wt. 7/0.45, RoF 2x7). То что продавалось в охотничьих и спортивных магазинах шло затычкой в магазине, позволяющей держать только 2 патрона (+1 в стволе) из за Американских законах об охоте. Однако эта затычка легко удаляется, это требует пять минут и бросок по  Armoury (Small Arms) или IQ-based Guns (Shotgun).

Model 870P (1969-) для полицейских нужд, с более коротким стволом и увеличенным до 7 патронов магазином: Wt. 8.3/0.8, Shots 7+1, Bulk -5, Cost $400. С 1972 можно быть укомплектован складным прикладом (Bulk -5*). Так-же предлагалось в комплектации cruiser - ствол 35см, нет приклада и пистолетная ручка:  Acc 2, Wt. 6.7/0.4, Shots 4+1, ST 12†, Bulk -3, Rcl 1/6.

KAC Masterkey (1992-) образный вариант - крепится на полозья подствольно под винтовку: Acc 2, Wt. 6/0.3, Shots 3+1, Cost $1,900, LC2. добовлет -2 к Bulk оружия.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>400</value>
	<weight>6.7/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>12†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>4+1</shots>
		<bulk>-3</bulk>
		<recoil>1/6</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Franchi SPAS-12</description>
	<description-loc>Италия 1979

<img data-src="http://weapons.gurps.ru/img/85.png">

Первое значение rcl для дроби, второе для пули (slug)



Разработан для полицейских и армейских нужд но назван почему-то “Спортивного Назначения Автоматический Дробовик 12 калибра”. Может стрелять как полу автоматическое ружье на принципе отводе газов, или в автоматическом режиме “нажми на кнопку”. Позволяет использовать любые патроны 12G, даже если патрон не достаточно мощен чтобы взвести помпу (такие как 12G 2.5”). Стандартно укомплектован складным прикладом, но бывает и с фиксированным (Bulk -5)

SPAS-12 до сих пор на службе в полиции и армии в некоторых европейских и африканских стран.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>950</value>
	<weight>9.8/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>7+1(2i)</shots>
		<bulk>-5*</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Италия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Armsel Striker</description>
	<description-loc>Южная Африка 1983

<img data-src="http://weapons.gurps.ru/img/86.png">

<img data-src="http://weapons.gurps.ru/img/91.png">

<img data-src="http://weapons.gurps.ru/img/531.png">

Первое значние rcl для дроби, второе для пули (slug)



Предназначенный для противобунтовых подразделений и защиты частной собственности. Патрон подается из барабана полуавтоматически, пружина крутит барабан. Перезарядка медленны (три раунда н то чтобы положить каждый патрон в барабан + два чтобы взвести пружину). Ствол длиной 30см и складной приклад.

Street Sweeper (1986-1994) несколько компаний выпускали такой по лицензии. Это версия с 45 см стволом: Wt. 11/1.3, Bulk -5*, Cost $2,000.

В Южной Африке есть выпускается фактически точная копия Reutech Protecta (1989- 2004), у него есть автоматический выброс гильз и убраны пружины (не нужны 2 маневра в момент перезарядки). Теперь используется помповый механизм для взвода цилиндра. Бывает со стволом 30см и 45см (отличается только  RoF 2x9), а так-же Protecta Bulldog с 18см стволом и без приклада: Acc 2, Wt. 6/1.2, RoF 2x9, Shots 11, ST 10†, Bulk -3, Rcl 1/6, Cost $1,500, LC2. Из за короткого ствола - вспышка выстрела боле заметна: +1 к броску слуха и зрения в темное время суток. Вы могли видеть его в фильме Disperado.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>10.6/1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>12(3i)</shots>
		<bulk>-5*</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Южная Африка</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Armsel Striker (Armsel Striker)</description>
	<description-loc>Южная Африка 1983

<img data-src="http://weapons.gurps.ru/img/86.png">

<img data-src="http://weapons.gurps.ru/img/91.png">

<img data-src="http://weapons.gurps.ru/img/531.png">

Первое значние rcl для дроби, второе для пули (slug)



Предназначенный для противобунтовых подразделений и защиты частной собственности. Патрон подается из барабана полуавтоматически, пружина крутит барабан. Перезарядка медленны (три раунда н то чтобы положить каждый патрон в барабан + два чтобы взвести пружину). Ствол длиной 30см и складной приклад.

Street Sweeper (1986-1994) несколько компаний выпускали такой по лицензии. Это версия с 45 см стволом: Wt. 11/1.3, Bulk -5*, Cost $2,000.

В Южной Африке есть выпускается фактически точная копия Reutech Protecta (1989- 2004), у него есть автоматический выброс гильз и убраны пружины (не нужны 2 маневра в момент перезарядки). Теперь используется помповый механизм для взвода цилиндра. Бывает со стволом 30см и 45см (отличается только  RoF 2x9), а так-же Protecta Bulldog с 18см стволом и без приклада: Acc 2, Wt. 6/1.2, RoF 2x9, Shots 11, ST 10†, Bulk -3, Rcl 1/6, Cost $1,500, LC2. Из за короткого ствола - вспышка выстрела боле заметна: +1 к броску слуха и зрения в темное время суток. Вы могли видеть его в фильме Disperado.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500</value>
	<weight>6/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>40/800</range>
		<rate_of_fire>2x9</rate_of_fire>
		<shots>11</shots>
		<bulk>-3</bulk>
		<recoil>1/6</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Южная Африка</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Benelli M1 Super 90</description>
	<description-loc>Италия 1985

<img data-src="http://weapons.gurps.ru/img/87.png">

<img data-src="http://weapons.gurps.ru/img/533.png">

Первое значение rcl для дроби, второе для пули (slug)



Полуавтоматический дробовик на принципе отдачи, знаменит за надежность и удобный хват. Всегда идет с полны перекладом и пистолетной ручкой. Способно стрелять обычными (2.75” указаны в таблице) и длинными патронами (3” Dmg 1d+2 pi, RoF 3x12, Shots 6+1) широко распространены у полицейских и антитеррористических подразделений.

M1 Super 90 Entry (1992-2004) с укороченным стволом (10см)  Wt. 7.2/0.6, Shots 5+1, Bulk -4, Cost $1,100.

M3 Super 90 (1989-) может быть переведен в помповый режим (RoF 2x9) для стрельбы маломощными патронами: Wt. 8.3, Cost $1,170.  

M3T Super 90 (1990-)  точно такой-же но со складным прикладом  Wt. 8.6, Bulk -5*, Cost $1,170.

M4 Super 90 (1999-) работает на принципе отвода ствольных газов : Wt. 8.3/0.7, Shots 6+1, Cost $1,470. В 2002 под маркой M1014 был принят на вооружение армией США - имел выдвижной приклад и полозья для прицела.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>8.2/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>7+1(2i)</shots>
		<bulk>-5</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Италия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Benelli M1 Super 90</description>
	<description-loc>Италия 1985

<img data-src="http://weapons.gurps.ru/img/87.png">

<img data-src="http://weapons.gurps.ru/img/533.png">

Первое значение rcl для дроби, второе для пули (slug)



Полуавтоматический дробовик на принципе отдачи, знаменит за надежность и удобный хват. Всегда идет с полны перекладом и пистолетной ручкой. Способно стрелять обычными (2.75” указаны в таблице) и длинными патронами (3” Dmg 1d+2 pi, RoF 3x12, Shots 6+1) широко распространены у полицейских и антитеррористических подразделений.

M1 Super 90 Entry (1992-2004) с укороченным стволом (10см)  Wt. 7.2/0.6, Shots 5+1, Bulk -4, Cost $1,100.

M3 Super 90 (1989-) может быть переведен в помповый режим (RoF 2x9) для стрельбы маломощными патронами: Wt. 8.3, Cost $1,170.  

M3T Super 90 (1990-)  точно такой-же но со складным прикладом  Wt. 8.6, Bulk -5*, Cost $1,170.

M4 Super 90 (1999-) работает на принципе отвода ствольных газов : Wt. 8.3/0.7, Shots 6+1, Cost $1,470. В 2002 под маркой M1014 был принят на вооружение армией США - имел выдвижной приклад и полозья для прицела.</description-loc>
	<tech_level>8</tech_level>
	<value>1,000</value>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x12</rate_of_fire>
		<shots>6+1</shots>
		<bulk>-5</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 3”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Италия</category>
	</categories>
<weight></weight></equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Benelli M1 Super 90 (M1 Super 90 Entry)</description>
	<description-loc>Италия 1985

<img data-src="http://weapons.gurps.ru/img/87.png">

<img data-src="http://weapons.gurps.ru/img/533.png">

Первое значение rcl для дроби, второе для пули (slug)



Полуавтоматический дробовик на принципе отдачи, знаменит за надежность и удобный хват. Всегда идет с полны перекладом и пистолетной ручкой. Способно стрелять обычными (2.75” указаны в таблице) и длинными патронами (3” Dmg 1d+2 pi, RoF 3x12, Shots 6+1) широко распространены у полицейских и антитеррористических подразделений.

M1 Super 90 Entry (1992-2004) с укороченным стволом (10см)  Wt. 7.2/0.6, Shots 5+1, Bulk -4, Cost $1,100.

M3 Super 90 (1989-) может быть переведен в помповый режим (RoF 2x9) для стрельбы маломощными патронами: Wt. 8.3, Cost $1,170.  

M3T Super 90 (1990-)  точно такой-же но со складным прикладом  Wt. 8.6, Bulk -5*, Cost $1,170.

M4 Super 90 (1999-) работает на принципе отвода ствольных газов : Wt. 8.3/0.7, Shots 6+1, Cost $1,470. В 2002 под маркой M1014 был принят на вооружение армией США - имел выдвижной приклад и полозья для прицела.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>7.2/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>3x9</rate_of_fire>
		<shots>5+1</shots>
		<bulk>-4</bulk>
		<recoil>1/4</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Италия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Daewoo USAS-12</description>
	<description-loc>Южная Корея 1987

<img data-src="http://weapons.gurps.ru/img/88.png">

Первое значние rcl для дроби, второе для пули (slug)



Универсальный Спортивный Автоматический Дробовик (USAS) ни что иное как спортивное оружие. Это оружие на отводе газов, сильно напоминающее винтовку M16. Выпускалось в Южной Корее по наработкам 1970 Максвела Ачисона, однако некоторые производители в США пытались продавать ее. Было выпущено более 30,000, большей частью полуавтоматическая версия  (RoF 3x9, LC3). Военные продажи были малы. Стреляет из 10 патронного магазина, но может использовать барабан на 20 патронов  ($264, 4.6 lbs.) что дает -1 Bulk.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,300/32</value>
	<weight>14.2/2.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>11†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>6x9</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>1/3</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:Южная Корея</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>C-More M26 MASS</description>
	<description-loc>США 2003

<img data-src="http://weapons.gurps.ru/img/89.png">

Первое значение rcl для дроби, второе для пули (slug)

Вешается подсвольно, увеличивает вес и Bulk этого оружия до на -1



Имеет механизм взвода курком и съемный магазин. В дополнение к дверевышибающем хрупкому “слагу” которым его обычно заряжают, может стрелять летальными и нелетальными патронами. (HT167).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>500/34</value>
	<weight>3.8/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>1x9</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>–</bulk>
		<recoil>1/5</recoil>
		<ammo>12G 2.75”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Ружья</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Brown Bess</description>
	<description-loc>Великобритания 1744

<img data-src="http://weapons.gurps.ru/img/92.png">

Не надежный - клинит на 16+

Так-же известен как "башенный мушкет" а так-же как "Коричневый Бес" - за коричневую отделку. Был представлен в 1744 как карабин для драгунов и был принят на вооружение в Британии в 1769. С небольшими изменениями использовался вплоть до 1840 в Американской Революции. Сотни тысяч было выпущено, копии делались по всему миру. Британская армия покупала их так-же у Бельгийский и Немецких производителей. 

Даже в сравнении с ровесниками он был тяжел, очень дрог и имел малую дальность и точность.

Имеет съемный штык 1.1lbs (Reach 1,2)</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>100</value>
	<weight>10.2/0.09</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi++</damage>
		<strength>11†</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(40)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.75 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>North West Gun</description>
	<description-loc>Великобритания 1770

<img data-src="http://weapons.gurps.ru/img/93.png">

Не надежный - клинит на 16+

Это общее название для оружия продававшегося в Америке в 18-19 веках. 

У них были дешевые кремневые замки, и относительно короткие стволы. Большинство из Англии (их предпочитали индейцы), некоторые делали в Бельгии и Америке.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>75</value>
	<weight>10/0.035</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi+</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>100/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(40)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.50 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Charleville Mle 1777</description>
	<description-loc>Франция 1777

<img data-src="http://weapons.gurps.ru/img/94.png">

Очень ненадежный - клинит на 14+



Стаяло на вооружении Франции в 18-19 веках. 4.8 фута (6.2 со штыком) оно было сама длинным мушкетом тех годов. Во времена Американской Революции армия Вашингтона получила большаку партию подобных мушкетов.. В 1801 войска Наполеона были вооружены модифицированной версией. Около семи миллионов Mle распространились по Европе и соседям - Австрии, Пруссии, Россие, а США разрабатывал свои мушкеты на базе этого.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>150</value>
	<weight>9.3/0.087</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+1 pi++</damage>
		<strength>10†</strength>
		<accuracy>2</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(40)</shots>
		<bulk>-7</bulk>
		<recoil>4</recoil>
		<ammo>17.5mm-Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Kentucky Rifle</description>
	<description-loc>США 1740

<img data-src="http://weapons.gurps.ru/img/95.png">

Не надежный - клинит на 16+



Была сделана из Пенсильвании а, названном в честь области Кентукки, где охотники и пионеры часто применяли оружие.  Похоже оружие выпускалась по всей англоговорящей Северной Америке. Они почти все были заменены В 1840, но выпускаются и по сей день для коллекционеров.

Дальнобойная охотничья и оборонительная винтовка, на вооружении в Германии и Швеции в течение 18 века. Малокалиберная, дальнобойная, позволяет вести быструю стрельбу. Ствол был удлинен чтобы увеличить прицельную дальность. Ускоренная зарядка производилась по промасленному каналу с помощью колотушки и стрежня которые позволяли забить шар паз намного быстрее других стволов.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>7/0.025</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d-1 pi+</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>110/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(60)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.45 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Baker Rifle</description>
	<description-loc>США 1800

<img data-src="http://weapons.gurps.ru/img/96.png">

<img data-src="http://weapons.gurps.ru/img/300.png">

Не надежный - клинит на 16+



Разработана Эзикилем Бейкером, эта удачная винтовка была использована элитными ружейными частями Британской Армии. Более 30,000 было выпущено, так-же они экспортировались в Португалию и Испанию. Служили в войнах Наполеона и в Северной Америке. 

Британцы заменили ее в 1837.

Имеет съемный меч-штык 2lbs (Reach 1,2*) с закрытой ручкой (считается за кастет)</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>9/0.062</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi++</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>80/900</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(60)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.625 Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Hall M1819</description>
	<description-loc>США 1819

<img data-src="http://weapons.gurps.ru/img/97.png">

Не надежный - клинит на 16+

Сделан Harper’s Ferry Arsenal для армии США использовался в мексиканской и индийской войнах. Он не заменил оружие заряжаемые через дуло, поскольку был слишком дорог легко ломался  и не имел нормального уплотнителя затвора. Всего было сделано 19,680 единиц.

Имеет съемный штык 0.7lbs (Reach 1,2)

Весь его затворный механизм может быть снят целиком и с него можно стрелять (Guns (Pistol)). Это стало полярным неуставным оружием у некоторых родов войск. Поскольку не было ни ручки ни ствола ни мушки, оно было ужасно неточным - Dam 1d+2 pi+, Acc 0, Range 40/450, Wt. 1.2/0.044, RoF 1, Shots 1(5), ST 10, Bulk -1, Rcl 6.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>330</value>
	<weight>10.3/0.044</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+1 pi+</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(5)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>.54-Flintlock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мушкеты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Dreyse M.1841</description>
	<description-loc>Пруссия 1841

<img data-src="http://weapons.gurps.ru/img/98.png">

Не надежный - клинит на 16+



Dreyse Zündnadelgewehr Modell 1841 (“винтовка со стрелковой иглой”) стояла на вооружении Пруссии 1848 по 1871 однако производство было начато ранее 1841.

Использовалась в немецкой революции, в войне против Дании (1864), Австии (1866) и Фраиции (1870). Более 600,000 было выпущено это было избыточно и за счет этого был дешева. 

Однозарядная затворная винтовка являлась переходной технологии между зарядом в ствол и металлическими пулями. Ее прозвали “иголчатой”, за то что в качестве бойка использовалась длинная игла чтобы протыкать бумажную оболочку и попадать по капсулю. У нее была низкая надежность, в основном из за этой иголки которая часто ломалась.

Имела шытк  (0.7-lb.Reach 1, 2*).</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>300</value>
	<weight>10.9/0.085</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi++</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>400/2,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>15.43x54mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Пруссия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield P/1853</description>
	<description-loc>Великобритания 1853

<img data-src="http://weapons.gurps.ru/img/99.png">

Не надежный - клинит на 16+





Был на вооружение британской армии пока не был вытеснен оружием заряжаемым с казенника. Продавался по всему миру, в основном в Европе. вовремя на американской гражданской войны обе стороны использовали сотни тысяч таких.

Кроме стандартных пуль (указаны в таблице) применялись  SAPLE (Dmg 3d+2 pi+ с последующим 1d-2 [1d-1] cr ex) и многошариковые  (Dmg 1d+1 pi, Acc 2, Range 50/550, RoF 1x3, Rcl 1). Мог быть оснащен штыком (0.8-lb.Reach 1, 2*).

Springfield M1858 (1858-1866) .58 калибра был столь конструктивно похож, что патрон был взаимозаменяем.

В 1866 Британская армия решила  заменить дульную зарядку на металлический патрон с зарядом в казенник. Такой винтовкой стал  Snider Pattern I (1866-1873) каолибра .577 Snider: Dmg 4d+1 pi+, Range 200/2,200, Wt. 10/0.1, Shots 1(3). Было выпущено 815,000.  Хотя он скоро был заменен Martini-Henry, Snider оставался на вооружения в колониях какое-то время, а так-же пошел на продажу. Использовался в Африке до 1940! Был выражение в Японии в 1880-x под названием Sunaidoru-juu</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>285</value>
	<weight>9.3/0.086</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+2 pi+</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>120/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(15)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.577 Caplock</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Volcanic</description>
	<description-loc>США 1855

<img data-src="http://weapons.gurps.ru/img/100.png">

Не надежный - клинит на 16+



Была одной из первых винтовок рычажного действия с магазином. Является прямым прародителем знаменитого Винчестера. разработана Смит энд Вессон, стреляет шариковым патроном который был странным гибридом - являлся контейнером, но бел полностью безоболоченым - имел крышки снизу и сверху. Патроны заряжались магазин-трубу под стволом.  Однако он оказался не очень хорошим стволом -  достаточно точным, не достаточно мощным, и имел неудобный хват. Было выпущено менее 2000.

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>750</value>
	<weight>8/0.45</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>2</accuracy>
		<range>70/800</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>25+1(3i)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.38 Volcanic</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Spencer M1860</description>
	<description-loc>США 1863

<img data-src="http://weapons.gurps.ru/img/101.png">

Стал первый успешной магазинной  винтовкой. Значительное число было использовано во время американской гражданской войны.  Было выпущено 48,000.  появлялся в фильме  с Клинтом Иствудом “не прощенный”.

Имела съемный трубный магазин в деревянном прикладе. Из него патроны поступали ствол  с помощью куркового взвода.  Боёк находящийся снаружи необходимо было взвести перед каждым выстрелом. Предзаряженый магазин можно быстро поменять (5 ready маневров), но он был 30см длиной и весил 0.6lbs.

M1865 (1865-1867) была разработана под калибр  .56-50 Spencer (still Dmg 3d+2 pi+). Позволяла заряжать патроны прямо в  ствол, дает возможность держать в магазин в резерве.  Было выпущено 61,000.  Стало основным оружием США, Франции и Японский кавалерии в 1860х - 1870х</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>8.8/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+2 pi+</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>180/2,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>7+1(16)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.56-56-Spencer</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Rolling Block</description>
	<description-loc>США 1868

<img data-src="http://weapons.gurps.ru/img/102.png">

Это было высокоточная винтовка высочайшего качества конца 19 века, и в большей степени оружия профессионалов -  охотники на бизонов часто используемые,в разных калибрах. Поставлялась хрупким но очень точным микрометром-прицелом.  У некоторых были квартиры новое действие. было выпущено около 10,000 штук.

Number 1 Long Range Creedmoor (1874-1891)  более мощная версия калибра .44-90 Remington Special: Acc 5, Range 600/3,600, Wt. 10.6/0.12, ST 11†, Cost $1,750. Было выпущено всего 500 штук. Это высококачественное (точное) оружие. 

The Number 10 (1877-1934)  одна из версий дробовика  под калибр 12G ( дымно пороховой) Dmg 1d+1 pi, Acc 3, Range 40/800, Wt. 7/0.1, RoF 1x8, Rcl 1.

 Достаточно часто эти охотничьи винтовки использовались в армии. Более миллиона было сделано для Первой мировой войны и на экспорт. Многие страны производили их по лицензии. Военные винтовки Surplus Rolling Block  были популярны среди охотников и у наемников погода 20 века. Колибры: 11.15x58mmR Spanish Remington (Dmg 4d+1 pi+), распространён в Латинской Америке из Китае, and 11.4x50mmR Egyptian Remington (Dmg 4d+1 pi+),  популярен в Северной Африке.



</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>650</value>
	<weight>9.2/0.086</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.45-70</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Rolling Block (Number 1 Long Range Creedmoor)</description>
	<description-loc>США 1868

<img data-src="http://weapons.gurps.ru/img/102.png">

Это было высокоточная винтовка высочайшего качества конца 19 века, и в большей степени оружия профессионалов -  охотники на бизонов часто используемые,в разных калибрах. Поставлялась хрупким но очень точным микрометром-прицелом.  У некоторых были квартиры новое действие. было выпущено около 10,000 штук.

Number 1 Long Range Creedmoor (1874-1891)  более мощная версия калибра .44-90 Remington Special: Acc 5, Range 600/3,600, Wt. 10.6/0.12, ST 11†, Cost $1,750. Было выпущено всего 500 штук. Это высококачественное (точное) оружие. 

The Number 10 (1877-1934)  одна из версий дробовика  под калибр 12G ( дымно пороховой) Dmg 1d+1 pi, Acc 3, Range 40/800, Wt. 7/0.1, RoF 1x8, Rcl 1.

 Достаточно часто эти охотничьи винтовки использовались в армии. Более миллиона было сделано для Первой мировой войны и на экспорт. Многие страны производили их по лицензии. Военные винтовки Surplus Rolling Block  были популярны среди охотников и у наемников погода 20 века. Колибры: 11.15x58mmR Spanish Remington (Dmg 4d+1 pi+), распространён в Латинской Америке из Китае, and 11.4x50mmR Egyptian Remington (Dmg 4d+1 pi+),  популярен в Северной Африке.



</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>Cost 1,750</value>
	<weight>10.6/0.12</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>11†</strength>
		<accuracy>5</accuracy>
		<range>600/3,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.44-90 Remington Special</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Rolling Block (The Number 10)</description>
	<description-loc>США 1868

<img data-src="http://weapons.gurps.ru/img/102.png">

Это было высокоточная винтовка высочайшего качества конца 19 века, и в большей степени оружия профессионалов -  охотники на бизонов часто используемые,в разных калибрах. Поставлялась хрупким но очень точным микрометром-прицелом.  У некоторых были квартиры новое действие. было выпущено около 10,000 штук.

Number 1 Long Range Creedmoor (1874-1891)  более мощная версия калибра .44-90 Remington Special: Acc 5, Range 600/3,600, Wt. 10.6/0.12, ST 11†, Cost $1,750. Было выпущено всего 500 штук. Это высококачественное (точное) оружие. 

The Number 10 (1877-1934)  одна из версий дробовика  под калибр 12G ( дымно пороховой) Dmg 1d+1 pi, Acc 3, Range 40/800, Wt. 7/0.1, RoF 1x8, Rcl 1.

 Достаточно часто эти охотничьи винтовки использовались в армии. Более миллиона было сделано для Первой мировой войны и на экспорт. Многие страны производили их по лицензии. Военные винтовки Surplus Rolling Block  были популярны среди охотников и у наемников погода 20 века. Колибры: 11.15x58mmR Spanish Remington (Dmg 4d+1 pi+), распространён в Латинской Америке из Китае, and 11.4x50mmR Egyptian Remington (Dmg 4d+1 pi+),  популярен в Северной Африке.



</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>650</value>
	<weight>7/0.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>40/800</range>
		<rate_of_fire>1x8</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>1</recoil>
		<ammo>12G</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Martini-Henry Mk I</description>
	<description-loc>Великобритания 1871

<img data-src="http://weapons.gurps.ru/img/103.png">

<img data-src="http://weapons.gurps.ru/img/480.png">



Эта тяжелая, заряжаемая с задней части, однозарядная винтовка повидала многое за 19век. Британия приняла ее на вооружение в 1871. Некоторые использовались даже в 20 веке. Засветилась в фильме Зулус.

Эксплуатация: рычаг ниже приклада наклоняет затвор вверх, выбрасывая пустую гильзу, после чего можно вставлять новый патрон.  .450 Martini-Henry патрон был незаслуженно раскритикован, но он был сделан из накатных слоёв что делал его уязвимым к разрыва и заклиниваниям. При броске malfunction (B407) заклинивание означает что необходимо ножом или отверткой выковыривать патрон (6 маневров Ready)

C 1885, для колонизаторов доступен в виде дробовика: Dmg 1d(0.5) pi-, Range 35/700, RoF 1x11, Rcl 1.

Имела штык (1.1-lb. Reach 1, 2*). 

Greener-Martini Mk II (1922-1998) стал легким гарпуном для охоты на моржей и крупную рыбу. Стреляло зазубренным гарпуном (0.6lbs - $175 каждый) из ствола используя .38 холостой патрон: Dmg 6d imp, Acc 2, Range 35/120, Wt. 13.1/1.6, RoF 1, Shots 1(45), ST 11†, Bulk -6, Rcl 4, Cost $2,000. К гарпуну прикреплялась 45 метровая 1/4" веревка (3.25 lbs.) несущая нагрузку до 300 lbs.



</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>550</value>
	<weight>8.9/0.11</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.450 MH</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Martini-Henry Mk I (Greener-Martini Mk II harpoon)</description>
	<description-loc>Великобритания 1871

<img data-src="http://weapons.gurps.ru/img/103.png">

<img data-src="http://weapons.gurps.ru/img/480.png">



Эта тяжелая, заряжаемая с задней части, однозарядная винтовка повидала многое за 19век. Британия приняла ее на вооружение в 1871. Некоторые использовались даже в 20 веке. Засветилась в фильме Зулус.

Эксплуатация: рычаг ниже приклада наклоняет затвор вверх, выбрасывая пустую гильзу, после чего можно вставлять новый патрон.  .450 Martini-Henry патрон был незаслуженно раскритикован, но он был сделан из накатных слоёв что делал его уязвимым к разрыва и заклиниваниям. При броске malfunction (B407) заклинивание означает что необходимо ножом или отверткой выковыривать патрон (6 маневров Ready)

C 1885, для колонизаторов доступен в виде дробовика: Dmg 1d(0.5) pi-, Range 35/700, RoF 1x11, Rcl 1.

Имела штык (1.1-lb. Reach 1, 2*). 

Greener-Martini Mk II (1922-1998) стал легким гарпуном для охоты на моржей и крупную рыбу. Стреляло зазубренным гарпуном (0.6lbs - $175 каждый) из ствола используя .38 холостой патрон: Dmg 6d imp, Acc 2, Range 35/120, Wt. 13.1/1.6, RoF 1, Shots 1(45), ST 11†, Bulk -6, Rcl 4, Cost $2,000. К гарпуну прикреплялась 45 метровая 1/4" веревка (3.25 lbs.) несущая нагрузку до 300 lbs.



</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>2,000</value>
	<weight>13.1/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d imp</damage>
		<strength>11†</strength>
		<accuracy>2</accuracy>
		<range>35/120</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(45)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.38 + harpoon</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M1873</description>
	<description-loc>США 1873

<img data-src="http://weapons.gurps.ru/img/104.png">



Эту винтовку часто называли “Trapdoor” (калитка) за ее шарнирный затворный механизм. Армия США приняла ее на вооружение в 1973 и она являлась официальной винтовкой до 1895. И до 20 века она оставалась в резерве.

M1873 была чувствительна к грязи и низкосортным патронам. Экстрактор мог сбросить следующий патрон и застрять с ним. Такая проблема проявлялась только при скоростной стрельбе и если это были мягко обмолоченные патроны. К сожалению армия США держала на вооружении именно такие патроны до 1880х - они были дешевле, а Конгресс требоал экономии. При неисправности  (Malf p. B407)  заклинивание означает что чинить нежно с помощью ножа или отвертки и это займет 6 раундов.

M1873 имела штык 1-lb. (Reach 1, 2*).

 M1873 Carbine (1873-1878) имела укороченный ствол и стрелял ослабленным патроном .45-55: Dmg 4d-1 pi+, Range 400/2,600, Wt. 7.1/0.08, Bulk -5. Часто использовалась кавалерией во времена войны с индейцами, выбиралась за лучшую дальность и мощность чем Внчестер.

</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>570</value>
	<weight>9.2/0.086</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.45-70</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Springfield M1873 (Carbine )</description>
	<value>570</value>
	<weight>Wt. 7.1/0.08</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 pi+</damage>
		<strength>10†</strength>
		<accuracy>3</accuracy>
		<range>400/2,600</range>
		<shots>1(3)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>.45-55</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>5</tech_level>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 1873
		<img data-src="http://weapons.gurps.ru/img/104.png">
		Эту винтовку часто называли “Trapdoor” (калитка) за ее шарнирный затворный механизм. Армия США приняла ее на вооружение в 1873 и она являлась официальной винтовкой до 1895. И до 20 века она оставалась в резерве.

M1873 была чувствительна к грязи и низкосортным патронам. Экстрактор мог сбросить следующий патрон и застрять с ним. Такая проблема проявлялась только при скоростной стрельбе и если это были мягко обмолоченные патроны. К сожалению армия США держала на вооружении именно такие патроны до 1880х - они были дешевле, а Конгресс требоал экономии. При неисправности  (Malf p. B407)  заклинивание означает что чинить нежно с помощью ножа или отвертки и это займет 6 раундов.

M1873 имела штык 1-lb. (Reach 1, 2*).

 M1873 Carbine (1873-1878) имела укороченный ствол и стрелял ослабленным патроном .45-55: Dmg 4d-1 pi+, Range 400/2,600, Wt. 7.1/0.08, Bulk -5. Часто использовалась кавалерией во времена войны с индейцами, выбиралась за лучшую дальность и мощность чем Внчестер.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester M1873</description>
	<description-loc>США 1873

<img data-src="http://weapons.gurps.ru/img/105.png">

Самая знаменитая винтовка рычажного действия. 

Henry Rifle (1862-1866) под калибр .44 Henry: Dmg 2d+1 pi+, Range 250/1,900, Wt. 10.1/0.6, Shots 15+1(4i), ST 6† Cost $760. Долго перезаряжается. подствольный магазин отрывается достаточно сложно, и патроны загружатся спереди. Всего было использовано 1,900 во времена Американской Гражданскей войны, но были популярны у гражданских. Было выпущено  13,500 штук.

Winchester Model 1866 (1866-1898) так-же под патрон .44 Henry доавлена зарядка сбоку. Dmg 2d+1 pi+, Range 250/1,900, Wt. 10/0.7, Shots 17+1(3i), ST 8†. Прозвано “желтый мальчик” за сеяющий медный казенник. Так-же был доступен в виде карабина  (Dmg 2d pi+, Wt. 7.8/0.5, Shots 13+1) и длинной винтовки  со штыком (Dmg 2d+2 pi+, Wt. 9/0.7, Shots 17+1, Bulk -6). Засветилась в десятках голливудских вестернов. Армия США никогда не брала их на вооружения, хотя некоторые войска закупали их самостоятельно. Было выпущено около 170,000.

Winchester ’73 под более мощный патрон  .44-40 Winchester. Выпускалась в виде длинной винтовки Wt. 8.7/0.7, Shots 17+1, Bulk -6), и карабина (Wt. 7.8/0.5, Shots 12+1). С 1879 так-же доступен калибр .38-40 Winchester (Dmg 3d-2 pi+) – а с1882, .32-20 Winchester (Dmg 2d+1 pi). Около 720,000 ,было выпущено, восновном в калибре .44-40.

Model 1876 (1876-1897) под патрон 45-75 Winchester: Dmg 4d+1 pi+, Range 370/2,300, Wt. 10.1/1, Shots 12+1, ST 10†, Rcl 3, Cost $460. Любимая винтовка Теодора Рузвельта. С 1879, так-же выпускалась в калибре .50-95 Express: Dmg 4d+2 pi+, Range 400/2,500, Wt. 10.2/1, Shots 10+1, ST 10†, Rcl 3, Cost $460. Около 64,000 было выпущено.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>420</value>
	<weight>8.9/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+1 pi+</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>300/2,200</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>15+1(2i)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.44-40</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Sharps Model 1874</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/106.png">

Заряжается с казенной части, была любимой среди Американских Охотников на бизонов. Огромный ствол 76 сантиметров, двойные куртки, и прицел с микрометром. Было выпущено  6500 штук в разных калибрах. Около четверти были оснащены с завода оптическим прицелом 6x (1.2-lb. +2 Acc).

Патрон .50-90  впервые появился в 1875.  Был назван “большим полтинником” среди Охотников на бизонов.  Также выпускался в нескольких других калибрах: .45-70 Springfield (Dmg 4d+1 pi+),  и по специальному заказу .45-110 Sharps (Dmg 5d pi+) или .50-140 Sharps (Dmg 5d+1 pi+).</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>10.7/0.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>11†</strength>
		<accuracy>4</accuracy>
		<range>360/3,900</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.50-90</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Greener Elephant Rifle</description>
	<description-loc>Великобритания 1881

<img data-src="http://weapons.gurps.ru/img/107.png">

Нет крепления для ремня

Двух ствольное оружие  с открытыми полками и относительно короткими стволами,  разработана для охоты на слонов и других крупных животных. Его огромные старинные патроны стреляют шариковым снарядом.  Такие винтовки были популярны у охотников в Африке и Азии до тех пор пока не были заменены толстый Express.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>3</legality_class>
	<value>3,000</value>
	<weight>12/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi++</damage>
		<strength>13†</strength>
		<accuracy>4</accuracy>
		<range>180/1,800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-5</bulk>
		<recoil>7</recoil>
		<ammo>8-bore</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Lebel Mle 1886</description>
	<description-loc>Франция 1886

<img data-src="http://weapons.gurps.ru/img/108.png">



Fusil d’Infanterie Lebel Modèle 1886 (Пехотная винтовка модель 1886), выпускалась арсеналом  Франции  по чертежи Николя Лебела,  была первой бездымный винтовкой среднего калибра.  Было выпущено около четырех миллионов.  Было очень распространено, Иностранный легион Франции и колониальные армии использование в Азии Африки, эксплуатировалась в северную и Восточную Европу до 20 годов. 

Это винтовка с ручным затвором и трубой подствольного магазина.  один патрон в стволе, второй между магазином и стволом этого 10 при полной зарядке. Длина этой винтовки огромна даже без учета штыка (1.1-lb. Reach 1, 2*). С 3х прицелом (+1 Acc) служила в качестве снайперской винтовки с 1916 до Второй Мировой. 

 Новая версия 1907/15 (1915-1918)  использовала обойма на 3 патрона Wt. 8.5/0.2, Shots 3(3).  А модель  1916 (1916-1919)  была с пятью патронами: Wt. 8.6/0.3, Shots 5(3).



</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>10/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>900/3,900</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>8+2(3i)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>8x50mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Винтовка Мосина</description>
	<description-loc>Россия / СССР 1891

<img data-src="http://weapons.gurps.ru/img/109.png">



Винтовка с ручным затвором 1891 года было на вооружении в России до 1930. а также встречалась на полях сражений во времена Второй мировой.  Было выпущено около 10 миллионов.  в русской армии штык был почти всегда присоединен (1.1-lb. Reach 1, 2*). 

V-1891/30 (1931-1958) Коротко-ствольная винтовка заменила предыдущую: Dmg 7d pi, Range 1,000/4,200, Wt. 9/0.3, Bulk -5. таких было выпущено 18 миллионов, широко экспортировались после Второй Мировой, имела оптический прицел  (1.3-lb. 4x +2 Acc). Стала стандартной Советской снайперской винтовкой. замечена в фильме Враг у ворот. 1941 года доступен глушитель (1.1-lb -2 to Hearing, -1 Bulk, на 85 выстрелов). Однако  требуется использовать дозвуковые патроны Dmg 4d pi, Range 380/1,600, что в сумме дает -4 to Hearing (включая модификатор за затвор).



</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>700</value>
	<weight>9.2/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Винтовка Мосина (Short)</description>
	<description-loc>Россия / СССР 1891

<img data-src="http://weapons.gurps.ru/img/109.png">



Винтовка с ручным затвором 1891 года было на вооружении в России до 1930. а также встречалась на полях сражений во времена Второй мировой.  Было выпущено около 10 миллионов.  в русской армии штык был почти всегда присоединен (1.1-lb. Reach 1, 2*). 

V-1891/30 (1931-1958) Коротко-ствольная винтовка заменила предыдущую: Dmg 7d pi, Range 1,000/4,200, Wt. 9/0.3, Bulk -5. таких было выпущено 18 миллионов, широко экспортировались после Второй Мировой, имела оптический прицел  (1.3-lb. 4x +2 Acc). Стала стандартной Советской снайперской винтовкой. замечена в фильме Враг у ворот. 1941 года доступен глушитель (1.1-lb -2 to Hearing, -1 Bulk, на 85 выстрелов). Однако  требуется использовать дозвуковые патроны Dmg 4d pi, Range 380/1,600, что в сумме дает -4 to Hearing (включая модификатор за затвор).



</description-loc>
	<tech_level>6</tech_level>
	<value>700</value>
	<weight>9/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester M1894</description>
	<description-loc>США 1894

<img data-src="http://weapons.gurps.ru/img/110.png">

Винтовка дизайна Браунинга была первой моделью Винчестера использующий бездымный порох, стала очень распространенной в Америке.  Большая линейка почти идентичных винтовок рычажного типа с подачей патронов из  приклада. Было выпущено более 6 миллионов.

Часто была на вооружении, особенно распространилась во времена мексиканская революция 1910. Во времена Первой Мировой использовалась королевской морской пехотой.  полицейские часто закупали их особенно на севере США. была на вооружении у большинства тюрьмы США. Даже в самом маленьком городке можно было купить несколько коробок .30-30 патронов.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>7.2/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>900/3,700</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>5+1(2i)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.30-30</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Mauser Gew98</description>
	<description-loc>Германия 1900

<img data-src="http://weapons.gurps.ru/img/111.png">



Gewehr 98 Была стандартной винтовкой немецкой армии во времена Первой мировой войны. Многие считали что это было лучшее винтовка с ручным затвором в мире. выпускалась множестве разных калибров. была столь успешно что в течение 20 века использовалась для разных целей от пехотного карабина до  cнайперской винтовки или охотничьего ружья.  Часто во многих конфликтов до 1952 года обе стороны были вооружены маузером.

Можно установить штык нож (1-lb.  Reach 1, 2*), и обойма на 5 патронов. В Первую мировую использовались также как магазин на 25 патронов: Wt. 11.3/1.5, Shots 25(15).  С 1915, 1.1-lb. 4x прицел (+2 Acc) для снайперов.





Широко экспортировались по всему миру, в разных калибрах: 7x57mm Mauser (Dmg 6d+2 pi) в Бразилию и Мексику, 7.65x53mm Mauser (Dmg 6d+2 pi)  в Аргентину, Боливию и Турцию.  В 1920 получили новый приклад и укороченный  ствол 12G 2.75” ружье продавалась на экспорт в Африку и Америку: Dmg 1d+1 pi, Acc 3, Range 40/800, Wt. 6.2/0.2, RoF 1x9, Shots 2+1(3i), ST 10†, Rcl 1/6. 





Pirschbüchse C98/07 (1907-1938)  было охотничьей винтовкой калибром  8x60mm Mauser: Dmg 7d pi, Wt. 7.5/0.3, Shots 5(3i). Также выпускались  калибром  7x57mm Mauser (Dmg 6d+2 pi) и 10.75x68mm Mauser (Dmg 7d+1 pi+). многие были инкрустированные (HT10).

Kar98k  немецкая винтовка пехоты Второй мировой войны: Dmg 7d pi, Range 1,000/4,300, Wt. 8.9/0.3, Shots 5+1(3), ST 10†, Cost $400.  Широко экспортировались выпускалась по лицензии копировалась по всему миру. С 30 по 50 года это была самая распространенная  военная винтовка по всему миру. только немецкая армия приобрела более 10 миллионов. Также использовалась Китаем, Чехословакией, Израилем, Персей, Польшей, Румынией, Испанией, Турцией и Югославией.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>900</value>
	<weight>9.5/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>11†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;H Royal Double-Express</description>
	<description-loc>Великобритания 1903

<img data-src="http://weapons.gurps.ru/img/112.png">

Высококачественна (точная)

Всегда инкрустирована

Нет крепления для ремня



Holland &amp; Holland Была самой мощной охотничьей винтовкой до 1950. Единственное оружие калибра .600 Nitro Express. Дорогостоящая, двухствольная, открывающиеся на излом  классическая английская винтовка. Обычно продавалась только в дорогих оружейных Лондона, и самых дорогих спортивных магазинах в крупных городах мира. Модель на заказ заказчик мог ждать год или больше, она была очень дорогостоящей. В Африке такие винтовки обычно становились подержанным товаром после того как предыдущий владелец допустил ошибку с носорогом или слоном. 

В 1974  прекращен выпуск винтовки этого калибра. Однако сторонние производители делают подобное под заказ. Подержанная винтовка в хорошем состоянии в наше время стоит до $60,000.

С 1907, еще одним распространенным калибром становится .470 Nitro Express: Dmg 8d+2 pi+, Range 640/4,000, Wt. 14.2/0.24, ST 12†, Rcl 5. 

С 1989, представлен .700 Nitro Express: Dmg 5dx2 pi++, Range 600/3,800, Wt. 19.3/0.5, ST 15†, Rcl 9, Cost $116,000. 

Владельцу винтовки (оригиальному!) необходимо взять перк “Weapon Bond (HT250)”</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>9,500</value>
	<weight>16.4/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5dx2 pi++</damage>
		<strength>14†</strength>
		<accuracy>5</accuracy>
		<range>800/4,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>2(3i)</shots>
		<bulk>-7</bulk>
		<recoil>7</recoil>
		<ammo>.600 NE</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M1903</description>
	<description-loc>США 1906

<img data-src="http://weapons.gurps.ru/img/113.png">

В 1906 армия США начала использовать M1903 - фактически копию Маузера 98, но стала выдающейся за счет качественной сборки, отличной точности и отличных патрново. Винтовка распространилась  по миру в качестве военного оружия и спортивного. Было выпущено около двух миллионов.  Иммет штык (1.1-lb.Reach 1, 2*). Стандартно имеет обойма на 5 патронов. Во времена Первой Мировой некоторые винтовки получили магазин на 20 патронов  Wt. 10/1.2, Shots 20(12). 

M1903A4 (1943-1944) снайперский вариант с 2.5х прицелом: Acc 5+1, Wt. 9.7.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>900</value>
	<weight>8.8/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Arisaka Meiji 38 Shiki</description>
	<description-loc>Япония 1907

<img data-src="http://weapons.gurps.ru/img/114.png">

Основана на Mauser ’98. была на вооружение японской армии до 1939, а также использовать во Второй Мировой войне. Было выпущено более трех миллионов. Экспортировала семидесятых в двадцатых годах, Британия приобрела 150 000 под названием Pattern 07, Россия получила около полумиллиона. Мексика приняла на вооружение экспортный вариант под патрон 7x57mm Mauser (Dmg 6d+2 pi).

Arisaka 38 Shiki  использовала обои на на 5 патронов имела штык-меч 0.9-lb. (Reach 1, 2*). 2.5x прицел (+1 Acc)   превращал ее в снайперскую винтовку.

На замену пришла Arisaka 99 Shiki Tanshoujuu (1939-1945), 7.7x58mm Arisaka: Dmg 6d+2 pi, Range 900/3,900, Wt. 8.6/0.3.



</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>700</value>
	<weight>9.4/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>600/3,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>6.5x50mmSR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Япония</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield SMLE Mk III</description>
	<description-loc>Великобритания 1907

<img data-src="http://weapons.gurps.ru/img/115.png">

Коротко-магазинная винтовка  служил в британской армии в течении обоих мировых войн. широко распространилась по британским колониям, так чтобы производилась в Австралии и Индии (где используется и по сей день).  Было выпущено 7  миллионов.

 Это одна из самых  скорострельность затворных винтовок. Имела магазин с единственным патроном вставляем и сверху, или обойма на 5 патронов (0.3 lb.).  Магазин был съемный (1 lb.), но не использовался поскольку каждая винтовка жила только с одним магазином. Если он доступен магазин, перезарядка занимает  3 маневрf подготовки. Имеется штык меч 1.3-lb. (Reach 1, 2*).

Дизайн менялся в течение почти века производство. Ранние версии Lee-Metford Mk I (1889-1892) заправлялись черно-пороховыми патронами. Несли 6 патронный магазин.  Dmg 5d+2 pi, Range 700/3,000, Wt. 10/0.5, Shots 8+1(3i), Bulk -6.  было выпущено 360 000. The Lee-Metford Mk II (1892-1895) с 10 патронами магазинам : Dmg 5d+2 pi, Range 700/3,000, Wt. 9.9/0.6, Shots 10+1(3i), Bulk -6.

SMLE Mk I (1903-1907) Стреляли улучшенным  бездымным патроном  Wt. 8.7/0.6, Shots 10+1(5).

Number 4 Mk I (1941-1945) Были очень дешевыми Wt. 9.6/0.6, Shots 10+1(5). более четырех миллионов было произведено в Австралии, Канаде, Индии, Британии  из США.

Sterling De Lisle Mk I (1944-1945) Оружие подавления спецназовцев на основе mk3. под патрон .45 ACP, имел встроенный глушитель  (-3 to Hearing,   включая модификатор за затвор),  использовала обоймы от Colt Government Dmg 3d-1 pi+, Acc 3, Range 150/1,600, Wt. 8.7/0.5, Shots 7+1(3), ST 9†, Bulk -4, Rcl 2.  было выпущено всего 200 штук, использовались в пятидесятых годах в Корее и Малайзии.

L42A1 (1965-1970) снайперская винтовка описана отдельно</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>700</value>
	<weight>9.2/0.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>800/3,300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10(5)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.303</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Mauser T-Gew18</description>
	<description-loc>Германия 1918

<img data-src="http://weapons.gurps.ru/img/116.png">

Нет крепления для ремня

Mauser Tank-Gewehr



После неожиданной британской танковой атаки  в Первую мировую войну, немцы разработали огромную однозарядную затворную винтовку для поражения бронированной техники.

Длиной 167 см, оружие стреляло пулями APHC, способными пробить любой танк того времени. Использовать для стрельбы лежа с сошек. Его пугающая отдача сломала ключицу многим немецким солдатам (при броске 18 при атаке,  если ST стрелка меньше минимальной - получает 1d-4 cr повреждений).

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>10,000</value>
	<weight>40/0.26</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5dx2(2) pi</damage>
		<strength>16B†</strength>
		<accuracy>5</accuracy>
		<range>2,100/8,800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3i)</shots>
		<bulk>-8</bulk>
		<recoil>6</recoil>
		<ammo>13x92mmSR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Browning M1918 BAR</description>
	<description-loc>США 1918

<img data-src="http://weapons.gurps.ru/img/117.png">

<img data-src="http://weapons.gurps.ru/img/483.png">

Browning Automatic Rifle (BAR) – поступило на вооружение в США в 1918 – тяжелая автоматическая винтовка разработанная для стрельбы от бедра или плеча во время атаки. Около 100,000 было приведено но поступило слишком поздно на вооружение в для Первой Мировой. 



Между войнами американская полиция и охрана тюрем использовали BAR, так же был в почете у гангстеров в том числе у Бони и Клайда - они крали их из полицейских участков и оружейных складов. Клайд любил обрезать ствол мушки и приклад (Dmg 6d+2 pi, Acc 3, Wt. 15.2,

ST 12†, Rcl 3.))

Очередь из такого могла остановить машину куда лучше чем из "Томми".



Он остается оружием пехоты в начале ВОВ



Так же выпускались бронебойные патроны (Dmg 5d(2) pi-)



Colt R75 (1925-1942) коммерческий вариант в пистолетной ручкой, утяжеленным стволом и сошками: Wt. 21.4, ST 11B†.



Около 5,000 было выпущено для полицейских, гражданских и на экспорт.



Colt R80 Monitor (1931-1942) еще одна коммерческая версия с пистолетный ручкой, укороченным стволом и дульным компенсатором: Dmg 6d+2 pi, Acc 4, Wt. 17.3, ST 11†, Bulk -5, Cost $3,600.

Было выпущено всего 125 штук и большинство ушли в ФБР.



M1918A2 (1943-1953) - усиленный ствол и сошки Wt. 22.5, RoF 6/9!, ST 11B†. 

Он не стреляет одиночными, но имеет де разные скорости стрельбы (малый RoF 6!, большой RoF 9!). Во времена ВОВ и Корейской Войны он часто использовался в качестве пулемета.

Было выпущено около 250,000 



В 20x-30x годах выпускались по лицензии в Швеции 6.5х55mm Mauser (Dmg 6d pi), Бельгии Belgium in 7.65х53mm Mauser (Dmg 6d+2 pi), и Польше 7.92х57mm Mauser (Dmg 7d pi).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>2,300/31</value>
	<weight>17.1/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Browning M1918 BAR (Colt R80 Monitor)</description>
	<description-loc>США 1918

<img data-src="http://weapons.gurps.ru/img/117.png">

<img data-src="http://weapons.gurps.ru/img/483.png">

Browning Automatic Rifle (BAR) – поступило на вооружение в США в 1918 – тяжелая автоматическая винтовка разработанная для стрельбы от бедра или плеча во время атаки. Около 100,000 было приведено но поступило слишком поздно на вооружение в для Первой Мировой. 



Между войнами американская полиция и охрана тюрем использовали BAR, так же был в почете у гангстеров в том числе у Бони и Клайда - они крали их из полицейских участков и оружейных складов. Клайд любил обрезать ствол мушки и приклад (Dmg 6d+2 pi, Acc 3, Wt. 15.2,

ST 12†, Rcl 3.))

Очередь из такого могла остановить машину куда лучше чем из "Томми".



Он остается оружием пехоты в начале ВОВ



Так же выпускались бронебойные патроны (Dmg 5d(2) pi-)



Colt R75 (1925-1942) коммерческий вариант в пистолетной ручкой, утяжеленным стволом и сошками: Wt. 21.4, ST 11B†.



Около 5,000 было выпущено для полицейских, гражданских и на экспорт.



Colt R80 Monitor (1931-1942) еще одна коммерческая версия с пистолетный ручкой, укороченным стволом и дульным компенсатором: Dmg 6d+2 pi, Acc 4, Wt. 17.3, ST 11†, Bulk -5, Cost $3,600.

Было выпущено всего 125 штук и большинство ушли в ФБР.



M1918A2 (1943-1953) - усиленный ствол и сошки Wt. 22.5, RoF 6/9!, ST 11B†. 

Он не стреляет одиночными, но имеет де разные скорости стрельбы (малый RoF 6!, большой RoF 9!). Во времена ВОВ и Корейской Войны он часто использовался в качестве пулемета.

Было выпущено около 250,000 



В 20x-30x годах выпускались по лицензии в Швеции 6.5х55mm Mauser (Dmg 6d pi), Бельгии Belgium in 7.65х53mm Mauser (Dmg 6d+2 pi), и Польше 7.92х57mm Mauser (Dmg 7d pi).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>3,600</value>
	<weight>17.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>11†</strength>
		<accuracy>4</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M1 Garand</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/118.png">

Разработана John Garand, первая успешная полуавтоматическая винтовка получившие всемирное распространение. Доллар США серьезное преимущество Второй мировой войне  против  винтовок с ручным затвором. Принята на вооружение армии США в 1936 году. распространилась по всему миру после 1945.  Было выпущено около 6 миллионов. Японцы пытались скопировать ее под патрон 7.7x58mm Arisaka (Dmg 7d pi), Италия выпускала по лицензии 1950. в гражданскую продажу поступила в 1959. 

Стреляет одиночными и точными патронами, затвор работает на возврате дульных газов запятая что делает скоростную стрельбу более легкой. Использует магазин на 6 патронов, который автоматические выбрасывается при опустошения характерным звуком. имеет штык (1.1-lb.Reach 1, 2*),  а с 1943 штык нож (0.8-lb.Reach 1). 

M1C (1944-1945) Снайперская версия с оптическим прицелом 2.5x: Acc 5+1, Wt. 11.7.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>510</value>
	<weight>10.1/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester Model 70</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/119.png">

Это очень успешная охотничья винтовка основанная на Mauser ’98 ручного затвора.   выпускалась в десятках различных калибров, включая .220 Swift (Dmg 6d+2 pi), 7.62¥51mm NATO (Dmg 7d pi), и .375 H&amp;H Magnum (Dmg 8d+2 pi, Shots 4+1). Полтора миллиона единиц было выпущено. Большинство владельцев устанавливают оптический прицел.

Model 70 African (1956-2006) под калибр  .458 Winchester Magnum: Dmg 8d pi+, Range 1,100/6,700, Wt. 9.6/0.3, Shots 3+1(3i), ST 12†, Rcl 7, Cost $4,700.



</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>750</value>
	<weight>7.8/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Winchester Model 70 (Model 70 African)</description>
	<description-loc>США 1937

<img data-src="http://weapons.gurps.ru/img/119.png">

Это очень успешная охотничья винтовка основанная на Mauser ’98 ручного затвора.   выпускалась в десятках различных калибров, включая .220 Swift (Dmg 6d+2 pi), 7.62¥51mm NATO (Dmg 7d pi), и .375 H&amp;H Magnum (Dmg 8d+2 pi, Shots 4+1). Полтора миллиона единиц было выпущено. Большинство владельцев устанавливают оптический прицел.

Model 70 African (1956-2006) под калибр  .458 Winchester Magnum: Dmg 8d pi+, Range 1,100/6,700, Wt. 9.6/0.3, Shots 3+1(3i), ST 12†, Rcl 7, Cost $4,700.



</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>4,700</value>
	<weight>9.6/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d pi+</damage>
		<strength>12†</strength>
		<accuracy>5</accuracy>
		<range>1,100/6,700</range>
		<rate_of_fire>3+1(3i)</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-5</bulk>
		<recoil>7</recoil>
		<ammo>.458 Winchester Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Steyr-Solothurn S18-1000</description>
	<description-loc>Австрия 1938

<img data-src="http://weapons.gurps.ru/img/120.png">

<img data-src="http://weapons.gurps.ru/img/152.png">

Нет крепления для ремня



Противотанковая, полуавтоматическая винтовка разработана для стрельбы с сошек. Длиной 216см! Это почти пушка и она слишком крупна чтобы стрелять с плеча или от бедра (ну разве что гигантом или “мехом” но тогда потребуется поставить больший курок). В момент анонса это бело самое мощное противотанковое орудие переносимое человеком. Была приобретена Голландской Ост-Индией, Италией, Нидерландами, Швецией и Швейцарией, использовалась в Северной Африке во Второй Мировой Войне.

Подача ведется из 10 патронного магазина вставляемого с левой стороны. Стреляет AP (указано в таблице) и SAPHE  (Dmg 6dx3 pi++ с последующим a 2d [1d] cr ex). Укомплектована прицелом 2.75х. Может быть разобрана на две части по 44lbs и 73lbs для транспортировки в рюкзаке. Другой вариант - катать на двухколесной коляске, которая весит 306lbs вместе с орудием и коробкой на три магазина.

S18-1100 (1938-1940) была фактически идентична, но способна вести автоматический огонь: RoF 14.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>25,000/62</value>
	<weight>117/12.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx2(2) pi++</damage>
		<strength>18B†</strength>
		<accuracy>5+1</accuracy>
		<range>2,100/8,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10(5)</shots>
		<bulk>-11</bulk>
		<recoil>3</recoil>
		<ammo>20x138mmB</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Rheinmetall FG42</description>
	<description-loc>Германия 1943

<img data-src="http://weapons.gurps.ru/img/121.png">

Fallschirmjägergewehr 42 ("Винтовка парашютистов 1942") уникальная автоматическая винтовка разработана чтобы встать на вооружении десантников люфтваффе. Булпап с горизонтальным расположением магазина относительно не большой размер и сошки. Всего несколько сотен было сделано для пробы. Оно ни использовались в рейде по освобождению Мусолини в 1943.

Развитие версии продолжил Крюегофф в 1944-1945.

Последняя версия - Wt. 12.9/2, RoF 12. Было выпущено около 5,000 шт.

Некоторые были оснащены 4х оптическим прицелом (1.3lbs, +2 Acc)

Магазин на 10 патронов ($28, 1.1 lbs)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>2,000/31</value>
	<weight>11/1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Haenel StG44</description>
	<description-loc>Германия 1944

<img data-src="http://weapons.gurps.ru/img/122.png">

<img data-src="http://weapons.gurps.ru/img/305.png">

<img data-src="http://weapons.gurps.ru/img/306.png">

<img data-src="http://weapons.gurps.ru/img/307.png">

Стреляет патронам средней мощности она прошла путь моделей MKb42, MP43, and MP44, которые по большом счеты были одним и тем-же оружием. Несколько тысяч MKb42s тестировались на войне 1942, а MK43 пошла в производство. MK44 было выпущено 426,000 использовались в войнах в Африке, Азии.



В конце 1944 около 300 винтовок было снабжено секретной системой ZG1223 Vampir - активной ИК подсветки. 75 метров ИК освещения (HT47) и 4х ночной прицел ранних разработок (HT156) весом 5.1lbs +2 Acc и Night Vision 2.

Батареи надо было носить в рюкзаке - 30lbs, 2xL/4 час.



Так-же в 1944 около 1,500 получило съемный Krummlauf (“изогнутый ствол”). SGV J имело изогнутый на 30° ствол и призматический прицел для того чтобы пехота могла стрелять из за угла Acc 3, Wt. 16, Bulk -6, все броски с -2



SGV P, с 90° изгибом и 1.25х призматическим прицелом, была придумана для танковых бригад чтобы стрелять с крыши когда пехота атакует из слепой зоны танка: Acc 2, Wt. 17.7, Bulk -6, все броски с -4.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>850/31</value>
	<weight>13.2/2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>500/3,100</range>
		<rate_of_fire>8</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>7.92x33mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Самозарядный Карабин Симонова СКС 45</description>
	<description-loc>Россия / СССР 1949

<img data-src="http://weapons.gurps.ru/img/123.png">

Автоматическая винтовка под калибр 7.62 с несъемным  магазином. Крупная опытная серии использовались в боях 1944,  в бою за Берлин 1945,  Однако полноценное производство началось только в 1949. Был на Советской Армии пока не был полностью вытеснен АК47. Также производился в Албании, Китае, Восточной Германии, Северной Корее, Румынии и Югославии.  Тайская версия использовалась  во время вьетнамской войны.В Восьмидесятых годах излишек и коммерческие вариант экспортировались большое количество стран. В конце девяностых это была одна из самых продаваемых винтовок США, пользоваться успехом у охотников и любители выживание по некоторым оценкам  купившим 2  миллиона таких.

 Хотя обычно используют 10 патронный несъемный карабин, многие винтовки были модифицированы под стандартный съемный магазин АК47.  Несъемный штык (Reach 1) складывается вдоль ствола.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>8.9/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>500/3,100</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>10(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Калашникова АК-47</description>
	<description-loc>Россия / СССР 1947

<img data-src="http://weapons.gurps.ru/img/124.png">

<img data-src="http://weapons.gurps.ru/img/301.png">

Снабжался штык-ножом 0.6lbs (Reach:1). 

Часто заряжался бронебойным патроном (Dmg: 4d-1(2) pi- inc)



Оригинальная версия 47 года имела тяжелую точенную стволовую коробку, и Характерно изогнутый магазин. К середине 50х был экспортирован большинство коммунистических стран и производился по всему миру - в Болгарии, Китае, Восточной Германии, Финляндии, Венгрии, Польше и Румынии. Девять миллионов было выпущено только в советском союзе. Пакистан до сих пор производит такие ручной сборки.



Серия АКС (Складной 1951) со складным прикладом Wt: 10.6 Bulk -5*.



Серия АКМ (Модернизированный 1960) получила более дешевую и легкую штампованную стволовую коробку: Wt 8.7 Он получил еще большее распространение чем предшественник и встречается чаще всего.



Серия АКМС (Модернизированный Складной 1960): Wt 9.4 Bulk -5.



Серия AK-103 (1993) последния версия под этот патрон - пластиковый складной приклад и пластиковый магазин. Wt:9.1/1.6, Bulk -5*.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>450/30</value>
	<weight>11.3/1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>500/3,100</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Калашникова АКМ</description>
	<description-loc>Россия / СССР 1947

<img data-src="http://weapons.gurps.ru/img/124.png">

<img data-src="http://weapons.gurps.ru/img/301.png">

Снабжался штык-ножом 0.6lbs (Reach:1). 

Часто заряжался бронебойным патроном (Dmg: 4d-1(2) pi- inc)



Оригинальная версия 47 года имела тяжелую точенную стволовую коробку, и Характерно изогнутый магазин. К середине 50х был экспортирован большинство коммунистических стран и производился по всему миру - в Болгарии, Китае, Восточной Германии, Финляндии, Венгрии, Польше и Румынии. Девять миллионов было выпущено только в советском союзе. Пакистан до сих пор производит такие ручной сборки.



Серия АКС (Складной 1951) со складным прикладом Wt: 10.6 Bulk -5*.



Серия АКМ (Модернизированный 1960) получила более дешевую и легкую штампованную стволовую коробку: Wt 8.7 Он получил еще большее распространение чем предшественник и встречается чаще всего.



Серия АКМС (Модернизированный Складной 1960): Wt 9.4 Bulk -5.



Серия AK-103 (1993) последния версия под этот патрон - пластиковый складной приклад и пластиковый магазин. Wt:9.1/1.6, Bulk -5*.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>450/30</value>
	<weight>8.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>500/3,100</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>FN FAL</description>
	<description-loc>Бельгия 1953

<img data-src="http://weapons.gurps.ru/img/125.png">

Очень успешная бельгийская винтовка более 90 стран используют ее. Выпускается по лицензии в Аргентине, Австрии, Австралии, Бразилии, Канаде, Индии, Израиле, Мексике, Южной Африке, Британии и Венисуэле. Многие страны выпускают полу-автоматическю версию (Rof 3)

FAL имеет съемный штык (Reach 1,2* 0.5lbs) подходит магазин на 30 патронов ($33, 2.6 lbs) от L4A4.

Британская версия часта комплектовалась x4 прицелом с тритиевой подсветкой (+2 Acc и цбирает -2 из штрафов за темноту)

FAL-Para (1955-1987) мел укороченный ствол и складной приклад Dmg 7d-1 pi, Range 900/3,900, Wt. 9.9/1.6, Bulk -5*</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,200/31</value>
	<weight>11/1.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN FAL (FAL-Para)</description>
	<description-loc>Бельгия 1953

<img data-src="http://weapons.gurps.ru/img/125.png">

Очень успешная бельгийская винтовка более 90 стран используют ее. Выпускается по лицензии в Аргентине, Австрии, Австралии, Бразилии, Канаде, Индии, Израиле, Мексике, Южной Африке, Британии и Венисуэле. Многие страны выпускают полу-автоматическю версию (Rof 3)

FAL имеет съемный штык (Reach 1,2* 0.5lbs) подходит магазин на 30 патронов ($33, 2.6 lbs) от L4A4.

Британская версия часта комплектовалась x4 прицелом с тритиевой подсветкой (+2 Acc и цбирает -2 из штрафов за темноту)

FAL-Para (1955-1987) мел укороченный ствол и складной приклад Dmg 7d-1 pi, Range 900/3,900, Wt. 9.9/1.6, Bulk -5*</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,200/31</value>
	<weight>9.9/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d-1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>900/3,900</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M14</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/126.png">

<img data-src="http://weapons.gurps.ru/img/517.png">

Основан на M1 но под калибр 7.62x51mm NATO,  с магазином на 20 патронов, и способен вести Одиночный огонь. Было выпущено 1.4 миллионов, также выпускался по лицензии в Тайване.  . A 5.9-lb. 4x прицел ночного видения (+2 Acc, Night Vision 4, 2хS/72 hrs.) доступен с 1965. Патрон с двумя убойными элементами (Dmg 6d pi, Range 500/2,100, RoF 12x2, Rcl 2)

RIA M21 (1969-1970)  была на вооружение армии США до 1988. Это качественное (fine) оружие имело высокоточной ствол и оптический прицел 1.4-lb. 3x-9x: Acc 6+3, Wt. 12.7, RoF 3, Cost $4,500, LC3. Можно установить глушитель (-3 to Hearing, -1 Bulk). Прицел ночного видения x4 (+2 Acc, Night Vision 5, 2¥S/30 hrs.) в 1978. Коммерческая продажа прицелов поступили с 1990.

M1A (1971-) Полуавтоматическая версия для  охотников. Wt. 10.6/1.6, RoF 3, Cost $1,500, LC3. было выпущено более 200 30 000 штук.

RTE M14 Designated Marksman Rifle (2002-) Обновленная версия с пластиковым прикладом, сошками, и 3.5-10x переменным прицелом (1.4-lb.): Acc 5+3, Wt. 11/1.6, RoF 3, Cost $2,500, LC3. На вооружение морской пехоты США. 

NSWC Crane MK 14 MOD 0 Enhanced Battle Rifle (2005-) Версия для спецназа запятая с укороченным стволом магазины для навесного и складным прикладом.  Dmg 6d+2 pi, Range 850/3,750, Wt. 14.6/1.6, Bulk -4*, Cost $2,900.



</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>600/31</value>
	<weight>10.9/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M14 (RIA M21)</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/126.png">

<img data-src="http://weapons.gurps.ru/img/517.png">

Основан на M1 но под калибр 7.62x51mm NATO,  с магазином на 20 патронов, и способен вести Одиночный огонь. Было выпущено 1.4 миллионов, также выпускался по лицензии в Тайване.  . A 5.9-lb. 4x прицел ночного видения (+2 Acc, Night Vision 4, 2хS/72 hrs.) доступен с 1965. Патрон с двумя убойными элементами (Dmg 6d pi, Range 500/2,100, RoF 12x2, Rcl 2)

RIA M21 (1969-1970)  была на вооружение армии США до 1988. Это качественное (fine) оружие имело высокоточной ствол и оптический прицел 1.4-lb. 3x-9x: Acc 6+3, Wt. 12.7, RoF 3, Cost $4,500, LC3. Можно установить глушитель (-3 to Hearing, -1 Bulk). Прицел ночного видения x4 (+2 Acc, Night Vision 5, 2¥S/30 hrs.) в 1978. Коммерческая продажа прицелов поступили с 1990.

M1A (1971-) Полуавтоматическая версия для  охотников. Wt. 10.6/1.6, RoF 3, Cost $1,500, LC3. было выпущено более 200 30 000 штук.

RTE M14 Designated Marksman Rifle (2002-) Обновленная версия с пластиковым прикладом, сошками, и 3.5-10x переменным прицелом (1.4-lb.): Acc 5+3, Wt. 11/1.6, RoF 3, Cost $2,500, LC3. На вооружение морской пехоты США. 

NSWC Crane MK 14 MOD 0 Enhanced Battle Rifle (2005-) Версия для спецназа запятая с укороченным стволом магазины для навесного и складным прикладом.  Dmg 6d+2 pi, Range 850/3,750, Wt. 14.6/1.6, Bulk -4*, Cost $2,900.



</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>4,500</value>
	<weight>12.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>6+3</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M14 (M1A)</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/126.png">

<img data-src="http://weapons.gurps.ru/img/517.png">

Основан на M1 но под калибр 7.62x51mm NATO,  с магазином на 20 патронов, и способен вести Одиночный огонь. Было выпущено 1.4 миллионов, также выпускался по лицензии в Тайване.  . A 5.9-lb. 4x прицел ночного видения (+2 Acc, Night Vision 4, 2хS/72 hrs.) доступен с 1965. Патрон с двумя убойными элементами (Dmg 6d pi, Range 500/2,100, RoF 12x2, Rcl 2)

RIA M21 (1969-1970)  была на вооружение армии США до 1988. Это качественное (fine) оружие имело высокоточной ствол и оптический прицел 1.4-lb. 3x-9x: Acc 6+3, Wt. 12.7, RoF 3, Cost $4,500, LC3. Можно установить глушитель (-3 to Hearing, -1 Bulk). Прицел ночного видения x4 (+2 Acc, Night Vision 5, 2¥S/30 hrs.) в 1978. Коммерческая продажа прицелов поступили с 1990.

M1A (1971-) Полуавтоматическая версия для  охотников. Wt. 10.6/1.6, RoF 3, Cost $1,500, LC3. было выпущено более 200 30 000 штук.

RTE M14 Designated Marksman Rifle (2002-) Обновленная версия с пластиковым прикладом, сошками, и 3.5-10x переменным прицелом (1.4-lb.): Acc 5+3, Wt. 11/1.6, RoF 3, Cost $2,500, LC3. На вооружение морской пехоты США. 

NSWC Crane MK 14 MOD 0 Enhanced Battle Rifle (2005-) Версия для спецназа запятая с укороченным стволом магазины для навесного и складным прикладом.  Dmg 6d+2 pi, Range 850/3,750, Wt. 14.6/1.6, Bulk -4*, Cost $2,900.



</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>1,500</value>
	<weight>10.6/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M14 (RTE M14)</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/126.png">

<img data-src="http://weapons.gurps.ru/img/517.png">

Основан на M1 но под калибр 7.62x51mm NATO,  с магазином на 20 патронов, и способен вести Одиночный огонь. Было выпущено 1.4 миллионов, также выпускался по лицензии в Тайване.  . A 5.9-lb. 4x прицел ночного видения (+2 Acc, Night Vision 4, 2хS/72 hrs.) доступен с 1965. Патрон с двумя убойными элементами (Dmg 6d pi, Range 500/2,100, RoF 12x2, Rcl 2)

RIA M21 (1969-1970)  была на вооружение армии США до 1988. Это качественное (fine) оружие имело высокоточной ствол и оптический прицел 1.4-lb. 3x-9x: Acc 6+3, Wt. 12.7, RoF 3, Cost $4,500, LC3. Можно установить глушитель (-3 to Hearing, -1 Bulk). Прицел ночного видения x4 (+2 Acc, Night Vision 5, 2¥S/30 hrs.) в 1978. Коммерческая продажа прицелов поступили с 1990.

M1A (1971-) Полуавтоматическая версия для  охотников. Wt. 10.6/1.6, RoF 3, Cost $1,500, LC3. было выпущено более 200 30 000 штук.

RTE M14 Designated Marksman Rifle (2002-) Обновленная версия с пластиковым прикладом, сошками, и 3.5-10x переменным прицелом (1.4-lb.): Acc 5+3, Wt. 11/1.6, RoF 3, Cost $2,500, LC3. На вооружение морской пехоты США. 

NSWC Crane MK 14 MOD 0 Enhanced Battle Rifle (2005-) Версия для спецназа запятая с укороченным стволом магазины для навесного и складным прикладом.  Dmg 6d+2 pi, Range 850/3,750, Wt. 14.6/1.6, Bulk -4*, Cost $2,900.



</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>2,500</value>
	<weight>11/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5+3</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Springfield M14 (NSWC Crane MK 14 MOD 0)</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/126.png">

<img data-src="http://weapons.gurps.ru/img/517.png">

Основан на M1 но под калибр 7.62x51mm NATO,  с магазином на 20 патронов, и способен вести Одиночный огонь. Было выпущено 1.4 миллионов, также выпускался по лицензии в Тайване.  . A 5.9-lb. 4x прицел ночного видения (+2 Acc, Night Vision 4, 2хS/72 hrs.) доступен с 1965. Патрон с двумя убойными элементами (Dmg 6d pi, Range 500/2,100, RoF 12x2, Rcl 2)

RIA M21 (1969-1970)  была на вооружение армии США до 1988. Это качественное (fine) оружие имело высокоточной ствол и оптический прицел 1.4-lb. 3x-9x: Acc 6+3, Wt. 12.7, RoF 3, Cost $4,500, LC3. Можно установить глушитель (-3 to Hearing, -1 Bulk). Прицел ночного видения x4 (+2 Acc, Night Vision 5, 2¥S/30 hrs.) в 1978. Коммерческая продажа прицелов поступили с 1990.

M1A (1971-) Полуавтоматическая версия для  охотников. Wt. 10.6/1.6, RoF 3, Cost $1,500, LC3. было выпущено более 200 30 000 штук.

RTE M14 Designated Marksman Rifle (2002-) Обновленная версия с пластиковым прикладом, сошками, и 3.5-10x переменным прицелом (1.4-lb.): Acc 5+3, Wt. 11/1.6, RoF 3, Cost $2,500, LC3. На вооружение морской пехоты США. 

NSWC Crane MK 14 MOD 0 Enhanced Battle Rifle (2005-) Версия для спецназа запятая с укороченным стволом магазины для навесного и складным прикладом.  Dmg 6d+2 pi, Range 850/3,750, Wt. 14.6/1.6, Bulk -4*, Cost $2,900.



</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>2,900</value>
	<weight>14.6/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>850/3,750</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ArmaLite AR-7</description>
	<description-loc>США 1959

<img data-src="http://weapons.gurps.ru/img/127.png">

Легкий дешевый но не очень надежный карабин для выживания. Хотя был снят с производства в 1973 году, другие производители немного меняет дизайн продолжили производства. Хорошо продавалась как винтовка для развлечений а также для тех кто нуждается в карабинер в машине или на яхте. 

Ствол затвор и магазин хранятся расстегнутыми внутри пластикового приклада. сборка занимает 20 секунд и требует броска по IQ-based Guns (Rifle) или Armoury (Small Arms). Имеет положительную плавучесть как собранном такой в разобранном состоянии. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>150/25</value>
	<weight>3.1/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+2 pi-</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>80/1,400</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>8+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>.22 LR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 700</description>
	<description-loc>США 1962

<img data-src="http://weapons.gurps.ru/img/128.png">

Возможно это самая популярная американская винтовка с ручным затвором, используется охотниками, военными и полицейскими. стандартные версии были как деревянным так и пластиковым прикладом, обычный мушки прицела. Владельцы часто устанавливают оптический прицел (HT155, B412). Выпускалась в десятках разных калибров, включая .30-06 (Dmg 7d+1 pi) и .300 Remington Ultra Magnum (Dmg 9d+1 pi). Секретная служба США использует 7 мм патрон 7mm Remington Magnum (Dmg 7d+2 pi).

M40 (1962-1966) и M24 (1988-) описаны отдельно как снайперские винтовки.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>450</value>
	<weight>7.8/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5(3i)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Снайперская Винтовка Драгунова СВД</description>
	<description-loc>Россия / СССР 1963

<img data-src="http://weapons.gurps.ru/img/129.png">

<img data-src="http://weapons.gurps.ru/img/481.png">

Полуавтоматическая винтовка с оптическим прицелом, стреляет из съемного магазина. Разработана для снабжения отрядов более точным чем Калашников оружием. Так-же выпускалась в Ките, Ираке и использовалась в Афганистане, Чечне и Никарагуа.

Можно присоежинить штык-нож от АК (0.6-lb.Reach 1, 2*). Стандартно установлен прицел 4x (1.3-lb) светоумножителем на батарейке (+2 Acc и снимает до  -2 штрафов за темноту, XS/100 hrs.) С 1980, идет 5х прицел ночного видения  (+2 Acc, Night Vision 6, 2xXS/10 hrs.)

СВДС (1994) та-же винтовка но с укороченным стволом и складным прикладом, используется десантом.  Dmg 6d+2 pi, Acc 5+2, Range 900/4,000, Wt. 11.4/0.7, Bulk -6*.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900/28</value>
	<weight>10.1/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5+2</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Снайперская Винтовка Драгунова СВД (СВДС)</description>
	<description-loc>Россия / СССР 1963

<img data-src="http://weapons.gurps.ru/img/129.png">

<img data-src="http://weapons.gurps.ru/img/481.png">

Полуавтоматическая винтовка с оптическим прицелом, стреляет из съемного магазина. Разработана для снабжения отрядов более точным чем Калашников оружием. Так-же выпускалась в Ките, Ираке и использовалась в Афганистане, Чечне и Никарагуа.

Можно присоежинить штык-нож от АК (0.6-lb.Reach 1, 2*). Стандартно установлен прицел 4x (1.3-lb) светоумножителем на батарейке (+2 Acc и снимает до  -2 штрафов за темноту, XS/100 hrs.) С 1980, идет 5х прицел ночного видения  (+2 Acc, Night Vision 6, 2xXS/10 hrs.)

СВДС (1994) та-же винтовка но с укороченным стволом и складным прикладом, используется десантом.  Dmg 6d+2 pi, Acc 5+2, Range 900/4,000, Wt. 11.4/0.7, Bulk -6*.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900/28</value>
	<weight>11.4/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>5+2</accuracy>
		<range>900/4,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G3A3</description>
	<description-loc>Германия 1964

<img data-src="http://weapons.gurps.ru/img/130.png">

<img data-src="http://weapons.gurps.ru/img/500.png">

В 1959 Западная Германия приняла на вооружение Gewehr 3, Прочную работающую на отдаче автоматическую винтовку.  Большинство не коммунистических стран которые не приняли на вооружение FN-FAL заинтересовались G3, а некоторые принял ее замену FLA. Производилась в Бирме, Греции, Иране, Мексики, Норвегии, Пакистане, Португалии, Саудовской Аравии, Швеции и Турции, а также на экспорт в Британии и Франции. 

G3 можно присеоединить штык нож (0.5 lbs Reach 1). Доступный магазин и из легкого тонкого алюминия ($36, 1.lbs),  а также барабаны на 50 патронов  (-1 Bulk, $264, 4.3 lbs.). 1.4-lb. 4x прицел (+2 Acc) и сошки могут легко присоединяться (1.3). 





HK91A2 (1976-1989): RoF 3, LC3. полуавтоматическая гражданское версия.





G3A4 (1964-2004) С отсоединяемым прикладом, для парашютных поиск и моторизированный пехоты.Wt. 12.1, Bulk -5*, Cost $1,650.



G3KA4 (1983-2004) укороченный ствол: Dmg 6d pi, Acc 4, Range 800/3,500, Wt. 11.4, Bulk -5*, Cost $1,650.



 

The PSG1 (1982-) Снайперская версия описана отдельно в снайперских винтовках.





HK33 (1965-1972) под патрон .223 Remington: Dmg 4d+2 pi, Range 460/2,900, Wt. 9.5/1.2, RoF 12, Shots 25+1, ST 9†, Rcl 2, Cost $1,200/$28.



The HK33A2 (1972-2004) ттх идентичны, Выпускалась по лицензии в Англии, Малайзии, Тайвани и Турции. Доступен магазин на 40 патронов ($30, 1.4 lbs.). 





HK53A3 (1975-2004) карабин. Dmg 3d+2 pi, Acc 4, Range 320/2,000, Wt. 7.9/1.2, RoF 12, Shots 25+1, ST 9†, Bulk -4*, Rcl 2, Cost $1,450/$28. Стволовая вспышка дает +2 к зрению в темноте и слуху чтобы услышать выстрел.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/31</value>
	<weight>11.4/1.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>850/3,750</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G3A3 (HK33 )</description>
	<description-loc>Германия 1964

<img data-src="http://weapons.gurps.ru/img/130.png">

<img data-src="http://weapons.gurps.ru/img/500.png">

В 1959 Западная Германия приняла на вооружение Gewehr 3, Прочную работающую на отдаче автоматическую винтовку.  Большинство не коммунистических стран которые не приняли на вооружение FN-FAL заинтересовались G3, а некоторые принял ее замену FLA. Производилась в Бирме, Греции, Иране, Мексики, Норвегии, Пакистане, Португалии, Саудовской Аравии, Швеции и Турции, а также на экспорт в Британии и Франции. 

G3 можно присеоединить штык нож (0.5 lbs Reach 1). Доступный магазин и из легкого тонкого алюминия ($36, 1.lbs),  а также барабаны на 50 патронов  (-1 Bulk, $264, 4.3 lbs.). 1.4-lb. 4x прицел (+2 Acc) и сошки могут легко присоединяться (1.3). 





HK91A2 (1976-1989): RoF 3, LC3. полуавтоматическая гражданское версия.





G3A4 (1964-2004) С отсоединяемым прикладом, для парашютных поиск и моторизированный пехоты.Wt. 12.1, Bulk -5*, Cost $1,650.



G3KA4 (1983-2004) укороченный ствол: Dmg 6d pi, Acc 4, Range 800/3,500, Wt. 11.4, Bulk -5*, Cost $1,650.



 

The PSG1 (1982-) Снайперская версия описана отдельно в снайперских винтовках.





HK33 (1965-1972) под патрон .223 Remington: Dmg 4d+2 pi, Range 460/2,900, Wt. 9.5/1.2, RoF 12, Shots 25+1, ST 9†, Rcl 2, Cost $1,200/$28.



The HK33A2 (1972-2004) ттх идентичны, Выпускалась по лицензии в Англии, Малайзии, Тайвани и Турции. Доступен магазин на 40 патронов ($30, 1.4 lbs.). 





HK53A3 (1975-2004) карабин. Dmg 3d+2 pi, Acc 4, Range 320/2,000, Wt. 7.9/1.2, RoF 12, Shots 25+1, ST 9†, Bulk -4*, Rcl 2, Cost $1,450/$28. Стволовая вспышка дает +2 к зрению в темноте и слуху чтобы услышать выстрел.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,200/28</value>
	<weight>9.5/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>460/2,900</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>25+1</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G3A3 (HK53A3 carabin)</description>
	<description-loc>Германия 1964

<img data-src="http://weapons.gurps.ru/img/130.png">

<img data-src="http://weapons.gurps.ru/img/500.png">

В 1959 Западная Германия приняла на вооружение Gewehr 3, Прочную работающую на отдаче автоматическую винтовку.  Большинство не коммунистических стран которые не приняли на вооружение FN-FAL заинтересовались G3, а некоторые принял ее замену FLA. Производилась в Бирме, Греции, Иране, Мексики, Норвегии, Пакистане, Португалии, Саудовской Аравии, Швеции и Турции, а также на экспорт в Британии и Франции. 

G3 можно присеоединить штык нож (0.5 lbs Reach 1). Доступный магазин и из легкого тонкого алюминия ($36, 1.lbs),  а также барабаны на 50 патронов  (-1 Bulk, $264, 4.3 lbs.). 1.4-lb. 4x прицел (+2 Acc) и сошки могут легко присоединяться (1.3). 





HK91A2 (1976-1989): RoF 3, LC3. полуавтоматическая гражданское версия.





G3A4 (1964-2004) С отсоединяемым прикладом, для парашютных поиск и моторизированный пехоты.Wt. 12.1, Bulk -5*, Cost $1,650.



G3KA4 (1983-2004) укороченный ствол: Dmg 6d pi, Acc 4, Range 800/3,500, Wt. 11.4, Bulk -5*, Cost $1,650.



 

The PSG1 (1982-) Снайперская версия описана отдельно в снайперских винтовках.





HK33 (1965-1972) под патрон .223 Remington: Dmg 4d+2 pi, Range 460/2,900, Wt. 9.5/1.2, RoF 12, Shots 25+1, ST 9†, Rcl 2, Cost $1,200/$28.



The HK33A2 (1972-2004) ттх идентичны, Выпускалась по лицензии в Англии, Малайзии, Тайвани и Турции. Доступен магазин на 40 патронов ($30, 1.4 lbs.). 





HK53A3 (1975-2004) карабин. Dmg 3d+2 pi, Acc 4, Range 320/2,000, Wt. 7.9/1.2, RoF 12, Shots 25+1, ST 9†, Bulk -4*, Rcl 2, Cost $1,450/$28. Стволовая вспышка дает +2 к зрению в темноте и слуху чтобы услышать выстрел.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,450/28</value>
	<weight>7.9/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>320/2,000</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>25+1</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>7</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G3A3 (G3KA4 )</description>
	<description-loc>Германия 1964

<img data-src="http://weapons.gurps.ru/img/130.png">

<img data-src="http://weapons.gurps.ru/img/500.png">

В 1959 Западная Германия приняла на вооружение Gewehr 3, Прочную работающую на отдаче автоматическую винтовку.  Большинство не коммунистических стран которые не приняли на вооружение FN-FAL заинтересовались G3, а некоторые принял ее замену FLA. Производилась в Бирме, Греции, Иране, Мексики, Норвегии, Пакистане, Португалии, Саудовской Аравии, Швеции и Турции, а также на экспорт в Британии и Франции. 

G3 можно присеоединить штык нож (0.5 lbs Reach 1). Доступный магазин и из легкого тонкого алюминия ($36, 1.lbs),  а также барабаны на 50 патронов  (-1 Bulk, $264, 4.3 lbs.). 1.4-lb. 4x прицел (+2 Acc) и сошки могут легко присоединяться (1.3). 





HK91A2 (1976-1989): RoF 3, LC3. полуавтоматическая гражданское версия.





G3A4 (1964-2004) С отсоединяемым прикладом, для парашютных поиск и моторизированный пехоты.Wt. 12.1, Bulk -5*, Cost $1,650.



G3KA4 (1983-2004) укороченный ствол: Dmg 6d pi, Acc 4, Range 800/3,500, Wt. 11.4, Bulk -5*, Cost $1,650.



 

The PSG1 (1982-) Снайперская версия описана отдельно в снайперских винтовках.





HK33 (1965-1972) под патрон .223 Remington: Dmg 4d+2 pi, Range 460/2,900, Wt. 9.5/1.2, RoF 12, Shots 25+1, ST 9†, Rcl 2, Cost $1,200/$28.



The HK33A2 (1972-2004) ттх идентичны, Выпускалась по лицензии в Англии, Малайзии, Тайвани и Турции. Доступен магазин на 40 патронов ($30, 1.4 lbs.). 





HK53A3 (1975-2004) карабин. Dmg 3d+2 pi, Acc 4, Range 320/2,000, Wt. 7.9/1.2, RoF 12, Shots 25+1, ST 9†, Bulk -4*, Rcl 2, Cost $1,450/$28. Стволовая вспышка дает +2 к зрению в темноте и слуху чтобы услышать выстрел.

</description-loc>
	<tech_level>7</tech_level>
	<value> 1,650</value>
	<weight>11.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Винтовка снайперская специальная ВСС “Винторез”</description>
	<description-loc>Россия / СССР 1987

<img data-src="http://weapons.gurps.ru/img/502.png">

Основана на конструкции Вал, но с несъемным прикладом и 4х оптическим прицелом. Имеет обойму на 10 патронов, но может использовать в магазин от ВАЛ-а (20 патронов). Использует патрон с улучённой кучностью боя (учтено в Acc). Прицел можно заменить на 4х ночного видения. (2-lb, +2 Acc and Night Vision 6, XS/10 hrs.)</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,000</value>
	<weight>7.8/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>8†</strength>
		<accuracy>5+2</accuracy>
		<range>400/1,700</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>9x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Marlin M444</description>
	<description-loc>США 1965

<img data-src="http://weapons.gurps.ru/img/131.png">

Эта винтовка рычажного действия разработана под уникальных калибр похожие на .44 Magnum, но более мощный. Хорошо подходит для охоты. На коротких дистанциях имеют больше сбивающие факторы чем обычная винтовка. </description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>650</value>
	<weight>7.7/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d-1 pi+</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>450/2,900</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>4+1(2i)</shots>
		<bulk>-5</bulk>
		<recoil>4</recoil>
		<ammo>.444 Marlin</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M16A1</description>
	<description-loc>США 1967

<img data-src="http://weapons.gurps.ru/img/132.png">

<img data-src="http://weapons.gurps.ru/img/495.png">

В 1958 ArmaLite представила AR-15 автомат для военных нужд США. Разработанный Юджином Стонером. Это был первый автомат с малым калибром. Он стал новым стандартом использования новых легких материалов таких как алюминий и пластик. Кольт лицензировал производство в 1959. В 1962 армия США первая получила их на вооружение в пехоте.

 с 1964 армия США и морские пехотинцы получили большое количество AR14  и М16 (1964-1967)  для войны во Вьетнаме. К сожалению в купе с нестандартным калибром и необоснованным заявлением что это оружие вообще не нуждается в уходе... в ходе реальных столкновений эта винтовка требует особого ухода. Иначе Malf=16.  Почистить ее можно только полностью разобрав (Armoury (Small Arms); B407). Результатом была потеря веры в “Барби винтовку” -Так и прозвали за дешевый и игрушечно пластиковый  внешний вид 

M16A1 Исправленная версия теперь ее можно легко почистить разобрать. оно быстро стало стандартом армии США. полиция и гражданские покупатели также оценили по достоинству.  Миллионы таких было сделано.  Выпускалась по лицензия на Филиппинах в Сингапуре Южной Кореи скопирована в Иране и Китае.

Оригинальная винтовка имела магазин на 20 патронов. 1967 спецподразделения получили 30 патронный магазин ($34, 1 lb.),  Который стал стандартной комплектации с 1975. Также можно купить все начиная любой магазин от 5 патронного  ($31, 0.35 lb.) магазина до 100 патронного  ($313, 5 lbs.).  Также в продаже отсоединяемые сошки (0.5lbs). M16A1 можно присоединить штык-нож (0.6-lb., Reach 1).



AR-15 R6000 Sporter (1963-1984) Полуавтоматическая версия популярной в США среди полицейских и гражданских: RoF 3, LC3.



M16A2 (1984-)  Улучшенная наследница принята на вооружение армии США в 1980. Изменения:  Очередь на 3 патроноа, модифицированный патрон 5.56x45m m NATO, новый ствол, и новый прицел: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $850. Была очень востребована в таких конторах как ФБР.  Также оценена полиции и покупателями и за рубежа. можно присоединить штык (1-lb., Reach 1).



M16A3 (1992-),Принята на вооружение военно морским флотом позволяет вести полностью автоматический огонь: Range 800/3,500, Wt. 8.9/1, RoF 13, Cost $850.  Выпускается по лицензии в Канаде и Греции. 



M16A4 (1999-) дальнейшее продолжение линейки: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $950. Полозья для навесного полученный за счет удаление ручки сверху. примером может быть оборудована тепловизором (+2 Acc Infravision, M/12 hrs. 5lbs). Имеет полозья на верху и снизу, а по бокам съемные панели для аксессуаров.  Стала на вооружении с 2001 года. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>550/34</value>
	<weight>7.2/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M16A1 (M16A2)</description>
	<description-loc>США 1967

<img data-src="http://weapons.gurps.ru/img/132.png">

<img data-src="http://weapons.gurps.ru/img/495.png">

В 1958 ArmaLite представила AR-15 автомат для военных нужд США. Разработанный Юджином Стонером. Это был первый автомат с малым калибром. Он стал новым стандартом использования новых легких материалов таких как алюминий и пластик. Кольт лицензировал производство в 1959. В 1962 армия США первая получила их на вооружение в пехоте.

 с 1964 армия США и морские пехотинцы получили большое количество AR14  и М16 (1964-1967)  для войны во Вьетнаме. К сожалению в купе с нестандартным калибром и необоснованным заявлением что это оружие вообще не нуждается в уходе... в ходе реальных столкновений эта винтовка требует особого ухода. Иначе Malf=16.  Почистить ее можно только полностью разобрав (Armoury (Small Arms); B407). Результатом была потеря веры в “Барби винтовку” -Так и прозвали за дешевый и игрушечно пластиковый  внешний вид 

M16A1 Исправленная версия теперь ее можно легко почистить разобрать. оно быстро стало стандартом армии США. полиция и гражданские покупатели также оценили по достоинству.  Миллионы таких было сделано.  Выпускалась по лицензия на Филиппинах в Сингапуре Южной Кореи скопирована в Иране и Китае.

Оригинальная винтовка имела магазин на 20 патронов. 1967 спецподразделения получили 30 патронный магазин ($34, 1 lb.),  Который стал стандартной комплектации с 1975. Также можно купить все начиная любой магазин от 5 патронного  ($31, 0.35 lb.) магазина до 100 патронного  ($313, 5 lbs.).  Также в продаже отсоединяемые сошки (0.5lbs). M16A1 можно присоединить штык-нож (0.6-lb., Reach 1).



AR-15 R6000 Sporter (1963-1984) Полуавтоматическая версия популярной в США среди полицейских и гражданских: RoF 3, LC3.



M16A2 (1984-)  Улучшенная наследница принята на вооружение армии США в 1980. Изменения:  Очередь на 3 патроноа, модифицированный патрон 5.56x45m m NATO, новый ствол, и новый прицел: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $850. Была очень востребована в таких конторах как ФБР.  Также оценена полиции и покупателями и за рубежа. можно присоединить штык (1-lb., Reach 1).



M16A3 (1992-),Принята на вооружение военно морским флотом позволяет вести полностью автоматический огонь: Range 800/3,500, Wt. 8.9/1, RoF 13, Cost $850.  Выпускается по лицензии в Канаде и Греции. 



M16A4 (1999-) дальнейшее продолжение линейки: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $950. Полозья для навесного полученный за счет удаление ручки сверху. примером может быть оборудована тепловизором (+2 Acc Infravision, M/12 hrs. 5lbs). Имеет полозья на верху и снизу, а по бокам съемные панели для аксессуаров.  Стала на вооружении с 2001 года. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>850</value>
	<weight>Wt. 8.9/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M16A1 (M16A3)</description>
	<description-loc>США 1967

<img data-src="http://weapons.gurps.ru/img/132.png">

<img data-src="http://weapons.gurps.ru/img/495.png">

В 1958 ArmaLite представила AR-15 автомат для военных нужд США. Разработанный Юджином Стонером. Это был первый автомат с малым калибром. Он стал новым стандартом использования новых легких материалов таких как алюминий и пластик. Кольт лицензировал производство в 1959. В 1962 армия США первая получила их на вооружение в пехоте.

 с 1964 армия США и морские пехотинцы получили большое количество AR14  и М16 (1964-1967)  для войны во Вьетнаме. К сожалению в купе с нестандартным калибром и необоснованным заявлением что это оружие вообще не нуждается в уходе... в ходе реальных столкновений эта винтовка требует особого ухода. Иначе Malf=16.  Почистить ее можно только полностью разобрав (Armoury (Small Arms); B407). Результатом была потеря веры в “Барби винтовку” -Так и прозвали за дешевый и игрушечно пластиковый  внешний вид 

M16A1 Исправленная версия теперь ее можно легко почистить разобрать. оно быстро стало стандартом армии США. полиция и гражданские покупатели также оценили по достоинству.  Миллионы таких было сделано.  Выпускалась по лицензия на Филиппинах в Сингапуре Южной Кореи скопирована в Иране и Китае.

Оригинальная винтовка имела магазин на 20 патронов. 1967 спецподразделения получили 30 патронный магазин ($34, 1 lb.),  Который стал стандартной комплектации с 1975. Также можно купить все начиная любой магазин от 5 патронного  ($31, 0.35 lb.) магазина до 100 патронного  ($313, 5 lbs.).  Также в продаже отсоединяемые сошки (0.5lbs). M16A1 можно присоединить штык-нож (0.6-lb., Reach 1).



AR-15 R6000 Sporter (1963-1984) Полуавтоматическая версия популярной в США среди полицейских и гражданских: RoF 3, LC3.



M16A2 (1984-)  Улучшенная наследница принята на вооружение армии США в 1980. Изменения:  Очередь на 3 патроноа, модифицированный патрон 5.56x45m m NATO, новый ствол, и новый прицел: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $850. Была очень востребована в таких конторах как ФБР.  Также оценена полиции и покупателями и за рубежа. можно присоединить штык (1-lb., Reach 1).



M16A3 (1992-),Принята на вооружение военно морским флотом позволяет вести полностью автоматический огонь: Range 800/3,500, Wt. 8.9/1, RoF 13, Cost $850.  Выпускается по лицензии в Канаде и Греции. 



M16A4 (1999-) дальнейшее продолжение линейки: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $950. Полозья для навесного полученный за счет удаление ручки сверху. примером может быть оборудована тепловизором (+2 Acc Infravision, M/12 hrs. 5lbs). Имеет полозья на верху и снизу, а по бокам съемные панели для аксессуаров.  Стала на вооружении с 2001 года. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>950</value>
	<weight>8.9/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M16A1 (M16A4)</description>
	<description-loc>США 1967

<img data-src="http://weapons.gurps.ru/img/132.png">

<img data-src="http://weapons.gurps.ru/img/495.png">

В 1958 ArmaLite представила AR-15 автомат для военных нужд США. Разработанный Юджином Стонером. Это был первый автомат с малым калибром. Он стал новым стандартом использования новых легких материалов таких как алюминий и пластик. Кольт лицензировал производство в 1959. В 1962 армия США первая получила их на вооружение в пехоте.

 с 1964 армия США и морские пехотинцы получили большое количество AR14  и М16 (1964-1967)  для войны во Вьетнаме. К сожалению в купе с нестандартным калибром и необоснованным заявлением что это оружие вообще не нуждается в уходе... в ходе реальных столкновений эта винтовка требует особого ухода. Иначе Malf=16.  Почистить ее можно только полностью разобрав (Armoury (Small Arms); B407). Результатом была потеря веры в “Барби винтовку” -Так и прозвали за дешевый и игрушечно пластиковый  внешний вид 

M16A1 Исправленная версия теперь ее можно легко почистить разобрать. оно быстро стало стандартом армии США. полиция и гражданские покупатели также оценили по достоинству.  Миллионы таких было сделано.  Выпускалась по лицензия на Филиппинах в Сингапуре Южной Кореи скопирована в Иране и Китае.

Оригинальная винтовка имела магазин на 20 патронов. 1967 спецподразделения получили 30 патронный магазин ($34, 1 lb.),  Который стал стандартной комплектации с 1975. Также можно купить все начиная любой магазин от 5 патронного  ($31, 0.35 lb.) магазина до 100 патронного  ($313, 5 lbs.).  Также в продаже отсоединяемые сошки (0.5lbs). M16A1 можно присоединить штык-нож (0.6-lb., Reach 1).



AR-15 R6000 Sporter (1963-1984) Полуавтоматическая версия популярной в США среди полицейских и гражданских: RoF 3, LC3.



M16A2 (1984-)  Улучшенная наследница принята на вооружение армии США в 1980. Изменения:  Очередь на 3 патроноа, модифицированный патрон 5.56x45m m NATO, новый ствол, и новый прицел: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $850. Была очень востребована в таких конторах как ФБР.  Также оценена полиции и покупателями и за рубежа. можно присоединить штык (1-lb., Reach 1).



M16A3 (1992-),Принята на вооружение военно морским флотом позволяет вести полностью автоматический огонь: Range 800/3,500, Wt. 8.9/1, RoF 13, Cost $850.  Выпускается по лицензии в Канаде и Греции. 



M16A4 (1999-) дальнейшее продолжение линейки: Range 800/3,500, Wt. 8.9/1, RoF 9, Cost $950. Полозья для навесного полученный за счет удаление ручки сверху. примером может быть оборудована тепловизором (+2 Acc Infravision, M/12 hrs. 5lbs). Имеет полозья на верху и снизу, а по бокам съемные панели для аксессуаров.  Стала на вооружении с 2001 года. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>950</value>
	<weight>8.9/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range> 800/3,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN BAR Magnum</description>
	<description-loc>Бельгия 1967

<img data-src="http://weapons.gurps.ru/img/133.png">

Разработана сыном Джноа Браунинга,  не стоит путать с Browning M1918 BAR- полуавтоматической винтовкой.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>890</value>
	<weight>8.8/0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>5</accuracy>
		<range>1,600/6,600</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>4+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>4</recoil>
		<ammo>.300 WM</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AAI XM19 игольник</description>
	<description-loc>США 1968

<img data-src="http://weapons.gurps.ru/img/134.png">

XM19 Серийная Игольчатая Винтовка (SFR) выполнена в стиле шурмовой винтовки но стреляет оболочными иглами из гладкоствольного ствола. Ранние прототипы использовали 60 зарядный барабанный магазин, но позже появился 50 патронный кривой рожок. Позволяет вести огонь одиночными, трехпульными и полными очередями.

Претендовала заменить собой M14 и M16A1, однако программа была свернута в 1972 из за ненадежности и очень сильного дульного пламени выстрела (+2 к зрению в темноте и слуху при обнаружении)

Всего было сделано 30 орудий</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/255</value>
	<weight>7.4/1.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d+1 pi-</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>750/4,700</range>
		<rate_of_fire>9#/10</rate_of_fire>
		<shots>60+1(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.6x57mmB</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ruger Mini-14</description>
	<description-loc>США 1973

<img data-src="http://weapons.gurps.ru/img/522.png">

<img data-src="http://weapons.gurps.ru/img/135.png">

Полуавтоматическая винтовка на основе Springfield M14.  США продавалось в большом количестве для гражданских лиц, Особенно для любителей “выживания”,  а также для силовых структур и техасских рейнджеров. Существует магазины на 5 ($26, 0.25 lb.), 30 ($29, 1.3 lbs.) или 50 патронов (-1 Bulk, $32, 2.2 lbs.). а также 90 патронный барабан (-1 Bulk, $312, 3.6 lbs.).

AC-556 (1976-1994) Версия с переключением режимов огня -  одиночный, три пули, автоматический RoF 9/12, Cost $790, LC2.  Доступен штык нож (0.6-lb.Reach 1).

 Muzzelite MZ-14 (1985-) это AC-556 с укороченным стволом в пластиковом кожухе, легко переводится система буллпап. Dmg 4d+2 pi, Acc 4, Range 430/2,700, Wt. 7/1, RoF 9/12, Bulk -4, Cost $750, LC2. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>655/28</value>
	<weight>7.5/0.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ruger Mini-14 (Muzzelite MZ-14)</description>
	<description-loc>США 1973

<img data-src="http://weapons.gurps.ru/img/522.png">

<img data-src="http://weapons.gurps.ru/img/135.png">

Полуавтоматическая винтовка на основе Springfield M14.  США продавалось в большом количестве для гражданских лиц, Особенно для любителей “выживания”,  а также для силовых структур и техасских рейнджеров. Существует магазины на 5 ($26, 0.25 lb.), 30 ($29, 1.3 lbs.) или 50 патронов (-1 Bulk, $32, 2.2 lbs.). а также 90 патронный барабан (-1 Bulk, $312, 3.6 lbs.).

AC-556 (1976-1994) Версия с переключением режимов огня -  одиночный, три пули, автоматический RoF 9/12, Cost $790, LC2.  Доступен штык нож (0.6-lb.Reach 1).

 Muzzelite MZ-14 (1985-) это AC-556 с укороченным стволом в пластиковом кожухе, легко переводится система буллпап. Dmg 4d+2 pi, Acc 4, Range 430/2,700, Wt. 7/1, RoF 9/12, Bulk -4, Cost $750, LC2. 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>750</value>
	<weight>7/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>8†</strength>
		<accuracy>4</accuracy>
		<range>430/2,700</range>
		<rate_of_fire>9/12</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Galil ARM</description>
	<description-loc>Израиль 1974

<img data-src="http://weapons.gurps.ru/img/136.png">

В начале 70х годов  Yisrael Galili адаптировала автомат Калашникова для стрельбы западными патронами. Армия Израиля одобрила финальную версию. она экспортировалась а ряд стран и так-же производилась в Колумбии, Хорватии, Сербии и Южной Африке.



Из особенностей - продвинутый прицел, складной приклад, несъемные сошки которые можно использовать для перерезания колючей проволоки (HT25)



Доступен удлиненный магазин ($32, 2.3 lbs.).



К нему подходит штык нож от M16A1 (0.6-lb Reach 1).

Galil ARM так-же выпускался по патрон 7.62x51mm NATO (1976-), но не был так распространен: Dmg 7d pi, Acc 5, Range 1,000/4,200, Wt. 11.5/2, RoF 10, Shots 25+1(3), ST 10B†, Rcl 3, Cost $1,350/$32.



Galil SR (1983-) полу автоматическая снайперская винтовка, описана отдельно.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,100/30</value>
	<weight>11.3/1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d-1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>480/3,000</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>35+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>.223 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Galil ARM (NATO ammo)</description>
	<description-loc>Израиль 1974

<img data-src="http://weapons.gurps.ru/img/136.png">

В начале 70х годов  Yisrael Galili адаптировала автомат Калашникова для стрельбы западными патронами. Армия Израиля одобрила финальную версию. она экспортировалась а ряд стран и так-же производилась в Колумбии, Хорватии, Сербии и Южной Африке.



Из особенностей - продвинутый прицел, складной приклад, несъемные сошки которые можно использовать для перерезания колючей проволоки (HT25)



Доступен удлиненный магазин ($32, 2.3 lbs.).



К нему подходит штык нож от M16A1 (0.6-lb Reach 1).

Galil ARM так-же выпускался по патрон 7.62x51mm NATO (1976-), но не был так распространен: Dmg 7d pi, Acc 5, Range 1,000/4,200, Wt. 11.5/2, RoF 10, Shots 25+1(3), ST 10B†, Rcl 3, Cost $1,350/$32.



Galil SR (1983-) полу автоматическая снайперская винтовка, описана отдельно.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,350/32</value>
	<weight>11.5/2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>25+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Galil SR</description>
	<description-loc>Израиль 1983

<img data-src="http://weapons.gurps.ru/img/492.png">

Полу автоматическая снайперская версия под патрон 7.62х51mm NATO, 2-lb. 6х прицел, облегченный курок, складной приклад, несъемные сошки которые можно использовать для перерезания колючей проволоки (HT25)



Доступен удлиненный магазин ($32, 2.3 lbs.).

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>5,600</value>
	<weight>15.6/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5+2</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-6*</bulk>
		<recoil>3</recoil>
		<ammo>7.62х51mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Калашникова АК-74</description>
	<description-loc>Россия / СССР 1974

<img data-src="http://weapons.gurps.ru/img/137.png">

<img data-src="http://weapons.gurps.ru/img/153.png">

Это версия АКМ под более мелкий патрон. 

Основное отличие от 47 серии - выступающий дульный тормоз и новый покрытый пластиком магазин (сначала оранжевый, потом появились коричневый и черный)

Дульный тормоз был эффективен, но усиливал дульную вспышку (+2 к броску на слух и на зрение в темноте чтобы различить откуда стреляют). Было выпущено 6.5 миллионов.

Так-же выпускался штык-нож 0.6lbs (Reach 1)

Увеличенный магазин (60 патронов, $60, 2.7lbs) выпускался с 1990г.



Серия АКС-74 (Складной 1975) со складным прикладом Wt: 8.8 Bulk -5*.



Серия АКС-74У (Складной  Укороченный 1979) версия для автомобилей и спецназа (так-же Осама бин Ладен обожал эту модель). Складной приклад, сильно укороченный ствол:  Dmg 4d-1 pi, Acc 3,Range 360/2,500, Wt. 6.7, RoF 13, ST 8†, Bulk -4*. 

Может быть укомплектован глушителем (1.4lbs, -1 Bulk) держит 90 выстрелов, и дает -1 на бросок слуха.

Требуется использовать дозвуковые патроны (H165):  Dmg 2d-1 pi, Range 250/1,600, общий модификатор с броску слуха -2.



Серия АКС-74М (Модернизированный 1989) до сих пор на службе в российской армии. Складной пластиковый приклад: Wt. 8.3, Bulk -5*. Можно установить 4x прицел ночного видения (2lbs, +2 Acc, Night VIsion 5, XS/10 час)



Серия AK-101 (1993-) уменьшен до НАТО-вского патрона 5.56x45mm (Dmg 4d+2 pi, Wt. 8.3/1.3, Bulk -5*)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>400/28</value>
	<weight>9.1/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>440/3,000</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.45x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Калашникова АК-74 (АКС-У)</description>
	<description-loc>Россия / СССР 1974

<img data-src="http://weapons.gurps.ru/img/137.png">

<img data-src="http://weapons.gurps.ru/img/153.png">

Это версия АКМ под более мелкий патрон. 

Основное отличие от 47 серии - выступающий дульный тормоз и новый покрытый пластиком магазин (сначала оранжевый, потом появились коричневый и черный)

Дульный тормоз был эффективен, но усиливал дульную вспышку (+2 к броску на слух и на зрение в темноте чтобы различить откуда стреляют). Было выпущено 6.5 миллионов.

Так-же выпускался штык-нож 0.6lbs (Reach 1)

Увеличенный магазин (60 патронов, $60, 2.7lbs) выпускался с 1990г.



Серия АКС-74 (Складной 1975) со складным прикладом Wt: 8.8 Bulk -5*.



Серия АКС-74У (Складной  Укороченный 1979) версия для автомобилей и спецназа (так-же Осама бин Ладен обожал эту модель). Складной приклад, сильно укороченный ствол:  Dmg 4d-1 pi, Acc 3,Range 360/2,500, Wt. 6.7, RoF 13, ST 8†, Bulk -4*. 

Может быть укомплектован глушителем (1.4lbs, -1 Bulk) держит 90 выстрелов, и дает -1 на бросок слуха.

Требуется использовать дозвуковые патроны (H165):  Dmg 2d-1 pi, Range 250/1,600, общий модификатор с броску слуха -2.



Серия АКС-74М (Модернизированный 1989) до сих пор на службе в российской армии. Складной пластиковый приклад: Wt. 8.3, Bulk -5*. Можно установить 4x прицел ночного видения (2lbs, +2 Acc, Night VIsion 5, XS/10 час)



Серия AK-101 (1993-) уменьшен до НАТО-вского патрона 5.56x45mm (Dmg 4d+2 pi, Wt. 8.3/1.3, Bulk -5*)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>400/28</value>
	<weight>6.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>360/2,500</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>5.45x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Калашникова АК-74 (AK-101)</description>
	<description-loc>Россия / СССР 1974

<img data-src="http://weapons.gurps.ru/img/137.png">

<img data-src="http://weapons.gurps.ru/img/153.png">

Это версия АКМ под более мелкий патрон. 

Основное отличие от 47 серии - выступающий дульный тормоз и новый покрытый пластиком магазин (сначала оранжевый, потом появились коричневый и черный)

Дульный тормоз был эффективен, но усиливал дульную вспышку (+2 к броску на слух и на зрение в темноте чтобы различить откуда стреляют). Было выпущено 6.5 миллионов.

Так-же выпускался штык-нож 0.6lbs (Reach 1)

Увеличенный магазин (60 патронов, $60, 2.7lbs) выпускался с 1990г.



Серия АКС-74 (Складной 1975) со складным прикладом Wt: 8.8 Bulk -5*.



Серия АКС-74У (Складной  Укороченный 1979) версия для автомобилей и спецназа (так-же Осама бин Ладен обожал эту модель). Складной приклад, сильно укороченный ствол:  Dmg 4d-1 pi, Acc 3,Range 360/2,500, Wt. 6.7, RoF 13, ST 8†, Bulk -4*. 

Может быть укомплектован глушителем (1.4lbs, -1 Bulk) держит 90 выстрелов, и дает -1 на бросок слуха.

Требуется использовать дозвуковые патроны (H165):  Dmg 2d-1 pi, Range 250/1,600, общий модификатор с броску слуха -2.



Серия АКС-74М (Модернизированный 1989) до сих пор на службе в российской армии. Складной пластиковый приклад: Wt. 8.3, Bulk -5*. Можно установить 4x прицел ночного видения (2lbs, +2 Acc, Night VIsion 5, XS/10 час)



Серия AK-101 (1993-) уменьшен до НАТО-вского патрона 5.56x45mm (Dmg 4d+2 pi, Wt. 8.3/1.3, Bulk -5*)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>400/28</value>
	<weight>8.3/1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>440/3,000</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Подводный автомат АПС</description>
	<description-loc>Россия / СССР 1975

<img data-src="http://weapons.gurps.ru/img/138.png">

Это единственный в мире подводный автомат. Используется Русским Спецназом. В 90х годах это был секретный проект. Он гладкоствольный и стреляет дротиками стабилизирующимися за счет кавитации (HT169). Приемлемые качества на земле и неплохие под водой. Максимальная рабочая глубина (50м), умножайте расстояние до цели на 25 чтобы посчитать дистанцию под водой (HT85). Из-за длинных патронов в магазине сколько громоздкий. Складной приклад. 



Wiki:

Автомат предназначен для вооружения боевых пловцов и подводных средств их передвижения.

Высокая пробивная способность 5,66-мм автоматного патрона МПС достигается за счет оригинальной конструктивной схемы пули и выбора оптимального баллистического решения.

На предельных дальностях стрельбы в воде автомат обеспечивает поражение цели, находящейся в гидрокомбинезоне с поролоновым утеплителем и защищенной оргстеклом толщиной 5 мм.

Автомат обеспечивает прицельную стрельбу со сложенным и выдвинутым прикладом из всех положений пловца. Он может успешно применяться для самообороны и на суше.

Подводный автомат обеспечивает одиночную и автоматическую стрельбу, не имеет аналогов по дальности эффективной стрельбы, эксплуатационным характеристикам и безопасности стрельбы в воде и на воздухе.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>750/33</value>
	<weight>8.2/2.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d imp</damage>
		<strength>9†</strength>
		<accuracy>2</accuracy>
		<range>750/3,200</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>26+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>5.66x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Steyr AUG A1</description>
	<description-loc>Австрия 1978

<img data-src="http://weapons.gurps.ru/img/139.png">

“Универсальная армейская винтовка” разработано для австрийской  армии разработчиками StG77. Будлпап,  на две трети длинее своих конкурентов. Ее отличительная футуристическая форма вклюбюает огромную скобу для курка в которую помещается вся рука Ирочка в которую встроен 1.5х оптический прицел. Магазин на 30 патронов из пластика, или 42 патронный магазин ($36, 1.5 lbs.). Прогрессивный курок (HT82)

Ствол меняется в течении 6 секунд позволяет Как легко трансформировать оружие. 

Корабельная версия 35см стволом  (Dmg 4d+2 pi, Acc 4, Range 750/2,900, Wt. 8.1). 

60 см ствол с сошками  (Dmg 5d+1 pi, Range 850/3,600, Wt. 13.1/1.5, Shots 42+1, ST 9B†, Bulk -5). Считается за пулемет.

Специальный комплект позволяет сменить патрон на 9x19mm Parabellum: Dmg 3d-1 pi, Acc 4, Range 170/1,900, Wt. 8.4/1.1, Shots 25+1.

AUG может быть трансформированы под  правую или левую руку при успешном броске Armoury (Small Arms). Он слишком короткий для штыка (-2 к умению Spear) Однако некоторые экспортные варианты предлагают штык нож (Reach 1)

AUG Экспортируется по всему миру и производится в Австралии и Малайзии.  армии разных стран мира полицейские силы основные покупатели. На большом экране она появлялась в фильме Крепкий орешек. Было произведено около полумиллиона. 

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,250/34</value>
	<weight>9/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield L85A1</description>
	<description-loc>Великобритания 1985

<img data-src="http://weapons.gurps.ru/img/501.png">

<img data-src="http://weapons.gurps.ru/img/140.png">

Не надежный - клинит на 16+



Так-же известна как SA80. Винтовкам системы булл-пап состоит на вооружении армии Британии. Отлично показал себя На полигонных испытаниях в Англии запятая был достаточно точным, однако в реальных условиях оказался далек от идеала.  Реальные отчеты после операции в заливе показали частые поломки, заклинивание, и другие проблемы. Было выпущено около 390,000. 

L85A1 использует магазины от M16. Имет штык-нож (0.65lbs, -2 to Spear skill, Reach) плохого качества. Включает 4х причел с тритиевой подсветкой (1lbs, +2 Acc, и уменьшает на -2 штрафы за освещение) Иногда заменяют на прицел с светоуножением (3.1-lb. +2 Acc, Night Vision 7, 2чXS/100 hrs.)

L86A1 (1985-1994) Легкий автомат поддержки удлиненный  стволом и сошками.  Dmg 5d+1 pi, Range 850/3,600, Wt. 14.5, ST 9B†, Bulk -5, Cost $1,500. Расценивается как пулемет. 

Версии L85A2 и  L86A2 (2001-2003) более надежны (Malf. 17) и остаются на вооружении до  2015.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,300/34</value>
	<weight>11.2/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5+2</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield L85A1 (L86A1)</description>
	<description-loc>Великобритания 1985

<img data-src="http://weapons.gurps.ru/img/501.png">

<img data-src="http://weapons.gurps.ru/img/140.png">

Не надежный - клинит на 16+



Так-же известна как SA80. Винтовкам системы булл-пап состоит на вооружении армии Британии. Отлично показал себя На полигонных испытаниях в Англии запятая был достаточно точным, однако в реальных условиях оказался далек от идеала.  Реальные отчеты после операции в заливе показали частые поломки, заклинивание, и другие проблемы. Было выпущено около 390,000. 

L85A1 использует магазины от M16. Имет штык-нож (0.65lbs, -2 to Spear skill, Reach) плохого качества. Включает 4х причел с тритиевой подсветкой (1lbs, +2 Acc, и уменьшает на -2 штрафы за освещение) Иногда заменяют на прицел с светоуножением (3.1-lb. +2 Acc, Night Vision 7, 2чXS/100 hrs.)

L86A1 (1985-1994) Легкий автомат поддержки удлиненный  стволом и сошками.  Dmg 5d+1 pi, Range 850/3,600, Wt. 14.5, ST 9B†, Bulk -5, Cost $1,500. Расценивается как пулемет. 

Версии L85A2 и  L86A2 (2001-2003) более надежны (Malf. 17) и остаются на вооружении до  2015.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500</value>
	<weight>14.5/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9B†</strength>
		<accuracy>5+2</accuracy>
		<range>850/3,600</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Barrett M82A1</description>
	<description-loc>США 1987

<img data-src="http://weapons.gurps.ru/img/141.png">

<img data-src="http://weapons.gurps.ru/img/154.png">

“Легкий полтинник” - тяжелая, работающая на отдаче затвора винтовка. Ее вес, механизм и отличный дульный компенсатор украшают отдачу огромного патрона .50 до разумных величин. Однако стрелок все-равно должен стрелять лежа с сошек или с зафиксированной турели. Военные закупают ее для снайперов дальних дистанций и уничтожения легко бронированной техники. Так-же будет полезна если вы решите поохотится на динозавров.

Оружие популярно у гражданских и спец подразделений. В 1991 Корпус морской пехоты США принял ее на вооружение. Было выпущено более 10,000 штук.

Не имеет обычного прицела, ее смысл только на дальних дистанциях и мощная оптика необходима. В таблице укзаны параметры для оружия с 10х прицелом используемым в армии США. С 1999 комплектуется 12.2х прицелом ночного зрения (5.5-lb. +3 Acc, Night Vision 7, 2xXS/10 hrs.) Обычно стреляет высокоточными патронами (+1 Acc) или APHEX rounds (Dmg 6dx2(2) pi с последующим 1d-2 [1d-2]).

Оригинальная M82 (1985-1987) использовалась в основном специализированными дальнобойными снайперами: Wt. 39/4.7, Shots 11+1, Cost $5,500. Было выпущено всего 115 штук.

 M107 (2003-) принята на вооружение армией США на замену .50, добавлен класический прицел, полозья для навесного сверху и переменный прицел 4.5-14x (1.4-lb.): Wt. 32.6/4.1, Cost $14,800. Может стрелять с глушителем (4.5-lb. -4 Hearing, -2 Bulk). Доступен 10х тепловизор  (5.5-lb.  +3 Acc, Infravision, M/12 hrs.).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>7,775/38</value>
	<weight>35/4.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx2 pi+</damage>
		<strength>13B†</strength>
		<accuracy>6+3</accuracy>
		<range>1,700/6,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-7</bulk>
		<recoil>3</recoil>
		<ammo>.50 Browning</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Автомат Специальный “Вал”</description>
	<description-loc>Россия / СССР 1987

<img data-src="http://weapons.gurps.ru/img/142.png">

<img data-src="http://weapons.gurps.ru/img/155.png">

Автомат специальный “Вал” основан на конструкции Калашникова. Имеет складной приклад, встроенный глушитель (-2 to Hearing), и стреляет до звуковыми патронами. Используется  российскими спецподразделениями.

Винтовка снайперская специальная “Винторез” описана отдельно в снайперских винтовках</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>750/35</value>
	<weight>7/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d(2) pi-</damage>
		<strength>8†</strength>
		<accuracy>4</accuracy>
		<range>400/1,700</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>9x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AI AW</description>
	<description-loc>Великобритания 1990

<img data-src="http://weapons.gurps.ru/img/143.png">

Высококачетсвеное (точность)



Accuracy International AW современная снайперская винтовка с ручным затвором с пластиковым прикладом, съемным магазином на 10 патронов, складными сошками, короткоходным курком и 6х оптическим прицелом (Acc 6+2). Около 2,000 было выпущено.

В 1990 встала на вооружение в шведской армии. Была оснащена прицелом х10 и новым стволом. Обычно стреляет высокоточными пулями (+1 Acc) а так-же APDS (Dmg 9d(2) pi-, Range 1,500/6,300). Широко экспортировалась по всему миру.

AWM (1990-) под калибр .338 Lapua Magnum: Dmg 9d+1 pi, Acc 6+2, Range 1,300/5,500, Wt. 19.8/0.8, Shots 4+1(3), ST 12B†, Bulk -7, Cost $5,100. В Британской армии называлась L115A1 Long-Range Rifle.

AWM так-же доступна в более мощном калибре .300 Winchester Magnum.

AWM-F (1990-) на вооружении немецкой армии (она же G22) - со складным прикладом и переменным прицелом 3-12х (2lbs): Dmg 8d+2 pi, Acc 6+3, Range 1,600/6,600, Wt. 20.1/0.8, Shots 5+1(3), ST 10B†, Bulk -7*, Rcl 2, Cost $5,800. Комплектовалась съемным глушителем (2-lb.-3 to Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>4,700/50</value>
	<weight>15/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>6+3</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AI AW (AWM)</description>
	<description-loc>Великобритания 1990

<img data-src="http://weapons.gurps.ru/img/143.png">

Высококачетсвеное (точность)



Accuracy International AW современная снайперская винтовка с ручным затвором с пластиковым прикладом, съемным магазином на 10 патронов, складными сошками, короткоходным курком и 6х оптическим прицелом (Acc 6+2). Около 2,000 было выпущено.

В 1990 встала на вооружение в шведской армии. Была оснащена прицелом х10 и новым стволом. Обычно стреляет высокоточными пулями (+1 Acc) а так-же APDS (Dmg 9d(2) pi-, Range 1,500/6,300). Широко экспортировалась по всему миру.

AWM (1990-) под калибр .338 Lapua Magnum: Dmg 9d+1 pi, Acc 6+2, Range 1,300/5,500, Wt. 19.8/0.8, Shots 4+1(3), ST 12B†, Bulk -7, Cost $5,100. В Британской армии называлась L115A1 Long-Range Rifle.

AWM так-же доступна в более мощном калибре .300 Winchester Magnum.

AWM-F (1990-) на вооружении немецкой армии (она же G22) - со складным прикладом и переменным прицелом 3-12х (2lbs): Dmg 8d+2 pi, Acc 6+3, Range 1,600/6,600, Wt. 20.1/0.8, Shots 5+1(3), ST 10B†, Bulk -7*, Rcl 2, Cost $5,800. Комплектовалась съемным глушителем (2-lb.-3 to Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>5,100</value>
	<weight>19.8/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>9d+1 pi</damage>
		<strength>12B†</strength>
		<accuracy>6+2</accuracy>
		<range>1,300/5,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>4+1(3)</shots>
		<bulk>-7</bulk>
		<recoil>3</recoil>
		<ammo>.338 Lapua Magnum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AI AW (AWM-F)</description>
	<description-loc>Великобритания 1990

<img data-src="http://weapons.gurps.ru/img/143.png">

Высококачетсвеное (точность)



Accuracy International AW современная снайперская винтовка с ручным затвором с пластиковым прикладом, съемным магазином на 10 патронов, складными сошками, короткоходным курком и 6х оптическим прицелом (Acc 6+2). Около 2,000 было выпущено.

В 1990 встала на вооружение в шведской армии. Была оснащена прицелом х10 и новым стволом. Обычно стреляет высокоточными пулями (+1 Acc) а так-же APDS (Dmg 9d(2) pi-, Range 1,500/6,300). Широко экспортировалась по всему миру.

AWM (1990-) под калибр .338 Lapua Magnum: Dmg 9d+1 pi, Acc 6+2, Range 1,300/5,500, Wt. 19.8/0.8, Shots 4+1(3), ST 12B†, Bulk -7, Cost $5,100. В Британской армии называлась L115A1 Long-Range Rifle.

AWM так-же доступна в более мощном калибре .300 Winchester Magnum.

AWM-F (1990-) на вооружении немецкой армии (она же G22) - со складным прикладом и переменным прицелом 3-12х (2lbs): Dmg 8d+2 pi, Acc 6+3, Range 1,600/6,600, Wt. 20.1/0.8, Shots 5+1(3), ST 10B†, Bulk -7*, Rcl 2, Cost $5,800. Комплектовалась съемным глушителем (2-lb.-3 to Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>5,800</value>
	<weight>20.1/0.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d+2 pi</damage>
		<strength>10B†</strength>
		<accuracy>6+3</accuracy>
		<range>1,600/6,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>-7*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G11</description>
	<description-loc>Германия 1990

<img data-src="http://weapons.gurps.ru/img/144.png">

<img data-src="http://weapons.gurps.ru/img/156.png">

Очень надежный, не клинит при критах если нормально обсужен





Gewehr 11 Революционное оружие, кульминация более чем 25 лет работы инженеров. Принят на вооружение после успешных полевых испытаний - фактически это первый малокалиберный автомат с безгильзовым патроном принятый на вооружение -  однако он так и не пошел в производство, жертва финансовых затруднений и политических проблемы после воссоединение Германии. Менее чем 100 единицы достигли законченного состояние. Он также  претендовал на то чтобы ставить американским стандартам, безуспешно.

 g11 коробочный буллпап пластиковом корпусе. Он выглядит неуклюжим, но очень эргономичен имеет малую отдачу.  При стрельбе весь механизм включая магазин, казенник и ствол откатываются назад к прикладу. Пистолетная ручка находится в центре масс. магазин на 45 патронов вставляется сверху над стволом. Казенник революционного типа поворачивает каждый патрон на 90 градусов. В полностью автоматическом режиме можно насладиться малой отдачей хотя и не высокой скорострельностью (RoF 7), на стандартный режим стрельбы три пули.

G11 Съемная ручка для переноски, и встроенный 1x оптический прицел. может быть заменён на прицел ночного видения. Можно присоединить штык нож  (1lbs, -2 to Spear skill, Reach 1), лазерный прицел, и сошки.

“Телескопические безгильзовые” патроны состоят из пуль, заключенных в небольшие, прямоугольные блоки взрывчатых веществ, и напоминают оранжевые восковые мелки. Магазин несколько  громоздкий.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>2,100/32</value>
	<weight>9.3/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>500/3,000</range>
		<rate_of_fire>9#/7</rate_of_fire>
		<shots>45+1(5)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>4.73x33mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Voere VEC91</description>
	<description-loc>Австрия 1991

<img data-src="http://weapons.gurps.ru/img/145.png">

Очень надежный, не клинит при критах если нормально обсужен

Требует батареек

Электро зажигание, спортивная винтовка



Первое ручное оружие под безоболочный патрон, дошедшие до коммерческой продажи.    Продавалась гражданским  как охотничье оружие. Не стала успешной поскольку была слишком дорога. выглядит как классическое оружие с деревянным прикладом и съемным магазином. В прикладе батарейки для электро зажигания (2xT/5,000 выстрелов). электро зажигание гарантирует мгновенную стрельбу без движения механических частей, Что улучшает точность стрельбы. Стреляет экспансивными пулями.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>2,500/26</value>
	<weight>6.2/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d(0.5) pi+</damage>
		<strength>8†</strength>
		<accuracy>5</accuracy>
		<range>480/3,400</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.7x26mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>950/34</value>
	<weight>7.3/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>750/2,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1 (CAR-15A1 R653 Carbine)</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<value>650</value>
	<weight>6.8/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>460/2,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1 (XM177E1 Commando)</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<value>650</value>
	<weight>6.8/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>420/2,600</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>20+1</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1 (CAR-15 R6001 Sporter Carbine)</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>650</value>
	<weight>6.8/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>460/2,900</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1 (CAR-15 R635 SMG)</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>950/34</value>
	<weight>7/1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>32+1</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9х19mm Parabellum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt M4A1 (CAR-15A2 R733 Commando)</description>
	<description-loc>США 1994

<img data-src="http://weapons.gurps.ru/img/146.png">

<img data-src="http://weapons.gurps.ru/img/484.png">

Полозья для навесного (HT161)





1962 Colt разрабатывал несколько версий короткоствольного карабина с выдвижным прикладом на базе винтовки M16. Некоторые версии использовались в течение вьетнамской войны на нарушение он был принят только в 1994. армия США приняла на вооружение два варианта с 35 см стволом. Этот автомат стал стандартным коротким оружием армии США и специальных технических подразделений. M4 ограниченный очередями в 3 патронов (RoF 9) был принят для легкой пехоты. Начиная с 1990 года американский спецназ используют повсеместно короткое оружие. Также производится в Канаде и Греции.  

Оба имеют съемную ручку  и полозья для навесного внизу. Доступен штык нож (1-lb.Reach 1). Может комплектоваться коллиматорным прицелом  (0.5-lb. +1 skill, T/1,000 hrs.) или х5 оптическим прицелом с тепловизором (5-lb., +2 Acc and Infravision, M/12 hrs)

XM177E1 Commando (1967-1968) 25 см ствол, широко использовался армии США во Вьетнаме  Dmg 4d pi, Range 420/2,600, Wt. 6.8/0.7, Shots 20+1, Cost $650. Короткий ствол усиливает столовую вспышку (+2 к слуху и зрению в темное время)

CAR-15A1 R653 Carbine (1971-1984) 40 см ствол Range 460/2,900, Wt. 6.8/1, Cost $650. Производится на экспорт а также по лицензии на Филиппинах. 

CAR-15 R6001 Sporter Carbine  (1978- 1985) Популярный гражданский вариант С 40 сантиметрам стволом.  Range 460/2,900, Wt. 6.8/1, RoF 3, Cost $650, LC3.

CAR-15 R635 SMG  (1985-)  под калибр 9х19mm Parabellum : Dmg 3d-1 pi, Range 170/1,900, Wt. 7/1.3, Shots 32+1. 

CAR-15A2 R733 Commando (1988-1996)  25 см ствол: Dmg 4d pi, Range 600/2,500, Wt. 6.4/1.

CAR-15A3 R6920 Government (1994-) Полуавтоматическая версия M4 40 сантиметровый стволом широко используется полиции США.  Wt. 7/1, RoF 3, LC3.

M4A1 SOPMOD (1998-) Wt. 7.6/1, Cost $1,200 Может использовать глушитель (1.4-lb. -3 to Hearing, -1 Bulk).





MK 18 MOD 0 (2000-) 25 см ствол Dmg 4d pi, Range 600/2,500, Wt. 6.8/1, Cost $1,200.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>950/34</value>
	<weight>6.4/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>600/2,500</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G36</description>
	<description-loc>Германия 1996

<img data-src="http://weapons.gurps.ru/img/147.png">

<img data-src="http://weapons.gurps.ru/img/302.png">

Встроенный калиматорный прицел (HT156)



Новейшая винтовка немецкой армии. Складной приклад и изменяемая конфигурация, легкий и прочный за счет синтетических материалов. Прозрачные магазины (которые можно скреплять доком друг с другом (H155)) так-же может присоединять  штык-нож 0.6lbs (Reach 1) от АК-47. Быстро отсоединяемые сошки (0.5lbs) в комплекте. Экспортируется по всему миру и производится по лицензии в Испании.

Уникальной особенностью G36 является двойной оптический прицел - коллиматор без приближения для выстрелов на вскидку (+1 Skill, XS/60 часов), а под ним встроенный 3х прицел (+1 Acc) для дальних дистанций. 

Можно добавить ночное видение (2.6 lbs Night Vision 7, 2xS/90 час) или тепловизор (5.5 lbs Infravision 6xS/12 час) - присоединяются на прицел спереди, действуют только на прицел и загораживают калиматор. Так-же весь прицел можно отсоединить и получить прицел и свободные полозья для навесного (HT161). 

Спец подразделения так-же используют версию "карабин" (1997) с укороченным стволом  Dmg 4d+2 pi, Acc 4+1, Range 650/2,700, Wt. 8.3/1. Ее можно укомплектовать глушителем  (-3 to Hearing, -1 Bulk).

С 2001 года доступна еще более компактная модель в размерах пистолет пулемета



Dmg 4d pi, Acc 4, Range 600/2,500, Wt. 7.2/1, Bulk -4*, Cost $1,200. Оптики на ней нет, вместо нее полозья для навесного.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,100/34</value>
	<weight>9/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5+1</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G36 (Carabin)</description>
	<description-loc>Германия 1996

<img data-src="http://weapons.gurps.ru/img/147.png">

<img data-src="http://weapons.gurps.ru/img/302.png">

Встроенный калиматорный прицел (HT156)



Новейшая винтовка немецкой армии. Складной приклад и изменяемая конфигурация, легкий и прочный за счет синтетических материалов. Прозрачные магазины (которые можно скреплять доком друг с другом (H155)) так-же может присоединять  штык-нож 0.6lbs (Reach 1) от АК-47. Быстро отсоединяемые сошки (0.5lbs) в комплекте. Экспортируется по всему миру и производится по лицензии в Испании.

Уникальной особенностью G36 является двойной оптический прицел - коллиматор без приближения для выстрелов на вскидку (+1 Skill, XS/60 часов), а под ним встроенный 3х прицел (+1 Acc) для дальних дистанций. 

Можно добавить ночное видение (2.6 lbs Night Vision 7, 2xS/90 час) или тепловизор (5.5 lbs Infravision 6xS/12 час) - присоединяются на прицел спереди, действуют только на прицел и загораживают калиматор. Так-же весь прицел можно отсоединить и получить прицел и свободные полозья для навесного (HT161). 

Спец подразделения так-же используют версию "карабин" (1997) с укороченным стволом  Dmg 4d+2 pi, Acc 4+1, Range 650/2,700, Wt. 8.3/1. Ее можно укомплектовать глушителем  (-3 to Hearing, -1 Bulk).

С 2001 года доступна еще более компактная модель в размерах пистолет пулемета



Dmg 4d pi, Acc 4, Range 600/2,500, Wt. 7.2/1, Bulk -4*, Cost $1,200. Оптики на ней нет, вместо нее полозья для навесного.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,100/34</value>
	<weight>8.3/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4+1</accuracy>
		<range>650/2,700</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K G36 (Small carabin)</description>
	<description-loc>Германия 1996

<img data-src="http://weapons.gurps.ru/img/147.png">

<img data-src="http://weapons.gurps.ru/img/302.png">

Встроенный калиматорный прицел (HT156)



Новейшая винтовка немецкой армии. Складной приклад и изменяемая конфигурация, легкий и прочный за счет синтетических материалов. Прозрачные магазины (которые можно скреплять доком друг с другом (H155)) так-же может присоединять  штык-нож 0.6lbs (Reach 1) от АК-47. Быстро отсоединяемые сошки (0.5lbs) в комплекте. Экспортируется по всему миру и производится по лицензии в Испании.

Уникальной особенностью G36 является двойной оптический прицел - коллиматор без приближения для выстрелов на вскидку (+1 Skill, XS/60 часов), а под ним встроенный 3х прицел (+1 Acc) для дальних дистанций. 

Можно добавить ночное видение (2.6 lbs Night Vision 7, 2xS/90 час) или тепловизор (5.5 lbs Infravision 6xS/12 час) - присоединяются на прицел спереди, действуют только на прицел и загораживают калиматор. Так-же весь прицел можно отсоединить и получить прицел и свободные полозья для навесного (HT161). 

Спец подразделения так-же используют версию "карабин" (1997) с укороченным стволом  Dmg 4d+2 pi, Acc 4+1, Range 650/2,700, Wt. 8.3/1. Ее можно укомплектовать глушителем  (-3 to Hearing, -1 Bulk).

С 2001 года доступна еще более компактная модель в размерах пистолет пулемета



Dmg 4d pi, Acc 4, Range 600/2,500, Wt. 7.2/1, Bulk -4*, Cost $1,200. Оптики на ней нет, вместо нее полозья для навесного.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,200</value>
	<weight>7.2/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>600/2,500</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>NORINCO QBZ95</description>
	<description-loc>Китай 1997

<img data-src="http://weapons.gurps.ru/img/148.png">

<img data-src="http://weapons.gurps.ru/img/309.png">

<img data-src="http://weapons.gurps.ru/img/310.png">

Shi Zidong Buqiang ("Автоматическая винтовка") последняя разработка для армии Китая. Булпап, большая ручка для переноски, свой уникальный калибр, режим 3 пули в добавок к одиночном и автоматическому режимам. Штык нож используется от М16А2 (1 lbs, -2 к Spear skill, Reach 1) может комплектоваться 3х прицелом (+1 Acc).

Версия QBZ95B (1997) выпускается в варианте карабина (32 см ствол) Dmg 4d+1 pi, Acc 4, Wt. 7.8/1.4, Bulk -3

Версия QBB95 (1997) сошки, и магазин на 75 патронов (52 см ствол) Dmg 5d+1 pi, Wt. 11.4/2.9, Shots 75+1(5), ST 9B†, Bulk -5. Расценивайте как пулемет.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>475/34</value>
	<weight>8.6/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>800/3,600</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>5.8x42mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Китай</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>NORINCO QBZ95 (QBZ95B)</description>
	<description-loc>Китай 1997

<img data-src="http://weapons.gurps.ru/img/148.png">

<img data-src="http://weapons.gurps.ru/img/309.png">

<img data-src="http://weapons.gurps.ru/img/310.png">

Shi Zidong Buqiang ("Автоматическая винтовка") последняя разработка для армии Китая. Булпап, большая ручка для переноски, свой уникальный калибр, режим 3 пули в добавок к одиночном и автоматическому режимам. Штык нож используется от М16А2 (1 lbs, -2 к Spear skill, Reach 1) может комплектоваться 3х прицелом (+1 Acc).

Версия QBZ95B (1997) выпускается в варианте карабина (32 см ствол) Dmg 4d+1 pi, Acc 4, Wt. 7.8/1.4, Bulk -3

Версия QBB95 (1997) сошки, и магазин на 75 патронов (52 см ствол) Dmg 5d+1 pi, Wt. 11.4/2.9, Shots 75+1(5), ST 9B†, Bulk -5. Расценивайте как пулемет.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>475/34</value>
	<weight>7.8/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+1 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>800/3,600</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>5.8x42mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Китай</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>NORINCO QBZ95 (QBB95)</description>
	<description-loc>Китай 1997

<img data-src="http://weapons.gurps.ru/img/148.png">

<img data-src="http://weapons.gurps.ru/img/309.png">

<img data-src="http://weapons.gurps.ru/img/310.png">

Shi Zidong Buqiang ("Автоматическая винтовка") последняя разработка для армии Китая. Булпап, большая ручка для переноски, свой уникальный калибр, режим 3 пули в добавок к одиночном и автоматическому режимам. Штык нож используется от М16А2 (1 lbs, -2 к Spear skill, Reach 1) может комплектоваться 3х прицелом (+1 Acc).

Версия QBZ95B (1997) выпускается в варианте карабина (32 см ствол) Dmg 4d+1 pi, Acc 4, Wt. 7.8/1.4, Bulk -3

Версия QBB95 (1997) сошки, и магазин на 75 патронов (52 см ствол) Dmg 5d+1 pi, Wt. 11.4/2.9, Shots 75+1(5), ST 9B†, Bulk -5. Расценивайте как пулемет.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>475/34</value>
	<weight>11.4/2.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9B†</strength>
		<accuracy>5</accuracy>
		<range>800/3,600</range>
		<shots>75+1(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.8x42mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Китай</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>8/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>750/2,900</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0 (Carabin)</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>7.7/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>600/2,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0 (Sniper (SV))</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>9.6/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>9†</strength>
		<accuracy>5+2</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0 (SCAR-H)</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>8.8/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0 (MK 17 MOD 0 CQC)</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>8.4/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>700/3,000</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>3</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MK 16 MOD 0 (MK 17 MOD 0 SV)</description>
	<description-loc>Бельгия 2006

<img data-src="http://weapons.gurps.ru/img/149.png">

<img data-src="http://weapons.gurps.ru/img/308.png">

Полозья для навесного (HT161)



Это целое семейство винтовок для спец. подразделений (SCAR)

Базовое орудие SCAR Light (SCAR L) - ствол 33см, настраиваемый складной приклад, калиматорный прицел как опция (0.5 lbs, +1 skill)  полозья для навесного. 

Любая из моделей может быть дополнена глушителем (1lbs, -3 to Hearing, -1 Bulk)



MK 16 MOD 0 Карабин для Закрытых Пространств (CQC) ствол 24см: Dmg 4d pi, Range 600/2,500, Wt. 7.7/1.



MK 16 MOD 0 Снайперский (SV) 45см ствол и съемный 4x прицел заменяющий калиматор (1-lb): Dmg 5d pi, Acc 5+2, Range 800/3,500, Wt. 9.6/1, Bulk -5*.



The MK 17 MOD 0 или SCAR-H под патрон 7.62x51mm NATO: Dmg 6d pi, Range 800/3,500, Wt. 8.8/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



The MK 17 MOD 0 CQC ствол 24см: Dmg 5d+1 pi, Range 700/3,000, Wt. 8.4/1.6, Shots 20+1, ST 10†, Rcl 3.



The MK 17 MOD 0 SV: 48 см ствол съемный 4x прицел заменяющий калиматор (1-lb): Dmg 7d pi, Acc 5+2, Range 1,000/4,200, Wt. 10.2/1.6, Shots 20+1, ST 10†, Bulk -5*, Rcl 3.



</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/34</value>
	<weight>10.2/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>5+2</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>3</recoil>
		<ammo>5.</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Автоматы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Remington Model 8</description>
	<description-loc>США 1906

<img data-src="http://weapons.gurps.ru/img/151.png">

Ранним изобретением Браунинг была удачная самозарядная винтовка. В основном использовалось как охотничье оружие. была популярна в силовых структур США - ФБР, техасские рейнджеры в тридцатых-сороковых годах.  Было выпущено около 136 тысяч.

Разбирается на две части  чем удобно хранении (Holdout -3). Сборка занимает 20 секунд, и требует броска на базе IQ по Guns (Rifle) или Armoury (Small Arms). Альтернативный калибр - .30 Remington (Dmg 5d pi). Можно заряжать магазином на 5 патронов (девять секунд) или по одной пуле (по 3 ready на каждый патрон). “Только для полиции” продавались обоймы на 10, 15 и 20 патронов с 1930г.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>3</legality_class>
	<value>800</value>
	<weight>7.9/0.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>5</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>5(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>.35 Remington</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Bergmann MP18/I</description>
	<description-loc>Германия 1918

<img data-src="http://weapons.gurps.ru/img/157.png">

Не надежный - клинит на 16+



Первый пистолет-пулемет по форме и смыслу. Немецкая армия использовала его во времена первой Мировой и позднейшие пустоплет-пулеметы 20х-30х годов базировались на нем. Оригинальная конструкция была с 32х патронным "уличточным барабаном". от пистолета-карабина Luger LP08 вставляемый с левой стороны. После войны, оружие переделали традиционный магазин на 20  ($28, 1 lb.) или 32  ($29, 1.5 lb.) патрона, что увеличило Malf до 17. Было выпущено около 35,000 и немецкая полиция использовал их до Второй Мировой Войны.

Haenel MP28/II (1928-1938) развитие иди позволяющий стрелять одиночными выстрелами используя 32х патронный магазин.  Wt. 10.3/1.5, Shots 32, RoF 8. Или магазин на 50 патронов  ($32, 2.3 lbs.) Использовался в Бельгии, Боливии, Эквадоре, Парагвае и войсках СС. Много экспортировалось в Китай в калибре  7.63x25mm Mauser (Dmg 3d pi-, Wt. 10.2/1.4, RoF 10), а Испания покупала  9x23mm Bergmann-Bayard (Wt. 10.3/1.5, RoF 8).

А начале Второй Мировой Джордж Ланчестер (Англия) внес небольшие косметический изменения и Королеский Морской Флот принял на вооружение  9x19mm Parabellum под названием Lanchester Mk I (1941-1943): Wt. 11.9/2.3, RoF 10, Shots 50. А Lanchester Mk I Star (1943) использовался до 1960х стрелял только в автоматическом режиме (Rof 10!). Было выпущено 80,000 экземпляров в Англии и еще больше в Индии. Можно было присоединить штык (1.3-lb. Reach 1).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/255</value>
	<weight>11.5/2.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>32(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Auto-Ordnance M1921</description>
	<description-loc>США 1921

<img data-src="http://weapons.gurps.ru/img/158.png">

<img data-src="http://weapons.gurps.ru/img/576.png">

Генерал Джон Томсон (ввел термин пистолет-пулемет) начал разработку этого знаменитого орудия в Первую Мировую Войну, но смог закончить ее только в 1921. "Томми ган" (Tommy Gun) был принят на вооружение Береговой Охраной США, охраной тюрем и полицейскими управлениями большинства крупных городов Америки. Морская пехота имела несколько сотен таких в Китае, Никарагуа и на родине (для защиты поездов). В руках столь знаменитого мафиози как Аль Капоне и Джона Дилинджера оно обрело известность как оружие гангстеров и грабителей банков. ИРА использовала их в войне против Британии. В небольшом количестве экспортировался полицейским в Канаду и Шанхай. Было выпущено всего 15,000 но очень сильно копировался в Китае с 1920х.

Оригинальный M1921 был очень точен. Мог использовать барабанный (50 патронов, в таблице) и классический магазины (20 патронов, $30, 1.3 lbs.), и даже 100 патронный барабан (Malf. 16, -1 Bulk, $274, 8.5 lbs.) однако он бул менее распространен. Магазин на 18 патронов  ($30, 1.2 lbs.) использовался для с мелкой дробью для контроля за бунтами Dmg 1d-3(0.5) pi-, Range 12/230, RoF 13¥120, Shots 18+1(3), Rcl 1.

Без съемного приклада (1.75-lb) Томми можно было спрятать в футляр от скрипки или под плащом Acc 3, ST 12†, Bulk -4, Rcl 3.

M1928 (1928-1938) разработана для Морского Флота США. Имела уменьшенную скорострельность RoF 11. ФБР приняла их на вооружение в 1935.

Упрощенный M1928A1 (1938-1942) бал принят на вооружение у многих родов войск в Британии и США: : Acc 3, Wt. 12/1.3, RoF 11, Shots 20+1(3). Некоторые поставлялись в Францию, Швецию  и Югославию перед Второй Мировой Войной. было выпущено почти 600,000 единиц больше частью для Британии. 

Первый Тимм для армии США M1 (1942-1943) был упрощен для производства в военное время поставлялся с 30 патронным магазином Acc 3, Wt. 12.2/1.6, RoF 11, Shots 30+1(3), Cost $750/$32. у него небыло передней ручки, он не мог использовать барабн а приклад не отсоединялся. Было выпущено и распродано по всему миру около 824,000 единиц.

Выпуск возобновился в 1975, но новые Тимми были полу автоматические с удлиненным стволом, чтобы соответсвовать законам США M1927A-1 (1975-) has Dmg 2d+2 pi+, Range 160/1,800, Wt. 12.6/1.6, RoF 3, Shots 30+1(3), Cost $1,150/$32, LC3.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>2</legality_class>
	<value>2,300/262</value>
	<weight>15.7/4.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>160/1,700</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>50+1(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Tikkakoski KP/31</description>
	<description-loc>Финляндия 1931

<img data-src="http://weapons.gurps.ru/img/159.png">

Это точный, хорошо собранный, надежный пистолет-пулемет назвался Suomi (Финляндия). Финская армия пряла их на вооружение в 1931. ВО Время Второй Мировой экспортировался в Бельгию и Хорватию. Немецкие отряды СС и личная охрана Гитлера так-же использовала их. Было выпущено около 62,000 выпускался по лицензии в Дании, Швеции и Швейцарии.

Обынчо поставлялся с 20 патронным магазином ($28, 1.3 lbs.) или с 40 патронным барабаном ($255, 3.1 lbs.). С 1936, выпускался знаменитый 70 патронный барабан (в таблице). Шведский 50 патронный магазин высокой плотности ($34, 2.6 lbs.) появился в 1941.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>2</legality_class>
	<value>1,600/260</value>
	<weight>15.6/4.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>10†</strength>
		<accuracy>4</accuracy>
		<range>180/2,000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>70(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Финляндия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ERMA MP40</description>
	<description-loc>Германия 1940

<img data-src="http://weapons.gurps.ru/img/160.png">

D 1938 немецкие военные приняли на вооружение Maschinenpistole Modell 1938 (1939-1941), или MP38, в которой были новшества - складной металлический приклад, и занчительнео использование пластика. Сходна разрабатывалась для парашютистов и экипажей танков. В начале Второй Мировой было выпущено 9,000. Очень быстро прижилась и стала востребована в каждой пехотной части.

Более продвинутое MP40 возможно самое узнаваемое Немецкое оружие времен Второй Мировой. Штампованные стальные компоненты, и защита от случайного выстрела - в отличии от MP38, которая могла начать стрелять при сильном ударе или падении на землю (киньте 3d - на 17,18 начинает стрелять и не прекратит пока не опустеет магазин!). Был выпущен миллион штук. После войны копировалась в Испании и Югославии.

В англо американском фольклоре прижилось название "Шмайсер" хотя Хюго Шмайсер ничего не сделал для этого, он вообще работал на другую компанию. Оружие всплывало на полях сражения уже и после войны. Вьетконговцы и Армия США использовали их во Вьетнаме. Так-же получила распространение у кримминиалитета. Не раз появлялась в фильмах про Джеймса Бонда.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>400/29</value>
	<weight>10.5/1.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пистолет-пулемёт Шпагина ППШ-41</description>
	<description-loc>Россия / СССР 1941

<img data-src="http://weapons.gurps.ru/img/161.png">

Не надежный - клинит на 16+

Перфорировнный ствол и барабанный магазин были его отличительной чертой. Советский Союз выпусил 5.4 миллиона и распространял их среди своих союзников. Еще больше было выпущено в Китае, Венгрии, Иране, Северной Корее, Польше, Румынии и Югославии.

Во Второй Мировой Войне пехотные батальоны Красной Армии снабжались именно им. Такие пехотинцы приписывались а танковым войскам. Они перемещались снаружи на броне танка. Должно быть это было односложно, особенно в условиях русской зимы.

В 1943 барабан заменил 35 патронный изогнутый магазин. Он был легче и дешевле, удобнее наполнять и мене склонен заклинивать  (Malf 17., $29, 1.5 lbs.). Часто использовался с API (бронебойными) патронами (Dmg 2d(2) pi- inc). Не смотря на дешевизну ППШ считался очень прочным (HT 12)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>200/260</value>
	<weight>11.7/4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi-</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>200/2,200</range>
		<rate_of_fire>16</rate_of_fire>
		<shots>71(5)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>7.62x25mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield Sten Mk II</description>
	<description-loc>Великобритания 1942

<img data-src="http://weapons.gurps.ru/img/162.png">

<img data-src="http://weapons.gurps.ru/img/554.png">

Не надежный - клинит на 16+



В 1941 Британии очень нехватало оружия. Два инженера Энфильд Шепхерт и Энфильд Турпин разработали пистолет-пулемет, который можно выпускать быстро и дешево. Его назвали STEN по их инициалам. Самой многочисленой вырсией был Mk II представленная в 1942. Таких было выпущено более 2 миллионов - т.е. около половины всех sten.

У него было множество проблем с нажедностью. Большая часть заключалась в магазине (вставляемом с левой стороны), он был плохо продуман и плохо собран. Даже производитель рекомендовал заряжать не более 28 патронов для больше надежности. Опытный солдат обычно просматривал все доступные магазины чтобы найти несколько более менее рабочих на вид. Мастер может увеличить Malf для ветеранов, если они сделали такую проверку (при успешном броске умения Soldier)

Превый Sten Mk I (1941-1942) имел складную деревянную переднюю ручку: Wt. 8.6. Около 100,000 было выпущено.

Sten Mk IIS (1943-1945) имел встроенный глушитель (-2 к слуху): Dmg 2d pi, Range 120/1,400, Wt. 9.1, Bulk -5, Cost $425. глушитель изнашивается за отстрел одного магазина, если стрелять в полностью автоматическом режиме. Аккуратные прицельные одиночные выстрелы продлевают жизнь глушителю на до сотни патронов. IIS был самым массовым оружием с глушителем Второй Мировой. Было выпущено 5,776 единиц. Британский коммандос и Американский OSS использовали их а Немцы использовали трофейные. 

Британские, Канадские и Новозиландские производители наштамповали много "стенов", так-же выпускались в Дании, Франции, Нидерландах, Польше и Вьетнаме. Выпускались в евреями Палестине... и даже в Германии, во время последних месяцев обороны (под магазин от MP40). Простая конструкция позволяла делать на минимальной технологической базе.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>135/29</value>
	<weight>7.9/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield Sten Mk II (Mk IIS (sound supressor))</description>
	<description-loc>Великобритания 1942

<img data-src="http://weapons.gurps.ru/img/162.png">

<img data-src="http://weapons.gurps.ru/img/554.png">

Не надежный - клинит на 16+



В 1941 Британии очень нехватало оружия. Два инженера Энфильд Шепхерт и Энфильд Турпин разработали пистолет-пулемет, который можно выпускать быстро и дешево. Его назвали STEN по их инициалам. Самой многочисленой вырсией был Mk II представленная в 1942. Таких было выпущено более 2 миллионов - т.е. около половины всех sten.

У него было множество проблем с нажедностью. Большая часть заключалась в магазине (вставляемом с левой стороны), он был плохо продуман и плохо собран. Даже производитель рекомендовал заряжать не более 28 патронов для больше надежности. Опытный солдат обычно просматривал все доступные магазины чтобы найти несколько более менее рабочих на вид. Мастер может увеличить Malf для ветеранов, если они сделали такую проверку (при успешном броске умения Soldier)

Превый Sten Mk I (1941-1942) имел складную деревянную переднюю ручку: Wt. 8.6. Около 100,000 было выпущено.

Sten Mk IIS (1943-1945) имел встроенный глушитель (-2 к слуху): Dmg 2d pi, Range 120/1,400, Wt. 9.1, Bulk -5, Cost $425. глушитель изнашивается за отстрел одного магазина, если стрелять в полностью автоматическом режиме. Аккуратные прицельные одиночные выстрелы продлевают жизнь глушителю на до сотни патронов. IIS был самым массовым оружием с глушителем Второй Мировой. Было выпущено 5,776 единиц. Британский коммандос и Американский OSS использовали их а Немцы использовали трофейные. 

Британские, Канадские и Новозиландские производители наштамповали много "стенов", так-же выпускались в Дании, Франции, Нидерландах, Польше и Вьетнаме. Выпускались в евреями Палестине... и даже в Германии, во время последних месяцев обороны (под магазин от MP40). Простая конструкция позволяла делать на минимальной технологической базе.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>425</value>
	<weight>9.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>120/1,400</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Guide Lamp M3</description>
	<description-loc>США 1943

<img data-src="http://weapons.gurps.ru/img/163.png">

Дешевое и простое оружие наследник "Томсона", прозвано "тавотница" из за сходства со шприцом для смазывания механизмов. Был сделан из штамповальных деталей и имел складной приклад. Широко экспортировался во времена Второй Мировой Войны а позже использовался в Корее и Вьетнаме. И хотя в 1960м был уже устаревшим - использовался армии США в экипажах танков до 1990х, пока не был полностью заменен Colt M4. Было выпущено более 606,000 штук.

Около 1,000 были оснащены глушителем (-2 к броскам слуха) для агентов OSS: Dmg 2d pi+, Range 110/1,200, Wt. 11.6, Cost $600. Использовались на дальнем востоке.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>350/37</value>
	<weight>10.2/2.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>160/1,700</range>
		<rate_of_fire>7!</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Sterling L2A3</description>
	<description-loc>Великобритания 1956

<img data-src="http://weapons.gurps.ru/img/164.png">

<img data-src="http://weapons.gurps.ru/img/555.png">

<img data-src="http://weapons.gurps.ru/img/556.png">

Был на вооружении Британской Армии до появления Enfield L85A1. Было выпущено более 400,000 штук, экспортировалось под маркой Mark 4.  Так-же выпускался по лицензии в Канаде и Индии. Имел складной приклад, гнутый магазин вставляемый с левой стороны. Меньший магазин на 15 патронов так-же доступен ($27, 0.8 lb.) Многие узнают в нем основу для бластема штурмовиков из фильма Звездные Воины!

L34A1 (1966-1988) был оборудован встроенным глушителем (-3 к слуху): Dmg 2d pi, Range 120/1,400, Wt.9.5, Bulk -5*, Cost $920. Экспортировался как Mark 5. Был востребован. Австралийские и Американские спец подразделения использовали их во Вьетнаме. 

Mark 7A4 (1972-1988) "пистолет парашютистов" был укорочен и без приклада: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 6.4/1.6, RoF 10, ST 7, Bulk -3. А если ставить 15 патронный магазин: Wt. 5.6/0.8, Shots 15(3), Bulk -2. Модель Mark 7C4 была точно такой-же но, ограничена полуавтоматической стрельбой (RoF 3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>550/29</value>
	<weight>7.6/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>34(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Sterling L2A3 (Sterling L2A3)</description>
	<description-loc>Великобритания 1956

<img data-src="http://weapons.gurps.ru/img/164.png">

<img data-src="http://weapons.gurps.ru/img/555.png">

<img data-src="http://weapons.gurps.ru/img/556.png">

Был на вооружении Британской Армии до появления Enfield L85A1. Было выпущено более 400,000 штук, экспортировалось под маркой Mark 4.  Так-же выпускался по лицензии в Канаде и Индии. Имел складной приклад, гнутый магазин вставляемый с левой стороны. Меньший магазин на 15 патронов так-же доступен ($27, 0.8 lb.) Многие узнают в нем основу для бластема штурмовиков из фильма Звездные Воины!

L34A1 (1966-1988) был оборудован встроенным глушителем (-3 к слуху): Dmg 2d pi, Range 120/1,400, Wt.9.5, Bulk -5*, Cost $920. Экспортировался как Mark 5. Был востребован. Австралийские и Американские спец подразделения использовали их во Вьетнаме. 

Mark 7A4 (1972-1988) "пистолет парашютистов" был укорочен и без приклада: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 6.4/1.6, RoF 10, ST 7, Bulk -3. А если ставить 15 патронный магазин: Wt. 5.6/0.8, Shots 15(3), Bulk -2. Модель Mark 7C4 была точно такой-же но, ограничена полуавтоматической стрельбой (RoF 3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>920</value>
	<weight>9.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>120/1,400</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>34(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Sterling L2A3 (Mark 7A4)</description>
	<description-loc>Великобритания 1956

<img data-src="http://weapons.gurps.ru/img/164.png">

<img data-src="http://weapons.gurps.ru/img/555.png">

<img data-src="http://weapons.gurps.ru/img/556.png">

Был на вооружении Британской Армии до появления Enfield L85A1. Было выпущено более 400,000 штук, экспортировалось под маркой Mark 4.  Так-же выпускался по лицензии в Канаде и Индии. Имел складной приклад, гнутый магазин вставляемый с левой стороны. Меньший магазин на 15 патронов так-же доступен ($27, 0.8 lb.) Многие узнают в нем основу для бластема штурмовиков из фильма Звездные Воины!

L34A1 (1966-1988) был оборудован встроенным глушителем (-3 к слуху): Dmg 2d pi, Range 120/1,400, Wt.9.5, Bulk -5*, Cost $920. Экспортировался как Mark 5. Был востребован. Австралийские и Американские спец подразделения использовали их во Вьетнаме. 

Mark 7A4 (1972-1988) "пистолет парашютистов" был укорочен и без приклада: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 6.4/1.6, RoF 10, ST 7, Bulk -3. А если ставить 15 патронный магазин: Wt. 5.6/0.8, Shots 15(3), Bulk -2. Модель Mark 7C4 была точно такой-же но, ограничена полуавтоматической стрельбой (RoF 3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>550/29</value>
	<weight>6.4/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>7</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>34(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>CZ Sa vz. 61 Skorpion</description>
	<description-loc>Чехословакия 1962

<img data-src="http://weapons.gurps.ru/img/165.png">

<img data-src="http://weapons.gurps.ru/img/177.png">

Компактный пистолет-пулемет разработан для ношения в поясной кобуре, для экипажей танков, парашютистов, и секретных служб если им необходимо что-то более мощное чем обычный пистолет. Выпустили 210,000 единиц. Широко распространен, он появлялся в руках революционеров и террористов. Производился по лицензии в Югославии.

Имеет складной приклад. Существует и магазин на 10 патронов ($26, 0.4 lb.). Можно стрелять одной руки без приклада: ST 8, Rcl 3. Можно установить глушитель (-1 to Hearing, -1 Bulk, на 40 выстрелов), уменьшает Dmg до 1d+2 pi-.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>350/27</value>
	<weight>3.7/0.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi-</damage>
		<strength>7†</strength>
		<accuracy>2</accuracy>
		<range>90/1,000</range>
		<rate_of_fire>14</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>.32 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Чехословакия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Uzi</description>
	<description-loc>Израиль 1967

<img data-src="http://weapons.gurps.ru/img/166.png">

<img data-src="http://weapons.gurps.ru/img/558.png">

<img data-src="http://weapons.gurps.ru/img/559.png">

<img data-src="http://weapons.gurps.ru/img/560.png">

Назван в честь изобретателя Узиела Гала - который стал основателем Израильской индустрии ручного оружия. У первой версии 1955 был несъемный деревянный приклад. IMI выпустило более двух миллионов УЗИ. Так-же производились по лицензии в Бельгии и Южной Африке, а так-же копировались в Бирме, Китае и Хорватии. Армии и полиции всего мира приняли их на вооружение. Секретная слуюба США использует и с 1967 до 1990х.

Даже с деревянным прикладом он был всего 60см: Wt. 9, Bulk -4. C 1967 складной приклад стал стандартом, а со сложенным прикладом оружие стало длиной всего 45 см. Можно стрелять с одной руки:  ST 11, Rcl 3.

Родной магазин на 25 патронов, но существуют 32 ($29, 1.3 lbs.) патронные и 20 ($28, 0.9 lb.) патронные версии. на резьбу стволам можно накрутить глушитель r (-2 to Hearing, -1 Bulk, 1 lbs). Так-же можно установить небольшой штык-нож (0.5 lbs -2 к умению Spear, Reach 1).

Доступен в калибре 45 ACP (1987-1998): Dmg 2d+1 pi+, Range 150/1,700, Wt. 8.9/1.2, RoF 8, Shots 16. А 20-патронный магазин весит 1.4 lbs

Uzi Carbine (1980-2004) полуавтоматическая версия со стволом 40см для гражданской продажи: Dmg 3d pi, Acc 4, Range 200/2,200, Wt. 9.5/1.1, RoF 3, Shots 25+1(3), Bulk -5*, Cost $1,000, LC3.

Mini-Uzi (1980-) для экипажей транспорта и спецназа длиной всего 35см Dmg 2d+2 pi, Wt. 7/1.1, RoF 15, Cost $900.

Micro-Uzi (1982-) еще меньше 25 см со сложеным прикладом: Dmg 2d+2 pi, Range 160/1,800, Wt. 5.2/0.9, RoF 28, Shots 20(3), ST 7†, Bulk -3*, Cost $900. При одноручной стрельбе без приклада Acc 2, ST 8, Rcl 3.

Uzi Pistol (1983-1994) без приклада, и только полу автоматический режим (в прочем тот-же Микро-Узи)i: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 4.7/0.9, RoF 3, Shots 20+1(3), ST 10, Bulk -2, Cost $900, LC3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>600/28</value>
	<weight>8.8/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>25(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Uzi</description>
	<description-loc>Израиль 1967

<img data-src="http://weapons.gurps.ru/img/166.png">

<img data-src="http://weapons.gurps.ru/img/558.png">

<img data-src="http://weapons.gurps.ru/img/559.png">

<img data-src="http://weapons.gurps.ru/img/560.png">

Назван в честь изобретателя Узиела Гала - который стал основателем Израильской индустрии ручного оружия. У первой версии 1955 был несъемный деревянный приклад. IMI выпустило более двух миллионов УЗИ. Так-же производились по лицензии в Бельгии и Южной Африке, а так-же копировались в Бирме, Китае и Хорватии. Армии и полиции всего мира приняли их на вооружение. Секретная слуюба США использует и с 1967 до 1990х.

Даже с деревянным прикладом он был всего 60см: Wt. 9, Bulk -4. C 1967 складной приклад стал стандартом, а со сложенным прикладом оружие стало длиной всего 45 см. Можно стрелять с одной руки:  ST 11, Rcl 3.

Родной магазин на 25 патронов, но существуют 32 ($29, 1.3 lbs.) патронные и 20 ($28, 0.9 lb.) патронные версии. на резьбу стволам можно накрутить глушитель r (-2 to Hearing, -1 Bulk, 1 lbs). Так-же можно установить небольшой штык-нож (0.5 lbs -2 к умению Spear, Reach 1).

Доступен в калибре 45 ACP (1987-1998): Dmg 2d+1 pi+, Range 150/1,700, Wt. 8.9/1.2, RoF 8, Shots 16. А 20-патронный магазин весит 1.4 lbs

Uzi Carbine (1980-2004) полуавтоматическая версия со стволом 40см для гражданской продажи: Dmg 3d pi, Acc 4, Range 200/2,200, Wt. 9.5/1.1, RoF 3, Shots 25+1(3), Bulk -5*, Cost $1,000, LC3.

Mini-Uzi (1980-) для экипажей транспорта и спецназа длиной всего 35см Dmg 2d+2 pi, Wt. 7/1.1, RoF 15, Cost $900.

Micro-Uzi (1982-) еще меньше 25 см со сложеным прикладом: Dmg 2d+2 pi, Range 160/1,800, Wt. 5.2/0.9, RoF 28, Shots 20(3), ST 7†, Bulk -3*, Cost $900. При одноручной стрельбе без приклада Acc 2, ST 8, Rcl 3.

Uzi Pistol (1983-1994) без приклада, и только полу автоматический режим (в прочем тот-же Микро-Узи)i: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 4.7/0.9, RoF 3, Shots 20+1(3), ST 10, Bulk -2, Cost $900, LC3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>600/28</value>
	<weight>8.9/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>150/1,700</range>
		<rate_of_fire>8</rate_of_fire>
		<shots>16</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Uzi (Uzi Carbine)</description>
	<description-loc>Израиль 1967

<img data-src="http://weapons.gurps.ru/img/166.png">

<img data-src="http://weapons.gurps.ru/img/558.png">

<img data-src="http://weapons.gurps.ru/img/559.png">

<img data-src="http://weapons.gurps.ru/img/560.png">

Назван в честь изобретателя Узиела Гала - который стал основателем Израильской индустрии ручного оружия. У первой версии 1955 был несъемный деревянный приклад. IMI выпустило более двух миллионов УЗИ. Так-же производились по лицензии в Бельгии и Южной Африке, а так-же копировались в Бирме, Китае и Хорватии. Армии и полиции всего мира приняли их на вооружение. Секретная слуюба США использует и с 1967 до 1990х.

Даже с деревянным прикладом он был всего 60см: Wt. 9, Bulk -4. C 1967 складной приклад стал стандартом, а со сложенным прикладом оружие стало длиной всего 45 см. Можно стрелять с одной руки:  ST 11, Rcl 3.

Родной магазин на 25 патронов, но существуют 32 ($29, 1.3 lbs.) патронные и 20 ($28, 0.9 lb.) патронные версии. на резьбу стволам можно накрутить глушитель r (-2 to Hearing, -1 Bulk, 1 lbs). Так-же можно установить небольшой штык-нож (0.5 lbs -2 к умению Spear, Reach 1).

Доступен в калибре 45 ACP (1987-1998): Dmg 2d+1 pi+, Range 150/1,700, Wt. 8.9/1.2, RoF 8, Shots 16. А 20-патронный магазин весит 1.4 lbs

Uzi Carbine (1980-2004) полуавтоматическая версия со стволом 40см для гражданской продажи: Dmg 3d pi, Acc 4, Range 200/2,200, Wt. 9.5/1.1, RoF 3, Shots 25+1(3), Bulk -5*, Cost $1,000, LC3.

Mini-Uzi (1980-) для экипажей транспорта и спецназа длиной всего 35см Dmg 2d+2 pi, Wt. 7/1.1, RoF 15, Cost $900.

Micro-Uzi (1982-) еще меньше 25 см со сложеным прикладом: Dmg 2d+2 pi, Range 160/1,800, Wt. 5.2/0.9, RoF 28, Shots 20(3), ST 7†, Bulk -3*, Cost $900. При одноручной стрельбе без приклада Acc 2, ST 8, Rcl 3.

Uzi Pistol (1983-1994) без приклада, и только полу автоматический режим (в прочем тот-же Микро-Узи)i: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 4.7/0.9, RoF 3, Shots 20+1(3), ST 10, Bulk -2, Cost $900, LC3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>1,000</value>
	<weight>9.5/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi</damage>
		<strength>9†</strength>
		<accuracy>4</accuracy>
		<range>200/2,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>25+1(3)</shots>
		<bulk>-5*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Uzi (Mini-Uzi)</description>
	<description-loc>Израиль 1967

<img data-src="http://weapons.gurps.ru/img/166.png">

<img data-src="http://weapons.gurps.ru/img/558.png">

<img data-src="http://weapons.gurps.ru/img/559.png">

<img data-src="http://weapons.gurps.ru/img/560.png">

Назван в честь изобретателя Узиела Гала - который стал основателем Израильской индустрии ручного оружия. У первой версии 1955 был несъемный деревянный приклад. IMI выпустило более двух миллионов УЗИ. Так-же производились по лицензии в Бельгии и Южной Африке, а так-же копировались в Бирме, Китае и Хорватии. Армии и полиции всего мира приняли их на вооружение. Секретная слуюба США использует и с 1967 до 1990х.

Даже с деревянным прикладом он был всего 60см: Wt. 9, Bulk -4. C 1967 складной приклад стал стандартом, а со сложенным прикладом оружие стало длиной всего 45 см. Можно стрелять с одной руки:  ST 11, Rcl 3.

Родной магазин на 25 патронов, но существуют 32 ($29, 1.3 lbs.) патронные и 20 ($28, 0.9 lb.) патронные версии. на резьбу стволам можно накрутить глушитель r (-2 to Hearing, -1 Bulk, 1 lbs). Так-же можно установить небольшой штык-нож (0.5 lbs -2 к умению Spear, Reach 1).

Доступен в калибре 45 ACP (1987-1998): Dmg 2d+1 pi+, Range 150/1,700, Wt. 8.9/1.2, RoF 8, Shots 16. А 20-патронный магазин весит 1.4 lbs

Uzi Carbine (1980-2004) полуавтоматическая версия со стволом 40см для гражданской продажи: Dmg 3d pi, Acc 4, Range 200/2,200, Wt. 9.5/1.1, RoF 3, Shots 25+1(3), Bulk -5*, Cost $1,000, LC3.

Mini-Uzi (1980-) для экипажей транспорта и спецназа длиной всего 35см Dmg 2d+2 pi, Wt. 7/1.1, RoF 15, Cost $900.

Micro-Uzi (1982-) еще меньше 25 см со сложеным прикладом: Dmg 2d+2 pi, Range 160/1,800, Wt. 5.2/0.9, RoF 28, Shots 20(3), ST 7†, Bulk -3*, Cost $900. При одноручной стрельбе без приклада Acc 2, ST 8, Rcl 3.

Uzi Pistol (1983-1994) без приклада, и только полу автоматический режим (в прочем тот-же Микро-Узи)i: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 4.7/0.9, RoF 3, Shots 20+1(3), ST 10, Bulk -2, Cost $900, LC3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900</value>
	<weight>7/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>25(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>IMI Uzi (IMI Uzi)</description>
	<description-loc>Израиль 1967

<img data-src="http://weapons.gurps.ru/img/166.png">

<img data-src="http://weapons.gurps.ru/img/558.png">

<img data-src="http://weapons.gurps.ru/img/559.png">

<img data-src="http://weapons.gurps.ru/img/560.png">

Назван в честь изобретателя Узиела Гала - который стал основателем Израильской индустрии ручного оружия. У первой версии 1955 был несъемный деревянный приклад. IMI выпустило более двух миллионов УЗИ. Так-же производились по лицензии в Бельгии и Южной Африке, а так-же копировались в Бирме, Китае и Хорватии. Армии и полиции всего мира приняли их на вооружение. Секретная слуюба США использует и с 1967 до 1990х.

Даже с деревянным прикладом он был всего 60см: Wt. 9, Bulk -4. C 1967 складной приклад стал стандартом, а со сложенным прикладом оружие стало длиной всего 45 см. Можно стрелять с одной руки:  ST 11, Rcl 3.

Родной магазин на 25 патронов, но существуют 32 ($29, 1.3 lbs.) патронные и 20 ($28, 0.9 lb.) патронные версии. на резьбу стволам можно накрутить глушитель r (-2 to Hearing, -1 Bulk, 1 lbs). Так-же можно установить небольшой штык-нож (0.5 lbs -2 к умению Spear, Reach 1).

Доступен в калибре 45 ACP (1987-1998): Dmg 2d+1 pi+, Range 150/1,700, Wt. 8.9/1.2, RoF 8, Shots 16. А 20-патронный магазин весит 1.4 lbs

Uzi Carbine (1980-2004) полуавтоматическая версия со стволом 40см для гражданской продажи: Dmg 3d pi, Acc 4, Range 200/2,200, Wt. 9.5/1.1, RoF 3, Shots 25+1(3), Bulk -5*, Cost $1,000, LC3.

Mini-Uzi (1980-) для экипажей транспорта и спецназа длиной всего 35см Dmg 2d+2 pi, Wt. 7/1.1, RoF 15, Cost $900.

Micro-Uzi (1982-) еще меньше 25 см со сложеным прикладом: Dmg 2d+2 pi, Range 160/1,800, Wt. 5.2/0.9, RoF 28, Shots 20(3), ST 7†, Bulk -3*, Cost $900. При одноручной стрельбе без приклада Acc 2, ST 8, Rcl 3.

Uzi Pistol (1983-1994) без приклада, и только полу автоматический режим (в прочем тот-же Микро-Узи)i: Dmg 2d+2 pi, Acc 2, Range 160/1,800, Wt. 4.7/0.9, RoF 3, Shots 20+1(3), ST 10, Bulk -2, Cost $900, LC3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900</value>
	<weight>5.2/0.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>28</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Израиль</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MAC-Ingram M10</description>
	<description-loc>США 1970

<img data-src="http://weapons.gurps.ru/img/167.png">

Гордон Инграм разработал Модель 10 - первый Американский компактный пистолет-пулемет. Сначала его производила компания MAС, и он был известен как MAC-10. Они не стали достаточно успешными и выпустили всего 16,000. Характерный силуэт сделал его любимым киношным оружием (есть даже шутка что вся партия была закуплена Голливудом)

Он был достаточно компактен чтобы носить его в кобуре на ремне или под плащом. Можно стрелять с одной руки без приклада: Acc 2, ST 10, Rcl 3. Можно использовать глушитель (1.2 lbs, -2 to Hearing, -1 Bulk)

C 1977 продается полуавтоматическая версия, однако ее легко перевести в автоматический режим броско Armoury (Small Arms) с+4 или Guns на базе IQ. Эта версия была более успешна - пол миллиона было продано под разными брендами включая Cobray.

Существует редкая версия на .45 ACP: Dmg 2d+1 pi+, Range 140/1,500, Wt. 8.4/2.2, RoF 19, Shots 30(3).

M11 (1970-1976) была даже несколько меньше и калибром .380 ACP Dmg 2d-1 pi, Range 110/1,100, Wt. 4.6/1.1, RoF 26, ST 7†. 16 патронный магазин весил 0.6 lb.; глушитель 1 lb.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>425/29</value>
	<weight>7.5/1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>130/1,400</range>
		<rate_of_fire>18</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MAC-Ingram M10</description>
	<description-loc>США 1970

<img data-src="http://weapons.gurps.ru/img/167.png">

Гордон Инграм разработал Модель 10 - первый Американский компактный пистолет-пулемет. Сначала его производила компания MAС, и он был известен как MAC-10. Они не стали достаточно успешными и выпустили всего 16,000. Характерный силуэт сделал его любимым киношным оружием (есть даже шутка что вся партия была закуплена Голливудом)

Он был достаточно компактен чтобы носить его в кобуре на ремне или под плащом. Можно стрелять с одной руки без приклада: Acc 2, ST 10, Rcl 3. Можно использовать глушитель (1.2 lbs, -2 to Hearing, -1 Bulk)

C 1977 продается полуавтоматическая версия, однако ее легко перевести в автоматический режим броско Armoury (Small Arms) с+4 или Guns на базе IQ. Эта версия была более успешна - пол миллиона было продано под разными брендами включая Cobray.

Существует редкая версия на .45 ACP: Dmg 2d+1 pi+, Range 140/1,500, Wt. 8.4/2.2, RoF 19, Shots 30(3).

M11 (1970-1976) была даже несколько меньше и калибром .380 ACP Dmg 2d-1 pi, Range 110/1,100, Wt. 4.6/1.1, RoF 26, ST 7†. 16 патронный магазин весил 0.6 lb.; глушитель 1 lb.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>425/29</value>
	<weight>8.4/2.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>140/1,500</range>
		<rate_of_fire>19</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MAC-Ingram M10 (M11)</description>
	<description-loc>США 1970

<img data-src="http://weapons.gurps.ru/img/167.png">

Гордон Инграм разработал Модель 10 - первый Американский компактный пистолет-пулемет. Сначала его производила компания MAС, и он был известен как MAC-10. Они не стали достаточно успешными и выпустили всего 16,000. Характерный силуэт сделал его любимым киношным оружием (есть даже шутка что вся партия была закуплена Голливудом)

Он был достаточно компактен чтобы носить его в кобуре на ремне или под плащом. Можно стрелять с одной руки без приклада: Acc 2, ST 10, Rcl 3. Можно использовать глушитель (1.2 lbs, -2 to Hearing, -1 Bulk)

C 1977 продается полуавтоматическая версия, однако ее легко перевести в автоматический режим броско Armoury (Small Arms) с+4 или Guns на базе IQ. Эта версия была более успешна - пол миллиона было продано под разными брендами включая Cobray.

Существует редкая версия на .45 ACP: Dmg 2d+1 pi+, Range 140/1,500, Wt. 8.4/2.2, RoF 19, Shots 30(3).

M11 (1970-1976) была даже несколько меньше и калибром .380 ACP Dmg 2d-1 pi, Range 110/1,100, Wt. 4.6/1.1, RoF 26, ST 7†. 16 патронный магазин весил 0.6 lb.; глушитель 1 lb.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>425/29</value>
	<weight>4.6/1.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d-1 pi</damage>
		<strength>7†</strength>
		<accuracy>3</accuracy>
		<range>110/1,100</range>
		<rate_of_fire>26</rate_of_fire>
		<shots>32(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>.380 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K MP5A3</description>
	<description-loc>Германия 1971

<img data-src="http://weapons.gurps.ru/img/168.png">

Первая версия MP5 (1966-1971) имела фиксированы пластиковый приклад и прямой магазин (Wt. 6, Bulk -4)

MP5A1 (1966-1971) была без приклада (Acc 3, Wt. 5.3, Bulk -3).

MP5A2 (1971-) немного продвинутая версия MP5 (Wt. 6, Bulk -4) она и MP5A3 (в таблице) являются основными производимыми моделями на данный момент.

MP5A4 (1982-) имела фиксированный приклад, но имела возможность ограничивать очередь до 3х патронов (RoF 9/13), MP5A5 то-же и самое но с выдвижным прикладом.

MP5N (1985-) была заказан для Морских Котиков США. Напоминает MP5A3, но имеет "обоерукую" конфигурацию и ствол с возможностью быстрого подключения глушителя (1.2 lbs, -2 Hearing, -1 Bulk). C 2001 доступен двойной барабан на 100 патронов.

Так-же существует в других калибрах. D 1994, ФБР заказывает MP5/10A3 (1992-1999), под 10x25mm Auto: Dmg 3d+2 pi+, Range 280/3,100, Wt. 7.8/1.5, RoF 6/13, ST 9†, Rcl 3. 

MP5/40A3 (1992-1999), in .40 S&amp;W, несколько более популярно: Dmg 3d-1 pi+, Range 190/2,000, Wt. 7.6/1.3, RoF 6/13. Обе стреляют в одиночном режиме, две пули или полностью автоматически.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/29</value>
	<weight>7.5/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>4</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K MP5SD3</description>
	<description-loc>Германия 1974

<img data-src="http://weapons.gurps.ru/img/169.png">

Schalldämpfer имеет встроенный глушитель (-3 к слуху) на 10,000 выстрелов.

Версия MP5SD1 без приклада (Acc 3, Wt. 7.3, Bulk -3)

MP5SD2 не складывающийся приклад (Wt. 8, Bulk -4)

MP5SD3 (в таблице) выдвижной приклад. 

MP5SD4,MP5SD5, и MP5SD6 (все с 1982) получили опцию очереди по три патрона (RoF 9/13) в остальном идентичны MP5SD1, MP5SD2 и MP5SD3 соответственно.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>2,400/29</value>
	<weight>8.7/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8†</strength>
		<accuracy>4</accuracy>
		<range>120/1,400</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K MP5K</description>
	<description-loc>Германия 1976

<img data-src="http://weapons.gurps.ru/img/170.png">

<img data-src="http://weapons.gurps.ru/img/563.png">

Kurz укороченная версия MP5 для скрытого ношения под плащем. У нее нет приклада, но есть передняя ручка для лучшей управляемости. Можно стрелять с одной руки ST 11, Rcl 3. магазин на 15 патронов ($27, 0.7 lb.) разработан специально для нее но стандартный 30 патронный более распространен.

MP5KA1 (1976-) имел очень компактные прицелы (Acc 1, Bulk -2, +1 к Fast-Draw)

MP5KA4 и MP5KA5 (1982-) позволяли ограничивать очередь (RoF 9/13)

MP5K-PDW (1991-) это MP5K но со складным прикладом (Acc 3, Wt. 6.2, Bulk -4*) а так-же позволяет подключать глушитель от MP5N.

Так-же существует специальной чемодан ($3,000, 14.9 lbs. вместе с оружием и запасным магазином), внутри него крепится MP5K. На ручке чемодана кнопка позволяющая стрелять прямо из чемодана. Это дает -4 к умению Guns (млмл можно зять отдельную технику упирания чемодана в зв среднюю часть), Rcl становится 3.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>1,400/29</value>
	<weight>5.6/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>9†</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN P90</description>
	<description-loc>Бельгия 1991

<img data-src="http://weapons.gurps.ru/img/171.png">

<img data-src="http://weapons.gurps.ru/img/564.png">

Встроенный калиматороный прицел



Инновационное оружие - компактное и удобное. Булпап с верхним магазином параллельно стволу. Эргономичные ручки прямо вокруг курка. Было выпущено более 17,000. Используется спецподразделениями, спецназом и Секретной Службой США. Иммет встроенный калиматроный прицел (+1 к умению), стандартно стреляет AP (бронебойными) патронам, можно установить глушитель (1.2 lbs, -3 Hearing, -1 Bulk)

P90TR (1999-) встроенный прицел заменен на полозья для навесного - одни посередине и по одному с боков.

PS90 (2006-) полуавтоматическая гражданская версия с удлиненным стволом (40см), стреляет обычными пулями: Dmg 4d pi-, Range 200/2,200, Wt. 7/0.7, Shots 30+1(3), Cost $1,400/$32, LC3. Если поставить AP: Dmg 3d(2) pi-. Магазин от P90 на 50 патронов подходит</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,650/55</value>
	<weight>6.6/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1(2) pi-</damage>
		<strength>8†</strength>
		<accuracy>4</accuracy>
		<range>180/1,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>50+1(5)</shots>
		<bulk>-3</bulk>
		<recoil>2</recoil>
		<ammo>5.7x28mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Steyr TMP</description>
	<description-loc>Австрия 1993

<img data-src="http://weapons.gurps.ru/img/172.png">

Тактический Автоматический Пистолет - легкий, гладкий, напоминает крупный пистолет с передней ручкой. общая длина 30см, его очень легко срыть, телохранители любят использовать такие. МОжно стрелять с одной руки: ST 10, Rcl 3.

С магазином на 15 патронов: Wt. 3.4/0.5, Shots 15+1(3).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,200/34</value>
	<weight>3.8/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+2 pi</damage>
		<strength>8†</strength>
		<accuracy>2</accuracy>
		<range>160/1,800</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ПП-19 Бизон 2</description>
	<description-loc>Россия / СССР 1996

<img data-src="http://weapons.gurps.ru/img/173.png">

Основан на частях от Калашникова. Имеет складной приклад, улиточный барабан на 64 патрона параллельно стволу. Российская полиция и внутренние силы используют их, часто с патроном APHC 

(Dmg 2d(2) pi-)

Бизон-2-01 (1996-) то-же оружие, но под патрон 9x19mm Parabellum: Dmg 3d-1 pi, Range 170/1,900, Wt. 8/2.2, RoF 12, Shots 53(5).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>450/305</value>
	<weight>7.4/2.25</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>120/1,300</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>64(5)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x18mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ПП-19 Бизон 2</description>
	<description-loc>Россия / СССР 1996

<img data-src="http://weapons.gurps.ru/img/173.png">

Основан на частях от Калашникова. Имеет складной приклад, улиточный барабан на 64 патрона параллельно стволу. Российская полиция и внутренние силы используют их, часто с патроном APHC 

(Dmg 2d(2) pi-)

Бизон-2-01 (1996-) то-же оружие, но под патрон 9x19mm Parabellum: Dmg 3d-1 pi, Range 170/1,900, Wt. 8/2.2, RoF 12, Shots 53(5).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>450/305</value>
	<weight>8/2.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>170/1,900</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>53(5)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x19mm Parabellum</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K UMP</description>
	<description-loc>Германия 1999

<img data-src="http://weapons.gurps.ru/img/174.png">

Полозья для навесного (HT161)

"Универсальный Пистолет-Пулемет" разработан для Американского спецназа и широко экспортировался.  оружие с малой отдачей и большей частью пластиковое. Складной приклад и полозья для навесного вокруг ствола и сверху. Так-же выпускался в калибре .40 S&amp;W: Dmg 3d-1 pi+, Range 190/2,000, Wt. 6/1.4, RoF 12, Shots 30+1(3). Можно установить глушитель (0.8-lb. -2 to Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>900/36</value>
	<weight>6.5/1.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d+1 pi+</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>160/1,700</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>25+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>.45 ACP</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K UMP</description>
	<description-loc>Германия 1999

<img data-src="http://weapons.gurps.ru/img/174.png">

Полозья для навесного (HT161)

"Универсальный Пистолет-Пулемет" разработан для Американского спецназа и широко экспортировался.  оружие с малой отдачей и большей частью пластиковое. Складной приклад и полозья для навесного вокруг ствола и сверху. Так-же выпускался в калибре .40 S&amp;W: Dmg 3d-1 pi+, Range 190/2,000, Wt. 6/1.4, RoF 12, Shots 30+1(3). Можно установить глушитель (0.8-lb. -2 to Hearing, -1 Bulk).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>900/36</value>
	<weight>6/1.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 pi+</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>190/2,000</range>
		<rate_of_fire>12</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>.40 S&amp;W</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>СР-2 «Вереск»</description>
	<description-loc>Россия / СССР 1999

<img data-src="http://weapons.gurps.ru/img/175.png">

Полозья для навесного (HT161)

Основан на пистолете "Гюрза" и стреляет тем-же APHC патроном. Компактное оружие с магазином в ручке, складным прикладом и полозьями для навесного сверху. В основном испольуется секретными службами и спецназом. </description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>750/29</value>
	<weight>4.8/1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1(2) pi-</damage>
		<strength>8†</strength>
		<accuracy>3</accuracy>
		<range>170/1,800</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>30+1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>9x21mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K MP7A1</description>
	<description-loc>Германия 2002

<img data-src="http://weapons.gurps.ru/img/176.png">

Полозья для навесного (HT161)



"Обоеручный" используется спец подразделениями. Напоминает крупный пистолет из черного пластика. Выдвижной приклад, магазин в ручке и складная передняя ручка. Можно стрелять с одной руки: ST 8, Rcl 3.

Имеет полозья для оптики. Обычно идет калиматорный прицел (+1 skill, 0.2 lbs). так-же есть боковые полозья. Может быть снабжен глушителем (0.8-lb, -3 to Hearing, -1 Bulk). Существует дополнительный магазин на 40 патронов (-1 Bulk, $28, 0.9 lb.). Можно снарядить AP (бронебойными): Dmg 3d(2) pi-.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>2</legality_class>
	<value>1,500/26</value>
	<weight>4.4/0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+1 pi-</damage>
		<strength>7†</strength>
		<accuracy>4</accuracy>
		<range>180/1,900</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>20+1(3)</shots>
		<bulk>-3*</bulk>
		<recoil>2</recoil>
		<ammo>4.6x30mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пистолет-пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>200/8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+1 pi+</damage>
		<strength>26M</strength>
		<accuracy>4</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>40(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.45-70</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (M1862)</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>390/7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>26M</strength>
		<accuracy>3</accuracy>
		<range>230/2,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>50(3i)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.58 Berdan</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (M1866 )</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>224/3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi+</damage>
		<strength>26M</strength>
		<accuracy>4</accuracy>
		<range>490/3,100</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>22(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.50-70 Government</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (M1866 1")</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>30,000/60</value>
	<weight>1,008/18</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi++</damage>
		<strength>26M</strength>
		<accuracy>5</accuracy>
		<range>420/2,700</range>
		<rate_of_fire>5</rate_of_fire>
		<shots>20(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>1”</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (M1883)</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>237/24.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+1 pi+</damage>
		<strength>26M</strength>
		<accuracy>4</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>104(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.45-70</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (M1903)</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>200/4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>26M</strength>
		<accuracy>4</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>40(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Gatling M1874 (Gatling Mk I)</description>
	<description-loc>США 1874

<img data-src="http://weapons.gurps.ru/img/178.png">

<img data-src="http://weapons.gurps.ru/img/181.png">

<img data-src="http://weapons.gurps.ru/img/596.png">

<img data-src="http://weapons.gurps.ru/img/597.png">

Сильно ненадежный - клинит на 15+



В 1962 Ричард Готлинг запатентовал оружие состоящие из группы стволов вращаемых с помощью рычага справа сзади с подачей из бункера под средством гравитации (очень похоже на ручную кофемолку). Каждый поворот рычага происходила подача, выстрел и отброс боеприпасах. Около 1,200 пулеметов Готлинга различных конструкция было выпущено в США, армия закупила 725 единиц, остальные были раскуплены гражданскими, полицией и отправлены на экспорт. Еще сотни были выпущены по лицензии в Австрии, Британии и России, копировались в Китае.

M1874 - классический 10 ствольный Готлинг используемый Армией США (закупила 82 штуки). Устанавливался на двухколесную артелериуский тележку (560 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (840 lbs) несла 2000 патронов в 50 магазинах. Тележка и подкат (+$6,500 к стоимости орудия) соединялись вместе и перевозились лошадьми. Трипод (40 lbs, $1,800) можно было возить а поклаже вместе с оружием на одном животном.

Подача птаронов велась со съемных 40 патронных магазинов верхнее подачи (8 lbs). Так-же можно было использовать барабан Бродвела на 400 патронов  ($500, 60 lbs.). Это была система из стоящий вертикально клястеров по 20 патронов, постле отстерала 20 штук необходимо было провернуть барабан вручную (Требует двух Ready маневров, или одного если помогает ассистент. установка нового барабана занимает 10 секунд). 

M1862 (1862-1866) оригинальный шестиствольный готлинг стреляющий патроно .58 Berdan: Malf. 14, Dmg 5d pi+, Acc 3, Range 230/2,300, EWt. 390/7, RoF 3, Shots 50(3i). устанавливался на деревянную артелериуский тележку (450 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (580 lbs) несла 2000 патронов, все это тянули четыре лошади. Было выпущено очень немного, генерал Батлер из Армии Объединения купил 12 и использовал во времена Гражданской Войны США. New York Times приобрела три и они были укомплектованы сотрудниками газеты во время восстаний в Июле 1863.

M1866 (1866-1871), шестиствольный под патрон .50-70 Government: Malf. 15, Dmg 5d+1 pi+, Range 490/3,100, EWt. 224/3, RoF 10, Shots 22(5). Первые 50 штука попали на вооружение армии США в 1867; 22 достались флоту. Устанавливался на двухколесную артелериуский тележку (426 lbs вместе с орудием), поставлялся с отдельной двухколесной тележкой с боеприпасам (470 lbs) перемещалось это все четырьмя лошадями.

Как минимум 66 единиц было выпущено в больее крупном калибре 1” (1866-1871): Malf. 15, Dmg 7d+1 pi++, Acc 5, Range 420/2,700, EWt. 1,008/18, RoF 5, Shots 20(5), Cost $30,000/$60. Из ниж часто стреляли картечью: Dmg 2d-1 pi+, Acc 3, Range 60/1,100, RoF 5x15, Rcl 1.

M1877 Bulldog (1877-1883) калибром .45- 70 был самой мелкой версией: Dmg 4d pi+, EWt. 90, RoF 7, ST 22M, Bulk -8, Cost $14,000. Устанавливался на трипод (40-lb. $1,800). использовался для полицейских нужд и не был успешен. Однако игроки могут найти ему применение...

M1883 (1883-1889) десяти-ствольный под калибр  .45-70, стволы были заключены в бронзовую оболочку для защиты, он выглядел как один толстый ствол: Malf. 14, EWt. 237/24.5, Shots 104(5) у нему шел 104 патронный барабан принудительной подачи  ($650, 24.5 lbs.) - штука в форме бублика поперек ствола. Он не работал за счет “гравитации” так что мог быть прикреплен и сбоку, а не обязательно сверху, что позволяло занизит силуэт оружия и устанавливать его в помещениях с низким потолком, допустим в бункерах. Однако подача была несколько недостаточно “принудительной” и вызывала частые заклинивания. Вращающаяся ручка имеет две позиции установки - при вставлении в заднюю повышается RoF до 25 но снижало Malf до 13! Устанавливался на двухколесную артиллерийскую тележку (831 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (754 lbs) несущей 4 барабана и 6,040 патронов. Тянуло это все четыре лошади.

M1903 (1907-1911) - десяти-ствольный в финальной версии имел калибр .30-06: Dmg 7d+1 pi, EWt. 200/4.

С 1868 Русская армия закупила минимум 520 орудий схожих с M1874 но калибром 10.75x58mmR Berdan (Dmg 5d-1 pi+). В России известна как Горлов, в честь российского атташе который изучал их. Использовалось во время войны Японией в 1904. Аргентина, Чили, Куба, Гватемала и Мексика использовала подобные оружия но в калибре 11.15x58mmR Spanish Remington (Dmg 5d pi+), Египет использовал 11.4x50mmR Egyptian Remington (Dmg 5d pi+).

Gatling Mk I (1874) десяти-ствольный для Британской Армии был калибром .450 Gardner-Gatling: Dmg 5d pi+, EWt. 200/70, RoF 13, Shots 352(5), Bulk -9. Его барабан Бродвела имел 352 патрона - под 16 вертикальных магазинов с 22 патронами в каждом. Был и более легкий барабана  на 240 патронов (50 lbs.) нес 16 x 15 магазинов. устанавливался на двухколесную артиллерийскую тележку (444 lbs вместе с орудием)  соединенную с тележкой для боеприпаса (пустая - 387-lb. lbs). Тянуло это все четыре лошади.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>16,000/40</value>
	<weight>200/70</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>26M</strength>
		<accuracy>4</accuracy>
		<range>470/3,000</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>352(5)</shots>
		<bulk>-9</bulk>
		<recoil>2</recoil>
		<ammo>.450 Gardner-Gatling</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Hotchkiss 1-pdr</description>
	<description-loc>Франция 1875

<img data-src="http://weapons.gurps.ru/img/179.png">

<img data-src="http://weapons.gurps.ru/img/184.png">

Не надежный - клинит на 16+



Очень похож на Готлинг, но крупнее и конструктивно другой.  У него 5 вращающихся стволов стреляющих патронами 1lbs черного пороха. Изначально морское оружие, разрабатывалось для борьбы с торпедными катерами, торпеды имели дальность до 400 метров а пулемет до 1000. Экспортировался в более чем 30 стран мира, выпускался по лицензии в Британии, Германии, России и США. Обычно на суше не использовался, но Армия США использовала его во время войны с индейцами.

Стреляет из 10 патронного бункера на принципе гравитации. Заряжающий может бункер с помощью зарядного зажима (18 lbs) или по одному патрону (1.4 lbs) прямо в процессе стрельбы. Кроме LE патронов (в таблице) использовались твердотельные (Dmg 5dx2 pi++), картечь (Dmg 1d+1 pi++, Acc 3, Range 60/1,200, RoF 1x75, Rcl 1), и c 1892 APEX (Dmg 4dx2(2) pi++ with a 1d+2 [2d-1] cr). Неземная версия устанавливалась на двухколесную артеллерийскую тележку (1,600

lbs. вместе с орудием) со щитом DR 15.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>1</legality_class>
	<value>20,000</value>
	<weight>495/18</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5dx2(0.5) pi++ 2d [2d] cr ex</damage>
		<strength>33M</strength>
		<accuracy>4</accuracy>
		<range>570/3,600</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>10(5)</shots>
		<bulk>-12</bulk>
		<recoil>2</recoil>
		<ammo>37x94mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Nordenfelt Single-Barrel</description>
	<description-loc>Великобритания 1882

<img data-src="http://weapons.gurps.ru/img/180.png">

<img data-src="http://weapons.gurps.ru/img/182.png">

<img data-src="http://weapons.gurps.ru/img/183.png">

Не надежный - клинит на 16+



Разработки шведского конструктора Нердинфелда этот механический пулемет стреляющий с помощью рычага на с правой стороны. Большинство моделей были тяжелы - монтировались на коляске или корабле и имели от 3 до 12 стволов.  Однако существовала и одноствольная версия. Менее 10 было куплено Королевскими Морскими Силами для пробы и так и небыли приняты на вооружение. И тем не менее это был чудесный переносной пулемет дающий мощные огневые возможности небольшой группе солдат (или приключенцев).



Питается от двух съемных бункерных магазинов по 4.7 lbs каждый, в каждом по 15 патронов. Стрелок может отстрелять 30 патронов, а потом заменить оба, или можно менять только верхний через 15 патронов. Оружие так-же снабжено гнутым плечевым прикладом. Устанавливается на 17 lbs складной трипод ($2,100). Так-же выпускался в других оружейных калибрах.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>2</legality_class>
	<value>2,000/45</value>
	<weight>13/9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi+</damage>
		<strength>15M</strength>
		<accuracy>4</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>30(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>.450 MH</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Maxim Mk I</description>
	<description-loc>Великобритания 1889

<img data-src="http://weapons.gurps.ru/img/185.png">

<img data-src="http://weapons.gurps.ru/img/608.png">

Не надежный - клинит на 16+



Хайрем Стивенс Максим представил свою конструкцию среднеразмерного пулемета в 1883 году, и это было первое автоматическое оружие. Он ввел в мир самозарядную конструкцию и сделал популярными патронажные ленты. Пулемет имел водяное охлаждение (4л) что позволяло вести непрерывный огонь. В 1889 Британская Армия его их на вооружение и началось массвоео производство в калибрах  .450 Martini-Henry (в таблице) и новом бездымном .303 British: Dmg 6d+2 pi, Range 790/3,300, EWt. 40/16.

Оба варината использовали неразъемные ленты по 250 патронов (30 lbs., или 40 lbs. в деревянном ящике для .450). В 1893 появилась 150 патронная лента для .450 (18 lbs., или 23 lbs. в деревенщиной коробке). Исходно устанавливался на двухколесную тележку для перевозки лошадьми (1,456 lbs. включая оружие и ствол) В 1897, появился мощный трипод (48 lbs, $2,700) что повозило перевозить его и оружие на одном вьючном животном.

В 1885-1889 было выпущено несколько тестовый орудий с возможностью смены режима стрельбы в калибре .450 Martini-Henry: Dmg 5d pi+, EWt. 60/40, RoF 10, Shots 333(5) - плоская рубашка охлаждения на 1.5 литра и трипод (14lbs $2,850) в 1888, ,Британский исследователь Генри Стэнли первым опробовал это орудие в бою в своем рискованном путешествии по "Темной Африке".

Бразилия покапала версию под патрон 7x57mm Mauser (Dmg 6d+2 pi); Бельгия и Перу 7.65x53mm Mauser (Dmg 6d+2 pi); Чили 7.92x57mm Mauser (Dmg 7d+1 pi). Армия США приобрела несколько сотен .30-06 (Dmg 7d+1 pi) под маркой M1904.

PM-1910 (1910-1943) Русский вариант "Пулемет Максима" под калибр 7.62x54mmR Mosin-Nagant: Dmg 7d pi, EWt. 44.7/22.7. Широко использовался в обоих мировых войнах. Часто устанавливался на небольшой двухколесной тележке (78 Lbs), часто дополнялся щитом (RD 20, 20 lbs)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>7,000</value>
	<weight>40/30</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+2 pi+</damage>
		<strength>12M</strength>
		<accuracy>4</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>.450 MH</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Maxim Mk I (Russian)</description>
	<description-loc>Великобритания 1889

<img data-src="http://weapons.gurps.ru/img/185.png">

<img data-src="http://weapons.gurps.ru/img/608.png">

Не надежный - клинит на 16+



Хайрем Стивенс Максим представил свою конструкцию среднеразмерного пулемета в 1883 году, и это было первое автоматическое оружие. Он ввел в мир самозарядную конструкцию и сделал популярными патронажные ленты. Пулемет имел водяное охлаждение (4л) что позволяло вести непрерывный огонь. В 1889 Британская Армия его их на вооружение и началось массвоео производство в калибрах  .450 Martini-Henry (в таблице) и новом бездымном .303 British: Dmg 6d+2 pi, Range 790/3,300, EWt. 40/16.

Оба варината использовали неразъемные ленты по 250 патронов (30 lbs., или 40 lbs. в деревянном ящике для .450). В 1893 появилась 150 патронная лента для .450 (18 lbs., или 23 lbs. в деревенщиной коробке). Исходно устанавливался на двухколесную тележку для перевозки лошадьми (1,456 lbs. включая оружие и ствол) В 1897, появился мощный трипод (48 lbs, $2,700) что повозило перевозить его и оружие на одном вьючном животном.

В 1885-1889 было выпущено несколько тестовый орудий с возможностью смены режима стрельбы в калибре .450 Martini-Henry: Dmg 5d pi+, EWt. 60/40, RoF 10, Shots 333(5) - плоская рубашка охлаждения на 1.5 литра и трипод (14lbs $2,850) в 1888, ,Британский исследователь Генри Стэнли первым опробовал это орудие в бою в своем рискованном путешествии по "Темной Африке".

Бразилия покапала версию под патрон 7x57mm Mauser (Dmg 6d+2 pi); Бельгия и Перу 7.65x53mm Mauser (Dmg 6d+2 pi); Чили 7.92x57mm Mauser (Dmg 7d+1 pi). Армия США приобрела несколько сотен .30-06 (Dmg 7d+1 pi) под маркой M1904.

PM-1910 (1910-1943) Русский вариант "Пулемет Максима" под калибр 7.62x54mmR Mosin-Nagant: Dmg 7d pi, EWt. 44.7/22.7. Широко использовался в обоих мировых войнах. Часто устанавливался на небольшой двухколесной тележке (78 Lbs), часто дополнялся щитом (RD 20, 20 lbs)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>7,000</value>
	<weight>44.7/22.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>12M</strength>
		<accuracy>4</accuracy>
		<range>500/3,200</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x54mmR Mosin-Nagant</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Maxim 1-pdr</description>
	<description-loc>Великобритания 1889

<img data-src="http://weapons.gurps.ru/img/186.png">

Одно пудовый пулемет Максим с водяным охлаждением фактически самая первая автоматическая пушка - Это Maxim MG уменьшенный для стрельбы 1 lbs черно пороховыми снарядами. Изначально разрабатывался для стрельбы по торпедным катерам для флота Аргентины, Испании, Турции, Британии и США, ну еще 25 стран приняло его на вооружение. Германия и Россия выпускала их по лицензии. Немецкие моряки использовали на суше во время восстания в Китае, а Британцы использовали против аэростатов и броне автомобилей во время Первой Мировой.

Использует не размыкаемые ленты на 25 патронов. (55 lbs., или 65 lbs. в деревянном коробе). Наземное оружие использовалось на двухколесной тележке (767 lbs вместе с орудием)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>15,000</value>
	<weight>410/55</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5dx2(0.5) pi++  2d [2d] cr ex</damage>
		<strength>31M</strength>
		<accuracy>4</accuracy>
		<range>480/4,500</range>
		<rate_of_fire>5</rate_of_fire>
		<shots>25(5)</shots>
		<bulk>-11</bulk>
		<recoil>2</recoil>
		<ammo>37x94mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Electric Gatling M1893</description>
	<description-loc>США 1893

<img data-src="http://weapons.gurps.ru/img/187.png">

Не надежный - клинит на 16+

Требует батарей



Первая попытка улучшить Готлинг был эксперимент 1890 по установке внешнего мотора вместо механической ручки. Вскоре последовали улучшения - Доктор Готлинг запатентовал 10 ствольный пулемет водного охлаждения с мотором внутри его бронзового ствола. Скорострельность оказалась невероятной -  3,000 выстрелов в минуту (RoF 50!), однако он оставался не надежным до момента изобретения конструкции "Вулкан" (M61 Vulcan) в 1950. Оружие было разработано для флота и генераторы судна могли поставлять электроэнергию, но для мира "альтернативной истории" возможны разные варианты. Один прототип был построен - подача шла из барабана на 104 патрона ($650, 21 lbs.) и требовал внешнего источника энергии на 1kW</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>25,000</value>
	<weight>300/21</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+1 pi</damage>
		<strength>29M</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>50!</rate_of_fire>
		<shots>104(5)</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>.30-40</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Colt Model 1895</description>
	<description-loc>США 1897

<img data-src="http://weapons.gurps.ru/img/188.png">

<img data-src="http://weapons.gurps.ru/img/217.png">

Не надежный - клинит на 16+

Это первый настоящий Американский Пулемет. Разработан Джонам Браунингом, так-же известен под именем "картофелекопалка" за рычаг газа который поворачивается вертикально под орудием. Военно Морской Флот США поставил их на вооружение для морской пехоты, и использовал в Испано-Американской войне и в Китае во время революции. Подача ведется из 120 патронной неразъемной ленты (7.4 lbs., или 20 lbs. за две ленты в деревянном коробе). Устанавливается на трипод (57-lb. $2,550) или на двухколесную коляску (146-lb).

Производился во множестве калибров. Италия использовала 6.5x52mm Mannlicher-Carcano (Dmg 6d pi); Мексика 7x57mm Mauser (Dmg 6d+2 pi); Персия и Россия 7.62x54mmR Mosin-Nagant (Dmg 7d pi); Бельгия 7.65x53mm Mauser (Dmg 6d+2 pi); Австралия, Канада и Южная Африка .303 British (Dmg 6d+2 pi). "Мужественные всадники" Теодора Рузвельта  приобрели два 7x57mm для Испано-Американской войны.

MK I MOD 1 (1898-1902) был калибром .30-40 Krag (Dmg 6d pi).

M1914 (1914-1917) на вооружении армии США под калибр  .30-06: Dmg 7d+1 pi, EWt. 36/15.3,

RoF 10!, Shots 250. Устанавливался на трипод (53-lb.  $2,550). Полиция Нью-Йорка так-же закупила несколько но вряд ли когда либо использовала. 

Marlin M1917 (1917-1918) калибра .30-06 заменила рычаг газа на обычный поршень, что позволило устанавливать его на самолетах): Dmg 7d+1 pi, EWt. 22.2, RoF 14! (RoF

10! если синхронизирован), Shots 500.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,000</value>
	<weight>35/7.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>17M</strength>
		<accuracy>6</accuracy>
		<range>700/3,000</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>120(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>6x60mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Maxim MG08</description>
	<description-loc>Германия 1908

<img data-src="http://weapons.gurps.ru/img/189.png">

<img data-src="http://weapons.gurps.ru/img/604.png">

В 1894 Германский флот принял на вооружения версию Maxim Mk I под патрон 7.92x57mm под маркой MG94. А в 1908 Немецкая Армия представила облегченную модель, которая (вместе со своими Британскими и Российскими аналогами) стала господствующим окопным орудием Первой Мировой Войны. Было выпущено примерно 32,000 единиц.

Подача ведется из 250 патронной неразъемной ленты (16 lbs., или 19.5 lbs. в коробе). Водяная рубашка охлаждения на 3.5 литра. Использует турель-салазки (88 lbs $1,900; см B353) или трипод (71 lbs, $2,850). Часто снабжается прицелом x2.5 (+1Acc). С 1915 доступен патрон APHC  (Dmg 7d+1(2) pi-)

Так-же на вооружении в Китае, Персии, Турции и Югославии. Бразилия использует с патроном 7x57mm Mauser (Dmg 6d+2 pi); Бельгия 7.65x53mm Mauser (Dmg 6d+2 pi); а Болгария 8x50mmR Mannlicher (Dmg 6d+1 pi). Многие использовались во время Второй Мировой Войны. Некоторые даже во Вьетнаме.

MG08/15 (1915-1918) облегченная версия с прикладом и сошками для штурмовых групп:  45.8/5.1, Shots 50(5), ST 13B†. Единственный легкий пулемет с водяным охлаждением. Его плоская водяная рубашка вмещала 2.5 литра жидкости. Это тяжелый "легкий пулемет" с трудом обслуживался одним человеком. Пулеметчиков подбирали из сильных и выносливых, однако для того чтобы поспеть за вооруженной винтовками пехотой, пулеметчикам все равно приходилось нести его по очереди. Подача ведется с 50 патронной ленты свернутой внутри барабана (3.2 lbs, вместе с барабаном 5.1), но может использовать и 250 патронные ленты. Было выпущено около 130,000 единиц. Германия держала их в резерве во время Второй Мировой.

LMG08/15 (1916-1918) воздушного охлаждения известный так-же как "Спандау" по названию бельгийского пригорода где он выпускался - стандартный авиационный пулемет Германии в Первую Мировую:  EWt. 27.5, RoF 11! (RoF 7! если синхронизирован). Набегающий поток воздуха дает достаточное охлаждение.

LMG14 Parabellum (1915-1918) воздушного охлаждения устанавливался на самолеты и дирижабли: : EWt. 23, RoF 11!, Bulk -7. Подача велась из 100 патронной ленты (в бочке или со спирали). С 1917 часто имеет прицел x3 (2 lbs, +1 Acc)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>7,000</value>
	<weight>59.4/16</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>19M</strength>
		<accuracy>6</accuracy>
		<range>1,000/4,400</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Maxim MG08 (MG08/15)</description>
	<description-loc>Германия 1908

<img data-src="http://weapons.gurps.ru/img/189.png">

<img data-src="http://weapons.gurps.ru/img/604.png">

В 1894 Германский флот принял на вооружения версию Maxim Mk I под патрон 7.92x57mm под маркой MG94. А в 1908 Немецкая Армия представила облегченную модель, которая (вместе со своими Британскими и Российскими аналогами) стала господствующим окопным орудием Первой Мировой Войны. Было выпущено примерно 32,000 единиц.

Подача ведется из 250 патронной неразъемной ленты (16 lbs., или 19.5 lbs. в коробе). Водяная рубашка охлаждения на 3.5 литра. Использует турель-салазки (88 lbs $1,900; см B353) или трипод (71 lbs, $2,850). Часто снабжается прицелом x2.5 (+1Acc). С 1915 доступен патрон APHC  (Dmg 7d+1(2) pi-)

Так-же на вооружении в Китае, Персии, Турции и Югославии. Бразилия использует с патроном 7x57mm Mauser (Dmg 6d+2 pi); Бельгия 7.65x53mm Mauser (Dmg 6d+2 pi); а Болгария 8x50mmR Mannlicher (Dmg 6d+1 pi). Многие использовались во время Второй Мировой Войны. Некоторые даже во Вьетнаме.

MG08/15 (1915-1918) облегченная версия с прикладом и сошками для штурмовых групп:  45.8/5.1, Shots 50(5), ST 13B†. Единственный легкий пулемет с водяным охлаждением. Его плоская водяная рубашка вмещала 2.5 литра жидкости. Это тяжелый "легкий пулемет" с трудом обслуживался одним человеком. Пулеметчиков подбирали из сильных и выносливых, однако для того чтобы поспеть за вооруженной винтовками пехотой, пулеметчикам все равно приходилось нести его по очереди. Подача ведется с 50 патронной ленты свернутой внутри барабана (3.2 lbs, вместе с барабаном 5.1), но может использовать и 250 патронные ленты. Было выпущено около 130,000 единиц. Германия держала их в резерве во время Второй Мировой.

LMG08/15 (1916-1918) воздушного охлаждения известный так-же как "Спандау" по названию бельгийского пригорода где он выпускался - стандартный авиационный пулемет Германии в Первую Мировую:  EWt. 27.5, RoF 11! (RoF 7! если синхронизирован). Набегающий поток воздуха дает достаточное охлаждение.

LMG14 Parabellum (1915-1918) воздушного охлаждения устанавливался на самолеты и дирижабли: : EWt. 23, RoF 11!, Bulk -7. Подача велась из 100 патронной ленты (в бочке или со спирали). С 1917 часто имеет прицел x3 (2 lbs, +1 Acc)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>7,000</value>
	<weight>45.8/5.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>13B†</strength>
		<accuracy>6</accuracy>
		<rate_of_fire>8!</rate_of_fire>
		<shots>50(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Vickers Mk I</description>
	<description-loc>Великобритания 1912

<img data-src="http://weapons.gurps.ru/img/190.png">

Это облегченная, более надежная версия Maxim Mk I, разработанная для британской армии. Усердно работал во обе Мировые Войны и в большинстве конфликтов того времени. Часто использовался против авиации - был причиной "Красного Барона" Манфреда фон Рихтгофена от рук Австралийской Армии. Так-же выпускался в Австралии, Индии и США, и поставлялся от Абисинии и Ирака до Новой Зеландии и Пакистана. Британия отправила его на покой в 1968, но он использовался в Африке до 1980х.

Использует незъемные ленты по 20 патронов (16 lbs или 22 lbs в деревянном ящике). Рубашка водяного охлаждения на 4.5 л. Устанавливается на трипод (51 Lbs $2,700) В 1942 Британская армия начала использовать сверх мощный патрон  .303 British с полностью оптикаемой пулей:  Dmg 7d-1 pi, Range 1,100/4,500. 

Экспортировался под маркой Vickers Class C. Голландская Ост-Индия использовала патрон 6.5x53mmR Mannlicher (Dmg 6d pi); Аргентина и Боливия 7.65x53mm Mauser (Dmg 6d+2 pi); а Россия 7.62x54mmR Mosin-Nagant (Dmg 7d pi).

Часто устанавливался на авиацию. Vickers Mk II (1917-1927) был воздушного охлаждения с большей скорострельностью EWt. 22, RoF 14! (RoF 10! если синхронизирован). Экспортировался под маркой Vickers Class E. Бразилия, Чили и Вьетнам приобретали 7x57mm Mauser (Dmg 6d+2 pi); Аргентина, Боливия и Перу 7.65x53mm Mauser (Dmg 6d+2 pi); Турция 7.92x57mm Mauser (Dmg 7d pi); Дания 8x58mmR Krag (Dmg 7d pi). Япония копировала  .303 British.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,500</value>
	<weight>40/16</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>pi</damage>
		<strength>18M</strength>
		<accuracy>6</accuracy>
		<range>800/3,300</range>
		<rate_of_fire>10!</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>.303 6d+2</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Hotchkiss Mle 1914</description>
	<description-loc>Франция 1914

<img data-src="http://weapons.gurps.ru/img/191.png">

Это пулемет с воздушным охлаждением - металлическими дисками вокруг ствола. Оно оставалось стандартным Французским пулеметом до начала Второй Мировой . В Первую Мировую использовался так-же армией США. Американцы прозвали его "Дятел". Экспортировался в Бразилию и Испанию в калибре  7x57mm Mauser (Dmg 6d+2 pi), и в Китай, Грецию и Польшу под 7.92x57mm Mauser (Dmg 7d+1 pi).

Использует 24 патронные металлические полосы вставляемые сбоку (1.5 lbs., или 26.4 lbs. за 12 полос в бочке), так же были полосы по 30 патронов  (1.9 lbs., или 15 lbs. за шесть полос в бочке). Полосы соединялись и получался пояс. Запасной ствол весил 23.3 lbs. Устанавливается на высокий трипод (53 lbs $2,850) часто с металлическим сиденьем для стрелка.

Оригинальный Mitrailleuse Modèle 1897 (1897-1900) был выпущен ограниченным числом в основном Иностранным Легионом EWt. 56, RoF 10!. It had a 36.5-lb. tripod. однако экспортировался под патрон 7x57mm Mauser (Dmg 6d+2 pi) в Чили, Мексику и Испанию. Япония выпускала по лицензии в калибре 6.5x50mmSR Arisaka (Dmg 6d pi).

 Koishikawa 92 Shiki Juukikanjuu (1932-1945) сделан на основе Mle 1897 стал стандартным пулеметом японской армии во Вторую Мировую Войну. Он был калибром 7.7x58mmSR Arisaka: Dmg 6d+2 pi, Range 1,100/4,600, EWt. 60.7/2, RoF 7!, Shots 30(5). Его трипод  61.5-lb. имел разъемы для переносных жердей что позволяло трем солдатам перемещать собранное оружие. Часто снабжался прицелом x4 (+2 Acc)</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,000</value>
	<weight>57.1/1.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>19M</strength>
		<accuracy>6</accuracy>
		<range>1,100/4,800</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>30(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>8x50mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Browning M1917</description>
	<description-loc>США 1917

<img data-src="http://weapons.gurps.ru/img/192.png">

Этот пулемет водяного олаждения первый из длинной линейки пулеметов Браунинга работающих на отдаче. Армия США использовала его главным образом как батальонный пулемет пехоты. Было выпущено около 43,000 единиц.

Стреляет 350 патронными неразъемными лентами (15.3 lbs., или 20.3 lbs. в деревянном ящике) Его водяная рубашка охлаждения содержит 4 л. жидкости. Устанавливается на трипод (61 Lbs $2,700).

Между мировыми войнами экспортировался под маркой Colt MG38 (1924-1943). Бразилия закупала 7x57mm Mauser (Dmg 6d+2 pi), Аргентина Боливия, Парагвай и Перу 7.65x53mm Mauser (Dmg 6d+2 pi). Выпускался по лицензии в Шведции под 6.5x55mm Mauser (Dmg 6d pi) и 8x63mm Bofors (Dmg 7d+1 pi), и Норвегии 7.92x57mm Mauser (Dmg 7d pi). КИтай и Польша копировали 7.92x57mm Mauser.

Во времена Второй Мировой вышла модель M1917A1 (1936-1945): EWt. 40.6. Трипод 53-lb.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,200</value>
	<weight>36.8/15.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>17M</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>10!</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Oerlikon Type S</description>
	<description-loc>Швейцария 1931

<img data-src="http://weapons.gurps.ru/img/193.png">

Продавался по всему миру как авиационный атомический пулемет. Часто устанавливался на двухколесную тележку (570 lbs. вместе с оружием) которая превращалась в трипод в позиции для стрельбы. Подача ведется из 60 патронного барабана (62 lbs) или 15 патронных коробочных магазинов (16 lbs) Стреляет SAPHE-T (в таблице) и API-T (Dmg 6dx2(2) pi++ inc).

Typ SS (1938-1947) улучшенная версия t: EWt.147, RoF 8! ее даже чаще устанавливали на трипод или транспорт (особенно на корабли). Сотни тысяч были выпущены в США и Британии.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>21,000/410</value>
	<weight>135/62</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3 pi++  2d-1 [1d] cr ex</damage>
		<strength>26M</strength>
		<accuracy>6</accuracy>
		<range>1,700/6,400</range>
		<rate_of_fire>5</rate_of_fire>
		<shots>60(5)</shots>
		<bulk>-10</bulk>
		<recoil>3</recoil>
		<ammo>20x110mmRB</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Швейцария</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Browning M1919A4</description>
	<description-loc>США 1934

<img data-src="http://weapons.gurps.ru/img/194.png">

<img data-src="http://weapons.gurps.ru/img/607.png">

Это оружие на основе Browning 1917 но с укороченным стволом и без водяного охлаждения. Хотя разрабатывался как танковое оружие (и устанавливался на некоторые танки) он был достаточно легок, для транспортировки быстро перемещающимися отрядами. Он стал стандартным пулеметом Американской пехоты. После Второй Мировой избыток оружия экспортировался по всему миру до конца 20 века. Более полу миллиона было выпущено, большая часть в Канаде. Постепенно армии США, Канады, Израиля и Южной Африки и прочие переходили на калибр 7.62x51mm NATO (Dmg 7d pi).

Использует неразъемные ленты на 250 патронов (15.3 lbs., или 18.8 lbs. в бочке). Запасной ствол весит 7.4 lbs. Для замены необходимы асбестовые перчатки. Часто стреляет патроном AP-T (Dmg 5d(2) pi- inc). Устанавливается на трипод 14 lbs. $2,550.

Оригинальный M1919 (1919-1920) предназначен для ранних танков: Dmg 7d-1, EWt. 33.

Colt MG32 (1932-1943) - довоенная экспортная версия M1919A4

M1919A6 (1943-1954) был безнадежной попыткой превратить M1919A4 в ручной пулемет - добавили сошки, приклад и ручку для переноски: Wt. 47.8/15.3, Bulk -8, ST 13B†. У него не было очень ствола "extra heawy". Ни смотря на это он был слишком большой и громоздкий для этой роли. Использовался во Вторую Мировую и в Корее.

M2 (1931-1945)  калибром .30 последняя и самая удачная модель из нескольких моделей для авиации выпускающихся с 1918., легкая и с хорошей скорострельностью EWt. 21.5, RoF 20! (RoF 12! если синхронизирован).  Устанавливался на многие ранние самолеты США. Было выпущено 193,000 единиц.

Colt MG40 (1932-1943) экспортный вариант M2 выпускался в нескольких калибрах, самый популярный 7.92x57mm Mauser: Dmg 7d pi, EWt. 21.5, RoF 20!. Великобритания использовала .303 British под маркой  Browning Mk II (1938-1945), он стал стандартным авиационным пулеметом начала Второй Мировой: Dmg 6d+2 pi, EWt. 25.3, RoF 19! (RoF 12! если синхронизирован).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,700</value>
	<weight>30.9/15.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>17M</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,500</range>
		<rate_of_fire>10!</rate_of_fire>
		<shots>250(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>.30-06</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Browning M2HB</description>
	<description-loc>США 1938

<img data-src="http://weapons.gurps.ru/img/195.png">

Во время первой мировой Джон Браунинг начал работу над тяжелым пулеметом переходя от калибра .30 к .50 базируясь на патронах Mauser Tank-Gewehr. В 1933 оружие было усовершенствовано до M2, сделано так, что можно осуществлять подачу с любой стороны. Основной наземной версией стал M2HB  1938 года, который получил удлиненный тяжелый ствол для длительной стрельбы. 

Это была очень удачная модель. Стало стандартным зенитными и противо-автомобильным орудием армии США, использовалась на триподе (44 lbs, $3,500), на лодках, танках грузовиках хамви и джипах. Было выпущено пол миллиона во время Второй Мировой и выпускалось до 1979. Оружие широко экспортировалось и выпускалось по лицензии в Бельгии, Японии, Южной Корее, Тайване и Британии.

Исходно использовал 105 патронные разъемные ленты  (31.8 lbs., 36.2 lbs. в бочке, или 95.6 lbs. две ленты в бочке). После 1945 соединяемый 100 патронные  (30.3 lbs., или 34.7 lbs. в бочке). В 1990х появились 225 патронные ленты  (68.2 lbs., или 73.7 lbs в бочке). Кроме твердого патрона (в таблице) часто использовался API-T (Dmg 5dx2(2) pi inc). APHEXT (Dmg 7dx2(2) pi  1d-2 [1d-2] cr ex) c 1980x, и APDS-T (Dmg 6dx3(2) pi inc) с 1993.

Сменный ствол 27 lbs. C 1978 часто устанавливается прицел ночного видения x6.6 (7.5 lbs (+2 Acc, Night Vision 5, 2xXS/30 час.), или с 1997 тепловизор x10 (+3 Acc, Infravision, M/12 час.) Так-же в 1997 доступен компьютерный прицел (11 lbs, +2 Acc прицел , +3 Acc за лазерный дальномер , Night Vision 7, +1 Gunner, HT157).

M2 (1933-1945) калибра .50 авиационная версия которая устанавливалась фактически на все самолеты США во время Второй Мировой: Dmg 6dx2 pi+, Range 1,700/7,100, EWt. 64, RoF 13!, Bulk -8. экспортировалась под маркой Colt MG53.

FN-Browning M3P (1984-) улучшенный Бельгийский вариант для транспорта: Dmg 6dx2 pi+, Range 1,700/7,100, EWt. 80, RoF 18!, Bulk -8. Армия США приняла его на вооружение под именем M296. M3M (1984-) то-же оружие для ручной стрельбы с двери (вертолета): EWt. 77. Так-же называлось GAU-21/A.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>15,000</value>
	<weight>84/35</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx2 pi+</damage>
		<strength>21M</strength>
		<accuracy>5</accuracy>
		<range>1,800/7,600</range>
		<rate_of_fire>8</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-9</bulk>
		<recoil>2</recoil>
		<ammo>.50 Browning</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пулемёт Дегтярёва ДШК-38</description>
	<description-loc>Россия / СССР 1938

<img data-src="http://weapons.gurps.ru/img/196.png">

Точнее Пулемет Дегтярева и Шпагина Советский аналог Браунинга .50 калибра. Использует разъемные ленты по 50 патронов (16.9 lbs., или 21 lbs. в бочке). Так-же доступны патроны API-T (Dmg 5dx2(2) pi inc), APHC-T (Dmg 7dx2(2) pi inc), и SAPHE-T (Dmg 7dx2 pi+  1d [1d-2] cr ex). Запасной ствол весит 28lbs. Часто устанавливается на двухколесную тележку 266 lbs с возможностью установки щита с DR25 который можно поднять для зенитного огня.

ДШКМ (1946-1980) пост военная версия распространенная по всему миру, использовался и как танковый пулемет: EWt. 78.5. Производился в Болгарии, Китае, Чехословакии, Иране, Казахстане, Пакистане, Польше и Румынии. Китай выпускал для них патроны APDS-T (Dmg 6dx3(2) pi inc)  с 1990х.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>12,000</value>
	<weight>73.3/16.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx2 pi+</damage>
		<strength>20M</strength>
		<accuracy>5</accuracy>
		<range>1,800/7,700</range>
		<rate_of_fire>8!</rate_of_fire>
		<shots>50(5)</shots>
		<bulk>-9</bulk>
		<recoil>2</recoil>
		<ammo>12.7x108mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Mauser MG151/20</description>
	<description-loc>Германия 1941

<img data-src="http://weapons.gurps.ru/img/197.png">

Во время Второй Мировой устанавливался на многие нацистские боевые воздушные суда а так-же на некоторые Итальянские, Японские и Румынские. Позже использовался как зенитная артиллерия и устанавливался на скоростные лодки. Было выпущено 36,000 штук. После войны  Франция и Южная Африка выпускала копии и использовали их как дверное вертолетное орудие.

Использует разъемные ленты (60.3 lbs. - 125 патронов, или 110 - 200 патронов в деревянном ящике). Кроме SAPHE-T (в таблице), стреляет AP-T (Dmg 5dx2(2) pi++ inc) и SAPHEC-SD (Dmg 7dx2 pi++  3d cr ex, Range 1,200), последнее для боя воздух-воздух (RoF 10! если синхронизировано).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>14,700</value>
	<weight>92.4/48.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx2 pi++ 2d [1d] cr ex</damage>
		<strength>22M</strength>
		<accuracy>5</accuracy>
		<range>1,200/6,900</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-9</bulk>
		<recoil>2</recoil>
		<ammo>20x82mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Крупнокалиберный пулемёт Владимирова КПВ</description>
	<description-loc>Россия / СССР 1944

<img data-src="http://weapons.gurps.ru/img/198.png">

Стреляет патроном 14.5x114mm исходно разработанными для противотанковых орудий в 1930х. В первую очередь использовалось как зенитное орудие в один два и четыре ствола и в одно и двух стольном варианте на водных судах. Его вес делает его редким гостем у пехоты, но любой воздушный налет на Советский аэродром или ракетный склад встречал их. Их так-же выпускали в Китае и Северной Корее, и распространяли по всему миру.

Использует разъемные ленты по 40 патронов  (20.9 lbs., или 25 lbs. в бочке). Стреляет  APHCI-T (в таблице) и SAPHE-T (Dmg 6dx3 pi+ 1d+1 [1d-1] cr ex). 

ЗПУ-1 (Зенитно Пулеметная Установка) была не двухколесной тележке (960 lbs вместе с орудием) с сидением для стрелка. Разбиралась на пять частей чтобы перевозить на вьючных животных или в грузовичках.

КПВТ (1947-) Вариант для бронированной техники: EWt. 115.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>18,000</value>
	<weight>108/20.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8dx2(2)pi inc</damage>
		<strength>23M</strength>
		<accuracy>6</accuracy>
		<range>2,100/8,800</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>40(5)</shots>
		<bulk>-9</bulk>
		<recoil>2</recoil>
		<ammo>14.5x114mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GE M61A1 Vilcan</description>
	<description-loc>США 1964

<img data-src="http://weapons.gurps.ru/img/199.png">

<img data-src="http://weapons.gurps.ru/img/610.png">

<img data-src="http://weapons.gurps.ru/img/611.png">

Очень надежный, не клинит при критах если нормально обсужен

Требует батарей



После Второй Мировой ВВС США задумалась о новом скорострельном авиационном пулемете на базе конструкции Готлинга. В 1956 был принят на вооружение M61 Vulcan: очень мощная пушка с шестью вращающимися стволами с подачей с разъемных лент. Вскоре M61A1 заменила его получила беззвеньевую систему подачи патронов для большей надежности и скорострельности. Выпускался по лицензии в Японии.

Как и большинство современных авиационных пушек, имеет два режима огня RoF 66! и RoF 100! (оригинальная M61 стреляла только с RoF 66!). Некоторые версии стреляли с другой скоростью, примеру на самолетах AC-130E и AC-130H это орудие использовалось с  RoF 41! Барабанный магазин с внешним электропитанием держал без звеньевые патроны. Его емкость варьировалась в зависимости от большинство истребителей несли 500-1,000 патронов. Кроме SAPHE (в таблице), стреляла API (Dmg 6dx2(2) pi++ inc) и APEX (Dmg 6dx2(2) pi++  1d+2 [1d] cr ex). После 1988, появилась аэродинамическая SAPHE (Range 1,650/6,900). Требует 26 kW электро питания.

MK 15 MOD 0 Phalanx используется на судах как оружие ближнего боя, стреляет APDSDU

(Dmg 7dx4(2) pi+ inc, Range 1,800/7,700) c фиксированным RoF 50!.

M168 (1968-1982) минорная версия - устанавливалась на бронетраспортерах для защиты от воздуха. Стреляет RoF 16! и RoF 50!.

M197 Vulcan (1969-) облегченный вариант с тремя стволами: Wt. 146, RoF 12!/25!, ST 24M, Bulk -10.  требуется всего 2.2kW энергии. Разработана для вертолетов.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>40,000</value>
	<weight>251/Var.</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3 pi++  2d [1d] cr ex</damage>
		<strength>29M</strength>
		<accuracy>5</accuracy>
		<range>1,250/5,300</range>
		<rate_of_fire>66!/100!</rate_of_fire>
		<shots>Var.</shots>
		<bulk>-11</bulk>
		<recoil>2</recoil>
		<ammo>20x102mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GE M61A1 Vilcan (M197 Vulcan)</description>
	<description-loc>США 1964

<img data-src="http://weapons.gurps.ru/img/199.png">

<img data-src="http://weapons.gurps.ru/img/610.png">

<img data-src="http://weapons.gurps.ru/img/611.png">

Очень надежный, не клинит при критах если нормально обсужен

Требует батарей



После Второй Мировой ВВС США задумалась о новом скорострельном авиационном пулемете на базе конструкции Готлинга. В 1956 был принят на вооружение M61 Vulcan: очень мощная пушка с шестью вращающимися стволами с подачей с разъемных лент. Вскоре M61A1 заменила его получила беззвеньевую систему подачи патронов для большей надежности и скорострельности. Выпускался по лицензии в Японии.

Как и большинство современных авиационных пушек, имеет два режима огня RoF 66! и RoF 100! (оригинальная M61 стреляла только с RoF 66!). Некоторые версии стреляли с другой скоростью, примеру на самолетах AC-130E и AC-130H это орудие использовалось с  RoF 41! Барабанный магазин с внешним электропитанием держал без звеньевые патроны. Его емкость варьировалась в зависимости от большинство истребителей несли 500-1,000 патронов. Кроме SAPHE (в таблице), стреляла API (Dmg 6dx2(2) pi++ inc) и APEX (Dmg 6dx2(2) pi++  1d+2 [1d] cr ex). После 1988, появилась аэродинамическая SAPHE (Range 1,650/6,900). Требует 26 kW электро питания.

MK 15 MOD 0 Phalanx используется на судах как оружие ближнего боя, стреляет APDSDU

(Dmg 7dx4(2) pi+ inc, Range 1,800/7,700) c фиксированным RoF 50!.

M168 (1968-1982) минорная версия - устанавливалась на бронетраспортерах для защиты от воздуха. Стреляет RoF 16! и RoF 50!.

M197 Vulcan (1969-) облегченный вариант с тремя стволами: Wt. 146, RoF 12!/25!, ST 24M, Bulk -10.  требуется всего 2.2kW энергии. Разработана для вертолетов.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>40,000</value>
	<weight>146</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3 pi++  2d [1d] cr ex</damage>
		<strength>24M</strength>
		<accuracy>5</accuracy>
		<range>1,250/5,300</range>
		<rate_of_fire>12!/25!</rate_of_fire>
		<shots>Var.</shots>
		<bulk>-10</bulk>
		<recoil>2</recoil>
		<ammo>20x102mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GE M134</description>
	<description-loc>США 1964

<img data-src="http://weapons.gurps.ru/img/200.png">

Очень надежный, не клинит при критах если нормально обсужен

Требует батарей



Фактически это уменьшенная версия "Вулкана" (M61A1), но он все-же очень мощное шестиствольное оружие. Разрабатывался для экипировки вертолетов в Вьетнамской Войне. "морские котики" использовали их на лодках, а спецподразделения на Хамиви.

Подача ведется с разъемной ленты обычно с несколькими тысячами патронов (204 lbs. лента на 3,000 патронов в бочке, 322 lbs. лента на 4,500 патронов в бочке). Имеет два режим огня RoF 33! и RoF 66! Требует 2.2kW электроэнергии, которая поступает от электро сети судна или из отдельного батарейного блока (35 lbs, 3xL/6,000 выстрелов).

ВВС устанавливала очень похожие GAU-2B/A (1964-1973) на вертолеты, штурмовики и пр. Имело RoF 50! и RoF 100!. Требовал 3.6 kW энергии.

Dillon M134DT (2006-) облегченная версия из титана EWt. 53.1, RoF 50!, Cost $25,000.

M134 стало стал знаменит благодаря использованию в качестве ручного оружия (не реалистичному) в фильмах "Хищник" и "Терминатор 2". Его закрепили с помощью самодельных ремней и рукоятки - должен был иметь характеристики EWt. 65, RoF 30!, ST 16†, Rcl 3, Cost $25,000. Плюс пояс из батарей от видеокамер 12 lbs  (5xM/2,000 выстрелов) и кабеля, 4-lb. желоб для патронов, 37-lb. бочонок патронов (400 штук), и 4-lb. рама в рюкзаке все в месте весило бы 122 lbs</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>20,000</value>
	<weight>61/322</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>20M</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>33!/66!</rate_of_fire>
		<shots>4,500(10)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>НСВ-12.7 «Утёс»</description>
	<description-loc>Россия / СССР 1972

<img data-src="http://weapons.gurps.ru/img/201.png">

Он заменил ДШК в качестве стандартного зенитного пулемета на Советских танках . Широко экспортировался, выпускался в Болгарии, Иране, Казахстане, Польше, Украине и Югославии.

Стреляет с 50 патронной размыкаемой ленты (16.9 lbs., или 24.4 lbs. в банке). Сменный ствол весит 19.8 lbs.

Установленное на трипод (35 lbs, $2,850) уже называется по другому - НСВС-12.7 используется пехотой, комплектуется прицелом 3-6x (3.7 lbs, +2 Acc). Так-же можно установить 6.4х прибор ночного видения (7 lbs, +2 Acc, Night Vision 5, 2xXS/25 час.)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>14,000</value>
	<weight>55/16.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx2 pi+</damage>
		<strength>19M</strength>
		<accuracy>5+2</accuracy>
		<range>1,800/7,700</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>50(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>12.7x108mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Hughes M242</description>
	<description-loc>США 1981

<img data-src="http://weapons.gurps.ru/img/202.png">

Очень надежный, не клинит при критах если нормально обслужен

Требует батарей



Пулемет с вешним электро питанием, для стрельбы используются две цепи внутри конструкции, за что пролечил название "Chain Gun" (цепоной пулемет). Устанавливался на бронемашинах Армии США и Морского Флота. Так-же использовалось под маркой MK 38 MOD 0. Было выпущено более 10,000 единиц, и широко экспортировалось.

Две подачи, что позволяет переключаться с ленты одного типа боеприпасов на другую (Ready маневр). Использует разъемные ленты идут сегментами по 15 патронов (19 lbs., или 47.7 lbs. за

30 патронов в бочке). В дополнение к SAPHE-SD-T (в таблице), стреляет APDS-T (Dmg 6dx5(2) pi+ inc, Range 3,200/16,500), APFSDSDU-T (Dmg 6dx8(2) pi inc, Range 4,200/17,600), а флот использует APDU-T (Dmg 6dx5(2) pi++ inc, Range 2,100/8,800).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>60,000</value>
	<weight>244/38</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx4 pi++   3d+2 [1d+1] cr ex</damage>
		<strength>28M</strength>
		<accuracy>6+3</accuracy>
		<range>2,400/3,300</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>30(5)</shots>
		<bulk>-11</bulk>
		<recoil>2</recoil>
		<ammo>25x137mm</ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Madsen M/03</description>
	<description-loc>Дания 1903

<img data-src="http://weapons.gurps.ru/img/203.png">

Это самый распространенный (хотя и не самый многочисленный) ручной пулемет в мире в первой половине 20-го века.  Был на вооружении в 34 странах не смотря на свою сложность и высокую цену. Датская армейская модель называлась Maskingevær M/03. Имел 30 патронный магазин вставляющийся сверху. Экспортный модели иногда шли с магазинами на 24, 25 или 48 патронов.

Датская Ост-Индия закупала калибр 6.5x53mmR Mannlicher (Dmg 6d pi); Норвегия и Шведция 6.5x55mm Mauser (Dmg 6d pi); Бразилия, Мексика и Испания 7x57mm Mauser (Dmg 6d+2 pi); Россия 7.62x54mmR MosinNagant (Dmg 7d pi); Аргентина, Боливия и Парагвай 7.65x53mm Mauser (Dmg 6d+2 pi); Пакистан .303 British (Dmg 6d+2 pi); Абисиния, Китай, Германия и Турция 7.92x57mm Mauser (Dmg 7d pi). После Второй Мировой Бразилия, Дания, Индонезия и Таиланд перешли на .30-06 (Dmg 7d+1 pi). Производство было прекращено в 1955. Но в 1960х его использовали в менее развитых частях света ванные, партизаны, полиция и бандиты.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>4,500/35</value>
	<weight>25.4/2.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>7!</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>8x58mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Дания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Lewis Mk I</description>
	<description-loc>Великобритания 1914

<img data-src="http://weapons.gurps.ru/img/204.png">

Разработан американцем Исааком Левисом и представлен в 1911 этот пулемет был достаточно легок чтобы стрелять и носить его одному человеку. У него характерный силуэт - алюминиевая рубашка охлаждения вокруг ствола и плоский сверху лежащий барабан на 47 патронов. Первое оружие выпустили в Бельгии, но скоро Британия приняла их на вооружение и под маркой Lewis Mk I. Широко использовался до 1930х. ВО Второй Мировой Войне часто пользовался как легкое зенитное оружие но торговых судах и легких лодках, и выпускался для отрядов британской самообороны.

Это было первое орудие для стрельбы с аэропланов, первый прототип встал на вооружение еще в 1912. Отдельная версия для воздушных судов называлась  Lewis Mk II (1915-1930) - без приклада и рубашки охлаждения: EWt. 18.5. С 1916 использует круглый барабан на 97 патронов (8.9 lbs). Устанавливался как поворотное орудие. В фильме "мумия" с него даже стреляли как из ручного оружия: ST 13†, Bulk -6, Rcl 3.

Savage-Lewis M1918 (1918) - американская версия авиационного орудия под .30-06: Dmg 7d+1 pi, EWt. 22.9.

Vickers G.O. Mk I (1937-1942) еще известный как Vickers Class K не родственный но очень похожий по назначению заменил Lawise в ВВС: EWt. 20.5, RoF 16!, Shots 96(5). Использовался в качестве наводимого вручную орудия на авиации и наземных машинах.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>3,000/260</value>
	<weight>32.8/4.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>800/3,300</range>
		<rate_of_fire>9!</rate_of_fire>
		<shots>47(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>.303</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ZB ZB26</description>
	<description-loc>Чехословакия 1927

<img data-src="http://weapons.gurps.ru/img/205.png">

Один из самых успешных ручных пулеметов в мире. Разработан арсеналом в Бруно и принят на вооружения чехословакской  армией и экспортировался по всему миру. Покупателями были такие страны как Китай, Персия, и Югославия. Бразилия использовала калибр 7x57mm Mauser (Dmg 6d+2 pi). Было выпущено 150,000 штук.

Воздушного охлаждения с сошками, он использовал 20 патронный съемный коробочный магазин, вставляемый сверху. Запасной ствол весил 5.5 lbs.

 ZB30 (1930-1941) Немного доработанный Wt. 23/1.8 он был даже более популярен. Во время Второй Мировой немецкие войска, а особенно СС использовали трофейные ZB. Румыния выпускала их по лицензии. Боливия покупала в калибре 7.65x53mm Mauser (Dmg 6d+2 pi) а Болгария 8x50mmR Mannlicher (Dmg 6d+1 pi).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>4,100/31</value>
	<weight>21.2/1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,400</range>
		<rate_of_fire>8</rate_of_fire>
		<shots>20(3)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Чехословакия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Дегтярева Пехотный (ДП)</description>
	<description-loc>Россия / СССР 1928

<img data-src="http://weapons.gurps.ru/img/206.png">

Простой ручной пулемет с с отличной репутацией за надежность и простое обслуживание. Плоский барабан сверху дал кличку "русская гитара". Он заменил Madsen в советской армии, использовавшей его до 1950х. Широко экспортировался, в гражданской войне Испании им экипировались "Лоялисты" а так-же Вьетконговцы в 1960х. Так-же выпускался в Китае.

Имел воздушное охлаждение и сошки. В барабане по кругу были уложены 47 патронов. Сменный ствол 4.4 lbs.

ДТ (1929-1946)  танковая версия устанавливалась на многие Советские автомобили. Имела выдвижной приклад, утяжеленный ствол и 63 патронный барабан: EWt. 23.1. Так-же можно было подсоединить сошки для использования вне техники:  Wt. 30/5, Shots 63(5), Bulk -7*. Многие использовались пехотой и партизанами (магазины не взаимозаменяемы с ДП)

ДА (1929-1936) авиационная версия так-же использовала 63 патронный барабан: EWt. 18.5. Использовалась в Советской авиации в 1930х.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>3,000/260</value>
	<weight>26.2/6.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>9</rate_of_fire>
		<shots>47(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Rheinmetall MG34</description>
	<description-loc>Германия 1936

<img data-src="http://weapons.gurps.ru/img/207.png">

Это был первый многоцелевой пулемет - мог использоваться и пехотой и устанавливаться на трипод и как зенитное оружие, с транспорта (включая корабли и подводные лодки) а так-же в укреплениях. Лишенный водяного охлаждения был снабжен двумя запасными стволами, которые носил помощник пулеметчика, ствол можно было быстро заменить (шесть секунд) бы избежать ожогов при длительной стрельбе.  Во время Второй Мировой Войны Германия, Венгрия и Румыния использовали MG34. После 1945 использовался во Франции, Израиле, Биафре и Вьетконге. Было выпущено 400,000 единиц.

Подача осуществляется с 50 патронных неразмыкаемых лент (3 lbs, или 5 lbs в барабане), которые можно соединить в один длинный (23.5 lbs на 300 патронов в бочке). Оружие используемое на танках стреляло с 150 патронных лент в мешке. Если заменить крышку ресивера (6 секунд) мог использовать 75 патронные двубарабанные сабельные магазины (9.5 lbs редки после 1940) вместо лент. У курка центр был посередине - нажатие на верхнюю часть позволяло стрелять в полу автоматическом режиме, для стрельбы в полностью автоматическом режиме курок давили как обычно, в нижнюю часть. Часто использовали APHC-T (Dmg 7d+1(2) pi- inc). Сменный ствол 4.4 lbs. (чемодан с двумя весил 12.5 lbs.); Для замены необходимы асбестовые перчатки. Может быть установлен на трипод (46-lb. $2,600) сов строенным x4 прицелом (+2 Acc).

MG15 (1932-1942) устанавливался как подвижный пулемет на многие самолеты Германии: Dmg 7d+1 pi, EWt. 18, RoF 16!, Bulk -6. Стреляет из 75-патронных сдвоенных сабельных барабанов (9.4 lbs.). Так-же производился в Японии.

MG17 (1934-1942) во Вторую Мировую был стандартным авиационным пулеметом с фиксированной установкой Dmg 7d+1 pi, EWt. 27.7, RoF 20! (RoF 16! если синхронизирован). Использовал разъемные ленты.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>4,200</value>
	<weight>31.6/5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,400</range>
		<rate_of_fire>15</rate_of_fire>
		<shots>50(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield Bren Mk I</description>
	<description-loc>Великобритания 1938

<img data-src="http://weapons.gurps.ru/img/208.png">

В 1930x Британия представила ZB30 калибра .303 И он выпускался по лицензии на заводе Энфильд с 19308 Bren это акроним "Бруно и Энфилд". Было выпущено около 300,000 единиц. Так-же выпускался в Австралии, Канаде и Индии.

Стал стандартными Ручным Пулеметом Британии во времена Второй Мировой. Устанавливался на транспорт, часто на танки в качестве зенитного оружия. Команда могла легко отсоединить его когда необходимо покинуть машину.

Использовал 30 патронный магазин, вставляемый сверху. Плоский 100 патронный барабан (12 lbs) использовался на танках. Запасной ствол 6.3 lbs. Британцы обычно использовали его с сошек, но существовал и трипод (30 lbs, $1,800).

L4A4 (1960-1961) это конвертация под патрон 7.62x51mm NATO: Dmg 7d pi, Wt. 23.6/2.6. Подходил магазин на 20 патронов от  винтовки FN FAL L1A1. Было выпущено 7,500, так-же выпускался в Индии.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>5,000/33</value>
	<weight>25.6/2.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>800/3,300</range>
		<rate_of_fire>8</rate_of_fire>
		<shots>30(3)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>.303</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Rheinmetall MG42</description>
	<description-loc>Германия 1942

<img data-src="http://weapons.gurps.ru/img/209.png">

Хотя MG34 полностью устраивал всех в полевых условиях, он был дорог и медлителен в производстве. MG42 разрабатывался ему на замену, был проще благодаря использованию штампованных конструкций. Было выпущено более 350,000 единиц. Был знаменит за высокую скорострельность, его характерный звук сливался с непрерывный стрекот.

Использовал 50 патронные неразъемные ленты (3 Lbs или 5lbs в барабане) которые можно было соединить чтобы образовалась более длинная лента (23.5 lbs. за 300 патронов в бочке) Запасной ствол весил 4 lbs (чемодан с двумя весил 11.7 lbs) И менялся за 3 секунды (но нужно одевать асбестовую перчатку). Часто стреляло AP-T (Dmg 5d-1(2) pi- inc). Для длительной стрельбы устанавливался на трипод (46-lb. $2,600) с встроенным x4 прицелом (+2 Acc).

После Второй Мировой выпускался под калибр 7.62x51mm NATO под маркой MG42/59 (1959-1968), в Германии назвался MG1: Dmg 7d-1 pi, Wt. 27.6/3.3. Выпускался по лицензии в Австрии и Италии (эта версия имела RoF 13!), и в Пакистане.

MG3 (1968-1979) так-же использовал патрон 7.62x51mm NATO: Wt. 27.6/3.3. он до сих пор на вооружении по всему миру и выпускался по лицензии а Греции, Иране, Пакистане, Испании и Турции. Может стрелять разъемными и не разъемными лентами 50 патронов (3.3 lbs., или 3.7 lbs. в барабане), 120 патронов (7.9 lbs., или 8.6 lbs. в бочке), и 250 патронов (16.5 lbs., или

20 lbs. в бочке).

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>3,400</value>
	<weight>30.5/5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d-1 pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,400</range>
		<rate_of_fire>20!</rate_of_fire>
		<shots>50(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.92x57mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ручной Пулемёт Дегтярёва РПД</description>
	<description-loc>Россия / СССР 1948

<img data-src="http://weapons.gurps.ru/img/210.png">

В 1948 Советский Союз принял на вооружение пулемет на сошках среднего калибра (патрон от винтовок АК и СКС), а механизм от ДП, но питался он от 100 патронной неразъемной ленты  (4.1 lbs., или 5.3 lbs. в барабане). В результате получился точный легкий автоматический пулемет. Широко экспортировался и выпускался по лицензии в Китае, Египте, Венгрии и Северной Корее. Спец подразделения США иногда использовали его во Вьетнаме.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>1,500</value>
	<weight>16.3/5.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>10B†</strength>
		<accuracy>5</accuracy>
		<range>600/3,900</range>
		<rate_of_fire>11!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Saco M60</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/211.png">

<img data-src="http://weapons.gurps.ru/img/609.png">

Армия США использовала этот многоцелевой пулемет десятилетия, он был легче конкурентов но был не очень надежен. Американские пулеметчики часто называли его "свинка". Так-же они ругали его "не безупречную" эргономику - расположение сошек, передней мушки и разовой систему не разборной со стволом. Горячий пулемет не мог стоять без ствола, и помощнику приходилось тащить тяжеленный запасной. Несколько стран выбрали M60 и США широко распространила его среди своих союзников в Центральную Америку и Южную Азию. Выпускался по лицензии на Тайване.

Использовал 100 патронные разъемные ленты (6.6 lbs., 7

lbs. в нейлоновом чехле, или 18.7 lbs. две ленты в бочке). Запасной ствол весили 8.2 lbs, для замены необходима асбестовая перчатка. Трипод (15 lbs, $1,800) позволял использовать его стационарно. С 1978 часто комплектовался прицелом ночного видения x4 (+2 Acc, Night Vision 5, 2xXS/30 час.)

M60C (1962-1983) с дистанционной стрельбой использовался на вертолетах и легких самолетах:  EWt. 24.

M60D (1962-1983) имеет сдвоенные ручки сзади для использования в двери вертолета или на танковой турели: EWt. 24.3. У него есть сошки для экстренного использования вне транспорта.

M60E3 (1983-) улучшенная версия: Wt. 26.3, Cost $10,500. Добавлена пистолетная ручка, и легкий ствол, упрощена замена стволов, облегченные сошки и улучшенная система подачи. Для штурмовых групп существует короткий ствол: Dmg 7d-1 pi, Range 900/3,750, Wt. 26, Bulk -6. Морские котики использовали его с 1985 до 1990х.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>6,000</value>
	<weight>29.6/6.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>9!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Saco M60 (M60E3 short)</description>
	<description-loc>США 1957

<img data-src="http://weapons.gurps.ru/img/211.png">

<img data-src="http://weapons.gurps.ru/img/609.png">

Армия США использовала этот многоцелевой пулемет десятилетия, он был легче конкурентов но был не очень надежен. Американские пулеметчики часто называли его "свинка". Так-же они ругали его "не безупречную" эргономику - расположение сошек, передней мушки и разовой систему не разборной со стволом. Горячий пулемет не мог стоять без ствола, и помощнику приходилось тащить тяжеленный запасной. Несколько стран выбрали M60 и США широко распространила его среди своих союзников в Центральную Америку и Южную Азию. Выпускался по лицензии на Тайване.

Использовал 100 патронные разъемные ленты (6.6 lbs., 7

lbs. в нейлоновом чехле, или 18.7 lbs. две ленты в бочке). Запасной ствол весили 8.2 lbs, для замены необходима асбестовая перчатка. Трипод (15 lbs, $1,800) позволял использовать его стационарно. С 1978 часто комплектовался прицелом ночного видения x4 (+2 Acc, Night Vision 5, 2xXS/30 час.)

M60C (1962-1983) с дистанционной стрельбой использовался на вертолетах и легких самолетах:  EWt. 24.

M60D (1962-1983) имеет сдвоенные ручки сзади для использования в двери вертолета или на танковой турели: EWt. 24.3. У него есть сошки для экстренного использования вне транспорта.

M60E3 (1983-) улучшенная версия: Wt. 26.3, Cost $10,500. Добавлена пистолетная ручка, и легкий ствол, упрощена замена стволов, облегченные сошки и улучшенная система подачи. Для штурмовых групп существует короткий ствол: Dmg 7d-1 pi, Range 900/3,750, Wt. 26, Bulk -6. Морские котики использовали его с 1985 до 1990х.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>10,500</value>
	<weight>26</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d-1 pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>900/3,750</range>
		<rate_of_fire>9!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MAG</description>
	<description-loc>Бельгия 1958

<img data-src="http://weapons.gurps.ru/img/212.png">

Mitrailleuse à Gaz - работающий на отводите газов продолжение серии винтовок FN очень успешный многоцелевой пулемет, на вооружен во многих странах, которе не приняли на вооружение ПК или M60 или MG42. Изготавливался в Аргентине, Индии, Израиле, Сингапуре, Швеции, Тайване, Британии и США. Его легко встретить в любой части света.

Использует 100 патронные разъемные ленты (6.6 lbs., или 18.7 lbs. за две ленты в бочке), однако некоторые используют неразъемные ленты. Запасной ствол 6 lbs. Устанавливается на трипод (23 Lbs, $1,800).

Армия США использует M240 (1977-) соосный на бронированной технике: EWt. 24.2.

Морская Пехота США M240G (1994-) идентичен оригинальному MAC он заменил M60E3.

На замену M60 Армия США приобрела M240B (1997-). У него есть теплозащитный экран и полозья для навесного: : EWt. 27.6. Устанавливается на легкий трипод (11.5 Lbs, $2,250) С 1999 часто устанавливают тепловизор x5 (5 lbs, +2 Acc, Infravision, M/12 час.), или оптический прицел x3.4 с 2001 (1.5 lbs, +1 Acc, и уменьшает штраф за темноту на -1, XS/175 час.) В 2006 появилась лента на 50 патронов (3.3 lbs) в мягком (0.2 lbs) мешке.

M240D (1997-) получил задние сдвоенные ручки для установки на танки или вертолетные двери: EWt. 25.6.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>6,900</value>
	<weight>30.5/6.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>12B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пулемёт Калашникова ПК</description>
	<description-loc>Россия / СССР 1961

<img data-src="http://weapons.gurps.ru/img/213.png">

<img data-src="http://weapons.gurps.ru/img/218.png">

Советская армия использовала его как многоцелевой пулемет, это была одна из модификаций АК. Широко экспортировался и выпускался в Болгарии, Китае, Венгрии, Польше, Румынии и Югославии.

Использовал неразъемные ленты по 100  (5.4 lbs., или 8.6 lbs. в бочонке) или 250 патронов (13.4 lbs., или 20.7 lbs. в бочонке).

ПКТ (1962-1969) (Танковый) соосная версия для броне машин.  EWt. 23.1.

ПКМ (1969-) (Модернизированный): Wt. 26/8.6. ПКМС (Стнок) устанавливался на трипод (9.9 lbs $2,500) ПКМТ соосный для бронетехники EWt. 25.8. Серия PKM могла быть снабжена прицелом ночного видения 2.9-lb. 5x (+2 Acc, Night Vision 5, XS/10 hrs.).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,500</value>
	<weight>28.4/8.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d+1 pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,100/4,800</range>
		<rate_of_fire>11!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x54mmR</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MAC AA7.62NF1</description>
	<description-loc>Франция 1963

<img data-src="http://weapons.gurps.ru/img/214.png">

<img data-src="http://weapons.gurps.ru/img/222.png">

Arme Automatique de 7.62N Modèle F1 пулемет с выдвижным прикладом до сих пор является стандартом для Французской армии. Экспортировался по всему миру, особенно в Африку. Использует ленты разъемные ленты на 50 патронов (3.3 lbs., или 18.7 lbs. за ленту в коробе). Может быть установлен на трипод 23-lb. tripod ($1,650). Сущетвуют разничные версии, с  AFV (HT240) имеет усиленный ствол (см  длительный огонь HT85-86) и удаленный курок: EWt. 19.4.

Ее предшественник Arme Automatique Modèle 52 (1952-1963) калибра 7.5x54mm MAS: Dmg 7d pi, Wt. 26.5/3.2, RoF 11, Shots 50(5)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>6,000</value>
	<weight>28.5/6.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>15!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-7*</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K HK21A1</description>
	<description-loc>Германия 1970

<img data-src="http://weapons.gurps.ru/img/215.png">

<img data-src="http://weapons.gurps.ru/img/612.png">

В 1960х H&amp;K разрабатывает семейство легких пулеметов на основе конструкции винтовки G3. Самый распространенный среди них HK21A1, так-же выпускался по лицензии в Греции и Мексике. Подразделение Дельа Армии США использовали их во врем операции "Коготь Орла" в 1980.

Подача с 100 патронных разъемных лент (6.6 lbs., или 7.9 lbs. а бочке). С адаптером ($850) может использовать магазины от G3 (20 патронов, 1.7 lbs) и 50 патронные барабаны (4.3 lbs). Запасной ствол весит 3.7 lbs (три секунды на замену).  Трипод весит 22 lbs ($1,650). Можно вешать навесное от винтовки, допустим прицел x4 (1.4 lbs, +2 Acc).

Оригинальная версия HK21 (1961-1970): Wt. 25.3/7.9, RoF 15. Могла использовать только ленты и медленно перезаряжалась (7 ready маневров). Так-же имела проблемы с надежностью (Malf 16). Выпускалась по лицензии в Португалии.

HK21E (1982-) заменила HK21A1. Получила удлиненный ствол и возможность стрелять очередями по три патрона: Dmg 7d pi, Wt. 27/6.6, RoF 9/13, Bulk -7.

HK23E (1982-2004) то-же оружие но под патрон 5.56x45mm NATO: Dmg 5d-1 pi, Range 750/3,100, Wt. 26.8/7.5, RoF 9/13, Shots 200. С адаптером ($850) может использовать магазины от M16: Wt. 20.3/1, Shots 30+1(3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>5,800</value>
	<weight>26.2/7.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+2 pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>900/3,750</range>
		<rate_of_fire>13</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K HK21A1 (HK21E (1982-))</description>
	<description-loc>Германия 1970

<img data-src="http://weapons.gurps.ru/img/215.png">

<img data-src="http://weapons.gurps.ru/img/612.png">

В 1960х H&amp;K разрабатывает семейство легких пулеметов на основе конструкции винтовки G3. Самый распространенный среди них HK21A1, так-же выпускался по лицензии в Греции и Мексике. Подразделение Дельа Армии США использовали их во врем операции "Коготь Орла" в 1980.

Подача с 100 патронных разъемных лент (6.6 lbs., или 7.9 lbs. а бочке). С адаптером ($850) может использовать магазины от G3 (20 патронов, 1.7 lbs) и 50 патронные барабаны (4.3 lbs). Запасной ствол весит 3.7 lbs (три секунды на замену).  Трипод весит 22 lbs ($1,650). Можно вешать навесное от винтовки, допустим прицел x4 (1.4 lbs, +2 Acc).

Оригинальная версия HK21 (1961-1970): Wt. 25.3/7.9, RoF 15. Могла использовать только ленты и медленно перезаряжалась (7 ready маневров). Так-же имела проблемы с надежностью (Malf 16). Выпускалась по лицензии в Португалии.

HK21E (1982-) заменила HK21A1. Получила удлиненный ствол и возможность стрелять очередями по три патрона: Dmg 7d pi, Wt. 27/6.6, RoF 9/13, Bulk -7.

HK23E (1982-2004) то-же оружие но под патрон 5.56x45mm NATO: Dmg 5d-1 pi, Range 750/3,100, Wt. 26.8/7.5, RoF 9/13, Shots 200. С адаптером ($850) может использовать магазины от M16: Wt. 20.3/1, Shots 30+1(3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>5,800</value>
	<weight>27/6.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>900/3,750</range>
		<rate_of_fire>9/13</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K HK21A1 (HK23E)</description>
	<description-loc>Германия 1970

<img data-src="http://weapons.gurps.ru/img/215.png">

<img data-src="http://weapons.gurps.ru/img/612.png">

В 1960х H&amp;K разрабатывает семейство легких пулеметов на основе конструкции винтовки G3. Самый распространенный среди них HK21A1, так-же выпускался по лицензии в Греции и Мексике. Подразделение Дельа Армии США использовали их во врем операции "Коготь Орла" в 1980.

Подача с 100 патронных разъемных лент (6.6 lbs., или 7.9 lbs. а бочке). С адаптером ($850) может использовать магазины от G3 (20 патронов, 1.7 lbs) и 50 патронные барабаны (4.3 lbs). Запасной ствол весит 3.7 lbs (три секунды на замену).  Трипод весит 22 lbs ($1,650). Можно вешать навесное от винтовки, допустим прицел x4 (1.4 lbs, +2 Acc).

Оригинальная версия HK21 (1961-1970): Wt. 25.3/7.9, RoF 15. Могла использовать только ленты и медленно перезаряжалась (7 ready маневров). Так-же имела проблемы с надежностью (Malf 16). Выпускалась по лицензии в Португалии.

HK21E (1982-) заменила HK21A1. Получила удлиненный ствол и возможность стрелять очередями по три патрона: Dmg 7d pi, Wt. 27/6.6, RoF 9/13, Bulk -7.

HK23E (1982-2004) то-же оружие но под патрон 5.56x45mm NATO: Dmg 5d-1 pi, Range 750/3,100, Wt. 26.8/7.5, RoF 9/13, Shots 200. С адаптером ($850) может использовать магазины от M16: Wt. 20.3/1, Shots 30+1(3).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>5,800</value>
	<weight>26.8/7.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d-1 pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>750/3,100</range>
		<rate_of_fire>9/13</rate_of_fire>
		<shots>200</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MINIMI</description>
	<description-loc>Бельгия 1982

<img data-src="http://weapons.gurps.ru/img/216.png">

<img data-src="http://weapons.gurps.ru/img/614.png">

Mini-Mitrailleuse (мини пулемет) самый распространенный ручной пулемет 21го века. Выпускался в Австралии, Канаде, Греции, Италии, Японии и США. Армия США использует из под именем M249 Squad Automatic Weapon (SAW) с 1984.

Стреляет с 200 патронных разъемных лент (6.4 lbs) в пластиковой бочке (0.6 lbs, -1 к Stealth). Может использовать магазины от M16 что увеличивает скорострельность до 15! но уменьшает Malf до 16. В 1990 появилась 100 патронная лента (3.2 lbs) в 0.2 мягком мешке. Запасной ствол весит 3.5 lbs. С 2001 часто комплектовались прицелом с подсветкой x3.4 (1.5 lbs, +1 Acc и уменьшает штраф за темноту на -1, XS/175 час.)

MINIMI-Para (1985-) для парашютистов с укороченным стволом и выдвижным прикладом: Dmg 4d+2 pi, Acc 4, Range 700/2,900, Wt. 22.7/7, Bulk -6*, Cost $3,700.

MK 46 MOD 0 (2001-) улучшенный вариант для "морских котиков" с укороченным стволом: Dmg 4d+2 pi, Acc 4, Range 750/3,100, Wt. 16/3.4, Shots 100(5), Cost $4,500. Чтобы улучшить надежность у нее убрали возможность подачи с магазина, только лента. Имеет полозья для навесного сверху и по бокам и съемные сошки (1 lbs). Можно установить глушитель (-3 Hearing, -1 Bulk)

MK 48 MOD 0 (2003-) то-же и самое что прошлый только под калибр 7.62x51mm NATO: Dmg 6d+1 pi, Acc 5, Range 900/3,750, Wt. 25.3/6.8, Shots 100(5), Cost $8,000.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>3,300</value>
	<weight>22.6/7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>800/3,500</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>200(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MINIMI (MINIMI-Para)</description>
	<description-loc>Бельгия 1982

<img data-src="http://weapons.gurps.ru/img/216.png">

<img data-src="http://weapons.gurps.ru/img/614.png">

Mini-Mitrailleuse (мини пулемет) самый распространенный ручной пулемет 21го века. Выпускался в Австралии, Канаде, Греции, Италии, Японии и США. Армия США использует из под именем M249 Squad Automatic Weapon (SAW) с 1984.

Стреляет с 200 патронных разъемных лент (6.4 lbs) в пластиковой бочке (0.6 lbs, -1 к Stealth). Может использовать магазины от M16 что увеличивает скорострельность до 15! но уменьшает Malf до 16. В 1990 появилась 100 патронная лента (3.2 lbs) в 0.2 мягком мешке. Запасной ствол весит 3.5 lbs. С 2001 часто комплектовались прицелом с подсветкой x3.4 (1.5 lbs, +1 Acc и уменьшает штраф за темноту на -1, XS/175 час.)

MINIMI-Para (1985-) для парашютистов с укороченным стволом и выдвижным прикладом: Dmg 4d+2 pi, Acc 4, Range 700/2,900, Wt. 22.7/7, Bulk -6*, Cost $3,700.

MK 46 MOD 0 (2001-) улучшенный вариант для "морских котиков" с укороченным стволом: Dmg 4d+2 pi, Acc 4, Range 750/3,100, Wt. 16/3.4, Shots 100(5), Cost $4,500. Чтобы улучшить надежность у нее убрали возможность подачи с магазина, только лента. Имеет полозья для навесного сверху и по бокам и съемные сошки (1 lbs). Можно установить глушитель (-3 Hearing, -1 Bulk)

MK 48 MOD 0 (2003-) то-же и самое что прошлый только под калибр 7.62x51mm NATO: Dmg 6d+1 pi, Acc 5, Range 900/3,750, Wt. 25.3/6.8, Shots 100(5), Cost $8,000.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>3,700</value>
	<weight>22.7/7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>11B†</strength>
		<accuracy>4</accuracy>
		<range>700/2,900</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>200(5)</shots>
		<bulk>-6*</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MINIMI (MK 46 MOD 0)</description>
	<description-loc>Бельгия 1982

<img data-src="http://weapons.gurps.ru/img/216.png">

<img data-src="http://weapons.gurps.ru/img/614.png">

Mini-Mitrailleuse (мини пулемет) самый распространенный ручной пулемет 21го века. Выпускался в Австралии, Канаде, Греции, Италии, Японии и США. Армия США использует из под именем M249 Squad Automatic Weapon (SAW) с 1984.

Стреляет с 200 патронных разъемных лент (6.4 lbs) в пластиковой бочке (0.6 lbs, -1 к Stealth). Может использовать магазины от M16 что увеличивает скорострельность до 15! но уменьшает Malf до 16. В 1990 появилась 100 патронная лента (3.2 lbs) в 0.2 мягком мешке. Запасной ствол весит 3.5 lbs. С 2001 часто комплектовались прицелом с подсветкой x3.4 (1.5 lbs, +1 Acc и уменьшает штраф за темноту на -1, XS/175 час.)

MINIMI-Para (1985-) для парашютистов с укороченным стволом и выдвижным прикладом: Dmg 4d+2 pi, Acc 4, Range 700/2,900, Wt. 22.7/7, Bulk -6*, Cost $3,700.

MK 46 MOD 0 (2001-) улучшенный вариант для "морских котиков" с укороченным стволом: Dmg 4d+2 pi, Acc 4, Range 750/3,100, Wt. 16/3.4, Shots 100(5), Cost $4,500. Чтобы улучшить надежность у нее убрали возможность подачи с магазина, только лента. Имеет полозья для навесного сверху и по бокам и съемные сошки (1 lbs). Можно установить глушитель (-3 Hearing, -1 Bulk)

MK 48 MOD 0 (2003-) то-же и самое что прошлый только под калибр 7.62x51mm NATO: Dmg 6d+1 pi, Acc 5, Range 900/3,750, Wt. 25.3/6.8, Shots 100(5), Cost $8,000.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>4,500</value>
	<weight>16/3.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2 pi</damage>
		<strength>11B†</strength>
		<accuracy>4</accuracy>
		<range>750/3,100</range>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>5.56x45mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FN MINIMI (MK 48 MOD 0)</description>
	<description-loc>Бельгия 1982

<img data-src="http://weapons.gurps.ru/img/216.png">

<img data-src="http://weapons.gurps.ru/img/614.png">

Mini-Mitrailleuse (мини пулемет) самый распространенный ручной пулемет 21го века. Выпускался в Австралии, Канаде, Греции, Италии, Японии и США. Армия США использует из под именем M249 Squad Automatic Weapon (SAW) с 1984.

Стреляет с 200 патронных разъемных лент (6.4 lbs) в пластиковой бочке (0.6 lbs, -1 к Stealth). Может использовать магазины от M16 что увеличивает скорострельность до 15! но уменьшает Malf до 16. В 1990 появилась 100 патронная лента (3.2 lbs) в 0.2 мягком мешке. Запасной ствол весит 3.5 lbs. С 2001 часто комплектовались прицелом с подсветкой x3.4 (1.5 lbs, +1 Acc и уменьшает штраф за темноту на -1, XS/175 час.)

MINIMI-Para (1985-) для парашютистов с укороченным стволом и выдвижным прикладом: Dmg 4d+2 pi, Acc 4, Range 700/2,900, Wt. 22.7/7, Bulk -6*, Cost $3,700.

MK 46 MOD 0 (2001-) улучшенный вариант для "морских котиков" с укороченным стволом: Dmg 4d+2 pi, Acc 4, Range 750/3,100, Wt. 16/3.4, Shots 100(5), Cost $4,500. Чтобы улучшить надежность у нее убрали возможность подачи с магазина, только лента. Имеет полозья для навесного сверху и по бокам и съемные сошки (1 lbs). Можно установить глушитель (-3 Hearing, -1 Bulk)

MK 48 MOD 0 (2003-) то-же и самое что прошлый только под калибр 7.62x51mm NATO: Dmg 6d+1 pi, Acc 5, Range 900/3,750, Wt. 25.3/6.8, Shots 100(5), Cost $8,000.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>8,000</value>
	<weight>25.3/6.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+1 pi</damage>
		<strength>11B†</strength>
		<accuracy>5</accuracy>
		<range>900/3,750</range>
		<rate_of_fire>12!</rate_of_fire>
		<shots>100(5)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>7.62x51mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>АГС-17 Пламя</description>
	<description-loc>Россия / СССР 1971

<img data-src="http://weapons.gurps.ru/img/219.png">

<img data-src="http://weapons.gurps.ru/img/223.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

 

Автоматический Гранатомет Станковый - АГС-17 Пламя - оружие избирательного поражения устанавливается на трипод (26lbs $3,000). Экспортировался по всему миру и производился в Болгарии, Китае и Сербии. Стреляет из 29 патронной ленты (20.2 lbs., или31.9 lbs. в барабане) патрон HE-SD имеет 2.7х прицел (2.2-lb. +1 Acc)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>11,000</value>
	<weight>68/32</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d [1d+2]cr-ex</damage>
		<strength>20M</strength>
		<accuracy>2+1</accuracy>
		<range>35/1,900</range>
		<rate_of_fire>6</rate_of_fire>
		<shots>29(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>30x28mmB </ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Saco MK 19 MOD 3</description>
	<description-loc>США 1980

<img data-src="http://weapons.gurps.ru/img/220.png">

<img data-src="http://weapons.gurps.ru/img/224.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D



Производился в США и большом количестве и на экспорт. Выпускался по лицензии в Египте и Южной Корее. Устанавливался на HMMWV, грузовики, Бронетранспортеры, лодки и вертолеты. 

C адаптером (21-lb), может быть установлен на 44-lb. треногу ($3,500) от Browning M2HB (p. 133).

В MK 19 MOD 3 подаются ленты на 32 патрона  (25.4 lbs., или в коробе 44 lbs.) а так-же на 48 патронов (38 lbs., в коробе 61.6 lbs.). Гранаты HE (Dmg 5d [2d] cr ex), но чаще заряжают HEDP (указано в таблице)

С 2001 так-же MF патроны: Dmg 1d-1 pi-, Range 100/1,200, RoF 6¥115, Rcl 1

C 2002 ABF патрон: Dmg 1d-2 pi-, Range 2,200, RoF 6¥400, Rcl 1

Можно установить ночной прицел 6.5х(+2 Acc, Night Vision 5, 2хXS/30 hrs.) а с 1997, a 5.5-lb. 10х тепловизор (+3 Acc, Infravision, M/12 hrs.).

Оригинальный  NOSL MK 19 MOD 0 (1967), использовался на патрульных лодках во Вьетнамской войне Malf. 16, EWt. 46, RoF 8, стрелял только HE</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>17,500</value>
	<weight>75/44</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d(10) cr-ex + 4d+1 [2d] cr ex</damage>
		<strength>21M</strength>
		<accuracy>2</accuracy>
		<range>35/2,200</range>
		<rate_of_fire>6</rate_of_fire>
		<shots>32(5)</shots>
		<bulk>-8</bulk>
		<recoil>2</recoil>
		<ammo>40x53mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GD M307</description>
	<description-loc>США 2008

<img data-src="http://weapons.gurps.ru/img/221.png">

<img data-src="http://weapons.gurps.ru/img/225.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Полозья для навесного (H161)



Легкий автоматический гранатомет должен был заменить в армии США пулемет M2HB и гранатомет MK 19 MOD 3. Может устанавилватся на трипод (13-lb. $2,550) и на транспорт - грузовики, БТР, лодки, вертолеты. Двойной курок позволяет стрелку мгновенно менять режимы огня.

Подается лента по 31 патрон (13.4 lbs., в барабане 16 lbs.). Стандартный патрон HEDP указан в таблице, так-же стреляет  HE-AB (Dmg 3d [1d+1] cr ex) и термобарическими-AB (Dmg 6d cr ex). Снабжается 3х компьютерным прицелом - 8.6-lb. M/32 hrs. +1 Acc, тепловизором (infravision), и  HUD на лицо выводящим информаци и предлагая балистические решения, а так-же системой лазерного целеуказания (4,400м, +3 Acc и один маневр Ready чтобы использовать), программой автоматического нведения (+1 к умению Gunner один Ready маневр на запуск программы)



Замена ствола, подачи и затвора - (что занимает 5 минут и требует броска Armoury (Heavy Weapons)) и он превращается в пулемёт стреляющий .50 Browning: Dmg 7dx2 pi+, Acc 5+3, Range 1,800/7,600, EWt. 30.6/35, RoF 4, Shots 100(5), ST 16M, Bulk -8, Rcl 2.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>20,000</value>
	<weight>39/16</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4d+2(10) cr-ex + 3d-1 [1d+1] cr ex</damage>
		<strength>17M</strength>
		<accuracy>3+3</accuracy>
		<range>30/2,200</range>
		<rate_of_fire>4</rate_of_fire>
		<shots>31(5)</shots>
		<bulk>-7</bulk>
		<recoil>2</recoil>
		<ammo>25x59mmB </ammo>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<specialization>Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<description>Walther Leuchtpistole</description>
	<value>480</value>
	<weight>1.8/0.2</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>Spec. </damage>
		<strength>8</strength>
		<accuracy>1</accuracy>
		<range>10/330</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>26.5x103mmR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<legality_class>3</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1934
		<img data-src="http://weapons.gurps.ru/img/226.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Кольцо для шнура (HT154)



Leuchtpistole (“Зажигательный пистолет”) гладкоствольный, открываемый “переламыванием” пистолет широко используемый Немецкой Армией и торговым флотом. Сотни тысяч копий были приняты на вооружение другими странам. Существует 40 разных сигнальных патронов в том числе и осветительные (100 метров, 30 сек.), цветные огни, сигнальные дымы, и свистящие патроны.

С 1942 доступны HEAT (Dmg 4d(10) cr ex with 3d cr ex linked), HE (Dmg 2d+1 [1d+1] cr ex), и HE-AB (Dmg 2d+1 [1d+1] cr ex, Range 10) 

HE-AB Были разработаны для обороны мертвых зон танков и бункеров. После выстрела - взрывается в 2 метрах над землей и 10 метрах от стрелка.

Немецкий военно морской флот так-же использует Walther SLD (1936- 1945) - двухствольный пистолет из нержавеющей стали: Wt. 6.3/0.4, RoF 2, Shots 2(3i), Bulk -3, Cost $650. Можно стрелять из обоих стволов без штрафов. Заряженный HE или HEAT становится грозным оружием.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Colt M79</description>
	<value>500</value>
	<weight>6.5/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>8†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-4</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns
</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 1961
		<img data-src="http://weapons.gurps.ru/img/227.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)



Первый современный гранатомет был достаточно простым шарнирно затворным устройством большого калибра,  похожие на одноствольное ружье. Было  на вооружении во Вьетнаме  пока не была вытеснена более новой моделью. около 300 50 тысяч было выпущено экспортировать по всему миру. Также производилось в Южной Африке и Южной Корее.  Может стрелять не только HE - см. список патронов.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Colt M203</description>
	<value>1,250</value>
	<weight>4.1/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>9†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>–</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 1969
		<img data-src="http://weapons.gurps.ru/img/228.png">
		<img data-src="http://weapons.gurps.ru/img/237.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Вешается подствольно, добавляет оружию веса и Bulk -1





Этот гранатометы монтируется под ствол винтовки серии M16. Экспортировался по всему миру. Выпускался по лицензии в Канаде, Китае, Египте, Иране, Италии, Южной Кореи и Турции. Копии часто модифицированный под другие типы винтовок. 

M203PI (1987-) Более гибкая версия  может быть установлено подствольным большое количество орудий, или использоваться без автоматоа. Wt. 2.7/0.5

 The M203A2 (1999-)  Wt. 3.1/0.5.





TAPCO CM2037 (1991-) гладкоствольное под калибр 37x122mmR, А значит что гражданские в США могут покупать ее свободно. : Wt. 4.7/0.37, Cost $225, LC3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Buck HAFLA</description>
	<value>100</value>
	<weight>1.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>[1d(0.2)] burn-ex</damage>
		<strength>5†</strength>
		<accuracy>0</accuracy>
		<range>10/90</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>35mm 1d-2 </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1970
		<img data-src="http://weapons.gurps.ru/img/229.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D



Handflammpatrone (“патроны ручного пламени”) карманный пиропатрон: просто алюминиевая банка выпускающая гранату красного фосфора. Применялся в Бельгийской и Немецкой армии в основном чтобы ослеплять танки. Выдавались в пластиковой упаковке (4.1lbs) по три штуки. Сняты с вооружения в начале 21 века. Складная ручка и курок - надо два маневра Ready чтобы подготовить к стрельбе. Расценивайте снаряд как белый фосфор - (HT172) с 7м облаком на 1 минуту.
	</description-loc>
</equipment>
<equipment version="3">
	<description>H&amp;K HK69A1</description>
	<value>1,550</value>
	<weight>6.3/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>8†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>-4*</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1976
		<img data-src="http://weapons.gurps.ru/img/230.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)



Открывается “переламыванием”, выдвижной приклад  - немецкий аналог M79. Granatpistole - “гранатный пистолет” он же GraPi, на вооружении в Германии с 1970, был вытеснен AG36. Можно носить в поясной кобуре. Засветился в фильме “Ронин”. 

Mehrzweckpistole 1 - “много целевой пистолет 1” или MZP1 вариант для полиции. Бывает в версии 40х46mmSR и 37х122mmR. см. делали в патронах (HT143)
	</description-loc>
</equipment>
<equipment version="3">
	<description>Гранатомет Подствольный ГП-25</description>
	<value>500</value>
	<weight>3.9/0.55</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>[2d] cr-ex</damage>
		<strength>9†</strength>
		<accuracy>1</accuracy>
		<range>25/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>–</bulk>
		<recoil>2</recoil>
		<ammo>40mm 4d+2 </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Россия / СССР 1979
		<img data-src="http://weapons.gurps.ru/img/231.png">
		<img data-src="http://weapons.gurps.ru/img/238.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Вешается подствольно, добавляет оружию веса и Bulk -1



Гранатомет Подствольный ГП-25 вешается на АК-74 и прочие Калашниковы. Экспортировался и производился Болгарией, Пакистаном и Сербией. Заряжается через ствол, а граната безоболоченая - вышибной заряд находится в полости задней части гранаты. 

Стреляет HE (указана в повреждениях), Дымоыми (8м облако на 30сек.), резиновой (Dmg 1d+1(0.5) cr dkb, Range 20/250), и слезоточивым газом (Dmg 1d+1(0.5) cr dkb, 8м облако на 20 сек.).

С 2001, HEDP (Dmg 5d-1(10) cr ex with 4d [2d] cr ex linked).
	</description-loc>
</equipment>
<equipment version="3">
	<description>Milkor MGL</description>
	<value>1,500</value>
	<weight>15.3/3</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>10†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-6*</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Южная Африка</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Южная Африка 1983
		<img data-src="http://weapons.gurps.ru/img/232.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)





Куркового взвода револьверный барабан, складной приклад встроенный коллиматорный прицел (+1 к умению). более 33 000 было сделано да, также копировалась в Индии и Хорватии. во многих полицейских управлениях всего мира используют их. Не может стрелять длинными гранатами. 

MGL-140 (2005-) выпускается по лицензии в США и стоит на вооружении у морской пехоты запятая может стрелять длинными гранатами, имеет полозья для навесного. Wt. 16.2/3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Hawk MM1</description>
	<value>2,000</value>
	<weight>18.5/6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>10†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>12(3i)</shots>
		<bulk>-6</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 1984
		<img data-src="http://weapons.gurps.ru/img/233.png">
		<img data-src="http://weapons.gurps.ru/img/239.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)





Разработана для гражданского использования полицейских, пружинный механизм барабанов на 12 патронов, пистолетная ручка, приклад отсутствует. долго перезаряжается ( три маневры подготовки чтобы положить одну гранату цилиндр, плюс один маневр подготовки если это длинна граната). Версии 40x46mmSR и 37x122mm калибра, но только 37mm может стрелять длинными грантами.

Вариация  Manville Gas Gun (1938-1943), стреляет 1” патроном: Dmg 1d+1(0.5) cr, Range 30/100, Wt. 18.8/3.2, Shots 18(5i), ST 11†, LC4. Доступны только патроны со слезоточивым газом (4-м облако на  20 сек.).
	</description-loc>
</equipment>
<equipment version="3">
	<description>Foster-Miller WebShot</description>
	<value>100</value>
	<weight>1.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>Spec. </damage>
		<strength>6†</strength>
		<accuracy>1</accuracy>
		<range>1/10</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-2</bulk>
		<recoil>2</recoil>
		<ammo>37x122mmR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>США 1999

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Смотри детали в патронах для гранатомета (HT143)

No image!



Одноразовый гранатомет выстраивает  гранату-сеть (HT143) Это заряженный на заводе гладкий ствол со складной пистолетной ручкой и курком. Длиной 30см, требует 2 раунда подготовки к стрельбе. Полиции Японии, Южной Кореи и США используют подобные.</description-loc>
</equipment>
<equipment version="3">
	<description>H&amp;K AG36</description>
	<value>1,550</value>
	<weight>3.8/0.5</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>4d-1 [2d]cr-ex</damage>
		<strength>9†</strength>
		<accuracy>1</accuracy>
		<range>30/440</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<bulk>–</bulk>
		<recoil>2</recoil>
		<ammo>40x46mmSR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:Германия</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Германия 1999
		<img data-src="http://weapons.gurps.ru/img/235.png">
		<img data-src="http://weapons.gurps.ru/img/240.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Вешается подствольно, добавляет оружию веса и Bulk -1



Подствольный гранатомет для винтовок H&amp;K G36 и G36K. У него есть собственная пистолетная ручка, открывается в сторону, позволяет использовать гранаты любой длины. стоит на вооружении Германии. Более 30000 было выпущено.
	</description-loc>
</equipment>
<equipment version="3">
	<description>ATK-H&amp;K M29</description>
	<value>12,000</value>
	<weight>15/1.6</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>1d+1 [1d]cr-ex</damage>
		<strength>11†</strength>
		<accuracy>3+3</accuracy>
		<range>30/2,200</range>
		<rate_of_fire>2</rate_of_fire>
		<shots>6+1(3)</shots>
		<bulk>-6</bulk>
		<recoil>3</recoil>
		<ammo>20x28mm </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade launcher</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Гранатометы</category>
		<category> Страна:США</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		США 2008
		<img data-src="http://weapons.gurps.ru/img/236.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)

Полозья для навесного (H161)





Консорциум ATK и H&amp;K разработал дизайн для армии США XM29 “Целевое Индивидуально Боевое Орудие” (OICW). Оно должно было быть поставлено на вооружение в 2008 году, но проект был отменён в 2005 из за высокого веса, не эффективности и проблемы с бюджетом. Появлялась в фильме “Умри но не сегодня”. 

Автоматический гранатомет системы буллпап стреляет из пластикого  магазина. Отброс  гильзы можно переключить справа налево. Он стреляет 20x28mm HE-AB гранатомет в одном из четырех режимов: 

Воздушный. Основной режим, предполагает атаковать противника за преградой. Граната взрывается в воздухе рожает осколками сверху (HT174). стрелок может установить дистанцию срабатывания. 

Контактный. Граната взрывается в момент  соприкосновения.

Контактный задержкой.  Позволяет стрелять через тонкие двери и т п. граната взрывается немедленно за   преградой.

 Окно. Используется для стрельбы по зданиям снаружи. Граната срабатывает внутри, полутора метрах за стеной.

Более поздняя модель. Dmg 3d(0.5) cr with a 1d+1 [1d] cr ex follow-up Сконструирована так, что граната пролетает как минимум 30 метров до срабатывания.  HEDP будт наносить Dmg 4d(10) with 1d [1d] cr ex linked.





Настольным компонентом является карабин H&amp;K G36 (5.56x45mm)  Dmg 4d pi, Acc 4+2, Range 600/2,500, Wt. 15/1, RoF 6, Shots 30+1(3), ST 10†, Bulk -6, Rcl 2.  используют магазины от винтовки m16. Стреляет одиночными или тройными автоматическими очередями. Отцы и дети темы, требует 3 раундов, и может быть использован без гранатомета: Acc 3, Wt. 5.1/1, ST 9†, Bulk -3.

Включает в себя 2x  компьютерный прицел. (2xS/10 hrs. +1 Acc) видео канал с 2х увеличение ми тепловизор (+1 Acc, Infravision), HUD с доп информацией, 2 200 м система лазерного наведения (+3, один раунд подготовки), использует программу наведения (+1 у мению, один раунд запрограммировать). Пользователь выбирает режим детонации, указывают лазером цель, компьютер указывает новую точку прицеливания. Камера может передавать изображение на HUD по радиоканалу солдату и руководству
	</description-loc>
</equipment>
<equipment version="3">
	<description>Stokes ML Mk I</description>
	<value>5,000</value>
	<weight>108/11.7</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6dx3 [4d] cr-ex</damage>
		<strength>21M</strength>
		<accuracy>2</accuracy>
		<range>275/1,600</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<ammo>81mm</ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Минометы</category>
		<category> Страна:Великобритания</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Великобритания 1916
		<img data-src="http://weapons.gurps.ru/img/241.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Первый современный миномет. Простая конструкция для пехоты. Подобную конструкцию позже производили фактически все страны.

Состоит из гладкоствольной части (43 lbs) с фиксированным бойком в торце устанавливаемый на платформу (28 lbs) чтобы выдержать отдачу и поддерживался сошками (37 lbs). Требует расчета из трех человек. После установки стрелок просто кидает патрон в трубу, выстрел происходит при касании зарядом бойка. Широко использовались только HE (в таблице)

Watervliet M1 (1937-1945)  продолжение серии разработано во Франции для армии США, распространилось по всему миру.  EWt. 136. Разбирается на ствол (44.5 lbs.), сошки (46.5 lbs.), нижнюю пластину (45 lbs.). Можно перевозить на 71 lbs ручной тележке. 

Бывает два типа 81mm HE боеприпасов: легкая бомба (Dmg 6dx2 [4d] cr ex,

Max 3,300, WPS 6.9) и тяжелая (Dmg 6dx4 [4d] cr ex, Max 2,600, WPS 10.6), а так-же WP (Dmg 4d [1d(0.2)] burn ex, 23-метров радиусом горения на 1 минуту).
	</description-loc>
</equipment>
<equipment version="3">
	<description>82-мм Батальенный Миномёт БМ-37</description>
	<value>6,000</value>
	<weight>123/7.4</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>6dx2 [4d] cr-ex</damage>
		<strength>21M</strength>
		<accuracy>2</accuracy>
		<range>110/3,400</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(3)</shots>
		<ammo>82mm</ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<legality_class>1</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Минометы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		Россия / СССР 1937
		<img data-src="http://weapons.gurps.ru/img/242.png">
		Первая цифра в дистанции это минимальная дистанция а не 1/2D

Использоваться с 30х годов, одна из вариация Stroke. Копировался в Болгарии, Китае, Египте и Польше а так-же широко экспортировался. Использовался в Корее, Вьетнаме и в куче африканских конфликтов и на ближнем востоке.

Кроме HE (в таблице) использовались дымовые (облака 23 метра радиусом на 2 минуты) и осветительные (550 метров радиусом на 45 секунд). Коробка с тремя бомбами весит 36 lbs. Восточный миномет 82мм мог стрелять и 81мм но не наоборот. 

Требуется расчет из трех человек.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Royal Ordnance ML Mk II</description>
	<description-loc>Великобритания 1938

<img data-src="http://weapons.gurps.ru/img/243.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D



Разработан для Британской Армии, Испанским происзодителем ECIA была максимально проста для взводного использования. Пехота Содружества использовала их со времен ВОВ до 1980х. ДО сих пор производится в Индии.

Состоит из короткой гладкоствольной трубы с небольшим заострением для базы. Не имела прицела, единственное что помогало наводится это бела полоса по всей трубе и стрелок наводился по предыдущим снарядам. Стреляла с курка (а не от падения бомбы в ствол). В дополнение к HE (в таблице) имелись дымовые снаряды (12 метров радиусом на 70 секунд), осветительные (270 метров радиусом на 45 секунд) и цветные сигнальные.

Watervliet M3 (1942-1945) один из вариантов устанавливаемый не Американские танки для создания дымовых завес: EWt. 18, ST 14M. три фиксированные дистанции: 35, 75, и 150

метров.

Royal Ordnance 51mm L10A1 (1981-1988) современная замена MK II: Dmg 8d [2d+2] cr

ex, Range 55/900, EWt. 13.8/1.7.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>500</value>
	<weight>9/2.25</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d [2d+2]cr-ex</damage>
		<strength>9†</strength>
		<accuracy>1</accuracy>
		<range>50/530</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(2)</shots>
		<ammo>2”    </ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Минометы</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>120-мм полковой миномёт ПМ-38</description>
	<description-loc>Россия / СССР 1938

<img data-src="http://weapons.gurps.ru/img/244.png">

<img data-src="http://weapons.gurps.ru/img/553.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D



Очень большой, максимум для пехотного миномета. Обычно перемещался на двухколесной тележке 495lbs с помощью легкого грузовика. Разбирается на три части для транспортировки на животных: ствол (220 lbs), сошки (136 lbs), база (207 lbs). Копировался в Германии и Румынии.

В дополнение к HE (в таблице), мог стрелять дымовыми (облака 42 метра радиусом на 2 минуты), WP (Dmg 6d [1d(0.2)] burn ex, горение 42 метра радиусом 1 минута) и осветительными (500 мтеров радиусом 45 секунд), Коробка с двумя зарядами весит 88 lbs. Требует расчета из трех человек.

Более дешёвая версия  120-PM-43 (1943-1955) была распространена по всему миру (EWt. 605.) так-же копировалась в Китае и Египте. </description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>16,000</value>
	<weight>563/35.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx5 [6d]cr-ex</damage>
		<strength>32M</strength>
		<accuracy>3</accuracy>
		<range>500/6,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(5)</shots>
		<ammo>120mm </ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Минометы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Watervliet M2</description>
	<description-loc>США 1938

<img data-src="http://weapons.gurps.ru/img/245.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D



Типичный для большинства армий 1930х миномет. Копировался по лицензии во Франции. Американцы встретили китайские копии таких во время Вьетнамской войны.

Разбирается на три части ствол (12.8 lbs.), сошки (16.4 lbs.), нижнюю пластину (12.8 lbs.). Можно опереть ствол о землю и стрелять без сошек и пластины (Acc 0, ST 10†). Был популярен у партизан за портативность.

Кроме HE (в таблице) используются так-же  WP (Dmg 2d [1d(0.2)] burn ex, 15 метров радиусом на 1 минуту), и осветительные (350-метров радиусом на 30 секунд).

Деревянный ящик на 10 снарядов весил 4 lbs</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>2,500</value>
	<weight>42/3.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d [3d] cr-ex</damage>
		<strength>15M</strength>
		<accuracy>2</accuracy>
		<range>100/2,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(2)</shots>
		<ammo>60mm</ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Минометы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Hotchkiss-Brandt Commando</description>
	<description-loc>Франция 1966

<img data-src="http://weapons.gurps.ru/img/246.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)



Даже легче и более транспортабельный чем ранние 60мм мортиры. Он разработан для быстро перемещающейся легкой пехоты. Он усиливает мале мобильные группы не снижая их скорости. Его малый вес конечно снижает точность и дальность, но это оружие поддержки которое можно носить где угодно (Holdout -4). Подобную конструкцию используют во многих странах. 

Не имеет сошек и сложного прицела, просто двойной желейный прицел планка с маркеры дистанции на ремне, позволяющие скорректировать угол. Стрелок удерживает трубу одной рукой за тканную защиту вокруг ствола, второй рукой закидывает бомбу в ствол. Стреляет HE (в таблице), дымовыми (15 метров радиусом на 1 минуту), и осветительными (350-метров радиусом на 35 секунд).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>750</value>
	<weight>17/3.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>9d [3d] cr-ex</damage>
		<strength>11†</strength>
		<accuracy>1</accuracy>
		<range>100/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(2)</shots>
		<ammo>60mm</ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Минометы</category>
		<category> Страна:Франция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>PRB FLY-K</description>
	<description-loc>Бельгия 1983

<img data-src="http://weapons.gurps.ru/img/247.png">

<img data-src="http://weapons.gurps.ru/img/248.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Крепление для ремня (HT154)



Возможно один из самых необычных современных минометов. Он использует принцип вышибного заряда чтобы стрелять без дыма и вспышки и намного менее шумно, что скрывает позицию стрелка. в самой гранате есть движущий пороховой заряд. Легкий и компактный  (Holdout -4) с простым но эффективным прицелом. Это идеальное оружие для засад, убийц и групп быстрого проникновения. Нес тал коммерчески успешным но выпускался по лицензии во Франции в 1990х и был на вооружении французской армии. Кроме HE (в таблице) стреляет WP (Dmg 2d [1d(0.2)] burn ex, 12 метров радиусом на 1 минуту) осветительными или ИК-осветительными (275 метров радиусом на 30 секунд).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>900</value>
	<weight>10/1.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d [2d+2] cr-ex</damage>
		<strength>8†</strength>
		<accuracy>2</accuracy>
		<range>220/770</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(2)</shots>
		<ammo>52mm </ammo>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<specialization>Cannon)</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Минометы</category>
		<category> Страна:Бельгия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GE M1A1 Bazooka</description>
	<description-loc>США 1943

<img data-src="http://weapons.gurps.ru/img/249.png">

<img data-src="http://weapons.gurps.ru/img/547.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+1 burn

Крепление для ремня (HT154)



Этот простой ракетомёт фактически стал первым противотанковым орудием, стреляет 60мм ракетами с боеголовкой HEAT. Сделан на "коленке" офицером ракетчиком американской армии, его прозвали "базука" за одноименный музыкальный инструмент изобретенный комиком того времени. Было выпущено пол миллиона.

В "прикладе" находятся батарейки (2xS) необходимые для зажигания и еще две запасные. HEAT ракета стоит $215 они поставляются в сумках.

M20 Super Bazooka (1950-1957) стреляла более крупным боеприпасом  3.5” (89mm) : Dmg 7dx3(10) cr ex  5dx4 cr ex, Range 10/950, Wt. 22/9, ST 9†, Bulk -7, Cost $2,500. 

Разбирается на две части: 4.5lbs и 8.5bls. Вместо батареек использует магнето генератор - необходимо сжать для зажигания. С немного обновленным снарядом Range 10/1,300, Wt. 20.5/7.5. до сих пор выпускается в Бразилии.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>1,800</value>
	<weight>16.1/3.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4dx2(10)cr-ex 5dx2cr-ex</damage>
		<strength>8†</strength>
		<accuracy>0</accuracy>
		<range>10/700</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-6</bulk>
		<recoil>1</recoil>
		<ammo>2.36” </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>GE M1A1 Bazooka (M20 Super Bazooka)</description>
	<description-loc>США 1943

<img data-src="http://weapons.gurps.ru/img/249.png">

<img data-src="http://weapons.gurps.ru/img/547.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+1 burn

Крепление для ремня (HT154)



Этот простой ракетомёт фактически стал первым противотанковым орудием, стреляет 60мм ракетами с боеголовкой HEAT. Сделан на "коленке" офицером ракетчиком американской армии, его прозвали "базука" за одноименный музыкальный инструмент изобретенный комиком того времени. Было выпущено пол миллиона.

В "прикладе" находятся батарейки (2xS) необходимые для зажигания и еще две запасные. HEAT ракета стоит $215 они поставляются в сумках.

M20 Super Bazooka (1950-1957) стреляла более крупным боеприпасом  3.5” (89mm) : Dmg 7dx3(10) cr ex  5dx4 cr ex, Range 10/950, Wt. 22/9, ST 9†, Bulk -7, Cost $2,500. 

Разбирается на две части: 4.5lbs и 8.5bls. Вместо батареек использует магнето генератор - необходимо сжать для зажигания. С немного обновленным снарядом Range 10/1,300, Wt. 20.5/7.5. до сих пор выпускается в Бразилии.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,500</value>
	<weight>22/9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx3(10) cr ex 5dx4 cr ex</damage>
		<strength>9†</strength>
		<accuracy>0</accuracy>
		<range>10/950</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>07</bulk>
		<recoil>1</recoil>
		<ammo>3.5”</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>HASAG Panzerfaust 30</description>
	<description-loc>Германия 1943

<img data-src="http://weapons.gurps.ru/img/250.png">

<img data-src="http://weapons.gurps.ru/img/260.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+1 burn

Не надежный - клинит на 16+



В конце Второй Мировой, германия разработала "танковый кулак" - огромная 150мм боеголовка запускалась из 44мм трубы безотдачным принцип. Она была столь легка и проста что выдавалась не специальному расчету, а любому солдату, который мог встретить танк. Было несколько моделей с разными дистанциями и боеголовками, однако самая распространенная Panzerfaust 30 - с 30 метровой дистанцией. Было выпущено шесть миллионов. Поставлялась в страны Оси включая Финляндию, Венгрию и Румынию.

Поставляется предзаряженным (четыре ракетницы в деревянном ящике 50lbs). Стрелок необходимо три секунды чтобы раскрыть прицелы и подготовится к стрельбе. 

Panzerfaust 60 (1944-1945) имел большую дальность: Range 10/150, Wt. 13.4.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>400</value>
	<weight>11.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3(10)cr-ex 5dx5cr-ex</damage>
		<strength>8†</strength>
		<accuracy>0</accuracy>
		<range>10/80</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>44mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Firestone M18</description>
	<description-loc>США 1945

<img data-src="http://weapons.gurps.ru/img/251.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 5d burn



Безотдачный гранатомет времен Второй Мировой Войны. Американский десант использовал такие в Европе и Японии. После очень широко экспортировался и был использован во Вьетнаме и Корее. Так-же выпускался в Китае.

Можно стрелять с плеча или с строенных сошек. Имеет несъемный прицел x3 (+1 Acc). В дополнение к HEAT (в таблице) стреляет:

HE (Dmg 7dx3 cr 4dx2 [3d] cr ex, Range 800/5,000), 

WP (Dmg 7d¥3(0.5) cr 1d+1 [1d(0.2)] burn ex, 14-метров радиусом горит 1 минуту, Range 750/4,600), 

и картечью (Dmg 2d pi+, Acc 3+1, Range 50/1,100, RoF 1x154, Rcl 1). 

В коробке 4 заряда 39 lbs.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,000</value>
	<weight>54/5.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>4dx2(10)cr-ex 4dx2cr-ex</damage>
		<strength>11B†</strength>
		<accuracy>4+1</accuracy>
		<range>10/4,800</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-8</bulk>
		<recoil>1</recoil>
		<ammo>57x305mmR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Carl Gustaf M2</description>
	<description-loc>Швеция 1948

<img data-src="http://weapons.gurps.ru/img/252.png">

<img data-src="http://weapons.gurps.ru/img/548.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 4d burn

Крепление для ремня (HT154)



Стреляющий с плеча безотдачный. Выпущена Шведским Арсеналом, использовалась по всему миру. И коммунистические страны и страны НАТО приняли ее на вооружение, так-же выпускалась по лицензии в Германии, Индии и Японии.

Оснащена оптическим прицелом  2х (2-lb. +1 Acc) Стреляет HEAT (в таблице), HE (Dmg 6dx2 cr  6dx5 [4d+1] cr ex), Осветительными (285-метров радиусом на 30 секунд), и дымовыми (Dmg 6dx2(0.5)  2d+1 cr ex , облако радиусом 10 метров в течении 10 секунд, Range 450/1,400).

FFV M3 (1986-) облегченная версия с более тяжелым патроном Wt. 26.4/6.6, ST 9†, Cost $2,600. Рейнджеры и Морская пехота Армии США приняли на вооружение. Оснащена прицелом 3х (1.5-lb. +1 Acc), а с 1998 мини компьютером (4.8lbs) с 3.5х приближением, и 1,650 метровым лазерным дальномером (+1 Acc за прицел, +3 за дальномер, +1 Guns, 6xVS/1,000 измерений). Стреляет HEAT (Dmg 6dx6(10) cr ex 5dx2 cr ex), HEDP (Dmg 6dx4(10) cr ex 6dx3 [4d+1] cr ex), и с 2002, MF (Dmg 1d-2 pi-, Acc 3+1, Range 100/1,200, RoF 1x1,100, Rcl 1).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,000</value>
	<weight>38.9/5.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx5(10)cr-ex 6dx3cr-ex</damage>
		<strength>10†</strength>
		<accuracy>4+1</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-7</bulk>
		<recoil>1</recoil>
		<ammo>84x250mmR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Швеция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Carl Gustaf M2 (FFV M3)</description>
	<description-loc>Швеция 1948

<img data-src="http://weapons.gurps.ru/img/252.png">

<img data-src="http://weapons.gurps.ru/img/548.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 4d burn

Крепление для ремня (HT154)



Стреляющий с плеча безотдачный. Выпущена Шведским Арсеналом, использовалась по всему миру. И коммунистические страны и страны НАТО приняли ее на вооружение, так-же выпускалась по лицензии в Германии, Индии и Японии.

Оснащена оптическим прицелом  2х (2-lb. +1 Acc) Стреляет HEAT (в таблице), HE (Dmg 6dx2 cr  6dx5 [4d+1] cr ex), Осветительными (285-метров радиусом на 30 секунд), и дымовыми (Dmg 6dx2(0.5)  2d+1 cr ex , облако радиусом 10 метров в течении 10 секунд, Range 450/1,400).

FFV M3 (1986-) облегченная версия с более тяжелым патроном Wt. 26.4/6.6, ST 9†, Cost $2,600. Рейнджеры и Морская пехота Армии США приняли на вооружение. Оснащена прицелом 3х (1.5-lb. +1 Acc), а с 1998 мини компьютером (4.8lbs) с 3.5х приближением, и 1,650 метровым лазерным дальномером (+1 Acc за прицел, +3 за дальномер, +1 Guns, 6xVS/1,000 измерений). Стреляет HEAT (Dmg 6dx6(10) cr ex 5dx2 cr ex), HEDP (Dmg 6dx4(10) cr ex 6dx3 [4d+1] cr ex), и с 2002, MF (Dmg 1d-2 pi-, Acc 3+1, Range 100/1,200, RoF 1x1,100, Rcl 1).</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,600</value>
	<weight>26.4/6.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx6(10) cr ex 5dx2 cr ex</damage>
		<strength>9†</strength>
		<accuracy>4+1+3</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-7</bulk>
		<recoil>1</recoil>
		<ammo>84x250mmR </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Швеция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ручной Противотанковый Гранатомёт РПГ-2</description>
	<description-loc>Россия / СССР 1949

<img data-src="http://weapons.gurps.ru/img/253.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn



Улучшенный немецкий Panzerfaust - с более удобным прицелом и эргономикой. Основное противотанковое оружие коммунистов до 1960х, широко экспортировалось. Вьетнамцы называли его Базука-40 Ли, или B-40. Китай выпускал по лицензии.

Стреляет  82мм боеголовкой HEAT. Рокету и боеголовку необходимо собрать вместе перед выстрелом (3 Ready маневра). Боеголовка стоит $80.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>750</value>
	<weight>10.3/4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7dx2(10)cr-ex 6dx2cr-ex</damage>
		<strength>9†</strength>
		<accuracy>1</accuracy>
		<range>10/550</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-6</bulk>
		<recoil>1</recoil>
		<ammo>40mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ручной Противотанковый Гранатомёт РПГ-7</description>
	<description-loc>Россия / СССР 1962

<img data-src="http://weapons.gurps.ru/img/254.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn



Продвинутая версия РПГ-2 использовалась коммунистами как противотанокове и для уничтожения живой силы противника в укрытиях. Было выпущено минимуму девять миллионов по всему миру включая Беларусю, Болгарию, Китай, Египет, Грузию, Иран, Ирак, Северную Корею, Пакистан, Румынию, Украину и Зимбабве. Использовалась в боях во Ветнаме, Авганистане, Анголе, Сомали, Чечне и Ираке. Партизаны всех этих воин использовании такие и стреляли из них во все подряд - танки, вертолеты, бункеры. Грабители использовали их для нападения на инкасаторсике колонны.

Обычно оборудован прицелом с светоусилением x2.7 (+1 Acc, уменьшает штраф за свет на -1, XS/10час) или может быть заменен на 2lvs x4 ночного зрения (+2 Acc and Night Vision 6, XS/10 hrs.) Рокету и боеголовку необходимо собрать вместе перед выстрелом (3 Ready маневра). В дополнение к стандартной 85mm HEAT Боеголовке (в таблице) имеются 40mm HE (Dmg 5dx2 [2d] cr ex).

В 1990s появились продвинутые:

93mm HEAT (Dmg 6dx8(10) cr ex 6dx3 cr ex , Wt. 19.6/5.7), 

105mm MS-HEAT (Dmg 6dx2(10) cr ex 6dx7(10) cr ex 6dx3 cr ex linked, Wt. 23.8/9.9), 

93mm thermobaric (Dmg 6dx9 cr ex, Range 20/750, Wt. 24.2/10.3). 

A HEAT стоят $150; поставляются в 18.7-lb. рюкзаках.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,300</value>
	<weight>18.9/5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx4(10)cr-ex 7dx2cr-ex</damage>
		<strength>9†</strength>
		<accuracy>2+1</accuracy>
		<range>10/1,000</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-7</bulk>
		<recoil>1</recoil>
		<ammo>40mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>HEC M72A2</description>
	<description-loc>США 1963

<img data-src="http://weapons.gurps.ru/img/255.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn

Крепление для ремня (HT154)



Одноразовый ракетомет стреляющий HEAT. Изначально выпускался для армии США и экипировался чуть ли не в каждом подразделении. Широко экспортировался и выпускался по лицензии в Норвегии и Турции. Выпущено минимуму семь миллионов.

В сложенном состоянии всего 60см длиной (Holdout -3). Стрелку необходимо три секунды для выдвижения трубы и прицелов.

M72A3 (1974-) имели тот же смысл

M72A4 (1993-) был более мощным Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.5, Cost $1,750.

M72A6 (1993-) и M72A7 (1997-) имели боеголовку HEDP Dmg 6dx2(10) cr ex 6dx2 [3d+1] cr ex, Wt. 7.6, Cost $2,200.

Российская РПГ-18 Муха (1971-) копия M72A2: Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.9, Cost $500.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>500</value>
	<weight>5.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3(10)cr-ex 6dx2cr-ex</damage>
		<strength>6†</strength>
		<accuracy>1</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-4</bulk>
		<recoil>1</recoil>
		<ammo>66mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>HEC M72A2 (M72A4 )</description>
	<description-loc>США 1963

<img data-src="http://weapons.gurps.ru/img/255.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn

Крепление для ремня (HT154)



Одноразовый ракетомет стреляющий HEAT. Изначально выпускался для армии США и экипировался чуть ли не в каждом подразделении. Широко экспортировался и выпускался по лицензии в Норвегии и Турции. Выпущено минимуму семь миллионов.

В сложенном состоянии всего 60см длиной (Holdout -3). Стрелку необходимо три секунды для выдвижения трубы и прицелов.

M72A3 (1974-) имели тот же смысл

M72A4 (1993-) был более мощным Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.5, Cost $1,750.

M72A6 (1993-) и M72A7 (1997-) имели боеголовку HEDP Dmg 6dx2(10) cr ex 6dx2 [3d+1] cr ex, Wt. 7.6, Cost $2,200.

Российская РПГ-18 Муха (1971-) копия M72A2: Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.9, Cost $500.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>1,750</value>
	<weight>5.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx5(10) cr ex 6dx2 cr ex</damage>
		<strength>6†</strength>
		<accuracy>1</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-4</bulk>
		<recoil>1</recoil>
		<ammo>66mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>HEC M72A2 (M72A6 and M72A7)</description>
	<description-loc>США 1963

<img data-src="http://weapons.gurps.ru/img/255.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn

Крепление для ремня (HT154)



Одноразовый ракетомет стреляющий HEAT. Изначально выпускался для армии США и экипировался чуть ли не в каждом подразделении. Широко экспортировался и выпускался по лицензии в Норвегии и Турции. Выпущено минимуму семь миллионов.

В сложенном состоянии всего 60см длиной (Holdout -3). Стрелку необходимо три секунды для выдвижения трубы и прицелов.

M72A3 (1974-) имели тот же смысл

M72A4 (1993-) был более мощным Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.5, Cost $1,750.

M72A6 (1993-) и M72A7 (1997-) имели боеголовку HEDP Dmg 6dx2(10) cr ex 6dx2 [3d+1] cr ex, Wt. 7.6, Cost $2,200.

Российская РПГ-18 Муха (1971-) копия M72A2: Dmg 6dx5(10) cr ex 6dx2 cr ex, Wt. 5.9, Cost $500.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,200</value>
	<weight>7.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx2(10) cr ex 6dx2 [3d+1] cr ex</damage>
		<strength>6†</strength>
		<accuracy>1</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-4</bulk>
		<recoil>1</recoil>
		<ammo>66mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MBB Armbrust</description>
	<description-loc>Германия 1979

<img data-src="http://weapons.gurps.ru/img/256.png">

<img data-src="http://weapons.gurps.ru/img/262.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+1 cr

Крепление для ремня (HT154)

Armbrust ("арбалет") одноразовый гранатомет стреляющий HEAT.  MBB занималось разработкой, но PRB в Бельгии занималась конечным выпуском. Выпускался в Сингапуре по лицензии. Использовался в Гражданской Войне Югославии.

Почти не имеет гоизонтального обратного выхлопа сзади есть пластиковые рассекали, что позволяет стрелять из закрытого помещения, где расстояние до стены 1 метр. Вышибной заряд скрывает звук, вспышку и дым  (используйте правила глушителей HT165, но используйте 256-м линию из таблиц дистанций HT158).</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>1,000</value>
	<weight>13.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx4(10)cr-ex 6dx2cr-ex</damage>
		<strength>8†</strength>
		<accuracy>1</accuracy>
		<range>10/1,500</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>67mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Реактивный пехотный огнемет РПО «Шмель»</description>
	<description-loc>Россия / СССР 1988

<img data-src="http://weapons.gurps.ru/img/257.png">

<img data-src="http://weapons.gurps.ru/img/552.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 3d burn

Крепление для ремня (HT154)

Термобарический. Делите повреждения на (2 х расстояние до центра взрыва)



Это одноразовый ракетомет с термоборической боеголовкой.  Сотская пехота получила его на вооружении в 1988 и использовала в Афганистане и Чечне. Однако полномасштабное производство началось только в 2001. Экспортировался в Китай, Конго и Индию.

Каждый имел плечевой ремень с подкладом, а два ракетомета можно было скрепить друг с другом, что образует рюкзак. 

РПО-З (зажигательный боеприпас) (1988-) такой-же ракетомет стреляющий WP: Dmg 6d [1d(0.2)] burn ex.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>3,600</value>
	<weight>24.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx9cr-ex </damage>
		<strength>9†</strength>
		<accuracy>2</accuracy>
		<range>20/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-6</bulk>
		<recoil>1</recoil>
		<ammo>93mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>FFV AT4</description>
	<description-loc>Швеция 1985

<img data-src="http://weapons.gurps.ru/img/258.png">

<img data-src="http://weapons.gurps.ru/img/263.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 4d burn

Крепление для ремня (HT154)



Одноразовый ракетомет стреляющий HEAT. Широко экспортировался, а с 1987 заменил M72 в армии США. Поставлялся в деревянных ящиках по 5 штук в каждом 113 lbs. 



Bofors AT4CS (1996-) версия способная стрелять из закрытых помещений - Wt. 16.5, Cost $2,700. его задняя часть наполнена водой и антифризом. Обратная вспышка 2d cr</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>1,600</value>
	<weight>14.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx6(10)cr-ex 7dx2cr-ex</damage>
		<strength>8†</strength>
		<accuracy>2</accuracy>
		<range>10/2,300</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-5</bulk>
		<recoil>1</recoil>
		<ammo>84mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Швеция</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Dynamit-Nobel PZF3</description>
	<description-loc>Германия 1990

<img data-src="http://weapons.gurps.ru/img/259.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 2d cr

Крепление для ремня (HT154)



Современный перезаряжаемый гранатомет. Было выпущено более 250,00 некоторые в Швейцарии. Иcпользуется в Германии, Италии, Японии и Южной Корее. 

Снабжен х2.5 оптическим прицелом (1.5lbs +1 Acc). A c 1998 мнини-компьютером 4.8lbs c x3.5 приближением и 1,650 метровым лазерным дальномером (+1 Acc за прицел, +3 за дальномер, +1 Guns, 6xVS/1,000 измерений). Доступно дополнительно ночное видение (2.6 lbs, Night Vision 7, 2xS/30 hrs.) для мини компьютера или оптического прицела.

Стреляет 110мм HEAT боеголовкой. Патрон идет в одноразовой трубе для вставленной в гранатомет (сам грнатомет 5.1 lbs., вместе с прицелом).

Боеголовка HEAT стоит $500. Так-же доступна MS-HEAT  (Dmg 6dx4(10) cr ex  6dx9(10) cr ex 6dx4 cr ex linked, Range 10/1,000, Wt. 29.3/24.2).

Использует мощные стальные отражатели что уменьшает опасную зону позади стрелка, что позваляет стреляь в помещении. </description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>7,200</value>
	<weight>28.4/23.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx9(10)cr-ex 6dx4cr-ex</damage>
		<strength>10†</strength>
		<accuracy>2+1</accuracy>
		<range>20/1,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1(4)</shots>
		<bulk>-7</bulk>
		<recoil>1</recoil>
		<ammo>60mm  </ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Fiedler Kleif</description>
	<description-loc>Германия 1912

<img data-src="http://weapons.gurps.ru/img/264.png">

Два раунда на подготовку



"Малый огнемет". Был первым из современных огнеметов и хорошо походит для взятия укреплений и окопов. в 1916 большинство стран имело подобное оружие. Поджигался один раз и выпускал свой 16 литровый бак за раз - 20 секунд.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>1,500</value>
	<weight>68</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d burn</damage>
		<strength>11†</strength>
		<range>15/20</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>1x20s</shots>
		<bulk>-8</bulk>
		<ammo>      </ammo>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Flamethrower</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Огнеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ранцевый огнемёт РОКС-2</description>
	<description-loc>Россия / СССР 1941

<img data-src="http://weapons.gurps.ru/img/265.png">

Два раунда на подготовку

Во время Второй Мировой Войны Красная Армия использовала ранцевые огнеметы. Использовался ствол похожий на винтовку со шлангом идущим в рюкзак. Своим видом издалека вводила противника в заблуждение (необходим броско зрения для идинтификации). Бак содержал 10 литров бензина а для поджига использовался патрон холостой патрон на 7.62x25mm в барабане на 10 патронов, что давало десять очередей по одной секунде каждая.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,000</value>
	<weight>50</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d burn</damage>
		<strength>10†</strength>
		<range>25/40</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>10x1s</shots>
		<bulk>-7</bulk>
		<ammo>      </ammo>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Flamethrower</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Огнеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Beattie M2-2</description>
	<description-loc>США 1942

<img data-src="http://weapons.gurps.ru/img/266.png">

<img data-src="http://weapons.gurps.ru/img/269.png">

Два раунда на подготовку

Этот огнемет был на вооружении армии США до 1950х. Было выпущено около 25,000. Большинство стран имело нечто подобное во время Второй Мировой Войны. Баллон содержит 18 литров сгущенного топлива а в стволе для поджига используются холостые патроны в барабане от револьвера на 5 патноов что дает стрелку пять очередей по две секунды или один 10 секундный залп.

GE M9A1-7 (1956-1969) заменил M2-2, использовался во Вьетнамской Войне. Range 35/55, Wt. 52. Армия США прекратила использовать огнеметы в 1978.

POA-CWS M3-4-3 (1944-1945) тот же принцип но устанавливался на танк "шерман" вместо пулемета. Стрелял из 100 литрового бака, которого хватало на 45 секундную струю или 10 пятисекундных вспышки. Было выпущено 1,784 единицы.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>1,800</value>
	<weight>72</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d burn</damage>
		<strength>11†</strength>
		<range>25/40</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>5x2s</shots>
		<bulk>-8</bulk>
		<ammo>      </ammo>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Flamethrower</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Огнеметы</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>DWM FmW46</description>
	<description-loc>Германия 1944

<img data-src="http://weapons.gurps.ru/img/267.png">

Два раунда на подготовку

Крепление для ремня (HT154)



Одноразовое оружие, похоже на огнетушитель с пистолетной ручкой. Стрелок берет бутылку под руку, направляет на врага и выдергивает чеку. Использовалось парашютистами и другими атакующими войсками. Было выпущено 30,900 единиц.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>500</value>
	<weight>7.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d burn</damage>
		<strength>6†</strength>
		<range>25/40</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>1x1s</shots>
		<bulk>-4</bulk>
		<ammo>      </ammo>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Flamethrower</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Огнеметы</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Лёгкий пехотный огнемёт ЛПО-50</description>
	<description-loc>Россия / СССР 1967

<img data-src="http://weapons.gurps.ru/img/268.png">

<img data-src="http://weapons.gurps.ru/img/270.png">

Два раунда на подготовку

10 литров топлива хватает на 3 трехсекундных залпа. Бтареи  (4xS) поджигают три зажигательных патрона. Имеются сошки. Копировался в Китае. </description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>2,500</value>
	<weight>51</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d burn</damage>
		<strength>10B†</strength>
		<range>50/75</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>3x3s</shots>
		<bulk>-7</bulk>
		<ammo>      </ammo>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Flamethrower</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Огнеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Cлезоточивый газ</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/271.png">

В большинстве случае необходимо попасть в лицо (-5), однако атака струей дает +2 (B180)



Аэрозольный баллончик распыляет смесь реагентов обычно называемые "слезоточивый газ" (HT171).

Расценивайте как холодное оружие с Reach 1,2 а не как дистанционное оружие.

Жертва должна сделать два броска по HT-2: первый на сопротивление кашлю (см. B428), второй на сопротивление ослеплению (B428). каждый из эффектов длится столько минут, на сколько провален бросок.

Бывает разных размеров, обычно помещается в карман или дамскую сумочку. Иногда совмещен с фанерам или дубинкой. Однозарядные модели обычно могут быть встроены даже в наручные часы.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>10</value>
	<weight>0.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>Special </damage>
		<strength>3</strength>
		<range>1,2</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>20</shots>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Sprayer</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Перцовка</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/272.png">

В большинстве случае необходимо попасть в лицо (-5), однако атака струей дает +2 (B180)



Аэрозольный баллончик распыляет реагентов обычно называемую "Перцовка" она эффективна чем "слезоточивый газ" на морозе, против животных и против людей под наркотой.

Расценивайте как холодное оружие с Reach 1,2 а не как дистанционное оружие.

Жертва должна сделать два броска по HT-4: первый на сопротивление кашлю (см. B428), второй на сопротивление ослеплению (B428). каждый из эффектов пока не смыто большим количество воды и полотенцем.

Бывает разных размеров, обычно помещается в карман или дамскую сумочку. Иногда совмещен с фанерам или дубинкой. Однозарядные модели обычно могут быть встроены даже в наручные часы.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>10</value>
	<weight>0.1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>Special </damage>
		<strength>3</strength>
		<range>1,2</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>20</shots>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Sprayer</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Stielhandgranate</description>
	<description-loc>Германия 1915

<img data-src="http://weapons.gurps.ru/img/274.png">

Задержка 4-5с

Чтобы активировать необходимо скрутить крышку и выдернуть шнур - это  занимает _два_ Ready маневра.



Это была стандартная граната в первой мировой в германии. У советских солдат получила прозвище «колотушка», у англоязычных союзников — «толкушка» (англ. "potato masher", то есть «картофелемялка»).

Длинная ручка дает хороший размах для броска однако добавляет веса (+2 к ST при вычислении дистанции броска). Она же делает ее неудобной в ношении и сокрытии; Немецкие солдаты носили ее заткнутой за ремень или даже в сапог.



Во времена 2й мировой использовалась StiHGr24 (1928-1945), с аполнителем из TNT а не черного пороха: Dmg 7d cr ex, Wt. 1.4. 



С 1943, появился съемный осколочный рукав -  0.3-lb.  Dmg 5d [2d] cr ex, Wt. 1.7.



Импровизированная "geballte Ladung" (сосредоточенный заряд) использовался против техники - всязка из шести головок вокруг одной ручки -  Dmg 6dx3 cr ex, Wt. 4.4.



Дымовая шашка NbHGr39 (1939-1943) выглядела точно так-же только имела белую полосу:

Wt. 1.9, Fuse 7-8. Дым в радиусе 7 метров, в течении 90 секунд.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>20</value>
	<weight>1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage> 5d cr ex</damage>
		<bulk>-3</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Mills Number 36M Mk I</description>
	<description-loc>Великобритания 1918

<img data-src="http://weapons.gurps.ru/img/275.png">

Задержка 7с.

Один раунд подготовки чтобы выдернуть чеку

Длительно производилась в Британии. Были выпущены тысячи а может быть и миллионы - экспортировались по всему миру. До сих пор производятся в Индии и Пакистане!

Это была первая граната с насечкой на металлическом корпусе. Насечки правда никак не помогали осколочному действия (Однако Вильям Милс об этом не знал), однако давала хороший хват. Осколочный эффект был очень неравномерный. Большую часть железа Разрывало на слишком мелкие куски чтобы быть опасными, однако иногда большие куски (особенно запал и дно) летали на 200 метров и имели достаточно скорости чтобы убить. Если мастер хочет - он может позволить осколочную атаку на дистанцию до 200 метров (2d)!

Изначально задержка была семь секунд

В 1940 стандартом стала 4х секундная задержка.

</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>20</value>
	<weight>1.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d-1 [2d] cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MK II (Копия F1) Лимонка</description>
	<description-loc>США 1920

<img data-src="http://weapons.gurps.ru/img/276.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



После Первой Мировой США скопировали французскую гранату F1. Название Лимонка (у англоговорящих Ананаска - Pineapple) стало народным.

Использовалась в ВОВ, и в Корейской войне. Широко распространена по миру. До сих пор выпускается в Китае, Тайване и Турции.

В СССР копия F1 (1933-), только задержка 3-4с.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>20</value>
	<weight>1.3</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage> 4d+1 [2d] cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MK III</description>
	<description-loc>США 1920

<img data-src="http://weapons.gurps.ru/img/277.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



Фугасная граната - пол фунта TNT в коронной коробке. Без осколочного действия. Финальная версия с маркировкой  MK 3A2 (1943-) используется до сих пор. Позже корпус стал пластиковым, что лучше предохраняет от сырости. Широко распространена - Израиль, Тайвань, Турция и пр.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value>20</value>
	<weight>1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d+2 cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Eihandgranate 39</description>
	<description-loc>Германия 1940

<img data-src="http://weapons.gurps.ru/img/278.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



Кроме "колатушек" немецкие солдаты использвали эти гранаты. Eihandgranate ("Граната яйо ручная") или r EiHGr39.

Небольшая фугасная граната с взрывателем в виде выдрергиваемого шнура.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>20</value>
	<weight>0/6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d+1 cr ex</damage>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AMC AN-M8 Дымовая</description>
	<description-loc>США 1940

<img data-src="http://weapons.gurps.ru/img/279.png">

Задержка 1-2с

Один раунд подготовки чтобы выдернуть чеку

Заполняет 7 метров дымом (B439) В обычную погоду облако стоит 80 секунд.



Форма банки, используется со времен ВОВ. Запал поджигает наполнитель (а не взрывает гранату). Граната горит 2 минуты, производя облака плотного белого дыма (см. HT171). Сама граната сильно разогревается (около  1200°С) чтобы вызвать ожоги (1d-2 burn) или поджечь сухую траву, бумагу и прочее горючие предметы (B433).



Серия M7 (1935-) Распыляет слезоточивый газ (H171) 7 метров радиусом на 25 seconds: Wt. 1, Cost $175.



Серия M18 (1942-) - сигнальные дымы - крассный, желтый, зеленый, фиолетовый.: Wt. 1.2.



Серия M83 (1994-) Заменила AN-M8 в США 7 метров дымом на 50 сек.: Wt. 1, Cost $35.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>45</value>
	<weight>1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage> Smoke (7 yd.)</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>AN-M14</description>
	<description-loc>США 1943

<img data-src="http://weapons.gurps.ru/img/280.png">

Задержка 1-2с

Один раунд подготовки чтобы выдернуть чеку



В форме банки внутри 1.6Lbs термитной зажигательной смеси.

Если засунуть внутрь открытого танка, ствол артиллерийской техники, или оборудования типо радио и т.п. достаточно быстро уничтожит его.

Нагревается достаточно чтобы в радиусе 2м загорелось что-нибудь горючее. Горит даже под водой

 

См термитный заряд (HT188) 

AN-M14 горит в течении 40 секунд. Любой касающийся получит 3d burn в секунду и теряет DR 1 за 10 единиц повреждения.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>45</value>
	<weight>2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>Special</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>РПГ-43</description>
	<description-loc>Россия / СССР 1943

<img data-src="http://weapons.gurps.ru/img/281.png">

Взрывается от контакта

Один раунд подготовки чтобы выдернуть чеку



Ручная противотанковая граната образца 1943 года, граната с ручкой с головной частью 95 миллиметров и хвостовым стабилизатором в виде тряпки. разработана во времена Второй мировой войны Советской Армии для использования пехоты против бронированная техника. также использовалась во вьетнамской войне.

Граната должна попасть в головной частью чтобы детонировать. Незнакомый с такой техникой броска получает -5 к умению. Можно атаковать сверху использование умение Dropping.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>2.6</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d(10) cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>M26</description>
	<description-loc>США 1953

<img data-src="http://weapons.gurps.ru/img/282.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



M26 имеет яйцевидный металлический корпус, составленный из двух половин. Вдоль внутренней поверхности корпуса плотно уложена спираль из насеченной стальной проволоки.

Заменила гранату MkII после Корейской войны.

Копируется по всему миру, в Германии, Израиле, Нидерландах, Северной Африке и Британии используется и по сей день.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d+2 [2d] cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>M34 WP</description>
	<description-loc>США 1953

<img data-src="http://weapons.gurps.ru/img/283.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку

Заполняет 5 метров дымомо (B439) В обычную погоду облако стоит 60 секунд.



Так-же известна как "белый фосфор". Результат горения - мгновенные облако горячего дыма (опасны для вдыхания) см. (HT172)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>50</value>
	<weight>1.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>2d [1d(0.2)] burn ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>M67</description>
	<description-loc>США 1971

<img data-src="http://weapons.gurps.ru/img/284.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



Размером с бейсбольный мяч,  до сих пор используется в США. Заменила M26 - она легче, безопасней, ее проще бросать. Широко распространена  и производится в Канаде, Южной Корее и Тайване</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>0.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>9d [2d] cr ex</damage>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Diehl DM51</description>
	<description-loc>Германия 1976

<img data-src="http://weapons.gurps.ru/img/285.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



Осколочная граната, со съемным пластиковым кожухом содержащим тысячи стальных шариков. Без кожуха это легкая фугасная граната Dmg 5d cr ex, Wt. 0.3. 

DM51 стоит на вооружении в Германии и экспортируется по всему миру.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage> 3d+2 [3d] cr ex</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Schermuly Stun Светошумовая</description>
	<description-loc>Великобритания 1976

<img data-src="http://weapons.gurps.ru/img/286.png">

Светошумовая граната. 

Исходно использовалась как тренировочная, но в 1977 была применена при спасении заложников в Германии. С 1980 стала на вооружении у сил спец назначения.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>HT-5 aff (10 yd.)</damage>
		<bulk>-2</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ARGES HG 86</description>
	<description-loc>Австрия 1986

<img data-src="http://weapons.gurps.ru/img/287.png">

Задержка 4-5с

Один раунд подготовки чтобы выдернуть чеку



Небольшая осколочная граната, отлично подходит для боев в помещении. В 2001 спецназ США использовал их зачистки пещер в Афганистане.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>25</value>
	<weight>0.4</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d-1 [2d] cr ex</damage>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:Австрия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>M452 Stingball</description>
	<description-loc>США 1987

<img data-src="http://weapons.gurps.ru/img/288.png">

Задержка 2-3с

Один раунд подготовки чтобы выдернуть чеку



Свето-шумовой эффект на расстоянии до 10 метров, требует броска HT провал означает оглушение (stun)  после на восстановление HT-5 каждый раунд. также создает в этой области.



 Нелетальная граната пластиковом корпусе положено 100 мелких резиновых шариков. Взрыв такой гранаты может вызвать обрушение ошейники создают болезненное ощущение расстояние до 7 метров. Морская пехота приняла на вооружение НАТО в 1998 году.





</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>30</value>
	<weight>0.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>1d+1 [1d-1 cr] cr ex  HT-5 aff (10 yd.)</damage>
		<bulk>-1</bulk>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>MBA Gyrojet Mk I</description>
	<description-loc>США 1965

<img data-src="http://weapons.gurps.ru/img/289.png">

<img data-src="http://weapons.gurps.ru/img/290.png">

Нет 1/2D но на расстоянии 1-7м дели повреждения на 3, а на расстоянии от 8-12м дали на 2.

Не надежный - клинит на 16+

Нет кольца для шнура





Этот уникальный пистолет стреляет ракетными  вращающимися патронами. ограничено продавался гражданским США, но не был успешным, было сделано около 3000 штук. Показано в фильме живешь только дважды.

 А системы “гиро” есть несколько преимуществ.  Нет отброса гильзы,  мало движущихся частей. может стрелять под водой (Range 10) или искупаться в болоте.  Он достаточно легкий и простой стрельбе почти не имеет отдачи. Однако есть и отрицательные стороны. Снаряд сначала должен пройти определенное расстояние чтобы набрать свою максимальную скорость, наносит меньше повреждений на близких дистанциях. А также он не точен и не надежен (Malf. 16), ранние версии были еще хуже  (Malf. 14). 

Звуки выстрелов отличаются от привычных: шипящий звук который сложно расценить как выстрел. Не съемный магазин ручки несет 6 патронов. перезарядка предполагает вставлять каждую ракету отдельно (3 ready на каждый патрон). 

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>1,400</value>
	<weight>1.2/0.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d pi+</damage>
		<strength>6</strength>
		<accuracy>0</accuracy>
		<range>1,000</range>
		<rate_of_fire>3</rate_of_fire>
		<shots>6(3i)</shots>
		<bulk>-2</bulk>
		<recoil>1</recoil>
		<ammo>13x36mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гирос</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Tellermine 35</description>
	<description-loc>Германия 1935

<img data-src="http://weapons.gurps.ru/img/291.png">

Holdout -4

Так-же применяются умения Soldier или Traps+2



Tellermine 35 (Тарелочная мина 1935г) была стандартной противотанковой миной в Германии в ВОВ. Дискообразное устройство диаметром ~30 см с ручкой для переноски.

Для срабатывания детонатора необходимо давление не менее 220 фунтов.

Так-же иногда комплектуется противо-подъемным детонатором (-2 при попытке разминировать - провал означает детонация)

До сих пор выпускается в разных странах.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>1</legality_class>
	<value> 130</value>
	<weight>19</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5dx8 cr ex</damage>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мины</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>ОЗМ-3</description>
	<description-loc>Россия / СССР 1950

<img data-src="http://weapons.gurps.ru/img/292.png">

<img data-src="http://weapons.gurps.ru/img/293.png">

Holdout -3

Так-же применяются умения Soldier или Traps+2



Похожа на банку с выходом детонатора на верху - детонатор обычно соединяют с растяжкой, требуется усилие в 15 фунтов чтобы активировать.

При срабатывания мина вышибает осколочную часть на высоту 5' (1.5)

Немедленный маневр Dodge &amp; Drop (B377) позволяет избежать осколочных повреждений.

Это очень типичная для TL7-8 "прыгающая" мина - часто применялась в ВОВ против пехотыю

Большинство армий имеют подобные мины на вооружении в течении второй половины 20 века.



German Schrapnellmine 35 (1935-1944), или SMi35, первая мина ткого типа: Dmg 4dx2 [4d] cr ex, Wt. 8.8.

В США M16 (1953-): Dmg 6dx2 [4d] cr ex, Wt. 8.2.

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>60</value>
	<weight>7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d [4d] cr ex</damage>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мины</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description> M18A1 Claymore</description>
	<description-loc>США 1960

<img data-src="http://weapons.gurps.ru/img/294.png">

<img data-src="http://weapons.gurps.ru/img/295.png">

Holdout -3

Так-же применяются умения Soldier или Traps+2



Это надземная мина направленного действия применяется в армии США в куче других стран, растиражирована по всему миру. Изогнутый пластиковый блок с С4 и 700 стальными шариками спереди размером с карманную книжку.

Поставляется в сумке 5-фунтов, 33-метровым шнуром со взрывателем на конце и военной подрывной машинкой (HT187). Устанавливается на ножки, направляется в нужную область и может быть подорвана детонатором или растяжкой.

В момент срабатывания, все на расстоянии 270 метров в 60° области поражения спереди от мины атакуются с умением 9 с еще +9 за скорострельность и минус дистанция до объекта.

Считывайте атаку как будто это огромный дробовик  (см HT172-174) c Dmg 2d(0.5) pi-, 55/270 rof 1x700 rcl 1 - если все 700 атак попали во что-то не надо кидать за следующую мишень. Сам же взрыв (6dx3 cr ex) не направленный и поражает все как обычно.



В 2001 выпущена "не летальная" M5 работает точно так-же но заполнена 600 пластиковыми шариками.  Dmg 1d-2(0.2) cr, 15/75 rof 1x600 rcl 1 - стоит $350, взрыв 2d+1 cr ex

</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>50</value>
	<weight>3.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx3 cr ex</damage>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мины</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>M86 PDM</description>
	<description-loc>США 1991

<img data-src="http://weapons.gurps.ru/img/296.png">

<img data-src="http://weapons.gurps.ru/img/297.png">

Holdout -2

Так-же применяются умения Soldier или Traps+2



Размером с гранату противопехотная мина. Американские спец. подразделения используют такие при отступлении или для быстрых засад. Необходимо просто взвести ее и бросить на землю. Через 25 секунд, она выбросит семь 20' (6м) нитей-растяжек. Еще через 40 секунд она встает на боевой взвод - если нить потревожена она взлетает вверх на 6' (2м) и взрывается. 

Если не сработала  в течении четырех часов - она самоподрывается.

Некоторые артиллерийские снаряды и кассетные бомбы TL8 несут подобные заряды.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>1</legality_class>
	<value>45</value>
	<weight>1.2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>8d [2d] cr ex</damage>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Мины</category>
		<category> Страна:США</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Коктейль молотова</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/298.png">

Коктейль Молотова (исходное название - коктейль для Мотлотова) это стеклянная бутылка на половину наполненная бензином в который запихана тряпка - запал. Когда бутылка рабивается - вылившееся топливо загорается от тряпки.



См. правила B411. Обычно Malf 12+



Мятежники и партизаны часто используют Коктейль Молотова как противопехотный снаряд, однако в оригинале целью были бронированные автомобили. В TL6 и начале TL7 большинство бронеавтомобилей были просто гражданскими машинам с броней и не имели не защищенный двигатель. Считайте это как атаку на жизненно важные органы -3 к попаданию (B554).

Попадание означает, что авто должен сделать бросок по HT и каждые 3 секунды пока горит огонь (обычно 2dx5 секунд). Провал означает двигатель заглох, следующий провал означает, двигатель загорелся и полностью уничтожен.



Есть куча вариантов рецепта - смешать бензин с дизелем или маслом, добавить резины как загуститель и т.п. но по большому счету эффект не меняется. Чтобы сделать Коктейль Молотова не нужно броска умения, требуется 5 минут.

</description-loc>
	<tech_level>6</tech_level>
	<value>-</value>
	<weight>1-2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>3d fire + 1d c.</damage>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Гранаты</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Водяное ружье</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/299.png">

Можно приделать ремень.

Это модная детская игрушка с помпой, действующей как карабин. Наполнить литровый бак занимает 10 секунд. Заменить бак занимает один маневр Ready. После этого надо накачать помпу - еще 5 сек. 

Более крупные версии с 5 литровым баком -  Range 12, Wt. 18/15, Shots 15, Cost $45, 10 сек накачать бак.

Можно зарядить водой (обычной или святой), водорастворимой краской, вонючей жидкостью (HT171), алкоголем, растворенным чесноком и т.п. Кислоты и прочие едкие вещества не подойдут - они слишком быстро испортят пластик пистолета.

Эффект зависит от жидкости. см жикдости в лицо (B405). Вода может раздражать человека -1 к действиям. Краска может ослепить того кто носит очки. и т.п.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>30</value>
	<weight>3.5/2</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>Special</damage>
		<strength>4†</strength>
		<accuracy>0</accuracy>
		<range>8</range>
		<rate_of_fire>Jet</rate_of_fire>
		<shots>2</shots>
		<default>
			<type>Skill</type>
			<name>Liquid projector</name>
			<specialization>Squirt Carabine</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Нелетальное</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>H&amp;K PSG1</description>
	<description-loc>Германия 1982

<img data-src="http://weapons.gurps.ru/img/497.png">

<img data-src="http://weapons.gurps.ru/img/498.png">

The PSG1 (1982-) Снайперская версия, более длинный ствол, настраиваемый приклад, анатомическая пистолетная ручка с выпечкой для большого пальца, настраиваемый курок, и 6х прицел с подсветкой сетки (+2 Acc и убирает -1 из штрафов за темноту, 3xT/100 час.) 



Это высококачественное оружие. Не имеет железного прицела, пламя-гасителя и сошек. Предполагается что будет оперта на окоп или на трипод (2.25 lbs - +1 Acc за опору). Поставляется с магазином на 5 патронов на может использовать магазины от G3. Антитеррористические подразделения взяли ее на вооружение.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>9,100/26</value>
	<weight>18.5/0.7</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi</damage>
		<strength>10†</strength>
		<accuracy>6+2</accuracy>
		<range>1,000/4,400</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>5+1(3)</shots>
		<bulk>-6</bulk>
		<ammo>7.62x51mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Германия</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Enfield L42A1</description>
	<description-loc>Великобритания 1965

<img data-src="http://weapons.gurps.ru/img/515.png">

Коротко-магазинная винтовка служил в британской армии в течении обоих мировых войн. широко распространилась по британским колониям, так чтобы производилась в Австралии и Индии (где используется и по сей день).

Снайперская винтовка 3X прицелом под патрон  использовать до конца 80x.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>700</value>
	<weight>10.8/1</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>7d pi, Acc 6+1</damage>
		<strength>10†</strength>
		<accuracy>6+1</accuracy>
		<range>1,000/4,200</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>3</recoil>
		<ammo>7.62x51mm NATO</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Винтовки Снайперские</category>
		<category> Страна:Великобритания</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>РПГ-18 «Муха»</description>
	<description-loc>Россия / СССР 1971

<img data-src="http://weapons.gurps.ru/img/551.png">

Первая цифра в дистанции это минимальная дистанция а не 1/2D

Опасный выхлоп. Обратная вспышка 1d+2 burn



Крепление для ремня (HT154)

Копия HEC M72A2

Одноразовый ракетомет стреляющий HEAT

В сложенном состоянии всего 60см длиной (Holdout -3). Стрелку необходимо три секунды для выдвижения трубы и прицелов.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>1</legality_class>
	<value>500</value>
	<weight>5.9</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6dx5(10) cr ex 6dx2 cr ex</damage>
		<strength>6†</strength>
		<accuracy>1</accuracy>
		<range>10/1,100</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>1</shots>
		<bulk>-4</bulk>
		<recoil>-1</recoil>
		<ammo>64mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Противотанковые</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ручной Пулемет Калашникова (РПК)</description>
	<description-loc>Россия / СССР 1955

<img data-src="http://weapons.gurps.ru/img/605.png">

РПК это продолжение серии АК-47 с удлиненным стволом, сошками и большим магазином.

Так-же существует 75 патронный магазин (-1 Bulk, $264, 4.6 lbs.). Оба магазина так-же подходят к обычному АК-47.

РПК-74 (1976-1990) версия на основе АК-74: Dmg 5d+1 pi, Acc 5, Range 650/4,200, Wt. 12.2/1.8, Shots 45+1(3), ST 9B†, Cost $900/$36. Так-же был барабан на 90 патронов (-1 Bulk, $262, 4.6 lbs.). Магазины так-же подходят к АК-74.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900/32</value>
	<weight>13/2.5</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>6d pi</damage>
		<strength>9B†</strength>
		<accuracy>5</accuracy>
		<range>600/3,900</range>
		<rate_of_fire>10</rate_of_fire>
		<shots>40+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>7.62x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ручной Пулемет Калашникова (РПК) (RPK-74)</description>
	<description-loc>Россия / СССР 1955

<img data-src="http://weapons.gurps.ru/img/605.png">

РПК это продолжение серии АК-47 с удлиненным стволом, сошками и большим магазином.

Так-же существует 75 патронный магазин (-1 Bulk, $264, 4.6 lbs.). Оба магазина так-же подходят к обычному АК-47.

РПК-74 (1976-1990) версия на основе АК-74: Dmg 5d+1 pi, Acc 5, Range 650/4,200, Wt. 12.2/1.8, Shots 45+1(3), ST 9B†, Cost $900/$36. Так-же был барабан на 90 патронов (-1 Bulk, $262, 4.6 lbs.). Магазины так-же подходят к АК-74.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>2</legality_class>
	<value>900/36</value>
	<weight>12.2/1.8</weight>
	<reference>HT</reference>
	<ranged_weapon>
		<damage>5d+1 pi</damage>
		<strength>9B†</strength>
		<accuracy>5</accuracy>
		<range>650/4,200</range>
		<rate_of_fire>11</rate_of_fire>
		<shots>45+1(3)</shots>
		<bulk>-5</bulk>
		<recoil>2</recoil>
		<ammo>5.45x39mm</ammo>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>0</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gun!</name>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<categories>
		<category>Пулеметы</category>
		<category> Страна:Россия / СССР</category>
	</categories>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Стальной жилет</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/311.png">
Торс, только спереди
Скрывается под одежу или как одежа

Бронированный жилет скрытого ношения, относительно легкий и дешевый. К примеру использовался во времена гражданской войны в США. Это стандартный  военного стиля камзол с карманами для стальных вставок спереди. С заклепками центре где живет застегивается. Пехотинцев считали его слишком тяжелым, днем становилось слишком жарко во время длинного перехода, также они считали его не особо эффективным против оружие мушкетов, несмотря на это он был очень расстроен на полях сражений. </description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value>150</value>
	<weight>7 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso (front)</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Стальной корсет</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/312.png">
Торс

Броня тяжелой кавалерии. До первой мировой войны большинство европейских правителей имела хотя бы один полк кирасиров -  здоровых мужиков на здоровых лошадях,  подготовленных защищать Родину с помощью меча. Их броня часто было  сильно отполирована для  парадов до блеска (и часто использовалось как зеркало!)  Однако всегда была одежда для сокрытия ,брони на поле боя.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value> 600</value>
	<weight>12 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>10</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Шелковый жилет</description>
	<value>800 </value>
	<weight>6 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/313.png">
		Торс
Скрывается под одежу или как одежа
DR 4 DR против piercing и cutting, против остальных  2 DR

+ Стальные пластины (+5F DR, +$400, +6lbs)

Жилет с толстым подкладом часто одевался состоятельными гражданами. Даже заметила сложно поверить что это броня. Во времена русско-японской войны более 50 тысяч таких жилетов были усилены остальные пластинами для русских солдат.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Шелковый жилет - дополнительные стальные пластины</description>
	<value>400</value>
	<weight>6 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso (front)</location>
		<amount>5</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/313.png">
		Торс
Скрывается под одежу или как одежа
DR 4 DR против piercing и cutting, против остальных  2 DR

+ Стальные пластины (+5F DR, +$400, +6lbs)

Жилет с толстым подкладом часто одевался состоятельными гражданами. Даже заметила сложно поверить что это броня. Во времена русско-японской войны более 50 тысяч таких жилетов были усилены остальные пластинами для русских солдат.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Shin Guards</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/331.png">
Ноги (2/6) спереди

Стальные поножи были разработаны для солдат во время американской гражданской войны, но использовались не долго. Защищают только нижнюю часть ноги (2/6) - и только спереди.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value>50</value>
	<weight>1.5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>Legs (front 2/6)</location>
		<amount>4</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Комбинированная броня</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/314.png">
Торс, пах

Защита груди и Пахом сделанная из слоев  пропитанного смолой шелком, Елена, и хлопка. К примеру “Chemico Body Shield”  которые делали в Англии.  Толщиной примерно дюйм, был покрыт парафином, имел карманы для патронов спереди.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>150</value>
	<weight>6 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>4</amount>
	</dr_bonus>		
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Броня пулеметчика</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/315.png">
Торс, Пах - только спереди.

Разные грудные латы как Infanterie-Panzer,  которые носили немецкие Солдаты во времена Первой Мировой.  Было произведено около полумиллиона единиц, большей частью для пулеметчиков и часовых. Т.е. тех кто не перемещается во время боя
</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>300</value>
	<weight>20 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso (front)</location>
		<amount>14</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin (front)</location>
		<amount>14</amount>
	</dr_bonus>		
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Легкая броня (торс)</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/316.png">
Торс, Пах
Скрывается под одежу или как одежа

Стальная броня с толстым подкладом из резины. Закрывает спереди и сзади, разработана для того чтобы защищать от осколков снарядов, и пистолетных патронов. Также доступна защита ног и рук. 

50 комплектов для Фрнации были сделан полным комплектом:
Для рук  $300 5lbs  DR 4 (5/6 зациты).
Для ног $350 8lbs  DR 4 (5/6 зациты).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>1,000</value>
	<weight>9 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>5</amount>
	</dr_bonus>		
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Легкая броня (руки)</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/316.png">
Торс, Пах
Скрывается под одежу или как одежа

Стальная броня с толстым подкладом из резины. Закрывает спереди и сзади, разработана для того чтобы защищать от осколков снарядов, и пистолетных патронов. Также доступна защита ног и рук. 

50 комплектов для Фрнации были сделан полным комплектом:
Для рук  $300 5lbs  DR 4 (5/6 зациты).
Для ног $350 8lbs  DR 4 (5/6 зациты).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>300</value>
	<weight>5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>arms (5/6)</location>
		<amount>4</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Легкая броня (ноги)</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/316.png">
Торс, Пах
Скрывается под одежу или как одежа

Стальная броня с толстым подкладом из резины. Закрывает спереди и сзади, разработана для того чтобы защищать от осколков снарядов, и пистолетных патронов. Также доступна защита ног и рук. 

50 комплектов для Фрнации были сделан полным комплектом:
Для рук  $300 5lbs  DR 4 (5/6 зациты).
Для ног $350 8lbs  DR 4 (5/6 зациты).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>350</value>
	<weight>8 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>legs (5/6)</location>
		<amount>4</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пуленепробиваемый жилет</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/317.png">
<img data-src="http://weapons.gurps.ru/img/328.png">
Торс
Скрывается под одежу или как одежа

Жилет из перекрывающихся стальных пластин соединенных с помощью ткани, сделай так чтобы выглядеть как обычный жилет от костюма. Защищает спереди и сзади. В двадцатых тридцатых годах такие жилеты стали очень популярны среди полицейских, кримминалитета и правительственных агентов. Висборд (разработчки) производящая их даже устроила целую компанию а демонстрация эффективности ихнего продукта: Он устраивал шоу среди толпы стреляет полицейского удерживая такой костюм. такая реклама работала. Даже Рузвельт носил такой.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>750</value>
	<weight>8 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Желет Flak</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/318.png">
Торс

Flak это сокращение от Fliegerabwehrkanone, “противо воздушная пушка”. Эти жилеты разрабатывались во времена Второй мировой войны чтобы защитить  экипаж самолетов от пулеметов ПВО.  Сдельные из марганцовой “стали Гадфильда” с нейлоновым подкладом. Были тяжелыми, неудобными, их невозможно было скрыть. 
</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>500</value>
	<weight>20 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>7</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Противоосколочный жилет</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/319.png">
Торс, Пах
Защищает "жизненно важные органы" с DR 8 только спереди

Нейлоновый жилет с алюминиевыми вставками для защиты спереди. Разработан для защиты от осколков артиллерии и ручных гранат, не останавливает пули. Американские морские пехотинцы взяли на вооружение 50000  жилетов во Вторую мировую войну запятая однако слишком поздно чтобы понять их эффективность в бою. Использовались в корейской войне.
</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>200</value>
	<weight>13.5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>6</amount>
	</dr_bonus>	
</equipment>
<equipment version="3">
	<description>Противоосколочный желет продвинутый</description>
	<value>400</value>
	<weight>8 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/320.png">
		Торс
DR 4 против piercing и cutting, против остальных  2 DR
+ Trauma Plates: DR +18, +$3,600 +15lbs, LC=2

+ Руки DR 3 против piercing и cutting, против остальных  1 DR, +$100, +2Lbs, можно носить отдельно скрытно.

+ Ноги DR 3 против piercing и cutting, против остальных  1 DR, +$100, +4Lbs, можно носить отдельно скрытно.

+ Кисти DR 3 против piercing и cutting, против остальных  1 DR - перчатки  +$30, +1Lbs

Типичный защитный жилет из баллистического нейлона и подобных материалов. Как пример жилеты M1952 и M69  которые носили  пехотинцы корейский вьетнамской войне.  Некоторые модели могут быть дополнены тяжелыми  керамическими стекловолокоными панелями, танкисты, экипажи лодок использовали такие во Вьетнаме.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Противоосколочный желет продвинутый - пластины Trauma Plates</description>
	<value>3,600</value>
	<weight>15 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>18</amount>
	</dr_bonus>
	<legality_class>2</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/320.png">
		Торс
DR 4 против piercing и cutting, против остальных  2 DR
+ Trauma Plates: DR +18, +$3,600 +15lbs, LC=2

+ Руки DR 3 против piercing и cutting, против остальных  1 DR, +$100, +2Lbs, можно носить отдельно скрытно.

+ Ноги DR 3 против piercing и cutting, против остальных  1 DR, +$100, +4Lbs, можно носить отдельно скрытно.

+ Кисти DR 3 против piercing и cutting, против остальных  1 DR - перчатки  +$30, +1Lbs

Типичный защитный жилет из баллистического нейлона и подобных материалов. Как пример жилеты M1952 и M69  которые носили  пехотинцы корейский вьетнамской войне.  Некоторые модели могут быть дополнены тяжелыми  керамическими стекловолокоными панелями, танкисты, экипажи лодок использовали такие во Вьетнаме.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Противоосколочный желет продвинутый (руки)</description>
	<value>100</value>
	<weight>2 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>arms</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>2</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/320.png">
		Торс
DR 4 против piercing и cutting, против остальных  2 DR
+ Trauma Plates: DR +18, +$3,600 +15lbs, LC=2

+ Руки DR 3 против piercing и cutting, против остальных  1 DR, +$100, +2Lbs, можно носить отдельно скрытно.

+ Ноги DR 3 против piercing и cutting, против остальных  1 DR, +$100, +4Lbs, можно носить отдельно скрытно.

+ Кисти DR 3 против piercing и cutting, против остальных  1 DR - перчатки  +$30, +1Lbs

Типичный защитный жилет из баллистического нейлона и подобных материалов. Как пример жилеты M1952 и M69  которые носили  пехотинцы корейский вьетнамской войне.  Некоторые модели могут быть дополнены тяжелыми  керамическими стекловолокоными панелями, танкисты, экипажи лодок использовали такие во Вьетнаме.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Противоосколочный желет продвинутый (ноги)</description>
	<value>100</value>
	<weight>4 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>arms</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms</location>
		<amount>2</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/320.png">
		Торс
DR 4 против piercing и cutting, против остальных  2 DR
+ Trauma Plates: DR +18, +$3,600 +15lbs, LC=2

+ Руки DR 3 против piercing и cutting, против остальных  1 DR, +$100, +2Lbs, можно носить отдельно скрытно.

+ Ноги DR 3 против piercing и cutting, против остальных  1 DR, +$100, +4Lbs, можно носить отдельно скрытно.

+ Кисти DR 3 против piercing и cutting, против остальных  1 DR - перчатки  +$30, +1Lbs

Типичный защитный жилет из баллистического нейлона и подобных материалов. Как пример жилеты M1952 и M69  которые носили  пехотинцы корейский вьетнамской войне.  Некоторые модели могут быть дополнены тяжелыми  керамическими стекловолокоными панелями, танкисты, экипажи лодок использовали такие во Вьетнаме.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Противоосколочный желет продвинутый (перчатки)</description>
	<value>30</value>
	<weight>1 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>hands</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>hands</location>
		<amount>2</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>3</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/320.png">
		Торс
DR 4 против piercing и cutting, против остальных  2 DR
+ Trauma Plates: DR +18, +$3,600 +15lbs, LC=2

+ Руки DR 3 против piercing и cutting, против остальных  1 DR, +$100, +2Lbs, можно носить отдельно скрытно.

+ Ноги DR 3 против piercing и cutting, против остальных  1 DR, +$100, +4Lbs, можно носить отдельно скрытно.

+ Кисти DR 3 против piercing и cutting, против остальных  1 DR - перчатки  +$30, +1Lbs

Типичный защитный жилет из баллистического нейлона и подобных материалов. Как пример жилеты M1952 и M69  которые носили  пехотинцы корейский вьетнамской войне.  Некоторые модели могут быть дополнены тяжелыми  керамическими стекловолокоными панелями, танкисты, экипажи лодок использовали такие во Вьетнаме.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Авиационная броня</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/321.png">
Торс - только спереди

Пластины из твердого оксида алюминия и бронестекла внутри разгрузки из баллистического нейлона. В армии США с 1966. Вертолетчики прозвании ее “Куриными латами”. Указаны характеристики для защиты только спереди - так носили пилоты. Пулеметчики вертолетов носили вариант с защитой и сзади +$1,100, +34lbs</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>600</value>
	<weight>15 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso (front)</location>
		<amount>20</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Авиационная броня (пулеметчика)</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/321.png">
Торс - только спереди

Пластины из твердого оксида алюминия и бронестекла внутри разгрузки из баллистического нейлона. В армии США с 1966. Вертолетчики прозвании ее “Куриными латами”. Указаны характеристики для защиты только спереди - так носили пилоты. Пулеметчики вертолетов носили вариант с защитой и сзади +$1,100, +34lbs</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>1700</value>
	<weight>49 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>20</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Плечевые накладки</description>
	<value>50</value>
	<weight>5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso (1/6)</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso (1/6)</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>arms (1/6)</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>arms (1/6)</location>
		<amount>2</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/322.png">
		Торс (1/6), Руки(1/6)
Сетчатая защита для американского футбола. Защищает верхнюю часть торса и плечи.

DR 3 против crush и DR 1 от остального.
Дает +1 к отражению повреждений и DR 3 против slam атак (B371).
	</description-loc>
</equipment>
<equipment version="3">
	<description>Ранний бронежилет скрытого ношения</description>
	<value>200</value>
	<weight>2.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/323.png">
		Торс
DR 8 DR против piercing и cutting, против остальных 2 DR
Скрывается под одежу или как одежа

Бронежилет скрытого ношения производился с 1970. В TL7 может быть использована с этого периода (с разрешения мастера).
	</description-loc>
</equipment>
<equipment version="3">
	<description>Бронежилет скрытого ношения</description>
	<value>1,000</value>
	<weight>2 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>	
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/324.png">
		Торс
DR 12 DR против piercing и cutting, против остальных 5 DR
Скрывается под одежу или как одежа

Легкий и самый незаметный жилет ныне представленный на рынке. Может быть дополнен защитными пластинами. 

Противо-ножевые пластины. Небольшие легкие металлические пластины разработанные для защиты от ножа, а не от огнестрельного оружия. Закрывают только жизненно важные органы спереди. 4 DR. $150, 0.5 lb. LC3. 

Легкие пластины. Небольшие керамические пластины защищающие жизненно важные органы спереди. +25 DR. $250, 3 lbs. LC3. 

Крупные керамические пластины защищающие все тело спереди или сзади. чтобы защитить все тело необходимо две такие. +25 DR. $500, 4 lbs. LC3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Бронежилет скрытого ношения - противо-ножевые пластины</description>
	<value>150</value>
	<weight>0.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>vitals (front)</location>
		<amount>4</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/324.png">
		Торс
DR 12 DR против piercing и cutting, против остальных 5 DR
Скрывается под одежу или как одежа

Легкий и самый незаметный жилет ныне представленный на рынке. Может быть дополнен защитными пластинами. 

Противо-ножевые пластины. Небольшие легкие металлические пластины разработанные для защиты от ножа, а не от огнестрельного оружия. Закрывают только жизненно важные органы спереди. 4 DR. $150, 0.5 lb. LC3. 

Легкие пластины. Небольшие керамические пластины защищающие жизненно важные органы спереди. +25 DR. $250, 3 lbs. LC3. 

Крупные керамические пластины защищающие все тело спереди или сзади. чтобы защитить все тело необходимо две такие. +25 DR. $500, 4 lbs. LC3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Бронежилет скрытого ношения - легкие пластины</description>
	<value>250</value>
	<weight>3 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>vitals (front)</location>
		<amount>25</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/324.png">
		Торс
DR 12 DR против piercing и cutting, против остальных 5 DR
Скрывается под одежу или как одежа

Легкий и самый незаметный жилет ныне представленный на рынке. Может быть дополнен защитными пластинами. 

Противо-ножевые пластины. Небольшие легкие металлические пластины разработанные для защиты от ножа, а не от огнестрельного оружия. Закрывают только жизненно важные органы спереди. 4 DR. $150, 0.5 lb. LC3. 

Легкие пластины. Небольшие керамические пластины защищающие жизненно важные органы спереди. +25 DR. $250, 3 lbs. LC3. 

Крупные керамические пластины защищающие все тело спереди или сзади. чтобы защитить все тело необходимо две такие. +25 DR. $500, 4 lbs. LC3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Бронежилет скрытого ношения - крупные пластины (спереди)</description>
	<value>500</value>
	<weight>4 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso (font)</location>
		<amount>25</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/324.png">
		Торс
DR 12 DR против piercing и cutting, против остальных 5 DR
Скрывается под одежу или как одежа

Легкий и самый незаметный жилет ныне представленный на рынке. Может быть дополнен защитными пластинами. 

Противо-ножевые пластины. Небольшие легкие металлические пластины разработанные для защиты от ножа, а не от огнестрельного оружия. Закрывают только жизненно важные органы спереди. 4 DR. $150, 0.5 lb. LC3. 

Легкие пластины. Небольшие керамические пластины защищающие жизненно важные органы спереди. +25 DR. $250, 3 lbs. LC3. 

Крупные керамические пластины защищающие все тело спереди или сзади. чтобы защитить все тело необходимо две такие. +25 DR. $500, 4 lbs. LC3.
	</description-loc>
</equipment><equipment version="3">
	<description>Бронежилет скрытого ношения - крупные пластины</description>
	<value>1000</value>
	<weight>8 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>25</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/324.png">
		Торс
DR 12 DR против piercing и cutting, против остальных 5 DR
Скрывается под одежу или как одежа

Легкий и самый незаметный жилет ныне представленный на рынке. Может быть дополнен защитными пластинами. 

Противо-ножевые пластины. Небольшие легкие металлические пластины разработанные для защиты от ножа, а не от огнестрельного оружия. Закрывают только жизненно важные органы спереди. 4 DR. $150, 0.5 lb. LC3. 

Легкие пластины. Небольшие керамические пластины защищающие жизненно важные органы спереди. +25 DR. $250, 3 lbs. LC3. 

Крупные керамические пластины защищающие все тело спереди или сзади. чтобы защитить все тело необходимо две такие. +25 DR. $500, 4 lbs. LC3.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Штурмовой жилет</description>
	<value>900</value>
	<weight>8 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>torso</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>groin</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/325.png">
		Торс, Пах
DR 12 DR против piercing и cutting, против остальных 5 DR
+ Trauma Plates Торс DR +23, +$600, +8lbs

Тяжелый противопулевой жилет, использующиеся спецназом, и солдатами. Съемная пластины способна дать защитам даже от винтовок. защита Паха также от соединяемых. Эти бронежилеты сейчас находятся на вооружении армия США.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Штурмовой жилет - Trauma Plates</description>
	<value>600</value>
	<weight>8 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>23</amount>
	</dr_bonus>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/325.png">
		Торс, Пах
DR 12 DR против piercing и cutting, против остальных 5 DR
+ Trauma Plates Торс DR +23, +$600, +8lbs

Тяжелый противопулевой жилет, использующиеся спецназом, и солдатами. Съемная пластины способна дать защитам даже от винтовок. защита Паха также от соединяемых. Эти бронежилеты сейчас находятся на вооружении армия США.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Противо ножевой жилет</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/326.png">
Торс - спереди

Жилет очень  плотного плетения нити.  хорошо останавливает колющие атаки наряду с остальными. Используется охраной тюрем, и полицейскими в районах с где не распространено огнестрельное оружие.

</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>300</value>
	<weight>4 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>torso (front)</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Наштанники (chaps)</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/330.png">
Ноги

Chaparreras носили ковбои для защиты от колючек укусов во время работы со скотом.</description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value>40</value>
	<weight>2 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>legs</location>
		<amount>1*</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>"Шкура дракона" чашуйчатый бронежилет</description>
	<value>4,600</value>
	<weight>17 lb</weight>
	<quantity>1</quantity>
	<dr_bonus except-damage-type="yes">
		<location>torso</location>
		<amount>35</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>full body</location>
		<amount>5</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>2</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/327.png">
		<img data-src="http://weapons.gurps.ru/img/329.png">
		Торс
DR 35, против crush только 5 DR

"Pinnacle Armor’s SOV" - выглядит как обычный баллистический жилет, даже более хлипкий, однако дает куда большую защиту. Вместо тяжелых пластин он имеет так называемую “чашуйчатую” структуру - Перекрывающиеся чешуйки  5-10 см в диаметре, сделано из запатентованного титана керамического сплава. это единственный бронежилет скрытого ношения, способный выдержать автоматическое оружие. +4  при сокрытии.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Авиационные поножи</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/332.png">
Ноги - спереди (3/6 защиты)

Тяжелые баллистические наколенники, использовались на вертолетах в течение вьетнамского конфликта. Защищает только переднюю часть ноги от колена до щиколотки (3/6 защиты)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>200</value>
	<weight>18 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>legs (front) 3/6</location>
		<amount>15</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Защитные наколенники</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/333.png">
Ноги DR 3 цена $100 вес 4
Руки DR 3 цена $100 вес 2

Комплект наколенников Аналог узников сделаны из толстого пластика  с мягким подкладом. Применяются подразделениями по предотвращению массовых беспорядков и тюремной охраной. Могут смягчить удар камнем и достаточно легкие для комфортного ношения. Очень похожая защита используется в контактных видах спорта.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>100</value>
	<weight>4 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>legs</location>
		<amount>3</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Защитные налокотники</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/333.png">
Ноги DR 3 цена $100 вес 4
Руки DR 3 цена $100 вес 2

Комплект наколенников Аналог узников сделаны из толстого пластика  с мягким подкладом. Применяются подразделениями по предотвращению массовых беспорядков и тюремной охраной. Могут смягчить удар камнем и достаточно легкие для комфортного ношения. Очень похожая защита используется в контактных видах спорта.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>100</value>
	<weight>2 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>arms</location>
		<amount>3</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Баллистические рейтузы</description>
	<value>400</value>
	<weight>8 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>legs (front)</location>
		<amount>5</amount>
	</dr_bonus>
	<dr_bonus>
		<location>legs (front)</location>
		<amount>7</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/334.png">
		Ноги
DR 12 спереди против piercing и cutting, против остальных DR 5 спереди

Гибкие рейтузы из баллистической ткани, используются штурмовыми войсками. Они громоздки и плохо скрываемы.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Защита предплечья и подмышек (DAP)</description>
	<value>200</value>
	<weight>5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>forearms</location>
		<amount>2</amount>
	</dr_bonus>
	<dr_bonus>
		<location>forearms</location>
		<amount>6</amount>
		<damage-type>pi</damage-type>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/335.png">
		DR 8 против piercing и cutting, против остальных 2 DR (2/6 Защиты)

Военное дополнение к штурмовому жилету закрывает только 2/6
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Ботинки саперные</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/337.png">
DR 15(2 сзади) неповоротливые, тяжелые ботинки обернутые в защиту, используются при зачистке минных полей. в стопе так-же есть защитный материал.
-1 к Stealth</description-loc>
	<tech_level>7</tech_level>
	<legality_class>3</legality_class>
	<value>350</value>
	<weight>5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>feet</location>
		<amount>15</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Защитный подшлемок</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/338.png">
<img data-src="http://weapons.gurps.ru/img/339.png">
Череп
DR 3
Скрывается под видом одежды

Подшлемок из тонкого металла,  разработан для ношения под шляпой.
В TL5-6 широко распространены на гражданском рынке. В 1915 Французская армия приобретала такие для своих солдат.
</description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value>50</value>
	<weight>1 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Защита шеи</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/340.png">
<img data-src="http://weapons.gurps.ru/img/341.png">
Шея
DR 2

Кожанный воротник из плотной кожы для защиты шеи от сабельной атаки. Многие солдаты носили такие, но моряки США ассоциируются с ними на столько, что их прозвали "кожанно шеими".</description-loc>
	<tech_level>5</tech_level>
	<legality_class>4</legality_class>
	<value>10</value>
	<weight>0.5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>neck</location>
		<amount>2</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Кавалерийский Шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/342.png">
Череп
DR 4

Никелированный или из нержавеющей стали. Отполирован как зеркало для парадов, он снабжался накидкой для боевых действий. Обычно одевался со стальным корсетом.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>100</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>4</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Шлем пожарника ранний</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/343.png">
Череп
DR 2

Имел защитную железную "корону" и поля защищающие от воды.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>20</value>
	<weight>1 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>2</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Тяжелый шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/344.png">
<img data-src="http://weapons.gurps.ru/img/345.png">
Череп
DR 5

Тяжелый стальной шлем, к примеру немецкий Stahlhelm времен Второй Мировой Войны. 
Прикрепляемая на ремне стальная пластина иногда использовались пулеметчиками чтобы защитить череп спереди (+15 DR, +$10, +5 lbs.).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>100</value>
	<weight>5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Тяжелый шлем - Доп пластина пулеметчика</description>
	<value>10</value>
	<weight>5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull (front)</location>
		<amount>15</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>6</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/344.png">
		<img data-src="http://weapons.gurps.ru/img/345.png">
		Череп
DR 5

Тяжелый стальной шлем, к примеру немецкий Stahlhelm времен Второй Мировой Войны. 
Прикрепляемая на ремне стальная пластина иногда использовались пулеметчиками чтобы защитить череп спереди (+15 DR, +$10, +5 lbs.).
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный Шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/346.png">
Череп
DR 2
Может быть сокрыт под одежду

Знаменитый шлем в стиле "Снуппи", используемый летчиками, танкистами, парашютистами и даже спортсменами. 
С "ушками спаниеля" и толстым подкладом. 
Более поздние модели имели встроенные наушники и стальные пластины сильно улучающие защиту (+4 DR, +$50, +2 lbs.).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>20</value>
	<weight>1 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>2</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный Шлем - поздняя модель</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/346.png">
Череп
DR 2
Может быть сокрыт под одежду

Знаменитый шлем в стиле "Снуппи", используемый летчиками, танкистами, парашютистами и даже спортсменами. 
С "ушками спаниеля" и толстым подкладом. 
Более поздние модели имели встроенные наушники и стальные пластины сильно улучающие защиту (+4 DR, +$50, +2 lbs.).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>70</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>6</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Легкий шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/347.png">
Череп
DR 3

С первой по вторую мировую это стандартный Британский и Американский шлем.
Неглубокий шлем с широким краем.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>40</value>
	<weight>2 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Средний шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/348.png">
Череп
DR 4

Стальной шлем к примеру M1 Американских солдат с 1942 по 1980. 
Съемная подкладка дает еще немного защиты (DR 1, $10, 1 lb.).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value> 60</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>4</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Средний шлем + подклад</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/348.png">
Череп
DR 4

Стальной шлем к примеру M1 Американских солдат с 1942 по 1980. 
Съемная подкладка дает еще немного защиты (DR 1, $10, 1 lb.).</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value> 70</value>
	<weight>4 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Противоосколочный шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/349.png">
<img data-src="http://weapons.gurps.ru/img/350.png">
Череп
DR 5
+ Визор (глаза, лицо DR 1 +$25 +1.5lbs)

Баллистическая смола прессованная в форме шлем. К примеру американский PASGT. 
При работе с демонстрантами одевается визор - он может защитить от камней и прочего бросаемого хлама.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>125</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Противоосколочный шлем - визор</description>
	<value>25</value>
	<weight>1.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>face</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>eyes</location>
		<amount>1</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/349.png">
		<img data-src="http://weapons.gurps.ru/img/350.png">
		Череп
DR 5
+ Визор (глаза, лицо DR 1 +$25 +1.5lbs)

Баллистическая смола прессованная в форме шлем. К примеру американский PASGT. 
При работе с демонстрантами одевается визор - он может защитить от камней и прочего бросаемого хлама.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Каска строительная</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/351.png">
<img data-src="http://weapons.gurps.ru/img/352.png">
Череп
DR 4 против crushing, от остального DR 2

Легкая алюминиевая каска для строителей.  
В TL8 выполнена из пластика и стоит в двое меньше.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>50</value>
	<weight>1 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>4/2</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Шлем пожарника современный</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/353.png">
Череп 
DR 5
+ Визор (глаза, лицо DR 1 +$50 +0.5lbs)</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>250</value>
	<weight>2.5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>5</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Шлем пожарника современный - визор</description>
	<value>50</value>
	<weight>0.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>face</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>eyes</location>
		<amount>1</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/353.png">
		Череп 
DR 5
+ Визор (глаза, лицо DR 1 +$50 +0.5lbs)
	</description-loc>
</equipment>
<equipment version="3">
	<description>Мотоциклетный шлем</description>
	<value>200</value>
	<weight>3 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/354.png">
		<img data-src="http://weapons.gurps.ru/img/355.png">
		Голова
DR 6 от crush от остального DR 3
+ Визор (глаза, лицо DR 1 +$50 +0.5lbs)

Закрытый, противоударный.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Мотоциклетный шлем - визор</description>
	<value>50</value>
	<weight>0.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>face</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>eyes</location>
		<amount>1</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>7</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/354.png">
		<img data-src="http://weapons.gurps.ru/img/355.png">
		Голова
DR 6 от crush от остального DR 3
+ Визор (глаза, лицо DR 1 +$50 +0.5lbs)

Закрытый, противоударный.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Балистический шлем</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/356.png">
<img data-src="http://weapons.gurps.ru/img/357.png">
Череп
DR 12
+ Визор (глаза, лицо DR 10 +$200 +1.4lbs)

Продвинутый балистическйи шлем, к примеру Американский MICH 
Имеет преспособления для крепления ПНВ и фонаря. Некоторые имеют визор для ближнего боя.
</description-loc>
	<tech_level>8</tech_level>
	<legality_class>3</legality_class>
	<value>250</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>12</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Балистический шлем - визор</description>
	<value>200</value>
	<weight>1.4 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>face</location>
		<amount>10</amount>
	</dr_bonus>
	<dr_bonus>
		<location>eyes</location>
		<amount>10</amount>
	</dr_bonus>
	<legality_class>3</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/356.png">
		<img data-src="http://weapons.gurps.ru/img/357.png">
		Череп
DR 12
+ Визор (глаза, лицо DR 10 +$200 +1.4lbs)

Продвинутый балистическйи шлем, к примеру Американский MICH 
Имеет преспособления для крепления ПНВ и фонаря. Некоторые имеют визор для ближнего боя.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Шлем для американского футбола</description>
	<value>150</value>
	<weight>3 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>3</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<dr_bonus>
		<location>face</location>
		<amount>3</amount>
	</dr_bonus>
	<dr_bonus>
		<location>face</location>
		<amount>3</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/358.png">
		Череп, лицо
DR 6 против crush, против остального DR 3

Тяжелый спортивный шлем.
	</description-loc>
</equipment>
<equipment version="3">
	<description>Спортивный шлем</description>
	<value>50</value>
	<weight>2 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>skull</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>skull</location>
		<amount>1</amount>
		<damage-type>cr</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/359.png">
		Череп
DR 2 против crush, против остального DR 1

Спортивный шлем используемый хоккеистами, соубордистами, альпинистами и т.п.
Штурмовики тоже иногда одевают такие для защиты от ударов и падений.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Шлем против бунтов</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/360.png">
Череп лицо 
DR 6
+ Визор (глаза, лицо DR +1 +$50 +0.5lbs)

Это шлем для подразделений работающий при скоплении гражданских.
Имеет металлическую сетку как у шлема для американского футбола.
Но можно добавить поликорбанатный визор. 
Так-же позволяет одеть маску от газов под низ.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>200</value>
	<weight>3 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Броня</category>
	</categories>
	<dr_bonus>
		<location>skull</location>
		<amount>6</amount>
	</dr_bonus>
</equipment>
<equipment version="3">
	<description>Шлем против бунтов - визор</description>
	<value>50</value>
	<weight>0.5 lb</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>face</location>
		<amount>1</amount>
	</dr_bonus>
	<dr_bonus>
		<location>eyes</location>
		<amount>1</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>8</tech_level>
	<categories>
		<category>Броня</category>
	</categories>
	<reference>HT</reference>
	<description-loc>
		<img data-src="http://weapons.gurps.ru/img/360.png">
		Череп лицо 
DR 6
+ Визор (глаза, лицо DR +1 +$50 +0.5lbs)

Это шлем для подразделений работающий при скоплении гражданских.
Имеет металлическую сетку как у шлема для американского футбола.
Но можно добавить поликорбанатный визор. 
Так-же позволяет одеть маску от газов под низ.
	</description-loc>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Пуленепробиваемый щит</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/361.png">
DB 2 
DR 10 
HP 80

Тяжелый стальной щит использовался военными и полицией в первой половине 20го века.
Обычно имеет щель для ведения стрельбы и опоры винтовки.</description-loc>
	<tech_level>6</tech_level>
	<legality_class>4</legality_class>
	<value>300</value>
	<weight>30 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Щит против бунтов</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/362.png">
DB 2
DR 7
HP 40

Простой среднеразмерный щит из поликорбаната
Обычно с надписью "полиция" спереди.</description-loc>
	<tech_level>7</tech_level>
	<legality_class>4</legality_class>
	<value>300</value>
	<weight>7.5 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Штурмовой щит средний</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/363.png">
DR 12
DB 2
HP 40

Тяжелый щит используемый спецподразделениями для проникновения в здания
Использует бронепластины и способен выдержать пистолетный огонь.
Некоторые модели оснащены светом или видео дисплеями на передней панели, а иногда и ступенями что позволяет использовать их для преодоления стен и т.п.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>1,200</value>
	<weight>17 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment>
<equipment version="3">
	<quantity>1</quantity>
	<description>Штурмовой щит большой</description>
	<description-loc> 
<img data-src="http://weapons.gurps.ru/img/364.png">
DB 3
DR 12
HP 60

Тяжелый щит используемый спецподразделениями для проникновения в здания
Использует бронепластины и способен выдержать пистолетный огонь.
Некоторые модели оснащены светом или видео дисплеями на передней панели, а иногда и ступенями что позволяет использовать их для преодоления стен и т.п.</description-loc>
	<tech_level>8</tech_level>
	<legality_class>4</legality_class>
	<value>1,400</value>
	<weight>22 lb</weight>
	<reference>HT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment>

</equipment_list>`;
 standaloneLibs['LowTech-rus.eqp']=`<!--?xml version="1.0" encoding="UTF-8"?-->
<name>Mentor: Low Tech</name>
<notes>Low Tech - Снаряжение + оружие и доспехи из базы <a href="http://weapons.gurps.ru/" target="_blank">Gurps Weapons</a><br><br><a href="editor.phtml?v=60000000000000000000000000000000" target="_blank">Редактироване библиотеки</a> разрешно, но с предмодерацией</notes>
<equipment_list id="bf224231-5ded-45bd-919f-dc3555bc0580" version="1">
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	


















































	
<equipment version="3">
		<quantity>1</quantity>
		<description>Аркбаллиста</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>15000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>3d-1 imp</damage>
			<strength>15M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>360/450</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>-9</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (p. LT83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Arbalest
<img data-src="lib/img/151591524147.png">
Средневековое орудие, по форме напоминающее большой арбалет; на самом деле, его иногда называют «станковым арбалетом». Здесь речь идет именно о таком большом орудие. Встроенная лебедка обеспечивает достаточную силу натяжения.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Аркбаллиста - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>16.5</value>
		<weight>0.5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Arbalest Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Аркбаллиста - тренога</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>800</value>
		<weight>32</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Arbalest Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Аркебуза</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>150</value>
		<weight>10</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>2d+2 pi+</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>65/660</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Arquebus
<img data-src="http://weapons.gurps.ru/img/1558.png">

С фитильным замком

Самое первое ружьё; название происходит от слова hackbusch, что значит "крюк-ствол", что скорее всего относится к изгибающемуся вниз прикладу. Ружья этого типа начали использовать в Европе вскоре после 1500 и в Китае во времена династии Мин, которая использовала их, чтобы завершить изгнание монголов. Аркебузы используют порошковый порох, а не гранулированный.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Аркебуза- пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.05</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Arquebus Bullet
		<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Атлатль</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>sw-1 imp</damage>
			<strength>5</strength>
			<usage>Shoot Dart</usage>
			<accuracy>1</accuracy>
			<range>x3/x4</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>sw+1 imp</damage>
			<strength>6</strength>
			<usage>Shoot Javelin</usage>
			<accuracy>3</accuracy>
			<range>x2/x3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Atlatl
<img data-src="http://weapons.gurps.ru/img/1559.png">

Ацтеки. 

Палка предназначенная для метания дротиков. Это название происходит из языка науатль (ацтекского), однако похожее оружие существует повсеместно. Использующий помещает дротик в выемку, после чего, запускает его мощным взмахом палки, удерживаемой одной рукой.



Требует обеих рук для Подготовки, но только одной руки для атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Атлатль дротик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT77</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Atlatl Dart
<img data-src="lib/img/151676824667.png">
</description-loc>
	</equipment><equipment version="3">
	<description>Балисонг</description>
	<value>50</value>
	<weight>0.5</weight>
	<quantity>1</quantity>
	<notes>+1 к Holdout</notes>
	<melee_weapon>
		<damage>sw-3 cut</damage>
		<strength>5</strength>
		<reach>C,1</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Swung</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>thr-1 imp</damage>
		<strength>5</strength>
		<reach>C</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Thrust</usage>
	</melee_weapon>
	<legality_class>4</legality_class>
	<tech_level>3</tech_level>
	<categories>
		<category>Холодное оружие</category>
	</categories>
	<reference>LT54</reference>
	<description-loc>
		Balisong
		<img data-src="http://weapons.gurps.ru/img/1566.png">
		Филиппины. 

Нож-бабочка



Складной нож без хвостовика с парой пустых рукояток, которые поворачиваются вперёд, чтобы закрыть нож, или назад, служа рукоятью. Иногда называется ножом-бабочкой. Традиционные балисонги с низких ТУ, такие как описан здесь, требуют манёвра Подготовки, чтобы их открыть. Их нельзя открыть "взмахом" броском Быстрого Выхватывания (балисонг).

+1 Holdout
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  0.5кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>3500</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>4d+1 cr</damage>
			<strength>20M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-10</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 1-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  0.5кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>1</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 1-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  0.5кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1500</value>
		<weight>60</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 1-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  10кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>67500</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>9d cr</damage>
			<strength>116M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>300/375</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(55)</shots>
			<bulk>-15</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(55)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 20-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 1 человек

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  15кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>102500</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>10d+1 cr</damage>
			<strength>143M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>310/385</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(45)</shots>
			<bulk>-15</bulk>
			<recoil>1</recoil>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(45)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 2 чел. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 30-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 2 человека

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  1кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>6500</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>5d-1 cr</damage>
			<strength>36M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>255/320</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(22)</shots>
			<bulk>-10</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 2-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  1кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>2</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 2-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  1кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>2300</value>
		<weight>95</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 2-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  2.5кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>17000</value>
		<reference>LT75</reference>
		<ranged_weapon>
			<damage>6d cr</damage>
			<strength>58M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>275/345</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(22)</shots>
			<bulk>-12</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 5-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 1 человек

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  5кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>33000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>7d+1 cr</damage>
			<strength>82M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>290/360</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>-14</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 10-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 1 человек

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста  7.5кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>50000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>8d+1 cr</damage>
			<strength>100M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>295/370</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(42)</shots>
			<bulk>-14</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(42)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 15-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 1 человек

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 10кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>20</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 20-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 10кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>10000</value>
		<weight>410</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 20-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 15кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>30</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 30-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 15кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>14000</value>
		<weight>570</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 30-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 2.5кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 5-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 2.5кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>4100</value>
		<weight>165</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 5-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 30кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>200000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>12d+1 cr</damage>
			<strength>200M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>315/390</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(55)</shots>
			<bulk>-17</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(55)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 3 чел. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 60-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.



Требуется персонал 3 человека

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 30кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>60</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 60-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 30кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>23000</value>
		<weight>930</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 60-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 5кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>10</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 10-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 5кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>6800</value>
		<weight>270</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 10-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 7.5кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>15</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 15-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 7.5кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>8400</value>
		<weight>340</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 15-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 90кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>600000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>16d cr</damage>
			<strength>350M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>345/435</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(70)</shots>
			<bulk>-25</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>4d cr</damage>
			<strength>–</strength>
			<usage>Fire Bundle of Stones</usage>
			<accuracy>4</accuracy>
			<range>245/305</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(70)</shots>
			<bulk>–</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 6 человек Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ballista, 180-lb.
<img data-src="lib/img/151591617979.png">
Торсионный механизм для метания камней, состоит из двух горизонтальных балок, к концам которых присоединен канат – в принципе, это гигантский пробойник (стр.73). Большая баллиста может метать группу из нескольких небольших булыжников (весом до 1 фунта), или один большой камень.


Требуется персонал 6 человек

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 90кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>180</value>
		<weight>180</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 180-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста 90кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50000</value>
		<weight>2000</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ballista, 180-lb. Tripod<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 15г</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>75</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>1d+2 cr</damage>
			<strength>7†[8]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>220/275</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Ballista, 0.03-lb.
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 15г - камень</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.03</value>
		<weight>0.03</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.03-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 15г - пуля</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.048</value>
		<weight>0.03</weight>
		<reference>LT83</reference>
		<notes>+1 к damage, damage становится pi+</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.03-lb Bullet
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 30г</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>1d+3 cr</damage>
			<strength>7†[10]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>225/280</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Ballista, 0.06-lb.
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 30г - камень</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.06</value>
		<weight>0.06</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.06-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 30г - пуля</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.096</value>
		<weight>0.06</weight>
		<reference>LT83</reference>
		<notes>+1 к damage, damage становится pi+</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.06-lb Bullet
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 60г</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>450</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>2d+1 cr</damage>
			<strength>12†[13]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>240/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(6)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Ballista, 0.12-lb.
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 60г - камень</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.12</value>
		<weight>0.12</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.12-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 60г - пуля</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.192</value>
		<weight>0.12</weight>
		<reference>LT83</reference>
		<notes>+1 к damage, damage становится pi+</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.12-lb Bullet
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 90г</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>675</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>2d+2 cr</damage>
			<strength>13†[15]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>255/320</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(7)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Ballista, 0.18-lb.
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 90г - камень</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.18</value>
		<weight>0.18</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.18-lb Stone
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллиста ручная 90г - пуля</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.288</value>
		<weight>0.18</weight>
		<reference>LT83</reference>
		<notes>+1 к damage, damage становится pi+</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ballista, 0.18-lb Bullet
		<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Белладонна</description>
		<tech_level>0</tech_level>
		<legality_class>1</legality_class>
		<value>8</value>
		<reference>LT128</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Belladonna
<img data-src="lib/img/151591853016.png"><img data-src="lib/img/151591858055.png">

Активным ингредиентом этого ядовитого растения (Atropa belladonna, она же красавка) является атропин. Белладонна может быть использована в качестве инъекционного или пищевого яда. В качестве инъекционного яда, у него одноминутная задержка; как пищевой яд, она имеет 15-минутную задержку. В любом случае, это наносит 1d ядовитых повреждений без броска сопротивления, повторяющийся с интервалом в 15 минут в течение 28 циклов с проверкой ЗД(HT)-2 для сопротивления. Когда повреждения достигают ЕЖ(HP)/2, у потерпевшего начинаются галлюцинации (стр. Б429); это, как правило, принимает форму искаженного восприятия, а не визуальных образов. Выжившие должны бросать против ЗД(HT), чтобы избежать постояннго штрафа в -1 ЗД(HT). $8 за дозу. КЛ(LC)1.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Биль</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<weight>8</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp / thr-1 cut</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>0</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Bill
<img data-src="http://weapons.gurps.ru/img/1599.png">

Европа.

Древковое оружие с клинком с крюком на обратной стороне, которое позволяет владельцу использовать правила во врезке "Крюк", обычно чтобы сбросить с лошади всадника. Первоначально это оружие использовалось на полях сражений, но иногда его делали с более короткой рукоятью для личного боя; результат - ДУЭЛЬНЫЙ БИЛЬ (стр. 68), к нему относятся лесной биль (forest bill, Англия) и гвизарма (Франция).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Боевая повозка</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>440</weight>
		<reference>LT137</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Battle Car
<img data-src="lib/img/151591817993.png">
<img data-src="lib/img/151591819598.png">

Ирландская версия лёгкой колесницы (называемая эсседа) весит даже меньше чем обычный ближневосточный вариант, так как в ней отсутствует бортик для двоих ездоков. Вместо лука воин брал с собой несколько метательных копий; он мог метать их во врагов или колоть ими, взбежав на хомут. Дальше он обычно сражался спешившись.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бокен</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>3</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Swing - One Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust - One Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>9†</strength>
			<usage>Swing - Two Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>9†</strength>
			<usage>Thrust - Two Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Bokken
<img data-src="http://weapons.gurps.ru/img/1607.png">

Деревянный меч размером с катану (стр. 64). Обычно (но не всегда) с деревянной или кожаной гардой. Также называется бокуто.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бола пердида</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT55,LT72</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>-1</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>0</accuracy>
			<range>x6/x10</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>Skill</type>
				<name>Bolas</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Bola Perdida
<img data-src="http://weapons.gurps.ru/img/1611.png">

Аргентина. 

Камень (или другое грузило), привязанный к ремню. Название пришло из Аргентины, хотя это оружие можно встретить повсеместно. Может использоваться в качестве метательного оружия - как однозарядная праща, которая метается вместе с камнем - и как кистень. Иногда может называться бола лока.



Можно атаковать не бросая по умению Flail</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Болас</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT55,LT72</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>-1</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 cr</damage>
			<strength>7</strength>
			<usage>Thrown</usage>
			<accuracy>0</accuracy>
			<range>x3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>Skill</type>
				<name>Bolas</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Bolas
<img data-src="http://weapons.gurps.ru/img/1613.png">

Это метательное оружие, и похожая на него БОЛА ПЕРДИДА (стр.66, 72), также могут быть использованы в качестве импровизированного одноручного цепа в ближнем бою.



Можно атаковать не бросая по умению Flail</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бомбарда</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>21000</value>
		<weight>1550</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>13d+2 pi++</damage>
			<strength>55M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>80/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-12</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Bombard
<img data-src="lib/img/151591934421.png">
Большая пушка с коротким дулом, стреляет большими или огромными камнями.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бомбарда - ядро камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5000</value>
		<weight>50</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Bombard Stone Ball
<img data-src="lib/img/151677150978.png">
Заряд для огнестрельного оружия ТУ3-4 состоит из пороха и ядер. Ядра должны быть обтёсаны или отлиты, чтобы соответствовать размеру, используемому в оружии. Чёрный порох и свинец покупаются оптом, на вес, и распределялся по солдатам для их орудий. Можно с достаточной точностью рассчитать стоимость выстрела простым умножением цены на вес за выстрел. Свинцовые или железные ядра просто отливаются. Каменные ядра нужно обтёсывать, что увеличивает стоимость; с другой стороны, камень легче метала при том же объеме.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бомбарда - ядро металл</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>50</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Bombard Metal Ball
<img data-src="lib/img/151677147827.png">
Заряд для огнестрельного оружия ТУ3-4 состоит из пороха и ядер. Ядра должны быть обтёсаны или отлиты, чтобы соответствовать размеру, используемому в оружии. Чёрный порох и свинец покупаются оптом, на вес, и распределялся по солдатам для их орудий. Можно с достаточной точностью рассчитать стоимость выстрела простым умножением цены на вес за выстрел. Свинцовые или железные ядра просто отливаются. Каменные ядра нужно обтёсывать, что увеличивает стоимость; с другой стороны, камень легче метала при том же объеме.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бомбарда крупня</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>220000</value>
		<weight>16000</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>6dx5 pi++</damage>
			<strength>92M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>130/740</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-16</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Bombard, Large
<img data-src="lib/img/151591922858.png">
Большая пушка с коротким дулом, стреляет большими или огромными камнями.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бомбарда крупня - ядро металл</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>8600</value>
		<weight>430</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Bombard, Large Metal Ball
    <img data-src="lib/img/151677147827.png">
Заряд для огнестрельного оружия ТУ3-4 состоит из пороха и ядер. Ядра должны быть обтёсаны или отлиты, чтобы соответствовать размеру, используемому в оружии. Чёрный порох и свинец покупаются оптом, на вес, и распределялся по солдатам для их орудий. Можно с достаточной точностью рассчитать стоимость выстрела простым умножением цены на вес за выстрел. Свинцовые или железные ядра просто отливаются. Каменные ядра нужно обтёсывать, что увеличивает стоимость; с другой стороны, камень легче метала при том же объеме.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Браслет, золото</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>12000</value>
		<weight>0.6</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Bracelet, gold
<img data-src="lib/img/151591961627.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Браслет, медь</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.3</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Bracelet, copper
<img data-src="lib/img/151591959785.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Браслет, серебро</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>350</value>
		<weight>0.35</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Bracelet, silver
<img data-src="lib/img/151591964639.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бриг, 15м</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>165000</value>
		<weight>140000</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Brig, 50'
<img data-src="lib/img/151592304008.png">
Двухмачтовое судно с квадратными парусами - такая конфигурация требует большего экипажа для управления парусами нежели на кораблях с косыми парусами (таких как шлюп, ниже). Экземпляр представленный в таблице имеет относительно небольшой размер: длинна 50 футов, ширина 18 футов и 10 футов от дна до верхушки мачты. Конфигурация парусов лучше всего подходит для длительных морских путешествий с попутным ветром и менее эффективна при движении против ветра, что делает работу этого судна менее эффективной в прибрежных водах.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бумеранг</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x6/x10</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Stick</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Boomerang
<img data-src="http://weapons.gurps.ru/img/1617.png">

Австралия. 

Изогнутый и более аэродинамичный вариант МЕТАТЕЛЬНОЙ ПАЛКИ (стр.75), предназначенный для охоты. Не возвращается; возвращающиеся версии не используются в качестве оружия, и в любом случае не возвращаются после попадания. Мастер может сделать исключение для мастеров боевых искусств с Искусством Метания! Можете считать ПАЛКОЙ (стр.Б273) если используете в качестве дубинки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бусы, золото, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>12000</value>
		<weight>0.6</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Beads, gold, per foot
<img data-src="lib/img/151591824023.png">
Набор декоративных бусин или маленьких пластин, нанизанных на нить.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бусы, медь, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.3</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Beads, copper, per foot
<img data-src="lib/img/151591822328.png">
Набор декоративных бусин или маленьких пластин, нанизанных на нить.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бусы, серебро, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>350</value>
		<weight>0.35</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Beads, silver, per foot
<img data-src="lib/img/151591825830.png">
Набор декоративных бусин или маленьких пластин, нанизанных на нить.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ванна камень</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>160</value>
		<weight>60</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Bathtub, Earthenware
<img data-src="lib/img/151591794366.png">
Первые передвижные минойские ванны были маленькими, вроде сидячих ванн ранней современности. Глиняная ванна: $160, 60 фунтов. Металлическая ванна: $1,600, 80 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ванна металл</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1600</value>
		<weight>80</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Bathtub, Metal
<img data-src="lib/img/151591805043.png">
Первые передвижные минойские ванны были маленькими, вроде сидячих ванн ранней современности. Глиняная ванна: $160, 60 фунтов. Металлическая ванна: $1,600, 80 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Воздушный пузырь</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>2.5</weight>
		<reference>LT143</reference>
		<categories>
			<category>Снаряжение ныряльщиков</category>
		</categories>
		<description-loc>Air Bladder
<img data-src="lib/img/151591509144.png">
Ассирийский рельеф, датируемый 8 веком до н.э. изображает ныряльщиков, использовавших наполненные воздухом шкуры животных для увеличения продолжительности погружения. Пузыри надуваются до входа в воду и позволяют обеспечить несколько вдохов под водой. Умножьте время Задержки дыхания (с. B351) на 4 при использовании воздушного пузыря. Он также является поплавком (с. 138), поэтому ныряльщику необходимо нести дополнительный груз в 60 фунтов, чтобы оставаться под водой. 15 $, 2.5 фунта 
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Волынка</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>8</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Bagpipe
<img data-src="lib/img/151591598350.png">
Больше всего известна её шотландская версия, но варианты этого инструмента встречаются по всему миру. Играется навыком Музыкальный инструмент (волынка). Дистанция слышимости: 32 ярда. 150$, 8 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>6</quantity>
		<description>Градуированная свеча</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>6</weight>
		<reference>LT44</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Candle, Graduated
<img data-src="lib/img/151592907288.png">
Впервые упоминается в китайских записях шестого столетия нашей эры; описанная здесь форма восходит к правлению в Англии Альфреда Великого (878). Состоит из шести 12-дюймовых свечей, каждая из которых сгорает за 4 часа; каждая свеча разделена на 12 20-минутных секций. Горящую свечу держат в ящике с прозрачными роговыми стенками. Эти и последующие часы измеряют часы постоянной длины. Свечи: 40$, 6 фунтов. Ящик: 10$, 0.7 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дротиковая духовая трубка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>1d-3 pi-</damage>
			<strength>2</strength>
			<usage>Launch Dart</usage>
			<accuracy>1</accuracy>
			<range>x4</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Blowpipe</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>В случае если повреждения превышают DR, вслед за ними следует атака наркотиком или ядом. Эффект зависит от используемого яда; см Яды (стр.128-130).</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Blowpipe
<img data-src="http://weapons.gurps.ru/img/1605.png">
<img data-src="lib/img/151676829712.png">


Длинная, узкая трубка с помощью которой можно стрелять специальными дротиками. Применяемые снаряды слишком малы, и не могут причинить вред большому животному или человеку, если они не отравлены. Может быть использовано чтобы выдувать порошки в лицо оппоненту. Также известно как фукия (Япония).



В случае если повреждения превышают DR, вслед за ними следует атака наркотиком или ядом. Эффект зависит от используемого яда; см Яды (стр.128-130).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дубинка работорговца</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Blackjack
<img data-src="http://weapons.gurps.ru/img/1602.png">

Небольшая, тяжелая дубинка из ткани или мягкой кожи, предназначена для избиения без явных синяков (Диагностика-2 чтобы заметить травмы при поверхностном рассмотрении). Каждая культура имеет свое название: блэк-джек, слэп-джек, кош, сап и т.д.



Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дыхательная трубка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>0.5</weight>
		<reference>LT143</reference>
		<categories>
			<category>Снаряжение ныряльщиков</category>
		</categories>
		<description-loc>Breathing Tube
<img data-src="lib/img/151592006782.png">
Древнеегипетские птицеловы придумали аналог современных дыхательных трубок, позволявших им подкрасться к водоплавающим птицам: при погружении воздух поступал через тростниковый стебель. Двухфутовая трубка позволяла погружаться на 16 дюймов под воду. Если погружаться глубже, то давление толщи воды не позволит сделать вдох через трубку. Наблюдатели за пловцом бросают на Зрение с -2, чтобы заметить ныряльщика. 5$ (или бесплатно на успешном броске Натуралиста или Выживания), 0,5 фунта. 
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Игла для удаления катаракты</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<reference>LT149</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Cataract Needles
<img data-src="lib/img/151594967942.png">
Очень длинная и острая игла, проникающая в глаз с минимальным ранением. Может сдвинуть катаракту от зрачка, рассечь ее на части или зафиксировать на месте. См. также Хирургические техники (с.12). За набор: $50, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Игральные карты</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.5</weight>
		<reference>LT40</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Cards
<img data-src="lib/img/151593046137.png">
Игральные карты относят к Средневековью. До изобретения печатного дела (стр. 48) их требовалось рисовать вручную:$400, 0.5 фунта. Цена упала, когда печать позволила их массовое производство (поздний ТУ4): $50, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кавалерийскя сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Cavalry Saber
<img data-src="http://weapons.gurps.ru/img/1629.png">

Европа. 

Изогнутый меч приспособленный для использования одной рукой, верхом на лошади. По форме напоминает фехтовальную САБЛЮ (стр. 61, Б273), но тяжелее и используется скорее как ШИРОКИЙ МЕЧ (стр. 55, Б271)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Казеннозарядный карабин</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>270</value>
		<weight>9.3</weight>
		<reference>LT94</reference>
		<ranged_weapon>
			<damage>2d pi+</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>55/570</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(10)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Breechloading Carbine
<img data-src="http://weapons.gurps.ru/img/1619.png">

С колесцовым замком

Основан на раннем карабине, сделанном для Генри Восьмого. Нарезной ствол короткий, но конструкция весьма крепкая.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Казеннозарядный карабин - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.8</value>
		<weight>0.04</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Breechloading Carbine Bullet
<img data-src="lib/img/151672117515.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каливер</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>135</value>
		<weight>6.6</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>3d+1 pi+</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>85/870</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Caliver
<img data-src="http://weapons.gurps.ru/img/1622.png">

С фитильным замком

Более лёгкий и удобный мушкет, предназначенный для использования обычными солдатами, недостаточно сильными, чтобы служить мушкетёрами.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каливер - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.4</value>
		<weight>0.07</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Caliver Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)

		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карабин</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>290</value>
		<weight>6.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>3d pi++</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>80/800</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Carbine
<img data-src="http://weapons.gurps.ru/img/1627.png">

С колесцовым замком

Мушкетоподобное оружие, предназначенное для кавалеристов, которые хотят что-то большее, чем пистолет. У него короткий ствол и весит он гораздо меньше, чем мушкет или каливер.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карабин - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.6</value>
		<weight>0.08</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Carbine Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карета</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>7500</value>
		<weight>3200</weight>
		<reference>LT137</reference>
		<notes>Запрягается лошадьми; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Carriage
<img data-src="lib/img/151593063540.png">
Небольшое колёсное средство передвижения, используемое для транспортировки по городу; в Лондоне и Париже были целые флотилии наёмных карет с начала 17 века (с 1650г., в Лондоне). В наёмную карету, описанную здесь, впрягались две лошади.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карробаллиста</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>4000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>3d imp</damage>
			<strength>17M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>220/275</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(10)</shots>
			<bulk>-10</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек. Включена колесная повозка, упряжь для двух тягловых животных и место для хранения 100 болтов (общим весом 50 фунтов).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Carroballista
<img data-src="lib/img/151594960706.png">
Использовалась легионами поздней Римской Империи, это самая древняя из известных форм полевой артиллерии: механизм для метания камней, установленный на колесной повозке. Обычно перемещался тягловыми животными, но был достаточно легким, и, в случае необходимости, мог перемещаться усилиями нескольких солдат.



Требуется персонал 1 человек

В характеристики включена колесная повозка, упряжь для двух тягловых животных и место для хранения 100 болтов (общим весом 50 фунтов). Суммарный вес достаточно мал, в случае необходимости обслуга может перемещать орудие своими силами, однако орудие слишком неудобное, чтобы его мог использовать гигант!</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карробаллиста - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>16.5</value>
		<weight>0.5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Carroballista Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кастет</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203)</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Brass Knuckles
<img data-src="http://weapons.gurps.ru/img/1618.png">

Зажимаемый в ладони предмет, защищающий кулак. В качестве материала может использоваться рог животных, железо, сталь, укрепленная свинцом кожа или латунь. Использующий это оружие игнорирует Собственное Ранение (стр. Б379) при ударе кулаком и получает +1 к наносимым повреждениям, но получает Плохую Хватку 3 (стр. Б123). К этому виду оружия относится тэкко (Япония, Окинава).



Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Катетер</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Catheter
<img data-src="lib/img/151594977935.png">
Узкая трубка, которую можно вставить в мочевой пузырь для смещения камня и выведения мочи, что дает временное облегчение, но не вылечивает. Бросок против Нетрадиционной медицины, Врачебного дела или Хирургии. $50, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Когти</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>1</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw-2 cut</damage>
			<strength>6</strength>
			<usage>Swing</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Bladed Hand
<img data-src="http://weapons.gurps.ru/img/2020.png">
<img data-src="http://weapons.gurps.ru/img/1603.png">

Экзотические. 

Оружие состоит из параллельных лезвий одинаковой длины, которые надеваются на руки и используются как когти животных. Некоторые короткие и ножевидные, другие длинные и похожие на грабли. Включает баг-нах (Индия, иногда переводится как «тигриные когти») и неко-де (Япония).



Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки. Когти не улучшают урон при использовании этого вспомогательного оружия.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ложка для извлечения стрел</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Arrow Spoon
<img data-src="lib/img/151591589453.png">
Используется для не вызывающего дополнительных повреждений извлечения наконечника стрелы из раны. $30, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мушкетон</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>165</value>
		<weight>11.2</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>1d pi</damage>
			<strength>7†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>45/810</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Blunderbuss
<img data-src="http://weapons.gurps.ru/img/1606.png">

Короткоствольный дробовик с дулом, которое расширяется от задней части к передней; дуло 1.25 калибра. Это мало влияет на то, как оно стреляет, зато даёт +1 к Запугиванию любого, на кого он направлен! Благодаря расширяющемуся стволу, он исключение из обычного броска Огнестрельного оружия-2, чтобы перезарядить его на движущемся транспорте (см. Зарядка, стр. 94-95). Он стреляет эквивалентом крупной дроби. Художественная литература и мультфильмы иногда изображают мушкетоны, заряжаемые металлоломом и маленькими камнями, но это плохо работает; эффекты см. в разделе "альтернативные боеприпасы" (стр. 95).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мушкетон - Выстрел</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT92</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Blunderbuss Shot
<img data-src="lib/img/151677142889.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Набор цирюльника</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<skill_bonus>
			<name compare="contains">Surgery</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
		<description-loc>Barber's Kit
<img data-src="lib/img/151591787799.png">
Это скромный набор инструментов – нож, бритва, ножницы, небольшой точильный камень, ложка (ТУ2), небольшой напильник (ТУ2) и пара других инструментов – преимущественно для бритья и стрижки; но в случае необходимости может использоваться и для небольших операций. Дает -1 (качество) к Хирургии, помимо других модификаторов ТУ. $100, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нарывники</description>
		<tech_level>0</tech_level>
		<legality_class>1</legality_class>
		<value>14</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Cantharides
<img data-src="lib/img/151593025943.png"><img data-src="lib/img/151593021579.png">
Особенно известна “Шпанская мушка” (на самом деле жук, Lytta vesicatoria), этот яд может быть использован как пищевой яд или контактный яд. Как пищевой яд, он имеет один час задержки и позволяет проверку ЗД(HT) для сопротивления, и наносит 4d ядовитых повреждений с симптомами тошноты (стр. Б428). Как контактный яд, он не имеет задержки, но все же позволяет проверку ЗД(HT) для сопротивления; он наносит 2d ядовитых повреждений и раздражает кожу, вызывая волдыри и умеренную боли (стр. Б428). В любом случае, жертва, которая достигает 0 ЕЖ(HP), страдает судорогами (стр. B429). $14 за дозу. КЛ(LC)1.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Настольные игры</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>3</weight>
		<reference>LT39</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Board Games
<img data-src="lib/img/151591902642.png"><img data-src="lib/img/151591904104.png">
Есть свидетельства существования настольных игр около 2500 года до н.э., но, вероятно, в них играли и гораздо раньше. Ранние западные игры строились вокруг гонки по игровому полю, возможно с захватом вражеских фишек, как в коротких нардах, а в Китае очень рано были изобретены го. Как правило, игровые доски были деревянными, с каменными или глиняными фигурками. $40, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
	<description>Палаш</description>
	<value>550</value>
	<weight>3</weight>
	<quantity>1</quantity>
	<notes>Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.</notes>
	<melee_weapon>
		<damage>thr cr</damage>
		<reach>C</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<melee_weapon>
		<damage>sw+1 cut</damage>
		<strength>10</strength>
		<reach>1</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>Skill</type>
			<name>Broadsword </name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<melee_weapon>
		<damage>thr+1 imp</damage>
		<strength>10</strength>
		<reach>1</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>Skill</type>
			<name>Broadsword </name>
			<modifier>0</modifier>
		</default>
	</melee_weapon>
	<dr_bonus>
		<location>hands</location>
		<amount>4</amount>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>4</tech_level>
	<categories>
		<category>Холодное оружие</category>
	</categories>
	<reference>LT54</reference>
	<description-loc>
		Backsword
		<img data-src="http://weapons.gurps.ru/img/1563.png">
		Англия.

Острый с одной стороны КОЛЮЩИЙ ШИРОКИЙ МЕЧ (стр. 66, 70, Б271) с корзинчатой гардой.



В ближнем бою можно атаковать по первой строке с умениями рукопашного боя

Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палка короткая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Baton
<img data-src="http://weapons.gurps.ru/img/1591.png">

Короткая, сбалансированная дубинка, обычно из дерева или металла. В том числе chung bong (Корея) dhot (Бурма), muchan (Индия) и mutton (Филипины), и узкие металлические segu (Индонезия). Некоторые короткие палки размером всего лишь с нож используйте для них параметры ОЧЕНЬ КОРОТКОЙ ПАЛКИ (стр. 67, 69). К очень коротким палкам относится dan bong (Корея).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Патронташ</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Bandolier
<img data-src="lib/img/151591718376.png">
Кожаная полоса, одеваемая через одно плечо и застегивающаяся на противоположной стороне туловища. На ней размещаются предметы необходимые для использования огнестрельного оружия: дюжина пузырьков для пороховых зарядов, пузырек с затравочным порохом, маленькая масленка, карман для пуль, карман для ветоши для чистки, и, для использующих фитильные замки, 1 ярд медленного фитиля. Требуется одна секунда чтобы надеть или снять. $50, 5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 100 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>40000</value>
		<weight>4000</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>13d+1 cr</damage>
			<strength>140M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>55/70</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-18/-22</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 100 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, 100-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 100 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 100 чел - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>30</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Beam Sling, 100-Man Stone
<img data-src="lib/img/151672143348.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 15 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>2400</value>
		<weight>240</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>7d cr</damage>
			<strength>35M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>50/60</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-12/-15</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Требуется персонал 15 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, 15-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 15 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 15 чел - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>2</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Beam Sling, 15-Man Stone
<img data-src="lib/img/151672143348.png">


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 30 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>6700</value>
		<weight>670</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>8d+2 cr</damage>
			<strength>58M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>50/65</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-14/-18</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 30 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, 30-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 30 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 30 чел - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Beam Sling, 30-Man Stone
<img data-src="lib/img/151672143348.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 50 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>14000</value>
		<weight>1400</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>10d+1 cr</damage>
			<strength>84M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>50/65</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-16/-20</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 50 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, 50-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 50 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье - 50 чел - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>10</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Beam Sling, 50-Man Stone
<img data-src="lib/img/151672143348.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье с утяжелением - 30 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>12600</value>
		<weight>1260</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>8d+2 cr</damage>
			<strength>80M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>105/130</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-15/-19</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Требуется персонал 30 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, Weighted, 30-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 30 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перье с утяжелением - 50 чел</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>24000</value>
		<weight>2400</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>10d+1 cr</damage>
			<strength>110M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>2</accuracy>
			<range>105/130</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-16/-21</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Требуется персонал 50 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Beam Sling, Weighted, 50-Man
<img data-src="lib/img/151591833051.png">
Основное тяжелое орудие в Китае и на Среднем Востоке, перье – также называемое мангонель, хироманганон или тракционный требушет – представляет собой, по сути, один огромный рычаг. Короткое плечо люди тянули вниз за присоединенные к нему веревки, в то время как к длинному крепилась котомка или сумка со снарядом. Размеры перье определялись количеством человек, необходимых для ее работы. На Среднем Востоке некоторые модели улучшались путем добавления грузов к короткому плечу, что было шагом к противовесному требушету (ниже).



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 50 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пехотная мина</description>
		<tech_level>4</tech_level>
		<legality_class>3</legality_class>
		<value>350</value>
		<weight>10</weight>
		<reference>LT86</reference>
		<notes>Damage 14d[4d] cr радиусом 1 метр</notes>
		<categories>
			<category>Бомбы</category>
		</categories>
		<description-loc>Bamboo Land Mine
<img data-src="lib/img/151591690510.png">
Китайское изобретение, описанное в военном тексте 14 века: девятидюймовое бамбуковое звено, горизонтально зарытое в землю, заполнено на 80% чёрным порохом, на 20% свинцовыми шариками. Когда кто-то наступает на него, груз падает и приводит в движение колесцовый замок, который высекает искру и зажигает порох. Грунт направляет взрывную волну вверх, мина наносит 14d [4d] дроб. (cr.) в радиусе одного ярда; осколки тоже наносят дробящие повреждения, не режущие. $350, 10 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ кожаный / шерстяной, дешевый (Статус -2)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>3</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>8</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Leather/Wool, Poor (Status -2)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ кожаный / шерстяной, дорогой (Статус 4)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>9000</value>
		<weight>3</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>8</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Leather/Wool, Expensive (Status 4)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ кожаный / шерстяной, обычный (Статус 0)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>90</value>
		<weight>3</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>8</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Leather/Wool, Freeman (Status 0)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ, дешевый (Статус -2)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>8</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Poor (Status -2)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ, дорогой (Статус 4)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6000</value>
		<weight>2</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>5</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Expensive (Status 4)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плащ, обычный (Статус 0)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>2</weight>
		<reference>LT99</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>5</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shield</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Cloak, Freeman (Status 0)
<img data-src="http://weapons.gurps.ru/img/1640.png">
Плащи (с. B287) обычно застегиваются на шее шнурком или застежкой. Некоторые имеют разрез, чтобы не мешать при езде; другие могут иметь прорези для рук или даже рукава, и напоминать пончо (ниже). Плащи универсальны – они защищают от погоды, могут послужить одеялом и палаткой. Под плащом нетрудно что-то спрятать (+4 к Утаиванию). Он даже может использоваться как активная защита в бою. Простейший способ – обернуть его вокруг руки и использовать ее для отражения атаки (Блокирование с умением Плащ, см.с.Б184). Удерживая тяжелый плащ перед собой на манер занавеси, есть неплохие шансы остановить удар легкого оружия дальнего боя (см. Занавеси от Стрел, с. 104). 


Плащ стоит 10% расходов на жизнь и весит 2 фунта. Тяжелый плащ, сделанный из шерсти или кожи, дает СП(DR) 1 против режущего вреда, стоит 15% расходов на жизнь и весит 3 фунта.

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 1.5 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>14000</value>
		<weight>1000</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>14d+1 pi++</damage>
			<strength>39M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>210/1,800</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-13</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 1 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Cannon, 3-lb.
<img data-src="lib/img/151592952993.png">
Полевые пушки (ТУ4)



Тактика использования пушек была разработана Густавом Адольфом. 

3х фунтовые модели предназначались для полковой поддержки; 12ти фунтовые орудия оказывали поддержку основным силам на поле боя; 24х фунтовые орудия находились в резерве, и предназначались против защитных укреплений. Сведение к трём стандартным размерам во многом упростило проблемы снабжения. Стенки этих пушек были тоньше, а стволы короче, чем у старых моделей, это делало их легче; кроме этого, их можно было устанавливать на полевые повозки.





Требуется команда 1 чел.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 1.5 кг - повозка полевая</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>590</value>
		<weight>1250</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Cannon, 3-lb. Field Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 1.5 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>90</value>
		<weight>4.5</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Cannon, 3-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 12 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>95000</value>
		<weight>6900</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>6dx5 pi++</damage>
			<strength>64M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>370/2,700</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(70)</shots>
			<bulk>-16</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 7 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Cannon, 24-lb.
<img data-src="lib/img/151592963448.png">
Полевые пушки (ТУ4)



Тактика использования пушек была разработана Густавом Адольфом. 

3х фунтовые модели предназначались для полковой поддержки; 12ти фунтовые орудия оказывали поддержку основным силам на поле боя; 24х фунтовые орудия находились в резерве, и предназначались против защитных укреплений. Сведение к трём стандартным размерам во многом упростило проблемы снабжения. Стенки этих пушек были тоньше, а стволы короче, чем у старых моделей, это делало их легче; кроме этого, их можно было устанавливать на полевые повозки.





Требуется команда 7 чел.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 12 кг - повозка полевая</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>960</value>
		<weight>8600</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Cannon, 24-lb. Field Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 12 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>720</value>
		<weight>36</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Cannon, 24-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 6 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>50000</value>
		<weight>3750</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>6dx4 pi++</damage>
			<strength>55M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>310/2,400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-15</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 5 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Cannon, 12-lb.
<img data-src="lib/img/151592959521.png">
Полевые пушки (ТУ4)



Тактика использования пушек была разработана Густавом Адольфом. 

3х фунтовые модели предназначались для полковой поддержки; 12ти фунтовые орудия оказывали поддержку основным силам на поле боя; 24х фунтовые орудия находились в резерве, и предназначались против защитных укреплений. Сведение к трём стандартным размерам во многом упростило проблемы снабжения. Стенки этих пушек были тоньше, а стволы короче, чем у старых моделей, это делало их легче; кроме этого, их можно было устанавливать на полевые повозки.





Требуется команда 5 чел.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 6 кг - повозка полевая</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>825</value>
		<weight>4700</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Cannon, 12-lb. Field Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полевая пушка 6 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>360</value>
		<weight>18</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Cannon, 12-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полуторный меч</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swing - One Handed</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>11</strength>
			<usage>Thrust - One Handed</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swing - Two Handed</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>10†</strength>
			<usage>Thrust - Two Handed</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Bastard Sword
<img data-src="http://weapons.gurps.ru/img/1587.png">

Этим мечом можно управляться и одной рукой, но его рукоятка достаточно длинная, чтобы использовать обе руки. Это позволяет использовать его как обычный двуручный (использовать навык двуручного меча) или защитным хватом, описанным в GURPS Боевые Искусства. Обычно конец был острым - в исторических кампаниях используйте КОЛЮЩИЙ ПОЛУТОРНЫЙ МЕЧ (стр. 66, 70, Б271, Б274). Его также называют меч-бастард. Включает в себя маленькие варианты нодати (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Поясной крюк</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Belt Hook
<img data-src="lib/img/151591863628.png"><img data-src="lib/img/151591867525.png">
Дополнение к арбалетному стремени (см. ниже). Вместо того чтобы нагибаться, арбалетчик опускается на колено, цепляет тетиву за крюк на поясе, и, выпрямляясь, натягивает тетиву. Эти три шага занимают 1 секунду, 2 секунды и 2 секунды – всего 5 секунд. Ограничение силы: СЛ(ST) персонажа +10-20%. $25, незн.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Прижигатель</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.5</weight>
		<reference>LT149</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Cautery
<img data-src="lib/img/151594981001.png"><img data-src="lib/img/151594984390.png">
Инструмент для контролируемого прижигания ткани – острый металлический наконечник на длинном пруте с теплоизолирующей рукояткой, нагерваемый на жаровне. Делается из железа, которое нагревается лучше, чем бронза, поэтому иногда именуется "каленым железом". Нагретый прижигатель может вызвать серьезные ожоги – большинство хирургов считает прижигание крайней мерой!

Использование прижигателя требует броска Хирургии. Критический успех наносит 1 очко обжигающего вреда. Обычный успех или провал – 1d-3 вреда, минимум 1. При критическом провале это повреждение удваивается.

Прижигание может прекратить кровотечение, с которым не справилась Первая помощь. Любой успех броска Хирургии остановит дальнейшую потерю ЕЖ(HP). Любой провал – нет.

Прижигание раны уничтожает не только плоть, но и бактерии. Если рана была инфицирована (с. B444), прижигание может остановить процесс – обычно с меньшим вредом, чем удаление инфицированных тканей и без ампутации. Сделайте бросок Хирургии, как описано выше; инфекция, нанесшая 3 ЕЖ(HP) вреда и больше или любая инфекция от проникающей или пробивающей раны, считается внутренней, и лечится как недиагносцированное состояние (см. Расширенные модификаторы, с.147). Независимо от результата пациент получает +1 на следующий бросок ЗД(HT) против инфекции. Успех дает дополнительный бонус, равный половине значения успеха (округляется вниз). Критический успех избавляет от инфекции без броска ЗД(HT). Прижигатель: $50, 0.5 ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пушка ранняя</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>80000</value>
		<weight>6000</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>6dx5 pi++</damage>
			<strength>68M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>350/2,600</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(100)</shots>
			<bulk>-16</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 12 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Cannon

<img data-src="lib/img/151592913221.png">
Ранние Европейские пушки (ТУ4)
К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.



Требуется команда 12 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пушка ранняя - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>7500</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Cannon Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Разжигающее стекло, кварц</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Burning Glass, Quartz
<img data-src="lib/img/151592859501.png">
Ручные линзы и зеркала изредка использовались для фокусировки солнечного света. Они хрупкие, дорогие и работают только при ярком солнечном свете. Шлифованное металлическое зеркало или природный кварц в форме линзы (ТУ2): $40, 1 фунт. Линза из прозрачного стекла (ТУ3): $20, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Разжигающее стекло, стекло</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Burning Glass, Glass
<img data-src="lib/img/151592854315.png">
Разжигающее стекло (ТУ2). Ручные линзы и зеркала изредка использовались для фокусировки солнечного света. Они хрупкие, дорогие и работают только при ярком солнечном свете. Шлифованное металлическое зеркало или природный кварц в форме линзы (ТУ2): $40, 1 фунт. Линза из прозрачного стекла (ТУ3): $20, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сапоги, кожа</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>3</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Boots, leather
<img data-src="lib/img/151591951382.png">
Сапоги похожи на ботинки, но делаются из более толстого материала и длиннее, защищая голени. С изобретением стремян (p. 134), в сапоги для верховой езды стали добавлять каблук, предотвращающий проскальзывание ноги. СП(DR) 2. $80, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Свеча</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>LT44</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Candle
<img data-src="lib/img/151592862451.png">
Горит 12 часов. Сальные свечи дымят и горят с характерным запахом: $5, 1 фунт. Пчелиный воск горит с минимумом дыма и запаха: $9, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Снаряжение для отливки пуль</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Bullet-Molding Gear
<img data-src="lib/img/151592695739.png">
Калибр огнестрельного оружия не был стандартизирован, а ядра не могли производится в массово. Владельцам огнестрельного оружия было необходимо снаряжение для отливки собственных ядер: железный или бронзовый тигель для плавки свинца, шпицы для его держания, и набор форм для пуль. Позже это стала пара игловидных носовых плоскогубцев с несколькими круглыми выемками соответствующего размера; в них можно было залить свинец и плотно закрыть, когда свинец остывали получившиеся ядра извлекали. Бивачный костер даёт достаточно тепла для плавки свинца; на отливку полудюжины шариков уходит около четырех минут. Армии носили слитки свинца с собой; если они заканчивались, проверка навыка Собирание помогала найти свинец в любом ТУ2+ городе. $50, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела зазубренная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>-1 Acc, снижает на 5 оба множителя Расстояния; повреждения становится Cutting, при извлечение из раны наносит половину повреждений.</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Bowel-Raker Arrow
<img data-src="lib/img/151591955441.png">
Наконечник в форме листа, или C-, U- или Y-образный, заточенный на внутренней стороне. Преобразует повреждения в режущие. Характеристики остаются без изменений. Зазубренный срезень стрела дает штраф -1 к Точ и снижает на 5 оба множителя Расстояния (т.е. х15/х20 становится х10/х15), извлечение такой стрелы из раны наносит половину повреждений от полученных в момент ранения. В любом случае цена и все без изменений.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела с тупыми наконечником</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>Повреждения становятся crushing</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Blunt Arrow
<img data-src="lib/img/151591897623.png">
Стрелы с тупыми наконечниками (томары): Преобразует повреждения в дробящие. Используется для тренировок или для охоты на птицу или пушного зверя. Половина от обычной стоимости, обычный вес.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрелы с зазубренными наконечниками</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>При извлечение из раны еще 1/2 damage</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Barbed Arrow
<img data-src="lib/img/151591756045.png">
Извлечение такой стрелы из раны наносит половину повреждений от полученных в момент ранения. Цена и вес без изменений (большинство боевых стрел снабжены зазубренными наконечниками по умолчанию).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Счёты (абак)</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>LT50</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Abacus
<img data-src="lib/img/151591500275.png">
Рама, обычно деревянная, на которой на проволоках нанизаны бусины. Бусины двигают туда-сюда, в соответствии с производимыми вычислениями. Позиционная система счисления в них встроена. Те, кто пользуется непозиционными числами, например римскими, могут считать на счётах без броска навыка, если у них есть очки персонажа в Бухгалтерском учете или Математике (прикладной). Любой, у кого есть опыт работы со счётами, может считать быстрее, чем с помощью карандаша и бумаги, в любой нотации. 50$, 2 фунта. Набор камней, выложенных на плоской поверхности, может использоваться в качестве импровизированных счёт бесплатно, но он намного медленнее, потому что нужно действовать аккуратно, чтобы не перемешать камни.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Топор</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>4</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>10†</strength>
			<usage>Swing - two handed</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Axe
<img data-src="http://weapons.gurps.ru/img/1561.png">

Клиновидное лезвие на деревянной рукоятке, рассчитанное на использование одной рукой и не сбалансированное для метания. У него достаточно длинная рукоять, чтобы его удобно было использовать двумя руками; используйте параметры, приведённые в разделе "двуручный топор/булава", которые отличаются от защитного хвата оружия, определённого в GURPS Боевые Искусства. В эту категорию входят топор "эпсилон" (шумерский) и масакари (японский). Топоры бывают разных форм и размеров, от МАЛЕНЬКОГО ТОПОРА (стр. 65), который лишь чуть больше, чем ТОПОРИК (стр. 56, Б271) и ДЛИННЫЙ ТОПОР (стр. 58, 70).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Узда и удила</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Bridle and Bit
<img data-src="lib/img/151592252089.png"><img data-src="lib/img/151592254706.png">
Узда, дополненная мундштуком, обычно из металла, который вставляют лошади между зубов. Это облегчает всаднику контроль над конем: +2 к Верховой езде, если держать поводья одной рукой (итого -1), и +3, если двумя (без штрафов). $35, 3ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фартук кожаный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>3</weight>
		<reference>LT99</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<dr_bonus>
			<location>torso</location>
			<amount>1</amount>
		</dr_bonus>
		<description-loc>Apron, Leather
<img data-src="lib/img/151591517484.png">
Ремесленники, такие как кузнецы или каменотесы, часто одевают кожаные фартуки, чтобы защитить себя и одежду. Они гибкие, но достаточно толстые, чтобы остановить небольшой вред. Кожаный фартук закрывает перед, защищая весь торс, кроме плеч (результат 1-5 на 1d), и верхнюю часть ног (защита на 4-6); см. Зоны покрытия брони (с. 100). СП(DR) 1. $60, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хиробаллиста - болт</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>3.96</value>
		<weight>0.12</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Cheiroballistra Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хиробаллиста 45см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>375</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>9†[14]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>215/270</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(6)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc><img data-src="lib/img/151595014527.png">
Cheiroballistra, 18”

Это двух-плечевой торсионный механизм для метания болтов, в основном сделан из железа, достаточно маленький для того, чтобы им мог пользоваться один человек. Римские кавалеристы обучались взводить, заряжать и стрелять из него верхом. Натяжение каната тянет рычаги не в стороны, а к центру, при этом тетива принимает форму острой "V", что направляет всю запасенную силу вперед. Торсионные пружины располагаются по сторонам, пространство между ними дает лучший угол обзора, позволяя использовать манёвр Прицеливания без предварительной проверки Зрения.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хиросифон</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>1000</value>
		<weight>20</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>3d burn</damage>
			<strength>12†</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>12x1s</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Выстрел может поразить одну твёрдую цель или разлиться кругом диаметром 2 ярда на поверхности воды. Используйте указанные повреждения для прямого попадания; продолжительные повреждения равняются 1d burn. в секунду, в течение 1d секунд после атаки. Требует 10 секунд на подготовку к стрельбе. После первого выстрела все последующие происходят непрерывно. Расстояние зависит от ST.</notes>
		<categories>
			<category>Огнеметы</category>
		</categories>
		<description-loc>Cheirosiphon
<img data-src="lib/img/151595026415.png">
Византийское устройство для разбрызгивания греческого огня по вражеским кораблям, сделано на базе римских насосных механизмов. Встраивается в конструкцию боевого корабля, форсунка располагается снаружи корпуса. Греческая принцесса Анна Комнина описывала его использование в морской битве в 1103 н.э. Ручной хиросифон появился на полях битвы в начале 10 века; несколько десятилетий спустя арабы сделали из него заррак аль-нафт, разбрызгивающий нафту, а не греческий огонь. Он продолжал использоваться в Египте вплоть до 1400 года. Внешне ручной сифон напоминает большой водяной пистолет с присоединенным большим резервуаром и медленным фитилем (выше), прикрепленным снаружи форсунки, чтобы воспламенять топливо. Это оружие представлено в Таблице Огнеметов (стр. 86).

Выстрел может поразить одну твёрдую цель или разлиться кругом диаметром 2 ярда на поверхности воды. Используйте указанные повреждения для прямого попадания; продолжительные повреждения равняются 1d burn. в секунду, в течение 10d секунд после атаки (для огне-сифона) или 1d секунд (для хиросифона).


Требует 10 секунд на подготовку к стрельбе. После первого выстрела все последующие происходят непрерывно. Расстояние зависит от ST.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепная плеть,  3м.</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>9</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>11†</strength>
			<usage>Swing</usage>
			<reach>1-3*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Chain Whip, 3 yard
<img data-src="http://weapons.gurps.ru/img/1632.png">

Китай. 

Плеть сделанная из металлических звеньев или брусков (обычно семи или девяти) соединенных между собой при помощи колец. Используется как хлыст и может опутывать оппонента, как КУСАРИ (стр.58, Б272). Так же называется жуаньбянь или кау син ке (Китай).

Длина бывает от 1 до 4 ярдов.

Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепная плеть, 1м.</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>3</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>9†</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Chain Whip, 1 yard
<img data-src="http://weapons.gurps.ru/img/1632.png">

Китай. 

Плеть сделанная из металлических звеньев или брусков (обычно семи или девяти) соединенных между собой при помощи колец. Используется как хлыст и может опутывать оппонента, как КУСАРИ (стр.58, Б272). Так же называется жуаньбянь или кау син ке (Китай).

Длина бывает от 1 до 4 ярдов.

Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепная плеть, 2м.</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>10†</strength>
			<usage>Swing</usage>
			<reach>1-2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Chain Whip, 2 yard
<img data-src="http://weapons.gurps.ru/img/1632.png">

Китай. 

Плеть сделанная из металлических звеньев или брусков (обычно семи или девяти) соединенных между собой при помощи колец. Используется как хлыст и может опутывать оппонента, как КУСАРИ (стр.58, Б272). Так же называется жуаньбянь или кау син ке (Китай).

Длина бывает от 1 до 4 ярдов.

Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепная плеть, 4м.</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>12</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>12†</strength>
			<usage>Swing</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Chain Whip, 4 yard
<img data-src="http://weapons.gurps.ru/img/1632.png">

Китай. 

Плеть сделанная из металлических звеньев или брусков (обычно семи или девяти) соединенных между собой при помощи колец. Используется как хлыст и может опутывать оппонента, как КУСАРИ (стр.58, Б272). Так же называется жуаньбянь или кау син ке (Китай).

Длина бывает от 1 до 4 ярдов.

Попытки парировать цепь происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепочка, золотая, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1200</value>
		<weight>0.06</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Chain, gold, per foot
<img data-src="lib/img/151594996691.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепочка, медная, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<weight>0.03</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Chain, copper, per foot
<img data-src="lib/img/151594993766.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цепочка, серебряная, за 30см</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>0.035</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Chain, silver, per foot
<img data-src="lib/img/151595001917.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цестус</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203)</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Cestus
<img data-src="http://weapons.gurps.ru/img/1631.png">

Он-же "цест"

Древний Рим

Кожаная "боксёрская перчатка" с заклёпками или шипами; считайте её перчаткой (DR 4). Были распространены варианты длинной по локоть: удвоенная базовая стоимость и увеличенный в 4 раза вес, дают руке DR 4 при выпадении 1-3 на 1d; и добавляют свои +1 к повреждениям при Ударе Локтём (стр. Б230, Б404), а не только при ударе кулаком.

Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Чакрам</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1.5</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+1 cut</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x4/x6</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Disc</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Chakram
<img data-src="http://weapons.gurps.ru/img/1636.png">

Индия. Металлическое метательное кольцо, заостренное с наружный стороны. Может метаться различными способами - даже раскручиваться на пальце!</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шест для лазания</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>5</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Climbing Pole
<img data-src="lib/img/151595045824.png">
Это шест с крюком на конце. Во время использования он цепляется за край стены и устанавливается под определенным углом. Персонаж подтягивается держась руками за шест и поднимается по стене при помощи ног.
Это устройство ограничено высотой стены, обычно не более 15 футов. В бою может использоваться в качестве неудобного (-2 к навыку) длинного посоха. $80, 5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шипы для лазания, 4 шт.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>2</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Climbing Spikes, set of four
<img data-src="lib/img/151595056959.png">
Эти устройства закрепляются на кистях и ступнях для улучшения сцепления с поверхностью - как "лазательные когти ниндзя". Они полезны на неровных поверхностях: дерево, мягкий камень, и т.п. Чтобы одеть полный набор требуется четыре минуты (по одной минуте на каждую конечность). Шипы убирают штраф -2 во время лазания по соответствующим поверхностям. Набор из четырёх элементов: $150, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Широкий меч</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Broadsword
<img data-src="http://weapons.gurps.ru/img/1620.png">

Термин для меча, который средневековые европейские воины обычно называли "arming sword" или "рыцарский меч"; придуман писателями 17ого века, чтобы различать массивные военные мечи от узких гражданских. Длинною обычно от 75 до 100 см. Традиционно прямой, обоюдоострый и остроконечный; используйте параметры КОЛЮЩЕГО ШИРОКОГО МЕЧА (стр. Б271). Эти же параметры можно использовать и для слегка изогнутых или заточенных с одной стороны вариаций. Почти в каждой культуре имеется некая версия широкого меча, который на своём языке часто называют просто "мечом". Включает лонгсакс (Скандинавия), спату (Древний Рим), и крупные экземпляры кацбальгера (Европа) и педанга (Индонезия).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Щетка, тростник</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Brush
<img data-src="lib/img/151592637281.png">
Ранние египетские щётки для волос были с щетиной из тростника, вроде современных мётел. Щетина животных стала применяться позже. $6, 0.5 фунта.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Щетка, шерсть</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>0.5</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Brush
<img data-src="lib/img/151592630425.png">
Ранние египетские щётки для волос были с щетиной из тростника, вроде современных мётел. Щетина животных стала применяться позже. $6, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ящик для свечи</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>0.7</weight>
		<reference>LT44</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Candle Case
<img data-src="lib/img/151592874649.png">
Горящую свечу держат в ящике с прозрачными роговыми стенками. Эти и последующие часы измеряют часы постоянной длины. Ящик: 10$, 0.7 фунта.
</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Мешок тканный, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.01</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 1, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.11 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 1/4 cup
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.25</value>
		<weight>0.01</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 2, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 1 cup
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.75</value>
		<weight>0.1</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 2, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.81 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 1 quart
    <img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1.75</value>
		<weight>0.25</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 3, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">7.15 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 1 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2.75</value>
		<weight>0.5</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 3, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">14.85 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 2 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 4, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 6 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>13</value>
		<weight>2</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 5, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">148.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 20 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 150 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>3</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 6, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">291.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 40 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 300 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>32</value>
		<weight>5</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 7, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">605 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 80 gal.
    <img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Мешок тканный, 450 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>42</value>
		<weight>6</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 8, Хрупкие (Воспламеняемые) см B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">880 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Cloth Bag, 120 gal.
<img data-src="lib/img/151595659261.png">
Матерчатые мешки имеют СП(DR) 0, и они Хрупкие (Воспламеняемые) (стр. Б136), а также не получают вреда и не защищают содержимое от дробящих атак. Они выдерживают примерно пол-унции веса на кубический дюйм объема, или 55 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment version="3">
		<quantity>1</quantity>
		<description>Абордажная сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>2</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Hilt punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>1</amount>
		</dr_bonus>
		<description-loc>Cutlass
<img data-src="http://weapons.gurps.ru/img/1653.png">

Европа. 

Короткий меч с односторонней заточкой и корзинчатым эфесом, излюбленное оружие моряков и пиратов. В некоторых случаях корзинчатого эфеса может не быть; используйте характеристики КОРОТКОГО МЕЧА (стр.69, Б273). Стоимость в 300$, указанная в Basic Set, применима к абордажным саблям массового производства в крупных морских империях; в случае если это оружие менее распространено, используйте стоимость, указанную здесь.



Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Алебарда дуэльная</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>10</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+4 cut</damage>
			<strength>12†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 imp</damage>
			<strength>12†</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dueling Halberd
<img data-src="http://weapons.gurps.ru/img/1673.png">

Европа.

Тяжелое древковое оружие с комбинированным наконечником, состоящим из лезвия боевого топора с выступающим острием на обухе (использующимся в качестве Крюка, стр.54) и с острием вверху древка (использующимся как копье). Боевые версии могли быть укорочены до размеров ДУЭЛЬНОЙ АЛЕБАРДЫ (стр.68) для индивидуального сражения. Сюда же относятся жи (Китай) и вульж (Швейцария).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет для дичи</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>450</value>
		<weight>9</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>8†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(8)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Стальной арбалет (См LT78, заметка 6)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Fowling Crossbow
<img data-src="http://weapons.gurps.ru/img/1691.png">

Европа.

Был изобретен приблизительно в 1400 н.э. - очень поздний ТУ3 - но классифицируется как оружие раннего ТУ4. В полной мере использует преимущества высококачественной стали, известной в то время как "арбалетная сталь". К представителям относятся: АРБАЛЕТ ДЛЯ ДИЧИ, ОХОТНИЧИЙ АРБАЛЕТ, ВОЕННЫЙ АРБАЛЕТ и ОСАДНЫЙ АРБАЛЕТ (все на стр.72, Б276). Все они крепче чем стандартный АРБАЛЕТ; поэтому считайте их упрочненными (стр.14). Жесткость стали позволяет компактному луку, несмотря на небольшой размер, обладать большей СЛ(ST), однако короткое натяжение тетивы и больший вес делают его менее эффективным; используйте половину от полной СЛ(ST) для определения Дальности и Повреждений. (Например: осадный арбалет снабжен кранекином с множителем силы x3. Арбалетчик с СЛ(ST) 12 может взвести осадный арбалет с СЛ(ST) 36. Повреждения и Дальность рассчитываются от СЛ(ST) 36/2 = 18.)

Стальной арбалет (См LT78, заметка 6)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Биль дуэльный</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1, 2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dueling Bill
<img data-src="http://weapons.gurps.ru/img/1668.png">

Европа.

Древковое оружие с клинком с крюком на обратной стороне, которое позволяет владельцу использовать правила во врезке "Крюк", обычно чтобы сбросить с лошади всадника. Первоначально это оружие использовалось на полях сражений, но иногда его делали с более короткой рукоятью для личного боя; результат - ДУЭЛЬНЫЙ БИЛЬ (стр. 68), к нему относятся лесной биль (forest bill, Англия) и гвизарма (Франция).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бледная поганка</description>
		<tech_level>0</tech_level>
		<legality_class>0</legality_class>
		<value>25</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Deathcap Mushroom
<img data-src="lib/img/151600792222.png"><img data-src="lib/img/151600806597.png">
Этот гриб (Amanita phalloides) является пищевым ядом, с часовой задержкой и броском ЗД(HT)-2 для сопротивления.Провал означает 1d ядовитых повреждений и галлюцинации (стр. Б429). Этот яд наносит дополнительные 2d ядовитых повреждений в течение двух циклов с трехчасовыми интервалами, с броском ЗД(HT)-2 для сопротивления. Провал первого броска ЗД(HT)-2 также вызывает потерю сознания (стр. Б429); провал при втором означает сердечный приступ (стр. B429). В дополнение ко всему этому, он вызывает головную боль без задержки или броска сопротивления, считайте умеренной болью (р. Б428), усиливающуюся до сильной боли при повреждениях, достигших ЕЖ(HP)/2, и ужасной боли, когда повреждения достигают ЕЖ(HP) (если жертва еще в сознании), и продолжающуюся до успешного броска сопротивления. $25 за дозу. КЛ(LC)0.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гада</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>15</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+6 cr</damage>
			<strength>16‡</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>15†</strength>
			<usage>Thrust</usage>
			<reach>1*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Gada
<img data-src="http://weapons.gurps.ru/img/1696.png">

Индия. 

Эта гигантская палица символизирует физическую силу. Это оружие держат двумя руками, им либо машут, либо наносят "тычки", держа возле навершия. Представленная в списке гада является маленькой; экземпляры большего размера не редки. См. правила по масштабированию оружия в GURPS Ранние Технологии Спутник 2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>3400</value>
		<weight>9</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>10†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(8)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Gastraphetes
<img data-src="http://weapons.gurps.ru/img/1699.png">

Древняя Греция.

Предшественник греческой и римской механической артиллерии, по сути это огромный СОСТАВНОЙ ЛУК (стр.Б275), слишком мощный для обычного человека. Можете считать его ранним вариантом СОСТАВНОГО АРБАЛЕТА (выше), со встроенным зарядным механизмом (см. Упор в Живот, стр.79). Типичный гастрофет имеет СЛ(ST) 13.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>66</value>
		<weight>2</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Gastraphetes Bolt
<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет - пуля</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.15</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Gastraphetes Bolt
<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет большой двойной</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>18000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>5d imp</damage>
			<strength>60M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>300/375</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-12</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Gastraphetes, Double
<img data-src="lib/img/151661973733.png">
Изначально, гастрофет (стр.72) был персональным оружием, сравнимым с тяжелым арбалетом. Позже масштаб был увеличен, и перемещать его стало возможно только при помощи механических устройств. Здесь представлены два варианта: большой двойной гастрофет, который может стрелять двумя длинными болтами, и легкий горный гастрофет, который стреляет одним коротким болтом.

У горного гастрофета был необычный ассиметричный станок, позволявший устанавливать его на покатой поверхности.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Глефа дуэльная</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>6</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>9†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr + 3 imp</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0U/ 0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dueling Glaive
<img data-src="http://weapons.gurps.ru/img/1671.png">

Европа. 

Древковое оружие, состоящие из заостренного тесака на длинном древке, развилось из ТЯЖЕЛОГО КОПЬЯ (стр.69) в древние времена. Более короткая версия,  (стр.68), использовалась во время поединков в Средние Века, а также, как комбинация секиры и мушкетной сошки, существовала с середины 16 века в Восточной Европе под названием бердыш. Так же к этому виду оружия относятся фаучард (Франция); джедвардский или джедартский посох (Шотландия), часто снабжаемый гардой; и лохаберская секира (Шотландия), часто снабжаемая крюком. О крюках и гардах см. в ГУРПС Low-Tech Companion 2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дао</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>5</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dao
<img data-src="http://weapons.gurps.ru/img/1658.png">

Китай.

Тяжелый меч с удлиненной рукоятью, используется одной рукой для нанесения рубящих и колющих ударов. Сюда же относится и дав (Бирма).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Диск</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+2 cr</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x4/x6</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Disc</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Discus
<img data-src="http://weapons.gurps.ru/img/1663.png">

Древняя Греция. Деревянный или металлический метательный диск. Метательное кольцо (Европа, Средний Восток) использует такие же характеристики.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Домино, 30 костяшек</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>22</value>
		<weight>1.5</weight>
		<reference>LT39</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Dominos, 30 tiles
<img data-src="lib/img/151602871949.png">
Игры с нумерованными плитками («косточками») были изобретены независимо в Египте и Китае около 1400 до н.э. Набор из 30 косточек: $22, 1.5 фунта. В ранние версии карточных игр, напоминающие маджонг (мачжан), играли большими наборами похожих на домино косточек: $44, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дротиковая духовая трубка - дротик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.05</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Blowpipe Dart
<img data-src="lib/img/151676830849.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дусак</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>1.5</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dusack
<img data-src="http://weapons.gurps.ru/img/1676.png">

Европа. 

Деревянный меч размером с короткий меч (стр.64).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Извергатель</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>500</value>
		<weight>50</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>1d+1 burn and linked 1 pi-</damage>
			<strength>16M†</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>1-6</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>1x300s</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Цена на турели: $270, 13.5 lbs.</notes>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Eruptor
<img data-src="lib/img/151602978621.png">
Увеличенный вариант железного огне-копья, предназначен для установки на городских стенах или рядом с городскими воротами. Поджигание требует манёвра Подготовки. Перезаряжается также, как и железное огне-копье, но вся процедура занимает 20 минут.



Цена на турели: $270, 13.5 lbs.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ двойное, 9м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>14000</value>
		<weight>6400</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Double Canoe, 30’
<img data-src="lib/img/151602882248.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ долбленное, 2.5м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>920</value>
		<weight>520</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Dugout Canoe, 8’
<img data-src="lib/img/151602895099.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карабин с кремнёвым замком</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>245</value>
		<weight>3.9</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>2d+2 pi++</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>65/670</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Flintlock Carbine
<img data-src="http://weapons.gurps.ru/img/1690.png">
<img data-src="http://weapons.gurps.ru/img/2037.png">

C кремнёвым замком 

Карабин, разработанный в Англии около 1690 года, с раздвижным прикладом. Если его свернуть, его можно использовать как пистолет, а не как ружьё. Со свёрнутым прикладом: Acc 2, ST 10, Bulk -3, Rcl 5.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карабин с кремнёвым замком - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Flintlock Carbine
<img data-src="lib/img/151676605490.png">
<img data-src="lib/img/151672076790.png"></description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кестр</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>sw imp</damage>
			<strength>6</strength>
			<usage>Shoot Dart</usage>
			<accuracy>1</accuracy>
			<range>x6/x10</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Dart Sling
<img data-src="http://weapons.gurps.ru/img/1660.png">

Ремень или шнур с "карманом" или "чашей" куда помещается снаряд. Использующий кладет снаряд в карман, берется одной рукой за оба конца шнура, раскручивает заряженную пращу над головой (горизонтально) или в стороне от себя (вертикально), после чего отпускает один конец, запуская таким образом снаряд. Присоединение пращи к палке, удерживаемой двумя руками, увеличивает подъемную силу, и как следствие наносимые повреждения и дальность полета снаряда; это ПРАЩА-ПОСОХ (стр.76), также известная как фустибал (Европа). ТЯЖЕЛАЯ ПРАЩА (стр.76) предназначена для бросания крупных снарядов на короткую дистанцию. Для того чтобы зарядить снаряд и использовать её требуются обе руки; техника метания схожа с метанием молота. Любая праща, из этих трех, может метать камни или свинцовые пули, или даже примитивные коктейли Молотова (см. Коктейль Молотова или Сосуды с Маслом, стр.Б411), с Точ 0 и только на 40% от обычной Дальности. Праща для метания дротиков, известная в Македонии как КЕСТР (стр.76), предназначена для метания однофутовых оперенных дротиков; хотя она и похожа на стандартную пращу, они не могут использовать снаряды друг друга. Кестр также не может быть использован для метания коктейлей Молотава.



Требует обеих рук для Подготовки, но только одной руки для атаки.

Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кестр - дротик</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.05</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Dart Sling Dart
<img data-src="lib/img/151676850944.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кинжал</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.25</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dagger
<img data-src="http://weapons.gurps.ru/img/1656.png">

В терминологии GURPS - короткий нож, только конец которого остр. К этому же виду относится и хиши (Япония). Исторически, этот термин описывает обоюдоострый нож с эфесом и навершием - крошечный меч. В повседневной жизни может обозначать КИНЖАЛ РОНДЕЛЬ (стр.67), СТИЛЕТ (стр.67) или любой нож размером от МАЛЕНЬКОГО НОЖА (стр.67, 77, Б727) до ДЛИННОГО НОЖА (стр.67, 69).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Книга по диагностике, базовая</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>2</weight>
		<reference>LT145</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Diagnostic Manual, Basic
Руководство по диагностике 
<img data-src="lib/img/151600813494.png">
Книга или сборник свитков, в которых перечисляются медицинские состояния, видимые симптомы, рекомендуемое лечение и возможные исходы; позволяет немодифицированный бросок Диагностики. Диагност без этого справочника получит -2, если столкнется с ранее неизвестным ему случаем.

Большое, полное руководство, подобное медицинской энциклопедии, или собрание нескольких книг, даёт +2; а обширная медицинская библиотека – +5. В любом случае это компенсирует штраф за редкую болезнь, но не даёт чистого бонуса. По решению Мастера, этот бонус может быть теми же, что и бонусы от Затраченного времени (стр.Б346) при длительных и кропотливых поисках. В этом случае для получения бонусов от дополнительно затраченного времени необходимы обширные справочные материалы; поиски в полном руководстве занимают в четыре раза больше времени, а в библиотеке – в тридцать раз.

Размеры и стоимость книги могут очень сильно различаться; см. GURPS Low- Tech Companion 1. Грубо говоря, печатный экземпляр Руководства по диагностике стоит $35 и весит 2 фунта. Более полный вариант (+2 к навыку при лечении известных состояний) $175, 20 фунтов. Рукописные копии стоят в 10 раз дороже и в весят в 4 раза больше.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Книга по диагностике, полная</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>175</value>
		<weight>20</weight>
		<reference>LT145</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Diagnostic Manual, Comprehensive
Руководство по диагностике 
<img data-src="lib/img/151600813494.png">
Книга или сборник свитков, в которых перечисляются медицинские состояния, видимые симптомы, рекомендуемое лечение и возможные исходы; позволяет немодифицированный бросок Диагностики. Диагност без этого справочника получит -2, если столкнется с ранее неизвестным ему случаем.

Большое, полное руководство, подобное медицинской энциклопедии, или собрание нескольких книг, даёт +2; а обширная медицинская библиотека – +5. В любом случае это компенсирует штраф за редкую болезнь, но не даёт чистого бонуса. По решению Мастера, этот бонус может быть теми же, что и бонусы от Затраченного времени (стр.Б346) при длительных и кропотливых поисках. В этом случае для получения бонусов от дополнительно затраченного времени необходимы обширные справочные материалы; поиски в полном руководстве занимают в четыре раза больше времени, а в библиотеке – в тридцать раз.

Размеры и стоимость книги могут очень сильно различаться; см. GURPS Low- Tech Companion 1. Грубо говоря, печатный экземпляр Руководства по диагностике стоит $35 и весит 2 фунта. Более полный вариант (+2 к навыку при лечении известных состояний) $175, 20 фунтов. Рукописные копии стоят в 10 раз дороже и в весят в 4 раза больше.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кости игральные</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<reference>LT39</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Dice
<img data-src="lib/img/151600823787.png">
Игральные кости из резных костей вроде бараньих фаланг восходят к 3000 г. до н.э. Большинство могло выдать 1-2 (игры с «двугранной костью» обычно предполагали бросок целой пригоршни и суммирование результатов), но было несложно встретить 1-4 и 1-6. Двадцатигранные кости, изобретённые римлянами, восходят ко второму веку н.э. Набор костей (до пяти двугранных или две или три кости с большим числом граней): $6, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Костюмный меч</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>1</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C,1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Dress Smallsword
<img data-src="http://weapons.gurps.ru/img/1666.png">

Франция.

Одноручный колющий меч, быстрый в атаке и защите, однако его легкий вес и малая досягаемость (reach) являются серьезными недостатками. Он еще легче и короче чем МАЛЫЙ МЕЧ, но может сойти за модный аксессуар. </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кремень</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.2</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Flint
<img data-src="lib/img/151661866258.png">
Кусочек кремня и кусочек металла или минерала, о который можно высечь искру. Производит громкий звук, который может привлечь внимание! Базовое время для разведения огня: 30 секунд. $2, 0.2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крепкий алкоголь, за 0.5л</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<reference>LT36</reference>
		<categories>
			<category>Еда и питье</category>
		</categories>
		<description-loc>Distilled Liquors, per pint
<img data-src="lib/img/151600832368.png"><img data-src="lib/img/151600848796.png">
Крепкие спиртные напитки (ТУ3). Изначально использовались в качестве лекарства, но получили большую популярность по мере снижения цены на перегонку. $20 за пинту на ТУ3, снижается до $16 за пинту на ТУ4.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кукла глиняная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<weight>0.25</weight>
		<reference>LT39</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Doll, Clay
<img data-src="lib/img/151602861355.png">
Многие сообщества делали маленькие фигурки из глины или недолговечных материалов. Возможно, ими играли. Глиняные: $4, 0.25 фунта. Из ткани, волоса или растительной шелухи: $4, незн.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кукла тряпичная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<reference>LT39</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Doll, Cloth
<img data-src="lib/img/151602866038.png">
Многие сообщества делали маленькие фигурки из глины или недолговечных материалов. Возможно, ими играли. Глиняные: $4, 0.25 фунта. Из ткани, волоса или растительной шелухи: $4, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кулеврина - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>870</value>
		<weight>6000</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Culverin Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кулеврина - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>30</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Culverin Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кураре</description>
		<tech_level>0</tech_level>
		<legality_class>1</legality_class>
		<value>50</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Curare
<img data-src="lib/img/151600748099.png">
<img data-src="lib/img/151600754956.png">

Этот яд извлечен из сока лозы Стрихнос ядоносный (Strychnos toxifera). Это инъекционный яд с одноминутной задержкой, и броском ЗД(HT)-6 для сопротивления, повторяющийся с 30-минутными интервалами в течение четырех циклов. Он вызывает 2d ядовитых повреждений каждый раз, независимо от результата проверки ЗД(HT), но каждый провал означает паралич (стр. Б429), в то время как критический провал означает удушье (стр. B428), которое может привести к смерти от удушья. $50 за дозу. КЛ(LC)1.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лучковая дрель для разжигания огня</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>0.75</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Firebow
<img data-src="lib/img/151660808249.png">
Это лучковая дрель (стр.28) приспособленная для разведения огня, трение производится тупым наконечником, а не острым, предназначенным для просверливания отверстия. Базовое время для разведения огня: 2 минуты. $5, 0.75 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нырятельный камень</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>15</weight>
		<reference>LT143</reference>
		<categories>
			<category>Снаряжение ныряльщиков</category>
		</categories>
		<description-loc>Diving Stone
<img data-src="lib/img/151602837924.png">
Человеческое тело весит примерно столько же, сколько равный объём воды. Чтобы достичь сколько-нибудь значительной глубины, нужно либо прыгать с высоты, либо активно плыть вниз. Раннее решение этой проблемы - камень, обвязанный шнуром. Одну ногу ныряльщик просовывает в шнур, как в стремя, и погружается с Движением 1 без активных усилий. Можно одновременно плыть горизонтально броском Плавания с -1. Чтобы использовать повторно, привяжите камень к верёвке, за которую его будет вытаскивать товарищ ныряльщика в лодке . 5$, 15 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Обмотки</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.5</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Foot Wrappings
<img data-src="lib/img/151661916304.png">
Самая первая защита ног – большие прочные листья или куски шкур, обернутые вокруг ног и связанные шнуром. Это сохраняет ноги в тепле и дает небольшую защиту подошвам. Обмотки не очень прочны и нуждаются в замене каждые несколько миль. Минимальная защита: $2, 0.5 фунта. Большие обмотки, защищающие и голень: $10, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Обмотки высокие</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Foot Wrappings, Boot
<img data-src="lib/img/151661923833.png">
Самая первая защита ног – большие прочные листья или куски шкур, обернутые вокруг ног и связанные шнуром. Это сохраняет ноги в тепле и дает небольшую защиту подошвам. Обмотки не очень прочны и нуждаются в замене каждые несколько миль. Минимальная защита: $2, 0.5 фунта. Большие обмотки, защищающие и голень: $10, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Огне-копьё</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>1d-1 burn</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>2-4</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>1x60s</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Огнеметы</category>
		</categories>
		<description-loc>Fire-Lance
<img data-src="lib/img/151663555602.png">
Изобретенное в Китае в начале 13 века, огне-копьё ценилось при обороне городских стен. Это двухфутовая ракета, привязанная к шесту. Солдат поджигал её и, рассеивая огонь и искры, направлял на врага. Использующий должен потратить один манёвр Подготовки чтобы взять шест в руки, еще один чтобы поджечь фитиль, и еще один чтобы изменить хват и вытянуть шест на всю длину перед собой. После того как заряд полностью сгорает оружие становится бесполезным и выбрасывается.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Огне-сифон</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>2750</value>
		<weight>550</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>3d burn</damage>
			<strength>29M†</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>15/25</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>60x1s</shots>
			<bulk>-14</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Выстрел может поразить одну твёрдую цель или разлиться кругом диаметром 2 ярда на поверхности воды. Используйте указанные повреждения для прямого попадания; продолжительные повреждения равняются 1d обж. в секунду, в течение 10d секунд после атаки. Требует 10 секунд на подготовку к стрельбе. После первого выстрела все последующие происходят непрерывно. Расстояние зависит от СЛ(ST).</notes>
		<categories>
			<category>Огнеметы</category>
		</categories>
		<description-loc>Fire-Siphon
<img data-src="lib/img/151660800658.png"><img data-src="lib/img/151660798255.png">
Византийское устройство для разбрызгивания греческого огня по вражеским кораблям, сделано на базе римских насосных механизмов. Встраивается в конструкцию боевого корабля, форсунка располагается снаружи корпуса. Греческая принцесса Анна Комнина описывала его использование в морской битве в 1103 н.э. Ручной хиросифон появился на полях битвы в начале 10 века; несколько десятилетий спустя арабы сделали из него заррак аль-нафт, разбрызгивающий нафту, а не греческий огонь. Он продолжал использоваться в Египте вплоть до 1400 года. Внешне ручной сифон напоминает большой водяной пистолет с присоединенным большим резервуаром и медленным фитилем (выше), прикрепленным снаружи форсунки, чтобы воспламенять топливо. Это оружие представлено в Таблице Огнеметов (стр. 86).



Выстрел может поразить одну твёрдую цель или разлиться кругом диаметром 2 ярда на поверхности воды. Используйте указанные повреждения для прямого попадания; продолжительные повреждения равняются 1d обж. в секунду, в течение 10к секунд после атаки (для огне-сифона) или 1d секунд (для хиросифона).



Требует 10 секунд на подготовку к стрельбе. После первого выстрела все последующие происходят непрерывно. Расстояние зависит от СЛ(ST).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Оленьи рога</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>75</value>
		<weight>1.5</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr+1 cut</damage>
			<strength>5</strength>
			<usage>Knife Thrust</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cut</damage>
			<strength>5</strength>
			<usage>Main-Gauche Thrust</usage>
			<reach>C</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Может использоваться для разоружения (стр.Б401) без пенальти -2 к попаданию за использование не-фехтовального оружия.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Deer Antlers
<img data-src="http://weapons.gurps.ru/img/1661.png">

Китай. 

Два переплетённых серповидных клинка, с рукояткой посередине одного из клинков. Это четырех-конечное оружие способно зажимать оружие противника между своими концами. Обычно используется в парах.


Может использоваться для разоружения (стр.Б401) без пенальти -2 к попаданию за использование не-фехтовального оружия.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Охотничье ружьё - выстрел</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT92</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Fowling Piece Shot
<img data-src="lib/img/151677142889.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Охотничье ружьё двуствольное</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>170</value>
		<weight>17</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>1d+1(0.5) pi-</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>15/330</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>2(40i)</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Fowling Piece, Double
<img data-src="http://weapons.gurps.ru/img/1692.png">

Очень длинноствольный дробовик, предназначеный на охоту и обычно заряжаемый дробью на птиц. Бывает одно- и двухствольное.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Охотничье ружьё одноствольное</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>135</value>
		<weight>9.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>1d+1(0.5) pi-</damage>
			<strength>7†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>15/330</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Shotgun</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Fowling Piece, Single
<img data-src="http://weapons.gurps.ru/img/1693.png">

Очень длинноствольный дробовик, предназначеный на охоту и обычно заряжаемый дробью на птиц. Бывает одно- и двухствольное.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Охотничья лодка 4.5м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>560</value>
		<weight>1040</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Fowling Boat, 16’
<img data-src="lib/img/151661967379.png">
Папирусные плоты, построенные для фараонов и знати для охоты на уток по берегам Нила, пригодны для перемещения по стоячей или медленно текущей воде где угодно. 16-ти футовый длинный корпус сужается от 3-х футовой балки в средней части лодки к тупому носу и корме, резко изогнутой вверх. Двое гребцов работают шестами, а пассажир сидит спереди.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Очки</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>0.25</weight>
		<reference>LT42</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Eyeglasses
<img data-src="lib/img/151602985850.png">
Очки изобрели в Италии около 1285 г. н.э. Выпуклые линзы исправляли дальнозоркость, включая трудности при чтении в старости. Николай Кузанский описывал исправляющие близорукость вогнутые линзы в трактате, написанном в 1453-1458; очки для близоруких - ТУ4. Считайте оба вида Смягчением (стр. B112) для своей формы Плохого зрения (стр. B123). На ТУ3-4 очки нужно держать перед глазами за оправу или ручку (лорнет), занимая руку, либо они зажимаются на переносице (пенсне). Пенсне слетает при 12 и менее на броске 3d если владелец движется быстрее обычной ходьбы; они часто крепятся на цепочку. $100, 0.25 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пинцет</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Forceps
<img data-src="lib/img/151661928784.png">
Иинструмент для захвата объектов или части тела. Удержание им намного лучше, чем пальцами. Считайте это противоположностью Слабой хватки (с. B123): +2 к умению для тонких задач, где важен хороший захват. Также снимает штрафы за затрудненный доступ (см. Расширенные модификаторы, с.147). $25, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пинцет для ресниц</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<reference>LT149</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Eyelash Forceps
<img data-src="lib/img/151603028443.png">
Набор крохотных зажимов, способных захватывать и удалять вросшие ресницы (см. Пинцет, с.148). $125, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пинцет зубной</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.5</weight>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Forceps, Dental

<img data-src="lib/img/151661948363.png">

Создан для захвата зуба и выдергивания его. Требует броска Хирургии от СЛ(ST); дает +2 за хороший захват. Обычный пинцет тоже можно использовать, но с -2, теряя премию за захват. Критический успех – вырывание всего зуба; обычный успех оставляет 1d/2 осколков (округлять вверх), которые нужно будет удалять отдельно; обычный провал оставляет зуб на месте; критический провал – 1d-3 вреда лицу. $50, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пинцет зубной для удаления осколков</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Forceps, Dental Splinter
    <img data-src="lib/img/151661933588.png">
Используется для удаления корней сломанного зуба; дополнительных бросков не надо. $50, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пинцет стафилагра</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>75</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Forceps, Staphylagra
<img data-src="lib/img/151661956128.png">
Фиксирующий пинцет с зубчатым зажимом, используемый для удаления хронически воспаленного язычка или геморроидальных узлов без риска кровотечения. $75, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет "утиная лапка"</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>150</value>
		<weight>1.9</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d+1 pi</damage>
			<strength>7</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>40/420</range>
			<rate_of_fire>0</rate_of_fire>
			<shots>1(20i)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Duck’s Foot Pistol
<img data-src="http://weapons.gurps.ru/img/1667.png">
С кремнёвым замком 
Разработан в 1720 году для противодействия массовым беспорядкам, этот странный пистолет имеет четыре ствола, расходящихся от одного замка, который стреляет из них всех разом. Вплоть до 2 ярдов, он действует как оружие с RoF 1*4, способное поразить одну цель. На дистанции 3+ ярда, он работает как четыре пистолета с RoF 1! Выберите угол в 30 градусов (как в правиле Spraying Fire, стр. Б409) и атакуйте одного из врагов там одним выстрелом; ему не нужно быть в центре этого угла. Потом используйте правило Hitting the Wrong Target (стр. 389) по отношению ко всем остальным в угле. Бросайте по порядку слева на право или с права на лево - на ваше усмотрение. Если каким-то образом ухитритесь поразить в сумме 4 цели, немедленно прекращайте бросать.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет "утиная лапка" - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Duck’s Foot Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет драгунов легкий</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>140</value>
		<weight>3</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>2d-1 pi+</damage>
			<strength>9</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>45/490</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Dragoon Pistol, Light
<img data-src="http://weapons.gurps.ru/img/1665.png">

С кремнёвым замком

Пистолеты драгунов. Оружие кавалеристов раннего 18ого века. Лёгкая модель .56 калибра и имеет ствол в 9 дюймов.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет драгунов легкий - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.8</value>
		<weight>0.04</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Dragon Pistol, Light Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет драгунов тяжелый</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>145</value>
		<weight>3.1</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>2d pi+</damage>
			<strength>10</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>55/540</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Dragoon Pistol, Heavy
<img data-src="http://weapons.gurps.ru/img/1664.png">

С кремнёвым замком

Оружие кавалеристов раннего 18ого века. Тяжёлая модель .65 калибра и имеет ствол в 12 дюймов.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет драгунов тяжелый - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Dragon Pistol, Heavy Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Подводная лодка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>40000</value>
		<weight>16000</weight>
		<reference>LT143</reference>
		<categories>
			<category>Подводные суда</category>
		</categories>
		<description-loc>Diving Boat
<img data-src="lib/img/151600881938.png">
Подлодка на этом ТУ - это 15-ти футовая крытая лодка, покрытая смазанной жиром кожей. Шесть пар весел торчат из кожаных вкладок. Т.к. тяга создаётся вёслами, а не пропеллером, управление кидается по новой специализации (Гребля) для навыка Подводная лодка (с. 11). Плавучесть обеспечивается заполнением водой камер под скамейками гребцов, чтобы погрузиться, и выдавливанием воды, чтобы всплыть. Лодка также оснащена металлическим балластом, чтобы добиться общей загрузки в 3.2 тонны, необходимой для нейтральной плавучести. Лодка может погружаться на глубину до 15 футов; самое длительное известное погружение длилось три часа.

Воздушные трубки, прикрепленные к поплавкам, позволяют команде и пассажирам свободно дышать. Некоторые источники утверждают, что Дреббель изобрел некие "алхимические" средства для поддержания воздуха пригодным для дыхания. Мастер может решить наделить подлодку (ТУ 4+1) технологией очистки воздуха.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Прижигатель для ресниц</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<reference>LT149</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Eyelash Cautery
<img data-src="lib/img/151603014238.png">
Тонкая железная игла с рукояткой; нагревается и прижигает корень вросшей ресницы после удаления волоса. $125, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рыбацкая лодка 8м</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>5000</value>
		<weight>4200</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Fishing Boat, 27'
<img data-src="lib/img/151660821114.png">
Лодка в стиле раковины, сконструированная древними жителями Средиземноморья, с досками соединёнными по краям деревянными гвоздями. Лёгкая, с практически отсутствующим каркасом. Габариты: длинна 27 футов, ширина 7,5 футов, высота борта 4 фута; заострённый нос, угловатая корма. Движется при помощи двух пар вёсел. В основном используется для ловли рыбы, однако может быть адаптирована для перевозки груза или десятерых пассажиров.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Салазки на пятьдесят человек</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>2500</value>
		<weight>8000</weight>
		<reference>LT135</reference>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Fifty-Man Sledge
<img data-src="lib/img/151660754962.png">
Использовались для таких задач, как перетаскивание строительных материалов. Подобны салазкам на одного человека (стр. 133), но куда больше. Груз находится на платформе, которая стоит на двух полозьях.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Слуховая трубка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>2</weight>
		<reference>LT42</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Ear Trumpet
<img data-src="lib/img/151602899347.png">
Слуховая трубка - широкий, расширяющийся рог на конце конической трубки. Узкий конец прикладывается к уху. Концентрируя звуковые волны с большой площади, он усиливает незаметные для владельца звуки. Изначально предназначался для моряков, позволяя слышать крики с других кораблей, но позднее был перенят плохо слышащими для смягчения своих проблем. Изобретательные шпионы задумаются о других применениях! Увеличьте дистанцию, с которой звук может быть услышан, в 8× (см. Слух, стр. B358). $15, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Собачьи сани</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>580</weight>
		<reference>LT135</reference>
		<notes>Запрягаются собаками</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Dogsled
Нарты
<img data-src="lib/img/151602849956.png">
Классический транспорт в Арктике, использовался племенами инуитов. Достаточно длинные, чтобы человек мог лечь; или он может нагрузить их снаряжением, а сам бежать рядом. Версию на таблице тянут 14 собак, каждая в отдельной кожаной упряжи. Сделаны по большей части из костей и кожи, а не из дерева.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела летучая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.05</weight>
		<reference>LT73</reference>
		<notes>Половина повреждений до 1/2D,  после 1/2D повреждений не наносит; Модификаторы дальности удваиваются</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Flight Arrow
<img data-src="lib/img/151661851337.png">
Летучая стрела жертвует силой ради большего расстояния. Наносит половину повреждений на расстоянии до 1/2Д; далее 1/2Д не наносит повреждений! Умножьте оба модификатора Дальности на 2. Обычная цена, вес уполовинен.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела огне-клетка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>Повреждения pi-; Огнем 1d-3 burn; -2 к попаданию, -1 Acc,  снижает на 5 оба множителя Расстояния; для зажигания маневр Подготовки</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Fire-Cage Arrow
<img data-src="lib/img/151660769001.png"><img data-src="lib/img/151660770188.png">
Специализированная версия импровизированной зажигаемой стрелы (Б.410), с коротким заостренным наконечником, в виде "клетки", предназначенным для хранения заряда, обычно промасленной ветоши. Наконечник может ранить, но в первую очередь нужен для того чтобы стрела могла воткнуться в деревянное строение и зажечь его; повреждения становятся малыми пробивающими. Хотя размер заряда и маленький, он всё-же больше чем в импровизированной версии; наносит 1d-3 обж. вреда. Как и стандартная зажигаемая стрела, стрела с огне-клеткой получает штраф -2 к проверке попадания; дополнительно она получает штраф -1 Точ и снижает на 5 оба множителя расстояния. Во всём остальном это зажигаемая стрела. Цена и вес без изменений.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела огненная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>-1 Acc,  снижает на 5 оба множителя Расстояния; для зажигания маневр Подготовки</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Fire Arrow
<img data-src="lib/img/151660762745.png">
Это Китайское улучшение импровизированной зажигаемой стрелы (стр.Б410), в виде закрученной трубочки с порохом. Убирает штраф -2 к броску на попадание (поскольку нет открытого пламени), но делает стрелу громоздкой: штраф -1 к Точ и снижает на 5 оба множителя Расстояния. Чтобы зажечь трубочку требуется маневр Подготовки и источник огня. Урон наносимый попаданием стрелы не изменяется. Заряд пороха наносит 1d-1 дроб. обж. (cr burn) Огненные стрелы очень чувствительны к влаге (дождю или сырости) - без соответствующей защиты они быстро портятся. Во всём остальном можете считать их обычными зажигаемыми стрелами. Стоят на 5$ больше, двойной вес.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрелы с режущими наконечниками</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>Повреждения становится Cutting</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Cutting Arrow
<img data-src="lib/img/151600779578.png">
Стрелы с режущими наконечниками (срезни): Наконечник в форме листа, или C-, U- или Y-образный, заточенный на внутренней стороне. Преобразует повреждения в режущие. Характеристики остаются без изменений.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Трут улучшенный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Enhanced Tinder
<img data-src="lib/img/151602968934.png">
Высушенный трутовик, замоченный в растворе селитры, зажигается намного лучше сухого дерева. Уменьшает время разведения огня в два раза (таким образом, улучшенный трут нейтрализует удвоение времени за влажные условия). На один раз: $2, 0.1 фунта
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Удавка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>see B405</damage>
			<usage>Garrote</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Garrote</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Garrote
<img data-src="http://weapons.gurps.ru/img/1698.png">

повсеместно. Шнур, проволока или веревка, используемые для удушения жертвы. Также известна, как гаротта.</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалкон</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>9400</value>
		<weight>680</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>10d+1 pi++</damage>
			<strength>36M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>140/1,300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-12</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Falcon
<img data-src="lib/img/151603057096.png">

Ранние Европейские пушки (ТУ4)

К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалкон - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>540</value>
		<weight>850</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Falcon Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалкон - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>64</value>
		<weight>3.2</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Falcon Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалконет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>6700</value>
		<weight>500</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>7d pi++</damage>
			<strength>33M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>120/1,000</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-10</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Falconet
<img data-src="lib/img/151603047425.png">
Ранние Европейские пушки (ТУ4)



К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалконет - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>625</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Falconet Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фалконет - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>28</value>
		<weight>1.4</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Falconet Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фальшион</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>3</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Falchion
<img data-src="http://weapons.gurps.ru/img/1683.png">

Средневековый европейский термин, применяемый практически к любому мечу с односторонней заточкой, но чаще к тем, у которых лезвие расширяется к концу, тяжелое, и/или изгибается вперёд возле конца, что делает более удобными режущие удары, а не колющие. Такой клинок существовал практически у всех культур, занимавшихся обработкой железа; охотники и солдаты всего мира ценили его в качестве инструмента (для разделки дичи, вырубки кустов, вскрывания кокосов, и т.п.) и оружия. Обычно заострен, но существуют варианты с тупым концом, что изменяет урон с колющего на дробящий. Фальшионы обычно размером с короткий меч, к ним относят боло (Филипины), дан санг гум (Корея), фальката (до-Римская Иберия), паранг (Индонезия), сика (Древний рим), серповидный меч (повсеместно), тромбаш (Конго), и меч-бабочку (Китай), который выделяется тем, что оборудован гардой. БОЛЬШОЙ ФАЛЬШИОН (стр.65) размером с широкий меч, включает в себя самые большие паранги и кольцевой меч (Китай).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ферментированные напитки, за 4л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>LT36</reference>
		<categories>
			<category>Еда и питье</category>
		</categories>
		<description-loc>Fermented Beverages, per gallon
<img data-src="lib/img/151603066468.png">
Вино, пиво и прочие продукты спиртового брожения (ферментированное молоко, рисовое вино и т.п.). Могут быть фильтрованными или слегка приправленными по вкусу изготовителя, но содержание алкоголя в них невелико. $5 за галлон.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фибула золотая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>8000</value>
		<weight>0.4</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Fibula, gold
<img data-src="lib/img/151603071971.png">
Похожа на большую булавку. Использовалась по всей Европе в качестве застёжки и украшения.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фибула медная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>0.2</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Fibula, copper
<img data-src="lib/img/151603069746.png">
Похожа на большую булавку. Использовалась по всей Европе в качестве застёжки и украшения.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фибула серебряная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>230</value>
		<weight>0.23</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Fibula, silver
<img data-src="lib/img/151603073765.png">
Похожа на большую булавку. Использовалась по всей Европе в качестве застёжки и украшения.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фифа</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>1</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Fife
<img data-src="lib/img/151603078167.png">
Пронзительный инструмент похожий на флейту, использовался спартанцами - и военными оркестрами последующих веков. Играется навыком Музыкальный Инструмент (Флейта). Дистанция слышимости 16 ярдов. 100$, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фузея обыкновенная</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>150</value>
		<weight>6.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>3d pi++</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>75/750</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Fusil Ordinaire
<img data-src="http://weapons.gurps.ru/img/1695.png">

Фузея подобна каливеру, только с кремнёвым замком, а не с фитильным. Охотничья фузея (.55 калибра, fusil de chasse) широко используется охотниками, позволяя им не держать фитиль зажжённым на природе, что неудобно; она становится доступной около 1630 года. Изящная фузея (fusil fin) подобна, но сделана специально для благородных, которым нужно самое лучшее ружьё; считайте её качественной (точной), за +0,75 ЦФ. Более тяжёлая военная модель, или обыкновенная фузея (.64 калибра), первоначально использовалась там, где горящий фитиль был бы неудобен или опасен; французский полк, посланный в Канаду в 1660ом воевать с ирокезами был первым отрядом общего назначения, который был ими вооружен. Гренадёрская фузея похожа на обыкновенную, но у неё есть ремень (стр. 96). Ещё более тяжёлый вариант, буканирская фузея, популярна для использования на борту корабля: Повр. 3d+1 pi++, Вес 7.5/0.065, СЛ(ST) 10†, Bulk -11.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фузея обыкновенная - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.3</value>
		<weight>0.065</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Fusil Ordinaire Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фузея охотничья</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>145</value>
		<weight>6.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>2d+2 pi+</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>75/750</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Fusil de Chasse
<img data-src="http://weapons.gurps.ru/img/1694.png">

Фузея подобна каливеру, только с кремнёвым замком, а не с фитильным. Охотничья фузея (.55 калибра, fusil de chasse) широко используется охотниками, позволяя им не держать фитиль зажжённым на природе, что неудобно; она становится доступной около 1630 года. Изящная фузея (fusil fin) подобна, но сделана специально для благородных, которым нужно самое лучшее ружьё; считайте её качественной (точной), за +0,75 ЦФ. Более тяжёлая военная модель, или обыкновенная фузея (.64 калибра), первоначально использовалась там, где горящий фитиль был бы неудобен или опасен; французский полк, посланный в Канаду в 1660ом воевать с ирокезами был первым отрядом общего назначения, который был ими вооружен. Гренадёрская фузея похожа на обыкновенную, но у неё есть ремень (стр. 96). Ещё более тяжёлый вариант, буканирская фузея, популярна для использования на борту корабля: Повр. 3d+1 pi++, Вес 7.5/0.065, СЛ(ST) 10†, Bulk -11.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фузея охотничья - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.8</value>
		<weight>0.04</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Fusil de Chasse Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фьёринг 6м</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2500</value>
		<weight>2500</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Faering, 20'
<img data-src="lib/img/151603039934.png">
Лодка по конструкции напоминающая лодку с прямым парусом (выше), но с 3-4 парами вёсел, использовалась во времена викингов - хотя те же самые характеристики могут быть использованы для различных средневековых лодок с вёслами. Типичные габариты: длина 20 футов, ширина 4 фута, высота борта 2 фута. Может быть использована в прибрежных водах для рыбной ловли или перевозки грузов, или как вспомогательное судно на большом корабле.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цеп</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>13†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цеп происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Flail
<img data-src="http://weapons.gurps.ru/img/1689.png">

Двуручное оружие - известное почти везде, где цепами молотят зерно - состоит из железных брусьев, шипованых шаров, или похожих тяжёлых вещей, присоединенных цепью или шнуром к длинной рукоятке. Сюда же относится и чи-гирики (Япония).



Попытки парировать цеп происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цилиндрическая печать</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Cylinder Seal
<img data-src="lib/img/151600786546.png">
Изобретены в древнем Шумере. Цилиндр прокатывался по влажной глине – а позже по воску – оставляя небольшой оттиск, чаще всего подпись. Обычно вырезались из полудрагоценных камней. $20, незн. 
</description-loc>
	<weight></weight></equipment><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.15</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 2, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.33 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 1/4 л.
</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.25</value>
		<weight>0.3</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 3, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.31 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 5, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">5.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>4</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 7, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">20.8 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7.5</value>
		<weight>10</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 9, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">43.2 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>16</value>
		<weight>20</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 11, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">128 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из необожжённой глины, 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>41</value>
		<weight>52</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 15, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">432 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, 1/4 cup
<img data-src="lib/img/151602920523.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.3</value>
		<weight>0.15</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 2, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.33 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.75</value>
		<weight>0.3</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 3, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.31 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 5, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">5.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>9</value>
		<weight>4</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 7, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">20.8 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>22.5</value>
		<weight>10</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 9, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">43.2 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>48</value>
		<weight>20</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 11, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">128 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Горшок из фарфора, 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>123</value>
		<weight>52</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 15, Хрупкий (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">432 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Earthenware Jar, Porcelain, 1 quart
<img data-src="lib/img/151602953287.png">
Глиняные кувшины имеют СП(DR) 1 и они Хрупкие (Ломкие) (стр. B136). Фарфоровые сосуды имеют тройную цену. Любые из них выдерживают 1.5 унции веса на кубический дюйм или 160 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment version="3">
		<quantity>1</quantity>
		<description>Аркан</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>3</weight>
		<reference>LT76</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>7†</strength>
			<usage>Lasso</usage>
			<accuracy>0</accuracy>
			<range>3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>Skill</type>
				<name>Lasso</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Lariat
<img data-src="http://weapons.gurps.ru/img/1789.png">

[В Low Tech описание отсутствует, есть только в таблице]

Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет большой двойной - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>6800</value>
		<weight>270</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Gastraphetes, Double Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет легкий горный</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>5000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>3d imp</damage>
			<strength>22M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>320/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-11</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Gastraphetes, Mountain
<img data-src="lib/img/151663168995.png">
Изначально, гастрофет (стр.72) был персональным оружием, сравнимым с тяжелым арбалетом. Позже масштаб был увеличен, и перемещать его стало возможно только при помощи механических устройств. Здесь представлены два варианта: большой двойной гастрофет, который может стрелять двумя длинными болтами, и легкий горный гастрофет, который стреляет одним коротким болтом.

У горного гастрофета был необычный ассиметричный станок, позволявший устанавливать его на покатой поверхности.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).



</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет легкий горный - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>33</value>
		<weight>1</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Gastraphetes, Mountain Bolt
<img data-src="lib/img/151672143348.png">
		</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гастрофет легкий горный - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1900</value>
		<weight>75</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Gastraphetes, Mountain Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Глефа</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Glaive
<img data-src="http://weapons.gurps.ru/img/1702.png">

Европа. 

Древковое оружие, состоящие из заостренного тесака на длинном древке, развилось из ТЯЖЕЛОГО КОПЬЯ (стр.69) в древние времена. Более короткая версия, ДУЭЛЬНАЯ ГЛЕФА (стр.68), использовалась во время поединков в Средние Века, а также, как комбинация секиры и мушкетной сошки, существовала с середины 16 века в Восточной Европе под названием бердыш. Так же к этому виду оружия относятся фаучард (Франция); джедвардский или джедартский посох (Шотландия), часто снабжаемый гардой; и лохаберская секира (Шотландия), часто снабжаемая крюком. О крюках и гардах см. в ГУРПС Low-Tech Companion 2.</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Стеклянная бутылка, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.15</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 3, Хрупкие (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.33 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Glass Bottle, 1/4 cup
<img data-src="lib/img/151663262047.png">
Стеклянные бутылки имеют СП(DR) 1 и они Хрупкие (Ломкие). Они выдерживают столько же веса, сколько и глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Стеклянная бутылка, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1.5</value>
		<weight>0.4</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 3, Хрупкие (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.31 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Glass Bottle, 1 cup
<img data-src="lib/img/151663262047.png">
Стеклянные бутылки имеют СП(DR) 1 и они Хрупкие (Ломкие). Они выдерживают столько же веса, сколько и глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Стеклянная бутылка, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3.75</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 5, Хрупкие (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">5.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Glass Bottle, 1 quart
<img data-src="lib/img/151663262047.png">
Стеклянные бутылки имеют СП(DR) 1 и они Хрупкие (Ломкие). Они выдерживают столько же веса, сколько и глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Стеклянная бутылка, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>13.5</value>
		<weight>4</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 7, Хрупкие (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">20.8 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Glass Bottle, 1 gal.
<img data-src="lib/img/151663262047.png">
Стеклянные бутылки имеют СП(DR) 1 и они Хрупкие (Ломкие). Они выдерживают столько же веса, сколько и глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Стеклянная бутылка, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>21</value>
		<weight>6</weight>
		<reference>LT34</reference>
		<notes>DR 1, HP 8, Хрупкие (Ломкие) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">43.2 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Glass Bottle, 2 gal.
<img data-src="lib/img/151663262047.png">
Стеклянные бутылки имеют СП(DR) 1 и они Хрупкие (Ломкие). Они выдерживают столько же веса, сколько и глиняные кувшины.
</description-loc>
	</equipment_container><equipment version="3">
		<quantity>1</quantity>
		<description>Алебарда</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>12</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+5 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+4 imp</damage>
			<strength>13‡</strength>
			<usage>Spike Thrust</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Может застрять; см Кирки (стр.Б405).</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Halberd
<img data-src="http://weapons.gurps.ru/img/1709.png">

Европа. 

Тяжелое древковое оружие с комбинированным наконечником, состоящим из лезвия боевого топора с выступающим острием на обухе (использующимся в качестве Крюка, стр.54) и с острием вверху древка (использующимся как копье). Боевые версии могли быть укорочены до размеров ДУЭЛЬНОЙ АЛЕБАРДЫ (стр.68) для индивидуального сражения. Сюда же относятся жи (Китай) и вульж (Швейцария).



Может застрять; см Кирки (стр.Б405).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>6</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+4 imp</damage>
			<strength>7†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x20/x25</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Crossbow
<img data-src="http://weapons.gurps.ru/img/1649.png">
<img data-src="http://weapons.gurps.ru/img/2028.png">

Азия, Европа. Оружие, запасающее силу в натяжении. Тетива оттягивается назад рукой, как описано на стр.Б410. Знакомые нам западные версии были созданы преимущественно в Средние Века, однако китайские датируются 600 годом до н.э. Также иногда называется самострелом.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет охотничий</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>12</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>10†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(13)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Стальной арбалет (См LT78, заметка 6)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Hunting Crossbow
<img data-src="http://weapons.gurps.ru/img/1728.png">

Европа.

Был изобретен приблизительно в 1400 н.э. - очень поздний ТУ3 - но классифицируется как оружие раннего ТУ4. В полной мере использует преимущества высококачественной стали, известной в то время как "арбалетная сталь". К представителям относятся: АРБАЛЕТ ДЛЯ ДИЧИ, ОХОТНИЧИЙ АРБАЛЕТ, ВОЕННЫЙ АРБАЛЕТ и ОСАДНЫЙ АРБАЛЕТ (все на стр.72, Б276). Все они крепче чем стандартный АРБАЛЕТ; поэтому считайте их упрочненными (стр.14). Жесткость стали позволяет компактному луку, несмотря на небольшой размер, обладать большей СЛ(ST), однако короткое натяжение тетивы и больший вес делают его менее эффективным; используйте половину от полной СЛ(ST) для определения Дальности и Повреждений. (Например: осадный арбалет снабжен кранекином с множителем силы x3. Арбалетчик с СЛ(ST) 12 может взвести осадный арбалет с СЛ(ST) 36. Повреждения и Дальность рассчитываются от СЛ(ST) 36/2 = 18.)



Стальной арбалет (См LT78, заметка 6)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет составной</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>950</value>
		<weight>7</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>8†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Composite Crossbow
<img data-src="http://weapons.gurps.ru/img/1647.png">

Европа. Созданная приблизительно в 1100 г. н.э. версия АРБАЛЕТА (ниже; стр.Б276), в которой простой деревянный лук (стр.73) заменен составным, сделанным из слоев рога, дерева и сухожилий.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арфа</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>7</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Harp
<img data-src="lib/img/151663364830.png">
Классический инструмент для барда. Играется при помощи навыка Музыкальный инструмент (Арфа). Дистанция слышимости: 4 ярда. $600, 7 фунтов.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Благовонии дешевые, 30г</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>0.1</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Incense, Cheap, per ounce
<img data-src="lib/img/151663520945.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Благовонии качественные, 30г</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>0.1</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc><img data-src="lib/img/151663522308.png">Incense, Fine, per ounce
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Боевой веер</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<strength>6</strength>
			<usage>Swing</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Combat Fan
<img data-src="http://weapons.gurps.ru/img/1646.png">
<img data-src="http://weapons.gurps.ru/img/1645.png">

Китай, Япония, Корея. 

Металлическая версия складного веера, используемого как мужчинами так и женщинами. Складывается либо частично, либо вообще не складывается. Используется как запасное оружие и как символ власти. В Японии называется тессен ("железный веер") .



Режущий удар идет с -2 к умению.



Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Болиголов</description>
		<tech_level>0</tech_level>
		<legality_class>1</legality_class>
		<value>5</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Hemlock
<img data-src="lib/img/151663377334.png"><img data-src="lib/img/151663380919.png">
Растение Conium maculatum является пищевым ядом с часовой задержкой; пострадавший получает на -2 к СЛ(ST) и -2 к ЛВ(DX), и должны сделать бросок ЗД(HT)-2 , чтобы избежать 1d ядовитых повреждений. Урон повторяется ежечасно в течение пяти циклов. Повреждения, равные 1/3 ЕЖ(HP), вызывают паралич (стр. Б429) в ступнях; повреждения, равные 1/2 ЕЖ(HP) парализуют нижнюю часть ног; повреждения, равные 2/3 ЕЖ(HP), парализуют верхнюю часть ног; и повреждения, равные полным ЕЖ(HP), парализует живот. В этот момент жертва должна бросать против ЗД(HT), чтобы избежать слепоты. В случае, если повреждения достигают 2xЕЖ, паралич распространяется на сердце; считайте сердечным приступом (стр. Б429). $5 за дозу. КЛ(LC)1.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Большая лодка из шкур 11м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>6680</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Large Hide Boat, 36’
<img data-src="lib/img/151664214221.png">
Лодка сделанная из прочной древесины, покрытой несколькими большими шкурами; то же самое что и эскимосский умиак, похожий на сибирскую байдару, или ирландский куррах (используемый в наше время. Легенда утверждает что именно на этом судне св.Брендан пересёк Атлантический океан). Это судно имеет форму обычной лодки с изогнутыми бортами, управляется рулём на корме, а движется при помощи весел или паруса. Типичные габариты: длина 36 футов, ширина 6 футов, высота борта 3 фута.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Большая сеть</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>20</weight>
		<reference>LT59</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>11</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>spec.</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>-5</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404). У сети нет расстояния половины повреждений. Максимальное расстояние равняется (СЛ(ST)/2 + Навык/5) для большой сети и (СЛ(ST) + Навык/5) для боевой сети.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Large Net
<img data-src="http://weapons.gurps.ru/img/1784.png">

Древний Рим. 

Утяжеленная сеть предназначенная для сражений. БОЕВАЯ СЕТЬ (стр.76) - одноручная метательная или для ближнего боя, использовалась Римскими гладиаторами в паре с ТРЕЗУБЦЕМ. Позволяет использовать Блокировать со значением (навык / 2) + 3, но не дает ПЗ(DB), и, как Рассеянная цель (стр.Б380), может остановить только 1-2 единиц урона, при блокировании снарядов. БОЛЬШАЯ СЕТЬ (стр.76) требует обеих рук и может быть использована только для метания, но из нее тяжелее выпутаться; см. правила на стр.Б411. Боец вооруженный сетью может расстилать её перед собой с целью опрокинуть оппонента. Гекс, в котором находится сеть считается неустойчивым. После чего можно попытаться выдернуть сеть из под ног оппонента. Проведите Быстрое Состязание СЛ(ST). Если использующий сеть выигрывает, оппонент падает, в обратном случае ничего не происходит. В случае если у использующего выпадает критический промах, падает он!



Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).

У сети нет расстояния половины повреждений. Максимальное расстояние равняется (СЛ(ST)/2 + Навык/5) для большой сети и (СЛ(ST) + Навык/5) для боевой сети.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Венец золотой</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20000</value>
		<weight>1</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Crown, gold
<img data-src="lib/img/151600728579.png">
Металлический обруч для ношения на голове. Обычная тиара может считаться лёгким венцом или изящным гребнем.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Венец медный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.5</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Crown, copper
<img data-src="lib/img/151600725682.png">
Металлический обруч для ношения на голове. Обычная тиара может считаться лёгким венцом или изящным гребнем.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Венец серебренный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>0.6</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Crown, silver
<img data-src="lib/img/151600732300.png">
Металлический обруч для ношения на голове. Обычная тиара может считаться лёгким венцом или изящным гребнем.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Веревочная лестница 9м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>22</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Ladder, Rope, 30 feet
<img data-src="lib/img/151664150506.png">
Похожа на обычную лестницу, за исключением того что в качестве реек используются веревки. Перекладины могут быть тоже веревочными или из более жесткого материала. Веревочную лестницу можно легко свернуть для более легкой транспортировки, но на неё тяжелее залазить, потому что она очень шаткая: скорость обычного подъема равняется одной ступеньке за каждые 2 секунды, в спешке - 1 ступенька в секунду. 30 футовая лестница: $50, 22 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Воздушный змей</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>33</value>
		<weight>2</weight>
		<reference>LT40</reference>
		<categories>
			<category>Игры и развлечения</category>
		</categories>
		<description-loc>Kite
<img data-src="lib/img/151664020104.png">
Сделанные из шелка или бумаги на деревянной раме воздушные змеи появились в восточной Азии между 1000 и 500 гг. до н.э. Кроме развлекательных целей, змеи использовались как заметные издалека сигнальные флаги или для переправки маленьких предметов по воздуху через препятствия. При благоприятном ветре обычный змей может поднять до 0.5 фунта. Воздушный змей шириной в ярд, с 20 ярдами нити: $33, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гарпун</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>11</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<notes>Привязной. См B276, B411.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Harpoon
<img data-src="http://weapons.gurps.ru/img/1712.png">

Зазубренное охотничье копье с присоединенной к нему леской. Не может быть использован для опутывания; леска предназначена для выдергивания оружия (см. сноску 8, стр. Б276). В ближнем бою можете считать его неудобным ТЯЖЕЛЫМ КОПЬЁМ (стр.69) с Досягаемостью (reach) 1, 2* и штрафом -2 к навыку.



Привязной. См B276, B411.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Горский пистолет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>135</value>
		<weight>2.75</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d+2 pi+</damage>
			<strength>9</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>45/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Highland Pistol
<img data-src="http://weapons.gurps.ru/img/1720.png">

С кремнёвым замком

Это оружие входит в употребление в самом конце ТУ4. Его 8-дюймовый ствол делает его очень удобным поясным пистолетом. Что необычно для той эпохи, он сделан целиком из стали.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Горский пистолет - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.6</value>
		<weight>0.03</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Highland Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Горючие смеси, ранние</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>1</weight>
		<reference>LT84</reference>
		<notes>за 0.5л; соприкосновение наносит 1 единицу burn в сек.;  залитые области получает 1d-1 burn в сек.; легко воспламеняема</notes>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Incendiaries, Early Mixtures

<img data-src="lib/img/151663513610.png">

Горючие вещества Древних Греков преимущественно состояли из смолы, которая горячо горела и липла ко всему, к чему прикасалась. Распространенными добавками были сера, уголь, и даже ароматические вещества. Лёгкое соприкосновение с такой смесью наносит 1 единицу обжигающих повреждений каждую секунду; всё, в области, залитой ей получает 1d-1 единиц обжигающих повреждений каждую секунду. Такие смеси являются легковоспламеняемыми (см. Заставляем предметы гореть стр. Б433), и продолжают гореть в течение 3d секунд после воспламенения, если не были потушены или помещены под воду. $1, 1 фунт, за каждую пинту.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Греческий огонь</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT84</reference>
		<notes>За 0.5л; Считайте огонь Коктейлем Молотова (стр. Б411) </notes>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Greek Fire
<img data-src="lib/img/151663329817.png">
 Эта смесь из зажигательных веществ – скорее всего содержащая нафту – изобретена сирийским беженцем, Каллиником, в 673 н.э. Точный состав держался Византийской Империей в строжайшем секрете и был утерян, вероятно в 1200-ые. Считайте Греческий огонь Коктейлем Молотова (стр. Б411) для подсчета повреждений и прочих эффектов. Может гореть на поверхности воды, что является настоящим ужасом для вражеского флота, и его нельзя погасить, заливая водой; одним из его названий в Византии было «морской огонь». Часто разбрызгивался при помощи огне-сифона (ниже). $10, 1 фунт, за каждую пинту.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дзитте</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Jutte
<img data-src="http://weapons.gurps.ru/img/1745.png">

Япония. 

Острое, похожее на наконечник копья лезвие с двумя ответвленными зубцами по краям, предназначенными для разоружения противника. Считайте тем же самым, что и САЙ (стр.66, 67). Название этого оружия и ДЗЮТТЭ (ниже) иногда путают или используют для обоих оружий одновременно - результат разных норм транслитераций.



Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дзё</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>9</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>6†</strength>
			<usage>Staff Swing</usage>
			<reach>1</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>6†</strength>
			<usage>Staff Thrust</usage>
			<reach>1</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>8†</strength>
			<usage>Sword Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>8†</strength>
			<usage>Sword Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Jo
<img data-src="http://weapons.gurps.ru/img/1739.png">

Япония. 

Палка длинной от 1.2 до 1.5 метров, обычно использует технику боя как у двуручного посоха. К похожим оружиям можно отнести ханбо (Япония) и тападо (Филипины).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Егерская винтовка</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>300</value>
		<weight>11</weight>
		<reference>LT94</reference>
		<ranged_weapon>
			<damage>3d+1 pi+</damage>
			<strength>10†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>65/650</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Jager Rifle
<img data-src="http://weapons.gurps.ru/img/1747.png">
С колесцовым замком 
Использовалась изначально немецкими охотниками и в дальнейшем принятая аристократами, которых они сопровождали на охоте. Есть одно- и двухствольные варианты.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Егерская винтовка - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Jäger Rifle Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Егерская винтовка двуствольная</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>500</value>
		<weight>20</weight>
		<reference>LT94</reference>
		<ranged_weapon>
			<damage>3d+1 pi+</damage>
			<strength>10†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>65/650</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>2(60i)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Rifle</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Jager Rifle, Double-Barreled
<img data-src="http://weapons.gurps.ru/img/1748.png">
С колесцовым замком 
Использовалась изначально немецкими охотниками и в дальнейшем принятая аристократами, которых они сопровождали на охоте. Есть одно- и двухствольные варианты.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Железная бомба</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>600</value>
		<weight>30</weight>
		<reference>LT85</reference>
		<notes>Повреждения 6dx4[2d] cr ex</notes>
		<categories>
			<category>Бомбы</category>
		</categories>
		<description-loc>Iron Bomb
<img data-src="lib/img/151663541088.png">
Во начале 13 века китайцы изобрели мощный чёрный порох, способный разорвать железную оболочку и разметать шрапнель. Маленькая железная бомба содержит 14 фунтов серпентина. Повреждения 6d x4 [2d] дроб. взрыв. (cr ex.), $600, 30 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Железное огне-копьё</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>150</value>
		<weight>10</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>1d burn and linked 1 pi-</damage>
			<strength>11†</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>2-4</range>
			<rate_of_fire>Jet</rate_of_fire>
			<shots>1x120s</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Liquid Projector</name>
				<specialization>Flamethrower</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Огнеметы</category>
		</categories>
		<description-loc>Iron Fire-Lance
<img data-src="lib/img/151660788231.png">
Более совершенное огне-копьё, изобретенное в конце 13 века. На вид это полый железный ствол, длинною один ярд, закрепленный на двухфутовом деревянном шесте. Извергает более интенсивное пламя, нежели её бумажный или бамбуковый предшественник. Часто к пороху добавляли железные или керамические фрагменты, что позволяло наносить пробивающие повреждения вражеским солдатам. Процедура подготовки такая же, как и у обычного огне-копья (выше). Ствол можно было перезаряжать и использовать повторно; на это требуется 10 минут и проверка навыка Взрывные работы (Фейерверки).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Зажигательная духовая трубка</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>35</value>
		<weight>1</weight>
		<reference>LT86</reference>
		<ranged_weapon>
			<damage>1d-1 burn</damage>
			<strength>2</strength>
			<usage>Blow Charge</usage>
			<accuracy>0</accuracy>
			<range>x0.2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Blowpipe</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки. Дистанция базируется на ST. Производит конус огня шириной на конце равный Range</notes>
		<categories>
			<category>Огнеметы</category>
		</categories>
		<description-loc>Incendiary Blowpipe
<img data-src="http://weapons.gurps.ru/img/1729.png">

Византийские источники упоминают духовую трубку, заряжаемую сосновой смолой. В момент выдоха топливо зажигается фитилем на конце трубки. В результате получается небольшое облако горящих испарений, не такое горячее как Греческий огонь или нафта. См. характеристики в Таблице Огнеметов (стр.86).



Требует обеих рук для Подготовки, но только одной руки для атаки.

Дистанция базируется на ST. Производит конус огня шириной на конце равный Range

Каждый снаряд стоит $0.50.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Зажигательная духовая трубка - снаряд</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.05</weight>
		<reference>LT86</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Incendiary Blowpipe Charge
<img data-src="lib/img/151677539983.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Зажигательная сфера</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>LT85</reference>
		<notes>Метается пращей "перье" (p. LT81); горит 2 мин; 1d+1 burn over 1-yard radius</notes>
		<categories>
			<category>Бомбы</category>
		</categories>
		<description-loc>Incendiary Sphere
<img data-src="lib/img/151663500758.png">    
Доступна в Китае, вначале 1100х годов., это хитроумное устройство метается при помощи перье (стр.81). Внешне это металлическая сфера со множеством отверстий, содержащая несколько фунтов низкосортного чёрного пороха. Порох горит 2 минуты, распыляя искры через отверстия, это наносит 1d+1 обжигающих повреждений всем объектам радиусе одного ярда. Сфера снабжена металлическими крюками, которые могут цепляться за укрепления противника или лестницы. $200, 10 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Какуте</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.1</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>see LT57</damage>
			<usage>Grappling</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
		</melee_weapon>
		<notes>+1 против маневра освобождение (break free)</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Kakute
<img data-src="http://weapons.gurps.ru/img/1749.png">

Япония. Кольцо с маленькими зубцами или "рожками", используется для надежного захвата оппонента и ударов в болевые точки. Пара - одно кольцо на безымянном, другое на большом пальце, дает +1 к проверкам против высвобождения оппонента из захвата и +1 к навыку Болевые Точки во время борьбы, но Плохую Хватку 1 (стр. 123) с оружием. Установка колец в положение для захвата или в положение, в котором они не мешают, требует маневр Подготовки.



+1 против маневра освобождение (break free)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ большое, 6м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>220</value>
		<weight>1760</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Large Bark Canoe, 20’
<img data-src="lib/img/151677501857.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Катана</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swing - One Handed</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>11</strength>
			<usage>Thrust - One Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swing - Two Handed</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10†</strength>
			<usage>Thrust - Two Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Katana
<img data-src="http://weapons.gurps.ru/img/1750.png">

Япония. 

Слегка искривленный меч с односторонней заточкой, предназначенный для одно- или двуручного использования. Может использоваться двумя руками обычным образом (используйте характеристики в разделе "Двуручный меч") или в положении Защитного Хвата, описанного в ГУРПС Боевые Искусства. Также к этому виду оружия относится янг гам (Корея). Basic Set описывает раннее оружие эпохи Токугава, переходящее от двуручного нодати (то же что и ДВУРУЧНЫЙ МЕЧ, стр.Б274) к клинку, достаточно короткому для ношения заткнутым за пояс. Используйте характеристики ПОЗДНЕЙ КАТАНЫ (стр.66, 70) для мечей последующих эпох.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Катана поздняя</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>550</value>
		<weight>3</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swing - One Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10</strength>
			<usage>Thrust - One Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>9†</strength>
			<usage>Swing - Two Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>9†</strength>
			<usage>Thrust - Two Handed</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Late Katana
<img data-src="http://weapons.gurps.ru/img/1790.png">

Япония.

Слегка искривленный меч с односторонней заточкой, предназначенный для одно- или двуручного использования. Может использоваться двумя руками обычным образом (используйте характеристики в разделе "Двуручный меч") или в положении Защитного Хвата, описанного в ГУРПС Боевые Искусства. Также к этому виду оружия относится янг гам (Корея). Basic Set описывает раннее оружие эпохи Токугава, переходящее от двуручного нодати (то же что и ДВУРУЧНЫЙ МЕЧ, стр.Б274) к клинку, достаточно короткому для ношения заткнутым за пояс. Используйте характеристики ПОЗДНЕЙ КАТАНЫ (стр.66, 70) для мечей последующих эпох.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Катар</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw-3 cut</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2. Используйте Драку или Карате, что больше, для парирования, если это значение больше обычного парирования оружием.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Katar
<img data-src="http://weapons.gurps.ru/img/1754.png">

Индия.

Лезвие, перпендикулярное рукоятке, оборудованной защитой для кисти или руки, неудобен для махов, но идеален для выпадов. Хват позволяет использовать для парирования навыки как безоружного боя, так и боя с оружием, как у ТОНФЫ (стр.64). Обычно размером с нож, но БОЛЬШОЙ КАТАР - размером с КОРОТКИЙ МЕЧ, а ПАТА (стр.65) - размером с ШИРОКИЙ МЕЧ и сопряжена с перчаткой.



Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.

Используйте Драку или Карате, что больше, для парирования, если это значение больше обычного парирования оружием.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Катар большой</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>2</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2. Используйте Драку или Карате, что больше, для парирования, если это значение больше обычного парирования оружием.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Large Katar
<img data-src="http://weapons.gurps.ru/img/1779.png">

Индия.

Лезвие, перпендикулярное рукоятке, оборудованной защитой для кисти или руки, неудобен для махов, но идеален для выпадов. Хват позволяет использовать для парирования навыки как безоружного боя, так и боя с оружием, как у ТОНФЫ (стр.64). Обычно размером с нож, но БОЛЬШОЙ КАТАР - размером с КОРОТКИЙ МЕЧ, а ПАТА (стр.65) - размером с ШИРОКИЙ МЕЧ и сопряжена с перчаткой.



Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.

Используйте Драку или Карате, что больше, для парирования, если это значение больше обычного парирования оружием.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каяк 5.5м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>240</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Kayak, 18’
<img data-src="lib/img/151663998407.png">
<img data-src="lib/img/151664002835.png">

Одноместная лодка используемая эскимосскими охотниками; тоже самое что и сибирская байдарка. Быстрая и манёвренная, с вытянутым узким корпусом. Обычно длина равняется троекратному росту владельца (от 15 до 18 футов), ширина не более 27 дюймов. Корпус закрыт сверху, тело гребца выступает через отверстие, которое слишком узкое для того чтобы вода могла попасть внутрь. 
Каяк очень легко перевернуть в случае опрокидывания; это требует проверки навыка Малые корабли (Гребля) со штрафом -3. Гребля осуществляется двухлопастным веслом. Корпус делается из дерева или китовых костей и оборачивается кожей тюленя. Лодка является достаточно лёгкой, чтобы её мог переносить один человек. У некоторых каяков могут быть два или даже три посадочных места.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Квадрен большой</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>3</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>thr+2(0.5) imp</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Large Quadrens
<img data-src="http://weapons.gurps.ru/img/1785.png">

Древний Рим.

Очень необычный гладиаторский "кинжал". Свидетельства об использовании этого оружия весьма размыты. Вместо одного клинка у него было четыре тонких штыка, расположенных в форме квадрата. Используется при помощи навыка Джитте/Сай, может разоружать как джитте (стр.57).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кобуры к седлу, пара</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<weight>5</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Holsters
<img data-src="lib/img/151663395191.png">
При ТУ4, кобуры являются частью конного снаряжения, и свешиваются по обе стороны седла. Продаются парами, по одной кобуре на каждую сторону, таким образом всадник получает доступ к двум пистолетам. Пара: $125, 5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Колесо-с-ножами</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>75</value>
		<weight>1.5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>thr+1 cut</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrust - Side blade</usage>
			<reach>C</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Knife-Wheel
<img data-src="http://weapons.gurps.ru/img/1758.png">

Китай. 

РУБЯЩЕЕ КОЛЕСО (стр.67) с короткими лезвиями, выступающими с обоих сторон. Традиционно используется парно.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Компас</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>1</weight>
		<reference>LT52</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<skill_bonus>
			<name compare="contains">Navigation</name>
			<specialization compare="is anything"></specialization>
			<amount>1</amount>
		</skill_bonus>
		<description-loc>Compass
<img data-src="lib/img/151600672848.png">
Впервые разработан в Китае и впоследствии распространился на Ближний Восток и Европу, компас содержит магнитную иголку, которая показывает на магнитный север (или, в Китае, на магнитный юг). Есть два варианта:

* Магнитная иголка, которая плавает в воде (требуется миска или блюдо с водой) позволяет немодифицированные броски Навигации. 5$, незн.

* Магнитная иголка на оси вращения. Даёт +1 к броскам навигации. 25$, 1 фунт.

Можно судить о направлении без компаса, если видно небо: -1 к броскам навигации по полярной звезде, или -2 по другим звёздам или по Солнцу.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Конеруб тяжелый</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>12</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+5 cut</damage>
			<strength>13‡</strength>
			<usage>Swing</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>1-3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Heavy Horse-Cutter
<img data-src="http://weapons.gurps.ru/img/1715.png">

Китай.

Древковое оружие с тяжелым рубящим клинком, таким же как у ДАО (выше), предназначенное для использования пехотой против всадников. ТЯЖЕЛЫЙ КОНЕРУБ (стр.68) в полтора раза длиннее и тяжелее ЛЕГКОГО КОНЕРУБА (стр.68). Также может называться пудао (Китай). К тяжелой версии можно отнести бисэнто (Япония, Окинава), а к легкой - совню (Русь) и пальму (Сибирь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Копьё тяжелое</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>90</value>
		<weight>6</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+4 imp</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3  cut</damage>
			<strength>11†</strength>
			<usage>Thrust - tip slash</usage>
			<reach>3</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Heavy Spear
<img data-src="http://weapons.gurps.ru/img/1718.png">

Древковое оружие с острым колющим наконечником, ценится за свою универсальность: длинное, может быть использовано как одной, так и двумя руками, часто метательное, и всегда смертоносное. Копье является по настоящему повсеместным оружием; к примерам можно отнести болг (древние кельты), цян (Китай), хаста (Древний Рим), нгао (Таиланд), сибат (Филиппины) и яри (Япония) - и это только некоторые. Многие варианты жертвуют универсальностью в обмен на особые возможности. Например у яри иногда можно встретить L-образный наконечник; это дает дополнительно $10 и 0,5 фунтов, и позволяет использовать правила для Крюка (стр.54), однако не позволяет метать. У других копий наконечник может быть не заостренным, а полукруглым или в форме полумесяца; повреждения при этом становятся рубящими, а прочие характеристики не изменяются. КОРОТКОЕ КОПЬЕ (стр.69) короткое, одноручное и не метательное - это колющий меч для бедных; примером может быть рохин (Япония). ДЛИННОЕ КОПЬЁ предназначено исключительно для ближнего боя и используется для сражения в строю, как со щитом, так и без него. ТЯЖЕЛОЕ КОПЬЕ (стр.69) похоже, однако у него очень широкий наконечник; оно такое тяжелое, что требует для использования обеих рук. К тяжелым копьям относятся дори и контос (оба Древняя Греция), а также рогатина (Русь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Косметика обычная, дешевая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.25</value>
		<weight>0.025</weight>
<notes>Цена за одно нанесение (15 г.)</notes>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Cosmetics, Common, Cheap, per use
<img data-src="lib/img/151600691399.png">
сделана из доступных материалов; например, подводка из сажи или пудра из мелового или рисового порошка. Держится 2 часа. За одно нанесение: от $0.25 до $1 (базовая цена), 0.25 унции.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Косметика обычная, дорогая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.025</weight>
<notes>Цена за одно нанесение (15 г.)</notes>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Cosmetics, Common, Expensive, per use
<img data-src="lib/img/151600692855.png">
сделана из доступных материалов; например, подводка из сажи или пудра из мелового или рисового порошка. Держится 2 часа. За одно нанесение: от $0.25 до $1 (базовая цена), 0.25 унции.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Косметика улучшенная, дешевая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.05</weight>
<notes>Цена за одно нанесение (15 г.)</notes>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Cosmetics, Better, Cheap, per use
<img data-src="lib/img/151600691399.png">
часто низкотехнологическая косметика «получше» была ядовитой, содержала мышьяк или свинец! Держится 4-6 часов. За одно нанесение: от $2 до $5 (базовая цена), 0.5 унции. 

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Косметика улучшенная, дорогая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>0.05</weight>
<notes>Цена за одно нанесение (15 г.)</notes>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Cosmetics, Better, Expensive, per use
<img data-src="lib/img/151600692855.png">
часто низкотехнологическая косметика «получше» была ядовитой, содержала мышьяк или свинец! Держится 4-6 часов. За одно нанесение: от $2 до $5 (базовая цена), 0.5 унции. 
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Краподо</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>440</value>
		<weight>32</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>1d+2 pi++</damage>
			<strength>17M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>20/170</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-8</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Crapaudeau
<img data-src="lib/img/151600708528.png">
Заряжаемая через казённик пушка с длинным стволом маленького калибра, стреляющая маленькими камнями.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Краподо - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>12</value>
		<weight>0.12</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Crapaudeau Stone
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крюк хирургический</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Hook, Surgical
<img data-src="lib/img/151663398804.png">
Палочка с острым или тупым крючком, используется для стягивания краев раны или разреза, или для манипуляции кусочком ткани. $10, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крюк-кошка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Grappling Hook, Unpadded
<img data-src="lib/img/151663274561.png">Состоит из трёх или четырёх металлических крюков прикреплённых к стержню с ушком, за которое можно привязать веревку. Чтобы бросить в цель используйте проверку ЛВ(DX)-3 или Метание. См. Метание (стр.Б355) чтобы определить расстояние на которое можно метнуть кошку, не прибегая к помощи механических устройств. Когда кошка приземляется на камне, бетоне, или похожем твёрдом материале, она издаёт громкий звук слышимый в радиусе 4х ярдов (см. стр.Б358). Мягкая подкладка уменьшает расстояние до 2х ярдов. Без подкладки: $20, 2 фунта. С подкладкой: $30, 3 фунта. 
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крюк-кошка с мягким подкладом</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>3</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Grappling Hook, Padded
<img data-src="lib/img/151663326067.png">
Состоит из трёх или четырёх металлических крюков прикреплённых к стержню с ушком, за которое можно привязать веревку. Чтобы бросить в цель используйте проверку ЛВ(DX)-3 или Метание. См. Метание (стр.Б355) чтобы определить расстояние на которое можно метнуть кошку, не прибегая к помощи механических устройств. Когда кошка приземляется на камне, бетоне, или похожем твёрдом материале, она издаёт громкий звук слышимый в радиусе 4х ярдов (см. стр.Б358). Мягкая подкладка уменьшает расстояние до 2х ярдов. Без подкладки: $20, 2 фунта. С подкладкой: $30, 3 фунта. 
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кукри</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1.5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>th-1 imp</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Kukri
<img data-src="http://weapons.gurps.ru/img/1761.png">

Непал.

Тяжелый рубящий клинок, лезвие в середине искривлено под углом 45 градусов. Предложенный кукри имеет размеры ножа; версии большего размера считайте МАЛЕНЬКИМ ФАЛЬШИОНОМ (стр.69), или даже ФАЛЬШИОНОМ (стр.69).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кулеврина</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>66000</value>
		<weight>4800</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>6dx4 pi++</damage>
			<strength>58M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>300/2,200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(70)</shots>
			<bulk>-15</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 6 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Culverin
<img data-src="lib/img/151600741170.png">
Ранние Европейские пушки (ТУ4)

К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.

Требуется команда 6 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кусари</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Kusari
<img data-src="http://weapons.gurps.ru/img/1763.png">

Япония.

Цепь с грузилами на обоих концах, также называется кусари-фундо или манрикигусари ("цепь с силой десяти тысяч"). Возможно "хлестнуть" врага кусарями концом вперёд. Повреждения становятся прямыми дробящими, но атака освобождается от двух недостатков описанных на стр.Б406: она действуют даже на близком расстоянии, и пропадает шанс ударить себя по лицу во время критического промаха. ДРОТИК НА ВЕРЕВКЕ (стр.61, 67) также может быть использован в качестве кусари в ближнем бою.



Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кусаригама</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>4.5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>10†</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11†</strength>
			<usage>Chain Swing</usage>
			<reach>1,2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2. Во время размахивания камой на конце цепи, кусаригамма не может разоружать или опутывать как обычная кусари (стр.Б406).</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Kusarigama
<img data-src="http://weapons.gurps.ru/img/1765.png">
<img data-src="http://weapons.gurps.ru/img/2022.png">

Япония. 

Кама (СЕРП, стр.62, 65) с присоединенной к основанию рукояти двухярдовой КУСАРИ (стр.Б272). В одной руке держится рукоять, в другой - цепь, производить атаку можно любой рукой. Сначала противник обездвиживается при помощи кусари (см. стр.406 или Опутывающие техники в ГУРПС Боевые искусства) после чего наносится добивающий удар камой. Считайте что это обычные атаки камы и кусари, но используйте первую линию характеристик, для двухярдовой кусари. Киношные воины иногда могут размахивать камой держа в руках цепь, как заточенным цепом, в этом случае используйте третью линию характеристик - Мастер вправе запретить такое действие в реалистичных играх. В некоторых версиях четырехярдовая кусари крепится к верхней части рукояти, за лезвием (позволяет использовать оружие одной рукой, но при этом только в качестве кусари или камы - выбирать можно в начале каждого хода); считайте это комбинированным оружием. 



Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.

Во время размахивания камой на конце цепи, кусаригамма не может разоружать или опутывать как обычная кусари (стр.Б406).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кусаридзюттэ</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>3.5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>8†</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>8†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Kusarijutte
<img data-src="http://weapons.gurps.ru/img/1768.png">

Япония. ДЗЮТТЭ (стр.66, 67) с присоединенной к рукояти двухярдовой КУСАРИ (выше, стр.272). В одной руке держится рукоять, в другой цепь. Используйте стандартные правила для дзюттэ и кусари, за исключением того, что для короткой кусари используются статистики, указанные в графе кусаридзюттэ. В некоторых версиях кусари спрятана внутри дзюттэ и может выбрасываться из наконечника (см.Маскировка стр.14).


Попытки парировать кусари происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лайтанг</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>7</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cut</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Lajatang
<img data-src="http://weapons.gurps.ru/img/1770.png">

Индонезия.

Древковое оружие с лезвиями в форме полумесяца на обоих концах.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ланса</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12</strength>
			<usage>Thrust</usage>
			<reach>4</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Lance</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Повреждения увеличиваются при использовании верхом; см. Кавалерийское оружие (стр.Б379). Также важные правила см. в Ланса (стр.58) и Снаряжение для верховой езды (стр.134).</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Lance
<img data-src="http://weapons.gurps.ru/img/1772.png">

Европа. 

Понятие "ланса" описывает любое длинное кавалерийское копье, но в Basic Set это тяжелое копье, достаточно крепкое, чтобы использовать для удара энергию всадника, пользующегося стременами и седлом с высокой спинкой. В отличии от пехотного копья, у неё обычно есть гарда и рукоять. Специализированные турнирные лансы обычно тупые и разламываются при ударе; см. Б397.



Повреждения увеличиваются при использовании верхом; см. Кавалерийское оружие (стр.Б379). Также важные правила см. в Ланса (стр.58) и Снаряжение для верховой езды (стр.134).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лантака</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>400</value>
		<weight>30</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>1d+1 pi++</damage>
			<strength>16M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>40/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Lantaka
<img data-src="lib/img/151664180235.png">
Является Индонезийским вариантом использующим серпентин; похожие орудия могут быть найдены на Китайских джонках или Средиземноморских галерах. ТУ4 орудия на вертлюжной установке (2.25 калибр), используют гранулированный порох, типичный для маленьких орудий на Европейских морских судах и пиратских кораблях.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лантака - шарнирные крепление</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>270</value>
		<weight>13.5</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Lantaka Pintle Mount
<img data-src="lib/img/151677485040.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лантака - ядро</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>1.6</value>
		<weight>0.08</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Lantaka Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ланцет</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<reference>LT153</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Lancet
<img data-src="lib/img/151664167504.png"> <img data-src="lib/img/151664176042.png">
Специальный нож для открытия вены. Использование требует бросков Хирургии и Нетрадиционной медицины. Провал броска Хирургии приводит к бесполезному поверхностному кровотечению. Критический провал – повреждение артерии! Обрабатывается по правилам Кровотечений (с.Б420) с -2 к броскам ЗД(HT). $25, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лестница 2м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>360</value>
		<weight>90</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Ladder, 6'
<img data-src="lib/img/151664147777.png">
Сделанная из дерева, лестница состоит из пары длинных реек, соединенных между собой (через равные интервалы) перемычками, называемыми перекладинами или ступеньками. Человек обычно поднимается или спускается со скоростью 1 ступенька/секунда (при интервалах между ступеньками не менее 1 фута), в спешке - как в бою - скорость подъёма может возрастать до 3 ступеньки/секунда, а спуска до 2 ступеньки/секунда. См. Лазание (стр.Б349). Обычно проверка лазания не делается, хотя ГМ может потребовать её во время спешки. Цена и вес равняются $10 и 2.5 фунта, умноженным на квадратный корень длинны в ярдах; т.е. самая длинная лестница при ТУ1-4 - 36 футов, $1,440, и 360 фунтов.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Литавры, кавлерийские</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>28</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Kettledrums, Cavalry
<img data-src="lib/img/151664013759.png"><img data-src="lib/img/151664015165.png">
Не оркестровый инструмент, а поменьше, рассчитанный на то, что его будет нести на плечах лошадь, а играть - всадник. Играется навыком Музыкальный Инструмент (Настроенный барабан). Дистанция слышимости: 32 ярда. 250$, 28 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательное копьё</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>2</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>3</accuracy>
			<range>x1.5/x1.75</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Javelin
<img data-src="http://weapons.gurps.ru/img/1731.png">

Тонкое копье, сбалансированное для метания, но также может использоваться как лёгкое оружие ближнего боя. Сюда также относятся ассегай (Африка), фракка (викинги), пелта (Древняя Греция), спикулум (Древний Рим), сулица (Русь), и яринаге (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательное копьё с ремнем</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>2</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>4</accuracy>
			<range>x1.75/x2.75</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Javelin w. Thong
<img data-src="http://weapons.gurps.ru/img/1733.png">
<img data-src="http://weapons.gurps.ru/img/2025.png">

Тонкое копье, сбалансированное для метания, но также может использоваться как лёгкое оружие ближнего боя. Сюда также относятся ассегай (Африка), фракка (викинги), пелта (Древняя Греция), спикулум (Древний Рим), сулица (Русь), и яринаге (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Меч двуручный</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>800</value>
		<weight>7</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>12†</strength>
			<usage>Swing</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Greatsword
<img data-src="http://weapons.gurps.ru/img/1707.png">

Европа. 

Настоящий двуручный меч. Обычно острый с конца (КОЛЮЩИЙ ДВУРУЧНЫЙ МЕЧ, стр.70, Б274). Типичный европейский двуручный меч обладал рикассо - незаточенной, иногда покрытой кожей, прилегающей к рукояти частью клинка, за которую можно было ухватиться, и которая заканчивалась двумя выступающими шипами, предназначенными для защиты руки. Также к этому виду относятся большие нодати (Япония) и цвайхендеры (Германия).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Меч-крюк</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>3</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<usage>Hilt Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<strength>10</strength>
			<usage>Hook Slice</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
		</melee_weapon>
		<notes>Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки. Может использоваться для разоружения (стр.Б401) без пенальти -2 к попаданию за использование не-фехтовального оружия.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Hook Sword
<img data-src="http://weapons.gurps.ru/img/1721.png">

Китай.

Тупое оружие, по форме напоминающее перевернутую "J", с лезвием-гардой для ударов рукой. Изгиб заострен изнутри, якобы чтобы калечить лошадей, и позволяет использовать правила для Крюка (стр.54). Обычно используется в парах.



Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.

Может использоваться для разоружения (стр.Б401) без пенальти -2 к попаданию за использование не-фехтовального оружия.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Набор взломщика</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>255</value>
		<weight>16</weight>
		<reference>LT126</reference>
		<categories>
			<category>Специализироване наборы</category>
		</categories>
		<description-loc>Housebreaker's Kit
<img data-src="lib/img/151663412155.png">
Отмычки, маленький лом, колотушка, долото, маленькая пила, 10 ярдов веревки диаметром 3/8 дюйма, крюк-кошка с подкладкой и фонарь, уложенные в мешок, достаточно вместительный, чтобы уместить какую-нибудь добычу.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Набор для чистки огнестрельного оружия</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Gun-Cleaning Kit
<img data-src="lib/img/151663352950.png">
Каждый, кто профессионально использует огнестрельное оружие, должен владеть снаряжением для его чистки. Сюда относятся спицной ключ, инструмент для продувки, пузырек с маслом, отвертка, шомпол-разрядник для чистки, и инструменты для извлечения заклинивших пуль. $20, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
	<description>Нож большой</description>
	<value>40</value>
	<weight>1</weight>
	<quantity>1</quantity>
	<melee_weapon>
		<damage>sw-2 cut</damage>
		<strength>6</strength>
		<reach>C,1</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Swung</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>thr imp</damage>
		<strength>6</strength>
		<reach>C</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Thrust</usage>
	</melee_weapon>
	<ranged_weapon>
		<damage>thr imp</damage>
		<strength>6</strength>
		<accuracy>0</accuracy>
		<range>x0.8/x1.5</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>T(1)</shots>
		<bulk>-2</bulk>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Thrown Weapon</name>
			<specialization>Knife</specialization>
			<modifier>0</modifier>
		</default>
		<usage>Thrown</usage>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Холодное оружие</category>
	</categories>
	<reference>LT58</reference>
	<description-loc>
		Large Knife
		<img data-src="http://weapons.gurps.ru/img/1781.png">
		Любой одноручный клинок размером меньше меча, сделанный для эффективных режущих и колющих ударов. Самым легким является МАЛЕНЬКИЙ НОЖ (стр.67, 77, Б272, Б276), который также может быть сбалансирован для метания; примерами являются бхудж (Индия), козука (Япония) и писау (Индонезия).

Следующая категория размеров - БОЛЬШОЙ НОЖ (стр.67, 77, Б272, Б276), который чаще всего предназначается для сражения, и очень редко для метания; к такому оружия относятся почковый нож или почковый кинжал (Европа), дан ган (Корея), дирк (Европа), кард (Персия) и заточенный как долото танто (Япония).

Самым большим, от 15 до 23 дюймов, является ДЛИННЫЙ НОЖ (стр.69), который лишь немного меньше чем КОРОТКИЙ МЕЧ (стр.61, Б273), его нельзя метать. К длинным кинжалам относятся самые длинные версии дирка, карда и танто. Некоторые термины, вроде пунал (Филипины), описывают ножи любого размера. Стреловидные эмэйици (Китай) и сиангкам (Индонезия) тоже могут быть любого размера, но могут наносить только колющие удары. Оружие предназначенное специально для метания, см МЕТАТЕЛЬНЫЙ НОЖ (стр.77).
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нож метательный большой</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT75</reference>
		<melee_weapon>
			<damage>sw-2 cut</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1/x2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Large Throwing Knife
<img data-src="http://weapons.gurps.ru/img/1786.png">

У настоящего метательного ножа гарда встречается редко, кроме этого часто отсутствует рукоять, такой нож сбалансирован для метания, а не для ближнего боя. Это дает штраф -2 к навыку ближнего боя. Как и все остальные, метательные ножи, могут различаться размерами; обычно встречаются БОЛЬШОЙ МЕТАТЕЛЬНЫЙ НОЖ (стр.77) и МАЛЕНЬКИЙ МЕТАТЕЛЬНЫЙ НОЖ (стр.77).</description-loc>
	</equipment><equipment version="3">
	<description>Одежда зимняя, аристократ (Статус 4)</description>
	<value>18000</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<dr_bonus>
		<location>full body</location>
		<amount>1</amount>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT98</reference>
	<description-loc>
		Clothing, Winter, Noble (Status 4)
		<img data-src="lib/img/151600606416.png">
		Это уличная одежда для холодного климата. При низких температурах она дает возможность броска ЗД(HT) против потери ЕУ(FP) без штрафов (см. с.Б430). Она может представлять собой дополнительный слой одежды к обычной или состоять из плотной ткани или меха, но должна защищать все тело полностью, чтобы избежать потери тепла – особенно стопы, кисти, голову и шею. Если эти части тела не будут защищены, Мастер может наложить штрафы на бросок ЗД(HT) – по -1 за недостающий предмет, как написано на стр. Б345. Зимняя одежда достаточно плотна, чтобы дать некоторую защиту: СП(DR) 1 против режущего вреда. Стоит 30% расходов на жизнь; вес 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Одежда зимняя, бедняк (Статус -2)</description>
	<value>30</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<dr_bonus>
		<location>full body</location>
		<amount>1</amount>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT98</reference>
	<description-loc>
		Clothing, Winter, Poor (Status -2)
		<img data-src="lib/img/151600606416.png">
		Это уличная одежда для холодного климата. При низких температурах она дает возможность броска ЗД(HT) против потери ЕУ(FP) без штрафов (см. с.Б430). Она может представлять собой дополнительный слой одежды к обычной или состоять из плотной ткани или меха, но должна защищать все тело полностью, чтобы избежать потери тепла – особенно стопы, кисти, голову и шею. Если эти части тела не будут защищены, Мастер может наложить штрафы на бросок ЗД(HT) – по -1 за недостающий предмет, как написано на стр. Б345. Зимняя одежда достаточно плотна, чтобы дать некоторую защиту: СП(DR) 1 против режущего вреда. Стоит 30% расходов на жизнь; вес 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Одежда зимняя, горожанин (Статус 0)</description>
	<value>180</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>full body</location>
		<amount>1</amount>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT98</reference>
	<description-loc>
		Clothing, Winter, Freeman (Status 0)
		<img data-src="lib/img/151600606416.png">
		Это уличная одежда для холодного климата. При низких температурах она дает возможность броска ЗД(HT) против потери ЕУ(FP) без штрафов (см. с.Б430). Она может представлять собой дополнительный слой одежды к обычной или состоять из плотной ткани или меха, но должна защищать все тело полностью, чтобы избежать потери тепла – особенно стопы, кисти, голову и шею. Если эти части тела не будут защищены, Мастер может наложить штрафы на бросок ЗД(HT) – по -1 за недостающий предмет, как написано на стр. Б345. Зимняя одежда достаточно плотна, чтобы дать некоторую защиту: СП(DR) 1 против режущего вреда. Стоит 30% расходов на жизнь; вес 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Одежда зимняя, торговец (Статус 1)</description>
	<value>360</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<dr_bonus>
		<location>full body</location>
		<amount>1</amount>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT98</reference>
	<description-loc>
		Clothing, Winter, Merchant (Status 1)
		<img data-src="lib/img/151600606416.png">
		Это уличная одежда для холодного климата. При низких температурах она дает возможность броска ЗД(HT) против потери ЕУ(FP) без штрафов (см. с.Б430). Она может представлять собой дополнительный слой одежды к обычной или состоять из плотной ткани или меха, но должна защищать все тело полностью, чтобы избежать потери тепла – особенно стопы, кисти, голову и шею. Если эти части тела не будут защищены, Мастер может наложить штрафы на бросок ЗД(HT) – по -1 за недостающий предмет, как написано на стр. Б345. Зимняя одежда достаточно плотна, чтобы дать некоторую защиту: СП(DR) 1 против режущего вреда. Стоит 30% расходов на жизнь; вес 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Одежда зимняя, царская (Статус 7)</description>
	<value>18000000</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<dr_bonus>
		<location>full body</location>
		<amount>1</amount>
		<damage-type>cut</damage-type>
	</dr_bonus>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT98</reference>
	<description-loc>
		Clothing, Winter, Royal (Status 7)
		<img data-src="lib/img/151600606416.png">
		Это уличная одежда для холодного климата. При низких температурах она дает возможность броска ЗД(HT) против потери ЕУ(FP) без штрафов (см. с.Б430). Она может представлять собой дополнительный слой одежды к обычной или состоять из плотной ткани или меха, но должна защищать все тело полностью, чтобы избежать потери тепла – особенно стопы, кисти, голову и шею. Если эти части тела не будут защищены, Мастер может наложить штрафы на бросок ЗД(HT) – по -1 за недостающий предмет, как написано на стр. Б345. Зимняя одежда достаточно плотна, чтобы дать некоторую защиту: СП(DR) 1 против режущего вреда. Стоит 30% расходов на жизнь; вес 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда летняя, аристократ (Статус 4)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6000</value>
		<weight>1</weight>
		<reference>LT97</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Summer, Noble (Status 4)
<img data-src="lib/img/151600545900.png">
Это лёгкая одежда: тонкая, белая арабская джалабия; складчатый льняной калазирис древнего Египта; индийское сари, сделанное из хлопка; или возможно набедренная повязка или юбка из травы. Она лёгкая, комфортная и прохладная. В жаркую погоду, свободная одежда позволяет воздуху циркулировать, охлаждая тело. Стоит 10% расходов на жизнь; весит 1 фунт.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда летняя, бедняк (Статус -2)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT97</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Summer, Poor (Status -2)
<img data-src="lib/img/151600545900.png">
Это лёгкая одежда: тонкая, белая арабская джалабия; складчатый льняной калазирис древнего Египта; индийское сари, сделанное из хлопка; или возможно набедренная повязка или юбка из травы. Она лёгкая, комфортная и прохладная. В жаркую погоду, свободная одежда позволяет воздуху циркулировать, охлаждая тело. Стоит 10% расходов на жизнь; весит 1 фунт.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда летняя, горожанин (Статус 0)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>1</weight>
		<reference>LT97</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Summer, Freeman (Status 0)
<img data-src="lib/img/151600545900.png">
Это лёгкая одежда: тонкая, белая арабская джалабия; складчатый льняной калазирис древнего Египта; индийское сари, сделанное из хлопка; или возможно набедренная повязка или юбка из травы. Она лёгкая, комфортная и прохладная. В жаркую погоду, свободная одежда позволяет воздуху циркулировать, охлаждая тело. Стоит 10% расходов на жизнь; весит 1 фунт.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда летняя, торговец (Статус 1)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>1</weight>
		<reference>LT97</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Summer, Merchant (Status 1)
<img data-src="lib/img/151600545900.png">
Это лёгкая одежда: тонкая, белая арабская джалабия; складчатый льняной калазирис древнего Египта; индийское сари, сделанное из хлопка; или возможно набедренная повязка или юбка из травы. Она лёгкая, комфортная и прохладная. В жаркую погоду, свободная одежда позволяет воздуху циркулировать, охлаждая тело. Стоит 10% расходов на жизнь; весит 1 фунт.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда летняя, царская (Статус 7)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6000000</value>
		<weight>1</weight>
		<reference>LT97</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Summer, Royal (Status 7)
<img data-src="lib/img/151600545900.png">
Это лёгкая одежда: тонкая, белая арабская джалабия; складчатый льняной калазирис древнего Египта; индийское сари, сделанное из хлопка; или возможно набедренная повязка или юбка из травы. Она лёгкая, комфортная и прохладная. В жаркую погоду, свободная одежда позволяет воздуху циркулировать, охлаждая тело. Стоит 10% расходов на жизнь; весит 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда обычная, аристократ (Статус 4)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>12000</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Ordinary, Noble (Status 4)
<img data-src="lib/img/151595818381.png">
Обычная рабочая или повседневная одежда для умеренного климата. Обычно делается из более плотного материала, чем летняя; возможно, это просто ещё один слой ткани поверх летней. Даже это увеличивает затраты ЕУ(FP) при жаре, как указано в параграфе Бой (с. Б426). Стоит 20% расходов на жизнь; вес 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда обычная, бедняк (Статус -2)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Ordinary, нищий (Status -2)
<img data-src="lib/img/151595818381.png">
Обычная рабочая или повседневная одежда для умеренного климата. Обычно делается из более плотного материала, чем летняя; возможно, это просто ещё один слой ткани поверх летней. Даже это увеличивает затраты ЕУ(FP) при жаре, как указано в параграфе Бой (с. Б426). Стоит 20% расходов на жизнь; вес 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда обычная, горожанин (Статус 0)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Ordinary, Freeman (Status 0)
<img data-src="lib/img/151595818381.png">
Обычная рабочая или повседневная одежда для умеренного климата. Обычно делается из более плотного материала, чем летняя; возможно, это просто ещё один слой ткани поверх летней. Даже это увеличивает затраты ЕУ(FP) при жаре, как указано в параграфе Бой (с. Б426). Стоит 20% расходов на жизнь; вес 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда обычная, торговец (Статус 1)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>240</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Ordinary, Merchant (Status 1)
<img data-src="lib/img/151595818381.png">
Обычная рабочая или повседневная одежда для умеренного климата. Обычно делается из более плотного материала, чем летняя; возможно, это просто ещё один слой ткани поверх летней. Даже это увеличивает затраты ЕУ(FP) при жаре, как указано в параграфе Бой (с. Б426). Стоит 20% расходов на жизнь; вес 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Одежда обычная, царская (Статус 7)</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>12000000</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Clothing, Ordinary, Royal (Status 7)
<img data-src="lib/img/151595818381.png">
Обычная рабочая или повседневная одежда для умеренного климата. Обычно делается из более плотного материала, чем летняя; возможно, это просто ещё один слой ткани поверх летней. Даже это увеличивает затраты ЕУ(FP) при жаре, как указано в параграфе Бой (с. Б426). Стоит 20% расходов на жизнь; вес 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие "Сгорбленный Тигр"</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>650</value>
		<weight>47</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>6d+2 pi++</damage>
			<strength>16M†</strength>
			<usage>Shoot Stone Ball</usage>
			<accuracy>2</accuracy>
			<range>60/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-8</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>1d-1 pi+</damage>
			<strength>19M†</strength>
			<usage>Shoot Lead Shot</usage>
			<accuracy>1</accuracy>
			<range>130/1,200</range>
			<rate_of_fire>1x100</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>–</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Crouching Tiger Gun
<img data-src="lib/img/151600715590.png">
Китайское орудие</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие "Сгорбленный Тигр" - выстрел</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>3.5</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Crouching Tiger Gun Shot
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие "Сгорбленный Тигр" - камень</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>115</value>
		<weight>1.15</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Crouching Tiger Gun Stone
<img data-src="lib/img/151677150978.png ">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Охотничий рог, медный</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>2</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Hunting Horn, Brass
<img data-src="lib/img/151663424270.png">
Сделан из меди, его носят охотники, чтобы подавать сигналы о успехе охоты. Играется навыком Музыкальный Инструмент (Рог). Дистанция слышимости: 16 ярдов. 200$, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
	<description>Охотничья рубаха, окрашенная</description>
	<value>100</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<skill_bonus>
		<name compare="is">Camouflage</name>
		<amount>2</amount>
	</skill_bonus>
	<legality_class>4</legality_class>
	<tech_level>1</tech_level>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT126</reference>
	<description-loc>
		Hunting Shirt, Dyed
		<img data-src="lib/img/151663490574.png">
		Мешковатая верхняя одежда до бедер из прочной ткани, с ремешками, шнурами или петлями для прикрепления растительности. Окаймленные рукава помогают ещё больше исказить силуэт; до конца эффект доведет пятнистая окраска. Простая рубаха даст +1 (качество) к Маскировке; окрашенная - +2. Этот бонус можно увеличить ещё больше через подгонку под окружение, на что уйдет 20 часов и успешная проверка Маскировки. Каждое очко успеха даст +1 вплоть до +3, в общей сумме до +5. Рубаха требует особой подготовки под местность, климат и время года – и, как обычная одежда, если она не подходит к фону, то может даже привести к штрафу Маскировки. Простая: $50, 5 фунтов. Окрашенная: $100, 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Охотничья рубаха, простая</description>
	<value>50</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<skill_bonus>
		<name compare="is">Camouflage</name>
		<amount>1</amount>
	</skill_bonus>
	<legality_class>4</legality_class>
	<tech_level>1</tech_level>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT126</reference>
	<description-loc>
		Hunting Shirt, Plain
		<img data-src="lib/img/151663489173.png">
		Мешковатая верхняя одежда до бедер из прочной ткани, с ремешками, шнурами или петлями для прикрепления растительности. Окаймленные рукава помогают ещё больше исказить силуэт; до конца эффект доведет пятнистая окраска. Простая рубаха даст +1 (качество) к Маскировке; окрашенная - +2. Этот бонус можно увеличить ещё больше через подгонку под окружение, на что уйдет 20 часов и успешная проверка Маскировки. Каждое очко успеха даст +1 вплоть до +3, в общей сумме до +5. Рубаха требует особой подготовки под местность, климат и время года – и, как обычная одежда, если она не подходит к фону, то может даже привести к штрафу Маскировки. Простая: $50, 5 фунтов. Окрашенная: $100, 5 фунтов.
	</description-loc>
</equipment><equipment version="3">
	<description>Пальто длинное</description>
	<value>50</value>
	<weight>5</weight>
	<quantity>1</quantity>
	<skill_bonus>
		<name compare="is">Holdout</name>
		<amount>4</amount>
	</skill_bonus>
	<legality_class>4</legality_class>
	<tech_level>1</tech_level>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT99</reference>
	<description-loc>
		Coat, Long
		<img data-src="lib/img/151600663102.png">
		Тренч, пальто, кафтан или другая подобная одежда, закрывающая туловище и ноги до колена или ниже. Может скрывать громоздкие вещи (+4 к Утаиванию), но в некоторых ситуациях неуместно. $50, 5 ф. Кожаное или войлочное дает СП(DR) 1: +4 МЦ, вес удвоен. Ещё более тяжелые кожаные пальто даже использовались как доспехи во времена Гражданской войны в Англии, называясь “buff coats”, считайте их доспехами, (см. Шкуры, с. 104).
	</description-loc>
</equipment><equipment version="3">
	<description>Пальто длинное, тяжелое</description>
	<value>250</value>
	<weight>10</weight>
	<quantity>1</quantity>
	<dr_bonus>
		<location>torso</location>
		<amount>1</amount>
	</dr_bonus>
	<skill_bonus>
		<name compare="is">Holdout</name>
		<amount>4</amount>
	</skill_bonus>
	<legality_class>4</legality_class>
	<tech_level>1</tech_level>
	<categories>
		<category>Одежда</category>
	</categories>
	<reference>LT99</reference>
	<description-loc>
		Coat, Long, Heavy
		<img data-src="lib/img/151600643847.png">
		Тренч, пальто, кафтан или другая подобная одежда, закрывающая туловище и ноги до колена или ниже. Может скрывать громоздкие вещи (+4 к Утаиванию), но в некоторых ситуациях неуместно. $50, 5 ф. Кожаное или войлочное дает СП(DR) 1: +4 МЦ, вес удвоен. Ещё более тяжелые кожаные пальто даже использовались как доспехи во времена Гражданской войны в Англии, называясь “buff coats”, считайте их доспехами, (см. Шкуры, с. 104).
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Подковы</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>4</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Horseshoes
<img data-src="lib/img/151663409188.png">
Появившиеся около 1000 г. н.э., подковы защищают копыта лошади, особенно когда она тащит тяжелые грузы. Они дают лошади +2 к основанным на ЗД(HT) проверкам на потерю ЕУ(FP); кроме того, они предотвращают повреждения ног на твердых поверхностях. За набор:$50, 4 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Попона</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>2.5</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Horse Blanket
<img data-src="lib/img/151663406277.png">
Довольно толстая ткань, которую кладут лошади на спину перед тем, как на неё сесть. Это предотвращает натирание ног всадника о лошадиные бока и наоборот, а кроме того немного уменьшает вес всадника, давая как коню, так и всаднику +1 ко всем основанным на ЗД(HT) проверкам на потерю ЕУ(FP). $25, 2.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща тяжелая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>sw+2 cr</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>x3/x6</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Обычные камни, можно собирать бесплатно, но штраф -1 к попаданию.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Heavy Sling
<img data-src="http://weapons.gurps.ru/img/1717.png">
<img data-src="http://weapons.gurps.ru/img/2032.png">

Ремень или шнур с "карманом" или "чашей" куда помещается снаряд. Использующий кладет снаряд в карман, берется одной рукой за оба конца шнура, раскручивает заряженную пращу над головой (горизонтально) или в стороне от себя (вертикально), после чего отпускает один конец, запуская таким образом снаряд. Присоединение пращи к палке, удерживаемой двумя руками, увеличивает подъемную силу, и как следствие наносимые повреждения и дальность полета снаряда; это ПРАЩА-ПОСОХ (стр.76), также известная как фустибал (Европа). ТЯЖЕЛАЯ ПРАЩА (стр.76) предназначена для бросания крупных снарядов на короткую дистанцию. Для того чтобы зарядить снаряд и использовать её требуются обе руки; техника метания схожа с метанием молота. Любая праща, из этих трех, может метать камни или свинцовые пули, или даже примитивные коктейли Молотова (см. Коктейль Молотова или Сосуды с Маслом, стр.Б411), с Точ 0 и только на 40% от обычной Дальности. Праща для метания дротиков, известная в Македонии как КЕСТР (стр.76), предназначена для метания однофутовых оперенных дротиков; хотя она и похожа на стандартную пращу, они не могут использовать снаряды друг друга. Кестр также не может быть использован для метания коктейлей Молотава.

Может стрелять камнями (ТУ0) или свинцовыми пулями (ТУ2). Свинцовые пули дают +1 повреждений и удваивают расстояние.

Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща тяжелая - формованный камень</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>1</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Heavy Sling Shaped Rock
<img data-src="lib/img/151676856673.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Расчёска</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.2</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Comb
<img data-src="lib/img/151600669940.png">
Обычно изготовляемая из кости или дерева расчёска нередко оставлялась в волосах, служа не только для причесывания, но и как украшение. $3, 0.2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ручница</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>240</value>
		<weight>6.9</weight>
		<reference>LT91</reference>
		<ranged_weapon>
			<damage>2d+1 pi++</damage>
			<strength>10†</strength>
			<usage>Shoot Bullet</usage>
			<accuracy>1</accuracy>
			<range>55/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>1d imp</damage>
			<strength>9†</strength>
			<usage>Shoot Bolt</usage>
			<accuracy>1</accuracy>
			<range>75/1,200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>–</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Gonne
<img data-src="http://weapons.gurps.ru/img/1704.png">
<img data-src="http://weapons.gurps.ru/img/2036.png">

Миниатюрная пушка, отлитая из бронзы и установленная на конце деревянного шеста. Арабская версия называется мидфа; китайская - пао ("извергающийся"). Обычно она стреляет свинцовыми ядрами, но некоторые иллюстрации изображают пищали, стреляющие снарядами, напоминающими арбалетные болты. Это огнестрельное оружие бывает разного размера; модель в таблице сравнима с самыми маленькими сохранившимися китайскими образцами. Оружие этого типа часто носили на гуситских боевых повозках (стр. 136, 137).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ручница - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2.6</value>
		<weight>0.13</weight>
		<reference>LT91</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Gonne Bolt
[к сожаления, изображение не удалось подобрать]</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ручница - пуля</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>3.4</value>
		<weight>0.17</weight>
		<reference>LT91</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Gonne Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сок лакового дерева</description>
		<tech_level>1</tech_level>
		<legality_class>3</legality_class>
		<value>2</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Lacquer
<img data-src="lib/img/151664124209.png"><img data-src="lib/img/151664141103.png">
Добываемый из лакового дерева (Toxicodendron vernicifluum) весной, этот сок используется для сохранения дерева и кожи, но может служить как контактный яд или (смешанный с ладаном и сожженный) респираторный яд. Как контактный яд, он имеет 10-секундную задержку и бросок против ЗД(HT) для сопротивления; провал вызывает образование волдырей, как ядовитый плющ (рассматривать как умеренную боль, B428) и 1 пункт ядовитых повреждений. В качестве респираторного яда он не имеет задержки и позволяет бросок против ЗД(HT)+4 для сопротивления, нанося 1d ядовитых повреждений; кроме того, он вызывает немедленный кашель и чих (B428). $2 за дозу. КЛ(LC)3.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стрела со свистящим наконечником</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<notes>-1 Acc, снижает на 5 оба множителя расстояния; damage Crushing (0.5)</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Humming Bulb Arrow
<img data-src="lib/img/151663421431.png">
Пустотелый наконечник с бороздками, издаёт свист во время полета стрелы. Используется для сигнализирования или вспугивания дичи. Некоторые из таких наконечников могут нести дополнительный заряд - обычно промасленную ветошь (считайте зажигаемой стрелой). Получает штраф -1 Точ и снижает на 5 оба множителя расстояния. Повреждения становятся дробящими, с делителем брони (0.5). Цена и вес без изменений.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Судовая шлюпка 5.5м</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>3000</value>
		<weight>2700</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Jolly Boat, 18'
<img data-src="lib/img/151663985278.png">
Гребная шлюпка 
Целая категория Европейских лодок использующих гребную силу, делались из досок соединяющихся внахлёст, и обладали стреловидным носом и плоской кормой. В таблице представлены два варианта. Баркас - длинна 30 футов, ширина 4-5 футов, с четырьмя парами гребцов и одним рулевым; использовался между 1515 и 1867 годами как личная лодка капитана корабля. Судовая шлюпка - длинна 18 футов, ширина 4 фута, с тремя парами гребцов, использовалась как вспомогательное судно на большом корабле, обычно её спускали со стороны кормы.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Топор двуручный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>8</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+4 cut</damage>
			<strength>12‡</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Great Axe
<img data-src="http://weapons.gurps.ru/img/1706.png">

Массивный двуручный топор, боевая форма топора, используемого палачом для совершения казни. Обоюдоострый и очень большой, он редко встречается за пределом жанра фэнтези - немногие из историчных боевых топоров имели такой вид! Для реалистичного двуручного топора используйте ГЛЕФУ (стр.68, Б272), ДЛИННЫЙ ТОПОР (стр.70) или ДРЕВКОВУЮ СЕКИРУ (стр.68, Б272).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Топорик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1.5/x2.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Hatchet
<img data-src="http://weapons.gurps.ru/img/1713.png">

Легкий топор с короткой рукоятью, который можно метать. Также известен как франциска (Нормандия) и ната (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Тяжелая Колесница</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>660</value>
		<weight>780</weight>
		<reference>LT137</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Heavy Chariot

<img data-src="lib/img/151664244758.png">

Большая, массивная колесница, запряженная четверкой коней и везущая трех человек: возница, воин, и щитоносец. U-образный деревянный бортик поднимается до пояса спереди и по бокам, защищая всадников против ударов пехотинцев. Такие колесницы используются для атаки прямо на пехоту или другие колесницы с целью заставить их сломать строй. Этот тип колесниц был особенно любим хеттами Анатолии (ныне часть Турции); он также использовался в Китае в период Сражающихся царств (481-221 до н.э.). Серпоносная колесница (ТУ2) - это тяжелая колесница с режущими клинками, установленными на оси на угол, изобретенная ассирийцами, а позже принятая на вооружение персами. Рассчитывайте удар серпами как наносящий режущие повреждения, основанные на Движении и ЕЖ(HP) колесницы, как при столкновении (с. Б430). Это хорошо работает только против плотных построений; солдаты в рассыпном строю, как правило, имеют время, чтобы отойти в сторону.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фальшион большой</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>625</value>
		<weight>4.5</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Large Falchion
<img data-src="http://weapons.gurps.ru/img/1774.png">

Средневековый европейский термин, применяемый практически к любому мечу с односторонней заточкой, но чаще к тем, у которых лезвие расширяется к концу, тяжелое, и/или изгибается вперёд возле конца, что делает более удобными режущие удары, а не колющие. Такой клинок существовал практически у всех культур, занимавшихся обработкой железа; охотники и солдаты всего мира ценили его в качестве инструмента (для разделки дичи, вырубки кустов, вскрывания кокосов, и т.п.) и оружия. Обычно заострен, но существуют варианты с тупым концом, что изменяет урон с колющего на дробящий. Фальшионы обычно размером с короткий меч, к ним относят боло (Филипины), дан санг гум (Корея), фальката (до-Римская Иберия), паранг (Индонезия), сика (Древний рим), серповидный меч (повсеместно), тромбаш (Конго), и меч-бабочку (Китай), который выделяется тем, что оборудован гардой. БОЛЬШОЙ ФАЛЬШИОН (стр.65) размером с широкий меч, включает в себя самые большие паранги и кольцевой меч (Китай).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хопеш</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>450</value>
		<weight>3</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<strength>10</strength>
			<usage>Hook Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Крюк позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Khopesh
<img data-src="http://weapons.gurps.ru/img/1756.png">

Древний Египет. 

Искривленный, серповидный рубящий меч, с клинком в форме вопросительного знака, заостренным на внешней стороне. Хотя и называется "мечом", действует как цельнометаллический топор, может наносить рубящие удары и атаки описанные в правилах для Крюка (стр.54). Может использоваться с навыками Топор/Булава или Широкий меч. Похожие виды оружия были известны и в других культурах, включая Индию.



Крюк позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хунгамунга</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<melee_weapon>
			<damage>sw-2 cut</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw-1 cut</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.8/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Не сбалансирован для ближнего боя! Считайте хунгамунгу - большим ножом, а большую хунгамунгу - топором, но со штрафом -2 к навыку и -1 к Парированию (для ножей это значение складывается с обычным штрафом -1 к Парированию.)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Hungamunga
<img data-src="http://weapons.gurps.ru/img/1725.png">

Африка южнее Сахары. 

Плоская "метательная железка" с несколькими острыми углами - обычно от пяти до восьми - и рукоятью. Обычно использует навык Метательное Оружие (Нож), однако БОЛЬШАЯ ХУНГАМУНГА (стр.77) использует Метательное Оружие (Топор/Палица). На ТУ2 хунгамунга делается из мягкого железа и может погнуться при успешном попадании. Бросьте 1d, результат 1-3 означает что оружие погнулось и теперь бесполезно. Процедура выпрямления требует 10 секунд и проверку навыка Оружейник+3. Игнорируйте это правило для стального оружия на ТУ3 и выше. Также называется монгванга.



Не сбалансирован для ближнего боя! Считайте хунгамунгу - большим ножом, а большую хунгамунгу - топором, но со штрафом -2 к навыку и -1 к Парированию (для ножей это значение складывается с обычным штрафом -1 к Парированию.)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хунгамунга большая</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>4</weight>
		<reference>LT72</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>-1U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>10†</strength>
			<usage>Swing - two handed</usage>
			<reach>1</reach>
			<parry>-1U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-6</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Не сбалансирован для ближнего боя! Считайте хунгамунгу  - большим ножом, а большую хунгамунгу - топором, но со штрафом -2 к навыку и -1 к Парированию (для ножей это значение складывается с обычным штрафом -1 к Парированию.)</notes>
		<description-loc>Large Hungamunga
<img data-src="http://weapons.gurps.ru/img/1776.png">

Африка южнее Сахары.

Плоская "метательная железка" с несколькими острыми углами - обычно от пяти до восьми - и рукоятью. Обычно использует навык Метательное Оружие (Нож), однако БОЛЬШАЯ ХУНГАМУНГА (стр.77) использует Метательное Оружие (Топор/Палица). На ТУ2 хунгамунга делается из мягкого железа и может погнуться при успешном попадании. Бросьте 1d, результат 1-3 означает что оружие погнулось и теперь бесполезно. Процедура выпрямления требует 10 секунд и проверку навыка Оружейник+3. Игнорируйте это правило для стального оружия на ТУ3 и выше. Также называется монгванга.



Не сбалансирован для ближнего боя! Считайте хунгамунгу  - большим ножом, а большую хунгамунгу - топором, но со штрафом -2 к навыку и -1 к Парированию (для ножей это значение складывается с обычным штрафом -1 к Парированию.)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цзянь</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>3</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Jian
<img data-src="http://weapons.gurps.ru/img/1737.png">

Китай.

Прямой, одноручный меч с длинным и узким лезвием, достаточно лёгким для того, чтобы фехтовать, и прочным, чтобы рубить. Рукоять часто украшается кисточкой.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Цзянь</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>3</weight>
		<reference>LT57</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Jian
<img data-src="http://weapons.gurps.ru/img/1737.png">

Китай.

Прямой, одноручный меч с длинным и узким лезвием, достаточно лёгким для того, чтобы фехтовать, и прочным, чтобы рубить. Рукоять часто украшается кисточкой.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Чашка-присоска для кровопускания</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>0.5</weight>
		<reference>LT153</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Bleeding Cup
<img data-src="lib/img/151591889492.png">
Эта роговая или металлическая чашка нагревается и прижимается к коже над разрезом. При охлаждении создается отрицательное давление и кровь вытягивается. Использование – бросок Нетрадиционной медицины. Вариант ТУ0 имеет маленькое отверстие; пользователь отсасывает воздух через него и замазывает воском. $25, 0.5 ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Чернила 0.5л</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>2.5</value>
		<weight>1</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Ink, per pint
<img data-src="lib/img/151663533832.png">
Этот водный раствор содержит пигмент (например, сажу) и связующее вещество, чтобы пигмент не осел (например, гуммиарабик или лак). Западные чернила хранят в жидком виде; пинта - 2,50$, 1 фунт. Азиатские чернила делают в виде палочек, которые разводят с помощью чернильного камня и воды; на одну пинту чернил 2.50$, 1 унция. За эту цену можно купить чёрные или коричневые чернила. Другие землистые цвета или красные: +1 ЦФ. Более редкие цвета, например фиолетовый: +4 ЦФ.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Чернильный камень</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Ink Stone
<img data-src="lib/img/151663530476.png">
Мелкая каменная ванночка для использования чернильных палочек. Писец наливает немного воды и трет палочку о внутреннюю поверхность, пока не получит требуемого цвета. $20, 2 ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Черный порох гранулированный</description>
		<tech_level>4</tech_level>
		<legality_class>3</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT85</reference>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Corned Black Powder
<img data-src="lib/img/151600679435.png">
Из-за высокой стоимости селитры (стр. 26, 84) китайские алхимики пытались получить вещество с похожими свойствами, смешивая её с другими веществами. Где-то около 1100 н.э., они изобрели взрывчатую смесь: чёрный порох. Селитра стала известна арабам в 1225 г.;. чёрный порох - в 1250 г. Роджер Бэкон записал формулу чёрного пороха в Англии в 1257 г. В качестве ингредиентов использовались селитра, древесный уголь и сера; типичная пропорция составляла 75%, 15% и 10% соответственно. Уголь был основным топливом, а селитра – источником кислорода; сера снижала температуру, при которой селитра начинала выделять кислород. Ингредиенты следовало мелко растолочь в ступке и перемешать.

Ранний чёрный порох был порошкообразным. Этот серпентин (ТУ3) сгорал мгновенно, но обладал ограниченной взрывной силой. В 15 веке был изобретен гранулированный порох (ТУ4), изначально он предназначался для того чтобы порох было легче хранить и перевозить. Влажный порошок прессовали в брикеты, после чего перемалывали до зернистого состояния: мелкого помола – для использования в запалах, среднего помола – для использования в маленьком огнестрельном оружии, или грубого помола – для пушек и взрывчатки.

Для чёрного пороха нашлось множество применений. Его использовали в качестве материала для пороховых дорожек (см. Зажигательные средства, 

стр.84), или взрывчатки (см. правила описанные в главе Взрывы, стр. Б414-415 ). Из него делали фейерверки (см. Фейерверки). И, конечно же, использовали в оружии.

Черный порох обычно продается в бочках по 100 фунтов каждая. Гранулированный порох стоит $20 за 1 фунт; считайте серпентин дешевым (-0.5 ЦФ). КЛ(LC)3.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шишковатая дубина</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Knobbed Club
<img data-src="http://weapons.gurps.ru/img/1760.png">

Дубина с увеличенной ударной головкой. Сюда относятся кнобкирри (Африка), S-образная отта (Индия) и куаухололии (Ацтеки).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шпага</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>3</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Edged Rapier
<img data-src="http://weapons.gurps.ru/img/1678.png">

Европа.

Длинный одноручный меч с жестким, узким лезвием, предназначенным для колющих ударов (но не для парирования, рапиристы часто носят с собой дополнительное оружие или плащ для защиты). Несмотря на ошибочные современные представления, рапира не является хрупкой или непрочной; она просто длиннее и уже режуще-колющих боевых мечей той же массы, являясь удобным гражданским оружием, предназначенным для сражений с одетыми в легкую броню противниками. Существует множество вариаций рапиры. ЛЁГКАЯ РАПИРА (стр.68) один из варианта оружия позднейших времен, на пути к МАЛОМУ МЕЧУ (ниже, стр.Б273). Ранние рапиры обычно были с острыми лезвиями и весили достаточно для нанесения рубящих ударов, этой же особенностью обладают и некоторые поздние клинки. Такое оружие именуется ШПАГА (стр.66, 68) и ЛЁГКАЯ ШПАГА(стр.68), соответственно.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Экипаж</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>11000</value>
		<weight>4800</weight>
		<reference>LT137</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Coach
<img data-src="lib/img/151600631831.png">
Текст на стр.B464 описывает "дилижанс" - один из основных видов экипажей, в который впрягаются четыре лошади: улучшенная упряжь позволяет одному кучеру управлять ими всеми. Также известен как "запряженный четвёркой". Становится распространённым приблизительно с 1640г.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Эсток</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Estoc
<img data-src="http://weapons.gurps.ru/img/1681.png">

Европа. 

Колющий меч, без заточки лезвия, с треугольным, круглым или ромбовидным сечением, предназначенный для протыкания щелей в пластинчатых доспехах. Благодаря специальной форме игнорирует -2 из штрафа за прицеливание в щели на броне (стр.Б400). Также называется тук (Англия).



Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.25</value>
		<weight>0.05</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 2</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.16 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 1/4 cup
<img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.75</value>
		<weight>0.1</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 2</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.66 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 1 cup
<img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.3</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 3</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2.72 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 1 quart
    <img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4.5</value>
		<weight>0.75</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 4</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">10.79 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 1 gal.
<img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7.35</value>
		<weight>1.25</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 5</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">22.41 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 2 gal.
    <img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>2.5</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 6</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">66.4 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 6 gal.
<img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>34</value>
		<weight>5.5</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 8</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">224.1 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 20 gal.
<img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 150 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>53</value>
		<weight>9</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 9</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">439.9 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 40 gal.
    <img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 300 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>85</value>
		<weight>14</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 10</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">913 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 80 gal.
    <img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Кожаная сумка, 450 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>111</value>
		<weight>18.5</weight>
		<reference>LT34</reference>
		<notes>DR 2, HP 11</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1328 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Leather Pouch, 120 gal.
    <img data-src="lib/img/151664223571.png">
Кожаные сумки имеют СП(DR) 2 и выдерживают 0.75 унций на кубический дюйм, или 83 фунта на кубический фут, но остальные характеристики как у матерчатых мешков.
</description-loc>
	</equipment_container><equipment version="3">
		<quantity>1</quantity>
		<description>Баркас 9м</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>5000</value>
		<weight>3500</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Longboat, 30'
<img data-src="lib/img/151669034240.png">
Гребная шлюпка 
Целая категория Европейских лодок использующих гребную силу, делались из досок соединяющихся внахлёст, и обладали стреловидным носом и плоской кормой. В таблице представлены два варианта. Баркас - длинна 30 футов, ширина 4-5 футов, с четырьмя парами гребцов и одним рулевым; использовался между 1515 и 1867 годами как личная лодка капитана корабля. Судовая шлюпка - длинна 18 футов, ширина 4 фута, с тремя парами гребцов, использовалась как вспомогательное судно на большом корабле, обычно её спускали со стороны кормы.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Боевая сеть</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>5</weight>
		<reference>LT59</reference>
		<ranged_weapon>
			<damage>spec.</damage>
			<strength>8</strength>
			<usage>Throw</usage>
			<accuracy>1</accuracy>
			<range>spec.</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>Skill</type>
				<name>Net</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Cloak</name>
				<modifier>-5</modifier>
			</default>
		</ranged_weapon>
		<notes>Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404). У сети нет расстояния половины повреждений. Максимальное расстояние равняется (СЛ(ST)/2 + Навык/5) для большой сети и (СЛ(ST) + Навык/5) для боевой сети.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Melee Net
<img data-src="http://weapons.gurps.ru/img/1832.png">

Древний Рим. 

Утяжеленная сеть предназначенная для сражений. БОЕВАЯ СЕТЬ (стр.76) - одноручная метательная или для ближнего боя, использовалась Римскими гладиаторами в паре с ТРЕЗУБЦЕМ. Позволяет использовать Блокировать со значением (навык / 2) + 3, но не дает ПЗ(DB), и, как Рассеянная цель (стр.Б380), может остановить только 1-2 единиц урона, при блокировании снарядов. БОЛЬШАЯ СЕТЬ (стр.76) требует обеих рук и может быть использована только для метания, но из нее тяжелее выпутаться; см. правила на стр.Б411. Боец вооруженный сетью может расстилать её перед собой с целью опрокинуть оппонента. Гекс, в котором находится сеть считается неустойчивым. После чего можно попытаться выдернуть сеть из под ног оппонента. Проведите Быстрое Состязание СЛ(ST). Если использующий сеть выигрывает, оппонент падает, в обратном случае ничего не происходит. В случае если у использующего выпадает критический промах, падает он!



Может обездвижить или опутать цель; см. Специальные Оружия Дальнего боя (стр. Б410-411) и Плащи (стр.Б404).

У сети нет расстояния половины повреждений. Максимальное расстояние равняется (СЛ(ST)/2 + Навык/5) для большой сети и (СЛ(ST) + Навык/5) для боевой сети.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Булава</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>11†</strength>
			<usage>Swing - two handed</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Mace
<img data-src="http://weapons.gurps.ru/img/1822.png">

Любая несбалансированная одноручная боевая дубина с массивной каменной, деревянной или металлической дробящей головкой. Хотя гладкая ПАЛИЦА (стр.65, 70) и является древней, современные мастера боевых искусств все еще используют "арбузные молоты" и похожее оружие - иногда даже парно. Стандартная БУЛАВА (стр.65, 70, 77, Б271, Б276), с "перьями" (как пернач или шестопер) или шипами (см. МОРГЕНШТЕРН), для ударов сквозь латы, является классическим примером оружия средневековой Европы. Оба варианта представляют из себя булавы большого размера, с рукоятями, достаточно длинными для комфортного двуручного использования; используйте характеристики из раздела Двуручный Топор/Булава, которые изменяются во время использования оружия в Защитном хвате, описанном в GURPS Боевые Искусства. Тем не менее, большинство исторических экземпляров были меньше и легче: МАЛЕНЬКАЯ ПАЛИЦА (стр.65, 77) и МАЛЕНЬКАЯ БУЛАВА (стр.65, 77, Б271, Б276). Метательная булава является смертоносным снарядом; атакующий подбрасывает её в воздух, а не кидает по прямой траектории.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дага</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1.25</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw-3 cut</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Main-Gauche
<img data-src="http://weapons.gurps.ru/img/1829.png">

Франция, Италия. 

Прочный нож с большой корзинчатой гардой и широким эфесом, в основном предназначен для парирования. Известен также как мэн-гош. Используется в паре с рапирой. Не для метания.</description-loc>
	</equipment><equipment version="3">
	<description>Длинный меч</description>
	<value>700</value>
	<weight>4</weight>
	<quantity>1</quantity>
	<melee_weapon>
		<damage>sw+1 cut</damage>
		<strength>10</strength>
		<reach>1</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>-4</modifier>
		</default>
		<usage>Swing - One Handed</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>thr+2 imp</damage>
		<strength>10</strength>
		<reach>1,2</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>-4</modifier>
		</default>
		<usage>Thrust - One Handed</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>sw+1 cut</damage>
		<strength>9†</strength>
		<reach>1</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<usage>Swing - Two Handed</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>thr+3 imp</damage>
		<strength>9†</strength>
		<reach>1,2</reach>
		<parry>0</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<usage>Thrust - Two Handed</usage>
	</melee_weapon>
	<legality_class>4</legality_class>
	<tech_level>3</tech_level>
	<categories>
		<category>Холодное оружие</category>
	</categories>
	<reference>LT58</reference>
	<description-loc>
		Longsword
		<img data-src="http://weapons.gurps.ru/img/1818.png">
		Германия. 

Легкий КОЛЮЩИЙ ПОЛУТОРНЫЙ МЕЧ (стр.54, Б271) предназначенный для колющих ударов с использованием обеих рук. Может быть использован как двуручный (используйте характеристики из раздела двуручных мечей) или в Защитном хвате, как описано в ГУРПС Боевые Искусства. Для способствования этой тактике обычно затачивались не более чем 6 ближайших к острию дюймов лезвия.
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дубина легкая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>3</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Club
<img data-src="http://weapons.gurps.ru/img/1794.png">

Любая сбалансированная деревянная дубина, будь это специализированное оружие (хорошее качество или лучше) или удобная ветка, ножка стола, и т.п. (дешевое качество). Это оружие известно под огромным количеством имен, включая "дубинка" (повсеместно) и "шылела" (Ирландия). У каждой культуры есть свое подобие дубины, и в большинстве языков есть слово отображающее концепцию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ длинное узкое, 9м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4000</value>
		<weight>5500</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Long Dugout Canoe, 30’
<img data-src="lib/img/151677498363.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 1м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>4</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 1 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 2м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>1-2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 2 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 3м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>1.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1-3*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 3 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 4м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>2</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 4 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 5м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>2.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1-5*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 5 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 6м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>3</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>9</strength>
			<usage>Swung</usage>
			<reach>1-6*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 6 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут легкий, 7м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>140</value>
		<weight>3.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-5(0.5) cr</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1-7*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Whip, 7 yd
<img data-src="http://weapons.gurps.ru/img/1801.png">

КНУТ (стр.70, Б274) - повсеместно. Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Конеруб легкий</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>8</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+4 cut</damage>
			<strength>11‡</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>11†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Horse-Cutter
<img data-src="http://weapons.gurps.ru/img/1798.png">

Китай.

Древковое оружие с тяжелым рубящим клинком, таким же как у ДАО (выше), предназначенное для использования пехотой против всадников. ТЯЖЕЛЫЙ КОНЕРУБ (стр.68) в полтора раза длиннее и тяжелее ЛЕГКОГО КОНЕРУБА (стр.68). Также может называться пудао (Китай). К тяжелой версии можно отнести бисэнто (Япония, Окинава), а к легкой - совню (Русь) и пальму (Сибирь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Копьё длинное</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>5</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>2, 3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<usage>Thrust - two hands</usage>
			<reach>2, 3*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Long Spear
<img data-src="http://weapons.gurps.ru/img/1811.png">

Древковое оружие с острым колющим наконечником, ценится за свою универсальность: длинное, может быть использовано как одной, так и двумя руками, часто метательное, и всегда смертоносное. Копье является по настоящему повсеместным оружием; к примерам можно отнести болг (древние кельты), цян (Китай), хаста (Древний Рим), нгао (Таиланд), сибат (Филиппины) и яри (Япония) - и это только некоторые. Многие варианты жертвуют универсальностью в обмен на особые возможности. Например у яри иногда можно встретить L-образный наконечник; это дает дополнительно $10 и 0,5 фунтов, и позволяет использовать правила для Крюка (стр.54), однако не позволяет метать. У других копий наконечник может быть не заостренным, а полукруглым или в форме полумесяца; повреждения при этом становятся рубящими, а прочие характеристики не изменяются. КОРОТКОЕ КОПЬЕ (стр.69) короткое, одноручное и не метательное - это колющий меч для бедных; примером может быть рохин (Япония). ДЛИННОЕ КОПЬЁ предназначено исключительно для ближнего боя и используется для сражения в строю, как со щитом, так и без него. ТЯЖЕЛОЕ КОПЬЕ (стр.69) похоже, однако у него очень широкий наконечник; оно такое тяжелое, что требует для использования обеих рук. К тяжелым копьям относятся дори и контос (оба Древняя Греция), а также рогатина (Русь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кувалда</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>12</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+5 cr</damage>
			<strength>13‡</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Maul
<img data-src="http://weapons.gurps.ru/img/1831.png">

Тяжелый двуручный молот.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Легкая колесница</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>330</value>
		<weight>460</weight>
		<reference>LT137</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Light Chariot
<img data-src="lib/img/151664239296.png">
Транспортное средство, разработанное для лучника с мощным сложным луком. Она перевозит двоих человек - возницу и лучника - и запряжено двумя лошадьми. У нее есть бортик высотой по пояс, как у тяжелой колесницы, но он сделан из кожи или переплетенных прутьев на легком деревянном каркасе. Обычная тактика подобных колесниц заключалась в том, чтобы осыпать стрелами вражескую армию, проезжая мимо нее. Подобные колесницы делались настолько легкими, что человек или двое могут тащить ее по неровной местности.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук длинный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>3</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>11†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Longbow
<img data-src="http://weapons.gurps.ru/img/1817.png">

ЛУК (стр.72, Б275) целиком из дерева. КОРОТКИЙ ЛУК (стр.76) можно сделать практически из любой достаточно удобной ветки, хотя особой силой он отличаться не будет, это наиболее ранний вид луков. ОБЫЧНЫЙ ЛУК (стр.76) длиннее и мощнее. ДЛИННЫЙ ЛУК (стр.76) - знаменитое оружие английских лучников - вершина технологии изготовления не-составных луков, длинною как минимум 6 футов. Лучшие из длинных луков делаются из тиса, естественные физические свойства которого очень схожи с составными материалами.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Макуавитль</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>3</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+2(0.5) cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Macuahuitl
<img data-src="http://weapons.gurps.ru/img/1827.png">

Ацтеки. 

Деревянная дубина, с лезвиями, склеенными вместе из кусочков обсидиана. Обычно снабжается петлей для надежного крепления на запястье. Способно наносить рубящие удары, хотя обсидиановые фрагменты легко крошатся и откалываются. В случае если это оружие используется для парирования, само парируется любым оружием или наносит удар предмету с СП(DR) 2+, оно получает -1 к режущим повреждениям до тех пор, пока не будет отремонтировано (см. Материал клинка, стр.Б275). Дополнительно, при любой успешной атаке или успешном парировании удара оружием, бросьте 1d; на 1-2 лезвие ломается, превращая макуавитль в дубину, наносящую амп+1 (sw+1) дробящих повреждений. К счастью, у этого оружия две острых стороны - и владеющий им может менять их (свободное действие) если одно лезвие сломается. Размер варьируется от короткого МАКУАВИЦОЧТЛИ (выше) до ДВУРУЧНОГО МАКУАВИТЛЯ (стр.70).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Макуавицочтли</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>350</value>
		<weight>2</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+1(0.5) cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Macuahuilzoctli
<img data-src="http://weapons.gurps.ru/img/1825.png">

Ацтеки. 

Укороченная версия МАКУАВИТЛЬ (ниже).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Негашеная известь</description>
		<tech_level>1</tech_level>
		<legality_class>3</legality_class>
		<value>1</value>
		<reference>LT130</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Lime Powder
<img data-src="lib/img/151664258592.png">
Порошковая негашеная известь (см. Строительные растворы и неорганические связывающие материалы, стр. 19) может быть использована в качестве респираторного яда или кровяного яда (в основном в глаза). В качестве респираторного яда, она имеет задержку в одну секунду и бросок против ЗД(HT) для сопротивления. Это вызывает немедленный кашель и чих (стр. Б428); кроме того, если бросок сопротивления провален, яд наносит 1 очко ядовитых повреждений, повторяющееся с интервалом в одну секунду в течение 10 секунд. Как кровяной яд, он не имеет задержки, но позволяет бросать против ЗД(HT) для сопротивления. Если сопротивление провалено, он вызывает сильные боли (стр. Б428) - и, если яд попал в глаза, слепоту. Оба условия длятся до тех пор, пока место попадания яда не будет промыто водой в течение 5 минут. Порошковая известь теряет эффективность за несколько дней, если не хранить её в сухом месте, что вызывает необходимость в закрытом контейнере. Бесплатно или $1 за дозу. КЛ(LC)3.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нож длинный</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>1.5</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>C, 1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Long Knife
<img data-src="http://weapons.gurps.ru/img/1809.png">

Любой одноручный клинок размером меньше меча, сделанный для эффективных режущих и колющих ударов. Самым легким является МАЛЕНЬКИЙ НОЖ (стр.67, 77, Б272, Б276), который также может быть сбалансирован для метания; примерами являются бхудж (Индия), козука (Япония) и писау (Индонезия).

Следующая категория размеров - БОЛЬШОЙ НОЖ (стр.67, 77, Б272, Б276), который чаще всего предназначается для сражения, и очень редко для метания; к такому оружия относятся почковый нож или почковый кинжал (Европа), дан ган (Корея), дирк (Европа), кард (Персия) и заточенный как долото танто (Япония).

Самым большим, от 15 до 23 дюймов, является ДЛИННЫЙ НОЖ (стр.69), который лишь немного меньше чем КОРОТКИЙ МЕЧ (стр.61, Б273), его нельзя метать. К длинным кинжалам относятся самые длинные версии дирка, карда и танто. Некоторые термины, вроде пунал (Филипины), описывают ножи любого размера. Стреловидные эмэйици (Китай) и сиангкам (Индонезия) тоже могут быть любого размера, но могут наносить только колющие удары. Оружие предназначенное специально для метания, см МЕТАТЕЛЬНЫЙ НОЖ (стр.77).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Носилки</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>25</weight>
		<reference>LT136</reference>
		<notes>Требуется 2 носильщика</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Litter
<img data-src="lib/img/151668824655.png">
Самые простые носилки сделаны из двух деревянных шестов, между которыми прикреплена кожа или плотная ткань. Пассажир лежит между шестами, которые поднимают на плечи двое носильщиков. Такие носилки похожи на волокушу, но держатся за оба конца; поэтому носильщики должны суметь поднять полный груз. 100$, 25 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие дальнобойное "Внушающий ужас"</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>2200</value>
		<weight>160</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>7d-1 pi++</damage>
			<strength>21M†</strength>
			<usage>Shoot Lead Ball</usage>
			<accuracy>1</accuracy>
			<range>130/1,200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-10</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>1d-1 pi+</damage>
			<strength>–</strength>
			<usage>Shoot Lead Shot</usage>
			<accuracy>1</accuracy>
			<range>130/1,200</range>
			<rate_of_fire>1x100</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>–</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Long-Range Awe-Inspiring Gun
<img data-src="lib/img/151668970229.png">
Китайское орудие
[Нет описания в LowTech, только в таблице]</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие дальнобойное "Внушающий ужас"  - выстрел</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>3.5</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Long-Range Awe-Inspiring Gun Lead Shot
<img data-src="lib/img/151677574012.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие дальнобойное "Внушающий ужас"  - шар</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>3</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Long-Range Awe-Inspiring Gun Lead Ball
<img data-src="lib/img/151677090776.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Отмычки, обычные</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>0.2</weight>
		<reference>LT126</reference>
		<categories>
			<category>Воровской инструмент</category>
		</categories>
		<description-loc>Lockpick Set, Basic
<img data-src="lib/img/151668956856.png">
Взлом замков включает в себя манипуляции с частями замка для того, чтобы открыть его без ключа. Защелки, ротационные замки и замки с бородка-пружинами могут быть взломаны одной рукой, в то время как ротационные замки с выемками требуют двух рук; см. Замки (стр. 120-121). Набор отмычек - доступный на ТУ1, но редкий до ТУ2 - включает щупы и болванки ключей и является базовым снаряжением: $50, 0,2 фунта. Набор хорошего качества (+1 к умению) включает более полный набор болванок ключей: $250, 0,5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Отмычки, хорошие</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>0.5</weight>
		<reference>LT126</reference>
		<categories>
			<category>Воровской инструмент</category>
		</categories>
		<description-loc>Lockpick Set, Good
<img data-src="lib/img/151668958682.png">
Взлом замков включает в себя манипуляции с частями замка для того, чтобы открыть его без ключа. Защелки, ротационные замки и замки с бородка-пружинами могут быть взломаны одной рукой, в то время как ротационные замки с выемками требуют двух рук; см. Замки (стр. 120-121). Набор отмычек - доступный на ТУ1, но редкий до ТУ2 - включает щупы и болванки ключей и является базовым снаряжением: $50, 0,2 фунта. Набор хорошего качества (+1 к умению) включает более полный набор болванок ключей: $250, 0,5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Посох длинный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>5</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>10†</strength>
			<usage>Swung</usage>
			<reach>2,3</reach>
			<parry>2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>10†</strength>
			<usage>Thrust</usage>
			<reach>2,3</reach>
			<parry>2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Long Staff
<img data-src="http://weapons.gurps.ru/img/1813.png">

Сбалансированный деревянный шест длиною от 2 до 3 метров, используемый обоими руками с хватом по центру.  ГМ использующий ГУРПС Боевые Искусства может разрешить для этого оружия преимущества Парирования Двуручным Оружием (Боевые Искусства стр.123), даже если он не использует это правило. Солдат непременно учат драться посохом, для того чтобы они могли защитить себя в случае потери наконечника древкового оружия. Сломанное древковое оружие обладает параметрами ДЛИННОГО ПОСОХА (стр.69) - также как традиционный 8-9 футовый средневековый Европейский квотерстафф и древко пики (Англия). Drag ограничивает ударную силу длинного посоха, и требует Защитного Хвата описанного в Боевых Искусствах, для большей пользы в ближнем бою.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Походный набор - роскошь</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>226</value>
		<weight>25</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Luxury Travel Kit
<img data-src="lib/img/151669044718.png">
Компактный чемодан с предметами роскоши — для путешествующих аристократов — практически бесполезен для выживания, но необходим для комфорта состоятельного человека! Включает полный набор принадлежностей для ухода за внешностью (бритва, щетка, гребень, мыло, духи и косметические средства), письменный ящик (стр.47), сервиз для чая, кофе или алкоголя (в зависимости от культуры), и всё это аккуратно уложено в специальный ящик. Относительно простые модели, с заурядным содержимым: $225, 25 фунтов. Используйте цены на роскошь (стр.37), чтобы заменить дешевое вино на бренди, парикмахерские принадлежности из дерева на слоновью кость, и т.п.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рапира легкая</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>2</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Rapier
<img data-src="http://weapons.gurps.ru/img/1800.png">

Европа.

Длинный одноручный меч с жестким, узким лезвием, предназначенным для колющих ударов (но не для парирования, рапиристы часто носят с собой дополнительное оружие или плащ для защиты). Несмотря на ошибочные современные представления, рапира не является хрупкой или непрочной; она просто длиннее и уже режуще-колющих боевых мечей той же массы, являясь удобным гражданским оружием, предназначенным для сражений с одетыми в легкую броню противниками. Существует множество вариаций рапиры. ЛЁГКАЯ РАПИРА (стр.68) один из варианта оружия позднейших времен, на пути к МАЛОМУ МЕЧУ (ниже, стр.Б273). Ранние рапиры обычно были с острыми лезвиями и весили достаточно для нанесения рубящих ударов, этой же особенностью обладают и некоторые поздние клинки. Такое оружие именуется ШПАГА (стр.66, 68) и ЛЁГКАЯ ШПАГА(стр.68), соответственно.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Топор длинный</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>75</value>
		<weight>6</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>11‡</strength>
			<usage>Swung</usage>
			<reach>1, 2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Long Axe
<img data-src="http://weapons.gurps.ru/img/1808.png">

ТОПОР (стр.54, Б271) с длинной рукоятью, предназначен для двуручного использования, однако достаточно сильные воины могут использовать его в качестве одноручного. Сюда относятся Скандинавская секира или Датский топор (Дания), Английский топор (Англия), самые большие из масакари (Япония) и топор викингов (Скандинавия). Исторически, оружие называемое "длинным топором" было как меньшего (как ТОПОР, стр.65, Б271) так и большего (как БОЛЬШОЙ ТОПОР, стр.70, Б274) размера.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фитильная заслонка
</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.5</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Match Cover
<img data-src="lib/img/151669103022.png">
Эта съемная заслонка защищает фитильный замок от дождя. Была изобретена в Японии, где ливневые дожди явление далеко не редкое. Побочным преимуществом является то, что она скрывает свет от горящего фитиля, не давая стрелку быть обнаруженным в ночное время. $10, 0.5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шпага легкая</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>2.25</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Light Edged Rapier
<img data-src="http://weapons.gurps.ru/img/1796.png">

Европа.

Длинный одноручный меч с жестким, узким лезвием, предназначенным для колющих ударов (но не для парирования, рапиристы часто носят с собой дополнительное оружие или плащ для защиты). Несмотря на ошибочные современные представления, рапира не является хрупкой или непрочной; она просто длиннее и уже режуще-колющих боевых мечей той же массы, являясь удобным гражданским оружием, предназначенным для сражений с одетыми в легкую броню противниками. Существует множество вариаций рапиры. ЛЁГКАЯ РАПИРА (стр.68) один из варианта оружия позднейших времен, на пути к МАЛОМУ МЕЧУ (ниже, стр.Б273). Ранние рапиры обычно были с острыми лезвиями и весили достаточно для нанесения рубящих ударов, этой же особенностью обладают и некоторые поздние клинки. Такое оружие именуется ШПАГА (стр.66, 68) и ЛЁГКАЯ ШПАГА(стр.68), соответственно.</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 0.1 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>28</value>
		<weight>0.4</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 3</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 1/4 cup
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 1/4 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>72</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 4</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.75 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 1 cup
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 1л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>184</value>
		<weight>2.5</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 5</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">7.25 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 1 quart
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 4 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>460</value>
		<weight>6.5</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 8</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">27.95 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 1 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 7.5 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1468</value>
		<weight>20</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 11</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">58.05 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 2 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 23 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>3044</value>
		<weight>42</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 14</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">172 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 6 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 75 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>6800</value>
		<weight>94</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 19</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">580.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 20 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 150 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>16200</value>
		<weight>225</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 25</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1139.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 40 gal.
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 300 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>25668</value>
		<weight>356</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 29</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2365 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 80 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка бронзовая, 450 л.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>33636</value>
		<weight>467</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 32</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">3440 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Bronze, 120 gal.
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 0.1 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.4</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 3</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 1/4 cup
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 1/4 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>18</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 4</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.75 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 1 cup
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 1 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>46</value>
		<weight>2.5</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 5</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">7.25 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 1 quart
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 4 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>115</value>
		<weight>6.5</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 8</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">27.95 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 1 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 7.5 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>367</value>
		<weight>20</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 11</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">58.05 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 2 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 23 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>761</value>
		<weight>42</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 14</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">172 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 6 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 75 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1700</value>
		<weight>94</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 19</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">580.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 20 gal.
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 150 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>4050</value>
		<weight>225</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 25</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1139.5 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 40 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 300 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>6417</value>
		<weight>356</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 29</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2365 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 80 gal.
    <img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Коробка железная, 450 л.</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>8409</value>
		<weight>467</weight>
		<reference>LT34</reference>
		<notes>DR 3, HP 32</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">3440 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Metal Box, Iron, 120 gal.
<img data-src="lib/img/151669126876.png">
У металлических ящиков СП(DR) 3. Цены рассчитаны для железа (ТУ2). Бронза (ТУ1) имеет четырехкратную цену. Оба типа выдерживают около 2 унций веса на кубический дюйм, или 215 фунтов на кубический фут.
</description-loc>
	</equipment_container><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.1м</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>7200</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>5d imp</damage>
			<strength>38M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>250/315</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(24)</shots>
			<bulk>-11</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Scorpion, 45”
<img data-src="lib/img/151591643601.png">
Древняя баллиста метающая болты, а не камни. Была названа «скорпионом» за внешний вид и форму снарядов. Также как и метающая камни баллиста, это торсионный двух-плечевой механизм с низкой траекторией полета снаряда. Скорпионы различались по длине метаемых ими снарядов. 

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.1м - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>74.25</value>
		<weight>2.25</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 45" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.1м - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>2300</value>
		<weight>93</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Scorpion, 45” Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.4м</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>12800</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>6d-1 imp</damage>
			<strength>51M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>250/315</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(35)</shots>
			<bulk>-12</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Scorpion, 54”
<img data-src="lib/img/151591643601.png">
Древняя баллиста метающая болты, а не камни. Была названа «скорпионом» за внешний вид и форму снарядов. Также как и метающая камни баллиста, это торсионный двух-плечевой механизм с низкой траекторией полета снаряда. Скорпионы различались по длине метаемых ими снарядов. 

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.4м - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>132</value>
		<weight>4</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 54" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.4м - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>3500</value>
		<weight>140</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Scorpion, 54” Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.8м</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>30000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>7d+1 imp</damage>
			<strength>77M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>275/345</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(30)</shots>
			<bulk>-14</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 1 человек Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Scorpion, 72” 
<img data-src="lib/img/151591643601.png">
Древняя баллиста метающая болты, а не камни. Была названа «скорпионом» за внешний вид и форму снарядов. Также как и метающая камни баллиста, это торсионный двух-плечевой механизм с низкой траекторией полета снаряда. Скорпионы различались по длине метаемых ими снарядов. 

Требуется персонал 1 человек 
Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.8м - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>330</value>
		<weight>10</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 72" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 1.8м - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>6300</value>
		<weight>250</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Scorpion, 72” Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 22 см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>1d+2 imp</damage>
			<strength>7†[7]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>185/230</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Scorpion, 9”
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 22 см - болт</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.66</value>
		<weight>0.02</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 9" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 34 см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>1d+3 imp</damage>
			<strength>7†[10]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>200/250</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Scorpion, 13.5”
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 34 см - болт</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1.98</value>
		<weight>0.06</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 13.5" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 45 см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>475</value>
		<reference>LT83</reference>
		<ranged_weapon>
			<damage>2d+1 imp</damage>
			<strength>12†[13]</strength>
			<usage>Shoot</usage>
			<accuracy>4</accuracy>
			<range>210/265</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(6)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Ручная артиллерия</category>
		</categories>
		<description-loc>Scorpion, 18”
<img data-src="lib/img/151591643601.png">
Греки и римляне также изобрели баллисты и скорпионы достаточно лёгкие для того, чтобы использовать их в качестве личного оружия. В отличии от арбалетов, как описано в Луки, Пращи, и Метательное оружие (стр.72-78), которые производятся индивидуально (см. Луки, Арбалеты и Расчётная СЛ(ST), стр. 74), эти орудия обладают определенным "калибром", в зависимости от длины болта или веса метаемого камня. Размер пружины выбирается соответственно диаметру используемой амуниции, все остальные части изготавливаются пропорционально размеру пружины. Несмотря на все различия, эти орудия используются с навыком Арбалет. Также как у полноразмерных баллист, у них узкое окно видимости, таким образом, использующий подвержен всем ограничениям Прицеливания, описанным в Орудия прямого обстрела (стр 79-80).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 45 см - болт</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>4.62</value>
		<weight>0.14</weight>
		<reference>LT83</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 18" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 68 см</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>1600</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>3d imp</damage>
			<strength>17M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>220/275</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(10)</shots>
			<bulk>-9</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Scorpion, 27”
<img data-src="lib/img/151591643601.png">
Древняя баллиста метающая болты, а не камни. Была названа «скорпионом» за внешний вид и форму снарядов. Также как и метающая камни баллиста, это торсионный двух-плечевой механизм с низкой траекторией полета снаряда. Скорпионы различались по длине метаемых ими снарядов. 

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 68 см - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>16.5</value>
		<weight>0.5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 27" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 68 см - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>42</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Scorpion, 27” Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 90 см</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>4000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>4d imp</damage>
			<strength>21M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>240/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(15)</shots>
			<bulk>-10</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Scorpion, 36”
<img data-src="lib/img/151591643601.png">
Древняя баллиста метающая болты, а не камни. Была названа «скорпионом» за внешний вид и форму снарядов. Также как и метающая камни баллиста, это торсионный двух-плечевой механизм с низкой траекторией полета снаряда. Скорпионы различались по длине метаемых ими снарядов. 

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 90 см  - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1700</value>
		<weight>67</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Scorpion, 36” Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>"Скорпион", 90 см - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>39.6</value>
		<weight>1.2</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Scorpion, 36" Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Monk's Spade</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>9†</strength>
			<usage>Swing Spade</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cut</damage>
			<strength>9†</strength>
			<usage>Thrust</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>9†</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Monk's Spade

<img data-src="http://weapons.gurps.ru/img/1836.png">

Китай. 
Древковое оружие с острой, лопатообразной головкой на одном конце, и лезвием в форме полумесяца на другом.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет военный</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>750</value>
		<weight>15</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>12†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(32)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Стальной арбалет (См LT78, заметка 6)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Military Crossbow
<img data-src="http://weapons.gurps.ru/img/1833.png">

Европа.

Был изобретен приблизительно в 1400 н.э. - очень поздний ТУ3 - но классифицируется как оружие раннего ТУ4. В полной мере использует преимущества высококачественной стали, известной в то время как "арбалетная сталь". К представителям относятся: АРБАЛЕТ ДЛЯ ДИЧИ, ОХОТНИЧИЙ АРБАЛЕТ, ВОЕННЫЙ АРБАЛЕТ и ОСАДНЫЙ АРБАЛЕТ (все на стр.72, Б276). Все они крепче чем стандартный АРБАЛЕТ; поэтому считайте их упрочненными (стр.14). Жесткость стали позволяет компактному луку, несмотря на небольшой размер, обладать большей СЛ(ST), однако короткое натяжение тетивы и больший вес делают его менее эффективным; используйте половину от полной СЛ(ST) для определения Дальности и Повреждений. (Например: осадный арбалет снабжен кранекином с множителем силы x3. Арбалетчик с СЛ(ST) 12 может взвести осадный арбалет с СЛ(ST) 36. Повреждения и Дальность рассчитываются от СЛ(ST) 36/2 = 18.)



Стальной арбалет (См LT78, заметка 6)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>4</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>7</strength>
			<usage>Fire Bolt</usage>
			<accuracy>1</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Pistol Crossbow
<img data-src="http://weapons.gurps.ru/img/1856.png">

Китай. 

АРБАЛЕТ (стр.72, Б276), достаточно маленький, чтобы его можно было использовать одной рукой. Может быть спрятан в рукаве или встроен в стремя (см. Сокрытие, стр.14).



Требует обеих рук для Подготовки, но только одной руки для атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет пистолетный - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.06</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Pistol Crossbow Dart
<img data-src="lib/img/151676767496.png">
</description-loc>
	</equipment><equipment version="3">
	<description>Арбалет самозарядный</description>
	<value>500</value>
	<weight>10</weight>
	<quantity>1</quantity>
	<ranged_weapon>
		<damage>thr+1 imp</damage>
		<strength>8†</strength>
		<accuracy>1</accuracy>
		<range>x7/x15</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>10(3i)</shots>
		<bulk>-5</bulk>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Crossbow</name>
			<modifier>0</modifier>
		</default>
		<usage>Fire Bolt</usage>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>2</tech_level>
	<categories>
		<category>Метательное оружие</category>
	</categories>
	<reference>LT73</reference>
	<description-loc>
		Repeating Crossbow
		<img data-src="http://weapons.gurps.ru/img/1881.png">
		<img data-src="http://weapons.gurps.ru/img/2030.png">
		Азия.

Китайский вариант АРБАЛЕТА (стр.72, Б276) с магазином, в который помещается 10 болтов. Из него стреляют, двигая рукоятку вперед и назад рукой; его расчетная СЛ(ST) не может превышать СЛ(ST) стрелка. Стрелок должен провести манёвр Подготовки перед каждым выстрелом, но может стрелять каждую вторую секунду. Известен в Китае как Чо-ко-ну или Жуге Ну.
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллистер</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>6</weight>
		<reference>LT73</reference>
		<ranged_weapon>
			<damage>thr+4 pi</damage>
			<strength>7†</strength>
			<usage>Fire Pellet</usage>
			<accuracy>2</accuracy>
			<range>x20/x25</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(4)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Prodd
<img data-src="http://weapons.gurps.ru/img/1864.png">

Европа, Средний Восток. 

Этот термин относится к АРБАЛЕТАМ (стр.72, Б276), которые стреляют не болтами, а свинцовыми дробинками. Такие арбалеты для охоты на птиц. Облегченный вариант баллистера называется шнеппером. Специальные баллистеры, заряжаемые примитивными гранатами с начинкой из нафты, использовались на Ближнем Востоке. У таких Точ 1 и Дальность -/х5, и они не могут стрелять дробинками. Эффект попадания см. в Коктейль Молотова и Сосуды с маслом (стр.Б411).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Баллистер - дробина</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.06</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Prodd Pellet
<img data-src="lib/img/151672076790.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Борец</description>
		<tech_level>0</tech_level>
		<legality_class>1</legality_class>
		<value>6</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Monkshood
<img data-src="lib/img/151669196759.png">
<img data-src="lib/img/151669198200.png">

Любое из растений рода Aconitum, также называемых “прострел-трава” или “волкобой”; активным ингредиентом является аконитин, который действует на нервную систему. Он может быть использован как пищевой яд или инъекционный яд. Как пищевой яд, он имеет пятиминутную задержку, после которой жертва чувствует покалывания на коже, языке и в горле, и должна сделать бросок ЗД(HT)-3 для сопротивления; он наносит 1d ядовитых повреждений, повторяющиеся с часовыми интервалами в течение шести циклов. Он также вызывает тошноту (стр. Б428) после первого проваленного броска, длящуюся до тех пор, пока действие яда не кончилось; через один час, это вызывает рвоту(стр. Б429), с броском против ЗД(HT)+1 для сопротивления. В качестве инъекционного яда, он имеет один час задержки и бросок ЗД(HT)-3 для сопротивления; он наносит 2d ядовитых повреждений, повторяющихся с часовыми интервалами в течение шести циклов. В любом случае, жертвы, которые теряет 1/3, 1/2 или 2/3 ЕЖ(HP) получает -2, -4, или -6 ЛВ(DX), соответственно. Когда жертва теряет полные ЕЖ(HP), у нее затрудняется дыхание; считайте жертву Очень неспортивной (стр. Б160) до тех пор, пока действие яда не прекратится. $6 за дозу. КЛ(LC)1.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бритва</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>18</value>
		<weight>0.2</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Razor
<img data-src="lib/img/151670130744.png">
Каменные лезвия использовались для стрижки волос уже в 30000 г. до н.э. Металлические лезвия для бритья, зачастую в форме полумесяца или овала, появились около 3000 до н.э. $18, 0.2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Бумажная бомба</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>100</value>
		<weight>5</weight>
		<reference>LT85</reference>
		<notes>Damage 5d cr ex заполняет 5-yd м дымом на 1 мин; броско HT-5 или штрф к слуху на 20-HT мин и оглушен.</notes>
		<categories>
			<category>Бомбы</category>
		</categories>
		<description-loc>Paper Bomb
<img data-src="lib/img/151669874005.png">
Еще одно Китайское изобретение начала 12 века, это огромная хлопушка: 3-4 фунта чёрного пороха завёрнуто в бумагу и обмотано бечевкой или засыпано внутрь бамбукового звена. Наносит 5d дроб. взрыв. (cr ex.) повреждений, и оставляет после себя дымовую завесу радиусом 5 ярдов, которая держится в течение одной минуты, даёт штраф -10 к проверкам Зрения и действует как лёгкий яд (стр.Б439). Взрыв издает очень громкий звук; каждый кто получает дробящие повреждения должен успешно выполнить проверку ЗД(HT)-5 или получить штраф к Слуху, равный величине провала, на (20 - ЗД(HT)) минут, но минимум на 1 минуту. Провал на 10+ или критический провал означает глухоту. Персонаж должен успешно выполнить проверку на восстановление от калечащего ранения, или получить длительную или постоянную Тугоухость или Глухоту. Любой провал первоначальной проверки ЗД(HT) означает также, что жертва оглушена; чтобы восстановиться, делайте проверку против ЗД(HT) каждый ход, до первого успеха. Ездовые животные, не приученные ко взрывам – и, по решению Мастера, сталкивающиеся с этим оружием в первый раз люди– должны выполнить Проверку Страха (стр.Б360). $100, 5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Весло</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>8</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>12‡</strength>
			<usage>Swung</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Oar
<img data-src="http://weapons.gurps.ru/img/1848.png">

Большое весло, может быть использовано в качестве подручного древкового оружия. Весла от маленьких лодок повсеместно использовались в качестве импровизированного оружия. Сюда же относятся ику (Окинава) и таяха (Маори).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Военный пистолет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>250</value>
		<weight>2.75</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>2d-1 pi+</damage>
			<strength>10</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>50/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Military Pistol
<img data-src="http://weapons.gurps.ru/img/1834.png">

С колесцовым замком

Большой, тяжёлый пистолет для кавалеристов. В бой берут по крайней мере два, позволяя сделать больше одного выстрела без проблемы перезарядки верхом.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Военный пистолет - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.8</value>
		<weight>0.04</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Military Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Воловья повозка</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>340</value>
		<weight>1800</weight>
		<reference>LT136</reference>
		<notes>Запрягается волами</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Oxcart
<img data-src="lib/img/151669248203.png">
<img data-src="lib/img/151669251470.png">

Один из древнейших видов хозяйственного транспорта, встречающийся на большей части Европы и Азии, где он использовался для доставки продуктов сельского хозяйства на рынок на протяжении тысячи лет. Два вола, запряженные вместе, тащат двухколесную повозку. Рядом идет погонщик, направляя волов; это по прежнему требует навыка Кучер, поскольку он управляет запряженными животными. Волы идут шагом, не больше пяти часов в день; это ограничивает расстояние, которое они могут пройти. 

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Втулка ювелирная золотая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>0.1</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Plug, gold
<img data-src="lib/img/151670007318.png">
Декоративная втулка, служит для растяжения прокола до больших размеров
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Втулка ювелирная медная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.05</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Plug, copper
<img data-src="lib/img/151670015493.png">
Декоративная втулка, служит для растяжения прокола до больших размеров
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Втулка ювелирная серебренная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>0.06</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Plug, silver
<img data-src="lib/img/151670006536.png">
Декоративная втулка, служит для растяжения прокола до больших размеров
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дощечка для разведения огня</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.5</weight>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Prepared Block
<img data-src="lib/img/151670033149.png">
Деревянное древко и дощечка с пропитанными смолой канавками. Использующий трёт концом древка вдоль канавки, производя трение. Базовое время для разведения огня: 3 минуты. $3, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Древковая секира</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>10</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw+4 cut</damage>
			<strength>12‡</strength>
			<usage>Blade Swing</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>12‡</strength>
			<usage>Hammer Swing</usage>
			<reach>2,3*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Poleaxe
<img data-src="http://weapons.gurps.ru/img/1858.png">

Европа. 

Большое лезвие топора с молоточным бойком на обухе, расположенное на длинном древке. Такая комбинация крайне редко использовалась в историчном оружии, если вообще использовалась - но для фэнтези это не помеха! Для более достоверного дуэльного оружия см. ПОЛЭКС (ниже); для более простых и коротких больших топоров, используйте ДВУРУЧНЫЙ ТОПОР (стр.70, Б274).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дротик на веревке</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>0.5</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw-1 cr</damage>
			<strength>5†</strength>
			<usage>Swing</usage>
			<reach>1-4</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5†</strength>
			<usage>Thrust</usage>
			<reach>1-4</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цеп и кусари происходят с штрафом -4; фехтовальное оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2. Уполовиньте этот штраф для бола перида, болас, нунчак, дубины на ремне и утяжеленного шарфа.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Rope Dart
<img data-src="http://weapons.gurps.ru/img/1883.png">

Китай.

Маленький метательный металлический дротик, один конец которого привязан к веревке. Это позволяет возвращать снаряд после метания. Дротик гладкий, в форме пули (без зазубрин) и поэтому не застревает в теле цели. Легкий, дальнего действия, и возвращаемый, дротик на веревке является полезным запасным оружием для кавалерии. Также известен как шен бяо (Китай).



Попытки парировать цеп и кусари происходят с штрафом -4; фехтовальное оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2. Уполовиньте этот штраф для бола перида, болас, нунчак, дубины на ремне и утяжеленного шарфа.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Зонд хирургический</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Probe, Surgical
<img data-src="lib/img/151670039245.png">
Длинный гибкий инструмент – обычно бронзовый – для нахождения инородных тел в ране или изучения внутреннего состояния тела на ощупь, уменьшая штрафы за работу с недиагностированными проблемами (см. Расширенные модификаторы, с.147). $10, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Игла хирургическая</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Needle, Surgical
<img data-src="lib/img/151669215013.png">
Для продевания шовного материала через ткани. Обычные швейные и кожевенные иглы считаются импровизированным снаряжением: -1 к умению Хирургии. $5, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кандалы железные</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>LT130</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Shackles, Iron
<img data-src="lib/img/151670469493.png">
Это работает, как и веревочные узы (выше), с небольшими отличиями. Во-первых, кандалы из металла, и не могут быть разорваны обычной человеческой силой - их предельная нагрузка - 1000 фунтов. Кроме того, они заперты или закованы, поэтому они не могут быть развязаны. Если они имеют замок, он может быть открыт с помощью ключа или использованием умения Взлом с обычным модификатором замка, с дополнительной -3 если вы пытаетесь взломать свои собственные кандалы. Если они закованы, их можно открыть только с помощью кузнечных инструментов, . Наконец, возможно выскользнуть из пут неизмененным броском Побега. СП(DR) 4, ЕЖ(HP). 10. $50, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ "стрела", 9м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>6000</value>
		<weight>5900</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Outrigger Canoe, 30’
<img data-src="lib/img/151669235308.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карманный пистолет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>190</value>
		<weight>0.7</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d pi</damage>
			<strength>6</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>25/300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Pocket Pistol
<img data-src="http://weapons.gurps.ru/img/1857.png">

С колесцовым замком

Маленький пистолет с очень коротким стволом - лишь чуть больше 4 дюймов - рассчитанный на то, чтобы его прятать под одеждой. Боязнь покушений часто приводит к законодательным ограничениям на такое оружие скрытного ношения.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Карманный пистолет - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.16</value>
		<weight>0.008</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Pocket Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Квадрен</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>2</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>thr+1(0.5) imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>C,1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Maine-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Quadrens
<img data-src="http://weapons.gurps.ru/img/1871.png">

Древний Рим.

Очень необычный гладиаторский "кинжал". Свидетельства об использовании этого оружия весьма размыты. Вместо одного клинка у него было четыре тонких штыка, расположенных в форме квадрата. Используется при помощи навыка Джитте/Сай, может разоружать как джитте (стр.57).

Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Киан Кун Ри Йу Дао</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>3</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<usage>Hilt Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>7†</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>7†</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<strength>7†</strength>
			<usage>Cut</usage>
			<reach>1</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<notes>Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки. -1 к попаданию</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Qian Kun Ri Yue Dao
<img data-src="http://weapons.gurps.ru/img/1867.png">

Китай. 

"Меч неба и земли, солнца и луны" 4-5 футовый металлический брусок с серпообразными лезвиями на обоих концах. Использующий держит два таких меча крестообразно, держа ладони внутри предохранительной скобы, закрытой лезвием в форме полумесяца. Он может резать и колоть одним концом, "бить" в ближнем бою, или использовать оба конца для атаки двумя оружиями, против оппонентов стоящих в двух смежных гесах. Атаки этим сложным оружием производятся со штрафом -1.


Удар эфесом  по DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.

-1 к попаданию</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кинжал рондель</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Rondel Dagger
<img data-src="http://weapons.gurps.ru/img/1882.png">

Европа. 

Тяжелый кинжал с двумя широкими дисками на рукояти и гарде. Такое строение позволяет наносить точные удары любой рукой, и убирает штраф -2 за прицеливание в уязвимые места брони (стр.Б400). В случае если на руках использующего надеты рукавицы (любые с СП(DR) 4+), диски надежно фиксируют оружие, давая +2 к сопротивлению Разоружению (в случае использования ГУРПС Боевые Искусства, кинжал должен удерживаться в Обратном Хвате).



Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Клевец</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>70</value>
		<weight>3</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw+1 imp</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Pick
<img data-src="http://weapons.gurps.ru/img/1854.png">

Одноручная боевая дубина с клювообразным лезвием, закрепленным на рукояти под прямым углом. Предназначен для пробивания доспехов; узкий наконечник убирает штраф -2 за удары в уязвимые места брони (стр.Б400). Также известен как загнал (Индия). Мартель-де-фер (Франция) является клевцом с молотком на обухе.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кольцо золотое</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4000</value>
		<weight>0.2</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Ring, gold
<img data-src="lib/img/151670138364.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кольцо медное</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.1</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Ring, copper
<img data-src="lib/img/151670136917.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кольцо серебренное</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>0.12</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Ring, silver
<img data-src="lib/img/151670140493.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 2 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>14000</value>
		<weight>1000</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>6dx3 pi++</damage>
			<strength>40M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>270/2,300</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-12</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 2 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ship's  Gun, 4-lb.
<img data-src="lib/img/151670474436.png">
Классическая пушка используемая пиратским кораблем около Испанского Побережья Америки. Экземпляры представленные в таблице разнятся по размеру: 42-фунтовая пушка-семерка, 18-фунтовая кулеврина, 9-фунтовая полу-кулеврина, и 4-фунтовый миньон. Длинна ствола 9-10 футов для трёх больших размеров, и 7 футов для миньона. 

Требуется команда 2 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 2 кг - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>590</value>
		<weight>1250</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ship’s  Gun, 4-lb. Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 21 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>100000</value>
		<weight>7300</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>6dx5 pi++</damage>
			<strength>75M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>380/2,800</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(90)</shots>
			<bulk>-16</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 11 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ship's  Gun
<img data-src="lib/img/151670474436.png">
Классическая пушка используемая пиратским кораблем около Испанского Побережья Америки. Экземпляры представленные в таблице разнятся по размеру: 42-фунтовая пушка-семерка, 18-фунтовая кулеврина, 9-фунтовая полу-кулеврина, и 4-фунтовый миньон. Длинна ствола 9-10 футов для трёх больших размеров, и 7 футов для миньона. 

Требуется команда 11 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 21 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1200</value>
		<weight>60</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ship's Gun,42-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 4 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>7.5</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ship's Gun,4-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 4.5 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>39000</value>
		<weight>2900</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>6dx4 pi++</damage>
			<strength>50M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>310/2,400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-14</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 4 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ship's  Gun
<img data-src="lib/img/151670474436.png">
Классическая пушка используемая пиратским кораблем около Испанского Побережья Америки. Экземпляры представленные в таблице разнятся по размеру: 42-фунтовая пушка-семерка, 18-фунтовая кулеврина, 9-фунтовая полу-кулеврина, и 4-фунтовый миньон. Длинна ствола 9-10 футов для трёх больших размеров, и 7 футов для миньона. 

Требуется команда 4 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 4.5 кг - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>770</value>
		<weight>3600</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ship’s  Gun, 9-lb. Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 4.5 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>330</value>
		<weight>16.5</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ship's Gun,9-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 9 кг</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>65000</value>
		<weight>5000</weight>
		<reference>LT89</reference>
		<ranged_weapon>
			<damage>7dx4 pi++</damage>
			<strength>60M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>340/2,600</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(70)</shots>
			<bulk>-15</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 6 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Ship's  Gun
<img data-src="lib/img/151670474436.png">
Классическая пушка используемая пиратским кораблем около Испанского Побережья Америки. Экземпляры представленные в таблице разнятся по размеру: 42-фунтовая пушка-семерка, 18-фунтовая кулеврина, 9-фунтовая полу-кулеврина, и 4-фунтовый миньон. Длинна ствола 9-10 футов для трёх больших размеров, и 7 футов для миньона. 

Требуется команда 6 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 9 кг - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>560</value>
		<weight>28</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Ship's Gun,18-lb. Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Коса</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>5</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>11‡</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 imp</damage>
			<strength>11‡</strength>
			<usage>Point Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<strength>11‡</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Может застрять; см Кирки (стр.Б405). Позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Scythe
<img data-src="http://weapons.gurps.ru/img/1901.png">

Двуручный рубящий инструмент, используемый для покоса злаков и сена. Как оружие используется редко, однако боевые версии все-таки существуют. К ним относятся огама (Япония) и двуручные версии фалькса (Дакия).



Может застрять; см Кирки (стр.Б405).

Позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Круглая лодка из шкур 1.5м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>280</value>
		<weight>2600</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Round Hide Boat, 5’
<img data-src="lib/img/151670158466.png">
Лодка круглой формы сделанная из шкур, обёрнутых вокруг деревянного каркаса. К этому виду можно отнести бычьи лодки индейцев Равнин или бамбуковые парикалы южной Индии. Монголы использовали похожие лодки, которые в Китае назывались "пи". Используйте те же характеристики для древних месопотамских куффа (ТУ1), сплетённых из лозы и покрытых слоем смолы. Лодка, представленная в таблице, имеет 5 футов в диаметре.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лодка из сшитых досок</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>1400</value>
		<weight>4400</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Sewn-Plank Sailboat
<img data-src="lib/img/151670463601.png">
Такие традиционно использовались в Индийском океане, длинные доски связанны вместе, также конструкция может включать в себя небольшой каркас. Гибкий корпус является преимуществом во время использования судна в прибрежных водах. На единственной мачте устанавливается большой треугольный парус, эффективный во время движения против ветра; он слишком тяжел для поворота на другой галс и вместо этого полагается на повороты через фордевинд (см. Движение против ветра, с.141). При длине 22 фута и ширине 5 футов, это судно является относительно небольшим и может использоваться для рыбной ловли или коротких путешествий.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лодка из шкур продолговатая 1.5м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>85</value>
		<weight>360</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Oblong Hide Boat, 5’
<img data-src="lib/img/151669221531.png">
По сравнению с ирландским кораклом эта лодка достаточно круглая, однако её длина превышает ширину. Используйте те же характеристики для вьетнамских рыбацких лодок сделанных из бамбуковых ковриков и обработанных смолой. Типичные габариты - длина 5 футов, ширина составляет 2/3 от длины. Перемещается при помощи гребли.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лом 50 см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>2</weight>
		<reference>LT126</reference>
		<categories>
			<category>Воровской инструмент</category>
		</categories>
		<description-loc>Pry-Bar, Small
<img data-src="lib/img/151670046826.png">
30-дюймовый (75 см.) лом (-4 к Утаиванию), меньший, чем упомянутый в Горном деле и Прокладке тоннелей (стр. 30), предназначенный для выбивания дверей и сбивания навесных замков. Он дает +2 к СЛ(ST) для открывания запертых дверей при Проникновении со взломом (стр. 122). Считайте маленькой булавой в бою. $80, 5 фунтов.

Ещё более маленький 20-дюймовый (50 см.) лом легче спрятать (-2 к Утаиванию), но он менее эффективен (+1 к СЛ(ST)). Считайте легкой дубинкой в бою. $60, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лом 75 см</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>5</weight>
		<reference>LT126</reference>
		<categories>
			<category>Воровской инструмент</category>
		</categories>
		<description-loc>Pry-Bar
<img data-src="lib/img/151670048882.png">
30-дюймовый (75 см.) лом (-4 к Утаиванию), меньший, чем упомянутый в Горном деле и Прокладке тоннелей (стр. 30), предназначенный для выбивания дверей и сбивания навесных замков. Он дает +2 к СЛ(ST) для открывания запертых дверей при Проникновении со взломом (стр. 122). Считайте маленькой булавой в бою. $80, 5 фунтов.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук обычный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>2</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+1 imp</damage>
			<strength>10†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Regular Bow
<img data-src="http://weapons.gurps.ru/img/1880.png">

ЛУК (стр.72, Б275) целиком из дерева. КОРОТКИЙ ЛУК (стр.76) можно сделать практически из любой достаточно удобной ветки, хотя особой силой он отличаться не будет, это наиболее ранний вид луков. ОБЫЧНЫЙ ЛУК (стр.76) длиннее и мощнее. ДЛИННЫЙ ЛУК (стр.76) - знаменитое оружие английских лучников - вершина технологии изготовления не-составных луков, длинною как минимум 6 футов. Лучшие из длинных луков делаются из тиса, естественные физические свойства которого очень схожи с составными материалами.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук составной выгнутый</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>2.25</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<usage>Shoot</usage>
			<accuracy>3</accuracy>
			<range>x20/x25</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Reflex Bow
<img data-src="http://weapons.gurps.ru/img/1879.png">

ЛУК (выше; стр.Б275), сделанный из нескольких слоев различных материалов, склеенных между собой. Это значительно увеличивает силу натяжения и количество запасаемой энергии, позволяя составному луку при натяжении сгибаться сильнее, чем простому того же размера (стр.73), не ломаясь.  (стр.76) по форме напоминает простой. Изогнутый лук имеет естественный обратный изгиб возле концов плечей, из-за чего натянутая на лук тетива находится под большим напряжением. Натягивание лука против этого напряжения позволяет накапливать больше энергии, что дает луку увеличенную дальность стрельбы и больший урон. В ВЫГНУТОМ ЛУКЕ (стр.76) этот механизм доведен до совершенства; когда тетива снята, плечи лука целиком выгибаются в противоположном от лучника направлении. Большинство составных луков изогнутые или выгнутые. Типичный вариант обладает той же силой что и ДЛИННЫЙ ЛУК (стр.73), но не такой громоздкий, что делает его удобным оружием для колесничих и всадников. Сюда же относится дай-кю (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мирмекс</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.25</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<notes>Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>1</amount>
		</dr_bonus>
		<description-loc>Myrmex
<img data-src="http://weapons.gurps.ru/img/1842.png">

Древняя Греция. Кожаные обмотки для рук с острыми лезвиями, наносящими порезы во время ударов руками. Дает СП(DR) 1 кистям рук - но также Плохую Хватку 1 (стр.Б123).



Атаки получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мистер Двусторонняя Ручница</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>370</value>
		<weight>10.8</weight>
		<reference>LT91</reference>
		<ranged_weapon>
			<damage>2d+1 pi++</damage>
			<strength>9†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>55/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>2(30i)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes></notes>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Mr. Facing-Both-Ways Gonne
<img data-src="http://weapons.gurps.ru/img/1840.png">

Китайская ручница со стволом на каждой стороне длинного шеста, который можно перевернуть (манёвр Подготовки), чтобы сделать второй выстрел. Дополнительный вес и размер делают её неуклюжей, но повышенный вес также уменьшает ощущаемую отдачу.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Монанкон</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>95000</value>
		<weight>3800</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>12d-1 cr</damage>
			<strength>138M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>1</accuracy>
			<range>440/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-15/-20</bulk>
			<recoil>2</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Требуется персонал 2 человека. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Monankon
<img data-src="lib/img/151669193709.png">
Конструкция проще чем у баллисты - состоит из одного плеча, одной торсионной пружины, без каната; к концу плеча приделана котомка пращи. Плечо переходит из горизонтального положения в вертикальное, ударяется в подушку и останавливается, запуская снаряд. Поздние римские версии были прозваны «онагр», поскольку отдача у этого оружия была соизмерима с ляганием дикого осла.



Минимальное расстояние равняется 25% от максимального расстояния.

Требуется персонал 2 человека.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Монанкон - камень</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>15</value>
		<weight>15</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Monankon Stone
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Моргенштерн</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>6</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>12</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>-2</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Morningstar
<img data-src="http://weapons.gurps.ru/img/1839.png">

Европа. 

Одноручный цеп, состоящий из рукояти, при помощи цепи, соединенной с шипованной ударной головкой. Некоторые источники используют этот термин для БУЛАВЫ (стр.58, Б271) с шипованной ударной головкой.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мушкет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>175</value>
		<weight>21</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>4d+2 pi++</damage>
			<strength>12R†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>120/1,200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Musket
<img data-src="http://weapons.gurps.ru/img/1841.png">
<img data-src="http://weapons.gurps.ru/img/2038.png">

С фитильным замком

Более крупное гладкоствольное ружьё с очень длинным стволом, стишком тяжёлое, чтобы его держать ровно без помощи. Мушкетёру нужна мушкетная сошка (стр. 96), чтобы эффективно использовать своё оружие; см. СЛ(ST) (Сила) (стр. Б270). Мушкетёры должны быть большими и сильными, чтобы управляться с этим мощным оружием. Название "мушкет" впоследствии стали использовать для обозначения гладкоствольных ружей вообще.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мушкет - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.15</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Musket Bullet
<img data-src="lib/img/151677127571.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мушкет - сошка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>2</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Musket Rest
<img data-src="lib/img/151677548043.png">
<img data-src="lib/img/151677550785.png">

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нагината</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>6</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>9†</strength>
			<usage>Polearm Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Polearm Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>9†</strength>
			<usage>Sword Swing</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Sword Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Naginata
<img data-src="http://weapons.gurps.ru/img/1843.png">

Япония.

Древковое оружие длиной с посох, с наконечником, похожим на меч. У нагамаки (Япония) и ромфая (Древняя Фракия) древко короче, а лезвие длиннее, но характеристики можно использовать те же. Сюда же относятся клинковые варианты нгао (Тайланд). </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нафта</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>1</weight>
		<reference>LT84</reference>
		<notes>За 0.5л; легковоспламеняема  (B433) горит 10d seconds; считайте маслом (p. B288)</notes>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Naphtha
<img data-src="lib/img/151669207119.png">
<img data-src="lib/img/151669210173.png">

Ближневосточные алхимики разработали метод перегонки сырой нефти, в результате которого получалось вещество, называемое нафт. Считайте её эквивалентом масла (стр.Б288). Наносит такие же повреждения, как и ранние смоляные смеси, но очень легковоспламеняема (см. Заставляем предметы гореть стр. Б433) и продолжает гореть в течение 10к секунд. $2, 1 фунт, за каждую пинту.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нунчаки</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>-1</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Nunchaku
<img data-src="http://weapons.gurps.ru/img/1847.png">

Окинава.

Цеп состоящий из двух деревянных палочек, соединенных цепью или шнуром, длина может быть разной, но обычно короткая. Иногда используется парно. Сюда же относятся санг-жил-бонг(Корея).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палица</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>5</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>12</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cr</damage>
			<strength>12</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Round Mace
<img data-src="http://weapons.gurps.ru/img/1885.png">

Любая несбалансированная одноручная боевая дубина с массивной каменной, деревянной или металлической дробящей головкой. Хотя гладкая ПАЛИЦА (стр.65, 70) и является древней, современные мастера боевых искусств все еще используют "арбузные молоты" и похожее оружие - иногда даже парно. Стандартная БУЛАВА (стр.65, 70, 77, Б271, Б276), с "перьями" (как пернач или шестопер) или шипами (см. МОРГЕНШТЕРН), для ударов сквозь латы, является классическим примером оружия средневековой Европы. Оба варианта представляют из себя булавы большого размера, с рукоятями, достаточно длинными для комфортного двуручного использования; используйте характеристики из раздела Двуручный Топор/Булава, которые изменяются во время использования оружия в Защитном хвате, описанном в GURPS Боевые Искусства. Тем не менее, большинство исторических экземпляров были меньше и легче: МАЛЕНЬКАЯ ПАЛИЦА (стр.65, 77) и МАЛЕНЬКАЯ БУЛАВА (стр.65, 77, Б271, Б276). Метательная булава является смертоносным снарядом; атакующий подбрасывает её в воздух, а не кидает по прямой траектории.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Парфюмерия дешевая, за одно применение</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.01</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Perfume, Cheap, per application
<img data-src="lib/img/151669891720.png">
Парфюмерию изначально сжигали или держали при себе, а не наносили. Благовония сжигались в Месопотамии и Египте уже в 3500 году до н.э.; примерно в это же время в Китае появился мускус. К 1000 году до н.э. ароматические масла применялись в личной гигиене. Древняя парфюмерия широко применяла ароматическую древесину и её смолу, а также специи вроде кассии (родственницы корицы). По мере развития химических методик создания экстрактов (см. Травяные экстракты, стр. 151-152), их стали использовать не только для лекарств, но и для запахов. Хотя египтяне и работали с некоторыми видами цветочной парфюмерии, цветы стали основным источником душистых веществ только на ТУ3, когда отладили технологию дистилляции.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Парфюмерия дорогая, за одно применение</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.01</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Perfume, Expensive, per application
<img data-src="lib/img/151669890265.png">
Парфюмерию изначально сжигали или держали при себе, а не наносили. Благовония сжигались в Месопотамии и Египте уже в 3500 году до н.э.; примерно в это же время в Китае появился мускус. К 1000 году до н.э. ароматические масла применялись в личной гигиене. Древняя парфюмерия широко применяла ароматическую древесину и её смолу, а также специи вроде кассии (родственницы корицы). По мере развития химических методик создания экстрактов (см. Травяные экстракты, стр. 151-152), их стали использовать не только для лекарств, но и для запахов. Хотя египтяне и работали с некоторыми видами цветочной парфюмерии, цветы стали основным источником душистых веществ только на ТУ3, когда отладили технологию дистилляции.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пата</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>3.75</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Pata
<img data-src="http://weapons.gurps.ru/img/1849.png">

Индия. 

КАТАР размером с широкий меч, обычно используется всадниками. У этого оружия имеется бронированная перчатка для зашиты руки. Действует как закрытый эфес с СП(DR) 4, и делает невозможным ношение на этой руке дополнительной металлической перчатки. Пата слишком длинная чтобы эффективно использовать её для парирования при помощи навыков безоружного боя. Короткие версии этого оружия можете считать КАТАРОМ с закрытым эфесом (см. GURPS Low-Tech Companion 2)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пемза</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.5</weight>
		<reference>LT47</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Pumice
<img data-src="lib/img/151670063693.png">
Лёгкий вулканический камень, который использовали вместо стирательной резинки. $3, 0,5 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пергамент, за лист</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>0.6</value>
		<weight>0.05</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Parchment, per sheet
<img data-src="lib/img/151669882332.png">
Очень тонкие шкуры (обычно овцы или козы) можно выскоблить начисто или обработать с известью, чтобы удались волос, не царапая шкуру. Пергамент впервые использовали в Анатолии не позже второго века до н.э. В средневековье он стал основным материалом для письма в умеренных широтах Европы. В отличие от кожи, пергамент не дубили, поэтому он оставался белым. Особенно качественный пергамент называли велень (лат. vellum), но производили так же. Наиболее ценный велень изготавливался из кожи ещё не рождённых телят — она тонка, лишена шерсти и достаточно велика, чтобы оправдать хлопоты.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перья дешевые</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>0.25</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Quill, Cheap
<img data-src="lib/img/151670085121.png">
Это трубка с тонкой щелью и небольшой полостью у кончика, в которой держатся чернила. На ТУ1 ручки делаются обычно из тростника; металлические ручки появились на ТУ2, а из птичьих перьев - на ТУ3. Тростниковая ручка или дешевое перо, годная на 20 страниц: $0.25, вес незначителен. Качественное перо, которое можно через 20 страниц заточить, и написать целых 100 страниц: $0.75, незн. Металлическая ручка, которая не изнашивается: $4, незн.

</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Перья дорогие</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>0.75</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Quill, Fine
<img data-src="lib/img/151670079043.png">
Это трубка с тонкой щелью и небольшой полостью у кончика, в которой держатся чернила. На ТУ1 ручки делаются обычно из тростника; металлические ручки появились на ТУ2, а из птичьих перьев - на ТУ3. Тростниковая ручка или дешевое перо, годная на 20 страниц: $0.25, вес незначителен. Качественное перо, которое можно через 20 страниц заточить, и написать целых 100 страниц: $0.75, незн. Металлическая ручка, которая не изнашивается: $4, незн.

</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Песочные часы</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>3</weight>
		<reference>LT45</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Sandglass
<img data-src="lib/img/151670293016.png">
Самое старое упоминание этого устройства - картина Амброджо Лоренцетти, датированная 1338 годом. Песочные часы состоят из двух стеклянных сосудов, соединённых узким горлышком, через которое сыпется сыпучий материал с постоянной скоростью. Несмотря на название, обычный песок не подходит; лучше работает мелкая мраморная пыль. Песочные часы не боятся морских условий, и поэтому использовались в навигации (стр. 50-52) и чтобы настраивать наручные часы. Стандартные песочные часы на пол-часа: 50$, 3 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петарда</description>
		<tech_level>4</tech_level>
		<legality_class>3</legality_class>
		<value>250</value>
		<weight>15</weight>
		<reference>LT86</reference>
		<notes>Damage 15d cr</notes>
		<categories>
			<category>Бомбы</category>
		</categories>
		<description-loc>Petard
<img data-src="lib/img/151669896082.png">
Изобретение эпохи Возрождения, предназначенное для штурма прочных дверей или ворот. Имя является грубой военной шуткой, происходит от Французского peter – «пукать». Состоит из железного котелка, в который помещается 5 фунтов чёрного пороха, и деревянной доски (благодаря ей, бомбу можно прибить гвоздями к взламываемому объекту). Бросьте 15d дробящего урона во время взрыва и сравните результат с СП(DR) и ЕЖ(HP) цели. $250, 15 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петриналь</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>280</value>
		<weight>7.75</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>2d+2 pi+</damage>
			<strength>11</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>60/630</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Petronel
<img data-src="http://weapons.gurps.ru/img/1853.png">

С колесцовым замком

Кавалерийское оружие 16ого века с рукоятью наподобие пистолетной, использовавшееся, упирая рукоять в нагрудник кирасы, и часто удерживаемое двумя руками. Ствол длиной 40 дюймов, сравнимой с таковой у карабина; перезарядка занимает соответственно большое время.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петриналь - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.8</value>
		<weight>0.04</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Petronel Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 2.5кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>18000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>5d+2 cr</damage>
			<strength>60M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>250/315</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-12</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Petrobolos, 5-lb.
<img data-src="lib/img/151669932950.png">
Ранний вариант флексионного механизма для метания камней, также назывался литоболой или петроболой. В таблице представлены два варианта - лёгкий и тяжелый.



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 2.5кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>5</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Petrobolos, 5-lb Stone
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 2.5кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>4100</value>
		<weight>165</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Petrobolos, 5-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 20кг</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>165000</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>11d cr</damage>
			<strength>180M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>4</accuracy>
			<range>330/415</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-16</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется персонал 2 человека. Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Petrobolos, 40-lb.
<img data-src="lib/img/151669932950.png">
Ранний вариант флексионного механизма для метания камней, также назывался литоболой или петроболой. В таблице представлены два варианта - лёгкий и тяжелый.



Требуется персонал 2 человека

Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83).</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 20кг - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>40</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Petrobolos, 40-lb Stone
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Петроболос 20кг - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20000</value>
		<weight>800</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Petrobolos, 40-lb. Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пика</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>13</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>4, 5*</reach>
			<parry>0U / 0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Pike
<img data-src="http://weapons.gurps.ru/img/1855.png">

Древняя Греция, Европа. 

Очень длинное копье, предназначенное для использования воинами в строю. В списке оружия представлена пика длинною около пяти ярдов; также доступны более короткие или более длинные варианты: 4-ярдовая пика : Дос. 3, 4*, Вес 10 фунтов, СЛ(ST) 11†; 6-ярдовая пика : Дос. 5, 6*, Вес 15 фунтов, СЛ(ST) 13†. Считайте пику от 3 ярдов и короче - ДЛИННЫМ КОПЬЕМ или КОПЬЕМ (стр. 69, Б273). Сюда же относятся нагаэ-яри (Япония) и сарисса (Македония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет королевы Анны</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>135</value>
		<weight>2.4</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d+2 pi+</damage>
			<strength>9</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>45/490</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Queen Anne Pistol
<img data-src="http://weapons.gurps.ru/img/1876.png">

С кремнёвым замком

Узнаваемая модель пистолета времён правления английской королевы Анны (1702-1714), популярная среди пиратов. 8-дюймовый ствол "медный" (то есть из литой бронзы), и привинчивается к обьединённому прикладу и рукояти. Чтобы перезарядить, ствол нужно открутить, но это позволяет использовать пули с минимальным сопротивлением воздуха, увеличивая точность.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет королевы Анны - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.6</value>
		<weight>0.03</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Queen Anne Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет-пуффер</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>260</value>
		<weight>2</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>2d-1 pi+</damage>
			<strength>9</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>50/550</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Puffer Pistol
<img data-src="http://weapons.gurps.ru/img/1866.png">

С колесцовым замком

Более лёгкий пистолет, чем военный, с заметно более коротким стволом несколько меньшего диаметра, который можно заткнуть за пояс. Модель "пуффер" имела узнаваемый увеличенный набалдашник на конце рукояти, давая +1 к Быстрому Выхватыванию (Пистолет). Также называется "даг" на Британских островах.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет-пуффер - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.7</value>
		<weight>0.035</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Puffer Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плот бревенчатый 1.2м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>95</value>
		<weight>580</weight>
		<reference>LT138</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Raft, 4" Logs
<img data-src="lib/img/151670106976.png">
Плот состоит из плавучих материалов связанных вместе веревками или ремнями. Результатом является плоская плавучая платформа на которой могут стоять пассажиры. Отдельные плоты могут быть цельными или с полостями, во всяком случае их плавучесть обеспечивается за счёт малого веса, у них нет внутреннего пространства. 

Поверхность плота колышется на волнах или от перекосов при распределении груза. Для того чтобы перемещаться по плоту делайте проверку DX -4, или DX -2 чтобы просто стоять на месте. Плот сделанный из брёвен или любых других длинных предметов раскачивается только в одной плоскости; в этом случае уполовиньте штраф. Плот элементы которого надёжно скреплены деревянными перемычками, втулками или связаны очень прочными шнуром требует проверок только в боевой ситуации (уполовиньте штраф, в случае если плот сделан из длинных предметов); делайте проверки баланса только в случае если плот раскачивается полностью, из-за колебаний воды или больших волн, используйте немодифицированную DX. Преимущество Идеальный баланс даёт +6 ко всем проверкам.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плот бревенчатый 2м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>140</value>
		<weight>960</weight>
		<reference>LT138</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Raft, 7" Logs
<img data-src="lib/img/151670106976.png">

Плот состоит из плавучих материалов связанных вместе веревками или ремнями. Результатом является плоская плавучая платформа на которой могут стоять пассажиры. Отдельные плоты могут быть цельными или с полостями, во всяком случае их плавучесть обеспечивается за счёт малого веса, у них нет внутреннего пространства. 

Поверхность плота колышется на волнах или от перекосов при распределении груза. Для того чтобы перемещаться по плоту делайте проверку DX -4, или DX -2 чтобы просто стоять на месте. Плот сделанный из брёвен или любых других длинных предметов раскачивается только в одной плоскости; в этом случае уполовиньте штраф. Плот элементы которого надёжно скреплены деревянными перемычками, втулками или связаны очень прочными шнуром требует проверок только в боевой ситуации (уполовиньте штраф, в случае если плот сделан из длинных предметов); делайте проверки баланса только в случае если плот раскачивается полностью, из-за колебаний воды или больших волн, используйте немодифицированную DX. Преимущество Идеальный баланс даёт +6 ко всем проверкам.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плот бревенчатый 3.5м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>240</value>
		<weight>1760</weight>
		<reference>LT138</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Raft, 12" Logs
<img data-src="lib/img/151670106976.png">

Плот состоит из плавучих материалов связанных вместе веревками или ремнями. Результатом является плоская плавучая платформа на которой могут стоять пассажиры. Отдельные плоты могут быть цельными или с полостями, во всяком случае их плавучесть обеспечивается за счёт малого веса, у них нет внутреннего пространства. 

Поверхность плота колышется на волнах или от перекосов при распределении груза. Для того чтобы перемещаться по плоту делайте проверку DX -4, или DX -2 чтобы просто стоять на месте. Плот сделанный из брёвен или любых других длинных предметов раскачивается только в одной плоскости; в этом случае уполовиньте штраф. Плот элементы которого надёжно скреплены деревянными перемычками, втулками или связаны очень прочными шнуром требует проверок только в боевой ситуации (уполовиньте штраф, в случае если плот сделан из длинных предметов); делайте проверки баланса только в случае если плот раскачивается полностью, из-за колебаний воды или больших волн, используйте немодифицированную DX. Преимущество Идеальный баланс даёт +6 ко всем проверкам.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плот бревенчатый 3м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>195</value>
		<weight>1360</weight>
		<reference>LT138</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Raft, 10" Logs
<img data-src="lib/img/151670106976.png">

Плот состоит из плавучих материалов связанных вместе веревками или ремнями. Результатом является плоская плавучая платформа на которой могут стоять пассажиры. Отдельные плоты могут быть цельными или с полостями, во всяком случае их плавучесть обеспечивается за счёт малого веса, у них нет внутреннего пространства. 

Поверхность плота колышется на волнах или от перекосов при распределении груза. Для того чтобы перемещаться по плоту делайте проверку DX -4, или DX -2 чтобы просто стоять на месте. Плот сделанный из брёвен или любых других длинных предметов раскачивается только в одной плоскости; в этом случае уполовиньте штраф. Плот элементы которого надёжно скреплены деревянными перемычками, втулками или связаны очень прочными шнуром требует проверок только в боевой ситуации (уполовиньте штраф, в случае если плот сделан из длинных предметов); делайте проверки баланса только в случае если плот раскачивается полностью, из-за колебаний воды или больших волн, используйте немодифицированную DX. Преимущество Идеальный баланс даёт +6 ко всем проверкам.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Плот тростниковый 2м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>330</value>
		<weight>1180</weight>
		<reference>LT138</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Raft, 6.5" Reeds
<img data-src="lib/img/151670110451.png">

Плот состоит из плавучих материалов связанных вместе веревками или ремнями. Результатом является плоская плавучая платформа на которой могут стоять пассажиры. Отдельные плоты могут быть цельными или с полостями, во всяком случае их плавучесть обеспечивается за счёт малого веса, у них нет внутреннего пространства. 

Поверхность плота колышется на волнах или от перекосов при распределении груза. Для того чтобы перемещаться по плоту делайте проверку DX -4, или DX -2 чтобы просто стоять на месте. Плот сделанный из брёвен или любых других длинных предметов раскачивается только в одной плоскости; в этом случае уполовиньте штраф. Плот элементы которого надёжно скреплены деревянными перемычками, втулками или связаны очень прочными шнуром требует проверок только в боевой ситуации (уполовиньте штраф, в случае если плот сделан из длинных предметов); делайте проверки баланса только в случае если плот раскачивается полностью, из-за колебаний воды или больших волн, используйте немодифицированную DX. Преимущество Идеальный баланс даёт +6 ко всем проверкам.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полиболос</description>
		<tech_level>2</tech_level>
		<legality_class>2</legality_class>
		<value>3500</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>3d imp</damage>
			<strength>17M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>310/385</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>20(2i)</shots>
			<bulk>-9</bulk>
			<recoil>1</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83). Между выстрадавшими необходимо выполнять маневр подготовки; 20 патронов расстреливается за 2 минуты.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Polybolos
<img data-src="lib/img/151670019140.png">
<img data-src="lib/img/151670020138.png">

«Автоматическое оружие» древнего мира, изобретено для стрельбы с максимально возможной скоростью, чтобы запугивать пехоту противника. Это торсионной механизм для стрельбы болтами, снабженный загрузочной камерой. Вращение рукояти натягивает тетиву, и управляет камерой, закладывающей болт из загрузочного устройства, после чего канат отпускается и болт выстреливается. Механизмы связаны между собой при помощи плоской цепи, как у велосипеда. Это самый древний пример использования камер и плоских цепей. Некоторые генералы древности неохотно использовали полиболос - они считали, что его скорострельность подталкивает солдат к излишнему расходу амуниции!</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полиболос - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>132</value>
		<weight>4</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Polybolos Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полиболос - тренога</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>42</weight>
		<reference>LT83</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Polybolos Tripod
<img data-src="lib/img/151677427256.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полэкс</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>10</weight>
		<reference>LT60</reference>
		<melee_weapon>
			<damage>sw+4 cr</damage>
			<strength>12†</strength>
			<usage>Axe Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>11†</strength>
			<usage>Spike Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 imp</damage>
			<strength>12†</strength>
			<usage>Spike Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Pollaxe
<img data-src="http://weapons.gurps.ru/img/1860.png">

Европа.

Дуэльное древковое оружие с головкой в форме лезвия топора или молота, молоточным бойком, штыком, шипованной рукоятью и усиленным металлом древком. Предназначенный для дуэлей между закованными в броню рыцарями, полэкс оптимизирован для использования Защитного Хвата, описанного в ГУРПС Боевые Искусства. Даже не разрешающий использовать защитный хват Мастер, имеющий книгу Боевые Искусства, должен разрешить его для этого оружия. В таблице представлено оружие с головкой в форме молотка; если поменять её на лезвие топора, оружие становится идентичным ДУЭЛЬНОЙ АЛЕБАРДЕ (стр.68). Не следует путать с ДРЕВКОВОЙ СЕКИРОЙ (стр.Б272). Сюда же относится бек де корбин (Франция).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Посох</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>4</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>7†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>7†</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>+2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>9†</strength>
			<usage>Sword Swing</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 cr</damage>
			<strength>9†</strength>
			<usage>Sword Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Quarterstaff
<img data-src="http://weapons.gurps.ru/img/1872.png">

Сбалансированный деревянный шест длиною от 1.5 до 2 метров, используемый обоими руками с хватом по центру. По всему миру его ценят за защитные качества и возможность наносить решающие удары во время сражении. Сюда относятся квотерстафф (Англия), бо (Япония), янг бонг (Корея), кеттуркари (Индия), пантиручан (Индия), бамбуковый плонг (Тайланд), рокушакубо (Окинава) и тоя (Индонезия). ГМ использующий ГУРПС Боевые Искусства может разрешить для этого оружия преимущества Парирования Двуручным Оружием (Боевые Искусства стр.123), даже если он не использует это правило. Солдат непременно учат драться посохом, для того чтобы они могли защитить себя в случае потери наконечника древкового оружия.  Drag ограничивает ударную силу длинного посоха, и требует Защитного Хвата описанного в Боевых Искусствах, для большей пользы в ближнем бою. </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Походный набор охотника-собирателя</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>210</value>
		<weight>40</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Pilgrim's Kit
<img data-src="lib/img/151669981797.png">
Сумка из шкуры животного или маленькая плетеная корзина, содержащая ядрище, с которого можно делать сколы; два булыжника-молотка; две кости или прямые палки длиной в фут; два маленьких керна из кости, рога или дерева; и несколько ярдов тонкого шнура. Если камень не кремень, добавьте две палочки для разведения огня. Многие из этих предметов могут использоваться для нескольких целей: из молотков можно делать каменные инструменты или колоть орехи и кости; длинную палку можно использовать для легкого копания или в качестве рукоятки, на которую можно укрепить микролиты и сделать серп или похожий режущий инструмент. $10, 5 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща - формованный камень</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.06</value>
		<weight>0.05</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Shaped Sling Stone
<img data-src="lib/img/151677150978.png ">
Камень подходящей формы для пращи стоит 
Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рабинет</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>4000</value>
		<weight>300</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>5d pi++</damage>
			<strength>29M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>90/850</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-9</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Rabinet

Ранние Европейские пушки (ТУ4)
<img data-src="lib/img/151670101881.png">
К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рабинет - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>430</value>
		<weight>375</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Rabinet Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рабинет - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>13</value>
		<weight>0.65</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Rabinet Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рапира</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>2.75</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>9</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Rapier
<img data-src="http://weapons.gurps.ru/img/1878.png">

Европа.

Длинный одноручный меч с жестким, узким лезвием, предназначенным для колющих ударов (но не для парирования, рапиристы часто носят с собой дополнительное оружие или плащ для защиты). Несмотря на ошибочные современные представления, рапира не является хрупкой или непрочной; она просто длиннее и уже режуще-колющих боевых мечей той же массы, являясь удобным гражданским оружием, предназначенным для сражений с одетыми в легкую броню противниками. Существует множество вариаций рапиры. ЛЁГКАЯ РАПИРА (стр.68) один из варианта оружия позднейших времен, на пути к МАЛОМУ МЕЧУ (ниже, стр.Б273). Ранние рапиры обычно были с острыми лезвиями и весили достаточно для нанесения рубящих ударов, этой же особенностью обладают и некоторые поздние клинки. Такое оружие именуется ШПАГА (стр.66, 68) и ЛЁГКАЯ ШПАГА(стр.68), соответственно.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Речная баржа 12м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>12000</value>
		<weight>8400</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>River Barge, 40'
<img data-src="lib/img/151670151710.png">
Довольно большое прямоугольное судно с плоским дном. Предназначено для транспортировки грузов вверх и вниз по течению реки, или с одного берега на другой. В сущности это большая открытая сверху коробка: длина 40 футов, ширина 7-5 футов и высота борта 1 фут, со слегка сужающимися носом и кормой. Во время передвижения по воде управляется четырьмя людьми с каждого борта; данные из таблицы подразумевают именно такой расклад. Для движения против течения такое судно необходимо тянуть.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ружьё Пакла</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>1800</value>
		<weight>90</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>2d+1 pi++</damage>
			<strength>18M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>55/510</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>9(10i)</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83). $380, 20 фунтов. Запасной цилиндр (пустой): $200, 10 фунтов.</notes>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Puckle Gun
<img data-src="http://weapons.gurps.ru/img/1865.png">

Одно из наиболее эксцентричных орудий 18ого века, Защитное Ружьё обычно называется по имени его изобретателя, Джеймса Пакла. Это оружие ставится на треножник, как с крепостное ружьё, но с кремнёвым замком. Для увеличения скорости стрельбы, у него есть цилиндр, содержащий боеприпасов на 9 выстрелов, поворачиваемый ручкой между выстрелами, чтобы подвести невыстреленные боеприпасы к стреляющему механизму. Обычно несколько цилиндров заготавливают заранее. Поменять старый цилинр на новый, заряженный, занимает 15 секунд. Оно было двух версий: одну предполагалось использовать против христиан, и стреляла она стандартными шарообразными пулями, а другую предполагалось использовать против турков, и стреляла она квадратными пулями!



Требуется съемная тренога; см. Таблицу Треножных Опор (стр.83). $380, 20 фунтов. 

Запасной цилиндр (пустой): $200, 10 фунтов.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ружьё Пакла - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>72</value>
		<weight>3.6</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Puckle Gun Bullet
<img data-src="lib/img/151676677384.png">
<img data-src="lib/img/151676673857.png"><img data-src="lib/img/151676675124.png">
Существовало два типа зарядов - круглые пули и квадратные

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Рукавицы</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>8</value>
		<weight>0.5</weight>
		<reference>LT98</reference>
		<notes>DR1 против cut</notes>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Mittens
<img data-src="lib/img/151669188082.png">
Самые первые рукавицы – просто мешки, укрывающие руки. Возможно, они делались из обрезков меха, связанных на запястьях. Самые первые изображения датируются серединой второго тысячелетия до н.э., и изображают двух минойских юношей, дерущихся в защитных рукавицах. Неясно, имели ли они отдельные большие пальцы, как это делается в современных. Рукавицы довольно неудобны, дают носителю Плохой захват 1 (с. B123) и Неуклюжие руки 2 (с. B138). (Броня для рук – латные рукавицы – дают Неуклюжие руки, но не Плохой захват.) Базовые рукавицы дают СП(DR) 1 от режущего вреда: $8, 0.5 фунта. Обладающие подкладкой боксерские перчатки (как в вышеуказанном примере) дают СП(DR) 1 против любого вреда: $20, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сабля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>700</value>
		<weight>2</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Saber
<img data-src="http://weapons.gurps.ru/img/1887.png">

Европа.

Легкий, одноручный фехтовальный меч, способный наносить рубящие и колющие удары. Сюда же относится краби (Тайланд).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сай</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>1.5</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr imp</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>7</strength>
			<usage>Thrown</usage>
			<accuracy>0</accuracy>
			<range>x0.8/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Sai
<img data-src="http://weapons.gurps.ru/img/1889.png">

Азия.

Трехконечное металлическое древко с одним длинным центральным шипом и парой коротких ответвлений, по боком. Оба сторонних шипа обычно выгнуты вперед, однако иногда один из них может смотреть назад (никакого игрового эффекта). Большинство саев обычно с острыми концами, но импровизированные могут быть тупыми. Похожее оружие существует по всей Азии; некоторые даже старше самого сая. Тюжа (Окинава) - маленький рыболовный трезубец, используемый одной рукой. Считайте что это сай с делителем брони 0.5.



Получает бонус +2 к разоружению когда используется вместе с навыком Дзитте/Сай; см.стр. Б208, Б401.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сакер</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>19000</value>
		<weight>1400</weight>
		<reference>LT88</reference>
		<ranged_weapon>
			<damage>15d pi++</damage>
			<strength>43M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>220/1,900</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-13</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требуется команда 3 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Saker

Ранние Европейские пушки (ТУ4)
<img data-src="lib/img/151670271866.png">
К раннему 16 веку, оружейники нашли способ создавать большое орудие из ресурсов, находящихся в их распоряжении: это была цельная бронзовая пушка, заряжаемая через дуло и стреляющая железными шарами. Эти орудия все еще использовали серпентин; ранний гранулированный порох был недостаточного качества и сгорал слишком быстро, что было небезопасно. Название «пушка» относится к одному определенному размеру; орудия прочих размеров называют иначе, часто поэтично. Распространенными размерами в Англии были рабинет, серпентина, фалконет, фалкон, миньон, сакер, кулеврина-бастард, полу-кулеврина, василиск, кулеврина, педреро, полу-пушка, пушка-бастард, пушка-серпентина, пушка и королевская пушка. Другие страны использовали собственные названия.

Требуется команда 3 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сакер - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>1750</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Saker Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сакер - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>10</weight>
		<reference>LT897</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Saker Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сампан 4.5м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1800</value>
		<weight>560</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Sampan, 15’
<img data-src="lib/img/151670287563.png">
Базовая конструкция судна для восточно-азиатских лодок и кораблей; лодка-плоскодонка, сделанная из доски-дна и двух досок-бортов. Типичные габариты: длинна 15 футов, ширина 4 фута, высота борта 1,5 фута. Спереди бортовые доски образуют стреловидный нос, а сзади угловатую корму. Это судно обладает одним выдающимся конструктивным решением, вероятнее всего навеянным строением бамбукового стебля: корпус поделен на несколько герметичных сегментов, в результате чего его тяжелее потопить. Двигать это судно при помощи одного кормового весла-юло; в спокойной воде можно использовать длинный шест.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Седло с подушками</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Saddle, Cushioned
<img data-src="lib/img/151670194122.png">
Изобретено скифами около 400 г. до н.э. Представляет из себя две подушки, по одной с каждого бока лошади, скреплённые деревянными дугами спереди и сзади. Лучше распределяет вес, что даёт лошади и всаднику +2 к основанным на ЗД(HT) проверкам на потерю ЕУ(FP). Также обеспечивает более устойчивую посадку, давая +1 к Верховой езде во время проверок на удержание в седле, и вполовину уменьшает штрафы от нагрузки во время Верховой езды (округлять вниз). Вместе с попоной: $100, 10 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Седло с рогами</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>20</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Saddle, Horned
<img data-src="lib/img/151670198801.png">
Использовавшееся Кельтами начиная с 100 г. до н.э., и принятое на вооружение Римской армией 300 лет спустя, седло с рогами представляет из себя жесткий каркас с четырьмя вертикальными выступами по углам. Это позволяет всаднику лучше держаться при помощи бёдер, даёт +3 Верховой езде во время проверок удерживания в седле; даже когда всадник теряет сознание, он остаётся в седле на 10 и менее при броске 3d6. Быстрое спешивание становится несколько проблематичным: -2 к проверке навыка при попытке спрыгнуть. Седло с выступами убирает штрафы от нагрузки во время Верховой езды, и даёт лошади и всаднику +2 основанным на ЗДпроверкам на потерю ЕУ(FP). Вместе с попоной: $200, 20 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Седло, боевое</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>30</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Saddle, War
<img data-src="lib/img/151670251585.png">
Это седло с высокой задней лукой, поддерживающей всадника. Оно дает все преимущества седла с рогами (выше), но не дает штрафов к спешиванию. С попоной:$250, 30 фунтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Седло, верховое
</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>15</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Saddle, Riding
<img data-src="lib/img/151670212095.png">
Использовалось Фракийцами около 300 г. до н.э. Стандартное седло с жёсткой основой, более устойчивое нежели седло с подушками, с небольшими луками спереди и сзади. Даёт +2 к проверкам Верховой езды когда требуется удержаться в седле, убирает штрафы к Верховой езде за нагрузку, даёт лошади и всаднику +2 к основанным на ЗД(HT) проверкам на потерю ЕУ(FP). Вместе с попоной: $150, 15 фунтов.
</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Седельные сумки</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>3</weight>
		<reference>LT134</reference>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">40 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Saddlebags
<img data-src="lib/img/151670268702.png">
Вмещают до 40 фунтов. $100, 3 фунта.
</description-loc>
	</equipment_container><equipment version="3">
	<quantity>1</quantity>
	<description>Агривский щит</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2093.png">

DB 2

DR 4

HP 20



+1 DB во время использования в щитовой стене.



Также называется "аспис" (по-гречески "щит") или (не столь корректно) "гоплон" (по-гречески "оружие"). Это специфический вариант среднего щита, оптимизированного для боя фалангой. Он круглый по форме, и столь сильно выпуклый, что край может опираться на плечо безо всякого наплечного ремня. Он сделан из дерева, покрыт кожей и иногда оббит бронзой. У него нет умбона; рука продевается через ремень в центре и держит рукоятку возле края. Только две трети щита защищают носителя. Оставшаяся треть выходит за его локоть, частично закрывая человека слева. Хоть они и среднего размера, перекрывающиеся агривские щиты идеально подходят для плотного строя, и дают ПЗ3, когда их используют в стене щитов. Но в бою один на один они дают лишь обычные ПЗ(DB) 2 среднего щита.

</description-loc>
	<tech_level>2</tech_level>
	<value>120</value>
	<weight>15</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Арбалет осадный</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>18</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>thr+5 imp</damage>
			<strength>14M†</strength>
			<usage>Fire Bolt</usage>
			<accuracy>4</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(50)</shots>
			<bulk>-10</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Стальной арбалет (См LT78, заметка 6)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Siege Crossbow
<img data-src="http://weapons.gurps.ru/img/1922.png">

Европа.

Был изобретен приблизительно в 1400 н.э. - очень поздний ТУ3 - но классифицируется как оружие раннего ТУ4. В полной мере использует преимущества высококачественной стали, известной в то время как "арбалетная сталь". К представителям относятся: АРБАЛЕТ ДЛЯ ДИЧИ, ОХОТНИЧИЙ АРБАЛЕТ, ВОЕННЫЙ АРБАЛЕТ и ОСАДНЫЙ АРБАЛЕТ (все на стр.72, Б276). Все они крепче чем стандартный АРБАЛЕТ; поэтому считайте их упрочненными (стр.14). Жесткость стали позволяет компактному луку, несмотря на небольшой размер, обладать большей СЛ(ST), однако короткое натяжение тетивы и больший вес делают его менее эффективным; используйте половину от полной СЛ(ST) для определения Дальности и Повреждений. (Например: осадный арбалет снабжен кранекином с множителем силы x3. Арбалетчик с СЛ(ST) 12 может взвести осадный арбалет с СЛ(ST) 36. Повреждения и Дальность рассчитываются от СЛ(ST) 36/2 = 18.)



Стальной арбалет (См LT78, заметка 6)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Боевой воз</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>6000</weight>
		<reference>LT136</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>War Wagon
<img data-src="lib/img/151671984423.png">
<img data-src="lib/img/151671992640.png">

Табор или боевой воз (возова градьба, в Чехии), разработанный Яном Жижкой во время восстания гуситов в начале 15 века, превращал воз в подобие бронетранспортера. Это средство передвижения тянули четыре упряжные лошади, а его прямоугольный корпус был 20 футов в длину. Его прочные деревянные борта были 3-4 фута в высоту, а поверх них устанавливались навесные планки с бойницами, обеспечивавшие прикрытие для стрелков из луков, арбалетов и ручниц; некоторые таборы имели дополнительные навесные планки, опускавшиеся вниз и не дававшие врагу залезть под воз. Обычно отряд состоял из десяти возов, которые выстраивались в квадрат, причем выступающие вперед передние колеса одного воза скреплялись цепью с задними колесами впередистоящего; лошади выпрягались и уводились в центр квадрата возницами. Со стороны табора, обращенной внутрь, могли быть двери для облегчения входа. Павезы (см. Передвижные укрытия) могли устанавливаться, что бы закрыть прогалы между возами.

В результате получалось передвижное укрепление, которое могло быть установлено в любом месте, д которого могли доехать возы. Стандартный экипаж табора включал в себя двух возниц, двух человек с ручницами, шестерых арбалетчиков, четверых воинов с цепами, четверых алебардистов и двоих держателей павез. Как боевой транспорт, табор имеет КЛ(LC)1, но его изобретатели, гуситы, были повстанцами и не заботились о законности!
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Восковая табличка, большая</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Wax Tablet, Large
<img data-src="lib/img/151672001204.png">
<img data-src="lib/img/151672002488.png">

Обычная для римских клерков поверхность. Очень мелкий ящик заполняется слоем воска, после чего на нем пишут стилом. При помощи петель можно соединить вместе несколько табличек. Небольшая табличка (5"*6"), вмещающая около 60 слов: $7, 0.2 ф. Большая табличка (8"*12"), содержащая около 200 слов: $20, 0.5 ф. Богачи используют таблички из кости, а не из дерева: +4 МЦ
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Восковая табличка, малая</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.2</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Wax Tablet, Small
<img data-src="lib/img/151672003411.png">
Обычная для римских клерков поверхность. Очень мелкий ящик заполняется слоем воска, после чего на нем пишут стилом. При помощи петель можно соединить вместе несколько табличек. Небольшая табличка (5"*6"), вмещающая около 60 слов: $7, 0.2 ф. Большая табличка (8"*12"), содержащая около 200 слов: $20, 0.5 ф. Богачи используют таблички из кости, а не из дерева: +4 МЦ
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кальян</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>5</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Water Pipe
<img data-src="lib/img/151671996018.png">
Состоит из сосуда для табака, трубки, соединяющей сосуд и дно резервуара с водой, и второй трубки, находящейся выше уровня воды, через которую вдыхают. Кальян впервые появился в Персии или Индии, где-то в первом веке н.э. До появления табака использовался для ингаляций медицинскими травами. $35, 4 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ боевое, 18м</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>18000</value>
		<weight>11600</weight>
		<reference>LT140</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>War Canoe, 60’
<img data-src="lib/img/151670995610.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Клевец двуручный</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>7</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw+4 imp</damage>
			<strength>12‡</strength>
			<usage>Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Warhammer
<img data-src="http://weapons.gurps.ru/img/2006.png">

Европа.

Длинный двуручный КЛЕВЕЦ (стр.60, Б271). Часто с тяжелым молоточным бойком на обухе; считайте комбинированным оружием. </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 1м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 1 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 2м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>4</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1-2*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 2 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 3м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>6</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>7</strength>
			<usage>Swung</usage>
			<reach>1-3*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 3 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 4м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>8</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1-4*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 4 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 5м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>9</strength>
			<usage>Swung</usage>
			<reach>1-5*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 5 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 6м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>12</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1-6*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 6 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кнут 7м</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>140</value>
		<weight>14</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-2(0.5) cr</damage>
			<strength>11</strength>
			<usage>Swung</usage>
			<reach>1-7*</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Whip, 7 yd
<img data-src="http://weapons.gurps.ru/img/2009.png">

От 1 до 7 метров



Отрез из плетеной кожи, которым можно хлестать или опутывать противника (см. стр.Б406 или технику Опутывание в ГУРПС Боевые искусства). При плотности 2 фунта на 1 ярд оба конца утяжелены и утыканы шипами. У ЛЁГКОГО КНУТА (стр.70) нет этих улучшений, поэтому он используется в основном для опутывания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крепостное ружьё - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>0.3</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Wall Gun Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Утяжеленный шарф</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>-1</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>see B405</damage>
			<usage>Garrote</usage>
			<reach>C</reach>
			<parry>No</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Garrote</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Weighted Scarf
<img data-src="http://weapons.gurps.ru/img/2007.png">

Индия.

Шарф с грузилом на одном, или обоих концах. Культ Тугов в основном использует его как УДАВКУ (стр.Б272), но также он может служить в качестве легкого цепа.</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<reference>LT34</reference>
		<notes>DR 0, HP 1,  Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.16 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 1/4 cup
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.15</value>
		<weight>0.07</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 2, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.66 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 1 cup
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.25</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 3, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2.72 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 1 quart
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1.75</value>
		<weight>1</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 4, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">10.79 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 1 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>1.5</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 5, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">22.41 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 2 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7.5</value>
		<weight>3.75</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 7, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">66.4 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 6 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>16</value>
		<weight>8</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 9, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">224.1 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 20 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 150 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>39</value>
		<weight>20</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 11, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">439.9 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 40 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 300 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>62</value>
		<weight>31</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 13, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">913 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 80 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Плетёная корзина, 450 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>108</value>
		<weight>54</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 16, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1328 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wicker Basket, 120 gal.
<img data-src="lib/img/151672008645.png">
Плетёные корзины имеют СП(DR) 0, и они Хрупкие (Воспламеняемые), а также не получают вреда и не защищают содержимое от дробящих атак. Их тонкое, открытое сплетение не подходит для хранения зерна, земли и иных сыпучих веществ. Они выдерживают столько же веса, сколько кожаные сумки.
</description-loc>
	</equipment_container><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный многослойный доспех, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2051.png">

В бронзовом веке китайские воины носили броню из нескольких слоев кожи. Азиатские кочевники и воины западной Европы в средние века тоже использовали похожие виды доспехов. Они были найдены и в Южной Америке. Несколько слоев кожи дают возможность поглощать удар и держать проникающие повреждения лучше, чем броня из одного толстого слоя кожи. Все, кроме самых легких доспехов из такой кожи – твердые. Количество слоев и толщина каждого из них определяет уровень защиты: легкий, средний, тяжелый (см. Таблица брони, сс.110-111). Броня из кожаных "чешуй" тоже может быть считаться многослойной кожей (о металлической чешуе см. с.106-107).



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>220</value>
	<weight>26</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>220</base-value>
		<base-weight>26</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ружьё "крылатый тигр"</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>220</value>
		<weight>6.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>2d-1 pi+</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>45/470</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>3(60i)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Winged Tiger Gun
<img data-src="http://weapons.gurps.ru/img/2016.png">

С фитильным замком

Короткоствольное китайское оружие, предназначеное для использования кавалеристами. Чтобы дать возможность делать несколько выстрелов, у него три заряженных ствола, из которых можно стрелять по-отдельности.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ружьё "крылатый тигр", пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>2.7</value>
		<weight>0.135</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Winged Tiger Gun Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 0.1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.05</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 2, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">0.33 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 1/4 cup
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка, 1/4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.1</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 2, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1.31 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 1 cup
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 1 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.25</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 3, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">5.44 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 1 quart
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка, 4 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1.5</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 5, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">20.8 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 1 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 7.5 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>17</value>
		<weight>2.5</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 6, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">43.2 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 2 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 23 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>31</value>
		<weight>6</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 8, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">128 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 6 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 75 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>55</value>
		<weight>11</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 9, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">432 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 20 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 150 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>113</value>
		<weight>32</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 13, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">848 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 40 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 300 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>178</value>
		<weight>50</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 15, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">1760 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 80 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment_container version="4" open="yes">
		<description>Деревянная коробка / бочка 450 л.</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>239</value>
		<weight>88</weight>
		<reference>LT34</reference>
		<notes>DR 0, HP 18, Хрупкая (Воспламеняемая) B136</notes>
		<categories>
			<category>Тара</category>
		</categories>
		<prereq_list all="yes">
			<contained_weight_prereq has="yes" compare="at most">2560 lb</contained_weight_prereq>
		</prereq_list>
		<description-loc>Wooden Box or Barrel, 120 gal.
<img data-src="lib/img/151672029222.png">
Деревянные ящики/бочки имеют СП(DR) 0 и они Хрупкие (Воспламеняемые). Они выдерживают столько же веса, сколько глиняные кувшины.
</description-loc>
	</equipment_container><equipment version="3">
	<quantity>1</quantity>
	<description>Большой щит, лёгкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2086.png">

DB 3

DR 2

HP 18





Лёгкие варианты (ТУ0) состояли из шкуры, натянутой на раму, сделанную из лёгкого дерева или сплетённую из лозы, или нескольких прошитых шкур. Более тяжелые деревянные варианты (ТУ1), покрытые кожей и/или металлом, часто использовались во время сражения в боевом порядке. Такие щиты были впервые использованы Шумерами, но также широко использовались многими другими культурами. Они закрывали воина от подбородка до голени, и могли быть любой формы - овальные, прямоугольные, шестиугольные, зубчатые или восьмёркой. Их поверхность была изогнутой, чтобы оборачиваться вокруг тела; обычно они снабжались гижом (ремнем), для снижения нагрузки на руку.

</description-loc>
	<tech_level>0</tech_level>
	<value>68</value>
	<weight>10</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Большой щит, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2092.png">

DB 3

DR 4

HP 22





Лёгкие варианты (ТУ0) состояли из шкуры, натянутой на раму, сделанную из лёгкого дерева или сплетённую из лозы, или нескольких прошитых шкур. Более тяжелые деревянные варианты (ТУ1), покрытые кожей и/или металлом, часто использовались во время сражения в боевом порядке. Такие щиты были впервые использованы Шумерами, но также широко использовались многими другими культурами. Они закрывали воина от подбородка до голени, и могли быть любой формы - овальные, прямоугольные, шестиугольные, зубчатые или восьмёркой. Их поверхность была изогнутой, чтобы оборачиваться вокруг тела; обычно они снабжались гижом (ремнем), для снижения нагрузки на руку.

</description-loc>
	<tech_level>1</tech_level>
	<value>90</value>
	<weight>20</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ботинки кожаные</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>LT98</reference>
		<categories>
			<category>Одежда</category>
		</categories>
		<description-loc>Shoes, leather
<img data-src="lib/img/151670489177.png">
Любая легкая кожаная или тканая обувь, закрывающая ступни, но не защищающая ноги. Низкотехнологичные ботинки шились не очень аккуратно, и разницы между левым и правым не было. Форма зависела от моды; одни были заостренными, другие – имели квадратные носы. Некоторые просто надевались на ногу (как тапочки), некоторые закреплялись шнуровкой или пряжками. СП(DR) 1. $40, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Бригантина, лёгкая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2067.png">

Хорошо сшитая облегающая броня состоящая из маленьких перекрывающих друг друга металлических пластинок, закрепленных на внутренней стороне полотняной или кожаной одежды. В современном английском слово "brigand" означает разбойника, однако название этого доспеха не имеет ничего общего с ворами или бандитами! Термин "бриганд" изначально обозначал пехотинца; таким образом, "бригантина" просто описывает тип брони для пехоты.



Впервые Бригантина появляется в Европе, в середине 14 века, эволюционируя из "coat of plates" (см. Сегментированные Латы, выше). Похожая броня также была изобретена в Азии, и стала модной одеждой при дворах правителей. За одно поколение бригантина завоевала огромную популярность, и оставалась в моде до конца 16 века. Многие обозреватели отмечают её как гражданскую броню, используемою джентльменами эпохи Возрождения, но, одновременно с этим, она часто появляется и на полях сражений, где обеспечивает отличную защиту; некоторые варианты были делались пуленепробиваемыми (см. Тяжелые Латы, стр.109), и обладали для станком для копья (см. Турнирные Латы, стр.109).



Бригантину можно скрыть, спрятав заклёпки под тканью или тонкой кожей (см. Сокрытие Брони, стр. 102); однако, хоть она и может показаться идеальной для этого, исторически её редко прятали. Бригантины были писком моды - их выставляли напоказ, располагая дорогие ткани и золочёные заклёпки в красивые узоры. Им подражали гражданские наряды и в Европе, и во дворах Азии. Одежда, известная как "поддельная бригантина" по покрою повторяла бригантины, с заклёпками, расположенными подобными узорами, но без металлических пластин с внутренней стороны. Такую одежду иногда ошибочно называют "клёпаной бронёй", но она не даёт СП(DR).



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>900</value>
	<weight>10</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>900</base-value>
		<base-weight>10</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Бригантина, средняя</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2068.png">

Хорошо сшитая облегающая броня состоящая из маленьких перекрывающих друг друга металлических пластинок, закрепленных на внутренней стороне полотняной или кожаной одежды. В современном английском слово "brigand" означает разбойника, однако название этого доспеха не имеет ничего общего с ворами или бандитами! Термин "бриганд" изначально обозначал пехотинца; таким образом, "бригантина" просто описывает тип брони для пехоты.



Впервые Бригантина появляется в Европе, в середине 14 века, эволюционируя из "coat of plates" (см. Сегментированные Латы, выше). Похожая броня также была изобретена в Азии, и стала модной одеждой при дворах правителей. За одно поколение бригантина завоевала огромную популярность, и оставалась в моде до конца 16 века. Многие обозреватели отмечают её как гражданскую броню, используемою джентльменами эпохи Возрождения, но, одновременно с этим, она часто появляется и на полях сражений, где обеспечивает отличную защиту; некоторые варианты были делались пуленепробиваемыми (см. Тяжелые Латы, стр.109), и обладали для станком для копья (см. Турнирные Латы, стр.109).



Бригантину можно скрыть, спрятав заклёпки под тканью или тонкой кожей (см. Сокрытие Брони, стр. 102); однако, хоть она и может показаться идеальной для этого, исторически её редко прятали. Бригантины были писком моды - их выставляли напоказ, располагая дорогие ткани и золочёные заклёпки в красивые узоры. Им подражали гражданские наряды и в Европе, и во дворах Азии. Одежда, известная как "поддельная бригантина" по покрою повторяла бригантины, с заклёпками, расположенными подобными узорами, но без металлических пластин с внутренней стороны. Такую одежду иногда ошибочно называют "клёпаной бронёй", но она не даёт СП(DR).



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>1800</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1800</base-value>
		<base-weight>20</base-weight>
		<base-dr>5</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Булава малая</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>35</value>
		<weight>3</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cr</damage>
			<strength>10</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Small Mace
<img data-src="http://weapons.gurps.ru/img/1933.png">

Любая несбалансированная одноручная боевая дубина с массивной каменной, деревянной или металлической дробящей головкой. Хотя гладкая ПАЛИЦА (стр.65, 70) и является древней, современные мастера боевых искусств все еще используют "арбузные молоты" и похожее оружие - иногда даже парно. Стандартная БУЛАВА (стр.65, 70, 77, Б271, Б276), с "перьями" (как пернач или шестопер) или шипами (см. МОРГЕНШТЕРН), для ударов сквозь латы, является классическим примером оружия средневековой Европы. Оба варианта представляют из себя булавы большого размера, с рукоятями, достаточно длинными для комфортного двуручного использования; используйте характеристики из раздела Двуручный Топор/Булава, которые изменяются во время использования оружия в Защитном хвате, описанном в GURPS Боевые Искусства. Тем не менее, большинство исторических экземпляров были меньше и легче: МАЛЕНЬКАЯ ПАЛИЦА (стр.65, 77) и МАЛЕНЬКАЯ БУЛАВА (стр.65, 77, Б271, Б276). Метательная булава является смертоносным снарядом; атакующий подбрасывает её в воздух, а не кидает по прямой траектории.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Бумажный усиленный доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2069.png">

Когда говорят о "бумажной броне", имеют в виду материал сделанный из внутренней коры деревьев семейства тутовых - лубяную ткань. (см. Бумага и её Родственники, стр.24). Несколько слоев склеенной лубяной ткани служила обычным солдатам в качестве дешевой, общедоступной брони. В Корее её называли джигап. Этот материал очень эффективно гасит силу удара, а несколько слоев могу "захватить" оружие противника. Считайте многослойной тканью (стр. 110), с тем исключением, что броня может вспыхнуть в случае если огненные повреждения проходят сквозь СП(DR). См Заставляем вещи гореть (ст.Б433); считайте этот материал устойчивым. -0.25 ЦФ; вес без изменений.



Лубяная ткань может быть усилена против лёгкого огнестрельного оружия при помощи нескольких слоёв шелка. Эта версия ТУ4. Как и прочая бумажная броня, она может загорется.



Горюче. Если СП(DR) преодолевают обжигающие повреждения, доспех может загореться. См. Поджигание Предметов (Б433); относится к категории огнестойкий (resistant).



Время одевания 20 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>2000</value>
	<weight>45</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>2000</base-value>
		<base-weight>45</base-weight>
		<base-dr>6</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ввелень, за лист</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.02</weight>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Vellum, per sheet
<img data-src="lib/img/151670968149.png">
Пергамент и велень (ТУ2). Пергамент и велень - обработанные шкуры животных, отличный материал для письма. Письмо на велени дает +1 (за качество) к четкости. Один фунт пергамента стоит $12 и содержит 20 листов; один фунт велени - $60, в нем 50 листов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Веглер</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>9600</value>
		<weight>700</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>4d+2 pi++</damage>
			<strength>36M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>40/340</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-12</bulk>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Veuglaire
<img data-src="lib/img/151670970623.png">
Достаточно маленькая, заряжаемая через казённик пушка, со стволом средней длины (в двенадцать раз больше калибра). Стреляет камнями большего размера, нежели крапаудью.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Веглер - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>250</value>
		<weight>2.5</weight>
		<reference>LT87</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Veuglaire Stone
<img data-src="lib/img/151677150978.png ">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Воз</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>680</value>
		<weight>1680</weight>
		<reference>LT136</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Wagon
<img data-src="lib/img/151670985235.png">
Это более тяжелое транспортное средство, которое тянут две запряженные лошади. Спереди расположено сиденье для возницы.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Вумера</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>LT75</reference>
		<ranged_weapon>
			<damage>sw+3 imp</damage>
			<strength>9</strength>
			<usage>Shoot Spear</usage>
			<accuracy>2</accuracy>
			<range>x1.5/x2</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Woomera
<img data-src="http://weapons.gurps.ru/img/2019.png">

Австралия.

Палка с прорезями, похожая на АТЛАТЛЬ (стр.72, Б276), но большего размера; в качестве снаряда используется полноразмерное КОПЬЕ (стр.69, Б276). Название пришло из Австралии, однако похожее оружие можно встретить повсеместно. Сюда же относятся амирре и мирру (оба Австралия).



Требует обеих рук для Подготовки, но только одной руки для атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Вытяжная скамья</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>125</weight>
		<reference>LT149</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Traction Bench
<img data-src="lib/img/151670930345.png">
Упоминалась в древней Греции около 500 г. до н.э.; фиксирует пациента и вытягивает сломанную конечность, что делает вправление кости независящим от физической силы хирурга. Считайте относительную премию СЛ(ST) (см. Хирургические техники, с.12) как если бы хирург имел СЛ(ST) 20. Родственница дыбы (с. 131)! $600, 125 фунтов.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Гомерический баклер, большой</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2091.png">

DB 3

DR 4

HP 22



Гомер подробно описывает эти щиты в Илиаде. Они крулые по форме и сделаны из нескольких слоёв воловьей шкуры, с внешним слоем из бронзы и умбоном, которому иногда придают вид головы фантастического существа. Часто, бронзу искусно украшают рельефом и эмалью (украшение, +4 ЦФ). Край укреплён либо бронзой, либо кожей, и удерживается заклёпками. У него рукоять в центре (поэтому требуется специализация "баклер"), но наплечный ремень снимает часть веса с руки. Размер варьируется от среднего (ПЗ(DB) 2) до крупного (ПЗ(DB) 3). Большие достаточно широки, чтобы дать укрытие товарищу - обычно лучнику.</description-loc>
	<tech_level>1</tech_level>
	<value>150</value>
	<weight>20</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Гомерический баклер, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2089.png">

DB 2

DR 4

HP 21



Гомер подробно описывает эти щиты в Илиаде. Они крулые по форме и сделаны из нескольких слоёв воловьей шкуры, с внешним слоем из бронзы и умбоном, которому иногда придают вид головы фантастического существа. Часто, бронзу искусно украшают рельефом и эмалью (украшение, +4 ЦФ). Край укреплён либо бронзой, либо кожей, и удерживается заклёпками. У него рукоять в центре (поэтому требуется специализация "баклер"), но наплечный ремень снимает часть веса с руки. Размер варьируется от среднего (ПЗ(DB) 2) до крупного (ПЗ(DB) 3). Большие достаточно широки, чтобы дать укрытие товарищу - обычно лучнику.</description-loc>
	<tech_level>1</tech_level>
	<value>100</value>
	<weight>16</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гривна (ожерелье) золотая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>17000</value>
		<weight>0.85</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Torc, gold
<img data-src="lib/img/151670886787.png">
Цельное металлическое ожерелье, популярное у кельтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гривна (ожерелье) медная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>7</value>
		<weight>0.4</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Torc, copper
<img data-src="lib/img/151670881594.png">
Цельное металлическое ожерелье, популярное у кельтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Гривна (ожерелье) сербрянная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>500</value>
		<weight>0.5</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Torc, silver
<img data-src="lib/img/151670892009.png">
Цельное металлическое ожерелье, популярное у кельтов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Двунога</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Shooting Stick
<img data-src="lib/img/151670514671.png">
<img data-src="lib/img/151670521657.png">

Опора для длинного оружия, сделанная из двух палок, связанных между собою шнуром или кожей. Сидящий стрелок может считать установленной на двуноге оружие зафиксированным (см. Прицеливание, стр.Б346). $5, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Деревянный доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2049.png">

<img data-src="http://weapons.gurps.ru/img/2080.png">

Из цельных кусков дерева можно вырезать облегающие тело элементы доспеха. Также доспех можно собрать и из деревянных планок или палок, связанных между собой кожаным или веревочным шнуром: такой доспех держится на плечах и висит на теле. Деревянный доспех полуразрушаем. Теряет 1 DR на 10 пунктов повреждений которым сопротивляется (см. стр. B47)



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>100</value>
	<weight>30</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>100</base-value>
		<base-weight>30</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Деревянный кол</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<weight>0.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>thr(0.5) imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr(0.5) imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>0</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-1</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Wooden Stake
<img data-src="http://weapons.gurps.ru/img/2017.png">

Палка с острым концом. Лучше, чем ничего. Также сюда относятся лианжат и паку (оба из Индонезии).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Десятиглазая ручница</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>920</value>
		<weight>27</weight>
		<reference>LT91</reference>
		<ranged_weapon>
			<damage>2d pi++</damage>
			<strength>11†</strength>
			<usage>First Shot</usage>
			<accuracy>1</accuracy>
			<range>50/510</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>10(30i)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>2d+1 pi++</damage>
			<strength>–</strength>
			<usage>Second Shot</usage>
			<accuracy>1</accuracy>
			<range>60/590</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>–</shots>
			<bulk>–</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>2d+2 pi++</damage>
			<strength>–</strength>
			<usage>Third Shot</usage>
			<accuracy>1</accuracy>
			<range>65/630</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>–</shots>
			<bulk>–</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>2d+2 pi++</damage>
			<strength>–</strength>
			<usage>Fourth Shot</usage>
			<accuracy>1</accuracy>
			<range>65/650</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>–</shots>
			<bulk>–</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>2d+3 pi++</damage>
			<strength>–</strength>
			<usage>Fifth Shot</usage>
			<accuracy>1</accuracy>
			<range>65/660</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>–</shots>
			<bulk>–</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Gonne</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Дальность и повреждения увеличиваются от первой до пятой пули с каждого конца. Пять строчек показывают это увеличение. После того, как один конец полностью разряжен, начните заново с самых низких значений с другого конца. Перезарядка внутренних зарядов занимает 60 секунд за заряд вместо 30.</notes>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Ten-Eyed Gonne
<img data-src="http://weapons.gurps.ru/img/1964.png">

Китайская ручница, максимально приближающаяся к автоматическому огню. Каждая половина имеет запальные отверстия для пяти зарядов,которые поджигают, начиная с дальней стороны; когда они заканчиваются, оружие переворачивают (манёвр Подготовки), чтобы произвести ещё пять выстрелов. Европейское огнестрельное оружие такого типа часто называют "ружьями-римскими свечами" (“Roman candle guns”).



Дальность и повреждения увеличиваются от первой до пятой пули с каждого конца. Пять строчек показывают это увеличение. После того, как один конец полностью разряжен, начните заново с самых низких значений с другого конца. Перезарядка внутренних зарядов занимает 60 секунд за заряд вместо 30.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Длинный Дуэльный Щит</description>
	<description-loc> <img data-src="lib/img/151672054740.png">

DB 3

DR 4

HP 21



Как описывается в руководствах по фехтованию эпохи Ренесанса, таких как Fechtbuch Тальхоффера и Codex Wallerstein, длинные дуэльные щиты предназначались для судебных поединков. Они были не только защитой, но и оружием: длинный, узкий щит, закрепленный на вертикальном шесте, с шипами на обоих концах, иногда со специальным вырезом, позволяющим использовать атаки Крюком (стр.54). В качестве навыка используются Щит -2, или Посох -4. Читатели, знакомые с GURPS Martial Arts, заметьте, что перк "Тренировка с Экзотическим Оружием" может отменить этот штраф к навыку.</description-loc>
	<tech_level>3</tech_level>
	<value>200</value>
	<weight>16</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Дубина на ремне</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>0.5</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>sw-1 cr</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>-2U</parry>
			<block>-1</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Thonged Club
<img data-src="http://weapons.gurps.ru/img/1974.png">

Маленькая палка с присоединенным к ней шнуром. Используйте представленные характеристики если размахиваете ею держась за шнур; в противном случае можете считать что это дешевая ДУБИНКА РАБОТОРГОВЦА (стр.65, Б271).</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Дуэльный баклер</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2096.png">

DB 0

DR 4

HP 11



+1 к Block



Самый маленький из баклеров, этот щит представляет из себя несколько большее, чем из просто умбон с рукояткой. Немецкие дуэлянты специально тренировались в его использовании, называя "хут" (шляпа). Он не даёт DB, но обеспечивает +1 к проверкам Блока (только), и DR 4 руке, у которой удерживается щит. Любой баклер, уничтоженный в процессе сражения, всё еще может быть использован в качестве дуэльного баклера.</description-loc>
	<tech_level>3</tech_level>
	<value>25</value>
	<weight>2</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Жгут</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<reference>LT145</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Tourniquet
<img data-src="lib/img/151670923862.png">
Отрезок ткани или веревки, достаточно длинный, чтобы быть плотно обвязанным вокруг раненой конечности, ограничивая кровоток и позволяя ране запечься. По сути, это удавка. См. Верёвки, бечёвки и нити (сс. 23-24) и с. Б288. В обществах, где веревки неизвестны, может быть использован кожаный ремешок. $2, вес незначителен. 

Импровизированные жгуты: в полевых условиях отрезок лозы может послужить заменой жгута. Это даст -2 к броску Первой помощи. Денег он не стоит, но поиск подходящего растения потребует 5 минут и броска Натуралиста. Мастер может модифицировать этот бросок по частоте произрастания таких растений – от +5 в джунглях до -5 в пустыне. Он может решить, что в некоторых местах их найти вообще нельзя – например, в Арктике!

обязательное правило: тугие жгуты

Мастер может использовать это правило вместе с правилами по Перевязке (с.Б424) и Кровотечению (с.Б420). Оставьте его на крайний случай – оно слишком рискованно для небольшого кровотечения! Оно работает с обычными жгутами, но не с импровизированными.

Жгут может натянут очень сильно, серьезно ограничивая кровоток. Это даст от +1 до +5 к броскам Первой помощи на остановку кровотечения; спасатель выбирает бонус, который ему нужен. Даже если бросок Первой помощи провален, можно оставить жгут на конечности. Тогда данный бонус уменьшит штраф за серьезность раны при бросках на ЗД(HT) для естественной остановки кровотечения, хотя и не даст чистого бонуса.

Риск этой процедуры заключается в возможности повредить ткани организма, чересчур ограничив приток крови. После остановки кровотечения из раны и снятия жгута раненый должен сделать бросок ЗД(HT) со штрафом, равным выбранному бонусу. Если бросок Первой помощи был провален, то штраф увеличивается на -1 за каждую минуту, в течение которой жгут оставался на конечности. Успешный бросок позволяет избежать негативных эффектов. Провал означает, что броски ЗД(HT) для естественного восстановления и броски медицинских умений для его ускорения делаются со штрафом -1, плюс еще -1 за каждые 2 очка провала. На критическом провале ткани конечности отмирают: конечность считается получившей постоянное увечье, и пациент должен сделать бросок против инфекции (с. B444), с -3 к обычному броску на ЗД(HT)+3 (то есть, на немодифицированное ЗД(HT)).
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Каноэ морское, 10м</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1900</value>
		<weight>11560</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Voyageur Canoe, 35’
<img data-src="lib/img/151670982431.png">
При ТУ0 лодки обычно делаются из цельного куска материала. Это может быть твёрдый объект с кропотливо вырезанной полостью (например долблёнка), или что-то плоское, которому придана форма, ограждающая внутреннее пространство, обычно с помощью какого-нибудь каркаса (например каноэ из коры или обшитая кожей лодка). Керамический сосуды, достаточно большие, что бы служить в качестве лодки использовались в некоторых частях Индии, ТУ1; они слишком хрупкие для каменистых или быстрых рек и не описаны здесь.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Каплевидный щит</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2098.png">

DB 3

DR 4

HP 21



В 11ом веке, этот длинный щит в форме капли стал самым популярным щитом в Европе, потеснив круглый щит. Он оставался основным вплоть до конца 13 века, и использовался и кавалерией и пехотой. Каплевидный щит уходит вниз, защищая ведущую ногу, и может закрыть левую ногу всадника. Он сделан как тяжёлый большой щит, но весит меньше, потому что сужается книзу.</description-loc>
	<tech_level>3</tech_level>
	<value>120</value>
	<weight>18</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный вываренный доспех, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2056.png">

Вываренная кожа (cuir-bouilli) впервые упоминается в Западной Европе в конце 12-го века. Веками раньше она использовалась в Азии. Размачивание кожи в горячей воде размягчает ее, позволяя придать ей нужную форму. Затем она сушится – естественно или выпекаясь в духовке при средней температуре. Наконец доспех покрывается водонепроницаемым слоем – воском, смолой или лаком. Конечный продукт – очень твердая, устойчивая к воде и ударам кожа, идеально подходящая для доспехов.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>125</value>
	<weight>15</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>125</base-value>
		<base-weight>15</base-weight>
		<base-dr>2</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный вываренный доспех, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2057.png">

Вываренная кожа (cuir-bouilli) впервые упоминается в Западной Европе в конце 12-го века. Веками раньше она использовалась в Азии. Размачивание кожи в горячей воде размягчает ее, позволяя придать ей нужную форму. Затем она сушится – естественно или выпекаясь в духовке при средней температуре. Наконец доспех покрывается водонепроницаемым слоем – воском, смолой или лаком. Конечный продукт – очень твердая, устойчивая к воде и ударам кожа, идеально подходящая для доспехов.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>250</value>
	<weight>25</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>250</base-value>
		<base-weight>25</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный доспех, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2046.png">

<img data-src="http://weapons.gurps.ru/img/2078.png">

-1DR против imp



Кожа очень часто используется для создания брони. Размер животного обычно определяет ее толщину и соответственно СП(DR).



Легкая кожа: мягкая, гибкая кожа – телячья, овечья, свиная, оленья, рептилий или даже рыбы. В качестве отдельного предмета брони одевается редко; чаще всего она используется в качестве основы для более мощной – например, чешуи (сс.106-107). Если надета сама по себе, действует как меха (выше), давая СП(DR) 1 против режущих атак.



Средняя кожа: от таких животных, как медведь, буйвол, зубр и крупных крокодилов. Броня из средней кожи использовалась от Европы до Индонезии. Она остается гибкой, но даёт сносную защиту. Средняя кожа дает СП(DR) 2 от всех атак, кроме проникающих, против которых СП(DR) 1.



Тяжелая кожа: кожа больших животных – бегемотов, носорогов, слонов и т.д. Широко использовалась в Азии; азиатский носорог был истреблен в бронзовом веке именно поэтому. Прибрежные китайские кланы иногда использовали китовую кожу, когда носороги стали редки. Тяжелая кожаная броня дает СП(DR) 3 для всех атак, кроме проникающих, против которых она защищает только с СП(DR) 2.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>100</value>
	<weight>12</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>100</base-value>
		<base-weight>12</base-weight>
		<base-dr>2*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>2*</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный доспех, тяжелый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2047.png">

-1DR против imp



Кожа очень часто используется для создания брони. Размер животного обычно определяет ее толщину и соответственно СП(DR).



Легкая кожа: мягкая, гибкая кожа – телячья, овечья, свиная, оленья, рептилий или даже рыбы. В качестве отдельного предмета брони одевается редко; чаще всего она используется в качестве основы для более мощной – например, чешуи (сс.106-107). Если надета сама по себе, действует как меха (выше), давая СП(DR) 1 против режущих атак.



Средняя кожа: от таких животных, как медведь, буйвол, зубр и крупных крокодилов. Броня из средней кожи использовалась от Европы до Индонезии. Она остается гибкой, но даёт сносную защиту. Средняя кожа дает СП(DR) 2 от всех атак, кроме проникающих, против которых СП(DR) 1.



Тяжелая кожа: кожа больших животных – бегемотов, носорогов, слонов и т.д. Широко использовалась в Азии; азиатский носорог был истреблен в бронзовом веке именно поэтому. Прибрежные китайские кланы иногда использовали китовую кожу, когда носороги стали редки. Тяжелая кожаная броня дает СП(DR) 3 для всех атак, кроме проникающих, против которых она защищает только с СП(DR) 2.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>200</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>200</base-value>
		<base-weight>20</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный многослойный доспех, легкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2050.png">

В бронзовом веке китайские воины носили броню из нескольких слоев кожи. Азиатские кочевники и воины западной Европы в средние века тоже использовали похожие виды доспехов. Они были найдены и в Южной Америке. Несколько слоев кожи дают возможность поглощать удар и держать проникающие повреждения лучше, чем броня из одного толстого слоя кожи. Все, кроме самых легких доспехов из такой кожи – твердые. Количество слоев и толщина каждого из них определяет уровень защиты: легкий, средний, тяжелый (см. Таблица брони, сс.110-111). Броня из кожаных "чешуй" тоже может быть считаться многослойной кожей (о металлической чешуе см. с.106-107).



Время одевания 20 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>120</value>
	<weight>15</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>120</base-value>
		<base-weight>15</base-weight>
		<base-dr>2*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>2*</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кожаный многослойный доспех, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2052.png">

<img data-src="http://weapons.gurps.ru/img/2079.png">

В бронзовом веке китайские воины носили броню из нескольких слоев кожи. Азиатские кочевники и воины западной Европы в средние века тоже использовали похожие виды доспехов. Они были найдены и в Южной Америке. Несколько слоев кожи дают возможность поглощать удар и держать проникающие повреждения лучше, чем броня из одного толстого слоя кожи. Все, кроме самых легких доспехов из такой кожи – твердые. Количество слоев и толщина каждого из них определяет уровень защиты: легкий, средний, тяжелый (см. Таблица брони, сс.110-111). Броня из кожаных "чешуй" тоже может быть считаться многослойной кожей (о металлической чешуе см. с.106-107).



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>525</value>
	<weight>35</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>525</base-value>
		<base-weight>35</base-weight>
		<base-dr>4</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Колесница с седлом</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>164</value>
		<weight>240</weight>
		<reference>LT137</reference>
		<notes>Запрягается ослом</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Straddle Car
<img data-src="lib/img/151670829350.png">
Ранняя предшественница обычной колесницы, в которую вместо пони впрягался онагр (родич осла). Конструкция не предусматривает защиты возницы - кроме того, у неё нет днища! Возница сидит над осью, свесив ноги по сторонам от дышла, в сиденье, чем-то напоминающем седло примитивного велосипеда. Колесницы с седлами обычно не вводили в бой; их использовали в основном для переброски воинов на поле боя, где те сражались пешими.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Кольцо-печать</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Signet Ring
<img data-src="lib/img/151670530221.png">
Выполняет ту же функцию, что и цилиндрическая печать, но гравировка выполняется на плоской стороне камня перстня. Владелец сжимает руку в кулак, и прижимает кольцо к воску, запечатывающему письмо. $30, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кольчато-пластинчатый доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2065.png">

-1 DR против crusing



Иногда называется "бехтерец", состоит из кольчуги с включёнными в неё вертикальными рядами перекрывающихся пластин. Он появился в Индии, на Руси и на Среднем Востоке около 14ого века. Он лучше защищает от дробящих повреждений, чем тяжёлая кольчуга.



Время одевания 20 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>3</tech_level>
	<value>1000</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1000</base-value>
		<base-weight>20</base-weight>
		<base-dr>5</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кольчуга, лёгкая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2059.png">

-2 DR против crusing



Состоит из довольно крупных колец из тонкой проволоки, чаще всего носится вместе с другой броней, чем сама по себе.



Время одевания 15 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>500</value>
	<weight>12</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>500</base-value>
		<base-weight>12</base-weight>
		<base-dr>3*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3*</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кольчуга, мелкая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2060.png">

-2 DR против crusing



Небольшие звенья тонкой проволоки, скользит в руках как ткань, только из металла, но может сопротивляться любому удару, кроме самых сильных ударов мечом или копьем. Самые первые находки датированы эпохой Рима.



Время одевания 15 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>900</value>
	<weight>15</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>900</base-value>
		<base-weight>15</base-weight>
		<base-dr>4*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4*</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кольчуга, турнирная</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2066.png">

-1 к DX, кроме навыка Пики.



Упомянутая в нескольких средневековых текстах, эта кольчуга, кажется, была специально разработана для турниров во времена, когда турниры использовали заточенные боевые кавалерийские пики! Не вполне ясно, чем они отличались от полевых кольчуг, но скорее всего они были твёрже и тяжелее. Как и с турнирными латами (стр. 109), эти доспехи стесняют движения: -1 ко всем основанным на ЛВ(DX) навыкам, кроме Пики.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>3</tech_level>
	<value>1500</value>
	<weight>30</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1500</base-value>
		<base-weight>30</base-weight>
		<base-dr>6</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Кольчуга, тяжёлая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2061.png">

-2 DR против crusing



Крупные кольца из толстой проволоки. Исторически, кольчуга, носимая в качестве основной брони (у римлян, викингов, норманнов и т.д.) была тяжелее, чем та, что надевалась вместе с другой.



Время одевания 15 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>1200</value>
	<weight>18</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1200</base-value>
		<base-weight>18</base-weight>
		<base-dr>5*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5*</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Копье</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>4</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3  imp</damage>
			<strength>9†</strength>
			<usage>Thrust - two hands</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>9</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Spear
<img data-src="http://weapons.gurps.ru/img/1947.png">

Древковое оружие с острым колющим наконечником, ценится за свою универсальность: длинное, может быть использовано как одной, так и двумя руками, часто метательное, и всегда смертоносное. Копье является по настоящему повсеместным оружием; к примерам можно отнести болг (древние кельты), цян (Китай), хаста (Древний Рим), нгао (Таиланд), сибат (Филиппины) и яри (Япония) - и это только некоторые. Многие варианты жертвуют универсальностью в обмен на особые возможности. Например у яри иногда можно встретить L-образный наконечник; это дает дополнительно $10 и 0,5 фунтов, и позволяет использовать правила для Крюка (стр.54), однако не позволяет метать. У других копий наконечник может быть не заостренным, а полукруглым или в форме полумесяца; повреждения при этом становятся рубящими, а прочие характеристики не изменяются. КОРОТКОЕ КОПЬЕ (стр.69) короткое, одноручное и не метательное - это колющий меч для бедных; примером может быть рохин (Япония). ДЛИННОЕ КОПЬЁ предназначено исключительно для ближнего боя и используется для сражения в строю, как со щитом, так и без него. ТЯЖЕЛОЕ КОПЬЕ (стр.69) похоже, однако у него очень широкий наконечник; оно такое тяжелое, что требует для использования обеих рук. К тяжелым копьям относятся дори и контос (оба Древняя Греция), а также рогатина (Русь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Копьё короткое</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>2</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cut</damage>
			<strength>6</strength>
			<usage>Thrust - tip slash</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Short Spear
<img data-src="http://weapons.gurps.ru/img/1911.png">

Древковое оружие с острым колющим наконечником, ценится за свою универсальность: длинное, может быть использовано как одной, так и двумя руками, часто метательное, и всегда смертоносное. Копье является по настоящему повсеместным оружием; к примерам можно отнести болг (древние кельты), цян (Китай), хаста (Древний Рим), нгао (Таиланд), сибат (Филиппины) и яри (Япония) - и это только некоторые. Многие варианты жертвуют универсальностью в обмен на особые возможности. Например у яри иногда можно встретить L-образный наконечник; это дает дополнительно $10 и 0,5 фунтов, и позволяет использовать правила для Крюка (стр.54), однако не позволяет метать. У других копий наконечник может быть не заостренным, а полукруглым или в форме полумесяца; повреждения при этом становятся рубящими, а прочие характеристики не изменяются.  (стр.69) короткое, одноручное и не метательное - это колющий меч для бедных; примером может быть рохин (Япония). ДЛИННОЕ КОПЬЁ предназначено исключительно для ближнего боя и используется для сражения в строю, как со щитом, так и без него. ТЯЖЕЛОЕ КОПЬЕ (стр.69) похоже, однако у него очень широкий наконечник; оно такое тяжелое, что требует для использования обеих рук. К тяжелым копьям относятся дори и контос (оба Древняя Греция), а также рогатина (Русь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Копьё с ремнем</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>45</value>
		<weight>4</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3  imp</damage>
			<strength>9†</strength>
			<usage>Thrust - two hands</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>9</strength>
			<usage>Thrown</usage>
			<accuracy>3</accuracy>
			<range>x1.25/x1.75</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Harpoon</specialization>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Spear w. Thong
<img data-src="http://weapons.gurps.ru/img/2021.png">
<img data-src="http://weapons.gurps.ru/img/1950.png">

Древковое оружие с острым колющим наконечником, ценится за свою универсальность: длинное, может быть использовано как одной, так и двумя руками, часто метательное, и всегда смертоносное. Копье является по настоящему повсеместным оружием; к примерам можно отнести болг (древние кельты), цян (Китай), хаста (Древний Рим), нгао (Таиланд), сибат (Филиппины) и яри (Япония) - и это только некоторые. Многие варианты жертвуют универсальностью в обмен на особые возможности. Например у яри иногда можно встретить L-образный наконечник; это дает дополнительно $10 и 0,5 фунтов, и позволяет использовать правила для Крюка (стр.54), однако не позволяет метать. У других копий наконечник может быть не заостренным, а полукруглым или в форме полумесяца; повреждения при этом становятся рубящими, а прочие характеристики не изменяются. КОРОТКОЕ КОПЬЕ (стр.69) короткое, одноручное и не метательное - это колющий меч для бедных; примером может быть рохин (Япония). ДЛИННОЕ КОПЬЁ предназначено исключительно для ближнего боя и используется для сражения в строю, как со щитом, так и без него. ТЯЖЕЛОЕ КОПЬЕ (стр.69) похоже, однако у него очень широкий наконечник; оно такое тяжелое, что требует для использования обеих рук. К тяжелым копьям относятся дори и контос (оба Древняя Греция), а также рогатина (Русь).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 21 кг - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1200</value>
		<weight>9000</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ship’s Gun, 42-lb. Truck Carriage Mount<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Корабельное орудие 9 кг - повозка</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>890</value>
		<weight>6000</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Ship’s Gun, 18-lb. Truck Carriage Mount
<img data-src="lib/img/151677461614.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Короткий меч</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>2</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Shortsword
<img data-src="http://weapons.gurps.ru/img/1915.png">

Одноручный рубящий-и-колющий меч длиною от 45 до 60 см. К примерам можно отнести кутто (Европа), дааб (Тайланд), гладиус (Древний Рим), хангер (Европа), кацбальгер (Европа), педанг (Индонезия), сакс (Скандинавия) и вакидзаси (Япония). Это оружие, предназначенное для войны. Сделанные как орудия труда клинки дешевле и менее эффективны в качестве оружия; стоимость снижена до $350 и -1 к прямым повреждениям. Для оптимизированных рубящих мечей такого размера см. ФАЛЬШИОН (стр.56.)</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Костяной доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2042.png">

<img data-src="http://weapons.gurps.ru/img/2076.png">

Сюда относятся рога, слоновая кость, копыта, панцири черепах и китовый ус. Эти материалы легки и прочны, и если их нагреть в воде, из них можно формировать броню - обычно какой-то вид чешуйчатой брони (ниже). Роговая броня популярная там, где мало ресурсов – в степях Азии и за Полярным кругом. Ранний пример - шлемы из кабаньих клыков, которые носили древние микенцы в Греции. Еще можно вспомнить описанную Павсанием чешуйчатую броню сарматов, которые нарезали лошадиные копыта на чешуйки и сшивали их сухожилиями.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>250</value>
	<weight>25</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>250</base-value>
		<base-weight>25</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Крепостное ружьё</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>425</value>
		<weight>27.5</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>5d+1 pi++</damage>
			<strength>13M†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>120/1,200</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(40)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<notes>Обычно используется установленным на треножник</notes>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Wall Gun
<img data-src="http://weapons.gurps.ru/img/2005.png">

Гладкоствольное оружие ещё тяжелее мушкета, помещённое на треножник на стене города для использования в обороне. Некоторые треножники имеют маленькие колёса для повышенной мобильности, но этого недостаточно, чтобы сделать крепостные ружья полезными в поле. Из крепостного ружья обычно стреляют с помощью колесцового замка, но за дополнительных 25$, у него может быть ещё и фитильный замок, в качестве запасного, если колесцовый сломается.



Обычно используется установленным на треножник. $260, 7.5 фунтов.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Ламинарный доспех, лёгкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2062.png">

Ламинарный доспех сделан из больших горизонтальных полос, изгибающихся вокруг тела и перекрывающихся, чтобы позволить некоторую подвижность. Самая известная разновидность - лорика сегментата римских легионов, но такие доспехи использовались на Ближнем Востоке и в Азии. Самый ранний известный экземпляр - бронзовый доспех из Дендры (Греция, относится примерно к 1400 д.н.э.), который состоит из цельной кирасы, защищающей грудь, с привязанным кожаными ремешками ламинарными пластинами, свисающими ниже, защищая живот и бёдра.



Ламинарный доспех намного проще изготовить, чем цельные латы, потому что требуемые куски металла меньше, и броню нужно меньше подгонять к данному носителю. Когда полосы выкованы, сборка быстра и проста. Шнуры, проволока или заклёпки соединяют соседние полосы, или пластины приклёпаны к холсту или коже. Правила по увеличению СП(DR) в разделе "тяжёлые латы" (стр. 109) применимы к ламинарным доспехам.



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>600</value>
	<weight>16</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>600</base-value>
		<base-weight>16</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Ламинарный доспех, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2063.png">

Ламинарный доспех сделан из больших горизонтальных полос, изгибающихся вокруг тела и перекрывающихся, чтобы позволить некоторую подвижность. Самая известная разновидность - лорика сегментата римских легионов, но такие доспехи использовались на Ближнем Востоке и в Азии. Самый ранний известный экземпляр - бронзовый доспех из Дендры (Греция, относится примерно к 1400 д.н.э.), который состоит из цельной кирасы, защищающей грудь, с привязанным кожаными ремешками ламинарными пластинами, свисающими ниже, защищая живот и бёдра.



Ламинарный доспех намного проще изготовить, чем цельные латы, потому что требуемые куски металла меньше, и броню нужно меньше подгонять к данному носителю. Когда полосы выкованы, сборка быстра и проста. Шнуры, проволока или заклёпки соединяют соседние полосы, или пластины приклёпаны к холсту или коже. Правила по увеличению СП(DR) в разделе "тяжёлые латы" (стр. 109) применимы к ламинарным доспехам.



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>900</value>
	<weight>24</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>900</base-value>
		<base-weight>24</base-weight>
		<base-dr>4</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Ламинарный доспех, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2064.png">

Ламинарный доспех сделан из больших горизонтальных полос, изгибающихся вокруг тела и перекрывающихся, чтобы позволить некоторую подвижность. Самая известная разновидность - лорика сегментата римских легионов, но такие доспехи использовались на Ближнем Востоке и в Азии. Самый ранний известный экземпляр - бронзовый доспех из Дендры (Греция, относится примерно к 1400 д.н.э.), который состоит из цельной кирасы, защищающей грудь, с привязанным кожаными ремешками ламинарными пластинами, свисающими ниже, защищая живот и бёдра.



Ламинарный доспех намного проще изготовить, чем цельные латы, потому что требуемые куски металла меньше, и броню нужно меньше подгонять к данному носителю. Когда полосы выкованы, сборка быстра и проста. Шнуры, проволока или заклёпки соединяют соседние полосы, или пластины приклёпаны к холсту или коже. Правила по увеличению СП(DR) в разделе "тяжёлые латы" (стр. 109) применимы к ламинарным доспехам.



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>1200</value>
	<weight>32</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1200</base-value>
		<base-weight>32</base-weight>
		<base-dr>5</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Латы, лёгкие</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2070.png">

В Basic Set латы указаны как ТУ3 (см. стр. Б283). Исторически, защита торса из сплошной пластины, сделанной из железа, была крайне редка до ТУ4. Более ранние попытки (например, японский доспех "танко") полагались на пластины меньшего размера, которые были склёпаны или спаяны и сделаны из железа худшего качества. Они были тяжелы и делать их должен был исключительно умелый ремёсленник. Сплошные латы начали развиваться только после появления доменных печей (см. Железо и Сталь, стр. 20), которые могли плавить куски железа достаточно большие, чтобы сделать из одного куска нагрудник, и приводимых в движение водой станков с падающим молотом, которые уменьшили затраты труда и стоимость производства.



Считайте латы с ТУ3 из БН ранними попытками создания такого доспеха – или попытками введения анахронической брони в фентези ТУ3. Она весит намного больше, чем многие реальные образцы ТУ4. Однако это относится только к полным комплектам и защите туловища. Меньшие части железных лат, такие, как наголенники и шлемы, стали доступными уже на ТУ2. Полный набор бронзовых лат доступен с ТУ1, с обычными +3 ЦФ.



Полные железные латы впервые появились в Западной Европе в конце 1300ых. За следующий век они развились в защиту со множеством шарнирных соединений (fully articulated), превосходящую всё, разработанное ранее. Латы могли быть на удивление лёгкими и, если их специально подогнать под носителя и правильно оборудовать сгибами, весьма удобными. Они позволяли всю полноту движений, и весили меньше, чем любая другая низкотехнологичная броня, дающая защиту того же уровня. Полный комплект лат (называемый "доспешным гарнитуром") использует пластины разной толщины, самые лёгкие - на наименее уязвимых местах (рёбрах, предплечьях, голенях) и самые тяжёлые - на самых уязвимых (голове и груди). Подробнее см. Тяжёлые Латы (выше).



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>1000</value>
	<weight>8</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1000</base-value>
		<base-weight>8</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Латы, средние</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2071.png">

В Basic Set латы указаны как ТУ3 (см. стр. Б283). Исторически, защита торса из сплошной пластины, сделанной из железа, была крайне редка до ТУ4. Более ранние попытки (например, японский доспех "танко") полагались на пластины меньшего размера, которые были склёпаны или спаяны и сделаны из железа худшего качества. Они были тяжелы и делать их должен был исключительно умелый ремёсленник. Сплошные латы начали развиваться только после появления доменных печей (см. Железо и Сталь, стр. 20), которые могли плавить куски железа достаточно большие, чтобы сделать из одного куска нагрудник, и приводимых в движение водой станков с падающим молотом, которые уменьшили затраты труда и стоимость производства.



Считайте латы с ТУ3 из БН ранними попытками создания такого доспеха – или попытками введения анахронической брони в фентези ТУ3. Она весит намного больше, чем многие реальные образцы ТУ4. Однако это относится только к полным комплектам и защите туловища. Меньшие части железных лат, такие, как наголенники и шлемы, стали доступными уже на ТУ2. Полный набор бронзовых лат доступен с ТУ1, с обычными +3 ЦФ.



Полные железные латы впервые появились в Западной Европе в конце 1300ых. За следующий век они развились в защиту со множеством шарнирных соединений (fully articulated), превосходящую всё, разработанное ранее. Латы могли быть на удивление лёгкими и, если их специально подогнать под носителя и правильно оборудовать сгибами, весьма удобными. Они позволяли всю полноту движений, и весили меньше, чем любая другая низкотехнологичная броня, дающая защиту того же уровня. Полный комплект лат (называемый "доспешным гарнитуром") использует пластины разной толщины, самые лёгкие - на наименее уязвимых местах (рёбрах, предплечьях, голенях) и самые тяжёлые - на самых уязвимых (голове и груди). Подробнее см. Тяжёлые Латы (выше).



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>2500</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>2500</base-value>
		<base-weight>20</base-weight>
		<base-dr>6</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>6</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Латы, тяжёлые</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2072.png">

В Basic Set латы указаны как ТУ3 (см. стр. Б283). Исторически, защита торса из сплошной пластины, сделанной из железа, была крайне редка до ТУ4. Более ранние попытки (например, японский доспех "танко") полагались на пластины меньшего размера, которые были склёпаны или спаяны и сделаны из железа худшего качества. Они были тяжелы и делать их должен был исключительно умелый ремёсленник. Сплошные латы начали развиваться только после появления доменных печей (см. Железо и Сталь, стр. 20), которые могли плавить куски железа достаточно большие, чтобы сделать из одного куска нагрудник, и приводимых в движение водой станков с падающим молотом, которые уменьшили затраты труда и стоимость производства.



Считайте латы с ТУ3 из БН ранними попытками создания такого доспеха – или попытками введения анахронической брони в фентези ТУ3. Она весит намного больше, чем многие реальные образцы ТУ4. Однако это относится только к полным комплектам и защите туловища. Меньшие части железных лат, такие, как наголенники и шлемы, стали доступными уже на ТУ2. Полный набор бронзовых лат доступен с ТУ1, с обычными +3 ЦФ.



Полные железные латы впервые появились в Западной Европе в конце 1300ых. За следующий век они развились в защиту со множеством шарнирных соединений (fully articulated), превосходящую всё, разработанное ранее. Латы могли быть на удивление лёгкими и, если их специально подогнать под носителя и правильно оборудовать сгибами, весьма удобными. Они позволяли всю полноту движений, и весили меньше, чем любая другая низкотехнологичная броня, дающая защиту того же уровня. Полный комплект лат (называемый "доспешным гарнитуром") использует пластины разной толщины, самые лёгкие - на наименее уязвимых местах (рёбрах, предплечьях, голенях) и самые тяжёлые - на самых уязвимых (голове и груди). Подробнее см. Тяжёлые Латы (выше).



Время одевания 45 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>4</tech_level>
	<value>4000</value>
	<weight>32</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>4000</base-value>
		<base-weight>32</base-weight>
		<base-dr>9</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>9</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лодка с прямым парусом</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>15000</value>
		<weight>14000</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Square-Rigged Sailboat
<img data-src="lib/img/151670740651.png">
Это судно было изобретено романизированными кельтами на Британских островах во времена поздней Римской Империи. Доски прилегают концами друг к другу, однако не соединяются между собой; вместо этого они прибиваются гвоздями к деревянному каркасу, а щели засмаливаются. Габариты: длина 37,5 футов, ширина 10 футов, высота борта 3 фута; нос и корма стреловидные. На расстоянии одной трети длины корпуса от носа установлена мачта с квадратным парусом. Конструкция достаточно прочная для использования в заливах и прибрежных водах.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лубки на ногу</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2</weight>
		<reference>LT146</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Splints, Leg
<img data-src="lib/img/151670708177.png">
Плоские деревянные доски, достаточно жесткие, накладываются вдоль сломанной конечности и привязываются, удерживая ее в нужном положении. Лубок для руки: $25, 1 фунт. Лубок для ноги: $50, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лубки на руку</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>1</weight>
		<reference>LT146</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Splints, Arm
<img data-src="lib/img/151670709610.png">
Плоские деревянные доски, достаточно жесткие, накладываются вдоль сломанной конечности и привязываются, удерживая ее в нужном положении. Лубок для руки: $25, 1 фунт. Лубок для ноги: $50, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук короткий</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>1.5</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>7†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Short Bow
<img data-src="http://weapons.gurps.ru/img/1910.png">

ЛУК (стр.72, Б275) целиком из дерева. КОРОТКИЙ ЛУК (стр.76) можно сделать практически из любой достаточно удобной ветки, хотя особой силой он отличаться не будет, это наиболее ранний вид луков. ОБЫЧНЫЙ ЛУК (стр.76) длиннее и мощнее. ДЛИННЫЙ ЛУК (стр.76) - знаменитое оружие английских лучников - вершина технологии изготовления не-составных луков, длинною как минимум 6 футов. Лучшие из длинных луков делаются из тиса, естественные физические свойства которого очень схожи с составными материалами.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук составной прямой</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>2.25</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>10†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-7</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Straight Composite Bow
<img data-src="http://weapons.gurps.ru/img/1961.png">

ЛУК (выше; стр.Б275), сделанный из нескольких слоев различных материалов, склеенных между собой. Это значительно увеличивает силу натяжения и количество запасаемой энергии, позволяя составному луку при натяжении сгибаться сильнее, чем простому того же размера (стр.73), не ломаясь.  (стр.76) по форме напоминает простой. Изогнутый лук имеет естественный обратный изгиб возле концов плечей, из-за чего натянутая на лук тетива находится под большим напряжением. Натягивание лука против этого напряжения позволяет накапливать больше энергии, что дает луку увеличенную дальность стрельбы и больший урон. В ВЫГНУТОМ ЛУКЕ (стр.76) этот механизм доведен до совершенства; когда тетива снята, плечи лука целиком выгибаются в противоположном от лучника направлении. Большинство составных луков изогнутые или выгнутые. Типичный вариант обладает той же силой что и ДЛИННЫЙ ЛУК (стр.73), но не такой громоздкий, что делает его удобным оружием для колесничих и всадников. Сюда же относится дай-кю (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Лук трубчатый</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>2</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>x20/x25</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Bow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Tubular Bow
<img data-src="http://weapons.gurps.ru/img/1999.png">

Гибкая планка, согнутая и удерживаемая под напряжением с помощью струны, натянутой между концами. Эта струна называется тетивой и позволяет использующему метать стрелы, помещая их на тетиву, натягивая и отпуская. Свойства лука зависят от материала, из которого он изготовлен: простой лук (стр.73) полностью состоит из дерева, СОСТАВНОЙ ЛУК (ниже) делается из различных материалов, склеиваемых между собой (также это относится к так называемым "ламинатным" лукам), а ТРУБЧАТЫЙ ЛУК (стр.75) из полых металлических, обычно стальных, трубок.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Макуавитль двуручный</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>650</value>
		<weight>5</weight>
		<reference>LT59</reference>
		<melee_weapon>
			<damage>sw+3(0.5) cut</damage>
			<strength>12†</strength>
			<usage>Swing</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Two-Handed Macuahuitl
<img data-src="http://weapons.gurps.ru/img/2000.png">

Деревянная дубина, с лезвиями, склеенными вместе из кусочков обсидиана. Обычно снабжается петлей для надежного крепления на запястье. Способно наносить рубящие удары, хотя обсидиановые фрагменты легко крошатся и откалываются. В случае если это оружие используется для парирования, само парируется любым оружием или наносит удар предмету с СП(DR) 2+, оно получает -1 к режущим повреждениям до тех пор, пока не будет отремонтировано (см. Материал клинка, стр.Б275). Дополнительно, при любой успешной атаке или успешном парировании удара оружием, бросьте 1d; на 1-2 лезвие ломается, превращая макуавитль в дубину, наносящую амп+1 (sw+1) дробящих повреждений. К счастью, у этого оружия две острых стороны - и владеющий им может менять их (свободное действие) если одно лезвие сломается. Размер варьируется от короткого МАКУАВИЦОЧТЛИ (выше) до ДВУРУЧНОГО МАКУАВИТЛЯ (стр.70).

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Малый меч</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>1.5</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Smallsword
<img data-src="http://weapons.gurps.ru/img/1942.png">

Франция.

Одноручный колющий меч, быстрый в атаке и защите, однако его легкий вес и малая досягаемость (reach) являются серьезными недостатками. КОСТЮМНЫЙ МЕЧ (стр.69) еще легче и короче, но может сойти за модный аксессуар. </description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Малый щит, лёгкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2083.png">

DB 1

DR 2

HP 14



Лёгкий (ТУ0) и тяжелый (ТУ1) варианты изготавливаются подобно большому и среднему щитам, но были ещё меньшего размера - малый щит редко выступал за предплечье. 

Даёт только DB 1, но очень манёвренный; в ближнем бою использующий получает только -1 DX (стр. Б392).

Лучники Среднего Востока иногда использовали такой щит и тренировались стрелять "под" ним, держа щит и лук в горизонтальном положении, а другие воины использовали нож рукой на которой был закреплен щит; в обоих случаях использующий получает штраф -2 к навыкам Щита и оружия, также, одноручное оружие получает штраф за использование не основной рукой.

Подробнее о этом приёме и правилах, связывающих ПЗ(DB) со штрафами к оружейному навыку, при использовании щита, читайте в GURPS Ранние Технологии Спутник 2.

</description-loc>
	<tech_level>0</tech_level>
	<value>30</value>
	<weight>3</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Малый щит, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2088.png">

DB 1

DR 4

HP 17



Лёгкий (ТУ0) и тяжелый (ТУ1) варианты изготавливаются подобно большому и среднему щитам, но были ещё меньшего размера - малый щит редко выступал за предплечье. 

Даёт только DB 1, но очень манёвренный; в ближнем бою использующий получает только -1 DX (стр. Б392).

Лучники Среднего Востока иногда использовали такой щит и тренировались стрелять "под" ним, держа щит и лук в горизонтальном положении, а другие воины использовали нож рукой на которой был закреплен щит; в обоих случаях использующий получает штраф -2 к навыкам Щита и оружия, также, одноручное оружие получает штраф за использование не основной рукой.

Подробнее о этом приёме и правилах, связывающих ПЗ(DB) со штрафами к оружейному навыку, при использовании щита, читайте в GURPS Ранние Технологии Спутник 2.

</description-loc>
	<tech_level>1</tech_level>
	<value>40</value>
	<weight>6</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>1</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательная палка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>sw-1 cr</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x4/x8</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Stick</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Throwing Stick
<img data-src="http://weapons.gurps.ru/img/1981.png">

Любая тяжелая палка, достаточно сбалансированная для метания.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательный дротик</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>thr imp</damage>
			<strength>6</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x2.5/x3.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Dart</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Throwing Dart
<img data-src="http://weapons.gurps.ru/img/1980.png">

Длинный дротик, снаряд похожий на тяжелую стрелу, или короткое метательное копье, который можно метать одной рукой. Некоторые снабжены стабилизатором из перьев или заканчиваются кисточкой, что гарантирует более предсказуемый полет и попадание в цель. Это не те дротики, которыми стреляет АТЛАТЛЬ (стр.72, Б276)! Сюда относятся джарид (Турция), нагеяри (Япония), скаен (Ирландия) и учинэ (Япония), а также плюмбата (Древний Рим), с тонкой металлической головкой, частично сделанной из свинца ("плюмбум" - свинец, от чего и произошло название оружия)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательный топор</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>4</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>10†</strength>
			<usage>Swung - two handed</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+2 cut</damage>
			<strength>11</strength>
			<usage>Thrown</usage>
			<accuracy>2</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Throwing Axe
<img data-src="http://weapons.gurps.ru/img/1977.png">

Европа.

ТОПОР (стр.54, Б271) сбалансированный для метания. Существует множество разновидностей. Полноразмерные версии имеют довольно длинную рукоять, что позволяет держать их двумя руками; используйте характеристики в разделе Двуручный Топор/Булава, которые изменяются при использовании этого оружия в Защитном Хвате, описанном в ГУРПС Боевые Искусства. МАЛЕНЬКИЙ МЕТАТЕЛЬНЫЙ ТОПОР (стр.65, 77) по размеру находится между полноразмерным топором и ТОПОРИКОМ. Крестообразные метательные топоры (и топорики), у которых отсутствует полноценная рукоять, дают штраф -2 к навыку при использовании в ближнем бою, но стоят на $10 меньше.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Метательный топор маленький</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>3</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Small Throwing Axe
<img data-src="http://weapons.gurps.ru/img/1937.png">
<img data-src="http://weapons.gurps.ru/img/2026.png">

ТОПОР (стр.54, Б271) сбалансированный для метания. Существует множество разновидностей. Полноразмерные версии имеют довольно длинную рукоять, что позволяет держать их двумя руками; используйте характеристики в разделе Двуручный Топор/Булава, которые изменяются при использовании этого оружия в Защитном Хвате, описанном в ГУРПС Боевые Искусства. МАЛЕНЬКИЙ МЕТАТЕЛЬНЫЙ ТОПОР (стр.65, 77) по размеру находится между полноразмерным топором и ТОПОРИКОМ. Крестообразные метательные топоры (и топорики), у которых отсутствует полноценная рукоять, дают штраф -2 к навыку при использовании в ближнем бою, но стоят на $10 меньше.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Меч двуручный колющий</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>900</value>
		<weight>7</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw+3 cut</damage>
			<strength>12†</strength>
			<usage>Swing</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>12†</strength>
			<usage>Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Thrusting Greatsword
<img data-src="http://weapons.gurps.ru/img/1988.png">

Европа.

Настоящий двуручный меч. Обычно острый с конца (КОЛЮЩИЙ ДВУРУЧНЫЙ МЕЧ, стр.70, Б274). Типичный европейский двуручный меч обладал рикассо - незаточенной, иногда покрытой кожей, прилегающей к рукояти частью клинка, за которую можно было ухватиться, и которая заканчивалась двумя выступающими шипами, предназначенными для защиты руки. Также к этому виду относятся большие нодати (Япония) и цвайхендеры (Германия).</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Микенский щит</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2087.png">

DB 3

DR 2

HP 17



Лёгкий большой щит, сплетенный из лозы и покрытый шкурой. Бывает двух видов: прямоугольный, с закругленной верхней кромкой, и в форме восьмёрки. Оба удерживаются исключительно при помощи гижа, ремня, переброшенного через шею, что позволяет использовать длинное копьё двумя руками. Эти щиты достаточно большие, чтобы остановить большинство атак, но ими тяжело управлять.



Управляется исключительно ремешком на шее; см. Хваты для Щитов (стр. 113-114)</description-loc>
	<tech_level>0</tech_level>
	<value>58</value>
	<weight>9</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мыло жидкое, 0.5 л</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Soap, Liquid, Pint
<img data-src="lib/img/151670687528.png">
Первое мыло, появившееся около первого века н.э., было полужидким и едким, и производилось смешиванием щёлока (см. Другие химикаты, стр. 26) с маслами. На ТУ3, уже в девятом веке, мыловары Средиземноморья обрабатывали жидкое мыло соленой водой, отделяя твердое мыло — которое прессовалось в бруски — от едких примесей. Пинта жидкого мыла: $20, 1 фунт. Кусок твердого мыла: $27, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Мыло твердое бурсок 0.5 кг</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>27</value>
		<weight>1</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Soap, Solid, Bar
<img data-src="lib/img/151670692216.png">
Первое мыло, появившееся около первого века н.э., было полужидким и едким, и производилось смешиванием щёлока (см. Другие химикаты, стр. 26) с маслами. На ТУ3, уже в девятом веке, мыловары Средиземноморья обрабатывали жидкое мыло соленой водой, отделяя твердое мыло — которое прессовалось в бруски — от едких примесей. Пинта жидкого мыла: $20, 1 фунт. Кусок твердого мыла: $27, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Набитый тканью доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2041.png">

Обычно либо плотный слой войлока (около 1/4” толщиной) либо набитая стеганка (два слоя ткани с прослойкой из ветоши, пакли, конского волоса, каменной соли, сушёной травы или соломы). Другие материалы могут давать схожую защиту; например, овечья шкура шерстью внутрь. Это – стандартный матерчатый доспех на с.Б283.



Время одевания 15 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>50</value>
	<weight>6</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>50</base-value>
		<base-weight>6</base-weight>
		<base-dr>1*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>1*</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Набор геодезиста</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>245</value>
		<weight>40</weight>
		<reference>LT43</reference>
		<categories>
			<category>Специализироване наборы</category>
		</categories>
		<description-loc>Surveyor's Kit
<img data-src="lib/img/151670863981.png"><img data-src="lib/img/151670865484.png">
Хорошо снаряженный геодезист со времен древнего Рима до эпохи Ренессанса нес с собой крестовину, диоптру, два 10-футовых шеста, 120 футов веревки (для сохранения длины пропитанной воском) и 20 колышков для отметок. $245, 40 ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Набор для пыток</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>150</value>
		<weight>8</weight>
		<reference>LT131</reference>
		<categories>
			<category>Специализироване наборы</category>
		</categories>
		<description-loc>Torture Kit
<img data-src="lib/img/151670920234.png">
Он состоит из множества небольших устройств для причинения боли: ножей, щипцов, молотков, металлических или бамбуковые щепок, паяльников для обжигания огнём, тиски для дробления костей (напр., тиски для больших пальцев)и др. Только воображение палача ограничивает разнообразие и сложность пыток! $150, 8 фунтов.

Хирургические инструменты (стр. 147-149) могут быть использованы в качестве импровизированного пыточного снаряжения.
</description-loc>
	</equipment><equipment version="3">
	<description>Нож маленький</description>
	<value>30</value>
	<weight>0.5</weight>
	<quantity>1</quantity>
	<melee_weapon>
		<damage>sw-3 cut</damage>
		<strength>5</strength>
		<reach>C,1</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Swung</usage>
	</melee_weapon>
	<melee_weapon>
		<damage>thr-1 imp</damage>
		<strength>7</strength>
		<reach>C</reach>
		<parry>-1</parry>
		<block>No</block>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<usage>Thrust</usage>
	</melee_weapon>
	<ranged_weapon>
		<damage>thr-1 imp</damage>
		<strength>5</strength>
		<accuracy>0</accuracy>
		<range>x0.5/x1</range>
		<rate_of_fire>1</rate_of_fire>
		<shots>T(1)</shots>
		<bulk>-1</bulk>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Thrown Weapon</name>
			<specialization>Knife</specialization>
			<modifier>0</modifier>
		</default>
		<usage>Thrown</usage>
	</ranged_weapon>
	<legality_class>4</legality_class>
	<tech_level>0</tech_level>
	<categories>
		<category>Холодное оружие</category>
	</categories>
	<reference>LT58</reference>
	<description-loc>
		Small Knife
		<img data-src="http://weapons.gurps.ru/img/1930.png">
		Любой одноручный клинок размером меньше меча, сделанный для эффективных режущих и колющих ударов. Самым легким является МАЛЕНЬКИЙ НОЖ (стр.67, 77, Б272, Б276), который также может быть сбалансирован для метания; примерами являются бхудж (Индия), козука (Япония) и писау (Индонезия).

Следующая категория размеров - БОЛЬШОЙ НОЖ (стр.67, 77, Б272, Б276), который чаще всего предназначается для сражения, и очень редко для метания; к такому оружия относятся почковый нож или почковый кинжал (Европа), дан ган (Корея), дирк (Европа), кард (Персия) и заточенный как долото танто (Япония).

Самым большим, от 15 до 23 дюймов, является ДЛИННЫЙ НОЖ (стр.69), который лишь немного меньше чем КОРОТКИЙ МЕЧ (стр.61, Б273), его нельзя метать. К длинным кинжалам относятся самые длинные версии дирка, карда и танто. Некоторые термины, вроде пунал (Филипины), описывают ножи любого размера. Стреловидные эмэйици (Китай) и сиангкам (Индонезия) тоже могут быть любого размера, но могут наносить только колющие удары. Оружие предназначенное специально для метания, см МЕТАТЕЛЬНЫЙ НОЖ (стр.77).
	</description-loc>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Нож метательный малый</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>0.5</weight>
		<reference>LT75</reference>
		<melee_weapon>
			<damage>sw-3 cut</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>C,1</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-2</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-7</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-5</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.8/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>0</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Knife</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Small Throwing Knife
<img data-src="http://weapons.gurps.ru/img/1939.png">

У настоящего метательного ножа гарда встречается редко, кроме этого часто отсутствует рукоять, такой нож сбалансирован для метания, а не для ближнего боя. Это дает штраф -2 к навыку ближнего боя. Как и все остальные, метательные ножи, могут различаться размерами; обычно встречаются БОЛЬШОЙ МЕТАТЕЛЬНЫЙ НОЖ (стр.77) и МАЛЕНЬКИЙ МЕТАТЕЛЬНЫЙ НОЖ (стр.77).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие на вертлюжной установке</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>1900</value>
		<weight>140</weight>
		<reference>LT87</reference>
		<ranged_weapon>
			<damage>6d+1 pi++</damage>
			<strength>27M†</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>90/900</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-8</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Cannon</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Swivel-Gun
<img data-src="lib/img/151670868965.png">
Это маленькая пушка, которая может быть установлена на планшире корабля или городской стене, и поворачиваться в сторону наступающего противника. Эти орудия вошли в обиход в ТУ3, в форме относительно маломощных пушек заряжаемых через казённик, и были эквивалентом нацеливаемых бомбард. Многие ТУ4 модели также заряжались через казённик. </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие на вертлюжной установке - шарнирные крепление</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1300</value>
		<weight>65</weight>
		<reference>LT89</reference>
		<categories>
			<category>Аксессуары тяжелых орудий</category>
		</categories>
		<description-loc>Swivel-Gun Pintle Mount
<img data-src="lib/img/151677485040.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Орудие на вертлюжной установке - ядро</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>50</value>
		<weight>2.5</weight>
		<reference>LT89</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Swivel-Gun Cannonball
<img data-src="lib/img/151677090776.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палица малая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>3</weight>
		<reference>LT58</reference>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>sw+1 cr</damage>
			<strength>10</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x1/x1.5</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>-3</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Axe/Mace</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Small Round Mace
<img data-src="http://weapons.gurps.ru/img/1935.png">

Любая несбалансированная одноручная боевая дубина с массивной каменной, деревянной или металлической дробящей головкой. Хотя гладкая ПАЛИЦА (стр.65, 70) и является древней, современные мастера боевых искусств все еще используют "арбузные молоты" и похожее оружие - иногда даже парно. Стандартная БУЛАВА (стр.65, 70, 77, Б271, Б276), с "перьями" (как пернач или шестопер) или шипами (см. МОРГЕНШТЕРН, с.?), для ударов сквозь латы, является классическим примером оружия средневековой Европы. Оба варианта представляют из себя булавы большого размера, с рукоятями, достаточно длинными для комфортного двуручного использования; используйте характеристики из раздела Двуручный Топор/Булава, которые изменяются во время использования оружия в Защитном хвате, описанном в GURPS Боевые Искусства. Тем не менее, большинство исторических экземпляров были меньше и легче: МАЛЕНЬКАЯ ПАЛИЦА (стр.65, 77) и МАЛЕНЬКАЯ БУЛАВА (стр.65, 77, Б271, Б276). Метательная булава является смертоносным снарядом; атакующий подбрасывает её в воздух, а не кидает по прямой траектории.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палка очень короткая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<weight>0.5</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw-1 cr</damage>
			<strength>5</strength>
			<usage>Swung</usage>
			<reach>C, 1</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>-1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Short Baton
<img data-src="http://weapons.gurps.ru/img/1908.png">
<img data-src="http://weapons.gurps.ru/img/2024.png">

Короткая, сбалансированная дубинка, обычно из дерева или металла. В том числе chung bong (Корея) dhot (Бурма), muchan (Индия) и mutton (Филипины), и узкие металлические segu (Индонезия). Некоторые короткие палки размером всего лишь с нож используйте для них параметры ОЧЕНЬ КОРОТКОЙ ПАЛКИ (стр. 67, 69). К очень коротким палкам относится dan bong (Корея).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палка-камнеметалка</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT72</reference>
		<ranged_weapon>
			<damage>sw-1 cr</damage>
			<strength>5</strength>
			<usage>Shoot Stone</usage>
			<accuracy>0</accuracy>
			<range>x2/x3</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(1)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear Thrower</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Spear</specialization>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки. Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Stone-Launching Stick
<img data-src="http://weapons.gurps.ru/img/1960.png">

Центральная Америка. 

Палка для метания каменных снарядов. Бывает двух видов. Первый - обыкновенная прямая палка. В качестве снарядов используются круглые плоские камни с отверстием в центре, они надеваются на палку, после чего взмахом метаются в цель. Второй - палка с вырезанным Y-образным пазом на одном из концов. Камни помещаются в паз (в этом случае отверстия не нужны) и метаются взмахом палки. В любом случае, для зарядки камня требуются обе руки, для атаки - только одна. Хотя это оружие и использует камни, принцип действия очень напоминает АТЛАТЛЬ (стр.Б276); поэтому в обоих случаях используется навык Копьеметалка. 



Требует обеих рук для Подготовки, но только одной руки для атаки.

Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Палка-камнеметалка - формованный камень</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.25</weight>
		<reference>LT77</reference>
		<notes>При извлечение из раны еще 1/2 damage</notes>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Stone-Launching Stick Shaped Stone
<img data-src="lib/img/151677150978.png ">
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Парирующий баклер</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2082.png">

+1 к Block

DB 1

DR 4

HP 16



Длинный, очень узкий баклер, используемый в Восточной Африке, Индии и Австралии. В Индии, иногда делается из двух, соединенных между собой, рогов антилопы. 

Место центрального хвата является самой толстой его частью; кромки, на обоих концах щита, закруглены. С их помощью можно наносить дробящие повреждения, также, чтобы наносить проникающие повреждения, можно добавить металлические наконечники (ТУ1): +1 ЦФ. Парирующий баклер даёт только DB 1, но также +1 к проверкам Блока (только).

</description-loc>
	<tech_level>0</tech_level>
	<value>50</value>
	<weight>8</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>1</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет-шнапхан</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>125</value>
		<weight>1.3</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d+1 pi</damage>
			<strength>7</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>40/420</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-2</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Snaphaunce Pistol
<img data-src="http://weapons.gurps.ru/img/1943.png">

Ранний вариант пистолета с кремнёвым замком, доступный с 1600, с относительно длинным 11-дюймовым стволом.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Пистолет-шнапхан - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.2</value>
		<weight>0.01</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Snaphaunce Pistol Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Полуторный меч колющий</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>750</value>
		<weight>5</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>11</strength>
			<usage>Swing - One Handed</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>11</strength>
			<usage>Thrust - One Handed</usage>
			<reach>2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+2 cut</damage>
			<strength>10†</strength>
			<usage>Swing - Two Handed</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+3 imp</damage>
			<strength>10†</strength>
			<usage>Thrust - Two Handed</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Thrusting Bastard Sword
<img data-src="http://weapons.gurps.ru/img/1982.png">

Этим мечом можно управляться и одной рукой, но его рукоятка достаточно длинная, чтобы использовать обе руки. Это позволяет использовать его как обычный двуручный (использовать навык двуручного меча) или защитным хватом, описанным в GURPS Боевые Искусства. Обычно конец был острым - в исторических кампаниях используйте КОЛЮЩИЙ ПОЛУТОРНЫЙ МЕЧ (стр. 66, 70, Б271, Б274). Его также называют меч-бастард. Включает в себя маленькие варианты нодати (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Посох короткий</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>1</weight>
		<reference>LT61</reference>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>6</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>6</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Short Staff
<img data-src="http://weapons.gurps.ru/img/1913.png">

Сбалансированная палка, длиною от 60 до 90 см, сделанная из ротанга (часто обожженного), для тренировок, или из твердого дерева, для сражений. Часто используется парно. Также может называться чунг бонг (Корея), палка эскрима (Филипины) и тонгкат (Индонезия).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.5</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>sw pi</damage>
			<strength>6</strength>
			<usage>Shoot</usage>
			<accuracy>0</accuracy>
			<range>x6/x10</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-4</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует обеих рук для Подготовки, но только одной руки для атаки. Может стрелять камнями (ТУ0) или свинцовыми пулями (ТУ2). Свинцовые пули дают +1 повреждений и удваивают расстояние.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Sling
<img data-src="http://weapons.gurps.ru/img/1924.png">
<img data-src="http://weapons.gurps.ru/img/2031.png">

Ремень или шнур с "карманом" или "чашей" куда помещается снаряд. Использующий кладет снаряд в карман, берется одной рукой за оба конца шнура, раскручивает заряженную пращу над головой (горизонтально) или в стороне от себя (вертикально), после чего отпускает один конец, запуская таким образом снаряд. Присоединение пращи к палке, удерживаемой двумя руками, увеличивает подъемную силу, и как следствие наносимые повреждения и дальность полета снаряда; это ПРАЩА-ПОСОХ (стр.76), также известная как фустибал (Европа). ТЯЖЕЛАЯ ПРАЩА (стр.76) предназначена для бросания крупных снарядов на короткую дистанцию. Для того чтобы зарядить снаряд и использовать её требуются обе руки; техника метания схожа с метанием молота. Любая праща, из этих трех, может метать камни или свинцовые пули, или даже примитивные коктейли Молотова (см. Коктейль Молотова или Сосуды с Маслом, стр.Б411), с Точ 0 и только на 40% от обычной Дальности. Праща для метания дротиков, известная в Македонии как КЕСТР (стр.76), предназначена для метания однофутовых оперенных дротиков; хотя она и похожа на стандартную пращу, они не могут использовать снаряды друг друга. Кестр также не может быть использован для метания коктейлей Молотава.



Требует обеих рук для Подготовки, но только одной руки для атаки.

Может стрелять камнями (ТУ0) или свинцовыми пулями (ТУ2). Свинцовые пули дают +1 повреждений и удваивают расстояние.


Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща - шарик</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.1</value>
		<weight>0.06</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Sling Pellet
<img data-src="lib/img/151676856673.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Праща-посох</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>2</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>sw+1 pi</damage>
			<strength>7†</strength>
			<usage>Shoot Stone</usage>
			<accuracy>1</accuracy>
			<range>x10/x15</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(2)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sling</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Может стрелять камнями (ТУ0) или свинцовыми пулями (ТУ2). Свинцовые пули дают +1 повреждений и удваивают расстояние.</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Staff Sling
<img data-src="http://weapons.gurps.ru/img/1956.png">
<img data-src="http://weapons.gurps.ru/img/2033.png">

Ремень или шнур с "карманом" или "чашей" куда помещается снаряд. Использующий кладет снаряд в карман, берется одной рукой за оба конца шнура, раскручивает заряженную пращу над головой (горизонтально) или в стороне от себя (вертикально), после чего отпускает один конец, запуская таким образом снаряд. Присоединение пращи к палке, удерживаемой двумя руками, увеличивает подъемную силу, и как следствие наносимые повреждения и дальность полета снаряда; это ПРАЩА-ПОСОХ (стр.76), также известная как фустибал (Европа). ТЯЖЕЛАЯ ПРАЩА (стр.76) предназначена для бросания крупных снарядов на короткую дистанцию. Для того чтобы зарядить снаряд и использовать её требуются обе руки; техника метания схожа с метанием молота. Любая праща, из этих трех, может метать камни или свинцовые пули, или даже примитивные коктейли Молотова (см. Коктейль Молотова или Сосуды с Маслом, стр.Б411), с Точ 0 и только на 40% от обычной Дальности. Праща для метания дротиков, известная в Македонии как КЕСТР (стр.76), предназначена для метания однофутовых оперенных дротиков; хотя она и похожа на стандартную пращу, они не могут использовать снаряды друг друга. Кестр также не может быть использован для метания коктейлей Молотава.


Может стрелять камнями (ТУ0) или свинцовыми пулями (ТУ2). Свинцовые пули дают +1 повреждений и удваивают расстояние.

Камень подходящей формы для пращи стоит $0.06. Обычные камни, подходящие для пращи, тяжелой пращи, и палки-камнеметалки, могут быть найдены бесплатно, однако атаки ими менее точные: штраф -1 к попаданию.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Ранняя Бригантина</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2058.png">

<img data-src="http://weapons.gurps.ru/img/2081.png">

-1 DR против crusing



Ранние европейские бригантины обычно состояли из перекрывающихся пластин - похожих на чешуйчатый доспех - зажатых между двумя слоями слегка подбитой ткани и удерживаемых на месте шнуром. Восточные ранние бригантины имеют индивидуальные карманы, в которые вшиваются пластины. Обе конструкции напоминают стёганую ткань, поэтому их просто скрыть (+1 к Holdout).



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>2</tech_level>
	<value>300</value>
	<weight>18</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>300</base-value>
		<base-weight>18</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Расширитель</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>1</weight>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Speculum
<img data-src="lib/img/151670696298.png">
Используется для расширения полостей тела, давая лучший обзор для Диагностики и уменьшая штраф из-за затрудненного доступа с -6 до -3. Различные полости тела требуют различных моделей. $60, 1 ф.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Режущие колесо</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>1</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+1 cut</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>0F</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<dr_bonus>
			<location>hands</location>
			<amount>4</amount>
		</dr_bonus>
		<description-loc>Slashing Wheel
<img data-src="http://weapons.gurps.ru/img/1923.png">

Китай. 

Полукруглое лезвие, иногда с зазубринами, удерживаемое за перекладины, используется для рубящих ударов. Часто используется парно. Идентично огненному колесу (Китай) и обладает такими же характеристиками.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Римский скутум, большой</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2095.png">

DB 3

DR 4

HP 27



Многослойная древесина (+20% НР).



Вариант баклера по образу большого тяжелого щита из многослойной древесины (берёзы), покрытого войлоком и обрамлённый металлом. Щит выносится перед собой и удерживается за горизонтальную ручку, руку защищает куполообразный умбон.

Республиканский скутум был овальной формы; и весил приблизительно 22 фунта, это один из самых тяжелых щитов активно использовавшихся во время сражений. Он идеален для штурмовых атак и может выдержать большое количество повреждений. 

Конструкция из многослойного дерева добавляет 20% НР, но делает его в два раза дороже, по сравнению с другими щитами (в общем, добавляет +1 ЦФ).

Скутум Имперского периода короче (ПЗ(DB) 2) и прямоугольной формы. Он также делается из слоёной березы, но покрыт кожей и снаружи - тканью. Края щита усилены сыромятной кожей, а не металлом. Все эти изменения делают его легче (около 16 фунтов) и манёвреннее. Средний скутум, как и большой скутум выше, состоит из многослойной древесины (берёзы), стоит в два раза дороже и получает на 20% больше НР.</description-loc>
	<tech_level>2</tech_level>
	<value>200</value>
	<weight>22</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>3</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>3</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Римский скутум, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2094.png">

DB 2

DR 4

HP 25



Многослойная древесина (+20% НР).



Вариант баклера по образу большого тяжелого щита из многослойной древесины (берёзы), покрытого войлоком и обрамлённый металлом. Щит выносится перед собой и удерживается за горизонтальную ручку, руку защищает куполообразный умбон.

Республиканский скутум был овальной формы; и весил приблизительно 22 фунта, это один из самых тяжелых щитов активно использовавшихся во время сражений. Он идеален для штурмовых атак и может выдержать большое количество повреждений. 

Конструкция из многослойного дерева добавляет 20% НР, но делает его в два раза дороже, по сравнению с другими щитами (в общем, добавляет +1 ЦФ).

Скутум Имперского периода короче (ПЗ(DB) 2) и прямоугольной формы. Он также делается из слоёной березы, но покрыт кожей и снаружи - тканью. Края щита усилены сыромятной кожей, а не металлом. Все эти изменения делают его легче (около 16 фунтов) и манёвреннее. Средний скутум, как и большой скутум выше, состоит из многослойной древесины (берёзы), стоит в два раза дороже и получает на 20% больше НР.</description-loc>
	<tech_level>2</tech_level>
	<value>140</value>
	<weight>16</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Ружейный ремень</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT96</reference>
		<categories>
			<category>Оружейные аксессуары</category>
		</categories>
		<description-loc>Sling, Long Arm
<img data-src="lib/img/151670648411.png">
Является стандартом для гренадёрской фузеи (см. Мушкеты, стр.92-93), однако его можно приспособить для других ружей. Позволяет стрелку использовать обе руки, и при этом не бояться уронить ружье. Снятие или надевание ружья с ремнем требует двух манёвров Подготовки - или трёх, если ремень перебрасывается через спину. При снятии ремня, успешная проверка навыка Быстрое выхватывание (Ружьё) снижает затрачиваемое время на одну секунду. Ремень также позволяет стрелку фиксировать оружие без использования опоры, что дает дополнительный +1 при прицеливании; см. Прицеливание (стр.Б364). Фиксирование оружия при помощи ремня использует обе руки и один маневр Подготовки за каждый -1 Гром.; т.е. 5 секунд для Громоздкости -5. Выход из этого положения, освобождающий руки, требует маневра подготовки. $10, 1 фунт.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сани</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>2000</value>
		<weight>600</weight>
		<reference>LT135</reference>
		<notes>Впрягаются лошади</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Sleigh
<img data-src="lib/img/151670539281.png">
Появившееся в 17 веке рассчитанное для использования по снегу средство передвижения с полозьями, которое тянут лошади. Модель в таблице - на одну лошадь и с достаточно широким сиденьем, чтобы поместилось два человека.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Селитра</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<weight>1</weight>
		<reference>LT84</reference>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Saltpeter
<img data-src="lib/img/151670277631.png">
Нитраты начали использовать как растопку на ТУ1, если не раньше, но чистая селитра была выделена лишь на ТУ3. Хотя в некоторых местах селитру добывали из залежей гуано, её преимущественно синтезировали. Навоз смешивали с гашёной известью или древесным пеплом и держали влажным несколько месяцев. Селитра вымывалась и высушивалась в кристаллы. При нагреве селитра выделяет кислород, что делает её окислителем во взрывчатке (см. Горючие вещества, стр. 84).
</description-loc>
	</equipment><equipment version="3">
		<quantity>4</quantity>
		<description>Серные спички</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>LT35</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Sulfur Matches
<img data-src="lib/img/151670848376.png">
Обработанные серой сосновые щепки появились в Китае в шестом столетии нашей эры, и к двенадцатому столетию распространились по Европе. Эти спички не были самовоспламеняющимися; но они зажигались от любой искры. Таким образом, это был просто очень хороший трут. Уменьшите время разведения огня вчетверо. Связка из 20 штук: $5, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Серп</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>2</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw imp</damage>
			<strength>8</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Sickle
<img data-src="http://weapons.gurps.ru/img/1919.png">

Инструмент земледельцев, который можно использовать в качестве оружия. Лезвия на боевых серпах обычно прямые, а не серпообразные. Это позволяет использовать цепляющие и маховые проникающие атаки. Включает арит (Индонезия), фалькс (Дакия) и каму (Япония).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Серпоносная колесница</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>660</value>
		<weight>780</weight>
		<reference>LT137</reference>
		<notes>Впрягаются лошади; дорожный транспорт</notes>
		<categories>
			<category>Наземный транспорт</category>
		</categories>
		<description-loc>Scythed Chariot
<img data-src="lib/img/151670308237.png">
Серпоносная колесница (ТУ2) - это тяжелая колесница с режущими клинками, установленными на оси на угол, изобретенная ассирийцами, а позже принятая на вооружение персами. Рассчитывайте удар серпами как наносящий режущие повреждения, основанные на Движении и ЕЖ(HP) колесницы, как при столкновении (с. Б430). Это хорошо работает только против плотных построений; солдаты в рассыпном строю, как правило, имеют время, чтобы отойти в сторону.

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Серьга золотая</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>0.02</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Piercing, gold
<img data-src="lib/img/151669958857.png">
Маленькое украшение с крохотным металлическим крючком, цепляемым за заранее проколотую часть тела.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Серьга медная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.01</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Piercing, copper
<img data-src="lib/img/151669950416.png">
Маленькое украшение с крохотным металлическим крючком, цепляемым за заранее проколотую часть тела.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Серьга серебряная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.01</weight>
		<reference>LT38</reference>
		<categories>
			<category>Украшения</category>
		</categories>
		<description-loc>Piercing, silver
<img data-src="lib/img/151669965304.png">
Маленькое украшение с крохотным металлическим крючком, цепляемым за заранее проколотую часть тела.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Скальные крючья</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>4</value>
		<weight>0.75</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Piton
<img data-src="lib/img/151669994605.png">
Скальный крюк это штырь или заострённый клин с ушком через которое можно протянуть веревку или шнур. Используется для лазания по вертикальным поверхностям у которых отсуствуют точки опоры. Скальный крюк вставляется в трещину (или забивается в дерево или лёд) на глубину достаточную для удержания присоединенного веса. Скалолаз использует один крюк в качестве опоры, а следующий забивает на большей высоте. После чего перемещает свой вес на второй крюк, с помощью шнура вытягивает предыдущий и снова использует его. Эта довольно непростая техника - крючья следует вбивать настолько глубоко, чтобы они выдерживали вес скалолаза, но не настолько, чтобы их нельзя было извлечь, вытащив за шнур. При таком использовании скальные крючья убирают штраф -2 за лазание по вертикальной поверхности.

Для большей надежности скальный крюк можно забить поглубже. Это убирает штрафы вплоть до -3, но вытащить крюк становится невозможным. Этот метод более надежен, поскольку веревку можно прицепить к каждому крюку, что предотвращает падение.

В ближнем бою скальный крюк может быть использован в качестве импровизированного кинжала (-2 к навыка), или брошен как маленький грубый метательный нож (-4 к навыку).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Скальные крючья - молоток</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT125</reference>
		<categories>
			<category>Лазательное Снаряжение</category>
		</categories>
		<description-loc>Piton Hammer
<img data-src="lib/img/151669998069.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Скальпель
</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>30</value>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Scalpel
<img data-src="lib/img/151670294886.png">
Для разрезания. $30, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сларбоу</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>1000</value>
		<weight>8</weight>
		<reference>LT74</reference>
		<ranged_weapon>
			<damage>thr+3 imp</damage>
			<strength>9†</strength>
			<usage>Fire 2 medium darts</usage>
			<accuracy>1</accuracy>
			<range>x25/x30</range>
			<rate_of_fire>1x2</rate_of_fire>
			<shots>1(2i)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<ranged_weapon>
			<damage>thr+2 imp</damage>
			<strength>9†</strength>
			<usage>Fire 5 small darts</usage>
			<accuracy>1</accuracy>
			<range>x15/x20</range>
			<rate_of_fire>1x5</rate_of_fire>
			<shots>1(2i)</shots>
			<bulk>-6</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Crossbow</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Требует нескольких маневров Подготовки для взведения тетивы до укладки дротиков; используйте стандартное время взведения для арбалетов, описанное в Луки, Арбалеты и Расчетная СЛ(ST) (стр.74)</notes>
		<categories>
			<category>Метательное оружие</category>
		</categories>
		<description-loc>Slurbow
<img data-src="http://weapons.gurps.ru/img/1925.png">
<img data-src="http://weapons.gurps.ru/img/2034.png">

Европа, Османская Империя. 

СОСТАВНОЙ АРБАЛЕТ (стр.76) с довольно необычным направляющим пазом (стр.72), сделанным таким образом, что его можно зарядить одним или, что удивительно, несколькими маленькими дротиками. Представленные характеристики подразумевают заряд из двух средних дротиков или пяти маленьких.

Требует нескольких маневров Подготовки для взведения тетивы до укладки дротиков; используйте стандартное время взведения для арбалетов, описанное в Луки, Арбалеты и Расчетная СЛ(ST) (стр.74)</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сларбоу - болт</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.03</weight>
		<reference>LT76</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Slurbow Dart
<img data-src="lib/img/151676767496.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Содэгарами</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>4</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>sw+2 cr</damage>
			<strength>7†</strength>
			<usage>Swung</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>7†</strength>
			<usage>Thrust</usage>
			<reach>1,2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-1 cut</damage>
			<strength>7†</strength>
			<usage>Hook Thrust</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<notes>Крюк позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Sodegarami
<img data-src="http://weapons.gurps.ru/img/1944.png">

Япония. 

Укрепленный металлом посох с зубцами по всей длине и зазубренной головкой, Т-образной или в форме вилки. Такое строение позволяет цепляться за одежду; см. Крюк (стр.54) для стандартной атаки. Похожая на него сасумата заканчивается широкой тупой вилкой предназначенной для удержания тела противника. Используйте те же самые статистики, но уберите прм+2 дробящую (thr+2 cr) атаку. Однако, использующий сасумату может пихать (стр.Б372) стоящего оппонента используя навык Посох, или удерживать (стр.Б370) его, в случае если оппонент прижат к стене или полу - в обоих случаях на Досягаемости (reach) 1, 2. Также к этому оружию относится Мэнкетчер (Европа). Урга (Монголия), представляет из себя веревочную петлю, закрепленную на конце древка, используется как древковое оружие и может опутывать как лассо (стр.Б411): Досягаемость (reach) 2, 3*, Цена $40, Вес 6 фунтов.

Крюк позволяет использовать правила для Крюка (стр.54), и также может ранить жертву.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Солнечные часы переносные</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>2</weight>
		<reference>LT44</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Portable Sundial
<img data-src="lib/img/151670023426.png">
Более продвинутое греческое изобретение, показывающее время: солнечные часы, достаточно маленькие, чтобы их можно было легко носить. Чтобы показывать время на новом месте, нужно навести их на полуденное солнце. 100$, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Соломяный доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2048.png">

<img data-src="http://weapons.gurps.ru/img/2075.png">

Будучи тяжелым и неудобным, соломенный доспех предлагает неплохую защиту за мизерные деньги. Во время своей последней экспедиции английский путешественник Джеймс Кук пытался усмирить гавайского аборигена мелкой дробью из мушкета. Его противник упал на землю, но соломенный доспех защитил его от серьезных ран. Солома может загореться (см. Тростник, выше)



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>50</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>50</base-value>
		<base-weight>20</base-weight>
		<base-dr>2</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>2</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Спрингалд</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>5400</value>
		<reference>LT80</reference>
		<ranged_weapon>
			<damage>5d+3 imp</damage>
			<strength>33M†</strength>
			<usage>Fire</usage>
			<accuracy>1</accuracy>
			<range>90/110</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(20)</shots>
			<bulk>-11/-14</bulk>
			<recoil>2</recoil>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Gunner</name>
				<modifier>-4</modifier>
			</default>
		</ranged_weapon>
		<notes>Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Springald
<img data-src="lib/img/151670725853.png">
Обладает странной гибридной конструкцией: однозарядное орудие, как монанкон (стр.81) или требушет (стр.81), но метает болты вместо камней, и используется для прямого обстрела, а не для стрельбы навесом.

Источника энергии флексионный: толстый деревянный рычаг, подобный половине лука, который оттягивают назад при помощи лебедки, а затем отпускают. Выпрямляясь, он бьет по тыльной стороне болта, выбивая его из желоба в верхней части орудия. Спрингалды в основном использовались для защиты укреплений от приступов осаждающих.



Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Спрингалд - болт</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>66</value>
		<weight>2</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Springald Bolt
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Средний щит, лёгкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2085.png">

DB 2

DR 2

HP 16



Лёгкий (ТУ0) и тяжелый (ТУ1) варианты изготавливались так же как и большой щит (выше), но были меньшего размера и закрывали тело от подбородка до бёдер. В том или ином виде эти щиты использовались большинством культур до конца Средних Веков. Средний щит может быть различной формы, но самой распространенной является круглая. Среди прочих, особенно выделяется щит в форме полумесяца - пельта, использовавшийся Греческими пельтастами, Скифами и другими культурами на востоке Центральной Еворопы.</description-loc>
	<tech_level>0</tech_level>
	<value>45</value>
	<weight>7</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Средний щит, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2090.png">

DB 2

DR 4

HP 20



Лёгкий (ТУ0) и тяжелый (ТУ1) варианты изготавливались так же как и большой щит (выше), но были меньшего размера и закрывали тело от подбородка до бёдер. В том или ином виде эти щиты использовались большинством культур до конца Средних Веков. Средний щит может быть различной формы, но самой распространенной является круглая. Среди прочих, особенно выделяется щит в форме полумесяца - пельта, использовавшийся Греческими пельтастами, Скифами и другими культурами на востоке Центральной Еворопы.</description-loc>
	<tech_level>1</tech_level>
	<value>60</value>
	<weight>14</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стек</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Riding Crop
<img data-src="lib/img/151670135232.png">
Длинная трость, обычно 2-3 фута, оплетённая кожей с коротким и гибким кожаным отрезом на конце. Используется для шлепков или ударов по бокам лошади, даёт +1 к Верховой езде при попытках управлять животным. Можно держать в той же руке, что и поводья. $10, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стилет</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>20</value>
		<weight>0.25</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr-1 imp</damage>
			<strength>5</strength>
			<usage>Thrust</usage>
			<reach>C</reach>
			<parry>1</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Main-Gauche</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Stiletto
<img data-src="http://weapons.gurps.ru/img/1959.png">

Италия. Тонкий, жесткий кинжал который может пробивать звенья кольчуги и сочленения полного доспеха. Узкое лезвие убирает штраф -2 за прицеливание в уязвимые места брони (стр.Б400).



Снижает штраф за прицеливание в уязвимые места брони (стр.Б400) на -2.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стило</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<reference>LT46</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Stylus
<img data-src="lib/img/151670837028.png">
Металлическим стилом (см. мягкие жёсткие носители, стр. 46) можно проводить тонкие линии по плоским носителям. Использовались свинец, медь, серебро (+4 ЦФ) и золото (+99 ЦФ). Предпочиталось серебро, потому что его линии не стираются. Лучше всего работает с бумагой, обработанной глиной или органическими клейкими веществами.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стремена</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>125</value>
		<weight>5</weight>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Stirrups
<img data-src="lib/img/151670748953.png">
Изобретенные, скорее всего, в Центральной Азии, стремена изображаются в китайском искусстве с 322 г. н.э. и достигают Западной Европы к 700 г. н.э. Они позволяют вскакивать на лошадь без штрафа к умению или залезать медленнее, но без проверки умения (см. с. Б396). Они дают +1 к Верховой езде при попытках управлять животным. Всадник может привстать в стременах при атаке, получая дополнительный фут преимущества по высоте перед жертвой. С боевым седлом (но не с седлом с рогами) всадник может прижаться к задней луке с помощью ног, создавая устойчивый упор для таранного удара лансой; это необходимо для умения Ланса. $125, 5 футов.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Стригиль</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>6</value>
		<weight>0.5</weight>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Strigil
<img data-src="lib/img/151670833376.png">
Инструмент, похожий на тупой нож с сильно погнутым лезвием. До изобретения мыла при мытье обмазывались маслом, которое затем вместе с грязью соскребали стригилем. Хотя обычно считается, что его ввели в обращение греки и римляне, стригиль появился около 3000 г. до н.э. Некоторые стригили шли в наборах разного размера для разных частей тела, соединенные как ключи на кольце.Каждый стригиль: $6, 0.5 фунта.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Стёганка, Лёгкая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2043.png">

<img data-src="http://weapons.gurps.ru/img/2074.png">

Обычно либо плотный слой войлока (около 1/4” толщиной) либо набитая стеганка (два слоя ткани с прослойкой из ветоши, пакли, конского волоса, каменной соли, сушёной травы или соломы). Другие материалы могут давать схожую защиту; например, овечья шкура шерстью внутрь. Это – стандартный матерчатый доспех на с.Б283.



Время одевания 20 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>150</value>
	<weight>12</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>150</base-value>
		<base-weight>12</base-weight>
		<base-dr>2*</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>2*</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Стёганка, Средняя</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2044.png">

<img data-src="http://weapons.gurps.ru/img/2077.png">

Обычно либо плотный слой войлока (около 1/4” толщиной) либо набитая стеганка (два слоя ткани с прослойкой из ветоши, пакли, конского волоса, каменной соли, сушёной травы или соломы). Другие материалы могут давать схожую защиту; например, овечья шкура шерстью внутрь. Это – стандартный матерчатый доспех на с.Б283.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>350</value>
	<weight>20</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>350</base-value>
		<base-weight>20</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Стёганка, Тяжёлая</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2045.png">

<img data-src="http://weapons.gurps.ru/img/2073.png">

Обычно либо плотный слой войлока (около 1/4” толщиной) либо набитая стеганка (два слоя ткани с прослойкой из ветоши, пакли, конского волоса, каменной соли, сушёной травы или соломы). Другие материалы могут давать схожую защиту; например, овечья шкура шерстью внутрь. Это – стандартный матерчатый доспех на с.Б283.



Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>600</value>
	<weight>28</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>600</base-value>
		<base-weight>28</base-weight>
		<base-dr>4</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сюрикен-звездочка</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-1 cut</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>0</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Shuriken</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<notes>Используется для лазания. Атаки в ближнем бою идут по умению ближнего боя и получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Star Shuriken
<img data-src="http://weapons.gurps.ru/img/1957.png">

Япония.

Целый класс металлических метательных клинков - достаточно маленьких, чтобы прятать их в одежде или прическе - метаются обычно при помощи резкого движения ладонью или во время разгибания запястья. Исторически, сюрикены были оружием не только ниндзя, но и самураев. Самым известным является СЮРИКЕН-ЗВЕЗДОЧКА (стр.77), диско-, кресто- или звездо-образной формы, с острыми краями или выступами. У большинства таких от трех до девяти вершин, но чаще - четыре или восемь. Также существуют варианты S-образной формы. В любом сюрикене могут быть вырезаны отверстия, в результате чего во время полета он издает характерный звук - это может служить для психологического эффекта, сигнализирования или просто для вида. СЮРИКЕН-ШИП (стр.77) по форме напоминает иглу. Одна из сторон острая, другая может быть тупой, острой или со стабилизатором. В плане характеристик, между "звездочкой" и "шипом", нет никаких различий. Несколько сюрикенов можно зажать в кулаке и использовать в качестве "когтей"; см. Таблицу Оружий Ближнего боя (стр.65). Также сюда относятся пиау (Индонезия).



Используется для лазания.

Атаки в ближнем бою идут по умению ближнего боя и получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Сюрикен-шип</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>3</value>
		<weight>0.1</weight>
		<reference>LT73</reference>
		<melee_weapon>
			<damage>thr-2 cut</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<ranged_weapon>
			<damage>thr-2 imp</damage>
			<strength>5</strength>
			<usage>Thrown</usage>
			<accuracy>1</accuracy>
			<range>x0.5/x1</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>T(1)</shots>
			<bulk>0</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Thrown Weapon</name>
				<specialization>Shuriken</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<notes>Используется для лазания. Атаки в ближнем бою идут по умению ближнего боя и получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Spike Shuriken
<img data-src="http://weapons.gurps.ru/img/1953.png">
<img data-src="http://weapons.gurps.ru/img/2035.png">

Япония.

Целый класс металлических метательных клинков - достаточно маленьких, чтобы прятать их в одежде или прическе - метаются обычно при помощи резкого движения ладонью или во время разгибания запястья. Исторически, сюрикены были оружием не только ниндзя, но и самураев. Самым известным является СЮРИКЕН-ЗВЕЗДОЧКА (стр.77), диско-, кресто- или звездо-образной формы, с острыми краями или выступами. У большинства таких от трех до девяти вершин, но чаще - четыре или восемь. Также существуют варианты S-образной формы. В любом сюрикене могут быть вырезаны отверстия, в результате чего во время полета он издает характерный звук - это может служить для психологического эффекта, сигнализирования или просто для вида. СЮРИКЕН-ШИП (стр.77) по форме напоминает иглу. Одна из сторон острая, другая может быть тупой, острой или со стабилизатором. В плане характеристик, между "звездочкой" и "шипом", нет никаких различий. Несколько сюрикенов можно зажать в кулаке и использовать в качестве "когтей"; см. Таблицу Оружий Ближнего боя (стр.65). Также сюда относятся пиау (Индонезия).



Используется для лазания.

Атаки в ближнем бою идут по умению ближнего боя и получают такой же бонус к урону при использовании умений Бокс (стр.Б182), Драка (стр.Б182), или Карате (стр.Б203), как и безоружные атаки.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Табак</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>10</value>
		<weight>0.25</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Tobacco
<img data-src="lib/img/151670875546.png">
Одного фунта хватает на 30 забивок трубки или самокрутных сигар или сигарет; такой табак стоит $12 за фунт. Пачка из 10 готовых табачных изделий, завёрнутых в листья до ТУ3, а затем в бумажной обертке: $10, 0.25 фунта. Табак с ароматом мёда или фруктового сока (ТУ3): +2 ЦФ.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Танцуцу</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>610</value>
		<weight>4.5</weight>
		<reference>LT93</reference>
		<ranged_weapon>
			<damage>1d+2 pi++</damage>
			<strength>11</strength>
			<usage>Shoot</usage>
			<accuracy>1</accuracy>
			<range>40/400</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(45)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Pistol</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Tantsutsu
<img data-src="http://weapons.gurps.ru/img/1963.png">

С фитильным замком

Японское огнестрельное оружие, похожее на теппо (стр. 92), предназначенное для использования всадниками и доступное лишь благородным достаточно богатым, чтобы позволить себе лошадь. Танцуцу делают как парадное оружие; см. Украшенное (стр. 14). Пример в Таблице Пистолетов (стр. 94) имеет +4 ЦФ. Танцуцу используют порошковый порох.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Танцуцу - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>1.2</value>
		<weight>0.06</weight>
		<reference>LT94</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Tantsutsu Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Тарч</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2097.png">

DB 2

DR 4

HP 19



К концу 13 века, Европейский каплевидный щит (ниже) был заменен более маленьким - тарчем. Он всё ещё сужается книзу до острия, но это не обеспечивает никакой дополнительной выгоды по сравнению с прочими формами щита - хотя, возможно, его проще использовать во время езды верхом. Считайте средним щитом.</description-loc>
	<tech_level>3</tech_level>
	<value>75</value>
	<weight>13</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Теппо</description>
		<tech_level>4</tech_level>
		<legality_class>2</legality_class>
		<value>170</value>
		<weight>8.6</weight>
		<reference>LT92</reference>
		<ranged_weapon>
			<damage>1d+2 pi+</damage>
			<strength>8†</strength>
			<usage>Shoot</usage>
			<accuracy>2</accuracy>
			<range>45/500</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(60)</shots>
			<bulk>-5</bulk>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<specialization>Musket</specialization>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Guns</name>
				<modifier>-2</modifier>
			</default>
		</ranged_weapon>
		<categories>
			<category>Пороховое оружие</category>
		</categories>
		<description-loc>Teppo
<img data-src="http://weapons.gurps.ru/img/1969.png">

С фитильным замком

Японская аркебуза, впервые изготовленная в 1543 году на острове Танешигама, в подражание португальскому образцу. Размеры бывали разные, но это - стандартая модель, выдаваемая армиям сёгуна: 53.5 дюймов длиной, со стволом из прокованного железа. Фитильные замки продолжали использоваться в Японии долгое время после того, как Европа перешла на кремниевые и капсульные (ТУ5). Теппо использует порошковый порох.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Теппо - пуля</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>0.5</value>
		<weight>0.025</weight>
		<reference>LT93</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Teppo Bullet
<img data-src="lib/img/151672076790.png">
Раннее огнестрельное оружие заряжали порохом, пулей и пыжом - в этом порядке. Каждую часть заряжали отдельно. Шведский король Гюстав Адольф, желая, чтобы его войска стреляли быстрее, принял на вооружение бумажные патроны, содержащие заранее отмеренное количество пороха; солдат отрывал конец патрона, высыпал порох, а потом использовал бумагу в качестве пыжа, что экономило время. Правила и дополнительную информацию см. в разделе Зарядка (стр. 94-95).

На ТУ3, порох - это порошковый порох. На ТУ4 гранулированный порох заменяет его в личном огнестрельном оружии; только аркебуза и японское огнестрельное оружие использует порошковый. Стандартый материал для пуль - свинец. Дула не стандартизованы, хоть в лоу-техе они расписаны так, как будто бы были; большинство владельцев оружия носят снаряжение для отливки собственных пуль (см. снаряжение для отливки пуль, стр. 96). В этот исторический период пули сферические и иногда называются ядрами. Исключением было ружьё Пакла (стр. 92-93)


</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Тонфа</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>40</value>
		<weight>1.5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>thr cr</damage>
			<usage>Butt jab</usage>
			<reach>C</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw cr</damage>
			<strength>7</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr cr</damage>
			<strength>7</strength>
			<usage>Thrust</usage>
			<reach>C, 1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<notes>Thr атака наносится ручкой, ее  так-же можно выполнять по умению DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Tonfa
<img data-src="http://weapons.gurps.ru/img/1990.png">

Общий термин для дубин размером от ДУБИНКИ РАБОТОРГОВЦА (стр.55, Б271) до ДУБИНКИ (стр.54, Б273)



Thr атака наносится ручкой, ее  так-же можно выполнять по умению DX / Boxing / Brawing / Karate, получают такой же бонус к урону от умения как и безоружные атаки.

Так-же можно использовать парирования по Brawing / Karate 

</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Топор маленький</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>45</value>
		<weight>3</weight>
		<reference>LT54</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Small Axe
<img data-src="http://weapons.gurps.ru/img/1927.png">

Клиновидное лезвие на деревянной рукоятке, рассчитанное на использование одной рукой и не сбалансированное для метания. У него достаточно длинная рукоять, чтобы его удобно было использовать двумя руками; используйте параметры, приведённые в разделе "двуручный топор/булава", которые отличаются от защитного хвата оружия, определённого в GURPS Боевые Искусства. В эту категорию входят топор "эпсилон" (шумерский) и масакари (японский). Топоры бывают разных форм и размеров, от МАЛЕНЬКОГО ТОПОРА (стр. 65), который лишь чуть больше, чем ТОПОРИК (стр. 56, Б271) и ДЛИННЫЙ ТОПОР (стр. 58, 70).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет большой</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>240000</value>
		<weight>56000</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>6dx3 cr</damage>
			<strength>530M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>1</accuracy>
			<range>290/360</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(450)</shots>
			<bulk>-22/-27</bulk>
			<recoil>4</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 30 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Trebuchet, Large
<img data-src="lib/img/151670940169.png">
Классическая средневековая «катапульта», создана для разрушения крепостных стен при помощи огромных камней. По конструкции похож на перье (выше), однако человеческая тяга заменена массивным противовесом. У обыкновенного требушета противовес жестко крепился к концу короткого плеча. В усовершенствованных моделях противовес крепился при помощи петель, что позволяло ему раскачиваться под различными углами и опускаться более вертикально, когда он тянул вниз короткое плечо. Такой требушет расходовал запасенную в противовесе энергию более эффективно и, соответственно, мог поражать цели на большем расстоянии.





Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 30 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет большой - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>80</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Trebuchet, Large Stone
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет малый</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>75000</value>
		<weight>17500</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>13d+2 cr</damage>
			<strength>330M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>1</accuracy>
			<range>265/330</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(300)</shots>
			<bulk>-20/-25</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 25 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Trebuchet, Small
<img data-src="lib/img/151670940169.png">
Классическая средневековая «катапульта», создана для разрушения крепостных стен при помощи огромных камней. По конструкции похож на перье (выше), однако человеческая тяга заменена массивным противовесом. У обыкновенного требушета противовес жестко крепился к концу короткого плеча. В усовершенствованных моделях противовес крепился при помощи петель, что позволяло ему раскачиваться под различными углами и опускаться более вертикально, когда он тянул вниз короткое плечо. Такой требушет расходовал запасенную в противовесе энергию более эффективно и, соответственно, мог поражать цели на большем расстоянии.





Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.



Требуется персонал 25 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет малый - камень</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<weight>25</weight>
		<reference>LT81</reference>
		<categories>
			<category>Боеприпасы</category>
		</categories>
		<description-loc>Trebuchet, Small Stone
<img data-src="lib/img/151672143348.png">
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет петельный большой</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>210000</value>
		<weight>44000</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>17d cr</damage>
			<strength>470M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>1</accuracy>
			<range>510/660</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(450)</shots>
			<bulk>-21/-26</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 30 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Trebuchet, Hinged, Large
<img data-src="lib/img/151670940169.png">
Классическая средневековая «катапульта», создана для разрушения крепостных стен при помощи огромных камней. По конструкции похож на перье (выше), однако человеческая тяга заменена массивным противовесом. У обыкновенного требушета противовес жестко крепился к концу короткого плеча. В усовершенствованных моделях противовес крепился при помощи петель, что позволяло ему раскачиваться под различными углами и опускаться более вертикально, когда он тянул вниз короткое плечо. Такой требушет расходовал запасенную в противовесе энергию более эффективно и, соответственно, мог поражать цели на большем расстоянии.



Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 30 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Требушет петельный малый</description>
		<tech_level>3</tech_level>
		<legality_class>2</legality_class>
		<value>70000</value>
		<weight>17500</weight>
		<reference>LT81</reference>
		<ranged_weapon>
			<damage>12d+2 cr</damage>
			<strength>295M†</strength>
			<usage>Fire Stone</usage>
			<accuracy>1</accuracy>
			<range>480/600</range>
			<rate_of_fire>1</rate_of_fire>
			<shots>1(300)</shots>
			<bulk>-19/-24</bulk>
			<recoil>3</recoil>
			<default>
				<type>IQ</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Artillery</name>
				<specialization>Catapult</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<notes>Минимальное расстояние равняется 25% от максимального расстояния. Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов. Требуется персонал 25 чел.</notes>
		<categories>
			<category>Тяжелые орудия</category>
		</categories>
		<description-loc>Trebuchet, Hinged, Small
<img data-src="lib/img/151670941916.png">
Классическая средневековая «катапульта», создана для разрушения крепостных стен при помощи огромных камней. По конструкции похож на перье (выше), однако человеческая тяга заменена массивным противовесом. У обыкновенного требушета противовес жестко крепился к концу короткого плеча. В усовершенствованных моделях противовес крепился при помощи петель, что позволяло ему раскачиваться под различными углами и опускаться более вертикально, когда он тянул вниз короткое плечо. Такой требушет расходовал запасенную в противовесе энергию более эффективно и, соответственно, мог поражать цели на большем расстоянии.


Минимальное расстояние равняется 25% от максимального расстояния.

Орудие с прямоугольным основанием; см. предисловие к таблицы для описания эффектов.

Требуется персонал 25 чел.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Трезубец</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>80</value>
		<weight>5</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>thr + 3 (0.5) imp</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+4 (0.5) imp</damage>
			<strength>10†</strength>
			<usage> Thrust - two hands</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Spear</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Staff</name>
				<modifier>-2</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Trident
<img data-src="http://weapons.gurps.ru/img/1997.png">

Трехзубая вилка, созданная на основе рыболовного копья. Римские гладиаторы использовали это оружие в паре с СЕТЬЮ (стр.59, Б276). Несколько зубцов делают головку более тяжелой (-2 к Acc (точности)) и подверженной перехвату (цель получает +1 к проверкам Блока или Парирования), но и менее предсказуемой (цель получает -1 к Уклонению). Также сюда относятся ча (Китай), фусцина (Древний Рим), боевые вилы (Европа) и вилы южного тигра (Китай), и развилистые версии нгао (Тайланд).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Трепан</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>120</value>
		<weight>1</weight>
		<reference>LT148</reference>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Trephin
<img data-src="lib/img/151670954973.png">
Специальная дрель для высверливания черепа, в виде полой металлической трубы с зубцами пилы на конце. См. Хирургические техники (с.12). $120, 1 фунт.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Трехсекционный цеп</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>60</value>
		<weight>5</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>11†</strength>
			<usage>Swung</usage>
			<reach>1-3</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+1 cr</damage>
			<strength>11†</strength>
			<usage>Swung, using both ends</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-6</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Flail</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>Попытки парировать цеп происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Three-Part Staff
<img data-src="http://weapons.gurps.ru/img/1975.png">

Китай. 

Три коротких палки, соединенных между собой веревкой или цепью, используется обеими руками, традиционно в Защитном Хвате, описанном в ГУРПС Боевые Искусства. Использующий может держаться за один конец и размахивать оружием как удлиненным цепом, или держать оба конца, как дубины или нунчаки для Двойной Атаки по стоящим рядом противникам. Это оружие считается сложным в использовании; все атаки производятся с штрафом -1. Также известно как сань-цзе-гунь (Китай).



Попытки парировать цеп происходят с штрафом -4; фехтовальное ("F" в parry) оружие не может парировать такие атаки вообще! Попытки блокировать такое оружие происходят с -2.</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Тростниковый доспех</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2040.png">

Распространен среди инков Перу, и на многих островах Тихого океана, но иногда использовалась и в Европе. Один из способов создания брони - отделать кору дерева ратангом. Другой – сплести из гибких тростниковых стеблей желаемую форму – нагрудник, шлем или наголенник. Тростник горюч – он может загореться, если обжигающий урон пройдет через СП(DR)! См. раздел Поджигание предметов (с. Б433); считайте этот материал огнестойким.



Время одевания 28 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>0</tech_level>
	<value>35</value>
	<weight>12</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>35</base-value>
		<base-weight>12</base-weight>
		<base-dr>1</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>1</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Труба</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>2</weight>
		<reference>LT49</reference>
		<categories>
			<category>Музыкальные инструменты</category>
		</categories>
		<description-loc>Trumpet
<img data-src="lib/img/151670959418.png">
Ранний медный духовой инструмент, часто длинная и прямая, а не изогнутая кольцом. Играется навыком Музыкальный Инструмент (Рог). Дистанция слышимости: 32 ярда. 200$, 2 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Трубка курительная</description>
		<tech_level>0</tech_level>
		<legality_class>4</legality_class>
		<value>1</value>
		<weight>0.25</weight>
		<reference>LT36</reference>
		<categories>
			<category>Роскошь</category>
		</categories>
		<description-loc>Pipe
<img data-src="lib/img/151669987970.png">
Ранняя трубка для курения табака выглядела как длинная деревянная трубочка с небольшой емкостью для табака на конце: $3, 1 фунт. По мере того, как курение распространялось по Европе (ТУ4), всё чаще использовались дешёвые, массово производимые глиняные трубки: $1, 0.25 фунта.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Тэцубо</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>100</value>
		<weight>10</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>sw+5 cr</damage>
			<strength>13‡</strength>
			<usage>Axe Swing</usage>
			<reach>1,2*</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>12†</strength>
			<usage>Axe Thrust</usage>
			<reach>1,2*</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Axe/Mace</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Axe/Mace</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Polearm</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Flail</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw+3 cr</damage>
			<strength>13†</strength>
			<usage>Sword Swing</usage>
			<reach>1,2</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 cr</damage>
			<strength>12†</strength>
			<usage>Sword Thrust</usage>
			<reach>2</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Tetsubo
<img data-src="http://weapons.gurps.ru/img/1970.png">

Япония. 

Означает "железный посох", хотя на самом деле является двуручной деревянной дубиной с железными шипами. Обычно используется в Защитном Хвате, описанном в GURPS Martial Arts. Также известно как канабо (Япония). </description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Уруми</description>
		<tech_level>3</tech_level>
		<legality_class>4</legality_class>
		<value>400</value>
		<weight>4</weight>
		<reference>LT64</reference>
		<melee_weapon>
			<damage>sw-1 cr</damage>
			<strength>8</strength>
			<usage>Swung, Flat</usage>
			<reach>1-3</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw-1(0.4) cut</damage>
			<strength>8</strength>
			<usage>Swing, Blade</usage>
			<reach>1-3</reach>
			<parry>-2U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Urumi
<img data-src="http://weapons.gurps.ru/img/2002.png">
<img data-src="http://weapons.gurps.ru/img/2027.png">

Индия. 

Одноручный меч с длинным, гибким клинком, используемым для того чтобы хлестать цель. Режущие повреждения подразумевают заточку как минимум одной стороны. Также существуют уруми с тупым лезвием; они могут наносить только дробящие повреждения. Наличие заточки не влияет на цену или вес. Возможны и укороченные версии; такие могут носиться в качестве металлических поясов и поэтому называются поясными мечами: Повреждения амп-2 дроб (sw-2 cr) или амп-2(0.5) реж (sw-2(0.5) cut), Досяг(Reach) 1,2 Цена $300, Вес 2 фунта, СЛ(ST) 7. +1 к Сокрытию, но у них отсутствует гарда, что дает дополнительный -1 к парированию.</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фальшион малый</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>2</weight>
		<reference>LT56</reference>
		<melee_weapon>
			<damage>sw cut</damage>
			<strength>8</strength>
			<usage>Swung</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr-2 imp</damage>
			<strength>8</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Jitte/Sai</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Knife</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Smallsword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Tonfa</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Small Falchion
<img data-src="http://weapons.gurps.ru/img/1928.png">

Средневековый европейский термин, применяемый практически к любому мечу с односторонней заточкой, но чаще к тем, у которых лезвие расширяется к концу, тяжелое, и/или изгибается вперёд возле конца, что делает более удобными режущие удары, а не колющие. Такой клинок существовал практически у всех культур, занимавшихся обработкой железа; охотники и солдаты всего мира ценили его в качестве инструмента (для разделки дичи, вырубки кустов, вскрывания кокосов, и т.п.) и оружия. Обычно заострен, но существуют варианты с тупым концом, что изменяет урон с колющего на дробящий. Фальшионы обычно размером с короткий меч, к ним относят боло (Филипины), дан санг гум (Корея), фальката (до-Римская Иберия), паранг (Индонезия), сика (Древний рим), серповидный меч (повсеместно), тромбаш (Конго), и меч-бабочку (Китай), который выделяется тем, что оборудован гардой. БОЛЬШОЙ ФАЛЬШИОН (стр.65) размером с широкий меч, включает в себя самые большие паранги и кольцевой меч (Китай).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фитиль быстрый</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.2</weight>
		<reference>LT84</reference>
		<notes>цена за метр; скорость горения 4 м. в мин.</notes>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Quick Match
<img data-src="lib/img/151670070486.png">
Используются для зажигания огнестрельного оружия с фитильным замком (см. Замки стр.90) и пороховых зарядов (стр.85). Использование фитиля в качестве зажигательного шнура требует проверки навыка Взрывные работы (Подрывник или Фейерверки).

Быстрый фитиль делается обработкой чёрным порохом и смолой аравийской акации (гуммиарабиком). Сгорает со скоростью 4 ярда в минуту. $2, 0.2, за каждый ярд.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Фитиль медленный</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>2</value>
		<weight>0.2</weight>
		<reference>LT84</reference>
		<notes>За метр;  5см за 30 минут</notes>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Slow Match
<img data-src="lib/img/151670070486.png">
Фитиль (ТУ4). Используются для зажигания огнестрельного оружия с фитильным замком (см. Замки стр.90) и пороховых зарядов (стр.85). Использование фитиля в качестве зажигательного шнура требует проверки навыка Взрывные работы (Подрывник или Фейерверки).

Медленный фитиль представляет собой пропитанную селитрой льняную ткань или пеньковый шнур. После воспламенения он сгорает со скоростью 1 дюйм за 15 минут. $2, 0.2, за каждый ярд (импровизированный вариант может быть сделан путём замачивания шнура в растворе древесного пепла, стоит 1/10, но дает штраф -2 к значению Поломки огнестрельного оружия и броскам Взрывных работ).
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хирургические инструменты - большой набор</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1500</value>
		<weight>40</weight>
		<reference>LT149</reference>
		<notes>Хорошего качества, дает +1 (за качество) к Хирургии</notes>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Surgeon Kit, Large
<img data-src="lib/img/151670859186.png">
Хирург использует множество разных инструментов. Малый набор содержит 12-20 предметов, а большой – от 30 до 60. Модификаторы умений за них составляются из нескольких параметров:

ТУ: Базовый набор дает -4 на ТУ1, -3 на ТУ2-3, и -2 на ТУ4-5. Эти значения отражают в основном развитие конструкции, хотя влияет и более широкий выбор материалов. Эти модификаторы не включают -2 за недостаток анестезии; см. Расширенные модификаторы (выше).

Размер набора: малый набор – базовое снаряжение. Большой набор – хорошее снаряжение: +1 к умению.

Превосходная работа: инструменты часто имеют накладки на рукоятках. Это не просто отделка, а улучшение захвата: +1 к умению. Материалы лучшего качества тоже могут давать эту премию; например, римские кузнецы могли закалять поверхность небольших инструментов – скальпелей и т.д., давая хорошее лезвие. С разрешения Мастера, очень дорогой инструментарий может дать до +2 к умению. Эти модификаторы могут применяться к отдельным предметам или ко всему набору; в последнем случае модификаторы качества за работу и размер набора складываются, давая до +3 в общем.

Импровизированное снаряжение: хирург без хирургических инструментов может оперировать и обычными. В общем, хорошие рабочие инструменты – ножи, лезвия, клещи – дадут -2 к умению. Если эти предметы сами импровизированного качества, то штраф будет -5. 

Определенные инструменты: Личный инструментарий обычно не модифицирует бросков Хирургии. Вместо этого он разрешает проведение особых процедур. Многие операции не могут быть выполнены без нужных инструментов; другие получают -1 за недостающий предмет. В некоторых случаях один инструмент высокого качества, нужный для конкретной задачи, может дать +1 к умению. Количество инструментов указано после названия. Большинство инструментов не имеют таких примечаний; они входят в набор и дают премию качества только полным набором.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Хирургические инструменты - малый набор</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>300</value>
		<weight>15</weight>
		<reference>LT149</reference>
		<notes>Необходим для хирургии</notes>
		<categories>
			<category>Медицина</category>
		</categories>
		<description-loc>Surgeon Kit, Small
<img data-src="lib/img/151670858014.png">
Хирург использует множество разных инструментов. Малый набор содержит 12-20 предметов, а большой – от 30 до 60. Модификаторы умений за них составляются из нескольких параметров:

ТУ: Базовый набор дает -4 на ТУ1, -3 на ТУ2-3, и -2 на ТУ4-5. Эти значения отражают в основном развитие конструкции, хотя влияет и более широкий выбор материалов. Эти модификаторы не включают -2 за недостаток анестезии; см. Расширенные модификаторы (выше).

Размер набора: малый набор – базовое снаряжение. Большой набор – хорошее снаряжение: +1 к умению.

Превосходная работа: инструменты часто имеют накладки на рукоятках. Это не просто отделка, а улучшение захвата: +1 к умению. Материалы лучшего качества тоже могут давать эту премию; например, римские кузнецы могли закалять поверхность небольших инструментов – скальпелей и т.д., давая хорошее лезвие. С разрешения Мастера, очень дорогой инструментарий может дать до +2 к умению. Эти модификаторы могут применяться к отдельным предметам или ко всему набору; в последнем случае модификаторы качества за работу и размер набора складываются, давая до +3 в общем.

Импровизированное снаряжение: хирург без хирургических инструментов может оперировать и обычными. В общем, хорошие рабочие инструменты – ножи, лезвия, клещи – дадут -2 к умению. Если эти предметы сами импровизированного качества, то штраф будет -5. 

Определенные инструменты: Личный инструментарий обычно не модифицирует бросков Хирургии. Вместо этого он разрешает проведение особых процедур. Многие операции не могут быть выполнены без нужных инструментов; другие получают -1 за недостающий предмет. В некоторых случаях один инструмент высокого качества, нужный для конкретной задачи, может дать +1 к умению. Количество инструментов указано после названия. Большинство инструментов не имеют таких примечаний; они входят в набор и дают премию качества только полным набором.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Черный порох серпентин</description>
		<tech_level>3</tech_level>
		<legality_class>3</legality_class>
		<value>10</value>
		<weight>1</weight>
		<reference>LT85</reference>
		<categories>
			<category>Зажигательные средства</category>
		</categories>
		<description-loc>Serpentine Black Powder
<img data-src="lib/img/151670324316.png">
Из-за высокой стоимости селитры (стр. 26, 84) китайские алхимики пытались получить вещество с похожими свойствами, смешивая её с другими веществами. Где-то около 1100 н.э., они изобрели взрывчатую смесь: чёрный порох. Селитра стала известна арабам в 1225 г.;. чёрный порох - в 1250 г. Роджер Бэкон записал формулу чёрного пороха в Англии в 1257 г. В качестве ингредиентов использовались селитра, древесный уголь и сера; типичная пропорция составляла 75%, 15% и 10% соответственно. Уголь был основным топливом, а селитра – источником кислорода; сера снижала температуру, при которой селитра начинала выделять кислород. Ингредиенты следовало мелко растолочь в ступке и перемешать.

Ранний чёрный порох был порошкообразным. Этот серпентин (ТУ3) сгорал мгновенно, но обладал ограниченной взрывной силой. В 15 веке был изобретен гранулированный порох (ТУ4), изначально он предназначался для того чтобы порох было легче хранить и перевозить. Влажный порошок прессовали в брикеты, после чего перемалывали до зернистого состояния: мелкого помола – для использования в запалах, среднего помола – для использования в маленьком огнестрельном оружии, или грубого помола – для пушек и взрывчатки.

Для чёрного пороха нашлось множество применений. Его использовали в качестве материала для пороховых дорожек (см. Зажигательные средства, 

стр.84), или взрывчатки (см. правила описанные в главе Взрывы, стр. Б414-415 ). Из него делали фейерверки (см. Фейерверки). И, конечно же, использовали в оружии.

Черный порох обычно продается в бочках по 100 фунтов каждая. Гранулированный порох стоит $20 за 1 фунт; считайте серпентин дешевым (-0.5 ЦФ). КЛ(LC)3.
</description-loc>
	</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Чешуйчатый доспех, легкий</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2053.png">

-1 DR против crusing



Чешуйчатые и Ламеллярные доспехи



Это самые древние из известных типов металлической нательной брони. Оба состоят из маленьких пластин, подогнанных друг поверх друга, плотными рядами. Если пластинки закреплены на тканевой или кожаной основе - это чешуйчатая броня. Если они собраны так, что несущая основа не требуется - это ламеллярная броня, примером этой может служить "о-йорой", который носили японские самураи. 



Уровень защиты, предоставляемой доспехом, зависит от толщины пластин и степени перекрытия. Таблица Брони (стр. 110) условно представляет три таких уровня: лёгкий, средний (самый распространенный) и тяжелый. Тяжелый вариант обычно закрывает грудь, хотя отдельные панели могут быть сделаны для защиты плеч, брюшной полости и бёдер.





Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>320</value>
	<weight>16</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>320</base-value>
		<base-weight>16</base-weight>
		<base-dr>3</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>3</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Чешуйчатый доспех, средний</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2054.png">

-1 DR против crusing



Чешуйчатые и Ламеллярные доспехи



Это самые древние из известных типов металлической нательной брони. Оба состоят из маленьких пластин, подогнанных друг поверх друга, плотными рядами. Если пластинки закреплены на тканевой или кожаной основе - это чешуйчатая броня. Если они собраны так, что несущая основа не требуется - это ламеллярная броня, примером этой может служить "о-йорой", который носили японские самураи. 



Уровень защиты, предоставляемой доспехом, зависит от толщины пластин и степени перекрытия. Таблица Брони (стр. 110) условно представляет три таких уровня: лёгкий, средний (самый распространенный) и тяжелый. Тяжелый вариант обычно закрывает грудь, хотя отдельные панели могут быть сделаны для защиты плеч, брюшной полости и бёдер.





Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>550</value>
	<weight>28</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>550</base-value>
		<base-weight>28</base-weight>
		<base-dr>4</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>4</amount>
	</dr_bonus>
</equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Чешуйчатый доспех, тяжёлый</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2055.png">

-1 DR против crusing



Чешуйчатые и Ламеллярные доспехи



Это самые древние из известных типов металлической нательной брони. Оба состоят из маленьких пластин, подогнанных друг поверх друга, плотными рядами. Если пластинки закреплены на тканевой или кожаной основе - это чешуйчатая броня. Если они собраны так, что несущая основа не требуется - это ламеллярная броня, примером этой может служить "о-йорой", который носили японские самураи. 



Уровень защиты, предоставляемой доспехом, зависит от толщины пластин и степени перекрытия. Таблица Брони (стр. 110) условно представляет три таких уровня: лёгкий, средний (самый распространенный) и тяжелый. Тяжелый вариант обычно закрывает грудь, хотя отдельные панели могут быть сделаны для защиты плеч, брюшной полости и бёдер.





Время одевания 30 сек



Цена и вес даны для защиты торса (области 9-11, плюс жизненно важные органы). 

Используйте Таблицу зон бронирования (LT100) для определения веса и цены брони, закрывающей прочие локации. </description-loc>
	<tech_level>1</tech_level>
	<value>1100</value>
	<weight>40</weight>
	<reference>LT</reference>
	<armor-components>
  		<base-value>1100</base-value>
		<base-weight>40</base-weight>
		<base-dr>5</base-dr>
  	</armor-components>
  		<categories>
		<category>Доспехи</category>
	</categories>
	<dr_bonus>
		<location>torso</location>
		<amount>5</amount>
	</dr_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Широкий меч колющий</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>600</value>
		<weight>3</weight>
		<reference>LT55</reference>
		<melee_weapon>
			<damage>sw+1 cut</damage>
			<strength>10</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>thr+2 imp</damage>
			<strength>10</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Thrusting Broadsword
<img data-src="http://weapons.gurps.ru/img/1986.png">

Термин для меча, который средневековые европейские воины обычно называли "arming sword" или "рыцарский меч"; придуман писателями 17ого века, чтобы различать массивные военные мечи от узких гражданских. Длинною обычно от 30 до 40 дюймов. Традиционно прямой, обоюдоострый и остроконечный; используйте параметры КОЛЮЩЕГО ШИРОКОГО МЕЧА (стр. Б271). Эти же параметры можно использовать и для слегка изогнутых или заточенных с одной стороны вариаций. Почти в каждой культуре имеется некая версия широкого меча, который на своём языке часто называют просто "мечом". Включает лонгсакс (Скандинавия), спату (Древний Рим), и крупные экземпляры кацбальгера (Европа) и педанга (Индонезия).</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шитая речная лодка из досок 9м.</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>1400</value>
		<weight>4000</weight>
		<reference>LT141</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Sewn-Plank Riverboat, 30’
<img data-src="lib/img/151670454018.png">
Лодка в египетском стиле, сделанная из досок акации (или дорогого импортного материала, например кедра) длинной около 3х футов, сшитых между собой по краям. Габариты: длина 30 футов, ширина 7 футов, высота борта 2,5 фута. С заострёнными носом и кормой. Движется при помощи весел, которыми гребут четыре пары человек. Стоящий на носу судна использует мерный шест (с.52) чтобы вовремя обнаруживать препятствия, а стоящий на корме правит при помощи весла погруженного в воду.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шлюп 6м</description>
		<tech_level>4</tech_level>
		<legality_class>4</legality_class>
		<value>5000</value>
		<weight>4800</weight>
		<reference>LT142</reference>
		<categories>
			<category>Лодки и корабли</category>
		</categories>
		<description-loc>Sloop, 21'
<img data-src="lib/img/151670669387.png">
Одномачтовый парусник, разработанный в Голландии в начале 17 века. Мачта расположена в передней трети судна, и на ней два треугольных паруса (стаксель и грот), придающих кораблю классический вид шлюпа. Шлюп в таблице - сравнительно небольшой: 21 фута в длину, 7 футов в ширину и 6 футов в высоту. 3-х футовый бушприт увеличивает площадь парусов. Хорошая маневренность и способность плыть против ветра делают этот корабль полезным для приключенцев. Более крупные корабли со шлюповыми парусами были любимы пиратами. Куттер - похожий корабль с мачтой, расположенной ближе к корме.
</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шотель</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>200</value>
		<weight>3</weight>
		<reference>LT62</reference>
		<melee_weapon>
			<damage>thr+1 imp</damage>
			<strength>11</strength>
			<usage>Swing</usage>
			<reach>1</reach>
			<parry>0</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<melee_weapon>
			<damage>sw-1 cut</damage>
			<strength>11</strength>
			<usage>Thrust</usage>
			<reach>1</reach>
			<parry>0U</parry>
			<block>No</block>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Broadsword</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Force Sword</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Rapier</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Saber</name>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Shortsword</name>
				<modifier>-2</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Two-Handed Sword</name>
				<modifier>-4</modifier>
			</default>
		</melee_weapon>
		<notes>-2 при попадании при Swing</notes>
		<categories>
			<category>Холодное оружие</category>
		</categories>
		<description-loc>Shotel
<img data-src="http://weapons.gurps.ru/img/1917.png">

Эфиопия.

Круто изогнутый, обоюдоострый меч длиною 40 дюймов. В основном используется для ударов в обход щита или парирующего оружия. Крутой изгиб делает его использование несколько затруднительным (-2 к броску атаки), однако блокирование и парирование такого оружия происходит с -1. Хотя и острый, рубит очень плохо. Экземпляры с еще большей кривизной лезвия, например фалькс (Дакия) и прочие серповидные мечи, используют такие же характеристики.



-2 при попадании при Swing</description-loc>
	</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Шпоры</description>
		<tech_level>2</tech_level>
		<legality_class>4</legality_class>
		<value>25</value>
		<reference>LT134</reference>
		<categories>
			<category>Верховая езда</category>
		</categories>
		<description-loc>Spurs
<img data-src="lib/img/151670729771.png">
Римское изобретение, датируемое первым столетием нашей эры. В позднем Средневековье шпоры становятся эмблемой знатности, их часто украшали позолотой или делали из серебра. Шпоры дают +1 к Верховой езде при попытках управлять животным. $25, незн.
</description-loc>
	<weight></weight></equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Щипчики</description>
		<tech_level>1</tech_level>
		<legality_class>4</legality_class>
		<value>5</value>
		<reference>LT36</reference>
		<categories>
			<category>Личные вещи</category>
		</categories>
		<description-loc>Tweezers
<img data-src="lib/img/151670961913.png">
Появились около 2000 года до н.э., предположительно для удаления волос на теле. $5.
</description-loc>
	<weight></weight></equipment><equipment version="3">
	<quantity>1</quantity>
	<description>Щит команчей</description>
	<description-loc> 

<img data-src="http://weapons.gurps.ru/img/2084.png">

DB 2

DR 4

HP 21щит, сделанный из двух слоёв шкуры, натянутых на деревянный обруч и набитых перьями, волосами или травой - или бумагой из книг поселенцев! Считайте Хрупким (Воспламеняемым) (стр. Б136). Его носят через плечо на ремне (называемом по-английски "гиж" или "гайдж") при езде на лошади.

Хрупкий (Горючий); см. стр.Б136.</description-loc>
	<tech_level>0</tech_level>
	<value>100</value>
	<weight>16</weight>
	<reference>LT</reference>
	<categories>
		<category>Щиты</category>
	</categories>
		<attribute_bonus>
			<attribute>dodge</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>parry</attribute>
			<amount>2</amount>
		</attribute_bonus>
		<attribute_bonus>
			<attribute>block</attribute>
			<amount>2</amount>
		</attribute_bonus>
</equipment><equipment version="3">
		<quantity>1</quantity>
		<description>Яд гадюки</description>
		<tech_level>0</tech_level>
		<legality_class>0</legality_class>
		<value>10</value>
		<reference>LT129</reference>
		<categories>
			<category>Яды</category>
		</categories>
		<description-loc>Viper Venom
<img data-src="lib/img/151670977217.png">
<img data-src="lib/img/151670979639.png">

Извлеченный из живой гадюки (змеи семейства гадюковые) и используемый в качестве инъекционного яда на наконечнике оружия. После задержки в 1d секунд, сделать бросок на ЗД(HT) для сопротивления. Провал наносит 1d ядовитых повреждений за рану; успех снижает повреждения до 1d-3 на рану. Гадюка дает до четырех доз яда; извлечение каждой дозы требует отдельного броска Обращения с животными. Провал означает, что дальнейшее получение яда из змеи невозможно. Критический провал приводит к укусу змеёй: 2d ядовитых повреждений с броском против ЗД(HT)-2 для сопротивления. $10 за дозу. КЛ(LC)0.
</description-loc>
	<weight></weight></equipment></equipment_list>`;
 standaloneLibs['Rules.list']=`<?xml version="1.0" encoding="UTF-8" ?>
<name>Mentor: Rules</name>
<notes>
Список заголовков из глоссариев <a href="books/basic_set_4ed_rus.pdf" target="_blank">Basic Set</a> и <a href="books/magic_rus.pdf" target="_blank">Gurps Magic</a><br/>
⚠ Первое открытие книги будет досточно медленое.
</notes>
<rule_list>
<!-- Basic Set Рус -->
<rule>
<name>Абсолютные силы, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Автоматическое оружие, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Адские параллели, B528.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Акробатическое уклонение, B375.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Активные защиты, B326, B363, B374</name>
<subrule> таблица модификаторов, B548.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Акулы, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Акценты, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алкоголь, B122, B439-B440.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Альтернативные атаки, B61.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Альтернативные миры, B64, B160</name>
<subrule> путешествия, B189, B190</subrule>
<subrule> Центрум, B541-B542, B545-B546</subrule>
<subrule> классы, B526</subrule>
<subrule> близкие параллели, B526</subrule>
<subrule> Кавентри, B540</subrule>
<subrule> эхо, B546</subrule>
<subrule> адскиепараллели, B528</subrule>
<subrule> параллели мифов, B527</subrule>
<subrule> Рейх-B5, B543</subrule>
<subrule> странные параллели, B527, классы миров, B535. см. тж. Путешествия между мирами, Кампании Бесконечных миров.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Амплитудное повреждение, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Анархия, B509.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Арбалеты, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Арканы, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Артефакты, вневременные, B478</name>
<subrule> футуристические и инопланетные, B478, магические, B240, B480-B483.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атака Выкручивание конечности, B370, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атака по оружию, B400.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки двумя оружиями, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки метательным оружием, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки метательным оружием, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки роя, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки с воздействием на область, B413</name>
<subrule> разброс, B414.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атаки, B326, B369</name>
<subrule> альтернативные, B61</subrule>
<subrule> в захвате, B371</subrule>
<subrule> Обманная атака, B369</subrule>
<subrule> двойная, B417</subrule>
<subrule> сверху, B402</subrule>
<subrule> в тактическом бою, B388</subrule>
<subrule> природная, B51</subrule>
<subrule> связанные эффекты, B381</subrule>
<subrule> модифицированные, B114</subrule>
<subrule> обходная, B391</subrule>
<subrule> внезапные, B393</subrule>
<subrule> рой, B461</subrule>
<subrule> без нанесения вреда, B381.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атмосферное давление, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атмосферы, опасные, B429</name>
<subrule> вакуум, B437.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Атрибуты, см. Базовые атрибуты.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Базовая грузоподъемность, B15</name>
<subrule> таблица, B17.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Базовая скорость, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Базовое передвижение, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Базовые атрибуты, B14</name>
<subrule> в шаблонах, B447</subrule>
<subrule> улучшение, B290.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Баланс игры, B11.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Барон Януш Телкозеп, лист персонажа, B312-B313</name>
<subrule> иллюстрации, B290.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>БГ, см. Базовая грузоподъемность.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бег (в бою), B370.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бег, B354, B357</name>
<subrule> усталость, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Безоружный бой, B370</name>
<subrule> ранения себя, B379</subrule>
<subrule> парирование, B376.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бесконечные боеприпасы, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Библиография, B566.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Блок, B51, B324, B327</name>
<subrule> в тактическом бою, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Блокирующие заклинания, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Богатство, B25, B26, B264, B517</name>
<subrule> и Статус, B26, B516</subrule>
<subrule> расходы на жизнь, B265, B516</subrule>
<subrule> экономика, B514</subrule>
<subrule> золото и серебро, B515</subrule>
<subrule> улучшение уровня богатства персонажа, B291</subrule>
<subrule> перенос денег между мирами, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боги, B33, B40, B59, B76, B113, B132, B143.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боевые карты, B384, B492.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боевые лошади, см. Лошади.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боевые скафандры, B192.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боеприпасы, B278.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Божественное происхождение</name>
<subrule> B33</subrule>
<subrule> см. тж. Боги.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бой верхом.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бой вплотную, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бой, B9, B362-B417</name>
<subrule> на разной высоте, B402</subrule>
<subrule> киношный, B417</subrule>
<subrule> манёвры, B324</subrule>
<subrule> таблица модификаторов боя, B547</subrule>
<subrule> техники, B230</subrule>
<subrule> последовательность ходов, B324, B362</subrule>
<subrule> на транспорте, B467-B470.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бола, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Броня, B110, B282-B286</name>
<subrule> изменение положения в броне, B395</subrule>
<subrule> комбинирование и наслоение, B286</subrule>
<subrule> гибкая броня и тупая травма, B379</subrule>
<subrule> одевание, снятие и сбрасывание, B286.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Броски понимания, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бросок атаки, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бросок попадания, B326, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бутыли с маслом, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Быстрое изучение в сложных обстоятельствах, B292.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Быстрое состязание, B348.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Быстрый огонь, B373, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Быстрый удар, B54, B93, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Важность в обществе, см. Звание, Статус.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вакуум, B437.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вампиры, B137, B212</name>
<subrule> см. тж. Барон Януш Телкозеп.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Василиски, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Введение, B5, B342.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ведение игры, B486-B504.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ведущая рука, B14.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вежливость в бою, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Верблюды, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Взрывные работы, B415.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Взрывы, B414-B415</name>
<subrule> киношные, B417.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Взятие живьем, B401.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Видимость, B394</name>
<subrule> см. тж. Темнота.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Виртуальные реальности, B520.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Внезапные атаки, B393.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Внешность, B21.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Военные, B218, B221, B222, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Воздействие, B35, B416, B428.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Возраст, B20.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вол, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Волки, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Воля, B16</name>
<subrule> броски Воли, B360. Воровское и шпионское снаряжение, B289.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Восп, см. Восприятие.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Восприятие, B16.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Восстановление, B328</name>
<subrule> см. тж. Лечение.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Восстановление, B423-B424</name>
<subrule> сознания, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Время, между приключениями, B498</name>
<subrule> между сессиями, B497</subrule>
<subrule> во время приключений, B497.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Всегда включенные</name>
<subrule> преимущества, B34, магические предметы, B482.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Встречи, B502</name>
<subrule> пример таблицы встреч, B503.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Встряски реальности, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вторичные характеристики, B15</name>
<subrule> улучшение, B290</subrule>
<subrule> в шаблонах, B447.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Выглянуть и атаковать, B390.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Выключаемые преимущества, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Высвобождение, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Галлюцинации, B429, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Галлюциногены, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гарпун, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Глоссарий, B563-B565</name>
<subrule> оружия и брони, B268</subrule>
<subrule> базовых терминов, B7</subrule>
<subrule> магии, B234</subrule>
<subrule> Бесконечных миров, B524</subrule>
<subrule> псионики, B254.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Глушители, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Голос, B132.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Голышом от пуль, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гориллы, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Готовое оружие, B369</name>
<subrule> подготовка, B382.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гравитация, B60, B350, B434</name>
<subrule> различная гравитация, B350</subrule>
<subrule> родная гравитация, B17.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Грамотность, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гранаты, B277, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гремучие змеи, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Грифоны, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Группы союзников, B37.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Грязные трюки, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Давление, атмосферное, B429, B435</name>
<subrule> кессонная болезнь, B435</subrule>
<subrule> воды, B435.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дай Блэкторн, B12, B18, B22, B116, B162, B164, B227</name>
<subrule> лист персонажа, B310-B311</subrule>
<subrule> иллюстрации, B32, B418.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Движение и бой, B367</name>
<subrule> направление, B386</subrule>
<subrule> на высокой скорости, B394</subrule>
<subrule> движение в тактическом бою, B386.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Движение на высокой скорости, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Двойные умолчания, позволенные техникам, B229</name>
<subrule> не позволенные усениями, B173.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Делители брони, B378.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Деньги, см. Богатство.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Депрессанты, B441.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дети, B20.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дикие кабаны, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дистанционные атаки, B327, B372</name>
<subrule> дистанция половинных повреждений, B378</subrule>
<subrule> попадание в другую цель, B389</subrule>
<subrule> таблица модификаторов, B548</subrule>
<subrule> стрельба по возможности, B390</subrule>
<subrule> промах, B390</subrule>
<subrule> выглянуть и атаковать, B390</subrule>
<subrule> стрельба наугад, B389.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Длительные действия, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Длительные задачи, B346, B499.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Допущения, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дороги, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Друзья и враги, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Духи, B41, B55, B68, B76, B113, B193, B200, B212</name>
<subrule> преимущества духов, B34.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Душение, B371, B404</name>
<subrule> см. тж. Удушение.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дыхание, B49, B55, B63, B68, B108</name>
<subrule> задержка дыхания, B351</subrule>
<subrule> удушение врага, B401.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дэвид Пулвер, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Единицы здоровья, B16, B418-B419</name>
<subrule> Таблица ЕЗ и СП построек, B558</subrule>
<subrule> см. тж. Ранения.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ЕЖ, см. Единицы жизни.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ЕУ, см. Единицы усталости.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Животные, B40, B87, B90, B137, B175, B187, B210, B211, B217, B223, B225, B226, B228, B395, B455-B460</name>
<subrule> в бою, B461</subrule>
<subrule> индивидуализация, B457</subrule>
<subrule> тяговые, B459</subrule>
<subrule> питомцы, B458-B459</subrule>
<subrule> верховая езда, B459</subrule>
<subrule> тренировка, B458-B459</subrule>
<subrule> см. тж. Бой верхом.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Журнал Пирамида, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заговор, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Загрязнитель, B443</name>
<subrule> см.тж. Инфекция.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Воды, B253.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Воздуха, B242.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Врат, B247.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания движения, B251.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Защиты и Предупреждения, B252.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Земли, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Знаний, B249.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Контроля разума, B250.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Контроля тела, B244.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания на боевой карте, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Некромантии, B251.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Общения и пони мания, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Света и Тьмы, B249.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания, B66</name>
<subrule> Воздуха, B242</subrule>
<subrule> областные, B239</subrule>
<subrule> обратный удар, B235</subrule>
<subrule> блокирующие, B241</subrule>
<subrule> Контроля тела, B244</subrule>
<subrule> маг, B236</subrule>
<subrule> сотворение, B235-B238</subrule>
<subrule> клериков, B77</subrule>
<subrule> Общения и понимания, B245</subrule>
<subrule> Земли, B245</subrule>
<subrule> Чары, B246, B480-B482</subrule>
<subrule> Огня, B246</subrule>
<subrule> Врат, B247</subrule>
<subrule> Лечения, B248</subrule>
<subrule> информационные, B241</subrule>
<subrule> Знаний, B249</subrule>
<subrule> легальность, B507</subrule>
<subrule> Света и Тьмы, B249</subrule>
<subrule> Мета, B250</subrule>
<subrule> касательные, B240</subrule>
<subrule> Контроля разума, B250</subrule>
<subrule> метательные, B240</subrule>
<subrule> Движения, B251</subrule>
<subrule> список, B304</subrule>
<subrule> Некромантии, B251</subrule>
<subrule> требования, B235</subrule>
<subrule> Защиты и предупреждения, B252</subrule>
<subrule> стандартные, B239</subrule>
<subrule> сопротивляемые, B241</subrule>
<subrule> особые, B242</subrule>
<subrule> цель, B236</subrule>
<subrule> Воды, B253</subrule>
<subrule> см.тж. Магия.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Законы, B65, B204, B506-B508, B518</name>
<subrule> наказания, B508</subrule>
<subrule> испытания, B507.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Залом руки, B370, B403.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Запах, B49, B243.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Запрещенные черты, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заражение, B435</name>
<subrule> см.тж. Радиация.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Затаптывание, существами, занимающими несколько клеток, B392.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Захваты и сжатие, B370</name>
<subrule> Зоны попадания, B400.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Защита, B326, B374</name>
<subrule> в тактическом бою, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Защиты, B46</name>
<subrule> улучшенные, B51</subrule>
<subrule> ограниченные, B46.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Звание, B29.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Звуки, см. Слух.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ЗД (Здоровье), B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Здоровье, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Змеи, B458</name>
<subrule> яд кобры, B439</subrule>
<subrule> удавы, B458</subrule>
<subrule> гремучие змеи, B458.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Знамения, B72.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Знания, НИП, B496</name>
<subrule> игрок и персонаж, B495.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Золото, см. Богатство.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зомби, B74, B94, B252, B380.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зоны попадания, B369, B398</name>
<subrule> и Сопротивление ранениям, B400</subrule>
<subrule> случайные, B400.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зрение, B92, B123, B124, B144, B151, B358.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зубы, B91.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Игра в сети, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Игровые миры, B505-B522</name>
<subrule> экономика, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изобретения, см. Приспособления.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Иллюминаты, B60, B130, B193, B200, B525</name>
<subrule> Заговор, B543.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Иммунитет, B443.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ИН (Интеллект), B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Индекс, B329-B334, B570-B575.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инициатива, B393.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инопланетные артефакты, B478.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инструменты, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Интеллект, B15</name>
<subrule> и грязные трюки, B405.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Интоксикация, см. Алкоголь.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инфекции, B442-B444</name>
<subrule> всемирные, B528.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инфекция, B444.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инфинити Анлимитед, B524, B535- B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Инфинити Девелопмент, B536.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Информационные заклинания, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>И-Полиция, B536-B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Искусственный интеллект, B528.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Испытания, B507</name>
<subrule> Наказание, B508.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Истощение, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Йоса, лист персонажа, B314-B315, иллюстрации, B343.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кавентри, B540.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кампании между мирами, B519-B522</name>
<subrule> см. тж. Кампании Бесконечных Миров.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кампании, B486-B489</name>
<subrule> киношные, B488</subrule>
<subrule> продолжение, B504</subrule>
<subrule> лист планирования, B567</subrule>
<subrule> уровень силы, B10, B486</subrule>
<subrule> общие кампании, B504</subrule>
<subrule> переход между кампаниями, B504</subrule>
<subrule> см. тж. Игровые миры.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карманные миры, B529.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карта НИП, B569.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карты мира, B491.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карты областей, B491.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карты помещений, B492.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Карты, B384, B490-B491</name>
<subrule> рисуемые игроками, B491</subrule>
<subrule> создание для приключений, B502.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Касательные заклинания, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кессонная болезнь, B435.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Киношные преимущества, B33</name>
<subrule> кампании, B488</subrule>
<subrule> персонажи, B489</subrule>
<subrule> бой, B417</subrule>
<subrule> взрывы, B417</subrule>
<subrule> отбрасывание, B417.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кирки, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кислота, B428.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>КЛ, см. Класс легальности.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Класс легальности, B267, B270, B507</name>
<subrule> легальность заклинаний, B507.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Классы областей, B176.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Классы персонажей, несуществующие, B259.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Клетки, B384.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кнуты, B406.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Коктейль Молотова, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Колдун (заклинаний), B236.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кома, B429</name>
<subrule> см. тж. Потеря сознания.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Компетентность, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Комплекция, B18.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Компьютеры, B48, B51, B55, B69, B71, B76, B100, B124, B184, B472</name>
<subrule> искусственный интеллект, B528</subrule>
<subrule> сложность, B472</subrule>
<subrule> программы, B472</subrule>
<subrule> миры виртуальной реальности, B520.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Конвертер мер, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контакты, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Конусные атаки, B413.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Копание, B350, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Корабли, B466</name>
<subrule> таблица, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Космическая болезнь, B434.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Космолеты, B466</name>
<subrule> таблица, B465.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Коспиративность, см. Иллюминаты.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кошки, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критические попадания, B381</name>
<subrule> таблица, B556.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критические промахи, B381</name>
<subrule> таблица, B556-B557.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критические промахи, B556</name>
<subrule> Таблица критических промахов в рукопашном бою, B557.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критический провал, заклинаний, B236.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критический успех, B347</name>
<subrule> при защите, B381.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кровотечение, B68, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Крысы, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ксин Ла, лист персонажа, B316- B317</name>
<subrule> иллюстрации, B167, B188, B418, B445.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Кубик, B8, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Культуры, B23, B505-B508.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лазание, B89, B349.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лазеры, B280, B399</name>
<subrule> тепловые боеголовки, B412</subrule>
<subrule> прицелы, B412.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ландшафт, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ЛВ, см. Ловкость.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Летучие мыши, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лечение, B59, B79, B80, B155, B160, B162</name>
<subrule> магическое, B248</subrule>
<subrule> медицинское снаряжение, B289</subrule>
<subrule> Технологический уровень медицины, B512</subrule>
<subrule> физика, B256.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ликантропия, см. Оборотни.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лист использования времени, B499, B569.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лист Контроля Мастера, B490, B568.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Личности, B31, B39.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ловкость, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ловля вещей, B355.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ловушки, B502.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лошади, B459-B460</name>
<subrule> снаряжение для верховой езды, B289</subrule>
<subrule> см. тж. Бой верхом, Верховые животные, Оружие (кавалерийское).</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лояльность, B518-B519.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Луи Д’Антарес, лист персонажа, B322-B323</name>
<subrule> иллюстрации, B368, B422, B505.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Львы, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магазин приключений eB23, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магичность, B66.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магия клериков, B77, B242</name>
<subrule> заклинания, B77.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магия, B66, B143, B144, B150, B218, B224, B225, B234-B253</name>
<subrule> преимущества, B34</subrule>
<subrule> церемониальная, B237</subrule>
<subrule> клериков, B242</subrule>
<subrule> школы, B239</subrule>
<subrule> зачарованные предметы, B240, B480-B483</subrule>
<subrule> расовая, B453</subrule>
<subrule> ритуальная, B237, B242</subrule>
<subrule> посохи, B240.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мана, B235.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Атака, B325, B365.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Бездействие, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Движение и атака, B325, B365, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Движение, B325, B364, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Концентрация, B325, B366.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Ожидание, B325, B366, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Оценка, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр подготовки, B325, B366, B382, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр прицеливания, B58, B324, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Смена позы, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Тотальная защита, B324, B366, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Тотальной атаки, B54, B324, B365, B385</name>
<subrule> будучи схваченным, B371.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвр Финт, B325, B365.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Манёвры, B324, B363, B385</name>
<subrule> Таблица, B551.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Масштабирование вреда, сотенное, B470.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Масштабирование повреждений, десятичное, B470.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мгновенная смерть, B423.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медведи, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медицинский уход, B424</name>
<subrule> хирургия, B424.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медицинское оборудование, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медь, см. Богатство.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ментальное оглушение, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ментальные мета-черты, B263.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ментальные преимущества, B32</name>
<subrule> недостатки, B120</subrule>
<subrule> силы, см.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Псионика.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мертвые миры, B527.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мета-заклинания, B250.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Метание предметов, B355, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Метательные заклинания, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мета-черта Дух, B263.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мета-черты элементалей, B262.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мета-черты, B262.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Механизмы, B16</name>
<subrule> Метачерта Машина, B263.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Миниатюры, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификатор размера, B19, B372</name>
<subrule> и досягаемость, B402.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификаторы (черт), B101</name>
<subrule> список, B300.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификаторы пробивания, B378, B416</name>
<subrule> пробивание насквозь, B379, B408.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификаторы ранений, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификация тела, B294.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Монстры, B460-B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Морская болезнь, B436.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Морфологические мета-черты, B263.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>МР, см. Модификатор размера.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>МСТГ, B162, B536.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мулы, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мутации, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Нагревание, B434</name>
<subrule> см. тж. Огонь.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Нагрузка, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Наемники, B517, B518.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Наземная техника, B466</name>
<subrule> таблица, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Наказание, законы, B508.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Направление (в бою), B385, B386.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Недостатки, B11, B119</name>
<subrule> выкуп, B121, B291</subrule>
<subrule> ограничение недостатков, B11</subrule>
<subrule> хорошие, B119</subrule>
<subrule> экзотические, B120</subrule>
<subrule> в шаблонах, B447</subrule>
<subrule> список, B299</subrule>
<subrule> ментальные, B120</subrule>
<subrule> обыденные, B120</subrule>
<subrule> новые, B162</subrule>
<subrule> физические, B120</subrule>
<subrule> тайные, B120</subrule>
<subrule> социальные, B120</subrule>
<subrule> добровольные, B121</subrule>
<subrule> сверхъестественные, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Нежить, B50</name>
<subrule> см. тж. Вампиры, Зомби.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Неигровые персонажи, см. НИП.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Некомпетентность, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Нелюди, B32.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>НИП, B31, B493</name>
<subrule> Таблица реакции НИП, B559-B562</subrule>
<subrule> Карта НИП, B569.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Новые изобретения, B473, B475</name>
<subrule> см. тж. Приспособления.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Новые недостатки, B162.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обезвоживание, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обезьяны, B455.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Областные заклинания, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обманная атака, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обоняние и вкус, B49, B358.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оборотни, B83, B84, B137.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обходные атаки, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Общение с игроками, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Объединенные нации, B535, B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Объекты, занимающие несколько клеток, B392.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обыденные преимущества, B32</name>
<subrule> недостатки, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оглушение, B35</name>
<subrule> ментальное оглушение, B420.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Огнестрельное оружие, B278-B281</name>
<subrule> аксессуары, B289, B411</subrule>
<subrule> прицеливание, B364</subrule>
<subrule> автоматическое, B408</subrule>
<subrule> упор, B364</subrule>
<subrule> стрельба вверх и вниз, B407</subrule>
<subrule> сбой, B382, B407</subrule>
<subrule> качество, B280</subrule>
<subrule> быстрый огонь, B408</subrule>
<subrule> ружья, B409</subrule>
<subrule> огонь на подавление, B409</subrule>
<subrule> ультратехнологичное, B280.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Огонь на подавление, B409.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Огонь, B61</name>
<subrule> горение предметов, B433, B434</subrule>
<subrule> повреждения, B433</subrule>
<subrule> горящие стрелы, B410</subrule>
<subrule> зажигательное оружие, B277, B411, B433</subrule>
<subrule> заклинания, B246</subrule>
<subrule> лучевые обжигающие атаки, B399.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ограничение защиты, B46.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ограничения, B101, B110</name>
<subrule> устройств, B116.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Одежда, B265.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Округление, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Олень, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оптика и сенсоры, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оптические прицелы, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Опутывание, B370, B401, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оружие, B267-B281</name>
<subrule> аксессуары, B289, B411</subrule>
<subrule> точность, B269</subrule>
<subrule> боеприпасы, B278</subrule>
<subrule> поломка, B401, B485</subrule>
<subrule> размер, B270</subrule>
<subrule> ношение, B287</subrule>
<subrule> кавалерия, B397</subrule>
<subrule> стоимость, B270</subrule>
<subrule> фехтовальное, B404</subrule>
<subrule> огнестрельное, B278-B281</subrule>
<subrule> гранаты, B277</subrule>
<subrule> тяжелое, B281</subrule>
<subrule> зажигательное, B277</subrule>
<subrule> киношные бесконечные боеприпасы, B417</subrule>
<subrule> Класс легальности, B271</subrule>
<subrule> сбой, B278, B407</subrule>
<subrule> рукопашное, B271-B275</subrule>
<subrule> снаряды, B281</subrule>
<subrule> парирование, B269</subrule>
<subrule> дальность, B269</subrule>
<subrule> дальнобойное, B275-B277, B278-B281</subrule>
<subrule> скорострельность, B270</subrule>
<subrule> досягаемость, B269</subrule>
<subrule> досягаемость и Модификатор Размера, B388, B402</subrule>
<subrule> отдача, B271</subrule>
<subrule> боезапас, B270</subrule>
<subrule> умное оружие, B278</subrule>
<subrule> сила, B270</subrule>
<subrule> атаки по оружию, B400</subrule>
<subrule> метательное, B356</subrule>
<subrule> вес, B270.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Осечки, B278, B382, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Осколочное повреждение, B414.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ослы, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Особые заклинания, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отбрасывание, B378.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отд, см. Отдача.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отдача, B271.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отступление (при активной защите), B377.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отступление, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оттаскивание объектов, B353.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отыгрыш, B7.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Охотники за головами, B539.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Очки движения, B386, B387.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Очки персонажей, B10, B119, B258, B290</name>
<subrule> премиальные очки, B498.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Падение при защите, B374.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Падение, B430-B431</name>
<subrule> повреждения от падающих предметов, B431.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Паралич, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Параллельные миры, см. Альтернативные миры.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Парахроника, псевдо-научное объяснение, B530</name>
<subrule> транспортер, B529</subrule>
<subrule> детектор, B532</subrule>
<subrule> опасности, B532</subrule>
<subrule> небольшие проблемы, B531</subrule>
<subrule> парадокс, B533</subrule>
<subrule> проектор, B524, B530</subrule>
<subrule> см. тж. Кампании Бесконечных миров.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Парахронные лаборатории, B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Парахронозоиды, B544.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Парирование, B51, B93, B324, B327, B376</name>
<subrule> голыми руками, B376</subrule>
<subrule> в тактическом бою, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Патруль Инфинити, B536-B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Первая помощь, B424.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Передвижение (параметр персонажа), B52.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Перезарядка метательного оружия, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Перенос разума, B296.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Перетаскивание предметов, B353.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Перки, B100.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Персонаж, B7</name>
<subrule> идея, B11</subrule>
<subrule> создание, B9, B10, B258</subrule>
<subrule> улучшение, B290, B499</subrule>
<subrule> происхождение, B33</subrule>
<subrule> лист, B13, B335-B336</subrule>
<subrule> история, B12</subrule>
<subrule> типы, B12.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Питомцы, B458-B459</name>
<subrule> см. тж. Животные.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пища, B95, B139, B159, B160, B265</name>
<subrule> добывание, B427</subrule>
<subrule> истощение, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Плавание, B354, B357</name>
<subrule> усталость, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пламя, см. Огонь.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Плащи, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>По умолчанию, B344</name>
<subrule> двойные уровни, B173, B232</subrule>
<subrule> умения, B173</subrule>
<subrule> техники, B229.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Повр, см. Повреждения.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Повреждения, B15, B327, B377</name>
<subrule> наносимые животными, B461</subrule>
<subrule> Таблица повреждений, B16</subrule>
<subrule> броски повреждений, B9, B378</subrule>
<subrule> масштабирование, B470</subrule>
<subrule> наносимые предметам, B483-B485.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Погода, B243, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подвижные зоны, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подготовка игры, B490.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подготовка к игре, B490.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подземелья, B501.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поднимание предметов, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подстройка правил, B486.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подъем, B14, B15, B65, B205, B353, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Позы, B367</name>
<subrule> смена позы в доспехах, B395</subrule>
<subrule> таблица, B551.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Покровители, B72-B73.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поле зрения, B389.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Полет, B56, B354</name>
<subrule> бой в воздухе, B398.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поломка оружия, B401.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поломки, B485.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Порталы, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Последние раны, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Последующее повреждение, B381.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Посохи, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Потенциальные преимущества, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Потеря сознания, B419, B423, B429</name>
<subrule> восстановление, B329.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правила для быстрого начала, B8.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правила, подстройка, B486</name>
<subrule> вопросы, B492.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правило B14-ти, B360.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правило B16-ти, B349.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правило B20-ти, B173, B344.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правоохранительное снаряжение, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Преимущества, B32</name>
<subrule> действует постоянно, B34</subrule>
<subrule> киношное, B33</subrule>
<subrule> экзотическое, B32, B34</subrule>
<subrule> в шаблонах, B447</subrule>
<subrule> магические, B34</subrule>
<subrule> ментальные, B32</subrule>
<subrule> обыденные, B32</subrule>
<subrule> новые, B117-B118</subrule>
<subrule> изучаемые, B294</subrule>
<subrule> список, B297</subrule>
<subrule> физические, B34</subrule>
<subrule> потенциальные, B33</subrule>
<subrule> Шредингера, B33</subrule>
<subrule> тайные, B33</subrule>
<subrule> социальные, B32</subrule>
<subrule> выключаемые, B34.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Препараты, B122, B130, B440</name>
<subrule> Стиратель, B540</subrule>
<subrule> передозировка, B441</subrule>
<subrule> ультратехнологичные, B425</subrule>
<subrule> синдром отмены, B440.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Престарелые персонажи, B20</name>
<subrule> см. тж. Возраст, Старение.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Привилегии, B30.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пригибание, B368.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Приключения, eB23, B494</name>
<subrule> финал, B503</subrule>
<subrule> готовые, B495</subrule>
<subrule> написание собственного, B500-B504.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прикрытие собой, B375.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Присмертные действия, B423.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Присмертные состояния, B429</name>
<subrule> раны, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Приспособления, B56-B58, B473-B477, B479</name>
<subrule> ограничения, B116.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прицельный огонь, B372.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Причуды, B162</name>
<subrule> расовые, B452.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пробивание насквозь, B379, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пробивание насквозь, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проверки влияния, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проверки реакции, B8, B494-B495.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проверки страха, B55, B93, B95, B121, B360</name>
<subrule> таблица проверок страха, B360-B361.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проверки успеха, B342</name>
<subrule> покупка успеха, B347</subrule>
<subrule> критический провал, B348</subrule>
<subrule> критический успех, B347</subrule>
<subrule> сложность, B345</subrule>
<subrule> модификаторы за снаряжение, B345</subrule>
<subrule> проверки влияния, B347</subrule>
<subrule> просьбы игрока, B347</subrule>
<subrule> повторные попытки, B348.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проверки успеха, B8.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прогрессия гравитации, B350.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Происхождение персонажей, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Проскальзывание, B368.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пространство (в бою), B368.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Профессор Вильям Хедли, лист персонажа, B318-B319</name>
<subrule> иллюстрации, B234, B486.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прыгуны по мирам, B544.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прыжки, B89, B203, B352, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прямые повреждения, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Псионика, B71, B78, B150, B254-B257</name>
<subrule> Антипси, B255</subrule>
<subrule> ЭСВ, B255</subrule>
<subrule> изучение, B294</subrule>
<subrule> новые силы, B257</subrule>
<subrule> Побочные эффекты, B255</subrule>
<subrule> Пси-лечение, B256</subrule>
<subrule> Психокинез, B256</subrule>
<subrule> Телепатия, B257</subrule>
<subrule> Телепортация, B257.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пси-силы, см. Псионика.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Психологическая война, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пулеметы, B281.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Путешествия во времени, B64, B93, B158, B189, B190.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Путешествия между мирами, B514, B519-B522</name>
<subrule> Фон кампаний Бесконечных миров, B523-B546</subrule>
<subrule> моментальное богатство, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пушечное мясо, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пчелы, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пылающие стрелы, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Работа, B292, B499, B516-B518</name>
<subrule> поиск, B518.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рабы, B518.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Радиация, B80, B105, B192, B435.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Радиус поворота, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разбойники времени, B542.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разговоры за столом, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разумность, B15, B23.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ранения плоти, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ранения, B327, B377, B380, B418-B425</name>
<subrule> накопление ран, B420</subrule>
<subrule> и активная защита, B374</subrule>
<subrule> кровотечение, B420</subrule>
<subrule> калечащие, B420-B423</subrule>
<subrule> ранения плоти, B417</subrule>
<subrule> повреждение большой области, B400</subrule>
<subrule> последние раны, B420</subrule>
<subrule> серьёзные раны, B420</subrule>
<subrule> смертельные раны, B423</subrule>
<subrule> шок, B419</subrule>
<subrule> предметам, B483-B485</subrule>
<subrule> щитам, B484</subrule>
<subrule> см. тж. Увечья, Лечение.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Раны, см. Ранения.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Растения, B75, B87, B90, B142, B197, B199, B211.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Расходы на жизнь, B265, B516.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Реализм, B11.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Реанимация, B425.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рейх-B5, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Религия, B30, B226</name>
<subrule> см. тж. Боги.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Репутация, B27.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ритуальная магия, B237, B242.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Родная гравитация, B17</name>
<subrule> см. тж.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гравитация.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ружья, B409.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Руны, B224.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>С-B31, лист персонажа, B307-B309</name>
<subrule> иллюстрации, B264, B549.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Самоконтроль, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Самолет, B466</name>
<subrule> таблица, B465.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Самонаводящееся оружие, B412-B413.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сб., см. Осечки.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сбивание, B371</name>
<subrule> существами, занимающими несколько клеток, B392.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сваливание, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сверх-усилие, B356.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сверхъестественные преимущества, B32, B33, B34</name>
<subrule> недостатки, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Свободные действия, B363.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сворачивание шеи, B370, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Связанные эффекты, B381.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сдвиг параллелей, B544-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Секретные личности, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сенсоры, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сердечный приступ, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Серебро, см. Богатство.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Серьёзные раны, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сети, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сеттинг Бесконечные миры, B523-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сила, B14.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Силы освобождения реальностей, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Силы правопорядка, B507</name>
<subrule> правоохранительное снаряжение, B289.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Скорострельность, B270, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>СЛ, см. Сила.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слоны, B460</name>
<subrule> розовые, B440.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слух, B49, B72, B89, B94, B138. B358.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Смертельный удар, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Смертштормы, B533.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Смерть, B296, B423</name>
<subrule> присмертные действия, B423</subrule>
<subrule> мгновенная смерть, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Снаряжение для верховой езды, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Снаряжение для походов и выживания, B288.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Снаряжение для связи и получения информации, B288, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Снаряжение, B264-B289</name>
<subrule> модификация бросков успеха, B345.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Собаки, B457, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сознание, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Солнечный удар, B434.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сон, B50, B65, B136, B140, B142, B154, B155</name>
<subrule> сонливость, B428</subrule>
<subrule> пропуск сна, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Соперники, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сопротивление повреждениям, B378</name>
<subrule> Таблица ЕЗ и СП построек, B558</subrule>
<subrule> Таблица СП укрытий, B559.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сопротивляемые заклинания, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сора, лист персонажа, B320-B321</name>
<subrule> иллюстрации, B10, B258, B356, B362, B375, B402.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Состояние пациента, B421.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Состязание, B348</name>
<subrule> быстрое, B348</subrule>
<subrule> обычное, B349</subrule>
<subrule> броски сопротивления, B348.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Социальное происхождение, B22.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Социальные недостатки, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Социальные ограничения, B30.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Социальные преимущества, B32</name>
<subrule> приобретение и улучшение, B291.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сошки, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Союзники, B36</name>
<subrule> группы союзников, B37.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>СП, см. Сопротивление повреждениям.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Списки черт, B297.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сс (Скорострельность), B270, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стандартные заклинания, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Старение, B53, B66, B95, B153, B154, B444.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Статус, B28, B265, B516.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Степень контроля, B506</name>
<subrule> см. тж.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Класс легальности.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стервятники, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стив Джексон, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стимуляторы, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стиратель, препарат, B540.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Столкновение, B430</name>
<subrule> удары при столкновении, B432.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Странности, B161</name>
<subrule> странные параллельные миры, B527</subrule>
<subrule> странная наука, B228, B479.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стрелы, горящие, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стрельба вверх и вниз, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стрельба наугад, B389.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стриги, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Супернаука, B513.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Суперы, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица ЕЗ и СП построек, B558.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица зон попаданий, B552-B555.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица зон попадания для пассажиров, B555.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица зон попадания для транспорта, B554.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица критических попаданий в голову, B556.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица критических попаданий, B556.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица критических промахов безоружного боя, B557.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица модификаторов активной защиты, B548.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица модификаторов дальнего боя, B548.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица модификаторов рукопашной атаки, B547.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица размеров, скоростей/ расстояний, B550.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица реакции НИП, B559-B562.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица реакции НИП, B559-B562.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица Скоростей/расстояний, B550.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица структурных повреждений, B558.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тайм Турс, B539.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тайные недостатки, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Телепатия, B69-B71, B91, B210, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Темнота, B47, B60, B71, B394</name>
<subrule> заклинания, B249</subrule>
<subrule> факелы, B394.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Температура, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Техники, B229</name>
<subrule> боевые, B230</subrule>
<subrule> улучшение, B292</subrule>
<subrule> список, B304.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Технологические навыки, B168.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Технологические уровни биотехнологий, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Технологические уровни медицины, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Технологические уровни оружия и брони, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Технологические уровни, B22, B99, B511-B512</name>
<subrule> и снаряжение, B27</subrule>
<subrule> и жанр, B514</subrule>
<subrule> и стартовое богатство, B27</subrule>
<subrule> разделение, B513</subrule>
<subrule> супернаука, B513</subrule>
<subrule> таблица ТУ по областям, B512.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Техуровни транспорта, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Техуровни энергетики, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Техуровни, см. Технологические уровни.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тигры, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Типы общества, B509-B510.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Типы планет, B180.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Типы правления, B509-B510</name>
<subrule> см. тж.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Законы.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Толкание, B372.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Топтание, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Травмы при столкновении, B432.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Трагические пороки, B119.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Транспорт, B188, B214, B223, B462-B470</name>
<subrule> воздушный, B465</subrule>
<subrule> поломки, B485</subrule>
<subrule> бой, B467-B470</subrule>
<subrule> броски управления, B466</subrule>
<subrule> повреждения, B555</subrule>
<subrule> наземный, B464</subrule>
<subrule> зоны попадания, B400, B554</subrule>
<subrule> движение, B463</subrule>
<subrule> космический, B465</subrule>
<subrule> уклонение транспорта, B375</subrule>
<subrule> водный, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Трансформации, B294.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Трассы между измерениями, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Требования, для умений, B169</name>
<subrule> для заклинаний, B235</subrule>
<subrule> для техник, B229.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Треноги, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ТУ, см. Технологические уровни.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Туннели, B94.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тупая травма, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Уайт Стар Трейдинг, B524, B539.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Увечья, B59, B420-B423.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удавки, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удар коленом, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удар локтем, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удар наугад, B388.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удача, B83, B89, B160.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удушение, B428, B436.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Уклонение, B17, B51, B324, B327, B374</name>
<subrule> с бросанием, B377.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Укрытие, B377, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Укрытие, B377, B407</name>
<subrule> Таблица СП укрытий, B559.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Улучшения, B101-B102</name>
<subrule> ограниченные, B111.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Улучшенные защиты, B51. умения влияния, B494. умения разработки, B190. умения ремонта, B190</name>
<subrule> ремонт предметов, B484. умения, B167, B174-B233</subrule>
<subrule> приобретение, B170</subrule>
<subrule> по умолчанию, B170</subrule>
<subrule> для разработки, B190</subrule>
<subrule> уровни сложности, B168</subrule>
<subrule> знакомство, B169</subrule>
<subrule> улучшение, B170, B292</subrule>
<subrule> в шаблонах, B447</subrule>
<subrule> влияния, B495</subrule>
<subrule> уровни, B171</subrule>
<subrule> список, B301</subrule>
<subrule> поддержание, B294</subrule>
<subrule> модификаторы физиологии, B181</subrule>
<subrule> требования, B169</subrule>
<subrule> расовые, B453</subrule>
<subrule> для ремонта, B190</subrule>
<subrule> широта, B176</subrule>
<subrule> специализации, B169</subrule>
<subrule> учеба, B292, B499</subrule>
<subrule> учителя, B293</subrule>
<subrule> технологические, B168</subrule>
<subrule> универсальные, B175.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Умное оружие, B278.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Универсальные навыки, B175.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Управляемое оружие, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Упрощенные правила боя, B324.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Уровень допустимого насилия, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Уровень силы в кампании, B10, B486.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ускорение, см. Гравитация.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Усталость, B16</name>
<subrule> B328, B426</subrule>
<subrule> единицы выносливости, B16</subrule>
<subrule> восстановление, B427.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Устойчивость к магии, B67.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Утопия, B510.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Учеба, B292.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Факелы, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Фамилиары, B38.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Фехтовальное оружие, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Физические действия, B349</name>
<subrule> сверхусилие, B356.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Физические преимущества, B32</name>
<subrule> недостатки, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Фонари, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ходьба, B351, B357, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Холод, B430.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Цель (заклинаний), B236.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Центрум, B541-B542, B545-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Цепы, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Церемониальная магия, B237.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ци, B33, B93, B192, B214.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чары, B480-B483</name>
<subrule> заклинания, B245.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Черты, мета-черты, B262</name>
<subrule> запрещенные черты, B26</subrule>
<subrule> см. тж. Создание персонажа.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чтение мыслей, см. Телепатия.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чтение, B134</name>
<subrule> см. тж. Грамотность.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чувства, B35, B78</name>
<subrule> броски чувств, B358.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чудотворцы, B538.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Воина, B449.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Героического рыцаря, B448.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Дварфа, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Дракона, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Мага, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Разведчика, B259.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Солдата удачи, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблон Человека-кошки, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаблоны, B258, B445-B454</name>
<subrule> культурные, B446</subrule>
<subrule> ролевые, B446</subrule>
<subrule> профессиональные, B446</subrule>
<subrule> расовые, B260, B450-B454.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шаг (в манёврах), B368, B386.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шимпанзе, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шок, электрический, B432-B433</name>
<subrule> от ран, B419.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шон Панч, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Шпионское снаряжение, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Щиты, B287, B374</name>
<subrule> повреждения, B484</subrule>
<subrule> в бою вплотную, B392</subrule>
<subrule> использование для нападения, B406.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Экзотические недостатки, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Экзотические преимущества, B32, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Экономика, B514.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Электричество, B432-B433.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Электроника, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эхо-параллели, B546.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Яды, B62, B437-B439</name>
<subrule> лечение, B439.</subrule>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Язык жестов, B25.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Языки, B23, B205, B506.</name>
<categories>
	<category>Basic Set</category>
	<category>Русский</category>
</categories>
</rule>
<!-- Basic Set Eng -->
<rule>
<name>Acceleration, see Gravity.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Accents, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Acid, B428.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Acrobatic dodge, B375.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Active Defense Modifiers Table, B548.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Active defenses, B326, B363, B374</name>
<subrule> modifiers table, B548.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Advantages, B32</name>
<subrule> always on, B34</subrule>
<subrule> cinematic, B33</subrule>
<subrule> exotic, B32, B34</subrule>
<subrule> in templates, B447</subrule>
<subrule> magic, B34</subrule>
<subrule> mental, B32</subrule>
<subrule> mundane, B32</subrule>
<subrule> new, B117-B118</subrule>
<subrule> learnable, B294</subrule>
<subrule> list, B297</subrule>
<subrule> physical, B34</subrule>
<subrule> potential, B33</subrule>
<subrule> Schrodinger’s, B33</subrule>
<subrule> secret, B33</subrule>
<subrule> social, B32</subrule>
<subrule> switchable, B34.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Adventures, eB23, B494</name>
<subrule> finale, B503</subrule>
<subrule> pre-packaged, B495</subrule>
<subrule> writing your own, B500-B504.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Adversary, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Afflictions, B35, B416, B428.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Age, B20.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Aging, B53, B66, B95, B153, B154, B444.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Aim maneuver, B58, B324, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Aimed fire, B372.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Air spells, B242.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Aircraft, B466</name>
<subrule> table, B465.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alcohol, B122, B439-B440.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alien artifacts, B478.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Allies, B36</name>
<subrule> ally groups, B37.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>All-Out Attack maneuver, B54, B324, B365, B385</name>
<subrule> after being grappled, B371.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>All-Out Defense maneuver, B324, B366, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ally groups, B37.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alternate worlds, B64, B160</name>
<subrule> travel, B189, B190</subrule>
<subrule> Centrum, B541-B542, B545-B546</subrule>
<subrule> classes, B526</subrule>
<subrule> close parallels, B526</subrule>
<subrule> Coventry, B540</subrule>
<subrule> echoes, B546</subrule>
<subrule> hell parallels, B528</subrule>
<subrule> myth parallels, B527</subrule>
<subrule> Reich-B5, B543</subrule>
<subrule> weird parallels, B527, world classes, B535. See also Crossworld Travel, Infinite Worlds Campaign.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alternative attacks, B61.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Always on</name>
<subrule> advantages, B34, magic items, B482.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ammunition, B278.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Anarchy, B509.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Animals, B40, B87, B90, B137, B175, B187, B210, B211, B217, B223, B225, B226, B228, B395, B455-B460</name>
<subrule> in combat, B461</subrule>
<subrule> individualizing, B457</subrule>
<subrule> draft, B459</subrule>
<subrule> pets, B458-B459</subrule>
<subrule> riding, B459</subrule>
<subrule> trained, B458-B459</subrule>
<subrule> see also Mounted Combat.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Apes, B455.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Appearance, B21.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Arc of vision, B389.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Area class, B176.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Area maps, B491.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Area spells, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Area-effect attacks, B413</name>
<subrule> scatter, B414.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Arm lock, B370, B403.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Armor divisors, B378.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Armor, B110, B282-B286</name>
<subrule> changing posture in armor, B395</subrule>
<subrule> combining and layering, B286</subrule>
<subrule> flexible armor and blunt trauma, B379</subrule>
<subrule> wearing, donning, and removing, B286.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Arrows, flaming, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Artifacts, anachronistic, B478</name>
<subrule> futuristic and alien, B478, magic, B240, B480-B483.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Artificial intelligences, B528.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Atmospheres, hazardous, B429</name>
<subrule> vacuum, B437.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Atmospheric pressure, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attack maneuver, B325, B365.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attack roll, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attacks, B326, B369</name>
<subrule> alternative, B61</subrule>
<subrule> after being grappled, B371</subrule>
<subrule> Deceptive.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attack, B369</name>
<subrule> dual-weapon, B417</subrule>
<subrule> from above, B402</subrule>
<subrule> in tactical combat, B388</subrule>
<subrule> innate, B51</subrule>
<subrule> linked effects, B381</subrule>
<subrule> modified, B114</subrule>
<subrule> runaround, B391</subrule>
<subrule> surprise, B393</subrule>
<subrule> swarm, B461</subrule>
<subrule> without damage, B381.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attributes, see Basic Attributes.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Automatic weapons, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Banestorms, B533.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Baron Janos Telkozep, character sheet, B312-B313</name>
<subrule> illustration, B290.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Basic attributes, B14</name>
<subrule> in templates, B447</subrule>
<subrule> improving, B290.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Basic Lift, B15</name>
<subrule> table, B17.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Basic Move, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Basic Speed, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Basilisks, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bats, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Battle maps, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Battlesuits, B192.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bears, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bees, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bends, the, B435.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Biotech tech levels, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bipods, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>BL, see Basic Lift.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bleeding, B68, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Block, B51, B324, B327</name>
<subrule> in tactical combat, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Blocking spells, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Blunt trauma, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Boars, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Body Control spells, B244.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Body modification, B294.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bolas, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bounty hunters, B539.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Break Free, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Breakdowns, B485.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Breaking a weapon, B401.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Breathing, B49, B55, B63, B68, B108</name>
<subrule> holding your breath, B351</subrule>
<subrule> smothering a foe, B401.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Build, B18.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bulletproof nudity, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>C-B31, character sheet, B307-B309</name>
<subrule> illustrations, B264, B549.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cabal, the, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Camels, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Campaigns, B486-B489</name>
<subrule> cinematic, B488</subrule>
<subrule> continuing, B504</subrule>
<subrule> planning form, B567</subrule>
<subrule> power level, B10, B486</subrule>
<subrule> shared campaigns, B504</subrule>
<subrule> travel between campaigns, B504</subrule>
<subrule> see also Game Worlds.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Camping and survival gear, B288.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cannon fodder, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Caster (of spells), B236.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Catching things, B355.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cats, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Centrum, B541-B542, B545-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Century scale damage, B470.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ceremonial magic, B237.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Change Posture maneuver, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Character classes, no such thing, B259.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Character points, B10, B119, B258, B290</name>
<subrule> awarding bonus points, B498.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Characters, B7</name>
<subrule> concept, B11</subrule>
<subrule> creation, B9, B10, B258</subrule>
<subrule> development, B290, B499</subrule>
<subrule> origins, B33</subrule>
<subrule> sheet, B13, B335-B336</subrule>
<subrule> stories, B12</subrule>
<subrule> types, B12.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Chi, B33, B93, B192, B214.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Children, B20.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Chimpanzees, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Choke hold, B371, B404</name>
<subrule> see also Suffocation.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cinematic advantages, B33</name>
<subrule> campaigns, B488</subrule>
<subrule> characters, B489</subrule>
<subrule> combat, B417</subrule>
<subrule> explosions, B417</subrule>
<subrule> knockback, B417.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Clerical magic, B77, B242</name>
<subrule> spells, B77.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Climbing, B89, B349.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cloaks, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Close combat, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Clothing, B265.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cold, B430.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Collisions, B430</name>
<subrule> whiplash, B432.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Coma, B429</name>
<subrule> see also Unconsciousness.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Combat Lite, B324.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Combat maps, B384, B492.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Combat, B9, B362-B417</name>
<subrule> at different levels, B402</subrule>
<subrule> cinematic, B417</subrule>
<subrule> maneuvers, B324</subrule>
<subrule> table of combat modifiers, B547</subrule>
<subrule> techniques, B230</subrule>
<subrule> turn sequence, B324, B362</subrule>
<subrule> vehicular, B467-B470.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Communication and Empathy spells, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Communications and information gear, B288, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Competence, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Comprehension rolls, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Computers, B48, B51, B55, B69, B71, B76, B100, B124, B184, B472</name>
<subrule> artificial intelligence, B528</subrule>
<subrule> complexity, B472</subrule>
<subrule> software, B472</subrule>
<subrule> virtual reality worlds, B520.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Concentrate maneuver, B325, B366.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cone attacks, B413.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Conspiracies, see Illuminati.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Contacts, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Contagion, B443</name>
<subrule> see also Disease.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Contests, B348</name>
<subrule> quick, B348</subrule>
<subrule> regular, B349</subrule>
<subrule> resistance rolls, B348.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Control Rating, B506</name>
<subrule> see also Legality Class.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Conventions of play, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Copper, see Wealth.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cosmic powers, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cost of living, B265, B516.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Coventry, B540.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cover, B377, B407</name>
<subrule> Cover DR Table, B559.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crippling, B59, B420-B423.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical failure, spells, B236.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical Head Blow Table, B556.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical Hit Table, B556.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical hits, B381</name>
<subrule> table, B556.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical Miss Table, B556</name>
<subrule> Unarmed Critical Miss Table, B557.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical misses, B381</name>
<subrule> table, B556-B557.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical success, B347</name>
<subrule> on defense, B381.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crossbows, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crosstime bandits, B542.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crossworld campaigns, B519-B522</name>
<subrule> see also Infinite Worlds Campaign.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crossworld travel, B514, B519-B522</name>
<subrule> Infinite Worlds campaign background, B523-B546</subrule>
<subrule> instant wealth, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Crouching, B368.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cultures, B23, B505-B508.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Customizing rules, B486.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dai Blackthorn, B12, B18, B22, B116, B162, B164, B227</name>
<subrule> character sheet, B310-B311</subrule>
<subrule> illustrations, B32, B418.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Damage Resistance, B378</name>
<subrule> HP and DR of Structures Table, B558</subrule>
<subrule> Cover DR Table, B559.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Damage, B15, B327, B377</name>
<subrule> by animals, B461</subrule>
<subrule> Damage Table, B16</subrule>
<subrule> damage rolls, B9, B378</subrule>
<subrule> scaling, B470</subrule>
<subrule> to objects, B483-B485.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Darkness, B47, B60, B71, B394</name>
<subrule> spells, B249</subrule>
<subrule> torches, B394.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>David Pulver, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dead worlds, B527.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dealing with players, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Death, B296, B423</name>
<subrule> dying actions, B423</subrule>
<subrule> instant death, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Decade scale damage, B470.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Deceptive attack, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Deer, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Defaults, B344</name>
<subrule> double, B173, B232</subrule>
<subrule> skills, B173</subrule>
<subrule> techniques, B229.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Defending, B326, B374</name>
<subrule> in tactical combat, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Defenses, B46</name>
<subrule> enhanced, B51</subrule>
<subrule> limited, B46.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dehydration, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Demolition, B415.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Depressants, B441.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Design skills, B190.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dexterity, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dice, B8, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Digging, B350, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dimensional highways, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dirty tricks, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Disadvantages, B11, B119</name>
<subrule> buying off, B121, B291</subrule>
<subrule> disadvantage limit, B11</subrule>
<subrule> good, B119</subrule>
<subrule> exotic, B120</subrule>
<subrule> in templates, B447</subrule>
<subrule> list, B299</subrule>
<subrule> mental, B120</subrule>
<subrule> mundane, B120</subrule>
<subrule> new, B162</subrule>
<subrule> physical, B120</subrule>
<subrule> secret, B120</subrule>
<subrule> social, B120</subrule>
<subrule> self-imposed, B121</subrule>
<subrule> supernatural, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Disease, B442-B444</name>
<subrule> worldwide, B528.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dive for cover, B377, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Divine origins</name>
<subrule> B33</subrule>
<subrule> see also Gods.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dmg, see Damage.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Do Nothing maneuver, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dodge, B17, B51, B324, B327, B374</name>
<subrule> and drop, B377.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dogs, B457, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Donkeys, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Double defaults, allowed for techniques, B229</name>
<subrule> not allowed for skills, B173.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>DR, see Damage Resistance.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dragging things, B353.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dragon template, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dropping prone, B374.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Drugs, B122, B130, B440</name>
<subrule> Eraser, B540</subrule>
<subrule> overdose, B441</subrule>
<subrule> ultra-tech, B425</subrule>
<subrule> withdrawal, B440.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dual-weapon attacks, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dungeons, B501.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dwarf template, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>DX, see Dexterity.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dying actions, B423. eB23 scenario warehouse, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Earth spells, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Echo timelines, B546.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Economics, B514.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elbow strike, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elderly characters, B20</name>
<subrule> see also Age, Aging.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Electricity, B432-B433.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Electronics, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elemental meta-traits, B262.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elephants, B460</name>
<subrule> pink, B440.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enchantment, B480-B483</name>
<subrule> spells, B245.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Encounters, B502</name>
<subrule> sample encounter table, B503.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Encumbrance, B17.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enhanced defenses, B51.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enhancements, B101-B102</name>
<subrule> limited, B111.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Equestrian gear, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Equipment, B264-B289</name>
<subrule> modifying success rolls, B345.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Eraser drug, B540.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Evading, B368.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Evaluate maneuver, B325, B364.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Exotic advantages, B32, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Exotic disadvantages, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Explosions, B414-B415</name>
<subrule> cinematic, B417.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Extra effort, B356.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Facing (in combat), B385, B386.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Falcons, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Falling, B430-B431</name>
<subrule> damage from falling objects, B431.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fallout, B435</name>
<subrule> see also Radiation.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Familiars, B38.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fatigue, B16</name>
<subrule> B328, B426</subrule>
<subrule> fatigue points, B16</subrule>
<subrule> recovering, B427.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Feint maneuver, B325, B365.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Felinoid template, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fencing weapons, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fire, B61</name>
<subrule> burning things, B433, B434</subrule>
<subrule> damage, B433</subrule>
<subrule> flaming arrows, B410</subrule>
<subrule> incendiary weapons, B277, B411, B433</subrule>
<subrule> spells, B246</subrule>
<subrule> tight-beam burning attacks, B399.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Firearms, B278-B281</name>
<subrule> accessories, B289, B411</subrule>
<subrule> aim, B364</subrule>
<subrule> automatic, B408</subrule>
<subrule> bracing, B364</subrule>
<subrule> firing upward and downward, B407</subrule>
<subrule> malfunction, B382, B407</subrule>
<subrule> quality, B280</subrule>
<subrule> rapid fire, B408</subrule>
<subrule> shotguns, B409</subrule>
<subrule> suppression fire, B409</subrule>
<subrule> ultra-tech, B280.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Firing upward and downward, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>First aid, B424.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flails, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flame, see Fire.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flaming arrows, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flashlights, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flesh wounds, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flight, B56, B354</name>
<subrule> flying combat, B398.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fnord, you’re not cleared for that.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Follow-up damage, B381.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Food, B95, B139, B159, B160, B265</name>
<subrule> foraging, B427</subrule>
<subrule> starvation, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>FP, see Fatigue Points.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fragmentation damage, B414.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Free actions, B363.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Friends and foes, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fright Checks, B55, B93, B95, B121, B360</name>
<subrule> Fright Check Table, B360-B361. Gadgeteering, see Gadgets.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gadgets, B56-B58, B473-B477, B479</name>
<subrule> limitations, B116.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Game balance, B11.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Game Mastering, B486-B504.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Game preparation, B490.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Game worlds, B505-B522</name>
<subrule> economics, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Garrotes, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gate spells, B247.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gerbils, B113.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>G-Increment, B350.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Glossary, B563-B565</name>
<subrule> arms and armor, B268</subrule>
<subrule> basic terms, B7</subrule>
<subrule> magic, B234</subrule>
<subrule> Infinite Worlds, B524</subrule>
<subrule> psionics, B254.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>GM Control Sheet, B490, B568.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gods, B33, B40, B59, B76, B113, B132, B143.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gold, see Wealth.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gorillas, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Government types, B509-B510</name>
<subrule> see also Laws.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Grabbing and grappling, B370</name>
<subrule> and hit location, B400.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gravity, B60, B350, B434</name>
<subrule> different gravity, B350</subrule>
<subrule> home gravity, B17.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Grenades, B277, B410.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ground vehicles, B466</name>
<subrule> table, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gryphons, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Guided weapons, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hallucinations, B429, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hallucinogens, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Handedness, B14.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Harpoons, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Healing, B59, B79, B80, B155, B160, B162</name>
<subrule> magic, B248</subrule>
<subrule> medical gear, B289</subrule>
<subrule> medical tech levels, B512</subrule>
<subrule> psychic, B256.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Health, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hearing, B49, B72, B89, B94, B138. B358.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Heart attacks, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Heat, B434</name>
<subrule> see also Fire.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hell parallels, B528.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Heroic Knight template, B448.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hexes, B384.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>High-speed movement, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hiking, B351, B357, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hirelings, B517, B518.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hit Location Tables, B552-B555.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hit location, B369, B398</name>
<subrule> and Injury Tolerance, B400</subrule>
<subrule> random, B400.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hit points, B16, B418-B419</name>
<subrule> HP and DR of Structures Table, B558</subrule>
<subrule> see also Injuries.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Home gravity, B17</name>
<subrule> see also Gravity.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Homing weapons, B412-B413.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Horses, B459-B460</name>
<subrule> equestrian gear, B289</subrule>
<subrule> see also Mounted Combat, Riding Animals, Weapons (Cavalry).</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>HP and DR of Structures Table, B558.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>HP, see Hit Points.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>HT (Health), B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>I-Cops, B536-B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Identities, B31, B39.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Illuminati, B60, B130, B193, B200, B525</name>
<subrule> the Cabal, B543.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Immunity, B443.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Importance in society, see Rank, Status.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Incompetence, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Index, B329-B334, B570-B575.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infection, B444.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infinite ammunition, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infinite Worlds campaign background, B523-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infinity Development, B536.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infinity Patrol, B536-B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Infinity Unlimited, B524, B535-B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Influence rolls, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Influence skills, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Information spells, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Initiative, B393.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Injuries, B327, B377, B380, B418-B425</name>
<subrule> accumulated wounds, B420</subrule>
<subrule> and active defense, B374</subrule>
<subrule> bleeding, B420</subrule>
<subrule> crippling, B420-B423</subrule>
<subrule> flesh wounds, B417</subrule>
<subrule> large-area injury, B400</subrule>
<subrule> last wounds, B420</subrule>
<subrule> major wounds, B420</subrule>
<subrule> mortal wounds, B423</subrule>
<subrule> shock, B419</subrule>
<subrule> to objects, B483-B485</subrule>
<subrule> to shields, B484</subrule>
<subrule> see also Crippling, Healing.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Instant death, B423.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Intelligence, B15</name>
<subrule> and dirty tricks, B405.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Intoxication, see Alcohol.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Introduction, B5, B342.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Investigator template, B259.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Iotha, character sheet, B314-B315, illustrations, B343.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>IQ (Intelligence), B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>ISWAT, B162, B536.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Jobs, B292, B499, B516-B518</name>
<subrule> finding, B518.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Jumping, B89, B203, B352, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Knee strike, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Knockback, B378.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Knowledge spells, B249.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Knowledge, NPC, B496</name>
<subrule> player vs. character, B495.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Languages, B23, B205, B506.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lariats, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lasers, B280, B399</name>
<subrule> seeker heads, B412</subrule>
<subrule> sights, B412.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Last wounds, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Law enforcement, B507</name>
<subrule> police gear, B289.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Laws, B65, B204, B506-B508, B518</name>
<subrule> punishment, B508</subrule>
<subrule> trials, B507.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>LC, see Legality Class.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Legality Class, B267, B270, B507</name>
<subrule> legality of spells, B507.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lethal strike, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lifting, B14, B15, B65, B205, B353, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Light and Darkness spells, B249.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Limitations, B101, B110</name>
<subrule> gadgets, B116.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Limited defenses, B46.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Linked effects, B381.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lions, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Literacy, B24.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Long actions, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Long tasks, B346, B499.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Louis d’Antares, character sheet, B322-B323</name>
<subrule> illustrations, B368, B422, B505.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Loyalty, B518-B519.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Luck, B83, B89, B160.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ludography, B566.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lycanthropy, see Werewolves.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Machine guns, B281.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Machines, B16</name>
<subrule> Machine meta-trait, B263.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mage template, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magery, B66.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic Resistance, B67.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic, B66, B143, B144, B150, B218, B224, B225, B234-B253</name>
<subrule> advantages, B34</subrule>
<subrule> ceremonial, B237</subrule>
<subrule> clerical, B242</subrule>
<subrule> colleges, B239</subrule>
<subrule> enchanted objects, B240, B480-B483</subrule>
<subrule> racial, B453</subrule>
<subrule> ritual, B237, B242</subrule>
<subrule> staffs, B240.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Major wounds, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Malf, see Malfunction.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Malfunction, B278, B382, B407.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mana, B235.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Maneuvers, B324, B363, B385</name>
<subrule> table, B551.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Maps, B384, B490-B491</name>
<subrule> mapping by players, B491</subrule>
<subrule> mapping for adventure design, B502.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Medical care, B424</name>
<subrule> surgery, B424.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Medical gear, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Medicine tech levels, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Melee Attack Modifiers Table, B547.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Melee etiquette, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Melee spells, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mental advantages, B32</name>
<subrule> disadvantages, B120</subrule>
<subrule> powers, see Psionics.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mental stun, B420.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mentality meta-traits, B263.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Meta-Spells, B250.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Meta-traits, B262.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Metric conversions, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Military, B218, B221, B222, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mind Control spells, B250.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mind reading, see Telepathy.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mind transfer, B296.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Miniature figures, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Miracle Workers Inc., B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Missile spells, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Missile weapon attacks, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Modifiers (to traits), B101</name>
<subrule> list, B300.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Molotov cocktails, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Money, see Wealth.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Monsters, B460-B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Morphology meta-traits, B263.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mortal conditions, B429</name>
<subrule> wounds, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mounted combat, B395-B398.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Move (character stat), B52.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Move and Attack maneuver, B325, B365, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Move maneuver, B325, B364, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Movement and combat, B367</name>
<subrule> and facing, B386</subrule>
<subrule> high-speed movement, B394</subrule>
<subrule> movement in tactical combat, B386.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Movement points, B386, B387.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Movement spells, B251.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mules, B459.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Multi-hex figures, B392.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mundane advantages, B32</name>
<subrule> disadvantages, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mutations, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Neck Snap attack, B370, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Necromantic spells, B251.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Nets, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>New disadvantages, B162.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>New inventions, B473, B475</name>
<subrule> see also Gadgets.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Nexus portals, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Nonhumans, B32.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Non-player characters, see NPCs.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>NPC Reactions Table, B559-B562.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>NPC Record Card, B569.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>NPCs, B31, B493</name>
<subrule> NPC Reactions Table, B559-B562</subrule>
<subrule> NPC Record Card, B569.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Oil flasks, B411.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Omens, B72.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Online gaming, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Optics and sensors, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Origins of characters, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Overpenetration, B379, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Overrun, by multi-hex figures, B392.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Oxen, B460.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parachronic Laboratories Inc., B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parachronics, bogus scientific explanation, B530</name>
<subrule> conveyor, B529</subrule>
<subrule> detector, B532</subrule>
<subrule> disasters, B532</subrule>
<subrule> minor accidents, B531</subrule>
<subrule> paradoxes, B533</subrule>
<subrule> projector</subrule>
<subrule> B524, B530</subrule>
<subrule> see also Infinite Worlds Campaign.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parachronozoids, B544.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parallel worlds, see Alternate Worlds.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Paralysis, B429.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parry, B51, B93, B324, B327, B376</name>
<subrule> unarmed, B376</subrule>
<subrule> in tactical combat, B390.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Patient status, B421.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Patrons, B72-B73.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Penetrating damage, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Penetration modifiers, B378, B416</name>
<subrule> overpenetration, B379, B408.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Per, see Perception.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Perception, B16.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Perks, B100.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pets, B458-B459</name>
<subrule> see also Animals.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Physical advantages, B32</name>
<subrule> disadvantages, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Physical feats, B349</name>
<subrule> extra effort, B356.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Picking things up, B383.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Picks, B405.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pinning (in combat), B370.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Planet types, B180.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Plants, B75, B87, B90, B142, B197, B199, B211.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pocket multiverses, B529.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Poison, B62, B437-B439</name>
<subrule> treatment, B439.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Police gear, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pop-up attacks, B390.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Postures, B367</name>
<subrule> changing posture in armor, B395</subrule>
<subrule> table, B551.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Potential advantages, B33.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Power level for campaigns, B10, B486.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Power tech levels, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Preparing for play, B490.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Prerequisites, skills, B169</name>
<subrule> spells, B235</subrule>
<subrule> techniques, B229.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pressure, atmospheric, B429, B435</name>
<subrule> the bends, B435</subrule>
<subrule> water, B435.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Privilege, B30.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Professor William Headley, character sheet, B318-B319</name>
<subrule> illustrations, B234, B486.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Protection and Warning spells, B252.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Psi powers, see Psionics.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Psionics, B71, B78, B150, B254-B257</name>
<subrule> Antipsi, B255</subrule>
<subrule> ESP, B255</subrule>
<subrule> learning, B294</subrule>
<subrule> new powers, B257</subrule>
<subrule> pside effects, B255</subrule>
<subrule> Psychic Healing, B256</subrule>
<subrule> Psychokinesis, B256</subrule>
<subrule> Telepathy, B257</subrule>
<subrule> Teleportation, B257.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Psychological warfare, B359.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pulling things, B353.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Punishment, legal, B508.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pyramid Magazine, B494.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Quick contests, B348.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Quick learning under pressure, B292.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Quick Start rules, B8.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Quirks, B162</name>
<subrule> racial, B452.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Radiation, B80, B105, B192, B435.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ranged attacks, B327, B372</name>
<subrule> half damage range, B378</subrule>
<subrule> hitting the wrong target, B389</subrule>
<subrule> modifiers table, B548</subrule>
<subrule> opportunity fire, B390</subrule>
<subrule> overshooting, B390</subrule>
<subrule> pop-up attacks, B390</subrule>
<subrule> shooting blind, B389.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ranged Combat Modifiers Table, B548.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rank, B29.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rapid fire, B373, B408.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rapid Strike, B54, B93, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rate of Fire, B270, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rats, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rattlesnakes, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rcl, see Recoil.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reaction rolls, B8, B494-B495, NPC Reactions Table, B559-B562.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reading, B134</name>
<subrule> see also Literacy.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ready maneuver, B325, B366, B382, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ready weapons, B369</name>
<subrule> readying, B382.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Realism, B11.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reality Liberation Force, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reality quakes, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Recoil, B271.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Recovery, B328</name>
<subrule> see also Healing.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Recovery, B423-B424</name>
<subrule> from unconsciousness, B423.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Regular spells, B239.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reich-B5, B543.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Religion, B30, B226</name>
<subrule> see also Gods.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reloading missile weapons, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Repair skills, B190</name>
<subrule> repairing things, B484.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reputation, B27.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Resisted spells, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Resuscitation, B425.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Retreat (in active defense), B377.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Retreating, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ritual magic, B237, B242.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Roads, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>RoF (Rate of Fire), B270, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Roleplaying, B7.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rolling to hit, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Room maps, B492.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rounding, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rule of B14, B360.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rule of B16, B349.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rule of B20, B173, B344.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rules, customizing, B486</name>
<subrule> questions, B492.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Runaround attacks, B391.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Runes, B224.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Running, B354, B357</name>
<subrule> fatigue, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sacrificial dodge, B375.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sapience, B15, B23.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Scopes, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sean Punch, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Seasickness, B436.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Secondary characteristics, B15</name>
<subrule> improving, B290</subrule>
<subrule> in templates, B447.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Secret disadvantages, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Secret identities, B31.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Self-control, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Senses, B35, B78</name>
<subrule> sense rolls, B358.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sensors, B471.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sentience, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sharks, B457.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shields, B287, B374</name>
<subrule> damage, B484</subrule>
<subrule> in close combat, B392</subrule>
<subrule> offensive use, B406.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shiftrealms, B534.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shock, electrical, B432-B433</name>
<subrule> from injury, B419.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shooting blind, B389.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shotguns, B409.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shove, B372.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sign language, B25.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Silencers, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Silver, see Wealth.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Size and Speed/Range Table, B550.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Size Modifier, B19, B372</name>
<subrule> and reach, B402.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Skills, B167, B174-B233</name>
<subrule> buying, B170</subrule>
<subrule> defaults, B170</subrule>
<subrule> design, B190</subrule>
<subrule> difficulty level, B168</subrule>
<subrule> familiarity, B169</subrule>
<subrule> improving, B170, B292</subrule>
<subrule> in templates, B447</subrule>
<subrule> influence, B495</subrule>
<subrule> levels, B171</subrule>
<subrule> list, B301</subrule>
<subrule> maintaining, B294</subrule>
<subrule> physiology modifiers, B181</subrule>
<subrule> prerequisites, B169</subrule>
<subrule> racially learned, B453</subrule>
<subrule> repair, B190</subrule>
<subrule> scope, B176</subrule>
<subrule> specialties, B169</subrule>
<subrule> studying, B292, B499</subrule>
<subrule> teachers, B293</subrule>
<subrule> technological, B168</subrule>
<subrule> wildcard, B175.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Slam, B371</name>
<subrule> by multi-hex figures, B392.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Slaves, B518.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sleep, B50, B65, B136, B140, B142, B154, B155</name>
<subrule> drowsy, B428</subrule>
<subrule> missed sleep, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>SM, see Size Modifier.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Smartguns, B278.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Smell, B49, B243.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Snakes, B458</name>
<subrule> cobra venom, B439</subrule>
<subrule> pythons, B458</subrule>
<subrule> rattlesnakes, B458.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Social advantages, B32</name>
<subrule> adding and improving, B291.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Social background, B22.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Social disadvantages, B120.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Social restraints, B30.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Society types, B509-B510.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Soldier of Fortune template, B260.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sora, character sheet, B320-B321</name>
<subrule> illustrations, B10, B258, B356, B362, B375, B402.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sounds, see Hearing.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Space sickness, B434.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spacecraft, B466</name>
<subrule> table, B465.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spacing (in combat), B368.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Special spells, B241.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Speed/Range Table, B550.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spells, B66</name>
<subrule> Air, B242</subrule>
<subrule> area, B239</subrule>
<subrule> backfire, B235</subrule>
<subrule> blocking, B241</subrule>
<subrule> Body Control, B244</subrule>
<subrule> caster, B236</subrule>
<subrule> casting, B235-B238</subrule>
<subrule> clerical, B77</subrule>
<subrule> Communication and Empathy, B245</subrule>
<subrule> Earth, B245</subrule>
<subrule> Enchantment, B246, B480-B482</subrule>
<subrule> Fire, B246</subrule>
<subrule> Gate, B247</subrule>
<subrule> Healing, B248</subrule>
<subrule> information, B241</subrule>
<subrule> Knowledge, B249</subrule>
<subrule> legality, B507</subrule>
<subrule> Light and Darkness, B249</subrule>
<subrule> Meta-Spells, B250</subrule>
<subrule> melee, B240</subrule>
<subrule> Mind Control, B250</subrule>
<subrule> missile, B240</subrule>
<subrule> Movement, B251</subrule>
<subrule> list, B304</subrule>
<subrule> Necromantic, B251</subrule>
<subrule> prerequisites, B235</subrule>
<subrule> Protection and Warning, B252</subrule>
<subrule> regular, B239</subrule>
<subrule> resisted, B241</subrule>
<subrule> special, B242</subrule>
<subrule> subject, B236</subrule>
<subrule> Water, B253</subrule>
<subrule> see also Magic.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spirits, B41, B55, B68, B76, B113, B193, B200, B212</name>
<subrule> spirit advantages, B34</subrule>
<subrule> Spirit meta-trait, B263.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spy gear, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>ST, see Strength.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Staffs, B240.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Starvation, B426.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Status, B28, B265, B516.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Step (in maneuvers), B368, B386.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Steve Jackson, B6.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Stimulants, B440.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Strangle, B370, B401, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Strength, B14.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Striges, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Striking at weapons, B400.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Structural Damage Table, B558.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Study, B292.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Stunning, B35</name>
<subrule> mental stun, B420.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Subduing a foe, B401.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Subject (of spells), B236.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Success rolls, B342</name>
<subrule> buying success, B347</subrule>
<subrule> critical failure, B348</subrule>
<subrule> critical success, B347</subrule>
<subrule> difficulty, B345</subrule>
<subrule> equipment modifiers, B345</subrule>
<subrule> influencing rolls, B347</subrule>
<subrule> player guidance, B347</subrule>
<subrule> repeated attempts, B348.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Success rolls, B8.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Suffocation, B428, B436.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sunburn, B434.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Supernatural advantages, B32, B33, B34</name>
<subrule> disadvantages, B120.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Supers, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Superscience, B513.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Suppression fire, B409.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Surprise attacks, B393.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Swarm attacks, B461.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Swimming, B354, B357</name>
<subrule> fatigue, B426.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Swinging damage, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Switchable advantages, B34.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Table talk, B493.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Taboo traits, B261.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Takedown, B370.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Taste and smell, B49, B358.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tech level, see Technology Levels.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Techniques, B229</name>
<subrule> combat, B230</subrule>
<subrule> improving, B292</subrule>
<subrule> list, B304.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Technological skills, B168.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Technology Levels, B22, B99, B511-B512</name>
<subrule> and equipment, B27</subrule>
<subrule> and genre, B514</subrule>
<subrule> and starting wealth, B27</subrule>
<subrule> divergent, B513</subrule>
<subrule> superscience, B513</subrule>
<subrule> table of TLs by field, B512.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Teeth, B91.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Telepathy, B69-B71, B91, B210, B245.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Temperature, B9.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Templates, B258, B445-B454</name>
<subrule> cultural, B446</subrule>
<subrule> dramatic, B446</subrule>
<subrule> occupational, B446</subrule>
<subrule> racial, B260, B450-B454.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Terrain, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Thief and spy gear, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Throwing things, B355, B357.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Thrown weapon attacks, B373.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Thrusting damage, B15.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tigers, B456.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time Tours, Ltd., B539.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time travel, B64, B93, B158, B189, B190.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time Use Sheets, B499, B569.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time, between adventures, B498</name>
<subrule> between sessions, B497</subrule>
<subrule> during adventures, B497.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Timeline shifts, B544-B546.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>TL, see Technology Level.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>To-hit roll, B326, B369.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tools, B289.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Torches, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tragic flaws, B119.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Trait lists, B297.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Traits, meta-traits, B262</name>
<subrule> taboo traits, B26</subrule>
<subrule> see also Character Creation.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Trampling, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Transformations, B294.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Transportation tech levels, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Traps, B502.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Travel maps, B491.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Trials, B507</name>
<subrule> punishment, B508.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tripods, B412.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tunnels, B94.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Turning radius, B394.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>TV action violence, B417.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Unarmed combat, B370</name>
<subrule> hurting yourself, B379</subrule>
<subrule> parrying, B376.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Unarmed Critical Miss Table, B557.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Unconsciousness, B419, B423, B429</name>
<subrule> recovery from, B329.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Undead, B50</name>
<subrule> see also Vampires, Zombies.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>United Nations, B535, B538.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Utopia, B510.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vacuum, B437.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vampires, B137, B212</name>
<subrule> see also Baron Janos Telkozep. Vehicle Hit Location Table, B554.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vehicle Occupant Hit Location Table, B555.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vehicles, B188, B214, B223, B462-B470</name>
<subrule> aircraft, B465</subrule>
<subrule> breakdowns, B485</subrule>
<subrule> combat, B467-B470</subrule>
<subrule> control rolls, B466</subrule>
<subrule> damage, B555</subrule>
<subrule> ground vehicles, B464</subrule>
<subrule> hit location, B400, B554</subrule>
<subrule> movement, B463</subrule>
<subrule> spacecraft, B465</subrule>
<subrule> vehicular dodge, B375</subrule>
<subrule> watercraft, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Virtual realities, B520.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Visibility, B394</name>
<subrule> see also Darkness.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vision, B92, B123, B124, B144, B151, B358.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Voice, B132.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wait maneuver, B325, B366, B385.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Warhorses, see Horses.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Warrior template, B449.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Water spells, B253.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Watercraft, B466</name>
<subrule> table, B464.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wealth, B25, B26, B264, B517</name>
<subrule> and Status, B26, B516</subrule>
<subrule> cost of living, B265, B516</subrule>
<subrule> economics, B514</subrule>
<subrule> gold and silver, B515</subrule>
<subrule> improving character wealth level, B291</subrule>
<subrule> moving money between worlds, B514.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weapon and armor tech levels, B512.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weapons, B267-B281</name>
<subrule> accessories, B289, B411</subrule>
<subrule> accuracy, B269</subrule>
<subrule> ammunition, B278</subrule>
<subrule> breaking, B401, B485</subrule>
<subrule> bulk, B270</subrule>
<subrule> carrying, B287</subrule>
<subrule> cavalry, B397</subrule>
<subrule> cost, B270</subrule>
<subrule> fencing, B404</subrule>
<subrule> firearms, B278-B281</subrule>
<subrule> grenades, B277</subrule>
<subrule> heavy, B281</subrule>
<subrule> incendiaries, B277</subrule>
<subrule> infinite cinematic ammunition, B417</subrule>
<subrule> Legality Class, B271</subrule>
<subrule> malfunction, B278, B407</subrule>
<subrule> melee, B271-B275</subrule>
<subrule> missiles, B281</subrule>
<subrule> parry, B269</subrule>
<subrule> range, B269</subrule>
<subrule> ranged, B275-B277, B278-B281</subrule>
<subrule> rate of fire, B270</subrule>
<subrule> reach, B269</subrule>
<subrule> reach and Size Modifier, B388, B402</subrule>
<subrule> recoil, B271</subrule>
<subrule> shots, B270</subrule>
<subrule> smartguns, B278</subrule>
<subrule> strength, B270</subrule>
<subrule> striking at weapons, B400</subrule>
<subrule> thrown, B356</subrule>
<subrule> weight, B270.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weather, B243, B351.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weirdness, B161</name>
<subrule> weird parallel worlds, B527</subrule>
<subrule> weird science, B228, B479.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Werewolves, B83, B84, B137.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Whiplash, B432.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Whips, B406.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>White Star Trading, B524, B539.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wild swings, B388.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wildcard skills, B175.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Will, B16</name>
<subrule> Will rolls, B360.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wolves, B458.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>World-jumpers, B544.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wounding modifier, B379.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wounds, see Injuries.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wrench Limb attack, B370, B404.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Xing La, character sheet, B316-B317</name>
<subrule> illustrations, B167, B188, B418, B445.</subrule>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Zombies, B74, B94, B252, B380.</name>
<categories>
	<category>Basic Set</category>
	<category>English</category>
</categories>
</rule>

<rule>
<name>«Действующие постоянно» предметы, M19.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>«Святые» заклинания, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алкахест, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алфавит Огам, M209.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алхимики, M18.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алхимические обереги, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>предметы, M210</name>
<subrule> использование предметов, M212</subrule>
<subrule> лаборатории, M211</subrule>
<subrule> талисманы, M220.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алхимическое противоядие, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алхимия, M210.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Алхимия, умение, M210.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Альтернативные магические ритуалы, M9.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Альтернативные требования, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Альтернативные системы магии, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Анализ алхимических оберегов, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Анализ эликсиров, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бдение, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Безумие, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Благословить, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Блокирующие заклинания, M8, M12.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Боевой эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Божественное зачарование, заклинания, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Бросок успешности зачарования, M17.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Быстрое и ненадежное зачарование, M17, M20, M22.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вариации, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вечный покой, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вечный покой, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Возгонка, заклинание, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Волшебники-алхимики, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Воскрешение, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Восприятие, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Вредоносные эликсиры, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Временные заклинания, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Время и стоимость создания алхимических оберегов, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Время сотворения заклинаний, M7</name>
<subrule> синтаксических, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Всадник, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Выносливость, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Высокий уровень умения и стоимость поддержания, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гибридизация, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Глаголы, M202, M206.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Глоссарий, M5.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Глупость, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гнусность, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гомункулус, M221.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Гримуар, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Грузчик, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дарованная сила, преимущество, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дельцы, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Длительность заклинаний, M9</name>
<subrule> синтактических, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Длительные заклинания, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Доверчивость, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Долгий сон, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Доступность эликсиров, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Другие ритуальные идиомы, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Дружелюбие, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Духовное Звание, преимущество, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Жреческая магия, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Забывчивость, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зависть, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Воды, M184.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания воздуха, M23.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Врат, M80.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания движения, M142.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Животных, M29.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания зачарования, M10, M14, M56.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Защиты и предупреждения, M166.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Звука, M171.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Земли, M50.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Знаний, M100.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Иллюзий и создания, M95.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Контроля разума, M133.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Контроля тела, M35.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Лечения, M88.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Молнии, M12.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Некромантии, M149.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Общения и понимания, M44.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания огня, M72.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания пищи, M77.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Погоды, M193.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Починки и поломки, M115.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Растений, M161.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Света и Тьмы, M110.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания Технологии, M175.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания, M5</name>
<subrule> областные, M11</subrule>
<subrule> блокирующие, M8, M12</subrule>
<subrule> отмена, M10</subrule>
<subrule> сотворение, M7</subrule>
<subrule> жреческие, M199</subrule>
<subrule> рассеивание, M14</subrule>
<subrule> длительность, M9</subrule>
<subrule> зачарование, M10, M14</subrule>
<subrule> информационные, M13</subrule>
<subrule> мгновенные, M10</subrule>
<subrule> разработка, M14</subrule>
<subrule> длительные, M10</subrule>
<subrule> поддержка, M9</subrule>
<subrule> контактные, M11</subrule>
<subrule> метательные, M12</subrule>
<subrule> одна попытка, M10</subrule>
<subrule> постоянные, M10</subrule>
<subrule> созданные игроками, M15</subrule>
<subrule> стандартные, M11</subrule>
<subrule> сопротивляемые, M13</subrule>
<subrule> тайны, M9</subrule>
<subrule> временные, M10.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания, одной попытки, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинания, созданные игроками, M15.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заклинатель, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Заучивание чар, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зачарование, M16</name>
<subrule> броски успеха, M17.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зачарование, и экономика, M21</name>
<subrule> быстрое и ненадежное, M17, M22</subrule>
<subrule> медленное и надежное, M18, M22</subrule>
<subrule> без предметов, M18</subrule>
<subrule> без заклинаний, M18</subrule>
<subrule> подержание, M21.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зачарователи, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Здоровье, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Зелье, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Знание трав, умение, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Игрок, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Идентификация магических предметов, M19, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Идеограммы-символы, M206.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изгнать зомби, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изобразительное искусство (Каллиграфия), умение, M207.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изобретатели-алхимики, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изобретатель, преимущество, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Изучение магии, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Импровизированная магия, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ингредиенты, магические, M8.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Информационные заклинания, M13.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Использование алхимических оберегов, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Использование алхимических предметов, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Использование магических предметов, M19.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Использование символьных чар на предмете, M208.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Истинная земля, заклинание, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Истинная кислота, заклинание, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Истинное зрение, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Исцеление, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Каменное сердце, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Классы заклинаний, M11.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Количество требований, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контактные заклинания, M11.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контроль животных, эликсир, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контроль магических предметов, M19.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контроль над наложением чар</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>ИП, M17.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Контроль птиц, эликсир, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Концентрация и поддержка, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Критический провал, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лаборатории, алхимические, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Лидерство, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Любовь, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магически заряженные материалы, M222.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магические ингредиент, M8.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магические посохи, M13.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магические предметы, M16</name>
<subrule> покупка, M20</subrule>
<subrule> идентификация, M19, M212</subrule>
<subrule> продажа, M21</subrule>
<subrule> использование, M19.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магические ритуалы, M8.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магические способности, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магичность, M5.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магия, основанная на преимуществах, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Магия, основанная на преимуществах, M201</name>
<subrule> церемониальная, M12, M16</subrule>
<subrule> жреческая, M199</subrule>
<subrule> школы, M11</subrule>
<subrule> импровизированная, M201</subrule>
<subrule> изучение, M6</subrule>
<subrule> принципы, M5</subrule>
<subrule> ритуальная, M200</subrule>
<subrule> символьная, M205</subrule>
<subrule> синтаксическая, M202</subrule>
<subrule> универсальная, M202.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мазь, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мана, M5, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мастера-зачарователи, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мастерение синтаксической магии, M204.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Материалы, магически заряженные, M222.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мгновенные заклинания, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медицинские эликсиры, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Медленное и надежное зачарование, M18, M20, M22.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мета-заклинания, M121.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Метательные заклинания, M12.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Многочисленные слова, M203.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Модификаторы дальних дистанций, M14.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Молодость, эликсир, M218,</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Мудрость, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Музыка, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Невидимость, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ненависть, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Неоднократное зачарование, M18.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Неудачливость, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Неуязвимость, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обаяние, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обереги, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обереги, алхимические, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Областные заклинания, M11</name>
<subrule> на боевой карте, M13.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обнаружение алхимических оберегов, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Обнаружение эликсиров, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Огненный шар, заклинание, M12.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ограничение эффекта, M9.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Оличение, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Описания заклинаний, M22.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Опьянение, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Острое зрение, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отвлечение, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Отмена заклинаний, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Память, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Переименование заклинаний, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Персонажи-волшебники, M15.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пир монаха, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Плодородие, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Погибель, заклинание, M18.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подводное дыхание, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поддержка заклинаний, M9.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Подержанные чары, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Поиск учителя, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Покупка магических предметов, M20.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Полет, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Порошок, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Посохи, магические, M13.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Постоянные заклинания, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Правда, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Предвидение, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Предметы, алхимические, M210</name>
<subrule> магические, M16</subrule>
<subrule> многократно зачарованные, M18.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Прерывание, M18.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Привлекательность, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Принципы магии, M5.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Природная атака, умение, M12.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Пробуждение, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Провал, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Продажа магических предметов, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Развратность, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разговор с животными, эликсир, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разочарование, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разработка новых заклинаний, M14, M202.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Разработка новых эликсиров, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ранение, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рассеивание заклинаний, M14.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рассеять одержимость, заклинание, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Растворитель, универсальный, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Реанимация, эликсир, M217.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Регенерация, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Результаты синтаксических заклинаний, M204.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ремесленник, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рисование пальцем, M208.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Рисование символов, умение, M205, M208.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ритуалы, магические, M8.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ритуальная магия, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ритуальные идиомы, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Руны Футарка, M208, M209.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Самовлюбленность, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Свитки, M207.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Связь синтаксических заклинаний, M204.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Святость, M199, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Секреты, алхимические, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сила магического предмета, M17.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сила, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Символьная магия, M205.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Символьные жезлы, M208.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Символьные начертания, M207.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Синтаксическая магия, M202</name>
<subrule> Мастерение, M204</subrule>
<subrule> связь, M204.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Скорость, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Скрытность, эликсир, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Скрытые таланты, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слабость, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слова силы, M203.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слова, M202.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Слух, эликсир, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Смена поддерживаемых заклинаний, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Смерть, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Создание алхимических предметов, M210.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Создание персонажа-волшебника, M15.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Созревание, заклинание, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сон, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сопротивляемые заклинания, M13</name>
<subrule> синтаксической магии, M204.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сотворение заклинаний, M7</name>
<subrule> символьной магии, M206</subrule>
<subrule> синтаксических заклинаний, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Сотворение с начертанных символов, M207.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Спокойствие, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стандартные заклинания, M11.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Старение, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стоимость эликсиров, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Стоимость энергокамней, M20.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Странствующие зачарователи, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Страх, эликсир, M215.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Существительные, M202, M206.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблетка, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица заклинаний, M223.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Таблица критических провалов заклинаний, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тайные заклинания, M9.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Тауматология, умение, M15, M200.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Типы длительности, M10.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Только в чрезвычайных ситуациях, ограничение, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Трансформация, M204.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Трансформация, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Требования веры, недостаток, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Требования, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Убийца драконов, эликсир, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Удача, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Укорочение цепочек требований, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Универсальная магия, M202.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Универсальное противоядие, эликсир, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Универсальный растворитель, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Уровни по умолчанию, заклинаний, M202.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Успех, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Устойчивость к боли, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Устойчивость к магии, к эликсирам, M213.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Устойчивость к магии, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Устойчивость к огню, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Учитель, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Философский камень, M221.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Фокусы, M203.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Формулы, алхимические, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Формулярий, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Химия, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Ходьба по воде, эликсир, M216.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Цель, M7.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Цепочки требований, укорочение, M201.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Церемониальная магия, M12, M16.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Церковный сан, преимущество, M199.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Чувство маны, M6.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Школы магии, M11.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Штуковины, преимущество, M211.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Экзотические вещества, M220.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Экономика и зачарование, M21.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эликсиры боевых способностей, M214.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эликсиры ментального контроля, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эликсиры ментальных способностей, M218.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эликсиры умений и физических способностей, M219.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Эликсиры, M212.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Энергостоимость, M8</name>
<subrule> синтаксических заклинаний, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>
<rule>
<name>Языковая символьная магия, M206.</name>
<categories>
	<category>Magic</category>
	<category>Русский</category>
</categories>
</rule>



</rule>
<rule>
<name>Advantage-based magic, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Aging elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Air spells, M23.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alchemical Antidote elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alchemical charms, M220</name>
<subrule> items, M210</subrule>
<subrule> items, using, M212</subrule>
<subrule> laboratories, M211</subrule>
<subrule> talismans, M220.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alchemists, M18.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alchemy skill, M210.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alchemy, M210.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alkahest, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alternate magic rituals, M9.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alternate prerequisites, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Alternative magic systems, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>“Always on” items, M19.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Amulets, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Analysis of alchemical charms, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Analysis of elixirs, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Animal Control elixirs, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Animal spells, M29.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Area spells, M11</name>
<subrule> on a battle map, M13.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Artist (Calligraphy) skill, M207.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Attractiveness elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Availability, of elixirs, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Awakening elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bane spell, M18.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Battle elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Beast-Speech elixir, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bird Control elixir, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Bless spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Blocking spells, M8, M12.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Body control spells, M35.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Brokers, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Buying magic items, M20.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Canceling spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cantrips, M203.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Caster, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Casting spells, M7</name>
<subrule> symbol magic, M206</subrule>
<subrule> syntactic spells, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ceremonial magic, M12, M16.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Changing maintained spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Charisma elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Charms, alchemical, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Chemistry, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Classes, spell, M11.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Clerical Investment advantage, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Clerical magic, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Colleges of magic, M11.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Combat Abilities elixirs, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Communication and</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Empathy spells, M44.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Concentration and maintenance, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Controlling magic items, M19.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Controlling PC enchantment, M17.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Cost, of elixirs, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Craftsmanship elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical failure, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Critical spell failure table, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Death elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Designing wizard characters, M15.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Detecting elixirs, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Detection of alchemical charms, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Devotional Enchantment spell, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Discipline of Faith disadvantage, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dispel Possession spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dissipating spells, M14.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Distill spell, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Distraction, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Dragonslaying elixir, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Drunkenness elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Duration of spells, M9</name>
<subrule> of syntactic spells, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Duration types, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Earth spells, M50.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Economics and enchantment, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elixirs, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Emergencies Only limitation, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enchanters, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enchanting, M16</name>
<subrule> success rolls, M17.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enchantment spells, M10, M14, M56.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Enchantment, economics and, M21</name>
<subrule> quick and dirty, M17, M22</subrule>
<subrule> slow and sure, M18, M22</subrule>
<subrule> without items, M18</subrule>
<subrule> without spells, M18</subrule>
<subrule> second-hand, M21.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Endurance elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Energy cost, M8</name>
<subrule> of syntactic spells, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Essential Acid spell, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Essential Earth spell, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Eternal Rest elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Exotic preparations, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Failure, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fear elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fertility elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fetching and Carrying elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Final Rest spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Finding a teacher, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Finger tracing, M208.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fire Resistance elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fire spells, M72.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Fireball spell, M12.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Flight elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Food spells, M77.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Foolishness elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Foresight elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Forgetfulness elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Formulary, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Formulas, alchemical, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Friendship elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Frustration elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Futhark runes, M208, M209.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gadgeteer advantage, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gadgeteer alchemists, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gambling elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gate spells, M80.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gizmo advantage, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Glossary, M5.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>GMing syntactic magic, M204.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Grimoire, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Gullibility elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hardheartedness elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hatred elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Healing elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Healing spells, M88.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Health elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hearing elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Herb Lore skill, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>High skill and cost to maintain, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>“Holy” spells, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Homunculus, M221.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Horsemanship elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hostile elixirs, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Hybridization elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Identifying magic items, M19, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ideogram symbols, M206.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Illusion and Creation spells, M95.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Improvisational magic, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Information spells, M13.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ingredients, magic, M8.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Injury, M7,</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Innate Attack skill, M12.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Instantaneous spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Interruptions, M18.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Inventing new elixirs, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Inventing new spells, M14, M202.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Invisibility elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Invulnerability elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Items, alchemical, M210</name>
<subrule> magic, M16</subrule>
<subrule> multiply enchanted, M18.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Jealousy elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Journeyman enchanters, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Keen Sight elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Knowledge spells, M100.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Laboratories, alchemical, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lasting spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Leadership elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Learning magic, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lecherousness elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lichdom elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Light and Darkness spells, M110.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Lightning spell, M12.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Limits on effect, M9.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Linking syntactic spells, M204.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Long Slumber elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Long-distance modifiers, M14.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Love elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Luck elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Madness elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magery, M5.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic ingredients, M8.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic items, M16</name>
<subrule> buying, M20</subrule>
<subrule> identifying, M19, M212</subrule>
<subrule> selling, M21</subrule>
<subrule> using, M19.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic Resistance elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic resistance, to elixirs, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic rituals, M8.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic staffs, M13.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magic, advantage-based, M201</name>
<subrule> ceremonial, M12, M16</subrule>
<subrule> clerical, M199</subrule>
<subrule> colleges of, M11</subrule>
<subrule> improvisational, M201</subrule>
<subrule> learning, M6</subrule>
<subrule> principles of, M5</subrule>
<subrule> ritual, M200</subrule>
<subrule> symbol, M205</subrule>
<subrule> syntactic, M202</subrule>
<subrule> wildcard, M202.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magical Abilities elixirs, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Magically potent minerals, M222.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Maintaining spells, M9.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Making alchemical items, M210.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Making and Breaking spells, M115.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mana, M5, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Master enchanters, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mature spell, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Medical elixirs, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Melee spells, M11.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Memory elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mental Abilities elixirs, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mental Control elixirs, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Meta-spells, M121.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Mind Control spells, M133.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Minerals, magically potent, M222.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Missile spells, M12.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Monk’s Banquet spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Movement spells, M142.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Multiple words, M203.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Multiply enchanted items, M18.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Music elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Necromantic spells, M149.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Nouns, M202, M206.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Odium elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ogham alphabet, M209.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ointment, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>One try spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Other ritual idioms, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pain Resistance elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Parchment symbol casting, M207.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Pastille, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Perception, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Permanent spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Philosopher’s Stone, M221.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Plant spells, M161.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Player-created spells, M15.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Potion, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Powder, M213.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Power Investiture advantage, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Power of a magic item, M17.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Powerstone costs, M20.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Prerequisite chains, shortening, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Prerequisite count, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Prerequisites, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Principles of magic, M5.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Protection and</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Warning spells, M166.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Quick and dirty enchantment, M17, M20, M22.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Reanimation elixir, M217.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Regeneration elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Regular spells, M11.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Religious Rank advantage, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Renaming spells, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Resisting spells, M13</name>
<subrule> of syntactic spells, M204.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Resurrection elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Retention enhancement, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ritual idioms, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Ritual magic, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Rituals, magic, M8.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sanctity, M199, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Scrolls, M207.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Second-hand enchantments, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Secret spells, M9.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Secrets, alchemical, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Self-Love elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Selling magic items, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sensing mana, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Shortening prerequisite chains, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Skills and Physical Abilities</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Elixirs, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sleep elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Slow and sure enchantment, M18, M20, M22.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Solvent, universal, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Sound spells, M171.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Speed elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spell classes, M11.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spell defaults, M202.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spell descriptions, M22.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spell results of syntactic spells, M204.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spell table, M223.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Spells, M5</name>
<subrule> area, M11</subrule>
<subrule> blocking, M8, M12</subrule>
<subrule> canceling, M10</subrule>
<subrule> casting, M7</subrule>
<subrule> clerical, M199</subrule>
<subrule> dissipating, M14</subrule>
<subrule> duration of, M9</subrule>
<subrule> enchantment, M10, M14</subrule>
<subrule> information, M13</subrule>
<subrule> instantaneous, M10</subrule>
<subrule> inventing, M14</subrule>
<subrule> lasting, M10</subrule>
<subrule> maintaining, M9</subrule>
<subrule> melee, M11</subrule>
<subrule> missile, M12</subrule>
<subrule> one try, M10</subrule>
<subrule> permanent, M10</subrule>
<subrule> player-created, M15</subrule>
<subrule> regular, M11</subrule>
<subrule> resisted, M13</subrule>
<subrule> secret, M9</subrule>
<subrule> temporary, M10.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Staffs, magic, M13.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Stealth elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Strength elixir, M214.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Subject, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Success rolls for enchanting, M17.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Success, M7.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Symbol Drawing skill, M205, M208.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Symbol magic, M205.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Symbol tokens, M208.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Symbolic inscriptions, M207.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Syntactic magic, M202</name>
<subrule> GMing, M204</subrule>
<subrule> linking, M204.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Teacher, M6.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Technological spells, M175.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Temporary spells, M10.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Thaumatology skill, M15, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time and cost to make alchemical charms, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Time to cast spells, M7</name>
<subrule> syntactic spells, M203.</subrule>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Tranquility elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Transform, M204.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Transformation elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>True Sight elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Truth elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Turn Zombie spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Universal Antidote elixir, M218.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Universal solvent, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Unluckiness elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Used enchantments, M21.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Using a symbol-enchanted item, M208.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Using alchemical charms, M220.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Using alchemical items, M212.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Using magic items, M19.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Variations, M199.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Verbs, M202, M206.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Vigil spell, M200.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Water Breathing elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Water spells, M184.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Water-Walking elixir, M216.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weakness elixir, M215.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Weather spells, M193.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Whole-language symbol magic, M206.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wild talents, M201.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wildcard magic, M202.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wisdom elixir, M219.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wizard alchemists, M211.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Wizard characters, M15.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Words of power, M203.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Words, M202.</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
<rule>
<name>Youth elixir, M218,</name>
<categories>
	<category>Magic</category>
	<category>English</category>
</categories>
</rule>
</rule_list>`;
 standaloneLibs['Skills-rus.skl']=`<!--?xml version="1.0" encoding="utf-8" ?-->
<name>Mentor: Skills</name>
<notes>Basic Set 4ed - Умения<br><br><a href="editor.phtml?v=20000000000000000000000000000000" target="_blank">Редактирование библиотеки</a> разрешно, но с предмодерацией</notes><editor-message>Редакторы!<br>
Эта библиотека только для умения и техник из книги Basic Set. <br>
Прошу, не стоит добавлять сюда отсебятину или данные из других книг без предварительного согласования.<br>
Так-же не стоит пресортировывать библиотеку, придерживайтесь алфавитаной сортировки.<br>
Спасибо за ваше участие!<br></editor-message>
<skill_list unique_id="hv8ilous:1xoofs20tgm7f" version="1">
	<skill version="2">
	<name>@Wildcard (IQ)@!</name>
	<name-loc>@Универсальное умение (IQ)@!</name-loc>
	<difficulty>IQ/W</difficulty>
	<points>3</points>
	<categories>
		<category>Wildcard</category>
	</categories>
	<reference>B175</reference>
	<description-loc>Необязательное правило: Универсальные умения
Профессор, изучавший все науки, мечник, способный сражаться любым клинком… фильмы полны героев, знающих понемногу из большого количества умений.
Время, необходимое для записи каждого из умений, и сложность выбора, какие из них брать (и какие использовать), может обескуражить многих игроков, отыгрывающих киношных экспертов. Такой ширины познаний в действительности не существует, но это – важная часть удовольствия, получаемого от киношных игр!
Решением могут стать «Универсальные умения»: включающие чрезвычайно широкий спектр возможность. Названия таких умений заканчиваются восклицательным знаком, чтобы отличить их от других, обычных умений; то есть, «Наука!» - умение о «всех науках». Универсальные умения включают и заменяют все конкретные умения в пределах своей области. Например, герой может сделать бросок Науки! в любом случае, когда необходим бросок против Химии, Физики или других научных умений.
Универсальные умения, включающие преимущественно научные компоненты, основываются на IQ, а зависящие преимущественно от физических действий – на DX. Такие умения не имеют уровня по умолчанию; чтобы их использовать, вы должны потратить очки. Универсальные умения приобретаются как Очень сложные, но обычная стоимость увеличивается втрое. Например, IQ/Очень Сложное умение можно приобрести на уровне IQ всего за 8 очков, но умение Наука! на том же уровне обойдется в 24 очка.
Мастер может ограничить универсальные умения, разрешив их только героям с подходящим Необычным происхождением – возможно, «Киношный герой». Это Необычное происхождение никогда не будет доступно случайным разбойникам и всем подряд! Чтобы придать каждому из героев четкую сюжетную нишу, Мастер может ограничить максимальное количество универсальных умений для каждого героя одним-двумя (преимущественно теми, что подходят под их прошлое).
Несколько примеров:
Детектив! (IQ). Заменяет Криминологию, Обнаружение лжи, Использование электроники (безопасность и шпионаж), Судебная экспертиза, Допрос, Право, Наблюдение, Исследование, Хорошие манеры (полиция), Обыск, Слежка, Знание улиц и т.п.
Пушки! (DX). Заменяет все специализации Лучевого, Тяжелого и Огнестрельного оружия и Распылителей, а также все связанные умения Быстрого выхватывания. Бросок от IQ делается, чтобы ухаживать за этим оружием (Оружейник).
Наука! (IQ). Заменит Астрономию, Биоинженерию, Биологию, Химию, Инженерию, Геологию, Математику, Металлургию, Метеорологию, Натуралиста, Палеонтологию, Физику, Физиологию и др.
Меч! (DX). Заменяет Широкий, Силовой, Короткий, Двуручный и Малый мечи, Саблю, Рапиру, Дагу, Дзитте/сай, Нож, а также все связанные умения Быстрого выхватывания. В моменты выполнения физических трюков во время боя может заменить такие умения, как Акробатику и  Прыжки.
Универсальные умения полезны для всесторонне развитых персонажей. Некоторые могут взять Музыку! и играть на любых музыкальных инструментах, хорошо петь и руководить выступлением. Если он одарен лишь в нескольких инструментах, и может легко изучать другие (но должен их изучать) – это Талант, называемый Музыкальные способности.
		</description-loc>
</skill>
	<skill version="2">
	<name>@Wildcard (DX)@!</name>
	<name-loc>@Универсальное умение (DX)@!</name-loc>
	<difficulty>DX/W</difficulty>
	<points changed="true">3</points>
	<categories>
		<category>Wildcard</category>
	</categories>
	<reference>B175</reference>
	<description-loc>Необязательное правило: Универсальные умения
Профессор, изучавший все науки, мечник, способный сражаться любым клинком… фильмы полны героев, знающих понемногу из большого количества умений.
Время, необходимое для записи каждого из умений, и сложность выбора, какие из них брать (и какие использовать), может обескуражить многих игроков, отыгрывающих киношных экспертов. Такой ширины познаний в действительности не существует, но это – важная часть удовольствия, получаемого от киношных игр!
Решением могут стать «Универсальные умения»: включающие чрезвычайно широкий спектр возможность. Названия таких умений заканчиваются восклицательным знаком, чтобы отличить их от других, обычных умений; то есть, «Наука!» - умение о «всех науках». Универсальные умения включают и заменяют все конкретные умения в пределах своей области. Например, герой может сделать бросок Науки! в любом случае, когда необходим бросок против Химии, Физики или других научных умений.
Универсальные умения, включающие преимущественно научные компоненты, основываются на IQ, а зависящие преимущественно от физических действий – на DX. Такие умения не имеют уровня по умолчанию; чтобы их использовать, вы должны потратить очки. Универсальные умения приобретаются как Очень сложные, но обычная стоимость увеличивается втрое. Например, IQ/Очень Сложное умение можно приобрести на уровне IQ всего за 8 очков, но умение Наука! на том же уровне обойдется в 24 очка.
Мастер может ограничить универсальные умения, разрешив их только героям с подходящим Необычным происхождением – возможно, «Киношный герой». Это Необычное происхождение никогда не будет доступно случайным разбойникам и всем подряд! Чтобы придать каждому из героев четкую сюжетную нишу, Мастер может ограничить максимальное количество универсальных умений для каждого героя одним-двумя (преимущественно теми, что подходят под их прошлое).
Несколько примеров:
Детектив! (IQ). Заменяет Криминологию, Обнаружение лжи, Использование электроники (безопасность и шпионаж), Судебная экспертиза, Допрос, Право, Наблюдение, Исследование, Хорошие манеры (полиция), Обыск, Слежка, Знание улиц и т.п.
Пушки! (DX). Заменяет все специализации Лучевого, Тяжелого и Огнестрельного оружия и Распылителей, а также все связанные умения Быстрого выхватывания. Бросок от IQ делается, чтобы ухаживать за этим оружием (Оружейник).
Наука! (IQ). Заменит Астрономию, Биоинженерию, Биологию, Химию, Инженерию, Геологию, Математику, Металлургию, Метеорологию, Натуралиста, Палеонтологию, Физику, Физиологию и др.
Меч! (DX). Заменяет Широкий, Силовой, Короткий, Двуручный и Малый мечи, Саблю, Рапиру, Дагу, Дзитте/сай, Нож, а также все связанные умения Быстрого выхватывания. В моменты выполнения физических трюков во время боя может заменить такие умения, как Акробатику и  Прыжки.
Универсальные умения полезны для всесторонне развитых персонажей. Некоторые могут взять Музыку! и играть на любых музыкальных инструментах, хорошо петь и руководить выступлением. Если он одарен лишь в нескольких инструментах, и может легко изучать другие (но должен их изучать) – это Талант, называемый Музыкальные способности.
		</description-loc>
</skill>
	<skill version="2">
		<name>Accounting</name>
		<name-loc>Бухгалтерский учет</name-loc>
		<description-loc>Это способности вести бухгалтерские книги, определять состояние бизнеса и т.д. Главным образом она полезна в качестве умения для работы. Успешная проверка Бухучета (требуется приблизительно два часа исследований, но может занять месяцы для крупных корпораций) может сообщить вам, правильны ли бухгалтерские записи – и, возможно, открыть факт подделки, подлога или подобной криминальной активности
Модификаторы: за потраченное время (B346). Таланты Бизнесмен (Business Acumen) и Математические способности (Mathematical Ability) также дают премию (кумулятивную, если имеются оба).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Business</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Finance</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Statistics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Acrobatics</name>
		<name-loc>Акробатика</name-loc>
		<description-loc>Это умение выполнять акробатические или гимнастические трюки, сгибаться, правильно падать и т.д. Для каждого трюка требуется отдельная проверка умения (с подходящими, на взгляд Мастера, штрафами). Это может оказаться полезным в приключении; хождение по канату, создание пирамиды из людей, прыжки на трапеции, - все это может пригодиться.
Проверка умения Акробатика может заменить собой  проверку DX при любой попытке прыгнуть, перевернуться, избежать Сбивания с ног и т.д. Персонаж, пытающийся уклониться, может попробовать выполнить Акробатическое уклонение, прыжок или переворот, который позволяет вам избежать попадания очень эффектным образом (B375). Удачная проверка умения Акробатика также может снизить эффективную высоту падения на 5 ярдов (Падение, B431). 
Мастер имеет право назначить пенальти на свое усмотрение, если он считает какой-то трюк особо сложным.

Существует также две особых версии акробатики:

Акробатика (воздушная) – способность выполнять сложные трюки, петли в полете. Полет необходим, но его природа не имеет значения (псионика, магия, реактивные ранцы и прочее). От природы летающие создания могут чувствовать себя как угодно свободно в полете, но и они должны изучать этот навык, чтобы выполнять сложные трюки. Модификаторы: +2 за Чувство пространства.
Акробатика (водная) – акробатика в водной среде. Требуется уметь плавать или преимущество Амфибия.
Совершенное равновесие дает +1 к любому из этих навыков.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Acting</name>
		<name-loc>Артистизм</name-loc>
		<description-loc>Способность подделывать настроение, эмоции, голоса и убедительно лгать некоторое время. Мастер может потребовать броска навыка когда вы пытаетесь обмануть кого-либо, имитировать смерть в бою и пр.
Подражание (Impersonating) – особый тип Артистизма. Для подражания кому-то вы сначала должны успешно загримироваться – разве что другие вас не видят.
Заметьте, что Артистизм – не то же самое, что Заговаривание зубов (искусство быстрого обмана) или Выступление (навык сценического выступления).
Модификаторы: ±1 за каждое очко разницы IQ вашего и жертвы (или умнейшей жертвы в группе); -3 за Низкую эмпатию, от -1 до -4 за Застенчивость, -5 за Правдивость (только если пытаетесь обмануть). 
Для Подражания: -5, если вы не очень знакомы с субъектом, -5, если те, кого вы обманываете, знакомы с субъектом (-10, если очень хорошо знакомы).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Social</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Performance</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Public Speaking</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Administration</name>
		<name-loc>Администрирование</name-loc>
		<description-loc>Это умение управлять крупной организацией. Оно особенно полезно, чтобы зарабатывать деньги или претендовать на высокий пост. Умелый администратор (умение 15+) также получает бонус +2 к реакции при общении с чиновниками и (при успешной проверке) может понять, как лучше всего иметь дело с бюрократией.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Business</category>
			<category>Social</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Aerobatics</name>
		<name-loc>Аэробатика</name-loc>
		<description-loc>Это умение выполнять акробатические или гимнастические трюки, сгибаться, правильно падать и т.д. Для каждого трюка требуется отдельная проверка умения (с подходящими, на взгляд Мастера, штрафами). Это может оказаться полезным в приключении; хождение по канату, создание пирамиды из людей, прыжки на трапеции, - все это может пригодиться.
Проверка умения Акробатика может заменить собой  проверку DX при любой попытке прыгнуть, перевернуться, избежать Сбивания с ног и т.д. Персонаж, пытающийся уклониться, может попробовать выполнить Акробатическое уклонение, прыжок или переворот, который позволяет вам избежать попадания очень эффектным образом (B375). Удачная проверка умения Акробатика также может снизить эффективную высоту падения на 5 ярдов (Падение, B431). 
Мастер имеет право назначить пенальти на свое усмотрение, если он считает какой-то трюк особо сложным.

Существует также две особых версии акробатики:

Акробатика (воздушная) – способность выполнять сложные трюки, петли в полете. Полет необходим, но его природа не имеет значения (псионика, магия, реактивные ранцы и прочее). От природы летающие создания могут чувствовать себя как угодно свободно в полете, но и они должны изучать этот навык, чтобы выполнять сложные трюки. Модификаторы: +2 за Чувство пространства.
Акробатика (водная) – акробатика в водной среде. Требуется уметь плавать или преимущество Амфибия.
Совершенное равновесие дает +1 к любому из этих навыков.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Airshipman</name>
	<name-loc>Летчик</name-loc>
	<difficulty>IQ/E</difficulty>
	<points>1</points>
	<default>
		<type>IQ</type>
		<modifier>-4</modifier>
	</default>
	<tech_level></tech_level>
	<categories>
		<category>Vehicle</category>
	</categories>
	<reference>B185</reference>
	<description-loc>Это способность работать в команде на борту определенного типа крупного вида транспорта. Включает знакомство с бытом, знание техники безопасности и тренированность предотвращать и ремонтировать повреждения. 
Также позволяет управлять кораблем. Навык легче, чем соответствующий навык управления. Специалисты контролируют такие действия, как прокладку курса и работу с приборами – данные передаются капитану, а он уже принимает решение о маневре и передает экипажу или рулевому. При каждом маневре кидается навык от DX, но эффективный навык не может быть выше навыка капитана.
Средний уровень навыка по экипажу представляет общую тренированность. Мастер кидает его каждый раз в бою, плохих условиях и пр.

Необходима специализация:
Летчик (Airshipman): Навык хранения и использования балласта, газовых вентилей, тросов и пр. на борту крупного воздухоплавательного аппарата. 
Моряк (Seamanship): Навык использования якорей, веревок, парусов и пр. на борту крупного надводного корабля (не подводной лодки). 
Космонавт (Spacer): Навык работы с шлюзами, воздушными пробками, причальными системами и пр. на борту крупного космолета или космической базы. 
Подводник (Submariner): Навык работы с шлюзами, насосами, вентилями и прочим оборудованием на подводной лодке или морской базе.</description-loc>
</skill>
	<skill version="2">
		<name>Alchemy</name>
		<name-loc>Алхимия/ТУ</name-loc>
		<description-loc>Алхимия - это наука магической трансформации и трансмутации. Это механический процесс, использующий магическую составляющую в различных веществах. Таким образом, Алхимию можно изучать без Магических Способностей! И верно, способность к магии не даёт никаких преимуществ при изучении алхимии. Алхимия считается обычной наукой - просто связанной с магией.
Основной задачей алхимиков является создание веществ с магическими свойствами. Основное название для таких веществ - эликсиры. Они подробно описаны в GURPS Magic.
Простая химия
Химия по умолчанию равна Алхимии-3; алхимик это тоже химии, просто специализирующийся в особенном предмете! Значение по умолчанию должно относится только к самым общим знаниям; алхимик, вероятно, не сможет сделать сложный химический анализ, но вполне сможет определить химические вещества по тому, как они выглядят, пахнут и т.д. Средневековые алхимики часто производили анализ, пробуя на вкус - такая процедура в наше время признана не очень умной…</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B174</reference>
		<categories>
			<category>Natural Science</category>
			<category>Occult/Magical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Animal Handling</name>
		<name-loc>Обращение с животными (@Специализация@)</name-loc>
		<description-loc>Это умение характеризует вашу способность дрессировать животных и работать с ними. Вы должны специализироваться на одной из категорий – чем более разумно животное, тем уже его категория. Примеры: Крупные кошачьи (ягуары, львы, тигры), Собачьи, Лошадиные (лошади, ослы), Стервятники (орлы, соколы, ястребы). Специализации по умолчанию относятся друг к другу с -2, если они одного типа (собаки и кошки), -4 за различные (собаки и лошади), и -6 за большие различия (собаки и стервятники).
Чтобы дрессировать животное, персонаж должен делать проверку на успех один раз за каждый день тренировки. Неудачная проверка означает, что животное ничему не научилось, Полностью проваленная проверка означает, что дрессировщик был атакован животным. Время, которое придется потратить на тренировку, обычно зависит от интеллекта животного и его послушания (см. главу 16). 
При работе с дрессированным животным дрессировщик делает проверку своего умения для каждого задания, которое он дает животному. 
Модификаторы: -5, если животное не знакомо с дрессировщиком, -5, если животное находится в стрессовой ситуации, -3 или больше, если задание трудное.
Это умение можно использовать (иногда), чтобы успокоить дикое, опасное и необученное животное. 
Модификаторы: -5 , если животное дикое или очень напуганное. -10 , если это животное-людоед или если оно убивает людей.
И наконец, это умение дает преимущество во время боя с животными. Если ваше  умение 15 или больше, то все проверки атаки и защиты животного против вас получают пенальти -1 , потому что вы можете предугадать его поведение. Если вы эксперт (умение 20 или больше), то проверки животного получают пенальти -2.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Animal Handling</name>
		<name-loc>Обращение с животными (Крупные Кошачьи)</name-loc>
		<description-loc>Это умение характеризует вашу способность дрессировать животных и работать с ними. Вы должны специализироваться на одной из категорий – чем более разумно животное, тем уже его категория. Примеры: Крупные кошачьи (ягуары, львы, тигры), Собачьи, Лошадиные (лошади, ослы), Стервятники (орлы, соколы, ястребы). Специализации по умолчанию относятся друг к другу с -2, если они одного типа (собаки и кошки), -4 за различные (собаки и лошади), и -6 за большие различия (собаки и стервятники).
Чтобы дрессировать животное, персонаж должен делать проверку на успех один раз за каждый день тренировки. Неудачная проверка означает, что животное ничему не научилось, Полностью проваленная проверка означает, что дрессировщик был атакован животным. Время, которое придется потратить на тренировку, обычно зависит от интеллекта животного и его послушания (см. главу 16). 
При работе с дрессированным животным дрессировщик делает проверку своего умения для каждого задания, которое он дает животному. 
Модификаторы: -5, если животное не знакомо с дрессировщиком, -5, если животное находится в стрессовой ситуации, -3 или больше, если задание трудное.
Это умение можно использовать (иногда), чтобы успокоить дикое, опасное и необученное животное. 
Модификаторы: -5 , если животное дикое или очень напуганное. -10 , если это животное-людоед или если оно убивает людей.
И наконец, это умение дает преимущество во время боя с животными. Если ваше  умение 15 или больше, то все проверки атаки и защиты животного против вас получают пенальти -1 , потому что вы можете предугадать его поведение. Если вы эксперт (умение 20 или больше), то проверки животного получают пенальти -2.</description-loc>
		<specialization>Big Cats</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Animal Handling</name>
		<name-loc>Обращение с животными (Собаки)</name-loc>
		<description-loc>Это умение характеризует вашу способность дрессировать животных и работать с ними. Вы должны специализироваться на одной из категорий – чем более разумно животное, тем уже его категория. Примеры: Крупные кошачьи (ягуары, львы, тигры), Собачьи, Лошадиные (лошади, ослы), Стервятники (орлы, соколы, ястребы). Специализации по умолчанию относятся друг к другу с -2, если они одного типа (собаки и кошки), -4 за различные (собаки и лошади), и -6 за большие различия (собаки и стервятники).
Чтобы дрессировать животное, персонаж должен делать проверку на успех один раз за каждый день тренировки. Неудачная проверка означает, что животное ничему не научилось, Полностью проваленная проверка означает, что дрессировщик был атакован животным. Время, которое придется потратить на тренировку, обычно зависит от интеллекта животного и его послушания (см. главу 16). 
При работе с дрессированным животным дрессировщик делает проверку своего умения для каждого задания, которое он дает животному. 
Модификаторы: -5, если животное не знакомо с дрессировщиком, -5, если животное находится в стрессовой ситуации, -3 или больше, если задание трудное.
Это умение можно использовать (иногда), чтобы успокоить дикое, опасное и необученное животное. 
Модификаторы: -5 , если животное дикое или очень напуганное. -10 , если это животное-людоед или если оно убивает людей.
И наконец, это умение дает преимущество во время боя с животными. Если ваше  умение 15 или больше, то все проверки атаки и защиты животного против вас получают пенальти -1 , потому что вы можете предугадать его поведение. Если вы эксперт (умение 20 или больше), то проверки животного получают пенальти -2.</description-loc>
		<specialization>Dogs</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Animal Handling</name>
		<name-loc>Обращение с животными (Лошади)</name-loc>
		<description-loc>Это умение характеризует вашу способность дрессировать животных и работать с ними. Вы должны специализироваться на одной из категорий – чем более разумно животное, тем уже его категория. Примеры: Крупные кошачьи (ягуары, львы, тигры), Собачьи, Лошадиные (лошади, ослы), Стервятники (орлы, соколы, ястребы). Специализации по умолчанию относятся друг к другу с -2, если они одного типа (собаки и кошки), -4 за различные (собаки и лошади), и -6 за большие различия (собаки и стервятники).
Чтобы дрессировать животное, персонаж должен делать проверку на успех один раз за каждый день тренировки. Неудачная проверка означает, что животное ничему не научилось, Полностью проваленная проверка означает, что дрессировщик был атакован животным. Время, которое придется потратить на тренировку, обычно зависит от интеллекта животного и его послушания (см. главу 16). 
При работе с дрессированным животным дрессировщик делает проверку своего умения для каждого задания, которое он дает животному. 
Модификаторы: -5, если животное не знакомо с дрессировщиком, -5, если животное находится в стрессовой ситуации, -3 или больше, если задание трудное.
Это умение можно использовать (иногда), чтобы успокоить дикое, опасное и необученное животное. 
Модификаторы: -5 , если животное дикое или очень напуганное. -10 , если это животное-людоед или если оно убивает людей.
И наконец, это умение дает преимущество во время боя с животными. Если ваше  умение 15 или больше, то все проверки атаки и защиты животного против вас получают пенальти -1 , потому что вы можете предугадать его поведение. Если вы эксперт (умение 20 или больше), то проверки животного получают пенальти -2.</description-loc>
		<specialization>Equines</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Animal Handling</name>
		<name-loc>Обращение с животными (Стервятники)</name-loc>
		<description-loc>Это умение характеризует вашу способность дрессировать животных и работать с ними. Вы должны специализироваться на одной из категорий – чем более разумно животное, тем уже его категория. Примеры: Крупные кошачьи (ягуары, львы, тигры), Собачьи, Лошадиные (лошади, ослы), Стервятники (орлы, соколы, ястребы). Специализации по умолчанию относятся друг к другу с -2, если они одного типа (собаки и кошки), -4 за различные (собаки и лошади), и -6 за большие различия (собаки и стервятники).
Чтобы дрессировать животное, персонаж должен делать проверку на успех один раз за каждый день тренировки. Неудачная проверка означает, что животное ничему не научилось, Полностью проваленная проверка означает, что дрессировщик был атакован животным. Время, которое придется потратить на тренировку, обычно зависит от интеллекта животного и его послушания (см. главу 16). 
При работе с дрессированным животным дрессировщик делает проверку своего умения для каждого задания, которое он дает животному. 
Модификаторы: -5, если животное не знакомо с дрессировщиком, -5, если животное находится в стрессовой ситуации, -3 или больше, если задание трудное.
Это умение можно использовать (иногда), чтобы успокоить дикое, опасное и необученное животное. 
Модификаторы: -5 , если животное дикое или очень напуганное. -10 , если это животное-людоед или если оно убивает людей.
И наконец, это умение дает преимущество во время боя с животными. Если ваше  умение 15 или больше, то все проверки атаки и защиты животного против вас получают пенальти -1 , потому что вы можете предугадать его поведение. Если вы эксперт (умение 20 или больше), то проверки животного получают пенальти -2.</description-loc>
		<specialization>Raptors</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Anthropology</name>
		<name-loc>Антропология (@Специализация@)</name-loc>
		<description-loc>Это наука об эволюции человека и культуры. Антрополог хорошо осведомлен о первобытных (и не только) группах людей (или о других разумных существах, которых он изучает). Проверка Антропологии поможет при попытке объяснить или даже предсказать необычные ритуалы и народные обычаи, с которыми может столкнуться путешественник.
Специализация необходима (если ее нет, то подразумевается, что антрополог специализируется на своем виде). Каждая специализация относится друг к другу с -2 и хуже, но уровень по умолчанию может отсутствовать в случае с совершенно чужеродными друг другу видами.</description-loc>
		<specialization>@Species@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B175</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Paleontology</name>
			<specialization>Paleoanthropology</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Sociology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Aquabatics</name>
	<name-loc>Аквабатика </name-loc>
	<difficulty>DX/H</difficulty>
	<points>1</points>
	<default>
		<type>DX</type>
		<modifier>-6</modifier>
	</default>
	<prereq_list all="no">
		<advantage_prereq has="yes">
			<name compare="is">Amphibious </name>
		</advantage_prereq>
		<skill_prereq has="yes">
			<name compare="is">Swimming</name>
		</skill_prereq>
	</prereq_list>
	<categories>
		<category>Athletic</category>
	</categories>
	<reference>B174</reference>
	<description-loc>Это умение выполнять акробатические или гимнастические трюки, сгибаться, правильно падать и т.д. Для каждого трюка требуется отдельная проверка умения (с подходящими, на взгляд Мастера, штрафами). Это может оказаться полезным в приключении; хождение по канату, создание пирамиды из людей, прыжки на трапеции, - все это может пригодиться.
Проверка умения Акробатика может заменить собой  проверку DX при любой попытке прыгнуть, перевернуться, избежать Сбивания с ног и т.д. Персонаж, пытающийся уклониться, может попробовать выполнить Акробатическое уклонение, прыжок или переворот, который позволяет вам избежать попадания очень эффектным образом (B375). Удачная проверка умения Акробатика также может снизить эффективную высоту падения на 5 ярдов (Падение, B431). 
Мастер имеет право назначить пенальти на свое усмотрение, если он считает какой-то трюк особо сложным.

Существует также две особых версии акробатики:

Акробатика (воздушная) – способность выполнять сложные трюки, петли в полете. Полет необходим, но его природа не имеет значения (псионика, магия, реактивные ранцы и прочее). От природы летающие создания могут чувствовать себя как угодно свободно в полете, но и они должны изучать этот навык, чтобы выполнять сложные трюки. Модификаторы: +2 за Чувство пространства.
Акробатика (водная) – акробатика в водной среде. Требуется уметь плавать или преимущество Амфибия.
Совершенное равновесие дает +1 к любому из этих навыков.</description-loc>
</skill>
	<skill version="2">
		<name>Archaeology</name>
		<name-loc>Археология</name-loc>
		<description-loc>Это наука о древних цивилизациях. Археолог чувствует себя как дома на раскопках, рядом с древними черепками, надписями и т.д. При успешной проверке археолог сможет ответить на вопросы относительно древней истории, идентифицировать находки, мертвые языки и так далее. Иногда археолог обладает информацией, касающейся оккультизма - например это Древние секреты и Вещи, о которых человек не должен знать...</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B176</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Architecture</name>
		<name-loc>Архитектура/ТУ</name-loc>
		<description-loc>Это способность проектировать здания и вычислять проекты зданий, зная об их функциях, и наоборот. Успешная проверка Архитектуры позволит вам узнать что-либо о странном здании, найти секретную комнату или дверь и т.д. 
Модификаторы: -2 для здания странного типа; -5 для инопланетных зданий.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B176</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Civil</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Area Knowledge</name>
		<name-loc>Знание местности (@Специализация@)</name-loc>
		<description-loc>Это умение отражает знакомство с населением, политикой и географией определенной местности. Обычно персонаж обладает Знанием местности только для места, которое он считает своим домом, будь то единственная ферма или Солнечная Система. Если доступна информация и о других регионах, то Мастер может позволить персонажу изучить Знание местности для других мест. Например, шпионы перед отправкой на задание попытаются детально изучить Знание местности для данного региона.
Мастер не должен требовать проверки на Знание местности в обычной ситуации: когда нужно найти кузницу, таверну или собственный дом. Но проверка нужна, чтобы обнаружить кузнеца, который готов подковать вашу лошадь в 3 часа ночи, или найти наилучшее место для засады на дороге. «Тайная» или очень непонятная информация даст пенальти, или же ее вовсе нельзя будет выяснить с помощью Знания местности. Например, Знание местности Вашингтона поможет вам найти российское посольство, но не резидентуру КГБ.
Вещи, которые можно выяснить с помощью Знания местности, частично совпадают с умениями Знание улиц, Навигация, Натуралист, Политика и т.д. Разница в том, что Знание местности работает только в определенном районе; вы знаете о привычках этого бандита или главаря шайки, но это не дает вам знаний обо всех подобных людях.
Знание местности можно приобрести для местности любого размера. Чем больше данная территория, тем меньше «конкретных» и больше общих сведений вы получаете. Почти все персонажи будут обладать Знанием местности одного вида. Вот некоторые примеры (в своей кампании Мастер может добавить и другие):
* Несколько сотен акров: Знание местных фермеров или соплеменников, тропинок, ручьев, убежищ, удобных для засады мест, флоры и фауны.
* Деревня, село или небольшой городок: Все важные жители и дела и почти все маловажные; все общественные здания и большинство домов.
* Город: Все важные вещи, улицы, горожане, лидеры и т.д.
* Баронство, графство, княжество или небольшое государство: Общие сведенья о его городах и поселениях, феодальной структуре, лидерах и большинстве жителей со Статусом 5 и выше.
* Большое государство: Расположение крупнейших городов и важных мест; знакомство с общими обычаями, народами и языками (но не обязательно хорошее их знание); имена людей со Статусом 6+ и общее понимание экономической и политической ситуации.
* Планета: То же, что и для большого государства, но информация более общая; знание людей лишь со Статусом 7+.
* Межпланетное государство: Расположение важнейших планет; знание крупнейших народов (но не обязательно хорошее их знание); знание людей со Статусом 7+; общее понимание экономической и политической ситуации.
Когда дело касается места, удаленного от знакомой вам территории, то Мастер должен назначить пенальти к умению. Например, если вам знаком небольшой городок, то сведения о соседних фермах можно получить с пенальти -1. О ближайшем городе (в миле от вашего) с -2; о крупном городе в 50 милях от вашего с пенальти -5. О столице ближайшего штата или  государства с -7, а о далекой стране с -10.
*Проверка по умолчанию разрешена, только если вы живете или когда-то жили в этой местности. Однако, широта местности различается на разных ТУ, в зависимости от наличия информации. Охотник ТУ 0 будет знаком лишь со своим поселком, а студент ТУ 8 может обладать общими знаниями на планетарном уровне.
В некоторых игровых мирах доступны более специфические виды Знания области (Киберпространство, Мир снов, и пр.).</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B176</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>@Specialty@</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<technique version="2" limit="4">
		<name>Arm Lock</name>
		<name-loc>Выкручивание руки</name-loc>
		<description-loc>Эта техника позволяет вам увеличить эффективность болевых приемов борьбы, применяемых на руки. Правила можно найти в параграфе Выкручивание рук, B403.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Judo</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Arm Lock</name>
		<name-loc>Выкручивание руки</name-loc>
		<description-loc>Эта техника позволяет вам увеличить эффективность болевых приемов борьбы, применяемых на руки. Правила можно найти в параграфе Выкручивание рук, B403.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Wrestling</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (@Тип брони@)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>@Armor type@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Battlesuits</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Мобильный костюм)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Battlesuits</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Battlesuits</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Личная броня)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Body Armor</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Body Armor</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Силовые поля)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Force Shields</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Force Shields</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Тяжелое оружие)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Heavy Weapons</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Heavy Weapons</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Холодное оружие)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Melee Weapons</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Melee Weapons</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Метательное оружие)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Missile Weapons</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Missile Weapons</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Легкое огнестрельное оружие)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Small Arms</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Small Arms</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Armoury</name>
		<name-loc>Оружейник/ТУ (Броня транспорта)</name-loc>
		<description-loc>Это способность делать и ремонтировать оружие и броню соответствующего технического уровня. Навык не предполагает умения проектировать новые виды снаряжения – этим занимаются Инженеры (c.B190). Успешная проверка требуется, чтобы найти поломку оружия (если она не очевидна). Вторая проверка позволяет вам отремонтировать его. Мастер должен определить разумное время для каждой попытки ремонта. 

Необходима специализация по одной из нижеследующих областей:

Мобильные костюмы (Battlesuits): все виды костюмов с энергоисточником, возможно, с наличием встроенного вооружения.

Личная броня (Body Armor): любой вид персональной брони (но не щитов). По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Силовые щиты (Force Shields): любой вид силовых экранов и отражателей – как персональных, так и устанавливаемых на транспорт. Это тоже самое, что и Ремонт электроники (Силовые щиты)

Тяжелое оружие (Heavy Weapon). Любое оружие, использующее навыки Артиллерия и Тяжелое оружие.

Оружие ближнего боя (Melee Weapon). Любое оружие, использующее навыки ближнего боя или метания, а также все виды щитов. По умолчанию: Кузнец (бронза)-3 на ТУ 1, Кузнец (железо) на ТУ 2..4, и Слесарь-3 на ТУ 5+.

Метательное оружие (Missile Weapon). Любое неогнестрельное персональное оружие дальнего боя – луки, арбалеты, пращи и пр.

Небольшое огнестрельное оружие (Small Arms). Любое оружие, используемое с навыками Лучевое и Огнестрельное оружие. По умолчанию Слесарь-5, на ТУ 5+.
Броня транспорта (Vehicular Armor). Любые виды брони транспорта.
Большинство специализаций по молчанию относятся друг к другу с -4, но на ТУ 4+ специализации на броне и на оружии не могут иметь уровня по умолчанию друг к другу. Исключение составляет мобильная броня, которая охватывает все ее системы, включая оружие. Разные ТУ предполагают разные технологии в текущей специализации. Например, Оружейник (небольшое оружие) обеспечивает уход за пистолями на ТУ 4, револьверами на ТУ 6 и лучевым оружием на ТУ 10.
Модификаторы: -2 за незнакомый предмет в пределах вашей специальности (латы, если вы привыкли делать кольчуги), модификаторы за наличие снаряжения (с.345).</description-loc>
		<specialization>Vehicular Armor</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Vehicular Armor</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (@Тип оружия@)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>@Weapon type@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Лучевая)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Beams</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Бомбы )</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Bombs</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Пушки)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Cannon</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Катапульты)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Catapult</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Управляемые ракеты)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Guided Missile</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artillery</name>
		<name-loc>Артиллерия/ТУ (Торпеды)</name-loc>
		<description-loc>Способность использовать тяжелое оружие наподобие требушета или катапульты, стреляющее по навесной траектории (для стрельбы прямой наводкой используется Тяжелое оружие). Специализация необходима.

Для ускорения перезарядки заряжающие могут бросать навык, основанный на ST. 

Лучевое оружие (Beams): непрямая наводка (наведение с орбиты, с использованием зеркал); 

Бомбы (Bombs) (любые снаряды свободного падения); 

Пушки (Cannon) (любые тяжелые орудия – минометы, корабельные орудия); 

Катапульты (Catapult) (осадные механизмы); 

Управляемые ракеты (Guided Missile): любой вид самонаводящихся или пилотируемых ракет.
Торпеды (Torpedoes) (подводные снаряды с собственным двигателем). 
Между специализациями нет зависимости по умолчанию. Все они считаются одним навыком лишь потому, что стрельба из них подчиняется одним и тем же правилам. Используемое навыком оружие различается на разных ТУ: Пушки на ТУ 3 – примитивные бомбарды, а на ТУ 9 – орбитальные рельсовые орудия.
Знакомство с каждым из видов орудий критически важно: -2 за разницу в калибре (155-мм и 203-мм), -2 за тип контроля огня (указание координат по карте, если вы обычно используете спутниковую навигацию) -2 за базирование (морское, орбитальное, наземное…). Модификаторы кумулятивны. -4 и больше, если оружие в плохом состоянии.
Для точной наводки может потребоваться навык Наблюдатель (c.B196).</description-loc>
		<specialization>Torpedoes</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B178</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (@Тип@)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>@Art@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Боди-арт)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Body Art</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Calligraphy</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Drawing</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Illumination</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Painting</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Каллиграфия)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Calligraphy</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Drawing</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Illumination</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Painting</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Body Art</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Рисование)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Drawing</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Calligraphy</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Illumination</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Painting</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Body Art</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Освещение)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Illumination</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Calligraphy</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Drawing</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Painting</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Body Art</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Иллюзионизм)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Illusion</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Дизайн интерьера)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Interior Decorating</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Architecture</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Scene Design</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Woodworking</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Живопись)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Painting</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Calligraphy</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Drawing</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Illumination</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Body Art</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artsit</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Гончар)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Pottery</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Дизайн сцен)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Scene Design</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Architecture</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Interior Decorating</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Woodworking</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Скульптура)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Sculpting</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Artist</name>
		<name-loc>Изобразительное искусство (Работа по дереву)</name-loc>
		<description-loc>Определяет таланты в визуальном искусстве. Удачная проверка этого умения позволит вам, создать узнаваемый портрет кого-либо, карту, по которой будет легко идти, или предмет искусства, который можно будет продать (для последнего Мастер не должен позволять бросок по умолчанию). 
Броски обычно основаны на IQ, однако, нередки случаи бросков, основанных на DX (если хорошо развитая тонкая моторика рук может помочь, с использованием модификаторов за уменьшенную или увеличенную ловкость рук), или даже ST (в случае работы с тяжелым материалом). 

Требуется специализация:

Боди-арт (Body-art): татуировки, пирсинг, скарификация. Косметическая хирургия не входит в этот навык.

Вышивка: искусство декоративного шитья.

Гончар (Pottery): работа с керамикой, обычно – глиной.

Гравер: аккуратная и красивая гравировка на различных материалах

Дизайн интерьера (Interior Decorating) создание приятного, уместного интерьера. (По умолчанию: Архитектор-3)

Дизайн сцен (Scene Design): создание хороших подходящих декораций.

Живопись (Painting): все формы – на холсте или стенах, маслом, темперой и пр.

Иллюзионизм (Illusion): создание впечатляющих и правдоподобных иллюзий. Требуется иметь способности к созданию иллюзий (магические или пси).

Каллиграфия (Calligraphy): красивое декоративное письмо. Грамотным быть не обязательно.

Ковродел: создание красивых ковров.

Работа по дереву: все формы резьбы и декоративной обработки дерева. (По умолчанию – плотник-3).

Рисование (Drawing): все формы работы углем, карандашом, чернилами…

Украшение текста (Illuminating): украшение текста миниатюрными рисунками;
Скульптура (Sculpting): создание трехмерных предметов искусства из гипса, дерева, камня и прочих материалов. 
Возможна необязательная специализация внутри одного рода искусств – по определенным техникам работы. Некоторые из специализаций людьми называются ремеслом, а не искусством – от вас зависит, будете ли вы концентрировать свое внимание на красоте, реализме или функциональности.
Каллиграфия, Рисование, Украшение и Живопись друг к другу относятся с -2, к Боди-арту с -4; Интерьер, Сцены и Работа по дереву друг к другу с -4. Все остальные специализации относятся друг к другу с -6.
Модификаторы: -2 за незнакомость с материалом, -5 за сложности. Модификаторы за оборудование (B345)</description-loc>
		<specialization>Woodworking</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Carpentry</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Interior Decorating</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<specialization>Scene Design</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Astronomy</name>
		<name-loc>Астрономия/ТУ</name-loc>
		<description-loc>
Это наука о звездах и других космических объектах. Астроном может ответить на вопросы, касающиеся Солнца, планет Солнечной системы, метеоритов и так далее. Любитель, который не выполняет вычислений, но знаком со звездами, имеет необязательную специализацию Наблюдение. Эта специализация не требует математических знаний.
При Техническом Уровне 4 или ниже это умение называется Астрологией, которая объединяет знания о звездах и созвездиях с большим количеством мифов и гаданий.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Autohypnosis</name>
		<name-loc>Самогипноз</name-loc>
		<description-loc>Позволяет подключать резервы внутренней силы, входя в трансоподобное состояние. Вхождение в транс требует периода концентрации в течение (20-навык) секунд, минимум 1 секунды. Вы не можете двигаться и разговаривать в это время. При успешном броске навыка вы можете сделать одно из следующих действий:
Улучшение концентрации: вы получаете +2 на определенную длительную ментальную работу (написание программы или взлом шифра), но -2 на все остальные броски IQ, Восприятия(Per) и навыков. Задача должна быть относительно спокойной и выполняться в тихом месте (библиотека, лаборатория, монастырь и пр).
Увеличение воли. Вы получаете +2 к Воле(Will) (+5 на критическом успехе) на один час. Этот бросок делается с -2.
Игнорирование боли/усталости: уменьшение негативных эффектов уменьшения ваших хитов или FP ниже 1/3 обычных (но не сами усталость и раны). Бросок делается с -4, и позволена только одна попытка в час.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Meditation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Axe/Mace</name>
		<name-loc>Топор/булава</name-loc>
		<description-loc>Короткие или средней длины одноручные виды рубящего оружия (топоры, топорики, дубины, кирки). По умолчанию: цеп-4.
Такое оружие не может парировать, если вы им уже атаковали в этот ход. Навыки в этой категории относятся друг к другу с -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
		<parry after-attack="no">0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Axe/Mace</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Flail</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Back Kick</name>
		<name-loc>Удар назад</name-loc>
		<description-loc>Эта техника позволяет вам атаковать противника позади вас, не поворачиваясь к нему лицом. Вы должны знать, что он там есть! Для попадания по противнику делается бросок Удара назад, но во всех остальных отношениях используются правила по ударам ногой.
После удара назад, все броски вашей активной защиты до следующего хода получают -2.
</description-loc>
		<difficulty>H</difficulty>
		<points>2</points>
		<reference>B230, MA67</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">Karate</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<skill version="2">
		<name>Bartender</name>
		<name-loc>Бармен</name-loc>
		<description-loc>Это умение содержать профессиональный бар, а также знание, как готовить различные коктейли.
Профессиональный бармен также знает, как общаться с посетителями в дружественной манере - а также должен уметь успокоить сильно выпивших людей до того, как они начнут все крушить. При высоком уровне это умение начинает сближаться с выступлением, бармен может сделать из своей рутинной работы настоящее шоу - например, смешивать коктейли, выполняя трюки и показные движения, и преподносить свои новые напитки красиво и необычно.
И, наконец, бармен будет знать законы, связанные с алкоголем и его потреблением, а также сумеет вычислить, кому и сколько надо наливать, чтобы тот не отравился.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Professional</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Carousing</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Battlesuit</name>
		<name-loc>Боевой скафандр/ТУ</name-loc>
		<description-loc>Это тренировка в использовании определенных защитных костюмов. Костюмы, созданные для защиты владельца от опасностей боя или окружающей среды часто имеют встроенные устройства (типа автошприцов и сенсоров) и приборы для поддержки жизнедеятельности. Некоторые костюмы даже содержат сервоприводы для увеличения ST и скорости. В результате вы не просто носите этот костюм – вы управляете им. Навык позволяет быстро одеть и снять скафандр (успешный бросок – половина времени). Для активации определенной суб-системы костюма или работы в костюме хорошем состоянии кидается бросок по IQ. В то время, когда на вас надет костюм, любой из бросков DX и навыков, на DX основанных вы кидаете против низшего значения из Скафандра и того навыка. Например, если у вас DX 14, Скрытность 15 и Скафандр 13 – вы работаете, как с DX 13 и Скрытностью 13, пока не снимете скафандр. Особенно неудобные и громоздкие костюмы будут давать штрафы к DX независимо от уровня навыка, а тонкие, высокотехнологичные костюмы могут вообще не давать штрафов.

Однако, навык работы в скафандре сильно зависит от привычки к нему. Знакомство и знания опасных ситуаций, входящих в такие навыки как Свободное падение, Опасные материалы, Выживание и прочие подобные навыки покупаются отдельно для каждого типа костюма.

Боевой костюм (Battlesuit): Все типы боевой брони и экзоскелетов со встроенным источником энергии. Боевая броня и Экзоскелеты – похожи, но не одинаковы, и считаются как за знакомство.

Водолазный костюм (Diving Suit). Все виды жестких водолазных костюмов (гибкие открытые и закрытые включены в навык Акваланг). Включает открытый костюм на ТУ 5, Жесткий шлем на ТУ 6, которые используют герметичный шлем и подачу воздуха – но не всегда полностью закрытый костюм. На ТУ 7 доступен настоящий, полноценный водолазный скафандр. Мастер может потребовать броска Плавания для маневрирования в этом костюме. (По умолчанию: Акваланг -2).

Защитный костюм (NBC Suit): Все виды снаряжения (включая не имеющие собственного питания), созданные для защиты от опасностей окружающей среды и рабоыт с опасными материалам. Без этого навыка вы постоянно рискуете в чем-то ошибиться и получить вред. 
Скафандр (Vacc Suit): Любой тип космического скафандра – включая специальные костюмы для работы в атмосферах с высоким давлением, кислотностью или ядами.
По умолчанию все виды костюмов относятся друг к другу с -2, кроме водолазного – с -4.
Негерметичные или не оборудованные энергопитанием костюмы никогда не требуют броска этого навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Technical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Beam Weapons</name>
		<name-loc>Лучевое Оружие/ТУ (@Класс оружия@)</name-loc>
		<description-loc>Это умение использовать лучевое оружие, включая бластеры, лазеры, станнеры и т.д. Требуется специализация

Пистолеты (Pistol): небольшое оружие, стреляющее лучами;

Проекторы (Projector): энергетическое оружие с конусообразным излучением
Винтовки (Rifle): длинноствольное лучевое оружие.
Разные типы лучей (лазер, бластер, станнер и пр.) считаются как знакомства. Похожие друг на друга виды лучевого и огнестрельного оружия также относятся друг к другу с -4.</description-loc>
		<specialization>@Weapon class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Beam Weapons</name>
		<name-loc>Лучевое Оружие/ТУ (Пистолеты)</name-loc>
		<description-loc>Это умение использовать лучевое оружие, включая бластеры, лазеры, станнеры и т.д. Требуется специализация

Пистолеты (Pistol): небольшое оружие, стреляющее лучами;

Проекторы (Projector): энергетическое оружие с конусообразным излучением
Винтовки (Rifle): длинноствольное лучевое оружие.
Разные типы лучей (лазер, бластер, станнер и пр.) считаются как знакомства. Похожие друг на друга виды лучевого и огнестрельного оружия также относятся друг к другу с -4.</description-loc>
		<specialization>Pistol</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Beam Weapons</name>
		<name-loc>Лучевое Оружие/ТУ (Веерные)</name-loc>
		<description-loc>Это умение использовать лучевое оружие, включая бластеры, лазеры, станнеры и т.д. Требуется специализация

Пистолеты (Pistol): небольшое оружие, стреляющее лучами;

Проекторы (Projector): энергетическое оружие с конусообразным излучением
Винтовки (Rifle): длинноствольное лучевое оружие.
Разные типы лучей (лазер, бластер, станнер и пр.) считаются как знакомства. Похожие друг на друга виды лучевого и огнестрельного оружия также относятся друг к другу с -4.</description-loc>
		<specialization>Projector</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Beam Weapons</name>
		<name-loc>Лучевое Оружие/ТУ (Винтовки)</name-loc>
		<description-loc>Это умение использовать лучевое оружие, включая бластеры, лазеры, станнеры и т.д. Требуется специализация

Пистолеты (Pistol): небольшое оружие, стреляющее лучами;

Проекторы (Projector): энергетическое оружие с конусообразным излучением
Винтовки (Rifle): длинноствольное лучевое оружие.
Разные типы лучей (лазер, бластер, станнер и пр.) считаются как знакомства. Похожие друг на друга виды лучевого и огнестрельного оружия также относятся друг к другу с -4.</description-loc>
		<specialization>Rifle</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B179</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bicycling</name>
		<name-loc>Велосипед</name-loc>
		<description-loc>Способность ездить на велосипеде на дальние дистанции, с высокой скоростью и т.д. Бросок, основанный на IQ, представляет ваши знания о поломках и ремонте велосипедов.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Athletic</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Motorcycle</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bioengineering</name>
		<name-loc>Биоинженерия/ТУ (@Специализация@)</name-loc>
		<description-loc>Способность разрабатывать живые организмы с заданными характеристиками, или создавать продукты биотехнологии. Необходима специализация:
Клонирование (Cloning): создание и выращивание клонов
Генная инженерия (Genetic Engineering): Модификация генома.
Органная инженерия (Tissue Engineering): Создание органов и тканей.
Специализации относятся друг к другу по умолчанию с -4.</description-loc>
		<specialization>@Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Bioengineering</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bioengineering</name>
		<name-loc>Биоинженерия/ТУ (Клонирование)</name-loc>
		<description-loc>Способность разрабатывать живые организмы с заданными характеристиками, или создавать продукты биотехнологии. Необходима специализация:
Клонирование (Cloning): создание и выращивание клонов
Генная инженерия (Genetic Engineering): Модификация генома.
Органная инженерия (Tissue Engineering): Создание органов и тканей.
Специализации относятся друг к другу по умолчанию с -4.</description-loc>
		<specialization>Cloning</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Bioengineering</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bioengineering</name>
		<name-loc>Биоинженерия/ТУ (Генная инженерия)</name-loc>
		<description-loc>Способность разрабатывать живые организмы с заданными характеристиками, или создавать продукты биотехнологии. Необходима специализация:
Клонирование (Cloning): создание и выращивание клонов
Генная инженерия (Genetic Engineering): Модификация генома.
Органная инженерия (Tissue Engineering): Создание органов и тканей.
Специализации относятся друг к другу по умолчанию с -4.</description-loc>
		<specialization>Genetic Engineering</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Bioengineering</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bioengineering</name>
		<name-loc>Биоинженерия/ТУ (Органная инженерия)</name-loc>
		<description-loc>Способность разрабатывать живые организмы с заданными характеристиками, или создавать продукты биотехнологии. Необходима специализация:
Клонирование (Cloning): создание и выращивание клонов
Генная инженерия (Genetic Engineering): Модификация генома.
Органная инженерия (Tissue Engineering): Создание органов и тканей.
Специализации относятся друг к другу по умолчанию с -4.</description-loc>
		<specialization>Tissue Engineering</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Bioengineering</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (@Специализация@)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>@Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Биохимия)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Biochemistry</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Ботаника)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Botany</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Землеподобные планеты)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Earthlike</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Экология)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Ecology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Газовые гиганты)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Gas Giants</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Генетика)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Genetics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Агрессивные миры)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Hostile Terrestrial</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Леядные карлики)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Ice Dwarfs</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Ледяные планеты)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Ice Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Морская биология)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Marine Biology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Микробиология)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Microbiology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Скалистые планеты)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Rock Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Biology</name>
		<name-loc>Биология/ТУ (Зоология)</name-loc>
		<description-loc>Наука о структуре, привычках и обитании живых организмов. Вы должны специализироваться на жизни определенного типа планет. Если вы не указываете тип планет, подразумевается специализация на типе вашей родной планеты. Бросок по умолчанию позволен только по тому типу планет, на котором вы выросли. Различные специализации зависят друг от друга с -4.
На ТУ 6+ большинство биологов берут также необязательную специализацию по типам живых организмов. Наиболее обычные типы – Биохимия (наука о химических реакциях в организме), Ботаника (наука о растениях), Экология (наука о окружающей среде), Генетика (учение о наследовании и генах), Морская биология (изучает подводную жизнь), Микробиология (наука о микроскопических организмах) и Зоология (Наука о животных), но доступны и другие виды специализации.</description-loc>
		<specialization>Zoology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Blind Fighting</name>
		<name-loc>Бой вслепую</name-loc>
		<description-loc>
Вы изучили тайны боя в полной темноте. В результате, вы можете чувствовать вашу цель, не видя ее.
Навык позволяет использовать другие чувства, кроме зрения – в основном слух, но зачастую и осязание и даже обоняние – для точного определения местонахождения врага. Успешный бросок навыка позволяет одну ближнюю атаку или защиту без любых штрафов за освещение, слепоту и невидимость врага (но с дополнительным штрафом -2, если вы пытаетесь ударить в определенную точку цели). Если вам также известен навык Дзен-лучник, вы можете стрелять по невидимым вам целям с -6 к обоим навыкам.
Оппоненты, которым известно о вашей способности, могут попытаться обмануть ее, победив в быстром состязании Скрытности-4 против Боя вслепую, каждый ход. В случае успеха вы не можете определить местонахождение врага. Однако, Искусство невидимости абсолютно бесполезно против этого навыка.
Модификаторы: штраф за фоновый шум: -1 за дождь, -2 ливень или буря, -3 – тяжелая техника или толпа, -4 за полный стадион, -5 среди канонады. Если вы не можете слышать вообще, то бросок навыка делается с -7. Премия, равная уровню Обостренного слуха. Также вы получаете премию за высшее значение из Таланта к телепатии или Таланта к экстрасенсорике.</description-loc>
		<difficulty>Per/VH</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="starts with">weapon master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Blowpipe</name>
		<name-loc>Духовая трубка</name-loc>
		<description-loc>Это умение стрелять из духовой трубки маленькими (обычно отравленными) стрелами. Такая стрела не может пробить обычную одежду, если не случится критический успех, и никогда не пробивает набивную или более прочную броню. Если дротик попадает в незащищенную или защищенную только легкой одеждой кожу, то яд может начать действовать. 
Также навык может использоваться для выдувания порошка в цели в радиусе 1 метра. Это считается атакой ближней, а не дальней, и делается с +2.
Модификаторы: -2 и больше при наличии ветра, если стрельба происходит на улице.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boating</name>
		<name-loc>Малые корабли/ТУ (@Класс судна@)</name-loc>
		<description-loc>Способность управлять определенным типом небольших судов. Большие суда с многочисленным экипажем используют навыки Член экипажа (моряк) (c.B185) и Кораблевождение (c.B220)

Бросок необходим для спуска на воду и при каждой опасности. При использовании по умолчанию вы также кидаете при первой посадке в лодку – чтобы не упасть. Необходима специализация.

Крупные моторные лодки (Large Powerboat): Лодки с закрытой кабиной и двигателем. По умолчанию: Моторные лодки-2, Парусные лодки-2, Гребля-4. Кораблевождение-4. 
Моторные лодки (Motorboat): любые моторные лодки, особенно катера и любые небольшие судна с двигателем на борту. По умолчанию: Парусные лодки-3, Крупные моторные лодки-2, Гребля-3.

Парусные лодки (Sailboat): все небольшие судна с парусом. По умолчанию: Крупные моторные лодки-4, Моторные лодки-3, Гребля-3.
Гребля (Unpowered): любые судна, приводимые в движение мускульной силой. По умолчанию: Крупные моторные лодки-4, Парусные или моторные лодки -3.
Модификаторы: -2, если лодка незнакомого типа; неспокойная погода и неблагоприятные навигационные условия дают пенальти -3 или больше.</description-loc>
		<specialization>@Boat class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Motorboat</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Sailboat</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Unpowered</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Seamanship</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boating</name>
		<name-loc>Малые корабли/ТУ (Крупные моторные лодки)</name-loc>
		<description-loc>Способность управлять определенным типом небольших судов. Большие суда с многочисленным экипажем используют навыки Член экипажа (моряк) (c.B185) и Кораблевождение (c.B220)

Бросок необходим для спуска на воду и при каждой опасности. При использовании по умолчанию вы также кидаете при первой посадке в лодку – чтобы не упасть. Необходима специализация.

Крупные моторные лодки (Large Powerboat): Лодки с закрытой кабиной и двигателем. По умолчанию: Моторные лодки-2, Парусные лодки-2, Гребля-4. Кораблевождение-4. 
Моторные лодки (Motorboat): любые моторные лодки, особенно катера и любые небольшие судна с двигателем на борту. По умолчанию: Парусные лодки-3, Крупные моторные лодки-2, Гребля-3.

Парусные лодки (Sailboat): все небольшие судна с парусом. По умолчанию: Крупные моторные лодки-4, Моторные лодки-3, Гребля-3.
Гребля (Unpowered): любые судна, приводимые в движение мускульной силой. По умолчанию: Крупные моторные лодки-4, Парусные или моторные лодки -3.
Модификаторы: -2, если лодка незнакомого типа; неспокойная погода и неблагоприятные навигационные условия дают пенальти -3 или больше.</description-loc>
		<specialization>Large Powerboat</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Motorboat</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Sailboat</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Unpowered</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Seamanship</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boating</name>
		<name-loc>Малые корабли/ТУ (Моторные лодки)</name-loc>
		<description-loc>Способность управлять определенным типом небольших судов. Большие суда с многочисленным экипажем используют навыки Член экипажа (моряк) (c.B185) и Кораблевождение (c.B220)

Бросок необходим для спуска на воду и при каждой опасности. При использовании по умолчанию вы также кидаете при первой посадке в лодку – чтобы не упасть. Необходима специализация.

Крупные моторные лодки (Large Powerboat): Лодки с закрытой кабиной и двигателем. По умолчанию: Моторные лодки-2, Парусные лодки-2, Гребля-4. Кораблевождение-4. 
Моторные лодки (Motorboat): любые моторные лодки, особенно катера и любые небольшие судна с двигателем на борту. По умолчанию: Парусные лодки-3, Крупные моторные лодки-2, Гребля-3.

Парусные лодки (Sailboat): все небольшие судна с парусом. По умолчанию: Крупные моторные лодки-4, Моторные лодки-3, Гребля-3.
Гребля (Unpowered): любые судна, приводимые в движение мускульной силой. По умолчанию: Крупные моторные лодки-4, Парусные или моторные лодки -3.
Модификаторы: -2, если лодка незнакомого типа; неспокойная погода и неблагоприятные навигационные условия дают пенальти -3 или больше.</description-loc>
		<specialization>Motorboat</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Large Powerboat</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Sailboat</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Unpowered</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boating</name>
		<name-loc>Малые корабли/ТУ (Парусные лодки)</name-loc>
		<description-loc>Способность управлять определенным типом небольших судов. Большие суда с многочисленным экипажем используют навыки Член экипажа (моряк) (c.B185) и Кораблевождение (c.B220)

Бросок необходим для спуска на воду и при каждой опасности. При использовании по умолчанию вы также кидаете при первой посадке в лодку – чтобы не упасть. Необходима специализация.

Крупные моторные лодки (Large Powerboat): Лодки с закрытой кабиной и двигателем. По умолчанию: Моторные лодки-2, Парусные лодки-2, Гребля-4. Кораблевождение-4. 
Моторные лодки (Motorboat): любые моторные лодки, особенно катера и любые небольшие судна с двигателем на борту. По умолчанию: Парусные лодки-3, Крупные моторные лодки-2, Гребля-3.

Парусные лодки (Sailboat): все небольшие судна с парусом. По умолчанию: Крупные моторные лодки-4, Моторные лодки-3, Гребля-3.
Гребля (Unpowered): любые судна, приводимые в движение мускульной силой. По умолчанию: Крупные моторные лодки-4, Парусные или моторные лодки -3.
Модификаторы: -2, если лодка незнакомого типа; неспокойная погода и неблагоприятные навигационные условия дают пенальти -3 или больше.</description-loc>
		<specialization>Sailboat</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Large Powerboat</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Motorboat</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Unpowered</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boating</name>
		<name-loc>Малые корабли/ТУ (Гребные)</name-loc>
		<description-loc>Способность управлять определенным типом небольших судов. Большие суда с многочисленным экипажем используют навыки Член экипажа (моряк) (c.B185) и Кораблевождение (c.B220)

Бросок необходим для спуска на воду и при каждой опасности. При использовании по умолчанию вы также кидаете при первой посадке в лодку – чтобы не упасть. Необходима специализация.

Крупные моторные лодки (Large Powerboat): Лодки с закрытой кабиной и двигателем. По умолчанию: Моторные лодки-2, Парусные лодки-2, Гребля-4. Кораблевождение-4. 
Моторные лодки (Motorboat): любые моторные лодки, особенно катера и любые небольшие судна с двигателем на борту. По умолчанию: Парусные лодки-3, Крупные моторные лодки-2, Гребля-3.

Парусные лодки (Sailboat): все небольшие судна с парусом. По умолчанию: Крупные моторные лодки-4, Моторные лодки-3, Гребля-3.
Гребля (Unpowered): любые судна, приводимые в движение мускульной силой. По умолчанию: Крупные моторные лодки-4, Парусные или моторные лодки -3.
Модификаторы: -2, если лодка незнакомого типа; неспокойная погода и неблагоприятные навигационные условия дают пенальти -3 или больше.</description-loc>
		<specialization>Unpowered</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B180</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Large Powerboat</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Motorboat</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Sailboat</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Body Control</name>
		<name-loc>Контроль тела</name-loc>
		<description-loc>
Эта способность позволяет контролировать непроизвольные функции тела, такие, как сердцебиение, кровоток и пищеварение. Одним из способов использования этого навыка является возможность входить в смертеподобный транс, во время которого только победа в состязании Диагностики против навыка Контроля тела позволит определить, что вы живы. Это требует (30-навык) секунд концентрации (минимум 1 секунда). Также вы можете использовать навык для выведения яда из тела. Для этого сначала надо определить яд броском навыка Яды (или Алхимия, Фармакология и т.д., если это подходит). Вы не можете делать такого броска до того, как узнаете, что вы отравлены – в большинстве случаев, до появления первых симптомов. Успешный бросок Контроля тела – модифицированный любыми доступными модификаторами HT для сопротивления ядам – выводит яд за 1d часов, после чего вы не получаете никаких дальнейших повреждений.
Наконец, вы можете использовать высшее из значений этого навыка и HT для сопротивления любому Воздействию, заклинанию и пси-атаке, которой обычно сопротивляются по HT.</description-loc>
		<difficulty>HT/VH</difficulty>
		<points>1</points>
		<reference>B181</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">meditation</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">breath control</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
	<name>Body Language</name>
	<name-loc>Язык тела</name-loc>
	<difficulty>Per/A</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Detect Lies</name>
		<modifier>-4</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Psychology</name>
		<modifier>-4</modifier>
	</default>
	<categories>
		<category>Police</category>
		<category>Social</category>
		<category>Spy</category>
	</categories>
	<reference>B181</reference>
	<description-loc>Это способность интерпретировать выражение лица персоны и ее движения, для предугадывания ее чувств. Вы можете использовать вместо преимущества Эмпатия или навыка Обнаружение лжи, но только если можете видеть субъекта. Также вы можете использовать эту способность для получения примерных представлений о действиях члена группы в ситуациях, когда вы не можете общаться напрямую. Вы можете наблюдать только за одним субъектом одновременно. 
Способность читать движения тела в бою – обычная часть любого боевого навыка. см. Финт (B365).
Модификаторы: все модификаторы зрения, физиологии. +4, если субъект имеет недостаток Легко Понять. Все, что затрудняет определение движений: тяжелая или свободная одежда -1, щит или плащ – от -2 до -4; маска - -5!</description-loc>
</skill>
	<skill version="2">
		<name>Body Sense</name>
		<name-loc>Чувство тела</name-loc>
		<description-loc>Это способность быстро прийти в себя после телепортации или любого подобного магического или телепатического "мгновенного перемещения". Успешная проверка показывает, что вы можете нормально действовать со следующего хода. Провал означает, что вы дезориентированы - никакие действия кроме защиты в первый ход невозможны. Критический провал означает, что вы упали оглушенным.
Модификаторы: +3 за Чувство Направления; -2, если вас развернуло, с -5, если перевернуло с ног на голову и т.д. Обратите внимание, что вы не можете изменять физическое расположение во время телепортации - только ориентацию в пространстве.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B181</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Acrobatics</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Bolas</name>
		<name-loc>Болас</name-loc>
		<description-loc>Болас - это метательное оружие, представляющее собой два или более грузов, соединенных между собой веревкой, предназначенное для обездвиживания противника. См. правила по Бола в параграфе Особое метательное оружие, B410.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B181</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Bow</name>
		<name-loc>Лук</name-loc>
		<description-loc>Это умение пользоваться длинным или коротким луком и всеми подобными типами луков. Оно также включает в себя умение пользоваться разными сложносоставными луками, но человек, незнакомый с новым типом луков. Получает штраф за знакомство (-2).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Boxing</name>
		<name-loc>Бокс</name-loc>
		<description-loc>Хотя на западе его и не считают боевым искусством, бокс - это научная техника рукопашного боя. В плане точности и изящества бокс находится где-то посередине между дракой и каратэ. Для ударов ногой подобного бонуса нет. Действительно, Бокс не учит драться ногами.
Если вы тренированы в боксе на уровне DX+1, ваше базовое повреждение кулаком увеличивается на +1 на кубик. Если ваш навык бокса DX+2 или выше, увеличьте повреждение на 2 за кубик.

Когда вы защищаетесь голыми руками, бокс позволяет вам парировать две разных атаки в ход, по одной каждой рукой. Ваш навык парирования – (Навык/2) +3. Маневр отступления дает +3 к броску парирования. Вы получаете -2 при парировании ударов ногами, и -3 на парирование оружия с другим типом атаки, нежели колющим (thrusting).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<weapon_bonus>
			<name compare="is">Boxing</name>
			<specialization compare="is anything"></specialization>
			<level compare="at least">1</level>
			<amount per_level="yes">1</amount>
		</weapon_bonus>
		<weapon_bonus>
			<name compare="is">Boxing</name>
			<specialization compare="is anything"></specialization>
			<level compare="at least">2</level>
			<amount per_level="yes">1</amount>
		</weapon_bonus>
	</skill>
	<skill version="2">
		<name>Brain Hacking</name>
		<name-loc>Взлом сознания/ТУ</name-loc>
		<description-loc> 
См. ниже, Промывка сознания.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Brainwashing</name>
		<name-loc>Промывка сознания/ТУ</name-loc>
		<description-loc> 
Темное искусство технологического контроля разума и изменения личности. Учат этому только в разведке, армии и службах безопасности – и только тех, кто имеет подходящий уровень доступа к секретной информации, но даже тогда этот навык редок в мирное время.
Взлом сознания охватывает множество типов техник – иногда доказательных, иногда – немногим лучше колдовства. В зависимости от мира, они могут включать химию, электрошок, гипноз, сенсорный голод, лишение сна, социальное давление, и даже хирургические вмешательства.
Независимо от применяемой техники, взлом сознания представлен Обычным Состязанием (не быстрым!) между навыком взлома против Воли(Will) жертвы. Бросок делается один раз в день. В такой ситуации у хакера огромные преимущества. Даже если жертва  выигрывает состязание умений, это означает только оттяжку неизбежного. Жертва никак не может повредить хакеру или что-то узнать. Вообще, жертва находится в незавидном положении. Взлом - вопрос времени.
Результат зависит от того, насколько Мастер позволит взлому быть эффективным. Взлом может привести к изменению психики, внушению или свести с ума. В сеттингах с нейро-интерфейсом, Мастер может позволить взлом сознания через компьютер – попытка занимает всего долю секунды! Взлом сознания должен считаться отдельным навыком той же сложности, но пререквизитом к нему выступает не Психология, а Компьютерный взлом.
Обычно этот навык не имеет значения по умолчанию. Однако, Мастер может позволить их, если используются определененные навыки: Использование электроники (медицина) -6, Гипноз -6, Допрос -6, Фармакология -6, Психология -6, или Хирургия -6.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<categories>
			<category>Military</category>
			<category>Spy</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">psychology</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Brawling</name>
		<name-loc>Драка</name-loc>
		<description-loc>Это непрофессиональное умение драться кулаками и ногами (а если у вас есть природное оружие – то и им тоже). Чтобы попасть в цель кулаком, делайте бросок Драки, ногой – Драки-2. Также навык может заменить любой бросок DX для атаки зубами, рогами и иным природным оружием. Если вы имеете навык Драки на уровне DX+2, вы увеличиваете базовый вред от ударов телом на +1 за кубик.
Драка включает навык сражения с использованием коротких дубинок (+1 к вреду).
Когда вы защищаетесь голыми руками, вы можете сделать две попытки парирования – по одной каждой рукой. Навык парирования составляет (Навык/2)+3. Парирование неколющего оружия делается с -3.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<weapon_bonus>
			<name compare="is">Brawling</name>
			<specialization compare="is anything"></specialization>
			<level compare="at least">2</level>
			<amount per_level="yes">1</amount>
		</weapon_bonus>
	</skill>
	<skill version="2">
		<name>Breaking Blow</name>
		<name-loc>Сокрушительный удар</name-loc>
		<description-loc>
Позволяет вам бить голыми руками по слабейшим точкам предметов. После успешного попадания делается бросок навыка. Каждое использование стоит 1 FP, независимо от того, попали вы в цель или нет. При успехе, вы получаете на эту атаку Делитель брони (5) против любой неодушевленной однородной цели, и она считается как Хрупкая (Brittle) (B136). В киношной кампании вы можете атаковать таким образом не только неживые цели – но также броню и силовые щиты (не природную броню), а однородные (Homogenous) враги считаются хрупкими. При провале броска ваша атака не получает никаких особых выгод. При критическом провале вы повреждаете свою руку или ногу.
Модификаторы: -10 за мгновенное использование, -5 за 1 ход концентрации, -4 – два хода, -3 – четыре хода, -2 восемь ходов, -1 после шестнадцати ходов, без штрафов за 32 хода концентрации. Если цель сделана из дерева или пластика -1, из камня или кирпича -3, из металла или современных композитных материалов -5.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Breath Control</name>
		<name-loc>Управление дыханием</name-loc>
		<description-loc>Это умение дышать максимально эффективно. Удачная проверка умения позволит вам на 50% увеличить время задержки дыхания (например под водой). Удачная проверка умения также позволит восстанавливать очко усталости каждые две минуты (это не относится к применению магических заклинаний, которые восстанавливают FP).
Это умение  обычно неизвестно за пределами восточных культур; Мастер может сделать данное умение доступным в мире будущего.</description-loc>
		<difficulty>HT/H</difficulty>
		<points>1</points>
		<reference>B182</reference>
		<categories>
			<category>Athletic</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Broadsword</name>
		<name-loc>Палаш</name-loc>
		<description-loc>Любой сбалансированный клинок длиной 2-4 фута, удерживаемый в одной руке: средний меч, кавалерийская сабля, скимитар и пр. Также используется для применения сбалансированных дубин и палок подобного размера, и кроме того, для катан, полуторных мечей и длинных мечей во время использования одной рукой. По умолчанию: силовой меч-4, Рапира-4, Сабля-4, Короткий меч-2, двуручный меч-4.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
		<parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Camouflage</name>
		<name-loc>Маскировка</name-loc>
		<description-loc>Это способность использовать натуральные вещества и/или краски для того, чтобы замаскировать себя, свою позицию, снаряжение и т.д. Чтобы определить, удачной ли оказалась маскировка, проводится Состязание умений (Зрение против Маскировки). В зависимости от обстоятельств, успешная маскировка может скрыть предмет полностью или сделать его очертания более размытыми, из-за чего по нему сложнее попасть (-1 к умению атакующего). Маскировка не улучшит ваше умение Скрытность, но если вы хорошо замаскировались, то противник может не заметить вас, даже если вы провалите проверку на Скрытность. Базовое умение позволяют замаскироваться самому: чем больший предмет вы пытаетесь закамуфлировать, тем больше пенальти к умению. 
Модификаторы: Модификаторы за снаряжение. Штраф, равный SM крупного объекта. При поиске с большого расстояния наблюдатель получает штрафы за зрение (см. Зрение, с.358).</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Military</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Captivate</name>
		<name-loc>Очарование</name-loc>
		<description-loc>
В фентези барды часто имеют способность влиять на других, рассказывая им истории. Мастер может представить эту способность в виде нескольких родственных навыков. В зависимости от сеттинга, этот навык может быть магическим, псионическим или просто формой гипноза. Каждый навык имеет свое время использования и действия, а также цену усталости. См B191
Этот навык позволяет вам рассказывать историю настолько впечатляюще, что все слушающие теряют волю и делают все, что вы хотите. По сути, они верят, что сами были героями этой истории, и уязвимы к манипулированию вами. В случае успеха в быстром состязании, аудитория становится полностью верной вам – они подчиняются любым вашим приказам, а в их отсутствие – действуют в ваших интересах, как они их понимают. Если ваш приказ очень опасен или противоречит «кодексу поведения» жертвы, она получает повторный бросок Воли(Will)-5, чтобы освободиться.
Затраты времени: 30 минут непрерывного рассказа.
Цена: 8 FP, независимо от успеха.
Продолжительность: пока субъект не упадет без сознания, не заснет, не будет атакован вами, или не потеряет половины НР от вреда, или пока вы не заснете или не потеряете сознание.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B191</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">suggest</name>
				<specialization compare="is"></specialization>
				<level compare="at least">12</level>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">public speaking</name>
				<specialization compare="is"></specialization>
				<level compare="at least">12</level>
			</skill_prereq>
			<advantage_prereq has="yes">
				<name compare="is">charisma</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Carousing</name>
		<name-loc>Пирушки</name-loc>
		<description-loc>Это умение общаться, участвовать в вечеринках и т.д. Успешная проверка умения, сделанная в подходящих обстоятельствах, даст вам бонус +2 при попытке добиться помощи или информации либо просто к общей реакции. Проваленная проверка означает, что вы каким-либо образом опростоволосились; вы получаете пенальти –2 от любого, с кем вы выпивали. Если вы пытаетесь применить данное умение в неподходящем месте, то проваленная проверка может привести и к другим опасностям! 
Модификаторы: по решению Мастера, до +3 за оплату выпивки или иных развлечений для своего товарища по пирушке. -3 за Безрадостность, -1..-4 за Застенчивость и т.д.</description-loc>
		<difficulty>HT/E</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Social</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Carpentry</name>
		<name-loc>Плотник</name-loc>
		<description-loc>Это способность делать предметы из дерева. Успешная проверка позволит вам профессионально выполнять работу по дереву в течение одного часа. Неудавшаяся проверка означает, что работа плоха. Мастер может потребовать броска от DX, в случае особенно тонкой работы.
Модификаторы: +5, если вас контролирует или помогает кто-то с умением 15 или выше; модификаторы за снаряжение.</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cartography</name>
		<name-loc>Картография/ТУ</name-loc>
		<description-loc>Это умение создавать и читать карты и схемы. При TL7+ умение включает в себя знание компьютерных технологий создания карт и знание технологий создания карт, основываясь на информации, полученной с сенсоров.
Персонажи, которые хотят нанести на карту территорию, через которую проходят, должны сделать проверку умения, чтобы установить, точной ли получилась карта.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Surveying</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Chemistry</name>
		<name-loc>Химия/ТУ</name-loc>
		<description-loc>Это наука о веществах. Химик сможет идентифицировать химические элементы и простые вещества (но не обязательно лекарства, волшебные зелья и т.д.). Располагая необходимым оборудованием, он сможет анализировать и синтезировать сложные вещества.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Alchemy</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Choke Hold</name>
		<name-loc>Удушение</name-loc>
		<description-loc>Эта техника позволяет уменьшить базовый штраф -2 к Дзюдо или -3 к Борьбе при использвании болевых и удушающих приемов на горло (B404).
</description-loc>
		<difficulty>H</difficulty>
		<points>2</points>
		<reference>B230, MA69</reference>
		<default>
			<type>Skill</type>
			<name>Judo</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">Judo</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<technique version="2" limit="0">
		<name>Choke Hold</name>
		<name-loc>Удушение</name-loc>
		<description-loc>Эта техника позволяет уменьшить базовый штраф -2 к Дзюдо или -3 к Борьбе при использвании болевых и удушающих приемов на горло (B404).
</description-loc>
		<difficulty>H</difficulty>
		<points>2</points>
		<reference>B230, MA69</reference>
		<default>
			<type>Skill</type>
			<name>Wrestling</name>
			<modifier>-3</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">Wrestling</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<skill version="2">
		<name>Climbing</name>
		<name-loc>Лазание</name-loc>
		<description-loc>Это умение лазать по горам, каменным стенам, деревьям, зданиям и т.д. 
Модификаторы: +3/+5, если у вас есть преимущество Гибкость; вычтите из умения уровень нагрузки. +2 за Цепкость (c.B41), +1 за Совершенное равновесие (c.B74).</description-loc>
		<encumbrance_penalty_multiplier>1</encumbrance_penalty_multiplier>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B183</reference>
		<categories>
			<category>Athletic</category>
			<category>Criminal/Street</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cloak</name>
		<name-loc>Плащ</name-loc>
		<description-loc>Навык использования плаща или накидки в качестве оружия. Существует два типа плащей: легкий (менее 5 фунтов весом) и тяжелый (5+ фунтов).
Атакуя, вы можете запутать врага, или кинуть плащ в лицо, закрывая ему обзор – все это считается за финт (см. правила Особые виды оружия ближнего боя, B402).
В защите плащ может использоваться как щит – DB равен +1 для легкого плаща, +2 для тяжелого, и дает защиту блокированием (Навык/2)+3. однако, плащ не настолько же прочен, как щит. Легкий плащ имеет DR 1 и 3 НР, тяжелый 5 НР.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<block>0</block>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Net</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shield</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Art</name>
		<name-loc>Художественное единоборство (@Умение Средние@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Average Skill@</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Average Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Sport</name>
			<specialization>@Average Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Art</name>
		<name-loc>Художественное единоборство (@Умение Легкое@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Easy Skill@</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Easy Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Sport</name>
			<specialization>@Easy Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Art</name>
		<name-loc>Художественное единоборство (@Умение Сложное@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Hard Skill@</specialization>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Hard Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Sport</name>
			<specialization>@Hard Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Sport</name>
		<name-loc>Художественное или спортивное единоборство (@Умение Средние@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Average Skill@</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Average Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Art</name>
			<specialization>@Average Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Sport</name>
		<name-loc>Художественное или спортивное единоборство (@Умение Легкое@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Easy Skill@</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Easy Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Art</name>
			<specialization>@Easy Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Combat Sport</name>
		<name-loc>Художественное или спортивное единоборство (@Умение Сложное@)</name-loc>
		<description-loc>Вы можете выбрать изучение большинства боевых навыков в несмертельном виде, с упором на зрелищность (боевые искусства) или Мастерство (боевой спорт).
Боевые искусства подчеркивают красоту движений и совершенство стоек. Поскольку эти навыки все равно дают уровни по умолчанию к полноценному смертельному владению оружием, это логичный выбор для пацифистов, желающих иметь боевые навыки.
Навыки в боевом спорте упирают в скорость движений и нелетальных атак. Проваленный бросок навыка может значить для вас дисквалификацию. Вы можете сделать бросок навыка, основанный на IQ, чтобы вспомнить основные турнирные правила, но чтобы стать квалифицированным судьей или рефери, необходимо изучение соответствующего вида Игр.
Боевые искусства и спорт основываются на DX, с тем же уровнем сложности и базовыми значениями по умолчанию, что и соответствующие боевые навыки. Боевой навык, и его показательная и спортивная формы относятся друг к другу по умолчанию с -3.</description-loc>
		<specialization>@Hard Skill@</specialization>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>@Hard Skill@</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Combat Art</name>
			<specialization>@Hard Skill@</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Computer Hacking</name>
		<name-loc>Компьютерный взлом/ТУ</name-loc>
		<description-loc>Навык получения нелегального доступа к компьютерной системе – обычно с использованием другого компьютера через сеть. Успешный бросок позволит вам получить доступ к закрытым данным или всем функциям взломанной системы. В случае критического провала вы не только не получаете доступа, но и оставляете следы взлома.
Этот навык очень киношный, и симулирует процесс взлома компьютерных систем, встречающийся во многих кинофильмах. Он не должен существовать в реалистичных сеттингах! Реалистичные хакеры должны использовать комбинацию из Использования компьютера (использование программ для взлома), Программирования (для их написания), Криптографии, Использования электроники (связь или системы безопасности), Ремонта электроники (компьютеры), Заговаривания зубов (для выпытывания паролей у пользователей), Исследования (для поиска необходимой для взлома информации в книгах), Собирания (для нахождения обрывков информации даже в мусоре).
Модификаторы: за снаряжение; от -1 до -10, если вы не знакомы с последними новостями из мира компьютерной безопасности (штраф зависит от того, насколько сильно вы отстали). Меры защиты также дают штрафы: от -1 за самую дешевую коммерческую систему до -15 за новейшую профессиональную систему обороны, грамотно настроенную профессионалами. Некоторые из систем могут сопротивляться попыткам взлома – для их обхода используется быстрое состязание по Взлому против эффективного навыка защиты.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">computer programming</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Computer Operation</name>
		<name-loc>Использование компьютера/ТУ</name-loc>
		<description-loc>Это способность пользоваться компьютером, вызывать данные, пользоваться соответствующими программами, играть в видеоигры и т.д. Это не то же самое, что программирование – оно является отдельным, более сложным умением. 
Это умение доступно только при существовании компьютеров в данном игровом мире. Персонажи из других миров не могут пользоваться этим умением по умолчанию, если у них не было времени, чтобы познакомится с компьютерами! В мирах, где возможно подключение компьютера к мозгу, навык также включает умение использовать нейро-интерфейс (незнакомые с ним получают сначала -4).
Модификаторы: -2 или больше за незнакомый компьютер или незнакомую программу.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Everyman</category>
			<category>Scholarly</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Computer Programming</name>
		<name-loc>Программирование/ТУ</name-loc>
		<description-loc>
Это способность писать и отлаживать программное обеспечение. Успешная проверка позволит (помимо прочих вещей) найти ошибку в программе; определить ее назначение по распечатке программного кода; ответить на вопрос, касающийся компьютеров или программирования; или при наличии достаточного времени написать новую программу. Необходимое время может существенно различаться! 
В мирах, где существует искусственный интеллект, для работы с ним требуется специализация (ИИ). При использовании социальных навыков, используется меньшее из значений ИИ и соответствующего навыка.
Искусственный интеллект (ИИ). Отражает знание новейших разработок в сфере создания искусственного интеллекта и умение тренировать обучаемые машины. Чтобы обучать ИИ в какой-то сфере, умение учителя в данной области должно быть выше, чем у машины. Он может работать с экспертом в выбранной сфере, но умение ИИ в этой сфере никогда не превысит умение учителя больше чем на 2 уровня и никогда не превысит умение научного сотрудника.
Модификаторы: за потраченное время; незнакомый язык программирования (см. Знакомство). Написание программы для определенной специализированной области требует броска по низшему из навыков Программирования и соответствующего навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Computer Programming</name>
		<name-loc>Программирование/ТУ (Искусственный интеллект)</name-loc>
		<description-loc>
Это способность писать и отлаживать программное обеспечение. Успешная проверка позволит (помимо прочих вещей) найти ошибку в программе; определить ее назначение по распечатке программного кода; ответить на вопрос, касающийся компьютеров или программирования; или при наличии достаточного времени написать новую программу. Необходимое время может существенно различаться! 
В мирах, где существует искусственный интеллект, для работы с ним требуется специализация (ИИ). При использовании социальных навыков, используется меньшее из значений ИИ и соответствующего навыка.
Искусственный интеллект (ИИ). Отражает знание новейших разработок в сфере создания искусственного интеллекта и умение тренировать обучаемые машины. Чтобы обучать ИИ в какой-то сфере, умение учителя в данной области должно быть выше, чем у машины. Он может работать с экспертом в выбранной сфере, но умение ИИ в этой сфере никогда не превысит умение учителя больше чем на 2 уровня и никогда не превысит умение научного сотрудника.
Модификаторы: за потраченное время; незнакомый язык программирования (см. Знакомство). Написание программы для определенной специализированной области требует броска по низшему из навыков Программирования и соответствующего навыка.</description-loc>
		<specialization>AI</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B184</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (@Предмет@)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>@Subject@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (Танцы)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>Dance</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (Литература)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>Literature</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Literature</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Poetry</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Writing</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (Музыка)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>Music</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Group Performance</name>
			<specialization>Conducting</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Musical Composition</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Musical Instrument</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (Изобразительное искусство)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>Visual Arts</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Connoisseur</name>
		<name-loc>Знаток (Вина)</name-loc>
		<description-loc>Навык отражает образованное понимание искусства и предметов. Это очень важный навык для людей искусства, критиков, воров и всех, кто хочет казаться культурным. Успешный бросок позволит определить, что подумает критик о предмете искусства, сколько это может стоить на рынке (+1 к навыку Торговли, когда продаешь это), или произвести впечатление (+1 на бросок реакции или Хороших манер). 
Вы должны специализироваться: Танцы, Литература (по умолчанию – Литература, Поэзия или Письмо -3), Музыка (По умолчанию: Дирижер, Композитор или Музыкальный инструмент -3), Изобразительное искусство, Вина. Каждая специальность по умолчанию относится к другим с -3. 
Модификаторы: знакомство с культурой (c.B23), -3 за Безрадостность (c.B140).</description-loc>
		<specialization>Wine</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cooking</name>
		<name-loc>Повар</name-loc>
		<description-loc>(Это навык шеф-повара, вы не должны сами все делать, и он не нужен для приготовления простых продуктов.)
Это способность готовить вкусную пищу из продуктов (не просто из воды и консервов). Возможна необязательная специализация по категории блюд (выпечка, напитки и пр.) или народности (китайская или французкая кухня).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Housekeeping</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cooking</name>
		<name-loc>Повар (@Специализация@)</name-loc>
		<description-loc>(Это навык шеф-повара, вы не должны сами все делать, и он не нужен для приготовления простых продуктов.)
Это способность готовить вкусную пищу из продуктов (не просто из воды и консервов). Возможна необязательная специализация по категории блюд (выпечка, напитки и пр.) или народности (китайская или французкая кухня).</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Housekeeping</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cooking</name>
		<name-loc>Повар (Выпечка)</name-loc>
		<description-loc>(Это навык шеф-повара, вы не должны сами все делать, и он не нужен для приготовления простых продуктов.)
Это способность готовить вкусную пищу из продуктов (не просто из воды и консервов). Возможна необязательная специализация по категории блюд (выпечка, напитки и пр.) или народности (китайская или французкая кухня).</description-loc>
		<specialization>Baking</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Housekeeping</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cooking</name>
		<name-loc>Повар (Изготовление напитков)</name-loc>
		<description-loc>(Это навык шеф-повара, вы не должны сами все делать, и он не нужен для приготовления простых продуктов.)
Это способность готовить вкусную пищу из продуктов (не просто из воды и консервов). Возможна необязательная специализация по категории блюд (выпечка, напитки и пр.) или народности (китайская или французкая кухня).</description-loc>
		<specialization>Beverage Making</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Housekeeping</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Counterfeiting</name>
		<name-loc>Фальшивомонетчик/ТУ</name-loc>
		<description-loc>Искусство подделки банкнот и монет. Доступно только криминальному миру и правительственным агентствам. Необходимое время варьируется от нескольких дней до недель (на усмотрение Мастера). Мастер тайно кидает навык при создании каждой партии денег. Вы не можете подделывать деньги, если у вас нет образца.
Критический успех означает, что вы создали подделку, которую не отличить от настоящих денег.
Обычных успех – работа хороша, но не идеальна. Когда вы пытаетесь использовать эти деньги, Мастер опять делает бросок, с теми же модификаторами. Провал будет означать, что проверяющий заметил неладное. Если деньги проверяются специально, требуется быстрое состязание Фальшивомонетчика против Восприятия(Per), Торговли или Судебной экспертизы.
Любой провал начального броска значит, что подделку распознает первый же увидевший монету. Критический провал будет значить немного другое: получивший подделку – скрытый полицейский, или вооруженный и злой горожанин и т.д.
Модификаторы: за оборудование. Если у вас есть материалы, которые используются при изготовлении настоящих денег, вы получаете от +1 (за несколько рулонов бумаги) до +10 (печатный пресс)</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Criminal/Street</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Forgery</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Criminology</name>
		<name-loc>Криминология/ТУ</name-loc>
		<description-loc>Это наука о преступлениях и мышлении преступников. Используя свое умение, криминалист сможет найти необходимые улики, выдвинуть предположение насчет действий преступников и т.д. Хотя это умение и не зависит по умолчанию от Знания улиц, Мастер может в определенных ситуациях позволить вместо него проверку Знания улиц – особенно если нужно предсказать действия преступника или перехитрить его.
Модификаторы: -3 за Нечувствительность (c.B142).</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Police</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Psychology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Crossbow</name>
		<name-loc>Арбалет</name-loc>
		<description-loc>Умение использовать различные Арбалеты, включая шаро- и камнестрельные арбалеты. Если вы владеете этим умением, то понимаете, как использовать осадные орудия арбалетного типа, но не имеете опыта в стрельбе из них.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cryptography</name>
		<name-loc>Криптография/ТУ</name-loc>
		<description-loc>Это умение позволяет кодировать и расшифровывать информацию, включает в себя использование различных систем шифрования, кодов и шифров. Навык широко используется в военное время, для шпионажа и даже в бизнесе. Включает в себя знание всех доступных систем шифрования – от простого замещения до сложных устройств. Знание конкретного шифра зависит от вашего уровня доступа и привилегий. В большинстве миров, для изучения этого навыка доступ к секретным материалам необходим. 
Расшифровка незнакомого кода – состязание по навыкам Криптографии шифровальщика и дешифровщика. Повторные попытки возможны, но каждая попытка занимает целый день. Шифровальщик кидает только один раз – при создании кода.
Делая проверку с -2, шифровальщик может изобрести код, который будет выглядеть как обычный разговор, не привлекая таким образом ненужного внимания.
Возможна специализация на создании или дешифровке (специализация дешифровщика часто называется Криптоанализ).
Любой человек может сделать или расшифровать банальный код или шифр, сделав проверку значения IQ-5. 
Шифровальщик может затратить больше времени, и получить лучший код (сверяйтесь с таблицей Размеров, Скоростей и Расстояний – в столбце Расстояний замените «ярд» на «день» - и используйте соответствующий бонус).
Модификаторы. Доступ к компьютеру: Домашний компьютер +1, миникомпьютер +2, мейнфрейм +3..+4 и суперкомпьютер +5. Пользователь должен быть опытен в умении Программирование или Использование Компьютера, уровень одного из которых должен быть 15+. Также необходима определенное программное обеспечение.
Наличие примера кода с расшифровкой дает +5. Если сообщение, которое необходимо расшифровать, короче 25 слов, то проверка получает -5. Любой человек, обладающий Математическими Способностями, может добавить их уровень к проверкам Криптоанализа.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Military</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Cryptology</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cryptography</name>
		<name-loc>Криптография/ТУ (Зашифровка)</name-loc>
		<description-loc>Это умение позволяет кодировать и расшифровывать информацию, включает в себя использование различных систем шифрования, кодов и шифров. Навык широко используется в военное время, для шпионажа и даже в бизнесе. Включает в себя знание всех доступных систем шифрования – от простого замещения до сложных устройств. Знание конкретного шифра зависит от вашего уровня доступа и привилегий. В большинстве миров, для изучения этого навыка доступ к секретным материалам необходим. 
Расшифровка незнакомого кода – состязание по навыкам Криптографии шифровальщика и дешифровщика. Повторные попытки возможны, но каждая попытка занимает целый день. Шифровальщик кидает только один раз – при создании кода.
Делая проверку с -2, шифровальщик может изобрести код, который будет выглядеть как обычный разговор, не привлекая таким образом ненужного внимания.
Возможна специализация на создании или дешифровке (специализация дешифровщика часто называется Криптоанализ).
Любой человек может сделать или расшифровать банальный код или шифр, сделав проверку значения IQ-5. 
Шифровальщик может затратить больше времени, и получить лучший код (сверяйтесь с таблицей Размеров, Скоростей и Расстояний – в столбце Расстояний замените «ярд» на «день» - и используйте соответствующий бонус).
Модификаторы. Доступ к компьютеру: Домашний компьютер +1, миникомпьютер +2, мейнфрейм +3..+4 и суперкомпьютер +5. Пользователь должен быть опытен в умении Программирование или Использование Компьютера, уровень одного из которых должен быть 15+. Также необходима определенное программное обеспечение.
Наличие примера кода с расшифровкой дает +5. Если сообщение, которое необходимо расшифровать, короче 25 слов, то проверка получает -5. Любой человек, обладающий Математическими Способностями, может добавить их уровень к проверкам Криптоанализа.</description-loc>
		<specialization>Code Design</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Military</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Cryptology</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Cryptography</name>
		<name-loc>Криптография/ТУ (Расшифровка)</name-loc>
		<description-loc>Это умение позволяет кодировать и расшифровывать информацию, включает в себя использование различных систем шифрования, кодов и шифров. Навык широко используется в военное время, для шпионажа и даже в бизнесе. Включает в себя знание всех доступных систем шифрования – от простого замещения до сложных устройств. Знание конкретного шифра зависит от вашего уровня доступа и привилегий. В большинстве миров, для изучения этого навыка доступ к секретным материалам необходим. 
Расшифровка незнакомого кода – состязание по навыкам Криптографии шифровальщика и дешифровщика. Повторные попытки возможны, но каждая попытка занимает целый день. Шифровальщик кидает только один раз – при создании кода.
Делая проверку с -2, шифровальщик может изобрести код, который будет выглядеть как обычный разговор, не привлекая таким образом ненужного внимания.
Возможна специализация на создании или дешифровке (специализация дешифровщика часто называется Криптоанализ).
Любой человек может сделать или расшифровать банальный код или шифр, сделав проверку значения IQ-5. 
Шифровальщик может затратить больше времени, и получить лучший код (сверяйтесь с таблицей Размеров, Скоростей и Расстояний – в столбце Расстояний замените «ярд» на «день» - и используйте соответствующий бонус).
Модификаторы. Доступ к компьютеру: Домашний компьютер +1, миникомпьютер +2, мейнфрейм +3..+4 и суперкомпьютер +5. Пользователь должен быть опытен в умении Программирование или Использование Компьютера, уровень одного из которых должен быть 15+. Также необходима определенное программное обеспечение.
Наличие примера кода с расшифровкой дает +5. Если сообщение, которое необходимо расшифровать, короче 25 слов, то проверка получает -5. Любой человек, обладающий Математическими Способностями, может добавить их уровень к проверкам Криптоанализа.</description-loc>
		<specialization>Cryptanalysis</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Military</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Cryptology</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (@Предмет@)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>@Subject@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Business</category>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Бизнес)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Business</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Business</category>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Главные новости)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Headline News</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Культура)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>High Culture</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Люди)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>People</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Политика)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Politics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Поп-культура)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Popular Culture</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Региональные)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Regional</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Наука и технологии)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Science &amp; Technology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Спорт)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Sports</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Current Affairs</name>
		<name-loc>Свежие новости/ТУ (Путешествия)</name-loc>
		<description-loc>Это способность быстро собирать и анализировать все, что в вашем мире определяется как новости, и вспоминать их при необходимости. Необходима специализация по области:
Бизнес (Business). Курсы обмена, эффективность капиталовложений.
Главные новости (Headline News). Обычно плохие – эпидемии, войны, убийства.
Культура (Culture). Галереи, оперы, симфонии и пр.
Люди (People). Имена и слухи о знаменитостях, руководстве и пр.
Политика (Politics). Международное отношение, результаты голосований.
Поп-культура (Popular Culture). Хиты, мода, новинки.
Региональные (Regional). Новости всех типов в одном регионе.
Наука и технологии (Science &amp; Technology). Новые разработки и изобретения.
Спорт (Sports). Результаты матчей, знаменитости.
Путешествия (Travel). Модные туристические маршруты, цены.
Специализации зависят друг от друга с -4. 
На успешном броске, Мастер сообщает вам любую новость в пределах вашей специализации, которая относится к текущему приключению (возможно с подсказками), или даст небольшой бонус к навыку.
Модификаторы: -1 за день давности. -3, если у вас есть только один источник. +1 и больше, за особый доступ.</description-loc>
		<specialization>Travel</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B186</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Research</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Current Affairs</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Dancing</name>
		<name-loc>Танцы</name-loc>
		<description-loc>Это умение танцевать так, как принято в вашей культуре и быстро обучаться новым танцам. Обратите внимание, что некоторые физические данные могут помешать вам. Экзотические виды танцев: танцы с мечами, танцы с быками, танцы с огнем, танцы со змеями. Мастер может определить их как отдельные DX/A навыки, с отношением по умолчанию с -5.
Модификаторы: -5, если танец вам неизвестен. После того, как вы удачно станцевали танец 3 раза, он становиться вам известен. Некоторые физические недостатки могут сделать это умение невозможным! Применяются также модификаторы за знакомство с культурой (B23).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B187</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Detect Lies</name>
		<name-loc>Определение лжи</name-loc>
		<description-loc>Это способность сказать, врет вам кто-либо или нет. Это не то же самое, что Допрашивание; Определение лжи используется от случая к случаю или при общении. Когда вы заявляете об использовании данного умения, то Мастер проводит Быстрое состязание умений между вашим Определением лжи и IQ оппонента (либо его Заговариванием зубов, либо Артистизмом). Если вы выигрываете, Мастер скажет, лгал ли вам собеседник. Если вы проиграли, то Мастер может обмануть вас насчет того, лгали вам или нет... или просто сказать «Ты не можешь сказать точно».
Модификаторы: +4, если у вас есть преимущество Эмпатия. Если лжец принадлежит к другому виду, то Мастер может назначить пенальти (обычно -2), разве что вы очень хорошо знакомы с этим видом! +4 за Легко понимаемого (B134) соперника, -3 за Нечувствительность.</description-loc>
		<difficulty>Per/H</difficulty>
		<points>1</points>
		<reference>B187</reference>
		<categories>
			<category>Police</category>
			<category>Social</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Body Language</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Psychology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Diagnosis</name>
		<name-loc>Диагностика/ТУ</name-loc>
		<description-loc>Это умение понять, что случилось с больным или раненым, а также установить причину смерти погибшего или умершего человека. Удачная проверка умения даст некоторую информацию о проблеме пациента – реалистично ограниченную знаниями для Технического уровня персонажа. Не обязательно обнаружится точная проблема (к примеру, Мастер может решить, что причина болезни выходит за пределы знаний врача), но умение всегда будет давать какие-то подсказки, помогать выйти из тупиковой ситуации и т.д. Заметьте, что Диагностика не нужна для таких очевидных вещей, как открытые ранения или оторванные конечности.
Модификаторы: -5 при повреждении внутренних органов; -5 для редких болезней; модификаторы за снаряжение и знание физиологии.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B187</reference>
		<categories>
			<category>Medical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>First Aid</name>
			<modifier>-8</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Veterinary</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Diplomacy</name>
		<name-loc>Дипломатия</name-loc>
		<description-loc>Это умение вести переговоры, достигать компромиссов и ладить с другими. Проверка на Дипломатию может заменить любой бросок на реакцию в небоевой ситуации (см. броски влияния, с.359). 
В отличие от других умений, также предназначенных чтобы оказывать влияние, Дипломатия никогда не приведет результату, худшему, чем был бы при обычном броске на реакцию. Проваленная проверка Заговаривания зубов или Сексапильности разозлит человека, а применение Дипломатии всегда безопасно.
Успешная проверка позволит вам предсказать возможный исход определенного способа ведения переговоров или выбрать наилучший подход. Если ваше умение Дипломатия находится на уровне эксперта (20 или выше), то вы получаете бонус +2 ко всем броскам на реакцию! 
Модификатор: +2, если у вас есть преимущество Голос (с.97). -3 за Нечувствительность (c.B141), -2 Заикание (c.B157), -1..-4 Застенчивость (c.B154), -1 за Непонимающий (B146).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B187</reference>
		<categories>
			<category>Business</category>
			<category>Police</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Politics</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230, MA70</reference>
		<default>
			<type>Skill</type>
			<name>@Unarmed or Melee Weapon Skill@</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">@Unarmed or Melee Weapon Skill@</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, с. B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, с. B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, с. B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Disarming</name>
		<name-loc>Обезоруживание</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь обезоружить противника (см. Удары по оружию, с. B400). Например, если вы знаете Средний меч-14 и Обезоруживание (средний меч)-17, вы можете обезоруживать врага, как если бы имели Средний меч-17.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Disguise</name>
		<name-loc>Изменение внешности/ТУ (@Специализация@)</name-loc>
		<description-loc>Это способность стать похожим на кого-то еще с помощью одежды, грима и т.д. Обратите внимание, что быстрая маскировка (надеть халат при входе в лабораторию, например) не требует проверки умения, но она сможет обмануть лишь невнимательных противников! Чтобы хорошо изменить внешность, требуется от 30 минут до часа. Для каждого человека (или группы), которого вы пытаетесь обмануть, проведите Быстрое состязание умений (Изменение внешности чаще всего против Восприятия(Per), Наблюдения или Криминологии). Люди, наделенные профессиональными умениями из сферы правопорядка или шпионажа, могут пользоваться и этими умениями при попытке раскрыть вашу маскировку. 
Когда вы сочетаете Артистизм с Изменением внешности (это так, когда вам нужно изменить и лицо, и поведение), то для каждого человека в группе вам нужно делать лишь одну проверку – но используя самое низкое значение навыка из Артистизма и Маскировки.
В мирах со множеством разумных рас необходима специализация по расе. Маскировка под похожие расы относится друг к другу обычно с -2..-4.

Модификаторы: за снаряжение (с. B345), +4 за Эластичную кожу (c.B51); от -1 до -5 (по решению Мастера), чтобы загримироваться под кого-то (или подо что-то), кто сильно отличается от вас. Если у вас очень приметная внешность, это также снизит эффективное умение на число от 1 до 5, по решению Мастера. Для больших групп может потребоваться много проверок, опять же решать Мастеру.
Изменение внешности (животные) Оно обычно используется при попытке тихо подобраться к животному, но также может применяться в религиозных или магических церемониях примитивными племенами.
Персонаж надевает шкуру животного, намазывает тело мускусом или навозом для запаха и маскируется с помощью грязи или глины. Маскировка занимает примерно 15 минут при условии, что у вас есть шкура.
Модификаторы: +2, если подходить с подветренной стороны; от +1 до +3 при удачной проверке умения Натуралист на знание повадок данного животного; -1 за каждое новое появившееся животное того же типа (-1 за каждые 10 животных, если они стадные); от -1 до -3, если шкура старая или в плохом состоянии; от -1 до -3 при провале проверки умения Натуралист.
Проверки должны делаться начиная с 200 ярдов от животных, за которыми крадутся, и потом через каждые 50 ярдов. Мастер может вносить изменение в это правило в зависимости от чутья добычи. К относительно слепым животным, таким как, например, шерстистый носорог, подобраться будет проще и потребуется меньше проверок умения. Также многое зависит от поведения самого маскирующегося; тут может пригодиться умения Натуралист.</description-loc>
		<specialization>@Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B187</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Makeup</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Diving Suit</name>
		<name-loc>Водолазный костюм/ТУ</name-loc>
		<description-loc>Это тренировка в использовании определенных защитных костюмов. Костюмы, созданные для защиты владельца от опасностей боя или окружающей среды часто имеют встроенные устройства (типа автошприцов и сенсоров) и приборы для поддержки жизнедеятельности. Некоторые костюмы даже содержат сервоприводы для увеличения ST и скорости. В результате вы не просто носите этот костюм – вы управляете им. Навык позволяет быстро одеть и снять скафандр (успешный бросок – половина времени). Для активации определенной суб-системы костюма или работы в костюме хорошем состоянии кидается бросок по IQ. В то время, когда на вас надет костюм, любой из бросков DX и навыков, на DX основанных вы кидаете против низшего значения из Скафандра и того навыка. Например, если у вас DX 14, Скрытность 15 и Скафандр 13 – вы работаете, как с DX 13 и Скрытностью 13, пока не снимете скафандр. Особенно неудобные и громоздкие костюмы будут давать штрафы к DX независимо от уровня навыка, а тонкие, высокотехнологичные костюмы могут вообще не давать штрафов.

Однако, навык работы в скафандре сильно зависит от привычки к нему. Знакомство и знания опасных ситуаций, входящих в такие навыки как Свободное падение, Опасные материалы, Выживание и прочие подобные навыки покупаются отдельно для каждого типа костюма.

Боевой костюм (Battlesuit): Все типы боевой брони и экзоскелетов со встроенным источником энергии. Боевая броня и Экзоскелеты – похожи, но не одинаковы, и считаются как за знакомство.

Водолазный костюм (Diving Suit). Все виды жестких водолазных костюмов (гибкие открытые и закрытые включены в навык Акваланг). Включает открытый костюм на ТУ 5, Жесткий шлем на ТУ 6, которые используют герметичный шлем и подачу воздуха – но не всегда полностью закрытый костюм. На ТУ 7 доступен настоящий, полноценный водолазный скафандр. Мастер может потребовать броска Плавания для маневрирования в этом костюме. (По умолчанию: Акваланг -2).

Защитный костюм (NBC Suit): Все виды снаряжения (включая не имеющие собственного питания), созданные для защиты от опасностей окружающей среды и рабоыт с опасными материалам. Без этого навыка вы постоянно рискуете в чем-то ошибиться и получить вред. 
Скафандр (Vacc Suit): Любой тип космического скафандра – включая специальные костюмы для работы в атмосферах с высоким давлением, кислотностью или ядами.
По умолчанию все виды костюмов относятся друг к другу с -2, кроме водолазного – с -4.
Негерметичные или не оборудованные энергопитанием костюмы никогда не требуют броска этого навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Scuba</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Battlesuit</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>NBC Suit</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Vacc Suit</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Dreaming</name>
		<name-loc>Ясный сон</name-loc>
		<description-loc>Это навык контролирования и запоминания снов. Успешный бросок навыка позволяет вам пережить яркий реалистичный сон на выбранную тему. Для интерпретации этого сна используется Предсказание судьбы: Интерпретация снов. В некоторых мирах это может быть полезным и распространенным способом прорицания.
Успешный бросок может также помочь вам вспомнить забытую информацию, или что-то, что вы видели, но не обратили внимания. Тем не менее, этот способ менее надежный, чем хорошая память – Мастер может просто описать сон, внеся туда несколько подсказок, расшифровка которых полностью возлагается на игрока.
Наконец, вы можете использованием этого навыка обнаружить и оборвать сверхъестественное влияние на ваши сны. Для этого кидается состязание по вашему навыку Ясного сна против навыка контроля сна атакующего. При победе вы избавляетесь от внешнего влияния.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<default>
			<type>Will</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (@Класс ТС@	)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>@Vehicle class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Heavy Wheeled</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Автомобили)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Automobile</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Heavy Wheeled</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Строительная техника)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Construction Equipment</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Полугусеничные)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Halftrack</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Tracked</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Тяжелые автомобили)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Heavy Wheeled</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Automobile</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Воздушная подушка)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Hovercraft</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Локомотив)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Locomotive</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Мех)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Mecha</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Battlesuit</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Мотоциклы)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Motorcycle</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Bicycling</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Driving</name>
		<name-loc>Вождение/ТУ (Гусеничная техника)</name-loc>
		<description-loc>Способность водить определенный вид наземного транспорта. Бросок от IQ помогает чтению простых карт, диагностике простых сбоев и припоминанию правил движения. Необходима специализация:
Автомобили (Automobile). Любая техника с тремя и более колесами, весом менее 5 тонн и не рельсовая. По умолчанию: Тяжелые автомобили -2, другое вождение -4.
Строительная техника (Construction Equipment). Любые бульдозеры, краны, плуги и прочее. По умолчанию: Другой вид вождения -5.
Полугусеничные (Halftrack). Любое транспортное средство, использующее для движения одновременно и гусеницы и колеса либо лыжи. По умолчанию: Гусеничная техника -2 или другой вид вождения -4.
Тяжелые автомобили (Heavy Wheeled). Любое средство с тремя и более колесами, весом 5 и более тонн, не использующее рельсы. По умолчанию: Автомобили -2, другой вид вождения -4.
Воздушная подушка (Hovercraft). Любой тип транспорта на воздушной подушке. По умолчанию: Другой вид Вождения -5.
Локомотив (Locomotive). Любое транспортное средство, движущееся по рельсам – обычным, магнитным и любым другим. По умолчанию: Другой вид вождения -5.
Меха (Mecha). Транспорт, использующий ноги, либо катящийся, скользящий или даже прыгающий. По умолчанию: Боевой скафандр -3, Другой вид вождения-5.
Мотоциклы (Motorcycle). Любое одно- или двухколесное транспортное средство с двигателем, включая имеющие коляски. Крупные мотоциклы часто имеют требования к ST, как оружие. По умолчанию: Велосипед -4.
Гусеничная техника (Tracked). Любой транспорт, передвигающийся с помощью гусениц. По умолчанию: Полугусеничные-2, другой вид Вождения-4.
Управление упряжкой животных относится к навыку Кучер (с. B225). 
Модификаторы: -2 за незнакомый транспорт известного вида (например, машина с ручной коробкой передач, когда вы привыкли к автоматической); -2 или больше за транспортное средство в плохом состоянии; -2 или больше при плохих условиях вождения; -4 или больше за транспорт незнакомого вида (например, Форд модели T, в то время как вы привыкли к транспортным средствам TL7, или гоночный автомобиль, в то время как вы привыкли к грузовикам).</description-loc>
		<specialization>Tracked</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B188</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<specialization>Halftrack</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Driving</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Dropping</name>
		<name-loc>Сбрасывание</name-loc>
		<description-loc>Это умение сбрасывать тяжелые предметы на врагов во время полета. Это считается дальней атакой сверху. Атаки бомбами и прочей взрывчаткой используют навык Артиллерия (бомбы).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Dual-Weapon Attack</name>
		<name-loc>Двойная атака</name-loc>
		<description-loc>* Вы можете изучить эту технику для Огнестрельного оружия (пистолеты) даже в реалистичной кампа-нии.
Если вы не используете Тотальную атаку (all-out attack) и данную технику, то при атаке с двух рук сразу вы получаете -4 на бросок атаки. Эта техника позволяет вам выкупить штраф. (обратите внимание, что вам необходимо знать также и Тренировка левой руки, (с. B232), чтобы снять положенный за использование неосновной руки штраф -4.
Подробные правила можно найти в параграфе Атака двумя оружиями (с. B417).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230, MA83</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Dual-Weapon Attack</name>
		<name-loc>Двойная атака</name-loc>
		<description-loc>* Вы можете изучить эту технику для Огнестрельного оружия (пистолеты) даже в реалистичной кампа-нии.
Если вы не используете Тотальную атаку (all-out attack) и данную технику, то при атаке с двух рук сразу вы получаете -4 на бросок атаки. Эта техника позволяет вам выкупить штраф. (обратите внимание, что вам необходимо знать также и Тренировка левой руки, (с. B232), чтобы снять положенный за использование неосновной руки штраф -4.
Подробные правила можно найти в параграфе Атака двумя оружиями (с. B417).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230, MA83</reference>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Dual-Weapon Attack</name>
		<name-loc>Двойная атака</name-loc>
		<description-loc>* Вы можете изучить эту технику для Огнестрельного оружия (пистолеты) даже в реалистичной кампа-нии.
Если вы не используете Тотальную атаку (all-out attack) и данную технику, то при атаке с двух рук сразу вы получаете -4 на бросок атаки. Эта техника позволяет вам выкупить штраф. (обратите внимание, что вам необходимо знать также и Тренировка левой руки, (с. B232), чтобы снять положенный за использование неосновной руки штраф -4.
Подробные правила можно найти в параграфе Атака двумя оружиями (с. B417).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230, MA83</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Dual-Weapon Attack</name>
		<name-loc>Двойная атака</name-loc>
		<description-loc>* Вы можете изучить эту технику для Огнестрельного оружия (пистолеты) даже в реалистичной кампа-нии.
Если вы не используете Тотальную атаку (all-out attack) и данную технику, то при атаке с двух рук сразу вы получаете -4 на бросок атаки. Эта техника позволяет вам выкупить штраф. (обратите внимание, что вам необходимо знать также и Тренировка левой руки, (с. B232), чтобы снять положенный за использование неосновной руки штраф -4.
Подробные правила можно найти в параграфе Атака двумя оружиями (с. B417).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B230, MA83</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Economics</name>
		<name-loc>Экономика</name-loc>
		<description-loc>Это наука о деньгах, биржевых операциях и банковском деле. Экономист может ответить на вопросы об инвестициях, экономической политике и т.д. Он также может предсказать локальные эффекты экономических изменений при появлении нового материала или технологии, разрушения электростанции или торгового дома и в других подобных ситуациях.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Business</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Finance</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Market Analysis</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Elbow Strike</name>
		<name-loc>Удар локтем</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -2 за удар локтем. Больше можно найти в Удар локтем, с. B404.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B230, MA71</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">Brawling</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<technique version="2" limit="0">
		<name>Elbow Strike</name>
		<name-loc>Удар локтем</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -2 за удар локтем. Больше можно найти в Удар локтем, с. B404.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B230, MA71</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">Karate</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<skill version="2">
		<name>Electrician</name>
		<name-loc>Электрик/ТУ</name-loc>
		<description-loc>Это навык создания, поддержания и ремонта электрических систем. Бросок навыка необходим для диагностики неисправности или создания проводки. В приключениях используют для повреждения и восстановления систем управления и, например, отрезания от электроснабжения построек. Обратите внимание, что электронные и электрические системы – не одно и то же.
Модификаторы: за снаряжение.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electrical</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (@Тип@)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>@Electronics type@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Communications</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Связь)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Communications</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Communications</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Радиоэлектронная разведка)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Electronic Warfare</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Military</category>
			<category>Spy</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Electronic Warfare</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Силовые поля)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Force Shields</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Force Shields</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<modifier>0</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Передача материи)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Matter Transmitters</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Matter Transmitters</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Медиа)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Media</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Media</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Медицина)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Medical</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Medical</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Medical</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Парахронотехника)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Parachronic</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Parachronic</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Психотроника)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Psychotronics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Psychotronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Научно исследовательское)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Scientific</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Scientific</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Системы безопасности)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Security</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Security</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Сенсоры )</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Sensors</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Sensors</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Сонары)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Sonar</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Sonar</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Охрана)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Surveillance</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Police</category>
			<category>Spy</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Surveillance</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Operation</name>
		<name-loc>Использование электроники/ТУ (Темпоральная)</name-loc>
		<description-loc>Это умение позволяет использовать все электронные устройства в пределах известной специальности. Для обычного, каждодневного использования оборудования не требуется проверки. Проверка требуется в чрезвычайных ситуациях или для «необычного» использования оборудования, или для использования сложного оборудования при низкой квалификации.
Персонаж с умением Использование электроники может попытаться создать новое устройство (как инженер) с пенальти -4 в пределах своей специальности, или с -8 вне ее.

Необходима специализация. Некоторые виды специализации включают:

Связь (Communication). Передача радиосигнала на дальние расстояния, сверхсветовое радио и спутниковые приемники. Специализация в связи также дает знание любых стандартов, текущих кодов связи, соответствующих происхождению персонажа. При этом проверка умения не требуется, хотя она необходима при попытке понять или использовать незнакомые коды. На ТУ 5-7 включает телеграфию (Навык*2 слов в минуту на ТУ 5, Навык*3 слов в минуту на ТУ 6-7).

Радиоэлектронная разведка (Electronic Warfare, EW). Все оборудование для разведки и противодействия разведке. В большинстве миров эта специализация доступна только военным.

Компьютеры (Computers). Системы прицеливания и управления огнем, калькуляторы, мозг роботов, искусственный интеллект.

Медиа (Media). Все виды оборудования для аудио, фильмов и видео. Если доступны трехмерное видео (голография) или сенсорные записи – и они тоже. Каждый тип считается знакомством.

Силовые поля (Force Shields) . Персональные, портативные, транспортные, стационарные и установленные на космических кораблях силовые поля и отражатели.

Передача материи (Matter Transmitters, MT): Все передатчики материи, телепортеры или транспортеры. Критическая ошибка может быть фатальной.

Медицина (Medical): Резервуары для клонирования, системы жизнеобеспечения и бионика.

Охрана (Surveillance). Все виды охранного и шпионского оборудования: жучки, камеры, микрофоны, перехват.

Системы безопасности (Security): работа и обход сигнализаций, сенсоров и прочего охранного оборудования.

Сенсоры (Sensors): Системы обнаружения всех типов – радары и даже сенсорные панели. Некоторые особые виды сенсоров выделены отдельно.

Сонары (Sonar). Все типы акустического оборудования (обычно используется под водой).

Парахронотехника (Parachronics). Любое снаряжение для путешествий через время и пространство.

Хронотехника (Temporal). Все виды машин времени. Критический провал фатален.
Психотроника (Psychotronics). Пси-оборудование, вроде телепатических щитов и усилителей.
Все эти виды специализаций относятся друг к другу с -4, но Мастер может изменить эти значения. Между распространенными (Медиа, Системы безопасноти) и экзотическими (Хронотехника и Психотроники) специальностями уровней по умолчанию нет.
На различных ТУ включаемые в специализацию устройства различаются: например, Связь на ТУ 5 – телеграф, ТУ 6 – телефоны и радио, ТУ 8 – цифровые системы и т.д.
Знакомство критически важно: по -2 за различные тип (термографы и радары), применение (самолет и спутник).
Модификаторы: -2 при отсутствии чертежей или схем; -5 при отсутствии нужных инструментов; -4 при работе вне своей специальности. Обратите внимание: Электрические моторы относятся к умению Механика, а не к Электронике.</description-loc>
		<specialization>Temporal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B189</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<specialization>Temporal</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (@Тип@)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>@Electronics type@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Communications</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Связь)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Communications</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Communications</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Компьютеры)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Computer</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Computer Operation</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Радиоэлектронная разведка)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Electronic Warfare</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Military</category>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Electronic Warfare</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Силовые поля)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Force Shields</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Force Shields</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Передача материи)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Matter Transmitters</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Matter Transmitters</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Electronics Repair</name>
	<name-loc>Ремонт электроники/ТУ (Медиа)</name-loc>
	<specialization>Media</specialization>
	<difficulty>IQ/A</difficulty>
	<points>1</points>
	<default>
		<type>IQ</type>
		<modifier>-5</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Electronics Operation</name>
		<specialization>Media</specialization>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Engineer</name>
		<specialization>Electronics</specialization>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Electronics Repair</name>
		<modifier>-4</modifier>
	</default>
	<tech_level></tech_level>
	<categories>
		<category>Repair/Maintainance</category>
	</categories>
	<reference>B190</reference>
	<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Медицина)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Medical</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Medical</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Парахронотехника)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Parachronic</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Parachronic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Психотроника)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Psychotronics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Psychotronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Научно исследовательское)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Scientific</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Scientific</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Системы безопасности)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Security</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Security</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Сенсоры )</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Sensors</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Sensors</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Сонары)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Sonar</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Sonar</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Охрана)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Surveillance</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Surveillance</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Electronics Repair</name>
		<name-loc>Ремонт электроники/ТУ (Темпоральная)</name-loc>
		<description-loc>Способность обнаруживать и устранять неполадки в электронном оборудовании. Необходимое время – по решению Мастера. Необходима специализация по определенному типу оборудования (см. Использование электроники) или в компьютерах (по умолчанию – Использование компьютера-5). Друг к другу специализации относятся с -4.
Модификаторы: за снаряжение. -2, если у вас нет схем и планов. -2 за незнакомую технологию или применение. -4 для модификации устройства, чьи функции далеки от ожидаемых.</description-loc>
		<specialization>Temporal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Temporal</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Electronics</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (@Область знаний@)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>@Field of expertise@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Armoury</name>
			<specialization>Heavy Weapons</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Артиллерия)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Artillery</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Armoury</name>
			<specialization>Heavy Weapons</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Автомобили)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Automobiles</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Automobiles</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Гражданские постройки)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Civil</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Architecture</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Часовщик )</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Clockwork</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Clockwork</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Военные постройки)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Combat</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Электричество)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Electrical</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Electrician</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Электроника )</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Electronics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Electronics Repair</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Материалы)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Materials</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="yes">
				<when_tl compare="at least">5</when_tl>
				<skill_prereq has="yes">
					<name compare="is">mathematics</name>
					<specialization compare="is">applied</specialization>
				</skill_prereq>
			</prereq_list>
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">metallurgy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">chemistry</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Chemistry</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Metallurgy</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Микротехнология)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Microtechnology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Micromachines</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Шахтерство)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Mining</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Нанотехнология)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Nanotechnology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Nanomachines</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Парахронотехника)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Parachronic</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="yes">
				<when_tl compare="at least">5</when_tl>
				<skill_prereq has="yes">
					<name compare="is">mathematics</name>
					<specialization compare="is">applied</specialization>
				</skill_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">physics</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Parachronic</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Психотроника)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Psychotronics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Psychotronics</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Робототехника)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Robotics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Robotics</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Корабли)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Ships</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Ships</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Легкое огнестрельное оружие)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Small Arms</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Armoury</name>
			<specialization>Small Arms</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Космические каорабли)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Starships</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<specialization>Starships</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Engineer</name>
		<name-loc>Инженерия/ТУ (Темпоральная)</name-loc>
		<description-loc>
Это умение разрабатывать и создавать сложные механизмы. Успешная проверка позволит вам (например) определить назначение непонятного устройства; определить неполадку в электрическом или механическом устройстве; произвести ремонт; разработать новый механизм; придумать устройство для решения определенной проблемы. Время, необходимое для каждой попытки, определяется Мастером. 

Специализация необходима. Возможные виды:

Артиллерия (Artillery) Все, что подходит в эту категорию на вашем ТУ. По умолчанию: Оружейник (тяжелое оружие)-6.

Гражданский (Civil) Автострады, акведуки, постройки и пр. По умолчанию: Архитектура-6.

Часовщик (Clockwork) Заводные устройства – часы, механизмы. По умолчанию: Механика (часы)-6.

Военный (Combat) Укрепления, рвы и пр. По умолчанию: Взрывные работы (взрывные работы)-6.

Электричество (Electrical) Электрические системы, батареи, электропроводка. По умолчанию: Электрик-6.

Электроника (Electronics) Электронные приборы – от компьютеров до космических сенсорных систем. По умолчанию: Ремонт электроники-6.

Материалы (Materials) Создание новых структурированных материалов. По умолчанию: Химия-6, Металлургия-6. Требуется: Химия или Металлургия.

Микротехнология (Microtechnology) Создание микромеханизмов. По умолчанию: Механика (микромеханизмы)-6.

Шахтерство (Mining) Проектирование подземных структур. По умолчанию: Взрывные работы-6 или Геология-6.

Нанотехнология (Nanotechnology) По умолчанию: Механика (наномеханизмы)-6.

Парахроника (Parachronic) Создание устройств для пересечения миров и времен. По умолчанию: Использование электроники (парахроника)-6. Требуется Физика.

Психотроника (Psychotronics) Работа с пси-технологией – типа усилителей и псионических щитов. По умолчанию: Использование электроники (психотроника)-6.

Робототехника (Robotics) Создание кибернетических устройств и роботов. По умолчанию: Механика (роботы)-6.

Малое оружие (Small Arms) Проектирование личного оружия – от пистолетов до ракетниц. По умолчанию: Оружейник (малое оружие)-6.

Темпоральная (Temporal) Создание машин времени. По умолчанию: Использование электроники (темпоральная)-6. Требуется Физика.
Тип транспорта (Vehicle Type) Создание и проектирование широкого класса машин (самолеты, корабли, автомобили) (По умолчанию: Инженер (та же специализация)-6.
По умолчанию специализации относятся друг к другу с -4. Мастер может изменить взаимоотношения между этими значениями; и запретить отношение по умолчанию между экзотическими и обычными видами.
Модификаторы: за снаряжение (с. B345); до +5, если вы создаете устройство, четко себе представляя, что именно и зачем вы делаете.</description-loc>
		<specialization>Temporal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B190</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Engineer</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="yes">
				<when_tl compare="at least">5</when_tl>
				<skill_prereq has="yes">
					<name compare="is">mathematics</name>
					<specialization compare="is">applied</specialization>
				</skill_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">physics</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Temporal</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Enthrallment</name>
		<name-loc>Увлечение</name-loc>
		<description-loc>
В фентези барды часто имеют способность влиять на других, рассказывая им истории. Мастер может представить эту способность в виде нескольких родственных навыков. В зависимости от сеттинга, этот навык может быть магическим, псионическим или просто формой гипноза. Каждый навык имеет свое время использования и действия, а также цену усталости. См B191
 Использование навыков требует двух бросков – первый, в начале рассказа, бросок Публичного выступления – для привлечения внимания аудитории, без которого вы не можете на нее воздействовать. В случае успеха, вы можете через определенное время рассказа сделать бросок Влияния (с +1, если первый бросок имел критический успех). При провале, вы получаете штраф, равный провальности броска. Критический провал означает автоматическую неудачу попытки Влияния.
Через некоторое время, необходимое для воздействия, делается быстрое состязание Влияния против Воли(Will) каждого слушателя. В случае успеха, ваш навык оказывает свое действие, при провале – нет. В случае критического провала, аудитория становится враждебной!
Ни один из этих навыков не может превышать уровня Публичного выступления.
Размер аудитории, на которую вы можете воздействовать, ограничен уровнем Харизмы в квадрате, до максимума 25 слушателей при Харизме 5.
Модификаторы: -3 за Нечувствительность. Если игрок рассказывает действительно хорошую историю, Мастер может наградить его бонусом от +1 до +3 на эти броски.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B191</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">charisma</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
			<skill_prereq has="yes">
				<name compare="is">public speaking</name>
				<specialization compare="is"></specialization>
				<level compare="at least">12</level>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Environment Suit</name>
		<name-loc>Скафандр/ТУ</name-loc>
		<description-loc>Это тренировка в использовании определенных защитных костюмов. Костюмы, созданные для защиты владельца от опасностей боя или окружающей среды часто имеют встроенные устройства (типа автошприцов и сенсоров) и приборы для поддержки жизнедеятельности. Некоторые костюмы даже содержат сервоприводы для увеличения ST и скорости. В результате вы не просто носите этот костюм – вы управляете им. Навык позволяет быстро одеть и снять скафандр (успешный бросок – половина времени). Для активации определенной суб-системы костюма или работы в костюме хорошем состоянии кидается бросок по IQ. В то время, когда на вас надет костюм, любой из бросков DX и навыков, на DX основанных вы кидаете против низшего значения из Скафандра и того навыка. Например, если у вас DX 14, Скрытность 15 и Скафандр 13 – вы работаете, как с DX 13 и Скрытностью 13, пока не снимете скафандр. Особенно неудобные и громоздкие костюмы будут давать штрафы к DX независимо от уровня навыка, а тонкие, высокотехнологичные костюмы могут вообще не давать штрафов.

Однако, навык работы в скафандре сильно зависит от привычки к нему. Знакомство и знания опасных ситуаций, входящих в такие навыки как Свободное падение, Опасные материалы, Выживание и прочие подобные навыки покупаются отдельно для каждого типа костюма.

Боевой костюм (Battlesuit): Все типы боевой брони и экзоскелетов со встроенным источником энергии. Боевая броня и Экзоскелеты – похожи, но не одинаковы, и считаются как за знакомство.

Водолазный костюм (Diving Suit). Все виды жестких водолазных костюмов (гибкие открытые и закрытые включены в навык Акваланг). Включает открытый костюм на ТУ 5, Жесткий шлем на ТУ 6, которые используют герметичный шлем и подачу воздуха – но не всегда полностью закрытый костюм. На ТУ 7 доступен настоящий, полноценный водолазный скафандр. Мастер может потребовать броска Плавания для маневрирования в этом костюме. (По умолчанию: Акваланг -2).

Защитный костюм (NBC Suit): Все виды снаряжения (включая не имеющие собственного питания), созданные для защиты от опасностей окружающей среды и рабоыт с опасными материалам. Без этого навыка вы постоянно рискуете в чем-то ошибиться и получить вред. 
Скафандр (Vacc Suit): Любой тип космического скафандра – включая специальные костюмы для работы в атмосферах с высоким давлением, кислотностью или ядами.
По умолчанию все виды костюмов относятся друг к другу с -2, кроме водолазного – с -4.
Негерметичные или не оборудованные энергопитанием костюмы никогда не требуют броска этого навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Erotic Art</name>
		<name-loc>Эротическое Искусство</name-loc>
		<description-loc> 
Это умение отражает основные знания о продвинутой технике секса. Все игровые эффекты на выбор Мастера.
Обычны броски на НТ, ST и даже IQ.
В настоящее время это умение пользуется популярностью только в Восточных культурах, особенно в тантрическом индуизме. Профессионалы в этом умении обычно экспериментируют с людьми, которые лично им нравятся.
Модификаторы: +3 или +5 за Гибкость (с. B56), -3 за Безрадостность (с. B140).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Acrobatics</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Escape</name>
		<name-loc>Побег</name-loc>
		<description-loc>Это способность освободиться от веревок, наручников и подобных пут. Первая попытка сбежать занимает одну минуту; каждая последующая требует 10 минут. Вы используете только половинный штраф за сложность пут, если можете вынимать конечность из суставов: это требует (20-навык) минут концентрации и последующего броска Воли(Will). Однако, если вы в этом случае провалите бросок на 3+, конечность получит 1d вреда. При критическом провале вы покалечите свою конечность.
Модификаторы: Чем тщательнее вы связаны, тем больше будет назначаемое Мастером пенальти к проверке: современные полицейские наручники, например, дадут -5 при попытке освободиться от них. Если у вас есть преимущество Гибкость (с. B20), то вы получаете +3 или +5 к данному умению. Также применяется бонус за преимущество Скользкий (c.B85).</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Criminal/Street</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Esoteric Medicine</name>
		<name-loc>Нетрадиционная медицина</name-loc>
		<description-loc>Навык лечения ран и болезней техниками, основанными на эзотерических теориях, а не на аналитических данных. Обычно это представлено магической или духовной традицией. Отдельные методы различаются, но могут включать травы, алхимию, массаж и акупунктуру, а также медитацию и даже контроль дыхания. 
Эффективность этого навыка относительно Врачебного дела (c.B213) – на усмотрение Мастера, но не должна быть хуже первой помощи (c.B195) – внимание опытного врача любого рода все равно предпочтительнее гибели! 
На ТУ 5+ часто воспринимается как «деревенская», независимо от эффективности. В сеттингах, где существует множество традиций лечения, целитель должен специализироваться.</description-loc>
		<difficulty>Per/H</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Esoteric</category>
			<category>Medical</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Exorcism</name>
		<name-loc>Экзорцизм</name-loc>
		<description-loc>Это способность изгонять духа из одержимого человека или проклятой местности. Экзорцизм - это не магическое, а религиозное умение, требующее проведения сложного ритуала (хотя, в зависимости от вида духа, ритуал может быть проведён одинаково эффективно как Малайским шаманом, так и католическим священником). 
Длительность ритуала зависит от HT духа (обычно 15 минут за каждое очко HT духа). По окончании ритуала экзорцист делает проверку умения или его значения по умолчанию. Некоторые духи будут вести себя спокойно, ожидая борьбы; другие буду пытаться отвлечь экзорциста и не дать ему завершить ритуал. Если проверка проваливается, то бес остаётся, и персонажу, который проводил ритуал, нужно ждать как минимум неделю, чтобы повторить ритуал. При критическом провале экзорцист делает проверку против 3d+10 по таблице Страха (с. B360). Более того, даже если он остается в здравом уме, он может никогда больше не согласиться изгонять подобного беса.
Критический успех автоматически изгоняет духа или беса. Если проверка оказывается просто удачной, то происходит быстрое состязание умений: Экзорцизм изгонявшего против высшего значения ST или Воли(Will) беса. При борьбе с духом, вселившимся в человека, изгоняющий беса прибавляет к своему значению ST или Волю(Will) человека, в которого бес вселился, так как он тоже будет стараться "вытолкнуть" духа из себя (соответственно, этого не происходит при изгнании духа из трупа или из какой-то местности). Если побеждает дух (или в состязании выпала ничья), то он остаётся, а экзорцист может повторить ритуал только через неделю.
Если побеждает экзорцист, дух изгоняется из своего вместилища. Дух скончавшегося человека упокаивается. В случае с демонами и подобными существами, делается бросок реакции. Только при Слабой (Poor) или лучшей реакции он улетит мирно, а при Плохой (Bad) и хуже дух приложит все усилия и воспользуется всеми своими возможностями, чтобы отомстить экзорцисту и всем, кто находился поблизости.
Удачная проверка IQ после проваленной попытки изгнать беса может дать экзорцисту какую-то полезную информацию о бесе, которая может пригодиться при последующих попытках. Она выражается как бонус +2 к умению. Разрешен только один такой бонус для каждого отдельного духа.
Модификаторы. -4, если у вас нет хотя бы одного из преимуществ Благословение (с. B40), Дарованная сила (с. B77), Истинная вера (с. B94). Вы можете понимать ритуал, но не имеете достаточной поддержки свыше.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
		<default>
			<type>Will</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Religious Ritual</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Ritual Magic</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Theology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Компьютерная безопасность)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Computer Security</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
			<category>Spy</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Теория конспирации)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Conspiracy Theory</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Египтология)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Egyptology</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
			<category>Social Sciences/Humanities</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Эпидемиология)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Epidemiology</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Medical</category>
			<category>Natural Science</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Гидрология)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Hydrology</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Natural Science</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Военная наука)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Military Science</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Military</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Природная мудрость)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Natural Philosophy</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Natural Science</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Политическая наука)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Political Science</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
			<category>Social Sciences/Humanities</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Псионика)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Psionics</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Occult/Magical</category>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Танатология)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Thantology</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
			<category>Social Sciences/Humanities</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Expert Skill</name>
		<name-loc>Эксперт (Ксенология)</name-loc>
		<description-loc>Навык эксперта представляет знание одной узкой темы, включающее знание нескольких навыков. При решении теоретического вопроса по этой теме, вы можете заменить этим навыком любой основанный на IQ бросок против любого навыка. Не аннулирует знания культур и языков, и не влияет на практические задачи. Необходима специализация по теме, Мастер может запретить любую выбранную вами специализацию, если посчитает ее тему слишком широкой.
Компьютерная безопасность (Computer Security). Любые вопросы по проникновению в компьютеры и противодействию ему. Может заменять Криптографию, работу с электроникой и компьютерами, чтобы обнаружить дыры в безопасности. Использование или закрытие этих дыр использует Программирование.
Теория конспирации (Conspiracy Theory). Наука о взаимодействии конспирационных сетей. Не включает внутренних знаний этих сетей.
Египтология (Egyptology). Наука о древнем Египте.
Эпидемиология (Epidemiology). Наука о распространении инфекций. Включает биологию, диагностику, экспертизу, географию.
Гидрология (Hydrology). Наука о водном покрове планеты, орошении и течениях. Биология, химия, география, геология и метеорология.
Военная наука (Military Science). Общее знание военных возможностей, стратегии и оружия. Артиллерия, оружейник, стратегия и тактика.
Псионика (Psionics). Наука о разуме и мозге, и феномене пси. Биология, физиология, психология, врач, диагностика.
Природная мудрость (Natural Philosophy). Общий навык, который обычно заменяет определенный научный навык (которого, может быть, еще и не существует вовсе) на ТУ 1-4. Может заменить любой такой бросок, и ответить на вопрос о известных вещах так, как их представляют люди.
Политическая наука (Political Science). Академическое изучение политики. Заменяет Географию, Историю, Право, Политик, Социологию при попытках анализа политической ситуации.
Танатология (Tanatology). Эзотерическая наука о смерти. Заменяет Антропологию, Археологию, Оккультизм и Теологию, когда ученый имеет дело со смертью и мертвецами.
Ксенология (Xenology): Общий набор знаний о известных расах вашего мира. Антропология, История, Физиология, Психология для различения других рас, а также дают ответы на общие вопросы о расе и ее культуре.</description-loc>
		<specialization>Xenology</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B193</reference>
		<categories>
			<category>Knowledge</category>
			<category>Scholarly</category>
			<category>Social Sciences/Humanities</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (@Специализация@)</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>@Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Combat</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Mining</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Underwater Demolition</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (Взрывные работы)</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>Demolition</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Combat</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Mining</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Underwater Demolition</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (Разминирование )</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>Explosive Ordnance Disposal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Military</category>
			<category>Police</category>
			<category>Technical</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="dx" compare="at least">12</attribute_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Nuclear Ordnance Disposal</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (Фейерверки)</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>Fireworks</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Chemistry</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (Разминирование ядерных устройств)</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>Nuclear Ordnance Disposal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Explosive Ordnance Disposal</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Explosives</name>
		<name-loc>Взрывные работы/ТУ (Подводные взрывные работы)</name-loc>
		<description-loc>Это навык работы со взрывчаткой и пиротехникой. Необходима специализация.

Взрывные работы (Demolition). Это способность приготовить и установить взрывное устройство. Провал – ошибка, серьезность которой зависит от величины провала; сильно проваленный бросок может привести к взрыву, пока вы еще рядом. Необходимое время сильно различается: только несколько секунд необходимо, чтобы установить готовый брикет С4, но подготовка к взрыву моста или небоскреба может занять несколько часов. Этот навык заменяет навык Ловушки, если вы имеете дело с взрывными устройствами. Разные типы взрывателей (ловушка и таймер) считаются за знакомство. По умолчанию: Инженер (военный) или (шахты) -3.

Разминирование (Explosive Ordnance Disposal, EOD): Это умение разряжать и обезвреживать бомбы, мины, запалы и т.д. Разминирование обычно применяется как быстрая Проверка умений, Разминирование сапёра и модифицированного умения Взрывные работы персонажа, который создавал механизм. Как и при прыжках с парашютом, провал или критический провал не обязательно означает смерти сапёра. Мастер может придумать много более интересных результатов. Внезапные шипящие звуки, странные отваливающиеся детали, нервный тик, зуд или сигнал тревоги - всё это возможно при подходящих условиях. Лучше будет, если Мастер сделает проверку умения и опишет жертве ее ощущения. Также возможна проверка на испуг у людей, выживших при проваленной проверке разминирования. Заметьте, что к саперам предъявляются строгие и слегка необычные требования насчет физической формы; нельзя иметь никаких дыхательных аллергий. Чихать во время разминирования не рекомендуется. Необходимо: DX 12+

Фейерверки (Fireworks): навык создания пиротехнических устройств – дымовых и световых гранат, фейерверков и т.п. Большая часть этого снаряжения может использоваться любым человеком. По умолчанию: Химия-3.

Разминирование ядерных устройств (Nuclear Ordnance Disposal, NOD): Разрядить большинство военного ядерного оружия несложно; гораздо сложнее будет разоружить бомбу, сделанную террористами. К ядерному взрыву приводят только два критических провала подряд. Просто провал приведёт максимум к детонации заряда, который должен сжать ядерные массы и заставить их детонировать… хотя это небольшое утешение для сапёра. При одном критическом провале без повторного, прилегающая зона (устанавливается Мастером) может быть отравлена радиоактивными веществами 
Подводные взрывные работы (Underwater Demolition, UD): Требования: Акваланг или Плавание. Способность подготовить и установить взрывчатку под водой. В остальном аналогично специализации Взрывные работы.
Специализации между собой относятся с -4, но Взрывные работы на суше и под водой между собой относятся с -2, и разминирование просто и разминирование ядреных устройств – тоже между собой -2.
Модификаторы: -1..-5 за отвлекающие факторы (вражеский огонь или рой кусачих муравье), или физическое движение (на ходу в лодке или автобусе). Модификаторы за потраченное время и имеющееся снаряжение также применяются.</description-loc>
		<specialization>Underwater Demolition</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Falconry</name>
		<name-loc>Соколиная охота</name-loc>
		<description-loc>Это умение охотиться с хищной птицей на мелкую дичь. Хороший сокольничий будет знать технику охоты, а также то, как заботиться о соколе. 
Чтобы найти гнездо сокола весной, нужно потратить неделю на поиски и удачно выполнить проверку умения Соколиная охота; в новом гнезде будет 1d-3 птенцов.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Raptors</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Farming</name>
		<name-loc>Сельское хозяйство/ТУ</name-loc>
		<description-loc>Навык выращивания всяких растений. Обычно изучается практическая часть, но вы также сможете ответить на теоретический вопрос о решении проблем, связанных с агрокультурой.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gardening</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Fast-Draw</name>
	<name-loc>Быстрое выхватывание (@Оружие/Инструмент@)</name-loc>
	<specialization>@Weapon or tool@</specialization>
	<difficulty>DX/E</difficulty>
	<points>1</points>
	<categories>
		<category>Combat/Weapon</category>
		<category>Ranged Combat</category>
	</categories>
	<reference>B194</reference>
	<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
</skill>
<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Стрела)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Arrow</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Силовой Меч)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Force Sword</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Нож)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Knife</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Длинное огнестрельное)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Long Arm</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Пистолеты)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Pistol</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Меч)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Sword</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Двуручный меч)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Two-Handed Sword</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Draw</name>
		<name-loc>Быстрое выхватывание (Патроны)</name-loc>
		<description-loc>Этот навык позволяет вам мгновенно достать предмет, оружие или боеприпас, или быстро перезарядить оружие. Удачное использование умения означает, что вы достаете оружие мгновенно (это не считается за маневр). Вы можете атаковать этим оружием (или зарядить лук) в этот же ход. Проваленная попытка означает, что вы готовите оружие как обычно, и не можете делать ничего другого в этот ход (если это стрела, то вы роняете ее). Критический провал означает, что вы роняете оружие!
Необходима специализация по типу оружия: Силовой меч, Нож, Длинное огнестрельное (винтовки, ружья, пистолеты-пулеметы), Пистолеты, Меч (одноручный клинок длиннее ножа), Двуручный меч.  Мастер может разрешить взятие специализации для других видов оружия (или даже инструментов и другого снаряжения), если сочтет это возможным. Помимо вышеуказанных видов, существует два особых:
Быстрое выхватывание (стрелы). Позволяет мгновенно достать стрелу, дротик или болт. Уменьшает время для подготовки лука, арбалета или духовой трубки, на одну секунду.
Быстрое выхватывание/ТУ (боеприпасы). Уменьшает время на перезарядку любого вида огнестрельного или лучевого оружия. Реальная выгода зависит от оружия, но успешный бросок ускорит перезарядку не менее, чем на секунду. Навык очень различается на разных ТУ. 
Провал приводит к падению боеприпаса, а в случае критического провала вы роняете весь колчан или подсумок, и рассыпаете боеприпасы по земле вокруг!
Модификаторы: Преимущество Боевые рефлексы дает бонус +1. Недостаток Неуклюжие руки – дает -3 за уровень.</description-loc>
		<specialization>Ammo</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B194</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Fast-Talk</name>
		<name-loc>Заговаривание зубов</name-loc>
		<description-loc>Это умение так уболтать человека, чтобы он сделал то, чего не собирался. Этому не учат (по крайней мере специально) в школе: этому можно научиться, будучи коммивояжером, мошенником, адвокатом и т.д. Если умение Заговаривание зубов у вас на уровне эксперта (20 или выше), то вы получаете +2 ко всем броскам на реакцию, если можете говорить! Мастер может потребовать от игрока подробно описать, о чем он говорит, а не просто отделаться словами «Я использую Заговаривание зубов».
Заговаривание зубов – не то же самое, что и Артистизм. Чаще всего Заговаривание зубов используется, чтобы заставить человека принять скоропалительное решение в вашу пользу. Артистизм же используется, чтобы долгое время держать кого-либо в заблуждении. Но во многих ситуациях Мастер может позволить проверку на любое из этих умений. В любой ситуации, когда требуется сделать бросок на реакцию, вы можете заменить его проверкой на Заговаривание зубов; все обычные модификаторы к реакции также применяются к Заговариванию зубов. Успешная проверка приведет к «Хорошей» реакции. Проваленная – к «Плохой».
Модификаторы: +2 за Голос, -3 за Нечувствительность, -1..-4 за Застенчивость, -2 Заикание, -5 за Правдивость.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Social</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Acting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA73</reference>
		<default>
			<type>Skill</type>
			<name>@Unarmed or Melee Weapon Skill@</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">@Unarmed or Melee Weapon Skill@</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="4">
		<name>Feint</name>
		<name-loc>Финт</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем это предлагает уровень по умолчанию, вы можете использо-вать ее вместо основного навыка, если пытаетесь провести финт против противника (см. Финт, с. B365). Например, если вы знаете Средний меч-14 и Финт (средний меч)-16, вы можете использовать Финт, как если бы имели Средний меч-16.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Filch</name>
		<name-loc>Кража</name-loc>
		<description-loc>Кража - умение незаметно своровать что-то из магазина или других подобных мест (лавка, открытое кухонное окно и т.д.) Умение скрыться с места преступления и спрятать вещь также входят в умение. Также в умение включен навык использования специальной палки с крюком на конце для известных целей. 
Если кто-то активно наблюдает за предметом, требуется выиграть состязание по навыку Кражи против Зрения (или Наблюдения) охранника.
Модификаторы: +3 за сообщника, отвлекающего внимание. +3 за тусклое освещение.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Pickpocket</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Sleight of Hand</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Finance</name>
		<name-loc>Финансы</name-loc>
		<description-loc>Навык распоряжаться деньгами. Это практическое применение Экономики – как Инженерия для Физики. Успешный бросок навыка позволит вам успешно заключить сделку, увеличить капитал, свести бюджет и пр.
Модификаторы: таланты к бизнесу и математике.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Business</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Accounting</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Economics</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Finger Lock</name>
		<name-loc>Выкручивание пальца</name-loc>
		<description-loc>Эта техника позволяет вам захватывать пальцы противника и больно их выкручивать. Используются пра-вила по выкручиванию рук (с. B403), но все повреждение идет на кисть, что быстрей может привести к ее выходу из строя.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA73</reference>
		<default>
			<type>Skill</type>
			<name>Arm Lock</name>
			<modifier>-3</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Fire Eating</name>
		<name-loc>Огнеглотание</name-loc>
		<description-loc>Это навык гасить огонь во рту не обжигаясь. Требуется бросок для каждой попытки. При провале броска вы получаете 1d-3 вреда (минимум 1) рту. Также навык позволяет выдыхать горючую жидкость изо рта. На усмотрение Мастера – это можно использовать для атаки (1d-3 вреда).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
	</skill>
	<skill version="2">
		<name>First Aid</name>
		<name-loc>Первая помощь/ТУ</name-loc>
		<description-loc>Это умение залатать раны в полевых условиях. Удачная проверка умения позволит остановить кровотечение, нейтрализовать или частично нейтрализовать яд, удачно сделать искусственное дыхание и т.д. Если проблема необычна, то ее сначала нужно определить с помощью Диагностики. 
Модификаторы: за снаряжение и знание физиологии.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Everyman</category>
			<category>Medical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Esoteric Medicine</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>0</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Veterinary</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fishing</name>
		<name-loc>Рыбная ловля</name-loc>
		<description-loc>Это умение ловить рыбу сетью, удочкой или каким-то другим способом, обычным для вашей культуры. Если у вас есть соответствующее снаряжение, а в водоеме имеется рыба, то удачная проверка умения означает, что вы поймали рыбу. Если снаряжение отсутствует, то вы можете попробовать сделать собственное. 
Модификаторы: за наличие снаряжения.</description-loc>
		<difficulty>Per/E</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Flail</name>
	<name-loc>Цеп</name-loc>
	<difficulty>DX/H</difficulty>
	<points>1</points>
	<parry after-attack="no">0</parry>
	<default>
		<type>DX</type>
		<modifier>-6</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Axe/Mace</name>
		<modifier>-4</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Two-Handed Flail</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
	</categories>
	<reference>B208</reference>
	<description-loc>Цеп – любое гибкое, несбалансированное оружие, масса которого сконцентрирована в ударной части. Такое оружие не может парировать, если вы им уже атаковали в этот ход. Поскольку цеп стремится обвиться вокруг вражеского оружия или щита, попытки его блокировать делаются -2, а парировать – с -4. Ножами и фехтовальным оружием парировать цеп вообще невозможно. Невооруженный боец парирует цепы с дополнительным штрафом -4 за безоружное парирование. Умения в этой категории по умолчанию относятся друг к другу с -3 Любой одноручный цеп – типа Утренней звезды или нунчаку. По умолчанию: Топор/Булава -4.</description-loc>
</skill>
	<skill version="2">
		<name>Flight</name>
		<name-loc>Полет</name-loc>
		<description-loc>
Отражает тренировку в долгом полете. Для бросков на усталость используется высшее из значений НТ и Полета. При полете на дальние дистанции, успешный бросок Полета увеличит покрываемое расстояние на 20% (если летит группа, бросок должен выкинуть каждый).</description-loc>
		<difficulty>HT/A</difficulty>
		<points>1</points>
		<reference>B195</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="starts with">flight</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
		<default>
			<type>HT</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Flying Leap</name>
		<name-loc>Парящий прыжок</name-loc>
		<description-loc>
Навык позволяет вам делать невероятные прыжки. Любая попытка (успешная или нет) стоит 1 FP.
При успешном броске вы можете немедленно предпринять попытку прыжка. Используйте стандартные правила по прыжкам (с. B352), но дистанция умножается втрое. При провале вы все равно можете попытаться, но не получаете премии, и делаете все броски, связанные с прыжком, с -5. При критическом провале вы падаете!
Вы можете использовать Парящий прыжок, чтобы прыгнуть на врага при атаке. Такая атака получает дополнительный штраф -2 на попадание, но если вы попали – умножьте вашу ST втрое в целях нанесения вреда и отбрасывания! При сбивании (slam) или столкновении, скорость движения во время прыжка рассчитывается по правилам Супер-прыжков (с.89), и эта скорость используется для расчета повреждений.
Модификаторы: -10 при мгновенном использовании, снижается до -5 через ход концентрации, -4 после 2-ходов, -3 после четырех, -2 после восьми, -1 после шестнадцати ходов, и без штрафов через 32 хода концентрации.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">weapon master</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">trained by a master</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">power blow</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">jumping</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Force Sword</name>
		<name-loc>Меч силовой</name-loc>
		<description-loc>Любой меч с клинком из энергии, а не материи. Это обычно ультра-технологичное оружие, проецирующее энергию из рукояти, но также применимо к подобным эффектам магии или псионики. По умолчанию: любой навык меча -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
		<parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Force Whip</name>
		<name-loc>Кнут силовой</name-loc>
		<description-loc>Любой кнут, сделанный не из материи, а из чистой энергии. Обычно это – ультратехнологические устройства, но возможны и магические и пси-аналоги. Большинство силовых кнутов ранят цель, а не запутывают ее.

Кнут – гибкое оружие, сделанное из отрезка цепи, кожи или шнура, и т.д. Кнут может иметь длину до 7 ярдов, но может бить только на максимальную дистанцию – кнутом длиной два ярда нельзя ударить на один ярд или вплотную; а также кнут долго готовится после атаки. Кнут захлестывается вокруг цели, что делает его превосходным обезоруживающим и опутывающим инструментом. Однако, недостаточная твердость затрудняет парирование кнутом: см. Особые правила по оружию ближнего боя, с. B404. Навыки в этой категории относятся друг к другу с -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
        <parry after-attack="no">-2</parry>
		<reference>B209</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Kusari</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Monowire Whip</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Whip</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Forced Entry</name>
		<name-loc>Выбивание дверей</name-loc>
		<description-loc>Это способность эффективно выбивать двери и окна, разрушать их фомкой, тараном или кувалдой любому, даже не бойцу. Для попадания делается бросок навыка. Если вы знаете навык на уровне DX+1, вы получаете +1 за кубик к базовому вреду, если же ваш навык выше – то +2. Такой же бонус применяется и при применении навыков оружия ближнего боя (вне боевой ситуации) против неподвижных предметов.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Forensics</name>
		<name-loc>Судебная экспертиза/ТУ</name-loc>
		<description-loc>Это общая наука “лабораторной” криминологии... расчет траектории пули, химический и микроанализ улик и т.д. В зависимости от ситуации, Мастер может позволить использование уровня по умолчанию от Химии или иной науки, соответствующей определенному исследованию. Некоторые задачи требуют знания других навыков (анатомии или химии)</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Police</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Criminology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Forgery</name>
		<name-loc>Подделка/ТУ</name-loc>
		<description-loc>Это способность изготовить поддельный паспорт, купюру или другой подобный документ. Этому не учат нигде кроме разведки и криминального мира, хотя вы всегда можете изучать данный навык самостоятельно. 
Когда вы используете фальшивый документ, то успешная проверка на Подделку требуется каждый раз, когда документ проверяют – если только в первый раз не произошел критический успех.
Создание документа может занять дни, если не недели. 
Некоторые задачи требуют броска, основанного на DX – в этом случае помогают модификаторы ловкости рук. Мастер может позволить делать броски по умолчанию от Рисования-5, если вы целиком и полностью делаете работу сами.
Модификаторы: Модификаторы за снаряжение (с.345); -5, если у вас не было образца для работы; +3, если вы слегка изменяете подлинник, а не делаете новый документ. Мастер также может назначить модификаторы в зависимости от серьезности проверки, которой подвергается документ; обычная проверка на границе, например, даст бонус +5.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Counterfeiting</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Астрология)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Astrology</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Авгури)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Augury</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Кристальный шар)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Crystal Gazing</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Толкование снов)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Dream Interpretation</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Фэн Шуй)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Feng Shui</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Хиромантия)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Palmistry</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Fortune-Telling</name>
		<name-loc>Предсказание Судьбы (Таро)</name-loc>
		<description-loc>Это профессиональное умение угадывать характер клиента и его желания и делать так, чтоб он остался доволен после сеанса. Очень опытные предсказатели берут большую плату за свои сеансы. Умение включается в себя знание  различных  методов гадания: хиромантии, френологии, гадания по чайной заварке, с помощью хрустально шара и карт таро. Астрология является исключением - она требует гораздо более специализированных знаний и является отдельным умением (см. умения Астрономия, B60), но Астрология и Предсказание Судьбы могут использоваться вместе, что позволит предсказателю описать гороскоп максимально точно и эмоционально.
Если предсказатель согласится на штраф -3, то он может вытягивать информацию из человека:
    "О… я вижу огромную печаль в твоем недавнем прошлом,"
    "Да! Меня бросила жена."
    "И она не единственный близкий человек, который предал тебя."
    "Это тоже верно - он сбежала с моим партнером по бизнесу."
Это умение модифицируется с помощью Харизмы. Персонажи с преимуществом Эмпатия получают бонус +3 к этому умению (включая использование по умолчанию).</description-loc>
		<specialization>Tarot</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast-Talk</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Occultism</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Forward Observer</name>
		<name-loc>Наводчик/ТУ</name-loc>
		<description-loc>Это умение навести огонь артиллерии и авиа-удар на цель. Он включает использование карты, компаса и особенностей ландшафта для определения расположения цели, а также тактическое умение навести огонь орудия для получения наилучшего результата. На высоких ТУ навык меньше зависит от наблюдения цели, и больше – от управления техникой (дронами, GPS-навигаторами, лазерными целеуказателями и пр.) – в этих случаях делается бросок, основанный на DX.
Неудача означает, что враг не задет; критическая неудача причиняет трудности и вызывает опасность. Наихудшая критическая неудача (по выбору Мастера) приводит к тому, что обстреляны свои позиции. Начиная с ТУ 7 и выше, навык может быть получен по умолчанию от Использования электроники (любой специализации) -5.
Модификаторы к проверке: модификаторы за снаряжение (с.345), -2 за незнакомый тип артиллерии (авиа-удар, если вы привыкли наводить морские орудия), –3 за каждые 500 ярдов до цели (расстояние сначала подвергается модификации при наличии оптики).</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B196</reference>
		<categories>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Artillery</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Free Fall</name>
		<name-loc>Свободное падение/ТУ</name-loc>
		<description-loc>Это умение управлять движением при свободном падении (нулевой гравитации). 
Одна проверка умения нужна, когда вы только выходите в среду без притяжения; проваленная проверка означает, что у вас начинается космическая болезнь (с. B434).
Последующие проверки умения потребуются, когда вы попытаетесь предпринять какое-либо сложное действие во время свободного падения. Любой бросок, основанный DX, сделанный в невесомости, делается против низшего из значений DX, используемого навыка или Свободного падения. Провал не означает, что вы получили космическую болезнь – просто действие не удалось.
Модификаторы: +2 за Чувство пространства (c.B34).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Freight Handling</name>
		<name-loc>Погрузка/ТУ</name-loc>
		<description-loc>Навык контроля за погрузкой и разгрузкой транспорта (нужен не грузчикам, а их бригадиру). Успешный бросок позволит избежать потери и повреждения груза во время транспортировки, и уменьшит необходимое для работы время на 20%.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gambling</name>
		<name-loc>Азартные игры</name-loc>
		<description-loc>Это умение играть в азартные игры. Успешная проверка позволит (помимо прочего) понять, жульничает ли игрок, кто на вашей стороне, а также «прикинуть шансы» в любой хитрой ситуации. Когда вы играете против казино, то просто делаете проверку умения (с отрицательными модификаторами, если Мастер говорит, что шансы малы). Когда вы играете против кого-либо еще, то оба делаете проверку на Азартные игры, пока кто-то из вас не победит. 
Умение Ловкость рук (с. B221) может помочь, если вы хотите сжульничать! Чтобы уличить шулера, проведите Состязание умений: ваше умение Азартные игры (или просто проверка на Зрение) против Ловкости рук оппонента в случае с картами или костями, либо против IQ при иных способах шулерства.
Модификаторы: от +1 до +5 за знакомство с данной игрой; от -1 до -5, если против вас жульничают. -3 за недостаток Безрадостный (с. B140).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Statistics</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Games</name>
		<name-loc>Игры (@Специализация@)</name-loc>
		<description-loc>Способность хорошо играть в игры. Навык включает знание правил игры, этикета и турнирных правил. Вы должны специализироваться в определенной игре (возможно – настольные игры, карточные, компьютерные, военные и пр.).
В большинстве культур умение играть в одну или несколько игр является ценным качеством в обществе. В кампании игра может вестись на крупную сумму, либо герою может прийтись сыграть против могущественного чудовища или мага, когда на кону жизни его компаньонов. Иногда споры решаются игрой, как видом бескровной дуэли.
Знания правил определенных видов спорта также сюда относится, но спортивные специализации позволяют лишь судить. Для участия используется соответствующая специализация навыка Спорт (Sports) или Спортивное единоборство (Combat Sports). Судья бросает против навыка для замечания нарушений, определения победителя и пр. Спортсмен может использовать навык Игры как бросок влияния, когда имеет дело с судьей, но штраф будет не менее -3.
При взятии спортивной специализации необходимо указать и специализацию по типу соревнований, например, Игры: НХЛ-хоккей, или Игры: Олимпийское дзюдо. Специализации по лигам относятся друг к другу с -2.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gardening</name>
		<name-loc>Садовод</name-loc>
		<description-loc>Способность выращивать растения в небольших пространствах (для больших масштабов используется Фермер). Успешный бросок навыка позволит вам вырастить еду, лекарственные травы, красивые цветы и деревья, и т.д.
Модификаторы: от -2 до -4 за незнакомый метод (гидропоника и бонсай), тип (трава, деревья), географический регион. Все штрафы кумулятивны.</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Farming</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Garrote</name>
		<name-loc>Удавка</name-loc>
		<description-loc>Способность опутывать беспомощную или неподозревающую жертву тонкой веревкой, удушая ее. Подробности можно найти в параграфе Особые виды оружия ближнего боя (с.404). Гарротой нельзя парировать!</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B197</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, @Класс ланеты@)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, @Planet class@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Землеподобная)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Earthlike</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Газовый гинант)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Gas Giants</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Gas Giants</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Gas Giants</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Агрессиваня территория)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Hostile Terrestrial</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Hostile Terrestrial</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Hostile Terrestrial</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Леденой карлик)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Ice Dwarfs</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Ice Dwarfs</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Ice Dwarfs</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Леденой мир)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Ice Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Ice Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Ice Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Физ, Скалистый мир)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Physical, Rock Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<specialization>Rock Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meteorology</name>
			<specialization>Rock Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Политическая)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Political</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Economics</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geography</name>
		<name-loc>География/ТУ (Региональные)</name-loc>
		<description-loc>Наука о физическом, политическом и экономическом делении планеты, и их взаимодействии. Это частично физическая, частично социальная наука. Специализация необходима.

Физическая: Наука о физических свойствах поверхности планеты. Такой географ способен ответить на вопрос о климате, ландшафте и т.д. Необходима дополнительная специализация по типу планет. По умолчанию: Геология-4, Метеорология-4.

Политическая: наука о политических регионах – границах, промышленности, ресурсах. Политический географ ответит на вопросы о обычаях, перенаселении, экономическом взаимодействии, транспортных путях и пр. По умолчанию: Экономика-4.
Региональная: Объединяет физическую и политическую географию, но изучает лишь один регион: США, Нью-Йорк, планету Земля. Глубина знаний уменьшается с увеличением размера региона (см. Знание области). По умолчанию: соответствующее Знание области-6.
Друг к другу специализации относятся с -5.</description-loc>
		<specialization>Regional</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Area Knowledge</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (@Типо планеты@)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>@Planet class@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Землеподобные планеты)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Earthlike</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Earthlike</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Газовые гиганты)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Gas Giants</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Gas Giants</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Агрессивные миры)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Hostile Terrestrial</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Hostile Terrestrial</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Леядные карлики)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Ice Dwarfs</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Ice Dwarfs</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Ледяные планеты)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Ice Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Ice Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Geology</name>
		<name-loc>Геология/ТУ (Скалистые планеты)</name-loc>
		<description-loc>Это наука, изучающая структуру планет. Геолог знает о нефти, скалах, металлических рудах и минералах, о землетрясениях и вулканах, а также об окаменелостях. Будучи на природе, он может попытаться отыскать воду, анализируя характерные черты местности, как и для умения Выживание.
Необходима специализация на типе планет.</description-loc>
		<specialization>Rock Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geography</name>
			<specialization>Physical, Rock Worlds</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Prospecting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gesture</name>
		<name-loc>Язык жестов</name-loc>
		<description-loc>Это способность общаться с помощью простых импровизированных сигналов руками. Глухие и/или немые персонажи получают +3 к использованию этого умения. Успешная проверка Языка жестов позволит вам сообщить простую мысль другому или понять одну простую мысль, сообщенную кем-то другим. При длинных "беседах" используйте правила для общения, описанные выше. Простой язык жестов не приспособлен для сложного общения! 
Модификаторы: знакомство с культурой (с.23).</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA73</reference>
		<default>
			<type>Skill</type>
			<name>@Combat Skill@</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">@Combat Skill@</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Ground Fighting</name>
		<name-loc>Бой лежа</name-loc>
		<description-loc>Эта техника позволяет уменьшить штраф -4 за атаку из положения лежа. Бросок атаки при этих условиях делается против уровня техники, а не навыка. Например, если у вас есть Борьба-14 и Бой лежа (борьба)-13, вы можете проводить захваты из положения лежа с навыком 13, а не 10.
Кроме того, вы можете сделать бросок этой техники, если вам необходимо защититься от атаки сзади. В случае успеха, бросок защиты делается со штрафом -1, а не -3.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Group Performance</name>
		<name-loc>Групповое выступление (@Тип@)</name-loc>
		<description-loc>Способность дирижировать и управлять группой выступающих – в студии, на репетиции или перед аудиторией. Успешный бросок значит, что выступление понравилось. Вы должны специализироваться в отдельном творческом искусстве. Все специализации имеют требования, указанные ниже, а также одно из следующих: Дипломатия, Лидерство или Допрос.

Хореография (Choreography). Способность инструктировать и вести группу танцоров. По умолчанию: Танцы-2. Требуется: Танцы

Дирижирование (Conducting). Способность управлять группой музыкантов. Хор, симфонический оркестр – все это разные знакомства. По умолчанию: Музыкальный инструмент-2 или Пение-2.. Требуется: два любых навыка музыкальных инструментов или один инструмент и Пение

Режиссирование (Directing); Способность управлять группой актеров (фильм, опера, телевидение, театр – все разные знакомства). По умолчанию: Выступление-5. Требования: Выступление
Боевая хореография (Figth Choreography). Подобно хореографии, но используется не для танцев, а для Сценических боев (Stage Combat, c.B222). По умолчанию: Сценический бой-2. Требования: Сценический бой</description-loc>
		<specialization>@Art@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">diplomacy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">intimidation</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">leadership</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Dancing</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Group Performance</name>
		<name-loc>Групповое выступление (Хореография )</name-loc>
		<description-loc>Способность дирижировать и управлять группой выступающих – в студии, на репетиции или перед аудиторией. Успешный бросок значит, что выступление понравилось. Вы должны специализироваться в отдельном творческом искусстве. Все специализации имеют требования, указанные ниже, а также одно из следующих: Дипломатия, Лидерство или Допрос.

Хореография (Choreography). Способность инструктировать и вести группу танцоров. По умолчанию: Танцы-2. Требуется: Танцы

Дирижирование (Conducting). Способность управлять группой музыкантов. Хор, симфонический оркестр – все это разные знакомства. По умолчанию: Музыкальный инструмент-2 или Пение-2.. Требуется: два любых навыка музыкальных инструментов или один инструмент и Пение

Режиссирование (Directing); Способность управлять группой актеров (фильм, опера, телевидение, театр – все разные знакомства). По умолчанию: Выступление-5. Требования: Выступление
Боевая хореография (Figth Choreography). Подобно хореографии, но используется не для танцев, а для Сценических боев (Stage Combat, c.B222). По умолчанию: Сценический бой-2. Требования: Сценический бой</description-loc>
		<specialization>Choreography</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">diplomacy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">intimidation</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">leadership</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">dancing</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Dancing</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Group Performance</name>
		<name-loc>Групповое выступление (Дирижирование )</name-loc>
		<description-loc>Способность дирижировать и управлять группой выступающих – в студии, на репетиции или перед аудиторией. Успешный бросок значит, что выступление понравилось. Вы должны специализироваться в отдельном творческом искусстве. Все специализации имеют требования, указанные ниже, а также одно из следующих: Дипломатия, Лидерство или Допрос.

Хореография (Choreography). Способность инструктировать и вести группу танцоров. По умолчанию: Танцы-2. Требуется: Танцы

Дирижирование (Conducting). Способность управлять группой музыкантов. Хор, симфонический оркестр – все это разные знакомства. По умолчанию: Музыкальный инструмент-2 или Пение-2.. Требуется: два любых навыка музыкальных инструментов или один инструмент и Пение

Режиссирование (Directing); Способность управлять группой актеров (фильм, опера, телевидение, театр – все разные знакомства). По умолчанию: Выступление-5. Требования: Выступление
Боевая хореография (Figth Choreography). Подобно хореографии, но используется не для танцев, а для Сценических боев (Stage Combat, c.B222). По умолчанию: Сценический бой-2. Требования: Сценический бой</description-loc>
		<specialization>Conducting</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">diplomacy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">intimidation</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">leadership</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
			<prereq_list all="no">
				<prereq_list all="yes">
					<skill_prereq has="yes">
						<name compare="contains">musical instrument</name>
						<specialization compare="is"></specialization>
					</skill_prereq>
					<skill_prereq has="yes">
						<name compare="contains">musical instrument</name>
						<specialization compare="is"></specialization>
					</skill_prereq>
				</prereq_list>
				<prereq_list all="yes">
					<skill_prereq has="yes">
						<name compare="contains">musical instrument</name>
						<specialization compare="is"></specialization>
					</skill_prereq>
					<skill_prereq has="yes">
						<name compare="is">singing</name>
						<specialization compare="is"></specialization>
					</skill_prereq>
				</prereq_list>
			</prereq_list>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Musical Instrument</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Singing</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Group Performance</name>
		<name-loc>Групповое выступление (Режиссирование )</name-loc>
		<description-loc>Способность дирижировать и управлять группой выступающих – в студии, на репетиции или перед аудиторией. Успешный бросок значит, что выступление понравилось. Вы должны специализироваться в отдельном творческом искусстве. Все специализации имеют требования, указанные ниже, а также одно из следующих: Дипломатия, Лидерство или Допрос.

Хореография (Choreography). Способность инструктировать и вести группу танцоров. По умолчанию: Танцы-2. Требуется: Танцы

Дирижирование (Conducting). Способность управлять группой музыкантов. Хор, симфонический оркестр – все это разные знакомства. По умолчанию: Музыкальный инструмент-2 или Пение-2.. Требуется: два любых навыка музыкальных инструментов или один инструмент и Пение

Режиссирование (Directing); Способность управлять группой актеров (фильм, опера, телевидение, театр – все разные знакомства). По умолчанию: Выступление-5. Требования: Выступление
Боевая хореография (Figth Choreography). Подобно хореографии, но используется не для танцев, а для Сценических боев (Stage Combat, c.B222). По умолчанию: Сценический бой-2. Требования: Сценический бой</description-loc>
		<specialization>Directing</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">diplomacy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">intimidation</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">leadership</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">performance</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Performance</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Group Performance</name>
		<name-loc>Групповое выступление (Боевая хореография)</name-loc>
		<description-loc>Способность дирижировать и управлять группой выступающих – в студии, на репетиции или перед аудиторией. Успешный бросок значит, что выступление понравилось. Вы должны специализироваться в отдельном творческом искусстве. Все специализации имеют требования, указанные ниже, а также одно из следующих: Дипломатия, Лидерство или Допрос.

Хореография (Choreography). Способность инструктировать и вести группу танцоров. По умолчанию: Танцы-2. Требуется: Танцы

Дирижирование (Conducting). Способность управлять группой музыкантов. Хор, симфонический оркестр – все это разные знакомства. По умолчанию: Музыкальный инструмент-2 или Пение-2.. Требуется: два любых навыка музыкальных инструментов или один инструмент и Пение

Режиссирование (Directing); Способность управлять группой актеров (фильм, опера, телевидение, театр – все разные знакомства). По умолчанию: Выступление-5. Требования: Выступление
Боевая хореография (Figth Choreography). Подобно хореографии, но используется не для танцев, а для Сценических боев (Stage Combat, c.B222). По умолчанию: Сценический бой-2. Требования: Сценический бой</description-loc>
		<specialization>Fight Choreography</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">diplomacy</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">intimidation</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="is">leadership</name>
					<specialization compare="is"></specialization>
				</skill_prereq>
			</prereq_list>
			<skill_prereq has="yes">
				<name compare="is">stage combat</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Stage Combat</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (@Тип оружия@)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>@Gun class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (Лучевая)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Beams</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (Пушки)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Cannon</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (Катапульты)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Catapult</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (Пулеметы)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Machine Gun</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Gunner</name>
		<name-loc>Тяжелое оружие/ТУ (Ракетные установки)</name-loc>
		<description-loc>Это способность использовать тяжелое оружие для ведения прямого огня. Делайте проверку умения каждый раз, когда стреляете из этого оружия. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.
Заряжающие могут бросать навык, основанный на ST, чтобы ускорить перезарядку.

Вы должны специализироваться на определенном виде оружия. Доступные виды специализаций варьируются на разных ТУ, но включают 1 или больше видов из следующих:

Лучевое (Beam): любой тип оружия, ведущее прямой прицельный огонь энергией (лазеры).

Орудия (Cannon): Любой вид тяжелого снарядного оружия – орудие танка или электромагнитное орудие космического корабля, стреляющее одиночными выстрелами.

Катапульта (Catapult): любой вид крупной механической метательной машины (баллисты)

Пулеметы (Machine Gun): любой вид тяжелого снарядного оружия, способного к стрельбе очередями.
Ракетные установки (Rockets): любые пусковые установки. 
Большинство из этих видов специализации относятся друг к другу по умолчанию с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (прицельная система, способ крепления, основа (авиапушка, наземная пушка на треноге), до возможного -6.
Тяжелое оружие также может заменять умение Механика для своего типа орудия. Проверка производится с -4 для того, чтобы обнаружить поломку и с -8, чтобы устранить ее. См. Механика, B54.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Rockets</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Gunner</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (@Тип оружия@)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>@Gun class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Гранатомет)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Grenade Launcher</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Гиро)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Gyroc</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Легкое бронебойное оружие)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Light Anti-Armor Weapon</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Легкие пулеметы)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Light Machine Gun</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Мушкеты)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Musket</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Пистолеты)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Pistol</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Винтовки)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Rifle</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Beam Weapons</name>
			<specialization>Rifle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Ружья)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Shotgun</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Submachine Gun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Guns</name>
		<name-loc>Огнестрельное оружие/ТУ (Пистолеты-пулеметы)</name-loc>
		<description-loc>Это способность использовать пороховые (и подобные) виды оружия с химическими или осколочными снарядами. Для попадания в цель требуется успешный бросок навыка, для быстрого устранения неполадки – бросок навыка, основанного на IQ.

Специализация на типе оружия необходима. Доступные виды оружия различаются на разных ТУ, но включают большую часть из следующих:

Гранатомет (Grenade Launcher): крупнокалиберное оружие, стреляющее разрывными снарядами. Включает в себя подствольные гранатометы, ракетницы и ультратехнологичные аналоги.

Гиро (Gyroc): любой тип небольшого оружия, стреляющего маленькими ракетами.

Легкое бронебойное оружие (LAW): все виды ракетных пусковых установок и безоткатных винтовок. 

Легкие пулеметы (Light Machine Gun): Любые пулеметы, стрельба из которых ведется от бедра или с сошки.

Мушкет (Musket): длинноствольное ненарезное оружие, стреляющее пулями (обычно, но не всегда – на дымном порохе)

Пистолет (Pistol): все виды небольших огнестрельных видов оружия (пистолеты, револьверы) – включая автоматические, но не стреляющие очередями.

Винтовки (Rifle): нарезное длинноствольное оружие – охотничьи, снайперские, штурмовые винтовки, стреляющие пулями.

Ружья (Shotgun): гладкоствольное длинноствольное оружие, стреляющее дробью и подобными боеприпасами.
Пистолеты-пулеметы (SMG): полностью автоматические виды оружия небольшого размера, использующие боеприпасы малого калибра.
Большинство из этих видов специализации относятся друг к другу по умолчанию с -2, но гранатометы, Гиро и LAW – с -4. Виды оружия, попадающие под каждую категорию, различаются на разных ТУ, также как и боеприпасы к ним (дымный и бездымный порох и энергоячейки с болванками).
Знакомство с оружием критически важно. Вы получаете по -2 за каждое различие (тип хвата, калибр, тип (снайперская и штурмовая винтовка), принцип действия), до возможного -6.
Модификаторы: все подходящие модификаторы за дальний бой, -4 за плохое состояние оружия.</description-loc>
		<specialization>Submachine Gun</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B198</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Grenade Launcher</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Gyroc</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Anti-Armor Weapon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Light Machine Gun</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Musket</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Rifle</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Shotgun</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hazardous Materials</name>
		<name-loc>Работа с опасными материалами/ТУ (Биологические)</name-loc>
		<description-loc>Способность транспортировки, хранения и уничтожения опасных материалов, включая их учет и маркировку, а также защиту, противоядия и пр. Бросок навыка делается всякий раз при использовании других навыков (по низшему из значений навыков) и просто при работе с материалами.
Необходима специализация (тип материалов). Обычные специализации – биологические, химические, радиоактивные, но другие тоже могут существовать (нанотехнологические, магические).
Уровень по умолчанию отражает только общеизвестные знания о хранении материалов.</description-loc>
		<specialization>Biological</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hazardous Materials</name>
		<name-loc>Работа с опасными материалами/ТУ (Химические)</name-loc>
		<description-loc>Способность транспортировки, хранения и уничтожения опасных материалов, включая их учет и маркировку, а также защиту, противоядия и пр. Бросок навыка делается всякий раз при использовании других навыков (по низшему из значений навыков) и просто при работе с материалами.
Необходима специализация (тип материалов). Обычные специализации – биологические, химические, радиоактивные, но другие тоже могут существовать (нанотехнологические, магические).
Уровень по умолчанию отражает только общеизвестные знания о хранении материалов.</description-loc>
		<specialization>Chemical</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hazardous Materials</name>
		<name-loc>Работа с опасными материалами/ТУ (Магические)</name-loc>
		<description-loc>Способность транспортировки, хранения и уничтожения опасных материалов, включая их учет и маркировку, а также защиту, противоядия и пр. Бросок навыка делается всякий раз при использовании других навыков (по низшему из значений навыков) и просто при работе с материалами.
Необходима специализация (тип материалов). Обычные специализации – биологические, химические, радиоактивные, но другие тоже могут существовать (нанотехнологические, магические).
Уровень по умолчанию отражает только общеизвестные знания о хранении материалов.</description-loc>
		<specialization>Magical</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hazardous Materials</name>
		<name-loc>Работа с опасными материалами/ТУ (Нанотехнологические)</name-loc>
		<description-loc>Способность транспортировки, хранения и уничтожения опасных материалов, включая их учет и маркировку, а также защиту, противоядия и пр. Бросок навыка делается всякий раз при использовании других навыков (по низшему из значений навыков) и просто при работе с материалами.
Необходима специализация (тип материалов). Обычные специализации – биологические, химические, радиоактивные, но другие тоже могут существовать (нанотехнологические, магические).
Уровень по умолчанию отражает только общеизвестные знания о хранении материалов.</description-loc>
		<specialization>Nanotech</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hazardous Materials</name>
		<name-loc>Работа с опасными материалами/ТУ (Ядерные)</name-loc>
		<description-loc>Способность транспортировки, хранения и уничтожения опасных материалов, включая их учет и маркировку, а также защиту, противоядия и пр. Бросок навыка делается всякий раз при использовании других навыков (по низшему из значений навыков) и просто при работе с материалами.
Необходима специализация (тип материалов). Обычные специализации – биологические, химические, радиоактивные, но другие тоже могут существовать (нанотехнологические, магические).
Уровень по умолчанию отражает только общеизвестные знания о хранении материалов.</description-loc>
		<specialization>Nuclear</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Heraldry</name>
		<name-loc>Геральдика</name-loc>
		<description-loc>Это умение определять и создавать гербы, их цвета, изображенные предметы, другие эмблемы. При успешной проверке герольд может определить рыцаря или дворянина по знамени или щиту, которые те носят, и описать это в надлежащих геральдических терминах; создавать привлекательные и подходящие гербы для новых дворян (без конфликтов с существующими правилами) и так далее. Геральдика также важна в некоторых научно-фантастических мирах!
Вы можете взять необязательную (в некоторых мирах – обязательную) специализацию на типе: гербы (обычная – как выше), Эмблемы корпораций (по умолчанию Свежие новости (бизнес)-3), Граффити (Знание улиц-3).
Модификаторы: за знание культуры; также может модифицироваться в зависимости от того, широко ли известен вид герба (вплоть до +5), наоборот малоизвестен (-1 или больше).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Savoir-Faire</name>
			<specialization>High Society</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Herb Lore</name>
		<name-loc>Знахарь/ТУ</name-loc>
		<description-loc>
Способность изготовлять травяные препараты с магическими эффектами – приворотные зелья, целительные бальзамы и пр. Существует только в магических мирах, и работает почти как Алхимия, но не дает способности распознать эликсир. С другой стороны, травник может найти ингредиенты бесплатно на природе бросками Натуралиста, а алхимик нуждается в редких и дорогих препаратах.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="contains">naturalist</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (@Предмет@)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>@Subject@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (Конспирация)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>Conspiracies</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (Демоны)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>Demon Lore</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
			<category>Occult/Magical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (Земля)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>Earth</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (Фэйри)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>Faerie Lore</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
			<category>Occult/Magical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hidden Lore</name>
		<name-loc>Тайное знание (Духи)</name-loc>
		<description-loc>Отражает знания, которые потеряны, скрыты или просто забыты. Независимо от причины, большая часть людей не знают о них – эти знания доступны только тем, кто их изучал специально.
Вы должны специализироваться в определенной области. Если вы желаете начать играть с этим навыком, вы должны указать в предыстории персонажа, откуда вы их изучили. Мастер может даже потребовать покупки Необычного происхождения – или вообще запретить начинающим (и даже вообще игрокам!).
Для приобретения знаний в ходе игры, вы должны найти надежный источник информации. Мастер может привязать увеличение навыка к определенным действиям – например, неделям изучения пыльных книг – вместо свободного распределения очков. Например, древняя рукопись может вам позволить потратить 8 очков (и не больше!) на определенную специализацию навыка.
Помните, что многие секреты остаются таковыми потому, что могущественные существа желают сохранить их в тайне. Так что, обсуждение или демонстрация таких знаний могут быть чрезвычайно опасными.
Возможные специализации включают:
Конспирация: вы знаете подробности, скрываемые о различных аспектах общества. Это – фактические знания, и не включают способности анализировать.
Демоны: вы познали секреты Ада, цели демонов в мире смертных, и возможно, даже имена некоторых демонов.
Фэйри: вы узнали о фэйри и их тайных королевствах.
Духи: вы знаете о духах и других духовных сущностях – цели, имена и пр.</description-loc>
		<specialization>Spirit Lore</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B199</reference>
		<categories>
			<category>Knowledge</category>
			<category>Occult/Magical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Hiking</name>
		<name-loc>Ходьба</name-loc>
		<description-loc>Оно отражает тренированность для длительных переходов, путешествий, марша и т.д. Оно также включает знания о том, как лучше нести рюкзак, как изменять темп движения и т.д. Бросайте навык в начале каждого дня пути; при успешном броске увеличьте пройденное расстояние (см. B187) на 20% до учета условий передвижения. Если несколько человек путешествуют вместе, все должны выполнить проверку Ходьбы, чтобы вместе пройти большое расстояние.
Мастер может дать бонусы за хорошие карты и удобную обувь, но не за ландшафт.</description-loc>
		<difficulty>HT/A</difficulty>
		<points>1</points>
		<reference>B200</reference>
		<categories>
			<category>Athletic</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>History</name>
		<name-loc>История (@Специализация@)</name-loc>
		<description-loc>Это наука, изучающая письменную историю (в противоположность археологии, изучающей дописьменную эпоху). Историк сможет ответить на вопросы, касающиеся истории или (по решению Мастера), выполнив проверку, вспомнить полезную аналогию из прошлого: «Ах, да. Ганнибал как-то столкнулся с похожей ситуацией, и вот как он поступил...». Специализация необходима.
* Специализация по ограниченному географическому региону (не более небольшой нации) на протяжении многих эр – история штата Нью-Йорк, Баварии, Ирландии.
* Одна эра (викторианский период, XX век) обширного географического региона (Европа); культура (мусульманство); идея (экономика, эзотерика, военная). Примеры: (История – Америка, ХХ-век; История (наполеоновская военная).
Если две специализации вообще пересекаются, они могут зависеть по умолчанию со штрафом от -2 до -4 и больше.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B200</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hobby Skill</name>
		<name-loc>Хобби (@Умственное@)</name-loc>
		<description-loc>Многие из областей, доступных для изучения, не приносят большой пользы для жизни или приключений – но люди все равно их изучают. Каждый из них – отдельный Хобби-навык. Навыки, требующие тонкой работы (вышивание, вязание, оригами и т.д.) – DX/Легкие навыки, по умолчанию относящиеся к DX-4; а концентрирующиеся на эрудиции или воображении (комиксы, рок-музыка, фантастика, аквариумистика) – IQ/Легкий, по умолчанию имеющие уровень IQ-4.
Несколько очков в хобби-навыках могут разнообразить ролевой отыгрыш – и, возможно, иногда оказаться полезными. Вам не нужен учитель для изучения и улучшения Хобби. Однако, вы не можете изучить в качестве Хобби ни один из навыков, приведенных в этой главе.</description-loc>
		<specialization>@Mental Hobby@</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B200</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hobby Skill</name>
		<name-loc>Хобби (@Физическое@)</name-loc>
		<description-loc>Многие из областей, доступных для изучения, не приносят большой пользы для жизни или приключений – но люди все равно их изучают. Каждый из них – отдельный Хобби-навык. Навыки, требующие тонкой работы (вышивание, вязание, оригами и т.д.) – DX/Легкие навыки, по умолчанию относящиеся к DX-4; а концентрирующиеся на эрудиции или воображении (комиксы, рок-музыка, фантастика, аквариумистика) – IQ/Легкий, по умолчанию имеющие уровень IQ-4.
Несколько очков в хобби-навыках могут разнообразить ролевой отыгрыш – и, возможно, иногда оказаться полезными. Вам не нужен учитель для изучения и улучшения Хобби. Однако, вы не можете изучить в качестве Хобби ни один из навыков, приведенных в этой главе.</description-loc>
		<specialization>@Physical Hobby@</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B200</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Holdout</name>
	<name-loc>Утаивание</name-loc>
	<difficulty>IQ/A</difficulty>
	<points>1</points>
	<default>
		<type>IQ</type>
		<modifier>-5</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Sleight of Hand</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Criminal/Street</category>
		<category>Spy</category>
	</categories>
	<reference>B200</reference>
	<description-loc>Это умение утаивать предметы на себе или на других (обычно тех, кто вам помогает). Также это умение находить спрятанные таким образом вещи.
Размер и форма предмета определяют, насколько удобно его прятать. Некоторые примеры:
+4: Драгоценный камень размером с горошину; почтовая марка.
+3: Дискета или компакт-диск XX века, без коробки
+2: Одна отмычка; крупный драгоценный камень; гривенник; компьютерный диск TL 9+; письмо
+1: Набор отмычек; кинжал; серебряный доллар
-1: Большой нож; рогатка, маленький пистолет или небольшая граната
-2: Обычный пистолет (например «Luger»)
-3: Пистолет-пулемет, короткий меч, обрез
-4: меч, автомат;
-5: полуторный меч, винтовка;
-6: арбалет, тяжелая снайперская винтовка.
Предметы, которые шевелятся или издают шум, дают как минимум -1 к умению Утаивания.
Одежда также влияет на эффективное умение. Монахиня из ордена кармелитов в полном облачении (+5 к умению) может скрыть от посторонних глаз гранатомет или секиру. Танцовщица из Лас-Вегаса в своем наряде (-5 к умению) с трудом сможет спрятать даже кинжал. Конечно, она может и вовсе избежать обыска (если охранникам не будет в этот момент скучно), потому что «ясно, что она ничего в таком наряде не спрячет...» Полностью голый человек получает -7 к умению. Правильно сшитая кобура помогает спрятать оружие. Одежда, специально созданная, чтобы прятать предметы, может дать бонус до +4.
Обнаружение: Чтобы обнаружить спрятанную вещь, требуется выиграть Быстрое состязание умений: проверка на Восприятие(Per)-5 (или Поиска) ищущего против Утаивания укрывающего.</description-loc>
</skill>
	<technique version="2" limit="0">
		<name>Horse Archery</name>
		<name-loc>Стрельба на скаку</name-loc>
		<description-loc>Техника позволяет более эффективно использовать лук на скаку. Модификаторы за стрельбу из седла (с. B387) не могут уменьшить навык лука ниже уровня этой техники (другие штрафы применяются как обыч-но). Например, если вы знаете Лук-13 и Стрельба на скаку-11, штрафы за стрельбу с лошади не опустят ваш навык ниже 11, до учета всех остальных модификаторов. 
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA74</reference>
		<default>
			<type>Skill</type>
			<name>Bow</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Animal</category>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
			<category>Technique</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">riding</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
	</technique>
	<skill version="2">
		<name>Housekeeping</name>
		<name-loc>Домашнее хозяйство</name-loc>
		<description-loc>Способность управлять домашним хозяйством. Включает домашнюю экономику и повседневные обязанности: уборку, готовку (но не общественное питание, которое относится к навыку Повар), мелкий ремонт (любая задача, дающая бонус +4 за простоту к ремесленным навыкам для ремонта) и пр. Основное использование навыка – качественное выполнение домашних обязанностей, но это может быть полезно и для приключенцев – например, для заметания следов.</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B200</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Hypnotism</name>
		<name-loc>Гипноз</name-loc>
		<description-loc>Это умение влиять на сознание жертвы словами или действиями. Первая попытка гипноза занимает 5 секунд. Если она неудачна, но жертва не сопротивляется вам, то вторую попытку можно сделать с пенальти -5, это займет 5 минут. Если и вторая попытка провалится, то жертва сопротивляется гипнозу и не может быть загипнотизирована в этот день.
Успешное применение гипноза погружает субъекта в сон. Этот сон считается хорошей анестезией в целях использования Хирургии. С позволения Мастера, дальнейшие броски Гипноза позволит жертве вспомнить что-то забытое, а Психологии – преодолеть ментальные проблемы.
Когда человек загипнотизирован, он очень легко поддается внушению. Проведите состязание навыка гипнотизера против Воли(Will) жертвы за  каждую отдаваемую команду. Любая команда, которая подвергает опасности жизнь жертвы или жизнь ее близких, дает бонус +5 к Воле(Will). Эффект гипноза длится 1d часов, если только не будет прерван гипнотизером раньше. Постгипнотическое внушение (программирование действий жертвы после ее выхода из транса) тоже возможно. Обычно это дает жертве бонус +1 к Воле(Will) за каждую полную неделю отсрочки.
Использование Гипноза в бою невозможно – разве что только в киношных играх. Вы можете пытаться загипнотизировать ничего неподозревающую или сопротивляющуюся жертву, но она может сопротивляться по Воле(Will)+5. Если сопротивление было успешным, в этот день данная жертва вам не поддастся. Конечно, если жертва не знакома с гипнозом, то она не поймет, что произошло, но может что-то заподозрить.
Модификаторы: +2 за использование через телепатию, поскольку ваш голос сложнее проигнорировать.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Medical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Immovable Stance</name>
		<name-loc>Недвижимая стойка</name-loc>
		<description-loc>
Нужным образом направляя вашу энергию, используя тайную технику сохранения равновесия и т.п., вы буквально «врастаете» в землю. Бросок навыка делается в любом случае, когда атака (толкание или навык Отбрасывания (c.B216)), может привести к падению или отбрасыванию.
При успехе вы не подвергаетесь эффекту отбрасывания или не падаете. При провале вы отброшены, но получаете обычный бросок DX для избежания падения. При критическом провале вы терпите полные эффекты падения и отбрасывания.
Этот навык также помогает против атак, использующихся с навыком Дзюдо (с. B203). Если вы провалили активную защиту (или не защищались вообще) против броска Дзюдо, ваш противник должен победить в состязании по навыкам Дзюдо против вашего навыка Недвижимой стойки, или его бросок не пройдет.
Модификаторы: -1 за ярд потенциального отбрасывания; +4 за Совершенное равновесие (с. B74).</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<technique version="2" limit="0">
		<name>Impersonate</name>
		<name-loc>Подражание</name-loc>
		<description-loc>Постоянно упражняясь, вы можете улучшить способность подражать одному конкретному человеку, вы-купая штраф -3 за подражание ему. Каждая персона - отдельная техника.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Mimicry</name>
			<specialization>Speech</specialization>
			<modifier>-3</modifier>
		</default>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Innate Attack</name>
		<name-loc>Природная атака (@Тип@)</name-loc>
		<description-loc>Представляет тренированность в использовании дальнобойного природного оружия: огненного дыхания, энергетических шаров и т.д. Увеличивает шансы на попадание Воздействием, Связыванием, Природным оружием, Волшебными струями и снарядами, и подобными атаками. Необходима специализация:
Лучи (Beams): любой энергетический удар, струя и пр., излучаемая из рук. Вам необходимо иметь хотя бы одну свободную (не обязательно пустую) руку.
Дыхание (Breath): любая атака, происходящая из вашего рта – типа плевка или огненного дыхания. Вы должны стоять лицом к цели и рот ваш не должен быть заткнут.
Взгляд (Gaze): атаки, исходящие из глаз – обжигающий взор, взгляд василиска и пр. Вы должны видеть жертву своими глазами. 
Снаряд (Projectile). Любой снаряд или псевдо-твердый сгусток энергии (например, заклинание Огненного шара), пускаемый из рук. Также необходимо иметь хотя бы одну свободную (необязательно пустую) руку. 
Все виды специализации относятся друг к другу с -2.
Навык используется для попадания атаки в цель, но не для ее активации или воздействия.</description-loc>
		<specialization>@Type@</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Innate Attack</name>
		<name-loc>Природная атака (Луч)</name-loc>
		<description-loc>Представляет тренированность в использовании дальнобойного природного оружия: огненного дыхания, энергетических шаров и т.д. Увеличивает шансы на попадание Воздействием, Связыванием, Природным оружием, Волшебными струями и снарядами, и подобными атаками. Необходима специализация:
Лучи (Beams): любой энергетический удар, струя и пр., излучаемая из рук. Вам необходимо иметь хотя бы одну свободную (не обязательно пустую) руку.
Дыхание (Breath): любая атака, происходящая из вашего рта – типа плевка или огненного дыхания. Вы должны стоять лицом к цели и рот ваш не должен быть заткнут.
Взгляд (Gaze): атаки, исходящие из глаз – обжигающий взор, взгляд василиска и пр. Вы должны видеть жертву своими глазами. 
Снаряд (Projectile). Любой снаряд или псевдо-твердый сгусток энергии (например, заклинание Огненного шара), пускаемый из рук. Также необходимо иметь хотя бы одну свободную (необязательно пустую) руку. 
Все виды специализации относятся друг к другу с -2.
Навык используется для попадания атаки в цель, но не для ее активации или воздействия.</description-loc>
		<specialization>Beam</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Innate Attack</name>
		<name-loc>Природная атака (Дыхание)</name-loc>
		<description-loc>Представляет тренированность в использовании дальнобойного природного оружия: огненного дыхания, энергетических шаров и т.д. Увеличивает шансы на попадание Воздействием, Связыванием, Природным оружием, Волшебными струями и снарядами, и подобными атаками. Необходима специализация:
Лучи (Beams): любой энергетический удар, струя и пр., излучаемая из рук. Вам необходимо иметь хотя бы одну свободную (не обязательно пустую) руку.
Дыхание (Breath): любая атака, происходящая из вашего рта – типа плевка или огненного дыхания. Вы должны стоять лицом к цели и рот ваш не должен быть заткнут.
Взгляд (Gaze): атаки, исходящие из глаз – обжигающий взор, взгляд василиска и пр. Вы должны видеть жертву своими глазами. 
Снаряд (Projectile). Любой снаряд или псевдо-твердый сгусток энергии (например, заклинание Огненного шара), пускаемый из рук. Также необходимо иметь хотя бы одну свободную (необязательно пустую) руку. 
Все виды специализации относятся друг к другу с -2.
Навык используется для попадания атаки в цель, но не для ее активации или воздействия.</description-loc>
		<specialization>Breath</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Innate Attack</name>
		<name-loc>Природная атака (Взгляд)</name-loc>
		<description-loc>Представляет тренированность в использовании дальнобойного природного оружия: огненного дыхания, энергетических шаров и т.д. Увеличивает шансы на попадание Воздействием, Связыванием, Природным оружием, Волшебными струями и снарядами, и подобными атаками. Необходима специализация:
Лучи (Beams): любой энергетический удар, струя и пр., излучаемая из рук. Вам необходимо иметь хотя бы одну свободную (не обязательно пустую) руку.
Дыхание (Breath): любая атака, происходящая из вашего рта – типа плевка или огненного дыхания. Вы должны стоять лицом к цели и рот ваш не должен быть заткнут.
Взгляд (Gaze): атаки, исходящие из глаз – обжигающий взор, взгляд василиска и пр. Вы должны видеть жертву своими глазами. 
Снаряд (Projectile). Любой снаряд или псевдо-твердый сгусток энергии (например, заклинание Огненного шара), пускаемый из рук. Также необходимо иметь хотя бы одну свободную (необязательно пустую) руку. 
Все виды специализации относятся друг к другу с -2.
Навык используется для попадания атаки в цель, но не для ее активации или воздействия.</description-loc>
		<specialization>Gaze</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Innate Attack</name>
		<name-loc>Природная атака (Снаряды)</name-loc>
		<description-loc>Представляет тренированность в использовании дальнобойного природного оружия: огненного дыхания, энергетических шаров и т.д. Увеличивает шансы на попадание Воздействием, Связыванием, Природным оружием, Волшебными струями и снарядами, и подобными атаками. Необходима специализация:
Лучи (Beams): любой энергетический удар, струя и пр., излучаемая из рук. Вам необходимо иметь хотя бы одну свободную (не обязательно пустую) руку.
Дыхание (Breath): любая атака, происходящая из вашего рта – типа плевка или огненного дыхания. Вы должны стоять лицом к цели и рот ваш не должен быть заткнут.
Взгляд (Gaze): атаки, исходящие из глаз – обжигающий взор, взгляд василиска и пр. Вы должны видеть жертву своими глазами. 
Снаряд (Projectile). Любой снаряд или псевдо-твердый сгусток энергии (например, заклинание Огненного шара), пускаемый из рук. Также необходимо иметь хотя бы одну свободную (необязательно пустую) руку. 
Все виды специализации относятся друг к другу с -2.
Навык используется для попадания атаки в цель, но не для ее активации или воздействия.</description-loc>
		<specialization>Projectile</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Intelligence Analysis</name>
		<name-loc>Анализ разведданных/ТУ</name-loc>
		<description-loc>Способность анализировать и интерпретировать данные разведки. Позволяет рассчитать вражеские планы и возможности, оценить точность информации и надежность источников, и т.д. В большинстве миров этому учат только в разведке, армии и службах безопасности. 
Мастер кидает бросок навыка тайно, при успехе он сообщает вам некоторые детали о значимости и точности данных, и возможные планы врага. При встрече с намеренной дезинформацией, Мастер тайно кидает состязание между вашим навыком против вражеского навыка дезинформации (подделка, пропаганда и т.д.). При вашей победе он сообщает вам неверные детали информации.
Этот навык не используется для собирания данных. Для публичных источников используются Свежие новости и Исследование, для физических улик – Судебная Экспертиза и Обыск; Наблюдение для человеческого поведения, и Работа с электроникой для работы со спутниковыми данными, данными радио-перехвата и прочих методов.
Вы можете взять необязательную специализацию на определенном типе разведки. Полезной специализацией на ТУ 6+ является Анализ Трафика – определение целей и организации путей сообщения с помощью изучения данных перехвата.
Модификаторы: от -1 до -5 за неполноту информации, -3, если вся информация поступила из одного источника, -3 за специализированные сведения, если вы не имеете соответствующих навыков.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B201</reference>
		<categories>
			<category>Military</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Strategy</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Interrogation</name>
		<name-loc>Допрос</name-loc>
		<description-loc>Это способность допрашивать пленного. Этому не учат нигде кроме разведки, полиции, тюрем, армии или преступного мира.
Чтобы допросить пленного, вы должны выиграть Состязание: ваш навык Допроса против Воли(Will) пленного. Мастер отыгрывает пленного (или, если пленный это вы, Мастер отыгрывает того, кто ведет допрос) и делает все броски кубиков секретно. Проверка на каждый вопрос занимает 5 минут времени; успешная проверка даст правдивый ответ на один вопрос. При проваленной проверке допрашиваемый будет молчать или солжет. Серьезный провал (на 5 или больше очков) означает, что вам хорошо, убедительно солгали! 
Модификаторы: +2 за длительный допрос (более двух часов); -5, если лояльность пленного по отношению к лидеру или к делу «Очень хорошая» или «Отличная»; +3 за применение серьезных угроз; +6 за применение пыток. 
Обратите внимание, что «пытки» не обязательно означают тиски и дыбу. Мучить пленного объектом его фобии (см. Фобии, B148) – это очень эффективная пытка, если он проваливает проверку Воли(Will), пытаясь преодолеть страх. Правдоподобная угроза в адрес близкого человека – это тоже пытка. Обратите также внимание, что пытки в отношение пленного обычно считаются подлостью и за ними наверняка последует расплата.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B202</reference>
		<categories>
			<category>Military</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Intimidation</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Psychology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Intimidation</name>
	<name-loc>Запугивание</name-loc>
	<difficulty>Will/A</difficulty>
	<points>1</points>
	<default>
		<type>will</type>
		<modifier>-5</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Acting</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Criminal/Street</category>
		<category>Police</category>
		<category>Social</category>
	</categories>
	<reference>B202</reference>
	<description-loc>Это умение убедить в чем-то кого-либо путем запугивания. Смысл его состоит в том, чтобы заставить жертву поверить, что вы можете и хотите, а возможно, даже стремитесь сделать с ней что-то очень нехорошее.
Умение запугивать может заменить бросок реакции в любой ситуации, хотя оно дает -3 при просьбе о помощи. Успешная проверка на запугивание дает Хорошую (но обычно не Дружественную) реакцию, проваленная - Плохую. При критическом успехе жертва должна сделать проверку Страха с -10!
Точный результат успешной проверки зависит от объекта воздействия. Честный гражданин, вероятно, будет сотрудничать, злясь или напустив на себя фальшивую радость. Бомж может вылизывать ваши ботинки (и даже стать искренне лояльным). А какой-нибудь крепкий качок может не испугаться, а заявить "Ты парень что надо!". Это решает и отыгрывает Мастер.
Если Запугивание используется против игрового персонажа (или, если захочет Мастер, против NPC), то также можно провести Состязание Запугивание против Воли(Will).
Особое запугивание: Если игрок выполнит проверки и Запугивания, и Заговаривания зубов, и хорошо все это отыграет, то он способен запугать кого-то, даже если ему нечем подкрепить свои слова. Это единственный способ запугать некоторых людей (Мастеров боевых искусств, правителей мира, агрессивных пьяниц). Успех при обеих проверках дает Очень Хорошую реакцию. Успех в одной и провал в другой дает Слабую реакцию. Провал обоих - Очень Плохую.
Запугивание группы. Вы можете пытаться запугать до 25 людей сразу, со штрафом -1 за каждые 5 людей (и долю). Множество «пугателей» может запугивать пропорционально больше людей. Штраф за количество людей делится на количество запугивающих. Состязание проводится по высшим навыкам Запугивания против высшего значения Воли(Will).
Учтите, что навык Допроса может по умолчанию равняться Запугиванию-3. Вы не сможете точно отличить правду ото лжи, но сможете заставить пленника говорить.
Модификаторы: +1..+4 за демонстрацию силы и кровожадности, при этом еще +1 за Безжалостность. +3 за Уродливую, +4 за Монструозную или Ужасающую внешность. -1..-4 за Застенчивость. Бросок бесстрашия соответственно модифицирует ваш бросок навыка.
Мастер может назначить бонус +1 за умный или пугающий диалог, но может дать и минусы, если подход нескладный или несоответствующий. Мастер может назначить любой минус, если игроки пытаются запугать кого-то, кого, по его мнению, просто нельзя напугать. Это, например, любой обладающий преимуществом Невозмутимый.</description-loc>
</skill>
	<skill version="2">
		<name>Invisibility Art</name>
		<name-loc>Искусство невидимости</name-loc>
		<description-loc>
Это невероятный навык, часто придаваемый ниндзя и другим Мастерам боевых искусств, дающий способность оставаться незамеченным, даже открыто стоя в поле зрения. Для активации требуется одна секунда концентрации. После этого, делается быстрое состязание по вашему Искусству Невидимости против броска Зрения для каждого персонажа, способного вас увидеть.
Наблюдатели должны получать штрафы за темноту к своему броску Зрения. Отвлеченный или занятый чем-то другим получает дополнительный штраф -3; намеренно осматривающий область – получает +3. Если кто-то заметил вас и поднял тревогу, показывая на вас – все, кто поверил, получают +3 на следующий бросок.
Если вы побеждаете в состязании, данная персона не может видеть вас в течение одной секунды, иначе – видит вас как обычно. С момента, как кто-то вас заметил, он не подвержен действию этого навыка, до тех пор, пока вы каким-либо образом не покинете его поле зрения (возможно, просто шагнув в затененный угол), после чего вы можете попытаться скрыться снова.
Этот навык вообще не действует в бою. В частности, если вы кого-то атакуете, то немедленно становитесь видимыми для всех!
Модификаторы: +3, если вы используете дымовую или световую гранату перед броском (кажется, что вы исчезли в клубе дыма). Ваше передвижение также модифицирует ваш бросок навыка: если вы спокойно стоите (Движение 0) – не получаете штрафов; -1, если вы медленно крадетесь (движение 1), -2, если вы быстро идете (Движение 2), или -5, если бежите (Движение 3 и больше). Если вы стоите совершенно неподвижно (требует броска Контроля дыхания или Медитации), то получаете +1.</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B202</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">stealth</name>
				<specialization compare="is"></specialization>
				<level compare="at least">14</level>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">hypnotism</name>
				<specialization compare="is"></specialization>
				<level compare="at least">14</level>
			</skill_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Jeweler</name>
		<name-loc>Ювелир/ТУ</name-loc>
		<description-loc>Это способность работать с драгоценным металлами всех видов, изготовлять драгоценности, инкрустировать оружие и так далее. Ювелир может распознать любой драгоценный металл или определить стоимость любой драгоценности, сделав проверку умения.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B203</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<specialization>Copper</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<specialization>Lead &amp; Tin</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Jitte/Sai</name>
		<name-loc>Дзитте/Сай</name-loc>
		<description-loc>Любой одноручный меч, имеющий зубцы для захвата вражеского оружия. Эти виды оружия созданы для обезоруживания, так что имеют премию +2 к состязанию для обезоруживания врага. Кроме того, если вы пытаетесь обезоружить врага на следующий ход после того, как успешно парировали его оружие, вы можете не бросать атаку по его оружию – переходите сразу к состязанию. Это действие считается за атаку. По умолчанию: силовой меч-4, дага-4, короткий меч -4.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Main-Gauche</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Judo</name>
	<name-loc>Дзюдо</name-loc>
	<notes>Позволяет парировать две атаки в раунд, каждую своей рукой.</notes>
	<difficulty>DX/H</difficulty>
	<points>1</points>
	<parry>0</parry>
	<encumbrance_penalty_multiplier>1</encumbrance_penalty_multiplier>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
	</categories>
	<reference>B203</reference>
	<description-loc>Этот навык отражает общее умение проводить голыми руками броски и захваты, а не специфическую школу рукопашного боя. Вы не можете использовать дзюдо, если держите что-либо в руках, или если ваша нагрузка больше Легкой. Используя дзюдо, вы можете парировать дважды в ход каждой рукой так, как если бы это было оружие, бросок парирования равен (Дзюдо/2)+3. Кроме того, при парировании во время отступления вы получаете дополнительный бонус (см. Отступление, с. B377). Вы не получаете штрафа -3 за парирование оружия голыми руками – это уменьшает ваши шансы получить ранение в бою с вооруженным врагом (см. парирование голыми руками, с.376).
В следующий ход после успешного парирования, вы можете попытаться бросить противника, если он находится в соседнем гексе. Это считается как атака, и требует броска навыка (если вы используете тотальную атаку (all-out attack), вы не можете сделать две попытки, но можете сделать одну с +4). Ваш враг может использовать любую активную защиту.
Когда вы бросаете противника, то он падает, куда вы захотите: в любые два смежных с вами гекса. Одним из этих гексов должен быть его, ваш или любой смежный с одним из них гекс. Противник должен сделать проверку HT; неудавшаяся проверка означает, что он оглушен! Если вы бросаете его в кого-то еще, то этот человек должен сделать проверку ST+3 или DX+3 (что лучше), чтобы избежать сбивания с ног. 
Кроме того, вы можете использовать свое умение Дзюдо вместо DX при любой проверке DX, сделанной в ходе Боя Вплотную, кроме проверок для поднятия оружия или бросания щита. Если вы хватаете врага, используя Дзюдо, и он провалил попытку освобождения – вы можете бросить его на следующий ход, как будто успешно парировали атаку.
Чтобы использовать навык Дзюдо, ваши руки должны быть свободными. Поскольку дзюдо сильно зависит от подвижности, вы получаете штраф, равный вашему уровню нагрузки.</description-loc>
</skill>
	<technique version="2" limit="0">
		<name>Jump Kick</name>
		<name-loc>Удар в прыжке</name-loc>
		<description-loc>Эта техника учит вас бить противника ногой в прыжке, увеличивая дальность действия и вред. Это краси-вый, но опасный прием! Для попадания делается бросок навыка техники. Дальность действия увеличивает-ся на один ярд, а повреждения - на +2. Ваша цель может парировать с -2. Однако, если вы промахиваетесь, или противник успешно защитился - вы должны немедленно сделать бросок DX-4 или Акробатики-2, иначе вы упадете!
Независимо от того, попали вы в цель или нет, вы получаете штраф -2 на все броски активной защиты до вашего следующего хода.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA75</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Jumping</name>
		<name-loc>Прыжки</name-loc>
		<description-loc>Отражает тренировку в прыжках. Попытка сложного прыжка – бросок против высшего значения из Прыжков или DX. Кроме того, вы можете использовать половину значения навыка Прыжков вместо Базового движения для расчета дальности прыжка. См. Прыжки, с. B352).</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B203</reference>
		<categories>
			<category>Athletic</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Karate</name>
		<name-loc>Каратэ</name-loc>
		<description-loc>Этот навык представляет общее умение натренированно бить рукой и ногой, а не специфическую школу рукопашного боя. Нет пенальти при использовании левой руки. Рука (руки), которую вы используете должна быть свободна (хотя вы можете использовать тяжелые перчатки и кастеты), и нагрузка дает штраф, равный уровню нагрузки. Вы не можете использовать Каратэ для использования природного оружия – для этого используется Драка, но вы можете использовать некоторые особые приемы.
Вы можете парировать дважды за ход, по одному разу каждой рукой так, как если бы это было оружие, используя (Навык/2)+3 в качестве защиты парированием. Если вы парируете оружие, парирование делается без штрафа -3, и вы получаете улучшенную премию к парированию, если парируете при отступлении (см. Отступление, с.377). 
При использовании для нападения, Каратэ увеличивает количество повреждений, наносимых вашим ударом без оружия. Делайте проверку Каратэ, чтобы попасть. (Если вы бьете ногой, делайте проверку Каратэ-2. Если вы промахнулись при ударе ногой, то сделайте проверку DX, чтобы удержаться на ногах.). 
Если вы тренированы на уровне DX, ваше базовое колющее повреждение увеличивается на +1 за кубик, при знании на уровне DX+1 – на +2 за кубик.
Парирование голой рукой удара все еще причиняет вам вред, если оно неудачно.</description-loc>
		<encumbrance_penalty_multiplier>1</encumbrance_penalty_multiplier>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B203</reference>
		<notes>Позволяет парировать две атаки в раунд, каждую своей рукой.</notes>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<weapon_bonus>
			<name compare="is">Karate</name>
			<specialization compare="is anything"></specialization>
			<level compare="at least">0</level>
			<amount per_level="yes">1</amount>
		</weapon_bonus>
		<weapon_bonus>
			<name compare="is">Karate</name>
			<specialization compare="is anything"></specialization>
			<level compare="at least">1</level>
			<amount per_level="yes">1</amount>
		</weapon_bonus>
	</skill>
	<skill version="2">
		<name>Kiai</name>
		<name-loc>Киай</name-loc>
		<description-loc>
Вы можете выбрасывать Ки мощным криком, который заставляет врагов замереть на месте. Это считается за атаку, и стоит 1 FP за попытку, независимо от успешности.
Используется быстрое состязание – навык Киай против Воли(Will) жертвы, с -1 за каждые два полных ярда дистанции до цели. Тугоухие сопротивляются с +1, глухие – с +2. В случае победы, жертва считается ментально оглушенной. 
Работает одновременно только против одного врага – услышать крик могут все, но ваша Ки сфокусирована на одном враге. Однако, успешный бросок навыка дает вам +2 на броски Допроса против всех услышавших.</description-loc>
		<difficulty>HT/H</difficulty>
		<points>1</points>
		<reference>B203</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="starts with">weapon master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<technique version="2" limit="0">
		<name>Kicking</name>
		<name-loc>Удар ногой</name-loc>
		<description-loc>Эта техника улучшает ваши удары ногами, что позволяет вам делать броски против этой техники. Удар ногой наносит Кол/туп вред, основанный на STЛ. Для определения премии к повреждениям используется основной навык, а не уровень владения техникой. Если вы промахнулись при ударе, вы должны сделать бросок Удара ногой или DX, чтобы не упасть.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA75</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Kicking</name>
		<name-loc>Удар ногой</name-loc>
		<description-loc>Эта техника улучшает ваши удары ногами, что позволяет вам делать броски против этой техники. Удар ногой наносит Кол/туп вред, основанный на STЛ. Для определения премии к повреждениям используется основной навык, а не уровень владения техникой. Если вы промахнулись при ударе, вы должны сделать бросок Удара ногой или DX, чтобы не упасть.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B231, MA75</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Knee Strike</name>
		<name-loc>Удар коленом</name-loc>
		<description-loc>Позволяет выкупить штраф -1 за удар коленом (см. Удар коленом, с. B404).</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B232, MA76</reference>
		<default>
			<type>Skill</type>
			<name>Brawling</name>
			<modifier>-1</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Knee Strike</name>
		<name-loc>Удар коленом</name-loc>
		<description-loc>Позволяет выкупить штраф -1 за удар коленом (см. Удар коленом, с. B404).</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-1</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Knife</name>
		<name-loc>Нож</name-loc>
		<description-loc>Любой клинок с лезвием длиной менее 1 фута – от карманного до тесака. Нож имеет очень небольшую парирующую поверхность, так что парирование ножом идет с -1. По умолчанию: Силовой меч-3, Дага-3, Короткий меч-3.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>-1</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Main-Gauche</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Knot-Tying</name>
		<name-loc>Вязание узлов</name-loc>
		<description-loc>Способность быстро и качественно вязать хорошие узлы. Успешный бросок навыка позволит сделать петлю, связать кого-либо и пр. Связанный этим навыком, должен победить в состязании, чтобы вырваться.
Модификаторы: ловкость рук.</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B203</reference>
		<categories>
			<category>Everyman</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Climbing</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Seamanship</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Kusari</name>
	<name-loc>Кусари</name-loc>
	<difficulty>DX/H</difficulty>
	<points>1</points>
	<parry after-attack="no">-2</parry>
	<default>
		<type>DX</type>
		<modifier>-6</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Force Whip</name>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Monowire Whip</name>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Whip</name>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Two-Handed Flail</name>
		<modifier>-4</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
	</categories>
	<reference>B209</reference>
	<description-loc>Использование цепи с грузилом. Кусари невозможно использовать в тесном пространстве. Можно использовать для захвата противника или обезоруживания. Готовится цепь по ходу за ярд длины. По умолчанию: Двуручный цеп-4.

Кнут – гибкое оружие, сделанное из отрезка цепи, кожи или шнура, и т.д. Кнут может иметь длину до 7 ярдов, но может бить только на максимальную дистанцию – кнутом длиной два ярда нельзя ударить на один ярд или вплотную; а также кнут долго готовится после атаки. Кнут захлестывается вокруг цели, что делает его превосходным обезоруживающим и опутывающим инструментом. Однако, недостаточная твердость затрудняет парирование кнутом: см. Особые правила по оружию ближнего боя, с. B404. Навыки в этой категории относятся друг к другу с -3.</description-loc>
</skill>
	<skill version="2">
		<name>Lance</name>
		<name-loc>Пика</name-loc>
		<description-loc>Способность использовать пику – оружие, похожее на копье 12 или более футов в длину, используемое верхом. В сражении на пиках обычное парирование не используется; человек, держащий пику, должен Блокировать или Уклоняться от вражеских ударов. По умолчанию: Копье-3, DX-6. Требование: Верховая Езда.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B204</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="starts with">riding</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spear</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Lasso</name>
		<name-loc>Лассо</name-loc>
		<description-loc>Это умение бросать лассо или аркан. Оно используется в основном для ловли животных. Подробные правила можно найти в параграфе Особые виды метательного оружия (с. B410).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B204</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Law</name>
		<name-loc>Право (@Специализация@)</name-loc>
		<description-loc>Отражает знания законов и юриспруденции. Успешная проверка позволит вам вспомнить, вывести или выяснить ответ на вопрос, касающийся права. Но помните, что немногие юридические вопросы имеют четкий ответ - даже совет эксперта будет уклончивым. 
Специализации необходима. Существует два типа специализаций:
* Определенный регион и область (канадская конституция, британское уголовное, договорное США)
* Определенная область, не привязанная к региону (католические обычаи, международное право)
Специализации в одном регионе или области относятся друг к другу с -4, при различии и по региону и области штраф будет -6 и хуже.
Успешная проверка Права может также требоваться, если вы (или ваш клиент) выступаете в суде – возможно, потребуется состязание по навыкам. Это зависит в значительной степени от правовой системы вашего игрового мира. В некоторых мирах быть юристом уже очень небезопасно...
Служители закона почти всегда имеют 1-2 очка в навыке Право (полиция) – отражает знания «правильной процедуры» ареста, обыска, допроса и пр.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B204</reference>
		<categories>
			<category>Business</category>
			<category>Police</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Leadership</name>
		<name-loc>Лидерство</name-loc>
		<description-loc>Это способность управлять действиями группы в стрессовой или боевой ситуации (Игровые персонажи могут сами решить, следовать ли вашим приказам!)
Вы можете попытаться взять на себя управление в бою, если тратите свой ход только на раздачу приказов и подбадривание. При успешном броске, все ваши союзники (включая PC), получают +1 на все броски Страха и боевого духа, а также броски самоконтроля для недостатков, ограничивающие боевую эффективность (Кровожадность, Неистовство, Трусость и т.п.). Критический успех даст премию +2. Премия длится до вашего следующего хода, после чего вы можете попытаться бросить Лидерство снова. Однако в группе может быть только один лидер! Если несколько человек пытаются прокинуть Лидерство, бонуса не получает никто!
Обратите внимание, что минимальный уровень Лидерства зачастую является требованием (prerequisite) для получения высокого Звания (c.B29).
Модификаторы: Премия за Харизму (с. B41), -3 за Нечувствительность (c.B142), от -1 до -4 за Застенчивость (с. B142). -5, если NPC никогда не действовали совместно с вами; -5, если вы подвергаете их опасности, которой сами избегаете; +5, если их лояльность к вам «Хорошая»; +10, если их лояльность «Очень хорошая». Если их лояльность «Отличная», то проверки вообще не требуется!</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B204</reference>
		<categories>
			<category>Military</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Leatherworking</name>
		<name-loc>Кожевник</name-loc>
		<description-loc>Это способность работать с кожей для изготовления поясов, седел, брони и т.д. Кожевник может создавать новые товары и ремонтировать старые. Сделав проверку умения, он может также определить стоимость изделий из кожи. Для создания более декоративных, чем практичных предметов, делается бросок, основанный на IQ.
Модификаторы: за снаряжение (с.345), +1 за уровень ловкости рук, или -3 за Неуклюжие руки (с. B138)</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Lifesaving</name>
		<name-loc>Спасение на воде</name-loc>
		<description-loc>Вы натренировались спасать утопающих, не получая положенного навыка в -5 за это. См. Спасение на воде (с. B355).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Swimming</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Athletic</category>
			<category>Outdoor/Exploration</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Lifting</name>
		<name-loc>Тяжелая атлетика</name-loc>
		<description-loc>Тренировка в использовании силы для поднятия тяжестей. Для каждого поднятия – новый бросок. В случае успеха Грузоподъемность (BL) увеличивается на 5% за каждое очко успешности. Не влияет на наносимый вред, уровни нагрузки.</description-loc>
		<difficulty>HT/A</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Athletic</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Light Walk</name>
		<name-loc>Легкий шаг</name-loc>
		<description-loc>
Этот навык позволяет вам оказывать крайне малое давление на поверхность при ходьбе. При успешном броске навыка вы не оставляете никаких видимых следов. Если преследователи ориентируются только на зрение, его бросок Следопыта немедленно будет провален; так, человек будет в замешательстве, но ищейка не получит вообще никакого штрафа.
Вы также можете попытаться пройти по хрупким и неустойчивым поверхностям, не упав. Максимальная скорость в таких обстоятельствах – 1/3 от нормальной (на усмотрение Мастера). Тонкий лед не наложит никаких штрафов на Легкий шаг, а лист рисовой бумаги потребует броска с -8!
Наконец, успешный бросок Легкого шага даст вам бонус к Скрытности, когда вы пытаетесь двигаться тихо. Этот бонус равен половине успешности броска (округляется вниз), но минимум +1.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<skill_prereq has="yes">
				<name compare="is">stealth</name>
				<specialization compare="is"></specialization>
				<level compare="at least">14</level>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">acrobatics</name>
				<specialization compare="is"></specialization>
				<level compare="at least">14</level>
			</skill_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Linguistics</name>
		<name-loc>Лингвистика</name-loc>
		<description-loc>Это наука о принципах построения языка. Лингвист может определить непонятный язык по короткому речевому или письменному отрывку, если выполнит проверку умения. Если вы облаете этим умением, то при изучении новых языков без учителя, вы каждый месяц можете кидать этот навык, и в случае успеха обучаться с полной скоростью, а не 25%.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Lip Reading</name>
		<name-loc>Чтение по губам</name-loc>
		<description-loc>Это способность видеть, что говорят другие. Вы должны находиться не дальше 20 футов либо использовать магию или бинокль, чтобы было видно как с такого расстояния. Каждая успешная проверка позволит вам разобрать одно предложение из разговора – если, конечно, вы знаете этот язык. Если человек подозревает, что вы способны читать по губам, то он может прикрыть рот или слабо артикулировать, делая чтение по губам невозможным. Критическая неудача при проверке на Чтение по губам – если наблюдаемый мог вас видеть – означает, что вы так открыто уставились, что были замечены! 
Модификаторы: Все модификаторы за Зрение (см. B358).</description-loc>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Spy</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-10</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Liquid Projector</name>
		<name-loc>Распылители/ТУ (@Класс оружия@)</name-loc>
		<description-loc>Это способность использовать оружие, выпускающую струю жидкости или газа. Бросок навыка необходим, чтобы попасть в цель. Для выполнения немедленного действия, чтобы избежать поломки оружия (например, заткнуть течь) бросается этот же навык, но основанный на IQ.

Вы должны специализироваться на типе оружия:

Огнемет (Flamethrower). Оружие, выпускающее горящую жидкость или газ. Это не включает плазменное оружие, часто называемое огнеметами.

Распылитель (Sprayer): выпускает газ или спрей (сонный, нервно-паралитический и т.д.), включая обычные спреи, используемые в качестве оружия.

Брызгалка (Squirt Gun): стреляет жидкостью или газом под небольшим давлением (скорость стрельбы – одна струя на каждое нажатие)
Водяная пушка (Water Cannon): оружие, испускающее долгую струю жидкости под высоким давлением (обычно, но не обязательно вода), вызывающую отдачу.
Эти специализации относятся друг к другу с -4. Оружие каждой специализации различается по ТУ, например Распылитель: огнемет имеет в виду Огнеметатель с греческим огнем на ТУ 4, а на ТУ 6 это ранцевый огнемет.
Модификаторы: все подходящие модификаторы дальнего боя. -2, если вы используете тяжелое оружие как переносное, -2 за незнание указанного типа, -4 за плохое состояние оружия.</description-loc>
		<specialization>@Weapon class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Liquid Projector</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Liquid Projector</name>
		<name-loc>Распылители/ТУ (Огнемет)</name-loc>
		<description-loc>Это способность использовать оружие, выпускающую струю жидкости или газа. Бросок навыка необходим, чтобы попасть в цель. Для выполнения немедленного действия, чтобы избежать поломки оружия (например, заткнуть течь) бросается этот же навык, но основанный на IQ.

Вы должны специализироваться на типе оружия:

Огнемет (Flamethrower). Оружие, выпускающее горящую жидкость или газ. Это не включает плазменное оружие, часто называемое огнеметами.

Распылитель (Sprayer): выпускает газ или спрей (сонный, нервно-паралитический и т.д.), включая обычные спреи, используемые в качестве оружия.

Брызгалка (Squirt Gun): стреляет жидкостью или газом под небольшим давлением (скорость стрельбы – одна струя на каждое нажатие)
Водяная пушка (Water Cannon): оружие, испускающее долгую струю жидкости под высоким давлением (обычно, но не обязательно вода), вызывающую отдачу.
Эти специализации относятся друг к другу с -4. Оружие каждой специализации различается по ТУ, например Распылитель: огнемет имеет в виду Огнеметатель с греческим огнем на ТУ 4, а на ТУ 6 это ранцевый огнемет.
Модификаторы: все подходящие модификаторы дальнего боя. -2, если вы используете тяжелое оружие как переносное, -2 за незнание указанного типа, -4 за плохое состояние оружия.</description-loc>
		<specialization>Flamethrower</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Liquid Projector</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Liquid Projector</name>
		<name-loc>Распылители/ТУ (Распылитель)</name-loc>
		<description-loc>Это способность использовать оружие, выпускающую струю жидкости или газа. Бросок навыка необходим, чтобы попасть в цель. Для выполнения немедленного действия, чтобы избежать поломки оружия (например, заткнуть течь) бросается этот же навык, но основанный на IQ.

Вы должны специализироваться на типе оружия:

Огнемет (Flamethrower). Оружие, выпускающее горящую жидкость или газ. Это не включает плазменное оружие, часто называемое огнеметами.

Распылитель (Sprayer): выпускает газ или спрей (сонный, нервно-паралитический и т.д.), включая обычные спреи, используемые в качестве оружия.

Брызгалка (Squirt Gun): стреляет жидкостью или газом под небольшим давлением (скорость стрельбы – одна струя на каждое нажатие)
Водяная пушка (Water Cannon): оружие, испускающее долгую струю жидкости под высоким давлением (обычно, но не обязательно вода), вызывающую отдачу.
Эти специализации относятся друг к другу с -4. Оружие каждой специализации различается по ТУ, например Распылитель: огнемет имеет в виду Огнеметатель с греческим огнем на ТУ 4, а на ТУ 6 это ранцевый огнемет.
Модификаторы: все подходящие модификаторы дальнего боя. -2, если вы используете тяжелое оружие как переносное, -2 за незнание указанного типа, -4 за плохое состояние оружия.</description-loc>
		<specialization>Sprayer</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Liquid Projector</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Liquid Projector</name>
		<name-loc>Распылители/ТУ (Брызгалка)</name-loc>
		<description-loc>Это способность использовать оружие, выпускающую струю жидкости или газа. Бросок навыка необходим, чтобы попасть в цель. Для выполнения немедленного действия, чтобы избежать поломки оружия (например, заткнуть течь) бросается этот же навык, но основанный на IQ.

Вы должны специализироваться на типе оружия:

Огнемет (Flamethrower). Оружие, выпускающее горящую жидкость или газ. Это не включает плазменное оружие, часто называемое огнеметами.

Распылитель (Sprayer): выпускает газ или спрей (сонный, нервно-паралитический и т.д.), включая обычные спреи, используемые в качестве оружия.

Брызгалка (Squirt Gun): стреляет жидкостью или газом под небольшим давлением (скорость стрельбы – одна струя на каждое нажатие)
Водяная пушка (Water Cannon): оружие, испускающее долгую струю жидкости под высоким давлением (обычно, но не обязательно вода), вызывающую отдачу.
Эти специализации относятся друг к другу с -4. Оружие каждой специализации различается по ТУ, например Распылитель: огнемет имеет в виду Огнеметатель с греческим огнем на ТУ 4, а на ТУ 6 это ранцевый огнемет.
Модификаторы: все подходящие модификаторы дальнего боя. -2, если вы используете тяжелое оружие как переносное, -2 за незнание указанного типа, -4 за плохое состояние оружия.</description-loc>
		<specialization>Squirt Gun</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Liquid Projector</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Liquid Projector</name>
		<name-loc>Распылители/ТУ (Водяная пушка)</name-loc>
		<description-loc>Это способность использовать оружие, выпускающую струю жидкости или газа. Бросок навыка необходим, чтобы попасть в цель. Для выполнения немедленного действия, чтобы избежать поломки оружия (например, заткнуть течь) бросается этот же навык, но основанный на IQ.

Вы должны специализироваться на типе оружия:

Огнемет (Flamethrower). Оружие, выпускающее горящую жидкость или газ. Это не включает плазменное оружие, часто называемое огнеметами.

Распылитель (Sprayer): выпускает газ или спрей (сонный, нервно-паралитический и т.д.), включая обычные спреи, используемые в качестве оружия.

Брызгалка (Squirt Gun): стреляет жидкостью или газом под небольшим давлением (скорость стрельбы – одна струя на каждое нажатие)
Водяная пушка (Water Cannon): оружие, испускающее долгую струю жидкости под высоким давлением (обычно, но не обязательно вода), вызывающую отдачу.
Эти специализации относятся друг к другу с -4. Оружие каждой специализации различается по ТУ, например Распылитель: огнемет имеет в виду Огнеметатель с греческим огнем на ТУ 4, а на ТУ 6 это ранцевый огнемет.
Модификаторы: все подходящие модификаторы дальнего боя. -2, если вы используете тяжелое оружие как переносное, -2 за незнание указанного типа, -4 за плохое состояние оружия.</description-loc>
		<specialization>Water Cannon</specialization>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Liquid Projector</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Literature</name>
		<name-loc>Литература</name-loc>
		<description-loc>Эта наука изучает великие памятники письменности. Студент-литературовед будет знаком со старинной поэзией, пыльными томами классики, с философией, критикой и т.д. Она может быть полезной при поиске упоминаний о тайных сокровищах, затонувших землях, Вещах, о которых человек не должен знать и другой подобной информации. Текст должен быть доступен на знакомом вам языке. 
Модификаторы: -5, если вы неграмотны (устный фольклор).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B205</reference>
		<categories>
			<category>Scholarly</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Lockpicking</name>
		<name-loc>Взлом/ТУ</name-loc>
		<description-loc>Это способность отпирать замки, не располагая ключом или кодом. Каждая попытка открыть замок требует одной минуты; если вы выполнили проверку и открыли замок, то каждое очко, на которое вы преуспели, уменьшает потраченное время на пять секунд. (Подвал, сейф или иной сложный замок может потребовать больше времени по решению Мастера.) Обратите внимание, что если замок снабжен ловушкой или сигнализацией, то требуется отдельная проверка на Ловушки, чтобы обойти ее. 
Модификаторы: модификаторы за снаряжение; -5 за темноту (работа на ощупь); Информация о внутреннем устройстве замка дает бонус на усмотрение Мастера. Также применяются модификаторы за ловкость рук, если Мастер требует броска, основанного на DX.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B206</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
			<category>Spy</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Machinist</name>
		<name-loc>Слесарь/ТУ</name-loc>
		<description-loc>Это навык создания и модификации механических частей и инструментов. Успешный бросок навыка позволит вам создать запчасть, инструмент для использования с другим навыком (например, Оружейник или Взлом), или изменить любое простое механическое устройство, не попадающее под другие навыки. Мастер может потребовать от изобретателя несколько бросков навыку, прежде чем тот сможет бросить Инженерию для сборки устройства.
Доступные технологии и материалы отличаются на разных ТУ. Ремесленник на ТУ 5 может работать с видимыми деталями из бронзы и стали, на ТУ 10 – с углеродными нанотрубками.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B206</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Main-Gauche</name>
		<name-loc>Дага</name-loc>
		<description-loc>Любое оружие, нормально используемое с навыком Нож или Дзитте/Сай, используемое левой рукой. С этим навыком вы игнорируете штраф за использование левой руки при парировании ею (но не на атаку, она все равно идет с -4), и -1 за парирование ножом. Использование ножа основным оружием – навык Нож. По умолчанию: Дзитте/Сай -4, Нож-4.

Будучи вооруженным фехтовальным оружием, вы получаете улучшенную премию за отступление при парировании (с. B377). 
Вы также получаете половинный штраф за повторные попытки парирования одной и той же рукой в течение одного хода (см. Парирование, с. B376).
Обратите внимание, что все фехтовальное оружие легкое, и часто ломается при парировании тяжелого оружия. Им вообще нельзя парировать цепы! Для нормального боя этим оружием вы должны быть достаточно подвижны – на все броски атаки и парирования вы получаете штраф, равный уровню нагрузки.

Навыки в пределах этой категории относятся друг к другу с -3. Они также могут относится к навыкам Мечей, как указано ниже.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Makeup</name>
		<name-loc>Грим/ТУ</name-loc>
		<description-loc>Это навык использования театрального грима для изменения внешности артиста. Это не только способность улучшать внешность – вы также можете изменять возраст, расу или национальность. На ТУ6+ вы можете использовать протезы. Однако, изменить рост этим навыком невозможно.
Использование для улучшения внешности, возможно, даст премию к реакции от противоположного пола (успешность броска /5).</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B206</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Disguise</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Market Analysis</name>
		<name-loc>Анализ рынка</name-loc>
		<description-loc>Способность делать краткосрочные прогнозы изменения рыночной ситуации - обычно для заработка. Главный заработок профессиональных торговцев. Бросок навыка нужен для определения текущих тенденций. На критическом успехе вы также узнаете краткий прогноз.
Модификаторы: за таланты Бизнесмен (Business Acumen) и Математические способности.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Business</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Economics</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Masonry</name>
		<name-loc>Каменщик</name-loc>
		<description-loc>Способность создавать предметы и постройки из кирпича и камня.
Модификаторы: за снаряжение; -3 за простую инженерную задачу (требующую заметной доли творчества и разработки).</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Прикладная)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Applied</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physics</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Компьютер)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Computer Science</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Computer Programming</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Криптология)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Cryptology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Cryptography</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Чистая)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Pure</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Чистая @со специализацией@)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Pure: @Optional specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Статистика)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Statistics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mathematics</name>
		<name-loc>Математика/ТУ (Геодезия)</name-loc>
		<description-loc>Наука о числах и величинах, их атрибутах и связях, с использованием чисел и символов. В игре математик может, сделав проверку, ответить на вопрос, как-либо касающийся математики. Если задача касается легких вычислений, то Мастер может назначить модификатор за ее простоту (или сложность). Необходима специализация.

Прикладная (Applied) Область математики, непосредственно взаимодействующая с физическими и инженерными задачами, математическими моделями поведения подобных систем. По умолчанию: Инженерия-5, Физика-5.

Компьютер (Computer Science) Теоретические сведения о структуре наборов данных. Не дает навыка использования компьютеров. По умолчанию: Программирование-5.

Криптология (Cryptology) Математическая наука о кодах и шифрах. Криптолог знает теорию шифровальных схем, как они развивались исторически и понимает, почему одни схемы эффективнее других. По умолчанию: Криптография-5.

Чистая (Pure). Общая наука о числах и величинах. Используется для любого броска, который не относится к другим специализациям. Имеет дюжины подтипов, но разница между ними вряд ли повлияет на игру.

Статистика (Statistics). Наука анализа и сбора данных для вычисления возможностей, моделирования и прогнозирования.
Геодезия (Surveying). Специализированная ветвь математики, которая учит определять площадь участка земной поверхности, определять ее границы и контур, а также аккуратно наносить все это на бумагу. По умолчанию: Картография-3, Навигация-4.
Специальности зависят друг от друга с -5.</description-loc>
		<specialization>Surveying</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Natural Science</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Cartography</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (@Тип механизма@)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>@Machine class@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Aerospace</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Аэрокосмические)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Aerospace</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Aerospace</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Антиматерия)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Antimatter Reactor</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Antimatter Reactor</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Автожир)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Autogyro</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Autogyro</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Автомобили)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Automobile</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Automobile</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Часовщик )</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Clockwork</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B107</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Clockwork</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Строительная техника)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Construction Equipment</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Construction Equipment</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Антиграв)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Contragravity</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Contragravity</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Дизель)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Diesel Engine</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Diesel Engine</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Раектор распада)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Fission Reactor</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Fission Reactor</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Ракетный ранец)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Flight Pack</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Flight Pack</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Легкие подводные лодки)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Free-Flooding Sub</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Free-Flooding Sub</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Энергоячейки)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Fuel Cell</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Fuel Cell</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Фузионный)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Fusion Reactor</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Fusion Reactor</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Газотурбинный)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Gas Turbine</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Gas Turbine</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Бензиновый)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Gasoline Engine</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Gasoline Engine</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Планеры)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Glider</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Glider</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Полугусеничные)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Halftrack</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Halftrack</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Тяжелые самолеты)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Heavy Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Heavy Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Тяжелые автомобили)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Heavy Wheeled</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Heavy Wheeled</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Вертолеты)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Helicopter</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Helicopter</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Скоростные самолеты)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>High-Performance Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Скоростные космические суда)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>High-Performance Spacecraft</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>High-Performance Spacecraft</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Воздушная подушка)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Hovercraft</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Hovercraft</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Крупные подводные лодки)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Large Sub</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Large Sub</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (ножной привод)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Legged Drive</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Legged Drive</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Легкие самолеты)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Light Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Light Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Ворздушные шары)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Lighter-Than-Air</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Lighter-Than-Air</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Световые паруса)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Lightsail</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Lightsail</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (?)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Low-G Wings</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Low-G Wings</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Легкие космические суда)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Low-Performance Spacecraft</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Low-Performance Spacecraft</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Мех)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Mecha</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Mecha</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Микромашины)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Micromachines</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Micromachines</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Мини подводные лодки)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Mini-Sub</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Mini-Sub</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Мотоциклы)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Motorcycle</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Motorcycle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Наномашины)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Nanomachines</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Nanomachines</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Беотдачные двигателя)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Reactionless Thrusters</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Reactionless Thrusters</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Робототехника)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Robotics</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Robotics</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Ракетные установки)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Rockets</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Rockets</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>0</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Паравые двигателя)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Steam Engine</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Steam Engine</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Гусеничный привод)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Tracked Drive</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Tracked Drive</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Гусеничный транспорт)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Tracked Vehicle</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Tracked Vehicle</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Сверхлегкие)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Ultralight</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Ultralight</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Вертокрыл)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Vertol</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Vertol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mechanic</name>
		<name-loc>Механик/ТУ (Колесный привод)</name-loc>
		<description-loc>Это способность определить и исправить обычные механические проблемы – обычно, но не всегда, в двигателе транспортного средства. Требуется специализация, некоторые виды которой включают:

Тип механизма (Machine Type): Любой один класс нетранспортного механизма. Типы включают микромашины (невидимые невооруженным глазом, ТУ 9+), наномеханизмы (ТУ 10+) и робототехнику (роботы и автоматические линии, ТУ 7+).

Тип движителя (Motive System). Любой один тип движителя, независимо от вида транспорта. Типы включают Ноги, Гусеницы, Колеса, Ракеты, reactionless thrasters.

Тип Энергоснабжения. Любой один тип энергоустройства, независимо от того, что он питает. Типы включают Заводной, Паровой, Бензиновый, Дизельный, Газотурбинный, Ядерный, Антиматерийный, Аккумуляторный, Fission и др.
Тип транспорта. Управление, корпус, движитель, энергия, трансмиссия и даже дизайн одного типа транспорта, попадающего под транспортные навыки – типа Вождения, Пилотирования или Подводных лодок.
Специализации механии между собой относятся с -4, хотя Мастер может модифицировать это значение за особенно близкое или дальнее родство. Системы, включаемые в каждую специализацию, различаются с каждым ТУ. Например, Механика (легкие самолеты) включают одномоторные бипланы на раннем ТУ 6, частные реактивные самолеты на ТУ 7, и так далее.
Знакомство критически важно. Штрафы получаются по -2 за незнакомый тип (пропеллерный и реактивный самолет), -2 за незнакомое применение (морской и обычный самолет), и так далее.  Также действуют модификаторы за наличие снаряжения.</description-loc>
		<specialization>Wheeled Drive</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Repair/Maintainance</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Engineer</name>
			<specialization>Wheeled Drive</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Machinist</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mechanic</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meditation</name>
		<name-loc>Медитация</name-loc>
		<description-loc>Это навык успокаивания эмоций, контроля мыслей и расслабления тела. Для использования, вы должны концентрироваться в течение (20-навык) секунд (минимум 1 секунду), и затем сделать бросок навыка. При успешном броске вы входите в трансоподобное состояние, которое можете поддерживать часами.
Медитативный транс необходим для некоторых ритуалов, и является обычной подготовкой к молитве. Кроме того, Мастер может позволить вам медитировать на определенную моральную проблему; при успешном броске Мастер «просветлит» вас, дав подсказку о верном выборе.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B207</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<default>
			<type>Will</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Autohypnosis</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mental Strength</name>
		<name-loc>Ментальная сила</name-loc>
		<description-loc>
* с разрешения Мастера, маги и псионики также могут изучать этот навык.
Вы можете сознательно фокусировать свой разум, сопротивляясь ментальным атакам. Этот навык может заменить бросок Воли(Will) в целях сопротивления ментальному воздействию. Не заменяет большинства обычных бросков Воли(Will). Не работает, если вы оглушены, спите или потеряли сознание – для этого есть преимущество Ментальный щит.</description-loc>
		<difficulty>Will/E</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="starts with">weapon master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Merchant</name>
		<name-loc>Торговое дело</name-loc>
		<description-loc>Это способность выступать в роли торговца, покупая и продавая товары. Сюда входит умение преподнести товар, практические знания о торговле и психология. При успешной проверке Торговец может помимо прочего: судить о цене любого распространенного товара в своем обществе; найти, где выгодно продаются или покупаются товары; выяснить справедливую рыночную стоимость любого товара и т.д. 
Торговец может выбрать необязательную специализацию в определенном виде товаров. 
Когда двое торгуются, то Мастер может быстро рассудить их, проведя Состязание умений. Победитель добавляет или вычитает 10% из справедливой цены товара, в зависимости от того, пытался ли он его купить или продать.
Персонаж, обладающий этим умением на любом уровне, получает +1 к броскам на реакцию при покупке или продаже чего-либо. Персонаж, располагающий данным умением на уровне эксперта – 20 или выше – получает +2.
Модификаторы: -3 за Доверчивость (c.B137), -3 за Нечувствительность (с. B142), -1..-4 за Застенчивость (c.B154). Если товар нелегален, то Торговец получает пенальти –3, если у него нет Знания улиц 12+ либо специализации в подобных товарах. В незнакомой местности торговец будет получать пенальти (от -2 до -6 по решению Мастера), пока не освоится с местными обычаями и ценами.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Business</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Finance</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Market Analysis</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Metallurgy</name>
		<name-loc>Металлургия/ТУ</name-loc>
		<description-loc>Это наука о металлах и их свойствах. Металлург может определить металлы или сплавы, а также решать проблемы, связанные с металлами, их применением, добычей или очисткой.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Chemistry</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jeweler</name>
			<modifier>-8</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<modifier>-8</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (@Тип планеты@)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>@Planet type@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Землеподобные планеты)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Earthlike</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Газовые гиганты)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Gas Giants</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Агрессивные миры)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Hostile Terrestrial</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Леядные карлики)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Ice Dwarfs</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Ледяные планеты)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Ice Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Meteorology</name>
		<name-loc>Метеорология/ТУ (Скалистые планеты)</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<specialization>Rock Worlds</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mimicry</name>
		<name-loc>Подражание голосам (Животные)</name-loc>
		<description-loc>Это способность имитировать голоса. Преимущество Голос (c.B97) дает +2 к навыку. Специализация необходима.

Животные (Animals). Позволяет имитировать рев, вой, кваканье и прочие звуки, издаваемые животными. Вы можете подражать только животным, которые издают некоторые отличительные звуки. Для привлечения особей того вида, который вы имитируете (и, возможно, хищников, которые на таких животных охотятся) – сделайте бросок навыка. Чтобы обмануть других людей, необходимо выиграть в состязании Подражания против Натуралиста (Naturalist) -3 или Восприятия(Per)-6. по умолчанию – Натуралист-6.

Птицы (Birds): Позволяет воспроизводить свист, чириканье и другие звуки, издаваемые птицами. Работает также, как и подражание животным звукам. По умолчанию – Натуралист-6.
Речь (Speech): Имитация голоса. Не дает знания другого языка, но вы, по крайней мере, можете воспроизвести слова. Бросок на имитацию конкретного человека делается с -3. Если вы пытаетесь надуть человека, близко знакомого с имитируемым, требуется выиграть состязание по IQ. По умолчанию: Артистизм-6 или Лингвистика-4.
Если у вас есть преимущество Подражание звукам (с.B68), вам не надо изучать этот навык.</description-loc>
		<specialization>Animal Sounds</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Animal</category>
			<category>Arts/Entertainment</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mimicry</name>
			<specialization>Bird Calls</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mimicry</name>
		<name-loc>Подражание голосам (Птицы)</name-loc>
		<description-loc>Это способность имитировать голоса. Преимущество Голос (c.B97) дает +2 к навыку. Специализация необходима.

Животные (Animals). Позволяет имитировать рев, вой, кваканье и прочие звуки, издаваемые животными. Вы можете подражать только животным, которые издают некоторые отличительные звуки. Для привлечения особей того вида, который вы имитируете (и, возможно, хищников, которые на таких животных охотятся) – сделайте бросок навыка. Чтобы обмануть других людей, необходимо выиграть в состязании Подражания против Натуралиста (Naturalist) -3 или Восприятия(Per)-6. по умолчанию – Натуралист-6.

Птицы (Birds): Позволяет воспроизводить свист, чириканье и другие звуки, издаваемые птицами. Работает также, как и подражание животным звукам. По умолчанию – Натуралист-6.
Речь (Speech): Имитация голоса. Не дает знания другого языка, но вы, по крайней мере, можете воспроизвести слова. Бросок на имитацию конкретного человека делается с -3. Если вы пытаетесь надуть человека, близко знакомого с имитируемым, требуется выиграть состязание по IQ. По умолчанию: Артистизм-6 или Лингвистика-4.
Если у вас есть преимущество Подражание звукам (с.B68), вам не надо изучать этот навык.</description-loc>
		<specialization>Bird Calls</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Animal</category>
			<category>Arts/Entertainment</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mimicry</name>
			<specialization>Animal Sounds</specialization>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Mimicry</name>
		<name-loc>Подражание голосам (Речь)</name-loc>
		<description-loc>Это способность имитировать голоса. Преимущество Голос (c.B97) дает +2 к навыку. Специализация необходима.

Животные (Animals). Позволяет имитировать рев, вой, кваканье и прочие звуки, издаваемые животными. Вы можете подражать только животным, которые издают некоторые отличительные звуки. Для привлечения особей того вида, который вы имитируете (и, возможно, хищников, которые на таких животных охотятся) – сделайте бросок навыка. Чтобы обмануть других людей, необходимо выиграть в состязании Подражания против Натуралиста (Naturalist) -3 или Восприятия(Per)-6. по умолчанию – Натуралист-6.

Птицы (Birds): Позволяет воспроизводить свист, чириканье и другие звуки, издаваемые птицами. Работает также, как и подражание животным звукам. По умолчанию – Натуралист-6.
Речь (Speech): Имитация голоса. Не дает знания другого языка, но вы, по крайней мере, можете воспроизвести слова. Бросок на имитацию конкретного человека делается с -3. Если вы пытаетесь надуть человека, близко знакомого с имитируемым, требуется выиграть состязание по IQ. По умолчанию: Артистизм-6 или Лингвистика-4.
Если у вас есть преимущество Подражание звукам (с.B68), вам не надо изучать этот навык.</description-loc>
		<specialization>Speech</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Mind Block</name>
		<name-loc>Ментальный блок</name-loc>
		<description-loc>Умение не требует наличия пси-способностей. Ментальный блок – это способность создать непсионическую ментальную преграду, не дающую псионикам и магам воспринимать ваши мысли и эмоции.
Примером ментального блока могут являться производимые в уме сложные математические вычисления или непрерывное чтение стихов. 
Новая проверка требуется каждую минуту, когда человек ничего не делает, или каждый ход в бою или в стрессовой ситуации (например, кто-то очень старается не думать о чем-то, что его сильно беспокоит).
Если используется данное умение, проводите Состязание в умениях Ментальный блок и способности Чтение мыслей. Оно отдельно от остальных проверок, требуемых, чтобы заставить работать Чтение мыслей или прорваться сквозь Ментальный Щит. Если объект выигрывает, то шпик не увидит ничего, кроме стихов или таблицы умножения. Если он проигрывает, то блок не удался. В случае вашего провала успешное Чтение мыслей позволит увидеть мысли частично или целиком.
Если пытающийся поставить Ментальный блок терпит критическую неудачу, то он думает об этом в подробностях – на самом видном участке сознания!
Ментальный блок помогает только против чтения мыслей и эмоций – но не против ментальных атак и попыток захвата. Если вы имеете сверхъестественную защиту разума (Ментальный щит), Ментальный блок вступает в дело последним, когда все остальные защиты пробиты.
Модификаторы. Если человек не делает ничего другого, кроме как концентрируется на блокировании, он получает бонус +2. Ментально или физически оглушенный человек получает –3 к проверке. Проверки при попытке спрятать не мысли, а эмоции сложнее, и они выполняются с пенальти –2 или больше, в зависимости от того, насколько сильными Мастер считает эмоции. Мастер может наложить дополнительные минусы за иные обстоятельства, например, при попытке скрыть эмоции, подбираясь к жутко ненавистному врагу.</description-loc>
		<difficulty>Will/A</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<default>
			<type>Will</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Meditation</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Monowire Whip</name>
		<name-loc>Кнут мономолекулярный</name-loc>
		<description-loc>Кнут, сделанный из отрезка мономолекулярной нити с грузилом, присоединенной к рукоятке. Он очень опасен - любой провал, означающий выпадение оружия, ранит кого-то из своих.

Кнут – гибкое оружие, сделанное из отрезка цепи, кожи или шнура, и т.д. Кнут может иметь длину до 7 ярдов, но может бить только на максимальную дистанцию – кнутом длиной два ярда нельзя ударить на один ярд или вплотную; а также кнут долго готовится после атаки. Кнут захлестывается вокруг цели, что делает его превосходным обезоруживающим и опутывающим инструментом. Однако, недостаточная твердость затрудняет парирование кнутом: см. Особые правила по оружию ближнего боя, с. B404. Навыки в этой категории относятся друг к другу с -3.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<parry after-attack="no">-2</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Whip</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Kusari</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Whip</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<technique version="2">
		<name>Motion-Picture Camera</name>
		<name-loc>Кинокамера</name-loc>
		<description-loc>Эта техника распространена среди профессиональных операторов, позволяет снизить базовый штраф -3 за использование кинокамеры с навыком Фотографирование.
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Photography</name>
			<modifier>-3</modifier>
		</default>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Spy</category>
			<category>Technical</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Mount</name>
		<name-loc>Скакун</name-loc>
		<description-loc>Тренировка в способности служить верховым животным. Если навык верхового животного выше навыка верховой езды седока, он может использовать среднее значение этих двух навыков (округлять вверх). Всадник получает не менее +1, если у коня есть хотя бы одно очко в навыке Скакуна. Чтобы сбросить нежелательного седока – бросается быстрое состязание по навыкам верховой езды против скакуна.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Animal</category>
			<category>Athletic</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Musical Composition</name>
		<name-loc>Композитор</name-loc>
		<description-loc>Это способность создавать приятную музыку. 
Для составления музыки для ансамбля или оркестра без дирижера, вы должны иметь навык IQ по крайней мере в одном инструменте, и IQ-2 во всех остальных. Каждая инструментальная группа после первой, используемая в композиции дает кумулятивный штраф -1 (например саксофон + барабаны + бас – штраф -2).
Если есть дирижер, вы должны иметь навык Дирижирования (Conducting, c.B198) на уровне IQ. Кидайте с -1 за каждый общий класс инструментов после первого (духовые, струнные, ударные и пр. При этом хор, арфы, орган и т.п. формируют каждый свой собственный класс).
Навык также включает способность читать, писать и переписывать музыку в принятой нотной системе. Разные системы и музыкальные традиции считаются как знакомство (с. B169).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Musical Instrument</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Poetry</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Musical Influence</name>
		<name-loc>Воздействие музыкой</name-loc>
		<description-loc>
Этот киношный навык позволяет вам воздействовать на эмоции других пением или игрой. Это может представлять магию, псионику или даже особую форму гипноза, и работает с любым инструментом или голосом – даже магическим или ультра-технологичным.
Вы должны сначала прокинуть бросок навыка игры или пения при внимательной аудитории, затем делается бросок воздействия. В случае успеха вы можете модифицировать бросок реакции аудитории к вам или любому присутствующему – в лучшую или худшую сторону, на количество, равное успешности броска (не более +-3, или +-4 для критического успеха).
Если у вас есть лишь несколько секунд, или аудитория слушает невнимательно, лучше, чем на +-1 не получится никак, даже в случае критического успеха.
Нежелающие подвергаться воздействию сопротивляются по Воле(Will). Тугоухость (c.B138) дает +4 к броску сопротивления, Глухота (c.B129)– полный иммунитет. Однако, некоторые фантастические устройства генерируют вибрацию и воздействуют на тело – в этом случае глухота не помогает.
Воздействует ли навык на животных – целиком на усмотрение Мастера.</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B210</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<skill_prereq has="yes">
					<name compare="is">singing</name>
					<specialization compare="is anything"></specialization>
					<level compare="at least">12</level>
				</skill_prereq>
				<skill_prereq has="yes">
					<name compare="starts with">musical instrument</name>
					<specialization compare="is anything"></specialization>
					<level compare="at least">12</level>
				</skill_prereq>
			</prereq_list>
			<advantage_prereq has="yes">
				<name compare="is">Talent (Musical Ability)</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Musical Instrument</name>
		<name-loc>Музыкальный Инструмент (@Специализация@)</name-loc>
		<description-loc>Это способность играть на определенном музыкальном инструменте. Использование умения позволить вам удачно сыграть на данном инструменте. Делайте проверку умения при каждом новом исполнении.
В этом навыке обязательна специализация. Значения по умолчанию различаются от -3 для похожих инструментов до полного отсутствия для сильно различающихся (Арфа и Барабаны).
Также включает умение читать нотные записи в принятой в вашей культуре системе (если таковая имеется). Различные системы считаются за знакомство (с. B169).</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (@Тип планеты@)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>@Planet type@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Землеподобные планеты)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Earthlike</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Газовые гиганты)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Gas Giants</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Агрессивные миры)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Hostile Terrestrial</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Леядные карлики)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Ice Dwarfs</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Ледяные планеты)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Ice Worlds</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Naturalist</name>
		<name-loc>Натуралист (Скалистые планеты)</name-loc>
		<description-loc>Это умение характеризует практическое знание животных и растений, и вообще природы во всех ее проявлениях. Включает понемногу знаний из множества наук (биология для определения свойств растений или привычек животного, Геология для нахождения пещер для укрытия, Метеорология для определения погоды и пр.), заменяя их в данных отношениях. Удачная проверка умения позволит  вам определить растение и его свойства или вспомнить какие-то особенности животного или его привычки. 
Вы должны специализироваться по определенной планете, планеты одинаковых типов относятся друг к другу с -4.</description-loc>
		<specialization>Rock Worlds</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Animal</category>
			<category>Natural Science</category>
			<category>Outdoor/Exploration</category>
			<category>Plant</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (@Где@)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>@Environment@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Astronomy</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Land</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Sea</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (Воздушная)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>Air</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Astronomy</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Land</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Sea</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (Гиперпространство)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>Hyperspace</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Astronomy</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Applied</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Space</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (Наземная)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>Land</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Cartography</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Surveying</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Air</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Sea</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (Морская)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>Sea</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Astronomy</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Seamanship</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Air</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Land</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Navigation</name>
		<name-loc>Навигация/ТУ (Космическая)</name-loc>
		<description-loc>Это способность определять свое местонахождение с помощью внимательного наблюдения за окружающей средой и инструментов. Удачная проверка умения означает, что вы узнали, где находитесь (будь то на земле или на море). Специализация необходима.

Морская (Naval): навигация по течениям и звездам. По умолчанию: Астрономия-5, Моряк-5.

Воздушная (Air): Навигация по звездам и ландшафту внизу. По умолчанию: Астрономия-5.

Наземная (Land): навигация по звездам и ориентирам (также называется Ориентирование). По умолчанию: IQ-5, картография-4, математика (геология)-4.

Космическая (Space): навигация в обычном межпланетном и межзвездном пространстве, обычно при скоростях ниже световой. По умолчанию: Астрономия-4 или Математика (прикладная)-4.
Гиперпространство (Hyperspace, Astrogation): Также называется «Астронавигация». Похожа на космическую, но используется при путешествиях в гиперпространстве или во время гипер-прыжков. В мирах с наличием нескольких видов сверхсветовых двигателей, возможно потребуется специализация еще и по типу двигателя. По умолчанию: Астрономия-4, математика (прикладная)-4.
Воздушная, земная и морская навигация относятся друг к другу с -2. космическая и гиперпространственная – с -5. между этими двумя группами не может быть уровня по умолчанию.
Модификаторы: -1..-10 за незнакомую область (на усмотрение Мастера), модификаторы за снаряжение.</description-loc>
		<specialization>Space</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Astronomy</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Mathematics</name>
			<specialization>Applied</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Navigation</name>
			<specialization>Hyperspace</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>NBC Suit</name>
		<name-loc>Защитный костюм/ТУ</name-loc>
		<description-loc>Это тренировка в использовании определенных защитных костюмов. Костюмы, созданные для защиты владельца от опасностей боя или окружающей среды часто имеют встроенные устройства (типа автошприцов и сенсоров) и приборы для поддержки жизнедеятельности. Некоторые костюмы даже содержат сервоприводы для увеличения ST и скорости. В результате вы не просто носите этот костюм – вы управляете им. Навык позволяет быстро одеть и снять скафандр (успешный бросок – половина времени). Для активации определенной суб-системы костюма или работы в костюме хорошем состоянии кидается бросок по IQ. В то время, когда на вас надет костюм, любой из бросков DX и навыков, на DX основанных вы кидаете против низшего значения из Скафандра и того навыка. Например, если у вас DX 14, Скрытность 15 и Скафандр 13 – вы работаете, как с DX 13 и Скрытностью 13, пока не снимете скафандр. Особенно неудобные и громоздкие костюмы будут давать штрафы к DX независимо от уровня навыка, а тонкие, высокотехнологичные костюмы могут вообще не давать штрафов.

Однако, навык работы в скафандре сильно зависит от привычки к нему. Знакомство и знания опасных ситуаций, входящих в такие навыки как Свободное падение, Опасные материалы, Выживание и прочие подобные навыки покупаются отдельно для каждого типа костюма.

Боевой костюм (Battlesuit): Все типы боевой брони и экзоскелетов со встроенным источником энергии. Боевая броня и Экзоскелеты – похожи, но не одинаковы, и считаются как за знакомство.

Водолазный костюм (Diving Suit). Все виды жестких водолазных костюмов (гибкие открытые и закрытые включены в навык Акваланг). Включает открытый костюм на ТУ 5, Жесткий шлем на ТУ 6, которые используют герметичный шлем и подачу воздуха – но не всегда полностью закрытый костюм. На ТУ 7 доступен настоящий, полноценный водолазный скафандр. Мастер может потребовать броска Плавания для маневрирования в этом костюме. (По умолчанию: Акваланг -2).

Защитный костюм (NBC Suit): Все виды снаряжения (включая не имеющие собственного питания), созданные для защиты от опасностей окружающей среды и рабоыт с опасными материалам. Без этого навыка вы постоянно рискуете в чем-то ошибиться и получить вред. 
Скафандр (Vacc Suit): Любой тип космического скафандра – включая специальные костюмы для работы в атмосферах с высоким давлением, кислотностью или ядами.
По умолчанию все виды костюмов относятся друг к другу с -2, кроме водолазного – с -4.
Негерметичные или не оборудованные энергопитанием костюмы никогда не требуют броска этого навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<technique version="2" limit="3">
		<name>Neck Snap</name>
		<name-loc>Сворачивание шеи</name-loc>
		<description-loc></description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA77</reference>
		<default>
			<type>ST</type>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Net</name>
		<name-loc>Сеть</name-loc>
		<description-loc>Сеть - это метательное оружие, которое предназначено для обездвижения противника. Подробные правила можно найти в параграфе Особые виды метательного оружия (с. B410).</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Cloak</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>No-Landing Extraction</name>
		<name-loc>Погрузка без приземления</name-loc>
		<description-loc>Техника позволяет поднимать грузы с земли, не приземляя летательного аппарата. Необходимо исполь-зование особого оборудования для этой цели. Также, ваши помощники на земле должны успешно подгото-вить груз броском Погрузки (занимает 2d часов). При провале любого из этих бросков, часть груза будет утеряна или повреждена. При критическом провале груз будет уничтожен или потерян вовсе (живой пасса-жир получит критические повреждения).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Technique</category>
			<category>Vehicle</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Observation</name>
		<name-loc>Наблюдение</name-loc>
		<description-loc>Это талант замечать опасные или интересные ситуации незаметно для других. Этот навык используется для обозрения места, группы людей или вашего непосредственного окружения на предмет скрытых или тактически важных деталей. Это не то же самое, что и сбор вещей или обыск – наблюдение ведется только с расстояния.
Успешный бросок даст вам информацию, которая не была скрыта специально. Например, вы можете осмотреть банк на предмет камер, расписания охранников, оценить размер толпы или мощь отряда на территории. Мастер может потребовать от вас броска навыка Анализ разведданных, чтобы интерпретировать результаты.
Для обнаружения специально скрытых вещей – например, пытающегося подкрасться к вам, вооруженного человека в толпе или замаскированное пулеметное гнездо – вы должны выиграть быстрое состязание по навыку Наблюдения против Скрытности, Слежки или Маскировки оппонента. Состязание бросает Мастер тайно от вас.
В случае провала вы не получаете лишней информации о заметном предмете или не замечаете скрытый. При критическом провале кто-то замечает, как вы всматриваетесь, и очень плохо реагирует.
Модификаторы: за размер, темноту и укрытие, +1..+10 за подходящее разведывательное устройство, -1..-10 за использование маскировочного устройства врагом. Премии за наличие обостренных чувств.</description-loc>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B211</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Military</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shadowing</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Occultism</name>
		<name-loc>Оккультизм</name-loc>
		<description-loc>Это наука о загадочном и сверхъестественном. Оккультист обладает особыми знаниями касаемо мистицизма, первобытных верований, древних ритуалов, призраках и т.д. Обратите внимание, что оккультист не обязательно верит в то, что изучает. 
В мирах, где магия широко распространена, «оккультизм» сменяется профессиональными знаниями магов. Навык включает знания о самих силах, и тех, кто их использует. Хороший бросок позволит даже немного понять неизвестные феномены, не встречающиеся в известных знаниях. Оккультизм, однако, не дает способностей распознать детали (жесты, символы). Если в мире кампании существует множество сверхъестественных вещей, Мастер может потребовать специализации. 

Некоторые из возможных специализаций:

Вампиры (Vampires). включает знания о вампирах: их привычках, сильных и слабых сторонах. Чаще всего те, кто владеет этим умением, будет заострять внимание на обнаружении и уничтожении вампиров. Умение может быть обширным, может быть очень узкоспециализированным - все зависит от разнообразия видов вампиров в выбранной кампании. 
Демонология (Demonology). Демонология - одно из специализаций умения Оккультизм и во многом копирует умение Теология. Умение отражает знания о злых духах: демонах, дьяволах и подобных существах, умение их узнавать и знание мест, где они живут. Оно может пригодиться для того, чтобы вычислить мощь определенного демона, его место в их иерархии, его привычки и особенности, а также то, как себя следует вести с ним. Также умение может быть использовано для того, чтобы определить одержимость демоном и (по решению Мастера) в совокупности с Магическими способностями проводить Экзорцизм так же эффективно, как и при наличии Духовного сана.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Off-Hand Weapon Training</name>
		<name-loc>Бой левой рукой</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -4 за использование определенного оружия ближнего боя левой рукой. При атаке будет использоваться уровень техники, а не навыка - как для атаки, так и для парирова-ния. Например, если вам известны навыки Рапира-14 и Бой левой рукой (рапира)-14, вы будете атаковать и парировать полностью без штрафов, используя левую руку.
С разрешения Мастера, вы можете выучить эту технику для любого навыка, основанного на DX, требую-щего использования только одной руки.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Off-Hand Weapon Training</name>
		<name-loc>Бой левой рукой</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -4 за использование определенного оружия ближнего боя левой рукой. При атаке будет использоваться уровень техники, а не навыка - как для атаки, так и для парирова-ния. Например, если вам известны навыки Рапира-14 и Бой левой рукой (рапира)-14, вы будете атаковать и парировать полностью без штрафов, используя левую руку.
С разрешения Мастера, вы можете выучить эту технику для любого навыка, основанного на DX, требую-щего использования только одной руки.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Guns</name>
			<specialization>Pistol</specialization>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Off-Hand Weapon Training</name>
		<name-loc>Бой левой рукой</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -4 за использование определенного оружия ближнего боя левой рукой. При атаке будет использоваться уровень техники, а не навыка - как для атаки, так и для парирова-ния. Например, если вам известны навыки Рапира-14 и Бой левой рукой (рапира)-14, вы будете атаковать и парировать полностью без штрафов, используя левую руку.
С разрешения Мастера, вы можете выучить эту технику для любого навыка, основанного на DX, требую-щего использования только одной руки.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Off-Hand Weapon Training</name>
		<name-loc>Бой левой рукой</name-loc>
		<description-loc>Эта техника позволяет выкупить штраф -4 за использование определенного оружия ближнего боя левой рукой. При атаке будет использоваться уровень техники, а не навыка - как для атаки, так и для парирова-ния. Например, если вам известны навыки Рапира-14 и Бой левой рукой (рапира)-14, вы будете атаковать и парировать полностью без штрафов, используя левую руку.
С разрешения Мастера, вы можете выучить эту технику для любого навыка, основанного на DX, требую-щего использования только одной руки.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-4</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Packing</name>
		<name-loc>Навьючивание</name-loc>
		<description-loc>Это умение быстро и эффективно нагружать и разгружать животных. Оно включает умение получать больше отдачи от животных,  умение судить о возможностях животного до приобретения, а также выбирать наиболее подходящие пути для караванов. Если животное раздражено или плохо дрессировано, перед броском Навьючивания необходим бросок Обращения с животными. 
Караваном должен руководить один Мастер-упаковщик (умения 15+), иначе его скорость понижается на 20%.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Equines</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Paleontology</name>
		<name-loc>Палеонтология/ТУ (Микропалеонтология)</name-loc>
		<description-loc>Это наука об ископаемых останках. Проверки умения делаются тогда, когда надо узнать окаменелое ископаемое или предположить гипотезу о его среде обитания, структуре тела, рационе и т.д. Удачная проверка (+4, если присутствует лабораторное оборудование) также может указать на примерный возраст объекта. 

Палеонтолог может специализироваться в одной из следующих областей; у каждой есть свое особенное значение по умолчанию и они относятся друг к другу по умолчанию с -2.

Палеозоология (Paleozoology) изучает доисторических животных, исследуя раскопанные останки костей, еды, фекалий, следы и т.д. По умолчанию: Зоология-4.

Палеоботаника (Paleobotany) изучает окаменелые древние растения. По умолчанию: Ботаника-3.

Палеоантропология (Paleoanthropology) изучает человеческие останки и древние инструменты, а также отношения внутри примитивных племен и места их расселения. По умолчанию: Антропология-2.
Микропалеонтология (Micropaleonthology) изучает ископаемые, которые не видно невооружённым глазом. Это умение нельзя использовать вне лаборатории. По умолчанию: Ботаника-4 или Биохимия-3.
Обычная Палеонтология по умолчанию равна любому из вышеперечисленных умений-2 или Антропологии-5.</description-loc>
		<specialization>Micropaleontology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Natural Science</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Paleontology</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Paleontology</name>
		<name-loc>Палеонтология/ТУ (Палеоантропология)</name-loc>
		<description-loc>Это наука об ископаемых останках. Проверки умения делаются тогда, когда надо узнать окаменелое ископаемое или предположить гипотезу о его среде обитания, структуре тела, рационе и т.д. Удачная проверка (+4, если присутствует лабораторное оборудование) также может указать на примерный возраст объекта. 

Палеонтолог может специализироваться в одной из следующих областей; у каждой есть свое особенное значение по умолчанию и они относятся друг к другу по умолчанию с -2.

Палеозоология (Paleozoology) изучает доисторических животных, исследуя раскопанные останки костей, еды, фекалий, следы и т.д. По умолчанию: Зоология-4.

Палеоботаника (Paleobotany) изучает окаменелые древние растения. По умолчанию: Ботаника-3.

Палеоантропология (Paleoanthropology) изучает человеческие останки и древние инструменты, а также отношения внутри примитивных племен и места их расселения. По умолчанию: Антропология-2.
Микропалеонтология (Micropaleonthology) изучает ископаемые, которые не видно невооружённым глазом. Это умение нельзя использовать вне лаборатории. По умолчанию: Ботаника-4 или Биохимия-3.
Обычная Палеонтология по умолчанию равна любому из вышеперечисленных умений-2 или Антропологии-5.</description-loc>
		<specialization>Paleoanthropology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Natural Science</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Paleontology</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Anthropology</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Paleontology</name>
		<name-loc>Палеонтология/ТУ (Палеоботаника)</name-loc>
		<description-loc>Это наука об ископаемых останках. Проверки умения делаются тогда, когда надо узнать окаменелое ископаемое или предположить гипотезу о его среде обитания, структуре тела, рационе и т.д. Удачная проверка (+4, если присутствует лабораторное оборудование) также может указать на примерный возраст объекта. 

Палеонтолог может специализироваться в одной из следующих областей; у каждой есть свое особенное значение по умолчанию и они относятся друг к другу по умолчанию с -2.

Палеозоология (Paleozoology) изучает доисторических животных, исследуя раскопанные останки костей, еды, фекалий, следы и т.д. По умолчанию: Зоология-4.

Палеоботаника (Paleobotany) изучает окаменелые древние растения. По умолчанию: Ботаника-3.

Палеоантропология (Paleoanthropology) изучает человеческие останки и древние инструменты, а также отношения внутри примитивных племен и места их расселения. По умолчанию: Антропология-2.
Микропалеонтология (Micropaleonthology) изучает ископаемые, которые не видно невооружённым глазом. Это умение нельзя использовать вне лаборатории. По умолчанию: Ботаника-4 или Биохимия-3.
Обычная Палеонтология по умолчанию равна любому из вышеперечисленных умений-2 или Антропологии-5.</description-loc>
		<specialization>Paleobotany</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Natural Science</category>
			<category>Plant</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Paleontology</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Paleontology</name>
		<name-loc>Палеонтология/ТУ (Палеозоология)</name-loc>
		<description-loc>Это наука об ископаемых останках. Проверки умения делаются тогда, когда надо узнать окаменелое ископаемое или предположить гипотезу о его среде обитания, структуре тела, рационе и т.д. Удачная проверка (+4, если присутствует лабораторное оборудование) также может указать на примерный возраст объекта. 

Палеонтолог может специализироваться в одной из следующих областей; у каждой есть свое особенное значение по умолчанию и они относятся друг к другу по умолчанию с -2.

Палеозоология (Paleozoology) изучает доисторических животных, исследуя раскопанные останки костей, еды, фекалий, следы и т.д. По умолчанию: Зоология-4.

Палеоботаника (Paleobotany) изучает окаменелые древние растения. По умолчанию: Ботаника-3.

Палеоантропология (Paleoanthropology) изучает человеческие останки и древние инструменты, а также отношения внутри примитивных племен и места их расселения. По умолчанию: Антропология-2.
Микропалеонтология (Micropaleonthology) изучает ископаемые, которые не видно невооружённым глазом. Это умение нельзя использовать вне лаборатории. По умолчанию: Ботаника-4 или Биохимия-3.
Обычная Палеонтология по умолчанию равна любому из вышеперечисленных умений-2 или Антропологии-5.</description-loc>
		<specialization>Paleozoology</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Natural Science</category>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Paleontology</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Panhandling</name>
		<name-loc>Попрошайничество</name-loc>
		<description-loc>Это умение выпрашивать еду или деньги у незнакомых людей: как правильно к ним подойти и как избежать неприятностей, связанных с законом. 
Бросок делается раз в час. Успешный бросок – вы насобирали Успешность*$2.00. Провал означает, что вам отказали. Критический провал означает, что тот, у кого вы просили, позвал полицию или напал на вас. Критическая удача даёт какой-то неожиданный бонус: вас накормят ужином, поделятся полезной информацией или дадут что-то полезное (зонтик, пальто, новые ботинки). 
Модификаторы: Харизма, +3 за преимущество Жалкий, от -1 до -4 за Застенчивость. Модификаторы Внешность действует на умение в обратную сторону - другими словами, красивые люди получают штраф при использовании умения, а некрасивые – премию (но это правило не распространяется на людей с ужасающей или чудовищной внешностью; см. B80). Попрошайки могут использовать умение Маскировка, чтобы выглядеть хуже, чем они выглядят на самом деле.</description-loc>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Fast Talk</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Public Speaking</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Parachuting</name>
		<name-loc>Парашют/ТУ</name-loc>
		<description-loc>Это способность благополучно пережить прыжок с парашютом. Неудачная проверка может означать все что угодно от небольшого ухода в сторону до паники, которая заставляет вас бросить снаряжение – на усмотрение Мастера. Критический провал означает, что парашют не раскрылся или оказался абсолютно непригоден (см. Падение, B431). Прыжок при плохих условиях может потребовать проверки при приземлении... например, чтобы не сломать лодыжку или уклониться от деревьев, заходя на посадку. Для упаковки парашюта используйте бросок, основанный на IQ.
Модификаторы: -2, если суммарный вес вашего тела и снаряжения превышает значение Basic Lift *10.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Athletic</category>
			<category>Military</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Parry Missile-Weapons</name>
		<name-loc>Парирование метательного оружия</name-loc>
		<description-loc>Позволяет парировать мечом, копьем, посохом и другим оружием ближнего боя метательное оружие. Имеющие на руках DR 2+ могут парировать даже руками. Парирование равно (Навык/2)+3, округляется вниз, и основан на навыке Парирования, а не оружейном навыке!
Модификаторы (к парированию): +4 к парированию больших метательных орудий (топоры и копья); +2 против малых метательных орудий (ножи и сюрикены); стрелы паруруются без модификаторов; -2 против снарядов низкотехнологичного оружия (болты и дроты духовой трубки). Вы не можете парировать пули или подобные снаряды! (Исключение: Улучшенное восприятие времени позволяет парировать пули с -5.)</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B212</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Performance</name>
		<name-loc>Выступление</name-loc>
		<description-loc>Это способность играть на сцене или на экране. От Артистизма отличается тем, что вы пытаетесь развлечь и впечатлить аудиторию, а не обмануть ее. Если вы изучали навык формально, он включает в себя знания, требуемые для профессиональных актеров на вашем уровне и в вашей культуре (управление сценой, связи между персоналом и пр.).
Модификаторы: +2 за Голос (Voice, c.B97), от -1 до -4 за Робость (Shyness, c.B154), -2 за Заикание (Stuttering, c.B157).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B212</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Acting</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Public Speaking</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Persuade</name>
	<name-loc>Убеждение</name-loc>
	<difficulty>Will/H</difficulty>
	<points>1</points>
	<prereq_list all="yes">
		<advantage_prereq has="yes">
			<name compare="is">charisma</name>
			<level compare="at least">1</level>
			<notes compare="is anything"></notes>
		</advantage_prereq>
		<skill_prereq has="yes">
			<name compare="is">public speaking</name>
			<level compare="at least">12</level>
			<specialization compare="is"></specialization>
		</skill_prereq>
	</prereq_list>
	<categories>
		<category>Esoteric</category>
	</categories>
	<reference>B191</reference>
	<description-loc>
В фентези барды часто имеют способность влиять на других, рассказывая им истории. Мастер может представить эту способность в виде нескольких родственных навыков. В зависимости от сеттинга, этот навык может быть магическим, псионическим или просто формой гипноза. Каждый навык имеет свое время использования и действия, а также цену усталости. См B191
Это способность убедить аудиторию в правильности своей точки зрения, что дает вам премию к броскам реакции от этой аудитории. Этот навык может использоваться в любой момент, когда необходим бросок реакции. Если вы побеждаете в быстром состязании, бросок реакции увеличивается на значение победы в этом состязании – до максимума в +3 (или +4 при критическом успехе). В случае критического провала, лучшая возможная реакция – Слабая (с. B560).
Время: 1 минута.
Стоимость: 2 ЕУ, независимо от успешности.
Продолжительность: пока вы не сделаете что-либо, что изменит мнение аудитории!</description-loc>
</skill>
	<skill version="2">
		<name>Pharmacy</name>
		<name-loc>Фармакология/ТУ (Травы)</name-loc>
		<description-loc>Это умение выбора и изготовления лекарства для лечения болезни. Специализация необходима.

Травы (Herbal): Способность создавать и использовать травяные препараты. Для поиска трав на природе делается бросок Натуралиста. До ТУ 5 это единственная специализация. Она заменяет Врачебное дело и часто используется в союзе с Эзотерической медицине. С ТУ 5 и выше специализация эта также доступна, но встречается намного реже. По умолчанию – Биология-5, Знание трав-5, Натуралист-5; Требуется: Натуралист.
Синтетическая (Synthetic): Способность создавать лекарства в лаборатории. Доступно только на ТУ 5+. По умолчанию – Химия-5 или Врачебное дело-5.</description-loc>
		<specialization>Herbal</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Medical</category>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">naturalist</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Biology</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Herb Lore</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Pharmacy</name>
		<name-loc>Фармакология/ТУ (Синтетическа)</name-loc>
		<description-loc>Это умение выбора и изготовления лекарства для лечения болезни. Специализация необходима.

Травы (Herbal): Способность создавать и использовать травяные препараты. Для поиска трав на природе делается бросок Натуралиста. До ТУ 5 это единственная специализация. Она заменяет Врачебное дело и часто используется в союзе с Эзотерической медицине. С ТУ 5 и выше специализация эта также доступна, но встречается намного реже. По умолчанию – Биология-5, Знание трав-5, Натуралист-5; Требуется: Натуралист.
Синтетическая (Synthetic): Способность создавать лекарства в лаборатории. Доступно только на ТУ 5+. По умолчанию – Химия-5 или Врачебное дело-5.</description-loc>
		<specialization>Synthetic</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Design/Invention</category>
			<category>Medical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Chemistry</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Philosophy</name>
	<name-loc>Философия (@Раса@)</name-loc>
	<specialization>@Race@</specialization>
	<difficulty>IQ/H</difficulty>
	<points>1</points>
	<default>
		<type>IQ</type>
		<modifier>-6</modifier>
	</default>
	<categories>
		<category>Social Sciences/Humanities</category>
	</categories>
	<reference>B213</reference>
	<description-loc>Это изучение основ убеждений, подобное Теологии (B62). Каждое философское учение - это отдельная специализация. Студент философского факультета не обязательно разделяет принципы, которые он изучает, или, если верит, не обязательно думает, что они установлены свыше. Философские учения не обязательно связаны с религиозными или сверхъестественными концепциями.
Это умение отчасти уместно в кампании по боевым искусствам, где персонаж знает боевые умения различных (и даже противостоящих друг другу) духовных учений; в случае примирения философии обеих школ, их можно безболезненно совместить (обратите внимание, что в Азии многие совмещают фактические противоположные религии, несмотря на значительные различия между ними).
Если во время приключения персонаж-философ задумывается над правильностью своих действий, Мастер должен позволить ему сделать проверку Философии или Теологии (буддизма, даосизма, синтоизма или другой специальной религии). При успешной проверке и в зависимости от ее успешности, Мастер может "просветить" персонажа, если это возможно, умной фразой или даже притчей. Мастер должен не говорить игрокам, что делать, а показать, что чувствовал бы человек с предысторией персонажа.
Успешная проверка Философии может также предсказать действия других людей, исповедующих данную философию.</description-loc>
</skill>
	<skill version="2">
		<name>Photography</name>
		<name-loc>Фотографирование/ТУ</name-loc>
		<description-loc>Это способность использовать фотоаппарат со знанием дела, пользоваться фотолабораторией (ТУ 5+) и цифровым фото-оборудование (ТУ 8+) и т.д., а также делать узнаваемые и красивые фотографии. Проверка по умолчанию позволяет использовать фотоаппарат, но не проявить пленку или напечатать снимки в лаборатории. 
Модификаторы: -3 за незнакомый аппарат; -3 за кинокамеру.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Spy</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Electronics Operation</name>
			<specialization>Media</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Physician</name>
		<name-loc>Врачебное дело/ТУ</name-loc>
		<description-loc>Это общее профессиональное умение помогать больным, прописывать лекарства и режим и т.д. Это умение используется, если Мастеру требуется единственная проверка общей медицинской осведомленности или знаний, для ускорения исцеления больного и пр. Врач может взять необязательную специализацию.
При TL4 и ниже Врачебное дело само по себе не существует, и заменяется Эзотерической медициной (если вообще такое есть) или фармацевтикой (травы). 
При TL5 и выше врач очень сильно зависит от доступных лекарств – знания разделяются между Фармакологией и Врачебным делом. Врач может довольно легко определить большинство лекарственных препаратов (-5, чтобы определить лекарство без лабораторного оборудования; +3, если рискнет понюхать/попробовать это вещество)., но не сможет их сделать самостоятельно без навыка Фармакологии.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Medical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-7</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>First Aid</name>
			<modifier>-11</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Veterinary</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Physics</name>
		<name-loc>Физика/ТУ</name-loc>
		<description-loc>Это наука о материи, силах и движении. Физик может ответить на вопросы об основных законах вселенной, поведении движущихся тел, о материи и энергии. На ТУ 6+ большинство физиков берут необязательную специализацию в определенной области: акустика, астрофизика, геофизика, ядерная физика, оптика, квантовая физика, физика относительности и пр. В некоторых сеттингах могут существовать и другие, необычные версии: физика гиперпространства, парахронология, парафизика, Физика вероятности, темпоральная, и т.д.

Физика вероятности. Крайне сложная область науки, изучающая саму природу реальности. Достижениями этой науки могут стать такие "волшебные" технологии, как анти-гравитационные аппараты, оружия, нарушающие закон причинности и т.д. Эта наука тесно связана с Физикой Гиперпространства (Hyperspace Physics), но принято, что оно всё же является отдельным умением. Требования: Математика, Физика и Ядерная Физика 15+.
Физика гиперпространства ответвление в физике, изучающее природу гиперпространства, точки прыжков и альтернативный ход времени в гиперпространстве. Доступно с ТУ 9. Умение применяется при создании гипердвигателей и при поиске точек прыжка. Требования: Математика, Физика, Ядерная Физика 15+.
Ядерная физика. Эта наука изучает ядерные процессы. Ядерный физик способен ответить на вопросы о строении солнца, ядерном оружии или об атомных электростанциях. Требования: Физика 15+ и Математика 15+.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<prereq_list all="yes">
			<when_tl compare="at least">5</when_tl>
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Physics</name>
		<name-loc>Физика/ТУ (@TL 6+ возможна специализация@)</name-loc>
		<description-loc>Это наука о материи, силах и движении. Физик может ответить на вопросы об основных законах вселенной, поведении движущихся тел, о материи и энергии. На ТУ 6+ большинство физиков берут необязательную специализацию в определенной области: акустика, астрофизика, геофизика, ядерная физика, оптика, квантовая физика, физика относительности и пр. В некоторых сеттингах могут существовать и другие, необычные версии: физика гиперпространства, парахронология, парафизика, Физика вероятности, темпоральная, и т.д.

Физика вероятности. Крайне сложная область науки, изучающая саму природу реальности. Достижениями этой науки могут стать такие "волшебные" технологии, как анти-гравитационные аппараты, оружия, нарушающие закон причинности и т.д. Эта наука тесно связана с Физикой Гиперпространства (Hyperspace Physics), но принято, что оно всё же является отдельным умением. Требования: Математика, Физика и Ядерная Физика 15+.
Физика гиперпространства ответвление в физике, изучающее природу гиперпространства, точки прыжков и альтернативный ход времени в гиперпространстве. Доступно с ТУ 9. Умение применяется при создании гипердвигателей и при поиске точек прыжка. Требования: Математика, Физика, Ядерная Физика 15+.
Ядерная физика. Эта наука изучает ядерные процессы. Ядерный физик способен ответить на вопросы о строении солнца, ядерном оружии или об атомных электростанциях. Требования: Физика 15+ и Математика 15+.</description-loc>
		<specialization>@TL 6+ Optional Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Natural Science</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">mathematics</name>
				<specialization compare="is">applied</specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Physiology</name>
		<name-loc>Физиология/ТУ (@Специализация@)</name-loc>
		<description-loc>Эта наука изучает человеческое тело и его функции. Физиолог знает, как работают мускулы, кости и органы, а также где они находятся. В мирах со множеством разумных рас необходима специализация на расе.</description-loc>
		<specialization>@Specialty@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Medical</category>
			<category>Natural Science</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Diagnosis</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Surgery</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Pickpocket</name>
		<name-loc>Карманное воровство</name-loc>
		<description-loc>Это способность украсть у кого-либо бумажник, нож и т.д. или «подбросить» ему что-то. 
Если клиент знает, что кто-то может попытаться его обокрасть или он просто осторожен, Мастер должен провести Быстрое состязание умений – его высшее значение Восприятия(Per) и Знания улиц против вашего умения Карманное воровство (с модификатором за сложность работы). Если жертва обладает Знанием улиц, то может использовать это умение вместо IQ! Подобная проверка может понадобиться и для того, чтобы обмануть третью сторону, наблюдающую за вами или за клиентом (наблюдатель кидает навык Наблюдения или Восприятия(Per)).
Модификаторы: +5 если клиент отвлечена +10, если он спит или пьян; до -5 за предмет во внутреннем кармане; до -10 за кольцо или подобную драгоценность.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B213</reference>
		<categories>
			<category>Criminal/Street</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Filch</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Sleight of Hand</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (@Тип судна@)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>@Flying vehicle class@</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Аэрокосмические)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Aerospace</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Автожир)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Autogyro</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Helicopter</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Heavy Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Light Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Антиграв)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Contragravity</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Vertol</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Ракетный ранец)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Flight Pack</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Vertol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Планеры)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Glider</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Light Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Ultralight</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Тяжелые самолеты)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Heavy Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Light Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Вертолеты)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Helicopter</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Autogyro</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Vertol</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Скоростные самолеты)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>High-Performance Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Aerospace</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Heavy Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Light Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Скоростные космические суда)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>High-Performance Spaecraft</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Aerospace</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Low-Performance Spacecraft</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Легкие самолеты)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Light Airplane</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Glider</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Heavy Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Ultralight</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Ворздушные шары)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Lighter-Than-Air</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Световые паруса)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Lightsail</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Low-Performance Spacecraft</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Низкогравитационные крылья)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Low-G Wings</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Glider</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Легкие космические суда)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Low-Performance Spacecraft</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Aerospace</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Spacecraft</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Сверхлегкие)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Ultralight</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Gilder</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Light Airplane</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Heavy Airplane</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Airplane</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Piloting</name>
		<name-loc>Пилотирование/ТУ (Вертокрыл)</name-loc>
		<description-loc>Это умение пилотировать определенный летательный аппарат или космический корабль. Необходима специализация. Уровень по умолчанию зависит от IQ, потому что в критической ситуации требуется интеллект, чтобы справиться с управлением. Но когда умение изучается обычным образом, оно основывается на DX, как и любое другое физическое умение.
Проверка на пилотирование требуется при взлете и посадке, а также в любой опасной ситуации. Неудача на 1 означает грубую работу; более серьезная ошибка приводит к повреждения летательного аппарата; критический провал означает крушение. Если умение пилота/водителя находится на уровне эксперта (15 или больше), любая критическая неудача требует немедленной повторной проверки. Только если вторая проверка неудачна, крушение действительно происходит. Другими словами, это была опасная ситуация, с которой помог справиться опыт.
Бросок, основанный на IQ, также используется для чтения карт и практической метеорологии, или для припоминания законов и регуляции воздушных полетов.

Дистанционно управляемая техника использует этот навык, если пилот неким образом имитирует действительное свое пребывание в кабине. Иначе делается DX-бросок против навыка, подходящего для выполняемой задачи. Необходима специализация. 

Аэрокосмический аппарат (Aerospace): Любой летательный аппарат, способный на полет в космос и из него через атмосферу. По умолчанию: Сверхзвуковой самолет -2, любой другой вид пилотирования -4. 
Автожир (Autogyro): Роторные аппараты, использующие роторы для взлета и посадки, но не для тяги. По умолчанию: Геликоптер -3, Самолет -4, любой другой вид пилотирования -5.

Антигравы (Contragravity): Любой вид техники, использующий технологическую или иную левитацию. (По умолчанию: Вертол -3, любой другой вид пилотирования -5. 
Ранцы (Flight Pack): Любой переносной, портативный аппарат. По умолчанию: Вертол -4, любой другой вид пилотирования -5. 
Планер (Glider): Любой тип крылатого аппарата без собственного двигателя. По умолчанию: Легкие самолеты -2, Сверхлегкие самолеты -2, любой другой вид пилотирования -4.
Тяжелый самолет (Heavy Airplane): Любой крылатый аппарат весом более 10 тонн и способный на крейсерскую скорость 600 миль в час и ниже. По умолчанию: Сверхзвуковой самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Геликоптер (Helicopter). Любой аппарат, использующий роторы для взлета, посадки и тяги. По умолчанию: Автожир -2, Вертол -5, любой другой вид пилотирования -5. 
Сверхзвуковой самолет (High-perfomance Airplane): Любой крылатый аппарат, способный на скорость свыше 600 миль в час. По умолчанию: Аэрокосмический аппарат -2, Тяжелый самолет -2, Легкий самолет -2, любой другой вид пилотирования -4.
Скоростной космолет (High-Perfomance Spacecraft): Космический корабль, способный на ускорение свыше 0,1G. По умолчанию: Аэрокосмический аппарат -4, Космолет -2. 
Легкий самолет (Light Airplane). Любой крылатый аппарат, весом менее 10 тонн и летающий со скоростью до 600 миль в час. По умолчанию: Планер -2, Тяжелый самолет -2, Сверхзвуковой самолет -2, Сверхлегкий самолет -2, любой другой вид пилотирования -4. 
Воздухоплавание (Lighter-Than-Air): Любой тип воздухоплавательного аппарата. По умолчанию: любой другой вид пилотирования -5.
Световой парус (Lightsail): Любой космолет, использующий световые паруса, независимо от тяги. По умолчанию: Космолет -4.
Низкогравитационные крылья (Low-G Wings): Пристегивающиеся крылья, использующие мускульную силу владельца. Используются в условиях низкой гравитации с атмосферой. По умолчанию: Планер -4. 
Космолет (Low-Performance Spacecraft): Любой космический корабль с ускорением менее 0,1 G. По умолчанию: Аэрокосмический аппарат -4, Скоростной космолет -2. 
Сверхлегкий самолет (Ultralight): Любой крылатый аппарат весом до 0,5 тонны и скоростью 200 и менее миль в час. По умолчанию: Планер -2, Легкий самолет -2, другой самолет -4, любой другой вид пилотирования -5. 
Вертол (Vertol): Летательный аппарат, использующий грубую силу тяги, а не крылья или роторы. По умолчанию: Антигравы -3, Геликоптер -4, любой другой вид пилотирования -5. 
Проверка пилотирования также может использоваться при разрешении результатов воздушного боя. Модификаторы: -2 за незнакомый летательный аппарат известного типа (например, «Piper», когда ваш собственный самолет - «Beech»); -4 или больше, если самолет в плохом состоянии; -2 за плохие летные условия; -4 или больше за самолет незнакомого типа (например, двухмоторный самолет, когда вы привыкли к одномоторному). Летательный аппарат с очень сложным управлением (например, космический челнок) или примитивный летательный аппарат (например, самолет братьев Райт) всегда дают штрафы, даже если пилот опытен. +1 за Чувство пространства (с. B34), +1 за Совершенное равновесие (c.B74).</description-loc>
		<specialization>Vertol</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Contragravity</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Helicopter</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Poetry</name>
		<name-loc>Поэзия</name-loc>
		<description-loc>Это умения писать хорошие стихи любого рода, который известен в вашей культуре, на любом языке, на котором вы говорите. Удачная проверка умения позволит вам написать хорошую поэму за определенное время (по решению Мастера). Проваленная проверка означает, что вы не смогли придумать хорошие рифмы или (по иной причине) публика просто никак не прореагировала на вашу работу. 
Модификаторы: за потраченное время (с. B346), знание культуры (с. B23), языка (с. B23).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Writing</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Poisons</name>
		<name-loc>Яды/ТУ</name-loc>
		<description-loc>Это общие практические знания об ядах. Успешная проверка данного умения позволит вам помимо прочего распознать в природе ядовитое растение; выделить из него пригодный для использования яд; распознать яд по вкусу в еде или напитке; определить яд по проявляемым эффектам (+3, если отравлены вы сами); вспомнить необходимое противоядие; распознать или выделить противоядие из подходящего источника. Помните, что каждая из этих вещей требует отдельной проверки. 
Модификаторы: Обостренный вкус/обоняние поможет распознать яд. Необычайный вкус или обоняние дают +4.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B214</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Medical</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Chemistry</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Pharmacy</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Polearm</name>
		<name-loc>Древковое оружие</name-loc>
		<description-loc>Любое очень длинное (не менее 2 ярдов) несбалансированное оружие с тяжелой ударной частью – глефа, алебарда, секира и множество других. Алебарды становятся неготовыми после атаки, но не после парирования. По умолчанию: посох-4, копье-4, двуручный топор/булава-4.
Все оружие этого вида требует двух рук.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spear</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Staff</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Axe/Mace</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Politics</name>
		<name-loc>Политика</name-loc>
		<description-loc>Это умение занять руководящую должность и поддерживать отношения с другими политиками. Оно не имеет ничего общего с Администрированием! Данное умение можно выучить, только занимая какую-то должность или работая на некое должностное лицо. Успешная проверка Политики даст вам +2 к реакции от любого политика. Во время выборов проводите Состязание в умении Политика. 
Модификаторы: +2, если у вас есть преимущество Голос. -3 за Нечувствительность (с. B142), -1 до -4 за Застенчивость (c.B154).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Business</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Diplomacy</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Power Blow</name>
		<name-loc>Мощный удар</name-loc>
		<description-loc>
Способность использовать свою внутреннюю силу для нанесения сокрушительных ударов в ближнем бою. Бросок навыка делается прямо перед атакой, каждая попытка стоит 1 FP, независимо от успеха. В случае успеха, следующая атака наносит вред, как если бы ваша сила была в два раза выше. Атака получает все обычные модификаторы. Если навык Мощного удара выше двадцати, за дополнительные -10 штрафа вы можете утроить силу удара.
Возможно использование навыка в небоевых ситуациях – например, для моментального увеличения силы для передвигания тяжестей.
Модификаторы: -10 за мгновенное использование, -5 за 1 ход концентрации, -4 за два хода, -3 за 4 хода, -2 за 8 ходов, -1 за 16 ходов, без штрафов за 32 хода концентрации.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="starts with">weapon master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Pressure Points</name>
		<name-loc>Парализующий удар</name-loc>
		<description-loc>
* В киношной кампании может иметь уровень по умолчанию от Нетрадиционной медицины-4.
Это умение точными ударами по уязвимым точкам нейтрализовывать оппонента. Для использования, вы должны сначала сделать успешную невооруженную атаку с -2 плюс модификатор за размер части тела. В случае успеха вы можете сделать быстрое состязание Парализующего удара против НТ жертвы. В случае успеха, цель будет временно нейтрализована. Конечности парализуются на 5d секунд, попадание в туловище сбивает дыхание (жертва начинает задыхаться, бросок НТ каждую секунду для восстановление). Удар в лицо оглушает жертву – она кидает IQ каждый ход, чтобы восстановиться. Удар по голове ослепляет жертву на 2d секунд.
Возможно использование навыка с навыком Дзюдо – в этом случае состязание по навыкам проходит после успешного захвата. Описанные выше эффекты добавляются к обычным эффектам захватов.
Мастер может разрешить воинам изучать специализированные версии навыка для использования с тупым оружием. Например, Парализующий удар (лук) – использование с тупыми стрелами, (посох) – с посохом, и так далее.
Модификаторы: знание физиологии (с. B181).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="starts with">weapon master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Pressure Secrets</name>
		<name-loc>Смертельный удар</name-loc>
		<description-loc>
Отражает знание наиболее уязвимых жизненно важных точек человеческого тела. Это позволяет вам убивать врагов, разрушая их внутренние органы и нервные сплетения.
Для использования, вы должны сначала сделать успешную невооруженную атаку с -2 плюс модификатор за размер части тела. В случае успеха вы можете сделать бросок Смертельного удара.
При успехе любой вред, пробивший DR, удваивается (если вы целились в жизненно важные органы – утраивается). По сути, ваши руки и ноги становятся проникающим оружием.
Также можно использовать этот навык с захватами и болевыми приемами, поскольку вы знаете, где лучше применить давление. Это позволяет удвоить негативные эффекты захвата.
Модификаторы: знание физиологии (с.181).</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">pressure points</name>
				<specialization compare="is"></specialization>
				<level compare="at least">16</level>
			</skill_prereq>
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Professional Skill</name>
		<name-loc>Профессиональные умения (@Ментальное умение@)</name-loc>
		<description-loc>Многие виды работы более полезны для заработка и жизни, чем приключения. Большинство таких навыков не отражены в этом списке, но вы можете взять их, если хотите! Каждый – отдельный профессиональный навык. Если ваши навыки для приключения не приносят серьезного дохода, вы можете зарабатывать профессиональным навыком. Для получения большинства видов работы, вы должны иметь соответствующий навык на уровне не менее 12.
Большинство навыков требуют определенного объема знаний – такие навыки считаются IQ/Средними, и имеют значение по умолчанию IQ-5. другие навыки требуют в большей мере точности, чем памяти. Такие навыки относятся по DX. На усмотрение Мастера, некоторые навыки могут иметь значения по умолчанию и от других навыков.</description-loc>
		<specialization>@Mental Skill@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Professional Skill</name>
		<name-loc>Профессиональные умения (@Физическое умение@)</name-loc>
		<description-loc>Многие виды работы более полезны для заработка и жизни, чем приключения. Большинство таких навыков не отражены в этом списке, но вы можете взять их, если хотите! Каждый – отдельный профессиональный навык. Если ваши навыки для приключения не приносят серьезного дохода, вы можете зарабатывать профессиональным навыком. Для получения большинства видов работы, вы должны иметь соответствующий навык на уровне не менее 12.
Большинство навыков требуют определенного объема знаний – такие навыки считаются IQ/Средними, и имеют значение по умолчанию IQ-5. другие навыки требуют в большей мере точности, чем памяти. Такие навыки относятся по DX. На усмотрение Мастера, некоторые навыки могут иметь значения по умолчанию и от других навыков.</description-loc>
		<specialization>@Physical Skill@</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B215</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Propaganda</name>
		<name-loc>Пропаганда/ТУ</name-loc>
		<description-loc>Навык непрямого убеждения через средства массовой информации. Используется для психологической войны разведками и военными организациями, а также для рекламы и маркетинга в мирное время. Для отражения различий между этими двумя областями используются знакомства.
Пропаганда работает на группы, а не их членов. Мастер устанавливает эффективную Волю(Will) целевой группы исходя из размера, состава и сопротивления желаемому результату. Для воздействия бросаются обычные броски Влияния. Пропаганда обычно занимает намного больше времени, чем обычные броски.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Business</category>
			<category>Military</category>
			<category>Social</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Merchant</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Psychology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Prospecting</name>
		<name-loc>Разведка полезных ископаемых/ТУ</name-loc>
		<description-loc>Это прикладная геология: умение находить полезные ископаемые, произведя осмотр на местности. Разведка полезных ископаемых на расстоянии с помощью приборов и изучения карты требует умения Геология. 
Успешная проверка на Разведку полезных ископаемых также позволит определить качество руды или минерала по небольшому образцу, а также судить о его ценности.
На природе изыскатель может попытаться найти воду, используя осмотр местности, как для умения Выживание.
Модификаторы: Модификаторы за снаряжение (с.345). Изыскатель действует с -1 на незнакомой местности знакомого типа, с -2 или больше на незнакомом типе местности, пока не пробудет там достаточно долго (месяц работы), чтобы познакомиться с ним.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Geology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Psychology</name>
		<name-loc>Психология</name-loc>
		<description-loc>Данная наука изучает поведение. Психолог имеет дело с человеческим сознанием (возможно не только с человеческим). Успешная проверка на Психологию может в целом предсказать поведение человека или небольшой группы в определенных обстоятельствах, особенно в стрессовой ситуации. Если в мире существует несколько разумных рас, необходима специализация по расе (значения по умолчанию между ними устанавливает Мастер).
Если Мастер хочет большей детализации, он может разделить навык на две специализации: прикладную (описанную выше) и экспериментальную (ученые, пускающие крыс по лабиринтам, и т.п.). Прикладная в этом случае зависит от экспериментальной по умолчанию с -5, но броски экспериментальной психологии по умолчанию от прикладной невозможны.
Модификаторы: +3, если психолог хорошо знает человека. +1..+3, если психолог обладает преимуществом Эмпатия и встречался с человеком. +3, если отклонения человека относятся к известному типу – например он страдает от фобии или иной ментальной проблемы. -3 за Безжалостность (с. B125) или Нечувствительность (с. B142).</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Sociology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Public Speaking</name>
		<name-loc>Публичное выступление</name-loc>
		<description-loc>Это умение рассказывать истории и хорошо импровизировать. Удачное использование этого таланта (например) позволит вам выдать удачную политическую речь; развлечь собравшихся у костра; поднять (или успокоить) бунт; или хорошо выступить в роли шута. 
Навык включает дебаты, ораторское Мастерство и риторику, а также менее формальные действия вроде каламбуров и рассказывания историй. Однако не все рассказчики обладают талантами во всех областях – вы можете взять необязательную специализацию для отражения этого.
Модификаторы: Премии за харизму; +2 за Голос, от -1 до -4 за Застенчивость, -2 за Заикание. Кроме того, применяются модификаторы за знание культуры и языка.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Business</category>
			<category>Scholarly</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Acting</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Performance</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Politics</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Push</name>
		<name-loc>Отбрасывание</name-loc>
		<description-loc>Это умение направляет вашу Ки, мягко отбрасывая противника, или вызывая потерю равновесия. Считается рукопашной атакой (см. Толкание, с.372), а ваша цель может предпринимать любую разрешенную ей активную защиту.
При попадании в качестве эффективной ST используется высшее из значений ST и умения Отбрасывания. Для этой ST делается бросок амплитудного (sw) повреждения, а в отношении результата это значение вреда удваивается. Например, если у вас ST 10 и Отбрасывание-15, вы делает бросок рубящего вреда для ST 15 (2d+1), и удваиваете его. Это повреждение вызывает отбрасывание (см. Отбрасывание, с.378), но не наносит физического вреда.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B216</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">trained by a master</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Rapier</name>
		<name-loc>Рапира</name-loc>
		<description-loc>Любой длинный (длиннее 1 ярда) легкий колющий меч. По умолчанию: Средний меч-4

Будучи вооруженным фехтовальным оружием, вы получаете улучшенную премию за отступление при парировании (с. B377). 
Вы также получаете половинный штраф за повторные попытки парирования одной и той же рукой в течение одного хода (см. Парирование, с. B376).
Обратите внимание, что все фехтовальное оружие легкое, и часто ломается при парировании тяжелого оружия. Им вообще нельзя парировать цепы! Для нормального боя этим оружием вы должны быть достаточно подвижны – на все броски атаки и парирования вы получаете штраф, равный уровню нагрузки.

Навыки в пределах этой категории относятся друг к другу с -3. Они также могут относится к навыкам Мечей, как указано ниже.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Main-Gauche</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Religious Ritual</name>
		<name-loc>Религиозный обряд (@Специализация@)</name-loc>
		<description-loc>Это способность проводить религиозные обряды – мессы, погребения, свадьбы перед людьми. Необходима специализация по религии. Навык включает подробные знания о движениях, молитвах, удержании внимания поклоняющихся и пр. В религиях, практикующих жертвоприношение, также включает знание методов и инструментов.
Жрец на ТУ 1+ должен знать еще и Теологию, на ТУ 0 можно обойтись знанием ритуалов.
В мирах, где священники могут вызывать чудеса, каждый магический ритуал – отдельный навык, но определенные обычные ритуалы (жертва, например) – могут дать бонус к навыку – но только при успешном броске. В других сеттингах, сила эффекта заклинания определяется успешностью броска ритуала. В этом случае эффект определяется наименьшим из навыков ритуала и магии.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Ritual Magic</name>
			<specialization>@Specialty@</specialization>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Theology</name>
			<specialization>@Specialty@</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Research</name>
		<name-loc>Исследования/ТУ</name-loc>
		<description-loc>
Исследования – это общая способность работать в библиотеке или архиве. Успешная проверка на Исследования, если они проведены в правильном месте, позволит вам найти некоторую полезную информацию, которую требуется найти, если она там вообще существует. 
Модификаторы: за знания языка, если вы изучаете иностранные материалы.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Scholarly</category>
			<category>Spy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="yes">
				<when_tl compare="at least">8</when_tl>
				<skill_prereq has="yes">
					<name compare="is">Computer Operation</name>
					<specialization compare="is anything"></specialization>
				</skill_prereq>
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Writing</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<technique version="2" limit="5">
		<name>Retain Weapon</name>
		<name-loc>Удержание оружия</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем с навыком владения оружия, то можете использовать ее уро-вень вместо навыка, когда кто-либо пытается вас обезоружить (см. Удары по оружию, с. B400). например, если у вас есть навыки Посох-13, и Удержание оружия (посох)-16, вы сопротивляетесь попытаам разоруже-ния, как если бы имели навык Посох-16.
Вы также можете изучить эту технику для метательного оружия - такого, как огнестрельного оружия и луков. В этом случае, по умолчанию он относится к DX, и не может превышать DX+5.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA78</reference>
		<default>
			<type>Skill</type>
			<name>@Melee Weapon Skill@</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Retain Weapon (@Ranged Weapon@)</name>
		<name-loc>Удержание оружия</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем с навыком владения оружия, то можете использовать ее уро-вень вместо навыка, когда кто-либо пытается вас обезоружить (см. Удары по оружию, с. B400). например, если у вас есть навыки Посох-13, и Удержание оружия (посох)-16, вы сопротивляетесь попытаам разоруже-ния, как если бы имели навык Посох-16.
Вы также можете изучить эту технику для метательного оружия - такого, как огнестрельного оружия и луков. В этом случае, по умолчанию он относится к DX, и не может превышать DX+5.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA78</reference>
		<default>
			<type>DX</type>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Retain Weapon</name>
		<name-loc>Удержание оружия</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем с навыком владения оружия, то можете использовать ее уро-вень вместо навыка, когда кто-либо пытается вас обезоружить (см. Удары по оружию, с. B400). например, если у вас есть навыки Посох-13, и Удержание оружия (посох)-16, вы сопротивляетесь попытаам разоруже-ния, как если бы имели навык Посох-16.
Вы также можете изучить эту технику для метательного оружия - такого, как огнестрельного оружия и луков. В этом случае, по умолчанию он относится к DX, и не может превышать DX+5.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Retain Weapon</name>
		<name-loc>Удержание оружия</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем с навыком владения оружия, то можете использовать ее уро-вень вместо навыка, когда кто-либо пытается вас обезоружить (см. Удары по оружию, с. B400). например, если у вас есть навыки Посох-13, и Удержание оружия (посох)-16, вы сопротивляетесь попытаам разоруже-ния, как если бы имели навык Посох-16.
Вы также можете изучить эту технику для метательного оружия - такого, как огнестрельного оружия и луков. В этом случае, по умолчанию он относится к DX, и не может превышать DX+5.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<technique version="2" limit="5">
		<name>Retain Weapon</name>
		<name-loc>Удержание оружия</name-loc>
		<description-loc>Если вы знакомы с этой техникой лучше, чем с навыком владения оружия, то можете использовать ее уро-вень вместо навыка, когда кто-либо пытается вас обезоружить (см. Удары по оружию, с. B400). например, если у вас есть навыки Посох-13, и Удержание оружия (посох)-16, вы сопротивляетесь попытаам разоруже-ния, как если бы имели навык Посох-16.
Вы также можете изучить эту технику для метательного оружия - такого, как огнестрельного оружия и луков. В этом случае, по умолчанию он относится к DX, и не может превышать DX+5.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232</reference>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>0</modifier>
		</default>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Riding</name>
		<name-loc>Верховая езда (@Специализация@)</name-loc>
		<description-loc>Способность ездить верхом на определенном виде верховых животных. Бросок умения необходим при знакомстве с животным, каждый раз, когда происходит что-то, что может испугать животное, а также когда животному предстоит сделать что-то трудное (например, прыжок). 
Необходима специализация по типу животных. Значения по умолчанию различаются от 0 до -10. К примеру, если вы умеет ездить на лошади, то получите пенальти -3 для верблюда, -6 для дельфина, -10 для дракона и никакого пенальти для мула.
Модификаторы: +5, если животное знает вас и вы ему нравитесь; +1 и больше, если животное имеет навык Скакун (с. B210). -10, если животное не ездовое или необъезженное.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>@Specialty@</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Riding</name>
		<name-loc>Верховая езда (Слон)</name-loc>
		<description-loc>Способность ездить верхом на определенном виде верховых животных. Бросок умения необходим при знакомстве с животным, каждый раз, когда происходит что-то, что может испугать животное, а также когда животному предстоит сделать что-то трудное (например, прыжок). 
Необходима специализация по типу животных. Значения по умолчанию различаются от 0 до -10. К примеру, если вы умеет ездить на лошади, то получите пенальти -3 для верблюда, -6 для дельфина, -10 для дракона и никакого пенальти для мула.
Модификаторы: +5, если животное знает вас и вы ему нравитесь; +1 и больше, если животное имеет навык Скакун (с. B210). -10, если животное не ездовое или необъезженное.</description-loc>
		<specialization>Camel</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Camel</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Riding</name>
		<name-loc>Верховая езда (Дельфин)</name-loc>
		<description-loc>Способность ездить верхом на определенном виде верховых животных. Бросок умения необходим при знакомстве с животным, каждый раз, когда происходит что-то, что может испугать животное, а также когда животному предстоит сделать что-то трудное (например, прыжок). 
Необходима специализация по типу животных. Значения по умолчанию различаются от 0 до -10. К примеру, если вы умеет ездить на лошади, то получите пенальти -3 для верблюда, -6 для дельфина, -10 для дракона и никакого пенальти для мула.
Модификаторы: +5, если животное знает вас и вы ему нравитесь; +1 и больше, если животное имеет навык Скакун (с. B210). -10, если животное не ездовое или необъезженное.</description-loc>
		<specialization>Dolphin</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Dolphin</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Riding</name>
		<name-loc>Верховая езда (Дракон)</name-loc>
		<description-loc>Способность ездить верхом на определенном виде верховых животных. Бросок умения необходим при знакомстве с животным, каждый раз, когда происходит что-то, что может испугать животное, а также когда животному предстоит сделать что-то трудное (например, прыжок). 
Необходима специализация по типу животных. Значения по умолчанию различаются от 0 до -10. К примеру, если вы умеет ездить на лошади, то получите пенальти -3 для верблюда, -6 для дельфина, -10 для дракона и никакого пенальти для мула.
Модификаторы: +5, если животное знает вас и вы ему нравитесь; +1 и больше, если животное имеет навык Скакун (с. B210). -10, если животное не ездовое или необъезженное.</description-loc>
		<specialization>Dragon</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Dragon</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Riding</name>
		<name-loc>Верховая езда (Лошадь)</name-loc>
		<description-loc>Способность ездить верхом на определенном виде верховых животных. Бросок умения необходим при знакомстве с животным, каждый раз, когда происходит что-то, что может испугать животное, а также когда животному предстоит сделать что-то трудное (например, прыжок). 
Необходима специализация по типу животных. Значения по умолчанию различаются от 0 до -10. К примеру, если вы умеет ездить на лошади, то получите пенальти -3 для верблюда, -6 для дельфина, -10 для дракона и никакого пенальти для мула.
Модификаторы: +5, если животное знает вас и вы ему нравитесь; +1 и больше, если животное имеет навык Скакун (с. B210). -10, если животное не ездовое или необъезженное.</description-loc>
		<specialization>Equine</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B217</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Equine</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Ritual Magic</name>
		<name-loc>Ритуальная Магия (@Специализация@)</name-loc>
		<description-loc>Навык дает понимание научных и мистических процессов, происходящих во время ритуалов определенной традиции магии. Это навык вызывания духов и создания магических эффектов нерелигиозными путями. 
Бросок навыка делается для определения цели ритуала, типа призываемого существа и пр.
Специализация в определенной традиции обязательна. Каждая специализация зависит друг от друга с -5. происходящие процессы похожи, но действия очень различаются.
В мирах с работающей ритуальной магией, этот навык становится основным навыком волшебников – все ритуалы делаются по нему.
Похожий навык для более быстрой и эффектной прямой магии – Теория магии (Тауматология), а для религии – Религиозный ритуал.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Ritual Magic</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Rope Up</name>
		<name-loc>Подъем по веревке</name-loc>
		<description-loc>При подъеме по веревке обычно персонаж получает штраф -2 (Лазание, с. B349). После тренировок вы сможете избавиться от этого штрафа.
"Противоположная" техника, Спуск по веревке, по умолчанию имеет уровень Лазание-1, и может быть улучшена до Лазания+3. Спускаться определенно легче, чем лезть вверх!
</description-loc>
		<difficulty>A</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Climbing</name>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Athletic</category>
			<category>Criminal/Street</category>
			<category>Outdoor/Exploration</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Running</name>
		<name-loc>Бег</name-loc>
		<description-loc>Отражает тренировку в спринте и беге на длинные дистанции. В процессе бега броски на усталость и повреждения делаются по высшему из значений Бега и НТ. При соревновании двух персон, имеющих одинаковую скорость, бросается состязание по навыку Бега.
Вы должны иметь ноги и быть способным к передвижению по суше.</description-loc>
		<difficulty>HT/A</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Saber</name>
		<name-loc>Сабля</name-loc>
		<description-loc>Любой легкий режуще-колющий клинок. Заметьте, что кавалерийские сабли довольно тяжелы, и используют навык Средний меч. По умолчанию: Средний меч-4 или Короткий меч-4

Будучи вооруженным фехтовальным оружием, вы получаете улучшенную премию за отступление при парировании (с. B377). 
Вы также получаете половинный штраф за повторные попытки парирования одной и той же рукой в течение одного хода (см. Парирование, с. B376).
Обратите внимание, что все фехтовальное оружие легкое, и часто ломается при парировании тяжелого оружия. Им вообще нельзя парировать цепы! Для нормального боя этим оружием вы должны быть достаточно подвижны – на все броски атаки и парирования вы получаете штраф, равный уровню нагрузки.

Навыки в пределах этой категории относятся друг к другу с -3. Они также могут относится к навыкам Мечей, как указано ниже.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortswort</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Main-Gauche</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Rapier</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (@Социальный слой@)</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>@Social group@</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Games</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Додзё )</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>Dojo</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Games</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Высшее общество)</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>High Society</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Business</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Savoir-Faire</name>
			<specialization>Servant</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Мафия)</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>Mafia</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Streetwise</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Армейский)</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>Military</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Knowledge</category>
			<category>Military</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Полиция )</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>Police</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Knowledge</category>
			<category>Police</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Savoir-Faire</name>
		<name-loc>Хорошие манеры (Прислуга )</name-loc>
		<description-loc>Это знание хороших манер поведения в данной культуре или обществе. Успешная проверка на Хорошие манеры требуется, чтобы уживаться в «высшем обществе» и при этом не ставить себя в неловкое положение – сделайте одну проверку на каждом приеме или встрече. Успешная проверка также позволит определить, кто притворяется, будто принадлежит к этому обществу.
В любой ситуации, где вам требуется сделать бросок на реакцию со стороны общества, вы можете заменить его проверкой на умение Хорошие манеры; к этой проверке добавляются все обычные модификаторы на реакцию. 

Специализация необходима. Обычные специализации включают в себя:

Додзё (Dojo): Это умение подскажет вам, как себя правильно вести на тренировке, турнире по определенным боевым искусствам и т.д. Как приветствовать старших, носить оружие, принимать и бросать вызов и пр. Провал такой проверки может означать что угодно, от простого пенальти к реакции до кровожадной расправы.

Высшее общество (High Society): манеры благородных людей. Относительное положение определяется статусом. Бросок навыка необходим всякий раз, когда вы пытаетесь имитировать кого-то, кто на три уровня статуса выше вас. Если ваш статус отрицателен, а вы пытаетесь выдать свой статус за +1, или наоборот – бросок делается с -2.

Мафия (Mafia): правильное поведение в формальной криминальной организации. Включает такие вопросы как кодекс молчания и выказывания положенного уважения соответствующим людям. Эти обычаи часто берутся из высшего общества, но неприятности за несоблюдения – намного более серьезны. По умолчанию – Знание улиц-3.

Армейский этикет (Military): Это умение для солдата включает в себя знания обычаев, традиций и положений его родной службы. Также умение включает в себя знание неписаных правил: что разрешено, не будучи обозначено, и что запрещено, даже если об этом нигде ничего не написано.

Полиция (Police): почти как Армейский этикет, но относится к гражданской полиции. Знание социальных обычаев для офицеров полиции.
Прислуга (Servant): Это умение обслуживать представителей правящего класса. Некоторые процедуры делаются особенным образом (вилка для салата кладется с самого края, герцогов объявляют прежде, чем лордов и т.д.). Человек, обладающий умением Хорошие манеры, чуть-чуть знаком с обязанностями слуги, но большинство людей, принадлежащих к высшему классу, обычно не знают в точности, что делает слуга - они просто замечают когда что-то идет не так. Хорошие манеры (высшее общество) и Хорошие манеры (слуга) относятся друг к другу с -2.
Модификаторы: +2, если ваше положение или «класс» выше, чем у NPC, на которого вы пытаетесь произвести впечатление; -2, если ваш социальный статус ниже; +2, если кажется, что у вас есть влиятельные друзья!; знакомство с культурой; -4 за Несообразительность (с. B126), -3 за Нечувствительность (с. B142), -1 Непонимающего (c.B146), -1 to -4 for Застенчивость (c.B154)</description-loc>
		<specialization>Servant</specialization>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Everyman</category>
			<category>Knowledge</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Savoir-Faire</name>
			<specialization>High Society</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Scaling</name>
		<name-loc>Цепляние за выступы</name-loc>
		<description-loc>Техника позволяет снизить штраф -3 за лазание по относительно ровным вертикальным поверхностям - стенам или отвесным скалам (см. Лазание, с. B349).
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Climbing</name>
			<modifier>-3</modifier>
		</default>
		<categories>
			<category>Athletic</category>
			<category>Criminal/Street</category>
			<category>Outdoor/Exploration</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Scrounging</name>
		<name-loc>Собирание</name-loc>
		<description-loc>Это способность находить, собирать или импровизированно создавать нужные вещи, которые другие заметить не могут. Каждая попытка занимает час. Такой человек не обязательно крадет всяческое добро; он просто как-либо находит его, а потом пытается заполучить необходимым образом. Обратите внимание, что если собирающий находит что-то, что плохо лежит, то он должен решить, каким образом это заполучить, а затем провести проверку другого необходимого умения. 
Модификаторы: Назначает Мастер за редкость предмета, который ищется.</description-loc>
		<difficulty>Per/E</difficulty>
		<points>1</points>
		<reference>B218</reference>
		<categories>
			<category>Criminal/Street</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Scuba</name>
		<name-loc>Акваланг/ТУ</name-loc>
		<description-loc>
Это умение пользоваться снаряжением для дыхания под водой. Одна проверка умения требуется, когда вы заходите в воду, и проверку нужно повторять каждые 30 минут, чтобы не вдохнуть воду, а это приводит к риску утонуть (считается за удушение, suffocation, с. B436). Кроме того, удачная проверка умения (только при наличии какой-либо тренировки) позволит вам обнаружить проблемы со снаряжением, если вы осмотрите его до того, как надевать на себя.
Модификаторы: -2..-4 за незнакомый тип.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B219</reference>
		<categories>
			<category>Athletic</category>
			<category>Military</category>
			<category>Outdoor/Exploration</category>
			<category>Technical</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">swimming</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Diving Suit</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Seamanship</name>
		<name-loc>Моряк</name-loc>
		<description-loc>Это способность работать в команде на борту определенного типа крупного вида транспорта. Включает знакомство с бытом, знание техники безопасности и тренированность предотвращать и ремонтировать повреждения. 
Также позволяет управлять кораблем. Навык легче, чем соответствующий навык управления. Специалисты контролируют такие действия, как прокладку курса и работу с приборами – данные передаются капитану, а он уже принимает решение о маневре и передает экипажу или рулевому. При каждом маневре кидается навык от DX, но эффективный навык не может быть выше навыка капитана.
Средний уровень навыка по экипажу представляет общую тренированность. Мастер кидает его каждый раз в бою, плохих условиях и пр.

Необходима специализация:
Летчик (Airshipman): Навык хранения и использования балласта, газовых вентилей, тросов и пр. на борту крупного воздухоплавательного аппарата. 
Моряк (Seamanship): Навык использования якорей, веревок, парусов и пр. на борту крупного надводного корабля (не подводной лодки). 
Космонавт (Spacer): Навык работы с шлюзами, воздушными пробками, причальными системами и пр. на борту крупного космолета или космической базы. 
Подводник (Submariner): Навык работы с шлюзами, насосами, вентилями и прочим оборудованием на подводной лодке или морской базе.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Search</name>
		<name-loc>Обыск</name-loc>
		<description-loc>Способность обыскивать багаж, людей и транспорт в поисках предметов, которые скрыты от простого взгляда. Мастер тайно бросает бросок навыка за каждый интересный предмет. Для умышленно скрытых предметов проводится быстрое состязание по навыку Обыска против Утаивания или Контрабанды. В случае провала Мастер говорит «ты ничего не нашел», но не что-нибудь подобное «Ты не заметил пистолет в потайном кармане». 
Если поисками занято несколько человек, бросок делается для каждого персонажа. Мастер может пропускать ненужные броски – никто не сможет пронести дробовик через тщательный обыск. Также, нож или драгоценный камень нельзя заметить на обычно одетом персонаже, не прибегая к рентген-облучению или личному досмотру. В общем, если премия за величину предмета составляет +3 и больше – требуется личный обыск. Штраф -2 и больше за величину предмета – предмет автоматически будет найден при личном досмотре.
Модификаторы: +1 за ощупывание несопротивляющегося (1 минута), +3 за личный досмотр, включая волосы и одежду (3 минуты), +5 за полный досмотр, даже полостей (5 минут). Премии за обострение осязания. Успешный бросок использования электроники (специальные сенсоры – рентген, металлодетекторы) добавит +1..+5 на нахождение предметов, которые оборудование может обнаружить</description-loc>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B219</reference>
		<categories>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Criminology</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Set Trap</name>
		<name-loc>Установка ловушек</name-loc>
		<description-loc>Вы изучили всевозможные детонаторы и спусковые механизмы ловушек, что позволяет вам устанавли-вать ловушки, не получая обычного штрафа -2.
Эта техника популярна среди убийц, шпионов и коммандо.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Explosives</name>
			<specialization>Demolition</specialization>
			<modifier>-2</modifier>
		</default>
		<categories>
			<category>Criminal/Street</category>
			<category>Military</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Sewing</name>
		<name-loc>Шитье/ТУ</name-loc>
		<description-loc>Способность работать с тканью, используя инструменты вашего ТУ. Успешный бросок навыка позволит вам починить прохудившуюся одежду, изменить отделку или слегка перешить предмет, и даже создать новый предмет одежды, если у вас есть подходящие материалы.
Для придумывания дизайна делайте бросок по IQ, с +1, если у вас есть Чувство моды.
До ТУ 7 почти все домохозяйки знакомы с этим навыком. На ТУ 7+ навык становится более редким – обычно он известен профессиональным швеям; большинство людей работают, бросая навык по умолчанию (с +4 за такую простую операцию, как пришивание пуговицы) и избавляются от вещей, которые не могут починить.
Модификаторы: за оборудование и ловкость рук.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B219</reference>
		<categories>
			<category>Craft</category>
			<category>Everyman</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Sex Appeal</name>
		<name-loc>Сексапильность</name-loc>
		<description-loc>Это способность производить впечатление на противоположный пол. Его можно учить лишь в «свободное время» - скажем, максимум по три часа в день – если только вы не входите в гарем или что-то вроде этого. Сексапильность зависит как от умения подать себя, так и от внешнего вида. Если вы не хотите соблазнять кого-то, чтобы получить то чего хотите, то не сможете получить этот талант или не захотите применять его. 
При необходимости броска на реакцию со стороны представителя противоположного пола вы можете заменить его проверкой на Сексапильность; к этой проверке добавляются все обычные модификаторы на реакцию. Обычно позволяется лишь одна попытка за «жертву», хотя Мастер может позволить попытаться еще раз по прошествии нескольких недель.
Модификаторы: +2, если у вас есть преимущество Голос. Удвойте все обычные пенальти за внешний вид! -2 Заикание, -1..-4 за Застенчивость, и т.д. -1 за Непонимающего, -3 за Нечувствительность (с. B142).</description-loc>
		<difficulty>HT/A</difficulty>
		<points>1</points>
		<reference>B219</reference>
		<categories>
			<category>Social</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shadowing</name>
		<name-loc>Слежка</name-loc>
		<description-loc>Это способность преследовать человека в толпе, не будучи замеченным. (На природе используйте умения Следопыт и Скрытность). Проводите Состязание каждый 10 минут: ваша Слежка против Зрения объекта; если вы проигрываете, то теряете субъекта, а если провальность была 5+, то он вас заметил.
Как только объект узнает, что вы за ним следите, начните проводить Состязание умений каждые 5 минут: ваша Слежка против его Слежки или Скрытности. Если он побеждает, то сумел уйти от вас. Если он проигрывает более чем на 5, то ему кажется, что он оторвался. Если вы потерпели критическую неудачу, то теряете его и следуете за другим человеком. Чтобы следить за кем-то на машине или подобном транспорте, используйте те же самые правила, но следящий получает -2; это труднее, чем преследовать человека пешком.
 Модификаторы: -2 или больше (по решению Мастера), если у вас примечательная внешность; -3, если объект знает вас.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B219</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Observation</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Stealth</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shield</name>
		<name-loc>Щит (Баклер)</name-loc>
		<description-loc>Способность использовать щит – как для блокирования, так и для атаки. Активная защита Блокированием любым видом щитов равна (Навык/2)+3, округленное вниз.

Вы должны специализироваться:

Щит (Shield): любой вид щитов, который прикрепляется к предплечью. Преимущество этого вида – вы можете держать что-либо в этой руке, недостаток – медленно одевается или снимается. Это наиболее обычная специализация.

Баклер (Buckler): любой вид щита, обычно небольшой, который владелец удерживает в руке. Баклер полностью занимает одну руку, но вы можете одеть его за один ход, а выбросить его – свободное действие.
Силовой щит (Force Shield): Способность использовать силовой щит, высокотехнологичное устройство, которое вешается на запястье и проецирует круг силового поля.
Все виды специализации относятся друг к другу с -2.</description-loc>
		<specialization>Buckler</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<block>0</block>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shield</name>
			<specialization>Force</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shield</name>
		<name-loc>Щит (Силовой)</name-loc>
		<description-loc>Способность использовать щит – как для блокирования, так и для атаки. Активная защита Блокированием любым видом щитов равна (Навык/2)+3, округленное вниз.

Вы должны специализироваться:

Щит (Shield): любой вид щитов, который прикрепляется к предплечью. Преимущество этого вида – вы можете держать что-либо в этой руке, недостаток – медленно одевается или снимается. Это наиболее обычная специализация.

Баклер (Buckler): любой вид щита, обычно небольшой, который владелец удерживает в руке. Баклер полностью занимает одну руку, но вы можете одеть его за один ход, а выбросить его – свободное действие.
Силовой щит (Force Shield): Способность использовать силовой щит, высокотехнологичное устройство, которое вешается на запястье и проецирует круг силового поля.
Все виды специализации относятся друг к другу с -2.</description-loc>
		<specialization>Force Shield</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<block>0</block>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shield</name>
			<specialization>Buckler</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shield</name>
		<name-loc>Щит (Щит)</name-loc>
		<description-loc>Способность использовать щит – как для блокирования, так и для атаки. Активная защита Блокированием любым видом щитов равна (Навык/2)+3, округленное вниз.

Вы должны специализироваться:

Щит (Shield): любой вид щитов, который прикрепляется к предплечью. Преимущество этого вида – вы можете держать что-либо в этой руке, недостаток – медленно одевается или снимается. Это наиболее обычная специализация.

Баклер (Buckler): любой вид щита, обычно небольшой, который владелец удерживает в руке. Баклер полностью занимает одну руку, но вы можете одеть его за один ход, а выбросить его – свободное действие.
Силовой щит (Force Shield): Способность использовать силовой щит, высокотехнологичное устройство, которое вешается на запястье и проецирует круг силового поля.
Все виды специализации относятся друг к другу с -2.</description-loc>
		<specialization>Shield</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B220</reference>
        <block>0</block>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (@Тип судна@)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>@Ship class@</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">air</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">airshipman</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Airshipman</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Lighter-Than-Air</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (Воздушный корабль)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>Airship</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">air</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">airshipman</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Airshipman</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Lighter-Than-Air</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (Корабль)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>Ship</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">seamanship</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">sea</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Seamanship</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Large Powerboat</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Boating</name>
			<specialization>Sailboat</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (Космолет)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>Spaceship</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">spacer</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">space</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spacer</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Low-Performance Spacecraft</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Spacecraft</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (Звездолет)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>Starship</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">spacer</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">hyperspace</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spacer</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>Low-Performance Spacecraft</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Piloting</name>
			<specialization>High-Performance Spacecraft</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shiphandling</name>
		<name-loc>Кораблевождение/ТУ (Подводная лодка)</name-loc>
		<description-loc>
Это умение полностью управлять крупным судом - капитаны обычно обладают этим умением на уровне Мастера. Умение включает в себя управление командой, скоростью и курсом судна.
Проверка этого умения необходима, когда требуется провести какой-то маневр во время боя или в шторм. Провал в бою означает, что судно пошло не туда, куда было запланировано. Во времена парусников это приведет к уменьшению эффективности выстрела из бортовых орудий (снизьте силу урона на 10% за каждое очко, на которое проверка оказалась неудачной), взятие на абордаж может оказаться осложнено (или наоборот облегчено если это вас берут на абордаж), и, наконец, привести к потере ветра или даже к столкновению! На более высоких технических уровнях это может привести к выходу из зоны поражения защитной артиллерии или глушению радиопередач. Здесь Мастер должен сам принимать решение. 
Провал умения в плохую погоду может привести к тому, что корабль затонет или получит повреждения. Что это может означать? Возможно, придется заменить пару деталей. А возможно - проводить серьезный ремонт в порту. На большинстве судов есть как минимум три человека, владеющих Кораблевождением. Кто-то из них всегда должен быть на вахте.

Критический провал при любых условиях будет означать серьезные последствия подходящего вида. В зависимости от ТУ и ситуации – бесполезное кружение, столкновение, потери среди экипажа, или просто отдачу приказа, который крайне не понравится команде (и она может решить оставить вас).

Воздушный корабль (Airship): Дирижабли и подобные крупные воздухоплавательные аппараты. По умолчанию: Летчик-5, Пилот (Воздухоплаватель)-5. Требования: Лидерство, Летчик, Навигация (воздушная).
Корабль (Ship): Надводные суда – от буксира до авианосца. Требования: Лидерство, Морская навигация, Моряк. По умолчанию: Моряк-5, Малые корабли (крупные моторные) или (парусные) -5. 
Космолет (Spaceship). Космический корабль со скоростью ниже световой. Требования: Лидерство, навигация (космическая), Космонавт. По умолчанию: Космонавт-5, пилотирование (любой космолет)-5.

Звездолет (Starship). Космический корабль со скоростью выше световой. Требования: Лидерство, навигация (гиперкосмос), Космонавт. По умолчанию: Космонавт -5, пилотирование (любой космолет)-5.
Подводная лодка (Submarine). Любые виды крупных подводных аппаратов. Требования: Лидерство, Подводник, Навигация (морская). По умолчанию: Подводник-5, Подводная лодка (крупная)-5.
Модификатор: -2, если вы ведете незнакомый вам тип корабля. -2, если вам незнаком экипаж; -2 и больше за плохое состояние судна.</description-loc>
		<specialization>Submarine</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">submariner</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">navigation</name>
				<specialization compare="is">sea</specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">leadership</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submariner</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<specialization>Large Sub</specialization>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Shortsword</name>
		<name-loc>Меч короткий</name-loc>
		<description-loc>Любой клинок с длиной лезвия 1-2 фута, и дубинки подходящего размера (например, полицейская дубинка). По умолчанию: Силовой меч-4, Средний меч-2, Нож-4, Дзитте/Сай -3, Сабля-4, Малый меч-4, Тонфа-3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jitte/Sai</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Knife</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Saber</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smallsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tonfa</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Singing</name>
		<name-loc>Пение</name-loc>
		<description-loc>Это умение приятно петь. Удачная проверка означает, что зрителям понравилось ваше пение. 
Модификаторы: -2, если зрители не понимают языка; +2, если у вас есть преимущество Голос. -2 за Заикание (c.B157).</description-loc>
		<difficulty>HT/E</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Skating</name>
		<name-loc>Коньки</name-loc>
		<description-loc>Вы заменяете этим навыком Ходьбу (c.B200), если передвигаетесь медленно, или Бег (c.B218) в случае быстрого движения. Мастер может потребовать броска, основанного на DX в ситуациях боя, опасностей, высоких скоростей и сложных маневров. Любой провал – падение, критический провал – ранение на 1d-2 случайной части тела.</description-loc>
		<difficulty>HT/H</difficulty>
		<points>1</points>
		<reference>B220</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Skiing</name>
		<name-loc>Лыжный спорт</name-loc>
		<description-loc>Это способность ездить на лыжах. Вы заменяете этим навыком Ходьбу (c.B200), если передвигаетесь медленно, или Бег (c.B218) в случае быстрого движения. Во время обычного похода вы кидаете навык раз в день.
Мастер может потребовать более частых проверок в некоторых случаях (бой и погоня, опасные маневры и ситуации). Проваленная проверка означает, что вы упали. При критическом провале случайно выбранная конечность получает 1d повреждений, и вы страдаете от соответствующих калечащих повреждений, пока не вылечитесь.</description-loc>
		<difficulty>HT/H</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Athletic</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Sleight of Hand</name>
		<name-loc>Ловкость рук</name-loc>
		<description-loc>Это умение прятать в руках небольшие предметы, выполнять фокусы с монетами, картами и т.д. Каждая успешная проверка позволит вам выполнить простой трюк; неудачная проверка означает, что вы завалили трюк. Также может помочь для кражи мелких предметов; если кто-то активно наблюдает за предметом, требуется выиграть состязание по навыку Ловкости рук против Зрения (или Наблюдения) охранника. 
Данное умение можно использовать и чтобы жульничать в игре. Успешная проверка на Ловкость рук даст +1..+5 к проверке при состязании умений в Азартных играх. Проваленная проверка приведет к тому, что вас обвинят в шулерстве!
 Модификаторы: -3, если человек, которого вы пытаетесь обмануть, обладает Обостренным зрением или сам владеет Ловкостью рук; +3 за приглушенный свет; +3 если ваш помощник отвлекает внимание; +3, если вы подготовились заранее (карты в рукаве и т.д.).</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Criminal/Street</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Filch</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Sling</name>
		<name-loc>Праща</name-loc>
		<description-loc>Это способность использовать пращу или пращу-ложку.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Slip Handcuffs</name>
		<name-loc>Снятие наручников</name-loc>
		<description-loc>Техника представляет знание определенных трюков для снятия наручников. С разрешения Мастера, вы можете выучить такую технику для других типов оков, распространенных в вашем мире.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Escape</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Criminal/Street</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
	<name>Smallsword</name>
	<name-loc>Шпага</name-loc>
	<difficulty>DX/A</difficulty>
	<points>1</points>
	<parry>0</parry>
	<default>
		<type>DX</type>
		<modifier>-5</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Shortsword</name>
		<modifier>-4</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Main-Gauche</name>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Rapier</name>
		<modifier>-3</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Saber</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
	</categories>
	<reference>B208</reference>
	<description-loc>Любой короткий (до 1 ярда) легкий колющий меч (например шпага) или одноручный короткий посох (подобный палкам, используемым в боевых искусствах Амис, Эскрима, Кали). По умолчанию: Короткий меч-4.

Будучи вооруженным фехтовальным оружием, вы получаете улучшенную премию за отступление при парировании (с. B377). 
Вы также получаете половинный штраф за повторные попытки парирования одной и той же рукой в течение одного хода (см. Парирование, с. B376).
Обратите внимание, что все фехтовальное оружие легкое, и часто ломается при парировании тяжелого оружия. Им вообще нельзя парировать цепы! Для нормального боя этим оружием вы должны быть достаточно подвижны – на все броски атаки и парирования вы получаете штраф, равный уровню нагрузки.

Навыки в пределах этой категории относятся друг к другу с -3. Они также могут относится к навыкам Мечей, как указано ниже.</description-loc>
</skill>
	<skill version="2">
		<name>Smith</name>
		<name-loc>Кузнец/ТУ (Медь)</name-loc>
		<description-loc>Это способность обрабатывать железо и другие недрагоценные металлы. Для этой работы необходима кузница, хотя кузнец может ее построить приблизительно за 30 дней при наличии подходящих материалов. 

Необходима специализация:

Медь (Copper). Включает собственно медь и ее сплавы – бронзу. По умолчанию: Ювелир-4.

Железо (Iron). Также включает сплавы и сталь.
Олово и свинец (Lead and Tin). Мягкие, «белые» металлы. По умолчанию: Ювелир-4.
Специализации зависят друг от друга по умолчанию с -4.
Навык зависит от IQ, но ST также чрезвычайно важна; некоторые инструменты имеют минимальное значение ST (например, оружие).</description-loc>
		<specialization>Copper</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jeweler</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Smith</name>
		<name-loc>Кузнец/ТУ (Железо)</name-loc>
		<description-loc>Это способность обрабатывать железо и другие недрагоценные металлы. Для этой работы необходима кузница, хотя кузнец может ее построить приблизительно за 30 дней при наличии подходящих материалов. 

Необходима специализация:

Медь (Copper). Включает собственно медь и ее сплавы – бронзу. По умолчанию: Ювелир-4.

Железо (Iron). Также включает сплавы и сталь.
Олово и свинец (Lead and Tin). Мягкие, «белые» металлы. По умолчанию: Ювелир-4.
Специализации зависят друг от друга по умолчанию с -4.
Навык зависит от IQ, но ST также чрезвычайно важна; некоторые инструменты имеют минимальное значение ST (например, оружие).</description-loc>
		<specialization>Iron</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Smith</name>
		<name-loc>Кузнец/ТУ (Олово и свинец)</name-loc>
		<description-loc>Это способность обрабатывать железо и другие недрагоценные металлы. Для этой работы необходима кузница, хотя кузнец может ее построить приблизительно за 30 дней при наличии подходящих материалов. 

Необходима специализация:

Медь (Copper). Включает собственно медь и ее сплавы – бронзу. По умолчанию: Ювелир-4.

Железо (Iron). Также включает сплавы и сталь.
Олово и свинец (Lead and Tin). Мягкие, «белые» металлы. По умолчанию: Ювелир-4.
Специализации зависят друг от друга по умолчанию с -4.
Навык зависит от IQ, но ST также чрезвычайно важна; некоторые инструменты имеют минимальное значение ST (например, оружие).</description-loc>
		<specialization>Lead &amp; Tin</specialization>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Craft</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Jeweler</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Smith</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Smuggling</name>
		<name-loc>Контрабанда</name-loc>
		<description-loc>Способность скрывать предметы в багаже, транспорте, комнатах и структурах. От обычного осмотра помогает простой бросок навыка, при внимательном осмотре требуется состязание.
Модификаторы: за специализированное снаряжение. Разница в SM между укрываемым предметом и его укрытием. Например, чтобы спрятать бутылку (SM -5) в машине (SM +3) вы будете бросать с +8.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Sociology</name>
		<name-loc>Социология</name-loc>
		<description-loc>Наука о обществе и социальных отношениях. Успешный бросок навыка позволит вам предсказать реакцию и способность к совместной работе крупной группы, реакцию на ухудшение криминальной обстановки, войну или революцию; или вычислить наиболее возможный результат взаимодействия двух групп.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Anthropology</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Psychology</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Soldier</name>
		<name-loc>Солдат/ТУ</name-loc>
		<description-loc>Отражает набор основных военных навыков – уроки, преподаваемые в тренировочном лагере или подобных местах – и боевой опыт. Этот навык доступен только служащим в армии, ополчении и др. Мастер может потребовать бросок навыка каждый раз, когда обстоятельства требуют проверки вашей дисциплины (определения подходящего момента для стрельбы, укрытия и пр.), или практических навыков выживания (как сохранить ноги в сухости и есть, когда представится возможность). Во время длительных военных действий бросок делается каждый день. Провал означает некоторую неприятность – возможно, поломку снаряжения. Критический провал – опасность: стрельба по своим, травма и пр.
Тренировка солдата включает базовые знания во многих областях, входящих в другие навыки. Например, солдат ТУ 8 изучает разборку и сборку винтовки без изучения Оружейника, использование рации без изучения Использования электроники, обустройства окопа без Инженерии и т.д. В ситуации, когда владеющий этим навыком может бросить с +4 за простоту задачи (см. Сложность задачи, с.345), Мастер может позволить вместо этого бросок по навыку Солдата. Вы не получаете такого же бонуса, как и полноценный знаток, но не получаете и ситуационного штрафа.
Навык может заменять броски других навыков только в таких ситуациях, которым обучают на тренировках. Это значит обычное использование стандартного снаряжения обычными войсками – не исследование, импровизация, создание и использование новых или секретных технологий. Также навык не может заменять оружейные навыки – они покупаются отдельно.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B221</reference>
		<categories>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Spacer</name>
		<name-loc>Космонавт</name-loc>
		<description-loc>Это способность работать в команде на борту определенного типа крупного вида транспорта. Включает знакомство с бытом, знание техники безопасности и тренированность предотвращать и ремонтировать повреждения. 
Также позволяет управлять кораблем. Навык легче, чем соответствующий навык управления. Специалисты контролируют такие действия, как прокладку курса и работу с приборами – данные передаются капитану, а он уже принимает решение о маневре и передает экипажу или рулевому. При каждом маневре кидается навык от DX, но эффективный навык не может быть выше навыка капитана.
Средний уровень навыка по экипажу представляет общую тренированность. Мастер кидает его каждый раз в бою, плохих условиях и пр.

Необходима специализация:
Летчик (Airshipman): Навык хранения и использования балласта, газовых вентилей, тросов и пр. на борту крупного воздухоплавательного аппарата. 
Моряк (Seamanship): Навык использования якорей, веревок, парусов и пр. на борту крупного надводного корабля (не подводной лодки). 
Космонавт (Spacer): Навык работы с шлюзами, воздушными пробками, причальными системами и пр. на борту крупного космолета или космической базы. 
Подводник (Submariner): Навык работы с шлюзами, насосами, вентилями и прочим оборудованием на подводной лодке или морской базе.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Spear</name>
		<name-loc>Копье</name-loc>
		<description-loc>Любое длинное сбалансированное оружие с колющим наконечником – копья, дротики, трезубцы, штыки. По умолчанию: Алебарда-4, посох-2.
Все оружие этого вида требует двух рук.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Polearm</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Staff</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Spear Thrower</name>
		<name-loc>Копьеметалка</name-loc>
		<description-loc>Это устройство и умение им пользоваться отличаются от умения Метание Копья, но каждое из них по умолчанию равно другому -4. 
Копьеметалка - это длинная плоская деревяшка с прорезью и петлей на одном конце. Она увеличивает силу, с которой делается бросок копья или подобного оружия. Требуется 1 ход, чтобы поместить копье в копьеметалку после того, как оба предмета находятся в руках и готовы.
Модификаторы: -5 в тесноте (для эффективного использования сверху должно быть по крайней мере 6 футов свободного пространства).</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Thrown Weapon</name>
			<specialization>Spear</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Speed-Reading</name>
		<name-loc>Быстрое чтение</name-loc>
		<description-loc>Вы натренированы читать быстрее обычного человека. Обычно скорость чтения пропорциональна Интеллекту (точная скорость зависит от шрифта или почерка); персонаж, обладающий этим умением, увеличивает скорость чтения в 1+(Навык/10) раз. Само значения умения используется, чтобы  вычислить, сколько вы запомнили. Если вы провалили проверку умения, то должны сделать проверку IQ минус число, на которое не удалась проверка каждый раз, когда хотите вспомнить что-то из прочитанного. При обычном провале вы ничего не можете вспомнить, а при критическом – вы жестоко ошибаетесь, но считаете информацию верной!
Позже вы можете вернуться и перечитать материал, чтобы восполнить пропуски.
Модификаторы: знание языка. на вспоминание +5 за Фотографическую память, +10 за Абсолютную.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Scholarly</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Sports</name>
		<name-loc>Спорт</name-loc>
		<description-loc>Это способность хорошо играть в определенном виде спорта – возможно, достаточно хорошо даже для заработка на жизнь.
Каждый спорт является отдельным умением. Большинство из них являются DX/Средними, и по умолчанию имеют значение DX-5. Те виды, в которых важную роль играет сила (например, американский футбол, регби) также по умолчанию могут равняться ST-5. Для вспоминания основных правил вашего вида спорта делается бросок, основанный на IQ. Подробные правила, включая правила турниров и т.п. – все, что нужно для работы в качестве судьи – см. соответствующую специализацию навыка Игры (c.B197).
Некоторые из спортивных навыков могут оказаться полезными в бою. Например, Спорт (бейсбол) может дать вам право на метание гранат или камней с навыком (Спорт, бейсбол /2) +3; спорт (коррида) – использовать этот навык в качестве основы для уклонения от подобных быкам животных, а Спорт (Регби) – на вашу атаку толканием.</description-loc>
		<specialization>@Speciality@</specialization>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Athletic</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Staff</name>
		<name-loc>Посох</name-loc>
		<description-loc>Длинное сбалансированное древко без бьющего наконечника. Этот навык делает успешным использование дополнительной поверхности посоха для парирования, так что дает вам +2 на бросок парирования посохом. По умолчанию: Копье-2, Древковое оружие-4.
Все оружие этого вида требует двух рук.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry>+2</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Polearm</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spear</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Stage Combat</name>
		<name-loc>Сценический бой</name-loc>
		<description-loc>Этот навык позволяет вам безопасно выполнять постановочный бой или сражаться для развлечения. Критический провал – вы наносите рану: 1d-2 вреда случайной части тела.
Модификаторы: -4 за незнакомое оружие.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Performance</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Stealth</name>
		<name-loc>Скрытность</name-loc>
		<description-loc>Это умение прятаться и бесшумно передвигаться. Успешная проверка позволит вам спрятаться где угодно, кроме абсолютно пустой комнаты, двигаться столь тихо, что вас никто не услышит или незаметно проследовать за кем-то. (Чтобы преследовать кого-либо в толпе, используйте умение Слежка).
Если вы бесшумно передвигаетесь, а кто-то специально прислушивается в поисках незваных гостей, то Мастер проводит Состязание умений между вашей Скрытностью и Слухом противника. 
Данное умение используется и чтобы подкрасться к животному, как только вы его заметили. Успешная проверка (и примерно 30 минут) позволит вам подобраться к большинству животных на 30 ярдов. Еще одна проверка, с -5, позволит вам подобраться на 15 ярдов. После этого вам придется использовать оружейное умение, чтобы попасть по животному.
Модификаторы: минус уровень нагрузки; -5, чтобы спрятаться в местности без «естественных» укрытий; +3 или больше, если укрытий много; -5, чтобы бесшумно бежать, а не идти (бесшумная ходьба проходит со скоростью 1 ярд в секунду); -5, чтобы обмануть обладающих Необычайным обонянием.</description-loc>
		<encumbrance_penalty_multiplier>1</encumbrance_penalty_multiplier>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
			<category>Spy</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Strategy</name>
		<name-loc>Стратегия (Наземная)</name-loc>
		<description-loc>Это способность планировать боевые действия и предсказывать действия противника. Обычно этому учат военных. Успешная проверка на Стратегию позволит вам выяснить наперед военные планы противника, если только им не командует другой человек, обладающий данным умением. В таком случае Мастер проводит Состязание умений между двумя стратегами; если игровой персонаж проигрывает, то его предположение о планах врага ошибочно (т.е. Мастер предоставляет ложную информацию). Количество получаемой стратегом информации зависит от того, насколько успешна проверка, а не от того, насколько хороши планы противника. Ревущая толпа тоже использует стратегию - хотя сама этого не понимает - и ее легко разгадать.
Стратег обязан специализироваться в определенном типе стратегии: таковыми являются сухопутная, морская, космическая стратегия и др. Конкретные подразделения, находящиеся под вашим командованием, менее важны; в худшем случае стратег получит пенальти -1 или -2, командуя подразделениями другого государства или TL, если он хорошо осведомлен об их способностях.</description-loc>
		<specialization>Land</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Intelligence Analysis</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tactics</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Strategy</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Strategy</name>
		<name-loc>Стратегия (Морская)</name-loc>
		<description-loc>Это способность планировать боевые действия и предсказывать действия противника. Обычно этому учат военных. Успешная проверка на Стратегию позволит вам выяснить наперед военные планы противника, если только им не командует другой человек, обладающий данным умением. В таком случае Мастер проводит Состязание умений между двумя стратегами; если игровой персонаж проигрывает, то его предположение о планах врага ошибочно (т.е. Мастер предоставляет ложную информацию). Количество получаемой стратегом информации зависит от того, насколько успешна проверка, а не от того, насколько хороши планы противника. Ревущая толпа тоже использует стратегию - хотя сама этого не понимает - и ее легко разгадать.
Стратег обязан специализироваться в определенном типе стратегии: таковыми являются сухопутная, морская, космическая стратегия и др. Конкретные подразделения, находящиеся под вашим командованием, менее важны; в худшем случае стратег получит пенальти -1 или -2, командуя подразделениями другого государства или TL, если он хорошо осведомлен об их способностях.</description-loc>
		<specialization>Naval</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Intelligence Analysis</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tactics</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Strategy</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Strategy</name>
		<name-loc>Стратегия (Космическая)</name-loc>
		<description-loc>Это способность планировать боевые действия и предсказывать действия противника. Обычно этому учат военных. Успешная проверка на Стратегию позволит вам выяснить наперед военные планы противника, если только им не командует другой человек, обладающий данным умением. В таком случае Мастер проводит Состязание умений между двумя стратегами; если игровой персонаж проигрывает, то его предположение о планах врага ошибочно (т.е. Мастер предоставляет ложную информацию). Количество получаемой стратегом информации зависит от того, насколько успешна проверка, а не от того, насколько хороши планы противника. Ревущая толпа тоже использует стратегию - хотя сама этого не понимает - и ее легко разгадать.
Стратег обязан специализироваться в определенном типе стратегии: таковыми являются сухопутная, морская, космическая стратегия и др. Конкретные подразделения, находящиеся под вашим командованием, менее важны; в худшем случае стратег получит пенальти -1 или -2, командуя подразделениями другого государства или TL, если он хорошо осведомлен об их способностях.</description-loc>
		<specialization>Space</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Intelligence Analysis</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Tactics</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Strategy</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Streetwise</name>
		<name-loc>Знание улиц</name-loc>
		<description-loc>Это способность уживаться в грубой компании. Успешная проверка Знания улиц помимо прочего позволит вам выяснить, где происходят нелегальные дела того или иного рода; какого местного копа или чиновника и за сколько можно подкупить; как связаться с преступным миром и т.д. Обратите внимание, что если вы принадлежите к организации с хорошими связями (Гильдия убийц, Братство, полиция, Иллюминати и т.д.), то можете получить информацию, опросив своих знакомых. «Знание улиц» показывает вашу способность заводить в случае необходимости собственные контакты.
Каждый раз, когда требуется бросок на реакцию со стороны преступного мира или «неприятных соседей», вы можете заменить его проверкой на Знание улиц; к этой проверке применяются все обычные модификаторы к реакции. Успешная проверка приведет к «Хорошей» реакции. Проваленная проверка вызовет «Плохую» реакцию. 
Модификаторы, применяемы только к этой проверке на Влияние: +3, если у вас крепкая репутация (как «хорошая», так и «плохая») в этом районе; -3, если видно, что вы здесь чужак.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Submarine</name>
		<name-loc>Подводные лодки/ТУ (Легкие подводные лодки)</name-loc>
		<description-loc>Это способность управлять определенным типом подводной техники. Как и в пилотировании, умолчание идет от IQ, но навык изучается от DX.
Бросок навыка делается для погружения и всплытия, маневрирования и избегания опасностей. Провал может означать что угодно – от легкого дрейфа до столкновения; критический провал может привести к затоплению.
Бросок, основанный на IQ делается, чтобы понять основные карты, вспомнить морские законы и предписания.
Специализация необходима:
Открытый аппарат (Free-flooding Sub): любой открытый небольшой подводный аппарат. Экипаж находится в воде, и должен одевать снаряжение для подводного дыхания. Требования: навык работы с подводным снаряжением. По умолчанию: Крупные корабли-5, Малые корабли -4.
Крупные корабли (Large Sub). Любые подводные лодки долгосрочного плавания, включая боевые и ракетные. По умолчанию: открытый аппарат -5 или Малые корабли -4.
Малые корабли (Mini-sub). Любые небольшие аппараты для краткосрочного погружения, обычно научные. По умолчанию: открытый аппарат -5 или крупные корабли -4.
Модификаторы: -2 за незнакомый вид подводного аппарата (дизельная боевая п/л, когда вы используете ядерную ракетную), -4 и больше за плохое состояние аппарата, от -1 до -10 за навигационные опасности.</description-loc>
		<specialization>Free-Flooding Sub</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<prereq_list all="no">
			<skill_prereq has="yes">
				<name compare="is">diving suit</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">scuba</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<specialization>Large Sub</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<specialization>Mini-Sub</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Submarine</name>
		<name-loc>Подводные лодки/ТУ (Крупные подводные лодки)</name-loc>
		<description-loc>Это способность управлять определенным типом подводной техники. Как и в пилотировании, умолчание идет от IQ, но навык изучается от DX.
Бросок навыка делается для погружения и всплытия, маневрирования и избегания опасностей. Провал может означать что угодно – от легкого дрейфа до столкновения; критический провал может привести к затоплению.
Бросок, основанный на IQ делается, чтобы понять основные карты, вспомнить морские законы и предписания.
Специализация необходима:
Открытый аппарат (Free-flooding Sub): любой открытый небольшой подводный аппарат. Экипаж находится в воде, и должен одевать снаряжение для подводного дыхания. Требования: навык работы с подводным снаряжением. По умолчанию: Крупные корабли-5, Малые корабли -4.
Крупные корабли (Large Sub). Любые подводные лодки долгосрочного плавания, включая боевые и ракетные. По умолчанию: открытый аппарат -5 или Малые корабли -4.
Малые корабли (Mini-sub). Любые небольшие аппараты для краткосрочного погружения, обычно научные. По умолчанию: открытый аппарат -5 или крупные корабли -4.
Модификаторы: -2 за незнакомый вид подводного аппарата (дизельная боевая п/л, когда вы используете ядерную ракетную), -4 и больше за плохое состояние аппарата, от -1 до -10 за навигационные опасности.</description-loc>
		<specialization>Large Sub</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<specialization>Free-Flooding Sub</specialization>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<specialization>Mini-Sub</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Submarine</name>
		<name-loc>Подводные лодки/ТУ (Мини подводная ложка)</name-loc>
		<description-loc>Это способность управлять определенным типом подводной техники. Как и в пилотировании, умолчание идет от IQ, но навык изучается от DX.
Бросок навыка делается для погружения и всплытия, маневрирования и избегания опасностей. Провал может означать что угодно – от легкого дрейфа до столкновения; критический провал может привести к затоплению.
Бросок, основанный на IQ делается, чтобы понять основные карты, вспомнить морские законы и предписания.
Специализация необходима:
Открытый аппарат (Free-flooding Sub): любой открытый небольшой подводный аппарат. Экипаж находится в воде, и должен одевать снаряжение для подводного дыхания. Требования: навык работы с подводным снаряжением. По умолчанию: Крупные корабли-5, Малые корабли -4.
Крупные корабли (Large Sub). Любые подводные лодки долгосрочного плавания, включая боевые и ракетные. По умолчанию: открытый аппарат -5 или Малые корабли -4.
Малые корабли (Mini-sub). Любые небольшие аппараты для краткосрочного погружения, обычно научные. По умолчанию: открытый аппарат -5 или крупные корабли -4.
Модификаторы: -2 за незнакомый вид подводного аппарата (дизельная боевая п/л, когда вы используете ядерную ракетную), -4 и больше за плохое состояние аппарата, от -1 до -10 за навигационные опасности.</description-loc>
		<specialization>Min-Sub</specialization>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B222</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Submarine</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Submariner</name>
		<name-loc>Подводник</name-loc>
		<description-loc>Это способность работать в команде на борту определенного типа крупного вида транспорта. Включает знакомство с бытом, знание техники безопасности и тренированность предотвращать и ремонтировать повреждения. 
Также позволяет управлять кораблем. Навык легче, чем соответствующий навык управления. Специалисты контролируют такие действия, как прокладку курса и работу с приборами – данные передаются капитану, а он уже принимает решение о маневре и передает экипажу или рулевому. При каждом маневре кидается навык от DX, но эффективный навык не может быть выше навыка капитана.
Средний уровень навыка по экипажу представляет общую тренированность. Мастер кидает его каждый раз в бою, плохих условиях и пр.

Необходима специализация:
Летчик (Airshipman): Навык хранения и использования балласта, газовых вентилей, тросов и пр. на борту крупного воздухоплавательного аппарата. 
Моряк (Seamanship): Навык использования якорей, веревок, парусов и пр. на борту крупного надводного корабля (не подводной лодки). 
Космонавт (Spacer): Навык работы с шлюзами, воздушными пробками, причальными системами и пр. на борту крупного космолета или космической базы. 
Подводник (Submariner): Навык работы с шлюзами, насосами, вентилями и прочим оборудованием на подводной лодке или морской базе.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/E</difficulty>
		<points>1</points>
		<reference>B185</reference>
		<categories>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Suggest</name>
		<name-loc>Внушение</name-loc>
		<description-loc>
В фентези барды часто имеют способность влиять на других, рассказывая им истории. Мастер может представить эту способность в виде нескольких родственных навыков. В зависимости от сеттинга, этот навык может быть магическим, псионическим или просто формой гипноза. Каждый навык имеет свое время использования и действия, а также цену усталости. См B191
Эта способность позволяет вам сделать аудитории одно простое внушение. Внушение должно не иметь сложных грамматических конструкций – подлежащее, сказуемое и еще максимум два слова. «Убейте короля!» - подходящее внушение, «Убейте короля, если он не примет наших условий!» - нет. Если внушение конфликтует с личной безопасностью, бросок сопротивления делается с +5; если идет против веры, знаний или убеждений – то с +3.
В случае победы в быстром состязании, члены аудитории стараются действовать на максимуме возможностей, считая эту идею своей собственной.
Время на воздействие – 20 минут непрерывного рассказа.
Цена: 6 FP, независимо от успеха.
Продолжительность: 10 минут, или дольше, если вы продолжаете воздействие и делаете бросок Внушения каждые 10 минут. После прекращения действия слушатели могут только удивляться, как это им в голову могло прийти (если они так никогда не делают)</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B191</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">persuade</name>
				<specialization compare="is"></specialization>
				<level compare="at least">12</level>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">public speaking</name>
				<specialization compare="is"></specialization>
				<level compare="at least">12</level>
			</skill_prereq>
			<advantage_prereq has="yes">
				<name compare="is">charisma</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	</skill>
	<skill version="2">
		<name>Sumo Wrestling</name>
		<name-loc>Борьба Сумо</name-loc>
		<description-loc>Это навык рукопашной борьбы, состоящей из захватов, толканий и сбиваний, а не конкретный традиционный японский вид борьбы. Навык может заменить DX в любом из бросков, когда вы пытаетесь провести захват, атаку толканием или сбиванием, либо сопротивляться ему. Если вы знакомы с этим навыком на уровне DX+1, ваша сила увеличивается на +1 для сопротивления захвата или сбивания, а также попытки освободиться из захвата, а также увеличивается вред на +1 за кубик, когда вы толкаете или сбиваете противника. Эти премии увеличиваются до +2, если навык вам известен на уровне DX+2 или лучше.
Когда вы защищаетесь голыми руками, Борьба Сумо позволяет вам парировать один раз за ход, используя обе руки. Ваш бросок парирования делается против (навык/2)+3, округляется вниз. Поскольку вы больше привыкли парировать захваты и толчки, вы получаете -2 на парирование ударов ногами, и -3 против оружия. Полные правила по парированию голыми руками см.B376.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Surgery</name>
		<name-loc>Хирургия/ТУ</name-loc>
		<description-loc>
Это умение используется, когда кто-либо пытается оперировать персонажа, чтобы излечить заболевание, повреждение или расстройство в организме. Удачная проверка умения означает, что операция прошла без осложнений. Проваленная проверка означает, что пациент получил 2d повреждений при выполнении простой ампутации и т.д., 3d при более сложном вмешательстве. 
Хирург обычно выбирает опциональную специализацию в какой-то определенной части тела (мозг, сердце) или в определенном виде операций (косметическая, микрохирургия, трансплантация и пр.).
Модификаторы: снаряжение и знание физиологии; -3, если операция проходит на голове или грудной клетке; -5, если проблема не диагностирована; -3 или хуже, если оборудование как следует не отчищено и не стерилизовано. Если вы не знакомы с навыком Врачебное дело, вы получаете -5 на любые операции, кроме самых элементарных – обработка ран, извлечение пуль и осколков.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Medical</category>
		</categories>
		<prereq_list all="no">
			<skill_prereq has="yes">
				<name compare="is">first aid</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">physician</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
		</prereq_list>
		<default>
			<type>Skill</type>
			<name>First Aid</name>
			<modifier>-12</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physiology</name>
			<modifier>-8</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Veterinary</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (@Где@)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>@Environment@</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Арктика)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Arctic</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swamplands</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Побережье)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Bank</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Глубины)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Deep Ocean Vent</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Пустыня)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Desert</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Пресноводные озера)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Fresh-Water Lake</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Пляж, остров)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Island/Beach</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Джунгли)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Jungle</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Горы)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Mountain</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Океан)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Open Ocean</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Равнины)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Plains</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Рифы)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Reef</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Реки)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>River/Stream</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Соленые водоемы)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Salt-Water Sea</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Tropical Lagoon</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Болота)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Swampland</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Woodlands</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Тропические лагуны)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Tropical Lagoon</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Bank</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Deep Ocean Vent</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Fresh-Water Lake</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Open Ocean</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Reef</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Salt-Water Sea</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>River/Stream</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Survival</name>
		<name-loc>Выживание (Леса)</name-loc>
		<description-loc>Это умение выживать на природе, находить подходящую пищу и воду, избегать опасностей, строить жилище и т.д. Один человек с этим умением может прокормить до десяти спутников. Каждый день нужно делать проверку умения, чтобы безопасно (или даже с удобствами) жить в дикой местности. Проваленная проверка означает, что каждый член группы получает 2d-4 повреждений (отдельный бросок для каждого).
Это умение также позволяет лучше ориентироваться на местности. Его можно использовать, чтобы выбрать правильное направление при поиске воды, горного прохода, или чего угодно другого, что вообще существует.
Также это умение используется, когда нужно поймать в ловушку диких зверей (городской вор может использовать свое умение Ловушки, но из-за различий он получит пенальти -5). Делайте одну проверку для каждой установленной ловушки. Ловушка создается из подручных материалов за 30 минут. Купленную ловушку устанавливают и прячут 10 минут. Конечно, копание ямы-ловушки для большого зверя займет несколько часов.
Необходима специализация по типу местности (Арктика, Пустыня, Пляж/остров, Джунгли, Горы, Равнины, Болота, Леса, Океан, Глубины, Подземелья, Соленые водоемы, Пресные водоемы, и пр.). Наземные виды местности относятся друг к другу с -3, водные – с -4. В кампаниях с возможностью путешествовать между мирами, вы также должны специализироваться на определенном мире. По умолчанию тот же тип местности на другой планете будет зависеть от текущей с -4, и еще с -4, если другой тип местности. Значение по умолчанию доступно только для планет того же типа
Часто бросок Выживания требуется сделать, основываясь на другом атрибуте – ST для выкапывания ловушки или убежища, DX для извлечения огня примитивным методом, НТ для избегания желудочных расстройств при непривычном питании.
Модификаторы: до -5 при плохих погодных условиях; модификаторы за снаряжение.</description-loc>
		<specialization>Woodlands</specialization>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B223</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Arctic</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Desert</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Island/Beach</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Jungle</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Mountain</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Plains</specialization>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Survival</name>
			<specialization>Swampland</specialization>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Sway Emotions</name>
		<name-loc>Внушение эмоций</name-loc>
		<description-loc>
В фентези барды часто имеют способность влиять на других, рассказывая им истории. Мастер может представить эту способность в виде нескольких родственных навыков. В зависимости от сеттинга, этот навык может быть магическим, псионическим или просто формой гипноза. Каждый навык имеет свое время использования и действия, а также цену усталости. См B191
Позволяет внушить аудитории одну эмоцию. Допустимые эмоции включают гнев, скуку, депрессию, отвращение, страх, жадность, ненависть, ревность, радость, любовь, страсть, патриотизм, мир, печаль, и беспокойство.
В случае успеха, аудитория испытывает выбранную эмоцию. Их действия – на усмотрение Мастера.
Время: 10 минут непрерывного рассказа.
Цена: 4 FP, независимо от успеха.
Продолжительность: 1 час.</description-loc>
		<difficulty>Will/H</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Social</category>
		</categories>
	</skill>
	<technique version="2" limit="0">
	<name>Sweep</name>
	<name-loc>Подсечка</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>@Two-Handed Weapon Skill@</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweep</name>
	<name-loc>Подсечка</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Polearm</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweep</name>
	<name-loc>Подсечка</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Spear</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweep</name>
	<name-loc>Подсечка</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Staff</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweeping Kick</name>
	<name-loc>Подсекающий ногой</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>@Unarmed Combat Skill@</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweeping Kick</name>
	<name-loc>Подсекающий ногой</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Judo</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweeping Kick</name>
	<name-loc>Подсекающий ногой</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Karate</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<technique version="2" limit="0">
	<name>Sweeping Kick</name>
	<name-loc>Подсекающий ногой</name-loc>
	<difficulty>H</difficulty>
	<points>1</points>
	<default>
		<type>Skill</type>
		<name>Sumo Wrestling</name>
		<modifier>-3</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Melee Combat</category>
		<category>Technique</category>
	</categories>
	<reference>B232, MA81</reference>
	<description-loc>Эта техника позволяет цеплять древком ногу противника, выводя его из равновесия. Для попадания делается бросок против уровня Подсечки. Цель может защищаться нормально. При провале защиты делается быстрое состязание: с вашей стороны - навык Подсечки или ST против ST или DX жертвы (в обоих случаях используется высшее значение). Если жертва проигрывает состязание, она падает - если не сделает бросок Акробатики-5, чтобы кувыркнуться в воздухе и приземлиться на ноги.
Эта техника может использоваться и в рукопашном бою (Sweeping Kick). Действует она точно также, но вместо древка оружия используется нога, и уровень по умолчанию равен Дзюдо-3, Карате-3 или Борьба сумо -3.
</description-loc>
</technique>
	<skill version="2">
		<name>Swimming</name>
		<name-loc>Плавание</name-loc>
		<description-loc>Это умение используется и для плаванья (по собственной воле или при падении в воду) и для спасения утопающих. Во время плавания для бросков на усталость и избежание водных опасностей бросается высшее из значений НТ и Плавания. Во время состязания с кем-либо, имеющим такую же скорость, используется быстрое состязание по навыку Плавания для определения победителя (см. Плавание, с. B354).
Не включает навык прыжков с вышки (для этого используется соответствующая специализация навыка Спорт).</description-loc>
		<encumbrance_penalty_multiplier>2</encumbrance_penalty_multiplier>
		<difficulty>HT/E</difficulty>
		<points>1</points>
		<reference>B224</reference>
		<categories>
			<category>Athletic</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>HT</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Symbol Drawing</name>
		<name-loc>Рисование символов (@Специализация@)</name-loc>
		<description-loc>Искусство рисования символов, используемых в магических ритуалах – как принято в ваших традициях: ножом в камне, кровью, чернилами, в воздухе и пр. Специализация по магической культуре необходима.
Если рисуемые символы используются в ритуальной магии, когда магия происходит из природы, мага или имеет другую внешнюю природу, будучи хорошо нарисованными, они могут помочь заклинанию. За каждые 2 очка успешности броска рисования символов, можно добавить +1 к ритуалу. Такая специальность Рисования символов может относиться по умолчанию к Ритуальной магии (той же специализации) -4.
В традициях, где символы собственно представляют магию и наделяют волшебными силами предметы, магия будет хороша настолько, насколько хорошо нарисованы символы. В этом случае навык Рисование символов заменяет навык Наложение чар (используется низшее из значений). Наиболее обычный пример такой магии – рунная магия. Каждый рунный алфавит – отдельная специализация.
Модификаторы: -1 или хуже за незнакомый способ рисования, -1 или хуже за непривычную поверхность.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B224</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Tactics</name>
		<name-loc>Тактика</name-loc>
		<description-loc>Это способность перехитрить противника в бою один на один или небольшими группами – пока вы можете лично (максимум – через одного) командовать каждым (радиосвязь здорово улучшает вашу способность командования). Обычно этому учат только военных. 
Успешная проверка на Тактику позволяет хорошо устроить засаду, расставить наблюдателей, а в ходе боя иногда (по решению Мастера) позволит вам получить информацию о ближайших планах противника (быстрое состязание по навыку тактики). 
Успешный бросок навыка перед началом боя (если у вас было хоть немного времени) дает вам более выгодную позицию – чем лучше бросок, тем больше преимущество. Если вы не использовали навык, или провалили его проверку, стартовые позиции в начале боя определяет Мастер.
Даже в случае попадания в засаду или подобной внезапной ситуации, Мастер может вам позволить использовать лучшее значение из Тактики и Восприятия(Per), чтобы определить, заметили ли вы опасность вовремя.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B224</reference>
		<categories>
			<category>Military</category>
			<category>Police</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Strategy</name>
			<modifier>-6</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Teaching</name>
		<name-loc>Обучение</name-loc>
		<description-loc>Это способность учить других. Чтобы научить кого-то, вы должны знать умение, которое преподаете, лучше своего ученика. Любой, у кого Обучение 12+, в игре обычно может выступать в роли учителя. 
Модификаторы: -3 за Безжалостность (c.B125), -1 до -4 за Застенчивость (c.B142). штрафы за знание языка применяются и со стороны учителя, и со стороны ученика.</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B224</reference>
		<categories>
			<category>Scholarly</category>
			<category>Social</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Teamster</name>
		<name-loc>Кучер (@Специализация@)</name-loc>
		<description-loc>Это умение управлять упряжками животных, такими как лошади, впряженные в карету или тянущие пушку. Оно включает в себя умения запрягать животных, заботиться о них и умение судить о возможностях животного до приобретения. Если животное плохо обучено, вы сначала должны сделать бросок Обращения с животными.
Во время обычного путешествия бросок навыка делается раз в день. Когда лошади, впряженные в карету или тянущие иной груз (например, пушку), мчатся галопом (80% или больше максимальной скорости), то возница должен делать проверку умения Кучер каждые 10 секунд. 
Проваленная проверка означает, что повозка перевернулась. Это равно падению с высоты 5 ярдов (5d-10 повреждений) для каждого человека и животного. Чтобы успокоить всех животных, нужно применить умение Приручение животных. И еще, для каждого животного киньте два кубика; выпадение 12 означает, то это животное сломало ногу! Время, требуемое, чтобы вернуть груз на место, зависит от груза, местности и погоды.
Необходима специализация по видам. По умолчанию они равняются друг другу с модификатором -3. Лошади и мулы включены в одну специализацию.
Модификаторы: -2 за 5 и более животных в упряжке, -2 за незнакомых животных, -5 и больше за плохую местность.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B225</reference>
		<categories>
			<category>Animal</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>@Specialty@</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Riding</name>
			<specialization>@Specialty@</specialization>
			<modifier>-2</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Teamster</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Teamster</name>
		<name-loc>Кучер (Лошади)</name-loc>
		<description-loc>Это умение управлять упряжками животных, такими как лошади, впряженные в карету или тянущие пушку. Оно включает в себя умения запрягать животных, заботиться о них и умение судить о возможностях животного до приобретения. Если животное плохо обучено, вы сначала должны сделать бросок Обращения с животными.
Во время обычного путешествия бросок навыка делается раз в день. Когда лошади, впряженные в карету или тянущие иной груз (например, пушку), мчатся галопом (80% или больше максимальной скорости), то возница должен делать проверку умения Кучер каждые 10 секунд. 
Проваленная проверка означает, что повозка перевернулась. Это равно падению с высоты 5 ярдов (5d-10 повреждений) для каждого человека и животного. Чтобы успокоить всех животных, нужно применить умение Приручение животных. И еще, для каждого животного киньте два кубика; выпадение 12 означает, то это животное сломало ногу! Время, требуемое, чтобы вернуть груз на место, зависит от груза, местности и погоды.
Необходима специализация по видам. По умолчанию они равняются друг другу с модификатором -3. Лошади и мулы включены в одну специализацию.
Модификаторы: -2 за 5 и более животных в упряжке, -2 за незнакомых животных, -5 и больше за плохую местность.</description-loc>
		<specialization>Equines</specialization>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B225</reference>
		<categories>
			<category>Animal</category>
			<category>Vehicle</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<specialization>Equines</specialization>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Riding</name>
			<specialization>Equines</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thaumatology</name>
		<name-loc>Тауматология</name-loc>
		<description-loc>Это умение покрывает академические знания о теории магии. Тауматология изучает "физику" маны и магии. Не маги могут изучать это умение, но это будет проще для магов; добавьте уровень Магических способностей к значению IQ при изучении этого умения, так же как для заклинаний (у магов есть "практические знания", которые им помогают!).
Это умение в большей степени применяется в магических исследованиях. При создании новых заклинаний используются правила по изобретениям (см. Главу 17), но навык Инженера заменяется на Тауматологию. Также оно может пригодиться для определения неизвестных заклинаний или при неожиданных критических неудачах или успехах при колдовстве. Оно может помочь понять, что возможно сделать магией или как правильно заколдовать магический предмет, чтобы он вёл себя как надо. Чем лучше успех при проверке умения, тем сильнее вы проникаете в суть проблемы.
Этот навык – наука о фентези-магии, классической системе заклинаний – огненные шары, кольца силы и т.д. Эквивалент науки для традиционного спиритуалистического волшебства – Ритуальная магия (с. B218), божественная магия изучается Религиозными обрядами (c.B217) или Теологией (c.B226). Однако Мастер может позволить бросать Тауматологию с -5, в случае наличия каких-то связей с этими дисциплинами.
Очевидно, что уровень по умолчанию доступен только тем, кто имел возможность изучить хоть что-то о настоящей магии.</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B225</reference>
		<categories>
			<category>Occult/Magical</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-7</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Theology</name>
		<name-loc>Теология (@Специализация@)</name-loc>
		<description-loc>Это наука о религии. Теолог знает о древних и современных религиозных воззрениях, истории религии и т.д. Теолог не обязан верить в то, что изучает. Обычно между разными религиями не позволяется значение по умолчанию. Специализация необходима, но возможна «Сравнительная теология» - когда вы специализируетесь на различиях и сходствах разных религий.
Для любых священнослужителей на ТУ 1+ необходимо знание Теологии и Религиозных обрядов. На ТУ 0 можно обойтись лишь Ритуалами. 
В случае, если вы верующий человек, то при моральном выборе Мастер может сделать тайный бросок навыка Теологии, и в случае успеха подсказать вам правильное решение.</description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Social Sciences/Humanities</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Religious Ritual</name>
			<specialization>@Specialty@</specialization>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Throwing</name>
		<name-loc>Метание</name-loc>
		<description-loc>Это способность бросать небольшие, относительно ровные предметы (бейсбольные мячи, гранаты, камни и пр.). Бумеранги, копья, ножи и прочее оружие требует собственной специализации. Она влияет и на точность (делайте проверку умения Метания, чтобы бросить что-либо, что вы можете поднять), и на дистанцию броска (добавьте +1 к своей ST при вычислении дистанции броска (но не повреждений), если вы знаете навык Метание на уровне DX+1, и +2, если на уровне DX+2 и выше). Если вы не владеете этим умением, то делайте проверку DX-3 , когда пытаетесь попасть по цели, или DX, когда хотите просто запустить предмет в некоторую зону. Если вы кидаете что-то, для чего существует специальное умение, то используйте это умение.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Athletic</category>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Dropping</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Throwing Art</name>
	<name-loc>Искусство метания</name-loc>
	<difficulty>DX/H</difficulty>
	<points>1</points>
	<prereq_list all="no">
		<advantage_prereq has="yes">
			<name compare="starts with">weapon master</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
		<advantage_prereq has="yes">
			<name compare="is">trained by a master</name>
			<notes compare="is anything"></notes>
		</advantage_prereq>
	</prereq_list>
	<categories>
		<category>Esoteric</category>
	</categories>
	<reference>B226</reference>
	<description-loc>
Это киношная способность метать все, что вы можете поднять: ножи, телевизоры, мячи… все! Для попадания делается бросок навыка. Дальше, если вы знакомы с Искусством метания на уровне DX, для определения расстояния броска ваша ST увеличивается на 1, а наносимые броском повреждения – на 1 за кубик. Эти премии увеличиваются до +2, если ваш навык Искусства метания DX+1 или лучше. Если вы также Мастер оружия, этот бонус используется вместо обычного бонуса повреждения для вашего оружия.
Вы можете использовать метаемые предметы в качестве импровизированного оружия. Вилки, кухонные ножи и другие длинные небольшие предметы считаются за кинжалы. Любой небольшой тупой предмет наносит прм+1 тупого вреда. Бесбольные биты –  амп+1 тупого. Карандаши нанесут прм-3 проникающего вреда, а игральные карты – прм-3 режущего.
Искусство метания позволяет кидать и все, что входит в навыки Метания и Метательного оружия. Если вы постигли Искусство метания, вам не нужны эти навыки.
Премия к повреждению за Искусство метания применима только к специальному метательному оружию, и не складывается с премией повреждений за Мастера оружия. Ни один из бонусов не применяется к импровизированному оружию из Базовых книг.</description-loc>
</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (@Специализация@)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>@Specialty@</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Топор/Дубина)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Axe/Mace</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
	<name>Thrown Weapon</name>
	<name-loc>Метание оружия (Дротик)</name-loc>
	<specialization>Dart</specialization>
	<difficulty>DX/E</difficulty>
	<points>1</points>
	<default>
		<type>DX</type>
		<modifier>-4</modifier>
	</default>
	<default>
		<type>Skill</type>
		<name>Throwing</name>
		<modifier>-2</modifier>
	</default>
	<categories>
		<category>Combat/Weapon</category>
		<category>Ranged Combat</category>
	</categories>
	<reference>B226</reference>
	<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дротик (Dart): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Гарпун)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Harpoon</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Thrown Weapon</name>
			<specialization>Spear</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Нож)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Knife</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Сюрикен)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Shuriken</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Throwing</name>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Копье)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Spear</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Spear Thrower</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Thrown Weapon</name>
			<specialization>Harpoon</specialization>
			<modifier>-2</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Thrown Weapon</name>
		<name-loc>Метание оружия (Палка)</name-loc>
		<description-loc>Это способность бросать любой один тип метательного оружия. Специализация необходима.

Топор/булава (Axe/Mace): любой топор или булава, сбалансированные для метания (но не боевая секира!).

Дан (Dan): любой небольшой оперенный дротик. По умолчанию – метание-2.

Гарпун (Harpoon): любое привязанное копье. По умолчанию – Копье-2.

Нож (Knife): любые виды ножей.

Сюрикен (Shuriken): Любой вид клинков без рукоятки, чаще – метательные звезды. По умолчанию – метание-2.

Копье (Spear) – любое копье или дротик. По умолчанию – копьеметалка-4 или гарпун-2.
Палка (Stick): любая сбалансированная метательная палка, подобная бумерангу. Она не возвращается к метнувшему.
Диск (Disc): плоский круглый снаряд, которому при метании сообщается вращение – наподобие Римского диска или индийского чакрам. </description-loc>
		<specialization>Stick</specialization>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Combat/Weapon</category>
			<category>Ranged Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Tonfa</name>
		<name-loc>Тонфа</name-loc>
		<description-loc>Тонфа – дубинка с дополнительной рукояткой сбоку, ближе к одному из концов. Ее можно использовать как дубинку, но вы также можете использовать ее как дополнительную защиту рук, держа за рукоятку и расположив длинное плечо вдоль предплечья. Это позволит вам наносить более сильные удары (кол+1 тупого вреда) и парировать атаки без штрафов. Для изменения хвата сделайте бросок навыка – при успехе смена хвата происходит свободным действием, иначе – занимает полный ход. По умолчанию: Короткий меч-3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Shortsword</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Tracking</name>
		<name-loc>Следопыт</name-loc>
		<description-loc>Это умение двигаться за человеком или зверем по его следам. Одна проверка умения требуется, чтобы найти след, частота бросков для следования зависит от сложности среды:
* Равнины, Джунгли, Лес: раз в 30 минут; 
* Пустыня, Горы, Арктика, Остров/Пляж: раз в 15 минут с -2.
* Болота: раз в 5 минут с -4.
* Город: раз в минуту с -6!
Это умение также используется, если вы хотите замести свои следы. (Если вы это делаете, то время путешествия увеличивается в два раза). Удачная проверка умения означает, что вы замели следы достаточно хорошо и их никто не заметит, разве что кто-то с этим же умением. Если за вами следует другой следопыт, то Мастер будет проводить между вами состязание умений Следопыт с описанными выше модификаторами. Одна проверка будет делаться через каждую милю пути. Если  в какой-то момент идущие по следам теряют след, то они теряют его окончательно.
Чтобы преследовать вблизи животное, которое вы отследили, используйте умение Скрытность (B222).
Модификаторы: -5, если следы были оставлены более дня назад, -10, если следам больше недели; +5, если вы идете по человеческим следам, +10, если вы идете по следам группы людей. То, по какой местности вы идете, тоже играет свою роль, пенальти составляет -3 в пустыни, -5 на сухих камнях, -10 на улице города! Все бонусы за наличие других видов зрения также учитываются.</description-loc>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Naturalist</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Traps</name>
		<name-loc>Ловушки/ТУ</name-loc>
		<description-loc>Это навык установки, обнаружения, а также обезвреживания ловушек. Успешная проверка умения Ловушки помимо прочего позволит обнаружить ловушку, если вы ее ищете; отключить обнаруженную ловушку; вновь поставить ловушку после того, как вы ее миновали. Обратите внимание, что «ловушка» может быть чем угодно, начиная от ямы с кольями и заканчивая тщательно спланированной системой безопасности! Время: Так же, как и для Взлома (B206). 
Также помните, что если вы не обладаете этим умением, то уровень по умолчанию от DX (DX-5) используется лишь для обезвреживания или возвращения ловушки в исходное состояние, но НЕ для ее нахождения или создания новой западни!
Обратите внимание, что при TL7 и выше умение Ловушки – это практически то же самое, что и Электроника (Системы безопасности). Также, системы обнаружения и наблюдения также попадают под этот навык.
Модификаторы: Сильно различаются. Чем запутаннее ловушка, тем труднее ее будет обнаружить и обезвредить/вернуть в исходное положение. Обратите внимание, что ловушку, например, может быть легко обнаружить, но сложно обезвредить! Все это остается на усмотрение Мастера или автора приключения. Модификаторы за зрение помогут вам найти ловушку, но не обезвредить или установить ее, а за Ловкость рук - наоборот.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B226</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Military</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Lockpicking</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Two-Handed Axe/Mace</name>
		<name-loc>Топор/булава, двуручный</name-loc>
		<description-loc>Длинные двуручные виды рубящего оружия – бита, кувалда, боевой молот. По умолчанию: Алебарда-4, Двуручный цеп-4.
Такое оружие не может парировать, если вы им уже атаковали в этот ход. Навыки в этой категории относятся друг к другу с -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B208</reference>
        <parry after-attack="no">0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Axe/Mace</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Polearm</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Flail</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Two-Handed Flail</name>
		<name-loc>Цеп двуручный</name-loc>
		<description-loc>Любой двуручный цеп. По умолчанию: Кусари-4, Двуручный топор/булава-4.</description-loc>
		<difficulty>DX/H</difficulty>
		<points>1</points>
		<reference>B208</reference>
		<parry after-attack="no">0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Flail</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Kusari</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Two-Handed Axe/Mace</name>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Two-Handed Sword</name>
		<name-loc>Меч двуручный</name-loc>
		<description-loc>Любое сбалансированное оружие свыше 4 футов длиной: двуручники, великие мечи. Также используется при двуручном хвате катан, длинных и полуторных мечей, а также посохов. По умолчанию: Силовой меч-4, Средний меч-4.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Sword</name>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Typing</name>
		<name-loc>Машинопись</name-loc>
		<description-loc>Это умение пользоваться пишущей машинкой. Скорость печатания равна Навык*3 слов в минуту на печатной машинке или Навык*5 на электронной или электрической клавиатуре. По умолчанию навык может иметь значение -3 от любого навыка, требующего больших объемов набора слов, особенно Администрирование, Использование компьютера, Исследование, Письмо и некоторых из Профессиональных навыков вроде Журналиста. Если у вас есть подобные навыки, в изучении Машинописи вы не нуждаетесь (если только вы не хотите работать профессиональным наборщиком).</description-loc>
		<difficulty>DX/E</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Everyman</category>
			<category>Scholarly</category>
			<category>Technical</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Urban Survival</name>
		<name-loc>Выживание Город</name-loc>
		<description-loc>Это умение выживать в городской среде, независимо от того, переполнена она или пуста. Социальные проблемы в городе относятся к умению Знание улиц. Специалист по Выживанию в городе, к примеру, сможет найти чистую дождевую воду; обнаружить люк сверху или снизу; быстро найти вход в здание, выход, лестницу и т.д.; обнаружить и избежать физически опасных мест, к примеру, рушащихся зданий; сам сделать и прочитать городские карты, будет уметь выбраться из неизвестных районов города; найти теплое место для ночлега, когда на улице холодно; и найти нужные ему здания, не спрашивая никого, просто с помощью городского чутья.</description-loc>
		<difficulty>Per/A</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Criminal/Street</category>
			<category>Police</category>
		</categories>
		<default>
			<type>Per</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Vacc Suit</name>
		<name-loc>Скафандр/ТУ</name-loc>
		<description-loc>Это тренировка в использовании определенных защитных костюмов. Костюмы, созданные для защиты владельца от опасностей боя или окружающей среды часто имеют встроенные устройства (типа автошприцов и сенсоров) и приборы для поддержки жизнедеятельности. Некоторые костюмы даже содержат сервоприводы для увеличения ST и скорости. В результате вы не просто носите этот костюм – вы управляете им. Навык позволяет быстро одеть и снять скафандр (успешный бросок – половина времени). Для активации определенной суб-системы костюма или работы в костюме хорошем состоянии кидается бросок по IQ. В то время, когда на вас надет костюм, любой из бросков DX и навыков, на DX основанных вы кидаете против низшего значения из Скафандра и того навыка. Например, если у вас DX 14, Скрытность 15 и Скафандр 13 – вы работаете, как с DX 13 и Скрытностью 13, пока не снимете скафандр. Особенно неудобные и громоздкие костюмы будут давать штрафы к DX независимо от уровня навыка, а тонкие, высокотехнологичные костюмы могут вообще не давать штрафов.

Однако, навык работы в скафандре сильно зависит от привычки к нему. Знакомство и знания опасных ситуаций, входящих в такие навыки как Свободное падение, Опасные материалы, Выживание и прочие подобные навыки покупаются отдельно для каждого типа костюма.

Боевой костюм (Battlesuit): Все типы боевой брони и экзоскелетов со встроенным источником энергии. Боевая броня и Экзоскелеты – похожи, но не одинаковы, и считаются как за знакомство.

Водолазный костюм (Diving Suit). Все виды жестких водолазных костюмов (гибкие открытые и закрытые включены в навык Акваланг). Включает открытый костюм на ТУ 5, Жесткий шлем на ТУ 6, которые используют герметичный шлем и подачу воздуха – но не всегда полностью закрытый костюм. На ТУ 7 доступен настоящий, полноценный водолазный скафандр. Мастер может потребовать броска Плавания для маневрирования в этом костюме. (По умолчанию: Акваланг -2).

Защитный костюм (NBC Suit): Все виды снаряжения (включая не имеющие собственного питания), созданные для защиты от опасностей окружающей среды и рабоыт с опасными материалам. Без этого навыка вы постоянно рискуете в чем-то ошибиться и получить вред. 
Скафандр (Vacc Suit): Любой тип космического скафандра – включая специальные костюмы для работы в атмосферах с высоким давлением, кислотностью или ядами.
По умолчанию все виды костюмов относятся друг к другу с -2, кроме водолазного – с -4.
Негерметичные или не оборудованные энергопитанием костюмы никогда не требуют броска этого навыка.</description-loc>
		<tech_level></tech_level>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B192</reference>
		<categories>
			<category>Technical</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Ventriloquism</name>
		<name-loc>Чревовещание</name-loc>
		<description-loc>Способность маскировать и «перемещать» голос на коротких дистанциях. Успешный бросок достаточно изменит ваш голос, чтобы обмануть аудиторию.
Модификаторы: +5, если у вас есть помощник или кукла для отвлечения аудитории. -3, если аудитория подозрительна.</description-loc>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Arts/Entertainment</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Veterinary</name>
		<name-loc>Ветеринария/ТУ</name-loc>
		<description-loc>Это умение ухаживать за больным или раненым животным. Это медицинское умение. Вы можете взять необязательную специализацию (с.169).
Модификаторы: +5, если животное знает вас и доверяет вам; -2 или хуже, если животное незнакомого вам вида.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/H</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Animal</category>
			<category>Medical</category>
		</categories>
		<default>
			<type>Skill</type>
			<name>Animal Handling</name>
			<modifier>-6</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Physician</name>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Surgery</name>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Weather Sense</name>
		<name-loc>Предсказание погоды</name-loc>
		<description-loc>Эта наука изучает погоду и возможности по ее предсказанию. При высоких технических уровнях этот навык включает способность снимать показания с приборов, читать спутниковые карты и т.д. Однако высокотехнологичный метеоролог все еще может работать без приборов; если это не так, то он не метеоролог, а наблюдатель за приборами.
Мастер делает проверку Метеорологии за игрока; удачный бросок означает, что он говорит правду, в то время как при неудачном броске он отвечает случайным образом или говорит неправду. Обратите внимание, что для каждого дня требуется отельная проверка, прогноз на 3 дня потребует 3 проверки, первую для завтрашнего дня и по одной для каждого последующего. 
При успешной проверке, метеоролог также узнает, что представляет собой общий климат в том месте, о котором он слышал или в котором был.
На низких технических уровнях это умение может называться Предсказанием погоды (Weather Sense). Любой человек TL4 или ниже получает +2 к Предсказанию погоды в своей родной местности.
На уровне ТУ 5+ Метеорология становится научным навыком и вы должны будете специализироваться на типе планет.
Модификаторы: решающий фактор – длительность прогноза. Вы получаете штраф -1 за прогноз на два дня, -2 за 3 дня, -4 за 4 дня, -6 за 5, и т.д. – добавьте еще -2 за каждый дополнительный день. Если проверка определенного дня провалена, автоматически терпят неудачу и последующие проверки. С ТУ 4 становится доступным оборудование, и начинают применяться модификаторы за наличие оборудования. Проверки по умолчанию не позволяют получить выгоду даже от самого лучшего метеооборудования.</description-loc>
		<tech_level></tech_level>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<categories>
			<category>Everyman</category>
			<category>Outdoor/Exploration</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Weird Science</name>
		<name-loc>Странная Наука</name-loc>
		<description-loc>Это умение создавать новые невероятные фантастические научные теории, намного опережающие свое время… или по крайней мере, сильно отличающиеся от известных. Успешная проверка пригодится при попытке что-либо изобрести (см. главу 17), или исследовать совершенно непонятный предмет (НЛО). 
Удачная проверка умения даст +5 бонус к любой попытке что-либо изобрести, но лишь +1 при использовании Изобретательства (Gadgeteer), поскольку это преимущество уже включает способность необычного подхода к идеям. Вы можете также получить +2 к любой проверке умения, когда дело обстоит с чем-то выходящим за рамки обычного (Это можно считать интуитивной догадкой); Мастер может даже позволить бросок по умолчанию для использования устройства.
Критически провалы этого умения всегда очень эффектны, но не обязательно опасны или смертельны. Критическая удача при использовании этого умения дает персонажу помимо решения нужной проблемы какие-либо невероятные знания о совершенно другом предмете. 
К сожалению, многие люди с этим умением так поглощены сложными теориями, что у них может вызвать затруднения даже использование простого кухонного крана.</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Design/Invention</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Whip</name>
		<name-loc>Кнут</name-loc>
		<description-loc>Любой обычный кнут. Время, необходимое на подготовку кнута, зависит от его длины: 0 ходов для 1-ярдового кнута, 1 ход  для 2-ярдового, 2 хода для 3-ярдового и более. 

Кнут – гибкое оружие, сделанное из отрезка цепи, кожи или шнура, и т.д. Кнут может иметь длину до 7 ярдов, но может бить только на максимальную дистанцию – кнутом длиной два ярда нельзя ударить на один ярд или вплотную; а также кнут долго готовится после атаки. Кнут захлестывается вокруг цели, что делает его превосходным обезоруживающим и опутывающим инструментом. Однако, недостаточная твердость затрудняет парирование кнутом: см. Особые правила по оружию ближнего боя, с. B404. Навыки в этой категории относятся друг к другу с -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B209</reference>
		<parry after-attack="no">-2</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
		<default>
			<type>DX</type>
			<modifier>-5</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Force Whip</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Kusari</name>
			<modifier>-3</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Monowire Whip</name>
			<modifier>-3</modifier>
		</default>
	</skill>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>@Melee Weapon Skill@</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>Boxing</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>Broadsword</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>Karate</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>Staff</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Whirlwind Attack</name>
		<name-loc>Круговая атака</name-loc>
		<description-loc>Круговая атака - особый вид Тотальной атаки  (all-out attack), позволяющий молниеносно атаковать сразу всех сосед-них противников! Если вы используете эту технику, то больше не можете делать ничего в этот свой ход, независимо от своего уровня навыка.
Более того, поскольку это Тотальная атака (all-out attack), вы не получаете права на активную защиту после нее - см. Тотальная атака (all-out attack), с. B365).
При использовании Тотальной атаки, вы поражаете всех противников в радиусе одного ярда от вас. Вы можете атаковать их только по очереди, вращаясь по часовой стрелке или против - на ваш выбор.
Все ваши атаки должны быть рубящими, и вы не можете комбинировать Круговую атаку с любыми дру-гими техниками (например, Разоружением) или киношными навыками (например, Мощным ударом). Для каждой цели локация ранения определяется случайно, затем делается бросок Круговой атаки для попада-ния - со всеми штрафами на попадание для этой локации. Противники могут защищаться нормально. Каж-дая из атак должна быть обсчитана полностью, прежде чем вы перейдете к следующему врагу. Если при любой из атак выпадает критический провал (или любой из ваших врагов выбрасывает критический успех при защите), эта атака, и все оставшиеся считаются получившими критический провал - и для каждой из них делается бросок по таблице критических промахов (с. B556).
Вы можете прекратить Круговую атаку, повернувшись в любом направлении на свой выбор.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B232, MA89</reference>
		<default>
			<type>Skill</type>
			<name>Two-Handed Sword</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Cinematic Techniques</category>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</technique>
	<technique version="2" limit="0">
		<name>Work by Touch</name>
		<name-loc>Работа на ощупь</name-loc>
		<description-loc>Если вы работаете исключительно на ощупь, навык Взлома получает штраф -5; но если вы будете прак-тиковаться, взлом вслепую может стать привычным.
Мастер может разрешить изучение этой техники для других "воровских" навыков - например, установки взрывчатки или ловушек - позволив вам действовать эффективно даже в полной темноте - ведь этими навы-ками обычно и пользуются в условиях недостаточной освещенности.
</description-loc>
		<difficulty>H</difficulty>
		<points>1</points>
		<reference>B233</reference>
		<default>
			<type>Skill</type>
			<name>Lockpicking</name>
			<modifier>-5</modifier>
		</default>
		<categories>
			<category>Criminal/Street</category>
			<category>Technique</category>
		</categories>
	</technique>
	<skill version="2">
		<name>Wrestling</name>
		<name-loc>Борьба</name-loc>
		<description-loc>В борьбе учат как повалить соперника, придавить его к земле и применять различные удержания и захваты. Пусть это умение не так эффективно как Дзюдо, но оно дает преимущество при ведении Боя вплотную.
Если вы имеете навык на уровне DX+1, ваша сила увеличивается на +1 в целях захватов, прижатий и прочих силовых приемов, а на уровне DX+2 вы получаете премию +2.
При защите голыми руками борьба позволяет вам парировать один раз в ход, используя обе руки. Навык парирования – (Навык/2) +3, округленное вниз. Оружие парируется с -3.</description-loc>
		<difficulty>DX/A</difficulty>
		<points>1</points>
		<reference>B228</reference>
        <parry>0</parry>
		<categories>
			<category>Combat/Weapon</category>
			<category>Melee Combat</category>
		</categories>
	</skill>
	<skill version="2">
		<name>Writing</name>
		<name-loc>Письмо</name-loc>
		<description-loc>Это умение писать четко и/или интересно. Удачная проверка означает, что работа легка для понимания и аккуратна. Это умение в основном используется, чтобы зарабатывать деньги, но иногда может быть использовано приключенцами…. или против них. Отчет шпиона, военного или частного сыщика будет более полезен, если он хорошо написан!
Модификаторы: за потраченное время (с. B346); -5, если вы писали на незнакомую тему. Модификаторы за знание языка (B24).</description-loc>
		<difficulty>IQ/A</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Arts/Entertainment</category>
			<category>Scholarly</category>
		</categories>
		<default>
			<type>IQ</type>
			<modifier>-5</modifier>
		</default>
	</skill>
	<skill version="2">
		<name>Zen Archery</name>
		<name-loc>Дзен-лучник</name-loc>
		<description-loc>
Позволяет вам более метко стрелять из лука. В случае успеха штрафы за скорость, размер и расстояние уменьшаются втрое.
Модификаторы: -10 за мгновенное использование, -5 за 1 ход концентрации, -4 за два хода, -3 за 4 хода, -2 за 8 ходов, -1 за 16 ходов, без штрафов за 32 хода концентрации.</description-loc>
		<difficulty>IQ/VH</difficulty>
		<points>1</points>
		<reference>B228</reference>
		<categories>
			<category>Esoteric</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">meditation</name>
				<specialization compare="is"></specialization>
			</skill_prereq>
			<skill_prereq has="yes">
				<name compare="is">bow</name>
				<specialization compare="is"></specialization>
				<level compare="at least">18</level>
			</skill_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">weapon master</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">trained by a master</name>
					<notes compare="is anything"></notes>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	</skill>
</skill_list>`;
 standaloneLibs['Magic-rus.spl']=`<!--?xml version="1.0" encoding="UTF-8" ?-->
<name>Mentor: Magic</name>
<notes><a href="books/magic_rus.pdf" target="_blank">Gurps Magic</a> - Заклинания. Так-же смотри <a onclick="showSpellCharts(); return false">таблицу зависмостей</a><br><br><a href="editor.phtml?v=30000000000000000000000000000000" target="_blank">Редактирование библиотеки</a> разрешно, но с предмодерацией</notes><editor-message>Редакторы!<br>
Эта библиотека заклинаний из Gurps Magic. <br>
Прошу, не стоит добавлять сюда отсебятину или данные из других книг без предварительного согласования.<br>
Так-же не стоит пресортировывать библиотеку.<br>
Спасибо за ваше участие!<br></editor-message>
<spell_list unique_id="hv8ipoh5:-e0dxvovo3f2v" version="1">
	<spell version="2">
	<name>Create Air</name>
	<name-loc>Создать воздух</name-loc>
	<points>1</points>
	<spell_class>Area</spell_class>
	<casting_cost>1</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>1 sec</casting_time>
	<duration>5 sec</duration>
	<college>Air</college>
	<power_source>Arcane</power_source>
	<prereq_list all="no">
		<spell_prereq has="yes">
			<name compare="is">purify air</name>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">seek air</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Air</category>
	</categories>
	<reference>M23</reference>
	<description-loc>Областное
Это заклинание создает воздух из «ничего». Сотворение его где уже есть воздух, приводит к появлению слабого ветра секунд на пять. В воде - появятся пузыри, в твердом материале - заполнит все пустоты, но не будет разрушать конструкцию. В вакууме - создает пригодный для дыхания воздух.
При сотворении в области радиусом 1 ярд создает по 45 ф3 воздуха каждую секунду в течение 5 секунд; каждого куба воздуха хватит на минуту дыхания обычному человеку в покое. Однако, в некоторых средах созданный воздух быстро рассеется в вакууме или сформирует пузырь и всплывет. Воздух нельзя создать внутри живого существа. 
Длительность: Ветер, пузыри и т.п. длятся 5 секунд, воздух создаётся навсегда.
Стоимость: 1. Не поддерживается.
Требования: Очистка воздуха или Поиск воздуха.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 200.</description-loc>
</spell>
	<spell version="2">
		<name>Purify Air</name>
		<name-loc>Очистка воздуха</name-loc>
		<description-loc>Областное
Убирает все примеси из воздуха. Это заклинание часто используется для нейтрализации отравляющих газов и ядовитых испарений. Дым можно убирать по частям, но от ядовитых газов лучше избавляться сразу – иначе они могут распространяться уже на очищенное пространство.
Может также превратить старый спертый воздух в свежий и пригодный для дыхания. Воздуха в радиусе  ярда достаточно для одного человека в течение 45 минут (если он не занимается тяжелым трудом).
Длительность: срабатывает мгновенно, очищает навсегда.
Базовая стоимость: 1. Не поддерживается.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 50.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M23</reference>
		<categories>
			<category>Air</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Air</name>
		<name-loc>Поиск воздуха</name-loc>
		<description-loc>Информационное
Сообщает магу примерное расстояние и направление до ближайшего значительного количества воздуха. Используются Модификаторы больших расстояний (M14). В мирах, где известно, что воздух – смесь газов, маг может искать любой определенный газ или их комбинацию, а не обычный воздух. Любой из известных источников может быть исключен из поиска.
Стоимость: 1.
Предмет
Раздвоенная палочка (обычно из кости птицы). Стоимость создания: 60 энергии, $200 за оникс.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M23</reference>
		<categories>
			<category>Air</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Air Jet</name>
		<name-loc>Струя воздуха</name-loc>
		<description-loc>Обычное
Позволяет выстрелить тонкую струю воздуха из пальца. Каждый ход маг кидает ЛВ(DX)-4 или умение Природная атака для попадания в цель. От этой атаки можно защититься блоком или уклонением, но парировать ее нельзя. Струя наносит 2d отбрасывающего вреда за единицу энергии, вложенную в заклинание, и имеет дальность, равную количеству кубиков вреда. Наносит реальный вред воздушным существам и роям мелких существ. Также неплохо подметает пол.
Длительность: 1 секунда
Стоимость: 1-3. Столько же поддержание.
Требования: Формирование воздуха.
Предмет
Посох, палочка или украшение. Используется только магами. Если это палочка или посох - струя исходит с конца. Энергостоимость создания: 200.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>2d kb/point</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Air Vision</name>
		<name-loc>Воздушное зрение</name-loc>
		<description-loc>Обычное
Позволяет видеть сквозь любой дым, пыль, песок в воздухе, уничтожает все штраф за состояние воздуха.
Также относится к школе Знания.
Длительность: 1 минута.
Стоимость: 1 за милю сотворения. Половина за поддержание.
Требования: Формирование воздуха.
Предмет
Любой. Энергостоимость создания: 200.</description-loc>
		<college>Air/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per mile</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Air</name>
		<name-loc>Тело из воздуха</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Тело объекта становится газообразным, он временно приобретает мета-черту Тело из воздуха (B262). Одежда (до 6 фунтов) также становится воздушной, но теряет магические свойства на время нахождения в этой форме.
Длительность: 1 минута.
Стоимость: 4 сотворение, 1 поддержание.
Время сотворения: 5 секунд.
Требования: Формирование воздуха.
Предмет
(а) Посох, палочка или украшение, действует только на носителя. Однако, сразу после активации предмет выпадает сквозь руки мага – то есть, заклинание, сотворенное с помощью этого предмета, длится только одну минуту. Энергостоимость создания: 800. (б) Посох, палочка, украшение. В отличие от предыдущей версии, приобретает газообразную форму вместе с владельцем, что позволяет поддерживать эффект заклинания дольше, чем одну минуту. Все остальные магические свойства в это время теряются. Энергостоимость создания: 1.500.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-HT</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Destroy Air</name>
		<name-loc>Уничтожить воздух</name-loc>
		<description-loc>Областное
Позволяет уничтожить весь воздух выбранной области. На открытом пространстве это вызовет мгновенное заполнение окружающим воздухом. В результате заполнения все находящиеся в области получают 1d-2 вреда если провалят бросок ЗД(HT). Существа с мета-чертой Тело из воздуха (B262) получают 2d вреда. В герметичных или закрытых помещениях может быть намного опаснее, т.к. не оставит пригодного для дыхания воздуха.
Длительность: мгновенно, но воздух исчезает навсегда.
Базовая стоимость: 2.
Требования: Создать воздух.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>No-Smell</name>
		<name-loc>Убрать запах</name-loc>
		<description-loc>Обычное
Убирает запах объекта и делает его совершенно невоспринимаемым обонянием. Личные вещи объекта также перестают пахнуть. Ни какие иные особенности объекта не затрагиваются.
Длительность: 1 час.
Стоимость: 2 сотворение, 2 поддержка.
Требования: Очистка воздуха.
Предмет
Украшение; действует только на носителя. Стоимость создания: 150 энергии и $300.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Odor</name>
		<name-loc>Запах</name-loc>
		<description-loc>Областное
Создает любой знакомый магу запах. В замкнутом помещении запах держится около часа (вне помещения быстро развеивается). Не может произвести никакого вредоносного эффекта- например, запах яда не ядовит.
Длительность: 1 час.
Базовая стоимость: 1. Не поддерживается.
Требования: Убрать запах.
Предмет
Украшение, постоянно распространяющее установленный при создании запах. Энергостоимость создания: 40.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">no-smell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Air</name>
		<name-loc>Формирование воздуха</name-loc>
		<description-loc>Областное
Позволяет заклинателю создать движения воздуха в небольшом объеме. Ветер начинает дуть из выбранной клетки (штрафы за расстояние до нее), потоком шириной в 1 клетку, на расстояние 5 ярдов за единицу вложенной энергии, после чего исчезает. Способно сдувать (см. Сбивание, B378) – каждую секунду бросается 1d за каждые две единицы энергии, вложенные в заклинание (выброшенный результат считается  вредом в целях сдувания, но не наносит никакого реального вреда).
Длительность: 1 минута.
Стоимость: 1-10. 1 даёт мягкий бриз, 4 ветер, 6 шторм, 8 и более сильный порыв. Столько же поддержку. 
Требования: Создать воздух.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 200.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stench</name>
		<name-loc>Зловоние</name-loc>
		<description-loc>Областное
Создает клубящееся облако с отвратительным запахом серы. Пока не рассеется, будет производить эффект удушающего газа – любой, кто вдохнет его, должен сделать бросок ЗД(HT), или получит 1d вреда (бросок раз в минуту). Также находящиеся в области начинают задыхаться (см. Удушение, B436). Газ тяжелее воздуха и будет опускаться к полу. Скорость рассеивания будет зависеть от площади и силы ветра. В помещениях это будет не менее 5 минут, а в ветреный день на открытом воздухе рассеется за 10 секунд. Обладающие чертами Фильтрация воздуха или Не дышит) невосприимчивы к токсичному эффекту газа.
Длительность: 5 минут, кроме открытых пространств.
Базовая стоимость: 1. Не поддерживается.
Требования: Очистка воздуха.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 60</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M24</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Devitalize Air</name>
		<name-loc>Омертвить воздух</name-loc>
		<description-loc>Областное
Удаляет кислород из воздуха, делая его непригодным для дыхания. До тех пор, пока «мёртвый» воздух не рассеется, любое дышащее существо начинает задыхаться (см. Удушье, B436), огонь в области эффекта заклинания гаснет. Жертвы могут не заметить эффекта, пока не начнут терять ЕУ(FP); требуется сделать бросок Восприятия(Per), чтобы заметить изменение качества воздуха. Спящие должны бросить ЗД(HT), чтобы проснуться, когда начнут задыхаться.
Заклинание длится до тех пор, пока живой воздух не распространится в область воздействия. В замкнутых помещениях это потребует около минуты на каждый ярд радиуса области, или всего до 10 секунд в ветреный день на улице. В герметичной комнате воздух останется «мёртвым» очень долго! Очистка воздуха отменяет эффект.
Базовая стоимость: 2. Не поддерживается.
Требования: Уничтожить воздух.
Предмет
Посох, палочка, украшение. Стоимость создания: 300 энергии и $200 за оникс.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Varies</duration>
		<reference>M25</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">destroy air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Earth to Air</name>
		<name-loc>Землю в воздух</name-loc>
		<description-loc>Обычная
Превращает землю или камень в воздух, пригодный для дыхания – это может оказаться полезным для тех, кто завален под землей. Чем больше маг затратит энергии, тем больше земли он сможет превратить; но полученное помещение будет ограничено простейшими геометрическими формами, наибольшее измерение которых не превышает четырехкратного наименьшего измерения.
Также это заклинанием школы Земли.
Длительность: навсегда.
Стоимость: 1 для превращения одного ф3 земли/камня в воздух, которого достаточно для дыхания одному персонажу в течение одной минуты. Большие объемы превращаются по цене 5 очков энергии за ярд3. Металл можно превратить в воздух за тройную стоимость.
Время сотворения: 2 секунды.
Требования: Создать воздух и Формировать воздух.
Предмет
Посох, палочка или украшение. Используется только магами. Для превращения нужно дотронуться предметом до камня. Стоимость создания: 750 энергии и $1.000 за украшение.</description-loc>
		<college>Air/Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5/25 cu ft#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M25</reference>
		<categories>
			<category>Air</category>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk on Air</name>
		<name-loc>Ходьба по воздуху</name-loc>
		<description-loc>Обычное
Временно дает преимущество Ходьба по воздуху (B97). Если по любой причине объект падает - заклинание ломается. Если пересоздать заклинание сразу же, субъект будет падать всего секунду (около 5 ярдов) и «приземлится» на воздух, получив 1d вреда (если он до этого не упадет на землю!). Если он находится в 10 футах над пропастью с лавой – у него проблемы!
Длительность: 1 минута.
Стоимость: 3 создание, 2 поддержание.
Требования: Формирование воздуха.
Предмет
Посох, палочка, украшение или обувь; действует только на носителя. Стоимость: 500 энергии и $1000.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M25</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wall of Wind</name>
		<name-loc>Стена ветра</name-loc>
		<description-loc>Областное
Окружает область стеной ветра, мешающего движению. 
Стена имеет толщину один ярд, и четыре ярда в высоту, но ее можно сделать выше, соответственно умножая стоимость (удваивая за 8 ярдов, утраивая за 12 ярдов и т.д.). Низкотехнологические снаряды сбиваются с курса, пересекая стену, и получают штраф на попадание -10 за каждый ярд стены, через который пролетают. Высокотехнологические пули получают штраф -2 за каждый ярд. Стоять в толще ветра очень сложно: -3 ЛВ(DX) и каждую секунду отбрасывание в случайном направлении на 2d вреда. 
Стена также поднимает в воздух легкий мусор с земли – пыль, листья, насекомых и т.д. Каждую секунду пересекающий стену или стоящий в ее толще должен закрывать глаза или бросать ЗД(HT), чтобы не быть ослепленным аналогично единичной Струе песка (M52) (если Мастер не решит, что область слишком чистая и поблизости нет мусора).
Длительность: 1 минута.
Базовая стоимость: 2. Половина за поддержание.
Время сотворения: стена возникает сразу после начала сотворения, изначально окружая область радиусом в один ярд; маг может расширять область воздействия со скоростью 1 ярд радиуса за секунду концентрации.
Требования: Формирование воздуха.
Предмет
Посох, палочка или украшение. Используется только магами. Стоимость создания: 400 энергии и  $500 за оникс.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>Instant</casting_time>
		<duration>1 min</duration>
		<reference>M25</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Windstorm</name>
		<name-loc>Ураган</name-loc>
		<description-loc>Областное
Круговорот ветра с центром спокойствия внутри (хорошее место для мага). Центр спокойствия может быть диаметром вплоть до половины диаметра бури – или меньше, по желанию мага. Концентрируясь, маг может перемещать бурю на любое расстояние вплоть до ее собственного диаметра в секунду; центр спокойствия перемещается вместе с ней. Маг может перемещаться сам со скоростью до половины своего нормального Движения в пределах центра, концентрируясь на заклинании.
Любой, попавший в достигший полной силы Ураган должен делать бросок СЛ(ST) каждую секунду, или будет сбит с ног ветром. Все ЛВ(DX)-умения получают -5, а дистанционные атаки штраф -10 за каждый ярд бури, через который они проходят.
За удвоенную стоимость маг может создать еще более мощный Ураган, подобный торнадо. Броски СЛ(ST), чтобы остаться на ногах, делаются с -5, дистанционные атаки сквозь него вообще невозможы;  видимость в пределах действия в лучшем случае один ярд. Этот мощный ураган физически поднимает и разбрасывает объекты весом вплоть до 30 фунтов за каждый ярд радиуса.
Длительность: 1 минута после достижения полной силы.
Базовая стоимость: 2. Половина за поддержание.
Время сотворения: Ураган возникает немедля, но маг должен концентрироваться в течение количества секунд, равного радиусу урагана в ярдах, чтобы вихрь достиг полной силы.
Требования: Формирование воздуха.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>Instant</casting_time>
		<duration>1 min</duration>
		<reference>M25</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Air Vortex</name>
		<name-loc>Воздушный вихрь</name-loc>
		<description-loc>Областное; Сопротивление по ЗД(HT) или ЛВ(DX)
Перемещает всех, оказавшихся в зоне сотворения эффекта, куда-то в другое место внутри огромного крутящегося Воздушного вихря. Вихрь имеет Движение 10. Заклинатель может исключить любого из площади захвата, определив это при сотворении. Можно сопротивляться захвату по лучшему значению из ЗД(HT) или ЛВ(DX). Захваченные вихрем принимают на время парообразную форму, как в заклинании Тело из воздуха (M24). Вихрь может не проходить сквозь однородные объекты.
Длительность: 10 секунд.
Базовая стоимость: 8 сотворение. 3 поддержание.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2, Тело из воздуха и Ураган.
Предмет
Посох. Используется только магами. Стоимость создания: 1200 энергии и $800 за оникс.</description-loc>
		<college>Air/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Area/R-HT or DX</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M26</reference>
		<categories>
			<category>Air</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (air)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">windstorm</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">body of air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Breathe Air</name>
		<name-loc>Дышать воздухом</name-loc>
		<description-loc>Обычное
Позволяет объекту дышать в воздухе так, как будто это вода; также защищает водяных созданий от обезвоживания на суше. Обычно используется для хранения рыбы, русалок и т.д. живыми вне воды. Во время действия заклинания объект может дышать водой как обычно.
Также относится к заклинаниям Воды.
Длительность: 1 минута.
Стоимость: 3 сотворение. 1 поддержание.
Требования: Создать воду и Уничтожить воздух.
Предмет
Посох, палочка, украшение или одежда; действует только на носителя. Энергостоимость создания: 150.</description-loc>
		<college>Air/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M26</reference>
		<categories>
			<category>Air</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">destroy air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Concussion</name>
		<name-loc>Сотрясение</name-loc>
		<description-loc>Метательное
Маг создает в руке шар плотного воздуха. При попадании в цель шар громко взрывается; Все в радиусе 10 ярдов должны сделать бросок ЗД(HT)-3, или будут оглушены. Оглушенные могут каждую секунду делать бросок ЗД(HT)-3 для восстановления. Защищенный слух дает +5 к этому броску. Сотрясение имеет 1/2Д 20, Max 40, Точ 1; на попадания бросок умения Природная атаки.
Также относится к заклинаниям Звука.
Стоимость: любая, вплоть до удвоенного уровня Магичности за секунду, в течение трех секунд. За каждые 2 единцы энергии, вложенные в заклинание, снаряд наносит 1d тупого вреда. Полные правила по взрывам см. Взрывы, B414.
Время сотворения: от 1 до 3 секунд.
Требования: Формирование воздуха и Гром (M171).
Предмет
Посох или палочка – снаряд вылетает с конца. Используется только магами. Стоимость создания: 1000 энергии и $400 за оникс.</description-loc>
		<college>Air/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>2-2xMagery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d cr ex/2 points</damage>
			<accuracy>1</accuracy>
			<range>20/40</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M26</reference>
		<categories>
			<category>Air</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">thunderclap</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Air</name>
		<name-loc>Истинный воздух</name-loc>
		<description-loc>Областное
Создает магическую эссенцию воздуха. Созданный воздух «чище» и используется (для дыхания и т.д.) в три раза дольше, чем обычный, прежде чем загрязнится. Огонь в Истинном воздухе горит жарче (но не быстрее), что добавляет единицу вреда за каждый кубик (это увеличивает жар даже Истинного огня!). На открытом пространстве рассеивается за 5 секунд.
Длительность: постоянно, пока не рассеется или .выработается.
Базовая стоимость: 2.
Время сотворения: 3 секунды.
Требования: как минимум шесть заклинаний воздуха.
Предмет
Посох, палочка или украшение. Используется только магами. Цена создания: 800 энергии и $400 за оникс.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M26</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Wind</name>
		<name-loc>Тело из ветра</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Превращает субъекта и его одежду в живой вихрь радиусом от 2 до 4 ярдов. В это время он получает вариант мета-черты Тело из воздуха (B262); нет Уязвимости к вакууму, Нет точных манипуляторов – вместо Нет манипуляторов), эффективная СЛ(ST) равна удвоенной обычной). Одежда весом до 6 фунтов также становится вихрем, но на это время теряет все магические свойства. Все в радиусе нахождения субъекта должны кидать СЛ(ST) каждую секунду, чтобы устоять на ногах. Все ЛВ(DX)-умения получают штраф -5, попавшие в вихрь метательные атаки попадают в цель только на критическом успехе. В области действия нет зоны безопасности.
Длительность: 5 минут.
Стоимость: 8 создание. 4 поддержание. Стоимость не умножается при сотворении на более крупных существ, как у большинства Обычных заклинаний.
Время сотворения: 2 секунды ; ветер достигает полной силы сразу после окончания сотворения.
Требования: Магичность(Magery) 3; Тело из воздуха и Ураган, каждое на уровне 16+; и по одному заклинанию из пяти других школ, кроме Воздуха.
Предмет
 (а) Посох, палочка или украшение; действует только на носителя. Сразу после активации предмет падает сквозь руки пользователя; однако, заклинание действует еще минимум минуту.  Стоимость создания: 1.700 энергии и $1.000 за оникс. (б) Посох, палочка или украшение; действует только на носителя. В отличии от предыдущего предмета, этот превращается в ветер вместе с носителем, позволяя ему поддерживать заклинание дольше минуты. Пока находится в таком состоянии он теряет все магические свойства, которыми обладал будучи твёрдым.  Стоимость создания:  3.500 энергии и $2.500 за оникс.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-HT</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M27</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">5</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">windstorm</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">body of air</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (air)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sandstorm</name>
		<name-loc>Песчаная буря</name-loc>
		<description-loc>Областное
Создает Ураган (M25) с неприятным дополнением в виде песка! Песок создается заклинанием – область не обязана быть песчаной. Песчаная буря мешает зрению (-2 за каждый ярд, через который смотрит персонаж, за исключением «ока»).
Каждую секунду каждое существо в пределах области действия должно закрыть глаза или сделать бросок ЗД(HT), чтобы не ослепнуть аналогично действию единичной Струи песка (M52).
Это также заклинивание Школы земли.
Длительность: 1 минута после набора полной силы.
Базовая стоимость: 3 сотворение. Половина за поддержание.
Время сотворения: буря возникает немедленно, но маг должен концентрироваться в течение количества секунд, равного радиусу бури в ярдах, чтобы она достигла полной силы.
Требования: Ураган и Создать зумлю.
Предмет
Посох, палочки или крошение. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Air/Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>Instant#</casting_time>
		<duration>1 min#</duration>
		<reference>M27</reference>
		<categories>
			<category>Air</category>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">windstorm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Air Elemental</name>
		<name-loc>Вызов воздушного элементаля</name-loc>
		<description-loc>Особое
Отдельное заклинание для каждого из четырех элементов. Позволяет магу вызвать ближайшего элементаля – если такой есть. В общем, Мастер должен подразумевать, что элементаль всегда будет присутствовать в подходящей локации, если сценарий или ситуация не предусматривают обратного. Уровень силы элементаля определяет маг, вкладывая определенное количество энергии в заклинание, но точные способности элементаля определяются Мастером.
Призванный элементаль не подконтролен заклинателю, но должен оставаться на час с ним, пока не будет отозван или разрушен. Заметьте, что отзыв не гарантирует что элементаль уйдёт. Если он враждебен или просто любопытен, то может захотеть остаться!

Заклинатель может спрашивать призванного элементаля, просить об услуге и т.д. Элементаль немедленно делает бросок реакции, чтобы понять своё отношение к волшебнику. При хорошей реакции, он сотрудничает в течение часа – не дольше –, а затем исчезает. Мнение элементаля можно поколебать соответствующими соблазнами, конечно если волшебник представляет что может заинтересовать элементаля.
Длительность: 1 час. Может быть неподдерживаемым.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Минимальная энергостоимость 4 (однако это не всегда призывает 40-очковое существо).
Время сотворения: 30 секунд. Элементаль может появиться в течении 2d минут.
Требования: Магичность(Magery) 1 также или восемь заклинаний соответствующего элемента или четыре заклинания соответствующего элемента  и иное заклинание Вызов элементаля.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Стоимость создания: 800 энергии, $1.300 золотом и платиной.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M27</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<prereq_list all="yes">
					<prereq_list all="no">
						<spell_prereq has="yes">
							<name compare="is">summon fire elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon water elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon earth elemental</name>
						</spell_prereq>
					</prereq_list>
					<spell_prereq has="yes">
						<college compare="contains">air</college>
						<quantity compare="at least">4</quantity>
					</spell_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<college compare="contains">air</college>
					<quantity compare="at least">8</quantity>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (air)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Earth Elemental</name>
		<name-loc>Вызов элементаля земли</name-loc>
		<description-loc>Особое
Отдельное заклинание для каждого из четырех элементов. Позволяет магу вызвать ближайшего элементаля – если такой есть. В общем, Мастер должен подразумевать, что элементаль всегда будет присутствовать в подходящей локации, если сценарий или ситуация не предусматривают обратного. Уровень силы элементаля определяет маг, вкладывая определенное количество энергии в заклинание, но точные способности элементаля определяются Мастером.
Призванный элементаль не подконтролен заклинателю, но должен оставаться на час с ним, пока не будет отозван или разрушен. Заметьте, что отзыв не гарантирует что элементаль уйдёт. Если он враждебен или просто любопытен, то может захотеть остаться!

Заклинатель может спрашивать призванного элементаля, просить об услуге и т.д. Элементаль немедленно делает бросок реакции, чтобы понять своё отношение к волшебнику. При хорошей реакции, он сотрудничает в течение часа – не дольше –, а затем исчезает. Мнение элементаля можно поколебать соответствующими соблазнами, конечно если волшебник представляет что может заинтересовать элементаля.
Длительность: 1 час. Может быть неподдерживаемым.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Минимальная энергостоимость 4 (однако это не всегда призывает 40-очковое существо).
Время сотворения: 30 секунд. Элементаль может появиться в течении 2d минут.
Требования: Магичность(Magery) 1 также или восемь заклинаний соответствующего элемента или четыре заклинания соответствующего элемента  и иное заклинание Вызов элементаля.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Стоимость создания: 800 энергии, $1.300 золотом и платиной.


Малый элементаль земли
Это базовый элементаль земли, призываемый сотворением Призыв элементаля земли с минимальными энергозатратами (4 единицы). Больше энергии позволит вызвать более могущественных духов. Обычно это просто означает более крупного элементаля; единица энергии равна 1 дополнительному очку СЛ(ST), 5 ЕЖ(HP) или двум очкам СП(DR). Однако, Мастер может создать и необычных элементалей, добавляя другие черты в данный ниже шаблон, или создать свой собственный.
Малый элементаль земли
40 очков
Модификаторы атрибутов: СЛ(ST)+1 [10]; ЛВ(DX)-2 [-40]; ИН(IQ)-4 [-80].
Модификаторы вторичных характеристик: МР(SM)-1.
Преимущества: Не дышит[20]; Не ест не пьёт[10]; Не спит [20]; СП(DR) 2 [10];  Иммунитет к метаболическим угрозам [30]; Устойчивость к ранениям (однородный) [40]; Устойчивость к давлению 3 [15]; Устойчивость к вакууму [5];</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>4#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M27</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<prereq_list all="yes">
					<prereq_list all="no">
						<spell_prereq has="yes">
							<name compare="is">summon fire elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon air elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon water elemental</name>
						</spell_prereq>
					</prereq_list>
					<spell_prereq has="yes">
						<college compare="contains">earth</college>
						<quantity compare="at least">4</quantity>
					</spell_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<college compare="contains">earth</college>
					<quantity compare="at least">8</quantity>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Fire Elemental</name>
		<name-loc>Вызов огненного элементаля</name-loc>
		<description-loc>Особое
Отдельное заклинание для каждого из четырех элементов. Позволяет магу вызвать ближайшего элементаля – если такой есть. В общем, Мастер должен подразумевать, что элементаль всегда будет присутствовать в подходящей локации, если сценарий или ситуация не предусматривают обратного. Уровень силы элементаля определяет маг, вкладывая определенное количество энергии в заклинание, но точные способности элементаля определяются Мастером.
Призванный элементаль не подконтролен заклинателю, но должен оставаться на час с ним, пока не будет отозван или разрушен. Заметьте, что отзыв не гарантирует что элементаль уйдёт. Если он враждебен или просто любопытен, то может захотеть остаться!

Заклинатель может спрашивать призванного элементаля, просить об услуге и т.д. Элементаль немедленно делает бросок реакции, чтобы понять своё отношение к волшебнику. При хорошей реакции, он сотрудничает в течение часа – не дольше –, а затем исчезает. Мнение элементаля можно поколебать соответствующими соблазнами, конечно если волшебник представляет что может заинтересовать элементаля.
Длительность: 1 час. Может быть неподдерживаемым.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Минимальная энергостоимость 4 (однако это не всегда призывает 40-очковое существо).
Время сотворения: 30 секунд. Элементаль может появиться в течении 2d минут.
Требования: Магичность(Magery) 1 также или восемь заклинаний соответствующего элемента или четыре заклинания соответствующего элемента  и иное заклинание Вызов элементаля.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Стоимость создания: 800 энергии, $1.300 золотом и платиной.

Малый огненный элементаль
Это базовый элементаль, призываемый заклинанием Призыв огненного элементаля при минимальных затратах энергии 4. При вложении в заклинание большего количества энергии призываются более сильные элементали. Обычно это означает просто элементаля больших размеров; 1 очко энергии равно 1 дополнительному очку СЛ(ST), 5 ЕЖ(HP) или 2 очкам СП(DR). Однако, Мастер может создать более экзотического элементаля, прибавляя необычные черты шаблону данному ниже, или создав свой.

Малый огненный элементаль
40 очков
Модификаторы атрибутов: СЛ(ST)-2 [-20]; ЛВ(DX)-1[-20]; ИН(IQ)-2[-40]; ЗД(HT)-3[-30].
Модификаторы вторичных характеристик: МР(SM) -1; ЕЖ(HP) +2[4].
Преимущества: Обжигающая природная атака 2d (Действует постоянно, -40%; Аура, +80%; Контактный бой, Досягаемость В (reach C), -30%)[11]; Харизма 1[5]; Не дышит (Сжигание кислорода, -50%)[10]; Не ест/не пьёт[10]; Не спит[20]; СП(DR) 10 (Ограниченная: тепло/огонь, -40%) [30]; Иммунитет к нарушениям метаболизма [30]; Устойчивость к ранениям (рассеянный) [100].
Недостатки: Нет хороших манипуляторов [-30]; Ослабление (Вода, 1d/мин.) [-40].</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>4#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M27</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<prereq_list all="no">
				<prereq_list all="yes">
					<prereq_list all="no">
						<spell_prereq has="yes">
							<name compare="is">summon air elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon water elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon earth elemental</name>
						</spell_prereq>
					</prereq_list>
					<spell_prereq has="yes">
						<college compare="contains">fire</college>
						<quantity compare="at least">4</quantity>
					</spell_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<college compare="contains">fire</college>
					<quantity compare="at least">8</quantity>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Water Elemental</name>
		<name-loc>Вызов водного элементаля</name-loc>
		<description-loc>Особое
Отдельное заклинание для каждого из четырех элементов. Позволяет магу вызвать ближайшего элементаля – если такой есть. В общем, Мастер должен подразумевать, что элементаль всегда будет присутствовать в подходящей локации, если сценарий или ситуация не предусматривают обратного. Уровень силы элементаля определяет маг, вкладывая определенное количество энергии в заклинание, но точные способности элементаля определяются Мастером.
Призванный элементаль не подконтролен заклинателю, но должен оставаться на час с ним, пока не будет отозван или разрушен. Заметьте, что отзыв не гарантирует что элементаль уйдёт. Если он враждебен или просто любопытен, то может захотеть остаться!

Заклинатель может спрашивать призванного элементаля, просить об услуге и т.д. Элементаль немедленно делает бросок реакции, чтобы понять своё отношение к волшебнику. При хорошей реакции, он сотрудничает в течение часа – не дольше –, а затем исчезает. Мнение элементаля можно поколебать соответствующими соблазнами, конечно если волшебник представляет что может заинтересовать элементаля.
Длительность: 1 час. Может быть неподдерживаемым.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Минимальная энергостоимость 4 (однако это не всегда призывает 40-очковое существо).
Время сотворения: 30 секунд. Элементаль может появиться в течении 2d минут.
Требования: Магичность(Magery) 1 также или восемь заклинаний соответствующего элемента или четыре заклинания соответствующего элемента  и иное заклинание Вызов элементаля.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Стоимость создания: 800 энергии, $1.300 золотом и платиной.

Малый элементаль воды
Это базовый элементаль воды, призываемый Вызовом элементаля воды с минимальными энергозатратами (4 энергии). Большие энергозатраты помогут вызвать более могущественных элементалей. Обычно это просто означает более крупного элементаля; единица энергии равна 1 доп. очку СЛ(ST), 5 ЕЖ(HP) или двум очкам СП(DR). Однако, Мастер может создать и необычных элементалей, добавляя необычные черты в данный ниже шаблон, или создать свой собственный.
Малый элементаль воды
40 очков
Модификаторы атрибутов: СЛ(ST)-3 [-30]; ЛВ(DX)-2 [-40]; ИН(IQ)-3 [-60]; ЗД(HT)-1 [-10].
Модификаторы вторичных характеристик: МР(SM)-1.
Преимущества: Амфибия [10]; Хамелеон 1 [5]; Не дышит[20]; Не спит [20]; Иммунитет к метаболическим угрозам [30]; Устойчивость к ранениям (рассеяный) [100]; устойчивость к давлению 3 [15]; Скользкий 5 [10].
Недостатки: Беспозвоночный [-20]; Уязвимость (Обезвоживание) [-10].</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>4#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M27</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<prereq_list all="yes">
					<prereq_list all="no">
						<spell_prereq has="yes">
							<name compare="is">summon fire elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon air elemental</name>
						</spell_prereq>
						<spell_prereq has="yes">
							<name compare="is">summon earth elemental</name>
						</spell_prereq>
					</prereq_list>
					<spell_prereq has="yes">
						<college compare="contains">water</college>
						<quantity compare="at least">4</quantity>
					</spell_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<college compare="contains">water</college>
					<quantity compare="at least">8</quantity>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Air Elemental</name>
		<name-loc>Контроль воздушного элементаля</name-loc>
		<description-loc>Обычное; Сопротивление по большему из СЛ(ST) и Воля(Will)
Контроль всех действий одного элементаля, пока длится заклинание. Для прямого управления элементаль должен быть в видимости заклинателя. Если элементалю просто говорят уйти, он сделает это. Если его посылают с заданием, без прямого управления, его ИН(IQ) должен быть достаточным (по решению Мастера) для выполнения инструкций!
Это заклинание может использоваться как информационное, чтобы оценить четыре атрибута данного типа элементаля (в пределах 15 футов). Бросок успеха требуется, но не стоит энергии.
Длительность: 1 минута.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Половина этого (округлять вверх) на поддержание.
Время сотворения: 2 секунды.
Требования: Вызов элементаля соответствующего элемента.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Предмет не позволяет пользователя творить заклинания, но даёт ненакапливаемую премию +2 к любым попыткам использовать заклинание. Стоимость создания: 1.000 энергии, $1.300 золотом или платиной.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-ST or IQ</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>Special</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M28</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon air elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Earth Elemental</name>
		<name-loc>Контроль элементаля земли</name-loc>
		<description-loc>Обычное; Сопротивление по большему из СЛ(ST) и Воля(Will)
Контроль всех действий одного элементаля, пока длится заклинание. Для прямого управления элементаль должен быть в видимости заклинателя. Если элементалю просто говорят уйти, он сделает это. Если его посылают с заданием, без прямого управления, его ИН(IQ) должен быть достаточным (по решению Мастера) для выполнения инструкций!
Это заклинание может использоваться как информационное, чтобы оценить четыре атрибута данного типа элементаля (в пределах 15 футов). Бросок успеха требуется, но не стоит энергии.
Длительность: 1 минута.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Половина этого (округлять вверх) на поддержание.
Время сотворения: 2 секунды.
Требования: Вызов элементаля соответствующего элемента.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Предмет не позволяет пользователя творить заклинания, но даёт ненакапливаемую премию +2 к любым попыткам использовать заклинание. Стоимость создания: 1.000 энергии, $1.300 золотом или платиной.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M28</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon earth elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Fire Elemental</name>
		<name-loc>Контроль огненного элементаля</name-loc>
		<description-loc>Обычное; Сопротивление по большему из СЛ(ST) и Воля(Will)
Контроль всех действий одного элементаля, пока длится заклинание. Для прямого управления элементаль должен быть в видимости заклинателя. Если элементалю просто говорят уйти, он сделает это. Если его посылают с заданием, без прямого управления, его ИН(IQ) должен быть достаточным (по решению Мастера) для выполнения инструкций!
Это заклинание может использоваться как информационное, чтобы оценить четыре атрибута данного типа элементаля (в пределах 15 футов). Бросок успеха требуется, но не стоит энергии.
Длительность: 1 минута.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Половина этого (округлять вверх) на поддержание.
Время сотворения: 2 секунды.
Требования: Вызов элементаля соответствующего элемента.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Предмет не позволяет пользователя творить заклинания, но даёт ненакапливаемую премию +2 к любым попыткам использовать заклинание. Стоимость создания: 1.000 энергии, $1.300 золотом или платиной.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M28</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon fire elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Water Elemental</name>
		<name-loc>Контроль водного элементаля</name-loc>
		<description-loc>Обычное; Сопротивление по большему из СЛ(ST) и Воля(Will)
Контроль всех действий одного элементаля, пока длится заклинание. Для прямого управления элементаль должен быть в видимости заклинателя. Если элементалю просто говорят уйти, он сделает это. Если его посылают с заданием, без прямого управления, его ИН(IQ) должен быть достаточным (по решению Мастера) для выполнения инструкций!
Это заклинание может использоваться как информационное, чтобы оценить четыре атрибута данного типа элементаля (в пределах 15 футов). Бросок успеха требуется, но не стоит энергии.
Длительность: 1 минута.
Стоимость: 1 энергия за 10 очков персонажа для построения элементаля. Половина этого (округлять вверх) на поддержание.
Время сотворения: 2 секунды.
Требования: Вызов элементаля соответствующего элемента.
Предмет
Посох, палочка или украшение, с соответствующими элементу изображениями – для каждого из четырёх элементов требуются различные чары. Предмет не позволяет пользователя творить заклинания, но даёт ненакапливаемую премию +2 к любым попыткам использовать заклинание. Стоимость создания: 1.000 энергии, $1.300 золотом или платиной.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M28</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon water elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Air Elemental</name>
		<name-loc>Создание воздушного элементаля</name-loc>
		<description-loc>Особое
Создание духа соответствующего элеменета. Заклинатель может определить возможности создаваемого элементаля увеличивая или уменьшая атрибуты базового элементаля данного типа; он может менять менять, добавлять или убирать преимущества и недостатки с разрешения Мастера. Нетпределов вариации атрибутов, однако очень глупые элементали могут не понимать сложных команд. Вновь созданный элементаль служит заклинателю примерно один час. В конце этого времени проведите состязание между умением мага в данном заклинании и комбинацией ИН(IQ) и СЛ(ST) элемента. При победе заклинателя, элемент служит еще час, в его конце снова требуется состязание, и т.д. При проигрыше заклинателя, элементаль избегает контроля и уходит (или атакует, при очень плохой реакции).
Стоимость: 1 энергия за 5 очков персонажа на построение элементаля.
Время сотворения: количество секунд равное сумме очков персонажа на создание элементаля.
Требования: Магичность(Magery) 2 и Контроль элементаля соответствующего элемента.</description-loc>
		<college>Air</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Special</casting_time>
		<duration>Permanent</duration>
		<reference>M28</reference>
		<categories>
			<category>Air</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (air)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">control air elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Earth Elemental</name>
		<name-loc>Создание элементаля земли</name-loc>
		<description-loc>Особое
Создание духа соответствующего элеменета. Заклинатель может определить возможности создаваемого элементаля увеличивая или уменьшая атрибуты базового элементаля данного типа; он может менять менять, добавлять или убирать преимущества и недостатки с разрешения Мастера. Нетпределов вариации атрибутов, однако очень глупые элементали могут не понимать сложных команд. Вновь созданный элементаль служит заклинателю примерно один час. В конце этого времени проведите состязание между умением мага в данном заклинании и комбинацией ИН(IQ) и СЛ(ST) элемента. При победе заклинателя, элемент служит еще час, в его конце снова требуется состязание, и т.д. При проигрыше заклинателя, элементаль избегает контроля и уходит (или атакует, при очень плохой реакции).
Стоимость: 1 энергия за 5 очков персонажа на построение элементаля.
Время сотворения: количество секунд равное сумме очков персонажа на создание элементаля.
Требования: Магичность(Magery) 2 и Контроль элементаля соответствующего элемента.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Special</casting_time>
		<duration>Permanent</duration>
		<reference>M28</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">control earth elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Fire Elemental</name>
		<name-loc>Создание огненного элементаля</name-loc>
		<description-loc>Особое
Создание духа соответствующего элеменета. Заклинатель может определить возможности создаваемого элементаля увеличивая или уменьшая атрибуты базового элементаля данного типа; он может менять менять, добавлять или убирать преимущества и недостатки с разрешения Мастера. Нетпределов вариации атрибутов, однако очень глупые элементали могут не понимать сложных команд. Вновь созданный элементаль служит заклинателю примерно один час. В конце этого времени проведите состязание между умением мага в данном заклинании и комбинацией ИН(IQ) и СЛ(ST) элемента. При победе заклинателя, элемент служит еще час, в его конце снова требуется состязание, и т.д. При проигрыше заклинателя, элементаль избегает контроля и уходит (или атакует, при очень плохой реакции).
Стоимость: 1 энергия за 5 очков персонажа на построение элементаля.
Время сотворения: количество секунд равное сумме очков персонажа на создание элементаля.
Требования: Магичность(Magery) 2 и Контроль элементаля соответствующего элемента.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Special</casting_time>
		<duration>Permanent</duration>
		<reference>M28</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">control fire elemental</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
	<name>Create Water Elemental</name>
	<name-loc>Создание водного элементаля</name-loc>
	<points>1</points>
	<spell_class>Special</spell_class>
	<casting_cost>Special</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>Special</casting_time>
	<duration>Permanent</duration>
	<college>Water</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<name compare="does not contain">one college</name>
				<level compare="at least">2</level>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery one college (water)</name>
				<level compare="at least">2</level>
			</advantage_prereq>
		</prereq_list>
		<spell_prereq has="yes">
			<name compare="is">control water elemental</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Water</category>
	</categories>
	<reference>M28</reference>
	<description-loc>Особое
Создание духа соответствующего элеменета. Заклинатель может определить возможности создаваемого элементаля увеличивая или уменьшая атрибуты базового элементаля данного типа; он может менять, добавлять или убирать преимущества и недостатки с разрешения Мастера. Нет пределов вариации атрибутов, однако очень глупые элементали могут не понимать сложных команд. Вновь созданный элементаль служит заклинателю примерно один час. В конце этого времени проведите состязание между умением мага в данном заклинании и комбинацией ИН(IQ) и СЛ(ST) элементаля. При победе заклинателя, элементаль служит еще час, в его конце снова требуется состязание, и т.д. При проигрыше заклинателя, элементаль избегает контроля и уходит (или атакует, при очень плохой реакции).
Стоимость: 1 энергия за 5 очков персонажа на построение элементаля.
Время сотворения: количество секунд равное сумме очков персонажа на создание элементаля.
Требования: Магичность(Magery) 2 и Контроль элементаля соответствующего элемента.</description-loc>
</spell>
	<spell version="2">
		<name>Beast Soother</name>
		<name-loc>Успокоить зверя</name-loc>
		<description-loc>Обычное
Успокаивает одиночное животное. Бросок реакции животного на заклинателя улучшается на удвоенное значение вложенной в заклинание энергии.
Длительность: постоянно, пока что-либо не встревожит животное.
Стоимость: 1-3 
Требования: Убеждение или преимущество Понимание животных.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 to 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M29</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">animal friend</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
			<spell_prereq has="yes">
				<name compare="is">persuasion</name>
			</spell_prereq>
			<advantage_prereq has="yes">
				<name compare="is">animal empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (@Animal@)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Variable</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (Bird)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (Fish)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (Mammal)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (Reptile)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animal Control (Vermin)</name>
		<name-loc>Контроль (животного)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого животного или единичного роя (см. Атака роем, B461). Концентрация необходима. Это заклинание не будет работать на разумных (расовый ИН(IQ) 6 и более). Необходимо учить отдельное заклинание для контроля каждой категории животных.
Длительность: 1 минута
Стоимость: Различна. Стоимость сотворения равна ИН(IQ) наиболее разумных существ категории. Половина  за поддержание.
Требования: Успокоить животное.
Предмет
(а) Посох, палочка или украшение. Позволяет пользователю контролировать отдельный вид животных. Энергостоимость создания: 100 за очко расового ИН(IQ) животного. (б) Посох, палочка или украшение. Позволяет пользователю контролировать любое животное одной категории. Энергостоимость создания: 200 умножить на стоимость произнесения на эту категорию.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast Link</name>
		<name-loc>Связаться со зверем</name-loc>
		<description-loc>Обычное
Устанавливает ментальный контакт с животным. Оно должно находиться недалеко от заклинателя (общее правило - на расстоянии не более чем получаса ходьбы). Животное явится в любой момент по желанию заклинателя в быстром, но не убийственном для него темпе. Если это дикий зверь, то реакция должна быть определена в момент прибытия животного; прошлые хорошие реакции от других заклинаний не учитываются. Это заклинание похоже на Призыв зверя, но творится на конкретное животное.
Длительность: пока животное не вызвано. Считается «включенным» заклинанием.
Стоимость: 3.
Время сотворения: 5 секунд.
Требования: Призыв животного.
Животное отожествлено со своей жизнедеятельностью. Оно не отличает себя от неё. Оно и есть жизнедеятельность.
- Карл Маркс
Предмет
Подходящие амулеты. Золотой носит человек, серебряный - животное; дает человеку возможность творить Связь со зверем, или (если амулет самозарядный) устанавливать связь автоматически. Энергостоимость создания: 500 за пару.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Until next call</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast summoning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast Summoning</name>
		<name-loc>Призыв животного</name-loc>
		<description-loc>Обычное
Вызывает одно существо названного вида (кого угодно с ИН(IQ) меньше 6). Расстояние не имеет значения. Если заклинание успешно, заклинатель знает где находится ближайший представитель нужного вида и сколько времени ему потребуется для того что бы явиться к нему. Существо будет двигаться прямо к заклинателю, так быстро как только сможет, пока заклинание не закончится либо пока не увидит заклинателя. Оно будет стоять рядом не атакуя, пока действие заклинания не закончится. У призванного животного будет +1 к броску реакции на заклинателя (но только на него). Если заклинатель, либо кто-то рядом, атакует животное, заклинание разрушается.
Длительность: 1 минута
Стоимость: 3 сотворение, 2 поддержание. Чтобы призвать сразу много зверей, удвойте стоимость. Все существа в определенной области (обычно радиусом в 10 миль; больше при очень успешном броске) будут призваны. Конечно время, необходимое им на явление зависит от того, с какой скоростью они могу двигаться, и если заклинание закончится прежде чем они прибудут, они развернутся и пойдут по своим делам.
Требования: Успокоить животное.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 400 за предмет способный вызывать один вид животных или 800 за предмет который может вызвать любое животное.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast-Rouser</name>
		<name-loc>Возбудить зверя</name-loc>
		<description-loc>Обычное
Возбуждает одиночное животное. Бросок реакции животного (на кого угодно) ухудшается на удвоенное количество очков энергии вложенное в заклинание. 
Длительность: до тех пор пока не потребуется бросок реакции или по истечении часа.
Стоимость: 1 - 3. Не поддерживается.
Требования: Раздражение или преимущество Понимание животных
Предмет
посох, палочка или украшение. Энергостоимость создания: 500.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 to 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr or reaction roll</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">animal friend</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">animal empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<spell_prereq has="yes">
				<name compare="is">vexation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hybrid Control</name>
		<name-loc>Контроль гибрида</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Контролирует действия одного большого существа либо одного роя (см. Атаки роем, B461). Учтите тем не менее, что контроль объектов с МР(SM) больше 0 увеличивает энергостоимость заклинания. Концентрация необходима. Заклинатель должен знать все заклинания контроля относящиеся к гибриду (например контроль грифона потребует знания Контроля птиц и Контроля млекопитающих); его эффективное умение равно самому низкому из используемых умений, включая Контроль гибрида. Заклинание не работает на разумных существ (расовый ИН(IQ) 6 и выше).
Длительность: 1 минута.
Стоимость: 6 создание, 3 поддержание.
Требования: Как минимум два заклинания Контроль (животного).
Предмет
Посох, палочка или украшение. Энергостоимость создания: 800 (будет контролировать только один тип гибрида).</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">animal control</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Master</name>
		<name-loc>Хозяин</name-loc>
		<description-loc>Обычное или Блокирующее; сопротивление по ИН(IQ)
Удерживает любое животное неподвижным и спокойным пока заклинатель поддерживает контакт глаза в глаза и концентрируется. Заметьте, темнота нарушает контакт! Может быть использовано как блокирующее заклинание если животное подходит на расстояние Боя вплотную — т.е. атакует.
Длительность: неопределенна.
Стоимость: 2.
Требования: Успокоить животное.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 800.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Indefinite</duration>
		<reference>M30</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast soother</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast Speech</name>
		<name-loc>Звериная речь</name-loc>
		<description-loc>Обычное
Дает заклинателю возможность разговаривать с животными на их родном «языке». Полученная таким образом информация зависит от интеллекта зверя; существа вроде птиц вряд ли смогут рассказать много интересного. Муравей мог проползать мимо золота, но он может сказать только то, что материал был твердый и несъедобный. Каждая минута заклинания позволяет задать один вопрос и получить один ответ.
Длительность: 1 минута.
Стоимость: 4 сотворение, 2 поддержание.
Требования: Призыв животного.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 1000 за предмет, позволяющий разговаривать с конкретным типом животных или 4000 за рассчитанный на любых созданий.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast summoning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flesh to Stone</name>
		<name-loc>Плоть в камень</name-loc>
		<description-loc>Обычное; Сопротивление ЗД(HT)
Превращает живой объект (и всё его снаряжение!) в камень. Обязательно действует на объект целиком.
Длительность: мгновенно, пока не обратят обратно закинанием Камень в плоть.
Стоимость: 10. За двойную цену, объект можно превратить в металлическую статую.
Время сотворения: 2 секунды.
Требуется:  Землю в камень.
Предмет
Посох или жезл. Используется только магами. Энергостоимость создания: 1.000. Предмет должен прикасаться к жертве заклинания, чтобы заклинание сработало.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M31</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">earth to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (@Animal@)</name>
		<name-loc>Отпугнуть (животное)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Variable</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">Animal Control (@Animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (Bird)</name>
		<name-loc>Отпугнуть (живо)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (Fish)</name>
		<name-loc>Отпугнуть (животное)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (Mammal)</name>
		<name-loc>Отпугнуть (животное)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (Reptile)</name>
		<name-loc>Отпугнуть (животное)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Animal (Vermin)</name>
		<name-loc>Отпугнуть (животное)</name-loc>
		<description-loc>Областное
Отпугивает животных из области. Заклинание сопротивляется попыткам животных войти в его область (или находиться в ней) каждую секунду. проведите Быстрое состязание между эффективным умением заклинателя и СЛ(ST) животных. Как и Контроль (животного) это заклинание на самом деле является набором заклинаний. Необходимо выучить Отпугнуть (животное) для каждой категории животных. Область действия как и у всех остальных областных заклинаний простирается на 4 ярда вверх (важная деталь для летающих животных, таких как летучие мыши и птицы). Заклинатель может увеличить область вверх пропорционально увеличивая энергозатраты. Удвоение энергии даст область в 8 ярдов высотой и так далее. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. 
Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения. Таким образом пастух может с помощью данного заклинания разогнать волков не разгоняя своего стада.
Длительность: 1 час.
Базовая стоимость: равна стоимости сотворения Контроль (животного) для соответствующего типа.
Время сотворения: 10 секунд.
Требования: Контроль(животного) того же типа, что и отпугиваемые.
Предмет
Область может быть навсегда сделана отпугивающей за 100-кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Repel Hybrids</name>
		<name-loc>Отпугнуть гибридов</name-loc>
		<description-loc>Областное
Отпугивает гибридов из области. Заклинания препятствует им зайти (или находится) в области действия. Каждую секунду проводите Быстрое состязание между эффективным умением заклинателя и звериной СЛ(ST). Заклинатель должен знать Отпугнуть (животное) относящихся к гибриду типов. Его эффективное умение равно наименьшему из всех учитываемых умений, включая Отпугнуть гибридов. Те, у кого есть Понимание животных могут ощущать скованность и раздражительность пока находятся в области действия заклинания. Заклинатель может исключить определенных животных из эффекта заклинания во время сотворения.
Длительность: 1 час.
Базовая стоимость: 6 сотворение, 3 поддержание.
Требования: Контроль гибрида.
Предмет
Область может быть навсегда сделана отпугивающей за 100 кратную энергостоимость.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hybrid control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rider (@Animal@)</name>
		<name-loc>Наездник</name-loc>
		<description-loc>Обычное
Позволяет заклинателю оседлать и ехать верхом на объекте заклинания так, как будто это тренированное, послушное верховое животное. Существо должно быть способно нести вес заклинателя, а он все равно должен делать броски Верховой езды в ситуации, где этого требовало бы обычное ездовое животное. Концентрация не требуется.
Длительность: 5 минут.
Стоимость: 2 сотворение, 1 поддержание.
Требования: хотя бы одно заклинание Контроль (животного). Заклинание можно использовать лишь на существ, для которых вы знаете заклинание Контроль, которое потребуется творить перед тем, как начинать данное заклинание.
Предмет
Посох, палочка или украшение. Заклинание не подействует на существо, пока носитель не оседлает животное. Если носитель сброшен, существо остается послушным около минуты, после чего убежит или атакует (что более естественно). Энергостоимость создания: 800 за вещь, которая подчиняет конкретный тип животных или 3000 за подчиняющую любое животное.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">Animal Control (@Animal@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rider Within</name>
		<name-loc>Внутренний наездник</name-loc>
		<description-loc>Обычное
Работает на любое животное (но не на разумное создание). Это модификация заклинания Наездник души для животных. Заклинатель получает возможность видеть из глаз объекта, слышать его ушами и т.д. Эффект продолжается пока заклинатель концентрируется. (он остается осведомленным о состоянии собственного тела и может действовать как обычно) Заклинатель не получает никакого контроля над объектом, и объект не осведомлен о том, что у него «внутренний наездник».
Длительность: 1 минута.
Стоимость: 4 сотворение, 1 поддержание.
Время сотворения: 3 секунды.
Требования: минимум два разных заклинания контроля животных. Заклинатель должен знать заклинание контроля, соответствующего типа животных, внутри которого он собирается «прокатиться».
Предмет
Два одинаковых ювелирных изделия, одно золотое, другое серебряное. Золотое должно быть надето на заклинателя, серебряное на объект (обычно на ошейник). После чего заклинание может быть использовано в любой момент. Используется только магами. Если камень силы встраивается в изделие - то в золотое. Если одно изделие сломано - второе теряет Магичность(Magery). Энергостоимость создания: 1000 за пару и каждое должно нести опал не дешевле, чем $100.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M31</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animal control (@animal@)</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast Possession</name>
		<name-loc>Вселение в зверя</name-loc>
		<description-loc>Обычное, Сопротивление по Воле(Will)
Подобно заклинанию Внутренний наездник, за исключением того, что заклинатель получает полный контроль над объектом заклинания «изнутри» и имеет полный доступ к памяти и способностям животного. Находясь «внутри» тела объекта заклинатель может использовать все умения и способности, как будто они его собственные. Он может использовать свои ментальные способности но не физические (что означает что он не может творить заклинания пока не выучит их до той степени, чтобы не нуждаться в жестах либо словах). Собственное тело заклинателя лежит без сознания и должно охраняться.
Длительность: 1 минута.
Стоимость: 6 сотворение, 2 поддержание.
Время сотворения: 5 секунд.
Требования: Внутренний наездник или Вселение
Предмет
Так же как и для Внутреннего наездника, но дороже. Энергостоимость создания: 1500 (за пару). Каждый амулет должен содержать опал стоимостью не менее $200.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M32</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">possession</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">rider within</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beast Seeker</name>
		<name-loc>Поиск Зверя</name-loc>
		<description-loc>Информационное
Это заклинание похоже на Поиск (M105), но работает только на животных. Оно может быть сотворено на любой вид, конкретное животное или просто любое животное.
Стоимость: 3. Одна попытка в неделю на вид.
Требования: либо Призыв животного и как минимум два других заклинания поиска, либо Поиск.
Прдемет
Раздвоенная палочка (деревянная, костяная или слоновой кости) или стрелка компаса (вырезанная из кости) которая показывает на вид животного определенный в момент создания, либо на любое животное. Одна унция кости животного соответствующего вида должна быть использована при создании. Энергостоимость создания: 500.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M32</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="no">
			<prereq_list all="yes">
				<spell_prereq has="yes">
					<name compare="contains">seek</name>
					<quantity compare="at least">2</quantity>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">beast summoning</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Beast Possession</name>
		<name-loc>Постоянное вселение в зверя</name-loc>
		<description-loc>Обычное, Сопротивление по Воле(Will)
Как и Вселение в зверя, но сознание заклинателя остаётся в теле объекта до тех пор, пока не решает покинуть его или не будет изгнано с помощью Рассеять вселение, Контрзаклинание, Убрать проклятие или похожим заклинанием. Помните, что заклинатель обязан знать соответствующее заклинание Контроль(животного) чтобы использовать заклинание на выбранный объект. Тело заклинателя находится под эффектом Остановленной жизнедеятельности (M94) пока продолжается заклинание. Если тело заклинателя умирает, заклинание разрушается. Если тело объекта получает повреждения, заклинатель должен бросить ЗД(HT) чтобы избежать таких же повреждений своему телу. Если животное-объект умирает, заклинатель должен бросить ЗД(HT) или умереть! Дополнительно, заклинатель должен делать броски ИН(IQ) каждый день нахождения в теле животного; проваленный бросок означает, что заклинатель теряет одно очко ИН(IQ). Он не должен делать броски после того, как достигнет нормального ИН(IQ) для данного вида зверей. Утраченный ИН(IQ) восстанавливается как только заклинание заканчивается. Если заклинатель достигает ИН(IQ) 5, только Убрать проклятие или Рассеять вселение могут прервать заклинание. 
Длительность: не ограничена (может быть постоянным).
Стоимость: 20.
Требования: Магичность(Magery) 2 и Вселение в зверя.
Предмет
Шляпа, корона, шлем или другой головной убор. На предмете должно быть изображения животного, на которое предмет применим. Используется только магами. Энергостоимость создания: 2000.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Indefinite</duration>
		<reference>M32</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">beast possession</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Protect Animal</name>
		<name-loc>Защитить животных</name-loc>
		<description-loc>Областное
Сотворённое на область, это заклинание защищает всех животных определенного типа пока они находятся в ней. Попытки повредить им наткнутся на сопротивление невидимых защитников. Защищённые животные получают ПЗ(DB) +3 и СП(DR) 5. 
Это также заклинание школы Предупреждения и защиты.
Длительность: 1 минута.
Базовая стоимость: 1. Столько же на поддержание.
Время на сотворение: 1 минута.
Требования: Броня, Сторожевой пёс и три заклинания школы Животных.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M32</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">animal</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">watchdog</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">armor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Shapeshifting (@Specialty@)</name>
		<name-loc>Превращение</name-loc>
		<description-loc>Специальное
Заклинатель превращается в животное. Каждая животная форма требует разных заклинаний, изучаемых отдельно. Заклинатель способен научиться превращаться лишь в тот тип животного, с которым он знаком. Во многих мирах можно превращаться только в некоторых животных.  Одежда, украшения и доспехи исчезают при принятии животной формы, и появляются вновь при возвращении в человеческую форму (магические украшения не могут быть обнаружены, когда «исчезают» при смене формы). Рюкзак, вещи и т.п. просто падают на землю. 
Заклинатель сохраняет свой интеллект, но получает физические способности новой формы. Это значит, что заклинания могут твориться, только если не требуют жестикуляции. Учтите, что силы, затрачиваемые на заклинания не увеличивается.
Также, в каждый час действия заклинания должен быть сделан бросок ИН(IQ), про провале заклинатель теряет единицу ИН(IQ), это продолжается пока ИН(IQ) не достигнет животного. Если ИН(IQ) заклинателя упадет до 5 - он заперт в теле животного пока заклинание не будет снято сотворением Убрать проклятие (другие заклинания не помогут). Потерянный ИН(IQ) восстанавливается при возвращении в человеческую форму.
Для большинства естественных животных форм приемлемая энергостоимость 6 на сотворение и 2 на поддержку; животные с большой силой, например, балансируются пониженной ловкостью. Тем не менее, если Мастер позволяет использовать сверхъестественных существ либо озабочен большой мощью данной животной формы, он может захотеть изменить стоимость этого заклинания. Подходящий способ расчета очков физических характеристик звериной формы - это 1/20  энергии за очко на сотворение и 1/60 на поддержание, минимум 3 на сотворение и 1 на поддержку.
Длительность: 1 час.
Стоимость: различна (см. выше).
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и минимум шесть других заклинаний любого типа.
Предмет
(а) Украшение. Должно иметь сходство с формой животного, в которое будет превращаться владелец. Используется только магами или натуральными оборотнями. Остается на заклинателе после превращения, так что в большинстве случаев это ошейник или ожерелье. Не имеет стоимости поддержания, однако заклинатель не может превратиться обратно в человека, если предмета на нём нет; или Убрать проклятие должно быть использовано для возвращения в нормальную форму. Энергостоимость создания: 1.500. (б) Шкура животного, форму которого примет владелец, также как и выше, однако шкура врастает в тело и не может быть потеряна! Энергостоимость создания: 3.000.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M32</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<any></any>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spider Silk</name>
		<name-loc>Паучий шёлк</name-loc>
		<description-loc>Специальное; Метательное
Заклинатель выстреливает нить паучьего шёлка, которая вытягивается из кончиков его пальцев к цели. Нити кажутся легкими и невесомыми, однако они очень прочные и могут выдержать до 500 фунтов не разрываясь. Как дистанционное, имеет Range (Дальность) равную длине нити, Acc (Точность) 3. Используйте ЛВ(DX) заклинателя либо умения Природная атака для попадания. При попадании жертва схвачена и обездвижена, как при преимуществе Сковывание с улучшением Липкий (B40). У единичной нити эффективная сила 10 и СП(DR) 3. Паучий шёлк получает тройное повреждение от атак основанных на огне. 
Заклинатель может метнуть столько нитей сколько у него есть рук за одно сотворение заклинания. Тем не менее, энергостоимость основывается на общей длине созданных нитей. Таким образом многорукий демон-паук может метнуть сразу пол дюжины нитей, но это будет недёшево.
Нити паучьего шёлка так же можно использовать для постройки сети, закрепляя концы между двумя поверхностями. Эта сеть захватит любого, кто попытается пройти сквозь нее. Механически, это подобно атаке Сковыванием с модификаторами Липкий и Область действия (B40). У сети СЛ(ST) 10 СП(DR) 3 плюс 1 СЛ(ST) за каждую дополнительную нить. 
Длительность: 1 минута.
Стоимость: 1 за сотворение 5 ярдов нити (максимум 100 ярдов). Половина за поддержание.
Требования: Магичность(Magery) 1 и два заклинания из Школы животных.
Предмет
Посох или палочка. Могут использовать только маги. Нить выстреливается из конца предмета. Энергостоимость создания: 400.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1/5 yd strand</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<ranged_weapon>
			<damage>grapple ST 10/strand</damage>
			<accuracy>3</accuracy>
			<range>5/point</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M32</reference>
		<notes>max range 100 yards</notes>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="is">animal</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Shapeshifting (@Specialty@)</name>
		<name-loc>Постоянное превращение</name-loc>
		<description-loc>Обычное
Как и Превращение, но объект остается в звериной форме пока не решит вернуться в нормальную форму. Он должен бросать ИН(IQ) ежедневно, а не ежечасно.
Длительность: не определена (может быть постоянной).
Стоимость: в пять раз больше, чем соответствующее Превращение.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3 и соответствующее Превращение.
Предмет
(а) Украшение. Предмет должен содержать изображение формы в которую позволяет превращаться. Используется только магами либо натуральными оборотнями. Оно остается на объекте когда форма изменена; заметьте, что объект не может прервать заклинание если потеряет предмет (иначе только Убрать проклятие может помочь!). Энергостоимость создания: 3.000. (б) Шкура принимаемой формы, также как и выше, однако шкура врастает в тело и не может быть потеряна! Энергостоимость создания: 4.500 .</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Indefinite</duration>
		<reference>M33</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">Shapeshifting (@Specialty@)</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Shapeshift Others</name>
		<name-loc>Превратить другого</name-loc>
		<description-loc>То же что и Превращение, но действует на объект (другого человека). Объект не может прекратить действие заклинания, это может сделать только заклинатель или успешное сотворение Убрать проклятье. Если ИН(IQ) объекта падает до 5, то он заперт в звериной форме!
Длительность: 1 час.
Стоимость: как и для Превращения, но минимум 6 на сотворение, 2 на поддержание.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 2 и соответствующее Превращение.
Предмет
(а) Посох или палочка. Используется только магами; нужно коснуться объекта. Энергостоимость создания: 3.000. (б) Шкура принимаемой формы. Всегда «включена». Одетая на объект, накладывает на него  эффект навсегда (быстрая потеря ИН(IQ) как описано выше), пока не будет снята заклинанием Убрать проклятие; затем её можно использовать снова. Энергостоимость создания: 3.000.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M33</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shapeshifting (@specialty@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Shapeshift</name>
		<name-loc>Великое превращение</name-loc>
		<description-loc>Специальное
Производит многочисленные, быстрые повторяющиеся изменения формы, временно используя способность Полиморф (B84). Тем не менее, заклинание прекращается, если любая часть заклинателя возвращается в его настоящую форму. Заклинатель ментально оглушается после окончания заклинания. 
 Одежда, украшения и доспехи исчезают при принятии животной формы, и появляются вновь при возвращении в человеческую форму (магические украшения не могут быть обнаружены, когда «исчезают» при смене формы). Рюкзак, вещи и т.д. просто падают на землю.
При минимальной стоимости, Великое превращение позволяет заклинателю превращаться только в существ чей расовый шаблон стоит 0 и менее (заметьте, что это немного отличается от способности Полиморф). Каждое дополнительное очко энергии, тем не менее, добавляет 5 очков к максимальной стоимости доступного расового шаблона.
Пока заклинатель изменяется, к нему применимы все требования по Магическим ритуалам (M8). Это означает, что если он превратится в форму в которой не может говорить либо жестикулировать, он не сможет творить заклинания, которые знает на уровне менее 20.
Маги, знающие Великое превращение могут использовать Контрзаклинание для того чтобы удержать мага сотворившего Великое превращение в той форме в которой он находится в данный момент на количество секунд, равное выигрышу в состязании броска Контрзаклинания (или до тех пор пока Великое превращение не закончится).
Длительность: 1 минута.
Стоимость: 20 на сотворение, плюс 1 за каждые 5 дополнительных очков стоимости расового шаблона. Половина на поддержание.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 3, Изменить тело, четыре типа Превращения, и как минимум 10 других заклинаний любого типа.
Предмет
Украшение, отделанное множеством звериных мотивов. Используется только магами. Предмет исчезает  когда заклинание начинается, и появляется после его завершения. Энергостоимость создания: 5.000.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M34</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">Alter Body</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<any></any>
				<quantity compare="at least">15</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="contains">Shapeshifting</name>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Partial Shapeshifting</name>
		<name-loc>Частичное превращение</name-loc>
		<description-loc>Обычное, Сопротивление по Воле(Will)
Как превращение, но затрагивает лишь одну часть тела. Объектом заклинания может быть как сам заклинатель так и кто-нибудь другой. Каждая вариация — отдельное заклинание. 
Результирующая часть тела сохраняет масштаб тела объекта: превращение человеческой головы в голову колибри создаст человека с головой колибри человеческого размера. Некоторые вариации носят сбивающие с толку названия: Крокодильи челюсти, к примеру, означают превращение головы полностью, не только челюстей — челюстные мышцы должны быть закреплены соответственно! 
Некоторые известные вариации:
Глаза хамелеона (Chameleon Eyes) (3 на сотворение): объект получает Улучшенное слежение 1 (B53) и Периферийное зрение (B74)
Крокодильи челюсти (Crocodile Jaws) (5 на сотворение): голова объекта становится крокодильей, принося объекту Острые зубы (B91) и СЛ(ST) 20 только для укусов. Речь невнятная, но разобрать можно. Как побочный эффект объект получает Периферийное зрение и Дальтонизм (B127).
Слоновий хобот (Elephant Trunk) (3 на сотворение): нос объекта превращается в хобот, даря Дополнительную руку (B53). Как побочный эффект объект получает Периферийное зрение и Дальтонизм (B127).
Оперённые руки (Feathered Arms) (3 на сотворение): руки объекта превращаются в крылья, предоставляя объекту Полет (крылатый) (B56)
Рыбий хвост (Fish Tail) (3 на сотворение): ноги объекта сливаются в мощный хвостовой плавник, давая объекту Увеличенное движение (вода) (B52).
Копыта горного козла (Mountain Goat Hooves) (4 на сотворение): ступни объекта превращаются в копыта горного козла, давая ему Лазание-14 (полезно только в горах) и Прыжки-14.
Саблезубый (Saber Teeth) (5 на сотворение): клыки объекта становятся острыми и длинными, давая ему Клыки (B91) и СЛ(ST) 25 только для укусов. Речь немного затруднена. Объект получает Дальтонизм как побочный эффект. 
Хвост cкорпиона (Scorpion Tail) (7 на сотворение): у объекта вырастает жало скорпиона вместе с ядовитыми железами. Это проникающее Естественное оружие (B88) с улучшением Последующая. При удачном проникающем ударе, жертва страдает от эффекта Природной атаки 1d+2 (Токсическая, Контактный бой, Сопротивляемая). Жертва может сопротивляться яду скорпиона бросив ЗД(HT)-6. 
Змеиные клыки (Serpent’s Fangs) (3 на сотворение): клыки жертвы приобретают способность производить ядовитый укус. Это Природная атака 1d+1 (Контактный бой, Контактное действие, Токсическая, Сопротивляемая (ЗД(HT)-4), Циклическая (ежедневно, длится три дня)).
Хвост скунса (Skunk Tail ) (3 на сотворение): у объекта вырастает огромный хвост скунса (2 ярда длиной) и даёт ему способность использовать заклинание Зловоние (M24). по желанию. Область эффекта круг 2 ярда радиусом в центр которого должена находиться любая часть хвоста. Способность стоит 2 ЕУ(FP) за использование.
Паучьи руки (Spider Arms) (7 на сотворение): у объекта вырастает две Дополнительные руки и он получает одну Дополнительную атаку (B53).
Тигриные лапы (Tiger Paws) (4 на сотворение): руки объекта превращаются в тигриные лапы, давая ему Острые когти и Ударную силу 24, но так же дают Нет хороших манипуляторов (B145).
Язык лягушки (Toad Tongue) (3 на сотворение): язык объекта становиться длинным и липким. Помогает как Дополнительная рука с особенностями Длинная и Слабая но с дополнительной Ударной силой — она атакует с обычной СЛ(ST) объекта, но поднимает только с 1/4 СЛ(ST). Объект также получает Периферийное зрение как побочный эффект. 
Панцирь черепахи (Turtle Shell) (10 на сотворение): объект оказывает в черепашьем панцире. Он имеет СП(DR) 5 и весит 4 фунта на очко СЛ(ST) объекта.
Длительность: 1 час.
Стоимость: различна. Всегда не меньше 3. Треть (округлять вверх) на поддержание.
Требования: Магичность(Magery) 3, Превратить другого для соответствующего животного и Изменить тело.
Предмет
Форма предмета зависит от того, какую часть тела он превращает — перчатки для рук, обувь для ног, маска для лица и т.д. Должно быть похоже на форму в которую превращает. Нет стоимости поддержания. Заклинание прекращается когда использующий делает вид что снимает предмет. Энергостоимость создания: 1.000 плюс 250 за очко стоимости сотворения.</description-loc>
		<college>Animal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M34</reference>
		<categories>
			<category>Animal</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (animal)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">alter body</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="starts with">shapeshift others</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Climbing</name>
		<name-loc>Лазание</name-loc>
		<description-loc>Обычное
Придаёт объекту силу и цепкость, повышая умение Лазание.
Длительность: 1 минута.
Стоимость: 1-3. Столько же поддержание. Увеличение умения равно удвоенной вложенной энергии.
Предмет
Обувь, перчатки, одежда или украшения, влияет только на владельца. Энергостоимость создания: 250 за премию +1 (максимум 5).</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Itch</name>
		<name-loc>Зуд</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Вызывает у объекта сильный зуд в выбранном заклинателем месте. Объект получает -2 к ЛВ(DX), пока не потратит полный ход на «почесаться» (дольше, если мешает броня или что-то еще!). Одновременно на объект может быть наложено только одно такое заклинание.
Длительность: пока объект не потратит полный ход на почёсывание.
Стоимость: 2. Не поддерживается.
Предмет
(а) Посох или палочка; используется только магами. Предмет должен коснуться жертвы. Энергостоимость создания: 100. (б) Любой предмет; действует всегда. Владелец чешется постоянно и получает -2 ЛВ(DX) пока предмет одет. Энергостоимость создания: 60.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Until scratched</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Perfume</name>
		<name-loc>Аромат</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект источает сильный запах на выбор мага. Субъект может ощущать запах, но не сочтет его слишком ярким (хотя его соседи – определенно смогут), независимо от его вида.
Длительность: 10 минут.
Стоимость: 2 на сотворение. 1 на поддержание.
Требования: Запах (M24).
Предмет
Посох или палочка. Предмет должен касаться объекта. Энергостоимость создания: 200.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">odor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spasm</name>
		<name-loc>Спазм</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Может быть направлено против любого мускула (c произвольным контролем) объекта. Направленное против руки заставляет объект бросить то, что зажато в руке (обычно это оружие). Если объект в этот момент выполняет пассы для сотворения заклинания, он должен выполнить бросок ЛВ(DX), чтобы продолжить. Изобретательные маги найдут и другие возможности для использования этого заклинания.
Длительность: мгновенно.
Стоимость: 2. Не поддерживается.
Требования: Зуд.
Предмет
(а) Посох или волшебная палочка; используется только магами. Предмет должен касаться жертвы. Энергостоимость создания: 300. (б) Любой предмет; действует всегда. Владелец должен бросать ЗД(HT) каждый раз, когда делает что-то деликатное (например, взлом замка, произнесение заклинания). При провале владелец получает Спазм. Энергостоимость создания: 100.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">itch</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stop Spasm</name>
		<name-loc>Остановить спазм</name-loc>
		<description-loc>Обычное
Немедленно прекращает спазмы любого рода – включая рвоту и эпилепсию. Магические причины получают право на сопротивление.
Также относится к заклинаниям Лечения.
Стоимость: 1.
Требования: Спазм или Передать здоровье.
Предмет
(а) Посох или волшебная палочка, с нанесенным изображением змеи. Используется только магами или обладающими умением Врачебное дело на уровне 15 или выше. Энергостоимость создания: 400. (б) Любой предмет. Всегда включён. Он защищает владельца от спазмов (даёт +5 к сопротивлению Спазму). Энергостоимость создания: 750.</description-loc>
		<college>Healing/Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Touch</name>
		<name-loc>Касание</name-loc>
		<description-loc>Обычное
Объект чувствует легкое касание к месту на выбор заклинателя. Касание обходит любую броню, но не имеет никаких других эффектов, кроме привлечения внимания. Оно не может нанести вред или дискомфорта, но очень хорошо отвлекает.
Стоимость: 1.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 50.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M35</reference>
		<categories>
			<category>Body Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Clumsiness</name>
		<name-loc>Неуклюжесть</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Уменьшает ЛВ(DX) объекта на 1 за каждое очко энергии, вложенное в заклинание. Все умения зависящие от ЛВ(DX) тоже уменьшаются.
Длительность: 1 минута.
Стоимость: 1-5. Половина за поддержание (округлять вверх).
Требования: Спазм.
Предмет
(а) Любой предмет. Всегда включён; Уменьшает ЛВ(DX) владельца. Энергостоимость создания: 100 за каждое уменьшаемое очко ЛВ(DX). (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Debility</name>
		<name-loc>Слабость</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Временно снижает СЛ(ST) объекта. Это уменьшит наносимый им вред, но не повлияет на ЕЖ(HP). Также уменьшает и грузоподъемность, но Мастер может проигнорировать это в интересах играбельности.
Длительность: 1 минута.
Стоимость: 1 за каждое уменьшаемое очко СЛ(ST) (максимум -5). Половина за поддержание (округлять вверх).
Предмет
(а) Посох или палочка. Используется только магами; необходимо указать на объект (касание не обязательно). Энергостоимость создания: 900. (б) Любой предмет. Всегда включён; уменьшает СЛ(ST) владельца. Энергостоимость создания: 100 за каждое уменьшаемое очко СЛ(ST).</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/-ST</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Hinder</name>
		<name-loc>Помеха</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Уменьшает базовое движение(BM) и Уклонение (dodge) объекта на 1 за каждое вложенное очко энергии. 
Также относится к заклинаниям школы Движения.
Длительность: 1 минута.
Стоимость: 1-4. Столько же поддержание.
Требования: Неуклюжесть или Ускорение (M142).
Предмет
(а) Посох или палочка. Используется только магами; необходимо указать на объект (касание не обязательно). Энергостоимость создания: 600. (б) Любой предмет. Всегда включён; уменьшает базовое движение(BM) владельца. Энергостоимость создания: 200 за каждый ярд, на который уменьшается базовое движение(BM) владельца.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pain</name>
		<name-loc>Боль</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект испытывает приступ ужасной боли. Нужен бросок Воли(Will), чтобы не закричать и не прервать действие. Если объект выполняет какое-то опасное действие (лезет по стене, например) – необходим бросок ЛВ(DX), чтобы избежать катастрофы. Жертва получает -3 к ЛВ(DX) и всем умениям, основанным на ней, на всю следующую секунду. Если в момент действия жертва творит заклинание, она должна бросить Волю(Will), чтобы не прерваться. Высокий болевой порог дает +3 к вышеуказанным броскам ЛВ(DX) и Воли(Will), Низкий болевой порог -4.
Длительность: 1 секунда.
Стоимость: 2. Не поддерживается.
Время сотворения: 2 секунды.
Требования: Спазм.
Предмет
(а) Посох или палочка; используется только магами. Предмет должен касаться жертвы. Энергостоимость создания: 400. (б) Любой предмет; действует всегда. Владелец чувствует острую боль, которая будет продолжаться до тех пор, пока не будет произведена успешная проверка ЗД(HT). Также владелец не может ни чего делать пока не будет успешного броска ЗД(HT)! Энергостоимость создания: 300.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rooted Feet</name>
		<name-loc>Вросшие ноги</name-loc>
		<description-loc>Обычное; Сопротивление по СЛ(ST)
Ноги объекта приклеиваются к поверхности! Он может пытаться освободиться каждый ход, делая новый бросок сопротивления с -5 против исходного уровня умения заклинания. Пока ноги приклеены, объект получает штраф -2 на любые боевые/оружейные умения, кроме дальнобойных. Уклонение также падает наполовину (округлять вниз). 
Длительность: 1 минута или пока объект не освободится.
Стоимость: 3. Не поддерживается.
Требования: Помеха.
Предмет
(а) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 400. (б) Любой предмет. Всегда включён; владелец должен делать бросок (СЛ(ST)-5) каждый ход для того чтобы сдвинуться с места. Провал броска означает, что он не может сдвинуться с места. Энергостоимость создания: 600.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min or until free</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hinder</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Roundabout</name>
		<name-loc>Развернуть</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Поворачивает субъект на месте в нужном магу направлении. Это не телепортация, а физическое действие. Для нормального действия в свой ход субъект должен бросить Чувство тела (или ЛВ(DX)-6). Если объект в предыдущий ход двигался со скоростью 2 и больше, он должен бросать также и ИН(IQ), или продолжит двигаться в новом направлении.
Длительность: мгновенно.
Стоимость: 3.
Требования: Спутать ноги.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">tanglefoot</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Tanglefoot</name>
		<name-loc>Спутать ноги</name-loc>
		<description-loc>Обычное; Сопротивление по ЛВ(DX)
Объект немедленно спотыкается и падает.
Длительность: мгновенно.
Стоимость: 2.
Требования: Неуклюжесть.
Предмет
Посох или палочка. Используется только магами; необходимо указать на объект (касание не обязательно). Энергостоимость создания: 600.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Tickle</name>
		<name-loc>Щекотка</name-loc>
		<description-loc>Обычное; Сопротивление по Воли(Will)
Объект чувствует сильную щекотку. При провале сопротивления он не сможет делать ничего, кроме как смеяться и пытаться убежать. Это серьезное воздействие; жертва выводится из строя как при судорогах (см. Состояния недееспособности, B428). Если необходимо вести себя тихо – необходим дополнительный бросок Воли(Will). Высокий или низкий болевой порог никак не влияют на сопротивление заклинанию. Невозмутимые получают +5 к сопротивлению.
Длительность: 1 минута.
Стоимость: 5 создание. 5 поддержание (необходима концентрация).
Требования: Спазм.
Предмет
(а) Посох, палочка или перо. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 600. (б) Стул, кресло или подушка. Всегда включён. Любой, кто сядет в стул или кресло будет немедленно «атакован» заклинанием. Это отличная шутка. Энергостоимость создания: 250.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>5</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M36</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">itch</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Boost Dexterity</name>
		<name-loc>Увеличить ловкость</name-loc>
		<description-loc>Обычное или Блокирующее
Имеет четыре вида, по одному на каждый атрибут: Увеличить Ловкость, Увеличить Здоровье, Увеличить Силу и Увеличить интеллект. Каждый вариант заклинания имеет собственные требования, и должен изучаться отдельно, но работают они совершенно одинаково.
Увеличивает указанный атрибут объекта, только для одного броска или одного короткого действия, занимающего не более секунды – одного Быстрого состязания, броска атрибута, нанесения удара, подготовки оружия, сопротивления заклинанию, метания предмета и т.д. Не может увеличить бросок, представляющий несколько секунд усилий – например, обычного Состязания. Увеличенный атрибут также увеличивает все зависимые от него параметры, кроме единиц жизни и усталости. Стоимость не уменьшается за высокий уровень умения.
Заклинание Увеличить интеллект относится к заклинаниям Контроля разума, а не Контроля тела.
Стоимость: 1 за каждое увеличиваемое очко атрибута (максимум 5).
Требования: каждый вид заклинания имеет собственные требования:
Заклинание	Требования
Увеличить ловкость	Изящество
Увеличить здоровье	Здравие
Увеличить силу	Мощь
Увеличить интеллект	Мудрость
Предмет
Посох, палочка, украшение или предмет одежды. Энергостоимость создания: 300.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Blocking</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Boost Health</name>
		<name-loc>Увеличить здоровье</name-loc>
		<description-loc>Обычное или Блокирующее
Имеет четыре вида, по одному на каждый атрибут: Увеличить Ловкость, Увеличить Здоровье, Увеличить Силу и Увеличить интеллект. Каждый вариант заклинания имеет собственные требования, и должен изучаться отдельно, но работают они совершенно одинаково.
Увеличивает указанный атрибут объекта, только для одного броска или одного короткого действия, занимающего не более секунды – одного Быстрого состязания, броска атрибута, нанесения удара, подготовки оружия, сопротивления заклинанию, метания предмета и т.д. Не может увеличить бросок, представляющий несколько секунд усилий – например, обычного Состязания. Увеличенный атрибут также увеличивает все зависимые от него параметры, кроме единиц жизни и усталости. Стоимость не уменьшается за высокий уровень умения.
Заклинание Увеличить интеллект относится к заклинаниям Контроля разума, а не Контроля тела.
Стоимость: 1 за каждое увеличиваемое очко атрибута (максимум 5).
Требования: каждый вид заклинания имеет собственные требования:
Заклинание	Требования
Увеличить ловкость	Изящество
Увеличить здоровье	Здравие
Увеличить силу	Мощь
Увеличить интеллект	Мудрость
Предмет
Посох, палочка, украшение или предмет одежды. Энергостоимость создания: 300.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Blocking</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">vigor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Boost Intelligence</name>
		<name-loc>Увеличить интеллект</name-loc>
		<description-loc>Обычное или Блокирующее
Имеет четыре вида, по одному на каждый атрибут: Увеличить Ловкость, Увеличить Здоровье, Увеличить Силу и Увеличить интеллект. Каждый вариант заклинания имеет собственные требования, и должен изучаться отдельно, но работают они совершенно одинаково.
Увеличивает указанный атрибут объекта, только для одного броска или одного короткого действия, занимающего не более секунды – одного Быстрого состязания, броска атрибута, нанесения удара, подготовки оружия, сопротивления заклинанию, метания предмета и т.д. Не может увеличить бросок, представляющий несколько секунд усилий – например, обычного Состязания. Увеличенный атрибут также увеличивает все зависимые от него параметры, кроме единиц жизни и усталости. Стоимость не уменьшается за высокий уровень умения.
Заклинание Увеличить интеллект относится к заклинаниям Контроля разума, а не Контроля тела.
Стоимость: 1 за каждое увеличиваемое очко атрибута (максимум 5).
Требования: каждый вид заклинания имеет собственные требования:
Заклинание	Требования
Увеличить ловкость	Изящество
Увеличить здоровье	Здравие
Увеличить силу	Мощь
Увеличить интеллект	Мудрость
Предмет
Посох, палочка, украшение или предмет одежды. Энергостоимость создания: 300.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Blocking</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M37</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">wisdom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Boost Strength</name>
		<name-loc>Увеличить силу</name-loc>
		<description-loc>Обычное или Блокирующее
Имеет четыре вида, по одному на каждый атрибут: Увеличить Ловкость, Увеличить Здоровье, Увеличить Силу и Увеличить интеллект. Каждый вариант заклинания имеет собственные требования, и должен изучаться отдельно, но работают они совершенно одинаково.
Увеличивает указанный атрибут объекта, только для одного броска или одного короткого действия, занимающего не более секунды – одного Быстрого состязания, броска атрибута, нанесения удара, подготовки оружия, сопротивления заклинанию, метания предмета и т.д. Не может увеличить бросок, представляющий несколько секунд усилий – например, обычного Состязания. Увеличенный атрибут также увеличивает все зависимые от него параметры, кроме единиц жизни и усталости. Стоимость не уменьшается за высокий уровень умения.
Заклинание Увеличить интеллект относится к заклинаниям Контроля разума, а не Контроля тела.
Стоимость: 1 за каждое увеличиваемое очко атрибута (максимум 5).
Требования: каждый вид заклинания имеет собственные требования:
Заклинание	Требования
Увеличить ловкость	Изящество
Увеличить здоровье	Здравие
Увеличить силу	Мощь
Увеличить интеллект	Мудрость
Предмет
Посох, палочка, украшение или предмет одежды. Энергостоимость создания: 300.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Blocking</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">might</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Frailty</name>
		<name-loc>Хрупкость</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Временно понижает ЗД(HT) объекта. Уменьшение действует на все зависимые от ЗД(HT) параметры и броски (Базовую Скорость, умения, основанные на ЗД(HT), сопротивление заклинаниям и ядам, броски против потери сознания и смерти и т.д.). Стоимость не уменьшается за высокий уровень умения.
Длительность: 1 минута.
Стоимость: 2 за каждое уменьшаемое очко ЗД(HT) (максимум 5). Столько же поддержание.
Требования: Передать энергию (M89).
Предмет
(а) Любой предмет. Всегда включён; уменьшает ЗД(HT) владельца, пока одет. Энергостоимость создания: 200 за каждое уменьшаемое очко ЗД(HT). (б) Посох или волшебная палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/-HT</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Grace</name>
		<name-loc>Изящество</name-loc>
		<description-loc>Обычное
Временно увеличивает ЛВ(DX) объекта (максимум 5). Все умения и параметры, основанные на ловкости, также увеличиваются. Волшебник может увеличить и свою ЛВ(DX) для того чтобы повысить свои шансы в использовании метательных заклинаний и т.п.
Длительность: 1 минута.
Стоимость: 4 за каждое увеличиваемое очко ЛВ(DX) (максимум 5). Столько же поддержание.
Требования: Неуклюжесть.
Предмет
(а) Любой предмет. Всегда включён; увеличивает ЛВ(DX) владельца только когда используется! Это очень редкий предмет. Энергостоимость создания: 2.000 за каждое увеличиваемое очко ЛВ(DX) (максимум 5). (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4/+DX</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Might</name>
		<name-loc>Мощь</name-loc>
		<description-loc>Обычное
Временно увеличивает СЛ(ST) объекта. Это соответственно увеличивает нагрузку, вред и ЕЖ(HP), но не лечит раны. Когда действие заклинания заканчивается, а ЕЖ(HP) из-за ранений остается меньше -ЗД(HT), то следует делать проверку ЗД(HT) чтобы не умереть. Стоимость не уменьшается за высокий уровень умения.
Длительность: 1 минута.
Стоимость: 2 за каждое увеличиваемое очко СЛ(ST) (максимум 5). Столько же поддержание.
Требования: Передать энергию (M89).
Предмет
(а) Любой. Всегда включён; увеличивает СЛ(ST) владельца только когда используется. Энергостоимость создания: 1.500 за каждое увеличиваемое очко СЛ(ST) (максимум 5). (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/+ST</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stun</name>
		<name-loc>Оглушение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект физически оглушен (B420) и должен делать проверку ЗД(HT) каждую секунду, чтобы оправиться от оглушения.
Стоимость: 2. Не поддерживается.
Требования: Боль.
Предмет
(а) Любой предмет. Всегда включён; владелец оглушен пока не снимет предмет. Энергостоимость создания: 500. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.100.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">pain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Vigor</name>
		<name-loc>Здравие</name-loc>
		<description-loc>Обычное
Увеличивает ЗД(HT) объекта. Влияет на Базовую Скорость, ЕУ(FP), способность противостоять заклинаниям и болезням. Заклинатель может увеличить свой показатель ЗД(HT). После окончания действия заклинания объект теряет столько же ЕУ(FP), сколько было добавлено заклинанием. Если ЕУ(FP) субъекта после окончания действия заклинания окажутся отрицательными, то следует отнять по одной ЕЖ(HP) за каждую отрицательную ЕУ(FP). Стоимость заклинания не уменьшается за высокий уровень умения.
Длительность: 1 минута.
Стоимость: 2 за каждое увеличиваемое очко ЗД(HT) (максимум 5). Столько же поддержание.
Требования: Передать жизнь или Хрупкость.
Предмет
(а) Любой предмет. Всегда включён; увеличивает ЗД(HT) владельца только когда используется. Энергостоимость создания: 1.500 за каждое увеличиваемое очко (максимум 5). (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/+HT</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M37</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">frailty</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fumble</name>
		<name-loc>Провал</name-loc>
		<description-loc>Блокирующее; Сопротивление по ЛВ(DX)
Объект автоматически прерывает текущее физическое действие. Применяются обычные штрафы за расстояние. Если действием была атака или парирование – провал считается критическим. Провальный блок делает щит неготовым, провальное уклонение приводит к падению. Другие действия приводят к результатам, которые Мастер сочтет подходящими. Ментальные действия не затрагиваются, если это не заклинание, требующее жестикуляции. 
Стоимость: 3.
Требования: Неуклюжесть.
Предмет
(а) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.000. (б) Драгоценность. Всегда включён; действует только на владельца. Тот, кто носит этот предмет, постоянно заваливает все физические действия! Энергостоимость создания: 1.500.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hunger</name>
		<name-loc>Голод</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Вызывает потерю 1 ЕУ(FP) от голода, равносильно пропуску одного приёма пищи. Восстанавливается только днём отдыха и хорошим питанием (см. Голод, B426).
Это заклинание также школы Пищи.
Стоимость: 2.
Время сотворения: 5 секунд.
Требования:  Магичность(Magery) 1, Слабость и Разложение.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control/Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Until eat/rest</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">debility</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Nauseate</name>
		<name-loc>Тошнота</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
У объекта немедленно появляются тошнотворные позывы (см. Тошнота, B428).
Длительность: 10 секунд.
Стоимость: 2. Столько же поддержание.
Требования: Аромат и минимум одно любое заклинание Контроля тела.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 100.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">perfume</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Pain</name>
		<name-loc>Сопротивление боли</name-loc>
		<description-loc>Обычное 
Субъект становится временно невосприимчив к боли. Он может игнорировать действие заклинания Спазм и других заклинаний, вызывающих боль. Он не может быть оглушен в бою, не получает штрафа за болевой шок при ранении и не теряет скорость при снижении ЕЖ(HP) ниже 1/3. Не дает защиты собственно от ран – только от боли.
Длительность: 1 минута.
Стоимость: 4 создание. 2 поддержание.
Требования: Магичность(Magery) 2 и Боль.
Предмет
Любой предмет; действует только на владельца. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">pain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Retch</name>
		<name-loc>Рвота</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объекта немедленно начинает рвать, это продолжается в течение 25-ЗД(HT) секунд (см. Тошнота, B428).
Стоимость: 3. Не поддерживается.
Время сотворения: 4 секунды.
Требования: Тошнота и Спазм.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 100.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>Instant</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">nauseate</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strike Blind</name>
		<name-loc>Поражение слепотой</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект временно ослеплён. См. Слепота B124, для полного описания воздействия. Главное, что объект получает -10 к физической атаке и не может видеть цель заклинания.
Длительность: 10 секунд.
Стоимость: 4 создание. 2 поддержание.
Требования: Спазм и два любых заклинания школы Света и тьмы.
Предмет
(а) Любой предмет. Всегда включён; владелец не видит. Энергостоимость создания: 500. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">light</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strike Deaf</name>
		<name-loc>Поражение глухотой</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект временно глохнет.
Длительность: 10 секунд.
Стоимость: 3 создание. 1 поддержание.
Требования: Спазм и два любых заклинания школы Звука.
Предмет
(а) Любой предмет. Всегда включён; владелец глух. Энергостоимость создания: 400. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">sound</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strike Dumb</name>
		<name-loc>Поражение немотой</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект временно не может говорить. Это может сорвать колдовство, требующее речи (M8).
Длительность: 10 секунд.
Стоимость: 3 создание. 1 поддержание.
Требования: Спазм.
Предмет
(а) Любой предмет. Всегда включён; владелец не может говорить. Энергостоимость создания: 500. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 2.500.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Thirst</name>
		<name-loc>Жажда</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Вызывает потерю 4 ЕУ(FP) и 1 ЕЖ(HP) от обезвоживания, равносильную суткам, проведенным без воды. Снимается только обильным питьем и отдыхом (см. Обезвоживание, B426). ЕЖ(HP) восстанавливаются как обычно. Несколько повторных сотворений могут лишить объект речи – во рту пересохнет, язык приклеивается к небу.
Это заклинание также относится и к школе Пищи.
Стоимость: 5.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 1, Слабость и Уничтожить воду (M185).
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control/Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Until drink/rest</duration>
		<reference>M38</reference>
		<categories>
			<category>Body Control</category>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">debility</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ambidexterity</name>
		<name-loc>Обоюдорукость</name-loc>
		<description-loc>Обычное
Объект получает преимущество Обоюдорукость (B39). Действует только на одну пару конечностей; цели с большим количеством рук нуждаются в повторном сотворении этого заклинания. Не даёт дополнительных выгод уже имеющим преимущество Обоюдорукость.
Длительность: 1 минута.
Стоимость: 3 создание. 2 поддержание.
Требования: Изящество.
Предмет
(а) Любой. Всегда включён; владелец получает преимущество Обоюдорукость. Довольно редкий предмет! Энергостоимость создания: 1.500. (б) Посох или палочка; используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Balance</name>
		<name-loc>Равновесие</name-loc>
		<description-loc>Обычное
Даёт прекрасное чувство равновесия (Идеальное равновесие, B74). Не дает дополнительных выгод уже имеющим преимущество Идеальное равновесие.
Длительность: 1 минута.
Стоимость: 5 создание. 3 поддержание.
Требования: Изящество.
Предмет
(а) Посох или волшебная палочка. Используется только магами; должен касаться объекта.  Энергостоимость создания: 300. (б) Драгоценность или головной убор. Всегда включён; действует только на владельца. Энергостоимость создания: 750.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cadence</name>
		<name-loc>Ритм</name-loc>
		<description-loc>Обычное
Удваивает скорость выполнения ремесленных работ и уменьшает выход брака. Действует на любое умение, создающее или улучшающее рукотворный объект; не воздействует на магические ремёсла (написание свитков, наложение чар и т.д.). Может ускорять также и скорость письма. Не воздействует на умения, требующие частых или продолжительных перерывов в работе, или требующих в основном ментальной активности (Счет, Архитектор, Письмо).
Длительность: 1 час. Прерывается, если объект прерывает свою работу.
Стоимость: 5 создание. 3 поддержание. Стоимость поддержки заклинания снимается также и с объекта – если маг не творит это заклинание на себя.
Время сотворения: 10 секунд.
Требования: Изящество и Ускорение.
Предмет
Набор инструментов. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hair Growth</name>
		<name-loc>Рост волос</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Ноги и волосы объекта растут в миллион раз быстрее - волосы прорастают на 1 дюйм за 5 секунд, а ногти - за 30). Если оставить без контроля, такой быстрый рост будет мешать зрению (волосы закрывают глаза), движению (запутывается в бороде), работе (ногти мешают). Если объект лыс, это позволит ему вырастить волосы, которые выпадут по естественным причинам примерно через месяц.
Длительность: 5 секунд.
Стоимость: 1 создание. 1 поддержание.
Требования: пять любых заклинания школы Контроля тела.
Предмет
(а) Любой. Всегда включён. Волосы начинают расти спустя час после одевания и заканчивают расти лишь спустя час после снятия предмета. Энергостоимость создания: 100. (б) Посох или палочка. Предмет должен касаться объекта. Энергостоимость создания: 250.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 sec</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Haircut</name>
		<name-loc>Стрижка</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Состригает волосы объекта (может и бороду, усы и прочий волосяной или шерстяной покров) на усмотрение мага. Эстетическое качество работы проверяется по броску умения Парикмахер (профессиональное ЛВ(DX)/Среднее умение). Также может использоваться для стрижки овец, ощипывания кур и постригания ногтей. Заклинание не может затупить или сломать зубы, когти и рога (хотя может сделать маникюр).
Длительность:  мгновенно.
Стоимость: 2.
Время сотворения: 2 секунды.
Требования: Рост волос.
Предмет
(а) Эффект заклинания можно сделать постоянным (заставить волосы перестать расти) за 10-кратную цену заклинания. (б) Головной убор. При надевании делает стрижку указанную создателем этого предмета. Энергостоимость создания: 150. (в) Посох или палочка. Энергостоимость создания: 300.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Instant</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hair growth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hold Breath</name>
		<name-loc>Задержать дыхание</name-loc>
		<description-loc>Обычное
Временно снимает потребность заклинателя в воздухе, давая Не дышит (B49). Он может без проблем оставаться под водой или в комнате с ядовитым газом, если, конечно, он не действует через кожу. Заклинание не создаёт воздух; оно просто откладывает удушение, пока заклинатель ищет (или создаёт) безопасное место. Это заклинание не защищает от изменения давления в вакууме или глубинах океанов.
Длительность: 1 минута.
Стоимость: 4 создание. 2 поддержание.
Требования: Магичность(Magery) 1 и Здравие.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 900.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">vigor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reflexes</name>
		<name-loc>Рефлексы</name-loc>
		<description-loc>Обычное
Объект получает Боевые рефлексы (B43). Не дает дополнительных выгод уже имеющим преимущество Боевые рефлексы
Длительность: 1 минута.
Стоимость: 5 создание. 3 поддержание.
Требования: Изящество и Ускорение.
Предмет
(а) Любой. Всегда включён; владелец получает преимущество Боевые рефлексы. Довольно редкий предмет! Энергостоимость создания: 1.200. (б) Посох или волшебная палочка; используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sensitize</name>
		<name-loc>Чувствительность</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект очень чувствителен к боли, получает Низкий болевой порог (B142). Не влияет на существ, уже имеющих этот недостаток.
Длительность: 1 минута.
Стоимость: 3 создание. 2 поддержание.
Требования: Магичность(Magery) 1 и Оглушение.
Предмет
(а) Любой. Всегда включён; действует только на владельца. Энергостоимость создания: 300. (б) Посох или палочка; используется только магами. Должен касаться объекта. Энергостоимость создания: 400.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M39</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">stun</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Agonize</name>
		<name-loc>Агония</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Чувствительность кожи объекта становится крайне высокой: даже легкое касание причиняет боль, как удар, чье-то дыхание – как пламя, а прохладный ветерок – как ледяная буря. Даже прикосновение к одежде приносит невыносимую боль – объект испытывает чувство, как будто с него сдирают кожу. Он переходит в состояние полной беспомощности, агонии (см. Состояния недееспособности; B428).
Длительность: 1 минута.
Стоимость: 8 создание. 6 поддержание.
Требования: Магичность(Magery) 2 и Чувствительность.
Предмет
(а) Любой. Всегда включён; действует только на владельца. Энергостоимость создания: 500. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>6</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">sensitize</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Choke</name>
		<name-loc>Удушение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект неспособен вдохнуть (или что-то сказать) и получает эффект удушения (B436). Заклинание не может быть поддержано, поэтому только постоянным пересотворением, отрезая жертве доступ воздуха, можно будет нанести реальный вред.
Длительность: 30 секунд.
Стоимость: 4. Не поддерживается.
Требования: Магичность(Magery) 1 и пять любых заклинания школы Контроля тела, включая Спазм.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 200.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Limb</name>
		<name-loc>Контроль конечности</name-loc>
		<description-loc>Обычное; Сопротивление по Воли(Will)
Одна из конечностей (включая крылья, щупальца и т.п.) объекта попадает под контроль заклинателя!  Руки могут бить оружием (используя умение заклинателя); ноги пинать и т.п. После сотворения необходимо концентрироваться для поддержания контроля; провал означает «омертвение» конечности на оставшуюся длительность. Жертва может пытаться схватить свою конечность, не давая ей действовать, но получает -3 на броски состязания по СЛ(ST) или ЛВ(DX) с самим собой!
Если заклинатель пожелает атаковать конечностью (оружием в ней или кулаком) саму жертву, то нужен бросок атаки (против умения объекта +4), а цель может уклоняться с -2. Цель даже может парировать (тоже с -2), если у неё есть оружие в другой руке! Трактуется как Бой вплотную со всеми штрафами.
Длительность: 5 секунд.
Стоимость: 3 создание. 3 поддержание. Если твориться только на кисть (или подобное) , то стоимость сотворения и поддержки только 2, но субъекта в этом случае можно вынудить только усилить или ослабить захват. Ваше влияние может помешать жестикуляции, броску гранаты или заставить выбросить оружие.
Требования: Магичность(Magery) 1 и пять любых заклинания школы Контроля тела, включая Спазм.
Предмет
Посох или палочка; используется только магами. Предмет должен указывать на объект. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 sec</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Paralyze Limb</name>
		<name-loc>Паралич конечности</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT)
Маг должен коснуться нужной конечности объекта (иное касание не дает эффекта). Броня не защищает. Бросок сопротивления делается при касании. Если маг побеждает, конечность считается покалеченной в течение одной минуты.
Длительность: 1 минута.
Стоимость:  3. Не поддерживается.
Требования: Магичность(Magery) 1 и пять любых заклинания школы Контроля тела, Неуклюжесть.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта.  Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strike Numb</name>
		<name-loc>Онемение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Временно лишает объект осязания и болевой чувствительности (недостаток Нет осязания B146). Включает эффекты заклинания Сопротивление боли, поэтому иногда может оказаться полезным. Субъект не чувствует ни ударов (beyond a jolt), ни чужих, шарящих по его карманам, ни даже жара раскаленных плит, на которых стоит. Возможно избирательное лишение чувствительности (только для рук, например).
Длительность: 10 секунд.
Стоимость: 3 создание. 1 поддержание.
Требования: Сопротивление боли.
Предмет
(а) Любой. Всегда включён; действует только на владельца. Энергостоимость создания: 300. (б) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">resist pain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Total Paralysis</name>
		<name-loc>Полный паралич</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT)
Требуется коснуться головы (-5 к атаке). Объект не способен двигаться в течение минуты, если проваливает сопротивление (в большинстве игр – до конца боя).
Длительность: 1 минута.
Стоимость: 5. Не поддерживается.
Требования: Паралич конечности.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта.  Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>thr-1 cr + Paralysis</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">paralyze limb</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Weaken Blood</name>
		<name-loc>Слабая кровь</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект получает недостаток Гемофилия (B138) на время действия заклинания. Любые раны вызывают сильное кровотечение.
Это заклинание также является заклинанием школы Некромагии.
Длительность: 1 день
Стоимость: 9 создание. 5 поддержание.
Требования: Болезнь или Украсть здоровье.
Предмет
Любой; всегда включён. Владелец страдает гемофилией!  Энергостоимость создания: 200. (Обычно комбинируется с заклинанием Неснимаемость.)</description-loc>
		<college>Body Control/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>9</casting_cost>
		<maintenance_cost>5</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 day</duration>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">sickness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wither Limb</name>
		<name-loc>Иссушение конечности</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT)
Маг должен коснуться одной из конечностей объекта (иное касание не дает эффекта). Броня не защищает. Бросок сопротивления делается при касании. Если маг побеждает, конечность усыхает и считается покалеченной (см. Калечащие ранения, B420). Объект также получает 1d вреда.
Длительность: постоянно пока не будет вылечено магией или необычной технологией.
Стоимость: 5.
Требования:  Магичность(Magery) 2 и Паралич конечности.
Предмет
Посох или палочка; используется только магами. Предмет должен касаться объекта.  Энергостоимость создания: 2.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>thr-1 cr +1d</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M40</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">paralyze limb</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Alter Body</name>
		<name-loc>Изменить тело</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Подобно Изменить лицо, выше, но можно менять всё тело (кожу, волосы, конечности и т.д.). Основная форма тела не может измениться: гуманоид останется гуманоидом. Нельзя добавлять конечности, крылья, и т.п.. Возможны простые дополнения (нехватательный хвост, рога, копыта), но персонаж, непривыкший к ним, на период адаптации (решает Мастер) будет иметь штрафы к ЛВ(DX). Масса тела и атрибуты персонажа не меняются.
Длительность: 1 час, если не сделано постоянным. Может быть снято заклинаниями Изменить тело  или Снять проклятье.
Стоимость: 8 создание. 6 поддержание. Можно сделать постоянным, если вложить 200 энергии.
Время сотворения: 2 минуты.
Требования: Изменить лицо.
Предмет
Любой, но, обычно, это предмет одежды или украшение. Даёт владельцу новый внешний вид, который был заложен во время создания. Энергостоимость создания: 4.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>6</maintenance_cost>
		<casting_time>2 min</casting_time>
		<duration>1 hr</duration>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">alter visage</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Alter Visage</name>
		<name-loc>Изменить лицо</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Изменяет лицо по желанию мага. Возможно любое изменение, но новые органы (например дополнительные глаза) не будут функционировать. При попытке скопировать чье-то лицо -1, если нет модели (или картинки); -2, если только по описанию. 
Заклинание не может нанести вреда объекту. Маги не получают права на бросок ИН(IQ) + Магичности для определения того, что внешность субъекта изменена данным заклинанием. 
Если это заклинание или Изменить тело улучшает внешность навсегда, то Мастер может потребовать заплатить за это очки персонажа!
Длительность: 1 час, если не сделано постоянным. Может быть снято заклинаниями Изменить лицо, Изменить тело  или Снять проклятье.
Стоимость: 4 создание. 3 поддержание. Можно сделать постоянным, если вложить 40 энергии.
Время сотворения: 1 минута.
Требования:  восемь заклинаний школы Контроля тела и любое из двух заклинаний Превращение или Совершенная иллюзия.
Предмет
Любой, но, обычно, это часть одежды или украшение. Даёт владельцу новое лицо, которое было заложено во время создания предмета. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="contains">shapeshifting</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">perfect illusion</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">8</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Alter Voice</name>
		<name-loc>Изменить голос</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Изменяет голос объекта по желанию заклинателя. Для копирования голоса нужен «образец» – по памяти знакомый голос копируется с -2, незнакомый -3 и хуже, если заклинатель слышал его пару раз или давно. Идеальная память (B51)  хорошо помогает в этом. 
Голос может быть изменён на более приятный или грубый, давая модификаторы от +2 до -2 к броскам реакции и умениям, связанным с общением на время действия заклинания. 
Заклинание не «дарует» голос немым. Если заклинание улучшает голос объекта навсегда (давая преимущество Голос), то Мастер может потребовать заплатить соответствующее количество очков персонажа!
Относится также к заклинаниям Звука.
Длительность: 1 час.
Стоимость: 2 создание. 2 поддержание. Изменение можно сделать постоянным, как чары, если вложить 200 энергии.
Время сотворения: 1 минута.
Требования:  четыре заклинания школы Контроля тела и четыре заклинания школы Звука.
Предмет
Любой, но, обычно, это украшение. Даёт владельцу новый голос, который был заложен во время создания. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">body</name>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">sound</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Deathtouch</name>
		<name-loc>Касание смерти</name-loc>
		<description-loc>Касательное 
Маг должен коснуться цели; место касания значения не имеет. Объект получает 1d вреда за каждое очко энергии, вложенное в это заклинание. СП(DR) не защищает от этой атаки. Действует также на нежить.
Стоимость: 1-3.
Требования: Иссушение конечности.
Предмет
Посох или палочка; предмет должен быть угольно чёрным. Используется только магами. Должен касаться объекта. Энергостоимость создания: 2.500.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>thr-1 cr +1d/point</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">wither limb</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lengthen Limb</name>
		<name-loc>Удлинить конечность</name-loc>
		<description-loc>Обычное 
Рука (возможно и нога или любая другая подобная конечность) заклинателя удлиняется, становясь похожей на длинную змею. Удлинение происходит со скоростью 1 ярд в секунду, без ограничения. Заклинатель сохраняет осязание и может удлинять руку в пределах своей видимости, а следить за ней при помощи заклинания Волшебный глаз или схожего. Рост требует концентрации, но после достижения желаемой длины можно расслабиться.
Удлинённая конечность может стать хорошей целью атаки! Когда заклинание заканчивается или в случае опасности, конечность «сматывается» обратно с Базовой скоростью заклинателя. Это полезно для доставания ключей из камеры или кражи алмаза халифа, пока он спит.
Длительность: 1 минута.
Стоимость: 2 создание. 2 поддержание.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 3 и Превращение.
Предмет
Палочка. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="contains">shapeshifting</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strike Barren</name>
		<name-loc>Поражение бесплодием</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект становится бесплодным. Можно творить на растения. Убрать можно заклинаниями Снять проклятье или Восстановление. Сотворённое на растение лишает его пыльцы, плодов, семян и т.п.
Это также заклинание Некромантии.
Длительность: постоянно.
Стоимость: 5.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 1, Вытянуть здоровье и Разложение.
Предмет
(а) Посох или палочка; используется только магами. Предмет должен касаться объекта. Энергостоимость создания: 200. (б) Любой предмет. Всегда включён; владелец бесплоден пока предмет одет. Энергостоимость создания: 800.</description-loc>
		<college>Body Control/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M41</reference>
		<categories>
			<category>Body Control</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Decapitation</name>
		<name-loc>Обезглавить</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)+2
Голова отваливается от тела! При сотворении заклинания голова субъекта (или одна из них, если голов несколько) отделяется от тела, но продолжает жить. Не наносит вреда, голова может быть повреждена, если упадет с шеи! Она может говорить, видеть, слышать и контролировать тело. Если голова будет ослеплена (засунута в мешок, например) то с управлением тела могут возникнуть большие проблемы. Заклинание действует постоянно и для его отмены надо приставить голову и пожелать присоединить. Если голова присоединения не желает, то делается обычное состязание по Воле(Will). Если заклинание сотворяется на врага, который затем возвращает ее себе и пытается прирастить, то маг не сможет ничем ему помешать – но он может сотворить это заклинание снова…
Это заклинание при всей его полезности в бою, можно использовать и иначе. Маг, лишившийся ноги, может сотворить это заклинаине на себя… и отправиться с группой в путешествие одной только головой! Однако тело нельзя надолго оставлять без головы, т.к. ему необходима еда, а без головы есть невозможно. Также если заклинатель без головы пытается сделать заклинание, в котором должны участвовать руки, то штрафы за дальность будут рассчитываться исходя из расстояния до тела, а не головы.
Длительность: Описана выше.
Стоимость: 4.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2 и Изменить тело.
Предмет
Посох, волшебная палочка или драгоценность. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Semi-permanent</duration>
		<reference>M42</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">alter body</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
	<name>Enlarge</name>
	<name-loc>Увеличиться</name-loc>
	<points>1</points>
	<spell_class>Regular</spell_class>
	<casting_cost>2 per +1 SM</casting_cost>
	<maintenance_cost>Same</maintenance_cost>
	<casting_time>5 sec</casting_time>
	<duration>1 hr</duration>
	<college>Body Control</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery one college (body control)</name>
				<level compare="at least">2</level>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<name compare="does not contain">one college</name>
				<level compare="at least">2</level>
			</advantage_prereq>
		</prereq_list>
		<spell_prereq has="yes">
			<name compare="is">alter body</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Body Control</category>
	</categories>
	<reference>M42</reference>
	<description-loc>Обычное
Увеличивает размеры тела волшебника, увеличивая его Модификатор размера. За каждые +1 МР: на 1,5 умножаются СЛ, ЕЖ, Базовое движение; за каждые 2 уровня СП увеличивается на 1. Одежда увеличивается вместе с магом, если он пожелает, но более значительные объемы вещей остаются неизменными (хотя маг может уменьшить их при помощи Увеличения объекта). Эффекты влияния брони см. в заклинании Дородность, с.43. ИН, ЛВ, ЗД, ЕЖ, Базовая скорость и Уклонение остаются неизменными. Вес значительно увеличивается; за каждые +1 МР следует умножить вес на 3,5.
Если маг находится в помещении, которое не может вместить его новый размер, то рост останавливается. Однако, если максимальный прямой вред превышает СП этого помещения, то маг может пробить его за (СП) секунд.
Длительность: 1 час.
Стоимость: 2 за +1 МР(SM). Столько же поддержание.
Время сотворения: 5 секунд.
Требования:  Магичность(Magery) 2 и Изменить тело
Предмет
(а) Волшебная палочка. Используется только магами. Энергостоимость создания: 2.000. (б) Изменение размера может быть постоянным, если заплатить 100-ую цену за заклинание (ГМ может потребовать постоянную поддержку).</description-loc>
</spell>
	<spell version="2" very_hard="yes">
		<name>Shrink</name>
		<name-loc>Уменьшение</name-loc>
		<description-loc>Обычное
Уменьшает размеры тела волшебника, снижая Модификатор размера. За каждые -1 МР(SM): на 2/3 умножаются СЛ(ST), ЕЖ(HP), Базовое движение; за каждые 2 уровня уменьшения СП(DR) уменьшается на 1. Одежда уменьшается вместе с магом, если он пожелает, но более значительные объемы вещей остаются неизменными (хотя маг может уменьшить их при помощи Уменьшения объекта). ИН(IQ), ЛВ(DX), ЗД(HT), ЕЖ(HP), Базовая скорость и Уклонение остаются неизменными.  Вес сильно уменьшается; за каждые -1 МР(SM) следует делить вес волшебника на 3.5. По магу сложнее попасть, соответственно его новому МР(SM). Чтобы маг все же мог иметь хоть какую-то возможность физического действия, Мастер может установить порог уменьшения до 1 ЕЖ(HP) и 1 базовое движение(BM). Может, это и нереалистично, но сохраняет традиции героической фэнтези.
Длительность: 1 час.
Стоимость: 2 за -1 МР(SM). Столько же поддержание.
Время сотворения: 5 секунд. Уменьшение происходит по 1 МР(SM) в секунду после окончания сотворения заклинания.
Требования:  Магичность(Magery) 2 и Изменить тело.
Предмет
(а) Волшебная палочка. Используется только магами. Энергостоимость создания: 2.000. (б) Изменение размера может быть постоянным, если заплатить 100-кратную стоимость за заклинание (Мастер может потребовать постоянную поддержку).</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per -1 SM</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M42</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">alter body</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Shrink Other</name>
		<name-loc>Уменьшить другого</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Аналогично заклинанию Уменьшение, но творится на других. Действие заклинания может прервать только сотворивший его или заклинание Убрать проклятье. Также Мастеру следует учесть психологический аспект этого заклинания для объекта. 
Длительность: 1 час.
Стоимость: 2 за -1 МР(SM). Столько же поддержание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 3 и Уменьшение.
Предмет
(a) Волшебная палочка. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 2.000. (б) Изменение размера может быть постоянным, если заплатить 100-кратную стоимость за заклинание (Мастер может потребовать постоянную поддержку).</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per -1 SM</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M42</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shrink</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Corpulence</name>
		<name-loc>Дородность</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Увеличивает комплекцию на 1 уровень вверх (Худой -&gt; Нормальный -&gt; Полнота -&gt; Толстый) (см. B18). Уже Толстые существа увеличивают вес на +100% (не считая модификации за Худобу или излишний вес) за каждое сотворение. Создания, на которых уже сотворено данное заклинание сопротивляются повторному сотворению с +5 (эффект накапливается). Кроме обычных эффектов увеличения веса, одежда на персонаже будет рваться; каждая часть жесткой брони нанесет СП(DR)/3 (округлять вниз) тупого вреда или начнет душить (B436). Когда субъект из-за излишнего веса окажется не в состоянии двигаться, он начнет задыхаться под собственным весом.
Длительность: 10 минут.
Стоимость: 6 создание. 6 поддержание.
Время сотворения: 3 секунды.
Требования:  Магичность(Magery) 2, Создать землю, Создать воду, и четыре любых заклинания школы контроля тела включая Изменить тело.
Предмет
(а) Любой предмет. Владелец получает новую комплекцию, которая была заложена во время создания предмета. Энергостоимость создания: 2.000. (б) Волшебная палочка. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>6</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 min</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">alter body</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Enlarge Other</name>
		<name-loc>Увеличить другого</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Действует как заклинание Увеличиться, но с возможностью применять на других существ. Действие заклинания может прервать сотворивший его или заклинание Убрать проклятье. Сотворите это заклинание на добровольца, и он станет отличной осадной машиной … но это сделает его главной целью для вражеской артиллерии и магии.
Длительность: 1 час.
Стоимость: 2 за +1 МР(SM). Столько же поддержание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 3 и Увеличиться.
Предмет
(а) Волшебная палочка. Используется только магами. Энергостоимость создания: 2.000. (б) Изменение размера может быть постоянным, если заплатить 100-ую цену за заклинание (Мастер может потребовать постоянную поддержку).</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per +1 SM</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">enlarge</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Gauntness</name>
		<name-loc>Измождение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект теряет в весе и переходит на 1 категорию ниже (противоположность заклинания Утолщить). Броня обвисает, давая -2 ЛВ(DX). Уже худой потеряет 20% веса и 1d ЕУ(FP) за каждое применение. Создания, на которых уже сотворено данное заклинание сопротивляются повторному сотворению с +5 (эффект накапливается).
Длительность: 10 минут.
Стоимость: 6 создание. 6 поддержание.
Время сотворения: 3 секунды.
Требования:  Магичность(Magery) 2, Землю в воздух, Уничтожить воду, и четыре любых заклинания школы контроля тела включая Голод.
Предмет
(а) Любой предмет. Владелец получает новую комплекцию, которая была заложена во время создания предмета. Энергостоимость создания: 2.000. (б) Волшебная палочка. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 1.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>6</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 min</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">earth to air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">hunger</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Transform Body (@Race@)</name>
		<name-loc>Трансформировать тело</name-loc>
		<description-loc>Особое
Превращает мага в существо другой разумной расы. Каждая раса – отдельное заклинание, изучаемое само по себе. Маг может изучить превращение только в известную ему расу. Одежда, украшения и доспехи не исчезают, хотя могут быть повреждены, если целевая форма имеет более крупное телосложение (см. заклинание Утолщить). Маг принимает все физические черты новой формы, сохраняя свои ментальные. Обратите внимание, что Единицы усталости в отношении сотворения заклинаний не увеличиваются. Затраты энергии на это заклинание рассчитываются исходя из стоимости физических особенностей принятой формы; 1/10 на создание и 1/20 на поддержание, при минимуме в 5 на сотворение и 2 на поддержание.
Длительность: 1 час.
Стоимость: Разная (см. выше).
Время сотворения: 1 минута.
Требования: Изменить тело и три формы заклинания Превращение.
Предмет
Драгоценность. Должна иметь схожую форму с тем обликом, который приобретёт владелец; используется только магами. Не поддерживается, но и вернуть собственную форму можно, только если драгоценность при маге; иначе можно применить заклинание Убрать проклятье для возвращения нормальной формы магу. Энергостоимость создания: 1,500.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">alter body</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="contains">shapeshift</name>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Transform Other (@Race@)</name>
		<name-loc>Трансформировать другого</name-loc>
		<description-loc>Особое; Сопротивление по Воли(Will)
Идентично Трансформации тела, но применяется на других. Объект не может прекратить действия заклинания сам – только по желанию мага или заклинанием Убрать проклятье.
Длительность: 1 час.
Стоимость: Та же как и у заклинания Трансформировать тело, но только минимальные затраты на заклинание составляют: 10 создание и 4 поддержание.
Время сотворения: 2 минуты.
Требования: Превращение другого и соответствующую форму в заклинании Трансформировать тело.
Предмет
(а) Волшебная палочка. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 3.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>2 min</casting_time>
		<duration>1 hr</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">transform body (@race@)</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shapeshift others</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Transmogrification</name>
		<name-loc>Превратить в предмет</name-loc>
		<description-loc>Обычное; Сопротивление по Воли(Will)
Превращает объекта в неживой предмет того же веса. Предмет может быть любым из известных магу. Живые существа с ИН(IQ) 0 – растения, например – считаются в этом отношении неодушевленными объектами. Объект находится в сознании, сохраняя лишь слух (в ограниченных пределах) и сильно ослабленное осязание. Он не может предпринимать никаких действий, включая использование магии и псионики. Если предмет будет поврежден, объект потеряет пропорциональное количество ЕЖ(HP) при возвращении в нормальную форму. Если предмет будет уничтожен, объект погибает.
Длительность: 1 час.
Стоимость: 20. Столько же поддержание.
Время сотворения: 2 минуты.
Требования: Магичность(Magery) 3, Трансформировать другого, Трансформировать объект, и Плоть в камень.
Предмет
Посох, волшебная палочка или драгоценность; используется только магами. Энергостоимость создания: 5.000.</description-loc>
		<college>Body Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>20</maintenance_cost>
		<casting_time>2 min</casting_time>
		<duration>1 hr</duration>
		<reference>M43</reference>
		<categories>
			<category>Body Control</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (body control)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">transform other</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">transform object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">flesh to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Foes</name>
		<name-loc>Почуять врагов</name-loc>
		<description-loc>Информационное; Областное
Позволяет заклинателю узнать о враждебных намерениях и о степени этой враждебности. Может быть сотворено на персону или область. При сотворении на область будет сообщать лишь присутствие враждебности, но не ее источник.
Базовая стоимость: 1 (минимум 2).
Предмет
Посох, палочка или украшение. Энергостоимость создания: 200.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Info/Area</spell_class>
		<casting_cost>1/area, min 2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M44</reference>
		<categories>
			<category>Communication</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Dream Sending</name>
		<name-loc>Отправка снов</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Заклинатель использует это заклинание для передачи видения объекту, который должен в это время спать. Сообщение воспринимается в виде символов сна, и объект должен бросить ИН(IQ)-5 или умение вроде Предсказание судьбы (интерпретация снов) (B196) для того чтобы понять их правильно. Величина успеха при броске показывает, насколько правильно было понято сообщение. Если объект использует умение Ясный сон, это может исказить или вообще отменить сообщение (решение Мастера).
Заклинатель рассказывает Мастеру точный смысл (хорошая идея — ограничить длину сообщения количеством слов равным умению заклинания). Мастер, в свою очередь, рассказывает объекту что он понял (бросайте скрытно, так как критический провал ведет к полному непониманию!). Используйте модификаторы Дальних расстояний и Чтения мыслей (M14 и M46). Если заклинатель и объект незнакомы, это дополнительный штраф -2.
Это так же заклинание Контроля разума.
Длительность: 1 час
Стоимость: 3. Одна попытка за ночь. Не может быть поддержано.
Время сотворения: 1 минута.
Требования: Просмотр снов или Сон.
Предмет
Палочка или посох. Энергостоимость создания: 400.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">dream viewing</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dream Viewing</name>
		<name-loc>Просмотр снов</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Просматривает сны объекта; они проявляются на любой гладкой поверхности по вашему выбору (чаша воды, зеркало, грань драгоценного камня и т.д.). Используйте модификаторы  Дальних дистанций и Чтения мыслей (M14 и M46, соответственно). Если заклинатель и объект не знакомы друг с другом, это даёт дополнительный штраф -2.
Длительность: 1 час.
Стоимость: 2 сотворение, 1 поддержание.
Время сотворения: 10 секунд.
Требования: Правдолюб или Сон.
Предмет
Зеркало. Энергостоимость создания: 300.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">truthsayer</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hide Emotion</name>
		<name-loc>Скрыть эмоции</name-loc>
		<description-loc>Обычное; Сопротивляется чтению эмоций
Придает объекту абсолютно невозмутимый внешний вид. Сопротивляется Чтению ауры и Обнаружить эмоции (и Обнаружить врагов, на усмотрение Мастера) так же как и любой попытке узнать эмоции другим путем (Эмпатия, псионика, Язык тела и т.д.). Это заклинание в большом почете у дипломатов, придворных и игроков в покер. Оно также дает премию до +4 (на усмотрение Мастера) к любому умению, где полезно скрытие эмоций.
Длительность: 1 час
Стоимость: 2 сотворение, 2 поддержание.
Требования: Почуять эмоции.
Предмет
Шляпа, корона или другой головной убор. Энергостоимость создания: 200.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense emotion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Persuasion</name>
		<name-loc>Убеждение</name-loc>
		<description-loc>Обычное; Сопротивление по ИН(IQ)
Используется для изменения броска реакции. Заклинание делает объект (разумное существо, расовый ИН(IQ) 6 и выше) более снисходительным.
Длительность: 1 минута.
Стоимость: удвоенная премия к реакции. Столько же на поддержку (максимум 5).
Требование: Почуять эмоции.
Предмет
Шапка, корона, шлем или другой головной убор. Должен быть украшен пурпурным камнем (гранатом или аметистом) на сумму минимум $200. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense emotion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Emotion</name>
		<name-loc>Почуять эмоции</name-loc>
		<description-loc>Обычное
Дает заклинателю знать о том, какие эмоции испытывает объект в данный момент. Сработает на любое живое существо, но естественно оно в основном полезно для разумных существ. Сообщает также, насколько лоялен объект к заклинателю (см. Лоялность наемников, B518).
Стоимость: 2.
Требования: Почуять врагов.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 300.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense foes</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Life</name>
		<name-loc>Почуять жизнь</name-loc>
		<description-loc>Информационное; Областное
Сообщает заклинателю, есть ли жизнь в данном месте, и (при хорошем броске) общее представление о типе этой жизни. Заклинатель также может точно указать, какого рода жизнь он ищет: растения, эльфов, рыжих девок или конкретную личность, с которой он знаком.
Базовая стоимость: 1/2 (минимум 1).
Предмет
Посох, палочка или украшение. Энергостоимость создания: 80.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Info/Area</spell_class>
		<casting_cost>1/2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Truthsayer</name>
		<name-loc>Правдолюб</name-loc>
		<description-loc>Информационное; Сопротивление по Воле(Will)
Сообщает, врет субъект или нет. Может быть сотворено в двух вариантах:
1. Где объект говорил любую лож за последние пять минут.
2. Когда объект последний раз солгал.
Также может сообщить величину лжи объекта. Если маг не касается объекта, то штрафы считаются как для Обычных заклинаний.
Стоимость: 2.
Требование: Почуять эмоции.
Предмет
Корона, шлем или другой головной убор. Энергостоимость создания: 500.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense emotion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Vexation</name>
		<name-loc>Недовольство</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Используется для изменения броска реакции. Заклинание делает объект (разумное существо, расовый ИН(IQ) 6 и выше) недружелюбным. Часто используется шпионами для срыва переговоров.
Длительность: 1 минута
Стоимость: удвоенный штраф к реакции. Столько же на поддержку (максимум 5).
Требование: Почуять эмоции.
Предмет
Шапка, корона, шлем или другой головной убор. Должен быть украшен пурпурным камнем (гранатом или аметистом) на сумму минимум $200. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M45</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense emotion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Borrow Language</name>
		<name-loc>Заимствовать язык</name-loc>
		<description-loc>Обычное
Заклинатель приобретает знание языка на уровне владения объекта или Акцент (что ниже). Объект должен знать данный язык.
Длительность: 1 минута
Стоимость: 3 сотворение. 1 поддержание.
Время сотворения: 3 секунды.
Требование: Передать язык.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend language</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Distill</name>
		<name-loc>Возгонка</name-loc>
		<description-loc>Обычное
Концентрирует жидкость, удаляя из нее воду. Заклинание главным образом используется, для создания крепких алкогольных напитков, но алхимики также его используют и в других целях. Каждое использование уменьшает вдвое объем жидкости, удваивая ее концентрацию. Одно заклинание превращает вино в крепленое вино, два – в бренди, а три – в почти чистый спирт. Возгонка не работает над живыми объектами.
Это также заклинание Воды.
Длительность: навсегда.
Стоимость: 1 за кварту первичной жидкости.
Требования: Созревание и Уничтожить воду.
Предмет
Большой закрытый котел, удерживающий  до 5 галлонов. Энергостоимость создания: 400. Нелегален везде, где запрещена обычная возгонка.</description-loc>
		<college>Food/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/quart</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M46</reference>
		<categories>
			<category>Food</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">mature</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dream Projection</name>
		<name-loc>Проекция снов</name-loc>
		<description-loc>Обычное
Используя его, заклинатель проецирует свое сознание в сны объекта для общения с ним. Бросайте Быстрое состязание между умением заклинания и Воле(Will)й объекта каждую минуту; как только объект выигрывает, заклинание прекращается и контакт более невозможен этой ночью.
Используйте модификаторы Дальних дистанций и Чтения разума (M14 и M46). Если заклинатель и объект незнакомы, это дает дополнительный штраф -2. Объект может использовать умение Ясный сон для помощи процессу — бросайте каждую минуту для пропуска состязания.
Это так же заклинание Контроля разума.
Длительность: 1 минута. Каждая минута позволяет обменяться двумя предложениями (одно от заклинателя, второе от объекта)
Стоимость: 3 сотворение, 3 поддержание. Одна попытка за ночь.
Время сотворения: 1 минута.
Требование: Передача снов.
Предмет
Головной убор. Используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dream sending</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Gift of Letters</name>
		<name-loc>Дар письма</name-loc>
		<description-loc>Обычное
Дает грамотность в любом языке (только разумным существам)
Длительность: 1 минута
Стоимость: 2 для уровня Ломаный, 4 для Акцента, 6 для Родного. Половина на поддержание.
Требования: Заимствование ззыка и три языка с письменным уровнем Акцент или лучше.
Предмет:
Головной убор или украшение. Работает только на надевшего и только для некоторых языков. Энергостоимость создания: 300 за каждый язык (который должен быть известен создающему).</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Written (Native)
				</notes></advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Written (Accented)
				</notes></advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">borrow language</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Gift of Tongues</name>
		<name-loc>Дар языков</name-loc>
		<description-loc>Обычное
Дает возможность говорить и понимать любой язык (только разумным существам). Не дает возможности говорить или слышать тем, кто лишен этих способностей.
Длительность: 1 минута.
Стоимость: 2 для уровня Ломаный, 4 для Акцента, 6 для Родного. Половина на поддержание.
Требования: Заимствование языка и три языка на уровне Акцента или выше.
Предмет
Головной убор или украшение. Работает только на надевшего и только для некоторых языков. Энергостоимость создания: 300 за каждый язык (который должен быть известен создающему).</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Spoken (Native)
				</notes></advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Spoken (Accented)
				</notes></advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">borrow language</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hide Thoughts</name>
		<name-loc>Скрыть мысли</name-loc>
		<description-loc>Обычное
Защищает цель от любых заклинаний Чтения мыслей или Контроля разума. Враждебный маг должен победить в состязании умений «атакующего» заклинания против данного заклинания. Если он пробил защиту, жертва получает еще и обычный бросок сопротивления. Не действует на уже установленный ментальный контакт.
Стоимость: 3. 1 поддержание.
Длительность: 10 минут.
Требования: Правдолюб или Скрыть эмоции.
Предмет
Корона, шлем или другой головной убор. Энергостоимость создания: 1.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">truthsayer</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hide emotion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Language</name>
		<name-loc>Передать язык</name-loc>
		<description-loc>Обычное
Объект получает знание языка (только разумные существа) на уровне владения им заклинателя или Акцент — что ниже. Заклинатель должен знать передаваемый язык.
Длительность: 1 минута
Стоимость: 3 сотворение. 1 поддержание.
Время сотворения: 3 секунды.
Требования: либо Звериная речь, либо три заклинания школы Общения и понимания.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<college compare="contains">communication</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">beast speech</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mind-Reading</name>
		<name-loc>Чтение мыслей</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Позволяет заклинателю читать поверхностные мысли объекта – о чем он думает в настоящий момент. Объект не знает, что его мысли читают. Работает на любом живом создании, но хорошие результаты будут конечно при чтении мыслей разумных существ.
Модификаторы: -2, если не знаешь родного языка объекта, -2 за чужую расу, -4 за полностью чужеродный объект.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 10 секунд.
Требования: Правдолюб или Заимствование языка
Предмет
Корона, шлем или другой головной убор. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">truthsayer</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">borrow language</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Mind-Search</name>
		<name-loc>Поиск в памяти</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Позволяет искать в сознании объекта глубинные мысли и знания даже о том, о чем объект в данный момент не думает. Фактически же, заклинатель может задать один вопрос (ответ будет не более чем в 10 слов) в минуту, и получить максимально правдивый ответ, который может дать объект. Объект не знает о проникновении, если заклинатель не выбросил критический промах.
Язык - не барьер для этого заклинания, а объект может даже спать. Сложнее работать с объектом чужой расы (решение Мастера).
Модификаторы: как у Чтения мыслей. Если объект магическим образом заставили забыть что-либо, это заклинание не восстановит потерянную память.
Длительность: 1 минута.
Стоимость: 6 сотворение. 3 поддержание.
Время сотворения: 1 минута.
Требование: Чтение мыслей.
Предмет
Шапка, корона, шлем или другой головной убор. Используется только магами.
Энергостоимость создания: 1.500.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M46</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-reading</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Borrow Skill</name>
		<name-loc>Заимствовать умение</name-loc>
		<description-loc>Обычное
Заклинатель получает умение на уровне (базовый аттрибут) + 4 или увеличивает свое существующее умение на 4 уровня, что больше. Умение заклинателя не может превосходить умение объекта. Объект должен быть согласен и знать передаваемое умение. Не работает на языки и заклинания.
Длительность: 1 минута.
Стоимость: 4 сотворение. 4 поддержание.
Время сотворения: 3 секунды.
Требования: Передать умение.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend skill</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Compel Truth</name>
		<name-loc>Сыворотка правды</name-loc>
		<description-loc>Информационное; Сопротивление по Воле(Will)
Объект не может лгать, однако он может хранить молчание или говорить только часть правды (это должно быть отыграно). Заклинание не заставляет его сдавать информацию, он просто не может вымолвить ни слова, если верит что это неправда.
Длительность: 5 минут.
Стоимость: 4 сотворение. 2 поддержание.
Требования: Магичность(Magery) 2 и Правдолюб.
Предмет
Галстук или тяжелый ошейник, носитель не может лгать. Энергостоимость: 600.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (communication)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">truthsayer</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Skill</name>
		<name-loc>Передать умение</name-loc>
		<description-loc>Обычное
Объект получает умение на (базовый атрибут) + 4 или увеличивает свое существующее умение на 4 уровня, что больше. Умение объекта не может превосходить умение заклинателя. Заклинатель должен знать передаваемое умение (либо как обычно, либо с помощью Заимствования умения, ниже). Не работает на языки и заклинания.
Длительность: 1 минута.
Стоимость: 3 сотворение, 2 поддержание.
Время сотворения: 3 секунды.
Требования: Отправка мыслей и ИН(IQ) 11+</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" combined_with="iq" compare="at least">11</attribute_prereq>
			<spell_prereq has="yes">
				<name compare="is">mind-sending</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mind-Sending</name>
		<name-loc>Отправка мыслей</name-loc>
		<description-loc>Обычное
Одностороннее средство коммуникации, позволяет заклинателю посылать свои мысли объекту. Передача происходит со скоростью сравнимой со скоростью обычной речи, однако также можно передать простые изображения (время на передачу похоже на время рисования этой картинки на бумаге или пергаменте).
При подсчете модификатора за расстояние используйте модификаторы Дальних дистанций (M14). Незнакомство с объектом даёт штраф -4.
Длительность: 1 минута.
Стоимость: 4 сотворение. 4 поддержание.
Время сотворения: 4 секунды.
Требование: Чтение мыслей.
Предмет
Шапка, корона, шлем или другой головной убор. Используется только магами. Энегостоимость создания: 1.500.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-reading</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Retrogression</name>
		<name-loc>Регресс</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Заставляет объект пережить событие из его прошлой жизни (или жизней!). Оно может быть как мучительным так и приятным.
Разные типы памяти дают разный эффект. Ужасное воспоминание требует бросок страха с -3 или более; память о насильственной смерти объекта (в кампании, где возможно Воскрешение), требует бросок страха с -5. Память о ране или болезни требует бросок ЗД(HT)-3 — провал приносит одно очко вреда. Память о рабстве или унижении дает -1 к Воле(Will), если провален бросок Воля(Will)-3. Память о личном триумфе и могуществе дает +1 к Воле(Will), если успешен бросок ИН(IQ). Мастер судит о эффектах других типов памяти.
Заклинатель указывает только тип события для вызова; он не может «досматривать» память объекта с помощью данного заклинания.
Если не оглушен, объект должен бросить Чувство тела для того, чтобы действовать нормально в ход после заклинания.
Длительность: для вызова памяти необходима одна секунда (хотя объекту может показаться, что прошло гораздо больше времени).
Стоимость: 5. Не может быть поддержано. Одна попытка в день.
Время сотворения: 10 секунд.
Требования: Поиск в памяти и Отправка мыслей.
Предмет
а) Головной убор. Каждый раз при одевании носящий испытывает свое лучшее или худшее переживание (решение создателя, но Мастер решает что именно подходит под это определение). Энергостоимость создания: 350. б) Посох, палочка или украшение. Используется только магами. Энергостоимость создания: 400.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-reading</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">mind-sending</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Telepathy</name>
		<name-loc>Телепатия</name-loc>
		<description-loc>Двухсторонняя коммуникация, как комбинация Чтение мыслей и Отправка мыслей. Объект должен быть согласен на контакт. Оба - заклинатель и объект - знают что думает и чувствует другой, и общение происходит со скоростью мысли. Если кто-то еще хочет включиться в «разговор», необходимо сотворить заклинание еще раз за каждую новую персону. Незаметное подслушивание канала связи делается с -4 к умению.
Если заклинатель и объект знают друг друга, и объект ожидает «звонка», штрафы за расстояние не применяются. В противном случае, они определяются как при Отправка мыслей. Однако это заклинание не способно работать сквозь время, измерения, межпланетные пространства и т.д.
Длительность: 1 минута.
Стоимость: 4 сотворение. 4 поддержание для двухстороннего контакта. Столько же за каждого нового «абонента».
Время сотворения: 4 секунды.
Требования: Отправка мыслей.
Предмет
Шапка, корона, шлем или любой другой головной убор. Используется только магами. Энергостоимость создания: 2.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M47</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-sending</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Communication</name>
		<name-loc>Общение</name-loc>
		<description-loc>Обычное
Это заклинание позволяет заклинателю установить двусторонний канал для общения с объектом. Каждый участник видит изображение собеседника, что позволяет общаться в реальном времени. Используйте модификаторы Дальних дистанций (M14), но если заклинатель знаком с объектом и тот ожидает «звонок», модификаторы дистанций не используются!
Примените дополнительные -4 к умению, если заклинатель не знает объект. Общение только аудио-визуальное, однако, если заклинатель так же знает Удаленный вкус и запах, он может добавить в общение запах за дополнительное очко энергии (и на сотворение, и на поддержание).
Другие могут включится в «конференцию» в любое время - новое сотворение необходимо для каждой подключаемой персоны. Таким образом такое общение не безопасно.
Длительность: 1 минута.
Стоимость: 4 сотворение. 4 поддержание. Столько же на подключение каждого дополнительного участника.
Время сотворения: 4 секунды.

Требования: Волшебный глаз, Удаленный слух, Голоса и Простая иллюзия.
Предмет
Головной убор, блюдце или хрустальный шар. Используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M48</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">wizard eye</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">far-hearing</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Insignificance</name>
		<name-loc>Незначительность</name-loc>
		<description-loc>Обычное
Специальное сопротивление
Заставляет всех вступающих в социальный контакт с объектом игнорировать или не замечать его. Только имеющие причины заметить данную конкретную персону, сопротивляются по Восп — объекту самому по себе сопротивляться не нужно. Наблюдатели получают премию к сопротивлению равную общему модификатору внешности объекта, положительного или отрицательного. Таким образом, наблюдатели за Привлекательным объектом сопротивляются с Восп +1, но наблюдатели за Непривлекательным объектом так же сопротивляются с Восп +1.
Эффект заклинания ограничен по важности; объект может проскользнуть незамеченным сквозь толпу, но будет остановлен стражником при попытке пройти туда, куда ему нельзя. Он может привлечь чьё-либо внимание, схватив его, но, скорее всего, получит при этом негативную реакцию. Если он что-то крадет или совершает другое нежелательное действие (например, раздевается догола), все свидетели получают новый бросок сопротивления. Если он атакует кого-либо, то жертва автоматически сбрасывает с себя эффект заклинания — более того, её крики о помощи не будут игнорироваться!
Незначительность и Присутствие сопротивляются друг другу.
Длительность: 1 час.
Стоимость: 4 сотворение, 4 поддержание.
Время сотворения: 10 секунд.
Требования: Убеждение и Избегание.
Предмет
а) Плащ, украшение или головной убор. Всегда включён. Одевший игнорируется! Энергостоимость создания: 700. б) Палочка или посох. Используется только магами. Энергостоимость создания: 450.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M48</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">persuasion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">avoid</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Presence</name>
		<name-loc>Присутствие</name-loc>
		<description-loc>Обычное, Специальное сопротивление
Все существа, вступившие в социальный контакт с объектом обращают на него внимание. Каждый пытающейся игнорировать его сопротивляется по Воле(Will) — но сам объект сопротивляться не должен! Заклинание не гарантирует хорошую реакцию — оно удваивает положительные и отрицательные модификаторы! Если у объекта нет таких модификаторов, оно дает +1. Большинство людей будут думать что к выделяющейся без особых причин персоне стоит получше присмотреться в надежде на некое ценное зрелище.
Затронутого этим заклинанием легко преследовать в толпе. Ищущему достаточно спросить очевидцев «куда прошел такой-то и такой-то?» и он быстро найдет преследуемого.  
Присутствие и Незначительность сопротивляются друг другу.
Длительность: 1 час.
Стоимость: 4 сотворение. 4 поддержание.
Время сотворения: 10 секунд.
Требования: Убеждение и Искушение.
Предмет
а) Плащ, украшение или головной убор. Всегда включено. Одевший привлекает внимание. Энергостоимость создания: 700. б) Палочка или посох. Используется только магами. Энергостоимость создания: 450.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M48</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">persuasion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lure</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Person</name>
		<name-loc>Контроль персоны</name-loc>
		<description-loc>Обычное; Сопротивляется по Воле(Will)
Использует все чувства жертвы и контролирует все ее физические действия (заклинатель не получает доступ к памяти жертвы, её умениям, заклинаниям и т.п.). Объект сохраняет свою память и разум, и осознает что с ним происходит - его личность не заменяется личностью заклинателя. Заклинатель может «двигать» только одно тело в каждый момент времени и должен концентрироваться для этого. Во время концентрации его собственное тело становиться безвольным; как только он прекращает концентрироваться, объект возвращает себе контроль над своим телом. Заклинатель может свободно перемещаться между телами пока заклинание не закончится.
Длительность: 1 минута.
Стоимость: 6 сотворение. 4 поддержание.
Время сотворения: 10 секунд.
Требование: Ментальный пассажир или Телепатия.
Предмет
Корона, шлем или другой головной убор. Используется только магами. Энергостоимость создания: 1.500.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">soul rider</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">telepathy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dispel Possession</name>
		<name-loc>Отменить вселение</name-loc>
		<description-loc>Обычное; Сопротивляется заклинанием
Заканчивает любое из действующих на объект заклинаний Ментальный пассажир,  Контроль или Вселение (или их эквиваленты для животных).
Стоимость: 10.
Время сотворения: 10 секунд.
Требования: Ментальный пассажир, Вселение или (по желанию Мастера) религиозный статус «святого».
Предмет
Посох или палочка. Используется только магами. Предмет должен коснуться одержимого. Энергостоимость создания: 300.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">soul rider</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">possession</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Exchange Bodies</name>
		<name-loc>Обмен телами</name-loc>
		<description-loc>Обычное; Сопротивляется по Воле(Will)
Заклинатель навсегда меняется телами с объектом. Объектом может быть любое живое существо. Есть только один способ отменить эффект этого заклинания - сотворить его снова;  Отменить вселение и остальная анти-магия работать не будет. Значения СЛ(ST), ЛВ(DX) и ЗД(HT), как и все физические преимущества и недостатки, остаются с телом. ИН(IQ), память, личность и все умения и заклинания переносятся с разумом.
Заметьте: Обмен телам может привести к тому, что заклинатель увеличит свою очковую стоимость. Мастер может потребовать от старого мага оплатить эту разницу. Более детально см. Перемещение сознания (B296). Для контроля меняющих тела магов Мастер может требовать редких ингредиентов для этого заклинания (M8).
Длительность: Постоянно.
Стоимость: 120.
Время сотворения: 1 час.
Требования: Постоянное вселение и Сосуд души.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>120</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">permanent possession</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Possession</name>
		<name-loc>Постоянное вселение</name-loc>
		<description-loc>Обычное; Сопротивляется по Воле(Will)
Как Вселение, но заклинатель остается в теле объекта пока не захочет его покинуть или будет изгнан заклинанием Отменить вселение или Снять проклятие. На собственное тело заклинателя накладывается эффект Приостановленной жизни (M94) до тех пор, пока заклинание не закончится. Если тело заклинателя умрет, заклинание рассеивается. Когда тело объекта получает вред, заклинатель должен сделать бросок против своего ЗД(HT) или получить такой же вред. Если тело объекта умирает, заклинатель должен сделать бросок своего ЗД(HT) или тоже умереть!
Длительность: Не ограничено (может быть постоянно).
Стоимость: 30.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 3 и Вселение.
Предмет
Шляпа, корона, шлем или другой головной убор. Используется только магами. Энергостоимость создания: 3.000.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>Indefinite</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (communication)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">possession</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Possession</name>
		<name-loc>Вселение</name-loc>
		<description-loc>Обычное; Сопротивляется по Воле(Will)
Как Контроль персоны, но жертва находиться без сознания во время «вселения» и заклинатель имеет полный доступ к памяти умениям и заклинаниям объекта. Во время пребывания в теле, заклинатель сохраняет все свои умения и заклинания а так же может использовать все умения заклинания и воспоминания объекта, как будто они его собственные (физические умения объекта используются с -1). Собственное тело заклинателя лежит без сознания во время заклинания и должно охраняться.
Длительность: 1 минута.
Стоимость: 10 сотворение. 4 поддержание.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 1 и либо Контроль персоны либо Вселение в зверя.
Предмет
Шляпа, корона, шлем или другой головной убор. Используется только магами. Энергостоимость создания: 2.500.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (communication)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">control person</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">beast possession</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Soul Rider</name>
		<name-loc>Ментальный пассажир</name-loc>
		<description-loc>Обычное; Сопротивляется по Воле(Will)
Заклинатель может видеть глазами объекта, слышать его ушами и т.д, пока концентрируется. (Заклинатель не теряет контроль над своим собственным телом и может действовать нормально). Заклинатель не получает контроля над объектом и не знает его мысли. Объект должен быть разумным (ИН(IQ) 6 или выше). Умение получает -2 если объект принадлежит другой расе; если объект полностью чужд, то -4 или более!
Длительность: 1 минута.
Стоимость: 5 сотворение, 2 поддержание.
Время сотворения: 3 секунды.
Требование: Чтение мыслей.
Предмет
Два идентичных украшения, одно из золота, второе из серебра. Золотое должно быть одето заклинателем, серебряное - объектом. Заклинание может быть сотворено в любое время, независимо от дистанции. Используется только магами. Если необходимо встроить Энергокамень, то в золотое украшение. Если один из предметов сломан, второй теряет силу. Энергостоимость создания: 1.000 (за пару), необходимо включить опал стоимостью $100 в каждый предмет.</description-loc>
		<college>Communication</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M49</reference>
		<categories>
			<category>Communication</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-reading</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Earth</name>
		<name-loc>Искать землю</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление и приблизительное расстояние до ближайшего значительного количества одного любого типа земли, металла или камня. Используйте Модификаторы больших расстояний (M14). Любые известные источники материала можно исключить, если заклинатель напрямую их укажет перед тем, как начнёт.
Стоимость: 3.
Время сотворения: 10 секунд.
Предмет
Раздвоенная палка с унцией желаемой земли/камня/металла установленной в верхушке; каждая палка будет находить только этот тип земли. Стоимость создания: 50 энергии, и деньги, чтобы купить унцию искомого материала.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M50</reference>
		<categories>
			<category>Earth</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Earth</name>
		<name-loc>Формировать землю</name-loc>
		<description-loc>Обычное
Двигает землю, и придаёт ей любую форму. Если форма стабильна (например, холм), она навсегда сохранится после того, как её придали. Нестабильная форма (например, колонна или стена) держится, только пока действует заклинание – никакой концентрации не требуется –, а потом обрушивается. Может потребоваться бросок Архитектуры, чтобы создать стабильную форму.
Земля, которую двигают этим заклинанием, передвигается с Движением 2; камень передвигается с Движением 1. Этим нельзя никому причинить вред, кроме как натечь на неподвижного человека и засыпать его. Если земля движется к человеку, чтобы его засыпать – или из-под него, чтобы сделать яму – он может нормально передвигаться в следующий свой ход, чтобы убежать. Он пойман, только если не сделал этого.
Любой, засыпанный неплотной землёй, может попытаться выкопаться. Позволен один бросок в секунду с СЛ(ST)-4. Мастер может сделать этот бросок сложнее, если жертву засыпало более чем двумя кубическими ярдами земли. Жертва может задерживать дыхание (см. Задержка дыхания, B251), но велик риск задохнуться (см. Удушение, B436). Жертва, погребённая под камнем может задержать дыхание, но если у неё нет приспособлений, позволяющих пробиться сквозь сплошной камень, шансов выбраться мало.
Длительность: 1 минута
Стоимость: 1 за кубический ярд формируемой земли (минимум 2). Двойная стоимость для камня; шестикратная для резаного или обработанного камня, например стены. Нелегко сделать собственную дверь в замок.
Требуется: Искать землю.
Предмет
Посох, жезл или украшение, или копательный инструмент. Энергостоимость создания: 200 (500 для предмета, формирующего камень).</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/25 cu ft</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M50</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Earth</name>
		<name-loc>Создать землю</name-loc>
		<description-loc>Обычное
Позволяет создать хорошую, твёрдую землю там, где её раньше не было. Земля должна быть создана в контакте с поверхностью, а не висящей в воздухе или плавающей в море!
Длительность: навсегда.
Стоимость: 2 за кубический ярд, чтобы создать землю из ничего (минимум 2); 1 за кубический ярд, чтобы сделать из грязи хорошую, твёрдую землю (минимум 1).
Требуется: Землю в камень.
Предмет
Посох или жезл. Энергостоимость создания: 500.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/25 cu ft</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">earth to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Earth to Stone</name>
		<name-loc>Землю в камень</name-loc>
		<description-loc>Обычное
Превращает предмет из земли или глины в твёрдый камень (но не драгоценный), или превращает предмет из камня в простой металл вроде бронзы или железа. За двойную стоимость, превращает предмет из земли или глины в металл.
Длительность: навсегда.
Стоимость: 3 за кубический ярд (минимум 3).
Требуется: Магичность(Magery) 1 и Формировать землю.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3/25 cu ft #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Earth Vision</name>
		<name-loc>Видеть сквозь землю</name-loc>
		<description-loc>Обычное
Позволяет смотреть сквозь землю – чтобы находить пещеры, залежи руды, зарытые сокровища, погребённых, и.т.д. Земля и необработанный камень (вплоть до 50 ярдов глубины) прозрачны для объекта заклинания, куда бы он ни посмотрел. Металл не прозрачен; как и обработанные камни, кирпичи, и.т.д. Таким образом, это заклинание не позволит смотреть сквозь стены замка.
Это также заклинание Школы знаний.
Длительность: 30 секунд.
Стоимость: 2 за 10 ярдов глубины. Столько же за поддержку.
Требуется: Формировать землю.
Предмет
Любой. Энергостоимость создания: 400.</description-loc>
		<college>Earth/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/10 yds#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Predict Earth Movement</name>
		<name-loc>Предсказать движение земли.</name-loc>
		<description-loc>Информационное
Точно предсказывает любые обвалы, оползни, землетрясения, или вулканическую деятельность, которая может случиться в данном районе в данный период. Даёт приблизительную информацию о природе, месте и тяжести приближающейся катастрофы. Это заклинание не может предсказать магически созданные землетрясения или вулканы.
Стоимость: 2 умножить на длину предсказания в днях. Двойная стоимость за предсказания не в текущей местности (за горизонтом). Четырёхкратныя за место на другом континенте.
Время сотворения: 5 секунд на день предсказания.
Требуется: 4 заклинания Земли.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2/day</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Instant</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">earth</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Pass</name>
		<name-loc>Искать перевал</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление и приблизительное расстояние до ближайшего перевала через горный хребет. Используйте модификаторы больших расстояний (M14).
Стоимость:3.
Время сотворения: 10 секунд.
Требуется: Искать землю.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stone to Earth</name>
		<name-loc>Камень в землю</name-loc>
		<description-loc>Обычное
Превращает любой камень (в том числе драгоценный) в простую землю. Обязательно применять на целый камень или блок, а не на его часть. Это заклинание также превращает металл в камень, или превращает металл в землю за двойную цену.
Длительность: навсегда.
Стоимость: 6 за кубический ярд (минимум 6)
Требуется: Землю в камень, или любые четыре заклинания Школы земли.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 400.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6 per 25 cu ft</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M51</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<college compare="is">earth</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Earth to Water</name>
		<name-loc>Землю в воду</name-loc>
		<description-loc>Обычное
Превращает землю в грязь (или воду). Различные применения этого заклинания включают замедление врагов или преследователей, изготовление лечебной грязи для обработки укусов насекомых, размягчение земли, чтобы использовать в качестве глиняных манекенов или ложных целей, и.т.д.
Это также заклинание школы Воды.
Длительность: навсегда.
Стоимость: 1 за кубический ярд земли, превращённой в грязь. Удвоенная за превращения в воду.
Требования: Магичность(Magery) 1, Создать воду и Формировать землю.
Предмет
Посох, жезл или украшение. Используется только магами; предмет должен прикасаться к цели. Энергостоимость создания: 500.</description-loc>
		<college>Earth/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/25 cu ft#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mud Jet</name>
		<name-loc>Струя грязи</name-loc>
		<description-loc>Обычное
Выстреливает тонкой струёй грязи из одного пальца. Каждый ход, заклинатель бросает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. От этой атаки можно уклониться или заблокировать, но парировать её нельзя. Она отбрасывает все цели;  может убить или сбить рои летающих существ. Гасит нормальный огонь на площади радиусом один ярд.
Если заклинание попадает в лицо, то временно ослепляет цель (см. Видимость, B394), если только она не сделает успешный бросок ЗД(HT). Если она провалила бросок ЗД(HT), то каждая единица энергии, вложенная в заклинание, ослепляет её на одну секунду. После того, как к цели вернётся возможность видеть, размытость зрения даёт ей штраф -3 на все боевые умения ещё на 1d секунд. При критическом провале ЗД(HT), цель ослеплена на 1d секунд на каждую единицу энергии, вложенную в заклинание. При успешном броске ЗД(HT), жертва закрывает глаза, и, таким образом, не может видеть одну секунду. При критическом успехе, на жертву не производится никакого эффекта.
Это также заклинание Школы воды.
Длительность: 1 секунда.
Стоимость: от 1 до 3. Наносит 1d отбрасывания за каждую потраченную единицу энергии.
Требуется: Струя воды и Создать землю, или Создать воду и Струя песка.
Предмет
Посох или жезл. Используется только магами. Струя исходит из вершины предмета. Энергостоимость создания: 600.</description-loc>
		<college>Earth/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>1-3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d kb/point - Blinds</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sand jet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Partial Petrification</name>
		<name-loc>Частичное окаменение.</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT)
Превращает часть живого объекта в камень, обычно оставляя его неподвижным, но способным говорить и подвергаться пыткам. Заклинатель должен прикасаться к цели. Части тела, которые изменяются, выбираются заклинателем,  можно превратить в камень всё что угодно, от одного пальца, до всего тела от шеи и ниже, но на голову подействовать нельзя. Метаболизм объекта магически изменяется для возможности пережить превращение, и он конечно чувствует сильный дискомфорт, что бы с ним не делали.
Окаменевшие части тела неподвижные, онемелые, и имеют СП(DR) 10. Жертвы этого заклинания получают штраф к ЛВ(DX) на любые попытки физических действий: -1 или больше, в зависимости от деталей заклинания и действия.
Одежда, украшения и т.п. могут быть «прихвачены» заклинанием и включены в окаменение, но магические предметы и всё, что несли в руке или рюкзаке, остаётся неизменным.
Только заклинания Камень в плоть или Снять проклятье могут отменить окаменение.
Длительность: навсегда (пока не снимут).
Стоимость: 12. Превращение больших объектов стоит больше, как если бы это было Обычное заклинание (т.е., 24 энергии при МР(SM)+1, 36 энергии при МР(SM)+2, и т.д.)
Время сотворения: 3 секунды.

Требуется: Магичность(Magery) 2 и Плоть в камень.
Предмет
Посох, жезл или украшение. Используется только магами; предмет должен прикасаться к объекту. Энергостоимость создания: 1.300.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>Petrification</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">flesh to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sand Jet</name>
		<name-loc>Струя песка</name-loc>
		<description-loc>Обычное
Выстреливает тонкой струёй песка из одной руки. Каждый ход, заклинатель бросает ЛВ(DX)-4 или умение Природная атака для попадания. От этой атаки можно уклониться или заблокировать, но парировать её нельзя. Если заклинание попадает в лицо, оно не наносит ран, но временно ослепляет цель, если только она не сделает успешный бросок ЗД(HT).
Если цель провалила бросок ЗД(HT), то она ослеплена (см. Видимость, B394) на одну секунду за каждую единицу энергии, вложенную в заклинание. После того, как к цели вернётся возможность видеть, размытость зрения даёт ей штраф -3 на все боевые умения ещё на 1d секунд. На критически проваленном броске ЗД(HT), цель ослеплена на 1d секунд на каждую единицу энергии, вложенную в заклинание. На успешном броске ЗД(HT), жертва закрывает глаза на время действия заклинания, и таким образом, не может видеть одну секунду. На критическом успехе, на жертву не производится никакого эффекта.
Длительность: 1 секунда.
Стоимость: 1-3. Длина струи в ярдах равна величине энергии, вложенной в него. Стоимость поддержания такая же.
Требуется: Создать землю.
Предмет
Украшение, посох или жезл. Используется только магами. Энергостоимость создания: 600.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>Blinds</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stone Missile</name>
		<name-loc>Каменный снаряд</name-loc>
		<description-loc>Метательное
Создаёт каменный шар, и запускает его из одной руки, нанося повреждения всему, во что попадёт. Это заклинание имеет 1/2Д 40, Max 80, Acc (Точность) 2.
Стоимость: любая, вплоть до уровня Магичности в секунду, в течение трёх секунд. Снаряд наносит 1d+1 дробящих повреждений за каждую единицу энергии.
Время сотворения: от 1 до 3 секунд.
Требуется: Создать Землю.
Предмет
Посох или жезл – снаряд выстреливается из конца предмета. Используется только магами. Энергостоимость создания: 400.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-Magery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d+1 cr/point</damage>
			<accuracy>2</accuracy>
			<range>40/80</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk Through Earth</name>
		<name-loc>Прохождение сквозь землю</name-loc>
		<description-loc>Обычное
Позволяет пройти сквозь землю, как если бы она была воздухом. Объект этого заклинания может пройти сквозь каменную стену подземелья, или земляную стену хижины. Это заклинание не открывает проход, которым могли бы последовать другие. Оно также не открывает, что находится на другой стороне. Если заклинатель также знает заклинание Землю в воздух, у него автоматически будет воздух для дыхания на время прохождения, без затрат энергии. Если нет, ему надо задерживать дыхание!
Если заклинание закончится до того, как цель выйдет на открытый воздух, он остаётся закопанным в землю или камень, как был. Автоматически вреда он не получает, но будет задыхаться (см. Удушение, B436), если не сможет выбраться.
Длительность: 10 секунд.
Стоимость: 3 сотворить, 3 поддержка. Удвоенная для прохождения камня. Утроенная - металла.
Требования: четыре заклинания Школы земли.
Предмет
Серый плащ или серебряное украшение; действует только на носящего. Энергостоимость создания: 1.200.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M52</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Entombment</name>
		<name-loc>Погребение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Земля мгновенно проглатывает объект. Он находится в состоянии Приостановленной жизни  (описано на M94), в крошечной сферической комнате в 50 футах под землёй, пока его не спасут выкапыванием или отменой заклинания. Маг, творящий Погребение на себя, может решить оставаться бодрствующим, но это глупо, если у него нет какого-то способа дышать, будучи погребённым!
Длительность:  навсегда, пока не будет обращено этим же заклинанием.
Стоимость:  10 (но только 6 за обращение погребения).
Время сотворения: 3 секунды.
Требования:  Магичность(Magery) 2 и пять заклинаний школы Земли.
Предмет
Жезл или посох – должен быть покрашен в угольно чёрный цвет. Используется только магами. Энергостоимость создания: 1.200. Предмет должен коснуться жертвы для срабатывания.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M53</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">earth</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Earth</name>
		<name-loc>Истинная земля</name-loc>
		<description-loc>Обычное
Создаёт магическую эссенцию земли. Она в три раза более плодородная: растения прорастают втрое быстрее и растут втрое выше или больше, чем обычно. Вдобавок, если её превратить в камень заклинанием Землю в камень, он будет втрое прочнее (СП(DR) и ЕЖ(HP)); колонны и блоки, вырезанные из такого камня, будут поддерживать втрое больший вес. Истинная земля похожа на легендарный материал адамант, который подробнее описывается в GURPS Фэнтези.
Если истинную землю превратить в металл с помощью заклинания Землю в камень, он тоже будет втрое прочнее (ЕЖ(HP), СП(DR) и нагрузка), чем обычный металл; это похоже на легендарный сплав орихалк, который подробнее обсуждается в GURPS Фентези.
Длительность: навсегда.
Стоимость: 8 за кубический ярд.
Время сотворения: 30 секунд.
Требования: шесть заклинаний школы Земли.
Предмет
Посох. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M53</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">earth</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain of Stones</name>
		<name-loc>Дождь камней</name-loc>
		<description-loc>Областное
Камни падают с неба в указанную область, нанося 1d-1 дробящего вреда в секунду всем, кто в ней находится. Персонажи и существа под дождём получают повреждения в свой ход; если не полная секунда была проведена в области воздействия, наносятся половинные повреждения (округлить вниз). 
Это заклинание можно сотворить только на открытом воздухе. Броня защищает, как обычно. Щит с ПЗ(DB) равной 2 или более можно держать над головой, чтобы блокировать камни, но он может получить повреждения (B484). На это нужно две руки и манёвр Подготовки, и это автоматически успешно защищает персонажа, как только щит направлен вверх, но это делает щит неготовым выполнять его обычные защитные функции!
Недвижимые предметы, например здания, защищают своим СП(DR).
Длительность: 1 минута.
Базовая стоимость: 1 за сотворение (минимум 2). Столько же за поддержание. За удвоенную базовую стоимость Дождь из камней наносит 2d-2 в секунду! 
Требования: Магичность(Magery) 2 и Создать землю.
Предмет
Посох. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 cr/point</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M53</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stone to Flesh</name>
		<name-loc>Камень в плоть</name-loc>
		<description-loc>Обычное
Обращает эффекты заклинания Плоть в камень, и возвращает его жертву к жизни (оглушённым). Не может использоваться, чтобы оживить статую, которая никогда не была живой. 
Длительность: мгновенно.
Стоимость:  10. Двойная для восстановления превращения в металл. 
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2, Плоть в камень и Камень в землю.

Предмет
Посох или жезл. Используется только магами. Энергостоимость создания: 1.000. Предмет должен касаться жертвы для срабатывания.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M53</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">stone to earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">flesh to stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Stone</name>
		<name-loc>Тело из камня</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект становится оживлённой каменной статуей; он временно получает мета-черту Тело из камня (B262). Одежда тоже становится камнем, но носимое снаряжение – нет.
Длительность: 1 минута.
Стоимость: 10 сотворение. 5 поддержка.
Время сотворения: 5 секунд.
Требования: Камень в плоть. 
Предмет
Посох, жезл или украшение. Действует только на носителя. Энергостоимость создания 1.500.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>5</maintenance_cost>
		<casting_time>5 secs</casting_time>
		<duration>1 min</duration>
		<reference>M54</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">stone to flesh</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Earthquake</name>
		<name-loc>Землетрясение</name-loc>
		<description-loc>Областное
Трясёт область воздействия. Заклинателю, вероятно, не захочется, чтобы в эту область входил и он. Разделите расстояние от заклинателя до границы области воздействия на 20 перед тем, как вычислять штраф к умению.
Это заклинание должно быть сотворено на довольно большую площадь, чтобы быть полезным. Тряска одного угла здания рассердит тех, кто внутри,  но здание не развалит. Стоимость зависит от силы землетрясения:
Слабое: просто демонстрация – лёгкое покачивание. Базовая стоимость.
Умеренное: небольшие повреждения зданиям. Умножить базовую стоимость на 2. Чтобы устоять на ногах, находясь в области воздействия, нужен бросок ЛВ(DX) каждую секунду.
Сильное: каменные стены трескаются; башни могут упасть. Умножить базовую стоимость на 4. Чтобы устоять на ногах, находясь в области воздействия, нужен бросок ЛВ(DX)-3 каждую секунду.
Длительность: 1 минута.
Базовая стоимость: 2  сотворение. Столько же поддержка.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 2 и минимум шесть заклинаний школы Земли, включая Видеть сквозь землю.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 min</duration>
		<reference>M54</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="is">earth</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Purify Earth</name>
		<name-loc>Очистить землю</name-loc>
		<description-loc>Областное
Удаляет посторонние предметы, яды и вредные элементы из почвы, делая её пригодной для выращивания растений. Это заклинание также помогает от любых недостатков в составе почвы. Маленькие сторонние предметы (монеты, гвозди) находящиеся под землёй уничтожаются; средние (мечи, артиллерийские снаряды, сундуки, статуэтки) «всплывают» на поверхность. Большие предметы (гробы, стены, большие статуи) приводят к провалу заклинания, но заклинатель получает общее представление о причине провала.
Это также заклинание школы Растений.
Длительность: навсегда.
Базовая стоимость: 2. Удвоенная за плохую почву, как каменистые равнины или пустыня.
Время сотворения: 30 секунд.
Требования:  Создать землю и Рост Растений.
Предмет
Посох. Энергостоимость создания: 400.
Песчаная буря</description-loc>
		<college>Plant/Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M54</reference>
		<notes>Double casting cost in poor or rocky soil/desert</notes>
		<categories>
			<category>Earth</category>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Steel Wraith</name>
		<name-loc>Призрак стали</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Делает объект нематериальным для металла. Мечи проходят сквозь него, он не может держать металлические ключи или носить металлическую броню, он проходит сквозь прутья решеток и металлические полы…
Длительность: 1 минута.
Стоимость: 7 сотворение. 4 поддержка.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2 и Прохождение сквозь землю.
Предмет
(а) Жезл, посох или украшение. Используется только магами. Энергостоимость создания 1.200. (б) Металлическое оружие может быть заколдовано, чтобы противодействовать этому заклинанию (чтобы оно могло быть использовано существом под воздействием этого заклинания или против него). Энергостоимость создания: 250 на фунт веса (минимум 1 фунт).</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M54</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (earth)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">walk through earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Volcano</name>
		<name-loc>Вулкан</name-loc>
		<description-loc>Обычное
Заставляет пар и лаву извергаться из выбранной точки на земле. Это не быстрое заклинание, но оно очень серьёзное! Вулкан вначале маленький – небольшая дыра в земле, выплёвывающая камни и пары – и увеличивается в диаметре на пару ярдов в день. Это заклинание также может пробудить спящий вулкан. Когда заклинанию позволяют закончиться, вулкан прекращает расти и вскоре потухнет (ранее дремавший вулкан может остаться активным на усмотрение Мастера)
Длительность: 1 день.
Стоимость: 15 сотворение. 10 поддержка.
Время сотворения: Один час до проявления первых эффектов. Непрерывная концентрация по 8 часов каждый день необходима для дальнейшего роста вулкана.
Требования:  Землетрясение и минимум шесть заклинаний школы Огня.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>15</casting_cost>
		<maintenance_cost>10</maintenance_cost>
		<casting_time>1 hr #</casting_time>
		<duration>1 day</duration>
		<reference>M54</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">fire</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earthquake</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
	<name>Alter Terrain</name>
	<name-loc>Изменить ландшафт</name-loc>
	<points>1</points>
	<spell_class>Area</spell_class>
	<casting_cost>1#</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>10 sec</casting_time>
	<duration>2d days</duration>
	<college>Earth</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<name compare="does not contain">one college</name>
				<level compare="at least">3</level>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery one college (earth)</name>
				<level compare="at least">3</level>
			</advantage_prereq>
		</prereq_list>
		<spell_prereq has="yes">
			<name compare="is">shape earth</name>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">shape fire</name>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">shape air</name>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">shape water</name>
			<quantity compare="is">1</quantity>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Earth</category>
	</categories>
	<reference>M55</reference>
	<description-loc>Областное
Может использоваться для того, чтобы полностью преобразить огромные площади. Если сотворить на достаточно большую область, оно может превратить город в озеро или море, или прибрежный остров в горный хребет. Профиль поверхности (в том числе дно морей, озёр или рек) в области действия можно поднять, опустить или переформировать как пожелает заклинатель, или поменять структуру на любую от мягкой земли и песка до твёрдого гранита. Каменные или кирпичные здания и растительное вещество могут быть превращены в «естественные» камень или землю, но не наоборот. Подводные участки, поднятые над водой, становятся сушей; любые участки, опущенные ниже уровня грунтовых вод, могут быть затоплены. Мастер должен потребовать броски умений Архитектура, Изобразительное искусство или Инженерия, если заклинатель пожелает преобразить местность во что-то конкретное.
Существа и незакреплённые предмет на поверхности во время сотворения заклинания просто опускаются или поднимаются, без вреда для себя. Если они находятся внутри зданий, их мягко выталкивает, а не погребает. Конечно, если они окажутся под водой, у них могут быть проблемы…
Если заклинание будет обращено или рассеяно, вся область возвращается в исходное состояние; даже преображённые здания и деревья восстанавливаются.
Длительность: 2d дней.
Базовая стоимость: 1 сотворение (минимальная стоимость 15). Не поддерживается. Можно воздействовать на объемы больше, чем 4 ярда в высоту, умножив сответственно базовую стоимость.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 3 и все четыре стихийных заклинания «Формировать…».
Предмет
Область может быть навсегда преображена за 100 кратную стоимость сотворения заклинания.</description-loc>
</spell>
	<spell version="2">
		<name>Move Terrain</name>
		<name-loc>Переместить ландшафт</name-loc>
		<description-loc>Областное; Особое сопротивление
Позволяет передвинуть на большие расстояния ландшафт области действия, со всеми зданиями, животными и людьми на или в ней. Когда заклинание сотворено, перемещаемая местность исчезает (см. ниже), и заменяется на голую землю или открытую воду. Заклинатель при этом «носит» эту область в невидимой и неосязаемой форме (это можно определить с помощью Обнаружить магию или чего-то подобного). Существа, попавшие в область действия, имеют бросок сопротивления, основанный на лучшем среди них значении Воли(Will), модифицированном на -1 за каждый дополнительный ярд радиуса области воздействия (так, Переместить ландшафт с 2-ярдовым радиусом сопротивляется Воле(Will)й-1). Успешное сопротивление отменяет заклинание.
Когда  заклинания успешно сотворено, область действия «уменьшается» со скоростью 1 ярд в секунду, и с той же скоростью движется к заклинателю. Достаточно быстроногие жертвы могут иметь возможность выпрыгнуть из области действия, пока она уменьшается (тут есть хороший драматический потенциал) – делайте броски ЛВ(DX) и ИН(IQ)! Мастер может решить, что это является основанием для Броска страха.
Запертые внутри заклинания существа видят дикое, кружащееся небо над головами и физически непреодолимый барьер вокруг. Атмосфера внутри остаётся пригодной для дыхания и комфортной (так что это заклинание нельзя использовать, чтобы кого-то душить!). Заклинания, которые произносятся из области действия, автоматически попадают в держателя передвигаемой местности – таким образом, запертый маг может подойти к границе области действия, положить руку на барьер, и сотворить Касание смерти на держателя. Запертые маги могут также сотворить Рассеять магию или Контрзаклинание на область действия, заставляя заклинание внезапно закончиться, если им это удастся.
Когда заклинатель прекращает поддерживать заклинание, местность появляется вновь. Заклинатель может оказаться где угодно внутри местности или на её границе. Область действия «расширяется» обратно до нормального размера с той же скоростью, что и уменьшалась. Если подходящего места нет, всё, что мешает, сдвигается в сторону, как под воздействием Формировать землю.
Заклинатель не может использовать это заклинание повторно в течение суток. Область действия или любая её часть не может быть передвинута этим заклинанием (любого заклинателя или магического предмета) на тот же период времени.
Будучи сотворённым на достаточно большую область, это заклинание может поместить горы в середину равнины, открытую воду (глубиной в половину радиуса эффекта, перемещённую из озера или океана) в середину пустыни – или переместить острова на сушу, чтобы сделать холмы!
Длительность: 1 час. (Эффекты после перемещения остаются навсегда.)
Базовая стоимость: 10 сотворение. 8 поддержка.
Время сотворения: 1 минута.
Требования: Изменить ландшафт и Скрыть объект.
Предмет
Посох. Используется только магами. Энергостоимость создания: 3.000.</description-loc>
		<college>Earth</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>8</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M55</reference>
		<categories>
			<category>Earth</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hide object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">alter terrain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Enchant</name>
		<name-loc>Наложение чар</name-loc>
		<description-loc>Наложение чар
Требование для всех остальных заклинаний наложения чар. Для зачарования предмета, заклинатель должен так же знать и это заклинания тоже. Заклинатель бросает против навыка меньшего между этим заклинанием и спецефическим заклинанием, которое он хочет наложить на предмет. Если у него есть помощники, у них должны быть навыки не меньше 15 в обоих заклинаниях, но бросок определяется умением заклинателя.
Длительность: до тех пор пока предмет не разрушится
Энергостоимость и время: см. Зачарование (M16).
Требования: Магичность(Magery) 2 и как минимум по одному заклинанию из 10 других школ</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M56</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Temporary Enchantment</name>
		<name-loc>Временные чары</name-loc>
		<description-loc>Наложение чар
Позволяет зачаровывающему создать магический предмет, который будет срабатывать всего несколько раз прежде чем потеряет чары, чтобы сильно сэкономить энергостоимость (и таким образом, время).
Предмет может быть зачарован за 15% от нормальной цены за каждое использование. Предмет на только одно использование будет стоить 15% нормальной цены, два использования будут стоить 30%, четыре 60% (очень неэффективно по цене в большинстве условий) и стоимость 7 и более использований превосходит стоимость постоянной вещи.
Временно зачарованный предмет работает, во всех отношениях, как нормальный предмет этого типа до тех пор, пока все его использования не закончатся. После этого предмет перестает быть магическим.
Временные чары заменяют Наложение Чар. Конкретный предмет не может быть зачарован одновременно с помощью обоих заклинаний одновременно.
Временные чары можно использовать только для того, чтобы дать предмету способность один раз сотворить заклинание, но не для того, чтобы сотворить заклинание на объект.
Например, маг не может сделать одноразовый невидимый доспех — его можно вообще никогда не снимать. Но он может дать броне способность сотворить невидимость на себя за нормальные время и энергостоимость.
Временный чары нельзя использовать вместе с любыми заклинаниями школы Наложения Чар и Метамагии за исключением следующих: Неснимаемость, Допуск, Связь, Имя, Энергия и Скорость. Временные чары абсолютно не могут быть использованы для уменьшения стоимости чар с уже ограниченным использованием (например Дух Черепа)
Длительность: до тех пор, пока все использования не будут истрачены
Энергостоимость и время: см. Зачарование, M16
Требования: Наложение Чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Indefinite#</duration>
		<reference>M56</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hex</name>
		<name-loc>Неснимаемость</name-loc>
		<description-loc>Наложение чар
Делает невозможным бросить/снять/избавиться от предмета. Сам по себе, этот эффект очень неудобен, но может быть полезен — к примеру, вы никогда не уроните неснимаемое оружие, а неснимаемые очки никогда не упадут. Тем не менее, если на неснимаемый предмет наложено другое вредное заклинание, это становится намного опаснее. Неснимаемость «всегда включена».
Для того, чтобы избавиться от неснимаемого объекта, вы должны убрать или подавить чары, найти кого-то, кто сотворит Убрать Проклятье, или ампутировать часть тела с предметом. Попытки сбить или срезать неснимаемую вещь не удадутся (или приведут к ампутации). ИМ должен позволить этому правилу давать нелогичные результаты, если необходимо, чтобы оставить предмет на теле жертвы. Неснимаемости не логичны!
Неснимаемость может быть ограничена с помощью заклинаний Связь или Пароль. Например, можно сделать неснимаемое кольцо, которое сотворяет Поражение Слепотой и пароль  «Гесундхейт». Любой, кто оденет кольцо, ослепнет — но стоит сказать пароль и кольцо спадет!
Энергостоимость создания: 200
Требования: Наложение Чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>200</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M57</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Power</name>
		<name-loc>Энергия</name-loc>
		<description-loc>Наложение чар
Дает предмету автономный «источник питания», полностью или частично обеспечивающий сотворение заклинания. Каждое очко Энергии уменьшает энергию на сотворение или поддержание заклинания с предмета на 1. Уменьшите вдвое эту премию в областях с низким уровнем маны, удвойте в областях с высоким или очень высоким уровнем маны. Энергия не влияет на стоимость заклинаний пользователя!
Если Энергия уменьшает стоимость поддержания до нуля, считайте предмет «всегда включенным» после того как стоимость на сотворение оплачена — но одевший должен оставаться в сознании для того, чтобы поддерживать заклинание. Если Энергия уменьшает стоимость сотворения до нуля, то предмет «всегда включен» для любых целей, владелец может выключить его по желанию.
Энергостоимость: см. таблицу ниже.
Энергия
Стоимость
1 очко  500
2 очка  1000
3 очка  2000
4 очка  4000
Удвойте стоимость для каждого дополнительного очка. Может быть пересотворено на   более высоком уровне как Точность (M65).
Требования: Наложение Чар и Восстановление энергии</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M57</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">recover energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scroll</name>
		<name-loc>Свиток</name-loc>
		<description-loc>Наложение чар
Написание магического свитка заряженного заклинанием из какой-либо другой школы. Если маг, понимающий язык свитка на уровне Акцент или лучше, громко читает его, свиток сотворяет свое заклинание, после чего его сила развеивается и написанное исчезает. Чтение свитка требует удвоенного времени на сотворение заклинания; маг, читающий свиток, платит нормальную энергостоимость заклинания. Бросок навыка не требуется, если только заклинание не является Сопротивляемым. В этом случае используется навык мага создавшего свиток.
При громком чтении свитка важно произношение! Если у мага, читающего свиток, понимание языка свитка на уровне Акцента, свиток сотворяет заклинание со штрафом -1; если на уровне Ломаный, свиток сотворяет со штрафом -3. Если заклинатель не знает языка, он не может произнести слова как следует и не может сотворить заклинание.
Свиток можно прочитать тихо, про себя, чтобы узнать что в нем написано. Любой маг, который понимает язык свитка, узнает какое заклинание в нем содержится. Это не приведет к сотворению заклинания!
Заклинания могут быть написаны на любом материале, но традиционно используется пергамент. Поврежденный свиток не утрачивает своей силы, пока его можно прочитать.
Время на сотворение: Количество дней, требуемых для написания свитка равно энергии требуемой для сотворения заклинания как обычно (базовой стоимости для областных заклинаний), не учитывая никакие премии от навыка. Умножьте это значение на $33 (или обычное для сеттинга значение за единицу зачарования; см. M21-M22) для того, чтобы получить нормальную магазинную цену свитка.
Пример:: Заднее зрение обычно стоит 3 единицы энергии для сотворения. Свиток Заднего Зрения потребует 3 полных дня для написания и обычно будет стоит $100. В конце времени написания, ИМ делает бросок против навыка Свитка или заклинания, которое вписывается — что меньше. Успешный бросок означает что заклинание будет сотворено успешно. Неудача означает что свиток работать не будет. Критический провал означает, что будет сотворено испорченное заклинание!
Длительность: до тех пор, пока заклинание не будет использовано. Маг, прочитавший свиток, может поддерживать заклинание, если его обычно можно поддерживать.
Требования: Магичность(Magery) 1 и как минимум уровень понимая Акцент в языке, на котором пишется свиток. Маг не может писать свитков на языке, которого он не знает.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Special</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>days=cost</casting_time>
		<duration>Varies</duration>
		<reference>M57</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Written (Accented)
				</notes></advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="starts with">Language</name>
					<notes compare="contains">Written (Native)
				</notes></advantage_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Speed</name>
		<name-loc>Скорость</name-loc>
		<description-loc>Наложение чар
Уменьшает время на сотворение любой другой чары на предмете, сделанной вместе со Скоростью. Каждое очко Скорости уменьшает время на сотворение вдвое, так же как и высокий навык для мага. Если время уменьшается до уровня менее чем 1 секунда, заклинание может быть сотворено без концентрации.
Энергостоимость создания: см. таблицу ниже.
Скорость
Стоимость
1 очко  500
2 очка  1000
3 очка  2000
4 очка  4000
Удвойте стоимость для каждого дополнительного очка. Может быть пересотворено на более высоком уровне как для Точности (M65)
Требования: Наложение чар и Ускорение</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M57</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Adjustable Clothing</name>
		<name-loc>Изменяемая одежда</name-loc>
		<description-loc>Наложение чар
Заставляет предмет одежды изменяться для того чтобы подойти тому, кто ее одевает, без ограничений. Изменения происходят в тот момент, когда пользователь начинает одевать  его, так что
чару нельзя обнаружить, если поднять вещь и сразу выбросить из-за «очевидно» неподходящего размера. Если предмет снять, он возвращается к первоначальному размеру. Изменение в размере вызывает так же изменения в весе; объект, удвоивший размер, увосьмерит вес.
Эта чара редко встречается — немногим заклинателям требуется создавать одежду, подходящую любому размеру. Иногда её можно среди исключительно дорогих театральных костюмов. Так же её используют когда вещь должна пережить первоначального носителя и часто предназначена стать семейной реликвией.
Энергостоимость: стоимость зачарования тканевой рубашки или пары брюк, способных увеличиваться или уменьшатся на 10% - 50. Эта стоимость широко варьируется в зависимости от размера, материала и изменяемости. Округляйте дробные части вверх.
Для перчаток, ботинок, туфлей, поясов или похожих маленьких предметов, разделите стоимость на 2. Для чего-то размером с кольцо или серьгу используйте треть стоимости. Для комбинезонов или длинных платьев удвойте стоимость. Для скафандров или для других вещей, которые закрывают тело полностью, утройте стоимость.
Вещь с несколькими незначительными металлическими частями (запонки, пуговицы) считается тканевой, как и тонкая кожа. Кожа, достаточно толстая чтобы получить СП(DR), удваивает стоимость. Чешуйчатый доспех, кольчуга или похожие материалы утраивают стоимость. Пластинчатый доспех и другие цельнометаллические костюмы умножают стоимость на 5. Для исключительно легких предметов одежды, таких как вуаль или женская ночная рубашка, уполовиньте стоимость.
Если предмет может подстраивать свой размер в пределах 25%, удвойте стоимость. Если может удвоить или уполовинить размер, утройте стоимость. Если может уменьшатся до 1/5 размера или увеличиваться в 5 раз, учетверите стоимость.
Требования: Наложение чар и Формирование</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">reshape</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Amulet</name>
		<name-loc>Амулет</name-loc>
		<description-loc>Наложение чар
Амулет — это предмет, который предоставляет одевшему магическое сопротивление против определенного заклинания. Амулеты часто зачаровываются с помощью нескольких заклинаний Амулета, чтобы противостоять широкому спектру эффектов. Несмотря на то, что обычно используются драгоценности, можно зачаровать любой предмет и даже вытатуировать амулет на теле носителя!
Заклинатель должен использовать меньшее из его умений Амулет и заклинания, от которого защищает. Амулеты так же работают против вариантов базового заклинания: амулет против Огненного Шара будет работать и против Разрывного Огненного Шара.
Алхимики могут создавать магические предметы, называемые амулетами (M220); не смотря на то, что они служат той же цели, это не тоже самое, что и амулеты, сделанные с помощью этого заклинания.
Энергостоимость: 50 за очко магической защиты, которую дает амулет (максимум 5)
Требования: соответствующее заклинания Талисмана (то есть для того, чтобы выучить Амулет против Паники, заклинатель должен знать Талисман против Паники)</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>50/ pt MR</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">talisman (@appropriate spell@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Lesser Wish</name>
		<name-loc>Малое желание</name-loc>
		<description-loc>Наложение чар
Это заклинание, как и более мощное заклинания Желание (ниже), должно быть сотворено на кольцо, амулет или украшение. Одевший эту вещь может указать любой результат броска кубиков, который делается в его присутствии, прямо перед броском — за исключением бросков использования магии. Это не «действие». Это не занимает времени и может быть сделано когда угодно. После использования заклинание пропадает.
Одно желание может подействовать только на один бросок или действие; вы можете использовать желание для броска атаки или для броска повреждений, но не для обоих. ИМ волен запретить любое использование желаний, которое кажется ему злоупотреблением или нарушением баланса.
Энергостоимость: 180
Требования: Наложение Чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>180</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Special</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Enchant</name>
		<name-loc>Снять чары</name-loc>
		<description-loc>Наложение чар
Убирает одну чару с предмета. Это не затрагивает остальные чары на этом же предмете. Исключение: проваленная попытка снять Ограничивающую чару убирает все чары с данного предмета.
Модификаторы: -3 если заклинатель не может наложить чару, которую пытается снять. -3 если не знает точно, какое именно заклинание на предмете. -3 за каждое дополнительное заклинание на предмете. Все модификаторы кумулятивны.
Длительность: снятие постоянно
Энергостоимость: 100 или 1/10 от стоимости оригинальной чары, что больше
Время на сотворение: см. Наложение Чар
Требования: Наложение чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>100 #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Enchantment</name>
		<name-loc>Сопротивление чарам</name-loc>
		<description-loc>Наложение чар
Предмет зачарованный этим заклинанием сопротивляется дальнейшему зачарованию добавляя штраф к броску наложения чар. Далее, эта чара сопротивляется  любым попыткам снять или подавить ее добавляя удвоенный обычный штраф.
Заклинатель может наложить Сопротивление Чарам, которая не будет сопротивляться определенным дальнейшим зачарованиям, но он должен либо сам наложить эти чары, либо присутствовать при всем процессе сотворения заклинания.
Энергостоимость: см. таблицу ниже
Штраф
Энергостоимость
-1   | 50
-2   | 100
-3   | 200
-4   | 500
-5   | 1000
Требования: Любая ограничивающая чара (см. с 68)</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">any limiting enchantment</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Suspend Enchantment</name>
		<name-loc>Подавить чары</name-loc>
		<description-loc>Наложение чар
Как Снять чары, но всего лишь подавляет а не снимает чару. Чара похоже пропадает, но появляется вновь, когда Подавление Чар заканчивается. Если кто-либо пытается изучить или обнаружить подавленную чару, она сопротивляется информационным заклинаниям с -5.
Модификаторы: -3 если заклинатель не знает, как наложить чару, которую он пытается подавить. -3 если он не знает какая именно это чара. -3 за каждую дополнительную чару на предмете. Все модификаторы кумулятивны.
Длительность: 1 час
Энергостоимость: 25 или 1/100 от стоимости наложения оригинальной чары, что больше. Половина на поддержание.
Требования: Наложение чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>25 #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Talisman</name>
		<name-loc>Талисман</name-loc>
		<description-loc>Наложение чар
Талисман — это предмет который дает одевшему одноразовое преимущество при атаке определенным заклинанием или немагической атакой или воздействием. Чара талисмана дает премию к броску сопротивления, проверке атрибута или броску защиты против его специфической атаки или воздействия. Талисман «всегда включен» когда одет или находиться в физическом контакте с владельцем, иначе неактивен. Он работает до тех пор, пока не случится вещь от которой он защищает, после чего теряет чары. Талисманы могут защищать от болезней, стрел, проклятий, молний и других бед.
Несмотря на то, что большинство талисманов создаются из драгоценностей, любой предмет может быть зачарован таким образом. Возможно даже вытатуировать талисман на теле носителя! При создании талисмана против заклинания, заклинатель должен использовать меньшее из его умений Талисмана и заклинания, от которого талисман защищает.
Каждая защита — это отдельное заклинание, которое должно быть изучено отдельно. Талисманы также работают против вариантов базового заклинания: талисман против Огненного Шара будет работать и против Разрывного Огненного Шара.
Алхимики могут создавать магические объекты, называемые талисманами (M220); однако это не тоже самое, что предметы созданные с помощью этого заклинания.
Энергостоимость: см. таблицу ниже
Защита
Энергостоимость
1 очко  15
2 очка  45
3 очка  90
4 очка  150
Требования: Наложение чар и заклинание от которого защищает (если нужно)</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M58</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spell to be opposed</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Golem</name>
		<name-loc>Голем</name-loc>
		<description-loc>Наложение чар
Создание и оживление постоянного слуги или воина. Големы прекрасные воины; они никогда не устают и не восприимчивы к оглушению, боли и желаниям. Более того, не существует известных заклинаний для «воровства» голема у его создателя. Заклинание постоянное, голем «всегда включен». Голем следуем устным приказам своего создателя; создатель также может приказать подчиняться кому-либо еще. Он понимает только один язык (который должен знать заклинатель). Не проявляет инициативу и игнорирует любые ситуации, для которых не было приказов. Тем не менее, он никогда не забывает ничего из увиденного или сказанного при нем.
Големы не лечатся сами по себе и уничтожаются, если здоровье уменьшается до -ЕЖ(HP). Они могут быть отремонтированы с помощью заклинаний лечения (исключая Воскрешение) если сотворено создателем голема. Другого способа починить голема нет. Для создания голема, создатель должен должен сделать тело голема — выполнив все работы самостоятельно — а потом оживить с помощью этого заклинания. Однажды оживленный, голем действует до тех пор, пока его здоровье не уменьшится до 0 ЕЖ(HP) или до тех пор, пока создатель не прикажет ему прекратить функционировать. Не требуется никакой концентрации или поддержки, чтобы контролировать голема.

Глиняный Голем
Глина — это материал по умолчанию для создания голема; ее легко лепить, в обоих, физическом и сверхъестественном, смыслах. Создатели големов часто используют более сложные материалы, такие как камень, пластик, плоть, но если голем нужен срочно, большинство заклинателей возвращаются к глине.
Глиняный Голем
0 очков
Модификаторы атрибутов: СЛ(ST)+5[50]; ЛВ(DX)+1[20]; ИН(IQ)-2[-40]; ЗД(HT)+4[40]
Преимущества: Не дышит [20]; Не ест/не пьет [10]; Не спит [20]; Высокий болевой порог [10]; Иммунитет к метаболическим угрозам [30]; Сопротивление ранениям (Однородный, Нет крови) [45]; Целеустремленный [5]; Нестареющий [15]; Невозмутимый [15]; Устойчивость к вакууму [5].
Недостатки: Автомат [-85]; Неспособен учиться [-30]; Неприятный голос [-10]; Нет чувства вкуса/запаха [-5]; Перепрограммируемый [-10]; Социальная дискриминация (Собственность) [-10]; Неисцеляемый (Полностью) [-30]; Неестественный [-50]; Богатство (Нищий) [-25].
Особенности: не имеет и не может тратить единицы усталости
Умения: 10 очков в умениях, соответствующих предназначению голема [10]

Големы — превосходные воины; они никогда не устают и имунны к оглушению, боли и желаниям.

Зачаровать простого глиняного голема (см. врезку) стоит 250 единиц энергии. Более мощные големы стоят на 2 единицы энергии больше за каждое очко персонажа, добавленное голему. В большинстве случаем, дополнительные способности должны быть ограничены дополнительными СЛ(ST), ЕЖ(HP) или СП(DR) (практическое правило: 20 единиц энергии добавляют 1 СЛ(ST), 5 ЕЖ(HP) или 2 СП). Тем не менее, ИМ может позволить более широкие изменения, если ему удобно. Для создания более мощных големов возможно понадобятся более прочные (и дорогие) материалы, что увеличит стоимость и  время необходимые для изготовления тела голема. (Опционально ИМ может разрешить создавать менее мощных големов; големы, хуже чем 0 очков, стоят на 2 единицы энергии меньше за каждое очко персонажа меньше нуля, до минимум в 130 единиц энергии)
Энергостоимость: 250 или больше
Требования: Наложение чар, Формировать Землю и Анимация. Другие заклинания могут потребоваться для работы с необычными материалами, например Формировать растение для деревянного голема или Восстановление для голема из плоти.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M59</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Ensorcel</name>
		<name-loc>Заклятье</name-loc>
		<description-loc>Наложение чар;
Специально сопротивление
Заклятье — это продолжительное заклинание, вредное, хотя иногда может быть полезным, сотворенное на одиночное существо. Процесс требует компонент релевантный цели; используйте модификаторы как для Проклятой куклы.
Эффективное умение заклинателя определяется как меньшее из этого заклинания и определенного заклинания, которое накладывается на объект. Если у заклинателя есть помощники, они должны знать оба заклинания на уровне 15 или больше, но бросок основан на умении заклинателя.
Возможные заклятья включают довольно немного заклинаний из школы Контроля Тела или Контроля Разума и другие, такие как Превратить другого, Плоть в камень, всевозможные заклинания «Тело из», Ходить по воздуху, всевозможные заклинания сопротивления, Скрыть, Невидимость, разные заклинания «видения» и Растительная форма другому. Во всех случаях это должно быть поддерживаемое Стандартное заклинание.
Когда заклинание сотворяется, объект может сопротивляться, если накладываемое заклинание это позволяет; расстояние не учитывается. Снять проклятие поможет против любого Заклятья.
Стоимость заклинания можно уменьшить, если определить «условие избавления» - определенное действие или условие которое прервет заклинание. Примеры: сказать магическое слово, быть поцелованным как жест настоящей любви, отказ от речи на три года и так далее. Размер уменьшения зависит от того, насколько «условие избавления» легко достигаемо, оно должно быть как минимум возможно, чтобы дать уменьшение. Размер «скидки» может быть от 10% (для по настоящему сложных или неприятных условий) до 90% (для чего-то, что объект может сделать просто и автоматически и легко обнаружить)
Энергостоимость: в 200 раз больше, чем стоит накладываемое на объект заклинание.
Требуется: Проклятая кукла</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>200xspell cost</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M60</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">malefice</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Impression Blocker</name>
		<name-loc>Блокатор ассоциаций</name-loc>
		<description-loc>Наложение чар
Искатель (M105) и родственные заклинания требуют объект, ассоциированный с предметом или персоной, которую ищут, для свое работы. Чара Блокатор ассоциаций создает контейнер, который позволяет людям переносить предметы без того, чтобы они стали «ассоциированы» с переносящим.
Объект в закрытом блокирующем контейнере сохраняет отпечатки, которые были на нем до закрытия контейнера. Если объект вытащить, недолго использовать и положить обратно, то он приобретет очень слабый отпечаток использовавшего, которого будет недостаточно для заклинания Искатель, если только тот не будет делать это каждый день в течение нескольких недель. Так же можно оставить объект полезным в контейнере; например, книгу, открытую на важной странице и помещенную в прозрачный контейнер, все еще можно прочесть! На достаточно высоких техуровнях, можно зачаровать контейнер с манипуляторами, что позволит использовать объект не открывая контейнер.
В некоторых игровых мирах такие контейнеры могут использоваться для сохранения доказательств. Если объект принадлежал кому-либо в течение большого времени, а потом передан кому-либо еще, то отпечаток первоначально хозяина может выветрится. Блокирующий контейнер сохраняет отпечаток первоначально хозяина. (в других мирах отпечаток может никуда не деваться, тогда предмет можно использовать для сотворения Искателя для любого из предыдущих хозяев).
Энергостоимость: 20 за фунт вместимости, минимум 20
Требуется: Наложение чар, Искатель,  Стена защиты от наблюдение</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>20/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M60</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">scry wall</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Malefice</name>
		<name-loc>Проклятая кукла</name-loc>
		<description-loc>Наложение чар
Посредством этой грязной чары заклинатель может сделать жертву своим рабом. Для этого он должен сделать куклу (обычно из воска, но ИМ может позволить глину, солому или что-нибудь еще) содержащую что-то релевантное цели. Части тела (обрезки ногтей, волосы, кровь, слюна и т. д.) не дают штрафов. Другие предметы дают различные штрафы; например, нитки из рубашки, которую носили годами дадут -2, в то время как грязь из свежего следа даст -6.
Проклятая кукла это длительное заклинание, которое продолжается до тех пор, пока его Сопротивление не уменьшится до 0 (M10). Начальное Сопротивление равно эффективному навыку заклинателя.
Сделавший куклу (и только он) может использовать её для сотворения вредных заклинаний (таких как Боль) на цель, с нормально энергостоимостью и без штрафов за расстояние. Для сотворения заклинатель должен использовать меньшее значение из Сопротивления куклы и его умения в том заклинании, которое он посылает. Цель сопротивляется всем таким атакам, даже если заклинанию обычно нельзя сопротивляться (при заклинаниях, которым обычно сопротивляться нельзя, можно сопротивляться по ЗД(HT) когда они сотворены через Проклятую куклу).
Если цель сопротивляется самому первому заклинанию, сотворенному через куклу, чара моментально ломается. В других случаях каждое успешное сопротивление просто ослабляет чару, уменьшая ее Сопротивление на 1. По достижению Сопротивления 0 Проклятая кукла рассеивается (хотя сама кукла остается пригодной для перезачарования, но ее магическая связь с целью даст штраф -1 при сотворении чары). Критический провал заклинание, направляемого через куклу, или критический успех сопротивления цели также ломают чару, уменьшая ее Сопротивление до 0.
Уничтожение куклы ломает чару, но так же вызывает на цель Касание Смерти (M41) на количество кубиков, равное текущему значению Сопротивления Проклятой куклы разделенному на 5 (округлите вниз, максимум 3d). Это повреждение будет появляться в любом случае, если у Проклятой куклы осталось Сопротивление. Заклинание Снять проклятие поможет цели освободиться без вреда.
Энергостоимость: 250. Воск и специальные компоненты стоят $500
Требования: Наложение чар и  Искатель</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>250</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Indefinite#</duration>
		<reference>M60</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spell Stone</name>
		<name-loc>Камень заклинаний</name-loc>
		<description-loc>Наложение чар
Камень заклинаний содержит в себе заклинание, до тех пор, пока кто-либо (даже не маг) использует его. Для использования достаточно концентрироваться в течение секунды, раздавливая камень в руке, таким образом сотворяя заклинание. В начале следующего хода, бросьте против Мощности камня. При успешном броске заклинание сотворено. Если бросок неудачный, камень просто потерян. Если камень раздавлен без необходимой секунды концентрации, он опять-таки просто теряется.
Энергия заклинания включена в стоимость заклинания; ничего дополнительно от пользователя не требуется, который также не может вкладывать свою энергию для поддержки заклинания. Так же он не может прервать заклинание, если оно уже сотворено, правда создатель камня может указать меньшую чем обычно продолжительность либо вложить дополнительную энергию в зачарование, так что заклинание будет поддерживать само себя. Персонаж может использовать только один камень заклинаний в ход.
Камень заклинаний должен быть сделан из драгоценности стоимостью $10xP^2 + $40xP где P — это максимальная энергия заклинания, которое может содержать камень.
Любое заклинание может быть помещено в Камень Заклинаний, исключая блокирующие и зачаровывающие заклинания. Можно также дополнительно наложить ограничивающие чары. Если заклинание в камне требует знания другого определенного заклинания (например Контрзаклинание), это другое заклинание должно быть указано при создании. Таким образом можно создать заклинание для противодействия одному конкретному заклинанию, но невозможно создать универсальный камень контрзаклинания.
Так же можно создать камень, который будучи раздавлен сотворит заклинание не для пользователя, а на него!
Анализ магии покажет какое заклинание содержит камень, будет ли оно сотворено для пользователя или на него, сколько энергии было потрачено и т. д. (один вопрос за одно сотворение Анализа магии)

Будьте осторожны со своими желаниями.
Они могут исполниться.
Энергостоимость: в 20 раз больше чем обычно стоит заклинание, включая стоимость поддержки, если необходимо.
Требования: Наложение чар и задержка</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>20xspell cost</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Varies</duration>
		<reference>M60</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hideaway</name>
		<name-loc>Скрытое пространство</name-loc>
		<description-loc>Наложение чар
При сотворении на объект, делает его больше внутри чем снаружи. Может быть использовано на карман, мешочек, ящик стола, кувшин — на все, что обычно может использоваться для хранения других вещей. Заклинатель может добавить любое количество фунтов дополнительного пространства, увеличивая так же внутренний объем на два кубических фута за фунт; дополнительное пространство может быть скрыто за фальшивым дном и т. д. В зависимости от энергии вложенной в заклинание, объекты в скрытом пространстве могут не считаться за нагрузку. Содержимое будет потеряно навсегда, если заклинание будет разрушено. Время, нужно для того, чтобы найти что-нибудь в скрытом пространстве зависит от того, насколько оно глубоко!
Большое скрытое пространство может содержать персону. Проблем с воздухом не будет, если только скрытое пространство не запечатано.
Энергостоимость: 50 за фунт дополнительного объема если объекты входят в нагрузку, 100 если не входят.
Требования: Наложение чар, Создать Объект и Облегчение</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>50#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M61</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lighten</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Leak</name>
		<name-loc>Течь</name-loc>
		<description-loc>Наложение чар
Извращение заклинания Рог Изобилия (M64). Сумка, дамская сумочка, колчан, рюкзак любо другой контейнер зачарованный этим заклинанием будет необъяснимо терять предметы, положенные в него (монеты, стрелы, одежду и т.д.). Текущий кошелек будет терять монету или две в сутки, текущий колчан будет терять стрелу или две в день, текущий рюкзак время от времени будет терять что-то из снаряжения... Потерянные вещи могут «вываливаться» из контейнера, похватываться вороватыми магами или магически растворяться в воздухе (как подскажет ИМу его фантазия). Живые существа на затрагиваются.
Энергостоимость: 100
Требование: Скрытое пространство</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>100</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M61</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hideaway</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Simulacrum</name>
		<name-loc>Симулякрум</name-loc>
		<description-loc>Наложение чар
Создает голема, которые является точной копии определенной жертвы. Голем должен быть подготовлен под конкретную цель; это требует включения в процесс создания чего-либо от оригинального тела (волос, кровь и т. д.). В других отношениях, любой материал, подходящий для големов, подходит и для симулякруму. Необходимо использовать подходящее заклинание формовки либо бросок Художник (Скульптура) с -10 к уровню умения для достижения хорошего подобия, однако заклинатель но может не делать их самостоятельно. После создания симулякрум становиться идентичным с жертвой (включая такие детали, как цвет глаз и тон кожи), будучи таким образом вариацией всегда включенной Совершенной Иллюзорной Маскировки.
У симулякрума будет те же атрибуты, что и у базового голема. Големы для симулякрумов обычно проектируются с более высоким ИН(IQ), для усложнения обмана.
После активации симулякрум получает личность и знания персоны такими, какими воспринимает их заклинатель. Таким образом, симулякрум не может знать тех вещей, которые знает цель, если заклинатель их не знает. Бросок ИН(IQ) может потребоваться от заклинателя, если вдруг потребуется вспомнить что-нибудь этакое (в самом деле, а как звали его двоюродного дедушку?). Как и любой другой голем, симулякрум находится под прямым контролем заклинателя.
Время на создание тела: как для базового голема, плюс одна неделя работы.
Энергостоимость активации: в два раза больше, чем у базового голема.
Требования: Магичность(Magery) 3, Голем, Совершенная иллюзия, Иллюзорная маскировка</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>2xgolem</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent#</duration>
		<reference>M61</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">golem</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">perfect illusion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">illusion disguise</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Wish</name>
		<name-loc>Желание</name-loc>
		<description-loc>Наложение чар
Позволяет желающему изменить ближайшее прошлое. Оно позволяет изменить любой только что сделанный бросок — исключая броски для сотворения заклинаний — на значение, которое укажет желающий. Ограничения для Малого Желания также применябтся и для этого заклинания.
Энергостоимость: 250
Требования: Малое желание и как минимум по одному заклинания из 15 различных школ</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>250</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Special</duration>
		<reference>M61</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">15</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lesser wish</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bane</name>
		<name-loc>Погибель</name-loc>
		<description-loc>Наложение чар
Это заклинание так считается Ограничивающей чарой (M68). Оно используется для создания оружия с силой, которая действует только против противников определенного типа. Успешно наложенное перед любой атакующей чарой, оно уменьшает стоимость этих последующих чар, однако они будут работать только против указанного противника. Например, можно создать меч который дает +3 повреждений против орков, и это будет дешевле, чем сделать меч, который будет добавлять 3 повреждения кому угодно. Заметьте, Погибель может быть убрана только вместе с чарой, которую она контролирует.
Накладывать ограниченную чару должен тот же заклинатель, который сотворил Погибель. Чем более специфична (решение ИМ) погибель, тем большую скидку она даст. Погибели типа «Все мои враги» не разрешены! Пример правильных Погибелей:
Против определенной нации, религии или расы: разделить стоимость на 2.
Против определенного типа существ или жителей конкретного города: разделить стоимость на 3
Против членов определённой семьи: разделить стоимость на 4
Против одного конкретного врага: разделить стоимость на 10
Энергостоимость: 100. Заклинатель должен так же пожертвовать предмет или останки принадлежавшие персоне, существу расе и так далее.
Требование: Наложение чар</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>100</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M62</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Doppleganger</name>
		<name-loc>Двойник</name-loc>
		<description-loc>Наложение чар
Двойник — это дубликат персоны, созданный с помощью могущественной магии. Двойник должен быть сделан для определенной цели; необходимы и образец тела(волос, кровь) цели, и желанное личное имущество цели. Статуя оригинала должны быть сделана используя какой-либо «чистый» элементальный материал — чистый лед с горной вершины, камень или огонь из кратера вулкана и подобные. Похожесть должна быть достигнута с помощью подходящего заклинания формовки либо умения Художник (Скульптура) с -10.
У двойника будут те же атрибуты, умения и навыки что и у оригинала, за исключением магии. У него не будет Магичности и он не сможет сотворять заклинания. Он получает знания из внедренного объекта, так что он будет знать все, что можно узнать с помощью заклинания История. Двойник будет вести себя как оригинал, которого поработил создатель двойника. Приостановить проклятье парализует его, Снять проклятье разрушит. После разрушения заклинания, все что останется — это масса материала, использованного для создания (лужа воды, куча земли, вспышка огня) и личную вещь.
Очень сложно определить подделку. Если по суждению ИМ информационные заклинания не проваливаются автоматически при попытке определить копию, он должен позволить заклинанию двойника сопротивляться. Например оно будет сопротивляться заклинанию Чтение Ауры и преимуществу Эмпатии.
Время на создание тела: 6 недель  работы.
Энергостоимость активации: 1000
Требования: Магичность(Magery) 3, Голем, История и Порабощение</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>1000</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Perm#</duration>
		<reference>M62</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">golem</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enslave</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Wish</name>
		<name-loc>Великое желание</name-loc>
		<description-loc>Наложение чар
Это заклинание може делать практически все. В частности:
1. Оно может быть использовано для сотворения любого другого заклинания с нулевой энергостоимостью, автоматическим успехом, и без шанса на сопротивление (для заклинаний с варьирующейся стоимостью, максимальная энергия равна 1000). Заклинатель может не знать это заклинания  - он только должне знать о том, что такое заклинание существует. Если заклинание «продолжительное», ИМ должен решить насколько долго оно будет держаться.
Оно может навсегда увеличить очки персонажа. Оно может увеличить любой атрибут на 1 уровень или любое умение на 3 уровня. Оно так же может уменьшить очки персонажа врага, однако только в том случае, если враг присутствует при сотворении заклинания.
Оно может дать любое преимущество стоимость 20 очков или меньше либо убрать недостаток стоимостью 20 или меньше очков. Враг может быть проклят таким же образом, путем потери преимущества стоимость до 20 очков, или приобретении недостатка такой стоимости, но только в том случае, если он присутствует при активации желания. Враг не получает шанса на сопротивление!
Оно может делать абсолютно что угодно другое, что по мнению ИМ не разрушит кампанию полностью
Из-за своей невероятной мощи это заклинание нечасто используется. Оно никогда не может быть выучено на уровне больше 15. Более того, любой проваленный бросок при создании Великого Желания стоит заклинателю и каждому помощнику 1 очка ИН(IQ) и 6d повреждений! Критические провалы обрушивают цивилизации. Обычно Великое Желание нельзя купить, однако если все таки можно, его цена должна быть не меньше $100000.
Энергостоимость: 2000
Требования: Магичность(Magery) 3, Желание и сумма ЛВ(DX) и ИН(IQ) больше 30.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>2000</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Special</duration>
		<reference>M62</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" combined_with="dx" compare="at least">30</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">wish</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dancing Weapon</name>
		<name-loc>Танцующее оружие</name-loc>
		<description-loc>Наложение чар
Оружие зачарованное этим заклинанием сражается само по себе по команде владельца, вися в воздухе как будто в руках невидимого воина. У него будет умение 15, Базовая скорость 5 и СЛ(ST) (для расчета повреждений) равная Силе чары. Оно будет использовать разумную стратегию и следовать устным или ментальным командам хозяина атаковать определенного противника. Оно будет продолжать сражаться до тех пор, пока не будет остановлено (см. ниже) либо пока хозяин не умрет либо пока хозяин не прикажет прекратить. Это заклинание не работает с метательным оружием!
Любая атака танцующего оружия производится с пенальти: от -4 (алебарда) до -5 (меч или топор) до -6 (кинжал или пистолет). Если оружие получает критический провал или по нему попали критическим ударом, оно «оглушено» и выходит из боя (если он не ломается, в таком случае оно уничтожено). Если хозяин убит, оно падает на пол — однако если хозяин всего лишь без сознания, оно продолжает атаковать ближайшего противника. Так же можно поймать танцующее орудие в сеть или сумку (такой же бросок как и ударить его, однако ИМ может дать премию или штраф в зависимости от остроумности использованного метода).
Так же можно оставить оружие проинструктировав атаковать любого, кто подойдет на определенное расстояние; можно использовать Связь для активации его только в определенных условиях. Будучи однажды активированными и если владельца нет на месте, оно будет атаковать всех в диапазоне, ближайшего — первым, если Связь не запрограммирована иначе.
Активированное танцующее оружие не может сменить владельца; просто схватить за рукоять недостаточно для того, чтобы заставить его сменить сторону.
Энергостоимость: 1000 за фунт веса оружия (минимум один фунт). Удвойте стоимость чтобы получить оружие с базовой скоростью 6 или умением 18. Умножьте стоимость на 4 для получения обоих улучшений.
Требования: Наложение чар и Танцующий Объект</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>1000/lb#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M63</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dancing object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Graceful Weapon</name>
		<name-loc>Изящное оружие</name-loc>
		<description-loc>Наложение чар
Эта чара — упрощенная версия Быстрого выхватывания (ниже). Оружие на становится неготовым после атаки или парирования, даже при критическом промахе. Если Изящное оружие встречается с заклинаниями Повернуть Клинок или Отворот Клинков, оно сопротивляется по свое Силе.
Энергостоимость: 150 за фунт веса (минимум 1 фунт)
Требования: Наложение чар и Перемещение
Предмет: может быть сотворено на любой тип инструмента, не только на оружие.</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>150/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M63</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Loyal Sword</name>
		<name-loc>Верный меч</name-loc>
		<description-loc>Наложение чар
Целевое оружие пытается вернуться в руку к владельцу, если было уронено или брошено — даже если тот не способен после этого сражаться. Если его уронить, оно вернется на следующих ход, как будто бы было быстро выхвачено (ниже). Если его бросить, оно летит до тех пор, пока не попадет в кого-либо или не упадет на землю, после чего возвращается настолько прямо, насколько возможно, со скоростью 12. Оно избегает врагов и препятствия во время возвращения! Если владелец умирает, оно возвращается к телу, но после этого становится верным тому, кто первый его подберет.
Верное оружие может быть поймано, перехвачено в воздухе и т. д. во время возвращения, но для этого требуется бросок ЛВ(DX)-4, и оно в любом случае будет пытаться вернуться к владельцу, давая любому другом -4 к попыткам драться с помощью него.
Верное оружие может быть продано или отдано в любое время, но подобный обмен должен быть полностью добровольным; после этого, оружие становится верным новому владельцу. У него может быть только один владелец в каждый  момент времени. Можно использовать ограничивающие чары, для ограничения типа людей, которые могут использовать это оружие.
Заметьте, что использование этого заклинания вместе с Танцующим оружием, делает Танцующее оружие почти бесполезным. Получится Верное оружие, которое бьет врагов во время возвращения (но не в другое время)
Энергостоимость: 750 за фунт веса оружия (минимум 1 фунт)
Требования: Наложение чар и Перемещение
Предмет: может быть сотворено на лбой тип инструмента, не только на оружие</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>750/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M63</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Penetrating Weapon</name>
		<name-loc>Проникающее оружие</name-loc>
		<description-loc>Наложение чар
Режущее, проникающее или пробивающее оружие с этой чарой проходит сквозь броню как сквозь масло. Технически, это заклинание дает оружию делитель брони (B268). Такое оружие на наносит дополнительное повреждение по небронированным врагам. Укрепленный СП(DR) защищает против делителя брони от данного заклинания как обычно.
Энергостоимость: зависит от делителя брони, получаемого оружием:
Делитель брони
Энергостоимость
2   | 250
3   | 750
5   | 2500
10  | 7500
Игнорирует СП(DR)  | 25000
Удвойте стоимость, если объектом является метающее оружие (например лук). Разделите стоимость на 10, если объект — это снаряд (например стрела). Если предмет попадает под несколько категорий (оружие, метающее оружие, снаряд), используйте наивысшее значение стоимости. В дополнение к оружию, любой режущий инструмент может быть зачарован этим заклинанием. Заметьте, что это заклинание может быть пересотворено на большем уровне, как и Точность.
Требования: Наложение чар и Найти Уязвимость</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M63</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">find weakness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Quick-Draw</name>
		<name-loc>Быстрое выхватывание</name-loc>
		<description-loc>Наложение чар
Оружие вскакивает в руку владельца когда он того хочет и мгновенно становиться готовым (не требуется маневра подготовки!). Нужна только ментальная команда владельца, не требуется никаких бросков кубиков.
Чара не будет работать, если оружие более чем в ярде от владельца либо если он связан, соблюдается общественный порядок (оружие привязано к ножнам проволокой или веревкой), в рюкзаке и т. д. Оружие с этим заклинанием не становится неготовым после атаки или парирования. (B382)
Энергостоимость: 300 за фунт веса (минимум 1 фунт); 2000 за колчан, сумку и т. д. Из которых обычные снаряды будут прыгать в руку владельца по мере необходимости.
Требования: Наложение чар и Перемещение
Предмет: может быт сотворено на любой тип инструмента — не только на оружие.</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>300/lb #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M63</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cornucopia</name>
		<name-loc>Рог изобилия</name-loc>
		<description-loc>Наложение чар
Дает колчан, мешочек пуль или другой контейнер боеприпасов с бесконечным запасом одного типа боеприпасов — но при это он должны доставаться вручную, по одной штуке за раз. Каждый снаряд существует одну минуту после извлечения из контейнера; потом он исчезает (или, если бы поднят кем-то кроме владельца контейнера, исчезает немедленно). Таким образом, это заклинание нельзя использовать для создание одного колчана, которого хватит  для целой армии. Так же оно не может быть сотворено на оружие. Маги из высокотехнологичных миров могут создать карман, в котором всегда есть один бронебойный трассирующий патрон; они не могут зачаровать пулемет, что бы тот стрелял постоянно.
Энергостоимость: это заклинание коварно. Потому что умелые игроки найдут кучу способов неправильного использования предмета. Если ИМ найдет это заклинание надоедливым, он может запретить это заклинание полностью. В общем: энергостоимость равна стоимости в $ боеприпаса, создаваемого рогом изобилия в текущем игровом мире умноженной на 50. Таким образом, колчан производящий обычные стрелы (2$ каждая) будет стоить 100 единиц энергии.
Это так же означает, что маги из средневекового мира не могут создать «колчан» для высокотехнологичных боеприпасов: в их мире они ничего не стоят. Колчан с Рогом избилия можно сделать для производства магических стрел — но только если этот конкретный маг может делать такие стрелы  - и энергостоимость будет огромной.
Требования: Наложение чар и 2 других заклинания зачарования оружия.</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>50x$ value#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M64</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">weapon enchantment</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Defending Weapon</name>
		<name-loc>Защищающее оружие</name-loc>
		<description-loc>Наложение чар
Оружие — объект этого заклинания позволяет владельцу парировать более эффективно; каждый уровень чары дает +1 к парированию, вплоть до максимума в +3. Заклинание не защищает само оружие от поломки (с B401).
Если эта чара скомбинирована с Танцующим Оружием, оружие сражается вместе с владельцем и по мере возможности отслеживает удары от атакующих. При этом оно использует оружейный навык как при Танцующем оружии плюс бонус от этого заклинания. Владелец может скомандовать ему защищать определенную его сторону (очень похоже на Танцующий щит) и либо защищаться (в этом случае оно получает два парирования в ход) либо атаковать (в этом случае оно получает одну атаку и одну защиту в ход). Если танцующее оружие не смогло спарировать удар, владелец все еще может использовать одну из своих активных защит.
Это заклинание может быть сотворено только на сбалансированное оружие, которым обычно можно парировать.
Энергостоимость: 500 за +1 к парированию, 1000 за +2 и 2000 за +3. Заклинание может быть пересотворено на более высоком уровне как и Точность.
Требоваия: Наложение чар и Танцующий объект

Дух Оружия</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M64</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dancing object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Weapon Spirit</name>
		<name-loc>Дух Оружия</name-loc>
		<description-loc>Перемещает личность и некоторую разумность недавно скончавшегося существа (гуманоидного или нет — собаки популярные объекты) в оружие, обычно меч. Наложение чар получает -1 за каждый полный день прошедший со смерти донора и началом зачарования. Большая часть тела должна присутствовать перед началом зачарования, однако может быть убрана после начала.
Маг может вложить в предмет столько донорского ИН(IQ), сколько захочет, так же как и некоторые умения, преимущества и недостатки. Оружие не будет помнить о существовании в другой форме. Не смотря на то, что у оружия нет органов чувств, оно может видеть и слышать (восп 10). Причуды (или недостатки, уменьшенные до уровня причуд) иногда предаются оружию независимо от желания заклинателя (именно поэтому популярны собаки; их личности способствуют созданию привязчивого но эффективного оружия).
Оружие может общаться с владельцем с помощью очень простой эмпатии. Когда владелец делает что-нибудь, что одобряется оружием, у него возникает «хорошее чувство», и если он делает что-то, что оружию не нравится, у него возникает такое же «плохое чувство». Оружие можно зачаровать заклинанием Голоса что бы дать ему голос. Так же можно использовать различные зачарования Общения и Понимания для улучшения общения.
Каждый раз, когда оружие получает новго владельца, оно должно сделать бросок реакции, который задаст тон общения нового хозяина с этим оружием. При очень хорошей реакции сделает буквально все для своего владельца; при очень плохой — оно откажется общаться или сотрудничать любым способом. ИМ должен записать результат. Оружие нельзя заставить сделать еще один бросок реакции путем отдавания его другому персонажу и забирания обратно!
Умения оружия не могут быть улучшены, но несмотря на это, умения, такие как История или Знание Местности оставаться на том же уровне за счет поступления новых знаний.
Энергостоимость: 100 за каждое переданное очко ИН(IQ), плюс очки умений умноженные на 25, плюс очки всех достоинств и недостатков умноженные на 50 (минимум 0). добавьте 300 для Голосов.
Требования: Наложение чар и Вызов Духа</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M64</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Accuracy</name>
		<name-loc>Точность</name-loc>
		<description-loc>Делает оружие более часто попадающим добавляя к эффективному умению пользователя.
Энергостоимость: см. таблицу ниже. Разделите стоимость на 10 если объектом является снаряд (стрела или пуля)
Премия
Стоимость
+1 | 250
+2 | 1000
+3 | 5000
Требования: Наложение чар и как минимум 5 заклинаний школы Воздуха
Примечание: Если оружие уже зачаровано этим заклинанием на низком уровне, заклинатель может пересотворить заклинание на более высоком уровне (сделав оружие более точным). Стоимость нового заклинания будет равна разнице стоимости уровней; «старое» заклинание не сопротивляется «новому».</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M65</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ghost Weapon</name>
		<name-loc>Призрачное оружие</name-loc>
		<description-loc>Наложение чар
Оружие зачарованное этим заклинанием может поражать призраков (и других нереальных сущностей и духов) как будто они материальны. Если оружие само сделано нематериальным (конечно если ИМ считает это возможным), оно будет воздействовать на физический мир по прихоти владельца.
Энергостоимость: 250 за фунт веса (минимум 1 фунт)
Требования: Наложение чар и Уплотнить
При очень хорошей реакции оружие сделает буквально все для своего владельца; при очень плохой оно откажется общаться и сотрудничать любым способом.</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>250/lb #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M65</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">solidify</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Puissance</name>
		<name-loc>Усиление</name-loc>
		<description-loc>Наложение чар
Добавляет к базовому повреждению оружия, когда оно попадает в цель.
Стоимость: См. Таблицу ниже. Разделите стоимость на 10, если объект является снарядом (т. е. Стрела или пуля). Удвойте стоимость, если объект — метательное оружие (т. е. Лук или пистолет)
Премия к повреждениям
Стоимость
+1 | 250
+2 | 1000
+3 | 5000
Может быть пересотворено на более выском уровне как и Точность (M65)
Требования: Наложение чар и как минимум 5 заклинаний земли</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M65</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Quick-Aim</name>
		<name-loc>Быстрое прицеливание</name-loc>
		<description-loc>Наложение чар
Зачарованное холодное дальнобойное оружие (лук, праща и т. д.) приобретает сверхъестественную отзывчивость; в игровых терминах односекундный маневр Прицеливания с этим оружием дает эффект двухсекундного прицеливания.
Энергостоимость: 100. За 200 энергии одна секунда прицеливания может считаться тремя. Уполовиньте стоимость если оружие метательное (метательное копье или топор). Зачарование не работает на боеприпасы (такие как стрелы). Заклинание может быть пересотворено на более высоком уровне как Точность.
Требования: Наложение чар и Изящество</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M65</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spell Arrow</name>
		<name-loc>Стрела заклинания</name-loc>
		<description-loc>Наложение чар
Как и Камень Заклинаний, стрела заклинания содержит в себе заклинание до тех пор, пока ее не выстрелят. Лучник может не быть магом. Пользователь должен концентрироваться такое же время, какое требуется для обычного сотворения данного заклинания, для того чтобы активировать «зарядить» заклинание. Это нельзя делать одновременно с прицеливанием и время не уменьшается в результате высокого уровня умения (но см. Ускоренная стрела заклинания, ниже). Неиспользованная стрела заклинаний разряжается через минуту. Заклинание активируется, когда стрела попадает в твердый объект; бросьте против эффективного уровня умения мага, зачаровавшего стрелу. Если бросок успешен, заклинание сотворено. Если произошел обычный провал, заклинание просто потеряно. Критический провал определяется по таблице критических провалов (M7). Если стрела была выпущена без  необходимой концентрации, заклинание теряется, но стрела наносит обычные повреждения.
Энергия заклинание вложена в чару. Лучник не дожен (и не может) нечего передавать дл сотворения или поддержания его. Так же, лучник не сможет прервать сотворенное заклинание, так что маг, наложивший чару, может указать длительность короче, чем обычно или вложить больше энергии для автоматического поддержания заклинания.
Наконечник стрелы должен содержать драгоценный камень стоимостью не меньше чем $10xP^2 + $40xP, где P — максимальное количество энергии которое можно вложить в заклинание на стреле. Драгоценность уничтожается при активации заклинания. (Остальную часть стрелы можно восстановить, однако она уже не будет магической).
В стрелу можно встроить любое заклинание, которое позволяет создание магического предмета, исключая Блокирующие заклинания, Наложение Чар и Рукопашных заклинаний или тех, в описании которых написано «должен коснуться». Заметьте, некоторые разрешенные заклинания бесполезны (например Успокоить Зверя), так как лучник в любом случае должен поразить объект стрелой любым способом. Чары на саму стрелу можно накладывать как обычно, включая ограничивающие чары.
От лучника зависит только то, куда попадет стрела. Если для заклинания требуется объект, объектом считается то, во что попала стрела (если это неправильный объект, например деревянная стена для Поражения слепотой — заклинание просто теряется). Возможно потребуется суждение ИМ для того, что считать «твердым объектом» (например капель дождя недостаточно для активации заклинания). Если это площадное заклинание, точка касания является центром области. Если это метательное заклинание, эффект появляется как будто оно поразило цель сразу же после стрелы (заклинание не запускает себя из точки касания). Если заклинание создает объект, он появляется настолько близко от точки касания, насколько это возможно. Если заклинание обычно воздействует не только на объект, но и на заклинателя (например Контроль Животного), лучник считается заклинателем. Если заклинание должно быть сотворено на гуманоида, оно будет работать даже если стрела застряла в одежде не добравшись до кожи. Заклинатель определяет все остальное: длительность, площадь, точный эффект и т. д.
С помощью Анализа магии можно выяснить какое заклинание содержится в стреле, сколько энергии вложено, и так далее, по одному вопросу за сотворение. Стрелы предназначенные для продажи обычно помечают цветом.
Энергостоимость сотворения: в 30 раз больше чем требуется для содержащегося заклинания, включая стоимость поддержки если необходимо, если сотворяется на что-то длиной со стрелу или арбалетный болт.
ИМ может решить, что это заклинание работоспособно на других типах снарядов (например пулях). Если так, умножьте стоимость содержащегося заклинания на 1/10 Максимальной дистанции снаряда вместо 30ти. Если пуля должна будет полететь дальше (например при выстреле из более мощного оружия) заклинание теряется. (Эти правила по потерям не касаются стрел и болтов). Помните, что требования по драгоценности так же применяются и для пуль!
Требование: Камень заклинаний</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>30xspell cost</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M65</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spell stone</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Blank Spell Arrow</name>
		<name-loc>Пустая стрела заклинаний</name-loc>
		<description-loc>Наложение чар
Эта чара создает стрелу заклинания бещ заклинания внутри. Вместо этого, любой заклинатель может позже поместить заклинание в стрелу и использовать ее как обычную стрелу заклинания.
У пустых стрел заклинаний есть емкость, которая показывает сколько энергии заклинаний они могут вместить. Когда заклинатель желает использовать стрелу, он сотворяет заклинание как обычно, но направляет его в стрелу. Если заклинание слишком большое, оно просто теряется. После заполнения стрела должна быть использована в течение суток заклинателем или кем-нибудь еще иначе заклинание безвредно рассеется, оставив стрелу снова пустой.
Все остальные правила по стрелам заклинаний применяются так же и к пустым стрелам заклинаний с одним исключением: если заклинатель сотворивший заклинание в стреле так является лучником ее выстрелившим, он может определить эффект во время выстрела и поддерживать его как обычно. (Он не может вложить больше или меньше энергии для сотворения заклинания во время выстрела; вся энергия на сотворение должна содержаться в стреле.)
Энергостоимость: в 30 раз больше нужной емкости. Все правила для снарядов, не являющимися стрелами, так же применяются к Пустым стрелам заклинаний.
Требование: Стрела заклинаний</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>30xcapacity#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M66</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spell arrow</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fortify</name>
		<name-loc>Укрепить</name-loc>
		<description-loc>Наложение чар
Увеличивает СП(DR) одежды или доспеха
Энергостоимость: см. таблицу ниже
Премия к СП(DR)
Стоимость
1 | 50
2 | 200
3 | 800
4 | 3000
5 | 8000
Это заклинание может быть пересотворено на более выском уровне как и Точность (M65)
Требование: Наложение чар</description-loc>
		<college>Armor Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M66</reference>
		<categories>
			<category>Armor Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Speed Spell Arrow</name>
		<name-loc>Ускоренная стрела заклинания</name-loc>
		<description-loc>Наложение чар
Это заклинание можно сотворить только на снаряды, зачарованные Стрелой заклинания. Как и чара Скорость, оно уменьшает время, которое должен потратить лучник на концентрацию для активации заклинания на стреле. Каждый уровень Ускоренной стрелы заклинания уменьшает время на концентрацию в два раза. Если время становится меньше секунды, концентрация не требуется.
Стоимость: см. таблицу ниже
Скорость
Стоимость
1 | 50
2 | 100
3 | 200
Удвойте стоимость за каждый дополнительное очко. Можно пересотворять на более высоком уровне как и Точность (M65).
Требования: Скорость, Стрела заклинания</description-loc>
		<college>Weapon Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M66</reference>
		<categories>
			<category>Weapon Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spell arrow</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">speed</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dancing Shield</name>
		<name-loc>Танцующий щит</name-loc>
		<description-loc>Наложение чар
Щит зачарованный этим заклинанием защищает своего владельца так, как будто одет невидимым щитовиком. У щита будет умение 16, Базовая Скорость 5 и СЛ(ST) равная Силе чары (для расчета толчков). Он подчиняется  мысленным или устным командам владельца, что бы выбрать с какой стороны защищать. Если владелец без сознания, щит продолжает защищать его так хорошо, как только может. Если же владелец умирает, щит падает на землю.
Щит может отразить две атаки за ход, независимо от действий владельца (так, владелец может парировать любой удар направленный в щит, например). Можно проинструктировать щит ударить противника (B406), в этом случае владелец лишается его защиты до начала его следующего хода (щит не будет перемещаться на расстояние более двух ярдов от владельца чтобы совершить удар).
Щит можно атаковать со штрафом равным его ПЗ(DB)-4. Щит при этом защищается либо Блокированием (используя Щит/2) или Уклонением (используя Скорость); он не получем никаких премий ПЗ(DB) от себя самого. Так же щит можно поймать сетью или мешком (с помощью стандартного броска атаки). В случае если шит совершает критический провал или получает критический удар, он «оглушается» и находится вне боя до тех пор, пока владелец не поднимет его и не «разбудит» (маневр Подготовки). При уничтожении щит теряет магию; будучи пробитым проникающим или пробивающим ударом, он теряет по одному очку Силы, умения Щит и Базовой Скорости. Как обычно, если его Сила падает ниже 15, предмет перестаёт работать.
Энергостоимость: 250 за фунт веса щита (минимум 1 фунт). Удвойте стоимость для того, чтобы получить щит с Базовой Скоростью 6 или умением 18. Учетверите для получения обоих улучшений. Это заклинание может быть пересотворено на более высоком уровне как и Точность (M65), как для улучшения так и для ремнота щита.
Требования: Танцующий объект и  Наложение чар</description-loc>
		<college>Armor Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>250/lb#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M67</reference>
		<categories>
			<category>Armor Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dancing object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Defending Shield</name>
		<name-loc>Защищающий щит</name-loc>
		<description-loc>Наложение чар
Эта чара позволяет пользователю блокировать более умело; каждый уровень заклинания дает обладателю +1 к Блокированию, вплоть до максимума +3. Это заклинание нельзя комбинировать с Танцующим щитом
Энергостоимость: см. таблицу ниже
Премия к блокированию
Стоимость
+1 | 500
+2 | 1000
+3 | 2000 
Это заклинание может быть пересотворено на более высоком уровне как и Точность (M65)
Требования: Наложение чар и Изящество</description-loc>
		<college>Armor Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M67</reference>
		<categories>
			<category>Armor Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">grace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Deflect</name>
		<name-loc>Отражение</name-loc>
		<description-loc>Наложение чар
Добавляет ПЗ(DB) к броне, одежде, щиту или оружию. Оно добавляется ко всем броскам активной защиты, которые делает пользователь.
Стоимость: см. таблицу ниже
ПЗ(DB)
Стоимость
1 | 100
2 | 500
3 | 2000
4 | 8000
5 | 20000
Это заклинание может быть пересотворено для усиления, как и Точность (M65)
Требование: Наложение чар</description-loc>
		<college>Armor Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M67</reference>
		<categories>
			<category>Armor Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lighten</name>
		<name-loc>Облегчение</name-loc>
		<description-loc>Наложение чар
Делает броню или щит легче и проще для ношения. Объект становится легче только когда одевается. Броня в рюкзаке будет весить свой полный вес.
Энергостоимость: 100 за уменьшение веса на 25%, 500 за уменьшение в два раза.
Требование: Наложение чар</description-loc>
		<college>Armor Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M67</reference>
		<categories>
			<category>Armor Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Limit</name>
		<name-loc>Допуск</name-loc>
		<description-loc>Наложение чар
Зачарованный предмет работает только для пользователя или группы пользователей определенной заклинателем во время сотворения заклинания. Эта группа может быть простой или сложной в зависимости от желания заклинателя. Допуск может затрагивать как все чары на предмете или только некоторые из них.
Энергостоимость: 200
Требование: Наложение чар</description-loc>
		<college>Limiting Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>200</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M68</reference>
		<categories>
			<category>Limiting Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Name</name>
		<name-loc>Имя</name-loc>
		<description-loc>Наложение чар
Дает магическое имя зачарованному объекту. Магия на объекте будет работать только для того, кто знает его имя. Пользователь должен произнести имя объекта при первом использовании чтобы показать, что он знает его имя.
Энергостоимость: 400, или 200 если имя написано на объекте. Оно должно быть читаемым (решение ИМ). Оно может быть маленьким, скрытым или даже замаскированным, но когда кто-то будет рассматривать объект, он должен иметь возможность его увидеть. По этой причине так популярны среди магов мертвые и редкие языки: написание имени на таком вымершем  языке почти также надёжно как и не написание его вовсе, однако намного дешевле.
Требование: Наложение чар</description-loc>
		<college>Limiting Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>200 or 400#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M68</reference>
		<categories>
			<category>Limiting Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Password</name>
		<name-loc>Пароль</name-loc>
		<description-loc>Наложение чар
Обратная имени чара. Магический предмет с Паролем работает до тех пор, пока не будет произнесен пароль. Если пароль произнесен, предмет будет инертным до тех пор пока его сила не будет вызвана обычным образом — или минуту (выбор того, кто создает предмет). На предмете могут быть как запароленные заклинания так и не запароленные. Детали, конечно, зависят от заклинания.
Примеры: (а) магическое кольцо которое силу полета — но еакладывает на обладателя Приостнановить Жизнь если не использован пароль;
(б) Пентаграмма которая можыт быть «выключена» словом; (в) Танцующий меч, который перестает размахиваться на минуту, если сказан пароль.
Энергостоимость: 400. Уполовиньте стоимость, если пароль написан на предмете (должен быть читаем).
Требование: Наложение чар</description-loc>
		<college>Limiting Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>400#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M68</reference>
		<categories>
			<category>Limiting Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Attune</name>
		<name-loc>Специализация</name-loc>
		<description-loc>Наложение чар
Эта ограничивающая чара, производная от Погибели, делает магический предмет более эффективным против определенной цели. Она помогает любому Сопротивляемому заклинанию, создавая штраф к броску сопротивления жертвы. Если накладывается перед контролируемым заклинанием, то оно становиться вдвое дешевле.
У заклинателя должно быть что-нибудь связанное с целью. Точность сиволического представления определяет штраф к броску сопротивления.
В любом случае, представление должно быть встроено в магический предмет, но не должно оставаться целым (т.о. Видеопленку можно раздавить в порошок). Если цель присутствует, то вероятно она либо введена в заблуждение по поводу зачарования или согласилась на зачарование из каких-либо сложных причин (например, если боится впасть в амок в будущем).
Недостаток этой чары в том, что все остальные цели получают бонус +5 для к броску сопротивления. Специализацию нельзя убрать с предмета до тех пор, пока не будут убраны чара или чары которые она контролирует.
Энергостоимость: 100.
Требование: Погибель
Символическое представление
Штраф
Минимальное (рисунок) -2
Небольшая вещь/часть одежды -4
Кусочки волос или ногтей -5
Фоторграфия или образец крови -6
Образец ДНК или видео -7
Цель присутствует при зачаровании -8</description-loc>
		<college>Limiting Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>100</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M69</reference>
		<categories>
			<category>Limiting Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">bane</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Powerstone</name>
		<name-loc>Энергокамень</name-loc>
		<description-loc>Наложение чар
Вливает ману в объект для последующего использования магом. Традиционным объектом этого заклинания являются драгоценные камни (именно из-за этого «Энергокамень» - это общее слово для объектов содержащих в себе ману), но в принципе можно использовать любой предмет. Любой маг, прикоснувшись к энергокамню, может использовать любое количество или всю энергию из него для сотворения заклинания вместо энергии из своего тела.
У каждого энергокамня есть «емкость». Это максимальное количество энергии которое он может содержать. Так как маг может использовать только один энергокамень за раз, то большой большой энергокамень полезнее чем пригоршня маленьких. Большой энергокамень можно использовать для сотворения большого заклинания; с помощью нескольких маленьких можно использовать по одному для поддержания заклинания, однако их нельзя использовать все за один раз.
Энергокамни перезаряжаются после использования, поглощая ману из окружающей среды. Скорость перезарядки зависит от уровня маны в данной местности:
Локальный уровень маны
Скорость перезарядки
Нет Нет
Низкий 1 очко в неделю
Нормальный 1 очко в день
Высокий 1 очко в 12 часов
Очень высокий 1 очко в 6 часов
Энергокамень не перезаряжается, если находится ближе чем шесть футов от большего энергокамня. Камни одинакового размера делят доступную ману и перезаряжаются медленнее. Этот прискорбный факт означает, что владелец нескольких энергокамней должен оставлять их вне своего поля зрения для перезарядки.
Энергокамень зачаровывается на один шаг за раз. Когда заклиание Жнергокамень сотворяется в первый раз, на выходе получается незаряженный энергокамень емкостью 1. Каждое последующее сотворение заклинания увеличивает его емкость еще на 1. Таким образом 15 сотворений создаст энергокамень емкостью 15. Но учтите, что при увеличения количества сотворений растет шанс критического провала. Для 15 это будет уже шанс 1 из 4 того, что выпадет критический провал и уничтожит камень. Для 60 успешных сотворений этот шанс будет уже 2 из 3!
Далее, каждый обычный провал накладывает на камень некоторую магическую «причуду». Таким образом, можно работать месяцами ио получить на выходе камень на 20 энергии который воняет рыбой и который можно использовать только по средам... Из-за этого большие камни без особыз недостатков дороже чем другие с такой же силой. Причуды энергокамней устанавливаются ИМ и их можно использоваться как инструмент для балансировки кампании. Большинство из них будут необычными, произвольными ограничениями того, как энекгокамень перезаряжается (например, только в ванночке с кровью летучих мышей) или того, как камень может быть использован (например только для заклинаний огня; только зеленоглазой девственницей; никем в шляпе). Тяжелые причуды затрагивают пользователя камня (например, делая его немым на час после использования)
Заклинатель знает когда его заклинание не удалось, но не знает какую именно причуду получил камень. Это можно определить с помощью Анализа Магии. Два провала подряд означают что данный камень нельзя больше увеличивать.
Энергокамень можно сделать из любого объекта. Тем не менее, намного проще зачаровать объект соответствующей стоимости. Энергетическая стоимость Энергокамня   учетверяется если зачаровываемый предмет дешевле чем $10*P^2 + $40*P, где P — целевая емкость камня. Это одна из причин популярности драгоценностей: дорогой камень компактен и долговечен.
Энергокамень не заряжен сразу после создания (если он уже содержит энергию, эта энергия не затрагивается заклинанием для увеличения емкости). Энергию из Энергокамня нельзя использовать для зачарования этого же камня — Энергокамень не может помочь зачаровать себя самого!
Энергостоимость каждого зачарования: 20.
Требование: Наложение чар

«Выделенные» Энергокамни
Если Энергокамень встраивается в предмет перед зачарованием этого предмета, он становится частью магической вещи. Теперь это «выделенный» энергокамень. Использующий вещь, может забирать энергию из него — но только для сотворения заклинаний с помощью или через этот предмет.
Если убрать выделенный энергокамень из предмета, он автоматически сломан и теряет чары, но сам камень остается целым и снова становится «обычным» энергокамнем. (Конечно, если энергокамень встроен в предмет каким-либо способом — например часть магического кольца — может потребоваться успешный бросок умения что бы вытащив не повредить его).
Преимущество выделенного энергокамня в том, что его энергия, будучи специально направлена, используется вдвое эффективнее. Одноочковый энергокамень  дает две единицы энергии (но все еще перезаряжается по одной в день в области нормальной маны).

«Эксклюзивные» Энергокамни
Можно сделать предмет с энергокамнями так, что только встроенные энергокамни могут питать его. Это делается точно так же как и для выделенных энергокамней, но энегия этих камней в три раза эффективнее — то есть одноочковый эксклюзивный энергокамень дает 3 очка энергии, но предмет бесполезен до тех пор пока камень не перезарядится.
Энергокамни одной школы
Эта вариация следующая обычным правилам Энергокамней. Энергокамень одной школы зачарован таким образом, что может давать энергию только для заклинаний одной конкретной школы. Такие энергокамни нельзя делать выделенными или эксклюзивными.
Преимущество энергокамней одной школы в том, что для каждого зачарования требуется тольк 12 едеиниц энергии, а не 20.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M69</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Homunculus</name>
		<name-loc>Гомункулус</name-loc>
		<description-loc>Наложение чар
Выращивает миниатюрное копию из вашей плоти.У этой копии, называемой гомункулусом, будет СЛ(ST) 1, ЛВ(DX) 0 и не будет ИН(IQ) или ЗД(HT). Ее необходимо держать в стеклянной бутылке и кормить не менее 1 ЕЖ(HP) человеческой крови каждый день для поддержания жизни. Если бутылку разбить или подвергнуть сильному свету или теплу, гомункулус умрет.
В любое время по своему желанию маг может переместить свой дух в гомункулус, независимо от того, насколько он далеко (как при Вселении, M49), за 4 энергии в первую минуту и по 2 за каждую последующую. Он может наблюдать и общаться со всеми, кто находится в присутствии гомункулуса. Так же заклинатель может сотворять заклинания через гомункулуса (использую свою собственную энергию) и не может совершить никаких физических действий, так как гомункулус пойман в бутылку. Заклинатель может вернуться в свое собственное тело по желанию.
Если враждебный маг получит в свои руки живого гомункулуса, он сможет сотворять заклинания школы Общения и Понимания на создателя гомункулуса без штрафов за расстояние! Более того, создатель сопротивляется этим заклинаниям с -5 если они сотворены через гомункулуса. Гомункулус таким образом является большой уязвимостью и доверяется только наиболее преданным слугам.
У заклинателя может быть несколько гомункулусов; он может перемещать свой дух только в одного за раз. Пока он «отсутсвтует» его тело очень уязвимо и должно охраняться.
Энергостоимость: 800
Требования: Магичность(Magery) 2 и Отправка мыслей</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>800</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M70</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mind-sending</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Manastone</name>
		<name-loc>Камень маны</name-loc>
		<description-loc>Наложение чар
Камень маны — это неперезаряжаемый энергокамень.
Используйте все правила по энегокамням (ограничение по стоимости и т.д.), за исключением того, что Камень маны не восстанавливает свою энергию — но может быть перезаряжен этим заклинанием. Если камень маны получает причуду во время создания, эта причуда должна быть приемлемой для неперезаряжаемого объекта (никаких причуд связанных с перезарядкой!). Камни маны не оказывают никакого эффекта на скорость перезарядки близлежащих энергокамней.
Энегостоимость: 5. Каждое сотворение заряжает камень один очком энергии.
Требование: наложение чар</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Indefinite</duration>
		<reference>M70</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>One-College Powerstone</name>
		<name-loc>Энергокамень</name-loc>
		<description-loc>Наложение чар
Вливает ману в объект для последующего использования магом. Традиционным объектом этого заклинания являются драгоценные камни (именно из-за этого «Энергокамень» - это общее слово для объектов содержащих в себе ману), но в принципе можно использовать любой предмет. Любой маг, прикоснувшись к энергокамню, может использовать любое количество или всю энергию из него для сотворения заклинания вместо энергии из своего тела.
У каждого энергокамня есть «емкость». Это максимальное количество энергии которое он может содержать. Так как маг может использовать только один энергокамень за раз, то большой большой энергокамень полезнее чем пригоршня маленьких. Большой энергокамень можно использовать для сотворения большого заклинания; с помощью нескольких маленьких можно использовать по одному для поддержания заклинания, однако их нельзя использовать все за один раз.
Энергокамни перезаряжаются после использования, поглощая ману из окружающей среды. Скорость перезарядки зависит от уровня маны в данной местности:
Локальный уровень маны
Скорость перезарядки
Нет Нет
Низкий 1 очко в неделю
Нормальный 1 очко в день
Высокий 1 очко в 12 часов
Очень высокий 1 очко в 6 часов
Энергокамень не перезаряжается, если находится ближе чем шесть футов от большего энергокамня. Камни одинакового размера делят доступную ману и перезаряжаются медленнее. Этот прискорбный факт означает, что владелец нескольких энергокамней должен оставлять их вне своего поля зрения для перезарядки.
Энергокамень зачаровывается на один шаг за раз. Когда заклиание Жнергокамень сотворяется в первый раз, на выходе получается незаряженный энергокамень емкостью 1. Каждое последующее сотворение заклинания увеличивает его емкость еще на 1. Таким образом 15 сотворений создаст энергокамень емкостью 15. Но учтите, что при увеличения количества сотворений растет шанс критического провала. Для 15 это будет уже шанс 1 из 4 того, что выпадет критический провал и уничтожит камень. Для 60 успешных сотворений этот шанс будет уже 2 из 3!
Далее, каждый обычный провал накладывает на камень некоторую магическую «причуду». Таким образом, можно работать месяцами ио получить на выходе камень на 20 энергии который воняет рыбой и который можно использовать только по средам... Из-за этого большие камни без особыз недостатков дороже чем другие с такой же силой. Причуды энергокамней устанавливаются ИМ и их можно использоваться как инструмент для балансировки кампании. Большинство из них будут необычными, произвольными ограничениями того, как энекгокамень перезаряжается (например, только в ванночке с кровью летучих мышей) или того, как камень может быть использован (например только для заклинаний огня; только зеленоглазой девственницей; никем в шляпе). Тяжелые причуды затрагивают пользователя камня (например, делая его немым на час после использования)
Заклинатель знает когда его заклинание не удалось, но не знает какую именно причуду получил камень. Это можно определить с помощью Анализа Магии. Два провала подряд означают что данный камень нельзя больше увеличивать.
Энергокамень можно сделать из любого объекта. Тем не менее, намного проще зачаровать объект соответствующей стоимости. Энергетическая стоимость Энергокамня   учетверяется если зачаровываемый предмет дешевле чем $10*P^2 + $40*P, где P — целевая емкость камня. Это одна из причин популярности драгоценностей: дорогой камень компактен и долговечен.
Энергокамень не заряжен сразу после создания (если он уже содержит энергию, эта энергия не затрагивается заклинанием для увеличения емкости). Энергию из Энергокамня нельзя использовать для зачарования этого же камня — Энергокамень не может помочь зачаровать себя самого!
Энергостоимость каждого зачарования: 20.
Требование: Наложение чар

«Выделенные» Энергокамни
Если Энергокамень встраивается в предмет перед зачарованием этого предмета, он становится частью магической вещи. Теперь это «выделенный» энергокамень. Использующий вещь, может забирать энергию из него — но только для сотворения заклинаний с помощью или через этот предмет.
Если убрать выделенный энергокамень из предмета, он автоматически сломан и теряет чары, но сам камень остается целым и снова становится «обычным» энергокамнем. (Конечно, если энергокамень встроен в предмет каким-либо способом — например часть магического кольца — может потребоваться успешный бросок умения что бы вытащив не повредить его).
Преимущество выделенного энергокамня в том, что его энергия, будучи специально направлена, используется вдвое эффективнее. Одноочковый энергокамень  дает две единицы энергии (но все еще перезаряжается по одной в день в области нормальной маны).

«Эксклюзивные» Энергокамни
Можно сделать предмет с энергокамнями так, что только встроенные энергокамни могут питать его. Это делается точно так же как и для выделенных энергокамней, но энегия этих камней в три раза эффективнее — то есть одноочковый эксклюзивный энергокамень дает 3 очка энергии, но предмет бесполезен до тех пор пока камень не перезарядится.
Энергокамни одной школы
Эта вариация следующая обычным правилам Энергокамней. Энергокамень одной школы зачарован таким образом, что может давать энергию только для заклинаний одной конкретной школы. Такие энергокамни нельзя делать выделенными или эксклюзивными.
Преимущество энергокамней одной школы в том, что для каждого зачарования требуется тольк 12 едеиниц энергии, а не 20.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Indefinite</duration>
		<reference>M70</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Staff</name>
		<name-loc>Посох</name-loc>
		<description-loc>Наложение чар
Зачаровывает магический посох — см  магические посохи (с 13) для подробностей. Несмотря на то, что много предметов имеют форму палочки или посоха, они не обязательно зачарованы этим заклинанием. Многие маги используют различные ограничивающие чары чтобы другие не могли использовать их посохи — но это не происходит автоматически.
Энергостоимость: 30
Требование: Наложение чар
Предмет
Любой кусок органического материала в форме палки (дерево, кость, слоновая кость и т. д.) вплоть до 6 футов длиной. Может быт украшен другими материалами, такими как драгоценный камни или драгоценные металлы. Маленький посох обычно называют «скипетром» и очень короткий и тонкий - «палочкой»</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M70</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Crystal Ball</name>
		<name-loc>Хрустальный шар</name-loc>
		<description-loc>Наложение чар
Используется при прорицании через хрустальный шар. Требует шар из безупречного кристалла как минимум 2 дюмов в диаметре (стоимость 1000$). Трёхдюймовый шар (стоимость 5000$) даст +1 к прорицанию. Четырёхдюймовый шар (стоимость 20000$) даст +2
Энергостоимость: 1000
Требование: Прорицание (Хрустальный шар)</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>1000</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M71</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">divination (crystal gazing)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Effigy</name>
		<name-loc>Отвлечение магии</name-loc>
		<description-loc>Наложение чар
Маг может зачаровать статую самого себя в натуральную величину, которая будет притягивать враждебную магию на себя. Как и Проклятая кукла, Отвлечение магии - это временное заклинание, которое продолжается до тех пор, пока его Сопротивление не упадет до нуля. Каждый раз, когда создателя атакуют заклинанием, Отвлечение магии сопротивляется ему со своим текущим Сопротивлением, модифицированным расстоянием между магом и статуей (используйте модификаторы больших дистанций, M14). Если получилось, заклинание воздействует на статую а не на создателя.
ИМ должен решить, что считать враждебным заклинанием, а что нет; например, Касание смерти враждебное, но Чтение мыслей — нет. Перенаправленное заклинание, которое обычно не может воздействовать на неподвижные статуи (такие как Парализовать конечность или Видение смерти) вместо этого «атакуют» чару. Отвлечение магии тогда сопротивляется со своим текущим Сопротивлением. Каждая такая успешная атака уменьшает сопротивление чары на один; когда же Сопротивление падает до 0, чара перестает действовать. Критический провал Отвлечения магии или критический успех атакующего заклинания так же ломаю чару, как и физическое разрушение статуи. Маг может иметь только одно отвлечение магии за раз.
Энергостоимость: 1000
Требования: Магичность(Magery) 2, Наложение чар, Защита проницания и Опека</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>1000</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M71</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">scryfool</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">ward</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Soul Stone</name>
		<name-loc>Камень души</name-loc>
		<description-loc>Наложение чар
Перемещая свою жизнь в Камень души, колдун становится бессмертным. Несмотря на то, что его тело все еще можно повредить (сжечь, порезать, разбить...), его нельзя убить до тех пор, пока камень цел. Заклинатель становиться неуязвим для болезней, ядов и старения. Он броски на умирание автоматически успешны. Но все еще может оказаться бес сознания.
Если Камень души уничтожить, заклинатель умирает, так что его обычно прячут в очень труднодоступном месте. Смерть также может случиться из некоторых магических причин, таких как неудачный Планарный визит. Заметьте, что камень не должен быть буквально куском скалы; примеры из фольклора и фантастики включают собственное сердце заклинателя (вынутое сразу после сотворения заклинания, по видимому!), яйца и другие.
Камень души и Сосуд души взамиоисключающи.
Стоимость: 500. Одна попытка; если чара не удалась, заклинатель умирает!
Требования: Магичность(Magery) 3, Наложение чар и Сосуд души</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>500</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>-</casting_time>
		<duration>Permanent</duration>
		<reference>M71</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Fire</name>
		<name-loc>Создать огонь</name-loc>
		<description-loc>Областное
Позволяет создать огонь без топлива. Создает клетку или больше, занятую огнём (или падающую сферу огня). Это настоящий огонь, который в конечном итоге поджигает любой горючий объект. Не может быть сотворен внутри камня, врага и т.п.
Длительность: 1 минута.
Базовая стоимость: 2. Половина на поддержание. Обычный огонь, полученный таким образом, не требует поддержания.
Требования: Воспламенение или Искать огонь.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 300; предмет должен содержать рубин на $200.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 burn</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M72</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">seek fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">ignite fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Extinguish Fire</name>
		<name-loc>Погасить огонь</name-loc>
		<description-loc>Областное
Гасит горящую клетку или, при необходимости, небольшую горящую площадь. Гасит обычный и магический огонь, но не расплавленную сталь, лаву и т.п.
Длительность: постоянно (но огонь можно зажечь снова).
Базовая стоимость: 3.
Требования: Воспламенение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 400; предмет должен содержать рубин на $300 и чёрного оникса на $100.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M72</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ignite fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ignite Fire</name>
		<name-loc>Воспламенение</name-loc>
		<description-loc>Стандартное
Создает на объекте разогретую точку и используется для поджигания легко воспламеняемых объектов. Лучше всего работает с бумагой или одежной, и не будет действовать на предметы, которые не загорятся под действием обычного огня. В частности, оно не подействует на живое существо. Зажжённое пламя горит как обычное.
Длительность: одна секунда.
Стоимость: зависит от желаемой температуры:
1 – спичка. Зажигает за секунду табак, свечу или прут.
2 – факел. Подожжет бумагу или тонкую одежду за секунду, обычная одежда загорится через 4 секунды.
3 – паяльная лампа. Сухое дерево или одежда загорается за секунду, кожа – за две, толстое дерево – за шесть секунд.
4 – вспышка магния. Толстое дерево загорается за две секунды, уголь – за одну.
Столько же на поддержание.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 100; в предмете должен быть маленький рубин за $50.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M72</reference>
		<categories>
			<category>Fire</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Fire</name>
		<name-loc>Искать огонь</name-loc>
		<description-loc>Информационное	
Сообщает заклинателю направление и примерное расстояние до ближайшего существенного огня или источника сильного тепла. Используются Модификаторы дальних дистанций (M14). Любые из известных источников тепла или огня могут быть исключены из поиска перед сотворением. Заклинатель также может уточнить тип огня, по топливу (природный газ, спирт, дерево и т.д.). 
Стоимость: 1.
Предмет
Раздвоенная палочка. Энергостоимость создания: 50 энергии и маленький рубин за $100.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M72</reference>
		<categories>
			<category>Fire</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Fire</name>
		<name-loc>Формировать огонь</name-loc>
		<description-loc>Областное
Позволяет заклинателю контролировать форму любого пламени и перемещать его. Однажды сформированное, пламя сохраняет форму, пока не кончится действие заклинания, не требуя концентрации. Естественное пламя не сможет перемещаться туда, где нет топлива, но пламя, созданное с помощью заклинания Создать огонь, в топливе не нуждается, и может перемещаться куда угодно. Можно перемещать при постоянной концентрации со скоростью 5. Изменение формы требует секунды концентрации. Огонь должен сохранять свой объем, иначе будет изменяться наносимое повреждение. Огонь «растянутый» вдвое наносит лишь половину урона, а распространённый на площадь втрое больше естественного размера – 1/3 урона и т.д.
Длительность: 1 минута.
Базовая стоимость: 2, половина на поддержание.
Требования: Воспламенение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 400; предмет должен содержать рубин на $300.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M72</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ignite fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Deflect Energy</name>
		<name-loc>Отклонить энергию</name-loc>
		<description-loc>Блокирующее
Отражает одну энергетическую атаку на субъект – включая лучи, Молнии и Огненные шары. В игромеханических целях считается за парирование. Если субъектом заклинания является не маг, применяются модификаторы дистанций как для Стандартного заклинания. Отраженные атаки не теряют поражающей силы и могут ранить кого-нибудь рядом.
Стоимость: 1.
Требования: Магичность(Magery) 1 и Формировать огонь.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fast Fire</name>
		<name-loc>Быстрый огонь</name-loc>
		<description-loc>Стандартное
Делает пламя горячее, соответственно ускоряя горение окружения (в том числе и людей). Повреждение, наносимое огнём, увеличивается пропорционально. Это заклинание действует как заклинание Великое ускорение на огненных элементалей и существ с мета-чертой Тело из огня.
Длительность: 1 минута.
Стоимость: 2 для увеличения скорости горения вдвое, 3 – втрое и т.д. Столько же за поддержание.
Требования: Замедлить горение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 375 энергии и рубин на $500.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">slow fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fireproof</name>
		<name-loc>Огнеупорность</name-loc>
		<description-loc>Областное
Предотвращает возгорание в области действия: спичка не загорится, кремень не высечет искру и т.д. Не погасит внесённый извне огонь, но этот огонь не сможет ничего поджечь. Полезно там, где огонь опасен (например, на пороховой фабрике). Попытка зажечь магический огонь получает штраф -5. Это заклинание не выдержит очень сильной жары (например, лавы или боевых лазеров), но не даст работать огнестрельному оружию.
Длительность: 1 день.
Базовая стоимость: 3. Удвоение стоимости наложит штраф -10 на попытку зажечь магический огонь, и делает заклинание стойким к любой температуре ниже температуры звезд. Столько же за поддержание. 
Время сотворения: 5 минут.
Требования: Погасить огонь.
Предмет
Заклинание Огнеупорность может быть наложено на область навсегда, если умножить стоимость на 100. Должно применяться некоторое количество рубинового порошка (примерно $10 на единицу энергии).</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 day</duration>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">extinguish fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flame Jet</name>
		<name-loc>Струя огня</name-loc>
		<description-loc>Стандартное
Позволяет выстрелить струю огня из кулака. Каждый ход заклинатель кидает ЛВ(DX)-4 или умение Природная атака для попадания, и повреждение, если попал. От этой атаки можно защититься блоком или уклонением, парировать её нельзя. Считайте струю контактным оружием – пылающий меч без реального клинка – но он не может парировать! Это замечательное эффектное [flashy] заклинание, подходящее для магических шоу, контактного боя, разрезания верёвок и т.д. Заклинатель может творить столько заклинаний, сколько имеет рук и держать в каждой руке по Струе огня; к Струе огня, находящейся в неосновной руке, применяется обычный штраф -4. 
Для «киношной» дуэли магов Мастер может разрешить парирование Струи огня другой Струёй огня. Это позволит провести вместо обычной магической дуэли в виде перестрелки, провести ближний бой между магами.
Длительность: 1 секунда.
Стоимость: от 1 до 3 очков. Наносит 1d повреждения за каждое очко стоимости. Дальность струи в ярдах равна количеству кубиков повреждения. Столько же на поддержание.
Требования: Создать огонь и Формировать огонь.
Предмет
Украшение. Энергостоимость создания: 800; должен содержать золота на $500, и рубинов на $300. Используется только магами.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d burn/point</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Phantom Flame</name>
		<name-loc>Призрачное пламя</name-loc>
		<description-loc>Областное
Создаёт область фантомного пламени. Стоящие вблизи чувствуют жар (и даже боль, если дотронутся до него); предметы внутри выглядят горящими. Однако пламя не распространяется и не наносит реального повреждения. Даже вызванная им боль утихает после первоначального шока. Формировать огонь и Погасить огонь влияют на это фантомное пламя; а вот вода – нет.
Это заклинание также относится к школе Иллюзии и Создания.
Длительность: 1 минута.
Базовая стоимость: 1. Столько же за поддержание.
Требования: Формировать огонь или Простая иллюзия.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 200; должен содержать рубин на $100.</description-loc>
		<college>Fire/Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Slow Fire</name>
		<name-loc>Замедлить горение</name-loc>
		<description-loc>Областное
Остужает пламя, делая горение окружения (в том числе людей) медленным. Повреждение, наносимое огнём, уменьшается пропорционально. Это заклинание действует как заклинание Замедлить на огненных элементалей и существ с мета-чертой Тело из огня (B262). Замедление горения противодействует Быстрому огню.
Длительность: 1 минута.
Базовая стоимость: 2 для уменьшения скорости горения вдвое, 3 – втрое и т.д. Столько же за поддержание.
Требования: Погасить огонь.
Предмет
Посох, палочка или украшение. Энергостоимость создания:350 энергии, рубин на $500 и чёрный оникс на $500.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">extinguish fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Smoke</name>
		<name-loc>Дым</name-loc>
		<description-loc>Областное
Создаётся облако густого дыма. Слой такого дыма толщиной в ярд блокирует видимость. Пока дым не рассеется, он имеет свойства слезоточивого газа (провалившие бросок ЗД(HT) не могут делать ничего, кроме как кашлять и плакать). Дым тёплый и медленно поднимается (примерно на фут в секунду). Скорость рассеивания зависит от места и наличия ветра; в помещении дым может существовать, пока не закончится заклинание, а на открытом воздухе в ветреный день может рассеяться за 10 секунд.
Длительность: 5 минут, если нет неблагоприятных факторов.
Базовая стоимость: 1. Половина на поддержание.
Требования: Формировать огонь и Погасить огонь.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 50.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min #</duration>
		<melee_weapon>
			<damage>Cough/Weep</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M73</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">extinguish fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cold</name>
		<name-loc>Охладить</name-loc>
		<description-loc>Стандартное
Это заклинание уменьшает температуру объекта. Многие материалы будут разрушаться при ударе, если будут достаточно охлаждены. Максимальное охлаждение – до абсолютного нуля. За пропорциональное увеличение затрат можно охлаждать быстрее.
Длительность, Стоимость и Время сотворения: идентично Нагреть, за исключением того, что каждая минута поддержания заклинания охлаждает предмет на 20°C.
Требования: Нагреть.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 400; предмет должен содержать рубин на $300 и сапфир на $300.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fireball</name>
		<name-loc>Огненный шар</name-loc>
		<description-loc>Метательное
Позволяет заклинателю швырнуть шар огня из руки. Шар имеет Точ +1, 1/2Д 25, Max 50. При попадании во что-либо он исчезает в клубах пламени, которое может поджечь воспламеняемые объекты. 
Стоимость: вплоть до уровня Магических способностей в секунду, на протяжении трех секунд. Каждая вложенная единица энергии наносит 1d обжигающего вреда.
Время сотворения: 3 секунд.
Требования: Минимум шесть других заклинаний школы Огня.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 800 энергии; рубин на $400.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-Magery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d burn/point</damage>
			<accuracy>1</accuracy>
			<range>25/50</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Heat</name>
		<name-loc>Нагреть</name-loc>
		<description-loc>Стандартное
Это заклинание увеличивает температуру объекта. Не создает огня само по себе, однако многие материалы будут загораться при достаточном нагреве. Магу, планирующему частое использование этого заклинания, будет полезно иметь под рукой табличку с температурами плавления и воспламенения. Заклинание может иметь некоторые побочные эффекты. Оно может быть полезным, если вы заперты за решеткой – вы можете ее попытаться расплавить, но жар от кипящего металла может поджарить и вас! (Эти рекомендации используйте лишь для ориентировки – не превращайте игру в физические опыты!)
Длительность: 1 минута. За каждую минуту температура поднимается на 20°С. Максимально возможная температура – 2.800°С.
Стоимость: 1 за предмет размером с кулак, 2 – куб.ярд, и еще по 2 за каждый кубический ярд объема. Скорость нагревания может быть увеличена: нагрев будет на 40°C в минуту за удвоенную цену, на 60°C – за утроенную, и так далее. Более медленный нагрев при желании возможен, но затрат не снижает. Столько же на поддержание.
Время сотворения: 1 минута.
Требования: Создать огонь, Формировать огонь.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 400; предмет должен содержать рубин на $300.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 min</duration>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain of Fire</name>
		<name-loc>Огненный дождь</name-loc>
		<description-loc>Областное
С неба на область заклинания падают огненные капли, нанося всем находящимся в ней 1d-1 огненного повреждения. Существа, попавшие под Огненный дождь, получают повреждение в свой же ход; если в области дождя проведено меньше секунды, повреждение уменьшается вдвое (округлять вниз). Это заклинание может быть сотворено только на открытом воздухе. Броня действует обычным образом. Щит с ПЗ(DB) 2 и больше можно держать над головой, чтоб блокировать пламя, однако, он тоже может получить повреждения (B484). Это требует двух рук и манёвра Подготовки, и если успешно, автоматически защищает персонажа, пока щит поднят над головой, но такой манёвр делает щит неготовым для выполнения обычной защитной функции! Неподвижные объекты, например здания, защищены своим СП(DR), но некоторые структуры (см. ЕЖ(HP) и СП(DR) построек, БС (BS) B558) могут быть повреждены или загореться.
Длительность: 1 минута.
Базовая стоимость: 1 для заклинания (минимум 2). Столько же за поддержание. За удвоенную стоимость Огненный дождь наносит 2d-2 повреждения в секунду!
Время сотворения: Одна минута.
Требования: Магичность(Magery) 2 и Создать огонь.
Предмет
Посох. Используется только магами. Энергостоимость создания: 600.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 burn</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">create fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Cold</name>
		<name-loc>Сопротивление холоду</name-loc>
		<description-loc>Стандартное
Объект (существо или предмет) и все, что он имеет с собой, получает иммунитет к охлаждению и обморожению. Не защищает от ледяных копей, падающих ледяных глыб и т.д. 
Продолжительность: 1 минута.
Энергостоимость: 2 на сотворение, 1 на поддержание. За двойную цену - защищает от -40° и ниже, за тройную - от абсолютного нуля!
Требуется: Нагреть.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Fire</name>
		<name-loc>Сопротивление огню</name-loc>
		<description-loc>Стандартное
Объект (существо или предмет) и все, что он имеет с собой, получает иммунитет к огню и жаре (но не электричеству).
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание. За двойную стоимость - защищает от вулкана, за тройную - от жара звезды или ядерного взрыва. Против обычных заклинаний школы огня достаточно первого уровня.
Требования: Огнеупорность.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 800; предмет должен содержать рубин на $500 и чёрный оникс на $200.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fireproof</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Warmth</name>
		<name-loc>Теплота</name-loc>
		<description-loc>Стандартное
Субъект сохраняет тепло на холоде, избегая обморожения и гипотермии. Это заклинание поднимает «местную температуру» на 30°F к «комфортной зоне» температур (B93). Это заклинание не защищает от атак магическим холодом, например заклинания Обморожение. Это заклинание так же относится к школе заклинаний Защиты и Предупреждения.
Длительность: 1 час.
Стоимость: 2 на сотворение, 1 на поддержание.
Время сотворения: 10 секунд.
Требования: Нагреть.
Предмет
Одежда, посох, украшение или попона (одеяло [blanket]); действует только на надевшего (в случае посоха - держащего). Энергостоимость создания: 200 энергии.</description-loc>
		<college>Fire/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M74</reference>
		<categories>
			<category>Fire</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Flame</name>
		<name-loc>Истинный огонь</name-loc>
		<description-loc>Областное
Подобно Создать огонь, но созданный огонь является магической эссенцией огня. Любой маг заметит разницу на взгляд. Он не может быть потушен обычной водой или простой магией, а только достаточным количеством Истинной воды или заклинанием Рассеять магию. Истинный огонь наносит +1 вреда (+2 водным созданиям). 
Продолжительность: 1 минута.
Базовая стоимость: 3. 2 поддержание. Огонь воспламеняет все горючие материалы, оставаясь Истинным огнём пока поддерживается заклинание. Когда поддержка прекращается, горение продолжается как обычный огонь.
Время сотворения:3 секунды.
Требования: минимум шесть иных заклинаний Огня.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 800; должен включать рубин за $400.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3#</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d burn</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M75</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Explosive Fireball</name>
		<name-loc>Разрывной огненный шар</name-loc>
		<description-loc>Метательное
Создаёт огненный шар, воздействующий как на цель, так и на её окружение. У шара 1/2Д 25, Max 50, Точ 1. Может метаться в стену, пол, и т.д. (с +4 к попаданию) для поражения целей пламенем. Цель и все находящиеся от неё в радиусе ярда получают полный вред. Все находящиеся дальше получают вред поделённый на три за каждый ярд удаления (округлять вверх). 
Стоимость: вплоть до удвоенного уровня Магических способностей в секунду, на протяжении трех секунд. Шар наносит 1d обжигающего вреда за каждые 2 единицы вложенной энергии.
Время сотворения: 1-3 секунды.
Требования: Огненный шар.
Предмет
Посох или палочка — шар вылетает из конца предмета. Энергостоимость создания: 1.200; должен содержать рубин за $500. Используется только магами.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>2-2xMagery#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d burn ex/2 points</damage>
			<accuracy>1</accuracy>
			<range>25/50</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M75</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fireball</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fire Cloud</name>
		<name-loc>Огненное облако</name-loc>
		<description-loc>Областное
Создаёт кружащееся облако огня и тлеющих углей. Оно не блокирует видимость. Но наносит обжигающий урон всем, кто в нём находится. Существа в облаке получают урон в свой ход. Если в облаке проведено меньше секунды, урон уменьшается вдвое (округлять вниз). Броня защищает как обычно. Огнеопасные материалы могут загореться.
Продолжительность:10 секунд.
Стоимость: 1 до 5; Облако причиняет в секунду столько единиц урона, сколько вложено очков энергии. Та же стоимость поддержания.
Время на сотворение: 1 до 5 секунд, в зависимости от стоимости.
Требования: Формировать воздух и Огненный шар.
 Предмет:
Посох, палочка или украшение. Применяется только магами. Энергостоимость создания: 175 энергии, рубин на $500.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1-5 sec</casting_time>
		<duration>10 sec</duration>
		<melee_weapon>
			<damage>1 point burn/point</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M75</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fireball</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flaming Armor</name>
		<name-loc>Пылающая броня</name-loc>
		<description-loc>Стандартное
Субъект покрывается пламенем, которое не доставляет ему никакого дискомфорта – он и всё что он несёт под защитой базового заклинания Сопротивления Огню. Внешне пламя такое же, как и обычное. Контактная атака субъекта наносит дополнительное очко огненного урона. Любая контактная атака, попавшая по субъекту, вызывает Струю огня с уроном 1d, которая бьёт врага, пролетая вдоль оружия. Эта атака автоматически попадает по руке, держащей оружие, если Досягаемость (reach) оружия не больше 1. Если субъекта схватили или он схватил, то врагу наносится 3d обжигающего урона, но заклинание рассеивается.
Продолжительность: 1 минута
Стоимость: 6 на сотворение, 3 на поддержание.
Требования: Магичность(Magery) 1, Сопротивление Огню и Струя огня.
Предмет:
(а) Посох или украшение. Используется только магами. Энергостоимость создания:600 энергии; должно быть использовано рубин на $300.
(б) Накидка или броня. Действует только на носящего. При активации накидка выглядит буквально сплетенной из огня; она будет защищать со спины и сбоку, но не спереди. Если только не держится в руках как лёгкий плащ (см. B184). Энергостоимость создания: 700 энергии за накидку, 1000 за броню.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M75</reference>
		<notes>+1 point burn damage to all melee attacks</notes>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">flame jet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flaming Missiles</name>
		<name-loc>Пылающие стрелы</name-loc>
		<description-loc>Стандартное
То же, что и Пылающее оружие, но творится на дистанционное оружие. Оружие приобретает мерцающий, огненный вид. Снаряд загорается при выстреле и наносит дополнительно +2 повреждения, как при Пылающем оружии; он рассыпается пеплом после попадания в цель или через 10 секунд после поджога, в зависимости от того, что случится раньше.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 2 на поддержание. Стоимость удваивается, если снаряд каменный или металлический.
Время на сотворение: 3 секунды.
Требования: Пылающее оружие.
Предмет
Дальнобойное оружие, всегда стреляющее пылающими снарядами и не стоящее энергии пользователю. Энергостоимость создания: 1000 энергии; $500 за инкрустированные в оружие рубины.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4#</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M75</reference>
		<notes>+2 points burn damage with missiles fired from weapon</notes>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">flaming weapon</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flaming Weapon</name>
		<name-loc>Пылающее оружие</name-loc>
		<description-loc>Стандартное
Оружие вспыхивает не нанося вреда владельцу, но причиняя врагам и воспламеняющимся предметам +2 повреждения (после проникновения сквозь броню и применения других бонусов). Металлическое оружие не повреждается, деревянное рассыпается пеплом, как только заклинание закончится. Оружие даёт свет так же как факел.
Длительность: 1 минута.
Стоимость: 4 за сотворения. 1 за поддержание. 
Время на сотворение: 2 секунды.
Требования: Магичность(Magery) 2 и Нагреть.
Предмет
Оружие, пылающее при использовании, и не стоящее энергии пользователю. Энергостоимость создания: 750 энергии; рубин на $400.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M75</reference>
		<notes>+2 points burn damage from attacks with melee weapon</notes>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Body of Flames</name>
		<name-loc>Тело из Огня</name-loc>
		<description-loc>Стандартное; Сопротивление по ЗД(HT)
Субъект получает мета-черту Тело из огня (B262) на время действия заклинания. Одежда (весом меньше 6 фунтов) также становится огненной, но теряет всякие магические свойства. Персонаж в таком состоянии не может ничего нести.
Продолжительность: 1 минута. Заклинание рассеивается если субъект теряет сознание.
Стоимость: 12 на сотворение, 4 на поддержание.
Время на сотворение: 5 секунд.
Требования: Огненное дыхание
Предмет:
(а) Посох, палочка или украшение. Действует только на носящего. Серьёзным недостатком является то, что как только заклинание активировано, предмет падает сквозь руки пользователя. Таким образом, заклинание, творимое с помощью предмета, длится только одну минуту. Энергостоимость создания: 3000 энергии.
(б) Посох, палочка или украшение. Действует только на носящего. В отличии от предыдущего предмета, обращается в огонь вместе с носящим, позволяя поддерживать заклинание. В огненной форме предмет теряет магические силы, которые обычно имел. Энергостоимость создания: 6000 энергии.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d burn</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M76</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">breathe fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Breathe Fire</name>
		<name-loc>Огненное дыхание</name-loc>
		<description-loc>Стандартное
Похоже на Струю огня, только огонь исходит изо рта заклинателя, Огненное дыхание нельзя поддерживать, и за одно очко энергии покупается 1d+1 очков урона, вместо 1d. Для попадания заклинатель кидает против ЛВ(DX)-2 или Природной атаки. Это считается действием; заклинатель должен смотреть в сторону цели. Для сотворения заклинания не требуются жесты руками; вместо этого совершаются определённые движения губами и языком. Таким образом, Огненное дыхание может быть сотворено без рук на любом уровне умения.
Продолжительность: 1 секунда.
Стоимость: от 1 до 4. Не поддерживается.
Время на сотворение: 2 секунды.
Требования: Магичность(Magery) 1, Струя огня и Сопротивление огню.
Предмет:
Украшение. Применяется только магами. Энергостоимость создания: 1000 энергии; должно применяться золота на $500 и рубин на $500.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d+1 burn/point</damage>
			<usage>Breath</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Breath</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M76</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">resist fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">flame jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Burning Death</name>
		<name-loc>Пылающая смерть</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT).
Сжигает жертву изнутри. Заклинатель должен попасть по цели чтоб заклинание сработало, место попадания значения не имеет. Каждый ход жертва должна бросать против ЗД(HT); при провале (как критическом, так и обычном) она получает 1d-1 огненного урона. В случае успеха жертва не получает урона в этот ход, при критическом успехе заклинание развеивается. Ни СП(DR), ни Сопротивление огню не защищают! При поддержке заклинания, жертва испытывает невыносимые муки, таки как при заклинании Болезнь (M138).
Если заклинание поддерживается достаточно долго, кожа и одежда жертвы начинают обугливаться и там и тут возникают маленькие огоньки. Если жертва умирает, её тело загорается и горит до тех пор, пока не останется лишь маленькая кучка золы.
 Нежить не поддаётся этому заклинанию. Для поддержки заклинания заклинатель должен сосредоточиться, но не должен поддерживать физический контакт.
Это заклинание также относится к школе Некромантии.
Продолжительность: 1 секунда.
Стоимость: 3 на сотворение, 2 на поддержание.
Требования: Магичность(Magery) 2, Нагреть и Болезнь.
Предмет:
Посох, палочка или украшение. Используется только магами; предмет должен касаться субъекта. Энергостоимость создания: 700 энергии, рубин на $500.</description-loc>
		<college>Fire/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>thr-1 cr +1d-1 burn/second</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M76</reference>
		<categories>
			<category>Fire</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sickness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Decay</name>
		<name-loc>Разложение</name-loc>
		<description-loc>Обычное
Заставляет пищу немедленно разлагаться, делая ее бесполезной (она может быть сохранена, если в течение минуты сотворить Контрзаклинание или Очистить пищу).
Стоимость: 1 за уничтоженную порцию.
Требования: Проверить пищу.
Предмет 
Посох или палочка. Должен коснуться объекта. Энергостоимость создания: 100.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/meal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M77</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">test food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Far-Tasting</name>
		<name-loc>Удаленная дегустация</name-loc>
		<description-loc>Обычный
Субъект может ощутить вкус и запах любого объекта, который он может видеть (даже на большом расстоянии) или ощутить вкус и запах сквозь твердые объекты не больше двух ярдов толщиной. Все броски Вкус/Запах автоматически успешны, хотя любое вещество, не определяемое на вкус или по запаху (например, угарный газ без вкуса и аромата), останется необнаруженным. Это может быть особенно полезным для вынюхивания ядов, так как их эффекты не передаются через запахи.
Так же это заклинание Школы знаний.
Длительность: 1 минута.
Стоимость: 3 сотворение, 1 поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и  Искать пищу или Искать воздух; отсутствие  недостатка Нет обоняния/вкуса.
Предмет 
Одежда или украшение, влияет только на носителя. Энергостоимость создания: 200.</description-loc>
		<college>Food/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M77</reference>
		<categories>
			<category>Food</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="contains">no taste/smell</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">seek food</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">seek air</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (food)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Season</name>
		<name-loc>Приправа</name-loc>
		<description-loc>Обычный
Добавляет приправы и заправку в одну емкость пищи по вкусу заклинателя. Станет ли вкус блюда лучше, зависит  от умения заклинателя, заклинание лишь добавляет затребованные вкусы.
Длительность: навсегда.
Стоимость: 2 за порцию.
Время сотворения: 10 секунд.
Требования: Проверить пищу. 
Предмет
Ложка, которая при размешивании пищи придаст ей заложенный вкус. Энергостоимость создания: 150.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/meal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M77</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">test food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Food</name>
		<name-loc>Искать пищу</name-loc>
		<description-loc>Информационное
Определяет направление, расстояние и общую природу ближайшего значительного источника пищи. Используются Модификаторы больших расстояний (M14). Обнаруженная пища будет полноценной, но не обязательно аппетитной, например съедобные насекомые. Любые известные источники пищи (те самые вкуснейшие насекомые) могут быть исключены из поиска. 
Стоимость: 2.
Предмет
Раздвоенная палочка. Энергостоимость создания: 300.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M77</reference>
		<categories>
			<category>Food</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Test Food</name>
		<name-loc>Проверить пищу</name-loc>
		<description-loc>Информационное
Определяет, подходит ли субстанция для еды. Заклинание ничего не скажет о вкусе или питательности, но определит яды, опасное гниение или инородные объекты (лезвие во фрукте). Не проверяет наличие магии в еде.
Стоимость: 1 за проверку одной порции или бутылки; 3 за всю еду и питье в радиусе 1 ярда.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1 or 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M77</reference>
		<categories>
			<category>Food</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Cook</name>
		<name-loc>Приготовить</name-loc>
		<description-loc>Обычное
Превращает сырые ингредиенты в готовое блюдо. Производит только простую пищу (тушеное мясо и т.д.), которая, однако также полезна, как ингредиенты. Огонь для приготовления  не нужен; высокую температуру обеспечивает заклинание.
Стоимость: 1 за порцию.
Время сотворения: 5 секунд.
Требования: Проверить пищу и Создать огонь.
Предмет
Котелок, готовящий любую еду, помещенную в него, не тратя энергии пользователя. Требует около минуты на готовку. Размер не имеет значения, каждый котелок может использоваться ограниченное число раз в день. 
Энергостоимость создания: 30 за порцию в день (например, котелок, готовящий три порции за день, будет стоить 90 энергии для создания).</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">test food</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create fire</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Know Recipe</name>
		<name-loc>Узнать рецепт</name-loc>
		<description-loc>Информационное
Особое сопротивление
Заклинание применяется на готовое блюдо и помещает полную информацию о компонентах еды (и методах приготовления использованных поваром) в мозг заклинателя. 
Так же может применяться на  алхимические составы. Однако эликсиры отражают заклинание с умением создавшего их алхимика. На усмотрение Мастера может использоваться для анализа химикатов или лекарств.
Так же это заклинание школы Знаний.
Длительность: запомненное остается предельно ясным в уме заклинателя 1 день. После чего угасает как в заклинании Запомнить (M105). Искажение рецептов может привести к чему угодно от неловкого положения (замена сахара солью в десерте) до серьезной неприятности (замена сахара солью в десерте для Короля).
Стоимость: 3. Не поддерживается.
Время сотворения: 15 секунд.
Требования:  Удаленная дегустация и Приправа.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 450.</description-loc>
		<college>Food/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>15 sec</casting_time>
		<duration>1 day</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">far-tasting</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">season</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mature</name>
		<name-loc>Созревание</name-loc>
		<description-loc>Обычное
Заставляет быстро состариться или созреть любые продукты, для которых это часть приготовления. Чаще всего используется для пива и вина, но также может использоваться для сыра, йогурта, хлебного теста, и даже мяса.
Процессы старения, которые обычно занимают дни или недели (пиво, вино, выдержанный  сыр, соленые огурцы, вяленое мясо), занимают только час с заклинанием. Процессы, которые обычно занимают часы (хлебное тесто, йогурт, свежий сыр) – минуту. Процессы, которые занимают годы (марочные вина, тысячелетние яйца) ускоряются на год за каждое сотворение заклинания..., это - дивный способ проверить, будут ли марочные вина так же хороши выдержанными.
Длительность: процесс занимает час (или минуту, см. выше), еда остается созревшей навсегда.
Стоимость: 1 за фунт пищи. Не поддерживается.
Время сотворения: 10 секунд.
Требования: Разложение или Приправа.
Предмет
Маленький бочонок, работающий без энергозатрат пользователя, ограниченное число раз в день.
Энергостоимость создания: 50 за каждый галлон объема и число использований в день. Например 10-галлонный бочонок, который работает дважды за день стоит 50*10*2 = 1.000 энергии для создания.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">season</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Poison Food</name>
		<name-loc>Отравить пищу</name-loc>
		<description-loc>Обычное
Вводит в пищу соматический неопределяемый яд. Может быть обнаружен только с помощью Проверить пищу. Любой, съевший отравленную пищу, должен сделать проверку ЗД(HT). При успешном броске он чувствует себя больным и теряет 2 ЕЖ(HP). При провале - испытывает болезненные спазмы желудка, теряет сразу 1d+1 ЕЖ(HP)  и получает -3 ко всем умениям или заклинаниям, пока потерянные ЕЖ(HP) не восстановятся.
Стоимость: 3 за порцию.
Требования: Очистить пищу.
Предмет
Посох или палочка. Должен коснуться объекта. Энергостоимость создания: 600.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Prepare Game</name>
		<name-loc>Обработка дичи</name-loc>
		<description-loc>Обычное
«Потрошит» убитое животное. Если сотворить, например, на оленя, удалится шкура, наряду с ненужными внешними деталями и внутренностями. На рыбу - будет почищена и выпотрошена. Заклинание ничего не уничтожает, просто все части отделяются и вычищаются лучшим способом для данного животного перед его готовкой.
Длительность: навсегда.
Стоимость: 2.
Время сотворения: 10 секунд.
Требования: Очистить пищу.
Предмет.
(а) Посох, палочка, украшение или нож. Энергостоимость создания 300.
(б) Нож для свежевания, чистки рыбы, чистки овощей и т.д. Используются для подходящего типа продуктов. Энергостоимость создания: 150.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Purify Food</name>
		<name-loc>Очистить пищу</name-loc>
		<description-loc>Обычное
Удаляет инородные объекты, яды, гниль и приводит пищу к пригодному для еды состоянию. Работает только на съедобных и бывших съедобных объектах. Предмет, испорченный целиком, заклинание полностью уничтожит.
Стоимость: 1 за фунт материала для очистки.
Требование: Разложение.
Предмет
Посох, палочка или украшение. Должен коснуться объекта. Энергостоимость создания: 400.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M78</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Burning Touch</name>
		<name-loc>Пылающее касание</name-loc>
		<description-loc>Касательное
Рука заклинателя окутывается пламенем. Первая цель, пораженная после сотворения заклятия, получает 1d урона за каждое очко энергии, вложенное в заклинание. Броня не помогает, защищает только собственное СП(DR).
Стоимость: 1 до 3.
Требования: Магичность(Magery) 2 и минимум 6 заклинаний Огня, включая Нагреть.
Предмет:
Посох, палочка или перчатка. Предмет должен касаться субъекта. Энергостоимость создания: 300 энергии.</description-loc>
		<college>Fire</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>thr-1 +1d burn/point</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M79</reference>
		<categories>
			<category>Fire</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (fire)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Food</name>
		<name-loc>Создать пищу</name-loc>
		<description-loc>Обычное
Производит съедобную пищу. Это заклинание легче использовать для преобразования существующего материала; чем он ближе к пище, тем вкуснее результат.
Длительность: навсегда.
Стоимость: 2 для превращения органики в пищу; 3  для превращения неорганики в пищу; 4 для вызова пищи из воздуха.
Время сотворения: 30 секунд.
Требования: Приготовить и Искать пищу.
Предмет
(а) Посох, палочка или украшение; используется только магами. Должен коснуться материала превращаемого в пищу. Энергостоимость создания: 600.
(б) Горшок, как указанно в Приготовить, обращающий все положенное в него в готовую еду. Энергостоимость создания: 200 за фунт пищи в день.
(в) Сосуд , создающий пищу из ничего. Энергостоимость создания: 400 за фунт пищи в день.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M79</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">cook</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">seek food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Food</name>
		<name-loc>Истинная пища</name-loc>
		<description-loc>Обычное
Преобразует еду, или любой другой материал, в невероятно хорошую, насыщенную, и питательную пищу. Истинная пища не портится, а шесть порций весят лишь фунт.
Длительность: неопределённа.
Стоимость: 3 за порцию из какой-либо органики; 5 за порцию из полностью несъедобных веществ.
Время сотворения: 30 секунд.
Требования: 6 заклинаний Пищи, включая Создать пищу.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3 or 5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Indefinite</duration>
		<reference>M79</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">food</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fool's Banquet</name>
		<name-loc>Пир дураков</name-loc>
		<description-loc>Обычное
Заставляет любую вещь казаться  привлекательной и вкусной едой. Основные свойства материи не изменяются, но едоки сочтут ее восхитительной – не обязательно питательной, но восхитительной. Может применяться только на то, что физически можно съесть; сработает с грязью, но не с камнями. Классическое дополнение к часто унылому корму, созданному заклинанием Создать пищу.
Длительность: 1 день.
Стоимость: 2 за порцию; не поддерживается.
Требования: Магичность(Magery) 1, Приготовить и Глупость.
Предмет
Посох, палочка или украшение; используется только магами. Предмет должен коснуться материала. Энергостоимость создания: 600.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 day</duration>
		<reference>M79</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">cook</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (food)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Monk's Banquet</name>
		<name-loc>Пир монаха</name-loc>
		<description-loc>Обычное
Позволяет обходиться без воды и пищи в течение суток без вредных последствий.
Длительность: 24 часа.
Стоимость: 6. Не поддерживается.
Требования: Пир дураков и Сопротивление боли.
Предмет
Одежда или украшение; применяется только магами или (по решению Мастера) «чистыми» или «святыми». Энергостоимость создания: 1.000.</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>24 hrs</duration>
		<reference>M79</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fool's banquet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist pain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Preserve Food</name>
		<name-loc>Консервация пищи</name-loc>
		<description-loc>Обычное
Предохраняет любую органику от порчи, высыхания и т.п. Весьма полезно путешественникам.
Длительность: 2 недели.
Стоимость: 2 за фунт пищи; 1 за поддержание.
Требования: Разложение.
Предмет
(а) Посох, палочка или украшение. Энергостоимость создания: 200.
(б) Сундук или мешок; включен постоянно; содержимое сохраняется достаточно долго. Энергостоимость создания: 20 за каждый сохраняемый фунт (округлять вверх).</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/lb</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 week</duration>
		<reference>M79</reference>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Water to Wine</name>
		<name-loc>Воду в вино</name-loc>
		<description-loc>Обычное
Превращает воду или другое питье в слабоалкогольный напиток. Природа полученного напитка зависит от начального материала. Вода или виноградный сок становится вином; фруктовые соки – «коктейлями». Качество результата зависит от броска заклинателя и качества начальной жидкости.
Длительность: навсегда.
Время сотворения: 10 секунд.
Стоимость: 4 за галлон (половина стоимости за пиво; двойная за спиртное).
Предмет
Бутылка или сосуд для питья, который раз в день, может превратить содержимое в алкогольный напиток. Качество результата зависит от начального материала; из морской воды получилось бы довольно плохое пиво, а из растопленного горного снега -  превосходное вино. Энергостоимость создания: 500 за галлон емкости сосуда. Отметьте, что критический провал заклинания, известен созданием опасных вещей, таких как кубки, отравляющие создаваемое ими вино; но зачаровать так осознанно еще ни у кого не получилось!</description-loc>
		<college>Food</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4 per gal#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M79</reference>
		<notes>Half cost for beer, double cost for spirits</notes>
		<categories>
			<category>Food</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">mature</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Timeport</name>
		<name-loc>Хронопортация</name-loc>
		<description-loc>Особое
Похоже на Телепортацию, только, перемещает во времени вместо пространства. Субъективное «движение» мгновенно. Чем более «удалено» время назначения, тем больше энергостоимость и штраф к умению (см. таблицу Модификаторы времени). В отличие от Телепортации, нет штрафа за прыжок в «незнакомое» время. Хотя Мастер может установить дополнительный штраф (возможно -2) на любой прыжок в будущее.
Перемещаясь в будущее, заклинатель попадет в его самый вероятный вариант из всех возможных. Вернувшись и действуя на основании полученных данных, он не обязательно создаст посещенное будущее.
Аналогично заклинатель, вернувшийся в прошлое и изменивший что-либо, обратно может вернуться в альтернативную линию времени. Число изменений между «домашней» линией времени и новой будет зависеть от взгляда Мастера на «сопротивляемость искажению» временного потока в его мире(ах).
Заклинание опасно - штрафы за неудачный бросок такие же, как у Телепортации с заменой пространства временем. Также как в Телепортации, можно нести вес не более Тяжелой нагрузки (вещи и существа). По прибытию нужен бросок Чувства тела, с модификацией за столкновения, изменения скорости, ориентации.
Если заклинатель хочет путешествовать одновременно во времени и пространстве, используется меньшее из умений Телепортация или Хронопортация с объединением штрафов и затрат за расстояние и время.
Стоимость: см. таблицу.
Требования: Магичность(Magery) 3 и Телепортация.
Предмет
Посох, палочка, или часы. Используется только магами. Энергостоимость создания: 4.000. Предмет, переносящий владельца в одно предопределенное время, стоит 2.000; создатель предмета должен быть хорошо знаком с тем временем.
Модификаторы времени</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M81</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Timeport Other</name>
		<name-loc>Хронопортация другого</name-loc>
		<description-loc>Особое; Сопротивление по Воле(Will)+1
Аналогично Телепортация другого (M147), за исключением того, что объект – Хронопортируется от или к заклинателю. Применяются: штраф за расстояния между заклинателем и объектом (как у Обычных заклинаний), штраф Хронопортации за отрезок времени, на который заклинатель хочет смеить объект. Важное различие между Хронопортацией и Хронопортацией другого, если заклинатель провалит бросок или Сопротивление заклинанию успешно, объект не перемещается!
Стоимость: как у Хронопортации, с учетом множителя веса из Телепортации другого.
Требование: Хронопортация.
Предмет
Посох или палочка. Используется только магами. Энергостоимость создания: 4.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M81</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">timeport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Timeslip</name>
		<name-loc>Хроносдвиг</name-loc>
		<description-loc>Блокирующее
Избегите атаки хронопортируясь с ее линии. Заклинатель сдвигается на несколько секунд в будущее, появляясь в том же месте - если оно не загромождено или занято! Место не свободно, если там кто-то стоит. Любая меньшая преграда заклинанием игнорируется.
Заклинателю нужен бросок Чувства тела, чтобы действовать в ход своего появления. Если его начальное местоположение остается загроможденным или занятым, заклинатель остается в лимбо, вновь появляясь, как только место очистится... даже если потребуются годы! Критические ошибки, как известно, приводят к подобным катастрофическим последствиям.
Если при сотворении Хроносдвига у заклинателя были какие-либо заклинания, требующие концентрации,  они автоматически истекают (кроме тех, где объект – заклинатель). Так же, заканчивается любое заклинание, подержание которого ожидается во время хроносдвига (но см., Поддержать заклинание, M128).
Стоимость: 1 за секунду намеченного смещения. Штраф -1 к броску заклинания за каждую секунду смещения кроме первой.
Требование: Хронопортация.
Предмет
Одежда, украшение или часы. Энергостоимость создания: 500.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1/sec #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M81</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">timeport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Timeslip Other</name>
		<name-loc>Хроносдвиг другого</name-loc>
		<description-loc>Блокирующее
Хроносдвиг применяемый на других.
Стоимость: 1 за секунду намеченного смещения. Штраф -1 к броску заклинания за каждую секунду смещения кроме первой.
Требование: Хронопортация.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1/sec #</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M81</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">timeport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Planar Summons (@Plane@)</name>
		<name-loc>Планарный вызов</name-loc>
		<description-loc>Особое
Вызывает существо, вроде демона или Нечто о Чем Человечество Не Догадывается, из другого плана существования. Склонности и способности существа определяет Мастер. Каждый план требует своего заклинания Планарного вызова. Для некоторых исключительно мощных сущностей могут понадобиться собственные заклинания! Если версия используемого Планарного вызова не определяет отдельную сущность, заклинатель не может контролировать вызванного заклинанием.
Планарный вызов не может использоваться в плане, для которого предназначен. Когда существо появляется, заклинатель должен немедленно попытаться управлять им. Считайте это Быстрым соревнование между умением Планарного вызова и Воле(Will)й сущности. Заклинатель в +4, если он знает «истинное имя существа».
Победив, заклинатель может дать сущности единственную команду, которую оно должно выполнить. При завершении этой задачи или, в любом случае, через час сущность, обычно, изгоняется. Однако, некоторые сильные сущности могут оставаться столько, сколько пожелают...
При ничьей или проигрыше заклинателя, существо будет реагировать ужасно. «Злое» совершит насилие или вандализм, а «хорошее», вероятно, отбудет в гневе и пожалуется богам заклинателя. Дикие или хаотические существа склонны заниматься воровством и вредительством. Крайне чуждые сущности могут отреагировать странными и непредсказуемыми способами.
Длительность: Обычно пока задача не решена или один час, что меньше.
Стоимость: 1 за 10 очков персонажа использованных для создания призванной сущности. Минимальная энергостоимость 20 (хотя не всегда вызовет 200-очковое существо). Мастер тайно определяет способности всех вызванных существ. Не может быть поддержано.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 1 и, по крайней мере, по одному заклинанию из 10 различных школ.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>20#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 hr</duration>
		<reference>M82</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Planar Visit (@Plane@)</name>
		<name-loc>Планарный визит</name-loc>
		<description-loc>Особое
Заклинатель оставляет тело и свободно блуждает как дух в другом плане существования. Он полностью иллюзорен и не может ни на что влиять или любым образом взаимодействовать с окружением (с другой стороны, это дарует полную физическую невосприимчивость к любой окружающей среде). Нельзя даже сотворять заклинания, хотя можно поддержать существующие. Заклинатель так же неуязвим к магии, не влияющей на разум или духов (коим он является, пока не вернется в тело). Он незаметен обычным чувствам, только магия (Астральное зрение, Почуять духов, Почуять наблюдение и подобные заклинания) обнаружит его присутствие.
Для путешествия в каждый план или измерение есть свое заклинание. Какие заклинания существуют, и точные детали измерений, куда они ведут – к Мастеру. Чувства объекта меняются, чтобы соответствовать среднему обитателю плана. В плане бесконечного мрака у него было бы Зрение в темноте, в астральном – Астральное зрение, в измерении, где все формы жизни чувствуют только звук – Сканирование (Сонар). Посещение очень странных меняющихся планов может быть опасным для психического здоровья не подготовленного путешественника...
Наиболее распространенный план, посещаемый в большинстве миров – астрал, сосуществующий с обычным миром и позволяющий посетителям наблюдать невидимые места реального мира (по крайней мере, невидимый не уроженцами астральной сферы, если такие есть). Во время астрального путешествия заклинателя движется с удвоенной Скоростью без нагрузки и может проходить сквозь стены, горы, существа... Он может также спуститься в недра земли или подняться высоко в атмосферу. Блокирование астрала (M159), Пентаграмма (M124) и «Сплошные» заклинания (M170) остановят его, а Отталкивание духов (M158) воспрепятствует его вторжению. Если заклинание заканчивается прежде, чем дух воссоединяется с телом или если телу вредят, когда дух находится далеко, нужен бросок ЗД(HT), со штрафами за расстояние (M14), чтобы остаться в живых! Само собой разумеется, его тело полностью беззащитно на время заклинания, а обычная медицинская экспертиза покажет, что оно (едва) живо.
Длительность: 1 минута.
Стоимость: 4 на сотворение, 2 на поддержание. Некоторые планы могут стоить больше, налагать штраф к умению или то и другое сразу.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 2 и или Проекция, или Планарный вызов.
Предмет
(a) Посох, палочка или украшение. Используется только магами, действует только на владельца. Энергостоимость создания: 1.000. Хотя предмет остается с телом пока дух прогуливается, он может использоваться для поддержания заклинания. (b) Оружие. Используется только магами. Призрачный аналог этого предмета сопровождает дух владельца! Энергостоимость создания: 2.000 за фунт (минимум 1).</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 min</duration>
		<reference>M82</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">projection</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">planar summons (@plane@)</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Rapid Journey</name>
		<name-loc>Быстрое путешествие</name-loc>
		<description-loc>Особое
Подобно Теле- и Хронопортации, но предусматривает немедленную обратную поездку. Работает только для заклинателя. Не работает с Планарным смещением. Все, что несет заклинатель, вплоть до Тяжелой нагрузки, отправляется с ним.
Если бросок умения провален, заклинатель остается на месте, и получает обычные штрафы за проваленную Теле- или Хронопортацию (возможны повреждения, дезориентация, оглушение). Щит телепортации, сопротивляется дважды, при отправке и возвращении. Сразу по прибытию к месту назначения, заклинатель должен тратить ЕУ(FP), чтобы оставаться там. Как только поддержка присутствия прекращена (включая провал броска на отвлечение), он вернется в начальное место или время.
Обратная поездка обычно не может провалиться. Но если сотворение заклинания удалось слегка (3 или меньше), то чтобы вернуться к отправной точке, надо делать броски ИН(IQ) (со штрафами за расстояние/время), во время поддержки заклинания. Можно делать только один бросок в минуту. Если заклинатель затем прекратит поддержку, то останется застрявшим там, куда или когда он отправился. Он также может застрять, если оглушен или попал в зону без маны.
Это также заклинание Движения.
Длительность: 1 минута.
Стоимость: Как Теле- или Хронопортация, плюс четверть стоимость поездки в минуту на поддержание.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 3 и Телепортация (для Быстрого путешествия в пространстве) или Хронопортации (для Быстрого путешествия во времени, или во времени и пространстве).
Предмет
Посох или палочка. Используется только магами. Энергостоимость создания: 5.000.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M82</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">teleport</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">timeport</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Beacon</name>
		<name-loc>Маяк</name-loc>
		<description-loc>Область
«Смягчает» местное пространство-время, делая область эффекта легкой для теле- и хронопортации или смещения плана. При отправке к маяку энергостоимость и штрафы делятся на два (округлять в меньшую сторону). Маяк также можно использовать для помощи в телепортации объекта из его зоны к заклинателю.
Маяк не будет личным; любой заклинатель, волшебно перемещающий себя (или кого-то еще) в область, получит выгоду от заклинания (хотя у навсегда зачарованных областей могут быть Доступ или Имя, см. M68).
Заклинатель, при сотворении, должен определить, каким заклинаниям путешествия его маяк помогает. Многоцелевой маяк не требует добавочной стоимости создания.
Это - также заклинание Движения.
Длительность: 24 часа.
Базовая стоимость: 10 на сотворение. Половина на поддержание.
Время сотворения: 30 секунд.
Требование: Телепортация, Хронопортация или Смещение плана. Маг должен знать Телепортацию, чтобы создать маяк телепортации, Хронопортацию, чтобы создать маяк хронопортации, Смещение плана, чтобы создать маяк смещения плана.
Предмет
(a) Любую область можно навсегда зачаровать как маяк телепортации за 100-кратную обычную энергостоимость. (b) Любой объект можно зачаровать как портативный маяк; любая попытка магического путешествия в район объекта получит премию. Энергостоимость создания: 1.500.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>24 hrs</duration>
		<reference>M83</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">timeport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">plane shift</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Phase</name>
		<name-loc>Фазировать</name-loc>
		<description-loc>Блокирующее
Избегите нападения, на мгновение выключаясь из плана. Заклинатель фактически становится эфирным на время достаточное для прохождения атаки сквозь него. Он не исчезает и не теряет возможность отслеживать окружение; бросок Чувства тела не нужен.
Стоимость: 3.
Требования: Магичность(Magery) 3 и или Планарное смещение, или Эфирное Тело.
Предмет
Одежда или украшение. Энергостоимость создания: 1.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M83</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="starts with">plane shift</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">ethereal body</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Phase Other</name>
		<name-loc>Фазировать другого</name-loc>
		<description-loc>Блокирующее
Как Фазироваться, но используется других.
Стоимость: 3.
Требование: Фазироваться.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 2.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M83</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">phase</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Plane Shift (@Plane@)</name>
		<name-loc>Планарное смещение</name-loc>
		<description-loc>Особое
Физически перемещает заклинателя вместе с вещами (до Тяжелой нагрузки) - в конкретный план. Каждый план требует своего собственного Планарного смещения. Это – путь в один конец. Чтобы вернуться, заклинатель должен знать Планарное смещение для своего домашнего плана или добраться до мага другого плана, который его Изгонит (M156).
Заклинание не дает специальной невосприимчивости к среде плана. Чтобы благополучно посетить план, где естественные условия - вакуум, пламя, и т.д., надо изучить защитные заклинания.
Длительность: Постоянное.
Стоимость: 20. Некоторые планы могут стоить больше, налагать штраф к умению или то и другое сразу.
Время сотворения: 5 секунд.
Требование: Планарный вызов для того же плана.
Предмет
Любой предмет, отправляет в единственный план. Энергостоимость создания: 100-кратная стоимости сотворения для плана.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M83</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">planar summons (@plane@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Plane Shift Other (@Plane@)</name>
		<name-loc>Планарное смещение другого</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)+1
Как Планарное смещение, но используется на любом существе или объекте. Объект, не ожидавший перемещения, должен пробросить умение Чувства тела или будет дезориентирован на секунду.
Длительность: Постоянное.
Стоимость: 20. Некоторые планы могут стоить больше и/или налагать штраф к умению.
Время сотворения: 5 секунд.
Требование: Планарное смещение.
Предмет
Палочка, посох или украшение. Используется только магами, посылает объект в единственный план. Энергостоимость создания: 100-кратная стоимости сотворения для плана.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M83</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">plane shift (@plane@)</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Door</name>
		<name-loc>Создать проход</name-loc>
		<description-loc>Обычное
Сотворенное на ближайшей стороне однородной преграды (стена, изгородь, утес и т.д.), создаст краткосрочные врата малой дальности, ведущие на другую сторону. Внутреннее расстояние фактически не проходится пользователями двери - они одновременно телепортируются от ближней стороны к дальней.
Заклинание имеет преимущество перед Телепортацией, разрешая доступ к местам, неизвестным заклинателю и перемещения более чем с Тяжелой нагрузкой.
Модификаторы: штраф -1 за ярд толщины преграды, нет штрафа, если толщина преграды пол ярда или меньше. Мастер не должен говорить игроку размер штрафа, надо просто сказать потерпело ли заклинание неудачу или нет.
Длительность: 10 секунд.
Стоимость: 2 за 10 квадратных футов проема. 2 на поддержание. Как эталон: современная дверь обычно около семи футов высотой и трех шириной. Проход, созданный за 2 энергии, будет значительно меньше.
Время сотворения: 5 секунд.
Требования: Телепортация и любое заклинание «Проходить сквозь».
Предмет
(a) Посох, палочка, украшение или писчие принадлежности (используются для «рисования» двери на препятствии). Энергостоимость создания: 500. (b) Портативная дверь. Активируется (если Сила выше 15 после вычитания штрафа за толщину преграды) прислонением к преграде. Энергостоимость создания: 500 за 10 квадратных футов размера.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/10 sq ft#</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M84</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">walk through</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Divert Teleport</name>
		<name-loc>Отклонить Телепортацию</name-loc>
		<description-loc>Блокирующее; Сопротивление заклинаниям объекта
Сотворенное в ход чьей-либо телепортации, хронопортации или смещении плана, позволит заклинателю навязать место или время назначения объекту.
Заклинатель должен знать отклоняемое заклинание; используется меньшее из умений: Отклонить телепортацию и заклинание объекта. Если заклинатель, например, хочет отклонить телепортацию в смещение плана, он должен знать оба заклинания и использовать меньшее из этих трех умений.
Сопротивление обсчитывается, сравнением величин успеха обоих заклинаний - если телепортирующийся маг преуспевает на 5, то пытающийся отклонить его, должен преуспеть на 6 или выше, чтобы выиграть. Используются обычные штрафы за расстояние между заклинателями Отклонить телепортации и Телепортации (Хронопортации и т.д.) и обычный штраф к умению за место назначения, куда заклинатель направляет телепортера.
Стоимость сотворения равна разнице стоимости для намеченного и нового места. Если мага телепортирующегося на 40 миль (9 энергии) вынуждают переместиться только на 10 ярдов (3 энергии), отклоняющий маг должен заплатить 6 энергии. Та же стоимость была бы, если места назначения полностью обратить. Минимальная стоимость сотворения 3 (высокое умение уменьшает ее обычным образом). Заклинатель платит полную энергостоимость независимо от успеха заклинание.
Пример: Предположим, Северин знает Телепортация-16 и пытается телепортироваться на 100 ярдов к ждущему его вагону (штраф к умению -2, стоимость 4). На расстоянии двух ярдов стоит Элсдон, знающий Отклонить Телепортацию-18 и Телепортация-20, который предпочел бы, чтоб Северин оказался за милю отсюда, как раз над озером (штраф -4, стоимость 7).
Северин предпринимает попытку, тратя 4 энергии и бросая 10. Так как ему нужно 14 или меньше, это успех на 4.
Элсдон используя основное умение 18 (самое низкое из соответствующих заклинаний), получает -2 за расстоянии в два ярда до Северина, и еще -4 за намеченное место. Его эффективное умение 12. Он должен бросить 7 (успех на 5), чтобы выиграть соревнование и отклонить Северина. Получится ли это или нет, расчетная стоимость - 3, таким образом, Элсдон должен заплатить минимум.
Это также заклинание Движения.
Стоимость: Как описано выше; минимум 3.
Требования: Магичность(Magery) 3 и Отследить телепорт.
Предмет
Любой. Используется только магами. Энергостоимость создания: 700.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M84</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">trace teleport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Trace Teleport</name>
		<name-loc>Отследить телепорт</name-loc>
		<description-loc>Информационное; Сопротивление заклинаниям объекта
Сотворенное вскоре после как кто-то или что-то телепортируется, хронопортируется или смещается в/из плана, дает заклинателю видение точки назначения отправленного объекта. Заклинатель также получит хорошее представления о величине штрафа к умению, примененного при сотворении заклинание. При критическом успехе будет известно текущее местоположение, но для преследования в течение минуты после сотворения Отследить телепорт достаточно любого успеха.
Это также заклинание Движения.
Модификаторы: накапливающийся штраф: -1 за каждую минуту, прошедшую между телепортацией и сотворением. Если заклинатель не видел телепортации, еще штраф -5
Стоимость: 3.
Требование: Телепортация, Хронопортация или Смещение плана.
Предмет
Любой. Энергостоимость создания: 100.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M84</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">timeport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">plane shift</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Gate</name>
		<name-loc>Контроль врат</name-loc>
		<description-loc>Обычное; Сопротивление от врат
Вынуждает открытые врата закрыться, закрытые - открыться или наклоняет и перемещает целевые врата, как желает заклинатель. Закрытие постоянных врат не разрушает их, в отличие от временных (для разрушения постоянных врат используют Снять чары).
Заклинание перемещает врата на 3 ярда в секунду. Контроль врат можно также использовать для «выбора» особого места назначение для врат со многими выходами (см. Создать врата).
Как только контроль снят, Врата возвращаются в свое «запрограммированное» состояние, двигаясь к начальному месту на большой скорости и кратчайшим путем.
Если несколько заклинаний Контроль врат действуют сразу на одни Врата, последние сопротивляются единым броском, контроль получит заклинание с наибольшей величиной успеха.
Длительность: 1 минута.
Стоимость: 6 на сотворение, 3 на поддержание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 3 и Искать врата.
Предмет
Посох, палочка или украшение. Используется только магами. Энергостоимость создания: 300.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M85</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">seek gate</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Create Gate</name>
		<name-loc>Создать врата</name-loc>
		<description-loc>Обычное
Создает временный портал, ведущий в другое место, время или измерение – фактически, дыру во времени и пространстве, сквозь которую телепортируются, хронопортируются и/или смещают план к предопределенному месту. Чем больше «расстояния» между вратами и их местом назначения, тем больше энергостоимость и штраф к умению.
Штраф рассчитывается, объединением штрафов соответствующих заклинаний: Телепортация, Хронопортация, Смещение плана. Для расчета энергостоимости, объедините энергетические затраты того же заклинания(й) и умножьте на 10. Это позволит создать врата с проемом до 3x6 ярдов (или равной по площади поверхностью). Создать большие врата не сложнее, но стоит пропорционально больше энергии.
Если заклинание используется для создания постоянных врат, становятся важными еще несколько соображений. Заклинатель(и) должен определить, будут ли они всегда открыты, всегда закрыты или открываться и закрываться в определенных условиях (открываются только на час в полнолуние, открываются только, когда кто-то произносит пароль и т.д.).
Несколько порталов могут вести в одно место. В любой момент может быть открыт только один из них, так что обычен временной цикл открытий, давая в результате эффект единственных врат, ведущих в выбранное место. Они должны быть созданы по отдельности, но все же вести себя как единственные врата. Постоянные врата могут быть «закреплены» на физических воротах; тогда они сопротивляются смещению или разрушению с премией от СП(DR) ворот.
Когда у врат есть компонент Хонопортации, создатель должен определить, перемещают ли они просто на заданное количество времени (1 год в прошлое, например) или же посылают в определенное, неизменное время (скажем, 25 декабря 1066). В последнем случае, так как объекты, прошедшие врата в разных исходных временах, не могут все прибыть в одно и то же время, врата или медленно «дрейфуют» во времени, чтобы создать интервал прибытия, по крайней мере, в секунду или различные объекты попадают в разное «прошлое» (решение Мастера).
Длительность: 1 минута.
Стоимость: 10-ти кратная полной стоимости используемых заклинаний: Телепортация, Хронопортация и Смещение плана (больше для больших врат). Столько же на поддержание. Создание постоянных врат стоит в 100 раз больше.
Время сотворения: 1 секунда за единицу энергии.
Требования: Контроль врат. Заклинатель также должен знать Телепортацию, чтобы создать врата, ведущие в другое место, Хронопортацию, чтобы создать врата, ведущие в другое время или Смещение плана, чтобы создать врата, ведущие в другой план существования.
Предмет
(a) Посох или палочка. Используется только магами. Энергостоимость создания: 1.000. (b) Перо или кисть. Используется только магом, который должен нарисовать схему дверного проема на твердой поверхности. Энергостоимость создания: 900.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>1 min</duration>
		<reference>M85</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">teleport</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">timeport</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="starts with">plane shift</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">control gate</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scry Gate</name>
		<name-loc>Наблюдение через врата</name-loc>
		<description-loc>Обычное
Сотворенное на открытые врата, позволит изображениям, звукам и запахам проникать через них с другой стороны, так же, как если бы каждый всматривался в открытое окно. На другом конце врат никаких соответствующих «окон» не открывается.
Если врата ведут в область, защищенную Стеной защиты от наблюдения, она сопротивляется Наблюдению. Почуять наблюдение может перехватить Наблюдение через врата. Однако Обман наблюдения не сможет его обмануть.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 4 на поддержание.
Время сотворения: 10 секунд.
Требование: Искать врата.
Предмет
(a) Посох, палочка или украшение. Энергостоимость создания: 200. (b) Врата можно заставить показывать их место назначение постоянно; это определяется при их создании и добавляет 100 энергии к стоимости создания. Создатель врат должен знать Наблюдение через врата на уровне равном или большем, чем Создать врата.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M85</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek gate</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Gate</name>
		<name-loc>Искать врата</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление и приблизительное расстояние до ближайших врат. Любые известные врата можно исключить, если заклинатель упомянет их перед началом.
Модификаторы: модификаторы расстояние (M14), -2, если врата в настоящее время закрыты,-5 при поиске места назначения врат, -10 при поиске врата, ведущих в определенное место. Учтите, сами врата могут быть под заклинанием Защита от наблюдения или Скрыть магию.
Стоимость: 3.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, Искать магию и по одному заклинанию каждой из 10 школ.
Предмет
Раздвоенная палочка. Энергостоимость создания: 100.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M85</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">seek magic</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Accelerate Time</name>
		<name-loc>Ускорить время</name-loc>
		<description-loc>Областное; Специальное сопротивление
Обратное к Замедлить время. Время в зоне поражения ускоряется. Все правила пересечения границы области, сопротивления и так далее, как в Замедлить время.
Камни силы перезаряжаются по внешним нормам, и заклинание не ускорит их перезарядку. Конечно, относительное время отдыха может быть увеличено, позволяя магам восстанавливать ЕУ(FP) быстрее.
Длительность: 1 минута (внешнего времени).
Базовая стоимость: 2 для удвоения, 3 для утроения, 4 для учетверения и так далее (предела нет, но см. ниже заклинание Выход из времени). Столько же на поддержание.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2, ИН(IQ) 13 + и, по крайней мере, по два заклинания от каждой из 10 разных школ.
Предмет
Посох или часы. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M86</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hide Object</name>
		<name-loc>Скрыть объект</name-loc>
		<description-loc>Обычное
Объект (должен быть неживым) исчезает в пространстве другого измерения, откуда может быть вызван по желанию. Отказ поддержания заклинание приведет к появлению объекта в воздушном пространстве рядом с заклинателем. Если объект удерживается существом, держатель может сопротивляться заклинанию с ИН(IQ).
Искатель не найдет объекты скрытые этим методом; Слежка потеряет связь на время действия заклинания и вернет ее при появлении объекта вновь в этом мире. Щит телепортации будет мешать заклинанию (например,  начальная величина успеха заклинания Скрыть объект должна быть 5 или выше, чтобы объекта вновь появился в области обычного эффекта Щита телепортации,). Объект появляется в руке заклинателя или в непосредственной близости (по выбору заклинателя).
Длительность: 1 час.
Стоимость: 1 за фунт веса объекта на сотворение. Столько же на поддержание.
Время сотворения: 10 секунд.
Требования: Скрытое пространство и Телепортация.
Предмет
(a) Посох, палочка или украшение. Используется только магами. Энергостоимость создания: 500. (b) Любой объект можно зачаровать на «исчезание» и «появление» по команде владельца. Энергостоимость зачарования: 100 за фунт веса предмета. Популярные чары для незаконных объектов...</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M86</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hideaway</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Sanctuary</name>
		<name-loc>Святилище</name-loc>
		<description-loc>Особое
Открывает портал размером с дверь в карманное измерение. Портал немедленно закроется после того, как заклинатель пройдет через него (конечно, перед ним могут пройти другие). Портал ведет в небольшую, слабо освещенную комнату с голыми стенами без видимых выходов. Когда заклинатель хочет уйти, он просто концентрируется, и портал появится на одной из стен, возвращая к начальной точке отправления. Размер пространства может быть как у куба со стороной в ярдах равной умению заклинателя.
Реальный мир полностью теряет связь с жителями карманного измерения; Искатель не найдет их, Слежка потеряет на время пребывания там (но снова найдет, как только они вернутся) и так далее. Конечно, обратное также верно.
Длительные посещения карманного измерения потребуют создания воздуха, еды и воды (и приличного освещения для комфорта), так же как избавления от загрязнений. Что немного осложнено фактом низкой маны в карманном измерении, все сотворения с -5, и не работает заклинание Восстановление энергии.
Если заклинание истекает или заклинатель теряет сознание, все содержимое комнаты возвращается, как будто телепортированное, каждый обитатель получает 1d повреждений и физическое оглушение, если провалит Чувство тела. То же произойдет с любым глупцом, не вышедшим перед заклинателем!
Если нужно вернуться в реальный мир, но не в точку отправления, заклинатель может сотворить нужное  транспортное заклинание из карманного измерения, как будто от точки входа (если он готов рисковать творить в низкой мане).
Отметьте: описание «стандартной» карманной вселенной, созданной этим заклинанием, ни в коем случае не должно быть взято в качестве евангелия. Менее аскетичная версия может включать богатую (но магическую и временную) обстановку и детали, иллюзорные окна и так далее. В некоторых мирах она определяется представлениями Мастера о дополнительных измерениях. В других – обстановка святилища может быть осознанным или неосознанным отражением личности мага.
Длительность: 1 час.
Стоимость: 5 на сотворение. 5 на поддержание.
Время сотворения: 10 секунд.
Требования: Скрытое пространство и Телепортация.
Предмет
Посох, палочка, украшение или дверь. Используется только магами. Энергостоимость создания: 2.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M86</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hideaway</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Slow Time</name>
		<name-loc>Замедлить время</name-loc>
		<description-loc>Областное; Специальное сопротивление
Время в области замедляется. Чтобы заклинание сработало, все существа в области сотворения нежелающие этого должны провалить сопротивление по большему из ИН(IQ) и СЛ(ST). Предметы и заклинания свободно пересекают границу области. Существам же нужен бросок ИН(IQ) от ментального оглушения.
Длительность: 1 минута (внешнего времени).
Базовая стоимость: половина нормальной «скорости» времени стоит 2, треть – 3, четверть – 4 и так далее (предела нет, но см. ниже заклинание Остановить время). Столько же на поддержание.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2, ИН(IQ) 13 + и, по крайней мере, по два заклинания от каждой из 10 разных школ.
Предмет
Посох или часы. Используется только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M86</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Suspend Time</name>
		<name-loc>Остановить время</name-loc>
		<description-loc>Областное; Сопротивление по ИН(IQ)
Время в области останавливается. Относительно внешнего мира находящиеся в области остановленного времени не будут двигаться, дышать, стареть и даже думать. По ощущениям пострадавших, во время действия заклинания время не течет. Только что они пили чай на приятном весеннем лугу, а в следующий момент уже сидят в круге травы, за которым наступила зима...
Любые возражающие существа в области сотворения сопротивляются с ИН(IQ). Они все должны провалиться, чтобы заклинания подействовало.
С внешней стороны область кажется окруженной абсолютно отражающей поверхностью, которую ничто (включая магию и магических существ) не может пересечь. Объекты от нее отскакивают. Любые заклинания требующие концентрацию вне области немедленно завершатся, если их заклинатель пойман внутри. Так же, закончится любое внешнее заклинание, подержание которого ожидается в течение остановленного времени(но см., Поддержать заклинание, M128).
Длительность: 1 день (внешнего времени).
Основная стоимость: 5 на сотворение. 5 на поддержание.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 3 и Замедлить время.
Предмет
Посох или часы. Используется только магами. Энергостоимость создания: 2.500.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 day</duration>
		<reference>M86</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">slow time</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Time Out</name>
		<name-loc>Выход из времени</name-loc>
		<description-loc>Областное
Область и все в ее пределах временно выходят из потока времени; эффект похож на бесконечное ускорение времени в области. Заклинание сотворяется только изнутри области, с центром на заклинателе (закончится, как только он коснется края), в отличие от Остановить время. Если заклинатель умрет внутри в одиночестве, заклинание никогда не закончится! Он и любые объекты, попавшие в область, кажутся просто исчезнувшими из потока времени.
По ощущениям внешних наблюдателей, область «стареет» мгновенно (может быть заметно, а может и нет). Только что пять Огров атаковали партию, пока их волшебник творил заклинание, а в следующий миг они мертвы, партия исцелена и все уже наотмечались ромом.
Изнутри область ограничена стеной (и покрыта потолком) абсолютной черноты. Кто- или что-либо касающееся края будет немедленно выброшено из области, назад в нормальное время. Что автоматически вызовет ментальное оглушение у любого кроме заклинателя. Снаряды всех видов можно запустить вслепую из области (см. Стрельба в слепую, B389), но не внутрь. Учтите, так как все снаряды вылетевшие из области, появятся в одно и то же внешнее время, стрелок сможет создать внушительный град снарядов, просто небрежно постреливая в течение нескольких субъективных часов...
Заклинания, действующие наружу, просто проваливаются. Требующие концентрации, расположенные внутри области немедленно завершатся, если их заклинатель остался снаружи. Так же закончится любое внутреннее заклинание, поддержание которого ожидается в течение Выхода из времени, если его заклинатель не внутри.
«Поток» маны в области эффекта – ноль. Камни силы не перезаряжаются, чары невозможны и т.д. Маги все еще восстанавливают энергию (физические последствия управления маной проходят независимо от потока маны в местности), но Мастер может решить, что заклинания стоят намного больше или невозможны в области (так как энергия должна быть целиком взята из жизненной силы заклинателя). Полностью зависит от роли маны в сеттинге Мастера.
Длительность: момент (вне времени). В области у заклинателя и всех остальных есть столько времени, сколько нужно.
Базовая стоимость: 5.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 3 и Ускорить время.
Предмет
Посох или часы. Используется только магами. Энергостоимость создания: 2.500.</description-loc>
		<college>Gate</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>Instant</duration>
		<reference>M87</reference>
		<categories>
			<category>Gate</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (gate)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">accelerate time</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body-Reading</name>
		<name-loc>Чтение тела</name-loc>
		<description-loc>Информационное; Сопротивление по Воле(Will)
Создает в уме заклинателя визуальное и тактильное «изображение» внутренностей тела объекта. Полезно для диагностирования боли или болезни неясного происхождения. Заклинание показывает разрывы органа и внутреннее кровотечение, переломы кости и даже пол будущего ребенка. Используются обычные модификаторы расстояний. По существу, это - волшебный эквивалент подробных рентген снимков. Что заклинатель сможет сделать с полученной информацией, зависит от его медицинских навыков.
Не показывает точную природу ядов или болезней, влияющих на объект, но дает +2 любым последующим броскам Яды или Диагноз. Заклинатель должен коснуться объекта.
Модификаторы:-2, если объект отличается по виду от заклинателя (например, эльфийский маг, читающий человека); -4 и ниже, если полностью чуждый!  
Стоимость: 2.
Время сотворение: 30 секунд.
Требование: Чувство жизни или Пробудить
Предмет
Головной убор или украшение. Действует только на носителя. Энергостоимость создания: 200.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>-</duration>
		<reference>M88</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">awaken</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sense life</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Final Rest</name>
		<name-loc>Вечный покой</name-loc>
		<description-loc>Обычное
Сотворенное на труп, делает объект неуязвимым к Некромагии. Дух покойного не может быть вызван, и при этом тело нельзя оживить или Воскресить. Не оказывает физического эффекта на тело. Может быть сотворено в любое время после смерти объекта. Есть накапливающийся  штраф -1 за каждый месяц со дня смерти, до максимума -10. Каждый заклинатель может сделать только одну попытку сотворения для одного объекта.
Заклинание не действует на живых людей и уже поднятых немертвых.
Во многих сеттингах это заклинание - часть похоронных обрядов, и может применяться только духовенством. По желанию, Мастер может заменить требование (prerequisite) Магичности на Дарованную силу (B77)  или Благословени е (B40). В других сеттингах заклинание ненужно; обычных не волшебных похоронных обрядов хватит, чтобы оградить умершего от некромантии.
Обычно считается, что заклинание посылает душу покойного из смертного плана в царство его божества. Однако, кое-кто (обычно члены того или иного культа смерти) полагают, что заклинание работает, разрушая бесплотную душу умершего! 
Это - также заклинание Некромагии.
Длительность: навсегда.
Время сотворения: 10 минут; заклинание всегда церемониальное.
Требования: Магичность(Magery) 1 или  Понимание духов. «Святые» могут сотворить заклинание без любых требований.
Предмет
Заклинанием можно освятить похоронные принадлежности. Энергостоимость создания: 1.200</description-loc>
		<college>Healing/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Permanent</duration>
		<reference>M89</reference>
		<categories>
			<category>Healing</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">spirit empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Energy</name>
		<name-loc>Передать энергию</name-loc>
		<description-loc>Обычное
Восстанавливает потерянные Единицы Усталости объекта из энергии, затраченной заклинателем. Не может увеличить ЕУ(FP) объекта  выше его обычного максимума.
Стоимость: Любое количество; потраченная энергия перейдет объекту как восстановленные ЕУ(FP) (т.е. если заклинатель потратит 5 энергии, объект восстановит 5 ЕУ(FP)). Стоимость не уменьшается с уровнем умения.
Требования: Магичность(Magery) 1 или Эмпатия (B51)
Предмет
Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M89</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<advantage_prereq has="yes">
				<name compare="is">empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Vitality</name>
		<name-loc>Передать здоровье</name-loc>
		<description-loc>Обычное
Временно восстанавливает объекту потерянные Единицы Жизни из энергии, затраченной заклинателем. Не может увеличить ЕЖ(HP) объекта выше его обычного максимума. Восстановленные ЕЖ(HP) исчезают через час. Заклинание не может быть поддержано - это только временная мера.
Длительность: 1 час.
Стоимость: Любое количество; потраченная энергия перейдет объекту как восстановленные ЕЖ(HP) (например, заклинатель тратит 5 энергии - объект восстановит 5 ЕЖ(HP)). Стоимость не уменьшается с уровнем умения. Не поддерживается; должно сотвориться заново.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 250.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M89</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Recover Energy</name>
		<name-loc>Восстановление энергии</name-loc>
		<description-loc>Особое
Отдохните и восстановите Единицы Усталости быстрее обычного, вытягивая энергию из маны вокруг. Каждые 10 минут обычный человек восстанавливает 1 ЕУ(FP). Маг, знающий это заклинание с навыком 15 и выше, восстанавливает 1 ЕУ(FP) каждые 5 минут; 20 и выше – 1 ЕУ(FP) каждые 2 минуты. Дальнейшее улучшение невозможно. Действует только на заклинателя и не может восстановить ЕУ(FP) другим.
Маг должен просто спокойно отдохнуть, ритуалов или бросков не требуется. Отдыхая, можно поддерживать обычные заклинания, не требующие концентрации.
Заклинание не функционирует в низко или безмановых областях.
Стоимость: Нет.
Требования: Магичность(Magery) 1 и Передать Энергию.
Предмет
Драгоценность. Позволяет носителю восстанавливаться, как под действием заклинания с уровнем равным Силе  предмета; всегда включен. Очень редкий предмет! Энергостоимость создания: 1.000; должен быть сделан из сплава золота и платины (минимальная цена маленького кольца $500).</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>0</casting_cost>
		<maintenance_cost>0</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Special</duration>
		<reference>M89</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Share Energy</name>
		<name-loc>Поделиться энергией</name-loc>
		<description-loc>Обычное
Делает ЕУ(FP) заклинателя доступными для другого мага творящего заклинание. Можно сотворить только на себя. Заклинатель должен указать, кто может черпать ЕУ(FP) в следующую секунду, и никто другой не сможет это сделать. Можно выбрать более одного мага, и за секунду можно черпать не более 5 ЕУ(FP). Заклинатель может определить более низкий порог! ЕЖ(HP) не может использоваться для сотворения заклинания. 
Если указанный маг не черпает ЕУ(FP) до следующего хода заклинателя, действие закончится, стоя одну ЕУ(FP). Маг, творящий другое заклинание, не должен знать о существовании Поделиться энергией. Поскольку он творит заклинание, то будет чувствовать внешнюю энергию пытающуюся помочь ему - можно уступить ей или нет, платя стоимость самому.
Черпать энергию можно только из одного заклинания Поделиться энергией. Если сотворено более одного заклинания, используется ближайшее; из двух одинаково близких выбирается случайным броском.
Длительность: ЕУ(FP) должны использоваться в данный ход. Не поддерживается. 
Стоимость: Удвоенное количество энергии фактически потраченной магом, черпающим ЕУ(FP). Энергия заклинателя усиливает заклинание другого мага. ЕУ(FP), сверх необходимых заклинанию, не передаются – для этого используется Передать энергию. Стоимость, сотворения не уменьшается высоким навыком, всегда тратится минимум 1 ЕУ(FP).
Требования: Передать энергию.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2-10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M89</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Awaken</name>
		<name-loc>Пробудить</name-loc>
		<description-loc>Областное
Приводит объект(ы) в сознание и боевую готовность. Немедленно снимает эффекты оглушения. Если объект очень утомлен (менее 1/3 базовых ЕУ(FP)), заклинание действует в течение часа и стоит ему 1 ЕУ(FP) в конце. Не действует  для тех, у кого 0 ЕУ(FP) или менее. Спящие или без сознания выполняют бросок ЗД(HT), чтобы проснуться, с премией, равной успеху заклинателя. Объект бросает с -3 если он без сознания из-за раны, с -6 если под наркотиками.
Базовая стоимость: 1.
Требования: Передать здоровье.
Предмет
Посох или палочка. Должен коснуться объекта. Энергостоимость создания: 300.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M90</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Relieve Sickness</name>
		<name-loc>Облегчить болезнь</name-loc>
		<description-loc>Обычное; Сопротивление от заклинаний на объекте
Временно облегчает любые внешние симптомы болезни (лихорадка, головокружение, сыпь, кашель, и т.д.). Заклинания Болезнь и Опьянение могут сопротивляться  . Отметьте, лечатся только симптомы. Облегчить Болезнь отрезвит пьяного на время, для постоянного лечения используйте Нейтрализовать Яд.
Длительность: 10 минут.
Стоимость: 2. Не поддерживается, должно быть сотворено повторно.
Время сотворения: 10 секунд.
Требования: Передать здоровье.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 250.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 min</duration>
		<reference>M90</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Contagion</name>
		<name-loc>Дезинфицировать</name-loc>
		<description-loc>Областное
Очищает целевую область от заразных болезнетворных агентов  - микробов, духов болезни, зараженного воздуха, и т.д. – делая ее стерильной и дезинфицированной. Может использоваться для чистки и стерилизации чего угодно, от храма болезнепоклонников  до операционной. Не лечит и не облегчает болезни живых существ; служит только для дезинфекции и очистки объектов и поверхностей. 
Области или объекты очищенные заклинанием, не могут быть источниками инфекции (см. Инфекция, B443) пока не заразятся повторно.
Продолжительность: Пока болезнетворные агенты не вернутся в зачищенную область. 
Базовая стоимость: 3.
Время сотворения: 2 секунды.
Требование: Разложение, Очистка или Вылечить болезнь.
Предмет
Палочка или посох, с образом змеи. Предмет должен коснуться объекта . Энергостоимость создания: 400.

Прекратить спазм
Обычное
Описано в заклинаниях Контроля тела, M35.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M90</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">clean</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">cure disease</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Disease</name>
		<name-loc>Сопротивление болезни</name-loc>
		<description-loc>Обычное
На время действия объект получает иммунитет к болезням, как преимущество Иммунитет к болезням (B80). Также заклинание Защиты и предупреждения.
Длительность: 1 час
Стоимость: 4 на сотворение; 3 на поддержание.
Время сотворения: 10 секунд.
Требования: Дезинфицировать или Здравие.
Предмет
а)  Украшение. Всегда включен, носитель имуннен к болезням. Редкий и ценный предмет! Энергостоимость создания: 1.000 за иммунитет от одной заданной болезни; 2.500 за иммунитет ко всем болезням.
б) Украшение. Всегда включен; предотвращает распространение любой болезни носителя. «Кандалы  прокаженных», например. Энергостоимость создания:250.</description-loc>
		<college>Healing/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M90</reference>
		<categories>
			<category>Healing</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">remove contagion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">vigor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Share Vitality</name>
		<name-loc>Поделиться жизнью</name-loc>
		<description-loc>Обычное
Заклинатель излечивает чьи - либо раны, передавая их себе, теряя столько ЕЖ(HP), сколько вылечил объекту. Увечья объекта остаются - лечится только потеря ЕЖ(HP). Аналогично, новые раны заклинателя не увечат (хотя, конечно, могут лишить сознания  или даже убить; заклинание не имеет «сети безопасности» для чрезмерно добрых волшебников). Заклинатель не получает обычный штраф к навыку за трату ЕЖ(HP) на заклинание и за повторное сотворение на тот же объект.
Длительность: Навсегда; заклинатель может быть излечен от новых ран обычным или магическим способом.
Стоимость: Не тратит энергии; высокий уровень влияет только на время сотворения.
Время сотворения:1 секунда на переданную ЕЖ(HP).
Требования: Передать здоровье.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>None</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec/HP</casting_time>
		<duration>Permanent</duration>
		<reference>M90</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cure Disease</name>
		<name-loc>Исцеление болезни</name-loc>
		<description-loc>Обычное
Устраняет один тип болезни или инфекции из тела объекта. Успешный бросок Диагноза (заклинателем, или кем-то другим) должен предшествовать сотворению; в противном случае используйте заклинания со штрафом -5! Не лечит повреждения, нанесенные болезнью, только устраняет ее саму.
Длительность: Болезнь уходит, но объект не получает иммунитет навсегда
Стоимость: 4.
Время сотворения: 10 минут. Одна попытка.
Требования: Облегчить болезнь и Большое лечение.
Предмет
Палочка или посох с образом змеи. Предмет должен коснуться объекта. Используется только магами. Энергостоимость создания: 800 за излечение от конкретной болезни; 1.500 за предмет, лечащий все болезни.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Permanent</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">relieve sickness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">major healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Healing</name>
		<name-loc>Великое лечение</name-loc>
		<description-loc>Обычное
Восстанавливает все недостающие ЕЖ(HP) объекта. Не устранит ни болезнь или отравление, ни поврежденные или недостающие части тела, но может излечить ЕЖ(HP), потерянные любым образом.
Любой объект может быть вылечен данным заклинанием только раз в день, независимо сотворено ли оно одним заклинателем или разными.
Если есть умение Врач уровня 15 или выше, критическая неудача считается обычной.
Стоимость: 20. Одна попытка в день на один объект.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3 и Большое лечение.
Предмет
Палочка или посох с образом змеи. Предмет должен коснуться объекта. Используется магами либо немагами с умением Врач уровня 25 и выше. Энергостоимость создания: 4.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">major healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Major Healing</name>
		<name-loc>Большое лечение</name-loc>
		<description-loc>Обычное
Восстанавливает объекту до 8 ЕЖ(HP). Не устранит болезнь или отравление, но вылечит повреждение, вызванное ими. 
Другие функции заклинания такие же, как в Малом лечении: -3 к сотворению на тот же объект в тот же день, и умение Врач уровня 15 и выше для смягчения эффекта критической неудачи.
Штрафы за повторное сотворение накапливаются отдельно для Малого и Большого лечения. Заклинатель может сотворить оба заклинания на один объект за день без штрафа.
Стоимость: от 1 до 4. Удвоенное число ЕЖ(HP) восстановится.
Требования: Магичность(Magery) 1 и Малое лечение.
Предмет
Палочка или посох с образом змеи. Предмет должен коснуться объекта. Используется магами либо немагами с умением Врач уровня 20 и выше. Энергостоимость создания: 1.500.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Minor Healing</name>
		<name-loc>Малое лечение</name-loc>
		<description-loc>Обычное
Восстанавливает объекту до 3 ЕЖ(HP). Не устранит болезнь или отравление, но вылечит повреждение, вызванное ими.
Заклинание опасно, если заклинатель сотворяет его несколько раз в день на один и тот же объект. Если пробуете, бросаете c -3 для первого повтора, -6 для второго, и так далее.
Если есть умение Врач   уровня 15 и выше, критическая неудача считается обычной, если заклинание не сотворено повторно на тот же самый объект.
Стоимость: от 1 до 3. Столько же ЕЖ(HP) восстановит объект.
Требования: Передать здоровье.
Предмет
Палочка или посох с образом змеи. Предмет должен коснуться объекта. Используется магами либо немагами с умением Врач уровня 15 и выше. Энергостоимость создания: 600.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Poison</name>
		<name-loc>Сопротивление яду</name-loc>
		<description-loc>Обычное
На время действия заклинания объект становится неуязвимым к ядам. Для очень стойких ядов это - только задержка неизбежного, так как следы яда могут все еще быть в организме, к концу действия заклинания! Также заклинание Защиты и предупреждения.
Длительность: 1 час
Стоимость: 4 на сотворение; 3 на поддержание.
Время сотворения: 10 секунд.
Требования: Здравие.
Предмет
Драгоценность,  должна иметь картину единорога. Всегда включен; владелец имунен к ядам. Редкий и дорогой предмет! Энергостоимость создания: 500 за иммунитет к конкретному яду, 4.000 за сопротивление всем ядам.</description-loc>
		<college>Healing/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 Hour</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">vigor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stop Bleeding</name>
		<name-loc>Остановить кровотечение</name-loc>
		<description-loc>Обычное
Объект сразу прекращает кровоточить, как будто перевязанный кем-то с навыком Первой помощи (B195). Это восстанавливает 1 ЕЖ(HP), и препятствует их дальнейшей потери, при использовании дополнительных правил кровотечения (B420). Объект, может, не получить дальнейшей выгоды из перевязки тех же самых ран. Заклинание может также использоваться, чтобы стабилизировать смертельную рану (B423), за существенно большую стоимость.
Длительность: Навсегда, хотя более поздние раны будут кровоточить как всегда.
Стоимость: 1, чтобы прекратить кровотечение нормальной раны; 10, чтобы стабилизировать смертную рану.
Требование: Передать здоровье.
Предмет
Любой Предмет с изображением пеликана. Препятствует кровотечению владельца и страданию от смертельных ран. Энергостоимость создания: 500.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 or 10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M91</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Instant Neutralize Poison</name>
		<name-loc>Мгновенная нейтрализация яда</name-loc>
		<description-loc>Обычное
То же что Нейтрализовать яд, но действует мгновенно.
Стоимость: 8. Одна попытка в день.
Требования Магичность(Magery) 2 и Нейтрализовать яд.
Предмет
Посох или палочка с образом змеи. Используется магами либо немагами с умением Врач-20 и выше. Предмет должен коснуться объекта. Энергостоимость создания: 800 за предмет, лечащий определенный яд, 3.000 за предмет, лечащий любой яд.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">neutralize poison</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Neutralize Poison</name>
		<name-loc>Нейтрализовать яд</name-loc>
		<description-loc>Обычное
Устраняет все следы одного выбранного яда из тела объекта. Успешный бросок Ядов (заклинателем или другим персонажем) должен предшествовать сотворению, чтобы определить очищаемый яд; в противном случае используйте заклинания со штрафом -5! Бесполезно против алхимических эликсиров, кроме наносящих прямой урон. Не лечит существующие повреждения, только удаляет сам яд, предотвращая дальнейшие.
Длительность: Навсегда.
Стоимость: 5.
Время сотворения: 30 секунд (остерегайтесь быстродействующих ядов!). Одна попытка.
Требования: Магичность(Magery) 3 и Проверить пищу либо Исцеление болезни.
Предмет
Посох или палочка с образом змеи. Используется магами либо немагами с умением Врач-20 и выше. Предмет должен коснуться объекта. Энергостоимость создания: 400 за предмет, лечащий определенный яд, 1.500 за предмет, лечащий любой яд.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<skill_prereq has="yes">
				<name compare="is">poisons</name>
				<specialization compare="is anything"></specialization>
			</skill_prereq>
			<prereq_list all="yes">
				<spell_prereq has="yes">
					<name compare="is">test food</name>
				</spell_prereq>
				<prereq_list all="no">
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="contains">one college (healing)
						<level compare="at least">3</level>
					</notes></advantage_prereq>
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="is anything"></notes>
						<level compare="at least">3</level>
					</advantage_prereq>
				</prereq_list>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">cure disease</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Relieve Addiction</name>
		<name-loc>Облегчить привыкание</name-loc>
		<description-loc>Обычное
Частично заменяет «ежедневную дозу» некоторых препаратов, требуемых объекту. Объект все еще будет чувствовать психологические эффекты пропуска дозы (т.е. все еще требуется бросок ЗД(HT) модифицированный Воле(Will)й  для учета дней до избавления от привыкания), но не будет страдать от физических повреждений при ломке .
Модификаторы: -4, если заклинатель сотворил заклинание на себя, и накапливающийся по -4 за каждый следующий день сотворения на тот же объект (таким образом, заклинанию становится все труднее и труднее заменить препарат). Кроме того, штраф абстиненции, свойственный препарату, применяется к любому сотворению!
Продолжительность: 1 день.
Стоимость: 6. Не поддерживается.
Время, чтобы сотворить: 10 секунд.
Требование: Нейтрализовать яд.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 day</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">neutralize poison</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Relieve Madness</name>
		<name-loc>Облегчить безумие</name-loc>
		<description-loc>Обычное
Временно восстанавливает здравомыслие объекта, освобождая его от одного Заблуждения, Фобии, Принуждения, или наведенного заклинанием Безумия (по выбору заклинателя). Заклинания Безумие и Постоянное Безумие сопротивляются данному.
Это - также заклинание Контроля разума.
Длительность: 10 минут.
Стоимость: 2. Не поддерживается.
Время сотворения: 10 секунд.
Требования: Передать здоровье и Мудрость.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 800.</description-loc>
		<college>Healing/Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 min</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wisdom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Restore Hearing</name>
		<name-loc>Восстановить слух</name-loc>
		<description-loc>Обычное
Схож с Восстановить зрение, но для слуха. Барабанные перепонки и другие органы слуха не должны полностью отсутствовать.
Длительность: 1 час.
Стоимость: Половина восстановленных очков слуха (Восп + Обостренный слух); половина на поддержание.
Время сотворения: 5 секунд.
Требования: Малое лечение и или Поражение глухотой или Обостренный слух.
Предмет
Украшение (сережки особенно подходят) или одежда. Всегда включен. Энергостоимость создания: 1.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 Hour</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">keen hearing</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">strike deaf</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Restore Memory</name>
		<name-loc>Восстановить память</name-loc>
		<description-loc>Обычное
Используется, для лечения жертв потери памяти, обычной или волшебной. Восстанавливает один забытый факт или навык за раз. Заклинание Забвения сопротивляется; Постоянное забвение сопротивляется с +5. Это заклинание не разрешает объекту вспомнить что-то, чего он фактически никогда не запоминал (но см. заклинание Вспомнить, M106).
Рискованно применять больше раза в день на том же объекте: заклинание повторно сотворяется с накапливающимся штрафом -3. Критическая неудача очень опасна – искомый фрагмент памяти разрушается навсегда, и объект погружается в пугающее чередование похороненных воспоминаний, длящуюся 2d минуты, что вызывает Проверку испуга с -6.
Если у заклинателя есть навык Психологии 15 и выше, «критическая неудача» считается обычной - если он уже не попробовал заклинание несколько раз за этот день на данном объекте.
Длительность: память восстанавливается навсегда.
Время сотворения: 10 секунд.
Стоимость: 3.
Требования: Пробудить и ИН(IQ) 11 или выше.
Предмет
Палочка или посох, с изображением медведя. Предмет должен коснуться объекта. Энергостоимость создания: 600.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" compare="at least">11</attribute_prereq>
			<spell_prereq has="yes">
				<name compare="is">awaken</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Restore Sight</name>
		<name-loc>Восстановить зрение</name-loc>
		<description-loc>Обычное
Временно восстанавливает зрение объекта, независимо от того, что вызвало потерю (если природа потери волшебная, соответствующие заклинания сопротивляются данному). Глаза не должны полностью отсутствовать (требует Регенерации). Для постоянного лечения, используйте Восстановление.
Длительность: 1 час.
Стоимость: Половина восстановленных очков Зрения (Восп + Обостренное зрение ); половина на поддержание.
Время сотворения: 5 секунд.
Требования: Малое лечение и или Поражение слепотой или Обостренное зрение .
Предмет
Украшение или одежда. Всегда включен. Энергостоимость создания: 1.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M92</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">keen vision</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">strike blind</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Instant Regeneration</name>
		<name-loc>Мгновенная регенерация</name-loc>
		<description-loc>Обычное
То же что Регенерация, но работает мгновенно.
Стоимость: 80. Одна попытка.
Требования: Магичность(Magery) 3 и Регенерация.
Предмет
Палочка или посох, с образом змеи. Используется только магами. Предмет должен коснуться объекта. Энергостоимость создания: 4.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>80</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">regeneration</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Instant Restoration</name>
		<name-loc>Мгновенное восстановление</name-loc>
		<description-loc>Обычное
То же что Восстановление, но работает мгновенно.
Стоимость: 50. Одна попытка.
Требования: Магичность(Magery) 2 и Восстановление.
Предмет
Палочка или посох, с образом змеи. Используется только магами. Предмет должен коснуться объекта. Энергостоимость создания: 2.500.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>50</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">restoration</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Regeneration</name>
		<name-loc>Регенерация</name-loc>
		<description-loc>Обычное
Выращивает заново одну потерянную конечность или глаз.
Длительность: Навсегда.
Стоимость: 20. Одна попытка.
Время сотворения: 1 минута на сотворение; 1 месяц на завершение процесса регенерации. Регенерирующая часть не может использоваться, пока не пройдет весь месяц.
Требования: Магичность(Magery) 2 и Восстановление.
Предмет
Палочка или посох, с образом змеи. Используется только магами. Предмет  должен коснуться объекта. Энергостоимость создания: 3.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">restoration</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Relieve Paralysis</name>
		<name-loc>Облегчить паралич</name-loc>
		<description-loc>Обычное
Временно возвращает объекту возможность использовать искалеченные или парализованные конечности. Конечно, если они не отсутствуют полностью (требует Регенерации). Конечности ослабевают без использования, поэтому Мастер должен на свое усмотрение определить ЛВ(DX) и СЛ(ST) штрафы к использованию. 
Продолжительность: 1 минута.
Стоимость: Равна порогу калечащего вреда этой части тела . Столько же на поддержание.
Время, чтобы сотворить: 10 секунд.
Требование: Остановить Паралич.
Предмет
Драгоценности или одежда. Всегда включен. Энергостоимость создания: 200 за восстановленную единицу из калечащего порога (если калечащий порог носителя ваше ёмкости  предмета, рекомендуется учесть разницу как штраф к ЛВ(DX) и СЛ(ST) для конечности)</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">stop paralysis</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Restoration</name>
		<name-loc>Восстановление</name-loc>
		<description-loc>Обычное
Возвращает возможность использовать одной искалеченной конечности, или поврежденного глаза, также восстанавливает слух, обоняние, и т.д. Не действует на потерянную конечность или глаз (требует Регенерации). Если часть тела ампутирована и не повреждена, можно попробовать восстановить ее в течение часа, со штрафом -5!
Длительность: Навсегда.
Стоимость: 15. Одна попытка.
Время сотворения: 1 минута, на сотворение; 1 месяц на завершение процесса восстановления. Весь месяц конечность не может использоваться; она просто не будет работать, даже если  кажется здоровой.
Требования: Либо Большое лечение, либо любые два из Облегчить паралич и различных заклинаний «Восстановить».
Предмет
Палочка или посох, с образом змеи. Употребляется только магами. Предмет должен коснуться объекта.  Энергостоимость создания: 2.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>15</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">major healing</name>
			</spell_prereq>
			<prereq_list all="yes">
				<prereq_list all="yes">
					<spell_prereq has="yes">
						<name compare="is">relieve paralysis</name>
					</spell_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<name compare="contains">restore</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Restore Speech</name>
		<name-loc>Восстановить речь</name-loc>
		<description-loc>Обычное
Схож с Восстановить зрение, но для речи. Глотка и голосовые связки не должны полностью отсутствовать.
Длительность: 1 час.
Стоимость: 5 на сотворение; 3 на поддержание.
Время сотворения: 5 секунд.
Требования: Малое лечение и или Поражение немотой, или Великий голос.
Предмет
Украшение или одежда. Всегда включен. Энергостоимость создания: 1.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 Hour</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">great voice</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">strike dumb</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stop Paralysis</name>
		<name-loc>Остановить паралич</name-loc>
		<description-loc>Обычное
Противодействует временному параличу (из-за заклинания, парализующего оружия, и т.д.). Постоянные заклинания (такие, как Паралич конечности или Полный паралич) получают бросок сопротивления.
Стоимость:1 за конкретную конечность; 2 за все тело.
Требования: Или Малое лечение и Паралич конечности или Большое лечение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 200.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 or 2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M93</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">major healing</name>
				</spell_prereq>
				<prereq_list all="yes">
					<prereq_list all="yes">
						<spell_prereq has="yes">
							<name compare="is">minor healing</name>
						</spell_prereq>
					</prereq_list>
					<spell_prereq has="yes">
						<name compare="is">paralyze limb</name>
					</spell_prereq>
				</prereq_list>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cleansing</name>
		<name-loc>Очищение</name-loc>
		<description-loc>Обычное; специальное сопротивление
Чистит ткани объекта от любых инородных тел, включая иглы кактуса или дикобраза, наконечники стрел и копий, пули, осколки, и т.д. Также устраняет бактерий и паразитов (только внешних). Не работает  против болезней, ядов или наркотиков. Объект не должен возражать или быть полностью беспомощным (например, связанным или без сознания), и заклинатель должен его коснуться. «Инородные тела», так или иначе являющиеся неотъемлемой частью объекта (золотые зубы, стальные пластины или пруты, стеклянные глаза, киберимпланты, и так далее) должны быть исключены заклинателем, или они могут быть разрушены! Если заклинатель является небрежным (или злонамеренным), каждый предмет сопротивляется отдельно с ЗД(HT)+5 объекта.
Стоимость: 2, чтобы очистить кисть или ступню, 4 для туловища или конечности, 6 для всего тела.
Время сотворения: 3 секунды.
Требования: Малое лечение и Очистить Землю.
Предмет
Палочка или посох с образом змеи. Предмет должен коснуться объекта. Используется только магом либо  немагом с Хирургией-15 и выше. Энергостоимость создания: 250.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/4/6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M94</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">purify earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Halt Aging</name>
		<name-loc>Прекратить старение</name-loc>
		<description-loc>Обычное
Останавливает старения объекта на 1 месяц. Не может быть сотворено повторно, пока не закончится подобное предыдущие заклинание.
Длительность: 1 месяц.
Стоимость: 20. Одна попытка в неделю.
Требования: Магичность(Magery) 2 и по крайней мере 8 заклинаний школы Лечение.
Предмет 
Драгоценность. Всегда включен. Предмет предотвращает старение, пока его носят. За обладание такими вещами разрушаются королевства... Энергостоимость создания: 10.000.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 month</duration>
		<reference>M94</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">healing</college>
				<quantity compare="at least">8</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Healing Slumber</name>
		<name-loc>Целительный сон</name-loc>
		<description-loc>Обычное; Автоматическое сопротивление
Объект впадает в глубокий укрепляющий сон, и излечивает 1 ЕЖ(HP) в течение каждого часа отдыха. Усталость восстанавливается с удвоенной скоростью. 
Объект проснется, когда полностью излечится, или после 8 часов сна; за это время также полностью восстановится усталость от недосыпа. Также может быть разбужен словом заклинателя, раной или заклинанием Пробудить (Удалить Проклятие, Противозаклинание, и т.д.). Возражающий  объект сопротивляется автоматически.
Длительность: до 8 часов (максимум восстанавливает 8 ЕЖ(HP) в день)
Стоимость: 6. За 10 скорость восстановления удвоится. Максимум восстановления не меняется.
Время сотворения: 30 секунд
Требования: Магичность(Magery) 2, Сон и Малое лечение.
Предмет
а) Палочка или посох, с образом змеи. Предмет должен коснуться объекта. Употребляется только магом либо немагом с умением Врач-15 и выше. Энергостоимость создания: 1.000.
б) Любой предмет. Включается, если владелец желает спать или теряет сознание от усталости или ран. Владелец проснется, если предмет убран или по истечению заклинания (если ЕЖ(HP) владельца все еще отрицательны, см. Восстановление сознания, B423). Энергостоимость создания: 900.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6 or 10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Up to 8 hrs</duration>
		<reference>M94</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
	<name>Resurrection</name>
	<name-loc>Воскрешение</name-loc>
	<points>1</points>
	<spell_class>Regular</spell_class>
	<casting_cost>300</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>2 Hours</casting_time>
	<duration>Permanent</duration>
	<college>Healing/Necromancy</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<spell_prereq has="yes">
			<name compare="is">instant regeneration</name>
			<quantity compare="is">1</quantity>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">summon spirit</name>
			<quantity compare="is">1</quantity>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Healing</category>
		<category>Necromancy</category>
	</categories>
	<reference>M94</reference>
	<description-loc>Обычное
Возвращает объект к жизни, при условии, что тело, или большая его часть, доступно (по решению Мастера). Отметьте, что тело, достигшее -10хЕЖ, по определению слишком повреждено для воскрешения. Возрожденный объект имеет 0 ЕУ(FP) и ЕЖ(HP), и должен восстановить их обычным способом. Независимо от убивших ран, все его члены будут целыми. За каждые сутки  после смерти объекта заклинание получает штраф -1.
Это - также заклинание Некромагии.
Продолжительность: Навсегда, пока вас снова не убьют...
Стоимость: 300. Одна попытка.
Время, чтобы сотворить: 2 часа.
Требования: Мгновенная регенерация и Вызов духа.
Предмет
Ходят упорные слухи о волшебном предмете, оживляющем мертвых, но точно ничего не известно.
</description-loc>
</spell>
	<spell version="2">
		<name>Suspended Animation</name>
		<name-loc>Приостановить жизнь</name-loc>
		<description-loc>Обычное; сопротивление по ЗД(HT).
Погружает объект в клинический сон  на неограниченный срок. Пока действует, остановлены эффекты серьезного кровотечения, болезни, возраста, и т.д. Объект не требует ни пищи, ни воздуха, но может быть поврежден огнем, оружием, и другими обычными опасностями.
Продолжительность: Остается в силе пока не нарушено (например, заклинанием Пробудить).
Стоимость: 6.
Время сотворения: 30 секунд.
Требования: Сон и по крайней мере четыре заклинания Лечения.
Предмет
(а) Драгоценности, стрела, или одежда. Всегда включен; немедленно приостанавливает жизнедеятельность владельца. Как только предмет убран, заклинание сразу снимается. Энергостоимость создания: 2.000.
(б) Склеп, гроб, и т.д. Всегда включен; приостанавливает жизнедеятельность находящегося в нём . Энергостоимость создания: 2.000 за место размером с человека.</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Until Awakened</duration>
		<reference>M94</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">healing</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Youth</name>
		<name-loc>Молодость</name-loc>
		<description-loc>Обычное
Омолаживает объект на год.  Автоматически восстанавливает потерянные за тот период уровни атрибутов. Не затрагивает воспоминания, навыки, раны, и т.д., полученный в течение «потерянных» месяцев.
Длительность: Объект начинает молодеть немедленно
Стоимость: 100. Одна попытка в месяц.
Требования: Магичность(Magery) 3 и Прекратить старение</description-loc>
		<college>Healing</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>100</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1</casting_time>
		<duration>Instant; aging starts immediately</duration>
		<reference>M94</reference>
		<categories>
			<category>Healing</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (healing)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">halt aging</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Simple Illusion</name>
		<name-loc>Простая иллюзия</name-loc>
		<description-loc>Областное
Создаёт исключительно визуальный образ, видимый всем, кто может видеть место назначения заклинания. Это может быть как единичный предмет, так и целое зрелище. Если заклинатель сконцентрируется, образ может двигаться в другую область или изменять форму или размеры, вплоть до занятия всей области действия. Любое разумное существо может развеять заклинание «неверием» в образ — выполнить манёвр Концентрация и сделать успешный бросок Воли(Will). Иллюзия развеется автоматически от первой же атаки, любого заклинания, кроме Контроля иллюзии, или прикосновения любого разумного существа.
Длительность: 1 минута.
Базовая стоимость: 1 на сотворение. Половина на поддержание.
Требования: Заклинатель должен быть зрячим и иметь ИН(IQ) не менее 11.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M95</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="starts with">blind</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">11</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Complex Illusion</name>
		<name-loc>Сложная иллюзия</name-loc>
		<description-loc>Областное
Подобно Простой иллюзии, но воздействует и на зрение, и на слух. Иллюзия не развеивается автоматически от заклинания или прикосновения; однако, её развеет любое полученное повреждение.
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение. Половина на поддержание.
Требования: Звук и Простая иллюзия.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M96</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sound</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Illusion Disguise</name>
		<name-loc>Иллюзорная маскировка</name-loc>
		<description-loc>Обычное
Эта иллюзия маскирует живое существо. Сначала заклинатель должен создать иллюзию (при помощи одного из базовых заклинаний иллюзии). Затем, при помощи Иллюзорной маскировки, иллюзия накладывается на объект, так, что она покрывает его и двигается вместе с ним. Чем лучше заклинание Иллюзия, тем надёжнее и долговечнее маскировка; Совершенная иллюзорная маскировка обманет даже осязание. Для поддержания заклинания концентрация на требуется. Иллюзорная маскировка считается одним «включённым» заклинанием.
Длительность: Пока не развеется иллюзия.
Стоимость: 3. Невозможно поддержать.
Требования: Простая иллюзия.
Предмет
Украшение или одежда; предмет творит заклинание Иллюзорная маскировка (качество иллюзии определяется при создании) на носящего. Энергостоимость создания: 150 — Простая иллюзия, 300 — Сложная, 500 — Совершенная. Носящий энергии не отдаёт!</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Until illusion ends</duration>
		<reference>M96</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Illusion Shell</name>
		<name-loc>Иллюзорная оболочка</name-loc>
		<description-loc>Обычное
Эта иллюзия делает так, что выбранный объект выглядит, звучит и осязается по-другому. Базовый объект должен иметь подходящие размеры и форму.  В иллюзию можно не поверить, иначе она стабильна. Однако иллюзия не двигается, если не двигается базовый объект. Повреждения, наносимые базовым объектом, не меняются. Например, Иллюзорная оболочка лошади может быть сотворена на деревянную лошадь. Она будет ржать, бить копытом и пахнуть как настоящая лошадь, но скакать на ней нельзя! Для поддержания иллюзии концентрация не требуется.
Длительность: 1 минута.
Стоимость: 1 для объектов, которые достаточно малы, чтобы их мог унести человек, или 2 для более крупных объектов. Половина на поддержание.
Требования: Простая иллюзия.
Предмет
За в 200 раз большую, чем базовая, стоимостью, заклинание можно наложить навсегда; в такую иллюзию нельзя не поверить!</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 or 2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M96</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Independence</name>
		<name-loc>Независимость</name-loc>
		<description-loc>Областное
Это заклинание может быть наложено на любую подконтрольную иллюзию или создание. Оно позволяет заклинателю «программировать» создание или иллюзию на движение, разговор (если оно может издавать звуки), и даже реакцию заранее установленным образом. Всё это будет выполняться без дальнейшей концентрации заклинателя; это заклинание не считается отдельно «включенным». При столкновении с чем-то, на что оно не «запрограммировано», оно будет ничего не делать или (если это иллюзия) просто исчезнет, по усмотрению Мастера.
Длительность: Пока существует создание или иллюзия.
Базовая стоимость: 2. Поддержание не требуется.
Время сотворения: Минимум 5 секунд. Столько, сколько потребуется игроку для описания инструкций Мастеру, или сколько потребуется времени для прочтения вслух записанных инструкций (запись инструкций поможет избежать споров!). Сложное программирование требует много времени.
Требования: Простая иллюзия.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Varies</duration>
		<reference>M96</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Perfect Illusion</name>
		<name-loc>Совершенная иллюзия</name-loc>
		<description-loc>Областное
Подобно Сложной иллюзии, но воздействует на все органы чувств, кроме осязания; рука просто пройдёт насквозь. Развеять иллюзию можно только заклинаниями Рассеять иллюзия и Рассеять магию. Любое повреждение будет только временной искажать её, выдавая иллюзию, но не развеивая её.  
Длительность: 1 минута.
Базовая стоимость: 3 на сотворение. Половина на поддержание. За удвоенную стоимость можно обмануть даже осязание, хотя от иллюзорного огня не согреешься «по-настоящему».
Требования: Магичность(Magery) 1 и Сложная иллюзия.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M96</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">complex illusion</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (illusion &amp; creation)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Illusion</name>
		<name-loc>Контроль иллюзии</name-loc>
		<description-loc>Обычное; Сопротивление по заклинаниям на объекте
Захватывает контроль над иллюзией, созданной кем-то другим. Если заклинание удалось, энергию для поддержания иллюзии платите вы. Если заклинание провалилось, иллюзию по-прежнему контролирует её создатель. Это заклинание не действует на Иллюзорную маскировку. Если заклинание творится на что-то, что не является иллюзией, энергия тратится, но эффекта нет.
Длительность: Однажды захваченный контроль будет ваш, пока его не перехватит кто-то другой.
Стоимость: 1.
Время сотворения: 2 секунды.
Требования: Совершенная иллюзия.
Предмет
Посох или палочка. Энергостоимость создания: 300. Для контроля иллюзии надо коснуться её предметом.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">perfect illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dispel Illusion</name>
		<name-loc>Рассеять иллюзию</name-loc>
		<description-loc>Обычное; Сопротивление по заклинаниям на объекте
Рассеивает любую иллюзию или иллюзорную маскировку. Не влияет на созданий.
Стоимость: 1.
Требования: Контроль иллюзии.
Предмет
Посох или палочка; предметом надо коснуться иллюзии. Энергостоимость создания: 400.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">control illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Initiative</name>
		<name-loc>Инициатива</name-loc>
		<description-loc>Областное
Заклинание может быть наложено на любую иллюзию или создание, подконтрольное заклинателю, давая им подобие интеллекта, например для того, чтобы они действовали по собственной инициативе. Объект абсолютно лоялен заклинателю и подчиняется ему (или любому, кому приказывает повиноваться заклинатель) так, как может.
Базовая стоимость зависит от того, какие знания заклинатель даёт созданию или иллюзии. Создания начинают с теми ИН(IQ) и ЛВ(DX), которые даны в описании заклинания создания. Иллюзии начинают с ИН(IQ) 0 и ЛВ(DX) 8. ЛВ(DX) и ИН(IQ) объектов могут быть повышены до соответствующих значений заклинателя. Также заклинатель может передавать объектам умения – каждое переданное умение известно объекту на том же относительном уровне, что и заклинателю. Иллюзии и создания под воздействием Инициативы также могут использовать умения по умолчанию.
После сотворения заклинания объект действует сам по себе, пока действие заклинания не закончится. Если объект сбит с толку. Он возвращается обратно к заклинателю за прояснением. Как и Независимость, это заклинание не считается отдельным «включённым» заклинанием, и не требует отдельного поддержания.

Пример:Леди Анна Голдинг создала магического слугу для развлечения своих знатных декадантствующих гостей. Она хочет, чтобы слуга ходил среди гостей, подавал еду, танцевал со знатными дамами и выказывал соответствующее уважение – не нуждаясь в постоянном надзоре, чтобы она сама могла развлечься. Слуга появляется со всеми атрибутами равными 9 и без умений (Леди Анна могла создать и умелого слугу, но она знает заклинание Создать слугу-15 и может поддерживать существование неумелого слуги бесконечно). Леди Анна добавляет 2 очка ЛВ(DX) (повышая её до собственного уровня 11), и 2 очка ИН(IQ) (несколько ниже её собственного ИН(IQ) 14), чтобы сделать слугу остроумнее. Всего добавлено 4 очка атрибутов, что стоит 2 очка.
Далее Леди Анна наделяет слугу умениями Танцы и Хорошие манеры. Её умение Танцы-14 (ЛВ(DX)+3), и так как ЛВ(DX) слуги такая же, его умение будет на том же уровне. Знание леди Хороших манер впечатляет(уровень 15 или ИН(IQ)+1), но слуга не так умён, как она, и его умение Хорошие манеры будет на уровне его ИН(IQ)+1, то есть Хорошие манеры-13. Эти два умения повышают стоимость заклинания ещё на 2 очка, доводя её до 4.Так как слуга радиусом меньше 1 ярда, подойдёт базовая стоимость.
Длительность: Пока существует объект.
Базовая стоимость: 1/3 за каждое дополнительное очко ЛВ(DX) или ИН(IQ) (округлять вверх), плюс 1 очко за каждое умение; минимальная стоимость – 3.
Время сотворения: 10 секунд.
Требования: Независимость и Мудрость.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Varies</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">independence</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wisdom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Inscribe</name>
		<name-loc>Надпись</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Создает надпись или изображение на любой поверхности. Для оценки эстетичности результата используется соответствующая специализация Изобразительного искусства (Каллиграфия, Иллюстрирование и т.д.). Вид послания может быть каким пожелает заклинатель: буквы из серебристого пламени, обычные печатные буквы, буквы из бликов на поверхности воды и так далее. Надпись является неотъемлемой  частью поверхности, она угасает только когда заклинание рассеяно или истекло время его действия. Любое живое существо, на котором попытаются написать может сопротивляться.
Это также заклинание Починки и поломки.
Длительность: 1 минута.
Базовая стоимость: 1 на сотворение. Столько же на поддержание. Минимум 2.
Требования: Простая Иллюзия и Копия текста.
Предмет
(а) Любую надпись или рисунок можно нанести навсегда за стоимость в 20 раз больше базовой. (б) Стилус, кисть и т.д. которые могут оставлять надписи или рисунки на чём угодно, не нуждаясь в чернилах или красках. Энергостоимость создания: 30.</description-loc>
		<college>Illusion &amp; Creation/Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/min 2</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">copy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Know Illusion</name>
		<name-loc>Распознать иллюзию</name-loc>
		<description-loc>Информационное
Сообщает заклинателю является объект иллюзией, или настоящим, или созданием. Заклинатель должен видеть объект.
Стоимость: 2.
Требования: Простая иллюзия.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Phantom</name>
		<name-loc>Фантом</name-loc>
		<description-loc>Областное
Похоже на Совершенную иллюзию, но фантом может препятствовать движению и наносить реальные повреждения. При первом физическом контакте живого существа с фантомом проведите быстрое состязание между эффективным умением заклинателя и ИН(IQ) существа. Если заклинатель проигрывает, то фантом по отношению к этому живому существу во всех смыслах считается Совершенной иллюзией.
Если заклинатель выигрывает, фантом материален, и может наносить удары, хватать, толкать и так далее, как если бы он был настоящим. В том, что касается состязания, нанесённого повреждения и так далее. фантом может иметь любую СЛ(ST) и ЛВ(DX), вплоть до уровня знания магом заклинания Фантом.
При первом сотворении этого заклинания Мастер должен записать величину успеха. Если за одну атаку фантому было причинено столько (или больше) базового повреждения, фантом немедленно рассеивается. На фантом действуют все заклинания, действующие на иллюзии (Рассеять иллюзию, Контроль иллюзии, Независимость и т.д.).
Длительность: 1 минута.
Базовая стоимость: 5. Половина на поддержание. За базовую стоимость 9, фантом может иметь в два раза больше СЛ(ST) (ЛВ(DX) не изменяется).
Требования: Магичность(Magery) 2, Совершенная иллюзия, Помеха и Перемещение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 300; половинная стоимость за предмет, который будет создавать только один вид фантома, определённый при создании предмета.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M97</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (illusion &amp; creation)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">perfect illusion</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hinder</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
	<name>Create Animal</name>
	<name-loc>Создать животное</name-loc>
	<points>1</points>
	<spell_class>Regular</spell_class>
	<casting_cost>Varies</casting_cost>
	<maintenance_cost>Half</maintenance_cost>
	<casting_time>1 sec/cost</casting_time>
	<duration>1 min</duration>
	<college>Illusion &amp; Creation</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
		<spell_prereq has="yes">
			<name compare="is">create water</name>
		</spell_prereq>
		<spell_prereq has="yes">
			<name compare="is">create object</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Illusion &amp; Creation</category>
	</categories>
	<reference>M98</reference>
	<description-loc>Обычное
Создаёт животное (ИН(IQ) не больше 5), выполняющее, пока существует, ментальные команды заклинателя. Созданное животное существует, пока заклинатель не прекратит поддерживать заклинание или пока животное не убьют, после чего оно растворяется. Животное должно быть идентично «реальному» живому существу, известному заклинателю. Вы не можете создать воображаемое существо, или даже реальное, если только слышали о нём. Также вы не сможете создать медведя с отравленными клыками… впрочем, некоторые волшебники изредка разрабатывают тайные вариации этого заклинания для создания необычных существ.
Также Создать животное подходит для создания роя маленьких существ (B461). Стоимость создания «роя» - 2 единицы энергии.
Длительность: 1 минута.
Стоимость: 2, умножте на 1+МР(SM) для животных, у которых МР(SM) больше 0. Половина на поддержание.
Время сотворения: Длительность в секундах равна стоимости заклинания.
Требования: Создать объект, Создать воду и ИН(IQ) не меньше 12.</description-loc>
</spell>
	<spell version="2" very_hard="yes">
		<name>Create Object</name>
		<name-loc>Создать объект</name-loc>
		<description-loc>Обычное
Создаёт любой простой предмет, знакомый заклинателю – например, мантию, меч или чашку. Заклинание не создаёт магических предметов или живых существ.
Ограничения: Еда, созданная таким образом, будет только выглядеть питательной. Нельзя создать информацию; заклинатель может создать книгу, только если знает её всю наизусть. Произведение искусства будет настолько хорошо, насколько заклинатель может сам его сделать. Нельзя создать механическое устройство, если только заклинатель не может сделать его сам. (Мастера, цель этого правила – сделать для магов почти невозможным создание машин, транзисторного радио и т.д. Будьте строги.)
Длительность: Созданный объект существует, пока касается живого мыслящего существа, теоретически - бесконечно долго. Так, заклинатель может создать меч и сражаться им или передать другу, но если он создаст монету, чтобы обмануть торговца, мошенничество может вскрыться, когда монета исчезнет, если торговец уронит её на прилавок или подбросит в воздух! Созданным предметам не обязательно касаться плоти, но они должны быть очень близко к кому-нибудь. Их можно держать рукой в перчатке, носить в кармане и т.д., но положить в рюкзак уже нельзя.
Стоимость: 2 за каждые 5 фунтов массы созданного объекта.
Время сотворения: Длительность в секундах равна стоимости заклинания.
Требования: Магичность(Magery) 2, Создать землю, Совершенная иллюзия.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/5 lbs</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec/cost</casting_time>
		<duration>While touching someone</duration>
		<reference>M98</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">perfect illusion</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (illusion &amp; creation)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Servant</name>
		<name-loc>Создать слугу</name-loc>
		<description-loc>Обычное
Создаёт тупого (все атрибуты 9), но преданного слугу для исполнения приказов заклинателя. Внешность слуги описывает заклинатель. Также это заклинание может создать Зверя – слугу с СЛ(ST) 16 и всеми остальными атрибутами 9. Или же заклинание может создать слугу со всеми атрибутами 9  и одним не боевым, не основанном на ИН(IQ) умении на уровне 16. Все созданные слуги выполняют простые устные команды, передают речевые сообщения и т.д. Слугу контролирует Мастер. Слуга не может драться и ориентироваться в запутанных ситуациях; у него нет умений. Встретив опасность, он хнычет, бежит или просто растворяется. Если его спросить, он будет знать только своего хозяина и что тот ему приказал.
Длительность: 1 минута.
Стоимость: 3 на сотворение, 1 на поддержание. Для умелого слуги 4 на сотворение, 4 на поддержание. Для Зверя 6 на сотворение, 2 на поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 3, ИН(IQ) не ниже 12 и Создать объект.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M98</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create object</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (illusion &amp; creation)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Warrior</name>
		<name-loc>Создать воина</name-loc>
		<description-loc>Обычное
Создаёт воина для сражения по приказам заклинателя. У него ИН(IQ) 10; СЛ(ST), ЛВ(DX) и ЗД(HT) 12; уровень 16 в одном оружейном (или безоружного боя) умении по желанию заклинателя. При создании он не имеет ни оружия, ни доспехов, он использует то, что ему дали.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 4 на поддержание. Для создания Воина Зверя (с СЛ(ST) 16) – 6 на сотворение, 6 на поддержание.
Время сотворения: 4 секунды.
Требования: Создать слугу.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M98</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create servant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Duplicate</name>
		<name-loc>Дубликат</name-loc>
		<description-loc>Обычное
Похоже на Создать объект, но вместо создания воображаемого заклинателем предмета, дублирует настоящий предмет, который заклинатель должен держать в руках, или касаться, во время сотворения заклинания. Это заклинание позволяет магу создать пистолет, не зная умения Оружейник, если у него есть ещё один под рукой для копирования. Оно также позволяет создавать совершенные подделки произведений искусства, денег, документов и так далее. Магические дубликаты подчиняются правилам для предметов созданных заклинанием Создать объект, например он должен постоянно контактировать с живым существом или исчезнет.
Также маг может попытаться  изменить создание. Например, он может создать копию меча, но с рунами, или копию паспорта, но с другим именем или фотографией и т.д. В этом случае применяются обычные правила для способностей заклинателя; может потребоваться бросок умения Подделка. Маг без знания оружия может покрыть копию пистолета золотом, но не сможет изменить ударно-спусковой механизм или ёмкость магазина.
Длительность: Как в Создать предмет (выше).
Стоимость: 3 за каждые 5 фунтов массы создаваемого объекта.
Время сотворения: Длительность в секундах равна стоимости заклинания.
Требования: Создать предмет и Копия текста.
Предмет
(а) Посох, палочка или украшение. Используется только магами. Энергостоимость создания: 650. (б) Дубликат можно сделать навсегда за в 100 раз большую стоимость.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3/5 lbs</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec/cost</casting_time>
		<duration>While touching someone</duration>
		<reference>M98</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">copy</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Creation</name>
		<name-loc>Контроль создания</name-loc>
		<description-loc>Обычное; Сопротивление по заклинаниям на объекте
Захватывает контроль над живым Созданием, созданным кем-то другим. Если заклинание удалось, энергию для поддержания Создания платите вы. Если заклинание провалилось, Создание по-прежнему контролирует его создатель. Это заклинание не действует на Иллюзии
Стоимость: 1.
Время сотворения: 2 секунды.
Требования: Создать животное или Создать слугу.
Предмет
Посох или палочка; надо коснуться объекта. Энергостоимость создания: 400.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Instant</duration>
		<reference>M99</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create animal</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create servant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Mount</name>
		<name-loc>Создать скакуна</name-loc>
		<description-loc>Обычное
Создаёт глупого, но преданного скакуна, на котором можно ездить, пока он существует. Также его можно использовать как тягловое животное.
Большинство скакунов имеют те же черты, что и пони (B460), но заклинатель определяет внешний вид скакуна при создании; это могут быть лошади, верблюды, дельфины, карликовые слоны, огромные страусы и всё, на что согласится Мастер (используйте Руководство по созданию животных). Скакун может понимать только очень простые устные команды, вроде стой, иди, налево, направо, кругом и т.д. Скакуна контролирует Мастер. Скакун не может драться и ориентироваться в запутанных ситуациях; у него нет умений. Перед лицом опасности он заскулит, сбежит или просто растворится.
Также заклинатель может создать Зверского скакуна с СЛ(ST) 35, Крылатого скакуна с БД (BM) 7/14, Гоночного скакуна с БД  (BM) 18, или Боевого скакуна который остаётся спокойным в опасной ситуации и понимающий команды давить или атаковать.
Длительность: 1 час.
Стоимость: 8 на сотворение, 3 на поддержание. Удвойте стоимость для Зверского скакуна, Крылатого скакуна, Боевого скакуна или Гоночного скакуна. Утройте для Крылатого Гоночного скакуна и т.д.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 3 и Создать животное.
Предмет
(а) Маг может создать скакуна навсегда за в 100 раз большую стоимость. (б) Свисток или рожок. Используется только магами. Звук свистка или рожка заставляет скакуна появиться, как будто его призвали. Энргостоимость создания: 200-кратная стоимость создания соответствующего скакуна.</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M99</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create animal</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (illusion &amp; creation)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dispel Creation</name>
		<name-loc>Отменить создание</name-loc>
		<description-loc>Обычное; Сопротивление по заклинаниям на объекте
Разрушает все виды Созданий. Не действует на Иллюзии.
Стоимость: 1 для отмены неживого объекта, 3 для отмены живого объекта.
Требования: Контроль создания.
Предмет</description-loc>
		<college>Illusion &amp; Creation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 or 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M99</reference>
		<categories>
			<category>Illusion &amp; Creation</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">control creation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Alarm</name>
		<name-loc>Будильник</name-loc>
		<description-loc>Обычное
Предупреждает объект в указанное время в будущем, пробуждая его, если необходимо. Также делает напоминание (по сути, доставляя сообщение), при условии, что оно было указано при сотворении. Может быть настроено на «срабатывание» в пределах недели от времени сотворения.
Длительность: 1 неделя.
Стоимость: 1. Не поддерживается.
Требование: Узнать Время.
Предмет
Украшение. Будет гудеть или вибрировать каждый день в одно и то же время, установленное создателем. Энергостоимость создания: 60.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 week</duration>
		<reference>M100</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">tell time</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Far-Feeling</name>
		<name-loc>Удалённое осязание</name-loc>
		<description-loc>Обычное
Цель может осязать любой объект, который видит (даже на большом расстоянии) или сквозь твёрдые предметы не более 6 футов в толщину. Ощущения односторонние (чтобы щипать девиц, используйте заклинание Манипулировать); в частности, маг не может доставлять заклинание через Удалённое осязание!
Длительность: 1 минута.
Стоимость: 3 сотворение, 1 поддержание.
Время сотворения: 3 секунды.
Требование: Магичность(Magery) 1.
Предмет
Перчатки или украшение. Действует только на носящего. Энергостоимость создания: 200.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M100</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (knowledge)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Measurement</name>
		<name-loc>Измерить</name-loc>
		<description-loc>Областное; Информационное.
Сообщает заклинателю одну из следующих вещей о субъекте: (а) вес; (б) размеры во всех измерениях; (с) площадь; (д) объем. Заклинание предоставит информацию в родной системе заклинателя, будь то фунты, граммы, или камни примерно размером с голову. Измерение настолько точно, насколько заклинатель может его понять.
В некоторых сеттингах, где часто меряются другие величины, могут быть возможны и другие измерения. На высоких ТУ, например, может быть определена длина волны света, или частота звука. Скорость двигающегося субъекта или местная гравитация тоже может быть измерена в некоторых сеттингах.
Базовая стоимость: 1.
Предмет
Существует отдельный предмет для каждой из вышеуказанных функций: зачарованная линейка для измерения длины, весы для веса, линза для цвета, или ониксовый куб для объема. Предмет должен прикасаться к объекту. Энергостоимость создания: 50.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Area/Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M100</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Tell Time</name>
		<name-loc>Узнать время</name-loc>
		<description-loc>Информационное
Сообщает заклинателю сколько времени – а также день и год, если в этом будут сомнения.
Стоимость: 1.
Предмет
Украшение, позволяет носителю узнать точное время, когда он захочет. Энергостоимость создания: 250.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M100</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Aura</name>
		<name-loc>Аура</name-loc>
		<description-loc>Информационное
Создаёт светящийся ореол или «ауру» вокруг объекта. Эта аура даёт заклинателю общее представление о личности объекта – чем лучше бросок, тем полнее информация. Аура также показывает, есть ли у объекта Магичность(Magery), Сопротивление магии или Подверженность магии (и на каком уровне); одержим или контролируется ли объект каким-то способом; и находится ли объект во власти какой-то сильной эмоции. Критический успех обнаружит «тайные» черты, такие как ликантропия, вампиризм и неестественное долгожительство.
У всех живых существ есть ауры; у неодушевлённых предметов их нет. Зомби можно обнаружить по его слабой ауре смерти, а вампир сохраняет ауру, которая у него была при жизни. Иллюзии и созданные существа не имеют ауры, поэтому успешное произнесение этого заклинания отличает их от настоящих существ. 
Стоимость: 3 (для объекта любого размера).
Требование: Обнаружить магию.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 100.

Составлять много книг - конца не будет, и много читать - утомительно для тела.
Екклесиаст 12:12</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Detect Magic</name>
		<name-loc>Обнаружить магию</name-loc>
		<description-loc>Обычное
Определяет, является ли один субъект магическим. Если заклинание успешно, второе сотворение сообщает, является ли магия постоянной или временной. Критический успех на любом из этих бросков полностью определяет заклинание, как заклинание Анализ магии.
Это не то же самое, что и способность определять магические предметы, которая входит в Магичность(Magery) 0; та способность определяет только постоянные магические предметы, в то время как Обнаружить магию - предметы, заклинания, магических существ или любой другой длительный магический эффект.
Стоимость: 2.
Время сотворения: 5 секунд.
Требование: Магичность(Magery) 1.
Предмет
(а) Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 100. (б) Кольцо или ожерелье. Действует всегда. Оно вибрирует, предупреждая носителя, когда любой магический предмет находится в пределах 5 ярдов. Часто используется заклинание Допуск, для предупреждения носителя только об определённых типах магии. Энергостоимость создания: 300.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (knowledge)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Find Direction</name>
		<name-loc>Узнать направление</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление на север. Альтернативно, может сообщить направление домой. Учтите, что ни у кого не может быть более одного настоящего дома, а у странника его может вообще не быть!
Стоимость: 2.
Требование: Магичность(Magery) 1.
Предмет
Зачарованная стрелка компаса, которая показывает на север, или на дом пользователя, по команде. Энергостоимость создания: 250.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (knowledge)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Mana</name>
		<name-loc>Почуять ману</name-loc>
		<description-loc>Информационное
Сообщает заклинателю уровень маны в точке, где он стоит, и является ли местная мана «направленной» (см. GURPS Фэнтези) или какой-то ещё необычной. Если заклинание удалось, то второе сотворение откроет точную природу и уровень «направленности» или любой другой особенности.
Стоимость: 3.
Время сотворения: 5 секунд.
Требование: Обнаружить магию.
Предмет
(а) Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 200. (б) Кольцо или украшение. Действует всегда. Оно вибрирует каждый раз, когда носитель проходит через границу между областями с различной маной. Энергостоимость создания: 500.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Tell Position</name>
		<name-loc>Узнать расположение</name-loc>
		<description-loc>Информационное
Сообщает заклинателю точное расстояние, азимут и высоту субъекта относительно заклинателя. Заклинатель должен иметь возможность видеть субъект.
Стоимость: 1.
Требование: Измерить.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 150.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">measurement</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Test Load</name>
		<name-loc>Проверить на нагрузку</name-loc>
		<description-loc>Областное; Информационное
Сообщает заклинателю, сколько ещё веса субъект может выдержать, прежде чем искривится или сломается. Это может открыть грузоподъемность мостов, корзин, верёвок, и т.д.
Базовая стоимость: 1 (минимум 2).
Требование: Измерить.
Предмет
Посох или жезл; предмет должен коснуться цели. Энергостоимость создания: 80.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Area/Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M101</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">measurement</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Analyze Magic</name>
		<name-loc>Анализ магии</name-loc>
		<description-loc>Информационное; Сопротивление против скрывающих магию заклинаний
Определяет, какие именно заклинания наложены на объект. Если на объект наложено больше одного заклинания, Анализ магии определяет то, на которое потребовалось меньше всего энергии, и сообщает заклинателю «есть ещё заклинания».
После этого, его можно сотворить ещё раз, чтобы определить следующее заклинание, и так далее. Чары Имя и Пароль считаются отдельными заклинаниями, которые сопротивляются с +5; каждый конкретный волшебник может пытаться Анализировать Имя или Пароль только один раз. Как и Определить заклинание, выше, оно даст ограниченные результаты, когда заклинатель сталкивается с неизвестным заклинанием.
Стоимость: 8.
Время сотворения: 1 час.
Требование: Определить заклинание.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 1.200.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">identify spell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Identify Spell</name>
		<name-loc>Определить заклинание</name-loc>
		<description-loc>Информационное
Определяет, какое заклинание или заклинания были только что сотворены (в течение последних пяти секунд), или творятся в данный момент, объектом или на объект. Оно не определяет заклинания на постоянно зачарованном предмете. Одно сотворение определяет все заклинания сотворённые объектом или на объект. Тем не менее, если любое из этих заклинаний полностью неизвестно заклинателю – не просто заклинания, которых он не знает, но и о которых  никогда не слышал – Мастер должен дать только расплывчатое описание; например, «какая-то физическая защита».
Волшебники слышали о каждом заклинании в этой книге (если только Мастер не решил, что часть из них – секретные), но не о новых заклинаниях, созданных Мастером или игроками.
Стоимость: 2.
Требование: Обнаружить магию.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 1.100.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mage Sense</name>
		<name-loc>Чувство магии</name-loc>
		<description-loc>Информационное
Сообщает заклинателю, есть ли какой-то невидимый магический предмет или существо поблизости. Заклинатель может указать, ищет ли он любой магический предмет, или конкретный. 
Модификатор умения: расстояние в ярдах до искомого объекта. Используйте ближайшее расстояние, если заклинатель движется во время действия заклинания, и делайте бросок в конце этого времени. По решению Мастера, некоторые очень могучие магические предметы можно почувствовать проще.
Длительность: 1 минута.
Стоимость: 3 сотворение. 2, поддержка.
Требование: Обнаружить магию.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 1.200.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mage Sight</name>
		<name-loc>Волшебное зрение</name-loc>
		<description-loc>Стандартное
Обнаруживает все магические предметы в поле зрения. Каждый такой предмет будет иметь свечение или «ауру», похожую на ауру живого существа. Это свечение будет видно сквозь одежду, броню и вплоть до 1/2 дюйма твёрдого материала.
Аура навсегда зачарованного предмета будет сильнее, чем у чего-то под действием временного заклинания. Зачарованные (или магические) существа тоже светятся, хотя сами маги – нет, если на них нет в данный момент заклинаний. Аура также может дать ключ к пониманию природы предмета. При хорошем броске, например, заклинания огня будут иметь характерное красное свечение, а злые предметы будут показывать некое «чёрное свечение» в своих аурах. Критический успех на этом заклинании позволяет заклинателю полностью опознать каждый магический предмет, который он видит. Отметим, что эта способность, по сути, более надёжная версия магических чувств, которые входят в Магичность(Magery) 0 (B66).
Длительность: 1 минута.
Стоимость: 3 сотворение, 2 поддержание.
Требование: Обнаружить магию.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 800.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Magic</name>
		<name-loc>Искать магию</name-loc>
		<description-loc>Информационное
Определяет направление и приблизительную дистанцию до ближайшего значительного магического предмета, активного заклинания, или магического существа (магические существа – это демоны, элеменали, духи, и т.д., но не расы или отдельные существа с Магичность(Magery)ю). Действуют стандартные штрафы за расстояние. Любые известные экземпляры магии могут быть исключены, если заклинатель отдельно упомянет их перед сотворением.
Это также Мета-заклинание.
Стоимость: 6.
Время сотворения: 10 секунд.
Требование: Обнаружить магию.
Предмет.
Посох, жезл или украшение. Энергостоимость создания: 1.200.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Summon Shade</name>
		<name-loc>Вызов тени</name-loc>
		<description-loc>Информационное; Сопротивление по Воле(Will)
Вызывает «тень» объекта из возможного будущего, чтобы ответить на вопросы заклинателя. Тень не будет лгать (кроме как на критическом провале), но она будет дезориентирована; поэтому её ответы могут быть неясными или неточными. Можно задать один вопрос на минуту поддержки заклинания. Поскольку тень всего лишь из наиболее вероятного будущего, предсказание, сделанное этим заклинанием, может быть ненадёжно.
Пример: Феликс Магистр может вызвать тень своего друга Рудольфа с двух месяцев тому вперёд, и спросить, удалось ли нападение на дракона – и затем, если ответ был «нет», убедить настоящего Рудольфа не пытаться. Тень просто пришла из другого будущего. Конечно, тень может также ответить «нет – решили не нападать».
Во времени, из которого взята тень, у объекта будет яркий сон, в котором он увидит спрашивающего или вспомнит всё, что было сказано – в случае, если предсказанное событие сбудется.
Модификаторы умения: -1 за каждый год в будущее, из которого взята тень; -5, если объект не присутствует при сотворении, или -10, если нет ничего, относящегося к объекту (одежда, срезанные волосы, и т.д.); -10, если не известно полное имя объекта.
Это заклинание можно пытаться сотворить не больше, чем один раз в год на одну и ту же личность. Это очень могучее заклятие, и Мастер может захотеть ограничить доступ к этому заклинанию, или потребовать дорогие материалы.
Длительность: 1 минута.
Стоимость: 50 сотворение. 20 поддержка.
Время сотворения: 10 минут. Одна попытка в год.
Требования: Вызов духа или Прорицание.
Предмет
Посох, жезл или украшение. Используется только магами. Предмет не даёт возможности произнести заклинание, но даёт +2 к знанию этого заклинания. Энергостоимость создания: 800.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>50</casting_cost>
		<maintenance_cost>20</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>1 min</duration>
		<reference>M102</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="contains">divination</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Glass Wall</name>
		<name-loc>Стеклянная стена</name-loc>
		<description-loc>Стандартное
Позволяет видеть сквозь одну стену, пол, потолок, или другой подобный барьер вплоть до 4 футов толщины (материал не имеет значения).
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Требования: Либо пять других заклинаний школы Знаний, либо Видеть сквозь землю.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 600.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M103</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<college compare="contains">knowledge</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Know Location</name>
		<name-loc>Узнать местонахождение</name-loc>
		<description-loc>Информационное
Даёт заклинателю приемлемое представление о его географическом местоположении (с точностью до пары миль). Это будет выражено в терминах ближайших ориентиров, о которых заклинатель слышал (если есть сомнения, слышал ли заклинатель об этом, Мастер должен кинуть Знание местности заклинателя). Например, «Вы в пустыне Сахара, примерно на 30 миль к северу от Тимбукту».
Стоимость: 2.
Время сотворения: 10 секунд. При последующих попытках, заклинание повторяет последний ответ (правильный он или нет), пока заклинатель не сдвинется с места примерно на милю.
Требования: Магичность(Magery) 1 и Узнать расположение. 
Предмет
Любая карта, глобус, и т.д., может быть зачарована, чтобы показывать местонахождение пользователя каждый раз, когда творится это заклятие. Отметка (выбранная создателем предмета) появляется в подходящем месте в случае успеха. Никакой отметки не появляется, если пользователь за пределами границ карты. Если заклинание не удаётся, либо не появляется никакой отметки, либо появляется ошибочная. Энергостоимость создания: 225.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M103</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">tell position</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Invisible Wizard Eye</name>
		<name-loc>Невидимый волшебный глаз</name-loc>
		<description-loc>Стандартное
Создаёт Волшебный глаз, который нельзя увидеть без заклинания Видеть невидимое. Любой, кто угадает, где он находится, всё ещё может атаковать, но с -7 за МР(SM) в сочетании со штрафом -6 за невидимость приводит к тому, что по нему крайне трудно попасть.
Длительность: 1 минута.
Стоимость: 5 сотворение. 3 поддержка.
Время сотворения: 4 секунды.
Требования: Волшебный глаз и Невидимость.
Предмет
Как для Волшебного глаза, но дороже. Стоимость создания: 1.600 энергии, $1000 за умелую резьбу по слоновой кости и $900 за изумруды и опалы.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M104</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">wizard eye</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">invisibility</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wizard Eye</name>
		<name-loc>Волшебный глаз</name-loc>
		<description-loc>Стандартное
Создаёт физический глаз – двухдюймовый шарик – через который заклинатель может видеть. Глаз может летать в воздухе, вертикально или горизонтально, с Движением 10; он движется в ход заклинателя. Концентрация требуется, чтобы двигать глаз, но не чтобы видеть через него. Глаз маленький, его МР(SM) равен -7, поэтому в него трудно попасть – но если в него попадут физической атакой, или любым заклинанием, которое могло бы вывести его из строя, он будет уничтожен.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 2 секунды.
Требования: Перемещение и Обострённое зрение.
Предмет
Глазное яблоко, вырезанное из слоновой кости с врезанными драгоценными камнями. Используется только магами. По команде держателя, оно превратится в Волшебный глаз; по возвращению в его руку оно вновь примет форму драгоценности. Стоимость создания: 1.100 энергии, $1000 за умелую резьбу по слоновой кости и $600 за изумруды.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M104</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">keen vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wizard Hand</name>
		<name-loc>Волшебная рука</name-loc>
		<description-loc>Стандартное
Создаёт копию физической кисти заклинателя, которой он может хватать и осязать. Рука летает по воздуху с Движением 10, в ход заклинателя, хотя она не может этого делать, не врезаясь в препятствия, если её не сопровождает Волшебный глаз или ухо! Альтернативно, она может ощупывать себе дорогу вдоль стен, полов и потолков с Движением 3. Концентрация требуется, чтобы двигать Руку, но не чтобы держать или осязать через неё. Рука не может колдовать или удерживать заклинания. Любые улучшающие осязание заклинания, действующие на заклинателя, можно также использовать через Руку. Когда заклинатель осязает через Руку, его собственные руки нечувствительны. Каждый ход, он должен указывать, осязает ли он через Руку или через собственные руки.
Рука маленькая, с МР(SM) -5, но если в неё попадут физической атакой, или любым заклинанием, которое могло бы её вывести из строя, это её уничтожит. Сама рука не может наносить урон ударом; у неё СЛ(ST) 2 и ЛВ(DX) заклинателя.
Это также заклинание Движения.
Длительность: 1 минута.
Стоимость: 4 сотворение, 2 поддержка для одной Руки; 6 сотворение, 4 поддержка для двух Рук.
Время сотворения: 3 секунды.
Требования: Манипулировать и Удалённое осязание.
Предмет
(а) Любой предмет, изображающий человеческую руку, может быть превращён в стационарную Волшебную Руку, через которую носитель перчатки, зачарованной одновременно, может ощупывать независимо от расстояния. Каждая Рука соединяется с одной перчаткой и наоборот. Энергостоимость создания: 300. (б) Рука, вырезанная из драгоценной древесины. Используется только магами. По приказу держащего её, она превращается в Волшебную руку; по возвращению в его руку она возвращается в форму предмета. Стоимость создания: 400 энергии, $500 за материалы и работу.</description-loc>
		<college>Knowledge/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M104</reference>
		<categories>
			<category>Knowledge</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">manipulate</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">far-feeling</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wizard Mouth</name>
		<name-loc>Волшебный рот</name-loc>
		<description-loc>Стандартное
Создаёт копию – примерно 4 дюйма шириной – физического рта и губ заклинателя, через который он может говорить и ощущать вкус. Рот летает по воздуху с Движением 10, в ход заклинателя, хотя он не может этого делать, не врезаясь в препятствия, если его не сопровождает Волшебный глаз или ухо!
Концентрация требуется, чтобы двигать Рот, но не чтобы говорить или пробовать сквозь него. Любые улучшающие голос или вкус заклинания, действующие на заклинателя, можно также использовать через Рот. Рот не может творить заклинания! Когда заклинатель пробует через Рот, его собственный рот нечувствителен. Каждый ход, он должен указывать, пробует ли он через Рот или через собственный рот.
Рот маленький, с МР(SM) -6, поэтому по нему трудно попасть – но если в него попадут физической атакой, или любым заклинанием, которое могло бы его вывести из строя, он уничтожен. Сам Рот не может наносить вреда укусом.
Это также заклинание Пищи и Звука.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 2 секунды.
Требования: Перемещение, Удалённая дегустация и Великий голос 
Предмет
(а) Любой предмет, изображающий человеческий рот может быть превращён в неподвижный Волшебный рот, через который держатель амулета в форме рта, зачарованный одновременно, может говорить независимо от расстояния. Каждый Рот подключен к одному амулету и наоборот. Энергостоимость создания: 325. (б) Рот, вырезанный из красного коралла, с зубами из слоновой кости. Используется только магами. По приказу держащего его, он превращается в Волшебный рот; по возвращению в его руку он возвращается в форму предмета. Стоимость создания: 650 энергии, $1000 за умелую резьбу по кораллу и $400 за слоновую кость.</description-loc>
		<college>Food/Knowledge/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M104</reference>
		<categories>
			<category>Food</category>
			<category>Knowledge</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">far-tasting</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">great voice</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wizard Nose</name>
		<name-loc>Волшебный нос</name-loc>
		<description-loc>Стандартное
Создаёт отделённую копию – примерно 2 или 3 дюйма длиной – физического носа заклинателя, через который он может ощущать запах. Нос летает по воздуху с Движением 10, в ход заклинателя, хотя он не может этого делать, не врезаясь в препятствия, если его не сопровождает Волшебный глаз или ухо!
Концентрация требуется, чтобы двигать Нос, но не чтобы нюхать через него. Любые улучшающие обоняние заклинания, действующие на заклинателя, можно также использовать через Нос. Когда заклинатель нюхает через Нос, его собственный нос нечувствителен. Каждый ход он должен указывать, нюхает ли он через Волшебный нос или через собственный. 
Нос маленький, с МР(SM) -7,– но если в него попадут физической атакой, или любым заклинанием, которое обосновано могло бы его вывести из строя, он уничтожен.
Это также заклинание Пищи.
Длительность: 1 минута
Стоимость: 3 сотворение. 2 поддержка.
Время сотворения: 2 секунды.
Требования: Перемещение, Удалённая дегустация.
Предмет
(а) Любой предмет, изображающий человеческий нос может быть превращён в неподвижный Волшебный Нос, через который держатель амулета в форме цветка, зачарованный одновременно, может нюхать независимо от расстояния. Каждый Нос соединяется с одним амулетом и наоборот. Энергостоимость создания: 475. (б) Нос, вырезанный из драгоценного камня. Используется только магами. По приказу держащего его, он превращается в Волшебный Нос; по возвращению в его руку он возвращается в форму предмета. Стоимость создания: 500 энергии, $500 за материалы и работу.</description-loc>
		<college>Food/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M104</reference>
		<categories>
			<category>Food</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">far-tasting</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Astral Vision</name>
		<name-loc>Астральное зрение</name-loc>
		<description-loc>Стандартное
Позволяет видеть бесплотные сущности. Например, привидений или объектов заклинаний Эфирное тело, Проекция или Планарный визит.
Это также заклинание школы Некромагии.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Требования: Чувство духов и Видеть невидимое.
Предмет
(а) Посох или жезл. Используется только магами. Энергостоимость создания: 900. (б) Очки или украшение. Действует только на носителя, Действует всегда. Энергостоимость создания: 1.400.</description-loc>
		<college>Knowledge/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M105</reference>
		<categories>
			<category>Knowledge</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">see invisible</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Memorize</name>
		<name-loc>Запомнить</name-loc>
		<description-loc>Стандартное
Всё, что заклинатель воспринимает во время сотворения (и ещё 10 секунд после этого) идеально впечатывается в память, как если бы у него была Фотографическая память (B51). Заклинание можно использовать, чтобы запоминать карты, лица, события, и т.д. Оно не может быть использовано, чтобы выучить умения или сохранить временные магические эффекты.
Это также заклинание Контроля разума.
Длительность: 1 день. После этого, проверяйте ИН(IQ) каждый день, с накопительным штрафом -1 за день. При критическом успехе, память остаётся навсегда; при обычном - всё ещё вспоминается. При провале память тает до нормального уровня памяти о данном событии; при критическом провале, создаётся фальшивая память(которая тоже может со временем исчезнуть).
Стоимость: 3 сотворение. Не поддерживается.
Время сотворения: 2 секунды.
Требования: Мудрость или минимум шесть заклинаний Знаний.
Предмет
(а) Украшение или головной убор. Энергостоимость создания: 1.000. (б) Любой. Действует всегда; носитель может вспомнить одну вещь, указанную создателем. Память тает полностью спустя час после того, как предмет снят. Энергостоимость создания: 400. (с) Память может быть сделана постоянной за 50 единиц энергии, но должна сохраняться всё время, пока происходит зачарование.</description-loc>
		<college>Knowledge/Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 day</duration>
		<reference>M105</reference>
		<categories>
			<category>Knowledge</category>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<college compare="contains">knowledge</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wisdom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pathfinder</name>
		<name-loc>Навигатор</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление на определённое место, или правильную дорогу в нужное место. Используйте Модификаторы больших расстояний (M14). Мастер должен применить штрафы, если заклинатель никогда не был в том месте, и большие штрафы, если заклинатель не уверен, что место на самом деле существует или на что оно похоже. Это заклинание не ищет людей или предметы. Город, горный проход, или общественное здание может быть местом. Дом или офис определённого человека не является «местом» для этого заклинания, если заклинатель там не был.
Стоимость: 4. Одна попытка в день.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 1, ИН(IQ) 12 или выше, и по минимум два заклинания «Искать ...». Предмет
Раздвоенная палка или игла компаса, которая будет показывать один раз в день, на цель, названную пользователем. Будет продолжать показывать в течение 10 минут за каждую единицу величины успеха заклинания, на основании Силы предмета. Энергостоимость создания: 1.000.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M105</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="contains">seek</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Projection</name>
		<name-loc>Проекция</name-loc>
		<description-loc>Стандартное
Заклинатель на короткое время выпускает свой разум из своего тела, в любую точку в прямой видимости (используйте модификаторы больших расстояний), чтобы рассмотреть свое окружение из другой точки обзора. Его проецированная сущность полностью бесплотна и может только видеть, слышать, осязать, нюхать и пробовать на вкус. Её присутствие можно обнаружить Астральным зрением, Чувством духов, Чувством наблюдения, и тому подобными; иначе она незаметна.
Проекция не может пересечь Астральный блок, Пентаграмму или Сплошные заклинания. Отталкивание духов будет сопротивляться её вторжению. 
Проекция не может двигаться; она может только поворачиваться, чтобы посмотреть в разные стороны. Тело неподвижно на время действия этого заклинания; оно не может действовать. Если кто-то атакует тело, заклинание автоматически прерывается.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 3 секунды.
Требования: Чувство духов и не меньше четырёх заклинаний школы Знаний.
Предмет
Посох, жезл или украшение. Используется только магами; действует только на носителя. Энергостоимость создания: 500.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M105</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">knowledge</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seeker</name>
		<name-loc>Искатель</name-loc>
		<description-loc>Информационное
Настраивает заклинателя на индивида или искусственный предмет, которого он ищет. Успех даёт заклинателю видение местонахождения предмета – или ведёт его к нему, если тот в пределах мили. 
Чтобы искать личность, заклинатель должен либо знать его имя или знать его достаточно хорошо, чтобы вообразить его.
Например, нельзя использовать это заклинание, чтобы раскрыть убийство, ища «убийцу» если вы не знаете кто это – но если знаете, то Искатель его найдёт.
Модификаторы: Модификаторы больших расстояний (M14). Что-то связанное с искомым (например, часть одежды личности) должно быть доступно во время сотворения; если нет, бросок делается с -5. Премия +1 если заклинатель держал или ещё как-то знаком с исходным предметом.
Стоимость: 3. Одна попытка в неделю.
Требования: Магичность(Magery) 1, ИН(IQ) 12 или выше, и по крайней мере два заклинания «Искать ...». Предмет
Раздвоенная палка (дерево, кость или слоновая кость) или игла компаса (вырезная из слоновой кости), которая будет указывать на один конкретный объект, выбранный при создании предмета. Что-то, относящееся к объекту должно быть использовано при создании предметам, и включено в него. Энергостоимость создания: 500.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M105</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="contains">seek</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ancient History</name>
		<name-loc>Древняя история</name-loc>
		<description-loc>Информационное
Как история, но даёт общее представление о истории предмета за гораздо больший промежуток времени.
Стоимость: 3 за 1 год истории; 5 за 10 лет; 8 за 100 лет; 10 за 1000 лет.
Время сотворения: 1 минута за единицу энергии.
Требование: История.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min/pt</casting_time>
		<duration>Instant</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>History</name>
		<name-loc>История</name-loc>
		<description-loc>Информация
Будучи сотворённым на любой неодушевлённых предмет (или на его часть радиусом в 1 ярд), позволяет заклинателю определить недавнее прошлое этого предмета, характер пользователя, и так далее – но никаких имён!
Стоимость: 3 за вчерашнюю историю; 5 за неделю; 8 за месяц; 10 за год.
Время сотворения: 1 секунда за единицу энергии.
Требование: Слежка.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<casting_time>1 sec/pt</casting_time>
		<duration>Instant</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">trace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Know True Shape</name>
		<name-loc>Распознать истинную форму</name-loc>
		<description-loc>Информационное
Сообщает, находится ли объект под действием любого типа заклинания Превращения или подобного магического эффекта, включая Изменить Лицо, Изменить Тело и иллюзии. Заклинатель должен иметь возможность видеть объект. Заклинание также даёт общее представление об истинном облике объекта; на критическом успехе, оно определяет истинную природу объекта (включая распространенное название или описание) и магию, которая используется чтобы опознать её. Оно не открывает истинную природу Галлюцинаций.
Стоимость: 2.
Требования: Магичность(Magery) 1, любое заклинание изменения формы (Превращение, Изменить лицо, Изменить тело), и либо Аура либо Распознать иллюзию.
Предмет
Посох, жезл или украшение (популярны медальоны или монеты с «Отверстием истинного зрения» в них). Используется только магами. Энергостоимость создания: 250.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">aura</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">know illusion</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">shrink</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">plant form</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">alter body</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">alter visage</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="contains">shift</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Prehistory</name>
		<name-loc>Древнейшая история</name-loc>
		<description-loc>Информационное
Это заклинание похоже на Древнюю историю, но даёт ещё менее конкретную информацию за период тысячелетий. Возраст и функция предмета определяются всегда, но если предмет не принимал участия в важных событиях, то это может быть единственной доступной информацией. К счастью, этого часто достаточно для магов-археологов, которые чаще всего используют Древнейшую историю.
Стоимость: 3 за 1.000 лет истории; 5 за 10.000 лет; 8 за 100.000 лет; 10 за большие промежутки времени. 
Время сотворения: 1 час за единицу энергии.
Требование: Древняя история.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr/pt</casting_time>
		<duration>Instant</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ancient history</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Recall</name>
		<name-loc>Вспомнить</name-loc>
		<description-loc>Стандартное
Объект вспоминает один забытый или незамеченный факт или событие, как если бы у него была Фотографическая память (B51). Действуют штрафы, данные в Модификаторах времени (M81), на основании времени, прошедшего с тех пор, как это событие произошло. Отличная Память даёт бонус +5. Фотографическая Память даёт бонус +10 (хотя тем, у кого есть Фотографическая память, это заклинание потребуется только чтобы восстановить неестественно отнятые воспоминания). Только критический успех позволяет вспомнить магически заблокированную память. Критический провал может привести к фальшивому или скаженному воспоминанию, или уничтожить воспоминание так, что его уже больше не вернуть!
Это также заклинание Контроля разума.
Длительность: 1 день. Впоследствии, память тает как и при использовании заклинания Запомнить. 
Стоимость: 4. Не поддерживается.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, Запомнить и История.
Предмет
(а) Головной убор, жезл или украшение. Используется только магом. Энергостоимость создания: 2.500. (б) Память может быть сделана постоянной за 50 единиц энергии, но память должна сохраняться в течение всего процесса зачарования.</description-loc>
		<college>Knowledge/Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 day</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">memorize</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reconstruct Spell</name>
		<name-loc>Восстановить заклинание</name-loc>
		<description-loc>Информационное
Сообщает заклинателю, какие заклинания были сотворены субъектом, на него или рядом с ним, в определённый момент в прошлом, указанный заклинателем. Если заклинание было не одно, Восстановить заклинание определяет заклинание, которое стоило меньше всего энергии и сообщит «есть ещё заклинания». Действуют модификаторы времени (M81). Заклинания опознаются как в Определить заклинание (M102).
Стоимость: 3. Модификатор Времени добавляется к цене, так что если заклинание стоит 3 (3+0) за «в течение минуты», то оно будет стоить 8 (3+5) за «от 4 до 40 дней». 
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, История и Определить заклинание.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 1.400.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">identify spell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Trace</name>
		<name-loc>Слежка</name-loc>
		<description-loc>Стандартное
Может быть сотворено на любой предмет или живое существо. Пока заклинание поддерживается, заклинатель будет знать, где объект находится, если сосредоточится на секунду. Либо объект должен быть рядом с заклинателем, когда заклинание твориться в первый раз, либо заклинатель должен сперва успешно сотворить заклинание Искатель.
Модификаторы для больших расстояний применяются, если объект не присутствует рядом с заклинателем. 
Длительность: 1 час
Стоимость: 3 сотворение. 1 поддержка. Одна попытка в день.
Время сотворения: 1 минута.
Требование: Искатель.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M106</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Echoes of the Past</name>
		<name-loc>Эхо прошлого</name-loc>
		<description-loc>Стандартное
Будучи сотворено на стену или какой-то предмет, это заклинание «проигрывает» звуки, которые оно могло «слышать» в прошлом. Заклинатель указывает момент, с которого начинать слушать («послушаем, что  было сказано в этой комнате год назад…»). Модификаторы времени (M81) действуют. Каждый раз, когда заклинание твориться для того же периода времени, есть дополнительный штраф -1 к умению. Критический провал стирает «память» предмета о том периоде времени. 
Это также заклинание Звука.
Длительность: 1 минута.
Стоимость: 2 сотворение. 2 поддержка. Величина модификатора Времени добавляется к цене, так что если заклинание стоит 3 (3+0) на момент времени «в течение минуты», то оно будет стоить 8 (3+5) на момент времени «от 4 до 40 дней».
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, История и Голоса.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 500.

Прорицание
В отличие от более бросающихся в глаза видов магии, которые имеют прямые и измеримые эффекты на игровой мир (взрывают драконов, лечат героев, создают каменные мосты, и т.д.), предсказания и другие Информационные заклинания имеют дело только со знаниями игровых персонажей, и поэтому требуют особого рассмотрения.
Когда у PC есть доступ к информации в таких широких пределах, может возникнуть множество проблем. Иногда, у Мастера нет ответа на вопросы игроков; Возможно, он не ожидал, что континент за океаном будет иметь значение в эту сессию. В то же время, особенно проницательный вопрос заданный в правильный момент может разрушить планы Мастера на приключение. Особенно подвержены разрушению предсказаниями приключения о загадках и тайнах.
Вряд ли справедливо изворачиваться или намеренно врать игрокам, которые потратили ценные очки персонажа, чтобы играть предсказателями. К счастью, есть альтернативы. Символические видения – это вполне подходящий ответ на любой вопрос, кроме тех, на которые можно ответить только «да» или «нет», и часто более интересны, чем прямой ответ. Штрафы за непрерывные вопросы на одну и ту же тему могут, по крайней мере, дать Мастеру время, чтобы подготовиться к вопросам игровых персонажей.
Мастер должен всегда делать бросок на успешность прорицания, ему не следует стесняться быть двусмысленным, когда требуется; предсказатели никогда не должны быть до конца уверены, что их видения полны и надёжны.
Существование предсказаний может сильно повлиять на игровой мир. Большинство людей захотят проконсультироваться с прорицателем, прежде чем принимать важные решения – браки, преступления, войны, и тому подобное. Судебные процедуры будут в корне изменены. Более того, закон может строго регулировать использование прорицаний.
Не каждый вид прорицания будет существовать в каждом игровом мире. Мастер должен выбрать те методы, которые, на его взгляд, подходят к его сеттингу.</description-loc>
		<college>Knowledge/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 + time modifier</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M107</reference>
		<categories>
			<category>Knowledge</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Images of the Past</name>
		<name-loc>Картины прошлого</name-loc>
		<description-loc>Стандартное
Будучи сотворено на зеркало или отражающую поверхность, это заклинание «проигрывает» изображения, которые оно могло «видеть» в прошлом. Заклинатель указывает момент, с которого начинать просмотр («посмотрим, что случилось в этой комнате год назад…»). Модификаторы времени (M81) действуют. Каждый раз, когда заклинание твориться для того же периода времени, есть дополнительный штраф -1 к умению. Критический провал стирает «память» предмета о том периоде времени. 
Мастер также может позволить творить это заклинание на любой пол, стену или предмет, «воспроизведение» при этом проявится как Простая иллюзия.
Это также заклинание Света и тьмы.
Длительность: 1 минута.
Стоимость: 3 сотворение. 3 поддержка. Величина модификатора Времени добавляется к цене, так что если заклинание стоит 3 (3+0) на момент времени «в течение минуты», то оно будет стоить 8 (3+5) на момент времени «от 4 до 40 дней».
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, История и Простая иллюзия. 
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 700.</description-loc>
		<college>Knowledge/Light &amp; Darkness</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3 + Time modifier</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M107</reference>
		<categories>
			<category>Knowledge</category>
			<category>Light &amp; Darkness</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (knowledge)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remember Path</name>
		<name-loc>Запомнить путь</name-loc>
		<description-loc>Стандартное
Пока это заклинание активно, объект будет идеально запоминать любой путь, по которому он идёт. Запомненное позволит объекту нарисовать точную карту своих путешествий или пройти обратно без ошибок, даже в кромешной тьме или через отвлекающие внимание обстоятельства вроде сражений. Конечно, последующие изменения ранее пройденной местности будут неизвестны объекту (например, завал в шахте после того, как объект из неё вышел).
Длительность: 1 час. Когда заклинание заканчивает своё действие, память начинает таять как при заклинании Запомнить, причём проверки на ИН(IQ) делаются ежечасно а не ежедневно. Когда её вспомнят, память может быть сделана постоянной за 50 единиц энергии (с помощью наложения чар), но память должна сохраняться в процессе зачарования. 
Стоимость: 3 сотворение. 1 поддержка.
Время сотворения: 10 секунд.
Требования: Узнать направление и Запомнить.
Предмет
(а) Украшение или посох. Энергостоимость создания: 600. (б) раздвоенная палка или игла компаса, которая будет показывать дорогу вдоль одного пути, заданного создателем. Если её активировать вне пути, она будет показывать на ближайшую точку пути. Альтернативная форма этого предмета – маленький магический мячик, который будет катиться вдоль пути чуть впереди путешественника, со скоростью ходьбы. Ещё одна форма этого предмета – обувь, которая, когда её носят, ведёт носителя по заданному пути. Энергостоимость создания: 400.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M107</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">find direction</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">memorize</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scents of the Past</name>
		<name-loc>Запахи прошлого</name-loc>
		<description-loc>Стандартное
Будучи сотворено на стену или какой-то предмет, это заклинание испускает запахи, которым он был подвергнут в прошлом. Заклинатель указывает момент, с которого начинать «воспроизведение». Модификаторы времени (M81) действуют. Каждый раз, когда заклинание твориться для того же периода времени, есть дополнительный штраф -1 к умению. Критический провал стирает «память» предмета о том периоде времени. 
Это также заклинание Пищи.
Длительность: 1 минута.
Стоимость: 1 сотворение. Столько же поддержание. Модификатор времени добавляется к цене, так что если заклинание стоит 3 (3+0) на момент времени «в течение минуты», то оно будет стоить 8 (3+5) на момент времени «от 4 до 40 дней».
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, История и Запах.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 350.</description-loc>
		<college>Food/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M107</reference>
		<categories>
			<category>Food</category>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (food)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">odor</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>See Secrets</name>
		<name-loc>Видеть скрытое</name-loc>
		<description-loc>Стандартное
Делает так, что скрытые двери, ловушки и т.д. резко выделяются для зрения субъекта. Это заклинание работает только на вещи, которые были намеренно спрятаны, а не потеряны.
Длительность: 1 минута.
Стоимость: 5 сотворение. 2 поддержка.
Время сотворения: 5 секунд.
Требования: Искатель и Аура.
Предмет
Посох, жезл или украшение. На предмете должно быть вырезано изображение глаза. Энергостоимость создания: 400.

Схема/ТУ
Schematic/TL
Информационное
Описано среди Технологических заклинаний, M177.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M107</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">aura</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Astrology</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">predict weather</name>
			</spell_prereq>
			<skill_prereq has="yes">
				<name compare="is">astronomy</name>
				<specialization compare="is anything"></specialization>
				<level compare="at least">15</level>
			</skill_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Augury</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">air</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Cartomancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Crystal-Gazing</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">earth vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">water vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Dactylomancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Extispicy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M108</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">animal</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Gastromancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<skill_prereq has="yes">
				<name compare="is">hypnotism</name>
				<specialization compare="is anything"></specialization>
				<level compare="at least">15</level>
			</skill_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Geomancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Lecanomancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Numerology</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">mathematical ability</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Oneiromancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">communication</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Physiognomy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Pyromancy</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Sortilege</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Divination: Symbol-Casting</name>
		<name-loc>Прорицание</name-loc>
		<description-loc>Информационное
Даёт заклинателю видение, имеющее отношение к его вопросу, или ответ на один вопрос, на которым можно ответить только да или нет. Существует много видов прорицания; каждый – это отдельное заклинание, и требует соответствующих материалов (см. ниже). У каждого есть свои плюсы и минусы. Те методы, которые связаны с определённой стихией или стихиями дают более подробные ответы, если ответ имеет какое-то отношение к этой стихии – например, леканомансия будет работать лучше, чем экстиспиция, в случае вопроса о море.
Модификаторы умения: стандартные Модификаторы за большие расстояния (M14). Если задаются повторные вопросы об одном и том же объекте в течение дня, «флюиды» становятся мутными; -4 к умению для второго вопроса, -8 для третьего, и так далее. Вопросы о прошлом или будущем также труднее; используйте Модификаторы времени (M81).
Стоимость: 10.
Время сотворения: 1 час, если не указано иное.
Требования: История, и другие заклинания, указанные для конкретных методов предсказания.

Стандартные прорицания:
Астрология (Astrology) – это прорицание с помощью изучения небес, включая погоду. Наблюдение за небом необходимо; заклинатель должен быть вне помещения, и получает штраф в -5, если наблюдение производится не в ясную ночь и вдали от городских огней. Без справочной библиотеки (стоимость 2000$, вес 200 фунтов), все броски с -5. Поскольку астрология полагается на предсказуемые движения звёзд, она хороша для прорицания далеко в прошлое или будущее; никакие модификаторы времени не применяются к астрологическим прорицаниям. Если прорицание касается индивидуума, должны быть известны его место и дата рождения, или все броски будут с -5. Все штрафы накапливаются! Требования: Предсказать погоду и Астрономия-15+.
Авгурия (Augury) – это изучение предвестий или знамений. Точная природа знамений зависит от культуры прорицателя; древнеримские жрецы изучали полёт и поведение птиц, например. Фэнтезийные культуры могут находить предвестия во всём, от того, как ест медведь возле ручья, до движения ветра сквозь ивовое дерево; общее – наблюдение какого-то естественного события. Когда это прорицание твориться, Мастер должен в тайне кинуть Зрение заклинателя. При провале броска, бросок на сотворение прорицания делается с -5. Авгурия не идеальна для прорицания о прошлом; модификаторы времени удваиваются при использовании Авгурии, при ответе на вопросы о прошедших событиях. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание на картах (Картомансия, Cartomancy) – это прорицание, используя карты таро или другие предсказательные карты. Карты, будучи очень символичными, редко дают прямой ответ вроде «да» или «нет». Единственное нужное оборудование – колода таро (раскрашенная вручную и стоящая 1000$ на ТУ3 и ниже, но массово и дешево производящаяся на более высоких ТУ). Картомансия – очень личный метод прорицания; любая попытка спросить о ком-то кроме объекта заклинания бросается с -5. Требования: по одному заклинанию из каждой из четырёх стихий.
Гадание с кристаллом (Сrystal-gazing) – это использование Хрустального шара (M71) или зеркала чтобы способствовать видению. Если оно сработает, Мастер описывает сцену; интерпретировать её должен игрок! Заклинатель может использовать чистую, неподвижную воду для этого прорицания, но с -10 к умению. Требование: Видеть сквозь землю или Видеть сквозь воду.
Дактиломантия (Dactylomancy) – это прорицание путём передвижения указателя по доске со всеми буквами алфавита, а также «да» и «нет». Дактиломантические прорицания обычно просты и понятны, но очень грубы; сложный вопрос (да и практически любой вопрос, на который не ответить пятью словами или меньше), скорее всего, даст загадочную тарабарщину. Требования: по одному заклинанию из каждой из четырёх стихий.
Экстиспиция (гиероскопия, Extispicy) – это прорицание путём рассмотрения внутренностей убитого животного (должно весить по меньшей мере 20 фунтов – никаких голубей!). Во многих местах оно запрещено законом. Можно задать только один вопрос на животное. Экстиспиция наиболее полезна в прорицании, касающемся вопросов жизни и смерти: болезнь и здоровье, война и мир, победа и поражение – все они хорошие кандидаты для экстиспиции. Другие вопросы с большей вероятностью получат расплывчатые и бесполезные ответы. Требования: четыре заклинания школы Животных.
Гастромансия (Gastromancy) – требует добровольца. Объект помещается в транс, в течение которого он говорит вещи пророческие и таинственные. Когда заклинание сотворено, объект теряет 5 ЕУ(FP) в добавок к энергии, потраченной заклинателем, вне зависимости от того, было ли заклинание успешным. Требования: Гипноз-15 или выше, и три заклинания из школы Контроля разума.
Геомансия (Geomancy) – прорицание путём изучения почвы. Геомансией надо заниматься вне помещений, где геомант может осмотреть положение земли. Она очень привязана к месту. Любые вопросы, которые не относятся к области, где производится прорицание, получают штраф -10. Требования: четыре заклинания школы Земли.
Леканомансия (Lecanomancy) – это прорицание путём наблюдения результатов бросания предметов в воду. Как и авгурия, леканомансия принимает разные формы в разных культурах. Некоторые прорицатели льют расплавленный металл в воду, чтобы пронаблюдать, какие формы примет металл, в то время как другие рассматривают чайные листья или просто кидают камни в бассейн и наблюдают рябь. Леканомансия всегда расплывчата, и всегда получает штраф -5; с другой стороны, все модификаторы времени делятся на два. Требования: четыре заклинания школы Воды.
Нумерология или арифмансия (Numerology, arithmancy), это прорицание по различным числам, которые определяют индивидуума, включая выведенные из имени, дня рождения и, в современных сеттингах, даже таких вещей, как номера социального страхования. Если день рождения объекта неизвестен, заклинатель получает -10 к эффективному умению. Требование: Математические способности.
Толкование снов (Онейромансия, Oneiromancy) – это интерпретация собственных снов заклинателя. Не требуется никакого снаряжения, но за ночь можно спросить только один вопрос, и всего 50% вероятности, что заклинатель вообще увидит сны! Использования умения Ясный сон  или любого заклинания снов, нарушает любую попытку толковать сны. Мастер говорит заклинателю, что он увидел во сне; игрок должен интерпретировать. Энергостоимость оплачивается по пробуждении. Требования: четыре заклинания школы Общения и Понимания.
Физиогномия (Physiognomy) – это предсказание путём осмотра и измерения частей тела объекта. Различные традиции обычно фокусируются на определённой части тела – кистях рук, ногах, голове, и т.д. Физиогномия только подходит для ответов на вопрос об объекте или его судьбе; попытки прорицать информацию об отсутствующих лицах с -5. Требования: четыре заклинания Контроля тела.
Пиромансия (Pyromancy) – это прорицание, наблюдая огонь или дым. Оно может создать видение, или заклинатель может услышать голос в пламени. Надо сжечь небольшое количество определённых редких растений (стоимостью 100$ за попытку). Вопросы с -4, если не сжечь ещё и что-то, относящееся к вопросу (например, волосы объекта прорицания). Требования: четыре заклинания школы Огня.
Клеромансия (Sortilege) – это предсказание путём бросания жребия или других предметов, которые раскрывают информацию исходя из того, как они упали. И Цзинь (I Ching) – форма клеромансии; другие культуры использовали клеромансию, кидая на землю пучок стрел и осмысляя то, как они упали. Требования: по одному заклинанию из каждой из четырёх стихий.
Символизм (Symbol-Casting) – это прорицание с помощью Символьных предметов (M205). Заклинатель должен иметь полный набор символов для своего символьного языка, и получает -1 за каждый предмет, которого не хватает. Просто предметы с символами вполне будут работать, но полный набор истинных символьных предметов даёт +2 к умению. Тщательное прорицание занимает 30 минут, но заклинатель может просто запустить руку в сумку и вытащить один или более камней. В последнем случае, энергостоимость всего 1. Мастер сообщает заклинателю, какие символ(ы) он вытащил; заклинатель должен это интерпретировать, и символы, вытащенные на проваленном броске, вводят в заблуждение. Требование: Рисование символов-15 или выше.</description-loc>
		<college>Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Instant</duration>
		<reference>M109</reference>
		<categories>
			<category>Knowledge</category>
		</categories>
		<prereq_list all="yes">
			<skill_prereq has="yes">
				<name compare="is">symbol-drawing</name>
				<specialization compare="is anything"></specialization>
				<level compare="at least">15</level>
			</skill_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Colors</name>
		<name-loc>Цвета</name-loc>
		<description-loc>Обычное
Изменяет цвет любого света. Сотворяется на источник света. Если заклинатель концентрируется, возможны многократные изменения цвета одним заклинанием.
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание (для заклинания Постоянный свет изменение постоянное).
Требование: Свет.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M110</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Continual Light</name>
		<name-loc>Постоянный свет</name-loc>
		<description-loc>Обычное
Заставляет маленький объект (до 1 фунта или с кулак размером) или маленькую часть большего объекта, излучать белый свет.
Длительность: Разная – бросьте 2d для определения количества дней. Не считается «активным» заклинанием. 
Стоимость: 2 – тусклое лунное свечение, 4 – яркость факела, 6 – яркий дневной свет.
Требование: Свет.
Предмет
За 100-кратную энергостоимость  (например, 200 для тусклого свечения, и т.д.) можно любой предмет сделать светящимся навсегда.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 moon, 4 torch, 6 day</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>2d days</duration>
		<reference>M110</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Light</name>
		<name-loc>Свет</name-loc>
		<description-loc>Обычное
Создает маленький неподвижный огонек, наподобие свечного. Он сможет перемещаться с БД (BM) 5, если заклинатель сконцентрируется на его движении.
Длительность: 1 минута.
Стоимость: 1 на сотворение, 1 на поддержание.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 100.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M110</reference>
		<categories>
			<category>Light</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Shadow</name>
		<name-loc>Убрать тень</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Тень объекта исчезает. Несогласные объекты сопротивляются по Воле(Will). (Если источников света более одного, исчезнут все тени!)
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание.
Требование: Свет.
Предмет
Украшение. Всегда включен; действует только на владельца. Энергостоимость создания: 100; должен содержать  черный оникс за 100 $.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-Will</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M110</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bright Vision</name>
		<name-loc>Светозащитные очки</name-loc>
		<description-loc>Обычное
Позволит безопасно смотреть на интенсивные источники света (бушующий огонь или солнце) и защищает от ослепления заклинанием Вспышка, атак, основанных на зрении и всего похожего.
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание.
Требования: Острое зрение  или, по крайней мере, пять заклинаний Света и тьмы. Объект не должен страдать от Слепоты.
Предмет
Посох, палочка или украшение (современным сеттингам больше подходят темные очки или сварочные щитки). Действует только на владельца. Энергостоимость создания: 200.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">blindness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">keen vision</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<college compare="is">light</college>
					<quantity compare="at least">5</quantity>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dark Vision</name>
		<name-loc>Зрение в темноте</name-loc>
		<description-loc>Обычное
Объект может видеть даже в полной темноте, как с преимуществом Зрение в темноте. Также он может игнорировать эффекты заклинания Темнота.
Длительность: 1 минута.
Стоимость: 5 на сотворение, 2 на поддержание.
Требование: Ночное зрение или Инфразрение.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 400.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">night vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">infravision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Darkness</name>
		<name-loc>Темнота</name-loc>
		<description-loc>Областное
Укрывает область кромешной тьмой. Персонаж в области видит наружу нормально, но не может ничего видеть внутри. Снаружи видно только темноту внутри области. Таким образом, атаки из темноты проходят без штрафа; атаки в темноту штрафуются по боевым правилам (B394). Преимущество Зрение в темноте позволяет видеть сквозь заклинание, а Инфразрение и Ночное зрение – нет.
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение, 1 на поддержание.
Требование: Постоянный свет.
Предмет
Пол, земля или коврик могут быть зачарованы, чтобы область над ними (около 6 футов) была постоянно в Темноте.
Энергостоимость создания: 12 за квадратный фут.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hawk Vision</name>
		<name-loc>Соколиный глаз</name-loc>
		<description-loc>Обычное
Объект получает необычайную ясность зрения и способность «приближать» отдаленные объекты аналогично Телескопическому зрению (B92). Каждый уровень позволяет игнорировать -1 штрафа за расстояние на любой бросок зрения или -2, если используется маневр Прицеливание. Также это заклинание может использоваться и как оптический прицел – давая вам премию +1 Точ за уровень, когда вы целитесь в течение количества секунд, равного получаемой премии. Выгоды заклинания не складываются с таковыми от технологических устройств – типа биноклей или прицелов. Если у вас есть и то и другое, надо выбрать что-то одно.
Длительность: 1 минута.
Основная стоимость: 2 за уровень Телескопического зрения. Половина на поддержание.
Время сотворения: 2 секунды.
Требования: Острое Зрение или 5 Заклинаний света. Объект не должен страдать от Слепоты или Плохого зрения.
Предмет
Одежда или украшение с изображением  сокола. Действует только на владельца. Энергостоимость создания: 400.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/level</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">blindness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">keen vision</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<college compare="is">light</college>
					<quantity compare="at least">5</quantity>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Infravision</name>
		<name-loc>Инфразрение</name-loc>
		<description-loc>Обычное
Позволит видеть «инфракрасные» или тепловые лучи в дополнение к нормальному свету, как с преимуществом Инфразрение (B60). Это заклинание не позволяет замечать невидимые объекты.
Длительность: 1 минута.
Стоимость: 3 на сотворение, 1 на поддержание.
Требование: Острое зрение  или 5 Заклинаний света.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 100.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">keen vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="is">light</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Night Vision</name>
		<name-loc>Ночное зрение</name-loc>
		<description-loc>Обычное
Пока есть хоть немного света, можно ясно видеть, как с Адаптацией к темноте 9. В полной темноте объект по-прежнему слеп.
Длительность: 1 минута.
Стоимость: 3 на сотворение, 1 на  поддержание.
Требование: Острое зрение или 5 Заклинания света.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 200.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">keen vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="is">light</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Light</name>
		<name-loc>Формировать свет</name-loc>
		<description-loc>Обычное
 Этим заклинанием можно превратить источник равномерного света в направленный. Заклинатель должен определить любое число «отражателей» или ограничить освещение определенными лучами. Таким образом, можно превратить факел в своего рода фонарь. Концентрация требуется для изменения формы света, но не для ее поддержания.
Заклинание может изгибать и закручивать лучи света. Мастер может разрешить любые эффекты, которые не предусмотрены заклинаниями Простая иллюзия, Микрозрение, Невидимость и т.п.
Длительность: 1 минута.
Стоимость: 2, столько же на поддержание.
Требование:  Свет
Предмет
(а) За 100-кратную стоимость эффект может быть закреплен навсегда (создание световой статуи, например), однако сам свет тоже должен быть сохранен. (б) Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Small Vision</name>
		<name-loc>Микрозрение</name-loc>
		<description-loc>Обычное
Объект может исследовать предметы в пределах досягаемости, как-будто они под x100 усилением, аналогично Микроскопическому зрению 2 (B68). На время действия заклинания объект чрезвычайно близорук (см. Плохое зрение, B123): он не может ясно видеть объекты далее одного ярда, они кажутся размытыми. Все контактные атаки производятся со штрафом -2 к навыку. 
Также относится к школе Знаний.
Длительность: 1 минута.
Стоимость: 4 на сотворение, 2 на поддержание. Каждое удвоение стоимости десятикратно увеличивает приближение.
Время сотворения: 2 секунды.
Требования: Острое зрение или, по крайней мере, пять заклинаний Света и тьмы. Объект не должен страдать от Слепоты или Плохого зрения.
Предмет
(a) Одежда или украшение. Должен иметь изображение блохи в натуральную величину. Действует только на владельца. Энергостоимость создания: 400. (б) Драгоценный камень, работающий как лупа. Стоимость создания: 400 энергии плюс стоимость камня.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4#</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M111</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="no">
				<name compare="is">blindness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">keen vision</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<college compare="is">light</college>
					<quantity compare="at least">5</quantity>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blackout</name>
		<name-loc>Тьма</name-loc>
		<description-loc>Областное
Покрывает область непроницаемой тьмой. Никто не может видеть сквозь нее ни снаружи, ни изнутри области; см. боевые правила B394.
Видеть сквозь заклинание позволяет преимущество Зрение в темноте, но не Инфразрение и Ночное зрение.
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение, 1 на поддержание.
Требование: Темнота.
Предмет
Пол, земля или коврик могут быть зачарованы, чтобы область над ними (около 6 футов) была постоянно во Тьме.
Энергостоимость создания: 15 за квадратный фут.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M112</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">darkness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Flash</name>
		<name-loc>Вспышка</name-loc>
		<description-loc>Обычное
Создает ярчайшую вспышку света. Она полностью ослепит всех ее видящих, и уменьшит ЛВ(DX) других на 3 (с уменьшением всех умений на основе ЛВ(DX)). Может подействовать на любого, оказавшегося перед вспышкой с открытыми глазами (если не используются миниатюры – на усмотрение Мастера). Не подействует на заклинателя, при сотворении закрывшего глаза. Все остальные существа в зоне действия должны сделать бросок ЗД(HT), чтобы избежать следующих эффектов:
Расстояние	бросок ЗД(HT) успешен	бросок ЗД(HT) провален
В пределах  10 ярдов	-3 ЛВ(DX) на 1 минуту	Слепота 3 сек. -3 ЛВ(DX) на 1 мин.
От 11 до 25 ярдов	-3 ЛВ(DX) на 10 сек.	-3 ЛВ(DX) на 1 минуту
Свыше 26 ярдов 	Нет эффекта	-3 ЛВ(DX) на 3 секунды
Стоимость: 4.
Время сотворения: 2 секунды.
Требование: Постоянный свет.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>Blinds</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M112</reference>
		<notes>HT roll to resist blinding</notes>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Gloom</name>
		<name-loc>Мрак</name-loc>
		<description-loc>Областное
Погружает область во мрак. Чем больше энергии потрачено, тем более мрачным становится окружающий свет. В отличие от заклинания Темноты, источники света нормально работают внутри области.
Длительность: Разная. Мастер должен бросить 2d для определения количества дней.
Основная стоимость: 1/2 – свет факела; 1 – лунный свет; 3/2 – звездный свет; 2 – полная темнота. Минимальный радиус – 2 ярда.
Время на сотворение: 1 секунда за полпункта основной стоимости.
Требование: Постоянный свет.
Предмет
(a) Палочка, посох или украшение. Энергостоимость создания: 250.  (б) область может быть затемнена навсегда за 100-кратную стоимость создания.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>2d days</duration>
		<reference>M112</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Glow</name>
		<name-loc>Свечение</name-loc>
		<description-loc>Областное
Заливает область однородным свечением. Объекты и существа внутри области не отбрасывают теней, если нет источника света сильнее созданного заклинанием.
Длительность: Разная. Мастер должен бросить 2d для определения количества дней.
Базовая стоимость: 1/2 – звездный свет; 1 – лунный свет; 3/2 – свет факела; 2 – дневной света (яркий без штрафа к зрению). Минимальный радиус – 2 ярда.
Время сотворение: 1 секунда за полпункта базовой стоимости
Требование: Постоянный свет.
Предмет
(a) Палочка, посох или украшение. Энергостоимость создания: 250.  (б) За 100-кратную базовую стоимость область может быть освещена навсегда.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>2d days</duration>
		<reference>M112</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Light Jet</name>
		<name-loc>Струя света</name-loc>
		<description-loc>Обычное
Испускает луч яркого света из пальца, который можно использовать как прожектор. Дает хорошее освещение на 10 ярдов в указываемом направлении, и можно что-либо рассмотреть вплоть до 30 ярдов. При хорошей видимости им можно подавать сигналы на целую милю. В бою может ослепить противников в пределах 10 ярдов, но только в относительной темноте (например, когда штраф за освещение не слабее -5). Каждый ход заклинатель бросает против умения Природной атаки или ЛВ(DX)-4; чтобы попасть в лицо штраф -5. От луча можно уклониться или блокировать, но нельзя парировать. Пораженная цель получает штраф к боевым умениям: -4 на следующий ход и -1 до конца боя. Эффект не складывается. Для противников с Адаптацией к темноте штрафы удваиваются.
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание.
Требование: Постоянный свет или Формировать свет.
Предмет
Перчатка или кольцо; предмет позволяет владельцу сотворить заклинание. Энергостоимость создания: 200.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>Blinds</damage>
			<usage>Jet</usage>
			<reach>10</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M112</reference>
		<notes>blinds only when darkness penalty is -5 or more</notes>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mirror</name>
		<name-loc>Зеркало</name-loc>
		<description-loc>Обычное
Создает отражающую поверхность на объекте или саму по себе (в этом случае двухстороннюю). Зеркальная поверхность не обязана быть плоской, например, можно создать «кривое» зеркало. 
Во вселенной с развитой наукой заклинатели со знанием физики могут создавать параболические отражатели. Несложной кривой хватит для готовки мяса; большую и качественную можно использовать, чтобы плавить свинец, при наличии достаточного освещения солнечным светом под нужным углом. Мастер может предположить, что против живых целей такое зеркало наносит 1 пункт обжигающих повреждений за ярд радиуса зеркала каждые 10 секунд. При зажигании вещей, используйте правила Воспламенения (M72), заменяя указанную энергостоимость размером Зеркала. Толстое дерево загорится от 8-ярдового Зеркала примерно через 10 секунд. Другие варианты использования – на усмотрение Мастера.
Длительность: 1 минута.
Стоимость: 2. Столько же на поддержание.
Требование: Цвета.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 350; предмет должен содержать крошечное зеркало.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M112</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">colors</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blur</name>
		<name-loc>Размыть</name-loc>
		<description-loc>Обычное
Объект сложнее увидеть, а значит сложнее попасть при атаке. Каждый пункт энергии дает -1 к эффективному навыку любой атаки на объект, до максимума -5.
Длительность: 1 минута.
Стоимость: 1 - 5 на сотворение. Столько же на поддержание.
Время сотворения: 2 секунды.
Требование: Темнота или Мрак.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 100 за пункт штрафа.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">darkness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">gloom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Continual Mage Light</name>
		<name-loc>Постоянный волшебный свет</name-loc>
		<description-loc>Обычное
Сотворенное на маленький объект (до 1 фунта или с кулак размером) или маленькую часть большого объекта, заставляет его светиться Волшебным светом. 
Длительность: Разная. Мастер должен бросить 2d для числа дней. 
Стоимость: 2 – тусклый свечной свет, 4  – яркость факела, 6 – яркий дневной свет. Столько же на поддержание.
Требования: Волшебный свет и Постоянный Свет.
Предмет
Любой предмет можно сделать излучателем Волшебного света навсегда, за 100-кратную энергостоимость  (например, 200 для тусклого света, и т.д.)</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 candle, 4 torch, 6 day</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>2d days</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mage light</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hide</name>
		<name-loc>Скрыть</name-loc>
		<description-loc>Обычное
Осложняет поиск объекта. Нужен бросок Зрения, чтобы заметить объект в зоне прямой видимости; броски Чувства, чтобы обнаружить уже скрытый объект, с -1 за каждую единицу потраченной энергии, до максимума -5. Эти эффекты действуют, только пока объект неподвижен; если он двигается, а затем остановится до того, как заклинание развеется, эффекты возобновятся.
Длительность: 1 час.
Стоимость: 1 - 5 на сотворение. Столько же на поддержание.
Время сотворения: 5 секунд.
Требование: Размыть или Забывчивость.
Предмет
(a) Украшение, палочка или посох; действует только на владельца. Энергостоимость создания: 1.000. (б) Любой предмет может быть «скрыт» навсегда, по энергостоимости 200 за пункт «скрытности».</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 secs</casting_time>
		<duration>1 hour</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">blur</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mage Light</name>
		<name-loc>Волшебный свет</name-loc>
		<description-loc>Обычное
Создает маленький огонек. Но его свечение заметно только магам, волшебным существам или находящимся под действием Волшебного зрения. Он перемещается точно так же как Свет. Бросок ИН(IQ)+Магичность(Magery) не нужен, чтобы увидеть или использовать данный свет.
Длительность: 1 минута.
Стоимость: 1 – тусклый свечной свет, 2 – яркость факела, 3 – яркий дневной свет. Столько же на поддержание.
Требования: Волшебное зрение и Свет.
Предмет
Палочка, посох, украшение или фонарь. Используется только магами. Энергостоимость создания: 100.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 candle, 2 torch, 3 day</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mage sight</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Reflection</name>
		<name-loc>Убрать отражение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Отражение(я) объекта, исчезает из зеркал, водоемов, и т.д. На более высоких ТУ может сделать объект невидимым для датчиков, имеющих зеркальные рабочие части (на усмотрение Мастера).
Длительность: 1 минута.
Стоимость: 2 на сотворение, 1 на поддержание.
Требование: Убрать тень.
Предмет
Украшение. Всегда включен. Действует только на владельца. Энергостоимость создания: 200; должен содержать черный оникс за 100 $.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-Will</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">remove shadow</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>See Invisible</name>
		<name-loc>Видеть невидимое</name-loc>
		<description-loc>Обычное
Объект может видеть что-нибудь скрытое заклинанием Невидимости или «естественной» невидимостью. Такие вещи будут немного прозрачными, так что сквозь них можно видеть и понять, что они невидимы для других.
Длительность: 1 минута.
Стоимость: 4 на сотворение,  2 на поддержание.
Требования: Или Зрение в темноте и Инфразрение, или Невидимость.
Предмет
Посох, палочка или украшение; действует только на владельца. Энергостоимость создания: 400.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">invisibility</name>
			</spell_prereq>
			<prereq_list all="yes">
				<spell_prereq has="yes">
					<name compare="is">dark vision</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">infravision</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Darkness</name>
		<name-loc>Формировать тьму</name-loc>
		<description-loc>Областное
Формирует и перемещает трехмерную темноту, созданную заклинаниями Темноты или Тьмы с БД (BM) 5. Также позволяет формировать существующие двумерные тени в другие двумерные формы. Тени легко уменьшаются, а увеличение делает их прозрачнее. Обычный случайный наблюдатель этого не заметит, но тот, кто пристально смотрит на тень, должен сделать бросок ИН(IQ), чтобы понять, что ей не хватает «плотности». Тени не обязаны оставаться прикрепленными к объектам, их отбросившими.
Длительность: 1 минута.
Базовая стоимость: 2. Столько же на поддержание. Для двумерных теней базовая стоимость 1.
Требование: Темнота.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 200.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">darkness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wall of Light</name>
		<name-loc>Стена света</name-loc>
		<description-loc>Областное
Создает занавес света вокруг области. Стена четыре ярда высотой, но может быть сделана выше простым расчетом стоимости от высоты (двойная для 8 ярдов, тройная для 12  и т.д.). 
Единственное что она блокирует, это зрение в оба направления. Не оказывает эффекта на заклинания, существ, звуки, и т.д. Светозащитные очки позволяют видеть сквозь стену.
Длительность: 1 минута.
Основная стоимость: 1 – 3 на сотворение. Столько же на поддержание. Свечение Стены зависит от затраченной энергии, согласно Постоянному свету.
Требование: Постоянный свет.
Предмет
(a) Посох, палочка или украшение. Энергостоимость создания: 200. (б) Стена света может быть сделана постоянной за 100-кратную энергостоимость.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M113</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Body of Shadows</name>
		<name-loc>Тело из тени</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Тело объекта исчезает, оставляя только тень. Теперь объект двумерная тень на стене или полу и на время действия заклинания получает преимущество Теневая форма (B83). Его одежда (до 6 фунтов) также становится тенью, но в этой форме теряет любые волшебные силы, если таковые были. Остальное снаряжение падает на землю; в этой форме объект ничего не может нести.
Заметьте, что заклинание не усиливает чувства объекта до возможности видеть в полной темноте!
Длительность: 1 минута. Прекращается, если объект теряет сознание.
Стоимость: 6 на сотворение, 3 на поддержание.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2, Формировать тьму и, по крайней мере, три Заклинания перемещения.
Предмет
Посох, палочка, украшение или плащ. Действует только на владельца. Серьезный недостаток всех предметов, кроме плаща, в том, что они провалятся сквозь объект, после сотворения заклинания! Энергостоимость создания: 2.500 (6.000 для плаща).</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/R-HT</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M114</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (light)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape darkness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="is">movement</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Continual Sunlight</name>
		<name-loc>Постоянный солнечный свет</name-loc>
		<description-loc>Областное
Освещает область согласно заклинанию Солнечного света, но длится дольше и не поддерживается.
Длительность: Разная. Сделайте бросок 2d для определения количества дней.
Базовая стоимость: 3.
Требование: Солнечный свет.
Предмет
Область может быть освещена навсегда за 100-кратную стоимость сотворения.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>2d days</duration>
		<reference>M114</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sunlight</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Invisibility</name>
		<name-loc>Невидимость</name-loc>
		<description-loc>Обычное
Цель невозможно увидеть, она не появляется в отражениях или фотографиях. Однако она по-прежнему издает звуки и может быть выслежена по запаху или по следам. Что-либо поднятое субъектом, становится невидимым, если он не пожелает оставить этот предмет видимым. Невидимку можно обнаружить с помощью Видеть невидимое, но не с помощью Инфразрения. У невидимых персонажей огромное преимущество в бою (B394).
Длительность: 1 минута.
Стоимость: 5 на сотворение, 3 на поддержание.
Время сотворения: 3 секунды.
Требования: Шесть Заклинаний света, включая Размыть.
Предмет
(a) Украшение, палочка или посох; действует только на владельца. Энергостоимость создания: 1.200. (б) предмет можно сделать невидимым навсегда по 500 энергии за клетку размера или 50 фунтов веса, смотря, что больше.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M114</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">light</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">blur</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sunbolt</name>
		<name-loc>Солнечный снаряд</name-loc>
		<description-loc>Метательное
Выстреливает снаряд концентрированного солнечного света из кончика пальца. Параметры: 1/2Д 75, max 150, Точ 2; используется умение Природная атака. Свет прожигает как лазерный луч и наносит обжигающие повреждения. Хорошая полировка щита увеличит его ПЗ(DB) против заклинания на 50 %, с округлением в меньшую сторону. 
Независимо от проникновения повреждений через броню, попадание в лицо ослепит жертву, если она не выполнит проверку ЗД(HT). Попадание в глаза наносит удвоенное повреждение и ослепляет жертву, если она не выполнит проверку ЗД(HT) со штрафом равным полученным повреждениям. Для целей восстановления считайте слепоту от Солнечного снаряда калечащим ранением  (B420). 
Любое зеркало отразит заклинание; если Мастер сомневается в точности угла падения/отражения (например, если снаряд попал в носимое зеркало), новое направление определяется случайным образом. Используйте правила поражения неверной цели (B389), при определении, поражено ли что-нибудь в новом направлении.
Намеренное отражение выстрелов - весьма хитрое дело; штраф на дальность считается за полное расстояние до цели, с дополнительным -2 на каждый «отскок». И если зеркала не являются очень большими и/или устойчивыми и/или специально  расставленными, Мастер может просто объявить невозможность выстрела.
Персонаж, защищающийся зеркалом, может попытаться отразить снаряд назад в заклинателя – считается Блоком со штрафом -2; также примените обычные штрафы на расстояние от защитника до заклинателя. ПЗ(DB) зеркала (если оно достаточно большое, чтобы иметь его; спросите у Мастера), добавляется к этому броску. Заклинатель может защищаться обычным образом, если атака не полностью неожиданная. Щит от снарядов и Обратить снаряды не действуют на Солнечный снаряд. От него защитят Силовой купол и Отразить энергию. Области волшебной Темноты или Тьмы сопротивляются Солнечному снаряду.
Стоимость: Любое количество, до вашего уровня Магичности, в секунду, в течение трех секунд. Снаряд наносит 1d-1, проникающего урона за единицу энергии.
Время на сотворение: 1 - 3 секунды.
Требования: По крайней мере, шесть других Заклинаний света и тьмы, включая Солнечный свет.
Предмет
Посох или палочка; снаряд запускается из кончика предмета. Используется только магами. Стоимость создания: 800 энергии и Солнечный камень стоящий, по крайней мере, 1.000 $.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-3xMagery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d-1 imp/point</damage>
			<accuracy>2</accuracy>
			<range>75/150</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M114</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">light</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sunlight</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sunlight</name>
		<name-loc>Солнечный свет</name-loc>
		<description-loc>Областное
Область полностью освещается дневным светом, даже подземелье! Она простирается ввысь, пока не достигнет какого-либо препятствия. Если сотворено в пещере, область - огромный столб света, поднимающийся вверх до скалы. Если сотворено в облачный день на открытом воздухе, кажется, что свет пробивается сквозь облака. Если сотворили ночью, свет как будто исходит от самой высокой звезды, кажущейся для находящихся внутри области ярким солнцем.
Рассматривайте свет как естественный солнечный для любых целей - можно выращивать растения, загорать, и т.д. Полностью действует на существ восприимчивых к эффектам солнечного света (таких как вампиры).
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение, 1 на поддержание.
Требования: Магичность(Magery) 1, Свечение и Цвета.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 150.</description-loc>
		<college>Light</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M114</reference>
		<categories>
			<category>Light</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (light)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">glow</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">colors</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Awaken Craft Spirit</name>
		<name-loc>Пробудить духа изделия</name-loc>
		<description-loc>Обычное
Каждый хорошо созданный объект – инструмент, оружие или предмет искусства может содержать духа, дремлющего внутри. Это заклинание позволяет заклинателю пробудить дух любого предмета, созданного ремесленником с величиной успеха 5 или более (Мастер может считать что это относится к случаю с ремесленником с умением не менее 15, или для любого хорошего или очень хорошего предмета). Любой предмет, созданный с помощью Вдохновленного создания, имеет ремесленный дух. Дух может ответить на один вопрос в минуту касательно своего создателя или любого из своих владельцев. Дух остается пробужденным на все время заклинания; он может оставаться в этом состоянии или уснуть, когда заклинание закончится, по собственной прихоти.
Не в каждом сеттинге существуют ремесленные духи; если Мастер не уверен, что они подходят под текущий сеттинг, этого заклинания не существует. Это также заклинание Некромантии.
Длительность: 1 минута.
Стоимость: 3 сотворение, 1 поддержка.
Время сотворения: 5 секунд.
Требования: Вдохновенное созидание и Чувствовать духа.</description-loc>
		<college>Making &amp; Breaking/Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M115</reference>
		<categories>
			<category>Making &amp; Breaking</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">inspired creation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sense spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Inspired Creation</name>
		<name-loc>Вдохновенное созидание</name-loc>
		<description-loc>Обычное
Помогает объекту создать один предмет ремесла – оружие, комплект брони, картину и т.д. – качества далеко за гранью его обычной способности. Процесс изнурителен и стоит объекту 5 ЕЖ(HP) и 10 ЕУ(FP). Работа хороша настолько, как если бы она была сделана с критическим успехом ремесленником с навыком на 5 уровней выше, чем у объекта; бросок кубика не требуется. Оружие, созданное с помощью данного эффекта, всегда Очень Хорошего качества. Такие предметы технически не являются магическими предметами, но могут быть(и часто являются) зачарованными.
По решению Мастера, это заклинание может быть использовано на предметах искусства, не относящихся к ремеслу – книгах, выступлениях, песнях и т.д.
Длительность: навсегда.
Стоимость: 5 за каждый день создания предмета.
Время сотворения: обычное время создания предмета.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5/day</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M115</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Clean</name>
		<name-loc>Уборка</name-loc>
		<description-loc>Областное
Очищает область или существо (т.е. убирает грязь и пятна, и полирует поверхности, которые могут быть отполированы). Не убирает застоявшихся запахов (для этого используйте Очистка воздуха).
Длительность: Навсегда.
Стоимость: 2
Требования: Восстановить.
Предмет
Палочка, посох или чистящий инструмент (метла, тряпка, и т.д.). Должен коснуться очищаемой области. Энергостоимость создания: 100.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">restore</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Copy</name>
		<name-loc>Копия текста</name-loc>
		<description-loc>Обычное
Делает одну или более копий одной страницы текста. Для копий необходимы бумага или пергамент. Копии магических свитков, рунных пергаментов, и т.п. не имеют магической силы.
На более высоких ТУ, это заклинание может быть использовано на цифровом носителе; одно сотворение этого заклинания скопируют примерно один килобайт информации.
Длительность: навсегда.
Стоимость: 2 + 1 за каждую копию. Копируемый документ может быть в 10 раз длиннее, если заклинатель удвоит стоимость;  так, 4 энергии произведут 1 копию 10-страничного документа, в то время как 8 энергии скопирует 100-страничную книгу.
Время сотворения: 5 секунд.
Требования: Окраска и владение письменностью на некотором языке по крайней мере на уровне Акцент.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="starts with">Language:</name>
					<notes compare="contains">Written (native)
				</notes></advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="starts with">Language:</name>
					<notes compare="contains">Written (accented)
				</notes></advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">dye</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dye</name>
		<name-loc>Окраска</name-loc>
		<description-loc>Обычное
Меняет цвет любого неодушевленного материала по желанию заклинателя (Обратите внимание, что волосы являются неодушевленными, как тонкий внешний слой кожи!). Цвет спадет через 2d дней, но на него не действуют обычные моющие средства или применение растворителей. Произведен может быть только единый, однородный цвет – узоры невозможны, но по желанию заклинателя можно повлиять только на часть объекта.
Стоимость: 1 за маленький (до ладони размером) объект, 2 за изменение цвета волос персоны или объекта кв.фут размером, 5 за объект с персону размером (МР(SM) 0)
Длительность:2d дней
Время сотворения: 3 секунды.
Требования: Восстановить и Цвета.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>2d days</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">restore</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">colors</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Find Weakness</name>
		<name-loc>Найти слабину</name-loc>
		<description-loc>Почувствовать самую уязвимую часть объекта. Заклинание может быть сотворено на любую часть большого объекта; к примеру, вам не нужно творить его на всю городскую стену сразу, а можно проверить один ярд за раз. Конечно, у многих объектов не будет особых уязвимостей.
Это заклинание может быть использовано для устранения неполадок в сложных объектах; дефект, мешающий работе машины, обычно рассматривается как ее самая уязвимая часть.
Длительность: 1 минута.
Стоимость: 1, или 1 за каждый ярд радиуса для большого объекта. Удваивается, если объект жив.
Время сотворения: 2 секунды.
Требования: одно заклинание каждого из четырех элементов.
Предмет
Драгоценности. Энергостоимость создания: 100.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Instant</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rejoin</name>
		<name-loc>Сборка</name-loc>
		<description-loc>Обычное
Временно чинит сломанный неодушевленный объект. Если не хватает каких-то мелких частей, то умение получает штраф -3, но если заклинание успешно объект держится целым без недостающих частей.
Длительность: 10 минут.
Стоимость: 1 за каждые 10 фунтов веса объекта (минимум 2) сотворение, половина этого с округлением вверх поддержка.
Требования: Ослабить и Восстановить.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/10 lbs</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>4 sec/10 lbs</casting_time>
		<duration>10 min</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">weaken</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">restore</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Restore</name>
		<name-loc>Восстановить</name-loc>
		<description-loc>Обычное
Временно заставляет сломанный неодушевленный объект выглядеть как новый. Другие чувства не будут обмануты, как и Волшебное зрение.
Длительность: 10 минут.
Стоимость: 2 сотворение, 1 поддержка.
Время сотворения: 3 секунды.
Требования: Найти слабину или Простая иллюзия.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 min</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">find weakness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Shatter</name>
		<name-loc>Расколоть</name-loc>
		<description-loc>Аналогично Ослабить, но быстрее – заклинание может быть сотворено за секунду, и может быть повторено несколько раз. Если заклинание не наносит достаточно вреда для поломки объекта, то он не повреждается. Это заклинание влияет только на неодушевленные объекты.
Человеку для своей культуры свойственно иметь хозяйство или ремесло. Мы должны иметь основу для наших высоких достижений, утонченных развлечений, поэзии и философии сделанную своими руками.
- Ральф Уолдо Эмерсон


Стоимость: от 1 до 3; наносит 1d вреда за каждую вложенную единицу энергии.
Требования: Магичность(Magery) 1 и Ослабить.
Предмет
Палочка, посох или перчатка. Используется для удара по объекту. Энергостоимость создания: 500.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>1d/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M116</reference>
		<notes>only affects inanimate objects</notes>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">weaken</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Soilproof</name>
		<name-loc>Защита от грязи</name-loc>
		<description-loc>Обычное
Объект (персона, существо или объект) и все, что он несет становится грязеотталкивающим. Одежда не пачкается и не пылится, руки не загрязняются и так далее. Заклинание не влияет на пятна, которые уже присутствуют на объекте.
Длительность: 10 минут.
Стоимость: 2 сотворение, 1 поддержка.
Время сотворения: 2 секунды.
Требования: Уборка.
Предмет
(а) Палочка, посох или драгоценности. Энергостоимость создания: 400. (б) За 100-кратную стоимость, любой предмет может стать грязеотталкивающим навсегда. Также можно сделать, чтобы предмет сопротивлялся заклинанию Ветхость (с помощью стойкости зачарования) за двойную цену. При обычном провале, зачарование теряет одно очко стойкости, и достигнув нуля перестает функционировать. Критический провал Защита от грязи  или критический успех Ветхость также ломают чары.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 min</duration>
		<reference>M116</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">clean</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Weaken</name>
		<name-loc>Ослабить</name-loc>
		<description-loc>Обычное
Наносит 1d вреда самой уязвимой части объекта (работает только с неодушевленными предметами) за каждые два очка энергии, вложенной в заклинание. См. B557, СП(DR) и ЕЖ(HP) разных предметов. Заклинатель не может использовать это заклинание на одном и том же объекте чаще, чем раз в час. СП(DR) объекта его не защищает.
Длительность: навсегда.
Стоимость: от 2 до 6.
Время сотворения: 5 секунд.
Требования: Найти слабину.
Предмет
Палочка, посох или перчатка. Используется для удара по объекту. Энергостоимость создания: 200.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2-6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>1d/2 points</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M116</reference>
		<notes>affects only inanimate objects</notes>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">find weakness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Animate Object</name>
		<name-loc>Анимировать объект</name-loc>
		<description-loc>Обычное; Специальное сопротивление
Оживляет существующий объект (статую, меч, стул, и т.д.). Его способности и атрибуты зависят от корпуса предмета – полностью на усмотрение Мастера.
Примеры: стул мог бы скакать вокруг и бить людей по голени, меч обвиться вокруг руки хозяина, а чайник сделать больше чем просто забавно удрать со стола...
Необходима концентрация; оживленный объект не имеет ИН(IQ) и является не более, чем куклой. Независимость и Инициатива не сработают на оживленный объект.
Существо, удерживающее этот объект, сопротивляется Воле(Will)й.
Длительность: 1 минута.
Стоимость: 1 за каждые 5 фунтов веса объекта за сотворение, цена удваивается при оживлении камня, утраивается при металле. Та же цена за поддержку.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 2 и по крайней мере 3 заклинания «Формировать».
Предмет
(а) Любой объект может быть оживлен навсегда за 100-кратную стоимость.(б) Палочка, посох или драгоценности. Может использоваться только магами; предмет должен коснуться объекта. Энергостоимость создания: 2.000.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/5 lbs</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M117</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">shape</name>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Knot</name>
		<name-loc>Узел</name-loc>
		<description-loc>Обычное
Завязывает узел, который невозможно развязать без магии (хотя веревка может быть просто обрезана). Узел развязывается, когда кто-то произносит пароль (указывается при сотворении), касаясь веревки в любое место. Так, веревка, привязанная на вершине скалы отвяжется когда кто-нибудь скажет пароль, если сможет прикоснуться к веревке. Узел может быть использован для шнуровки, поясов целомудрия и т.п.
Заклинание Развязать также отменит его, но у Узела будет бросок сопротивления.
Длительность: пока не будет произнесен пароль или обрезана веревка.
Стоимость: 2 сотворение, невозможна поддержка: должно быть сотворено заново, если веревка развязана.
Время сотворения: 3 секунды.
Требования: Жесткость.
Предмет
Веревка. Любой узел, завязанный этой веревкой не может быть развязан без помощи магии. При сотворении чар устанавливается пароль. Чары пропадают, если веревка обрезана. Энергостоимость сотворения: 20 за фут веревки.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Varies</duration>
		<reference>M117</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">stiffen</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reshape</name>
		<name-loc>Формирование</name-loc>
		<description-loc>Обычное
Лепит любую неодушевленную субстанцию, как глину. Однако, не передает дополнительной художественной ценности объекту! Любой неодушевленный предмет, взятый объктом под влиянием этого заклинания, станет чуть мягче – это может стать проблемой. К примеру, если объект попробует взять посох или меч, он будет наносить только половину повреждений! Оружие, выстрел из которого будет сделан в «мягком» состоянии, будет разрушено. Любой слепленный таким образом материал снова станет твердым в своей новой форме, как только объект уберет от него свои руки.
Неудобные двери и стены могут быть убраны со скоростью двух горстей материала в секунду. Это заклинание даже может быть использовано, для прокладки тоннеля через камень, но поскольку объект вынужден копать мягкую землю руками, то процесс будет медленным и изматывающим.
Длительность: 1 минута.
Стоимость: 6 сотворение, 3 поддержка.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 1, Ослабить, и либо Формировать землю, либо Формировать растение.
Предмет
Перчатки. Энергостоимость создания: 500.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M117</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">shape plant</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">shape earth</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">weaken</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Rive</name>
		<name-loc>Дыра</name-loc>
		<description-loc>Обычное
Пробивает дыры в неодушевленных объектах, стенах, и т.п. См. B557 о СП(DR) и ЕЖ(HP) разных предметов. Это заклинание работает как огромная пробивающая атака, создающая дыру 2 фута диаметром (зона влияния может быть меньше по усмотрению заклинателя).

Стоимость: 1 за кубик вреда, наносимых объекту.
Требования: Магичность(Magery) 2 и Расколоть.
Предмет
Палочка, посох или перчатка. Используется для удара по объекту. Энергостоимость создания:1.000.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/d</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>1d (pi ++)/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M117</reference>
		<notes>only affects inanimate objects</notes>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shatter</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stiffen</name>
		<name-loc>Жесткость</name-loc>
		<description-loc>Обычное; Специальное сопротивление
Временно делает мягкий объект более жестким; превращает веревку в шест, или, например, нитку в отмычку. Не работает на одушевленных предметах. Это заклинание может быть использовано, чтобы сделать импровизированное оружие; Мастеру судить о его эффективности. Это заклинание также может быть использовано, чтобы сделать жесткой одежду оппонента. В этом случае, он сопротивляется заклинанию с его СЛ(ST)+2. Если это срабатывает, он получает -1 к ЛВ(DX) за каждый фунт жесткой одежды, и это изменение ЛВ(DX) не влияет на его БД (BM).
Длительность: 10 минут.
Стоимость: 1 за каждый фунт веса объекта(минимум 2) сотворение. Половина цены за поддержку.
Время сотворения: 2 секунды за каждый фунт веса.
Требования: Сборка.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec/lb</casting_time>
		<duration>10 min</duration>
		<reference>M117</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">rejoin</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Explode</name>
		<name-loc>Взрыв</name-loc>
		<description-loc>Обычное
То же, что и Дыра, но раздробленный объект взрывается, нанося осколочные повреждения(B414).
Стоимость: от 2 до 6 сотворение, наносит 1d вреда за каждые 2 единицы вложенной энергии. За двойную стоимость вред увеличивается до 1d+2.
Требования: Магичность(Magery) 2, Расколоть и Перемещение.
Предмет
Палочка, посох или перчатка. Используется для удара по объекту. Энергостоимость создания:1.000.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2-6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>1d frag/2 points</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M118</reference>
		<notes>affects only inanimate objects</notes>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shatter</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fasten</name>
		<name-loc>Привязать</name-loc>
		<description-loc>Обычное
Обвязывает объект веревкой или цепью (которые не создаются заклинанием, только приводятся в действие). Полезно для упаковки пакетов, причаливания судов, связывания пленных и т.д. Активно сопротивляющийся объект использует свою ЛВ(DX). Привязка является обычным узлом (хотя может быть совмещена с Узлом, увеличивая расход энергии).
Длительность: Навсегда.
Стоимость: 3 сотворение(и дополнительно 1 если использовать Узел)
Требования: Узел.
Предмет
Веревка или цепь, которая обвяжет себя вокруг объекта (должна его касаться), когда команда будет произнесена; чары теряются, если она срезана или сломана. Энергостоимость создания: 90 за ярд длины.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">knot</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mapmaker</name>
		<name-loc>Картограф</name-loc>
		<description-loc>Специальное
При сотворении заклинания на свиток или любую другую пишущую поверхность (в том числе и незавершенную карту), заклинание создает карту, задуманную держателем свитка.
Заклинатель должен объявить масштаб карты, направление на север, точку свитка где начинается карта и какие подробности должны быть на карте. Созданная таким образом карта такого же качества, как если бы она была нарисована кем-то с умением Картографии, равным наименьшему значению из эффективного умения заклинателя в этом заклинании и его умения Картографии. Это ничем не лучше того, как если бы держатель свитка потратил время на самостоятельное рисование карты  - заклинание лишь экономит время.
Длительность: 1 час. Заклинание не теряет силы, если пользователь свитка сдвигается за край карты; оно лишь не может описать ничего, пока он не вернется обратно. Нарисованное остается навсегда.
Стоимость: 4 сотворение, 2 поддержка.
Время сотворения: 10 секунд.
Требования: Надпись и Измерить.
Предмет
(а) Свиток может быть сделан самописным, обновляя себя каждый раз когда держатель входит в новую область(и тратя энергию на активацию). Энергостоимость создания: 100. (б) Палочка или посох. Энергостоимость создания: 300.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">inscribe</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">measurement</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repair</name>
		<name-loc>Починить</name-loc>
		<description-loc>Обычное
Навсегда чинит сломанный неодушевленный объект. Если не хватает мелких частей, умение получает штраф -5 и требуемые материалы должны быть подготовлены, например кусок золота, для починки золотой филиграни. Если заклинание успешно, недостающие части вновь появляются. Ранее магические предметы не возвращают себе свою силу после починки (хотя это заклинание восстанавливает ослабленную магию до полной силы).
Длительность: Навсегда.
Стоимость: 2 за 5 фунтов веса объекта, минимум 6 для объектов с движущимися частями.
Время сотворения: 1 секунда за фунт (минимум 10).
Требования:  Магичность(Magery) 2 и Сборка.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/5 lbs</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec/lb</casting_time>
		<duration>Permanent</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">rejoin</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ruin</name>
		<name-loc>Ветхость</name-loc>
		<description-loc>Обычное
Ускоряет естественные процессы разложения неживых материалов. Железо и сталь ржавеют, но эффект на другие материалы слаб, если только не поддерживается очень длительное время. Заставляет органические материалы – кожу, мех, древесину, пластик, и т.д. – разлагаться до бесполезного состояния. Керамика не подвержена действию Ветхости.
Длительность: 1 минута. Каждая минута сотворения оказывает эффект старения объекта на 5 лет, и это уберет 1 СП(DR) и ЕЖ(HP) у большинства объектов. Оружие просто теряет одну градацию качества за каждое сотворение заклинания, за исключением Очень хорошего, на которое не действует совсем!
Стоимость:2 сотворение за фунт разрушаемого материала, столько же поддержка.
Время сотворения: 5 секунд за фунт материала.
Требования: Магичность(Magery) 1, Ослабить и Разложение.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 sec/lb</casting_time>
		<duration>1 min</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">weaken</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sharpen</name>
		<name-loc>Заострить</name-loc>
		<description-loc>Обычное
Временно придает чрезвычайную остроту режущему или колющему оружию. +1 или больше к базовому вреду.

Длительность: 1 минута
Стоимость: 1 за каждые 6 дюймов лезвия. Типичные стоимости (используйте их при обычных обстоятельствах) : 1 для стрелы, 2 для ножа, копья или топора; 3 для одноручного меча; 5 для двуручного. Стоимость удваивается при премии +2 или утраивается при +3. Половина этого с округлением вверх за  поддержку.
Время сотворения: 4 секунды.
Требования: Починить.
Предмет
См. Мощность(M65). Если на оружие уже действует это заклинание, премии не складываются – работает только больший.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/6" of edge</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">repair</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shatterproof</name>
		<name-loc>Ударопрочность</name-loc>
		<description-loc>Обычное
Делает маленький объект (вроде оружия или чего-то еще, что может сжимать в одной руке человек) устойчивым к разрушению. Дешёвое или обычное металлическое оружие считаются Хорошими, пока действует заклинание, и Хорошее оружие считается Очень хорошим. У других предметов удваиваются ЕЖ(HP) и они никогда не ломаются если их случайно уронить и т.д. У щитов удваиваются СП(DR) и ЕЖ(HP), если используются Правила поломки щитов (B484). Это заклинание не увеличивает сопротивление к «проникновению», так что оно не поможет стенам, броне и т.п.
Длительность: 1 час.
Стоимость: 3 сотворение, 1 поддержка.
Требования: Починить и Расколоть.
Предмет
Любой предмет можно упрочить навсегда; если он ломается, то части теряют чары. Энергостоимость создания: 400.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M118</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">repair</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shatter</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mystic Mark</name>
		<name-loc></name-loc>
		<description-loc>Тайная метка
Обычное
Оставляет невидимую метку на объекте. Метка видна заклинателю (простая концентрация) и другим с с заклинанием Аура, Видеть скрытое, Волшебное зрение, Обнаружить магию и подобных. Это может быть руна, сигил, монограмма и т.д.(Геральдика может быть полезна для распознавания.) Объект может сопротивляться с помощью ИН(IQ). При сотворении Искатель на объект с Тайной меткой заклинателю не требует более ничего «связанного с данным объектом». Метка может быть удалена с помощью Снять проклятье.
Длительность: Метка спадает с течением времени. Каждый месяц делайте бросок против Стойкости метки (M10). При провале, стойкость падает на величину провала. При критическом или при Стойкости 0 заклинание спадёт. Метки на более крепких объектах сами становятся крепче; применяйте СП(DR) поверхности в качестве премии к броску спадения метки.
Стоимость: 3 сотворение.
Время сотворения: 10 секунд.
Требования: Окраска и Слежка.
Предмет
(а) Отметка может держаться всегда (без бросков спадания каждый месяц) за 30 энергии. (б) Посох, палочка или пишущий инструмент (в том числе и клеймо). Энергостоимость создания: 300.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Varies</duration>
		<reference>M119</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dye</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">trace</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Toughen</name>
		<name-loc>Прочность</name-loc>
		<description-loc>Обычное
Делает неодушевленный объект более сложным для проникновения, увеличивая его СП(DR). Не действует на защитные качества доспехов. Если объекту наносятся повреждения, равные или больше его усиленному СП(DR), заклинание пропадает и должно быть сотворено заново.
Длительность: 1 час.
Стоимость: 1 сотворение за каждый пункт СП(DR) (максимум 8) для объекта с кулак размером, стоимость удваивается для размера до кубического фута, утраивается для объекта МР(SM) 0, та же стоимость поддержки
Время сотворения: 5 секунд.
Требования: Ударопрочность.
Предмет
См. Укрепить (M66).</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt of DR</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M119</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shatterproof</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Transparency</name>
		<name-loc></name-loc>
		<description-loc>Прозрачность
Обычное
Делает объект прозрачным. Контуры объекта остаются видимыми и его физические свойства не меняются (жесткость, вес и т.д.). Заклинатель может придать объекту цвет, вместо его обесцвечивания.
Длительность: 1 минута.
Стоимость: 4 сотворение, 2 поддержка.
Время сотворения: 10 секунд.
Требования: Окраска и Камень в землю.
Предмет
(а) Палочка, посох или драгоценности. Энергостоимость создания: 850. (б) За 400 очков (умноженных на 1+МР(SM)), любой предмет можно сделать прозрачным навсегда.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M119</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dye</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">stone to earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Weapon Self</name>
		<name-loc>Вооружиться</name-loc>
		<description-loc>Обычное; сопротивление по ЗД(HT) (или эффективному умению магического оружия)
Тело заклинателя магическим образом объединяется с контактным оружием, которое он держит. Одежда весом до 6 фунтов пропадает вместе с ним, но все остальное снаряжение падает на землю. Так, оружие танцует в воздухе, словно его сжимает невидимый оппонент. Объект сохраняет своё оружейное умение и атрибуты со скоростью, не менее 5. Атаки по оружию получают нормальный штраф за размер (B400). Оружие может только уклоняться или парировать, но его обычное СП(DR) соответствует  материалу (B483). Если оружие ломается, заклинание заканчивается и объект появляется, не раненый, но оглушенный, сжимающий бесполезное оружие в своих руках.
Объект не может говорить, так что он может творить заклинания, которые знает на уровне 20 или выше. Объект сопротивляется заклинаниям Починки и Поломки, таким как Ослабить или Дыра с помощью своего ЗД(HT).
Магическое оружие сопротивляется объединению с помощью своей Силы. Если объект желает активировать чары на оружии, он должен выиграть обычное состязание своей Воли(Will) против Силы оружия.
Длительность: 1 минута.
Стоимость: 8 сотворение, 4 поддержка
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2, Перемещение и не менее 6 заклинаний Починки и поломки, в том числе Изменить форму.
Предмет
(а) Драгоценности. Предмет исчезает вместе со своим владельцем когда заклинание сотворено, так что заклинатель может поддерживать его. Энергостоимость создания: 2.000. (б) Любое оружие. Энергостоимость создания: 500 за фунт веса (минимум 1 фунт). (в) Магическое оружие может быть зачаровано не сопротивляться объединению за 500 энергии на каждый фунт веса оружия (минимум 1 фунт).</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M119</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">making &amp; breaking</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">reshape</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Contract Object</name>
		<name-loc>Сжать объект</name-loc>
		<description-loc>Обычное
Уменьшает объект в одном измерении. Веревка или клинок, к примеру, могут стать короче. Это заклинание может сделать большинство одежды непригодным для носки. МР(SM) объекта уменьшается, только если изменения происходят не с самым большим измерением объекта. СП(DR) объекта не меняется, но ЕЖ(HP) обычно уменьшается прямо пропорционально уменьшению объекта.
Длительность: 1 час.
Стоимость: 1 сотворение за 1 фунт начального веса объекта (минимум 1 фунт) за каждое уменьшение вдвое выбранного измерения. Та же цена поддержки.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 3 и Изменить объект.
Предмет
Палочка, посох или драгоценность. Может использоваться только магами. Предмет должен коснуться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M120</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">transform object</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Disintegrate</name>
		<name-loc>Дезинтеграция</name-loc>
		<description-loc>Обычное
Аналогично Дыре, но оставляет только пыль(починка невозможна!). Если повреждений недостаточно для уничтожения объекта, эффекта не будет. Это заклинание действует только на неодушевленный объект и не может быть применено на его часть.
Длительность: навсегда.
Стоимость: от 1 до 4 сотворение; наносит 1d вреда за каждую единицу энергии.
Требования: Магичность(Magery) 2, Расколоть, Ветхость, Землю в воздух, Уничтожить воздух, и Уничтожить воду.
Предмет
Аналогично Расколоть. Энергостоимость создания: 1.500.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>1d/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M120</reference>
		<notes>affects only inanimate objects</notes>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shatter</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">ruin</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth to air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">destroy air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Enlarge Object</name>
		<name-loc>Увеличить объект</name-loc>
		<description-loc>Обычное
Увеличивает размер объекта, сохраняя его пропорции и увеличивая его МР(SM). Умножайте вес на 3,5 и ЕЖ(HP) на 1,5 за каждый прибавленный пункт МР(SM); прибавьте 1 СП(DR) за каждые 2 прибавленных пункта МР(SM).
Длительность: 1 час.
Стоимость: 1 сотворение за 1 фунт начального веса(минимум 1 фунт) за каждый пункт увеличения МР(SM). Та же цена поддержка.
Время сотворения: 3 секунды.
Требования: Расширить объект.
Предмет
Палочка, посох или драгоценность. Может быть использовано только магами. Предмет должен прикоснуться к объекту. Энергостоимость создания:800.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M120</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">extend object</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Extend Object</name>
		<name-loc>Расширить объект</name-loc>
		<description-loc>Обычное
Увеличивает объект в одном измерении. Обратное Сжать объект(см. выше).
Длительность: 1 час.
Стоимость: 1 сотворение за 1 фунт начального веса (минимум 1 фунт) за удвоение выбранного измерения. Та же цена поддержки.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 3 и Изменить объект.
Предмет
Палочка, посох или драгоценность. Может использоваться только магами. Предмет должен коснуться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M120</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">transform object</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Shrink Object</name>
		<name-loc>Уменьшить объект</name-loc>
		<description-loc>Обычное
Уменьшает размер объекта, сохраняя его пропорции и уменьшая его МР(SM). Умножайте вес на 13 и ЕЖ(HP) на 23 за каждый отнятый пункт МР(SM); отнимите 1 СП(DR) за каждые 2 отнятых пункта МР(SM).
Длительность: 1 час.
Стоимость: 1 сотворение за 1 фунт начального веса(минимум 1 фунт) за каждый пункт уменьшения МР(SM). Та же цена поддержка.
Время сотворения: 3 секунды.
Требования: Сжать объект.
Предмет
Палочка, посох или драгоценность. Может быть использовано только магами. Предмет должен прикоснуться к объекту. Энергостоимость создания:800.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M120</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">contract object</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Transform Object</name>
		<name-loc>Изменить объект</name-loc>
		<description-loc>Обычное; Специальное сопротивление
Превращает один объект в другой того же веса. Превращение может быть любым – пистолет может быть превращен в тряпичную куклу, к примеру. Также как и в случае с Создать объект (M98) все, что маг притворяет в реальность должно быть ему знакомо. Чтобы превратить в функциональный объект, заклинатель должен иметь подходящее умение для создания похожего объекта; вышеупомянутая тряпичная кукла будет довольно плохой, если заклинатель не обладает умением Шитья, и если он захочет превратить тряпичную куклу в пистолет, ему лучше иметь Оружейное умение.
Объект, удерживаемый или надетый кем-то, сопротивляется с помощью Воли(Will) своего владельца.
Длительность: 1 час.
Стоимость: 1 на сотворение за каждый фунт веса объекта, при превращении в камень (или из него) стоимость удваивается, в случае с металлом утраивается. Та же цена поддержки.
Время сотворения:равно стоимости, в секундах.
Требования: Магичность(Magery) 2, Изменить форму и не менее 4 заклинаний «Создать».
Предмет
Посох, палочка или драгоценность. Может использоваться только магами. Энергостоимость создания: 1.000.</description-loc>
		<college>Making &amp; Breaking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>cost=sec</casting_time>
		<duration>1 hr</duration>
		<reference>M120</reference>
		<categories>
			<category>Making &amp; Breaking</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">create</name>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">reshape</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (making &amp; breaking)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Counterspell</name>
		<name-loc>Контрзаклинание</name-loc>
		<description-loc>Обычное; Сопротивление от целевых заклинаний
Отменяет одно любое действующее заклинание. Не может «противостоять» заклинаниям, вносящим в мир постоянные изменения (Погасить огонь, Плоть в камень, Зомби и т.д.). Не действует на предметы зачарованные навсегда, но влияет на сотворенные ими заклинания. «Объектом» контрзаклинания может быть или объект противостоящего заклинания, или сотворивший его персонаж.
Контрзаклинание - отдельное заклинание,  но для отмены конкретного заклинания его тоже надо знать. Бросьте против меньшего из умений Контрзаклинания или отменяемого заклинания. Для отмены заклинания надо выиграть Быстрое состязание с ним. Можно сотворять Контрзаклинание много раз, отменяя областное заклинание по частям.
Стоимость: Половина цены отменяемого заклинания, без учета премий другого заклинателя за высокий уровень.
Время сотворения: 5 секунд.
Требование: Магичность(Magery) 1.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Half countered spell</casting_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M121</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (meta)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scryguard</name>
		<name-loc>Защита от наблюдения</name-loc>
		<description-loc>Обычное; Сопротивление любым Информационным заклинаниям
Любое информационное заклинание, сотворяемое на объект, должно выиграть Быстрое состязание с Защитой , чтобы «увидеть» его. Обнаружить Защиту от наблюдения может Определить заклинание.
Длительность: 10 часов.
Стоимость: 3 на сотворение, 1 на поддержание.
Время сотворения: 5 секунд.
Требование: Магичность(Magery) 1.
Предмет
Можно навсегда зачаровать любой предмет, заставив его сопротивляться любой попытке магического обнаружения. Энергостоимость создания: 500; для предметов с МР(SM) больше 0, множитель 1+МР(SM)   .</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M121</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Suspend Spell</name>
		<name-loc>Подавить заклинание</name-loc>
		<description-loc>Обычное; Сопротивление от целевых заклинаний
Временно отменяет любое действующее заклинание. Заклинатель должен знать подавляемое заклинание. Подавить заклинание не работает на магические предметы, но действует на сотворенные ими заклинания. Не могут быть приостановлены заклинания, удаляемые только с помощью Снять проклятие; для них используется Подавить проклятие.
Сотворятся на меньшем из уровней Подавить заклинание и останавливаемого заклинания. По истечению подавления, остановленное заклинание продолжит действовать с «места прекращения». Если целевое заклинание поддерживается, то его заклинатель автоматически узнает, что оно подавлено. Иначе, бросок против Восприятия(Per) + Магичность(Magery) - 3 – без учета расстояния. 
 Длительность: 1 минута.
Стоимость: 1/10 подавляемого заклинания, без учета возможной премии другого заклинателя за высокий уровень (округлять вверх). Столько же на поддержание.
Требования: Магичность(Magery) 1 и Контрзаклинание.
Предмет
Посох, палочка, или украшение. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/10th suspended spell</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M121</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">counterspell</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Conceal Magic</name>
		<name-loc>Скрыть магию</name-loc>
		<description-loc>Обычное
Сотворенное на одну персону или предмет, мешает любому информационному заклинанию, применяемому к этому объекту. Удвоенная энергия, вложенная в заклинание (до 5 единиц), вычитается из любого броска умений поиска предмета, получения информации и т.д. 
Пример: 4 единицы энергии вложено в Скрыть магию, сотворенное на кольцо. Пока заклинание действует: Обнаружить магию на кольце с -8; Идентифицировать магию для поиска любых заклинаний на кольце с -8; Волшебное зрение не увидит кольцо, пока маг не выбросит, по крайней мере, 8 (хотя остальные вещи видны) и т.д.
Заметьте, что эффекты заклинания в чем-то схожи с Защитой от наблюдения, но не точно такие же.
Длительность: 10 часов
Стоимость: от 1 до 5 на сотворение, столько же на поддержание.
Время сотворения: 3 секунды
Требования: Магичность(Magery) 1 и Обнаружить магию
Предмет
Заклинание можно сотворить на предмет навсегда, усложнив его обнаружение или определение магией. Энергостоимость создания: 100-кратная от указанной, т.е. 200 за -4 к попыткам определения или обнаружениям.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">detect magic</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>False Aura</name>
		<name-loc>Ложная Аура</name-loc>
		<description-loc>Обычное, Областное; Специальное сопротивление; Сопротивление Информационным заклинаниям
Заменяет волшебные эманации существа, области или объекта ложными; для живых существ буквально «аура». Например, человека можно заставить иметь ауру Зомби, меч может казаться зачарован Танцующим оружием, область может казаться под связанными заклинаниями Создать огонь и Клей, и т.д. Используют быстрое соревнование между Ложной аурой и любым заклинанием (Информационным или обычным), способным видеть или обнаружить эманации (такие как Аура, Волшебное зрение, Анализ магии). Если победит Ложная аура, другое заклинание одурачено. Ложная аура также работает против похожих чувств, которые могут быть у некоторых существ.
Возражающие объекты сопротивляются с ИН(IQ). Выбранная Ложная аура должна быть знакомой заклинателю, например, маг не cможет поместить Ложную ауру Голема на статуе, если не знает заклинание Голема.
Длительность: 10 часов.
Стоимость: 4 на сотворение. Половина на поддержание. При сотворении на область, базовая стоимость 4.
Время сотворения: 10 секунд.
Требования: Скрыть магию и Аура.
Предмет
(а) Любой. Действует только на владельца. Энергостоимость создания: 300. (б) Любой объект или область можно навсегда зачаровать Ложной аурой за 100-кратную стоимость.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">conceal magic</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">aura</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Great Ward</name>
		<name-loc>Великий отвод заклинания</name-loc>
		<description-loc>Блокирующее; Сопротивление от целевых заклинаний
Как Отвод  заклинания, но если сработает, защитит любое число атакованных.
Цена: 1 за объект защиты (стоит минимум 4).
Требования: Магичность(Magery) 2 и Отвод заклинания.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1/subject</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ward</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reflect</name>
		<name-loc>Отразить магию</name-loc>
		<description-loc>Блокирующее, сопротивление от целевых заклинаний
Это улучшенная версия Отвода заклинания, и работает схожим образом. Различие в том, что оно отразит враждебное заклинание, вместо рассеивания. Таким образом, если отражение успешно, враждебное заклинание атакует своего заклинателя, как если бы сразу было сотворено на него. Успешное отражение областного заклинания, защитит его объект и подействует на заклинателя, как будто он в атакованной зоне, а в остальной области действует как обычно.
Стоимость: 4 на себя, 6 на любого в пределах видимости. Нельзя защитить того, кого не видите.
Требования:  Отвод заклинания</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>4 or 6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ward</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scrywall</name>
		<name-loc>Стена защиты от наблюдения</name-loc>
		<description-loc>Областное; Сопротивление любым Информационным заклинаниям
Как Защита от наблюдения, но защищает область и содержимое целиком. 
Длительность: 10 часов.
Базовая стоимость: 3 на сотворение, 2 на поддержание.
Время сотворения: Секунда за единицу энергии. 
Требование: Защита от наблюдения.
Предмет
(а) Любой контейнер. Защищен он и содержимое. Энергостоимость создания: 200 за кубический фут (стоит минимум 500). (б) Любой коврик или область пола; защищает людей и вещи, стоящие на нем. Энергостоимость создания: 300 за ярд радиуса.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>10 hrs</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">scryguard</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ward</name>
		<name-loc>Отвод  заклинания</name-loc>
		<description-loc>Блокирующие. Сопротивление от целевых заклинаний.
Сотворенное сразу после того, как заклинание брошено в цель, может помешать его срабатыванию. Работает только против одиночной магической атаки. Если атакующее заклинание действует на нескольких человек, каждый Отвод может спасти только один объект. Не защищает от метательных заклинаний. 
Заклинатель может Отвести только те заклинания, которые он знает на уровне 12 и выше; зная, например, Сон, также может защитить отдельный объект от Массового сна. Заклинатель бросает против меньшего из значений Отвода или отражаемого заклинания. Должно объявить об использовании Отвода до того, как защищающийся  сделает бросок сопротивления. Если окажется, что сотворенное заклинание маг не может блокировать, Отвод потрачен впустую.
Стоимость: 2 на себя, 3 на любого в пределах видимости. Нельзя отвести заклинание от тех, кого не видите.
Требования: Магичность(Magery) 1.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2 or 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M122</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (meta)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Catch Spell</name>
		<name-loc>Поймать заклинание</name-loc>
		<description-loc>Блокирующее, Специальное
Сотворенное сразу после броска метаемого заклинания (не после его сотворения), позволит своему заклинателю поймать «снаряд», когда он окажется в пределах досягаемости. Заклинатель может удерживать пойманное заклинание, как если бы он сам его сотворил и позже бросить (возможно обратно в первоначального заклинателя …). Заклинатель не обязан знать ловимое заклинание.
При успешном броске Поймать заклинание, заклинатель физически ловит снаряд, как только он достаточно приблизится для захвата. Если бросок провален, заклинателя обязательно поражает заклинанием  (при критической неудаче он получит максимальные повреждения от заклинания).
Стоимость 3.
Требования Магичность(Magery) 2, ЛВ(DX) 12 и выше, Обратить снаряд.
Предмет
Перчатки. Используются только магами. Одна пара может поймать только конкретное метаемое заклинание. В данном случае варианты (такие как Огненный шар/ Разрывной огненный шар) считаются отдельными. Энергостоимость создания: 300. Перчатки, которые могут поймать любое метаемое заклинание, потребуют 1.200 энергии.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking/Special</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M123</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">return missile</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="dx" compare="at least">12</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Magic Resistance</name>
		<name-loc>Устойчивость к магии</name-loc>
		<description-loc>Обычное; сопротивление по Воле(Will) + Магичность(Magery)
За каждый пункт энергии вложенной в заклинание (до 5ти), Устойчивость к магии объекта растет на 2 или на 1 если он сопротивляется. Эта МУ работает как обычная (B67) при сотворении заклинания на объект. Он по-прежнему может творить заклинания, но со штрафом равным МУ. Заклинания уже наложенные на объект (или сотворенные им) не меняются. Зелья и магические предметы используются объектом как обычно.
Длительность: 1 минута.
Стоимость: от 1 до 5. Столько же на поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и по одному (или больше) заклинанию из семи разных школ.
Предмет
(а) Палочка, посох, оружие, или украшение; действует только на владельца. Используется кем угодно, но для немагов стоимость удвоена. Энергостоимость создания: 300 за единицу максимально возможной к сотворению магической устойчивости. (б) Любой предмет. Собственная магическая устойчивость предмета увеличена на 1 - 10; не влияет на устойчивость пользователя. Энергостоимость создания: 200 за единицу добавленной устойчивости. Не влияет на способность пользователя творить заклинания.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M123</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">7</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Penetrating Spell</name>
		<name-loc>Проникающее заклинание</name-loc>
		<description-loc>Обычное
Накладывается на другое наносящее урон заклинание, предоставляя ему делитель брони. Заклинания сотворяются одно за другим без задержек. Проникающее заклинание сотворяется первым и считается «включенным» при расчете эффективного умения второго заклинания.
Заклинание усиленное Проникающим не наносит дополнительного  урона небронированным врагам. Укрепленный СП(DR) защищает от делителя брони предоставленного заклинанием как обычный.
Длительность: пока не закончится второе заклинание.
Стоимость: смотри таблицу 
Делитель брони	Цена
2  |	2
3  |	4
5  |	6
10 | 	8
Игнорирование СП(DR)	10
Время сотворения: 3 секунды
Требования: Отсрочка и Найти слабину.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Varies</duration>
		<reference>M123</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">find weakness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scryfool</name>
		<name-loc>Обман наблюдения</name-loc>
		<description-loc>Обычное; Специальное сопротивление
Переадресует Информационные заклинания, предназначенные  первому объекту, на второй - «приманку». Оба объекта должны присутствовать во время сотворения; иначе штраф за расстояние. Возражающие объекты сопротивляются с Воле(Will)й.
С этих пор, любое Информационное заклинание, пытающееся наблюдать  первый объект, должно выиграть Быстрое соревнование с Обманом, чтобы его увидеть. Иначе увидит «приманку».
Длительность: 10 часов.
Стоимость: 4 на сотворение, 2 на  поддержание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2, Почуять наблюдение и Простая иллюзия.
Предмет
Палочка, посох, или украшение. Используется  для отклонения Информационных заклинаний только от владельца. Энергостоимость создания: 300.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M123</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense observation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">simple illusion</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Suspend Magic</name>
		<name-loc>Подавить магию</name-loc>
		<description-loc>Областное; сопротивление от целевых заклинаниям
Временно аннулирует все другие заклинания в данной области. Не влияет на зачарованные вещи и некоторые особо мощные заклинания (особенно убираемые Снять проклятием). Каждое заклинание сопротивляется отдельно.
Подавить магию не избирательное, заклинатель может выбрать форму области, за которую он платит энергию (как для всех областных), но не может исключить объекты внутри нее. Знать подавляемое заклинание(я) не обязательно. Чтобы подавить конкретное заклинание не влияя на остальные используйте Подавить заклинание.
Длительность: 1 минута
Базовая стоимость: 3 на сотворение, 2 на поддержание.
Время сотворения: 1 секунда за каждую вложенную единицу энергии.
Требования: Подавить заклинание и, по крайней мере, восемь других заклинаний любого вида.
Предмет
Посох, палочка или украшение. Используется только магами. Энергостоимость создания 1.500.
Волшебные существа (демоны, големы, создания, зомби, элементали, и т.п.) не могут пересечь границу пентаграммы; и так же не могут сотворять заклинания, или перемещать любой физический объект, через нее.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec/pt</casting_time>
		<duration>1 min</duration>
		<reference>M123</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is anything"></name>
				<quantity compare="at least">8</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">suspend spell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Displace Spell</name>
		<name-loc>Сместить заклинание</name-loc>
		<description-loc>Обычное. Сопротивление от целевого заклинания
Навсегда изменяет положение любого областного заклинания. Не влияет на особо мощные, как и на убираемые Снять проклятием. Каждое заклинание перемещается отдельно, за исключением связанных между собой, перемещаемых вместе. Заклинатель не обязан знать передвигаемые заклинания. 
После завершения сотворения область перемещается с БД (BM), равным Магичности заклинателя. Каждый ход перемещаемое заклинание выполняет бросок сопротивления, как только он хоть раз успешен, заклинание останавливается, а Сместить заклинание прерывается, хотя может быть сотворено заново. Целевое заклинание всегда делает бросок сопротивления, даже если его заклинатель не желает этого (заклинания самого заклинателя  сопротивляются с -5). Будучи перемещенным, заклинание остается активным (таким образом, заклинатель может спровоцировать Связь, перемещая его к намеченной цели). Если целевое заклинание поддерживается, сотворивший его автоматически узнает о перемещении. Иначе бросок против Восприятия(Per) + Магичность(Magery)-3, расстояние не влияет .
Длительность: до прекращения концентрации заклинателем или успешного сопротивления заклинания.
Стоимость: 1/4 перемещаемого заклинания, без учета бонусов другого заклинателя за высокий уровень (округлять вверх). 
Время сотворения: 5 секунд
Требования:  Подавить магию
Предмет
Посох, палочка или украшение. Используется только магами.  Энергостоимость создания: 1.000.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/4th displaced spell</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Varies</duration>
		<reference>M124</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">suspend magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pentagram</name>
		<name-loc>Пентаграмма</name-loc>
		<description-loc>Особенное; Сопротивляется попыткам пересечь его.
Создает магический барьер, блокирующий прохождение враждебных заклинаний и волшебных существ в любом направлении. Барьер - звездообразная фигура, начертанная на полу или земле. Волшебные существа (демоны, големы, создания, зомби, элементали, и т.п.) не могут пересечь границу пентаграммы; и так же не могут сотворять заклинания, или перемещать любой физический объект, через нее. Не волшебные существа, включая магов, могут свободно пересекать пентаграмму, но не могут сотворять заклинания через границу. Заклинания транспортировки (например Полет или Телепортация) не могут использоваться, чтобы войти в пентаграмму во враждебных целях.
Некоторых очень враждебных существ можно вызвать в пределах пентаграммы; заклинатель стоит снаружи и вызывает существо к месту в пентаграмме. Он откроет пентаграмму только, когда будет уверен, что сможет управлять вызванным существом.
У Гильдий Магов могут быть постоянные пентаграммы, сотворенные на очень высоком уровне, инкрустированные мозаикой  или драгоценностями, чтобы избежать случайного шарканья ногами.
Если часть пентаграммы разомкнута или стерта, вся сила будет потеряна, пока заклинатель не восстановит ее – все что нужно кусок мела и время (обычно только секунда), чтобы начертить линию. Никакое магическое заклинание не повредит пентаграмму, но физические атаки, как подойти и стереть линии ногами, могут получиться, если они сделаны не волшебными существами. Демон или тварь не могут сделать этого, а обычный человек может. Аналогично, обычный человек может кинуть камнем внутрь пентаграммы, а демон или голем нет.
Волшебное существо может попытаться пробиться через пентаграмму. Нужно соревнование между существом (СЛ(ST) + Воля(Will))/2 и уровнем сотворения пентаграммы. Если существо побеждает, пентаграмма разрушается! Ни одно существо не может таким образом «проверить» пентаграмму более раза в день.
Длительность: Постоянная, пока не разрушится.
Стоимость: 1 за квадратный фут защиты (минимум 10). Когда заклинание сотворено церимониально, заклинатели могут потратить дополнительную энергию, увеличив эффективное умение Пентаграммы. Маг может также использовать Медленный и верный метод зачарования (хотя технически Пентаграмма не Чара) для создания большой пентаграммы одному.
Время сотворения: Одна секунда на квадратный фут. Время тратится на черчение линий и нужно независимо от того, как хорошо заклинание известно, или сколько силы доступно. 
Требования: Щит от заклинаний
Предмет
У Гильдий Магов могут быть постоянные пентаграммы, сотворенные на очень высоком уровне, инкрустированные мозаикой или драгоценностями, чтобы избежать случайного шарканья ногами. Такой проект может быть ритуально «сокращен», если надо, меловым рисунком. Нет никакого существенного различия между ними и обычной пентаграммой - любая пентаграмма является «постоянной» пока не стерта или сломана. (Если враждебное существо прорывается через заклинание Пентаграммы, это разрушает зачарование, но не затрагивает физический чертеж, который может быть повторно зачарован позже... если его владелец выживет).</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>1/sq foot</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec/sq foot</casting_time>
		<duration>Permanent</duration>
		<reference>M124</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spell shield</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spell Shield</name>
		<name-loc>Щит от заклинаний</name-loc>
		<description-loc>Областное; Сопротивление всем заклинаниям, сотворенным через него.
Сопротивляется любому заклинанию, сотворенному через него на уровне своей Стойкости   (M10). Действует подобно Стене защиты от наблюдения. Исключение: полностью не влияет на метаемые заклинания, включая брошенные Метнуть заклинание . Если атакующее заклинание выигрывает состязание, оно проходит Щит, уменьшая его Стойкость на 1.  Когда Стойкость опустится до 0, щит рассеивается и не может быть поддержан.
Длительность: 1 минута.
Базовая стоимость: 3 на сотворение, 2 на поддержание.
Требования: Магичность(Magery) 2, Защита от наблюдения, Устойчивость к магии.
Предмет
(а) Любой контейнер. Он и содержимое защищено Щитом. Энергостоимость создания : 250 за кубический фут (минимум 500). (б) коврик или область пола, защищает людей и предметы стоящие на нем. Энергостоимость создания: 400 за ярд радиуса.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M124</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">scryguard</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">magic resistance</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spell Wall</name>
		<name-loc>Защита от заклинаний, стена</name-loc>
		<description-loc>Обычное. Сопротивление всем заклинаниям, сотворенным сквозь него
Создает стену антимагии. Стена сопротивляется всем заклинаниям творящимся через нее с одной стороны, определенной заклинателем в момент создания. Также действует подобно Стене защиты от наблюдения. Исключение: полностью не влияет на метаемые заклинания, включая Запущенные. Если Стена проваливает сопротивление проходящему сквозь нее заклинанию, оно пробивает Стену, уменьшая ее стойкость на 1.  При нулевой Стойкости рассеивается. Не сопротивляется и не влияет на заклинания проходящие ее в «безопасном» направлении (обычно со стороны сотворившего!).
Стена твориться увеличением размера от ярда, либо кусочками. При добавлении нового сегмента к ослабевшей Стене, новый сегмент принимает Стойкость «слабейшего звена». Единственный способ «починить» ослабленную Стену – создать ее заново.
Стена 4 ярда в высоту, так что возможно творить  через нее с достаточного возвышения. Более высокие стены можно сотворить пропорциональным увеличением энергии (удвоенная для удвоенной высоты и т.д.).
Длительность: 1 минута.
Стоимость: 2 за ярдовый фрагмент , столько же на поддержание. Стена также может быть горизонтальной, как «потолок» или «пол»; каждая единица энергии покрывает 2 клетки боевой карты.
Требования: Щит от заклинаний.
Предмет
Стена от заклинаний может быть постоянной за 100-кратную стоимость. Маги часто покрывают таким образом окна и люк и. «Постоянная» стена не слабеет от пробивания.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/1 yard wall</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M124</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">spell shield</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Suspend Curse</name>
		<name-loc>Подавить проклятие</name-loc>
		<description-loc>Обычное. Сопротивление от целевых заклинаний
Временно аннулирует любое из следующих заклинаний: Изменить (любого вида), Проклятие, Увеличить другого, Заклятье  (любого вида), Плоть в лед, Зарок (любого типа), Целительный сон, Неснимаемость, Проклятая кукла, Тайная метка, Клятва, Частичное окаменение, Растительная форма (любого вида), Вселение (любого вида), Превращение (любого вида), Уменьшить другого, Камень в плоть, Остановить лечение, Поражение бесплодием, Подавить Магичность(Magery), Остановить время. Также приостановит любое физическое или умственное ухудшение, вызванное враждебным Желанием любого вида. Если по какой-либо причине уровень заклинания на объекте неизвестен, оценка Мастера решающая.
Длительность: 10 минут.
Стоимость: 10, столько же на поддержание.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 1 и заклинания, по крайней мере, из 12 разных школ.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>10</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>10 min</duration>
		<reference>M125</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">12</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Suspend Mana</name>
		<name-loc>Подавить ману</name-loc>
		<description-loc>Областное
Целевая область временно становится зоной без маны, мертвой к потоку магии. Критическая неудача стоит заклинателю уровня Магичности в течение 2d дней. В конце этого времени заклинатель должен бросить против ИН(IQ)+Магичность(Magery); любой результат, кроме критической неудачи означает, что потерянная Магичность(Magery) возвращена, критическая неудача - потеря постоянна!
Длительность: зона восстанавливается в зависимости от окружающего уровня маны. При низком уровне зона заклинания сжимается в радиусе на ярд каждые три дня;  при нормальном на ярд каждый час; при высоком  или очень высоком на ярд каждую минуту!
Основная стоимость: 5. Не поддерживается.
Время сотворения: 10 минут.
Требования: Подавить магию и заклинания, по крайней мере, из 10 разных школ.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Varies</duration>
		<reference>M125</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">suspend magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Charge Powerstone</name>
		<name-loc>Зарядить энергокамень</name-loc>
		<description-loc>Обычное
Перезаряжает энергокамень с более высокой скоростью, чем он зарядится сам. Каждые 3 энергии, потраченные заклинателем, восстановят единицу энергии камня, но каждый такая единица считается «улучшенной» против будущей «обычной » перезарядки. Таким образом, Энергокамень на 10 единиц перезаряженный заклинанием в области нормальной маны, не начнет перезаряжаться сам в течение следующих 10 дней. Если он будет использован и снова перезаряжен заклинанием, то камень не начнет перезаряжаться сам 20 дней, и так далее. Присутствие нескольких Энергокамней не запрещает сотворение заклинания.
При любой обычной неудаче Энергокамень получает новую причуду (M69). При критической неудаче Энергокамень трескается и разрушается. 
Заклинанием можно благополучно перезарядить Энергокамень с причудами, ограничивающими перезарядку, только соблюдая условия, наложенные причудой. Попытки проигнорировать их могут расколоть Энергокамень.
Это заклинание не действует на Камни маны.
Длительность: энергия остается в камне до востребования.
Стоимость: 3 за единицу заряженной энергии.
Время сотворения: 10 минут.
Требования: Магичность(Magery) 3, Энергокамень, и Передать энергию.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3/pt of energy</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>until used</duration>
		<reference>M126</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">powerstone</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dispel Magic</name>
		<name-loc>Рассеять магию</name-loc>
		<description-loc>Областное, Сопротивление от целевых заклинаний
При успехе уничтожает другие заклинания в области. Совсем не влияет на чары, но рассеивает любое временное, длительное, или постоянное заклинание (M10), если в его описании не сказано иное. Каждое заклинание сопротивляется отдельно. Заклинатель не должен знать рассеиваемое заклинание(я).  Рассеять магию, не выборочное! Чтобы аннулировать отдельное заклинание, не затрагивая другие, используйте Контрзаклинание.
Длительность: Рассеянная магия исчезает навсегда.
Базовая стоимость: 3
Время сотворения: 1 секунда на единицу вложенной энергии.
Требования: Контрзаклинание и как минимум 12 любых других заклинаний.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>Permanent</duration>
		<reference>M126</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<any></any>
				<quantity compare="at least">12</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">counterspell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Spell</name>
		<name-loc>Передать заклинание</name-loc>
		<description-loc>Обычное
«Передает» – сотворенное поддерживаемое заклинание кому-то еще. Получатель полностью контролирует и ответственен за переданное заклинание, так же, как если бы сотворил его сам; он может поддерживать его или управлять им по желанию, в рамках  самого заклинания.
Получатель должен подходить по всем преимуществам и атрибутам, нужным заклинанию, но не должен знать его требований. Т.е. заклинание, требующее Магичности 2, может быть дано взаймы только персонажу с Магичность(Magery)ю 2, но заклинание, не требующее Магичности и других специальных преимуществ или атрибутов, может быть передано любому. Если у получателя есть Устойчивость к магии, Передать заклинание должно преодолеть ее.
Передать заклинание, сотворяется на меньшем из уровней Передать заклинание или целевого заклинание. Заклинатель должен коснуться получателя.
Модификаторы: Если получатель не знает всех требований получаемого заклинания, заклинатель получает -2 к умению. Если знает ¬– сотворение по номиналу. Если получатель фактически знает заклинание, заклинатель получает +2.
Длительность: Постоянное; «данное взаймы» заклинание больше не принадлежит его первоначальному заклинателю.
Стоимость: равна стоимости поддержания переданного заклинания.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1, Передать умение, и заклинания, по крайней мере, шести разных школ.
Предмет
Посох, палочка, или украшение. Используется только магами. Маг передает целевое заклинание, активируя предмет и физически отдавая его получателю; чтобы магия работала, надо постоянно держать предмет - перебросить его нельзя. Заклинание «принадлежит» получателю, пока он держит предмет, и его можно передать еще одному получателю, независимо маг он или нет. 
Энергостоимость создания: 1.000.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>maint cost of lent spell</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M126</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">6</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lend skill</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Curse</name>
		<name-loc>Снять проклятие</name-loc>
		<description-loc>Обычное; Сопротивление от целевых заклинаний
Аннулирует любое из следующих заклинаний: Изменить (любого вида), Проклятие, Увеличить другого, Заклятье  (любого вида), Плоть в лед, Зарок (любого типа), Целительный сон, Неснимаемость, Проклятая кукла, Тайная метка, Клятва, Частичное окаменение, Растительная форма (любого вида), Вселение (любого вида), Превращение (любого вида), Уменьшить другого, Камень в плоть, Остановить лечение, Поражение бесплодием, Подавить Магичность(Magery), Остановить время. Также уберет любое физическое или умственное ухудшение, вызванное враждебным Желанием любого вида. Если по какой-либо причине уровень заклинания на объекте неизвестен, оценка Мастера решающая.
Стоимость: 20.
Время сотворения: 1 час.
Требования: Магичность(Magery) 2 и, по крайней мере, по одному заклинание из 15 разных школ</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M126</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">15</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Drain Mana</name>
		<name-loc>Истощить ману</name-loc>
		<description-loc>Областное
Убирает всю ману из области навсегда, оставляя ее «мертвой» к магии. Заклинания не работают, и магия не может ощутить кого-либо или что-либо в зоне без маны; заклинания  останавливаются, магические предметы не работают, пока их не вынесут из области.
Это заклинание используется, для создания области, в которых маги, волшебные существа и объекты могут быть благополучно ограничены или скрыты. Зона без маны остается постоянной относительно земли, но не объектов. Так, если сделать внутреннюю часть коробки безманой , то при ее перемещении, мертвое место останется, где было, вместо того, чтобы переместиться с коробкой.
Критическая неудача стоит заклинателю одного уровеня Магичности!
Длительность: Постоянное.
Основная стоимость: 10.
Время сотворения: 1 час.
Требования: Рассеять магию и Подавить ману.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M127</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dispel magic</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">suspend magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Remove Aura</name>
		<name-loc>Убрать ауру</name-loc>
		<description-loc>Обычное; Специальное сопротивление; Сопротивление Информационным заклинаниям
Схожа с Ложной аурой, но удаляет магические эманации объекта полностью. Сотворенное на неодушевленный объект превратит его в чистый лист для таких заклинаний как Древняя история, История, Видеть скрытое, или Искатель (в последнем случае, Убрать ауру ломает «ассоциацию»,  таким образом Искатель сотворяется с -5). Чтобы решить это, Убрать Ауру сопротивляется любым последующим сотворениям упомянутых заклинаний - всякий раз, когда другое заклинание терпит неудачу, информация, которую оно пробовало получить, успешно удаляется. Конечно все, что случилось с объектом после удаления его ауры, свободно доступно этим заклинаниям.
Сотворенное на живой или магический объект, Убрать ауру длится только день и не может быть поддержана. Оно мешает таким заклинаниям как Аура, Обнаружить магию, Искать магию, или Волшебное зрение. Нежелающие живые объекты сопротивляются с Воле(Will)й.
Длительность: Постоянная (но см. выше).
Стоимость: 5.
Время сотворения: 10 секунд.
Требования: Рассеять магию и Аура.
Предмет
(a) Палочка, посох, или украшение. Используется только магами; предмет должен коснуться объекта. Энергостоимость создания: 250. 
(b) Украшение или одежда. Всегда включен; действует только на владельца. Энергостоимость создания: 750.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M127</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">aura</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">dispel magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Restore Mana</name>
		<name-loc>Восстановить Ману</name-loc>
		<description-loc>Областное
Обратное к Истощить ману; восстанавливает ману в мертвой зоне. Область получает уровень маны, равный «среднему» по окружающей области, независимо, какой он, возможно, был прежде. Стоимость, время, и требования такие же как для Истощить ману, но полностью нет риска потерять Магичность(Magery).</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M127</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dispel magic</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">suspend mana</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Spellguard</name>
		<name-loc>Защита заклинания</name-loc>
		<description-loc>Обычное. Сопротивление попыткам вмешаться в целевое заклинание
Твориться на другое заклинание для защиты его от попыток вмешательства . Удвоенная энергия, вложенная в заклинание (до 3 единиц) вычитается из любого умения сотворения следующих Мета-заклинаний: Контрзаклинание, Сместить заклинание, Ложная аура, Убрать ауру, Снять проклятия, Украсть заклинание, Подавит проклятие, Подавить заклинание.  Удвоенная вложенная энергия, добавляется к эффективному умению сотворившего защищаемое заклинание, при его сопротивлении  заклинаниям Рассеять магию или Подавить магию. Когда защищаемое заклинание истекает или рассеяно, Защита заклинания также рассеивается.
Длительность: 10 часов.
Стоимость: 1 - 3 на сотворение. Столько же на поддержание. Не уменьшается с повышением умения.
Время сотворения: 1 секунда за каждую единицу энергии.
Требование: Рассеять магию.
Предмет
(а) Посох, палочка, или украшение. Используется только магами. Энергостоимость создания: 500. (б) Может быть, сотворено навсегда на зачарованном предмете или области, сделав вмешательство сложнее; тогда также затрудняет Подавить чары и Снять чары. Энергостоимость сотворения: 100-кратная нормальная.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>10 hrs</duration>
		<reference>M127</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">dispel magic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Spell</name>
		<name-loc>Украсть заклинание</name-loc>
		<description-loc>Обычное; Сопротивление от целевых заклинаний
Похищает контролируемое или уже сотворенное поддерживаемое заклинание у его первоначального заклинателя. Отметьте, что оно творится около целевого заклинателя , и поэтому учитываются штрафы за расстояние. Заклинатель должен точно знать, что он крадет – Определить заклинание будет весьма полезно. Заклинания, работающие под Поддержать заклинание, также можно украсть; «заклинатель», для определения расстояния, область или объект поддерживаемого заклинания.
Нельзя украсть заклинание, если нет необходимой Магичности, преимущества, уровня атрибута, или отсутствия недостатка (см. условия для Передать заклинание). Удерживаемый Снаряд не может быть украден.
Модификаторы: -3, если заклинатель не знает воруемое  заклинание; еще -2, если также не знает требуемого для воруемого заклинания .
Длительность: Навсегда; украденное заклинание больше не принадлежит владельцу.
Стоимость: Равна стоимости поддержания краденного заклинания. 
Время сотворения: 1 секунда за единицу потраченной энергии.
Требования: Передать заклинание и Великий отвод заклинания.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>maint cost of stolen spell</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>Permanent</duration>
		<reference>M127</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend spell</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">great ward</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Hang Spell</name>
		<name-loc>Отложенное заклинание</name-loc>
		<description-loc>Особое
Творится на другое заклинании, для задержки его активации до желания заклинателя. Блокирующие заклинаний нельзя отложить.
 Отложенное заклинание, сотворяется непосредственно перед заклинанием - объектом, без задержек между сотворениями. Заклинатель бросает Отложенное заклинание при сотворении; бросок целевого заклинания не делается, пока оно не активируется. Штрафы за расстояние, «включенные» заклинания, Магическая устойчивость, изменения уровня маны и т.п. применяются во время активации целевого заклинания.
Заклинатель должен заплатить полную энергию и затраты времени за Отложенное заклинание, и его объект во время сотворения. Если заклинатель откладывает заклинание, настроенное на объект человеческих размеров, и затем активирует его на большем объекте, то эффекта, либо не будет, либо он уменьшен, как сочтет нужным Мастер.
Отложенное заклинание рассчитывает как одно «включенное» заклинание (M10) для целей сотворения; и не считается против себя при активации. Таким образом, если у мага есть четыре отложенных заклинания, он сотворяет другие с -4, но любое из отложенных с -3. Отложенное заклинание требует действия Концентрация при активации. 
Отложенные заклинания восприимчивы к Рассеять магию и Контрзаклинание, разрушающие их, и к Подавить магию и Подавить заклинание, временно препятствующие их активации. Они не могут быть украдены или переданны, потому что еще не сотворены.
Длительность: 1 час.
Стоимость: такая же, как основного заклинания при сотворении (минимум 2); столько же на поддержание. Отложенное заклинание может поддерживаться как обычно при вступлении в силу.
Время сотворения: 10 секунд.
Требование: Отсрочка.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>same as underlying spell</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M128</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Maintain Spell</name>
		<name-loc>Поддержать заклинание</name-loc>
		<description-loc>Особое
Сотворяется на одно из длящихся заклинаний самого заклинателя, предавая резерв энергии для поддержания. Как только Поддержать заклинание сотворено, целевое заклинание тянет энергию поддержания из него. Оно больше не принадлежит первоначальному заклинателю: не считается «включенным», не может быть отменено и т.д. Поддержать заклинание можно сотворить в любое время, пока активно заклинание - объект. Некоторые поддерживаемые заклинания можно «запрограммировать» согласно Независимости (M96) или даже Инициативе (M97) ( по усмотрению Мастера). 
Контроль над заклинанием, работающим под Поддержать заклинание можно украсть, используя Украсть заклинание.
Длительность: Пока не истощен резерв энергии или не рассеяно основное заклинание. 
Стоимость: Равна обычному поддержанию целевого заклинания, на срок по желанию заклинатель (с учетом сокращения стоимости за высокий уровень). Так, заклинание, поддерживаемое за 1 в минуту, может само поддерживаться в течение 10 минут за 10 энергии.
 Если заклинатель может поддерживать заклинание бесконечно без энергозатрат (из-за высокого уровня), стоимость 1 за каждые пять полных периодов работы. Так, маг с Землетрясением-20 может заставить заклинание длиться 30 минут за 6 энергии. Высокий уровень в этом заклинании также уменьшает стоимость как обычно! 
Время сотворения: 2 секунды, плюс «время программирования» если нужно.
Требование: Связь.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>maint cost of subject spell</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Varies</duration>
		<reference>M128</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">link</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Telecast</name>
		<name-loc>Удаленное сотворение</name-loc>
		<description-loc>Особое
Создает и телепортирует Волшебный глаз в отдаленное место. Теперь заклинатель может творить заклинания через него, как при своем присутствии. Нельзя удаленно сотворить Снаряды, но можно Струйные  заклинания. Контактные заклинания также можно сотворить удаленно, но Волшебный Глаз должен попасть в цель, и защищающийся должен провалить защиту.
Используйте стоимость и штрафы сотворения от заклинания Телепортация (M147). Заклинания сотворенные с «другого конца» измеряют расстояние от той точки. Удаленное сотворение считается «включенным» и требует концентрации. Мастера, желающие ограничить это сильное заклинание, могут применять штрафы за речь, движения ног или рук (M9). Если бросок Удаленного сотворения провален на 1, Волшебный глаз достигает намеченной дислокации, но заклинатель ментально оглушен. Если бросок провален более чем на 1, Волшебный Глаз оказывается где-то в другом месте (по выбору Мастера!) и заклинатель также ментально оглушен. Во всех случаях требуется бросок Чувства тела со штрафом -2, прежде чем заклинатель сможет придти в себя и начать сотворять другое заклинание; при критической неудаче он заклинатель ментально оглушен.
Ходят упорные слухи о вариантах заклинания, где Волшебный Глаз заменен Хронопортацией или Планарным смещением.
Длительность: 5 секунд.
Стоимость: Как у Телепортации для сотворения, столько же на поддержание. Высокое умение не уменьшает стоимость. Энергия тратится, успешно ли заклинание или нет.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3, Телепортация, Волшебный глаз, и заклинания, по крайней мере, из 10 разных школ.
Предмет
Глазное яблоко, вырезанное слоновой кости и инкрустированное драгоценностями. Используется только магами. По команде хозяина телепортируется; когда заклинание истекает, оно вновь появляется в руке хозяина (если не было физически уничтожено). Стоимость создания: 1.900 энергии, 1.000 $ на качественную резьбу из кости, 600 $ на драгоценности.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>same as Teleport</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>5 sec</duration>
		<reference>M128</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wizard eye</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Throw Spell</name>
		<name-loc>Метнуть заклинание</name-loc>
		<description-loc>Метаемое; Особое
Твориться на другое заклинание, преобразовывая его в Метаемое. Заклинания творятся одно за другим без задержек.  Метнуть заклинание, твориться первым и считается «включенным» при определении уровня умения заклинания - объекта (M10).
Заклинатель должен оплатить полную энергию и затраты времени для Метнуть заклинание и его объекта во время сотворения; если заклинатель метает заклинание, рассчитанное на человеческий размер, в больший объект, то эффект, либо отсутствует, либо уменьшен, на усмотрение Мастера. 
Заклинатель бросает Метнуть заклинание при сотворении; бросок для целевого заклинания не делается, до его запуска. Запущенные  заклинания имеют: 1/2Д нет, Max 80, Точ 1; для попадания бросок против ЛВ(DX)-4 или Природной атаки.
Все запущенные заклинания вступают в силу как только поразят что-либо. Центр запущенных Областных заклинаний находится в точке попадания . Эффект Струйных заклинаний начинается в точке попадания, по направлению прибытия (считайте их Ударом наугад, B388). Большинство других заклинаний просто позволяют заклинателю использовать их на более длинные дистанции, чем обычно - брошенное Почуять эмоции, например, или Малое лечение. Это заклинание позволит, применять на расстоянии контактные заклинания (Касание смерти, например). Метаемые и Блокирующие заклинания запустить нельзя.
Запущенные заклинания можно блокировать или уклониться, но не парировать. Однако любой, включая врагов, может их поймать, используя Поймать заклинание!
Длительность: Пока не запущено. 
Стоимость: 3. Запущенные заклинание поддерживаются как обычно, после вступления их в силу.
Требования: Отсрочка и Поймать заклинание.
Предмет
Любое метательное оружие может быть зачаровано для метания одного определенного заклинания, которое летит так же, как обычные боеприпасы оружия. Энергостоимость создания: 2.500-кратная  стоимость сотворения целевого заклинания-объекта. Есть слухи о зачарованном оружии, способном метать любое заклинание, известное его хозяину, но ничего более точного не известно.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile/Special</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Until thrown</duration>
		<ranged_weapon>
			<damage>Special</damage>
			<accuracy>1</accuracy>
			<range>80</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M128</reference>
		<notes>transforms another spell into a Missile spell</notes>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">catch spell</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bless</name>
		<name-loc>Благословить</name-loc>
		<description-loc>Обычное
Общее заклинание помощи и защиты. Сотворяется на другом, нельзя благословить себя. В некоторых игровых миров только святые люди или «хорошие» волшебники могут сотворить это заклинание, по решению Мастера.
Эффект благословения следующий: все броски кубиков объекта благоприятно изменены на одно очко (или больше, для более сильного благословения). Изменение затрагивает критические успехи и неудачи. Он  длится до те пор... пока объект не провалит какой либо бросок (или противник сделает хороший бросок) и попадет в серьезную опасность. Тогда благословение чудесно предотвращает или уменьшает опасность и заканчивается. Мастера решить, когда благословение выдаст заключительный эффект и какого вида будет защита. Если стрела нацелена в сердце, благословение в 1 очко могло бы перенацелить ее в руку, в то время как в 2 очка пробило бы ей шляпу, а в 3 очка позволило бы ей убить противника сзади.
Длительность: Как указанно.
Стоимость: 10 для благословения в 1 очко, 50 – в 2 очка, 500 – в 3 очка. Благословения «складываются» - более сильное рассеет более слабое.
Время сотворения: 1 минута за каждую единицу энергии в заклинании.
Требования: Магичность(Magery) 2 и по крайней мере два заклинания от каждо1 из 10 разных школ. Магичность(Magery) 3 для сотвориния благословение в 3 очка. Мастер может потребовать «святого» или «хорошего» статуса.
Предмет
Любой. Благословение сотворяется на предмет, а не на человека и действует владельца предмета. Когда благословение, наконец, предотвращает большую угрозу, предмет теряет свои чары. Энергостоимость создания: 10-кратная стоимости сотвориния на человека.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10/50/500</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>min=cost</casting_time>
		<duration>Varies</duration>
		<reference>M129</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Curse</name>
		<name-loc>Проклятие</name-loc>
		<description-loc>Обычное
Точная противоположность Благословения. Все броски объекта изменены неблагоприятно, длясь пока он не получит значительный успех, несмотря на плохие броски, Мастер решает что им считать. Тогда успеха так или иначе превращается в пепел, и проклятие окончено.
Стоимость: 3 для Проклятия в 1 очко, 10 – в 2 очка, 20 – в 3 очка. Как и Благословения, не «складываются». 
Время сотворения: 2 секунды на Проклятие в 1 очко, 4 на Проклятие в 2 очка, 6 на Проклятие в 3 очка.
Требования: Что и для Благословения, за исключением, что проклясть могут и очень хорошие, и очень злые персонажи.
Предмет
Любой. Проклятие твориться на предмет, а не на человека и действует на владельца предмета. Мастер должны бросать в секрете или делать все, что может, чтобы не дать игрокам понять, что они столкнулись с проклятым предметом! Когда Проклятие выдаст заключительное «столкновение», чары исчезнут. Энергостоимость создания: 10-кратная стоимости сотворения на человека.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3/10/20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2/4/6 sec</casting_time>
		<duration>Varies</duration>
		<reference>M129</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Delay</name>
		<name-loc>Отсрочка</name-loc>
		<description-loc>Обычное
Сотворяется на другое заклинание для задержки его активации, пока не случится указанное событие в присутствии связанного заклинания, т.е. в присутствии предмета или области, на которую оно  сотворено. Пусковое событие может быть простым или сложным по желанию заклинателя; сложное указывается в письменном виде. Пусковое событие должно сносно определяться на участке Отсрочки обычным человеком; решение за Мастером. Если Отсрочка должна быть вызвана более необычным  случаем, нужное заклинание, такое как Волшебное зрение, можно сотворить на Отсрочке. Она также может сработать при активации другого заклинания, такого как Сторожевой пес или другого связанного заклинания. Задержка может активировать только одно заклинание. 
Заклинания творятся одно за другим без задержек между ними. Отсрочка сотворяется первой и считается «включенной» при расчете умения для связанного заклинания (M10). Полная стоимость для связанного заклинания и для Отсрочки оплачивается во время сотворения. Если заклинатель определит заклинание для объекта человеческого размера, а Отсрочка сработает на большей жертве (требующей больше энергии - смотри M11), эффекта, либо не будет, либо он уменьшен, зависит от заклинания. Последнее слово за Мастером.
Отсрочку можно сотворить двумя путями: активировать связанное заклинание на конкретный объект, или, как ловушка, активировать связанное заклинание на любой объект, удовлетворяющий условиям вызова. В последнем случае Отсрочка и связанное заклинание и творятся на «предмет-ловушку», и расстояние рассчитывается от него в момент вызова. Штрафы за Магическую устойчивость также применяются в момент вызова.
Заклинатель делает бросок Отсрочки при первом сотворении; бросок для связанного заклинания не делается до момента вызова. Если намеченного объекта связанного заклинания нет во время сотворения, применяется дополнительный штраф -5 на связанное заклинание (но не на Связь) за неспособность касаться или видеть объект – смотри M11. Так, например, страшная «дверь  Смертельного касания» с установкой «напасть» на первого коснувшегося ее активируется со штрафом -5. 
Когда Отсрочка вызвана, связанное заклинание начинает активироваться, вступая в силу в следующий ход. Таким образом, Отсрочка не может использоваться как Блокирующее заклинание. Она может использоваться как ловушка, для захвата жертвы врасплох. А не ожидающая жертва должна сделать бросок ИН(IQ),  для ответа прежде, чем связанное заклинание полностью активируется - Боевые рефлексы дают +6 этому броску.
И Отсрочка, и связанное заклинание считаются «включенными», как и добавленное Информационное. Связанное заклинание не надо поддерживать, хотя, возможно, нужно Отсрочку или Информационное заклинание. Как только Отсрочка вызвана, она исчезает, и больше не считается включенной. Связанное заклинание продолжает считаться таким, пока активно и может поддерживаться как обычно.
Отсрочка можно настроить на «выключения» длящегося заклинание при возникновении события. В этом случае связанное заклинание длится, пока заклинатель поддерживает его, но сама Отсрочка не требует поддержания.
Блокирующие и Метаемые заклинания нельзя Отсрочить, можно все другие. «Мгновенные» заклинания, как Гром, срабатывают однажды при активации, затем исчезают. Длящиеся заклинания, как Голоса, начинаются при активации и работают до истечения.
Длительность: 2 часа.
Время сотворения: 10 секунд.
Стоимость: 3 на сотворение. 3 на поддержание.
Требования: Магичность(Magery) 3 и любые 15 заклинаний.</description-loc>
		<college>Meta/Linking</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>2 hrs</duration>
		<reference>M130</reference>
		<categories>
			<category>Linking</category>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<any></any>
				<quantity compare="at least">15</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Drain Magery</name>
		<name-loc>Истощить Магичность(Magery)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)+Магичность(Magery)
Навсегда истощает один уровень Магичности объекта. Заклинатель должен коснуться объекта при сотворении. 
Объект сохраняет знание заклинаний (хотя на более низком уровне), но не может сотворить требующие более высокой степени Магичности чем его новая.
Критическая неудача стоит заклинателю уровня Магичности и очко ИН(IQ)!
Длительность: Навсегда.
Стоимость: 30.
Время сотворения: 10 минут.
Требования: Магичность(Magery) 3 и Подавить Магичность(Magery).
Предмет
Ходят упорные слухи о злобных предметах, истощающих Магичность(Magery) своих жертв, но точно ничего не известно.


Связующие заклинания
Это три родственных заклинания. Отсрочка (Обычное) используется для быстрой сцепки заклинаний, а Связь (Областное) более полезна для долгосрочного связывания. Отражение (Специальное) сотворенное на другое заклинание превратит его в одноразовое Блокирующее, правила управления ими  на стр 12-13.
Любое из них: Отсрочка, Связь, Отражение - «связующее заклинание». «Связанное заклинание» – другое заклинание, управляемое «связующим». Связанные заклинания должны быть сотворены тем же самым заклинателем, в течение одной минуты после сотворения связующего.
По усмотрению Мастера решаются любые вопросы о способности заклинания обнаружить данное событие, или возможности данного заклинание быть связанным. Мастера, желающие ограничить связующие заклинания, могут разрешить маленький список заклинаний для связи, или исключить некоторые заклинания.
Любой предмет с заклинанием, связанным с ним, видим как таковой Волшебному зрению, но не броску ИН(IQ)+Магичность(Magery). Только Анализ магии может указать природу связанного заклинания.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Permanent</duration>
		<reference>M130</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">suspend magery</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Suspend Magery</name>
		<name-loc>Подавить Магичность(Magery)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)+Магичность(Magery)
Временно аннулирует Магичность(Magery) объекта. Заклинатель должен коснуться объекта при сотворении. Объект сохраняет знания заклинаний, но не может сотворить их - если, конечно, не находится в области высокой маны, когда он просто теряет премию. Даже в области высокой маны, объект не может сотворить заклинания, которые требуют Магичности любого уровня. Подавить Магичность(Magery) можно убрать только Снять проклятие.
Критическая неудача стоит заклинателю уровеня Магичности в течение 2d дней. В конце периода заклинатель должен бросить против. ИН(IQ)+Магичность(Magery); любой бросок кроме критической неудачи означает, что Магичность(Magery) восстановлена, критическая неудача – потеря навсегда!
Длительность: 1 час.
Стоимость: 12 на сотворение. Столько же на поддержание. Однако, объект сопротивляется каждый раз при продлении заклинание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2 и два заклинания по крайней мере из 10 разных школ.
Предмет
Одежда или украшение (лучше кандалы ). Всегда включен действует только на владельца. Энергостоимость создания: 2.200.</description-loc>
		<college>Meta</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M130</reference>
		<categories>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (meta)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Link</name>
		<name-loc>Связь</name-loc>
		<description-loc>Областное
Откладывает активацию одного или более связанных заклинаний, сотворенных в его области, пока не случится указанное событие в присутствии Связи. Пусковое событие может быть простым или сложным по желанию заклинателя, по правилам Отсрочки (выше). Связь также можно вызвать активацией заклинания, помещенного в область после Связи, например Сторожевой пес, Отсрочка или другая Связь. 
Заклинатель платит энергию и делает броски заклинания Связи и всех связанных заклинаний во время сотворения. Связанные заклинания могут не получить пользы за сокращение стоимости для высокого умения. Если намеченный объект связанного заклинания не присутствует во время сотворения, есть дополнительные штраф -5 на связанное заклинание (но не на Связь) за неспособность касаться или видеть объект - смотри M11.
Размер области Связи определяется во время сотворения. Любые связанные заклинания могут перемещаться в пределах области; например, если Создать огонь и Клей радиусом в ярд были связаны Связью радиусом 20 ярдов, для поимки злоумышленников, то первый, вошедший в область Связи, окажется в зоне пылающего клея, но последующие будут в безопасности (во всяком случае от этой Связи). Размер связанных заклинаний должно установить во время сотворения. Если объект больше чем предполагаемая цель, эффекта заклинания нет или он ослаблен, в зависимости от заклинания. Последнее слово за Мастером.
Поражаются объекты только в пределах области Связи, если только результат не привязывающийся к области эффект – например, вызов демона! Однако пусковое событие может произойти за пределами области. 
Время сотворения связанных заклинаний тратится при установки Связи. Нет задержек при вызове Связи - все связанные заклинания активируются немедленно.
Связанные заклинания не считаются «включенными», ни для каких целей. Каждые три Связи считаются одним «включенным» заклинанием (округлять вниз). Маг не может обнаружить Связь просто смотря на нее. Однако, заклинание Волшебное зрение или Обнаружить магию обнаружат ее. Если маг знает Скрыть магию, можно затруднить обнаружение Связи магическими методами. Просто добавьте стоимость Скрыть магию к базовой стоимости Связи для достижения эффекта. Маг должен знать, Скрыть магию, чтобы  использовать эту опцию. 
Чтобы определить результаты, если объект связанного заклинания не присутствовал при сотворении, и имеет Магическую устойчивость, пересчитайте начальный бросок, Если оригинал броска связанного заклинания не записан, перебросьте его. 
Блокирующие и Метаемые заклинания нельзя Связать – все другие можно. «Мгновенные» заклинания, как Гром, срабатывают однажды при активации, затем исчезают. Длящиеся заклинания, как Голоса, начинаются при активации и работают до истечения.
Одиночную Связь можно сделать активирующей заклинание при входе в область и деактивирующей при выходе. Она будет длиться, пока связанное заклинание не истечет. Пример, маг может сотворить Связь на Непрерывный свет. Если он выбросит семь дней длительности Непрерывного света (168 часов), он может настроить Связь на включение света, когда он входит в комнату, и выключении, когда уходит. По окончанию 168 часов света, оба заклинания рассеиваются. Мгновенные заклинания исчезает вместе со Связью после срабатывания.
Поддержание Связи не требуется, как для самой Связи, так и для связанных или любых информационных «пусковых» заклинаний.
Связь можно сотворить наоборот, для остановки одного или более заклинаний, при «стоповом » событии. В этом случае, связанное заклинание длится, пока заклинатель поддерживает его, а сама связь не требует поддержания.
Связь также может использоваться в Ограничивающих чарах (см. стр 68-69).
Длительность: До запуска и истекания связанных заклинаний.
Базовая стоимость: 8; связанные заклинания не поддерживаются.
Время сотворения: 4 часа - нет сокращения во времени, несмотря на то, как хорошо Связь изучена.
Требование: Отсрочка.
Экстравагантно или даже бесполезно сотворять некоторые заклинания как Рефлекторные!

Предмет
Заклинание можно навсегда сотворить на любой зачарованный предмет, определив обстоятельства, когда он работает. Допуск мог бы определить класс пользователей, способных использовать предмет, а Связь могла бы, например, заставить его работать только ночью. Энергостоимость создания: 200. Любые Информационные заклинания, требуемые для пуска (например, Обнаружить магию), должны сотворяться на предмет, как отдельные чары. Например, меч можно Связать с заклинаниями Свет и Почуять жизнь, так, чтобы он пылал в присутствии орков. 
Обратную Связь можно навсегда сотворить на любой зачарованный предмет, деактивируя его в указанном случае. Это часто используется, чтобы волшебные предметы не попали в неправильные руки. Энергостоимость создания: 200.</description-loc>
		<college>Meta/Linking</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>4 hrs</casting_time>
		<duration>Until triggered</duration>
		<reference>M131</reference>
		<categories>
			<category>Linking</category>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reflex</name>
		<name-loc>Рефлекс</name-loc>
		<description-loc>Особое
Cотворенное на другое заклинание, преобразует его в одноразовое Блокирующее, а затем исчезает. В отличие от Отсрочки или Связи, Рефлекс вызывается желанием заклинателя, не внешним случаем. Это значит, что Обратить снаряды Рефлекторно  можно активировать, если заклинатель видит, что кто-то стреляет в него и нельзя если стреляют в спину. Он считается активной защитой, как Парировать или Блокировать, во всех практических целях (кроме +3 к броску за отступления). Сотворение Рефлекса прервет любую концентрацию мага на заклинаниях и обрабатывается как любое другое Блокирующее заклинание - см. стр 12-13.
Связанное заклинание сотворяется немедленно после сотворения Рефлекса, тем же заклинателем. Каждое сотворение Отражения действует только на одно заклинание - нельзя иметь несколько заклинаний, работающих как одно. Рефлекс бросают во время сотворения, но бросок связанного заклинания не делают, пока оно не сотворено как Блокирующее. Энергостоимость Рефлекса платится во время сотворения, но энергия для связанного заклинания не платится, пока оно сотворено как активная защита или иначе. Время сотворения связанного заклинание тратится сразу после сотворения Рефлекса, но бросок успеха и энергостоимость обрабатываются позже. 
Связанное заклинание вместе с Рефлексом считаются одним «включенным» в целях сотворения - смотри M10. И не считается «включенным», при своем сотворении. Так, если у мага есть четыре Рефлекторные заклинания  , любое другое заклинание он творит с -4, но творя один из Рефлексов, он только с -3 за три других Рефлекса.
Рефлекс используется только раз. Затем он исчезает, и больше не считается «включенным». Эффект немедленный и мгновенный, а не с длительностью указанной в описании заклинания. Это значит, что экстравагантно или даже бесполезно сотворять некоторые заклинания как Рефлекторные! Силовой купол, например, остановил бы одну физическую атаку, а затем исчез  - затратная, но эффективная защита! Созданное животное появится, затем исчезнет прежде, чем сможет сделать что-либо. (Хотя, оно могло бы остановить снаряд во время краткого существования. Мастер может решить, что животное должно быть почти равно по размеру прикрытой цели). Исключения из правила «результат-мгновение » – заклинания с постоянными эффектом, как Большое лечение – его эффект действительно постоянный.
Персонаж может «нести» любое число Рефлексов. Однако только одно заклинание можно сотворить за ход. Учтите, если Рефлекс использован как активная защита, против этой атаки нельзя использовать другую активную защиту, кроме случая Тотальной защиты (all-out defense), см. B366.
Рефлекторное заклинание можно сотворить как обычное действие, а не обязательно как защиту. На что требуется секунда, независимо от обычного времени сотворения.
Все обычные модификаторы расстояния и Магической устойчивости используются при сотворении Рефлекторного заклинание, если его объект удален от персонажа или объект Рефлекса сам Рефлекс .
Заметьте, маг может сотворить Рефлекс на другого человека. Заклинатель (не объект) может активировать его в любое время, учтя штрафы за расстояние. Если связанное заклинание творится на объект отличный от объекта самого Рефлекса, обычный штраф на расстояния до того объекта добавляется к штрафу за расстояние для заклинателя.
Пример: Феликс дает Рудольфу Успокоить животное как Рефлекторное заклинание. Для наблюдения за охотой Рудольфа он использует Волшебный глаз. Охотник встречает разъяренного вепря, Феликс это видит через Волшебный Глаз. Рудольф не может активировать заклинание. К счастью он и не должен! Феликс активирует Успокоить животное, пока Рудольф пытается Приручить животное, успокаиваю вепря. Рудольф ушел в лес почти на две мили, так что у Феликса -3 за большое расстояние. Боров на расстоянии 3 ярда от Рудольфа, т.е. у Феликс еще -3 за расстояние до объекта Рефлекторного заклинания. Еще -1 за включенный Волшебный глаз. Таким образом, Феликс творит Успокоить животное с -7 и только теперь платит энергию за него. К счастью он знает заклинание на уровне 21, так что творит его с максимальным эффектом. Вепрь успокоен, и Рудольф идет дальше, а Феликс отдыхает. Рефлекторное Успокоить животное больше не существует. Если Рудольф встретит другое животное, он будет справляться сам, хотя Феликс все еще может видеть любое его действие Волшебным глазом.
Блокирующие и метаемые заклинания не могут быть Рефлекторными; другие заклинания – вполне.
Длительность: 1 час.
Время сотворения: 10 секунд.
Стоимость: Равна стоимости сотворения целевого заклинания, минимум 1. Столько же на поддержание. Учтите, уровень владения Рефлексом не влияет на стоимость.
Требования: Отсрочка и Отвод заклинания.</description-loc>
		<college>Meta/Linking</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>cost of subject spell</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M132</reference>
		<categories>
			<category>Linking</category>
			<category>Meta</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">delay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">ward</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Alertness</name>
		<name-loc>Бдительность</name-loc>
		<description-loc>Обычное
Улучшает все броски всех чувств.
Длительность: 10 минут.
Стоимость: 2 за каждое очко улучшения (максимальная стоимость 5). Половина на поддержание.
Требования: Любые два варианта Обострённого (чувства).
Предмет
Одежда или украшение. Энергостоимость создания: 300 за каждое очко улучшения.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/pt increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">keen</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dull @Sense@</name>
		<name-loc>Притупление (чувства)</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Заклинание обратное Обостренное (чувство), это заклинание ухудшает броски соответствующих чувств.
Длительность: 30 минут.
Стоимость: от 1 до 3. За каждое вложенное очко энергии результат броска ухудшается на 2.
Предмет
Одежда или украшение. Соответствующее чувство надевшего предмет ухудшается. Энергостоимость создания: 50 за каждое очко понижения чувства.
Посох или палочка. Используется лишь магами. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 pts decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Dull Hearing</name>
		<name-loc>Притупление слуха</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Заклинание обратное Обостренное (чувство), это заклинание ухудшает броски соответствующих чувств.
Длительность: 30 минут.
Стоимость: от 1 до 3. За каждое вложенное очко энергии результат броска ухудшается на 2.
Предмет
Одежда или украшение. Соответствующее чувство надевшего предмет ухудшается. Энергостоимость создания: 50 за каждое очко понижения чувства.
Посох или палочка. Используется лишь магами. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 pts decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Dull Taste and Smell</name>
		<name-loc>Притупление вкуса и нюха</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Заклинание обратное Обостренное (чувство), это заклинание ухудшает броски соответствующих чувств.
Длительность: 30 минут.
Стоимость: от 1 до 3. За каждое вложенное очко энергии результат броска ухудшается на 2.
Предмет
Одежда или украшение. Соответствующее чувство надевшего предмет ухудшается. Энергостоимость создания: 50 за каждое очко понижения чувства.
Посох или палочка. Используется лишь магами. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 pts decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Dull Touch</name>
		<name-loc>Притупление осязания</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Заклинание обратное Обостренное (чувство), это заклинание ухудшает броски соответствующих чувств.
Длительность: 30 минут.
Стоимость: от 1 до 3. За каждое вложенное очко энергии результат броска ухудшается на 2.
Предмет
Одежда или украшение. Соответствующее чувство надевшего предмет ухудшается. Энергостоимость создания: 50 за каждое очко понижения чувства.
Посох или палочка. Используется лишь магами. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 pts decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Dull Vision</name>
		<name-loc>Притупление зрения</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Заклинание обратное Обостренное (чувство), это заклинание ухудшает броски соответствующих чувств.
Длительность: 30 минут.
Стоимость: от 1 до 3. За каждое вложенное очко энергии результат броска ухудшается на 2.
Предмет
Одежда или украшение. Соответствующее чувство надевшего предмет ухудшается. Энергостоимость создания: 50 за каждое очко понижения чувства.
Посох или палочка. Используется лишь магами. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 pts decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Keen @Sense@</name>
		<name-loc>Обострённое (чувство)</name-loc>
		<description-loc>Обычное
На самом деле это несколько заклинаний, так же как Контроль (животных) и Увеличить (атрибут). Наиболее распространённые варианты – Обострённое Зрение, Обострённый Слух, Обострённый Вкус и Обоняние, но возможны и необычные варианты для необычных способов восприятия , таких как Обнаружение, Сканирование и Чувство вибрации.
Обострённое (чувство) даёт бонус +1 при соответствующих бросках чувств за каждое затраченное очко энергии.
Обострённый слух также является заклинанием школы Звука.
Длительность: 30 минут.
Стоимость: 1 очко за каждое бонусное очко (максимум 5). Половина (округляется вверх) на поддержание.
Предмет:
Одежда или украшение. Энергостоимость создания: 150 за каждое бонусное очко.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Keen Hearing</name>
		<name-loc>Обострённый слух</name-loc>
		<description-loc>Описано в Заклинаниях контроля разума, M133.</description-loc>
		<college>Mind Control/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
			<category>Sound</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Keen Taste and Smell</name>
		<name-loc>Обострённый вус и нюх</name-loc>
		<description-loc>Обычное
На самом деле это несколько заклинаний, так же как Контроль (животных) и Увеличить (атрибут). Наиболее распространённые варианты – Обострённое Зрение, Обострённый Слух, Обострённый Вкус и Обоняние, но возможны и необычные варианты для необычных способов восприятия , таких как Обнаружение, Сканирование и Чувство вибрации.
Обострённое (чувство) даёт бонус +1 при соответствующих бросках чувств за каждое затраченное очко энергии.
Обострённый слух также является заклинанием школы Звука.
Длительность: 30 минут.
Стоимость: 1 очко за каждое бонусное очко (максимум 5). Половина (округляется вверх) на поддержание.
Предмет:
Одежда или украшение. Энергостоимость создания: 150 за каждое бонусное очко.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Keen Touch</name>
		<name-loc>Обострённое осязание</name-loc>
		<description-loc>Обычное
На самом деле это несколько заклинаний, так же как Контроль (животных) и Увеличить (атрибут). Наиболее распространённые варианты – Обострённое Зрение, Обострённый Слух, Обострённый Вкус и Обоняние, но возможны и необычные варианты для необычных способов восприятия , таких как Обнаружение, Сканирование и Чувство вибрации.
Обострённое (чувство) даёт бонус +1 при соответствующих бросках чувств за каждое затраченное очко энергии.
Обострённый слух также является заклинанием школы Звука.
Длительность: 30 минут.
Стоимость: 1 очко за каждое бонусное очко (максимум 5). Половина (округляется вверх) на поддержание.
Предмет:
Одежда или украшение. Энергостоимость создания: 150 за каждое бонусное очко.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Keen Vision</name>
		<name-loc>Обострённое зрение</name-loc>
		<description-loc>Обычное
На самом деле это несколько заклинаний, так же как Контроль (животных) и Увеличить (атрибут). Наиболее распространённые варианты – Обострённое Зрение, Обострённый Слух, Обострённый Вкус и Обоняние, но возможны и необычные варианты для необычных способов восприятия , таких как Обнаружение, Сканирование и Чувство вибрации.
Обострённое (чувство) даёт бонус +1 при соответствующих бросках чувств за каждое затраченное очко энергии.
Обострённый слух также является заклинанием школы Звука.
Длительность: 30 минут.
Стоимость: 1 очко за каждое бонусное очко (максимум 5). Половина (округляется вверх) на поддержание.
Предмет:
Одежда или украшение. Энергостоимость создания: 150 за каждое бонусное очко.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 min</duration>
		<reference>M133</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Berserker</name>
		<name-loc>Берсерк</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Заставляет объект драться как берсерка (смотри недостаток Неистовство B124). Если враги в поле зрения или хотя бы в зоне слышимости, они атакуют первыми.
Длительность: 10 минут или пока бой не закончится и объект не выйдет из состояния неистовства как описано на B124.
Время сотворения: 4 секунды.
Стоимость: 3 на сотворение. 2 на поддержание.
Требования: Храбрость.
Предмет
Посох или палочка; используется только магами. Предмет должен содержать изображение медведя или медвежий зуб. Энергостоимость создания: 750
Плащ из медвежьей шкуры, который творит на носящего его заклинание без затрат энергии (возможен нормальный бросок на сопротивление). Он считается Тяжёлым Плащом с ПЗ2, СП(DR)2 и ЕЖ(HP) 20. Если плащ теряет все ЕЖ(HP), чары спадают. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>10 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">bravery</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bravery</name>
		<name-loc>Храбрость</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)-1
Делает объект(ы) бесстрашным(и). Любой, под воздействием этого заклинания, должен сделать в ситуации, где храбрость нежелательна, бросок ИН(IQ), чтобы поступить благоразумно.
Длительность: 1 час или пока не столкнётся с заклинанием Страх.
Базовая стоимость: 2. Не может быть поддержано.
Требования: Страх.
Предмет
Любой предмет. Всегда включён; предмет поддерживает на носящем заклинание Храбрость. Энергостоимость создания: 500.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fear</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Daze</name>
		<name-loc>Оцепенение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект действует и выглядит нормально, но не замечает ничего вокруг и не помнит ничего после. Оцепеневший стражник спокойно стоит на посту, пока вор просто проходит мимо! Любое повреждение или удачный бросок сопротивления выводит объект из оцепенения и возвращает его в полностью настороженное состояние.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 2 на поддержание.
Время сотворения: 2 секунды.
Требования: Глупость.
Предмет
Любой предмет. Всегда включён; предмет наводит эффект Оцепенения на носящего. Энергостоимость создания: 400.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимсоть создания: 1,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Dullness</name>
		<name-loc>Притупление чувств</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Ухудшает все броски чувств.
Длительность: 10 минут.
Стоимость: от 2 до 10 на сотворение. Половина на поддержание. Чувства ухудшаются на 1 за каждые 2 очка, вложенных в заклинание.
Требования: Любые два варианта Притупления (чувства).
Предмет:
Одежда или украшение. Чувства надевшего притупляются. Энергостоимость создания: 200 за каждое очко ухудшения.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/pt decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">dull</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fear</name>
		<name-loc>Страх</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Объект(ы) чувствуют страх. Заклинатель получает +3 к броску реакции в потенциально боевой ситуации и других ситуациях, где подействуют угрозы, но получает -3 к броску верности, в ситуациях, когда запугивание NPC нецелесообразно.
Длительность: 10 минут или пока не столкнулось с заклинанием Храбрость.
Базовая стоимость: 1. Не может быть поддержано.
Требования: Почуять Эмоции или преимущество Эмпатия.
Предмет:
Любой предмет. Всегда включён; при надевании предмет вызывает страх. Энергостоимость создания: 200.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 300.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">sense emotion</name>
			</spell_prereq>
			<advantage_prereq has="yes">
				<name compare="is">empathy</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Foolishness</name>
		<name-loc>Глупость</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
За каждое очко стоимости заклинания объект получает штраф -1 к ИН(IQ) и всем умениям (в том числе заклинаниям) основанным на ИН(IQ). Также пока объект под действием заклинания, Мастер может потребовать бросок ИН(IQ) для того, чтобы вспомнить какую-нибудь сложную вещь.
Длительность: 1 минута.
Стоимость: от 1 до 5 на сотворение. Половина (округляется вверх) на поддержание.
Требования: Ин 12 или выше
Предмет
Любой предмет. Всегда включён; предмет снижает ИН(IQ) носящего. Энергостоимсоть создания: 100 за каждое отнимаемое очко ИН(IQ).
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Panic</name>
		<name-loc>Паника</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Находящиеся в зоне действия заклинания бегут в безумном страхе от заклинателя, всё время действия заклинания. Объект, который бежать не может, повернётся к заклинателю и в случае атаки предпримет манёвр Тотальная Защита (all-out defense).
Длительность: 1 минута.
Базовая стоимость: 4 на сотворение. 2 на поддержание.
Требования: Страх.
Предмет
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fear</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rear Vision</name>
		<name-loc>Заднее зрение</name-loc>
		<description-loc>Обычное
Объект может видеть всё вокруг себя, как если бы имел преимущество Круговой Обзор (B34).
Длительность: 1 минута.
Стоимость: 3 на сотворение. 1 на поддержание.
Требования: Бдительность.
Предмет
Оружие, одежда или украшение. Энергостоимость создания: 1,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M134</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">alertness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
	<name>Terror</name>
	<name-loc>Ужас</name-loc>
	<points>1</points>
	<spell_class>Area</spell_class>
	<casting_cost>4</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>1 sec</casting_time>
	<duration>1 sec</duration>
	<college>Mind Control</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<spell_prereq has="yes">
			<name compare="is">fear</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Mind Control</category>
	</categories>
	<reference>M134</reference>
	<description-loc>Областное; Сопротивление по Воле(Will)
При провале сопротивления по Воле(Will) всякий находящийся в области должен пойти Проверку Страха со штрафом -3.
Базовая стоимость: 4.
Требования: Страх.
Предмет
Посох или палочка. Используется только магами; надо коснуться объекта. Энегостоимость создания: 600.</description-loc>
</spell>
	<spell version="2">
		<name>Disorient</name>
		<name-loc>Дезориентация</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Все в области дезориентированы. Они не заметят это сразу, но не смогут вспомнить маршрут, которым шли и не смогут вспомнить своё положение относительно какого-либо ориентира. Имеющие преимущество Чувство Направления при сопротивлении получают бонус +5.
Длительность: Объект может восстановить чувство направления обычным образом (броском Навигации, идти обратно по следу, сравнение записей ит.д.)
Время сотворения: 10 секунд.
Базовая стоимость: 1. Не может поддерживаться.
Требования: Глупость.
Предмет
Посох или палочка. Используется только магами. Энергостоимость создания: 200.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Varies</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Encrypt</name>
		<name-loc>Зашифровать</name-loc>
		<description-loc>Обычное
При сотворении на письменный или какой-либо другой визуальный носитель информации, информация становится читаема только для заклинателя. Для не-заклинателя информация на носителе будет видна, но будет выглядеть как слишком сложной или на незнакомом языке. Другие носители информации, основанный на чувствах (например, тайные азбуки, основанные на вкусе или запахе, используемые нечеловеческими цивилизациями, а также существующая азбука Брайля) могут быть зашифрованы с разрешения Мастера.
Длительность: 1 неделя.
Стоимость: 1 за менее чем 1,000 слов текста; 2 за текст от 1,000 до 10,000 слов; 3 за текст от 10,000 до 100,000 слов; +1 за каждые дополнительные 100,000 слов. Таким образом, шифрование шести базовых книг GURPS Четвёртого Издания по 175,000 слов в каждой будет стоить 12 очков.
Требования:  Оцепенение.
Предмет
Любая запись может быть зашифрована навсегда, но стоить это будет в 100 раз больше.
Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 week</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fascinate</name>
		<name-loc>Заворожить</name-loc>
		<description-loc>Обычное или Блокирующее; Сопротивление по Воле(Will)
Удерживает объект (разумное существо) безэмоциональным и нечувствительным к течению времени, пока заклинатель поддерживает глазной контакт и концентрацию. Темнота нарушает глазной контакт! Если объект подходит на расстояние ближнего боя, заклинание может твориться как Блокирующее. Если заклинатель знает заклинание на уровне 15 и больше. Он может медленно (Движение 1) двигаться, поддерживая глазной контакт; каждый ярд, на который заклинатель отходит от объекта. Позволяет один бросок сопротивления для снятия заклинания. Заклинание также снимается любой атакой объекта (физическая или магическая).
Длительность: Не ограничена.
Стоимость: 4.
Требования: Оцепенение.
Предмет
Зеркало, рисунок или статуэтка. Всегда включён. Энергостоимость создания: 1,000. Такие предметы в некоторых местах используются в качестве охранной системы (заклинание развеивается, когда жертва падает без сознания от голода, обезвоживания или истощения).</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular/Blocking</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Indefinite</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Forgetfulness</name>
		<name-loc>Забывчивость</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will) или умению
Заставляет объект на время забыть какой-нибудь факт, умение или заклинание. Пока действует Забывчивость, невозможно применить этот навык или заклинание. Если (например) забытое заклинание является требованием (prerequisite) для другого заклинания, это другое заклинание может быть применено со штрафом -2.
Длительность: 1час.
Стоимость: 3 на сотворение. 3 на поддержание.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 1 и Глупость.
Предмет
Любой предмет. Всегда включён; предмет заставляет носящего забыть одну вещь, определённую при создании предмета. Через час после снятия предмета носящий вспомнит забытую вещь. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mental Stun</name>
		<name-loc>Ментальное оглушение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект ментально оглушён, пока не совершит успешный бросок ИН(IQ).
Стоимость: 2.
Требования: Оцепенение или Оглушение.
Предмет
Любой предмет. Всегда включён; надевший ментально оглушён, пока предмет не снят. Энергостоимость создания: 500.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 1,100.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Until recovery roll made</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">stun</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
	<name>Sleep</name>
	<name-loc>Сон</name-loc>
	<points>1</points>
	<spell_class>Regular</spell_class>
	<casting_cost>4</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>3 sec</casting_time>
	<duration>Until awakened</duration>
	<college>Mind Control</college>
	<power_source>Arcane</power_source>
	<prereq_list all="yes">
		<spell_prereq has="yes">
			<name compare="is">daze</name>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Mind Control</category>
	</categories>
	<reference>M135</reference>
	<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект засыпает. Если он стоит, он падает, но это его не будит. Он может быть разбужен взрывом, громким звуком и т.д. но после пробуждения он будет ментально оглушён (смотри Эффекты Оглушения B420). Заклинание Пробудить (M90) разбудит его немедленно. Если объект не будить, он проспит восемь часов и проснётся.
Стоимость: 4.
Время сотворения: 3 секунды.
Требования: Оцепенение.
Предмет
Любой предмет. Всегда включён; усыпляет надевшего до тех пор, пока предмет не снимут. При создании предмета зачарователь может указать будет ли усыпление мгновенным или постепенным. Энергостоимость создания: 600.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимотсь создания: 1.200.</description-loc>
</spell>
	<spell version="2">
		<name>Wisdom</name>
		<name-loc>Мудрость</name-loc>
		<description-loc>Обычное
Временно повышает ИН(IQ) объекта. Вместе с ИН(IQ) увеличиваются умения, но заклинания остаются на прежнем уровне. ИН(IQ) объекта не может стать выше ИН(IQ) заклинателя.
Длительность: 1 минута.
Стоимость: 4 за каждое очко ИН(IQ) (максимально 5). Столько же на поддержание.
Требования: как минимум шесть других заклинаний школы контроля разума.
Предмет
Любой предмет. Всегда включён; пока предмет надет, ИН(IQ) носящего увеличен! Это очень редкие и ценные вещи. Энергостоимость создания: 2,000 за каждое очко ИН(IQ) (максимум 5).
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 2,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4/pt of IQ</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M135</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Command</name>
		<name-loc>Команда</name-loc>
		<description-loc>Блокирующее; Сопротивление по Воле(Will)
Даёт объекту какую-то срочную команду – слово и жест, или не больше двух слов – которой объект должен немедленно повиноваться. Если объект не может выполнить команду сразу же, или на свой следующий ход, заклинание не имеет эффекта.
Примеры:
«Брось!» - объект бросает то. что держит в руках.
«Смотри!» - объект смотрит в направлении, указанном заклинателем.
«Жди!» - объект в следующий ход выбирает манёвр Ожидание.
Стоимость: 2.
Требования: Магичность(Magery) 2 и Забывчивость.
Предмет
Палочка, посох или украшения. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Drunkenness</name>
		<name-loc>Опьянение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will).
Временно опьяняет жертву: она шумна, весела и у неё плохо с координацией. И ИН(IQ), и ЛВ(DX) снижены на то же количество очков, которое вложили в заклинание. Если жертва – PC, ему должны сообщить, что он чувствует себя пьяным и предложить отыграть это! Заклинание прекращается мгновенно (похмелья нет).
Длительность: 1 минута.
Стоимость: 1 очко за снижение на единицу ИН(IQ) и ЛВ(DX) (максимум 5). Половина на поддержание.
Время сотворения: 2 секунды.
Требования: Глупость и Неуклюжесть.
Предмет
Любой предмет. Всегда включён; надевший подвергается эффекту заклинания Опьянение. Энергостоимость создания: 200 за единицу снижения ИН(IQ) и ЛВ(DX).
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 800.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt of IQ &amp; DX loss</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Loyalty</name>
		<name-loc>Верность</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Делает объект верным заклинателю. Он выполняет любые прямые приказы заклинателя; в отсутствии прямых приказов он действует в интересах заклинателя, как он это понимает.  Заклинание сразу же развеивается, если заклинатель атаковал объект. Если заклинатель приказывает сделать что-нибудь слишком опасное или противоречащее нормам поведения объекта в обычной ситуации, то (по решению Мастера) объект может сделать бросок ИН(IQ) для того, чтоб развеять заклинание.
Длительность: 1 час;
Стоимость: 2 на сотворение. 2 на поддержание. Двойная цена, если объект не знает заклинателя. Тройная, если объект – враг заклинателя.
Время сотворения: 2 секунды.
Требования: Храбрость и два других заклинания из школы Контроля Разума.
Предмет
Любой предмет. Всегда включён; надевший становится верным создателю предмета (после смерти создателя предмет утрачивает силу). Энергостоимость создания: 500. Для того, чтобы надевший стал верен не создателю предмета, а третьему лицу, удвойте цену.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 2,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">bravery</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Madness</name>
		<name-loc>Безумие</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)-2
Объект на время теряет рассудок; это должно отыгрываться. Заклинатель определяет «глубину» безумия, а Мастер определяет подходящую природу безумия (для этой цели хорошо подходит бросок кости). При критическом успехе, заклинатель сразу называет природу безумия.
Если не указано обратное, каждый вид безумия совпадает по проявлениям с недостатком с таким же названием. Некоторые типы безумии совпадают с недостатками, позволяющими броски самоконтроля. При магическом безумии объект всегда проваливает броски самоконтроля.
Лёгкое: Заблуждения [-5]; Галлюцинации [-5]; Призрачные голоса [-5]; Фобия [-5].
Умеренное: Животное поведение [-10]; Заторможенный [-10]; Заблуждение [-10]; Галлюцинации [-10]; Призрачные голоса [-10]; Паранойя [-10].
Тяжелое: Неистовство; Животное поведение [-15]; Хроническая депрессия; Заблуждение [-15]; Галлюцинация (как состояние Галлюцинация, описанное на B429); Призрачные голоса [-15].
Крайнее: Кататонический синдром (как состояние Оцепенение на B428, но объект не может из него выйти пока не закончится заклинание); Галлюцинации [-20].
Длительность: 1 минута.
Стоимость: 2 на Лёгкое безумие, 3 на Умеренно, 4 на тяжелое, 6 на Крайнее. Половина на поддержание.
Время сотворения: 2 секунды.
Требования: Забывчивость или Опьянение.
Предмет
Любой предмет. Всегда включен; предмет наводит на надевшего эффект Безумия. При создании предмета можно указать наступит ли эффект сразу или постепенно, и (при желании) определить тип безумия. Энергостоимость создания: 500.
 Посох или палочка. Используется только магами. Энергостоимость создания: 1,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/3/4/6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">drunkenness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Strengthen Will</name>
		<name-loc>Сильная воля</name-loc>
		<description-loc>Обычное
Временно повышает Волю(Will) объекта.
Длительность: 1 минута.
Стоимость: 1 за каждое дополнительное очко Воли(Will) (максимум 5). Половина на поддержание.
Требования: Магичность(Magery) 1 и как минимум шесть заклинаний школы Контроля разума.
Предмет
Любой предмет. Всегда включён; Воля(Will) надевшего повышается. Такие предметы редки. Энергостоимость создания: 1,000 за одно очко Воли(Will) (максимум 5).
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 1,500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/pt of Will increase</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Weaken Will</name>
		<name-loc>Слабая Воля(Will)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will).
Временно снижает Волю(Will) объекта.
Длительность: 1 минута.
Стоимость: 2 за каждое отнимаемое очко Воли(Will) (максимальное снижение на 5). Половина на поддержание.
Требования: Магичность(Magery) 1 и Глупость
Предмет
Любой предмет. Всегда включён; Воля(Will) надевшего снижается. Энергостоимость создания: 100 за каждое отнимаемое очко Воли(Will).
Посох или палочка. Используется только магами; надо коснуться предмета. Энергостоимость создания: 700.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/pt of Will decrease</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M136</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Compel Lie</name>
		<name-loc>Лжец</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект не может говорить правду: он не может сделать ни одного заявления, которое он бы считал правдивым и чувствует потребность лгать, хотя (если он понимает, что он под воздействием заклинания) он может хранить молчание.
Лжец и Сыворотка правды сопротивляются друг другу. Для того, чтобы определить какое заклинание победило, может потребоваться заклинание Аура!
Это также заклинание школы Общения и понимания.
Длительность: 5 минут.
Стоимость: 4 на сотворение. 2 на поддержание.
Требование: Контроль эмоций.
Предмет
Тяжёлое ожерелье или ошейник [torc]; надевший не может сказать правду. Энергостоимость создания: 600.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Emotion Control</name>
		<name-loc>Контроль эмоций</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Внушает объекту(-ам) одну эмоцию по выбору заклинателя. Пока Мастер не посчитает нужным, это не влечёт никакого изменения характеристик, но должно быть отыграно! Некоторые простые эмоции: любовь, ненависть, злость, жадность, похоть, ревность, голод, страх, печаль, радость, умиротворение, беспокойство, депрессия, патриотизм, скука.
Длительность: 1 час.
Базовая стоимость: 2. Не может быть поддержано; надо творить заклинание заново.
Требования: Верность или Ментальное оглушение.
Предмет
Любой предмет. Всегда включён; надевший чувствует эмоцию, заключённую в предмете при создании. Энергостоимость создания: 300.
Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 1,000 за предмет, внушающий одну эмоцию, 2,200 за предмет, внушающий любую эмоцию на выбор.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">mental stun</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">loyalty</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lure</name>
		<name-loc>Искушение</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Каждый, ступивший в заколдованную область, чувствует потребность подойти к центру заколдованной области. Мастер должен тайно делать броски на сопротивление, а потом сообщать неудачливым жертвам, что они «заинтересовались сундуком» или другой коварный намёк. Когда жертва дойдёт до центра области, она невосприимчива к заклинанию, пока не покинет заколдованную область (если он вернётся, Он снова будет «атакован» заклинанием).
Искушение и Избегание - противоположенные заклинания, и поэтому сопротивляются друг другу.
Длительность: 1 час.
Базовая стоимость: 1 на сотворение. Столько же на поддержание.
Время сотворения: 10 секунд.
Требования: Контроль Эмоций.
Предмет
Заклинание может быть наложено на область навсегда, за в 100 раз большую стоимость.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mass Daze</name>
		<name-loc>Массовое оцепенение</name-loc>
		<description-loc>Областное; Сопротивление по ЗД(HT)
Оцепенение, которое можно сотворить на область.
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение. 1 на поддержание. Минимальный радиус 2 ярда.
Время сотворения: 1 секунда, за каждое потраченное очко энергии.
Требования: Оцепенение и ИН(IQ) 13 или выше.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>1 min</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mass Sleep</name>
		<name-loc>Массовый сон</name-loc>
		<description-loc>Областное; Сопротивление по ЗД(HT)
То же, что сон, но может быть наложено на область.
Базовая стоимость: 3 . Минимальный радиус 2 ярда.
Время сотворения: 1 секунда за каждое затраченное очко энергии.
Требования: Сон и ИН(IQ) 13 или выше.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>Until awakened</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Mindlessness</name>
		<name-loc>Умалишение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Понижает ИН(IQ) объекта до 1, превращая его в бубнящего идиота. Объект не может поддерживать или творить заклинания, пользоваться умениями, говорить и совершать другие действия, определённые Мастером. Объект может ходить, смеяться, плакать, пускать слюни, есть руками, реагировать на тепло, холод ит.д. У него очень короткий период внимания и он замечает только цвета, яркие предметы, движение и другие вещи, привлекающие внимание младенцев. Если объект – PC, игрок должен это отыграть.
Длительность: 1 минута.
Стоимость: 8 на сотворение. 4 на поддержание.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2и Забывчивость.
Предмет
Любой предмет. Предмет наводит эффект Умалишения на надевшего. Энергостоимость создания: 800.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M137</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Oath</name>
		<name-loc>Клятва</name-loc>
		<description-loc>Обычное; Особое сопротивление
Подобно Великому Зароку, но действует лишь на добровольно принявших клятву. В то время как маг произносит заклинание, объект должен произносить клятву.
Объект может осознанно попытаться нарушить клятву (бросок против Воли(Will)) не чаще одного раза в день. Заклинание сопротивляется попыткам; если объект переборет сопротивление, он может нарушить клятву в тот день. Критический успех объекта или критический провал заклинания при состязании развеивает заклинание. Единственный другой способ снять заклинание – Снять Проклятье.
Несознательные попытки нарушения заклинания, например когда объекта обманывают, не сопротивляются заклинанием.
Длительность: Постоянная.
Стоимость: 4
Время сотворения: 1 минута.
Требования: Магичность(Magery) 1 и Контроль Эмоций.
Предмет
Украшение. Всегда включено; действует лишь на носящего. Энергостоимость создания: 550.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M138</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Peaceful Sleep</name>
		<name-loc>Мирный сон</name-loc>
		<description-loc>Обычное; Особое сопротивление [Special Resistance]
Ночью ничто не тревожит сон объекта. Это заклинание лечит бессонницу, позволяет спать в шумном, неспокойном окружении и защищает  от заклинания Кошмар. Длительность такого сна при подсчётах восстановленных ЕУ(FP) и ЕЖ(HP) считается в 2 раза больше фактической. Заклинатель может разбудить объект одним словом. Иными способами объект не может быть разбужен, кроме случаев. Если объекту нанесено повреждение или применено заклинание Пробудить.
Это заклинание действует лишь на несопротивляющийся объект, иначе сопротивление успешно автоматически.
Длительность: 8 часов.
Стоимость: 4.
Время сотворения: 30 секунд.
Требования: Сон и Тишина.
Предмет
Посох или палочка. дающие возможность творить это заклинание. Энергостоимость создания: 900.
Любой предмет. Если носящий хочет спать, предмет усыпляет его, как описано в заклинании; носящий просыпается через 8 часов, или когда предмет снимут. Энергостоимость создания: 800.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>8 hrs</duration>
		<reference>M138</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">silence</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Forgetfulness</name>
		<name-loc>Постоянная забывчивость</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will) или умению
Как Забывчивость, но постоянное. Объект также забывает прошлое и то, что он зачарован. [The subject also forgets he ever knew that thing or that he was enchanted.] Другой маг может таким же заклинанием восстановить память, если выиграет быстрое состязание между умениями заклинания его и мага первым наложившего заклинание.
Длительность: Постоянная
Стоимость: 15
Время сотворения: 1 час.
Требования: Магичность(Magery) 2, Забывчивость и ИН(IQ) 13 или выше.
Предмет
Любой предмет. Эффект тот же, что и у предмета с заклинанием Забывчивость, но если предмет надет больше одного дня, информация забывается навсегда, пока заклинание на снято Снять Проклятие или противодействующим заклинанием Постоянная Забывчивость. Энергостоимсоть создания: 1,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>15</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M138</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sickness</name>
		<name-loc>Болезнь</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект начинает плохо себя чувствовать, его начинает тошнить (головокружение, рвота ит.д.). Он может бежать при необходимости (Движение в два раза меньше), но не может делать ничего кроме поддержания заклинаний и односложных ответов. Когда заклинание заканчивается, слабость сразу же пропадает.
Это также заклинание школы Контроля тела.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 3 на поддержание.
Время сотворения: 4 секунды.
Требования: Опьянение или Чума.
Предмет
(а) Любой. Всегда включён; наводит эффект Болезни на носящего. Энергостоимость создания: 300.           (б) Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 1,500.</description-loc>
		<college>Body Control/Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M138</reference>
		<categories>
			<category>Body Control</category>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">pestilence</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">drunkenness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Vigil</name>
		<name-loc>Бдение</name-loc>
		<description-loc>Можно не спать ночью, при этом не чувствовать недомогания в связи с недосыпанием. Если объект таким образом пытается не спать несколько ночей подряд, после первого успешного сотворения заклинания каждая следующая попытка получает штраф -3 (штрафы складываются).
Длительность: 1 ночь.
Стоимость: 8. Не может быть поддержано, но может быть сотворено заново.
Требования: Магичность(Magery) 2, Сон и Передать энергию. При согласии Мастера может быть достаточен «святой» статус.
Предмет
Украшение или головной убор.  Используется только магами или (при согласии Мастера) «святыми» созданиями. Энергостоимсоть создания: 1,000. Ходят слухи о существовании «всегда включённой» версии.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 night</duration>
		<reference>M138</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lend energy</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Will Lock</name>
		<name-loc>Преграда воли</name-loc>
		<description-loc>Областное; Сопротивление по (СЛ(ST)+Воля(Will))/2
Создаёт круглую область, запирающую внутри всех, находящихся там, в момент создания. Барьер исключительно психологический, воздействующий на волю запертых существ. Поэтому, объектам должно быть известно, что они заперты, иначе Преграда воли не сработает.
Каждый пойманный может раз в день попытаться вырваться, проходя Обычное состязание между его (СЛ(ST)+Воля(Will))/2 против Сопротивления заклинания (M10). Каждое сбежавшее существо понижает Сопротивление заклинания на 1. Если Сопротивление достигнет 0 или при Состязании произойдёт критический провал, Преграда воли развеивается. Критический успех бегущего не разрушит преграду воли. Также Преграда разрушится, если кто-то снаружи разорвёт круг [scuffs the circles away].
Запертые свободно могут метать снаряды и заклинания через барьер. Интересным способом побега может стать потеря сознания и переброска тела через преграду!
Длительность: 1 день
Базовая стоимость: 3 на сотворение. Не может быть поддержано; надо творить снова.
Время сотворения: Столько, сколько надо заклинателю, чтобы трижды обойти запираемую область против (часовой стрелки).
Требования: Контроль эмоций.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>1 day</duration>
		<reference>M138</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Charm</name>
		<name-loc>Очаровать</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект становится верным рабом заклинателя до окончания действия заклинания; он выполнит любые приказы независимо от их опасности. С рабом нет ментальной связи и заклинатель должен отдавать приказы устно или письменно. Однако защищать заклинателя объект будет без приказа. Во всех остальных отношениях объект будет умственно нормален и бдителен. Он не сможет (и не захочет говорить и даже думать об этом) объяснить свою преданность заклинателю.
Длительность: 1 минута.
Стоимость: 6 на сотворение. 3 на поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1, Верность и ещё семь заклинаний Контроля Разума.
Предмет
(а) Любой предмет. Всегда включён; Надевший становится верным создателю предмета (после смерти создателя предмет теряет магическую силу).  Энергостоимость создания: 1,000. Удвойте стоимость, если хотите, чтобы надевший стал верным кому-то. а не заклинателю.
(b) Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимсоть создания: 3,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M139</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">7</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">loyalty</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Ecstasy</name>
		<name-loc>Экстаз</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект испытывает наплыв полностью расслабляющего блаженства; под действием заклинания объект не может выполнять никаких действий, даже чтобы избежать повреждений! Высокий/низкий болевой порог никак не влияет. Повторные заклинания могут повредить объекту. Если персонаж становится объектом заклинания Экстаз более трёх раз за 10 дней, после третьего воздействия он должен сделать бросок Воля(Will)+2, такой же бросок он должен совершать  после каждого заклинания Экстаз, если с момента применения предыдущего заклинания не прошло 5 дней. Если хоть один бросок провален, персонаж получает недостаток Пристрастие к заклинанию  (B122) и пристаёт к заклинателю (или любому другому, о ком известно, что он знает заклинание) клянча об ещё одном заклинании! Эффект отсутствия заклинания Экстаз подпадает под правила обычной физической зависимости (см. Синдром Отмены B440).
Длительность: 10 секунд.
Стоимость: 6 на сотворение. Не может быть поддержано.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 2и Контроль Эмоций.
Предмет
(а) Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 800.
(б) Головной убор. Всегда включён. Носящий не может добровольно снять предмет, Пристрастие наступает через 15 минут. Энергостоимость создания: 1,300.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M139</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Enthrall</name>
		<name-loc>Увлечь</name-loc>
		<description-loc>Особое; Сопротивление по Воле(Will)
Заклинатель произносит увлекательную речь. Все, находящиеся в пределах слышимости, знающие язык и обращающие внимание попадают под действие заклинания, если не сделают бросок Воли(Will). Проходят часы,  но попавшим под действие заклинания они кажутся минутами. Любой сопротивляющийся будет считать заклинателя и его жертв парализованными, хотя при долгом наблюдении поймёт, что они движутся, но очень медленно. Объект освободится от заклятья, если его атаковать или встряхнуть (в последнем случае он делает бросок на сопротивление каждую секунду, пока его беспокоят).
Уровень этого заклинания никогда не может превышать умение заклинателя Публичное выступление, или умение Выступление, если вместо речи заклинатель показывал пантомиму или представление.
Длительность: 1 час (реального времени).
Стоимость: 3 на сотворение. 3 на поддержание.
Требования: Забывчивость, Оцепенение и Замедлить.
Предмет
Посох, маска комика или музыкальный инструмент. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M139</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">slow</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>False Memory</name>
		<name-loc>Ложная память</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Внедряет в память объекта одно простое ложное воспоминание. Это заклинание считается незаконным во многих областях, так как часто используется для уклонения от уплаты налогов ит.д.
Если внедряемое воспоминание противоречит реальным, объект всё равно его воспримет и поверит, но будет немного смущён. В случае явного противоречия – «Ты помнишь, что убил герцога» (хотя объект видел, что герцога убил заклинатель!) – объект должен получить бонус при броске сопротивления; например, если в описанном случае объект был верен герцогу, он получит бонус +5, если же объект желал смерти герцога, бонус может быть всего +1.
Длительность: Различная (см. ниже). Когда заклинание развеется, объект делает повторный бросок на сопротивление со штрафом -1 за каждый день нахождения под действием заклинания. Если бросок провален, объект поверит в ложное воспоминание на неопределённое время, он может вспомнить правду в непредсказуемый момент, возможно в результате сильного потрясения.
Стоимость: 3 за длительность заклинания – час; или 8 за наложение заклинания на весь день. Стоимость поддержания – 3 за каждый час если заклинание было наложено на час, 4 за день, если заклинание было наложено на день.
Время сотворения: 5 секунд.
Требования: Забывчивость и шесть других заклинаний школы Контроля Разума.
Предмет
Любой. Всегда включён; предмет внедряет в память носящего одно ложное воспоминание, заложенное при создании предмета. Через час после снятия предмета носящий забудет воспоминание. Энергостоимсоть создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Varies</duration>
		<reference>M139</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Madness</name>
		<name-loc>Постоянное безумие</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)-2
Как Безумие, но постоянное.
Длительность: Навсегда.
Стоимость: 20.
Время сотворения: 10 минут.
Требования: Магичность(Magery) 2, Безумие, и ИН(IQ) 13 или больше.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Permanent</duration>
		<reference>M139</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">madness</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Avoid</name>
		<name-loc>Избегание</name-loc>
		<description-loc>Областное
Делает область, на которую наложено заклинание, непривлекательной для всех существ, кроме заклинателя. На области будет эффект отвода глаз, а приближающиеся персонажи будут испытывать сильное беспокойство и желание оказаться где-нибудь подальше. Заклинание противодействует попыткам взглянуть на область или приблизиться к ней (бросайте умение заклинателя против Воли(Will) искателя). Жертвы не будут знать об отталкивании, если оно сможет действовать не напрямую (например, вы только что почувствовали, что сидите спереди, а не в середине…). Это коварное заклинание и Мастер должен делать броски тайно. Если заклинание работает, не надо говорить жертве «Ты не можешь заглянуть в этот чулан», правильнее сказать «Ты ничего не видишь». Заклинание заставило их думать, что они уже проверили чулан, или кто-то другой из партии его проверил, или ещё что-то подобное. Если заклинатель творит Избегание и Скрыть, Мастер не должен проверять успешность заклинания Скрыть, если только ищущий не преодолел заклинание Избегание и не смотрит в сторону заклинателя.
Длительность: 1 час.
Стоимость: 3 на сотворение. 3 на поддержание.
Время сотворения: 1 минута.
Требования: Скрыть, Страх и Забывчивость.
Предмет
Можно сделать область «избегаемой» навсегда за в 100 раз большую стоимость.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M140</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hide</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">fear</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hallucination</name>
		<name-loc>Галлюцинации</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will).
Восприятие объекта портится. Он полностью уверен, что какой-либо несуществующий предмет или существо существует (или наоборот); объект может видеть его, слышать, чувствовать и так далее. Это похоже на иллюзию, но существует исключительно в мозгу объекта.
Галлюцинация должна касаться присутствия или отсутствия единичной «вещи»: один человек, которого персонаж знает или знал, одна толпа гуляк, одна пара кандалов на запястьях объекта, один прайд львов ... Если галлюцинация относится к чему-то, что можно описать на русском языке единственным числом (не прибегая к словесной акробатике), заклинание должно сработать. Как обычно, решение Мастера окончательное.
Галлюцинация не требует концентрации: объект бессознательно сам создаёт реалистичный образ. Концентрируясь, заклинатель может «направлять» галлюцинацию – сказать, что говорит несуществующий человек, направить толпу гуляк, начать петь какую-либо песню ит.д.
При сопротивлении невозможной или явно ложной галлюцинации (например давно умерший дядюшка) объект поучает бонус +5.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 2 на поддержание.
Время сотворения: 2 секунды.
Требования: Безумие и Внушение.
Предмет
(а) Любой предмет. Всегда включён; предмет вызывает эффект заклинания Галлюцинация. Заклинатель должен определить природу галлюцинации при создании предмета. Энергостоимость создания: 1,000.
(б) Посох или палочка. Используется только магами. Энергостоимость создания: 1,200.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M140</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">madness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">suggestion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Lesser Geas</name>
		<name-loc>Малый зарок</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will).
Даёт объекту одну команду, которой он должен повиноваться. Команда должна заключаться в том, чтобы сделать одно определённое действие. Это действие должно быть выполнимо, по мнению Мастера. «Уничтожь все деревья на континенте» - некорректный зарок (по крайней мере, в сеттинге с низким ТУ). Пока зарок не выполнен или отменён (это можно сделать только заклинанием Снять Проклятье), объект в первую очередь выполнять зарок.
Длительность: пока зарок не выполнен.
Стоимость: 12.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 2 и как минимум 10 заклинаний школы Контроля разума, в том числе Команда.
Предмет
Любой предмет. Всегда включён; творит заклинание Малый зарок (зарок определяется при создании предмета) на носящего. Носящий не может добровольно снять предмет; если предмет всё же снят, зарок будет действовать ещё месяц, если только не будет развеян заклинанием Снять проклятье. Энергостоимость создания: 2,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Until fulfilled</duration>
		<reference>M140</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">command</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">9</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Nightmare</name>
		<name-loc>Кошмар</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
При сотворении на спящий объект, заклинание вызывает кошмар по выбору заклинателя. Знание страхов и фобий объекта даёт бонус +2 к эффективному умению. Объект кидает ИН(IQ)-4 для того, чтоб понять, что кошмары наведены враждебным магом. Если заклинание удалось, объект не отдыхает ночью и теряет 2 ЕУ(FP). Рассеять Магию остановят кошмары и предотвратят потерю ЕУ(FP). Это заклинание противостоит заклинанию Мирный сон. Если заклинание сотворить на следующую ночь, эффекты накапливаются. Если из-за заклинания ЕУ(FP) объекта падают до нуля, объект впадает в кому и теряет 1d ЕЖ(HP) каждый день пока не умрёт или не будет сотворено заклинание Рассеять магию.
Длительность: 1 час.
Стоимость: 6.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 2, Видение Смерти, Страх и Сон.
Предмет
(а) Посох или палочка, дающие возможность творить это заклинание. Энергостоимость создание: 800.
(б) Любой предмет. Если его носят больше восьми часов в день, он вызывает кошмар ночью, даже если предмет на ночь снимают! Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M140</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">death vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">fear</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sleep</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Suggestion</name>
		<name-loc>Внушение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Вводит внушение в мозг объекта. Это должна быть простая мысль; незнание языка не имеет значение, если только мысль можно выразить на языке объекта. Если внушаемая мысль противоречит безопасности объекта, он сопротивляется ей с бонусом +5; если внушаемая мысль противоречит вере, убеждениям или знаниям объекта, он сопротивляется ей с бонусом +3. Объект попробует выполнить идею или будет действовать так, как будто идея его собственная.
Длительность: 10 минут.
Стоимость: 4 на сотворение. 3 на поддержание.
Время сотворения: 10 секунд.
Требования: Контроль эмоций и Забывчивость.
Предмет
(а) Любой. Всегда включён; объект внушает носящему одну идею, заложенную при создании предмета. Внушение проходит через час после снятия объекта. Энергостоимость создания: 400.
(б) Посох, палочка или украшение. Используется только магами; надо коснуться объекта. Энергостоимость создания: 500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 min</duration>
		<reference>M140</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">forgetfulness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Enslave</name>
		<name-loc>Поработить</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Похоже на заклинание Очаровать, но действует постоянно. Объект будет выполнять приказы заклинателя до тех пор, пока заклинание не будет закончено или развеяно. При любой концентрации, заклинатель может создавать ментальную связь с объектом и видеть его глазами, слышать его ушами и отдавать приказы.
Стоимость: 30.
Требования: Очаровать и Телепатия.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M141</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">charm</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">telepathy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Glib Tongue</name>
		<name-loc>Гибкий язык</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Заклинатель может мистическим образом превращать то, что он сказал, в то, что хочет услышать объект. Всё, даже полная тарабарщина, сказанное заклинателем, будет находить сердечную поддержку. Однако, заклинатель понятия не имеет, что слышится объекту… В зависимости от того, насколько умно PC отыграл это, Мастер может дать бонус на броски реакции вплоть до +3.
Длительность: 5 минут.
Стоимость: 2 на сотворение. 1 на поддержание.
Требования: Внушение.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 650.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M141</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">suggestion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Geas</name>
		<name-loc>Великий зарок</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Даёт объекту одну длительную команду, например «Никогда не прикасайся к оружию» или «Убей всех орков». Великий Зарок не обязан быть выполнимым; он может захватить объект до конце жизни объекта или пока не будет снят. Зарок может снять только заклинание Снять Проклятье. Критический провал при сотворении Великого зарока будет стоить заклинателю одного очка ИН(IQ).
Длительность: Бессрочная.
Стоимость: 30.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3 и минимум 15 заклинаний школы Контроля разума, в том числе Малый зарок.
Предмет
Любой предмет. Всегда включён; предмет налагает на носящего Великий зарок (определённый при создании предмета). Носящий не может снять предмет добровольно; если предмет всё же снят, зарок продержится ещё год, если не будет снят раньше заклинанием Снять проклятье. Энергостоимость создания: 4,000.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M141</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">mind control</college>
				<quantity compare="at least">14</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lesser geas</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Hallucination</name>
		<name-loc>Великие галлюцинации</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Похоже на Галлюцинацию, но подменено может быть всё окружение объекта. Объект может видеть , что он стоит на краю обрыва, на оживлённой городской улице, в центре озера ит.д. Всё ограничено лишь жестокостью воображения заклинателя и мнением Мастера.
Для каждого значительного изменения видимой объектом обстановки, требуется концентрация заклинателя на изменяющейся детали как при заклинании Галлюцинации. Если заклинатель резко меняет восприятие объекта, Мастер может дать объекту дополнительный бросок на сопротивление.
Пример: объект «помещён» на вершину гигантского каменного столба, возвышающегося над озером расплавленной лавы. Концентрируясь, заклинатель может заставить столб опускаться, крошиться под ногами объекта или заклинатель может призвать летающих монстров. Однако, если заклинатель вдруг решит, что лава превратилась в зелёный луг, объект получит ещё один бросок на Сопротивление.
Это заклинание можно использовать и в добрых целях; если объекту предстоит прогуляться по узкому брёвнышку над тысячефутовой пропастью, возможно, ему будет легче, если ему будет казаться, что бревно перекинуто через неглубокий ручей…
Длительность: 1 минута.
Стоимость: 6 на сотворение. 3 на поддержание.
Время сотворения: 4 секунды.
Требования: Магичность(Magery) 2 и Галлюцинации.
Предмет
(а) Любой предмет. Всегда включён; действует лишь на носящего. Заклинатель должен опрелелить природу галлюцинаций при создании предмета. Энергостоимость создания: 2,500.
(б) Посох или палочка. Используется только магами. Энергостоимость создания: 900.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M141</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hallucination</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (mind control)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mass Suggestion</name>
		<name-loc>Массовое внушение</name-loc>
		<description-loc>Областное; Сопротивление по Воле(Will)
Похоже на Внушение, но вместо одного человека, внушает единую мысль всем, находящимся в поражённой области.
Длительность: 10 минут.
Базовая стоимость: 4 на сотворение, 2 на поддержание (минимальный радиус 2 ярда).
Время сотворения: 1 секунда за каждую единицу энергии.
Требования: Внушение.
Предмет
Музыкальный инструмент. Пользователь должен уметь на нём играть (используйте меньшее из двух значений умений игры и заклинания). Энергостоимость создания: 1,500.</description-loc>
		<college>Mind Control</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>10 min</duration>
		<reference>M141</reference>
		<categories>
			<category>Mind Control</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">suggestion</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Apportation</name>
		<name-loc>Перемещение</name-loc>
		<description-loc>Обычное; сопротивление по Воле(Will)
Позволяет двигать материальные объекты, не прикасаясь к ним. Это заклинание левитирует объект с Движением 1 — недостаточно быстро, чтобы нанести вред. Живые объекты могут сопротивляться Воле(Will)й.
Длительность: 1 минута.
Энергостоимость: зависит от веса объекта. Столько же поддержание.
Вес	Энергостоимость
менее 1 фунта	1
до 10 фунтов	2
до 50 фунтов	3
до 200 фунтов	4
каждые дополнительные 100 фунтов	+4
Требования: Магичность(Magery) 1.
Предмет
Посох или палочка. Используется только магами; предмет должен прикасаться или быть направленным на объект. Энергостоимость создания: 900.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M142</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Glue</name>
		<name-loc>Клей</name-loc>
		<description-loc>Областное
Делает поверхность необычайно клейкой, останавливая любого, наступившего на поверхность, как под воздействием заклинания Вросшие ноги (M36). Если жертва успешно сопротивляется, она может двигаться свободно пока не сдвинется больше чем на ярд от своей позиции, после чего она снова прилипает, если все еще находится в области Клея.
Длительность: 10 минут.
Базовая стоимость: 3 сотворение. Столько же поддержание.
Требования: Ускорение.
Предмет
(а) Палочка, посох или украшение. Энергостоимость создания: 900. (б) Может быть наложено на область навсегда за 100-кратную стоимость.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M142</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Grease</name>
		<name-loc>Смазка</name-loc>
		<description-loc>Областное
Делает поверхность необычайно скользкой. Любой, наступивший на поверхность, должен сделать бросок  ЛВ(DX)-2 за каждый пройденный в области заклинания ярд. При провале броска он падает. Еще один бросок ЛВ(DX)-2 требуется, чтобы встать (но не сесть или встать на колени). Весь бой вплотную, контактные атаки и активные защиты получают штраф -3; остальные физические умения, включая атаки стрелковым и метательным оружием, получают штраф -2 за плохую стойку. Это заклинание также можно наложить на вертикальную поверхность, что сделает лазание невозможным. Наклонные поверхности оставляются на усмотрение Мастера.
В отличие от заклинания Гололед, эффекты которого почти идентичны, Смазку нельзя увидеть обычными методами. Также сапоги с шипами бесполезны против Смазанной поверхности. Смазка и Клей сопротивляются друг другу.
Длительность: 10 минут.
Базовая стоимость: 3 сотворение. Столько же поддержание.
Требования: Ускорение.
Предмет
(а) Палочка, посох или украшение. Энергостоимость создания: 700. (б) Может быть наложено на область навсегда за 100-кратную стоимость.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M142</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Haste</name>
		<name-loc>Ускорение</name-loc>
		<description-loc>Обычное
Увеличивает Движении и Уклонение на не более, чем на 3.
Длительность: 1 минута.
Стоимость: 2 сотворение за единицу, добавленную к Движению и Уклонению объекта. Половина  поддержание.
Время сотворения: 2 секунды.
Предмет
Обувь или украшение. Действует только на носителя. Энергостоимость создания: 250 за каждые +1 к Движению.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/pt</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M142</reference>
		<categories>
			<category>Movement</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Deflect Missile</name>
		<name-loc>Отклонить снаряд</name-loc>
		<description-loc>Блокирующее
Отклоняет один снаряд, который вот-вот попадет в объект — включая все Метательные заклинания. Игротехнически считается парированием. Если объектом заклинания является не маг, применяются модификаторы дистанций как для Стандартного заклинания. Отраженные атаки не теряют поражающей силы и могут ранить кого-то рядом. 
Это также заклинание Защиты и Предупреждения.
Стоимость: 1.
Требования: Перемещение.</description-loc>
		<college>Movement/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hold Fast</name>
		<name-loc>Устоять</name-loc>
		<description-loc>Блокирующее
Это заклинание отменяет отбрасывание от любого источника.
Стоимость: 1 за каждый ярд отмены отбрасывания.
Требования: Перемещение.
Предмет
Обувь или украшение. На предмете должно быть изображение быка или дуба. Включен постоянно. Энергостоимость создания: 300.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1/yd</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Increase Burden</name>
		<name-loc>Увеличить ношу</name-loc>
		<description-loc>Обычное; особое сопротивление
Увеличивает вес объекта, носитель объекта (если таковой имеется) сопротивляется Воле(Will)й. Полезно, чтобы замедлить наступающего рыцаря или не дать ветру унести вещи.
Длительность: 10 минут.
Стоимость: 1 за 25 фунтов исходного веса (или долю) за удвоение, вдвое больше за утроение и еще вдвое больше за учетверение. Половина на поддержание.
Время сотворения: 3 секунды.
Требования: Перемещение.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 min</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Jump</name>
		<name-loc>Прыжок</name-loc>
		<description-loc>Обычное
Улучшает способность объекта к прыжкам, увеличивая его Базовое Движение только для прыжков.
Длительность: 1 минута.
Стоимость: от 1 до 3 сотворение. Не поддерживается. Увеличение Базового Движения равно удвоенной вложенной энергии.
Требования: Перемещение.
Предмет
Посох, украшение или обувь. На предмете должно быть изображение кузнечика, кролика или оленя. Энергостоимость создания: 250 за единицу премии к прыжку, которую дает предмет (максимум 6).</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Levitation</name>
		<name-loc>Левитация</name-loc>
		<description-loc>Обычное; сопротивление по СЛ(ST) или Воле(Will).
Объект должен быть живым существом. Объект плывет сквозь воздух, перемещаясь так, как желает заклинатель. Передвижение левитируемого объекта требует Концентрацию, если заклинатель не является объектом. Оставить объект подвешенным в воздухе можно без концентрации. Максимальное Движение объекта равно 3, горизонтально или вертикально. Заклинатель, который левитирует себя, использует ЛВ(DX)-умения как обычно; другие объекты используют их с -3.
Длительность: 1 минута.
Стоимость: 1 за 80 фунтов (минимум 2) сотворение. Половина (округлить вверх) поддержание.
Время сотворения: 2 секунды.
Требования: Перемещение.
Предмет
(а) Посох, жезл или украшение; действует только на носителя. Энергостоимость создания: 800.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 80 lbs</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lighten Burden</name>
		<name-loc>Облегчение ноши</name-loc>
		<description-loc>Обычное
Уменьшает вес любого снаряжения, которое несет объект.
Длительность: 10 минут.
Стоимость: 3 за уменьшение на 25%; 5 за уменьшение на 50%. Половина (округлить вверх) поддержание.
Время сотворения: 3 секунды.
Требования: Перемещение.
Предмет
Рюкзак, уменьшающий вес вещей, переносимых в нем. Энергостоимость создания: 300 за уменьшение на 25%; 600 за уменьшение на 50%.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 min</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Locksmith</name>
		<name-loc>Взлом</name-loc>
		<description-loc>Обычное
Позволяет манипулировать маленькими деталями — например, внутри замка. Дает объекту +5 к умению Взлом, позволяя ему двигать механизмы замка., не прикасаясь к ним, как если бы у него были обычные инструменты. Позволяет волшебнику без инструментов пробовать открывать замок на его обычном умении Взлом. Дает аналогичную премию к Механику и другим умениям, где была бы полезной «третья рука». 
Длительность: 1 минута. (Одна минута позволяет одну попытку для обычного замка.) Открытый замок остается открытым, пока его не закроют.
Стоимость: 2 сотворение, 2 поддержание.
Требования: Перемещение.
Предмет
Золотой ключ, или золотой амулет в форме ключа. Его собственная стоимость должна быть не меньше $300. Энергостоимость создания: 1.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Long March</name>
		<name-loc>Долгий поход</name-loc>
		<description-loc>Обычное; сопротивление по СЛ(ST)
Уменьшает вдвое скорость пешего перехода объекта на дальние дистанции (B351). Не влияет на Движение или Базовую Скорость объекта в бою. 
Длительность: 1 день.
Стоимость: 3 сотворение. Не поддерживается.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 1 и либо Неуклюжесть, либо Слабость.
Предмет
(а) Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 400. (б) Обувь.  На предмете должно быть изображение улитки. Включен постоянно; действует только на носителя. Энергостоимость создания: 300.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M143</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">debility</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">clumsiness</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dancing Object</name>
		<name-loc>Танцующий объект</name-loc>
		<description-loc>Обычное
Оживляет один предмет для повторяющейся работы. Он может совершать примерно те же задания, что и человек с СЛ(ST) 15: ведро может носить воду из ручья в бочку, метла может подметать здание снова и снова, арбалет может самостоятельно взводиться и т.п. Задачи объекта не могут изменяться или зависеть от каких-либо событий... он просто бездумно продолжает свою работу. Умное использование Связи позволяет Танцующему объекту эффективно отвечать на ситуации, но это требует тщательного продумывания.
Длительность: 1 час.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 10 секунд.
Требования: Магичность(Magery) 2 и Перемещение.
Предмет
Может быть наложено на любой предмет навсегда . Стоимость создания: 400 энергии и на $500 магических ингредиентов. Объект необходимо «проводить» по его программе 1 раз в день пока действует чара.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Distant Blow</name>
		<name-loc>Дальний удар</name-loc>
		<description-loc>Обычное
Атакует объект на расстоянии. Заклинатель выбирает одно рукопашное оружие, которое на протяжении заклинания получает бесконечную досягаемость, но только по отношению к объекту. Оружие должно быть наносящим удары — кастет подходит, а удавка — нет! Пока объект находится в поле зрения заклинателя, оружие заклинателя может атаковать его. Объект защищается нормально (уклон, блок, парирование), как если бы с ним сражался невидимый двойник заклинателя. 
Тело заклинателя (для ударов руками, укусов и пинков) считается одним оружием для этого заклинания. Если объект подбирается ближе, чем на реальную Досягаемость (reach) оружия, применяются обычные правила. Оружие не вытягивается и не выпрыгивает из руки заклинателя, сила удара передается магически. Примените стандартные модификаторы дистанционного боя (B548) к атакам заклинателя. 
Заметьте, что магические свойства оружия (например, Пылающее оружие) или заклинателя (Касательные заклинания) не могут быть использованы с этим заклинанием!
Длительность: 5 секунд.
Стоимость: 3. Столько же поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 2 и Перемещение.
Предмет
Посох или другое оружие. Энергостоимость создания: 1.000 за фунт веса оружия (минимум 1 фунт).</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>5 sec</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lockmaster</name>
		<name-loc>Повелитель замков</name-loc>
		<description-loc>Обычное; Сопротивляется по Волшебному замку
Открывает замки магически. Заклинание Волшебного замка получает бросок сопротивления Повелителю замков. Любые модификаторы за сложность замка, которые применялись бы к умению Взлом, влияют также и на это заклинание.
Длительность: Открытый замок остается открытым, пока его не закроют.
Стоимость: 3. Не поддерживается.
Время сотворения: 10 секунд.
Требования: Или Магичность(Magery) 2 и Перемещение, или Взлом.

Предмет
Платиновый ключ, или платиновый амулет в форме ключа. Его собственная стоимость должна быть не меньше $800. Энергостоимость создания: 2.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">locksmith</name>
			</spell_prereq>
			<prereq_list all="yes">
				<spell_prereq has="yes">
					<name compare="is">apportation</name>
				</spell_prereq>
				<prereq_list all="no">
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="contains">one college (movement)
						<level compare="at least">2</level>
					</notes></advantage_prereq>
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="is anything"></notes>
						<level compare="at least">2</level>
					</advantage_prereq>
				</prereq_list>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Poltergeist</name>
		<name-loc>Полтергейст</name-loc>
		<description-loc>Метательное; сопротивление по ЗД(HT)
Швыряет объект в цель, выбранную заклинателем. Эффект — как если бы человек с СЛ(ST) 15 кинул объект (см. Метание, B355). Когда он ударяется обо что-то, то наносит дробящие повреждения. Бросок ЛВ(DX)-4 или умение Метания необходим, чтобы попасть по цели, которая может уклоняться или блокировать как обычно. Заметьте, что только объект заклинания — не цель — может сопротивляться! 1/2Д 20, Мах 60, Точ 1. Рассчитывая расстояние до цели, берите расстояние или от заклинателя, или от предмета, который кидается, используя большее из них.
Стоимость: 1 за предмет до 10 фунтов (1d вреда); 2 до 25 фунтов (1d+1 вреда).
Предмет
Посох или жезл. Используется только магами; предметом указать на объект, потом на цель. Энергостоимость создания: 1.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1 or 2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>Special cr</damage>
			<accuracy>1</accuracy>
			<range>20/60</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M144</reference>
		<notes>throws object with ST 15, p. B355.  Cost: 1 pt for an item up to 10 lbs (1d dmg); 2 pts for something up to 25 lbs (1d+1 dmg).</notes>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Quick March</name>
		<name-loc>Быстрый Марш</name-loc>
		<description-loc>Обычное
Увеличивает вдвое скорость пешего перехода объекта на дальние дистанции. По окончании дневного перехода объект теряет 10 ЕУ(FP) и должен выспаться. Это заклинание не влияет на Движение или Базовую Скорость объекта в бою. 
Длительность: 1 дневной переход.
Стоимость: 4. Не поддерживается.
Время сотворения: 1 минута.
Требования: Магичность(Magery) 1 и Ускорение.
Предмет
Обувь или украшение. Действует только на носителя. Энергостоимость создания: 400.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Slow Fall</name>
		<name-loc>Замедлить Падение</name-loc>
		<description-loc>Обычное
Уменьшает скорость падения объекта до 1 ярда в секунду. При приземлении на обычную поверхность объект не получит вреда (шипы и т.п. наносят половину вреда). Это заклинание можно сотворить до начала падения объекта. Если объект уже падает, он упадет еще на 10 футов (предполагая стандартную гравитацию 1G) в ту секунду, которая обычно требуется для сотворения этого заклинания. 
Длительность: 1 минута.
Стоимость: 1 за 50 фунтов веса. Половина поддержание.
Требования: Перемещение.
Предмет
Одежда или украшение. Энергостоимость создания: 1.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 50 lbs</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wallwalker</name>
		<name-loc>Ходить по стенам</name-loc>
		<description-loc>Обычное
Позволяет ходить по стенам или потолкам, как если бы они были горизонтальными поверхностями.  Объект должен держать хотя бы одну руку или ногу в контакте с поверхностью; иначе заклинание нарушается. Бой имеет штраф -2 и для ходящего по стенам, и для его противника из-за непривычных углов.
Длительность: 1 минута.
Стоимость: 1 за 50 фунтов, минимум 2. Половина поддержание.
Требования: Перемещение.
Предмет
Украшение или обувь.  На предмете должно быть изображение паука, мухи или ящерицы. Действует только на носителя. Энергостоимость создания: 1.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 50 lbs</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M144</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Flight</name>
		<name-loc>Полет</name-loc>
		<description-loc>Обычное
Позволяет летать по воздуху под собственным контролем, без крыльев, с Движением 10. Скорость полета уменьшается за нагрузку нормальным образом. Летающий персонаж может передвигаться и сражаться как обычно, и имеет преимущество в бою, если находится над врагами (B402).
Длительность: 1 минута.
Стоимость: 5 сотворение. 3 поддержание.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 2 и Левитация.
Предмет
Посох, палочка или украшение. Используется только магами; действует только на носителя. Энергостоимость создания: 2.500.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">levitation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Light Tread</name>
		<name-loc>Легкий шаг</name-loc>
		<description-loc>Обычное
Позволяет ходить по любой поверхности (которая выдерживает его вес), не оставляя следов, что делает следопытство невозможным. Если на поверхности присутствует растительность, некоторые следы объекта остаются, делая следопытство возможным, со штрафом -8. Заклинание также позволяет объекту избежать срабатывания нажимных частей ловушек и .т.п.
Длительность: 10 минут.
Стоимость: 4 сотворение. 1 поддержание. Если заклинатель также знает Скрыть следы, то допольнительная единица энергии при сотворении и поддержке гарантирует, отсутствие следов даже на растительности.
Требования: Перемещение и Формировать землю.
Предмет
Обувь; на предмете должно быть изображение зайчихи. Энергостоимость создания: 400.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Manipulate</name>
		<name-loc>Манипулировать</name-loc>
		<description-loc>Обычное
Позволяет манипулировать более крупными предметами, чем заклинание Взлом. Может развязывать веревки, поворачивать дверные ручки, поворачивать рычаг ручной мельницы и т.п. Заклинателю не обязательно прикасаться к объекту. Любая работа, достаточно сложная для того, чтобы давать штраф к ЛВ(DX), дает тот же штраф к этому заклинанию.
Длительность: 1 минута. (Это позволяет развязать обычный узел.)
Стоимость: 4 сотворение и 3 поддержка за каждые 10 фунтов, которыми манипулирует заклинание.
Требования: Взлом.
Предмет
Палочка, посох или перчатка. Энергостоимость создания: 600.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">locksmith</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Slide</name>
		<name-loc>Скольжение</name-loc>
		<description-loc>Обычное; сопротивление по Воле(Will)
Позволяет скользить вниз по склону как на лыжах. Объект использует умение Лыжного спорта, по умолчанию, если необходимо, со штрафом -2 если у него нет палок, которыми можно направлять свое движение. Заклинание одинаково хорошо работает на всех поверхностях (песок, трава, камень...), но объекту все равно надо остерегаться препятствий!
По хорошему склону объект может достигнуть Движения, равного своему умению Лыжного спорта, относительно безопасно. Максимальное Движение, в необычайно хороших условиях, равно удвоенному умению Лыжного спорта.
На горизонтальной поверхности, это заклинание — помеха; объект постоянно ведет себя так, как если бы он вошел в Смазанную зону!
Длительность: 1 минута.
Стоимость: 2. Столько же поддержание.
Требования: Перемещение и Смазка.
Предмет
Украшение или обувь. На предмете должно быть изображение выдры. Действует только на носителя. Энергостоимость создания: 350.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">grease</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Slow</name>
		<name-loc>Замедлить</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Сильно замедляет объект; фактически, объект имеет один уровень Замедленного хода времени на время действия заклинания.
Длительность: 10 секунд.
Стоимость: 5 сотворение. 4 поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1, Ускорение и Помеха.
Предмет
(а) Посох или палочка. Используется только магами. Энергостоимость создания: 1.000. (б). Обувь или украшение. Включен постоянно. Энергостоимость создания: 500.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hinder</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Undo</name>
		<name-loc>Развязать</name-loc>
		<description-loc>Обычное; Особое сопротивление
Развязывает узлы и крепления любого типа, которые обычно можно развязать руками (но не замки). Критический успех сможет даже разделить кольчугу на ее составные звенья! Полезно чтобы незаметно украсть у кого-то серьги, ожерелья, и т. п. Может снять тетиву с лука, расстегнуть рубашку, расшнуровать корсаж, расстегнуть пояс... 
Стоимость: 3 за одну завязку, на 1 больше за каждую следующую цель в пределах 1 ярда; 6 достаточно, чтобы развязать все в радиусе 1 ярда, хотя человек в этой области сопротивляется своей Воле(Will)й. 
Более тяжелые предметы можно развязать за пропорциональную стоимость. Например, если маг закован в цепи, он может Развязать звено цепи, изогнув его до открытого состояния. Мастер устанавливает СЛ(ST), необходимое для разгибания звена руками как 20 (вдвое больше нормальной силы). Поэтому стоимость Развязывания звена вдвое больше обычной, то есть 6.
Требования: Взлом.
Предмет
(а) Палочка, посох или перчатка. Действует только на носителя;  должен касаться объекта. Энергостоимость создания: 400. (б) Амулет, дающий иммунитет к заклинанию Развязывания. Энергостоимость создания: 40.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M145</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">locksmith</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Winged Knife</name>
		<name-loc>Крылатый кинжал</name-loc>
		<description-loc>Метательное
Магически бросает любое оружие. Оружие является «объектом» для определения расстояния для сотворения. 1/2Д 20, Мах 40, Точ 1. Если он попадает, то наносит повреждения, как если бы его кинул человек с СЛ(ST) 15. Базовые прямые повреждения для этой СЛ(ST) 1d+1; базовые амплитудные повреждения — 2d+1. 
Стоимость: 1 за фунт веса оружия. Стоимость удваивается за оружие, которое обычно не кидается (например, меч). 
Требования: Полтергейст.
Предмет
Любое оружие. По команде держателя оружие выпрыгивает из его руки, или из ножен, чтобы лететь к цели. Это считается маневром атаки, проводимым с ЛВ(DX), равной силе предмета. Энергостоимость создания: 300 за фунт веса оружия, минимум 300.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1/lb</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>per weapon</damage>
			<accuracy>1</accuracy>
			<range>20/40</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Throwing</name>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M145</reference>
		<notes>throws any weapon with ST 15</notes>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">poltergeist</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Ethereal Body</name>
		<name-loc>Эфирное тело</name-loc>
		<description-loc>Обычное
Объект становится эфирным и может двигаться сквозь твердые объекты и существ, как если бы их там не было. Его одежда тоже становится эфирной, но не его снаряжение. Он не может владеть оружием или передвигать предметы, и ему не надо дышать, есть или пить, пока он эфирный. Он становится, почти по всем критериям, призраком. Его можно увидеть, хотя он выглядит прозрачным, и его можно услышать, если он говорит.
Физические атаки и большая часть магии не могут воздействовать на эфирного персонажа. Однако любые заклинания школ Общения и понимания или Контроля разума действуют на него, как обычно, а броски сопротивления им имеют штраф -2! Аналогично, заклинания Некромантии, воздействующие на разум или душу, действуют, как обычно, а броски сопротивления им имеют штраф -2.
Эфирные персонажи могут применять магию, но с -5 к умению; эфирный план, похоже, является зоной низкой маны. Эфирные тела могут проникать друг в друга, и не могут причинять друг другу вред, кроме как заклинаниями, как описано выше.
Длительность: 10 секунд
Стоимость: 8 сотворение. 4 поддержание.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 3 и или Тело из воздуха, или 6 заклинания Движения.
Предмет
(а). Посох, палочка, украшение или накидка; действует только на носителя. Существенный недостаток состоит в том, что, за исключением накидки, предмет проваливается сквозь заклинателя как только заклинание сотворено! Энергостоимость создания: 3.000 (8.000 за накидку). (б) Драгоценный камень, который светится и вибрирует, когда в пределах 50 ярдов от него находится какое-нибудь эфирное существо. Стоимость создания: драгоценный камень за $500, и 100 энергии.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M146</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<prereq_list all="yes">
				<prereq_list all="no">
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="contains">one college (movement)
						<level compare="at least">3</level>
					</notes></advantage_prereq>
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="is anything"></notes>
						<level compare="at least">3</level>
					</advantage_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<name compare="is">body of air</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">movement</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Flying Carpet</name>
		<name-loc>Летучий ковер</name-loc>
		<description-loc>Обычное
Превращает ковер (или любой другой объект, на или в котором можно стоять — котел, стул, полотенце, метла и т. п.) в летающее транспортное средство. Оно находится под командой первого человека, вставшего на него. Если на объекте в момент сотворения заклинания уже находятся несколько человек, проведите Быстрое состязание Воли(Will), чтобы понять, кто получит контроль; заклинатель (если находится на ковре) получает в этом состязании премию +5. Если пилот покидает ковер, проведите еще одно быстрое состязание Воли(Will) между оставшимися пассажирами, чтобы определить, кто получает контроль.
Максимальное Движение ковра равно эффективному умению заклинателя, и он может справиться с поворотами вплоть до 1G без бросков умения (B466). Используйте умение Пилотирование (Антигравы) (B214), чтобы управлять ковром.
В общем, летящий на ковре, не может упасть с него, если он специально не спрыгнет, или если его не собьет с ковра препятствие (например, ветка дерева) или атака; ковер держит своих пассажиров на борту, используя магию и ловкое маневрирование. Летучий ковер не наклоняется, не складывается и не сгибается; это заклинание предоставляет устойчивую, горизонтальную поверхность (из-за чего весьма сложно пролетать через узкие щели). Любой находящийся на ковре, кто занят энергичной деятельностью, такой как бой, должен делать бросок ЛВ(DX) каждый ход, чтобы не упасть с ковра (Мастер может модифицировать этот бросок в зависимости от деятельности). Во всех остальных отношениях, считайте кого-либо, сражающегося на ковре, как находящегося на земле (игнорируйте специальные правила для летающих бойцов на B548). Персонажи, прицеливающиеся дистанционным оружием с летучего ковра, могут получить только премию Точ; дополнительное время прицеливания не дает дополнительных премий. Разумеется, кто-либо, сражающийся с летучей метлы или стула, получит обычные штрафы за то, что он сидит (B547).
Добрый Мастер может обговорить, что после того как заклинатель отменит заклинание, транспортное средство останется летучим еще 2d+2 секунд, с тряской, усиливающейся каждую секунду. Это в некоторых случаях позволит совершить безопасную, хотя и напряженную, посадку.
Длительность: 10 минут.
Стоимость: 1 за квадратный фут поверхности. Каждый квадратный фут может нести около 25 фунтов (или меньше, если ковер сделан из непрочного материала). Половина поддержание.
Время сотворения: 5 секунд.
Требования: или Магичность(Magery) 2 и Ходить по воздуху, или Полет.
Предмет
Ковер может быть заколдован навсегда за 200-кратную стоимость.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/sq foot of surface</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>10 min</duration>
		<reference>M146</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<prereq_list all="yes">
				<prereq_list all="no">
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="contains">one college (movement)
						<level compare="at least">2</level>
					</notes></advantage_prereq>
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="is anything"></notes>
						<level compare="at least">2</level>
					</advantage_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<name compare="is">walk on air</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">flight</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Great Haste</name>
		<name-loc>Великое ускорение</name-loc>
		<description-loc>Обычное
Очень сильно ускоряет объект. Фактически, объект имеет один уровень Ускоренного хода времени (B38) на время действия заклинания.
Длительность: 10 секунд.
Стоимость: 5. Не поддерживается; надо творить заново. По окончании заклинания объект также теряет 5 ЕУ(FP) (если заклинатель не был объектом).
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1, ИН(IQ) 12 или выше, и Ускорение.
Предмет
Обувь или украшение; действует только на носителя. Энергостоимость создания: 2.000. Предмет стоит носителю 5 ЕУ(FP) за каждые 10 секунд эффекта.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M146</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">haste</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="iq" compare="at least">12</attribute_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Hawk Flight</name>
		<name-loc>Полет сокола</name-loc>
		<description-loc>Обычное
Очень быстрое заклинание Полета. Объект получает Движение 40 (80 миль в час) без нагрузки; нагрузка уменьшает Движение обычным образом. Объект может передвигаться и сражаться как обычно, и имеет преимущество в бою, если находится над врагами (B402).
Длительность: 1 минута.
Стоимость: 8 сотворение. 4 поддержка.
Время сотворения: 3 секунды.
Требования: Полет.
Предмет
Посох, палочка или украшение. Используется только магами; действует только на носителя. Энергостоимость создания: 3.000.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M146</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">flight</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pull</name>
		<name-loc>Тянуть</name-loc>
		<description-loc>Обычное
Когда это заклинание творится на точку, оно создает зону «притяжения». Предметы (включая живых существ) притягиваются к центральной точке с Движением 1 силой, которая растет по мере приближения к центру. Живые существа могут «сопротивляться» Быстрым состязанием СЛ(ST) каждую секунду. Притяжение имеет СЛ(ST), равную удвоенному количеству энергии, вложенной в заклинание, в центре, и уменьшается на 1 за каждый ярд расстояния. Заклинание не имеет никакого эффекта на предметы тяжелее чем его СЛ(ST), увеличенная в 20 раз. Заметете, что для того, чтобы тянуть обычного человека (вес 150 фунтов) по обычному полу, заклинание должно иметь как минимум СЛ8.

Это заклинание можно творить только на точку в пространстве или на земле, не на предмет или существо. Маленькая кучка незакрепленных предметов, пыли, опавших листьев, мелких насекомых и т. п. обычно формируется в центре.
Длительность: 1 минута.
Стоимость: 1 за каждые 2 СЛ(ST) «притяжения».
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2 и хотя бы четыре заклинания Движения, включая Левитацию. 
Предмет
(а) Палочка, посох, или украшение. Используется только магами. Энергостоимость создания: 250. (б) Область может быть сделана притягивающей навсегда за 100-кратную стоимость.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 2 ST of pull</casting_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M146</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="contains">movement</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">levitation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel</name>
		<name-loc>Отталкивать</name-loc>
		<description-loc>Как Тянуть, только сила теперь отталкивает предметы, а не притягивает их.
Длительность: 1 минута.
Стоимость: 1 за каждые 2 СЛ(ST) «отталкивания» в центральной точке.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2 и хотя бы четыре заклинания Движения, включая Левитацию. 
Предмет
(а) Палочка, посох, или украшение. Используется только магами. Энергостоимость создания: 250. (б) Область может быть сделана отталкивающей навсегда за 100-кратную стоимость.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 2 ST of repulsion</casting_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M147</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">movement</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">levitation</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Swim</name>
		<name-loc>Плавание</name-loc>
		<description-loc>Обычное
Позволяет двигаться сквозь воду с нормальным Движением (уменьшенным как обычно за нагрузку). Объект полностью контролирует свое передвижение, и может действовать и сражаться без обычных штрафов за подводный бой. Это заклинание не дает объекту воздух для дыхания! Однако, объект имеет автоматические успехи на всех бросках Плавания, независимо от усталости или нагрузки, если его силой не затаскивают целиком под воду. 
Это также заклинание Воды.
Длительность: 1 минута.
Стоимость: 6 сотворение. 3 поддержание.
Время сотворения: 3 секунды.
Требования: Формировать воду и Левитация.
Предмет
Посох, палочка, украшение или накидка. На предмете должно быть изображение рыбы . Действует только на носителя. Энергостоимость создания: 1.000.</description-loc>
		<college>Movement/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M147</reference>
		<categories>
			<category>Movement</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">levitation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Teleport</name>
		<name-loc>Телепортация</name-loc>
		<description-loc>Особое
Мгновенно перемещает заклинателя на другое место. Однако, чем дальше находится это место, тем больше энергии требуется потратить, и тем больше штраф к умению, как указано далее:
Обычно можно телепортироваться только на место, на которое вы смотрите, или на место, с которым вы знакомы. Штрафы: -2 за место, которое вы «видели» только через разум или память кого-то еще, или по телевизору; -2 за место, где вы не были больше месяца (кроме, возможно, вашего дома!); и от -1 до -3 за место, которое видели мельком.
Это заклинание еще и опасно. Если вы провалите свой бросок на 1, то получите 1d вреда и попадете в точку назначения физически оглушенным (бросок ЗД(HT), чтобы восстановится). Если вы провалите бросок заклинания больше, чем на 1, вы не получаете вреда — но оказываетесь где-то не там. Где именно — решает Мастер! Критический провал этого заклинания может послать заклинателя куда угодно Мастеру — пусть это будет интересно! — и наносит физический вред, пока заклинатель не умрет.
Даже успешная телепортация может сбить с толку. Волшебник должен сделать бросок умения Чувства тела (B181), чтобы действовать дальше в ход телепортации. Проваленный бросок означает дезориентацию — никакие действия кроме защиты невозможны на этом ходу. Критический провал означает, что он падает и физически оглушен. Телепортирующийся прибывает в той же самой позе, в которой он был. Он может быть повернутым в другую сторону, но это делает более вероятным то, что он будет дезориентирован по прибытии: -2 чтобы быть направленным в другую сторону, -5 чтобы из вертикального положения принять горизонтальное, или наоборот!
Расстояние	Стоимость	Умение
Не более 10 ярдов	3	0
11-20 ярдов	4	-1
20-100 ярдов	5	-2
101-500 ярдов	6	-3
От 501 ярда до 1.99 мили	7	-4
От 2 до 9.99 мили	8	-5
От 10 до 99.99 мили	9	-6
От 100 до 999.99 мили	10	-7
Расстояние x10	1	-1

Все, что было у вас с собой, вплоть до «тяжелой» нагрузки, перемещается с вами. Вы также можете взять с собой одного человека, держась с ним за руки, если добавленный вес не превышает предел вашей «тяжелой» нагрузки. На проваленном броске, он будет страдать от тех же побочных эффектов, что и вы.
Это также заклинание Врат.
Требования: или ИН(IQ) не ниже 13 и хотя бы одно заклинание из 10 разных школ, или Полет сокола.
Предмет
Посох или палочка; используется только магами. Энергостоимость создания: 3.000. Предмет, берущий носителя в одно заранее определенное место, имеет энергостоимость создания 2.000; заклинатель должен знать это место очень хорошо.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M147</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">hawk flight</name>
			</spell_prereq>
			<prereq_list all="yes">
				<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
				<spell_prereq has="yes">
					<college_count compare="at least">10</college_count>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Teleport Other</name>
		<name-loc>Телепортация другого</name-loc>
		<description-loc>Обычное; сопротивление по Воле(Will)+1
Как Телепортация, но заклинатель остается на месте, а объектом может быть что или кто угодно. Нельзя телепортировать только часть объекта; также твердое тело нельзя телепортировать в другое твердое тело. Разделение двух соединенных предметов дает штраф, определяемый Мастером; вынуть пробку из банки может быть на -1, а телепортирование запертой двери из косяка — на -5. Носимые украшения или одежда, или предмет, который крепко держит другой человек, могут быть телепортированы на -5, и этот человек может сопротивляться заклинанию.
Это также заклинание Врат.
Стоимость: Стоимость и штрафы к умению как у Телепортации, но с множителями: 
Вес	Множитель
Меньше 10 фунтов	x1/2
10-49 фунтов	x1
50-99 фунтов	x2
100-200 фунтов	x3
Одно дополнительное кратное за каждые дополнительные 100 фунтов	
Последствия проваленного броска аналогичны, но неодушевленные объекты имеют меньший шанс получить повреждения. Если разумный объект успешно сопротивляется заклинанию, заклинатель не страдает от негативных эффектов, кроме затрат энергии.
Требования: Магичность(Magery) 3 и Телепортация.

Предмет
Посох или палочка; используется только магами. Использующий должен направить предмет сначала на объект, а потом на желаемый пункт назначения; это требует секунду и не может быть сделано быстрее. Энергостоимость создания: 3.000.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>_</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M147</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (movement)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blink</name>
		<name-loc>Мерцание</name-loc>
		<description-loc>Блокирующее
Уход от атаки путем мгновенной телепортации с ее пути на свободное место неподалеку. Место не считается свободным, если на нем кто-то стоит; менее серьезные препятствия не имеют значения для этого заклинания.
Заклинатель может Мерцать на любое незанятое место в пределах 3 ярдов, в любом направлении. Направление взглляда заклинателя не меняется. Заклинатель должен сделать бросок Чувства тела, чтобы действовать на своем следующем ходу (В181). Если в пределах 3 ярдов нет свободных мест, заклинание провалится. 
Для боя, «мерцание» считается уклонением, которое автоматически успешно, если бросок заклинания успешен.
Критический провал с этим заклинанием аналогичен критическому провалу Телепортации, но заклинатель редко перемещается больше, чем на милю.
Это также заклинание Врат.
Стоимость: 2
Требования: Телепортация.
Предмет
Одежда или украшение. Энергостоимость создания: 800.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M148</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">teleport</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blink Other</name>
		<name-loc>Мерцание другого</name-loc>
		<description-loc>Блокирующее
Как Мерцание, но может использоваться на других.
Это также заклинание Врат.
Стоимость: 2
Требования: Мерцание.
Предмет
Палочка, посох или украшение. Используется только магами. Энергостоимость создания: 1.600.</description-loc>
		<college>Gate/Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M148</reference>
		<categories>
			<category>Gate</category>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">blink</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Cloud Vaulting</name>
		<name-loc>Прыжки по облакам</name-loc>
		<description-loc>Обычное
Преодолевать огромные расстояния несколькими движениями. Объект подбрасывается в воздух и прыгает к своему назначению, используя облака как батуты. Прыжки по облакам можно творить только под открытым небом.
Каждый раз при сотворении объект перемещается на не более чем 100 миль, плюс 100 миль за каждую единицу умения выше ЛВ(DX) в Акробатике. Если в небе нет облаков (что часто случается в пустынях), объект не может переместиться более чем на 100 миль. Бури аналогичным образом перекроют путь объекта. Каждые 100 миль требуется бросок Акробатики, со штрафом, равным уровню нагрузки объекта. При провале, объект падает 3dx3 ярдов (B431), и приземляется в случайной точке на запланированном пути — Замедлить падение спасет объект от вреда, но заклинание Прыжков по облакам все равно нарушено.
Это заклинание вызывает головокружение; как только объект прибудет на место назначения (или провалит бросок Акробатики), объект будет физически оглушен, если не проведет бросок Чувства тела на -1 за каждые 100 миль, которые он преодолел.
Это также заклинание Погоды.
Длительность: 1 секунда за 100 миль.
Стоимость: 7 сотворение. Не поддерживается.
Требования: Магичность(Magery) 2, Прыжок и Ходить по воздуху.
Предмет
(а) Обувь. На предмете должен быть узор из облаков. Энергостоимость создания: 4.000. (б) Украшение, палочка, или посох. Используется только магами. Энергостоимость создания: 3.000.</description-loc>
		<college>Movement/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec/100 miles</duration>
		<reference>M148</reference>
		<categories>
			<category>Movement</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">walk on air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">jump</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (weather)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cloud Walking</name>
		<name-loc>Ходьба по облакам</name-loc>
		<description-loc>Обычное
Позволяет ходить по облакам (включая туман), как если бы они были твердыми. Если объект по какой-либо причине (например, ранение) падает, заклинание нарушено! Если заклинание немедленно наложено еще раз, объект падает только 1 секунду (примерно 5 ярдов); если он все еще в облаке, ему придется «прокапывать» свой путь наружу, что займет около 5 секунд. Если он уже провалился сквозь облако - у него проблемы! 
Это также заклинание Погоды.
Длительность: 1 час.
Стоимость: 3 сотворение. 2 поддержание.
Требования: Ходить по воздуху и Ходить по воде.
Предмет
Посох, палочка, украшение или обувь. Украшение и обувь действуют только на носителя. Энергостоимость создания: 500.</description-loc>
		<college>Movement/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M148</reference>
		<categories>
			<category>Movement</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">walk on air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">walk on water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Freedom</name>
		<name-loc>Свобода</name-loc>
		<description-loc>Обычное
Дает премию к броскам умений и атрибутов объекта, направленным на поддержание или восстановление его свободы передвижения. Типичные примеры: Состязания ЛВ(DX) или СЛ(ST), чтобы избежать захвата, освободиться от него, или для проскальзывания; использования Побега или Взлома; перепрыгивание и перелезание через удерживающие стены; разгибание прутьев или выламывание дверей; сопротивление заклинаниям Клей, Левитация или Паралич и т.д.
Это заклинание не помогает Маскировке, Изменению внешности или Скрытности; заклинаниям Контроля разума; уклонению от снарядов; использованию Взлома, Лазания и Прыжков, чтобы попасть в какое-нибудь место, и так далее. Решение за Мастером.
Это также заклинание Защиты и Предупреждения.
Длительность: 1 минута.
Стоимость: 2 за единицу премии (максимум +5). Столько же поддержание.
Требования: не менее трех заклинаний каждой из школ Контроля тела, Движения и Защиты и предупреждения.
Предмет
Украшение или одежда. Включен постоянно. Владельца становится очень трудно удержать, держать в цепях или за решеткой... Редкий предмет! Энергостоимость создания: 500 за единицу премии.</description-loc>
		<college>Movement</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per 1 pt of bonus</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M148</reference>
		<categories>
			<category>Movement</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">protection &amp; warning</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">movement</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">body control</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Death Vision</name>
		<name-loc>Видение смерти</name-loc>
		<description-loc>Обычное
Объект испытывает реалистичное видение своей смерти. Это может оказаться видением из будущего, либо ложным образом из другого возможного будущего – но это всегда ужасает. Объект ментально оглушен до успешного броска ИН(IQ). Это заклинание может принести ему и пользу – указав на возможную смертельную опасность.
Длительность: 1 секунда.
Стоимость: 2.
Время сотворения: 3 секунды
Требования: Магичность(Magery) 1.
Предмет: Посох или палочка. Используется только магами. Требуется коснуться объекта. Энергостоимость: 600.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M149</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (necromancy)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Spirit</name>
		<name-loc>Почуять духов</name-loc>
		<description-loc>Информационное; Областное
Обнаруживает любых духов, призраков, нежить и прочих подобных сверхъестественных существ в области действия. При успешном броске дает общее впечатление о видах присутствующих духов. Маг в момент сотворения может ограничить заклинание определенным типом сущностей, либо исключить какие-то из них.
Базовая стоимость: 1/2 (минимум 1).
Требования: Магичность(Magery) 1 и либо Почуять жизнь, либо Видение смерти.
Предмет
(а) Посох, палочка, украшение. Энергостоимость: 100. (б) Самоцвет, который будет светиться или вибрировать, когда дух окажется в заданном радиусе. Энергостоимость: 100 за радиус 1 ярд, 200 – за два ярда и т.д.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Info/Area</spell_class>
		<casting_cost>1/2 (min 1)</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M149</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="no">
			<prereq_list all="yes">
				<prereq_list all="no">
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="contains">one college (necromancy)
						<level compare="at least">1</level>
					</notes></advantage_prereq>
					<advantage_prereq has="yes">
						<name compare="is">magery</name>
						<notes compare="is anything"></notes>
						<level compare="at least">1</level>
					</advantage_prereq>
				</prereq_list>
				<spell_prereq has="yes">
					<name compare="is">sense life</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">death vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Animation</name>
		<name-loc>Анимация</name-loc>
		<description-loc>Обычное
Вызывает духа (ИН(IQ) 9), вселяющегося в существующую скульптуру, изображение или другой предмет. Анимируемый объект должен изображать или представлять животное или человека. Способности и характеристики зависят от его тела. Это остается целиком на усмотрение Мастера – например, рисунок сможет говорить, но не передвигаться, а статуя может оставить свой пьедестал и свободно расхаживать вокруг. В этих пределах анимированный объект должен подчиняться устным приказам мага; он не имеет своей воли и подчиняется им в точности. В отличие от голема (M59), его нельзя заставить подчиняться другому.
Длительность: 1 минута
Стоимость: 3, умноженная на МР(SM)+1 для объектов крупнее среднего человека. Половина на поддержание. Цена удваивается при анимации камня, утраивается – для металла. 
Время сотворения: 5 секунд.
Требования: Вызов духа.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M150</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Materialize</name>
		<name-loc>Материализовать</name-loc>
		<description-loc>Особое; Сопротивление по СЛ(ST) или ИН(IQ)
Это заклинание используется призраками и прочими духами, которые не могут сами по себе становиться видимыми для материального мира.
Также это заклинание используют маги, чтобы вынудить духа проявиться; в этом случае призрак сопротивляется по лучшему из СЛ(ST) или ИН(IQ).
Длительность: 1 минута
Стоимость: 5 на сотворение. 5 на поддержание.
Требования: Вызов духа.

Дух черепа
Дух черепа – призрачная, полуматериальная нежить, создаваемая из жизненной силы черепа разумного существа. Дух черепа безоговорочно подчиняется существу, которое его призвало. Его невозможно уговорить, но иногда можно озадачить.
Дух черепа
224 очка
Модификаторы атрибутов: СЛ(ST) -10 [-100]; ЛВ(DX) +4 [80].
Модификаторы вторичных характеристик: МР(SM) -5; ЕЖ(HP) +20 [40].
Преимущества: Не дышит [20]; Не ест/Не пьет [10]; Не спит [20]; Иммунитет к метаболическим атаками [30]; Устойчивость к повреждениям (рассеянный) [100]; Токсическая атака, 2 очка (Невозможно парировать, -5%; Неостановимая атака, +300%; Контактный бой, Досягаемость В (reach C), -30%) [11]; Нестареющий [15].
Особенности: Фиксированная СЛ(ST)
Умения: Природная атака (Л) ЛВ(DX)+3 [8]-17.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>5</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M150</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Steal Energy</name>
		<name-loc>Украсть энергию</name-loc>
		<description-loc>Обычное
Отнимает ЕУ(FP) у объекта, восстанавливая вашу собственную усталость. Объект должен желать этого или быть беспомощным (например, без сознания или связанным). Маг должен касаться объекта. Заклинание действует только на живых, разумных существ! Действие заклинания прекращается, когда ЕУ(FP) мага полностью восстановлены, либо когда маг пожелает прекратить его, либо когда ЕУ(FP) объекта достигнут 0 и он потеряет сознание.
Длительность: Постоянно.
Стоимость: Бесплатно для мага! За каждые 3 ЕУ(FP), взятых у объекта, маг восстанавливает 1 ЕУ(FP).
Время сотворения: 1 минута за каждые 3 ЕУ(FP), украденные у объекта.
Требования: Малое лечение.
Предмет
Посох, палочка, украшение. Носитель и предмет должны касаться жертвы. Энергостоимость: 800.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>0</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min per 3 FP drained</casting_time>
		<duration>Permanent</duration>
		<reference>M150</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Steal Vitality</name>
		<name-loc>Украсть здоровье</name-loc>
		<description-loc>Обычное
Отнимает ЕЖ(HP) у объекта, восстанавливая их у мага. Объект должен желать этого или быть беспомощным; маг должен касаться объекта. Действует только на живых, разумных существ! Действие заклинания прекращается, когда ЕЖ(HP) мага будут полностью восстановлены, либо маг решит остановить его, либо ЕЖ(HP) объекта снизятся до -1 (что автоматически его убьет).
Длительность: постоянно.
Стоимость: Бесплатно для мага! За каждые 3 ЕЖ(HP), украденные у объекта, маг восстанавливает 1 ЕЖ(HP).
Время сотворения: 1 минута за каждые 3 ЕЖ(HP), украденные у объекта.
Требования: Украсть энергию.
Предмет
(а) Посох, палочка, украшение. Носитель и предмет должны касаться жертвы. Используется только магами. Энергостоимость: 1500. (б) Любой предмет. Пока одет, снижает ЕЖ(HP) владельца на 1-5 единиц. Персонаж восстановит потерянные ЕЖ(HP), когда снимет предмет. Энергостоимость: 200 за каждое очко ЕЖ(HP).</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>0</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min per 3 HP drained</casting_time>
		<duration>Permanent</duration>
		<reference>M150</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">steal energy</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Spirit</name>
		<name-loc>Вызов духа</name-loc>
		<description-loc>Информационное; Сопротивление по Воле(Will) духа
Призывает дух умершего человека. Объект сопротивляется с -5, если был другом мага. При успешном сотворении объект ответит на один вопрос, по мере своих знаний на момент смерти, и сможет отвечать далее на один вопрос в минуту. 
При провале заклинания данный маг (или церемониальная группа) не смогут вызывать этого духа в течение года. При критическом провале появляется враждебный дух, который сознательно лжет.
Модификаторы: -5, если вы не знаете полного имени объекта. -1, если с момента смерти прошло более недели, -2 – если более месяца, -3 – если более года, -4, если более десятилетия, -5, если более 50 лет, и -6, если прошло более 500 лет.
Длительность: 1 минута
Стоимость:  20 на сотворение. 10 на поддержание. Цена уменьшается вдвое, если заклинание творится на месте смерти или над телом объекта, и вчетверо, если соблюдены оба эти условия.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 2 и Видение смерти.
Предмет
Посох, палочка, украшение. Используется только магами. Не дает возможности сотворять заклинание, но дает +2 к его уровню умения. Энергостоимость: 1000.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>10</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 min</duration>
		<reference>M150</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">death vision</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Affect Spirits</name>
		<name-loc>Воздействие на духов</name-loc>
		<description-loc>Обычное
При сотворении на объект или существо, это заклинание позволяет ему взаимодействовать с нематериальными духами, как если бы они были осязаемыми. Оружие под действием этого заклинания может наносить вред нематериальным духам.
Длительность: 1 минута
Стоимость: 4 на сотворение. 2 на поддержание
Время сотворения: 2 секунды
Требования: Уплотнить.
Предмет
Этим заклинанием нельзя зачаровывать предметы, см. Призрачное оружие (M65).</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M151</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">solidify</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Skull-Spirit</name>
		<name-loc>Дух черепа</name-loc>
		<description-loc>Обычное
Призывает призрачного убийцу в услужение магу (см. врезку на M150). Требует черепа разумного существа, который разрушается при сотворении.
Длительность: Дух служит 24 часа, либо пока не будет уничтожен.
Стоимость: 20.
Требования: Четыре заклинания некромагии.
Предмет
Череп разумного создания. Любой может призвать духа черепа, сказав пароль (выбранный магом при наложении чары). В этот момент череп уничтожается, и появляется дух. Энергостоимость: 40.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>20</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>24 hrs</duration>
		<reference>M151</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">necromancy</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Solidify</name>
		<name-loc>Уплотнить</name-loc>
		<description-loc>Особое; Сопротивление по СЛ(ST) или ИН(IQ)
Это заклинание используется нематериальными духами, чтобы стать осязаемым и влиять на объекты материального мира. Осязаемый дух во всех отношениях подобен обычному материальному существу.
Маги, используя это заклинание, могут вынудить духа материализоваться; в этом случае дух сопротивляется по лучшему из значений СЛ(ST) и ИН(IQ).
Длительность: 1 минута
Стоимость: 50 на сотворение. 10 на поддержание.
Требования: Материализовать.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>50</casting_cost>
		<maintenance_cost>10</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M151</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">materialize</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Turn Spirit</name>
		<name-loc>Изгнать духа</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Принуждает одно существо в форме духа бежать от мага. Маг должен видеть цель все это время. Объект движется от него со всей своей возможной скоростью, пока не прекратится действие заклинания, либо пока маг не потеряет его из вида. Объект под влиянием заклинания не может нападать на мага никаким образом; сюда относятся и особые способности, и заклинания.
Если заклинание накладывается на духа, вселившегося в живое существо, оно не вынуждает его покинуть свое вместилище. Вместо этого дух бежит, используя свое временное тело.
Длительность: 10 секунд.
Стоимость: 4 на сотворение. 2 на поддержание. Каждое лишняя единица энергии уменьшает устойчивость духа на 1.
Требования: Страх и Почуять духов.
Предмет
Посох, палочка, украшение. Используется только магами. Энергостоимость: 350.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 sec</duration>
		<reference>M151</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">fear</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">sense spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Zombie</name>
		<name-loc>Зомби</name-loc>
		<description-loc>Обычное
объектом этого заклинания должно быть относительно целое мертвое тело. Природа и состояние тела определяет свойства созидаемой нежити. Оживленный труп становится верным слугой мага. Его атрибуты – а также физические преимущества и ЛВ(DX)-умения – основаны на таковых исходного тела. Нежить не имеет «души», ментальных черт, ИН(IQ)-умений и памяти живого существа. Точные характеристики и способности определяет Мастер по необходимости кампании.
Длительность: Пока не будет уничтожен.
Стоимость: 8.
Время сотворения: 1 минута
Требования: Вызов духа и Передать здоровье.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>until destroyed</duration>
		<reference>M151</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lend vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Control Zombie</name>
		<name-loc>Контроль зомби</name-loc>
		<description-loc>Обычное; Сопротивление по заклинанию Зомби
Перехватывает контроль над нежитью, поднятой заклинанием Зомби другого мага. Если пытающийся перехватить зомби маг побеждает в состязании, зомби начинает служить ему, как если бы он сам поднял этого зомби. Если маг-создатель находится не дальше 100 ярдов, заклинание Зомби сопротивляется с +2, если же он мертв – то с -2.
Длительность: постоянно.
Стоимость: 3.
Требования: Зомби.
Предмет
Посох, палочка, украшение. Используется только магами. Не дает возможности сотворять это заклинание, но дает +2 к умению тем, кто его знает. Энергостоимость: 500.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M152</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">zombie</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Turn Zombie</name>
		<name-loc>Изгнать зомби</name-loc>
		<description-loc>Областное
Наносит 1d вреда любым существам в области, которые были подняты при помощи заклинания Зомби; СП(DR) не защищает. Кроме того, сделайте бросок 1d для каждого из зомби. При выпавшей 1, зомби убегает от мага. 
Длительность: Успешно изгнанный зомби будет избегать мага в течение одного дня.
Базовая стоимость: 2. Поддержание невозможно.
Время сотворения: 4 секунды.
Требования: Зомби, либо статус «святого» (на усмотрение Мастера).
Предмет
Посох, палочка, украшение. По решению Мастера, этот предмет может работать только для владельцев Благословения или Дарованной силы. Энергостоимость: 600.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>Turned undead will avoid caster for 1 day</duration>
		<reference>M152</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">zombie</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Zombie Summoning</name>
		<name-loc>Призыв зомби</name-loc>
		<description-loc>Особое
Призывает к магу ближайшего зомби (это заклинание считается им любую нежить, созданную заклинанием Зомби). Расстояние значения не имеет. После успешного сотворения маг узнает местонахождение ближайшего зомби (любые известные магу зомби могут быть исключены из поля действия) и сколько времени ему потребуется, чтобы добраться до мага. Зомби движется к магу со всей возможной скоростью, пока не увидит его, либо заклинание не прекратит свое действие. После этого он остается в пределах досягаемости, не нападая и не подчиняясь, до окончания действия заклинания. Заклинание прекращает действие, если зомби подвергается любой атаке; зомби не может добраться до мага до окончания действия заклинания, он просто идет по своим делам.
Зомби не отвечают на вызов, если это противоречит приказам хозяина (поэтому вы не можете, например, отозвать зомби, что-то охраняющих).
Длительность: 1 минута
Стоимость: 5 на сотворение. 2 на поддержание. Для вызова нескольких зомби цена удваивается. Все зомби в радиусе 10 миль (при очень успешном сотворении) будут призваны.
Время сотворения: 4 секунд.
Требования: Зомби</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M152</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">zombie</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Command Spirit (@spirit@)</name>
		<name-loc>Управление духом</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will) духа.
Аналогично Очаровать (M139), но действует только на духов. Каждая категория духов (баньши, спектры, маниту и т.д.) требуют отдельного заклинания. Варианта для демонов и элементалей не существует – используйте Вызов демона или Контроль элементаля. В отличие от объекта заклинания Charm, дух может пытаться извратить приказы мага, как демон (см. Вызов демона, M155).

Длительность: 1 минута
Стоимость: 1 за 10 очков персонажа в духе. Половина на поддержание. (Если у мастера нет листа для духов, 5 единиц будет достаточно для малых духов, 10 – для более сильных.)
Время сотворения: 2 секунды.
Требования: Вызов духа, Изгнать духа.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 10 CP</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M153</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">turn spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Mass Zombie</name>
		<name-loc>Массовое поднятие зомби (ОС)</name-loc>
		<description-loc>Областное
Аналогично Зомби, но оживляет все относительно целые мертвые тела в области действия. Как и в случае с Зомби, тип создаваемой нежити зависит от состояния тела; одним сотворением можно создать нежить разных типов. Тела должны лежать в своей могиле или на месте смерти; в противном случае заклинание не подействует. Тела в могилах выроются с глубины вплоть до 4 ярдов.
Созданная этим заклинанием нежить становится слугами мага. Однако, ими можно управлять только группой; отдельным членам ее нельзя дать отдельные задачи. Если это заклинание сотворяется церемониально, хозяином становится лидер круга. Остальных членов круга зомби считают его лейтенантами; они подчиняются их приказам, но приказы хозяина считаются важнее. Маг-лидер, однако, может во время сотворения разделить «орду» поровну, и каждый участник круга станет хозяином своей доли.
В большинстве удачных для сотворения зон это заклинание поднимет (RxR)/2 зомби (округлять виз), где R – радиус действия заклинания. Результат будет хуже на кладбищах высшего класса, где у мертвых полно места в своих склепах, и лучше – в местах массовых захоронений. Нежить, создаваемая этим заклинанием, идентична таковой, создаваемой заклинанием Зомби. Она использует те же шаблоны и точно так же подвержена магии. 
Длительность: Постоянно.
Базовая стоимость: 7. Минимальный радиус – 2 ярда.
Время сотворения: Количество минут, равное радиусу.
Требования: Зомби и Харизма 2+</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min per area</casting_time>
		<duration>Permanent</duration>
		<reference>M153</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">charisma</name>
				<notes compare="is anything"></notes>
				<level compare="at least">2</level>
			</advantage_prereq>
			<spell_prereq has="yes">
				<name compare="is">zombie</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Slow Healing</name>
		<name-loc>Замедлить лечение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Затрудняет лечение объекта. Это заклинание вычитается из всех бросков естественного выздоровления (B424) и целительских умений (Первая помощь, Врачебное дело, Хирургия и т.д.), включая заклинания исцеления. На болезни, восстановление ЕУ(FP) и броски сопротивления по ЗД(HT) оно не действует. Снять заклинание можно только при помощи Снять проклятие.
Длительность: 1 день
Стоимость: 1-5 на сотворение. То же на поддержание. Это значение вычитается из всех бросков лечения.
Время сотворения: 30 секунд
Требования: Магичность(Magery) 1, Хрупкость и Украсть здоровье.
Предметы
(а) Посох, палочка, украшение. Используется только магами. Энергостоимость: 175. (б) Любое оружие. Раны, нанесенные им, очень трудно заживают; штраф применяется до тех пор, пока рана не затянется полностью, либо не будет снято проклятие. При попытке лечения целитель должен указать, пытается ли он повлиять на данную рану. Если да – применяется штраф. Энергостоимость: 100 за единицу штрафа. Цена удваивается для дистанционного оружия (лук, арбалет). Цена уменьшается в 10 раз, если цель – снаряд (стрела, например). Если оружие попадает под несколько категорий, используется высшая цена.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 day</duration>
		<reference>M153</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">frailty</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Stop Healing</name>
		<name-loc>Остановить лечение</name-loc>
		<description-loc>Обычное; Сопротивление по Лечению.
Аналогично Замедлить лечение, но это заклинание противостоит естественному заживлению и целительным умениям и заклинаниям. Каждая попытка лечения объекта должна выиграть Быстрое состязание по умению против стойкости Остановить лечение (M10). Каждый провал остановки лечения ослабляет его стойкость на 1; когда она достигает 0, заклинание рассеивается. Критический провал Остановки лечения или критический успех сопротивляемого заклинания, умения или процесса также разрушает чары. В других случаях нужно Снять проклятие.
Длительность: До рассеивания.
Стоимость: 10.
Время сотворения: 10 секунд
Требования: Замедлить лечение.
Предмет
Посох, палочка, украшение. Используется только магами. Энергостоимость: 500.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Until spell dissipates</duration>
		<reference>M153</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">slow healing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Age</name>
		<name-loc>Старение (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Делает объекта старше! объект старится на год за каждые 10 очков энергии, вложенной в заклинание.
Длительность: постоянно
Стоимость: 10-50 очков
Время сотворения: 1 минута
Требования: Молодость, либо шесть других заклинаний некромагии.
Предмет
(а) Любой предмет. Действует постоянно. Если будет носиться (просто касания мало), жертва будет стариться на год за каждый день носки (так, два часа носки состарит ее на месяц). Энергостоимость: 500. (б) Посох или палочка. Используется только магами; необходимо коснуться предметом цели. Энергостоимость: 2000.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10 per year of aging</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">youth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">necromancy</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animate Shadow</name>
		<name-loc>Анимировать тень</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Призывает духа, который оживляет тень объекта и нападает на него. Тень имеет ИН(IQ) 9, ЗД(HT) 10, ЛВ(DX), равную эффективному умению мага, и СЛ(ST) и Движение, равное таковым объекта. Цель имеет оружие, которое жертва имела в руке на момент сотворения (даже если бросила его позже!), наносит только базовый вред (не учитывая премию за режущий или проникающий тип вреда) в виде изнуряющего. Броня не защищает, но атаки тени можно парировать или блокировать, если оружие или щит, используемые для этого, находились в руках объекта в момент сотворения заклинания. Когда ЕУ(FP) объекта достигают 0, он теряет сознание и заклинание прекращается. Оживленную тень можно атаковать, как обладателя Тела из тени (см. B114); если ее ЕЖ(HP) доходят до 0, она «убита», и объект восстанавливает свою обычную тень. 
Длительность: 5 секунд
Стоимость: 4. То же на поддержание.
Время сотворения: 2 секунды
Требования: Дух черепа и Формировать тьму.
Предмет
Посох, палочка, украшение. Используется только магами. Энергостоимость: 450.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>5 sec</duration>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">skull-spirit</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape darkness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Evisceration</name>
		<name-loc>Потрошение (ОС)</name-loc>
		<description-loc>Контактное; Сопротивление по ЗД(HT) или ИН(IQ)
Позволяет вонзить кисть в тело объекта и вырвать его органы, оставив зияющую дыру. Извлечение мозга мгновенно убивает тело, но мозг сам по себе может прожить еще несколько минут! Каждую секунду нужен бросок против ЗД(HT); при успехе мозг остается живым и в сознании, но теряет 1 ЕУ(FP); при провале он погибает. Живой мозг может творить любые заклинания, известные на достаточном уровне, чтобы не требовать ритуала. Помните, что сам мозг не имеет органов чувств и вынужден действовать вслепую.
Извлечение сердца требует от жертвы броска ЗД(HT)-6 каждый ход; при провале она теряет сознание и погибнет через пять секунд.
Удаление других органов требует бросков ЗД(HT) со штрафом от 0 до -5, чтобы сохранять сознание. Большинство таких атак убьет жертву за минуту; однако, потерю некоторых органов можно пережить – легкие, почку и т.д. В этом случае, однако, жертва страдает от сильного кровотечения. Для замещения потерянного органа нужно Восстановление. Извлеченные органы умирают через минуту.
Стоимость: 10.
Время сотворения: 5 секунд
Требования: Магичность(Magery) 3, Перемещение и Украсть здоровье.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>removes vital organ</damage>
			<usage>Grapple</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Judo</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Sumo Wrestling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Wrestling</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pestilence</name>
		<name-loc>Чума</name-loc>
		<description-loc>Обычное
Заражает цель жуткой инфекцией на выбор мага (Хотя Мастер может отклонить неподходящий выбор). Болезнь идет своим нормальным ходом; инфекции обычно не будет заметно какое-то время.
Длительность: До исцеления.
Стоимость: 6.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 1, Украсть здоровье и Разложение.
Предмет
Посох или палочка. Используется только магами; требуется коснуться предметом объекта. Налагаемая болезнь устанавливается зачарователем. Энергостоимость: 1000.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Rotting Death</name>
		<name-loc>Гниющая смерть (ОС)</name-loc>
		<description-loc>Контактное; Сопротивление по ЗД(HT)
Жертва, к которой прикоснулся маг, начинает гнить изнутри. Каждый ход она должна сделать бросок ЗД(HT); при провале она получает 1d-1 вреда; при критическом провале – 6 единиц. Успешный бросок означает, что она не получает вреда в этот ход, а критический успех рассеивает заклинание. СП(DR) не защищает! 
Во время действия заклинания жертва чувствует жуткий дискомфорт, аналогичный таковому при заклинании Болезнь (M138).
Внешне это выглядит как молниеносно развивающаяся гангрена. В каждый ход нанесения вреда делается бросок на зону поражения; после увечья конечность отваливается! Когда объект погибает, его тело быстро разлагается, оставляя лишь вонючую лужу.
На нежить заклинание не действует. Маг должен концентрироваться, поддерживая заклинание, но физический контакт больше не нужен. 
Длительность: 1 секунд
Стоимость: 3 на сотворение. 2 на поддержание
Требования: Магичность(Magery) 2, Болезнь и Чума.
Предмет
Посох, палочка, украшение. Используется только магами; требуется коснуться предметом жертвы. Энергостоимость: 700.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>thr-1 cr +1d-1 tox/second</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">sickness</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">pestilence</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Soul Jar</name>
		<name-loc>Сосуд души (ОС)</name-loc>
		<description-loc>Обычное
Заключает душу объекта в некотором объекте (который должен присутствовать). Если объектом не является маг, объект должен присутствовать при сотворении, и быть желающим или бессознательным.
Когда ваша душа находится в «сосуде», заклинание не действует, пока тело не умрет, или не будет уничтожен сосуд. Смерть тела не убивает вас. Сознание перемещается в «сосуд», откуда вы можете видеть, слышать и даже колдовать любые заклинания, известные вам на уровне 20+ (то есть не требующие ни речи, ни жестов). Вы можете общаться на расстоянии при помощи подходящих заклинаний, если вам такие известны – или прямым ментальным контактом с любым, кто держит сосуд. Ваши ЕУ(FP) сохраняются. Вы не можете тратить ЕЖ(HP), но можете использовать любой энергокамень, касающийся вашего сосуда.
Когда новое тело оказывается поблизости от сосуда, вы можете захватить его при помощи Переселения, Постоянного переселения или Обмена телами, если вам они знакомы. В этом случае душа данного тела занимает ваше место в сосуде. Пока ваша душа находится в сосуде, его уничтожение убьет вас навсегда – без надежды на воскрешение – даже если тело невредимо.
Это заклинание можно сотворить еще раз, чтобы переместить душу в новый сосуд.
Длительность: постоянно
Стоимость: 8.
Время сотворения: 1 минута
Требования: Магичность(Magery) 1 и шесть заклинаний некромагии, включая Украсть здоровье.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M154</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">necromancy</college>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Summon Demon</name>
		<name-loc>Вызов демона</name-loc>
		<description-loc>Особое
Это особая версия Планарного вызова (M82), вызывающая демона; все подробности описаны в том заклинании. Если маг проваливает контроль демона, тот всегда нападает на него! Если демон не может до него добраться (например, если маг защищен Пентаграммой), демон исчезнет (если заперт) или сбежит, стараясь принести в мир больше хаоса.
Подконтрольный демон будет подчиняться приказам, выполняя их буквально и стараясь максимально извратить дух против намерений мага. Он также будет стараться нанести случайный вред, если ему не запретить это специально.
С разрешения Мастера маг может призвать толпу мелких демонов, чья очковая стоимость в сумме не превышает 200 очков (но тогда маг не может потратить на заклинание больше 20 единиц энергии). В этом случае маг контролирует всю толпу, состязаясь по высшей Воле(Will) среди этих демонов. Группа мелких демонов не ограничена одной задачей; они всегда остаются на все время действия. 
Длительность: До выполнения задачи демоном, или один час, что меньше.
Стоимость: 1 единица за 10 очков персонажа в демоне. Минимальная цена – 20 единиц (хотя не обязательно будет призван 200-очковый демон). Рискнувшие вызывать могущественных существ должны помнить, что у них часто высокое значение Воли(Will), и это затрудняет их контроль.
Время сотворения: 5 минут
Требования: Магичность(Magery) 1 и по одному заклинанию из 10 разных школ.
Предмет
Известно, что некоторые артефакты легко вызывают демонов (или одного конкретного). Такие предметы ценятся теми, кто имеет дела с демонами, но (к счастью!) технология создания таких предметов неизвестна.

Демон
Демоны этого вида чаще всего появляются на материальном плане: громилы с кожистыми крыльями и острейшими когтями и клыками. Эти демоны не очень умны, но сильны, выносливы и жестоки. Их жестокое чувство юмора вошло в историю, и они всегда оставляют после себя огромные разрушения, независимо от того, какой приказ им дали.
Демоны чрезвычайно разнообразны; эти характеристики – вполне приемлемые усредненные.

Демон
200 очков
Модификаторы атрибутов: СЛ(ST)+7 [70]; ЛВ(DX)+2 [40]; ЗД(HT)+4 [40].
Модификаторы вторичных характеристик: ЕЖ(HP)+8 [16].
Преимущества: Когти (Острые когти) [5]; СП(DR) 5 [25]; Полет (Крылья, -25%; +5 ярдов в секунду) [40]; Иммунитет к нарушениям метаболизма [30]; Иммунитет к магии, воздействующей на разум [30]; Магичность(Magery) 0 [5]; Адаптация к темноте 5 [5]; Ударная СЛ(ST) +2 [10]; Зубы (Острые зубы) [1].
Недостатки: Внешность (Монстр) [-20]; Кровожадность (12) [-10]; Задира (12) [-10]; Жестокий [-5]; Не трогает невиновных (не наносить только прямой вред истинно добрым или святым, -50%) [-5]; Хрупкость (Неестественный) [-50]; Садизм (12) [-15]; Эгоизм (12) [-5]; Социальная дискриминация (Монстр) [-15].
Особенности: Подвержен действию Истинной веры и Пентаграммы.
Умения: Артистизм (С) ИН(IQ)-1 [1]-9; Драка (Л) ЛВ(DX)+2 [4]-14; Палаш (С) ЛВ(DX) [2]-12; Заговаривание зубов (Л)
ИН(IQ)+2 [4]-12; Тайные знания (Знания демонов) (С) ИН(IQ)-1 [1]-9; Запугивание (Л) ИН(IQ)+2 [4]-12; Скрытность (С)
ЛВ(DX) [2]-12.

Контракты с демонами
Некоторых «магов» не устраивает время, которое нужно потратить на заучивание мощных заклинаний, или ограничения, накладываемые их собственной Магичность(Magery)ю (или ее отсутствием). Для тех, кто не желает мириться с этими ограничениями, существует другой, черный выбор. Помощь демонов рядом – только попроси.
Колдовство с демонской помощью начинается с вызова демона. В большинстве сеттингов для этого нужен достаточно сильный маг; в других мирах для вызова демона может даже не требоваться Магичности – или даже пререквизитов! Если демон желает быть призванным, он иногда оставляет легкие способы для заключения контракта.
После вызова маг обсуждает контракт со своим будущим демоном-покровителем и подписывает его собственной кровью (те, что поумнее, обычно готовят контракт заранее, или берут его из книги; обычно то, что предлагает демон – самоубийство). 
После подписания маг может использовать помощь демона в колдовстве, не вызывая его заново. Обычно такие заклинания черпают энергию у темных, потусторонних сил; маг может уменьшить цену заклинания на любое значение вплоть до утроенного уровня умения в Оккультизме или Тауматологии (что выше), до уменьшения ее за высокий уровень умения.
Однако, такая магия имеет свои ограничения. Ее невозможно использовать для прямой выгоды другим, если это не приведет позже к еще большему вреду (на усмотрение Мастера). Тем не менее, для комфорта самого мага она вполне доступна. Любая попытка направить демоническую энергию в позитивном направлении может привести к приостановке контракта, что не дает использовать темную энергию до тех пор, пока не будет принесено достаточное извинение.
Любой провал демонического заклинания считается критическим; любой критический провал считается, как если бы маг выкинул 18 по таблице Темных критических результатов (M157).

Черная магия
Черная магия имеет свою цену. Управление темной энергией отравляет душу мага. В конце каждого дня, когда маг использовал темную энергию, он должен сделать бросок Воли(Will)+Магичность(Magery) со штрафом, равным количеству этой энергии. При успехе не случается ничего. При провале броска маг получает уровень Темного Штрафа за каждые 10 очков (или их часть) провальности. 
Темный штраф – это штраф на любые заклинания, сотворяемые без помощи демона. Он очевиден для заклинания Аура, а обладатели Магичности 3 и выше могут заметить следы при первой встрече темного мага, сделав бросок Зрения. Любое заклинание, сотворяемое магом под Темным штрафом считается демоническим в отношении обычных и критических провалов.
Маг может иметь лишь 10 уровней Темного штрафа. С этого момента его душа абсолютно черна; любой благородный недостаток, такой, как Честность или Пацифизм, будет потерян и часто замещен некой извращенной версией изначальной добродетели. Он также получает Зависимость на -10 очков к демонической энергии (магия демонов дешева, сильно затягивает и обычно нелегальна). Такие маги по-прежнему должны делать броски Воли(Will)+Магичности в конце каждого дня использования демонической магии, но с +10. Провал приводит к потере 5 очков персонажа – уменьшения атрибутов, потери преимуществ или приобретения новых недостатков – за каждое очко провальности!
Демонолог может попытаться очистить свою душу, но это сложный процесс. Каждый уровень требует отказа от любого использования магии и всех чувственных удовольствий на (20-Воля(Will)) дней (минимум 1) для его снятия. Это достаточно сложно; волшебник, вынужденный бороться еще и с Зависимостью, практически безнадежен.
Темный штраф – недостаток на -3 очка/уровень. Контракт с демоном – перк (B100).</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>1 per 10 CP</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 hr</duration>
		<reference>M155</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Banish</name>
		<name-loc>Изгнать</name-loc>
		<description-loc>Особое; Сопротивление по Воле(Will)
Изгоняет пришельца с другого плана (например, демона) на его родной план. Может сотворяться только магом на своем родном измерении. На чужом плане вы не можете «изгнать» себя домой, а уроженцы этого плана – могут. Это заклинание не действует на существ, уже находящихся на родном плане.
Попытка Изгнания – быстрое состязание по умению мага против Воли(Will) объекта. Если маг побеждает, существо немедленно возвращается «домой». Оно не сможет вернуться на данный план в течение месяца. Все, что пришелец принес с собой (например, оружие), исчезает вместе с ним. Другие предметы, которые существо несло (например, кричащая жертва), остается.
Обратите внимание, что некоторые могущественные создания устойчивы или даже иммунны к этому заклинанию.
Модификаторы: +4, если маг знает «истинное имя» существа; -5, если маг не знает, откуда существо пришло… и еще -1, если он думает, что знает, но ошибается!
Стоимость:  1 за 10 очков персонажа в объекте. Минимальная цена – 10. Маг не знает заранее, сколько может потребовать заклинание и может упасть без сознания и даже ранить себя.
Время сотворения: 5 секунд
Требования: Магичность(Magery) 1 и не менее чем по одному заклинанию из 10 разных школ.
Предмет
Некоторые «святые» артефакты помогают изгонять настоящих демонов, а предметы из родных планов пришельцев могут помочь понять и изгнать их. Ходят слухи, что какие-то талисманы, которые носят планарные странники, защищают их от изгнания.

Воскрешение (ОС)
Обычное
Описано среди заклинаний Исцеления, M94.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>1 per 10 CP</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M156</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Entrap Spirit</name>
		<name-loc>Поймать духа</name-loc>
		<description-loc>Обычное
Позволяет магу запечатать контейнер или комнату так, что дух, находящийся внутри, не сможет выйти. Загнать сначала духа в ловушку – отдельный вопрос; обычно нужен Управление духом, но его можно и обмануть.
Контейнер может быть любого размера – от небольшой бутылки до целого строения, но обязательно должен крепко, плотно закрываться (достаточно водонепроницаемости), и маг должен касаться его в течение всего времени сотворения. Дух не может сопротивляться заклинанию, но цена зависит от его силы. Итоговая цена сотворения равна СЛ(ST)+ИН(IQ) духа, разделенному на 5, или на 10 – для поддержания. Для поимки действительно могущественного духа требуются весьма серьезные усилия! В момент запирания маг узнает требуемые затраты, и вкладывает энергию; если энергии у него не хватает, дух заперт не будет. Если маг заплатит половину цены, духу хватит секунды, чтобы вырваться из ловушки, но иногда даже секунда имеет значение. Если в одном контейнере запирается несколько духов, цена рассчитывается исходя из суммы полных СЛ(ST) и ИН(IQ) самого сильного духа и половины таковых остальных духов. Дух не может повредить контейнер, воздействовать на что-либо за его пределами, либо использовать какие-то превращения, чтобы его покинуть. Он может общаться обычным способом с любым в радиусе 1 ярда от контейнера. 
Длительность: 5 минут
Стоимость: (СЛ(ST)+ИН(IQ))/5 духа на сотворение, (СЛ(ST)+ИН(IQ))/10 на поддержание.
Требования: Магичность(Magery) 1, Сосуд души и Изгнать духа.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Varies</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min</duration>
		<reference>M157</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">turn spirit</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Bind Spirit (@Spirit@)</name>
		<name-loc>Связать духа (тип) (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по ИН(IQ) духа
Аналогично Поработить (M141), но действует на духов. Как и Поработить, позволяет ментальный контакт после хода концентрации. Отдельный вариант заклинания нужен для каждого варианта Управления духом. Духи могут понимать приказы по-своему, как и в случае с Управлением духом.
Длительность: Постоянно.
Стоимость: 1 за 3 очка персонажа, используемых для создания духа (минимум 30 единиц).
Время сотворения: 5 минут.
Требования: Управление духом (того же типа) и Сосуд души.
Предмет
Дух может быть привязан к предмету или месту. Привязанные духи служат владельцу предмета и не развеиваются. Энергостоимость: Четырехкратная цена; половина, если дух сотрудничает.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>Permanent</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">command spirit (@spirit@)</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Repel Spirits</name>
		<name-loc>Отталкивание духов</name-loc>
		<description-loc>Областное
Изгоняет духов из области. Заклинание сопротивляется попыткам духов (а также любых других нематериальных существ – объектов Эфирного тела или  Планарного визита, например) войти или оставаться в ней, путем обычного состязания между их Воле(Will)й и эффективным умением мага (каждый раунд длится секунду). Находящиеся внутри сопротивляются по Воле(Will); при первом же провале они будут выгнаны.
Длительность: 1 час.
Базовая стоимость:  4 на сотворение. Половина на поддержание.
Время сотворения: 10 секунд
Требования: Изгнать и Изгнать духа.
Предмет
(а) Посох, палочка, украшение. Используется только магами. Энергостоимость: 100. (б) Любая область или контейнер может быть зачарованы постоянно за 100-кратную цену.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">banish</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">turn spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Dexterity</name>
		<name-loc>Украсть изящество (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по атрибуту.
На самом деле это четыре отдельных заклинания. Украсть мощь крадет СЛ(ST) объекта, Украсть изящество крадет ЛВ(DX), Украсть мудрость – ИН(IQ), и Украсть здравие - ЗД(HT). Каждое заклинание нужно учить отдельно, но все они действуют одинаково.
Это заклинание передает основные атрибуты один-к-одному магу от объекта (который должен быть живым разумным существом). Маг не может снизить атрибуты цели ниже средних расовых (10 для человека). Таким образом, объект должен иметь более высокие значения, чтобы заклинание подействовало. Вторичные атрибуты также уменьшаются.
Маг должен касаться объекта в течение всего времени сотворения; никто из них не должен делать ничего больше. Маг увеличивает свой атрибут (соответствующий), как если бы потратил очки персонажа, украденные у объекта.
Пример: Рольф, имеющий ИН(IQ) 14, желает украсть мудрость жертвы с ИН(IQ) 13 (это возможно, поскольку любой персонаж может иметь опыт и знания, которые могут помочь другим, даже если значение атрибута меньше). Если он снизит ИН(IQ) жертвы до 10, то украдет 3 уровня ИН(IQ), и поднимет свой ИН(IQ) до 17.
Длительность: 1 день; после чего и маг и объект восстанавливают исходные значения.
Стоимость: 1 за очко персонажа (минимальная цена 10 единиц).
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3. Кроме того, для каждой версии заклинания существуют дополнительные требования:
Заклинание		Требования
Украсть мощь		Украсть здоровье и Слабость
Украсть изящество	Украсть здоровье и Неуклюжесть
Украсть мудрость	Украсть здоровье и Глупость
Украсть здравие		Украсть энергию и Хрупкость</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">clumsiness</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Might</name>
		<name-loc>Украсть мощь (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по атрибуту.
На самом деле это четыре отдельных заклинания. Украсть мощь крадет СЛ(ST) объекта, Украсть изящество крадет ЛВ(DX), Украсть мудрость – ИН(IQ), и Украсть здравие - ЗД(HT). Каждое заклинание нужно учить отдельно, но все они действуют одинаково.
Это заклинание передает основные атрибуты один-к-одному магу от объекта (который должен быть живым разумным существом). Маг не может снизить атрибуты цели ниже средних расовых (10 для человека). Таким образом, объект должен иметь более высокие значения, чтобы заклинание подействовало. Вторичные атрибуты также уменьшаются.
Маг должен касаться объекта в течение всего времени сотворения; никто из них не должен делать ничего больше. Маг увеличивает свой атрибут (соответствующий), как если бы потратил очки персонажа, украденные у объекта.
Пример: Рольф, имеющий ИН(IQ) 14, желает украсть мудрость жертвы с ИН(IQ) 13 (это возможно, поскольку любой персонаж может иметь опыт и знания, которые могут помочь другим, даже если значение атрибута меньше). Если он снизит ИН(IQ) жертвы до 10, то украдет 3 уровня ИН(IQ), и поднимет свой ИН(IQ) до 17.
Длительность: 1 день; после чего и маг и объект восстанавливают исходные значения.
Стоимость: 1 за очко персонажа (минимальная цена 10 единиц).
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3. Кроме того, для каждой версии заклинания существуют дополнительные требования:
Заклинание		Требования
Украсть мощь		Украсть здоровье и Слабость
Украсть изящество	Украсть здоровье и Неуклюжесть
Украсть мудрость	Украсть здоровье и Глупость
Украсть здравие		Украсть энергию и Хрупкость</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">debility</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Skill</name>
		<name-loc>Украсть умение (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Передает одно умение от объекта магу. Маг должен касаться объекта в течение всего времени сотворения; никто из них не должен делать ничего больше. Исход борьбы (например, бросок сопротивления) неясен до момента завершения сотворения. Маг может прекратить сотворение в любой момент; энергия все равно тратится.
Маг получает умение, как если бы потратил то количество очков персонажа, которое украл. Это заклинание может использоваться для кражи заклинаний.
Если жертва имеет другие умения, основанные на этом, то они сохраняются, но получают штраф -2 за нехватку пререквизитов.
Пример: Северин хочет продать несколько вещей сомнительного происхождения, но не особенно соображает в торговле. Чтобы это компенсировать, он колдует Украсть умение на первого же базарного торговца. Торговец имеет ИН(IQ) 10, Счетовод 2 и Торговля-15, потратив 12 очков в это умение. Северин получает Торговлю так, как если бы потратил на нее 12 очков – с его ИН(IQ) 14 его умение составит 17. Северин не получает выгоды от Таланта торговца.
Длительность: 24 часа.
Стоимость: 1 за краденное очко персонажа (Минимальная цена 10).
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3, Заимствовать умение и Оцепенение.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per CP stolen</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>24 hrs</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">borrow skill</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">daze</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Vigor</name>
		<name-loc>Украсть здравие (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по атрибуту.
На самом деле это четыре отдельных заклинания. Украсть мощь крадет СЛ(ST) объекта, Украсть изящество крадет ЛВ(DX), Украсть мудрость – ИН(IQ), и Украсть здравие - ЗД(HT). Каждое заклинание нужно учить отдельно, но все они действуют одинаково.
Это заклинание передает основные атрибуты один-к-одному магу от объекта (который должен быть живым разумным существом). Маг не может снизить атрибуты цели ниже средних расовых (10 для человека). Таким образом, объект должен иметь более высокие значения, чтобы заклинание подействовало. Вторичные атрибуты также уменьшаются.
Маг должен касаться объекта в течение всего времени сотворения; никто из них не должен делать ничего больше. Маг увеличивает свой атрибут (соответствующий), как если бы потратил очки персонажа, украденные у объекта.
Пример: Рольф, имеющий ИН(IQ) 14, желает украсть мудрость жертвы с ИН(IQ) 13 (это возможно, поскольку любой персонаж может иметь опыт и знания, которые могут помочь другим, даже если значение атрибута меньше). Если он снизит ИН(IQ) жертвы до 10, то украдет 3 уровня ИН(IQ), и поднимет свой ИН(IQ) до 17.
Длительность: 1 день; после чего и маг и объект восстанавливают исходные значения.
Стоимость: 1 за очко персонажа (минимальная цена 10 единиц).
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3. Кроме того, для каждой версии заклинания существуют дополнительные требования:
Заклинание		Требования
Украсть мощь		Украсть здоровье и Слабость
Украсть изящество	Украсть здоровье и Неуклюжесть
Украсть мудрость	Украсть здоровье и Глупость
Украсть здравие		Украсть энергию и Хрупкость</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">steal energy</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">frailty</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Wisdom</name>
		<name-loc>Украсть мудрость (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по атрибуту.
На самом деле это четыре отдельных заклинания. Украсть мощь крадет СЛ(ST) объекта, Украсть изящество крадет ЛВ(DX), Украсть мудрость – ИН(IQ), и Украсть здравие - ЗД(HT). Каждое заклинание нужно учить отдельно, но все они действуют одинаково.
Это заклинание передает основные атрибуты один-к-одному магу от объекта (который должен быть живым разумным существом). Маг не может снизить атрибуты цели ниже средних расовых (10 для человека). Таким образом, объект должен иметь более высокие значения, чтобы заклинание подействовало. Вторичные атрибуты также уменьшаются.
Маг должен касаться объекта в течение всего времени сотворения; никто из них не должен делать ничего больше. Маг увеличивает свой атрибут (соответствующий), как если бы потратил очки персонажа, украденные у объекта.
Пример: Рольф, имеющий ИН(IQ) 14, желает украсть мудрость жертвы с ИН(IQ) 13 (это возможно, поскольку любой персонаж может иметь опыт и знания, которые могут помочь другим, даже если значение атрибута меньше). Если он снизит ИН(IQ) жертвы до 10, то украдет 3 уровня ИН(IQ), и поднимет свой ИН(IQ) до 17.
Длительность: 1 день; после чего и маг и объект восстанавливают исходные значения.
Стоимость: 1 за очко персонажа (минимальная цена 10 единиц).
Время сотворения: 1 минута.
Требования: Магичность(Magery) 3. Кроме того, для каждой версии заклинания существуют дополнительные требования:
Заклинание		Требования
Украсть мощь		Украсть здоровье и Слабость
Украсть изящество	Украсть здоровье и Неуклюжесть
Украсть мудрость	Украсть здоровье и Глупость
Украсть здравие		Украсть энергию и Хрупкость</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 day</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">foolishness</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Youth</name>
		<name-loc>Украсть молодость (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Забирает чужую молодость. За каждые вложенные 10 единиц энергии маг молодеет на год, а объект (должен быть той же расы) старится на два. Объект должен сотрудничать, либо быть полностью беспомощным; маг должен касаться объекта. Критический провал этого заклинания стоит магу 1 ИН(IQ) и мгновенно старит его на 20 лет.
Длительность: Постоянно.
Стоимость: 10-30.
Время сотворения: 1 час
Требования: Молодость, Старение и Украсть здоровье. 
Предмет
Посох, палочка, украшение. Используется только магами. Маг и предмет должны касаться жертвы. Предмет можно использовать только раз в год, и красть за раз только один год молодости – таким образом, одним предметом можно только сохранять молодость, но не больше. Энергостоимость: 8.000.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10 per year</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 hr</casting_time>
		<duration>Permanent</duration>
		<reference>M158</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">youth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">age</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Astral Block</name>
		<name-loc>Блокирование астрала</name-loc>
		<description-loc>Областное
Ни один дух или иное нематериальное существо не могут пересечь границы астрального блока. Кроме того, нематериальные существа в пределах его зоны не могут становиться материальными, и наоборот. То есть, 
маг не может сотворить Эфирное тело в области действия заклинания, а призрак не способен Уплотняться. Призрак, уже находящийся в материальном состоянии, не может стать нематериальным!
Длительность: 10 минут.
Стоимость: 4 на сотворение и 2 на поддержание при сотворении на область. 15 за куб. ярд при сотворении на контейнер, половина на поддержание.
Время сотворения: 2 секунды.
Требования: Вызов духа и Отталкивание духов.
Предмет
(а) Посох, палочка, украшение. Используется только магами. Энергостоимость: 600. (б) Любой контейнер или область могут быть зачарованы навсегда за 100-кратную цену. (в) Контейнер любого размера (от бутылки до космолета) может быть зачарован за 500 единиц за куб. ярд емкости (или его часть). Контейнер при закрывании должен быть герметичным. Это создает переносной астральный блок. Любой дух, попавший внутрь контейнера (или уже находящийся там при сотворении) попадет под действие заклинания, когда контейнер будет закрыт. Открытие контейнера временно приостанавливает действие заклинания.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 min</duration>
		<reference>M159</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">repel spirits</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">summon spirit</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Lich</name>
		<name-loc>Лич (ОС)</name-loc>
		<description-loc>Зачарование
Это заклинание позволяет магу стать личем – могущественным волшебником-нежитью, в совершенстве владеющим магией и алхимией. Он сохраняет личность, знания, ИН(IQ), умения и заклинания, и все свои ментальные черты (включая Магичность(Magery)), но получает физические и сверхъестественные черты лича, определенные Мастером. Чем сильнее шаблон лича, тем выше будут затраты энергии.
После создания Мастером шаблона лича (и определения энергостоимости) маг колдует это заклинание как любую другую чару. После этого делается бросок умения. Любой провал наносит магу 6к вреда. Успешное сотворение подготавливает тело мага к следующему шагу.
Для завершения трансформации будущий лич должен выпить алхимический эликсир Оличения. Этот эликсир готовится как любой другой алхимический препарат (см. M210); ингредиенты для него стоят $13.500, а готовится он 50 недель. Уровень умения по умолчанию равен Алхимии-7. Любой, не находящийся под действием заклинания Лич, и выпивший эликсир, подвергается действию эликсира Смерти (M215). Однако, эликсиру Оличения невозможно противодействовать – даже алхимическим Противоядием. Эликсир Оличения запрещен везде, и его формулу найти почти невозможно; большинству личей приходится создавать его заново.
Когда маг под заклинанием Лич выпивает зелье Оличения, он делает бросок ЗД(HT). При успешном броске он умирает и через 2d дней поднимается в виде лича. При провале броска он просто умирает. Удача, а также Благословение и заклинания Желание могут помочь этому броску ЗД(HT).
Это заклинание также относится к школе Зачарования.
Стоимость: Равна суммарной очковой стоимости лича в окончательном виде, включая все его личные способности и черты шаблона лича. Для могущественных магов чара стоит больше, поскольку нужно сохранить больше черт. Минимальная цена – 100.
Требования: Магичность(Magery) 3, ИН(IQ) 13 и выше, Наложение чар, Сосуд души и Зомби.</description-loc>
		<college>Necromancy/Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M159</reference>
		<categories>
			<category>Enchantment</category>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">zombie</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Beauty</name>
		<name-loc>Украсть красоту (ОС)</name-loc>
		<description-loc>Обычное
Передает красоту объекта магу. Маг получает один или больше уровней красоты (B21), а объект теряет то же количество.
Красота может быть украдена только у кого-то с лучшей внешностью, чем у мага, и маг не может получить уровень красоты выше, чем было у объекта изначально. Объект должен быть того же вида и пола, что и маг. Кроме того, объект должен сотрудничать или быть беспомощным, и его нужно касаться в течение всего времени действия заклинания. Критический провал этого заклинания делает мага Отвратительным.
Мастер может разрешить при помощи этого заклинания красть также Харизму и преимущество Голос. Люди, потерявшие харизму, просто кажутся менее увлекающими; те, у кого украли голос – получают Немоту. Критический провал в любом из этих вариантов делает немым мага! 
Длительность: 24 часа; по их истечении и маг, и объект восстанавливают исходные уровни внешности.
Стоимость: равна разнице в очках персонажа между исходной и окончательной внешностью объекта (или цене краденного преимущества в случае с Голосом или Харизмой).
Время сотворения: 30 секунд
Требования: Магичность(Magery) 3, Изменить лицо и Украсть здоровье.
Предмет
Посох, палочка, украшение. Носитель и предмет должны касаться жертвы. Используется только магами. Энергостоимость: 2,500.</description-loc>
		<college>Necromancy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>24 hrs</duration>
		<reference>M159</reference>
		<categories>
			<category>Necromancy</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (necromancy)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">alter visage</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">steal vitality</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Wraith</name>
		<name-loc>Дух (ОС)</name-loc>
		<description-loc>Чара; Сопротивление по ЗД(HT)
Зачаровывает кольцо или амулет так, что будучи надетыми, они превращают владельца в духа, неупокоенного стража, поддерживаемого магией. Предмет пытается воздействовать на объект каждый раз, когда их надевают. Заклинанию можно сопротивляться по ЗД(HT), как обычно. Если любая из попыток проваливается (или объект решает не сопротивляться), он «погибает» и через 24 часа становится духом. 
Точный шаблон определяется Мастером, но ментальные черты сохраняются как при заклинании Лич. Дух всегда имеет Зависимость (B130) к предмету Духа (редкий предмет, постоянная потребность, за -150 очков) и умирает, если его снять или уничтожить. Обратить действие заклинания можно только Снятием проклятия.
Каждый предмет Духа может поддерживать только одного духа за раз. Когда данный предмет создал духа, он не будет действовать на других носителей, пока его дух не будет уничтожен. Заклинание Дух не действует на нежить.
За двойную стоимость чародей может создать предмет, делающий духа его слугой. Дух автоматически получает Перепрограммируемый (B150) с чародеем в качестве хозяина, и не может снять предмет сам. 
За половинную цену чародей может создать предмет, превращающий носителя в неупокоенного стража гробниц. Действует аналогично обычному предмету, но созданная нежить получает Разорительную привычку (оставаться в гробнице и охранять ее; убивать пришельцев и возвращаться, если будет насильно из нее извлечен) [-15].
Это заклинание также относится к школе Зачарований.
Стоимость: 500.
Требования: Магичность(Magery) 3, ИН(IQ) 13 и выше, Наложение чар, Остановить старение и Сосуд души.
Предмет
Кольцо или погребальный амулет, не должны быть украшены.</description-loc>
		<college>Enchantment</college>
		<power_source>Arcane</power_source>
		<spell_class>Enchantment</spell_class>
		<casting_cost>500</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M160</reference>
		<categories>
			<category>Enchantment</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">enchant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">halt aging</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">soul jar</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (enchantment)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<attribute_prereq has="yes" which="iq" compare="at least">13</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bless Plant</name>
		<name-loc>Благословить растения</name-loc>
		<description-loc>Областное
Заставляет растения в области эффекта расти быстрее и сильнее, чем в обычный период. Урожайность в области эффекта удваивается.
Длительность: один урожай или сезон.
Базовая стоимость: 1. Что бы заклинание подействовало, растения должны полностью находиться в области эффекта.
Время сотворения: 5 минут.
Требования: Исцеление растений.
Предмет
Палочка. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1 minimum</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 Crop or Season</duration>
		<reference>M161</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heal plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Heal Plant</name>
		<name-loc>Исцеление растений.</name-loc>
		<description-loc>Областное
Исцеляет зараженные, поврежденные, больные растения в области. Растения должны быть еще живы для срабатывания заклинания.
Длительность: Постоянно.
Базовая стоимость: 3. Деревья больше саженцев, требуют радиус, по крайней мере, 3 ярда.
Время сотворения: 1 минута.
Требования: Определить растение.
Предмет
Палочка. Предмет должен касаться растения. Энергостоимость создания: 400.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 Min</casting_time>
		<duration>Permanent</duration>
		<reference>M161</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">identify plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Identify Plant</name>
		<name-loc>Определить растение</name-loc>
		<description-loc>Информационное
Заклинание определяет тип и вид какого-либо одного растения. Оно также дает основную информацию о нем (съедобное, ядовитое, и т.д.). Успешное сотворение этого заклинания дает +3 к умениям Натуралист (Naturalist) или Знахарь (Physician) для определения лекарственных или других специальных свойств растения.
Стоимость: 2.
Требование: Поиск растений.
Предмет
Посох, палочка. Энергостоимость создания: 200.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M161</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Plant</name>
		<name-loc>Поиск растения</name-loc>
		<description-loc>Информационное
Сообщает магу примерное расстояние и направление до ближайшего растущего растения, или одного особого типа растения. Используются Модификаторы больших расстояний (M14). Любые из известных растений могут быть исключены из поиска, если заклинатель упоминает их до сотворения.
Стоимость: 2.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 50.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M161</reference>
		<categories>
			<category>Plant</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Plant</name>
		<name-loc>Формировать растение</name-loc>
		<description-loc>Обычная
Позволяет руками лепить и формовать растения и растительный материал.
Заклинание дает +2 к умениям Плотник и Художник (Деревообработка), или позволяет заклинателю работать без каких-либо средств со штрафом -1. Это полезно для строительства дома и создания мебели, ремонта щитов и снаряжения, и устранения деревянных препятствий. Также это может быть использовано на оружие врага в бою, нанося 2d повреждения деревянному оружию; смотри Удары по оружию (B400) для подробной информации об уроне оружию.
Длительность: 1 минута.
Стоимость: 3 сотворение. 1 поддержка. Двойная цена, если материал недолговечный.
Время сотворения: 10 секунд.
Требования: Определить растение.
Предмет
Перчатка из растительного материала. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M161</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">identify plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blight</name>
		<name-loc>Увядание</name-loc>
		<description-loc>Областное
Заставляет растения в области эффекта расти более медленно и более слабо, чем в обычный сезон. Урожай в области сокращается вдвое. Незамедлительные последствия включают потерю листьев, плодов и цветов; пострадавшие растения восстанавливаются (частично) на следующий день.
Длительность: Один урожай или сезон.
Базовая стоимость: 1. Что бы заклинание подействовало, растения должны полностью находиться в области эффекта.
Время сотворения: 5 минут.
Требования: Рост растений.
Предмет
Палочка. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1 minimum</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 Crop or Season</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Blossom</name>
		<name-loc>Цветение</name-loc>
		<description-loc>Областное
Заставляет растения в области, цвести и плодоносить в течении одного часа действия заклинания. Что бы заклинание подействовало, растения должны полностью находиться в области эффекта. Растения остаются в таком состоянии в течении 24 часов, в конце которых, они вступают в конечную фазу – листья деревьев возвращают свой цвет, цветы и плоды опадают, и т.д. Заклинание может быть ограничено одним растением или определенным типом растений.
Длительность: 1 час.
Базовая стоимость: 2. Не поддерживается.
Время сотворения: 5 минут.
Требования: Рост растений.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>1 hour</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Conceal</name>
		<name-loc>Скрыть в зарослях</name-loc>
		<description-loc>Областное
Заставляет местную растительность быстро расти вокруг какого-либо объекта в области, скрывая его от случайного поиска. Каждый, кто ищет в этой области, должен провести быстрое состязание (Зрение против вашего заклинания), чтобы заметить скрытый объект. Большие объекты могут быть замаскированы под «холмы», заросшие травой или мхом.
Длительность: 1 час.
Базовая стоимость: В лесу или джунглях (или под водой), 1 сотворение; на равнинах или в саванне, 2; в тундре, 3. Такая же цена на поддержку.
Время сотворения: 4 секунды.
Требования: Рост растений.
Предмет
Посох или палочка. Энергостоимость создания: 250.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Forest Warning</name>
		<name-loc>Лесное предупреждение</name-loc>
		<description-loc>Областное
Так же как и Соловей (M167), но работает в области с растениями.
Длительность: 10 часов.
Базовая стоимость: 1/2 (минимум 2). Такая же стоимость поддержки.
Требования: Чувство опасности или четыре заклинания Растений.
Предмет
Может быть сотворено навсегда на область или растения. Энергостоимость создания: 100 на ярд радиуса.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 hours</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">Sense Danger</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<spell_prereq has="yes">
				<college compare="is">plant</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hide Path</name>
		<name-loc>Скрыть следы</name-loc>
		<description-loc>Обычная
Позволяет заклинателю и другим существам размером с человека (вплоть до пяти), или одному заклинателю верхом, пройти сквозь траву, подлесок, или джунгли не оставляя каких-либо следов. Любая попытка выследить на этом скрытом пути производится со штрафом -8!
Длительность: 1 минута.
Стоимость: 2 сотворение. 1 поддержка.
Требования: Исцеление растений.
Предмет
Плащ из растительного материала. Энергостоимость создания: 300.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">Heal Plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Growth</name>
		<name-loc>Рост растений</name-loc>
		<description-loc>Областное
Заклинание вызывает эквивалент одного месяца роста в одну минуту. Деревья изменяются лишь незначительно, в то время как сорняки растут чрезвычайно. Полезно для садоводства (после удаления всех сорняков!), и посева.
Длительность: 1 минута.
Базовая стоимость: 3 сотворение. 2 поддержка.
Время сотворения: 10 секунд.
Требования: Исцеление растений.
Предмет
Посох или палочка. Энергостоимость создания: 300.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 min</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heal plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Vision</name>
		<name-loc>Видеть сквозь растения</name-loc>
		<description-loc>Обычное
Заклинание позволяет видеть сквозь растительность, чтобы найти заросшие здания, скрытых врагов, и т.д. Зачарованные природные растения становятся прозрачными для заклинателя. Магические растения, мертвые деревья, и деревянные конструкции – нет.
Это также заклинание Знаний.
Длительность: 30 секунд.
Стоимость: 1 за 10 ярдов дистанции (100 ярдов максимум). Та же стоимость поддержки.
Длительность: 30 секунд.
Требования: Рост растений.
Предмет
Любой. Энергостоимость создания: 300.</description-loc>
		<college>Plant/Knowledge</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 10 yards</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M162</reference>
		<categories>
			<category>Knowledge</category>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Pollen Cloud</name>
		<name-loc>Облако пыльцы</name-loc>
		<description-loc>Областное. Сопротивление по ЗД(HT).
Облако пыльцы заполняет область; все кто находятся в нем, начинают чихать, плакать и кашлять. Все жертвы получают штраф -2 к ЛВ(DX), пока находятся в облаке и до 3d ходов после. Скорость распыления зависит от области и наличия ветра; в помещении оно длится пока действует заклинание, а на открытом воздухе в ветреный день может продолжаться только 10 секунд или около того.
Длительность: 5 минут или меньше.
Базовая стоимость: 1. Не поддерживается.
Требования: Рост растений.
Предмет
Посох, палочка, украшение. Энергостоимость создания: 100.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min#</duration>
		<melee_weapon>
			<damage>Cough/Sneeze</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Tangle Growth</name>
		<name-loc>Заросли</name-loc>
		<description-loc>Областное
Заставляет траву или другие растения в области вырасти и стать препятствием (движение сокращается вдвое, -2 к уклонению), или кусты и низкие деревья вырастают в препятствие, которое нужно миновать. Рассматривать такое препятствие как 3” деревянный забор (B558) на метр ширины. Любой в области где твориться заклинание может передвигаться с нормальной скорость в следующий ход; если он не покинул область, то препятствие появляется перед ним.  
Длительность: 1 минута.
Базовая стоимость: 1 для травы, 2 для кустов и деревьев. Половина для поддержки.
Время сотворения: 2 секунды.
Требования: Рост растений.
Предмет
Область может быть постоянно «сложной».Энергостоимость создания 20 на ярд радиуса для травы, или 30 на ярд радиуса для деревьев и кустов.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1 to 2#</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>2</casting_time>
		<duration>1 min</duration>
		<reference>M162</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Plants</name>
		<name-loc>Создать растение</name-loc>
		<description-loc>Областное
Создает растительность там, где ничего не росло раньше. Выживет ли эта растительность, зависит от района.
Длительность: Постоянно.
Базовая стоимость: 4 для травы; 8 для кустарников; 15 для деревьев.
Время сотворения: 1 секунда на единицу энергии.
Требования: Магичность(Magery) 1 и Рост растений.
Предмет
Палочка. Используется только магами. Предмет должен касаться области, где должны появиться растения. Энергостоимость создания: 1.000.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>False Tracks</name>
		<name-loc>Ложные следы</name-loc>
		<description-loc>Обычное. Сопротивление по Воле(Will).
Объект оставляет следы похожие на следы животного или другого существа. Нежалающий этого объект сопротивляется по Воле(Will). Быстрое состязание между охотником (Следопыт) и заклинателем (Натуралист) (или его умение заклинания, что меньше) определяет смог ли заклинатель обмануть охотника.
Длительность: 1 минута.
Цена: 2 сотворение. 1 поддержание.
Требования: Формировать растение и Формировать землю.
Предмет
Обувь. Предмет должен содержать изображение животного или того, чьи следы должен создавать. Энергостоимость создания: 300.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Sense</name>
		<name-loc>Восприятие растений</name-loc>
		<description-loc>Обычное; Сопротивление по умению Скрыть следы.
Объект видит и слышит мельчайшие детали известные растениям вокруг него – такие как нарушения вызванные прошедшими или спрятавшимися созданиями. Это заклинание дает  +4 к умению Следопыт, +2 ко всем броскам Чувств, и способность обнаруживать невидимые или магически скрытые создания с нормальным броском Чувств. Работает только в области с густым покровом растительности (джунгли, лес, и т.д.); может работать с половинным эффектом (без возможности обнаружить невидимые или магически скрытые создания) в местности с редкой растительностью
Длительность: 1 минута.
Стоимость: 3 сотворение. 2 поддержание.
Требования: Лесное предупреждение и Скрыть следы.
Предмет
Посох или статуэтка. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">forest warning</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hide path</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rejuvenate Plant</name>
		<name-loc>Омолодить растение</name-loc>
		<description-loc>Обычное
Заставляет мертвое, умирающее или старое растение, внезапно наполнится жизнью.
Столы (или луки!) прорастают листьями, старое плодовое дерево, приносит плоды еще раз, и т.д. Сможет ли растение поддерживать жизнестойкость, зависит от непосредственного окружения. Например, обновленный стул будет разрушаться медленно, если его ножки пустят корни в питательной почве.
Длительность: Постоянно.
Стоимость: 3.
Требования: Магичность(Magery) 1 и Рост растений.
Предмет
Посох. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 700.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant growth</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk Through Plants</name>
		<name-loc>Проходить сквозь растения</name-loc>
		<description-loc>Обычное
Позволяет объекту пройти через траву, подлесок, большой лес или джунгли, без каких-либо помех от растительности. Он может путешествовать как по голой земле (нормальное движение); растения раздвигаются в стороны, позволяя объекту пройти, и затем становятся на место.
Заклинание затрудняет проследить за целью, давая штраф от -1 до -8, в зависимости от толщины местной растительности. Если против объекта используется Заросли, проводите быстрое состязание магических умений каждую секунду.
Длительность: 1 минута.
Стоимость: 3 сотворение. 1 поддержка.
Требования: Скрыть следы и Формировать растение.
Предмет
Плащ из растительного материала. Энергостоимость создания: 400.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hide path</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape plant</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wither Plant</name>
		<name-loc>Иссушение растений</name-loc>
		<description-loc>Областное; Сопротивление по ЗД(HT).
Заставляет растения в области чахнуть и погибать. Заклинатель может выбрать на своё усмотрение эффект – заклинание затрагивает одно растение или все, но одного вида. Любым крупным растениям или живым, необходимо назначить ЗД(HT), чтобы они могли сопротивляться этому заклинанию – смотри Анимировать растение.
Длительность: Постоянно.
Базовая стоимость: 2.
Время сотворения: 10 секунд.
Требования: Увядание.
Предмет
Посох или палочка мертвого дерева. Энергостоимость создания: 200.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M163</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">blight</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Animate Plant</name>
		<name-loc>Анимировать растение</name-loc>
		<description-loc>Обычное
Подобно Анимации (M150), исключая что только одно растение может быть анимировано. Анимированное растение получает ЗД(HT) равное удвоенному количеству энергии, вложенному в заклинание. Следует помнить, что древесные растения часто имеют высокий показатель СП(DR) и могут напугать противника.
Разумное растение (ИН(IQ) 6 и выше) не может быть анимировано.
Длительность: 1 минута.
Стоимость: 3 сотворение. Половина на поддержание. Двойная стоимость, если растение должно вытянуться с земли и пройтись на своих корнях! (Движение 4)
Время сотворения: 5 секунд.
Требования: Семь заклинаний Растений.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 secs</casting_time>
		<duration>1 min</duration>
		<reference>M164</reference>
		<notes>Double casting cost if plant moves</notes>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">plant</college>
				<quantity compare="at least">7</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Wood</name>
		<name-loc>Истинное древо</name-loc>
		<description-loc>Обычное
Преобразует любую неповрежденную древесину в волшебную эссенцию дерева. Эссенция дерева, в три раза сильнее обычного дерева, и имеет в три раза больше ЗД(HT) и СП(DR), перечисленных на B558, и выдерживает в три раза больше веса. Она трудно воспламеняется огнем (Огнеупорный согласно таблице на B433), но один раз воспламенившись, горит в три раза дольше. Также горит жарче, добавляя дополнительные очки урона на кубик (это также увеличивает тепло Истинного огня!).
Рукотворные предметы из дерева, могут быть превращены в аналогичные из Истинного древа; однако живые растения не могут быть преобразованы.
Длительность: Постоянно.
Стоимость: 8.
Время сотворения: 30 секунд.
Требования: Шесть заклинаний Растений.
Предмет
Посох. Используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M164</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">plant</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Control</name>
		<name-loc>Контроль растений</name-loc>
		<description-loc>Обычное; сопротивление по Воле(Will)
Контролировать действия одного большого растения (любого размера) или группы небольших - от одного до 100 фунтов . Возможно, только если растение может начать двигаться самопроизвольно. Требуется концентрация. Это заклинание не будет работать с умными растениями (ИН(IQ) 6 и выше). Учитывайте, что такое заклинание дает возможность использовать умения Всадник, Ментальный наездник,  Вселение в зверя и схожие умения над созданными растениями. Контроль растений сопротивляется умению Анимировать растение.
Длительность: 1 минута.
Стоимость: 3 сотворение. Половина на поддержание.
Требования: Восприятие растений.
Предмет
Посох, палочка или статуэтка. Энергостоимость создания: 600 (контроль любого типа растений).</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M164</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant sense</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Form</name>
		<name-loc>Форма растения</name-loc>
		<description-loc>Особое
Принять форму любого растения или дерева между 1/2 и 5 вашего собственного размера. Одежда исчезает и появляется вновь, когда вы приобретаете свою форму; большое имущество падает на землю, в то время как небольшие вещи (до размера браслета или палочки) могут быть встроены в вашу растительную форму.
Заклинатель не может передвигаться, атаковать и т.п., только если растение с этими способностями существует в игровом мире и маг принимает его форму, или если на его форму растения сотворено заклятие Анимировать растение. Заклинатель в форме растения может творить заклинания, если он знает их настолько хорошо, что может обойтись без речи или жеста! Он может нормально слышать, но может не видеть, кроме ощущения самого света и темноты. Он может быть лишен речи.
Травмы, полученные в форме растения, переносятся пропорционально. Это означает, например, что для дерева попавшая стрела, все равно, что булавочный укол для человека; здесь необходима гибкость Мастера! Время, проведенное в растительной форме, автоматически подсчитывается как «отдых», только если растение не атакуют. Однако, заклинатель должен делать бросок ИН(IQ) каждый час, находясь в форме растения. Неудачный бросок временно уменьшает его ИН(IQ) на 1. Если ИН(IQ) падает до 5, он остается в форме растения с ИН(IQ) растения, пока кто-то другой не освободит его с помощью Снять проклятие.
Длительность: 1 час.
Стоимость: 5 сотворение. 2 поддержка.
Требования: Магичность(Magery) 1 и шесть заклинаний Растений.
Предмет
Посох или палочка. Энергостоимость создания: 1.200.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M164</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">plant</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plant Speech</name>
		<name-loc>Разговор с растениями</name-loc>
		<description-loc>Обычное
«Общение» с растениями в самой элементарной форме (полу-телепатически; маг должен говорить вслух). Чем старше растение, тем больше информации оно может дать. Например, трава может сказать кто ходил по ней недавно (в течении дня), в то время как вековой дуб, может вспомнить детали средства передвижения, одежды, запаха… Разумные растения могут вести более содержательный разговор.
Длительность: 1 минута. Каждая минута позволяет задать один вопрос и получить один ответ.
Стоимость: 3 сотворение. 2 поддержку.
Требования: Магичность(Magery) 1 и Восприятие растений.
Предмет
Посох. Энергостоимость создания: 750 для объекта, который будет разговаривать с одним конкретным видом, 2.000 для разговора с любыми растениями.
Растительные Мета-черты (Plant Meta-Traits)
Тело из дерева: Ваше тело сделано из дерева. Базовая скорость -1[-20]; Подъемная СЛ(ST) +5[15]; Тупой Коготь [3]; СП(DR) 2 (полу-разрушающийся, -20%); Не дышит [20]; Иммунитет к Метаболическим угрозам [30]; Устойчивость к ранениям (Однородный) [40]; Беспомощный [-20] и Находится под воздействием заклинаний Растений [0]. 76 очков.
Тело из слизи: Ваше тело состоит из органической слизи например морская водоросль или плесень. Амфибия [10]; Не дышит [20]; Иммунитет к Метаболическим угрозам [30]; Устойчивость к ранениям (Однородный) [40]; Плохо пахнет [-10]; Неприятный голос [-10]; Беспозвоночный [-20]; Находится под влиянием заклинаний Растений [0]. 60 очков.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M164</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">plant sense</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk Through Wood</name>
		<name-loc>Проходить сквозь дерево</name-loc>
		<description-loc>Обычное
Позволяет объекту пройти через массивное дерево (живое или мертвое) как сквозь воздух. Он не открывает проход чтобы другие могли последовать, ни показывает что находится на другой стороне…Объект должен задержать дыхание, т.к. заклинание не дает воздуха!
Если заклинание закончится прежде, чем объект окажется на открытом воздухе, он будет погружен в дерево. Это не наносит автоматического вреда, но объект задохнется (B436), если не сможет выбраться.
Длительность: 1 секунда.
Стоимость: 3 сотворение. 2 поддержка
Требования: Проходить сквозь растения.
Предмет
Плащ из растительного материала. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M164</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">walk through plants</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Arboreal Immurement</name>
		<name-loc>Замуровать в дереве</name-loc>
		<description-loc>Обычное; сопротивление ЗД(HT)
Аналог Захоронения, но вместо земли объект заключается в дерево. Объект мгновенно поглощается ближайшим деревом, достаточно большим, чтобы вместить его. Объект погружается в клинический сон  (как в заклинании Приостановить жизнь; см M94) в крошечной цилиндрической камере, внутри дерева, пока не будет вырублен из дерева или до отмены заклинания.
Маг, сотворивший Замуровать в дереве на себя, может решить остаться в сознании, но это глупо без воздуха!
Модификаторы: Применяется модификатор расстояния (M14) для расстояния от объекта до ближайшего дерева, достаточного по размеру, чтобы поглотить объект.
Длительность: Не определена.
Стоимость: 8 на сотворение. 5 для отмены Древесного заточения.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 2 and Проходить сквозь дерево.
Предмет
Посох или палочка. Предмет должен быть деревянным, и работает только с деревьями этой породы деревьев. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 1000.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Indefinite</duration>
		<reference>M165</reference>
		<notes>Costs 5 to reverse an Arboreal Immurement</notes>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">walk through wood</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Slime</name>
		<name-loc>Тело из слизи</name-loc>
		<description-loc>Обычное; сопротивление по ЗД(HT)
Водный эквивалент Тело из дерева. Объект становится подвижной массой зеленой слизи – водорослей, озерной тины и другой мерзости которую можно найти в болоте – временно объекту предоставляется мета-черта Тело из слизи (см. вставку). Одежда (до 6 фунтов) также трансформируется, но теряет всякие магические свойства.
Длительность: 1 минута. Заклинание истекает, если объект теряет сознание.
Стоимость: 6 сотворение. 2 поддержка.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2, Растительная форма, Формировать воду.
Предмет
Посох, палочка или статуэтка. Влияет только на пользователя. Энергостоимость создания: 1.300.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M165</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">plant form</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Wood</name>
		<name-loc>Тело из дерева</name-loc>
		<description-loc>Обычное; сопротивление по ЗД(HT)
Объект становится подвижной деревянной статуей, временно дайте объекту мета-черту Тело из дерева (см. вставку). Одежда (до 6 фунтов) также становится деревянной, но теряются её любые магические свойства. Объект может по-прежнему говорить, колдовать и т.д.
Объект под действием Тело из дерева, может также погрузится в деревянный предмет, если имеет преимущество Проникновение (Дерево) (B75).
Длительность: 1 минута. Заклинание истекает, если объект теряет сознание.
Стоимость: 7 сотворение. 3 поддержка.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2 и Растительная форма.
Предмет
Посох, палочка или статуэтка. Действует только на пользователя. Энергостоимость создания: 1.300.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M165</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant form</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Plant Form Other</name>
		<name-loc>Растительная форма другому (ОС)</name-loc>
		<description-loc>Особое; сопротивление по Воле(Will)
Как и Растительная форма, но используется на других. Только колдующий или заклинание Снять проклятие может завершить действие заклинания. Потери ИН(IQ) вскоре превратят объект в настоящее растение!
Длительность: 1 час.
Стоимость: 5 на сотворение. 2 на поддержание.
Время сотворения: 30 секунд.
Требования: Магичность(Magery) 2 и Растительная форма.
Предмет
Посох или палочка. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 3.000.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M165</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">plant form</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain of Nuts</name>
		<name-loc>Дождь орехов</name-loc>
		<description-loc>Областное
В указанной области выпадает дождь из орехов, исходящий от близлежащих деревьев, как если бы они были заполнены сумасшедшими белками. Шумный ливень барабанит о шлемы, жалит открытые участки кожи, и препятствует дистанционным атакам. Любые персонажи в области получают штраф -1 к любым задачам, требующим концентрации или умениям, включая боевые и колдовство. Также есть дополнительный штраф к видимости от -1 до -8 ярдов расстояния, применимые к дистанционным атакам и броскам Зрения. Маг может выбрать, область, где нет эффекта от заклинания, фокусируя «гнев» леса на врагах.
Это заклинание может быть сотворено снаружи, в лесу. Оно не будет работать в глухую зиму, или в редком лесу. В зависимости от видов деревьев, орехи могут оказаться съедобными.
Человеческие маги редко используют это заклинание (большинство считают, это ниже своего достоинства), но разновидности лесных жителей и природных духов, используют его для того, чтобы выгнать захватчиков из их лесов.
Длительность: 1 минута.
Базовая стоимость: 1/10 на сотворение. Столько же на поддержание. За двойную стоимость, заклинатель может удвоить эффект заклинания (штраф -2 к умениям и -1 штрафа на 4 ярда видимости), если Мастер соглашается с тем, что леса являются достаточно плотные и дикие.
Требования: Магичность(Magery) 1 и по крайней мере шесть заклинаний Растений, включая Формировать растение.
Предмет
Посох или палочка. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Plant</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1 per 10 yds</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M165</reference>
		<categories>
			<category>Plant</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape plant</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="is">plant</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (plant)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Block</name>
		<name-loc>Блок</name-loc>
		<description-loc>Блокирующее
Мгновенная версия заклинания Щит – увеличивает ПЗ(DB) объекта для одного броска защиты. Эффекты этого заклинания и заклинания Щит не складываются – используйте большее значение.
Стоимость: 1 за очко ПЗ(DB) (максимум 5).
Требования: Магичность(Magery) 1.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1 per DB</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M166</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (protection)
				<level compare="at least">1</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Detect Poison</name>
		<name-loc>Обнаружить яд</name-loc>
		<description-loc>Областное; Информационное
Определяет наличие ядов и даёт бонус +2 к последующему броску Ядов для определения конкретного вещества. Заклинатель может по желанию исключить некоторые яды из поиска перед сотворением заклинания (например, чтобы искать именно нервнопаралитические яды, или исключить «лёгкие» яды вроде алкоголя). Это также заклинание школы Лечения.
Базовая стоимость: 2.
Время сотворения: 2 секунды.
Требования: Почуять опасность или Проверить пищу.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 250.</description-loc>
		<college>Healing/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area/Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>-</duration>
		<reference>M166</reference>
		<categories>
			<category>Healing</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">sense danger</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">test food</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Magelock</name>
		<name-loc>Волшебный замок</name-loc>
		<description-loc>Обычное; сопротивление заклинанию Повелитель замков
Запирает дверь магией. Дверь не откроется, пока не развеется заклинание (Контрзаклинание или Повелитель замков) или дверь не будет сломана.
Длительность: 6 часов.
Стоимость: 3 сотворение. 2 поддержание.
Время сотворения: 4 секунды.
Требования: Магичность(Magery) 1.
Предмет
Золотой ключ, которым надо коснуться двери. Энергостоимость создания:200.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>6 hrs</duration>
		<reference>M166</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="contains">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Danger</name>
		<name-loc>Почуять опасность</name-loc>
		<description-loc>Информационное
Сообщает заклинателю, есть ли поблизости непосредственная опасность; также может сообщить об отдалённой опасности, если она приближается. Если времени до беды осталось около минуты, ощущается природа опасности; если не больше пяти минут, то появляется только дурное предчувствие (более точное предчувствие возможно только при критическом успехе).
Длительность: мгновенная.
Стоимость: 3.
Требования: Почуять врагов или Чувство опасности.
Предмет
Палочка, посох или украшение. Энергостоимость создания:400.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M166</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">sense foes</name>
			</spell_prereq>
			<advantage_prereq has="yes">
				<name compare="is">danger sense</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Armor</name>
		<name-loc>Броня</name-loc>
		<description-loc>Обычное
Увеличивает Сопротивление повреждениям живых существ. СП(DR), данное этим заклинанием, считается СП(DR), данным бронёй, и складывается с СП(DR), данным бронёй.
Длительность: 1 минута.
Стоимость: 2 за каждое очко СП(DR), вплоть до +5 СП(DR) (10 очков). Половина поддержка.
Требования: Щит.
Предмет:
Это заклинание не накладывается на предметы, но СП(DR) вашей брони может повысить  на 1-5 очков чары Укрепить (M66).</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per DR</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shield</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hardiness</name>
		<name-loc>Твёрдость</name-loc>
		<description-loc>Блокирующее
Мгновенная версия заклинания Броня – увеличивает СП(DR) объекта для одной пропущенной атаки. Эффекты этого заклинания и заклинания Броня не складываются – используйте большее значение. Помните, что за ход можно сотворить лишь Блокирующее заклинание. Например, маг не может сразу же после провала заклинания Железная рука сотворить Твёрдость.
Стоимость: 1 за очко СП(DR) (максимум 5).
Требования: Блок.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1 per DR</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">block</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Nightingale</name>
		<name-loc>Соловей</name-loc>
		<description-loc>Областное
Делает «шумными» дверь или область пола. Дверь громко скрипнет при открывании, клочок земли покроется слоем трескучих веточек, когда по нему кто-нибудь пойдёт, половицы заскрипят ит.д. Эти звуки автоматически сообщат о тревоге заклинателю, если он в зоне слышимости, и возможно, других находящихся вблизи (сделайте бросок ИН(IQ) если недалеко есть другие источники шума).
Длительность: 10 часов.
Базовая стоимость: 2 сотворение. 2 поддержание.
Требования: Почуять опасность.
Предмет
Может быть наложено на область пола или земли, или на ковёр. Энергостоимость создания: 100 за каждый ярд радиуса.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense danger</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sense Observation</name>
		<name-loc>Почуять наблюдение</name-loc>
		<description-loc>Областное
Сообщает заклинателю о том, что за областью ведётся магическое или обычное наблюдение. Проводится быстрое состязание: ИН(IQ) шпиона или эффективное умение сотворившего Информационное заклинание (Слежка, Искатель, Хрустальный шар или заклинания с названием, начинающимся на «Чуять»…) против эффективного умения заклинателя, творящего Почуять наблюдение; если заклинатель выигрывает, ему становится известно, что за областью следят. Критический успех (в состязании) может дать намёк кто или что наблюдает за областью. Если заклинатель попытается найти наблюдателя, значение успеха при состязании может быть добавлено как бонус к броску Искателя, максимальный бонус - +5 (что нейтрализует штраф -5 за отсутствие чего-либо связанного с искомым человеком). Другой возможный вариант развития событий – сотворить Контрзаклинание на шпионящее заклинание; модификаторы больших расстояний не применяются, но налагается штраф -5 за отсутствие субъекта. Почуять наблюдение также можно наложить на живое существо; в этом случае заклинатель может сделать так, чтобы в случае подслушивания оповещался объект, а не он.
Длительность: 1 час.
Базовая стоимость: 1, при сотворении на живое существо – 3. Половина поддержка.
Время сотворения: 5 секунд.
Требования: Почуять опасность или Защита от наблюдения.
Предмет
(а) Палочка, посох или украшение. Энергостоимость создания:300. (б) Украшение или одежда. Действуют всегда. Предупреждает лишь надевшего. Энергостоимость создания:1.500.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1 or 3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">sense danger</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">scryguard</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shield</name>
		<name-loc>Щит</name-loc>
		<description-loc>Обычное
Создаёт перед объектом магический щит, который движется вместе с объектом и защищает его от атак спереди. ПЗ(DB), данная этим заклинанием, складывается с ПЗ(DB), даваемым щитом, но не даёт возможность блокировать, если щита нет. ПЗ(DB) данные Щитом и Блоком (M166) не складываются.
Длительность: 1 минута.
Стоимость: 2 за каждое очко ПЗ(DB), вплоть до +4 ПЗ(DB) (8 очков). Половина поддержка.
Требования: Магичность(Magery) 2.
Предмет:
Это заклинание не накладывается на предметы, но вашу ПЗ(DB) может повысить на 1-5 очков броня с чарой Отражение (M67).</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per DB</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="contains">one college (protection)
				<level compare="at least">2</level>
			</notes></advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<notes compare="is anything"></notes>
				<level compare="at least">2</level>
			</advantage_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Turn Blade</name>
		<name-loc>Повернуть клинок</name-loc>
		<description-loc>Блокирующее
Поворачивает летящий к цели клинок в руке атакующего, меня тип повреждения с режущего на дробящий. Кроме того оружие становится неготовым. Хорошо только против клинкового оружия, бесполезно против копья, булавы или зубов и когтей животного. Это заклинание не считается активной защитой и может быть дополнено обычными Парированием, Блоком или Уклонением. Если заклинание налагается не на заклинателя, то применяются модификаторы больших расстояний, исходя из расстояния между заклинателем и атакующим.
Стоимость: 1.
Требования: Перемещение или Спазм.
Предмет
Браслет или что-то ещё надеваемое на руку. Энергостоимость создания: 300.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spasm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Watchdog</name>
		<name-loc>Сторожевой пёс</name-loc>
		<description-loc>Областное
При наложении на область, это заклинание предупреждает заклинателя о любом проходящем через эту область с враждебными намерениями. Если заклинатель спал, то он просыпается без ошеломления. После срабатывания заклинание не рассеивается, и продолжает функционировать до окончания времени действия.
Длительность: 10 часов.
Базовая стоимость: 1 сотворение. 1 поддержание.
Время сотворения: 10 секунд.
Требования: Почуять опасность.
Предмет
Может быть наложено на область пола или земли, или на ковёр. Энергостоимость создания: 200 за каждый ярд радиуса.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 hrs</duration>
		<reference>M167</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense danger</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Bladeturning</name>
		<name-loc>Отворот клинков</name-loc>
		<description-loc>Обычное
Длительная версия Повернуть клинок – все клинки, атакующие объект поворачиваются, наносят повреждения дробящего типа и становятся неготовыми. При каждой атаке клинком, для того чтобы узнать подействовало ли заклинание, проводите быстрое состязание между ЛВ(DX) атакующего и эффективным умением заклинателя. Как и Повернуть клинок, это заклинание полезно только против клинков. Заметьте, что это заклинание, в отличие от Повернуть клинок, творится на атакуемого, а не на атакующего.
Длительность: 1 минута.
Стоимость: 2. Столько же на поддержание.
Требования: Щит или Повернуть клинок.
Предмет
Палочка, посох, украшение, оружие или броня. Энергостоимость создания: 300.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">shield</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">turn blade</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Catch Missile</name>
		<name-loc>Поймать снаряд</name-loc>
		<description-loc>Блокирующее
Заклинатель ловит один летящий в него снаряд. Умение бросается с модификатором, зависящим от типа снаряда. Сотворение заклинания считается манёвром Парирование. После поимки снаряд считается неготовым. Чтобы поймать метательные заклинания используйте Поймать заклинание.

Тип снаряда
Штраф
Большое метательное оружие (топоры, дротики ит.д.) +4
Метательные ножи +2
Стрелы 0
Иглы духовой трубки, арбалетные болты -5
Пули, сверхзвуковые снаряды Невозможно

Стоимость: 2.
Требования: Отклонить снаряд.
Предмет
Перчатки. Энергостоимость создания: 300.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">deflect missile</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Missile Shield</name>
		<name-loc>Щит от снарядов</name-loc>
		<description-loc>Обычное
Немного отклоняет снаряды, ровно настолько, чтобы они пролетели мимо, игровой смысл в том, что летящие по прямой снаряды промахиваются мимо объекта. Это заклинание действует на все виды снарядов – стрелы, пули, падающие камни, шрапнель, метательные заклинания, торты – на все. Мастер должен как можно дольше скрывать заклинание от врагов заклинателя, сообщая, что они просто промахнулись!
Длительность: 1 минута.
Стоимость: 5 сотворение. 2 поддержание.
Требования: Щит или Перемещение.
Предмет
Палочка, посох, оружие или броня. Энергостоимость создания: 400.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shield</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mystic Mist</name>
		<name-loc>Таинственный туман</name-loc>
		<description-loc>Областное
Создаёт густой молочный туман, сбивающий с толку всех в него входящих; считается, что нельзя различить ничего дальше 2 ярдов, кроме как при помощи Волшебного зрения. Те, кто находился в области до сотворения заклинания, невосприимчивы к его эффектам; они могут видеть его как тусклое мерцание, но он не сбивает их с толку и не влияет на видимость. Другие же. если у них нет проводника, должны бросать против (ИН(IQ)+Устойчивость к магии) каждую секунду, или использовать Волшебное зрение, чтобы не потерять чувство направления и не пойти в случайную выбранную сторону. Чувство направления позволяет избежать этих проблем. Бросок страха совершается при входе в туман и каждые 5 минут в тумане. Любой, проваливший первый бросок страха, войдёт очень неохотно! Опасные животные просто избегают тумана, но, если им придётся войти, они подвергнутся всем эффектам тумана. Находившиеся в тумане до его сотворения получают +1 к броскам защиты, против атаки вошедших в туман; «вошедшие» же получают штраф -1 к броскам защиты, против атаки «находившихся». Это заклинание – отличная защита для лагеря группы. Заклинатель должен сотворить Таинственный туман с собой в центре области. Чем большую область он сможет покрыть тем лучше!
Длительность: 10 часов.
Базовая стоимость: 1. Столько же поддержка.
Время на сотворение: 5 минут.
Требования: Магичность(Magery) 1 и Сторожевой пёс или Щит.
Предмет
(а) Амулет, защищающий надевшего от эффектов Таинственного тумана. Энергостоимость создания: 400. (б) Ходят слухи, что существуют предметы, создающие постоянный Таинственный туман, некоторым образом контролируемый, но больше пока ничего не известно.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>10 hrs</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">watchdog</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">shield</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (protection)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Reflect Gaze</name>
		<name-loc>Отразить взгляд</name-loc>
		<description-loc>Блокирующее; сопротивление по атаке взглядом
Отбивает одну атаку взглядом (в том числе Молниевый взгляд, Заворожить и любую силу требующую контакта глаза в глаза) направленную на объект. Если заклинание успешно, атака взглядом отведена; если успех 10 и более - критический успех и атака перенаправляется на атакующего. Если заклинание провалилось, атака взглядом действует как обычно. Считается, что заклинатель совершает манёвр Парирование. Если объектом заклинания является не заклинатель, применяются обычные модификаторы расстояний.
Стоимость: 2.
Требования: Зеркало.
Предмет
Украшение. Энергостоимость создания: 600, должен включать в себя маленькое зеркальце.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">mirror</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Return Missile</name>
		<name-loc>Обратить снаряд</name-loc>
		<description-loc>Блокирующее
Заставляет один снаряд (в том числе метательное заклинание), летевший в объект, развернуться и лететь в атакующего. Если бросок атакующего «для попадания» удачен, он попадает сам в себя; если нет – он видит, как снаряд летит обратно в него, но не попадает. Считается, что заклинатель выполняет манёвр Парирование. Если объектом заклинания является не заклинатель, применяются обычные модификаторы расстояний.
Стоимость: 2.
Требования: Поймать снаряд.
Предмет
Украшение, оружие или щит. Энергостоимость создания: 400.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">catch missile</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reverse Missiles</name>
		<name-loc>Обратить снаряды</name-loc>
		<description-loc>Обычное
Обращает любую дистанционную атаку (в том числе метательные заклинания) в атакующего. Если бросок атакующего «для попадания» удачен, он попадает сам в себя; если нет – он видит, как снаряд летит обратно в него, но не попадает. Эффект в игре – снаряд отскакивает от объекта заклинания и летит прямо в атакующего.
Длительность: 1 минута.
Стоимость: 7 сотворение. 3 поддержание.
Требования: Щит от снарядов или Силовой купол.
Предмет
Палочка, посох, оружие или броня. Энергостоимость создания:600.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M168</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">missile shield</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">force dome</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Atmosphere Dome</name>
		<name-loc>Атмосферный купол</name-loc>
		<description-loc>Областное
Создаёт мерцающий купол, избирательно проницаемый для различных газов. Он может как выводить определённые газы, так и втягивать. После создания купола, заклинатель определяет желаемое состояние атмосферы; когда желаемое состояние каждого газа достигнуто, купол прекращает влияние на эти газы, пока обстановка внутри него не изменится. Этим заклинанием можно задавать не только состав атмосферы под куполом, но её давление; так что можно менять состав атмосферы, давление атмосферы, или и то и другое. Если какого-то газа на планете нет, то купол не сможет его выработать, он только собирает газы из окружающей атмосферы. Это также заклинание школы Воздуха.
Длительность: 6 часов.
Базовая стоимость: 4 сотворение. Половина поддержка.
Требования: Очистить воздух и Погодный купол.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>6 hrs</duration>
		<reference>M169</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">weather dome</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Iron Arm</name>
		<name-loc>Железная рука</name-loc>
		<description-loc>Блокирующее
Останавливает рукой удар. Если заклинание успешно, рука моментально становится крепче стали и автоматически парирует атакующее оружие без вреда заклинателю. Если заклинание проваливается, заклинатель парирует удар голой рукой! Это заклинание может парировать лишь те атаки, которые можно парировать мечом, и в бою считается манёвром Парирование.
Стоимость: 1.
Требования: Сопротивление боли и ЛВ(DX) не ниже 11.
Предмет
Браслет или что-то другое, надеваемое на руку. Энергостоимость создания: 600.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Blocking</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M169</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">resist pain</name>
			</spell_prereq>
			<attribute_prereq has="yes" which="dx" compare="at least">11</attribute_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Pressure</name>
		<name-loc>Сопротивление давлению</name-loc>
		<description-loc>Обычное
Защищает объект от воздействия давления выше или ниже его родного, действует подобно Устойчивости к давлению (B77) или Устойчивость к вакууму (B96). Заклинатель должен выбрать получаемое преимущество и его уровень на время действия заклинания. Это заклинание больше всего подходит для научно-направленных сеттингов; если же пространство между планетами заполнено обычным воздухом, а дно океана не сильно отличается от дна реки, толку от этого заклинания немного. Сопротивление давлению не даёт возможность дышать в ставшем теперь не смертельном окружении; для таких целей пригодятся заклинания Дышать водой и Задержать дыхание.
Длительность: 1 минута.
Стоимость: Зависит от выбранного преимущества.
Преимущество
Энергостоимость
Устойчивость к давлению 1
2 сотворение; 1 поддержка
Устойчивость к давлению 2
3 сотворение; 2 поддержка
Устойчивость к давлению 3
5 сотворение; 3 поддержка
Устойчивость к вакууму
3 сотворение; 2 поддержка
Требования: Погодный купол.
Предмет
Палочка, посох или украшение. Энергостоимость создания: 900.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M169</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">weather dome</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shade</name>
		<name-loc>Тень</name-loc>
		<description-loc>Обычное
Наводит тень на объект. Тень предотвращает солнечные ожоги и даёт некоторую защиту от жары (снижает температуру на 10°F, если солнце – серьёзный источник жары). Эффект – как от невидимого зонтика. Это заклинание также относится к школе заклинаний Света и тьмы.
Длительность: 1 час.
Стоимость: 1 сотворение. Половина поддержка.
Время сотворения: 10 секунд.
Требования: Постоянный свет или  Щит.
Предмет
Посох или украшение. Действует лишь на носящего. Энергостоимость создания:  100.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M169</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">continual light</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shield</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Weather Dome</name>
		<name-loc>Погодный купол</name-loc>
		<description-loc>Областное
Создаёт мерцающий купол, отражающий любую плохую погоду (вплоть до заклинаний Буря включительно, вулканический пепел, дождь из лягушек и даже летающих насекомых!). Наводнения, оползни и другие подобные катастрофы разрушают купол. Под куполом воздух остаётся свежим, а температура- комфортной для заклинателя. Это также заклинание школы Погоды.
Длительность: 6 часов.
Базовая стоимость: 3 сотворение. 2 поддержание.
Требования: Не меньше двух заклинаний из школы каждого элемента (стихии).</description-loc>
		<college>Protection/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>6 hrs</duration>
		<reference>M169</reference>
		<categories>
			<category>Protection</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Force Dome</name>
		<name-loc>Силовой купол</name-loc>
		<description-loc>Областное
Похоже на Погодный купол, но Силовой купол отталкивает любую физическую силу или метательное заклинание. Ничто не может войти, кроме небольшого количества света чтобы видеть (внутри постоянные сумерки).Также ничто не может покинуть купол кроме света, а если заклинатель захочет, то и свет не сможет выйти. Однако, магия и магические существа и предметы могут проходить сквозь купол как будто бы его и нет. После сотворения Силовой купол ещё формируется в течении секунды, так что у всех, находящихся внутри области заклинания есть один ход чтобы её покинуть.
Длительность: 10 минут.
Базовая стоимость: 3 сотворение. 2 поддержание.
Требования: Магичность(Magery) 1, Погодный купол и Перемещение.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M170</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (protection)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">weather dome</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Force Wall</name>
		<name-loc>Силовая стена</name-loc>
		<description-loc>Обычное
Создаёт мерцающий барьер, который не могут пересечь физические силы и метательные заклинания. Проникнуть могут только свет и неметательные заклинания. Высота Силовой стены – 4 ярда. Повышение стены возможно пропорциональным повышением стоимости (удвойте стоимость для удвоения высоты и т.д.).
Длительность: 10 минут.
Стоимость: 2 очка за каждый ярд длины на сотворение. Столько же поддержка.
Требования: Силовой купол.
Предмет
(а) Посох. Используется только магами. Энергостоимость создания: 300. (б) За 100-кратную стоимость Силовая стена может быть установлена навсегда.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/yd</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M170</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">force dome</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Teleport Shield</name>
		<name-loc>Щит телепортации</name-loc>
		<description-loc>Областное
Любая попытка сотворения Телепортация (или Мерцание) для попадания или покидания зоны действия заклинания получает штраф -5.Проваленная попытка телепортации внутрь зоны имеет обычный эффект. Проваленная попытка телепортации наружу зоны удерживает пытающегося на месте, физически оглушённым и потратившим всю энергию на попытку! Удвоение энергетической стоимости повысит штраф до -10, а утроение – до -15! Это заклинание действует на заклинания Телепортация, Хронопортация, Планарное смещение, Хроносдвиг и на все их вариации.
Это также заклинание школы Врат.
Длительность: 1 час.
Базовая стоимость: 1/3 на сотворение (минимальный радиус 3 ярда). Столько же поддержка.
Время сотворения: 10 секунд.
Требования: Сторожевой пёс и или Щит от заклинаний или Телепортация.
Предмет
Может быть наложено на область пола или земли, или на ковёр или на что-то подобное. Энергостоимость создания: 50 за каждый ярд радиуса.</description-loc>
		<college>Gate/Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M170</reference>
		<categories>
			<category>Gate</category>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">watchdog</name>
			</spell_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">spell shield</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">teleport</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Utter Dome</name>
		<name-loc>Сплошной купол</name-loc>
		<description-loc>Областное
Защищает от физических и магических атак; имеет эффект как при совмещении Силового купола и Пентаграммы. Однако, внутри купола не могут быть призваны никакие существа, и нет возможности досрочного развеивания. Заклинание может быть развеяно Контрзаклинанием или Рассеять магию. Сопротивляется любой попытке взглянуть сквозь него магией. Как и Силовой купол, Сплошной купол после сотворения формируется ещё секунду.
Длительность: 1 минута.
Базовая стоимость: 6 сотворение. 4 поддержание.
Требования: Магичность(Magery) 2, Силовой купол и Щит от заклинаний.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M170</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">force dome</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spell shield</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (protection)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Utter Wall</name>
		<name-loc>Сплошная стена</name-loc>
		<description-loc>Обычное; Сопротивление по пробивающимся заклинаниям
Подобна силовой стене, но защищает от физических и магических атак; эффект как при совмещении Силовой стены и Защита от заклинаний, стена.
Длительность: 1 минута.
Стоимость: 4 за каждый ярд длины на сотворение. Столько же поддержка.
Требования: Сплошной купол и Защита от заклинаний, стена.
Предмет
(а) Посох. Используется только магами. Энергостоимость создания: 1.000. (б) За 100-кратную стоимость Сплошная стена может быть установлена навсегда.</description-loc>
		<college>Protection</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4/yd</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M170</reference>
		<categories>
			<category>Protection</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">utter dome</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spell wall</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Silence</name>
		<name-loc>Тишина</name-loc>
		<description-loc>Областное
Создаёт область тишины. Ни один, находящийся в этой области, ничего не слышит, и ничто, происходящее в области, не производит звуков. Заклинание действует на область, а не на находящихся в ней; любой, покинувший область, снова сможет говорить. В области тишины невозможно сотворить заклинание, требующее произнесения слов или звуков!
Длительность: 1 минута.
Базовая стоимость: 2 сотворение. 1 поддержание.
Требования: Звук.
Предмет
Область можно «заглушить» навсегда; заклинание накладывается на пол или почву, но оно рассеивается, если поверхность, на которую наложено заклинание, разорвана. В качестве переносной «заглушённой» зоны может выступать большой ковёр. Энергостоимость создания: 80 за каждый ярд радиуса, но для всей области надо сотворить лишь одно заклинание.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M171</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sound</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sound</name>
		<name-loc>Звук</name-loc>
		<description-loc>Обычное
Производит какой-либо бессмысленно звук по желанию заклинателя – гул насекомых, далекий лепет голосов, звук  падения, или что-то подобное. Заклинание не может произвести громкий шум. После сотворения заклинания Концентрация не требуется.
Длительность и стоимость: 1 для создания 5-секундного звука; 2 для создания звука, длящегося минуту; 1 за поддержание ещё минуту.
Предмет
Любой. Шумит постоянно (хотя для его включения и выключения часто используют Связь) Энергостоимость создания: 50.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>1/ min</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Varies</duration>
		<reference>M171</reference>
		<categories>
			<category>Sound</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Sound Vision</name>
		<name-loc>Звуковое зрение</name-loc>
		<description-loc>Обычное
Объект видит звуком, как летучая мышь или дельфин, как если бы имел преимущество Сканирование (Радар) (B81). Заклинания Тишина и Стена тишины действуют на объект как заклинание Темнота, а использующий заклинания Молчание или Волшебная бесшумность будет невидим для объекта Звукового зрения. Объект может пользоваться обычным зрением, если хочет, и достаточно светло.
Длительность: 1 минута.
Стоимость: 5 на сотворение. 2 на поддержание.
Требования: Обострённый слух или преимущество Обострённый слух.
Предмет:
Посох, палочка или украшение; действует лишь на надевшего. Энергостоимость создания: 400.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M171</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">acute hearing</name>
				<notes compare="is anything"></notes>
				<level compare="at least">1</level>
			</advantage_prereq>
			<spell_prereq has="yes">
				<name compare="is">keen hearing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Thunderclap</name>
		<name-loc>Гром</name-loc>
		<description-loc>Обычное
Раздаётся один громкий звук, вроде взрыва или раската грома. «Объектом» является точка, которую заклинатель выбрал центром заклинания. На открытой местности каждый в радиусе 3 ярдов должен сделать бросок против ЗД(HT)  или будет оглушён, оглушённый может каждый час делать бросок против ЗД(HT), чтобы прийти в себя. В закрытом помещении (меньше 10 ярдов хоть в одном измерении) увеличьте радиус до 6 ярдов! Заклинатель делает бросок против ЗД(HT)+2.
Стоимость: 2.
Требования: Звук.
Предмет
Перчатки, посох, палочка или украшение. Энергостоимость создания: 300.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M171</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sound</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Garble</name>
		<name-loc>Искажение</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект (живое существо) может произносить лишь бессмысленные звуки; что бы он ни сказал, всё звучит искажённо. Это заклинание может сделать вражеского волшебника беспомощным!
Длительность: 1 минута.
Стоимость: 4 на сотворение. 2 на поддержание.
Требования: Голоса.
Предмет
(а) Одежда или украшение; действует лишь на надевшего. Всегда включено. Энергостоимость создания: 400. (b) Посох или палочка. Применяется лишь магами; надо коснуться объекта. Энергостоимость создания:1,000.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hush</name>
		<name-loc>Молчание</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Объект (живое существо или предмет) не может издать ни звука, ни случайно, ни специально. Прибавьте при броске  3 к умению объекта Скрытность, или отнимите 5 от броска Слуха для присушивающегося. Это заклинание может заглушить вражеского волшебника в бою!
Длительность: 10 секунд, если объект сопротивляется, иначе 1 минута.
Стоимость: 2 на сотворение. 1 на поддержание.
Время сотворения: 2 секунды.
Требования: Тишина.
Предмет
Одежда или украшение; Действует лишь на надевшего. Энергостоимость создания: 200.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 sec#</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">silence</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Imitate Voice</name>
		<name-loc>Имитация голоса</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Изменяет голос объекта, точно имитируя голос известного заклинателю существа (в том числе интонацию и акцент). Если знакомый голос воссоздаётся из памяти, на умение накладывается штраф -2; если заклинатель слышал голос всего несколько раз или давно, штраф -3 и больше (в этом случае помогут Отличная или Фотографическая память). Для того, чтобы определить обмануло ли заклинание кого-то хорошо знающего подделываемый голос, при первой встрече проведите быстрое состязание заклинания против ИН(IQ) слушающего.
Модификаторы: +2 хорошо знакомым с имитируемым голосом; -2 слушателю, не ожидающему подвоха или не прислушивающемуся.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 1 на поддержание.
Требования: Голоса.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Mage-Stealth</name>
		<name-loc>Волшебная бесшумность</name-loc>
		<description-loc>Обычное
Объект может бесшумно двигаться и дышать, но при надобности может говорить. Другие преимущества как при Молчании.
Длительность:1 минута.
Стоимость: 3 на сотворение. 2 на поддержание.
Время сотворения: 3 секунды.
Требования: Молчание.
Предмет
Одежда или украшение; Действует лишь на надевшего. Энергостоимость создания: 500.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hush</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Voices</name>
		<name-loc>Голоса</name-loc>
		<description-loc>Обычное
Создаёт осмысленный звук нормальной громкости – голоса, музыку ит.д. от заклинателя требуется постоянная концентрация.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 2 на поддержание.
Требования: Звук.
Предмет
Любой. Предмет повторяет одно высказывание снова и снова (если только не подвержен заклинанию Связь). Энергостоимость создания: 20 за слово.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sound</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wall of Silence</name>
		<name-loc>Стена тишины</name-loc>
		<description-loc>Областное
Окружает заколдовываемую область стеной, не пропускающей звуки. Находящиеся внутри не могут ни  слышать, ни докричаться до оставшихся снаружи. Сотворение заклинаний, требующих произнесения слов не нарушается.
Длительность: 1 минута.
Базовая стоимость: 2 на сотворение. 1 не поддержание.
Требования: Тишина.
Предмет
Как для Тишины, но стоимость – 100 за каждый ярд радиуса.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M172</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">silence</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Converse</name>
		<name-loc>Разговор</name-loc>
		<description-loc>Обычное
Позволяет заклинателю и объекту заклинания спокойно говорить, не опасаясь подслушивания, даже в шумном окружении (например, на вечеринке). Вне зависимости от окружающего шума собеседники будут слышать каждое слово друг друга. Другие существа в пределах слышимости будут слышать лишь бессмысленный гул разговора. Разговор сопротивляется заклинаниям, блокирующим звук, например Тишине и Шуму.
Длительность: пока поддерживается зрительный контакт.
Стоимость: 2 .
Требования: Магичность(Magery) 1, Искажение и Тишина.
Предмет
Любой. Используется лишь магами. Энергостоимость создания:150.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Indef #</duration>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (sound)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">silence</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">garble</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Delayed Message</name>
		<name-loc>Отложенное сообщение</name-loc>
		<description-loc>Областное
Создаёт устное сообщение, произнесение которого может быть отложено до вхождения в зону действия заклинания определённого человека. Получатель, независимо от шума, слышит сообщение хорошо, остальные сообщение не слышат. Если в области сотворить заклинание Обнаружить магию, оно покажет, что в области висит отложенное сообщение, но больше информации можно получит только при критическом успехе. При критическом успехе становится известным (случайно выбирается из): отправитель, получатель или слова (но не скрытый смысл) сообщения.
Это заклинание не считается «поддерживаемым» - после сотворения заклинатель может забыть о нём.
Длительность: пока не прибудет получатель.
Стоимость: 3 за простое предложение – одна мысль. Не поддерживается.
Время сотворения: 4 секунды.
Требования: Магичность(Magery) 1, Голоса и Почуять жизнь.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>Indef #</duration>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sense life</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (sound)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Far-Hearing</name>
		<name-loc>Удаленный слух</name-loc>
		<description-loc>Информационное
Заклинатель может слышать любой разговор, который он может видеть, не зависимо от расстояния; он может слышать через препятствия толщиной до 6 футов. Он автоматически выполняет проверку слуха. Это также заклинание школы Знаний.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 2 на поддержание.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и четыре других заклинаний Звука. Нельзя при недостатках Глухота или Тугоухость.
Предмет
Одежда или украшение. Действует лишь на надевшего. Энергостоимость: 400.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">sound</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<advantage_prereq has="no">
				<name compare="is">hard of hearing</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<advantage_prereq has="no">
				<name compare="is">deafness</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (sound)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Great Voice</name>
		<name-loc>Великий голос</name-loc>
		<description-loc>Обычное
Объекта могут слышать чётко и ясно все, кого он видит, даже на большом расстоянии. Объект может выбрать тех, кто может его слышать перед тем, как начать говорить (конечно, те, кто находятся в пределах зоны обычной слышимости, будут слышать его в любом случае). Заметьте, что спрятавшись за камень, слышимость не испортить. Это заклинание широко применяется капитанами кораблей, военными командирами и ораторами. Если голос изначально громки, под действием заклинания он может стать раздражающим. Но не оглушит  и не причинит вреда.
Длительность:1 минута.
Стоимость: 3 на сотворение. 1 на поддержание.
Время сотворения: 2 секунды.
Требования: Голоса и Гром
Предмет
Посох, палочка, шлем или украшение; действует лишь на надевшего. Энергостоимость создания: 200.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">thunderclap</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Noise</name>
		<name-loc>Шум</name-loc>
		<description-loc>Областное
Наполняет область бессмысленным, длительным и очень громким шумом. Никто, находящийся в этой области не может разговаривать или слышать другие звуки. Применение любого умения, основанного на ИН(IQ), или рассеяно [distracted](например заклинания), или получает штраф -3 (или и то и другое! по желанию Мастера). Область, на которую наложено заклинание, окружает Стена тишины. Заклинание взаимно резистивно с заклинанием Тишина.
Длительность: 5 секунд.
Стоимость: 4 на сотворение. 2 на поддержание.
Требования: Стена тишины.
Предмет
Область можно навсегда сделать шумной; заклинание накладывается на пол или почву, но оно рассеивается, если поверхность, на которую наложено заклинание, разорвана. В качестве переносной «шумной» зоны может выступать большой ковёр. Энергостоимость создания: 100 за каждый ярд радиуса, но для всей области надо сотворить лишь одно заклинание.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 sec</duration>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">wall of silence</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Sound</name>
		<name-loc>Сопротивление звуку</name-loc>
		<description-loc>Обычное
Объект (личность, существо и предмет) и всё, что он несёт, становится иммунным к звуковым эффектам: Гром их не оглушит, звуковое оружие не причинит вреда, Струя звука не оглушит ит.д. Однако, шум всё ещё может отвлекать. Заклинание популярно на высоких ТУ. Это заклинание также относится к школе Заклинаний защиты и предупреждения.
Длительность: 1 минута.
Стоимость: 2 на сотворение. 1 на поддержание.
Требования: Не меньше 4 заклинаний звука.
Предмет
(а) Любой. Действует лишь на надевшего. Энергостоимость создания: 800. (б) Палочка, посох или украшение. Энергосоимость создания: 1,200.</description-loc>
		<college>Protection/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M173</reference>
		<categories>
			<category>Protection</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">sound</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Sound Jet</name>
		<name-loc>Струя звука</name-loc>
		<description-loc>Обычное
Из пальца выстреливается узкий луч пронзительного звука. Для попадания заклинатель бросает каждый ход против ЛВ(DX)-4 или Природной атаки. От такой атаки можно уклониться или блокировать её, но парировать её нельзя. Заклинание не наносит урона, но каждый поражённый должен сделать бросок против ЗД(HT) минус стоимость заклинания, чтобы избежать оглушения (см. Эффекты оглушения B420) . За каждые пять единиц СП(DR) персонаж получает бонус к ЗД(HT) при проверке +1. Для восстановления оглушённый может каждый ход кидать против ЗД(HT) минус стоимость заклинания.
Длительность: 1 секунда.
Стоимость: От 1 до 4 на сотворение. Столько же на поддержание. Дальность в ярдах равна стоимости .
Требования: Великий голос.
Предмет
Посох, палочка или украшение. Используется только магами. Энергостоимость создания: 400.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>1-4</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>Stuns</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M173</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">great voice</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Invisible Wizard Ear</name>
		<name-loc>Невидимое волшебное ухо</name-loc>
		<description-loc>Обычное
Создаёт Волшебное ухо, которое нельзя увидеть без заклинания Видеть невидимое. Его можно атаковать наугад, но складывающиеся штрафы за его невидимость и малый размер делают это практически невыполнимым.
Длительность: 1 минута.
Стоимость: 5 на сотворение. 3 на поддержание.
Время сотворения: 4 секунды.
Требования: Волшебное ухо и Невидимость.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M174</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">invisibility</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wizard ear</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Message</name>
		<name-loc>Сообщение</name-loc>
		<description-loc>Обычное; Сопротивление по заклинаниям, блокирующим звук
Отсылает объекту звуковое послание. Используйте модификаторы Больших расстояний (M14). Если заклинатель не знает объект, он получает штраф -2. Если заклинатель не знает местоположение объекта, он получает штраф -5 (исправляется успешным применением заклинания Искатель). Эти штрафы складываются. Успешный применение заклинания Слежка даёт бонус +5. Объект слышит сообщение чётко и ясно не зависимо от звуков, его окружающих, но сообщение слышит только он. Тишина, Стена тишины и Шум будут сопротивляться входящему сообщению. Это так же заклинание школы Общения и понимания.
Длительность: Сообщение идёт со скоростью 50миль/час. Если удвоить стоимость удвоится и скорость.
Стоимость: 1 за 15 секунд сообщения.
Время сотворения: Столько же, сколько заклинатель говорит сообщение.
Требования: Великий голос и Искатель.
Предмет
Раковина, в которую надо говорить, концентрируясь на виде объекта и его окружения. Энергостоимость создания: 1,000.</description-loc>
		<college>Communication/Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/15 sec</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Varies</duration>
		<reference>M174</reference>
		<categories>
			<category>Communication</category>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seeker</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">great voice</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Musical Scribe</name>
		<name-loc>Нотный писарь</name-loc>
		<description-loc>Обычное
На время действия заклинания оживляет ручку, которая будет записывать музыкальной грамотой любую мелодию, которую заклинатель будет бурчать, петь или играть на музыкальном инструменте. Заклинатель может настроить ручку не на себя, а на другого человек (или на радио ит.д.). Ручка записывает только музыку; если надо записать текст, это может сделать вторая ручка, под действием заклинания Писарь!
Длительность: 1 минута.
Стоимость: 3 на сотворение. 1 на поддержание. Если бумага не разлинована для записи нот. Увеличьте стоимость сотворения и поддержания на 1, так как ручке приходится кроме записи нот линовать бумагу.
Требования: Писарь.
Предмет
Ручку можно оживить навсегда за 350 очков. Заклинатель может по желанию «направлять» её на тот или иной источник музыки.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3#</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M174</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">scribe</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Scribe</name>
		<name-loc>Писарь</name-loc>
		<description-loc>Обычное
На время действия заклинания оживляет ручку, которая будет записывать всё, что диктует ей заклинатель. Если величина провала при чтении заклинания 1 или 2, ручка будет писать, но с грамматическими ошибками! Поэтому заклинатель должен проверять свою работу. На высоких ТУ это заклинание можно применять к пишущим машинкам, компьютерным клавиатурам и прочим устройствам для письма.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 1 на поддержание.
Требования: Голоса, Танцующий объект и знание письма хотя бы для одного языка на уровне не ниже чем «с акцентом».
Предмет
Ручку можно оживить навсегда за 250 очков. За дополнительные 100 очков энергии (можно и отдельным зачарованием)  заклинатель может настроить ручку на чей-то ещё голос.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M174</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<advantage_prereq has="yes">
				<name compare="is">accented language</name>
				<notes compare="is anything"></notes>
			</advantage_prereq>
			<spell_prereq has="yes">
				<name compare="is">dancing object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Silver Tongue</name>
		<name-loc>Серебряный язык</name-loc>
		<description-loc>Обычное
Даёт объекту преимущество Голос (B97). На существ уже имеющих это преимущество заклинание не действует.
Длительность: 1 минута.
Стоимость: 3 на сотворение. 2 на поддержание.
Требования: Голоса и Контроль эмоций.
Предмет
(а) Посох или палочка. Используется только магами; надо коснуться объекта. Энергостоимость создания: 200. (б) Украшение; на нём должно быть изображение соловья. Всегда включено, действует лишь на надевшего. Энергостоимость создания: 600.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M174</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">emotion control</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">voices</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wizard Ear</name>
		<name-loc>Волшебное ухо</name-loc>
		<description-loc>Обычное
Создаёт копию уха заклинателя, которым он может слышать. Ухо может двигаться, не врезаясь в предметы (как если бы у него было Звуковое зрение), однако оно может различать лишь размер и общую форму коридоров и комнат. Это заклинание может быть сотворено на ранее созданный Волшебный глаз (обычный или невидимый); это не изменит его формы, но даст возможность слышать разговоры и прочие звуки.
Длительность: 1 минута.
Стоимость: 4 на сотворение. 3 на поддержание.
Время сотворения: 2 секунды.
Требования: Перемещение, Удалённый слух и Звуковое зрение.
Предмет
Любое рисованное или скульптурное изображение уха можно превратить в неподвижное Волшебное ухо, таким образом, два носителя амулета в форме уха могут слышать друг друга  независимо от расстояния. Каждое такое Ухо соединено лишь с одним амулетом и наоборот [бред какой-то]. Энергостоимость создания: 450.</description-loc>
		<college>Sound</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M174</reference>
		<categories>
			<category>Sound</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">sound vision</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">far-hearing</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Machine</name>
		<name-loc>Искать механизм/ТУ</name-loc>
		<description-loc>Информационное
Сообщает магу примерное расстояние и направление до любого ближайшего механизма. Заклинатель может уточнить тип искомого устройства: лазеры, компьютеры, источники света и т.д. Любой известный образец технологии может быть исключён из поиска, если маг укажет на них до сотворения заклинания. Используются Модификаторы больших расстояний (M14).
Стоимость: 3.
Время сотворения: 10 секунд.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M175</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Glitch</name>
		<name-loc>Сбой/ТУ</name-loc>
		<description-loc>Обычное; сопротивление по ЗД(HT)
Эквивалент Спазма (M35) для механизмов. Это заклинание вызывает мгновенный сбой в работе механизма. Механизм может выронить то, что держит, потерять какую-то часть, у него может сломаться зубец на шестерёнке или неправильно передаться пакет информации. Изобретательный заклинатель может придумать множество вариантов. Последствия могут быть как просто неприятными (при сотворении заклинания на фонарик), так и смертельно опасными (при сотворении на медробота посреди операции).
Длительность: 1 минута.
Стоимость: 4, не может быть поддержано.
Требования: Контроль механизма.
Предмет
Посох или палочка. Используется только магами; нужно коснуться объекта. Энергостоимость создания: 300.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M176</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">machine control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Machine Control</name>
		<name-loc>Контроль механизма/ТУ</name-loc>
		<description-loc>Обычное
Контроль над действиями одного механизма (любого размере с ИН(IQ) меньше 6) или роя мелких механизмов общим весом не более 100 фунтов или количеством не более 1000. Для контролирования механизма заклинатель должен знать его назначение/функцию. Заклинание не даёт бонуса умению для использования механизма – заклинатель должен применять свои умения Тяжелое оружие, Использование компьютера, Вождение и т.д. Требуется концентрация. Заклинание действует на механические или электрические органы управления механизмом. Маг может использовать заклинание, чтобы камера сделала снимок, робот задушил своего злого создателя, а оружие расстреляло весь боезапас. Он не может двигать или нацеливать объект, если только он не самонаводящийся или самодвижущийся (по крайней мере без применения заклинания Перемещение). Если ещё кто-то контролирует объект (например, ИИ или водитель в автомобиле), то он каждую секунду может перехватить контроль над механизмом в результате быстрого состязания между эффективными уровнями умения заклинателя и умения оператора (или Воли(Will)+ТУ для кибернетического управления). Заклинатель, знающий это заклинание, может творить на механизмы заклинания Наездник или Ментальный Наездник, однако сенсорный аппарат механизма может быть не предназначен для человеческих существ.
Длительность: 1 минута.
Стоимость: 6 сотворение.3 поддержка.
Требования: Определить функцию, Молния и Взлом.
Предмет
Посох, палочка, головной убор или украшение. Энергостоимость создания: 1.000 для создания предмета, контролирующего определённый тип механизмов; 2.000 для создания предмета, контролирующего любые механизмы.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M176</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">reveal function</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">locksmith</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Machine Speech</name>
		<name-loc>Разговор с механизмом/ТУ</name-loc>
		<description-loc>Обычное
Позволяет общаться с любым механизмом (независимо от ИН(IQ)) на родном «языке» механизма. Если язык не звуковой, заклинатель должен поддерживать физический контакт с  портом интерфейса или антенной. Количество полученной информации зависит от ИН(IQ) механизма; механизм с ИН(IQ) меньше 3 вряд ли будет знать что-нибудь интересное. Каждая минута разговора позволяет задать один вопрос и получить ответ на него. Это заклинание также относится к школе заклинаний Общения и Понимания.
Длительность: 1 минута.
Стоимость: 5 сотворение. 3 на поддержка.
Требования: Призыв механизма.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 1.200 для создания предмета, позволяющего общаться с определённым типом механизмов; 5.000 для создания предмета, позволяющего общаться с любым типом механизмов.</description-loc>
		<tech_level></tech_level>
		<college>Communication/Technological</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M176</reference>
		<categories>
			<category>Communication</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">machine summoning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Machine Summoning</name>
		<name-loc>Призыв механизма/ТУ</name-loc>
		<description-loc>Обычное
Призывает один механизм указанного типа (ИН(IQ) меньше 6). Расстояние не влияет на это заклинание. Если заклинание сотворено успешно, то заклинатель знает расположение ближайшего механизма нужного типа,  расстояние до механизма и сколько понадобится времени, чтобы механизм пришёл к нему. Механизм движется к заклинателю на всей возможной скорости, пока не кончится действие заклинания или пока механизм не окажется в непосредственной близи от заклинателя.
Конечно, механизм может быть не приспособлен для прокладывания маршрута, у него может кончиться топливо, энергия и т.д. Например, холодильник на ТУ7 вообще не сможет двигаться. Автомобиль на ТУ7 будет ехать по прямой, невзирая на такие препятствия как пешеходы, ямы и фонарные столбы… Когда механизм достигнет заклинателя он остановится не атакуя его. Если заклинатель или один из его компаньонов атакует механизм, заклинание провалено.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 4 секунды.
Требования: Контроль механизма.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 500 для создания предмета, призывающего определённый тип механизмов; 1.000 для создания предмета, призывающего любые механизмы.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M176</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">machine control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Reveal Function</name>
		<name-loc>Определить функцию/ТУ</name-loc>
		<description-loc>Информационное; Сопротивление по заклинаниям, скрывающим наличие магии
Определяет функцию исследуемого механизма. Если субъект имеет более одной функции, заклинание определяет их по порядку сложности (начиная с простейших) и сообщает заклинателю о наличии дополнительных функций. Повторное сотворение определяет по одной дополнительной функции за сотворение. Также заклинание может быть использовано для того, чтобы определить как активировать одну из известных функций (например, какую кнопку нажать); заклинатель имеет одну попытку со штрафом -5! При успехе заклинатель может использовать механизм, применяя соответствующее умение (или ИН(IQ)-6) получая за незнакомство с этим механизмом штраф всего -1.
Стоимость: 8.
Время сотворения: 10 минут.
Требования: Искать механизм.
Предмет
Посох, палочка или украшение. Энергостоимость создания: 1.500.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 min</casting_time>
		<duration>Instant</duration>
		<reference>M176</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek machine</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Animate Machine</name>
		<name-loc>Анимировать механизм/ТУ</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
Призывает духа (spirit) чтобы оживить механизм к которому прикасается заклинатель. Это заклинание может воздействовать на персонажей с мета-чертой Машина (c.B263), хотя разумные механизмы могут сопротивляться. Призванный дух управляет оживлённым механизмом так, как если бы им управляли обычным образом. Дух контролирует и все электронные и механические приспособления (включая оружие) встроенные в механизм. Дух имеет ЛВ10 и ИН9 с мета-чертами Автомат и Дух (c.B263). Он подчиняется всем приказам заклинателя  и указанного хозяина, но все приказы воспринимает буквально! «Скинь меня у дома» - неудачная команда ожившему вертолёту. В таких случаях бросайте против ИН(IQ) духа, чтобы выяснить понял ли он приказ буквально.
При критическом провале при сотворении заклинания в механизм вселяется демон и пытается убить заклинателя и всех кого сможет достать.  Заклинатель не может изгнать демона, просто не поддерживая заклинание – демон сам тратит свои 15 ЕУ(FP) на поддержку заклинания! В других отношениях демон не отличается от призванного духа.
Длительность: 1 минута.
Базовая стоимость: 8 для машин массой не более тонны, 9 от тонны до двух, 10 от двух до четырёх, 11 от четырёх до восьми, 12 от восьми до 16 тонн, и так далее удваивая максимальную массу механизма за каждое дополнительное очко энергии. Половина для поддержания.
Время сотворения: 1 секунда за каждое требующееся очко энергии.
Требования: Контроль механизма и Анимация или Анимировать объект.


«Любая достаточно развитая технология неотличима от магии»
Артур Чарльз Кларк</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>1 min</duration>
		<reference>M177</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">machine control</name>
			</spell_prereq>
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">animation</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">animate object</name>
				</spell_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Malfunction</name>
		<name-loc>Отказ/ТУ</name-loc>
		<description-loc>Касательное; Сопротивление по ЗД(HT)
Эквивалент Полного паралича  для механизмов. Механизм просто прекращает работать на время действия заклинания (самолёт падает, сенсоры «слепнут» и т.д.). Заклинатель должен коснуться объекта.
Длительность: 1 минута.
Стоимость: 5, не может быть поддержано, требуется пересотворять.
Требования: Магичность(Magery) 2 и Сбой.
Предмет
Посох или палочка. Используется только магами; нужно коснуться объекта. Энергостоимость создания: 2.000.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M177</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">glitch</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Rebuild</name>
		<name-loc>Реконструкция/ТУ</name-loc>
		<description-loc>Обычное
Это заклинание – продвинутая версия заклинания Починить. Заклинание восстанавливает объект даже из отдельного фрагмента. Заклинатель сначала должен успешно сотворить Схему, а затем, пока схема ещё в голове, начать творить Реконструкцию. Для простых объектов Схема необязательна. При достаточном количестве энергии вы можете восстановить звездолёт из куска переборки! Объект восстанавливается со скоростью 500 фунтов утраченной массы в секунду, с момента сотворения заклинания. Так, чтобы восстановить 30-тонный танк понадобится две минуты. Потребность в экзотических материалах может наложить штраф на умение или замедлить восстановление. Модификаторы ТУ игнорируются при восстановлении простых устройств, не являющихся механизмами. Магические предметы не могут быть реконструированы. Это заклинание также относится к школе заклинаний починки и Поломки.
Длительность: постоянно.
Базовая стоимость: 30, если конечная масса объекта не больше 500 фунтов; начальная масса объекта не имеет значения. Добавьте 1 дополнительное очко за каждые дополнительные 500 фунтов конечной массы.
Время сотворения: 1 секунда за каждое требующееся очко энергии.
Требования: Магичность(Magery) 3, Починить, Создать объект и минимум три заклинания каждого элемента. Для сотворения заклинания на механизмы требуется Схема.</description-loc>
		<tech_level></tech_level>
		<college>Making &amp; Breaking/Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>sec=cost</casting_time>
		<duration>Permanent</duration>
		<reference>M177</reference>
		<categories>
			<category>Machine</category>
			<category>Making &amp; Breaking</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">schematic</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create object</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">repair</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Schematic</name>
		<name-loc>Схема/ТУ</name-loc>
		<description-loc>Информационное
Создаёт в уме заклинателя детальную схему механизма. Заклинатель может изучить схему на досуге или проверить напечатанную схему. Однако заклинание не даёт никаких бонусов навыкам; например, чтобы понять схему термоядерной электростанции звездолёта заклинатель должен иметь некоторый уровень умения Инженерия (Термоядерный синтез). Чтобы извлечь толк из схем оружия понадобятся Инженерия или Оружейник. Продолжительность заклинания – время, в течении которого заклинатель помнит схему достаточно ясно. При сотворении заклинатель должен касаться объекта. По желанию схема может отражать как текущее состояние объекта (показывая внутренние повреждения, модификации и износ), так и объект в идеальном состоянии. Второй способ применения заклинания даёт возможность составить схему, имея лишь часть объекта (часть должна весить не менее 5% от общей массы). Например, это позволит восстановить схему устройства Предвестника по его части. В любом случае стоимость сотворения рассчитывается из массы неповреждённого механизма. Даже поддерживаемое заклинание не учитывается при расчёте штрафов. Это заклинание также относится к школе заклинаний Знаний.
Длительность: 1 минута.
Базовая стоимость: 5 для объекта с массой не больше одной тонны, еще по 1 очку за каждую тонну массы. Половина для поддержки.
Время сотворения: 5 секунд.
Требования: Определить функцию и История.
Предмет
Калька или головной убор. Используется только магами; нужно коснуться объекта. Энергостоимость создания: 200.</description-loc>
		<tech_level></tech_level>
		<college>Knowledge/Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>5+1/ton</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M177</reference>
		<categories>
			<category>Knowledge</category>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">reveal function</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">history</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Awaken Computer</name>
		<name-loc>Пробудить компьютер/ТУ</name-loc>
		<description-loc>Обычное
Подобно Пробудить духа изделия это заклинание пробуждает дух компьютера, наделяя его собственным сознанием и разумом. Если на компьютере работает разумная программа, то она попытается сопротивляться; если сопротивление не удалось, то программа «без сознания» на время действия заклинания. ИН(IQ) пробужденного духа компьютера равен его Сложности+5. Дух имеет доступ ко всем базам данных компьютера и периферии, однако он не может считать  данные из баз данных хост-машины. Он имеет такой же доступ к другим компьютерам сети, как и любой работающий на компьютере; его умения Программирование и Использование компьютера равны его ИН(IQ). Дух повинуется заклинателю, но имеет свою волю (также из-за своей натуры он всё понимает очень буквально). Духи компьютера зачастую осень причудливы. Они помнят что произошло в их прошлое пробуждение; между пробуждениями духи существуют, но спят. Если при первом пробуждении духа компьютера произошёл критический провал, дух становится злым и порочным и пытается причинить вред заклинателю и всем, кого сможет достать.  Его Взлом компьютера равен его Сложности; если нет причин сохранить данные, он стирает их все просто потому, что может сделать это.
Длительность: 1 час.
Стоимость: 8 сотворение. 2 поддержка.
Время сотворения: 10 секунд.
Требования: Анимация и Мудрость.
Предмет
Компьютер может быть пробуждён навсегда за стократную стоимость.


Заклинания энергии
«Энергией» считается любая энергия, которую  применяют механизмы для совершения работы. На ТУ8 это обычно означает электричество. На более ранних ТУ может применяться механическая энергия водяной мельницы или пара, а на будущих ТУ может использоваться различная экзотическая энергия. «Топливом» называется любое вещество, расходуемое для получения энергии. Топливом может быть многое от дерева, до антиматерии. ТУ топлива и источника питания является тот, на котором их применяют для питания механизмов. Если топливо имеет несколько ТУ, то при расчётах используйте наиболее удобный заклинателю.  Многие нижеприведенные заклинания требуют конверсии общепринятых единиц энергии в очки магии GURPS. По умолчанию считается, что один киловатт-час (кВт-ч) равен 10 очкам энергии; поэтому 360 киловатт (кВт) равны 1 очко/секунду, а 360 киловатт-секунд (кВт-с) или килоджоуль (кДж) равны 1 очку. Однако, в некоторых сеттингах может быть другая пропорция; заклинания энергии могут стать слишком сильными в сеттингах с реакторами на антиматерии и Мастер может захотеть ослабить их.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M178</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">animation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">wisdom</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Machine Possession</name>
		<name-loc>Вселение в механизм/ТУ</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
То же, что Анимировать механизм, но в механизм вселяется дух самого заклинателя. Механизм должен иметь ИН(IQ) не больше 5. Заклинатель контролирует механизм, как если бы он сам был за рычагами управления. Он имеет полный доступ к памяти механизма и его возможностям, а также может применять все умения и способности механизма, как если бы они были его собственными. Он может использовать свои ментальные способности, но не может физические (это значит, что заклинания могут твориться, только если не требуют речи и жестикуляции). Заклинание позволяет заклинателю использовать свои органы чувств вместе с механическими; иначе заклинатель будет инвалидом – механизмы ТУ6 и ниже обычно глухи и слепы. Во время действия заклинания тело заклинателя лежит без сознания и должно быть под охраной.
Длительность: 1 минута.
Стоимость: 6 сотворение. 3 поддержка.
Время сотворения: 30 секунд.
Требования: Контроль механизма и Ментальный наездник или Ментальный пассажир.
Предмет:
Пара одинаковых украшений, одно из золота, другое из серебра. Заклинатель надевает золотое украшение, а серебряное помещается в механизм. В дальнейшем заклинание может быть сотворено в любое время независимо от расстояния. Если применяется Камень силы (Powerstone), то он находится в золотом украшении. Если одно из украшений сломано, то второе теряет магические свойства. Энергостоимость создания:1.000 за два украшения, каждое украшение должно содержать искусственный драгоценный камень не дешевле $200.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>1 min</duration>
		<reference>M178</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">soul rider</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">rider within</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="starts with">machine control</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Permanent Machine Possession</name>
		<name-loc>Постоянное вселение в механизм/ТУ</name-loc>
		<description-loc>Обычное; Сопротивление по Воле(Will)
То же, что и Вселение в механизм, но дух заклинателя остаётся в механизме пока не решит его покинуть или пока не будет изгнан соответствующим заклинанием (Отменить вселение, Снять проклятие, Контрзаклинание и т.д.). На время действия заклинания жизнь в теле заклинателя приостанавливается (M94). Заклинание рассеивается, если тело заклинателя умирает. Если механизм, в который вселился заклинатель, получает повреждение, заклинатель должен совершить бросок своего ЗД(HT) или его тело получит такое же повреждение. Если механизм «гибнет», то заклинатель должен сделать бросок ЗД(HT) чтобы не погибнуть вместе с ним!
Вдобавок заклинатель должен каждый день кидать Волю(Will), при провале он теряет один пункт ИН(IQ). Заклинатель не должен бросать если его ИН(IQ) уже опустился до ИН(IQ) или Воли(Will) механизма. Потерянные очки атрибутов восстановятся после завершения действия заклинания. Если ИН(IQ) заклинателя опустился до 5, то снять заклинание смогут только заклинания Отменить вселение или Снять проклятье.
Длительность: не определена (может быть постоянной).
Стоимость: 30.
Время сотворения: 5 минут.
Требования: Магичность(Magery) 3 и Вселение в механизм.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Machine</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>30</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 min</casting_time>
		<duration>Indefinite</duration>
		<reference>M178</reference>
		<categories>
			<category>Machine</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">machine possession</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Fuel</name>
		<name-loc>Создать топливо/ТУ</name-loc>
		<description-loc>Обычное
Превращает любую природную субстанцию в основное жидкое или твердое топлива соответствующего ТУ. На ТУ5 камень превратится в уголь, а на ТУ7 – в уран. Другие заклинания энергии (Вытянуть энергию или Украсть энергию) не могут извлекать энергию из магически созданного топлива или механизмов, использующих это топливо.
Длительность: бесконечная.
Стоимость: Значение ТУ на фунт, так топливо ТУ5 будет стоить 5 очков за фунт. Минимальная стоимость очко за фунт.
Время сотворения: 30 секунд.
Требования: Искать топливо и любые два заклинания превращения.
Предмет:
(a)Компьютер может быть пробуждён навсегда за стократную стоимость; используется только магами. Нужно коснуться предметом превращаемого в топливо материала. Энергостоимость создания: 400. (b) Тгель или контейнер, который будет превращать содержимое в топливо. Энергостоимость создания: 100 за фунт дневной выработки контейнера .</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 x TL x lbs</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">transmut</name>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="starts with">seek fuel</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Fuel</name>
		<name-loc>Истинное топливо/ТУ</name-loc>
		<description-loc>Обычное
Превращает обычное топливо в его магический экстракт. Истинное топливо горит в 10 раз дольше обычного и выделяет в 3 раза меньше загрязнения (дым, радиация ит.д.). У транспорта , едущего на Истинном топливе, в 10 раз увеличивается дальность хода; в сеттингах, где магия тайна, это может привести к появлению мифов о 200-мильных карбюраторах (едущих 200 миль на одном галлоне бензина).
Истинное топливо улучшает только топливо для механизмов; если сотворить его на сено и скормить мулу, то ничего не произойдёт.
Другие заклинания энергии (Вытянуть энергию или Украсть энергию) не могут извлекать энергию из Истинного топлива или механизмов, использующих это топливо.
Длительность: бесконечная.
Стоимость: очко за фунт.
Время сотворения: 10 секунд.
Требования: любые шесть заклинаний Энергии.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/lb of fuel</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">energy</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Preserve Fuel</name>
		<name-loc>Консервация топлива/ТУ</name-loc>
		<description-loc>Обычное
Предотвращает порчу топлива. Дрова не гниют, бензин не испаряется, прекращается даже радиоактивный распад в ядерном топливе!
Длительность: 1 неделя.
Стоимость: 4 за каждый фунт топлива, половина на поддержку.
Требования: Проверить топливо.
Предмет
(а) Посох, палочка или украшение. Энергостоимость создания: 400. (b) Ящик или контейнер; всегда действует; содержимое контейнера консервируется на любое время. Энергомстоимость создания: 40 за каждый фунт содержащегося топлива (округлять вверх).</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4/lb of fuel</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 week</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">test fuel</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Purify Fuel</name>
		<name-loc>Очистить топливо/ТУ</name-loc>
		<description-loc>Обычное
Удаляет из топлива все примеси и осадки, делая его вновь пригодным к использованию. Если топливо было полностью испорчено, заклинание удалит примеси… ничего не оставив!
Стоимость: 1/2 на фунт очищаемого материала (минимум 1).
Требования: Очистить воду или Разложение.
Предмет
Посох, палочка или украшение. Нужно коснуться объекта. Энергостоимость создания: 200.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/2 per lb of material</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">purify water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Fuel</name>
		<name-loc>Искать топливо/ТУ</name-loc>
		<description-loc>Информационное
Сообщает направление и примерное расстояние до ближайшего значительного источника топлива. Используйте модификаторы больших расстояний (M14). Любые известные источники  топлива  можно исключить, если заклинатель  напрямую  их  укажет  перед тем, как начнёт.
Стоимость:3.
Время сотворения: 10 секунд.
Предмет:
Тонкий градуированный металлический стержень, указывающий нужное направление и показывающий на шкале примерное количество топлива. Энергостоимость создания: 60.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Power</name>
		<name-loc>Искать электроэнергию/ТУ</name-loc>
		<description-loc>Информационное
Сообщает направление и примерное расстояние до ближайшего значительного источника энергии. Используйте модификаторы больших расстояний (M14). Любые известные источники  энергии  можно исключить, если заклинатель напрямую их укажет  перед тем, как начнёт. Источники энергии неиспользуемые в момент поиска (например батарейка не подключённая к цепи) обнаружить сложнее; удвойте штрафы за расстояние.
Стоимость:3.
Время сотворения: 10 секунд.
Предмет:
Палочка, указывающая нужное направление и светящаяся соответственно важности цели. Энергостоимость создания: 60.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Stop Power</name>
		<name-loc>Остановить энергию</name-loc>
		<description-loc>Областное
Прекращается поток энергии в области, что вызывает остановку всех механизмов. В зависимости от конструкции это может привести или не привести к поломке. Если поломки не произошло, механизм продолжает нормально работать после выхода из зоны действия заклинания.
Длительность: 1 минута.
Базовая стоимость: 3 сотворение. Половина поддержка.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и Искать Электроэнергию.
Предмет:
Палочка или посох, используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">seek power</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Test Fuel</name>
		<name-loc>Проверить топливо/ТУ</name-loc>
		<description-loc>Информационное
Определяет, может ли вещество использоваться как топливо для определённой цели (механизма). Заклинание ничего не сообщает о составе вещества или содержащейся энергии, но сообщает о наличие примесей, осадков и инородных предметов, которые могут помешать нормальной работе; оно детектирует магию.
Стоимость:1 на проверку одного фунта или галлона; 3 на проверку всего топлива в радиусе одного ярда.
Предмет:
Посох, палочка или украшение. Энергостоимость создания: 100.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1 or 3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M179</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Conduct Power</name>
		<name-loc>Проводник энергии/ТУ</name-loc>
		<description-loc>Особое
Превращает заклинателя в проводник энергии, [a link between an active power source and a device in need of it] для связи источника энергии и требующего её устройства. У заклинания два «объекта» : источник энергии и получатель. Штраф за расстояние берется исходя из суммы расстояний от источника энергии до заклинателя и от заклинателя до получателя энергии. Если заклинателю не виден источник или получатель энергии, бросок происходит со штрафом -5; если заклинатель не видит ни одного из объектов, штраф -10!
Одновременно с источником или получателем энергии может быть соединён только один маг или круг магов; если одновременно пытаются присоединиться несколько магов, проводится быстрое состязание Умения между заклинателями, расстояние учитывается.
Максимальная энергия, которую маг может пропустить через себя (ЗД(HT))x(Магичность(Magery) в квадрате)/4, в мегаваттах. Так, маг с ЗД(HT) 10 и Магичность(Magery)ю 2 может без опаски пропускать 10x(2x2)/4 или 10 мегаватт. Если безопасный для мага уровень превышен, он теряет 1 ЕУ(FP) за каждый лишний МВатт (или его часть) и бросает против ЗД(HT). При провале  маг теряет столько ЕЖ(HP), сколько ЕУ(FP) он потерял в этот ход. При критическом провале  происходит Сердечный приступ (смотри Смертельные состояния B429) и маг падает.
Источником для этого заклинания, особенно для его варианта для низких ТУ, не обязательно должен быть источник электроэнергии; заклинание может брать механическую энергию из естественных источников. Однако, энергия должна быть в форме, пригодной для использования механизмами, например водяная мельница подходящий источник, а водопад – нет.
Длительность: 1 минута.
Стоимость: Бесплатное сотворение. 1 поддержка (из-за нагрузки при протекании энергии). Стоимость поддержания не снижается при высоком умении.
Требования: Магичность(Magery) 1 и Искать электроэнергию.
Пример: Заклинание творится на термоядерную электростанцию звездолёта (источник) и на бластер в руке мага (получатель). Пока заклинание поддерживается, электростанция питает бластер. Если маг держит бластер в руке, а электростанция в трёх ярдах под мостиком, на котором стоит маг, то общее расстояние 3 ярда, что даёт штраф -3 за расстояние. Если мостик скрывает электростанцию от мага, это даёт штраф ещё -5 (помните, магу надо смотреть на электростанцию только при сотворении заклинания!!!).</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>0</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M180</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">seek power</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Draw Power</name>
		<name-loc>Получить энергию/ТУ</name-loc>
		<description-loc>Особое
То же, что и Проводник энергии, но получателем энергии является заклинание; волшебник со ЗД(HT) 10 и Магичность(Magery)ю 2 может, используя термоядерную электростанцию, обеспечить себя 28 очками для поддержания магии в секунду. Сначала должно твориться заклинании Получить энергию, которое считается «включённым» при сотворении заклинания-объекта.
Длительность: 1 минута.
Стоимость: Бесплатное сотворение. 1 поддержка (из-за нагрузки при протекании энергии). Стоимость поддержания не снижается при высоком умении.
Требования: Украсть энергию и как минимум по два заклинания из 10 различных школ.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>0</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M180</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<college_count compare="at least">10</college_count>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="starts with">steal power</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lend Power</name>
		<name-loc>Передать электроэнергию/ТУ</name-loc>
		<description-loc>Обычное
Заклинатель тратит энергию, чтобы питать механизмы. Теоретически, магов с помощью этого заклинания достаточно большой круг может питать звездолёт вместе со всем вооружением. Заклинанием нельзя напрямую заряжать батарейки и другие источники энергии, но можно питать устройства, их заряжающие.
Длительность: не определена.
Стоимость: Мастер должен перевести требующуюся устройству энергию в очки магии (M178-179). Минимальная энергостоимость – 1 очко в час; высокий уровень умения не снижает затраты.
Требования: Магичность(Magery) 2 и Искать Электроэнергию.
Предмет
(a) Посох, палочка или украшение. Используется только магами; надо коснуться объекта. Энергостоимость создания: 1.000 (b) Любой механизм может быть зачарован так, чтобы ему мог дать энергию любой желающий маг. Магу не надо знать это заклинание; энергию проводят сами чары. Зачарованный механизм также сможет брать энергию от Камней Силы (Powerstone) и заклинания Поддержать заклинание. Энергостоимость создания: очко за каждые 100 фунтов массы механизма (округлять вверх); минимальная стоимость 250.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Indefinite</duration>
		<reference>M180</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">seek power</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Propel</name>
		<name-loc>Двигатель/ТУ</name-loc>
		<description-loc>Обычное
Позволяет, используя магическую энергию, управлять любыми механизмами, преобразующими энергию или топливо в движение, от газонокосилки до звездолёта. Обычно, это означает транспорт; подробности – B462 Транспорт.
Длительность: 10 минут.
Стоимость: Умножьте МВс (в тоннах) на желаемое Движение (вплоть до Максимальной скорости транспорта), а затем разделите на Умение заклинателя. Минимальная стоимость – одно очко; высокое умение не снижает стоимость. Столько же поддержка.
Требования: Создать топливо и Танцующий объект.
Пример: Маг с умением Двигатель/ТУ7-15 хочет переместить спорткар (B464) на его максимальной скорости Движение 75 (150 миль/час). Спорткар весит 1.8 тонн. Для того, чтобы перемещать спорткар с Движением 75 на время действия заклинания  потребуется (1.8x75)/15=9 очков.
Предмет
(a) Посох, палочка или украшение. Применяется только магами; надо прикоснуться к объекту. Энергостоимость создания: 1.000 (b) Любой двигатель может быть зачарован так, чтобы любой желающий маг мог контролировать его. Магу не надо знать это заклинание, двигатель контролируют сами чары. Зачарованный механизм также сможет брать энергию от Камней Силы [Powerstone] и заклинания Поддержать заклинание. Энергостоимость созданиия: 20 очков за каждую тонну МВс (округлять вверх); минимальная стоимость 200.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>10 min</duration>
		<reference>M180</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="starts with">create fuel</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">dancing object</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Steal Power</name>
		<name-loc>Украсть энергию/ТУ</name-loc>
		<description-loc>Обычное
Заклинатель крадёт энергию из её хранилища (например, батарейки) для восстановления собственных ЕУ(FP).
Стоимость: Заклинатель тратит на восстановление ЕУ(FP) такое же количество процентов украденной энергии, какого уровня у него умение; заклинатель с Умением 15, полностью истощив батарею, потратит на восстановление ЕУ(FP) только 15% очков, заключённых в батарее (если для полного восстановления ЕУ(FP) требуется меньше очков, то меньше). Остальная энергия теряется.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2, Малое лечение и Проводник энергии.
Предмет:
Украшение, палочка или посох. Используется только магами. И маг и предмет должны касаться объекта. Энергостоимость создания:1.000.</description-loc>
		<tech_level></tech_level>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>None</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M180</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">minor healing</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="starts with">conduct power</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Extinguish Radiation</name>
		<name-loc>Ослабить радиацию</name-loc>
		<description-loc>Обычное
Избавляет объект от вредной радиоактивности.
Длительность: навсегда.
Базовая стоимость: 1 за 10 рентген/час.
Требования: Магичность(Magery) 2, Погасить огонь, Землю в воздух и Облучение.
Предмет:
Посох, палочка или украшение. Энергостоимость создания: 1.000.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/10 rads/hr</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M181</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">extinguish fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">earth to air</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">irradiate</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Irradiate</name>
		<name-loc>Облучение</name-loc>
		<description-loc>Областное
Делает область радиоактивной.
Длительность: 1 час.
Базовая стоимость: 1 за 10 рентген/час. Половина поддержка.
Требования: не меньше двух заклинаний Земли и двух заклинаний Огня.
Предмет:
Посох, палочка или украшение. Энергостоимость создания: 300.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/10 rads/hr</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M181</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">earth</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">fire</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Magnetic Vision</name>
		<name-loc>Магнитное зрение</name-loc>
		<description-loc>Обычное
Показывает объекту магнитные поля. Чем поля плотнее, тем они ярче, также видно как они протекают от одного полюса к другому. Если объект имеет умение Физика для ТУ не ниже 6 и на уровне не меньше 12, он сможет оценить силу магнитного поля. Если в пределах одного ярда от объекта нет магнитного предмета сильнее магнита на холодильник, он сможет определить магнитный север. В сочетании с 1.000-кратным Микроскопическим зрением (B68) заклинание даёт возможность читать информацию прямо с магнитного носителя (каждый формат – отдельный язык, который должен быть известен на уровне Родной для беглого чтения).
Длительность: 1 минута.
Стоимость: 2 для сотворения. 1 для поддержания.
Требования: Обострённое зрение [Keen Vision].
Предмет:
Украшение или очки. В предмете должен быть магнит. Действует лишь на надевшего. Энергостоимость создания: 150.</description-loc>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M181</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">keen vision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Radio Hearing</name>
		<name-loc>Радио-слух</name-loc>
		<description-loc>Обычное
Объект может «настроить» слух на радио и микроволновую часть электромагнитного спектра, как при преимуществе Телекоммуникация (Радио)(Только приём, -50%)(B91).
Длительность: 1 минута.
Стоимость: 2 для сотворения. 1 для поддержания.
Требования: Обострённый слух [Keen Hearing].
Предмет:
Украшение (особо подходят серьги). Действует лишь на надевшего. Энергостоимость создания: 150. Некоторые зачарователи создают предметы (обычно раковины, маленькие радио или затычки для ушей), которые преобразуют радиосигналы в звуковые; пользователь настраивается концентрируясь. (выполняя в свой ход действие Концентрация)</description-loc>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M181</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">keen hearing</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>See Radiation</name>
		<name-loc>Видеть радиацию</name-loc>
		<description-loc>Обычное
Подсвечивает все радиоактивные предметы в поле зрения объекта заклинания. Такие предметы светятся пропорционально своей радиоактивности. Предметы, спрятанные под одеждой, за стенами ит.д. светятся пропорционально дозе радиации, проходящей через препятствия. Также становятся видимыми такие заклинания, как Струя Радиации.
Длительность: 1 минута.
Стоимость: 3 для сотворения. 2 для поддержания.
Предмет:
Посох, палочка или украшение. Энергостоимость создания:400.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M181</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Radiation</name>
		<name-loc>Искать радиацию</name-loc>
		<description-loc>Информационное
Сообщает примерное расстояние и направление до ближайшего значительного источника радиации. Также заклинатель может уточнить какой тип излучения он ищет (гамма, нейтронное ит.д.). Любой известный источник излучения может быть исключен из поиска, если заклинатель укажет их до сотворения заклинания. Применяются модификаторы дальних расстояний (M14).
Стоимость: 3.
Время сотворения: 10 секунд.
Требования: Видеть радиацию.
Предмет:
Жезл или палочка, которые укажут направление, в котором расположен источник излучения; и частотой щелчков или пиканий скажут о расстоянии до источника. Энергостоимость создания: 60.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M181</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">see radiation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spectrum Vision</name>
		<name-loc>Спектральное зрение</name-loc>
		<description-loc>Обычное
Даёт объекту возможность воспринимать любую часть электромагнитного спектра, как если бы он обладал преимуществом Гиперспектральное зрение с улучшениями Расширенный нижний диапазон и Расширенный верхний диапазон. Мастер может потребовать от игрока броска различных научных умений дл понимания того, что он видит.
Длительность: 1 минута.
Стоимость: 4 для сотворения. Столько же для поддержания.
Требования: Инфразрение.
Предмет:
Украшение или очки. Предмет должен содержать маленькую призму. Действует лишь на надевшего. Энергостоимость создания: 750.


Заклинания радиации
Радиация коварна; она не невидима, бесшумна, не пахнет. Можно получить смертельную дозу облучения за несколько минут, и ждать смерти неделями – отвратительной, мучительной смерти. Подробнее эффекты облучения человека описаны на B435.
В некоторых обстоятельствах (в частности при заклинании Струя радиации) облучается лишь часть тела жертвы. Эффект такого облучения не совпадает с эффектом облучения той же дозой всего тела. Для оценки эффекта дозу полученную частью тела надо «растянуть» на всё тело: разделите дозу полученную головой или конечностью на 15, торсом – на 8, и на 4 полученную жизненно важными органами.</description-loc>
		<college>Technological/Energy</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M181</reference>
		<categories>
			<category>Energy</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">infravision</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Breathe Radiation</name>
		<name-loc>Облучающее дыхание</name-loc>
		<description-loc>Обычное
Похоже на Струю радиации, только радиация исходит изо рта заклинателя, и заклинание нельзя поддерживать. Для попадания заклинатель бросает против ЛВ(DX)-4 или Природной атаки. Это считается действием, и заклинатель должен стоять лицом к цели. Для  сотворения заклинания  не  требуются  жесты руками; вместо этого совершаются определённые движения губами и языком. Таким  образом, Облучающее дыхание может быть сотворено без рук на любом уровне умения.
Длительность: 1 секунда.
Стоимость: 1-4. Не поддерживается.
Время сотворения: 2 секунды.
Требования:  Магичность(Magery)  2 и Струя радиации.
Предмет
Украшение. Применяется только магами. Энергостоимость создания: 1.200.


Заклинания металла и  пластика
Для этих заклинаний «металл» - любой проводящий материал. А «пластик» - любой искусственный непроводящий, неживой, полимерный материал. Если это не (а) животное, (б) камень/земля/керамика/стекло, (в) вода/простая жидкость, (г) воздух/газ, (д) растение/дерево (живое и нет) или (е) металл, то это – пластик.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M182</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">radiation jet</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Cure Radiation</name>
		<name-loc>Исцеление радиации</name-loc>
		<description-loc>Обычное
Излечивает объект от радиационного заражения; это заклинание выводит радиацию из тела объекта, в том числе и «постоянные» 10% полученной дозы (однако, «постоянная» доза – последняя, которую можно вывести). Уже потерянные ЕЖ(HP), как и другие повреждения, не восстанавливаются, они должны быть излечены другими способами. Это заклинание также относится к школе Лечения.
Длительность: радиация выводится навсегда.
Стоимость: 1 за каждые 10 выведенных из организма рад; минимальная стоимость – 5.
Время сотворения: 30 секунд.
Требования: Сопротивление радиации и Большое лечение.
Предмет:
Палочка или посох. Надо коснуться объекта. Используется только магом или немагом с умением Врачебное дело 20+. Энергостоимость создания: 1.000.</description-loc>
		<college>Healing/Technological</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1/10 Rads</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>30 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M182</reference>
		<categories>
			<category>Healing</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">major healing</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist radiation</name>
				<quantity compare="is">1</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Identify Metal</name>
		<name-loc>Определит металл</name-loc>
		<description-loc>Информационное
Определяет тип металла. Заклинатель должен коснуться металла для определения.
Стоимость: 1.
Требования: Искать землю.</description-loc>
		<college>Technological/Metal</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M182</reference>
		<categories>
			<category>Metal</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek earth</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Identify Plastic</name>
		<name-loc>Определить пластик</name-loc>
		<description-loc>Информационное
Определяет тип пластика. Заклинатель должен коснуться пластика для определения. Полезно для сортировки вторсырья.
Стоимость: 1.
Требования: Искать пластик.</description-loc>
		<college>Technological/Plastic</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M182</reference>
		<categories>
			<category>Plastic</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek plastic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Radiation Jet</name>
		<name-loc>Струя радиации</name-loc>
		<description-loc>Обычное
Из пальца выстреливается невидимая струя радиации. Для попадания заклинатель каждый ход бросает против ЛВ(DX)-4 или Природной атаки. От такой атаки можно уклониться или блокировать её (но только щитом непроницаемым для радиации), но парировать её нельзя. Струя заражает цель человеческих размеров десятью рад за каждое очко вложенное в заклинание. Заклинание также может засветить фотоплёнку, заглушить электронику ит.д.
Длительность: 1 секунда.
Стоимость: от 1 до 3. Дальность в ярдах равна стоимости. Столько же поддержка.
Требования: Облучение и Сопротивление радиации.
Предмет:
Посох или палочка. Используется только магами. Струя испускается из наконечника предмета. Энергостоимость создания: 600.</description-loc>
		<college>Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M182</reference>
		<categories>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">resist radiation</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">irradiate</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Radiation</name>
		<name-loc>Сопротивление радиации</name-loc>
		<description-loc>Обычное
Объект (человек, создание или предмет) и все, что он держит, получают сопротивляемость радиации. Это выражается Степенью защиты (см. B436). Это заклинание также относится к школе Защиты и предупреждения.
Длительность: 1 минута.
Стоимость: 1 за СЗ 10, 2 за СЗ 100, 3 за СЗ 1000.  Половина для поддержания (округлять вверх).
Требования: не меньше трёх заклинаний Радиации.
Предмет:
(а) Любой, действует лишь на носящего. Энергостоимость создания: 1.000.
(б) Палочка, посох или украшение. Энергостоимость создания: 1.000.</description-loc>
		<college>Protection/Technological/Radiation</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M182</reference>
		<categories>
			<category>Protection</category>
			<category>Radiation</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">radiation</college>
				<quantity compare="at least">3</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Plastic</name>
		<name-loc>Искать пластик</name-loc>
		<description-loc>Информационное
Сообщает примерное расстояние и направление до ближайшего значительного объёма пластика. Любой известный объём пластика может быть исключен из поиска, если заклинатель укажет их до сотворения заклинания. Применяются модификаторы дальних расстояний (M14).
Стоимость: 3.
Время сотворения: 10 секунд.
Предмет:
 Палочка, посох или украшение. Энергостоимость создания: 60.</description-loc>
		<college>Technological/Plastic</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M182</reference>
		<categories>
			<category>Plastic</category>
			<category>Technological</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Metal</name>
		<name-loc>Формировать металл</name-loc>
		<description-loc>Обычное
Двигает твёрдый и жидкий металл и придаёт ему форму. Если форма стабильна, она навсегда сохраняется после того. Как её придали. Нестабильная форма держится, только пока действует заклинание – никакой концентрации не требуется – а потом обрушается. Для создания стабильной формы, например навеса, может потребоваться бросок Архитектуры. Твёрдый металл движется этим заклинанием с Движением 1/2; жидкий металл движется вверх на такой же скорости, но гораздо быстрее горизонтально (Движение 4) и вниз (до Движения 10).
Длительность: 1 минута.
Стоимость: 6 (для мягких металлов, например свинца, золота или магния 4). Половина поддержка.
Требования: Магичность(Magery) 1 и либо Формировать землю, либо шесть заклинаний Технологии.</description-loc>
		<college>Technological/Metal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6 or 4</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M182</reference>
		<categories>
			<category>Metal</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<college compare="contains">technological</college>
					<quantity compare="at least">6</quantity>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">shape earth</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Metal</name>
		<name-loc>Тело из металла</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект становится ожившей статуей из металла, временно получая мета-черту Тело из метала (c.B262). Одежда (до 6 фунтов весом) тоже становится металлической, но теряет всякие магические свойства.
Длительность: 1 минута. Заклинание развеивается, если объект теряет сознание.
Стоимость: 12 сотворение. 6 поддержка.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2 и Формировать металл.
Предмет:
Посох, палочка или украшение. Действует лишь на носящего. Энергостоимость создания: 3.000.</description-loc>
		<college>Technological/Metal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>6</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M183</reference>
		<categories>
			<category>Metal</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape metal</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Plastic</name>
		<name-loc>Тело из пластика</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект становится ожившей статуей из пластика, временно получая мета-черту Тело из пластика (см. текст в рамке). Одежда (до 6 фунтов весом) тоже становится пластиковой, но теряет всякие магические свойства.
Длительность: 1 минута. Заклинание развеивается, если объект теряет сознание.
Стоимость: 10 сотворение. 5 поддержка.
Время сотворения: 5 секунд.
Требования: Магичность(Magery) 2 и Формировать пластик.
Предмет:
Посох, палочка или украшение. Действует лишь на носящего. Энергостоимость создания: 2.000.</description-loc>
		<college>Technological/Plastic</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>10</casting_cost>
		<maintenance_cost>5</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M183</reference>
		<categories>
			<category>Plastic</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape plastic</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Metal Vision</name>
		<name-loc>Видеть сквозь металл</name-loc>
		<description-loc>Обычное
Видеть сквозь металл, чтобы узнать что лежит за дверью или в сундуке. Некоторые металлы (свинец) сопротивляются заклинанию или полностью непроницаемы для него. Это также заклинание Знаний.
Длительность: 30 секунд.
Стоимость: 2 за каждые 5 ярдов толщины (максимум 50 ярдов) на сотворение. Столько же поддержка.
Требования: Формировать металл.
Предмет:
Любой. Действует лишь на носящего. Энергостоимость создания: 800.</description-loc>
		<college>Knowledge/Technological/Metal</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per 5 yd</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M183</reference>
		<categories>
			<category>Knowledge</category>
			<category>Metal</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape metal</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Plastic Vision</name>
		<name-loc>Видеть сквозь пластик</name-loc>
		<description-loc>Обычное
Видеть сквозь пластик. Это также заклинание Знаний.
Длительность: 30 секунд.
Стоимость: 2 за каждые 5 ярдов толщины (максимум 50 ярдов) на сотворение. Столько же поддержка.
Требования: Формировать пластик.
Предмет:
Любой. Действует лишь на носящего. Энергостоимость создания: 800.</description-loc>
		<college>Knowledge/Technological/Plastic</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 per 5 yd</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M183</reference>
		<categories>
			<category>Knowledge</category>
			<category>Plastic</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape plastic</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Plastic</name>
		<name-loc>Формировать пластик</name-loc>
		<description-loc>Обычное
Похоже на Формировать металл, но действует на «пластик». Материал движется этим заклинанием с Движением 1/2  или быстрее, если он вязкий или жидкий.
Длительность: 1 минута.
Стоимость: 6 сотворение. 3 поддержка.
Требования: Магичность(Magery) 1 и либо Формировать растение, либо шесть заклинаний Технологии.</description-loc>
		<college>Technological/Plastic</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>6</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M183</reference>
		<categories>
			<category>Plastic</category>
			<category>Technological</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<college compare="contains">technological</college>
					<quantity compare="at least">6</quantity>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">shape plant</name>
				</spell_prereq>
			</prereq_list>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (technological)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Water</name>
		<name-loc>Создать воду</name-loc>
		<description-loc>Обычное
Создаёт чистую воду из ничего. Эта вода может появиться в любой из нескольких форм. Она может появиться в ёмкости или как сфера в воздухе (она сразу падает). Или она может появиться как густой туман из капель; в этой форме, один галлон воды потушит все огни в радиусе одного ярда. Воду нельзя создать внутри врага, чтобы его утопить!
Длительность: Вода создаётся навсегда.
Стоимость: 2 за созданный галлон.
Требование: Очистить воду.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 200.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M184</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">purify water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Purify Water</name>
		<name-loc>Очистить воду</name-loc>
		<description-loc>Особое
Позволяет изъять все примеси из воды, проливая её через любой обруч или кольцо (или, в крайнем случае, собственные пальцы) в ёмкость. Требуется  только один бросок умения, пока поток продолжается.
Длительность: Пока снова не загрязнят.
Стоимость: 1 за каждый очищенный галлон.
Время сотворения: обычно от 5 до 10 секунд на галлон, если не используются большие ёмкость и кольцо.
Требование: Искать воду
Предмет
Обруч из кости. Энергостоимость создания 50.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Special</spell_class>
		<casting_cost>1/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5-10/gal#</casting_time>
		<duration>Permanent</duration>
		<reference>M184</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Coastline</name>
		<name-loc>Искать берег</name-loc>
		<description-loc>Информационное
Сообщает заклинателю направление и приблизительное расстояние до ближайшего берега. Используйте модификаторы больших расстояний (M14). Любой известный берег, например ближайшего острова, можно исключить, если заклинатель специально его укажет при сотворении заклинания.
Стоимость: 3.
Время сотворения: 10 секунд.
Требование: Искать воду.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Instant</duration>
		<reference>M184</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">seek water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Seek Water</name>
		<name-loc>Искать воду</name-loc>
		<description-loc>Информационное
Определяет направление, расстояние, и общую природу ближайшего значительного источника воды. Используйте модификаторы больших расстояний (M14). Любые известные источники воды могут быть исключены, если заклинатель специально их укажет до того, как начнёт. Требуется раздвоенная палка; бросок на -3, если она не доступна.
Стоимость: 2.
Предмет
Раздвоенная палка (может быть костью или вырезана из слоновой кости).
Стоимость создания: 40 энергии и на $300 материал.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<reference>M184</reference>
		<categories>
			<category>Water</category>
		</categories>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Water</name>
		<name-loc>Тело из воды</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Временно даёт объекту мета-черту «Тело из воды» (B262). Одежда (вплоть до 6 фунтов) становится жидкой вместе с ним, а остальные пожитки падают на землю.
Длительность: 1 минута.
Стоимость: 5 сотворение. 2 поддержка.
Время сотворения: 5 секунд.
Требование: Формировать воду
Предмет
(а) Посох, жезл или украшение. Действует только на носителя. Большой недостаток в падении предмета сквозь руку пользователя после активации – таким образом он действует всего минуту. Энергостоимость создания: 1.200. (б) Посох, жезл или украшение. Действует только на носителя. В отличие от предыдущего предмета, оно становится водянистым вместе с носителем, позволяя ему поддерживать заклинание больше чем минуту. Пока предмет водянистый, он теряет все магические силы, которые у него обычно есть. Энергостоимость создания: 2.500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M185</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Destroy Water</name>
		<name-loc>Уничтожить воду</name-loc>
		<description-loc>Областное
Заставляет воду (в любой форме) исчезнуть, оставив вместо себя вакуум – или, возможно, пятна сухих примесей. Если кругом есть ещё вода, она поспешит заполнить дыру. Полезна для сушки вещей, спасения утопающих, и т.д. Нельзя использовать в качестве «обезвоживающей» атаки на противника.
Длительность: Навсегда.
Базовая стоимость: 3. В глубокой воде, область имеет всего 2 ярда в высоту (или глубину). Столько же поддержка.
Требование: Создать воду
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M185</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Foul Water</name>
		<name-loc>Плохая вода</name-loc>
		<description-loc>Областное
Делает воду непригодной для питья. Плохая вода легко узнаётся по её неаппетитным цвету и запаху, в то время как загрязнённое пиво или вино может быть труднее обнаружить. Тот, кто достаточно глуп, чтобы выпить её, должен сделать бросок ЗД(HT). При успехе он  лишь чувствует тошноту и теряет 2 ЕЖ(HP). При провале ему сильно сводит желудок и он теряет 1d+1 ЕЖ(HP); у него -3 ко всем умениям, пока потерянные ЕЖ(HP) не восстановятся. 
Загрязнённая вода также не утоляет жажду, и не может поддерживать рыбу или других водных обитателей (любая рыба медленно задыхается в такой воде; морское млекопитающее заболевает от того, что глотает её). В водоёме, загрязнённая вода со временем растворяется до безвредности; если заклинание, например, сотворить в горном ручье, то оно длится всего секунду или две. 
Базовая стоимость: 3.
Требования: Очистить воду и Разложение.
Предмет
Посох или жезл. Предмет должен коснуться воды. Энергостоимость создания: 100.</description-loc>
		<college>Food/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M185</reference>
		<categories>
			<category>Food</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">decay</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">purify water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Freeze</name>
		<name-loc>Заморозить</name-loc>
		<description-loc>Обычное
Превращает воду в твёрдый лёд. Лёд сохраняет форму контейнера; в открытой воде, лёд замерзает в форме сферы или куба, по желанию заклинателя. Заклинание Формирования воды может быть сотворено на воду до того, как она будет заморожена, или чтобы изменить форму льда после того, как она заморожена.

Длительность: Лёд остаётся пока не растает естественным образом. 
Стоимость: 2 за объект размером с кулак, 4 за размер вплоть до кубического фута, 6 за кубический ярд, ещё 3 за каждый доп. кубический ярд. Если температура выше нуля, то можно поддерживать заклинание за стоимость сотворения каждые 10 минут.
Время сотворения: 10 секунд.
Требование: Формировать воду.
Предмет
Посох, жезл или украшение. Стоимость создания: 200 энергии, синий драгоценный камень за $100.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M185</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Icy Weapon</name>
		<name-loc>Ледяное оружие</name-loc>
		<description-loc>Обычное
Делает любое оружие обжигающе холодным. Это не вредит держателю, но атака этим оружием нанесёт +2 вреда большинству врагов, если преодолеет СП(DR). Умножьте этоу премию на любую уязвимость ко льду или холоду. Добавляйте эту премию к окончательному вреду атаки – например, «проникающая» ледяная атака всё равно нанесёт +2 вреда, а не +4.
Длительность: 1 минута.
Стоимость: 3 сотворение. 1 поддержка.
Время сотворения: 3 секунды
Требование: Создать воду.
Предмет
Оружие, ледянеющее, при применении. Владелец не тратит на это энергию. Стоимость создания:  750 энергии, на $2.000 материала.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M185</reference>
		<notes>+2 freezing damage to melee weapons</notes>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shape Water</name>
		<name-loc>Формировать воду</name-loc>
		<description-loc>Обычное
Придаёт воде (включая лёд или пар) любую форму, и даже двигает её. После того, как форма придана, вода удерживает её без дальнейшего сосредоточения, пока заклинание не закончится. Вода, которую двигают этим заклинанием, передвигается с Движением 3.
Полезная форма – стена воды, как преграда огненным атакам – 20 галлонов создают стену в 2 ярда высотой и 1 ярд шириной. Она остановит Огненный шар и обычный огонь.
Длительность: 1 минута.
Стоимость: 1 за 20 сформированных галлонов. Столько же на поддержку.
Время сотворения: 2 секунды.
Требование: Создать воду.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 400.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1#</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M185</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Umbrella</name>
		<name-loc>Зонтик</name-loc>
		<description-loc>Обычное
Позволяет ходить, при любых лёгких осадках, не намокая. Видно, как невидимый «щит» отклоняет капли. Зонтик не работает против сильного (или магического) града, дождей из камней или лягушек, и т.д.
Также относится к школе Защиты и предупреждения.
Длительность: 10 минут.
Стоимость: 1.
Время сотворения: 2 секунды.
Требование: Формировать воду или Щит.
Предмет
Украшение. Действует всегда. Действует только на носителя. Энергостоимость создания: 100.</description-loc>
		<college>Protection/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 min</duration>
		<reference>M185</reference>
		<categories>
			<category>Protection</category>
			<category>Water</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">shield</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ice Slick</name>
		<name-loc>Гололёд</name-loc>
		<description-loc>Областное
Покрывает пол или землю четвертьдюймовым слоем прозрачного льда. Рисковая опора для ног. Все атаки в рукопашную, и все активные защиты получают -3 на льду. Другие физические умения, включая дальнобойные и метательные оружия, производятся с -2. Даже ходить по льду тяжело – в целом, каждый кто пытается ходить или бегать должен кидать ЛВ(DX)-2 на каждый пройденный ярд. При провале он падает на лёд. Можно с ещё одним броском ЛВ(DX)-2 попытаться встать на следующем ходу. Шипованная обувь устраняет эти штрафы.
Гололёд очень трудно увидеть. Все, кто не высматривает специально на земле лёд, должны кидать Зрение-3, чтобы заметить гололёд до того, как на него наступят.
Гололёд потушит область нормального огня, которая с ним перекрывается, и наоборот.
Длительность: Гололёд существует, пока не растает естественным образом.
Базовая стоимость: 3.
Время сотворения: 2 секунды на ярд радиуса.
Требование: Иней.
Предмет
(а) Коврик или циновка. Стоимость за 10 квадратных футов: 100 энергии, на $250 материала. (б) Посох, жезл или украшение.  Стоимость создания: 250 энергии, синий драгоценный камень за $500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>Permanent</duration>
		<reference>M186</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">frost</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ice Sphere</name>
		<name-loc>Ледяная сфера</name-loc>
		<description-loc>Метательное
Позволяет швырнуть шар льда из руки. При ударе он наносит дробящий вред и рассыпается в водные брызги. Ледяная сфера в 1 куб также может потушить огонь в радиусе ярда, если хорошо прицелиться. Сфера имеет 1/2Д 40, Max 80, Точ 2.
Стоимость: Любая, вплоть до уровня Магических способностей в секунду, на протяжении трех секунд. Сфера наносит 1d вреда за единицу энергии.
Время сотворения: 1-3 секунд.
Требование: Формировать воду
Предмет
Посох или жезл – шар выстреливается из конца предмета. Используется только магами. Энергостоимость создания: 400; Посох или жезл должен иметь на конце сапфир на $500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-Magery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d cr/point</damage>
			<accuracy>2</accuracy>
			<range>40/80</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M186</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Icy Missiles</name>
		<name-loc>Ледяные снаряды</name-loc>
		<description-loc>Обычное
Как Ледяное оружие, но творится на стрелковое оружие. Само оружие становится холодным на ощупь, но не вредит пользователю. Любой выпущенный им снаряд становится обжигающе холодным, нанося +2 вреда большинству противников; он разбивается после того, как попадёт в цель или спустя 10 секунд, в зависимости от того, что произойдёт раньше.
Длительность: 1 минута
Стоимость: 4 сотворение. 2 поддержка.
Время сотворения: 3 секунды
Требование: Ледяное оружие.
Предмет
Оружие, стреляющее ледяными снарядами, без энергетической стоимости для пользователя. Стоимость создания: 1.000; в оружие должен быть вставлен сапфир на $500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M186</reference>
		<notes>+2 freezing damage to missiles fired from weapon</notes>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">icy weapon</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Melt Ice</name>
		<name-loc>Растопить лёд</name-loc>
		<description-loc>Областное
Превращает твёрдый лёд в воду.
Длительность: Навсегда при температуре ниже нуля; иначе 10 минут.
Базовая стоимость: 1 (минимум 2). Ниже нуля стоимость поддержки такая же. 
Время сотворения: 10 секунд.
Требование: Нагреть или Заморозить.
Предмет
Посох, жезл или украшение. Стоимость создания: 300 энергии, на $100 материала.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Perm #</duration>
		<reference>M186</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">freeze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Water</name>
		<name-loc>Сопротивление воде</name-loc>
		<description-loc>Обычное
Объект (личность, существо или предмет) и всё, что он несет, становится неуязвимым к воздействию сырости, оставаясь сухим, даже если будучи полностью погружённым в воду. Это заклинание защищает от сырости пара или льда, но не от обжигания или замерзания! Оно также защищает от подобных воде веществ; например, разлитый напиток не оставляет пятен. Его защита от кислоты ограничена – объект получает 2 СП(DR) от кислоты или погружения в неё.
Также относится к школе Защиты и предупреждения.
Длительность: 1 минута.
Стоимость: 2 сотворение. 1 поддержка.
Требования: или Формировать воду и Уничтожить воду, или Зонтик.
Предмет
(а) Посох, жезл или украшение. Действует постоянно. Действует только на носителя. Стоимость создания: 200 энергии и изумруд на 200$. (б) Посох, жезл или украшение. стоимость создания 400 энергии и изумруд на 200$.</description-loc>
		<college>Protection/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M186</reference>
		<categories>
			<category>Protection</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<name compare="is">shape water</name>
				</spell_prereq>
				<spell_prereq has="yes">
					<name compare="is">umbrella</name>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Snow Shoes</name>
		<name-loc>Снегоступы</name-loc>
		<description-loc>Обычное
Позволяет ходить по снегу или льду, как будто это обычная земля. Заклинание устраняет любые штрафы к движению, ловкости или умениям за лёд или снег. Объект всё ещё подвержен штрафам за неустойчивую поверхность, например раскачивающуюся плавучую льдину или снежную лавину.
Длительность: 1 минута
Стоимость: 2 сотворение. 1 поддержка.
Время сотворения: 2 секунды.
Требование: Формировать воду.
Предмет
Башмаки, сапоги или сандалии. Действует только на носителя. Энергостоимость создания: 350.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M186</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk on Water</name>
		<name-loc>Ходить по воде</name-loc>
		<description-loc>Обычное
Ходить по воде, как с преимуществом Ходьба по жидкости (B97).
Длительность: 1 минута
Стоимость: 3 сотворение. 2 поддержка.
Время сотворения: 4 секунды.
Требование: Формировать воду.
Предмет
Посох, жезл, украшение или одежда. Действует только на носителя. Энергостоимость создания: 500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>4 sec</casting_time>
		<duration>1 min</duration>
		<reference>M186</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Coolness</name>
		<name-loc>Прохлада</name-loc>
		<description-loc>Обычное
Объекту комфортно прохладно в тёплую погоду, что исключает риск обезвоживания и теплового удара – но не солнечных ожогов! Объект получает Устойчивость к температуре 3 (B93) против жары на время действия заклинания. Заклинание не даёт защиты от настоящего пламени или огненных атак.
Также относится к школе Защиты и предупреждения.
Длительность: 1 час.
Стоимость: 2 сотворение. 1 поддержка.
Время сотворения: 10 секунд.
Требование: Охладить.
Предмет
Одежда, посох или украшение. Действует только на носителя. Энергостоимость создания: 200.</description-loc>
		<college>Protection/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>1 hour</duration>
		<reference>M187</reference>
		<categories>
			<category>Protection</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">cold</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Water Jet</name>
		<name-loc>Струя воды</name-loc>
		<description-loc>Обычное
Позволяет выстрелить тонкой струёй воды из пальца. Каждый ход, заклинатель кидает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. От этой атаки можно уклониться или блокировать, но нельзя парировать. Она отбрасывает все цели, и повреждает существа из огня; она может убить или сбить рои летающих существ. Она может погасить область обычного огня радиусом в 1 ярд. Любой, кому попали в лицо Струёй воды получает штраф в -3 к боевым умениям на следующий ход за каждую единицу энергии, вложенную в струю.
Длительность: 1 секунда.
Стоимость: от 1 до 3. Наносит 1d повреждений за каждую единицу энергии, вложенную в неё. Расстояние равно количеству кубиков. 
Требование: Формировать воду.
Предмет
Посох, жезл или украшение. Используется только магами. Если предмет посох или жезл, струя исходит из его вершины. Энергостоимость создания: 600.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>1-3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d cr/point</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M187</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Water Vision</name>
		<name-loc>Видеть сквозь воду</name-loc>
		<description-loc>Информационное
Позволяет видеть сквозь воду, снег и лёд – чтобы найти затонувшие сокровища, прячущихся чудовищ и т.д.
Также относится к школе Знаний.
Длительность: 30 секунд.
Стоимость: 1 за 20 ярдов глубины на сотворение (вплоть до 200 ярдов). Столько же на поддержание.
Требование: Формировать воду.
Предмет
Любой. Энергостоимость создания: 200.</description-loc>
		<college>Knowledge/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>1#</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>30 sec</duration>
		<reference>M187</reference>
		<categories>
			<category>Knowledge</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Whirlpool</name>
		<name-loc>Водоворот</name-loc>
		<description-loc>Областное
Создаёт круглый водоворот в водоёме (озёра, реки, моря, а также пруды и бассейны). Концентрируясь, заклинатель может двигать Водоворот на любое расстояние, вплоть до его  диаметра за секунду. Заклинатель может перемещаться с половинной скоростью, пока концентрируется. 
В центре водоворота есть «воронка», радиус которой (на поверхности) может быть вплоть до половины радиуса водоворота. Глубина воронки может быть до удвоенного радиуса водоворота. Воронка становится уже к низу.
Крайний ярд водоворота имеет Движение 1, внутреннее по отношению к нему кольцо  Движение 2, и так далее. Любого, кто попал в водоворот, будет тянуть на дно; необходимо сделать бросок Плавания, со штрафом равным скорости текущего кольца, каждый оборот, чтобы не быть затянутым в следующее внутреннее кольцо (вдобавок к обычным последствиям провала – B354). Успех на 3 или больше означает, что пловец смог выплыть на одно кольцо наружу (если он этого хочет).
Водоворот мало влияет на существа и предметы, которые весят более 90 фунтов, умноженных на его радиус в ярдах. В водовороте, все основанные на ловкости умения (кроме водных, таких как Плавание и Акваланг) получают штраф -5, сверх любых штрафов за нахождение в воде.
Длительность: 1 минута после достижения максимальной силы.
Базовая стоимость: 2 на сотворение, половина на поддержание.
Время сотворения: Водоворот появляется сразу, но заклинатель должен концентрироваться количество секунд, равное радиусу Водоворота в ярдах, чтобы довести его до полной силы. Водовороту требуется столько же времени на остановку после того, как заклинание закончится, но никакой концентрации на это не требуется.
Требование: Формировать воду.
Предмет
Посох, жезл или украшение. Только для магов. Энергостоимость создания: 200 энергии и  изумруд на $500.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>Varies</casting_time>
		<duration>1 min#</duration>
		<reference>M187</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Ice</name>
		<name-loc>Создать лёд</name-loc>
		<description-loc>Обычное
Создаёт некоторое количество льда или снега. Он может появиться как: твёрдая глыба любой формы; в контейнере (который должен быть достаточно велик); как масса ледяных стружек (отлично подходит для охлаждения напитков); или как облако снега (которое оседает на землю). Требуются 60 галлонов ледяных стружек или снега, чтобы потушить огонь радиусом 1 ярд.
Галлон снега, в зависимости от пушистости (M195), покроет область радиусом в один ярд на глубину от двух до 18 дюймов.
Длительность: навсегда, пока не растает естественным путём.
Стоимость: 2 за каждый галлон льда.
Требование: Заморозить.
Предмет
Посох, жезл или украшение. Стоимость создания: 200 энергии и сапфир за 100$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">freeze</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dehydrate</name>
		<name-loc>Обезвоживание</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT).
Убирает воду из тканей объекта, приводя к вреду или смерти. Действует на всю жертву, если творится на расстоянии; если заклинатель касается объекта, вред ограничен частью тела, к которой коснулись. Броня не защищает!
Длительность: вред остается, пока не будет вылечен.
Стоимость: 1 за 1d-1 вреда, вплоть до 3.
Время сотворения: 2 секунды.
Требования: По меньшей мере пять заклинаний Воды, включая Уничтожить воду. 
Предмет
Жезл или посох. Используется только магами; Предмет должен касаться объекта. Стоимость создания:  700 энергии и на 1.000$ материала.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>1d-1 dehydrate/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="is">water</college>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Dry Spring</name>
		<name-loc>Осушить источник</name-loc>
		<description-loc>Обычное
Осушает и перекрывает поток воды в источнике, уменьшая его силу.
Длительность: навсегда. Но учтите, что местная геология может со временем перемениться, восстановив силу источника до предыдущего уровня.
Стоимость: 3 умножить на уменьшение силы источника, в галлонах в час. 
Время сотворения: 1 минута.
Требования: Уничтожить воду и Формировать землю.
Предмет
Посох. Стоимость создания: 450 энергии, и изумруд за 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ice Dagger</name>
		<name-loc>Ледяной кинжал</name-loc>
		<description-loc>Метательное
Создаёт и метает острую как бритва сосульку. При попадании наносит проникающий вред и мгновенно тает. У неё 1/2Д 30, Max 60, Точ 3.
Стоимость: любое количество вплоть до уровня Магичности в секунду, за 3 секунды. Наносит 1d-1 проникающего вреда за единицу вложенной энергии. Нет доп. эффекта против огненных существ.
Время сотворения: от 1 до 3 секунд.
Требование: Сфера льда или Струя воды.
Предмет
Украшение; предмет должен либо иметь форму кинжала, или быть украшенным кинжалами. Используется только магами. Энергостоимость создания: 400.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-Magery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d-1 imp/point</damage>
			<accuracy>3</accuracy>
			<range>30/60</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">water jet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">ice sphere</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Icy Touch</name>
		<name-loc>Ледяное касание</name-loc>
		<description-loc>Касательное
Покрывает объект льдом. Заклинатель должен коснуться объекта для появления эффекта; место прикосновения неважно. Объект обездвижен, и не может действовать, пока не вырвется изо льда успешным броском СЛ(ST), со штрафом -1 за каждые 1/4 дюйма льда. Лёд можно сколоть снаружи, со скоростью 1/4 дюйма за каждый пункт базового вреда; У него есть СП(DR) 1 за каждые 1/2 дюйма льда. Если спасатели неосторожны, то могут проломить лёд и повредить объект (см. Пробивание, B408).
Будучи закованным в лёд, объект уязвим к тепловому шоку (B430); он должен бросить ЗД(HT) немедленно. В случае успеха, он теряет 1 ЕУ(FP); в случае провала, он теряет количество ЕУ(FP), равное величине провала. Бросок ЗД(HT) необходимо повторять каждую минуту, пока цель остаётся закованной в лёд. Если ситуация становится настолько серьёзной, что объект должен делать проверки на смерть, критический успех означает, что объект впал в спячку, как под действием заклинания Приостановить жизнь.
Длительность: навсегда. Если температура выше нуля, ледяное покрытие можно поддерживать, тратя энергии как на сотворение, каждые 10 минут. 
Стоимость: 2 за каждые 1/4 дюйма льда; Должно действовать на весь объект, а не на его часть! Каждые 1/4 дюйма нанесут 1d-1 вреда огненным существам.
Время сотворения: 1 секунда на 1/4 дюйма льда.
Требования: Магичность(Magery) 1 и минимум четыре заклинания Воды.
Предмет
Посох или жезл. Используется только магами; предмет должен касаться объекта. Кончик предмета должен быть белым. Энергостоимость создания: 800.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec#</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>thr-1 +paralysis</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="is">water</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Walk Through Water</name>
		<name-loc>Проходить сквозь воду</name-loc>
		<description-loc>Обычное
Позволяет проходить сквозь воду или лёд, как будто это воздух; объект может проходить сквозь ледники, по дну озёр и т.д. Как заклинание Плавание, это заклинание убирает штрафы в бою за сражение в воде. В жидкой воде, объекту нужна поверхность, чтобы ходить по ней. Это заклинание может стоить больше, если требуется сопротивление большим давлениям. Заклинание ни открывает проход, которым могли бы последовать остальные, ни открывает, что с другой стороны.… Если заклинатель (или объект) знает заклинание, которое позволит ему дышать, у объекта не будет сложностей с дыханием в это время, без энергостоимости. Иначе, он должен задерживать дыхание!
Если заклинание закончится до того, как объект выйдет на открытый воздух, он обнаружит, что погружён в воду. Автоматически вреда он не получает, но тонет (или задыхается, если во льду), если он не может выбраться.
Длительность: 1 секунда.
Стоимость: 4 сотворение. 3 поддержка.
Время сотворения: 3 секунды.
Требования: Магичность(Magery) 1 и Формировать воду.
Предмет
Одежда или украшение; Действует только на носителя. Энергостоимость создания: 1.100.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M188</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Body of Ice</name>
		<name-loc>Тело изо льда (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Временно даёт мета-черту «Тело изо льда» (B262). Одежда (вплоть до 6 фунтов) также становится льдом, но теряет любые магические силы, которые у неё были.
Длительность: 1 минута. Заканчивается, если объект теряет сознание. 
Стоимость: 7 сотворение. 3 поддержка.
Время сотворения: 5 секунд.
Требования:  Магичность(Magery) 2, Тело из воды и Заморозить.
Предмет
Посох, жезл или украшение. Работает только на носителя. Энергостоимость создания: 1.300.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>3</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">freeze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">body of water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Boil Water</name>
		<name-loc>Вскипятить Воду</name-loc>
		<description-loc>Обычное
Превращает воду в пар. Вода значительно расширяется, переходя из жидкости в газ; всего пинта воды создает очень много пара. Обжигающий эффекта пара таков, что гекс с паром следует рассматривать в точности как гекс с огнём, за тем исключением, что он не может ничего поджечь.
Длительность: навсегда, хотя пар сконденсируется естественным путём (примерно спустя 10 минут).
Стоимость: 2 за объем воды размером с кулак (образует примерно гекс пара), 4 за кубический фут (40 кубических ярдов пара), 6 за квадратный ярд воды до глубины в фут (примерно 400 кубических ярдов пара), 3 за каждую дополнительную треть кубического ярда.
Время сотворения: 10 секунд.
Требования: Формировать воду и Нагреть.
Предмет
Посох, жезл или украшение. Стоимость создания: 200 энергии и сердолик стоимостью 100$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Breathe Water</name>
		<name-loc>Дышать водой</name-loc>
		<description-loc>Обычное
Позволяет объекту дышать водой, как будто это воздух, временно давая преимущество Не дышит (жабры) (B49). Объект не теряет способность дышать обычным воздухом! На усмотрение Мастера, это заклинание может также давать эквивалент Устойчивости к давлению 1 (B77), позволяя объекту забираться глубоко под воду без опасений.
Также относится к школе Воздуха.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка.
Требования: Создать воздух и Уничтожить воду. 
Предмет
Одежда или украшение. Энергостоимость создания: 400.</description-loc>
		<college>Air/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M189</reference>
		<categories>
			<category>Air</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">destroy water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Condense Steam</name>
		<name-loc>Конденсация пара</name-loc>
		<description-loc>Областное
Превращает пар в воду комнатной температуры.
Длительность: навсегда, но вода может снова закипеть. 
Базовая стоимость: 1 (минимум 2).
Время сотворения: 10 секунд.
Требование: Охладить или Вскипятить воду.
Предмет
Посох, жезл или украшение.  Стоимость создания: 300 энергии и изумруд стоимостью 100$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">boil water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">cold</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Water</name>
		<name-loc>Истинная вода</name-loc>
		<description-loc>Обычное
Подобно заклинанию Создать воду, но созданная вода – магически истинная вода. Она тушит любой огонь в той же пропорции, что обычная вода тушит обычный огонь. Она также в три раза лучше утоляет жажду – другими словами, всего кварта Истинной воды обеспечит жидкостью человека на день физически напряжённой деятельности в горячем климате (B426).
Длительность: навсегда, пока её не используют; если её использовать, чтобы потушить огонь, например, образовавшийся пар – это обычная вода. 
Стоимость: 3 за созданный галлон.
Требование: минимум 6 других заклинаний Воды.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 800.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>3/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="is">water</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Frostbite</name>
		<name-loc>Обморожение</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Понижает температуры тканей тела объекта, вызывая повреждения или смерть. Действует на всю цель, если твориться на расстоянии; если сотворено при касании, вред ограничиваются частью тела. Броня не защищает.
Длительность: Вред остаётся пока не будет вылечен. 
Стоимость: 1 за 1d вреда, вплоть до 3.
Время сотворения: 3 секунды.
Требования: Иней и Заморозить.
Предмет
Посох или жезл. Используется только магами; предмет должен касаться объекта. Стоимость создания: 700 энергии, $500 материалов для заклинания, и синий драгоценный камень за 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>Permanent</duration>
		<melee_weapon>
			<damage>1d freezing/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">freeze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">frost</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Snow Jet</name>
		<name-loc>Струя снега</name-loc>
		<description-loc>Обычное
Позволяет выстрелить тонкой струёй снега из пальца. Каждый ход, заклинатель кидает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. От этой атаки можно уклониться или блокировать, но нельзя парировать. Она отбрасывает все цели, и повреждает существа из огня; может убить или сбить рои летающих существ. Может погасить область обычного огня радиусом в ярд. Если заклинание попадает в лицо цели, то временно ослепляет её, если она не выкинет ЗД(HT).
Если бросок ЗД(HT) провален, каждая единица энергии, вложенная в заклинание, ослепляет цель на одну секунду. После возвращения зрения, из-за неясного зрения она получает штраф -3 ко всем боевым умениям ещё на 1d секунд. При критически провале ЗД(HT), цель ослеплена на 1d секунд за каждую единицу энергии, вложенную в заклинание. При успешном броске ЗД(HT), жертва закрывает глаза, и соответственно не может видеть, на одну секунду. При критическом успехе, на жертву заклинание не подействовало.
Длительность: 1 секунда.
Стоимость: от 1 до 3. Наносит 1d отбрасывания за каждую единицу энергии, вложенную в неё. Расстояние равно количеству кубиков. Стоимость поддержания та же.
Требования: Струя воды и Заморозить.
Предмет
Посох или жезл. Используется только магами. Струя исходит из вершины предмета.
Энергостоимость создания: 600; Посох или жезл должен заканчиваться сапфиром стоимостью в 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>1-3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d kb/point - Blinds</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M189</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">freeze</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">water jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Acid</name>
		<name-loc>Создать кислоту</name-loc>
		<description-loc>Обычное
Создаёт сильный раствор кислоты из ничего. Он может появиться в нескольких формах. Он может появиться в ёмкости (которая должна быть из стекла или какого-то особого камня или металла, чтобы кислота его не разъела), как сфера в воздухе (которая немедленно упадёт), или как плотный туман капель (который наносит вред, как разбрызгивание).
Длительность: навсегда, но может быть нейтрализована по мере реакций с предметами и существами. 
Стоимость: 4 за галлон.
Время сотворения: 2 секунды.
Требования: Создать воду и Создать землю.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 300.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M190</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Spring</name>
		<name-loc>Создать источник</name-loc>
		<description-loc>Обычное
Увеличивает силу источника, или создаёт его там, где раньше не было.
Длительность: навсегда. Но учтите, что местная геология может со временем перемениться, уменьшив силу источника до предыдущего уровня.
Стоимость: 5 умножить на увеличение силы источника, в галлонах в час. 
Время сотворения: 1 минута.
Требования: Осушить источник и Формировать воду.
Предмет
Посох. Стоимость создания: 675 энергии, и изумруд за 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>Permanent</duration>
		<reference>M190</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">dry spring</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Create Steam</name>
		<name-loc>Создать пар</name-loc>
		<description-loc>Областное
Создаёт облако пара. Пока оно не рассеется, любой, стоящий в области действия заклинания рискует ошпариться (рассматривайте как окружение огнём, B443-B444, тлько пар не может ничего поджечь). Пар имеет тенденцию подниматься; скорость рассеяния зависит от местности, окружающей температуры и наличия ветра -  в помещении, пар остаётся пока заклинание не закончится, но вне помещений в ветреный или холодный день может продержаться всего около 10 секунд.
Длительность: 5 минут или менее, как описано выше.
Базовая стоимость:  2 сотворение. Невозможно поддержать.
Требование: Вскипятить воду.
Предмет
Посох, жезл или украшение. Стоимость создания: 400 энергии и сердолик стоимостью в  100$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>5 min #</duration>
		<reference>M190</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">boil water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" very_hard="yes">
		<name>Flesh to Ice</name>
		<name-loc>Плоть в лёд (ОС)</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Превращает живой объект (и всё его снаряжение!) в лёд. Камень в плоть может обратить эффект этого заклинания, но заклинатель получает штраф -4, если он не знает Плоть в лёд. Снять проклятье также может разрушить чары.
Длительность:  навсегда, пока не обратит другое заклинание, или произойдёт существенное растопление (или разрушение). 
Стоимость: 12 сотворение; должно воздействовать на весь объект, а не на часть!
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 1, Обморожение и Тело из воды.
Предмет
Посох или жезл. Используется только магами; предмет должен касаться объекта. Энергостоимость создания: 1.200.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M190</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">body of water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">frostbite</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Geyser</name>
		<name-loc>Гейзер (ОС)</name-loc>
		<description-loc>Областное
Вызывает извержение гейзера обжигающей воды из земли. Он создаёт дыру заданного заклинателем радиуса. Все находящиеся внутри гейзера, получают 3d вреда. Их автоматически выталкивает из области действия, и они должны бросить ЛВ(DX)-5, чтобы остаться на ногах!
Через две секунды после появления гейзера обжигающая вода начинает падать обратно мелкими брызгами. В нормальных условиях, она воздействует на площадь вдвое большего радиуса исходного гейзера. Все попавшие под брызги получают 1d вреда в секунду.
Пример: создан гейзер радиусом 2 ярда. Все в этой области получают 3d вреда. Спустя 2 секунды, все в 4 ярдах (кроме исходных 2 ярдов) получают 1d вреда.

Если заклинатель находится в области гейзера, то получает обычный вред, а в области брызг, он остаётся невредим. 
Гейзер всегда должен появляться из земли; он не будет работать на крыше. Сотворённый при необычных обстоятельствах, он может создать интересные эффекты, такие как непрерывный ручей обжигающей воды, текущий под гору на врагов, но это должен контролировать Мастер.
Длительность: 1 секунда.
Базовая стоимость: 5 сотворение. 2 поддержка.
Время сотворения: 5 секунд.
Требования:  Шесть заклинаний школы Воды, включая Создать источник, и либо четыре заклинания школы Земли, либо четыре заклинания школы Огня.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>5</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 sec</duration>
		<reference>M190</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<spell_prereq has="yes">
					<college compare="is">fire</college>
					<quantity compare="at least">4</quantity>
				</spell_prereq>
				<spell_prereq has="yes">
					<college compare="is">earth</college>
					<quantity compare="at least">4</quantity>
				</spell_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<college compare="is">water</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create spring</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Acid</name>
		<name-loc>Сопротивление кислоте</name-loc>
		<description-loc>Обычное
Объект (человек, существо или предмет) и всё, что он несёт, становится неподверженным воздействию кислоты.
Также относится к школе Защиты и предупреждения.
Длительность: 1 минута.
Стоимость:  2 сотворение; 6, если объект должен сопротивляться Истинной кислоте. Половина за поддержку.
Требование: Создать кислоту.
Предмет
(а) Посох, жезл или украшение; действует только на носителя. Энергостоимость создания: 800. (б) Посох, жезл или украшение. Энергостоимость создания: 1.200.
Призыв Элементаля воды, Контроль Элементаля воды, Создание Элементаля воды.
Summon Water Elemental, Control Water Elemental, Create Water Elemental
см. M27-27</description-loc>
		<college>Protection/Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2 or 6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M190</reference>
		<categories>
			<category>Protection</category>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create acid</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Acid Ball</name>
		<name-loc>Кислотный шар</name-loc>
		<description-loc>Метательное
Позволяет бросить шар кислоты из руки. Когда он попадает во что-то, то лопается, нанося кислотный вред. У него 1/2Д 20, Max 40, Точ 1; используйте умение Природная атака. 
Стоимость: любая вплоть до уровня Магичности в секунду, за 3 секунды. Наносит 1d вреда за единицу вложенной энергии. 
Время сотворения: от 1 до 3 секунд.
Требования: Магичность(Magery) 2 и Создать кислоту.
Предмет
Посох или жезл – снаряд выстреливается из вершины предмета. Используется только магами. Энергостоимость создания: 300.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>1-Magery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d cor/point</damage>
			<accuracy>1</accuracy>
			<range>20/40</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Projectile</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M191</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">create acid</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain of Acid</name>
		<name-loc>Кислотный дождь</name-loc>
		<description-loc>Областное
Капли кислоты падают с неба на область действия, нанося 1d-1 вреда кислотой в секунду всем, кто в ней находится. Персонажи и существа под дождём получают вред кислотой в свои ходы; Если менее секунды проведены под дождём, вред делится на два (округлять вниз).
Это заклинание можно сотворить только вне помещений. Броня защищает обычно. Щит с ПЗ(DB) 2 или лучше можно держать над головой, чтобы блокировать капли, но он может получить вред (B484). На это требуются две руки и манёвр Подготовки, и автоматически успешно защищает, как только щит подготовлен вверх, но это делает щит неготовым для его обычных защитных функций!
Кроме того, кислотный дождь разъедает предметы со скоростью 1 ЕЖ(HP) в 10 секунд; СП(DR) предмета полностью защищает его на 3 секунды на единицу СП(DR). Это относится и к зданиям.
Длительность: 1 минута.
Базовая стоимость: 3. Столько же поддержка.
Требования: Магичность(Magery) 2, Создать воду и Создать землю.
Предмет
Посох. Используется только магами. Энергостоимость создания: 1.200.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>3</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 cor</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M191</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">create earth</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Steam Jet</name>
		<name-loc>Струя пара</name-loc>
		<description-loc>Обычное
Позволяет выстрелить тонкой струёй обжигающего пара из пальца. Каждый ход, заклинатель кидает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. От этой атаки можно уклониться или блокировать, но нельзя парировать. Она отбрасывает все цели вдобавок к обычному вреду; она наносит двойной вред существам из огня или льда. Она может погасить область обычного огня радиусом в 1 ярд. Если заклинание попадает в лицо цели, но временно ослепляет её, если она не выбросит ЗД(HT).
Если бросок ЗД(HT) провален, каждая единица энергии, вложенная в заклинание, ослепляет цель на одну секунду. После возвращения зрение, из-за неясного зрения она получает штраф -3 ко всем боевым умениям ещё на 1d секунд. При критическом провале ЗД(HT), цель ослеплена на 1d секунд за каждую единицу энергии, вложенную в заклинание. При успешном броске ЗД(HT), жертва закрывает глаза, и соответственно не может видеть, на одну секунду. При критическом успехе, на жертву заклинание не подействовало.
Длительность: 1 секунда
Стоимость: от 1 до 3. Наносит 1d-1 ошпаривающего вреда за каждую единицу вложенной энергии. Дальность равна количеству кубиков. Стоимость поддержания та же. 
Требования: Струя воды и Вскипятить воду.
Предмет
Посох или жезл. Используется только магами. Струя исходит из вершины предмета. Энергостоимость создания: 700; Посох или жезл должен заканчиваться сердоликом стоимостью 300$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>1-3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d-1 burn/point</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M191</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">boil water</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">water jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Acid Jet</name>
		<name-loc>Струя кислоты</name-loc>
		<description-loc>Обычное
Позволяет выстрелить струёй кислоты из руки. Каждый ход, заклинатель кидает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. От струи можно уклониться, но нельзя парировать или блокировать. Она отбрасывает как Струя снега; если струя попадает в лицо, кислота может ослепить жертву, как описано на странице B428.
Длительность: 1 секунда.
Стоимость: от 1 до 3. Наносит 1d-1 ошпаривающего вреда за единицу вложенной энергии. Дальность равна количеству кубиков. Стоимость поддержания та же. Требования: Магичность(Magery) 2, Струя воды и Создать кислоту.
Предмет
Посох или жезл. Используется только магами. Струя исходит из вершины предмета. Энергостоимость создания: 400.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>1-3</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d-1 cor/point</damage>
			<usage>Jet</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">create acid</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">water jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Breathe Steam</name>
		<name-loc>Паровое дыхание (ОС)</name-loc>
		<description-loc>Обычное
Подобно Струе пара, за тем исключением, что пар выходит изо рта заклинателям, Паровое дыхание невозможно поддерживать, и каждая единица энергии дает 1d вреда, а не 1d-1. Заклинатель кидает ЛВ(DX)-2 или умение Природной атаки. Это считается атакой; от неё можно уклониться или блокировать, но её нельзя парировать. Заклинатель должен стоять лицом к цели. Чтобы творить это заклинание не требуются жесты руками; вместо этого делаются определённые движения губами и языком. Таким образом, Паровое дыхание можно творить «без рук» на любом уровне.
Длительность: 1 секунда.
Стоимость: от 1 до 4. Невозможно поддерживать.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 1, Струя Пара и Сопротивление огню. 
Предмет
Украшение. Используется только магами. Стоимость создания: 1.000 энергии и сердолик стоимостью 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d burn/point</damage>
			<usage>Breath</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Breath</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">resist fire</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">steam jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Essential Acid</name>
		<name-loc>Истинная кислота (ОС)</name-loc>
		<description-loc>Обычное
Превращает обычную кислоту в магическую истинную кислоту. Ни одно вещество не устойчиво к её разъеданию, и она наносит в три раза больше вреда, прежде чем нейтрализоваться. Истинная вода или Пламя, в подобных количествах, аннулируют Истинную кислоту. Если её заморозить заклинанием Заморозить, она безобидна, пока не растает.
На усмотрение Мастера, это заклинание может создавать алкахест (M220).
Длительность: навсегда, пока она не нейтрализуется.
Стоимость: 8 за галлон.
Требования: Магичность(Magery) 3 и все шесть заклинаний Кислоты. 
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 1.100.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>8/gal</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Permanent</duration>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">acid ball</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">acid jet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create acid</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">rain of acid</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist acid</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">spit acid</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Icy Breath</name>
		<name-loc>Ледяное дыхание (ОС)</name-loc>
		<description-loc>Обычное
Заклинатель испускает смертоносный град льда и холодного воздуха изо рта. Заклинатель бросает ЛВ(DX)-4 или умение Природная атака, чтобы попасть. Это считается атакой; от неё можно уклониться или блокировать, но её нельзя парировать. Заклинатель должен стоять лицом к цели. Чтобы творить это заклинание не требуются жесты руками; вместо этого делаются определённые движения губами и языком. Таким образом, Ледяное дыхание можно творить «без рук» на любом уровне.
Длительность: 1 секунда.
Стоимость: от 1 до 4. Наносит 1d+1 вреда за вложенную единицу энергии. Невозможно поддерживать. 
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 1, Струя снега и Сопротивление холоду.
Предмет
Украшение. Используется только магами. Стоимость создания: 400 энергии и сапфир стоимостью 500$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d+1 freezing/point</damage>
			<usage>Breath</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Breath</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">1</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">1</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">snow jet</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist cold</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain Ice Daggers</name>
		<name-loc>Дождь ледяных кинжалов</name-loc>
		<description-loc>Областное
Ледяные кинжалы падают с неба на область действия, нанося 1d-2 пронзающего вреда в секунду всем находящимся в ней. Персонажи и существа под Дождём ледяных кинжалов получают вред в свой ход; если менее секунды было проведено в области действия, вред делятся на два (округлять вниз).
Это заклинание можно сотворить только вне помещений. Броня защищает обычно. Щит с ПЗ(DB) 2 или лучше можно держать над головой, чтобы блокировать лёд, но он может получить повреждения (B484). На это требуются две руки и манёвр Подготовки, и автоматически успешно защищает, как только щит подготовлен вверх, но это делает щит неготовым для его обычных защитных функций!
Неподвижные предметы вроде зданий защищают своим СП(DR).
Длительность: 1 минута.
Базовая стоимость: 1 (минимум 2). За удвоенную базовую стоимость вред 1d в секунду!
Требования: Магичность(Magery) 2, Град и Ледяной кинжал.
Предмет
Посох. Используется только магами. Стоимость создания: 800 энергии и сапфир стоимостью в 1.000$.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-2 imp</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">ice dagger</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">hail</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spit Acid</name>
		<name-loc>Плевок кислотой (ОС)</name-loc>
		<description-loc>Обычное
Подобно Струе кислоты, за тем исключением, что кислота выходит изо рта заклинателя, Плевок кислотой невозможно поддерживать, и каждая единица энергии дает 1d вреда, а не 1d-1. Заклинатель кидает ЛВ(DX)-2 или умение Природной атаки (M201). Это считается атакой; от неё можно уклониться или блокировать, но её нельзя парировать. Заклинатель должен стоять лицом к цели. Чтобы творить это заклинание не требуются жесты руками; вместо этого делаются определённые движения губами и языком. Таким образом, Паровое Дыхание можно творить «без рук» на любом уровне.
Длительность: 1 секунда.
Стоимость: от 1 до 4. Невозможно поддерживать.
Время сотворения: 2 секунды.
Требования: Магичность(Magery) 3, Струя кислоты и Сопротивление кислоте.
Предмет
Украшение. Используется только магами. Энергостоимость создания: 400.</description-loc>
		<college>Water</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d cor/point</damage>
			<usage>Breath</usage>
			<reach>1/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Breath</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M192</reference>
		<categories>
			<category>Water</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">3</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery one college (water)</name>
					<level compare="at least">3</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">resist acid</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">acid jet</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Fog</name>
		<name-loc>Туман</name-loc>
		<description-loc>Областное
Создает в области густой туман. Видимость в тумане составляет 1 ярд. Огненные оружие и метательные снаряды теряют свою дополнительную мощь в тумане. Огненный шар теряет 1 единицу урона за ярд тумана, который необходимо преодолеть (например, 3d Огненный шар пересекает 5 ярдов тумана и наносит 3d-5 ущерба), в то же время жертвы взрыва Огненного шара, могут рассчитывать каждый ярд тумана как 2 ярда от взрыва. Однако никакое количество тумана не может потушить огонь.
Это также заклинание Воды.
Длительность: 1 минута.
Стоимость: 2 сотворение. Половина поддержка.
Требование: Формировать Воду.
Предмет
Посох, жезл или украшение.
Энергостоимость создания: 300.</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M193</reference>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Frost</name>
		<name-loc>Иней</name-loc>
		<description-loc>Областное
Покрывает инеем все поверхности в области действия заклинаний. Иней является настоящим, и длится бесконечно долго, пока температура ниже нуля. В более теплых условиях, быстро таит, образуя росу. Если бросить сверху реальный или магический огонь, иней становится облаком пара и вызывает яркий свет со свистом на несколько секунд. На самом деле, достаточно крошечного огня – спичка или свеча – чтобы заклинание Иней перестало работать.
Если использовать заклинание Иней на огненный элементаль или другое огненное создание, то оно наносит 1 единицу урона, но это скорее разозлит создание, чем прогонит.
Это также заклинание Воды.
Длительность: иней длится до тех пор, пока не растает.
Стоимость: 1.
Требование: Создание Воды или Охладить.
Предмет
Посох, жезл или украшение.
Энергостоимость создания: 200, $350 голубой камень.</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Indef</duration>
		<reference>M193</reference>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="no">
			<spell_prereq has="yes">
				<name compare="is">cold</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">create water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Predict Weather</name>
		<name-loc>Предсказать погоду</name-loc>
		<description-loc>Информационное
Прогноз погоды для данного места через заданное время. Этот прогноз не принимает во внимание магическое вмешательство или предсказания других магов!
Это также заклинание Воздуха.
Стоимость: 2 за промежуток времени предсказания, в днях. Двойная стоимость за область вне пределов данного района (скажем, за горизонтом). Учетверенная стоимость за область на другом континенте. Это заклинание не может предсказать погоду на планете или астральном плане, отличном от того, в котором находится заклинатель.
Время сотворения: 5 секунд за день предсказания.
Требование: Как минимум четыре заклинания Воздуха.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Info</spell_class>
		<casting_cost>Varies</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>Instant</duration>
		<reference>M193</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Clouds</name>
		<name-loc>Облака</name-loc>
		<description-loc>Областное
Создает или рассеивает обычный облачный покров, на выбор заклинателя.
Это также заклинание Воздуха.
Длительность: 10 минут, после чего облака уходят или возвращаются, если заклинание не поддерживается.
Стоимость: 1/20 (минимум 1). Столько же на поддержание.
Время сотворения: 10 секунд.
Требование: Как минимум два заклинания Воды и два заклинания Воздуха.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/20</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>10 sec</casting_time>
		<duration>10 min</duration>
		<reference>M194</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">2</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Current</name>
		<name-loc>Течение</name-loc>
		<description-loc>Специальное; Областное
Влияет на течения любого большого количества воды. Каждое наложение заклинания, может сдвинуть течение на 22,5 градуса или изменить скорость на 1 миль/ч (или узел). Для достижения комбинации изменения направления и скорости, или более мощного изменения в одном или другом, стоимость увеличивается пропорционально.
Заклинание может быть наложено на площадь, влияя на течение, протекающее на глубине до 40 ярдов.  Также заклинание может быть наложено на объект, например корабль, который должен быть охвачен во всей его полноте. Область действия перемещается вместе с объектом.
Это также заклинание Воды.
Длительность: 1 час.
Стоимость: 1/50 (минимум 1). Столько же на поддержание.
Время сотворения: 1 минута.
Требование: Как минимум шесть заклинаний Воды.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Special/Area</spell_class>
		<casting_cost>1/50</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M194</reference>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Tide</name>
		<name-loc>Прилив</name-loc>
		<description-loc>Специальное; Областное
Каждое наложение этого заклинания может повысить или понизить уровень воды на один фут; для более крупных изменений, стоимость увеличивается пропорционально.
«Холм воды» созданный таким образом распространяется органично в области действия, опускаясь на один фут на каждый ярд за пределами фактической области заклинания. Заклинание может быть наложено на площадь, влияя на предметы затронутые приливом. Также заклинание может быть наложено на объект, например корабль, который должен быть охвачен во всей его полноте. Область действия перемещается вместе с объектом.
Это также заклинание Воды.
Длительность: 1 час.
Стоимость: 1/50 (минимум 1). Столько же на поддержание.
Время сотворения: 1 минута.
Требование: Как минимум восемь заклинаний Воды.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 225</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Special/Area</spell_class>
		<casting_cost>1/30</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M194</reference>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">water</college>
				<quantity compare="at least">8</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Waves</name>
		<name-loc>Волны</name-loc>
		<description-loc>Специальное, областное.
Изменение состояния поверхности любого большого количества воды. Каждое наложение заклинания может увеличить или уменьшить высоту волны на один Балл шкалы Бофорта (см. выше); чтобы добиться изменения нескольких баллов, умножьте на них стоимость. Ветер не влияет. Следует отметить, что шкала Бофорта для океанских волн; волны, созданные на берегах озера, обычно, намного ниже, относительно скорости ветра (на усмотрение Мастера).
Заклинание может быть наложено на площадь, влияя на вещи пересекающие её. Также заклинание может быть наложено на объект, например корабль, который должен быть охвачен весь (обычно, 10-30 ярдов в радиусе). Область действия перемещается вместе с объектом.
Это также заклинание Воды.
Длительность: 1 час.
Стоимость: 1/60 (минимум 1). Столько же на поддержание.
Время сотворения: 1 минута.
Требование: Формировать Воду.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Special/Area</spell_class>
		<casting_cost>1/60</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M194</reference>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">shape water</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Cool</name>
		<name-loc>Похолодание</name-loc>
		<description-loc>Областное
Понижает температуру окружающего воздуха в области. Это может вызвать туман, если позволяют условия. Заклинание не может понизить температуру ниже -40.
Это также заклинание Воздуха.
Длительность: 1 час.
Время сотворения: 1 минута на 1 единицу энергии вложенного в заклинание.
Стоимость: 1/10 (минимум 1). Каждое сотворение понижает температуру окружающей среды  на 10F(12C).
Требование: Охладить и как минимум четыре заклинания Воздуха.
Предмет
Посох. Используется только магами.
Энергостоимость создания: 150.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/10</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">cold</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Hail</name>
		<name-loc>Град</name-loc>
		<description-loc>Областное.
Создает град. Температура должна быть чуть выше нуля. Главный эффект – подвергнуть интенсивному разрушению любое живое существо, на которое обрушился град; маг должен бросать кубик Воли(Will) каждую секунду, чтобы поддерживать концентрацию. При сотворении града стоимостью 5, Мастер может позволить реально большие градины, наносящие 1d-2 дробящего урона в секунду.
Это также заклинание Воды.
Длительность: 1 минута.
Стоимость: 1/5 (минимум 1). Для разрушительных градин, стоимость 1. Столько же на поддержание.
Требование: Снег
Предмет
Посох. Используется только магами. Энергостоимость создания: 500.</description-loc>
		<college>Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/5#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-2 cr</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M195</reference>
		<notes>base cost 1 for damaging hail</notes>
		<categories>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">snow</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Rain</name>
		<name-loc>Дождь</name-loc>
		<description-loc>Областное
Создает (или предотвращает) 1 дюйм дождя в обычных условиях.
Это также заклинание Воздуха и заклинание Воды.
Длительность: 1 час.
Стоимость: 1/10 (минимум 1). Стоимость сотворения дождя может быть удвоена в пустыне или на другой территории (на усмотрение Мастера) где дождь не свойствен. Стоимость для предотвращения дождя удваивается в естественных для дождя условиях или болотной местности. Столько же на поддержание.
Время сотворения: 1 минута.
Требование: Облака.
Предмет
Посох или палочка. Используется только магами. Предмет должен храниться в воде, если не используется; он теряет свою силу, если остается сухим более чем на час.
Энергостоимость создания: 600</description-loc>
		<college>Air/Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/10#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">clouds</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Snow</name>
		<name-loc>Снег</name-loc>
		<description-loc>Областное
Создает (или предотвращает) 1 дюйм снега в обычных условиях. Для работы должны образом, это заклинание необходимо колдовать при температуре 32°F (0°C) и ниже. Если это заклинание колдуется в более теплых условиях, то оно призывает моросящий дождь, который увлажняет землю, но не оставляет каких-либо значительных луж.
Это также заклинание Воздуха и заклинание Воды.
Длительность: 1 час.
Стоимость: 1/15 (минимум 1). Каждые дополнительные 1/15 единиц энергии на ярд радиуса увеличивает количество снега на 1 дюйм в час. Столько же на поддержание.
Требование: Облака и Иней.
Предмет
Посох. Используется только магами. Предмет должен храниться в холоде, если не используется; он теряет свою силу, если находится под воздействием температуры 90°F (32°C) более чем два часа. Столько же на поддержание. Энергостоимость создания: 450.</description-loc>
		<college>Air/Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/15#</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">frost</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">clouds</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Storm</name>
		<name-loc>Шторм</name-loc>
		<description-loc>Областное
Создает или рассеивает шторм. В зависимости от окружающей температуры и влажности, он может стать просто штормовым ветром или включать в себя дождь, снег или град – случайные молнии, также. Это особенно эффективно на море. Заклинание является непредсказуемым по своему воздействию (что позволяет Мастеру решить, что делает шторм… ).
Заклинание может также использоваться для того, чтобы развеять шторм; эффективность заклинания зависит от размеров заколдованного района, в соотношении с естественной территорией шторма.
 Продолжительность: 1 час.
Базовая стоимость: 1/50 (минимум 1). Столько же  поддержка.
Требование: Дождь и Град.
Предмет
Посох. Используется только магами.
Энергостоимость создания: 1.000.</description-loc>
		<college>Air/Water/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/50</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Water</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">hail</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">rain</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Warm</name>
		<name-loc>Потепление</name-loc>
		<description-loc>Областное
Поднимает температуру окружающего воздуха в области. Это может быть использовано для рассеивания Тумана, например. Заклинание не может поднять температура выше 100F(38°C).
Это также заклинание Воздуха.
Длительность: 1 час.
Время сотворения: 1 минута на 1 энергию в заклинании.
Стоимость: 1/10 (минимум 1). Каждое сотворение повышает температуру окружающей среды  на 10F(12C).
Требование: Нагреть и как минимум четыре заклинания Воздуха.
Предмет
Посох. Используется только магами.
Энергостоимость создания: 150.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1/10</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">heat</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">4</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wind</name>
		<name-loc>Ветер</name-loc>
		<description-loc>Специальное; Областное
Изменяет текущий открытый поток ветра. Каждое наложение заклинания может сместить направление ветра на 22,5 градуса (например, с З на ЮЗ), или изменить скорость на один уровень по шкале Бофорта (см. вставку). Для достижения комбинации изменения направления и скорости, или более мощного изменения в одном или другом, стоимость увеличивается пропорционально.
Заклинание может быть наложено на площадь, заставляя воздушный поток двигаться от земли и на высоте около 300 футов над нею.  Также заклинание может быть наложено на объект, например корабль, который должен быть охвачен во всей его полноте. Область действия перемещается вместе с объектом.
Это также заклинание Воздуха.
Длительность: 1 час.
Стоимость: 1/50 (минимум 1). Столько же на поддержание.
Время сотворения: 1 минута.
Требование: Буря.
Предмет
Посох, жезл или украшение. Энергостоимость создания: 300</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Special/Area</spell_class>
		<casting_cost>1/50</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 min</casting_time>
		<duration>1 hr</duration>
		<reference>M195</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">windstorm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Explosive Lightning</name>
		<name-loc>Разрывная молния</name-loc>
		<description-loc>Метательное
Создает снаряд молнии, который затрагивает непосредственно цель и вещи поблизости. Такой снаряд имеет 1/2Д 50, Мах 100, Точ 3. Это заклинание можно бросить на стену, пол, и т.д. (с +4 на попадание) чтобы задеть врагов взрывом. Цель и все кто рядом с целью на расстоянии 1 ярда получают полный вред. Тот, кто находится дальше, уменьшает повреждения в три раза на ярд расстояния от взрыва (округляя вниз). Последствия от применения заклинания такие же, как и у заклинания Молния.
Это также заклинание Воздуха.
Стоимость: Не более вашего удвоенного уровня Магических способностей в секунду, на протяжении трех секунд. Снаряд наносит 1d-1 обжигающего урона, на 2 единицы вложенной энергии.
Время сотворения: 1-3 секунды.
Требование: Молния.
Предмет
Посох или жезл – молния срывается с конца предмета. Используется только магами. Энергостоимость создания: 1.200; предмет должен содержать в себе украшений на $500 платины.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>2-2xMagery</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>Instant</duration>
		<ranged_weapon>
			<damage>1d-1 burn ex/2 points</damage>
			<accuracy>3</accuracy>
			<range>50/100</range>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Beam</specialization>
				<modifier>0</modifier>
			</default>
		</ranged_weapon>
		<reference>M196</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2" changed="true">
	<name>Lightning</name>
	<name-loc>Молния</name-loc>
	<points>1</points>
	<spell_class>Missile</spell_class>
	<casting_cost>1-Magery</casting_cost>
	<maintenance_cost>-</maintenance_cost>
	<casting_time>1-3 sec</casting_time>
	<duration>Instant</duration>
	<college>Air/Weather</college>
	<power_source>Arcane</power_source>
	<ranged_weapon>
		<damage>1d-1 burn/point</damage>
		<accuracy>3</accuracy>
		<range>50/100</range>
		<default>
			<type>DX</type>
			<modifier>-4</modifier>
		</default>
		<default>
			<type>Skill</type>
			<name>Innate Attack</name>
			<specialization>Beam</specialization>
			<modifier>0</modifier>
		</default>
	</ranged_weapon>
	<prereq_list all="yes">
		<prereq_list all="no">
			<advantage_prereq has="yes">
				<name compare="is">magery one college (weather)</name>
				<level compare="at least">1</level>
			</advantage_prereq>
			<advantage_prereq has="yes">
				<name compare="is">magery</name>
				<name compare="does not contain">one college</name>
				<level compare="at least">1</level>
			</advantage_prereq>
		</prereq_list>
		<spell_prereq has="yes">
			<college compare="contains">air</college>
			<quantity compare="at least">6</quantity>
		</spell_prereq>
	</prereq_list>
	<categories>
		<category>Air</category>
		<category>Weather</category>
	</categories>
	<reference>M196</reference>
	<description-loc>Метательное
Стреляйте молнией прямо из пальцев! Такой снаряд имеет 1/2Д 50, Мах 100, Точ 3. Против этого заклинания любая металлическая броня защищает с СП(DR) 1. Если цель поражена, она должна сделать бросок ЗД(HT) с -1 за каждые потерянные 2 ЕЖ(HP), иначе оглушена. Против электронного оборудования, считать эту атаку, как если бы она имела модификатор Импульс (B105).
Молния ведет себя непредсказуемо вокруг проводников. Молнию нельзя пустить сквозь металлическую решетку, между прутьями, изнутри автомобиля и т.д. – она перескочит на металл и заземлится. Однако, Мастер может позволить (для примера) магу выстрелить молнией в металлический пол. Это не убьет током тех, кто на нем находился, но может шокировать всех, прерывая концентрацию и нанося незначительные повреждения (не более 1 очка, или же вовсе ничего). Мастер может поощрять креативное использование молнии, до тех пор, пока это не начнет раздражать.
Это также заклинание Воздуха.
Стоимость: Не более вашего уровня Магических способностей в секунду, на протяжении трех секунд. Снаряд наносит 1d-1 обжигающего урона, на 1 единицу вложенной энергии.
Время сотворения: 1-3 секунды (во время сотворения заклинания пальцы мага сверкают).
Требование: Магические способности 1 и как минимум шесть заклинаний Воздуха.
Предмет
Посох или жезл – молния срывается с конца предмета. Используется только магами. Энергостоимость создания: 800, украшений с камнями на $1.200.</description-loc>
</spell>
	<spell version="2">
		<name>Lightning Whip</name>
		<name-loc>Молниевый кнут</name-loc>
		<description-loc>Обычное
Создает кнут из молний в руках мага. Кнут обладает теми же свойствами, что и обычный кнут (B404), за исключением того, что для его подготовки необходима всего секунда, и его нельзя использовать для парирования или опутывания. Кнут наносит 1d обжигающего вреда каждый раз, когда поражает противника. Последствия от применения заклинания такие же, как и у заклинания Молния.
Это также заклинание Воздуха.
Длительность: 10 секунд.
Стоимость: 1 на два ярда длины (максимум 8 ярдов). Столько же на поддержку.
Время сотворения: 2 секунды.
Требование: Молния.
Предмет
Перчатка, кнут или украшение. Используется только магами. Энергостоимость создания: 350.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1 per 2 yards</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>10 sec</duration>
		<melee_weapon>
			<damage>1d burn</damage>
			<reach>2/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-5</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Whip</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Kusari</name>
				<modifier>-3</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Monowire Whip</name>
				<modifier>-3</modifier>
			</default>
		</melee_weapon>
		<reference>M196</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Resist Lightning</name>
		<name-loc>Сопротивление молнии</name-loc>
		<description-loc>Обычное
Объект и все что на нем, защищено от воздействия молнии и электричества. В низко технологичных мирах, это заклинание наиболее часто используется для защиты от враждебной магии; в высоко технологичных мирах - становится ценным профессиональным инструментом.
Это также заклинание Защиты и предупреждения и заклинание Воздуха.
Длительность: 1 минута.
Стоимость: 2 сотворение. 1 поддержка.
Требование: Любые шесть заклинаний воздуха.
Предмет
а) Любой. Влияет только на пользователя. Энергостоимость создания: 1000 единиц энергии и $1000 платины. б) Посох, жезл или украшение. Энергостоимость создания: 1500 единиц энергии и $1000 платины.</description-loc>
		<college>Air/Protection/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>2</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M196</reference>
		<categories>
			<category>Air</category>
			<category>Protection</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<college compare="contains">air</college>
				<quantity compare="at least">6</quantity>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Shocking Touch</name>
		<name-loc>Шоковое касание</name-loc>
		<description-loc>Касательное
Заряжает руки мага или жезл электричеством. Колдующий должен ударить объект, чтобы это заклинание сработало; место касания значения не имеет. Объект получает 1d+1 обжигающего урона за единицу вложенной энергии. Броня не защищает. Шоковое касание имеет необычный побочный эффект на электронику и проводящие материалы, как Молния (см. выше).
Это также заклинание Воздуха.
Стоимость: 1-3
Требование: Молния.
Предмет
Посох, жезл или перчатки. Предмет должен касаться объекта. Энергостоимость создания: 1.500.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Melee</spell_class>
		<casting_cost>1-3</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>Instant</duration>
		<melee_weapon>
			<damage>thr-1 cr +1d+1 burn/point</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M196</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spark Cloud</name>
		<name-loc>Искрящее облако</name-loc>
		<description-loc>Областное
Создает облако насыщенное электричеством на уровне земли. Оно не блокирует видимость, но наносит обжигающий вред тому, кто станет в него. Броня защищает с обычным СП(DR) (металлическая броня обеспечивает минимальную защиту как против заклинания Молния).
Это также заклинание Воздуха.
Длительность: 10 секунд.
Стоимость: 1-5; облако наносит 1 единицу повреждений в секунду на каждое очко вложенной энергии.
Время сотворения: 1-5 секунд, в зависимости от стоимости. Не поддерживается.
Требование: Формировать воздух и Молния.
Предмет
Посох, жезл или украшение. Используется только магами. Стоимость создания: 150, $500 платины, и опал  за $500.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>1-5</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>1-5 sec</casting_time>
		<duration>10 sec</duration>
		<melee_weapon>
			<damage>1 point burn/second</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M196</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">shape air</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Ball of Lightning</name>
		<name-loc>Молниевый шар</name-loc>
		<description-loc>Метательное
Создает шар из молний в руках мага. Молниевый шар отличается от обычных метательных заклинаний, однако, он плывет прочь в направлении заданном магом; его нельзя метнуть обычным образом. Шар бесшумно двигается по прямой с максимальной скоростью, равной умению мага деленного на 5 (округляется вниз), независимо от ветра и неметаллических препятствий – шар проплывает прямо через окна, шторы, стены, и т.д. Он сохраняет своё направление и скорость до тех пор, пока заклинатель, концентрируясь, не изменит их. Шар взрывается по мысленной команде мага или при контакте с живым существом или металлическим объектом. Если время заклинания заканчивается, шар мгновенно исчезает без взрыва.
Это также заклинание Воздуха.
Длительность: 1 минута.
Стоимость: Не более вашего удвоенного уровня Магических способностей в секунду, на протяжении трех секунд; половина на поддержку. Шар наносит 1d-1 обжигающего урона за каждые 2 единицы вложенной энергии кому-либо в пределах 1 ярда от взрыва. Тот, кто находится дальше, уменьшает повреждения в три раза на ярд расстояния от взрыва (округляя вниз).
Время сотворения: 1-3 секунды; шар растет в руке мага пока заклинание колдуется.
Требование: Перемещение и Молния.
Предмет
Посох, жезл или украшение. Используется только магами. Энергостоимость создания: 600 и опал стоимостью $500.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Missile</spell_class>
		<casting_cost>2-6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>1-3 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 burn ex/point</damage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M197</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">apportation</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Spark Storm</name>
		<name-loc>Искрящий шторм</name-loc>
		<description-loc>Областное
Создает нормальный штормовой ветер, с опасным дополнением: каждый ход Молния поражает одну случайную цель, находящуюся в области эффекта. Чтобы избежать удара молнии, бросьте кубик против умения мага в заклинании, без какой-либо корректировки. Жертва получает активную защиту, как обычно.
На усмотрение Мастера, удары молний могут быть не полностью случайными: высокие цели могут быть подвержены большему риску, чем низкие, также металлическая броня более привлекательна для попадания молнии. Маги, которые используют это заклинание, знают какие на самом деле правила в их мире.
Это также заклинание Воздуха.
Длительность: 1 минута после достижения полной силы.
Стоимость: 2 (для 1d-1 Молнии), 4 (для 2d-2 Молнии) или 6 (для 3d-3 Молнии). Половина на поддержку.
Время сотворения: Шторм начинается немедленно, но колдующий должен концентрироваться столько секунд, какой радиус в ярдах необходим до достижения полной силы.
Требование: Буря и Молния.
Предмет
Посох, жезл или украшение. Используется только магами. Стоимость создания: 300, $500 платины, и опал за $500.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2/4/6</casting_cost>
		<maintenance_cost>Half</maintenance_cost>
		<casting_time>sec=radius in yards</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d-1 burn/2 points</damage>
			<usage>Area</usage>
			<reach>Special</reach>
			<parry>No</parry>
		</melee_weapon>
		<reference>M197</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">windstorm</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Wall of Lightning</name>
		<name-loc>Стена молний</name-loc>
		<description-loc>Областное
Создает мерцающий, потрескивающий занавес молний вокруг области.
Стена четыре ярда высотой, но может быть выше, в зависимости от стоимости (двойная для 8 ярдов высоты, тройная для 12 ярдов высоты, и т.д.).
Каждый ход, каждый, кто пытается пересечь или дотронутся до стены, получает обжигающий урон. Она затрудняет видимость  слышимость сквозь неё: -1 к броскам Чувств.
Это также заклинание Воздуха.
Длительность: 1 минута.
Стоимость: 2-6 сотворение. Столько же поддержка. Каждый ход Стена наносит 1d-1 обжигающего урона на каждые две единицы энергии вложенных в заклинание.
Требование: Молния.
Предмет
а) Посох, жезл или украшение. Используется только магами. Стоимость создания: 500 энергии и опал за $500. б) Стена молний может быть создана навсегда за 100-кратную стоимость.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Area</spell_class>
		<casting_cost>2-6</casting_cost>
		<maintenance_cost>Same</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M197</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Body of Lightning</name>
		<name-loc>Тело из молний</name-loc>
		<description-loc>Обычное; Сопротивление по ЗД(HT)
Объект становится подвижной фигурой из молний, временно предоставляется ему мета-черта Тело из Молний (см. вставку). Одежда (до 6 фунтов) также превращаются в молнии, но теряют всякие магические силы, которыми могли обладать.
На объект заклинания Остановить энергию действует как Клей, а Украсть электроэнергию действует как Украсть СЛ(ST)
Это также заклинание Воздуха.
Длительность: 1 минута. Заклинание перестает работать, если объект теряет сознание.
Стоимость: 12 сотворение. 4 поддержка.
Время сотворения: 5 секунд.
Требование: Магические способности 2 и Молния.
Предмет
а) Посох, жезл или украшение. Влияет только на пользователя. Серьезным недостатком является то, что как только предмет будет активирован, он падает сквозь руки пользователя – таким образом, заклинание длится всего минуту. Энергостоимость создания: 3.000. б) Посох, жезл или украшение. Влияет только на пользователя.  В отличие от предыдущего предмета, этот предмет пребывает в форме молний вместе с пользователем. Пока он в этой форме, он теряет какие-либо магические силы, которые у него могли быть. Энергостоимость создания: 6.000.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>12</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>5 sec</casting_time>
		<duration>1 min</duration>
		<melee_weapon>
			<damage>1d burn</damage>
			<usage>Punch</usage>
			<reach>C</reach>
			<parry>0</parry>
			<default>
				<type>DX</type>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Boxing</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Brawling</name>
				<modifier>0</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Karate</name>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M198</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (weather)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lightning Armor</name>
		<name-loc>Молниевая броня</name-loc>
		<description-loc>Обычное
Объект заключается в оболочку потрескивающих молний, не испытывая какого-либо дискомфорта (объект и все что он носит, получают Сопротивление молнии). Контактным атакам объекта добавляются дополнительные очки обжигающего урона. Любое металлическое оружие, которое попадает по объекту, запускает обратную реакцию, которая наносит 1d-1 обжигающего вреда вдоль оружия. Эти атаки автоматически попадают по рукам, которые держат оружие, независимо от длины оружия. Схвативший получает 3d-3 обжигающего урона, но заклинание перестает действовать.
Это также заклинание Воздуха.
Длительность: 1 минута.
Стоимость: 7 сотворение. 4 поддержка.
Требование: Как минимум шесть заклинаний Молний, включая Сопротивление молнии.
Предмет
а) Жезл или украшение. Используется только магами. Стоимость создания: 1.000 энергии, на $300 платины и опал. б) Плащ или доспех; влияет только на пользователя. Когда предмет активирован, плащ выглядит как кусок полосы молний; он защищает от атак со спины и боков, но не с фронта, если не обладает свойствами  легкого плаща (см. Плащ, с 184). Энергостоимость создания: 700 для плаща, 1.000 для доспеха.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>7</casting_cost>
		<maintenance_cost>4</maintenance_cost>
		<casting_time>1 sec</casting_time>
		<duration>1 min</duration>
		<reference>M198</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="contains">lightning</name>
				<quantity compare="at least">5</quantity>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">resist lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lightning Missiles</name>
		<name-loc>Молниевые снаряды</name-loc>
		<description-loc>Обычное
Также как и Молниевое оружие, но твориться на дистанционное оружие. Оружие само по себе окружается электрическим сиянием. Любой снаряд которым стреляют из этого оружия, заряжается электричеством и наносит дополнительные 2 очка повреждений так же как и Молниевое оружие. Деревянные части снарядов, обращаются в пепел, после того как попадают в цель или же по истечении 10 секунд, что первее.
Это также заклинание Воздуха.
Длительность: 1 минута.
Стоимость: 4 сотворение. 2 поддержка. Стоимость удваивается, если выстреливаемые снаряды не металлические.
Время сотворения: 3 секунды.
Требование: Молниевое оружие.
Предмет
Дистанционное оружие, из которого будут стрелять заряженными снарядами, не стоит очков энергии. Энергостоимость создания: 1.000, и как минимум на $400 опаловых украшениях.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>2</maintenance_cost>
		<casting_time>3 sec</casting_time>
		<duration>1 min</duration>
		<reference>M198</reference>
		<notes>+2 points burn damage to missiles fired with weapon</notes>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">lightning weapon</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lightning Stare</name>
		<name-loc>Молниевый взор</name-loc>
		<description-loc>Обычное
Маг стреляет молниями из глаз, с ЛВ(DX)-4 или, используя навык Природная Атака. Маг должен повернуться лицом к цели, чтобы использовать это заклинание. Обычный способ для этого заклинания, использование лицевых мышц, а не жестов руками; таким образом, Молниевый взор может колдовать «без рук» на любом уровне навыка.
Это также заклинание Воздуха.
Длительность: 1 секунда.
Стоимость: 1-4. Не поддерживается.
Наносит 1d обжигающего урона на единицу вложенной энергии. Диапазон – 2 ярда на единицу энергии.
Время сотворения: 2 секунды.
Требование: Молния, Сопротивление молнии.
Предмет
Украшение. Используется только магами.
Стоимость создания: 1.000, драгоценностей на $500 и опал за $500.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>1-4</casting_cost>
		<maintenance_cost>-</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 sec</duration>
		<melee_weapon>
			<damage>1d burn/point</damage>
			<usage>Gaze</usage>
			<reach>2/point</reach>
			<parry>No</parry>
			<default>
				<type>DX</type>
				<modifier>-4</modifier>
			</default>
			<default>
				<type>Skill</type>
				<name>Innate Attack</name>
				<specialization>Gaze</specialization>
				<modifier>0</modifier>
			</default>
		</melee_weapon>
		<reference>M198</reference>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<spell_prereq has="yes">
				<name compare="is">resist lightning</name>
			</spell_prereq>
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
	<spell version="2">
		<name>Lightning Weapon</name>
		<name-loc>Молниевое оружие</name-loc>
		<description-loc>Обычное
Контактное оружие объекта заключается в оболочку из молний, которая заметно шипит и искрится, не повреждая его обладателя. Оружие должно быть, по крайней мере, частично металлическим; оружие, сделанное из дерева и/или камня, не может удерживать заклинание. Оружие наносит дополнительные 2 очка повреждений после того, как проникло сквозь броню и нанесло рассчитанный урон. При попадании по металлическим доспехам, оружие наносит как минимум 1 очко повреждений.
Это также заклинание Воздуха.
Длительность: 1 минута.
Стоимость: 4 сотворение. 1 поддержка.
Время сотворение: 2 секунды.
Требование: Магические способности 2 и Молния.
Предмет
Оружие, которое будет заключено в оболочку из молний, не стоит очков энергии. Энергостоимость создания: 750, и как минимум $300 опаловых украшениях.</description-loc>
		<college>Air/Weather</college>
		<power_source>Arcane</power_source>
		<spell_class>Regular</spell_class>
		<casting_cost>4</casting_cost>
		<maintenance_cost>1</maintenance_cost>
		<casting_time>2 sec</casting_time>
		<duration>1 min</duration>
		<reference>M198</reference>
		<notes>+2 burn damage with melee weapon</notes>
		<categories>
			<category>Air</category>
			<category>Weather</category>
		</categories>
		<prereq_list all="yes">
			<prereq_list all="no">
				<advantage_prereq has="yes">
					<name compare="is">magery one college (weather)</name>
					<level compare="at least">2</level>
				</advantage_prereq>
				<advantage_prereq has="yes">
					<name compare="is">magery</name>
					<name compare="does not contain">one college</name>
					<level compare="at least">2</level>
				</advantage_prereq>
			</prereq_list>
			<spell_prereq has="yes">
				<name compare="is">lightning</name>
			</spell_prereq>
		</prereq_list>
	<points>1</points></spell>
</spell_list>`;
 var standaloneTplChar=`<?xml version="1.0" encoding="UTF8" ?>
<character version="2">
	<created_date>11.10.2016</created_date>
	<modified_date>12.10.2016 23:21</modified_date>
	<profile>
		<name></name>
		<player_name></player_name>
		<campaign></campaign>
		<tech_level>8</tech_level>
		<title></title>
		<age></age>
		<birthday></birthday>
		<eyes></eyes>
		<hair></hair>
		<skin></skin>
		<handedness></handedness>
		<height></height>
		<weight></weight>
		<gender></gender>
		<race></race>
		<religion></religion>
		<sm>0</sm>
		<notes></notes>
	        <portrait></portrait>
	</profile>
	<HP>0</HP>
	<FP>0</FP>
	<total_points>100</total_points>
	<disadvantages_threshold>-40</disadvantages_threshold>
	<quirks_threshold>-5</quirks_threshold>
	<ST>10</ST>
	<DX>10</DX>
	<IQ>10</IQ>
	<HT>10</HT>
	<will>0</will>
	<perception>0</perception>
	<speed>0</speed>
	<move>0</move>
	<hp_lost></hp_lost>
	<fp_lost></fp_lost>
	<advantage_list></advantage_list>
	<skill_list></skill_list>
	<spell_list></spell_list>
	<equipment_list></equipment_list>
	<notes></notes>
</character>`;
 var standaloneTplTpl=`<?xml version="1.0" encoding="UTF8" ?>
<template>
	<spend_points></spend_points>
	<created_date>11.10.2016</created_date>
	<modified_date>12.10.2016 23:21</modified_date>
	<advantage_list>
		<advantage_container type="race">
			<name>Название шаблона</name>
		</advantage_container>
	</advantage_list>
	<skill_list></skill_list>
	<spell_list></spell_list>
	<equipment_list></equipment_list>
	<notes></notes>
</template>`;
 var standaloneTplBoard=`<gm-board>
  <created_date></created_date>
  <modified_date></modified_date>
  <name>Мастерская доска</name>
  <arrow to="arr33593771" from="arr88895388" class="c9" curve="4" arrow-end="" style="top: 307.992px; left: 221.165px; height: 50.9532px; width: 42.0252px; stroke-width: 4px;"></arrow>
  <text-block style="top: 61.9818px; left: -32.0052px; width: 312.01px; height: 249.01px; position: absolute;" class="c1" id="arr33593771"><text>Вы создали мастерскую "доску"<div><br></div><div>* Редактировать текст - двойной щелчок мыши на блоке</div><div>* Сделать <span><b>жирным</b></span>&nbsp;Ctrl-b, <i>курсивом</i> Ctrl-I, <u>подчеркнутым</u> Ctrl-u</div><div>* Перетаскивайте блоки мышью, чтобы выделить несколько боков используйте Shift</div><div>* Чтобы выделить область с блоками тяните мышью вместе с Ctrl или Shift (добавляет) со свободного места.</div><div>* Используйте колёсико мыши на свободном месте чтобы изменить масштаб</div></text></text-block>
  <text-block style="left: 55.9713px; width: 284.01px; height: 132.01px; position: absolute; top: 396px;" class="c9" id="arr88895388"><text>Используйте кнопку "<i></i> Генератор" для создания быстрых образов персонажей.<div>Нажимайте на кнопку "на лист" чтобы сохранить понравившееся описание.</div><div><br></div><div>Теперь эти блоки можно удалить</div></text></text-block>
</gm-board>
`;